# Light-weight tight-binding framework

[![License](https://img.shields.io/github/license/tblite/tblite)](https://github.com/tblite/tblite/blob/HEAD/COPYING.LESSER)
[![Build Status](https://github.com/tblite/tblite/workflows/CI/badge.svg)](https://github.com/tblite/tblite/actions)
[![Doxygen Status](https://github.com/tblite/tblite/workflows/docs/badge.svg)](https://tblite.github.io/tblite)
[![Documentation Status](https://readthedocs.org/projects/tblite/badge/?version=latest)](https://tblite.readthedocs.io/en/latest/?badge=latest)
[![codecov](https://codecov.io/gh/tblite/tblite/branch/main/graph/badge.svg?token=JXIE6myqNH)](https://codecov.io/gh/tblite/tblite)

This project is an effort to create a library implementation of the
extended tight binding (xTB) Hamiltonian which can be shared between
[``xtb``](https://github.com/grimme-lab/xtb) and
[``dftb+``](https://github.com/dftbplus/dftbplus).

Goals of this project are

- create a high-level interface to the extended tight binding methods
- allow low-level access to the components forming the actual energy expression
- provide a framework to handle and manipulate parametrization data

Explicit non-goals are

- provide functionality beyond singlepoint calculations in this library
  (like geometry optimization or molecular dynamics)


## Installation

### Conda package

[![Conda Version](https://img.shields.io/conda/vn/conda-forge/tblite.svg?label=tblite)](https://anaconda.org/conda-forge/tblite)
[![Conda Version](https://img.shields.io/conda/vn/conda-forge/tblite-python.svg?label=tblite-python)](https://anaconda.org/conda-forge/tblite-python)

This project is packaged for the *conda* package manager and available on the *conda-forge* channel.
To install the *mamba* package manager we recommend the [mambaforge](https://github.com/conda-forge/miniforge/releases) installer.
If the *conda-forge* channel is not yet enabled, add it to your channels with

```
mamba config --add channels conda-forge
mamba config --set channel_priority strict
```

Once the *conda-forge* channel has been enabled, this project can be installed with:

```
mamba install tblite
```

If you want to enable the Python API as well install

```
mamba install tblite-python
```

It is possible to list all of the versions available on your platform with:

```
mamba repoquery search tblite --channel conda-forge
```

Now you are ready to use ``tblite``.


### FreeBSD Port

[![FreeBSD port](https://repology.org/badge/version-for-repo/freebsd/tblite.svg)](https://www.freshports.org/science/tblite/)

A port for FreeBSD is available

```
pkg install science/tblite
```

In case no package is available build the port using

```
cd /usr/ports/science/tblite
make install clean
```

For more information see the [tblite port details](https://www.freshports.org/science/tblite/).


### Building from source

To build *tblite* from the source code in this repository you need to have
a Fortran compiler supporting Fortran 2008 and one of the supported build systems:

- [meson](https://mesonbuild.com) version 0.57.2 or newer, with
  a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.10 or newer
- [cmake](https://cmake.org) version 3.14 or newer, with
  a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.10 or newer
- [fpm](https://github.com/fortran-lang/fpm) version 0.3.0 or newer

To build this project from the source code in this repository you need to have
- a Fortran compiler supporting Fortran 2008
- [meson](https://mesonbuild.com) version 0.57.2 or newer
- a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.10 or newer
- a LAPACK / BLAS provider, like MKL or OpenBLAS

Meson is the primary build system and provides feature-complete functionality of this project.
CMake and fpm support are available but the functionality of the project is limited.
Currently, *tblite* support GCC 8 and newer or Intel 18 and newer.

Detailed installation instruction are available in the project documentation under the [installation category](https://tblite.readthedocs.io/en/latest/installation.html).


#### Building with meson

Optional dependencies are
- asciidoctor to build the manual page
- C compiler to test the C-API and compile the Python extension module
- Python 3.6 or newer with the CFFI package installed to build the Python API

Setup a build with

```sh
meson setup _build
```

You can select the Fortran compiler by the `FC` environment variable.
To compile and run the projects testsuite use

```sh
meson test -C _build --print-errorlogs
```

To run the more extensive testing for the available parametrizations use

```sh
meson test -C _build --print-errorlogs --benchmark
```

If the testsuites pass you can install with

```sh
meson configure _build --prefix=/path/to/install
meson install -C _build
```

This might require administrator access depending on the chosen install prefix.
For more details see the [meson installation instructions](https://tblite.readthedocs.io/en/latest/installation.html#meson-based-build).


## Usage

This project provides multiple entry points for different usage scenarios.
The simplest way to check out this project is by using the command line driver.


### Command line interface

The ``tblite`` runner executable provides full access to the implemented Hamiltonians, with the [``tblite-run``](man/tblite-run.1.adoc) subcommand.
You can run a single point calculation by providing a geometry input with

```
tblite run --method gfn2 coord
```

To export a parametrization use the [``tblite-param``](man/tblite-param.1.adoc) subcommand

```
tblite param --method gfn2 --output gfn2-xtb.toml
```

The parameter file can be inspected or modified and than used to perform single point calculations with

```
tblite run --param gfn2-xtb.toml coord
```

A preliminary interfaces for the parameter optimization is provided by the [``tblite-fit``](man/tblite-fit.1.adoc) subcommand.
By providing a external command to evaluate the data set in the input file and setting the parameters to relax the fit can be started with

```
tblite fit gfn2-xtb.toml input.toml
```

The provided external program can callback to the main program to evaluate single points or create differences between data outputs using the [``tblite-tagdiff``](man/tblite-tagdiff.1.adoc) subcommand.
By adding the ``--dry-run`` option the setup of the parameter optimization can be inspected and with ``--copy copy.toml`` the input settings can be dumped for user inspection and tweaking.

For more details on all available subcommands checkout the [``tblite(1)``](man/tblite.1.adoc) man page and the respective subcommand man pages.


## Documentation

The user documentation is available at [readthedocs](https://tblite.readthedocs.io).
Additionally, the [doxygen](https://doxygen.nl) generated API documentation is available [here](https://tblite.github.io/tblite).

To build the user documentation locally we use sphinx, install the dependencies you can use the *mamba* package manager

```
mamba create -n sphinx --file doc/requirements.txt
mamba activate sphinx
```

The documentation is build with

```
sphinx-build doc _doc
```

You can inspect the generated documentation by starting a webserver

```
python3 -m http.server -d _doc
```

And open the down URL in a browser.


## Contributing

This is a volunteer open source projects and contributions are always welcome.
Please, take a moment to read the [contributing guidelines](CONTRIBUTING.md) on how to get involved in tblite.


## License

This project is free software: you can redistribute it and/or modify it under
the terms of the Lesser GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This project is distributed in the hope that it will be useful,
but without any warranty; without even the implied warranty of
merchantability or fitness for a particular purpose.  See the
Lesser GNU General Public License for more details.

Unless you explicitly state otherwise, any contribution intentionally
submitted for inclusion in this project by you, as defined in the
Lesser GNU General Public license, shall be licensed as above, without any
additional terms or conditions.

# Light-weight tight-binding framework

[![License](https://img.shields.io/github/license/tblite/tblite)](https://github.com/tblite/tblite/blob/HEAD/COPYING.LESSER)
[![Build Status](https://github.com/tblite/tblite/workflows/CI/badge.svg)](https://github.com/tblite/tblite/actions)
[![Documentation Status](https://readthedocs.org/projects/tblite/badge/?version=latest)](https://tblite.readthedocs.io/en/latest/?badge=latest)
[![codecov](https://codecov.io/gh/tblite/tblite/branch/main/graph/badge.svg?token=JXIE6myqNH)](https://codecov.io/gh/tblite/tblite)

This project is an effort to create a library implementation of the
extended tight binding (xTB) Hamiltonian which can be shared between
[``xtb``](https://github.com/grimme-lab/xtb) and
[``dftb+``](https://github.com/dftbplus/dftbplus).
The current state of this project should be considered as *highly experimental*.

Goals of this project are

- create a high-level interface to the extended tight binding methods
- allow low-level access to the components forming the actual energy expression
- provide a framework to handle and manipulate parametrization data

Explicit non-goals are

- provide functionality beyond singlepoint calculations in this library
  (like geometry optimization or molecular dynamics)


## Installation

### Conda package

[![Conda Version](https://img.shields.io/conda/vn/conda-forge/tblite.svg)](https://anaconda.org/conda-forge/tblite)

This project is packaged for the *conda* package manager and available on the *conda-forge* channel.
To install the *conda* package manager we recommend the [miniforge](https://github.com/conda-forge/miniforge/releases) installer.
If the *conda-forge* channel is not yet enabled, add it to your channels with

```
conda config --add channels conda-forge
```

Once the *conda-forge* channel has been enabled, this project can be installed with:

```
conda install tblite
```

It is possible to list all of the versions available on your platform with:

```
conda search tblite --channel conda-forge
```

Now you are ready to use ``tblite``.


### FreeBSD Port

[![FreeBSD port](https://repology.org/badge/version-for-repo/freebsd/tblite.svg)](https://www.freshports.org/science/tblite/)

A port for FreeBSD is available

```
pkg install science/tblite
```

In case no package is available build the port using

```
cd /usr/ports/science/tblite
make install clean
```

For more information see the [tblite port details](https://www.freshports.org/science/tblite/).


### Building from source

To build *tblite* from the source code in this repository you need to have
a Fortran compiler supporting Fortran 2008 and one of the supported build systems:

- [meson](https://mesonbuild.com) version 0.57.2 or newer, with
  a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.10 or newer
- [cmake](https://cmake.org) version 3.14 or newer, with
  a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.10 or newer
- [fpm](https://github.com/fortran-lang/fpm) version 0.3.0 or newer

To build this project from the source code in this repository you need to have
- a Fortran compiler supporting Fortran 2008
- [meson](https://mesonbuild.com) version 0.57.2 or newer
- a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.10 or newer
- a LAPACK / BLAS provider, like MKL or OpenBLAS

Meson is the primary build system and provides feature-complete functionality of this project.
CMake and fpm support are available but the functionality of the project is limited.
Currently, *tblite* support GCC 8 and newer or Intel 18 and newer.

Detailed installation instruction are available in the project documentation under the [installation category](https://tblite.readthedocs.io/en/latest/installation.html).


#### Building with meson

Optional dependencies are
- asciidoctor to build the manual page
- C compiler to test the C-API and compile the Python extension module
- Python 3.6 or newer with the CFFI package installed to build the Python API

Setup a build with

```sh
meson setup _build
```

You can select the Fortran compiler by the `FC` environment variable.
To compile and run the projects testsuite use

```sh
meson test -C _build --print-errorlogs
```

To run the more extensive testing for the available parametrizations use

```sh
meson test -C _build --print-errorlogs --benchmark
```

If the testsuites pass you can install with

```sh
meson configure _build --prefix=/path/to/install
meson install -C _build
```

This might require administrator access depending on the chosen install prefix.
For more details see the [meson installation instructions](https://tblite.readthedocs.io/en/latest/installation.html#meson-based-build).


## Usage

This project provides multiple entry points for different usage scenarios.
The simplest way to check out this project is by using the command line driver.


### Command line interface

The ``tblite`` runner executable provides full access to the implemented Hamiltonians, with the [``tblite-run``](man/tblite-run.1.adoc) subcommand.
You can run a single point calculation by providing a geometry input with

```
tblite run --method gfn2 coord
```

To export a parametrization use the [``tblite-param``](man/tblite-param.1.adoc) subcommand

```
tblite param --method gfn2 --output gfn2-xtb.toml
```

The parameter file can be inspected or modified and than used to perform single point calculations with

```
tblite run --param gfn2-xtb.toml coord
```

A preliminary interfaces for the parameter optimization is provided by the [``tblite-fit``](man/tblite-fit.1.adoc) subcommand.
By providing a external command to evaluate the data set in the input file and setting the parameters to relax the fit can be started with

```
tblite fit gfn2-xtb.toml input.toml
```

The provided external program can callback to the main program to evaluate single points or create differences between data outputs using the [``tblite-tagdiff``](man/tblite-tagdiff.1.adoc) subcommand.
By adding the ``--dry-run`` option the setup of the parameter optimization can be inspected and with ``--copy copy.toml`` the input settings can be dumped for user inspection and tweaking.

For more details on all available subcommands checkout the [``tblite(1)``](man/tblite.1.adoc) man page and the respective subcommand man pages.


## Documentation

User and developer documentation is available [here](https://tblite.readthedocs.io).


## License

This project is free software: you can redistribute it and/or modify it under
the terms of the Lesser GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This project is distributed in the hope that it will be useful,
but without any warranty; without even the implied warranty of
merchantability or fitness for a particular purpose.  See the
Lesser GNU General Public License for more details.

Unless you explicitly state otherwise, any contribution intentionally
submitted for inclusion in this project by you, as defined in the
Lesser GNU General Public license, shall be licensed as above, without any
additional terms or conditions.

# Modular computation tool chain library

[![Apache-2.0](https://img.shields.io/github/license/grimme-lab/mctc-lib)](LICENSE)
[![Release](https://img.shields.io/github/v/release/grimme-lab/mctc-lib)](https://github.com/grimme-lab/mctc-lib/releases/latest)
[![CI](https://github.com/grimme-lab/mctc-lib/workflows/CI/badge.svg)](https://github.com/grimme-lab/mctc-lib/actions)
[![docs](https://github.com/grimme-lab/mctc-lib/workflows/docs/badge.svg)](https://grimme-lab.github.io/mctc-lib)
[![codecov](https://codecov.io/gh/grimme-lab/mctc-lib/branch/main/graph/badge.svg)](https://codecov.io/gh/grimme-lab/mctc-lib)

A Fortran library providing unified molecular structure data handling and geometry file format I/O for computational chemistry applications.
The library supports reading and writing of molecular structures in more than twelve different geometry formats and provides element data and coordination number utilities.


## Features

- **Unified structure representation**: A common [``structure_type``](https://grimme-lab.github.io/mctc-lib/type/structure_type.html) for handling molecular and periodic systems
- **Multi-format I/O**: Read and write structures in 12+ geometry formats
- **Element data**: Access to atomic/covalent/vdW radii and Pauling electronegativities
- **Coordination numbers**: Multiple counting functions (exponential, error function, electronegativity-weighted)
- **Helpful error messages**: Detailed error reporting with source location information
- **Multiple build systems**: Support for meson, CMake, and fpm


## Quick Start

```f90
program example
   use mctc_io
   use mctc_env
   implicit none
   type(structure_type) :: mol
   type(error_type), allocatable :: error

   ! Read a structure (format auto-detected from extension)
   call read_structure(mol, "molecule.xyz", error)
   if (allocated(error)) stop error%message

   ! Access structure data
   print '(a,i0)', "Number of atoms: ", mol%nat
   print '(a,f12.6)', "Total charge: ", mol%charge

   ! Write to different format
   call write_structure(mol, "molecule.mol", error)
   if (allocated(error)) stop error%message
end program
```


## Supported formats

This library supports reading and writing in more than ten different geometry formats, including general ASCII formats, like xyz, JSON based formats, like QCSchema, and program specific formats, for example compatible with Turbomole or Vasp.

*General geometry formats*

- [xyz][xyz] file format with ``xyz`` extension
- [Protein data base][pdb] file format with ``pdb`` extension
- [mol][ctfile] and [structure data][ctfile] connection table file formats with ``mol`` and ``sdf`` extension, respectively

[xyz]: http://www.ccl.net/chemistry/resources/messages/1996/10/21.005-dir/index.html
[pdb]: http://www.wwpdb.org/documentation/file-format-content/format33/v3.3.html
[ctfile]: https://www.daylight.com/meetings/mug05/Kappler/ctfile.pdf

*JSON based formats*

- [Pymatgen JSON][pmg] with ``pmgjson`` or ``json`` extension
- [QCSchema JSON][qcsk] with ``qcjson`` or ``json`` extension
- [Chemical JSON][cjson] with ``cjson`` or ``json`` extension

[pmg]: https://pymatgen.org
[qcsk]: https://molssi-qc-schema.readthedocs.io
[cjson]: https://github.com/OpenChemistry/avogadrolibs/blob/master/avogadro/io/cjsonformat.cpp

*Program specific formats*

- [Q-Chem molecule][qchem] file format with ``qchem`` extension
- [Turbomole coord][tmol] file format with ``tmol`` or ``coord`` extension
- [VASP POSCAR and CONTCAR][vasp] files with ``vasp``, ``poscar``, or ``contcar`` extension
- [DFTB+ gen][gen] format with ``gen`` extension
- [Gaussian external][ein] format with ``ein`` extension
- [FHI-aims][aims] ``geometry.in`` input files

[aims]: https://fhi-aims.org
[qchem]: https://manual.q-chem.com
[tmol]: https://www.turbomole.org
[gen]: https://dftbplus.org
[ein]: https://gaussian.com/external/
[vasp]: https://www.vasp.at/wiki/index.php


## Installation

To build this project from the source code in this repository you need to have
a Fortran compiler supporting Fortran 2008 and one of the supported build systems:
- [meson](https://mesonbuild.com) version 0.55 or newer (except 1.8.0), with
  a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.7 or newer
- [cmake](https://cmake.org) version 3.14 or newer, with
  a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.10 or newer
- [fpm](https://github.com/fortran-lang/fpm) version 0.3.0 or newer

Currently this project supports GCC, Intel and PGI/NVHPC compilers.


### Building with meson

Setup a build with

```
meson setup _build
```

You can select the Fortran compiler by the `FC` environment variable.
To compile the project run

```
meson compile -C _build
```

You can run the projects testsuite with

```
meson test -C _build --print-errorlogs
```

To include ``mctc-lib`` in your project add the following wrap file to your subprojects directory:

```ini
[wrap-git]
directory = mctc-lib
url = https://github.com/grimme-lab/mctc-lib
revision = head
```

You can retrieve the dependency from the wrap fallback with

```meson
mctc_dep = dependency('mctc-lib', fallback: ['mctc-lib', 'mctc_dep'])
```

and add it as dependency to your targets.


### Building with CMake

Alternatively, this project can be build with CMake (in this case ninja 1.10 or newer is required):

```
cmake -B _build -G Ninja
```

To compile the project with CMake run

```
cmake --build _build
```

You can run the project testsuite with

```
pushd _build && ctest && popd
```

To include ``mctc-lib`` in your CMake project retrieve it using the ``FetchContent`` module:

```cmake
if(NOT TARGET mctc-lib)
  set("mctc-lib-url" "https://github.com/grimme-lab/mctc-lib")
  message(STATUS "Retrieving mctc-lib from ${mctc-lib-url}")
  include(FetchContent)
  FetchContent_Declare(
    "mctc-lib"
    GIT_REPOSITORY "${mctc-lib-url}"
    GIT_TAG "HEAD"
  )
  FetchContent_MakeAvailable("mctc-lib")
endif()
```

And link against the ``"mctc-lib"`` interface library.

```cmake
target_link_libraries("${PROJECT_NAME}-lib" PUBLIC "mctc-lib")
```


### Building with fpm

Invoke fpm in the project root with

```
fpm build
```

To run the testsuite use

```
fpm test
```

You can access the ``mctc-convert`` program using the run subcommand

```
fpm run -- --help
```

To use ``mctc-lib`` for testing include it as dependency in your package manifest

```toml
[dependencies]
mctc-lib.git = "https://github.com/grimme-lab/mctc-lib"
```


## Example

An example application is provided with the [``mctc-convert``](man/mctc-convert.1.adoc) program to convert between different supported input formats.


### Using mctc-convert

After building, the ``mctc-convert`` tool can convert between any supported formats:

```bash
# Convert xyz to Turbomole coord
mctc-convert molecule.xyz molecule.coord

# Convert VASP POSCAR to xyz
mctc-convert POSCAR structure.xyz

# Pipe from stdin to stdout
cat input.xyz | mctc-convert -i xyz -o mol - -

# Preserve bond information from SDF when converting
mctc-convert optimized.xyz final.sdf --template original.sdf
```


### Library Usage

To read an input file using the IO library use the ``read_structure`` routine.
The final geometry data is stored in a ``structure_type``:

```f90
use mctc_io
use mctc_env
type(structure_type) :: mol
type(error_type), allocatable :: error

call read_structure(mol, "input.xyz", error)
if (allocated(error)) then
   print '(a)', error%message
   error stop
end if
```

The environment library provides a basic error back-propagation mechanism using an allocatable ``error_type``, which is passed to the library routines.
Usually the reader can detect the file type from the suffix of file names.
Alternatively, the ``filetype`` enumerator provides the identifiers of all supported file types, which can be passed as optional argument to the ``read_structure`` routine.

In a similar way the ``write_structure`` routine allows to write a ``structure_type`` to a file or unit:

```f90
use mctc_io
use mctc_env
type(structure_type) :: mol
type(error_type), allocatable :: error

call write_structure(mol, "output.xyz", error)
if (allocated(error)) then
   print '(a)', error%message
   error stop
end if
```

The [``mctc-convert``](man/mctc-convert.1.adoc) program provides a chained reader and writer call to act as a geometry file converter.
Checkout the implementation in [``app/main.f90``](app/main.f90).


## Working with the Structure Type

The [``structure_type``](https://grimme-lab.github.io/mctc-lib/type/structure_type.html) is the central data structure for representing molecular systems:

```f90
type(structure_type) :: mol

! Basic properties
mol%nat           ! Number of atoms
mol%nid           ! Number of unique species
mol%charge        ! Total molecular charge
mol%uhf           ! Number of unpaired electrons

! Atomic data (arrays)
mol%xyz(:, :)     ! Cartesian coordinates (3, nat) in Bohr
mol%id(:)         ! Species index for each atom (nat)
mol%num(:)        ! Atomic numbers for each species (nid)
mol%sym(:)        ! Element symbols for each species (nid)

! Periodic systems
mol%lattice(:, :) ! Lattice vectors (3, 3) in Bohr
mol%periodic(:)   ! Periodic directions (3)

! Optional data
mol%bond(:, :)    ! Bond connectivity
mol%comment       ! Structure title/comment
```

### Creating Structures Programmatically

All inputs use atomic units. Coordinates must be provided in Bohr (1 Bohr ≈ 0.529 Å).

```f90
use mctc_io
use mctc_env, only : wp
implicit none
type(structure_type) :: mol
integer :: num(3)
real(wp) :: xyz(3, 3)

! Water molecule (coordinates in Bohr)
num = [8, 1, 1]  ! O, H, H
xyz = reshape([ &
   & 0.0_wp, 0.0_wp, 0.2372_wp, &
   & 0.0_wp, 1.4939_wp, -0.9487_wp, &
   & 0.0_wp, -1.4939_wp, -0.9487_wp], [3, 3])

call new(mol, num, xyz, charge=0.0_wp, uhf=0)
```


## Using Element Data

Access element-specific properties from the [``mctc_data``](https://grimme-lab.github.io/mctc-lib/module/mctc_data.html) module:

```f90
use mctc_data
use mctc_env, only : wp
implicit none
real(wp) :: radius

! Get covalent radius for carbon (atomic number 6)
radius = get_covalent_rad(6)

! Available functions:
! get_covalent_rad(num) - Covalent radii in Bohr
! get_vdw_rad(num)      - van der Waals radii in Bohr
! get_atomic_rad(num)   - Atomic radii in Bohr
! get_pauling_en(num)   - Pauling electronegativities
```


## Element Symbol Conversion

Convert between element symbols and atomic numbers:

```f90
use mctc_io, only : to_number, to_symbol

integer :: num
character(len=2) :: sym

num = to_number("C")     ! Returns 6
sym = to_symbol(6)       ! Returns "C"
```


## Specifying File Formats

When the file extension is non-standard, use the ``filetype`` enumerator:

```f90
use mctc_io

call read_structure(mol, "geometry.in", error, filetype%aims)
call write_structure(mol, "output.dat", error, filetype%xyz)
```

Available format identifiers:
- ``filetype%xyz`` - xyz format
- ``filetype%tmol`` - Turbomole coord
- ``filetype%molfile`` - mol file
- ``filetype%sdf`` - SDF format
- ``filetype%vasp`` - VASP POSCAR
- ``filetype%pdb`` - PDB format
- ``filetype%gen`` - DFTB+ genFormat
- ``filetype%gaussian`` - Gaussian external
- ``filetype%qcschema`` - QCSchema JSON
- ``filetype%cjson`` - Chemical JSON
- ``filetype%pymatgen`` - Pymatgen JSON
- ``filetype%aims`` - FHI-aims
- ``filetype%qchem`` - Q-Chem


## Error reporting

The geometry input readers try to be provide helpful error messages, no user should be left alone with an error message like *invalid input*.
Unclear error messages are considered a bug in *mctc-lib*, if you struggle to make sense of a reported error, file us an issue and we will make the report better.

**How can helpful error messages look like?**
Here are some examples.

1. negative number of atoms declared in xyz file

```
Error: Impossible number of atoms provided
 --> struc.xyz:1:1-2
  |
1 | -3
  | ^^ expected positive integer value
  |
```

2. total charge is not specified as integer

```
Error: Cannot read eht entry
  --> struc.coord:18:13-15
   |
18 | $eht charge=one unpaired=0
   |             ^^^ expected integer value
   |
```

3. a fixed width entry contains an incorrect value

```
Error: Cannot read charges
  --> struc.mol:29:23-25
   |
29 | M  CHG  3   1   1   3   b   2  -1
   |                       ^^^ expected integer value
   |
```

4. Turbomole input with conflicting data groups

```
Error: Conflicting lattice and cell groups
  --> struc.coord:37:1-5
   |
35 | $lattice angs
   | -------- lattice first defined here
   :
37 | $cell angs
   | ^^^^^ conflicting cell group
   |
```

We try to retain as much information as possible when displaying the error message to make it easy to fix the offending part in the input.


## API Documentation

Full API documentation is available at [grimme-lab.github.io/mctc-lib](https://grimme-lab.github.io/mctc-lib).

Key modules:
- [``mctc_io``](https://grimme-lab.github.io/mctc-lib/module/mctc_io.html) - Structure I/O (``read_structure``, ``write_structure``, ``structure_type``)
- [``mctc_env``](https://grimme-lab.github.io/mctc-lib/module/mctc_env.html) - Environment utilities (``error_type``, ``wp`` working precision)
- [``mctc_data``](https://grimme-lab.github.io/mctc-lib/module/mctc_data.html) - Element data (radii, electronegativities)
- [``mctc_ncoord``](https://grimme-lab.github.io/mctc-lib/module/mctc_ncoord.html) - Coordination number evaluation


## License

Licensed under the Apache License, Version 2.0 (the “License”);
you may not use this file except in compliance with the License.
You may obtain a copy of the License at
http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an *“as is” basis*,
*without warranties or conditions of any kind*, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Unless you explicitly state otherwise, any contribution intentionally
submitted for inclusion in this project by you, as defined in the
Apache-2.0 license, shall be licensed as above, without any additional
terms or conditions.

# Atomic Partial Charge Model

[![Apache-2.0](https://img.shields.io/github/license/grimme-lab/multicharge)](LICENSE)
[![Release](https://img.shields.io/github/v/release/grimme-lab/multicharge)](https://github.com/grimme-lab/multicharge/releases/latest)
[![CI](https://github.com/grimme-lab/multicharge/workflows/CI/badge.svg)](https://github.com/grimme-lab/multicharge/actions)
[![codecov](https://codecov.io/gh/grimme-lab/multicharge/branch/main/graph/badge.svg)](https://codecov.io/gh/grimme-lab/multicharge)

Electronegativity equilibration models for atomic partial charges.


## Installation

To build this project from the source code in this repository you need to have
a Fortran compiler supporting Fortran 2008 and one of the supported build systems:
- [meson](https://mesonbuild.com) version 0.53 or newer (except 1.8.0), with
  a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.7 or newer
- [cmake](https://cmake.org) version 3.14 or newer, with
  a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.10 or newer
- [fpm](https://github.com/fortran-lang/fpm) version 0.2.0 or newer

Currently this project supports GCC and Intel compilers.


### Building with meson

Setup a build with

```
meson setup _build
```

You can select the Fortran compiler by the `FC` environment variable.
To compile the project run

```
meson compile -C _build
```

You can run the projects testsuite with

```
meson test -C _build --print-errorlogs
```

To include ``multicharge`` in your project add the following wrap file to your subprojects directory:

```ini
[wrap-git]
directory = multicharge
url = https://github.com/grimme-lab/multicharge
revision = head
```

You can retrieve the dependency from the wrap fallback with

```meson
multicharge_dep = dependency('multicharge', fallback: ['multicharge', 'multicharge_dep'])
```

and add it as dependency to your targets.


### Building with CMake

Alternatively, this project can be build with CMake (in this case ninja 1.10 or newer is required):

```
cmake -B _build -G Ninja
```

To compile the project with CMake run

```
cmake --build _build
```

You can run the project testsuite with

```
pushd _build && ctest && popd
```

To include ``multicharge`` in your CMake project retrieve it using the ``FetchContent`` module:

```cmake
if(NOT TARGET multicharge)
  set("multicharge-url" "https://github.com/grimme-lab/multicharge")
  message(STATUS "Retrieving multicharge from ${multicharge-url}")
  include(FetchContent)
  FetchContent_Declare(
    "multicharge"
    GIT_REPOSITORY "${multicharge-url}"
    GIT_TAG "HEAD"
  )
  FetchContent_MakeAvailable("multicharge")
endif()
```

And link against the ``"multicharge"`` interface library.

```cmake
target_link_libraries("${PROJECT_NAME}-lib" PUBLIC "multicharge")
```


### Building with fpm

Invoke fpm in the project root with

```
fpm build
```

To run the testsuite use

```
fpm test
```

You can access the ``multicharge`` program using the run subcommand

```
fpm run -- --help
```

To use ``multicharge`` for testing include it as dependency in your package manifest

```toml
[dependencies]
multicharge.git = "https://github.com/grimme-lab/multicharge"
```


## Usage

For an overview over all command line arguments use the ``--help`` argument or checkout the [``multicharge(1)``](man/multicharge.1.adoc) manpage.

## Citation

For the electronegativity equilibration model (EEQ): 

Eike Caldeweyher, Sebastian Ehlert, Andreas Hansen, Hagen Neugebauer, Sebastian Spicher, Christoph Bannwarth and Stefan Grimme, *J. Chem Phys*, **2019**, 150, 154122.
DOI: [10.1063/1.5090222](https://doi.org/10.1063/1.5090222)
chemrxiv: [10.26434/chemrxiv.7430216](https://doi.org/10.26434/chemrxiv.7430216.v2)

... the EEQ extention to Fr, Ra, and the full Actinide series: 

Lukas Wittmann, Igor Gordiy, Marvin Friede, Benjamin Helmich-Paris, Stefan Grimme, Andreas Hansen and Markus Bursch, *Phys. Chem. Chem. Phys.*, **2024**, 26, 21379-21394.
DOI: [10.1039/D4CP01514B](10.1039/D4CP01514B)

... the periodic EEQ implementation: 

Eike Caldeweyher, Jan-Michael Mewes, Sebastian Ehlert and Stefan Grimme, *Phys. Chem. Chem. Phys.*, **2020**, 22, 8499-8512.
DOI: [10.1039/D0CP00502A](https://doi.org/10.1039/D0CP00502A)
chemrxiv: [10.26434/chemrxiv.10299428](https://doi.org/10.26434/chemrxiv.10299428.v1)

<br>

For the bond capacity electronegativity equilibration charge model (EEQ<sub>BC</sub>): 

Thomas Froitzheim, Marcel Müller, Andreas Hansen, and Stefan Grimme, *J. Chem. Phys.*, **2025**, 162, 214109.
DOI: [10.1039/10.1063/5.0268978](https://doi.org/10.1063/5.0268978)
chemrxiv: [10.26434/chemrxiv-2025-1nxwg](https://doi.org/10.26434/chemrxiv-2025-1nxwg)


## License

Licensed under the Apache License, Version 2.0 (the “License”);
you may not use this file except in compliance with the License.
You may obtain a copy of the License at
http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an *“as is” basis*,
*without warranties or conditions of any kind*, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Unless you explicitly state otherwise, any contribution intentionally
submitted for inclusion in this project by you, as defined in the
Apache-2.0 license, shall be licensed as above, without any additional
terms or conditions.

DFT-D4 project
==============

[![License](https://img.shields.io/github/license/dftd4/dftd4?cacheSeconds=86400)](https://github.com/dftd4/dftd4/blob/main/COPYING.LESSER)
[![Latest Version](https://img.shields.io/github/v/release/dftd4/dftd4)](https://github.com/dftd4/dftd4/releases/latest)
[![Build Status](https://github.com/dftd4/dftd4/workflows/CI/badge.svg)](https://github.com/dftd4/dftd4/actions)
[![Documentation Status](https://readthedocs.org/projects/dftd4/badge/?version=latest)](https://dftd4.readthedocs.io/en/latest/?badge=latest)
[![docs](https://github.com/dftd4/dftd4/workflows/docs/badge.svg)](https://dftd4.github.io/dftd4/)
[![codecov](https://codecov.io/gh/dftd4/dftd4/branch/main/graph/badge.svg?token=IFtEF1Hwqj)](https://codecov.io/gh/dftd4/dftd4)

Generally Applicable Atomic-Charge Dependent London Dispersion Correction.


## Installing

A statically linked binary distribution for Linux platforms is available at the [latest release](https://github.com/dftd4/dftd4/releases/latest) tag.


### Conda package

[![Conda Version](https://img.shields.io/conda/vn/conda-forge/dftd4.svg?label=dftd4)](https://anaconda.org/conda-forge/dftd4)
[![Conda Version](https://img.shields.io/conda/vn/conda-forge/dftd4-python.svg?label=dftd4-python)](https://anaconda.org/conda-forge/dftd4-python)

This project is packaged for the *conda* package manager and available on the *conda-forge* channel.
To install the *conda* package manager we recommend the [miniforge](https://github.com/conda-forge/miniforge/releases) installer.
If the *conda-forge* channel is not yet enabled, add it to your channels with

```
conda config --add channels conda-forge
```

Once the *conda-forge* channel has been enabled, this project can be installed with:

```
conda install dftd4
```

If you want to enable the Python API as well install

```
conda install dftd4-python
```

It is possible to list all of the versions available on your platform with:

```
conda search dftd4 --channel conda-forge
```

Now you are ready to use `dftd4`.


### Spack package

[![Spack](https://img.shields.io/spack/v/dftd4)](https://packages.spack.io/package.html?name=dftd4)

This project is available with [spack](https://spack.io) in its develop version.
You can install and load `dftd4` with

```
spack install dftd4
spack load dftd4
```

The Python API can be enabled by adding `+python` to the command.


### FreeBSD Port

[![FreeBSD port](https://repology.org/badge/version-for-repo/freebsd/dftd4.svg)](https://www.freshports.org/science/dftd4/)

A port for FreeBSD is available and can be installed using

```
pkg install science/dftd4
```

In case no package is available build the port using

```
cd /usr/ports/science/dftd4
make install clean
```

For more information see the [dftd4 port details](https://www.freshports.org/science/dftd4/).



### Building from Source

To build this project from the source code in this repository you need to have
a Fortran compiler supporting Fortran 2008 and one of the supported build systems:
- [meson](https://mesonbuild.com) version 0.55 or newer, with
  a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.7 or newer
- [cmake](https://cmake.org) version 3.14 or newer, with
  a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.10 or newer
- [fpm](https://github.com/fortran-lang/fpm) version 0.2.0 or newer

Currently this project supports GCC and Intel compilers.

<details>
<summary>Problematic Versions</summary>

GCC versions 15.0.x - 15.1.x contain a [compiler bug](https://gcc.gnu.org/bugzilla/show_bug.cgi?id=119928) leading to "Interface mismatch" errors during compilation.

</details>


#### Building with meson

To compile this version of DFT-D4 with meson the following programs are needed
(the number in parentheses specifies the tested versions).

To build this project from the source code in this repository you need to have
- a Fortran compiler supporting Fortran 2008
- [meson](https://mesonbuild.com) version 0.55 or newer
- a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.7 or newer
- a LAPACK / BLAS provider, like MKL or OpenBLAS

Optional dependencies are
- asciidoctor to build the manual page
- FORD to build the developer documentation
- C compiler to test the C-API and compile the Python extension module
- Python 3.6 or newer with the CFFI package installed to build the Python API

Setup a build with

```sh
meson setup _build
```

You can select the Fortran compiler by the `FC` environment variable.
To compile and run the projects testsuite use

```sh
meson test -C _build --print-errorlogs
```

If the testsuite passes you can install with

```sh
meson configure _build --prefix=/path/to/install
meson install -C _build
```

This might require administrator access depending on the chosen install prefix.


#### Building with CMake

Alternatively, this project can be build with CMake (in this case ninja 1.10 or newer is required):

```
cmake -B _build -G Ninja -DCMAKE_INSTALL_PREFIX=$HOME/.local
```

To compile the project with CMake run

```
cmake --build _build
```

You can run the project testsuite with

```
ctest --test-dir _build --parallel --output-on-failure
```

Finally, you can install the project to the selected prefix

```
cmake --install _build
```

Note that the CMake build does not support to build the Python extension module as part of the main build.


#### Building with fpm

This project support the Fortran package manager (fpm).
Invoke fpm in the project root with

```
fpm build
```

To run the testsuite use

```
fpm test
```

You can access the ``dftd4`` program using the run subcommand

```
fpm run -- --help
```

To use ``dftd4`` for testing include it as dependency in your package manifest

```toml
[dependencies]
dftd4.git = "https://github.com/dftd4/dftd4"
```

Note that the fpm build does not support exporting the C-API, it only provides access to the standalone binary.


## Usage

DFT-D4 calculations can be performed with the `dftd4` executable.
To calculate the dispersion correction for PBE0-D4 run:

```sh
dftd4 --func pbe0 coord
```

In case you want to access the DFT-D4 results from other programs, dump the results to JSON with
(the `--noedisp` flag prevents the `.EDISP` file generation):

```sh
dftd4 --func pbe0 --json --grad --noedisp struct.xyz
```

Dispersion related properties can be calculated as well:

```sh
dftd4 --property geo.gen
```

To evaluate pairwise resolved dispersion energies use

```sh
dftd4 --pair-resolved mol.xyz
```

For an overview over all command line arguments use the `--help` argument or checkout the [`dftd4(1)`](https://github.com/dftd4/dftd4/blob/main/man/dftd4.1.adoc) manpage.


### Parallelism

DFT-D4 calculations can be performed with shared-memory parallelism (OpenMP).

The number of parallel threads can be set through environment variables.

```sh
export OMP_NUM_THREADS=4
export MKL_NUM_THREADS=4  # Intel
```

For large calculations, additional speed-ups might be possible by enabling dynamic scheduling in OMP by setting `OMP_SCHEDULE=dynamic`.
This might help particularly for versions <4.0.0 ([explanation](https://github.com/dftd4/dftd4/pull/319)).

Note that DFT-D4 is not MPI parallelized, and there are currently no plans to implement MPI parallelism.


## Parameters

DFT-D4 is parametrized for plenty of density functionals.
The available parameters are listed in the [parameters.toml file](https://github.com/dftd4/dftd4/blob/main/assets/parameters.toml) or with the following command.

```sh
dftd4 param --list
```

While the functionals can be selected with their common names (e.g., `PBE`), the [libxc](https://www.tddft.org/programs/libxc/functionals/) names can also be used (e.g., `GGA_X_PBE:GGA_C_PBE`).

```sh
dftd4 --func PBE coord
dftd4 --func GGA_X_PBE:GGA_C_PBE coord
```

The exchange and correlation functional must be separated by a colon.
All names are case-insensitive.

<details>
<summary>Note on ωB97X-type functionals</summary>

Since there has been some confusion concerning the different ωB97X functionals, we provide a detailed summary: 

- [ωB97X](https://doi.org/10.1063/1.2834918) (original functional, 2008, parameters: `wb97x-2008`)
- [ωB97X-D](https://doi.org/10.1039/B810189B) (re-optimization of ωB97X to include dispersion correction, 2008, no D4 parameters)
- [ωB97X-D3](https://doi.org/10.1021/ct300715s) (re-optimization of ωB97X-D with improved dispersion corrections, D3(0), 2013, no D4 parameters)
- [ωB97X-V](https://doi.org/10.1039/C3CP54374A) (new functional, different from the above ωB97X's and not just a re-optimization for VV10 dispersion, 2013)
- [ωB97X-D4](https://doi.org/10.1002/jcc.26411) (ωB97X-V with D4 dispersion instead of VV10 dispersion, parameters: `wb97x`)
- [ωB97X-D4rev](https://doi.org/10.1063/5.0133026) (revised D4 parameters for ωB97X-V with D4 dispersion instead of VV10 dispersion, parameters: `wb97x-rev`)
- [ωB97X-3c](https://doi.org/10.1063/5.0133026) (Composite "3c" method based on ωB97X-V, parameters: `wb97x-3c`)

Note that the ωB97X parameters (`wb97x-2008`) cannot be used for the ωB97X-V functional (`wb97x`, `wb97x-rev`).

We recommend the revised D4 parameters for ωB97X-V (`wb97x-rev`).

</details>

<br>

You can add new functionals using to the TOML file by adding a new subtable

```toml
[parameter.name]
reference.doi = ["<functional reference>"]
d4.bj-eeq-atm = { s8=1.0, a1=0.4, a2=5.0, doi="<parameter reference>" }
```

Those parameters are currently only used as reference and not yet usable in the library or executable.


## API access

The DFT-D4 project provides first class API support Fortran, C and Python.
Other programming languages should try to interface with to DFT-D4 via one of those three APIs.
To provide first class API support for a new language the interface specification should be available as meson build files.

The `dftd4` binary provides with the `--json` option access to all quantities available from the APIs as well.


### Fortran API

The recommended way to access the Fortran module API is by using `dftd4` as a meson subproject.
Alternatively, the project is accessible by the Fortran package manager ([fpm](https://github.com/fortran-lang/fpm)).

The complete API is available from `dftd4` module, the individual modules are available to the user as well but are not part of the public API and therefore not guaranteed to remain stable.
ABI compatibility is only guaranteed for the same minor version.

The communication with the Fortran API uses the `error_type` and `structure_type` of the modular computation tool chain library (mctc-lib) to handle errors and represent geometries, respectively.


#### Building Vasp with support for D4

To use ``dftd4`` in Vasp the compatibility layer for the 2.5.x API has to be enable with ``-Dapi_v2=true`` (meson) or ``-DWITH_API_V2=ON`` (CMake).
It is important to build ``dftd4`` with the same Fortran compiler you build Vasp with.

After you completed the installation of ``dftd4``, make sure it is findable by ``pkg-config``, you can check by running:

```
pkg-config --modversion dftd4
```

If your ``dftd4`` installation is not findable, you have to update your environment variables.
One option is to provide a module file for your ``dftd4`` installation.
The example module file below can be placed in your ``MODULEPATH`` to provide access to an installation in ``~/opt/dftd4/4.2.0``.
Retry the above comment after loading the ``dftd4`` module and adjust the module file until ``pkg-config`` finds your installation.

```lua
-- dftd4/4.2.0.lua
local name = "dftd4"
local version = "4.2.0"
local prefix = pathJoin(os.getenv("HOME"), "opt", name, version)
local libdir = "lib"  -- or lib64

whatis("Name        : " .. name)
whatis("Version     : " .. version)
whatis("Description : Generally applicable charge dependent London dispersion correction")
whatis("URL         : https://github.com/dftd4/dftd4")

prepend_path("PATH", pathJoin(prefix, "bin"))
prepend_path("MANPATH", pathJoin(prefix, "share", "man"))
prepend_path("CPATH", pathJoin(prefix, "include"))
prepend_path("LIBRARY_PATH", pathJoin(prefix, libdir))
prepend_path("LD_LIBRARY_PATH", pathJoin(prefix, libdir))
prepend_path("PKG_CONFIG_PATH", pathJoin(prefix, libdir, "pkgconfig"))
```

To enable support for D4 in Vasp add the following lines to the Makefile:

```make
CPP_OPTIONS += -DDFTD4
LLIBS       += $(shell pkg-config --libs dftd4)
INCS        += $(shell pkg-config --cflags dftd4)
```

Depending on how you built DFT-D4, DFT-D4's dependencies might not be properly recognized during the VASP build. Try to explicitly add them to the link line.

```make
CPP_OPTIONS += -DDFTD4
LLIBS       += $(shell pkg-config --libs dftd4) -lmulticharge -lmctc-lib -lmstore
INCS        += $(shell pkg-config --cflags dftd4)
```

If you still run into issues, check out [VASP-related issues](https://github.com/dftd4/dftd4/issues?q=label%3Avasp%20) on the ``dftd4`` issue tracker.


### C API

The C API provides access to the basic Fortran objects and their most important methods to interact with them.
All Fortran objects are available as opaque `void*` in C and can only be manipulated with the correct API calls.
To evaluate a dispersion correction in C four objects are available:

1. the error handler:

   Simple error handler to carry runtime exceptions created by the library.
   Exceptions can be handled and/or transfered to the downstream error handling system by this means.

2. the molecular structure data:

   Provides a representation of the molecular structure with immutable number of atoms, atomic species, total charge and boundary conditions.
   The object provides a way to update coordinates and lattice parameters, to update immutable quantities the object has to be recreated.

3. the dispersion model:

   Instantiated for a given molecular structure type, it carries no information on the geometry but relies on the atomic species of the structure object.
   Recreating a structure object requires to recreate the dispersion model as well.

4. the damping parameters:

   Damping parameter object determining the short-range behaviour of the dispersion correction.
   Standard damping parameters like the rational damping are independent of the molecular structure and can easily be reused for several structures or easily exchanged.

The user is responsible for creating and deleting the objects to avoid memory leaks.
For convenience the type-generic macro ``dftd4_delete`` is available to free any memory allocation made in the library.


### Python API

The Python API is disabled by default and can be built in-tree or out-of-tree.
The in-tree build is mainly meant for end users and packages.
To build the Python API with the normal project set the `python` option in the configuration step with

```sh
meson setup _build -Dpython=true -Dpython_version=$(which python3)
```

The Python version can be used to select a different Python version, it defaults to `'python3'`.
Python 2 is not supported with this project, the Python version key is meant to select between several local Python 3 versions.

Proceed with the build as described before and install the projects to make the Python API available in the selected prefix.

For the out-of-tree build see the instructions in the [`python`](https://github.com/dftd4/dftd4/blob/main/python) directory.


## Citation

Always cite:

Eike Caldeweyher, Christoph Bannwarth and Stefan Grimme, *J. Chem. Phys.*, **2017**, 147, 034112.
DOI: [10.1063/1.4993215](https://doi.org/10.1063/1.4993215)

Eike Caldeweyher, Sebastian Ehlert, Andreas Hansen, Hagen Neugebauer, Sebastian Spicher, Christoph Bannwarth and Stefan Grimme, *J. Chem Phys*, **2019**, 150, 154122.
DOI: [10.1063/1.5090222](https://doi.org/10.1063/1.5090222)
chemrxiv: [10.26434/chemrxiv.7430216](https://doi.org/10.26434/chemrxiv.7430216.v2)

Eike Caldeweyher, Jan-Michael Mewes, Sebastian Ehlert and Stefan Grimme, *Phys. Chem. Chem. Phys.*, **2020**, 22, 8499-8512.
DOI: [10.1039/D0CP00502A](https://doi.org/10.1039/D0CP00502A)
chemrxiv: [10.26434/chemrxiv.10299428](https://doi.org/10.26434/chemrxiv.10299428.v1)

<br>

In the range-separate hybrid context:

Marvin Friede, Sebastian Ehlert, Stefan Grimme and Jan-Michael Mewes, *J. Chem. Theory Comput.*, **2023**, 19 (22), 8097-8107.
DOI: [10.1021/acs.jctc.3c00717](10.1021/acs.jctc.3c00717)

<br>

Extension to Fr, Ra, and full Actinide series:

Lukas Wittmann, Igor Gordiy, Marvin Friede, Benjamin Helmich-Paris, Stefan Grimme, Andreas Hansen and Markus Bursch, *Phys. Chem. Chem. Phys.*, **2024**, 26, 21379-21394.
DOI: [10.1039/D4CP01514B](10.1039/D4CP01514B)

<br>

Citations can also be viewed via `dftd4 --citation` or in the [BibTeX file](CITATION.bib).


## License

This project is free software: you can redistribute it and/or modify it under
the terms of the Lesser GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This project is distributed in the hope that it will be useful,
but without any warranty; without even the implied warranty of
merchantability or fitness for a particular purpose.  See the
Lesser GNU General Public License for more details.

Unless you explicitly state otherwise, any contribution intentionally
submitted for inclusion in this project by you, as defined in the
Lesser GNU General Public license, shall be licensed as above, without any
additional terms or conditions.

# The D3 dispersion model

[![Latest Version](https://img.shields.io/github/v/release/dftd3/simple-dftd3)](https://github.com/dftd3/simple-dftd3/releases/latest)
[![LGPL-3.0-or-later](https://img.shields.io/github/license/dftd3/simple-dftd3)](COPYING)
[![JOSS](https://joss.theoj.org/papers/1a0f4b4571b8a362d596bd5759572d7f/status.svg)](https://joss.theoj.org/papers/1a0f4b4571b8a362d596bd5759572d7f)
[![CI](https://github.com/dftd3/simple-dftd3/workflows/CI/badge.svg)](https://github.com/dftd3/simple-dftd3/actions)
[![Documentation](https://readthedocs.org/projects/dftd3/badge/?version=latest)](https://dftd3.readthedocs.io/en/latest/)
[![docs](https://github.com/dftd3/simple-dftd3/actions/workflows/docs.yml/badge.svg)](https://dftd3.github.io/simple-dftd3/)
[![codecov](https://codecov.io/gh/dftd3/simple-dftd3/branch/main/graph/badge.svg)](https://codecov.io/gh/dftd3/simple-dftd3)

This package provides a library first implementation of the DFT-D3 dispersion correction
(see [*JCP* **132**, 154104 (2010)](https://dx.doi.org/10.1063/1.3382344)
and [*JCC* **32**, 1456 (2011)](https://dx.doi.org/10.1002/jcc.21759) for details).
Usable via the command line interface of the [`s-dftd3` executable](man/s-dftd3.1.adoc),
in Fortran via the [`dftd3` module](https://dftd3.readthedocs.io/en/latest/api/fortran.html),
with the C interface by including the [`dftd3.h` header](https://dftd3.readthedocs.io/en/latest/api/c.html),
or in Python by using the [`dftd3` module](https://dftd3.readthedocs.io/en/latest/api/python.html).
Additionally, the geometric counter-poise correction (see [*JCP* **136**, 154101 (2012)](https://dx.doi.org/10.1063/1.3700154))
is available to correct for basis set superposition errors and construct composite electronic structure methods of the 3c family.


## Installation

A full guide for installing this package or building from source can be found in the
[installation guide](https://dftd3.readthedocs.io/en/latest/installation.html).

### Conda package

[![Conda Version](https://img.shields.io/conda/vn/conda-forge/simple-dftd3.svg?label=simple-dftd3)](https://anaconda.org/conda-forge/simple-dftd3)
[![Conda Version](https://img.shields.io/conda/vn/conda-forge/dftd3-python.svg?label=dftd3-python)](https://anaconda.org/conda-forge/dftd3-python)

The preferred way of installing this package is from the *conda-forge* distribution via the *mamba* package manager.
To install the *mamba* package manager the [miniforge](https://github.com/conda-forge/miniforge/releases) installer can be used.
If you already have the *mamba* package manager installed add the *conda-forge* channel if it is not yet enabled:

```
mamba config --add channels conda-forge
```

Once the *conda-forge* channel has been enabled, this project can be installed with:

```
mamba install simple-dftd3
```

If you want to enable the Python API as well install

```
mamba install dftd3-python
```

Now you are ready to use ``s-dftd3``.


### Building from Source

To build this project from the source code in this repository you need a Fortran compiler supporting
at least the Fortran 2008 standard.
If a C compiler is available the C interface tests will be build with this compiler.
For building the Python bindings a C compiler is required to build the Python extension module.

For building from source the

- [meson](https://mesonbuild.com) version 0.58 or newer, with
  a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.7 or newer
- [asciidoctor](https://asciidoctor.org/) to build the manual page (optional)
- [FORD](https://forddocs.readthedocs.io/en/stable/) to build the developer documentation (optional)
- Python 3.7 or newer with the [CFFI](https://cffi.readthedocs.io/en/latest/), [NumPy](https://numpy.org/) and [setuptools](https://setuptools.pypa.io/en/latest/index.html) package installed to build the Python API

This project builds on many existing Fortran packages, the following ones are used as dependencies

- [mctc-lib](https://github.com/grimme-lab/mctc-lib):
  For reading geometry files in a wide range of formats
  (like xyz, PBD, mol, SDF, Turbomole, DFTB+, Vasp, FHI-aims, Gaussian, QChem, QCSchema JSON, Chemical JSON)
- [toml-f](https://toml-f.readthedocs.org)
  For reading the parameter file with all damping parameters
  (see [`assets/`](assets/parameters.toml))
- [mstore](https://github.com/grimme-lab/mstore)
  For molecule fixtures to use when defining unit tests
  (testing only)
- [test-drive](https://github.com/fortran-lang/test-drive)
  Unit testing framework
  (testing only)

If these Fortran packages are not available, the build system will automatically fetch them and build
them as part of this project.

To setup a build use

```
meson setup _build --prefix=/path/to/install
```

You can select the Fortran compiler by the `FC` environment variable, similarly the C compiler is selected from the `CC` environment variable.
To compile and run the projects testsuite use

```
meson test -C _build --print-errorlogs
```

If the testsuite passes you can install with

```
meson install -C _build
```

This might require administrator access depending on the chosen install prefix.

Meson is the primary build system and provides feature-complete functionality of this project.
If you for any reason cannot use meson, this project also supports CMake and fpm as build systems.
For more details checkout the [installation guide](https://dftd3.readthedocs.io/en/latest/installation.html#building-from-source).


## Generating docs

The documentation is generated using [sphinx](https://www.sphinx-doc.org) for the general documentation and the Python API,
[FORD](https://forddocs.readthedocs.io) for the Fortran API documentation,
and [asciidoctor](https://asciidoctor.org/) for the command line interface manpage.


### Documentation pages (Sphinx)

[![Documentation](https://readthedocs.org/projects/dftd3/badge/?version=latest)](https://dftd3.readthedocs.io/en/latest/)

For generating the main documentation pages, install the documentation dependencies with

```
pip install -r doc/requirements.txt
```

The pages can be built with

```
sphinx-build doc _docs -b html
```

To view the final pages you can start a HTTP server via

```
python -m http.server -d _docs
```

And open the shown URL in a browser (usually this is https://localhost:8000).
The documentation is automatically deployed from the main branch and can be viewed on [readthedocs](https://dftd3.readthedocs.io/).


### API documentation (Ford)

[![docs](https://github.com/dftd3/simple-dftd3/actions/workflows/docs.yml/badge.svg)](https://dftd3.github.io/simple-dftd3/)

To generate the API documentation of the Fortran library install ford via

```
mamba install ford
```

The API documentation can be generated with

```
ford docs.md -o _api
```

To view the final pages you can start a HTTP server via

```
python -m http.server -d _docs
```

And open the shown URL in a browser.
The API documentation is automatically deployed from the main branch and can be viewed on [GitHub pages](https://dftd3.github.io/simple-dftd3).


## Usage

DFT-D3 calculations can be performed with the ``s-dftd3`` executable.
To calculate the dispersion correction for PBE0-D3(BJ)-ATM run:

```
s-dftd3 --bj pbe0 --atm coord
```

In case you want to access the DFT-D3 results from other programs, dump the results to JSON with
(the ``--noedisp`` flag prevents the ``.EDISP`` file generation):

```
s-dftd3 --bj pbe0 --atm --json --grad --noedisp struct.xyz
```

Dispersion related properties can be calculated as well:

```
s-dftd3 --property geo.gen
```

For an overview over all command line arguments use the ``--help`` argument or checkout the [``s-dftd3(1)``](man/s-dftd3.1.adoc) manpage.


## API access

This DFT-D3 implementation provides first class API support Fortran, C and Python.
Other programming languages should try to interface via one of those three APIs.
To provide first class API support for a new language the interface specification should be available as meson build files.


### Fortran API

The recommended way to access the Fortran module API is by using ``dftd3`` as a meson subproject.
Alternatively, the project is accessible by the Fortran package manager ([fpm](https://github.com/fortran-lang/fpm)) or as CMake subproject as explained above.

The complete API is available from ``dftd3`` module, the individual modules are available to the user as well but are not part of the public API and therefore not guaranteed to remain stable.
API compatibility is only guaranteed for the same minor version, while ABI compatibility cannot be guaranteed in a pre 1.0 stage.

The communication with the Fortran API uses the ``error_type`` and ``structure_type`` of the modular computation tool chain library (mctc-lib) to handle errors and represent geometries, respectively.


### C API

The C API provides access to the basic Fortran objects and their most important methods to interact with them.
All Fortran objects are available as opaque ``void*`` in C and can only be manipulated with the correct API calls.
To evaluate a dispersion correction in C four objects are available:

1. the error handler:

   Simple error handler to carry runtime exceptions created by the library.
   Exceptions can be handled and/or transfered to the downstream error handling system by this means.

2. the molecular structure data:

   Provides a representation of the molecular structure with immutable number of atoms, atomic species, total charge and boundary conditions.
   The object provides a way to update coordinates and lattice parameters, to update immutable quantities the object has to be recreated.

3. the dispersion model:

   Instantiated for a given molecular structure type, it carries no information on the geometry but relies on the atomic species of the structure object.
   Recreating a structure object requires to recreate the dispersion model as well.

4. the damping parameters:

   Damping parameter object determining the short-range behaviour of the dispersion correction.
   Standard damping parameters like the rational damping are independent of the molecular structure and can easily be reused for several structures or easily exchanged.

5. the counter-poise parameters:

   Counter-poise parameter object determining the basis set specific correction for basis set superposition error.
   Recreating a structure object requires to recreate the counter-poise parameters as well as they are dependent on the basis definition for each element type.

The user is responsible for creating and deleting the objects to avoid memory leaks.


### Python API

The Python API is disabled by default and can be built in-tree or out-of-tree.
The in-tree build is mainly meant for end users and packages.
To build the Python API with the normal project set the ``python`` option in the configuration step with

```sh
meson setup _build -Dpython=true -Dpython_version=$(which python3)
```

The Python version can be used to select a different Python version, it defaults to `'python3'`.
Python 2 is not supported with this project, the Python version key is meant to select between several local Python 3 versions.

Proceed with the build as described before and install the projects to make the Python API available in the selected prefix.

For the out-of-tree build see the instructions in the [``python``](./python) directory.


## Contributing

This is a volunteer open source projects and contributions are always welcome. 
Please, take a moment to read the [contributing guidelines](CONTRIBUTING.md).


## License

This project is free software: you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This project is distributed in the hope that it will be useful,
but without any warranty; without even the implied warranty of
merchantability or fitness for a particular purpose.  See the
GNU Lesser General Public License for more details.

Unless you explicitly state otherwise, any contribution intentionally
submitted for inclusion in this project by you, as defined in the
GNU Lesser General Public license, shall be licensed as above, without any
additional terms or conditions.

# The simple testing framework

[![License](https://img.shields.io/badge/license-MIT%7CApache%202.0-blue)](LICENSE-Apache)
[![Latest Version](https://img.shields.io/github/v/release/fortran-lang/test-drive)](https://github.com/fortran-lang/test-drive/releases/latest)
[![CI](https://github.com/fortran-lang/test-drive/workflows/CI/badge.svg)](https://github.com/fortran-lang/test-drive/actions)
[![codecov](https://codecov.io/gh/fortran-lang/test-drive/branch/main/graph/badge.svg)](https://codecov.io/gh/fortran-lang/test-drive)

This project offers a lightweight, procedural unit testing framework based on nothing but standard Fortran.
Integration with [meson](https://mesonbuild.com), [cmake](https://cmake.org) and [Fortran package manager (fpm)](https://github.com/fortran-lang/fpm) is available.
Alternatively, the [``testdrive.F90``](src/testdrive.F90) source file can be redistributed in the project's testsuite as well.


## Usage

Testsuites are defined by a ``collect_interface`` returning a set of ``unittest_type`` objects.
To create a new test use the ``new_unittest`` constructor, which requires a test identifier and a procedure with a ``test_interface`` compatible signature.
The error status is communicated by the allocation status of an ``error_type``.

The necessary boilerplate code to setup the test entry point is just

```fortran
program tester
  use, intrinsic :: iso_fortran_env, only : error_unit
  use testdrive, only : run_testsuite, new_testsuite, testsuite_type
  use test_suite1, only : collect_suite1
  use test_suite2, only : collect_suite2
  implicit none
  integer :: stat, is
  type(testsuite_type), allocatable :: testsuites(:)
  character(len=*), parameter :: fmt = '("#", *(1x, a))'

  stat = 0

  testsuites = [ &
    new_testsuite("suite1", collect_suite1), &
    new_testsuite("suite2", collect_suite2) &
    ]

  do is = 1, size(testsuites)
    write(error_unit, fmt) "Testing:", testsuites(is)%name
    call run_testsuite(testsuites(is)%collect, error_unit, stat)
  end do

  if (stat > 0) then
    write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
    error stop
  end if

end program tester
```

Every test is defined in a separate module using a ``collect`` function, which is exported and added to the ``testsuites`` array in the test runner.
All tests have a simple interface with just an allocatable ``error_type`` as output to provide the test results.

```fortran
module test_suite1
  use testdrive, only : new_unittest, unittest_type, error_type, check
  implicit none
  private

  public :: collect_suite1

contains

!> Collect all exported unit tests
subroutine collect_suite1(testsuite)
  !> Collection of tests
  type(unittest_type), allocatable, intent(out) :: testsuite(:)

  testsuite = [ &
    new_unittest("valid", test_valid), &
    new_unittest("invalid", test_invalid, should_fail=.true.) &
    ]

end subroutine collect_suite1

subroutine test_valid(error)
  type(error_type), allocatable, intent(out) :: error
  ! ...
end subroutine test_valid

subroutine test_invalid(error)
  type(error_type), allocatable, intent(out) :: error
  ! ...
end subroutine test_invalid

end module test_suite1
```


### Checking test conditions

The procedures defining the tests can contain any Fortran code required for checking the correctness of the project.
An easy way to do so is provided by the generic ``check`` function.

```f90
subroutine test_valid(error)
  type(error_type), allocatable, intent(out) :: error

  call check(error, 1 + 2 == 3)
  if (allocated(error)) return

  ! equivalent to the above
  call check(error, 1 + 2, 3)
  if (allocated(error)) return
end subroutine test_valid
```

After each check, the status of the error should be checked.
Uncaught errors will not be silently dropped, instead the error will be caught, its message displayed and the run aborted.
Possible ways to use check are listed below

| available checks     | arguments                                                      |
| -------------------- | -------------------------------------------------------------- |
| logical check        | *error*, *logical*, ...                                        |
| status check         | *error*, *integer*, ...                                        |
| logical comparison   | *error*, *logical*, *logical*, ...                             |
| integer comparison   | *error*, *integer*, ...                                        |
| character comparison | *error*, *character*, *character*, ...                         |
| real comparison      | *error*, *real*, *real*, ..., thr=*real*, rel=*logical*                |
| real combined check  | *error*, *real*, *real*, *thr_abs*, *thr_rel*, ...                     |
| real NaN check       | *error*, *real*, ...                                                   |
| complex comparison   | *error*, *complex*, *complex*, ..., thr=*real*, rel=*logical*          |
| complex combined check | *error*, *complex*, *complex*, *thr_abs*, *thr_rel*, ...             |
| complex NaN check    | *error*, *complex*, ...                                                |

Each check will generate a meaningful error message based on the available arguments, but can also be provided with a custom error message instead.

The combined check uses a pytest-style tolerance: `|actual - expected| <= max(thr_abs, thr_rel * |expected|)`, where both the absolute and relative threshold should be positive tolerances.
This passes if *either* the absolute or relative threshold is satisfied.

To generate custom checks the ``test_failed`` procedure is available to generate error messages

```f90
subroutine test_custom(error)
  type(error_type), allocatable, intent(out) :: error

  ! ...

  if (.not.cond) then
    call test_failed(error, "Custom check failed")
    return
  end if

  ! ...

  if (.not.cond) then
    call test_failed(error, "Custom check failed", "Additional context")
    return
  end if

end subroutine test_custom
```

To conditionally skip a test use the ``skip_test`` procedure.
It uses the same signature as ``test_failed``, but will mark the respective test as skipped, this is useful to disable tests based on conditional compilation, *e.g.* by using a preprocessor or a different submodule.
An uncaught skipped test will fail regardless, therefore make sure to not run any other checks afterwards.


### Integration in build systems

Finally, for usage with *fpm* it is beneficial to have a single test driver which can run all tests.
While this brings the disadvantage of always having to run the complete testsuite, the main driver can provide the flexibility to select the suite and also the unit test using the boilerplate code shown here:

```f90
!> Driver for unit testing
program tester
  use, intrinsic :: iso_fortran_env, only : error_unit
  use testdrive, only : run_testsuite, new_testsuite, testsuite_type, &
    & select_suite, run_selected, get_argument
  use test_suite1, only : collect_suite1
  use test_suite2, only : collect_suite2
  implicit none
  integer :: stat, is
  character(len=:), allocatable :: suite_name, test_name
  type(testsuite_type), allocatable :: testsuites(:)
  character(len=*), parameter :: fmt = '("#", *(1x, a))'

  stat = 0

  testsuites = [ &
    new_testsuite("suite1", collect_suite1), &
    new_testsuite("suite2", collect_suite2) &
    ]

  call get_argument(1, suite_name)
  call get_argument(2, test_name)

  if (allocated(suite_name)) then
    is = select_suite(testsuites, suite_name)
    if (is > 0 .and. is <= size(testsuites)) then
      if (allocated(test_name)) then
        write(error_unit, fmt) "Suite:", testsuites(is)%name
        call run_selected(testsuites(is)%collect, test_name, error_unit, stat)
        if (stat < 0) then
          error stop 1
        end if
      else
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
      end if
    else
      write(error_unit, fmt) "Available testsuites"
      do is = 1, size(testsuites)
        write(error_unit, fmt) "-", testsuites(is)%name
      end do
      error stop 1
    end if
  else
    do is = 1, size(testsuites)
      write(error_unit, fmt) "Testing:", testsuites(is)%name
      call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do
  end if

  if (stat > 0) then
    write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
    error stop 1
  end if

end program tester
```

From *fpm* this allows to run all tests using just the *fpm test* command, but also to debug an individual test in a debugger.
For example to run *broken-test* in *large-suite* with ``gdb`` use

```
fpm test --runner gdb -- large-suite broken-test
```

To make this approach feasible for meson the tests can be created as individual suites.
A usual layout of the test directory like

```
test
├── main.f90
├── meson.build
├── test_suite1.f90
├── test_suite2.f90
└── ...
```

Can use the following snippet to automatically create individual tests running complete suites inside the driver.
Resolution to the unit tests is possible but usually not desired, because the individual runtime of the tests will be short compared to the overhead to start the actual test.

```meson
testdrive_dep = dependency('test-drive', fallback: ['test-drive', 'testdrive_dep'])

tests = [
  'suite1',
  'suite2',
  # ...
]

test_srcs = files(
  'main.f90',
)
foreach t : tests
  test_srcs += files('test_@0@.f90'.format(t.underscorify()))
endforeach

tester = executable(
  'tester',
  sources: test_srcs,
  dependencies: [proj_dep, testdrive_dep],
)

test('all tests', tester)

foreach t : tests
  test(t, tester, args: t)
endforeach
```

Similar for a CMake based build the tests can be generated automatically for the layout shown below.

```
test
├── CMakeLists.txt
├── main.f90
├── test_suite1.f90
├── test_suite2.f90
└── ...
```

The CMake file in the test directory should look similar to the one shown here

```cmake
if(NOT TARGET "test-drive::test-drive")
  find_package("test-drive" REQUIRED)
endif()

# Unit testing
set(
  tests
  "suite1"
  "suite2"
)
set(
  test-srcs
  "main.f90"
)
foreach(t IN LISTS tests)
  string(MAKE_C_IDENTIFIER ${t} t) 
  list(APPEND test-srcs "test_${t}.f90")
endforeach()

add_executable(
  "${PROJECT_NAME}-tester"
  "${test-srcs}"
)
target_link_libraries(
  "${PROJECT_NAME}-tester"
  PRIVATE
  "${PROJECT_NAME}-lib"
  "test-drive::test-drive"
)

foreach(t IN LISTS tests)
  add_test("${PROJECT_NAME}/${t}" "${PROJECT_NAME}-tester" "${t}")
endforeach()
```


## License

This project is free software: you can redistribute it and/or modify it under the terms of the [Apache License, Version 2.0](LICENSE-Apache) or [MIT license](LICENSE-MIT) at your opinion.

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an _as is_ basis, without warranties or conditions of any kind, either express or implied. See the License for the specific language governing permissions and limitations under the License.

Unless you explicitly state otherwise, any contribution intentionally submitted for inclusion in this project by you, as defined in the Apache-2.0 license, shall be dual licensed as above, without any additional terms or conditions.

# ddX

| **Documentation** | **Build Status** | **Installation** |
|:----------------- |:---------------- |:----------- |
| [![][docs-img]][docs-url] | [![][ci-img]][ci-url] | [![][pypi-img]][pypi-url] [![][conda-img]][conda-url] [![][license-img]][license-url]

[docs-img]: https://img.shields.io/badge/doc-latest-blue.svg
[docs-url]: https://ddsolvation.github.io/ddX
[ci-img]: https://github.com/ddsolvation/ddX/actions/workflows/CI.yaml/badge.svg
[ci-url]: https://github.com/ddsolvation/ddX/actions/workflows/CI.yaml
[cov-img]: https://coveralls.io/repos/ddsolvation/ddX/badge.svg?branch=main&service=github
[cov-url]: https://coveralls.io/github/ddsolvation/ddX?branch=main
[license-img]: https://img.shields.io/badge/License-LGPL%20v3-blue.svg
[license-url]: https://github.com/ddsolvation/ddx/blob/master/LICENSE
[pypi-img]: https://img.shields.io/pypi/v/pyddx
[pypi-url]: https://pypi.org/project/pyddx
[conda-img]: https://anaconda.org/conda-forge/pyddx/badges/version.svg
[conda-url]: https://anaconda.org/conda-forge/pyddx

ddX is an open-source software package for continuum solvation models based on
the domain decomposition paradigm. It contains a common interface for the three
different methods ddCOSMO, ddPCM and ddLPB for the numerical solution to the
COSMO, PCM and LPB solvation models.  ddX computes for these methods the
electrostatic contribution to the solvation energy, the corresponding
contribution to the forces and/or the contribution to the Fock- or DFT
Kohn-Sham-matrix.  Using the common interface, all three methods are accessible
from a host-code that is used to model the solute and which can be on the level
of QM, QM/MM, polarizable MM or MM, or as a standalone application.

## Documentation
The code is documented through the Doxygen, visit the [ddX-documentation](https://ddsolvation.github.io/ddX/).

## License 
ddX: an open-source software package for continuum solvation models based on the domain decomposition paradigm.

Copyright (c) 2022 The ddX Developers.

ddX is free software; you can redistribute it and/or modify it under the terms of the LGPL-3.0 License.

## Using TOML-Fortran with the Fortran package manager

The Fortran package manager [`fpm`](https://github.com/fortran-lang/fpm) can be used to declare TOML-Fortran as dependency for a project, just add

```toml
[dependencies]
toml-f = { git = "https://github.com/toml-f/toml-f" }
```

For more details checkout the packaging information in the `fpm` repository.

This example project will build a simple executable to read and process TOML documents using the TOML-Fortran dependency provided from the project root, serving both as example and a simple integration test.

Test this example by running it from `fpm` on one of the provided example TOML documents:

```
fpm run -- package-1.toml
fpm run -- package-2.toml
```

Note, this is an example project with a made-up package format, for the mere reason of demonstrating functionality, therefore, do not expect all design choices in this example to be sensible ones.

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the effective core Hamiltonian used in the extended tight binding.
module tblite_xtb_h0
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_adjlist, only : adjacency_list
   use tblite_basis_type, only : basis_type
   use tblite_integral_multipole, only : multipole_cgto, multipole_grad_cgto, maxl, msao
   use tblite_scf_potential, only : potential_type
   use tblite_xtb_spec, only : tb_h0spec
   implicit none
   private

   public :: tb_hamiltonian, new_hamiltonian
   public :: get_selfenergy, get_hamiltonian, get_occupation, get_hamiltonian_gradient


   type :: tb_hamiltonian
      !> Atomic level information
      real(wp), allocatable :: selfenergy(:, :)
      !> Coordination number dependence of the atomic levels
      real(wp), allocatable :: kcn(:, :)
      !> Charge dependence of the atomic levels
      real(wp), allocatable :: kq1(:, :)
      !> Charge dependence of the atomic levels
      real(wp), allocatable :: kq2(:, :)
      !> Enhancement factor to scale the Hamiltonian elements
      real(wp), allocatable :: hscale(:, :, :, :)
      !> Polynomial coefficients for distance dependent enhancement factor
      real(wp), allocatable :: shpoly(:, :)
      !> Atomic radius for polynomial enhancement
      real(wp), allocatable :: rad(:)
      !> Reference occupation numbers
      real(wp), allocatable :: refocc(:, :)
   end type tb_hamiltonian


contains


!> Constructor for a new Hamiltonian object, consumes a Hamiltonian specification
subroutine new_hamiltonian(self, mol, bas, spec)
   type(tb_hamiltonian), intent(out) :: self
   type(structure_type), intent(in) :: mol
   type(basis_type), intent(in) :: bas
   class(tb_h0spec), intent(in) :: spec

   integer :: mshell

   mshell = maxval(bas%nsh_id)
   allocate(self%selfenergy(mshell, mol%nid), self%kcn(mshell, mol%nid), &
      & self%kq1(mshell, mol%nid), self%kq2(mshell, mol%nid))
   call spec%get_selfenergy(mol, bas, self%selfenergy)
   call spec%get_cnshift(mol, bas, self%kcn)
   call spec%get_q1shift(mol, bas, self%kq1)
   call spec%get_q2shift(mol, bas, self%kq2)

   allocate(self%hscale(mshell, mshell, mol%nid, mol%nid))
   call spec%get_hscale(mol, bas, self%hscale)

   allocate(self%shpoly(mshell, mol%nid), self%rad(mol%nid))
   call spec%get_rad(mol, bas, self%rad)
   call spec%get_shpoly(mol, bas, self%shpoly)

   allocate(self%refocc(mshell, mol%nid))
   call spec%get_reference_occ(mol, bas, self%refocc)
end subroutine new_hamiltonian


subroutine get_selfenergy(h0, id, ish_at, nshell, cn, qat, selfenergy, dsedcn, dsedq)
   type(tb_hamiltonian), intent(in) :: h0
   integer, intent(in) :: id(:)
   integer, intent(in) :: ish_at(:)
   integer, intent(in) :: nshell(:)
   real(wp), intent(in), optional :: cn(:)
   real(wp), intent(in), optional :: qat(:)
   real(wp), intent(out) :: selfenergy(:)
   real(wp), intent(out), optional :: dsedcn(:)
   real(wp), intent(out), optional :: dsedq(:)

   integer :: iat, izp, ish, ii

   selfenergy(:) = 0.0_wp
   if (present(dsedcn)) dsedcn(:) = 0.0_wp
   if (present(dsedq)) dsedq(:) = 0.0_wp
   do iat = 1, size(id)
      izp = id(iat)
      ii = ish_at(iat)
      do ish = 1, nshell(izp)
         selfenergy(ii+ish) = h0%selfenergy(ish, izp)
      end do
   end do
   if (present(cn)) then
      if (present(dsedcn)) then
         do iat = 1, size(id)
            izp = id(iat)
            ii = ish_at(iat)
            do ish = 1, nshell(izp)
               selfenergy(ii+ish) = selfenergy(ii+ish) - h0%kcn(ish, izp) * cn(iat)
               dsedcn(ii+ish) = -h0%kcn(ish, izp)
            end do
         end do
      else
         do iat = 1, size(id)
            izp = id(iat)
            ii = ish_at(iat)
            do ish = 1, nshell(izp)
               selfenergy(ii+ish) = selfenergy(ii+ish) - h0%kcn(ish, izp) * cn(iat)
            end do
         end do
      end if
   end if
   if (present(qat)) then
      if (present(dsedq)) then
         do iat = 1, size(id)
            izp = id(iat)
            ii = ish_at(iat)
            do ish = 1, nshell(izp)
               selfenergy(ii+ish) = selfenergy(ii+ish) &
                  & - h0%kq1(ish, izp)*qat(iat) - h0%kq2(ish, izp)*qat(iat)**2
               dsedq(ii+ish) = -h0%kq1(ish, izp) - h0%kq2(ish, izp)*2*qat(iat)
            end do
         end do
      else
         do iat = 1, size(id)
            izp = id(iat)
            ii = ish_at(iat)
            do ish = 1, nshell(izp)
               selfenergy(ii+ish) = selfenergy(ii+ish) &
                  & - h0%kq1(ish, izp)*qat(iat) - h0%kq2(ish, izp)*qat(iat)**2
            end do
         end do
      end if
   end if

end subroutine get_selfenergy


subroutine get_hamiltonian(mol, trans, list, bas, h0, selfenergy, overlap, dpint, qpint, &
      & hamiltonian)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points within a given realspace cutoff
   real(wp), intent(in) :: trans(:, :)
   !> Neighbour list
   type(adjacency_list), intent(in) :: list
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Hamiltonian interaction data
   type(tb_hamiltonian), intent(in) :: h0
   !> Diagonal elememts of the Hamiltonian
   real(wp), intent(in) :: selfenergy(:)
   !> Overlap integral matrix
   real(wp), intent(out) :: overlap(:, :)
   !> Dipole moment integral matrix
   real(wp), intent(out) :: dpint(:, :, :)
   !> Quadrupole moment integral matrix
   real(wp), intent(out) :: qpint(:, :, :)
   !> Effective Hamiltonian
   real(wp), intent(out) :: hamiltonian(:, :)

   integer :: iat, jat, izp, jzp, itr, k, img, inl
   integer :: ish, jsh, is, js, ii, jj, iao, jao, nao, ij
   real(wp) :: rr, r2, vec(3), cutoff2, hij, shpoly, dtmpj(3), qtmpj(6)
   real(wp), allocatable :: stmp(:), dtmpi(:, :), qtmpi(:, :)

   overlap(:, :) = 0.0_wp
   dpint(:, :, :) = 0.0_wp
   qpint(:, :, :) = 0.0_wp
   hamiltonian(:, :) = 0.0_wp

   allocate(stmp(msao(bas%maxl)**2), dtmpi(3, msao(bas%maxl)**2), qtmpi(6, msao(bas%maxl)**2))

   !$omp parallel do schedule(runtime) default(none) &
   !$omp shared(mol, bas, trans, list, overlap, dpint, qpint, hamiltonian, h0, selfenergy) &
   !$omp private(iat, jat, izp, jzp, itr, is, js, ish, jsh, ii, jj, iao, jao, nao, ij, k) &
   !$omp private(r2, vec, stmp, dtmpi, qtmpi, dtmpj, qtmpj, hij, shpoly, rr, inl, img)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = bas%ish_at(iat)
      inl = list%inl(iat)
      do img = 1, list%nnl(iat)
         jat = list%nlat(img+inl)
         itr = list%nltr(img+inl)
         jzp = mol%id(jat)
         js = bas%ish_at(jat)
         vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
         r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         rr = sqrt(sqrt(r2) / (h0%rad(jzp) + h0%rad(izp)))
         do ish = 1, bas%nsh_id(izp)
            ii = bas%iao_sh(is+ish)
            do jsh = 1, bas%nsh_id(jzp)
               jj = bas%iao_sh(js+jsh)
               call multipole_cgto(bas%cgto(jsh, jzp), bas%cgto(ish, izp), &
                  & r2, vec, bas%intcut, stmp, dtmpi, qtmpi)

               shpoly = (1.0_wp + h0%shpoly(ish, izp)*rr) &
                  * (1.0_wp + h0%shpoly(jsh, jzp)*rr)

               hij = 0.5_wp * (selfenergy(is+ish) + selfenergy(js+jsh)) &
                  * h0%hscale(jsh, ish, jzp, izp) * shpoly

               nao = msao(bas%cgto(jsh, jzp)%ang)
               do iao = 1, msao(bas%cgto(ish, izp)%ang)
                  do jao = 1, nao
                     ij = jao + nao*(iao-1)
                     call shift_operator(vec, stmp(ij), dtmpi(:, ij), qtmpi(:, ij), &
                        & dtmpj, qtmpj)
                     !$omp atomic
                     overlap(jj+jao, ii+iao) = overlap(jj+jao, ii+iao) &
                        + stmp(ij)

                     do k = 1, 3
                        !$omp atomic
                        dpint(k, jj+jao, ii+iao) = dpint(k, jj+jao, ii+iao) &
                           + dtmpi(k, ij)
                     end do

                     do k = 1, 6
                        !$omp atomic
                        qpint(k, jj+jao, ii+iao) = qpint(k, jj+jao, ii+iao) &
                           + qtmpi(k, ij)
                     end do

                     !$omp atomic
                     hamiltonian(jj+jao, ii+iao) = hamiltonian(jj+jao, ii+iao) &
                        + stmp(ij) * hij

                     if (iat /= jat) then
                        !$omp atomic
                        overlap(ii+iao, jj+jao) = overlap(ii+iao, jj+jao) &
                           + stmp(ij)
                        do k = 1, 3
                           !$omp atomic
                           dpint(k, ii+iao, jj+jao) = dpint(k, ii+iao, jj+jao) &
                              + dtmpj(k)
                        end do

                        do k = 1, 6
                           !$omp atomic
                           qpint(k, ii+iao, jj+jao) = qpint(k, ii+iao, jj+jao) &
                              + qtmpj(k)
                        end do
                        !$omp atomic
                        hamiltonian(ii+iao, jj+jao) = hamiltonian(ii+iao, jj+jao) &
                           + stmp(ij) * hij
                     end if
                  end do
               end do

            end do
         end do

      end do
   end do

   !$omp parallel do schedule(runtime) default(none) &
   !$omp shared(mol, bas, trans, cutoff2, overlap, dpint, qpint, hamiltonian, h0, selfenergy) &
   !$omp private(iat, izp, itr, is, ish, jsh, ii, jj, iao, jao, nao, ij) &
   !$omp private(r2, vec, stmp, dtmpi, qtmpi, hij, shpoly, rr)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = bas%ish_at(iat)
      vec(:) = 0.0_wp
      r2 = 0.0_wp
      rr = sqrt(sqrt(r2) / (h0%rad(izp) + h0%rad(izp)))
      do ish = 1, bas%nsh_id(izp)
         ii = bas%iao_sh(is+ish)
         do jsh = 1, bas%nsh_id(izp)
            jj = bas%iao_sh(is+jsh)
            call multipole_cgto(bas%cgto(jsh, izp), bas%cgto(ish, izp), &
               & r2, vec, bas%intcut, stmp, dtmpi, qtmpi)

            shpoly = (1.0_wp + h0%shpoly(ish, izp)*rr) &
               * (1.0_wp + h0%shpoly(jsh, izp)*rr)

            hij = 0.5_wp * (selfenergy(is+ish) + selfenergy(is+jsh)) &
               * shpoly

            nao = msao(bas%cgto(jsh, izp)%ang)
            do iao = 1, msao(bas%cgto(ish, izp)%ang)
               do jao = 1, nao
                  ij = jao + nao*(iao-1)
                  overlap(jj+jao, ii+iao) = overlap(jj+jao, ii+iao) &
                     + stmp(ij)

                  dpint(:, jj+jao, ii+iao) = dpint(:, jj+jao, ii+iao) &
                     + dtmpi(:, ij)

                  qpint(:, jj+jao, ii+iao) = qpint(:, jj+jao, ii+iao) &
                     + qtmpi(:, ij)

                  hamiltonian(jj+jao, ii+iao) = hamiltonian(jj+jao, ii+iao) &
                     + stmp(ij) * hij
               end do
            end do

         end do
      end do

   end do

end subroutine get_hamiltonian


subroutine get_hamiltonian_gradient(mol, trans, list, bas, h0, selfenergy, dsedcn, &
      & pot, pmat, xmat, dEdcn, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points within a given realspace cutoff
   real(wp), intent(in) :: trans(:, :)
   !> Neighbour list
   type(adjacency_list), intent(in) :: list
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Hamiltonian interaction data
   type(tb_hamiltonian), intent(in) :: h0
   !> Diagonal elememts of the Hamiltonian
   real(wp), intent(in) :: selfenergy(:)
   !> Derivative of the diagonal elements of the Hamiltonian w.r.t. the coordination number
   real(wp), intent(in) :: dsedcn(:)
   !> Density dependent potential shifts on the Hamiltonian
   type(potential_type), intent(in) :: pot
   !> Density matrix
   real(wp), intent(in) :: pmat(:, :, :)
   !> Energy weighted density matrix
   real(wp), intent(in) :: xmat(:, :, :)

   !> Derivative of the electronic energy w.r.t. the coordination number
   real(wp), intent(inout) :: dEdcn(:)
   !> Derivative of the electronic energy w.r.t. coordinate displacements
   real(wp), intent(inout) :: gradient(:, :)
   !> Derivative of the electronic energy w.r.t. strain deformations
   real(wp), intent(inout) :: sigma(:, :)

   integer :: iat, jat, izp, jzp, itr, img, inl, spin, nspin
   integer :: ish, jsh, is, js, ii, jj, iao, jao, nao, ij
   real(wp) :: rr, r2, vec(3), cutoff2, hij, shpoly, dshpoly, dG(3), hscale
   real(wp) :: sval, dcni, dcnj, dhdcni, dhdcnj, hpij, pij
   real(wp), allocatable :: stmp(:), dtmp(:, :), qtmp(:, :)
   real(wp), allocatable :: dstmp(:, :), ddtmpi(:, :, :), dqtmpi(:, :, :)
   real(wp), allocatable :: ddtmpj(:, :, :), dqtmpj(:, :, :)

   nspin = size(pmat, 3)

   allocate(stmp(msao(bas%maxl)**2), dstmp(3, msao(bas%maxl)**2), &
      & dtmp(3, msao(bas%maxl)**2), ddtmpi(3, 3, msao(bas%maxl)**2), &
      & qtmp(6, msao(bas%maxl)**2), dqtmpi(3, 6, msao(bas%maxl)**2), &
      & ddtmpj(3, 3, msao(bas%maxl)**2), dqtmpj(3, 6, msao(bas%maxl)**2))

   !$omp parallel do schedule(runtime) default(none) reduction(+:dEdcn, gradient, sigma) &
   !$omp shared(mol, bas, trans, h0, selfenergy, dsedcn, pot, pmat, xmat, list, nspin) &
   !$omp private(iat, jat, izp, jzp, itr, is, js, ish, jsh, ii, jj, iao, jao, nao, ij, spin, &
   !$omp& r2, vec, stmp, dtmp, qtmp, dstmp, ddtmpi, dqtmpi, ddtmpj, dqtmpj, hij, shpoly, &
   !$omp& dshpoly, dG, dcni, dcnj, dhdcni, dhdcnj, hpij, rr, sval, hscale, pij, inl, img)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = bas%ish_at(iat)
      inl = list%inl(iat)
      do img = 1, list%nnl(iat)
         jat = list%nlat(img+inl)
         itr = list%nltr(img+inl)
         jzp = mol%id(jat)
         js = bas%ish_at(jat)
         if (iat == jat) cycle
         vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
         r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         rr = sqrt(sqrt(r2) / (h0%rad(jzp) + h0%rad(izp)))
         do ish = 1, bas%nsh_id(izp)
            ii = bas%iao_sh(is+ish)
            do jsh = 1, bas%nsh_id(jzp)
               jj = bas%iao_sh(js+jsh)
               call multipole_grad_cgto(bas%cgto(jsh, jzp), bas%cgto(ish, izp), &
                  & r2, vec, bas%intcut, stmp, dtmp, qtmp, dstmp, ddtmpj, dqtmpj, &
                  & ddtmpi, dqtmpi)

               shpoly = (1.0_wp + h0%shpoly(ish, izp)*rr) &
                  & * (1.0_wp + h0%shpoly(jsh, jzp)*rr)
               dshpoly = ((1.0_wp + h0%shpoly(ish, izp)*rr)*h0%shpoly(jsh, jzp)*rr &
                  & + (1.0_wp + h0%shpoly(jsh, jzp)*rr)*h0%shpoly(ish, izp)*rr) &
                  & * 0.5_wp / r2

               hscale = h0%hscale(jsh, ish, jzp, izp)
               hij = 0.5_wp * (selfenergy(is+ish) + selfenergy(js+jsh)) * hscale
               dhdcni = dsedcn(is+ish) * shpoly * hscale
               dhdcnj = dsedcn(js+jsh) * shpoly * hscale

               dG(:) = 0.0_wp
               dcni = 0.0_wp
               dcnj = 0.0_wp
               nao = msao(bas%cgto(jsh, jzp)%ang)
               do iao = 1, msao(bas%cgto(ish, izp)%ang)
                  do jao = 1, nao
                     ij = jao + nao*(iao-1)
                     do spin = 1, nspin
                        pij = pmat(jj+jao, ii+iao, spin)
                        hpij = pij * hij * shpoly
                        sval = 2*hpij - 2*xmat(jj+jao, ii+iao, spin) &
                           - pij * (pot%vao(jj+jao, spin) + pot%vao(ii+iao, spin))

                        dG(:) = dG + sval * dstmp(:, ij) &
                           + 2*hpij*stmp(ij) * dshpoly / shpoly * vec &
                           - pij * matmul(ddtmpi(:, :, ij), pot%vdp(:, iat, spin)) &
                           - pij * matmul(ddtmpj(:, :, ij), pot%vdp(:, jat, spin)) &
                           - pij * matmul(dqtmpi(:, :, ij), pot%vqp(:, iat, spin)) &
                           - pij * matmul(dqtmpj(:, :, ij), pot%vqp(:, jat, spin))

                        dcni = dcni + dhdcni * pmat(jj+jao, ii+iao, spin) * stmp(ij)
                        dcnj = dcnj + dhdcnj * pmat(jj+jao, ii+iao, spin) * stmp(ij)
                     end do
                  end do
               end do
               dEdcn(iat) = dEdcn(iat) + dcni
               dEdcn(jat) = dEdcn(jat) + dcnj
               gradient(:, iat) = gradient(:, iat) + dG
               gradient(:, jat) = gradient(:, jat) - dG
               sigma(:, :) = sigma + 0.5_wp * (spread(vec, 1, 3) * spread(dG, 2, 3) &
                  + spread(dG, 1, 3) * spread(vec, 2, 3))

            end do
         end do

      end do
   end do

   !$omp parallel do schedule(runtime) default(none) reduction(+:dEdcn) &
   !$omp shared(mol, bas, dsedcn, pmat, nspin) &
   !$omp private(iat, izp, jzp, is, ish, ii, iao, dcni, dhdcni, spin)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = bas%ish_at(iat)
      do ish = 1, bas%nsh_id(izp)
         ii = bas%iao_sh(is+ish)
         dhdcni = dsedcn(is+ish)
         dcni = 0.0_wp
         do iao = 1, msao(bas%cgto(ish, izp)%ang)
            do spin = 1, nspin
               dcni = dcni + dhdcni * pmat(ii+iao, ii+iao, spin)
            end do
         end do
         dEdcn(iat) = dEdcn(iat) + dcni
      end do
   end do

end subroutine get_hamiltonian_gradient


subroutine get_occupation(mol, bas, h0, nocc, n0at, n0sh)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Hamiltonian interaction data
   type(tb_hamiltonian), intent(in) :: h0
   !> Occupation number
   real(wp), intent(out) :: nocc
   !> Reference occupation for each atom
   real(wp), intent(out) :: n0at(:)
   !> Reference occupation for each shell
   real(wp), intent(out) :: n0sh(:)

   integer :: iat, ish, izp, ii

   nocc = -mol%charge
   n0at(:) = 0.0_wp
   n0sh(:) = 0.0_wp
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = bas%ish_at(iat)
      do ish = 1, bas%nsh_id(izp)
         nocc = nocc + h0%refocc(ish, izp)
         n0at(iat) = n0at(iat) + h0%refocc(ish, izp)
         n0sh(ii+ish) = n0sh(ii+ish) + h0%refocc(ish, izp)
      end do
   end do

end subroutine get_occupation


!> Shift multipole operator from Ket function (center i) to Bra function (center j),
!> the multipole operator on the Bra function can be assembled from the lower moments
!> on the Ket function and the displacement vector using horizontal shift rules.
pure subroutine shift_operator(vec, s, di, qi, dj, qj)
   !> Displacement vector of center i and j
   real(wp),intent(in) :: vec(:)
   !> Overlap integral between basis functions
   real(wp),intent(in) :: s
   !> Dipole integral with operator on Ket function (center i)
   real(wp),intent(in) :: di(:)
   !> Quadrupole integral with operator on Ket function (center i)
   real(wp),intent(in) :: qi(:)
   !> Dipole integral with operator on Bra function (center j)
   real(wp),intent(out) :: dj(:)
   !> Quadrupole integral with operator on Bra function (center j)
   real(wp),intent(out) :: qj(:)

   real(wp) :: tr

   ! Create dipole operator on Bra function from Ket function and shift contribution
   ! due to monopol displacement
   dj(1) = di(1) + vec(1)*s
   dj(2) = di(2) + vec(2)*s
   dj(3) = di(3) + vec(3)*s

   ! For the quadrupole operator on the Bra function we first construct the shift
   ! contribution from the dipole and monopol displacement, since we have to remove
   ! the trace contribution from the shift and the moment integral on the Ket function
   ! is already traceless
   qj(1) = 2*vec(1)*di(1) + vec(1)**2*s
   qj(3) = 2*vec(2)*di(2) + vec(2)**2*s
   qj(6) = 2*vec(3)*di(3) + vec(3)**2*s
   qj(2) = vec(1)*di(2) + vec(2)*di(1) + vec(1)*vec(2)*s
   qj(4) = vec(1)*di(3) + vec(3)*di(1) + vec(1)*vec(3)*s
   qj(5) = vec(2)*di(3) + vec(3)*di(2) + vec(2)*vec(3)*s
   ! Now collect the trace of the shift contribution
   tr = 0.5_wp * (qj(1) + qj(3) + qj(6))

   ! Finally, assemble the quadrupole operator on the Bra function from the operator
   ! on the Ket function and the traceless shift contribution
   qj(1) = qi(1) + 1.5_wp * qj(1) - tr
   qj(2) = qi(2) + 1.5_wp * qj(2)
   qj(3) = qi(3) + 1.5_wp * qj(3) - tr
   qj(4) = qi(4) + 1.5_wp * qj(4)
   qj(5) = qi(5) + 1.5_wp * qj(5)
   qj(6) = qi(6) + 1.5_wp * qj(6) - tr
end subroutine shift_operator


end module tblite_xtb_h0

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_scf_info
   use mctc_env, only : sp, dp, error_type
   implicit none
   private

   public :: scf_info, not_used, atom_resolved, shell_resolved, orbital_resolved, max

   integer, parameter :: not_used = 0
   integer, parameter :: atom_resolved = 1
   integer, parameter :: shell_resolved = 2
   integer, parameter :: orbital_resolved = 3

   type :: scf_info
      integer :: charge = not_used
      integer :: dipole = not_used
      integer :: quadrupole = not_used
   end type scf_info

   interface max
      module procedure :: max_info
   end interface max

contains

pure function max_info(lhs, rhs) result(new)
   type(scf_info), intent(in) :: lhs
   type(scf_info), intent(in) :: rhs
   type(scf_info) :: new

   new = scf_info( &
      charge=max(lhs%charge, rhs%charge), &
      dipole=max(lhs%dipole, rhs%dipole), &
      quadrupole=max(lhs%quadrupole, rhs%quadrupole))

end function max_info

end module tblite_scf_info

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> High-level interface to level 3 basic linear algebra subprogram operations
module tblite_blas_level3
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_gemm


   !> Performs one of the matrix-matrix operations
   !>
   !>    C := alpha*A*B + beta*C,
   !>
   !> or
   !>
   !>    C := alpha*B*A + beta*C,
   !>
   !> where alpha and beta are scalars,  A is a symmetric matrix and  B and
   !> C are  m by n matrices.
   interface wrap_gemm
      module procedure :: wrap_sgemm
      module procedure :: wrap_dgemm
      module procedure :: wrap_sgemm323
      module procedure :: wrap_sgemm233
      module procedure :: wrap_sgemm332
      module procedure :: wrap_dgemm323
      module procedure :: wrap_dgemm233
      module procedure :: wrap_dgemm332
   end interface wrap_gemm


   !> Performs one of the matrix-matrix operations
   !>
   !>    C := alpha*op( A )*op( B ) + beta*C,
   !>
   !> where  op( X ) is one of
   !>
   !>    op( X ) = X   or   op( X ) = X**T,
   !>
   !> alpha and beta are scalars, and A, B and C are matrices, with op( A )
   !> an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
   interface blas_gemm
      pure subroutine sgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, &
            & beta, c, ldc)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: b(ldb, *)
         real(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: transb
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine sgemm
      pure subroutine dgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, &
            & beta, c, ldc)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: b(ldb, *)
         real(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: transb
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine dgemm
   end interface blas_gemm


contains


pure subroutine wrap_sgemm(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: bmat(:, :)
   real(sp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1) :: tra, trb
   real(sp) :: a, b
   integer :: m, n, k, lda, ldb, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_sp
   end if
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if ((tra.eq.'n'.or.tra.eq.'N')) then
      k = size(amat, 2)
   else
      k = size(amat, 1)
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   m = size(cmat, 1)
   n = size(cmat, 2)
   call blas_gemm(tra, trb, m, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
end subroutine wrap_sgemm


pure subroutine wrap_dgemm(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: bmat(:, :)
   real(dp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1) :: tra, trb
   real(dp) :: a, b
   integer :: m, n, k, lda, ldb, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_dp
   end if
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if ((tra.eq.'n'.or.tra.eq.'N')) then
      k = size(amat, 2)
   else
      k = size(amat, 1)
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   m = size(cmat, 1)
   n = size(cmat, 2)
   call blas_gemm(tra, trb, m, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
end subroutine wrap_dgemm


subroutine wrap_sgemm323(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in) :: bmat(:, :)
   real(sp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   real(sp), pointer :: aptr(:, :), cptr(:, :)
   character(len=1) :: tra
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   end if
   cptr(1:size(cmat, 1)*size(cmat, 2), 1:size(cmat, 3)) => cmat
   call wrap_gemm(aptr, bmat, cptr, tra, transb, alpha, beta)
end subroutine wrap_sgemm323


subroutine wrap_sgemm233(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in), contiguous, target :: bmat(:, :, :)
   real(sp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   real(sp), pointer :: bptr(:, :), cptr(:, :)
   character(len=1) :: trb
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   end if
   cptr(1:size(cmat, 1), 1:size(cmat, 2)*size(cmat, 3)) => cmat
   call wrap_gemm(amat, bptr, cptr, transa, trb, alpha, beta)
end subroutine wrap_sgemm233


subroutine wrap_sgemm332(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in), contiguous, target :: bmat(:, :, :)
   real(sp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   real(sp), pointer :: aptr(:, :), bptr(:, :)
   character(len=1) :: tra, trb
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   end if
   call wrap_gemm(aptr, bptr, cmat, tra, trb, alpha, beta)
end subroutine wrap_sgemm332


subroutine wrap_dgemm323(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in) :: bmat(:, :)
   real(dp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   real(dp), pointer :: aptr(:, :), cptr(:, :)
   character(len=1) :: tra
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   end if
   cptr(1:size(cmat, 1)*size(cmat, 2), 1:size(cmat, 3)) => cmat
   call wrap_gemm(aptr, bmat, cptr, tra, transb, alpha, beta)
end subroutine wrap_dgemm323


subroutine wrap_dgemm233(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in), contiguous, target :: bmat(:, :, :)
   real(dp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   real(dp), pointer :: bptr(:, :), cptr(:, :)
   character(len=1) :: trb
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   end if
   cptr(1:size(cmat, 1), 1:size(cmat, 2)*size(cmat, 3)) => cmat
   call wrap_gemm(amat, bptr, cptr, transa, trb, alpha, beta)
end subroutine wrap_dgemm233


subroutine wrap_dgemm332(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in), contiguous, target :: bmat(:, :, :)
   real(dp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   real(dp), pointer :: aptr(:, :), bptr(:, :)
   character(len=1) :: tra, trb
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   end if
   call wrap_gemm(aptr, bptr, cmat, tra, trb, alpha, beta)
end subroutine wrap_dgemm332


end module tblite_blas_level3

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Integrator for Born radii
module tblite_solvation_born
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use mctc_io_convert, only : aatoau
   use tblite_adjlist, only : adjacency_list, new_adjacency_list
   implicit none
   private

   public :: born_integrator, new_born_integrator

   !> Implementation of GBOBC integrator
   type :: born_integrator
      !> van der Waals radii of the particles
      real(wp), allocatable :: vdwr(:)
      !> pair descreening approximation radii
      real(wp), allocatable :: rho(:)
      !> offset van der Waals radii
      real(wp), allocatable :: svdw(:)
      !> cut-off radius for the Born radius NN list
      real(wp) :: lrcut
      !> Scaling factor for Born radii
      real(wp) :: born_scale
      !> Volume polynome correction, default parameters correspond to GBOBCII
      real(wp) :: obc(3)
   contains
      !> Calculate Born radii for a given geometry
      procedure :: get_rad
   end type born_integrator

   real(wp), parameter :: lrcut_default = 35.0_wp * aatoau
   real(wp), parameter :: born_scale_default = 1.0_wp
   real(wp), parameter :: born_offset_default = 0.0_wp
   real(wp), parameter :: descreening_default = 0.8_wp
   real(wp), parameter :: obc_default(3) = [1.0_wp, 0.8_wp, 4.85_wp]

contains

!> Create new Born radii integrator
subroutine new_born_integrator(self, mol, vdwrad, descreening, born_scale, born_offset, &
      & obc, rcutoff)
   !> Instance of the Born integrator
   type(born_integrator), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Van-der-Waals Radii
   real(wp), intent(in) :: vdwRad(:)
   !> Dielectric descreening parameter
   real(wp), intent(in), optional :: descreening(:)
   !> Scaling factor for Born radii
   real(wp), intent(in), optional :: born_scale
   !> Offset parameter for Born radii integration
   real(wp), intent(in), optional :: born_offset
   !> GBOBC integrator parameters
   real(wp), intent(in), optional :: obc(3)
   !> Real-space cutoff for Born radii integration
   real(wp), intent(in), optional :: rCutoff

   self%lrcut = lrcut_default
   if (present(rCutoff)) then
      self%lrcut = rCutoff
   end if

   self%born_scale = born_scale_default
   if (present(born_scale)) then
      self%born_scale = born_scale
   end if

   self%obc = obc_default
   if (present(obc)) then
      self%obc = obc
   end if

   self%vdwr = vdwRad(mol%id)

   if (present(descreening)) then
      self%rho = self%vdwr * descreening(mol%id)
   else
      self%rho = self%vdwr * descreening_default
   end if

   if (present(born_offset)) then
      self%svdw = self%vdwr - born_offset
   else
      self%svdw = self%vdwr - born_offset_default
   end if
end subroutine new_born_integrator

!> Calculate Born radii
subroutine get_rad(self, mol, rad, draddr)
   !> Instance of the Born integrator
   class(born_integrator), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Born radii
   real(wp), intent(out) :: rad(:)
   !> Derivative of Born radii w.r.t. cartesian displacements
   real(wp), intent(out), optional :: draddr(:, :, :)

   type(adjacency_list) :: list
   real(wp), parameter :: trans(3, 1) = 0.0_wp
   real(wp), allocatable :: brdr(:, :, :)

   call new_adjacency_list(list, mol, trans, self%lrcut)
   allocate(brdr(3, mol%nat, mol%nat))

   call compute_bornr(mol%nat, mol%xyz, list, &
      & self%vdwr, self%rho, self%svdw, self%born_scale, self%obc, rad, brdr)

   if (present(draddr)) then
      draddr(:, :, :) = brdr
   end if
end subroutine get_rad

subroutine compute_bornr(nat, xyz, list, vdwr, rho, svdw, c1, obc, &
      & brad, brdr)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Neighbourlist
   type(adjacency_list), intent(in) :: list
   !> Van-der-Waals radii
   real(wp), intent(in) :: vdwr(:)
   !> Descreened van-der-Waals radii
   real(wp), intent(in) :: rho(:)
   !> van-der-Waals radii with offset
   real(wp), intent(in) :: svdw(:)
   !> Scaling factor for the Born radii
   real(wp), intent(in) :: c1
   !> Volume polynome correction
   real(wp), intent(in) :: obc(3)
   !> Born radii
   real(wp), intent(out) :: brad(:)

   !> Derivative of Born radii w.r.t. cartesian coordinates
   real(wp), intent(out) :: brdr(:, :, :)

   integer :: iat
   real(wp) :: br, dpsi, svdwi, vdwri, s1, v1, s2, arg, arg2
   real(wp) :: th, ch, alpi, beti, gami

   call compute_psi(nat, xyz, list, vdwr, rho, brad, brdr)

   do iat = 1, nat

      br = brad(iat)

      svdwi = svdw(iat)
      vdwri = vdwr(iat)
      s1 = 1.0_wp/svdwi
      v1 = 1.0_wp/vdwri
      s2 = 0.5_wp*svdwi

      br = br*s2

      arg2 = br*(obc(3)*br-obc(3))
      arg = br*(obc(1)+arg2)
      arg2 = 2.0_wp*arg2+obc(1)+obc(3)*br*br

      th = tanh(arg)
      ch = cosh(arg)

      br = 1.0_wp/(s1-v1*th)
      ! Include GBMV2-like scaling
      br = c1*br

      dpsi = ch*(s1-v1*th)
      dpsi = s2*v1*arg2/(dpsi*dpsi)
      dpsi = c1*dpsi

      brad(iat) = br
      brdr(:, :, iat) = brdr(:, :, iat) * dpsi

   end do

end subroutine compute_bornr


pure subroutine compute_psi(nat, xyz, list, vdwr, rho, psi, dpsidr)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Neighbourlist
   type(adjacency_list), intent(in) :: list
   !> Van-der-Waals radii
   real(wp), intent(in) :: vdwr(:)
   !> Descreened van-der-Waals radii
   real(wp), intent(in) :: rho(:)
   !> Integrated value of Psi
   real(wp), intent(out) :: psi(:)
   !> Derivative of Psi w.r.t. cartesian coordinates
   real(wp), intent(out) :: dpsidr(:, :, :)
   real(wp), allocatable :: dpsitr(:, :)

   integer  :: iat, jat, img, inl
   real(wp) :: vec(3), r, rhoi, rhoj
   real(wp) :: gi, gj, ap, am, lnab, rhab, ab, dgi, dgj
   real(wp) :: drjj(3)
   real(wp) :: rh1, rhr1, r24, rh2, r1, aprh1, r12
   real(wp) :: rvdwi, rvdwj
   logical :: ijov, jiov

   allocate(dpsitr(3, nat))
   psi(:) = 0.0_wp
   dpsidr(:, :, :) = 0.0_wp
   dpsitr(:, :) = 0.0_wp

   do iat = 1, nat
      inl = list%inl(iat)
      do img = 1, list%nnl(iat)
         jat = list%nlat(inl+img)

         vec(:) = xyz(:, iat) - xyz(:, jat)
         r = norm2(vec)

         rhoi = rho(iat)
         rhoj = rho(jat)
         rvdwi = vdwr(iat)
         rvdwj = vdwr(jat)

         ijov = r < (rvdwi+rhoj)
         jiov = r < (rhoi+rvdwj)

         if (.not.(ijov .or. jiov)) then
            ! nonoverlaping spheres
            if(abs(rhoi-rhoj) < 1.e-8_wp) then
               ! equal reduced radii
               r1 = 1.0_wp/r
               ap = r+rhoj
               am = r-rhoj
               ab = ap*am
               rhab = rhoj/ab
               lnab = 0.5_wp*log(am/ap)*r1
               gi = rhab+lnab
               dgi = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
               ! accumulate psi
               psi(iat) = psi(iat)+gi
               psi(jat) = psi(jat)+gi
               ! accumulate psi gradient
               drjj(:) = dgi*vec(:)
               dpsitr(:, iat) = dpsitr(:, iat)+drjj(:)
               dpsidr(:, jat, iat) = dpsidr(:, jat, iat)-drjj(:)
               dpsitr(:, jat) = dpsitr(:, jat)-drjj(:)
               dpsidr(:, iat, jat) = dpsidr(:, iat, jat)+drjj(:)
            else
               ! unequal reduced radii
               ! ij contribution
               r1 = 1.0_wp/r
               ap = r+rhoj
               am = r-rhoj
               ab = ap*am
               rhab = rhoj/ab
               lnab = 0.5_wp*log(am/ap)*r1
               gi = rhab+lnab
               dgi = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
               ! ji contribution
               ap = r+rhoi
               am = r-rhoi
               ab = ap*am
               rhab = rhoi/ab
               lnab = 0.5_wp*log(am/ap)*r1
               gj = rhab+lnab
               dgj = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
               ! accumulate psi
               psi(iat) = psi(iat)+gi
               psi(jat) = psi(jat)+gj
               ! accumulate psi gradient
               drjj(:) = dgi*vec(:)
               dpsitr(:, iat) = dpsitr(:, iat)+drjj(:)
               dpsidr(:, jat, iat) = dpsidr(:, jat, iat)-drjj(:)

               drjj(:) = dgj*vec(:)
               dpsitr(:, jat) = dpsitr(:, jat)-drjj(:)
               dpsidr(:, iat, jat) = dpsidr(:, iat, jat)+drjj(:)
            end if

         else if (.not.ijov .and. jiov) then

            ! ij contribution
            r1 = 1.0_wp/r
            ap = r+rhoj
            am = r-rhoj
            ab = ap*am
            rhab = rhoj/ab
            lnab = 0.5_wp*log(am/ap)*r1
            gi = rhab+lnab
            dgi = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
            ! accumulate psi
            psi(iat) = psi(iat)+gi
            ! accumulate psi gradient
            drjj(:) = dgi*vec(:)
            dpsitr(:, iat) = dpsitr(:, iat)+drjj(:)
            dpsidr(:, jat, iat) = dpsidr(:, jat, iat)-drjj(:)

            if((r+rhoi) > rvdwj) then
               ! ji contribution
               r1 = 1.0_wp/r
               r12 = 0.5_wp*r1
               r24 = r12*r12

               ap = r+rhoi
               am = r-rhoi
               rh1 = 1.0_wp/rvdwj
               rhr1 = 1.0_wp/ap
               aprh1 = ap*rh1
               lnab = log(aprh1)

               gj = rh1-rhr1+r12*(0.5_wp*am*(rhr1-rh1*aprh1)-lnab)

               dgj = rhr1*rhr1*(1.0_wp-0.25_wp*am*r1*(1.0_wp+aprh1*aprh1))+ &
                  &         rhoi*r24*(rhr1-rh1*aprh1)+ &
                  &         r12*(r1*lnab-rhr1)
               dgj = dgj*r1
               ! accumulate psi
               psi(jat) = psi(jat)+gj
               ! accumulate psi gradient
               drjj(:) = dgj*vec(:)
               dpsitr(:, jat) = dpsitr(:, jat)-drjj(:)
               dpsidr(:, iat, jat) = dpsidr(:, iat, jat)+drjj(:)
            end if

         else if (ijov .and. .not.jiov) then

            if((r+rhoj) > rvdwi) then
               ! ij contribution
               r1 = 1.0_wp/r
               r12 = 0.5_wp*r1
               r24 = r12*r12

               ap = r+rhoj
               am = r-rhoj
               rh1 = 1.0_wp/rvdwi
               rhr1 = 1.0_wp/ap
               aprh1 = ap*rh1
               lnab = log(aprh1)

               gi = rh1-rhr1+r12*(0.5_wp*am*(rhr1-rh1*aprh1)-lnab)

               dgi = rhr1*rhr1*(1.0_wp-0.25_wp*am*r1*(1.0_wp+aprh1*aprh1))+ &
                  &         rhoj*r24*(rhr1-rh1*aprh1)+ &
                  &         r12*(r1*lnab-rhr1)
               dgi = dgi*r1
               ! accumulate psi
               psi(iat) = psi(iat)+gi
               ! accumulate psi gradient
               drjj(:) = dgi*vec(:)
               dpsitr(:, iat) = dpsitr(:, iat)+drjj(:)
               dpsidr(:, jat, iat) = dpsidr(:, jat, iat)-drjj(:)
            end if

            ! ji contribution
            ap = r+rhoi
            am = r-rhoi
            ab = ap*am
            rhab = rhoi/ab
            lnab = 0.5_wp*log(am/ap)*r1
            gj = rhab+lnab
            dgj = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
            ! accumulate psi
            psi(jat) = psi(jat)+gj
            ! accumulate psi gradient
            drjj(:) = dgj*vec(:)
            dpsitr(:, jat) = dpsitr(:, jat)-drjj(:)
            dpsidr(:, iat, jat) = dpsidr(:, iat, jat)+drjj(:)

         else if (ijov .and. jiov) then
            ! overlaping spheres
            if((r+rhoj) > rvdwi) then
               ! ij contribution
               r1 = 1.0_wp/r
               r12 = 0.5_wp*r1
               r24 = r12*r12

               ap = r+rhoj
               am = r-rhoj
               rh1 = 1.0_wp/rvdwi
               rhr1 = 1.0_wp/ap
               aprh1 = ap*rh1
               lnab = log(aprh1)

               gi = rh1-rhr1+r12*(0.5_wp*am*(rhr1-rh1*aprh1)-lnab)

               dgi = rhr1*rhr1*(1.0_wp-0.25_wp*am*r1*(1.0_wp+aprh1*aprh1))+ &
                  &         rhoj*r24*(rhr1-rh1*aprh1)+ &
                  &         r12*(r1*lnab-rhr1)
               dgi = dgi*r1
               ! accumulate psi
               psi(iat) = psi(iat)+gi
               ! accumulate psi gradient
               drjj(:) = dgi*vec(:)
               dpsitr(:, iat) = dpsitr(:, iat)+drjj(:)
               dpsidr(:, jat, iat) = dpsidr(:, jat, iat)-drjj(:)
            end if

            if((r+rhoi) > rvdwj) then
               ! ji contribution
               r1 = 1.0_wp/r
               r12 = 0.5_wp*r1
               r24 = r12*r12

               ap = r+rhoi
               am = r-rhoi
               rh1 = 1.0_wp/rvdwj
               rhr1 = 1.0_wp/ap
               aprh1 = ap*rh1
               lnab = log(aprh1)

               gj = rh1-rhr1+r12*(0.5_wp*am*(rhr1-rh1*aprh1)-lnab)

               dgj = rhr1*rhr1*(1.0_wp-0.25_wp*am*r1*(1.0_wp+aprh1*aprh1))+ &
                  &         rhoi*r24*(rhr1-rh1*aprh1)+ &
                  &         r12*(r1*lnab-rhr1)
               dgj = dgj*r1
               ! accumulate psi
               psi(jat) = psi(jat)+gj
               ! accumulate psi gradient
               drjj(:) = dgj*vec(:)
               dpsitr(:, jat) = dpsitr(:, jat)-drjj(:)
               dpsidr(:, iat, jat) = dpsidr(:, iat, jat)+drjj(:)
            end if

         end if

      end do
   end do

   ! save one-center terms
   do iat = 1, nat
      dpsidr(:, iat, iat) = dpsitr(:, iat)
   end do

end subroutine compute_psi

end module tblite_solvation_born

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_api_param
   use, intrinsic :: iso_c_binding
   use mctc_env, only : fatal_error
   use tblite_api_error, only : vp_error
   use tblite_api_table, only : vp_table
   use tblite_api_version, only : namespace
   use tblite_api_utils, only : f_c_character
   use tblite_param, only : param_record
   use tblite_toml, only : toml_table
   use tblite_xtb_gfn1, only : export_gfn1_param
   use tblite_xtb_gfn2, only : export_gfn2_param
   use tblite_xtb_ipea1, only : export_ipea1_param
   implicit none
   private

   public :: vp_param
   public :: new_param_api, delete_param_api
   public :: load_param_api, dump_param_api
   public :: export_gfn1_param_api, export_gfn2_param_api, export_ipea1_param_api

   !> Void pointer to manage parametrization records
   type :: vp_param
      !> Actual payload
      type(param_record) :: ptr
   end type vp_param

   logical, parameter :: debug = .false.

contains

!> Create new parametrization records object
function new_param_api() &
      & result(vparam) &
      & bind(C, name=namespace//"new_param")
   type(vp_param), pointer :: param
   type(c_ptr) :: vparam

   if (debug) print '("[Info]", 1x, a)', "new_param"

   allocate(param)
   vparam = c_loc(param)
end function new_param_api

!> Delete paramrization records object
subroutine delete_param_api(vparam) &
      & bind(C, name=namespace//"delete_param")
   type(c_ptr), intent(inout) :: vparam
   type(vp_param), pointer :: param

   if (debug) print '("[Info]", 1x, a)', "delete_param"

   if (c_associated(vparam)) then
      call c_f_pointer(vparam, param)

      deallocate(param)
      vparam = c_null_ptr
   end if

end subroutine delete_param_api

!> Load parametrization record from data table
subroutine load_param_api(verror, vparam, vtable) &
      & bind(C, name=namespace//"load_param")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table

   if (debug) print '("[Info]", 1x, a)', "load_param"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vparam)) then
      call fatal_error(error%ptr, "Parametrization record is missing")
      return
   end if
   call c_f_pointer(vparam, param)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if
   call c_f_pointer(vtable, table)

   call param%ptr%load(table%ptr, error%ptr)

end subroutine load_param_api

!> Dump parametrization record to data table
subroutine dump_param_api(verror, vparam, vtable) &
      & bind(C, name=namespace//"dump_param")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table

   if (debug) print '("[Info]", 1x, a)', "dump_param"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vparam)) then
      call fatal_error(error%ptr, "Parametrization record is missing")
      return
   end if
   call c_f_pointer(vparam, param)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if
   call c_f_pointer(vtable, table)

   call param%ptr%dump(table%ptr, error%ptr)

end subroutine dump_param_api


subroutine export_gfn1_param_api(verror, vparam) &
      & bind(C, name=namespace//"export_gfn1_param")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param

   if (debug) print '("[Info]", 1x, a)', "export_gfn1_param"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vparam)) then
      call fatal_error(error%ptr, "Parametrization record is missing")
      return
   end if
   call c_f_pointer(vparam, param)

   call export_gfn1_param(param%ptr)
end subroutine export_gfn1_param_api


subroutine export_gfn2_param_api(verror, vparam) &
      & bind(C, name=namespace//"export_gfn2_param")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param

   if (debug) print '("[Info]", 1x, a)', "export_gfn2_param"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vparam)) then
      call fatal_error(error%ptr, "Parametrization record is missing")
      return
   end if
   call c_f_pointer(vparam, param)

   call export_gfn2_param(param%ptr)
end subroutine export_gfn2_param_api


subroutine export_ipea1_param_api(verror, vparam) &
      & bind(C, name=namespace//"export_ipea1_param")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param

   if (debug) print '("[Info]", 1x, a)', "ipea1_param"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vparam)) then
      call fatal_error(error%ptr, "Parametrization record is missing")
      return
   end if
   call c_f_pointer(vparam, param)

   call export_ipea1_param(param%ptr)
end subroutine export_ipea1_param_api

end module tblite_api_param

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_output_ascii
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_convert, only : autoev
   use tblite_version, only : get_tblite_version
   implicit none
   private

   public :: ascii_levels, ascii_dipole_moments, ascii_quadrupole_moments
   public :: json_results, tagged_result

contains


subroutine ascii_levels(unit, verbosity, homo, emo, focc, range)
   integer, intent(in) :: unit
   integer, intent(in) :: verbosity
   integer, intent(in) :: homo(:)
   real(wp), intent(in) :: emo(:, :)
   real(wp), intent(in) :: focc(:, :)
   integer, intent(in) :: range

   character(len=*), parameter :: hlfmt = '(a21, f21.7, 1x, "Eh", f18.4, 1x, "eV")'
   integer :: nao, maxorb, minorb, iorb, spin
   real(wp) :: gap

   do spin = 1, size(emo, 2)
   nao = size(emo, 1)
   minorb = max(homo(spin) - (range+1), 1)
   maxorb = min(homo(spin) +  range, nao)
   gap = emo(min(homo(spin)+1, nao), spin) - emo(max(homo(spin), 1), spin)

   write(unit, '(66("-"))')
   write(unit, '(a7, a14, a21, a21)') "#", "Occupation", "Energy/Eh", "Energy/eV"
   write(unit, '(66("-"))')
   if (minorb > 1) then
      call write_line(1, focc(:, spin), emo(:, spin), homo(spin))
      if (minorb > 2) &
         write(unit, '(a7, a14, a21, a21)') "...", "...", "...", "..."
   endif
   do iorb = minorb, maxorb
      call write_line(iorb, focc(:, spin), emo(:, spin), homo(spin))
   enddo
   if (maxorb < nao) then
      if (maxorb < nao-1) then
         if (focc(maxorb, spin) > sqrt(epsilon(1.0_wp))) then
            write(unit, '(a7, a14, a21, a21)') "...", "...", "...", "..."
         else
            write(unit, '(a7, a14, a21, a21)') "...", "", "...", "..."
         endif
      endif
      call write_line(nao, focc(:, spin), emo(:, spin), homo(spin))
   endif
   write(unit, '(66("-"))')
   write(unit, hlfmt) "HL-Gap", gap, gap*autoev
   write(unit, '(66("-"))')
   write(unit, '(a)')
   end do

contains
   subroutine write_line(iorb, focc, emo, ihomo)
      integer, intent(in) :: iorb
      integer, intent(in) :: ihomo
      real(wp), intent(in) :: focc(:)
      real(wp), intent(in) :: emo (:)
      character(len=*), parameter :: mofmt = '(i7, f14.4, f21.7, f21.4)'
      character(len=*), parameter :: vofmt = '(i7, 14x,  f21.7, f21.4)'
      if (focc(iorb) < 1.0e-7_wp) then
         write(unit, vofmt, advance='no') iorb,             emo(iorb), emo(iorb)*autoev
      else
         write(unit, mofmt, advance='no') iorb, focc(iorb), emo(iorb), emo(iorb)*autoev
      endif
      if (iorb == ihomo) then
         write(unit, '(1x, "(HOMO)")')
      elseif (iorb == ihomo+1) then
         write(unit, '(1x, "(LUMO)")')
      else
         write(unit, '(a)')
      endif
   end subroutine write_line
end subroutine ascii_levels

subroutine ascii_dipole_moments(unit, verbosity, mol, dpat, dpmom)
   integer, intent(in) :: unit
   integer, intent(in) :: verbosity
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: dpat(:, :)
   real(wp), intent(in) :: dpmom(:)

   integer :: iat, isp

   write(unit, '(a,":")') "Atomic dipole moments (in atomic units)"
   write(unit, '(51("-"))')
   write(unit, '(a6, 1x, a4, 5x, *(1x, a10))') &
      & "#", "Z", "x", "y", "z"
   write(unit, '(51("-"))')
   do iat = 1, mol%nat
      isp = mol%id(iat)
      write(unit, '(i6, 1x, i4, 1x, a4, *(1x, f10.4))') &
         & iat, mol%num(isp), mol%sym(isp), dpat(:, iat)
   end do
   write(unit, '(51("-"))')
   write(unit, '(1x, a15, *(1x, f10.4))') "total", dpmom
   write(unit, '(51("-"))')
   write(unit, '(a)')
end subroutine ascii_dipole_moments

subroutine ascii_quadrupole_moments(unit, verbosity, mol, qpat, qpmom)
   integer, intent(in) :: unit
   integer, intent(in) :: verbosity
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: qpat(:, :)
   real(wp), intent(in) :: qpmom(:)

   integer :: iat, isp

   write(unit, '(a,":")') "Atomic quadrupole moments (in atomic units)"
   write(unit, '(83("-"))')
   write(unit, '(a6, 1x, a4, 5x, *(1x, a10))') &
      & "#", "Z", "xx", "xy", "yy", "xz", "yz", "zz"
   write(unit, '(83("-"))')
   do iat = 1, mol%nat
      isp = mol%id(iat)
      write(unit, '(i6, 1x, i4, 1x, a4, *(1x, f10.4))') &
         & iat, mol%num(isp), mol%sym(isp), qpat(:, iat)
   end do
   write(unit, '(83("-"))')
   write(unit, '(1x, a15, *(1x, f10.4))') "total", qpmom
   write(unit, '(83("-"))')
   write(unit, '(a)')
end subroutine ascii_quadrupole_moments


subroutine json_results(unit, indentation, energy, gradient, sigma, energies)
   integer, intent(in) :: unit
   character(len=*), intent(in), optional :: indentation
   real(wp), intent(in), optional :: energy
   real(wp), intent(in), optional :: gradient(:, :)
   real(wp), intent(in), optional :: sigma(:, :)
   real(wp), intent(in), optional :: energies(:)
   character(len=:), allocatable :: indent, version_string
   character(len=*), parameter :: jsonkey = "('""',a,'"":',1x)"
   real(wp), allocatable :: array(:)

   call get_tblite_version(string=version_string)

   if (present(indentation)) then
      indent = indentation
   end if

   write(unit, '("{")', advance='no')
   if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
   write(unit, jsonkey, advance='no') 'version'
   write(unit, '(1x,a)', advance='no') '"'//version_string//'"'
   if (present(energy)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'energy'
      write(unit, '(1x,es25.16)', advance='no') energy
   end if
   if (present(energies)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'energies'
      call write_json_array(unit, energies, indent)
   end if
   if (present(sigma)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'virial'
      array = reshape(sigma, [size(sigma)])
      call write_json_array(unit, array, indent)
   end if
   if (present(gradient)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'gradient'
      array = reshape(gradient, [size(gradient)])
      call write_json_array(unit, array, indent)
   end if
   if (allocated(indent)) write(unit, '(/)', advance='no')
   write(unit, '("}")')

end subroutine json_results


subroutine write_json_array(unit, array, indent)
   integer, intent(in) :: unit
   real(wp), intent(in) :: array(:)
   character(len=:), allocatable, intent(in) :: indent
   integer :: i
   write(unit, '("[")', advance='no')
   do i = 1, size(array)
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 2)
      write(unit, '(es23.16)', advance='no') array(i)
      if (i /= size(array)) write(unit, '(",")', advance='no')
   end do
   if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
   write(unit, '("]")', advance='no')
end subroutine write_json_array


subroutine tagged_result(unit, energy, gradient, sigma, energies)
   integer, intent(in) :: unit
   real(wp), intent(in), optional :: energy
   real(wp), intent(in), optional :: gradient(:, :)
   real(wp), intent(in), optional :: sigma(:, :)
   real(wp), intent(in), optional :: energies(:)
   character(len=*), parameter :: tag_header = &
      & '(a,t20,":",a,":",i0,":",*(i0:,","))'

   if (present(energy)) then
      write(unit, tag_header) "energy", "real", 0
      write(unit, '(3es24.16)') energy
   end if
   if (present(energies)) then
      write(unit, tag_header) "energies", "real", 1, shape(energies)
      write(unit, '(3es24.16)') energies
   end if
   if (present(gradient)) then
      write(unit, tag_header) "gradient", "real", 2, shape(gradient)
      write(unit, '(3es24.16)') gradient
   end if
   if (present(sigma)) then
      write(unit, tag_header) "virial", "real", 2, shape(sigma)
      write(unit, '(3es24.16)') sigma
   end if

end subroutine tagged_result


end module tblite_output_ascii

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_wavefunction_fermi
   use mctc_env, only : wp
   implicit none
   private

   public :: get_fermi_filling


contains

subroutine get_fermi_filling(nel, kt, emo, homo, focc, e_fermi, ts)
   real(wp), intent(in) :: nel
   real(wp), intent(in) :: emo(:)
   real(wp), intent(in) :: kt
   integer, intent(out) :: homo
   real(wp), intent(out) :: focc(:)
   real(wp), intent(out) :: e_fermi
   real(wp), intent(out) :: ts

   real(wp) :: etmp, stmp

   ts = 0.0_wp
   e_fermi = 0.0_wp

   call get_aufbau_filling(nel, homo, focc)

   if (homo > 0) then
      call get_fermi_filling_(homo, kt, emo, focc, etmp)
      call get_electronic_entropy(focc, kt, ts)
      e_fermi = 0.5_wp * etmp
   end if

end subroutine get_fermi_filling

subroutine get_aufbau_filling(nel, homo, occ)
   real(wp), intent(in) :: nel
   integer, intent(out) :: homo
   real(wp), intent(out) :: occ(:)

   occ(:) = 0.0_wp
   homo = floor(nel)
   occ(:min(homo, size(occ))) = 1.0_wp
   if (homo < size(occ)) occ(homo+1) = mod(nel, 1.0_wp)
   homo = merge(homo+1, homo, mod(nel, 1.0_wp) > 0.5_wp)
end subroutine get_aufbau_filling

subroutine get_fermi_filling_(homo, kt, emo, occ, e_fermi)
   integer, intent(in) :: homo
   real(wp), intent(in) :: emo(:)
   real(wp), intent(in) :: kt
   real(wp), intent(out) :: occ(:)
   real(wp), intent(out) :: e_fermi

   real(wp) :: occt, total_number
   real(wp) :: total_dfermi, dfermifunct, fermifunct, change_fermi
   integer, parameter :: max_cycle = 200
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   integer :: ncycle, iao

   e_fermi = 0.5*(emo(max(homo, 1))+emo(min(homo+1, size(emo))))
   occt = homo

   do ncycle = 1, max_cycle
      total_number = 0.0
      total_dfermi = 0.0
      do iao = 1, size(emo)
         fermifunct = 0.0
         if((emo(iao)-e_fermi)/kt.lt.50) then
            fermifunct = 1.0/(exp((emo(iao)-e_fermi)/kt)+1.0)
            dfermifunct = exp((emo(iao)-e_fermi)/kt) / &
               & (kt*(exp((emo(iao)-e_fermi)/kt)+1.0)**2)
         else
            dfermifunct = 0.0
         end if
         occ(iao) = fermifunct
         total_number = total_number + fermifunct
         total_dfermi = total_dfermi + dfermifunct
      end do
      change_fermi = (occt-total_number)/total_dfermi
      e_fermi = e_fermi+change_fermi
      if (abs(occt-total_number) <= thr) exit
   end do

end subroutine get_fermi_filling_

subroutine get_electronic_entropy(occ, kt, s)
   real(wp), intent(in) :: occ(:)
   real(wp), intent(in) :: kt
   real(wp), intent(out) :: s

   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   integer :: iao

   s = 0.0_wp
   do iao = 1, size(occ)
      if (occ(iao) > thr .and. 1.0_wp - occ(iao) > thr) then
         s = s + occ(iao)*log(occ(iao)) + (1.0_wp - occ(iao))*log(1.0_wp - occ(iao))
      end if
   enddo
   s=s*kt

end subroutine get_electronic_entropy



end module tblite_wavefunction_fermi

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_repulsion
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type
   use mstore, only : get_structure
   use tblite_container_cache, only : container_cache
   use tblite_repulsion, only : tb_repulsion, new_repulsion
   implicit none
   private

   public :: collect_repulsion

   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

   abstract interface
      subroutine repulsion_maker(rep, mol)
         import :: tb_repulsion, structure_type
         type(tb_repulsion), intent(out) :: rep
         type(structure_type), intent(in) :: mol
      end subroutine repulsion_maker
   end interface

contains


!> Collect all exported unit tests
subroutine collect_repulsion(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("energy-1", test_e_effective_m01), &
      new_unittest("energy-2", test_e_effective_m02), &
      new_unittest("energy-pbc", test_e_effective_uracil), &
      new_unittest("gradient-1", test_g_effective_m03), &
      new_unittest("gradient-2", test_g_effective_m04), &
      new_unittest("gradient-pbc", test_g_effective_urea), &
      new_unittest("sigma-1", test_s_effective_m05), &
      new_unittest("sigma-2", test_s_effective_m06), &
      new_unittest("sigma-pbc", test_s_effective_succinic) &
      ]

end subroutine collect_repulsion


!> Factory to create repulsion objects based on GFN1-xTB
subroutine make_repulsion1(rep, mol)
   type(tb_repulsion), intent(out) :: rep
   type(structure_type), intent(in) :: mol

   real(wp), parameter :: alpha_gfn1(1:20) = [&
      & 2.209700_wp, 1.382907_wp, 0.671797_wp, 0.865377_wp, 1.093544_wp, &
      & 1.281954_wp, 1.727773_wp, 2.004253_wp, 2.507078_wp, 3.038727_wp, &
      & 0.704472_wp, 0.862629_wp, 0.929219_wp, 0.948165_wp, 1.067197_wp, &
      & 1.200803_wp, 1.404155_wp, 1.323756_wp, 0.581529_wp, 0.665588_wp]
   real(wp), parameter :: zeff_gfn1(1:20) = [&
      &  1.116244_wp,  0.440231_wp,  2.747587_wp,  4.076830_wp,  4.458376_wp, &
      &  4.428763_wp,  5.498808_wp,  5.171786_wp,  6.931741_wp,  9.102523_wp, &
      & 10.591259_wp, 15.238107_wp, 16.283595_wp, 16.898359_wp, 15.249559_wp, &
      & 15.100323_wp, 17.000000_wp, 17.153132_wp, 20.831436_wp, 19.840212_wp]
   real(wp), allocatable :: alpha(:), zeff(:), kexp

   alpha = alpha_gfn1(mol%num)
   zeff = zeff_gfn1(mol%num)
   kexp = 1.5_wp
   call new_repulsion(rep, mol, alpha, zeff, 1.5_wp, kexp, 1.0_wp)

end subroutine make_repulsion1

!> Factory to create repulsion objects based on GFN2-xTB
subroutine make_repulsion2(rep, mol)
   type(tb_repulsion), intent(out) :: rep
   type(structure_type), intent(in) :: mol

   real(wp), parameter :: alpha_gfn2(1:20) = [&
      & 2.213717_wp, 3.604670_wp, 0.475307_wp, 0.939696_wp, 1.373856_wp, &
      & 1.247655_wp, 1.682689_wp, 2.165712_wp, 2.421394_wp, 3.318479_wp, &
      & 0.572728_wp, 0.917975_wp, 0.876623_wp, 1.187323_wp, 1.143343_wp, &
      & 1.214553_wp, 1.577144_wp, 0.896198_wp, 0.482206_wp, 0.683051_wp]
   real(wp), parameter :: zeff_gfn2(1:20) = [&
      &  1.105388_wp,  1.094283_wp,  1.289367_wp,  4.221216_wp,  7.192431_wp, &
      &  4.231078_wp,  5.242592_wp,  5.784415_wp,  7.021486_wp, 11.041068_wp, &
      &  5.244917_wp, 18.083164_wp, 17.867328_wp, 40.001111_wp, 19.683502_wp, &
      & 14.995090_wp, 17.353134_wp,  7.266606_wp, 10.439482_wp, 14.786701_wp]
   real(wp), allocatable :: alpha(:), zeff(:), kexp

   alpha = alpha_gfn2(mol%num)
   zeff = zeff_gfn2(mol%num)
   kexp = 1.0_wp
   call new_repulsion(rep, mol, alpha, zeff, 1.5_wp, kexp, 1.0_wp)

end subroutine make_repulsion2


subroutine test_generic(error, mol, make_repulsion, ref)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Factory to produce repulsion objects
   procedure(repulsion_maker) :: make_repulsion

   !> Reference value to compare against
   real(wp), intent(in) :: ref

   type(tb_repulsion) :: rep
   type(container_cache) :: cache
   real(wp) :: energy(mol%nat), sigma(3, 3)
   real(wp), allocatable :: gradient(:, :), numgrad(:, :), lattr(:, :)
   real(wp), parameter :: step = 1.0e-6_wp

   allocate(gradient(3, mol%nat), numgrad(3, mol%nat))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   call make_repulsion(rep, mol)
   call rep%get_engrad(mol, cache, energy)

   call check(error, sum(energy), ref, thr=thr)
   if (allocated(error)) then
      print*,sum(energy)
   end if

end subroutine test_generic


subroutine test_numgrad(error, mol, make_repulsion)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Factory to create a repulsion object
   procedure(repulsion_maker) :: make_repulsion

   integer :: iat, ic
   type(tb_repulsion) :: rep
   type(container_cache) :: cache
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat), sigma(3, 3)
   real(wp), allocatable :: gradient(:, :), numgrad(:, :)
   real(wp), parameter :: step = 1.0e-6_wp

   allocate(gradient(3, mol%nat), numgrad(3, mol%nat))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   call make_repulsion(rep, mol)

   do iat = 1, mol%nat
      do ic = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call rep%get_engrad(mol, cache, er)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2*step
         call rep%get_engrad(mol, cache, el)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         numgrad(ic, iat) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   call rep%get_engrad(mol, cache, energy, gradient, sigma)

   if (any(abs(gradient - numgrad) > thr2)) then
      call test_failed(error, "Gradient of dispersion energy does not match")
      print'(3es21.14)', gradient-numgrad
   end if

end subroutine test_numgrad


subroutine test_numsigma(error, mol, make_repulsion)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Factory to create a repulsion object
   procedure(repulsion_maker) :: make_repulsion

   integer :: ic, jc
   type(tb_repulsion) :: rep
   type(container_cache) :: cache
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat), sigma(3, 3), eps(3, 3), numsigma(3, 3)
   real(wp), allocatable :: gradient(:, :), xyz(:, :), lat(:, :)
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], shape(unity))
   real(wp), parameter :: step = 1.0e-6_wp

   allocate(gradient(3, mol%nat), xyz(3, mol%nat), lat(3, 3))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   call make_repulsion(rep, mol)

   eps(:, :) = unity
   xyz(:, :) = mol%xyz
   if (any(mol%periodic)) &
   lat(:, :) = mol%lattice
   do ic = 1, 3
      do jc = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = matmul(eps, xyz)
         if (any(mol%periodic)) &
         mol%lattice(:, :) = matmul(eps, lat)
         call rep%get_engrad(mol, cache, er)
         eps(jc, ic) = eps(jc, ic) - 2*step
         mol%xyz(:, :) = matmul(eps, xyz)
         if (any(mol%periodic)) &
         mol%lattice(:, :) = matmul(eps, lat)
         call rep%get_engrad(mol, cache, el)
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = xyz
         if (any(mol%periodic)) &
         mol%lattice(:, :) = lat
         numsigma(jc, ic) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   call rep%get_engrad(mol, cache, energy, gradient, sigma)

   if (any(abs(sigma - numsigma) > thr2)) then
      call test_failed(error, "Strain derivatives do not match")
      print'(3es21.14)', sigma-numsigma
   end if

end subroutine test_numsigma


subroutine test_e_effective_m01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "01")
   call test_generic(error, mol, make_repulsion1, 0.16777923624986593_wp)

end subroutine test_e_effective_m01


subroutine test_e_effective_m02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "02")
   call test_generic(error, mol, make_repulsion2, 0.10745931926703985_wp)

end subroutine test_e_effective_m02


subroutine test_e_effective_uracil(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "X23", "uracil")
   call test_generic(error, mol, make_repulsion2, 1.0401472262740301_wp)

end subroutine test_e_effective_uracil


subroutine test_g_effective_m03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "03")
   call test_numgrad(error, mol, make_repulsion1)

end subroutine test_g_effective_m03


subroutine test_g_effective_m04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "04")
   call test_numgrad(error, mol, make_repulsion2)

end subroutine test_g_effective_m04


subroutine test_g_effective_urea(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "X23", "urea")
   call test_numgrad(error, mol, make_repulsion2)

end subroutine test_g_effective_urea


subroutine test_s_effective_m05(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "05")
   call test_numsigma(error, mol, make_repulsion1)

end subroutine test_s_effective_m05


subroutine test_s_effective_m06(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "06")
   call test_numsigma(error, mol, make_repulsion2)

end subroutine test_s_effective_m06


subroutine test_s_effective_succinic(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "X23", "succinic")
   call test_numsigma(error, mol, make_repulsion2)

end subroutine test_s_effective_succinic


end module test_repulsion

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Proxy module for TOML library implementation
module tblite_toml
   use tomlf, only : toml_table, toml_array, toml_error, toml_serializer, toml_parse, &
      & toml_key, get_value, set_value, add_table, add_array, len
   use tomlf_build, only : merge_table
   use tomlf_type, only : toml_value
   implicit none
   private

   public :: toml_table, toml_array, toml_error, toml_serializer, toml_parse, toml_key, &
      & toml_value, len
   public :: get_value, set_value, add_table, add_array, merge_table



contains

end module tblite_toml

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_api_result
   use, intrinsic :: iso_c_binding
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_api_error, only : vp_error
   use tblite_api_version, only : namespace
   use tblite_results, only : results_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: vp_result, new_result_api, copy_result_api, delete_result_api
   public :: get_result_number_of_atoms_api, get_result_number_of_shells_api, &
      & get_result_number_of_orbitals_api, get_result_energy_api, get_result_gradient_api, &
      & get_result_virial_api, get_result_charges_api, get_result_dipole_api, &
      & get_result_quadrupole_api, get_result_orbital_energies_api, &
      & get_result_orbital_occupations_api, get_result_orbital_coefficients_api, &
      & get_result_energies_api, get_result_density_matrix_api, &
      & get_result_overlap_matrix_api, get_result_hamiltonian_matrix_api


   !> Void pointer holding results of a calculation
   type :: vp_result
      !> Single point energy
      real(wp), allocatable :: energy
      !> Molecular gradient
      real(wp), allocatable :: gradient(:, :)
      !> Virial
      real(wp), allocatable :: sigma(:, :)
      !> Dipole moment
      real(wp), allocatable :: dipole(:)
      !> Quadrupole moment
      real(wp), allocatable :: quadrupole(:)
      !> Wavefunction
      type(wavefunction_type), allocatable :: wfn
      !> Additional results
      type(results_type), allocatable :: results
   end type vp_result


   logical, parameter :: debug = .false.


contains


!> Create new result container
function new_result_api() result(vres) &
      & bind(C, name=namespace//"new_result")
   type(vp_result), pointer :: res
   type(c_ptr) :: vres

   if (debug) print '("[Info]", 1x, a)', "new_result"

   allocate(res)
   vres = c_loc(res)

end function new_result_api


!> Create copy result container
function copy_result_api(vold) result(vnew) &
      & bind(C, name=namespace//"copy_result")
   type(vp_result), pointer :: new
   type(c_ptr), value :: vold
   type(vp_result), pointer :: old
   type(c_ptr) :: vnew

   if (debug) print '("[Info]", 1x, a)', "copy_result"

   vnew = c_null_ptr
   if (c_associated(vold)) then
      call c_f_pointer(vold, old)
      allocate(new, source=old)
      vnew = c_loc(new)
   end if

end function copy_result_api


!> Delete result container
subroutine delete_result_api(vres) &
      & bind(C, name=namespace//"delete_result")
   type(c_ptr), intent(inout) :: vres
   type(vp_result), pointer :: res

   if (debug) print '("[Info]", 1x, a)', "delete_result"

   if (c_associated(vres)) then
      call c_f_pointer(vres, res)

      deallocate(res)
      vres = c_null_ptr
   end if
end subroutine delete_result_api


subroutine get_result_number_of_atoms_api(verror, vres, natoms) &
      & bind(C, name=namespace//"get_result_number_of_atoms")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   integer(c_int), intent(out) :: natoms
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_number_of_atoms"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain number of atoms")
      return
   end if

   natoms = size(res%wfn%qat)
end subroutine get_result_number_of_atoms_api


subroutine get_result_number_of_shells_api(verror, vres, nshells) &
      & bind(C, name=namespace//"get_result_number_of_shells")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   integer(c_int), intent(out) :: nshells
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_number_of_shells"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain number of shells")
      return
   end if

   nshells = size(res%wfn%qsh)
end subroutine get_result_number_of_shells_api


subroutine get_result_number_of_orbitals_api(verror, vres, norb) &
      & bind(C, name=namespace//"get_result_number_of_orbitals")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   integer(c_int), intent(out) :: norb
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_number_of_orbitals"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain number of orbitals")
      return
   end if

   norb = size(res%wfn%emo)
end subroutine get_result_number_of_orbitals_api


subroutine get_result_energy_api(verror, vres, energy) &
      & bind(C, name=namespace//"get_result_energy")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: energy
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_energy"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%energy)) then
      call fatal_error(error%ptr, "Result does not contain energy")
      return
   end if

   energy = res%energy
end subroutine get_result_energy_api


subroutine get_result_energies_api(verror, vres, energies) &
      & bind(C, name=namespace//"get_result_energies")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: energies(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_energies"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%results)) then
      call fatal_error(error%ptr, "Result does not contain energies")
      return
   end if

   if (.not.allocated(res%results%energies)) then
      call fatal_error(error%ptr, "Result does not contain energies")
      return
   end if

   energies(:size(res%results%energies)) = res%results%energies
end subroutine get_result_energies_api


subroutine get_result_gradient_api(verror, vres, gradient) &
      & bind(C, name=namespace//"get_result_gradient")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: gradient(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_gradient"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%gradient)) then
      call fatal_error(error%ptr, "Result does not contain gradient")
      return
   end if

   gradient(:size(res%gradient)) = reshape(res%gradient, [size(res%gradient)])
end subroutine get_result_gradient_api


subroutine get_result_virial_api(verror, vres, sigma) &
      & bind(C, name=namespace//"get_result_virial")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: sigma(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_virial"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%sigma)) then
      call fatal_error(error%ptr, "Result does not contain virial")
      return
   end if

   sigma(:size(res%sigma)) = reshape(res%sigma, [size(res%sigma)])
end subroutine get_result_virial_api


subroutine get_result_charges_api(verror, vres, charges) &
      & bind(C, name=namespace//"get_result_charges")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: charges(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_charges"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain atomic charges")
      return
   end if

   charges(:size(res%wfn%qat)) = res%wfn%qat(:, 1)
end subroutine get_result_charges_api


subroutine get_result_dipole_api(verror, vres, dipole) &
      & bind(C, name=namespace//"get_result_dipole")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: dipole(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_dipole"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%dipole)) then
      call fatal_error(error%ptr, "Result does not contain dipole moment")
      return
   end if

   dipole(:size(res%dipole)) = res%dipole
end subroutine get_result_dipole_api


subroutine get_result_quadrupole_api(verror, vres, quadrupole) &
      & bind(C, name=namespace//"get_result_quadrupole")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: quadrupole(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_quadrupole"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%quadrupole)) then
      call fatal_error(error%ptr, "Result does not contain quadrupole moment")
      return
   end if

   quadrupole(:size(res%quadrupole)) = res%quadrupole
end subroutine get_result_quadrupole_api


subroutine get_result_orbital_energies_api(verror, vres, emo) &
      & bind(C, name=namespace//"get_result_orbital_energies")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: emo(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_orbital_energies"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain orbital energies")
      return
   end if

   emo(:size(res%wfn%emo)) = res%wfn%emo(:, 1)
end subroutine get_result_orbital_energies_api


subroutine get_result_orbital_occupations_api(verror, vres, occ) &
      & bind(C, name=namespace//"get_result_orbital_occupations")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: occ(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_orbital_occupations"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain orbital occupations")
      return
   end if

   occ(:size(res%wfn%focc)) = res%wfn%focc(:, 1)
end subroutine get_result_orbital_occupations_api


subroutine get_result_orbital_coefficients_api(verror, vres, cmo) &
      & bind(C, name=namespace//"get_result_orbital_coefficients")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: cmo(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_orbital_coefficients"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain orbital coefficients")
      return
   end if

   cmo(:size(res%wfn%coeff)) = reshape(res%wfn%coeff(:, :, 1), [size(res%wfn%coeff)])
end subroutine get_result_orbital_coefficients_api


subroutine get_result_density_matrix_api(verror, vres, pmat) &
      & bind(C, name=namespace//"get_result_density_matrix")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: pmat(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_density_matrix"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain density matrix")
      return
   end if

   pmat(:size(res%wfn%density)) = reshape(res%wfn%density(:, :, 1), [size(res%wfn%density)])
end subroutine get_result_density_matrix_api


subroutine get_result_overlap_matrix_api(verror, vres, smat) &
      & bind(C, name=namespace//"get_result_overlap_matrix")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: smat(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_overlap_matrix"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%results)) then
      call fatal_error(error%ptr, "Result does not contain overlap matrix")
      return
   end if

   if (.not.allocated(res%results%overlap)) then
      call fatal_error(error%ptr, "Result does not contain overlap matrix")
      return
   end if

   smat(:size(res%results%overlap)) = &
      & reshape(res%results%overlap, [size(res%results%overlap)])
end subroutine get_result_overlap_matrix_api


subroutine get_result_hamiltonian_matrix_api(verror, vres, hmat) &
      & bind(C, name=namespace//"get_result_hamiltonian_matrix")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: hmat(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_hamiltonian_matrix"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%results)) then
      call fatal_error(error%ptr, "Result does not contain Hamiltonian matrix")
      return
   end if

   if (.not.allocated(res%results%hamiltonian)) then
      call fatal_error(error%ptr, "Result does not contain Hamiltonian matrix")
      return
   end if

   hmat(:size(res%results%hamiltonian)) = &
      & reshape(res%results%hamiltonian, [size(res%results%hamiltonian)])
end subroutine get_result_hamiltonian_matrix_api


subroutine get_result(verror, vres, error, res, ok)
   type(c_ptr), intent(in) :: verror
   type(c_ptr), intent(in) :: vres
   type(vp_error), pointer, intent(out) :: error
   type(vp_result), pointer, intent(out) :: res
   logical, intent(out) :: ok

   ok = .false.
   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vres)) then
      call fatal_error(error%ptr, "Result container is missing")
      return
   end if
   call c_f_pointer(vres, res)
   ok = .true.
end subroutine get_result


end module tblite_api_result

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Gaussian type basis set data
module tblite_basis_type
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   implicit none
   private

   public :: cgto_type
   public :: basis_type, new_basis, get_cutoff

   !> Maximum contraction length of basis functions.
   !> The limit is chosen as twice the maximum size returned by the STO-NG expansion
   integer, parameter :: maxg = 12

   !> Contracted Gaussian type basis function
   type :: cgto_type
      !> Angular momentum of this basis function
      integer :: ang = -1
      !> Contraction length of this basis function
      integer :: nprim = 0
      !> Exponent of the primitive Gaussian functions
      real(wp) :: alpha(maxg) = 0.0_wp
      !> Contraction coefficients of the primitive Gaussian functions,
      !> might contain normalization
      real(wp) :: coeff(maxg) = 0.0_wp
   end type cgto_type

   !> Collection of information regarding the basis set of a system
   type :: basis_type
      !> Maximum angular momentum of all basis functions,
      !> used to determine scratch size in integral calculation
      integer :: maxl = 0
      !> Number of shells in this basis set
      integer :: nsh = 0
      !> Number of spherical atomic orbitals in this basis set
      integer :: nao = 0
      !> Integral cutoff as maximum exponent of Gaussian product theoreom to consider
      real(wp) :: intcut = 0.0_wp
      !> Smallest primitive exponent in the basis set
      real(wp) :: min_alpha = huge(0.0_wp)
      !> Number of shells for each species
      integer, allocatable :: nsh_id(:)
      !> Number of shells for each atom
      integer, allocatable :: nsh_at(:)
      !> Number of spherical atomic orbitals for each shell
      integer, allocatable :: nao_sh(:)
      !> Index offset for each shell in the atomic orbital space
      integer, allocatable :: iao_sh(:)
      !> Index offset for each atom in the shell space
      integer, allocatable :: ish_at(:)
      !> Mapping from spherical atomic orbitals to the respective atom
      integer, allocatable :: ao2at(:)
      !> Mapping from spherical atomic orbitals to the respective shell
      integer, allocatable :: ao2sh(:)
      !> Mapping from shells to the respective atom
      integer, allocatable :: sh2at(:)
      !> Contracted Gaussian basis functions forming the basis set
      type(cgto_type), allocatable :: cgto(:, :)
   end type basis_type

   !> Get optimal real space cutoff for integral evaluation
   interface get_cutoff
      module procedure :: get_cutoff
   end interface get_cutoff

contains

!> Create a new basis set
subroutine new_basis(self, mol, nshell, cgto, acc)
   !> Instance of the basis set data
   type(basis_type), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells per species
   integer, intent(in) :: nshell(:)
   !> Contracted Gaussian basis functions for each shell and species
   type(cgto_type), intent(in) :: cgto(:, :)
   !> Calculation accuracy
   real(wp), intent(in) :: acc

   integer :: iat, isp, ish, iao, ii
   real(wp) :: min_alpha

   self%nsh_id = nshell
   self%cgto = cgto
   self%intcut = integral_cutoff(acc)

   ! Make count of shells for each atom
   self%nsh_at = nshell(mol%id)

   ! Create mapping between atoms and shells
   self%nsh = sum(self%nsh_at)
   allocate(self%ish_at(mol%nat), self%sh2at(self%nsh))
   ii = 0
   do iat = 1, mol%nat
      self%ish_at(iat) = ii
      do ish = 1, self%nsh_at(iat)
         self%sh2at(ii+ish) = iat
      end do
      ii = ii + self%nsh_at(iat)
   end do

   ! Make count of spherical orbitals for each shell
   allocate(self%nao_sh(self%nsh))
   do iat = 1, mol%nat
      isp = mol%id(iat)
      ii = self%ish_at(iat)
      do ish = 1, self%nsh_at(iat)
         self%nao_sh(ii+ish) = 2*cgto(ish, isp)%ang + 1
      end do
   end do

   ! Create mapping between shells and spherical orbitals, also map directly back to atoms
   self%nao = sum(self%nao_sh)
   allocate(self%iao_sh(self%nsh), self%ao2sh(self%nao), self%ao2at(self%nao))
   ii = 0
   do ish = 1, self%nsh
      self%iao_sh(ish) = ii
      do iao = 1, self%nao_sh(ish)
         self%ao2sh(ii+iao) = ish
         self%ao2at(ii+iao) = self%sh2at(ish)
      end do
      ii = ii + self%nao_sh(ish)
   end do

   ii = 0
   do iat = 1, mol%nat
      isp = mol%id(iat)
      do ish = 1, nshell(isp)
         self%iao_sh(ish+self%ish_at(iat)) = ii
         ii = ii + 2*cgto(ish, isp)%ang + 1
      end do
   end do

   min_alpha = huge(acc)
   do isp = 1, size(nshell)
      do ish = 1, nshell(isp)
         self%maxl = max(self%maxl, cgto(ish, isp)%ang)
         min_alpha = min(min_alpha, minval(cgto(ish, isp)%alpha(:cgto(ish, isp)%nprim)))
      end do
   end do

   self%min_alpha = min_alpha

end subroutine new_basis

!> Determine required real space cutoff for the basis set
pure function get_cutoff(self, acc) result(cutoff)
   !> Instance of the basis set data
   type(basis_type), intent(in) :: self
   !> Accuracy for the integral cutoff
   real(wp), intent(in), optional :: acc
   !> Required realspace cutoff
   real(wp) :: cutoff

   real(wp) :: intcut
   real(wp), parameter :: max_cutoff = 40.0_wp

   if (present(acc)) then
      intcut = integral_cutoff(acc)
   else
      intcut = self%intcut
   end if
   ! ai * aj * cutoff2 / (ai + aj) == intcut
   cutoff = min(sqrt(2.0_wp*intcut/self%min_alpha), max_cutoff)

end function get_cutoff


!> Create integral cutoff from accuracy value
pure function integral_cutoff(acc) result(intcut)
   !> Accuracy for the integral cutoff
   real(wp), intent(in) :: acc
   !> Integral cutoff
   real(wp) :: intcut

   real(wp), parameter :: min_intcut = 5.0_wp, max_intcut = 25.0_wp, &
      & max_acc = 1.0e-4_wp, min_acc = 1.0e+3_wp

   intcut = clip(max_intcut - 10*log10(clip(acc, min_acc, max_acc)), min_intcut, max_intcut)
end function integral_cutoff


pure function clip(val, min_val, max_val) result(res)
   real(wp), intent(in) :: val, min_val, max_val
   real(wp) :: res
   res = min(max(val, min_val), max_val)
end function clip

end module tblite_basis_type

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> API export for environment context setup
module tblite_api_context
   use, intrinsic :: iso_c_binding
   use mctc_env, only : error_type, fatal_error
   use tblite_context, only : context_type, context_logger, context_terminal
   use tblite_api_error, only : vp_error
   use tblite_api_version, only : namespace
   use tblite_api_utils, only : f_c_character
   implicit none
   private

   public :: vp_context
   public :: new_context_api, check_context_api, get_context_error_api, delete_context_api
   public :: set_context_logger_api


   !> Void pointer to manage calculation context
   type :: vp_context
      !> Actual payload
      type(context_type) :: ptr
   end type vp_context


   abstract interface
      !> Interface for callbacks used in custom logger
      subroutine callback(msg, len, udata)
         import :: c_char, c_int, c_ptr
         !> Message payload to be displayed
         character(len=1, kind=c_char), intent(in) :: msg(*)
         !> Length of the message
         integer(c_int), value :: len
         !> Data pointer for callback
         type(c_ptr), value :: udata
      end subroutine callback
   end interface


   !> Custom logger for calculation context to display messages
   type, extends(context_logger) :: callback_logger
      !> Data pointer for callback
      type(c_ptr) :: udata = c_null_ptr
      !> Custom callback function to display messages
      procedure(callback), pointer, nopass :: callback => null()
   contains
      !> Entry point for context instance to log message
      procedure :: message
   end type callback_logger


   logical, parameter :: debug = .false.


contains


!> Create new calculation context object
function new_context_api() &
      & result(vctx) &
      & bind(C, name=namespace//"new_context")
   type(vp_context), pointer :: ctx
   type(c_ptr) :: vctx

   if (debug) print '("[Info]", 1x, a)', "new_context"

   allocate(ctx)
   vctx = c_loc(ctx)

end function new_context_api


!> Create new calculation context object
function check_context_api(vctx) result(status) &
      & bind(C, name=namespace//"check_context")
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vctx
   integer(c_int) :: status

   if (debug) print '("[Info]", 1x, a)', "check_context"

   if (c_associated(vctx)) then
      call c_f_pointer(vctx, ctx)

      status = merge(1, 0, ctx%ptr%failed())
   else
      status = 2
   end if

end function check_context_api


!> Get error message from calculation environment
subroutine get_context_error_api(vctx, charptr, buffersize) &
      & bind(C, name=namespace//"get_context_error")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   character(kind=c_char), intent(inout) :: charptr(*)
   integer(c_int), intent(in), optional :: buffersize
   integer :: max_length
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_context_error"

   if (c_associated(vctx)) then
      call c_f_pointer(vctx, ctx)

      if (present(buffersize)) then
         max_length = buffersize
      else
         max_length = huge(max_length) - 2
      end if

      call ctx%ptr%get_error(error)
      if (allocated(error)) then
         call f_c_character(error%message, charptr, max_length)
      end if
   end if

end subroutine get_context_error_api


subroutine set_context_color_api(vctx, color) &
      & bind(C, name=namespace//"set_context_color")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   integer(c_int), value :: color

   if (debug) print '("[Info]", 1x, a)', "set_context_color"

   if (c_associated(vctx)) then
      call c_f_pointer(vctx, ctx)

      ctx%ptr%terminal = context_terminal(color /= 0)
   end if
end subroutine set_context_color_api


!> Delete context object
subroutine delete_context_api(vctx) &
      & bind(C, name=namespace//"delete_context")
   type(c_ptr), intent(inout) :: vctx
   type(vp_context), pointer :: ctx

   if (debug) print '("[Info]", 1x, a)', "delete_context"

   if (c_associated(vctx)) then
      call c_f_pointer(vctx, ctx)

      deallocate(ctx)
      vctx = c_null_ptr
   end if

end subroutine delete_context_api


!> Create a new custom logger for the calculation context
subroutine set_context_logger_api(vctx, vproc, vdata) &
      & bind(C, name=namespace//"set_context_logger")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_funptr), value :: vproc
   procedure(callback), pointer :: fptr
   type(c_ptr), value :: vdata

   if (debug) print '("[Info]", 1x, a)', "set_context_logger"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (c_associated(vproc)) then
      call c_f_procpointer(vproc, fptr)
      ctx%ptr%io = new_callback_logger(fptr, vdata)
   else
      if (allocated(ctx%ptr%io)) deallocate(ctx%ptr%io)
   end if

end subroutine set_context_logger_api


!> Create a new custom logger
function new_callback_logger(fptr, udata) result(self)
   !> Actual function used to display messages
   procedure(callback) :: fptr
   !> Data pointer used inside the callback function
   type(c_ptr), intent(in) :: udata
   !> New instance of the custom logger
   type(callback_logger) :: self

   self%callback => fptr
   self%udata = udata
end function new_callback_logger


!> Entry point for context type logger, transfers message from context to callback
subroutine message(self, msg)
   !> Instance of the custom logger with the actual logger callback function
   class(callback_logger), intent(inout) :: self
   !> Message payload from the calculation context
   character(len=*), intent(in) :: msg

   character(len=1, kind=c_char) :: charptr(len(msg))
   integer(c_int) :: nchars

   charptr = transfer(msg, charptr)
   nchars = len(msg)
   call self%callback(charptr, nchars, self%udata)
end subroutine message


end module tblite_api_context

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_scf_solver
   use mctc_env, only : sp, dp, error_type
   implicit none
   private

   public :: solver_type

   type, abstract :: solver_type
   contains
      generic :: solve => solve_sp, solve_dp
      procedure(solve_sp), deferred :: solve_sp
      procedure(solve_dp), deferred :: solve_dp
   end type solver_type

   abstract interface
      subroutine solve_sp(self, hmat, smat, eval, error)
         import :: solver_type, error_type, sp
         class(solver_type), intent(inout) :: self
         real(sp), contiguous, intent(inout) :: hmat(:, :)
         real(sp), contiguous, intent(in) :: smat(:, :)
         real(sp), contiguous, intent(inout) :: eval(:)
         type(error_type), allocatable, intent(out) :: error
      end subroutine solve_sp
      subroutine solve_dp(self, hmat, smat, eval, error)
         import :: solver_type, error_type, dp
         class(solver_type), intent(inout) :: self
         real(dp), contiguous, intent(inout) :: hmat(:, :)
         real(dp), contiguous, intent(in) :: smat(:, :)
         real(dp), contiguous, intent(inout) :: eval(:)
         type(error_type), allocatable, intent(out) :: error
      end subroutine solve_dp
   end interface


end module tblite_scf_solver

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the driver entry points for parameter optimizations
module tblite_driver_fit
   use mctc_env, only : error_type, fatal_error, get_argument, wp
   use mctc_io, only : structure_type, read_structure, write_structure, &
      & filetype, get_filetype, to_symbol
   use mctc_io_resize, only : resize
   use tblite_cli, only : fit_config
   use tblite_context_type, only : context_type
   use tblite_output_format, only : format_string
   use tblite_param, only : param_record, count
   use tblite_fit_newuoa, only : newuoa
   use tblite_fit_settings, only : fit_settings
   use tblite_os, only : setenv, file_exists, delete_file
   implicit none
   private

   public :: main

   interface main
      module procedure :: fit_main
   end interface


contains


subroutine fit_main(config, error)
   type(fit_config), intent(in) :: config
   type(error_type), allocatable, intent(out) :: error

   type(fit_settings), target :: set
   type(param_record) :: param
   type(context_type) :: ctx
   integer :: stat, npar
   real(wp), allocatable :: array(:), p(:)
   class(*), pointer :: handle
   real(wp), parameter :: conv = 1.0e-5_wp

   allocate(set%base)
   call set%base%load(config%param, error)
   if (allocated(error)) return

   call clear_metadata(set%base)

   call set%load(config%input, error)
   if (allocated(error)) return

   npar = count(set%mask)
   allocate(array(npar))
   if (set%relative) then
      array(:) = 1.0_wp
   else
      call set%base%dump(array, set%mask, error)
   end if
   if (allocated(error)) return

   call summary(ctx%unit, config, set)

   call setenv("TBLITE_EXE", config%prog, stat)
   call setenv("TBLITE_OUT", set%output, stat)
   call setenv("TBLITE_PAR", set%fitpar, stat)

   if (allocated(config%copy_input)) then
      call set%dump(config%copy_input, error)
      if (allocated(error)) return
      call ctx%message("[Info] Input settings dumped to '"//config%copy_input//"'")
   end if

   call write_param(set, array, error)
   if (allocated(error)) return

   if (config%dry_run) then
      call ctx%message("[Info] Initial parameters written to '"//set%fitpar//"'")
      return
   end if

   handle => set
   call newuoa(npar, 2*npar, array, set%trustr, conv, config%verbosity, set%max_iter*npar, &
      & eval, handle, error)
   if (allocated(error)) return

   call write_param(set, array, error)
   if (allocated(error)) return
   call ctx%message("[Info] Final parameters written to '"//set%fitpar//"'")
end subroutine fit_main


subroutine summary(unit, config, set)
   integer, intent(in) :: unit
   type(fit_config), intent(in) :: config
   type(fit_settings), intent(in) :: set

   write(unit, '(a, t30, a)') &
      & "Optimization method", set%method, &
      & "Max. function evaluations", format_string(count(set%mask)*set%max_iter, '(i0)'), &
      & "Number of parameters", format_string(count(set%mask), '(i0)'), &
      & "Initial trust radius", format_string(set%trustr, '(f8.6)'), &
      & "Initial parameter file", config%param, &
      & "Script command", "'"//set%script//"'"
end subroutine summary


function eval(n, x, h, error) result(f)
   integer, intent(in) :: n
   real(wp), intent(in) :: x(*)
   class(*), intent(in) :: h
   type(error_type), allocatable, intent(out) :: error
   real(wp) :: f

   type(param_record) :: param
   integer :: stat
   real(wp), allocatable :: actual(:), reference(:)
   real(wp), allocatable :: p(:)

   f = huge(0.0_wp)

   select type(set => h)
   type is (fit_settings)
      call write_param(set, x(1:n), error)
      if (allocated(error)) return

      call delete_file(set%output)

      call execute_command_line(set%script, exitstat=stat)
      if (stat /= 0) then
         call fatal_error(error, "Running '"//set%script//"' failed")
         return
      end if

      if (.not.file_exists(set%output)) then
         call fatal_error(error, "Output data '"//set%script//"' of script not found")
         return
      end if

      call read_data(set%output, actual, reference)

      f = sum((actual - reference)**2)
   end select

end function eval


subroutine read_data(file, actual, reference)
   character(len=*), intent(in) :: file
   real(wp), allocatable, intent(out) :: actual(:), reference(:)
   integer :: idata, stat, unit

   open(file=file, newunit=unit)
   call resize(actual)
   call resize(reference)
   idata = 0
   stat = 0
   do while(stat == 0)
      if (idata >= min(size(reference), size(actual))) then
         call resize(actual)
         call resize(reference)
      end if
      idata = idata + 1
      read(unit, *, iostat=stat) reference(idata), actual(idata)
      if (stat /= 0) idata = idata - 1
   end do
   close(unit)

   call resize(actual, idata)
   call resize(reference, idata)
end subroutine read_data


!> Make sure no stale meta data is present in parameter file
subroutine clear_metadata(param)
   type(param_record), intent(inout) :: param

   param%version = 0
   if (allocated(param%name)) deallocate(param%name)
   if (allocated(param%reference)) deallocate(param%reference)
end subroutine clear_metadata


subroutine write_param(set, array, error)
   type(fit_settings), intent(in) :: set
   real(wp), intent(in) :: array(:)
   type(error_type), allocatable, intent(out) :: error

   type(param_record) :: param
   real(wp), allocatable :: p(:)

   if (set%relative) then
      allocate(p(size(array)))
      call set%base%dump(p, set%mask, error)
      if (allocated(error)) return
      p(:) = array * p
      call param%load(p, set%base, set%mask, error)
      if (allocated(error)) return
   else
      call param%load(array, set%base, set%mask, error)
      if (allocated(error)) return
   end if

   call param%dump(set%fitpar, error)
   if (allocated(error)) return
end subroutine write_param


end module tblite_driver_fit

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_wignerseitz
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_cutoff, only : get_lattice_points
   implicit none
   private

   public :: wignerseitz_cell, new_wignerseitz_cell

   type :: wignerseitz_cell
      integer, allocatable :: nimg(:, :)
      integer, allocatable :: tridx(:, :, :)
      real(wp), allocatable :: trans(:, :)
   end type wignerseitz_cell


   !> Small cutoff threshold to create only closest cells
   real(wp), parameter :: thr = sqrt(epsilon(0.0_wp))

   !> Tolerance to consider equivalent images
   real(wp), parameter :: tol = 0.01_wp


contains


subroutine new_wignerseitz_cell(self, mol)

   !> Wigner-Seitz cell instance
   type(wignerseitz_cell), intent(out) :: self

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   integer :: iat, jat, ntr, nimg
   integer, allocatable :: tridx(:)
   real(wp) :: vec(3)
   real(wp), allocatable :: trans(:, :)

   call get_lattice_points(mol%periodic, mol%lattice, thr, trans)
   ntr = size(trans, 2)
   allocate(self%nimg(mol%nat, mol%nat), self%tridx(ntr, mol%nat, mol%nat), &
      & tridx(ntr))

   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(mol, trans, self) private(iat, jat, vec, nimg, tridx)
   do iat = 1, mol%nat
      do jat = 1, mol%nat
         vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat)
         call get_pairs(nimg, trans, vec, tridx)
         self%nimg(jat, iat) = nimg
         self%tridx(:, jat, iat) = tridx
      end do
   end do

   call move_alloc(trans, self%trans)
   
end subroutine new_wignerseitz_cell


subroutine get_pairs(iws, trans, rij, list)
   integer, intent(out) :: iws
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: trans(:, :)
   integer, intent(out) :: list(:)

   logical :: mask(size(list))
   real(wp) :: dist(size(list)), vec(3), r2
   integer :: itr, img, pos

   iws = 0
   img = 0
   list(:) = 0
   mask(:) = .true.

   do itr = 1, size(trans, 2)
      vec(:) = rij - trans(:, itr)
      r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
      if (r2 < thr) cycle
      img = img + 1
      dist(img) = r2
   end do

   if (img == 0) return

   pos = minloc(dist(:img), dim=1)

   r2 = dist(pos)
   mask(pos) = .false.

   iws = 1
   list(iws) = pos
   if (img <= iws) return

   do
      pos = minloc(dist(:img), dim=1, mask=mask(:img))
      if (abs(dist(pos) - r2) > tol) exit
      mask(pos) = .false.
      iws = iws + 1
      list(iws) = pos
   end do

end subroutine get_pairs


end module tblite_wignerseitz

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of abstract base class for dispersion interactions
module tblite_disp_type
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_container_type, only : container_type
   use tblite_scf_info, only : scf_info
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: dispersion_type

   !> Abstract base class for dispersion interactions
   type, extends(container_type), abstract :: dispersion_type
   end type dispersion_type


end module tblite_disp_type

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_api_table
   use, intrinsic :: iso_c_binding
   use mctc_env, only : fatal_error
   use tblite_api_error, only : vp_error
   use tblite_api_version, only : namespace
   use tblite_api_utils, only : c_f_character, strlen
   use tblite_toml, only : toml_table, toml_array, toml_value, add_array, set_value, get_value
   implicit none
   private

   public :: vp_table
   public :: new_table_api, delete_table_api
   public :: table_set_double_api, table_set_int64_t_api, table_set_bool_api, &
      & table_set_char_api, table_add_table_api

   !> Void pointer to manage general data tables
   type :: vp_table
      !> Actual payload
      type(toml_table), pointer :: ptr
      !> Data is owned by the object
      logical :: owned
   end type vp_table

   logical, parameter :: debug = .false.

contains

!> Create data table reference object
function new_table_api(vtable) &
      & result(vval) &
      & bind(C, name=namespace//"new_table")
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   type(vp_table), pointer :: val
   type(c_ptr) :: vval
   type(toml_table), pointer :: dat

   if (debug) print '("[Info]", 1x, a)', "new_table"

   allocate(val)
   if (c_associated(vtable)) then
      call c_f_pointer(vtable, table)
      val%ptr => table%ptr
      val%owned = .false.
   else
      allocate(dat)
      dat = toml_table()
      val%ptr => dat
      val%owned = .true.
   end if
   vval = c_loc(val)
end function new_table_api

!> Delete data table object
subroutine delete_table_api(vtable) &
      & bind(C, name=namespace//"delete_table")
   type(c_ptr), intent(inout) :: vtable
   type(vp_table), pointer :: table

   if (debug) print '("[Info]", 1x, a)', "delete_table"

   if (c_associated(vtable)) then
      call c_f_pointer(vtable, table)

      if (table%owned) deallocate(table%ptr)
      deallocate(table)
      vtable = c_null_ptr
   end if

end subroutine delete_table_api

subroutine table_set_double_api(verror, vtable, ckey, val, n) &
      & bind(C, name=namespace//"table_set_double")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   real(c_double), intent(in) :: val(*)
   integer(c_int), value :: n
   type(toml_array), pointer :: array
   integer :: i, stat

   if (debug) print '("[Info]", 1x, a)', "table_set_double"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)

   if (table%ptr%has_key(key)) call table%ptr%delete(key)

   if (n > 0) then
      call add_array(table%ptr, key, array)
      do i = 1, n
         call set_value(array, i, val(i), stat=stat)
         if (stat /= 0) exit
      end do
   else
      call set_value(table%ptr, key, val(1), stat=stat)
   end if

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back double value(s) to data table")
   end if
end subroutine table_set_double_api

subroutine table_set_int64_t_api(verror, vtable, ckey, val, n) &
      & bind(C, name=namespace//"table_set_int64_t")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   integer(c_int64_t), intent(in) :: val(*)
   integer(c_int), value :: n
   type(toml_array), pointer :: array
   integer :: i, stat

   if (debug) print '("[Info]", 1x, a)', "table_set_int64_t"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)

   if (table%ptr%has_key(key)) call table%ptr%delete(key)

   if (n > 0) then
      call add_array(table%ptr, key, array)
      do i = 1, n
         call set_value(array, i, val(i), stat=stat)
         if (stat /= 0) exit
      end do
   else
      call set_value(table%ptr, key, val(1), stat=stat)
   end if

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back integer value(s) to data table")
   end if
end subroutine table_set_int64_t_api

subroutine table_set_bool_api(verror, vtable, ckey, val, n) &
      & bind(C, name=namespace//"table_set_bool")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   logical(c_bool), intent(in) :: val(*)
   integer(c_int), value :: n
   type(toml_array), pointer :: array
   integer :: i, stat

   if (debug) print '("[Info]", 1x, a)', "table_set_bool"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)

   if (table%ptr%has_key(key)) call table%ptr%delete(key)

   if (n > 0) then
      call add_array(table%ptr, key, array)
      do i = 1, n
         call set_value(array, i, merge(.true., .false., val(i)), stat=stat)
         if (stat /= 0) exit
      end do
   else
      call set_value(table%ptr, key, merge(.true., .false., val(1)), stat=stat)
   end if

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back boolean value(s) to data table")
   end if
end subroutine table_set_bool_api

subroutine table_set_char_api(verror, vtable, ckey, cval, n) &
      & bind(C, name=namespace//"table_set_char")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key, val
   type(c_ptr), value :: cval
   character(kind=c_char), pointer :: carr(:, :)
   integer(c_int), value :: n
   type(toml_array), pointer :: array
   integer :: i, stat

   if (debug) print '("[Info]", 1x, a)', "table_set_char"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)
   call c_f_pointer(cval, carr, [strlen(cval)+1, min(n, 1)])

   if (table%ptr%has_key(key)) call table%ptr%delete(key)

   if (n > 0) then
      call add_array(table%ptr, key, array)
      do i = 1, n
         call c_f_character(carr(:, i), val)
         call set_value(array, i, val, stat=stat)
         if (stat /= 0) exit
      end do
   else
      call c_f_character(carr(:, 1), val)
      call set_value(table%ptr, key, val, stat=stat)
   end if

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back character string to data table")
   end if
end subroutine table_set_char_api

function table_add_table_api(verror, vtable, ckey) &
      & result(vval) &
      & bind(C, name=namespace//"table_add_table")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   type(c_ptr) :: vval
   type(vp_table), pointer :: val
   type(toml_table), pointer :: tmp
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "table_add_table"

   vval = c_null_ptr
   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   vval = new_table_api(vtable)
   call c_f_pointer(vtable, table)
   call c_f_pointer(vval, val)
   call c_f_character(ckey, key)

   call get_value(table%ptr, key, tmp, stat=stat)
   val%ptr => tmp

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back subtable to data table")
      call delete_table_api(vval)
   end if
end function table_add_table_api


end module tblite_api_table

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Declaration of an integral storage container to collect all overlap related integrals
module tblite_integral_type
   use mctc_env, only : wp
   implicit none
   private

   public :: integral_type, new_integral

   !> Integral container to store all overlap related integrals
   type :: integral_type
      !> Effective one-electron Hamiltonian
      real(wp), allocatable :: hamiltonian(:, :)
      !> Overlap integrals
      real(wp), allocatable :: overlap(:, :)
      !> Dipole moment integrals, moment operator is centered on last index
      real(wp), allocatable :: dipole(:, :, :)
      !> Quadrupole moment integrals, moment operator is centered on last index
      real(wp), allocatable :: quadrupole(:, :, :)
   end type integral_type

contains

!> Create and allocate a new integral container storage
subroutine new_integral(self, nao)
   !> Instance of the integral container
   type(integral_type), intent(out) :: self
   !> Dimension of the integrals
   integer, intent(in) :: nao

   allocate(self%hamiltonian(nao, nao))
   allocate(self%overlap(nao, nao))
   allocate(self%dipole(3, nao, nao))
   allocate(self%quadrupole(6, nao, nao))
end subroutine new_integral

end module tblite_integral_type

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of an abstract base class of the generator for the Hamiltonian.
module tblite_xtb_spec
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_basis_type, only : basis_type
   use tblite_data_atomicrad, only : get_atomic_rad
   implicit none
   private

   public :: tb_h0spec


   !> Specification of the effective Hamiltonian.
   !>
   !> An instance of the specification is consumed by the constructor of the
   !> Hamiltonian to generate the respective entries in the derived type.
   type, abstract :: tb_h0spec
   contains
      !> Generator for the self energy / atomic levels of the Hamiltonian
      procedure(get_selfenergy), deferred :: get_selfenergy
      !> Generator for the coordination number dependent shift of the self energy
      procedure :: get_cnshift
      !> Generator for the linear partial charge dependent shift of the self energy
      procedure :: get_q1shift
      !> Generator for the quadratic partial charge dependent shift of the self energy
      procedure :: get_q2shift
      !> Generator for the enhancement factor to for scaling Hamiltonian elements
      procedure(get_hscale), deferred :: get_hscale
      !> Generator for the atomic radii used in the distant dependent scaling
      procedure :: get_rad
      !> Generator for the polynomial parameters for the distant dependent scaling
      procedure(get_shpoly), deferred :: get_shpoly
      !> Generator for the reference occupation numbers of the atoms
      procedure(get_reference_occ), deferred :: get_reference_occ
   end type tb_h0spec

   abstract interface
      !> Generator for the enhancement factor to for scaling Hamiltonian elements
      subroutine get_hscale(self, mol, bas, hscale)
         import :: tb_h0spec, structure_type, basis_type, wp
         !> Instance of the Hamiltonian specification
         class(tb_h0spec), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Basis set information
         type(basis_type), intent(in) :: bas
         !> Scaling parameters for the Hamiltonian elements
         real(wp), intent(out) :: hscale(:, :, :, :)
      end subroutine get_hscale

      !> Generator for the self energy / atomic levels of the Hamiltonian
      subroutine get_selfenergy(self, mol, bas, selfenergy)
         import :: tb_h0spec, structure_type, basis_type, wp
         !> Instance of the Hamiltonian specification
         class(tb_h0spec), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Basis set information
         type(basis_type), intent(in) :: bas
         !> Self energy / atomic levels
         real(wp), intent(out) :: selfenergy(:, :)
      end subroutine get_selfenergy

      !> Generator for the polynomial parameters for the distant dependent scaling
      subroutine get_shpoly(self, mol, bas, shpoly)
         import :: tb_h0spec, structure_type, basis_type, wp
         !> Instance of the Hamiltonian specification
         class(tb_h0spec), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Basis set information
         type(basis_type), intent(in) :: bas
         !> Polynomial parameters for distant dependent scaleing
         real(wp), intent(out) :: shpoly(:, :)
      end subroutine get_shpoly

      !> Generator for the reference occupation numbers of the atoms
      subroutine get_reference_occ(self, mol, bas, refocc)
         import :: tb_h0spec, structure_type, basis_type, wp
         !> Instance of the Hamiltonian specification
         class(tb_h0spec), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Basis set information
         type(basis_type), intent(in) :: bas
         !> Reference occupation numbers
         real(wp), intent(out) :: refocc(:, :)
      end subroutine get_reference_occ
   end interface

contains


!> Stub implementation of the coordination number dependent shift generator
subroutine get_cnshift(self, mol, bas, kcn)
   !> Instance of the Hamiltonian specification
   class(tb_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Coordination number dependent shift
   real(wp), intent(out) :: kcn(:, :)

   kcn(:, :) = 0.0_wp
end subroutine get_cnshift


!> Stub implementation of the linear partial charge dependent shift generator
subroutine get_q1shift(self, mol, bas, kq1)
   !> Instance of the Hamiltonian specification
   class(tb_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Linear partial charge dependent shift
   real(wp), intent(out) :: kq1(:, :)

   kq1(:, :) = 0.0_wp
end subroutine get_q1shift


!> Stub implementation of the quadratic partial charge dependent shift generator
subroutine get_q2shift(self, mol, bas, kq2)
   !> Instance of the Hamiltonian specification
   class(tb_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Quadratic partial charge dependent shift
   real(wp), intent(out) :: kq2(:, :)

   kq2(:, :) = 0.0_wp
end subroutine get_q2shift


!> Stub implementation of the atomic radii generator
subroutine get_rad(self, mol, bas, rad)
   !> Instance of the Hamiltonian specification
   class(tb_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Atomic radii
   real(wp), intent(out) :: rad(:)

   rad(:) = get_atomic_rad(mol%num)
end subroutine get_rad


end module tblite_xtb_spec

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_output_property
   use mctc_env, only : wp
   implicit none
   private

   public :: property, write(formatted)

   type :: property
      character(len=:), allocatable :: label
      real(wp) :: value
      character(len=:), allocatable :: unit
   end type property

   interface property
      module procedure :: new_property
   end interface property

    interface write(formatted)
        module procedure :: write_formatted
    end interface


contains


pure function new_property(label, value, unit) result(new)
   character(len=*), intent(in) :: label
   real(wp), intent(in) :: value
   character(len=*), intent(in) :: unit
   type(property) :: new

   new%label = label
   new%value = value
   new%unit = unit
end function new_property


subroutine write_formatted(prop, unit, iotype, v_list, iostat, iomsg)
   class(property), intent(in) :: prop
   integer, intent(in) :: unit
   character(len=*), intent(in) :: iotype
   integer, intent(in) :: v_list(:)
   integer, intent(out) :: iostat
   character(len=*), intent(inout) :: iomsg

   write(unit, '(a, t25, es20.13, 1x, a)') prop%label, prop%value, prop%unit
end subroutine write_formatted


end module tblite_output_property

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> API export for working with molecular structure data objects
module tblite_api_structure
   use, intrinsic :: iso_c_binding
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type, new
   use tblite_api_error, only : vp_error
   use tblite_api_version, only : namespace
   use tblite_cutoff, only : wrap_to_central_cell
   implicit none
   private

   public :: vp_structure
   public :: new_structure_api, delete_structure_api, update_structure_geometry_api
   public :: update_structure_charge_api, update_structure_uhf_api


   !> Void pointer to molecular structure data
   type :: vp_structure
      !> Actual payload
      type(structure_type) :: ptr
   end type vp_structure


   logical, parameter :: debug = .false.


contains


!> Create new molecular structure data (quantities in Bohr)
function new_structure_api(verror, natoms, numbers, positions, c_charge, c_uhf, &
      & c_lattice, c_periodic) result(vmol) &
      & bind(C, name=namespace//"new_structure")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   integer(c_int), value, intent(in) :: natoms
   integer(c_int), intent(in) :: numbers(natoms)
   real(c_double), intent(in) :: positions(3, natoms)
   real(c_double), intent(in), optional :: c_charge
   real(wp), allocatable :: charge
   integer(c_int), intent(in), optional :: c_uhf
   integer, allocatable :: uhf
   real(c_double), intent(in), optional :: c_lattice(3, 3)
   real(wp), allocatable :: lattice(:, :)
   logical(c_bool), intent(in), optional :: c_periodic(3)
   logical, allocatable :: periodic(:)
   type(vp_structure), pointer :: mol
   type(c_ptr) :: vmol

   if (debug) print '("[Info]",1x, a)', "new_structure"

   vmol = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (present(c_lattice)) then
      allocate(lattice(3, 3))
      lattice(:, :) = c_lattice
   end if
   if (present(c_periodic)) then
      allocate(periodic(3))
      periodic(:) = c_periodic
   end if
   if (present(c_charge)) then
      charge = c_charge
   end if
   if (present(c_uhf)) then
      uhf = c_uhf
   end if

   allocate(mol)
   call new(mol%ptr, numbers, positions, lattice=lattice, periodic=periodic, &
      charge=charge, uhf=uhf)
   vmol = c_loc(mol)

   call wrap_to_central_cell(mol%ptr%xyz, mol%ptr%lattice, mol%ptr%periodic)

   call verify_structure(error%ptr, mol%ptr)

end function new_structure_api


!> Delete molecular structure data
subroutine delete_structure_api(vmol) &
      & bind(C, name=namespace//"delete_structure")
   type(c_ptr), intent(inout) :: vmol
   type(vp_structure), pointer :: mol

   if (debug) print '("[Info]",1x, a)', "delete_structure"

   if (c_associated(vmol)) then
      call c_f_pointer(vmol, mol)

      deallocate(mol)
      vmol = c_null_ptr
   end if

end subroutine delete_structure_api


!> Update coordinates and lattice parameters (quantities in Bohr)
subroutine update_structure_geometry_api(verror, vmol, positions, lattice) &
      & bind(C, name=namespace//"update_structure_geometry")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   real(c_double), intent(in) :: positions(3, *)
   real(c_double), intent(in), optional :: lattice(3, 3)

   if (debug) print '("[Info]",1x, a)', "update_structure"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vmol)) then
      call fatal_error(error%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   if (mol%ptr%nat <= 0 .or. mol%ptr%nid <= 0 .or. .not.allocated(mol%ptr%num) &
      & .or. .not.allocated(mol%ptr%id) .or. .not.allocated(mol%ptr%xyz)) then
      call fatal_error(error%ptr, "Invalid molecular structure data provided")
      return
   end if

   mol%ptr%xyz(:, :) = positions(:3, :mol%ptr%nat)
   if (present(lattice)) then
      mol%ptr%lattice(:, :) = lattice(:3, :3)
   end if

   call wrap_to_central_cell(mol%ptr%xyz, mol%ptr%lattice, mol%ptr%periodic)

   call verify_structure(error%ptr, mol%ptr)

end subroutine update_structure_geometry_api


!> Update coordinates and lattice parameters (quantities in Bohr)
subroutine update_structure_charge_api(verror, vmol, c_charge) &
      & bind(C, name=namespace//"update_structure_charge")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   real(c_double), intent(in), optional :: c_charge

   if (debug) print '("[Info]",1x, a)', "update_structure_charge"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vmol)) then
      call fatal_error(error%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   if (mol%ptr%nat <= 0 .or. mol%ptr%nid <= 0 .or. .not.allocated(mol%ptr%num) &
      & .or. .not.allocated(mol%ptr%id) .or. .not.allocated(mol%ptr%xyz)) then
      call fatal_error(error%ptr, "Invalid molecular structure data provided")
      return
   end if

   if (present(c_charge)) then
      mol%ptr%charge = c_charge
   end if

end subroutine update_structure_charge_api


!> Update coordinates and lattice parameters (quantities in Bohr)
subroutine update_structure_uhf_api(verror, vmol, c_uhf) &
      & bind(C, name=namespace//"update_structure_uhf")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   integer(c_int), intent(in), optional :: c_uhf

   if (debug) print '("[Info]",1x, a)', "update_structure_uhf"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vmol)) then
      call fatal_error(error%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   if (mol%ptr%nat <= 0 .or. mol%ptr%nid <= 0 .or. .not.allocated(mol%ptr%num) &
      & .or. .not.allocated(mol%ptr%id) .or. .not.allocated(mol%ptr%xyz)) then
      call fatal_error(error%ptr, "Invalid molecular structure data provided")
      return
   end if

   if (present(c_uhf)) then
      mol%ptr%uhf = c_uhf
   end if

end subroutine update_structure_uhf_api


!> Cold fusion check
subroutine verify_structure(error, mol)
   type(error_type), allocatable, intent(out) :: error
   type(structure_type), intent(in) :: mol
   integer :: iat, jat, stat
   stat = 0
   do iat = 1, mol%nat
      do jat = 1, iat - 1
         if (norm2(mol%xyz(:, jat) - mol%xyz(:, iat)) < 1.0e-9_wp) stat = stat + 1
      end do
   end do
   if (stat > 0) then
      call fatal_error(error, "Too close interatomic distances found")
   end if
end subroutine verify_structure


end module tblite_api_structure

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_wavefunction_guess
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_disp_d4, only : get_eeq_charges
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_xtb_h0, only : get_occupation
   use tblite_xtb_calculator, only : xtb_calculator
   implicit none
   private

   public :: sad_guess, eeq_guess

contains

subroutine sad_guess(mol, calc, wfn)
   type(structure_type), intent(in) :: mol
   type(xtb_calculator), intent(in) :: calc
   type(wavefunction_type), intent(inout) :: wfn

   wfn%qat(:, :) = 0.0_wp
   wfn%qat(:, 1) = mol%charge / mol%nat
   call shell_partition(mol, calc, wfn)
end subroutine sad_guess

subroutine eeq_guess(mol, calc, wfn)
   type(structure_type), intent(in) :: mol
   type(xtb_calculator), intent(in) :: calc
   type(wavefunction_type), intent(inout) :: wfn

   wfn%qat(:, :) = 0.0_wp
   call get_eeq_charges(mol, wfn%qat(:, 1))
   call shell_partition(mol, calc, wfn)
end subroutine eeq_guess

subroutine shell_partition(mol, calc, wfn)
   type(structure_type), intent(in) :: mol
   type(xtb_calculator), intent(in) :: calc
   type(wavefunction_type), intent(inout) :: wfn

   integer :: iat, ii, ish, spin

   call get_occupation(mol, calc%bas, calc%h0, wfn%nocc, wfn%n0at, wfn%n0sh)
   do spin = 1, size(wfn%qat, 2)
      do iat = 1, size(wfn%qat, 1)
         ii = calc%bas%ish_at(iat)
         do ish = 1, calc%bas%nsh_at(iat)
            wfn%qsh(ii+ish, spin) = (wfn%n0sh(ii+ish) / wfn%n0at(iat)) * wfn%qat(iat, spin)
         end do
      end do
   end do
end subroutine shell_partition

end module tblite_wavefunction_guess

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_lapack_getrs
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_getrs


   !> Solves a system of linear equations
   !>    A * X = B  or  A**T * X = B
   !> with a general N-by-N matrix A using the LU factorization computed
   !> by ?GETRF.
   interface wrap_getrs
      module procedure :: wrap_sgetrs
      module procedure :: wrap_dgetrs
   end interface wrap_getrs


   !> Solves a system of linear equations
   !>    A * X = B  or  A**T * X = B
   !> with a general N-by-N matrix A using the LU factorization computed
   !> by ?GETRF.
   interface lapack_getrs
      pure subroutine sgetrs(trans, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         real(sp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: trans
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine sgetrs
      pure subroutine dgetrs(trans, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         real(dp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: trans
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine dgetrs
   end interface lapack_getrs

contains

subroutine wrap_sgetrs(amat, bmat, ipiv, info, trans)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout) :: bmat(:, :)
   integer, intent(in) :: ipiv(:)
   integer, intent(out) :: info
   character(len=1), intent(in), optional :: trans
   character(len=1) :: tra
   integer :: n, nrhs, lda, ldb
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   nrhs = size(bmat, 2)
   call lapack_getrs(tra, n, nrhs, amat, lda, ipiv, bmat, ldb, info)
end subroutine wrap_sgetrs


subroutine wrap_dgetrs(amat, bmat, ipiv, info, trans)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout) :: bmat(:, :)
   integer, intent(in) :: ipiv(:)
   integer, intent(out) :: info
   character(len=1), intent(in), optional :: trans
   character(len=1) :: tra
   integer :: n, nrhs, lda, ldb
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   nrhs = size(bmat, 2)
   call lapack_getrs(tra, n, nrhs, amat, lda, ipiv, bmat, ldb, info)
end subroutine wrap_dgetrs

end module tblite_lapack_getrs

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> High-level interface to level 1 basic linear algebra subprogram operations
module tblite_blas_level1
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_dot


   !> Forms the dot product of two vectors.
   interface wrap_dot
      module procedure :: wrap_sdot
      module procedure :: wrap_ddot
      module procedure :: wrap_sdot12
      module procedure :: wrap_sdot21
      module procedure :: wrap_sdot22
      module procedure :: wrap_ddot12
      module procedure :: wrap_ddot21
      module procedure :: wrap_ddot22
   end interface wrap_dot


   !> Forms the dot product of two vectors.
   !> Uses unrolled loops for increments equal to one.
   interface blas_dot
      pure function sdot(n, x, incx, y, incy)
         import :: sp
         real(sp) :: sdot
         real(sp), intent(in) :: x(*)
         real(sp), intent(in) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end function sdot
      pure function ddot(n, x, incx, y, incy)
         import :: dp
         real(dp) :: ddot
         real(dp), intent(in) :: x(*)
         real(dp), intent(in) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end function ddot
   end interface blas_dot


contains


function wrap_sdot(xvec, yvec) result(dot)
   real(sp) :: dot
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(in) :: yvec(:)
   integer :: incx, incy, n
   incx = 1
   incy = 1
   n = size(xvec)
   dot = blas_dot(n, xvec, incx, yvec, incy)
end function wrap_sdot


function wrap_ddot(xvec, yvec) result(dot)
   real(dp) :: dot
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(in) :: yvec(:)
   integer :: incx, incy, n
   incx = 1
   incy = 1
   n = size(xvec)
   dot = blas_dot(n, xvec, incx, yvec, incy)
end function wrap_ddot


function wrap_sdot12(xvec, yvec) result(dot)
   real(sp) :: dot
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(in), contiguous, target :: yvec(:, :)
   real(sp), pointer :: yptr(:)
   yptr(1:size(yvec)) => yvec
   dot = wrap_dot(xvec, yptr)
end function wrap_sdot12


function wrap_sdot21(xvec, yvec) result(dot)
   real(sp) :: dot
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(in) :: yvec(:)
   real(sp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   dot = wrap_dot(xptr, yvec)
end function wrap_sdot21


function wrap_sdot22(xvec, yvec) result(dot)
   real(sp) :: dot
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(in), contiguous, target :: yvec(:, :)
   real(sp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   dot = wrap_dot(xptr, yptr)
end function wrap_sdot22


function wrap_ddot12(xvec, yvec) result(dot)
   real(dp) :: dot
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(in), contiguous, target :: yvec(:, :)
   real(dp), pointer :: yptr(:)
   yptr(1:size(yvec)) => yvec
   dot = wrap_dot(xvec, yptr)
end function wrap_ddot12


function wrap_ddot21(xvec, yvec) result(dot)
   real(dp) :: dot
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(in) :: yvec(:)
   real(dp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   dot = wrap_dot(xptr, yvec)
end function wrap_ddot21


function wrap_ddot22(xvec, yvec) result(dot)
   real(dp) :: dot
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(in), contiguous, target :: yvec(:, :)
   real(dp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   dot = wrap_dot(xptr, yptr)
end function wrap_ddot22


end module tblite_blas_level1

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Module to collect all help printout for the tblite program
module tblite_cli_help
   implicit none
   private

   public :: prog_name, help_text, help_text_run, help_text_param, help_text_fit, &
      & help_text_tagdiff

   character(len=*), parameter :: nl = new_line('a')

   !> Name of the main executable
   character(len=*), parameter :: prog_name = "tblite"

   !> General help text regarding response file support
   character(len=*), parameter :: help_text_response = &
      "Command line arguments can be read from an indirect file / response file"//nl//&
      "by specifying the file with @name in the command line. Each line in the file"//nl//&
      "is interpreted as command line argument, shell like escape sequences are not"//nl//&
      "available. The file can contain further @name inputs. If the file cannot be"//nl//&
      "found the argument is used literally."

   !> General help text for version and help commands
   character(len=*), parameter :: help_text_general = &
      "      --version           Print program version and exit"//nl//&
      "      --help              Show this help message"

   !> General help text regarding geometry input formats
   character(len=*), parameter :: help_text_geometry = &
      "Supported geometry input formats are:"//nl//&
      ""//nl//&
      "- Xmol/xyz files (xyz, log)"//nl//&
      "- Turbomole's coord, riper's periodic coord (tmol, coord)"//nl//&
      "- DFTB+ genFormat geometry inputs as cluster, supercell or fractional (gen)"//nl//&
      "- VASP's POSCAR/CONTCAR input files (vasp, poscar, contcar)"//nl//&
      "- Protein Database files, only single files (pdb)"//nl//&
      "- Connection table files, molfile (mol) and structure data format (sdf)"//nl//&
      "- Gaussian's external program input (ein)"

   !> Help text for main driver
   character(len=*), parameter :: help_text = &
      "Usage: "//prog_name//" <run|param|fit|tagdiff> [options]"//nl//&
      ""//nl//&
      "Commands"//nl//&
      ""//nl//&
      "  run       Evaluate tight-binding module on the provided input structure."//nl//&
      "            If no command is specified run is selected by default."//nl//&
      ""//nl//&
      "  param     Inspect and manipulate tight-binding parametrization data."//nl//&
      ""//nl//&
      "  fit       Optimize tight-binding parameters."//nl//&
      ""//nl//&
      "  tagdiff   Auxilary tool to compute differences between data outputs."//nl//&
      ""//nl//&
      "Options"//nl//&
      ""//nl//&
      "      --color string      Support colorful terminal output,"//nl//&
      "                          possible values are never (default), always, auto."//nl//&
      help_text_general//nl//&
      ""//nl//&
      help_text_response

   !> Help text for param command
   character(len=*), parameter :: help_text_param = &
      "Usage: "//prog_name//" param [options] <input>"//nl//&
      ""//nl//&
      "Import, export and manipulate tight-binding parameter files."//nl//&
      "An input parameter file must be present as positional argument or"//nl//&
      "an internal parametrization should be selected."//nl//&
      ""//nl//&
      "Options"//nl//&
      ""//nl//&
      "      --method <name>     Base parametrization of the xTB Hamiltonian to use"//nl//&
      "                          Available methods: gfn1, gfn2, ipea1"//nl//&
      "      --output <file>     Output file for writing parametrization"//nl//&
      help_text_general//nl//&
      ""//nl//&
      help_text_response

   !> Help text for run command
   character(len=*), parameter :: help_text_run = &
      "Usage: "//prog_name//" [run] [options] <input>"//nl//&
      ""//nl//&
      "Evaluates the tight-binding model on the provided input structure."//nl//&
      "Periodic calculations are performed automatically for periodic input formats."//nl//&
      ""//nl//&
      help_text_geometry//nl//&
      ""//nl//&
      "Options"//nl//&
      ""//nl//&
      "  -c, --charge <real>     Set charge to molecule, overwrites .CHRG file"//nl//&
      "      --spin <int>        Set number of unpaired electrons, overwrites .UHF file"//nl//&
      "      --method <name>     Parametrization of the xTB Hamiltonian to use"//nl//&
      "                          Available methods: gfn1, gfn2, ipea1 (Default: gfn2)"//nl//&
      "      --param <file>      Parametrization file to use for calculation"//nl//&
      "      --etemp <real>      Electronic temperature for calculation (Default: 300K)"//nl//&
      "      --guess <name>      Guess for the initial populations, possible options:"//nl//&
      "                          sad (default), and eeq."//nl//&
      "      --efield <real>,<real>,<real>"//nl//&
      "                          Homogeneous electric field in V/Å."//nl//&
      "--alpb <real>             Use analytical linearized Poisson-Boltzmann solvation."//nl//&
      "                          Solvent is specified by dielectric constant."//nl//&
      "--gbsa <real>             Use generalized Born solvation model."//nl//&
      "                          Solvent is specified by dielectric constant."//nl//&
      "--cpcm <real>             Use polarizable continuum solvation model."//nl//&
      "                          Solvent is specified by dielectric constant."//nl//&
      "      --spin-polarized    Use spin-polarized xTB Hamiltonian"//nl//&
      "      --grad [file]       Evaluate molecular gradient and virial"//nl//&
      "                          Results are stored in file (default: tblite.txt)"//nl//&
      "      --json [file]       Dump results as JSON output (default: tblite.json)"//nl//&
      "  -i, --input <format>    Hint for the format of the input file"//nl//&
      "  -v, --verbose           Increase verbosity of printout"//nl//&
      "  -s, --silent            Reduce verbosity of printout"//nl//&
      help_text_general//nl//&
      ""//nl//&
      help_text_response

   !> Help text for fit command
   character(len=*), parameter :: help_text_fit = &
      "Usage: "//prog_name//" fit [options] <param-file> <input-file>"//nl//&
      ""//nl//&
      "Takes the name of the starting parameter file as first positional argument and"//nl//&
      "an input file for the settings of the run as second positional argument."//nl//&
      "A starting parameter file can be produced using the tblite-param(1) command."//nl//&
      ""//nl//&
      "Options"//nl//&
      ""//nl//&
      "      --dry-run           Do not run start the fitting procedure"//nl//&
      "      --copy <file>       Write the full representation of the input to <file>,"//nl//&
      "                          all defaults will be filled in and the mask expanded"//nl//&
      "  -v, --verbose           Increase verbosity of printout"//nl//&
      "  -s, --silent            Reduce verbosity of printout"//nl//&
      help_text_general//nl//&
      ""//nl//&
      help_text_response

   !> Help text for tagdiff command
   character(len=*), parameter :: help_text_tagdiff = &
      "Usage: "//prog_name//" tagdiff [options] <actual> <reference>"//nl//&
      ""//nl//&
      "Takes two positional arguments and computes the difference between the"//nl//&
      "entries in the reference and the actual data files. Only keys of the"//nl//&
      "reference data file are used from the actual one."//nl//&
      ""//nl//&
      "Options"//nl//&
      ""//nl//&
      "      --fit               Produce output for fit command"//nl//&
      help_text_general//nl//&
      ""//nl//&
      help_text_response

end module tblite_cli_help

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_io_tag
   use mctc_io_utils, only : getline
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: tagged_data, tagged_entry
   public :: write_tagged, read_tagged

   interface write_tagged
      module procedure :: write_tagged
      module procedure :: write_tagged_dp0
      module procedure :: write_tagged_dp1
      module procedure :: write_tagged_dp2
   end interface

   interface read_tagged
      module procedure :: read_tagged
   end interface

   character(len=*), parameter :: tag_header = &
      & '(a,t20,":",a,":",i0,":",*(i0:,","))'

   type :: tagged_entry
      character(len=:), allocatable :: tag
      class(*), allocatable :: raw(:)
      integer, allocatable :: shape(:)
   end type tagged_entry

   type :: tagged_data
      type(tagged_entry), allocatable :: val(:)
   contains
      procedure :: get
      !> Reading of tagged data
      generic :: load => load_from_file, load_from_unit
      !> Read tagged data from file
      procedure, private :: load_from_file
      !> Read tagged data from formatted unit
      procedure, private :: load_from_unit
      !> Writing of tagged data
      generic :: dump => dump_to_file, dump_to_unit
      !> Write tagged data to file
      procedure, private :: dump_to_file
      !> Write tagged data to formatted unit
      procedure, private :: dump_to_unit
   end type tagged_data

contains

subroutine write_tagged_dp0(unit, tag, val, stat)
   integer, intent(in) :: unit
   character(len=*), intent(in) :: tag
   real(dp), intent(in) :: val
   integer, intent(out) :: stat

   type(tagged_entry) :: tmp

   tmp%tag = tag
   tmp%raw = [val]
   allocate(tmp%shape(0))
   call write_tagged(unit, tmp, stat)
end subroutine write_tagged_dp0

subroutine write_tagged_dp1(unit, tag, val, stat)
   integer, intent(in) :: unit
   character(len=*), intent(in) :: tag
   real(dp), intent(in) :: val(:)
   integer, intent(out) :: stat

   type(tagged_entry) :: tmp

   tmp%tag = tag
   tmp%raw = val
   tmp%shape = shape(val)
   call write_tagged(unit, tmp, stat)
end subroutine write_tagged_dp1

subroutine write_tagged_dp2(unit, tag, val, stat)
   integer, intent(in) :: unit
   character(len=*), intent(in) :: tag
   real(dp), intent(in) :: val(:, :)
   integer, intent(out) :: stat

   type(tagged_entry) :: tmp

   tmp%tag = tag
   tmp%raw = reshape(val, [size(val)])
   tmp%shape = shape(val)
   call write_tagged(unit, tmp, stat)
end subroutine write_tagged_dp2

subroutine write_tagged(unit, val, stat)
   integer, intent(in) :: unit
   type(tagged_entry), intent(in) :: val
   integer, intent(out) :: stat

   select type(raw => val%raw)
   type is(real(dp))
      write(unit, tag_header, iostat=stat) val%tag, "real", size(val%shape), val%shape
      write(unit, '(3es24.16)') raw
   end select
end subroutine write_tagged

subroutine read_tagged(unit, val, stat)
   integer, intent(in) :: unit
   type(tagged_entry), intent(out) :: val
   integer, intent(out) :: stat

   integer :: idel, jdel, kdel, vrank, i
   character(len=:), allocatable :: line

   call getline(unit, line, stat)
   if (is_iostat_end(stat)) return
   idel = scan(line, ":")
   jdel = scan(line(idel+1:), ":") + idel

   val%tag = trim(line(:idel-1))

   kdel = scan(line(jdel+1:), ":") + jdel
   read(line(jdel+1:kdel-1), *) vrank
   allocate(val%shape(vrank))
   if (vrank > 0) then
      do i = kdel+1, len(line)
         if (line(i:i) == ",") line(i:i) = " "
      end do
      read(line(kdel+1:), *) val%shape
   end if

   select case(line(idel+1:jdel-1))
   case("real")
      block
         integer :: i, n
         real(dp), allocatable :: tmp(:)
         n = max(product(val%shape), 1)
         allocate(tmp(n))
         read(unit, *) (tmp(i), i = 1, n)
         call move_alloc(tmp, val%raw)
      end block
   end select
end subroutine read_tagged


subroutine load_from_unit(self, unit, stat)
   class(tagged_data), intent(out) :: self
   integer, intent(in) :: unit
   integer, intent(out) :: stat

   integer :: it

   call resize(self%val)

   it = 0
   stat = 0
   do while(stat == 0)
      if (it > size(self%val)) call resize(self%val)
      it = it + 1
      call read_tagged(unit, self%val(it), stat)
      if (stat /= 0) it = it - 1
   end do
   call resize(self%val, it)

   if (is_iostat_end(stat)) stat = 0
end subroutine load_from_unit

subroutine dump_to_unit(self, unit, stat)
   class(tagged_data), intent(in) :: self
   integer, intent(in) :: unit
   integer, intent(out) :: stat

   integer :: it

   do it = 1, size(self%val)
      call write_tagged(unit, self%val(it), stat)
      if (stat /= 0) exit
   end do
end subroutine dump_to_unit

subroutine get(self, tag, ptr)
   class(tagged_data), intent(in), target :: self
   character(len=*), intent(in) :: tag
   type(tagged_entry), pointer, intent(out) :: ptr

   integer :: i

   nullify(ptr)
   do i = 1, size(self%val)
      if (self%val(i)%tag == tag) then
         ptr => self%val(i)
         exit
      end if
   end do
end subroutine get


!> Reallocate list of tagged entries
pure subroutine resize(var, n)
   !> Instance of the array to be resized
   type(tagged_entry), allocatable, intent(inout) :: var(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(tagged_entry), allocatable :: tmp(:)
   integer :: this_size, new_size, i
   integer, parameter :: initial_size = 20

   if (allocated(var)) then
      this_size = size(var, 1)
      call move_alloc(var, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(var(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(var, 1))
      do i = 1, this_size
         call move_alloc(tmp(i)%tag, var(i)%tag)
         call move_alloc(tmp(i)%raw, var(i)%raw)
         call move_alloc(tmp(i)%shape, var(i)%shape)
      end do
      deallocate(tmp)
   end if
end subroutine resize


!> Read parametrization data from file
subroutine load_from_file(self, file, stat)
   !> Instance of the parametrization data
   class(tagged_data), intent(inout) :: self
   !> File name
   character(len=*), intent(in) :: file
   !> Error handling
   integer, intent(out) :: stat

   integer :: unit
   logical :: exist

   inquire(file=file, exist=exist)
   if (.not.exist) then
     stat = 1
     return
   end if

   open(file=file, newunit=unit)
   call self%load(unit, stat)
   close(unit)
end subroutine load_from_file


!> Write parametrization data to file
subroutine dump_to_file(self, file, stat)
   !> Instance of the parametrization data
   class(tagged_data), intent(in) :: self
   !> File name
   character(len=*), intent(in) :: file
   !> Error handling
   integer, intent(out) :: stat

   integer :: unit

   open(file=file, newunit=unit)
   call self%dump(unit, stat)
   close(unit)
   if (stat /= 0) return

end subroutine dump_to_file


end module tblite_io_tag

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_version
   implicit none
   private

   public :: tblite_version_string, tblite_version_compact
   public :: get_tblite_version


   !> String representation of the tblite version
   character(len=*), parameter :: tblite_version_string = "0.2.1"

   !> Numeric representation of the tblite version
   integer, parameter :: tblite_version_compact(3) = [0, 2, 1]


contains


!> Getter function to retrieve tblite version
subroutine get_tblite_version(major, minor, patch, string)
   !> Major version number of the tblite version
   integer, intent(out), optional :: major
   !> Minor version number of the tblite version
   integer, intent(out), optional :: minor
   !> Patch version number of the tblite version
   integer, intent(out), optional :: patch
   !> String representation of the tblite version
   character(len=:), allocatable, intent(out), optional :: string

   if (present(major)) then
      major = tblite_version_compact(1)
   end if
   if (present(minor)) then
      minor = tblite_version_compact(2)
   end if
   if (present(patch)) then
      patch = tblite_version_compact(3)
   end if
   if (present(string)) then
      string = tblite_version_string
   end if

end subroutine get_tblite_version


end module tblite_version

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Gram-Schmidt orthonormalization routines for contracted Gaussian basis functions
module tblite_basis_ortho
   use mctc_env, only : wp
   use mctc_io_constants, only : pi
   use tblite_basis_type, only : cgto_type
   implicit none
   private

   public :: orthogonalize


contains

!> Orthogonalize a contracted Gaussian basis function to an existing basis function
pure subroutine orthogonalize(cgtoi, cgtoj)
   !> Existing basis function
   type(cgto_type), intent(in) :: cgtoi
   !> Basis function to orthogonalize
   type(cgto_type), intent(inout) :: cgtoj

   integer :: ipr, jpr
   real(wp) :: eab, oab, kab, overlap

   if (cgtoi%ang /= cgtoj%ang) return

   overlap = 0.0_wp
   do ipr = 1, cgtoi%nprim
      do jpr = 1, cgtoj%nprim
         eab = cgtoi%alpha(ipr) + cgtoj%alpha(jpr)
         oab = 1.0_wp / eab
         kab = sqrt(pi*oab)**3

         overlap = overlap + cgtoi%coeff(ipr) * cgtoj%coeff(jpr) * kab
      end do
   end do

   cgtoj%alpha(cgtoj%nprim+1:cgtoj%nprim+cgtoi%nprim) = cgtoi%alpha(:cgtoi%nprim)
   cgtoj%coeff(cgtoj%nprim+1:cgtoj%nprim+cgtoi%nprim) = -overlap*cgtoi%coeff(:cgtoi%nprim)
   cgtoj%nprim = cgtoj%nprim + cgtoi%nprim

   overlap = 0.0_wp
   do ipr = 1, cgtoj%nprim
      do jpr = 1, cgtoj%nprim
         eab = cgtoj%alpha(ipr) + cgtoj%alpha(jpr)
         oab = 1.0_wp / eab
         kab = sqrt(pi*oab)**3

         overlap = overlap + cgtoj%coeff(ipr) * cgtoj%coeff(jpr) * kab
      end do
   end do

   cgtoj%coeff(:cgtoj%nprim) = cgtoj%coeff(:cgtoj%nprim) / sqrt(overlap)

end subroutine orthogonalize

end module tblite_basis_ortho

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Isotropic second-order electrostatics using an effective Coulomb operator
module tblite_coulomb_charge_effective
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_math, only : matdet_3x3, matinv_3x3
   use mctc_io_constants, only : pi
   use tblite_blas, only : dot, gemv, symv, gemm
   use tblite_coulomb_cache, only : coulomb_cache
   use tblite_coulomb_ewald, only : get_dir_cutoff, get_rec_cutoff
   use tblite_coulomb_charge_type, only : coulomb_charge_type
   use tblite_cutoff, only : get_lattice_points
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_wignerseitz, only : wignerseitz_cell
   implicit none
   private

   public :: effective_coulomb, new_effective_coulomb
   public :: average_interface, harmonic_average, arithmetic_average, geometric_average


   !> Effective, Klopman-Ohno-type, second-order electrostatics
   type, extends(coulomb_charge_type) :: effective_coulomb
      !> Hubbard parameter for each shell and species
      real(wp), allocatable :: hubbard(:, :, :, :)
      !> Exponent of Coulomb kernel
      real(wp) :: gexp
      !> Long-range cutoff
      real(wp) :: rcut
   contains
      !> Evaluate Coulomb matrix
      procedure :: get_coulomb_matrix
      !> Evaluate uncontracted derivatives of Coulomb matrix
      procedure :: get_coulomb_derivs
   end type effective_coulomb


   abstract interface
      !> Average Hubbard parameter for two shells
      pure function average_interface(gi, gj) result(gij)
         import :: wp
         !> Hubbard parameter of shell i
         real(wp), intent(in) :: gi
         !> Hubbard parameter of shell j
         real(wp), intent(in) :: gj
         !> Averaged Hubbard parameter
         real(wp) :: gij
      end function average_interface
   end interface

   real(wp), parameter :: twopi = 2 * pi
   real(wp), parameter :: sqrtpi = sqrt(pi)
   real(wp), parameter :: eps = sqrt(epsilon(0.0_wp))
   real(wp), parameter :: conv = eps
   character(len=*), parameter :: label = "isotropic Klopman-Ohno electrostatics"

contains

!> Construct new effective electrostatic interaction container
subroutine new_effective_coulomb(self, mol, gexp, hubbard, average, nshell)
   !> Instance of the electrostatic container
   type(effective_coulomb), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Exponent of Coulomb kernel
   real(wp), intent(in) :: gexp
   !> Averaging function for Hubbard parameter of a shell-pair
   procedure(average_interface) :: average
   !> Hubbard parameter for all shells and species
   real(wp), intent(in) :: hubbard(:, :)
   !> Number of shells for each species
   integer, intent(in), optional :: nshell(:)

   integer :: mshell
   integer :: isp, jsp, ish, jsh, ind, iat

   self%label = label
   if (present(nshell)) then
      mshell = maxval(nshell)
      self%nshell = nshell(mol%id)
   else
      mshell = 1
      self%nshell = spread(1, 1, mol%nat)
   end if
   allocate(self%offset(mol%nat))
   ind = 0
   do iat = 1, mol%nat
      self%offset(iat) = ind
      ind = ind + self%nshell(iat)
   end do

   self%gexp = gexp
   self%rcut = 10.0_wp

   if (present(nshell)) then
      allocate(self%hubbard(mshell, mshell, mol%nid, mol%nid))
      do isp = 1, mol%nid
         do jsp = 1, mol%nid
            self%hubbard(:, :, jsp, isp) = 0.0_wp
            do ish = 1, nshell(isp)
               do jsh = 1, nshell(jsp)
                  self%hubbard(jsh, ish, jsp, isp) = &
                     & average(hubbard(ish, isp), hubbard(jsh, jsp))
               end do
            end do
         end do
      end do
   else
      allocate(self%hubbard(1, 1, mol%nid, mol%nid))
      do isp = 1, mol%nid
         do jsp = 1, mol%nid
            self%hubbard(1, 1, jsp, isp) = average(hubbard(1, isp), hubbard(1, jsp))
         end do
      end do
   end if

end subroutine new_effective_coulomb


!> Harmonic averaging functions for hardnesses in GFN1-xTB
pure function harmonic_average(gi, gj) result(gij)
   !> Hubbard parameter of shell i
   real(wp), intent(in) :: gi
   !> Hubbard parameter of shell j
   real(wp), intent(in) :: gj
   !> Averaged Hubbard parameter
   real(wp) :: gij

   gij = 2.0_wp/(1.0_wp/gi+1.0_wp/gj)

end function harmonic_average


!> Arithmetic averaging functions for hardnesses in GFN2-xTB
pure function arithmetic_average(gi, gj) result(gij)
   !> Hubbard parameter of shell i
   real(wp), intent(in) :: gi
   !> Hubbard parameter of shell j
   real(wp), intent(in) :: gj
   !> Averaged Hubbard parameter
   real(wp) :: gij

   gij = 0.5_wp*(gi+gj)

end function arithmetic_average


!> Geometric averaging functions for hardnesses
pure function geometric_average(gi, gj) result(gij)
   !> Hubbard parameter of shell i
   real(wp), intent(in) :: gi
   !> Hubbard parameter of shell j
   real(wp), intent(in) :: gj
   !> Averaged Hubbard parameter
   real(wp) :: gij

   gij = sqrt(gi*gj)

end function geometric_average


!> Evaluate coulomb matrix
subroutine get_coulomb_matrix(self, mol, cache, amat)
   !> Instance of the electrostatic container
   class(effective_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(coulomb_cache), intent(inout) :: cache
   !> Coulomb matrix
   real(wp), contiguous, intent(out) :: amat(:, :)

   amat(:, :) = 0.0_wp

   if (any(mol%periodic)) then
      call get_amat_3d(mol, self%nshell, self%offset, self%hubbard, self%gexp, &
         & self%rcut, cache%wsc, cache%alpha, amat)
   else
      call get_amat_0d(mol, self%nshell, self%offset, self%hubbard, self%gexp, amat)
   end if

end subroutine get_coulomb_matrix


!> Get real lattice vectors
subroutine get_dir_trans(lattice, alpha, conv, trans)
   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)
   !> Parameter for Ewald summation
   real(wp), intent(in) :: alpha
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Translation vectors
   real(wp), allocatable, intent(out) :: trans(:, :)

   call get_lattice_points([.true.], lattice, get_dir_cutoff(alpha, conv), trans)

end subroutine get_dir_trans

!> Get reciprocal lattice translations
subroutine get_rec_trans(lattice, alpha, volume, conv, trans)
   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)
   !> Parameter for Ewald summation
   real(wp), intent(in) :: alpha
   !> Cell volume
   real(wp), intent(in) :: volume
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Translation vectors
   real(wp), allocatable, intent(out) :: trans(:, :)

   real(wp) :: rec_lat(3, 3)

   rec_lat = twopi*transpose(matinv_3x3(lattice))
   call get_lattice_points([.true.], rec_lat, get_rec_cutoff(alpha, volume, conv), trans)
   trans = trans(:, 2:)

end subroutine get_rec_trans


!> Evaluate Coulomb matrix for finite systems
subroutine get_amat_0d(mol, nshell, offset, hubbard, gexp, amat)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells for each atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each shell
   integer, intent(in) :: offset(:)
   !> Hubbard parameter parameter for each shell
   real(wp), intent(in) :: hubbard(:, :, :, :)
   !> Exponent of Coulomb kernel
   real(wp), intent(in) :: gexp
   !> Coulomb matrix
   real(wp), intent(inout) :: amat(:, :)

   integer :: iat, jat, izp, jzp, ii, jj, ish, jsh
   real(wp) :: vec(3), r1, r1g, gam, tmp

   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(amat, mol, nshell, offset, hubbard, gexp) &
   !$omp private(iat, izp, ii, ish, jat, jzp, jj, jsh, gam, vec, r1, r1g, tmp)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         vec = mol%xyz(:, jat) - mol%xyz(:, iat)
         r1 = norm2(vec)
         r1g = r1**gexp
         do ish = 1, nshell(iat)
            do jsh = 1, nshell(jat)
               gam = hubbard(jsh, ish, jzp, izp)
               tmp = 1.0_wp/(r1g + gam**(-gexp))**(1.0_wp/gexp)
               !$omp atomic
               amat(jj+jsh, ii+ish) = amat(jj+jsh, ii+ish) + tmp
               !$omp atomic
               amat(ii+ish, jj+jsh) = amat(ii+ish, jj+jsh) + tmp
            end do
         end do
      end do
      do ish = 1, nshell(iat)
         do jsh = 1, ish-1
            gam = hubbard(jsh, ish, izp, izp)
            !$omp atomic
            amat(ii+jsh, ii+ish) = amat(ii+jsh, ii+ish) + gam
            !$omp atomic
            amat(ii+ish, ii+jsh) = amat(ii+ish, ii+jsh) + gam
         end do
         !$omp atomic
         amat(ii+ish, ii+ish) = amat(ii+ish, ii+ish) + hubbard(ish, ish, izp, izp)
      end do
   end do

end subroutine get_amat_0d

!> Evaluate the coulomb matrix for 3D systems
subroutine get_amat_3d(mol, nshell, offset, hubbard, gexp, rcut, wsc, alpha, amat)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells per atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each atom
   integer, intent(in) :: offset(:)
   !> Hubbard parameter of the shells
   real(wp), intent(in) :: hubbard(:, :, :, :)
   !> Exponent of the interaction kernel
   real(wp), intent(in) :: gexp
   !> Long-range cutoff
   real(wp), intent(in) :: rcut
   !> Wigner-Seitz cell
   type(wignerseitz_cell), intent(in) :: wsc
   !> Convergence factor
   real(wp), intent(in) :: alpha
   !> Coulomb matrix
   real(wp), intent(inout) :: amat(:, :)

   integer :: iat, jat, izp, jzp, img, ii, jj, ish, jsh
   real(wp) :: vec(3), gam, wsw, dtmp, rtmp, vol, aval
   real(wp), allocatable :: dtrans(:, :), rtrans(:, :)

   vol = abs(matdet_3x3(mol%lattice))
   call get_dir_trans(mol%lattice, alpha, conv, dtrans)
   call get_rec_trans(mol%lattice, alpha, vol, conv, rtrans)

   !$omp parallel do default(none) schedule(runtime) shared(amat) &
   !$omp shared(mol, nshell, offset, hubbard, gexp, wsc, dtrans, rtrans, alpha, vol, rcut) &
   !$omp private(iat, izp, jat, jzp, ii, jj, ish, jsh, gam, wsw, vec, dtmp, rtmp, aval)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, iat) - mol%xyz(:, jat) - wsc%trans(:, wsc%tridx(img, jat, iat))
            call get_amat_rec_3d(vec, vol, alpha, 0.0_wp, rtrans, rtmp)
            do ish = 1, nshell(iat)
               do jsh = 1, nshell(jat)
                  gam = hubbard(jsh, ish, jzp, izp)
                  call get_amat_dir_3d(vec, gam, gexp, rcut, alpha, dtrans, dtmp)
                  aval = (dtmp + rtmp) * wsw
                  !$omp atomic
                  amat(jj+jsh, ii+ish) = amat(jj+jsh, ii+ish) + aval
                  !$omp atomic
                  amat(ii+ish, jj+jsh) = amat(ii+ish, jj+jsh) + aval
               end do
            end do
         end do
      end do

      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec = wsc%trans(:, wsc%tridx(img, iat, iat))
         call get_amat_rec_3d(vec, vol, alpha, 0.0_wp, rtrans, rtmp)
         rtmp = rtmp - 2 * alpha / sqrtpi
         do ish = 1, nshell(iat)
            do jsh = 1, ish-1
               gam = hubbard(jsh, ish, izp, izp)
               call get_amat_dir_3d(vec, gam, gexp, rcut, alpha, dtrans, dtmp)
               aval = (dtmp + rtmp + gam) * wsw
               !$omp atomic
               amat(ii+jsh, ii+ish) = amat(ii+jsh, ii+ish) + aval
               !$omp atomic
               amat(ii+ish, ii+jsh) = amat(ii+ish, ii+jsh) + aval
            end do
            gam = hubbard(ish, ish, izp, izp)
            call get_amat_dir_3d(vec, gam, gexp, rcut, alpha, dtrans, dtmp)
            aval = (dtmp + rtmp + gam) * wsw
            !$omp atomic
            amat(ii+ish, ii+ish) = amat(ii+ish, ii+ish) + aval
         end do
      end do

   end do

end subroutine get_amat_3d

!> Calculate real space contributions for a pair under 3D periodic boundary conditions
subroutine get_amat_dir_3d(rij, gam, gexp, rcut, alp, trans, amat)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Hubbard parameter
   real(wp), intent(in) :: gam
   !> Exponent for interaction kernel
   real(wp), intent(in) :: gexp
   !> Long-range cutoff
   real(wp), intent(in) :: rcut
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Interaction matrix element
   real(wp), intent(out) :: amat

   integer :: itr
   real(wp) :: vec(3), r1, tmp, fcut

   amat = 0.0_wp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      fcut = fsmooth(r1, rcut)
      tmp = fcut/(r1**gexp + gam**(-gexp))**(1.0_wp/gexp) + (1.0_wp-fcut)/r1 &
         & - erf(alp*r1)/r1
      amat = amat + tmp
   end do

end subroutine get_amat_dir_3d

!> Calculate reciprocal space contributions for a pair under 3D periodic boundary conditions
subroutine get_amat_rec_3d(rij, vol, alp, qpc, trans, amat)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Volume of cell
   real(wp), intent(in) :: vol
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Pseudo-quadrupole contribution
   real(wp), intent(in) :: qpc
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Interaction matrix element
   real(wp), intent(out) :: amat

   integer :: itr
   real(wp) :: fac, vec(3), g2, tmp, gv, expk, cosk

   amat = 0.0_wp
   fac = 4*pi/vol

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      gv = dot_product(rij, vec)
      expk = fac * exp(-0.25_wp*g2/(alp*alp))/g2
      cosk = cos(gv) * expk
      amat = amat + cosk
   end do

end subroutine get_amat_rec_3d

function fsmooth(r1, rcut) result(fcut)
   real(wp), intent(in) :: r1
   real(wp), intent(in) :: rcut
   real(wp) :: fcut

   real(wp), parameter :: offset = 1.0_wp
   real(wp), parameter :: c(*) = [-6.0_wp, 15.0_wp, -10.0_wp, 1.0_wp]
   real(wp) :: xrel

   if (r1 < rcut - offset) then
      fcut = 1.0_wp
   else if (r1 > rcut) then
      fcut = 0.0_wp
   else
      xrel = (r1 - (rcut - offset)) / offset
      fcut = c(1)*xrel**5 + c(2)*xrel**4 + c(3)*xrel**3 + c(4)
   end if
end function fsmooth

function dsmooth(r1, rcut) result(dcut)
   real(wp), intent(in) :: r1
   real(wp), intent(in) :: rcut
   real(wp) :: dcut

   real(wp), parameter :: offset = 1.0_wp
   real(wp), parameter :: c(*) = [-6.0_wp, 15.0_wp, -10.0_wp, 1.0_wp]
   real(wp) :: xrel

   if (r1 < rcut - offset .or. r1 > rcut) then
      dcut = 0.0_wp
   else
      xrel = (r1 - (rcut - offset)) / offset
      dcut = (5*c(1)*xrel**4 + 4*c(2)*xrel**3 + 3*c(3)*xrel**2) / offset
   end if

end function dsmooth


!> Evaluate uncontracted derivatives of Coulomb matrix
subroutine get_coulomb_derivs(self, mol, cache, qat, qsh, dadr, dadL, atrace)
   !> Instance of the electrostatic container
   class(effective_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(coulomb_cache), intent(inout) :: cache
   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)
   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)
   !> Derivative of interactions with respect to cartesian displacements
   real(wp), contiguous, intent(out) :: dadr(:, :, :)
   !> Derivative of interactions with respect to strain deformations
   real(wp), contiguous, intent(out) :: dadL(:, :, :)
   !> On-site derivatives with respect to cartesian displacements
   real(wp), contiguous, intent(out) :: atrace(:, :)

   if (any(mol%periodic)) then
      call get_damat_3d(mol, self%nshell, self%offset, self%hubbard, self%gexp, &
         & self%rcut, cache%wsc, cache%alpha, qsh, dadr, dadL, atrace)
   else
      call get_damat_0d(mol, self%nshell, self%offset, self%hubbard, self%gexp, qsh, &
         & dadr, dadL, atrace)
   end if

end subroutine get_coulomb_derivs


!> Evaluate uncontracted derivatives of Coulomb matrix for finite system
subroutine get_damat_0d(mol, nshell, offset, hubbard, gexp, qvec, dadr, dadL, atrace)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells for each atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each shell
   integer, intent(in) :: offset(:)
   !> Hubbard parameter for each shell and species
   real(wp), intent(in) :: hubbard(:, :, :, :)
   !> Exponent of Coulomb kernel
   real(wp), intent(in) :: gexp
   !> Partial charge vector
   real(wp), intent(in) :: qvec(:)
   !> Derivative of interactions with respect to cartesian displacements
   real(wp), intent(out) :: dadr(:, :, :)
   !> Derivative of interactions with respect to strain deformations
   real(wp), intent(out) :: dadL(:, :, :)
   !> On-site derivatives with respect to cartesian displacements
   real(wp), intent(out) :: atrace(:, :)

   integer :: iat, jat, izp, jzp, ii, jj, ish, jsh
   real(wp) :: vec(3), r1, gam, arg, dtmp, dG(3), dS(3, 3)
   real(wp), allocatable :: itrace(:, :), didr(:, :, :), didL(:, :, :)

   atrace(:, :) = 0.0_wp
   dadr(:, :, :) = 0.0_wp
   dadL(:, :, :) = 0.0_wp

   !$omp parallel default(none) &
   !$omp shared(atrace, dadr, dadL, mol, qvec, hubbard, nshell, offset, gexp) &
   !$omp private(iat, izp, ii, ish, jat, jzp, jj, jsh, gam, r1, vec, dG, dS, dtmp, arg) &
   !$omp private(itrace, didr, didL)
   itrace = atrace
   didr = dadr
   didL = dadL
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         vec = mol%xyz(:, iat) - mol%xyz(:, jat)
         r1 = norm2(vec)
         do ish = 1, nshell(iat)
            do jsh = 1, nshell(jat)
               gam = hubbard(jsh, ish, jzp, izp)
               dtmp = 1.0_wp / (r1**gexp + gam**(-gexp))
               dtmp = -r1**(gExp-2.0_wp) * dtmp * dtmp**(1.0_wp/gExp)
               dG = dtmp*vec
               dS = spread(dG, 1, 3) * spread(vec, 2, 3)
               itrace(:, ii+ish) = +dG*qvec(jj+jsh) + itrace(:, ii+ish)
               itrace(:, jj+jsh) = -dG*qvec(ii+ish) + itrace(:, jj+jsh)
               didr(:, iat, jj+jsh) = +dG*qvec(ii+ish) + didr(:, iat, jj+jsh)
               didr(:, jat, ii+ish) = -dG*qvec(jj+jsh) + didr(:, jat, ii+ish)
               didL(:, :, jj+jsh) = +dS*qvec(ii+ish) + didL(:, :, jj+jsh)
               didL(:, :, ii+ish) = +dS*qvec(jj+jsh) + didL(:, :, ii+ish)
            end do
         end do
      end do
   end do
   !$omp critical (get_damat_0d_)
   atrace(:, :) = atrace + itrace
   dadr(:, :, :) = dadr + didr
   dadL(:, :, :) = dadL + didL
   !$omp end critical (get_damat_0d_)
   !$omp end parallel

end subroutine get_damat_0d

!> Evaluate uncontracted derivatives of Coulomb matrix for 3D periodic system
subroutine get_damat_3d(mol, nshell, offset, hubbard, gexp, rcut, wsc, alpha, qvec, &
      & dadr, dadL, atrace)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells for each atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each shell
   integer, intent(in) :: offset(:)
   !> Hubbard parameter for each shell and species
   real(wp), intent(in) :: hubbard(:, :, :, :)
   !> Exponent of Coulomb kernel
   real(wp), intent(in) :: gexp
   !> Long-range cutoff
   real(wp), intent(in) :: rcut
   !> Wigner-Seitz image information
   type(wignerseitz_cell), intent(in) :: wsc
   !> Convergence factor for Ewald sum
   real(wp), intent(in) :: alpha
   !> Partial charge vector
   real(wp), intent(in) :: qvec(:)
   !> Derivative of interactions with respect to cartesian displacements
   real(wp), intent(out) :: dadr(:, :, :)
   !> Derivative of interactions with respect to strain deformations
   real(wp), intent(out) :: dadL(:, :, :)
   !> On-site derivatives with respect to cartesian displacements
   real(wp), intent(out) :: atrace(:, :)

   integer :: iat, jat, izp, jzp, img, ii, jj, ish, jsh
   real(wp) :: vol, gam, wsw, vec(3), dG(3), dS(3, 3)
   real(wp) :: dGd(3), dSd(3, 3), dGr(3), dSr(3, 3)
   real(wp), allocatable :: itrace(:, :), didr(:, :, :), didL(:, :, :)
   real(wp), allocatable :: dtrans(:, :), rtrans(:, :)

   atrace(:, :) = 0.0_wp
   dadr(:, :, :) = 0.0_wp
   dadL(:, :, :) = 0.0_wp

   vol = abs(matdet_3x3(mol%lattice))
   call get_dir_trans(mol%lattice, alpha, conv, dtrans)
   call get_rec_trans(mol%lattice, alpha, vol, conv, rtrans)

   !$omp parallel default(none) shared(atrace, dadr, dadL) &
   !$omp shared(mol, wsc, alpha, vol, dtrans, rtrans, qvec, hubbard, nshell, offset, gexp, &
   !$omp& rcut) private(iat, izp, jat, jzp, img, ii, jj, ish, jsh, gam, wsw, vec, dG, dS, &
   !$omp& dGr, dSr, dGd, dSd, itrace, didr, didL)
   itrace = atrace
   didr = dadr
   didL = dadL
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, iat) - mol%xyz(:, jat) - wsc%trans(:, wsc%tridx(img, jat, iat))
            wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
            call get_damat_rec_3d(vec, vol, alpha, 0.0_wp, rtrans, dGr, dSr)
            do ish = 1, nshell(iat)
               do jsh = 1, nshell(jat)
                  gam = hubbard(jsh, ish, jzp, izp)
                  call get_damat_dir_3d(vec, gam, gexp, rcut, alpha, dtrans, dGd, dSd)
                  dG = (dGd + dGr) * wsw
                  dS = (dSd + dSr) * wsw
                  itrace(:, ii+ish) = +dG*qvec(jj+jsh) + itrace(:, ii+ish)
                  itrace(:, jj+jsh) = -dG*qvec(ii+ish) + itrace(:, jj+jsh)
                  didr(:, iat, jj+jsh) = +dG*qvec(ii+ish) + didr(:, iat, jj+jsh)
                  didr(:, jat, ii+ish) = -dG*qvec(jj+jsh) + didr(:, jat, ii+ish)
                  didL(:, :, jj+jsh) = +dS*qvec(ii+ish) + didL(:, :, jj+jsh)
                  didL(:, :, ii+ish) = +dS*qvec(jj+jsh) + didL(:, :, ii+ish)
               end do
            end do
         end do
      end do

      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec = wsc%trans(:, wsc%tridx(img, iat, iat))
         call get_damat_rec_3d(vec, vol, alpha, 0.0_wp, rtrans, dGr, dSr)
         do ish = 1, nshell(iat)
            do jsh = 1, ish-1
               gam = hubbard(jsh, ish, izp, izp)
               call get_damat_dir_3d(vec, gam, gexp, rcut, alpha, dtrans, dGd, dSd)
               dS = (dSd + dSr) * wsw
               didL(:, :, ii+jsh) = +dS*qvec(ii+ish) + didL(:, :, ii+jsh)
               didL(:, :, ii+ish) = +dS*qvec(ii+jsh) + didL(:, :, ii+ish)
            end do
            gam = hubbard(ish, ish, izp, izp)
            call get_damat_dir_3d(vec, gam, gexp, rcut, alpha, dtrans, dGd, dSd)
            dS = (dSd + dSr) * wsw
            didL(:, :, ii+ish) = +dS*qvec(ii+ish) + didL(:, :, ii+ish)
         end do
      end do
   end do
   !$omp critical (get_damat_3d_)
   atrace(:, :) = atrace + itrace
   dadr(:, :, :) = dadr + didr
   dadL(:, :, :) = dadL + didL
   !$omp end critical (get_damat_3d_)
   !$omp end parallel

end subroutine get_damat_3d

!> Calculate real space contributions for a pair under 3D periodic boundary conditions
subroutine get_damat_dir_3d(rij, gam, gexp, rcut, alp, trans, dg, ds)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Hubbard parameter
   real(wp), intent(in) :: gam
   !> Exponent for interaction kernel
   real(wp), intent(in) :: gexp
   !> Long-range cutoff
   real(wp), intent(in) :: rcut
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Derivative with respect to cartesian displacements
   real(wp), intent(out) :: dg(3)
   !> Derivative with respect to strain deformations
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr
   real(wp) :: vec(3), r1, r2, gtmp, atmp, alp2, fcut, dcut

   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp

   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      r2 = r1*r1
      fcut = fsmooth(r1, rcut)
      dcut = dsmooth(r1, rcut)
      gtmp = 1.0_wp / (r1**gexp + gam**(-gexp))
      gtmp = -r1**(gexp-2.0_wp) * gtmp * gtmp**(1.0_wp/gexp) * fcut - (1.0_wp-fcut)/(r2*r1) &
         & + dcut * (gtmp**(1.0_wp/gexp) * r1 - 1.0_wp) / r2
      atmp = -2*alp*exp(-r2*alp2)/(sqrtpi*r2) + erf(r1*alp)/(r2*r1)
      dg(:) = dg + (gtmp + atmp) * vec
      ds(:, :) = ds + (gtmp + atmp) * spread(vec, 1, 3) * spread(vec, 2, 3)
   end do

end subroutine get_damat_dir_3d

!> Calculate reciprocal space contributions for a pair under 3D periodic boundary conditions
subroutine get_damat_rec_3d(rij, vol, alp, qpc, trans, dg, ds)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Cell volume
   real(wp), intent(in) :: vol
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Pseudo-quadrupole contribution
   real(wp), intent(in) :: qpc
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Derivative with respect to cartesian displacements
   real(wp), intent(out) :: dg(3)
   !> Derivative with respect to strain deformations
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr
   real(wp) :: fac, vec(3), g2, gv, expk, sink, cosk, alp2, fqp
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], shape(unity))

   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp
   fac = 4*pi/vol
   alp2 = alp*alp
   fqp = 2*qpc*qpc

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      gv = dot_product(rij, vec)
      expk = fac * exp(-0.25_wp*g2/alp2)/g2
      cosk = cos(gv) * expk
      sink = sin(gv) * expk
      dg(:) = dg - sink * vec
      ds(:, :) = ds + cosk &
         & * ((2.0_wp/g2 + 0.5_wp/alp2 + 0.5_wp*fqp) * spread(vec, 1, 3)*spread(vec, 2, 3) &
         &     - unity * (1.0_wp + g2*fqp))
   end do

end subroutine get_damat_rec_3d


end module tblite_coulomb_charge_effective

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_solvation_surface
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use mctc_io_convert, only : aatoau, kcaltoau
   use mstore, only : get_structure
   use tblite_container, only : container_cache
   use tblite_mesh_lebedev, only : grid_size
   use tblite_scf_potential, only : potential_type
   use tblite_solvation_cds
   use tblite_solvation_data
   use tblite_solvation_surface
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: collect_solvation_surface

   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

   real(wp), parameter :: tension_water(20) = 1.0e-5_wp * [&
      &-0.08499967_wp, 0.46780225_wp,-2.87013596_wp,-3.95935069_wp,-0.29783987_wp, &
      &-0.48323273_wp, 0.00133622_wp, 0.20448945_wp, 0.20150600_wp, 0.36379863_wp, &
      &-3.47082133_wp,-0.93451053_wp,-1.46342018_wp,-0.32774697_wp,-0.38015204_wp, &
      &-0.35311116_wp,-0.19972593_wp,-0.12891363_wp,-1.19450558_wp,-1.61289300_wp]
   real(wp), parameter :: hbond_water(20) = -kcaltoau * [&
      & 6.70894947_wp, 0.00000000_wp, 0.00000000_wp, 0.00000000_wp, 0.00000000_wp, &
      & 1.26459036_wp, 3.52206160_wp, 2.30440543_wp, 1.98829409_wp, 0.00000000_wp, &
      & 0.00000000_wp, 0.00000000_wp, 0.00000000_wp, 0.00000000_wp, 2.68116653_wp, &
      & 0.38262428_wp, 1.02948365_wp, 0.00000000_wp, 0.00000000_wp, 0.00000000_wp]**2
contains


!> Collect all exported unit tests
subroutine collect_solvation_surface(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("surface-1", test_mb01), &
      new_unittest("surface-2", test_mb02), &
      new_unittest("surface-3", test_mb03), &
      new_unittest("surface-4", test_mb04), &
      new_unittest("sasa-e", test_e_sasa), &
      new_unittest("sasa-g", test_g_sasa), &
      new_unittest("sasa-p", test_p_sasa) &
      ]

end subroutine collect_solvation_surface


subroutine test_numg(error, sasa, mol)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Surface integrator
   type(surface_integrator), intent(inout) :: sasa
   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   integer :: iat, ic
   real(wp), allocatable :: surface(:), sr(:), sl(:), dsdr(:, :, :), numg(:, :, :)
   real(wp), parameter :: step = 1.0e-5_wp

   allocate(surface(mol%nat), sr(mol%nat), sl(mol%nat))
   allocate(dsdr(3, mol%nat, mol%nat), numg(3, mol%nat, mol%nat))

   call sasa%get_surface(mol, surface, dsdr)

   do iat = 1, mol%nat
      do ic = 1, 3
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call sasa%get_surface(mol, sr)

         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2*step
         call sasa%get_surface(mol, sl)

         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step

         numg(ic, iat, :) = 0.5_wp * (sr - sl) / step
      end do
   end do

   if (any(abs(numg - dsdr) > thr2)) then
      call test_failed(error, "Surface derivative does not much finite difference solution")
   end if
end subroutine test_numg


subroutine test_mb01(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(surface_integrator) :: sasa
   real(wp), allocatable :: rad(:), surface(:), dsdr(:, :, :)
   real(wp), parameter :: probe = 1.4_wp * aatoau
   integer, parameter :: nang = 110
   real(wp), parameter :: ref(16) = [&
      & 1.98249964115938E+2_wp, 9.34967917451750E+1_wp, 7.26746426166825E+1_wp, &
      & 3.72308704194178E+1_wp, 1.00057039382294E+2_wp, 8.72703799067120E+1_wp, &
      & 1.75563552659476E+1_wp, 5.79324044451170E+1_wp, 9.81702069377092E-3_wp, &
      & 1.05256238709304E+2_wp, 6.62363239088925E+1_wp, 1.44944527871945E+2_wp, &
      & 3.33346854609299E+1_wp, 5.79746583890200E+1_wp, 6.69252987306994E+0_wp, &
      & 4.86484695123678E+1_wp]

   call get_structure(mol, "MB16-43", "01")

   allocate(surface(mol%nat), dsdr(3, mol%nat, mol%nat))
   rad = get_vdw_rad_d3(mol%num)

   call new_surface_integrator(sasa, mol%id, rad, probe, nang)
   call sasa%get_surface(mol, surface, dsdr)

   if (any(abs(surface - ref) > thr2)) then
      call test_failed(error, "Surface area values do not match")
      print '(es20.14e1)', surface
      return
   end if

   call test_numg(error, sasa, mol)

end subroutine test_mb01


subroutine test_mb02(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(surface_integrator) :: sasa
   real(wp), allocatable :: rad(:), surface(:), dsdr(:, :, :)
   real(wp), parameter :: probe = 1.2_wp * aatoau
   integer, parameter :: nang = 230
   real(wp), parameter :: ref(16) = [&
      & 2.86084867409084E+1_wp, 7.50937554738823E+1_wp, 8.05879870633801E+1_wp, &
      & 8.24020440071839E+1_wp, 6.48136730333555E+1_wp, 1.97586790838718E+1_wp, &
      & 4.90632286612891E+1_wp, 5.29220735196209E+1_wp, 9.14599027767086E+1_wp, &
      & 1.38294851038605E+1_wp, 9.02032750404975E+1_wp, 1.13713659886359E+2_wp, &
      & 9.83820273872444E+1_wp, 5.95926059064588E+1_wp, 2.96614651477179E+0_wp, &
      & 1.44874751678823E+2_wp]

   call get_structure(mol, "MB16-43", "02")

   allocate(surface(mol%nat), dsdr(3, mol%nat, mol%nat))
   rad = get_vdw_rad_bondi(mol%num)

   call new_surface_integrator(sasa, mol%id, rad, probe, nang)
   call sasa%get_surface(mol, surface, dsdr)

   if (any(abs(surface - ref) > thr2)) then
      call test_failed(error, "Surface area values do not match")
      print '(es20.14e1)', surface
      return
   end if

   call test_numg(error, sasa, mol)

end subroutine test_mb02


subroutine test_mb03(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(surface_integrator) :: sasa
   real(wp), allocatable :: rad(:), surface(:), dsdr(:, :, :)
   real(wp), parameter :: probe = 0.2_wp * aatoau
   integer, parameter :: nang = 111
   real(wp), parameter :: ref(16) = [&
      & 4.93447390062137E+1_wp, 5.42387848008597E+1_wp, 2.58043996919982E+1_wp, &
      & 3.26892802882332E+1_wp, 1.27988011902719E+1_wp, 9.45810634328472E+1_wp, &
      & 3.43532468932011E+1_wp, 2.76341415226557E+1_wp, 2.74903763271451E+1_wp, &
      & 2.85813017380994E+1_wp, 7.99313006099443E+1_wp, 1.26258175368922E+2_wp, &
      & 5.38016574327888E+1_wp, 4.16287245551897E+1_wp, 9.95930646163274E+1_wp, &
      & 2.36024718010776E+1_wp]

   call get_structure(mol, "MB16-43", "03")

   allocate(surface(mol%nat), dsdr(3, mol%nat, mol%nat))
   rad = get_vdw_rad_cosmo(mol%num)

   call new_surface_integrator(sasa, mol%id, rad, probe, nang)
   call sasa%get_surface(mol, surface, dsdr)

   if (any(abs(surface - ref) > thr2)) then
      call test_failed(error, "Surface area values do not match")
      print '(es20.14e1)', surface
      return
   end if

   call test_numg(error, sasa, mol)

end subroutine test_mb03


subroutine test_mb04(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(surface_integrator) :: sasa
   integer :: iang
   real(wp) :: this_thr
   real(wp), allocatable :: rad(:), surface(:), dsdr(:, :, :)
   real(wp), parameter :: probe = 1.4_wp * aatoau
   real(wp), parameter :: ref(16) = [&
      & 3.17888246831669E+1_wp, 1.10843192647448E+2_wp, 6.88322051937029E+1_wp, &
      & 1.14544539434107E+2_wp, 1.70720777045875E+2_wp, 3.13678105884819E+1_wp, &
      & 4.58475695169198E+1_wp, 1.93179973322729E+2_wp, 6.00038959489535E+1_wp, &
      & 6.11241830519643E+1_wp, 4.51433360077588E+1_wp, 9.79240756407461E+0_wp, &
      & 1.11790314128626E+2_wp, 3.26024197541769E+1_wp, 7.04914424301540E+1_wp, &
      & 7.70033481249225E+1_wp]

   call get_structure(mol, "MB16-43", "04")

   allocate(surface(mol%nat), dsdr(3, mol%nat, mol%nat))
   rad = get_vdw_rad_bondi(mol%num)

   do iang = 1, size(grid_size)
      call new_surface_integrator(sasa, mol%id, rad, probe, grid_size(iang))
      call sasa%get_surface(mol, surface, dsdr)

      if (grid_size(iang) > 1000) then
         this_thr = 0.1_wp
      else if (grid_size(iang) > 250) then
         this_thr = 1.0_wp
      else if (grid_size(iang) > 75) then
         this_thr = 10.0_wp
      else
         cycle
      end if
      call check(error, 0.0_wp, norm2(abs(surface - ref)), thr=this_thr)
      if (allocated(error)) return
   end do

   if (any(abs(surface - ref) > thr2)) then
      call test_failed(error, "Surface area values do not match")
      print '(es20.14e1)', surface
      return
   end if

end subroutine test_mb04


subroutine test_e(error, mol, input, qat, ref)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Solvation model input
   type(cds_input), intent(in) :: input

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Reference energy
   real(wp), intent(in) :: ref

   type(cds_solvation) :: solv
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp) :: energy(mol%nat)

   energy = 0.0_wp
   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))

   solv = cds_solvation(mol, input)

   call solv%update(mol, cache)
   call solv%get_engrad(mol, cache, energy)
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)

   if (abs(sum(energy) - ref) > thr) then
      call test_failed(error, "Energy does not match reference")
      print *, sum(energy)
   end if
end subroutine test_e


subroutine test_g(error, mol, input, qat)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Solvation model input
   type(cds_input), intent(in) :: input

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   type(cds_solvation) :: solv
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp), allocatable :: gradient(:, :), numg(:, :)
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat), sigma(3, 3)
   integer :: ii, ic

   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))

   solv = cds_solvation(mol, input)

   allocate(numg(3, mol%nat), gradient(3, mol%nat))
   do ii = 1, mol%nat
      do ic = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(ic, ii) = mol%xyz(ic, ii) + step
         call solv%update(mol, cache)
         call solv%get_engrad(mol, cache, er)
         call solv%get_potential(mol, cache, wfn, pot)
         call solv%get_energy(mol, cache, wfn, er)

         mol%xyz(ic, ii) = mol%xyz(ic, ii) - 2*step
         call solv%update(mol, cache)
         call solv%get_engrad(mol, cache, el)
         call solv%get_potential(mol, cache, wfn, pot)
         call solv%get_energy(mol, cache, wfn, el)

         mol%xyz(ic, ii) = mol%xyz(ic, ii) + step
         numg(ic, ii) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call solv%update(mol, cache)
   call solv%get_engrad(mol, cache, energy, gradient, sigma)
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)
   call solv%get_gradient(mol, cache, wfn, gradient, sigma)

   if (any(abs(gradient - numg) > thr)) then
      call test_failed(error, "Gradient does not match")
      print '(3es20.13)', gradient
      print '(a)', "---"
      print '(3es20.13)', numg
      print '(a)', "---"
      print '(3es20.13)', gradient - numg
   end if
end subroutine test_g


subroutine test_p(error, mol, input, qat)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Solvation model input
   type(cds_input), intent(in) :: input

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   type(cds_solvation) :: solv
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp), parameter :: thr = 1e+3_wp*sqrt(epsilon(1.0_wp))
   real(wp), allocatable :: vat(:)
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat)
   integer :: ii

   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))

   solv = cds_solvation(mol, input)

   call solv%update(mol, cache)

   allocate(vat(mol%nat))
   do ii = 1, mol%nat
      er = 0.0_wp
      el = 0.0_wp
      wfn%qat(ii, 1) = wfn%qat(ii, 1) + step
      call solv%get_potential(mol, cache, wfn, pot)
      call solv%get_energy(mol, cache, wfn, er)

      wfn%qat(ii, 1) = wfn%qat(ii, 1) - 2*step
      call solv%get_potential(mol, cache, wfn, pot)
      call solv%get_energy(mol, cache, wfn, el)

      wfn%qat(ii, 1) = wfn%qat(ii, 1) + step
      vat(ii) = 0.5_wp*(sum(er) - sum(el))/step
   end do

   energy = 0.0_wp
   pot%vat(:, :) = 0.0_wp
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)

   if (any(abs([pot%vat] - vat) > thr)) then
      call test_failed(error, "Potential does not match")
      print '(3es20.13)', pot%vat
      print '(a)', "---"
      print '(3es20.13)', vat
      print '(a)', "---"
      print '(3es20.13)', [pot%vat] - vat
   end if
end subroutine test_p


subroutine test_e_sasa(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-8.99890404486076E-2_wp, 9.42168087556583E-2_wp,-1.49387631509499E-1_wp, &
      &-2.99114121895542E-1_wp, 4.85527734875224E-1_wp,-6.83156326406137E-2_wp, &
      & 1.50011293889337E-2_wp, 2.79368544459465E-1_wp,-1.24072452878322E-1_wp, &
      &-9.36760994051244E-2_wp,-2.19062123031622E-1_wp, 2.14538817685587E-1_wp, &
      & 3.06156726072831E-1_wp,-3.86105514712244E-1_wp,-1.51265171389388E-3_wp, &
      & 3.64255069977693E-2_wp]
   real(wp), allocatable :: rad(:), tension(:), hbond(:)

   call get_structure(mol, "MB16-43", "04")
   rad = get_vdw_rad_cosmo(mol%num)
   tension = tension_water(mol%num)
   hbond = hbond_water(mol%num)

   call test_e(error, mol, cds_input(probe=0.3_wp, nang=110, rad=rad, tension=tension), &
      & qat, -2.0260925782007388E-3_wp)
   if (allocated(error)) return

   call test_e(error, mol, cds_input(probe=0.3_wp, nang=110, rad=rad, tension=tension, &
      & hbond=hbond), qat, -0.21782880741530361_wp)

end subroutine test_e_sasa


subroutine test_g_sasa(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 2.08159387594211E-1_wp,-3.78010519998818E-1_wp, 3.36498247356244E-2_wp, &
      &-4.11556158912895E-1_wp, 8.14928196660512E-2_wp,-2.00886649303053E-1_wp, &
      & 2.44756994282684E-1_wp, 2.54580499189089E-2_wp, 2.59835128092562E-1_wp, &
      & 4.21683321877209E-1_wp, 1.37097163086023E-1_wp, 4.06951664942900E-2_wp, &
      &-1.10955378625897E-1_wp,-6.44033540918074E-2_wp,-1.91525919028143E-1_wp, &
      &-9.54898757869102E-2_wp]
   real(wp), allocatable :: rad(:), tension(:), hbond(:)

   call get_structure(mol, "MB16-43", "06")
   rad = get_vdw_rad_bondi(mol%num)
   tension = tension_water(mol%num)
   hbond = hbond_water(mol%num)
   call test_g(error, mol, cds_input(probe=2.0_wp, nang=110, rad=rad, tension=tension, &
      & hbond=hbond), qat)

end subroutine test_g_sasa


subroutine test_p_sasa(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-2.05668345919710E-1_wp,-3.99553123071811E-1_wp, 3.29242774348191E-1_wp, &
      &-3.11737933844111E-1_wp, 3.58851882478133E-2_wp, 3.21886835736497E-1_wp, &
      & 4.14743455841314E-2_wp, 2.95727359478547E-2_wp,-5.06347224522431E-1_wp, &
      & 3.43067182413129E-1_wp, 6.88373767679515E-1_wp, 7.03357390141253E-2_wp, &
      &-9.62424552888750E-2_wp,-1.32209348056625E-1_wp, 9.78998441832186E-2_wp, &
      &-3.05979982450903E-1_wp]
   real(wp), allocatable :: rad(:), tension(:), hbond(:)

   call get_structure(mol, "MB16-43", "08")
   rad = get_vdw_rad_d3(mol%num)
   tension = tension_water(mol%num)
   hbond = hbond_water(mol%num)
   call test_p(error, mol, cds_input(probe=2.2_wp, nang=110, rad=rad, tension=tension, &
      & hbond=hbond), qat)

end subroutine test_p_sasa


end module test_solvation_surface

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Driver for unit testing
program tester
   use, intrinsic :: iso_fortran_env, only : error_unit
   use mctc_env, only : get_argument
   use mctc_env_testing, only : run_testsuite, new_testsuite, testsuite_type, &
      & select_suite, run_selected
   use test_cgto_ortho, only : collect_cgto_ortho
   use test_coulomb_charge, only : collect_coulomb_charge
   use test_coulomb_multipole, only : collect_coulomb_multipole
   use test_fit, only : collect_fit
   use test_gfn1_xtb, only : collect_gfn1_xtb
   use test_gfn2_xtb, only : collect_gfn2_xtb
   use test_hamiltonian, only : collect_hamiltonian
   use test_halogen, only : collect_halogen
   use test_integral_multipole, only : collect_integral_multipole
   use test_integral_overlap, only : collect_integral_overlap
   use test_ipea1_xtb, only : collect_ipea1_xtb
   use test_ncoord_gfn, only : collect_ncoord_gfn
   use test_repulsion, only : collect_repulsion
   use test_slater_expansion, only : collect_slater_expansion
   use test_spin, only : collect_spin
   use test_solvation_born, only : collect_solvation_born
   use test_solvation_cpcm, only : collect_solvation_cpcm
   use test_solvation_surface, only : collect_solvation_surface
   use test_tagged_io, only : collect_tagged_io
   use test_xtb_external, only : collect_xtb_external
   use test_xtb_param, only : collect_xtb_param
   implicit none
   integer :: stat, is
   character(len=:), allocatable :: suite_name, test_name
   type(testsuite_type), allocatable :: testsuites(:)
   character(len=*), parameter :: fmt = '("#", *(1x, a))'

   stat = 0

   testsuites = [ &
      new_testsuite("tagged-io", collect_tagged_io), &
      new_testsuite("fit", collect_fit), &
      new_testsuite("repulsion", collect_repulsion), &
      new_testsuite("ncoord-gfn", collect_ncoord_gfn), &
      new_testsuite("solvation-born", collect_solvation_born), &
      new_testsuite("solvation-cpcm", collect_solvation_cpcm), &
      new_testsuite("solvation-surface", collect_solvation_surface), &
      new_testsuite("coulomb-charge", collect_coulomb_charge), &
      new_testsuite("coulomb-multipole", collect_coulomb_multipole), &
      new_testsuite("slater-expansion", collect_slater_expansion), &
      new_testsuite("cgto-ortho", collect_cgto_ortho), &
      new_testsuite("integral-overlap", collect_integral_overlap), &
      new_testsuite("integral-multipole", collect_integral_multipole), &
      new_testsuite("hamiltonian", collect_hamiltonian), &
      new_testsuite("halogen", collect_halogen), &
      new_testsuite("gfn1-xtb", collect_gfn1_xtb), &
      new_testsuite("ipea1-xtb", collect_ipea1_xtb), &
      new_testsuite("gfn2-xtb", collect_gfn2_xtb), &
      new_testsuite("xtb-external", collect_xtb_external), &
      new_testsuite("spin", collect_spin), &
      new_testsuite("xtb-param", collect_xtb_param) &
      ]

   call get_argument(1, suite_name)
   call get_argument(2, test_name)

   if (allocated(suite_name)) then
      is = select_suite(testsuites, suite_name)
      if (is > 0 .and. is <= size(testsuites)) then
         if (allocated(test_name)) then
            write(error_unit, fmt) "Suite:", testsuites(is)%name
            call run_selected(testsuites(is)%collect, test_name, error_unit, stat)
            if (stat < 0) then
               error stop 1
            end if
         else
            write(error_unit, fmt) "Testing:", testsuites(is)%name
            call run_testsuite(testsuites(is)%collect, error_unit, stat)
         end if
      else
         write(error_unit, fmt) "Available testsuites"
         do is = 1, size(testsuites)
            write(error_unit, fmt) "-", testsuites(is)%name
         end do
         error stop 1
      end if
   else
      do is = 1, size(testsuites)
         write(error_unit, fmt) "Testing:", testsuites(is)%name
         call run_testsuite(testsuites(is)%collect, error_unit, stat)
      end do
   end if

   if (stat > 0) then
      write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
      error stop 1
   end if


end program tester

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_timer
   use mctc_env_accuracy, only : wp, i8
   use tblite_output_format, only : format_string
   implicit none
   private

   public :: timer_type, format_time

   type :: time_record
      character(len=:), allocatable :: label
      logical :: running = .false.
      real(wp) :: time = 0.0_wp
   end type time_record

   type :: timer_type
      integer :: n = 0
      character(len=:), allocatable :: last
      type(time_record), allocatable :: record(:)
   contains
      procedure :: push
      procedure :: pop
      procedure :: get
   end type timer_type

contains


subroutine push(self, label)
   class(timer_type), intent(inout) :: self
   character(len=*), intent(in) :: label

   integer :: it

   if (.not.allocated(self%record)) call resize(self%record)
   it = find(self%record(:self%n), label)

   if (it == 0) then
      if (self%n >= size(self%record)) then
         call resize(self%record)
      end if

      self%n = self%n + 1
      it = self%n
      self%record(it) = time_record(label)
   end if

   associate(record => self%record(it))
      self%last = record%label
      record%time = record%time + timing() * merge(+1, -1, record%running)
      record%running = .not.record%running
   end associate
end subroutine push


subroutine pop(self)
   class(timer_type), intent(inout) :: self

   integer :: it

   if (.not.allocated(self%record)) return
   it = find(self%record(:self%n), self%last)
   if (it == 0) return

   associate(record => self%record(it))
      record%time = record%time + timing() * merge(+1, -1, record%running)
      record%running = .not.record%running
   end associate
   if (allocated(self%last)) deallocate(self%last)
end subroutine pop


function get(self, label) result(time)
   class(timer_type), intent(in) :: self
   character(len=*), intent(in) :: label
   real(wp) :: time

   integer :: it

   time = 0.0_wp
   if (self%n <= 0) return
   it = find(self%record(:self%n), label)
   if (it == 0) return

   associate(record => self%record(it))
      time = record%time
      if (record%running) then
         time = time + timing()
      end if
   end associate
end function get


pure function find(record, label) result(pos)
   type(time_record), intent(in) :: record(:)
   character(len=*), intent(in), optional :: label
   integer :: pos

   integer :: i

   pos = 0
   if (present(label)) then
      do i = size(record), 1, -1
         if (allocated(record(i)%label)) then
            if (label == record(i)%label) then
               pos = i
               exit
            end if
         end if
      end do
   else
      do i = size(record), 1, -1
         if (record(i)%running) then
            pos = i
            exit
         end if
      end do
   end if
end function find


function format_time(time) result(string)
   real(wp), intent(in) :: time
   character(len=:), allocatable :: string

   real(wp) :: secs
   integer :: mins, hours, days

   secs = time
   days = int(secs/86400.0_wp)
   secs = secs - days*86400.0_wp
   hours = int(secs/3600.0_wp)
   secs = secs - hours*3600.0_wp
   mins = int(secs/60.0_wp)
   secs = time - mins*60.0_wp

   if (days > 0) then
      string = format_string(days, '(i0, " d,")')
   else
      string = repeat(" ", 4)
   end if
   if (hours > 0) then
      string = string // format_string(hours, '(1x, i2, " h,")')
   else
      string = string // repeat(" ", 6)
   end if
   if (mins > 0) then
      string = string // format_string(mins, '(1x, i2, " min,")')
   else
      string = string // repeat(" ", 8)
   end if
   string = string // format_string(secs, '(f6.3)')//" sec"
end function format_time


function timing() result(time)
   real(wp) :: time

   integer(i8) :: time_count, time_rate, time_max
   call system_clock(time_count, time_rate, time_max)
   time = real(time_count, wp)/real(time_rate, wp)
end function timing


!> Reallocate list of timing records
pure subroutine resize(var, n)
   !> Instance of the array to be resized
   type(time_record), allocatable, intent(inout) :: var(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(time_record), allocatable :: tmp(:)
   integer :: this_size, new_size
   integer, parameter :: initial_size = 20

   if (allocated(var)) then
      this_size = size(var, 1)
      call move_alloc(var, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(var(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(var, 1))
      var(:this_size) = tmp(:this_size)
      deallocate(tmp)
   end if

end subroutine resize

end module tblite_timer

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Isotropic third-order onsite correction
module tblite_coulomb_thirdorder
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_container_cache, only : container_cache
   use tblite_coulomb_charge, only : effective_coulomb
   use tblite_coulomb_multipole, only : damped_multipole
   use tblite_coulomb_type, only : coulomb_type
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: onsite_thirdorder, new_onsite_thirdorder

   !> Onsite correction for third-order charge expansion
   type, extends(coulomb_type) :: onsite_thirdorder
      !> Whether the third order contribution is shell-dependent
      logical :: shell_resolved
      !> Number of shell for each atom
      integer, allocatable :: nsh_at(:)
      !> Shell offset for each atom
      integer, allocatable :: ish_at(:)
      !> Hubbard derivatives for each species
      real(wp), allocatable :: hubbard_derivs(:, :)
   contains
      !> Update container cache
      procedure :: update
      !> Get information about density dependent quantities used in the energy
      procedure :: variable_info
      !> Evaluate selfconsistent energy of the interaction
      procedure :: get_energy
      !> Evaluate charge dependent potential shift from the interaction
      procedure :: get_potential
      !> Evaluate gradient contributions from the selfconsistent interaction
      procedure :: get_gradient
   end type onsite_thirdorder

   character(len=*), parameter :: label = "onsite third-order electrostatics"

contains


!> Create new onsite third-order contribution
subroutine new_onsite_thirdorder(self, mol, hubbard_derivs, nshell)
   !> Instance of the electrostatic container
   type(onsite_thirdorder), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Hubbard derivatives
   real(wp), intent(in) :: hubbard_derivs(:, :)
   !> Number of shells for each species
   integer, intent(in), optional :: nshell(:)

   integer :: ind, iat

   self%label = label
   self%hubbard_derivs = hubbard_derivs

   self%shell_resolved = present(nshell)
   if (present(nshell)) then
      self%nsh_at = nshell(mol%id)

      allocate(self%ish_at(mol%nat))
      ind = 0
      do iat = 1, mol%nat
         self%ish_at(iat) = ind
         ind = ind + self%nsh_at(iat)
      end do
   end if

end subroutine new_onsite_thirdorder


!> Update container cache
subroutine update(self, mol, cache)
   !> Instance of the electrostatic container
   class(onsite_thirdorder), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

end subroutine update


!> Evaluate selfconsistent energy of the interaction
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the electrostatic container
   class(onsite_thirdorder), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)

   integer :: iat, izp, ii, ish

   if (self%shell_resolved) then
      do iat = 1, mol%nat
         izp = mol%id(iat)
         ii = self%ish_at(iat)
         do ish = 1, self%nsh_at(iat)
            energies(iat) = energies(iat) &
               & + wfn%qsh(ii+ish, 1)**3 * self%hubbard_derivs(ish, izp) / 3.0_wp
         end do
      end do
   else
      do iat = 1, mol%nat
         izp = mol%id(iat)
         energies(iat) = energies(iat) &
            & + wfn%qat(iat, 1)**3 * self%hubbard_derivs(1, izp) / 3.0_wp
      end do
   end if
end subroutine get_energy


!> Evaluate charge dependent potential shift from the interaction
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the electrostatic container
   class(onsite_thirdorder), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   integer :: iat, izp, ii, ish

   if (self%shell_resolved) then
      do iat = 1, mol%nat
         izp = mol%id(iat)
         ii = self%ish_at(iat)
         do ish = 1, self%nsh_at(iat)
            pot%vsh(ii+ish, 1) = pot%vsh(ii+ish, 1) &
               & + wfn%qsh(ii+ish, 1)**2 * self%hubbard_derivs(ish, izp)
         end do
      end do
   else
      do iat = 1, mol%nat
         izp = mol%id(iat)
         pot%vat(iat, 1) = pot%vat(iat, 1) + wfn%qat(iat, 1)**2 * self%hubbard_derivs(1, izp)
      end do
   end if
end subroutine get_potential


!> Evaluate gradient contributions from the selfconsistent interaction
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the electrostatic container
   class(onsite_thirdorder), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the repulsion energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

end subroutine get_gradient


!> Get information about density dependent quantities used in the energy
pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, atom_resolved, shell_resolved
   !> Instance of the electrostatic container
   class(onsite_thirdorder), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=merge(shell_resolved, atom_resolved, self%shell_resolved))
end function variable_info

end module tblite_coulomb_thirdorder

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of the dispersion corrections
module tblite_param_dispersion
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io_symbols, only : to_number
   use tblite_param_serde, only : serde_record
   use tblite_toml, only : toml_table, get_value, set_value, add_table
   implicit none
   private

   public :: dispersion_record, dispersion_mask, count


   character(len=*), parameter :: k_d3 = "d3", k_d4 = "d4", k_sc = "sc", &
      & k_s6 = "s6", k_s8 = "s8", k_s9 = "s9", k_a1 = "a1", k_a2 = "a2"

   !> Parametrization record specifying the dispersion model
   type, extends(serde_record) :: dispersion_record
      !> Scaling for dipole-dipole (C6) interactions
      real(wp) :: s6
      !> Scaling for dipole-quadrupole (C6) interactions
      real(wp) :: s8
      !> Scaling for critical radius in rational damping function
      real(wp) :: a1
      !> Offset for critical radius in rational damping function
      real(wp) :: a2
      !> Scaling for triple-dipole (C9) interactions
      real(wp) :: s9
      !> Use DFT-D3 type dispersion
      logical :: d3
      !> Use selfconsistent DFT-D4 type dispersion
      logical :: sc
   contains
      generic :: load => load_from_array
      generic :: dump => dump_to_array
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Read parametrization data from parameter array
      procedure, private :: load_from_array
      !> Write parametrization data to parameter array
      procedure, private :: dump_to_array
   end type


   type :: dispersion_mask
   end type dispersion_mask


   interface count
      module procedure :: count_mask
   end interface count


contains


!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(dispersion_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   integer :: stat

   if (.not.any([table%has_key(k_d3), table%has_key(k_d4)])) then
      call fatal_error(error, "Dispersion model not provided in dispersion table")
      return
   end if

   call get_value(table, k_d3, child, requested=.false., stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read D3 dispersion table")
      return
   end if
   self%d3 = associated(child)
   if (.not.associated(child)) then
      call get_value(table, k_d4, child, stat=stat)
      if (stat /= 0) then
         call fatal_error(error, "Cannot read D4 dispersion table")
         return
      end if
      call get_value(child, k_sc, self%sc, .true., stat=stat)
      if (stat /= 0) then
         call fatal_error(error, "Cannot read self-consistency for D4 dispersion")
         return
      end if
   end if

   call get_value(child, k_s6, self%s6, 1.0_wp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read s6 parameter for dispersion")
      return
   end if
   call get_value(child, k_s8, self%s8, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read s8 parameter for dispersion")
      return
   end if
   call get_value(child, k_a1, self%a1, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read a1 parameter for dispersion")
      return
   end if
   call get_value(child, k_a2, self%a2, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read a2 parameter for dispersion")
      return
   end if
   call get_value(child, k_s9, self%s9, 0.0_wp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read s9 parameter for dispersion")
      return
   end if
end subroutine load_from_toml


!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(dispersion_record), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   call add_table(table, merge(k_d3, k_d4, self%d3), child)
   if (.not.self%d3) call set_value(child, k_sc, self%sc)

   call set_value(child, k_s6, self%s6)
   call set_value(child, k_s8, self%s8)
   call set_value(child, k_a1, self%a1)
   call set_value(child, k_a2, self%a2)
   call set_value(child, k_s9, self%s9)
end subroutine dump_to_toml


!> Read parametrization data from parameter array
subroutine load_from_array(self, array, offset, base, mask, error)
   class(dispersion_record), intent(inout) :: self
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: offset
   type(dispersion_record), intent(in) :: base
   type(dispersion_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   select type(self)
   type is (dispersion_record)
      self = base
   end select

end subroutine load_from_array

!> Write parametrization data to parameter array
subroutine dump_to_array(self, array, offset, mask, error)
   class(dispersion_record), intent(in) :: self
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: offset
   type(dispersion_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

end subroutine dump_to_array

elemental function count_mask(mask) result(ncount)
   type(dispersion_mask), intent(in) :: mask
   integer :: ncount
   ncount = 0
end function count_mask


end module tblite_param_dispersion

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Semiclassical DFT-D3 dispersion correction
module tblite_disp_d3
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_container_cache, only : container_cache
   use tblite_cutoff, only : get_lattice_points
   use tblite_disp_cache, only : dispersion_cache
   use tblite_disp_type, only : dispersion_type
   use dftd3, only : d3_model, new_d3_model, rational_damping_param, realspace_cutoff
   use dftd3_ncoord, only : get_coordination_number, add_coordination_number_derivs
   implicit none
   private

   public :: d3_dispersion, new_d3_dispersion


   !> Container for DFT-D3 type dispersion correction
   type, extends(dispersion_type) :: d3_dispersion
      type(d3_model) :: model
      type(rational_damping_param) :: param
      type(realspace_cutoff) :: cutoff
   contains
      procedure :: get_engrad
   end type d3_dispersion

   character(len=*), parameter :: label = "DFT-D3(BJ) dispersion correction"

contains

subroutine new_d3_dispersion(self, mol, s6, s8, a1, a2, s9)
   !> Instance of the dispersion correction
   type(d3_dispersion), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: s6, s8, a1, a2, s9

   self%label = label
   call new_d3_model(self%model, mol)
   self%param = rational_damping_param(s6=s6, s8=s8, s9=s9, a1=a1, a2=a2, alp=14.0_wp)
   self%cutoff = realspace_cutoff(cn=25.0_wp, disp3=25.0_wp, disp2=50.0_wp)
end subroutine new_d3_dispersion

!> Evaluate non-selfconsistent part of the dispersion correction
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the dispersion correction
   class(d3_dispersion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different dispersion runs
   type(container_cache), intent(inout) :: cache
   !> Dispersion energy
   real(wp), intent(inout) :: energies(:)
   !> Dispersion gradient
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Dispersion virial
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)

   logical :: grad
   integer :: mref
   real(wp), allocatable :: cn(:)
   real(wp), allocatable :: gwvec(:, :), gwdcn(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :)
   real(wp), allocatable :: dEdcn(:), lattr(:, :)

   mref = maxval(self%model%ref)
   grad = present(gradient).and.present(sigma)

   allocate(cn(mol%nat))
   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff%cn, lattr)
   call get_coordination_number(mol, lattr, self%cutoff%cn, self%model%rcov, cn)

   allocate(gwvec(mref, mol%nat))
   if (grad) allocate(gwdcn(mref, mol%nat))
   call self%model%weight_references(mol, cn, gwvec, gwdcn)

   allocate(c6(mol%nat, mol%nat))
   if (grad) allocate(dc6dcn(mol%nat, mol%nat))
   call self%model%get_atomic_c6(mol, gwvec, gwdcn, c6, dc6dcn)

   if (grad) then
      allocate(dEdcn(mol%nat))
      dEdcn(:) = 0.0_wp
   end if
   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff%disp2, lattr)
   call self%param%get_dispersion2(mol, lattr, self%cutoff%disp2, self%model%rvdw, &
      & self%model%r4r2, c6, dc6dcn, energies, dEdcn, gradient, sigma)

   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff%disp3, lattr)
   call self%param%get_dispersion3(mol, lattr, self%cutoff%disp3, self%model%rvdw, &
      & self%model%r4r2, c6, dc6dcn, energies, dEdcn, gradient, sigma)
   if (grad) then
      call add_coordination_number_derivs(mol, lattr, self%cutoff%cn, self%model%rcov, &
         & dEdcn, gradient, sigma)
   end if
end subroutine get_engrad


end module tblite_disp_d3

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_data_covrad
   use mctc_env, only : wp
   use mctc_io_convert, only : aatoau
   use mctc_io_symbols, only : to_number
   implicit none
   private

   public :: get_covalent_rad


   !> Covalent radii for DFT-D3 coordination number
   interface get_covalent_rad
      module procedure :: get_covalent_rad_num
      module procedure :: get_covalent_rad_sym
   end interface get_covalent_rad


   integer, parameter :: max_elem = 118

   !> Covalent radii (taken from Pyykko and Atsumi, Chem. Eur. J. 15, 2009,
   !  188-197), values for metals decreased by 10 %
   real(wp), parameter :: covalent_rad_2009(max_elem) = aatoau * [ &
      & 0.32_wp,0.46_wp, & ! H,He
      & 1.20_wp,0.94_wp,0.77_wp,0.75_wp,0.71_wp,0.63_wp,0.64_wp,0.67_wp, & ! Li-Ne
      & 1.40_wp,1.25_wp,1.13_wp,1.04_wp,1.10_wp,1.02_wp,0.99_wp,0.96_wp, & ! Na-Ar
      & 1.76_wp,1.54_wp, & ! K,Ca
      &                 1.33_wp,1.22_wp,1.21_wp,1.10_wp,1.07_wp, & ! Sc-
      &                 1.04_wp,1.00_wp,0.99_wp,1.01_wp,1.09_wp, & ! -Zn
      &                 1.12_wp,1.09_wp,1.15_wp,1.10_wp,1.14_wp,1.17_wp, & ! Ga-Kr
      & 1.89_wp,1.67_wp, & ! Rb,Sr
      &                 1.47_wp,1.39_wp,1.32_wp,1.24_wp,1.15_wp, & ! Y-
      &                 1.13_wp,1.13_wp,1.08_wp,1.15_wp,1.23_wp, & ! -Cd
      &                 1.28_wp,1.26_wp,1.26_wp,1.23_wp,1.32_wp,1.31_wp, & ! In-Xe
      & 2.09_wp,1.76_wp, & ! Cs,Ba
      &         1.62_wp,1.47_wp,1.58_wp,1.57_wp,1.56_wp,1.55_wp,1.51_wp, & ! La-Eu
      &         1.52_wp,1.51_wp,1.50_wp,1.49_wp,1.49_wp,1.48_wp,1.53_wp, & ! Gd-Yb
      &                 1.46_wp,1.37_wp,1.31_wp,1.23_wp,1.18_wp, & ! Lu-
      &                 1.16_wp,1.11_wp,1.12_wp,1.13_wp,1.32_wp, & ! -Hg
      &                 1.30_wp,1.30_wp,1.36_wp,1.31_wp,1.38_wp,1.42_wp, & ! Tl-Rn
      & 2.01_wp,1.81_wp, & ! Fr,Ra
      &      1.67_wp,1.58_wp,1.52_wp,1.53_wp,1.54_wp,1.55_wp,1.49_wp, & ! Ac-Am
      &      1.49_wp,1.51_wp,1.51_wp,1.48_wp,1.50_wp,1.56_wp,1.58_wp, & ! Cm-No
      &                 1.45_wp,1.41_wp,1.34_wp,1.29_wp,1.27_wp, & ! Lr-
      &                 1.21_wp,1.16_wp,1.15_wp,1.09_wp,1.22_wp, & ! -Cn
      &                 1.36_wp,1.43_wp,1.46_wp,1.58_wp,1.48_wp,1.57_wp ] ! Nh-Og

   !> D3 covalent radii used to construct the coordination number
   real(wp), parameter :: covalent_rad_d3(max_elem) = &
      & 4.0_wp / 3.0_wp * covalent_rad_2009

contains


!> Get covalent radius for a given element symbol
elemental function get_covalent_rad_sym(sym) result(rad)

   !> Element symbol
   character(len=*), intent(in) :: sym

   !> Covalent radius
   real(wp) :: rad

   rad = get_covalent_rad(to_number(sym))

end function get_covalent_rad_sym


!> Get covalent radius for a given atomic number
elemental function get_covalent_rad_num(num) result(rad)

   !> Atomic number
   integer, intent(in) :: num

   !> Covalent radius
   real(wp) :: rad

   if (num > 0 .and. num <= size(covalent_rad_d3)) then
      rad = covalent_rad_d3(num)
   else
      rad = 0.0_wp
   end if

end function get_covalent_rad_num


end module tblite_data_covrad

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Handling of spin information in the wavefunction
!>
!> Spin is represented as charge and magnetization density in the population based
!> properties, *e.g.* Mulliken partial charges, atomic dipole moments, ..., and
!> in up/down representation for orbials energies, occupation numbers, ...
module tblite_wavefunction_spin
   use mctc_env, only : wp
   implicit none
   private

   public :: magnet_to_updown, updown_to_magnet


   !> Convert a charge-magnetization representation into an up-down representation
   interface magnet_to_updown
      module procedure :: magnet_to_updown_1
      module procedure :: magnet_to_updown_2
      module procedure :: magnet_to_updown_3
      module procedure :: magnet_to_updown_4
   end interface magnet_to_updown

   !> Convert an up-down representation into a charge-magnetization representation
   interface updown_to_magnet
      module procedure :: updown_to_magnet_1
      module procedure :: updown_to_magnet_2
      module procedure :: updown_to_magnet_3
      module procedure :: updown_to_magnet_4
   end interface updown_to_magnet

contains

!> Convert a charge-magnetization representation into an up-down representation
subroutine magnet_to_updown_1(x)

   !> Data in charge-magnetization representation on entry
   !> transformed to up-down representation on exit
   real(wp), intent(inout) :: x(:)

   if (size(x, 1) == 2) then
      x(1) = 0.5_wp * (x(1) + x(2))
      x(2) = x(1) - x(2)
   end if
end subroutine magnet_to_updown_1

!> Convert a charge-magnetization representation into an up-down representation
subroutine magnet_to_updown_2(x)

   !> Data in charge-magnetization representation on entry
   !> transformed to up-down representation on exit
   real(wp), intent(inout) :: x(:, :)

   if (size(x, 2) == 2) then
      x(:, 1) = 0.5_wp * (x(:, 1) + x(:, 2))
      x(:, 2) = x(:, 1) - x(:, 2)
   end if
end subroutine magnet_to_updown_2

!> Convert a charge-magnetization representation into an up-down representation
subroutine magnet_to_updown_3(x)

   !> Data in charge-magnetization representation on entry
   !> transformed to up-down representation on exit
   real(wp), intent(inout) :: x(:, :, :)

   if (size(x, 3) == 2) then
      x(:, :, 1) = 0.5_wp * (x(:, :, 1) + x(:, :, 2))
      x(:, :, 2) = x(:, :, 1) - x(:, :, 2)
   end if
end subroutine magnet_to_updown_3

!> Convert a charge-magnetization representation into an up-down representation
subroutine magnet_to_updown_4(x)

   !> Data in charge-magnetization representation on entry
   !> transformed to up-down representation on exit
   real(wp), intent(inout) :: x(:, :, :, :)

   if (size(x, 4) == 2) then
      x(:, :, :, 1) = 0.5_wp * (x(:, :, :, 1) + x(:, :, :, 2))
      x(:, :, :, 2) = x(:, :, :, 1) - x(:, :, :, 2)
   end if
end subroutine magnet_to_updown_4

!> Convert an up-down representation into a charge-magnetization representation
subroutine updown_to_magnet_1(x)

   !> Data in up-down representation on entry
   !> transformed to charge-magnetization representation on exit
   real(wp), intent(inout) :: x(:)

   if (size(x, 1) == 2) then
      x(1) = x(1) + x(2)
      x(2) = x(1) - 2.0_wp * x(2)
   end if
end subroutine updown_to_magnet_1

!> Convert an up-down representation into a charge-magnetization representation
subroutine updown_to_magnet_2(x)

   !> Data in up-down representation on entry
   !> transformed to charge-magnetization representation on exit
   real(wp), intent(inout) :: x(:, :)

   if (size(x, 2) == 2) then
      x(:, 1) = x(:, 1) + x(:, 2)
      x(:, 2) = x(:, 1) - 2.0_wp * x(:, 2)
   end if
end subroutine updown_to_magnet_2

!> Convert an up-down representation into a charge-magnetization representation
subroutine updown_to_magnet_3(x)

   !> Data in up-down representation on entry
   !> transformed to charge-magnetization representation on exit
   real(wp), intent(inout) :: x(:, :, :)

   if (size(x, 3) == 2) then
      x(:, :, 1) = x(:, :, 1) + x(:, :, 2)
      x(:, :, 2) = x(:, :, 1) - 2.0_wp * x(:, :, 2)
   end if
end subroutine updown_to_magnet_3

!> Convert an up-down representation into a charge-magnetization representation
subroutine updown_to_magnet_4(x)

   !> Data in up-down representation on entry
   !> transformed to charge-magnetization representation on exit
   real(wp), intent(inout) :: x(:, :, :, :)

   if (size(x, 4) == 2) then
      x(:, :, :, 1) = x(:, :, :, 1) + x(:, :, :, 2)
      x(:, :, :, 2) = x(:, :, :, 1) - 2.0_wp * x(:, :, :, 2)
   end if
end subroutine updown_to_magnet_4

end module tblite_wavefunction_spin

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_ncoord_type
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   implicit none
   private

   public :: ncoord_type

   type, abstract :: ncoord_type
   contains
      procedure(get_cn), deferred :: get_cn
   end type ncoord_type

   abstract interface
      subroutine get_cn(self, mol, cn, dcndr, dcndL)
         import :: ncoord_type, structure_type, wp
         !> Coordination number container
         class(ncoord_type), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Error function coordination number.
         real(wp), intent(out) :: cn(:)
         !> Derivative of the CN with respect to the Cartesian coordinates.
         real(wp), intent(out), optional :: dcndr(:, :, :)
         !> Derivative of the CN with respect to strain deformations.
         real(wp), intent(out), optional :: dcndL(:, :, :)
      end subroutine get_cn
   end interface

end module tblite_ncoord_type

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_scf_iterator
   use mctc_env, only : wp, error_type
   use mctc_io, only : structure_type
   use tblite_basis_type, only : basis_type
   use tblite_container, only : container_cache, container_list
   use tblite_disp, only : dispersion_type
   use tblite_integral_type, only : integral_type
   use tblite_wavefunction_type, only : wavefunction_type, get_density_matrix
   use tblite_wavefunction_fermi, only : get_fermi_filling
   use tblite_wavefunction_mulliken, only : get_mulliken_shell_charges, &
      & get_mulliken_atomic_multipoles
   use tblite_xtb_coulomb, only : tb_coulomb
   use tblite_scf_broyden, only : broyden_mixer, new_broyden
   use tblite_scf_info, only : scf_info
   use tblite_scf_potential, only : potential_type, add_pot_to_h1
   use tblite_scf_solver, only : solver_type
   implicit none
   private

   public :: next_scf, get_mixer_dimension

contains

!> Evaluate self-consistent iteration for the density-dependent Hamiltonian
subroutine next_scf(iscf, mol, bas, wfn, solver, mixer, info, coulomb, dispersion, &
      & interactions, ints, pot, cache, dcache, icache, &
      & energies, error)
   !> Current iteration count
   integer, intent(inout) :: iscf
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Tight-binding wavefunction data
   type(wavefunction_type), intent(inout) :: wfn
   !> Solver for the general eigenvalue problem
   class(solver_type), intent(inout) :: solver
   !> Convergence accelerator
   type(broyden_mixer), intent(inout) :: mixer
   !> Information on wavefunction data used to construct Hamiltonian
   type(scf_info), intent(in) :: info
   !> Container for coulombic interactions
   type(tb_coulomb), intent(in), optional :: coulomb
   !> Container for dispersion interactions
   class(dispersion_type), intent(in), optional :: dispersion
   !> Container for general interactions
   type(container_list), intent(in), optional :: interactions

   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Density dependent potential shifts
   type(potential_type), intent(inout) :: pot
   !> Restart data for coulombic interactions
   type(container_cache), intent(inout) :: cache
   !> Restart data for dispersion interactions
   type(container_cache), intent(inout) :: dcache
   !> Restart data for interaction containers
   type(container_cache), intent(inout) :: icache

   !> Self-consistent energy
   real(wp), intent(inout) :: energies(:)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp), allocatable :: eao(:)
   real(wp) :: ts

   if (iscf > 0) then
      call mixer%next
      call get_mixer(mixer, bas, wfn, info)
   end if

   iscf = iscf + 1
   call pot%reset
   if (present(coulomb)) then
      call coulomb%get_potential(mol, cache, wfn, pot)
   end if
   if (present(dispersion)) then
      call dispersion%get_potential(mol, dcache, wfn, pot)
   end if
   if (present(interactions)) then
      call interactions%get_potential(mol, icache, wfn, pot)
   end if
   call add_pot_to_h1(bas, ints, pot, wfn%coeff)

   call set_mixer(mixer, wfn, info)

   call get_density(wfn, solver, ints, ts, error)
   if (allocated(error)) return

   call get_mulliken_shell_charges(bas, ints%overlap, wfn%density, wfn%n0sh, &
      & wfn%qsh)
   call get_qat_from_qsh(bas, wfn%qsh, wfn%qat)

   call get_mulliken_atomic_multipoles(bas, ints%dipole, wfn%density, &
      & wfn%dpat)
   call get_mulliken_atomic_multipoles(bas, ints%quadrupole, wfn%density, &
      & wfn%qpat)

   call diff_mixer(mixer, wfn, info)

   allocate(eao(bas%nao), source=0.0_wp)
   call get_electronic_energy(ints%hamiltonian, wfn%density, eao)

   energies(:) = ts / size(energies)
   call reduce(energies, eao, bas%ao2at)
   if (present(coulomb)) then
      call coulomb%get_energy(mol, cache, wfn, energies)
   end if
   if (present(dispersion)) then
      call dispersion%get_energy(mol, dcache, wfn, energies)
   end if
   if (present(interactions)) then
      call interactions%get_energy(mol, icache, wfn, energies)
   end if
end subroutine next_scf


subroutine get_electronic_energy(h0, density, energies)
   real(wp), intent(in) :: h0(:, :)
   real(wp), intent(in) :: density(:, :, :)
   real(wp), intent(inout) :: energies(:)

   integer :: iao, jao, spin

   !$omp parallel do collapse(3) schedule(runtime) default(none) &
   !$omp reduction(+:energies) shared(h0, density) private(spin, iao, jao)
   do spin = 1, size(density, 3)
      do iao = 1, size(density, 2)
         do jao = 1, size(density, 1)
            energies(iao) = energies(iao) + h0(jao, iao) * density(jao, iao, spin)
         end do
      end do
   end do
end subroutine get_electronic_energy


subroutine reduce(reduced, full, map)
   real(wp), intent(inout) :: reduced(:)
   real(wp), intent(in) :: full(:)
   integer, intent(in) :: map(:)

   integer :: ix

   do ix = 1, size(map)
      reduced(map(ix)) = reduced(map(ix)) + full(ix)
   end do
end subroutine reduce


subroutine get_qat_from_qsh(bas, qsh, qat)
   type(basis_type), intent(in) :: bas
   real(wp), intent(in) :: qsh(:, :)
   real(wp), intent(out) :: qat(:, :)

   integer :: ish, ispin

   qat(:, :) = 0.0_wp
   !$omp parallel do schedule(runtime) collapse(2) default(none) &
   !$omp reduction(+:qat) shared(bas, qsh) private(ish)
   do ispin = 1, size(qsh, 2)
      do ish = 1, size(qsh, 1)
         qat(bas%sh2at(ish), ispin) = qat(bas%sh2at(ish), ispin) + qsh(ish, ispin)
      end do
   end do
end subroutine get_qat_from_qsh


function get_mixer_dimension(mol, bas, info) result(ndim)
   use tblite_scf_info, only : atom_resolved, shell_resolved
   type(structure_type), intent(in) :: mol
   type(basis_type), intent(in) :: bas
   type(scf_info), intent(in) :: info
   integer :: ndim

   ndim = 0

   select case(info%charge)
   case(atom_resolved)
      ndim = ndim + mol%nat
   case(shell_resolved)
      ndim = ndim + bas%nsh
   end select

   select case(info%dipole)
   case(atom_resolved)
      ndim = ndim + 3*mol%nat
   end select

   select case(info%quadrupole)
   case(atom_resolved)
      ndim = ndim + 6*mol%nat
   end select
end function get_mixer_dimension

subroutine set_mixer(mixer, wfn, info)
   use tblite_scf_info, only : atom_resolved, shell_resolved
   type(broyden_mixer), intent(inout) :: mixer
   type(wavefunction_type), intent(in) :: wfn
   type(scf_info), intent(in) :: info

   select case(info%charge)
   case(atom_resolved)
      call mixer%set(wfn%qat)
   case(shell_resolved)
      call mixer%set(wfn%qsh)
   end select

   select case(info%dipole)
   case(atom_resolved)
      call mixer%set(wfn%dpat)
   end select

   select case(info%quadrupole)
   case(atom_resolved)
      call mixer%set(wfn%qpat)
   end select
end subroutine set_mixer

subroutine diff_mixer(mixer, wfn, info)
   use tblite_scf_info, only : atom_resolved, shell_resolved
   type(broyden_mixer), intent(inout) :: mixer
   type(wavefunction_type), intent(in) :: wfn
   type(scf_info), intent(in) :: info

   select case(info%charge)
   case(atom_resolved)
      call mixer%diff(wfn%qat)
   case(shell_resolved)
      call mixer%diff(wfn%qsh)
   end select

   select case(info%dipole)
   case(atom_resolved)
      call mixer%diff(wfn%dpat)
   end select

   select case(info%quadrupole)
   case(atom_resolved)
      call mixer%diff(wfn%qpat)
   end select
end subroutine diff_mixer

subroutine get_mixer(mixer, bas, wfn, info)
   use tblite_scf_info, only : atom_resolved, shell_resolved
   type(broyden_mixer), intent(inout) :: mixer
   type(basis_type), intent(in) :: bas
   type(wavefunction_type), intent(inout) :: wfn
   type(scf_info), intent(in) :: info

   select case(info%charge)
   case(atom_resolved)
      call mixer%get(wfn%qat)
   case(shell_resolved)
      call mixer%get(wfn%qsh)
      call get_qat_from_qsh(bas, wfn%qsh, wfn%qat)
   end select

   select case(info%dipole)
   case(atom_resolved)
      call mixer%get(wfn%dpat)
   end select

   select case(info%quadrupole)
   case(atom_resolved)
      call mixer%get(wfn%qpat)
   end select
end subroutine get_mixer


subroutine get_density(wfn, solver, ints, ts, error)
   !> Tight-binding wavefunction data
   type(wavefunction_type), intent(inout) :: wfn
   !> Solver for the general eigenvalue problem
   class(solver_type), intent(inout) :: solver
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Electronic entropy
   real(wp), intent(out) :: ts
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp) :: e_fermi, stmp(2)
   real(wp), allocatable :: focc(:)
   integer :: spin

   select case(wfn%nspin)
   case default
      call solver%solve(wfn%coeff(:, :, 1), ints%overlap, wfn%emo(:, 1), error)
      if (allocated(error)) return

      allocate(focc(size(wfn%focc, 1)))
      wfn%focc(:, :) = 0.0_wp
      do spin = 1, 2
         call get_fermi_filling(wfn%nel(spin), wfn%kt, wfn%emo(:, 1), &
            & wfn%homo(spin), focc, e_fermi, stmp(spin))
         wfn%focc(:, 1) = wfn%focc(:, 1) + focc
      end do
      ts = sum(stmp)

      call get_density_matrix(wfn%focc(:, 1), wfn%coeff(:, :, 1), wfn%density(:, :, 1))
   case(2)
      wfn%coeff = 2*wfn%coeff
      do spin = 1, 2
         call solver%solve(wfn%coeff(:, :, spin), ints%overlap, wfn%emo(:, spin), error)
         if (allocated(error)) return

         call get_fermi_filling(wfn%nel(spin), wfn%kt, wfn%emo(:, spin), &
            & wfn%homo(spin), wfn%focc(:, spin), e_fermi, stmp(spin))
         call get_density_matrix(wfn%focc(:, spin), wfn%coeff(:, :, spin), &
            & wfn%density(:, :, spin))
      end do
      ts = sum(stmp)
   end select
end subroutine get_density

end module tblite_scf_iterator

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of spin-interactions for spin-polarized tight-binding.
!>
!> The spin-components are represented as difference between alpha and beta population
!> resulting in a magnetization density.
module tblite_spin
   use mctc_env, only : wp
   use mctc_io, only : structure_type, new
   use tblite_blas, only : dot
   use tblite_container_cache, only : container_cache
   use tblite_container_type, only : container_type
   use tblite_scf_info, only : scf_info, shell_resolved
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: spin_polarization, new_spin_polarization


   !> On-site spin-interaction
   type, extends(container_type) :: spin_polarization
      !> Number of shells for each atom
      integer, allocatable :: nsh_at(:)
      !> Index offset for each shell block
      integer, allocatable :: ish_at(:)
      !> Spin constants for each element
      real(wp), allocatable :: wll(:, :, :)
   contains
      !> Return dependency on density
      procedure :: variable_info
      !> Get spin-polarization energy
      procedure :: get_energy
      !> Get spin-polarization potential
      procedure :: get_potential
   end type spin_polarization

   !> Identifier for container
   character(len=*), parameter :: label = "spin polarization"

contains


!> Create new spin-polarization container
pure subroutine new_spin_polarization(self, mol, wll, nshell)
   !> Instance of the spin-polarization container
   type(spin_polarization), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Spin constants for each species
   real(wp), intent(in) :: wll(:, :, :)
   !> Number of shells for each species
   integer, intent(in), optional :: nshell(:)

   integer :: ind, iat

   self%label = label
   self%wll = wll
   self%nsh_at = nshell(mol%id)

   allocate(self%ish_at(mol%nat))
   ind = 0
   do iat = 1, mol%nat
      self%ish_at(iat) = ind
      ind = ind + self%nsh_at(iat)
   end do
end subroutine new_spin_polarization


!> Get spin-polarization energy
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the spin-polarization container
   class(spin_polarization), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> spin-polarization energy
   real(wp), intent(inout) :: energies(:)

   integer :: iat, izp, ish, jsh, ii, spin

   do spin = 2, wfn%nspin
      do iat = 1, mol%nat
         izp = mol%id(iat)
         ii = self%ish_at(iat)
         do ish = 1, self%nsh_at(iat)
            do jsh = 1, self%nsh_at(iat)
               energies(iat) = energies(iat) + &
                  & 0.5_wp*wfn%qsh(ii+ish, spin)*wfn%qsh(ii+jsh, spin)*self%wll(jsh, ish, izp)
            end do
         end do
      end do
   end do
end subroutine get_energy


!> Get spin-polarization potential
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the spin-polarization container
   class(spin_polarization), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   integer :: iat, izp, ish, jsh, ii, spin

   do spin = 2, wfn%nspin
      do iat = 1, mol%nat
         izp = mol%id(iat)
         ii = self%ish_at(iat)
         do ish = 1, self%nsh_at(iat)
            do jsh = 1, self%nsh_at(iat)
               pot%vsh(ii+ish, spin) = pot%vsh(ii+ish, spin) + &
                  & wfn%qsh(ii+jsh, spin) * self%wll(jsh, ish, izp)
            end do
         end do
      end do
   end do
end subroutine get_potential


!> Return dependency on density
pure function variable_info(self) result(info)
   !> Instance of the spin-polarization container
   class(spin_polarization), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=shell_resolved)
end function variable_info


end module tblite_spin

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Calculation context for storing and communicating with the environment
module tblite_context_type
   use iso_fortran_env, only : output_unit
   use mctc_env, only : error_type
   use tblite_context_logger, only : context_logger
   use tblite_context_terminal, only : context_terminal
   implicit none
   private

   public :: context_type


   !> Calculation context type for error handling and output messages
   type :: context_type
      !> Default output unit for this context
      integer :: unit = output_unit
      !> Default verbosity for procedures using this context
      integer :: verbosity = 1
      !> Stack containing the error messages of this context
      type(error_type), allocatable :: error_log(:)
      !> Optional logger to be used for writing messages
      class(context_logger), allocatable :: io
      !> Color support for output
      type(context_terminal) :: terminal = context_terminal()
   contains
      !> Write a message to the output
      procedure :: message
      !> Push an error message to the context
      procedure :: set_error
      !> Pop an error message from the context
      procedure :: get_error
      !> Query the context for errors
      procedure :: failed
   end type context_type


contains


!> Add an error message to the context
subroutine set_error(self, error)
   !> Instance of the calculation context
   class(context_type), intent(inout) :: self
   !> Error handling
   type(error_type), intent(in), optional :: error

   if (present(error)) then
      if (.not.allocated(self%error_log)) allocate(self%error_log(0))
      self%error_log = [self%error_log, error]
   end if
end subroutine set_error


!> Pop an error message from the context
subroutine get_error(self, error)
   !> Instance of the calculation context
   class(context_type), intent(inout) :: self
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   if (.not.allocated(self%error_log)) allocate(self%error_log(0))

   if (size(self%error_log) > 0) then
      error = self%error_log(size(self%error_log))
      self%error_log = self%error_log(:size(self%error_log)-1)
   end if
end subroutine get_error


!> Write a message to the output
subroutine message(self, msg)
   !> Instance of the calculation context
   class(context_type), intent(inout) :: self
   !> Message to write
   character(len=*), intent(in) :: msg

   if (allocated(self%io)) then
      call self%io%message(msg)
   else
      write(self%unit, '(a)') msg
   end if
end subroutine message


!> Query the context for errors
pure function failed(self)
   !> Instance of the calculation context
   class(context_type), intent(in) :: self
   !> Error status of the context
   logical :: failed

   failed = .false.
   if (allocated(self%error_log)) then
      failed = size(self%error_log) > 0
   end if
end function failed


end module tblite_context_type

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_xtb_coulomb
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_container_cache, only : container_cache
   use tblite_container_type, only : container_type
   use tblite_coulomb_charge, only : coulomb_charge_type
   use tblite_coulomb_multipole, only : damped_multipole
   use tblite_coulomb_thirdorder, only : onsite_thirdorder
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: tb_coulomb

   type, extends(container_type) :: tb_coulomb
      class(coulomb_charge_type), allocatable :: es2
      type(damped_multipole), allocatable :: aes2
      type(onsite_thirdorder), allocatable :: es3
   contains
      procedure :: update
      procedure :: variable_info
      procedure :: get_energy
      procedure :: get_potential
      procedure :: get_gradient
      procedure :: info
   end type tb_coulomb

contains


subroutine update(self, mol, cache)
   !> Instance of the electrostatic container
   class(tb_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   if (allocated(self%es2)) then
      call self%es2%update(mol, cache)
   end if

   if (allocated(self%aes2)) then
      call self%aes2%update(mol, cache)
   end if

   if (allocated(self%es3)) then
      call self%es3%update(mol, cache)
   end if
end subroutine update


subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the electrostatic container
   class(tb_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)

   if (allocated(self%es2)) then
      call self%es2%get_energy(mol, cache, wfn, energies)
   end if

   if (allocated(self%aes2)) then
      call self%aes2%get_energy(mol, cache, wfn, energies)
   end if

   if (allocated(self%es3)) then
      call self%es3%get_energy(mol, cache, wfn, energies)
   end if
end subroutine get_energy


subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the electrostatic container
   class(tb_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   if (allocated(self%es2)) then
      call self%es2%get_potential(mol, cache, wfn, pot)
   end if

   if (allocated(self%aes2)) then
      call self%aes2%get_potential(mol, cache, wfn, pot)
   end if

   if (allocated(self%es3)) then
      call self%es3%get_potential(mol, cache, wfn, pot)
   end if
end subroutine get_potential


subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the electrostatic container
   class(tb_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the repulsion energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   if (allocated(self%es2)) then
      call self%es2%get_gradient(mol, cache, wfn, gradient, sigma)
   end if

   if (allocated(self%aes2)) then
      call self%aes2%get_gradient(mol, cache, wfn, gradient, sigma)
   end if

   if (allocated(self%es3)) then
      call self%es3%get_gradient(mol, cache, wfn, gradient, sigma)
   end if
end subroutine get_gradient


pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, max
   !> Instance of the electrostatic container
   class(tb_coulomb), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info()

   if (allocated(self%es2)) then
      info = max(info, self%es2%variable_info())
   end if

   if (allocated(self%aes2)) then
      info = max(info, self%aes2%variable_info())
   end if

   if (allocated(self%es3)) then
      info = max(info, self%es3%variable_info())
   end if

end function variable_info


!> Information on container
pure function info(self, verbosity, indent) result(str)
   !> Instance of the interaction container
   class(tb_coulomb), intent(in) :: self
   !> Verbosity level
   integer, intent(in) :: verbosity
   !> Indentation level
   character(len=*), intent(in) :: indent
   !> Information on the container
   character(len=:), allocatable :: str

   integer :: ic
   character(len=*), parameter :: nl = new_line('a'), marker = " * "

   if (allocated(self%label)) then
      str = self%label
   else
      str = "Coulomb electrostatics"
   end if

   if (allocated(self%es2)) then
      str = str // nl // indent // marker // &
         & self%es2%info(verbosity, indent//marker)
   end if

   if (allocated(self%aes2)) then
      str = str // nl // indent // marker // &
         & self%aes2%info(verbosity, indent//marker)
   end if

   if (allocated(self%es3)) then
      str = str // nl // indent // marker // &
         & self%es3%info(verbosity, indent//marker)
   end if
end function info


end module tblite_xtb_coulomb

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of the element specific parameter records
module tblite_param_element
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io_symbols, only : to_number, symbol_length
   use tblite_data_paulingen, only : get_pauling_en
   use tblite_param_serde, only : serde_record
   use tblite_toml, only : toml_table, toml_array, get_value, set_value, add_array, len
   implicit none
   private

   public :: element_record, element_mask, count


   !> The conversion factor from eV to Hartree is used for compatibility with older
   !> versions of xtb
   real(wp), parameter :: evtoau = 1.0_wp / 27.21138505_wp

   integer, parameter :: ngauss_default = 6
   real(wp), parameter :: kcn_default = 0.0_wp, lgam_default = 0.0_wp, &
      & mprad_default = 5.0_wp, xbond_default = 0.0_wp

   character(len=*), parameter :: k_shells = "shells", k_levels = "levels", &
      & k_shpoly = "shpoly", k_slater = "slater", k_refocc = "refocc", k_ngauss = "ngauss", &
      & k_gam = "gam", k_lgam = "lgam", k_gam3 = "gam3", k_kcn = "kcn", k_zeff = "zeff", &
      & k_arep = "arep", k_dkernel = "dkernel", k_qkernel = "qkernel", k_mprad = "mprad", &
      & k_mpvcn = "mpvcn", k_xbond = "xbond", k_en = "en"

   !> Representation of the element specific parameters
   type, extends(serde_record) :: element_record
      !> Element symbol of specie represented by this record
      character(len=symbol_length) :: sym = ''
      !> Atomic number of the specie represented by this record
      integer :: num = 0

      !> Effective nuclear charge used in repulsion
      real(wp) :: zeff = 0.0_wp
      !> Repulsion exponent
      real(wp) :: alpha = 0.0_wp

      !> Halogen bonding strength
      real(wp) :: xbond = 0.0_wp

      !> Number of valence and polarization shells
      integer :: nsh = 0
      !> Angular momentum for each shell
      integer, allocatable :: lsh(:)
      !> Principal quantum number for each shell
      integer, allocatable :: pqn(:)
      !> Number of primitive Gaussian functions used in the STO-NG expansion for each shell
      integer, allocatable :: ngauss(:)
      !> Atomic level energies for each shell
      real(wp), allocatable :: levels(:)
      !> Slater exponents of the STO-NG functions for each shell
      real(wp), allocatable :: slater(:)
      !> Reference occupation for each shell
      real(wp), allocatable :: refocc(:)
      !> CN dependent shift of the self energy for each shell
      real(wp), allocatable :: kcn(:)
      !> Polynomial enhancement for Hamiltonian elements
      real(wp), allocatable :: shpoly(:)

      !> Chemical hardness / Hubbard parameter
      real(wp) :: gam = 0.0_wp
      !> Relative chemical hardness for each shell
      real(wp), allocatable :: lgam(:)

      !> Atomic Hubbard derivative
      real(wp) :: gam3 = 0.0_wp

      !> Dipolar exchange-correlation kernel
      real(wp) :: dkernel = 0.0_wp
      !> Quadrupolar exchange-correlation kernel
      real(wp) :: qkernel = 0.0_wp
      !> Multipole radius
      real(wp) :: mprad = 0.0_wp
      !> Multipole valence CN
      real(wp) :: mpvcn = 0.0_wp

      !> Electronnegativity
      real(wp) :: en = 0.0_wp
   contains
      generic :: load => load_from_array
      generic :: dump => dump_to_array
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Read parametrization data from parameter array
      procedure, private :: load_from_array
      !> Write parametrization data to parameter array
      procedure, private :: dump_to_array
   end type


   type :: element_mask
      !> Element symbol of specie represented by this record
      character(len=symbol_length) :: sym = ''
      !> Atomic number of the specie represented by this record
      integer :: num = 0

      !> Effective nuclear charge used in repulsion
      logical :: zeff
      !> Repulsion exponent
      logical :: alpha

      !> Halogen bonding strength
      logical :: xbond

      !> Number of valence and polarization shells
      integer :: nsh
      !> Atomic level energies for each shell
      logical, allocatable :: levels(:)
      !> Slater exponents of the STO-NG functions for each shell
      logical, allocatable :: slater(:)
      !> CN dependent shift of the self energy for each shell
      logical, allocatable :: kcn(:)
      !> Polynomial enhancement for Hamiltonian elements
      logical, allocatable :: shpoly(:)

      !> Chemical hardness / Hubbard parameter
      logical :: gam
      !> Relative chemical hardness for each shell
      logical, allocatable :: lgam(:)

      !> Atomic Hubbard derivative
      logical :: gam3

      !> Dipolar exchange-correlation kernel
      logical :: dkernel
      !> Quadrupolar exchange-correlation kernel
      logical :: qkernel
   end type element_mask


   interface count
      module procedure :: count_mask
   end interface count


contains


!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   class(element_record), intent(inout) :: self
   type(toml_table), intent(inout) :: table
   type(error_type), allocatable, intent(out) :: error

   character(len=:), allocatable :: sym
   type(toml_array), pointer :: array
   integer :: stat

   call table%get_key(sym)
   self%sym = sym
   self%num = to_number(sym)

   call get_value(table, k_shells, array)
   if (.not.associated(array)) then
      call fatal_error(error, "No shells specified for "//trim(self%sym))
      return
   end if
   call get_shells(self, array, error)
   if (allocated(error)) return

   call get_value(table, k_levels, array)
   if (.not.associated(array)) then
      call fatal_error(error, "No atomic levels specified for "//trim(self%sym))
      return
   end if
   call get_levels(self, array, error)
   if (allocated(error)) return

   call get_value(table, k_slater, array)
   if (.not.associated(array)) then
      call fatal_error(error, "No slater exponents specified for "//trim(self%sym))
      return
   end if
   call get_slater(self, array, error)
   if (allocated(error)) return

   call get_value(table, k_refocc, array)
   if (.not.associated(array)) then
      call fatal_error(error, "No reference occupation specified for "//trim(self%sym))
      return
   end if
   call get_refocc(self, array, error)
   if (allocated(error)) return

   call get_value(table, k_ngauss, array, requested=.false.)
   if (associated(array)) then
      call get_ngauss(self, array, error)
      if (allocated(error)) return
   else
      allocate(self%ngauss(self%nsh), source=ngauss_default)
   end if

   call get_value(table, k_shpoly, array)
   if (.not.associated(array)) then
      call fatal_error(error, "No shell-polynomials specified for "//trim(self%sym))
      return
   end if
   call get_shpoly(self, array, error)
   if (allocated(error)) return

   call get_value(table, k_kcn, array, requested=.false.)
   if (associated(array)) then
      call get_kcn(self, array, error)
      if (allocated(error)) return
   else
      allocate(self%kcn(self%nsh), source=kcn_default)
   end if

   call get_value(table, k_gam, self%gam, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid atomic Hubbard parameter for "//trim(self%sym))
      return
   end if
   call get_value(table, k_lgam, array, requested=.false.)
   if (associated(array)) then
      call get_lgam(self, array, error)
      if (allocated(error)) return
   else
      allocate(self%lgam(self%nsh), source=lgam_default)
   end if

   call get_value(table, k_gam3, self%gam3, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid atomic Hubbard derivative for "//trim(self%sym))
      return
   end if

   call get_repulsion(self, table, error)
   if (allocated(error)) return

   call get_multipole(self, table, error)
   if (allocated(error)) return

   call get_value(table, k_xbond, self%xbond, xbond_default, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid halogen bonding strength for "//trim(self%sym))
      return
   end if

   call get_value(table, k_en, self%en, get_pauling_en(self%sym), stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid electronegativity for "//trim(self%sym))
      return
   end if

end subroutine load_from_toml

subroutine get_multipole(self, table, error)
   type(element_record), intent(inout) :: self
   type(toml_table), intent(inout) :: table
   type(error_type), allocatable, intent(out) :: error

   integer :: stat

   call get_value(table, k_dkernel, self%dkernel, 0.0_wp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid dipole kernel for "//trim(self%sym))
      return
   end if
   call get_value(table, k_qkernel, self%qkernel, 0.0_wp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid quadrupole kernel for "//trim(self%sym))
      return
   end if
   call get_value(table, k_mprad, self%mprad, mprad_default, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid multipole damping radius for "//trim(self%sym))
      return
   end if
   call get_value(table, k_mpvcn, self%mpvcn, 0.0_wp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid multipole valence CN for "//trim(self%sym))
      return
   end if
end subroutine get_multipole

subroutine get_repulsion(self, table, error)
   type(element_record), intent(inout) :: self
   type(toml_table), intent(inout) :: table
   type(error_type), allocatable, intent(out) :: error

   integer :: stat

   call get_value(table, k_zeff, self%zeff, real(self%num, wp), stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid effective nuclear charge for "//trim(self%sym))
      return
   end if
   call get_value(table, k_arep, self%alpha, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid repulsion exponent for "//trim(self%sym))
      return
   end if
end subroutine get_repulsion

subroutine get_shells(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   character(len=:), allocatable :: tmp

   self%nsh = len(array)
   if (self%nsh == 0) then
      call fatal_error(error, "No entries for "//trim(self%sym))
      return
   end if
   allocate(self%lsh(self%nsh))
   allocate(self%pqn(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%lsh(i) = get_lsh(tmp(2:2))
      self%pqn(i) = get_pqn(tmp(1:1))
   end do

   if (any(self%lsh < 0)) then
      call fatal_error(error, "Invalid angular momentum for "//trim(self%sym))
      return
   end if

   if (any(self%pqn < 1)) then
      call fatal_error(error, "Invalid principal quantum number for "//trim(self%sym))
      return
   end if

end subroutine get_shells

pure function get_pqn(str) result(pqn)
   character, intent(in) :: str
   integer :: pqn
   select case(str)
   case default
      pqn = 0
   case("1")
      pqn = 1
   case("2")
      pqn = 2
   case("3")
      pqn = 3
   case("4")
      pqn = 4
   case("5")
      pqn = 5
   case("6")
      pqn = 6
   end select
end function get_pqn

pure function get_lsh(str) result(lsh)
   character, intent(in) :: str
   integer :: lsh
   select case(str)
   case default
      lsh = -1
   case("s", "S")
      lsh = 0
   case("p", "P")
      lsh = 1
   case("d", "D")
      lsh = 2
   case("f", "F")
      lsh = 3
   case("g", "G")
      lsh = 4
   end select
end function get_lsh

subroutine get_levels(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   real(wp) :: tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient atomic level energies for "//trim(self%sym))
      return
   end if
   allocate(self%levels(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%levels(i) = tmp * evtoau
   end do
end subroutine get_levels

subroutine get_shpoly(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   real(wp) :: tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient shell-polynomials for "//trim(self%sym))
      return
   end if
   allocate(self%shpoly(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%shpoly(i) = tmp
   end do
end subroutine get_shpoly

subroutine get_slater(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   real(wp) :: tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient slater exponents for "//trim(self%sym))
      return
   end if
   allocate(self%slater(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%slater(i) = tmp
   end do

   if (any(self%slater < epsilon(0.0_wp))) then
      call fatal_error(error, "Invalid slater exponents for "//trim(self%sym))
   end if
end subroutine get_slater

subroutine get_refocc(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   real(wp) :: tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient reference occupations for "//trim(self%sym))
      return
   end if
   allocate(self%refocc(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%refocc(i) = tmp
   end do
end subroutine get_refocc

subroutine get_ngauss(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i, tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient primitive gaussians for "//trim(self%sym))
      return
   end if
   allocate(self%ngauss(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%ngauss(i) = tmp
   end do

   if (any(self%ngauss < 1) .or. any(self%ngauss > 6)) then
      call fatal_error(error, "Invalid number of primitive gaussian for "//trim(self%sym))
   end if
end subroutine get_ngauss

subroutine get_kcn(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   real(wp) :: tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient CN shift parameters for "//trim(self%sym))
      return
   end if
   allocate(self%kcn(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%kcn(i) = tmp * evtoau
   end do
end subroutine get_kcn

subroutine get_lgam(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   real(wp) :: tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient shell hardnesses for "//trim(self%sym))
      return
   end if
   allocate(self%lgam(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%lgam(i) = tmp
   end do
end subroutine get_lgam

!> Write parametrization data to TOML data structure
subroutine dump_to_toml(self, table, error)
   class(element_record), intent(in) :: self
   type(toml_table), intent(inout) :: table
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   type(toml_array), pointer :: array
   character, parameter :: lsh(0:4) = ["s", "p", "d", "f", "g"]
   character, parameter :: pqn(1:6) = ["1", "2", "3", "4", "5", "6"]

   call add_array(table, k_shells, array)
   do i = 1, self%nsh
      call set_value(array, i, pqn(self%pqn(i))//lsh(self%lsh(i)))
   end do

   call add_array(table, k_levels, array)
   do i = 1, self%nsh
      call set_value(array, i, self%levels(i) / evtoau)
   end do

   call add_array(table, k_slater, array)
   do i = 1, self%nsh
      call set_value(array, i, self%slater(i))
   end do

   call add_array(table, k_ngauss, array)
   do i = 1, self%nsh
      call set_value(array, i, self%ngauss(i))
   end do

   call add_array(table, k_refocc, array)
   do i = 1, self%nsh
      call set_value(array, i, self%refocc(i))
   end do

   call add_array(table, k_shpoly, array)
   do i = 1, self%nsh
      call set_value(array, i, self%shpoly(i))
   end do

   call add_array(table, k_kcn, array)
   do i = 1, self%nsh
      call set_value(array, i, self%kcn(i) / evtoau)
   end do

   call set_value(table, k_gam, self%gam)
   call add_array(table, k_lgam, array)
   do i = 1, self%nsh
      call set_value(array, i, self%lgam(i))
   end do

   call set_value(table, k_gam3, self%gam3)

   call set_value(table, k_zeff, self%zeff)
   call set_value(table, k_arep, self%alpha)
   call set_value(table, k_xbond, self%xbond)
   call set_value(table, k_en, self%en)

   call set_value(table, k_dkernel, self%dkernel)
   call set_value(table, k_qkernel, self%qkernel)
   call set_value(table, k_mprad, self%mprad)
   call set_value(table, k_mpvcn, self%mpvcn)

end subroutine dump_to_toml

!> Read parametrization data from parameter array
subroutine load_from_array(self, array, offset, base, mask, error)
   class(element_record), intent(inout) :: self
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: offset
   type(element_record), intent(in) :: base
   type(element_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   select type(self)
   type is (element_record)
      self = base
   end select

   call load_atom_par(self%zeff, mask%zeff, array, offset)
   call load_atom_par(self%alpha, mask%alpha, array, offset)

   call load_atom_par(self%xbond, mask%xbond, array, offset)

   call load_shell_par(self%levels, mask%levels, array, offset, scale=evtoau)
   call load_shell_par(self%slater, mask%slater, array, offset)
   call load_shell_par(self%kcn, mask%kcn, array, offset, scale=evtoau)
   call load_shell_par(self%shpoly, mask%shpoly, array, offset, scale=0.01_wp)

   call load_atom_par(self%gam, mask%gam, array, offset)
   call load_shell_par(self%lgam, mask%lgam, array, offset)

   call load_atom_par(self%gam3, mask%gam3, array, offset, scale=0.1_wp)

   call load_atom_par(self%dkernel, mask%dkernel, array, offset, scale=0.01_wp)
   call load_atom_par(self%qkernel, mask%qkernel, array, offset, scale=0.01_wp)
end subroutine load_from_array

!> Write parametrization data to parameter array
subroutine dump_to_array(self, array, offset, mask, error)
   class(element_record), intent(in) :: self
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: offset
   type(element_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   call dump_atom_par(self%zeff, mask%zeff, array, offset)
   call dump_atom_par(self%alpha, mask%alpha, array, offset)

   call dump_atom_par(self%xbond, mask%xbond, array, offset)

   call dump_shell_par(self%levels, mask%levels, array, offset, scale=evtoau)
   call dump_shell_par(self%slater, mask%slater, array, offset)
   call dump_shell_par(self%kcn, mask%kcn, array, offset, scale=evtoau)
   call dump_shell_par(self%shpoly, mask%shpoly, array, offset, scale=0.01_wp)

   call dump_atom_par(self%gam, mask%gam, array, offset)
   call dump_shell_par(self%lgam, mask%lgam, array, offset)

   call dump_atom_par(self%gam3, mask%gam3, array, offset, scale=0.1_wp)

   call dump_atom_par(self%dkernel, mask%dkernel, array, offset, scale=0.01_wp)
   call dump_atom_par(self%qkernel, mask%qkernel, array, offset, scale=0.01_wp)
end subroutine dump_to_array

pure subroutine load_atom_par(par, mask, array, ii, scale)
   real(wp), intent(inout) :: par
   logical, intent(in) :: mask
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: ii
   real(wp), intent(in), optional :: scale
   real(wp) :: scale_
   scale_ = 1.0_wp
   if (present(scale)) scale_ = scale
   if (mask) then
      ii = ii+1
      par = array(ii) * scale_
   end if
end subroutine load_atom_par

pure subroutine load_shell_par(par, mask, array, ii, scale)
   real(wp), intent(inout) :: par(:)
   logical, intent(in) :: mask(:)
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: ii
   real(wp), intent(in), optional :: scale
   real(wp) :: scale_
   integer :: ish
   scale_ = 1.0_wp
   if (present(scale)) scale_ = scale
   do ish = 1, size(par)
      if (mask(ish)) then
         ii = ii+1
         par(ish) = array(ii) * scale_
      end if
   end do
end subroutine load_shell_par

pure subroutine dump_atom_par(par, mask, array, ii, scale)
   real(wp), intent(in) :: par
   logical, intent(in) :: mask
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: ii
   real(wp), intent(in), optional :: scale
   real(wp) :: scale_
   scale_ = 1.0_wp
   if (present(scale)) scale_ = scale
   if (mask) then
      ii = ii+1
      array(ii) = par / scale_
   end if
end subroutine dump_atom_par

pure subroutine dump_shell_par(par, mask, array, ii, scale)
   real(wp), intent(in) :: par(:)
   logical, intent(in) :: mask(:)
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: ii
   real(wp), intent(in), optional :: scale
   real(wp) :: scale_
   integer :: ish
   scale_ = 1.0_wp
   if (present(scale)) scale_ = scale
   do ish = 1, size(par)
      if (mask(ish)) then
         ii = ii+1
         array(ii) = par(ish) / scale_
      end if
   end do
end subroutine dump_shell_par

elemental function count_mask(mask) result(ncount)
   type(element_mask), intent(in) :: mask
   integer :: ncount
   ncount = count([ &
      mask%zeff, &
      mask%alpha, &
      mask%xbond, &
      mask%levels, &
      mask%slater, &
      mask%kcn, &
      mask%shpoly, &
      mask%gam, &
      mask%lgam, &
      mask%gam3, &
      mask%dkernel, &
      mask%qkernel])
end function count_mask

end module tblite_param_element

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Data container for mutable data in electrostatic calculations
module tblite_coulomb_cache
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_coulomb_ewald, only : get_alpha
   use tblite_wignerseitz, only : wignerseitz_cell, new_wignerseitz_cell
   implicit none
   private

   public :: coulomb_cache


   type :: coulomb_cache
      real(wp) :: alpha
      type(wignerseitz_cell) :: wsc
      real(wp), allocatable :: amat(:, :)
      real(wp), allocatable :: vvec(:)

      real(wp), allocatable :: cn(:)
      real(wp), allocatable :: dcndr(:, :, :)
      real(wp), allocatable :: dcndL(:, :, :)
      real(wp), allocatable :: mrad(:)
      real(wp), allocatable :: dmrdcn(:)

      real(wp), allocatable :: amat_sd(:, :, :)
      real(wp), allocatable :: amat_dd(:, :, :, :)
      real(wp), allocatable :: amat_sq(:, :, :)
   contains
      procedure :: update
   end type coulomb_cache


contains


subroutine update(self, mol)
   !> Instance of the electrostatic container
   class(coulomb_cache), intent(inout) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   if (any(mol%periodic)) then
      call new_wignerseitz_cell(self%wsc, mol)
      call get_alpha(mol%lattice, self%alpha, .false.)
   end if

end subroutine update

end module tblite_coulomb_cache

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_os
   use, intrinsic :: iso_c_binding, only : c_char, c_null_char, c_int
   implicit none
   private

   public :: setenv
   public :: file_exists, delete_file


   interface
      function sys_putenv(name) result(stat) &
            & bind(c, name="putenv")
         import :: c_char, c_int
         character(len=c_char), intent(in) :: name(*)
         integer(c_int) :: stat
      end function
   end interface


contains


subroutine setenv(name, value, stat)
   character(len=*), intent(in) :: name
   character(len=*), intent(in) :: value
   integer, intent(out) :: stat

   stat = sys_putenv(as_c_char(name//"="//value))

end subroutine setenv


pure function as_c_char(str) result(res)
   character(len=*), intent(in) :: str
   character(kind=c_char) :: res(len(str)+1)
   res = transfer(str // c_null_char, res)
end function as_c_char


function file_exists(file) result(exist)
   character(len=*), intent(in) :: file
   logical :: exist
   inquire(file=file, exist=exist)
end function file_exists


subroutine delete_file(file)
   character(len=*), intent(in) :: file
   integer :: unit
   if (file_exists(file)) then
      open(file=file, newunit=unit)
      close(unit, status="delete")
   end if
end subroutine delete_file


end module tblite_os

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_api_utils
   use, intrinsic :: iso_c_binding
   implicit none
   private

   public :: f_c_character, c_f_character, strlen


   interface
      function strlen(str) result(len) bind(c)
         import :: c_ptr, c_int
         type(c_ptr), value :: str
         integer(c_int) :: len
      end function strlen
   end interface

contains


subroutine f_c_character(rhs, lhs, len)
   character(kind=c_char), intent(out) :: lhs(*)
   character(len=*), intent(in) :: rhs
   integer, intent(in) :: len
   integer :: length
   length = min(len-1, len_trim(rhs))

   lhs(1:length) = transfer(rhs(1:length), lhs(1:length))
   lhs(length+1:length+1) = c_null_char

end subroutine f_c_character

subroutine c_f_character(rhs, lhs)
   character(kind=c_char), intent(in) :: rhs(*)
   character(len=:), allocatable, intent(out) :: lhs

   integer :: ii

   do ii = 1, huge(ii) - 1
      if (rhs(ii) == c_null_char) then
         exit
      end if
   end do
   allocate(character(len=ii-1) :: lhs)
   lhs = transfer(rhs(1:ii-1), lhs)

end subroutine c_f_character

end module tblite_api_utils

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_integral_multipole
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type
   use mstore, only : get_structure
   use tblite_basis_type
   use tblite_basis_slater, only : slater_to_gauss
   use tblite_cutoff, only : get_lattice_points
   use tblite_integral_dipole
   use tblite_integral_multipole
   implicit none
   private

   public :: collect_integral_multipole

   real(wp), parameter :: thr = 5e+6_wp*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

contains


!> Collect all exported unit tests
subroutine collect_integral_multipole(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("dipole-trans-ss", test_dipole_ss), &
      new_unittest("dipole-trans-pp", test_dipole_pp), &
      new_unittest("dipole-trans-dd", test_dipole_dd), &
      new_unittest("dipole-grad-ss", test_dipole_grad_ss) &
      ]

end subroutine collect_integral_multipole


subroutine make_basis(bas, mol, ng)
   type(basis_type), intent(out) :: bas
   type(structure_type), intent(in) :: mol
   integer, intent(in) :: ng

   integer, parameter :: nsh(20) = [&
      & 1, 2, 2, 2, 2, 2, 2, 2, 2, 3, 2, 3, 3, 3, 3, 3, 3, 3, 2, 3]
   integer, parameter :: lsh(3, 20) = reshape([&
      & 0, 0, 0,  0, 1, 0,  0, 1, 0,  0, 1, 0,  0, 1, 0,  0, 1, 0,  0, 1, 0, &
      & 0, 1, 0,  0, 1, 0,  0, 1, 2,  0, 1, 0,  0, 1, 2,  0, 1, 2,  0, 1, 2, &
      & 0, 1, 2,  0, 1, 2,  0, 1, 2,  0, 1, 2,  0, 1, 0,  0, 1, 2], &
      & shape(lsh))
   integer, parameter :: pqn(3, 20) = reshape([&
      & 1, 0, 0,  1, 2, 0,  2, 2, 0,  2, 2, 0,  2, 2, 0,  2, 2, 0,  2, 2, 0, &
      & 2, 2, 0,  2, 2, 0,  2, 2, 3,  3, 3, 0,  3, 3, 3,  3, 3, 3,  3, 3, 3, &
      & 3, 3, 3,  3, 3, 3,  3, 3, 3,  3, 3, 3,  4, 4, 0,  4, 4, 3], &
      & shape(pqn))
   real(wp), parameter :: zeta(3, 20) = reshape([&
      & 1.230000_wp, 0.000000_wp, 0.000000_wp, 1.669667_wp, 1.500000_wp, 0.000000_wp, &
      & 0.750060_wp, 0.557848_wp, 0.000000_wp, 1.034720_wp, 0.949332_wp, 0.000000_wp, &
      & 1.479444_wp, 1.479805_wp, 0.000000_wp, 2.096432_wp, 1.800000_wp, 0.000000_wp, &
      & 2.339881_wp, 2.014332_wp, 0.000000_wp, 2.439742_wp, 2.137023_wp, 0.000000_wp, &
      & 2.416361_wp, 2.308399_wp, 0.000000_wp, 3.084104_wp, 2.312051_wp, 2.815609_wp, &
      & 0.763787_wp, 0.573553_wp, 0.000000_wp, 1.184203_wp, 0.717769_wp, 1.300000_wp, &
      & 1.352531_wp, 1.391201_wp, 1.000000_wp, 1.773917_wp, 1.718996_wp, 1.250000_wp, &
      & 1.816945_wp, 1.903247_wp, 1.167533_wp, 1.981333_wp, 2.025643_wp, 1.702555_wp, &
      & 2.485265_wp, 2.199650_wp, 2.476089_wp, 2.329679_wp, 2.149419_wp, 1.950531_wp, &
      & 0.875961_wp, 0.631694_wp, 0.000000_wp, 1.267130_wp, 0.786247_wp, 1.380000_wp],&
      & shape(zeta))

   integer :: isp, izp, ish, stat
   integer, allocatable :: nshell(:)
   type(cgto_type), allocatable :: cgto(:, :)

   nshell = nsh(mol%num)
   allocate(cgto(maxval(nshell), mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      do ish = 1, nshell(isp)
         call slater_to_gauss(ng, pqn(ish, izp), lsh(ish, izp), zeta(ish, izp), &
            & cgto(ish, isp), .true., stat)
      end do
   end do

   call new_basis(bas, mol, nshell, cgto, 1.0_wp)

end subroutine make_basis


subroutine test_dipole_ss(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer, parameter :: ng = 6
   integer :: stat, i
   type(cgto_type) :: cgtoi, cgtoj
   real(wp) :: vec(3), r2
   real(wp) :: overlap(1, 1), dipolei(3, 1, 1), dipolej(3, 1, 1)

   call slater_to_gauss(ng, 2, 0, 1.0_wp, cgtoi, .true., stat)
   call slater_to_gauss(ng, 1, 0, 1.0_wp, cgtoj, .true., stat)

   call random_number(vec)
   vec = vec - 0.5_wp
   r2 = sum(vec**2)

   call dipole_cgto(cgtoi, cgtoj, r2, vec, 100.0_wp, overlap, dipolej)

   vec(:) = -vec

   call dipole_cgto(cgtoj, cgtoi, r2, vec, 100.0_wp, overlap, dipolei)

   do i = 1, 3
      call check(error, dipolei(i, 1, 1) + vec(i) * overlap(1, 1), dipolej(i, 1, 1), thr=thr)
      if (allocated(error)) return
   end do

end subroutine test_dipole_ss


subroutine test_dipole_pp(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer, parameter :: ng = 6, n = 2

   integer :: stat, i, j, k
   type(cgto_type) :: cgtoi, cgtoj
   real(wp) :: vec(3), r2
   real(wp) :: overlap(3, 3), dipolei(3, 3, 3), dipolej(3, 3, 3)

   call slater_to_gauss(ng, 2, 1, 1.0_wp, cgtoi, .true., stat)
   call slater_to_gauss(ng, 3, 1, 1.0_wp, cgtoj, .true., stat)

   call random_number(vec)
   vec = vec - 0.5_wp
   r2 = sum(vec**2)

   call dipole_cgto(cgtoi, cgtoj, r2, vec, 100.0_wp, overlap, dipolej)

   vec(:) = -vec

   call dipole_cgto(cgtoj, cgtoi, r2, vec, 100.0_wp, overlap, dipolei)

   do i = 1, 3
      do j = 1, 3
         do k = 1, 3
            call check(error, dipolei(k, j, i) + vec(k) * overlap(j, i), dipolej(k, i, j), thr=thr)
            if (allocated(error)) return
         end do
      end do
   end do

end subroutine test_dipole_pp


subroutine test_dipole_dd(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer, parameter :: ng = 6, n = 2

   integer :: stat, i, j, k
   type(cgto_type) :: cgtoi, cgtoj
   real(wp) :: vec(3), r2
   real(wp) :: overlap(5, 5), dipolei(3, 5, 5), dipolej(3, 5, 5)

   call slater_to_gauss(ng, 3, 2, 1.0_wp, cgtoi, .true., stat)
   call slater_to_gauss(ng, 4, 2, 1.0_wp, cgtoj, .true., stat)

   call random_number(vec)
   vec = vec - 0.5_wp
   r2 = sum(vec**2)

   call dipole_cgto(cgtoi, cgtoj, r2, vec, 100.0_wp, overlap, dipolej)

   vec(:) = -vec

   call dipole_cgto(cgtoj, cgtoi, r2, vec, 100.0_wp, overlap, dipolei)

   do i = 1, 5
      do j = 1, 5
         do k = 1, 3
            call check(error, dipolei(k, j, i) + vec(k) * overlap(j, i), dipolej(k, i, j), thr=thr)
            if (allocated(error)) return
         end do
      end do
   end do

end subroutine test_dipole_dd


subroutine test_dipole_grad_ss(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer, parameter :: ng = 6
   integer :: stat, i, j
   type(cgto_type) :: cgtoi, cgtoj
   real(wp) :: vec(3), r2, zero(3)
   real(wp) :: overlap(1, 1), doverlapi(3, 1, 1), doverlapj(3, 1, 1)
   real(wp) :: dipole(3, 1, 1), ddipolei(3, 3, 1, 1), ddipolej(3, 3, 1, 1)
   real(wp) :: quadrupole(6, 1, 1), dquadrupolei(3, 6, 1, 1), dquadrupolej(3, 6, 1, 1)
   real(wp) :: sr(1, 1), sl(1, 1), dr(3, 1, 1), dl(3, 1, 1), qr(6, 1, 1), ql(6, 1, 1)
   real(wp), parameter :: step = 1.0e-6_wp

   call slater_to_gauss(ng, 2, 0, 1.0_wp, cgtoi, .true., stat)
   call slater_to_gauss(ng, 1, 0, 1.0_wp, cgtoj, .true., stat)

   call random_number(vec)
   vec = vec - 0.5_wp
   zero = 0
   r2 = sum(vec**2)

   call multipole_grad_cgto(cgtoj, cgtoi, r2, vec, 100.0_wp, overlap, dipole, quadrupole, &
      & doverlapi, ddipolej, dquadrupolej, ddipolei, dquadrupolei)

   do i = 1, 3
      vec(i) = vec(i) + step
      r2 = sum(vec**2)
      call multipole_cgto(cgtoj, cgtoi, r2, vec, 100.0_wp, sr, dr, qr)
      vec(i) = vec(i) - 2*step
      r2 = sum(vec**2)
      call multipole_cgto(cgtoj, cgtoi, r2, vec, 100.0_wp, sl, dl, ql)
      vec(i) = vec(i) + step
      ddipolej(i, :, :, :) = 0.5_wp * (dr - dl) / step
      dquadrupolej(i, :, :, :) = 0.5_wp * (qr - ql) / step
   end do

   num: do i = 1, 3
      do j = 1, 3
         call check(error, ddipolei(i, j, 1, 1), ddipolej(i, j, 1, 1), thr=thr)
         if (allocated(error)) exit num
      end do
      do j = 1, 6
         call check(error, dquadrupolei(i, j, 1, 1), dquadrupolej(i, j, 1, 1), thr=thr)
         if (allocated(error)) exit num
      end do
   end do num
   if (allocated(error)) return

end subroutine test_dipole_grad_ss


end module test_integral_multipole

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_solvation_cpcm
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use tblite_blas, only : dot, gemv
   use tblite_container_cache, only : container_cache
   use tblite_mesh_lebedev, only : grid_size, get_angular_grid, list_bisection
   use tblite_scf_info, only : scf_info, atom_resolved
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_solvation_cpcm_dd
   use tblite_solvation_data, only : get_vdw_rad_cosmo
   use tblite_solvation_type, only : solvation_type
   implicit none
   private

   public :: cpcm_solvation, new_cpcm, cpcm_input


   !> Input for CPCM solvation
   type :: cpcm_input
      !> Dielectric constant
      real(wp) :: dielectric_const
      !> Number of grid points for each atom
      integer :: nang = grid_size(6)
      !> Scaling of van-der-Waals radii
      real(wp) :: rscale = 1.0_wp
      !> Accuracy for iterative solver
      real(wp) :: conv = 1.0e-8_wp
      !> Regularization parameter
      real(wp) :: eta = 2.0_wp
      !> Maximum angular momentum of basis functions
      integer :: lmax = 6
      !> Van-der-Waals radii for all species
      real(wp), allocatable :: rvdw(:)
   end type cpcm_input


   !> Definition of polarizable continuum model
   type, extends(solvation_type) :: cpcm_solvation
      !> Actual domain decomposition calculator
      type(domain_decomposition) :: dd
      !> Dielectric function
      real(wp) :: keps
      !> Van-der-Waal radii for all atoms
      real(wp), allocatable :: rvdw(:)
   contains
      !> Update cache from container
      procedure :: update
      !> Return dependency on density
      procedure :: variable_info
      !> Get electric field energy
      procedure :: get_energy
      !> Get electric field potential
      procedure :: get_potential
      !> Get electric field gradient
      procedure :: get_gradient
   end type cpcm_solvation

   !> Provide constructor for CPCM solvation
   interface cpcm_solvation
      module procedure :: create_cpcm
   end interface


   !> Restart data for CPCM calculation
   type :: cpcm_cache
      !> Actual domain decomposition calculator
      type(domain_decomposition) :: dd
      !> Electrostatic potential phi(ncav)
      real(wp), allocatable :: phi(:)
      !> Psi vector psi(nylm, n)
      real(wp), allocatable :: psi(:, :)
      !> CPCM solution sigma(nylm, n)
      real(wp), allocatable :: sigma(:, :)
      !> CPCM adjoint solution s(nylm, n)
      real(wp), allocatable :: s(:, :)
      !> Interaction matrix with surface charges jmat(ncav, n)
      real(wp), allocatable :: jmat(:, :)
   end type cpcm_cache


   !> Identifier for container
   character(len=*), parameter :: label = "polarizable continuum model"

   real(wp), parameter :: alpha_alpb = 0.571412_wp
   integer, parameter :: ndiis = 25


contains


!> Create new electric field container
subroutine new_cpcm(self, mol, input, error)
   !> Instance of the solvation model
   type(cpcm_solvation), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input for CPCM solvation
   type(cpcm_input), intent(in) :: input
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: igrid, stat, iat, izp
   real(wp), allocatable :: ang_grid(:, :), ang_weight(:)
   type(domain_decomposition_input) :: ddinput

   self%label = label

   allocate(self%rvdw(mol%nat))
   if (allocated(input%rvdw)) then
      self%rvdw(:) = input%rscale*input%rvdw(mol%id)
   else
      do iat = 1, mol%nat
         izp = mol%num(mol%id(iat))
         self%rvdw(iat) = input%rscale*get_vdw_rad_cosmo(izp)
      end do
   end if
   self%keps = -0.5_wp * (1.0_wp/input%dielectric_const - 1.0_wp) / (1.0_wp + alpha_alpb)
   ! choose the lebedev grid with number of points closest to nAng:
   igrid = list_bisection(grid_size, input%nang)
   allocate(ang_grid(3, grid_size(igrid)))
   allocate(ang_weight(grid_size(igrid)))
   call get_angular_grid(igrid, ang_grid, ang_weight, stat)
   if (stat /= 0) then
      call fatal_error(error, "Could not initialize angular grid for CPCM model")
   end if

   ddinput = domain_decomposition_input(lmax=input%lmax, conv=input%conv, eta=input%eta)

   call new_domain_decomposition(self%dd, ddinput, self%rvdw, ang_weight, ang_grid)

end subroutine new_cpcm


!> Type constructor for CPCM splvation
function create_cpcm(mol, input) result(self)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input for CPCM solvation
   type(cpcm_input), intent(in) :: input
   !> Instance of the solvation model
   type(cpcm_solvation) :: self

   type(error_type), allocatable :: error

   call new_cpcm(self, mol, input, error)
end function create_cpcm


!> Update cache from container
subroutine update(self, mol, cache)
   !> Instance of the solvation model
   class(cpcm_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   type(cpcm_cache), pointer :: ptr

   call taint(cache, ptr)

   if (allocated(ptr%phi)) deallocate(ptr%phi)
   if (allocated(ptr%psi)) deallocate(ptr%psi)
   if (allocated(ptr%sigma)) deallocate(ptr%sigma)
   if (allocated(ptr%s)) deallocate(ptr%s)
   if (allocated(ptr%jmat)) deallocate(ptr%jmat)

   ptr%dd = self%dd

   call ddupdate(ptr%dd, mol%xyz)

   allocate(ptr%phi(ptr%dd%ncav), ptr%psi(ptr%dd%nylm, ptr%dd%nat))
   allocate(ptr%jmat(ptr%dd%ncav, ptr%dd%nat))

   call get_coulomb_matrix(mol%xyz, ptr%dd%ccav, ptr%jmat)
end subroutine update


!> Get electric field energy
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the solvation model
   class(cpcm_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Solvation free energy
   real(wp), intent(inout) :: energies(:)

   type(cpcm_cache), pointer :: ptr

   call view(cache, ptr)

   energies(:) = energies + self%keps * sum(ptr%sigma * ptr%psi, 1)
end subroutine get_energy


!> Get electric field potential
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the solvation model
   class(cpcm_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   real(wp) :: xx(1, 1)
   logical :: restart
   type(cpcm_cache), pointer :: ptr

   call view(cache, ptr)

   restart = allocated(ptr%sigma)
   if (.not.allocated(ptr%sigma)) then
      allocate(ptr%sigma(ptr%dd%nylm, ptr%dd%nat))
   end if

   call get_phi(wfn%qat(:, 1), ptr%jmat, ptr%phi)

   call solve_cosmo_direct(ptr%dd, .true., ptr%phi, xx, ptr%sigma, restart)

   restart = allocated(ptr%s)
   if (.not.allocated(ptr%s)) then
      allocate(ptr%s(ptr%dd%nylm, ptr%dd%nat))
   end if

   call get_psi(wfn%qat(:, 1), ptr%psi)

   ! solve adjoint ddCOSMO equation to get full potential contributions
   call solve_cosmo_adjoint(ptr%dd, ptr%psi, ptr%s, restart)

   ! we abuse Phi to store the unpacked and scaled value of s
   call get_zeta(ptr%dd, self%keps, ptr%s, ptr%phi)
   ! and contract with the Coulomb matrix
   call gemv(ptr%jmat, ptr%phi, pot%vat(:, 1), alpha=-1.0_wp, &
      & beta=1.0_wp, trans='t')

   pot%vat(:, 1) = pot%vat(:, 1) + (self%keps * sqrt(4*pi)) * ptr%sigma(1, :)

end subroutine get_potential


!> Get electric field gradient
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the solvation model
   class(cpcm_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the solvation free energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the solvation free energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   integer :: ii, iat, ig
   real(wp), allocatable :: gx(:, :), zeta(:), ef(:, :)
   type(cpcm_cache), pointer :: ptr

   call view(cache, ptr)

   allocate(gx(3, mol%nat), zeta(ptr%dd%ncav), ef(3, max(mol%nat, ptr%dd%ncav)))

   call solve_cosmo_adjoint(ptr%dd, ptr%psi, ptr%s, .true., &
      & accuracy=ptr%dd%conv*1e-3_wp)

   ! reset Phi
   call get_phi(wfn%qat(:, 1), ptr%jmat, ptr%phi)

   ! now call the routine that computes the ddcosmo specific contributions to the forces.
   call get_deriv(ptr%dd, self%keps, ptr%phi, ptr%sigma, ptr%s, gx)

   ! form the "zeta" intermediate
   call get_zeta(ptr%dd, self%keps, ptr%s, zeta)

   ! 1. solute's electric field at the cav points times zeta:
   !    compute the electric field
   call efld(mol%nat, wfn%qat(:, 1), ptr%dd%xyz, ptr%dd%ncav, ptr%dd%ccav, ef)

   ! contract it with the zeta intermediate
   ii = 0
   do iat = 1, ptr%dd%nat
      do ig = 1, ptr%dd%ngrid
         if (ptr%dd%ui(ig, iat) > 0.0_wp) then
            ii = ii + 1
            gx(:, iat) = gx(:, iat) + zeta(ii)*ef(:, ii)
         end if
      end do
   end do

   ! 2. "zeta's" electric field at the nuclei times the charges.
   !    compute the "electric field"
   call efld(ptr%dd%ncav, zeta, ptr%dd%ccav, mol%nat, ptr%dd%xyz, ef)

   ! contract it with the solute's charges.
   do iat = 1, ptr%dd%nat
      gx(:, iat) = gx(:, iat) + ef(:, iat)*wfn%qat(iat, 1)
   end do

   gradient(:, :) = gradient(:, :) + gx
end subroutine get_gradient


!> Return dependency on density
pure function variable_info(self) result(info)
   !> Instance of the solvation model
   class(cpcm_solvation), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=atom_resolved)
end function variable_info


subroutine taint(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(cpcm_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(cpcm_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

subroutine view(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(cpcm_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(cpcm_cache)
      ptr => target
   end select
end subroutine view


!> Evaluate the Coulomb interactions between the atomic sides (xyz) and the
!> surface elements of the cavity (ccav).
subroutine get_coulomb_matrix(xyz, ccav, jmat)
   real(wp), intent(in) :: xyz(:, :)
   real(wp), intent(in) :: ccav(:, :)
   real(wp), intent(inout) :: jmat(:, :)

   integer :: ic, j
   real(wp) :: vec(3), d2, d

   jmat(:, :) = 0.0_wp
   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(ccav, xyz, jmat) private(ic, j, vec, d2, d)
   do ic = 1, size(ccav, 2)
      do j = 1, size(xyz, 2)
         vec(:) = ccav(:, ic) - xyz(:, j)
         d2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         d = sqrt(d2)
         jmat(ic, j) = 1.0_wp / d
      end do
   end do

end subroutine get_coulomb_matrix


!> Routine to compute the psi vector
subroutine get_psi(charge, psi)
   real(wp), intent(in) :: charge(:)
   real(wp), intent(out) :: psi(:, :)

   integer :: iat
   real(wp), parameter :: fac = sqrt(4*pi)

   psi(:,:) = 0.0_wp

   do iat = 1, size(charge)
      psi(1, iat) = fac*charge(iat)
   end do

end subroutine get_psi


!> Routine to compute the potential vector
subroutine get_phi(charge, jmat, phi)
   real(wp), intent(in) :: charge(:)
   real(wp), intent(in) :: jmat(:, :)
   real(wp), intent(out) :: phi(:)

   phi(:) = 0.0_wp

   call gemv(jmat, charge, phi)

end subroutine get_phi


!> Computes the electric field produced by the sources src (nsrc point charges
!  with coordinates csrc) at the ntrg target points ctrg:
subroutine efld(nsrc, src, csrc, ntrg, ctrg, ef)
   integer, intent(in) :: nsrc, ntrg
   real(wp), intent(in) :: src(:)
   real(wp), intent(in) :: csrc(:, :)
   real(wp), intent(in) :: ctrg(:, :)
   real(wp), intent(inout) :: ef(:, :)

   integer :: i, j
   real(wp) :: vec(3), r2, rr, r3, f
   real(wp), parameter :: zero=0.0_wp

   ef(:, :) = 0.0_wp
   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp reduction(+:ef) shared(ntrg, nsrc, ctrg, csrc, src) &
   !$omp private(j, i, f, vec, r2, rr, r3)
   do j = 1, ntrg
      do i = 1, nsrc
         vec(:) = ctrg(:, j) - csrc(:, i)
         r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         rr = sqrt(r2)
         r3 = r2*rr
         f = src(i)/r3
         ef(:, j) = ef(:, j) + f*vec
      end do
   end do

end subroutine efld


end module tblite_solvation_cpcm

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Surface integrator for solvent accessible surface area
module tblite_solvation_surface
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use mctc_io_convert, only : aatoau
   use tblite_mesh_lebedev, only : get_angular_grid, grid_size, list_bisection
   use tblite_adjlist, only : adjacency_list, new_adjacency_list
   implicit none
   private

   public :: surface_integrator, new_surface_integrator

   type :: surface_integrator
      !> Number of angular grid points
      integer :: nang
      !> Angular grid coordinates
      real(wp), allocatable :: ang_grid(:, :)
      !> Angular grid weights
      real(wp), allocatable :: ang_weight(:)
      !> Cut-off radius for the nearest neighbour list
      real(wp) :: srcut
      !> Atom specific surface data
      real(wp), allocatable :: vdwsa(:)
      real(wp), allocatable :: wrp(:)
      real(wp), allocatable :: trj2(:, :)
      real(wp) :: ah0, ah1, ah3
   contains
      procedure :: get_surface
   end type surface_integrator

   !> real space cut-offs
   real(wp), parameter :: tolsesp = 1.e-6_wp

   real(wp), parameter :: default_offset = 2.0_wp*aatoau
   real(wp), parameter :: default_smoothing = 0.3*aatoau

contains

!> Initialize data straucture
subroutine new_surface_integrator(self, num, rad, probe, nang, offset, smoothing)
   !> Instance of the surface integrator
   type(surface_integrator), intent(out) :: self
   !> Atomic numbers
   integer, intent(in) :: num(:)
   !> Van-der-Waals Radii
   real(wp), intent(in) :: rad(:)
   !> Probe radius of the solvent
   real(wp), intent(in) :: probe
   !> Number of angular grid points for integration
   integer, intent(in) :: nang
   !> Offset for surface integration cutoff
   real(wp), intent(in), optional :: offset
   !> Smooting function parameter
   real(wp), intent(in), optional :: smoothing

   integer :: iat, izp, ij, iang, ierr, nat
   real(wp) :: r, w, w3

   nat = size(num)

   allocate (self%vdwsa(nat))
   allocate (self%trj2(2, nat))
   allocate (self%wrp(nat))
   if (present(smoothing)) then
      w = smoothing
   else
      w = default_smoothing
   end if
   w3 = w*w*w
   self%ah0 = 0.5_wp
   self%ah1 = 3._wp/(4.0_wp*w)
   self%ah3 = -1._wp/(4.0_wp*w3)
   do iat = 1, nat
      izp = num(iat)
      self%vdwsa(iat) = rad(izp) + probe
      self%trj2(1, iat) = (self%vdwsa(iat) - w)**2
      self%trj2(2, iat) = (self%vdwsa(iat) + w)**2
      r = self%vdwsa(iat) + w
      self%wrp(iat) = (0.25_wp/w + &
         &            3.0_wp*self%ah3*(0.2_wp*r*r - 0.5_wp*r*self%vdwsa(iat) + &
         &            self%vdwsa(iat)*self%vdwsa(iat)/3.0_wp))*r*r*r
      r = self%vdwsa(iat) - w
      self%wrp(iat) = self%wrp(iat) - (0.25/w + &
         &    3.0_wp*self%ah3*(0.2_wp*r*r - 0.5_wp*r*self%vdwsa(iat) + &
         &            self%vdwsa(iat)*self%vdwsa(iat)/3.0_wp))*r*r*r
   end do
   self%srcut = 2*(w + maxval(self%vdwsa))
   if (present(offset)) then
      self%srcut = self%srcut + offset
   else
      self%srcut = self%srcut + default_offset
   end if

   iang = list_bisection(grid_size, nang)
   allocate (self%ang_grid(3, grid_size(iang)))
   allocate (self%ang_weight(grid_size(iang)))
   call get_angular_grid(iang, self%ang_grid, self%ang_weight, ierr)
   self%ang_weight(:) = self%ang_weight*4*pi

end subroutine new_surface_integrator

subroutine get_surface(self, mol, surface, dsdr)
   !> Instance of the surface integrator
   class(surface_integrator), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Surface area for each sphere
   real(wp), intent(out) :: surface(:)
   !> Derivative of surface area w.r.t. to coordinate displacements
   real(wp), intent(out), optional :: dsdr(:, :, :)

   type(adjacency_list) :: list
   real(wp), parameter :: trans(3, 1) = 0.0_wp

   call new_adjacency_list(list, mol, trans, self%srcut, .true.)

   ! compute solvent accessible surface and its derivatives
   if (present(dsdr)) then
      call compute_numsa(mol%nat, mol%xyz, list, self%vdwsa, &
         & self%wrp, self%trj2, self%ah0, self%ah1, self%ah3, self%ang_weight, self%ang_grid, &
         & surface, dsdr)
   else
      call compute_surface(mol%nat, mol%xyz, list, self%vdwsa, &
         & self%wrp, self%trj2, self%ah0, self%ah1, self%ah3, self%ang_weight, self%ang_grid, &
         & surface)
   end if

end subroutine get_surface

subroutine compute_surface(nat, xyz, list, vdwsa, &
      & wrp, trj2, ah0, ah1, ah3, ang_weight, ang_grid, surface)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Neighbourlist
   type(adjacency_list), intent(in) :: list
   !> Van-der-Waals radii including probe radius of solvent
   real(wp), intent(in) :: vdwsa(:)
   !> Radial weights for the numerical integration
   real(wp), intent(in) :: wrp(:)
   !> Radial smoothing function
   real(wp), intent(in) :: trj2(:, :)
   real(wp), intent(in)  :: ah0, ah1, ah3
   !> Angular weights for the numerical integration
   real(wp), intent(in) :: ang_weight(:)
   !> Angular grid for each atom
   real(wp), intent(in) :: ang_grid(:, :)
   !> Surface area for each atom, including surface tension
   real(wp), intent(out) :: surface(:)

   integer :: iat, jat, ip, nno, ino
   real(wp) :: rsas, sasai, xyza(3), xyzp(3), sasap, wr, wsa

   surface(:) = 0.0_wp

   !$omp parallel do default(none) shared(surface, ah0, ah1, ah3) &
   !$omp shared(nat, vdwsa, list, xyz, wrp, ang_grid, ang_weight, trj2) &
   !$omp private(iat, rsas, nno, sasai, xyza, wr, ip, xyzp, wsa, sasap, ino)
   do iat = 1, nat

      rsas = vdwsa(iat)
      ino = list%inl(iat)
      nno = list%nnl(iat)

      ! initialize storage
      sasai = 0.0_wp

      ! atomic position
      xyza(:) = xyz(:, iat)
      ! radial atomic weight
      wr = wrp(iat)

      ! loop over grid points
      do ip = 1, size(ang_grid, 2)
         ! grid point position
         xyzp(:) = xyza(:) + rsas*ang_grid(:, ip)
         ! atomic surface function at the grid point
         call compute_w_sp(nat, list%nlat(ino+1:ino+nno), trj2, vdwsa, xyz, xyzp, &
            & ah0, ah1, ah3, sasap)

         if (sasap > tolsesp) then
            ! numerical quadrature weight
            wsa = ang_weight(ip)*wr*sasap
            ! accumulate the surface area
            sasai = sasai + wsa
         end if
      end do

      surface(iat) = sasai
   end do

end subroutine compute_surface

subroutine compute_numsa(nat, xyz, list, vdwsa, &
      & wrp, trj2, ah0, ah1, ah3, ang_weight, ang_grid, surface, dsdrt)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Neighbourlist
   type(adjacency_list), intent(in) :: list
   !> Van-der-Waals radii including probe radius of solvent
   real(wp), intent(in) :: vdwsa(:)
   !> Radial weights for the numerical integration
   real(wp), intent(in) :: wrp(:)
   !> Radial smoothing function
   real(wp), intent(in) :: trj2(:, :)
   real(wp), intent(in)  :: ah0, ah1, ah3
   !> Angular weights for the numerical integration
   real(wp), intent(in) :: ang_weight(:)
   !> Angular grid for each atom
   real(wp), intent(in) :: ang_grid(:, :)
   !> Surface area for each atom, including surface tension
   real(wp), intent(out) :: surface(:)
   !> Derivative of surface area w.r.t. cartesian coordinates
   real(wp), intent(out) :: dsdrt(:, :, :)

   integer :: iat, jat, ip, jj, nni, nno, ino
   real(wp) :: rsas, sasai, xyza(3), xyzp(3), sasap, wr, wsa, drjj(3)
   real(wp), allocatable :: grds(:, :), grads(:, :)
   integer, allocatable :: grdi(:)

   surface(:) = 0.0_wp
   dsdrt(:, :, :) = 0.0_wp

   ! allocate space for the gradient storage
   allocate (grads(3, nat), source=0.0_wp)
   allocate (grds(3, maxval(list%nnl)))
   allocate (grdi(maxval(list%nnl)))

   !$omp parallel do default(none) shared(surface, dsdrt, ah0, ah1, ah3) &
   !$omp shared(nat, vdwsa, list, xyz, wrp, ang_grid, ang_weight, trj2) &
   !$omp private(iat, jat, rsas, nno, grads, sasai, xyza, wr, ip, xyzp, wsa, &
   !$omp& sasap, jj, nni, grdi, grds, drjj, ino)
   do iat = 1, nat

      rsas = vdwsa(iat)
      ino = list%inl(iat)
      nno = list%nnl(iat)

      ! initialize storage
      grads = 0.0_wp
      sasai = 0.0_wp

      ! atomic position
      xyza(:) = xyz(:, iat)
      ! radial atomic weight
      wr = wrp(iat)

      ! loop over grid points
      do ip = 1, size(ang_grid, 2)
         ! grid point position
         xyzp(:) = xyza(:) + rsas*ang_grid(:, ip)
         ! atomic surface function at the grid point
         call compute_w_spg(nat, list%nlat(ino+1:ino+nno), trj2, vdwsa, xyz, xyzp, &
            & ah0, ah1, ah3, sasap, grds, nni, grdi)

         if (sasap > tolsesp) then
            ! numerical quadrature weight
            wsa = ang_weight(ip)*wr*sasap
            ! accumulate the surface area
            sasai = sasai + wsa
            ! accumulate the surface gradient
            do jj = 1, nni
               jat = grdi(jj)
               drjj(:) = wsa*grds(:, jj)
               grads(:, iat) = grads(:, iat) + drjj(:)
               grads(:, jat) = grads(:, jat) - drjj(:)
            end do
         end if
      end do

      surface(iat) = sasai
      dsdrt(:, :, iat) = grads
   end do

end subroutine compute_numsa

pure subroutine compute_w_sp(nat, nnlists, trj2, vdwsa, xyza, xyzp, ah0, ah1, ah3, &
      & sasap)
   integer, intent(in)  :: nat
   integer, intent(in)  :: nnlists(:)
   real(wp), intent(in)  :: xyza(:, :)
   real(wp), intent(in)  :: xyzp(:)
   real(wp), intent(in)  :: ah0, ah1, ah3
   real(wp), intent(out) :: sasap
   real(wp), intent(in)  :: trj2(:, :)
   real(wp), intent(in)  :: vdwsa(:)

   integer  :: img, jat
   real(wp) :: tj(3), tj2, sqtj
   real(wp) :: uj, uj3, ah3uj2
   real(wp) :: sasaij, dsasaij

   sasap = 1.0_wp
   do img = 1, size(nnlists)
      jat = nnlists(img)
      ! compute the distance to the atom
      tj(:) = xyzp(:) - xyza(:, jat)
      tj2 = dot_product(tj, tj)
      ! if within the outer cut-off compute
      if (tj2 < trj2(2, jat)) then
         if (tj2 <= trj2(1, jat)) then
            sasap = 0.0_wp
            return
         else
            sqtj = sqrt(tj2)
            uj = sqtj - vdwsa(jat)
            ah3uj2 = ah3*uj*uj
            dsasaij = ah1 + 3.0_wp*ah3uj2
            sasaij = ah0 + (ah1 + ah3uj2)*uj

            ! accumulate the molecular surface
            sasap = sasap*sasaij
         end if
      end if
   end do

end subroutine compute_w_sp

pure subroutine compute_w_spg(nat, nnlists, trj2, vdwsa, xyza, xyzp, ah0, ah1, ah3, &
      & sasap, grds, nni, grdi)
   integer, intent(in)  :: nat
   integer, intent(in)  :: nnlists(:)
   integer, intent(out) :: nni
   real(wp), intent(in)  :: xyza(:, :)
   real(wp), intent(in)  :: xyzp(:)
   real(wp), intent(in)  :: ah0, ah1, ah3
   real(wp), intent(out) :: sasap
   real(wp), intent(out) :: grds(:, :)
   integer, intent(out) :: grdi(:)
   real(wp), intent(in)  :: trj2(:, :)
   real(wp), intent(in)  :: vdwsa(:)

   integer  :: img, jat
   real(wp) :: tj(3), tj2, sqtj
   real(wp) :: uj, uj3, ah3uj2
   real(wp) :: sasaij, dsasaij

   nni = 0
   sasap = 1.0_wp
   do img = 1, size(nnlists)
      jat = nnlists(img)
      ! compute the distance to the atom
      tj(:) = xyzp(:) - xyza(:, jat)
      tj2 = dot_product(tj, tj)
      ! if within the outer cut-off compute
      if (tj2 < trj2(2, jat)) then
         if (tj2 <= trj2(1, jat)) then
            sasap = 0.0_wp
            return
         else
            sqtj = sqrt(tj2)
            uj = sqtj - vdwsa(jat)
            ah3uj2 = ah3*uj*uj
            dsasaij = ah1 + 3.0_wp*ah3uj2
            sasaij = ah0 + (ah1 + ah3uj2)*uj

            ! accumulate the molecular surface
            sasap = sasap*sasaij
            ! compute the gradient wrt the neighbor
            dsasaij = dsasaij/(sasaij*sqtj)
            nni = nni + 1
            grdi(nni) = jat
            grds(:, nni) = dsasaij*tj(:)
         end if
      end if
   end do

end subroutine compute_w_spg

end module tblite_solvation_surface

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_ncoord_exp
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_cutoff, only : get_lattice_points
   use tblite_data_covrad, only : get_covalent_rad
   use tblite_ncoord_type, only : ncoord_type
   use dftd3_ncoord, only : get_coordination_number
   implicit none
   private

   public :: exp_ncoord_type, new_exp_ncoord

   type, extends(ncoord_type) :: exp_ncoord_type
      real(wp) :: cutoff
      real(wp), allocatable :: rcov(:)
   contains
      procedure :: get_cn
   end type exp_ncoord_type

   real(wp), parameter :: default_cutoff = 25.0_wp

contains


subroutine new_exp_ncoord(self, mol, cutoff, rcov)
   !> Coordination number container
   type(exp_ncoord_type), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Real space cutoff
   real(wp), intent(in), optional :: cutoff
   !> Covalent radii
   real(wp), intent(in), optional :: rcov(:)

   if (present(cutoff)) then
      self%cutoff = cutoff
   else
      self%cutoff = default_cutoff
   end if

   allocate(self%rcov(mol%nid))
   if (present(rcov)) then
      self%rcov(:) = rcov
   else
      self%rcov(:) = get_covalent_rad(mol%num)
   end if
end subroutine new_exp_ncoord


subroutine get_cn(self, mol, cn, dcndr, dcndL)
   !> Coordination number container
   class(exp_ncoord_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Error function coordination number.
   real(wp), intent(out) :: cn(:)
   !> Derivative of the CN with respect to the Cartesian coordinates.
   real(wp), intent(out), optional :: dcndr(:, :, :)
   !> Derivative of the CN with respect to strain deformations.
   real(wp), intent(out), optional :: dcndL(:, :, :)

   real(wp), allocatable :: lattr(:, :)

   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff, lattr)
   call get_coordination_number(mol, lattr, self%cutoff, self%rcov, cn, dcndr, dcndL)
end subroutine get_cn


end module tblite_ncoord_exp

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> API export for error handling
module tblite_api_error
   use, intrinsic :: iso_c_binding
   use mctc_env, only : error_type, fatal_error
   use tblite_api_version, only : namespace
   use tblite_api_utils, only : f_c_character
   implicit none
   private

   public :: vp_error
   public :: new_error_api, check_error_api, clear_error_api, get_error_api, delete_error_api


   !> Void pointer to error handle
   type :: vp_error
      !> Actual payload
      type(error_type), allocatable :: ptr
   end type vp_error


   logical, parameter :: debug = .false.


contains


!> Create new error handle object
function new_error_api() &
      & result(verror) &
      & bind(C, name=namespace//"new_error")
   type(vp_error), pointer :: error
   type(c_ptr) :: verror

   if (debug) print '("[Info]", 1x, a)', "new_error"

   allocate(error)
   verror = c_loc(error)

end function new_error_api


!> Delete error handle object
subroutine delete_error_api(verror) &
      & bind(C, name=namespace//"delete_error")
   type(c_ptr), intent(inout) :: verror
   type(vp_error), pointer :: error

   if (debug) print '("[Info]", 1x, a)', "delete_error"

   if (c_associated(verror)) then
      call c_f_pointer(verror, error)

      deallocate(error)
      verror = c_null_ptr
   end if

end subroutine delete_error_api


!> Check error handle status
function check_error_api(verror) result(status) &
      & bind(C, name=namespace//"check_error")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   integer(c_int) :: status

   if (debug) print '("[Info]", 1x, a)', "check_error"

   if (c_associated(verror)) then
      call c_f_pointer(verror, error)

      if (allocated(error%ptr)) then
         status = 1
      else
         status = 0
      end if
   else
      status = 2
   end if

end function check_error_api


!> Clear error from handle
subroutine clear_error_api(verror) &
      & bind(C, name=namespace//"clear_error")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error

   if (debug) print '("[Info]", 1x, a)', "clear_error"

   if (c_associated(verror)) then
      call c_f_pointer(verror, error)

      if (allocated(error%ptr)) then
         deallocate(error%ptr)
      end if
   end if

end subroutine clear_error_api


!> Get error message from error handle
subroutine get_error_api(verror, charptr, buffersize) &
      & bind(C, name=namespace//"get_error")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   character(kind=c_char), intent(inout) :: charptr(*)
   integer(c_int), intent(in), optional :: buffersize
   integer :: max_length

   if (debug) print '("[Info]", 1x, a)', "get_error"

   if (c_associated(verror)) then
      call c_f_pointer(verror, error)

      if (present(buffersize)) then
         max_length = buffersize
      else
         max_length = huge(max_length) - 2
      end if

      if (allocated(error%ptr)) then
         call f_c_character(error%ptr%message, charptr, max_length)
      end if
   end if

end subroutine get_error_api


end module tblite_api_error

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Defininition of the parametrization data format
module tblite_param
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io_symbols, only : to_number, symbol_length
   use tblite_param_charge, only : charge_record
   use tblite_param_dispersion, only : dispersion_record
   use tblite_param_element, only : element_record
   use tblite_param_halogen, only : halogen_record
   use tblite_param_hamiltonian, only : hamiltonian_record
   use tblite_param_mask, only : param_mask, count
   use tblite_param_multipole, only : multipole_record
   use tblite_param_repulsion, only : repulsion_record
   use tblite_param_serde, only : serde_record
   use tblite_param_thirdorder, only : thirdorder_record
   use tblite_toml, only : toml_table, toml_key, get_value, set_value, add_table
   implicit none
   private

   public :: param_record, param_mask, count
   public :: charge_record, dispersion_record, element_record, halogen_record, &
      & hamiltonian_record, multipole_record, repulsion_record, thirdorder_record


   character(len=*), parameter :: k_dispersion = "dispersion", k_repulsion = "repulsion", &
      & k_charge = "charge", k_thirdorder = "thirdorder", k_multipole = "multipole", &
      & k_halogen = "halogen", k_hamiltonian = "hamiltonian", k_element = "element", &
      & k_meta = "meta", k_version = "version", k_name = "name", k_reference = "reference", &
      & k_format = "format"

   !> Current parameter format version
   integer, parameter :: current_format = 1


   !> Complete self-contained representation of a complete parametrization record.
   type, extends(serde_record) :: param_record
      !> Version of the represented method
      integer :: version = 0
      !> Name of the represented method
      character(len=:), allocatable :: name
      !> References relevant for the parametrization records
      character(len=:), allocatable :: reference
      !> Definition of the Hamiltonian, always required
      type(hamiltonian_record) :: hamiltonian
      !> Definition of the dispersion correction
      type(dispersion_record), allocatable :: dispersion
      !> Definition of the repulsion contribution
      type(repulsion_record), allocatable :: repulsion
      !> Definition of the isotropic second-order charge interactions
      type(charge_record), allocatable :: charge
      !> Definition of the anisotropic second-order multipolar interactions
      type(multipole_record), allocatable :: multipole
      !> Definition of the halogen bonding correction
      type(halogen_record), allocatable :: halogen
      !> Definition of the isotropic third-order charge interactions
      type(thirdorder_record), allocatable :: thirdorder
      !> Element specific parameter records
      type(element_record), allocatable :: record(:)
   contains
      generic :: load => load_from_array
      generic :: dump => dump_to_array
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Read parametrization data from parameter array
      procedure, private :: load_from_array
      !> Write parametrization data to parameter array
      procedure, private :: dump_to_array
      !> Get element record
      procedure :: get
   end type param_record


contains


!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(param_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   integer :: this_format

   call get_value(table, k_meta, child)
   call get_value(child, k_format, this_format, current_format)
   if (this_format < 1) then
      call fatal_error(error, "Parametrer file format must be a positive version")
      return
   end if
   if (this_format > current_format) then
      call fatal_error(error, "Requested future parameter file format which is not yet supported")
      return
   end if
   call get_value(child, k_version, self%version, 0)
   call get_value(child, k_name, self%name)
   call get_value(child, k_reference, self%reference)

   call get_value(table, k_dispersion, child, requested=.false.)
   if (associated(child)) then
      allocate(self%dispersion)
      call self%dispersion%load(child, error)
      if (allocated(error)) return
   end if

   call get_value(table, k_repulsion, child, requested=.false.)
   if (associated(child)) then
      allocate(self%repulsion)
      call self%repulsion%load(child, error)
      if (allocated(error)) return
   end if

   call get_value(table, k_halogen, child, requested=.false.)
   if (associated(child)) then
      allocate(self%halogen)
      call self%halogen%load(child, error)
      if (allocated(error)) return
   end if

   call get_value(table, k_charge, child, requested=.false.)
   if (associated(child)) then
      allocate(self%charge)
      call self%charge%load(child, error)
      if (allocated(error)) return
   end if

   call get_value(table, k_thirdorder, child, requested=.false.)
   if (associated(child)) then
      allocate(self%thirdorder)
      call self%thirdorder%load(child, error)
      if (allocated(error)) return
   end if

   call get_value(table, k_multipole, child, requested=.false.)
   if (associated(child)) then
      allocate(self%multipole)
      call self%multipole%load(child, error)
      if (allocated(error)) return
   end if

   call get_value(table, k_element, child)
   call records_from_table(self%record, child, error)
   if (allocated(error)) return

   call get_value(table, k_hamiltonian, child, requested=.false.)
   if (associated(child)) then
      self%hamiltonian%sym = self%record%sym
      call self%hamiltonian%load(child, error)
      if (allocated(error)) return
   else
      call fatal_error(error, "Hamiltonian entry is missing")
      if (allocated(error)) return
   end if
end subroutine load_from_toml


!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(param_record), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   call add_table(table, k_meta, child)
   if (allocated(self%name)) call set_value(child, k_name, self%name)
   if (allocated(self%reference)) call set_value(child, k_reference, self%reference)
   call set_value(child, k_version, self%version)
   call set_value(child, k_format, current_format)

   call add_table(table, k_hamiltonian, child)
   call self%hamiltonian%dump(child, error)
   if (allocated(error)) return

   if (allocated(self%dispersion)) then
      call add_table(table, k_dispersion, child)
      call self%dispersion%dump(child, error)
      if (allocated(error)) return
   end if

   if (allocated(self%repulsion)) then
      call add_table(table, k_repulsion, child)
      call self%repulsion%dump(child, error)
      if (allocated(error)) return
   end if

   if (allocated(self%halogen)) then
      call add_table(table, k_halogen, child)
      call self%halogen%dump(child, error)
      if (allocated(error)) return
   end if

   if (allocated(self%charge)) then
      call add_table(table, k_charge, child)
      call self%charge%dump(child, error)
      if (allocated(error)) return
   end if

   if (allocated(self%thirdorder)) then
      call add_table(table, k_thirdorder, child)
      call self%thirdorder%dump(child, error)
      if (allocated(error)) return
   end if

   if (allocated(self%multipole)) then
      call add_table(table, k_multipole, child)
      call self%multipole%dump(child, error)
      if (allocated(error)) return
   end if

   call add_table(table, k_element, child)
   call records_to_table(self%record, child, error)
   if (allocated(error)) return
end subroutine dump_to_toml


!> Deserialize records from a table by iterating over all entires
subroutine records_from_table(record, table, error)
   !> List of all element records
   type(element_record), allocatable, intent(out) :: record(:)
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ii
   type(toml_key), allocatable :: list(:)
   type(toml_table), pointer :: child

   call table%get_keys(list)
   allocate(record(size(list)))

   do ii = 1, size(list)
      call get_value(table, list(ii)%key, child)
      call record(ii)%load(child, error)
      if (allocated(error)) exit
   end do
   if (allocated(error)) return
end subroutine records_from_table


!> Serialize records to a table by iterating over all entries
subroutine records_to_table(record, table, error)
   !> List of all element records
   type(element_record), intent(in) :: record(:)
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ii
   type(toml_table), pointer :: child

   do ii = 1, size(record)
      call add_table(table, trim(record(ii)%sym), child)
      call record(ii)%dump(child, error)
      if (allocated(error)) exit
   end do
   if (allocated(error)) return
end subroutine records_to_table


!> Get the position of an element in the parameter records
pure subroutine get(self, sym, num, pos)
   !> Instance of the parametrization records
   class(param_record), target, intent(in) :: self
   !> Symbol of the element
   character(len=*), intent(in) :: sym
   !> Atomic number of the element
   integer, intent(in) :: num
   !> Position in the records
   integer, intent(out) :: pos

   integer :: ii

   pos = 0
   if (.not.allocated(self%record)) return

   do ii = 1, size(self%record)
      if (self%record(ii)%sym == sym) then
         pos = ii
         exit
      end if
   end do
   if (pos /= 0) return

   do ii = 1, size(self%record)
      if (self%record(ii)%num == num) then
         pos = ii
         exit
      end if
   end do
   if (pos /= 0) return
end subroutine get

!> Read parametrization data from parameter array
subroutine load_from_array(self, array, base, mask, error)
   class(param_record), intent(inout) :: self
   real(wp), intent(in) :: array(:)
   type(param_record), intent(in) :: base
   type(param_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   integer :: ii, ir
   integer :: offset

   select type(self)
   type is (param_record)
      self = base
   end select

   offset = 0
   call self%hamiltonian%load(array, offset, base%hamiltonian, mask%hamiltonian, error)
   if (allocated(error)) return

   if (allocated(self%dispersion)) then
      call self%dispersion%load(array, offset, base%dispersion, mask%dispersion, error)
      if (allocated(error)) return
   end if

   if (allocated(self%repulsion)) then
      call self%repulsion%load(array, offset, base%repulsion, mask%repulsion, error)
      if (allocated(error)) return
   end if

   if (allocated(self%halogen)) then
      call self%halogen%load(array, offset, base%halogen, mask%halogen, error)
      if (allocated(error)) return
   end if

   if (allocated(self%charge)) then
      call self%charge%load(array, offset, base%charge, mask%charge, error)
      if (allocated(error)) return
   end if

   if (allocated(self%thirdorder)) then
      call self%thirdorder%load(array, offset, base%thirdorder, mask%thirdorder, error)
      if (allocated(error)) return
   end if

   if (allocated(self%multipole)) then
      call self%multipole%load(array, offset, base%multipole, mask%multipole, error)
      if (allocated(error)) return
   end if

   do ii = 1, size(mask%record)
      call self%get(mask%record(ii)%sym, mask%record(ii)%num, ir)
      call self%record(ir)%load(array, offset, base%record(ir), mask%record(ii), error)
      if (allocated(error)) exit
   end do
   if (allocated(error)) return
end subroutine load_from_array


!> Write parametrization data to parameter array
subroutine dump_to_array(self, array, mask, error)
   class(param_record), intent(in) :: self
   real(wp), intent(inout) :: array(:)
   type(param_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   integer :: ii, ir
   integer :: offset

   offset = 0
   call self%hamiltonian%dump(array, offset, mask%hamiltonian, error)
   if (allocated(error)) return

   if (allocated(self%dispersion)) then
      call self%dispersion%dump(array, offset, mask%dispersion, error)
      if (allocated(error)) return
   end if

   if (allocated(self%repulsion)) then
      call self%repulsion%dump(array, offset, mask%repulsion, error)
      if (allocated(error)) return
   end if

   if (allocated(self%halogen)) then
      call self%halogen%dump(array, offset, mask%halogen, error)
      if (allocated(error)) return
   end if

   if (allocated(self%charge)) then
      call self%charge%dump(array, offset, mask%charge, error)
      if (allocated(error)) return
   end if

   if (allocated(self%thirdorder)) then
      call self%thirdorder%dump(array, offset, mask%thirdorder, error)
      if (allocated(error)) return
   end if

   if (allocated(self%multipole)) then
      call self%multipole%dump(array, offset, mask%multipole, error)
      if (allocated(error)) return
   end if

   do ii = 1, size(mask%record)
      call self%get(mask%record(ii)%sym, mask%record(ii)%num, ir)
      call self%record(ir)%dump(array, offset, mask%record(ii), error)
      if (allocated(error)) exit
   end do
   if (allocated(error)) return
end subroutine dump_to_array

end module tblite_param

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of abstract base class for general interactions
module tblite_container_type
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_container_cache, only : container_cache
   use tblite_scf_info, only : scf_info
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: container_type

   !> Abstract base class for interactions containers
   type, abstract :: container_type
      !> Label identifying this contribution
      character(len=:), allocatable :: label
   contains
      !> Update container cache
      procedure :: update
      !> Get information about density dependent quantities used in the energy
      procedure :: variable_info
      !> Evaluate non-selfconsistent part of the interaction
      procedure :: get_engrad
      !> Evaluate selfconsistent energy of the interaction
      procedure :: get_energy
      !> Evaluate charge dependent potential shift from the interaction
      procedure :: get_potential
      !> Evaluate gradient contributions from the selfconsistent interaction
      procedure :: get_gradient
      !> Information on container
      procedure :: info
   end type container_type


contains


!> Update container cache
subroutine update(self, mol, cache)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
end subroutine update


!> Evaluate non-selfconsistent part of the interaction
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Interaction energy
   real(wp), intent(inout) :: energies(:)
   !> Interaction gradient
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Interaction virial
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)
end subroutine get_engrad


!> Evaluate selfconsistent energy of the interaction
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Interaction energy
   real(wp), intent(inout) :: energies(:)
end subroutine get_energy


!> Evaluate charge dependent potential shift from the interaction
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot
end subroutine get_potential


!> Evaluate gradient contributions from the selfconsistent interaction
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Interaction gradient
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Interaction virial
   real(wp), contiguous, intent(inout) :: sigma(:, :)
end subroutine get_gradient


!> Get information about density dependent quantities used in the energy
pure function variable_info(self) result(info)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info()
end function variable_info


!> Information on container
pure function info(self, verbosity, indent) result(str)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Verbosity level
   integer, intent(in) :: verbosity
   !> Indentation level
   character(len=*), intent(in) :: indent
   !> Information on the container
   character(len=:), allocatable :: str

   if (allocated(self%label)) then
      str = self%label
   else
      str = "Unknown"
   end if
end function info


end module tblite_container_type

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Realspace cutoff and lattice point generator utilities
module tblite_cutoff
   use mctc_env, only : wp
   use mctc_io_math, only : matinv_3x3
   implicit none
   private

   public :: get_lattice_points, wrap_to_central_cell


   interface get_lattice_points
      module procedure :: get_lattice_points_cutoff
      module procedure :: get_lattice_points_rep_3d
   end interface get_lattice_points


contains


!> Generate lattice points from repeatitions
subroutine get_lattice_points_rep_3d(lat, rep, origin, trans)

   !> Lattice vectors
   real(wp), intent(in) :: lat(:, :)

   !> Repeatitions of lattice points to generate
   integer, intent(in) :: rep(:)

   !> Include the origin in the generated lattice points
   logical, intent(in) :: origin

   !> Generated lattice points
   real(wp), allocatable, intent(out) :: trans(:, :)

   integer :: itr, ix, iy, iz, jx, jy, jz

   itr = 0
   if (origin) then
      allocate(trans(3, product(2*rep+1)))
      do ix = 0, rep(1)
         do iy = 0, rep(2)
            do iz = 0, rep(3)
               do jx = 1, merge(-1, 1, ix > 0), -2
                  do jy = 1, merge(-1, 1, iy > 0), -2
                     do jz = 1, merge(-1, 1, iz > 0), -2
                        itr = itr + 1
                        trans(:, itr) = lat(:, 1)*ix*jx &
                           & + lat(:, 2)*iy*jy + lat(:, 3)*iz*jz
                     end do
                  end do
               end do
            end do
         end do
      end do
   else
      allocate(trans(3, product(2*rep+1)-1))
      do ix = 0, rep(1)
         do iy = 0, rep(2)
            do iz = 0, rep(3)
               if (ix == 0 .and. iy == 0 .and. iz == 0) cycle
               do jx = 1, merge(-1, 1, ix > 0), -2
                  do jy = 1, merge(-1, 1, iy > 0), -2
                     do jz = 1, merge(-1, 1, iz > 0), -2
                        itr = itr + 1
                        trans(:, itr) = lat(:, 1)*ix*jx &
                           & + lat(:, 2)*iy*jy + lat(:, 3)*iz*jz
                     end do
                  end do
               end do
            end do
         end do
      end do
   end if

end subroutine get_lattice_points_rep_3d


!> Create lattice points within a given cutoff
subroutine get_lattice_points_cutoff(periodic, lat, rthr, trans)

   !> Periodic dimensions
   logical, intent(in) :: periodic(:)

   !> Real space cutoff
   real(wp), intent(in) :: rthr

   !> Lattice parameters
   real(wp), intent(in) :: lat(:, :)

   !> Generated lattice points
   real(wp), allocatable, intent(out) :: trans(:, :)

   integer :: rep(3)

   if (.not.any(periodic)) then
      allocate(trans(3, 1))
      trans(:, :) = 0.0_wp
   else
      call get_translations(lat, rthr, rep)
      call get_lattice_points(lat, rep, .true., trans)
   end if

end subroutine get_lattice_points_cutoff


!> Generate a supercell based on a realspace cutoff, this subroutine
!> doesn't know anything about the convergence behaviour of the
!> associated property.
pure subroutine get_translations(lat, rthr, rep)
   real(wp), intent(in) :: rthr
   real(wp), intent(in) :: lat(3, 3)
   integer, intent(out) :: rep(3)
   real(wp) :: normx(3), normy(3), normz(3)
   real(wp) :: cos10, cos21, cos32

   ! find normal to the plane...
   call crossproduct(lat(:, 2), lat(:, 3), normx)
   call crossproduct(lat(:, 3), lat(:, 1), normy)
   call crossproduct(lat(:, 1), lat(:, 2), normz)
   ! ...normalize it...
   normx = normx/norm2(normx)
   normy = normy/norm2(normy)
   normz = normz/norm2(normz)
   ! cos angles between normals and lattice vectors
   cos10 = sum(normx*lat(:, 1))
   cos21 = sum(normy*lat(:, 2))
   cos32 = sum(normz*lat(:, 3))
   rep(1) = ceiling(abs(rthr/cos10))
   rep(2) = ceiling(abs(rthr/cos21))
   rep(3) = ceiling(abs(rthr/cos32))

contains

   pure subroutine crossproduct(a, b, c)
      real(wp), intent(in) :: a(3)
      real(wp), intent(in) :: b(3)
      real(wp), intent(out) :: c(3)
      c(1)=a(2)*b(3)-b(2)*a(3)
      c(2)=a(3)*b(1)-b(3)*a(1)
      c(3)=a(1)*b(2)-b(1)*a(2)
   end subroutine crossproduct

end subroutine get_translations


subroutine wrap_to_central_cell(xyz, lattice, periodic)
   real(wp), intent(inout) :: xyz(:, :)
   real(wp), intent(in) :: lattice(:, :)
   logical, intent(in) :: periodic(:)
   real(wp) :: invlat(3, 3), vec(3)
   integer :: iat, idir

   if (.not.any(periodic)) return

   invlat = matinv_3x3(lattice)
   do iat = 1, size(xyz, 2)
      vec(:) = matmul(invlat, xyz(:, iat))
      vec(:) = shift_back_abc(vec)
      xyz(:, iat) = matmul(lattice, vec)
   end do

end subroutine wrap_to_central_cell


elemental function shift_back_abc(in) result(out)
   !> fractional coordinate in (-∞,+∞)
   real(wp),intent(in) :: in
   !> fractional coordinate in [0,1)
   real(wp) :: out
   real(wp),parameter :: p_pbc_eps = 1.0e-14_wp
   out = in
   if(in < (0.0_wp - p_pbc_eps)) &
      out = in + real(ceiling(-in),wp)
   if(in > (1.0_wp + p_pbc_eps)) &
      out = in - real(floor  ( in),wp)
   if (abs(in - 1.0_wp) < p_pbc_eps) &
      out = in - 1.0_wp
end function shift_back_abc


end module tblite_cutoff

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/param/multipole.f90
!> Provides a model for the anisotropic second-order electrostatic

!> Definition of the anisotropic second-order electrostatic contributions
module tblite_param_multipole
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_param_serde, only : serde_record
   use tblite_toml, only : toml_table, get_value, set_value, add_table
   implicit none
   private

   public :: count


   character(len=*), parameter :: k_damped = "damped", k_dmp3 = "dmp3", k_dmp5 = "dmp5", &
      & k_kexp = "kexp", k_shift = "shift", k_rmax = "rmax"

   !> Representation of the multipolar electrostatics
   type, public, extends(serde_record) :: multipole_record
      !> Damping exponent for quadratic terms
      real(wp) :: dmp3
      !> Damping exponent for cubic terms
      real(wp) :: dmp5
      !> Exponent for multipole radii
      real(wp) :: kexp
      !> Shift for valence CN
      real(wp) :: shift
      !> Maximum multipole radus
      real(wp) :: rmax
   contains
      generic :: load => load_from_array
      generic :: dump => dump_to_array
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Read parametrization data from parameter array
      procedure, private :: load_from_array
      !> Write parametrization data to parameter array
      procedure, private :: dump_to_array
   end type


   !> Masking for the anisotropic electrostatic parametrization
   type, public :: multipole_mask
   end type multipole_mask


   interface count
      module procedure :: count_mask
   end interface count


contains


!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(multipole_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   integer :: stat

   call get_value(table, k_damped, child, requested=.false.)
   if (.not.associated(child)) then
      call fatal_error(error, "No entry for damped multipole electrostatic found")
      return
   end if

   call get_value(child, k_dmp3, self%dmp3, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for multipole range separation parameter")
      return
   end if
   call get_value(child, k_dmp5, self%dmp5, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for multipole range separation parameter")
      return
   end if
   call get_value(child, k_kexp, self%kexp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for multipole damping function exponent")
      return
   end if
   call get_value(child, k_shift, self%shift, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for CN multipole shift")
      return
   end if
   call get_value(child, k_rmax, self%rmax, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for maximum multipole radius")
      return
   end if
end subroutine load_from_toml


!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(multipole_record), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   call add_table(table, k_damped, child)
   call set_value(child, k_dmp3, self%dmp3)
   call set_value(child, k_dmp5, self%dmp5)
   call set_value(child, k_kexp, self%kexp)
   call set_value(child, k_shift, self%shift)
   call set_value(child, k_rmax, self%rmax)
end subroutine dump_to_toml


!> Read parametrization data from parameter array
subroutine load_from_array(self, array, offset, base, mask, error)
   class(multipole_record), intent(inout) :: self
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: offset
   type(multipole_record), intent(in) :: base
   type(multipole_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   select type(self)
   type is (multipole_record)
      self = base
   end select

end subroutine load_from_array

!> Write parametrization data to parameter array
subroutine dump_to_array(self, array, offset, mask, error)
   class(multipole_record), intent(in) :: self
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: offset
   type(multipole_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

end subroutine dump_to_array

elemental function count_mask(mask) result(ncount)
   type(multipole_mask), intent(in) :: mask
   integer :: ncount
   ncount = 0
end function count_mask


end module tblite_param_multipole

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_xtb_external
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type, new
   use mstore, only : get_structure
   use tblite_container, only : container_type, container_cache
   use tblite_context_type, only : context_type
   use tblite_external_field, only : electric_field
   use tblite_wavefunction_type, only : wavefunction_type, new_wavefunction
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_gfn1, only : new_gfn1_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   implicit none
   private

   public :: collect_xtb_external

   real(wp), parameter :: acc = 0.01_wp
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp), parameter :: thr2 = 1e+4_wp*sqrt(epsilon(1.0_wp))
   real(wp), parameter :: kt = 300.0_wp * 3.166808578545117e-06_wp

  real(wp), parameter :: aatoau = 1.0_wp / 0.529177249_wp, &
     & ctoau = 1.0_wp / 1.60217653e-19_wp, jtoau = 1.0_wp / 4.3597441775e-18_wp
  !> Convert V/Å = J/(C·Å) to atomic units
  real(wp), parameter :: vatoau = jtoau / (ctoau * aatoau)

  type, extends(container_type) :: empty_interaction
  end type empty_interaction

contains


!> Collect all exported unit tests
subroutine collect_xtb_external(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("gfn1-efield", test_e_mb01), &
      new_unittest("gfn2-efield", test_e_mb02), &
      new_unittest("gfn1-dipole", test_d_mb03), &
      new_unittest("gfn2-dipole", test_d_mb04), &
      new_unittest("gfn1-empty", test_g_mb05), &
      new_unittest("gfn2-empty", test_g_mb06) &
      ]

end subroutine collect_xtb_external


subroutine test_e_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy
   real(wp), parameter :: ref1 = -33.092759826817499_wp, ref0 = -33.040345115781605_wp

   call get_structure(mol, "MB16-43", "01")
   energy = 0.0_wp

   call new_gfn1_calculator(calc, mol)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)

   cont = electric_field([-2.0_wp, 0.0_wp, 0.0_wp]*vatoau)
   call calc%push_back(cont)

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0)

   call check(error, energy, ref1, thr=thr)
   if (allocated(error)) return

   call calc%pop(cont)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0)

   call check(error, energy, ref0, thr=thr)

end subroutine test_e_mb01


subroutine test_e_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   real(wp), parameter :: ref1 = -24.157134025160921_wp, ref0 = -24.069929678894123_wp

   call get_structure(mol, "MB16-43", "02")
   allocate(gradient(3, mol%nat), sigma(3, 3))
   energy = 0.0_wp

   call new_gfn2_calculator(calc, mol)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)

   cont = electric_field([0.0_wp, sqrt(2.0_wp), -sqrt(2.0_wp)]*vatoau)
   call calc%push_back(cont)

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, ref1, thr=thr)
   if (allocated(error)) return

   call calc%pop(cont)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, ref0, thr=thr)

end subroutine test_e_mb02


subroutine test_d_mb03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn, wfn0
   class(container_type), allocatable :: cont
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp) :: energy, efield(3), er, el, numdip(3), dipole(3)
   integer :: i

   call get_structure(mol, "MB16-43", "03")
   energy = 0.0_wp
   efield(:) = 0.0_wp

   call new_gfn1_calculator(calc, mol)
   call new_wavefunction(wfn0, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)

   cont = electric_field(efield)
   call calc%push_back(cont)

   call xtb_singlepoint(ctx, mol, calc, wfn0, acc, energy, verbosity=0)
   dipole(:) = matmul(mol%xyz, wfn0%qat(:, 1)) + sum(wfn0%dpat(:, :, 1), 2)

   do i = 1, 3
      wfn = wfn0
      efield(i) = efield(i) + step
      call calc%pop(cont)
      cont = electric_field(efield)
      call calc%push_back(cont)
      call xtb_singlepoint(ctx, mol, calc, wfn, acc, er, verbosity=0)

      wfn = wfn0
      efield(i) = efield(i) - 2*step
      call calc%pop(cont)
      cont = electric_field(efield)
      call calc%push_back(cont)
      call xtb_singlepoint(ctx, mol, calc, wfn, acc, el, verbosity=0)

      efield(i) = efield(i) + step
      numdip(i) = -0.5_wp * (er - el) / step
   end do

   if (any(abs(dipole - numdip) > thr2)) then
      call test_failed(error, "Numerical dipole moment does not match")
      print '(3es21.14)', dipole
      print '("---")'
      print '(3es21.14)', numdip
      print '("---")'
      print '(3es21.14)', dipole - numdip
   end if

end subroutine test_d_mb03


subroutine test_d_mb04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn, wfn0
   class(container_type), allocatable :: cont
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp) :: energy, efield(3), er, el, numdip(3), dipole(3)
   integer :: i

   call get_structure(mol, "MB16-43", "04")
   energy = 0.0_wp
   efield(:) = 0.0_wp

   call new_gfn2_calculator(calc, mol)
   call new_wavefunction(wfn0, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)

   cont = electric_field(efield)
   call calc%push_back(cont)

   call xtb_singlepoint(ctx, mol, calc, wfn0, acc, energy, verbosity=0)
   dipole(:) = matmul(mol%xyz, wfn0%qat(:, 1)) + sum(wfn0%dpat(:, :, 1), 2)

   do i = 1, 3
      wfn = wfn0
      efield(i) = efield(i) + step
      call calc%pop(cont)
      cont = electric_field(efield)
      call calc%push_back(cont)
      call xtb_singlepoint(ctx, mol, calc, wfn, acc, er, verbosity=0)

      wfn = wfn0
      efield(i) = efield(i) - 2*step
      call calc%pop(cont)
      cont = electric_field(efield)
      call calc%push_back(cont)
      call xtb_singlepoint(ctx, mol, calc, wfn, acc, el, verbosity=0)

      efield(i) = efield(i) + step
      numdip(i) = -0.5_wp * (er - el) / step
   end do

   if (any(abs(dipole - numdip) > thr2)) then
      call test_failed(error, "Numerical dipole moment does not match")
      print '(3es21.14)', dipole
      print '("---")'
      print '(3es21.14)', numdip
      print '("---")'
      print '(3es21.14)', dipole - numdip
   end if

end subroutine test_d_mb04


subroutine test_g_mb05(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   real(wp), parameter :: eref = -27.735987624622005_wp, gref(3, 16) = reshape([&
      & -1.82353787492949E-3_wp,  1.31818459922823E-3_wp,  8.58226495653576E-3_wp, &
      &  1.97688739182230E-2_wp, -7.29458073763057E-3_wp, -6.04380003974638E-3_wp, &
      &  3.98810014714115E-3_wp,  6.14906826920453E-3_wp,  4.80384729197490E-3_wp, &
      &  9.11662446246199E-3_wp,  8.11888967395009E-4_wp, -2.06033497236509E-3_wp, &
      &  6.93297807104095E-3_wp, -9.99636455500038E-4_wp, -5.74433211393415E-3_wp, &
      & -4.86754354610952E-3_wp, -3.06270172653747E-3_wp, -2.01091116475248E-3_wp, &
      &  4.16440905040429E-3_wp, -2.03405181467356E-3_wp, -6.07808932105647E-4_wp, &
      & -2.20381696875807E-2_wp, -1.11474305059426E-4_wp,  7.88311942639446E-3_wp, &
      & -1.13525078678607E-3_wp, -9.03126254289776E-3_wp,  5.41440972040784E-3_wp, &
      & -4.31763236474853E-4_wp,  7.28641048680264E-3_wp,  1.46388718395281E-3_wp, &
      & -9.52395151098753E-3_wp, -3.06196332824414E-4_wp, -1.18009384848677E-2_wp, &
      & -3.17217740137865E-3_wp,  1.23412949417049E-2_wp, -6.93057638998609E-3_wp, &
      &  3.84703556856836E-3_wp, -5.30965159378415E-3_wp, -4.76649943206558E-3_wp, &
      &  4.01813275719477E-3_wp, -6.60996461366484E-3_wp, -4.94608420633252E-3_wp, &
      &  4.66628771990608E-3_wp,  2.54601905375790E-3_wp,  1.53173370986307E-3_wp, &
      & -1.35100476506938E-2_wp,  4.30665380447907E-3_wp,  1.52320234470266E-2_wp],&
      & shape(gref))

   call get_structure(mol, "MB16-43", "05")
   allocate(gradient(3, mol%nat), sigma(3, 3))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call new_gfn2_calculator(calc, mol)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)

   cont = empty_interaction()
   call calc%push_back(cont)

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, eref, thr=thr)
   if (allocated(error)) return
   call check(error, all(abs(gradient - gref) < thr))

end subroutine test_g_mb05


subroutine test_g_mb06(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   real(wp), parameter :: eref = -18.559531670207463_wp, gref(3, 16) = reshape([&
      & -7.68855208823154E-3_wp,  2.10638867503445E-2_wp,  2.41215155941334E-3_wp, &
      &  2.90805965762717E-3_wp, -1.75018015056621E-3_wp,  3.85582760443651E-3_wp, &
      &  1.54219205661951E-3_wp,  1.32376377402360E-3_wp,  1.01824888645767E-3_wp, &
      & -1.91452656544107E-2_wp, -2.23384392341465E-2_wp,  5.48586109290690E-3_wp, &
      & -4.39746104836314E-3_wp, -1.10529660508857E-2_wp, -2.03434329217776E-2_wp, &
      &  9.62864183290068E-3_wp,  9.33495782979855E-3_wp,  4.28513096166196E-3_wp, &
      &  3.40301832758327E-3_wp,  1.33326298386767E-2_wp,  3.81296500108361E-4_wp, &
      & -2.32159630655584E-3_wp,  8.79100677206436E-4_wp, -2.03120821307283E-3_wp, &
      &  1.73423639495923E-2_wp,  1.52735549282184E-2_wp, -5.01999960210040E-3_wp, &
      & -3.35073564349097E-3_wp, -1.59744035347341E-2_wp,  8.31528670874199E-3_wp, &
      & -1.82578281101229E-3_wp, -3.86682679585475E-3_wp, -1.47462197318047E-3_wp, &
      &  1.33591887148489E-3_wp, -9.88764121832669E-4_wp,  6.43834617770471E-3_wp, &
      & -2.84651079600129E-3_wp,  1.62990353769770E-3_wp,  1.10448375328198E-3_wp, &
      &  4.00339318812389E-3_wp, -1.03144794325501E-3_wp,  4.05047193028005E-3_wp, &
      &  1.72567953487094E-3_wp, -6.60586563316507E-3_wp, -3.98074228816423E-3_wp, &
      & -3.13363070736831E-4_wp,  7.71096128474042E-4_wp, -4.49710017669782E-3_wp],&
      & shape(gref))

   call get_structure(mol, "MB16-43", "06")
   allocate(gradient(3, mol%nat), sigma(3, 3))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call new_gfn2_calculator(calc, mol)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)

   cont = empty_interaction()
   call calc%push_back(cont)

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, eref, thr=thr)
   if (allocated(error)) return
   call check(error, all(abs(gradient - gref) < thr))

end subroutine test_g_mb06


end module test_xtb_external

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_output_format
   use mctc_env, only : wp
   implicit none
   private

   public :: format_string

   interface format_string
      module procedure :: format_string_int
      module procedure :: format_string_real_dp
   end interface format_string

contains

pure function format_string_real_dp(val, format) result(str)
   real(wp), intent(in) :: val
   character(len=*), intent(in) :: format
   character(len=:), allocatable :: str

   character(len=128) :: buffer
   integer :: stat

   write(buffer, format, iostat=stat) val
   if (stat == 0) then
      str = trim(buffer)
   else
      str = "*"
   end if
end function format_string_real_dp

pure function format_string_int(val, format) result(str)
   integer, intent(in) :: val
   character(len=*), intent(in) :: format
   character(len=:), allocatable :: str

   character(len=128) :: buffer
   integer :: stat

   write(buffer, format, iostat=stat) val
   if (stat == 0) then
      str = trim(buffer)
   else
      str = "*"
   end if
end function format_string_int

end module tblite_output_format

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_spin
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type, new
   use mstore, only : get_structure
   use tblite_basis_type, only : basis_type
   use tblite_container, only : container_type, container_cache
   use tblite_context_type, only : context_type
   use tblite_data_spin, only : get_spin_constant
   use tblite_spin, only : spin_polarization, new_spin_polarization
   use tblite_wavefunction_type, only : wavefunction_type, new_wavefunction
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_gfn1, only : new_gfn1_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   implicit none
   private

   public :: collect_spin

   real(wp), parameter :: acc = 0.01_wp
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp), parameter :: thr2 = 1e+4_wp*sqrt(epsilon(1.0_wp))
   real(wp), parameter :: kt = 300.0_wp * 3.166808578545117e-06_wp

  real(wp), parameter :: aatoau = 1.0_wp / 0.529177249_wp, &
     & ctoau = 1.0_wp / 1.60217653e-19_wp, jtoau = 1.0_wp / 4.3597441775e-18_wp
  !> Convert V/Å = J/(C·Å) to atomic units
  real(wp), parameter :: vatoau = jtoau / (ctoau * aatoau)

  type, extends(container_type) :: empty_interaction
  end type empty_interaction

contains


!> Collect all exported unit tests
subroutine collect_spin(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("gfn1-e-spin", test_e_crcp2), &
      new_unittest("gfn2-e-spin", test_e_p10), &
      new_unittest("gfn1-g-spin", test_g_p10), &
      new_unittest("gfn2-g-spin", test_g_crcp2) &
      ]

end subroutine collect_spin


subroutine test_e_p10(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy
   real(wp), parameter :: ref1 = -10.802158458119459_wp, ref0 = -10.789711352994029_wp

   call rse43_p10(mol)
   energy = 0.0_wp

   call new_gfn2_calculator(calc, mol)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 2, kt)

   block
      type(spin_polarization), allocatable :: spin
      real(wp), allocatable :: wll(:, :, :)
      allocate(spin)
      call get_spin_constants(wll, mol, calc%bas)
      call new_spin_polarization(spin, mol, wll, calc%bas%nsh_id)
      call move_alloc(spin, cont)
      call calc%push_back(cont)
   end block

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0)

   call check(error, energy, ref1, thr=thr)
   if (allocated(error)) return

   call calc%pop(cont)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0)

   call check(error, energy, ref0, thr=thr)

end subroutine test_e_p10


subroutine test_e_crcp2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   real(wp), parameter :: ref1 = -28.373975300991656_wp, ref0 = -28.349613833733063_wp

   call crcp2(mol)
   allocate(gradient(3, mol%nat), sigma(3, 3))
   energy = 0.0_wp

   call new_gfn1_calculator(calc, mol)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 2, kt)

   block
      type(spin_polarization), allocatable :: spin
      real(wp), allocatable :: wll(:, :, :)
      allocate(spin)
      call get_spin_constants(wll, mol, calc%bas)
      call new_spin_polarization(spin, mol, wll, calc%bas%nsh_id)
      call move_alloc(spin, cont)
      call calc%push_back(cont)
   end block

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, ref1, thr=thr)
   if (allocated(error)) return

   mol%uhf = 0
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 2, kt)

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, ref0, thr=thr)
   if (allocated(error)) return

   call calc%pop(cont)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, ref0, thr=thr)

end subroutine test_e_crcp2


subroutine test_g_p10(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   real(wp), parameter :: eref = -10.802158458119459_wp, gref(3, 8) = reshape([&
      &  3.44372867961642E-2_wp, 2.89668908616586E-2_wp, 0.00000000000000E+0_wp, &
      & -2.80723809016365E-2_wp,-1.00834875574939E-2_wp, 0.00000000000000E+0_wp, &
      &  1.04211820977626E-2_wp,-9.05593425636342E-3_wp, 0.00000000000000E+0_wp, &
      & -1.13278278111116E-3_wp,-3.35609740436932E-3_wp, 0.00000000000000E+0_wp, &
      & -3.49675168314730E-3_wp, 6.69933288874169E-4_wp, 0.00000000000000E+0_wp, &
      & -6.26451127274136E-3_wp,-3.91350539652029E-3_wp, 6.24022723117457E-3_wp, &
      & -6.26451127274141E-3_wp,-3.91350539652033E-3_wp,-6.24022723117462E-3_wp, &
      &  3.72469017451023E-4_wp, 6.85705860734490E-4_wp, 0.00000000000000E+0_wp],&
      & shape(gref))

   call rse43_p10(mol)
   allocate(gradient(3, mol%nat), sigma(3, 3))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call new_gfn2_calculator(calc, mol)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 2, kt)

   block
      type(spin_polarization), allocatable :: spin
      real(wp), allocatable :: wll(:, :, :)
      allocate(spin)
      call get_spin_constants(wll, mol, calc%bas)
      call new_spin_polarization(spin, mol, wll, calc%bas%nsh_id)
      call move_alloc(spin, cont)
      call calc%push_back(cont)
   end block

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, eref, thr=thr)
   if (allocated(error)) return
   call check(error, all(abs(gradient - gref) < thr))

end subroutine test_g_p10


subroutine test_g_crcp2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   real(wp), parameter :: eref = -28.468935665985757_wp, gref(3, 21) = reshape([&
      &  0.00000000000000E+0_wp, 0.00000000000000E+0_wp, 1.49861687763978E-2_wp, &
      &  0.00000000000000E+0_wp,-1.16038259401258E-2_wp, 2.03502831773555E-2_wp, &
      &  1.74447048728472E-2_wp,-4.60640513497974E-3_wp,-3.72049040084506E-3_wp, &
      & -3.28789545574795E-3_wp, 3.63968948328127E-3_wp,-9.31846330721445E-3_wp, &
      &  3.28789545573468E-3_wp, 3.63968948328219E-3_wp,-9.31846330718765E-3_wp, &
      & -1.74447048728304E-2_wp,-4.60640513497095E-3_wp,-3.72049040086045E-3_wp, &
      &  0.00000000000000E+0_wp,-3.53779049238523E-3_wp, 2.23088623183937E-3_wp, &
      &  2.14952077707115E-3_wp,-4.18349753460354E-3_wp,-8.67369569229115E-5_wp, &
      &  5.33595323144723E-4_wp,-4.80615218621908E-3_wp,-1.91143623372045E-3_wp, &
      & -5.33595323142007E-4_wp,-4.80615218621850E-3_wp,-1.91143623372393E-3_wp, &
      & -2.14952077707253E-3_wp,-4.18349753460315E-3_wp,-8.67369569205225E-5_wp, &
      &  1.74447048728435E-2_wp, 4.60640513497770E-3_wp,-3.72049040084305E-3_wp, &
      &  0.00000000000000E+0_wp, 1.16038259401211E-2_wp, 2.03502831773515E-2_wp, &
      & -3.28789545574107E-3_wp,-3.63968948327898E-3_wp,-9.31846330721205E-3_wp, &
      &  2.14952077707168E-3_wp, 4.18349753460354E-3_wp,-8.67369569235181E-5_wp, &
      & -1.74447048728271E-2_wp, 4.60640513497129E-3_wp,-3.72049040085343E-3_wp, &
      &  0.00000000000000E+0_wp, 3.53779049238530E-3_wp, 2.23088623184008E-3_wp, &
      &  3.28789545572897E-3_wp,-3.63968948327921E-3_wp,-9.31846330719197E-3_wp, &
      &  5.33595323143857E-4_wp, 4.80615218621915E-3_wp,-1.91143623372073E-3_wp, &
      & -2.14952077707288E-3_wp, 4.18349753460300E-3_wp,-8.67369569215739E-5_wp, &
      & -5.33595323141162E-4_wp, 4.80615218621862E-3_wp,-1.91143623372332E-3_wp],&
      & shape(gref))

   call crcp2(mol)
   allocate(gradient(3, mol%nat), sigma(3, 3))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call new_gfn2_calculator(calc, mol)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 2, kt)

   block
      type(spin_polarization), allocatable :: spin
      real(wp), allocatable :: wll(:, :, :)
      allocate(spin)
      call get_spin_constants(wll, mol, calc%bas)
      call new_spin_polarization(spin, mol, wll, calc%bas%nsh_id)
      call move_alloc(spin, cont)
      call calc%push_back(cont)
   end block

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, eref, thr=thr)
   if (allocated(error)) return
   call check(error, all(abs(gradient - gref) < thr))

end subroutine test_g_crcp2


subroutine get_spin_constants(wll, mol, bas)
   real(wp), allocatable, intent(out) :: wll(:, :, :)
   type(structure_type), intent(in) :: mol
   type(basis_type), intent(in) :: bas

   integer :: izp, ish, jsh, il, jl

   allocate(wll(bas%nsh, bas%nsh, mol%nid), source=0.0_wp)

   do izp = 1, mol%nid
      do ish = 1, bas%nsh_id(izp)
         il = bas%cgto(ish, izp)%ang
         do jsh = 1, bas%nsh_id(izp)
            jl = bas%cgto(jsh, izp)%ang
            wll(jsh, ish, izp) = get_spin_constant(jl, il, mol%num(izp))
         end do
      end do
   end do
end subroutine get_spin_constants


subroutine rse43_p10(self)
   type(structure_type), intent(out) :: self
   integer, parameter :: nat = 8
   character(len=*), parameter :: sym(nat) = [character(len=4)::&
      & "C", "C", "O", "H", "H", "H", "H", "H"]
   real(wp), parameter :: xyz(3, nat) = reshape([&
      & -1.97051959765227_wp, -0.86572333787476_wp,  0.00000000000000_wp, &
      &  0.35098462279192_wp,  0.68629061984403_wp,  0.00000000000000_wp, &
      &  2.50609985217434_wp, -0.93449614912242_wp,  0.00000000000000_wp, &
      & -1.83649606109455_wp, -2.90299181092582_wp,  0.00000000000000_wp, &
      & -3.80466245712260_wp,  0.03498324286025_wp,  0.00000000000000_wp, &
      &  0.37355558151150_wp,  1.94431040908593_wp, -1.66596178649581_wp, &
      &  0.37355558151150_wp,  1.94431040908593_wp,  1.66596178649581_wp, &
      &  4.00748247788017_wp,  0.09331661704686_wp,  0.00000000000000_wp],&
      & shape(xyz))
   integer, parameter :: uhf = 1
   call new(self, sym, xyz, uhf=uhf)
end subroutine rse43_p10


subroutine crcp2(self)
   type(structure_type), intent(out) :: self
   integer, parameter :: nat = 21
   character(len=*), parameter :: sym(nat) = [character(len=4)::&
      & "Cr", "C", "C", "C", "C", "C", "H", "H", "H", "H", "H", "C", "C", "C", &
      & "H", "C", "H", "C", "H", "H", "H"]
   real(wp), parameter :: xyz(3, nat) = reshape([&
      &  0.00000000000000_wp,  0.00000000000000_wp, -0.06044684528305_wp, &
      &  0.00000000000000_wp,  3.19613712523832_wp,  2.30877824528581_wp, &
      &  2.18828801115897_wp,  3.32943780995849_wp,  0.70249948585734_wp, &
      &  1.33235791539260_wp,  3.55640652898451_wp, -1.83908673090077_wp, &
      & -1.33235791539260_wp,  3.55640652898451_wp, -1.83908673090077_wp, &
      & -2.18828801115897_wp,  3.32943780995849_wp,  0.70249948585734_wp, &
      &  0.00000000000000_wp,  3.10509505378016_wp,  4.34935395653655_wp, &
      &  4.13810718850644_wp,  3.28428734944129_wp,  1.31235006648465_wp, &
      &  2.52190264478214_wp,  3.60569548880830_wp, -3.50208900904435_wp, &
      & -2.52190264478214_wp,  3.60569548880830_wp, -3.50208900904435_wp, &
      & -4.13810718850644_wp,  3.28428734944129_wp,  1.31235006648465_wp, &
      &  2.18828801115897_wp, -3.32943780995849_wp,  0.70249948585734_wp, &
      &  0.00000000000000_wp, -3.19613712523832_wp,  2.30877824528581_wp, &
      &  1.33235791539260_wp, -3.55640652898451_wp, -1.83908673090077_wp, &
      &  4.13810718850644_wp, -3.28428734944129_wp,  1.31235006648465_wp, &
      & -2.18828801115897_wp, -3.32943780995849_wp,  0.70249948585734_wp, &
      &  0.00000000000000_wp, -3.10509505378016_wp,  4.34935395653655_wp, &
      & -1.33235791539260_wp, -3.55640652898451_wp, -1.83908673090077_wp, &
      &  2.52190264478214_wp, -3.60569548880830_wp, -3.50208900904435_wp, &
      & -4.13810718850644_wp, -3.28428734944129_wp,  1.31235006648465_wp, &
      & -2.52190264478214_wp, -3.60569548880830_wp, -3.50208900904435_wp],&
      & shape(xyz))
   integer, parameter :: uhf = 2
   call new(self, sym, xyz, uhf=uhf)
end subroutine crcp2


end module test_spin

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/scf
!> Contains the implementation for the self-consistent field iterations

!> @file tblite/scf.f90
!> Reexports the self-consistent field iteration related functionality.

!> Proxy module for rexports from SCF related modules
module tblite_scf
   use tblite_scf_mixer, only : mixer_type, new_mixer
   use tblite_scf_info, only : scf_info
   use tblite_scf_iterator, only : next_scf, get_mixer_dimension
   use tblite_scf_potential, only : potential_type, new_potential
   implicit none
   private

   public :: mixer_type, new_mixer, scf_info, next_scf, get_mixer_dimension, &
      & potential_type, new_potential

end module tblite_scf

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_wavefunction_mulliken
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_basis_type, only : basis_type
   use tblite_wavefunction_spin, only : updown_to_magnet
   implicit none
   private

   public :: get_mulliken_shell_charges, get_mulliken_atomic_multipoles
   public :: get_molecular_dipole_moment, get_molecular_quadrupole_moment

contains


subroutine get_mulliken_shell_charges(bas, smat, pmat, n0sh, qsh)
   type(basis_type), intent(in) :: bas
   real(wp), intent(in) :: smat(:, :)
   real(wp), intent(in) :: pmat(:, :, :)
   real(wp), intent(in) :: n0sh(:)
   real(wp), intent(out) :: qsh(:, :)

   integer :: iao, jao, spin
   real(wp) :: pao

   qsh(:, :) = 0.0_wp
   !$omp parallel do default(none) collapse(2) schedule(runtime) reduction(+:qsh) &
   !$omp shared(bas, pmat, smat) private(spin, iao, jao, pao)
   do spin = 1, size(pmat, 3)
      do iao = 1, bas%nao
         pao = 0.0_wp
         do jao = 1, bas%nao
            pao = pao + pmat(jao, iao, spin) * smat(jao, iao)
         end do
         qsh(bas%ao2sh(iao), spin) = qsh(bas%ao2sh(iao), spin) - pao
      end do
   end do

   call updown_to_magnet(qsh)
   qsh(:, 1) = qsh(:, 1) + n0sh

end subroutine get_mulliken_shell_charges


subroutine get_mulliken_atomic_multipoles(bas, mpmat, pmat, mpat)
   type(basis_type), intent(in) :: bas
   real(wp), intent(in) :: mpmat(:, :, :)
   real(wp), intent(in) :: pmat(:, :, :)
   real(wp), intent(out) :: mpat(:, :, :)

   integer :: iao, jao, spin
   real(wp) :: pao(size(mpmat, 1))

   mpat(:, :, :) = 0.0_wp
   !$omp parallel do default(none) schedule(runtime) reduction(+:mpat) &
   !$omp shared(bas, pmat, mpmat) private(spin, iao, jao, pao)
   do spin = 1, size(pmat, 3)
      do iao = 1, bas%nao
         pao(:) = 0.0_wp
         do jao = 1, bas%nao
            pao(:) = pao + pmat(jao, iao, spin) * mpmat(:, jao, iao)
         end do
         mpat(:, bas%ao2at(iao), spin) = mpat(:, bas%ao2at(iao), spin) - pao
      end do
   end do

   call updown_to_magnet(mpat)

end subroutine get_mulliken_atomic_multipoles


subroutine get_molecular_dipole_moment(mol, qat, dpat, dpmom)
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: qat(:)
   real(wp), intent(in) :: dpat(:, :)
   real(wp), intent(out) :: dpmom(:)

   integer :: iat

   dpmom(:) = 0.0_wp
   do iat = 1, mol%nat
      dpmom(:) = dpmom + mol%xyz(:, iat) * qat(iat) + dpat(:, iat)
   end do
end subroutine get_molecular_dipole_moment

subroutine get_molecular_quadrupole_moment(mol, qat, dpat, qpat, qpmom)
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: qat(:)
   real(wp), intent(in) :: dpat(:, :)
   real(wp), intent(in) :: qpat(:, :)
   real(wp), intent(out) :: qpmom(:)

   integer :: iat
   real(wp) :: vec(3), cart(6), tr

   qpmom(:) = 0.0_wp
   do iat = 1, mol%nat
      vec(:) = mol%xyz(:, iat)*qat(iat)
      cart([1, 3, 6]) = mol%xyz(:, iat) * (vec + 2*dpat(:, iat))
      cart(2) = mol%xyz(1, iat) * (vec(2) + dpat(2, iat)) + dpat(1, iat)*mol%xyz(2, iat)
      cart(4) = mol%xyz(1, iat) * (vec(3) + dpat(3, iat)) + dpat(1, iat)*mol%xyz(3, iat)
      cart(5) = mol%xyz(2, iat) * (vec(3) + dpat(3, iat)) + dpat(2, iat)*mol%xyz(3, iat)
      tr = 0.5_wp * (cart(1) + cart(3) + cart(6))
      cart(1) = 1.5_wp * cart(1) - tr
      cart(2) = 3.0_wp * cart(2)
      cart(3) = 1.5_wp * cart(3) - tr
      cart(4) = 3.0_wp * cart(4)
      cart(5) = 3.0_wp * cart(5)
      cart(6) = 1.5_wp * cart(6) - tr
      qpmom(:) = qpmom(:) + qpat(:, iat) + cart
   end do
end subroutine get_molecular_quadrupole_moment


end module tblite_wavefunction_mulliken

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_solvation_input
   use tblite_solvation_alpb, only : alpb_input
   use tblite_solvation_cpcm, only : cpcm_input
   implicit none
   private

   public :: solvation_input


   !> Collection of possible solvation models
   type :: solvation_input
      !> Input for CPCM solvation model
      type(cpcm_input), allocatable :: cpcm
      !> Input for ALPB solvation model
      type(alpb_input), allocatable :: alpb
   end type solvation_input

end module tblite_solvation_input

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/solvation/data/shift
!> Provides solvent specific data for solvation state shift

!> @file tblite/solvation/data/shift.f90
!> Provides parameters for solvation state shift

!> ALPB/GBSA shift parameters
module tblite_solvation_data_shift
   use mctc_env, only : error_type, fatal_error
   use mctc_env, only : wp
   use tblite_solvation_shift, only: shift_input
   use mctc_io_convert, only : kcaltoau
   implicit none
   private

   public :: get_shift_param

   !> Parameters for solvation state shift
   type :: shift_parameter
      !> Molar mass of solvent
      real(wp) :: smass = 0.0_wp
      !> Density of solvent
      real(wp) :: rhos = 0.0_wp
      !> Solvent specific free energy shift
      real(wp) :: gshift = 0.0_wp
   end type shift_parameter

   include 'shift/param_gbsa_acetone.fh'
   include 'shift/param_gbsa_acetonitrile.fh'
   include 'shift/param_gbsa_benzene.fh'
   include 'shift/param_gbsa_ch2cl2.fh'
   include 'shift/param_gbsa_chcl3.fh'
   include 'shift/param_gbsa_cs2.fh'
   include 'shift/param_gbsa_dmf.fh'
   include 'shift/param_gbsa_dmso.fh'
   include 'shift/param_gbsa_ether.fh'
   include 'shift/param_gbsa_hexane.fh'
   include 'shift/param_gbsa_methanol.fh'
   include 'shift/param_gbsa_thf.fh'
   include 'shift/param_gbsa_toluene.fh'
   include 'shift/param_gbsa_water.fh'

   include 'shift/param_alpb_acetone.fh'
   include 'shift/param_alpb_acetonitrile.fh'
   include 'shift/param_alpb_aniline.fh'
   include 'shift/param_alpb_benzaldehyde.fh'
   include 'shift/param_alpb_benzene.fh'
   include 'shift/param_alpb_ch2cl2.fh'
   include 'shift/param_alpb_chcl3.fh'
   include 'shift/param_alpb_cs2.fh'
   include 'shift/param_alpb_dioxane.fh'
   include 'shift/param_alpb_dmf.fh'
   include 'shift/param_alpb_dmso.fh'
   include 'shift/param_alpb_ethanol.fh'
   include 'shift/param_alpb_ether.fh'
   include 'shift/param_alpb_ethylacetate.fh'
   include 'shift/param_alpb_furane.fh'
   include 'shift/param_alpb_hexadecane.fh'
   include 'shift/param_alpb_hexane.fh'
   include 'shift/param_alpb_nitromethane.fh'
   include 'shift/param_alpb_octanol.fh'
   include 'shift/param_alpb_phenol.fh'
   include 'shift/param_alpb_thf.fh'
   include 'shift/param_alpb_toluene.fh'
   include 'shift/param_alpb_water.fh'
   include 'shift/param_alpb_woctanol.fh'
   include 'shift/param_alpb_methanol.fh'

contains

!> Get ALPB/GBSA shift parameters
subroutine get_shift_param(input, method, error)
   !> Input of ALPB
   type(shift_input), intent(inout) :: input
   !> Method for parameter selection
   character(len=*), intent(in) :: method
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> internal parameters to be used
   type(shift_parameter), allocatable :: param

   select case(input%alpb)
   case(.false.)
      if (method == 'gfn2') then
         select case(input%solvent)
         case('acetone');      param = gfn2_acetone
         case('acetonitrile'); param = gfn2_acetonitrile
         case('benzene');      param = gfn2_benzene
         case('ch2cl2','dichlormethane','methylenechloride');
            param = gfn2_ch2cl2
         case('chcl3','chloroform');       param = gfn2_chcl3
         case('cs2','carbondisulfide');    param = gfn2_cs2
         case('dmf','dimethylformamide');  param = gfn2_dmf
         case('dmso','dimethylsulfoxide'); param = gfn2_dmso
         case('ether','diethylether');     param = gfn2_ether
         case('hexane','nhexan','n-hexan','nhexane','n-hexane');
            param = gfn2_hexane
         case('methanol');                 param = gfn2_methanol
         case('thf','tetrahydrofuran');    param = gfn2_thf
         case('toluene');                  param = gfn2_toluene         
         case('water','h2o');              param = gfn2_water
         end select
      else if (method == 'gfn1') then
         select case(input%solvent)
         case('acetone');      param = gfn1_acetone
         case('acetonitrile'); param = gfn1_acetonitrile
         case('benzene');      param = gfn1_benzene
         case('ch2cl2','dichlormethane','methylenechloride');
            param = gfn1_ch2cl2
         case('chcl3','chloroform');       param = gfn1_chcl3
         case('cs2','carbondisulfide');    param = gfn1_cs2
         case('dmso','dimethylsulfoxide'); param = gfn1_dmso
         case('ether','diethylether');     param = gfn1_ether
         case('methanol');                 param = gfn1_methanol
         case('thf','tetrahydrofuran');    param = gfn1_thf
         case('toluene');                  param = gfn1_toluene
         case('water','h2o');              param = gfn1_water
         end select
      end if
   case(.true.)
      if (method == 'gfn2') then
         select case(input%solvent)
         case('acetone');      param = gfn2_alpb_acetone
         case('acetonitrile'); param = gfn2_alpb_acetonitrile
         case('aniline');      param = gfn2_alpb_aniline
         case('benzaldehyde'); param = gfn2_alpb_benzaldehyde
         case('benzene');      param = gfn2_alpb_benzene
         case('ch2cl2','dichlormethane','methylenechloride'); 
            param = gfn2_alpb_ch2cl2
         case('chcl3','chloroform');       param = gfn2_alpb_chcl3
         case('cs2','carbondisulfide');    param = gfn2_alpb_cs2
         case('dioxane');      param = gfn2_alpb_dioxane
         case('dmf','dimethylformamide');  param = gfn2_alpb_dmf
         case('dmso','dimethylsulfoxide'); param = gfn2_alpb_dmso
         case('ethanol');      param = gfn2_alpb_ethanol
         case('ether','diethylether');     param = gfn2_alpb_ether
         case('ethylacetate'); param = gfn2_alpb_ethylacetate
         case('furane');       param = gfn2_alpb_furane
         case('hexadecane');   param = gfn2_alpb_hexadecane
         case('hexane','nhexan','n-hexan','nhexane','n-hexane');
            param = gfn2_alpb_hexane
         case('nitromethane'); param = gfn2_alpb_nitromethane
         case('methanol');     param = gfn2_alpb_methanol 
         case('octanol');      param = gfn2_alpb_octanol
         case('phenol');       param = gfn2_alpb_phenol 
         case('thf','tetrahydrofuran');    param = gfn2_alpb_thf
         case('toluene');      param = gfn2_alpb_toluene
         case('water','h2o');  param = gfn2_alpb_water
         case('woctanol');     param = gfn2_alpb_woctanol
         end select
      else if (method == 'gfn1') then
         select case(input%solvent)
         case('acetone');      param = gfn1_alpb_acetone
         case('acetonitrile'); param = gfn1_alpb_acetonitrile
         case('aniline');      param = gfn1_alpb_aniline
         case('benzaldehyde'); param = gfn1_alpb_benzaldehyde
         case('benzene');      param = gfn1_alpb_benzene
         case('ch2cl2','dichlormethane','methylenechloride');
            param = gfn1_alpb_ch2cl2
         case('chcl3','chloroform');       param = gfn1_alpb_chcl3
         case('cs2','carbondisulfide');    param = gfn1_alpb_cs2
         case('dioxane');      param = gfn1_alpb_dioxane
         case('dmf','dimethylformamide');  param = gfn1_alpb_dmf
         case('dmso','dimethylsulfoxide'); param = gfn1_alpb_dmso
         case('ethanol');      param = gfn1_alpb_ethanol
         case('ether','diethylether');     param = gfn1_alpb_ether
         case('ethylacetate'); param = gfn1_alpb_ethylacetate
         case('furane');       param = gfn1_alpb_furane
         case('hexadecane');   param = gfn1_alpb_hexadecane
         case('hexane','nhexan','n-hexan','nhexane','n-hexane');
            param = gfn1_alpb_hexane
         case('nitromethane'); param = gfn1_alpb_nitromethane
         case('methanol');     param = gfn1_alpb_methanol
         case('octanol');      param = gfn1_alpb_octanol
         case('phenol');       param = gfn1_alpb_phenol 
         case('thf','tetrahydrofuran');    param = gfn1_alpb_thf
         case('toluene');      param = gfn1_alpb_toluene
         case('water','h2o');  param = gfn1_alpb_water
         case('woctanol');     param = gfn1_alpb_woctanol
         end select
      end if
   end select

   if (.not.allocated(param)) then
      call fatal_error(error, "Unknown solvent, cannot set up ALPB/GBSA shift")
      return
   end if
 
   call load_shift_param(input, param)

end subroutine get_shift_param

!> Load ALPB/GBSA shift parameters
subroutine load_shift_param(input, param)
   !> Input of ALPB
   type(shift_input), intent(inout) :: input
   !> Internal parameters to be used
   type(shift_parameter), intent(in) :: param

   input%molar_mass = param%smass

   input%rho = param%rhos

   input%gshift = param%gshift * kcaltoau

end subroutine load_shift_param

end module tblite_solvation_data_shift

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_solvation
   use mctc_env, only : error_type, fatal_error
   use mctc_io, only : structure_type
   use tblite_solvation_alpb, only : alpb_solvation, new_alpb, alpb_input
   use tblite_solvation_cpcm, only : cpcm_solvation, new_cpcm, cpcm_input
   use tblite_solvation_data, only : solvent_data, get_solvent_data
   use tblite_solvation_input, only : solvation_input
   use tblite_solvation_type, only : solvation_type
   implicit none
   private

   public :: alpb_solvation, new_alpb, alpb_input
   public :: cpcm_solvation, new_cpcm, cpcm_input
   public :: solvent_data, get_solvent_data
   public :: solvation_input, new_solvation, solvation_type


contains

!> Create new solvation model from input data
subroutine new_solvation(solv, mol, input, error)
   !> Instance of the solvation model
   class(solvation_type), allocatable, intent(out) :: solv
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input data
   type(solvation_input), intent(in) :: input
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   if (allocated(input%alpb)) then
      solv = alpb_solvation(mol, input%alpb)
      return
   end if

   if (allocated(input%cpcm)) then
      solv = cpcm_solvation(mol, input%cpcm)
      return
   end if

   call fatal_error(error, "Unknown solvation model")
end subroutine new_solvation

end module tblite_solvation

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Proxy module for general interaction containers.
!>
!> Provides access to the abstract base class [[container_type]] for declaring
!> a new interaction. Container extending the base class can provide (semi-)classical
!> energy contributions, i.e. independent of the density and/or density-dependent
!> contributions, which are included in the minimization of the electronic energy.
!>
!> The [[container_type]] itself is immutable once constructed, restart data must
!> be associated with a [[container_cache]] object. This cache object can be
!> populated in an [[container_type:update]] procedure. The update procedure is
!> allowed to invalidate existing caches and reallocate them as needed.
!>
!> Additionally, to ease compilation of several containers in an actual calculator
!> the [[container_list]] type is provided, which itself extends the [[container_type]]
!> base class to provide an uniform interface.
!>
!> New containers are added to the list by using the [[container_list:push_back]]
!> procedure. Since the list owns the containers, the container object should be
!> provided as allocatable class polymorphic [[container_type]], i.e. by transfer
!> using the intrinsic `move_alloc` procedure or by automatic LHS allocation of
!> the polymorphic object.
module tblite_container
   use tblite_container_cache, only : container_cache
   use tblite_container_list, only : container_list
   use tblite_container_type, only : container_type
   implicit none
   public
end module tblite_container

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_lapack_getri
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_getri


   !> Computes the inverse of a matrix using the LU factorization
   !> computed by ?GETRF.
   !>
   !> This method inverts U and then computes inv(A) by solving the system
   !> inv(A)*L = inv(U) for inv(A).
   interface wrap_getri
      module procedure :: wrap_sgetri
      module procedure :: wrap_dgetri
   end interface wrap_getri


   !> Computes the inverse of a matrix using the LU factorization
   !> computed by ?GETRF.
   !>
   !> This method inverts U and then computes inv(A) by solving the system
   !> inv(A)*L = inv(U) for inv(A).
   interface lapack_getri
      pure subroutine sgetri(n, a, lda, ipiv, work, lwork, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine sgetri
      pure subroutine dgetri(n, a, lda, ipiv, work, lwork, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine dgetri
   end interface lapack_getri

contains

subroutine wrap_sgetri(amat, ipiv, info)
   real(sp), intent(inout) :: amat(:, :)
   integer, intent(in) :: ipiv(:)
   integer, intent(out) :: info
   integer :: n, lda, lwork
   real(sp), allocatable :: work(:)
   real(sp) :: test(1)
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   lwork = -1
   call lapack_getri(n, amat, lda, ipiv, test, lwork, info)
   if (info == 0) then
      lwork = nint(test(1))
      allocate(work(lwork))
      call lapack_getri(n, amat, lda, ipiv, work, lwork, info)
   end if
end subroutine wrap_sgetri


subroutine wrap_dgetri(amat, ipiv, info)
   real(dp), intent(inout) :: amat(:, :)
   integer, intent(in) :: ipiv(:)
   integer, intent(out) :: info
   integer :: n, lda, lwork
   real(dp), allocatable :: work(:)
   real(dp) :: test(1)
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   lwork = -1
   call lapack_getri(n, amat, lda, ipiv, test, lwork, info)
   if (info == 0) then
      lwork = nint(test(1))
      allocate(work(lwork))
      call lapack_getri(n, amat, lda, ipiv, work, lwork, info)
   end if
end subroutine wrap_dgetri

end module tblite_lapack_getri

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/wavefunction/spin.f90
!> Provides conversion routines to change the representation of spin-polarized densities

!> Handling of spin information in the wavefunction
!>
!> Spin is represented as charge and magnetization density in the population based
!> properties, *e.g.* Mulliken partial charges, atomic dipole moments, ..., and
!> in up/down representation for orbials energies, occupation numbers, ...
module tblite_wavefunction_spin
   use mctc_env, only : wp
   implicit none
   private

   public :: magnet_to_updown, updown_to_magnet


   !> Convert a charge-magnetization representation into an up-down representation
   interface magnet_to_updown
      module procedure :: magnet_to_updown_1
      module procedure :: magnet_to_updown_2
      module procedure :: magnet_to_updown_3
      module procedure :: magnet_to_updown_4
   end interface magnet_to_updown

   !> Convert an up-down representation into a charge-magnetization representation
   interface updown_to_magnet
      module procedure :: updown_to_magnet_1
      module procedure :: updown_to_magnet_2
      module procedure :: updown_to_magnet_3
      module procedure :: updown_to_magnet_4
   end interface updown_to_magnet

contains

!> Convert a charge-magnetization representation into an up-down representation
subroutine magnet_to_updown_1(x)

   !> Data in charge-magnetization representation on entry
   !> transformed to up-down representation on exit
   real(wp), intent(inout) :: x(:)

   if (size(x, 1) == 2) then
      x(1) = 0.5_wp * (x(1) + x(2))
      x(2) = x(1) - x(2)
   end if
end subroutine magnet_to_updown_1

!> Convert a charge-magnetization representation into an up-down representation
subroutine magnet_to_updown_2(x)

   !> Data in charge-magnetization representation on entry
   !> transformed to up-down representation on exit
   real(wp), intent(inout) :: x(:, :)

   if (size(x, 2) == 2) then
      x(:, 1) = 0.5_wp * (x(:, 1) + x(:, 2))
      x(:, 2) = x(:, 1) - x(:, 2)
   end if
end subroutine magnet_to_updown_2

!> Convert a charge-magnetization representation into an up-down representation
subroutine magnet_to_updown_3(x)

   !> Data in charge-magnetization representation on entry
   !> transformed to up-down representation on exit
   real(wp), intent(inout) :: x(:, :, :)

   if (size(x, 3) == 2) then
      x(:, :, 1) = 0.5_wp * (x(:, :, 1) + x(:, :, 2))
      x(:, :, 2) = x(:, :, 1) - x(:, :, 2)
   end if
end subroutine magnet_to_updown_3

!> Convert a charge-magnetization representation into an up-down representation
subroutine magnet_to_updown_4(x)

   !> Data in charge-magnetization representation on entry
   !> transformed to up-down representation on exit
   real(wp), intent(inout) :: x(:, :, :, :)

   if (size(x, 4) == 2) then
      x(:, :, :, 1) = 0.5_wp * (x(:, :, :, 1) + x(:, :, :, 2))
      x(:, :, :, 2) = x(:, :, :, 1) - x(:, :, :, 2)
   end if
end subroutine magnet_to_updown_4

!> Convert an up-down representation into a charge-magnetization representation
subroutine updown_to_magnet_1(x)

   !> Data in up-down representation on entry
   !> transformed to charge-magnetization representation on exit
   real(wp), intent(inout) :: x(:)

   if (size(x, 1) == 2) then
      x(1) = x(1) + x(2)
      x(2) = x(1) - 2.0_wp * x(2)
   end if
end subroutine updown_to_magnet_1

!> Convert an up-down representation into a charge-magnetization representation
subroutine updown_to_magnet_2(x)

   !> Data in up-down representation on entry
   !> transformed to charge-magnetization representation on exit
   real(wp), intent(inout) :: x(:, :)

   if (size(x, 2) == 2) then
      x(:, 1) = x(:, 1) + x(:, 2)
      x(:, 2) = x(:, 1) - 2.0_wp * x(:, 2)
   end if
end subroutine updown_to_magnet_2

!> Convert an up-down representation into a charge-magnetization representation
subroutine updown_to_magnet_3(x)

   !> Data in up-down representation on entry
   !> transformed to charge-magnetization representation on exit
   real(wp), intent(inout) :: x(:, :, :)

   if (size(x, 3) == 2) then
      x(:, :, 1) = x(:, :, 1) + x(:, :, 2)
      x(:, :, 2) = x(:, :, 1) - 2.0_wp * x(:, :, 2)
   end if
end subroutine updown_to_magnet_3

!> Convert an up-down representation into a charge-magnetization representation
subroutine updown_to_magnet_4(x)

   !> Data in up-down representation on entry
   !> transformed to charge-magnetization representation on exit
   real(wp), intent(inout) :: x(:, :, :, :)

   if (size(x, 4) == 2) then
      x(:, :, :, 1) = x(:, :, :, 1) + x(:, :, :, 2)
      x(:, :, :, 2) = x(:, :, :, 1) - 2.0_wp * x(:, :, :, 2)
   end if
end subroutine updown_to_magnet_4

end module tblite_wavefunction_spin

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_ncoord_gfn
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, &
      & test_failed
   use mctc_io_structure, only : structure_type
   use mstore, only : get_structure
   use tblite_cutoff, only : get_lattice_points
   use tblite_data_covrad, only : get_covalent_rad
   use tblite_ncoord_gfn
   implicit none
   private

   public :: collect_ncoord_gfn

   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))


contains


!> Collect all exported unit tests
subroutine collect_ncoord_gfn(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("cn-mb01", test_cn_mb01), &
      & new_unittest("cn-mb02", test_cn_mb02), &
      & new_unittest("cn-mb03", test_cn_mb03), &
      & new_unittest("cn-acetic", test_cn_acetic), &
      & new_unittest("dcndr-mb04", test_dcndr_mb04), &
      & new_unittest("dcndr-mb05", test_dcndr_mb05), &
      & new_unittest("dcndr-ammonia", test_dcndr_ammonia), &
      & new_unittest("dcndL-mb06", test_dcndL_mb06), &
      & new_unittest("dcndL-mb07", test_dcndL_mb07), &
      & new_unittest("dcndL-antracene", test_dcndL_anthracene) &
      & ]

end subroutine collect_ncoord_gfn


subroutine test_cn_gen(error, mol, ref)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type) :: mol

   !> Reference CNs
   real(wp), intent(in) :: ref(:)

   real(wp), allocatable :: cn(:), rcov(:)
   real(wp), parameter :: cutoff = 30.0_wp
   real(wp), allocatable :: lattr(:, :)

   allocate(rcov(mol%nid), cn(mol%nat))
   rcov(:) = get_covalent_rad(mol%num)

   call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)
   call get_coordination_number(mol, lattr, cutoff, rcov, cn)

   if (any(abs(cn - ref) > thr)) then
      call test_failed(error, "Coordination numbers do not match")
      print'(3es21.14)', cn
   end if

end subroutine test_cn_gen


subroutine test_numgrad(error, mol)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   integer :: iat, ic
   real(wp), allocatable :: cn(:), rcov(:), cnr(:), cnl(:)
   real(wp), allocatable :: dcndr(:, :, :), dcndL(:, :, :)
   real(wp), allocatable :: numdr(:, :, :)
   real(wp), allocatable :: lattr(:, :)
   real(wp), parameter :: cutoff = 30.0_wp
   real(wp), parameter :: step = 1.0e-6_wp

   allocate(rcov(mol%nid), cn(mol%nat), cnr(mol%nat), cnl(mol%nat), &
      & dcndr(3, mol%nat, mol%nat), dcndL(3, 3, mol%nat), &
      & numdr(3, mol%nat, mol%nat))
   rcov(:) = get_covalent_rad(mol%num)
   call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)

   do iat = 1, mol%nat
      do ic = 1, 3
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call get_coordination_number(mol, lattr, cutoff, rcov, cnr)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2*step
         call get_coordination_number(mol, lattr, cutoff, rcov, cnl)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         numdr(ic, iat, :) = 0.5_wp*(cnr - cnl)/step
      end do
   end do

   call get_coordination_number(mol, lattr, cutoff, rcov, cn, dcndr, dcndL)

   if (any(abs(dcndr - numdr) > thr2)) then
      call test_failed(error, "Derivative of coordination number does not match")
   end if

end subroutine test_numgrad


subroutine test_numsigma(error, mol)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   integer :: ic, jc
   real(wp) :: eps(3, 3)
   real(wp), allocatable :: cn(:), rcov(:), cnr(:), cnl(:), xyz(:, :)
   real(wp), allocatable :: dcndr(:, :, :), dcndL(:, :, :)
   real(wp), allocatable :: numdL(:, :, :)
   real(wp), allocatable :: lattr(:, :), trans(:, :)
   real(wp), parameter :: cutoff = 30.0_wp
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], shape(unity))
   real(wp), parameter :: step = 1.0e-6_wp

   allocate(rcov(mol%nid), cn(mol%nat), cnr(mol%nat), cnl(mol%nat), &
      & dcndr(3, mol%nat, mol%nat), dcndL(3, 3, mol%nat), xyz(3, mol%nat), &
      & numdL(3, 3, mol%nat))
   rcov(:) = get_covalent_rad(mol%num)
   call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)

   eps(:, :) = unity
   xyz(:, :) = mol%xyz
   trans = lattr
   do ic = 1, 3
      do jc = 1, 3
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = matmul(eps, xyz)
         lattr(:, :) = matmul(eps, trans)
         call get_coordination_number(mol, lattr, cutoff, rcov, cnr)
         eps(jc, ic) = eps(jc, ic) - 2*step
         mol%xyz(:, :) = matmul(eps, xyz)
         lattr(:, :) = matmul(eps, trans)
         call get_coordination_number(mol, lattr, cutoff, rcov, cnl)
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = xyz
         lattr(:, :) = trans
         numdL(jc, ic, :) = 0.5_wp*(cnr - cnl)/step
      end do
   end do

   call get_coordination_number(mol, lattr, cutoff, rcov, cn, dcndr, dcndL)

   if (any(abs(dcndL - numdL) > thr2)) then
      call test_failed(error, "Derivative of coordination number does not match")
   end if

end subroutine test_numsigma


subroutine test_cn_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: ref(16) = [&
      & 4.11453659059991E+0_wp, 9.32058998762811E-1_wp, 2.03554597140311E+0_wp, &
      & 1.42227835389358E+0_wp, 1.12812426574031E+0_wp, 1.05491602558828E+0_wp, &
      & 1.52709064704269E+0_wp, 1.95070367247232E+0_wp, 3.83759889196540E+0_wp, &
      & 1.09388314007182E+0_wp, 1.07090773695340E+0_wp, 2.00285254082830E+0_wp, &
      & 4.36400837813955E+0_wp, 3.83469860546080E+0_wp, 3.91542517673963E+0_wp, &
      & 5.58571682419960E+0_wp]

   call get_structure(mol, "MB16-43", "01")
   call test_cn_gen(error, mol, ref)

end subroutine test_cn_mb01


subroutine test_cn_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: ref(16) = [&
      & 9.16720394154780E-1_wp, 3.81678481096046E+0_wp, 3.58669504034282E+0_wp, &
      & 2.90017371823910E+0_wp, 5.09896950232009E+0_wp, 1.13810142820063E+0_wp, &
      & 9.35735928561309E-1_wp, 9.43324181507483E-1_wp, 4.86704300506033E+0_wp, &
      & 1.22024405676881E+0_wp, 3.86661472534511E+0_wp, 4.02897853934353E+0_wp, &
      & 1.96869999324996E+0_wp, 9.04495366214972E-1_wp, 1.49977675358986E+0_wp, &
      & 2.04937665719480E+0_wp]

   call get_structure(mol, "MB16-43", "02")
   call test_cn_gen(error, mol, ref)

end subroutine test_cn_mb02


subroutine test_cn_mb03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: ref(16) = [&
      & 4.03003984525826E+0_wp, 2.88404829383272E+0_wp, 1.12030447706437E+0_wp, &
      & 4.89326653038565E+0_wp, 6.97177319120287E+0_wp, 4.43722632690247E+0_wp, &
      & 4.74866591812568E+0_wp, 1.30338583081493E+0_wp, 1.06130190313902E+0_wp, &
      & 1.04048373066340E+0_wp, 1.92270060977307E+0_wp, 2.98737904327655E+0_wp, &
      & 4.69081207436918E+0_wp, 1.26260125612717E+0_wp, 3.36368006785498E+0_wp, &
      & 1.35743886389476E+0_wp]

   call get_structure(mol, "MB16-43", "03")
   call test_cn_gen(error, mol, ref)

end subroutine test_cn_mb03


subroutine test_cn_acetic(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: ref(32) = [&
      & 1.11869327906258E+0_wp, 1.11873798419384E+0_wp, 1.11867539605108E+0_wp, &
      & 1.11871888406156E+0_wp, 1.00298061967398E+0_wp, 1.00296246055984E+0_wp, &
      & 1.00292045987951E+0_wp, 9.96672431444661E-1_wp, 9.96665461112044E-1_wp, &
      & 9.96644836940640E-1_wp, 9.96639762485971E-1_wp, 9.96009549496349E-1_wp, &
      & 9.96081138973917E-1_wp, 9.96044567123842E-1_wp, 9.96030395875155E-1_wp, &
      & 1.00297417207048E+0_wp, 3.11025027428883E+0_wp, 3.11027217276691E+0_wp, &
      & 3.11021682807939E+0_wp, 3.11025492840344E+0_wp, 4.00458350822475E+0_wp, &
      & 4.00464380514876E+0_wp, 4.00453849863709E+0_wp, 4.00457231615400E+0_wp, &
      & 2.09575556191806E+0_wp, 2.09584291489233E+0_wp, 2.09574612300023E+0_wp, &
      & 2.09582178519930E+0_wp, 1.31402642902757E+0_wp, 1.31407686428049E+0_wp, &
      & 1.31404047639461E+0_wp, 1.31407349269578E+0_wp]

   call get_structure(mol, "X23", "acetic")
   call test_cn_gen(error, mol, ref)

end subroutine test_cn_acetic


subroutine test_dcndr_mb04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "04")
   call test_numgrad(error, mol)

end subroutine test_dcndr_mb04


subroutine test_dcndr_mb05(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "05")
   call test_numgrad(error, mol)

end subroutine test_dcndr_mb05


subroutine test_dcndr_ammonia(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "X23", "ammonia")
   call test_numgrad(error, mol)

end subroutine test_dcndr_ammonia


subroutine test_dcndL_mb06(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "06")
   call test_numsigma(error, mol)

end subroutine test_dcndL_mb06


subroutine test_dcndL_mb07(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "07")
   call test_numsigma(error, mol)

end subroutine test_dcndL_mb07


subroutine test_dcndL_anthracene(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "X23", "anthracene")
   call test_numsigma(error, mol)

end subroutine test_dcndL_anthracene


end module test_ncoord_gfn

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Proxy module for wavefunction related types and procedures
module tblite_wavefunction
   use tblite_wavefunction_guess, only : sad_guess, eeq_guess
   use tblite_wavefunction_mulliken, only : get_molecular_dipole_moment, &
      & get_molecular_quadrupole_moment
   use tblite_wavefunction_spin, only : magnet_to_updown, updown_to_magnet
   use tblite_wavefunction_type, only : wavefunction_type, new_wavefunction, &
      & get_density_matrix, get_alpha_beta_occupation
   implicit none
   public

end module tblite_wavefunction

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_lapack_getrf
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_getrf


   !> Computes an LU factorization of a general M-by-N matrix A
   !> using partial pivoting with row interchanges.
   !>
   !> The factorization has the form
   !>    A = P * L * U
   !> where P is a permutation matrix, L is lower triangular with unit
   !> diagonal elements (lower trapezoidal if m > n), and U is upper
   !> triangular (upper trapezoidal if m < n).
   interface wrap_getrf
      module procedure :: wrap_sgetrf
      module procedure :: wrap_dgetrf
   end interface wrap_getrf


   !> Computes an LU factorization of a general M-by-N matrix A
   !> using partial pivoting with row interchanges.
   !>
   !> The factorization has the form
   !>    A = P * L * U
   !> where P is a permutation matrix, L is lower triangular with unit
   !> diagonal elements (lower trapezoidal if m > n), and U is upper
   !> triangular (upper trapezoidal if m < n).
   interface lapack_getrf
      pure subroutine sgetrf(m, n, a, lda, ipiv, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine sgetrf
      pure subroutine dgetrf(m, n, a, lda, ipiv, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dgetrf
   end interface lapack_getrf

contains

subroutine wrap_sgetrf(amat, ipiv, info)
   real(sp), intent(inout) :: amat(:, :)
   integer, intent(out) :: ipiv(:)
   integer, intent(out) :: info
   integer :: m, n, lda
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
   call lapack_getrf(m, n, amat, lda, ipiv, info)
end subroutine wrap_sgetrf


subroutine wrap_dgetrf(amat, ipiv, info)
   real(dp), intent(inout) :: amat(:, :)
   integer, intent(out) :: ipiv(:)
   integer, intent(out) :: info
   integer :: m, n, lda
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
   call lapack_getrf(m, n, amat, lda, ipiv, info)
end subroutine wrap_dgetrf

end module tblite_lapack_getrf

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/wavefunction/mulliken.f90
!> Provides Mulliken population analysis

!> Wavefunction analysis via Mulliken populations
module tblite_wavefunction_mulliken
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_basis_type, only : basis_type
   use tblite_blas, only: gemm
   use tblite_wavefunction_spin, only : updown_to_magnet
   implicit none
   private

   public :: get_mulliken_shell_charges, get_mulliken_atomic_multipoles
   public :: get_molecular_dipole_moment, get_molecular_quadrupole_moment
   public :: get_mayer_bond_orders, get_mulliken_shell_multipoles

contains


subroutine get_mulliken_shell_charges(bas, smat, pmat, n0sh, qsh)
   type(basis_type), intent(in) :: bas
   real(wp), intent(in) :: smat(:, :)
   real(wp), intent(in) :: pmat(:, :, :)
   real(wp), intent(in) :: n0sh(:)
   real(wp), intent(out) :: qsh(:, :)

   integer :: ish, ii, iao, jao, spin
   real(wp) :: psh

   qsh(:, :) = 0.0_wp
   !$omp parallel do default(none) collapse(2) schedule(runtime) &
   !$omp shared(qsh, bas, pmat, smat) private(spin, ish, ii, iao, jao, psh)
   do spin = 1, size(pmat, 3)
      do ish = 1, bas%nsh
         psh = 0.0_wp
         ii = bas%iao_sh(ish)
         do iao = 1, bas%nao_sh(ish)
            do jao = 1, bas%nao
               psh = psh + pmat(jao, ii+iao, spin) * smat(jao, ii+iao)
            end do
         end do
         qsh(ish, spin) = -psh
      end do
   end do

   call updown_to_magnet(qsh)
   qsh(:, 1) = qsh(:, 1) + n0sh

end subroutine get_mulliken_shell_charges


subroutine get_mulliken_atomic_multipoles(bas, mpmat, pmat, mpat)
   type(basis_type), intent(in) :: bas
   real(wp), intent(in) :: mpmat(:, :, :)
   real(wp), intent(in) :: pmat(:, :, :)
   real(wp), intent(out) :: mpat(:, :, :)

   integer ::  iat, ish, is, ii, iao, jao, spin
   real(wp) :: pat(size(mpmat, 1))

   mpat(:, :, :) = 0.0_wp
   !$omp parallel do default(none) collapse(2) schedule(runtime) &
   !$omp shared(bas, pmat, mpmat, mpat) &
   !$omp private(spin, iat, ish, is, ii, iao, jao, pat)
   do spin = 1, size(pmat, 3)
      do iat = 1, size(mpat, 2)
         pat(:) = 0.0_wp
         is = bas%ish_at(iat)
         do ish = 1, bas%nsh_at(iat)
            ii = bas%iao_sh(is + ish)
            do iao = 1, bas%nao_sh(is + ish)
               do jao = 1, bas%nao
                  pat(:) = pat(:) + pmat(jao, ii+iao, spin) * mpmat(:, jao, ii+iao)
               end do
            end do
         end do
         mpat(:, iat, spin) = -pat(:)
      end do
   end do

   call updown_to_magnet(mpat)

end subroutine get_mulliken_atomic_multipoles

subroutine get_mulliken_shell_multipoles(bas, mpmat, pmat, mpsh)
   type(basis_type), intent(in) :: bas
   real(wp), intent(in) :: mpmat(:, :, :)
   real(wp), intent(in) :: pmat(:, :, :)
   real(wp), intent(out) :: mpsh(:, :, :)

   integer :: iao, jao, spin, ish, ii
   real(wp) :: psh(size(mpmat, 1))

   mpsh(:, :, :) = 0.0_wp
   !$omp parallel do default(none) collapse(2) schedule(runtime) &
   !$omp shared(bas, pmat, mpmat, mpsh) &
   !$omp private(spin, ish, iao, jao, ii, psh)
   do spin = 1, size(pmat, 3)
      do ish = 1, bas%nsh
         psh(:) = 0.0_wp
         ii = bas%iao_sh(ish)
         do iao = 1, bas%nao_sh(ish)
            do jao = 1, bas%nao
               psh(:) = psh + pmat(jao, ii+iao, spin) * mpmat(:, jao, ii+iao)
            end do
         end do
         mpsh(:, ish, spin) = -psh(:)
      end do
   end do

   call updown_to_magnet(mpsh)

end subroutine get_mulliken_shell_multipoles

subroutine get_molecular_dipole_moment(mol, qat, dpat, dpmom)
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: qat(:)
   real(wp), intent(in) :: dpat(:, :)
   real(wp), intent(out) :: dpmom(:)

   integer :: iat

   dpmom(:) = 0.0_wp
   do iat = 1, mol%nat
      dpmom(:) = dpmom + mol%xyz(:, iat) * qat(iat) + dpat(:, iat)
   end do
end subroutine get_molecular_dipole_moment

subroutine get_molecular_quadrupole_moment(mol, qat, dpat, qpat, qpmom)
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: qat(:)
   real(wp), intent(in) :: dpat(:, :)
   real(wp), intent(in) :: qpat(:, :)
   real(wp), intent(out) :: qpmom(:)

   integer :: iat
   real(wp) :: vec(3), cart(6), tr

   qpmom(:) = 0.0_wp
   do iat = 1, mol%nat
      vec(:) = mol%xyz(:, iat)*qat(iat)
      cart([1, 3, 6]) = mol%xyz(:, iat) * (vec + 2*dpat(:, iat))
      cart(2) = mol%xyz(1, iat) * (vec(2) + dpat(2, iat)) + dpat(1, iat)*mol%xyz(2, iat)
      cart(4) = mol%xyz(1, iat) * (vec(3) + dpat(3, iat)) + dpat(1, iat)*mol%xyz(3, iat)
      cart(5) = mol%xyz(2, iat) * (vec(3) + dpat(3, iat)) + dpat(2, iat)*mol%xyz(3, iat)
      tr = 0.5_wp * (cart(1) + cart(3) + cart(6))
      cart(1) = 1.5_wp * cart(1) - tr
      cart(2) = 3.0_wp * cart(2)
      cart(3) = 1.5_wp * cart(3) - tr
      cart(4) = 3.0_wp * cart(4)
      cart(5) = 3.0_wp * cart(5)
      cart(6) = 1.5_wp * cart(6) - tr
      qpmom(:) = qpmom(:) + qpat(:, iat) + cart
   end do
end subroutine get_molecular_quadrupole_moment


!> Evaluate Wiberg/Mayer bond orders including factor 2 scaling for open-shell cases
subroutine get_mayer_bond_orders(mol, bas, smat, pmat, mbo)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Overlap matrix
   real(wp), intent(in) :: smat(:, :)
   !> Density matrix
   real(wp), intent(in) :: pmat(:, :, :)
   !> Wiberg/Mayer bond orders
   real(wp), intent(out) :: mbo(:, :, :)

   integer :: iao, jao, iat, jat, ish, jsh, ii, jj, is, js, spin, nspin
   real(wp) :: pao, uhf_scale
   real(wp), allocatable :: psmat(:, :)

   allocate(psmat(bas%nao, bas%nao))

   nspin = size(pmat, 3)

   ! Scaling factor of 2 for unrestricted case
   uhf_scale = 1.0_wp
   if (nspin == 2) then
      uhf_scale = 2.0_wp
   end if

   mbo(:, :, :) = 0.0_wp
   do spin = 1, nspin
      call gemm(pmat(:, :, spin), smat, psmat)
      !$omp parallel do default(none) schedule(runtime) &
      !$omp shared(mol, bas, psmat, mbo, spin, uhf_scale) &
      !$omp private(iat, jat, is, js, ish, jsh, ii, jj, iao, jao, pao)
      do iat = 1, mol%nat
         is = bas%ish_at(iat)
         do jat = 1, iat - 1
            pao = 0.0_wp
            js = bas%ish_at(jat)
            do ish = 1, bas%nsh_at(iat)
            ii = bas%iao_sh(is + ish)
               do jsh = 1, bas%nsh_at(jat)
                  jj = bas%iao_sh(js + jsh)
                  do iao = 1, bas%nao_sh(is + ish)
                     do jao = 1, bas%nao_sh(js + jsh)
                        pao = pao + psmat(jj+jao, ii+iao) * psmat(ii+iao, jj+jao)
                     end do
                  end do
               end do
            end do 
            mbo(jat, iat, spin) = pao * uhf_scale
            mbo(iat, jat, spin) = pao * uhf_scale
         end do
      end do
   end do

   call updown_to_magnet(mbo)

end subroutine get_mayer_bond_orders


end module tblite_wavefunction_mulliken

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_fit_settings
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_param_serde, only : serde_record
   use tblite_param, only : param_record, param_mask
   use tblite_toml, only : toml_table, get_value, set_value, add_table
   implicit none
   private

   public :: fit_settings

   type, extends(serde_record) :: fit_settings
      character(len=:), allocatable :: method
      character(len=:), allocatable :: script
      character(len=:), allocatable :: output
      character(len=:), allocatable :: fitpar
      logical :: relative
      integer :: max_iter
      real(wp) :: trustr
      type(param_record), allocatable :: base
      type(param_mask) :: mask
   contains
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
   end type fit_settings

contains

!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(fit_settings), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   call get_value(table, "max-iter", self%max_iter, 100)
   if (self%max_iter <= 0) then
      call fatal_error(error, "Positive number of iterations required")
      return
   end if

   call get_value(table, "method", self%method, "newuoa")
   if (self%method /= "newuoa") then
      call fatal_error(error, "Unknown optimization method '"//self%method//"'")
      return
   end if

   call get_value(table, "relative", self%relative, .true.)

   call get_value(table, "trust-rad", self%trustr, 0.1_wp)
   if (self%trustr <= 0.0_wp) then
      call fatal_error(error, "Positive value for trust radius required")
      return
   end if

   call get_value(table, "script", self%script, "./run.sh")
   call get_value(table, "data-file", self%output, ".data")
   call get_value(table, "param-file", self%fitpar, "fitpar.toml")

   call set_base_param(self%mask, self%base)
   call get_value(table, "mask", child)
   call self%mask%load(child, error)
   if (allocated(error)) return
end subroutine load_from_toml

subroutine set_base_param(mask, base)
   type(param_mask), intent(out) :: mask
   type(param_record), intent(in), target, optional :: base
   if (present(base)) mask%ref => base%record
end subroutine set_base_param

!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(fit_settings), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   call set_value(table, "max-iter", self%max_iter)
   call set_value(table, "method", self%method)
   call set_value(table, "relative", self%relative)
   call set_value(table, "trust-rad", self%trustr)
   call set_value(table, "script", self%script)
   call set_value(table, "data-file", self%output)
   call set_value(table, "param-file", self%fitpar)

   call add_table(table, "mask", child)
   call self%mask%dump(child, error)
   if (allocated(error)) return
end subroutine dump_to_toml

end module tblite_fit_settings

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_solvation_born
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type
   use mstore, only : get_structure
   use tblite_container, only : container_cache
   use tblite_scf_potential, only : potential_type
   use tblite_solvation_alpb
   use tblite_solvation_born
   use tblite_solvation_data
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: collect_solvation_born


   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

contains


!> Collect all exported unit tests
subroutine collect_solvation_born(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("born-1", test_mb01), &
      new_unittest("born-2", test_mb02), &
      new_unittest("born-3", test_mb03), &
      new_unittest("energy-p16", test_e_p16), &
      new_unittest("energy-still", test_e_still), &
      new_unittest("energy-charged", test_e_charged), &
      new_unittest("gradient-p16", test_g_p16), &
      new_unittest("gradient-still", test_g_still), &
      new_unittest("potential-p16", test_p_p16), &
      new_unittest("potential-still", test_p_still) &
      ]

end subroutine collect_solvation_born


subroutine test_numg(error, gbobc, mol)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Born radii integrator
   type(born_integrator), intent(inout) :: gbobc
   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   integer :: iat, ic
   real(wp), allocatable :: rad(:), sr(:), sl(:), draddr(:, :, :), numg(:, :, :)
   real(wp), parameter :: step = 1.0e-5_wp

   allocate(rad(mol%nat), sr(mol%nat), sl(mol%nat))
   allocate(draddr(3, mol%nat, mol%nat), numg(3, mol%nat, mol%nat))

   call gbobc%get_rad(mol, rad, draddr)

   do iat = 1, mol%nat
      do ic = 1, 3
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call gbobc%get_rad(mol, sr)

         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2*step
         call gbobc%get_rad(mol, sl)

         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step

         numg(ic, iat, :) = 0.5_wp * (sr - sl) / step
      end do
   end do

   if (any(abs(numg - draddr) > thr2)) then
      call test_failed(error, "Born radii derivative does not much finite difference solution")
   end if
end subroutine test_numg


subroutine test_mb01(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(born_integrator) :: gbobc
   real(wp), allocatable :: rvdw(:), rad(:), draddr(:, :, :)
   real(wp), parameter :: ref(16) = [&
      & 3.71925575124827E+0_wp, 2.16476296748035E+0_wp, 2.44825652097444E+0_wp, &
      & 2.09711787712670E+0_wp, 2.29941177202782E+0_wp, 2.14968507129966E+0_wp, &
      & 1.99677395424007E+0_wp, 2.46559580246828E+0_wp, 2.37324209856960E+0_wp, &
      & 2.18243689290327E+0_wp, 2.13048306044765E+0_wp, 3.09974452166843E+0_wp, &
      & 3.20882938587537E+0_wp, 3.20921511705709E+0_wp, 2.53773676318564E+0_wp, &
      & 4.00110742187589E+0_wp]

   call get_structure(mol, "MB16-43", "01")

   allocate(rad(mol%nat), draddr(3, mol%nat, mol%nat))
   rvdw = get_vdw_rad_d3(mol%num)

   call new_born_integrator(gbobc, mol, rvdw)
   call gbobc%get_rad(mol, rad, draddr)

   if (any(abs(rad - ref) > thr2)) then
      call test_failed(error, "Born radii area values do not match")
      print '(es20.14e1)', rad
      return
   end if

   call test_numg(error, gbobc, mol)

end subroutine test_mb01


subroutine test_mb02(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(born_integrator) :: gbobc
   real(wp), allocatable :: rvdw(:), rad(:), draddr(:, :, :)
   real(wp), parameter :: ref(16) = [&
      & 2.03003227094783E+0_wp, 3.40982182726134E+0_wp, 3.76340232663856E+0_wp, &
      & 3.02407929386614E+0_wp, 3.28929987264365E+0_wp, 2.02682762576029E+0_wp, &
      & 2.06667722254266E+0_wp, 2.11393249229453E+0_wp, 4.16230157963295E+0_wp, &
      & 2.04425241577056E+0_wp, 3.80120245507398E+0_wp, 3.57807956271496E+0_wp, &
      & 2.91118854660600E+0_wp, 2.13114311540872E+0_wp, 1.88663598634422E+0_wp, &
      & 3.56776838036666E+0_wp]

   call get_structure(mol, "MB16-43", "02")

   allocate(rad(mol%nat), draddr(3, mol%nat, mol%nat))
   rvdw = get_vdw_rad_bondi(mol%num)

   call new_born_integrator(gbobc, mol, rvdw)
   call gbobc%get_rad(mol, rad, draddr)

   if (any(abs(rad - ref) > thr2)) then
      call test_failed(error, "Born radii area values do not match")
      print '(es20.14e1)', rad
      return
   end if

   call test_numg(error, gbobc, mol)

end subroutine test_mb02


subroutine test_mb03(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(born_integrator) :: gbobc
   real(wp), allocatable :: rvdw(:), rad(:), draddr(:, :, :)
   real(wp), parameter :: ref(16) = [&
      & 3.91411897069798E+0_wp, 3.42789823632301E+0_wp, 2.34668834621558E+0_wp, &
      & 2.83891414188962E+0_wp, 2.83920259470834E+0_wp, 4.13896803442111E+0_wp, &
      & 3.80142626778573E+0_wp, 2.33205296768204E+0_wp, 2.38132797993608E+0_wp, &
      & 2.36905436033089E+0_wp, 3.39351426743609E+0_wp, 4.26806882116276E+0_wp, &
      & 3.93884836867883E+0_wp, 2.58357231353968E+0_wp, 3.59967451118629E+0_wp, &
      & 2.34133649556104E+0_wp]

   call get_structure(mol, "MB16-43", "03")

   allocate(rad(mol%nat), draddr(3, mol%nat, mol%nat))
   rvdw = get_vdw_rad_cosmo(mol%num)

   call new_born_integrator(gbobc, mol, rvdw)
   call gbobc%get_rad(mol, rad, draddr)

   if (any(abs(rad - ref) > thr2)) then
      call test_failed(error, "Born radii area values do not match")
      print '(es20.14e1)', rad
      return
   end if

   call test_numg(error, gbobc, mol)

end subroutine test_mb03


subroutine test_e(error, mol, input, qat, ref)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Solvation model input
   type(alpb_input), intent(in) :: input

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Reference energy
   real(wp), intent(in) :: ref

   type(alpb_solvation) :: solv
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp) :: energy(mol%nat)

   energy = 0.0_wp
   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))

   solv = alpb_solvation(mol, input)

   call solv%update(mol, cache)
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)

   if (abs(sum(energy) - ref) > thr) then
      call test_failed(error, "Energy does not match reference")
      print *, sum(energy)
   end if
end subroutine test_e


subroutine test_g(error, mol, input, qat)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Solvation model input
   type(alpb_input), intent(in) :: input

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   type(alpb_solvation) :: solv
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp), allocatable :: gradient(:, :), numg(:, :)
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat), sigma(3, 3)
   integer :: ii, ic

   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))

   solv = alpb_solvation(mol, input)

   allocate(numg(3, mol%nat), gradient(3, mol%nat))
   do ii = 1, mol%nat
      do ic = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(ic, ii) = mol%xyz(ic, ii) + step
         call solv%update(mol, cache)
         call solv%get_potential(mol, cache, wfn, pot)
         call solv%get_energy(mol, cache, wfn, er)

         mol%xyz(ic, ii) = mol%xyz(ic, ii) - 2*step
         call solv%update(mol, cache)
         call solv%get_potential(mol, cache, wfn, pot)
         call solv%get_energy(mol, cache, wfn, el)

         mol%xyz(ic, ii) = mol%xyz(ic, ii) + step
         numg(ic, ii) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp

   call solv%update(mol, cache)
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)
   call solv%get_gradient(mol, cache, wfn, gradient, sigma)

   if (any(abs(gradient - numg) > thr)) then
      call test_failed(error, "Gradient does not match")
      print '(3es20.13)', gradient
      print '(a)', "---"
      print '(3es20.13)', numg
      print '(a)', "---"
      print '(3es20.13)', gradient - numg
   end if
end subroutine test_g


subroutine test_p(error, mol, input, qat)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Solvation model input
   type(alpb_input), intent(in) :: input

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   type(alpb_solvation) :: solv
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp), parameter :: thr = 1e+3_wp*sqrt(epsilon(1.0_wp))
   real(wp), allocatable :: vat(:)
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat)
   integer :: ii

   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))

   solv = alpb_solvation(mol, input)

   call solv%update(mol, cache)

   allocate(vat(mol%nat))
   do ii = 1, mol%nat
      er = 0.0_wp
      el = 0.0_wp
      wfn%qat(ii, 1) = wfn%qat(ii, 1) + step
      call solv%get_potential(mol, cache, wfn, pot)
      call solv%get_energy(mol, cache, wfn, er)

      wfn%qat(ii, 1) = wfn%qat(ii, 1) - 2*step
      call solv%get_potential(mol, cache, wfn, pot)
      call solv%get_energy(mol, cache, wfn, el)

      wfn%qat(ii, 1) = wfn%qat(ii, 1) + step
      vat(ii) = 0.5_wp*(sum(er) - sum(el))/step
   end do

   energy = 0.0_wp
   pot%vat(:, :) = 0.0_wp
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)

   if (any(abs([pot%vat] - vat) > thr)) then
      call test_failed(error, "Potential does not match")
      print '(3es20.13)', pot%vat
      print '(a)', "---"
      print '(3es20.13)', vat
      print '(a)', "---"
      print '(3es20.13)', [pot%vat] - vat
   end if
end subroutine test_p


subroutine test_e_p16(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-8.99890404486076E-2_wp, 9.42168087556583E-2_wp,-1.49387631509499E-1_wp, &
      &-2.99114121895542E-1_wp, 4.85527734875224E-1_wp,-6.83156326406137E-2_wp, &
      & 1.50011293889337E-2_wp, 2.79368544459465E-1_wp,-1.24072452878322E-1_wp, &
      &-9.36760994051244E-2_wp,-2.19062123031622E-1_wp, 2.14538817685587E-1_wp, &
      & 3.06156726072831E-1_wp,-3.86105514712244E-1_wp,-1.51265171389388E-3_wp, &
      & 3.64255069977693E-2_wp]
   real(wp), parameter :: feps = 80.0_wp

   call get_structure(mol, "MB16-43", "04")
   call test_e(error, mol, alpb_input(feps, kernel=born_kernel%p16), qat, &
      & -1.6360713677542098E-2_wp)

end subroutine test_e_p16


subroutine test_e_still(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 2.29208822115185E-1_wp, 4.70816658242009E-2_wp,-3.52834459119718E-2_wp, &
      & 3.09012847396269E-2_wp, 3.28898468854920E-1_wp,-2.01747405019535E-1_wp, &
      & 5.46554362391008E-2_wp,-1.09681283064574E-1_wp,-3.47340505091849E-1_wp, &
      & 1.84567817865267E-1_wp,-2.07552337277185E-1_wp, 4.67140380802351E-1_wp, &
      &-1.84261319200178E-2_wp,-1.05015595324833E-1_wp, 6.52511545312054E-2_wp, &
      &-3.82658324740237E-1_wp]
   real(wp), parameter :: feps = 80.0_wp

   call get_structure(mol, "MB16-43", "05")
   call test_e(error, mol, alpb_input(feps, kernel=born_kernel%still), qat, &
      & -1.3942011944024141E-2_wp)

end subroutine test_e_still


subroutine test_e_charged(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 2.91737167991831E-1_wp,-4.44921281646692E-1_wp, 7.03886898899541E-2_wp, &
      & 4.32458130745259E-2_wp, 3.90393832017139E-2_wp, 9.56766032864156E-2_wp, &
      & 6.01866392558221E-2_wp,-3.31751380042108E-1_wp, 1.56707781479786E-1_wp, &
      & 8.89443731456522E-2_wp,-6.03526873354187E-2_wp, 3.83058968439732E-2_wp, &
      & 9.51289165540499E-2_wp,-9.20860756307965E-2_wp, 7.12122392663975E-2_wp, &
      & 2.76742553014572E-1_wp,-4.38083248713717E-1_wp,-1.76798298145349E-1_wp, &
      & 2.14382387079637E-1_wp, 3.25215078814299E-1_wp,-4.30846325150764E-1_wp, &
      & 1.12908046155543E-1_wp, 6.61648434849400E-2_wp, 9.89171412174742E-2_wp, &
      & 5.80323177221752E-2_wp,-4.43388471029542E-1_wp, 3.38493755177292E-1_wp, &
      &-3.52969753592199E-1_wp, 4.59552645375000E-1_wp,-5.33442813398395E-1_wp, &
      &-5.23460418980519E-1_wp,-3.14158345734236E-1_wp, 8.63777453496141E-2_wp, &
      & 5.51896920278464E-2_wp, 5.60421076086023E-2_wp, 1.02875052304244E-1_wp, &
      & 5.43513415521492E-2_wp,-3.13791816210054E-1_wp, 1.68862983166011E-1_wp, &
      & 8.93759201291419E-2_wp,-8.90121909290432E-2_wp, 4.15150867426933E-2_wp, &
      & 1.22221651251480E-1_wp,-8.26447904844349E-2_wp, 1.00154406589010E-1_wp, &
      & 2.77572579099978E-1_wp,-4.29147369583175E-1_wp,-1.78581481555413E-1_wp, &
      & 2.09487890121871E-1_wp, 3.17109649407645E-1_wp,-4.62948099575570E-1_wp, &
      & 9.81620738022878E-2_wp, 5.14984224707990E-2_wp, 9.63222020737258E-2_wp, &
      & 3.80443799704811E-2_wp,-4.41189291092377E-1_wp, 3.13549746324888E-1_wp, &
      &-4.41335746902051E-1_wp, 3.01219329594079E-1_wp]
   real(wp), parameter :: feps = 80.0_wp

   call get_structure(mol, "UPU23", "0a")
   call test_e(error, mol, alpb_input(feps, kernel=born_kernel%p16, alpb=.true.), qat, &
      & -0.16028444888366283_wp)
   if (allocated(error)) return

   call test_e(error, mol, alpb_input(feps, kernel=born_kernel%p16, alpb=.false.), qat, &
      & -0.16111025145311508_wp)

end subroutine test_e_charged


subroutine test_g_p16(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 2.08159387594211E-1_wp,-3.78010519998818E-1_wp, 3.36498247356244E-2_wp, &
      &-4.11556158912895E-1_wp, 8.14928196660512E-2_wp,-2.00886649303053E-1_wp, &
      & 2.44756994282684E-1_wp, 2.54580499189089E-2_wp, 2.59835128092562E-1_wp, &
      & 4.21683321877209E-1_wp, 1.37097163086023E-1_wp, 4.06951664942900E-2_wp, &
      &-1.10955378625897E-1_wp,-6.44033540918074E-2_wp,-1.91525919028143E-1_wp, &
      &-9.54898757869102E-2_wp]
   real(wp), parameter :: feps = 80.0_wp

   call get_structure(mol, "MB16-43", "06")
   call test_g(error, mol, alpb_input(feps, kernel=born_kernel%p16), qat)

end subroutine test_g_p16


subroutine test_g_still(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-1.57321098180703E-1_wp, 1.65233008998668E-1_wp, 3.22320267782066E-1_wp, &
      & 3.63564544135336E-2_wp, 4.85639267214320E-2_wp,-3.59203277893926E-1_wp, &
      &-1.93841260011383E-1_wp,-3.86495230324447E-1_wp, 3.10104147485353E-1_wp, &
      & 8.34907519580185E-2_wp,-3.62672063405622E-1_wp, 3.64143595819311E-1_wp, &
      & 3.34640678947868E-1_wp,-4.69881543486815E-1_wp,-1.89222615863620E-1_wp, &
      & 4.53784257040286E-1_wp]
   real(wp), parameter :: feps = 80.0_wp

   call get_structure(mol, "MB16-43", "07")
   call test_g(error, mol, alpb_input(feps, kernel=born_kernel%still), qat)

end subroutine test_g_still


subroutine test_p_p16(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-2.05668345919710E-1_wp,-3.99553123071811E-1_wp, 3.29242774348191E-1_wp, &
      &-3.11737933844111E-1_wp, 3.58851882478133E-2_wp, 3.21886835736497E-1_wp, &
      & 4.14743455841314E-2_wp, 2.95727359478547E-2_wp,-5.06347224522431E-1_wp, &
      & 3.43067182413129E-1_wp, 6.88373767679515E-1_wp, 7.03357390141253E-2_wp, &
      &-9.62424552888750E-2_wp,-1.32209348056625E-1_wp, 9.78998441832186E-2_wp, &
      &-3.05979982450903E-1_wp]
   real(wp), parameter :: feps = 80.0_wp

   call get_structure(mol, "MB16-43", "08")
   call test_p(error, mol, alpb_input(feps, kernel=born_kernel%p16), qat)

end subroutine test_p_p16


subroutine test_p_still(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-5.25247525508526E-2_wp,-1.97060288484673E-2_wp,-1.36432079012167E-1_wp, &
      &-9.52347486058915E-2_wp, 4.66468767398605E-1_wp, 2.70593750695380E-2_wp, &
      &-1.82819518140298E-1_wp, 1.59893322865668E-1_wp,-1.04573523319519E-1_wp, &
      & 1.16709722834927E-2_wp, 4.11411958411730E-1_wp, 2.87449331948580E-2_wp, &
      &-4.12833246638830E-1_wp,-3.57145165960098E-1_wp,-9.54533576632005E-2_wp, &
      & 3.51473091515422E-1_wp]
   real(wp), parameter :: feps = 80.0_wp

   call get_structure(mol, "MB16-43", "09")
   call test_p(error, mol, alpb_input(feps, kernel=born_kernel%still), qat)

end subroutine test_p_still


end module test_solvation_born

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Generally applicable charge-dependent London-dispersion correction, DFT-D4.
module tblite_disp_d4
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use dftd4, only : d4_model, damping_param, rational_damping_param, realspace_cutoff, &
      & get_coordination_number, new_d4_model
   use dftd4_model, only : d4_ref
   use dftd4_charge, only : get_eeq_charges => get_charges
   use tblite_blas, only : dot, gemv
   use tblite_container_cache, only : container_cache
   use tblite_disp_cache, only : dispersion_cache
   use tblite_disp_type, only : dispersion_type
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_cutoff, only : get_lattice_points
   implicit none
   private

   public :: d4_dispersion, new_d4_dispersion, get_eeq_charges


   !> Container for self-consistent D4 dispersion interactions
   type, extends(dispersion_type) :: d4_dispersion
      !> Instance of the actual D4 dispersion model
      type(d4_model) :: model
      !> Rational damping parameters
      type(rational_damping_param) :: param
      !> Selected real space cutoffs for this instance
      type(realspace_cutoff) :: cutoff
   contains
      !> Update dispersion cache
      procedure :: update
      !> Get information about density dependent quantities used in the energy
      procedure :: variable_info
      !> Evaluate non-selfconsistent part of the dispersion correction
      procedure :: get_engrad
      !> Evaluate selfconsistent energy of the dispersion correction
      procedure :: get_energy
      !> Evaluate charge dependent potential shift from the dispersion correction
      procedure :: get_potential
      !> Evaluate gradient contributions from the selfconsistent dispersion correction
      procedure :: get_gradient
   end type d4_dispersion

   character(len=*), parameter :: label = "self-consistent DFT-D4 dispersion"


contains


!> Create a new instance of a self-consistent D4 dispersion correction
subroutine new_d4_dispersion(self, mol, s6, s8, a1, a2, s9)
   !> Instance of the dispersion correction
   type(d4_dispersion), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: s6, s8, a1, a2, s9

   self%label = label
   call new_d4_model(self%model, mol, ref=d4_ref%gfn2)
   self%param = rational_damping_param(s6=s6, s8=s8, s9=s9, a1=a1, a2=a2)
   self%cutoff = realspace_cutoff(disp3=25.0_wp, disp2=50.0_wp)
end subroutine new_d4_dispersion


!> Update dispersion cache
subroutine update(self, mol, cache)
   !> Instance of the dispersion correction
   class(d4_dispersion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different dispersion runs
   type(container_cache), intent(inout) :: cache

   real(wp), allocatable :: lattr(:, :)
   type(dispersion_cache), pointer :: ptr
   integer :: mref

   call taint(cache, ptr)
   mref = maxval(self%model%ref)

   if (.not.allocated(ptr%cn)) allocate(ptr%cn(mol%nat))
   if (.not.allocated(ptr%dcndr)) allocate(ptr%dcndr(3, mol%nat, mol%nat))
   if (.not.allocated(ptr%dcndL)) allocate(ptr%dcndL(3, 3, mol%nat))
   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff%cn, lattr)
   call get_coordination_number(mol, lattr, self%cutoff%cn, self%model%rcov, self%model%en, &
      & ptr%cn, ptr%dcndr, ptr%dcndL)

   if (.not.allocated(ptr%dispmat)) allocate(ptr%dispmat(mref, mol%nat, mref, mol%nat))
   if (.not.allocated(ptr%vvec)) allocate(ptr%vvec(mref, mol%nat))
   if (.not.allocated(ptr%gwvec)) allocate(ptr%gwvec(mref, mol%nat))
   if (.not.allocated(ptr%dgwdq)) allocate(ptr%dgwdq(mref, mol%nat))

   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff%disp2, lattr)
   call get_dispersion_matrix(mol, self%model, self%param, lattr, self%cutoff%disp2, &
      & self%model%r4r2, ptr%dispmat)
end subroutine update


!> Evaluate non-selfconsistent part of the dispersion correction
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the dispersion correction
   class(d4_dispersion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different dispersion runs
   type(container_cache), intent(inout) :: cache
   !> Dispersion energy
   real(wp), intent(inout) :: energies(:)
   !> Dispersion gradient
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Dispersion virial
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)

   type(dispersion_cache), pointer :: ptr

   call view(cache, ptr)

   call get_dispersion_nonsc(mol, self%model, self%param, self%cutoff, ptr, &
      & energies, gradient, sigma)
end subroutine get_engrad


!> Evaluate selfconsistent energy of the dispersion correction
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the dispersion correction
   class(d4_dispersion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different dispersion runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Dispersion energy
   real(wp), intent(inout) :: energies(:)

   type(dispersion_cache), pointer :: ptr

   call view(cache, ptr)

   call self%model%weight_references(mol, ptr%cn, wfn%qat(:, 1), ptr%gwvec)

   call gemv(ptr%dispmat, ptr%gwvec, ptr%vvec, alpha=0.5_wp)
   ptr%vvec(:, :) = ptr%vvec * ptr%gwvec
   energies(:) = energies + sum(ptr%vvec, 1)
end subroutine get_energy


!> Evaluate charge dependent potential shift from the dispersion correction
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the dispersion correction
   class(d4_dispersion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different dispersion runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   type(dispersion_cache), pointer :: ptr

   call view(cache, ptr)

   call self%model%weight_references(mol, ptr%cn, wfn%qat(:, 1), ptr%gwvec, ptr%vvec, &
      & ptr%dgwdq)

   call gemv(ptr%dispmat, ptr%gwvec, ptr%vvec)
   ptr%vvec(:, :) = ptr%vvec * ptr%dgwdq
   pot%vat(:, 1) = pot%vat(:, 1) + sum(ptr%vvec, 1)
end subroutine get_potential


!> Evaluate gradient contributions from the selfconsistent dispersion correction
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the dispersion correction
   class(d4_dispersion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different dispersion runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Dispersion gradient
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Dispersion virial
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   integer :: mref
   real(wp), allocatable :: gwvec(:, :), gwdcn(:, :), gwdq(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :), dc6dq(:, :)
   real(wp), allocatable :: dEdcn(:), dEdq(:), energies(:)
   real(wp), allocatable :: lattr(:, :)
   type(dispersion_cache), pointer :: ptr

   call view(cache, ptr)
   mref = maxval(self%model%ref)

   allocate(gwvec(mref, mol%nat), gwdcn(mref, mol%nat), gwdq(mref, mol%nat))
   call self%model%weight_references(mol, ptr%cn, wfn%qat(:, 1), gwvec, gwdcn, gwdq)

   allocate(c6(mol%nat, mol%nat), dc6dcn(mol%nat, mol%nat), dc6dq(mol%nat, mol%nat))
   call self%model%get_atomic_c6(mol, gwvec, gwdcn, gwdq, c6, dc6dcn, dc6dq)

   allocate(energies(mol%nat), dEdcn(mol%nat), dEdq(mol%nat))
   energies(:) = 0.0_wp
   dEdcn(:) = 0.0_wp
   dEdq(:) = 0.0_wp
   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff%disp2, lattr)
   call self%param%get_dispersion2(mol, lattr, self%cutoff%disp2, self%model%r4r2, &
      & c6, dc6dcn, dc6dq, energies, dEdcn, dEdq, gradient, sigma)
   call gemv(ptr%dcndr, dEdcn, gradient, beta=1.0_wp)
   call gemv(ptr%dcndL, dEdcn, sigma, beta=1.0_wp)
end subroutine get_gradient


subroutine get_dispersion_matrix(mol, disp, param, trans, cutoff, r4r2, dispmat)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Damping parameters
   type(rational_damping_param), intent(in) :: param
   !> Instance of the dispersion model
   type(d4_model), intent(in) :: disp
   !> Lattice points
   real(wp), intent(in) :: trans(:, :)
   !> Real space cutoff
   real(wp), intent(in) :: cutoff
   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)
   !> Dispersion matrix
   real(wp), intent(out) :: dispmat(:, :, :, :)

   integer :: iat, jat, izp, jzp, jtr, iref, jref
   real(wp) :: vec(3), r2, cutoff2, r0ij, rrij, t6, t8, edisp, dE

   dispmat(:, :, :, :) = 0.0_wp
   cutoff2 = cutoff**2

   !$omp parallel do schedule(runtime) default(none) &
   !$omp shared(mol, param, disp, trans, cutoff2, r4r2, dispmat) &
   !$omp private(iat, jat, izp, jzp, jtr, vec, r2, r0ij, rrij, &
   !$omp& t6, t8, edisp, dE)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)
         rrij = 3*r4r2(izp)*r4r2(jzp)
         r0ij = param%a1 * sqrt(rrij) + param%a2
         dE = 0.0_wp
         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, jtr))
            r2 = vec(1)*vec(1) + vec(2)*vec(2) + vec(3)*vec(3)
            if (r2 > cutoff2 .or. r2 < epsilon(1.0_wp)) cycle

            t6 = 1.0_wp/(r2**3 + r0ij**6)
            t8 = 1.0_wp/(r2**4 + r0ij**8)

            edisp = param%s6*t6 + param%s8*rrij*t8

            dE = dE - edisp
         end do

         do iref = 1, disp%ref(izp)
            do jref = 1, disp%ref(jzp)
               dispmat(iref, iat, jref, jat) = dE * disp%c6(iref, jref, izp, jzp)
               dispmat(jref, jat, iref, iat) = dE * disp%c6(jref, iref, jzp, izp)
            end do
         end do
      end do
   end do
end subroutine get_dispersion_matrix


!> Wrapper to handle the evaluation of dispersion energy and derivatives
subroutine get_dispersion_nonsc(mol, disp, param, cutoff, cache, energies, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Dispersion model
   type(d4_model), intent(in) :: disp
   !> Damping parameters
   class(damping_param), intent(in) :: param
   !> Realspace cutoffs
   type(realspace_cutoff), intent(in) :: cutoff
   !> Cached data between different dispersion runs
   type(dispersion_cache), intent(inout) :: cache
   !> Dispersion energy
   real(wp), intent(inout) :: energies(:)
   !> Dispersion gradient
   real(wp), intent(inout), contiguous, optional :: gradient(:, :)
   !> Dispersion virial
   real(wp), intent(inout), contiguous, optional :: sigma(:, :)

   logical :: grad
   integer :: mref
   real(wp), allocatable :: qat(:)
   real(wp), allocatable :: gwvec(:, :), gwdcn(:, :), gwdq(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :), dc6dq(:, :)
   real(wp), allocatable :: dEdcn(:), dEdq(:)
   real(wp), allocatable :: lattr(:, :)

   mref = maxval(disp%ref)
   grad = present(gradient).and.present(sigma)

   allocate(gwvec(mref, mol%nat), qat(mol%nat), c6(mol%nat, mol%nat))
   if (grad) then
      allocate(gwdcn(mref, mol%nat), gwdq(mref, mol%nat), &
         & dc6dcn(mol%nat, mol%nat), dc6dq(mol%nat, mol%nat))
   end if
   qat(:) = 0.0_wp
   if (grad) then
      allocate(dEdcn(mol%nat), dEdq(mol%nat))
      dEdcn(:) = 0.0_wp
      dEdq(:) = 0.0_wp
   end if

   call disp%weight_references(mol, cache%cn, qat, gwvec, gwdcn, gwdq)
   call disp%get_atomic_c6(mol, gwvec, gwdcn, gwdq, c6, dc6dcn, dc6dq)

   call get_lattice_points(mol%periodic, mol%lattice, cutoff%disp3, lattr)
   call param%get_dispersion3(mol, lattr, cutoff%disp3, disp%r4r2, &
      & c6, dc6dcn, dc6dq, energies, dEdcn, dEdq, gradient, sigma)
   if (grad) then
      call gemv(cache%dcndr, dEdcn, gradient, beta=1.0_wp)
      call gemv(cache%dcndL, dEdcn, sigma, beta=1.0_wp)
   end if

end subroutine get_dispersion_nonsc


!> Get information about density dependent quantities used in the energy
pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, atom_resolved
   !> Instance of the electrostatic container
   class(d4_dispersion), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=atom_resolved)
end function variable_info


!> Inspect container cache and reallocate it in case of type mismatch
subroutine taint(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(dispersion_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(dispersion_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

!> Return reference to container cache after resolving its type
subroutine view(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(dispersion_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(dispersion_cache)
      ptr => target
   end select
end subroutine view

end module tblite_disp_d4

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_xtb_param
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type, new
   use mstore, only : get_structure
   use tblite_context_type, only : context_type
   use tblite_param, only : param_record, charge_record, dispersion_record, element_record, &
      & halogen_record, hamiltonian_record, multipole_record, repulsion_record, &
      & thirdorder_record, param_mask, count
   use tblite_toml, only : toml_table
   use tblite_wavefunction_type, only : wavefunction_type, new_wavefunction
   use tblite_xtb_calculator, only : xtb_calculator, new_xtb_calculator
   use tblite_xtb_gfn2, only : export_gfn2_param, new_gfn2_calculator
   use tblite_xtb_gfn1, only : export_gfn1_param, new_gfn1_calculator
   use tblite_xtb_ipea1, only : export_ipea1_param, new_ipea1_calculator
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   implicit none
   private

   public :: collect_xtb_param

   real(wp), parameter :: acc = 1.0_wp
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp), parameter :: kt = 300.0_wp * 3.166808578545117e-06_wp

contains


!> Collect all exported unit tests
subroutine collect_xtb_param(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("param-empty", test_param_empty, should_fail=.true.), &
      new_unittest("param-minimal", test_param_minimal), &
      new_unittest("param-invalid", test_param_invalid, should_fail=.true.), &
      new_unittest("element-empty", test_element_empty, should_fail=.true.), &
      new_unittest("charge-empty", test_charge_empty, should_fail=.true.), &
      new_unittest("dispersion-empty", test_dispersion_empty, should_fail=.true.), &
      new_unittest("halogen-empty", test_halogen_empty, should_fail=.true.), &
      new_unittest("hamiltonian-empty", test_hamiltonian_empty, should_fail=.true.), &
      new_unittest("multipole-empty", test_multipole_empty, should_fail=.true.), &
      new_unittest("repulsion-empty", test_repulsion_empty, should_fail=.true.), &
      new_unittest("thirdorder-empty", test_thirdorder_empty), &
      new_unittest("mask-a", test_mask_gfn2), &
      new_unittest("mask-b", test_mask_gfn1), &
      new_unittest("gfn2-xtb-a", test_gfn2_mb02), &
      new_unittest("gfn2-xtb-b", test_gfn2_mb05), &
      new_unittest("gfn2-xtb-c", test_gfn2_round_trip), &
      new_unittest("gfn1-xtb-a", test_gfn1_mb01), &
      new_unittest("gfn1-xtb-b", test_gfn1_mb04), &
      new_unittest("gfn1-xtb-c", test_gfn1_round_trip), &
      new_unittest("ipea1-xtb-a", test_ipea1_mb03), &
      new_unittest("ipea1-xtb-b", test_ipea1_mb06), &
      new_unittest("ipea1-xtb-c", test_ipea1_round_trip) &
      ]

end subroutine collect_xtb_param


subroutine test_param_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(param_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_param_empty


subroutine test_param_minimal(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: io
   type(param_record) :: param

   open(newunit=io, status="scratch")
   write(io, '(a)') &
      "[hamiltonian.xtb]", &
      "wexp = 5.0000000000000000E-01", &
      "kpol = 2.0000000000000000E+00", &
      "enscale = 2.0000000000000000E-02", &
      "cn = ""gfn""", &
      "shell = {ss=1.85, pp=2.23, dd=2.23, sd=2.00, pd=2.00}", &
      "[element.H]", &
      "shells = [ ""1s"" ]", &
      "levels = [ -1.0707210999999999E+01 ]", &
      "slater = [ 1.2300000000000000E+00 ]", &
      "ngauss = [ 3 ]", &
      "refocc = [ 1.0000000000000000E+00 ]", &
      "shpoly = [ -9.5361800000000000E-03 ]", &
      "kcn = [ -5.0000000000000003E-02 ]", &
      "gam = 4.0577099999999999E-01", &
      "lgam = [ 1.0000000000000000E+00 ]", &
      "gam3 = 8.0000000000000016E-02", &
      "zeff = 1.1053880000000000E+00", &
      "arep = 2.2137169999999999E+00", &
      "xbond = 0.0000000000000000E+00", &
      "dkernel = 5.5638889999999996E-02", &
      "qkernel = 2.7430999999999999E-04", &
      "mprad = 1.3999999999999999E+00", &
      "mpvcn = 1.0000000000000000E+00", &
      "[element.C]", &
      "shells = [ ""2s"", ""2p"" ]", &
      "levels = [ -1.3970922000000002E+01, -1.0063292000000001E+01 ]", &
      "slater = [ 2.0964320000000001E+00, 1.8000000000000000E+00 ]", &
      "ngauss = [ 4, 4 ]", &
      "refocc = [ 1.0000000000000000E+00, 3.0000000000000000E+00 ]", &
      "shpoly = [ -2.2943210000000002E-02, -2.7110200000000002E-03 ]", &
      "kcn = [ -1.0214400000000000E-02, 1.6165700000000002E-02 ]", &
      "gam = 5.3801500000000002E-01", &
      "lgam = [ 1.0000000000000000E+00, 1.1056357999999999E+00 ]", &
      "gam3 = 1.5000000000000002E-01", &
      "zeff = 4.2310780000000001E+00", &
      "arep = 1.2476550000000000E+00", &
      "xbond = 0.0000000000000000E+00", &
      "dkernel = -4.1167399999999998E-03", &
      "qkernel = 2.1358300000000000E-03", &
      "mprad = 3.0000000000000000E+00", &
      "mpvcn = 3.0000000000000000E+00", &
      ""
   rewind io

   call param%load(io, error)
   close(io)
end subroutine test_param_minimal


subroutine test_param_invalid(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: io
   type(param_record) :: param

   open(newunit=io, status="scratch")
   write(io, '(a)') &
      "[hamiltonian.xtb]", &
      "wexp = 5.0000000000000000E-01", &
      "kpol = 2.0000000000000000E+00", &
      "enscale = 2.0000000000000000E-02", &
      "cn = ""gfn""", &
      "shell = {ss=1.85, pp=2.23, dd=2.23, sd=2.00, pd=2.00"
   rewind io

   call param%load(io, error)
   close(io)
end subroutine test_param_invalid


subroutine test_element_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(element_record) :: param

   table = toml_table()
   table%key = "Te"
   call param%load(table, error)
end subroutine test_element_empty


subroutine test_charge_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(charge_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_charge_empty


subroutine test_dispersion_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(dispersion_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_dispersion_empty


subroutine test_halogen_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(halogen_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_halogen_empty


subroutine test_hamiltonian_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(hamiltonian_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_hamiltonian_empty


subroutine test_multipole_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(multipole_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_multipole_empty


subroutine test_repulsion_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(repulsion_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_repulsion_empty


subroutine test_thirdorder_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(thirdorder_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_thirdorder_empty


subroutine test_mask_gfn2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(param_record), target :: param, base
   type(param_mask) :: mask1, mask2
   real(wp), allocatable :: array(:)
   type(toml_table) :: table
   integer :: io

   call export_gen_param("gfn2", base)

   mask1%ref => base%record
   open(newunit=io, status="scratch")
   write(io, '(a)') &
      "hamiltonian = {}", &
      "dispersion = {}", &
      "repulsion = {}", &
      "charge = {}", &
      "thirdorder = {}", &
      "multipole = {}", &
      "[element]", &
      "H = {slater=[false]}", &
      "C = {}", &
      ""
   rewind io

   call mask1%load(io, error)
   close(io)
   if (allocated(error)) return

   call check(error, count(mask1), 26)
   if (allocated(error)) return

   table = toml_table()
   call mask1%dump(table, error)
   if (allocated(error)) return

   mask2%ref => base%record
   call mask2%load(table, error)
   if (allocated(error)) return

   call check(error, count(mask2), 26)
   if (allocated(error)) return

   allocate(array(count(mask2)))
   call base%dump(array, mask2, error)
   if (allocated(error)) return

   call param%load(array, base, mask2, error)
   if (allocated(error)) return

end subroutine test_mask_gfn2


subroutine test_mask_gfn1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(param_record), target :: param, base
   type(param_mask) :: mask
   real(wp), allocatable :: array(:)
   integer :: io

   call export_gen_param("gfn1", base)

   mask%ref => base%record
   open(newunit=io, status="scratch")
   write(io, '(a)') &
      "hamiltonian = {}", &
      "dispersion = {}", &
      "repulsion = {}", &
      "charge = {}", &
      "thirdorder = {}", &
      "halogen = {}", &
      "[element]", &
      "H = {slater=[false, true], gam3=false}", &
      "C = {}", &
      ""
   rewind io

   call mask%load(io, error)
   close(io)
   if (allocated(error)) return

   call check(error, count(mask), 28)
   if (allocated(error)) return

   allocate(array(count(mask)))
   call base%dump(array, mask, error)
   if (allocated(error)) return

   call param%load(array, base, mask, error)
   if (allocated(error)) return

end subroutine test_mask_gfn1


subroutine export_gen_param(method, param)
   character(len=*), intent(in) :: method
   type(param_record), intent(out) :: param
   select case(method)
   case("gfn1")
      call export_gfn1_param(param)
   case("gfn2")
      call export_gfn2_param(param)
   case("ipea1")
      call export_ipea1_param(param)
   end select
end subroutine export_gen_param


subroutine new_gen_calculator(calc, method, mol)
   type(xtb_calculator), intent(out) :: calc
   character(len=*), intent(in) :: method
   type(structure_type), intent(in) :: mol
   select case(method)
   case("gfn1")
      call new_gfn1_calculator(calc, mol)
   case("gfn2")
      call new_gfn2_calculator(calc, mol)
   case("ipea1")
      call new_ipea1_calculator(calc, mol)
   end select
end subroutine new_gen_calculator


subroutine test_gen(mol, method, error)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Method name
   character(len=*), intent(in) :: method
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(xtb_calculator) :: calc
   type(param_record) :: param
   type(wavefunction_type) :: wfn
   real(wp) :: energy1, energy2

   call export_gen_param(method, param)
   call new_xtb_calculator(calc, mol, param, error)
   if (allocated(error)) return

   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy1, verbosity=0)

   call new_gen_calculator(calc, method, mol)

   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy2, verbosity=0)

   call check(error, energy2, energy1, thr=thr)

end subroutine test_gen


subroutine test_round_trip(mol, method, error)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Method name
   character(len=*), intent(in) :: method
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(xtb_calculator) :: calc
   type(param_record) :: param1, param2
   type(wavefunction_type) :: wfn
   real(wp) :: energy1, energy2
   character(len=:), allocatable :: io

   call export_gen_param(method, param1)

   io = "." // method // "-" // get_name() // ".toml"
   call param1%dump(io, error)
   if (.not.allocated(error)) then
      call param2%load(io, error)
   end if
   call delete_file(io)
   if (allocated(error)) return

   call new_xtb_calculator(calc, mol, param1, error)
   if (allocated(error)) return

   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy1, verbosity=0)

   call new_xtb_calculator(calc, mol, param2, error)
   if (allocated(error)) return

   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy2, verbosity=0)

   call check(error, energy2, energy1, thr=thr)

end subroutine test_round_trip


subroutine test_gfn1_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "01")
   call test_gen(mol, "gfn1", error)

end subroutine test_gfn1_mb01


subroutine test_gfn2_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "02")
   call test_gen(mol, "gfn2", error)

end subroutine test_gfn2_mb02


subroutine test_ipea1_mb03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "03")
   call test_gen(mol, "ipea1", error)

end subroutine test_ipea1_mb03


subroutine test_gfn1_mb04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "04")
   call test_gen(mol, "gfn1", error)

end subroutine test_gfn1_mb04


subroutine test_gfn2_mb05(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "05")
   call test_gen(mol, "gfn2", error)

end subroutine test_gfn2_mb05


subroutine test_ipea1_mb06(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "06")
   call test_gen(mol, "ipea1", error)

end subroutine test_ipea1_mb06


subroutine test_gfn2_round_trip(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "07")
   call test_round_trip(mol, "gfn2", error)

end subroutine test_gfn2_round_trip


subroutine test_gfn1_round_trip(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "08")
   call test_round_trip(mol, "gfn1", error)

end subroutine test_gfn1_round_trip


subroutine test_ipea1_round_trip(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "09")
   call test_round_trip(mol, "ipea1", error)

end subroutine test_ipea1_round_trip


function get_name() result(name)
   character(len=20) :: name
   real :: val

   call random_number(val)
   write(name, '(a, z8.8)') "tblite-test-", int(val*1.0e9)
end function get_name


subroutine delete_file(file)
   character(len=*), intent(in) :: file
   integer :: unit
   logical :: exist
   inquire(file=file, exist=exist)
   if (exist) then
      open(newunit=unit, file=file)
      close(unit, status="delete")
   end if
end subroutine delete_file


end module test_xtb_param

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

!> Versioning information on this library.
module dftd4_version
   implicit none
   private

   public :: dftd4_version_string, dftd4_version_compact
   public :: get_dftd4_version


   !> String representation of the dftd4 version
   character(len=*), parameter :: dftd4_version_string = "4.2.0"

   !> Numeric representation of the dftd4 version
   integer, parameter :: dftd4_version_compact(3) = [4, 2, 0]


contains


!> Getter function to retrieve dftd4 version
subroutine get_dftd4_version(major, minor, patch, string)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_dftd4_version

   !> Major version number of the dftd4 version
   integer, intent(out), optional :: major

   !> Minor version number of the dftd4 version
   integer, intent(out), optional :: minor

   !> Patch version number of the dftd4 version
   integer, intent(out), optional :: patch

   !> String representation of the dftd4 version
   character(len=:), allocatable, intent(out), optional :: string

   if (present(major)) then
      major = dftd4_version_compact(1)
   end if
   if (present(minor)) then
      minor = dftd4_version_compact(2)
   end if
   if (present(patch)) then
      patch = dftd4_version_compact(3)
   end if
   if (present(string)) then
      string = dftd4_version_string
   end if

end subroutine get_dftd4_version


end module dftd4_version

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the density dependent potential and its contribution
!> to the effective Hamiltonian
module tblite_scf_potential
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_basis_type, only : basis_type
   use tblite_integral_type, only : integral_type
   use tblite_wavefunction_spin, only : magnet_to_updown
   implicit none
   private

   public :: potential_type, new_potential, add_pot_to_h1


   !> Container for density dependent potential-shifts
   type :: potential_type
      !> Atom-resolved charge-dependent potential shift
      real(wp), allocatable :: vat(:, :)
      !> Shell-resolved charge-dependent potential shift
      real(wp), allocatable :: vsh(:, :)
      !> Orbital-resolved charge-dependent potential shift
      real(wp), allocatable :: vao(:, :)

      !> Atom-resolved dipolar potential
      real(wp), allocatable :: vdp(:, :, :)
      !> Atom-resolved quadrupolar potential
      real(wp), allocatable :: vqp(:, :, :)
   contains
      !> Reset the density dependent potential
      procedure :: reset
   end type potential_type


contains


!> Create a new potential object
subroutine new_potential(self, mol, bas, nspin)
   !> Instance of the density dependent potential
   type(potential_type), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Description of the basis set
   type(basis_type), intent(in) :: bas
   !> Number of spin channels
   integer, intent(in) :: nspin

   allocate(self%vat(mol%nat, nspin))
   allocate(self%vsh(bas%nsh, nspin))
   allocate(self%vao(bas%nao, nspin))

   allocate(self%vdp(3, mol%nat, nspin))
   allocate(self%vqp(6, mol%nat, nspin))
end subroutine new_potential

!> Reset the density dependent potential
subroutine reset(self)
   !> Instance of the density dependent potential
   class(potential_type), intent(inout) :: self

   self%vat(:, :) = 0.0_wp
   self%vsh(:, :) = 0.0_wp
   self%vao(:, :) = 0.0_wp
   self%vdp(:, :, :) = 0.0_wp
   self%vqp(:, :, :) = 0.0_wp
end subroutine reset

!> Add the collected potential shifts to the effective Hamiltonian
subroutine add_pot_to_h1(bas, ints, pot, h1)
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Density dependent potential-shifts
   type(potential_type), intent(inout) :: pot
   !> Effective Hamiltonian
   real(wp), intent(out) :: h1(:, :, :)

   h1(:, :, 1) = ints%hamiltonian
   if (size(h1, 3) > 1) h1(:, :, 2:) = 0.0_wp

   call add_vat_to_vsh(bas, pot%vat, pot%vsh)
   call add_vsh_to_vao(bas, pot%vsh, pot%vao)
   call add_vao_to_h1(bas, ints%overlap, pot%vao, h1)
   call add_vmp_to_h1(bas, ints%dipole, pot%vdp, h1)
   call add_vmp_to_h1(bas, ints%quadrupole, pot%vqp, h1)

   call magnet_to_updown(h1)
end subroutine add_pot_to_h1

!> Expand an atom-resolved potential shift to a shell-resolved potential shift
subroutine add_vat_to_vsh(bas, vat, vsh)
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Atom-resolved charge-dependent potential shift
   real(wp), intent(in) :: vat(:, :)
   !> Shell-resolved charge-dependent potential shift
   real(wp), intent(inout) :: vsh(:, :)

   integer :: iat, ish, ii, spin

   !$omp parallel do schedule(runtime) collapse(2) default(none) &
   !$omp reduction(+:vsh) shared(bas, vat) private(spin, ii, ish, iat)
   do spin = 1, size(vat, 2)
      do iat = 1, size(vat, 1)
         ii = bas%ish_at(iat)
         do ish = 1, bas%nsh_at(iat)
            vsh(ii+ish, spin) = vsh(ii+ish, spin) + vat(iat, spin)
         end do
      end do
   end do
end subroutine add_vat_to_vsh

!> Expand a shell-resolved potential shift to an orbital-resolved potential shift
subroutine add_vsh_to_vao(bas, vsh, vao)
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Shell-resolved charge-dependent potential shift
   real(wp), intent(in) :: vsh(:, :)
   !> Orbital-resolved charge-dependent potential shift
   real(wp), intent(inout) :: vao(:, :)

   integer :: ish, iao, ii, spin

   !$omp parallel do schedule(runtime) collapse(2) default(none) &
   !$omp reduction(+:vao) shared(bas, vsh) private(ii, iao, ish)
   do spin = 1, size(vsh, 2)
      do ish = 1, size(vsh, 1)
         ii = bas%iao_sh(ish)
         do iao = 1, bas%nao_sh(ish)
            vao(ii+iao, spin) = vao(ii+iao, spin) + vsh(ish, spin)
         end do
      end do
   end do
end subroutine add_vsh_to_vao


!> Add a charge-dependent potential to the Hamiltonian
subroutine add_vao_to_h1(bas, sint, vao, h1)
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Overlap integrals
   real(wp), intent(in) :: sint(:, :)
   !> Orbital-resolved charge-dependent potential shift
   real(wp), intent(in) :: vao(:, :)
   !> Effective Hamiltonian
   real(wp), intent(inout) :: h1(:, :, :)

   integer :: iao, jao, spin

   !$omp parallel do collapse(3) schedule(runtime) default(none) &
   !$omp shared(h1, bas, sint, vao) private(spin, iao, jao)
   do spin = 1, size(h1, 3)
      do iao = 1, bas%nao
         do jao = 1, bas%nao
            h1(jao, iao, spin) = h1(jao, iao, spin) &
               & - sint(jao, iao) * 0.5_wp * (vao(jao, spin) + vao(iao, spin))
         end do
      end do
   end do
end subroutine add_vao_to_h1

!> Add a multipolar potential to the Hamiltonian
subroutine add_vmp_to_h1(bas, mpint, vmp, h1)
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Multipole integrals, multipole operator is always centered on last index
   real(wp), intent(in) :: mpint(:, :, :)
   !> Multipole potential
   real(wp), intent(in) :: vmp(:, :, :)
   !> Effective Hamiltonian
   real(wp), intent(inout) :: h1(:, :, :)

   integer :: iao, jao, iat, jat, nmp, spin

   nmp = min(size(mpint, 1), size(vmp, 1))

   !$omp parallel do collapse(3) schedule(runtime) default(none) &
   !$omp shared(h1, bas, mpint, vmp, nmp) private(spin, iao, jao, iat, jat)
   do spin = 1, size(h1, 3)
      do iao = 1, bas%nao
         do jao = 1, bas%nao
            iat = bas%ao2at(iao)
            jat = bas%ao2at(jao)
            h1(jao, iao, spin) = h1(jao, iao, spin) &
               & - 0.5_wp * dot_product(mpint(:nmp, jao, iao), vmp(:nmp, iat, spin)) &
               & - 0.5_wp * dot_product(mpint(:nmp, iao, jao), vmp(:nmp, jat, spin))
         end do
      end do
   end do
end subroutine add_vmp_to_h1

end module tblite_scf_potential

!> Routines to build rhs (phi and psi)
module ddx_multipolar_solutes

use ddx_definitions
use ddx_core
use ddx_gradients

implicit none

contains

!> @defgroup Fortran_interface_multipolar Fortran interface: multipolar terms
!! Exposed multipolar modules in the Fortran API

!> Given a multipolar distribution, compute the required electrostatic
!! properties for the chosen model
!!
!> @ingroup Fortran_interface_multipolar
!! @param[in] params: ddx parameters
!! @param[in]  constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2, nsph)
!! @param[in] mmax: maximum angular momentum of the multipoles
!! @param[out] electrostatics, ddX electrostatic properties container
!! @param[inout] ddx_error: ddX error
!!
subroutine multipole_electrostatics(params, constants, workspace, multipoles, &
        & mmax, electrostatics, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    integer, intent(in) :: mmax
    real(dp), intent(in) :: multipoles((mmax + 1)**2, params % nsph)
    type(ddx_electrostatics_type), intent(out) :: electrostatics
    type(ddx_error_type), intent(inout) :: ddx_error

    call allocate_electrostatics(params, constants, electrostatics, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "allocate_electrostatics returned an error, exiting")
        return
    end if

    ! Compute the required electrostatic properties
    if (electrostatics % do_phi .and. electrostatics % do_e &
            & .and. electrostatics % do_g) then
        call multipole_electrostatics_2(params, constants, workspace, &
            & multipoles, 0, electrostatics % phi_cav, &
            & electrostatics % e_cav, electrostatics % g_cav, ddx_error)
    else if (electrostatics % do_phi .and. electrostatics % do_e) then
        call multipole_electrostatics_1(params, constants, workspace, &
            & multipoles, 0, electrostatics % phi_cav, &
            & electrostatics % e_cav, ddx_error)
    else
        call multipole_electrostatics_0(params, constants, workspace, &
            & multipoles, 0, electrostatics % phi_cav, ddx_error)
    end if

end subroutine multipole_electrostatics

!> Given a multipolar distribution, compute the potential, its gradient and
!> its hessian at the target points this is done with or without FMMs depending
!> on the relevant flag
!> The multipoles must be centered on the ddx spheres.
!! @param[in] params: ddx parameters
!! @param[in]  constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2, nsph)
!! @param[in] mmax: maximum angular momentum of the multipoles
!! @param[out] phi_cav: electric potential at the target points, size (ncav)
!! @param[out] e_cav: electric field at the target points,
!!     size (3, ncav)
!! @param[out] g_cav: electric field gradient at the target points,
!!     size (3, 3, ncav)
!! @param[inout] ddx_error: ddX error
!!
subroutine multipole_electrostatics_2(params, constants, workspace, multipoles, &
        & mmax, phi_cav, e_cav, g_cav, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    integer, intent(in) :: mmax
    real(dp), intent(in) :: multipoles((mmax + 1)**2, params % nsph)
    real(dp), intent(out) :: phi_cav(constants % ncav)
    real(dp), intent(out) :: e_cav(3, constants % ncav)
    real(dp), intent(out) :: g_cav(3, 3, constants % ncav)

    if (params % fmm .eq. 0) then
        call build_g_dense(multipoles, params % csph, mmax, params % nsph, &
            & phi_cav, constants % ccav, constants % ncav, e_cav, g_cav, &
            & ddx_error)
    else if (params % fmm .eq. 1) then
        call build_g_fmm(params, constants, workspace, multipoles, &
            & mmax, phi_cav, e_cav, g_cav, ddx_error)
    end if
end subroutine multipole_electrostatics_2

!> Given a multipolar distribution, compute the potential, its gradient and
!> its hessian at the target points using a N^2 code.
!> As this routine does not use the FMM machinery it is more flexible and
!> accepts arbitrary sources and targets.
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2,nm)
!! @param[in] cm: centers of the multipolar distributions, size (3,nm)
!! @param[in] mmax: maximum angular momentum of the multipoles
!! @param[in] nm: number of multipoles
!! @param[out] phi_cav: electric potential at the target points, size (ncav)
!! @param[out] e_cav: electric field at the target points, size (3, ncav)
!! @param[out] g_cav: electric field at the target points, size (3, 3, ncav)
!! @param[in] ccav: coordinates of the target points, size (3,ncav)
!! @param[in] ncav: number of target points
!! @param[out] error_flag: 0 if everything went fine
!! @param[out] error_message: additional information in case of an error
!! @param[inout] ddx_error: ddX error
!!
subroutine build_g_dense(multipoles, cm, mmax, nm, phi_cav, ccav, ncav, &
        & e_cav, g_cav, ddx_error)
    implicit none
    integer, intent(in) :: mmax, nm, ncav
    real(dp), intent(in) :: multipoles((mmax + 1)**2, nm)
    real(dp), intent(in) :: cm(3, nm), ccav(3, ncav)
    real(dp), intent(out) :: phi_cav(ncav), e_cav(3, ncav), g_cav(3, 3, ncav)
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), allocatable  :: tmp_m_grad(:, :, :), vscales(:), &
        & vscales_rel(:), v4pi2lp1(:), tmp_m_hess(:, :, :, :), tmp(:, :)
    integer icav, im, info
    real(dp) :: v, ex, ey, ez, c(3), gxx, gxy, gxz, gyy, gyz, gzz

    ! allocate some space for the M2M gradients and precompute
    ! the quantities for the m2p
    allocate(tmp_m_grad((mmax + 2)**2, 3, nm), vscales((mmax + 3)**2), &
        & vscales_rel((mmax + 3)**2), v4pi2lp1(mmax + 3), &
        & tmp_m_hess((mmax + 3)**2, 3, nm, 3), tmp((mmax + 2)**2, 3), &
        & stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Allocation failed in build_g_dense!")
        return
    end if
    call ylmscale(mmax + 2, vscales, v4pi2lp1, vscales_rel)

    ! call the helper routine for the M2M gradient and hessian
    call grad_m2m(multipoles, mmax, nm, tmp_m_grad, ddx_error)
    tmp = tmp_m_grad(:, 1, :)
    call grad_m2m(tmp, mmax + 1, nm, tmp_m_hess(:, :, :, 1), ddx_error)
    tmp = tmp_m_grad(:, 2, :)
    call grad_m2m(tmp, mmax + 1, nm, tmp_m_hess(:, :, :, 2), ddx_error)
    tmp = tmp_m_grad(:, 3, :)
    call grad_m2m(tmp, mmax + 1, nm, tmp_m_hess(:, :, :, 3), ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "grad_m2m returned an error, exiting")
        return
    end if

    ! loop over the targets and the sources and assemble the electric
    ! potential and field
    do icav = 1, ncav
        v = zero
        ex = zero
        ey = zero
        ez = zero
        gxx = zero
        gxy = zero
        gxz = zero
        gyy = zero
        gyz = zero
        gzz = zero
        do im = 1, nm
            c(:) = ccav(:, icav) - cm(:, im)
            call fmm_m2p(c, one, mmax, vscales_rel, one, multipoles(:, im), &
                & one, v)

            call fmm_m2p(c, one, mmax + 1, vscales_rel, one, &
                & tmp_m_grad(:, 1, im), one, ex)
            call fmm_m2p(c, one, mmax + 1, vscales_rel, one, &
                & tmp_m_grad(:, 2, im), one, ey)
            call fmm_m2p(c, one, mmax + 1, vscales_rel, one, &
                & tmp_m_grad(:, 3, im), one, ez)

            call fmm_m2p(c, one, mmax + 2, vscales_rel, one, &
                & tmp_m_hess(:, 1, im, 1), one, gxx)
            call fmm_m2p(c, one, mmax + 2, vscales_rel, one, &
                & tmp_m_hess(:, 2, im, 1), one, gxy)
            call fmm_m2p(c, one, mmax + 2, vscales_rel, one, &
                & tmp_m_hess(:, 3, im, 1), one, gxz)

            call fmm_m2p(c, one, mmax + 2, vscales_rel, one, &
                & tmp_m_hess(:, 2, im, 2), one, gyy)
            call fmm_m2p(c, one, mmax + 2, vscales_rel, one, &
                & tmp_m_hess(:, 3, im, 2), one, gyz)

            call fmm_m2p(c, one, mmax + 2, vscales_rel, one, &
                & tmp_m_hess(:, 3, im, 3), one, gzz)
        end do
        phi_cav(icav) = v
        e_cav(1, icav) = ex
        e_cav(2, icav) = ey
        e_cav(3, icav) = ez
        g_cav(1, 1, icav) = gxx
        g_cav(1, 2, icav) = gxy
        g_cav(1, 3, icav) = gxz
        g_cav(2, 1, icav) = gxy
        g_cav(2, 2, icav) = gyy
        g_cav(2, 3, icav) = gyz
        g_cav(3, 1, icav) = gxz
        g_cav(3, 2, icav) = gyz
        g_cav(3, 3, icav) = gzz
    end do

    deallocate(tmp_m_grad, vscales, vscales_rel, v4pi2lp1, tmp_m_hess, &
        & tmp, stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Deallocation failed in build_e_dense!")
        return
    end if
end subroutine build_g_dense

!> Given a multipolar distribution, compute the potential and its gradient
!> at the target points this is done with or without FMMs depending on the
!> relevant flag
!> The multipoles must be centered on the ddx spheres.
!! @param[in] params: ddx parameters
!! @param[in]  constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2, nsph)
!! @param[in] mmax: maximum angular momentum of the multipoles
!! @param[out] phi_cav: electric potential at the target points, size (ncav)
!! @param[out] e_cav: electric field at the target points,
!!     size (3, ncav)
!! @param[inout] ddx_error: ddX error
!!
subroutine multipole_electrostatics_1(params, constants, workspace, multipoles, &
        & mmax, phi_cav, e_cav, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    integer, intent(in) :: mmax
    real(dp), intent(in) :: multipoles((mmax + 1)**2, params % nsph)
    real(dp), intent(out) :: phi_cav(constants % ncav)
    real(dp), intent(out) :: e_cav(3, constants % ncav)
    if (params % fmm .eq. 0) then
        call build_e_dense(multipoles, params % csph, mmax, params % nsph, &
            & phi_cav, constants % ccav, constants % ncav, e_cav, ddx_error)
    else if (params % fmm .eq. 1) then
        call build_e_fmm(params, constants, workspace, multipoles, &
            & mmax, phi_cav, e_cav, ddx_error)
    end if
end subroutine multipole_electrostatics_1

!> Given a multipolar distribution, compute the potential and its gradient
!> at the target points using a N^2 code. 
!> As this routine does not use the FMM machinery it is more flexible and
!> accepts arbitrary sources and targets.
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2,nm)
!! @param[in] cm: centers of the multipolar distributions, size (3,nm)
!! @param[in] mmax: maximum angular momentum of the multipoles
!! @param[in] nm: number of multipoles
!! @param[out] phi_cav: electric potential at the target points, size (ncav)
!! @param[out] e_cav: electric field at the target points, size (3, ncav)
!! @param[in] ccav: coordinates of the target points, size (3,ncav)
!! @param[in] ncav: number of target points
!! @param[inout] ddx_error: ddX error
!!
subroutine build_e_dense(multipoles, cm, mmax, nm, phi_cav, ccav, ncav, &
        & e_cav, ddx_error)
    implicit none
    integer, intent(in) :: mmax, nm, ncav
    real(dp), intent(in) :: cm(3, nm), ccav(3, ncav), &
        & multipoles((mmax + 1)**2, nm)
    real(dp), intent(out) :: phi_cav(ncav), e_cav(3, ncav)
    type(ddx_error_type), intent(inout) :: ddx_error
    ! local variables
    real(dp), allocatable  :: tmp_m_grad(:, :, :), vscales(:), &
        & vscales_rel(:), v4pi2lp1(:)
    integer icav, im, info
    real(dp) :: v, ex, ey, ez, c(3)

    ! allocate some space for the M2M gradients and precompute
    ! the quantities for the m2p
    allocate(tmp_m_grad((mmax + 2)**2, 3, nm), vscales((mmax + 2)**2), &
        & vscales_rel((mmax + 2)**2), v4pi2lp1(mmax + 2), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Allocation failed in build_e_dense!")
        return
    end if
    call ylmscale(mmax + 1, vscales, v4pi2lp1, vscales_rel)

    ! call the helper routine for the M2M gradients
    call grad_m2m(multipoles, mmax, nm, tmp_m_grad, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "grad_m2m returned an error, exiting")
        return
    end if


    ! loop over the targets and the sources and assemble the electric
    ! potential and field
    do icav = 1, ncav
        v = zero
        ex = zero
        ey = zero
        ez = zero
        do im = 1, nm
            c(:) = ccav(:, icav) - cm(:, im)
            call fmm_m2p(c, one, mmax, vscales_rel, one, multipoles(:, im), &
                & one, v)

            call fmm_m2p(c, one, mmax + 1, vscales_rel, one, &
                & tmp_m_grad(:, 1, im), one, ex)
            call fmm_m2p(c, one, mmax + 1, vscales_rel, one, &
                & tmp_m_grad(:, 2, im), one, ey)
            call fmm_m2p(c, one, mmax + 1, vscales_rel, one, &
                & tmp_m_grad(:, 3, im), one, ez)
        end do
        phi_cav(icav) = v
        e_cav(1, icav) = ex
        e_cav(2, icav) = ey
        e_cav(3, icav) = ez
    end do

    deallocate(tmp_m_grad, vscales, vscales_rel, v4pi2lp1, stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Deallocation failed in build_e_dense!")
        return
    end if
end subroutine build_e_dense

!> Given a multipolar distribution, compute the potential at the target points
!> this is done with or without FMMs depending on the relevant flag
!> The multipoles must be centered on the ddx spheres.
!! @param[in] params: ddx parameters
!! @param[in]  constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2, nsph)
!! @param[in] mmax: maximum angular momentum of the multipoles
!! @param[out] phi_cav: electric potential at the target points, size (ncav)
!! @param[inout] ddx_error: ddX error
!!
subroutine multipole_electrostatics_0(params, constants, workspace, multipoles, &
        & mmax, phi_cav, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    integer, intent(in) :: mmax
    real(dp), intent(in) :: multipoles((mmax + 1)**2, params % nsph)
    real(dp), intent(out) :: phi_cav(constants % ncav)
    if (params % fmm .eq. 0) then
        call build_phi_dense(multipoles, params % csph, mmax, params % nsph, &
            & phi_cav, constants % ccav, constants % ncav, ddx_error)
    else if (params % fmm .eq. 1) then
        call build_phi_fmm(params, constants, workspace, multipoles, mmax, &
            & phi_cav)
    end if
end subroutine multipole_electrostatics_0

!> Given a multipolar distribution, compute the potential at the target points
!> using a N^2 code.
!> As this routine does not use the FMM machinery it is more flexible and
!> accepts arbitrary sources and targets.
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2,nm)
!! @param[in] cm: centers of the multipolar distributions, size (3,nm)
!! @param[in] mmax: maximum angular momentum of the multipoles
!! @param[in] nm: number of multipoles
!! @param[out] phi_cav: electric potential at the target points, size (ncav)
!! @param[in] ccav: coordinates of the target points, size (3,ncav)
!! @param[in] ncav: number of target points
!! @param[inout] ddx_error: ddX error
!!
subroutine build_phi_dense(multipoles, cm, mmax, nm, phi_cav, ccav, ncav, &
        & ddx_error)
    implicit none
    integer, intent(in) :: mmax, nm, ncav
    real(dp), intent(in) :: cm(3, nm), ccav(3, ncav), &
        & multipoles((mmax + 1)**2, nm)
    real(dp), intent(out) :: phi_cav(ncav)
    type(ddx_error_type), intent(inout) :: ddx_error
    ! local variables
    integer icav, im, info
    real(dp) :: v, c(3)
    real(dp), allocatable :: vscales(:), vscales_rel(:), v4pi2lp1(:)

    ! precompute the quantities for the m2p
    allocate(vscales((mmax + 1)**2), vscales_rel((mmax + 1)**2), &
        & v4pi2lp1(mmax + 1), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, 'Allocation failed in build_phi_dense!')
        return
    end if
    call ylmscale(mmax, vscales, v4pi2lp1, vscales_rel)

    do icav = 1, ncav
        v = zero
        do im = 1, nm
            c(:) = ccav(:, icav) - cm(:, im)
            call fmm_m2p(c, one, mmax, vscales_rel, one, &
                & multipoles(:, im), one, v)
        end do
        phi_cav(icav) = v
    end do

    deallocate(vscales, vscales_rel, v4pi2lp1, stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, 'Deallocation failed in build_phi_dense!')
        return
    end if

end subroutine build_phi_dense

!> Given a multipolar distribution, compute the potential and its gradient
!> at the target points using FMMs.
!! @param[in] params: ddx parameters
!! @param[in]  constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2,nsph)
!! @param[in] mmax: maximum angular momentum of the multipoles
!! @param[out] phi_cav: electric potential at the target points, size (ncav)
!! @param[out] e_cav: electric field at the target points,
!!     size(3, ncav)
!! @param[inout] ddx_error: ddX error
!!
subroutine build_e_fmm(params, constants, workspace, multipoles, &
        & mmax, phi_cav, e_cav, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    integer, intent(in) :: mmax
    real(dp), intent(in) :: multipoles((mmax + 1)**2, params % nsph)
    real(dp), intent(out) :: phi_cav(constants % ncav), &
        & e_cav(3, constants % ncav)
    ! local variables
    integer :: info, isph, igrid, inode, jnode, jsph, jnear, icav
    real(dp) :: ex, ey, ez, c(3)
    real(dp), allocatable :: tmp_m_grad(:, :, :), grid_grad(:, :, :)

    allocate(tmp_m_grad((mmax + 2)**2, 3, params % nsph), &
        & grid_grad(params % ngrid, 3, params % nsph), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Allocation failed in build_e_fmm!")
        return
    end if

    ! compute the gradient of the m2m trasformation
    call grad_m2m(multipoles, mmax, params % nsph, tmp_m_grad, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "grad_m2m returned an error, exiting")
        return
    end if

    ! copy the multipoles in the right places
    call load_m(params, constants, workspace, multipoles, mmax)

    ! perform the m2m, m2l and l2l steps
    call do_fmm(params, constants, workspace)

    ! near field potential (m2p)
    call tree_m2p(params, constants, params % lmax, one, &
        & workspace % tmp_sph, one, workspace % tmp_grid)

    ! far field potential, each sphere at its own points (l2p)
    call dgemm('T', 'N', params % ngrid, params % nsph, &
        & constants % nbasis, one, constants % vgrid2, &
        & constants % vgrid_nbasis, workspace % tmp_sph, &
        & constants % nbasis, one, workspace % tmp_grid, &
        & params % ngrid)

    ! near field gradients
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if(constants % ui(igrid, isph) .eq. zero) cycle
            inode = constants % snode(isph)
            ex = zero
            ey = zero
            ez = zero
            do jnear = constants % snear(inode), constants % snear(inode+1) - 1
                jnode = constants % near(jnear)
                jsph = constants % order(constants % cluster(1, jnode))
                c = params % csph(:, isph) + constants % cgrid(:, igrid) &
                    & *params % rsph(isph) - params % csph(:, jsph)
                call fmm_m2p(c, one, mmax + 1, constants % vscales_rel, &
                    & one, tmp_m_grad(:, 1, jsph), one, ex)
                call fmm_m2p(c, one, mmax + 1, constants % vscales_rel, &
                    & one, tmp_m_grad(:, 2, jsph), one, ey)
                call fmm_m2p(c, one, mmax + 1, constants % vscales_rel, &
                    & one, tmp_m_grad(:, 3, jsph), one, ez)
            end do
            grid_grad(igrid, 1, isph) = ex
            grid_grad(igrid, 2, isph) = ey
            grid_grad(igrid, 3, isph) = ez
        end do
    end do

    ! far-field FMM gradients (only if pl > 0)
    if (params % pl .gt. 0) then
        call tree_grad_l2l(params, constants, workspace % tmp_node_l, &
            & workspace % tmp_sph_l_grad, workspace % tmp_sph_l)
        call dgemm('T', 'N', params % ngrid, 3*params % nsph, &
            & (params % pl)**2, one, constants % vgrid2, &
            & constants % vgrid_nbasis, workspace % tmp_sph_l_grad, &
            & (params % pl+1)**2, one, grid_grad, params % ngrid)
    end if

    ! discard the internal points
    icav = 0
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if(constants % ui(igrid, isph) .eq. zero) cycle
            icav = icav + 1
            phi_cav(icav) = workspace % tmp_grid(igrid, isph)
            e_cav(:, icav) = grid_grad(igrid, :, isph)
        end do
    end do

    deallocate(tmp_m_grad, grid_grad, stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Deallocation failed in build_e_fmm!")
        return
    end if

end subroutine build_e_fmm

!> Given a multipolar distribution, compute the potential, the field
!> and the field gradient at the target points using FMMs.
!! @param[in] params: ddx parameters
!! @param[in]  constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2,nsph)
!! @param[in] mmax: maximum angular momentum of the multipoles
!! @param[out] phi_cav: electric potential at the target points, size (ncav)
!! @param[out] e_cav: electric field at the target points,
!!     size(3, ncav)
!! @param[out] g_cav: electric field gradient at the target points,
!!     size(3, 3, ncav)
!! @param[inout] ddx_error: ddX error
!!
subroutine build_g_fmm(params, constants, workspace, multipoles, &
        & mmax, phi_cav, e_cav, g_cav, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    integer, intent(in) :: mmax
    real(dp), intent(in) :: multipoles((mmax + 1)**2, params % nsph)
    real(dp), intent(out) :: phi_cav(constants % ncav), &
        & e_cav(3, constants % ncav), g_cav(3, 3, constants % ncav)
    ! local variables
    integer :: info, isph, igrid, inode, jnode, jsph, jnear, icav
    real(dp) :: ex, ey, ez, c(3), gxx, gxy, gxz, gyy, gyz, gzz
    real(dp), allocatable :: m_grad(:, :, :), grid_grad(:, :, :), &
        & m_hess_x(:, :, :), m_hess_y(:, :, :), m_hess_z(:, :, :), &
        & m_grad_component(:, :), grid_hess_x(:, :, :), &
        & grid_hess_y(:, :, :), grid_hess_z(:, :, :), grid_hessian2(:, :, :)

    allocate(m_hess_x((mmax+3)**2, 3, params % nsph), &
        & m_hess_y((mmax+3)**2, 3, params % nsph), &
        & m_hess_z((mmax+3)**2, 3, params % nsph), &
        & m_grad_component((mmax+2)**2, params % nsph), &
        & m_grad((mmax + 2)**2, 3, params % nsph), &
        & grid_grad(params % ngrid, 3, params % nsph), &
        & grid_hess_x(params % ngrid, 3, params % nsph), &
        & grid_hess_y(params % ngrid, 3, params % nsph), &
        & grid_hess_z(params % ngrid, 3, params % nsph), &
        & grid_hessian2(params % ngrid, 3, params % nsph), &
        & stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Allocation failed in build_g_fmm!")
        return
    end if

    ! compute the gradient of the m2m trasformation
    call grad_m2m(multipoles, mmax, params % nsph, m_grad, ddx_error)

    ! starting from the previously computed gradient, compute the
    ! hessian of the target multipoles
    m_grad_component = m_grad(:, 1, :)
    call grad_m2m(m_grad_component, mmax + 1, params % nsph, m_hess_x, ddx_error)
    m_grad_component = m_grad(:, 2, :)
    call grad_m2m(m_grad_component, mmax + 1, params % nsph, m_hess_y, ddx_error)
    m_grad_component = m_grad(:, 3, :)
    call grad_m2m(m_grad_component, mmax + 1, params % nsph, m_hess_z, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "grad_m2m returned an error, exiting")
        return
    end if


    ! copy the multipoles to the right places
    call load_m(params, constants, workspace, multipoles, mmax)

    ! perform the m2m, m2l and l2l steps
    call do_fmm(params, constants, workspace)

    ! near field potential (m2p)
    call tree_m2p(params, constants, params % lmax, one, &
        & workspace % tmp_sph, one, workspace % tmp_grid)

    ! far field potential, each sphere at its own points (l2p)
    call dgemm('T', 'N', params % ngrid, params % nsph, &
        & constants % nbasis, one, constants % vgrid2, &
        & constants % vgrid_nbasis, workspace % tmp_sph, &
        & constants % nbasis, one, workspace % tmp_grid, &
        & params % ngrid)

    ! near field gradients
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if(constants % ui(igrid, isph) .eq. zero) cycle
            inode = constants % snode(isph)
            ex = zero
            ey = zero
            ez = zero
            do jnear = constants % snear(inode), constants % snear(inode+1) - 1
                jnode = constants % near(jnear)
                jsph = constants % order(constants % cluster(1, jnode))
                c = params % csph(:, isph) + constants % cgrid(:, igrid) &
                    & *params % rsph(isph) - params % csph(:, jsph)
                call fmm_m2p(c, one, mmax + 1, constants % vscales_rel, &
                    & one, m_grad(:, 1, jsph), one, ex)
                call fmm_m2p(c, one, mmax + 1, constants % vscales_rel, &
                    & one, m_grad(:, 2, jsph), one, ey)
                call fmm_m2p(c, one, mmax + 1, constants % vscales_rel, &
                    & one, m_grad(:, 3, jsph), one, ez)
            end do
            grid_grad(igrid, 1, isph) = ex
            grid_grad(igrid, 2, isph) = ey
            grid_grad(igrid, 3, isph) = ez
        end do
    end do

    ! near field hessians
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if(constants % ui(igrid, isph) .eq. zero) cycle
            inode = constants % snode(isph)
            gxx = zero
            gxy = zero
            gxz = zero
            gyy = zero
            gyz = zero
            gzz = zero
            do jnear = constants % snear(inode), constants % snear(inode+1) - 1
                jnode = constants % near(jnear)
                jsph = constants % order(constants % cluster(1, jnode))
                c = params % csph(:, isph) + constants % cgrid(:, igrid) &
                    & *params % rsph(isph) - params % csph(:, jsph)
                call fmm_m2p(c, one, mmax + 2, constants % vscales_rel, &
                    & one, m_hess_x(:, 1, jsph), one, gxx)
                call fmm_m2p(c, one, mmax + 2, constants % vscales_rel, &
                    & one, m_hess_x(:, 2, jsph), one, gxy)
                call fmm_m2p(c, one, mmax + 2, constants % vscales_rel, &
                    & one, m_hess_x(:, 3, jsph), one, gxz)
                call fmm_m2p(c, one, mmax + 2, constants % vscales_rel, &
                    & one, m_hess_y(:, 2, jsph), one, gyy)
                call fmm_m2p(c, one, mmax + 2, constants % vscales_rel, &
                    & one, m_hess_y(:, 3, jsph), one, gyz)
                call fmm_m2p(c, one, mmax + 2, constants % vscales_rel, &
                    & one, m_hess_z(:, 3, jsph), one, gzz)
            end do
            grid_hess_x(igrid, 1, isph) = gxx
            grid_hess_x(igrid, 2, isph) = gxy
            grid_hess_x(igrid, 3, isph) = gxz
            grid_hess_y(igrid, 1, isph) = gxy
            grid_hess_y(igrid, 2, isph) = gyy
            grid_hess_y(igrid, 3, isph) = gyz
            grid_hess_z(igrid, 1, isph) = gxz
            grid_hess_z(igrid, 2, isph) = gyz
            grid_hess_z(igrid, 3, isph) = gzz
        end do
    end do

    ! far-field FMM gradients (only if pl > 0)
    if (params % pl .gt. 0) then
        call tree_grad_l2l(params, constants, workspace % tmp_node_l, &
            & workspace % tmp_sph_l_grad, workspace % tmp_sph_l)
        call dgemm('T', 'N', params % ngrid, 3*params % nsph, &
            & (params % pl)**2, one, constants % vgrid2, &
            & constants % vgrid_nbasis, workspace % tmp_sph_l_grad, &
            & (params % pl+1)**2, one, grid_grad, params % ngrid)
        call tree_grad_l2l(params, constants, workspace % tmp_node_l, &
            & workspace % tmp_sph_l_grad, workspace % tmp_sph_l)
    end if

    ! Far field FMM hessians
    if (params % pl .gt. 1) then
        ! Load previously computed gradient into leaves, since
        ! tree_grad_l2l currently takes local expansions of entire
        ! tree. In future it might be changed.
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            workspace % tmp_node_l(:, inode) = &
                & workspace % tmp_sph_l_grad(:, 1, isph)
        end do
        ! Get gradient of a gradient of L2L. Currently this uses input
        ! pl maximal degree of local harmonics but in reality we need
        ! only pl-1 maximal degree since coefficients of harmonics of a
        ! degree pl are zeros.
        call tree_grad_l2l(params, constants, workspace % tmp_node_l, &
            & workspace % tmp_sph_l_grad2, workspace % tmp_sph_l)
        ! Apply L2P for every axis
        call dgemm('T', 'N', params % ngrid, 3*params % nsph, &
            & (params % pl-1)**2, one, constants % vgrid2, &
            & constants % vgrid_nbasis, workspace % tmp_sph_l_grad2, &
            & (params % pl+1)**2, zero, grid_hessian2, params % ngrid)
        ! Properly copy hessian
        grid_hess_x = grid_hess_x + grid_hessian2

        ! same for y
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            workspace % tmp_node_l(:, inode) = &
                & workspace % tmp_sph_l_grad(:, 2, isph)
        end do
        call tree_grad_l2l(params, constants, workspace % tmp_node_l, &
            & workspace % tmp_sph_l_grad2, workspace % tmp_sph_l)
        call dgemm('T', 'N', params % ngrid, 3*params % nsph, &
            & (params % pl-1)**2, one, constants % vgrid2, &
            & constants % vgrid_nbasis, workspace % tmp_sph_l_grad2, &
            & (params % pl+1)**2, zero, grid_hessian2, params % ngrid)
        grid_hess_y = grid_hess_y + grid_hessian2

        ! same for z
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            workspace % tmp_node_l(:, inode) = &
                & workspace % tmp_sph_l_grad(:, 3, isph)
        end do
        call tree_grad_l2l(params, constants, workspace % tmp_node_l, &
            & workspace % tmp_sph_l_grad2, workspace % tmp_sph_l)
        call dgemm('T', 'N', params % ngrid, 3*params % nsph, &
            & (params % pl-1)**2, one, constants % vgrid2, &
            & constants % vgrid_nbasis, workspace % tmp_sph_l_grad2, &
            & (params % pl+1)**2, zero, grid_hessian2, params % ngrid)
        grid_hess_z = grid_hess_z + grid_hessian2

    end if

    ! discard the internal points
    icav = 0
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if(constants % ui(igrid, isph) .eq. zero) cycle
            icav = icav + 1
            phi_cav(icav) = workspace % tmp_grid(igrid, isph)
            e_cav(:, icav) = grid_grad(igrid, :, isph)
            g_cav(1, :, icav) = grid_hess_x(igrid, :, isph)
            g_cav(2, :, icav) = grid_hess_y(igrid, :, isph)
            g_cav(3, :, icav) = grid_hess_z(igrid, :, isph)
        end do
    end do

    deallocate(m_hess_x, m_hess_y, m_hess_z, m_grad_component, m_grad, &
        & grid_grad, grid_hess_x, grid_hess_y, grid_hess_z, grid_hessian2, &
        & stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Deallocation failed in build_g_fmm!")
        return
    end if

end subroutine build_g_fmm

!> Given a multipolar distribution, compute the potential at the target points
!> using FMMs.
!! @param[in] params: ddx parameters
!! @param[in]  constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2,nsph)
!! @param[in] mmax: maximum angular momentum of the multipoles
!! @param[out] phi_cav: electric potential at the target points, size (ncav)
!!
subroutine build_phi_fmm(params, constants, workspace, multipoles, mmax, &
        & phi_cav)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: mmax
    real(dp), intent(in) :: multipoles((mmax + 1)**2, params % nsph)
    real(dp), intent(out) :: phi_cav(constants % ncav)
    ! local variables
    integer isph, igrid, icav

    ! copy the multipoles in the right places
    call load_m(params, constants, workspace, multipoles, mmax)

    ! perform the m2m, m2l and l2l steps
    call do_fmm(params, constants, workspace)

    ! near field
    call tree_m2p(params, constants, params % lmax, one, &
        & workspace % tmp_sph, one, workspace % tmp_grid)

    ! Potential from each sphere to its own grid points (l2p)
    call dgemm('T', 'N', params % ngrid, params % nsph, &
       & constants % nbasis, one, constants % vgrid2, &
       & constants % vgrid_nbasis, workspace % tmp_sph, &
       & constants % nbasis, one, workspace % tmp_grid, &
       & params % ngrid)

    ! discard the internal points
    icav = 0
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if(constants % ui(igrid, isph) .eq. zero) cycle
            icav = icav + 1
            phi_cav(icav) = workspace % tmp_grid(igrid, isph)
        end do
    end do

end subroutine build_phi_fmm

!> @ingroup Fortran_interface_multipolar
!> Given a multipolar distribution, assemble the RHS psi.
!> The multipoles must be centered on the ddx spheres.
!! @param[in] params: ddx parameters
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2,nsph)
!! @param[in] mmax: maximum angular momentum of the multipoles
!! @param[out] psi: RHS for adjoint linear systems,
!!     size ((lmax+1)**2,nsph), the internal lmax should be >= mmax
!!
subroutine multipole_psi(params, multipoles, mmax, psi)
    implicit none
    type(ddx_params_type), intent(in) :: params
    integer, intent(in) :: mmax
    real(dp), intent(in) :: multipoles((mmax+1)**2, params % nsph)
    real(dp), intent(out) :: psi((params % lmax+1)**2, params % nsph)
    integer :: isph, l, m, i
    real(dp) :: v

    psi = zero
    do isph = 1, params % nsph
        do l = 0, mmax
            v = fourpi/((two*dble(l) + one)*(params % rsph(isph)**(l)))
            i = l*l + l + 1
            do m = -l, l
                psi(i + m, isph) = v*multipoles(i + m, isph)
            end do
        end do
    end do
end subroutine multipole_psi

!> Given a multipolar distribution, load it into workspace % tmp_sph
!> and workspace % tmp_node_m to be used by the FMM
!! @param[in] params: ddx parameters
!! @param[in] constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2,nsph)
!! @param[in] mmax: maximum angular momentum of the multipoles
!!
subroutine load_m(params, constants, workspace, multipoles, mmax)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: mmax
    real(dp), intent(in) :: multipoles((mmax + 1)**2, params % nsph)
    integer :: isph, l, ind, m, inode, tmp_max

    tmp_max = min(params % pm, mmax)

    ! P2M is not needed as we have already multipolar distributions
    ! we just have to copy the multipoles in the proper places
    do isph = 1, params % nsph
        inode = constants % snode(isph)
        workspace % tmp_sph(:, isph) = zero
        workspace % tmp_node_m(:, inode) = zero
        do l = 0, tmp_max
            ind = l*l + l + 1
            do m = -l, l
                workspace % tmp_sph(ind+m, isph) = &
                    & multipoles(ind+m, isph)/(params%rsph(isph)**(l+1))
                workspace % tmp_node_m(ind+m, inode) = &
                    & multipoles(ind+m, isph)/(params%rsph(isph)**(l+1))
            end do
        end do
    end do

end subroutine load_m

!> Given a multipolar distribution loaded in the workspace
!> perform the M2M, M2L, L2L and L2P steps.
!! @param[in] params: ddx parameters
!! @param[in]  constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[inout] ddx_error: ddX error
!!
subroutine do_fmm(params, constants, workspace)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    call tree_m2m_rotation(params, constants, workspace % tmp_node_m)
    call tree_m2l_rotation(params, constants, workspace % tmp_node_m, &
        & workspace % tmp_node_l)
    call tree_l2l_rotation(params, constants, workspace % tmp_node_l)
    call tree_l2p(params, constants, one, workspace % tmp_node_l, zero, &
        & workspace % tmp_grid, workspace % tmp_sph_l)
end subroutine do_fmm

!> Given a multipolar distribution compute the action of dP on it, this
!> is required in the computation of the forces.
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2, nsph)
!! @param[in] mmax: maximum angular momentum of the multipolar distribution
!! @param[in] nm: number of multipoles
!! @param[out] tmp_m_grad: gradient of the M2M operator,
!!     size ((mmax + 1)**2, 3, nm)
!! @param[inout] ddx_error: ddX error
!!
subroutine grad_m2m(multipoles, mmax, nm, tmp_m_grad, ddx_error)
    implicit none
    integer, intent(in) :: mmax, nm
    real(dp), intent(in) :: multipoles((mmax + 1)**2, nm)
    real(dp), intent(out) :: tmp_m_grad((mmax + 2)**2, 3, nm)
    type(ddx_error_type), intent(inout) :: ddx_error
    ! local variables
    real(dp), dimension(3, 3) :: zx_coord_transform, zy_coord_transform
    real(dp), allocatable :: tmp(:, :)
    integer :: info, im, l, indi, indj, m
    real(dp) :: tmp1, tmp2

    allocate(tmp((mmax + 2)**2, nm), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Allocation failed in grad_m2m!")
        return
    end if

    zx_coord_transform = zero
    zx_coord_transform(3, 2) = one
    zx_coord_transform(2, 3) = one
    zx_coord_transform(1, 1) = one
    zy_coord_transform = zero
    zy_coord_transform(1, 2) = one
    zy_coord_transform(2, 1) = one
    zy_coord_transform(3, 3) = one

    tmp_m_grad(1:(mmax + 1)**2, 3, :) = multipoles
    do im = 1, nm
        call fmm_sph_transform(mmax, zx_coord_transform, one, &
            & multipoles(:, im), zero, tmp_m_grad(1:(mmax + 1)**2, 1, im))
        call fmm_sph_transform(mmax, zy_coord_transform, one, &
            & multipoles(:, im), zero, tmp_m_grad(1:(mmax + 1)**2, 2, im))
    end do

    do l = mmax+1, 1, -1
        indi = l*l + l + 1
        indj = indi - 2*l
        tmp1 = sqrt(dble(2*l+1)) / sqrt(dble(2*l-1))
        do m = 1-l, l-1
            tmp2 = sqrt(dble(l*l-m*m)) * tmp1
            tmp_m_grad(indi+m, :, :) = tmp2 * tmp_m_grad(indj+m, :, :)
        end do
        tmp_m_grad(indi+l, :, :) = zero
        tmp_m_grad(indi-l, :, :) = zero
    end do
    tmp_m_grad(1, :, :) = zero

    do im = 1, nm
        tmp_m_grad(:, 3, im) = tmp_m_grad(:, 3, im)
        tmp(:, im) = tmp_m_grad(:, 1, im)
        call fmm_sph_transform(mmax+1, zx_coord_transform, one, &
            & tmp(:, im), zero, tmp_m_grad(:, 1, im))
        tmp(:, im) = tmp_m_grad(:, 2, im)
        call fmm_sph_transform(mmax+1, zy_coord_transform, one, &
            & tmp(:, im), zero, tmp_m_grad(:, 2, im))
    end do

    deallocate(tmp, stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Deallocation failed in grad_m2m!")
        return
    end if

end subroutine grad_m2m

!> Given a charge distribution centered on the spheres, compute the
!> contributions to the forces stemming from its electrostatic interactions.
!! @param[in] params: ddx parameters
!! @param[in] constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[in] charges: charges, size (nsph)
!! @param[inout] forces: forces array, size (3, nsph)
!! @param[inout] ddx_error: ddX error
!!
subroutine grad_phi_for_charges(params, constants, workspace, state, &
        & charges, forces, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(in) :: charges(params % nsph)
    real(dp), intent(inout) :: forces(3, params % nsph)
    ! local variables
    integer :: info
    real(dp), allocatable :: multipoles(:, :)

    allocate(multipoles(1, params % nsph), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Allocation failed in grad_phi_for_charges")
        return
    end if
    ! convert the charges to multipoles
    multipoles(1, :) = charges/sqrt4pi
    call grad_phi(params, constants, workspace, state, 0, multipoles, forces, &
        & ddx_error)
    deallocate(multipoles, stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Deallocation failed in grad_phi_for_charges")
        return
    end if

end subroutine grad_phi_for_charges

!> Given a multipolar distribution in real spherical harmonics and
!> centered on the spheres, compute the contributions to the forces
!> stemming from its electrostatic interactions.
!! @param[in] params: ddx parameters
!! @param[in] constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[inout] state: ddx state
!! @param[in] mmax: maximum angular momentum of the multipolar distribution
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2, nsph)
!! @param[inout] forces: forces array, size (3, nsph)
!! @param[inout] ddx_error: ddX error
!!
subroutine grad_phi(params, constants, workspace, state, mmax, &
        & multipoles, forces, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    integer, intent(in) :: mmax
    real(dp), intent(in) :: multipoles((mmax + 1)**2, params % nsph)
    real(dp), intent(inout) :: forces(3, params % nsph)
    ! local variables
    integer :: info, im, lm, ind, l, m
    real(dp), allocatable :: adj_phi(:, :), m_grad(:, :, :)
    real(dp) :: fac

    ! get some space for the adjoint potential, note that we need it
    ! up to mmax + 1 as we are doing derivatives
    allocate(adj_phi((mmax + 2)**2, params % nsph), &
        & m_grad((mmax + 2)**2, 3, params % nsph), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Allocation failed in grad_phi!")
        return
    end if

    ! build the adjoint potential
    call build_adj_phi(params, constants, workspace, state % zeta, &
        & mmax + 1, adj_phi, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "build_adj_phi returned an error, exiting")
        return
    end if

    ! build the gradient of the M2M transformation
    call grad_m2m(multipoles, mmax, params % nsph, m_grad, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "grad_m2m returned an error, exiting")
        return
    end if

    ! contract the two ingredients to build the second contribution
    do im = 1, params % nsph
        do l = 1, mmax + 1
            ind = l*l + l + 1
            fac = (-one)**(l+1)
            do m = -l, l
                lm = ind + m
                forces(1, im) = forces(1, im) &
                    & + fac*pt5*m_grad(lm, 1, im)*adj_phi(lm, im)
                forces(2, im) = forces(2, im) &
                    & + fac*pt5*m_grad(lm, 2, im)*adj_phi(lm, im)
                forces(3, im) = forces(3, im) &
                    & + fac*pt5*m_grad(lm, 3, im)*adj_phi(lm, im)
            end do
        end do
    end do

    deallocate(adj_phi, m_grad, stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Deallocation failed in grad_phi!")
        return
    end if

end subroutine grad_phi

!> Given a distribution of point charges at the cavity points, compute the
!> potential and its higher order derivatives up to pmax at the center of
!> the spheres. This is done with or without the FMMs depending on the
!> given flag. This is used in the computation of the forces.
!! @param[in] params: ddx parameters
!! @param[in] constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[in] charges: charges (zeta) at cavity points, size(ncav)
!! @param[in] mmax: maximum angular momentum of the target multipoles
!! @param[out] adj_phi: electrostatic properties up to order mmax at
!!     the target multipoles, size ((mmax+1)**2, nsph)
!! @param[inout] ddx_error: ddX error
!!
subroutine build_adj_phi(params, constants, workspace, charges, mmax, &
        & adj_phi, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    integer, intent(in) :: mmax
    real(dp), intent(in) :: charges(constants % ncav)
    real(dp), intent(out) :: adj_phi((mmax + 1)**2, params % nsph)
    if (params % fmm .eq. 0) then
        call build_adj_phi_dense(charges, constants % ccav, constants % ncav, &
            & params % csph, mmax, params % nsph, adj_phi, ddx_error)
    else if (params % fmm .eq. 1) then
        call build_adj_phi_fmm(params, constants, workspace, charges, mmax, &
            & adj_phi, ddx_error)
    end if
end subroutine build_adj_phi

!> Given a distribution of point charges at the cavity points, compute the
!> potential and its higher order derivatives up to pmax at the center of
!> the spheres. This is done using two loops and required in the computation
!> of the forces.
!! @param[in] qcav: charges, size(ncav)
!! @param[in] ccav: coordinates of the charges, size(3,ncav)
!! @param[in] ncav: number of charges
!! @param[in] cm: coordinates of the multipoles, size(3,nm)
!! @param[in] mmax: maximum angular momentum of the multipoles
!! @param[in] nm: number of multipoles
!! @param[out] adj_phi: adjoint potential, size((mmax+1)**2,nm)
!! @param[inout] ddx_error: ddX error
!!
subroutine build_adj_phi_dense(qcav, ccav, ncav, cm, mmax, nm, adj_phi, &
        & ddx_error)
    implicit none
    integer, intent (in) :: ncav, mmax, nm
    real(dp), intent(in) :: qcav(ncav), ccav(3, ncav), cm(3, nm)
    real(dp), intent(out) :: adj_phi((mmax + 1)**2, nm)
    type(ddx_error_type), intent(inout) :: ddx_error
    ! local variables
    integer :: icav, im, info
    real(dp) :: c(3)
    real(dp), allocatable :: vscales(:), vscales_rel(:), v4pi2lp1(:), &
        & work(:)

    allocate(vscales((mmax + 1)**2), vscales_rel((mmax + 1)**2), &
        & v4pi2lp1(mmax + 1), work((mmax + 1)**2 + 3*mmax), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, 'Allocation failed in build_adj_phi_dense!')
        return
    end if
    call ylmscale(mmax, vscales, v4pi2lp1, vscales_rel)

    do im = 1, nm
        adj_phi(:, im) = zero
        do icav = 1, ncav
            c(:) = cm(:, im) - ccav(:, icav)
            call fmm_m2p_adj_work(c, qcav(icav), one, mmax, vscales_rel, &
                & one, adj_phi(:, im), work)
        end do
    end do

    deallocate(vscales, vscales_rel, v4pi2lp1, work, stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, 'Deallocation failed in build_adj_phi_dense!')
        return
    end if

end subroutine build_adj_phi_dense

!> Given a distribution of point charges at the cavity points, compute the
!> potential and its higher order derivatives up to pmax at the center of
!> the spheres. This is done with FMMs and required in the computation of
!> the forces.
!! @param[in] params: ddx parameters
!! @param[in] constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[in] charges: charges (zeta) at cavity points, size(ncav)
!! @param[in] mmax: maximum angular momentum of the target multipoles
!! @param[out] adj_phi: electrostatic properties up to order mmax at
!!     the target multipoles, size ((mmax+1)**2, nsph)
!! @param[inout] ddx_error: ddX error
!!
subroutine build_adj_phi_fmm(params, constants, workspace, charges, mmax, &
        & adj_phi, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    integer, intent(in) :: mmax
    real(dp), intent(in) :: charges(constants % ncav)
    real(dp), intent(out) :: adj_phi((mmax + 1)**2, params % nsph)
    ! local variables
    real(dp), allocatable :: tmp_grid(:, :), sph_m(:, :), work(:)
    integer :: info, icav, isph, igrid, inode, indl, l, jnear, &
        & jnode, jsph, m, ind
    real(dp) :: c(3), fac

    allocate(tmp_grid(params % ngrid, params % nsph), &
        & sph_m((mmax + 1)**2, params % nsph), &
        & work((mmax + 1)**2 + 3*mmax), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Allocation failed in build_adj_phi_fmm!")
        return
    end if

    tmp_grid = zero

    ! expand the input from cavity points to all the Lebedev points
    icav = 0
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if (constants % ui(igrid, isph) .eq. zero) cycle
            icav = icav + 1
            tmp_grid(igrid, isph) = charges(icav)
        end do
    end do
    adj_phi = zero

    ! near field. We do not call tree_m2p_adj as this routine skips the
    ! isph = jsph case which instead is needed.
    do isph = 1, params % nsph
        inode = constants % snode(isph)
        do jnear = constants % snear(inode), constants % snear(inode+1)-1
            jnode = constants % near(jnear)
            jsph = constants % order(constants % cluster(1, jnode))
            do igrid = 1, params % ngrid
                c = constants % cgrid(:, igrid)*params % rsph(isph) - &
                    & params % csph(:, jsph) + params % csph(:, isph)
                call fmm_m2p_adj_work(c, tmp_grid(igrid, isph), &
                    & params % rsph(jsph), mmax, constants % vscales_rel, one, &
                    & adj_phi(:, jsph), work)
            end do
        end do
    end do

    ! compute the far field and store it in tmp_node_m
    call tree_l2p_adj(params, constants, one, tmp_grid, zero, &
        & workspace % tmp_node_l, workspace % tmp_sph_l)
    call tree_l2l_rotation_adj(params, constants, workspace % tmp_node_l)
    call tree_m2l_rotation_adj(params, constants, workspace % tmp_node_l, &
        & workspace % tmp_node_m)
    call tree_m2m_rotation_adj(params, constants, workspace % tmp_node_m)

    ! move the far field from tmp_node_m to adj_phi
    if(mmax .lt. params % pm) then
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            adj_phi(:, isph) = adj_phi(:, isph) &
                & + workspace % tmp_node_m(1:(mmax + 1)**2, inode)
        end do
    else
        indl = (params % pm+1)**2
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            adj_phi(1:indl, isph) = adj_phi(1:indl, isph) &
                & + workspace % tmp_node_m(:, inode)
        end do
    end if

    ! scale by a factor to make it consistent with the non FMMized adjoint
    ! potential
    do isph = 1, params % nsph
        do l = 0, mmax
           ind = l*l + l + 1
           fac = - (-one/params % rsph(isph))**(l + 1)
           do m = -l, l
               adj_phi(ind + m, isph) = fac*adj_phi(ind + m, isph)
           end do
       end do
    end do

    deallocate(tmp_grid, work, stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Deallocation failed in build_adj_phi_fmm")
        return
    end if

end subroutine build_adj_phi_fmm

!> Given a charge distribution centered on the spheres, compute the
!> contributions to the forces stemming from its electrostatic interactions.
!!
!! @param[in] params: ddx parameters
!! @param[in] constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[inout] state: ddx state
!! @param[in] charges: charges, size (nsph)
!! @param[inout] forces: forces array, size (3, nsph)
!! @param[inout] ddx_error: ddX error
!!
subroutine grad_e_for_charges(params, constants, workspace, state, &
        & charges, force, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(in) :: charges(params % nsph)
    real(dp), intent(inout) :: force(3, params % nsph)
    real(dp), allocatable :: multipoles(:, :)
    integer :: info

    allocate(multipoles(1, params % nsph), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Allocation failed in grad_e_for_charges")
        return
    end if
    ! convert the charges to multipoles
    multipoles(1, :) = charges/sqrt4pi
    call grad_e(params, constants, workspace, state, 0, multipoles, force, &
        & ddx_error)
    deallocate(multipoles, stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "Deallocation failed in grad_e_for_charges")
        return
    end if

end subroutine grad_e_for_charges

!> Given a multipolar distribution in real spherical harmonics and
!> centered on the spheres, compute the contributions to the forces
!> stemming from its electrostatic interactions in case of ddLPB F RHS.
!! @param[in] params: ddx parameters
!! @param[in] constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[inout] state: ddx state
!! @param[in] mmax: maximum angular momentum of the multipolar distribution
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2, nsph)
!! @param[inout] forces: forces array, size (3, nsph)
!! @param[inout] ddx_error: ddX error
!!
subroutine grad_e(params, constants, workspace, state, mmax, &
        & multipoles, force, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    integer, intent(in) :: mmax
    real(dp), intent(in) :: multipoles((mmax+1)**2, params % nsph)
    real(dp), intent(inout) :: force(3, params % nsph)

    real(dp), allocatable :: zeta_comp(:),  m_grad(:, :, :), &
        & m_hess_x(:, :, :), m_hess_y(:, :, :), m_hess_z(:, :, :), &
        & m_grad_component(:, :), adj_phi_x(:, :), adj_phi_y(:, :), &
        & adj_phi_z(:, :)
    integer :: info, isph, ind, l, m, lm
    real(dp) :: fac

    allocate(zeta_comp(constants % ncav), &
        & adj_phi_x((mmax+3)**2, params % nsph), &
        & adj_phi_y((mmax+3)**2, params % nsph), &
        & adj_phi_z((mmax+3)**2, params % nsph), &
        & m_hess_x((mmax+3)**2, 3, params % nsph), &
        & m_hess_y((mmax+3)**2, 3, params % nsph), &
        & m_hess_z((mmax+3)**2, 3, params % nsph), &
        & m_grad((mmax+2)**2, 3, params % nsph), &
        & m_grad_component((mmax+2)**2, params % nsph), &
        & stat=info)
    if (info.ne.0) then
        call update_error(ddx_error, "Allocation failed in grad_e")
        return
    end if

    ! compute the gradient of the target charges
    call grad_m2m(multipoles, mmax, params % nsph, m_grad, ddx_error)

    ! starting from the previously computed gradient, compute the
    ! hessian of the target multipoles
    m_grad_component = m_grad(:, 1, :)
    call grad_m2m(m_grad_component, mmax + 1, params % nsph, m_hess_x, ddx_error)
    m_grad_component = m_grad(:, 2, :)
    call grad_m2m(m_grad_component, mmax + 1, params % nsph, m_hess_y, ddx_error)
    m_grad_component = m_grad(:, 3, :)
    call grad_m2m(m_grad_component, mmax + 1, params % nsph, m_hess_z, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "grad_m2m returned an error, exiting")
        return
    end if


    ! now we compute the adjoint potential of the x, y and z components
    ! of the input dipoles separately
    zeta_comp = state % zeta_dip(1, :)
    call build_adj_phi(params, constants, workspace, zeta_comp, &
        & mmax + 2, adj_phi_x, ddx_error)
    zeta_comp = state % zeta_dip(2, :)
    call build_adj_phi(params, constants, workspace, zeta_comp, &
        & mmax + 2, adj_phi_y, ddx_error)
    zeta_comp = state % zeta_dip(3, :)
    call build_adj_phi(params, constants, workspace, zeta_comp, &
        & mmax + 2, adj_phi_z, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "build_adj_phi returned an error, exiting")
        return
    end if


    ! contract the hessian of the multipoles with the three adjoint
    ! potentials to get the forces contributions
    do isph = 1, params % nsph
        do l = 2, mmax + 2
            ind = l*l + l + 1
            fac = -(-one)**(l+1)/2.0d0
            do m = -l, l
                lm = ind + m
                force(1, isph) = force(1, isph) &
                    & + fac*m_hess_x(lm, 1, isph)*adj_phi_x(lm, isph) &
                    & + fac*m_hess_y(lm, 1, isph)*adj_phi_y(lm, isph) &
                    & + fac*m_hess_z(lm, 1, isph)*adj_phi_z(lm, isph)
                force(2, isph) = force(2, isph) &
                    & + fac*m_hess_x(lm, 2, isph)*adj_phi_x(lm, isph) &
                    & + fac*m_hess_y(lm, 2, isph)*adj_phi_y(lm, isph) &
                    & + fac*m_hess_z(lm, 2, isph)*adj_phi_z(lm, isph)
                force(3, isph) = force(3, isph) &
                    & + fac*m_hess_x(lm, 3, isph)*adj_phi_x(lm, isph) &
                    & + fac*m_hess_y(lm, 3, isph)*adj_phi_y(lm, isph) &
                    & + fac*m_hess_z(lm, 3, isph)*adj_phi_z(lm, isph)
            end do
        end do
    end do

    deallocate(zeta_comp, adj_phi_x, adj_phi_y, adj_phi_z, m_hess_x, &
        & m_hess_y, m_hess_z, m_grad, m_grad_component, stat=info)
    if (info.ne.0) then
        call update_error(ddx_error, "Allocation failed in grad_e")
        return
    end if

end subroutine grad_e

!> @ingroup Fortran_interface_multipolar
!> Given a multipolar distribution in real spherical harmonics and
!> centered on the spheres, compute the contributions to the forces
!> stemming from its electrostatic interactions.
!! @param[in] params: ddx parameters
!! @param[in] constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[inout] state: ddx state
!! @param[in] mmax: maximum angular momentum of the multipolar distribution
!! @param[in] multipoles: multipoles as real spherical harmonics,
!!     size ((mmax+1)**2, nsph)
!! @param[inout] forces: forces array, size (3, nsph)
!! @param[inout] ddx_error: ddX error
!!
subroutine multipole_force_terms(params, constants, workspace, state, mmax, &
        & multipoles, forces, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    integer, intent(in) :: mmax
    real(dp), intent(in) :: multipoles((mmax + 1)**2, params % nsph)
    real(dp), intent(inout) :: forces(3, params % nsph)

    call grad_phi(params, constants, workspace, state, mmax, multipoles, &
        & forces, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "multipole_force_terms: grad_phi returned an error, exiting")
        return
    end if

    if (params % model .eq. 3) then
        call grad_e(params, constants, workspace, state, mmax, multipoles, &
            & forces, ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, &
                & "multipole_force_terms: grad_e returned an error, exiting")
            return
        end if
    end if
end subroutine multipole_force_terms

end module ddx_multipolar_solutes

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Logger to display strings
module tblite_context_logger
   implicit none
   private

   public :: context_logger


   !> Base class defining the logger interface
   type, abstract :: context_logger
   contains
      !> Entry point for displaying a string in the logger
      procedure(message), deferred :: message
   end type context_logger


   abstract interface
      !> Entry point for displaying a string in the logger
      subroutine message(self, msg)
         import :: context_logger
         !> Instance of the logger
         class(context_logger), intent(inout) :: self
         !> String to display
         character(len=*), intent(in) :: msg
      end subroutine message
   end interface


end module tblite_context_logger

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Proxy module for the calculation context related data types.
!>
!> Provides access to the [[context_type]] to manage the calculation.
!> The context stores error messages generated while running which can be
!> queried using the [[context_type:failed]] procedure. To access the actual
!> errors the messages can be removed using the [[context:get_error]] procedure.
!>
!> Errors can be pushed to a context by using the [[context_type:set_error]] procedure,
!> A context containing any error will automatically be marked as failed. Once all
!> error messages are removed from the context with [[context_type:get_error]] the
!> failed status is removed from the context again.
!>
!> The context provides also access to output by providing the [[context_type:message]]
!> procedure. Using this procedure for printouts ensures they are correctly handled in
!> case of API usage.
!>
!> An output verbosity is available in the context as the member verbosity, all procedures
!> with access to the context will default to the verbosity of the context unless
!> the verbosity level is overwritten by an argument.
!>
!> To cutomize the output the [[context_logger]] abstract base class is available.
!> It provides a [[context_logger:message]] procedure which is used by the context
!> to create output. This type can be used to create callbacks for customizing or
!> redirecting the output of the library, e.g. when used from C or Python.
!>
!> ANSI escape sequences are available via the [[context_terminal]] class and which is
!> instantiated in the [[context_type:terminal]] member. The terminal instance provides
!> access to various terminal formatting codes to produce the respective ANSI escape
!> sequences if the terminal is created with color support, otherwise return empty strings.
!> Detecting whether the terminal supports ANSI escape sequences is left as excerise to
!> the consumer of the [[context_terminal]] class.
!>
!> For convenience operators are provided to add escape codes as well as concatenate
!> them directly with strings.
module tblite_context
   use tblite_context_logger, only : context_logger
   use tblite_context_terminal, only : context_terminal, escape, operator(+), operator(//)
   use tblite_context_type, only : context_type
   implicit none
   public
end module tblite_context

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/context/type.f90
!> Provides a context manager for storing persistent environment settings

#ifndef WITH_MKL
#define WITH_MKL 0
#endif

!> Calculation context for storing and communicating with the environment
module tblite_context_type
   use iso_fortran_env, only : output_unit
   use mctc_env, only : wp, error_type
   use tblite_context_logger, only : context_logger
   use tblite_context_solver, only : context_solver
   use tblite_context_terminal, only : context_terminal
   use tblite_scf_solver, only : solver_type
   implicit none
   private


   !> Calculation context type for error handling and output messages
   type, public :: context_type
      !> Default output unit for this context
      integer :: unit = output_unit
      !> Default verbosity for procedures using this context
      integer :: verbosity = 1
      !> Stack containing the error messages of this context
      type(error_type), allocatable :: error_log(:)
      !> Optional logger to be used for writing messages
      class(context_logger), allocatable :: io
      !> Optional factory for creating electronic solvers
      class(context_solver), allocatable :: solver
      !> Color support for output
      type(context_terminal) :: terminal = context_terminal()
   contains
      !> Write a message to the output
      procedure :: message
      !> Push an error message to the context
      procedure :: set_error
      !> Pop an error message from the context
      procedure :: get_error
      !> Query the context for errors
      procedure :: failed
      !> Create electronic solver instance
      procedure :: new_solver
      !> Delete an electronic solver instance
      procedure :: delete_solver
   end type context_type


contains


!> Add an error message to the context
subroutine set_error(self, error)
   !> Instance of the calculation context
   class(context_type), intent(inout) :: self
   !> Error handling
   type(error_type), intent(in), optional :: error

   if (present(error)) then
      if (.not.allocated(self%error_log)) allocate(self%error_log(0))
      self%error_log = [self%error_log, error]
   end if
end subroutine set_error


!> Pop an error message from the context
subroutine get_error(self, error)
   !> Instance of the calculation context
   class(context_type), intent(inout) :: self
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   if (.not.allocated(self%error_log)) allocate(self%error_log(0))

   if (size(self%error_log) > 0) then
      error = self%error_log(size(self%error_log))
      self%error_log = self%error_log(:size(self%error_log)-1)
   end if
end subroutine get_error


!> Write a message to the output
subroutine message(self, msg)
   !> Instance of the calculation context
   class(context_type), intent(inout) :: self
   !> Message to write
   character(len=*), intent(in) :: msg
   type(error_type), allocatable :: error

   if (allocated(self%io)) then
      call self%io%message(msg, error)
      if (allocated(error)) then
         call self%set_error(error)
      end if
   else
      write(self%unit, '(a)') msg
   end if
end subroutine message


!> Query the context for errors
pure function failed(self)
   !> Instance of the calculation context
   class(context_type), intent(in) :: self
   !> Error status of the context
   logical :: failed

   failed = .false.
   if (allocated(self%error_log)) then
      failed = size(self%error_log) > 0
   end if
end function failed


!> Create new electronic solver
subroutine new_solver(self, solver, overlap, nel, kt)
   use tblite_lapack_solver, only : lapack_solver
   !> Instance of the calculation context
   class(context_type), intent(inout) :: self
   !> New electronic solver
   class(solver_type), allocatable, intent(out) :: solver
   !> Overlap matrix
   real(wp), intent(in) :: overlap(:, :)
   !> Number of electrons per spin channel
   real(wp), intent(in) :: nel(:)
   !> Electronic temperature
   real(wp), intent(in) :: kt

   if (.not.allocated(self%solver)) then
      self%solver = lapack_solver()
   end if

   call self%solver%new(solver, overlap, nel, kt)
end subroutine new_solver


!> Delete electronic solver instance
subroutine delete_solver(self, solver)
   !> Instance of the calculation context
   class(context_type), intent(inout) :: self
   !> Electronic solver instance
   class(solver_type), allocatable, intent(inout) :: solver

   if (allocated(self%solver)) then
      call self%solver%delete(solver)
   end if
#if WITH_MKL 
   call mkl_free_buffers()
#endif
   if (allocated(solver)) deallocate(solver)
end subroutine delete_solver


end module tblite_context_type

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of list of general interaction contaienrs
module tblite_container_list
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_container_cache, only : container_cache, resize
   use tblite_container_type, only : container_type
   use tblite_scf_info, only : scf_info
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_output_format, only : format_string
   implicit none
   private

   public :: container_list


   !> Wrapped container type for creation of lists
   type :: container_node
      !> Actual interaction container
      class(container_type), allocatable :: raw
   end type container_node

   !> List of interaction containers
   type, extends(container_type) :: container_list
      private
      !> Number of stored containers
      integer :: nc = 0
      !> Raw list of interaction containers
      type(container_node), allocatable :: list(:)
   contains
      !> Update container cache
      procedure :: update
      !> Get information about density dependent quantities used in the energy
      procedure :: variable_info
      !> Evaluate non-selfconsistent part of the interaction
      procedure :: get_engrad
      !> Evaluate selfconsistent energy of the interaction
      procedure :: get_energy
      !> Evaluate charge dependent potential shift from the interaction
      procedure :: get_potential
      !> Evaluate gradient contributions from the selfconsistent interaction
      procedure :: get_gradient
      !> Add a container
      procedure :: push_back
      !> Remove a container
      procedure :: pop
      !> Information about the container list
      procedure :: info
   end type container_list


   !> Reallocate list of containers
   interface resize
      module procedure :: resize_node
   end interface


   !> List of container chach instances
   type :: cache_list
      !> Actual cache instances
      type(container_cache), allocatable :: list(:)
   end type cache_list


contains


!> Update container cache
subroutine update(self, mol, cache)
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache

   integer :: ic
   type(cache_list), pointer :: ptr

   call taint(cache, ptr)
   call resize(ptr%list, self%nc)

   do ic = 1, self%nc
      if (allocated(self%list(ic)%raw)) then
         associate(cont => self%list(ic)%raw)
            call cont%update(mol, ptr%list(ic))
         end associate
      end if
   end do
end subroutine update


!> Evaluate non-selfconsistent part of the interaction
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Interaction energy
   real(wp), intent(inout) :: energies(:)
   !> Interaction gradient
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Interaction virial
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)

   integer :: ic
   type(cache_list), pointer :: ptr

   call view(cache, ptr)

   do ic = 1, self%nc
      if (allocated(self%list(ic)%raw)) then
         associate(cont => self%list(ic)%raw)
            call cont%get_engrad(mol, ptr%list(ic), energies, gradient, sigma)
         end associate
      end if
   end do
end subroutine get_engrad


!> Evaluate selfconsistent energy of the interaction
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Interaction energy
   real(wp), intent(inout) :: energies(:)

   integer :: ic
   type(cache_list), pointer :: ptr

   call view(cache, ptr)

   do ic = 1, self%nc
      if (allocated(self%list(ic)%raw)) then
         associate(cont => self%list(ic)%raw)
            call cont%get_energy(mol, ptr%list(ic), wfn, energies)
         end associate
      end if
   end do
end subroutine get_energy


!> Evaluate charge dependent potential shift from the interaction
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   integer :: ic
   type(cache_list), pointer :: ptr

   call view(cache, ptr)

   do ic = 1, self%nc
      if (allocated(self%list(ic)%raw)) then
         associate(cont => self%list(ic)%raw)
            call cont%get_potential(mol, ptr%list(ic), wfn, pot)
         end associate
      end if
   end do
end subroutine get_potential


!> Evaluate gradient contributions from the selfconsistent interaction
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Interaction gradient
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Interaction virial
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   integer :: ic
   type(cache_list), pointer :: ptr

   call view(cache, ptr)

   do ic = 1, self%nc
      if (allocated(self%list(ic)%raw)) then
         associate(cont => self%list(ic)%raw)
            call cont%get_gradient(mol, ptr%list(ic), wfn, gradient, sigma)
         end associate
      end if
   end do
end subroutine get_gradient


!> Get information about density dependent quantities used in the energy
pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, max
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   integer :: ic

   info = scf_info()

   do ic = 1, self%nc
      if (allocated(self%list(ic)%raw)) then
         info = max(info, self%list(ic)%raw%variable_info())
      end if
   end do
end function variable_info


!> Information on container
pure function info(self, verbosity, indent) result(str)
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Verbosity level
   integer, intent(in) :: verbosity
   !> Indentation level
   character(len=*), intent(in) :: indent
   !> Information on the container
   character(len=:), allocatable :: str

   integer :: ic
   character(len=*), parameter :: nl = new_line('a')

   if (allocated(self%label)) then
      str = self%label
   else
      str = "Interactions"
   end if

   str = str // format_string(self%nc, '(1x,"(",i0,")")')

   do ic = 1, self%nc
      str = str // nl // indent // format_string(ic, '("[",i0,"]")') // " " // &
         & self%list(ic)%raw%info(verbosity, indent//"* ")
   end do
end function info


!> Add a container
subroutine push_back(self, cont)
   !> Instance of the container list
   class(container_list), intent(inout) :: self
   !> Container to be added
   class(container_type), allocatable, intent(inout) :: cont

   if (.not.allocated(self%list)) call resize(self%list)

   if (allocated(cont)) then
      if (self%nc >= size(self%list)) call resize(self%list)
      self%nc = self%nc + 1
      call move_alloc(cont, self%list(self%nc)%raw)
   end if
end subroutine push_back


!> Add a container
subroutine pop(self, cont, idx)
   !> Instance of the container list
   class(container_list), intent(inout) :: self
   !> Container to be removed
   class(container_type), allocatable, intent(out) :: cont
   !> Index to remove container from
   integer, intent(in), optional :: idx

   integer :: ic, pos

   if (present(idx)) then
      pos = max(1, min(self%nc, idx))
   else
      pos = self%nc
   end if

   if (pos <= 0) return

   call move_alloc(self%list(pos)%raw, cont)

   self%nc = self%nc - 1
   do ic = pos, self%nc
      call move_alloc(self%list(ic+1)%raw, self%list(ic)%raw)
   end do
end subroutine pop


!> Reallocate list of containers
pure subroutine resize_node(list, n)
   !> Instance of the array to be resized
   type(container_node), allocatable, intent(inout) :: list(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(container_node), allocatable :: tmp(:)
   integer, parameter :: initial_size = 20
   integer :: this_size, new_size, item

   if (allocated(list)) then
      this_size = size(list, 1)
      call move_alloc(list, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(list(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(list, 1))
      do item = 1, this_size
         call move_alloc(tmp(item)%raw, list(item)%raw)
      end do
      deallocate(tmp)
   end if

end subroutine resize_node


!> Inspect container cache and reallocate it in case of type mismatch
subroutine taint(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(cache_list), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(cache_list), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

!> Return reference to container cache after resolving its type
subroutine view(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(cache_list), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(cache_list)
      ptr => target
   end select
end subroutine view


end module tblite_container_list

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/solvation/cds.f90
!> Provides non-polar contributions to the solvation free energy

!> Cavity, dispersion and surface contribution to the solvation free energy
module tblite_solvation_cds
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use mctc_io_math, only : matdet_3x3
   use tblite_blas, only : dot, gemv, symv
   use tblite_container_cache, only : container_cache
   use tblite_mesh_lebedev, only : grid_size, get_angular_grid, list_bisection
   use tblite_scf_info, only : scf_info, atom_resolved, not_used
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_solvation_surface, only : surface_integrator, new_surface_integrator
   use tblite_solvation_data, only : get_vdw_rad_cosmo
   use tblite_solvation_type, only : solvation_type
   use tblite_solvation_cm5, only : get_cm5_charges
   use mctc_io_convert, only : aatoau
   implicit none
   private

   public :: cds_solvation, new_cds, cds_input

   !> Input for CDS model
   type :: cds_input
      !> Probe radius of the solvent
      real(wp) :: probe = 1.00000_wp * aatoau
      !> Number of angular grid points for integration
      integer :: nang = 230
      !> Van-der-Waals radii for each species
      real(wp), allocatable :: rad(:)
      !> Surface tension for each species
      real(wp), allocatable :: tension(:)
      !> Hydrogen bonding strength for each species
      real(wp), allocatable :: hbond(:)
      !> Linearized Poisson-Boltzmann model for parameter selection
      logical :: alpb = .true.
      !> Solvent for parameter selection
      character(len=:), allocatable :: solvent
   end type cds_input

   !> Provide constructor for CDS input
   interface cds_input
      module procedure :: create_cds_input
   end interface cds_input

   !> Definition of the CDS model
   type, extends(solvation_type) :: cds_solvation
      !> Integrator for solvent accessible surface area
      type(surface_integrator) :: sasa
      !> Surface tension for each species
      real(wp), allocatable :: tension(:)
      !> Hydrogen bonding correction
      real(wp), allocatable :: hbond(:)
      !> Use CM5 charges (for GFN1-xTB compatibility)
      logical :: useCM5 = .false.
   contains
      !> Update cache from container
      procedure :: update
      !> Return dependency on density
      procedure :: variable_info
      !> Get solvation energy and gradient
      procedure :: get_engrad
      !> Get solvation energy
      procedure :: get_energy
      !> Get solvation potential
      procedure :: get_potential
      !> Get solvation gradient
      procedure :: get_gradient
   end type cds_solvation

   !> Provide constructor for CDS solvation
   interface cds_solvation
      module procedure :: create_cds
   end interface cds_solvation

   !> Restart data for CDS calculation
   type :: cds_cache
      !> Surface tension
      real(wp), allocatable :: tension(:)
      !> Derivative of surface tension w.r.t. cartesian displacements
      real(wp), allocatable :: dtdr(:, :, :)
      !> Solvent accessible surface area for each atom
      real(wp), allocatable :: surface(:)
      !> Derivative of the solvent accessible surface area w.r.t. cartesian displacements
      real(wp), allocatable :: dsdr(:, :, :)
      !> Scratch array to store potential shift
      real(wp), allocatable :: scratch(:)
      !> Hydrogen bonding correction
      real(wp), allocatable :: hbond(:)
      !> Scratch for atomic charges
      real(wp), allocatable :: qscratch(:)
      !> CM5 charges (only required for GFN1 compatibility)
      real(wp), allocatable :: cm5(:)
      !> CM5 charge derivatives
      real(wp), allocatable :: dcm5dr(:,:,:)
   end type cds_cache

   !> Identifier for container
   character(len=*), parameter :: label = "cds contribution to solvation"

contains


!> Consturctor for CDS input to properly assign allocatable strings
function create_cds_input(solvent, alpb, probe, nang, rad, tension, hbond) result(self)
   !> Solvent for parameter selection
   character(len=*), intent(in), optional :: solvent
   !> Use analytical linearized Poisson-Boltzmann model
   logical, intent(in), optional :: alpb
   !> Probe radius of the solvent
   real(wp), intent(in), optional :: probe
   !> Number of angular grid points for integration
   integer, intent(in), optional :: nang
   !> Van-der-Waals radii for each species
   real(wp), allocatable, intent(in), optional :: rad(:)
   !> Surface tension for each species
   real(wp), allocatable, intent(in), optional :: tension(:)
   !> Hydrogen bonding strength for each species
   real(wp), allocatable, intent(in), optional :: hbond(:)

   type(cds_input) :: self

   if (present(solvent)) then 
      self%solvent = solvent
   end if

   if (present(alpb)) then 
      self%alpb = alpb
   end if

   if (present(probe)) then
      self%probe = probe
   end if

   if (present(nang)) then
      self%nang = nang
   end if

   if (present(rad)) then
      self%rad = rad
   end if

   if (present(tension)) then
      self%tension = tension
   end if

   if (present(hbond)) then
      self%hbond = hbond
   end if

end function create_cds_input


!> Create new CDS solvation model
subroutine new_cds(self, mol, input, method)
   !> Instance of the solvation model
   type(cds_solvation), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input for CDS solvation
   type(cds_input), intent(in) :: input
   !> Method for parameter selection
   character(len=*), intent(in), optional :: method

   real(wp), allocatable :: rad(:)

   self%label = label
   if (allocated(input%rad)) then
      rad = input%rad
   else
      rad = get_vdw_rad_cosmo(mol%num)
   end if

   self%tension = input%tension
  
   if (allocated(input%hbond)) then
      self%hbond = input%hbond/(4*pi*(rad+input%probe)**2)
   end if

   if (allocated(input%solvent) .and. present(method))then
      self%useCM5 = trim(method)=='gfn1'
   endif

   call new_surface_integrator(self%sasa, mol%id, rad, input%probe, input%nang)
end subroutine new_cds

!> Type constructor for CDS solvation
function create_cds(mol, input, method) result(self)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input for CDS solvation
   type(cds_input), intent(in) :: input
   !> Method for parameter selection
   character(len=*), intent(in), optional :: method
   !> Instance of the solvation model
   type(cds_solvation) :: self

   call new_cds(self, mol, input, method)
end function create_cds

!> Update cache from container
subroutine update(self, mol, cache)
   !> Instance of the solvation model
   class(cds_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   type(cds_cache), pointer :: ptr

   call taint(cache, ptr)

   if (.not.allocated(ptr%surface)) then
      allocate(ptr%surface(mol%nat))
   end if
   if (.not.allocated(ptr%dsdr)) then
      allocate(ptr%dsdr(3, mol%nat, mol%nat))
   end if
   if (.not.allocated(ptr%scratch)) then
      allocate(ptr%scratch(mol%nat))
   end if
   if (.not.allocated(ptr%qscratch))then
      allocate(ptr%qscratch(mol%nat))
   endif
   if (self%useCM5)then
      if (.not.allocated(ptr%cm5))then
         allocate(ptr%cm5(mol%nat))
      endif
      if (.not.allocated(ptr%dcm5dr))then
         allocate(ptr%dcm5dr(3, mol%nat, mol%nat))
      endif
      call get_cm5_charges(mol, ptr%cm5, ptr%dcm5dr)
   endif

   call self%sasa%get_surface(mol, ptr%surface, ptr%dsdr)

   ptr%tension = self%tension(mol%id)
   if (allocated(self%hbond)) then
      ptr%hbond = self%hbond(mol%id)
   end if
end subroutine update


!> Evaluate non-selfconsistent part of the interaction
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the solvation model
   class(cds_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Interaction energy
   real(wp), intent(inout) :: energies(:)
   !> Interaction gradient
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Interaction virial
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)

   type(cds_cache), pointer :: ptr

   call view(cache, ptr)

   energies(:) = energies + ptr%surface * ptr%tension

   if (present(gradient)) then
      if (allocated(ptr%dsdr)) &
         call gemv(ptr%dsdr, ptr%tension, gradient, beta=1.0_wp)
      if (allocated(ptr%dtdr)) &
         call gemv(ptr%dtdr, ptr%surface, gradient, beta=1.0_wp)
   end if
end subroutine get_engrad


!> Get solvation energy
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the solvation model
   class(cds_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Solvation free energy
   real(wp), intent(inout) :: energies(:)

   type(cds_cache), pointer :: ptr

   call view(cache, ptr)

   if (allocated(self%hbond)) then
      if(self%useCM5)then
         ptr%qscratch(:) = wfn%qat(:, 1) + ptr%cm5(:)
      else
         ptr%qscratch(:) = wfn%qat(:, 1)
      endif
      ptr%scratch(:) = ptr%hbond * ptr%surface * ptr%qscratch(:)**2
      energies(:) = energies + ptr%scratch
   end if
end subroutine get_energy


!> Get solvation potential
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the solvation model
   class(cds_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   type(cds_cache), pointer :: ptr

   call view(cache, ptr)

   if (allocated(self%hbond)) then
      if(self%useCM5)then
         ptr%qscratch(:) = wfn%qat(:, 1) + ptr%cm5(:)
      else
         ptr%qscratch(:) = wfn%qat(:, 1)
      endif
      ptr%scratch(:) = 2*ptr%hbond * ptr%surface * ptr%qscratch(:)
      pot%vat(:, 1) = pot%vat(:, 1) + ptr%scratch(:)
   end if
end subroutine get_potential


!> Get solvation gradient
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the solvation model
   class(cds_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the solvation free energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the solvation free energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   type(cds_cache), pointer :: ptr

   call view(cache, ptr)

   if (allocated(self%hbond)) then
      if(self%useCM5)then
         ptr%qscratch(:) = wfn%qat(:, 1) + ptr%cm5(:)
      else
         ptr%qscratch(:) = wfn%qat(:, 1)
      endif
      ptr%scratch(:) = ptr%hbond * ptr%qscratch(:)**2
      if (allocated(ptr%dsdr)) &
         call gemv(ptr%dsdr, ptr%scratch, gradient, beta=1.0_wp)
      if(self%useCM5)then 
        ptr%scratch(:) = 2*ptr%hbond * ptr%surface * ptr%qscratch(:)  
        call gemv(ptr%dcm5dr, ptr%scratch, gradient, beta=1.0_wp) 
      endif  
   end if
end subroutine get_gradient


!> Return dependency on density
pure function variable_info(self) result(info)
   !> Instance of the solvation model
   class(cds_solvation), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=merge(atom_resolved, not_used, allocated(self%hbond)))
end function variable_info


subroutine taint(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(cds_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(cds_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

subroutine view(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(cds_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(cds_cache)
      ptr => target
   end select
end subroutine view

end module tblite_solvation_cds

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

program main_driver
   use, intrinsic :: iso_fortran_env, only : error_unit
   use mctc_env, only : error_type
   use tblite_cli, only : get_arguments, driver_config, run_config, param_config, &
      & fit_config, tagdiff_config
   use tblite_context_type, only : context_type
   use tblite_driver, only : main
   implicit none
   class(driver_config), allocatable :: config
   type(error_type), allocatable :: error

   call get_arguments(config, error)
   if (allocated(error)) then
      write(error_unit, '(a)') error%message
      error stop
   end if

   select type(config)
   type is (fit_config)
      call main(config, error)
   type is (param_config)
      call main(config, error)
   type is (run_config)
      call main(config, error)
   type is (tagdiff_config)
      call main(config, error)
   end select
   if (allocated(error)) then
      write(error_unit, '(a)') error%message
      error stop
   end if
end program main_driver

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Complete reexport of the public API of TOML-Fortran
module tomlf_all
   use tomlf_build
   use tomlf_constants
   use tomlf_datetime
   use tomlf_de
   use tomlf_error
   use tomlf_ser
   use tomlf_structure
   use tomlf_type
   use tomlf_utils
   use tomlf_version
   implicit none
   public

end module tomlf_all

! This file is part of test-drive.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module test_select
  use, intrinsic :: ieee_arithmetic, only : ieee_value, ieee_quiet_nan
  use testdrive, only : new_unittest, unittest_type, error_type, check, &
    & run_testsuite, new_testsuite, testsuite_type, select_suite, run_selected
  implicit none
  private

  public :: collect_select


contains


  !> Collect all exported unit tests
  subroutine collect_select(testsuite)

    !> Collection of tests
    type(unittest_type), allocatable, intent(out) :: testsuite(:)

    testsuite = [ &
      new_unittest("always-pass", always_pass), &
      new_unittest("always-fail", always_fail, should_fail=.true.), &
      new_unittest("run-good-suite", test_run_good_suite), &
      new_unittest("run-bad-suite", test_run_bad_suite), &
      new_unittest("run-selected", test_run_selected), &
      new_unittest("select-missing", test_select_missing) &
      ]

  end subroutine collect_select


  subroutine always_pass(error)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    call check(error, 0)

  end subroutine always_pass


  subroutine always_fail(error)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    call check(error, 1, "Always failing test")

  end subroutine always_fail


  !> Stub test suite collector defining passing unit tests
  subroutine stub_collect(testsuite)

    !> Collection of tests
    type(unittest_type), allocatable, intent(out) :: testsuite(:)

    testsuite = [ &
      new_unittest("always-pass", always_pass), &
      new_unittest("always-fail", always_fail, should_fail=.true.) &
      ]

  end subroutine stub_collect


  !> Bad test suite collector defining flaky unit tests
  subroutine stub_collect_bad(testsuite)

    !> Collection of tests
    type(unittest_type), allocatable, intent(out) :: testsuite(:)

    testsuite = [ &
      new_unittest("always-pass", always_pass, should_fail=.true.), &
      new_unittest("always-fail", always_fail) &
      ]

  end subroutine stub_collect_bad


  subroutine test_run_good_suite(error)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: unit, stat

    open(status='scratch', newunit=unit)

    stat = 7
    call run_testsuite(stub_collect, unit, stat)
    call check(error, stat, 7)

    close(unit)

  end subroutine test_run_good_suite


  subroutine test_run_bad_suite(error)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: unit, stat

    open(status='scratch', newunit=unit)

    stat = 3
    call run_testsuite(stub_collect_bad, unit, stat)
    call check(error, stat, 5)

    close(unit)

  end subroutine test_run_bad_suite


  subroutine test_run_selected(error)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: unit, stat

    open(status='scratch', newunit=unit)

    stat = 1
    call run_selected(stub_collect, "always-fail", unit, stat)
    call check(error, stat, 1)

    close(unit)

  end subroutine test_run_selected


  subroutine test_select_missing(error)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: unit, stat

    open(status='scratch', newunit=unit)

    call run_selected(stub_collect, "not-available", unit, stat)
    call check(error, stat < 0)

    close(unit)

  end subroutine test_select_missing


end module test_select

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Isotropic second-order electrostatics using the DFTB Coulomb functional.
module tblite_coulomb_charge_gamma
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_math, only : matdet_3x3, matinv_3x3
   use mctc_io_constants, only : pi
   use tblite_blas, only : dot, gemv, symv, gemm
   use tblite_coulomb_cache, only : coulomb_cache
   use tblite_coulomb_ewald, only : get_dir_cutoff, get_rec_cutoff
   use tblite_coulomb_charge_type, only : coulomb_charge_type
   use tblite_cutoff, only : get_lattice_points
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_wignerseitz, only : wignerseitz_cell
   implicit none
   private

   public :: gamma_coulomb, new_gamma_coulomb


   !> DFTB Gamma functional second-order electrostatics
   type, extends(coulomb_charge_type) :: gamma_coulomb
      !> Chemical hardness for each shell and species
      real(wp), allocatable :: hubbard(:, :)
      !> Long-range cutoff
      real(wp) :: rcut
   contains
      !> Evaluate Coulomb matrix
      procedure :: get_coulomb_matrix
      !> Evaluate uncontracted derivatives of Coulomb matrix
      procedure :: get_coulomb_derivs
   end type gamma_coulomb


   real(wp), parameter :: twopi = 2 * pi
   real(wp), parameter :: sqrtpi = sqrt(pi)
   real(wp), parameter :: eps = sqrt(epsilon(0.0_wp))
   real(wp), parameter :: conv = eps
   character(len=*), parameter :: label = "isotropic DFTB-γ electrostatics"

contains

!> Construct new effective electrostatic interaction container
subroutine new_gamma_coulomb(self, mol, hubbard, nshell)
   !> Instance of the electrostatic container
   type(gamma_coulomb), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Chemical hardness for all shells and species
   real(wp), intent(in) :: hubbard(:, :)
   !> Number of shells for each species
   integer, intent(in), optional :: nshell(:)

   integer :: mshell
   integer :: isp, jsp, ish, jsh, ind, iat

   self%label = label
   if (present(nshell)) then
      mshell = maxval(nshell)
      self%nshell = nshell(mol%id)
   else
      mshell = 1
      self%nshell = spread(1, 1, mol%nat)
   end if
   allocate(self%offset(mol%nat))
   ind = 0
   do iat = 1, mol%nat
      self%offset(iat) = ind
      ind = ind + self%nshell(iat)
   end do

   if (present(nshell)) then
      allocate(self%hubbard(mshell, mol%nid))
      do isp = 1, mol%nid
         self%hubbard(:, isp) = 0.0_wp
         do ish = 1, nshell(isp)
            self%hubbard(ish, isp) = hubbard(ish, isp)
         end do
      end do
   else
      allocate(self%hubbard(1, mol%nid))
      do isp = 1, mol%nid
         self%hubbard(1, isp) = hubbard(1, isp)
      end do
   end if

end subroutine new_gamma_coulomb


!> Evaluate coulomb matrix
subroutine get_coulomb_matrix(self, mol, cache, amat)
   !> Instance of the electrostatic container
   class(gamma_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(coulomb_cache), intent(inout) :: cache
   !> Coulomb matrix
   real(wp), contiguous, intent(out) :: amat(:, :)

   amat(:, :) = 0.0_wp

   if (any(mol%periodic)) then
      call get_amat_3d(mol, self%nshell, self%offset, self%hubbard, &
         & self%rcut, cache%wsc, cache%alpha, amat)
   else
      call get_amat_0d(mol, self%nshell, self%offset, self%hubbard, amat)
   end if

end subroutine get_coulomb_matrix


!> Get real lattice vectors
subroutine get_dir_trans(lattice, alpha, conv, trans)
   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)
   !> Parameter for Ewald summation
   real(wp), intent(in) :: alpha
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Translation vectors
   real(wp), allocatable, intent(out) :: trans(:, :)

   call get_lattice_points([.true.], lattice, get_dir_cutoff(alpha, conv), trans)

end subroutine get_dir_trans

!> Get reciprocal lattice translations
subroutine get_rec_trans(lattice, alpha, volume, conv, trans)
   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)
   !> Parameter for Ewald summation
   real(wp), intent(in) :: alpha
   !> Cell volume
   real(wp), intent(in) :: volume
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Translation vectors
   real(wp), allocatable, intent(out) :: trans(:, :)

   real(wp) :: rec_lat(3, 3)

   rec_lat = twopi*transpose(matinv_3x3(lattice))
   call get_lattice_points([.true.], rec_lat, get_rec_cutoff(alpha, volume, conv), trans)
   trans = trans(:, 2:)

end subroutine get_rec_trans


!> Evaluate Coulomb matrix for finite systems
subroutine get_amat_0d(mol, nshell, offset, hubbard, amat)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells for each atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each shell
   integer, intent(in) :: offset(:)
   !> Hardness parameter for each shell
   real(wp), intent(in) :: hubbard(:, :)
   !> Coulomb matrix
   real(wp), intent(inout) :: amat(:, :)

   integer :: iat, jat, izp, jzp, ii, jj, ish, jsh
   real(wp) :: vec(3), r1, r1g, gam, tmp

   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(amat, mol, nshell, offset, hubbard) &
   !$omp private(iat, izp, ii, ish, jat, jzp, jj, jsh, gam, vec, r1, r1g, tmp)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         vec = mol%xyz(:, jat) - mol%xyz(:, iat)
         r1 = norm2(vec)
         tmp = 1.0_wp / r1
         do ish = 1, nshell(iat)
            do jsh = 1, nshell(jat)
               gam = tmp - exp_gamma(r1, hubbard(ish, izp), hubbard(jsh, jzp))
               !$omp atomic
               amat(jj+jsh, ii+ish) = amat(jj+jsh, ii+ish) + gam
               !$omp atomic
               amat(ii+ish, jj+jsh) = amat(ii+ish, jj+jsh) + gam
            end do
         end do
      end do
      do ish = 1, nshell(iat)
         do jsh = 1, ish-1
            gam = -exp_gamma(0.0_wp, hubbard(ish, izp), hubbard(jsh, izp))
            !$omp atomic
            amat(ii+jsh, ii+ish) = amat(ii+jsh, ii+ish) + gam
            !$omp atomic
            amat(ii+ish, ii+jsh) = amat(ii+ish, ii+jsh) + gam
         end do
         gam = -exp_gamma(0.0_wp, hubbard(ish, izp), hubbard(ish, izp))
         !$omp atomic
         amat(ii+ish, ii+ish) = amat(ii+ish, ii+ish) + gam
      end do
   end do

end subroutine get_amat_0d

!> Evaluate the coulomb matrix for 3D systems
subroutine get_amat_3d(mol, nshell, offset, hubbard, rcut, wsc, alpha, amat)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells per atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each atom
   integer, intent(in) :: offset(:)
   !> Hardness of the shells
   real(wp), intent(in) :: hubbard(:, :)
   !> Long-range cutoff
   real(wp), intent(in) :: rcut
   !> Wigner-Seitz cell
   type(wignerseitz_cell), intent(in) :: wsc
   !> Convergence factor
   real(wp), intent(in) :: alpha
   !> Coulomb matrix
   real(wp), intent(inout) :: amat(:, :)

   integer :: iat, jat, izp, jzp, img, ii, jj, ish, jsh
   real(wp) :: vec(3), ui, uj, wsw, dtmp, rtmp, vol, aval
   real(wp), allocatable :: dtrans(:, :), rtrans(:, :)

   vol = abs(matdet_3x3(mol%lattice))
   call get_dir_trans(mol%lattice, alpha, conv, dtrans)
   call get_rec_trans(mol%lattice, alpha, vol, conv, rtrans)

   !$omp parallel do default(none) schedule(runtime) shared(amat) &
   !$omp shared(mol, nshell, offset, hubbard, wsc, dtrans, rtrans, alpha, vol, rcut) &
   !$omp private(iat, izp, jat, jzp, ii, jj, ish, jsh, ui, uj, wsw, vec, dtmp, rtmp, aval)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, iat) - mol%xyz(:, jat) - wsc%trans(:, wsc%tridx(img, jat, iat))
            call get_amat_rec_3d(vec, vol, alpha, rtrans, rtmp)
            do ish = 1, nshell(iat)
               do jsh = 1, nshell(jat)
                  ui = hubbard(ish, izp)
                  uj = hubbard(jsh, jzp)
                  call get_amat_dir_3d(vec, ui, uj, alpha, dtrans, dtmp)
                  aval = (dtmp + rtmp) * wsw
                  !$omp atomic
                  amat(jj+jsh, ii+ish) = amat(jj+jsh, ii+ish) + aval
                  !$omp atomic
                  amat(ii+ish, jj+jsh) = amat(ii+ish, jj+jsh) + aval
               end do
            end do
         end do
      end do

      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec = wsc%trans(:, wsc%tridx(img, iat, iat))
         call get_amat_rec_3d(vec, vol, alpha, rtrans, rtmp)
         rtmp = rtmp - 2 * alpha / sqrtpi
         do ish = 1, nshell(iat)
            do jsh = 1, ish-1
               ui = hubbard(ish, izp)
               uj = hubbard(jsh, izp)
               call get_amat_dir_3d(vec, ui, uj, alpha, dtrans, dtmp)
               aval = (dtmp + rtmp - exp_gamma(0.0_wp, ui, uj)) * wsw
               !$omp atomic
               amat(ii+jsh, ii+ish) = amat(ii+jsh, ii+ish) + aval
               !$omp atomic
               amat(ii+ish, ii+jsh) = amat(ii+ish, ii+jsh) + aval
            end do
            ui = hubbard(ish, izp)
            call get_amat_dir_3d(vec, ui, ui, alpha, dtrans, dtmp)
            aval = (dtmp + rtmp - exp_gamma(0.0_wp, ui, ui)) * wsw
            !$omp atomic
            amat(ii+ish, ii+ish) = amat(ii+ish, ii+ish) + aval
         end do
      end do

   end do

end subroutine get_amat_3d

!> Calculate real space contributions for a pair under 3D periodic boundary conditions
subroutine get_amat_dir_3d(rij, ui, uj, alp, trans, amat)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Chemical hardness
   real(wp), intent(in) :: ui, uj
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Interaction matrix element
   real(wp), intent(out) :: amat

   integer :: itr
   real(wp) :: vec(3), r1, tmp, fcut

   amat = 0.0_wp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      tmp = 1.0_wp / r1 - exp_gamma(r1, ui, uj) &
         & - erf(alp*r1)/r1
      amat = amat + tmp
   end do

end subroutine get_amat_dir_3d

!> Calculate reciprocal space contributions for a pair under 3D periodic boundary conditions
subroutine get_amat_rec_3d(rij, vol, alp, trans, amat)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Volume of cell
   real(wp), intent(in) :: vol
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Interaction matrix element
   real(wp), intent(out) :: amat

   integer :: itr
   real(wp) :: fac, vec(3), g2, tmp, gv, expk, cosk

   amat = 0.0_wp
   fac = 4*pi/vol

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      gv = dot_product(rij, vec)
      expk = fac * exp(-0.25_wp*g2/(alp*alp))/g2
      cosk = cos(gv) * expk
      amat = amat + cosk
   end do

end subroutine get_amat_rec_3d

function fsmooth(r1, rcut) result(fcut)
   real(wp), intent(in) :: r1
   real(wp), intent(in) :: rcut
   real(wp) :: fcut

   real(wp), parameter :: offset = 1.0_wp
   real(wp), parameter :: c(*) = [-6.0_wp, 15.0_wp, -10.0_wp, 1.0_wp]
   real(wp) :: xrel

   if (r1 < rcut - offset) then
      fcut = 1.0_wp
   else if (r1 > rcut) then
      fcut = 0.0_wp
   else
      xrel = (r1 - (rcut - offset)) / offset
      fcut = c(1)*xrel**5 + c(2)*xrel**4 + c(3)*xrel**3 + c(4)
   end if
end function fsmooth

function dsmooth(r1, rcut) result(dcut)
   real(wp), intent(in) :: r1
   real(wp), intent(in) :: rcut
   real(wp) :: dcut

   real(wp), parameter :: offset = 1.0_wp
   real(wp), parameter :: c(*) = [-6.0_wp, 15.0_wp, -10.0_wp, 1.0_wp]
   real(wp) :: xrel

   if (r1 < rcut - offset .or. r1 > rcut) then
      dcut = 0.0_wp
   else
      xrel = (r1 - (rcut - offset)) / offset
      dcut = (5*c(1)*xrel**4 + 4*c(2)*xrel**3 + 3*c(3)*xrel**2) / offset
   end if

end function dsmooth


!> Evaluate uncontracted derivatives of Coulomb matrix
subroutine get_coulomb_derivs(self, mol, cache, qat, qsh, dadr, dadL, atrace)
   !> Instance of the electrostatic container
   class(gamma_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(coulomb_cache), intent(inout) :: cache
   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)
   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)
   !> Derivative of interactions with respect to cartesian displacements
   real(wp), contiguous, intent(out) :: dadr(:, :, :)
   !> Derivative of interactions with respect to strain deformations
   real(wp), contiguous, intent(out) :: dadL(:, :, :)
   !> On-site derivatives with respect to cartesian displacements
   real(wp), contiguous, intent(out) :: atrace(:, :)

   if (any(mol%periodic)) then
      call get_damat_3d(mol, self%nshell, self%offset, self%hubbard, &
         & self%rcut, cache%wsc, cache%alpha, qsh, dadr, dadL, atrace)
   else
      call get_damat_0d(mol, self%nshell, self%offset, self%hubbard, qsh, &
         & dadr, dadL, atrace)
   end if

end subroutine get_coulomb_derivs


!> Evaluate uncontracted derivatives of Coulomb matrix for finite system
subroutine get_damat_0d(mol, nshell, offset, hubbard, qvec, dadr, dadL, atrace)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells for each atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each shell
   integer, intent(in) :: offset(:)
   !> Chemical hardness for each shell and species
   real(wp), intent(in) :: hubbard(:, :)
   !> Partial charge vector
   real(wp), intent(in) :: qvec(:)
   !> Derivative of interactions with respect to cartesian displacements
   real(wp), intent(out) :: dadr(:, :, :)
   !> Derivative of interactions with respect to strain deformations
   real(wp), intent(out) :: dadL(:, :, :)
   !> On-site derivatives with respect to cartesian displacements
   real(wp), intent(out) :: atrace(:, :)

   integer :: iat, jat, izp, jzp, ii, jj, ish, jsh
   real(wp) :: vec(3), r1, gam, arg, dtmp, dG(3), dS(3, 3)
   real(wp), allocatable :: itrace(:, :), didr(:, :, :), didL(:, :, :)

   atrace(:, :) = 0.0_wp
   dadr(:, :, :) = 0.0_wp
   dadL(:, :, :) = 0.0_wp

   !$omp parallel default(none) &
   !$omp shared(atrace, dadr, dadL, mol, qvec, hubbard, nshell, offset) &
   !$omp private(iat, izp, ii, ish, jat, jzp, jj, jsh, gam, r1, vec, dG, dS, dtmp, arg) &
   !$omp private(itrace, didr, didL)
   itrace = atrace
   didr = dadr
   didL = dadL
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         vec = mol%xyz(:, iat) - mol%xyz(:, jat)
         r1 = norm2(vec)
         dtmp = -1.0_wp / (r1*r1*r1)
         do ish = 1, nshell(iat)
            do jsh = 1, nshell(jat)
               gam = dtmp - dexp_gamma(r1, hubbard(ish, izp), hubbard(jsh, jzp))/r1
               dG = gam*vec
               dS = spread(dG, 1, 3) * spread(vec, 2, 3)
               itrace(:, ii+ish) = +dG*qvec(jj+jsh) + itrace(:, ii+ish)
               itrace(:, jj+jsh) = -dG*qvec(ii+ish) + itrace(:, jj+jsh)
               didr(:, iat, jj+jsh) = +dG*qvec(ii+ish) + didr(:, iat, jj+jsh)
               didr(:, jat, ii+ish) = -dG*qvec(jj+jsh) + didr(:, jat, ii+ish)
               didL(:, :, jj+jsh) = +dS*qvec(ii+ish) + didL(:, :, jj+jsh)
               didL(:, :, ii+ish) = +dS*qvec(jj+jsh) + didL(:, :, ii+ish)
            end do
         end do
      end do
   end do
   !$omp critical (get_damat_0d_)
   atrace(:, :) = atrace + itrace
   dadr(:, :, :) = dadr + didr
   dadL(:, :, :) = dadL + didL
   !$omp end critical (get_damat_0d_)
   !$omp end parallel

end subroutine get_damat_0d

!> Evaluate uncontracted derivatives of Coulomb matrix for 3D periodic system
subroutine get_damat_3d(mol, nshell, offset, hubbard, rcut, wsc, alpha, qvec, &
      & dadr, dadL, atrace)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells for each atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each shell
   integer, intent(in) :: offset(:)
   !> Chemical hardness for each shell and species
   real(wp), intent(in) :: hubbard(:, :)
   !> Long-range cutoff
   real(wp), intent(in) :: rcut
   !> Wigner-Seitz image information
   type(wignerseitz_cell), intent(in) :: wsc
   !> Convergence factor for Ewald sum
   real(wp), intent(in) :: alpha
   !> Partial charge vector
   real(wp), intent(in) :: qvec(:)
   !> Derivative of interactions with respect to cartesian displacements
   real(wp), intent(out) :: dadr(:, :, :)
   !> Derivative of interactions with respect to strain deformations
   real(wp), intent(out) :: dadL(:, :, :)
   !> On-site derivatives with respect to cartesian displacements
   real(wp), intent(out) :: atrace(:, :)

   integer :: iat, jat, izp, jzp, img, ii, jj, ish, jsh
   real(wp) :: vol, ui, uj, wsw, vec(3), dG(3), dS(3, 3)
   real(wp) :: dGd(3), dSd(3, 3), dGr(3), dSr(3, 3)
   real(wp), allocatable :: itrace(:, :), didr(:, :, :), didL(:, :, :)
   real(wp), allocatable :: dtrans(:, :), rtrans(:, :)

   atrace(:, :) = 0.0_wp
   dadr(:, :, :) = 0.0_wp
   dadL(:, :, :) = 0.0_wp

   vol = abs(matdet_3x3(mol%lattice))
   call get_dir_trans(mol%lattice, alpha, conv, dtrans)
   call get_rec_trans(mol%lattice, alpha, vol, conv, rtrans)

   !$omp parallel default(none) shared(atrace, dadr, dadL) &
   !$omp shared(mol, wsc, alpha, vol, dtrans, rtrans, qvec, hubbard, nshell, offset, rcut) &
   !$omp private(iat, izp, jat, jzp, img, ii, jj, ish, jsh, ui, uj, wsw, vec, dG, dS, &
   !$omp& dGr, dSr, dGd, dSd, itrace, didr, didL)
   itrace = atrace
   didr = dadr
   didL = dadL
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, iat) - mol%xyz(:, jat) - wsc%trans(:, wsc%tridx(img, jat, iat))
            wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
            call get_damat_rec_3d(vec, vol, alpha, rtrans, dGr, dSr)
            do ish = 1, nshell(iat)
               do jsh = 1, nshell(jat)
                  ui = hubbard(ish, izp)
                  uj = hubbard(jsh, jzp)
                  call get_damat_dir_3d(vec, ui, uj, alpha, dtrans, dGd, dSd)
                  dG = (dGd + dGr) * wsw
                  dS = (dSd + dSr) * wsw
                  itrace(:, ii+ish) = +dG*qvec(jj+jsh) + itrace(:, ii+ish)
                  itrace(:, jj+jsh) = -dG*qvec(ii+ish) + itrace(:, jj+jsh)
                  didr(:, iat, jj+jsh) = +dG*qvec(ii+ish) + didr(:, iat, jj+jsh)
                  didr(:, jat, ii+ish) = -dG*qvec(jj+jsh) + didr(:, jat, ii+ish)
                  didL(:, :, jj+jsh) = +dS*qvec(ii+ish) + didL(:, :, jj+jsh)
                  didL(:, :, ii+ish) = +dS*qvec(jj+jsh) + didL(:, :, ii+ish)
               end do
            end do
         end do
      end do

      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec = wsc%trans(:, wsc%tridx(img, iat, iat))
         call get_damat_rec_3d(vec, vol, alpha, rtrans, dGr, dSr)
         do ish = 1, nshell(iat)
            do jsh = 1, ish-1
               ui = hubbard(ish, izp)
               uj = hubbard(jsh, izp)
               call get_damat_dir_3d(vec, ui, uj, alpha, dtrans, dGd, dSd)
               dS = (dSd + dSr) * wsw
               didL(:, :, ii+jsh) = +dS*qvec(ii+ish) + didL(:, :, ii+jsh)
               didL(:, :, ii+ish) = +dS*qvec(ii+jsh) + didL(:, :, ii+ish)
            end do
            ui = hubbard(ish, izp)
            call get_damat_dir_3d(vec, ui, ui, alpha, dtrans, dGd, dSd)
            dS = (dSd + dSr) * wsw
            didL(:, :, ii+ish) = +dS*qvec(ii+ish) + didL(:, :, ii+ish)
         end do
      end do
   end do
   !$omp critical (get_damat_3d_)
   atrace(:, :) = atrace + itrace
   dadr(:, :, :) = dadr + didr
   dadL(:, :, :) = dadL + didL
   !$omp end critical (get_damat_3d_)
   !$omp end parallel

end subroutine get_damat_3d

!> Calculate real space contributions for a pair under 3D periodic boundary conditions
subroutine get_damat_dir_3d(rij, ui, uj, alp, trans, dg, ds)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Chemical hardness
   real(wp), intent(in) :: ui, uj
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Derivative with respect to cartesian displacements
   real(wp), intent(out) :: dg(3)
   !> Derivative with respect to strain deformations
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr
   real(wp) :: vec(3), r1, r2, gtmp, atmp, alp2, fcut, dcut

   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp

   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      r2 = r1*r1
      gtmp = -1.0_wp/(r2*r1) - dexp_gamma(r1, ui, uj)/r1
      atmp = -2*alp*exp(-r2*alp2)/(sqrtpi*r2) + erf(r1*alp)/(r2*r1)
      dg(:) = dg + (gtmp + atmp) * vec
      ds(:, :) = ds + (gtmp + atmp) * spread(vec, 1, 3) * spread(vec, 2, 3)
   end do

end subroutine get_damat_dir_3d

!> Calculate reciprocal space contributions for a pair under 3D periodic boundary conditions
subroutine get_damat_rec_3d(rij, vol, alp, trans, dg, ds)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Cell volume
   real(wp), intent(in) :: vol
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Derivative with respect to cartesian displacements
   real(wp), intent(out) :: dg(3)
   !> Derivative with respect to strain deformations
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr
   real(wp) :: fac, vec(3), g2, gv, expk, sink, cosk, alp2
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], shape(unity))

   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp
   fac = 4*pi/vol
   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      gv = dot_product(rij, vec)
      expk = fac * exp(-0.25_wp*g2/alp2)/g2
      cosk = cos(gv) * expk
      sink = sin(gv) * expk
      dg(:) = dg - sink * vec
      ds(:, :) = ds + cosk &
         & * ((2.0_wp/g2 + 0.5_wp/alp2) * spread(vec, 1, 3)*spread(vec, 2, 3) &
         &     - unity)
   end do

end subroutine get_damat_rec_3d


!> Determines the value of the short range contribution to gamma with the exponential form
pure function exp_gamma(r1, ui, uj)
   !> separation of sites a and b
   real(wp), intent(in) :: r1
   !> Hubbard U for site a
   real(wp), intent(in) :: ui
   !> Hubbard U for site b
   real(wp), intent(in) :: uj
   !> contribution
   real(wp) :: exp_gamma

   real(wp) :: taui, tauj, tauij

   ! 16/5 * U, see review papers / theses
   taui = 3.2_wp*ui
   tauj = 3.2_wp*uj

   if (r1 < eps) then
      ! on-site case with R~0
      if (abs(ui - uj) < eps) then
         ! same Hubbard U values, onsite
         exp_gamma = -0.5_wp*(ui + uj)
      else
         ! ui /= uj Hubbard U values - limiting case
         exp_gamma = &
            & -0.5_wp*((taui*tauj)/(taui+tauj) + (taui*tauj)**2/(taui+tauj)**3)
      end if
   else
      if (abs(ui - uj) < eps) then
         ! R > 0 and same Hubbard U values
         tauij = 0.5_wp*(taui + tauj)
         exp_gamma = &
            & exp(-tauij*r1) &
            & * (48.0_wp/r1 &
            &   + 33.0_wp*tauij &
            &   + 9.0_wp*r1*(tauij**2) &
            &   + (r1**2)*(tauij**3)) / 48.0_wp
      else
         exp_gamma = gamma_sf(r1,taui,tauj) + gamma_sf(r1,tauj,taui)
      end if
   end if

end function exp_gamma

!> Determines the value of a part of the short range contribution to the exponential gamma, when
!> ui /= uj and R > 0
pure function gamma_sf(r1, taui, tauj) result(sf)
   !> separation of sites a and b
   real(wp), intent(in) :: r1
   !> Charge fluctuation for site a
   real(wp), intent(in) :: taui
   !> Charge fluctuation U for site b
   real(wp), intent(in) :: tauj
   !> contribution
   real(wp) :: sf

   sf = exp(-taui * r1) &
      & * ((0.5_wp*tauj**4*taui/(taui**2-tauj**2)**2) &
      &   - (tauj**6-3.0_wp*tauj**4*taui**2)/(r1*(taui**2-tauj**2)**3))

end function gamma_sf

!> Determines the value of the derivative of the short range contribution to gamma with the
!> exponential form
pure function dexp_gamma(r1,ui,uj)
   !> separation of sites a and b
   real(wp), intent(in) :: r1
   !> Hubbard U for site a
   real(wp), intent(in) :: ui
   !> Hubbard U for site b
   real(wp), intent(in) :: uj
   !> returned contribution
   real(wp) :: dexp_gamma

   real(wp) :: taui, tauj, tauij

   dexp_gamma = 0.0_wp
   if (r1 < eps) return

   ! 16/5 * U, see review papers
   taui = 3.2_wp*ui
   tauj = 3.2_wp*uj

   if (abs(ui - uj) < eps) then
      ! R > 0 and same Hubbard U values
      tauij = 0.5_wp * (taui + tauj)
      dexp_gamma = &
         & -exp(-tauij*r1) &
         & * (tauij**4*r1**4 &
         &   + 7*tauij**3*r1**3 &
         &   + 24*tauij**2*r1**2 &
         &   + 48*tauij*r1 &
         &   + 48.0_wp) &
         & / (48.0_wp*r1**2)
   else
      dexp_gamma = dgamma_sf(r1,taui,tauj) + dgamma_sf(r1,tauj,taui)
   end if
end function dexp_gamma

!> Determines the derivative of the value of a part of the short range contribution to the
!> exponential gamma, when ui /= uj and R > 0
pure function dgamma_sf(r1, taui, tauj) result(dsf)
   !> separation of sites a and b
   real(wp), intent(in) :: r1
   !> Charge fluctuation for site a
   real(wp), intent(in) :: taui
   !> Charge fluctuation U for site b
   real(wp), intent(in) :: tauj
   !> contribution
   real(wp) :: dsf

   dsf = &
      & exp(- taui * r1) &
      & * (taui * tauj**4 * (tauj**2 - 3.0_wp*taui**2)/(r1*(taui**2-tauj**2)**3) &
      &   - tauj**4 * taui**2 / (2*(taui**2-tauj**2)**2) &
      &   + tauj**4*(tauj**2 - 3.0_wp*taui**2) / (r1**2 *(taui**2-tauj**2)**3))

end function dgamma_sf


end module tblite_coulomb_charge_gamma

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module test_read_gaussian
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check
   use mctc_io_read_gaussian
   use mctc_io_structure
   implicit none
   private

   public :: collect_read_gaussian


contains


!> Collect all exported unit tests
subroutine collect_read_gaussian(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("valid1-ein", test_valid1_ein), &
      & new_unittest("invalid1-ein", test_invalid1_ein, should_fail=.true.), &
      & new_unittest("invalid2-ein", test_invalid2_ein, should_fail=.true.), &
      & new_unittest("invalid3-ein", test_invalid3_ein, should_fail=.true.), &
      & new_unittest("invalid4-ein", test_invalid4_ein, should_fail=.true.) &
      & ]

end subroutine collect_read_gaussian


subroutine test_valid1_ein(error)

   use mctc_env_accuracy, only : wp
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "         4         1         0         1", &
      "         7      0.000000000000      0.000000000000     -0.114091591161      0.000000000000 ", &
      "         1     -1.817280998039      0.000000000000      0.528409372569      0.000000000000 ", &
      "         1      0.908640499019     -1.573811509290      0.528409372569      0.000000000000 ", &
      "         1      0.908640499019      1.573811509290      0.528409372569      0.000000000000 ", &
      " 1 2 1.000 3 1.000 4 1.000", &
      " 2 1 1.000", &
      " 3 1 1.000", &
      " 4 1 1.000"
   rewind(unit)

   call read_gaussian_external(struc, unit, error)
   close(unit)
   if (allocated(error)) return

   call check(error, struc%nat, 4, "Number of atoms does not match")
   if (allocated(error)) return
   call check(error, struc%nid, 2, "Number of species does not match")
   if (allocated(error)) return
   
   call check(error, struc%xyz(1,1), 0.000000000000_wp, thr=1.0e-10_wp, message="Coordinates do not match")
   if (allocated(error)) return
  
   call check(error, struc%xyz(3,2), 0.528409372569_wp, thr=1.0e-10_wp,message="Coordinates do not match")
   if (allocated(error)) return
   
   call check(error, struc%xyz(2,3), -1.573811509290_wp, thr=1.0e-10_wp, message="Coordinates do not match")
  if (allocated(error)) return

end subroutine test_valid1_ein


subroutine test_invalid1_ein(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "         4         1      zero       one", &
      "         7      0.000000000000      0.000000000000     -0.114091591161      0.000000000000 ", &
      "         1     -1.817280998039      0.000000000000      0.528409372569      0.000000000000 ", &
      "         1      0.908640499019     -1.573811509290      0.528409372569      0.000000000000 ", &
      "         1      0.908640499019      1.573811509290      0.528409372569      0.000000000000 ", &
      " 1 2 1.000 3 1.000 4 1.000", &
      " 2 1 1.000", &
      " 3 1 1.000", &
      " 4 1 1.000"
   rewind(unit)

   call read_gaussian_external(struc, unit, error)
   close(unit)

end subroutine test_invalid1_ein


subroutine test_invalid2_ein(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "        -4         1         0         1", &
      "         7      0.000000000000      0.000000000000     -0.114091591161      0.000000000000 ", &
      "         1     -1.817280998039      0.000000000000      0.528409372569      0.000000000000 ", &
      "         1      0.908640499019     -1.573811509290      0.528409372569      0.000000000000 ", &
      "         1      0.908640499019      1.573811509290      0.528409372569      0.000000000000 ", &
      " 1 2 1.000 3 1.000 4 1.000", &
      " 2 1 1.000", &
      " 3 1 1.000", &
      " 4 1 1.000"
   rewind(unit)

   call read_gaussian_external(struc, unit, error)
   close(unit)

end subroutine test_invalid2_ein


subroutine test_invalid3_ein(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "         4         1         0         1", &
      "         7      0.000000000000      0.000000000000     -0.114091591161      0.000000000000 ", &
      "         1     -1.817280998039      0.000000000000      0.528409372569      0.000000000000 ", &
      "         1      0.908640499019     -1.573811509290      0.528409372569      0.000000000000 ", &
      "         1      abcd.efgh-jklm      1.573811509290      0.528409372569      0.000000000000 ", &
      " 1 2 1.000 3 1.000 4 1.000", &
      " 2 1 1.000", &
      " 3 1 1.000", &
      " 4 1 1.000"
   rewind(unit)

   call read_gaussian_external(struc, unit, error)
   close(unit)

end subroutine test_invalid3_ein


subroutine test_invalid4_ein(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "         4         1         0         1", &
      "         7      0.000000000000      0.000000000000     -0.114091591161      0.000000000000 ", &
      "         1     -1.817280998039      0.000000000000      0.528409372569      0.000000000000 ", &
      "         1      0.908640499019     -1.573811509290      0.528409372569      0.000000000000 ", &
      "        -1      0.908640499019      1.573811509290      0.528409372569      0.000000000000 ", &
      " 1 2 1.000 3 1.000 4 1.000", &
      " 2 1 1.000", &
      " 3 1 1.000", &
      " 4 1 1.000"
   rewind(unit)

   call read_gaussian_external(struc, unit, error)
   close(unit)

end subroutine test_invalid4_ein


end module test_read_gaussian

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/wavefunction/type.f90
!> Provides a wavefunction type for holding density-related information

!> Declaration of a tight-binding wavefunction
module tblite_wavefunction_type
   use mctc_env, only : wp
   use tblite_blas, only : gemm
   implicit none
   private

   public :: new_wavefunction
   public :: get_density_matrix, get_alpha_beta_occupation

   !> Tight-binding wavefunction
   type, public :: wavefunction_type
      !> Electronic temperature
      real(wp) :: kt = 0.0_wp
      !> Number of electrons in this wavefunction
      real(wp) :: nocc = 0.0_wp
      !> Number of unpaired electrons in this wavefunction
      real(wp) :: nuhf = 0.0_wp
      !> Number of spin channels
      integer :: nspin = 1
      !> Number of electrons
      real(wp), allocatable :: nel(:)
      !> Reference occupation number for each atom, shape: [nat]
      real(wp), allocatable :: n0at(:)
      !> Reference occupation number for each shell, shape: [nsh]
      real(wp), allocatable :: n0sh(:)

      !> Density matrix, shape: [nao, nao, spin]
      real(wp), allocatable :: density(:, :, :)
      !> Orbital coefficients, shape: [nao, nao, spin]
      real(wp), allocatable :: coeff(:, :, :)
      !> Orbital energies, eigenvalues, shape: [nao, spin]
      real(wp), allocatable :: emo(:, :)
      !> Occupation numbers, shape: [nao, spin]
      real(wp), allocatable :: focc(:, :)

      !> Number of electrons for each atom, shape: [nat, spin]
      real(wp), allocatable :: qat(:, :)
      !> Number of electrons for each shell, shape: [nsh, spin]
      real(wp), allocatable :: qsh(:, :)

      !> Atomic dipole moments for each atom, shape: [3, nat, spin]
      real(wp), allocatable :: dpat(:, :, :)
      !> Atomic quadrupole moments for each atom, shape: [5, nat, spin]
      real(wp), allocatable :: qpat(:, :, :)

      !> Derivative of atomic charges w.r.t. the positions: [3, nat, nat, spin]
      real(wp), allocatable :: dqatdr(:, :, :, :)
      !> Derivative of atomic charges w.r.t. the lattice vectors: [3, 3, nat, spin]
      real(wp), allocatable :: dqatdL(:, :, :, :)

      !> Derivative of shell charges w.r.t. the positions: [3, nat, nsh, spin]
      real(wp), allocatable :: dqshdr(:, :, :, :)
      !> Derivative of shell charges w.r.t. the lattice vectors: [3, 3, nsh, spin]
      real(wp), allocatable :: dqshdL(:, :, :, :)
   end type wavefunction_type

contains


subroutine new_wavefunction(self, nat, nsh, nao, nspin, kt, grad)
   type(wavefunction_type), intent(out) :: self
   integer, intent(in) :: nat
   integer, intent(in) :: nsh
   integer, intent(in) :: nao
   integer, intent(in) :: nspin
   real(wp), intent(in) :: kt
   !> Flag to indicate if a wavefunction gradient is requested
   logical, intent(in), optional :: grad

   self%nspin = nspin
   self%kt = kt

   allocate(self%nel(max(2, nspin)))

   allocate(self%n0at(nat))
   allocate(self%n0sh(nsh))

   allocate(self%density(nao, nao, nspin))
   allocate(self%coeff(nao, nao, nspin))
   allocate(self%emo(nao, nspin))
   allocate(self%focc(nao, max(2, nspin)))

   allocate(self%qat(nat, nspin))
   allocate(self%qsh(nsh, nspin))

   allocate(self%dpat(3, nat, nspin))
   allocate(self%qpat(6, nat, nspin))

   ! Check if a wavefunction gradient is requested
   if(present(grad)) then
      if(grad) then
         allocate(self%dqatdr(3, nat, nat, nspin))
         allocate(self%dqatdL(3, 3, nat, nspin))

         allocate(self%dqshdr(3, nat, nsh, nspin))
         allocate(self%dqshdL(3, 3, nsh, nspin))

         self%dqatdr(:, :, :, :) = 0.0_wp
         self%dqatdL(:, :, :, :) = 0.0_wp
         self%dqshdr(:, :, :, :) = 0.0_wp
         self%dqshdL(:, :, :, :) = 0.0_wp
      end if
   end if

   self%density(:, :, :) = 0.0_wp
   self%coeff(:, :, :) = 0.0_wp
   self%qat(:, :) = 0.0_wp
   self%qsh(:, :) = 0.0_wp
   self%dpat(:, :, :) = 0.0_wp
   self%qpat(:, :, :) = 0.0_wp
end subroutine new_wavefunction

subroutine get_density_matrix(focc, coeff, pmat)
   real(wp), intent(in) :: focc(:)
   real(wp), contiguous, intent(in) :: coeff(:, :)
   real(wp), contiguous, intent(out) :: pmat(:, :)

   real(wp), allocatable :: scratch(:, :)
   integer :: iao, jao

   allocate(scratch(size(pmat, 1), size(pmat, 2)))
   !$omp parallel do collapse(2) default(none) schedule(runtime) &
   !$omp shared(scratch, coeff, focc, pmat) private(iao, jao)
   do iao = 1, size(pmat, 1)
      do jao = 1, size(pmat, 2)
         scratch(jao, iao) = coeff(jao, iao) * focc(iao)
      end do
   end do
   call gemm(scratch, coeff, pmat, transb='t')
end subroutine get_density_matrix


!> Split an real occupation number into alpha and beta space.
!>
!> This routine does not perform any checks on the condition
!> ``mod(nocc, 2) == 0 .eqv. mod(nuhf, 2) == 0`` and will yield fractional
!> occupations in case those condtions are not fullfilled.
!> However, it will avoid creating negative occupation numbers.
subroutine get_alpha_beta_occupation(nocc, nuhf, nalp, nbet)
   real(wp), intent(in) :: nocc
   real(wp), intent(in) :: nuhf
   real(wp), intent(out) :: nalp
   real(wp), intent(out) :: nbet

   real(wp) :: ntmp, diff

   ! make sure we cannot get a negative occupation here
   diff = min(nuhf, nocc)
   ntmp = nocc - diff

   nalp = ntmp / 2 + diff
   nbet = ntmp / 2
end subroutine get_alpha_beta_occupation

end module tblite_wavefunction_type

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module tftest_parser
   use testdrive
   use tomlf_constants, only : nl => TOML_NEWLINE
   use tomlf_de_parser
   use tomlf_de_lexer, only : toml_lexer, new_lexer_from_string, toml_token, token_kind
   use tomlf_error, only : toml_error
   use tomlf_type, only : toml_table
   use tomlf_terminal, only : toml_terminal
   implicit none

   public :: collect_parser

   type, extends(toml_lexer) :: mocked_lexer
      type(toml_token), allocatable :: token(:)
   contains
      procedure :: next
   end type mocked_lexer

contains

!> Collect all exported unit tests
subroutine collect_parser(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("root-invalid", root_invalid, should_fail=.true.), &
      & new_unittest("table-body", table_body), &
      & new_unittest("table-header-long", table_header_long), &
      & new_unittest("table-header-empty", table_header_empty, should_fail=.true.), &
      & new_unittest("table-header-unclosed1", table_header_unclosed1, should_fail=.true.), &
      & new_unittest("table-header-unclosed2", table_header_unclosed2, should_fail=.true.), &
      & new_unittest("table-header-invalid", table_header_invalid, should_fail=.true.), &
      & new_unittest("table-header-newline1", table_header_newline1, should_fail=.true.), &
      & new_unittest("table-header-newline2", table_header_newline2, should_fail=.true.), &
      & new_unittest("table-header-duplicate", table_header_duplicate, should_fail=.true.), &
      & new_unittest("table-header-trailing-whitespace", table_header_trailing_whitespace), &
      & new_unittest("table-header-trailing-comment", table_header_trailing_comment), &
      & new_unittest("aot-body", aot_body), &
      & new_unittest("aot-inline", aot_inline, should_fail=.true.), &
      & new_unittest("aot-header-whitespace1", aot_header_whitespace1), &
      & new_unittest("aot-header-whitespace2", aot_header_whitespace2), &
      & new_unittest("aot-header-empty", aot_header_empty, should_fail=.true.), &
      & new_unittest("aot-header-unclosed1", aot_header_unclosed1, should_fail=.true.), &
      & new_unittest("aot-header-unclosed2", aot_header_unclosed2, should_fail=.true.), &
      & new_unittest("aot-header-unclosed3", aot_header_unclosed3, should_fail=.true.), &
      & new_unittest("aot-header-duplicate1", aot_header_duplicate1, should_fail=.true.), &
      & new_unittest("aot-header-duplicate2", aot_header_duplicate2, should_fail=.true.), &
      & new_unittest("aot-header-duplicate3", aot_header_duplicate3, should_fail=.true.), &
      & new_unittest("aot-header-invalid1", aot_header_invalid1, should_fail=.true.), &
      & new_unittest("aot-header-invalid2", aot_header_invalid2, should_fail=.true.), &
      & new_unittest("keyval-empty", keyval_empty, should_fail=.true.), &
      & new_unittest("keyval-equal", keyval_equal, should_fail=.true.), &
      & new_unittest("keyval-dotted", keyval_dotted), &
      & new_unittest("keyval-comment", keyval_comment), &
      & new_unittest("inline-array", inline_array), &
      & new_unittest("inline-array-empty", inline_array_empty), &
      & new_unittest("inline-array-whitespace", inline_array_whitespace), &
      & new_unittest("inline-array-newline", inline_array_newline), &
      & new_unittest("inline-array-nested", inline_array_nested), &
      & new_unittest("inline-table", inline_table), &
      & new_unittest("inline-table-empty", inline_table_empty), &
      & new_unittest("inline-table-whitespace", inline_table_whitespace), &
      & new_unittest("inline-table-newline", inline_table_newline), &
      & new_unittest("inline-table-comma", inline_table_comma), &
      & new_unittest("inline-table-modify", inline_table_modify, should_fail=.true.), &
      & new_unittest("empty", empty)]

end subroutine collect_parser

subroutine empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "", [toml_token(token_kind%eof)])
end subroutine empty

subroutine root_invalid(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "}", &
      & [toml_token(token_kind%lbrace, 1, 1), toml_token(token_kind%eof, 2, 2)])
end subroutine root_invalid

subroutine table_body(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[a]"//nl//"c=1"//nl//"[b]"//nl//"c=1", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%keypath, 2, 2), &
      &  toml_token(token_kind%rbracket, 3, 3), toml_token(token_kind%newline, 4, 4), &
      &  toml_token(token_kind%keypath, 5, 5), toml_token(token_kind%equal, 6, 6), &
      &  toml_token(token_kind%int, 7, 7), toml_token(token_kind%newline, 8, 8), &
      &  toml_token(token_kind%lbracket, 9, 9), toml_token(token_kind%keypath, 10, 10), &
      &  toml_token(token_kind%rbracket, 11, 11), toml_token(token_kind%newline, 12, 12), &
      &  toml_token(token_kind%keypath, 13, 13), toml_token(token_kind%equal, 14, 14), &
      &  toml_token(token_kind%int, 15, 15), toml_token(token_kind%eof, 16, 16)])
end subroutine table_body

subroutine aot_body(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[[a]]"//nl//"b=1"//nl//"[[a]]"//nl//"b=1", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%lbracket, 2, 2), &
      &  toml_token(token_kind%keypath, 3, 3), toml_token(token_kind%rbracket, 4, 4), &
      &  toml_token(token_kind%rbracket, 5, 5), toml_token(token_kind%newline, 6, 6), &
      &  toml_token(token_kind%keypath, 7, 7), toml_token(token_kind%equal, 8, 8), &
      &  toml_token(token_kind%int, 9, 9), toml_token(token_kind%newline, 10, 10), &
      &  toml_token(token_kind%lbracket, 11, 11), toml_token(token_kind%lbracket, 12, 12), &
      &  toml_token(token_kind%keypath, 13, 13), toml_token(token_kind%rbracket, 14, 14), &
      &  toml_token(token_kind%rbracket, 15, 15), toml_token(token_kind%newline, 16, 16), &
      &  toml_token(token_kind%keypath, 17, 17), toml_token(token_kind%equal, 18, 18), &
      &  toml_token(token_kind%int, 19, 19), toml_token(token_kind%eof, 20, 20)])
end subroutine aot_body

subroutine table_header_long(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[a.b.c.d.e.f.g.h.i.j.k.l.m.n.o.p.q.r.s.t.u.v.w.x.y.z]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%keypath, 2, 2), &
      &  toml_token(token_kind%dot, 3, 3), toml_token(token_kind%keypath, 4, 4), &
      &  toml_token(token_kind%dot, 5, 5), toml_token(token_kind%keypath, 6, 6), &
      &  toml_token(token_kind%dot, 7, 7), toml_token(token_kind%keypath, 8, 8), &
      &  toml_token(token_kind%dot, 9, 9), toml_token(token_kind%keypath, 10, 10), &
      &  toml_token(token_kind%dot, 11, 11), toml_token(token_kind%keypath, 12, 12), &
      &  toml_token(token_kind%dot, 13, 13), toml_token(token_kind%keypath, 14, 14), &
      &  toml_token(token_kind%dot, 15, 15), toml_token(token_kind%keypath, 16, 16), &
      &  toml_token(token_kind%dot, 17, 17), toml_token(token_kind%keypath, 18, 18), &
      &  toml_token(token_kind%dot, 19, 19), toml_token(token_kind%keypath, 20, 20), &
      &  toml_token(token_kind%dot, 21, 21), toml_token(token_kind%keypath, 22, 22), &
      &  toml_token(token_kind%dot, 23, 23), toml_token(token_kind%keypath, 24, 24), &
      &  toml_token(token_kind%dot, 25, 25), toml_token(token_kind%keypath, 26, 26), &
      &  toml_token(token_kind%dot, 27, 27), toml_token(token_kind%keypath, 28, 28), &
      &  toml_token(token_kind%dot, 29, 29), toml_token(token_kind%keypath, 30, 30), &
      &  toml_token(token_kind%dot, 31, 31), toml_token(token_kind%keypath, 32, 32), &
      &  toml_token(token_kind%dot, 33, 33), toml_token(token_kind%keypath, 34, 34), &
      &  toml_token(token_kind%dot, 35, 35), toml_token(token_kind%keypath, 36, 36), &
      &  toml_token(token_kind%dot, 37, 37), toml_token(token_kind%keypath, 38, 38), &
      &  toml_token(token_kind%dot, 39, 39), toml_token(token_kind%keypath, 40, 40), &
      &  toml_token(token_kind%dot, 41, 41), toml_token(token_kind%keypath, 42, 42), &
      &  toml_token(token_kind%dot, 43, 43), toml_token(token_kind%keypath, 44, 44), &
      &  toml_token(token_kind%dot, 45, 45), toml_token(token_kind%keypath, 46, 46), &
      &  toml_token(token_kind%dot, 47, 47), toml_token(token_kind%keypath, 48, 48), &
      &  toml_token(token_kind%dot, 49, 49), toml_token(token_kind%keypath, 50, 50), &
      &  toml_token(token_kind%dot, 51, 51), toml_token(token_kind%keypath, 52, 52), &
      &  toml_token(token_kind%rbracket, 53, 53), toml_token(token_kind%eof, 54, 54)])
end subroutine table_header_long

subroutine table_header_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[]", &
      & [toml_token(token_kind%lbracket, 60, 1), toml_token(token_kind%rbracket, 2, 2), &
      &  toml_token(token_kind%eof, 15, 9)])
end subroutine table_header_empty

subroutine table_header_unclosed1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%eof, 2, 2)])
end subroutine table_header_unclosed1

subroutine table_header_unclosed2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[a.]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%keypath, 2, 2), &
      &  toml_token(token_kind%dot, 3, 3), toml_token(token_kind%rbracket, 4, 4), &
      &  toml_token(token_kind%eof, 5, 5)])
end subroutine table_header_unclosed2

subroutine table_header_invalid(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[a,]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%keypath, 2, 2), &
      &  toml_token(token_kind%comma, 3, 3), toml_token(token_kind%rbracket, 4, 4), &
      &  toml_token(token_kind%eof, 5, 5)])
end subroutine table_header_invalid

subroutine table_header_newline1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[""\n""]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%string, 2, 5), &
      &  toml_token(token_kind%rbracket, 6, 6), toml_token(token_kind%eof, 7, 7)])
end subroutine table_header_newline1

subroutine table_header_newline2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[a] [b]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%keypath, 2, 2), &
      &  toml_token(token_kind%rbracket, 3, 3), toml_token(token_kind%whitespace, 4, 4), &
      &  toml_token(token_kind%lbracket, 5, 5), toml_token(token_kind%keypath, 6, 6), &
      &  toml_token(token_kind%rbracket, 7, 7), toml_token(token_kind%eof, 8, 8)])
end subroutine table_header_newline2

subroutine table_header_duplicate(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[a]"//nl//"[a]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%keypath, 2, 2), &
      &  toml_token(token_kind%rbracket, 3, 3), toml_token(token_kind%newline, 4, 4), &
      &  toml_token(token_kind%lbracket, 5, 5), toml_token(token_kind%keypath, 6, 6), &
      &  toml_token(token_kind%rbracket, 7, 7), toml_token(token_kind%eof, 5, 5)])
end subroutine table_header_duplicate

subroutine table_header_trailing_whitespace(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[a.b] ", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%keypath, 2, 2), &
      &  toml_token(token_kind%dot, 3, 3), toml_token(token_kind%keypath, 4, 4), &
      &  toml_token(token_kind%rbracket, 5, 5), toml_token(token_kind%whitespace, 6, 6), &
      &  toml_token(token_kind%eof, 7, 7)])
end subroutine table_header_trailing_whitespace

subroutine table_header_trailing_comment(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[a.b]#", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%keypath, 2, 2), &
      &  toml_token(token_kind%dot, 3, 3), toml_token(token_kind%keypath, 4, 4), &
      &  toml_token(token_kind%rbracket, 5, 5), toml_token(token_kind%comment, 6, 6), &
      &  toml_token(token_kind%eof, 7, 7)])
end subroutine table_header_trailing_comment

subroutine aot_header_whitespace1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[[ a]]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%lbracket, 2, 2), &
      &  toml_token(token_kind%whitespace, 3, 3), toml_token(token_kind%keypath, 4, 4), &
      &  toml_token(token_kind%rbracket, 5, 5), toml_token(token_kind%rbracket, 6, 6), &
      &  toml_token(token_kind%eof, 7, 7)])
end subroutine aot_header_whitespace1

subroutine aot_header_whitespace2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[[a ]]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%lbracket, 2, 2), &
      &  toml_token(token_kind%keypath, 3, 3), toml_token(token_kind%whitespace, 4, 4), &
      &  toml_token(token_kind%rbracket, 5, 5), toml_token(token_kind%rbracket, 6, 6), &
      &  toml_token(token_kind%eof, 7, 7)])
end subroutine aot_header_whitespace2

subroutine aot_header_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[[]]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%lbracket, 2, 2), &
      &  toml_token(token_kind%rbracket, 3, 3), toml_token(token_kind%rbracket, 4, 4), &
      &  toml_token(token_kind%eof, 5, 5)])
end subroutine aot_header_empty

subroutine aot_header_unclosed1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[[", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%lbracket, 2, 2), &
      &  toml_token(token_kind%eof, 3, 3)])
end subroutine aot_header_unclosed1

subroutine aot_header_unclosed2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[[a.]]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%lbracket, 2, 2), &
      &  toml_token(token_kind%keypath, 3, 3), toml_token(token_kind%dot, 4, 4), &
      &  toml_token(token_kind%rbracket, 5, 5), toml_token(token_kind%rbracket, 6, 6), &
      &  toml_token(token_kind%eof, 7, 7)])
end subroutine aot_header_unclosed2

subroutine aot_header_unclosed3(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[ [a]  #", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%whitespace, 2, 2), &
      &  toml_token(token_kind%lbracket, 3, 3), toml_token(token_kind%keypath, 4, 4), &
      &  toml_token(token_kind%rbracket, 5, 5), toml_token(token_kind%whitespace, 6, 7), &
      &  toml_token(token_kind%comment, 8, 8), toml_token(token_kind%eof, 9, 9)])
end subroutine aot_header_unclosed3

subroutine aot_header_duplicate1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[[a]]"//nl//"[a]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%lbracket, 2, 2), &
      &  toml_token(token_kind%keypath, 3, 3), toml_token(token_kind%rbracket, 4, 4), &
      &  toml_token(token_kind%rbracket, 5, 5), toml_token(token_kind%newline, 6, 6), &
      &  toml_token(token_kind%lbracket, 7, 7), toml_token(token_kind%keypath, 8, 8), &
      &  toml_token(token_kind%rbracket, 9, 9), toml_token(token_kind%eof, 10, 10)])
end subroutine aot_header_duplicate1

subroutine aot_header_duplicate2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[a]"//nl//"[[a]]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%keypath, 2, 2), &
      &  toml_token(token_kind%rbracket, 3, 3), toml_token(token_kind%newline, 4, 4), &
      &  toml_token(token_kind%lbracket, 5, 5), toml_token(token_kind%lbracket, 6, 6), &
      &  toml_token(token_kind%keypath, 7, 7), toml_token(token_kind%rbracket, 8, 8), &
      &  toml_token(token_kind%rbracket, 9, 9), toml_token(token_kind%eof, 10, 10)])
end subroutine aot_header_duplicate2

subroutine aot_header_duplicate3(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[a.b.c]"//nl//"[[a.b]]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%keypath, 2, 2), &
      &  toml_token(token_kind%dot, 3, 3), toml_token(token_kind%keypath, 4, 4), &
      &  toml_token(token_kind%dot, 5, 5), toml_token(token_kind%keypath, 6, 6), &
      &  toml_token(token_kind%rbracket, 7, 7), toml_token(token_kind%newline, 8, 8), &
      &  toml_token(token_kind%lbracket, 9, 9), toml_token(token_kind%lbracket, 10, 10), &
      &  toml_token(token_kind%keypath, 11, 11), toml_token(token_kind%dot, 12, 12), &
      &  toml_token(token_kind%keypath, 13, 13), toml_token(token_kind%rbracket, 14, 14), &
      &  toml_token(token_kind%rbracket, 15, 15), toml_token(token_kind%eof, 16, 16)])
end subroutine aot_header_duplicate3

subroutine aot_header_invalid1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[ [a]]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%whitespace, 2, 2), &
      &  toml_token(token_kind%lbracket, 3, 3), toml_token(token_kind%keypath, 4, 4), &
      &  toml_token(token_kind%rbracket, 5, 5), toml_token(token_kind%rbracket, 6, 6), &
      &  toml_token(token_kind%eof, 6, 6)])
end subroutine aot_header_invalid1

subroutine aot_header_invalid2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "[[a] ]", &
      & [toml_token(token_kind%lbracket, 1, 1), toml_token(token_kind%lbracket, 2, 2), &
      &  toml_token(token_kind%keypath, 3, 3), toml_token(token_kind%rbracket, 4, 4), &
      &  toml_token(token_kind%whitespace, 5, 5), toml_token(token_kind%rbracket, 6, 6), &
      &  toml_token(token_kind%eof, 6, 6)])
end subroutine aot_header_invalid2

subroutine aot_inline(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a=[]"//nl//"[[a]]", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%lbracket, 3, 3), toml_token(token_kind%rbracket, 4, 4), &
      &  toml_token(token_kind%newline, 6, 6), toml_token(token_kind%lbracket, 6, 6), &
      &  toml_token(token_kind%lbracket, 7, 7), toml_token(token_kind%keypath, 8, 8), &
      &  toml_token(token_kind%rbracket, 9, 9), toml_token(token_kind%rbracket, 10, 10), &
      &  toml_token(token_kind%eof, 6, 6)])
end subroutine aot_inline

subroutine keyval_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a=", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%eof, 3, 3)])
end subroutine keyval_empty

subroutine keyval_equal(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a=,", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%comma, 3, 3), toml_token(token_kind%eof, 4, 4)])
end subroutine keyval_equal

subroutine keyval_dotted(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a.b.c=1", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%dot, 2, 2), &
      &  toml_token(token_kind%keypath, 3, 3), toml_token(token_kind%dot, 4, 4), &
      &  toml_token(token_kind%keypath, 5, 5), toml_token(token_kind%equal, 6, 6), &
      &  toml_token(token_kind%int, 7, 7), toml_token(token_kind%eof, 8, 8)])
end subroutine keyval_dotted

subroutine keyval_comment(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "# This is a full-line comment"//nl//&
      & "key = ""value"" # This is a comment at the end of a line", &
      & [toml_token(token_kind%comment, 1, 29), toml_token(token_kind%newline, 30, 30), &
      &  toml_token(token_kind%keypath, 31, 33), toml_token(token_kind%whitespace, 34, 34), &
      &  toml_token(token_kind%equal, 35, 35), toml_token(token_kind%whitespace, 36, 36), &
      &  toml_token(token_kind%string, 37, 43), toml_token(token_kind%whitespace, 44, 44), &
      &  toml_token(token_kind%comment, 45, 85), toml_token(token_kind%eof, 86, 86)])
end subroutine keyval_comment

subroutine inline_array(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a=[1,[2,],[3]]", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%lbracket, 3, 3), toml_token(token_kind%int, 4, 4), &
      &  toml_token(token_kind%comma, 5, 5), toml_token(token_kind%lbracket, 6, 6), &
      &  toml_token(token_kind%int, 7, 7), toml_token(token_kind%comma, 8, 8), &
      &  toml_token(token_kind%rbracket, 9, 9), toml_token(token_kind%comma, 10, 10), &
      &  toml_token(token_kind%lbracket, 11, 11), toml_token(token_kind%int, 12, 12), &
      &  toml_token(token_kind%rbracket, 13, 13), toml_token(token_kind%rbracket, 14, 14), &
      &  toml_token(token_kind%eof, 15, 15)])
end subroutine inline_array

subroutine inline_array_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a=[]", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%lbracket, 3, 3), toml_token(token_kind%rbracket, 4, 4), &
      &  toml_token(token_kind%eof, 5, 5)])
end subroutine inline_array_empty

subroutine inline_array_whitespace(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a=[ 1 , ]", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%lbracket, 3, 3), toml_token(token_kind%whitespace, 4, 4), &
      &  toml_token(token_kind%int, 5, 5), toml_token(token_kind%whitespace, 6, 6), &
      &  toml_token(token_kind%comma, 7, 7), toml_token(token_kind%whitespace, 8, 8), &
      &  toml_token(token_kind%rbracket, 9, 9), toml_token(token_kind%eof, 10, 10)])
end subroutine inline_array_whitespace

subroutine inline_array_newline(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a=[ #"//nl//"1 #"//nl//", #"//nl//"] #", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%lbracket, 3, 3), toml_token(token_kind%whitespace, 4, 4), &
      &  toml_token(token_kind%comment, 5, 5), toml_token(token_kind%newline, 6, 6), &
      &  toml_token(token_kind%int, 7, 7), toml_token(token_kind%whitespace, 8, 8), &
      &  toml_token(token_kind%comment, 9, 9), toml_token(token_kind%newline, 10, 10), &
      &  toml_token(token_kind%comma, 11, 11), toml_token(token_kind%whitespace, 12, 12), &
      &  toml_token(token_kind%comment, 13, 13), toml_token(token_kind%newline, 14, 14), &
      &  toml_token(token_kind%rbracket, 15, 15), toml_token(token_kind%whitespace, 16, 16), &
      &  toml_token(token_kind%comment, 17, 17), toml_token(token_kind%eof, 18, 18)])
end subroutine inline_array_newline


subroutine inline_array_nested(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "data=[[""gamma"",""delta""],[1,2]]", &
      & [toml_token(token_kind%keypath, 1, 4), toml_token(token_kind%equal, 5, 5), &
      &  toml_token(token_kind%lbracket, 6, 6), toml_token(token_kind%lbracket, 7, 7), &
      &  toml_token(token_kind%string, 8, 14), toml_token(token_kind%comma, 15, 15), &
      &  toml_token(token_kind%string, 16, 22), toml_token(token_kind%rbracket, 23, 23), &
      &  toml_token(token_kind%comma, 24, 24), toml_token(token_kind%lbracket, 25, 25), &
      &  toml_token(token_kind%int, 26, 26), toml_token(token_kind%comma, 27, 27), &
      &  toml_token(token_kind%int, 28, 28), toml_token(token_kind%rbracket, 29, 29), &
      &  toml_token(token_kind%rbracket, 30, 30), toml_token(token_kind%eof, 31, 31)])
end subroutine inline_array_nested

subroutine inline_table(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a={b=1,c.d=2}", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%lbrace, 3, 3), toml_token(token_kind%keypath, 4, 4), &
      &  toml_token(token_kind%equal, 5, 5), toml_token(token_kind%int, 6, 6), &
      &  toml_token(token_kind%comma, 7, 7), toml_token(token_kind%keypath, 8, 8), &
      &  toml_token(token_kind%dot, 9, 9), toml_token(token_kind%keypath, 10, 10), &
      &  toml_token(token_kind%equal, 11, 11), toml_token(token_kind%int, 12, 12), &
      &  toml_token(token_kind%rbrace, 13, 13), toml_token(token_kind%eof, 14, 14)])
end subroutine inline_table

subroutine inline_table_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a={}", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%lbrace, 3, 3), toml_token(token_kind%rbrace, 4, 4), &
      &  toml_token(token_kind%eof, 5, 5)])
end subroutine inline_table_empty

subroutine inline_table_empty_whitespace(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a={ }", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%lbrace, 3, 3), toml_token(token_kind%whitespace, 4, 4), &
      &  toml_token(token_kind%rbrace, 5, 5), toml_token(token_kind%eof, 6, 6)])
end subroutine inline_table_empty_whitespace

subroutine inline_table_whitespace(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a={ b=1 }", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%lbrace, 3, 3), toml_token(token_kind%whitespace, 4, 4), &
      &  toml_token(token_kind%keypath, 5, 5), toml_token(token_kind%equal, 6, 6), &
      &  toml_token(token_kind%int, 7, 7), toml_token(token_kind%whitespace, 8, 8), &
      &  toml_token(token_kind%rbrace, 9, 9), toml_token(token_kind%eof, 10, 10)])
end subroutine inline_table_whitespace

subroutine inline_table_newline(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a={ b=1"//nl//"}", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%lbrace, 3, 3), toml_token(token_kind%whitespace, 4, 4), &
      &  toml_token(token_kind%keypath, 5, 5), toml_token(token_kind%equal, 6, 6), &
      &  toml_token(token_kind%int, 7, 7), toml_token(token_kind%newline, 8, 8), &
      &  toml_token(token_kind%rbrace, 9, 9), toml_token(token_kind%eof, 10, 10)])
end subroutine inline_table_newline

subroutine inline_table_comma(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a={ b=1,}", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%lbrace, 3, 3), toml_token(token_kind%whitespace, 4, 4), &
      &  toml_token(token_kind%keypath, 5, 5), toml_token(token_kind%equal, 6, 6), &
      &  toml_token(token_kind%int, 7, 7), toml_token(token_kind%comma, 8, 8), &
      &  toml_token(token_kind%rbrace, 9, 9), toml_token(token_kind%eof, 10, 10)])
end subroutine inline_table_comma


subroutine inline_table_modify(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_parser(error, "a={}"//nl//"[a.b]", &
      & [toml_token(token_kind%keypath, 1, 1), toml_token(token_kind%equal, 2, 2), &
      &  toml_token(token_kind%lbrace, 3, 3), toml_token(token_kind%rbrace, 4, 4), &
      &  toml_token(token_kind%newline, 5, 5), toml_token(token_kind%lbracket, 6, 6), &
      &  toml_token(token_kind%keypath, 7, 7), toml_token(token_kind%dot, 8, 8), &
      &  toml_token(token_kind%keypath, 9, 9), toml_token(token_kind%rbracket, 10, 10), &
      &  toml_token(token_kind%eof, 11, 11)])
end subroutine inline_table_modify

subroutine check_parser(error, string, token)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   character(len=*), intent(in) :: string
   type(toml_token), intent(in) :: token(:)

   type(mocked_lexer) :: lexer
   type(toml_error), allocatable :: parse_error
   type(toml_table), allocatable :: table

   call new_lexer(lexer, string, token)

   call parse(lexer, table, config=toml_parser_config(color=.true.), error=parse_error)
   call move_error(error, parse_error)
   if (allocated(error)) return
   call check(error, allocated(table))
end subroutine check_parser

!> Create a new lexer
subroutine new_lexer(lexer, string, token)
   type(mocked_lexer), intent(out) :: lexer
   character(len=*), intent(in) :: string
   type(toml_token), intent(in) :: token(:)

   lexer%filename = "mocked"
   lexer%pos = 0
   lexer%chunk = string
   lexer%token = token
end subroutine new_lexer

subroutine next(lexer, token)
   class(mocked_lexer), intent(inout) :: lexer
   type(toml_token), intent(inout) :: token

   lexer%pos = lexer%pos + 1
   token = lexer%token(lexer%pos)
end subroutine next

subroutine move_error(error, parse_error)
   type(error_type), allocatable, intent(out) :: error
   type(toml_error), intent(in), optional :: parse_error

   if (present(parse_error)) then
      allocate(error)
      error%stat = 1
      error%message = parse_error%message
   end if
end subroutine move_error

end module tftest_parser

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> API export for managing tight-binding parameters and calculators
module tblite_api_calculator
   use, intrinsic :: iso_c_binding
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type
   use tblite_api_container, only : vp_container
   use tblite_api_context, only : vp_context
   use tblite_api_param, only : vp_param
   use tblite_api_result, only : vp_result
   use tblite_api_structure, only : vp_structure
   use tblite_api_version, only : namespace
   use tblite_results, only : results_type
   use tblite_wavefunction_mulliken, only : get_molecular_dipole_moment, &
      & get_molecular_quadrupole_moment
   use tblite_wavefunction, only : wavefunction_type, new_wavefunction, sad_guess, eeq_guess
   use tblite_xtb_calculator, only : xtb_calculator, new_xtb_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator
   use tblite_xtb_gfn1, only : new_gfn1_calculator
   use tblite_xtb_ipea1, only : new_ipea1_calculator
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   implicit none
   private

   public :: vp_calculator, delete_calculator_api
   public :: new_gfn2_calculator_api, new_ipea1_calculator_api, new_gfn1_calculator_api, &
      & new_xtb_calculator_api
   public :: set_calculator_mixer_damping_api, set_calculator_max_iter_api, &
      & set_calculator_accuracy_api, set_calculator_temperature_api, &
      & set_calculator_save_integrals_api
   public :: get_singlepoint_api


   enum, bind(c)
      enumerator :: &
         tblite_guess_sad = 0_c_int, &
         tblite_guess_eeq = 1_c_int
   end enum


   !> Void pointer to calculator type
   type :: vp_calculator
      !> Actual payload
      type(xtb_calculator) :: ptr
      !> Calculation accuracy
      real(wp) :: accuracy = 1.0_wp
      !> Electronic temperature
      real(wp) :: etemp = 300.0_wp * 3.166808578545117e-06_wp
      !> Wavefunction guess
      integer :: guess = tblite_guess_sad
   end type vp_calculator


   logical, parameter :: debug = .false.


contains


function new_gfn2_calculator_api(vctx, vmol) result(vcalc) &
      & bind(C, name=namespace//"new_gfn2_calculator")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr) :: vcalc
   type(vp_calculator), pointer :: calc

   if (debug) print '("[Info]", 1x, a)', "new_gfn2_calculator"

   vcalc = c_null_ptr
   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vmol)) return
   call c_f_pointer(vmol, mol)

   allocate(calc)
   call new_gfn2_calculator(calc%ptr, mol%ptr)
   vcalc = c_loc(calc)

end function new_gfn2_calculator_api


function new_ipea1_calculator_api(vctx, vmol) result(vcalc) &
      & bind(C, name=namespace//"new_ipea1_calculator")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr) :: vcalc
   type(vp_calculator), pointer :: calc

   if (debug) print '("[Info]", 1x, a)', "new_ipea1_calculator"

   vcalc = c_null_ptr
   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vmol)) return
   call c_f_pointer(vmol, mol)

   allocate(calc)
   call new_ipea1_calculator(calc%ptr, mol%ptr)
   vcalc = c_loc(calc)

end function new_ipea1_calculator_api


function new_gfn1_calculator_api(vctx, vmol) result(vcalc) &
      & bind(C, name=namespace//"new_gfn1_calculator")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr) :: vcalc
   type(vp_calculator), pointer :: calc

   if (debug) print '("[Info]", 1x, a)', "new_gfn1_calculator"

   vcalc = c_null_ptr
   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vmol)) return
   call c_f_pointer(vmol, mol)

   allocate(calc)
   call new_gfn1_calculator(calc%ptr, mol%ptr)
   vcalc = c_loc(calc)

end function new_gfn1_calculator_api


function new_xtb_calculator_api(vctx, vmol, vparam) result(vcalc) &
      & bind(C, name=namespace//"new_xtb_calculator")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param
   type(c_ptr) :: vcalc
   type(vp_calculator), pointer :: calc

   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "new_xtb_calculator"

   vcalc = c_null_ptr
   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vmol)) return
   call c_f_pointer(vmol, mol)

   if (.not.c_associated(vparam)) return
   call c_f_pointer(vparam, param)

   allocate(calc)
   call new_xtb_calculator(calc%ptr, mol%ptr, param%ptr, error)
   if (allocated(error)) then
      deallocate(calc)
   else
      vcalc = c_loc(calc)
   end if

end function new_xtb_calculator_api


subroutine delete_calculator_api(vcalc) &
      & bind(C, name=namespace//"delete_calculator")
   type(c_ptr), intent(inout) :: vcalc
   type(vp_calculator), pointer :: calc

   if (debug) print '("[Info]", 1x, a)', "delete_calculator"

   if (c_associated(vcalc)) then
      call c_f_pointer(vcalc, calc)

      deallocate(calc)
      vcalc = c_null_ptr
   end if
end subroutine delete_calculator_api


subroutine set_calculator_mixer_damping_api(vctx, vcalc, damping) &
      & bind(C, name=namespace//"set_calculator_mixer_damping")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   real(c_double), value :: damping
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "set_calculator_mixer_damping"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   calc%ptr%mixer_damping = damping
end subroutine set_calculator_mixer_damping_api


subroutine set_calculator_max_iter_api(vctx, vcalc, max_iter) &
      & bind(C, name=namespace//"set_calculator_max_iter")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), value :: max_iter
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_calculator_max_iter"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   calc%ptr%max_iter = max_iter
end subroutine set_calculator_max_iter_api


subroutine set_calculator_guess_api(vctx, vcalc, guess) &
      & bind(C, name=namespace//"set_calculator_guess")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), value :: guess
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "set_calculator_guess"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   calc%guess = guess
end subroutine set_calculator_guess_api


subroutine set_calculator_accuracy_api(vctx, vcalc, accuracy) &
      & bind(C, name=namespace//"set_calculator_accuracy")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   real(c_double), value :: accuracy
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "set_calculator_accuracy"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   calc%accuracy = accuracy
end subroutine set_calculator_accuracy_api


subroutine set_calculator_temperature_api(vctx, vcalc, etemp) &
      & bind(C, name=namespace//"set_calculator_temperature")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   real(c_double), value :: etemp
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_calculator_temperature"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   calc%etemp = etemp
end subroutine set_calculator_temperature_api


subroutine set_calculator_save_integrals_api(vctx, vcalc, save_integrals) &
      & bind(C, name=namespace//"set_calculator_save_integrals")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), value :: save_integrals
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "set_calculator_save_integrals"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   calc%ptr%save_integrals = save_integrals /= 0
end subroutine set_calculator_save_integrals_api


subroutine get_calculator_shell_count(vctx, vcalc, nsh) &
      & bind(C, name=namespace//"get_calculator_shell_count")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), intent(inout) :: nsh
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_calculator_shell_count"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   associate(sh2at => calc%ptr%bas%sh2at)
      nsh = size(sh2at)
   end associate
end subroutine get_calculator_shell_count

subroutine get_calculator_shell_map(vctx, vcalc, imap) &
      & bind(C, name=namespace//"get_calculator_shell_map")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), intent(inout) :: imap(*)
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_calculator_shell_map"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   associate(sh2at => calc%ptr%bas%sh2at)
      imap(:size(sh2at)) = sh2at - 1_c_int
   end associate
end subroutine get_calculator_shell_map

subroutine get_calculator_orbital_count(vctx, vcalc, nao) &
      & bind(C, name=namespace//"get_calculator_orbital_count")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), intent(inout) :: nao
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_calculator_orbital_count"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   associate(ao2sh => calc%ptr%bas%ao2sh)
      nao = size(ao2sh)
   end associate
end subroutine get_calculator_orbital_count

subroutine get_calculator_orbital_map(vctx, vcalc, imap) &
      & bind(C, name=namespace//"get_calculator_orbital_map")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), intent(inout) :: imap(*)
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_calculator_orbital_map"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   associate(ao2sh => calc%ptr%bas%ao2sh)
      imap(:size(ao2sh)) = ao2sh - 1_c_int
   end associate
end subroutine get_calculator_orbital_map


subroutine get_singlepoint_api(vctx, vmol, vcalc, vres) &
      & bind(C, name=namespace//"get_singlepoint")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_singlepoint"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vmol)) then
      call fatal_error(error, "Molecular structure data is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vmol, mol)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   if (.not.c_associated(vres)) then
      call fatal_error(error, "Result container is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vres, res)

   res%energy = 0.0_wp
   res%gradient = spread([0.0_wp, 0.0_wp, 0.0_wp], 2, mol%ptr%nat)
   res%sigma = spread([0.0_wp, 0.0_wp, 0.0_wp], 2, 3)
   res%dipole = spread(0.0_wp, 1, 3)
   res%quadrupole = spread(0.0_wp, 1, 6)
   res%results = results_type()
   call check_wavefunction(res%wfn, mol%ptr, calc%ptr, calc%etemp, calc%guess)

   call xtb_singlepoint(ctx%ptr, mol%ptr, calc%ptr, res%wfn, calc%accuracy, res%energy, &
      & res%gradient, res%sigma, results=res%results)

   call get_molecular_dipole_moment(mol%ptr, res%wfn%qat(:, 1), res%wfn%dpat(:, :, 1), &
      & res%dipole)
   call get_molecular_quadrupole_moment(mol%ptr, res%wfn%qat(:, 1), res%wfn%dpat(:, :, 1), &
      & res%wfn%qpat(:, :, 1), res%quadrupole)

end subroutine get_singlepoint_api


subroutine push_back_api(vctx, vcalc, vcont) &
      & bind(C, name=namespace//"calculator_push_back")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   type(c_ptr), intent(inout) :: vcont
   type(vp_container), pointer :: cont

   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "calculator_push_back"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   if (.not.c_associated(vcont)) then
      call fatal_error(error, "Molecular structure data is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcont, cont)

   call calc%ptr%push_back(cont%ptr)

   deallocate(cont)
   vcont = c_null_ptr
end subroutine push_back_api


subroutine check_wavefunction(wfn, mol, calc, etemp, guess)
   type(wavefunction_type), allocatable, intent(inout) :: wfn
   type(structure_type), intent(in) :: mol
   type(xtb_calculator), intent(in) :: calc
   real(wp), intent(in) :: etemp
   integer, intent(in) :: guess

   integer, parameter :: nspin = 1

   if (allocated(wfn)) then
      wfn%kt = etemp

      if (size(wfn%qat) /= mol%nat .or. size(wfn%emo) /= calc%bas%nao &
         & .or. size(wfn%qsh) /= calc%bas%nsh) then
         deallocate(wfn)
      end if
   end if

   if (.not.allocated(wfn)) then
      allocate(wfn)
      call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, nspin, etemp)

      select case(guess)
      case default
         call sad_guess(mol, calc, wfn)
      case(tblite_guess_eeq)
         call eeq_guess(mol, calc, wfn)
      end select
   end if
end subroutine check_wavefunction


end module tblite_api_calculator

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the driver entry points for the singlepoint runner
module tblite_driver_run
   use, intrinsic :: iso_fortran_env, only : output_unit, error_unit, input_unit
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_io, only : structure_type, read_structure, filetype
   use mctc_io_constants, only : codata
   use mctc_io_convert, only : aatoau, ctoau
   use tblite_cli, only : run_config
   use tblite_basis_type, only : basis_type
   use tblite_container, only : container_type
   use tblite_context, only : context_type, context_terminal, escape
   use tblite_data_spin, only : get_spin_constant
   use tblite_external_field, only : electric_field
   use tblite_output_ascii
   use tblite_param, only : param_record
   use tblite_results, only : results_type
   use tblite_spin, only : spin_polarization, new_spin_polarization
   use tblite_solvation, only : new_solvation, solvation_type
   use tblite_wavefunction, only : wavefunction_type, new_wavefunction, sad_guess, eeq_guess
   use tblite_xtb_calculator, only : xtb_calculator, new_xtb_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator, export_gfn2_param
   use tblite_xtb_gfn1, only : new_gfn1_calculator, export_gfn1_param
   use tblite_xtb_ipea1, only : new_ipea1_calculator, export_ipea1_param
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   implicit none
   private

   public :: main

   interface main
      module procedure :: run_main
   end interface

   real(wp), parameter :: kt = 3.166808578545117e-06_wp
   real(wp), parameter :: jtoau = 1.0_wp / (codata%me*codata%c**2*codata%alpha**2)
   !> Convert V/Å = J/(C·Å) to atomic units
   real(wp), parameter :: vatoau = jtoau / (ctoau * aatoau)

contains


subroutine run_main(config, error)
   type(run_config), intent(in) :: config
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   character(len=:), allocatable :: method
   integer :: spin, charge, stat, unit, nspin
   logical :: exist
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   type(param_record) :: param
   type(context_type) :: ctx
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(results_type) :: results

   ctx%terminal = context_terminal(config%color)

   if (config%input == "-") then
      if (allocated(config%input_format)) then
         call read_structure(mol, input_unit, config%input_format, error)
      else
         call read_structure(mol, input_unit, filetype%xyz, error)
      end if
   else
      call read_structure(mol, config%input, error, config%input_format)
   end if
   if (allocated(error)) return

   if (allocated(config%charge)) then
      mol%charge = config%charge
   else
      inquire(file='.CHRG', exist=exist)
      if (exist) then
         open(file='.CHRG', newunit=unit)
         read(unit, *, iostat=stat) charge
         if (stat == 0) then
            mol%charge = charge
            if (config%verbosity > 0) call info(ctx, "Molecular charge read from .CHRG")
         else
            if (config%verbosity > 0) call warn(ctx, &
               "Could not read molecular charge read from .CHRG")
         end if
         close(unit)
      end if
   end if

   if (allocated(config%spin)) then
      mol%uhf = config%spin
   else
      inquire(file='.UHF', exist=exist)
      if (exist) then
         open(file='.UHF', newunit=unit)
         read(unit, *, iostat=stat) spin
         if (stat == 0) then
            mol%uhf = spin
            if (config%verbosity > 0) call info(ctx, "Molecular spin read from .UHF")
         else
            if (config%verbosity > 0) &
               call warn(ctx, "Could not read molecular spin read from .UHF")
         end if
         close(unit)
      end if
   end if

   nspin = merge(2, 1, config%spin_polarized)

   if (config%grad) then
      allocate(gradient(3, mol%nat), sigma(3, 3))
   end if

   if (allocated(config%param)) then
      call param%load(config%param, error)
      if (.not. allocated(error)) then
         call new_xtb_calculator(calc, mol, param, error)
      end if
   else
      method = "gfn2"
      if (allocated(config%method)) method = config%method
      select case(method)
      case default
         call fatal_error(error, "Unknown method '"//method//"' requested")
      case("gfn2")
         call new_gfn2_calculator(calc, mol)
      case("gfn1")
         call new_gfn1_calculator(calc, mol)
      case("ipea1")
         call new_ipea1_calculator(calc, mol)
      end select
   end if
   if (allocated(error)) return

   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, nspin, config%etemp * kt)

   select case(config%guess)
   case default
      call fatal_error(error, "Unknown starting guess '"//config%guess//"' requested")
   case("sad")
      call sad_guess(mol, calc, wfn)
   case("eeq")
      call eeq_guess(mol, calc, wfn)
   end select
   if (allocated(error)) return

   if (allocated(config%efield)) then
      block
         class(container_type), allocatable :: cont
         cont = electric_field(config%efield*vatoau)
         call calc%push_back(cont)
      end block
   end if

   if (config%spin_polarized) then
      block
         class(container_type), allocatable :: cont
         type(spin_polarization), allocatable :: spin
         real(wp), allocatable :: wll(:, :, :)
         allocate(spin)
         call get_spin_constants(wll, mol, calc%bas)
         call new_spin_polarization(spin, mol, wll, calc%bas%nsh_id)
         call move_alloc(spin, cont)
         call calc%push_back(cont)
      end block
   end if

   if (allocated(config%solvation)) then
      block
         class(container_type), allocatable :: cont
         class(solvation_type), allocatable :: solv
         call new_solvation(solv, mol, config%solvation, error)
         if (allocated(error)) return
         call move_alloc(solv, cont)
         call calc%push_back(cont)
      end block
   end if

   if (config%verbosity > 0) then
      call ctx%message(calc%info(config%verbosity, " | "))
      call ctx%message("")
   end if

   call xtb_singlepoint(ctx, mol, calc, wfn, config%accuracy, energy, gradient, sigma, &
      & config%verbosity, results)
   if (ctx%failed()) then
      call fatal(ctx, "Singlepoint calculation failed")
      do while(ctx%failed())
         call ctx%get_error(error)
         write(error_unit, '("->", 1x, a)') error%message
      end do
      error stop
   end if

   if (config%verbosity > 2) then
      call ascii_levels(ctx%unit, config%verbosity, wfn%homo, wfn%emo, wfn%focc, 7)
   end if

   if (allocated(config%grad_output)) then
      open(file=config%grad_output, newunit=unit)
      call tagged_result(unit, energy, gradient, sigma, energies=results%energies)
      close(unit)
      if (config%verbosity > 0) then
         call info(ctx, "Tight-binding results written to '"//config%grad_output//"'")
      end if
   end if

   if (config%json) then
      open(file=config%json_output, newunit=unit)
      call json_results(unit, "  ", energy=energy, gradient=gradient, sigma=sigma, &
         & energies=results%energies)
      close(unit)
      if (config%verbosity > 0) then
         call info(ctx, "JSON dump of results written to '"//config%json_output//"'")
      end if
   end if
end subroutine run_main


subroutine info(ctx, message)
   type(context_type), intent(inout) :: ctx
   character(len=*), intent(in) :: message

   call ctx%message( &
      & escape(ctx%terminal%bold) // "[" // &
      & escape(ctx%terminal%bold_cyan) // "Info" // &
      & escape(ctx%terminal%bold) // "]" // &
      & escape(ctx%terminal%reset) // " " // &
      & message)
end subroutine info


subroutine warn(ctx, message)
   type(context_type), intent(inout) :: ctx
   character(len=*), intent(in) :: message

   call ctx%message( &
      & escape(ctx%terminal%bold) // "[" // &
      & escape(ctx%terminal%bold_yellow) // "Warn" // &
      & escape(ctx%terminal%bold) // "]" // &
      & escape(ctx%terminal%reset) // " " // &
      & message)
end subroutine warn


subroutine fatal(ctx, message)
   type(context_type), intent(inout) :: ctx
   character(len=*), intent(in) :: message

   call ctx%message( &
      & escape(ctx%terminal%bold) // "[" // &
      & escape(ctx%terminal%bold_red) // "Fatal" // &
      & escape(ctx%terminal%bold) // "]" // &
      & escape(ctx%terminal%reset) // " " // &
      & message)
end subroutine fatal


subroutine get_spin_constants(wll, mol, bas)
   real(wp), allocatable, intent(out) :: wll(:, :, :)
   type(structure_type), intent(in) :: mol
   type(basis_type), intent(in) :: bas

   integer :: izp, ish, jsh, il, jl

   allocate(wll(bas%nsh, bas%nsh, mol%nid), source=0.0_wp)

   do izp = 1, mol%nid
      do ish = 1, bas%nsh_id(izp)
         il = bas%cgto(ish, izp)%ang
         do jsh = 1, bas%nsh_id(izp)
            jl = bas%cgto(jsh, izp)%ang
            wll(jsh, ish, izp) = get_spin_constant(jl, il, mol%num(izp))
         end do
      end do
   end do
end subroutine get_spin_constants

end module tblite_driver_run

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Element specific data for solvation models
module tblite_solvation_data
   use mctc_env, only : wp
   use mctc_io, only : to_number
   use mctc_io_convert, only : aatoau
   implicit none
   private

   public :: get_vdw_rad_d3, get_vdw_rad_cosmo, get_vdw_rad_bondi
   public :: get_solvent_data, solvent_data


   type :: solvent_data
      real(wp) :: eps
      real(wp) :: n
      real(wp) :: alpha
      real(wp) :: beta
      real(wp) :: gamma
      real(wp) :: phi2
      real(wp) :: psi2
   end type solvent_data

   interface solvent_data
      module procedure get_solvent_data
   end interface solvent_data


   !> Get D3 van-der-Waals radius for a species
   interface get_vdw_rad_d3
      module procedure :: get_vdw_rad_d3_sym
      module procedure :: get_vdw_rad_d3_num
   end interface get_vdw_rad_d3

   !> Get COSMO van-der-Waals radius for a species
   interface get_vdw_rad_cosmo
      module procedure :: get_vdw_rad_cosmo_sym
      module procedure :: get_vdw_rad_cosmo_num
   end interface get_vdw_rad_cosmo

   !> Get Bondi van-der-Waals radius for a species
   interface get_vdw_rad_bondi
      module procedure :: get_vdw_rad_bondi_sym
      module procedure :: get_vdw_rad_bondi_num
   end interface get_vdw_rad_bondi


   !> In case no van-der-Waals value is provided
   real(wp), parameter :: missing = -1.0_wp

   !> D3 pairwise van-der-Waals radii (only homoatomic pairs present here)
   real(wp), parameter :: vdw_rad_d3(1:94) = aatoau * [&
      & 1.09155_wp, 0.86735_wp, 1.74780_wp, 1.54910_wp, &  ! H-Be
      & 1.60800_wp, 1.45515_wp, 1.31125_wp, 1.24085_wp, &  ! B-O
      & 1.14980_wp, 1.06870_wp, 1.85410_wp, 1.74195_wp, &  ! F-Mg
      & 2.00530_wp, 1.89585_wp, 1.75085_wp, 1.65535_wp, &  ! Al-S
      & 1.55230_wp, 1.45740_wp, 2.12055_wp, 2.05175_wp, &  ! Cl-Ca
      & 1.94515_wp, 1.88210_wp, 1.86055_wp, 1.72070_wp, &  ! Sc-Cr
      & 1.77310_wp, 1.72105_wp, 1.71635_wp, 1.67310_wp, &  ! Mn-Ni
      & 1.65040_wp, 1.61545_wp, 1.97895_wp, 1.93095_wp, &  ! Cu-Ge
      & 1.83125_wp, 1.76340_wp, 1.68310_wp, 1.60480_wp, &  ! As-Kr
      & 2.30880_wp, 2.23820_wp, 2.10980_wp, 2.02985_wp, &  ! Rb-Zr
      & 1.92980_wp, 1.87715_wp, 1.78450_wp, 1.73115_wp, &  ! Nb-Ru
      & 1.69875_wp, 1.67625_wp, 1.66540_wp, 1.73100_wp, &  ! Rh-Cd
      & 2.13115_wp, 2.09370_wp, 2.00750_wp, 1.94505_wp, &  ! In-Te
      & 1.86900_wp, 1.79445_wp, 2.52835_wp, 2.59070_wp, &  ! I-Ba
      & 2.31305_wp, 2.31005_wp, 2.28510_wp, 2.26355_wp, &  ! La-Nd
      & 2.24480_wp, 2.22575_wp, 2.21170_wp, 2.06215_wp, &  ! Pm-Gd
      & 2.12135_wp, 2.07705_wp, 2.13970_wp, 2.12250_wp, &  ! Tb-Er
      & 2.11040_wp, 2.09930_wp, 2.00650_wp, 2.12250_wp, &  ! Tm-Hf
      & 2.04900_wp, 1.99275_wp, 1.94775_wp, 1.87450_wp, &  ! Ta-Os
      & 1.72280_wp, 1.67625_wp, 1.62820_wp, 1.67995_wp, &  ! Ir-Hg
      & 2.15635_wp, 2.13820_wp, 2.05875_wp, 2.00270_wp, &  ! Tl-Po
      & 1.93220_wp, 1.86080_wp, 2.53980_wp, 2.46470_wp, &  ! At-Ra
      & 2.35215_wp, 2.21260_wp, 2.22970_wp, 2.19785_wp, &  ! Ac-U
      & 2.17695_wp, 2.21705_wp]                            ! Np-Pu


   !> Default value for unoptimized van-der-Waals radii
   real(wp), parameter :: cosmostub = 2.223_wp

   !> COSMO optimized van-der-Waals radii
   real(wp), parameter :: vdw_rad_cosmo(1:94) = aatoau * [ &
      & 1.3000_wp, 1.6380_wp, 1.5700_wp, 1.0530_wp, &   ! H-Be
      & 2.0480_wp, 2.0000_wp, 1.8300_wp, 1.7200_wp, &   ! B-O
      & 1.7200_wp, 1.8018_wp, 1.8000_wp, 1.6380_wp, &   ! F-Mg
      & 2.1530_wp, 2.2000_wp, 2.1060_wp, 2.1600_wp, &   ! Al-S
      & 2.0500_wp, 2.2000_wp, 2.2230_wp, cosmostub, &   ! Cl-Ca
      & cosmostub, 2.2930_wp, cosmostub, cosmostub, &   ! Sc-Cr
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Mn-Ni
      & cosmostub, 1.6260_wp, cosmostub, 2.7000_wp, &   ! Cu-Ge
      & 2.3500_wp, 2.2000_wp, 2.1600_wp, 2.3630_wp, &   ! As-Kr
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Rb-Zr
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Nb-Ru
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Rh-Cd
      & 2.2580_wp, 2.5500_wp, 2.4100_wp, 2.4100_wp, &   ! In-Te
      & 2.3200_wp, 2.5270_wp, cosmostub, cosmostub, &   ! I-Ba
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! La-Nd
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Pm-Gd
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Tb-Er
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Tm-Hf
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Ta-Os
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Ir-Hg
      & cosmostub, 2.3600_wp, 2.4220_wp, 2.3050_wp, &   ! Tl-Po
      & 2.3630_wp, 2.5740_wp, cosmostub, cosmostub, &   ! At-Ra
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Ac-U
      & cosmostub, cosmostub]                           ! Np-Pu

   !> Van-der-Waals radii from
   !> Manjeera Mantina, Adam C. Chamberlin, Rosendo Valero, Christopher J. Cramer,
   !> and Donald G. Truhlar, Consistent van der Waals Radii for the Whole Main Group,
   !> J. Phys. Chem. A 2009, 113, 19, 5806–5812. https://doi.org/10.1021/jp8111556
   real(wp), parameter :: vdw_rad_bondi(1:88) = aatoau * [ &
      & 1.10_wp, 1.40_wp, 1.81_wp, 1.53_wp, 1.92_wp, 1.70_wp, 1.55_wp, 1.52_wp, &  ! H-O
      & 1.47_wp, 1.54_wp, 2.27_wp, 1.73_wp, 1.84_wp, 2.10_wp, 1.80_wp, 1.80_wp, &  ! F-S
      & 1.75_wp, 1.88_wp, 2.75_wp, 2.31_wp, missing, missing, missing, missing, &  ! Cl-Cr
      & missing, missing, missing, missing, missing, missing, 1.87_wp, 2.11_wp, &  ! Mn-Ge
      & 1.85_wp, 1.90_wp, 1.83_wp, 2.02_wp, 3.03_wp, 2.49_wp, missing, missing, &  ! As-Zr
      & missing, missing, missing, missing, missing, missing, missing, missing, &  ! Nb-Cd
      & 1.93_wp, 2.17_wp, 2.06_wp, 2.06_wp, 1.98_wp, 2.16_wp, 3.43_wp, 2.68_wp, &  ! I-Ba
      & missing, missing, missing, missing, missing, missing, missing, missing, &  ! La-Gd
      & missing, missing, missing, missing, missing, missing, missing, missing, &  ! Tb-Hf
      & missing, missing, missing, missing, missing, missing, missing, missing, &  ! Ta-Hg
      & 1.96_wp, 2.02_wp, 2.07_wp, 1.97_wp, 2.02_wp, 2.20_wp, 3.48_wp, 2.83_wp]    ! Tl-Ra


contains


!> Get van-der-Waals radius for species with a given symbol
elemental function get_vdw_rad_d3_sym(symbol) result(radius)
   !> Element symbol
   character(len=*), intent(in) :: symbol
   !> van-der-Waals radius
   real(wp) :: radius

   radius = get_vdw_rad_d3(to_number(symbol))

end function get_vdw_rad_d3_sym


!> Get van-der-Waals radius for species with a given atomic number
elemental function get_vdw_rad_d3_num(number) result(radius)
   !> Atomic number
   integer, intent(in) :: number
   !> van-der-Waals radius
   real(wp) :: radius

   if (number > 0 .and. number <= size(vdw_rad_d3, dim=1)) then
      radius = vdw_rad_d3(number)
   else
      radius = missing
   end if

end function get_vdw_rad_d3_num


!> Get van-der-Waals radius for species with a given symbol
elemental function get_vdw_rad_cosmo_sym(symbol) result(radius)
   !> Element symbol
   character(len=*), intent(in) :: symbol
   !> van-der-Waals radius
   real(wp) :: radius

   radius = get_vdw_rad_cosmo(to_number(symbol))

end function get_vdw_rad_cosmo_sym


!> Get van-der-Waals radius for species with a given atomic number
elemental function get_vdw_rad_cosmo_num(number) result(radius)
   !> Atomic number
   integer, intent(in) :: number
   !> van-der-Waals radius
   real(wp) :: radius

   if (number > 0 .and. number <= size(vdw_rad_cosmo, dim=1)) then
      radius = vdw_rad_cosmo(number)
   else
      radius = missing
   end if

end function get_vdw_rad_cosmo_num


!> Get van-der-Waals radius for species with a given symbol
elemental function get_vdw_rad_bondi_sym(symbol) result(radius)
   !> Element symbol
   character(len=*), intent(in) :: symbol
   !> van-der-Waals radius
   real(wp) :: radius

   radius = get_vdw_rad_bondi(to_number(symbol))

end function get_vdw_rad_bondi_sym


!> Get van-der-Waals radius for species with a given atomic number
elemental function get_vdw_rad_bondi_num(number) result(radius)
   !> Atomic number
   integer, intent(in) :: number
   !> van-der-Waals radius
   real(wp) :: radius

   if (number > 0 .and. number <= size(vdw_rad_bondi, dim=1)) then
      radius = vdw_rad_bondi(number)
   else
      radius = missing
   end if

end function get_vdw_rad_bondi_num


!> Get solvent parameters, in case the solvent is not known the ideal conductor is assumed
pure function get_solvent_data(solvent) result(data)
   !> Name of solvent
   character(len=*), intent(in) :: solvent
   !> Solvent data
   type(solvent_data) :: data

   select case(compact(solvent))
   case default
      data = solvent_data(-1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp)
   case("inf")
      data = solvent_data(huge(1.0_wp), 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp)
   case("2methylpyridine")
      data = solvent_data(9.9533_wp, 1.4957_wp, 0.0_wp, 0.58_wp, 47.5_wp, 0.509796_wp, 0.0_wp)
   case("4methyl2pentanone")
      data = solvent_data(12.8871_wp, 1.3962_wp, 0.0_wp, 0.51_wp, 33.83_wp, 0.0_wp, 0.0_wp)
   case("aceticacid")
      data = solvent_data(6.2528_wp, 1.372_wp, 0.61_wp, 0.44_wp, 39.01_wp, 0.0_wp, 0.0_wp)
   case("acetonitrile")
      data = solvent_data(35.6881_wp, 1.3442_wp, 0.07_wp, 0.32_wp, 41.25_wp, 0.0_wp, 0.0_wp)
   case("acetophenone")
      data = solvent_data(17.44_wp, 1.5372_wp, 0.0_wp, 0.48_wp, 56.19_wp, 0.444889_wp, 0.0_wp)
   case("aniline")
      data = solvent_data(6.8882_wp, 1.5863_wp, 0.26_wp, 0.41_wp, 60.62_wp, 0.734449_wp, 0.0_wp)
   case("anisole")
      data = solvent_data(4.2247_wp, 1.5174_wp, 0.0_wp, 0.29_wp, 50.52_wp, 0.5625_wp, 0.0_wp)
   case("benzene")
      data = solvent_data(2.2706_wp, 1.5011_wp, 0.0_wp, 0.14_wp, 40.62_wp, 1_wp, 0.0_wp)
   case("benzonitrile")
      data = solvent_data(25.592_wp, 1.5289_wp, 0.0_wp, 0.33_wp, 55.83_wp, 0.5625_wp, 0.0_wp)
   case("benzylalcohol")
      data = solvent_data(12.4569_wp, 1.5396_wp, 0.33_wp, 0.56_wp, 52.96_wp, 0.5625_wp, 0.0_wp)
   case("bromobenzene")
      data = solvent_data(5.3954_wp, 1.5597_wp, 0.0_wp, 0.09_wp, 50.72_wp, 0.734449_wp, 0.020449_wp)
   case("bromoethane")
      data = solvent_data(9.01_wp, 1.4239_wp, 0.0_wp, 0.12_wp, 34_wp, 0.0_wp, 0.110889_wp)
   case("bromoform")
      data = solvent_data(4.2488_wp, 1.6005_wp, 0.15_wp, 0.06_wp, 64.58_wp, 0.0_wp, 0.5625_wp)
   case("bromooctane")
      data = solvent_data(5.0244_wp, 1.4524_wp, 0.0_wp, 0.12_wp, 41.28_wp, 0.0_wp, 0.0121_wp)
   case("butanol")
      data = solvent_data(17.3323_wp, 1.3993_wp, 0.37_wp, 0.48_wp, 35.88_wp, 0.0_wp, 0.0_wp)
   case("butanone")
      data = solvent_data(18.2457_wp, 1.3788_wp, 0.0_wp, 0.51_wp, 34.5_wp, 0.0_wp, 0.0_wp)
   case("butylacetate")
      data = solvent_data(4.9941_wp, 1.3941_wp, 0.0_wp, 0.45_wp, 35.81_wp, 0.0_wp, 0.0_wp)
   case("butylbenzene")
      data = solvent_data(2.36_wp, 1.4898_wp, 0.0_wp, 0.15_wp, 41.33_wp, 0.36_wp, 0.0_wp)
   case("carbondisulfide")
      data = solvent_data(2.6105_wp, 1.6319_wp, 0.0_wp, 0.07_wp, 45.45_wp, 0.0_wp, 0.0_wp)
   case("carbontet")
      data = solvent_data(2.228_wp, 1.4601_wp, 0.0_wp, 0.0_wp, 38.04_wp, 0.0_wp, 0.64_wp)
   case("chlorobenzene")
      data = solvent_data(5.6968_wp, 1.5241_wp, 0.0_wp, 0.07_wp, 47.48_wp, 0.734449_wp, 0.020449_wp)
   case("chloroform")
      data = solvent_data(4.7113_wp, 1.4459_wp, 0.15_wp, 0.02_wp, 38.39_wp, 0.0_wp, 0.5625_wp)
   case("chlorohexane")
      data = solvent_data(5.9491_wp, 1.4199_wp, 0.0_wp, 0.1_wp, 37.03_wp, 0.0_wp, 0.020449_wp)
   case("cyclohexane")
      data = solvent_data(2.0165_wp, 1.4266_wp, 0.0_wp, 0.0_wp, 35.48_wp, 0.0_wp, 0.0_wp)
   case("cyclohexanone")
      data = solvent_data(15.6186_wp, 1.4507_wp, 0.0_wp, 0.56_wp, 49.76_wp, 0.0_wp, 0.0_wp)
   case("decalin")
      data = solvent_data(2.196_wp, 1.4528_wp, 0.0_wp, 0.0_wp, 43.82_wp, 0.0_wp, 0.0_wp)
   case("decane")
      data = solvent_data(1.9846_wp, 1.4102_wp, 0.0_wp, 0.0_wp, 33.64_wp, 0.0_wp, 0.0_wp)
   case("decanol")
      data = solvent_data(7.5305_wp, 1.4372_wp, 0.37_wp, 0.48_wp, 41.04_wp, 0.0_wp, 0.0_wp)
   case("dibromoethane")
      data = solvent_data(4.9313_wp, 1.5387_wp, 0.1_wp, 0.17_wp, 56.93_wp, 0.0_wp, 0.25_wp)
   case("dibutylether")
      data = solvent_data(3.0473_wp, 1.3992_wp, 0.0_wp, 0.45_wp, 35.98_wp, 0.0_wp, 0.0_wp)
   case("dichloroethane")
      data = solvent_data(10.125_wp, 1.4448_wp, 0.1_wp, 0.11_wp, 45.86_wp, 0.0_wp, 0.25_wp)
   case("diethylether")
      data = solvent_data(4.24_wp, 1.3526_wp, 0.0_wp, 0.41_wp, 23.96_wp, 0.0_wp, 0.0_wp)
   case("diisopropylether")
      data = solvent_data(3.38_wp, 1.3679_wp, 0.0_wp, 0.41_wp, 24.86_wp, 0.0_wp, 0.0_wp)
   case("dimethylacetamide")
      data = solvent_data(37.7807_wp, 1.438_wp, 0.0_wp, 0.78_wp, 47.62_wp, 0.0_wp, 0.0_wp)
   case("dimethylformamide")
      data = solvent_data(37.219_wp, 1.4305_wp, 0.0_wp, 0.74_wp, 49.56_wp, 0.0_wp, 0.0_wp)
   case("dimethylpyridine")
      data = solvent_data(7.1735_wp, 1.4953_wp, 0.0_wp, 0.63_wp, 44.64_wp, 0.390625_wp, 0.0_wp)
   case("dimethylsulfoxide")
      data = solvent_data(46.826_wp, 1.417_wp, 0.0_wp, 0.88_wp, 61.78_wp, 0.0_wp, 0.0_wp)
   case("dodecane")
      data = solvent_data(2.006_wp, 1.4216_wp, 0.0_wp, 0.0_wp, 35.85_wp, 0.0_wp, 0.0_wp)
   case("ethanol")
      data = solvent_data(24.852_wp, 1.3611_wp, 0.37_wp, 0.48_wp, 31.62_wp, 0.0_wp, 0.0_wp)
   case("ethoxybenzene")
      data = solvent_data(4.1797_wp, 1.5076_wp, 0.0_wp, 0.32_wp, 46.65_wp, 0.444889_wp, 0.0_wp)
   case("ethylacetate")
      data = solvent_data(5.9867_wp, 1.3723_wp, 0.0_wp, 0.45_wp, 33.67_wp, 0.0_wp, 0.0_wp)
   case("ethylbenzene")
      data = solvent_data(2.4339_wp, 1.4959_wp, 0.0_wp, 0.15_wp, 41.38_wp, 0.5625_wp, 0.0_wp)
   case("fluorobenzene")
      data = solvent_data(5.42_wp, 1.4684_wp, 0.0_wp, 0.1_wp, 38.37_wp, 0.734449_wp, 0.020449_wp)
   case("fluoroctane")
      data = solvent_data(3.89_wp, 1.3935_wp, 0.0_wp, 0.1_wp, 33.92_wp, 0.0_wp, 0.012321_wp)
   case("heptane")
      data = solvent_data(1.9113_wp, 1.3878_wp, 0.0_wp, 0.0_wp, 28.28_wp, 0.0_wp, 0.0_wp)
   case("heptanol")
      data = solvent_data(11.321_wp, 1.4249_wp, 0.37_wp, 0.48_wp, 38.5_wp, 0.0_wp, 0.0_wp)
   case("hexadecane")
      data = solvent_data(2.0402_wp, 1.4345_wp, 0.0_wp, 0.0_wp, 38.93_wp, 0.0_wp, 0.0_wp)
   case("hexadecyliodide")
      data = solvent_data(3.5338_wp, 1.4806_wp, 0.0_wp, 0.15_wp, 46.48_wp, 0.0_wp, 0.0_wp)
   case("hexane")
      data = solvent_data(1.8819_wp, 1.3749_wp, 0.0_wp, 0.0_wp, 25.7495_wp, 0.0_wp, 0.0_wp)
   case("hexanol")
      data = solvent_data(12.5102_wp, 1.4178_wp, 0.37_wp, 0.48_wp, 37.15_wp, 0.0_wp, 0.0_wp)
   case("iodobenzene")
      data = solvent_data(4.547_wp, 1.62_wp, 0.0_wp, 0.12_wp, 55.72_wp, 0.734449_wp, 0.0_wp)
   case("isobutanol")
      data = solvent_data(16.7766_wp, 1.3955_wp, 0.37_wp, 0.48_wp, 32.38_wp, 0.0_wp, 0.0_wp)
   case("isooctane")
      data = solvent_data(1.9358_wp, 1.3915_wp, 0.0_wp, 0.0_wp, 26.38_wp, 0.0_wp, 0.0_wp)
   case("isopropanol")
      data = solvent_data(19.2645_wp, 1.3776_wp, 0.33_wp, 0.56_wp, 30.13_wp, 0.0_wp, 0.0_wp)
   case("isopropylbenzene")
      data = solvent_data(2.3712_wp, 1.4915_wp, 0.0_wp, 0.16_wp, 39.85_wp, 0.444889_wp, 0.0_wp)
   case("mcresol")
      data = solvent_data(12.44_wp, 1.5438_wp, 0.57_wp, 0.34_wp, 51.37_wp, 0.5625_wp, 0.0_wp)
   case("mesitylene")
      data = solvent_data(2.265_wp, 1.4994_wp, 0.0_wp, 0.19_wp, 39.65_wp, 0.444889_wp, 0.0_wp)
   case("methanol")
      data = solvent_data(32.613_wp, 1.3288_wp, 0.43_wp, 0.47_wp, 31.77_wp, 0.0_wp, 0.0_wp)
   case("methoxyethanol")
      data = solvent_data(17.2_wp, 1.4024_wp, 0.3_wp, 0.84_wp, 44.39_wp, 0.0_wp, 0.0_wp)
   case("methylenechloride")
      data = solvent_data(8.93_wp, 1.4242_wp, 0.1_wp, 0.05_wp, 39.15_wp, 0.0_wp, 0.444889_wp)
   case("methylformamide")
      data = solvent_data(181.5619_wp, 1.4319_wp, 0.4_wp, 0.55_wp, 55.4372_wp, 0.0_wp, 0.0_wp)
   case("nitrobenzene")
      data = solvent_data(34.8091_wp, 1.5562_wp, 0.0_wp, 0.28_wp, 57.54_wp, 0.444889_wp, 0.0_wp)
   case("nitroethane")
      data = solvent_data(28.2896_wp, 1.3917_wp, 0.02_wp, 0.33_wp, 46.25_wp, 0.0_wp, 0.0_wp)
   case("nitromethane")
      data = solvent_data(36.5623_wp, 1.3817_wp, 0.06_wp, 0.31_wp, 52.58_wp, 0.0_wp, 0.0_wp)
   case("nonane")
      data = solvent_data(1.9605_wp, 1.4054_wp, 0.0_wp, 0.0_wp, 32.21_wp, 0.0_wp, 0.0_wp)
   case("nonanol")
      data = solvent_data(8.5991_wp, 1.4333_wp, 0.37_wp, 0.48_wp, 40.14_wp, 0.0_wp, 0.0_wp)
   case("octane")
      data = solvent_data(1.9406_wp, 1.3974_wp, 0.0_wp, 0.0_wp, 30.4273_wp, 0.0_wp, 0.0_wp)
   case("octanol")
      data = solvent_data(9.8629_wp, 1.4295_wp, 0.37_wp, 0.48_wp, 39.01_wp, 0.0_wp, 0.0_wp)
   case("odichlorobenzene")
      data = solvent_data(9.9949_wp, 1.5515_wp, 0.0_wp, 0.04_wp, 52.72_wp, 0.5625_wp, 0.0625_wp)
   case("onitrotoluene")
      data = solvent_data(25.6692_wp, 1.545_wp, 0.0_wp, 0.27_wp, 59.12_wp, 0.36_wp, 0.0_wp)
   case("pentadecane")
      data = solvent_data(2.0333_wp, 1.4315_wp, 0.0_wp, 0.0_wp, 38.34_wp, 0.0_wp, 0.0_wp)
   case("pentane")
      data = solvent_data(1.8371_wp, 1.3575_wp, 0.0_wp, 0.0_wp, 22.3_wp, 0.0_wp, 0.0_wp)
   case("pentanol")
      data = solvent_data(15.13_wp, 1.4101_wp, 0.37_wp, 0.48_wp, 36.5_wp, 0.0_wp, 0.0_wp)
   case("perfluorobenzene")
      data = solvent_data(2.029_wp, 1.3777_wp, 0.0_wp, 0.0_wp, 31.74_wp, 0.25_wp, 0.25_wp)
   case("phenylether")
      data = solvent_data(3.73_wp, 1.5787_wp, 0.0_wp, 0.2_wp, 38.5_wp, 0.851929_wp, 0.0_wp)
   case("propanol")
      data = solvent_data(20.5237_wp, 1.385_wp, 0.37_wp, 0.48_wp, 33.57_wp, 0.0_wp, 0.0_wp)
   case("pyridine")
      data = solvent_data(12.9776_wp, 1.5095_wp, 0.0_wp, 0.52_wp, 52.62_wp, 0.693889_wp, 0.0_wp)
   case("secbutanol")
      data = solvent_data(15.9436_wp, 1.3978_wp, 0.33_wp, 0.56_wp, 32.44_wp, 0.0_wp, 0.0_wp)
   case("secbutylbenzene")
      data = solvent_data(2.3446_wp, 1.4895_wp, 0.0_wp, 0.16_wp, 40.35_wp, 0.36_wp, 0.0_wp)
   case("tbutylbenzene")
      data = solvent_data(2.3447_wp, 1.4927_wp, 0.0_wp, 0.16_wp, 39.78_wp, 0.36_wp, 0.0_wp)
   case("tetrachloroethene")
      data = solvent_data(2.268_wp, 1.5053_wp, 0.0_wp, 0.0_wp, 45.19_wp, 0.0_wp, 0.444889_wp)
   case("tetrahydrofuran")
      data = solvent_data(7.4257_wp, 1.405_wp, 0.0_wp, 0.48_wp, 39.44_wp, 0.0_wp, 0.0_wp)
   case("tetrahydrothiophenedioxide")
      data = solvent_data(43.9622_wp, 1.4833_wp, 0.0_wp, 0.88_wp, 87.49_wp, 0.0_wp, 0.0_wp)
   case("tetralin")
      data = solvent_data(2.771_wp, 1.5413_wp, 0.0_wp, 0.19_wp, 47.74_wp, 0.36_wp, 0.0_wp)
   case("toluene")
      data = solvent_data(2.3741_wp, 1.4961_wp, 0.0_wp, 0.14_wp, 40.2_wp, 0.734449_wp, 0.0_wp)
   case("tributylphosphate")
      data = solvent_data(8.1781_wp, 1.4224_wp, 0.0_wp, 1.21_wp, 27.55_wp, 0.0_wp, 0.0_wp)
   case("triethylamine")
      data = solvent_data(2.3832_wp, 1.401_wp, 0.0_wp, 0.79_wp, 29.1_wp, 0.0_wp, 0.0_wp)
   case("trimethylbenzene")
      data = solvent_data(2.3653_wp, 1.5048_wp, 0.0_wp, 0.19_wp, 42.03_wp, 0.444889_wp, 0.0_wp)
   case("undecane")
      data = solvent_data(1.991_wp, 1.4398_wp, 0.0_wp, 0.0_wp, 34.85_wp, 0.0_wp, 0.0_wp)
   case("water")
      data = solvent_data(78.36_wp, 1.3328_wp, 0.82_wp, 0.35_wp, 103.62_wp, 0.0_wp, 0.0_wp)
   case("xylene")
      data = solvent_data(2.3879_wp, 1.4995_wp, 0.0_wp, 0.16_wp, 41.38_wp, 0.5625_wp, 0.0_wp)
   end select
end function get_solvent_data

!> Convert input string to lowercase
pure function compact(str) result(lcstr)

   !> Input string
   character(len=*), intent(in) :: str

   !> Lowercase version of string
   character(len=:), allocatable :: lcstr

   integer :: ilen, i, j, iav
   integer, parameter :: offset = iachar('A') - iachar('a')

   ilen = len(str)
   lcstr = ''

   j = 0
   do i = 1, ilen
      iav = iachar(str(i:i))
      if (any(iav == [iachar('-'), iachar(','), iachar(' ')])) cycle
      j = j + 1
      if (iav >= iachar('A') .and. iav <= iachar('Z')) then
         lcstr = lcstr // achar(iav - offset)
      else
         lcstr = lcstr // str(i:i)
      end if
   end do
   lcstr = trim(lcstr)

end function compact

end module tblite_solvation_data

program demo
  use tomlf, only : toml_table, toml_error, toml_context, toml_load
  use demo_config, only : config_type, load_config
  implicit none

  type(config_type) :: config
  character(128) :: arg

  call get_command_argument(1, arg)

  block
    type(toml_table), allocatable :: table
    type(toml_error), allocatable :: error
    type(toml_context) :: context

    call toml_load(table, trim(arg), context=context, error=error)
    if (allocated(error)) then
      print '(a)', error%message
      stop 1
    end if

    call load_config(config, table, context)
  end block
end program demo

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of the repulsion interactions
module tblite_param_repulsion
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_param_serde, only : serde_record
   use tblite_toml, only : toml_table, get_value, set_value, add_table
   implicit none
   private

   public :: repulsion_record, repulsion_mask, count


   character(len=*), parameter :: k_effective = "effective", k_kexp = "kexp", &
      & k_klight = "klight"

   !> Parametrization records describing the repulsion interactions
   type, extends(serde_record) :: repulsion_record
      real(wp) :: kexp
      real(wp) :: klight
   contains
      generic :: load => load_from_array
      generic :: dump => dump_to_array
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Read parametrization data from parameter array
      procedure, private :: load_from_array
      !> Write parametrization data to parameter array
      procedure, private :: dump_to_array
   end type


   type :: repulsion_mask
   end type repulsion_mask


   interface count
      module procedure :: count_mask
   end interface count


contains


!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(repulsion_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   integer :: stat

   call get_value(table, k_effective, child, requested=.false.)
   if (.not.associated(child)) then
      call fatal_error(error, "No entry for effective repulsion found")
      return
   end if

   call get_value(child, k_kexp, self%kexp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for repulsion exponent")
      return
   end if

   call get_value(child, k_klight, self%klight, self%kexp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for light-atom repulsion exponent")
      return
   end if
end subroutine load_from_toml


!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(repulsion_record), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   call add_table(table, k_effective, child)
   call set_value(child, k_kexp, self%kexp)
   if (abs(self%kexp - self%klight) > epsilon(self%kexp)) then
      call set_value(child, k_klight, self%klight)
   end if

end subroutine dump_to_toml


!> Read parametrization data from parameter array
subroutine load_from_array(self, array, offset, base, mask, error)
   class(repulsion_record), intent(inout) :: self
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: offset
   type(repulsion_record), intent(in) :: base
   type(repulsion_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   select type(self)
   type is (repulsion_record)
      self = base
   end select

end subroutine load_from_array

!> Write parametrization data to parameter array
subroutine dump_to_array(self, array, offset, mask, error)
   class(repulsion_record), intent(in) :: self
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: offset
   type(repulsion_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

end subroutine dump_to_array

elemental function count_mask(mask) result(ncount)
   type(repulsion_mask), intent(in) :: mask
   integer :: ncount
   ncount = 0
end function count_mask


end module tblite_param_repulsion

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_trexio
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_env_testing, only : new_unittest, unittest_type, check
   use mctc_io, only : structure_type, new
   use mstore, only : get_structure
   use tblite_basis_type, only : basis_type, cgto_type, new_basis
   use tblite_context_type, only : context_type
   use tblite_features, only : get_tblite_feature
   use tblite_io_trexio, only : load_trexio, save_trexio
   use tblite_wavefunction, only : wavefunction_type, new_wavefunction, eeq_guess
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   implicit none
   private

   public :: collect_trexio

   real(wp), parameter :: kt = 300.0_wp * 3.166808578545117e-06_wp
   real(wp), parameter :: acc = 0.01_wp

contains

subroutine collect_trexio(testsuite)
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   if (get_tblite_feature("trexio")) then
      if (get_tblite_feature("hdf5")) then
         testsuite = [ &
            new_unittest("roundtrip-text", test_roundtrip_text), &
            new_unittest("roundtrip-hdf5", test_roundtrip_hdf5), &
            new_unittest("restart-text", test_restart_from_trexio_text), &
            new_unittest("restart-hdf5", test_restart_from_trexio_hdf5), &
            new_unittest("restart-unrestricted-text", test_restart_uhf_from_trexio_text), &
            new_unittest("restart-unrestricted-hdf5", test_restart_uhf_from_trexio_hdf5), &
            new_unittest("ao-shell-fail-text", test_ao_shell_fail_text, should_fail=.true.), &
            new_unittest("ao-shell-fail-hdf5", test_ao_shell_fail_hdf5, should_fail=.true.), &
            new_unittest("num-prim-fail-text", test_num_prim_fail_text, should_fail=.true.), &
            new_unittest("num-prim-fail-hdf5", test_num_prim_fail_hdf5, should_fail=.true.), &
            new_unittest("mo-occ-fail-text", test_mo_occ_fail_text, should_fail=.true.), &
            new_unittest("mo-occ-fail-hdf5", test_mo_occ_fail_hdf5, should_fail=.true.) &
         ]
      else
         testsuite = [ &
            new_unittest("roundtrip-text", test_roundtrip_text), &
            new_unittest("restart-text", test_restart_from_trexio_text), &
            new_unittest("restart-unrestricted-text", test_restart_uhf_from_trexio_text), &
            new_unittest("ao-shell-fail-text", test_ao_shell_fail_text, should_fail=.true.), &
            new_unittest("num-prim-fail-text", test_num_prim_fail_text, should_fail=.true.), &
            new_unittest("mo-occ-fail-text", test_mo_occ_fail_text, should_fail=.true.) &
         ]
      end if
   else
      testsuite = [new_unittest("trexio-disabled", test_trexio_disabled)]
   end if
end subroutine collect_trexio

subroutine test_trexio_disabled(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(error_type), allocatable :: actual
   type(structure_type) :: mol
   type(basis_type) :: bas
   type(wavefunction_type) :: wfn
   real(wp) :: energy

   call load_trexio(".trexio-disabled.trexio", mol, bas, wfn, energy, actual)
   call check(error, allocated(actual), "TREXIO read unexpectedly succeeded without TREXIO support")
   if (allocated(actual)) deallocate(actual)
end subroutine test_trexio_disabled

subroutine test_roundtrip_text(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_roundtrip(".trexio-roundtrip.trexio", error)
end subroutine test_roundtrip_text

subroutine test_roundtrip_hdf5(error)
   type(error_type), allocatable, intent(out) :: error

   call check_roundtrip(".trexio-roundtrip.h5", error)
end subroutine test_roundtrip_hdf5

subroutine check_roundtrip(filename, error)
   !> TREXIO file name
   character(len=*), intent(in) :: filename
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: energy = -12.345_wp
   type(structure_type) :: mol
   type(structure_type) :: mol_loaded
   type(basis_type) :: bas
   type(basis_type) :: bas_loaded
   type(wavefunction_type) :: wfn
   type(wavefunction_type) :: wfn_loaded
   real(wp) :: energy_loaded

   call make_roundtrip_data(mol, bas, wfn)

   ! Remove existing TREXIO output before test and leave the test output for inspection
   call remove_trexio_output(filename)
   call save_trexio(filename, mol, bas, wfn, energy, error)
   if (allocated(error)) return

   call load_trexio(filename, mol_loaded, bas_loaded, wfn_loaded, energy_loaded, error)
   if (allocated(error)) return

   call check_structure(error, mol_loaded, mol)
   if (allocated(error)) return
   call check_basis(error, bas_loaded, bas)
   if (allocated(error)) return
   call check_wavefunction(error, wfn_loaded, wfn)
   if (allocated(error)) return
   call check(error, abs(energy_loaded - energy) <= epsilon(1.0_wp), &
      & "State energy changed in TREXIO round trip")
   if (allocated(error)) return
end subroutine check_roundtrip

subroutine check_structure(error, actual, expected)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Read structure data
   type(structure_type), intent(in) :: actual
   !> Reference structure data
   type(structure_type), intent(in) :: expected

   integer :: i

   call check(error, actual%nat, expected%nat)
   if (allocated(error)) return
   call check(error, all(actual%num(actual%id) == expected%num(expected%id)), &
      & "Nuclear charges changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, all(abs(actual%xyz - expected%xyz) <= epsilon(1.0_wp)), &
      & "Nuclear coordinates changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, size(actual%sym) == size(expected%sym), &
      & "Nuclear symbol table size changed in TREXIO round trip")
   if (allocated(error)) return
   do i = 1, size(expected%sym)
      call check(error, trim(actual%sym(i)) == trim(expected%sym(i)), &
         & "Nuclear symbol " // trim(expected%sym(i)) // " changed in TREXIO round trip")
      if (allocated(error)) return
   end do
   call check(error, abs(actual%charge - expected%charge) <= epsilon(1.0_wp), &
      & "Molecular charge changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, actual%uhf, expected%uhf, &
      & "Molecular spin multiplicity changed in TREXIO round trip")
   if (allocated(error)) return
   if (allocated(expected%periodic)) then
      if (.not. allocated(actual%periodic)) then
         call fatal_error(error, "Periodicity missing in TREXIO round trip")
         return
      end if
      call check(error, all(actual%periodic .eqv. expected%periodic), &
         & "Periodicity changed in TREXIO round trip")
      if (allocated(error)) return
   else
      call check(error, .not. allocated(actual%periodic), &
         & "Unexpected periodicity in TREXIO round trip")
      if (allocated(error)) return
   end if
   if (allocated(expected%lattice)) then
      if (.not. allocated(actual%lattice)) then
         call fatal_error(error, "Lattice vectors missing in TREXIO round trip")
         return
      end if
      call check(error, all(abs(actual%lattice - expected%lattice) <= epsilon(1.0_wp)), &
         & "Lattice vectors changed in TREXIO round trip")
   else
      call check(error, .not. allocated(actual%lattice), &
         & "Unexpected lattice vectors in TREXIO round trip")
   end if
end subroutine check_structure

subroutine check_basis(error, actual, expected)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Read basis set information
   type(basis_type), intent(in) :: actual
   !> Reference basis set information
   type(basis_type), intent(in) :: expected

   integer :: isp, ish, nprim

   call check(error, actual%nsh, expected%nsh, &
      & "Basis shell count changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, actual%nao, expected%nao, &
      & "Basis AO count changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, actual%nao_cart, expected%nao_cart, &
      & "Basis Cartesian AO count changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, actual%maxl, expected%maxl, &
      & "Basis maximum angular momentum changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, all(actual%sh2at == expected%sh2at), &
      & "Basis nucleus map changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, all(actual%nao_sh == expected%nao_sh), &
      & "Basis shell AO counts changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, all(actual%iao_sh == expected%iao_sh), &
      & "Basis shell AO offsets changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, all(actual%ao2sh == expected%ao2sh), &
      & "Basis AO shell map changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, all(actual%ao2at == expected%ao2at), &
      & "Basis AO atom map changed in TREXIO round trip")
         if (allocated(error)) return

   ! Check CGTO primitives
   do isp = 1, size(expected%cgto, 2)
      do ish = 1, expected%nsh_id(isp)
         call check(error, actual%cgto(ish, isp)%ang, expected%cgto(ish, isp)%ang, &
            & "Shell angular momentum changed in TREXIO round trip")
         if (allocated(error)) return
         call check(error, actual%cgto(ish, isp)%nprim, expected%cgto(ish, isp)%nprim, &
            & "Shell primitive count changed in TREXIO round trip")
         nprim = expected%cgto(ish, isp)%nprim
         if (allocated(error)) return
         call check(error, all(abs(actual%cgto(ish, isp)%alpha(:nprim) - &
            & expected%cgto(ish, isp)%alpha(:nprim)) <= epsilon(1.0_wp)), &
            & "Primitive exponents changed in TREXIO round trip")
         if (allocated(error)) return
         call check(error, all(abs(actual%cgto(ish, isp)%coeff(:nprim) - &
            & expected%cgto(ish, isp)%coeff(:nprim)) <= epsilon(1.0_wp)), &
            & "Primitive coefficients changed in TREXIO round trip")
         if (allocated(error)) return
      end do
   end do
end subroutine check_basis

subroutine check_wavefunction(error, actual, expected)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Read wavefunction data
   type(wavefunction_type), intent(in) :: actual
   !> Reference wavefunction data
   type(wavefunction_type), intent(in) :: expected

   call check(error, actual%nspin, expected%nspin)
   if (allocated(error)) return
   call check(error, abs(actual%nocc - expected%nocc) <= epsilon(1.0_wp), &
      & "Wavefunction electron count changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, abs(actual%nuhf - expected%nuhf) <= epsilon(1.0_wp), &
      & "Wavefunction unpaired electron count changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, all(abs(actual%nel - expected%nel) <= epsilon(1.0_wp)), &
      & "Wavefunction spin electron counts changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, all(abs(actual%emo - expected%emo) <= epsilon(1.0_wp)), &
      & "Wavefunction MO energies changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, all(abs(actual%n0at - expected%n0at) <= epsilon(1.0_wp)), &
      & "Wavefunction atomic reference occupation changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, all(abs(actual%focc - expected%focc) <= epsilon(1.0_wp)), &
      & "Wavefunction MO occupations changed in TREXIO round trip")
   if (allocated(error)) return
   call check(error, all(abs(actual%coeff - expected%coeff) <= epsilon(1.0_wp)), &
      & "Wavefunction MO coefficients changed in TREXIO round trip")
end subroutine check_wavefunction

subroutine make_roundtrip_data(mol, bas, wfn)
   !> Molecular structure data
   type(structure_type), intent(out) :: mol
   !> Basis set information
   type(basis_type), intent(out) :: bas
   !> Wavefunction data
   type(wavefunction_type), intent(out) :: wfn

   integer, allocatable :: nshell(:)
   type(cgto_type), allocatable :: cgto(:, :)

   call new(mol, [1, 4], reshape([ &
      & 0.0_wp, 0.0_wp, 0.0_wp, &
      & 0.0_wp, 0.0_wp, 1.4_wp], [3, 2]), charge=0.0_wp, uhf=1)

   allocate(nshell(mol%nid), cgto(1, mol%nid))
   nshell(:) = 1
   cgto(:, :) = cgto_type()

   cgto(1, 1)%ang = 0
   cgto(1, 1)%nprim = 1
   cgto(1, 1)%alpha(1) = 1.2_wp
   cgto(1, 1)%coeff(1) = 0.8_wp

   cgto(1, 2)%ang = 0
   cgto(1, 2)%nprim = 2
   cgto(1, 2)%alpha(:2) = [0.9_wp, 0.4_wp]
   cgto(1, 2)%coeff(:2) = [0.7_wp, 0.2_wp]

   call new_basis(bas, mol, nshell, cgto, 1.0_wp)

   call new_wavefunction(wfn, mol%nat, bas%nsh, bas%nao, 2, 0.0_wp)
   wfn%nocc = 3.0_wp
   wfn%nuhf = 1.0_wp
   wfn%nel = [2.0_wp, 1.0_wp]
   wfn%n0at = [1.0_wp, 2.0_wp]
   wfn%n0sh = [1.0_wp, 2.0_wp]
   wfn%emo(:, 1) = [-0.5_wp, 0.2_wp]
   wfn%emo(:, 2) = [-0.4_wp, 0.3_wp]
   wfn%focc(:, 1) = [1.5_wp, 0.5_wp]
   wfn%focc(:, 2) = [1.0_wp, 0.0_wp]
   wfn%coeff(:, :, 1) = reshape([1.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], [2, 2])
   wfn%coeff(:, :, 2) = reshape([0.6_wp, 0.8_wp, 0.8_wp, -0.6_wp], [2, 2])
end subroutine make_roundtrip_data

subroutine remove_trexio_output(filename)
   !> TREXIO file name or directory
   character(len=*), intent(in) :: filename

   integer :: io, stat, ig
   logical :: exist
   character(len=*), parameter :: groups(*) = [character(len=32) :: &
      & "metadata", "nucleus", "electron", "cell", "basis", "ao", "mo", "state", "ecp"]

   if (is_hdf5_file(filename)) then
      ! Remove HDF5 files
      inquire(file=filename, exist=exist)
      if (exist) then
         open(newunit=io, file=filename, status="old", action="write", iostat=stat)
         if (stat == 0) close(io, status="delete")
         return
      end if
   else
      ! Remove individual TREXIO text files from TREXIO folder
      do ig = 1, size(groups)
         inquire(file=filename, exist=exist)
         if (exist) then
            open(newunit=io, file=trim(filename) // "/" // trim(groups(ig)) // ".txt", &
               & status="old", action="write", iostat=stat)
            if (stat == 0) close(io, status="delete")
         end if
      end do
   end if
end subroutine remove_trexio_output

pure function is_hdf5_file(filename) result(is_hdf5)
   !> File name to inspect
   character(len=*), intent(in) :: filename
   !> Whether the file name uses an HDF5 extension
   logical :: is_hdf5

   is_hdf5 = len(filename) >= 3 .and. filename(len(filename)-2:) == ".h5"
   is_hdf5 = is_hdf5 .or. &
      & (len(filename) >= 5 .and. filename(len(filename)-4:) == ".hdf5")
end function is_hdf5_file

subroutine test_restart_from_trexio_text(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_restart_from_trexio(".trexio-restart.trexio", 1, error)
end subroutine test_restart_from_trexio_text

subroutine test_restart_from_trexio_hdf5(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_restart_from_trexio(".trexio-restart.h5", 1, error)
end subroutine test_restart_from_trexio_hdf5

subroutine test_restart_uhf_from_trexio_text(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_restart_from_trexio(".trexio-restart-uhf.trexio", 2, error)
end subroutine test_restart_uhf_from_trexio_text

subroutine test_restart_uhf_from_trexio_hdf5(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_restart_from_trexio(".trexio-restart-uhf.h5", 2, error)
end subroutine test_restart_uhf_from_trexio_hdf5

subroutine check_restart_from_trexio(filename, nspin, error)
   !> TREXIO file name
   character(len=*), intent(in) :: filename
   !> Number of spin channels in the wavefunction to test
   integer, intent(in) :: nspin
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol, mol_loaded
   type(basis_type) :: bas, bas_loaded
   type(wavefunction_type) :: wfn, wfn_loaded
   type(xtb_calculator) :: calc
   real(wp) :: energy, energy_loaded

   ! Perform GFN2-xTB calculation to save in trexio
   call make_restart_data(nspin, mol, bas, wfn, energy)

   ! Remove existing TREXIO output before test and leave the test output for inspection
   call remove_trexio_output(filename)
   call save_trexio(filename, mol, bas, wfn, energy, error)
   if (allocated(error)) return

   call load_trexio(filename, mol_loaded, bas_loaded, wfn_loaded, energy_loaded, error)
   if (allocated(error)) return

   ! Setup a new calculator
   call new_gfn2_calculator(calc, mol, error)
   if (allocated(error)) return

   !> Check that loaded structure and basis set
   call check_structure(error, mol_loaded, mol)
   if (allocated(error)) return
   call check_basis(error, bas_loaded, calc%bas)
   if (allocated(error)) return

   ! Copy all necessary restart wavefunction information
   wfn%coeff = wfn_loaded%coeff
   wfn%focc = wfn_loaded%focc
   wfn%emo = wfn_loaded%emo
   wfn%nocc = wfn_loaded%nocc
   wfn%nel = wfn_loaded%nel
   ! Copy also the basis set to check for correct normalization and mappings
   calc%bas = bas_loaded

   ! Check for immediate convergence with TREXIO guess
   calc%max_iter = 2
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0)
   call check(error, .not.ctx%failed(), &
      & "Calculation did not converge in < 3 iterations with TREXIO guess")
end subroutine check_restart_from_trexio

subroutine make_restart_data(nspin, mol, bas, wfn, energy)
   !> Number of spin channels
   integer, intent(in) :: nspin
   !> Molecular structure data
   type(structure_type), intent(out) :: mol
   !> Basis set information
   type(basis_type), intent(out) :: bas
   !> Wavefunction data
   type(wavefunction_type), intent(out) :: wfn
   !> Total energy
   real(wp), intent(out) :: energy

   type(context_type) :: ctx
   type(xtb_calculator) :: calc
   type(error_type), allocatable :: error

   call get_structure(mol, "X23", "oxacb")

   call new_gfn2_calculator(calc, mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, nspin, kt)
   call eeq_guess(mol, calc, wfn, error)

   energy = 0.0_wp
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0)

   bas = calc%bas
end subroutine make_restart_data

subroutine test_ao_shell_fail_text(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call test_ao_shell_fail(".trexio-ao-shell-map-fail.trexio", error)
end subroutine test_ao_shell_fail_text

subroutine test_ao_shell_fail_hdf5(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call test_ao_shell_fail(".trexio-ao-shell-map-fail.h5", error)
end subroutine test_ao_shell_fail_hdf5

subroutine test_ao_shell_fail(filename, error)
   !> TREXIO file name
   character(len=*), intent(in) :: filename
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: energy = -12.345_wp
   type(structure_type) :: mol, mol_loaded
   type(basis_type) :: bas, bas_loaded
   type(wavefunction_type) :: wfn, wfn_loaded
   real(wp) :: energy_loaded

   call make_roundtrip_data(mol, bas, wfn)
   bas%ao2sh(1) = bas%nsh

   ! Remove existing TREXIO output before test and leave the test output for inspection
   call remove_trexio_output(filename)
   call save_trexio(filename, mol, bas, wfn, energy, error)
   if (allocated(error)) return

   call load_trexio(filename, mol_loaded, bas_loaded, wfn_loaded, energy_loaded, error)
   if (.not. allocated(error)) return
   call remove_trexio_output(filename)

   bas%ao2sh(1) = bas%nsh + 5

   ! Remove existing TREXIO output before test and leave the test output for inspection
   call remove_trexio_output(filename)
   call save_trexio(filename, mol, bas, wfn, energy, error)
   if (allocated(error)) return

   call load_trexio(filename, mol_loaded, bas_loaded, wfn_loaded, energy_loaded, error)
end subroutine test_ao_shell_fail

subroutine test_num_prim_fail_text(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call test_num_prim_fail(".trexio-num-prim-fail.trexio", error)
end subroutine test_num_prim_fail_text

subroutine test_num_prim_fail_hdf5(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call test_num_prim_fail(".trexio-num-prim-fail.h5", error)
end subroutine test_num_prim_fail_hdf5

subroutine test_num_prim_fail(filename, error)
   !> TREXIO file name
   character(len=*), intent(in) :: filename
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: energy = -12.345_wp
   type(structure_type) :: mol, mol_loaded
   type(basis_type) :: bas, bas_loaded
   type(wavefunction_type) :: wfn, wfn_loaded
   real(wp) :: energy_loaded

   call make_roundtrip_data(mol, bas, wfn)
   bas%cgto(1, 2)%nprim = 0

   ! Remove existing TREXIO output before test and leave the test output for inspection
   call remove_trexio_output(filename)
   call save_trexio(filename, mol, bas, wfn, energy, error)
   if (allocated(error)) return

   call load_trexio(filename, mol_loaded, bas_loaded, wfn_loaded, energy_loaded, error)
end subroutine test_num_prim_fail

subroutine test_mo_occ_fail_text(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call test_mo_occ_fail(".trexio-mo-occ-fail.trexio", error)
end subroutine test_mo_occ_fail_text

subroutine test_mo_occ_fail_hdf5(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call test_mo_occ_fail(".trexio-mo-occ-fail.h5", error)
end subroutine test_mo_occ_fail_hdf5

subroutine test_mo_occ_fail(filename, error)
   !> TREXIO file name
   character(len=*), intent(in) :: filename
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: energy = -12.345_wp
   type(structure_type) :: mol, mol_loaded
   type(basis_type) :: bas, bas_loaded
   type(wavefunction_type) :: wfn, wfn_loaded
   real(wp) :: energy_loaded

   call make_roundtrip_data(mol, bas, wfn)
   wfn%focc(:, 1) = [1.0_wp, 0.5_wp]

   ! Remove existing TREXIO output before test and leave the test output for inspection
   call remove_trexio_output(filename)
   call save_trexio(filename, mol, bas, wfn, energy, error)
   if (allocated(error)) return

   call load_trexio(filename, mol_loaded, bas_loaded, wfn_loaded, energy_loaded, error)
end subroutine test_mo_occ_fail

end module test_trexio

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implemenation of transformations from cartesian to spherical harmonic basis functions
!>
!> Spherical harmonics use standard ordering, *i.e.* [-l, ..., 0, ..., l].
module tblite_integral_trafo
   use mctc_env, only : wp
   implicit none
   private

   public :: transform0, transform1, transform2


   real(wp), parameter :: s3 = sqrt(3.0_wp)
   real(wp), parameter :: s3_4 = s3 * 0.5_wp
   real(wp), parameter :: dtrafo(5, 6) = reshape([&
      ! -2      -1       0       1       2
      & 0.0_wp, 0.0_wp, -0.5_wp, 0.0_wp,   s3_4, & ! xx
      & 0.0_wp, 0.0_wp, -0.5_wp, 0.0_wp,  -s3_4, & ! yy
      & 0.0_wp, 0.0_wp,  1.0_wp, 0.0_wp, 0.0_wp, & ! zz
      &     s3, 0.0_wp,  0.0_wp, 0.0_wp, 0.0_wp, & ! xy
      & 0.0_wp, 0.0_wp,  0.0_wp,     s3, 0.0_wp, & ! xz
      & 0.0_wp,     s3,  0.0_wp, 0.0_wp, 0.0_wp],& ! yz
      & shape(dtrafo))

   real(wp), parameter :: d32 = 3.0_wp/2.0_wp
   real(wp), parameter :: s3_8 = sqrt(3.0_wp/8.0_wp)
   real(wp), parameter :: s5_8 = sqrt(5.0_wp/8.0_wp)
   real(wp), parameter :: s6 = sqrt(6.0_wp)
   real(wp), parameter :: s15 = sqrt(15.0_wp)
   real(wp), parameter :: s15_4 = sqrt(15.0_wp/4.0_wp)
   real(wp), parameter :: s45 = sqrt(45.0_wp)
   real(wp), parameter :: s45_8 = sqrt(45.0_wp/8.0_wp)
   real(wp), parameter :: ftrafo(7, 10) = reshape([&
      ! -3       -2       -1       0        1         2         3
      &  0.0_wp,  0.0_wp,  0.0_wp, 0.0_wp,   -s3_8,   0.0_wp,     s5_8, & ! xxx
      &   -s5_8,  0.0_wp,   -s3_8, 0.0_wp,  0.0_wp,   0.0_wp,   0.0_wp, & ! yyy
      &  0.0_wp,  0.0_wp,  0.0_wp, 1.0_wp,  0.0_wp,   0.0_wp,   0.0_wp, & ! zzz
      &   s45_8,  0.0_wp,   -s3_8, 0.0_wp,  0.0_wp,   0.0_wp,   0.0_wp, & ! xxy
      &  0.0_wp,  0.0_wp,  0.0_wp,   -d32,  0.0_wp,    s15_4,   0.0_wp, & ! xxz
      &  0.0_wp,  0.0_wp,  0.0_wp, 0.0_wp,   -s3_8,   0.0_wp,   -s45_8, & ! xyy
      &  0.0_wp,  0.0_wp,  0.0_wp,   -d32,  0.0_wp,   -s15_4,   0.0_wp, & ! yyz
      &  0.0_wp,  0.0_wp,  0.0_wp, 0.0_wp,      s6,   0.0_wp,   0.0_wp, & ! xzz
      &  0.0_wp,  0.0_wp,      s6, 0.0_wp,  0.0_wp,   0.0_wp,   0.0_wp, & ! yzz
      &  0.0_wp,     s15,  0.0_wp, 0.0_wp,  0.0_wp,   0.0_wp,   0.0_wp],& ! xyz
      & shape(ftrafo))

   real(wp), parameter :: d38 = 3.0_wp/8.0_wp
   real(wp), parameter :: d34 = 3.0_wp/4.0_wp
   real(wp), parameter :: s5_16 = sqrt(5.0_wp/16.0_wp)
   real(wp), parameter :: s10 = sqrt(10.0_wp)
   real(wp), parameter :: s10_8 = sqrt(10.0_wp/8.0_wp)
   real(wp), parameter :: s35_4 = sqrt(35.0_wp/4.0_wp)
   real(wp), parameter :: s35_8 = sqrt(35.0_wp/8.0_wp)
   real(wp), parameter :: s35_64 = sqrt(35.0_wp/64.0_wp)
   real(wp), parameter :: s45_4 = sqrt(45.0_wp/4.0_wp)
   real(wp), parameter :: s315_8 = sqrt(315.0_wp/8.0_wp)
   real(wp), parameter :: s315_16 = sqrt(315.0_wp/16.0_wp)
   real(wp), parameter :: gtrafo(9, 15) = reshape([&
      !  -4     -3     -2     -1       0    1      2       3        4
      &  0._wp, 0._wp, 0._wp, 0._wp,   d38, 0._wp,-s5_16,  0._wp,  s35_64, & ! xxxx
      &  0._wp, 0._wp, 0._wp, 0._wp,   d38, 0._wp, s5_16,  0._wp,  s35_64, & ! yyyy
      &  0._wp, 0._wp, 0._wp, 0._wp, 1._wp, 0._wp, 0._wp,  0._wp,   0._wp, & ! zzzz
      &  s35_4, 0._wp,-s10_8, 0._wp, 0._wp, 0._wp, 0._wp,  0._wp,   0._wp, & ! xxxy
      &  0._wp, 0._wp, 0._wp, 0._wp, 0._wp,-s45_8, 0._wp,  s35_8,   0._wp, & ! xxxz
      & -s35_4, 0._wp,-s10_8, 0._wp, 0._wp, 0._wp, 0._wp,  0._wp,   0._wp, & ! xyyy
      &  0._wp,-s35_8, 0._wp,-s45_8, 0._wp, 0._wp, 0._wp,  0._wp,   0._wp, & ! yyyz
      &  0._wp, 0._wp, 0._wp, 0._wp, 0._wp,   s10, 0._wp,  0._wp,   0._wp, & ! xzzz
      &  0._wp, 0._wp, 0._wp,   s10, 0._wp, 0._wp, 0._wp,  0._wp,   0._wp, & ! yzzz
      &  0._wp, 0._wp, 0._wp, 0._wp,   d34, 0._wp, 0._wp,  0._wp,-s315_16, & ! xxyy
      &  0._wp, 0._wp, 0._wp, 0._wp,-3._wp, 0._wp, s45_4,  0._wp,   0._wp, & ! xxzz
      &  0._wp, 0._wp, 0._wp, 0._wp,-3._wp, 0._wp,-s45_4,  0._wp,   0._wp, & ! yyzz
      &  0._wp,s315_8, 0._wp,-s45_8, 0._wp, 0._wp, 0._wp,  0._wp,   0._wp, & ! xxyz
      &  0._wp, 0._wp, 0._wp, 0._wp, 0._wp,-s45_8, 0._wp,-s315_8,   0._wp, & ! xyyz
      &  0._wp, 0._wp,   s45, 0._wp, 0._wp, 0._wp, 0._wp,  0._wp,   0._wp],& ! xyzz
      &  shape(gtrafo))

contains


pure subroutine transform0(lj, li, cart, sphr)
   integer, intent(in) :: li
   integer, intent(in) :: lj
   real(wp), intent(in) :: cart(:, :)
   real(wp), intent(out) :: sphr(:, :)

   select case(li)
   case(0, 1)
      select case(lj)
      case(0, 1)
         sphr = cart
      case(2)
         ! sphr = matmul(dtrafo, cart)
         sphr(1, :) = cart(3, :) - 0.5_wp * (cart(1, :) + cart(2, :))
         sphr(2, :) = s3 * cart(5, :)
         sphr(3, :) = s3 * cart(6, :)
         sphr(4, :) = s3_4 * (cart(1, :) - cart(2, :))
         sphr(5, :) = s3 * cart(4, :)
      case(3)
         sphr = matmul(ftrafo, cart)
      case(4)
         sphr = matmul(gtrafo, cart)
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select

   case(2)
      select case(lj)
      case(0, 1)
         ! sphr = matmul(cart, transpose(dtrafo))
         sphr(:, 1) = cart(:, 3) - 0.5_wp * (cart(:, 1) + cart(:, 2))
         sphr(:, 2) = s3 * cart(:, 5)
         sphr(:, 3) = s3 * cart(:, 6)
         sphr(:, 4) = s3_4 * (cart(:, 1) - cart(:, 2))
         sphr(:, 5) = s3 * cart(:, 4)
      case(2)
         ! sphr = matmul(dtrafo, matmul(cart, transpose(dtrafo)))
         sphr(1, 1) = cart(3, 3) &
            & - 0.5_wp * (cart(3, 1) + cart(3, 2) + cart(1, 3) + cart(2, 3)) &
            & + 0.25_wp * (cart(1, 1) + cart(1, 2) + cart(2, 1) + cart(2, 2))
         sphr([2, 3, 5], 1) = s3 * cart([5, 6, 4], 3) &
            & - s3_4 * (cart([5, 6, 4], 1) + cart([5, 6, 4], 2))
         sphr(4, 1) = s3_4 * (cart(1, 3) - cart(2, 3)) &
            & - s3 * 0.25_wp * (cart(1, 1) - cart(2, 1) + cart(1, 2) - cart(2, 2))
         sphr(1, 2) = s3 * cart(3, 5) - s3_4 * (cart(1, 5) + cart(2, 5))
         sphr([2, 3, 5], 2) = 3 * cart([5, 6, 4], 5)
         sphr(4, 2) = 1.5_wp * (cart(1, 5) - cart(2, 5))
         sphr(1, 3) = s3 * cart(3, 6) - s3_4 * (cart(1, 6) + cart(2, 6))
         sphr([2, 3, 5], 3) = 3 * cart([5, 6, 4], 6)
         sphr(4, 3) = 1.5_wp * (cart(1, 6) - cart(2, 6))
         sphr(1, 4) = s3_4 * (cart(3, 1) - cart(3, 2)) &
            & - s3 * 0.25_wp * (cart(1, 1) - cart(1, 2) + cart(2, 1) - cart(2, 2))
         sphr([2, 3, 5], 4) = 1.5_wp * (cart([5, 6, 4], 1) - cart([5, 6, 4], 2))
         sphr(4, 4) = 0.75_wp * (cart(1, 1) - cart(2, 1) - cart(1, 2) + cart(2, 2))
         sphr(1, 5) = s3 * cart(3, 4) - s3_4 * (cart(1, 4) + cart(2, 4))
         sphr([2, 3, 5], 5) = 3 * cart([5, 6, 4], 4)
         sphr(4, 5) = 1.5_wp * (cart(1, 4) - cart(2, 4))
      case(3)
         sphr = matmul(ftrafo, matmul(cart, transpose(dtrafo)))
      case(4)
         sphr = matmul(gtrafo, matmul(cart, transpose(dtrafo)))
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select

   case(3)
      select case(lj)
      case(0, 1)
         sphr = matmul(cart, transpose(ftrafo))
      case(2)
         sphr = matmul(dtrafo, matmul(cart, transpose(ftrafo)))
      case(3)
         sphr = matmul(ftrafo, matmul(cart, transpose(ftrafo)))
      case(4)
         sphr = matmul(gtrafo, matmul(cart, transpose(ftrafo)))
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select

   case(4)
      select case(lj)
      case(0, 1)
         sphr = matmul(cart, transpose(gtrafo))
      case(2)
         sphr = matmul(dtrafo, matmul(cart, transpose(gtrafo)))
      case(3)
         sphr = matmul(ftrafo, matmul(cart, transpose(gtrafo)))
      case(4)
         sphr = matmul(gtrafo, matmul(cart, transpose(gtrafo)))
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select

   case default
      error stop "[Fatal] Moments higher than g are not supported"
   end select

end subroutine transform0

pure subroutine transform1(lj, li, cart, sphr)
   integer, intent(in) :: li
   integer, intent(in) :: lj
   real(wp), intent(in) :: cart(:, :, :)
   real(wp), intent(out) :: sphr(:, :, :)
   integer :: k

   do k = 1, size(cart, 1)
      call transform0(lj, li, cart(k, :, :), sphr(k, :, :))
   end do
end subroutine transform1

pure subroutine transform2(lj, li, cart, sphr)
   integer, intent(in) :: li
   integer, intent(in) :: lj
   real(wp), intent(in) :: cart(:, :, :, :)
   real(wp), intent(out) :: sphr(:, :, :, :)
   integer :: k, l

   do l = 1, size(cart, 2)
      do k = 1, size(cart, 1)
         call transform0(lj, li, cart(k, l, :, :), sphr(k, l, :, :))
      end do
   end do
end subroutine transform2


end module tblite_integral_trafo

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> API export for the version information of the library
module tblite_api_version
   use, intrinsic :: iso_c_binding
   use tblite_version, only : get_tblite_version
   implicit none
   private

   public :: get_version_api, namespace

   character(len=*), parameter :: namespace = "tblite_"

contains


!> Obtain library version as major * 10000 + minor + 100 + patch
function get_version_api() result(version) &
      & bind(C, name=namespace//"get_version")
   integer(c_int) :: version
   integer :: major, minor, patch

   call get_tblite_version(major, minor, patch)
   version = 10000_c_int * major + 100_c_int * minor + patch

end function get_version_api


end module tblite_api_version

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Classical correction term for halogen bonding contributions
module tblite_classical_halogen
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_container, only : container_cache
   use tblite_cutoff, only : get_lattice_points
   use tblite_data_atomicrad, only : get_atomic_rad
   use tblite_repulsion_type, only : repulsion_type
   implicit none

   public :: halogen_correction, new_halogen_correction


   !> Container for evaluating halogen bonding energy terms by a classical potential
   type, extends(repulsion_type) :: halogen_correction
      !> Interaction strength of the halogen bond
      real(wp), allocatable :: bond_strength(:)
      !> Atomic radii of all atoms
      real(wp), allocatable :: rad(:)
      !> Damping for the interaction potential
      real(wp) :: damping
      !> Suitable acceptors for halogen bonding interactions
      logical, allocatable :: acceptor(:)
      !> Suitable donors for halogen bonding interactions
      logical, allocatable :: halogen(:)
      !> Real-space cutoff
      real(wp) :: cutoff = 20.0_wp
   contains
      !> Entry point for evaluation of energy and gradient
      procedure :: get_engrad
   end type halogen_correction

   real(wp), parameter :: alp = 6.0_wp, lj = 12.0_wp, lj2 = lj * 0.5_wp
   character(len=*), parameter :: label = "halogen-bond correction"

contains


!> Construct new halogen bonding correction
subroutine new_halogen_correction(self, mol, damping, rad_scale, bond_strength, rad, cutoff)
   !> Instance of the halogen bond correction
   type(halogen_correction), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Damping factor
   real(wp), intent(in) :: damping
   !> Scaling of the atomic radii
   real(wp), intent(in) :: rad_scale
   !> Strength of the halogen bond
   real(wp), intent(in) :: bond_strength(:)
   !> Atomic radii for each species
   real(wp), intent(in), optional :: rad(:)
   !> Real-space cutoff
   real(wp), intent(in), optional :: cutoff

   self%label = label
   allocate(self%rad(mol%nid), self%bond_strength(mol%nid), self%halogen(mol%nid), &
      & self%acceptor(mol%nid))
   if (present(rad)) then
      self%rad(:) = rad * rad_scale
   else
      self%rad(:) = get_atomic_rad(mol%num) * rad_scale
   end if
   if (present(cutoff)) self%cutoff = cutoff
   self%bond_strength(:) = bond_strength
   self%damping = damping

   self%halogen(:) = is_halogen(mol%num)
   self%acceptor(:) = is_acceptor(mol%num)

end subroutine new_halogen_correction


!> Check whether an atom qualifies as halogen bond doner
elemental function is_halogen(num) result(halogen)
   integer, intent(in) :: num
   logical :: halogen
   halogen = any(num == [17, 35, 53, 85])
end function is_halogen

!> Check whether an atom qualifies as halogen bond acceptor
elemental function is_acceptor(num) result(acceptor)
   integer, intent(in) :: num
   logical :: acceptor
   acceptor = any(num == [7, 8, 15, 16])
end function is_acceptor


!> Evaluate classical interaction for energy and derivatives
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the halogen bond correction
   class(halogen_correction), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Halogen-bonding energy
   real(wp), intent(inout) :: energies(:)
   !> Molecular gradient of the halogen-bonding energy
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Strain derivatives of the halogen-bonding energy
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)

   integer, allocatable :: list(:, :)
   real(wp), allocatable :: trans(:, :)

   if (count(self%halogen) * count(self%acceptor) == 0) return

   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff, trans)

   call get_xbond_list(mol, trans, self%cutoff, self%halogen, self%acceptor, list)
   if (.not.allocated(list)) return

   if (present(gradient) .and. present(sigma)) then
      call get_xbond_derivs(mol, trans, list, self%damping, self%bond_strength, self%rad, &
         & energies, gradient, sigma)
   else
      call get_xbond_energy(mol, trans, list, self%damping, self%bond_strength, self%rad, &
         & energies)
   end if

end subroutine get_engrad


!> Collect all triples for halogen bonding interactions
subroutine get_xbond_list(mol, trans, cutoff, halogen, acceptor, list)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points
   real(wp), intent(in) :: trans(:, :)
   !> Real space cutoff
   real(wp), intent(in) :: cutoff
   !> Species can act as halogen bond donor
   logical, intent(in) :: halogen(:)
   !> Species can act as halogen bond acceptor
   logical, intent(in) :: acceptor(:)
   !> List of all halogen bonds
   integer, allocatable, intent(out) :: list(:, :)

   integer :: iat, jat, kat, izp, jzp, jtr, ktr, nxb, ij
   real(wp) :: vec(3), r1, dist

   nxb = 0
   call resize(list)

   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, mol%nat
         jzp = mol%id(jat)
         if (.not.(halogen(izp).and.acceptor(jzp))) cycle
         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, jtr)
            r1 = norm2(vec)
            if (r1 > cutoff) cycle
            nxb = nxb + 1
            if (nxb > size(list, 2)) call resize(list)
            list([1, 2, 4], nxb) = [iat, jat, jtr]
         end do
      end do
   end do

   if (nxb == 0) then
      deallocate(list)
      return
   end if

   call resize(list, nxb)

   do ij = 1, size(list, 2)
      iat = list(1, ij)
      jat = list(2, ij)
      dist = huge(1.0_wp)
      do kat = 1, mol%nat
         do ktr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - mol%xyz(:, kat) - trans(:, ktr)
            r1 = norm2(vec)
            if (r1 < dist .and. r1 > 0.0_wp) then
               list([3, 5], ij) = [kat, ktr]
               dist = r1
            end if
         end do
      end do
   end do
end subroutine get_xbond_list


!> Reallocate list of integers
pure subroutine resize(var, n)
   !> Instance of the array to be resized
   integer, allocatable, intent(inout) :: var(:, :)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   integer, parameter :: nitem = 5, initial_size = 20
   integer, allocatable :: tmp(:, :)
   integer :: this_size, new_size

   if (allocated(var)) then
      this_size = size(var, 2)
      call move_alloc(var, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(var(nitem, new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 2), size(var, 2))
      var(:, :this_size) = tmp(:, :this_size)
      deallocate(tmp)
   end if

end subroutine resize


!> Get energy contributions from halogen bonding interactions
subroutine get_xbond_energy(mol, trans, list, damping, bond_strength, rad, &
      & energies)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points
   real(wp), intent(in) :: trans(:, :)
   !> List of halogen bonded atoms
   integer, intent(in) :: list(:, :)
   !> Damping factor
   real(wp), intent(in) :: damping
   !> Strength of the halogen bond
   real(wp), intent(in) :: bond_strength(:)
   !> Atomic radii for each species
   real(wp), intent(in) :: rad(:)
   !> Repulsion energy
   real(wp), intent(inout) :: energies(:)

   integer :: ijk, jat, kat, xat, xzp, jzp, jtr, ktr
   real(wp) :: cc, r0jx, t13, t14, d2jx, rjx, term, aterm
   real(wp) :: xy, d2kx, d2jk, dxj(3), dxk(3), dkj(3)

   do ijk = 1, size(list, 2)
      xat = list(1, ijk)
      jat = list(2, ijk)
      kat = list(3, ijk)
      jtr = list(4, ijk)
      ktr = list(5, ijk)
      xzp = mol%id(xat)
      jzp = mol%id(jat)
      cc = bond_strength(xzp)
      r0jx = rad(xzp) + rad(jzp)
      dxj = mol%xyz(:, jat) - mol%xyz(:, xat)
      dxk = mol%xyz(:, kat) + trans(:, ktr) - mol%xyz(:, xat)
      dkj = mol%xyz(:, jat) + trans(:, jtr) - mol%xyz(:, kat) - trans(:, ktr)
      d2jx = sum(dxj*dxj)
      d2kx = sum(dxk*dxk)
      d2jk = sum(dkj*dkj)
      rjx = sqrt(d2jx)
      ! angle part. term = cos angle kat-xat-jat
      xy = sqrt(d2kx*d2jx)
      term = (d2kx+d2jx-d2jk) / xy
      aterm = (0.5_wp-0.25_wp*term)**alp
      t13 = r0jx/rjx
      t14 = t13**lj
      energies(xat) = energies(xat) + aterm*cc*(t14-damping*t13**lj2) / (1.0_wp+t14)
   end do

end subroutine get_xbond_energy


!> Get energy and its derivatives for halogen bonding interactions
subroutine get_xbond_derivs(mol, trans, list, damping, bond_strength, rad, &
      & energies, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points
   real(wp), intent(in) :: trans(:, :)
   !> Damping factor
   real(wp), intent(in) :: damping
   !> List of halogen bonded atoms
   integer, intent(in) :: list(:, :)
   !> Strength of the halogen bond
   real(wp), intent(in) :: bond_strength(:)
   !> Atomic radii for each species
   real(wp), intent(in) :: rad(:)
   !> Repulsion energy
   real(wp), intent(inout) :: energies(:)
   !> Molecular gradient of the repulsion energy
   real(wp), intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), intent(inout) :: sigma(:, :)

   integer :: ijk, jat, kat, xat, xzp, jzp, jtr, ktr
   real(wp) :: cc, r0jx, t13, t14
   real(wp) :: d2jx, rjx, rkx, term, aterm, xy, d2kx, d2jk
   real(wp) :: dxj(3), dxk(3), dkj(3), dcosterm
   real(wp) :: dtermlj, termlj, prefactor, numerator, denominator

   do ijk = 1, size(list, 2)
      xat = list(1, ijk)
      jat = list(2, ijk)
      kat = list(3, ijk)
      jtr = list(4, ijk)
      ktr = list(5, ijk)
      xzp = mol%id(xat)
      jzp = mol%id(jat)
      cc = bond_strength(xzp)
      r0jx = rad(xzp)+rad(jzp)

      dxj = mol%xyz(:, jat) - mol%xyz(:, xat)
      dxk = mol%xyz(:, kat) + trans(:, ktr) - mol%xyz(:, xat)
      dkj = mol%xyz(:, jat) + trans(:, jtr) - mol%xyz(:, kat) - trans(:, ktr)

      d2jx = sum(dxj*dxj)
      d2kx = sum(dxk*dxk)
      d2jk = sum(dkj*dkj)
      rjx = sqrt(d2jx)+1.0e-18_wp
      rkx = sqrt(d2kx)+1.0e-18_wp

      xy = sqrt(d2kx*d2jx)
      term = (d2kx+d2jx-d2jk) / xy
      ! now compute angular damping function
      aterm = (0.5_wp-0.25_wp*term)**alp

      t13 = r0jx/rjx
      t14 = t13**lj
      energies(xat) = energies(xat) + aterm*cc*(t14-damping*t13**lj2) / (1.0_wp+t14)

      ! set up weighted inverted distance and compute the modified Lennard-Jones potential
      t14 = (r0jx/rjx)**lj2 ! (rov/r)^lj2 ; lj2 = 6 in GFN1
      numerator = (t14*t14 - damping*t14)
      denominator = (1.0_wp + t14*t14)
      termLJ = numerator/denominator

      ! LJ derivative
      ! denominator part
      dtermlj = 2.0_wp*lj2*numerator*t14*t14/(rjx*denominator*denominator)
      ! numerator part
      dtermlj = dtermlj+lj2*t14*(damping - 2.0_wp*t14)/(rjx*denominator)
      ! scale w/ angular damping term
      dtermlj = dtermlj*aterm*cc/rjx
      ! gradient for the acceptor
      gradient(:, jat) = gradient(:, jat)+dtermlj*dxj(:)
      ! halogen gradient
      gradient(:, xat) = gradient(:, xat)-dtermlj*dxj(:)
      ! strain contribution
      sigma(:, :) = sigma + spread(dxj, 1, 3) * spread(dxj, 2, 3) * dtermlj

      ! cosine term derivative
      prefactor = -0.250_wp*alp*(0.5_wp-0.25_wp*term)**(alp-1.0_wp)
      prefactor = prefactor*cc*termlj
      ! AX part
      dcosterm = 2.0_wp/rkx - term/rjx
      dcosterm = dcosterm*prefactor/rjx
      ! gradient for the acceptor
      gradient(:, jat) = gradient(:, jat)+dcosterm*dxj(:)
      ! halogen gradient
      gradient(:, xat) = gradient(:, xat)-dcosterm*dxj(:)
      ! strain contribution
      sigma(:, :) = sigma + spread(dxj, 1, 3) * spread(dxj, 2, 3) * dcosterm
      ! KX part
      dcosterm = 2.0_wp/rjx - term/rkx
      dcosterm = dcosterm*prefactor/rkx
      ! gradient for the acceptor
      gradient(:, kat) = gradient(:, kat)+dcosterm*dxk(:)
      ! halogen gradient
      gradient(:, xat) = gradient(:, xat)-dcosterm*dxk(:)
      ! strain contribution
      sigma(:, :) = sigma + spread(dxk, 1, 3) * spread(dxk, 2, 3) * dcosterm
      ! JK part
      t13 = 2.0_wp*prefactor/xy
      ! acceptor
      gradient(:, jat) = gradient(:, jat)-t13*dkj(:)
      ! neighbor
      gradient(:, kat) = gradient(:, kat)+t13*dkj(:)
      ! strain contribution
      sigma(:, :) = sigma - spread(dkj, 1, 3) * spread(dkj, 2, 3) * t13
   end do

end subroutine get_xbond_derivs


end module tblite_classical_halogen

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/coulomb/multipole.f90
!> Provides an implemenation of a multipole based second-order electrostatic

!> Anisotropic second-order electrostatics using a damped multipole expansion
module tblite_coulomb_multipole
   use mctc_env, only : error_type, wp
   use mctc_io, only : structure_type
   use mctc_io_math, only : matdet_3x3, matinv_3x3
   use mctc_io_constants, only : pi
   use mctc_ncoord, only : new_ncoord, ncoord_type, cn_count
   use tblite_blas, only : dot, gemv, symv, gemm
   use tblite_container_cache, only : container_cache
   use tblite_coulomb_cache, only : coulomb_cache
   use tblite_coulomb_ewald, only : get_dir_cutoff, get_rec_cutoff
   use tblite_coulomb_type, only : coulomb_type
   use tblite_cutoff, only : get_lattice_points
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_wignerseitz, only : wignerseitz_cell
   implicit none
   private

   public :: new_damped_multipole


   !> Container to handle multipole electrostatics
   type, public, extends(coulomb_type) :: damped_multipole
      !> Damping function for inverse quadratic contributions
      real(wp) :: kdmp3 = 0.0_wp
      !> Damping function for inverse cubic contributions
      real(wp) :: kdmp5 = 0.0_wp
      !> Kernel for on-site dipole exchange-correlation
      real(wp), allocatable :: dkernel(:)
      !> Kernel for on-site quadrupolar exchange-correlation
      real(wp), allocatable :: qkernel(:)

      !> Shift for the generation of the multipolar damping radii
      real(wp) :: shift = 0.0_wp
      !> Exponent for the generation of the multipolar damping radii
      real(wp) :: kexp = 0.0_wp
      !> Maximum radius for the multipolar damping radii
      real(wp) :: rmax = 0.0_wp
      !> Base radii for the multipolar damping radii
      real(wp), allocatable :: rad(:)
      !> Valence coordination number
      real(wp), allocatable :: valence_cn(:)

      !> Coordination number container for multipolar damping radii
      class(ncoord_type), allocatable :: ncoord
   contains
      !> Update cache from container
      procedure :: update
      !> Return dependency on density
      procedure :: variable_info
      !> Get anisotropic electrostatic energy
      procedure :: get_energy
      !> Get anisotropic electrostatic potential
      procedure :: get_potential
      !> Get derivatives of anisotropic electrostatics
      procedure :: get_gradient
      ! These additional functions are necessary as the atomic contributions to AES are not 
      ! the same in this implemntation and in the GFN2 paper,
      ! for details see https://github.com/tblite/tblite/pull/224/files#r1970341792
      !> Get only AXC part of the anisotropic electrostatics
      procedure :: get_energy_axc
      !> Get AES energy of the anisotropic electrostatics
      procedure :: get_energy_aes
   end type damped_multipole

   real(wp), parameter :: unity(3, 3) = reshape([1, 0, 0, 0, 1, 0, 0, 0, 1], [3, 3])
   real(wp), parameter :: twopi = 2 * pi
   real(wp), parameter :: sqrtpi = sqrt(pi)
   real(wp), parameter :: eps = sqrt(epsilon(0.0_wp))
   real(wp), parameter :: conv = 100*eps
   character(len=*), parameter :: label = "anisotropic electrostatics"

contains


!> Create a new anisotropic electrostatics container
subroutine new_damped_multipole(self, mol, kdmp3, kdmp5, dkernel, qkernel, &
      & shift, kexp, rmax, rad, vcn, error)
   !> Instance of the multipole container
   type(damped_multipole), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Damping function for inverse quadratic contributions
   real(wp), intent(in) :: kdmp3
   !> Damping function for inverse cubic contributions
   real(wp), intent(in) :: kdmp5
   !> Kernel for on-site dipole exchange-correlation
   real(wp), intent(in) :: dkernel(:)
   !> Kernel for on-site quadrupolar exchange-correlation
   real(wp), intent(in) :: qkernel(:)
   !> Shift for the generation of the multipolar damping radii
   real(wp), intent(in) :: shift
   !> Exponent for the generation of the multipolar damping radii
   real(wp), intent(in) :: kexp
   !> Maximum radius for the multipolar damping radii
   real(wp), intent(in) :: rmax
   !> Base radii for the multipolar damping radii
   real(wp), intent(in) :: rad(:)
   !> Valence coordination number
   real(wp), intent(in) :: vcn(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   self%label = label
   self%kdmp3 = kdmp3
   self%kdmp5 = kdmp5
   self%dkernel = dkernel
   self%qkernel = qkernel

   self%shift = shift
   self%kexp = kexp
   self%rmax = rmax
   self%rad = rad
   self%valence_cn = vcn

   call new_ncoord(self%ncoord, mol, cn_count%dexp, error)
end subroutine new_damped_multipole


!> Update cache from container
subroutine update(self, mol, cache)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   type(coulomb_cache), pointer :: ptr

   call taint(cache, ptr)
   call ptr%update(mol)

   if (.not.allocated(ptr%mrad)) then
      allocate(ptr%mrad(mol%nat))
   end if
   if (.not.allocated(ptr%dmrdcn)) then
      allocate(ptr%dmrdcn(mol%nat))
   end if

   if (.not.allocated(ptr%amat_sd)) then
      allocate(ptr%amat_sd(3, mol%nat, mol%nat))
   end if
   if (.not.allocated(ptr%amat_dd)) then
      allocate(ptr%amat_dd(3, mol%nat, 3, mol%nat))
   end if
   if (.not.allocated(ptr%amat_sq)) then
      allocate(ptr%amat_sq(6, mol%nat, mol%nat))
   end if

   if (.not.allocated(ptr%cn)) then
      allocate(ptr%cn(mol%nat))
   end if
   if (.not.allocated(ptr%dcndr)) then
      allocate(ptr%dcndr(3, mol%nat, mol%nat))
   end if
   if (.not.allocated(ptr%dcndL)) then
      allocate(ptr%dcndL(3, 3, mol%nat))
   end if

   if (allocated(self%ncoord)) then
      call self%ncoord%get_cn(mol, ptr%cn, ptr%dcndr, ptr%dcndL)
   else
      ptr%cn(:) = self%valence_cn(mol%id)
      ptr%dcndr(:, :, :) = 0.0_wp
      ptr%dcndL(:, :, :) = 0.0_wp
   end if

   call get_mrad(mol, self%shift, self%kexp, self%rmax, self%rad, self%valence_cn, &
      & ptr%cn, ptr%mrad, ptr%dmrdcn)

   call get_multipole_matrix(self, mol, ptr, ptr%amat_sd, ptr%amat_dd, ptr%amat_sq)
end subroutine update


!> Get anisotropic electrostatic energy
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   real(wp), allocatable :: vs(:), vd(:, :), vq(:, :)
   type(coulomb_cache), pointer :: ptr

   call view(cache, ptr)

   allocate(vs(mol%nat), vd(3, mol%nat), vq(6, mol%nat))

   call gemv(ptr%amat_sd, wfn%qat(:, 1), vd)
   call gemv(ptr%amat_dd, wfn%dpat(:, :, 1), vd, beta=1.0_wp, alpha=0.5_wp)
   call gemv(ptr%amat_sq, wfn%qat(:, 1), vq)

   energies(:) = energies + sum(wfn%dpat(:, :, 1) * vd, 1) + sum(wfn%qpat(:, :, 1) * vq, 1)

   call get_kernel_energy(mol, self%dkernel, wfn%dpat(:, :, 1), energies)
   call get_kernel_energy(mol, self%qkernel, wfn%qpat(:, :, 1), energies)
end subroutine get_energy

!> Get anisotropic electrostatic energy
subroutine get_energy_aes(self, mol, cache, wfn, energies)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   real(wp), allocatable :: vs(:), vd(:, :), vq(:, :),mur(:)
   real(wp), allocatable :: e01(:),e11(:),e02(:)
   real(wp), allocatable :: t1(:)
   type(coulomb_cache), pointer :: ptr
   integer :: i,j

   call view(cache, ptr)

   allocate(vs(mol%nat), vd(3, mol%nat), vq(6, mol%nat))

   allocate(mur(mol%nat), source=0.0_wp)
   allocate(e01(mol%nat),e11(mol%nat),e02(mol%nat),source=0.0_wp)
   allocate(t1(mol%nat),source=0.0_wp)

   call gemv(ptr%amat_sd, wfn%qat(:, 1), vd)
   do i = 1,3
      call gemv(ptr%amat_sd(i,:,:),wfn%dpat(i,:,1),mur,beta=1.0_wp, alpha=1.0_wp,trans="T")
   end do

   e01 = (mur)*wfn%qat(:,1) + sum(wfn%dpat(:, :, 1) * vd, 1)

   vd = 0.0_wp
   call gemv(ptr%amat_dd, wfn%dpat(:, :, 1), vd, beta=1.0_wp, alpha=0.5_wp)
   e11 = sum(wfn%dpat(:, :, 1) * vd, 1)

   call gemv(ptr%amat_sq, wfn%qat(:, 1), vq)

   do i = 1,6
      call gemv(ptr%amat_sq(i,:,:),wfn%qpat(i,:,1),t1,beta=1.0_wp, alpha=1.0_wp,trans="T")
   end do
   e02 = t1*wfn%qat(:,1) + sum(wfn%qpat(:, :, 1) * vq, 1)

   energies(:) = energies + 0.5_wp * e01 + e11 + 0.5_wp * e02

end subroutine get_energy_aes

!> Get multipolar anisotropic exchange-correlation kernel
subroutine get_kernel_energy(mol, kernel, mpat, energies)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Multipole kernel
   real(wp), intent(in) :: kernel(:)
   !> Atomic multipole momemnt
   real(wp), intent(in) :: mpat(:, :)
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)

   integer :: iat, izp
   real(wp) :: mpt(size(mpat, 1)), mpscale(size(mpat, 1))

   mpscale(:) = 1
   if (size(mpat, 1) == 6) mpscale([2, 4, 5]) = 2

   do iat = 1, mol%nat
      izp = mol%id(iat)
      mpt(:) = mpat(:, iat) * mpscale
      energies(iat) = energies(iat) + kernel(izp) * dot_product(mpt, mpat(:, iat))
   end do
end subroutine get_kernel_energy


!> Get anisotropic electrostatic potential
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   type(coulomb_cache), pointer :: ptr

   call view(cache, ptr)

   call gemv(ptr%amat_sd, wfn%qat(:, 1), pot%vdp(:, :, 1), beta=1.0_wp)
   call gemv(ptr%amat_sd, wfn%dpat(:, :, 1), pot%vat(:, 1), beta=1.0_wp, trans="T")

   call gemv(ptr%amat_dd, wfn%dpat(:, :, 1), pot%vdp(:, :, 1), beta=1.0_wp)

   call gemv(ptr%amat_sq, wfn%qat(:, 1), pot%vqp(:, :, 1), beta=1.0_wp)
   call gemv(ptr%amat_sq, wfn%qpat(:, :, 1), pot%vat(:, 1), beta=1.0_wp, trans="T")

   call get_kernel_potential(mol, self%dkernel, wfn%dpat(:, :, 1), pot%vdp(:, :, 1))
   call get_kernel_potential(mol, self%qkernel, wfn%qpat(:, :, 1), pot%vqp(:, :, 1))
end subroutine get_potential


!> Get multipolar anisotropic potential contribution
subroutine get_kernel_potential(mol, kernel, mpat, vm)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Multipole kernel
   real(wp), intent(in) :: kernel(:)
   !> Atomic multipole momemnt
   real(wp), intent(in) :: mpat(:, :)
   !> Potential shoft on atomic multipole moment
   real(wp), intent(inout) :: vm(:, :)

   integer :: iat, izp
   real(wp) :: mpscale(size(mpat, 1))

   mpscale(:) = 1
   if (size(mpat, 1) == 6) mpscale([2, 4, 5]) = 2

   do iat = 1, mol%nat
      izp = mol%id(iat)
      vm(:, iat) = vm(:, iat) + 2*kernel(izp) * mpat(:, iat) * mpscale
   end do
end subroutine get_kernel_potential


!> Get derivatives of anisotropic electrostatics
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the repulsion energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   real(wp), allocatable :: dEdr(:)
   type(coulomb_cache), pointer :: ptr

   call view(cache, ptr)

   allocate(dEdr(mol%nat))
   dEdr = 0.0_wp

   call get_multipole_gradient(self, mol, ptr, &
      & wfn%qat(:, 1), wfn%dpat(:, :, 1), wfn%qpat(:, :, 1), &
      & dEdr, gradient, sigma)

   dEdr(:) = dEdr * ptr%dmrdcn

   call gemv(ptr%dcndr, dEdr, gradient, beta=1.0_wp)
   call gemv(ptr%dcndL, dEdr, sigma, beta=1.0_wp)
end subroutine get_gradient


!> Calculate multipole damping radii
subroutine get_mrad(mol, shift, kexp, rmax, rad, valence_cn, cn, mrad, dmrdcn)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Shift for the generation of the multipolar damping radii
   real(wp), intent(in) :: shift
   !> Exponent for the generation of the multipolar damping radii
   real(wp), intent(in) :: kexp
   !> Maximum radius for the multipolar damping radii
   real(wp), intent(in) :: rmax
   !> Base radii for the multipolar damping radii
   real(wp), intent(in) :: rad(:)
   !> Valence coordination number
   real(wp), intent(in) :: valence_cn(:)
   !> Coordination numbers for all atoms
   real(wp), intent(in) :: cn(:)
   !> Multipole damping radii for all atoms
   real(wp), intent(out) :: mrad(:)
   !> Derivative of multipole damping radii with repect to the coordination numbers
   real(wp), intent(out) :: dmrdcn(:)

   integer :: iat, izp
   real(wp) :: arg, t1, t2

   do iat = 1, mol%nat
      izp = mol%id(iat)
      arg = cn(iat) - valence_cn(izp) - shift
      t1 = exp(-kexp*arg)
      t2 = (rmax - rad(izp)) / (1.0_wp + t1)
      mrad(iat) = rad(izp) + t2
      dmrdcn(iat) = -t2 * kexp * t1 / (1.0_wp + t1)
   end do
end subroutine get_mrad


!> Get real lattice vectors
subroutine get_dir_trans(lattice, alpha, conv, trans)
   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)
   !> Parameter for Ewald summation
   real(wp), intent(in) :: alpha
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Translation vectors
   real(wp), allocatable, intent(out) :: trans(:, :)

   call get_lattice_points([.true.], lattice, get_dir_cutoff(alpha, conv), trans)

end subroutine get_dir_trans

!> Get reciprocal lattice translations
subroutine get_rec_trans(lattice, alpha, volume, conv, trans)
   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)
   !> Parameter for Ewald summation
   real(wp), intent(in) :: alpha
   !> Cell volume
   real(wp), intent(in) :: volume
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Translation vectors
   real(wp), allocatable, intent(out) :: trans(:, :)

   real(wp) :: rec_lat(3, 3)

   rec_lat = twopi*transpose(matinv_3x3(lattice))
   call get_lattice_points([.true.], rec_lat, get_rec_cutoff(alpha, volume, conv), trans)
   trans = trans(:, 2:)

end subroutine get_rec_trans


!> Get interaction matrix for all multipole moments up to inverse cubic order
subroutine get_multipole_matrix(self, mol, cache, amat_sd, amat_dd, amat_sq)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(coulomb_cache), intent(inout) :: cache
   !> Interation matrix for charges and dipoles
   real(wp), intent(inout) :: amat_sd(:, :, :)
   !> Interation matrix for dipoles and dipoles
   real(wp), intent(inout) :: amat_dd(:, :, :, :)
   !> Interation matrix for charges and quadrupoles
   real(wp), intent(inout) :: amat_sq(:, :, :)

   amat_sd(:, :, :) = 0.0_wp
   amat_dd(:, :, :, :) = 0.0_wp
   amat_sq(:, :, :) = 0.0_wp
   if (any(mol%periodic)) then
      call get_multipole_matrix_3d(mol, cache%mrad, self%kdmp3, self%kdmp5, &
         & cache%wsc, cache%alpha, amat_sd, amat_dd, amat_sq)
   else
      call get_multipole_matrix_0d(mol, cache%mrad, self%kdmp3, self%kdmp5, &
         & amat_sd, amat_dd, amat_sq)
   end if
end subroutine get_multipole_matrix

!> Calculate the multipole interaction matrix for finite systems
subroutine get_multipole_matrix_0d(mol, rad, kdmp3, kdmp5, amat_sd, amat_dd, amat_sq)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Multipole damping radii for all atoms
   real(wp), intent(in) :: rad(:)
   !> Damping function for inverse quadratic contributions
   real(wp), intent(in) :: kdmp3
   !> Damping function for inverse cubic contributions
   real(wp), intent(in) :: kdmp5
   !> Interaction matrix for charges and dipoles
   real(wp), intent(inout) :: amat_sd(:, :, :)
   !> Interaction matrix for dipoles and dipoles
   real(wp), intent(inout) :: amat_dd(:, :, :, :)
   !> Interaction matrix for charges and quadrupoles
   real(wp), intent(inout) :: amat_sq(:, :, :)

   integer :: iat, jat
   real(wp) :: r1, vec(3), g1, g3, g5, fdmp3, fdmp5, tc(6), rr

   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(amat_sd, amat_dd, amat_sq, mol, rad, kdmp3, kdmp5) &
   !$omp private(r1, vec, g1, g3, g5, fdmp3, fdmp5, tc, rr)
   do iat = 1, mol%nat
      do jat = 1, mol%nat
         if (iat == jat) cycle
         vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat)
         r1 = norm2(vec)
         g1 = 1.0_wp / r1
         g3 = g1 * g1 * g1
         g5 = g3 * g1 * g1

         rr = 0.5_wp * (rad(jat) + rad(iat)) * g1
         fdmp3 = 1.0_wp / (1.0_wp + 6.0_wp * rr**kdmp3)
         fdmp5 = 1.0_wp / (1.0_wp + 6.0_wp * rr**kdmp5)

         amat_sd(:, jat, iat) = amat_sd(:, jat, iat) + vec * g3 * fdmp3
         amat_dd(:, jat, :, iat) = amat_dd(:, jat, :, iat) &
            & + unity * g3*fdmp5 - spread(vec, 1, 3) * spread(vec, 2, 3) * 3*g5*fdmp5
         tc(2) = 2*vec(1)*vec(2)*g5*fdmp5
         tc(4) = 2*vec(1)*vec(3)*g5*fdmp5
         tc(5) = 2*vec(2)*vec(3)*g5*fdmp5
         tc(1) = vec(1)*vec(1)*g5*fdmp5
         tc(3) = vec(2)*vec(2)*g5*fdmp5
         tc(6) = vec(3)*vec(3)*g5*fdmp5
         amat_sq(:, jat, iat) = amat_sq(:, jat, iat) + tc
      end do
   end do
end subroutine get_multipole_matrix_0d

!> Evaluate multipole interaction matrix under 3D periodic boundary conditions
subroutine get_multipole_matrix_3d(mol, rad, kdmp3, kdmp5, wsc, alpha, &
      & amat_sd, amat_dd, amat_sq)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Multipole damping radii for all atoms
   real(wp), intent(in) :: rad(:)
   !> Damping function for inverse quadratic contributions
   real(wp), intent(in) :: kdmp3
   !> Damping function for inverse cubic contributions
   real(wp), intent(in) :: kdmp5
   !> Wigner-Seitz cell images
   type(wignerseitz_cell), intent(in) :: wsc
   !> Convergence parameter for Ewald sum
   real(wp), intent(in) :: alpha
   !> Interation matrix for charges and dipoles
   real(wp), intent(inout) :: amat_sd(:, :, :)
   !> Interation matrix for dipoles and dipoles
   real(wp), intent(inout) :: amat_dd(:, :, :, :)
   !> Interation matrix for charges and quadrupoles
   real(wp), intent(inout) :: amat_sq(:, :, :)

   integer :: iat, jat, img, k
   real(wp) :: vec(3), rr, wsw, vol
   real(wp) :: d_sd(3), d_dd(3, 3), d_sq(6), r_sd(3), r_dd(3, 3), r_sq(6)
   real(wp), allocatable :: dtrans(:, :), rtrans(:, :)

   vol = abs(matdet_3x3(mol%lattice))
   call get_dir_trans(mol%lattice, alpha, conv, dtrans)
   call get_rec_trans(mol%lattice, alpha, vol, conv, rtrans)

   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(amat_sd, amat_dd, amat_sq) &
   !$omp shared(mol, wsc, rad, vol, alpha, rtrans, dtrans, kdmp3, kdmp5) &
   !$omp private(iat, jat, img, vec, rr, wsw, d_sd, d_dd, d_sq, r_sd, r_dd, r_sq)
   do iat = 1, mol%nat
      do jat = 1, mol%nat
         wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, iat) - mol%xyz(:, jat) - wsc%trans(:, wsc%tridx(img, jat, iat))

            rr = 0.5_wp * (rad(jat) + rad(iat))
            call get_amat_sdq_rec_3d(vec, vol, alpha, rtrans, r_sd, r_dd, r_sq)
            call get_amat_sdq_dir_3d(vec, rr, kdmp3, kdmp5, alpha, dtrans, d_sd, d_dd, d_sq)

            amat_sd(:, jat, iat) = amat_sd(:, jat, iat) + wsw * (d_sd + r_sd)
            amat_dd(:, jat, :, iat) = amat_dd(:, jat, :, iat) + wsw * (r_dd + d_dd)
            amat_sq(:, jat, iat) = amat_sq(:, jat, iat) + wsw * (r_sq + d_sq)
         end do
      end do
   end do

   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(amat_sd, amat_dd, amat_sq, mol, vol, alpha) private(iat, rr, k)
   do iat = 1, mol%nat
      ! dipole-dipole selfenergy: -2/3·α³/sqrt(π) Σ(i) μ²(i)
      rr = -2.0_wp/3.0_wp * alpha**3 / sqrtpi
      do k = 1, 3
         amat_dd(k, iat, k, iat) = amat_dd(k, iat, k, iat) + 2*rr
      end do

      ! charge-quadrupole selfenergy: 4/9·α³/sqrt(π) Σ(i) q(i)Tr(θi)
      ! (no actual contribution since quadrupoles are traceless)
      rr = 4.0_wp/9.0_wp * alpha**3 / sqrtpi
      amat_sq([1, 3, 6], iat, iat) = amat_sq([1, 3, 6], iat, iat) + rr
   end do
end subroutine get_multipole_matrix_3d

pure subroutine get_amat_sdq_rec_3d(rij, vol, alp, trans, amat_sd, amat_dd, amat_sq)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: vol
   real(wp), intent(in) :: alp
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(out) :: amat_sd(:)
   real(wp), intent(out) :: amat_dd(:, :)
   real(wp), intent(out) :: amat_sq(:)

   integer :: itr
   real(wp) :: fac, vec(3), g2, expk, sink, cosk, gv

   amat_sd = 0.0_wp
   amat_dd = 0.0_wp
   amat_sq = 0.0_wp
   fac = 4*pi/vol

   amat_dd(1, 1) = fac/6.0_wp
   amat_dd(2, 2) = fac/6.0_wp
   amat_dd(3, 3) = fac/6.0_wp
   amat_sq([1, 3, 6]) = -fac/9.0_wp

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      gv = dot_product(rij, vec)
      expk = fac*exp(-0.25_wp*g2/(alp*alp))/g2
      sink = sin(gv)*expk
      cosk = cos(gv)*expk

      amat_sd(:) = amat_sd + 2*vec*sink
      amat_dd(:, :) = amat_dd + spread(vec, 1, 3) * spread(vec, 2, 3) * cosk
      amat_sq(1) = amat_sq(1) +   vec(1)*vec(1)*cosk
      amat_sq(2) = amat_sq(2) + 2*vec(1)*vec(2)*cosk
      amat_sq(3) = amat_sq(3) +   vec(2)*vec(2)*cosk
      amat_sq(4) = amat_sq(4) + 2*vec(1)*vec(3)*cosk
      amat_sq(5) = amat_sq(5) + 2*vec(2)*vec(3)*cosk
      amat_sq(6) = amat_sq(6) +   vec(3)*vec(3)*cosk
   end do

end subroutine get_amat_sdq_rec_3d

pure subroutine get_amat_sdq_dir_3d(rij, rr, kdmp3, kdmp5, alp, trans, &
      & amat_sd, amat_dd, amat_sq)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: rr
   real(wp), intent(in) :: kdmp3
   real(wp), intent(in) :: kdmp5
   real(wp), intent(in) :: alp
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(out) :: amat_sd(:)
   real(wp), intent(out) :: amat_dd(:, :)
   real(wp), intent(out) :: amat_sq(:)

   integer :: itr
   real(wp) :: vec(3), r1, tmp, fdmp3, fdmp5, g1, g3, g5, arg, arg2, alp2, e1, e2, erft, expt

   amat_sd = 0.0_wp
   amat_dd = 0.0_wp
   amat_sq = 0.0_wp
   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      g1 = 1.0_wp/r1
      g3 = g1 * g1 * g1
      g5 = g3 * g1 * g1
      fdmp3 = 1.0_wp / (1.0_wp + 6.0_wp * (rr/r1)**kdmp3)
      fdmp5 = 1.0_wp / (1.0_wp + 6.0_wp * (rr/r1)**kdmp5)

      arg = r1*alp
      arg2 = arg*arg
      expt = exp(-arg2)/sqrtpi
      erft = -erf(arg)*g1
      e1 = g1*g1 * (erft + 2*expt*alp)
      e2 = g1*g1 * (e1 + 4*expt*alp2*alp/3)

      tmp = fdmp3 * g3 + e1
      amat_sd = amat_sd + vec * tmp
      amat_dd(:, :) = amat_dd(:, :) + unity * (fdmp5*g3 + e1) &
         & - spread(vec, 1, 3) * spread(vec, 2, 3) * (3 * (g5*fdmp5 + e2))
      amat_sq(1) = amat_sq(1) +   vec(1)*vec(1)*(g5*fdmp5 + e2) - (fdmp5*g3 + e1)/3.0_wp
      amat_sq(2) = amat_sq(2) + 2*vec(1)*vec(2)*(g5*fdmp5 + e2)
      amat_sq(3) = amat_sq(3) +   vec(2)*vec(2)*(g5*fdmp5 + e2) - (fdmp5*g3 + e1)/3.0_wp
      amat_sq(4) = amat_sq(4) + 2*vec(1)*vec(3)*(g5*fdmp5 + e2)
      amat_sq(5) = amat_sq(5) + 2*vec(2)*vec(3)*(g5*fdmp5 + e2)
      amat_sq(6) = amat_sq(6) +   vec(3)*vec(3)*(g5*fdmp5 + e2) - (fdmp5*g3 + e1)/3.0_wp
   end do

end subroutine get_amat_sdq_dir_3d


!> Calculate derivatives of multipole interactions
subroutine get_multipole_gradient(self, mol, cache, qat, dpat, qpat, dEdr, gradient, sigma)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(coulomb_cache), intent(inout) :: cache
   !> Atomic partial charges
   real(wp), contiguous, intent(in) :: qat(:)
   !> Atomic dipole moments
   real(wp), contiguous, intent(in) :: dpat(:, :)
   !> Atomic quadrupole moments
   real(wp), contiguous, intent(in) :: qpat(:, :)
   !> Derivative of the energy w.r.t. the critical radii
   real(wp), contiguous, intent(inout) :: dEdr(:)
   !> Derivative of the energy w.r.t. atomic displacements
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Derivative of the energy w.r.t. strain deformations
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   if (any(mol%periodic)) then
      call get_multipole_gradient_3d(mol, cache%mrad, self%kdmp3, self%kdmp5, &
         & qat, dpat, qpat, cache%wsc, cache%alpha, dEdr, gradient, sigma)
   else
      call get_multipole_gradient_0d(mol, cache%mrad, self%kdmp3, self%kdmp5, &
         & qat, dpat, qpat, dEdr, gradient, sigma)
   end if
end subroutine get_multipole_gradient

!> Evaluate multipole derivatives for finite systems
subroutine get_multipole_gradient_0d(mol, rad, kdmp3, kdmp5, qat, dpat, qpat, &
      & dEdr, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Multipole damping radii for all atoms
   real(wp), intent(in) :: rad(:)
   !> Damping function for inverse quadratic contributions
   real(wp), intent(in) :: kdmp3
   !> Damping function for inverse cubic contributions
   real(wp), intent(in) :: kdmp5
   !> Atomic partial charges
   real(wp), contiguous, intent(in) :: qat(:)
   !> Atomic dipole moments
   real(wp), contiguous, intent(in) :: dpat(:, :)
   !> Atomic quadrupole moments
   real(wp), contiguous, intent(in) :: qpat(:, :)
   !> Derivative of the energy w.r.t. the critical radii
   real(wp), contiguous, intent(inout) :: dEdr(:)
   !> Derivative of the energy w.r.t. atomic displacements
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Derivative of the energy w.r.t. strain deformations
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   integer :: iat, jat
   real(wp) :: r1, r2, vec(3), rr, fdmp3, fdmp5, g1, g3, g5, g7, dG(3), dS(3, 3)
   real(wp) :: ddmp3, ddmp5, fddr, eq, edd, dpidpj, dpiv, dpjv, dpiqj, qidpj

   !$omp parallel do default(none) schedule(runtime) reduction(+:dEdr, gradient, sigma) &
   !$omp shared(mol, kdmp3, kdmp5, rad, qat, dpat, qpat) &
   !$omp private(iat, jat, r1, r2, vec, rr, fdmp3, fdmp5, g1, g3, g5, g7, dG, dS, &
   !$omp& ddmp3, ddmp5, fddr, eq, edd, dpidpj, dpiv, dpjv, dpiqj, qidpj)
   do iat = 1, mol%nat
      do jat = 1, iat - 1
         rr = 0.5_wp*(rad(iat)+rad(jat))
         vec(:) = mol%xyz(:, jat)-mol%xyz(:, iat)
         r1 = norm2(vec)
         r2 = r1 * r1
         g1 = 1.0_wp/r1
         g3 = g1 * g1 * g1
         g5 = g3 * g1 * g1
         g7 = g5 * g1 * g1

         fdmp3 = 1.0_wp/(1.0_wp+6.0_wp*(rr*g1)**kdmp3)
         ddmp3 = -3*g5*fdmp3 - kdmp3*fdmp3*(fdmp3-1.0_wp)*g5
         fdmp5 = 1.0_wp/(1.0_wp+6.0_wp*(rr*g1)**kdmp5)
         ddmp5 = -5*fdmp5 - kdmp5*(fdmp5*fdmp5-fdmp5)

         dpiqj = dot_product(vec, dpat(:, iat))*qat(jat)
         qidpj = dot_product(vec, dpat(:, jat))*qat(iat)
         fddr = 3.0_wp*(dpiqj - qidpj)*kdmp3*fdmp3*g3*(fdmp3/rr)*(rr*g1)**kdmp3
         dg(:) = - ddmp3*vec * (dpiqj - qidpj) &
            & + fdmp3*g3*(qat(iat)*dpat(:, jat) - qat(jat)*dpat(:, iat))
         ds(:, :) = - 0.5_wp * (spread(vec, 1, 3) * spread(dG, 2, 3) &
            & + spread(dG, 1, 3) * spread(vec, 2, 3))

         dEdr(iat) = dEdr(iat) + fddr
         dEdr(jat) = dEdr(jat) + fddr
         gradient(:, iat) = gradient(:, iat) + dG
         gradient(:, jat) = gradient(:, jat) - dG
         sigma(:, :) = sigma + dS

         dpidpj = dot_product(dpat(:, jat), dpat(:, iat))
         dpiv = dot_product(dpat(:, iat), vec)
         dpjv = dot_product(dpat(:, jat), vec)
         edd = dpidpj*r2 - 3*dpjv*dpiv
         fddr = 3.0_wp*edd*kdmp5*fdmp5*g5*(fdmp5/rr)*(rr*g1)**kdmp5
         dg(:) = - 2.0_wp*fdmp5*g5*dpidpj*vec &
            & + 3.0_wp*fdmp5*g5*(dpiv*dpat(:, jat) + dpjv*dpat(:, iat)) &
            & - edd*ddmp5*g7*vec
         ds(:, :) = - 0.5_wp * (spread(vec, 1, 3) * spread(dg, 2, 3) &
            & + spread(dg, 1, 3) * spread(vec, 2, 3))

         dEdr(iat) = dEdr(iat) + fddr
         dEdr(jat) = dEdr(jat) + fddr
         gradient(:, iat) = gradient(:, iat) + dg
         gradient(:, jat) = gradient(:, jat) - dg
         sigma(:, :) = sigma + ds

         eq = &
            & + 2*(qat(jat)*qpat(2,iat) + qpat(2,jat)*qat(iat))*vec(1)*vec(2) &
            & + 2*(qat(jat)*qpat(4,iat) + qpat(4,jat)*qat(iat))*vec(1)*vec(3) &
            & + 2*(qat(jat)*qpat(5,iat) + qpat(5,jat)*qat(iat))*vec(2)*vec(3) &
            & + (qat(jat)*qpat(1,iat) + qpat(1,jat)*qat(iat))*vec(1)*vec(1) &
            & + (qat(jat)*qpat(3,iat) + qpat(3,jat)*qat(iat))*vec(2)*vec(2) &
            & + (qat(jat)*qpat(6,iat) + qpat(6,jat)*qat(iat))*vec(3)*vec(3)

         fddr = eq * 3.0_wp*kdmp5*fdmp5*g5*fdmp5/rr*(rr*g1)**kdmp5
         dg(:) = - eq*ddmp5*g7*vec &
            & - 2.0_wp*fdmp5*g5*qat(iat) * &
            &[vec(1)*qpat(1,jat) + vec(2)*qpat(2,jat) + vec(3)*qpat(4,jat), &
            & vec(1)*qpat(2,jat) + vec(2)*qpat(3,jat) + vec(3)*qpat(5,jat), &
            & vec(1)*qpat(4,jat) + vec(2)*qpat(5,jat) + vec(3)*qpat(6,jat)] &
            & - 2.0_wp*fdmp5*g5*qat(jat) * &
            &[vec(1)*qpat(1,iat) + vec(2)*qpat(2,iat) + vec(3)*qpat(4,iat), &
            & vec(1)*qpat(2,iat) + vec(2)*qpat(3,iat) + vec(3)*qpat(5,iat), &
            & vec(1)*qpat(4,iat) + vec(2)*qpat(5,iat) + vec(3)*qpat(6,iat)]
         ds(:, :) = - 0.5_wp * (spread(vec, 1, 3) * spread(dG, 2, 3) &
            & + spread(dG, 1, 3) * spread(vec, 2, 3))

         dEdr(iat) = dEdr(iat) + fddr
         dEdr(jat) = dEdr(jat) + fddr
         gradient(:, iat) = gradient(:, iat) + dg
         gradient(:, jat) = gradient(:, jat) - dg
         sigma(:, :) = sigma + ds
      end do
   end do
end subroutine get_multipole_gradient_0d

!> Evaluate multipole derivatives under 3D periodic boundary conditions
subroutine get_multipole_gradient_3d(mol, rad, kdmp3, kdmp5, qat, dpat, qpat, wsc, alpha, &
      & dEdr, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Multipole damping radii for all atoms
   real(wp), intent(in) :: rad(:)
   !> Damping function for inverse quadratic contributions
   real(wp), intent(in) :: kdmp3
   !> Damping function for inverse cubic contributions
   real(wp), intent(in) :: kdmp5
   !> Atomic partial charges
   real(wp), contiguous, intent(in) :: qat(:)
   !> Atomic dipole moments
   real(wp), contiguous, intent(in) :: dpat(:, :)
   !> Atomic quadrupole moments
   real(wp), contiguous, intent(in) :: qpat(:, :)
   !> Wigner-Seitz cell images
   type(wignerseitz_cell), intent(in) :: wsc
   !> Convergence parameter for Ewald sum
   real(wp), intent(in) :: alpha
   !> Derivative of the energy w.r.t. the critical radii
   real(wp), contiguous, intent(inout) :: dEdr(:)
   !> Derivative of the energy w.r.t. atomic displacements
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Derivative of the energy w.r.t. strain deformations
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   integer :: iat, jat, img
   real(wp) :: vec(3), dG(3), dGr(3), dGd(3), dS(3, 3), dSr(3, 3), dSd(3, 3)
   real(wp) :: wsw, vol, rr, dE, dEd
   real(wp), allocatable :: dtrans(:, :), rtrans(:, :)

   vol = abs(matdet_3x3(mol%lattice))
   call get_dir_trans(mol%lattice, alpha, conv, dtrans)
   call get_rec_trans(mol%lattice, alpha, vol, conv, rtrans)

   !$omp parallel do default(none) schedule(runtime) reduction(+:dEdr, gradient, sigma) &
   !$omp shared(mol, wsc, kdmp3, kdmp5, vol, alpha, rtrans, dtrans, rad, qat, dpat, qpat) &
   !$omp private(iat, jat, dE, dG, dS, wsw, img, vec, rr, dEd, dGd, dGr, dSd, dSr)
   do iat = 1, mol%nat
      do jat = 1, iat - 1
         dE = 0.0_wp
         dG(:) = 0.0_wp
         dS(:, :) = 0.0_wp
         wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
         do img = 1, wsc%nimg(jat, iat)
            vec(:) = mol%xyz(:, jat)-mol%xyz(:, iat) + wsc%trans(:, wsc%tridx(img, jat, iat))
            rr = 0.5_wp * (rad(jat) + rad(iat))

            call get_damat_sdq_rec_3d(vec, qat(iat), qat(jat), dpat(:, iat), dpat(:, jat), &
               & qpat(:, iat), qpat(:, jat), vol, alpha, rtrans, dGr, dSr)
            call get_damat_sdq_dir_3d(vec, qat(iat), qat(jat), dpat(:, iat), dpat(:, jat), &
               & qpat(:, iat), qpat(:, jat), rr, kdmp3, kdmp5, alpha, dtrans, dEd, dGd, dSd)
            dE = dE + dEd * wsw
            dG = dG + (dGd + dGr) * wsw
            dS = dS + (dSd + dSr) * wsw
         end do
         dEdr(iat) = dEdr(iat) + dE
         dEdr(jat) = dEdr(jat) + dE
         gradient(:, iat) = gradient(:, iat) + dG
         gradient(:, jat) = gradient(:, jat) - dG
         sigma = sigma + dS
      end do
   end do

   !$omp parallel do default(none) schedule(runtime) reduction(+:dEdr, sigma) &
   !$omp shared(mol, wsc, kdmp3, kdmp5, vol, alpha, rtrans, dtrans, rad, qat, dpat, qpat) &
   !$omp private(iat, jat, dE, dG, dS, wsw, img, vec, rr, dEd, dGd, dGr, dSd, dSr)
   do iat = 1, mol%nat
      dE = 0.0_wp
      dS(:, :) = 0.0_wp
      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec(:) = wsc%trans(:, wsc%tridx(img, iat, iat))
         rr = rad(iat)

         call get_damat_sdq_rec_3d(vec, qat(iat), qat(iat), dpat(:, iat), dpat(:, iat), &
            & qpat(:, iat), qpat(:, iat), vol, alpha, rtrans, dGr, dSr)
         call get_damat_sdq_dir_3d(vec, qat(iat), qat(iat), dpat(:, iat), dpat(:, iat), &
            & qpat(:, iat), qpat(:, iat), rr, kdmp3, kdmp5, alpha, dtrans, dEd, dGd, dSd)
         dE = dE + dEd * wsw
         dS = dS + (dSd + dSr) * wsw
      end do
      dEdr(iat) = dEdr(iat) + dE
      sigma = sigma + 0.5_wp * dS
   end do
end subroutine get_multipole_gradient_3d

pure subroutine get_damat_sdq_rec_3d(rij, qi, qj, mi, mj, ti, tj, vol, alp, trans, dg, ds)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: qi, qj, mi(3), mj(3), ti(6), tj(6)
   real(wp), intent(in) :: vol
   real(wp), intent(in) :: alp
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(out) :: dg(3)
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr, a, b
   real(wp) :: fac, vec(3), g2, gv, expk, alp2, sink, cosk, dpiqj, qidpj
   real(wp) :: qpiqj, qiqpj, dpiv, dpjv, tiv(3), tjv(3)

   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp
   fac = 4*pi/vol
   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      gv = dot_product(rij, vec)
      expk = fac*exp(-0.25_wp*g2/alp2)/g2
      cosk = cos(gv)*expk
      sink = sin(gv)*expk

      dpiqj = dot_product(vec, mi)*qj
      qidpj = dot_product(vec, mj)*qi

      dg(:) = dg - 2*vec*cosk * (dpiqj - qidpj)
      do b = 1, 3
         do a = 1, 3
            ds(a, b) = ds(a, b) &
               & + 2 * sink * (dpiqj - qidpj) * ((2.0_wp/g2 + 0.5_wp/alp2) * vec(a)*vec(b) - unity(a, b)) &
               & - sink*(vec(a)*(qj*mi(b) - qi*mj(b)) + vec(b)*(qj*mi(a) - qi*mj(a)))
         end do
      end do

      dpiv = dot_product(mi, vec)
      dpjv = dot_product(mj, vec)

      dg(:) = dg + vec*sink*dpiv*dpjv
      do b = 1, 3
         do a = 1, 3
            ds(a, b) = ds(a, b) &
               & + cosk * dpiv*dpjv * ((2.0_wp/g2 + 0.5_wp/alp2) * vec(a)*vec(b) - unity(a, b)) &
               & - 0.5_wp*cosk*(vec(a)*(mi(b)*dpjv + mj(b)*dpiv) + vec(b)*(mi(a)*dpjv + mj(a)*dpiv))
         end do
      end do

      qiqpj = qi*(tj(1)*vec(1)*vec(1) + tj(3)*vec(2)*vec(2) + tj(6)*vec(3)*vec(3) &
         & + 2*tj(2)*vec(1)*vec(2) + 2*tj(4)*vec(1)*vec(3) + 2*tj(5)*vec(2)*vec(3))
      qpiqj = qj*(ti(1)*vec(1)*vec(1) + ti(3)*vec(2)*vec(2) + ti(6)*vec(3)*vec(3) &
         & + 2*ti(2)*vec(1)*vec(2) + 2*ti(4)*vec(1)*vec(3) + 2*ti(5)*vec(2)*vec(3))
      tiv = [ti(1)*vec(1) + ti(2)*vec(2) + ti(4)*vec(3), &
         & ti(2)*vec(1) + ti(3)*vec(2) + ti(5)*vec(3), &
         & ti(4)*vec(1) + ti(5)*vec(2) + ti(6)*vec(3)]
      tjv = [tj(1)*vec(1) + tj(2)*vec(2) + tj(4)*vec(3), &
         & tj(2)*vec(1) + tj(3)*vec(2) + tj(5)*vec(3), &
         & tj(4)*vec(1) + tj(5)*vec(2) + tj(6)*vec(3)]

      dg(:) = dg + vec * sink * (qiqpj + qpiqj)
      do b = 1, 3
         do a = 1, 3
            ds(a, b) = ds(a, b) &
               & + cosk * (qiqpj + qpiqj) * ((2.0_wp/g2 + 0.5_wp/alp2) * vec(a)*vec(b) - unity(a, b)) &
               & - cosk*(vec(a)*(qi*tjv(b) + qj*tiv(b)) + vec(b)*(qi*tjv(a) + qj*tiv(a)))
         end do
      end do
   end do

end subroutine get_damat_sdq_rec_3d

pure subroutine get_damat_sdq_dir_3d(rij, qi, qj, mi, mj, ti, tj, rr, kdmp3, kdmp5, &
      & alp, trans, de, dg, ds)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: qi, qj, mi(3), mj(3), ti(6), tj(6)
   real(wp), intent(in) :: rr
   real(wp), intent(in) :: kdmp3
   real(wp), intent(in) :: kdmp5
   real(wp), intent(in) :: alp
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(out) :: de
   real(wp), intent(out) :: dg(3)
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr, k, a, b, c
   real(wp) :: vec(3), r1, r2, g1, g3, g5, g7, fdmp3, fdmp5, ddmp3, ddmp5, dpiqj, qidpj
   real(wp) :: alp2, arg, arg2, erft, expt, e1, e2, e3, tabc(3, 3, 3), tab(3, 3)
   real(wp) :: dpidpj, dpiv, dpjv, edd, eq, g_sd(3), g_dd(3), g_sq(3)

   de = 0.0_wp
   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp

   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      r2 = r1 * r1
      g1 = 1.0_wp/r1
      g3 = g1 * g1 * g1
      g5 = g3 * g1 * g1
      g7 = g5 * g1 * g1

      arg = r1*alp
      arg2 = arg*arg
      erft = -erf(arg)*g1
      expt = exp(-arg2)/sqrtpi
      e1 = g1*g1 * (erft + expt*(2*alp2)/alp)
      e2 = g1*g1 * (e1 + expt*(2*alp2)**2/(3*alp))
      e3 = g1*g1 * (e2 + expt*(2*alp2)**3/(15*alp))

      fdmp3 = 1.0_wp/(1.0_wp+6.0_wp*(rr*g1)**kdmp3)
      ddmp3 = -3*fdmp3 - kdmp3*fdmp3*(fdmp3-1.0_wp)
      fdmp5 = 1.0_wp/(1.0_wp+6.0_wp*(rr*g1)**kdmp5)
      ddmp5 = -5*fdmp5 - kdmp5*(fdmp5*fdmp5-fdmp5)

      dpiqj = dot_product(vec, mi)*qj
      qidpj = dot_product(vec, mj)*qi
      dpidpj = dot_product(mj, mi)
      dpiv = dot_product(mi, vec)
      dpjv = dot_product(mj, vec)
      edd = dpidpj*r2 - 3*dpjv*dpiv

      ! Charge - dipole
      g_sd(:) = - (ddmp3*g5)*vec * (dpiqj - qidpj) + fdmp3*g3*(qi*mj - qj*mi)

      do b = 1, 3
         do a = 1, 3
            tab(a, b) = 3*vec(a)*vec(b)*e2
         end do
         tab(b, b) = tab(b, b) - e1
      end do

      do k = 1, 3
         g_sd(k) = g_sd(k) &
            & + qj * (tab(1, k) * mi(1) &
            &       + tab(2, k) * mi(2) &
            &       + tab(3, k) * mi(3))&
            & - qi * (tab(1, k) * mj(1) &
            &       + tab(2, k) * mj(2) &
            &       + tab(3, k) * mj(3))
      end do

      de = de + 3.0_wp*(dpiqj - qidpj)*kdmp3*fdmp3*g3*(fdmp3/rr)*(rr*g1)**kdmp3
      dg(:) = dg + g_sd
      ds(:, :) = ds - 0.5_wp * (spread(vec, 1, 3) * spread(g_sd, 2, 3) &
         & + spread(g_sd, 1, 3) * spread(vec, 2, 3))

      ! Dipole - dipole
      g_dd(:) = - 2.0_wp*fdmp5*g5*dpidpj*vec &
         & + 3.0_wp*fdmp5*g5*(dpiv*mj + dpjv*mi) &
         & - edd*ddmp5*g7*vec

      do c = 1, 3
         do b = 1, 3
            do a = 1, 3
               tabc(a, b, c) = - 15*vec(a)*vec(b)*vec(c)*e3
            end do
         end do
         do a = 1, 3
            tabc(a, a, c) = tabc(a, a, c) + 3*e2*vec(c)
            tabc(c, a, c) = tabc(c, a, c) + 3*e2*vec(a)
            tabc(a, c, c) = tabc(a, c, c) + 3*e2*vec(a)
         end do
      end do

      do k = 1, 3
         g_dd(k) = g_dd(k) &
            & + mi(1)*(tabc(1, 1, k) * mj(1) &
            &        + tabc(2, 1, k) * mj(2) &
            &        + tabc(3, 1, k) * mj(3))&
            & + mi(2)*(tabc(1, 2, k) * mj(1) &
            &        + tabc(2, 2, k) * mj(2) &
            &        + tabc(3, 2, k) * mj(3))&
            & + mi(3)*(tabc(1, 3, k) * mj(1) &
            &        + tabc(2, 3, k) * mj(2) &
            &        + tabc(3, 3, k) * mj(3))
      end do

      de = de + 3.0_wp*edd*kdmp5*fdmp5*g5*(fdmp5/rr)*(rr*g1)**kdmp5
      dg(:) = dg + g_dd
      ds(:, :) = ds - 0.5_wp * (spread(vec, 1, 3) * spread(g_dd, 2, 3) &
         & + spread(g_dd, 1, 3) * spread(vec, 2, 3))

      ! Charge - quadrupole
      eq = &
         & + 2*(qj*ti(2) + tj(2)*qi)*vec(1)*vec(2) &
         & + 2*(qj*ti(4) + tj(4)*qi)*vec(1)*vec(3) &
         & + 2*(qj*ti(5) + tj(5)*qi)*vec(2)*vec(3) &
         & + (qj*ti(1) + tj(1)*qi)*vec(1)*vec(1) &
         & + (qj*ti(3) + tj(3)*qi)*vec(2)*vec(2) &
         & + (qj*ti(6) + tj(6)*qi)*vec(3)*vec(3)

      g_sq(:) = - eq*ddmp5*g7*vec &
         & - 2.0_wp*fdmp5*g5*qi * &
         &[vec(1)*tj(1) + vec(2)*tj(2) + vec(3)*tj(4), &
         & vec(1)*tj(2) + vec(2)*tj(3) + vec(3)*tj(5), &
         & vec(1)*tj(4) + vec(2)*tj(5) + vec(3)*tj(6)] &
         & - 2.0_wp*fdmp5*g5*qj * &
         &[vec(1)*ti(1) + vec(2)*ti(2) + vec(3)*ti(4), &
         & vec(1)*ti(2) + vec(2)*ti(3) + vec(3)*ti(5), &
         & vec(1)*ti(4) + vec(2)*ti(5) + vec(3)*ti(6)]

      do k = 1, 3
         g_sq(k) = g_sq(k) + (&
            & - qi * (tabc(1, 1, k) * tj(1) &
            &     + 2*tabc(2, 1, k) * tj(2) &
            &     + 2*tabc(3, 1, k) * tj(4) &
            &     +   tabc(2, 2, k) * tj(3) &
            &     + 2*tabc(3, 2, k) * tj(5) &
            &     +   tabc(3, 3, k) * tj(6))&
            & - qj * (tabc(1, 1, k) * ti(1) &
            &     + 2*tabc(2, 1, k) * ti(2) &
            &     + 2*tabc(3, 1, k) * ti(4) &
            &     +   tabc(2, 2, k) * ti(3) &
            &     + 2*tabc(3, 2, k) * ti(5) &
            &     +   tabc(3, 3, k) * ti(6)))/3.0_wp
      end do

      de = de + eq * 3.0_wp*kdmp5*fdmp5*g5*fdmp5/rr*(rr*g1)**kdmp5
      dg(:) = dg + g_sq
      ds(:, :) = ds - 0.5_wp * (spread(vec, 1, 3) * spread(g_sq, 2, 3) &
         & + spread(g_sq, 1, 3) * spread(vec, 2, 3))
   end do

end subroutine get_damat_sdq_dir_3d


!> Get information about density dependent quantities used in the energy
pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, atom_resolved
   !> Instance of the electrostatic container
   class(damped_multipole), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(dipole=atom_resolved, quadrupole=atom_resolved)
end function variable_info


!> Inspect container cache and reallocate it in case of type mismatch
subroutine taint(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(coulomb_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(coulomb_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

!> Return reference to container cache after resolving its type
subroutine view(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(coulomb_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(coulomb_cache)
      ptr => target
   end select
end subroutine view

subroutine get_energy_axc(self, mol, wfn, energies)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)

   call get_kernel_energy(mol, self%dkernel, wfn%dpat(:, :, 1), energies)
   call get_kernel_energy(mol, self%qkernel, wfn%qpat(:, :, 1), energies)

end subroutine get_energy_axc

end module tblite_coulomb_multipole

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_spin
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type, new
   use mstore, only : get_structure
   use tblite_basis_type, only : basis_type
   use tblite_container, only : container_type, container_cache
   use tblite_context_type, only : context_type
   use tblite_data_spin, only : get_spin_constant
   use tblite_spin, only : spin_polarization, new_spin_polarization
   use tblite_wavefunction_type, only : wavefunction_type, new_wavefunction
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_gfn1, only : new_gfn1_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   implicit none
   private

   public :: collect_spin

   real(wp), parameter :: acc = 0.01_wp
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp), parameter :: thr2 = 1e+4_wp*sqrt(epsilon(1.0_wp))
   real(wp), parameter :: kt = 300.0_wp * 3.166808578545117e-06_wp

  real(wp), parameter :: aatoau = 1.0_wp / 0.529177249_wp, &
     & ctoau = 1.0_wp / 1.60217653e-19_wp, jtoau = 1.0_wp / 4.3597441775e-18_wp
  !> Convert V/Å = J/(C·Å) to atomic units
  real(wp), parameter :: vatoau = jtoau / (ctoau * aatoau)

  type, extends(container_type) :: empty_interaction
  end type empty_interaction

contains


!> Collect all exported unit tests
subroutine collect_spin(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("gfn1-e-spin", test_e_crcp2), &
      new_unittest("gfn2-e-spin", test_e_p10), &
      new_unittest("gfn1-g-spin", test_g_p10), &
      new_unittest("gfn2-g-spin", test_g_crcp2) &
      ]

end subroutine collect_spin


subroutine test_e_gen(error, mol, calc, ref1, ref0)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Molecular structure 
   type(structure_type), intent(inout) :: mol
   !> XTB calculator
   type(xtb_calculator), intent(inout) :: calc
   !> Reference energy for spin-polarized UHF
   real(wp), intent(in) :: ref1
   !> Reference energy without spin-polarization
   real(wp), intent(in) :: ref0

   type(context_type) :: ctx
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy

   energy = 0.0_wp

   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 2, kt)

   block
      type(spin_polarization), allocatable :: spin
      real(wp), allocatable :: wll(:, :, :)
      allocate(spin)
      call get_spin_constants(wll, mol, calc%bas)
      call new_spin_polarization(spin, mol, wll, calc%bas%nsh_id)
      call move_alloc(spin, cont)
      call calc%push_back(cont)
   end block

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0)

   call check(error, energy, ref1, thr=thr)
   if (allocated(error)) return

   if(mod(mol%uhf, 2) == 0) then
      mol%uhf = 0
      call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 2, kt)
   
      call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0)
   
      call check(error, energy, ref0, thr=thr)
      if (allocated(error)) return
   end if
   
   call calc%pop(cont)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0)

   call check(error, energy, ref0, thr=thr)

end subroutine test_e_gen


subroutine test_g_gen(error, mol, calc, eref, gref)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Molecular structure 
   type(structure_type), intent(inout) :: mol
   !> XTB calculator
   type(xtb_calculator), intent(inout) :: calc
   !> Reference energy for spin-polarized UHF
   real(wp), intent(in) :: eref
   !> Reference gradient for spin-polarized UHF
   real(wp), intent(in) :: gref(:, :)

   type(context_type) :: ctx
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)

   allocate(gradient(3, mol%nat), sigma(3, 3))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 2, kt)

   block
      type(spin_polarization), allocatable :: spin
      real(wp), allocatable :: wll(:, :, :)
      allocate(spin)
      call get_spin_constants(wll, mol, calc%bas)
      call new_spin_polarization(spin, mol, wll, calc%bas%nsh_id)
      call move_alloc(spin, cont)
      call calc%push_back(cont)
   end block

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, eref, thr=thr)
   if (allocated(error)) return
   call check(error, all(abs(gradient - gref) < thr))

end subroutine test_g_gen


subroutine test_e_p10(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   real(wp), parameter :: ref1 = -10.801224611773206_wp, ref0 = -10.7897113668574_wp

   call rse43_p10(mol)

   call new_gfn2_calculator(calc, mol, error)
   if (allocated(error)) return

   call test_e_gen(error, mol, calc, ref1, ref0)

end subroutine test_e_p10

subroutine test_e_crcp2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   real(wp), parameter :: ref1 = -28.376485853038645_wp, ref0 = -28.3496138337329_wp

   call crcp2(mol)
   allocate(gradient(3, mol%nat), sigma(3, 3))
   energy = 0.0_wp

   call new_gfn1_calculator(calc, mol, error)
   if (allocated(error)) return

   call test_e_gen(error, mol, calc, ref1, ref0)

end subroutine test_e_crcp2


subroutine test_g_p10(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   real(wp), parameter :: eref = -11.539671328635730_wp, gref(3, 8) = reshape([&
      &  4.6250747795231898E-03_wp,  3.0613008404354290E-03_wp, -4.1003763872489694E-17_wp, &
      & -5.8127688918931083E-03_wp,  7.0212976481872583E-03_wp,  7.4006869452289192E-17_wp, &
      &  8.4737687859435182E-03_wp, -7.8529734509620933E-03_wp,  1.4182424493755559E-17_wp, &
      &  1.6732818000371087E-04_wp, -2.6987199782906278E-03_wp,  8.6784398428552196E-18_wp, &
      & -2.4727166634656915E-03_wp,  1.1335882595829142E-03_wp,  1.1165068841281504E-17_wp, &
      & -1.2010615143533908E-03_wp, -5.3284767411932365E-04_wp,  2.1499927548673772E-03_wp, &
      & -1.2010615143534362E-03_wp, -5.3284767411941928E-04_wp, -2.1499927548674475E-03_wp, &
      & -2.5785631614047800E-03_wp,  4.0120202928582558E-04_wp, -2.7346723399901103E-18_wp], &
      & shape(gref))


   call rse43_p10(mol)
   allocate(gradient(3, mol%nat), sigma(3, 3))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call new_gfn1_calculator(calc, mol, error)
   if (allocated(error)) return

   call test_g_gen(error, mol, calc, eref, gref)

end subroutine test_g_p10


subroutine test_g_crcp2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   real(wp), parameter :: eref = -28.471439648669477_wp, gref(3, 21) = reshape([&
      & -3.3346209907941793E-14_wp,  9.4095128281949936E-15_wp,  7.3031040873146682E-04_wp, &
      &  2.0737422989057993E-14_wp, -1.3810438730716156E-03_wp,  1.4534865767653804E-02_wp, &
      &  1.2023217179885587E-02_wp,  8.5569295722914113E-05_wp,  9.6517319007189957E-04_wp, &
      &  3.7815059360380221E-05_wp,  1.8331263028967730E-03_wp, -7.4190049135553562E-03_wp, &
      & -3.7815059340987442E-05_wp,  1.8331263028886257E-03_wp, -7.4190049135963677E-03_wp, &
      & -1.2023217179908601E-02_wp,  8.5569295703461453E-05_wp,  9.6517319009760687E-04_wp, &
      & -2.1579772050526842E-15_wp, -4.7641226402683678E-03_wp,  1.7211385778858280E-03_wp, &
      &  1.8164603206477625E-03_wp, -4.7321956256350887E-03_wp, -1.2363412674730632E-04_wp, &
      &  4.6032135883547536E-04_wp, -4.5828980598753965E-03_wp, -1.7331139247164979E-03_wp, &
      & -4.6032135883693128E-04_wp, -4.5828980598751675E-03_wp, -1.7331139247122576E-03_wp, &
      & -1.8164603206444060E-03_wp, -4.7321956256338536E-03_wp, -1.2363412674987575E-04_wp, &
      &  1.2023217179875622E-02_wp, -8.5569295726056334E-05_wp,  9.6517319007691270E-04_wp, &
      &  2.1969354427773201E-14_wp,  1.3810438730645139E-03_wp,  1.4534865767642511E-02_wp, &
      &  3.7815059363820869E-05_wp, -1.8331263028954043E-03_wp, -7.4190049135521609E-03_wp, &
      &  1.8164603206502138E-03_wp,  4.7321956256355432E-03_wp, -1.2363412674731755E-04_wp, &
      & -1.2023217179899397E-02_wp, -8.5569295707092256E-05_wp,  9.6517319009984900E-04_wp, &
      & -2.2096020250407485E-15_wp,  4.7641226402693401E-03_wp,  1.7211385778886621E-03_wp, &
      & -3.7815059345164216E-05_wp, -1.8331263028875707E-03_wp, -7.4190049135908296E-03_wp, &
      &  4.6032135883590795E-04_wp,  4.5828980598754208E-03_wp, -1.7331139247177656E-03_wp, &
      & -1.8164603206467446E-03_wp,  4.7321956256343913E-03_wp, -1.2363412674968964E-04_wp, &
      & -4.6032135883749967E-04_wp,  4.5828980598752534E-03_wp, -1.7331139247138050E-03_wp], &
      & shape(gref))

   call crcp2(mol)
   allocate(gradient(3, mol%nat), sigma(3, 3))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call new_gfn2_calculator(calc, mol, error)
   if (allocated(error)) return

   call test_g_gen(error, mol, calc, eref, gref)

end subroutine test_g_crcp2


subroutine get_spin_constants(wll, mol, bas)
   real(wp), allocatable, intent(out) :: wll(:, :, :)
   type(structure_type), intent(in) :: mol
   type(basis_type), intent(in) :: bas

   integer :: izp, ish, jsh, il, jl

   allocate(wll(bas%nsh, bas%nsh, mol%nid), source=0.0_wp)

   do izp = 1, mol%nid
      do ish = 1, bas%nsh_id(izp)
         il = bas%cgto(ish, izp)%ang
         do jsh = 1, bas%nsh_id(izp)
            jl = bas%cgto(jsh, izp)%ang
            wll(jsh, ish, izp) = get_spin_constant(jl, il, mol%num(izp))
         end do
      end do
   end do
end subroutine get_spin_constants


subroutine rse43_p10(self)
   type(structure_type), intent(out) :: self
   integer, parameter :: nat = 8
   character(len=*), parameter :: sym(nat) = [character(len=4)::&
      & "C", "C", "O", "H", "H", "H", "H", "H"]
   real(wp), parameter :: xyz(3, nat) = reshape([&
   & -1.97051959765227E+00_wp,   -8.65723337874754E-01_wp,    0.00000000000000E+00_wp, &     
   &  3.50984622791913E-01_wp,    6.86290619844032E-01_wp,    0.00000000000000E+00_wp, &      
   &  2.50609985217434E+00_wp,   -9.34496149122418E-01_wp,    0.00000000000000E+00_wp, &      
   & -1.83649606109455E+00_wp,   -2.90299181092583E+00_wp,    0.00000000000000E+00_wp, &      
   & -3.80466245712260E+00_wp,    3.49832428602470E-02_wp,    0.00000000000000E+00_wp, &      
   &  3.73555581511497E-01_wp,    1.94431040908594E+00_wp,   -1.66596178649581E+00_wp, &      
   &  3.73555581511497E-01_wp,    1.94431040908594E+00_wp,    1.66596178649581E+00_wp, &      
   &  4.00748247788016E+00_wp,    9.33166170468600E-02_wp,    0.00000000000000E+00_wp], &      
      & shape(xyz))
   integer, parameter :: uhf = 1
   call new(self, sym, xyz, uhf=uhf)
end subroutine rse43_p10


subroutine crcp2(self)
   type(structure_type), intent(out) :: self
   integer, parameter :: nat = 21
   character(len=*), parameter :: sym(nat) = [character(len=4)::&
      & "Cr", "C", "C", "C", "C", "C", "H", "H", "H", "H", "H", "C", "C", "C", &
      & "H", "C", "H", "C", "H", "H", "H"]
   real(wp), parameter :: xyz(3, nat) = reshape([&
  &  0.00000000000000E+00_wp,    0.00000000000000E+00_wp,   -6.04468452830504E-02_wp, &      
  &  0.00000000000000E+00_wp,    3.19613712523833E+00_wp,    2.30877824528580E+00_wp, &      
  &  2.18828801115897E+00_wp,    3.32943780995850E+00_wp,    7.02499485857345E-01_wp, &      
  &  1.33235791539260E+00_wp,    3.55640652898451E+00_wp,   -1.83908673090077E+00_wp, &      
  & -1.33235791539260E+00_wp,    3.55640652898451E+00_wp,   -1.83908673090077E+00_wp, &      
  & -2.18828801115897E+00_wp,    3.32943780995850E+00_wp,    7.02499485857345E-01_wp, &      
  &  0.00000000000000E+00_wp,    3.10509505378016E+00_wp,    4.34935395653655E+00_wp, &      
  &  4.13810718850644E+00_wp,    3.28428734944129E+00_wp,    1.31235006648465E+00_wp, &      
  &  2.52190264478215E+00_wp,    3.60569548880831E+00_wp,   -3.50208900904436E+00_wp, &      
  & -2.52190264478215E+00_wp,    3.60569548880831E+00_wp,   -3.50208900904436E+00_wp, &      
  & -4.13810718850644E+00_wp,    3.28428734944129E+00_wp,    1.31235006648465E+00_wp, &      
  &  2.18828801115897E+00_wp,   -3.32943780995850E+00_wp,    7.02499485857345E-01_wp, &      
  &  0.00000000000000E+00_wp,   -3.19613712523833E+00_wp,    2.30877824528580E+00_wp, &      
  &  1.33235791539260E+00_wp,   -3.55640652898451E+00_wp,   -1.83908673090077E+00_wp, &      
  &  4.13810718850644E+00_wp,   -3.28428734944129E+00_wp,    1.31235006648465E+00_wp, &      
  & -2.18828801115897E+00_wp,   -3.32943780995850E+00_wp,    7.02499485857345E-01_wp, &      
  &  0.00000000000000E+00_wp,   -3.10509505378016E+00_wp,    4.34935395653655E+00_wp, &      
  & -1.33235791539260E+00_wp,   -3.55640652898451E+00_wp,   -1.83908673090077E+00_wp, &      
  &  2.52190264478215E+00_wp,   -3.60569548880831E+00_wp,   -3.50208900904436E+00_wp, &      
  & -4.13810718850644E+00_wp,   -3.28428734944129E+00_wp,    1.31235006648465E+00_wp, &      
  & -2.52190264478215E+00_wp,   -3.60569548880831E+00_wp,   -3.50208900904436E+00_wp], &      
 & shape(xyz))
   integer, parameter :: uhf = 2
   call new(self, sym, xyz, uhf=uhf)
end subroutine crcp2


end module test_spin

module test_halogen
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io_structure, only : structure_type, new
   use mstore, only : get_structure
   use tblite_container, only : container_cache
   use tblite_classical_halogen
   implicit none
   private

   public :: collect_halogen

   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

   !> Strength of the halogen bond
   real(wp), parameter :: halogen_bond(*) = 0.1_wp * [ &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.381742_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.321944_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, &
      & 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.000000_wp, 0.220000_wp, &
      & 0.000000_wp]

contains


!> Collect all exported unit tests
subroutine collect_halogen(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("Br2-NH3", test_br2nh3), &
      & new_unittest("Br2-OCN2", test_br2och2), &
      & new_unittest("FI-NCH", test_finch) &
      & ]

end subroutine collect_halogen


subroutine test_br2nh3(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(halogen_correction) :: xb
   type(container_cache) :: cache
   real(wp), allocatable :: energy(:)
   real(wp), parameter :: trans(3, 1) = 0.0_wp, cutoff = sqrt(400.0_wp)

   call BrBr_NH3(mol)
   call new_halogen_correction(xb, mol, 0.44_wp, 1.3_wp, halogen_bond(mol%num))

   allocate(energy(mol%nat))

   call check(error, count(xb%halogen), 1)
   if (allocated(error)) return

   call check(error, count(xb%acceptor), 1)
   if (allocated(error)) return

   energy = 0.0_wp
   call xb%get_engrad(mol, cache, energy)

   call check(error, sum(energy), 2.4763110097465683E-3_wp, thr=thr)
   if (allocated(error)) return

end subroutine test_br2nh3


subroutine test_br2och2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(halogen_correction) :: xb
   type(container_cache) :: cache
   integer :: iat, ic
   real(wp) :: sigma(3, 3)
   real(wp), allocatable :: energy(:), er(:), el(:)
   real(wp), parameter :: trans(3, 1) = 0.0_wp, cutoff = sqrt(400.0_wp)
   real(wp), allocatable :: gradient(:, :), numgrad(:, :)
   real(wp), parameter :: step = 1.0e-6_wp

   call BrBr_OCH2(mol)
   call new_halogen_correction(xb, mol, 0.44_wp, 1.3_wp, halogen_bond(mol%num))

   allocate(energy(mol%nat), er(mol%nat), el(mol%nat))

   call check(error, count(xb%halogen), 1)
   if (allocated(error)) return

   call check(error, count(xb%acceptor), 1)
   if (allocated(error)) return

   allocate(gradient(3, mol%nat), numgrad(3, mol%nat))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call xb%get_engrad(mol, cache, energy, gradient, sigma)

   call check(error, sum(energy), -6.7587305781592112E-4_wp, thr=thr)
   if (allocated(error)) return

   do iat = 1, mol%nat
      do ic = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call xb%get_engrad(mol, cache, er)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2*step
         call xb%get_engrad(mol, cache, el)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         numgrad(ic, iat) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   if (any(abs(gradient - numgrad) > thr2)) then
      call test_failed(error, "Gradient of dispersion energy does not match")
      print'(3es21.14)', gradient-numgrad
   end if

end subroutine test_br2och2


subroutine test_finch(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(halogen_correction) :: xb
   type(container_cache) :: cache
   integer :: ic, jc
   real(wp) :: sigma(3, 3), eps(3, 3), numsigma(3, 3)
   real(wp), allocatable :: energy(:), er(:), el(:)
   real(wp), parameter :: trans(3, 1) = 0.0_wp, cutoff = sqrt(400.0_wp)
   real(wp), allocatable :: gradient(:, :), xyz(:, :)
   real(wp), parameter :: step = 1.0e-6_wp, unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], shape(unity))

   call FI_NCH(mol)
   call new_halogen_correction(xb, mol, 0.44_wp, 1.3_wp, halogen_bond(mol%num))

   allocate(energy(mol%nat), er(mol%nat), el(mol%nat))

   call check(error, count(xb%halogen), 1)
   if (allocated(error)) return

   call check(error, count(xb%acceptor), 1)
   if (allocated(error)) return

   allocate(gradient(3, mol%nat), xyz(3, mol%nat))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call xb%get_engrad(mol, cache, energy, gradient, sigma)

   call check(error, sum(energy), 1.1857937381795408E-2_wp, thr=thr)
   if (allocated(error)) return

   eps(:, :) = unity
   xyz(:, :) = mol%xyz
   do ic = 1, 3
      do jc = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = matmul(eps, xyz)
         call xb%get_engrad(mol, cache, er)
         eps(jc, ic) = eps(jc, ic) - 2*step
         mol%xyz(:, :) = matmul(eps, xyz)
         call xb%get_engrad(mol, cache, el)
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = xyz
         numsigma(jc, ic) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   if (any(abs(sigma - numsigma) > thr2)) then
      call test_failed(error, "Strain derivatives do not match")
      print'(3es21.14)', sigma-numsigma
   end if

end subroutine test_finch


subroutine BrBr_NH3(self)
   type(structure_type), intent(out) :: self
   integer, parameter :: nat = 6
   character(len=*), parameter :: sym(nat) = [character(len=4)::&
      & "Br", "Br", "N", "H", "H", "H"]
   real(wp), parameter :: xyz(3, nat) = reshape([&
      &  0.00000000000000_wp,  0.00000000000000_wp,  3.11495251300000_wp, &
      &  0.00000000000000_wp,  0.00000000000000_wp, -1.25671880600000_wp, &
      &  0.00000000000000_wp,  0.00000000000000_wp, -6.30201130100000_wp, &
      &  0.00000000000000_wp,  1.78712709700000_wp, -6.97470840000000_wp, &
      & -1.54769692500000_wp, -0.89356260400000_wp, -6.97470840000000_wp, &
      &  1.54769692500000_wp, -0.89356260400000_wp, -6.97470840000000_wp],&
      & shape(xyz))
   call new(self, sym, xyz)
end subroutine BrBr_NH3

subroutine BrBr_OCH2(self)
   type(structure_type), intent(out) :: self
   integer, parameter :: nat = 6
   character(len=*), parameter :: sym(nat) = [character(len=4)::&
      & "Br", "Br", "O", "C", "H", "H"]
   real(wp), parameter :: xyz(3, nat) = reshape([&
      & -1.78533374700000_wp, -3.12608299900000_wp,  0.00000000000000_wp, &
      &  0.00000000000000_wp,  0.81604226400000_wp,  0.00000000000000_wp, &
      &  2.65828699900000_wp,  5.29707580600000_wp,  0.00000000000000_wp, &
      &  4.88597158600000_wp,  4.86116137300000_wp,  0.00000000000000_wp, &
      &  5.61550975300000_wp,  2.90822215900000_wp,  0.00000000000000_wp, &
      &  6.28907612600000_wp,  6.39963643500000_wp,  0.00000000000000_wp],&
      & shape(xyz))
   call new(self, sym, xyz)
end subroutine BrBr_OCH2


subroutine FI_NCH(self)
   type(structure_type), intent(out) :: self
   integer, parameter :: nat = 5
   character(len=*), parameter :: sym(nat) = [character(len=4)::&
      & "F", "I", "N", "C", "H"]
   real(wp), parameter :: xyz(3, nat) = reshape([&
      &  0.00000000000000_wp,  0.00000000000000_wp,  4.37637862700000_wp, &
      &  0.00000000000000_wp,  0.00000000000000_wp,  0.69981844700000_wp, &
      &  0.00000000000000_wp,  0.00000000000000_wp, -4.24181123900000_wp, &
      &  0.00000000000000_wp,  0.00000000000000_wp, -6.39520691700000_wp, &
      &  0.00000000000000_wp,  0.00000000000000_wp, -8.41387269200000_wp],&
      & shape(xyz))
   call new(self, sym, xyz)
end subroutine FI_NCH


end module test_halogen

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/wavefunction
!> Contains wavefunction related information

!> @file tblite/wavefunction.f90
!> Provides reexports of wavefunction related procedures and types

!> Proxy module for wavefunction related types and procedures
module tblite_wavefunction
   use tblite_wavefunction_guess, only : sad_guess, eeq_guess, eeqbc_guess, &
      & shell_partition
   use tblite_wavefunction_mulliken, only : get_molecular_dipole_moment, &
      & get_molecular_quadrupole_moment, get_mayer_bond_orders
   use tblite_wavefunction_restart, only : load_wavefunction, save_wavefunction
   use tblite_wavefunction_spin, only : magnet_to_updown, updown_to_magnet
   use tblite_wavefunction_type, only : wavefunction_type, new_wavefunction, &
      & get_density_matrix, get_alpha_beta_occupation
   implicit none
   public

end module tblite_wavefunction

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of a parameter record with serde properties.
!> Each record knows how to serialize and deserialize itself.
module tblite_param_serde
   use mctc_env, only : error_type, fatal_error
   use tblite_toml, only : toml_table, toml_error, toml_parse, toml_serializer
   implicit none
   private

   public :: serde_record


   !> Serializable and deserializable parameter record
   type, abstract :: serde_record
   contains
      !> Reading of parametrization data
      generic :: load => load_from_file, load_from_unit, load_from_toml
      !> Read parametrization data from file
      procedure, private :: load_from_file
      !> Read parametrization data from formatted unit
      procedure, private :: load_from_unit
      !> Read parametrization data from TOML data structure
      procedure(load_from_toml), deferred :: load_from_toml
      !> Writing of parametrization data
      generic :: dump => dump_to_file, dump_to_unit, dump_to_toml
      !> Write parametrization data to file
      procedure, private :: dump_to_file
      !> Write parametrization data to formatted unit
      procedure, private :: dump_to_unit
      !> Write parametrization data to TOML data structure
      procedure(dump_to_toml), deferred :: dump_to_toml
   end type serde_record


   abstract interface
      !> Read parametrization data from TOML data structure
      subroutine load_from_toml(self, table, error)
         import :: serde_record, toml_table, error_type
         !> Instance of the parametrization data
         class(serde_record), intent(inout) :: self
         !> Data structure
         type(toml_table), intent(inout) :: table
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine load_from_toml
      !> Write parametrization data to TOML datastructure
      subroutine dump_to_toml(self, table, error)
         import :: serde_record, toml_table, error_type
         !> Instance of the parametrization data
         class(serde_record), intent(in) :: self
         !> Data structure
         type(toml_table), intent(inout) :: table
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine dump_to_toml
   end interface

contains


!> Read parametrization data from file
subroutine load_from_file(self, file, error)
   !> Instance of the parametrization data
   class(serde_record), intent(inout) :: self
   !> File name
   character(len=*), intent(in) :: file
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: unit
   logical :: exist

   inquire(file=file, exist=exist)
   if (.not.exist) then
     call fatal_error(error, "Could not find parameter file '"//file//"'")
     return
   end if

   open(file=file, newunit=unit)
   call self%load(unit, error)
   close(unit)
end subroutine load_from_file


!> Read parametrization data from file
subroutine load_from_unit(self, unit, error)
   !> Instance of the parametrization data
   class(serde_record), intent(inout) :: self
   !> File name
   integer, intent(in) :: unit
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_error), allocatable :: parse_error
   type(toml_table), allocatable :: table

   call toml_parse(table, unit, parse_error)

   if (allocated(parse_error)) then
      allocate(error)
      call move_alloc(parse_error%message, error%message)
      return
   end if

   call self%load(table, error)
   if (allocated(error)) return

end subroutine load_from_unit


!> Write parametrization data to file
subroutine dump_to_file(self, file, error)
   !> Instance of the parametrization data
   class(serde_record), intent(in) :: self
   !> File name
   character(len=*), intent(in) :: file
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: unit

   open(file=file, newunit=unit)
   call self%dump(unit, error)
   close(unit)
   if (allocated(error)) return

end subroutine dump_to_file


!> Write parametrization data to file
subroutine dump_to_unit(self, unit, error)
   !> Instance of the parametrization data
   class(serde_record), intent(in) :: self
   !> Formatted unit
   integer, intent(in) :: unit
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(toml_serializer) :: ser

   table = toml_table()
   ser = toml_serializer(unit)

   call self%dump(table, error)

   call table%accept(ser)

end subroutine dump_to_unit


end module tblite_param_serde

program defaults
  use reader, only : read_data
  use tomlf, only : toml_table
  implicit none

  type(toml_table), allocatable :: table
  character(len=:), allocatable :: title
  real, allocatable :: spectrum(:)

  table = toml_table()

  call read_data(table, title, spectrum)

  if (allocated(title)) then
    print '(a)', "Title: '"//title//"'"
  end if

  print '(*(g0, 1x))', "Entries:", size(spectrum)
  if (size(spectrum) > 0) then
    print '(*(g0, 1x))', "Spectrum:", spectrum
  end if
end program defaults

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/coulomb/charge/gamma.f90
!> Provides the DFTB Coulomb functional for isotropic electrostatic interactions.

!> Isotropic second-order electrostatics using the DFTB Coulomb functional.
module tblite_coulomb_charge_gamma
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_math, only : matdet_3x3, matinv_3x3
   use mctc_io_constants, only : pi
   use tblite_blas, only : dot, gemv, symv, gemm
   use tblite_coulomb_cache, only : coulomb_cache
   use tblite_coulomb_ewald, only : get_dir_cutoff, get_rec_cutoff
   use tblite_coulomb_charge_type, only : coulomb_charge_type
   use tblite_cutoff, only : get_lattice_points
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_wignerseitz, only : wignerseitz_cell
   implicit none
   private

   public :: new_gamma_coulomb


   !> DFTB Gamma functional second-order electrostatics
   type, public, extends(coulomb_charge_type) :: gamma_coulomb
      !> Chemical hardness for each shell and species
      real(wp), allocatable :: hubbard(:, :)
      !> Long-range cutoff
      real(wp) :: rcut
   contains
      !> Evaluate Coulomb matrix
      procedure :: get_coulomb_matrix
      !> Evaluate uncontracted derivatives of Coulomb matrix
      procedure :: get_coulomb_derivs
   end type gamma_coulomb


   real(wp), parameter :: twopi = 2 * pi
   real(wp), parameter :: sqrtpi = sqrt(pi)
   real(wp), parameter :: eps = sqrt(epsilon(0.0_wp))
   real(wp), parameter :: conv = eps
   character(len=*), parameter :: label = "isotropic DFTB-γ electrostatics"

contains

!> Construct new effective electrostatic interaction container
subroutine new_gamma_coulomb(self, mol, hubbard, nshell)
   !> Instance of the electrostatic container
   type(gamma_coulomb), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Chemical hardness for all shells and species
   real(wp), intent(in) :: hubbard(:, :)
   !> Number of shells for each species
   integer, intent(in), optional :: nshell(:)

   integer :: mshell
   integer :: isp, ish, ind, iat

   self%label = label
   self%shell_resolved = present(nshell)

   if (present(nshell)) then
      mshell = maxval(nshell)
      self%nshell = nshell(mol%id)
   else
      mshell = 1
      self%nshell = spread(1, 1, mol%nat)
   end if
   allocate(self%offset(mol%nat))
   ind = 0
   do iat = 1, mol%nat
      self%offset(iat) = ind
      ind = ind + self%nshell(iat)
   end do

   if (present(nshell)) then
      allocate(self%hubbard(mshell, mol%nid))
      do isp = 1, mol%nid
         self%hubbard(:, isp) = 0.0_wp
         do ish = 1, nshell(isp)
            self%hubbard(ish, isp) = hubbard(ish, isp)
         end do
      end do
   else
      allocate(self%hubbard(1, mol%nid))
      do isp = 1, mol%nid
         self%hubbard(1, isp) = hubbard(1, isp)
      end do
   end if

end subroutine new_gamma_coulomb


!> Evaluate coulomb matrix
subroutine get_coulomb_matrix(self, mol, cache, amat)
   !> Instance of the electrostatic container
   class(gamma_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(coulomb_cache), intent(inout) :: cache
   !> Coulomb matrix
   real(wp), contiguous, intent(out) :: amat(:, :)

   amat(:, :) = 0.0_wp

   if (any(mol%periodic)) then
      call get_amat_3d(mol, self%nshell, self%offset, self%hubbard, &
         & self%rcut, cache%wsc, cache%alpha, amat)
   else
      call get_amat_0d(mol, self%nshell, self%offset, self%hubbard, amat)
   end if

end subroutine get_coulomb_matrix


!> Get real lattice vectors
subroutine get_dir_trans(lattice, alpha, conv, trans)
   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)
   !> Parameter for Ewald summation
   real(wp), intent(in) :: alpha
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Translation vectors
   real(wp), allocatable, intent(out) :: trans(:, :)

   call get_lattice_points([.true.], lattice, get_dir_cutoff(alpha, conv), trans)

end subroutine get_dir_trans

!> Get reciprocal lattice translations
subroutine get_rec_trans(lattice, alpha, volume, conv, trans)
   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)
   !> Parameter for Ewald summation
   real(wp), intent(in) :: alpha
   !> Cell volume
   real(wp), intent(in) :: volume
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Translation vectors
   real(wp), allocatable, intent(out) :: trans(:, :)

   real(wp) :: rec_lat(3, 3)

   rec_lat = twopi*transpose(matinv_3x3(lattice))
   call get_lattice_points([.true.], rec_lat, get_rec_cutoff(alpha, volume, conv), trans)
   trans = trans(:, 2:)

end subroutine get_rec_trans


!> Evaluate Coulomb matrix for finite systems
subroutine get_amat_0d(mol, nshell, offset, hubbard, amat)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells for each atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each shell
   integer, intent(in) :: offset(:)
   !> Hardness parameter for each shell
   real(wp), intent(in) :: hubbard(:, :)
   !> Coulomb matrix
   real(wp), intent(inout) :: amat(:, :)

   integer :: iat, jat, izp, jzp, ii, jj, ish, jsh
   real(wp) :: vec(3), r1, r1g, gam, tmp

   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(amat, mol, nshell, offset, hubbard) &
   !$omp private(iat, izp, ii, ish, jat, jzp, jj, jsh, gam, vec, r1, r1g, tmp)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         vec = mol%xyz(:, jat) - mol%xyz(:, iat)
         r1 = norm2(vec)
         tmp = 1.0_wp / r1
         do ish = 1, nshell(iat)
            do jsh = 1, nshell(jat)
               gam = tmp - exp_gamma(r1, hubbard(ish, izp), hubbard(jsh, jzp))
               amat(jj+jsh, ii+ish) = amat(jj+jsh, ii+ish) + gam
               amat(ii+ish, jj+jsh) = amat(ii+ish, jj+jsh) + gam
            end do
         end do
      end do
      do ish = 1, nshell(iat)
         do jsh = 1, ish-1
            gam = -exp_gamma(0.0_wp, hubbard(ish, izp), hubbard(jsh, izp))
            amat(ii+jsh, ii+ish) = amat(ii+jsh, ii+ish) + gam
            amat(ii+ish, ii+jsh) = amat(ii+ish, ii+jsh) + gam
         end do
         gam = -exp_gamma(0.0_wp, hubbard(ish, izp), hubbard(ish, izp))
         amat(ii+ish, ii+ish) = amat(ii+ish, ii+ish) + gam
      end do
   end do

end subroutine get_amat_0d

!> Evaluate the coulomb matrix for 3D systems
subroutine get_amat_3d(mol, nshell, offset, hubbard, rcut, wsc, alpha, amat)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells per atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each atom
   integer, intent(in) :: offset(:)
   !> Hardness of the shells
   real(wp), intent(in) :: hubbard(:, :)
   !> Long-range cutoff
   real(wp), intent(in) :: rcut
   !> Wigner-Seitz cell
   type(wignerseitz_cell), intent(in) :: wsc
   !> Convergence factor
   real(wp), intent(in) :: alpha
   !> Coulomb matrix
   real(wp), intent(inout) :: amat(:, :)

   integer :: iat, jat, izp, jzp, img, ii, jj, ish, jsh
   real(wp) :: vec(3), ui, uj, wsw, dtmp, rtmp, vol, aval
   real(wp), allocatable :: dtrans(:, :), rtrans(:, :)

   vol = abs(matdet_3x3(mol%lattice))
   call get_dir_trans(mol%lattice, alpha, conv, dtrans)
   call get_rec_trans(mol%lattice, alpha, vol, conv, rtrans)

   !$omp parallel do default(none) schedule(runtime) shared(amat) &
   !$omp shared(mol, nshell, offset, hubbard, wsc, dtrans, rtrans, alpha, vol, rcut) &
   !$omp private(iat, izp, jat, jzp, ii, jj, ish, jsh, ui, uj, wsw, vec, dtmp, rtmp, aval)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, iat) - mol%xyz(:, jat) - wsc%trans(:, wsc%tridx(img, jat, iat))
            call get_amat_rec_3d(vec, vol, alpha, rtrans, rtmp)
            do ish = 1, nshell(iat)
               do jsh = 1, nshell(jat)
                  ui = hubbard(ish, izp)
                  uj = hubbard(jsh, jzp)
                  call get_amat_dir_3d(vec, ui, uj, alpha, dtrans, dtmp)
                  aval = (dtmp + rtmp) * wsw
                  amat(jj+jsh, ii+ish) = amat(jj+jsh, ii+ish) + aval
                  amat(ii+ish, jj+jsh) = amat(ii+ish, jj+jsh) + aval
               end do
            end do
         end do
      end do

      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec = wsc%trans(:, wsc%tridx(img, iat, iat))
         call get_amat_rec_3d(vec, vol, alpha, rtrans, rtmp)
         rtmp = rtmp - 2 * alpha / sqrtpi
         do ish = 1, nshell(iat)
            do jsh = 1, ish-1
               ui = hubbard(ish, izp)
               uj = hubbard(jsh, izp)
               call get_amat_dir_3d(vec, ui, uj, alpha, dtrans, dtmp)
               aval = (dtmp + rtmp - exp_gamma(0.0_wp, ui, uj)) * wsw
               amat(ii+jsh, ii+ish) = amat(ii+jsh, ii+ish) + aval
               amat(ii+ish, ii+jsh) = amat(ii+ish, ii+jsh) + aval
            end do
            ui = hubbard(ish, izp)
            call get_amat_dir_3d(vec, ui, ui, alpha, dtrans, dtmp)
            aval = (dtmp + rtmp - exp_gamma(0.0_wp, ui, ui)) * wsw
            amat(ii+ish, ii+ish) = amat(ii+ish, ii+ish) + aval
         end do
      end do

   end do

end subroutine get_amat_3d

!> Calculate real space contributions for a pair under 3D periodic boundary conditions
subroutine get_amat_dir_3d(rij, ui, uj, alp, trans, amat)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Chemical hardness
   real(wp), intent(in) :: ui, uj
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Interaction matrix element
   real(wp), intent(out) :: amat

   integer :: itr
   real(wp) :: vec(3), r1, tmp

   amat = 0.0_wp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      tmp = 1.0_wp / r1 - exp_gamma(r1, ui, uj) &
         & - erf(alp*r1)/r1
      amat = amat + tmp
   end do

end subroutine get_amat_dir_3d

!> Calculate reciprocal space contributions for a pair under 3D periodic boundary conditions
subroutine get_amat_rec_3d(rij, vol, alp, trans, amat)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Volume of cell
   real(wp), intent(in) :: vol
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Interaction matrix element
   real(wp), intent(out) :: amat

   integer :: itr
   real(wp) :: fac, vec(3), g2, gv, expk, cosk

   amat = 0.0_wp
   fac = 4*pi/vol

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      gv = dot_product(rij, vec)
      expk = fac * exp(-0.25_wp*g2/(alp*alp))/g2
      cosk = cos(gv) * expk
      amat = amat + cosk
   end do

end subroutine get_amat_rec_3d

function fsmooth(r1, rcut) result(fcut)
   real(wp), intent(in) :: r1
   real(wp), intent(in) :: rcut
   real(wp) :: fcut

   real(wp), parameter :: offset = 1.0_wp
   real(wp), parameter :: c(*) = [-6.0_wp, 15.0_wp, -10.0_wp, 1.0_wp]
   real(wp) :: xrel

   if (r1 < rcut - offset) then
      fcut = 1.0_wp
   else if (r1 > rcut) then
      fcut = 0.0_wp
   else
      xrel = (r1 - (rcut - offset)) / offset
      fcut = c(1)*xrel**5 + c(2)*xrel**4 + c(3)*xrel**3 + c(4)
   end if
end function fsmooth

function dsmooth(r1, rcut) result(dcut)
   real(wp), intent(in) :: r1
   real(wp), intent(in) :: rcut
   real(wp) :: dcut

   real(wp), parameter :: offset = 1.0_wp
   real(wp), parameter :: c(*) = [-6.0_wp, 15.0_wp, -10.0_wp, 1.0_wp]
   real(wp) :: xrel

   if (r1 < rcut - offset .or. r1 > rcut) then
      dcut = 0.0_wp
   else
      xrel = (r1 - (rcut - offset)) / offset
      dcut = (5*c(1)*xrel**4 + 4*c(2)*xrel**3 + 3*c(3)*xrel**2) / offset
   end if

end function dsmooth


!> Evaluate uncontracted derivatives of Coulomb matrix
subroutine get_coulomb_derivs(self, mol, cache, qat, qsh, dadr, dadL, atrace)
   !> Instance of the electrostatic container
   class(gamma_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(coulomb_cache), intent(inout) :: cache
   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)
   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)
   !> Derivative of interactions with respect to cartesian displacements
   real(wp), contiguous, intent(out) :: dadr(:, :, :)
   !> Derivative of interactions with respect to strain deformations
   real(wp), contiguous, intent(out) :: dadL(:, :, :)
   !> On-site derivatives with respect to cartesian displacements
   real(wp), contiguous, intent(out) :: atrace(:, :)

   if (any(mol%periodic)) then
      call get_damat_3d(mol, self%nshell, self%offset, self%hubbard, &
         & self%rcut, cache%wsc, cache%alpha, qsh, dadr, dadL, atrace)
   else
      call get_damat_0d(mol, self%nshell, self%offset, self%hubbard, qsh, &
         & dadr, dadL, atrace)
   end if

end subroutine get_coulomb_derivs


!> Evaluate uncontracted derivatives of Coulomb matrix for finite system
subroutine get_damat_0d(mol, nshell, offset, hubbard, qvec, dadr, dadL, atrace)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells for each atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each shell
   integer, intent(in) :: offset(:)
   !> Chemical hardness for each shell and species
   real(wp), intent(in) :: hubbard(:, :)
   !> Partial charge vector
   real(wp), intent(in) :: qvec(:)
   !> Derivative of interactions with respect to cartesian displacements
   real(wp), intent(out) :: dadr(:, :, :)
   !> Derivative of interactions with respect to strain deformations
   real(wp), intent(out) :: dadL(:, :, :)
   !> On-site derivatives with respect to cartesian displacements
   real(wp), intent(out) :: atrace(:, :)

   integer :: iat, jat, izp, jzp, ii, jj, ish, jsh
   real(wp) :: vec(3), r1, gam, arg, dtmp, dG(3), dS(3, 3)
   real(wp), allocatable :: itrace(:, :), didr(:, :, :), didL(:, :, :)

   atrace(:, :) = 0.0_wp
   dadr(:, :, :) = 0.0_wp
   dadL(:, :, :) = 0.0_wp

   !$omp parallel default(none) &
   !$omp shared(atrace, dadr, dadL, mol, qvec, hubbard, nshell, offset) &
   !$omp private(iat, izp, ii, ish, jat, jzp, jj, jsh, gam, r1, vec, dG, dS, dtmp, arg) &
   !$omp private(itrace, didr, didL)
   itrace = atrace
   didr = dadr
   didL = dadL
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         vec = mol%xyz(:, iat) - mol%xyz(:, jat)
         r1 = norm2(vec)
         dtmp = -1.0_wp / (r1*r1*r1)
         do ish = 1, nshell(iat)
            do jsh = 1, nshell(jat)
               gam = dtmp - dexp_gamma(r1, hubbard(ish, izp), hubbard(jsh, jzp))/r1
               dG = gam*vec
               dS = spread(dG, 1, 3) * spread(vec, 2, 3)
               itrace(:, ii+ish) = +dG*qvec(jj+jsh) + itrace(:, ii+ish)
               itrace(:, jj+jsh) = -dG*qvec(ii+ish) + itrace(:, jj+jsh)
               didr(:, iat, jj+jsh) = +dG*qvec(ii+ish) + didr(:, iat, jj+jsh)
               didr(:, jat, ii+ish) = -dG*qvec(jj+jsh) + didr(:, jat, ii+ish)
               didL(:, :, jj+jsh) = +dS*qvec(ii+ish) + didL(:, :, jj+jsh)
               didL(:, :, ii+ish) = +dS*qvec(jj+jsh) + didL(:, :, ii+ish)
            end do
         end do
      end do
   end do
   !$omp critical (get_damat_0d_)
   atrace(:, :) = atrace + itrace
   dadr(:, :, :) = dadr + didr
   dadL(:, :, :) = dadL + didL
   !$omp end critical (get_damat_0d_)
   !$omp end parallel

end subroutine get_damat_0d

!> Evaluate uncontracted derivatives of Coulomb matrix for 3D periodic system
subroutine get_damat_3d(mol, nshell, offset, hubbard, rcut, wsc, alpha, qvec, &
      & dadr, dadL, atrace)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells for each atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each shell
   integer, intent(in) :: offset(:)
   !> Chemical hardness for each shell and species
   real(wp), intent(in) :: hubbard(:, :)
   !> Long-range cutoff
   real(wp), intent(in) :: rcut
   !> Wigner-Seitz image information
   type(wignerseitz_cell), intent(in) :: wsc
   !> Convergence factor for Ewald sum
   real(wp), intent(in) :: alpha
   !> Partial charge vector
   real(wp), intent(in) :: qvec(:)
   !> Derivative of interactions with respect to cartesian displacements
   real(wp), intent(out) :: dadr(:, :, :)
   !> Derivative of interactions with respect to strain deformations
   real(wp), intent(out) :: dadL(:, :, :)
   !> On-site derivatives with respect to cartesian displacements
   real(wp), intent(out) :: atrace(:, :)

   integer :: iat, jat, izp, jzp, img, ii, jj, ish, jsh
   real(wp) :: vol, ui, uj, wsw, vec(3), dG(3), dS(3, 3)
   real(wp) :: dGd(3), dSd(3, 3), dGr(3), dSr(3, 3)
   real(wp), allocatable :: itrace(:, :), didr(:, :, :), didL(:, :, :)
   real(wp), allocatable :: dtrans(:, :), rtrans(:, :)

   atrace(:, :) = 0.0_wp
   dadr(:, :, :) = 0.0_wp
   dadL(:, :, :) = 0.0_wp

   vol = abs(matdet_3x3(mol%lattice))
   call get_dir_trans(mol%lattice, alpha, conv, dtrans)
   call get_rec_trans(mol%lattice, alpha, vol, conv, rtrans)

   !$omp parallel default(none) shared(atrace, dadr, dadL) &
   !$omp shared(mol, wsc, alpha, vol, dtrans, rtrans, qvec, hubbard, nshell, offset, rcut) &
   !$omp private(iat, izp, jat, jzp, img, ii, jj, ish, jsh, ui, uj, wsw, vec, dG, dS, &
   !$omp& dGr, dSr, dGd, dSd, itrace, didr, didL)
   itrace = atrace
   didr = dadr
   didL = dadL
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, iat) - mol%xyz(:, jat) - wsc%trans(:, wsc%tridx(img, jat, iat))
            wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
            call get_damat_rec_3d(vec, vol, alpha, rtrans, dGr, dSr)
            do ish = 1, nshell(iat)
               do jsh = 1, nshell(jat)
                  ui = hubbard(ish, izp)
                  uj = hubbard(jsh, jzp)
                  call get_damat_dir_3d(vec, ui, uj, alpha, dtrans, dGd, dSd)
                  dG = (dGd + dGr) * wsw
                  dS = (dSd + dSr) * wsw
                  itrace(:, ii+ish) = +dG*qvec(jj+jsh) + itrace(:, ii+ish)
                  itrace(:, jj+jsh) = -dG*qvec(ii+ish) + itrace(:, jj+jsh)
                  didr(:, iat, jj+jsh) = +dG*qvec(ii+ish) + didr(:, iat, jj+jsh)
                  didr(:, jat, ii+ish) = -dG*qvec(jj+jsh) + didr(:, jat, ii+ish)
                  didL(:, :, jj+jsh) = +dS*qvec(ii+ish) + didL(:, :, jj+jsh)
                  didL(:, :, ii+ish) = +dS*qvec(jj+jsh) + didL(:, :, ii+ish)
               end do
            end do
         end do
      end do

      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec = wsc%trans(:, wsc%tridx(img, iat, iat))
         call get_damat_rec_3d(vec, vol, alpha, rtrans, dGr, dSr)
         do ish = 1, nshell(iat)
            do jsh = 1, ish-1
               ui = hubbard(ish, izp)
               uj = hubbard(jsh, izp)
               call get_damat_dir_3d(vec, ui, uj, alpha, dtrans, dGd, dSd)
               dS = (dSd + dSr) * wsw
               didL(:, :, ii+jsh) = +dS*qvec(ii+ish) + didL(:, :, ii+jsh)
               didL(:, :, ii+ish) = +dS*qvec(ii+jsh) + didL(:, :, ii+ish)
            end do
            ui = hubbard(ish, izp)
            call get_damat_dir_3d(vec, ui, ui, alpha, dtrans, dGd, dSd)
            dS = (dSd + dSr) * wsw
            didL(:, :, ii+ish) = +dS*qvec(ii+ish) + didL(:, :, ii+ish)
         end do
      end do
   end do
   !$omp critical (get_damat_3d_)
   atrace(:, :) = atrace + itrace
   dadr(:, :, :) = dadr + didr
   dadL(:, :, :) = dadL + didL
   !$omp end critical (get_damat_3d_)
   !$omp end parallel

end subroutine get_damat_3d

!> Calculate real space contributions for a pair under 3D periodic boundary conditions
subroutine get_damat_dir_3d(rij, ui, uj, alp, trans, dg, ds)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Chemical hardness
   real(wp), intent(in) :: ui, uj
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Derivative with respect to cartesian displacements
   real(wp), intent(out) :: dg(3)
   !> Derivative with respect to strain deformations
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr
   real(wp) :: vec(3), r1, r2, gtmp, atmp, alp2

   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp

   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      r2 = r1*r1
      gtmp = -1.0_wp/(r2*r1) - dexp_gamma(r1, ui, uj)/r1
      atmp = -2*alp*exp(-r2*alp2)/(sqrtpi*r2) + erf(r1*alp)/(r2*r1)
      dg(:) = dg + (gtmp + atmp) * vec
      ds(:, :) = ds + (gtmp + atmp) * spread(vec, 1, 3) * spread(vec, 2, 3)
   end do

end subroutine get_damat_dir_3d

!> Calculate reciprocal space contributions for a pair under 3D periodic boundary conditions
subroutine get_damat_rec_3d(rij, vol, alp, trans, dg, ds)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Cell volume
   real(wp), intent(in) :: vol
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Derivative with respect to cartesian displacements
   real(wp), intent(out) :: dg(3)
   !> Derivative with respect to strain deformations
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr
   real(wp) :: fac, vec(3), g2, gv, expk, sink, cosk, alp2
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], shape(unity))

   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp
   fac = 4*pi/vol
   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      gv = dot_product(rij, vec)
      expk = fac * exp(-0.25_wp*g2/alp2)/g2
      cosk = cos(gv) * expk
      sink = sin(gv) * expk
      dg(:) = dg - sink * vec
      ds(:, :) = ds + cosk &
         & * ((2.0_wp/g2 + 0.5_wp/alp2) * spread(vec, 1, 3)*spread(vec, 2, 3) &
         &     - unity)
   end do

end subroutine get_damat_rec_3d


!> Determines the value of the short range contribution to gamma with the exponential form
pure function exp_gamma(r1, ui, uj)
   !> separation of sites a and b
   real(wp), intent(in) :: r1
   !> Hubbard U for site a
   real(wp), intent(in) :: ui
   !> Hubbard U for site b
   real(wp), intent(in) :: uj
   !> contribution
   real(wp) :: exp_gamma

   real(wp) :: taui, tauj, tauij

   ! 16/5 * U, see review papers / theses
   taui = 3.2_wp*ui
   tauj = 3.2_wp*uj

   if (r1 < eps) then
      ! on-site case with R~0
      if (abs(ui - uj) < eps) then
         ! same Hubbard U values, onsite
         exp_gamma = -0.5_wp*(ui + uj)
      else
         ! ui /= uj Hubbard U values - limiting case
         exp_gamma = &
            & -0.5_wp*((taui*tauj)/(taui+tauj) + (taui*tauj)**2/(taui+tauj)**3)
      end if
   else
      if (abs(ui - uj) < eps) then
         ! R > 0 and same Hubbard U values
         tauij = 0.5_wp*(taui + tauj)
         exp_gamma = &
            & exp(-tauij*r1) &
            & * (48.0_wp/r1 &
            &   + 33.0_wp*tauij &
            &   + 9.0_wp*r1*(tauij**2) &
            &   + (r1**2)*(tauij**3)) / 48.0_wp
      else
         exp_gamma = gamma_sf(r1,taui,tauj) + gamma_sf(r1,tauj,taui)
      end if
   end if

end function exp_gamma

!> Determines the value of a part of the short range contribution to the exponential gamma, when
!> ui /= uj and R > 0
pure function gamma_sf(r1, taui, tauj) result(sf)
   !> separation of sites a and b
   real(wp), intent(in) :: r1
   !> Charge fluctuation for site a
   real(wp), intent(in) :: taui
   !> Charge fluctuation U for site b
   real(wp), intent(in) :: tauj
   !> contribution
   real(wp) :: sf

   sf = exp(-taui * r1) &
      & * ((0.5_wp*tauj**4*taui/(taui**2-tauj**2)**2) &
      &   - (tauj**6-3.0_wp*tauj**4*taui**2)/(r1*(taui**2-tauj**2)**3))

end function gamma_sf

!> Determines the value of the derivative of the short range contribution to gamma with the
!> exponential form
pure function dexp_gamma(r1,ui,uj)
   !> separation of sites a and b
   real(wp), intent(in) :: r1
   !> Hubbard U for site a
   real(wp), intent(in) :: ui
   !> Hubbard U for site b
   real(wp), intent(in) :: uj
   !> returned contribution
   real(wp) :: dexp_gamma

   real(wp) :: taui, tauj, tauij

   dexp_gamma = 0.0_wp
   if (r1 < eps) return

   ! 16/5 * U, see review papers
   taui = 3.2_wp*ui
   tauj = 3.2_wp*uj

   if (abs(ui - uj) < eps) then
      ! R > 0 and same Hubbard U values
      tauij = 0.5_wp * (taui + tauj)
      dexp_gamma = &
         & -exp(-tauij*r1) &
         & * (tauij**4*r1**4 &
         &   + 7*tauij**3*r1**3 &
         &   + 24*tauij**2*r1**2 &
         &   + 48*tauij*r1 &
         &   + 48.0_wp) &
         & / (48.0_wp*r1**2)
   else
      dexp_gamma = dgamma_sf(r1,taui,tauj) + dgamma_sf(r1,tauj,taui)
   end if
end function dexp_gamma

!> Determines the derivative of the value of a part of the short range contribution to the
!> exponential gamma, when ui /= uj and R > 0
pure function dgamma_sf(r1, taui, tauj) result(dsf)
   !> separation of sites a and b
   real(wp), intent(in) :: r1
   !> Charge fluctuation for site a
   real(wp), intent(in) :: taui
   !> Charge fluctuation U for site b
   real(wp), intent(in) :: tauj
   !> contribution
   real(wp) :: dsf

   dsf = &
      & exp(- taui * r1) &
      & * (taui * tauj**4 * (tauj**2 - 3.0_wp*taui**2)/(r1*(taui**2-tauj**2)**3) &
      &   - tauj**4 * taui**2 / (2*(taui**2-tauj**2)**2) &
      &   + tauj**4*(tauj**2 - 3.0_wp*taui**2) / (r1**2 *(taui**2-tauj**2)**3))

end function dgamma_sf


end module tblite_coulomb_charge_gamma

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_param_mask
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io_symbols, only : to_number, symbol_length
   use tblite_param_charge, only : charge_mask, count
   use tblite_param_dispersion, only : dispersion_mask, count
   use tblite_param_element, only : element_record, element_mask, count
   use tblite_param_halogen, only : halogen_mask, count
   use tblite_param_hamiltonian, only : hamiltonian_mask, count
   use tblite_param_multipole, only : multipole_mask, count
   use tblite_param_repulsion, only : repulsion_mask, count
   use tblite_param_serde, only : serde_record
   use tblite_param_thirdorder, only : thirdorder_mask, count
   use tblite_toml, only : toml_table, toml_array, toml_key, get_value, set_value, &
      & add_table, add_array
   implicit none
   private

   public :: param_mask, count


   type :: allowed_records
      logical :: hamiltonian = .false.
      logical :: dispersion = .false.
      logical :: repulsion = .false.
      logical :: charge = .false.
      logical :: multipole = .false.
      logical :: halogen = .false.
      logical :: thirdorder = .false.
   end type allowed_records


   type, extends(serde_record) :: param_mask
      !> Definition of the Hamiltonian, always required
      type(hamiltonian_mask), allocatable :: hamiltonian
      !> Definition of the dispersion correction
      type(dispersion_mask), allocatable :: dispersion
      !> Definition of the repulsion contribution
      type(repulsion_mask), allocatable :: repulsion
      !> Definition of the isotropic second-order charge interactions
      type(charge_mask), allocatable :: charge
      !> Definition of the anisotropic second-order multipolar interactions
      type(multipole_mask), allocatable :: multipole
      !> Definition of the halogen bonding correction
      type(halogen_mask), allocatable :: halogen
      !> Definition of the isotropic third-order charge interactions
      type(thirdorder_mask), allocatable :: thirdorder
      !> Element specific parameter masks
      type(element_mask), allocatable :: record(:)
      !> Reference to base parametrization
      type(element_record), pointer :: ref(:) => null()
   contains
      !> Read parametrization mask from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization mask to TOML data structure
      procedure :: dump_to_toml
   end type param_mask


   interface count
      module procedure :: count_mask
   end interface count


contains


!> Read parametrization mask from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(param_mask), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(allowed_records) :: allowed
   type(toml_table), pointer :: child

   call get_value(table, "hamiltonian", child, requested=.false.)
   allowed%hamiltonian = associated(child)
   if (associated(child)) then
      allocate(self%hamiltonian)
   end if

   call get_value(table, "dispersion", child, requested=.false.)
   allowed%dispersion = associated(child)
   if (associated(child)) then
      allocate(self%dispersion)
   end if

   call get_value(table, "repulsion", child, requested=.false.)
   allowed%repulsion = associated(child)
   if (associated(child)) then
      allocate(self%repulsion)
   end if

   call get_value(table, "halogen", child, requested=.false.)
   allowed%halogen = associated(child)
   if (associated(child)) then
      allocate(self%halogen)
   end if

   call get_value(table, "charge", child, requested=.false.)
   allowed%charge = associated(child)
   if (associated(child)) then
      allocate(self%charge)
   end if

   call get_value(table, "multipole", child, requested=.false.)
   allowed%multipole = associated(child)
   if (associated(child)) then
      allocate(self%multipole)
   end if

   call get_value(table, "thirdorder", child, requested=.false.)
   allowed%thirdorder = associated(child)
   if (associated(child)) then
      allocate(self%thirdorder)
   end if

   call get_value(table, "element", child)
   call records_from_table(self%record, child, self%ref, allowed, error)
   if (allocated(error)) return
end subroutine load_from_toml


!> Deserialize records from a table by iterating over all entires
subroutine records_from_table(record, table, ref, allowed, error)
   !> List of all element records
   type(element_mask), allocatable, intent(out) :: record(:)
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> List of all element records
   type(element_record), intent(in), optional :: ref(:)
   !> Allowed entries in record
   type(allowed_records), intent(in) :: allowed
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ii, nsh, ir, stat
   type(toml_key), allocatable :: list(:)
   type(toml_table), pointer :: child

   call table%get_keys(list)
   allocate(record(size(list)))

   do ii = 1, size(list)
      call get_value(table, list(ii)%key, child)
      if (present(ref)) then
         call get(ref, list(ii)%key, ir)
         if (ir == 0) cycle
         nsh = ref(ir)%nsh
      else
         call get_value(child, "nsh", nsh, stat=stat)
         if (stat /= 0) cycle
      end if
      call record_from_table(record(ii), child, nsh, allowed, error)
      if (allocated(error)) exit
   end do
   if (allocated(error)) return
end subroutine records_from_table


!> Get the position of an element in the parameter records
pure subroutine get(record, sym, pos)
   !> Instance of the parametrization records
   type(element_record), intent(in) :: record(:)
   !> Symbol of the element
   character(len=*), intent(in) :: sym
   !> Position in the records
   integer, intent(out) :: pos

   integer :: num
   integer :: ii

   num = to_number(sym)
   pos = 0

   do ii = 1, size(record)
      if (record(ii)%sym == sym) then
         pos = ii
         exit
      end if
   end do
   if (pos /= 0) return

   do ii = 1, size(record)
      if (record(ii)%num == num) then
         pos = ii
         exit
      end if
   end do
   if (pos /= 0) return
end subroutine get


!> Deserialize records from a table by iterating over all entires
subroutine record_from_table(record, table, nsh, allowed, error)
   !> List of all element records
   type(element_mask), intent(out) :: record
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Number of shells for this record
   integer, intent(in) :: nsh
   !> Allowed entries in record
   type(allowed_records), intent(in) :: allowed
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   record%sym = table%key
   record%num = to_number(table%key)

   allocate(record%levels(nsh), source=.false.)
   allocate(record%slater(nsh), source=.false.)
   allocate(record%kcn(nsh), source=.false.)
   allocate(record%shpoly(nsh), source=.false.)
   allocate(record%lgam(nsh), source=.false.)

   call read_shell_mask(table, "levels", record%levels, allowed%hamiltonian, error)
   if (allocated(error)) return
   call read_shell_mask(table, "slater", record%slater, allowed%hamiltonian, error)
   if (allocated(error)) return
   call read_shell_mask(table, "shpoly", record%shpoly, allowed%hamiltonian, error)
   if (allocated(error)) return
   call read_shell_mask(table, "kcn", record%kcn, allowed%hamiltonian, error)
   if (allocated(error)) return

   call read_atom_mask(table, "gam", record%gam, allowed%charge, error)
   if (allocated(error)) return
   call read_shell_mask(table, "lgam", record%lgam, allowed%charge, error)
   if (allocated(error)) return

   call read_atom_mask(table, "dkernel", record%dkernel, allowed%multipole, error)
   if (allocated(error)) return
   call read_atom_mask(table, "qkernel", record%qkernel, allowed%multipole, error)
   if (allocated(error)) return

   call read_atom_mask(table, "gam3", record%gam3, allowed%thirdorder, error)
   if (allocated(error)) return

   call read_atom_mask(table, "zeff", record%zeff, allowed%repulsion, error)
   if (allocated(error)) return
   call read_atom_mask(table, "arep", record%alpha, allowed%repulsion, error)
   if (allocated(error)) return

   call read_atom_mask(table, "xbond", record%xbond, allowed%halogen, error)
   if (allocated(error)) return
end subroutine record_from_table


subroutine read_atom_mask(table, key, mask, default, error)
   type(toml_table), intent(inout) :: table
   character(len=*), intent(in) :: key
   logical, intent(out) :: mask
   logical, intent(in) :: default
   type(error_type), allocatable, intent(out) :: error

   integer :: stat

   call get_value(table, key, mask, default)
end subroutine read_atom_mask


subroutine read_shell_mask(table, key, mask, default, error)
   type(toml_table), intent(inout) :: table
   character(len=*), intent(in) :: key
   logical, intent(out) :: mask(:)
   logical, intent(in) :: default
   type(error_type), allocatable, intent(out) :: error

   type(toml_array), pointer :: array
   integer :: ii, stat

   call get_value(table, key, array, requested=.false.)
   if (associated(array)) then
      do ii = 1, size(mask)
         call get_value(array, ii, mask(ii))
      end do
   else
      call get_value(table, key, mask(1), default)
      mask(:) = mask(1)
   end if
end subroutine read_shell_mask


!> Write parametrization mask to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(param_mask), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   if (allocated(self%hamiltonian)) then
      call add_table(table, "hamiltonian", child)
   end if

   if (allocated(self%dispersion)) then
      call add_table(table, "dispersion", child)
   end if

   if (allocated(self%repulsion)) then
      call add_table(table, "repulsion", child)
   end if

   if (allocated(self%halogen)) then
      call add_table(table, "halogen", child)
   end if

   if (allocated(self%charge)) then
      call add_table(table, "charge", child)
   end if

   if (allocated(self%multipole)) then
      call add_table(table, "multipole", child)
   end if

   if (allocated(self%thirdorder)) then
      call add_table(table, "thirdorder", child)
   end if

   if (allocated(self%thirdorder)) then
      call add_table(table, "thirdorder", child)
   end if

   call add_table(table, "element", child)
   call records_to_table(self%record, child, error)
   if (allocated(error)) return

end subroutine dump_to_toml


!> Serialize records to a table by iterating over all entries
subroutine records_to_table(record, table, error)
   !> List of all element records
   type(element_mask), intent(in) :: record(:)
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ii
   type(toml_table), pointer :: child

   do ii = 1, size(record)
      call add_table(table, trim(record(ii)%sym), child)
      call record_to_table(record(ii), child, error)
      if (allocated(error)) exit
   end do
   if (allocated(error)) return
end subroutine records_to_table


!> Serialize records to a table by iterating over all entries
subroutine record_to_table(record, table, error)
   !> List of all element records
   type(element_mask), intent(in) :: record
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: i, nsh
   type(toml_array), pointer :: array

   nsh = size(record%levels)

   call add_array(table, "levels", array)
   do i = 1, nsh
      call set_value(array, i, record%levels(i))
   end do

   call add_array(table, "slater", array)
   do i = 1, nsh
      call set_value(array, i, record%slater(i))
   end do

   call add_array(table, "shpoly", array)
   do i = 1, nsh
      call set_value(array, i, record%shpoly(i))
   end do

   call add_array(table, "kcn", array)
   do i = 1, nsh
      call set_value(array, i, record%kcn(i))
   end do

   call set_value(table, "gam", record%gam)
   call add_array(table, "lgam", array)
   do i = 1, nsh
      call set_value(array, i, record%lgam(i))
   end do

   call set_value(table, "gam3", record%gam3)

   call set_value(table, "zeff", record%zeff)
   call set_value(table, "arep", record%alpha)
   call set_value(table, "xbond", record%xbond)

   call set_value(table, "dkernel", record%dkernel)
   call set_value(table, "qkernel", record%qkernel)
end subroutine record_to_table


elemental function count_mask(mask) result(ncount)
   type(param_mask), intent(in) :: mask
   integer :: ncount
   ncount = 0
   if (allocated(mask%hamiltonian)) ncount = ncount + count(mask%hamiltonian)
   if (allocated(mask%dispersion)) ncount = ncount + count(mask%dispersion)
   if (allocated(mask%repulsion)) ncount = ncount + count(mask%repulsion)
   if (allocated(mask%halogen)) ncount = ncount + count(mask%halogen)
   if (allocated(mask%charge)) ncount = ncount + count(mask%charge)
   if (allocated(mask%multipole)) ncount = ncount + count(mask%multipole)
   if (allocated(mask%thirdorder)) ncount = ncount + count(mask%thirdorder)
   if (allocated(mask%record)) ncount = ncount + sum(count(mask%record))
end function count_mask


end module tblite_param_mask

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file src/ddx_definitions.f90
!! Compile-time constants are defined here.
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-06-15

!> Compile-time constants and definitions
module ddx_definitions

! Disable implicit types
implicit none

!> Kind of double precision
integer, parameter :: dp = kind(1.0d0)

!! Compile-time constants
real(dp), parameter :: zero = 0d0, one = 1d0, two = 2d0, three = 3d0
real(dp), parameter :: four = 4d0, pt5 = 5d-1
real(dp), parameter :: sqrt2 = sqrt(two)
real(dp), parameter :: sqrt3 = sqrt(three)
real(dp), parameter :: pi4 = atan(one)
real(dp), parameter :: pi = four * pi4
real(dp), parameter :: fourpi = four * pi
real(dp), parameter :: twopi = two * pi
real(dp), parameter :: sqrt4pi = four * sqrt(pi4)
real(dp), parameter :: machine_eps = epsilon(zero)
real(dp), parameter :: toang = 0.52917721092d0
real(dp), parameter :: tokcal = 627.509469d0
real(dp), parameter :: tokj = 2625.509469d0
real(dp), parameter :: tobohr = one / toang
!> Number of supported Lebedev grids
integer, parameter :: nllg = 32
!> Number of grid points of each Lebedev grid
integer, parameter :: ng0(nllg) = (/ 6, 14, 26, 38, 50, 74, 86, 110, 146, &
    & 170, 194, 230, 266, 302, 350, 434, 590, 770, 974, 1202, 1454, 1730, &
    & 2030, 2354, 2702, 3074, 3470, 3890, 4334, 4802, 5294, 5810 /)
!> Names of ddX models
character(len=255), parameter :: model_str(3) = (/ "COSMO", "PCM  ", "LPB  " /)

end module ddx_definitions

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_lapack_sygvd
   use mctc_env, only : sp, dp, error_type, fatal_error
   use tblite_output_format, only : format_string
   use tblite_scf_solver, only : solver_type
   implicit none
   private

   public :: sygvd_solver


   interface lapack_sygvd
      pure subroutine ssygvd(itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, &
            & iwork, liwork, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(inout) :: b(ldb, *)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine ssygvd
      pure subroutine dsygvd(itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, &
            & iwork, liwork, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(inout) :: b(ldb, *)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine dsygvd
   end interface lapack_sygvd


   type, extends(solver_type) :: sygvd_solver
      private
      integer :: n = 0
      integer, allocatable :: iwork(:)
      real(sp), allocatable :: swork(:)
      real(sp), allocatable :: sbmat(:, :)
      real(dp), allocatable :: dwork(:)
      real(dp), allocatable :: dbmat(:, :)
   contains
      procedure :: solve_sp
      procedure :: solve_dp
   end type sygvd_solver

contains

subroutine solve_sp(self, hmat, smat, eval, error)
   class(sygvd_solver), intent(inout) :: self
   real(sp), contiguous, intent(inout) :: hmat(:, :)
   real(sp), contiguous, intent(in) :: smat(:, :)
   real(sp), contiguous, intent(inout) :: eval(:)
   type(error_type), allocatable, intent(out) :: error
   integer :: info, lswork, liwork

   if (self%n == 0) then
      self%n = size(hmat, 1)
   end if
   if (.not.allocated(self%swork)) then
      allocate(self%swork(1 + 6*self%n + 2*self%n**2))
   end if
   if (.not.allocated(self%iwork)) then
      allocate(self%iwork(3 + 5*self%n))
   end if
   self%sbmat = smat
   lswork = size(self%swork)
   liwork = size(self%iwork)

   call lapack_sygvd(1, 'v', 'u', self%n, hmat, self%n, self%sbmat, self%n, eval, &
      & self%swork, lswork, self%iwork, liwork, info)

   call handle_info(error, info)

end subroutine solve_sp

subroutine solve_dp(self, hmat, smat, eval, error)
   class(sygvd_solver), intent(inout) :: self
   real(dp), contiguous, intent(inout) :: hmat(:, :)
   real(dp), contiguous, intent(in) :: smat(:, :)
   real(dp), contiguous, intent(inout) :: eval(:)
   type(error_type), allocatable, intent(out) :: error
   integer :: info, ldwork, liwork

   if (self%n == 0) then
      self%n = size(hmat, 1)
   end if
   if (.not.allocated(self%dwork)) then
      allocate(self%dwork(1 + 6*self%n + 2*self%n**2))
   end if
   if (.not.allocated(self%iwork)) then
      allocate(self%iwork(3 + 5*self%n))
   end if
   self%dbmat = smat
   ldwork = size(self%dwork)
   liwork = size(self%iwork)

   call lapack_sygvd(1, 'v', 'u', self%n, hmat, self%n, self%dbmat, self%n, eval, &
      & self%dwork, ldwork, self%iwork, liwork, info)

   call handle_info(error, info)

end subroutine solve_dp

subroutine handle_info(error, info)
   type(error_type), allocatable, intent(out) :: error
   integer, intent(in) :: info

   if (info /= 0) then
      call fatal_error(error, "(sygvd) failed to solve eigenvalue problem.&
         & info="//format_string(info, '(i0)'))
   end if
end subroutine handle_info

end module tblite_lapack_sygvd

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Automatically generated from 2018 CODATA NIST file:
!> https://physics.nist.gov/cuu/Constants/Table/allascii.txt
!>
!> Based on https://github.com/vmagnin/fundamental_constants.
module mctc_io_codata2018
   use mctc_env, only : wp
   implicit none
   public

   !> alpha particle-electron mass ratio (dimensionless)
   real(wp), parameter :: alpha_particle_electron_mass_ratio = 7294.29954142_wp
   !> alpha particle mass (kg)
   real(wp), parameter :: alpha_particle_mass = 6.6446573357e-27_wp
   !> alpha particle mass energy equivalent (J)
   real(wp), parameter :: alpha_particle_mass_energy_equivalent = 5.9719201914e-10_wp
   !> alpha particle mass energy equivalent in MeV (MeV)
   real(wp), parameter :: alpha_particle_mass_energy_equivalent_in_MeV = 3727.3794066_wp
   !> alpha particle mass in u (u)
   real(wp), parameter :: alpha_particle_mass_in_u = 4.001506179127_wp
   !> alpha particle molar mass (kg mol^-1)
   real(wp), parameter :: alpha_particle_molar_mass = 4.0015061777e-3_wp
   !> alpha particle-proton mass ratio (dimensionless)
   real(wp), parameter :: alpha_particle_proton_mass_ratio = 3.97259969009_wp
   !> alpha particle relative atomic mass (dimensionless)
   real(wp), parameter :: alpha_particle_relative_atomic_mass = 4.001506179127_wp
   !> Angstrom star (m)
   real(wp), parameter :: Angstrom_star = 1.00001495e-10_wp
   !> atomic mass constant (kg)
   real(wp), parameter :: atomic_mass_constant = 1.66053906660e-27_wp
   !> atomic mass constant energy equivalent (J)
   real(wp), parameter :: atomic_mass_constant_energy_equivalent = 1.49241808560e-10_wp
   !> atomic mass constant energy equivalent in MeV (MeV)
   real(wp), parameter :: atomic_mass_constant_energy_equivalent_in_MeV = 931.49410242_wp
   !> atomic mass unit-electron volt relationship (eV)
   real(wp), parameter :: atomic_mass_unit_electron_volt_relationship = 9.3149410242e8_wp
   !> atomic mass unit-hartree relationship (E_h)
   real(wp), parameter :: atomic_mass_unit_hartree_relationship = 3.4231776874e7_wp
   !> atomic mass unit-hertz relationship (Hz)
   real(wp), parameter :: atomic_mass_unit_hertz_relationship = 2.25234271871e23_wp
   !> atomic mass unit-inverse meter relationship (m^-1)
   real(wp), parameter :: atomic_mass_unit_inverse_meter_relationship = 7.5130066104e14_wp
   !> atomic mass unit-joule relationship (J)
   real(wp), parameter :: atomic_mass_unit_joule_relationship = 1.49241808560e-10_wp
   !> atomic mass unit-kelvin relationship (K)
   real(wp), parameter :: atomic_mass_unit_kelvin_relationship = 1.08095401916e13_wp
   !> atomic mass unit-kilogram relationship (kg)
   real(wp), parameter :: atomic_mass_unit_kilogram_relationship = 1.66053906660e-27_wp
   !> atomic unit of 1st hyperpolarizability (C^3 m^3 J^-2)
   real(wp), parameter :: atomic_unit_of_1st_hyperpolarizability = 3.2063613061e-53_wp
   !> atomic unit of 2nd hyperpolarizability (C^4 m^4 J^-3)
   real(wp), parameter :: atomic_unit_of_2nd_hyperpolarizability = 6.2353799905e-65_wp
   !> atomic unit of action (J s)
   real(wp), parameter :: atomic_unit_of_action = 1.054571817e-34_wp
   !> atomic unit of charge (C)
   real(wp), parameter :: atomic_unit_of_charge = 1.602176634e-19_wp
   !> atomic unit of charge density (C m^-3)
   real(wp), parameter :: atomic_unit_of_charge_density = 1.08120238457e12_wp
   !> atomic unit of current (A)
   real(wp), parameter :: atomic_unit_of_current = 6.623618237510e-3_wp
   !> atomic unit of electric dipole mom. (C m)
   real(wp), parameter :: atomic_unit_of_electric_dipole_mom_ = 8.4783536255e-30_wp
   !> atomic unit of electric field (V m^-1)
   real(wp), parameter :: atomic_unit_of_electric_field = 5.14220674763e11_wp
   !> atomic unit of electric field gradient (V m^-2)
   real(wp), parameter :: atomic_unit_of_electric_field_gradient = 9.7173624292e21_wp
   !> atomic unit of electric polarizability (C^2 m^2 J^-1)
   real(wp), parameter :: atomic_unit_of_electric_polarizability = 1.64877727436e-41_wp
   !> atomic unit of electric potential (V)
   real(wp), parameter :: atomic_unit_of_electric_potential = 27.211386245988_wp
   !> atomic unit of electric quadrupole mom. (C m^2)
   real(wp), parameter :: atomic_unit_of_electric_quadrupole_mom_ = 4.4865515246e-40_wp
   !> atomic unit of energy (J)
   real(wp), parameter :: atomic_unit_of_energy = 4.3597447222071e-18_wp
   !> atomic unit of force (N)
   real(wp), parameter :: atomic_unit_of_force = 8.2387234983e-8_wp
   !> atomic unit of length (m)
   real(wp), parameter :: atomic_unit_of_length = 5.29177210903e-11_wp
   !> atomic unit of mag. dipole mom. (J T^-1)
   real(wp), parameter :: atomic_unit_of_mag__dipole_mom_ = 1.85480201566e-23_wp
   !> atomic unit of mag. flux density (T)
   real(wp), parameter :: atomic_unit_of_mag__flux_density = 2.35051756758e5_wp
   !> atomic unit of magnetizability (J T^-2)
   real(wp), parameter :: atomic_unit_of_magnetizability = 7.8910366008e-29_wp
   !> atomic unit of mass (kg)
   real(wp), parameter :: atomic_unit_of_mass = 9.1093837015e-31_wp
   !> atomic unit of momentum (kg m s^-1)
   real(wp), parameter :: atomic_unit_of_momentum = 1.99285191410e-24_wp
   !> atomic unit of permittivity (F m^-1)
   real(wp), parameter :: atomic_unit_of_permittivity = 1.11265005545e-10_wp
   !> atomic unit of time (s)
   real(wp), parameter :: atomic_unit_of_time = 2.4188843265857e-17_wp
   !> atomic unit of velocity (m s^-1)
   real(wp), parameter :: atomic_unit_of_velocity = 2.18769126364e6_wp
   !> Avogadro constant (mol^-1)
   real(wp), parameter :: Avogadro_constant = 6.02214076e23_wp
   !> Bohr magneton (J T^-1)
   real(wp), parameter :: Bohr_magneton = 9.2740100783e-24_wp
   !> Bohr magneton in eV/T (eV T^-1)
   real(wp), parameter :: Bohr_magneton_in_eV_T = 5.7883818060e-5_wp
   !> Bohr magneton in Hz/T (Hz T^-1)
   real(wp), parameter :: Bohr_magneton_in_Hz_T = 1.39962449361e10_wp
   !> Bohr magneton in inverse meter per tesla (m^-1 T^-1)
   real(wp), parameter :: Bohr_magneton_in_inverse_meter_per_tesla = 46.686447783_wp
   !> Bohr magneton in K/T (K T^-1)
   real(wp), parameter :: Bohr_magneton_in_K_T = 0.67171381563_wp
   !> Bohr radius (m)
   real(wp), parameter :: Bohr_radius = 5.29177210903e-11_wp
   !> Boltzmann constant (J K^-1)
   real(wp), parameter :: Boltzmann_constant = 1.380649e-23_wp
   !> Boltzmann constant in eV/K (eV K^-1)
   real(wp), parameter :: Boltzmann_constant_in_eV_K = 8.617333262e-5_wp
   !> Boltzmann constant in Hz/K (Hz K^-1)
   real(wp), parameter :: Boltzmann_constant_in_Hz_K = 2.083661912e10_wp
   !> Boltzmann constant in inverse meter per kelvin (m^-1 K^-1)
   real(wp), parameter :: Boltzmann_constant_in_inverse_meter_per_kelvin = 69.50348004_wp
   !> characteristic impedance of vacuum (ohm)
   real(wp), parameter :: characteristic_impedance_of_vacuum = 376.730313668_wp
   !> classical electron radius (m)
   real(wp), parameter :: classical_electron_radius = 2.8179403262e-15_wp
   !> Compton wavelength (m)
   real(wp), parameter :: Compton_wavelength = 2.42631023867e-12_wp
   !> conductance quantum (S)
   real(wp), parameter :: conductance_quantum = 7.748091729e-5_wp
   !> conventional value of ampere-90 (A)
   real(wp), parameter :: conventional_value_of_ampere_90 = 1.00000008887_wp
   !> conventional value of coulomb-90 (C)
   real(wp), parameter :: conventional_value_of_coulomb_90 = 1.00000008887_wp
   !> conventional value of farad-90 (F)
   real(wp), parameter :: conventional_value_of_farad_90 = 0.99999998220_wp
   !> conventional value of henry-90 (H)
   real(wp), parameter :: conventional_value_of_henry_90 = 1.00000001779_wp
   !> conventional value of Josephson constant (Hz V^-1)
   real(wp), parameter :: conventional_value_of_Josephson_constant = 483597.9e9_wp
   !> conventional value of ohm-90 (ohm)
   real(wp), parameter :: conventional_value_of_ohm_90 = 1.00000001779_wp
   !> conventional value of volt-90 (V)
   real(wp), parameter :: conventional_value_of_volt_90 = 1.00000010666_wp
   !> conventional value of von Klitzing constant (ohm)
   real(wp), parameter :: conventional_value_of_von_Klitzing_constant = 25812.807_wp
   !> conventional value of watt-90 (W)
   real(wp), parameter :: conventional_value_of_watt_90 = 1.00000019553_wp
   !> Copper x unit (m)
   real(wp), parameter :: Copper_x_unit = 1.00207697e-13_wp
   !> deuteron-electron mag. mom. ratio (dimensionless)
   real(wp), parameter :: deuteron_electron_mag__mom__ratio = -4.664345551e-4_wp
   !> deuteron-electron mass ratio (dimensionless)
   real(wp), parameter :: deuteron_electron_mass_ratio = 3670.48296788_wp
   !> deuteron g factor (dimensionless)
   real(wp), parameter :: deuteron_g_factor = 0.8574382338_wp
   !> deuteron mag. mom. (J T^-1)
   real(wp), parameter :: deuteron_mag__mom_ = 4.330735094e-27_wp
   !> deuteron mag. mom. to Bohr magneton ratio (dimensionless)
   real(wp), parameter :: deuteron_mag__mom__to_Bohr_magneton_ratio = 4.669754570e-4_wp
   !> deuteron mag. mom. to nuclear magneton ratio (dimensionless)
   real(wp), parameter :: deuteron_mag__mom__to_nuclear_magneton_ratio = 0.8574382338_wp
   !> deuteron mass (kg)
   real(wp), parameter :: deuteron_mass = 3.3435837724e-27_wp
   !> deuteron mass energy equivalent (J)
   real(wp), parameter :: deuteron_mass_energy_equivalent = 3.00506323102e-10_wp
   !> deuteron mass energy equivalent in MeV (MeV)
   real(wp), parameter :: deuteron_mass_energy_equivalent_in_MeV = 1875.61294257_wp
   !> deuteron mass in u (u)
   real(wp), parameter :: deuteron_mass_in_u = 2.013553212745_wp
   !> deuteron molar mass (kg mol^-1)
   real(wp), parameter :: deuteron_molar_mass = 2.01355321205e-3_wp
   !> deuteron-neutron mag. mom. ratio (dimensionless)
   real(wp), parameter :: deuteron_neutron_mag__mom__ratio = -0.44820653_wp
   !> deuteron-proton mag. mom. ratio (dimensionless)
   real(wp), parameter :: deuteron_proton_mag__mom__ratio = 0.30701220939_wp
   !> deuteron-proton mass ratio (dimensionless)
   real(wp), parameter :: deuteron_proton_mass_ratio = 1.99900750139_wp
   !> deuteron relative atomic mass (dimensionless)
   real(wp), parameter :: deuteron_relative_atomic_mass = 2.013553212745_wp
   !> deuteron rms charge radius (m)
   real(wp), parameter :: deuteron_rms_charge_radius = 2.12799e-15_wp
   !> electron charge to mass quotient (C kg^-1)
   real(wp), parameter :: electron_charge_to_mass_quotient = -1.75882001076e11_wp
   !> electron-deuteron mag. mom. ratio (dimensionless)
   real(wp), parameter :: electron_deuteron_mag__mom__ratio = -2143.9234915_wp
   !> electron-deuteron mass ratio (dimensionless)
   real(wp), parameter :: electron_deuteron_mass_ratio = 2.724437107462e-4_wp
   !> electron g factor (dimensionless)
   real(wp), parameter :: electron_g_factor = -2.00231930436256_wp
   !> electron gyromag. ratio (s^-1 T^-1)
   real(wp), parameter :: electron_gyromag__ratio = 1.76085963023e11_wp
   !> electron gyromag. ratio in MHz/T (MHz T^-1)
   real(wp), parameter :: electron_gyromag__ratio_in_MHz_T = 28024.9514242_wp
   !> electron-helion mass ratio (dimensionless)
   real(wp), parameter :: electron_helion_mass_ratio = 1.819543074573e-4_wp
   !> electron mag. mom. (J T^-1)
   real(wp), parameter :: electron_mag__mom_ = -9.2847647043e-24_wp
   !> electron mag. mom. anomaly (dimensionless)
   real(wp), parameter :: electron_mag__mom__anomaly = 1.15965218128e-3_wp
   !> electron mag. mom. to Bohr magneton ratio (dimensionless)
   real(wp), parameter :: electron_mag__mom__to_Bohr_magneton_ratio = -1.00115965218128_wp
   !> electron mag. mom. to nuclear magneton ratio (dimensionless)
   real(wp), parameter :: electron_mag__mom__to_nuclear_magneton_ratio = -1838.28197188_wp
   !> electron mass (kg)
   real(wp), parameter :: electron_mass = 9.1093837015e-31_wp
   !> electron mass energy equivalent (J)
   real(wp), parameter :: electron_mass_energy_equivalent = 8.1871057769e-14_wp
   !> electron mass energy equivalent in MeV (MeV)
   real(wp), parameter :: electron_mass_energy_equivalent_in_MeV = 0.51099895000_wp
   !> electron mass in u (u)
   real(wp), parameter :: electron_mass_in_u = 5.48579909065e-4_wp
   !> electron molar mass (kg mol^-1)
   real(wp), parameter :: electron_molar_mass = 5.4857990888e-7_wp
   !> electron-muon mag. mom. ratio (dimensionless)
   real(wp), parameter :: electron_muon_mag__mom__ratio = 206.7669883_wp
   !> electron-muon mass ratio (dimensionless)
   real(wp), parameter :: electron_muon_mass_ratio = 4.83633169e-3_wp
   !> electron-neutron mag. mom. ratio (dimensionless)
   real(wp), parameter :: electron_neutron_mag__mom__ratio = 960.92050_wp
   !> electron-neutron mass ratio (dimensionless)
   real(wp), parameter :: electron_neutron_mass_ratio = 5.4386734424e-4_wp
   !> electron-proton mag. mom. ratio (dimensionless)
   real(wp), parameter :: electron_proton_mag__mom__ratio = -658.21068789_wp
   !> electron-proton mass ratio (dimensionless)
   real(wp), parameter :: electron_proton_mass_ratio = 5.44617021487e-4_wp
   !> electron relative atomic mass (dimensionless)
   real(wp), parameter :: electron_relative_atomic_mass = 5.48579909065e-4_wp
   !> electron-tau mass ratio (dimensionless)
   real(wp), parameter :: electron_tau_mass_ratio = 2.87585e-4_wp
   !> electron to alpha particle mass ratio (dimensionless)
   real(wp), parameter :: electron_to_alpha_particle_mass_ratio = 1.370933554787e-4_wp
   !> electron to shielded helion mag. mom. ratio (dimensionless)
   real(wp), parameter :: electron_to_shielded_helion_mag__mom__ratio = 864.058257_wp
   !> electron to shielded proton mag. mom. ratio (dimensionless)
   real(wp), parameter :: electron_to_shielded_proton_mag__mom__ratio = -658.2275971_wp
   !> electron-triton mass ratio (dimensionless)
   real(wp), parameter :: electron_triton_mass_ratio = 1.819200062251e-4_wp
   !> electron volt (J)
   real(wp), parameter :: electron_volt = 1.602176634e-19_wp
   !> electron volt-atomic mass unit relationship (u)
   real(wp), parameter :: electron_volt_atomic_mass_unit_relationship = 1.07354410233e-9_wp
   !> electron volt-hartree relationship (E_h)
   real(wp), parameter :: electron_volt_hartree_relationship = 3.6749322175655e-2_wp
   !> electron volt-hertz relationship (Hz)
   real(wp), parameter :: electron_volt_hertz_relationship = 2.417989242e14_wp
   !> electron volt-inverse meter relationship (m^-1)
   real(wp), parameter :: electron_volt_inverse_meter_relationship = 8.065543937e5_wp
   !> electron volt-joule relationship (J)
   real(wp), parameter :: electron_volt_joule_relationship = 1.602176634e-19_wp
   !> electron volt-kelvin relationship (K)
   real(wp), parameter :: electron_volt_kelvin_relationship = 1.160451812e4_wp
   !> electron volt-kilogram relationship (kg)
   real(wp), parameter :: electron_volt_kilogram_relationship = 1.782661921e-36_wp
   !> elementary charge (C)
   real(wp), parameter :: elementary_charge = 1.602176634e-19_wp
   !> elementary charge over h-bar (A J^-1)
   real(wp), parameter :: elementary_charge_over_h_bar = 1.519267447e15_wp
   !> Faraday constant (C mol^-1)
   real(wp), parameter :: Faraday_constant = 96485.33212_wp
   !> Fermi coupling constant (GeV^-2)
   real(wp), parameter :: Fermi_coupling_constant = 1.1663787e-5_wp
   !> fine-structure constant (dimensionless)
   real(wp), parameter :: fine_structure_constant = 7.2973525693e-3_wp
   !> first radiation constant (W m^2)
   real(wp), parameter :: first_radiation_constant = 3.741771852e-16_wp
   !> first radiation constant for spectral radiance (W m^2 sr^-1)
   real(wp), parameter :: first_radiation_constant_for_spectral_radiance = 1.191042972e-16_wp
   !> hartree-atomic mass unit relationship (u)
   real(wp), parameter :: hartree_atomic_mass_unit_relationship = 2.92126232205e-8_wp
   !> hartree-electron volt relationship (eV)
   real(wp), parameter :: hartree_electron_volt_relationship = 27.211386245988_wp
   !> Hartree energy (J)
   real(wp), parameter :: Hartree_energy = 4.3597447222071e-18_wp
   !> Hartree energy in eV (eV)
   real(wp), parameter :: Hartree_energy_in_eV = 27.211386245988_wp
   !> hartree-hertz relationship (Hz)
   real(wp), parameter :: hartree_hertz_relationship = 6.579683920502e15_wp
   !> hartree-inverse meter relationship (m^-1)
   real(wp), parameter :: hartree_inverse_meter_relationship = 2.1947463136320e7_wp
   !> hartree-joule relationship (J)
   real(wp), parameter :: hartree_joule_relationship = 4.3597447222071e-18_wp
   !> hartree-kelvin relationship (K)
   real(wp), parameter :: hartree_kelvin_relationship = 3.1577502480407e5_wp
   !> hartree-kilogram relationship (kg)
   real(wp), parameter :: hartree_kilogram_relationship = 4.8508702095432e-35_wp
   !> helion-electron mass ratio (dimensionless)
   real(wp), parameter :: helion_electron_mass_ratio = 5495.88528007_wp
   !> helion g factor (dimensionless)
   real(wp), parameter :: helion_g_factor = -4.255250615_wp
   !> helion mag. mom. (J T^-1)
   real(wp), parameter :: helion_mag__mom_ = -1.074617532e-26_wp
   !> helion mag. mom. to Bohr magneton ratio (dimensionless)
   real(wp), parameter :: helion_mag__mom__to_Bohr_magneton_ratio = -1.158740958e-3_wp
   !> helion mag. mom. to nuclear magneton ratio (dimensionless)
   real(wp), parameter :: helion_mag__mom__to_nuclear_magneton_ratio = -2.127625307_wp
   !> helion mass (kg)
   real(wp), parameter :: helion_mass = 5.0064127796e-27_wp
   !> helion mass energy equivalent (J)
   real(wp), parameter :: helion_mass_energy_equivalent = 4.4995394125e-10_wp
   !> helion mass energy equivalent in MeV (MeV)
   real(wp), parameter :: helion_mass_energy_equivalent_in_MeV = 2808.39160743_wp
   !> helion mass in u (u)
   real(wp), parameter :: helion_mass_in_u = 3.014932247175_wp
   !> helion molar mass (kg mol^-1)
   real(wp), parameter :: helion_molar_mass = 3.01493224613e-3_wp
   !> helion-proton mass ratio (dimensionless)
   real(wp), parameter :: helion_proton_mass_ratio = 2.99315267167_wp
   !> helion relative atomic mass (dimensionless)
   real(wp), parameter :: helion_relative_atomic_mass = 3.014932247175_wp
   !> helion shielding shift (dimensionless)
   real(wp), parameter :: helion_shielding_shift = 5.996743e-5_wp
   !> hertz-atomic mass unit relationship (u)
   real(wp), parameter :: hertz_atomic_mass_unit_relationship = 4.4398216652e-24_wp
   !> hertz-electron volt relationship (eV)
   real(wp), parameter :: hertz_electron_volt_relationship = 4.135667696e-15_wp
   !> hertz-hartree relationship (E_h)
   real(wp), parameter :: hertz_hartree_relationship = 1.5198298460570e-16_wp
   !> hertz-inverse meter relationship (m^-1)
   real(wp), parameter :: hertz_inverse_meter_relationship = 3.335640951e-9_wp
   !> hertz-joule relationship (J)
   real(wp), parameter :: hertz_joule_relationship = 6.62607015e-34_wp
   !> hertz-kelvin relationship (K)
   real(wp), parameter :: hertz_kelvin_relationship = 4.799243073e-11_wp
   !> hertz-kilogram relationship (kg)
   real(wp), parameter :: hertz_kilogram_relationship = 7.372497323e-51_wp
   !> hyperfine transition frequency of Cs-133 (Hz)
   real(wp), parameter :: hyperfine_transition_frequency_of_Cs_133 = 9192631770e0_wp
   !> inverse fine-structure constant (dimensionless)
   real(wp), parameter :: inverse_fine_structure_constant = 137.035999084_wp
   !> inverse meter-atomic mass unit relationship (u)
   real(wp), parameter :: inverse_meter_atomic_mass_unit_relationship = 1.33102505010e-15_wp
   !> inverse meter-electron volt relationship (eV)
   real(wp), parameter :: inverse_meter_electron_volt_relationship = 1.239841984e-6_wp
   !> inverse meter-hartree relationship (E_h)
   real(wp), parameter :: inverse_meter_hartree_relationship = 4.5563352529120e-8_wp
   !> inverse meter-hertz relationship (Hz)
   real(wp), parameter :: inverse_meter_hertz_relationship = 299792458e0_wp
   !> inverse meter-joule relationship (J)
   real(wp), parameter :: inverse_meter_joule_relationship = 1.986445857e-25_wp
   !> inverse meter-kelvin relationship (K)
   real(wp), parameter :: inverse_meter_kelvin_relationship = 1.438776877e-2_wp
   !> inverse meter-kilogram relationship (kg)
   real(wp), parameter :: inverse_meter_kilogram_relationship = 2.210219094e-42_wp
   !> inverse of conductance quantum (ohm)
   real(wp), parameter :: inverse_of_conductance_quantum = 12906.40372_wp
   !> Josephson constant (Hz V^-1)
   real(wp), parameter :: Josephson_constant = 483597.8484e9_wp
   !> joule-atomic mass unit relationship (u)
   real(wp), parameter :: joule_atomic_mass_unit_relationship = 6.7005352565e9_wp
   !> joule-electron volt relationship (eV)
   real(wp), parameter :: joule_electron_volt_relationship = 6.241509074e18_wp
   !> joule-hartree relationship (E_h)
   real(wp), parameter :: joule_hartree_relationship = 2.2937122783963e17_wp
   !> joule-hertz relationship (Hz)
   real(wp), parameter :: joule_hertz_relationship = 1.509190179e33_wp
   !> joule-inverse meter relationship (m^-1)
   real(wp), parameter :: joule_inverse_meter_relationship = 5.034116567e24_wp
   !> joule-kelvin relationship (K)
   real(wp), parameter :: joule_kelvin_relationship = 7.242970516e22_wp
   !> joule-kilogram relationship (kg)
   real(wp), parameter :: joule_kilogram_relationship = 1.112650056e-17_wp
   !> kelvin-atomic mass unit relationship (u)
   real(wp), parameter :: kelvin_atomic_mass_unit_relationship = 9.2510873014e-14_wp
   !> kelvin-electron volt relationship (eV)
   real(wp), parameter :: kelvin_electron_volt_relationship = 8.617333262e-5_wp
   !> kelvin-hartree relationship (E_h)
   real(wp), parameter :: kelvin_hartree_relationship = 3.1668115634556e-6_wp
   !> kelvin-hertz relationship (Hz)
   real(wp), parameter :: kelvin_hertz_relationship = 2.083661912e10_wp
   !> kelvin-inverse meter relationship (m^-1)
   real(wp), parameter :: kelvin_inverse_meter_relationship = 69.50348004_wp
   !> kelvin-joule relationship (J)
   real(wp), parameter :: kelvin_joule_relationship = 1.380649e-23_wp
   !> kelvin-kilogram relationship (kg)
   real(wp), parameter :: kelvin_kilogram_relationship = 1.536179187e-40_wp
   !> kilogram-atomic mass unit relationship (u)
   real(wp), parameter :: kilogram_atomic_mass_unit_relationship = 6.0221407621e26_wp
   !> kilogram-electron volt relationship (eV)
   real(wp), parameter :: kilogram_electron_volt_relationship = 5.609588603e35_wp
   !> kilogram-hartree relationship (E_h)
   real(wp), parameter :: kilogram_hartree_relationship = 2.0614857887409e34_wp
   !> kilogram-hertz relationship (Hz)
   real(wp), parameter :: kilogram_hertz_relationship = 1.356392489e50_wp
   !> kilogram-inverse meter relationship (m^-1)
   real(wp), parameter :: kilogram_inverse_meter_relationship = 4.524438335e41_wp
   !> kilogram-joule relationship (J)
   real(wp), parameter :: kilogram_joule_relationship = 8.987551787e16_wp
   !> kilogram-kelvin relationship (K)
   real(wp), parameter :: kilogram_kelvin_relationship = 6.509657260e39_wp
   !> lattice parameter of silicon (m)
   real(wp), parameter :: lattice_parameter_of_silicon = 5.431020511e-10_wp
   !> lattice spacing of ideal Si (220) (m)
   real(wp), parameter :: lattice_spacing_of_ideal_Si_220 = 1.920155716e-10_wp
   !> Loschmidt constant (273.15 K, 100 kPa) (m^-3)
   real(wp), parameter :: Loschmidt_constant_273_15_K__100_kPa = 2.651645804e25_wp
   !> Loschmidt constant (273.15 K, 101.325 kPa) (m^-3)
   real(wp), parameter :: Loschmidt_constant_273_15_K__101_325_kPa = 2.686780111e25_wp
   !> luminous efficacy (lm W^-1)
   real(wp), parameter :: luminous_efficacy = 683e0_wp
   !> mag. flux quantum (Wb)
   real(wp), parameter :: mag__flux_quantum = 2.067833848e-15_wp
   !> molar gas constant (J mol^-1 K^-1)
   real(wp), parameter :: molar_gas_constant = 8.314462618_wp
   !> molar mass constant (kg mol^-1)
   real(wp), parameter :: molar_mass_constant = 0.99999999965e-3_wp
   !> molar mass of carbon-12 (kg mol^-1)
   real(wp), parameter :: molar_mass_of_carbon_12 = 11.9999999958e-3_wp
   !> molar Planck constant (J Hz^-1 mol^-1)
   real(wp), parameter :: molar_Planck_constant = 3.990312712e-10_wp
   !> molar volume of ideal gas (273.15 K, 100 kPa) (m^3 mol^-1)
   real(wp), parameter :: molar_volume_of_ideal_gas_273_15_K__100_kPa = 22.71095464e-3_wp
   !> molar volume of ideal gas (273.15 K, 101.325 kPa) (m^3 mol^-1)
   real(wp), parameter :: molar_volume_of_ideal_gas_273_15_K__101_325_kPa = 22.41396954e-3_wp
   !> molar volume of silicon (m^3 mol^-1)
   real(wp), parameter :: molar_volume_of_silicon = 1.205883199e-5_wp
   !> Molybdenum x unit (m)
   real(wp), parameter :: Molybdenum_x_unit = 1.00209952e-13_wp
   !> muon Compton wavelength (m)
   real(wp), parameter :: muon_Compton_wavelength = 1.173444110e-14_wp
   !> muon-electron mass ratio (dimensionless)
   real(wp), parameter :: muon_electron_mass_ratio = 206.7682830_wp
   !> muon g factor (dimensionless)
   real(wp), parameter :: muon_g_factor = -2.0023318418_wp
   !> muon mag. mom. (J T^-1)
   real(wp), parameter :: muon_mag__mom_ = -4.49044830e-26_wp
   !> muon mag. mom. anomaly (dimensionless)
   real(wp), parameter :: muon_mag__mom__anomaly = 1.16592089e-3_wp
   !> muon mag. mom. to Bohr magneton ratio (dimensionless)
   real(wp), parameter :: muon_mag__mom__to_Bohr_magneton_ratio = -4.84197047e-3_wp
   !> muon mag. mom. to nuclear magneton ratio (dimensionless)
   real(wp), parameter :: muon_mag__mom__to_nuclear_magneton_ratio = -8.89059703_wp
   !> muon mass (kg)
   real(wp), parameter :: muon_mass = 1.883531627e-28_wp
   !> muon mass energy equivalent (J)
   real(wp), parameter :: muon_mass_energy_equivalent = 1.692833804e-11_wp
   !> muon mass energy equivalent in MeV (MeV)
   real(wp), parameter :: muon_mass_energy_equivalent_in_MeV = 105.6583755_wp
   !> muon mass in u (u)
   real(wp), parameter :: muon_mass_in_u = 0.1134289259_wp
   !> muon molar mass (kg mol^-1)
   real(wp), parameter :: muon_molar_mass = 1.134289259e-4_wp
   !> muon-neutron mass ratio (dimensionless)
   real(wp), parameter :: muon_neutron_mass_ratio = 0.1124545170_wp
   !> muon-proton mag. mom. ratio (dimensionless)
   real(wp), parameter :: muon_proton_mag__mom__ratio = -3.183345142_wp
   !> muon-proton mass ratio (dimensionless)
   real(wp), parameter :: muon_proton_mass_ratio = 0.1126095264_wp
   !> muon-tau mass ratio (dimensionless)
   real(wp), parameter :: muon_tau_mass_ratio = 5.94635e-2_wp
   !> natural unit of action (J s)
   real(wp), parameter :: natural_unit_of_action = 1.054571817e-34_wp
   !> natural unit of action in eV s (eV s)
   real(wp), parameter :: natural_unit_of_action_in_eV_s = 6.582119569e-16_wp
   !> natural unit of energy (J)
   real(wp), parameter :: natural_unit_of_energy = 8.1871057769e-14_wp
   !> natural unit of energy in MeV (MeV)
   real(wp), parameter :: natural_unit_of_energy_in_MeV = 0.51099895000_wp
   !> natural unit of length (m)
   real(wp), parameter :: natural_unit_of_length = 3.8615926796e-13_wp
   !> natural unit of mass (kg)
   real(wp), parameter :: natural_unit_of_mass = 9.1093837015e-31_wp
   !> natural unit of momentum (kg m s^-1)
   real(wp), parameter :: natural_unit_of_momentum = 2.73092453075e-22_wp
   !> natural unit of momentum in MeV/c (MeV/c)
   real(wp), parameter :: natural_unit_of_momentum_in_MeV_c = 0.51099895000_wp
   !> natural unit of time (s)
   real(wp), parameter :: natural_unit_of_time = 1.28808866819e-21_wp
   !> natural unit of velocity (m s^-1)
   real(wp), parameter :: natural_unit_of_velocity = 299792458e0_wp
   !> neutron Compton wavelength (m)
   real(wp), parameter :: neutron_Compton_wavelength = 1.31959090581e-15_wp
   !> neutron-electron mag. mom. ratio (dimensionless)
   real(wp), parameter :: neutron_electron_mag__mom__ratio = 1.04066882e-3_wp
   !> neutron-electron mass ratio (dimensionless)
   real(wp), parameter :: neutron_electron_mass_ratio = 1838.68366173_wp
   !> neutron g factor (dimensionless)
   real(wp), parameter :: neutron_g_factor = -3.82608545_wp
   !> neutron gyromag. ratio (s^-1 T^-1)
   real(wp), parameter :: neutron_gyromag__ratio = 1.83247171e8_wp
   !> neutron gyromag. ratio in MHz/T (MHz T^-1)
   real(wp), parameter :: neutron_gyromag__ratio_in_MHz_T = 29.1646931_wp
   !> neutron mag. mom. (J T^-1)
   real(wp), parameter :: neutron_mag__mom_ = -9.6623651e-27_wp
   !> neutron mag. mom. to Bohr magneton ratio (dimensionless)
   real(wp), parameter :: neutron_mag__mom__to_Bohr_magneton_ratio = -1.04187563e-3_wp
   !> neutron mag. mom. to nuclear magneton ratio (dimensionless)
   real(wp), parameter :: neutron_mag__mom__to_nuclear_magneton_ratio = -1.91304273_wp
   !> neutron mass (kg)
   real(wp), parameter :: neutron_mass = 1.67492749804e-27_wp
   !> neutron mass energy equivalent (J)
   real(wp), parameter :: neutron_mass_energy_equivalent = 1.50534976287e-10_wp
   !> neutron mass energy equivalent in MeV (MeV)
   real(wp), parameter :: neutron_mass_energy_equivalent_in_MeV = 939.56542052_wp
   !> neutron mass in u (u)
   real(wp), parameter :: neutron_mass_in_u = 1.00866491595_wp
   !> neutron molar mass (kg mol^-1)
   real(wp), parameter :: neutron_molar_mass = 1.00866491560e-3_wp
   !> neutron-muon mass ratio (dimensionless)
   real(wp), parameter :: neutron_muon_mass_ratio = 8.89248406_wp
   !> neutron-proton mag. mom. ratio (dimensionless)
   real(wp), parameter :: neutron_proton_mag__mom__ratio = -0.68497934_wp
   !> neutron-proton mass difference (kg)
   real(wp), parameter :: neutron_proton_mass_difference = 2.30557435e-30_wp
   !> neutron-proton mass difference energy equivalent (J)
   real(wp), parameter :: neutron_proton_mass_difference_energy_equivalent = 2.07214689e-13_wp
   !> neutron-proton mass difference energy equivalent in MeV (MeV)
   real(wp), parameter :: neutron_proton_mass_difference_energy_equivalent_in_MeV = 1.29333236_wp
   !> neutron-proton mass difference in u (u)
   real(wp), parameter :: neutron_proton_mass_difference_in_u = 1.38844933e-3_wp
   !> neutron-proton mass ratio (dimensionless)
   real(wp), parameter :: neutron_proton_mass_ratio = 1.00137841931_wp
   !> neutron relative atomic mass (dimensionless)
   real(wp), parameter :: neutron_relative_atomic_mass = 1.00866491595_wp
   !> neutron-tau mass ratio (dimensionless)
   real(wp), parameter :: neutron_tau_mass_ratio = 0.528779_wp
   !> neutron to shielded proton mag. mom. ratio (dimensionless)
   real(wp), parameter :: neutron_to_shielded_proton_mag__mom__ratio = -0.68499694_wp
   !> Newtonian constant of gravitation (m^3 kg^-1 s^-2)
   real(wp), parameter :: Newtonian_constant_of_gravitation = 6.67430e-11_wp
   !> Newtonian constant of gravitation over h-bar c ((GeV/c^2)^-2)
   real(wp), parameter :: Newtonian_constant_of_gravitation_over_h_bar_c = 6.70883e-39_wp
   !> nuclear magneton (J T^-1)
   real(wp), parameter :: nuclear_magneton = 5.0507837461e-27_wp
   !> nuclear magneton in eV/T (eV T^-1)
   real(wp), parameter :: nuclear_magneton_in_eV_T = 3.15245125844e-8_wp
   !> nuclear magneton in inverse meter per tesla (m^-1 T^-1)
   real(wp), parameter :: nuclear_magneton_in_inverse_meter_per_tesla = 2.54262341353e-2_wp
   !> nuclear magneton in K/T (K T^-1)
   real(wp), parameter :: nuclear_magneton_in_K_T = 3.6582677756e-4_wp
   !> nuclear magneton in MHz/T (MHz T^-1)
   real(wp), parameter :: nuclear_magneton_in_MHz_T = 7.6225932291_wp
   !> Planck constant (J Hz^-1)
   real(wp), parameter :: Planck_constant = 6.62607015e-34_wp
   !> Planck constant in eV/Hz (eV Hz^-1)
   real(wp), parameter :: Planck_constant_in_eV_Hz = 4.135667696e-15_wp
   !> Planck length (m)
   real(wp), parameter :: Planck_length = 1.616255e-35_wp
   !> Planck mass (kg)
   real(wp), parameter :: Planck_mass = 2.176434e-8_wp
   !> Planck mass energy equivalent in GeV (GeV)
   real(wp), parameter :: Planck_mass_energy_equivalent_in_GeV = 1.220890e19_wp
   !> Planck temperature (K)
   real(wp), parameter :: Planck_temperature = 1.416784e32_wp
   !> Planck time (s)
   real(wp), parameter :: Planck_time = 5.391247e-44_wp
   !> proton charge to mass quotient (C kg^-1)
   real(wp), parameter :: proton_charge_to_mass_quotient = 9.5788331560e7_wp
   !> proton Compton wavelength (m)
   real(wp), parameter :: proton_Compton_wavelength = 1.32140985539e-15_wp
   !> proton-electron mass ratio (dimensionless)
   real(wp), parameter :: proton_electron_mass_ratio = 1836.15267343_wp
   !> proton g factor (dimensionless)
   real(wp), parameter :: proton_g_factor = 5.5856946893_wp
   !> proton gyromag. ratio (s^-1 T^-1)
   real(wp), parameter :: proton_gyromag__ratio = 2.6752218744e8_wp
   !> proton gyromag. ratio in MHz/T (MHz T^-1)
   real(wp), parameter :: proton_gyromag__ratio_in_MHz_T = 42.577478518_wp
   !> proton mag. mom. (J T^-1)
   real(wp), parameter :: proton_mag__mom_ = 1.41060679736e-26_wp
   !> proton mag. mom. to Bohr magneton ratio (dimensionless)
   real(wp), parameter :: proton_mag__mom__to_Bohr_magneton_ratio = 1.52103220230e-3_wp
   !> proton mag. mom. to nuclear magneton ratio (dimensionless)
   real(wp), parameter :: proton_mag__mom__to_nuclear_magneton_ratio = 2.79284734463_wp
   !> proton mag. shielding correction (dimensionless)
   real(wp), parameter :: proton_mag__shielding_correction = 2.5689e-5_wp
   !> proton mass (kg)
   real(wp), parameter :: proton_mass = 1.67262192369e-27_wp
   !> proton mass energy equivalent (J)
   real(wp), parameter :: proton_mass_energy_equivalent = 1.50327761598e-10_wp
   !> proton mass energy equivalent in MeV (MeV)
   real(wp), parameter :: proton_mass_energy_equivalent_in_MeV = 938.27208816_wp
   !> proton mass in u (u)
   real(wp), parameter :: proton_mass_in_u = 1.007276466621_wp
   !> proton molar mass (kg mol^-1)
   real(wp), parameter :: proton_molar_mass = 1.00727646627e-3_wp
   !> proton-muon mass ratio (dimensionless)
   real(wp), parameter :: proton_muon_mass_ratio = 8.88024337_wp
   !> proton-neutron mag. mom. ratio (dimensionless)
   real(wp), parameter :: proton_neutron_mag__mom__ratio = -1.45989805_wp
   !> proton-neutron mass ratio (dimensionless)
   real(wp), parameter :: proton_neutron_mass_ratio = 0.99862347812_wp
   !> proton relative atomic mass (dimensionless)
   real(wp), parameter :: proton_relative_atomic_mass = 1.007276466621_wp
   !> proton rms charge radius (m)
   real(wp), parameter :: proton_rms_charge_radius = 8.414e-16_wp
   !> proton-tau mass ratio (dimensionless)
   real(wp), parameter :: proton_tau_mass_ratio = 0.528051_wp
   !> quantum of circulation (m^2 s^-1)
   real(wp), parameter :: quantum_of_circulation = 3.6369475516e-4_wp
   !> quantum of circulation times 2 (m^2 s^-1)
   real(wp), parameter :: quantum_of_circulation_times_2 = 7.2738951032e-4_wp
   !> reduced Compton wavelength (m)
   real(wp), parameter :: reduced_Compton_wavelength = 3.8615926796e-13_wp
   !> reduced muon Compton wavelength (m)
   real(wp), parameter :: reduced_muon_Compton_wavelength = 1.867594306e-15_wp
   !> reduced neutron Compton wavelength (m)
   real(wp), parameter :: reduced_neutron_Compton_wavelength = 2.1001941552e-16_wp
   !> reduced Planck constant (J s)
   real(wp), parameter :: reduced_Planck_constant = 1.054571817e-34_wp
   !> reduced Planck constant in eV s (eV s)
   real(wp), parameter :: reduced_Planck_constant_in_eV_s = 6.582119569e-16_wp
   !> reduced Planck constant times c in MeV fm (MeV fm)
   real(wp), parameter :: reduced_Planck_constant_times_c_in_MeV_fm = 197.3269804_wp
   !> reduced proton Compton wavelength (m)
   real(wp), parameter :: reduced_proton_Compton_wavelength = 2.10308910336e-16_wp
   !> reduced tau Compton wavelength (m)
   real(wp), parameter :: reduced_tau_Compton_wavelength = 1.110538e-16_wp
   !> Rydberg constant (m^-1)
   real(wp), parameter :: Rydberg_constant = 10973731.568160_wp
   !> Rydberg constant times c in Hz (Hz)
   real(wp), parameter :: Rydberg_constant_times_c_in_Hz = 3.2898419602508e15_wp
   !> Rydberg constant times hc in eV (eV)
   real(wp), parameter :: Rydberg_constant_times_hc_in_eV = 13.605693122994_wp
   !> Rydberg constant times hc in J (J)
   real(wp), parameter :: Rydberg_constant_times_hc_in_J = 2.1798723611035e-18_wp
   !> Sackur-Tetrode constant (1 K, 100 kPa) (dimensionless)
   real(wp), parameter :: Sackur_Tetrode_constant_1_K__100_kPa = -1.15170753706_wp
   !> Sackur-Tetrode constant (1 K, 101.325 kPa) (dimensionless)
   real(wp), parameter :: Sackur_Tetrode_constant_1_K__101_325_kPa = -1.16487052358_wp
   !> second radiation constant (m K)
   real(wp), parameter :: second_radiation_constant = 1.438776877e-2_wp
   !> shielded helion gyromag. ratio (s^-1 T^-1)
   real(wp), parameter :: shielded_helion_gyromag__ratio = 2.037894569e8_wp
   !> shielded helion gyromag. ratio in MHz/T (MHz T^-1)
   real(wp), parameter :: shielded_helion_gyromag__ratio_in_MHz_T = 32.43409942_wp
   !> shielded helion mag. mom. (J T^-1)
   real(wp), parameter :: shielded_helion_mag__mom_ = -1.074553090e-26_wp
   !> shielded helion mag. mom. to Bohr magneton ratio (dimensionless)
   real(wp), parameter :: shielded_helion_mag__mom__to_Bohr_magneton_ratio = -1.158671471e-3_wp
   !> shielded helion mag. mom. to nuclear magneton ratio (dimensionless)
   real(wp), parameter :: shielded_helion_mag__mom__to_nuclear_magneton_ratio = -2.127497719_wp
   !> shielded helion to proton mag. mom. ratio (dimensionless)
   real(wp), parameter :: shielded_helion_to_proton_mag__mom__ratio = -0.7617665618_wp
   !> shielded helion to shielded proton mag. mom. ratio (dimensionless)
   real(wp), parameter :: shielded_helion_to_shielded_proton_mag__mom__ratio = -0.7617861313_wp
   !> shielded proton gyromag. ratio (s^-1 T^-1)
   real(wp), parameter :: shielded_proton_gyromag__ratio = 2.675153151e8_wp
   !> shielded proton gyromag. ratio in MHz/T (MHz T^-1)
   real(wp), parameter :: shielded_proton_gyromag__ratio_in_MHz_T = 42.57638474_wp
   !> shielded proton mag. mom. (J T^-1)
   real(wp), parameter :: shielded_proton_mag__mom_ = 1.410570560e-26_wp
   !> shielded proton mag. mom. to Bohr magneton ratio (dimensionless)
   real(wp), parameter :: shielded_proton_mag__mom__to_Bohr_magneton_ratio = 1.520993128e-3_wp
   !> shielded proton mag. mom. to nuclear magneton ratio (dimensionless)
   real(wp), parameter :: shielded_proton_mag__mom__to_nuclear_magneton_ratio = 2.792775599_wp
   !> shielding difference of d and p in HD (dimensionless)
   real(wp), parameter :: shielding_difference_of_d_and_p_in_HD = 2.0200e-8_wp
   !> shielding difference of t and p in HT (dimensionless)
   real(wp), parameter :: shielding_difference_of_t_and_p_in_HT = 2.4140e-8_wp
   !> speed of light in vacuum (m s^-1)
   real(wp), parameter :: speed_of_light_in_vacuum = 299792458e0_wp
   !> standard acceleration of gravity (m s^-2)
   real(wp), parameter :: standard_acceleration_of_gravity = 9.80665_wp
   !> standard atmosphere (Pa)
   real(wp), parameter :: standard_atmosphere = 101325e0_wp
   !> standard-state pressure (Pa)
   real(wp), parameter :: standard_state_pressure = 100000e0_wp
   !> Stefan-Boltzmann constant (W m^-2 K^-4)
   real(wp), parameter :: Stefan_Boltzmann_constant = 5.670374419e-8_wp
   !> tau Compton wavelength (m)
   real(wp), parameter :: tau_Compton_wavelength = 6.97771e-16_wp
   !> tau-electron mass ratio (dimensionless)
   real(wp), parameter :: tau_electron_mass_ratio = 3477.23_wp
   !> tau energy equivalent (MeV)
   real(wp), parameter :: tau_energy_equivalent = 1776.86_wp
   !> tau mass (kg)
   real(wp), parameter :: tau_mass = 3.16754e-27_wp
   !> tau mass energy equivalent (J)
   real(wp), parameter :: tau_mass_energy_equivalent = 2.84684e-10_wp
   !> tau mass in u (u)
   real(wp), parameter :: tau_mass_in_u = 1.90754_wp
   !> tau molar mass (kg mol^-1)
   real(wp), parameter :: tau_molar_mass = 1.90754e-3_wp
   !> tau-muon mass ratio (dimensionless)
   real(wp), parameter :: tau_muon_mass_ratio = 16.8170_wp
   !> tau-neutron mass ratio (dimensionless)
   real(wp), parameter :: tau_neutron_mass_ratio = 1.89115_wp
   !> tau-proton mass ratio (dimensionless)
   real(wp), parameter :: tau_proton_mass_ratio = 1.89376_wp
   !> Thomson cross section (m^2)
   real(wp), parameter :: Thomson_cross_section = 6.6524587321e-29_wp
   !> triton-electron mass ratio (dimensionless)
   real(wp), parameter :: triton_electron_mass_ratio = 5496.92153573_wp
   !> triton g factor (dimensionless)
   real(wp), parameter :: triton_g_factor = 5.957924931_wp
   !> triton mag. mom. (J T^-1)
   real(wp), parameter :: triton_mag__mom_ = 1.5046095202e-26_wp
   !> triton mag. mom. to Bohr magneton ratio (dimensionless)
   real(wp), parameter :: triton_mag__mom__to_Bohr_magneton_ratio = 1.6223936651e-3_wp
   !> triton mag. mom. to nuclear magneton ratio (dimensionless)
   real(wp), parameter :: triton_mag__mom__to_nuclear_magneton_ratio = 2.9789624656_wp
   !> triton mass (kg)
   real(wp), parameter :: triton_mass = 5.0073567446e-27_wp
   !> triton mass energy equivalent (J)
   real(wp), parameter :: triton_mass_energy_equivalent = 4.5003878060e-10_wp
   !> triton mass energy equivalent in MeV (MeV)
   real(wp), parameter :: triton_mass_energy_equivalent_in_MeV = 2808.92113298_wp
   !> triton mass in u (u)
   real(wp), parameter :: triton_mass_in_u = 3.01550071621_wp
   !> triton molar mass (kg mol^-1)
   real(wp), parameter :: triton_molar_mass = 3.01550071517e-3_wp
   !> triton-proton mass ratio (dimensionless)
   real(wp), parameter :: triton_proton_mass_ratio = 2.99371703414_wp
   !> triton relative atomic mass (dimensionless)
   real(wp), parameter :: triton_relative_atomic_mass = 3.01550071621_wp
   !> triton to proton mag. mom. ratio (dimensionless)
   real(wp), parameter :: triton_to_proton_mag__mom__ratio = 1.0666399191_wp
   !> unified atomic mass unit (kg)
   real(wp), parameter :: unified_atomic_mass_unit = 1.66053906660e-27_wp
   !> vacuum electric permittivity (F m^-1)
   real(wp), parameter :: vacuum_electric_permittivity = 8.8541878128e-12_wp
   !> vacuum mag. permeability (N A^-2)
   real(wp), parameter :: vacuum_mag__permeability = 1.25663706212e-6_wp
   !> von Klitzing constant (ohm)
   real(wp), parameter :: von_Klitzing_constant = 25812.80745_wp
   !> weak mixing angle (dimensionless)
   real(wp), parameter :: weak_mixing_angle = 0.22290_wp
   !> Wien frequency displacement law constant (Hz K^-1)
   real(wp), parameter :: Wien_frequency_displacement_law_constant = 5.878925757e10_wp
   !> Wien wavelength displacement law constant (m K)
   real(wp), parameter :: Wien_wavelength_displacement_law_constant = 2.897771955e-3_wp
   !> W to Z mass ratio (dimensionless)
   real(wp), parameter :: W_to_Z_mass_ratio = 0.88153_wp

end module mctc_io_codata2018

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of restart data cache
module tblite_container_cache
   implicit none
   private

   public :: container_cache, resize

   !> Restart data for an interaction container
   type :: container_cache
      !> Label identifying this contribution
      character(len=:), allocatable :: label
      !> Actual restart data
      class(*), allocatable :: raw
   end type container_cache


   !> Reallocate list of containers
   interface resize
      module procedure :: resize_cache
   end interface


contains


!> Reallocate list of containers
pure subroutine resize_cache(list, n)
   !> Instance of the array to be resized
   type(container_cache), allocatable, intent(inout) :: list(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(container_cache), allocatable :: tmp(:)
   integer, parameter :: initial_size = 20
   integer :: this_size, new_size, item

   if (allocated(list)) then
      this_size = size(list, 1)
      call move_alloc(list, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(list(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(list, 1))
      do item = 1, this_size
         call move_alloc(tmp(item)%raw, list(item)%raw)
         call move_alloc(tmp(item)%label, list(item)%label)
      end do
      deallocate(tmp)
   end if

end subroutine resize_cache


end module tblite_container_cache

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/api/double_dictionary
!> Contains API access to a double dictionary instance i.e. to retrieve teh post processing dict.

!> @file tblite/api/double_dictionery.f90
!> Implements API calls to double dictionary.
module tblite_api_double_dictionary
   use mctc_env, only : wp, error_type, fatal_error
   use iso_c_binding
   use tblite_double_dictionary
   use tblite_api_version, only : namespace
   use tblite_api_utils, only : f_c_character, c_f_character
   use tblite_api_error, only : vp_error
   implicit none
   private

   public :: vp_double_dictionary
   public :: get_array_entry_index_api, get_n_entries_dict_api, get_label_entry_index_api, &
      & get_array_size_index_api, get_array_entry_label_api, get_array_size_label_api

   type :: vp_double_dictionary
      type(double_dictionary_type) :: ptr
   end type

   logical, parameter :: debug = .false.
contains

function get_n_entries_dict_api(verror, vdict) result(n) &
      & bind(C, name = namespace//"get_n_entries_dict")
   type(vp_double_dictionary), pointer :: dict
   type(c_ptr), value :: vdict
   type(c_ptr), value :: verror 
   type(vp_error), pointer :: error
   integer(kind=c_int) :: n
   logical :: ok
   if (debug) print '("[Info]", 1x, a)', "get n_entries form dict"
   n = 0
   call check_dict(verror, vdict, error, dict, ok)
   if (.not.(ok)) return
   n = dict%ptr%get_n_entries()
end function

subroutine check_dict(verror, vdict, error, dict, ok)
   type(vp_double_dictionary), pointer :: dict
   type(c_ptr), value :: vdict
   type(c_ptr), value :: verror 
   type(vp_error), pointer :: error
   logical :: ok
   ok = .false.

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vdict)) then
      call fatal_error(error%ptr, "Dictionary is missing.")
      return
   end if
   call c_f_pointer(vdict, dict)
   ok = .true.
end subroutine

subroutine get_array_size_label_api(verror, vdict, label, dim1, dim2, dim3) &
   & bind(C, name = namespace//"get_array_size_label")

   type(vp_double_dictionary), pointer :: dict
   type(c_ptr), value :: vdict
   type(c_ptr), value :: verror 
   type(vp_error), pointer :: error
   character(kind=c_char), intent(in) :: label(*)
   character(len=:), allocatable :: f_char
   integer(kind=c_int), intent(out) :: dim1, dim2, dim3
   logical :: ok
   real(kind=wp), allocatable :: array1(:), array2(:, :), array3(:, :, :)
   integer :: index
   
   if (debug) print '("[Info]", 1x, a)', "get array size by label"

   dim1 = 0
   dim2 = 0
   dim3 = 0

   call check_dict(verror, vdict, error, dict, ok)
   if (.not.(ok)) return
   call c_f_character(label, f_char)
   index = dict%ptr%get_index(f_char)
   if (index == 0) then 
      call fatal_error(error%ptr, "Label is not a key in the dictionary.")
      return
   end if

   call dict%ptr%get_entry(f_char, array1)
   if (allocated(array1)) then
      dim1 = size(array1, dim=1)
      return
   end if

   call dict%ptr%get_entry(f_char, array2)
   if (allocated(array2)) then
      dim1 = size(array2, dim=1)
      dim2 = size(array2, dim=2)
      return
   end if

   call dict%ptr%get_entry(f_char, array3)
   if (allocated(array3)) then
      dim1 = size(array3, dim=1)
      dim2 = size(array3, dim=2)
      dim3 = size(array3, dim=3)
      return
   end if

end subroutine

subroutine get_array_entry_label_api(verror, vdict, label, array_out) &
   & bind(C, name = namespace//"get_array_entry_label")
type(vp_double_dictionary), pointer :: dict
type(c_ptr), value :: vdict
type(c_ptr), value :: verror 
type(vp_error), pointer :: error
character(kind=c_char), intent(in) :: label(*)
character(len=:), allocatable :: f_char
real(c_double), intent(out) :: array_out(*)
real(kind=wp), allocatable :: array1(:), array2(:, :), array3(:, :, :)
integer :: index

logical :: ok
if (debug) print '("[Info]", 1x, a)', "get array values by label"

call check_dict(verror, vdict, error, dict, ok)
if (.not.(ok)) return

call c_f_character(label, f_char)
index = dict%ptr%get_index(f_char)
if (index == 0) then 
   call fatal_error(error%ptr, "Label is not a key in the dictionary.")
   return
end if

call dict%ptr%get_entry(index, array1)
if (allocated(array1)) then
   array_out(:size(array1)) = &
      & reshape(array1, [size(array1)])
   return
end if

call dict%ptr%get_entry(index, array2)
if (allocated(array2)) then
   array_out(:size(array2)) = &
      & reshape(array2, [size(array2)])
   return
end if

call dict%ptr%get_entry(index, array3)
if (allocated(array3)) then
   array_out(:size(array3)) = &
      & reshape(array3, [size(array3)])
   return
end if

end subroutine

subroutine get_array_size_index_api(verror, vdict, index, dim1, dim2, dim3) &
      & bind(C, name = namespace//"get_array_size_index")
   type(vp_double_dictionary), pointer :: dict
   type(c_ptr), value :: vdict
   type(c_ptr), value :: verror 
   type(vp_error), pointer :: error
   integer(kind=c_int), intent(in) :: index
   integer(kind=c_int), intent(out) :: dim1, dim2, dim3
   logical :: ok
   real(kind=wp), allocatable :: array1(:), array2(:, :), array3(:, :, :)
   if (debug) print '("[Info]", 1x, a)', "get array size by index"
   dim1 = 0
   dim2 = 0
   dim3 = 0

   call check_dict(verror, vdict, error, dict, ok)
   if (.not.(ok)) return


   call dict%ptr%get_entry(index, array1)
   if (allocated(array1)) then
      dim1 = size(array1, dim=1)
      return
   end if

   call dict%ptr%get_entry(index, array2)
   if (allocated(array2)) then
      dim1 = size(array2, dim=1)
      dim2 = size(array2, dim=2)
      return
   end if

   call dict%ptr%get_entry(index, array3)
   if (allocated(array3)) then
      dim1 = size(array3, dim=1)
      dim2 = size(array3, dim=2)
      dim3 = size(array3, dim=3)
      return
   end if

   call fatal_error(error%ptr, "Index is not a key in the dictionary.")
   return

end subroutine

subroutine get_array_entry_index_api(verror, vdict, index, array_out) &
      & bind(C, name = namespace//"get_array_entry_index")
   type(vp_double_dictionary), pointer :: dict
   type(c_ptr), value :: vdict
   type(c_ptr), value :: verror 
   type(vp_error), pointer :: error
   integer(kind=c_int), intent(in) :: index
   real(c_double), intent(out) :: array_out(*)
   real(kind=wp), allocatable :: array1(:), array2(:, :), array3(:, :, :)
   logical :: ok
   if (debug) print '("[Info]", 1x, a)', "get array value by index"
   call check_dict(verror, vdict, error, dict, ok)
   if (.not.(ok)) return

   call dict%ptr%get_entry(index, array1)
   if (allocated(array1)) then
      array_out(:size(array1)) = &
         & reshape(array1, [size(array1)])
      return
   end if

   call dict%ptr%get_entry(index, array2)
   if (allocated(array2)) then
      array_out(:size(array2)) = &
         & reshape(array2, [size(array2)])
      return
   end if

   call dict%ptr%get_entry(index, array3)
   if (allocated(array3)) then
      array_out(:size(array3)) = &
         & reshape(array3, [size(array3)])
      return
   end if

   call fatal_error(error%ptr, "Index is not a key in the dictionary.")
   return

end subroutine

subroutine get_label_entry_index_api(verror, vdict, index, charptr, buffersize) &
      & bind(C, name= namespace//"get_label_entry_index")
   type(vp_double_dictionary), pointer :: dict
   type(c_ptr), value :: vdict
   type(c_ptr), value :: verror 
   type(vp_error), pointer :: error
   integer(kind=c_int), intent(in) :: index
   character(kind=c_char), intent(out) :: charptr(*)
   integer(c_int), intent(in), optional :: buffersize
   character(len=:), allocatable :: fchar
   integer :: max_length
   logical :: ok
   if (debug) print '("[Info]", 1x, a)', "get dict label from index"
   call check_dict(verror, vdict, error, dict, ok)
   if (.not.(ok)) return

   associate(dict => dict%ptr)
      call dict%get_label(index, fchar)
   end associate
   
   if (present(buffersize)) then
      max_length = buffersize
   else
      max_length = huge(max_length) - 2
   end if

   call f_c_character(fchar, charptr, max_length)

end subroutine

subroutine delete_post_processing_api(vdict) &
      & bind(C, name=namespace//"delete_double_dictionary")
   type(c_ptr), intent(inout) :: vdict
   type(vp_double_dictionary), pointer :: dict
if (debug) print '("[Info]", 1x, a)', "get n_entries form dict"
   if (debug) print '("[Info]", 1x, a)', "delete_double_dictionary"

   if (c_associated(vdict)) then
      call c_f_pointer(vdict, dict)

      deallocate(dict)
      vdict = c_null_ptr
   end if
end subroutine delete_post_processing_api

end module

! This file is part of jonquil.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module jonquil_lexer
   use tomlf_constants, only : tfc, tfi, tfr, toml_escape
   use tomlf_datetime, only : toml_datetime
   use tomlf_de_abc, only : abstract_lexer
   use tomlf_de_token, only : toml_token, token_kind
   use tomlf_error, only : toml_error, make_error
   use tomlf_utils, only : read_whole_file, read_whole_line
   implicit none
   private

   public :: json_lexer
   public :: new_lexer_from_file, new_lexer_from_unit, new_lexer_from_string
   public :: toml_token, token_kind

   !> Tokenizer for JSON documents
   type, extends(abstract_lexer) :: json_lexer
      !> Name of the source file, used for error reporting
      character(len=:), allocatable :: filename
      !> Current internal position in the source chunk
      integer :: pos = 0
      !> Current source chunk
      character(:, tfc), allocatable :: chunk
      !> Additional tokens to insert before the actual token stream
      integer :: prelude = 2
   contains
      !> Obtain the next token
      procedure :: next
      !> Extract a string from a token
      procedure :: extract_string
      !> Extract an integer from a token
      procedure :: extract_integer
      !> Extract a float from a token
      procedure :: extract_float
      !> Extract a boolean from a token
      procedure :: extract_bool
      !> Extract a timestamp from a token
      procedure :: extract_datetime
      !> Get information about source
      procedure :: get_info
   end type json_lexer

   character(*, tfc), parameter :: terminated = " {}[],:"//&
      & toml_escape%tabulator//toml_escape%newline//toml_escape%carriage_return

contains

!> Create a new instance of a lexer by reading from a file
subroutine new_lexer_from_file(lexer, filename, error)
   !> Instance of the lexer
   type(json_lexer), intent(out) :: lexer
   !> Name of the file to read from
   character(len=*), intent(in) :: filename
   !> Error code
   type(toml_error), allocatable, intent(out) :: error

   integer :: stat

   lexer%filename = filename
   call read_whole_file(filename, lexer%chunk, stat)

   if (stat /= 0) call make_error(error, "Could not open file '"//filename//"'")
end subroutine new_lexer_from_file

!> Create a new instance of a lexer by reading from a unit.
!>
!> Currently, only sequential access units can be processed by this constructor.
subroutine new_lexer_from_unit(lexer, io, error)
   !> Instance of the lexer
   type(json_lexer), intent(out) :: lexer
   !> Unit to read from
   integer, intent(in) :: io
   !> Error code
   type(toml_error), allocatable, intent(out) :: error

   character(:, tfc), allocatable :: source, line
   integer, parameter :: bufsize = 512
   character(bufsize, tfc) :: filename, mode
   integer :: stat

   inquire(unit=io, access=mode, name=filename)
   select case(trim(mode))
   case default
      stat = 1

   case("sequential", "SEQUENTIAL")
      allocate(character(0) :: source)
      do 
         call read_whole_line(io, line, stat)
         if (stat > 0) exit
         source = source // line // toml_escape%newline
         if (stat < 0) then
            if (is_iostat_end(stat)) stat = 0
            exit
         end if
      end do
      call new_lexer_from_string(lexer, source)
   end select
   if (len_trim(filename) > 0) lexer%filename = trim(filename)

   if (stat /= 0) call make_error(error, "Failed to read from unit")
end subroutine new_lexer_from_unit

!> Create a new instance of a lexer by reading from a string.
subroutine new_lexer_from_string(lexer, string)
   !> Instance of the lexer
   type(json_lexer), intent(out) :: lexer
   !> String to read from
   character(len=*), intent(in) :: string

   lexer%chunk = string
end subroutine new_lexer_from_string

!> Extract information about the source
subroutine get_info(lexer, meta, output)
   !> Instance of the lexer
   class(json_lexer), intent(in) :: lexer
   !> Query about the source
   character(*, tfc), intent(in) :: meta
   !> Metadata about the source
   character(:, tfc), allocatable, intent(out) :: output

   select case(meta)
   case("source")
      output = lexer%chunk // toml_escape%newline
   case("filename")
      if (allocated(lexer%filename)) output = lexer%filename
   end select
end subroutine get_info

!> Advance to the next token in the lexer
subroutine next(lexer, token)
   !> Instance of the lexer
   class(json_lexer), intent(inout) :: lexer
   !> Current token
   type(toml_token), intent(inout) :: token

   type(toml_token), parameter :: prelude(2) = &
      [toml_token(token_kind%equal, 0, 0), toml_token(token_kind%keypath, 1, 0)]

   if (lexer%prelude > 0) then
      token = prelude(lexer%prelude)
      lexer%prelude = lexer%prelude - 1
      return
   end if

   call next_token(lexer, token)
end subroutine next

!> Actually generate the next token, unbuffered version
subroutine next_token(lexer, token)
   !> Instance of the lexer
   class(json_lexer), intent(inout) :: lexer
   !> Current token
   type(toml_token), intent(inout) :: token

   integer :: prev, pos

   ! Consume current token
   lexer%pos = lexer%pos + token%last - token%first + 1
   prev = lexer%pos
   pos = lexer%pos

   ! If lexer is exhausted, return EOF as early as possible
   if (pos > len(lexer%chunk)) then
      token = toml_token(token_kind%eof, prev, pos)
      return
   end if

   select case(lexer%chunk(pos:pos))
   case(" ", toml_escape%tabulator, toml_escape%newline, toml_escape%carriage_return)
      do pos = pos, len(lexer%chunk) - 1
         if (all(lexer%chunk(pos+1:pos+1) /= [" ", toml_escape%tabulator,&
            & toml_escape%newline, toml_escape%carriage_return])) &
            & exit
      end do

      token = toml_token(token_kind%whitespace, prev, pos)
      return
   case(":")
      token = toml_token(token_kind%equal, prev, pos)
      return
   case("{")
      token = toml_token(token_kind%lbrace, prev, pos)
      return
   case("}")
      token = toml_token(token_kind%rbrace, prev, pos)
      return
   case("[")
      token = toml_token(token_kind%lbracket, prev, pos)
      return
   case("]")
      token = toml_token(token_kind%rbracket, prev, pos)
      return
   case('"')
      call next_string(lexer, token)
      return
   case("-", "0":"9")
      call next_number(lexer, token)
      if (token%kind /= token_kind%invalid) return
   case("t", "f")
      call next_boolean(lexer, token)
      return
   case("n")
      call next_nil(lexer, token)
      return
   case(",")
      token = toml_token(token_kind%comma, prev, pos)
      return
   end select

   do pos=pos,len(lexer%chunk)-1
      if (verify(lexer%chunk(pos+1:pos+1), terminated) <= 0) exit
   end do

   token = toml_token(token_kind%invalid, prev, pos)
end subroutine next_token

!> Process next string token
subroutine next_string(lexer, token)
   !> Instance of the lexer
   type(json_lexer), intent(inout) :: lexer
   !> Current token
   type(toml_token), intent(inout) :: token

   character(1, tfc) :: ch
   character(*, tfc), parameter :: valid_escape = 'btnfr\"'
   integer :: prev, pos, it
   logical :: escape, valid, space

   prev = lexer%pos
   pos = lexer%pos

   valid = .true.
   escape = .false.

   do while(pos < len(lexer%chunk))
      pos = pos + 1
      ch = lexer%chunk(pos:pos)
      valid = valid .and. valid_string(ch)
      if (escape) then
         escape = .false.
         valid = valid .and. verify(ch, valid_escape) == 0
         cycle
      end if
      escape = ch == toml_escape%backslash
      if (ch == '"') exit
      if (ch == toml_escape%newline) then
         pos = pos - 1
         valid = .false.
         exit
      end if
   end do

   valid = valid .and. lexer%chunk(pos:pos) == '"' .and. pos /= prev
   token = toml_token(merge(token_kind%string, token_kind%invalid, valid), prev, pos)
end subroutine next_string

!> Process next number token, can produce either integer or floats
subroutine next_number(lexer, token)
   !> Instance of the lexer
   type(json_lexer), intent(inout) :: lexer
   !> Current token
   type(toml_token), intent(inout) :: token

   integer :: prev, pos, point, expo
   logical :: minus, okay, zero, first
   character(1, tfc) :: ch
   integer, parameter :: offset(*) = [0, 1, 2]

   prev = lexer%pos
   pos = lexer%pos
   token = toml_token(token_kind%invalid, prev, pos)

   point = 0
   expo = 0
   zero = .false.
   first = .true.
   minus = lexer%chunk(pos:pos) == "-"
   if (minus) pos = pos + 1

   do while(pos <= len(lexer%chunk))
      ch = lexer%chunk(pos:pos)
      if (ch == ".") then
         if (point > 0 .or. expo > 0) return
         zero = .false.
         point = pos
         pos = pos + 1
         cycle
      end if

      if (ch == "e" .or. ch == "E") then
         if (expo > 0) return
         zero = .false.
         expo = pos
         pos = pos + 1
         cycle
      end if

      if (ch == "+" .or. ch == "-") then
         if (.not.any(lexer%chunk(pos-1:pos-1) == ["e", "E"])) return
         pos = pos + 1
         cycle
      end if

      if (verify(ch, "0123456789") == 0) then
         if (zero) return
         zero = first .and. ch == "0"
         first = .false.
         pos = pos + 1
         cycle
      end if

      exit
   end do

   if (any([expo, point] == pos-1)) return
   token = toml_token(merge(token_kind%float, token_kind%int, any([expo, point] > 0)), &
      & prev, pos-1)
end subroutine next_number

!> Process next boolean token
subroutine next_boolean(lexer, token)
   !> Instance of the lexer
   type(json_lexer), intent(inout) :: lexer
   !> Current token
   type(toml_token), intent(inout) :: token

   integer :: pos, prev

   prev = lexer%pos
   pos = lexer%pos

   do pos=lexer%pos,len(lexer%chunk)-1
      if (verify(lexer%chunk(pos+1:pos+1), terminated) <= 0) exit
   end do

   select case(lexer%chunk(prev:pos))
   case default
      token = toml_token(token_kind%invalid, prev, pos)
   case("true", "false")
      token = toml_token(token_kind%bool, prev, pos)
   end select
end subroutine next_boolean

!> Process next nil token
subroutine next_nil(lexer, token)
   !> Instance of the lexer
   type(json_lexer), intent(inout) :: lexer
   !> Current token
   type(toml_token), intent(inout) :: token

   integer :: pos, prev

   prev = lexer%pos
   pos = lexer%pos

   do pos=lexer%pos,len(lexer%chunk)-1
      if (verify(lexer%chunk(pos+1:pos+1), terminated) <= 0) exit
   end do

   select case(lexer%chunk(prev:pos))
   case default
      token = toml_token(token_kind%invalid, prev, pos)
   case("null")
      token = toml_token(token_kind%nil, prev, pos)
   end select
end subroutine next_nil

!> Validate characters in string, non-printable characters are invalid in this context
pure function valid_string(ch) result(valid)
   character(1, tfc), intent(in) :: ch
   logical :: valid

   character(1, tfc), parameter :: x00 = achar(int(z"00")), x08 = achar(int(z"08")), &
      & x0b = achar(int(z"0b")), x1f = achar(int(z"1f")), x7f = achar(int(z"7f"))

   valid = &
      & .not.(x00 <= ch .and. ch <= x08) .and. &
      & .not.(x0b <= ch .and. ch <= x1f) .and. &
      & ch /= x7f
end function valid_string

!> Extract string value of token
subroutine extract_string(lexer, token, string)
   !> Instance of the lexer
   class(json_lexer), intent(in) :: lexer
   !> Token to extract string value from
   type(toml_token), intent(in) :: token
   !> String value of token
   character(len=:), allocatable, intent(out) :: string

   integer :: it, length
   logical :: escape
   character(1, tfc) :: ch

   length = token%last - token%first + 1

   select case(token%kind)
   case(token_kind%keypath)  ! dummy token inserted by lexer prelude
      string = "_"
   case(token_kind%string)
      string = ""
      escape = .false.
      do it = token%first + 1, token%last - 1
         ch = lexer%chunk(it:it)
         if (escape) then
            escape = .false.
            select case(ch)
            case(toml_escape%dquote, toml_escape%backslash); string = string // ch
            case("b"); string = string // toml_escape%bspace
            case("t"); string = string // toml_escape%tabulator
            case("n"); string = string // toml_escape%newline
            case("r"); string = string // toml_escape%carriage_return
            case("f"); string = string // toml_escape%formfeed
            end select
            cycle
         end if
         escape = ch == toml_escape%backslash
         if (.not.escape) string = string // ch
      end do
   end select
end subroutine extract_string

!> Extract integer value of token
subroutine extract_integer(lexer, token, val)
   !> Instance of the lexer
   class(json_lexer), intent(in) :: lexer
   !> Token to extract integer value from
   type(toml_token), intent(in) :: token
   !> Integer value of token
   integer(tfi), intent(out) :: val

   integer :: first, it, tmp
   character(1, tfc) :: ch
   character(*, tfc), parameter :: num = "0123456789"

   if (token%kind /= token_kind%int) return

   val = 0
   first = token%first

   if (lexer%chunk(first:first) == "-") first = first + 1
   if (lexer%chunk(first:first) == "0") return

   do it = first, token%last
      ch = lexer%chunk(it:it)
      tmp = scan(num, ch) - 1
      if (tmp < 0) cycle
      val = val * 10 - tmp
   end do

   if (lexer%chunk(token%first:token%first) /= "-") val = -val
end subroutine extract_integer

!> Extract floating point value of token
subroutine extract_float(lexer, token, val)
   use, intrinsic :: ieee_arithmetic, only : ieee_value, &
      & ieee_positive_inf, ieee_negative_inf, ieee_quiet_nan
   !> Instance of the lexer
   class(json_lexer), intent(in) :: lexer
   !> Token to extract floating point value from
   type(toml_token), intent(in) :: token
   !> Floating point value of token
   real(tfr), intent(out) :: val

   integer :: stat

   if (token%kind /= token_kind%float) return

   read(lexer%chunk(token%first:token%last), *, iostat=stat) val
end subroutine extract_float

!> Extract boolean value of token
subroutine extract_bool(lexer, token, val)
   !> Instance of the lexer
   class(json_lexer), intent(in) :: lexer
   !> Token to extract boolean value from
   type(toml_token), intent(in) :: token
   !> Boolean value of token
   logical, intent(out) :: val

   if (token%kind /= token_kind%bool) return

   val = lexer%chunk(token%first:token%last) == "true"
end subroutine extract_bool

!> Extract datetime value of token
subroutine extract_datetime(lexer, token, val)
   !> Instance of the lexer
   class(json_lexer), intent(in) :: lexer
   !> Token to extract datetime value from
   type(toml_token), intent(in) :: token
   !> Datetime value of token
   type(toml_datetime), intent(out) :: val
end subroutine extract_datetime

end module jonquil_lexer

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/solvation/input.f90
!> Provides a collection of all input configurations

!> Collection of the configuration types for all available implicit solvation models
module tblite_solvation_input
   use tblite_solvation_alpb, only : alpb_input
   use tblite_solvation_ddx, only : ddx_input
   use tblite_solvation_cds,  only : cds_input
   use tblite_solvation_shift,  only : shift_input
   implicit none
   private


   !> Collection of possible solvation models
   type, public :: solvation_input
      !> Input for ddX solvation model
      type(ddx_input), allocatable :: ddx
      !> Input for ALPB solvation model
      type(alpb_input), allocatable :: alpb
      !> Input for CDS model 
      type(cds_input), allocatable :: cds
      !> Input for solvation shift 
      type(shift_input), allocatable :: shift
   end type solvation_input

end module tblite_solvation_input

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Handle conversion between element symbols and atomic numbers
module mctc_io_symbols
   use mctc_io_resize, only : resize
   implicit none
   private

   public :: symbol_length
   public :: symbol_to_number, number_to_symbol, number_to_lcsymbol
   public :: to_number, to_symbol, to_lcsymbol
   public :: get_identity, collect_identical


   !> Get chemical identity
   interface get_identity
      module procedure :: get_identity_number
      module procedure :: get_identity_symbol
   end interface get_identity


   !> Maximum allowed length of element symbols
   integer, parameter :: symbol_length = 4


   !> Periodic system of elements
   character(len=2), parameter :: pse(118) = [ &
      & 'H ','He', &
      & 'Li','Be','B ','C ','N ','O ','F ','Ne', &
      & 'Na','Mg','Al','Si','P ','S ','Cl','Ar', &
      & 'K ','Ca', &
      & 'Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu','Zn', &
      &           'Ga','Ge','As','Se','Br','Kr', &
      & 'Rb','Sr', &
      & 'Y ','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd', &
      &           'In','Sn','Sb','Te','I ','Xe', &
      & 'Cs','Ba', &
      & 'La','Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb', &
      & 'Lu','Hf','Ta','W ','Re','Os','Ir','Pt','Au','Hg', &
      &           'Tl','Pb','Bi','Po','At','Rn', &
      & 'Fr','Ra', &
      & 'Ac','Th','Pa','U ','Np','Pu','Am','Cm','Bk','Cf','Es','Fm','Md','No', &
      & 'Lr','Rf','Db','Sg','Bh','Hs','Mt','Ds','Rg','Cn', &
      &           'Nh','Fl','Mc','Lv','Ts','Og' ]


   !> Lower case version of the periodic system of elements
   character(len=2), parameter :: lcpse(118) = [ &
      & 'h ','he', &
      & 'li','be','b ','c ','n ','o ','f ','ne', &
      & 'na','mg','al','si','p ','s ','cl','ar', &
      & 'k ','ca', &
      & 'sc','ti','v ','cr','mn','fe','co','ni','cu','zn', &
      &           'ga','ge','as','se','br','kr', &
      & 'rb','sr', &
      & 'y ','zr','nb','mo','tc','ru','rh','pd','ag','cd', &
      &           'in','sn','sb','te','i ','xe', &
      & 'cs','ba','la', &
      & 'ce','pr','nd','pm','sm','eu','gd','tb','dy','ho','er','tm','yb', &
      & 'lu','hf','ta','w ','re','os','ir','pt','au','hg', &
      &           'tl','pb','bi','po','at','rn', &
      & 'fr','ra','ac', &
      & 'th','pa','u ','np','pu','am','cm','bk','cf','es','fm','md','no', &
      & 'lr','rf','db','sg','bh','hs','mt','ds','rg','cn', &
      &           'nh','fl','mc','lv','ts','og' ]


   !> ASCII offset between lowercase and uppercase letters
   integer, parameter :: offset = iachar('a') - iachar('A')


contains


!> Convert element symbol to atomic number
elemental subroutine symbol_to_number(number, symbol)

   !> Element symbol
   character(len=*), intent(in) :: symbol

   !> Atomic number
   integer, intent(out) :: number

   character(len=2) :: lcsymbol
   integer :: i, j, k, l

   number = 0
   lcsymbol = '  '

   k = 0
   do j = 1, len_trim(symbol)
      if (k > 2) exit
      l = iachar(symbol(j:j))
      if (k >= 1 .and. l == iachar(' ')) exit
      if (k >= 1 .and. l == 9) exit
      if (l >= iachar('A') .and. l <= iachar('Z')) l = l + offset
      if (l >= iachar('a') .and. l <= iachar('z')) then
         k = k+1
         if (k > 2) exit
         lcsymbol(k:k) = achar(l)
      endif
   enddo

   do i = 1, size(lcpse)
      if (lcsymbol == lcpse(i)) then
         number = i
         exit
      endif
   enddo

   if (number == 0) then
      select case(lcsymbol)
      case('d ', 't ')
         number = 1
      end select
   end if

end subroutine symbol_to_number


!> Convert atomic number to element symbol
elemental subroutine number_to_symbol(symbol, number)

   !> Atomic number
   integer, intent(in) :: number

   !> Element symbol
   character(len=2), intent(out) :: symbol

   if (number <= 0 .or. number > size(pse)) then
      symbol = '--'
   else
      symbol = pse(number)
   endif

end subroutine number_to_symbol


!> Convert atomic number to element symbol
elemental subroutine number_to_lcsymbol(symbol, number)

   !> Atomic number
   integer, intent(in) :: number

   !> Element symbol
   character(len=2), intent(out) :: symbol

   if (number <= 0 .or. number > size(lcpse)) then
      symbol = '--'
   else
      symbol = lcpse(number)
   endif

end subroutine number_to_lcsymbol


!> Convert element symbol to atomic number
elemental function to_number(symbol) result(number)

   !> Element symbol
   character(len=*), intent(in) :: symbol

   !> Atomic number
   integer :: number

   call symbol_to_number(number, symbol)

end function to_number


!> Convert atomic number to element symbol
elemental function to_symbol(number) result(symbol)

   !> Atomic number
   integer,intent(in) :: number

   !> Element symbol
   character(len=2) :: symbol

   call number_to_symbol(symbol, number)

end function to_symbol


!> Convert atomic number to element symbol
elemental function to_lcsymbol(number) result(symbol)

   !> Atomic number
   integer,intent(in) :: number

   !> Element symbol
   character(len=2) :: symbol

   call number_to_lcsymbol(symbol, number)

end function to_lcsymbol


!> Get chemical identity from a list of atomic numbers
pure subroutine get_identity_number(nid, identity, number)

   !> Number of unique species
   integer, intent(out) :: nid

   !> Ordinal numbers
   integer, intent(in) :: number(:)

   !> Chemical identity
   integer, intent(out) :: identity(:)

   integer, allocatable :: itmp(:)
   integer :: nat, iat, iid

   nat = size(identity)
   allocate(itmp(nat))
   nid = 0
   do iat = 1, nat
      iid = find_number(itmp(:nid), number(iat))
      if (iid == 0) then
         call append_number(itmp, nid, number(iat))
         iid = nid
      end if
      identity(iat) = iid
   end do

end subroutine get_identity_number


!> Get chemical identity from a list of element symbols
pure subroutine get_identity_symbol(nid, identity, symbol)

   !> Number of unique species
   integer, intent(out) :: nid

   !> Element symbols
   character(len=*), intent(in) :: symbol(:)

   !> Chemical identity
   integer, intent(out) :: identity(:)

   character(len=len(symbol)), allocatable :: stmp(:)
   integer :: nat, iat, iid

   nat = size(identity)
   allocate(stmp(nat))
   nid = 0
   do iat = 1, nat
      iid = find_symbol(stmp(:nid), symbol(iat))
      if (iid == 0) then
         call append_symbol(stmp, nid, symbol(iat))
         iid = nid
      end if
      identity(iat) = iid
   end do

end subroutine get_identity_symbol


!> Establish a mapping between unique atom types and species
pure subroutine collect_identical(identity, mapping)

   !> Chemical identity
   integer, intent(in) :: identity(:)

   !> Mapping from unique atoms
   integer, intent(out) :: mapping(:)

   integer :: iid, iat

   do iid = 1, size(mapping)
      do iat = 1, size(identity)
         if (identity(iat) == iid) then
            mapping(iid) = iat
            exit
         end if
      end do
   end do

end subroutine collect_identical


!> Find element symbol in an unordered list, all entries are required to be unique
pure function find_symbol(list, symbol) result(position)

   !> List of element symbols
   character(len=*), intent(in) :: list(:)

   !> Element symbol
   character(len=*), intent(in) :: symbol

   !> Position of the symbol in list if found, otherwise zero
   integer :: position
   integer :: isym

   position = 0
   do isym = 1, size(list)
      if (symbol == list(isym)) then
         position = isym
         exit
      end if
   end do

end function find_symbol


!> Find atomic number in an unordered list, all entries are required to be unique
pure function find_number(list, number) result(position)

   !> List of atomic numbers
   integer, intent(in) :: list(:)

   !> Atomic number
   integer, intent(in) :: number

   !> Position of the number in list if found, otherwise zero
   integer :: position
   integer :: inum

   position = 0
   do inum = 1, size(list)
      if (number == list(inum)) then
         position = inum
         exit
      end if
   end do

end function find_number


!> Append an element symbol to an unsorted list, to ensure no duplicates search
!> for the element symbol first
pure subroutine append_symbol(list, nlist, symbol)

   !> List of element symbols
   character(len=*), allocatable, intent(inout) :: list(:)

   !> Current occupied size of list
   integer, intent(inout) :: nlist

   !> Elements symbol
   character(len=*), intent(in) :: symbol

   if (nlist >= size(list)) then
      call resize(list)
   end if

   nlist = nlist + 1
   list(nlist) = symbol

end subroutine append_symbol


!> Append an atomic number to an unsorted list, to ensure no duplicates search
!> for the atomic number first
pure subroutine append_number(list, nlist, number)

   !> List of atomic number
   integer, allocatable, intent(inout) :: list(:)

   !> Current occupied size of list
   integer, intent(inout) :: nlist

   !> Atomic number
   integer, intent(in) :: number

   if (nlist >= size(list)) then
      call resize(list)
   end if

   nlist = nlist + 1
   list(nlist) = number

end subroutine append_number


end module mctc_io_symbols

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/external
!> Contains external potentials

!> @file tblite/external/field.f90
!> Provides interaction of charge density with external fields

!> Interaction of Hamiltonian with external fields
module tblite_external_field
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_blas, only : dot
   use tblite_container_cache, only : container_cache
   use tblite_container_type, only : container_type
   use tblite_scf_info, only : scf_info, atom_resolved
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: new_electric_field

   !> Container for contribution from an instantaneous electric field
   type, public, extends(container_type) :: electric_field
      !> Instantaneous electric field
      real(wp) :: efield(3) = 0.0_wp
   contains
      !> Update cache from container
      procedure :: update
      !> Return dependency on density
      procedure :: variable_info
      !> Get electric field energy
      procedure :: get_energy
      !> Get electric field potential
      procedure :: get_potential
      !> Get electric field potential
      procedure :: get_potential_gradient
      !> Get electric field gradient
      procedure :: get_gradient
   end type electric_field


   !> Create electric field container from field vector
   interface electric_field
      module procedure :: create_electric_field
   end interface electric_field


   !> Identifier for container
   character(len=*), parameter :: label = "electric field"


contains


!> Create new electric field container
pure subroutine new_electric_field(self, efield)
   !> Instance of the electrostatic container
   type(electric_field), intent(out) :: self
   !> Instantaneous electric field
   real(wp), intent(in) :: efield(:)

   self%efield(:) = efield(:3)
   self%label = label
end subroutine new_electric_field


!> Create new electric field container
pure function create_electric_field(efield) result(new)
   !> Instantaneous electric field
   real(wp), intent(in) :: efield(:)
   !> Instance of the electrostatic container
   type(electric_field) :: new

   call new_electric_field(new, efield)
end function create_electric_field


!> Update cache from container
subroutine update(self, mol, cache)
   !> Instance of the electrostatic container
   class(electric_field), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
end subroutine update


!> Get electric field energy
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the electrostatic container
   class(electric_field), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)

   real(wp), allocatable :: vdp(:, :), vat(:)

   vat = matmul(self%efield, mol%xyz)
   vdp = spread(self%efield, 2, mol%nat)
   energies(:) = energies - vat * wfn%qat(:, 1) - sum(vdp * wfn%dpat(:, :, 1), 1)
end subroutine get_energy


!> Get electric field potential
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the electrostatic container
   class(electric_field), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   pot%vat(:, 1) = pot%vat(:, 1) - matmul(self%efield, mol%xyz)
   pot%vdp(:, :, 1) = pot%vdp(:, :, 1) - spread(self%efield, 2, mol%nat)
end subroutine get_potential


!> Get electric field potential gradient (empty)
subroutine get_potential_gradient(self, mol, cache, wfn, pot)
   !> Instance of the electrostatic container
   class(electric_field), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

end subroutine get_potential_gradient


!> Get electric field gradient
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the electrostatic container
   class(electric_field), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the repulsion energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   real(wp), allocatable :: vdp(:, :), stmp(:, :)

   vdp = spread(self%efield, 2, mol%nat)
   stmp = matmul(vdp, transpose(mol%xyz))
   gradient(:, :) = gradient - vdp
   sigma(:, :) = sigma - 0.5_wp * (stmp + transpose(stmp))
end subroutine get_gradient


!> Return dependency on density
pure function variable_info(self) result(info)
   !> Instance of the electrostatic container
   class(electric_field), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=atom_resolved, dipole=atom_resolved)
end function variable_info


end module tblite_external_field

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_xtb_singlepoint
   use mctc_env, only : wp, error_type, fatal_error, get_variable
   use mctc_io, only : structure_type
   use tblite_adjlist, only : adjacency_list, new_adjacency_list
   use tblite_basis_type, only : get_cutoff, basis_type
   use tblite_blas, only : gemv
   use tblite_container, only : container_cache
   use tblite_context, only : context_type, escape
   use tblite_cutoff, only : get_lattice_points
   use tblite_lapack_sygvd, only : sygvd_solver
   use tblite_integral_type, only : integral_type, new_integral
   use tblite_output_ascii, only : ascii_levels, ascii_dipole_moments, &
      & ascii_quadrupole_moments
   use tblite_output_property, only : property, write(formatted)
   use tblite_output_format, only : format_string
   use tblite_results, only : results_type
   use tblite_scf, only : broyden_mixer, new_broyden, scf_info, next_scf, &
      & get_mixer_dimension, potential_type, new_potential
   use tblite_timer, only : timer_type, format_time
   use tblite_wavefunction, only : wavefunction_type, get_density_matrix, &
      & get_alpha_beta_occupation, get_molecular_dipole_moment, &
      & get_molecular_quadrupole_moment, magnet_to_updown, updown_to_magnet
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_h0, only : get_selfenergy, get_hamiltonian, get_occupation, &
      & get_hamiltonian_gradient
   implicit none
   private

   public :: xtb_singlepoint

   real(wp), parameter :: cn_cutoff = 25.0_wp

contains


subroutine xtb_singlepoint(ctx, mol, calc, wfn, accuracy, energy, gradient, sigma, &
      & verbosity, results)
   type(context_type), intent(inout) :: ctx
   type(structure_type), intent(in) :: mol
   type(xtb_calculator), intent(in) :: calc
   type(wavefunction_type), intent(inout) :: wfn
   real(wp), intent(in) :: accuracy
   real(wp), intent(out) :: energy
   real(wp), contiguous, intent(out), optional :: gradient(:, :)
   real(wp), contiguous, intent(out), optional :: sigma(:, :)
   integer, intent(in), optional :: verbosity
   type(results_type), intent(out), optional :: results

   logical :: grad, converged, econverged, pconverged
   integer :: prlevel
   real(wp) :: econv, pconv, cutoff, elast, dpmom(3), qpmom(6), nel
   real(wp), allocatable :: energies(:), edisp(:), erep(:), exbond(:), eint(:), eelec(:)
   real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :), dEdcn(:)
   real(wp), allocatable :: selfenergy(:), dsedcn(:), lattr(:, :), wdensity(:, :, :)
   type(integral_type) :: ints
   real(wp), allocatable :: tmp(:)
   type(potential_type) :: pot
   type(container_cache) :: ccache, dcache, icache, hcache, rcache
   type(broyden_mixer) :: mixer
   type(timer_type) :: timer
   type(error_type), allocatable :: error

   type(scf_info) :: info
   type(sygvd_solver) :: sygvd
   type(adjacency_list) :: list
   integer :: iscf, spin

   call timer%push("total")

   if (present(verbosity)) then
      prlevel = verbosity
   else
      prlevel = ctx%verbosity
   end if

   econv = 1.e-6_wp*accuracy
   pconv = 2.e-5_wp*accuracy

   sygvd = sygvd_solver()

   grad = present(gradient) .and. present(sigma)

   allocate(energies(mol%nat), source=0.0_wp)
   allocate(erep(mol%nat), source=0.0_wp)
   allocate(edisp(mol%nat), source=0.0_wp)
   allocate(eint(mol%nat), source=0.0_wp)
   allocate(exbond(mol%nat), source=0.0_wp)
   if (grad) then
      gradient(:, :) = 0.0_wp
      sigma(:, :) = 0.0_wp
   end if

   if (allocated(calc%halogen)) then
      call timer%push("halogen")
      call calc%halogen%update(mol, hcache)
      call calc%halogen%get_engrad(mol, hcache, exbond, gradient, sigma)
      if (prlevel > 1) print *, property("halogen-bonding energy", sum(exbond), "Eh")
      energies(:) = energies + exbond
      call timer%pop
   end if

   if (allocated(calc%repulsion)) then
      call timer%push("repulsion")
      call calc%repulsion%update(mol, rcache)
      call calc%repulsion%get_engrad(mol, rcache, erep, gradient, sigma)
      if (prlevel > 1) print *, property("repulsion energy", sum(erep), "Eh")
      energies(:) = energies + erep
      call timer%pop
   end if

   if (allocated(calc%dispersion)) then
      call timer%push("dispersion")
      call calc%dispersion%update(mol, dcache)
      call calc%dispersion%get_engrad(mol, dcache, edisp, gradient, sigma)
      if (prlevel > 1) print *, property("dispersion energy", sum(edisp), "Eh")
      energies(:) = energies + edisp
      call timer%pop
   end if

   if (allocated(calc%interactions)) then
      call timer%push("interactions")
      call calc%interactions%update(mol, icache)
      call calc%interactions%get_engrad(mol, icache, eint, gradient, sigma)
      if (prlevel > 1) print *, property("interaction energy", sum(eint), "Eh")
      energies(:) = energies + eint
      call timer%pop
   end if

   call new_potential(pot, mol, calc%bas, wfn%nspin)
   if (allocated(calc%coulomb)) then
      call timer%push("coulomb")
      call calc%coulomb%update(mol, ccache)
      call timer%pop
   end if

   call get_occupation(mol, calc%bas, calc%h0, wfn%nocc, wfn%n0at, wfn%n0sh)
   nel = sum(wfn%n0at) - mol%charge
   if (mod(mol%uhf, 2) == mod(nint(nel), 2)) then
      wfn%nuhf = mol%uhf
   else
      wfn%nuhf = mod(nint(nel), 2)
   end if
   call get_alpha_beta_occupation(wfn%nocc, wfn%nuhf, wfn%nel(1), wfn%nel(2))

   if (prlevel > 1) print *, property("number of electrons", wfn%nocc, "e")

   call timer%push("hamiltonian")
   if (allocated(calc%ncoord)) then
      allocate(cn(mol%nat))
      if (grad) then
         allocate(dcndr(3, mol%nat, mol%nat), dcndL(3, 3, mol%nat))
      end if
      call calc%ncoord%get_cn(mol, cn, dcndr, dcndL)
   end if

   allocate(selfenergy(calc%bas%nsh), dsedcn(calc%bas%nsh))
   call get_selfenergy(calc%h0, mol%id, calc%bas%ish_at, calc%bas%nsh_id, cn=cn, &
      & selfenergy=selfenergy, dsedcn=dsedcn)

   cutoff = get_cutoff(calc%bas, accuracy)
   call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)
   call new_adjacency_list(list, mol, lattr, cutoff)

   if (prlevel > 1) then
      print *, property("integral cutoff", cutoff, "bohr")
      print *
   end if

   call new_integral(ints, calc%bas%nao)
   call get_hamiltonian(mol, lattr, list, calc%bas, calc%h0, selfenergy, &
      & ints%overlap, ints%dipole, ints%quadrupole, ints%hamiltonian)
   call timer%pop

   call timer%push("scc")
   allocate(eelec(mol%nat), source=0.0_wp)
   iscf = 0
   converged = .false.
   info = calc%variable_info()
   call new_broyden(mixer, calc%max_iter, wfn%nspin*get_mixer_dimension(mol, calc%bas, info), &
      & calc%mixer_damping)
   if (prlevel > 0) then
      call ctx%message(repeat("-", 60))
      call ctx%message("  cycle        total energy    energy error   density error")
      call ctx%message(repeat("-", 60))
   end if
   do while(.not.converged .and. iscf < calc%max_iter)
      elast = sum(eelec)
      call next_scf(iscf, mol, calc%bas, wfn, sygvd, mixer, info, &
         & calc%coulomb, calc%dispersion, calc%interactions, ints, pot, &
         & ccache, dcache, icache, eelec, error)
      econverged = abs(sum(eelec) - elast) < econv
      pconverged = mixer%get_error() < pconv
      converged = econverged .and. pconverged
      if (prlevel > 0) then
         call ctx%message(format_string(iscf, "(i7)") // &
            & format_string(sum(eelec + energies), "(g24.13)") // &
            & escape(merge(ctx%terminal%green, ctx%terminal%red, econverged)) // &
            & format_string(sum(eelec) - elast, "(es16.7)") // &
            & escape(merge(ctx%terminal%green, ctx%terminal%red, pconverged)) // &
            & format_string(mixer%get_error(), "(es16.7)") // &
            & escape(ctx%terminal%reset))
      end if
      if (allocated(error)) then
         call ctx%set_error(error)
         exit
      end if
   end do
   if (prlevel > 0) then
      call ctx%message(repeat("-", 60) // new_line('a'))
   end if
   energies(:) = energies + eelec
   energy = sum(energies)
   if (present(results)) then
      results%energies = energies
   end if
   call timer%pop

   if (prlevel > 1) then
      print *, property("electronic energy", sum(eelec), "Eh")
      print *, property("total energy", sum(energies), "Eh")
      print *
   end if

   if (ctx%failed()) return

   call get_molecular_dipole_moment(mol, wfn%qat(:, 1), wfn%dpat(:, :, 1), dpmom)
   call get_molecular_quadrupole_moment(mol, wfn%qat(:, 1), wfn%dpat(:, :, 1), &
      & wfn%qpat(:, :, 1), qpmom)
   if (prlevel > 2) then
      call ascii_dipole_moments(6, 1, mol, wfn%dpat(:, :, 1), dpmom)
      call ascii_quadrupole_moments(6, 1, mol, wfn%qpat(:, :, 1), qpmom)
   end if

   if (grad) then
      if (allocated(calc%coulomb)) then
         call timer%push("coulomb")
         call calc%coulomb%get_gradient(mol, ccache, wfn, gradient, sigma)
         call timer%pop
      end if

      if (allocated(calc%dispersion)) then
         call timer%push("dispersion")
         call calc%dispersion%get_gradient(mol, dcache, wfn, gradient, sigma)
         call timer%pop
      end if

      if (allocated(calc%interactions)) then
         call timer%push("interactions")
         call calc%interactions%get_gradient(mol, icache, wfn, gradient, sigma)
         call timer%pop
      end if

      call timer%push("hamiltonian")
      allocate(dEdcn(mol%nat))
      dEdcn(:) = 0.0_wp

      allocate(wdensity(calc%bas%nao, calc%bas%nao, wfn%nspin))
      do spin = 1, wfn%nspin
         tmp = wfn%focc(:, spin) * wfn%emo(:, spin)
         call get_density_matrix(tmp, wfn%coeff(:, :, spin), wdensity(:, :, spin))
      end do
      call updown_to_magnet(wfn%density)
      call updown_to_magnet(wdensity)
      !print '(3es20.13)', sigma
      call get_hamiltonian_gradient(mol, lattr, list, calc%bas, calc%h0, selfenergy, &
         & dsedcn, pot, wfn%density, wdensity, dEdcn, gradient, sigma)
      call magnet_to_updown(wfn%density)

      if (allocated(dcndr)) then
         call gemv(dcndr, dEdcn, gradient, beta=1.0_wp)
      end if
      if (allocated(dcndL)) then
         call gemv(dcndL, dEdcn, sigma, beta=1.0_wp)
      end if
      call timer%pop
   end if

   if (calc%save_integrals .and. present(results)) then
      call move_alloc(ints%overlap, results%overlap)
      call move_alloc(ints%hamiltonian, results%hamiltonian)
   end if

   block
      integer :: it
      real(wp) :: ttime, stime
      character(len=*), parameter :: label(*) = [character(len=20):: &
         & "repulsion", "halogen", "dispersion", "coulomb", "hamiltonian", "scc"]
      if (prlevel > 0) then
         ttime = timer%get("total")
         call ctx%message(" total:"//repeat(" ", 16)//format_time(ttime))
      end if
      if (prlevel > 1) then
         do it = 1, size(label)
            stime = timer%get(label(it))
            if (stime <= epsilon(0.0_wp)) cycle
            call ctx%message(" - "//label(it)//format_time(stime) &
               & //" ("//format_string(int(stime/ttime*100), '(i3)')//"%)")
         end do
         call ctx%message("")
      end if
   end block

   if (.not.converged) then
      call fatal_error(error, "SCF not converged in "//format_string(iscf, '(i0)')//" cycles")
      call ctx%set_error(error)
   end if

end subroutine xtb_singlepoint


end module tblite_xtb_singlepoint

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> High-level interface to level 2 basic linear algebra subprogram operations
module tblite_blas_level2
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_gemv, wrap_symv


   !> Performs one of the matrix-vector operations
   !>
   !>    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
   !>
   !> where alpha and beta are scalars, x and y are vectors and A is an
   !> m by n matrix.
   interface wrap_gemv
      module procedure :: wrap_sgemv
      module procedure :: wrap_dgemv
      module procedure :: wrap_sgemv312
      module procedure :: wrap_sgemv321
      module procedure :: wrap_sgemv422
      module procedure :: wrap_dgemv312
      module procedure :: wrap_dgemv321
      module procedure :: wrap_dgemv422
   end interface wrap_gemv

   !> Performs the matrix-vector  operation
   !>
   !>    y := alpha*A*x + beta*y,
   !>
   !> where alpha and beta are scalars, x and y are n element vectors and
   !> A is an n by n symmetric matrix.
   interface wrap_symv
      module procedure :: wrap_ssymv
      module procedure :: wrap_dsymv
   end interface wrap_symv


   !> Performs one of the matrix-vector operations
   !>
   !>    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
   !>
   !> where alpha and beta are scalars, x and y are vectors and A is an
   !> m by n matrix.
   interface blas_gemv
      pure subroutine sgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: x(*)
         real(sp), intent(inout) :: y(*)
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine sgemv
      pure subroutine dgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: x(*)
         real(dp), intent(inout) :: y(*)
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dgemv
   end interface blas_gemv

   !> Performs the matrix-vector  operation
   !>
   !>    y := alpha*A*x + beta*y,
   !>
   !> where alpha and beta are scalars, x and y are n element vectors and
   !> A is an n by n symmetric matrix.
   interface blas_symv
      pure subroutine ssymv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: x(*)
         real(sp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine ssymv
      pure subroutine dsymv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: x(*)
         real(dp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dsymv
   end interface blas_symv


contains


subroutine wrap_sgemv422(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in), contiguous, target :: amat(:, :, :, :)
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(inout), contiguous, target :: yvec(:, :)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp), pointer :: aptr(:, :), yptr(:), xptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)*size(amat, 4)) => amat
   xptr(1:size(xvec, 1)*size(xvec, 2)) => xvec
   yptr(1:size(yvec, 1)*size(yvec, 2)) => yvec
   call wrap_gemv(aptr, xptr, yptr, alpha, beta, tra)
end subroutine wrap_sgemv422


subroutine wrap_sgemv312(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout), contiguous, target :: yvec(:, :)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp), pointer :: aptr(:, :), yptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      yptr(1:size(yvec, 1)*size(yvec, 2)) => yvec
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      yptr(1:size(yvec, 1) * size(yvec, 2)) => yvec
   end if
   call wrap_gemv(aptr, xvec, yptr, alpha, beta, tra)
end subroutine wrap_sgemv312


subroutine wrap_sgemv321(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(inout) :: yvec(:)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp), pointer :: aptr(:, :), xptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      xptr(1:size(xvec, 1)*size(xvec, 2)) => xvec
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      xptr(1:size(xvec, 1) * size(xvec, 2)) => xvec
   end if
   call wrap_gemv(aptr, xptr, yvec, alpha, beta, tra)
end subroutine wrap_sgemv321


subroutine wrap_dgemv422(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in), contiguous, target :: amat(:, :, :, :)
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(inout), contiguous, target :: yvec(:, :)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp), pointer :: aptr(:, :), yptr(:), xptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)*size(amat, 4)) => amat
   xptr(1:size(xvec, 1)*size(xvec, 2)) => xvec
   yptr(1:size(yvec, 1)*size(yvec, 2)) => yvec
   call wrap_gemv(aptr, xptr, yptr, alpha, beta, tra)
end subroutine wrap_dgemv422


subroutine wrap_dgemv312(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout), contiguous, target :: yvec(:, :)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp), pointer :: aptr(:, :), yptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      yptr(1:size(yvec, 1)*size(yvec, 2)) => yvec
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      yptr(1:size(yvec, 1) * size(yvec, 2)) => yvec
   end if
   call wrap_gemv(aptr, xvec, yptr, alpha, beta, tra)
end subroutine wrap_dgemv312


subroutine wrap_dgemv321(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(inout) :: yvec(:)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp), pointer :: aptr(:, :), xptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      xptr(1:size(xvec, 1)*size(xvec, 2)) => xvec
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      xptr(1:size(xvec, 1) * size(xvec, 2)) => xvec
   end if
   call wrap_gemv(aptr, xptr, yvec, alpha, beta, tra)
end subroutine wrap_dgemv321


pure subroutine wrap_sgemv(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout) :: yvec(:)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp) :: a, b
   character(len=1) :: tra
   integer :: incx, incy, m, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
   call blas_gemv(tra, m, n, a, amat, lda, xvec, incx, b, yvec, incy)
end subroutine wrap_sgemv


pure subroutine wrap_dgemv(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout) :: yvec(:)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp) :: a, b
   character(len=1) :: tra
   integer :: incx, incy, m, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
   call blas_gemv(tra, m, n, a, amat, lda, xvec, incx, b, yvec, incy)
end subroutine wrap_dgemv


pure subroutine wrap_ssymv(amat, xvec, yvec, uplo, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout) :: yvec(:)
   character(len=1), intent(in), optional :: uplo
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1) :: ula
   real(sp) :: a, b
   integer :: incx, incy, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   call blas_symv(ula, n, a, amat, lda, xvec, incx, b, yvec, incy)
end subroutine wrap_ssymv


pure subroutine wrap_dsymv(amat, xvec, yvec, uplo, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout) :: yvec(:)
   character(len=1), intent(in), optional :: uplo
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1) :: ula
   real(dp) :: a, b
   integer :: incx, incy, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   call blas_symv(ula, n, a, amat, lda, xvec, incx, b, yvec, incy)
end subroutine wrap_dsymv


end module tblite_blas_level2

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Container for holding results produced by a calculation
module tblite_results
   use mctc_env, only : wp
   implicit none
   private

   public :: results_type


   !> Results container
   type results_type
      !> Atom-resolved energies
      real(wp), allocatable :: energies(:)
      !> Overlap integrals
      real(wp), allocatable :: overlap(:, :)
      !> (Core) Hamiltonian integrals
      real(wp), allocatable :: hamiltonian(:, :)
   end type results_type

end module tblite_results

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Proxy module to expose coordination number containers
module tblite_ncoord
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_ncoord_type, only : ncoord_type
   use tblite_ncoord_gfn, only : gfn_ncoord_type, new_gfn_ncoord
   use tblite_ncoord_exp, only : exp_ncoord_type, new_exp_ncoord
   implicit none
   private

   public :: ncoord_type, new_ncoord


contains

!> Create a new generic coordination number container
subroutine new_ncoord(self, mol, cn_type)
   !> Instance of the coordination number container
   class(ncoord_type), allocatable, intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Coordination number type
   character(len=*), intent(in) :: cn_type

   select case(cn_type)
   case("exp")
      block
         type(exp_ncoord_type), allocatable :: tmp
         allocate(tmp)
         call new_exp_ncoord(tmp, mol)
         call move_alloc(tmp, self)
      end block
   case("gfn")
      block
         type(gfn_ncoord_type), allocatable :: tmp
         allocate(tmp)
         call new_gfn_ncoord(tmp, mol)
         call move_alloc(tmp, self)
      end block
   end select
end subroutine new_ncoord

end module tblite_ncoord

program test_multipolar_solutes
use ddx_core
use ddx_multipolar_solutes
implicit none

integer, parameter :: natoms = 24
character(len=255) :: dummy_file_name = ''

type(ddx_type) :: nofmm, fmm
type(ddx_error_type) :: ddx_error

real(dp) :: coordinates(3, natoms), radii(natoms), charges(natoms)
real(dp) :: x(natoms), y(natoms), z(natoms)
integer :: info, nproc = 1
real(dp), allocatable :: multipoles(:, :)
real(dp) :: diff
real(dp), parameter :: threshold = 1e-10

! We manually specify two benzene molecules 20 A apart

radii = (/ &
    & 4.00253d0, &
    & 4.00253d0, &
    & 4.00253d0, &
    & 4.00253d0, &
    & 4.00253d0, &
    & 4.00253d0, &
    & 2.99956d0, &
    & 2.99956d0, &
    & 2.99956d0, &
    & 2.99956d0, &
    & 2.99956d0, &
    & 2.99956d0, &
    & 4.00253d0, &
    & 4.00253d0, &
    & 4.00253d0, &
    & 4.00253d0, &
    & 4.00253d0, &
    & 4.00253d0, &
    & 2.99956d0, &
    & 2.99956d0, &
    & 2.99956d0, &
    & 2.99956d0, &
    & 2.99956d0, &
    & 2.99956d0/)

charges = (/ &
    & -0.04192d0, &
    & -0.04192d0, &
    & -0.04198d0, &
    & -0.04192d0, &
    & -0.04192d0, &
    & -0.04198d0, &
    &  0.04193d0, &
    &  0.04193d0, &
    &  0.04197d0, &
    &  0.04193d0, &
    &  0.04193d0, &
    &  0.04197d0, &
    & -0.04192d0, &
    & -0.04192d0, &
    & -0.04198d0, &
    & -0.04192d0, &
    & -0.04192d0, &
    & -0.04198d0, &
    &  0.04193d0, &
    &  0.04193d0, &
    &  0.04197d0, &
    &  0.04193d0, &
    &  0.04193d0, &
    &  0.04197d0/)

coordinates = reshape((/ &
    &  0.00000d0,  2.29035d0,  1.32281d0, &
    &  0.00000d0,  2.29035d0, -1.32281d0, &
    &  0.00000d0,  0.00000d0, -2.64562d0, &
    &  0.00000d0, -2.29035d0, -1.32281d0, &
    &  0.00000d0, -2.29035d0,  1.32281d0, &
    &  0.00000d0,  0.00000d0,  2.64562d0, &
    &  0.00000d0,  4.05914d0,  2.34326d0, &
    &  0.00000d0,  4.05914d0, -2.34326d0, &
    &  0.00000d0,  0.00000d0, -4.68652d0, &
    &  0.00000d0, -4.05914d0, -2.34326d0, &
    &  0.00000d0, -4.05914d0,  2.34326d0, &
    &  0.00000d0,  0.00000d0,  4.68652d0, &
    & 20.00000d0,  2.29035d0,  1.32281d0, &
    & 20.00000d0,  2.29035d0, -1.32281d0, &
    & 20.00000d0,  0.00000d0, -2.64562d0, &
    & 20.00000d0, -2.29035d0, -1.32281d0, &
    & 20.00000d0, -2.29035d0,  1.32281d0, &
    & 20.00000d0,  0.00000d0,  2.64562d0, &
    & 20.00000d0,  4.05914d0,  2.34326d0, &
    & 20.00000d0,  4.05914d0, -2.34326d0, &
    & 20.00000d0,  0.00000d0, -4.68652d0, &
    & 20.00000d0, -4.05914d0, -2.34326d0, &
    & 20.00000d0, -4.05914d0,  2.34326d0, &
    & 20.00000d0,  0.00000d0,  4.68652d0/), &
    (/3, natoms/))

coordinates = coordinates * tobohr
radii = radii * tobohr

x = coordinates(1, :)
y = coordinates(2, :)
z = coordinates(3, :)

! Initialize two ddX model instances, with and without FMMs

call allocate_model(natoms, x, y, z, radii, 1, 10, 302, 0, 0, 0, 0, 0.0d0, &
    & 0.1d0, 80.0d0, 0.104d0*tobohr, 0, 200, 25, nproc, &
    & dummy_file_name, nofmm, ddx_error)
call check_error(ddx_error)

call allocate_model(natoms, x, y, z, radii,  1, 10, 302, 0, 1, 20, 20, 0.0d0, &
    & 0.1d0, 80.0d0, 0.104d0*tobohr, 0, 200, 25, nproc, &
    & dummy_file_name, fmm, ddx_error)
call check_error(ddx_error)

if (nofmm % constants % ncav .ne. fmm % constants % ncav) &
    & call test_error("Mismatch in geometry between FMM and no FMM.")

! Compute the multipoles from the charges

allocate(multipoles(1, natoms), stat=info)
if (info .ne. 0) call test_error("Allocation failed in test_multipolar_solutes")
multipoles(1, :) = charges / sqrt4pi

write(6, *) "Testing up to charges"
call test(fmm, nofmm, multipoles, 0, natoms, threshold, ddx_error)
call check_error(ddx_error)

deallocate(multipoles, stat=info)
if (info .ne. 0) call test_error("Deallocation failed in test_multipolar_solutes")

! Now we do charges and some random dipoles

allocate(multipoles(4, natoms), stat=info)
if (info .ne. 0) call test_error("Allocation failed in test_multipolar_solutes")
multipoles(1, :) = charges / sqrt4pi
multipoles(2, :) = 0.0d0
multipoles(3, :) = 0.1d0
multipoles(4, :) = -0.1d0

write(6, *) "Testing up to dipoles"
call test(fmm, nofmm, multipoles, 1, natoms, threshold, ddx_error)
call check_error(ddx_error)

deallocate(multipoles, stat=info)
if (info .ne. 0) call test_error("Deallocation failed in test_multipolar_solutes")

! And finally we do  charges, random dipoles and random quadrupoles

allocate(multipoles(10, natoms), stat=info)
if (info .ne. 0) call test_error("Allocation failed in test_multipolar_solutes")
multipoles(1, :) = charges / sqrt4pi
multipoles(2, :) = 0.0d0
multipoles(3, :) = 0.1d0
multipoles(4, :) = 0.1d0
multipoles(5, :) = -0.1d0
multipoles(6, :) = 0.2d0
multipoles(7, :) = -0.2d0
multipoles(8, :) = 0.3d0
multipoles(9, :) = -0.3d0
multipoles(10, :) = 0.1d0

write(6, *) "Testing up to quadrupoles"
call test(fmm, nofmm, multipoles, 2, natoms, threshold, ddx_error)
call check_error(ddx_error)

deallocate(multipoles, stat=info)
if (info .ne. 0) call test_error("Deallocation failed in test_multipolar_solutes")

! deallocate

call deallocate_model(nofmm, ddx_error)
call check_error(ddx_error)
call deallocate_model(fmm, ddx_error)
call check_error(ddx_error)

contains

subroutine test(fmm, nofmm, multipoles, mmax, nm, threshold, ddx_error)
    type(ddx_type), intent(inout) :: fmm, nofmm
    integer, intent(in) :: mmax, nm
    real(dp), intent(in) :: multipoles((mmax+1)**2, nm)
    real(dp), intent(in) :: threshold
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), allocatable :: phi_nofmm(:), phi_fmm(:), e_nofmm(:, :), &
        & e_fmm(:, :), e_num(:, :), g_nofmm(:, :, :), g_fmm(:, :, :), &
        & g_num(:, :, :)
    integer :: info

    ! Allocate the electrostatic properties arrays

    allocate(phi_nofmm(nofmm % constants % ncav), &
        & phi_fmm(nofmm % constants % ncav), &
        & e_nofmm(3, nofmm % constants % ncav), &
        & e_fmm(3, nofmm % constants % ncav), &
        & e_num(3, nofmm % constants % ncav), &
        & g_nofmm(3, 3, nofmm % constants % ncav), &
        & g_fmm(3, 3, nofmm % constants % ncav), &
        & g_num(3, 3, nofmm % constants % ncav), &
        & stat=info)
    if (info .ne. 0) &
        & call test_error("Allocation failed in test_multipolar_solutes")

    ! Compare the potential with and without FMMs

    call multipole_electrostatics_0(nofmm % params, nofmm % constants, &
        & nofmm % workspace, multipoles, mmax, phi_nofmm, ddx_error)

    call multipole_electrostatics_0(fmm % params, fmm % constants, &
        & fmm % workspace, multipoles, mmax, phi_fmm, ddx_error)

    diff = norm_inf_1d(nofmm % constants % ncav, phi_nofmm, phi_fmm)
    if (diff .ge. threshold) &
        & call test_error("multipole_electrostatics_0, phi: FMM and no FMM mismatch")

    ! Compare the field with and without FMMs, furthermore, compare the
    ! potential with the previously obtained one

    call multipole_electrostatics_1(nofmm % params, nofmm % constants, &
        & nofmm % workspace, multipoles, mmax, phi_nofmm, e_nofmm, ddx_error)

    ! Note, here phi_fmm contains the one from the previous step, so we
    ! are actually comparing multipole_electrostatics_0 with multipole_electrostatics_1

    diff = norm_inf_1d(nofmm % constants % ncav, phi_nofmm, phi_fmm)
    if (diff .ge. threshold) &
        & call test_error("multipole_electrostatics_1 multipole_electrostatics_0, phi: mismatch")

    call multipole_electrostatics_1(fmm % params, fmm % constants, fmm % workspace, &
        & multipoles, mmax, phi_fmm, e_fmm, ddx_error)

    diff = norm_inf_1d(nofmm % constants % ncav, phi_nofmm, phi_fmm)
    if (diff .ge. threshold) &
        & call test_error("multipole_electrostatics_1, phi: FMM and no FMM mismatch")

    diff = norm_inf_2d(3, nofmm % constants % ncav, e_nofmm, e_fmm)
    if (diff .ge. threshold) &
        & call test_error("multipole_electrostatics_1, e: FMM and no FMM mismatch")

    ! Compute the numerical field and check

    call numerical_field(multipoles, nofmm % params % csph, mmax, &
        & nofmm % params % nsph, nofmm % constants % ccav, &
        & nofmm % constants % ncav, e_num, ddx_error)

    diff = norm_inf_2d(3, nofmm % constants % ncav, e_nofmm, e_num)
    if (diff .ge. threshold) &
        & call test_error("The analytical field does not match the numerical field")

    ! Compare the field gradient with and without FMMs, furthermore, compare
    ! the field and the potential with the previously obtained ones

    call multipole_electrostatics_2(nofmm % params, nofmm % constants, &
        & nofmm % workspace, multipoles, mmax, phi_nofmm, e_nofmm, g_nofmm, ddx_error)

    ! Note, here phi_fmm and e_fmm contain the properties from the previous
    ! step, so we are actually comparing multipole_electrostatics_2 with multipole_electrostatics_1

    diff = norm_inf_1d(nofmm % constants % ncav, phi_nofmm, phi_fmm)
    if (diff .ge. threshold) &
        & call test_error("multipole_electrostatics_2 multipole_electrostatics_1, phi: mismatch")

    diff = norm_inf_2d(3, nofmm % constants % ncav, e_nofmm, e_fmm)
    if (diff .ge. threshold) &
        & call test_error("multipole_electrostatics_2 multipole_electrostatics_1, e: mismatch")

    call multipole_electrostatics_2(fmm % params, fmm % constants, fmm % workspace, &
        & multipoles, mmax, phi_fmm, e_fmm, g_fmm, ddx_error)

    diff = norm_inf_1d(nofmm % constants % ncav, phi_nofmm, phi_fmm)
    if (diff .ge. threshold) &
        & call test_error("multipole_electrostatics_2, phi: FMM and no FMM mismatch")

    diff = norm_inf_2d(3, nofmm % constants % ncav, e_nofmm, e_fmm)
    if (diff .ge. threshold) &
        & call test_error("multipole_electrostatics_2, e: FMM and no FMM mismatch")

    diff = norm_inf_3d(3, 3, nofmm % constants % ncav, g_nofmm, g_fmm)
    if (diff .ge. threshold) &
        & call test_error("multipole_electrostatics_2, g: FMM and no FMM mismatch")

    ! Compute the numerical field gradient and check

    call numerical_field_gradient(multipoles, nofmm % params % csph, mmax, &
        & nofmm % params % nsph, nofmm % constants % ccav, &
        & nofmm % constants % ncav, g_num, ddx_error)

    diff = norm_inf_2d(3, nofmm % constants % ncav, g_nofmm, g_num)
    if (diff .ge. threshold) &
        & call test_error("The analytical field gradient does not match the numerical field gradient")

    ! Deallocate everything

    deallocate(phi_nofmm, phi_fmm, e_nofmm, e_fmm, e_num, g_nofmm, &
        & g_fmm, g_num, stat=info)
    if (info .ne. 0) &
        & call test_error("Deallocation failed in test_multipolar_solutes")

end subroutine test

real(dp) function norm_inf_1d(n, array_1, array_2)
    implicit none
    integer, intent(in) :: n
    real(dp), intent(in) :: array_1(n), array_2(n)
    norm_inf_1d = maxval(abs(array_1 - array_2))
end function norm_inf_1d

real(dp) function norm_inf_2d(m, n, array_1, array_2)
    implicit none
    integer, intent(in) :: m, n
    real(dp), intent(in) :: array_1(m, n), array_2(m, n)
    norm_inf_2d = maxval(abs(array_1 - array_2))
end function norm_inf_2d

real(dp) function norm_inf_3d(l, m, n, array_1, array_2)
    implicit none
    integer, intent(in) :: l, m, n
    real(dp), intent(in) :: array_1(l, m, n), array_2(l, m, n)
    norm_inf_3d = maxval(abs(array_1 - array_2))
end function norm_inf_3d

subroutine test_error(message)
    implicit none
    character(*) :: message
    write(6,*) message
    stop 1
end subroutine test_error

subroutine numerical_field(multipoles, cm, mmax, nm, coordinates, &
        & npoints, num_field, ddx_error)
    implicit none
    integer, intent(in) :: mmax, nm, npoints
    real(dp), intent(in) :: cm(3, nm), coordinates(3, npoints), &
        & multipoles((mmax + 1)**2, nm)
    real(dp), intent(out) :: num_field(3, npoints)
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp) :: local_coords(3, npoints), v_plus(npoints), v_minus(npoints)
    real(dp), parameter :: delta = 1d-5

    local_coords = coordinates
    local_coords(1, :) = local_coords(1, :) + delta
    call build_phi_dense(multipoles, cm, mmax, nm, v_plus, local_coords, &
        & npoints, ddx_error)

    local_coords = coordinates
    local_coords(1, :) = local_coords(1, :) - delta
    call build_phi_dense(multipoles, cm, mmax, nm, v_minus, local_coords, &
        & npoints, ddx_error)

    num_field(1, :) = - (v_plus - v_minus)/(2.0d0*delta)

    local_coords = coordinates
    local_coords(2, :) = local_coords(2, :) + delta
    call build_phi_dense(multipoles, cm, mmax, nm, v_plus, local_coords, &
        & npoints, ddx_error)

    local_coords = coordinates
    local_coords(2, :) = local_coords(2, :) - delta
    call build_phi_dense(multipoles, cm, mmax, nm, v_minus, local_coords, &
        & npoints, ddx_error)

    num_field(2, :) = - (v_plus - v_minus)/(2.0d0*delta)

    local_coords = coordinates
    local_coords(3, :) = local_coords(3, :) + delta
    call build_phi_dense(multipoles, cm, mmax, nm, v_plus, local_coords, &
        & npoints, ddx_error)

    local_coords = coordinates
    local_coords(3, :) = local_coords(3, :) - delta
    call build_phi_dense(multipoles, cm, mmax, nm, v_minus, local_coords, &
        & npoints, ddx_error)

    num_field(3, :) = - (v_plus - v_minus)/(2.0d0*delta)

end subroutine numerical_field

subroutine numerical_field_gradient(multipoles, cm, mmax, nm, coordinates, &
        & npoints, num_field_gradient, ddx_error)
    implicit none
    integer, intent(in) :: mmax, nm, npoints
    real(dp), intent(in) :: cm(3, nm), coordinates(3, npoints), &
        & multipoles((mmax + 1)**2, nm)
    real(dp), intent(out) :: num_field_gradient(3, 3, npoints)
    real(dp) :: local_coords(3, npoints), e_plus(3, npoints), &
        & e_minus(3, npoints), v_scratch(npoints)
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), parameter :: delta = 1d-5

    local_coords = coordinates
    local_coords(1, :) = local_coords(1, :) + delta
    call build_e_dense(multipoles, cm, mmax, nm, v_scratch, local_coords, &
        & npoints, e_plus, ddx_error)

    local_coords = coordinates
    local_coords(1, :) = local_coords(1, :) - delta
    call build_e_dense(multipoles, cm, mmax, nm, v_scratch, local_coords, &
        & npoints, e_minus, ddx_error)

    num_field_gradient(1, :, :) = - (e_plus - e_minus)/(2.0d0*delta)

    local_coords = coordinates
    local_coords(2, :) = local_coords(2, :) + delta
    call build_e_dense(multipoles, cm, mmax, nm, v_scratch, local_coords, &
        & npoints, e_plus, ddx_error)

    local_coords = coordinates
    local_coords(2, :) = local_coords(2, :) - delta
    call build_e_dense(multipoles, cm, mmax, nm, v_scratch, local_coords, &
        & npoints, e_minus, ddx_error)

    num_field_gradient(2, :, :) = - (e_plus - e_minus)/(2.0d0*delta)

    local_coords = coordinates
    local_coords(3, :) = local_coords(3, :) + delta
    call build_e_dense(multipoles, cm, mmax, nm, v_scratch, local_coords, &
        & npoints, e_plus, ddx_error)

    local_coords = coordinates
    local_coords(3, :) = local_coords(3, :) - delta
    call build_e_dense(multipoles, cm, mmax, nm, v_scratch, local_coords, &
        & npoints, e_minus, ddx_error)

    num_field_gradient(3, :, :) = - (e_plus - e_minus)/(2.0d0*delta)

end subroutine numerical_field_gradient

end program test_multipolar_solutes

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_param_hamiltonian
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io_symbols, only : symbol_length
   use tblite_param_serde, only : serde_record
   use tblite_toml, only : toml_table, get_value, set_value, add_table
   implicit none
   private

   public :: hamiltonian_record, hamiltonian_mask, count

   character(len=*), parameter :: k_xtb = "xtb", k_ang(0:4) = ["s", "p", "d", "f", "g"], &
      & k_enscale = "enscale", k_shell = "shell", k_wexp = "wexp", k_cn = "cn", &
      & k_kpol = "kpol", k_kpair = "kpair"
   real(wp), parameter :: kpol_default = 2.0_wp

   type, extends(serde_record) :: hamiltonian_record
      character(len=symbol_length), allocatable :: sym(:)
      character(len=:), allocatable :: cn
      real(wp), allocatable :: kpair(:, :)
      real(wp) :: ksh(0:4, 0:4)
      real(wp) :: kpol
      real(wp) :: enscale
      real(wp) :: wexp
      integer :: lmax
   contains
      generic :: load => load_from_array
      generic :: dump => dump_to_array
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Read parametrization data from parameter array
      procedure, private :: load_from_array
      !> Write parametrization data to parameter array
      procedure, private :: dump_to_array
   end type


   type :: hamiltonian_mask
   end type hamiltonian_mask


   interface count
      module procedure :: count_mask
   end interface count


contains


!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(hamiltonian_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   integer :: stat

   call get_value(table, k_xtb, child, requested=.false.)
   if (.not.associated(child)) then
      call fatal_error(error, "No entry for xTB Hamiltonian found")
      return
   end if

   call get_value(child, k_cn, self%cn, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for CN type in Hamiltonian")
      return
   end if

   call get_value(child, k_wexp, self%wexp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for Slater exponent weighting of Hamiltonian")
      return
   end if

   call get_value(child, k_kpol, self%kpol, kpol_default, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for scaling of non-valence Hamiltonian elements")
      return
   end if

   call get_ksh(self, child, error)
   if (allocated(error)) return

   call get_value(child, k_enscale, self%enscale, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for EN scaling parameter in Hamiltonian")
      return
   end if

   call get_kpair(self, child, error)
   if (allocated(error)) return

end subroutine load_from_toml


subroutine get_kpair(self, table, error)
   !> Instance of the parametrization data
   type(hamiltonian_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   character(len=:), allocatable :: key
   real(wp) :: tmp
   integer :: ir, jr

   call get_value(table, k_kpair, child)

   allocate(self%kpair(size(self%sym), size(self%sym)))
   self%kpair(:, :) = 1.0_wp

   do ir = 1, size(self%sym)
      do jr = 1, ir
         key = trim(self%sym(jr))//"-"//trim(self%sym(ir))
         if (.not.child%has_key(key)) key = trim(self%sym(ir))//"-"//trim(self%sym(jr))
         if (child%has_key(key)) then
            call get_value(child, key, tmp, 1.0_wp)
            self%kpair(jr, ir) = tmp
            self%kpair(ir, jr) = tmp
         end if
      end do
   end do

end subroutine get_kpair


subroutine get_ksh(self, table, error)
   !> Instance of the parametrization data
   type(hamiltonian_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   character(len=:), allocatable :: key
   real(wp), allocatable :: last, kav
   integer :: l, k, stat, lmax

   call get_value(table, k_shell, child, requested=.false.)
   if (associated(child)) then
      do l = 0, 4
         key = repeat(k_ang(l), 2)
         if (.not.child%has_key(key)) then
            if (allocated(last)) then
               self%ksh(l, l) = last
               cycle
            end if
            call fatal_error(error, "No entry for "//key//"-shell pair scaling parameter")
            exit
         end if
         call get_value(child, key, self%ksh(l, l), stat=stat)
         if (stat /= 0) then
            call fatal_error(error, "Cannot read "//key//"-shell pair scaling parameter")
            exit
         end if
         if (stat == 0) then
            last = self%ksh(l, l)
            lmax = l
         end if
      end do
      if (allocated(error)) return

      do l = 0, 4
         do k = 0, l-1
            key = k_ang(k)//k_ang(l)
            kav = 0.5_wp * (self%ksh(k, k) + self%ksh(l, l))
            call get_value(child, key, self%ksh(k, l), kav, stat=stat)
            if (stat /= 0) then
               call fatal_error(error, "Cannot read "//key//"-shell pair scaling parameter")
               exit
            end if
            self%ksh(l, k) = self%ksh(k, l)
         end do
      end do
   end if

   self%lmax = lmax

end subroutine get_ksh

!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(hamiltonian_record), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child, sub
   character(len=:), allocatable :: key
   integer :: l, k, ir, jr

   call add_table(table, k_xtb, child)
   call set_value(child, k_wexp, self%wexp)
   call set_value(child, k_kpol, self%kpol)
   call set_value(child, k_enscale, self%enscale)
   if (allocated(self%cn)) call set_value(child, k_cn, self%cn)
   call add_table(child, k_shell, sub)
   do l = 0, self%lmax
      call set_value(sub, repeat(k_ang(l), 2), self%ksh(l, l))
   end do
   do l = 0, self%lmax
      do k = 0, l-1
         if (abs(self%ksh(k, l) - (self%ksh(l, l) + self%ksh(k, k))/2) > epsilon(1.0_wp)) then
            call set_value(sub, k_ang(k)//k_ang(l), self%ksh(k, l))
         end if
      end do
   end do

   if (any(abs(self%kpair - 1.0_wp) > epsilon(1.0_wp))) then
      call add_table(child, k_kpair, sub)
      do ir = 1, size(self%sym)
         do jr = 1, ir
            if (abs(self%kpair(jr, ir) - 1.0_wp) > epsilon(1.0_wp)) then
               key = trim(self%sym(ir))//"-"//trim(self%sym(jr))
               call set_value(sub, key, self%kpair(jr, ir))
            end if
         end do
      end do
   end if
end subroutine dump_to_toml


!> Read parametrization data from parameter array
subroutine load_from_array(self, array, offset, base, mask, error)
   class(hamiltonian_record), intent(inout) :: self
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: offset
   type(hamiltonian_record), intent(in) :: base
   type(hamiltonian_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   select type(self)
   type is (hamiltonian_record)
      self = base
   end select

end subroutine load_from_array

!> Write parametrization data to parameter array
subroutine dump_to_array(self, array, offset, mask, error)
   class(hamiltonian_record), intent(in) :: self
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: offset
   type(hamiltonian_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

end subroutine dump_to_array

elemental function count_mask(mask) result(ncount)
   type(hamiltonian_mask), intent(in) :: mask
   integer :: ncount
   ncount = 0
end function count_mask


end module tblite_param_hamiltonian

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/xtb/singlepoint.f90
!> Provides main entry point for performing single point calculations with
!> a #xtb_calculator instance.

!> Implementation of the single point calculation for a self-consistent
!> extended tight-binding Hamiltonian.
module tblite_xtb_singlepoint
   use mctc_env, only : wp, error_type, fatal_error, get_variable
   use mctc_io, only : structure_type
   use tblite_adjlist, only : adjacency_list, new_adjacency_list
   use tblite_basis_type, only : get_cutoff, basis_type
   use tblite_blas, only : gemv
   use tblite_container, only : container_cache
   use tblite_container_list, only : cache_list
   use tblite_context, only : context_type, escape
   use tblite_cutoff, only : get_lattice_points
   use tblite_integral_type, only : integral_type, new_integral
   use tblite_lapack_sygvr, only : sygvr_solver
   use tblite_output_format, only : format_string
   use tblite_results, only : results_type
   use tblite_scf, only : mixer_type, new_mixer, scf_info, next_scf, &
      & get_mixer_dimension, potential_type, new_potential
   use tblite_scf_mixer_input, only : scf_version_to_string
   use tblite_scf_solver, only : solver_type
   use tblite_timer, only : timer_type, format_time
   use tblite_wavefunction, only : wavefunction_type, get_density_matrix, &
      & get_alpha_beta_occupation, &
      & magnet_to_updown, updown_to_magnet
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_h0, only : get_selfenergy, get_hamiltonian, get_occupation, &
      & get_hamiltonian_gradient
   use tblite_post_processing_type, only : collect_containers_caches
   use tblite_post_processing_list, only : post_processing_list
   implicit none
   private

   public :: xtb_singlepoint

   real(wp), parameter :: cn_cutoff = 25.0_wp


   character(len=*), parameter :: real_format = "(es20.13)"
   character(len=25), parameter :: &
      label_halogen = "halogen bonding energy", &
      label_repulsion = "repulsion energy", &
      label_dispersion = "dispersion energy", &
      label_other = "interaction energy", &
      label_electrons = "number of electrons", &
      label_cutoff = "integral cutoff", &
      label_electronic = "electronic energy", &
      label_total = "total energy"

contains


!> Entry point for performing single point calculation using the xTB calculator
subroutine xtb_singlepoint(ctx, mol, calc, wfn, accuracy, energy, gradient, sigma, &
   & verbosity, results, post_process)
   !> Calculation context
   type(context_type), intent(inout) :: ctx
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Single-point calculator
   type(xtb_calculator), intent(in) :: calc
   !> Wavefunction data
   type(wavefunction_type), intent(inout) :: wfn
   !> Accuracy for computation
   real(wp), intent(in) :: accuracy
   !> Total energy
   real(wp), intent(out) :: energy
   !> Gradient with respect to cartesian coordinates
   real(wp), contiguous, intent(out), optional :: gradient(:, :)
   !> Strain derivatives with respect to strain deformations
   real(wp), contiguous, intent(out), optional :: sigma(:, :)
   !> Verbosity level of output
   integer, intent(in), optional :: verbosity
   !> Container for storing additional results
   type(results_type), intent(out), optional :: results
   !> List of post-processing methods
   type(post_processing_list), intent(inout), optional :: post_process
   
   logical :: grad, converged, econverged, pconverged, tconverged
   integer :: prlevel
   real(wp) :: econv, pconv, cutoff, elast, nel, target_kt, elevated_kt, anneal_fraction
   real(wp) :: pnorm
   integer :: anneal_hold, anneal_steps
   integer, parameter :: default_anneal_hold = 50, default_anneal_steps = 50
   real(wp), allocatable :: energies(:), edisp(:), erep(:), exbond(:), eint(:), eelec(:)
   real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :), dEdcn(:)
   real(wp), allocatable :: selfenergy(:), dsedcn(:), lattr(:, :), wdensity(:, :, :)
   type(integral_type) :: ints
   type(potential_type) :: pot
   type(container_cache), allocatable :: ccache, dcache, icache, hcache, rcache
   class(mixer_type), allocatable :: mixer
   type(timer_type) :: timer
   type(error_type), allocatable :: error
   type(scf_info) :: info
   class(solver_type), allocatable :: solver
   type(adjacency_list) :: list
   type(cache_list), allocatable :: caches
   
   integer :: iscf, spin

   call timer%push("total")

   if (present(verbosity)) then
      prlevel = verbosity
   else
      prlevel = ctx%verbosity
   end if

   econv = 1.e-6_wp*accuracy
   pconv = 2.e-5_wp*accuracy

   grad = present(gradient) .and. present(sigma)

   allocate(energies(mol%nat), source=0.0_wp)
   allocate(erep(mol%nat), source=0.0_wp)
   allocate(edisp(mol%nat), source=0.0_wp)
   allocate(eint(mol%nat), source=0.0_wp)
   allocate(exbond(mol%nat), source=0.0_wp)
   if (grad) then
      gradient(:, :) = 0.0_wp
      sigma(:, :) = 0.0_wp
   end if

   call get_occupation(mol, calc%bas, calc%h0, wfn%nocc, wfn%n0at, wfn%n0sh)
   nel = sum(wfn%n0at) - mol%charge
   if (mod(mol%uhf, 2) == mod(nint(nel), 2)) then
      wfn%nuhf = mol%uhf
   else
      if (mol%uhf /= 0) then
         call fatal_error(error, "Total number of electrons ("//format_string(nint(nel), "(i0)")//") and "//&
            & "number unpaired electrons ("//format_string(mol%uhf, "(i0)")//") is not compatible")
         call ctx%set_error(error)
         return
      end if
      wfn%nuhf = mod(nint(nel), 2)
   end if
   call get_alpha_beta_occupation(wfn%nocc, wfn%nuhf, wfn%nel(1), wfn%nel(2))

   if (allocated(calc%halogen)) then
      call timer%push("halogen")
      allocate(hcache)
      call calc%halogen%update(mol, hcache)
      call calc%halogen%get_engrad(mol, hcache, exbond, gradient, sigma)
      if (prlevel > 1) &
         call ctx%message(label_halogen // format_string(sum(exbond), real_format) // " Eh")
      energies(:) = energies + exbond
      call timer%pop
   end if

   if (allocated(calc%repulsion)) then
      call timer%push("repulsion")
      allocate(rcache)
      call calc%repulsion%update(mol, rcache)
      call calc%repulsion%get_engrad(mol, rcache, erep, gradient, sigma)
      if (prlevel > 1) &
         call ctx%message(label_repulsion // format_string(sum(erep), real_format) // " Eh")
      energies(:) = energies + erep
      call timer%pop
   end if

   if (allocated(calc%dispersion)) then
      call timer%push("dispersion")
      allocate(dcache)
      call calc%dispersion%update(mol, dcache)
      call calc%dispersion%get_engrad(mol, dcache, edisp, gradient, sigma)
      if (prlevel > 1) &
         call ctx%message(label_dispersion // format_string(sum(edisp), real_format) // " Eh")
      energies(:) = energies + edisp
      call timer%pop
   end if

   if (allocated(calc%interactions)) then
      call timer%push("interactions")
      allocate(icache)
      call calc%interactions%update(mol, icache)
      call calc%interactions%get_engrad(mol, icache, eint, gradient, sigma)
      if (prlevel > 1) &
         call ctx%message(label_other // format_string(sum(eint), real_format) // " Eh")
      energies(:) = energies + eint
      call timer%pop
   end if

   call new_potential(pot, mol, calc%bas, wfn%nspin)
   if (allocated(calc%coulomb)) then
      allocate(ccache)
      call timer%push("coulomb")
      call calc%coulomb%update(mol, ccache)
      call timer%pop
   end if

   if (prlevel > 1) &
      call ctx%message(label_electrons // format_string(wfn%nocc, real_format) // " e")

   call timer%push("hamiltonian")
   if (allocated(calc%ncoord)) then
      allocate(cn(mol%nat))
      if (grad) then
         allocate(dcndr(3, mol%nat, mol%nat), dcndL(3, 3, mol%nat))
      end if
      call calc%ncoord%get_cn(mol, cn, dcndr, dcndL)
   end if

   allocate(selfenergy(calc%bas%nsh), dsedcn(calc%bas%nsh))
   call get_selfenergy(calc%h0, mol%id, calc%bas%ish_at, calc%bas%nsh_id, cn=cn, &
      & selfenergy=selfenergy, dsedcn=dsedcn)

   cutoff = get_cutoff(calc%bas, accuracy)
   call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)
   call new_adjacency_list(list, mol, lattr, cutoff)

   if (prlevel > 1) then
      call ctx%message(label_cutoff // format_string(cutoff, real_format) // " bohr")
      call ctx%message("")
   end if

   call new_integral(ints, calc%bas%nao)
   call get_hamiltonian(mol, lattr, list, calc%bas, calc%h0, selfenergy, &
      & ints%overlap, ints%dipole, ints%quadrupole, ints%hamiltonian)

   call ctx%new_solver(solver, ints%overlap, wfn%nel, wfn%kt)
   target_kt = wfn%kt
   elevated_kt = target_kt
   anneal_hold = default_anneal_hold
   anneal_steps = default_anneal_steps
   if (allocated(calc%mixer_input%anneal)) then
      elevated_kt = calc%mixer_input%anneal%initial_kt
      anneal_hold = max(0, calc%mixer_input%anneal%hold)
      anneal_steps = max(0, calc%mixer_input%anneal%cycles)
   end if
   call timer%pop

   call timer%push("scc")
   allocate(eelec(mol%nat), source=0.0_wp)
   iscf = 0
   converged = .false.
   info = calc%variable_info()

   if (prlevel > 1) then
      call ctx%message(scf_version_to_string(calc%mixer_input%scf))
      call ctx%message("Mixer memory             " // format_string(calc%mixer_input%memory, "(i16)"))
      call ctx%message("Mixer damping            " // format_string(calc%mixer_input%damping, real_format))
      if (allocated(calc%mixer_input%anneal)) then
      call ctx%message("Annealing initial kt     " // format_string(elevated_kt, real_format) // " Eh")
      call ctx%message("Annealing hold cycles    " // format_string(anneal_hold, "(i16)"))
      call ctx%message("Annealing cycles         " // format_string(anneal_steps, "(i16)"))
      end if
   end if
   call new_mixer(mixer, calc%mixer_input, &
      & wfn%nspin*get_mixer_dimension(mol, calc%bas, info), error)
   if (allocated(error)) then
      call ctx%set_error(error)
      return
   end if

   if (prlevel > 0) then
      call ctx%message(repeat("-", 60))
      call ctx%message("  cycle        total energy    energy error   density error")
      call ctx%message(repeat("-", 60))
   end if
   do while(.not.converged .and. iscf < calc%max_iter)
      elast = sum(eelec)
      if (elevated_kt > target_kt) then
         if (iscf < anneal_hold) then
            wfn%kt = elevated_kt
         else if (anneal_steps > 0 .and. iscf < anneal_hold + anneal_steps) then
            anneal_fraction = real(iscf - anneal_hold + 1, wp)/real(anneal_steps, wp)
            wfn%kt = elevated_kt + anneal_fraction*(target_kt - elevated_kt)
         else
            wfn%kt = target_kt
         end if
         solver%kt = wfn%kt
      end if
      call next_scf(iscf, mol, calc%bas, wfn, solver, mixer, info, &
         & calc%coulomb, calc%dispersion, calc%interactions, ints, pot, &
         & ccache, dcache, icache, eelec, error)
      econverged = abs(sum(eelec) - elast) < econv
      pnorm = mixer%get_error()
      pconverged = pnorm < pconv
      tconverged = wfn%kt <= target_kt
      converged = econverged .and. pconverged .and. tconverged
      if (prlevel > 0) then
         call ctx%message(format_string(iscf, "(i7)") // &
            & format_string(sum(eelec + energies), "(g24.13)") // &
            & escape(merge(ctx%terminal%green, ctx%terminal%red, econverged)) // &
            & format_string(sum(eelec) - elast, "(es16.7)") // &
            & escape(merge(ctx%terminal%green, ctx%terminal%red, pconverged)) // &
            & format_string(pnorm, "(es16.7)") // &
            & escape(ctx%terminal%reset))
      end if
      if (allocated(error)) then
         call ctx%set_error(error)
         exit
      end if
   end do
   wfn%kt = target_kt
   solver%kt = target_kt
   if (prlevel > 0) then
      call ctx%message(repeat("-", 60))
      call ctx%message("")
   end if
   energies(:) = energies + eelec
   energy = sum(energies)
   if (present(results)) then
      results%energies = energies
   end if
   call timer%pop

   if (prlevel > 1) then
      call ctx%message(label_electronic // format_string(sum(eelec), real_format) // " Eh")
      call ctx%message(label_total // format_string(sum(energies), real_format) // " Eh")
      call ctx%message("")
   end if

   if (ctx%failed()) then
      call ctx%delete_solver(solver)
      return
   end if

   if (grad) then
      if (allocated(calc%coulomb)) then
         call timer%push("coulomb")
         call calc%coulomb%get_gradient(mol, ccache, wfn, gradient, sigma)
         call timer%pop
      end if

      if (allocated(calc%dispersion)) then
         call timer%push("dispersion")
         call calc%dispersion%get_gradient(mol, dcache, wfn, gradient, sigma)
         call timer%pop
      end if

      if (allocated(calc%interactions)) then
         call timer%push("interactions")
         call calc%interactions%get_gradient(mol, icache, wfn, gradient, sigma)
         call timer%pop
      end if

      call timer%push("hamiltonian")
      allocate(dEdcn(mol%nat))
      dEdcn(:) = 0.0_wp

      allocate(wdensity(calc%bas%nao, calc%bas%nao, wfn%nspin))
      call solver%get_wdensity(wfn%coeff, ints%overlap, wfn%emo, wfn%focc, wdensity, error)
      call updown_to_magnet(wfn%density)
      call updown_to_magnet(wdensity)
      call get_hamiltonian_gradient(mol, lattr, list, calc%bas, calc%h0, selfenergy, &
         & dsedcn, pot, wfn%density, wdensity, dEdcn, gradient, sigma)
      call magnet_to_updown(wfn%density)

      if (allocated(dcndr)) then
         call gemv(dcndr, dEdcn, gradient, beta=1.0_wp)
      end if
      if (allocated(dcndL)) then
         call gemv(dcndL, dEdcn, sigma, beta=1.0_wp)
      end if
      call timer%pop
   end if

   call ctx%delete_solver(solver)
   if (ctx%failed()) return

   if (present(post_process) .and. present(results)) then
      call timer%push("post processing")
      allocate(caches)
      call collect_containers_caches(rcache, ccache, hcache, dcache, icache, calc, caches)
      allocate(results%dict)
      call post_process%compute(mol, wfn, ints, calc, caches, ctx, timer, prlevel, results)
      if (prlevel > 1) call ctx%message(post_process%info(prlevel, " | "))
      call post_process%print_timer(timer, prlevel, ctx)
      deallocate(caches)
      call timer%pop()
   else if (present(post_process)) then
      call fatal_error(error, "Post-processing list provided without results container")
      call ctx%set_error(error)
   end if

   if (calc%save_integrals .and. present(results)) then
      call move_alloc(ints%overlap, results%overlap)
      call move_alloc(ints%hamiltonian, results%hamiltonian)
   end if

   block
      integer :: it
      real(wp) :: ttime, stime
      character(len=*), parameter :: label(*) = [character(len=20):: &
         & "repulsion", "halogen", "dispersion", "interactions", &
         & "coulomb", "hamiltonian", "post processing", "scc"]
      if (prlevel > 0) then
         ttime = timer%get("total")
         call ctx%message(" total:"//repeat(" ", 16)//format_time(ttime))
      end if
      if (prlevel > 1) then
         do it = 1, size(label)
            stime = timer%get(label(it))
            if (stime <= epsilon(0.0_wp)) cycle
            call ctx%message(" - "//label(it)//format_time(stime) &
               & //" ("//format_string(int(stime/ttime*100), '(i3)')//"%)")
         end do
         call ctx%message("")
      end if
   end block

   if (.not.converged) then
      call fatal_error(error, "SCF not converged in "//format_string(iscf, '(i0)')//" cycles")
      call ctx%set_error(error)
   end if


end subroutine xtb_singlepoint

end module tblite_xtb_singlepoint

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Helper tools for dealing with Ewald summation related calculations
module tblite_coulomb_ewald
   use mctc_env, only : wp
   use mctc_io_constants, only : pi
   use mctc_io_math, only : matdet_3x3, matinv_3x3
   implicit none
   private

   public :: get_alpha, get_dir_cutoff, get_rec_cutoff

   real(wp), parameter :: twopi = 2 * pi
   real(wp), parameter :: sqrtpi = sqrt(pi)
   real(wp), parameter :: eps = sqrt(epsilon(0.0_wp))

   !> Evaluator for interaction term
   type, abstract :: term_type
   contains
      !> Interaction at specified distance
      procedure(get_value), deferred :: get_value
   end type term_type

   abstract interface
      !> Interaction at specified distance
      pure function get_value(self, dist, alpha, vol) result(val)
         import :: term_type, wp
         !> Instance of interaction
         class(term_type), intent(in) :: self
         !> Distance between the two atoms
         real(wp), intent(in) :: dist
         !> Parameter of the Ewald summation
         real(wp), intent(in) :: alpha
         !> Volume of the real space unit cell
         real(wp), intent(in) :: vol
         !> Value of the interaction
         real(wp) :: val
      end function get_value
   end interface

   !> Real space Coulombic interaction 1/R
   type, extends(term_type) :: dir_term
   contains
      procedure :: get_value => dir_value
   end type dir_term

   !> Reciprocal space Coulombic interaction 1/R in 3D
   type, extends(term_type) :: rec_3d_term
   contains
      procedure :: get_value => rec_3d_value
   end type rec_3d_term

   !> Real space Coulombic interaction 1/R^2
   type, extends(term_type) :: dir_mp_term
   contains
      procedure :: get_value => dir_mp_value
   end type dir_mp_term

   !> Reciprocal space Coulombic interaction 1/R^2 in 3D
   type, extends(term_type) :: rec_3d_mp_term
   contains
      procedure :: get_value => rec_3d_mp_value
   end type rec_3d_mp_term

contains


!> Convenience interface to determine Ewald splitting parameter
subroutine get_alpha(lattice, alpha, multipole)
   !> Lattice vectors
   real(wp), intent(in) :: lattice(:, :)
   !> Estimated Ewald splitting parameter
   real(wp), intent(out) :: alpha
   !> Multipole expansion is used
   logical, intent(in) :: multipole

   real(wp) :: vol, rec_lat(3, 3)
   class(term_type), allocatable :: dirv, recv

   vol = abs(matdet_3x3(lattice))
   rec_lat = twopi*transpose(matinv_3x3(lattice))
   if (multipole) then
      dirv = dir_mp_term()
      recv = rec_3d_mp_term()
   else
      dirv = dir_term()
      recv = rec_3d_term()
   end if

   call search_alpha(lattice, rec_lat, vol, eps, dirv, recv, alpha)
end subroutine get_alpha


!> Get optimal alpha-parameter for the Ewald summation by finding alpha, where
!> decline of real and reciprocal part of Ewald are equal.
subroutine search_alpha(lattice, rec_lat, volume, tolerance, dirv, recv, alpha)
   !> Lattice vectors
   real(wp), intent(in) :: lattice(:,:)
   !> Reciprocal vectors
   real(wp), intent(in) :: rec_lat(:,:)
   !> Volume of the unit cell
   real(wp), intent(in) :: volume
   !> Tolerance for difference in real and rec. part
   real(wp), intent(in) :: tolerance
   !> Real-space interaction term
   class(term_type), intent(in) :: dirv
   !> Reciprocal space interaction term
   class(term_type), intent(in) :: recv
   !> Optimal alpha
   real(wp), intent(out) :: alpha

   real(wp) :: alpl, alpr, rlen, dlen, diff
   real(wp), parameter :: alpha0 = sqrt(epsilon(0.0_wp))
   integer, parameter :: niter = 30
   integer :: ibs, stat

   rlen = sqrt(minval(sum(rec_lat(:,:)**2, dim=1)))
   dlen = sqrt(minval(sum(lattice(:,:)**2, dim=1)))

   stat = 0
   alpha = alpha0
   diff = rec_dir_diff(alpha, dirv, recv, rlen, dlen, volume)
   do while (diff < -tolerance .and. alpha <= huge(1.0_wp))
      alpha = 2.0_wp * alpha
      diff = rec_dir_diff(alpha, dirv, recv, rlen, dlen, volume)
   end do
   if (alpha > huge(1.0_wp)) then
      stat = 1
   elseif (alpha == alpha0) then
      stat = 2
   end if

   if (stat == 0) then
      alpl = 0.5_wp * alpha
      do while (diff < tolerance .and. alpha <= huge(1.0_wp))
         alpha = 2.0_wp * alpha
         diff = rec_dir_diff(alpha, dirv, recv, rlen, dlen, volume)
      end do
      if (alpha > huge(1.0_wp)) then
         stat = 3
      end if
   end if

   if (stat == 0) then
      alpr = alpha
      alpha = (alpl + alpr) * 0.5_wp
      ibs = 0
      diff = rec_dir_diff(alpha, dirv, recv, rlen, dlen, volume)
      do while (abs(diff) > tolerance .and. ibs <= niter)
         if (diff < 0) then
            alpl = alpha
         else
            alpr = alpha
         end if
         alpha = (alpl + alpr) * 0.5_wp
         diff = rec_dir_diff(alpha, dirv, recv, rlen, dlen, volume)
         ibs = ibs + 1
      end do
      if (ibs > niter) then
         stat = 4
      end if
   end if

   if (stat /= 0) then
      alpha = 0.25_wp
   end if

end subroutine search_alpha


!> Return cutoff for reciprocal contributions
function get_rec_cutoff(alpha, volume, conv) result(x)
   !> Parameter of Ewald summation
   real(wp), intent(in) :: alpha
   !> Volume of the unit cell
   real(wp), intent(in) :: volume
   !> Tolerance value
   real(wp), intent(in) :: conv
   !> Magnitude of reciprocal vector
   real(wp) :: x

   class(term_type), allocatable :: term

   term = rec_3d_term()
   x = search_cutoff(term, alpha, volume, conv)

end function get_rec_cutoff


!> Return cutoff for real-space contributions
function get_dir_cutoff(alpha, conv) result(x)
   !> Parameter of Ewald summation
   real(wp), intent(in) :: alpha
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Magnitude of real-space vector
   real(wp) :: x

   real(wp), parameter :: volume = 0.0_wp
   class(term_type), allocatable :: term

   term = dir_term()
   x = search_cutoff(term, alpha, volume, conv)

end function get_dir_cutoff


!> Search for cutoff value of interaction term
function search_cutoff(term, alpha, volume, conv) result(x)
   !> Interaction term
   class(term_type), intent(in) :: term
   !> Parameter of Ewald summation
   real(wp), intent(in) :: alpha
   !> Volume of the unit cell
   real(wp), intent(in) :: volume
   !> Tolerance value
   real(wp), intent(in) :: conv
   !> Magnitude of reciprocal vector
   real(wp) :: x

   real(wp), parameter :: init = sqrt(epsilon(0.0_wp))
   integer, parameter :: miter = 30
   real(wp) :: xl, xr, yl, yr, y
   integer :: iter

   x = init
   y = term%get_value(x, alpha, volume)
   do while (y > conv .and. x <= huge(1.0_wp))
      x = 2.0_wp * x
      y = term%get_value(x, alpha, volume)
   end do

   xl = 0.5_wp * x
   yl = term%get_value(xl, alpha, volume)
   xr = x
   yr = y

   do iter = 1, miter
      if (yl - yr <= conv) exit
      x = 0.5_wp * (xl + xr)
      y = term%get_value(x, alpha, volume)
      if (y >= conv) then
         xl = x
         yl = y
      else
         xr = x
         yr = y
      end if
   end do

end function search_cutoff


!> Returns the difference in the decrease of the real and reciprocal parts of the
!> Ewald sum. In order to make the real space part shorter than the reciprocal
!> space part, the values are taken at different distances for the real and the
!> reciprocal space parts.
pure function rec_dir_diff(alpha, dirv, recv, rlen, dlen, volume) result(diff)
   !> Parameter for the Ewald summation
   real(wp), intent(in) :: alpha
   !> Procedure pointer to real-space routine
   class(term_type), intent(in) :: dirv
   !> Procedure pointer to reciprocal routine
   class(term_type), intent(in) :: recv
   !> Length of the shortest reciprocal space vector in the sum
   real(wp), intent(in) :: rlen
   !> Length of the shortest real space vector in the sum
   real(wp), intent(in) :: dlen
   !> Volume of the real space unit cell
   real(wp), intent(in) :: volume
   !> Difference between changes in the two terms
   real(wp) :: diff

   diff = ((recv%get_value(4*rlen, alpha, volume) - recv%get_value(5*rlen, alpha, volume))) &
      & - (dirv%get_value(2*dlen, alpha, volume) - dirv%get_value(3*dlen, alpha, volume))

end function rec_dir_diff


!> Returns the max. value of a term in the reciprocal space part of the Ewald
!> summation for a given vector length.
pure function rec_3d_value(self, dist, alpha, vol) result(rval)
   !> Instance of interaction
   class(rec_3d_term), intent(in) :: self
   !> Length of the reciprocal space vector
   real(wp), intent(in) :: dist
   !> Parameter of the Ewald summation
   real(wp), intent(in) :: alpha
   !> Volume of the real space unit cell
   real(wp), intent(in) :: vol
   !> Reciprocal term
   real(wp) :: rval

   rval = 4.0_wp*pi*(exp(-0.25_wp*dist*dist/(alpha**2))/(vol*dist*dist))

end function rec_3d_value


!> Returns the max. value of a term in the reciprocal space part of the Ewald
!> summation for a given vector length.
pure function rec_3d_mp_value(self, dist, alpha, vol) result(rval)
   !> Instance of interaction
   class(rec_3d_mp_term), intent(in) :: self
   !> Length of the reciprocal space vector
   real(wp), intent(in) :: dist
   !> Parameter of the Ewald summation
   real(wp), intent(in) :: alpha
   !> Volume of the real space unit cell
   real(wp), intent(in) :: vol
   !> Reciprocal term
   real(wp) :: rval

   real(wp) :: g2

   g2 = dist*dist

   rval = 4.0_wp*pi*(exp(-0.25_wp*g2/(alpha**2))/vol)

end function rec_3d_mp_value


!> Direct space interaction at specified distance
pure function dir_value(self, dist, alpha, vol) result(val)
   !> Instance of interaction
   class(dir_term), intent(in) :: self
   !> Distance between the two atoms
   real(wp), intent(in) :: dist
   !> Parameter of the Ewald summation
   real(wp), intent(in) :: alpha
   !> Volume of the real space unit cell
   real(wp), intent(in) :: vol
   !> Value of the interaction
   real(wp) :: val

   val = erfc(alpha*dist)/dist
end function dir_value

!> Direct space interaction at specified distance
pure function dir_mp_value(self, dist, alpha, vol) result(val)
   !> Instance of interaction
   class(dir_mp_term), intent(in) :: self
   !> Distance between the two atoms
   real(wp), intent(in) :: dist
   !> Parameter of the Ewald summation
   real(wp), intent(in) :: alpha
   !> Volume of the real space unit cell
   real(wp), intent(in) :: vol
   !> Value of the interaction
   real(wp) :: val

   real(wp) :: arg

   arg = alpha * dist

   val = (2/sqrtpi*arg*exp(-arg*arg) + erfc(arg))/dist**3
end function dir_mp_value

end module tblite_coulomb_ewald

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_xtb_calculator
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type
   use tblite_basis_ortho, only : orthogonalize
   use tblite_basis_type, only : basis_type, new_basis, cgto_type
   use tblite_basis_slater, only : slater_to_gauss
   use tblite_classical_halogen, only : halogen_correction, new_halogen_correction
   use tblite_container, only : container_type, container_list
   use tblite_coulomb_charge, only : coulomb_kernel, new_gamma_coulomb, gamma_coulomb, &
      & new_effective_coulomb, effective_coulomb, average_interface, &
      & harmonic_average, arithmetic_average, geometric_average
   use tblite_coulomb_multipole, only : new_damped_multipole
   use tblite_coulomb_thirdorder, only : new_onsite_thirdorder
   use tblite_disp, only : dispersion_type, d4_dispersion, new_d4_dispersion, &
      & d3_dispersion, new_d3_dispersion
   use tblite_ncoord, only : ncoord_type, new_ncoord
   use tblite_param, only : param_record
   use tblite_repulsion, only : new_repulsion
   use tblite_repulsion_effective, only : tb_repulsion
   use tblite_xtb_coulomb, only : tb_coulomb
   use tblite_xtb_h0, only : tb_hamiltonian, new_hamiltonian
   use tblite_xtb_spec, only : tb_h0spec
   implicit none
   private

   public :: xtb_calculator, new_xtb_calculator
   public :: param_h0spec

   real(wp), parameter :: mixer_damping_default = 0.4_wp
   integer, parameter :: max_iter_default = 250

   type :: xtb_calculator
      type(basis_type) :: bas
      type(tb_hamiltonian) :: h0
      class(ncoord_type), allocatable :: ncoord
      type(tb_repulsion), allocatable :: repulsion
      type(tb_coulomb), allocatable :: coulomb
      type(halogen_correction), allocatable :: halogen
      class(dispersion_type), allocatable :: dispersion
      real(wp) :: mixer_damping = mixer_damping_default
      integer :: max_iter = max_iter_default
      logical :: save_integrals = .false.
      !> List of additional interaction containers
      type(container_list), allocatable :: interactions
   contains
      !> Get information about density dependent quantities used in the energy
      procedure :: variable_info
      !> Information on calculator
      procedure :: info
      !> Add an interaction container
      procedure :: push_back
      !> Remove an interaction container
      procedure :: pop
   end type xtb_calculator


   !> Specification of the
   type, extends(tb_h0spec) :: param_h0spec
      type(param_record), pointer :: param => null()
      integer, pointer :: irc(:) => null()
      logical, allocatable :: valence(:, :)
   contains
      !> Generator for the self energy / atomic levels of the Hamiltonian
      procedure :: get_selfenergy
      !> Generator for the coordination number dependent shift of the self energy
      procedure :: get_cnshift
      !> Generator for the enhancement factor to for scaling Hamiltonian elements
      procedure :: get_hscale
      !> Generator for the polynomial parameters for the distant dependent scaling
      procedure :: get_shpoly
      !> Generator for the reference occupation numbers of the atoms
      procedure :: get_reference_occ
   end type param_h0spec

   interface param_h0spec
      module procedure :: new_param_h0spec
   end interface param_h0spec


contains


subroutine new_xtb_calculator(calc, mol, param, error)
   !> Instance of the xTB calculator
   type(xtb_calculator), intent(out) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: isp
   integer, allocatable :: irc(:)

   allocate(irc(mol%nid))

   do isp = 1, mol%nid
      call param%get(mol%sym(isp), mol%num(isp), irc(isp))
      if (irc(isp) == 0) then
         call fatal_error(error, "No entry in parametrization for element "//mol%sym(isp))
         exit
      end if
   end do
   if (allocated(error)) return

   call add_basis(calc, mol, param, irc)
   call add_ncoord(calc, mol, param)
   call add_hamiltonian(calc, mol, param, irc)
   call add_repulsion(calc, mol, param, irc)
   call add_halogen(calc, mol, param, irc)
   call add_dispersion(calc, mol, param)
   call add_coulomb(calc, mol, param, irc)

end subroutine new_xtb_calculator


subroutine add_basis(calc, mol, param, irc)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)

   integer :: isp, ir, ish, stat, ng, il
   integer, allocatable :: nsh_id(:)
   integer :: ang_idx(0:4), ortho(10)
   type(cgto_type), allocatable :: cgto(:, :)

   nsh_id = param%record(irc)%nsh
   allocate(cgto(maxval(nsh_id), mol%nid))
   do isp = 1, mol%nid
      ang_idx = 0
      ortho = 0
      ir = irc(isp)
      do ish = 1, nsh_id(isp)
         il = param%record(ir)%lsh(ish)
         ng = param%record(ir)%ngauss(ish)
         if (ang_idx(il) > 0) then
            ortho(ish) = ang_idx(il)
         else
            ang_idx(il) = ish
         end if
         call slater_to_gauss(ng, param%record(ir)%pqn(ish), il, &
            & param%record(ir)%slater(ish), cgto(ish, isp), .true., stat)
      end do

      do ish = 1, nsh_id(isp)
         if (ortho(ish) > 0) then
            call orthogonalize(cgto(ortho(ish), isp), cgto(ish, isp))
         end if
      end do
   end do

   call new_basis(calc%bas, mol, nsh_id, cgto, 1.0_wp)

end subroutine add_basis


subroutine add_ncoord(calc, mol, param)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param

   if (allocated(param%hamiltonian%cn)) then
      call new_ncoord(calc%ncoord, mol, cn_type=param%hamiltonian%cn)
   end if
end subroutine add_ncoord


subroutine add_hamiltonian(calc, mol, param, irc)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)

   call new_hamiltonian(calc%h0, mol, calc%bas, new_param_h0spec(mol, param, irc))
end subroutine add_hamiltonian


subroutine add_dispersion(calc, mol, param)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param

   type(d4_dispersion), allocatable :: d4
   type(d3_dispersion), allocatable :: d3

   if (.not.allocated(param%dispersion)) return
   associate(par => param%dispersion)
      if (par%d3) then
         allocate(d3)
         call new_d3_dispersion(d3, mol, s6=par%s6, s8=par%s8, a1=par%a1, a2=par%a2, s9=par%s9)
         call move_alloc(d3, calc%dispersion)
      else
         allocate(d4)
         call new_d4_dispersion(d4, mol, s6=par%s6, s8=par%s8, a1=par%a1, a2=par%a2, s9=par%s9)
         call move_alloc(d4, calc%dispersion)
      end if
   end associate
end subroutine add_dispersion

subroutine add_repulsion(calc, mol, param, irc)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)

   real(wp), allocatable :: alpha(:), zeff(:)
   real(wp), parameter :: rep_rexp = 1.0_wp

   if (.not.allocated(param%repulsion)) return
   allocate(calc%repulsion)
   alpha = param%record(irc)%alpha
   zeff = param%record(irc)%zeff
   call new_repulsion(calc%repulsion, mol, alpha, zeff, param%repulsion%kexp, &
      & param%repulsion%klight, rep_rexp)

end subroutine add_repulsion


subroutine add_halogen(calc, mol, param, irc)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)

   real(wp), allocatable :: bond_strength(:)

   if (.not.allocated(param%halogen)) return
   allocate(calc%halogen)
   bond_strength = param%record(irc)%xbond
   associate(par => param%halogen)
      call new_halogen_correction(calc%halogen, mol, par%damping, par%rscale, &
         & bond_strength)
   end associate
end subroutine add_halogen

subroutine add_coulomb(calc, mol, param, irc)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)

   real(wp), allocatable :: hardness(:, :), hubbard_derivs(:, :)
   real(wp), allocatable :: dkernel(:), qkernel(:), rad(:), vcn(:)
   procedure(average_interface), pointer :: average

   if (.not.any([allocated(param%charge), allocated(param%thirdorder), &
      & allocated(param%multipole)])) return
   allocate(calc%coulomb)

   if (allocated(param%charge)) then
      call get_shell_hardness(mol, param, irc, hardness)
      select case(param%charge%kernel)
      case(coulomb_kernel%effective)
         block
            type(effective_coulomb), allocatable :: es2
            allocate(es2)
            call get_average(param%charge%average, average)
            call new_effective_coulomb(es2, mol, param%charge%gexp, hardness, &
               & average, calc%bas%nsh_id)
            call move_alloc(es2, calc%coulomb%es2)
         end block
      case(coulomb_kernel%dftb_gamma)
         block
            type(gamma_coulomb), allocatable :: es2
            allocate(es2)
            call new_gamma_coulomb(es2, mol, hardness, calc%bas%nsh_id)
            call move_alloc(es2, calc%coulomb%es2)
         end block
      end select
   end if

   if (allocated(param%thirdorder)) then
      allocate(calc%coulomb%es3)
      if (param%thirdorder%shell) then
         call get_hubbard_derivs(mol, param, irc, hubbard_derivs)
         call new_onsite_thirdorder(calc%coulomb%es3, mol, hubbard_derivs, calc%bas%nsh_id)
      else
         allocate(hubbard_derivs(1, mol%nid))
         hubbard_derivs(1, :) = param%record(irc)%gam3
         call new_onsite_thirdorder(calc%coulomb%es3, mol, hubbard_derivs)
      end if
   end if

   if (allocated(param%multipole)) then
      allocate(calc%coulomb%aes2)
      dkernel = param%record(irc)%dkernel
      qkernel = param%record(irc)%qkernel
      rad = param%record(irc)%mprad
      vcn = param%record(irc)%mpvcn
      associate(par => param%multipole)
         call new_damped_multipole(calc%coulomb%aes2, mol, par%dmp3, par%dmp5, &
            & dkernel, qkernel, par%shift, par%kexp, par%rmax, rad, vcn)
      end associate
   end if

end subroutine add_coulomb


subroutine get_average(average_type, averager)
   character(len=*), intent(in) :: average_type
   procedure(average_interface), pointer, intent(out) :: averager
   select case(average_type)
   case default
      nullify(averager)
   case("harmonic")
      averager => harmonic_average
   case("geometric")
      averager => geometric_average
   case("arithmetic")
      averager => arithmetic_average
   end select
end subroutine get_average


subroutine get_shell_hardness(mol, param, irc, hardness)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)
   !> Shell resolved hardness parameters
   real(wp), allocatable, intent(out) :: hardness(:, :)

   integer :: isp, ir, ish, il

   allocate(hardness(maxval(param%record(irc)%nsh), mol%nid))
   hardness(:, :) = 0.0_wp
   do isp = 1, mol%nid
      ir = irc(isp)
      do ish = 1, param%record(ir)%nsh
         il = param%record(ir)%lsh(ish)
         hardness(ish, isp) = param%record(ir)%gam * param%record(ir)%lgam(ish)
      end do
   end do
end subroutine get_shell_hardness


subroutine get_hubbard_derivs(mol, param, irc, hubbard_derivs)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)
   !> Shell resolved Hubbard derivatives
   real(wp), allocatable, intent(out) :: hubbard_derivs(:, :)

   integer :: isp, ir, ish, il

   allocate(hubbard_derivs(maxval(param%record(irc)%nsh), mol%nid))
   hubbard_derivs(:, :) = 0.0_wp
   do isp = 1, mol%nid
      ir = irc(isp)
      do ish = 1, param%record(ir)%nsh
         il = param%record(ir)%lsh(ish)
         hubbard_derivs(ish, isp) = param%record(ir)%gam3 * param%thirdorder%ksh(il)
      end do
   end do
end subroutine get_hubbard_derivs


function new_param_h0spec(mol, param, irc) result(self)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), target, intent(in) :: param
   !> Record identifiers
   integer, target, intent(in) :: irc(:)
   !> Instance of the Hamiltonian specification
   type(param_h0spec) :: self

   integer :: isp, jsp, il, jl, ir, ish
   integer :: ang_idx(0:4)

   self%param => param
   self%irc => irc

   allocate(self%valence(maxval(param%record(irc)%nsh), mol%nid))
   do isp = 1, mol%nid
      ang_idx = 0
      ir = irc(isp)
      do ish = 1, param%record(ir)%nsh
         il = param%record(ir)%lsh(ish)
         self%valence(ish, isp) = ang_idx(il) == 0
         if (self%valence(ish, isp)) ang_idx(il) = ish
      end do
   end do
end function new_param_h0spec


!> Generator for the enhancement factor to for scaling Hamiltonian elements
subroutine get_hscale(self, mol, bas, hscale)
   !> Instance of the Hamiltonian specification
   class(param_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Scaling parameters for the Hamiltonian elements
   real(wp), intent(out) :: hscale(:, :, :, :)

   integer :: isp, jsp, izp, jzp, ish, jsh, il, jl, ir, jr
   real(wp) :: zi, zj, zij, den, enp, km

   hscale(:, :, :, :) = 0.0_wp

   associate(par => self%param%hamiltonian, record => self%param%record, irc => self%irc)
      do isp = 1, mol%nid
         izp = mol%num(isp)
         ir = irc(isp)
         do jsp = 1, mol%nid
            jzp = mol%num(jsp)
            jr = irc(jsp)
            den = (record(ir)%en - record(jr)%en)**2
            do ish = 1, bas%nsh_id(isp)
               il = bas%cgto(ish, isp)%ang
               do jsh = 1, bas%nsh_id(jsp)
                  jl = bas%cgto(jsh, jsp)%ang
                  zi = record(ir)%slater(ish)
                  zj = record(jr)%slater(jsh)
                  zij = (2*sqrt(zi*zj)/(zi+zj))**par%wexp
                  if (self%valence(ish, isp) .and. self%valence(jsh, jsp)) then
                     enp = 1.0_wp + par%enscale * den
                     km = par%kpair(jr, ir) * par%ksh(jl, il) * enp
                  else if (self%valence(ish, isp) .and. .not.self%valence(jsh, jsp)) then
                     km = 0.5_wp * (par%ksh(il, il) + par%kpol)
                  else if (.not.self%valence(ish, isp) .and. self%valence(jsh, jsp)) then
                     km = 0.5_wp * (par%ksh(jl, jl) + par%kpol)
                  else
                     km = par%kpol
                  end if
                  hscale(jsh, ish, jsp, isp) = zij * km
               end do
            end do
         end do
      end do
   end associate
end subroutine get_hscale


!> Generator for the self energy / atomic levels of the Hamiltonian
subroutine get_selfenergy(self, mol, bas, selfenergy)
   !> Instance of the Hamiltonian specification
   class(param_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Self energy / atomic levels
   real(wp), intent(out) :: selfenergy(:, :)

   integer :: isp, ir, ish

   selfenergy(:, :) = 0.0_wp

   associate(record => self%param%record, irc => self%irc)
      do isp = 1, mol%nid
         ir = irc(isp)
         do ish = 1, bas%nsh_id(isp)
            selfenergy(ish, isp) = record(ir)%levels(ish)
         end do
      end do
   end associate
end subroutine get_selfenergy


!> Generator of the coordination number dependent shift of the self energy
subroutine get_cnshift(self, mol, bas, kcn)
   !> Instance of the Hamiltonian specification
   class(param_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Coordination number dependent shift
   real(wp), intent(out) :: kcn(:, :)

   integer :: isp, ir, ish

   kcn(:, :) = 0.0_wp

   associate(record => self%param%record, irc => self%irc)
      do isp = 1, mol%nid
         ir = irc(isp)
         do ish = 1, bas%nsh_id(isp)
            kcn(ish, isp) = record(ir)%kcn(ish)
         end do
      end do
   end associate
end subroutine get_cnshift


!> Generator for the polynomial parameters for the distant dependent scaling
subroutine get_shpoly(self, mol, bas, shpoly)
   !> Instance of the Hamiltonian specification
   class(param_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Polynomial parameters for distant dependent scaleing
   real(wp), intent(out) :: shpoly(:, :)

   integer :: isp, ir, ish

   shpoly(:, :) = 0.0_wp

   associate(record => self%param%record, irc => self%irc)
      do isp = 1, mol%nid
         ir = irc(isp)
         do ish = 1, bas%nsh_id(isp)
            shpoly(ish, isp) = record(ir)%shpoly(ish)
         end do
      end do
   end associate
end subroutine get_shpoly


subroutine get_reference_occ(self, mol, bas, refocc)
   !> Instance of the Hamiltonian specification
   class(param_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Reference occupation numbers
   real(wp), intent(out) :: refocc(:, :)

   integer :: isp, ir, ish

   refocc(:, :) = 0.0_wp

   associate(record => self%param%record, irc => self%irc)
      do isp = 1, mol%nid
         ir = irc(isp)
         do ish = 1, bas%nsh_id(isp)
            refocc(ish, isp) = merge(record(ir)%refocc(ish), 0.0_wp, self%valence(ish, isp))
         end do
      end do
   end associate
end subroutine get_reference_occ


subroutine update(self, mol)
   class(xtb_calculator), intent(inout) :: self
   type(structure_type), intent(in) :: mol
end subroutine update


!> Add an interaction container
subroutine push_back(self, cont)
   !> Instance of the tight-binding calculator
   class(xtb_calculator), intent(inout) :: self
   !> Container to be added
   class(container_type), allocatable, intent(inout) :: cont

   if (.not.allocated(self%interactions)) allocate(self%interactions)

   call self%interactions%push_back(cont)
end subroutine push_back


!> Add a container
subroutine pop(self, cont, idx)
   !> Instance of the tight-binding calculator
   class(xtb_calculator), intent(inout) :: self
   !> Container to be removed
   class(container_type), allocatable, intent(out) :: cont
   !> Index to remove container from
   integer, intent(in), optional :: idx

   if (.not.allocated(self%interactions)) return

   call self%interactions%pop(cont, idx)
end subroutine pop


pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, max
   !> Instance of the electrostatic container
   class(xtb_calculator), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info()

   if (allocated(self%coulomb)) then
      info = max(info, self%coulomb%variable_info())
   end if

   if (allocated(self%dispersion)) then
      info = max(info, self%dispersion%variable_info())
   end if

   if (allocated(self%interactions)) then
      info = max(info, self%interactions%variable_info())
   end if

end function variable_info


!> Information on container
pure function info(self, verbosity, indent) result(str)
   !> Instance of the interaction container
   class(xtb_calculator), intent(in) :: self
   !> Verbosity level
   integer, intent(in) :: verbosity
   !> Indentation level
   character(len=*), intent(in) :: indent
   !> Information on the container
   character(len=:), allocatable :: str

   character(len=*), parameter :: nl = new_line('a')

   str = "xTB calculator"

   if (allocated(self%repulsion)) then
      str = str // nl // indent // self%repulsion%info(verbosity, indent)
   end if

   if (allocated(self%coulomb)) then
      str = str // nl // indent // self%coulomb%info(verbosity, indent)
   end if

   if (allocated(self%dispersion)) then
      str = str // nl // indent // self%dispersion%info(verbosity, indent)
   end if

   if (allocated(self%interactions)) then
      str = str // nl // indent // self%interactions%info(verbosity, indent)
   end if
end function info


end module tblite_xtb_calculator

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Base model for the extended tight binding hamiltonian
module tblite_wavefunction_type
   use mctc_env, only : wp
   use tblite_blas, only : gemm
   implicit none
   private

   public :: wavefunction_type, new_wavefunction
   public :: get_density_matrix, get_alpha_beta_occupation

   type :: wavefunction_type
      !> Electronic temperature
      real(wp) :: kt = 0.0_wp
      !> Number of electrons in this wavefunction
      real(wp) :: nocc = 0.0_wp
      !> Number of unpaired electrons in this wavefunction
      real(wp) :: nuhf = 0.0_wp
      !> Number of spin channels
      integer :: nspin = 1
      !> Index of the highest occupied molecular orbitals
      integer, allocatable :: homo(:)
      !> Number of electrons
      real(wp), allocatable :: nel(:)
      !> Reference occupation number for each atom, shape: [nat]
      real(wp), allocatable :: n0at(:)
      !> Reference occupation number for each shell, shape: [nsh]
      real(wp), allocatable :: n0sh(:)

      !> Density matrix, shape: [nao, nao, spin]
      real(wp), allocatable :: density(:, :, :)
      !> Orbital coefficients, shape: [nao, nao, spin]
      real(wp), allocatable :: coeff(:, :, :)
      !> Orbital energies, eigenvalues, shape: [nao, spin]
      real(wp), allocatable :: emo(:, :)
      !> Occupation numbers, shape: [nao, spin]
      real(wp), allocatable :: focc(:, :)

      !> Number of electrons for each atom, shape: [nat, spin]
      real(wp), allocatable :: qat(:, :)
      !> Number of electrons for each shell, shape: [nsh, spin]
      real(wp), allocatable :: qsh(:, :)

      !> Atomic dipole moments for each atom, shape: [3, nat, spin]
      real(wp), allocatable :: dpat(:, :, :)
      !> Atomic quadrupole moments for each atom, shape: [5, nat, spin]
      real(wp), allocatable :: qpat(:, :, :)
   end type wavefunction_type

contains


subroutine new_wavefunction(self, nat, nsh, nao, nspin, kt)
   type(wavefunction_type), intent(out) :: self
   integer, intent(in) :: nat
   integer, intent(in) :: nsh
   integer, intent(in) :: nao
   integer, intent(in) :: nspin
   real(wp), intent(in) :: kt

   self%nspin = nspin
   self%kt = kt

   allocate(self%homo(max(2, nspin)))
   allocate(self%nel(max(2, nspin)))

   allocate(self%n0at(nat))
   allocate(self%n0sh(nsh))

   allocate(self%density(nao, nao, nspin))
   allocate(self%coeff(nao, nao, nspin))
   allocate(self%emo(nao, nspin))
   allocate(self%focc(nao, nspin))

   allocate(self%qat(nat, nspin))
   allocate(self%qsh(nsh, nspin))

   allocate(self%dpat(3, nat, nspin))
   allocate(self%qpat(6, nat, nspin))

   self%qat(:, :) = 0.0_wp
   self%qsh(:, :) = 0.0_wp
   self%dpat(:, :, :) = 0.0_wp
   self%qpat(:, :, :) = 0.0_wp
end subroutine new_wavefunction


subroutine get_density_matrix(focc, coeff, pmat)
   real(wp), intent(in) :: focc(:)
   real(wp), contiguous, intent(in) :: coeff(:, :)
   real(wp), contiguous, intent(out) :: pmat(:, :)

   real(wp), allocatable :: scratch(:, :)
   integer :: iao, jao

   allocate(scratch(size(pmat, 1), size(pmat, 2)))
   !$omp parallel do collapse(2) default(none) schedule(runtime) &
   !$omp shared(scratch, coeff, focc, pmat) private(iao, jao)
   do iao = 1, size(pmat, 1)
      do jao = 1, size(pmat, 2)
         scratch(jao, iao) = coeff(jao, iao) * focc(iao)
      end do
   end do
   call gemm(scratch, coeff, pmat, transb='t')
end subroutine get_density_matrix


!> Split an real occupation number into alpha and beta space.
!>
!> This routine does not perform any checks on the condition
!> ``mod(nocc, 2) == 0 .eqv. mod(nuhf, 2) == 0`` and will yield fractional
!> occupations in case those condtions are not fullfilled.
!> However, it will avoid creating negative occupation numbers.
subroutine get_alpha_beta_occupation(nocc, nuhf, nalp, nbet)
   real(wp), intent(in) :: nocc
   real(wp), intent(in) :: nuhf
   real(wp), intent(out) :: nalp
   real(wp), intent(out) :: nbet

   real(wp) :: ntmp, diff

   ! make sure we cannot get a negative occupation here
   diff = min(nuhf, nocc)
   ntmp = nocc - diff

   nalp = ntmp / 2 + diff
   nbet = ntmp / 2
end subroutine get_alpha_beta_occupation


end module tblite_wavefunction_type

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/io/numpy/save.f90
!> Provides npy output routines

!> Implementation of saving multidimensional arrays to npy files
module tblite_io_numpy_save
   use mctc_env, only : dp, i4
   use tblite_io_numpy_constants, only : magic_number, magic_string, type_rdp, type_i4
   use tblite_output_format, only : format_string
   implicit none
   private

   public :: save_npy, npy_header

   interface save_npy
      module procedure save_npy_i4_r1
      module procedure save_npy_rdp_r1
      module procedure save_npy_rdp_r2
      module procedure save_npy_rdp_r3
   end interface save_npy

   character(len=*), parameter :: nl = achar(10)

contains

!> Generate magic header string for npy format
pure function magic_header(major, minor) result(str)
   !> Major version of npy format
   integer, intent(in) :: major
   !> Minor version of npy format
   integer, intent(in) :: minor
   !> Magic string for npy format
   character(len=8) :: str

   str = magic_number // magic_string // achar(major) // achar(minor)
end function magic_header


!> Generate header for npy format
pure function npy_header(vtype, vshape) result(str)
   !> Type of variable
   character(len=*), intent(in) :: vtype
   !> Shape of variable
   integer, intent(in) :: vshape(:)
   !> Header string for npy format
   character(len=:), allocatable :: str

   integer, parameter :: len_v10 = 8 + 2, len_v20 = 8 + 4, block_size = 64

   str = &
      "{'descr': '"//vtype//&
      "', 'fortran_order': True, 'shape': "//&
      shape_str(vshape)//", }"

    if (len(str) + len_v10 >= 65535) then
      str = str // &
         & repeat(" ", block_size - mod(len(str) + len_v20 + 1, block_size)) // nl
      str = magic_header(2, 0) // to_bytes_i4(int(len(str))) // str
    else
      str = str // &
         & repeat(" ", block_size - mod(len(str) + len_v10 + 1, block_size)) // nl
      str = magic_header(1, 0) // to_bytes_i2(int(len(str))) // str
    end if
end function npy_header

!> Write integer as byte string in little endian encoding
pure function to_bytes_i4(val) result(str)
   !> Integer value to convert to bytes
   integer, intent(in) :: val
   !> String of bytes
   character(len=4) :: str

   str = achar(mod(val, 256**1)) // &
      & achar(mod(val, 256**2) / 256**1) // &
      & achar(mod(val, 256**3) / 256**2) // &
      & achar(val / 256**3)
end function to_bytes_i4


!> Write integer as byte string in little endian encoding, 2-byte truncated version
pure function to_bytes_i2(val) result(str)
   !> Integer value to convert to bytes
   integer, intent(in) :: val
   !> String of bytes
   character(len=2) :: str

   str = achar(mod(val, 2**8)) // &
      & achar(mod(val, 2**16) / 2**8)
end function to_bytes_i2


!> Print array shape as tuple of int
pure function shape_str(vshape) result(str)
   !> Shape of variable
   integer, intent(in) :: vshape(:)
   !> Shape string for npy format
   character(len=:), allocatable :: str

   integer :: i

   str = "("
   do i = 1, size(vshape)
      str = str//format_string(vshape(i), '(i0)')//", "
   enddo
   str = str//")"
end function shape_str


!> Save 1-dimensional array in npy format
subroutine save_npy_i4_r1(filename, array, iostat, iomsg)
   !> Name of the npy file to load from
   character(len=*), intent(in) :: filename
   !> Array to be loaded from the npy file
   integer(i4), intent(in) :: array(:)
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=*), parameter :: vtype = type_i4
   integer :: io, stat

   open(newunit=io, file=filename, form="unformatted", access="stream", iostat=stat)
   if (stat == 0) then
      write(io, iostat=stat) npy_header(vtype, shape(array))
   end if
   if (stat == 0) then
      write(io, iostat=stat) array
   end if
   close(io, iostat=stat)

   call handle_iostat(stat, filename, iostat, iomsg)
end subroutine save_npy_i4_r1

!> Save 1-dimensional array in npy format
subroutine save_npy_rdp_r1(filename, array, iostat, iomsg)
   !> Name of the npy file to load from
   character(len=*), intent(in) :: filename
   !> Array to be loaded from the npy file
   real(dp), intent(in) :: array(:)
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=*), parameter :: vtype = type_rdp
   integer :: io, stat

   open(newunit=io, file=filename, form="unformatted", access="stream", iostat=stat)
   if (stat == 0) then
      write(io, iostat=stat) npy_header(vtype, shape(array))
   end if
   if (stat == 0) then
      write(io, iostat=stat) array
   end if
   close(io, iostat=stat)

   call handle_iostat(stat, filename, iostat, iomsg)
end subroutine save_npy_rdp_r1

!> Save 2-dimensional array in npy format
subroutine save_npy_rdp_r2(filename, array, iostat, iomsg)
   !> Name of the npy file to load from
   character(len=*), intent(in) :: filename
   !> Array to be loaded from the npy file
   real(dp), intent(in) :: array(:, :)
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=*), parameter :: vtype = type_rdp
   integer :: io, stat

   open(newunit=io, file=filename, form="unformatted", access="stream", iostat=stat)
   if (stat == 0) then
      write(io, iostat=stat) npy_header(vtype, shape(array))
   end if
   if (stat == 0) then
      write(io, iostat=stat) array
   end if
   close(io, iostat=stat)

   call handle_iostat(stat, filename, iostat, iomsg)
end subroutine save_npy_rdp_r2

!> Save 3-dimensional array in npy format
subroutine save_npy_rdp_r3(filename, array, iostat, iomsg)
   !> Name of the npy file to load from
   character(len=*), intent(in) :: filename
   !> Array to be loaded from the npy file
   real(dp), intent(in) :: array(:, :, :)
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=*), parameter :: vtype = type_rdp
   integer :: io, stat

   open(newunit=io, file=filename, form="unformatted", access="stream", iostat=stat)
   if (stat == 0) then
      write(io, iostat=stat) npy_header(vtype, shape(array))
   end if
   if (stat == 0) then
      write(io, iostat=stat) array
   end if
   close(io, iostat=stat)

   call handle_iostat(stat, filename, iostat, iomsg)
end subroutine save_npy_rdp_r3

!> Handle iostat and iomsg of write operation
subroutine handle_iostat(stat, filename, iostat, iomsg)
   !> Error status of loading, zero on success
   integer, intent(in) :: stat
   !> Name of the npy file to load from
   character(len=*), intent(in) :: filename
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   if (present(iostat)) then
      iostat = stat
   else if (stat /= 0) then
      error stop "Failed to write array to file '"//filename//"'"
   end if

   if (present(iomsg)) then
      if (stat /= 0) then
         iomsg = "Failed to write array to file '"//filename//"'"
      end if
   end if
end subroutine handle_iostat

end module tblite_io_numpy_save

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Classical repulsion interaction as used with the xTB Hamiltonian
module tblite_repulsion_effective
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_container, only : container_cache
   use tblite_cutoff, only : get_lattice_points
   use tblite_repulsion_type, only : repulsion_type
   implicit none
   private

   public :: tb_repulsion, new_repulsion


   !> Container to evaluate classical repulsion interactions for the xTB Hamiltonian
   type, extends(repulsion_type) :: tb_repulsion
      !> Exponent for the repulsion interaction
      real(wp), allocatable :: alpha(:, :)
      !> Effective nuclear charge
      real(wp), allocatable :: zeff(:, :)
      !> Scaling of the repulsion exponents
      real(wp), allocatable :: kexp(:, :)
      !> Exponent of the repulsion polynomial
      real(wp), allocatable :: rexp(:, :)
      !> Real-space cutoff
      real(wp) :: cutoff = 25.0_wp
   contains
      procedure :: get_engrad
   end type tb_repulsion

   character(len=*), parameter :: label = "screened Coulomb repulsion"

contains


subroutine new_repulsion(self, mol, alpha, zeff, kexp, kexp_light, rexp, cutoff)
   !> Instance of the repulsion container
   type(tb_repulsion), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Exponent for the repulsion interaction
   real(wp), intent(in) :: alpha(:)
   !> Effective nuclear charge
   real(wp), intent(in) :: zeff(:)
   !> Scaling of the repulsion exponents
   real(wp), intent(in) :: kexp
   !> Scaling of the repulsion exponents for light atom pairs
   real(wp), intent(in) :: kexp_light
   !> Exponent of the repulsion polynomial
   real(wp), intent(in) :: rexp
   !> Real-space cutoff
   real(wp), intent(in), optional :: cutoff

   integer :: isp, izp, jsp, jzp

   self%label = label
   allocate(self%alpha(mol%nid, mol%nid))
   do isp = 1, mol%nid
      do jsp = 1, mol%nid
         self%alpha(jsp, isp) = sqrt(alpha(isp)*alpha(jsp))
      end do
   end do

   allocate(self%zeff(mol%nid, mol%nid))
   do isp = 1, mol%nid
      do jsp = 1, mol%nid
         self%zeff(jsp, isp) = zeff(isp)*zeff(jsp)
      end do
   end do

   allocate(self%kexp(mol%nid, mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      do jsp = 1, mol%nid
         jzp = mol%num(jsp)
         self%kexp(jsp, isp) = merge(kexp, kexp_light, izp > 2 .or. jzp > 2)
      end do
   end do

   allocate(self%rexp(mol%nid, mol%nid))
   self%rexp(:, :) = rexp
   if (present(cutoff)) self%cutoff = cutoff

end subroutine new_repulsion


!> Evaluate classical interaction for energy and derivatives
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the repulsion container
   class(tb_repulsion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Repulsion energy
   real(wp), intent(inout) :: energies(:)
   !> Molecular gradient of the repulsion energy
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)

   real(wp), allocatable :: trans(:, :)

   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff, trans)

   if (present(gradient) .and. present(sigma)) then
      call get_repulsion_derivs(mol, trans, self%cutoff, self%alpha, self%zeff, &
         & self%kexp, self%rexp, energies, gradient, sigma)
   else
      call get_repulsion_energy(mol, trans, self%cutoff, self%alpha, self%zeff, &
         & self%kexp, self%rexp, energies)
   end if

end subroutine get_engrad


subroutine get_repulsion_energy(mol, trans, cutoff, alpha, zeff, kexp, rexp, &
      & energies)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points
   real(wp), intent(in) :: trans(:, :)
   !> Real space cutoff
   real(wp), intent(in) :: cutoff
   !> Exponents for all element pairs
   real(wp), intent(in) :: alpha(:, :)
   !> Effective nuclear charges for all element pairs
   real(wp), intent(in) :: zeff(:, :)
   !> Pairwise parameters for all element pairs
   real(wp), intent(in) :: kexp(:, :)
   !> Pairwise parameters for all element pairs
   real(wp), intent(in) :: rexp(:, :)
   !> Repulsion energy
   real(wp), intent(inout) :: energies(:)

   integer :: iat, jat, izp, jzp, itr
   real(wp) :: r1, r2, rij(3), r1k, r1r, exa, cutoff2, dE

   cutoff2 = cutoff**2

   !$omp parallel do default(none) schedule(runtime) reduction(+:energies) &
   !$omp shared(mol, trans, cutoff2, kexp, rexp, alpha, zeff) &
   !$omp private(iat, jat, izp, jzp, itr, r1, r2, rij, r1k, r1r, exa, dE)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)
         do itr = 1, size(trans, dim=2)
            rij = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
            r2 = sum(rij**2)
            if (r2 > cutoff2 .or. r2 < 1.0e-12_wp) cycle
            r1 = sqrt(r2)

            r1k = r1**kexp(jzp, izp)
            exa = exp(-alpha(jzp, izp)*r1k)
            r1r = r1**rexp(jzp, izp)
            dE = zeff(jzp, izp) * exa/r1r
            energies(iat) = energies(iat) + 0.5_wp * dE
            if (iat /= jat) then
               energies(jat) = energies(jat) + 0.5_wp * dE
            end if
         end do
      end do
   end do

end subroutine get_repulsion_energy


subroutine get_repulsion_derivs(mol, trans, cutoff, alpha, zeff, kexp, rexp, &
      & energies, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points
   real(wp), intent(in) :: trans(:, :)
   !> Real space cutoff
   real(wp), intent(in) :: cutoff
   !> Exponents for all element pairs
   real(wp), intent(in) :: alpha(:, :)
   !> Effective nuclear charges for all element pairs
   real(wp), intent(in) :: zeff(:, :)
   !> Pairwise parameters for all element pairs
   real(wp), intent(in) :: kexp(:, :)
   !> Pairwise parameters for all element pairs
   real(wp), intent(in) :: rexp(:, :)
   !> Repulsion energy
   real(wp), intent(inout) :: energies(:)
   !> Molecular gradient of the repulsion energy
   real(wp), intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), intent(inout) :: sigma(:, :)

   integer :: iat, jat, izp, jzp, itr
   real(wp) :: r1, r2, rij(3), r1k, r1r, exa, cutoff2, dE, dG(3), dS(3, 3)

   cutoff2 = cutoff**2

   !$omp parallel do default(none) schedule(runtime) reduction(+:energies, gradient, sigma) &
   !$omp shared(mol, trans, cutoff2, kexp, rexp, alpha, zeff) &
   !$omp private(iat, jat, izp, jzp, itr, r1, r2, rij, r1k, r1r, exa, dE, dG, dS)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)
         do itr = 1, size(trans, dim=2)
            rij = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
            r2 = sum(rij**2)
            if (r2 > cutoff2 .or. r2 < 1.0e-12_wp) cycle
            r1 = sqrt(r2)

            r1k = r1**kexp(jzp, izp)
            exa = exp(-alpha(jzp, izp)*r1k)
            r1r = r1**rexp(jzp, izp)
            dE = zeff(jzp, izp) * exa/r1r
            dG = -(alpha(jzp, izp)*r1k*kexp(jzp, izp) + rexp(jzp, izp)) * dE * rij/r2
            dS = spread(dG, 1, 3) * spread(rij, 2, 3)
            energies(iat) = energies(iat) + 0.5_wp * dE
            if (iat /= jat) then
               energies(jat) = energies(jat) + 0.5_wp * dE
               gradient(:, iat) = gradient(:, iat) + dG
               gradient(:, jat) = gradient(:, jat) - dG
               sigma(:, :) = sigma + dS
            else
               sigma(:, :) = sigma + 0.5_wp * dS
            end if
         end do
      end do
   end do

end subroutine get_repulsion_derivs


end module tblite_repulsion_effective

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of multipole moment integrals, dipole and quadrupole.
module tblite_integral_multipole
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use tblite_basis_type, only : basis_type, cgto_type
   use tblite_integral_trafo, only : transform0, transform1, transform2
   implicit none
   private

   public :: multipole_cgto, multipole_grad_cgto
   public :: get_multipole_integrals
   public :: maxl, msao

   interface get_multipole_integrals
      module procedure :: get_multipole_integrals_lat
   end interface get_multipole_integrals

   integer, parameter :: maxl = 6
   integer, parameter :: maxl2 = maxl*2
   integer, parameter :: msao(0:maxl) = [1, 3, 5, 7, 9, 11, 13]
   integer, parameter :: mlao(0:maxl) = [1, 3, 6, 10, 15, 21, 28]
   integer, parameter :: lmap(0:maxl) = [0, 1, 4, 10, 20, 35, 56]
   real(wp), parameter :: sqrtpi = sqrt(pi)
   real(wp), parameter :: sqrtpi3 = sqrtpi**3

   ! x (+1), y (-1), z (0) in [-1, 0, 1] sorting
   integer, parameter :: lx(3, 84) = reshape([&
      & 0, &
      & 0,0,1, &
      & 2,0,0,1,1,0, &
      & 3,0,0,2,2,1,0,1,0,1, &
      & 4,0,0,3,3,1,0,1,0,2,2,0,2,1,1, &
      & 5,0,0,3,3,2,2,0,0,4,4,1,0,0,1,1,3,1,2,2,1, &
      & 6,0,0,3,3,0,5,5,1,0,0,1,4,4,2,0,2,0,3,3,1,2,2,1,4,1,1,2, &
      & 0, &
      & 1,0,0, &
      & 0,2,0,1,0,1, &
      & 0,3,0,1,0,2,2,0,1,1, &
      & 0,4,0,1,0,3,3,0,1,2,0,2,1,2,1, &
      & 0,5,0,2,0,3,0,3,2,1,0,4,4,1,0,1,1,3,2,1,2, &
      & 0,6,0,3,0,3,1,0,0,1,5,5,2,0,0,2,4,4,2,1,3,1,3,2,1,4,1,2, &
      & 0, &
      & 0,1,0, &
      & 0,0,2,0,1,1, &
      & 0,0,3,0,1,0,1,2,2,1, &
      & 0,0,4,0,1,0,1,3,3,0,2,2,1,1,2, &
      & 0,0,5,0,2,0,3,2,3,0,1,0,1,4,4,3,1,1,1,2,2, &
      & 0,0,6,0,3,3,0,1,5,5,1,0,0,2,4,4,0,2,1,2,2,3,1,3,1,1,4,2], &
      & shape(lx), order=[2, 1])


contains


elemental function overlap_1d(moment, alpha) result(overlap)
   integer, intent(in) :: moment
   real(wp), intent(in) :: alpha
   real(wp) :: overlap
   real(wp), parameter :: dfactorial(0:7) = & ! see OEIS A001147
      & [1._wp,1._wp,3._wp,15._wp,105._wp,945._wp,10395._wp,135135._wp]

   if (modulo(moment, 2) == 0) then
      overlap = (0.5_wp/alpha)**(moment/2) * dfactorial(moment/2)
   else
      overlap = 0.0_wp
   end if
end function overlap_1d


pure subroutine horizontal_shift(ae, l, cfs)
   integer, intent(in) :: l
   real(wp), intent(in) :: ae
   real(wp), intent(inout) :: cfs(*)
   select case(l)
   case(0) ! s
      continue
   case(1) ! p
      cfs(1)=cfs(1)+ae*cfs(2)
   case(2) ! d
      cfs(1)=cfs(1)+ae*ae*cfs(3)
      cfs(2)=cfs(2)+ 2*ae*cfs(3)
   case(3) ! f
      cfs(1)=cfs(1)+ae*ae*ae*cfs(4)
      cfs(2)=cfs(2)+ 3*ae*ae*cfs(4)
      cfs(3)=cfs(3)+ 3*ae*cfs(4)
   case(4) ! g
      cfs(1)=cfs(1)+ae*ae*ae*ae*cfs(5)
      cfs(2)=cfs(2)+ 4*ae*ae*ae*cfs(5)
      cfs(3)=cfs(3)+ 6*ae*ae*cfs(5)
      cfs(4)=cfs(4)+ 4*ae*cfs(5)
   end select
end subroutine horizontal_shift

pure subroutine form_product(a, b, la, lb, d)
   integer, intent(in) :: la, lb
   real(wp), intent(in) :: a(*), b(*)
   real(wp), intent(inout) :: d(*)
   if(la.ge.4.or.lb.ge.4) goto 40
   if(la.ge.3.or.lb.ge.3) goto 30
   if(la.ge.2.or.lb.ge.2) goto 20
   ! <s|s> = <s>
   d(1)=a(1)*b(1)
   if(la.eq.0.and.lb.eq.0) return
   ! <s|p> = <s|*(|s>+|p>)
   !       = <s> + <p>
   d(2)=a(1)*b(2)+a(2)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|p> = (<s|+<p|)*(|s>+|p>)
   !       = <s> + <p> + <d>
   d(3)=a(2)*b(2)
   return
20 continue
   ! <s|d> = <s|*(|s>+|p>+|d>)
   !       = <s> + <p> + <d>
   d(1)=a(1)*b(1)
   d(2)=a(1)*b(2)+a(2)*b(1)
   d(3)=a(1)*b(3)+a(3)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|d> = (<s|+<p|)*(|s>+|p>+|d>)
   !       = <s> + <p> + <d> + <f>
   d(3)=d(3)+a(2)*b(2)
   d(4)=a(2)*b(3)+a(3)*b(2)
   if(la.le.1.or.lb.le.1) return
   ! <d|d> = (<s|+<p|+<d|)*(|s>+|p>+|d>)
   !       = <s> + <p> + <d> + <f> + <g>
   d(5)=a(3)*b(3)
   return
30 continue
   ! <s|f> = <s|*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f>
   d(1)=a(1)*b(1)
   d(2)=a(1)*b(2)+a(2)*b(1)
   d(3)=a(1)*b(3)+a(3)*b(1)
   d(4)=a(1)*b(4)+a(4)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|f> = (<s|+<p|)*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f> + <g>
   d(3)=d(3)+a(2)*b(2)
   d(4)=d(4)+a(2)*b(3)+a(3)*b(2)
   d(5)=a(2)*b(4)+a(4)*b(2)
   if(la.le.1.or.lb.le.1) return
   ! <d|f> = (<s|+<p|+<d|)*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f> + <g> + <h>
   d(5)=d(5)+a(3)*b(3)
   d(6)=a(3)*b(4)+a(4)*b(3)
   if(la.le.2.or.lb.le.2) return
   ! <f|f> = (<s|+<p|+<d|+<f|)*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i>
   d(7)=a(4)*b(4)
   return
40 continue
   ! <s|g> = <s|*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g>
   d(1)=a(1)*b(1)
   d(2)=a(1)*b(2)+a(2)*b(1)
   d(3)=a(1)*b(3)+a(3)*b(1)
   d(4)=a(1)*b(4)+a(4)*b(1)
   d(5)=a(1)*b(5)+a(5)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|g> = (<s|+<p|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h>
   d(3)=d(3)+a(2)*b(2)
   d(4)=d(4)+a(2)*b(3)+a(3)*b(2)
   d(5)=d(5)+a(2)*b(4)+a(4)*b(2)
   d(6)=a(2)*b(5)+a(5)*b(2)
   if(la.le.1.or.lb.le.1) return
   ! <d|g> = (<s|+<p|+<d|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i>
   d(5)=d(5)+a(3)*b(3)
   d(6)=d(5)+a(3)*b(4)+a(4)*b(3)
   d(7)=a(3)*b(5)+a(5)*b(3)
   if(la.le.2.or.lb.le.2) return
   ! <f|g> = (<s|+<p|+<d|+<f|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i> + <k>
   d(7)=d(7)+a(4)*b(4)
   d(8)=a(4)*b(5)+a(5)*b(4)
   if(la.le.3.or.lb.le.3) return
   ! <g|g> = (<s|+<p|+<d|+<f|+<g|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i> + <k> + <l>
   d(9)=a(5)*b(5)

end subroutine form_product


pure subroutine multipole_3d(rpj, rpi, aj, ai, lj, li, s1d, s3d, d3d, q3d)
   real(wp), intent(in) :: rpi(3)
   real(wp), intent(in) :: rpj(3)
   real(wp), intent(in) :: ai
   real(wp), intent(in) :: aj
   integer, intent(in) :: li(3)
   integer, intent(in) :: lj(3)
   real(wp), intent(in) :: s1d(0:)
   real(wp), intent(out) :: s3d
   real(wp), intent(out) :: d3d(3)
   real(wp), intent(out) :: q3d(6)

   integer :: k, l
   real(wp) :: vi(0:maxl), vj(0:maxl), vv(0:maxl2), v1d(3, 3)

   v1d(:, :) = 0.0_wp

   do k = 1, 3
      vv(:) = 0.0_wp
      vi(:) = 0.0_wp
      vj(:) = 0.0_wp
      vi(li(k)) = 1.0_wp
      vj(lj(k)) = 1.0_wp

      call horizontal_shift(rpi(k), li(k), vi)
      call horizontal_shift(rpj(k), lj(k), vj)
      call form_product(vi, vj, li(k), lj(k), vv)
      do l = 0, li(k) + lj(k)
         v1d(k, 1) = v1d(k, 1) + s1d(l) * vv(l)
         v1d(k, 2) = v1d(k, 2) + (s1d(l+1) + rpi(k)*s1d(l)) * vv(l)
         v1d(k, 3) = v1d(k, 3) + (s1d(l+2) + 2*rpi(k)*s1d(l+1) + rpi(k)*rpi(k)*s1d(l)) * vv(l)
      end do
   end do

   s3d = v1d(1, 1) * v1d(2, 1) * v1d(3, 1)
   d3d(1) = v1d(1, 2) * v1d(2, 1) * v1d(3, 1)
   d3d(2) = v1d(1, 1) * v1d(2, 2) * v1d(3, 1)
   d3d(3) = v1d(1, 1) * v1d(2, 1) * v1d(3, 2)
   q3d(1) = v1d(1, 3) * v1d(2, 1) * v1d(3, 1)
   q3d(2) = v1d(1, 2) * v1d(2, 2) * v1d(3, 1)
   q3d(3) = v1d(1, 1) * v1d(2, 3) * v1d(3, 1)
   q3d(4) = v1d(1, 2) * v1d(2, 1) * v1d(3, 2)
   q3d(5) = v1d(1, 1) * v1d(2, 2) * v1d(3, 2)
   q3d(6) = v1d(1, 1) * v1d(2, 1) * v1d(3, 3)

end subroutine multipole_3d


pure subroutine multipole_grad_3d(rpj, rpi, aj, ai, lj, li, s1d, s3d, d3d, q3d, &
      & ds3d, dd3d, dq3d)
   real(wp), intent(in) :: rpi(3)
   real(wp), intent(in) :: rpj(3)
   real(wp), intent(in) :: ai
   real(wp), intent(in) :: aj
   integer, intent(in) :: li(3)
   integer, intent(in) :: lj(3)
   real(wp), intent(in) :: s1d(0:)
   real(wp), intent(out) :: s3d
   real(wp), intent(out) :: d3d(3)
   real(wp), intent(out) :: q3d(6)
   real(wp), intent(out) :: ds3d(3)
   real(wp), intent(out) :: dd3d(3, 3)
   real(wp), intent(out) :: dq3d(3, 6)

   integer :: k, l
   real(wp) :: vi(0:maxl), vj(0:maxl), vv(0:maxl2), v1d(3, 3)
   real(wp) :: gi(0:maxl), gg(0:maxl2), g1d(3, 3), rpc

   v1d(:, :) = 0.0_wp
   g1d(:, :) = 0.0_wp

   do k = 1, 3
      vv(:) = 0.0_wp
      gg(:) = 0.0_wp
      vi(:) = 0.0_wp
      vj(:) = 0.0_wp
      gi(:) = 0.0_wp
      rpc = rpj(k)

      vi(li(k)) = 1.0_wp
      vj(lj(k)) = 1.0_wp
      gi(li(k)+1) = 2*ai
      if (li(k) > 0) gi(li(k)-1) = -li(k)

      call horizontal_shift(rpi(k), li(k)-1, gi)
      call horizontal_shift(rpi(k), li(k)+1, gi)
      call horizontal_shift(rpi(k), li(k), vi)
      call horizontal_shift(rpj(k), lj(k), vj)
      call form_product(vi, vj, li(k), lj(k), vv)
      call form_product(gi, vj, li(k)+1, lj(k), gg)
      do l = 0, li(k) + lj(k) + 1
         v1d(k, 1) = v1d(k, 1) + s1d(l) * vv(l)
         v1d(k, 2) = v1d(k, 2) + (s1d(l+1) + rpc*s1d(l)) * vv(l)
         v1d(k, 3) = v1d(k, 3) + (s1d(l+2) + 2*rpc*s1d(l+1) + rpc*rpc*s1d(l)) * vv(l)
         g1d(k, 1) = g1d(k, 1) + s1d(l) * gg(l)
         g1d(k, 2) = g1d(k, 2) + (s1d(l+1) + rpc*s1d(l)) * gg(l)
         g1d(k, 3) = g1d(k, 3) + (s1d(l+2) + 2*rpc*s1d(l+1) + rpc*rpc*s1d(l)) * gg(l)
      end do
   end do

   s3d = v1d(1, 1) * v1d(2, 1) * v1d(3, 1)
   d3d(1) = v1d(1, 2) * v1d(2, 1) * v1d(3, 1)
   d3d(2) = v1d(1, 1) * v1d(2, 2) * v1d(3, 1)
   d3d(3) = v1d(1, 1) * v1d(2, 1) * v1d(3, 2)
   q3d(1) = v1d(1, 3) * v1d(2, 1) * v1d(3, 1)
   q3d(2) = v1d(1, 2) * v1d(2, 2) * v1d(3, 1)
   q3d(3) = v1d(1, 1) * v1d(2, 3) * v1d(3, 1)
   q3d(4) = v1d(1, 2) * v1d(2, 1) * v1d(3, 2)
   q3d(5) = v1d(1, 1) * v1d(2, 2) * v1d(3, 2)
   q3d(6) = v1d(1, 1) * v1d(2, 1) * v1d(3, 3)

   ds3d(1) = g1d(1, 1) * v1d(2, 1) * v1d(3, 1)
   ds3d(2) = v1d(1, 1) * g1d(2, 1) * v1d(3, 1)
   ds3d(3) = v1d(1, 1) * v1d(2, 1) * g1d(3, 1)
   dd3d(1, 1) = g1d(1, 2) * v1d(2, 1) * v1d(3, 1)
   dd3d(2, 1) = v1d(1, 2) * g1d(2, 1) * v1d(3, 1)
   dd3d(3, 1) = v1d(1, 2) * v1d(2, 1) * g1d(3, 1)
   dd3d(1, 2) = g1d(1, 1) * v1d(2, 2) * v1d(3, 1)
   dd3d(2, 2) = v1d(1, 1) * g1d(2, 2) * v1d(3, 1)
   dd3d(3, 2) = v1d(1, 1) * v1d(2, 2) * g1d(3, 1)
   dd3d(1, 3) = g1d(1, 1) * v1d(2, 1) * v1d(3, 2)
   dd3d(2, 3) = v1d(1, 1) * g1d(2, 1) * v1d(3, 2)
   dd3d(3, 3) = v1d(1, 1) * v1d(2, 1) * g1d(3, 2)
   dq3d(1, 1) = g1d(1, 3) * v1d(2, 1) * v1d(3, 1)
   dq3d(2, 1) = v1d(1, 3) * g1d(2, 1) * v1d(3, 1)
   dq3d(3, 1) = v1d(1, 3) * v1d(2, 1) * g1d(3, 1)
   dq3d(1, 2) = g1d(1, 2) * v1d(2, 2) * v1d(3, 1)
   dq3d(2, 2) = v1d(1, 2) * g1d(2, 2) * v1d(3, 1)
   dq3d(3, 2) = v1d(1, 2) * v1d(2, 2) * g1d(3, 1)
   dq3d(1, 3) = g1d(1, 1) * v1d(2, 3) * v1d(3, 1)
   dq3d(2, 3) = v1d(1, 1) * g1d(2, 3) * v1d(3, 1)
   dq3d(3, 3) = v1d(1, 1) * v1d(2, 3) * g1d(3, 1)
   dq3d(1, 4) = g1d(1, 2) * v1d(2, 1) * v1d(3, 2)
   dq3d(2, 4) = v1d(1, 2) * g1d(2, 1) * v1d(3, 2)
   dq3d(3, 4) = v1d(1, 2) * v1d(2, 1) * g1d(3, 2)
   dq3d(1, 5) = g1d(1, 1) * v1d(2, 2) * v1d(3, 2)
   dq3d(2, 5) = v1d(1, 1) * g1d(2, 2) * v1d(3, 2)
   dq3d(3, 5) = v1d(1, 1) * v1d(2, 2) * g1d(3, 2)
   dq3d(1, 6) = g1d(1, 1) * v1d(2, 1) * v1d(3, 3)
   dq3d(2, 6) = v1d(1, 1) * g1d(2, 1) * v1d(3, 3)
   dq3d(3, 6) = v1d(1, 1) * v1d(2, 1) * g1d(3, 3)

end subroutine multipole_grad_3d


pure subroutine multipole_cgto(cgtoj, cgtoi, r2, vec, intcut, overlap, dpint, qpint)
   !> Description of contracted Gaussian function on center i
   type(cgto_type), intent(in) :: cgtoi
   !> Description of contracted Gaussian function on center j
   type(cgto_type), intent(in) :: cgtoj
   !> Square distance between center i and j
   real(wp), intent(in) :: r2
   !> Distance vector between center i and j, ri - rj
   real(wp), intent(in) :: vec(3)
   !> Maximum value of integral prefactor to consider
   real(wp), intent(in) :: intcut
   !> Overlap integrals for the given pair i  and j
   real(wp), intent(out) :: overlap(msao(cgtoj%ang), msao(cgtoi%ang))
   !> Dipole moment integrals for the given pair i  and j
   real(wp), intent(out) :: dpint(3, msao(cgtoj%ang), msao(cgtoi%ang))
   !> Quadrupole moment integrals for the given pair i  and j
   real(wp), intent(out) :: qpint(6, msao(cgtoj%ang), msao(cgtoi%ang))

   integer :: ip, jp, mli, mlj, l
   real(wp) :: eab, oab, est, s1d(0:maxl2), rpi(3), rpj(3), cc, val, dip(3), quad(6), pre, tr
   real(wp) :: s3d(mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: d3d(3, mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: q3d(6, mlao(cgtoj%ang), mlao(cgtoi%ang))

   s3d(:, :) = 0.0_wp
   d3d(:, :, :) = 0.0_wp
   q3d(:, :, :) = 0.0_wp

   do ip = 1, cgtoi%nprim
      do jp = 1, cgtoj%nprim
         eab = cgtoi%alpha(ip) + cgtoj%alpha(jp)
         oab = 1.0_wp/eab
         est = cgtoi%alpha(ip) * cgtoj%alpha(jp) * r2 * oab
         if (est > intcut) cycle
         pre = exp(-est) * sqrtpi3*sqrt(oab)**3
         rpi = -vec * cgtoj%alpha(jp) * oab
         rpj = +vec * cgtoi%alpha(ip) * oab
         do l = 0, cgtoi%ang + cgtoj%ang + 2
            s1d(l) = overlap_1d(l, eab)
         end do
         cc = cgtoi%coeff(ip) * cgtoj%coeff(jp) * pre
         do mli = 1, mlao(cgtoi%ang)
            do mlj = 1, mlao(cgtoj%ang)
               call multipole_3d(rpj, rpi, cgtoj%alpha(jp), cgtoi%alpha(ip), &
                  & lx(:, mlj+lmap(cgtoj%ang)), lx(:, mli+lmap(cgtoi%ang)), &
                  & s1d, val, dip, quad)
               s3d(mlj, mli) = s3d(mlj, mli) + cc*val
               d3d(:, mlj, mli) = d3d(:, mlj, mli) + cc*dip
               q3d(:, mlj, mli) = q3d(:, mlj, mli) + cc*quad
            end do
         end do
      end do
   end do

   call transform0(cgtoj%ang, cgtoi%ang, s3d, overlap)
   call transform1(cgtoj%ang, cgtoi%ang, d3d, dpint)
   call transform1(cgtoj%ang, cgtoi%ang, q3d, qpint)

   ! remove trace from quadrupole integrals (transfrom to spherical harmonics and back)
   do mli = 1, msao(cgtoi%ang)
      do mlj = 1, msao(cgtoj%ang)
         tr = 0.5_wp * (qpint(1, mlj, mli) + qpint(3, mlj, mli) + qpint(6, mlj, mli))
         qpint(1, mlj, mli) = 1.5_wp * qpint(1, mlj, mli) - tr
         qpint(2, mlj, mli) = 1.5_wp * qpint(2, mlj, mli)
         qpint(3, mlj, mli) = 1.5_wp * qpint(3, mlj, mli) - tr
         qpint(4, mlj, mli) = 1.5_wp * qpint(4, mlj, mli)
         qpint(5, mlj, mli) = 1.5_wp * qpint(5, mlj, mli)
         qpint(6, mlj, mli) = 1.5_wp * qpint(6, mlj, mli) - tr
      end do
   end do

end subroutine multipole_cgto


pure subroutine multipole_grad_cgto(cgtoj, cgtoi, r2, vec, intcut, overlap, dpint, qpint, &
      & doverlap, ddpintj, dqpintj, ddpinti, dqpinti)
   !> Description of contracted Gaussian function on center i
   type(cgto_type), intent(in) :: cgtoi
   !> Description of contracted Gaussian function on center j
   type(cgto_type), intent(in) :: cgtoj
   !> Square distance between center i and j
   real(wp), intent(in) :: r2
   !> Distance vector between center i and j, ri - rj
   real(wp), intent(in) :: vec(3)
   !> Maximum value of integral prefactor to consider
   real(wp), intent(in) :: intcut
   !> Overlap integrals for the given pair i  and j
   real(wp), intent(out) :: overlap(msao(cgtoj%ang), msao(cgtoi%ang))
   !> Dipole moment integrals for the given pair i  and j
   real(wp), intent(out) :: dpint(3, msao(cgtoj%ang), msao(cgtoi%ang))
   !> Quadrupole moment integrals for the given pair i  and j
   real(wp), intent(out) :: qpint(6, msao(cgtoj%ang), msao(cgtoi%ang))
   !> Overlap integral gradient for the given pair i  and j
   real(wp), intent(out) :: doverlap(3, msao(cgtoj%ang), msao(cgtoi%ang))
   !> Dipole moment integral gradient for the given pair i  and j
   real(wp), intent(out) :: ddpinti(3, 3, msao(cgtoj%ang), msao(cgtoi%ang))
   !> Quadrupole moment integral gradient for the given pair i  and j
   real(wp), intent(out) :: dqpinti(3, 6, msao(cgtoj%ang), msao(cgtoi%ang))
   !> Dipole moment integral gradient for the given pair i  and j
   real(wp), intent(out) :: ddpintj(3, 3, msao(cgtoj%ang), msao(cgtoi%ang))
   !> Quadrupole moment integral gradient for the given pair i  and j
   real(wp), intent(out) :: dqpintj(3, 6, msao(cgtoj%ang), msao(cgtoi%ang))

   integer :: ip, jp, mli, mlj, l
   real(wp) :: eab, oab, est, s1d(0:maxl2), rpi(3), rpj(3), cc, val, dip(3), quad(6)
   real(wp) :: pre, grad(3), ddip(3, 3), dquad(3, 6), tr, dtr(3)
   real(wp) :: s3d(mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: d3dj(3, mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: q3dj(6, mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: ds3d(3, mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: dd3di(3, 3, mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: dq3di(3, 6, mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: dd3dj(3, 3, mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: dq3dj(3, 6, mlao(cgtoj%ang), mlao(cgtoi%ang))

   s3d(:, :) = 0.0_wp
   d3dj(:, :, :) = 0.0_wp
   q3dj(:, :, :) = 0.0_wp
   ds3d(:, :, :) = 0.0_wp
   dd3di(:, :, :, :) = 0.0_wp
   dq3di(:, :, :, :) = 0.0_wp
   dd3dj(:, :, :, :) = 0.0_wp
   dq3dj(:, :, :, :) = 0.0_wp

   do ip = 1, cgtoi%nprim
      do jp = 1, cgtoj%nprim
         eab = cgtoi%alpha(ip) + cgtoj%alpha(jp)
         oab = 1.0_wp/eab
         est = cgtoi%alpha(ip) * cgtoj%alpha(jp) * r2 * oab
         if (est > intcut) cycle
         pre = exp(-est) * sqrtpi3*sqrt(oab)**3
         rpi = -vec * cgtoj%alpha(jp) * oab
         rpj = +vec * cgtoi%alpha(ip) * oab
         do l = 0, cgtoi%ang + cgtoj%ang + 3
            s1d(l) = overlap_1d(l, eab)
         end do
         cc = cgtoi%coeff(ip) * cgtoj%coeff(jp) * pre
         do mli = 1, mlao(cgtoi%ang)
            do mlj = 1, mlao(cgtoj%ang)
               call multipole_grad_3d(rpj, rpi, cgtoj%alpha(jp), cgtoi%alpha(ip), &
                  & lx(:, mlj+lmap(cgtoj%ang)), lx(:, mli+lmap(cgtoi%ang)), &
                  & s1d, val, dip, quad, grad, ddip, dquad)
               s3d(mlj, mli) = s3d(mlj, mli) + cc*val
               d3dj(:, mlj, mli) = d3dj(:, mlj, mli) + cc*dip
               q3dj(:, mlj, mli) = q3dj(:, mlj, mli) + cc*quad
               ds3d(:, mlj, mli) = ds3d(:, mlj, mli) + cc*grad
               dd3dj(:, :, mlj, mli) = dd3dj(:, :, mlj, mli) + cc*ddip
               dq3dj(:, :, mlj, mli) = dq3dj(:, :, mlj, mli) + cc*dquad
            end do
         end do
      end do
   end do

   do mli = 1, mlao(cgtoi%ang)
      do mlj = 1, mlao(cgtoj%ang)
         call shift_operator(vec, s3d(mlj, mli), d3dj(:, mlj, mli), q3dj(:, mlj, mli), &
            & ds3d(:, mlj, mli), dd3dj(:, :, mlj, mli), dq3dj(:, :, mlj, mli), &
            & dd3di(:, :, mlj, mli), dq3di(:, :, mlj, mli))
      end do
   end do

   call transform0(cgtoj%ang, cgtoi%ang, s3d, overlap)
   call transform1(cgtoj%ang, cgtoi%ang, d3dj, dpint)
   call transform1(cgtoj%ang, cgtoi%ang, q3dj, qpint)
   call transform1(cgtoj%ang, cgtoi%ang, ds3d, doverlap)
   call transform2(cgtoj%ang, cgtoi%ang, dd3dj, ddpintj)
   call transform2(cgtoj%ang, cgtoi%ang, dq3dj, dqpintj)
   call transform2(cgtoj%ang, cgtoi%ang, dd3di, ddpinti)
   call transform2(cgtoj%ang, cgtoi%ang, dq3di, dqpinti)

   ! remove trace from quadrupole integrals (transfrom to spherical harmonics and back)
   do mli = 1, msao(cgtoi%ang)
      do mlj = 1, msao(cgtoj%ang)
         tr = 0.5_wp * (qpint(1, mlj, mli) + qpint(3, mlj, mli) + qpint(6, mlj, mli))
         qpint(1, mlj, mli) = 1.5_wp * qpint(1, mlj, mli) - tr
         qpint(2, mlj, mli) = 1.5_wp * qpint(2, mlj, mli)
         qpint(3, mlj, mli) = 1.5_wp * qpint(3, mlj, mli) - tr
         qpint(4, mlj, mli) = 1.5_wp * qpint(4, mlj, mli)
         qpint(5, mlj, mli) = 1.5_wp * qpint(5, mlj, mli)
         qpint(6, mlj, mli) = 1.5_wp * qpint(6, mlj, mli) - tr
      end do
   end do

   ! remove trace from quadrupole integral derivatives
   do mli = 1, msao(cgtoi%ang)
      do mlj = 1, msao(cgtoj%ang)
         dtr = dqpinti(:, 1, mlj, mli) + dqpinti(:, 3, mlj, mli) + dqpinti(:, 6, mlj, mli)
         dqpinti(:, 1, mlj, mli) = 1.5_wp * dqpinti(:, 1, mlj, mli) - 0.5_wp * dtr
         dqpinti(:, 2, mlj, mli) = 1.5_wp * dqpinti(:, 2, mlj, mli)
         dqpinti(:, 3, mlj, mli) = 1.5_wp * dqpinti(:, 3, mlj, mli) - 0.5_wp * dtr
         dqpinti(:, 4, mlj, mli) = 1.5_wp * dqpinti(:, 4, mlj, mli)
         dqpinti(:, 5, mlj, mli) = 1.5_wp * dqpinti(:, 5, mlj, mli)
         dqpinti(:, 6, mlj, mli) = 1.5_wp * dqpinti(:, 6, mlj, mli) - 0.5_wp * dtr
      end do
   end do

   ! remove trace from quadrupole integral derivatives
   do mli = 1, msao(cgtoi%ang)
      do mlj = 1, msao(cgtoj%ang)
         dtr = dqpintj(:, 1, mlj, mli) + dqpintj(:, 3, mlj, mli) + dqpintj(:, 6, mlj, mli)
         dqpintj(:, 1, mlj, mli) = 1.5_wp * dqpintj(:, 1, mlj, mli) - 0.5_wp * dtr
         dqpintj(:, 2, mlj, mli) = 1.5_wp * dqpintj(:, 2, mlj, mli)
         dqpintj(:, 3, mlj, mli) = 1.5_wp * dqpintj(:, 3, mlj, mli) - 0.5_wp * dtr
         dqpintj(:, 4, mlj, mli) = 1.5_wp * dqpintj(:, 4, mlj, mli)
         dqpintj(:, 5, mlj, mli) = 1.5_wp * dqpintj(:, 5, mlj, mli)
         dqpintj(:, 6, mlj, mli) = 1.5_wp * dqpintj(:, 6, mlj, mli) - 0.5_wp * dtr
      end do
   end do

end subroutine multipole_grad_cgto


pure subroutine shift_operator(vec, s, di, qi, ds, ddi, dqi, ddj, dqj)
   real(wp),intent(in) :: vec(:)
   real(wp),intent(in) :: s
   real(wp),intent(in) :: di(:)
   real(wp),intent(in) :: qi(:)
   real(wp),intent(in) :: ds(:)
   real(wp),intent(in) :: ddi(:, :)
   real(wp),intent(in) :: dqi(:, :)
   real(wp),intent(out) :: ddj(:, :)
   real(wp),intent(out) :: dqj(:, :)

   ddj(:, 1) = ddi(:, 1) - vec(1)*ds
   ddj(:, 2) = ddi(:, 2) - vec(2)*ds
   ddj(:, 3) = ddi(:, 3) - vec(3)*ds
   ddj(1, 1) = ddj(1, 1) - s
   ddj(2, 2) = ddj(2, 2) - s
   ddj(3, 3) = ddj(3, 3) - s

   dqj(:, 1) = dqi(:, 1) - 2*vec(1)*ddi(:, 1) + vec(1)**2*ds
   dqj(:, 3) = dqi(:, 3) - 2*vec(2)*ddi(:, 2) + vec(2)**2*ds
   dqj(:, 6) = dqi(:, 6) - 2*vec(3)*ddi(:, 3) + vec(3)**2*ds
   dqj(:, 2) = dqi(:, 2) - vec(1)*ddi(:, 2) - vec(2)*ddi(:, 1) + vec(1)*vec(2)*ds
   dqj(:, 4) = dqi(:, 4) - vec(1)*ddi(:, 3) - vec(3)*ddi(:, 1) + vec(1)*vec(3)*ds
   dqj(:, 5) = dqi(:, 5) - vec(2)*ddi(:, 3) - vec(3)*ddi(:, 2) + vec(2)*vec(3)*ds
   dqj(1, 1) = dqj(1, 1) - 2*di(1) + 2*vec(1)*s
   dqj(2, 3) = dqj(2, 3) - 2*di(2) + 2*vec(2)*s
   dqj(3, 6) = dqj(3, 6) - 2*di(3) + 2*vec(3)*s
   dqj(1, 2) = dqj(1, 2) - di(2) + vec(2)*s
   dqj(2, 2) = dqj(2, 2) - di(1) + vec(1)*s
   dqj(1, 4) = dqj(1, 4) - di(3) + vec(3)*s
   dqj(3, 4) = dqj(3, 4) - di(1) + vec(1)*s
   dqj(2, 5) = dqj(2, 5) - di(3) + vec(3)*s
   dqj(3, 5) = dqj(3, 5) - di(2) + vec(2)*s

end subroutine shift_operator


!> Evaluate overlap for a molecular structure
subroutine get_multipole_integrals_lat(mol, trans, cutoff, bas, overlap, dpint, qpint)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points within a given realspace cutoff
   real(wp), intent(in) :: trans(:, :)
   !> Realspace cutoff
   real(wp), intent(in) :: cutoff
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Overlap matrix
   real(wp), intent(out) :: overlap(:, :)
   !> Dipole moment integral matrix
   real(wp), intent(out) :: dpint(:, :, :)
   !> Quadrupole moment integral matrix
   real(wp), intent(out) :: qpint(:, :, :)

   integer :: iat, jat, izp, jzp, itr, is, js
   integer :: ish, jsh, ii, jj, iao, jao, nao
   real(wp) :: r2, vec(3), cutoff2
   real(wp), allocatable :: stmp(:), dtmp(:, :), qtmp(:, :)

   overlap(:, :) = 0.0_wp
   dpint(:, :, :) = 0.0_wp
   qpint(:, :, :) = 0.0_wp

   allocate(stmp(msao(bas%maxl)**2), dtmp(3, msao(bas%maxl)**2), qtmp(6, msao(bas%maxl)**2))
   cutoff2 = cutoff**2

   !$omp parallel do schedule(runtime) default(none) &
   !$omp shared(mol, bas, trans, cutoff2, overlap, dpint, qpint) &
   !$omp private(iat, jat, izp, jzp, itr, is, js, ish, jsh, ii, jj, iao, jao, nao) &
   !$omp private(r2, vec, stmp, dtmp, qtmp)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = bas%ish_at(iat)
      do jat = 1, mol%nat
         jzp = mol%id(jat)
         js = bas%ish_at(jat)
         do itr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
            r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
            if (r2 > cutoff2) cycle
            do ish = 1, bas%nsh_id(izp)
               ii = bas%iao_sh(is+ish)
               do jsh = 1, bas%nsh_id(jzp)
                  jj = bas%iao_sh(js+jsh)
                  call multipole_cgto(bas%cgto(jsh, jzp), bas%cgto(ish, izp), &
                     & r2, vec, bas%intcut, stmp, dtmp, qtmp)

                  nao = msao(bas%cgto(jsh, jzp)%ang)
                  !$omp simd collapse(2)
                  do iao = 1, msao(bas%cgto(ish, izp)%ang)
                     do jao = 1, nao
                        overlap(jj+jao, ii+iao) = overlap(jj+jao, ii+iao) &
                           & + stmp(jao + nao*(iao-1))

                        dpint(:, jj+jao, ii+iao) = dpint(:, jj+jao, ii+iao) &
                           & + dtmp(:, jao + nao*(iao-1))

                        qpint(:, jj+jao, ii+iao) = qpint(:, jj+jao, ii+iao) &
                           & + qtmp(:, jao + nao*(iao-1))
                     end do
                  end do

               end do
            end do

         end do
      end do
   end do

end subroutine get_multipole_integrals_lat


end module tblite_integral_multipole

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/container
!> Proxy module for general interaction containers.
!>
!> Provides access to the abstract base class [[container_type]] for declaring
!> a new interaction. Container extending the base class can provide (semi-)classical
!> energy contributions, i.e. independent of the density and/or density-dependent
!> contributions, which are included in the minimization of the electronic energy.
!>
!> The [[container_type]] itself is immutable once constructed, restart data must
!> be associated with a [[container_cache]] object. This cache object can be
!> populated in an [[container_type:update]] procedure. The update procedure is
!> allowed to invalidate existing caches and reallocate them as needed.
!>
!> Additionally, to ease compilation of several containers in an actual calculator
!> the [[container_list]] type is provided, which itself extends the [[container_type]]
!> base class to provide an uniform interface.
!>
!> New containers are added to the list by using the [[container_list:push_back]]
!> procedure. Since the list owns the containers, the container object should be
!> provided as allocatable class polymorphic [[container_type]], i.e. by transfer
!> using the intrinsic `move_alloc` procedure or by automatic LHS allocation of
!> the polymorphic object.
module tblite_container
   use tblite_container_cache, only : container_cache
   use tblite_container_list, only : container_list
   use tblite_container_type, only : container_type
   implicit none
   public
end module tblite_container

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_solvation_cds
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type
   use mctc_io_convert, only : kcaltoau
   use mstore, only : get_structure
   use tblite_container, only : container_cache
   use tblite_scf_potential, only : potential_type
   use tblite_solvation_cds, only : cds_solvation, cds_input
   use tblite_solvation_data_cds, only : get_cds_param
   use tblite_solvation_data, only : solvent_data, get_solvent_data, & 
      & get_vdw_rad_cosmo, get_vdw_rad_bondi, get_vdw_rad_d3
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: collect_solvation_cds

   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

   real(wp), parameter :: tension_water(20) = 1.0e-5_wp * [&
      &-0.08499967_wp, 0.46780225_wp,-2.87013596_wp,-3.95935069_wp,-0.29783987_wp, &
      &-0.48323273_wp, 0.00133622_wp, 0.20448945_wp, 0.20150600_wp, 0.36379863_wp, &
      &-3.47082133_wp,-0.93451053_wp,-1.46342018_wp,-0.32774697_wp,-0.38015204_wp, &
      &-0.35311116_wp,-0.19972593_wp,-0.12891363_wp,-1.19450558_wp,-1.61289300_wp]
   real(wp), parameter :: hbond_water(20) = -kcaltoau * [&
      & 6.70894947_wp, 0.00000000_wp, 0.00000000_wp, 0.00000000_wp, 0.00000000_wp, &
      & 1.26459036_wp, 3.52206160_wp, 2.30440543_wp, 1.98829409_wp, 0.00000000_wp, &
      & 0.00000000_wp, 0.00000000_wp, 0.00000000_wp, 0.00000000_wp, 2.68116653_wp, &
      & 0.38262428_wp, 1.02948365_wp, 0.00000000_wp, 0.00000000_wp, 0.00000000_wp]**2

contains


!> Collect all exported unit tests
subroutine collect_solvation_cds(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("sasa-e", test_e_sasa), &
      new_unittest("sasa-g", test_g_sasa), &
      new_unittest("sasa-p", test_p_sasa), &
      new_unittest("energy-neutral-alpb-gfn1", test_e_alpb_gfn1_all_solvents), &
      new_unittest("energy-neutral-alpb-gfn2", test_e_alpb_gfn2_all_solvents), &
      new_unittest("energy-neutral-gbsa-gfn1", test_e_gbsa_gfn1_all_solvents), &
      new_unittest("energy-neutral-gbsa-gfn2", test_e_gbsa_gfn2_all_solvents), &
      new_unittest("energy-charged-alpb-gfn1", test_e_charged_alpb_gfn1), &
      new_unittest("energy-charged-alpb-gfn2", test_e_charged_alpb_gfn2), &
      new_unittest("energy-charged-gbsa-gfn1", test_e_charged_gbsa_gfn1), &
      new_unittest("energy-charged-gbsa-gfn2", test_e_charged_gbsa_gfn2), &
      new_unittest("gradient-scf", test_g_cds), &
      new_unittest("gradient-nonscf", test_g_cds_nonscf), &
      new_unittest("potential", test_p_cds), &
      new_unittest("unsupported-solvent", test_unsupported_solvent, should_fail=.true.) &
      ]

end subroutine collect_solvation_cds


subroutine test_e(error, mol, input, qat, ref, method)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Solvation model input
   type(cds_input), intent(in) :: input

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Reference energy
   real(wp), intent(in) :: ref

   !> Method for parameter selection
   character(len=*), intent(in), optional :: method

   type(cds_solvation) :: solv
   type(cds_input), allocatable :: scratch_input
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp) :: energy(mol%nat)

   energy = 0.0_wp
   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))

   scratch_input = input

   if (allocated(input%solvent) .and. present(method)) then
      call get_cds_param(scratch_input, mol, method, error)
      if(allocated(error)) then
         call test_failed(error, "No CDS parameters found for the method/solvent")
         return
      end if
   end if

   solv = cds_solvation(mol, scratch_input, method)

   call solv%update(mol, cache)
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)
   !> CDS has some non-selfconsistent part as well:
   call solv%get_engrad(mol, cache, energy)

   if (abs(sum(energy) - ref) > thr) then
      call test_failed(error, "Energy does not match reference")
      print '(es21.14)', sum(energy)
      print '(es21.14)', ref
      print '(a)', "---"
   end if
end subroutine test_e


subroutine test_g(error, mol, input, qat, method)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Solvation model input
   type(cds_input), intent(in) :: input

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Method for parameter selection
   character(len=*), intent(in), optional :: method

   type(cds_solvation) :: solv
   type(cds_input), allocatable :: scratch_input
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp), allocatable :: gradient(:, :), numg(:, :)
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat), sigma(3, 3)
   integer :: ii, ic

   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))

   scratch_input = input

   if (allocated(input%solvent) .and. present(method)) then   
      call get_cds_param(scratch_input, mol, method, error)
      if(allocated(error)) then
         call test_failed(error, "No CDS parameters found for the method/solvent")
         return
      end if
   end if

   solv = cds_solvation(mol, scratch_input, method)

   allocate(numg(3, mol%nat), gradient(3, mol%nat))
   do ii = 1, mol%nat
      do ic = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(ic, ii) = mol%xyz(ic, ii) + step
         call solv%update(mol, cache)
         call solv%get_potential(mol, cache, wfn, pot)
         call solv%get_energy(mol, cache, wfn, er)

         mol%xyz(ic, ii) = mol%xyz(ic, ii) - 2*step
         call solv%update(mol, cache)
         call solv%get_potential(mol, cache, wfn, pot)
         call solv%get_energy(mol, cache, wfn, el)

         mol%xyz(ic, ii) = mol%xyz(ic, ii) + step
         numg(ic, ii) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp

   call solv%update(mol, cache)
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)
   call solv%get_gradient(mol, cache, wfn, gradient, sigma)

   if (any(abs(gradient - numg) > thr2)) then
      call test_failed(error, "Gradient does not match")
      print '(3es20.13)', gradient
      print '(a)', "---"
      print '(3es20.13)', numg
      print '(a)', "---"
      print '(3es20.13)', gradient - numg
   end if
end subroutine test_g


subroutine test_g_nonscf(error, mol, input, method)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Solvation model input
   type(cds_input), intent(in) :: input

   !> Method for parameter selection
   character(len=*), intent(in), optional :: method

   type(cds_solvation) :: solv
   type(cds_input), allocatable :: scratch_input
   type(container_cache) :: cache
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp), allocatable :: gradient(:, :), numg(:, :)
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat)
   integer :: ii, ic

   scratch_input = input

   if (allocated(input%solvent) .and. present(method)) then   
      call get_cds_param(scratch_input, mol, method, error)
      if(allocated(error)) then
         call test_failed(error, "No CDS parameters found for the method/solvent")
         return
      end if
   end if

   solv = cds_solvation(mol, scratch_input, method)

   allocate(numg(3, mol%nat), gradient(3, mol%nat))
   do ii = 1, mol%nat
      do ic = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(ic, ii) = mol%xyz(ic, ii) + step
         call solv%update(mol, cache)
         call solv%get_engrad(mol, cache, er)

         mol%xyz(ic, ii) = mol%xyz(ic, ii) - 2*step
         call solv%update(mol, cache)
         call solv%get_engrad(mol, cache, el)

         mol%xyz(ic, ii) = mol%xyz(ic, ii) + step
         numg(ic, ii) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp

   call solv%update(mol, cache)
   call solv%get_engrad(mol, cache, energy, gradient)

   if (any(abs(gradient - numg) > thr2)) then
      call test_failed(error, "Gradient does not match")
      print '(3es20.13)', gradient
      print '(a)', "---"
      print '(3es20.13)', numg
      print '(a)', "---"
      print '(3es20.13)', gradient - numg
   end if
end subroutine test_g_nonscf

subroutine test_p(error, mol, input, qat, method)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Solvation model input
   type(cds_input), intent(in) :: input

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Method for parameter selection
   character(len=*), intent(in), optional :: method

   type(cds_solvation) :: solv
   type(cds_input), allocatable :: scratch_input
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp), allocatable :: vat(:)
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat)
   integer :: ii

   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))

   scratch_input = input

   if (allocated(input%solvent) .and. present(method)) then   
      call get_cds_param(scratch_input, mol, method, error)
      if(allocated(error)) then
         call test_failed(error, "No CDS parameters found for the method/solvent")
         return
      end if
   end if

   solv = cds_solvation(mol, scratch_input, method)

   call solv%update(mol, cache)

   allocate(vat(mol%nat))
   do ii = 1, mol%nat
      er = 0.0_wp
      el = 0.0_wp
      wfn%qat(ii, 1) = wfn%qat(ii, 1) + step
      call solv%get_potential(mol, cache, wfn, pot)
      call solv%get_energy(mol, cache, wfn, er)

      wfn%qat(ii, 1) = wfn%qat(ii, 1) - 2*step
      call solv%get_potential(mol, cache, wfn, pot)
      call solv%get_energy(mol, cache, wfn, el)

      wfn%qat(ii, 1) = wfn%qat(ii, 1) + step
      vat(ii) = 0.5_wp*(sum(er) - sum(el))/step
   end do

   energy = 0.0_wp
   pot%vat(:, :) = 0.0_wp
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)

   if (any(abs([pot%vat] - vat) > thr)) then
      call test_failed(error, "Potential does not match")
      print '(3es20.13)', pot%vat
      print '(a)', "---"
      print '(3es20.13)', vat
      print '(a)', "---"
      print '(3es20.13)', [pot%vat] - vat
   end if
end subroutine test_p


subroutine test_e_sasa(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(cds_input) :: input
   real(wp), parameter :: qat(*) = [&
      &-8.99890404486076E-2_wp, 9.42168087556583E-2_wp,-1.49387631509499E-1_wp, &
      &-2.99114121895542E-1_wp, 4.85527734875224E-1_wp,-6.83156326406137E-2_wp, &
      & 1.50011293889337E-2_wp, 2.79368544459465E-1_wp,-1.24072452878322E-1_wp, &
      &-9.36760994051244E-2_wp,-2.19062123031622E-1_wp, 2.14538817685587E-1_wp, &
      & 3.06156726072831E-1_wp,-3.86105514712244E-1_wp,-1.51265171389388E-3_wp, &
      & 3.64255069977693E-2_wp]
   real(wp), allocatable :: rad(:), tension(:), hbond(:)

   call get_structure(mol, "MB16-43", "04")
   rad = get_vdw_rad_cosmo(mol%num)
   tension = tension_water(mol%num)
   hbond = hbond_water(mol%num)

   input = cds_input(probe=0.3_wp, nang=110, rad=rad, tension=tension)
   call test_e(error, mol, input, qat, -2.0260929722303264E-3_wp)

   if (allocated(error)) return

   input = cds_input(probe=0.3_wp, nang=110, rad=rad, tension=tension, hbond=hbond)
   call test_e(error, mol, input, qat, -3.89595604489100E-3_wp)

end subroutine test_e_sasa


subroutine test_g_sasa(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(cds_input) :: input
   real(wp), parameter :: qat(*) = [&
      & 2.08159387594211E-1_wp,-3.78010519998818E-1_wp, 3.36498247356244E-2_wp, &
      &-4.11556158912895E-1_wp, 8.14928196660512E-2_wp,-2.00886649303053E-1_wp, &
      & 2.44756994282684E-1_wp, 2.54580499189089E-2_wp, 2.59835128092562E-1_wp, &
      & 4.21683321877209E-1_wp, 1.37097163086023E-1_wp, 4.06951664942900E-2_wp, &
      &-1.10955378625897E-1_wp,-6.44033540918074E-2_wp,-1.91525919028143E-1_wp, &
      &-9.54898757869102E-2_wp]
   real(wp), allocatable :: rad(:), tension(:), hbond(:)

   call get_structure(mol, "MB16-43", "06")
   rad = get_vdw_rad_bondi(mol%num)
   tension = tension_water(mol%num)
   hbond = hbond_water(mol%num)

   input = cds_input(probe=0.3_wp, nang=110, rad=rad, tension=tension, hbond=hbond)
   call test_g(error, mol, input, qat)

   if (allocated(error)) return

   call test_g_nonscf(error, mol, input)

end subroutine test_g_sasa


subroutine test_p_sasa(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(cds_input) :: input
   real(wp), parameter :: qat(*) = [&
      &-2.05668345919710E-1_wp,-3.99553123071811E-1_wp, 3.29242774348191E-1_wp, &
      &-3.11737933844111E-1_wp, 3.58851882478133E-2_wp, 3.21886835736497E-1_wp, &
      & 4.14743455841314E-2_wp, 2.95727359478547E-2_wp,-5.06347224522431E-1_wp, &
      & 3.43067182413129E-1_wp, 6.88373767679515E-1_wp, 7.03357390141253E-2_wp, &
      &-9.62424552888750E-2_wp,-1.32209348056625E-1_wp, 9.78998441832186E-2_wp, &
      &-3.05979982450903E-1_wp]
   real(wp), allocatable :: rad(:), tension(:), hbond(:)

   call get_structure(mol, "MB16-43", "08")
   rad = get_vdw_rad_d3(mol%num)
   tension = tension_water(mol%num)
   hbond = hbond_water(mol%num)

   input = cds_input(probe=2.2_wp, nang=110, rad=rad, tension=tension, hbond=hbond)
   call test_p(error, mol, input, qat)

end subroutine test_p_sasa


subroutine test_e_alpb_gfn1_all_solvents(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   real(wp), parameter :: qat(*) = [&
      &-8.99890404486076E-2_wp, 9.42168087556583E-2_wp,-1.49387631509499E-1_wp, &
      &-2.99114121895542E-1_wp, 4.85527734875224E-1_wp,-6.83156326406137E-2_wp, &
      & 1.50011293889337E-2_wp, 2.79368544459465E-1_wp,-1.24072452878322E-1_wp, &
      &-9.36760994051244E-2_wp,-2.19062123031622E-1_wp, 2.14538817685587E-1_wp, &
      & 3.06156726072831E-1_wp,-3.86105514712244E-1_wp,-1.51265171389388E-3_wp, &
      & 3.64255069977693E-2_wp]
   type(cds_input) :: input
   integer, parameter :: nsolvents = 25
   character(len=*), parameter :: solvents(*) = [character(len=nsolvents):: &
      & "acetone", "acetonitrile", "aniline", "benzaldehyde", "benzene", &
      & "ch2cl2", "chcl3", "cs2", "dioxane", "dmf", "dmso", "ethanol", &
      & "ether", "ethylacetate", "furane", "hexadecane", "hexane", &
      & "nitromethane", "methanol", "octanol", "phenol", "thf", "toluene", &
      & "water", "woctanol"] 
   real(wp), parameter :: refs(*) = [&
      &-1.87575467176401E-2_wp, -2.19756935070354E-2_wp, -7.59897506913909E-3_wp, &
      &-1.28403478505020E-2_wp, -1.39686149805164E-2_wp, -1.08664447124936E-2_wp, &
      &-1.04964421005823E-2_wp, -1.14057753202729E-2_wp, -7.06543816921921E-3_wp, &
      &-1.44521134955677E-2_wp, -1.44911028376612E-2_wp, -8.97886030389678E-3_wp, &
      &-1.95763354166587E-2_wp, -1.14400229683406E-2_wp, -8.60633510983436E-3_wp, &
      &-1.12789113389271E-2_wp, -1.11505748030504E-2_wp, -8.81015006824253E-3_wp, &
      &-9.43366007096800E-3_wp, -9.76784539429431E-3_wp, -5.54432225159284E-3_wp, &
      &-1.20189216613106E-2_wp, -1.09141276818639E-2_wp, -4.39565407359322E-3_wp, &
      &-1.03868393814325E-2_wp]
   integer :: i

   call get_structure(mol, "MB16-43", "04")

   ! Check GFN1/ALPB for all available solvents
   do i = 1, nsolvents
      solvent = get_solvent_data(solvents(i))
      input = cds_input(solvent=solvent%solvent, alpb=.true.)
      call test_e(error, mol, input, qat, refs(i), method='gfn1') 
      if (allocated(error)) return
   end do 

end subroutine test_e_alpb_gfn1_all_solvents

subroutine test_e_alpb_gfn2_all_solvents(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   real(wp), parameter :: qat(*) = [&
      & 2.29208822115185E-1_wp, 4.70816658242009E-2_wp,-3.52834459119718E-2_wp, &
      & 3.09012847396269E-2_wp, 3.28898468854920E-1_wp,-2.01747405019535E-1_wp, &
      & 5.46554362391008E-2_wp,-1.09681283064574E-1_wp,-3.47340505091849E-1_wp, &
      & 1.84567817865267E-1_wp,-2.07552337277185E-1_wp, 4.67140380802351E-1_wp, &
      &-1.84261319200178E-2_wp,-1.05015595324833E-1_wp, 6.52511545312054E-2_wp, &
      &-3.82658324740237E-1_wp]
   type(cds_input) :: input
   integer, parameter :: nsolvents = 25
   character(len=*), parameter :: solvents(*) = [character(len=nsolvents):: &
      & "acetone", "acetonitrile", "aniline", "benzaldehyde", "benzene", &
      & "ch2cl2", "chcl3", "cs2", "dioxane", "dmf", "dmso", "ethanol", &
      & "ether", "ethylacetate", "furane", "hexadecane", "hexane", &
      & "nitromethane", "methanol", "octanol", "phenol", "thf", "toluene", &
      & "water", "woctanol"] 
   real(wp), parameter :: refs(*) = [&
      &-2.05399633856027E-2_wp, -1.76286670133248E-2_wp, -1.52489808627813E-2_wp, &
      &-1.61094315706730E-2_wp, -2.00524539538480E-2_wp, -2.04518654284223E-2_wp, &
      &-1.89495890022200E-2_wp, -1.83634224905815E-2_wp, -1.35338999058532E-2_wp, &
      &-2.02119670921433E-2_wp, -2.06860521914816E-2_wp, -1.55826272873075E-2_wp, &
      &-1.91024778367152E-2_wp, -1.64456391051830E-2_wp, -1.51588817057209E-2_wp, &
      &-7.85038297075149E-3_wp, -1.80332280208901E-2_wp, -1.27398470763579E-2_wp, &
      &-1.43153922624655E-2_wp,  1.17718049638770E-3_wp, -1.25432724254740E-2_wp, &
      &-2.00228656875909E-2_wp, -1.75195809653790E-2_wp,  1.88693640907118E-3_wp, &
      &-1.59803235935055E-2_wp]
   integer :: i

   call get_structure(mol, "MB16-43", "05")

   ! Check GFN2/ALPB for all available solvents
   do i = 1, nsolvents
      solvent = get_solvent_data(solvents(i))
      input = cds_input(solvent=solvent%solvent, alpb=.true.)
      call test_e(error, mol, input, qat, refs(i), method='gfn2') 
      if (allocated(error)) return
   end do 

end subroutine test_e_alpb_gfn2_all_solvents

subroutine test_e_gbsa_gfn1_all_solvents(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   real(wp), parameter :: qat(*) = [&
      & 2.08159387594211E-1_wp,-3.78010519998818E-1_wp, 3.36498247356244E-2_wp, &
      &-4.11556158912895E-1_wp, 8.14928196660512E-2_wp,-2.00886649303053E-1_wp, &
      & 2.44756994282684E-1_wp, 2.54580499189089E-2_wp, 2.59835128092562E-1_wp, &
      & 4.21683321877209E-1_wp, 1.37097163086023E-1_wp, 4.06951664942900E-2_wp, &
      &-1.10955378625897E-1_wp,-6.44033540918074E-2_wp,-1.91525919028143E-1_wp, &
      &-9.54898757869102E-2_wp]
   type(cds_input) :: input
   integer, parameter :: nsolvents = 12
   character(len=*), parameter :: solvents(*) = [character(len=nsolvents):: &
      & "acetone", "acetonitrile", "benzene", "ch2cl2", "chcl3", "cs2", &
      & "dmso", "ether", "methanol", "thf", "toluene", "water"] 
   real(wp), parameter :: refs(*) = [&
      &-2.16720081179071E-3_wp, -3.28426923492598E-2_wp, -2.52277980102607E-2_wp, &
      &-2.41431963258825E-2_wp, -2.41431963258825E-2_wp, -4.54197252450546E-3_wp, &
      &-3.28426923492598E-2_wp, -2.62339810005497E-2_wp, -2.55870388212558E-2_wp, &
      &-2.95720285475705E-2_wp, -2.52277980102607E-2_wp, -1.87472790863901E-2_wp]
   integer :: i

   call get_structure(mol, "MB16-43", "06")

   ! Check GFN1/GBSA for all available solvents
   do i = 1, nsolvents
      solvent = get_solvent_data(solvents(i))
      input = cds_input(solvent=solvent%solvent, alpb=.false.)
      call test_e(error, mol, input, qat, refs(i), method='gfn1') 
      if (allocated(error)) return
   end do 

end subroutine test_e_gbsa_gfn1_all_solvents

subroutine test_e_gbsa_gfn2_all_solvents(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   real(wp), parameter :: qat(*) = [&
      &-1.57321098180703E-1_wp, 1.65233008998668E-1_wp, 3.22320267782066E-1_wp, &
      & 3.63564544135336E-2_wp, 4.85639267214320E-2_wp,-3.59203277893926E-1_wp, &
      &-1.93841260011383E-1_wp,-3.86495230324447E-1_wp, 3.10104147485353E-1_wp, &
      & 8.34907519580185E-2_wp,-3.62672063405622E-1_wp, 3.64143595819311E-1_wp, &
      & 3.34640678947868E-1_wp,-4.69881543486815E-1_wp,-1.89222615863620E-1_wp, &
      & 4.53784257040286E-1_wp]
   type(cds_input) :: input
   integer, parameter :: nsolvents = 14
   character(len=*), parameter :: solvents(*) = [character(len=nsolvents):: &
      & "acetone", "acetonitrile", "benzene", "ch2cl2", "chcl3", "cs2", &
      & "dmf", "dmso", "ether", "hexane", "methanol", "thf", "toluene", &
      & "water"]
   real(wp), parameter :: refs(*) = [&
      &-2.21027923191889E-2_wp, -1.67263825829947E-2_wp, -1.54769936490801E-2_wp, &
      &-1.61275987597537E-2_wp, -1.46478122238807E-2_wp, -1.64141563713530E-2_wp, &
      &-2.22619239865685E-2_wp, -2.50545882957244E-2_wp, -1.93615578636444E-2_wp, &
      &-1.49825471291675E-2_wp, -1.73962890782651E-2_wp, -2.06110330162246E-2_wp, &
      &-1.54769936490801E-2_wp, -8.02197393839715E-3_wp]
   integer :: i

   call get_structure(mol, "MB16-43", "07")

   ! Check GFN2/GBSA for all available solvents
   do i = 1, nsolvents
      solvent = get_solvent_data(solvents(i))
      input = cds_input(solvent=solvent%solvent, alpb=.false.)
      call test_e(error, mol, input, qat, refs(i), method='gfn2') 
      if (allocated(error)) return
   end do 

end subroutine test_e_gbsa_gfn2_all_solvents


subroutine test_e_charged_alpb_gfn1(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   type(cds_input) :: input
   real(wp), parameter :: qat(*) = [&
      & 2.91737167991831E-1_wp,-4.44921281646692E-1_wp, 7.03886898899541E-2_wp, &
      & 4.32458130745259E-2_wp, 3.90393832017139E-2_wp, 9.56766032864156E-2_wp, &
      & 6.01866392558221E-2_wp,-3.31751380042108E-1_wp, 1.56707781479786E-1_wp, &
      & 8.89443731456522E-2_wp,-6.03526873354187E-2_wp, 3.83058968439732E-2_wp, &
      & 9.51289165540499E-2_wp,-9.20860756307965E-2_wp, 7.12122392663975E-2_wp, &
      & 2.76742553014572E-1_wp,-4.38083248713717E-1_wp,-1.76798298145349E-1_wp, &
      & 2.14382387079637E-1_wp, 3.25215078814299E-1_wp,-4.30846325150764E-1_wp, &
      & 1.12908046155543E-1_wp, 6.61648434849400E-2_wp, 9.89171412174742E-2_wp, &
      & 5.80323177221752E-2_wp,-4.43388471029542E-1_wp, 3.38493755177292E-1_wp, &
      &-3.52969753592199E-1_wp, 4.59552645375000E-1_wp,-5.33442813398395E-1_wp, &
      &-5.23460418980519E-1_wp,-3.14158345734236E-1_wp, 8.63777453496141E-2_wp, &
      & 5.51896920278464E-2_wp, 5.60421076086023E-2_wp, 1.02875052304244E-1_wp, &
      & 5.43513415521492E-2_wp,-3.13791816210054E-1_wp, 1.68862983166011E-1_wp, &
      & 8.93759201291419E-2_wp,-8.90121909290432E-2_wp, 4.15150867426933E-2_wp, &
      & 1.22221651251480E-1_wp,-8.26447904844349E-2_wp, 1.00154406589010E-1_wp, &
      & 2.77572579099978E-1_wp,-4.29147369583175E-1_wp,-1.78581481555413E-1_wp, &
      & 2.09487890121871E-1_wp, 3.17109649407645E-1_wp,-4.62948099575570E-1_wp, &
      & 9.81620738022878E-2_wp, 5.14984224707990E-2_wp, 9.63222020737258E-2_wp, &
      & 3.80443799704811E-2_wp,-4.41189291092377E-1_wp, 3.13549746324888E-1_wp, &
      &-4.41335746902051E-1_wp, 3.01219329594079E-1_wp]

   call get_structure(mol, "UPU23", "0a")
   solvent = get_solvent_data("water")
   input = cds_input(solvent=solvent%solvent, alpb=.true.)
   call test_e(error, mol, input, qat, -1.74474048674407E-02_wp, method='gfn1')

end subroutine test_e_charged_alpb_gfn1

subroutine test_e_charged_alpb_gfn2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   type(cds_input) :: input
   real(wp), parameter :: qat(*) = [&
      & 2.91737167991831E-1_wp,-4.44921281646692E-1_wp, 7.03886898899541E-2_wp, &
      & 4.32458130745259E-2_wp, 3.90393832017139E-2_wp, 9.56766032864156E-2_wp, &
      & 6.01866392558221E-2_wp,-3.31751380042108E-1_wp, 1.56707781479786E-1_wp, &
      & 8.89443731456522E-2_wp,-6.03526873354187E-2_wp, 3.83058968439732E-2_wp, &
      & 9.51289165540499E-2_wp,-9.20860756307965E-2_wp, 7.12122392663975E-2_wp, &
      & 2.76742553014572E-1_wp,-4.38083248713717E-1_wp,-1.76798298145349E-1_wp, &
      & 2.14382387079637E-1_wp, 3.25215078814299E-1_wp,-4.30846325150764E-1_wp, &
      & 1.12908046155543E-1_wp, 6.61648434849400E-2_wp, 9.89171412174742E-2_wp, &
      & 5.80323177221752E-2_wp,-4.43388471029542E-1_wp, 3.38493755177292E-1_wp, &
      &-3.52969753592199E-1_wp, 4.59552645375000E-1_wp,-5.33442813398395E-1_wp, &
      &-5.23460418980519E-1_wp,-3.14158345734236E-1_wp, 8.63777453496141E-2_wp, &
      & 5.51896920278464E-2_wp, 5.60421076086023E-2_wp, 1.02875052304244E-1_wp, &
      & 5.43513415521492E-2_wp,-3.13791816210054E-1_wp, 1.68862983166011E-1_wp, &
      & 8.93759201291419E-2_wp,-8.90121909290432E-2_wp, 4.15150867426933E-2_wp, &
      & 1.22221651251480E-1_wp,-8.26447904844349E-2_wp, 1.00154406589010E-1_wp, &
      & 2.77572579099978E-1_wp,-4.29147369583175E-1_wp,-1.78581481555413E-1_wp, &
      & 2.09487890121871E-1_wp, 3.17109649407645E-1_wp,-4.62948099575570E-1_wp, &
      & 9.81620738022878E-2_wp, 5.14984224707990E-2_wp, 9.63222020737258E-2_wp, &
      & 3.80443799704811E-2_wp,-4.41189291092377E-1_wp, 3.13549746324888E-1_wp, &
      &-4.41335746902051E-1_wp, 3.01219329594079E-1_wp]

   call get_structure(mol, "UPU23", "0a")
   solvent = get_solvent_data("water")
   input = cds_input(solvent=solvent%solvent, alpb=.true.)
   call test_e(error, mol, input, qat, -7.40555251354138E-03_wp, method='gfn2')

end subroutine test_e_charged_alpb_gfn2

subroutine test_e_charged_gbsa_gfn1(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   type(cds_input) :: input
   real(wp), parameter :: qat(*) = [&
      & 2.91737167991831E-1_wp,-4.44921281646692E-1_wp, 7.03886898899541E-2_wp, &
      & 4.32458130745259E-2_wp, 3.90393832017139E-2_wp, 9.56766032864156E-2_wp, &
      & 6.01866392558221E-2_wp,-3.31751380042108E-1_wp, 1.56707781479786E-1_wp, &
      & 8.89443731456522E-2_wp,-6.03526873354187E-2_wp, 3.83058968439732E-2_wp, &
      & 9.51289165540499E-2_wp,-9.20860756307965E-2_wp, 7.12122392663975E-2_wp, &
      & 2.76742553014572E-1_wp,-4.38083248713717E-1_wp,-1.76798298145349E-1_wp, &
      & 2.14382387079637E-1_wp, 3.25215078814299E-1_wp,-4.30846325150764E-1_wp, &
      & 1.12908046155543E-1_wp, 6.61648434849400E-2_wp, 9.89171412174742E-2_wp, &
      & 5.80323177221752E-2_wp,-4.43388471029542E-1_wp, 3.38493755177292E-1_wp, &
      &-3.52969753592199E-1_wp, 4.59552645375000E-1_wp,-5.33442813398395E-1_wp, &
      &-5.23460418980519E-1_wp,-3.14158345734236E-1_wp, 8.63777453496141E-2_wp, &
      & 5.51896920278464E-2_wp, 5.60421076086023E-2_wp, 1.02875052304244E-1_wp, &
      & 5.43513415521492E-2_wp,-3.13791816210054E-1_wp, 1.68862983166011E-1_wp, &
      & 8.93759201291419E-2_wp,-8.90121909290432E-2_wp, 4.15150867426933E-2_wp, &
      & 1.22221651251480E-1_wp,-8.26447904844349E-2_wp, 1.00154406589010E-1_wp, &
      & 2.77572579099978E-1_wp,-4.29147369583175E-1_wp,-1.78581481555413E-1_wp, &
      & 2.09487890121871E-1_wp, 3.17109649407645E-1_wp,-4.62948099575570E-1_wp, &
      & 9.81620738022878E-2_wp, 5.14984224707990E-2_wp, 9.63222020737258E-2_wp, &
      & 3.80443799704811E-2_wp,-4.41189291092377E-1_wp, 3.13549746324888E-1_wp, &
      &-4.41335746902051E-1_wp, 3.01219329594079E-1_wp]

   call get_structure(mol, "UPU23", "0a")
   solvent = get_solvent_data("water")
   input = cds_input(solvent=solvent%solvent, alpb=.false.)
   call test_e(error, mol, input, qat, 8.78720929142896E-03_wp, method='gfn1')

end subroutine test_e_charged_gbsa_gfn1

subroutine test_e_charged_gbsa_gfn2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   type(cds_input) :: input
   real(wp), parameter :: qat(*) = [&
      & 2.91737167991831E-1_wp,-4.44921281646692E-1_wp, 7.03886898899541E-2_wp, &
      & 4.32458130745259E-2_wp, 3.90393832017139E-2_wp, 9.56766032864156E-2_wp, &
      & 6.01866392558221E-2_wp,-3.31751380042108E-1_wp, 1.56707781479786E-1_wp, &
      & 8.89443731456522E-2_wp,-6.03526873354187E-2_wp, 3.83058968439732E-2_wp, &
      & 9.51289165540499E-2_wp,-9.20860756307965E-2_wp, 7.12122392663975E-2_wp, &
      & 2.76742553014572E-1_wp,-4.38083248713717E-1_wp,-1.76798298145349E-1_wp, &
      & 2.14382387079637E-1_wp, 3.25215078814299E-1_wp,-4.30846325150764E-1_wp, &
      & 1.12908046155543E-1_wp, 6.61648434849400E-2_wp, 9.89171412174742E-2_wp, &
      & 5.80323177221752E-2_wp,-4.43388471029542E-1_wp, 3.38493755177292E-1_wp, &
      &-3.52969753592199E-1_wp, 4.59552645375000E-1_wp,-5.33442813398395E-1_wp, &
      &-5.23460418980519E-1_wp,-3.14158345734236E-1_wp, 8.63777453496141E-2_wp, &
      & 5.51896920278464E-2_wp, 5.60421076086023E-2_wp, 1.02875052304244E-1_wp, &
      & 5.43513415521492E-2_wp,-3.13791816210054E-1_wp, 1.68862983166011E-1_wp, &
      & 8.93759201291419E-2_wp,-8.90121909290432E-2_wp, 4.15150867426933E-2_wp, &
      & 1.22221651251480E-1_wp,-8.26447904844349E-2_wp, 1.00154406589010E-1_wp, &
      & 2.77572579099978E-1_wp,-4.29147369583175E-1_wp,-1.78581481555413E-1_wp, &
      & 2.09487890121871E-1_wp, 3.17109649407645E-1_wp,-4.62948099575570E-1_wp, &
      & 9.81620738022878E-2_wp, 5.14984224707990E-2_wp, 9.63222020737258E-2_wp, &
      & 3.80443799704811E-2_wp,-4.41189291092377E-1_wp, 3.13549746324888E-1_wp, &
      &-4.41335746902051E-1_wp, 3.01219329594079E-1_wp]

   call get_structure(mol, "UPU23", "0a")
   solvent = get_solvent_data("water")
   input = cds_input(solvent=solvent%solvent, alpb=.false.)
   call test_e(error, mol, input, qat, -1.68750629525887E-02_wp, method='gfn2')

end subroutine test_e_charged_gbsa_gfn2


subroutine test_g_cds(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   type(cds_input) :: input
   real(wp), parameter :: qat(*) = [&
      & 2.08159387594211E-1_wp,-3.78010519998818E-1_wp, 3.36498247356244E-2_wp, &
      &-4.11556158912895E-1_wp, 8.14928196660512E-2_wp,-2.00886649303053E-1_wp, &
      & 2.44756994282684E-1_wp, 2.54580499189089E-2_wp, 2.59835128092562E-1_wp, &
      & 4.21683321877209E-1_wp, 1.37097163086023E-1_wp, 4.06951664942900E-2_wp, &
      &-1.10955378625897E-1_wp,-6.44033540918074E-2_wp,-1.91525919028143E-1_wp, &
      &-9.54898757869102E-2_wp]

   call get_structure(mol, "MB16-43", "06")
   solvent = get_solvent_data("water")
   input = cds_input(solvent=solvent%solvent, alpb=.true.)
   call test_g(error, mol, input, qat, method='gfn2')

end subroutine test_g_cds


subroutine test_g_cds_nonscf(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   type(cds_input) :: input

   call get_structure(mol, "MB16-43", "07")
   solvent = get_solvent_data("water")
   input = cds_input(solvent=solvent%solvent, alpb=.true.)
   call test_g_nonscf(error, mol, input, method='gfn2')

end subroutine test_g_cds_nonscf


subroutine test_p_cds(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   type(cds_input) :: input
   real(wp), parameter :: qat(*) = [&
      &-2.05668345919710E-1_wp,-3.99553123071811E-1_wp, 3.29242774348191E-1_wp, &
      &-3.11737933844111E-1_wp, 3.58851882478133E-2_wp, 3.21886835736497E-1_wp, &
      & 4.14743455841314E-2_wp, 2.95727359478547E-2_wp,-5.06347224522431E-1_wp, &
      & 3.43067182413129E-1_wp, 6.88373767679515E-1_wp, 7.03357390141253E-2_wp, &
      &-9.62424552888750E-2_wp,-1.32209348056625E-1_wp, 9.78998441832186E-2_wp, &
      &-3.05979982450903E-1_wp]

   call get_structure(mol, "MB16-43", "08")
   solvent = get_solvent_data("water")
   input = cds_input(solvent=solvent%solvent, alpb=.true.)
   call test_p(error, mol, input, qat, method='gfn2')

end subroutine test_p_cds


subroutine test_unsupported_solvent(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   real(wp), parameter :: qat(*) = [&
      &-8.99890404486076E-2_wp, 9.42168087556583E-2_wp,-1.49387631509499E-1_wp, &
      &-2.99114121895542E-1_wp, 4.85527734875224E-1_wp,-6.83156326406137E-2_wp, &
      & 1.50011293889337E-2_wp, 2.79368544459465E-1_wp,-1.24072452878322E-1_wp, &
      &-9.36760994051244E-2_wp,-2.19062123031622E-1_wp, 2.14538817685587E-1_wp, &
      & 3.06156726072831E-1_wp,-3.86105514712244E-1_wp,-1.51265171389388E-3_wp, &
      & 3.64255069977693E-2_wp]
   type(cds_input) :: input

   call get_structure(mol, "MB16-43", "04")

   ! Check GFN1/GBSA unavailable solvent
   solvent = get_solvent_data("aniline")
   input = cds_input(solvent=solvent%solvent, alpb=.false.)
   call get_cds_param(input, mol, 'gfn1', error)

end subroutine test_unsupported_solvent


end module test_solvation_cds

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/lapack/sygvd.f90
!> Provides an inverface to symmetric divide-and-conquer solver

!> Wrapper to symmetric divide-and-conquer solver for general eigenvalue problems
module tblite_lapack_sygvd
   use mctc_env, only : sp, dp, wp, error_type, fatal_error
   use tblite_output_format, only : format_string
   use tblite_scf_diag, only : diag_solver_type
   implicit none
   private

   public :: new_sygvd


   interface lapack_sygvd
      pure subroutine ssygvd(itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, &
            & iwork, liwork, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(inout) :: b(ldb, *)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine ssygvd
      pure subroutine dsygvd(itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, &
            & iwork, liwork, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(inout) :: b(ldb, *)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine dsygvd
   end interface lapack_sygvd


   !> Wrapper class for solving symmetric general eigenvalue problems
   type, public, extends(diag_solver_type) :: sygvd_solver
      private
      integer :: n = 0
      integer, allocatable :: iwork(:)
      real(sp), allocatable :: swork(:)
      real(sp), allocatable :: sbmat(:, :)
      real(dp), allocatable :: dwork(:)
      real(dp), allocatable :: dbmat(:, :)
   contains
      procedure :: solve_sp
      procedure :: solve_dp
   end type sygvd_solver

contains

subroutine new_sygvd(self, overlap, nel, kt)
   type(sygvd_solver), intent(out) :: self
   real(wp), intent(in) :: overlap(:, :)
   real(wp), intent(in) :: nel(:)
   real(wp), intent(in) :: kt
   self%n = size(overlap, 1)
   self%nel = nel
   self%kt = kt
end subroutine new_sygvd

subroutine solve_sp(self, hmat, smat, eval, error)
   class(sygvd_solver), intent(inout) :: self
   real(sp), contiguous, intent(inout) :: hmat(:, :)
   real(sp), contiguous, intent(in) :: smat(:, :)
   real(sp), contiguous, intent(inout) :: eval(:)
   type(error_type), allocatable, intent(out) :: error
   integer :: info, lswork, liwork

   if (self%n == 0) then
      self%n = size(hmat, 1)
   end if
   if (.not.allocated(self%swork)) then
      allocate(self%swork(1 + 6*self%n + 2*self%n**2))
   end if
   if (.not.allocated(self%iwork)) then
      allocate(self%iwork(3 + 5*self%n))
   end if
   self%sbmat = smat
   lswork = size(self%swork)
   liwork = size(self%iwork)

   call lapack_sygvd(1, 'v', 'u', self%n, hmat, self%n, self%sbmat, self%n, eval, &
      & self%swork, lswork, self%iwork, liwork, info)

   call handle_info(error, info)

end subroutine solve_sp

subroutine solve_dp(self, hmat, smat, eval, error)
   class(sygvd_solver), intent(inout) :: self
   real(dp), contiguous, intent(inout) :: hmat(:, :)
   real(dp), contiguous, intent(in) :: smat(:, :)
   real(dp), contiguous, intent(inout) :: eval(:)
   type(error_type), allocatable, intent(out) :: error
   integer :: info, ldwork, liwork

   if (self%n == 0) then
      self%n = size(hmat, 1)
   end if
   if (.not.allocated(self%dwork)) then
      allocate(self%dwork(1 + 6*self%n + 2*self%n**2))
   end if
   if (.not.allocated(self%iwork)) then
      allocate(self%iwork(3 + 5*self%n))
   end if
   self%dbmat = smat
   ldwork = size(self%dwork)
   liwork = size(self%iwork)

   call lapack_sygvd(1, 'v', 'u', self%n, hmat, self%n, self%dbmat, self%n, eval, &
      & self%dwork, ldwork, self%iwork, liwork, info)

   call handle_info(error, info)

end subroutine solve_dp

subroutine handle_info(error, info)
   type(error_type), allocatable, intent(out) :: error
   integer, intent(in) :: info

   if (info /= 0) then
      call fatal_error(error, "(sygvd) failed to solve eigenvalue problem.&
         & info="//format_string(info, '(i0)'))
   end if
end subroutine handle_info

end module tblite_lapack_sygvd

!> High-level module of the ddX software
module ddx
! Get ddcosmo-module
use ddx_cosmo
! Get ddpcm-module
use ddx_pcm
! Get ddlpb-module
use ddx_lpb
implicit none

contains

!> @defgroup Fortran_interface_core Fortran interface: core routines

!> Read the configuration from ddX input file and return a ddx_data
!! structure
!!
!> @ingroup Fortran_interface_core
!! @param[in] fname: Filename containing all the required info
!! @param[out] ddx_data: Object containing all inputs
!! @param[out] tol: tolerance for iterative solvers
!! @param[out] charges: charge array, size(nsph)
!! @param[inout] ddx_error: ddX error
!!
subroutine ddfromfile(fname, ddx_data, tol, charges, ddx_error)
    implicit none
    character(len=*), intent(in) :: fname
    type(ddx_type), intent(out) :: ddx_data
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(out) :: tol
    real(dp), allocatable, intent(out) :: charges(:)
    ! Local variables
    integer :: nproc, model, lmax, ngrid, force, fmm, pm, pl, &
        & nsph, i, matvecmem, maxiter, jacobi_ndiis, &
        & istatus
    real(dp) :: eps, se, eta, kappa
    real(dp), allocatable :: csph(:, :), radii(:)
    character(len=255) :: output_filename
    !! Read all the parameters from the file
    ! Open a configuration file
    open(unit=100, file=fname, form='formatted', access='sequential')
    ! Printing flag
    read(100, *) output_filename
    ! Number of OpenMP threads to be used
    read(100, *) nproc
    if(nproc .lt. 0) then
        call update_error(ddx_error, "Error on the 2nd line of a config " // &
            & "file " // trim(fname) // ": `nproc` must be a positive " // &
            & "integer value.")
    end if
    ! Model to be used: 1 for COSMO, 2 for PCM and 3 for LPB
    read(100, *) model
    if((model .lt. 1) .or. (model .gt. 3)) then
        call update_error(ddx_error, "Error on the 3rd line of a config file " // &
            & trim(fname) // ": `model` must be an integer of a value " // &
            & "1, 2 or 3.")
    end if
    ! Max degree of modeling spherical harmonics
    read(100, *) lmax
    if(lmax .lt. 0) then
        call update_error(ddx_error, "Error on the 4th line of a config file " // &
            & trim(fname) // ": `lmax` must be a non-negative integer value.")
    end if
    ! Approximate number of Lebedev points
    read(100, *) ngrid
    if(ngrid .lt. 0) then
        call update_error(ddx_error, "Error on the 5th line of a config file " // &
            & trim(fname) // ": `ngrid` must be a non-negative integer value.")
    end if
    ! Dielectric permittivity constant of the solvent
    read(100, *) eps
    if(eps .lt. zero) then
        call update_error(ddx_error, "Error on the 6th line of a config file " // &
            & trim(fname) // ": `eps` must be a non-negative floating " // &
            & "point value.")
    end if
    ! Shift of the regularized characteristic function
    read(100, *) se
    if((se .lt. -one) .or. (se .gt. one)) then
        call update_error(ddx_error, "Error on the 7th line of a config file " // &
            & trim(fname) // ": `se` must be a floating point value in a " // &
            & " range [-1, 1].")
    end if
    ! Regularization parameter
    read(100, *) eta
    if((eta .lt. zero) .or. (eta .gt. one)) then
        call update_error(ddx_error, "Error on the 8th line of a config file " // &
            & trim(fname) // ": `eta` must be a floating point value " // &
            & "in a range [0, 1].")
    end if
    ! Debye H\"{u}ckel parameter
    read(100, *) kappa
    if(kappa .lt. zero) then
        call update_error(ddx_error, "Error on the 9th line of a config file " // &
            & trim(fname) // ": `kappa` must be a non-negative floating " // &
            & "point value.")
    end if
    ! whether the (sparse) matrices are precomputed and kept in memory (1)
    ! or not (0).
    read(100, *) matvecmem 
    if((matvecmem.lt. 0) .or. (matvecmem .gt. 1)) then
        call update_error(ddx_error, "Error on the 10th line of a config " // &
            & "file " // trim(fname) // ": `matvecmem` must be an " // &
            & "integer value of a value 0 or 1.")
    end if
    ! Relative convergence threshold for the iterative solver
    read(100, *) tol
    if((tol .lt. 1d-14) .or. (tol .gt. one)) then
        call update_error(ddx_error, "Error on the 12th line of a config " // &
            & "file " // trim(fname) // ": `tol` must be a floating " // &
            & "point value in a range [1d-14, 1].")
    end if
    ! Maximum number of iterations for the iterative solver
    read(100, *) maxiter
    if((maxiter .le. 0)) then
        call update_error(ddx_error, "Error on the 13th line of a config " // &
            & "file " // trim(fname) // ": `maxiter` must be a positive " // &
            & " integer value.")
    end if
    ! Number of extrapolation points for Jacobi/DIIS solver
    read(100, *) jacobi_ndiis
    if((jacobi_ndiis .lt. 0)) then
        call update_error(ddx_error, "Error on the 14th line of a config " // &
            & "file " // trim(fname) // ": `jacobi_ndiis` must be a " // &
            & "non-negative integer value.")
    end if
    ! Whether to compute (1) or not (0) forces as analytical gradients
    read(100, *) force
    if((force .lt. 0) .or. (force .gt. 1)) then
        call update_error(ddx_error, "Error on the 17th line of a config " // &
            & "file " // trim(fname) // ": `force` must be an integer " // &
            "value of a value 0 or 1.")
    end if
    ! Whether to use (1) or not (0) the FMM to accelerate computations
    read(100, *) fmm
    if((fmm .lt. 0) .or. (fmm .gt. 1)) then
        call update_error(ddx_error, "Error on the 18th line of a config " // &
            & "file " // trim(fname) // ": `fmm` must be an integer " // &
            & "value of a value 0 or 1.")
    end if
    ! Max degree of multipole spherical harmonics for the FMM
    read(100, *) pm
    if(pm .lt. 0) then
        call update_error(ddx_error, "Error on the 19th line of a config " // &
            & "file " // trim(fname) // ": `pm` must be a non-negative " // &
            & "integer value.")
    end if
    ! Max degree of local spherical harmonics for the FMM
    read(100, *) pl
    if(pl .lt. 0) then
        call update_error(ddx_error, "Error on the 20th line of a config " // &
            & "file " // trim(fname) // ": `pl` must be a non-negative " // &
            & "integer value.")
    end if
    ! Number of input spheres
    read(100, *) nsph
    if(nsph .le. 0) then
        call update_error(ddx_error, "Error on the 21th line of a config " // &
            & "file " // trim(fname) // ": `nsph` must be a positive " // &
            & "integer value.")
    end if

    ! return in case of errors in the parameters
    if (ddx_error % flag .ne. 0) return

    ! Coordinates, radii and charges
    allocate(charges(nsph), csph(3, nsph), radii(nsph), stat=istatus)
    if(istatus .ne. 0) then
        call update_error(ddx_error, "Could not allocate space for " // &
            & "coordinates, radii and charges of atoms.")
        return
    end if
    do i = 1, nsph
        read(100, *) charges(i), csph(1, i), csph(2, i), csph(3, i), radii(i)
    end do
    ! Finish reading
    close(100)
    !! Convert Angstrom input into Bohr units
    csph = csph * tobohr
    radii = radii * tobohr
    kappa = kappa / tobohr

    ! adjust ngrid
    call closest_supported_lebedev_grid(ngrid)

    !! Initialize ddx_data object
    call ddinit(model, nsph, csph, radii, eps, ddx_data, ddx_error, &
        & force=force, kappa=kappa, eta=eta, shift=se, lmax=lmax, &
        & ngrid=ngrid, incore=matvecmem, maxiter=maxiter, &
        & jacobi_ndiis=jacobi_ndiis, enable_fmm=fmm, pm=pm, pl=pl, &
        & nproc=nproc, logfile=output_filename)

    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "ddinit returned an error, exiting")
        return
    end if
    !! Clean local temporary data
    deallocate(radii, csph, stat=istatus)
    if(istatus .ne. 0) then
        call update_error(ddx_error, "Could not deallocate space for " // &
            & "coordinates, radii and charges of atoms")
        return
    end if
end subroutine ddfromfile

!> Wrapper to the initialization routine which supports optional arguments.
!! This will make future maintenance easier.
!!
!> @ingroup Fortran_interface_core
!! @param[in] model: 1 for COSMO, 2 for PCM and 3 for LPB
!! @param[in] nsph: number of spheres n > 0
!! @param[in] coords: coordinates of the spheres, size (3, nsph)
!! @param[in] radii: radii of the spheres, size (nsph)
!! @param[in] eps: relative dielectric permittivity eps > 1
!! @param[out] ddx_data: Container for ddX data structures
!! @param[inout] ddx_error: ddX error
!!
!! @param[in,optional] force: 1 if forces are required and 0 otherwise
!! @param[in,optional] kappa: Debye-H\"{u}ckel parameter
!! @param[in,optional] eta: regularization parameter 0 < eta <= 1
!! @param[in,optional] shift: shift of characteristic function -1 for interior,
!!                     0 for centered and 1 for outer regularization
!! @param[in,optional] lmax: Maximal degree of modeling spherical harmonics,
!!                     `lmax` >= 0
!! @param[in,optional] ngrid: Number of Lebedev grid points `ngrid` >= 0
!! @param[in,optional] incore: handling of the sparse matrices, 1 for
!!                     precomputing them and keeping them in memory,
!!                     0 for assembling the matrix-vector products on-the-fly
!! @param[in,optional] maxiter: Maximum number of iterations for the
!!                     iterative solver,  maxiter > 0
!! @param[in,optional] jacobi_ndiis: Number of extrapolation points for
!!                     the  Jacobi/DIIS solver, ndiis >= 0
!! @param[in,optional] enable_fmm: 1 to use FMM acceleration and 0 otherwise
!! @param[in,optional] pm: Maximal degree of multipole spherical harmonics.
!!                     Ignored in the case `fmm=0`. Value -1 means no
!!                     far-field FMM interactions are computed, `pm` >= -1
!! @param[in,optional] pl: Maximal degree of local spherical harmonics.
!!                     Ignored in the case `fmm=0`. Value -1 means no
!!                     far-field FMM interactions are computed, `pl` >= -1
!! @param[in,optional] nproc: Number of OpenMP threads, nproc >= 0.
!! @param[in,optional] logfile: file name for log information.
!!
subroutine ddinit(model, nsph, coords, radii, eps, ddx_data, ddx_error, &
        & force, kappa, eta, shift, lmax, ngrid, incore, maxiter, &
        & jacobi_ndiis, enable_fmm, pm, pl, nproc, logfile, adjoint, eps_int)

    ! mandatory arguments
    integer, intent(in) :: model, nsph
    real(dp), intent(in) :: coords(3, nsph), radii(nsph)
    type(ddx_type), target, intent(out) :: ddx_data
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(in) :: eps

    ! optional arguments
    integer, intent(in), optional :: force, adjoint, lmax, ngrid, incore, &
        & maxiter, jacobi_ndiis, enable_fmm, pm, pl, nproc
    real(dp), intent(in), optional :: kappa, eta, shift, eps_int
    character(len=255), intent(in), optional :: logfile

    ! local copies of the optional arguments with dummy default values
    integer :: local_force = 0
    integer :: local_adjoint = 0
    integer :: local_lmax = 6
    integer :: local_ngrid = 302
    integer :: local_incore = 0
    integer :: local_maxiter = 100
    integer :: local_jacobi_ndiis = 20
    integer :: local_enable_fmm = 1
    integer :: local_pm = 8
    integer :: local_pl = 8
    integer :: local_nproc = 1
    real(dp) :: local_kappa = 0.0d0
    real(dp) :: local_eta = 0.1d0
    real(dp) :: local_shift
    real(dp) :: local_eps_int = 1.0d0
    character(len=255) :: local_logfile = ""

    ! arrays for x, y, z coordinates
    real(dp), allocatable :: x(:), y(:), z(:)
    integer :: info

    ! Update local variables with provided optional arguments
    if (present(force)) local_force = force
    if (present(lmax)) local_lmax = lmax
    if (present(ngrid)) local_ngrid = ngrid
    if (present(incore)) local_incore = incore
    if (present(maxiter)) local_maxiter = maxiter
    if (present(jacobi_ndiis)) local_jacobi_ndiis = jacobi_ndiis
    if (present(enable_fmm)) local_enable_fmm = enable_fmm
    if (present(pm)) local_pm = pm
    if (present(pl)) local_pl = pl
    if (present(nproc)) local_nproc = nproc
    if (present(kappa)) local_kappa = kappa
    if (present(eta)) local_eta = eta
    if (present(logfile)) local_logfile = logfile

    ! for the shift eta the default value depends on the model
    ! ddCOSMO has an interal shift, ddPCM and ddLPB a symmetric shift
    if (present(shift)) then
        local_shift = shift
    else
        if (model.eq.1) then
            local_shift = -one
        else
            local_shift = zero
        end if
    end if

    ! this are not yet supported, but they will probably
    if (present(adjoint)) then
        local_adjoint = adjoint
        call update_error(ddx_error, &
            & "ddinit: adjoint argument is not yet supported")
        return
    end if
    if (present(eps_int)) then
        local_eps_int = eps_int
        call update_error(ddx_error, &
            & "ddinit: eps_int argument is not yet supported")
        return
    end if

    allocate(x(nsph), y(nsph), z(nsph), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "ddinit: allocation failed")
        return
    end if
    x = coords(1,:)
    y = coords(2,:)
    z = coords(3,:)

    call allocate_model(nsph, x, y, z, radii, model, local_lmax, local_ngrid, &
        & local_force, local_enable_fmm, local_pm, local_pl, local_shift, &
        & local_eta, eps, local_kappa, local_incore, local_maxiter, &
        & local_jacobi_ndiis, local_nproc, local_logfile, ddx_data, ddx_error)

    deallocate(x, y, z, stat=info)
    if (info.ne.0) then
        call update_error(ddx_error, "ddinit: deallocation failed")
        return
    end if
end subroutine ddinit

!> Main solver routine
!!
!! Solves the solvation problem, computes the energy, and if required
!! computes the forces.
!!
!> @ingroup Fortran_interface_core
!! @param[in] ddx_data: ddX object with all input information
!! @param[inout] state: ddx state (contains RHSs and solutions)
!! @param[in] electrostatics: electrostatic property container
!! @param[in] psi: RHS of the adjoint problem
!! @param[in] tol: tolerance for the linear system solvers
!! @param[out] esolv: solvation energy
!! @param[inout] ddx_error: ddX error
!! @param[out] force: Analytical forces (optional argument, only if
!!             required)
!! @param[in] read_guess: optional argument, if true read the guess
!!            from the state object
!!
subroutine ddrun(ddx_data, state, electrostatics, psi, tol, esolv, &
        & ddx_error, force, read_guess)
    type(ddx_type), intent(inout) :: ddx_data
    type(ddx_state_type), intent(inout) :: state
    type(ddx_electrostatics_type), intent(in) :: electrostatics
    real(dp), intent(in) :: psi(ddx_data % constants % nbasis, &
        & ddx_data % params % nsph)
    real(dp), intent(in) :: tol
    real(dp), intent(out) :: esolv
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(out), optional :: force(3, ddx_data % params % nsph)
    logical, intent(in), optional :: read_guess
    ! local variables
    logical :: do_guess

    ! decide if the guess has to be read or must be done
    if (present(read_guess)) then
        do_guess = .not.read_guess
    else
        do_guess = .true.
    end if

    ! if the forces are to be computed, but the array is not passed, raise
    ! an error
    if ((.not.present(force)) .and. (ddx_data % params % force .eq. 1)) then
        call update_error(ddx_error, &
            & "ddrun: forces are to be computed, but the optional force" // &
            & " array has not been passed.")
        return
    end if

    call setup(ddx_data % params, ddx_data % constants, &
        & ddx_data % workspace, state, electrostatics, psi, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "ddrun: setup returned an error, exiting")
        return
    end if

    ! solve the primal linear system
    if (do_guess) then
        call fill_guess(ddx_data % params, ddx_data % constants, &
            & ddx_data % workspace, state, tol, ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, &
                & "ddrun: fill_guess returned an error, exiting")
            return
        end if
    end if
    call solve(ddx_data % params, ddx_data % constants, &
        & ddx_data % workspace, state, tol, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "ddrun: solve returned an error, exiting")
        return
    end if

    ! compute the energy
    call energy(ddx_data % params, ddx_data % constants, &
        & ddx_data % workspace, state, esolv, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "ddrun: energy returned an error, exiting")
        return
    end if

    ! solve the primal linear system
    if (ddx_data % params % force .eq. 1) then
        if (do_guess) then
            call fill_guess_adjoint(ddx_data % params, ddx_data % constants, &
                & ddx_data % workspace, state, tol, ddx_error)
            if (ddx_error % flag .ne. 0) then
                call update_error(ddx_error, &
                    & "ddrun: fill_guess_adjoint returned an error, exiting")
                return
            end if
        end if
        call solve_adjoint(ddx_data % params, ddx_data % constants, &
            & ddx_data % workspace, state, tol, ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, &
                & "ddrun: solve_adjoint returned an error, exiting")
            return
        end if
    end if

    ! compute the forces
    if (ddx_data % params % force .eq. 1) then
        force = zero
        call solvation_force_terms(ddx_data % params, ddx_data % constants, &
            & ddx_data % workspace, state, electrostatics, force, ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, &
                & "ddrun: solvation_force_terms returned an error, exiting")
            return
        end if
    end if

end subroutine ddrun

!> Setup the state for the different models
!!
!> @ingroup Fortran_interface_core
!! @param[in] params: User specified parameters
!! @param[in] constants: Precomputed constants
!! @param[inout] workspace: Preallocated workspaces
!! @param[inout] state: ddx state (contains solutions and RHSs)
!! @param[in] electrostatics: electrostatic property container
!! @param[in] psi: Representation of the solute potential in spherical
!!     harmonics, size (nbasis, nsph)
!! @param[inout] ddx_error: ddX error
!!
subroutine setup(params, constants, workspace, state, electrostatics, &
        & psi, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_electrostatics_type), intent(in) :: electrostatics
    real(dp), intent(in) :: psi(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error

    if (params % model .eq. 1) then
        call cosmo_setup(params, constants, workspace, state, &
            & electrostatics % phi_cav, psi, ddx_error)
    else if (params % model .eq. 2) then
        call pcm_setup(params, constants, workspace, state, &
            & electrostatics % phi_cav, psi, ddx_error)
    else if (params % model .eq. 3) then
        call lpb_setup(params, constants, workspace, state, &
            & electrostatics % phi_cav, electrostatics % e_cav, &
            & psi, ddx_error)
    else
        call update_error(ddx_error, "Unknow model in setup.")
        return
    end if

end subroutine setup

!> Do a guess for the primal linear system for the different models
!!
!> @ingroup Fortran_interface_core
!! @param[in] params: User specified parameters
!! @param[inout] constants: Precomputed constants
!! @param[inout] workspace: Preallocated workspaces
!! @param[inout] state: ddx state (contains solutions and RHSs)
!! @param[in] tol: tolerance
!! @param[inout] ddx_error: ddX error
!!
subroutine fill_guess(params, constants, workspace, state, tol, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: tol
    type(ddx_error_type), intent(inout) :: ddx_error

    if (.not.state % rhs_done) then
        call update_error(ddx_error, &
            & "In fill_guess, the RHS is not initialized")
        return
    end if

    if (params % model .eq. 1) then
        call cosmo_guess(params, constants, workspace, state, ddx_error)
    else if (params % model .eq. 2) then
        call pcm_guess(params, constants, workspace, state, ddx_error)
    else if (params % model .eq. 3) then
        call lpb_guess(params, constants, workspace, state, tol, ddx_error)
    else
        call update_error(ddx_error, "Unknow model in fill_guess.")
        return
    end if

    if (ddx_error % flag .eq. 0) then
        state % guess_done = .true.
        state % solved = .false.
    end if

end subroutine fill_guess

!> Do a guess for the adjoint linear system for the different models
!!
!> @ingroup Fortran_interface_core
!! @param[in] params: User specified parameters
!! @param[inout] constants: Precomputed constants
!! @param[inout] workspace: Preallocated workspaces
!! @param[inout] state: ddx state (contains solutions and RHSs)
!! @param[in] tol: tolerance
!! @param[inout] ddx_error: ddX error
!!
subroutine fill_guess_adjoint(params, constants, workspace, state, tol, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: tol
    type(ddx_error_type), intent(inout) :: ddx_error

    if (.not.state % adjoint_rhs_done) then
        call update_error(ddx_error, &
            & "In fill_guess_adjoint, the adjoint RHS is not initialized")
        return
    end if

    if (params % model .eq. 1) then
        call cosmo_guess_adjoint(params, constants, workspace, state, ddx_error)
    else if (params % model .eq. 2) then
        call pcm_guess_adjoint(params, constants, workspace, state, ddx_error)
    else if (params % model .eq. 3) then
        call lpb_guess_adjoint(params, constants, workspace, state, tol, ddx_error)
    else
        call update_error(ddx_error, "Unknow model in fill_guess_adjoint.")
        return
    end if

    if (ddx_error % flag .eq. 0) then
        state % adjoint_guess_done = .true.
        state % adjoint_solved = .false.
    end if

end subroutine fill_guess_adjoint

!> Solve the primal linear system for the different models
!!
!> @ingroup Fortran_interface_core
!! @param[in] params       : General options
!! @param[in] constants    : Precomputed constants
!! @param[inout] workspace : Preallocated workspaces
!! @param[inout] state     : Solutions, guesses and relevant quantities
!! @param[in] tol          : Tolerance for the iterative solvers
!! @param[inout] ddx_error: ddX error
!!
subroutine solve(params, constants, workspace, state, tol, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: tol
    type(ddx_error_type), intent(inout) :: ddx_error

    if (.not.state % rhs_done) then
        call update_error(ddx_error, "In solve, the RHS is not initialized")
        return
    end if
    if (.not.(state % solved .or. state % guess_done)) then
        call update_error(ddx_error, &
            & "In solve, no guess or previous solution is provided")
        return
    end if

    if (params % model .eq. 1) then
        call cosmo_solve(params, constants, workspace, state, tol, ddx_error)
    else if (params % model .eq. 2) then
        call pcm_solve(params, constants, workspace, state, tol, ddx_error)
    else if (params % model .eq. 3) then
        call lpb_solve(params, constants, workspace, state, tol, ddx_error)
    else
        call update_error(ddx_error, "Unknow model in solve.")
        return
    end if

    if (ddx_error % flag .eq. 0) then
        state % solved = .true.
    end if

end subroutine solve

!> Solve the adjoint linear system for the different models
!!
!> @ingroup Fortran_interface_core
!! @param[in] params       : General options
!! @param[in] constants    : Precomputed constants
!! @param[inout] workspace : Preallocated workspaces
!! @param[inout] state     : Solutions, guesses and relevant quantities
!! @param[in] tol          : Tolerance for the iterative solvers
!! @param[inout] ddx_error: ddX error
!!
subroutine solve_adjoint(params, constants, workspace, state, tol, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: tol
    type(ddx_error_type), intent(inout) :: ddx_error

    if (.not.state % adjoint_rhs_done) then
        call update_error(ddx_error, &
            & "In solve_adjoint, the RHS is not initialized")
        return
    end if
    if (.not.(state % adjoint_solved .or. state % adjoint_guess_done)) then
        call update_error(ddx_error, &
            & "In solve_adjoint, no guess or previous solution is provided")
        return
    end if

    if (params % model .eq. 1) then
        call cosmo_solve_adjoint(params, constants, workspace, state, tol, ddx_error)
    else if (params % model .eq. 2) then
        call pcm_solve_adjoint(params, constants, workspace, state, tol, ddx_error)
    else if (params % model .eq. 3) then
        call lpb_solve_adjoint(params, constants, workspace, state, tol, ddx_error)
    else
        call update_error(ddx_error, "Unknow model in solve_adjoint.")
        return
    end if

    if (ddx_error % flag .eq. 0) then
        state % adjoint_solved = .true.
    end if

end subroutine solve_adjoint

!> Compute the energy for the different models
!!
!> @ingroup Fortran_interface_core
!! @param[in] params: General options
!! @param[in] constants: Precomputed constants
!! @param[inout] workspace: Preallocated workspaces
!! @param[in] state: ddx state (contains solutions and RHSs)
!! @param[out] solvation_energy: resulting energy
!! @param[inout] ddx_error: ddX error
!!
subroutine energy(params, constants, workspace, state, solvation_energy, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(in) :: workspace
    type(ddx_state_type), intent(in) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(out) :: solvation_energy

    ! dummy operation on unused interface arguments
    if (allocated(workspace % tmp_pot)) continue

    if (.not.state % solved) then
        call update_error(ddx_error, &
            & "In energy, the solution is not available.")
        return
    end if
    if (.not.state % adjoint_rhs_done) then
        call update_error(ddx_error, &
            & "In energy, the adjoint RHS is not initialized")
        return
    end if


    if (params % model .eq. 1) then
        call cosmo_energy(constants, state, solvation_energy, ddx_error)
    else if (params % model .eq. 2) then
        call pcm_energy(constants, state, solvation_energy, ddx_error)
    else if (params % model .eq. 3) then
        call lpb_energy(constants, state, solvation_energy, ddx_error)
    else
        call update_error(ddx_error, "Unknow model in energy.")
        return
    end if

end subroutine energy

!> Compute the solvation terms of the forces (solute aspecific) for the
!! different models. This must be summed to the solute specific term to get
!! the full forces
!!
!> @ingroup Fortran_interface_core
!! @param[in] params: General options
!! @param[in] constants: Precomputed constants
!! @param[inout] workspace: Preallocated workspaces
!! @param[inout] state: Solutions and relevant quantities
!! @param[in] electrostatics: Electrostatic properties container.
!! @param[out] force: Geometrical contribution to the forces
!! @param[inout] ddx_error: ddX error
!!
subroutine solvation_force_terms(params, constants, workspace, &
        & state, electrostatics, force, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_electrostatics_type), intent(in) :: electrostatics
    real(dp), intent(out) :: force(3, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error

    if (.not.state % solved) then
        call update_error(ddx_error, &
            & "In solvation_force_terms, the solution is not available.")
        return
    end if
    if (.not.state % adjoint_solved) then
        call update_error(ddx_error, &
            & "In solvation_force_terms, the adjoint solution is not available.")
        return
    end if
    if (.not.state % rhs_done) then
        call update_error(ddx_error, &
            & "In solvation_force_terms, the RHS is not initialized")
        return
    end if
    if (.not.state % adjoint_rhs_done) then
        call update_error(ddx_error, &
            & "In solvation_force_terms, the adjoint RHS is not initialized")
        return
    end if

    if (params % model .eq. 1) then
        call cosmo_solvation_force_terms(params, constants, workspace, &
            & state, electrostatics % e_cav, force, ddx_error)
    else if (params % model .eq. 2) then
        call pcm_solvation_force_terms(params, constants, workspace, &
            & state, electrostatics % e_cav, force, ddx_error)
    else if (params % model .eq. 3) then
        call lpb_solvation_force_terms(params, constants, workspace, &
            & state, electrostatics % g_cav, force, ddx_error)
    else
        call update_error(ddx_error, "Unknow model in solvation_force_terms.")
        return
    end if

end subroutine solvation_force_terms

end module ddx

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of the command-line interface of the tblite framework
module tblite_cli
   use, intrinsic :: iso_fortran_env, only : output_unit, error_unit, input_unit
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : filetype, get_filetype, to_symbol
   use tblite_argument, only : argument_list, len
   use tblite_cli_help, only : prog_name, help_text, help_text_run, help_text_param, &
      & help_text_fit, help_text_tagdiff
   use tblite_features, only : get_tblite_feature
   use tblite_solvation, only : solvation_input, cpcm_input, alpb_input, &
      & solvent_data, get_solvent_data
   use tblite_version, only : get_tblite_version
   implicit none
   private

   public :: get_arguments, driver_config, run_config, param_config, fit_config, &
      & tagdiff_config


   type, abstract :: driver_config
      logical :: color = .false.
   end type driver_config

   type, extends(driver_config) :: run_config
      character(len=:), allocatable :: input
      integer, allocatable :: input_format
      logical :: grad = .false.
      character(len=:), allocatable :: grad_output
      integer :: verbosity = 2
      integer, allocatable :: charge
      integer, allocatable :: spin
      character(len=:), allocatable :: method
      character(len=:), allocatable :: param
      character(len=:), allocatable :: guess
      logical :: json = .false.
      character(len=:), allocatable :: json_output
      type(solvation_input), allocatable :: solvation
      real(wp) :: accuracy = 1.0_wp
      real(wp) :: etemp = 300.0_wp
      real(wp), allocatable :: efield(:)
      logical :: spin_polarized = .false.
   end type run_config

   type, extends(driver_config) :: param_config
      integer :: verbosity = 2
      character(len=:), allocatable :: input
      character(len=:), allocatable :: output
      character(len=:), allocatable :: method
   end type param_config

   type, extends(driver_config) :: fit_config
      integer :: verbosity = 2
      character(len=:), allocatable :: prog
      character(len=:), allocatable :: param
      character(len=:), allocatable :: input
      character(len=:), allocatable :: copy_input
      logical :: dry_run = .false.
   end type fit_config

   type, extends(driver_config) :: tagdiff_config
      character(len=:), allocatable :: actual
      character(len=:), allocatable :: reference
      logical :: fit = .false.
   end type tagdiff_config

contains

subroutine get_arguments(config, error)

   !> Command line options
   class(driver_config), allocatable, intent(out) :: config

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(argument_list) :: list
   integer :: iarg, narg
   logical :: getopts
   character(len=:), allocatable :: arg
   logical, allocatable :: color

   list = argument_list()

   iarg = 0
   getopts = .true.
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      select case(arg)
      case("--help")
         write(output_unit, '(a)') help_text
         stop
      case("--version")
         call version(output_unit)
         stop
      case default
         iarg = iarg - 1
         allocate(run_config :: config)
         exit
      case("--color")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for color options")
            exit
         end if
         select case(arg)
         case default
            call fatal_error(error, "Unknown option for color support '"//arg//"'")
         case("always")
            color = .true.
         case("never")
            color = .false.
         case("auto")
            color = get_tblite_feature("color")
         end select
      case("fit")
         allocate(fit_config :: config)
         exit
      case("param")
         allocate(param_config :: config)
         exit
      case("run")
         allocate(run_config :: config)
         exit
      case("tagdiff")
         allocate(tagdiff_config :: config)
         exit
      end select
   end do
   if (allocated(error)) return

   if (.not.allocated(config)) then
      write(output_unit, '(a)') help_text
      error stop
   end if

   select type(config)
   type is (fit_config)
      call get_fit_arguments(config, list, iarg, error)
   type is (param_config)
      call get_param_arguments(config, list, iarg, error)
   type is (run_config)
      call get_run_arguments(config, list, iarg, error)
   type is (tagdiff_config)
      call get_tagdiff_arguments(config, list, iarg, error)
   end select
   if (allocated(error)) return

   if (allocated(color)) config%color = color

end subroutine get_arguments


subroutine get_run_arguments(config, list, start, error)

   !> Command line options
   type(run_config), intent(out) :: config

   !> List of command line arguments
   type(argument_list), intent(in) :: list

   !> First command line argument
   integer, intent(in) :: start

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   logical :: getopts
   character(len=:), allocatable :: arg
   logical :: alpb
   type(solvent_data) :: solvent

   iarg = start
   getopts = .true.
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      if (.not.getopts) then
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end if
      select case(arg)
      case("--")
         getopts = .false.

      case("--help")
         write(output_unit, '(a)') help_text_run
         stop

      case("--version")
         call version(output_unit)
         stop

      case("-v", "-vv", "--verbose")
         config%verbosity = config%verbosity + 1
         if (arg == "-vv") config%verbosity = config%verbosity + 1

      case("-s", "-ss", "--silent")
         config%verbosity = config%verbosity - 1
         if (arg == "-ss") config%verbosity = config%verbosity - 1

      case default
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit

      case("-i", "--input")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for input format")
            exit
         end if
         config%input_format = get_filetype("."//arg)

      case("-c", "--charge")
         iarg = iarg + 1
         allocate(config%charge)
         call list%get(iarg, arg)
         call get_argument_as_int(arg, config%charge, error)
         if (allocated(error)) exit

      case("--spin")
         iarg = iarg + 1
         allocate(config%spin)
         call list%get(iarg, arg)
         call get_argument_as_int(arg, config%spin, error)
         if (allocated(error)) exit

      case("--spin-polarized")
         config%spin_polarized = .true.

      case("--method")
         if (allocated(config%param)) then
            call fatal_error(error, "Cannot specify method if parameter file is provided")
            exit
         end if
         iarg = iarg + 1
         call list%get(iarg, config%method)
         if (.not.allocated(config%method)) then
            call fatal_error(error, "Missing argument for method")
            exit
         end if

      case("--guess")
         iarg = iarg + 1
         call list%get(iarg, config%guess)

      case("--cpcm")
         if (allocated(config%solvation)) then
            call fatal_error(error, "Cannot use CPCM if ALPB/GBSA is enabled")
            exit
         end if
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for CPCM")
            exit
         end if

         solvent = get_solvent_data(arg)
         if (solvent%eps <= 0.0_wp) then
            call get_argument_as_real(arg, solvent%eps, error)
         end if
         if (allocated(error)) exit
         allocate(config%solvation)
         config%solvation%cpcm = cpcm_input(solvent%eps)

      case("--alpb", "--gbsa")
         if (allocated(config%solvation)) then
            call fatal_error(error, "Cannot use ALPB/GBSA if CPCM is enabled")
            exit
         end if
         alpb = arg == "--alpb"
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for ALPB/GBSA")
            exit
         end if

         solvent = get_solvent_data(arg)
         if (solvent%eps <= 0.0_wp) then
            call get_argument_as_real(arg, solvent%eps, error)
         end if
         if (allocated(error)) exit
         allocate(config%solvation)
         config%solvation%alpb = alpb_input(solvent%eps, alpb=alpb)

      case("--param")
         if (allocated(config%param)) then
            call fatal_error(error, "Cannot specify parameter file if method is provided")
            exit
         end if
         iarg = iarg + 1
          call list%get(iarg, config%param)
         if (.not.allocated(config%param)) then
            call fatal_error(error, "Missing argument for param")
            exit
         end if

      case("--acc")
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%accuracy, error)
         if (allocated(error)) exit

      case("--etemp")
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%etemp, error)
         if (allocated(error)) exit

      case("--efield")
         iarg = iarg + 1
         call list%get(iarg, arg)
         allocate(config%efield(3))
         call get_argument_as_realv(arg, config%efield, error)
         if (allocated(error)) exit

      case("--grad")
         config%grad = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (allocated(arg)) then
            if (arg(1:1) == "-") then
               iarg = iarg - 1
               cycle
            end if
            call move_alloc(arg, config%grad_output)
         end if

      case("--json")
         config%json = .true.
         config%json_output = "tblite.json"
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (allocated(arg)) then
            if (arg(1:1) == "-") then
               iarg = iarg - 1
               cycle
            end if
            call move_alloc(arg, config%json_output)
         end if
      end select
   end do

   if (.not.(allocated(config%input))) then
      if (.not.allocated(error)) then
         write(output_unit, '(a)') help_text_run
         error stop
      end if
   end if

   if (.not.allocated(config%guess)) config%guess = "sad"

   if (config%grad .and. .not.allocated(config%grad_output) .and. .not.config%json) then
      config%grad_output = "tblite.txt"
   end if
end subroutine get_run_arguments


subroutine get_param_arguments(config, list, start, error)

   !> Command line options
   type(param_config), intent(out) :: config

   !> List of command line arguments
   type(argument_list), intent(in) :: list

   !> First command line argument
   integer, intent(in) :: start

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   logical :: getopts
   character(len=:), allocatable :: arg

   iarg = start
   getopts = .true.
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      if (.not.getopts) then
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end if
      select case(arg)
      case("--")
         getopts = .false.
      case("--help")
         write(output_unit, '(a)') help_text_param
         stop
      case("--version")
         call version(output_unit)
         stop
      case default
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      case("--method")
         iarg = iarg + 1
         call list%get(iarg, config%method)
         if (.not.allocated(config%method)) then
            call fatal_error(error, "Missing argument for method")
            exit
         end if
      case("--output")
         iarg = iarg + 1
         call list%get(iarg, config%output)
         if (.not.allocated(config%output)) then
            call fatal_error(error, "Missing argument for output")
            exit
         end if
      end select
   end do

   if (.not.any([allocated(config%input), allocated(config%method)])) then
      if (.not.allocated(error)) then
         write(output_unit, '(a)') help_text_param
         error stop
      end if
   end if
end subroutine get_param_arguments


subroutine get_fit_arguments(config, list, start, error)

   !> Command line options
   type(fit_config), intent(out) :: config

   !> List of command line arguments
   type(argument_list), intent(in) :: list

   !> First command line argument
   integer, intent(in) :: start

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   logical :: getopts
   character(len=:), allocatable :: arg

   config%prog = list%prog

   iarg = start
   getopts = .true.
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      if (.not.getopts) then
         if (.not.allocated(config%param)) then
            call move_alloc(arg, config%param)
            cycle
         end if
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end if
      select case(arg)
      case("--")
         getopts = .false.
      case("--help")
         write(output_unit, '(a)') help_text_fit
         stop
      case("--version")
         call version(output_unit)
         stop
      case("--dry-run")
         config%dry_run = .true.
      case("-v", "-vv", "--verbose")
         config%verbosity = config%verbosity + 1
         if (arg == "-vv") config%verbosity = config%verbosity + 1
      case("-s", "-ss", "--silent")
         config%verbosity = config%verbosity - 1
         if (arg == "-ss") config%verbosity = config%verbosity - 1
      case("--copy")
         iarg = iarg + 1
         call list%get(iarg, config%copy_input)
         if (.not.allocated(config%copy_input)) then
            call fatal_error(error, "Missing argument for copy")
            exit
         end if
      case default
         if (.not.allocated(config%param)) then
            call move_alloc(arg, config%param)
            cycle
         end if
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end select
   end do

   if (.not.allocated(config%input)) then
      if (.not.allocated(error)) then
         write(output_unit, '(a)') help_text_fit
         error stop
      end if
   end if
end subroutine get_fit_arguments


subroutine get_tagdiff_arguments(config, list, start, error)

   !> Command line options
   type(tagdiff_config), intent(out) :: config

   !> List of command line arguments
   type(argument_list), intent(in) :: list

   !> First command line argument
   integer, intent(in) :: start

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   logical :: getopts
   character(len=:), allocatable :: arg

   iarg = start
   getopts = .true.
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      if (.not.getopts) then
         if (.not.allocated(config%actual)) then
            call move_alloc(arg, config%actual)
            cycle
         end if
         if (.not.allocated(config%reference)) then
            call move_alloc(arg, config%reference)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end if
      select case(arg)
      case("--")
         getopts = .false.
      case("--help")
         write(output_unit, '(a)') help_text_tagdiff
         stop
      case("--version")
         call version(output_unit)
         stop
      case("--fit")
         config%fit = .true.
      case default
         if (.not.allocated(config%actual)) then
            call move_alloc(arg, config%actual)
            cycle
         end if
         if (.not.allocated(config%reference)) then
            call move_alloc(arg, config%reference)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end select
   end do

   if (.not.(allocated(config%actual).and.allocated(config%reference))) then
      if (.not.allocated(error)) then
         write(output_unit, '(a)') help_text_tagdiff
         error stop
      end if
   end if
end subroutine get_tagdiff_arguments


subroutine get_argument_as_real(arg, val, error)
   !> Index of command line argument, range [0:command_argument_count()]
   character(len=:), intent(in), allocatable :: arg
   !> Real value
   real(wp), intent(out) :: val
   !> Error handling
   type(error_type), allocatable :: error

   integer :: stat

   if (.not.allocated(arg)) then
      call fatal_error(error, "Cannot read real value, argument missing")
      return
   end if
   read(arg, *, iostat=stat) val
   if (stat /= 0) then
      call fatal_error(error, "Cannot read real value from '"//arg//"'")
      return
   end if

end subroutine get_argument_as_real


subroutine get_argument_as_realv(arg, val, error)
   !> Index of command line argument, range [0:command_argument_count()]
   character(len=:), intent(in), allocatable :: arg
   !> Real value
   real(wp), intent(out) :: val(:)
   !> Error handling
   type(error_type), allocatable :: error

   integer :: stat
   integer :: i
   character(len=*), parameter :: sep = ","
   character(len=:), allocatable :: targ

   if (.not.allocated(arg)) then
      call fatal_error(error, "Cannot read real value, argument missing")
      return
   end if
   allocate(character(len=len(arg)) :: targ)
   do i = 1, len(arg)
      if (arg(i:i) == sep) then
         targ(i:i) = " "
      else
         targ(i:i) = arg(i:i)
      end if
   end do
   read(targ, *, iostat=stat) val
   if (stat /= 0) then
      call fatal_error(error, "Cannot read real value from '"//arg//"'")
      return
   end if

end subroutine get_argument_as_realv


subroutine get_argument_as_int(arg, val, error)
   !> Index of command line argument, range [0:command_argument_count()]
   character(len=:), intent(in), allocatable :: arg
   !> Real value
   integer, intent(out) :: val
   !> Error handling
   type(error_type), allocatable :: error

   integer :: stat

   if (.not.allocated(arg)) then
      call fatal_error(error, "Cannot read integer value, argument missing")
      return
   end if
   read(arg, *, iostat=stat) val
   if (stat /= 0) then
      call fatal_error(error, "Cannot read integer value from '"//arg//"'")
      return
   end if

end subroutine get_argument_as_int


subroutine version(unit)
   integer, intent(in) :: unit
   character(len=:), allocatable :: version_string

   call get_tblite_version(string=version_string)
   write(unit, '(a, *(1x, a))') &
      & prog_name, "version", version_string

end subroutine version


end module tblite_cli

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Cavity, dispersion and surface contribution to the solvation free energy
module tblite_solvation_cds
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use mctc_io_math, only : matdet_3x3
   use tblite_blas, only : dot, gemv, symv
   use tblite_container_cache, only : container_cache
   use tblite_mesh_lebedev, only : grid_size, get_angular_grid, list_bisection
   use tblite_scf_info, only : scf_info, atom_resolved, not_used
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_solvation_surface, only : surface_integrator, new_surface_integrator
   use tblite_solvation_data, only : get_vdw_rad_cosmo
   use tblite_solvation_type, only : solvation_type
   implicit none
   private

   public :: cds_solvation, new_cds, cds_input

   !> Input for CDS model
   type :: cds_input
      !> Probe radius of the solvent
      real(wp) :: probe
      !> Number of angular grid points for integration
      integer :: nang
      !> Van-der-Waals radii for each species
      real(wp), allocatable :: rad(:)
      !> Surface tension for each species
      real(wp), allocatable :: tension(:)
      !> Hydrogen bonding strength for each species
      real(wp), allocatable :: hbond(:)
   end type cds_input

   !> Definition of the CDS model
   type, extends(solvation_type) :: cds_solvation
      !> Integrator for solvent accessible surface area
      type(surface_integrator) :: sasa
      !> Surface tension for each species
      real(wp), allocatable :: tension(:)
      !> Hydrogen bonding correction
      real(wp), allocatable :: hbond(:)
   contains
      !> Update cache from container
      procedure :: update
      !> Return dependency on density
      procedure :: variable_info
      !> Get solvation energy and gradient
      procedure :: get_engrad
      !> Get solvation energy
      procedure :: get_energy
      !> Get solvation potential
      procedure :: get_potential
      !> Get solvation gradient
      procedure :: get_gradient
   end type cds_solvation

   !> Provide constructor for CDS solvation
   interface cds_solvation
      module procedure :: create_cds
   end interface cds_solvation

   !> Restart data for CDS calculation
   type :: cds_cache
      !> Surface tension
      real(wp), allocatable :: tension(:)
      !> Derivative of surface tension w.r.t. cartesian displacements
      real(wp), allocatable :: dtdr(:, :, :)
      !> Solvent accessible surface area for each atom
      real(wp), allocatable :: surface(:)
      !> Derivative of the solvent accessible surface area w.r.t. cartesian displacements
      real(wp), allocatable :: dsdr(:, :, :)
      !> Scratch array to store potential shift
      real(wp), allocatable :: scratch(:)
      !> Hydrogen bonding correction
      real(wp), allocatable :: hbond(:)
   end type cds_cache

contains

!> Create new CDS solvation model
subroutine new_cds(self, mol, input)
   !> Instance of the solvation model
   type(cds_solvation), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input for CDS solvation
   type(cds_input), intent(in) :: input

   real(wp), allocatable :: rad(:)

   if (allocated(input%rad)) then
      rad = input%rad
   else
      rad = get_vdw_rad_cosmo(mol%num)
   end if

   self%tension = input%tension

   if (allocated(input%hbond)) then
      self%hbond = input%hbond
   end if

   call new_surface_integrator(self%sasa, mol%id, rad, input%probe, input%nang)
end subroutine new_cds

!> Type constructor for CDS splvation
function create_cds(mol, input) result(self)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input for CDS solvation
   type(cds_input), intent(in) :: input
   !> Instance of the solvation model
   type(cds_solvation) :: self

   call new_cds(self, mol, input)
end function create_cds

!> Update cache from container
subroutine update(self, mol, cache)
   !> Instance of the solvation model
   class(cds_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   type(cds_cache), pointer :: ptr
   real(wp) :: adet

   call taint(cache, ptr)

   if (.not.allocated(ptr%surface)) then
      allocate(ptr%surface(mol%nat))
   end if
   if (.not.allocated(ptr%dsdr)) then
      allocate(ptr%dsdr(3, mol%nat, mol%nat))
   end if
   if (.not.allocated(ptr%scratch)) then
      allocate(ptr%scratch(mol%nat))
   end if

   call self%sasa%get_surface(mol, ptr%surface, ptr%dsdr)

   ptr%tension = self%tension(mol%id)
   if (allocated(self%hbond)) then
      ptr%hbond = self%hbond(mol%id)
   end if
end subroutine update


!> Evaluate non-selfconsistent part of the interaction
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the solvation model
   class(cds_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Interaction energy
   real(wp), intent(inout) :: energies(:)
   !> Interaction gradient
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Interaction virial
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)

   type(cds_cache), pointer :: ptr

   call view(cache, ptr)

   energies(:) = energies + ptr%surface * ptr%tension

   if (present(gradient)) then
      if (allocated(ptr%dsdr)) &
         call gemv(ptr%dsdr, ptr%tension, gradient, beta=1.0_wp)
      if (allocated(ptr%dtdr)) &
         call gemv(ptr%dtdr, ptr%surface, gradient, beta=1.0_wp)
   end if
end subroutine get_engrad


!> Get solvation energy
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the solvation model
   class(cds_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Solvation free energy
   real(wp), intent(inout) :: energies(:)

   type(cds_cache), pointer :: ptr

   call view(cache, ptr)

   if (allocated(self%hbond)) then
      ptr%scratch(:) = ptr%hbond * ptr%surface * wfn%qat(:, 1)**2
      energies(:) = energies + ptr%scratch
   end if
end subroutine get_energy


!> Get solvation potential
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the solvation model
   class(cds_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   type(cds_cache), pointer :: ptr

   call view(cache, ptr)

   if (allocated(self%hbond)) then
      ptr%scratch(:) = 2*ptr%hbond * ptr%surface * wfn%qat(:, 1)
      pot%vat(:, 1) = pot%vat(:, 1) + ptr%scratch(:)
   end if
end subroutine get_potential


!> Get solvation gradient
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the solvation model
   class(cds_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the solvation free energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the solvation free energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   type(cds_cache), pointer :: ptr

   call view(cache, ptr)

   if (allocated(self%hbond)) then
      ptr%scratch(:) = ptr%hbond * wfn%qat(:, 1)**2
      if (allocated(ptr%dsdr)) &
         call gemv(ptr%dsdr, ptr%scratch, gradient, beta=1.0_wp)
   end if
end subroutine get_gradient


!> Return dependency on density
pure function variable_info(self) result(info)
   !> Instance of the solvation model
   class(cds_solvation), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=merge(atom_resolved, not_used, allocated(self%hbond)))
end function variable_info


subroutine taint(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(cds_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(cds_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

subroutine view(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(cds_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(cds_cache)
      ptr => target
   end select
end subroutine view

end module tblite_solvation_cds

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3_damping
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   implicit none

   public :: damping_param, dispersion_interface


   type, abstract :: damping_param
   contains
      generic :: get_dispersion2 => get_dispersion2_impl, get_dispersion2_compat
      procedure(dispersion_interface), deferred :: get_dispersion2_impl
      procedure :: get_dispersion2_compat => get_dispersion2_compat
      generic :: get_dispersion3 => get_dispersion3_impl, get_dispersion3_compat
      procedure(dispersion_interface), deferred :: get_dispersion3_impl
      procedure :: get_dispersion3_compat => get_dispersion3_compat
      generic :: get_pairwise_dispersion2 => get_pairwise_dispersion2_impl, get_pairwise_dispersion2_compat
      procedure(pairwise_dispersion_interface), deferred :: get_pairwise_dispersion2_impl
      procedure :: get_pairwise_dispersion2_compat => get_pairwise_dispersion2_compat
      generic :: get_pairwise_dispersion3 => get_pairwise_dispersion3_impl, get_pairwise_dispersion3_compat
      procedure(pairwise_dispersion_interface), deferred :: get_pairwise_dispersion3_impl
      procedure :: get_pairwise_dispersion3_compat => get_pairwise_dispersion3_compat
   end type damping_param


   abstract interface
      !> Evaluation of the dispersion energy expression
      subroutine dispersion_interface(self, mol, trans, cutoff, width, rvdw, r4r2, c6, dc6dcn, &
            & energy, dEdcn, gradient, sigma)
         import :: structure_type, damping_param, wp

         !> Damping parameters
         class(damping_param), intent(in) :: self

         !> Molecular structure data
         class(structure_type), intent(in) :: mol

         !> Lattice points
         real(wp), intent(in) :: trans(:, :)

         !> Real space cutoff
         real(wp), intent(in) :: cutoff

         !> Width of smooth cutoff
         real(wp), intent(in) :: width

         !> Van-der-Waals radii for damping function
         real(wp), intent(in) :: rvdw(:, :)

         !> Expectation values for C8 extrapolation
         real(wp), intent(in) :: r4r2(:)

         !> C6 coefficients for all atom pairs.
         real(wp), intent(in) :: c6(:, :)

         !> Derivative of the C6 w.r.t. the coordination number
         real(wp), intent(in), optional :: dc6dcn(:, :)

         !> Dispersion energy
         real(wp), intent(inout) :: energy(:)

         !> Derivative of the energy w.r.t. the coordination number
         real(wp), intent(inout), optional :: dEdcn(:)

         !> Dispersion gradient
         real(wp), intent(inout), optional :: gradient(:, :)

         !> Dispersion virial
         real(wp), intent(inout), optional :: sigma(:, :)
      end subroutine dispersion_interface


      !> Evaluation of the pairwise representation of the dispersion energy
      subroutine pairwise_dispersion_interface(self, mol, trans, cutoff, width, rvdw, r4r2, c6, &
            & energy)
         import :: structure_type, damping_param, wp

         !> Damping parameters
         class(damping_param), intent(in) :: self

         !> Molecular structure data
         class(structure_type), intent(in) :: mol

         !> Lattice points
         real(wp), intent(in) :: trans(:, :)

         !> Real space cutoff
         real(wp), intent(in) :: cutoff

         !> Width of smooth cutoff
         real(wp), intent(in) :: width

         !> Van-der-Waals radii for damping function
         real(wp), intent(in) :: rvdw(:, :)

         !> Expectation values for r4 over r2 operator
         real(wp), intent(in) :: r4r2(:)

         !> C6 coefficients for all atom pairs.
         real(wp), intent(in) :: c6(:, :)

         !> Pairwise representation of the dispersion energy
         real(wp), intent(inout) :: energy(:, :)
      end subroutine pairwise_dispersion_interface
   end interface

contains

   !> Evaluation of the dispersion energy expression
   subroutine get_dispersion2_compat(self, mol, trans, cutoff, rvdw, r4r2, c6, dc6dcn, &
         & energy, dEdcn, gradient, sigma)

      !> Damping parameters
      class(damping_param), intent(in) :: self

      !> Molecular structure data
      class(structure_type), intent(in) :: mol

      !> Lattice points
      real(wp), intent(in) :: trans(:, :)

      !> Real space cutoff
      real(wp), intent(in) :: cutoff

      !> Van-der-Waals radii for damping function
      real(wp), intent(in) :: rvdw(:, :)

      !> Expectation values for C8 extrapolation
      real(wp), intent(in) :: r4r2(:)

      !> C6 coefficients for all atom pairs.
      real(wp), intent(in) :: c6(:, :)

      !> Derivative of the C6 w.r.t. the coordination number
      real(wp), intent(in), optional :: dc6dcn(:, :)

      !> Dispersion energy
      real(wp), intent(inout) :: energy(:)

      !> Derivative of the energy w.r.t. the coordination number
      real(wp), intent(inout), optional :: dEdcn(:)

      !> Dispersion gradient
      real(wp), intent(inout), optional :: gradient(:, :)

      !> Dispersion virial
      real(wp), intent(inout), optional :: sigma(:, :)

      call self%get_dispersion2(mol, trans, cutoff, 0.0_wp, rvdw, r4r2, c6, &
         & dc6dcn, energy, dEdcn, gradient, sigma)
   end subroutine get_dispersion2_compat


   !> Evaluation of the dispersion energy expression
   subroutine get_dispersion3_compat(self, mol, trans, cutoff, rvdw, r4r2, c6, dc6dcn, &
         & energy, dEdcn, gradient, sigma)

      !> Damping parameters
      class(damping_param), intent(in) :: self

      !> Molecular structure data
      class(structure_type), intent(in) :: mol

      !> Lattice points
      real(wp), intent(in) :: trans(:, :)

      !> Real space cutoff
      real(wp), intent(in) :: cutoff

      !> Van-der-Waals radii for damping function
      real(wp), intent(in) :: rvdw(:, :)

      !> Expectation values for C8 extrapolation
      real(wp), intent(in) :: r4r2(:)

      !> C6 coefficients for all atom pairs.
      real(wp), intent(in) :: c6(:, :)

      !> Derivative of the C6 w.r.t. the coordination number
      real(wp), intent(in), optional :: dc6dcn(:, :)

      !> Dispersion energy
      real(wp), intent(inout) :: energy(:)

      !> Derivative of the energy w.r.t. the coordination number
      real(wp), intent(inout), optional :: dEdcn(:)

      !> Dispersion gradient
      real(wp), intent(inout), optional :: gradient(:, :)

      !> Dispersion virial
      real(wp), intent(inout), optional :: sigma(:, :)

      call self%get_dispersion3(mol, trans, cutoff, 0.0_wp, rvdw, r4r2, c6, &
         & dc6dcn, energy, dEdcn, gradient, sigma)
   end subroutine get_dispersion3_compat


   !> Evaluation of the pairwise representation of the dispersion energy
   subroutine get_pairwise_dispersion2_compat(self, mol, trans, cutoff, rvdw, r4r2, c6, &
         & energy)

      !> Damping parameters
      class(damping_param), intent(in) :: self

      !> Molecular structure data
      class(structure_type), intent(in) :: mol

      !> Lattice points
      real(wp), intent(in) :: trans(:, :)

      !> Real space cutoff
      real(wp), intent(in) :: cutoff

      !> Van-der-Waals radii for damping function
      real(wp), intent(in) :: rvdw(:, :)

      !> Expectation values for r4 over r2 operator
      real(wp), intent(in) :: r4r2(:)

      !> C6 coefficients for all atom pairs.
      real(wp), intent(in) :: c6(:, :)

      !> Pairwise representation of the dispersion energy
      real(wp), intent(inout) :: energy(:, :)

      call self%get_pairwise_dispersion2(mol, trans, cutoff, 0.0_wp, rvdw, r4r2, c6, energy)
   end subroutine get_pairwise_dispersion2_compat


   !> Evaluation of the pairwise representation of the dispersion energy
   subroutine get_pairwise_dispersion3_compat(self, mol, trans, cutoff, rvdw, r4r2, c6, &
         & energy)

      !> Damping parameters
      class(damping_param), intent(in) :: self

      !> Molecular structure data
      class(structure_type), intent(in) :: mol

      !> Lattice points
      real(wp), intent(in) :: trans(:, :)

      !> Real space cutoff
      real(wp), intent(in) :: cutoff

      !> Van-der-Waals radii for damping function
      real(wp), intent(in) :: rvdw(:, :)

      !> Expectation values for r4 over r2 operator
      real(wp), intent(in) :: r4r2(:)

      !> C6 coefficients for all atom pairs.
      real(wp), intent(in) :: c6(:, :)

      !> Pairwise representation of the dispersion energy
      real(wp), intent(inout) :: energy(:, :)

      call self%get_pairwise_dispersion3(mol, trans, cutoff, 0.0_wp, rvdw, r4r2, c6, energy)
   end subroutine get_pairwise_dispersion3_compat

end module dftd3_damping

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Interaction of Hamiltonian with external fields
module tblite_external_field
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_blas, only : dot
   use tblite_container_cache, only : container_cache
   use tblite_container_type, only : container_type
   use tblite_scf_info, only : scf_info, atom_resolved
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: electric_field, new_electric_field

   !> Container for contribution from an instantaneous electric field
   type, extends(container_type) :: electric_field
      !> Instantaneous electric field
      real(wp) :: efield(3) = 0.0_wp
   contains
      !> Update cache from container
      procedure :: update
      !> Return dependency on density
      procedure :: variable_info
      !> Get electric field energy
      procedure :: get_energy
      !> Get electric field potential
      procedure :: get_potential
      !> Get electric field gradient
      procedure :: get_gradient
   end type electric_field


   !> Create electric field container from field vector
   interface electric_field
      module procedure :: create_electric_field
   end interface electric_field


   !> Identifier for container
   character(len=*), parameter :: label = "electric field"


contains


!> Create new electric field container
pure subroutine new_electric_field(self, efield)
   !> Instance of the electrostatic container
   type(electric_field), intent(out) :: self
   !> Instantaneous electric field
   real(wp), intent(in) :: efield(:)

   self%efield(:) = efield(:3)
   self%label = label
end subroutine new_electric_field


!> Create new electric field container
pure function create_electric_field(efield) result(new)
   !> Instantaneous electric field
   real(wp), intent(in) :: efield(:)
   !> Instance of the electrostatic container
   type(electric_field) :: new

   call new_electric_field(new, efield)
end function create_electric_field


!> Update cache from container
subroutine update(self, mol, cache)
   !> Instance of the electrostatic container
   class(electric_field), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
end subroutine update


!> Get electric field energy
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the electrostatic container
   class(electric_field), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)

   real(wp), allocatable :: vdp(:, :), vat(:)

   vat = matmul(self%efield, mol%xyz)
   vdp = spread(self%efield, 2, mol%nat)
   energies(:) = energies - vat * wfn%qat(:, 1) - sum(vdp * wfn%dpat(:, :, 1), 1)
end subroutine get_energy


!> Get electric field potential
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the electrostatic container
   class(electric_field), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   pot%vat(:, 1) = pot%vat(:, 1) - matmul(self%efield, mol%xyz)
   pot%vdp(:, :, 1) = pot%vdp(:, :, 1) - spread(self%efield, 2, mol%nat)
end subroutine get_potential


!> Get electric field gradient
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the electrostatic container
   class(electric_field), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the repulsion energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   real(wp), allocatable :: vdp(:, :), stmp(:, :)

   vdp = spread(self%efield, 2, mol%nat)
   stmp = matmul(vdp, transpose(mol%xyz))
   gradient(:, :) = gradient - vdp
   sigma(:, :) = sigma - 0.5_wp * (stmp + transpose(stmp))
end subroutine get_gradient


!> Return dependency on density
pure function variable_info(self) result(info)
   !> Instance of the electrostatic container
   class(electric_field), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=atom_resolved, dipole=atom_resolved)
end function variable_info


end module tblite_external_field

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/wavefunction/guess.f90
!> Provides guesses for the wavefunction

!> Implementation of the guess wavefunctions
module tblite_wavefunction_guess
   use mctc_env, only : wp, error_type
   use mctc_io, only : structure_type
   use multicharge, only : mchrg_model_type, get_eeq_charges, get_eeqbc_charges
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_xtb_h0, only : get_occupation
   use tblite_xtb_calculator, only : xtb_calculator
   implicit none
   private

   public :: sad_guess, eeq_guess, eeqbc_guess, shell_partition
   interface sad_guess
      module procedure sad_guess_qat
      module procedure sad_guess_qsh
   end interface sad_guess

   interface eeq_guess
      module procedure eeq_guess_qat
      module procedure eeq_guess_qsh
   end interface eeq_guess

   interface eeqbc_guess
      module procedure eeqbc_guess_qat
      module procedure eeqbc_guess_qsh
   end interface eeqbc_guess

contains

subroutine sad_guess_qat(mol, charges, dpat)
   type(structure_type), intent(in) :: mol
   real(wp), intent(inout) :: charges(:), dpat(:, :)

   dpat(:, :) = 0.0_wp
   charges = mol%charge / mol%nat
end subroutine sad_guess_qat

subroutine sad_guess_qsh(mol, calc, wfn)
   type(structure_type), intent(in) :: mol
   type(xtb_calculator), intent(in) :: calc
   type(wavefunction_type), intent(inout) :: wfn

   call sad_guess_qat(mol, wfn%qat(:, 1), wfn%dpat(:, :, 1))
   call shell_partition(mol, calc, wfn)
end subroutine sad_guess_qsh

subroutine eeq_guess_qat(mol, charges, dpat, error)
   type(structure_type), intent(in) :: mol
   real(wp), intent(inout) :: charges(:), dpat(:, :)
   type(error_type), intent(out), allocatable :: error

   dpat(:, :) = 0.0_wp
   call get_eeq_charges(mol, error, charges)
end subroutine eeq_guess_qat

subroutine eeq_guess_qsh(mol, calc, wfn, error)
   type(structure_type), intent(in) :: mol
   type(xtb_calculator), intent(in) :: calc
   type(wavefunction_type), intent(inout) :: wfn
   type(error_type), intent(out), allocatable :: error

   call eeq_guess_qat(mol, wfn%qat(:, 1), wfn%dpat(:, :, 1), error)
   call shell_partition(mol, calc, wfn)
end subroutine eeq_guess_qsh

subroutine eeqbc_guess_qat(mol, charges, dpat, error)
   type(structure_type), intent(in) :: mol
   real(wp), intent(inout) :: charges(:), dpat(:, :)
   type(error_type), intent(out), allocatable :: error

   dpat(:, :) = 0.0_wp
   call get_eeqbc_charges(mol, error, charges)
end subroutine eeqbc_guess_qat

subroutine eeqbc_guess_qsh(mol, calc, wfn, error)
   type(structure_type), intent(in) :: mol
   type(xtb_calculator), intent(in) :: calc
   type(wavefunction_type), intent(inout) :: wfn
   type(error_type), intent(out), allocatable :: error

   call eeqbc_guess_qat(mol, wfn%qat(:, 1), wfn%dpat(:, :, 1), error)
   call shell_partition(mol, calc, wfn)
end subroutine eeqbc_guess_qsh

subroutine shell_partition(mol, calc, wfn)
   type(structure_type), intent(in) :: mol
   type(xtb_calculator), intent(in) :: calc
   type(wavefunction_type), intent(inout) :: wfn

   integer :: iat, ii, ish, spin

   call get_occupation(mol, calc%bas, calc%h0, wfn%nocc, wfn%n0at, wfn%n0sh)
   do spin = 1, size(wfn%qat, 2)
      do iat = 1, size(wfn%qat, 1)
         ii = calc%bas%ish_at(iat)
         do ish = 1, calc%bas%nsh_at(iat)
            wfn%qsh(ii+ish, spin) = (wfn%n0sh(ii+ish) / wfn%n0at(iat)) * wfn%qat(iat, spin)
         end do
      end do
   end do
end subroutine shell_partition

end module tblite_wavefunction_guess

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> API export for managing interaction containers
module tblite_api_container
   use, intrinsic :: iso_c_binding
   use tblite_api_version, only : namespace
   use tblite_container, only : container_type
   use tblite_external_field, only : electric_field
   implicit none
   private

   public :: vp_container, delete_container_api


   !> Void pointer to a container instance
   type :: vp_container
      !> Actual container
      class(container_type), allocatable :: ptr
   end type vp_container

   logical, parameter :: debug = .false.

contains


function new_electric_field_api(efield) result(vcont) &
      & bind(C, name=namespace//"new_electric_field")
   real(c_double), intent(in) :: efield(3)
   type(c_ptr) :: vcont
   type(vp_container), pointer :: cont

   allocate(cont)
   cont%ptr = electric_field(efield)
   vcont = c_loc(cont)
end function new_electric_field_api


subroutine delete_container_api(vcont) &
      & bind(C, name=namespace//"delete_container")
   type(c_ptr), intent(inout) :: vcont
   type(vp_container), pointer :: cont

   if (debug) print '("[Info]", 1x, a)', "delete_container"

   if (c_associated(vcont)) then
      call c_f_pointer(vcont, cont)

      deallocate(cont)
      vcont = c_null_ptr
   end if
end subroutine delete_container_api


end module tblite_api_container

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_utils
   use mctc_env_accuracy, only : wp
   use mctc_env_error, only : error_type, fatal_error
   implicit none
   private

   public :: getline, next_line
   public :: token_type, next_token, read_token, read_next_token
   public :: io_error, io2_error
   public :: filename, to_string
   public :: to_lower


   !> Text token
   type :: token_type
      !> Begin of sequence
      integer :: first
      !> End of sequence
      integer :: last
   end type token_type


   interface read_token
      module procedure :: read_token_int
      module procedure :: read_token_real
   end interface read_token

   interface read_next_token
      module procedure :: read_next_token_int
      module procedure :: read_next_token_real
   end interface read_next_token


contains


subroutine getline(unit, line, iostat, iomsg)

   !> Formatted IO unit
   integer, intent(in) :: unit

   !> Line to read
   character(len=:), allocatable, intent(out) :: line

   !> Status of operation
   integer, intent(out) :: iostat

   !> Error message
   character(len=:), allocatable, optional :: iomsg

   integer, parameter :: bufsize = 512
   character(len=bufsize) :: buffer
   character(len=bufsize) :: msg
   integer :: size
   integer :: stat

   allocate(character(len=0) :: line)
   do
      read(unit, '(a)', advance='no', iostat=stat, iomsg=msg, size=size) &
         & buffer
      if (stat > 0) exit
      line = line // buffer(:size)
      if (stat < 0) then
         if (is_iostat_eor(stat)) then
            stat = 0
         end if
         exit
      end if
   end do

   if (stat /= 0) then
      if (present(iomsg)) iomsg = trim(msg)
   end if
   iostat = stat

end subroutine getline


!> Convenience function to read a line and update associated descriptors
subroutine next_line(unit, line, pos, lnum, iostat, iomsg)

   !> Formatted IO unit
   integer, intent(in) :: unit

   !> Line to read
   character(len=:), allocatable, intent(out) :: line

   !> Current position in line
   integer, intent(out) :: pos

   !> Current line number
   integer, intent(inout) :: lnum

   !> Status of operation
   integer, intent(out) :: iostat

   !> Error message
   character(len=:), allocatable, optional :: iomsg

   pos = 0
   call getline(unit, line, iostat, iomsg)
   if (iostat == 0) lnum = lnum + 1
end subroutine next_line


!> Advance pointer to next text token
subroutine next_token(string, pos, token)

   !> String to check
   character(len=*), intent(in) :: string

   !> Current position in string
   integer, intent(inout) :: pos

   !> Token found
   type(token_type), intent(out) :: token

   integer :: start

   if (pos >= len(string)) then
      token = token_type(len(string)+1, len(string)+1)
      return
   end if

   do while(pos < len(string))
      pos = pos + 1
      select case(string(pos:pos))
      case(" ", achar(9), achar(10), achar(13))
         continue
      case default
         exit
      end select
   end do

   start = pos

   do while(pos < len(string))
      pos = pos + 1
      select case(string(pos:pos))
      case(" ", achar(9), achar(10), achar(13))
         pos = pos - 1
         exit
      case default
         continue
      end select
   end do

   token = token_type(start, pos)
end subroutine next_token


function filename(unit)
   integer, intent(in) :: unit
   character(len=:), allocatable :: filename

   character(len=512) :: buffer
   logical :: opened

   filename = "(input)"
   if (unit /= -1) then
      buffer = ""
      inquire(unit=unit, opened=opened, name=buffer)
      if (opened .and. len_trim(buffer) > 0) then
         filename = trim(buffer)
      end if
   end if
end function


!> Create new IO error
subroutine io_error(error, message, source, token, filename, line, label)

   !> Error handler
   type(error_type), allocatable, intent(out) :: error

   !> Main error message
   character(len=*), intent(in) :: message

   !> String representing the offending input
   character(len=*), intent(in) :: source

   !> Last processed token
   type(token_type), intent(in) :: token

   !> Name of the input file
   character(len=*), intent(in), optional :: filename

   !> Line number
   integer, intent(in), optional :: line

   !> Label of the offending statement
   character(len=*), intent(in), optional :: label

   character(len=*), parameter :: nl = new_line('a')
   integer :: offset, lnum, width
   character(len=:), allocatable :: string

   lnum = 1
   if (present(line)) lnum = line
   offset = integer_width(lnum)
   width = token%last - token%first + 1

   ! Fix print alignment for empty files
   if (offset == 0) offset = 1
   
   string = "Error: " // message

   if (present(filename)) then
      string = string // nl // &
         repeat(" ", offset)//"--> "//filename

      string = string // ":" // to_string(lnum)
      if (token%first > 0 .and. token%last >= token%first) then
         string = string // &
            ":"//to_string(token%first)
         if (token%last > token%first) string = string//"-"//to_string(token%last)
      end if
   end if

   string = string // nl //&
      repeat(" ", offset+1)//"|"//nl//&
      to_string(lnum)//" | "//source//nl//&
      repeat(" ", offset+1)//"|"//repeat(" ", token%first)//repeat("^", width)

   if (present(label)) then
      string = string // " " // label
   end if

   string = string // nl //&
      repeat(" ", offset+1)//"|"

   call fatal_error(error, string)
end subroutine io_error


!> Create new IO error
subroutine io2_error(error, message, source1, source2, token1, token2, filename, &
      & line1, line2, label1, label2)

   !> Error handler
   type(error_type), allocatable, intent(out) :: error

   !> Main error message
   character(len=*), intent(in) :: message

   !> String representing the offending input
   character(len=*), intent(in) :: source1, source2

   !> Last processed token
   type(token_type), intent(in) :: token1, token2

   !> Name of the input file
   character(len=*), intent(in), optional :: filename

   !> Line number
   integer, intent(in), optional :: line1, line2

   !> Label of the offending statement
   character(len=*), intent(in), optional :: label1, label2

   character(len=*), parameter :: nl = new_line('a')
   integer :: offset, lnum1, lnum2, width1, width2
   character(len=:), allocatable :: string

   lnum1 = 1
   lnum2 = 1
   if (present(line1)) lnum1 = line1
   if (present(line2)) lnum2 = line2
   offset = integer_width(max(lnum1, lnum2))
   width1 = token1%last - token1%first + 1
   width2 = token2%last - token2%first + 1

   string = "Error: " // message

   if (present(filename)) then
      string = string // nl // &
         repeat(" ", offset)//"--> "//filename

      string = string // ":" // to_string(lnum2)
      if (token2%first > 0 .and. token2%last >= token2%first) then
         string = string // &
            ":"//to_string(token2%first)
         if (token2%last > token2%first) string = string//"-"//to_string(token2%last)
      end if
   end if

   string = string // nl //&
      repeat(" ", offset+1)//"|"//nl//&
      to_string(lnum1, offset)//" | "//source1//nl//&
      repeat(" ", offset+1)//"|"//repeat(" ", token1%first)//repeat("-", width1)

   if (present(label1)) then
      string = string // " " // label1
   end if

   string = string // nl //&
      repeat(" ", offset+1)//":"//nl//&
      to_string(lnum2)//" | "//source2//nl//&
      repeat(" ", offset+1)//"|"//repeat(" ", token2%first)//repeat("^", width2)

   if (present(label2)) then
      string = string // " " // label2
   end if

   string = string // nl //&
      repeat(" ", offset+1)//"|"

   call fatal_error(error, string)
end subroutine io2_error


pure function integer_width(input) result(width)
   integer, intent(in) :: input
   integer :: width

   integer :: val

   val = input
   width = 0
   do while (val /= 0)
      val = val / 10
      width = width + 1
   end do

end function integer_width


!> Represent an integer as character sequence.
pure function to_string(val, width) result(string)
   integer, intent(in) :: val
   integer, intent(in), optional :: width
   character(len=:), allocatable :: string
   integer, parameter :: buffer_len = range(val)+2
   character(len=buffer_len) :: buffer
   integer :: pos
   integer :: n
   character(len=1), parameter :: numbers(0:9) = &
      ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]

   if (val == 0) then
      if (present(width)) then
         string = repeat(" ", width-1) // numbers(0)
      else
         string = numbers(0)
      end if
      return
   end if

   n = abs(val)
   buffer = ""

   pos = buffer_len + 1
   do while (n > 0)
      pos = pos - 1
      buffer(pos:pos) = numbers(mod(n, 10))
      n = n/10
   end do
   if (val < 0) then
      pos = pos - 1
      buffer(pos:pos) = '-'
   end if

   if (present(width)) then
      string = repeat(" ", max(width-(buffer_len+1-pos), 0)) // buffer(pos:)
   else
      string = buffer(pos:)
   end if
end function to_string


subroutine read_next_token_int(line, pos, token, val, iostat, iomsg)
   character(len=*), intent(in) :: line
   integer, intent(inout) :: pos
   type(token_type), intent(inout) :: token
   integer, intent(out) :: val
   integer, intent(out) :: iostat
   character(len=:), allocatable, intent(out), optional :: iomsg

   call next_token(line, pos, token)
   call read_token(line, token, val, iostat, iomsg)
end subroutine read_next_token_int


subroutine read_token_int(line, token, val, iostat, iomsg)
   character(len=*), intent(in) :: line
   type(token_type), intent(in) :: token
   integer, intent(out) :: val
   integer, intent(out) :: iostat
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=512) :: msg

   if (token%first > 0 .and. token%last <= len(line)) then
      read(line(token%first:token%last), *, iostat=iostat, iomsg=msg) val
   else
      iostat = 1
      msg = "No input found"
   end if
   if (present(iomsg)) iomsg = trim(msg)
end subroutine read_token_int


subroutine read_next_token_real(line, pos, token, val, iostat, iomsg)
   character(len=*), intent(in) :: line
   integer, intent(inout) :: pos
   type(token_type), intent(inout) :: token
   real(wp), intent(out) :: val
   integer, intent(out) :: iostat
   character(len=:), allocatable, intent(out), optional :: iomsg

   call next_token(line, pos, token)
   call read_token(line, token, val, iostat, iomsg)
end subroutine read_next_token_real


subroutine read_token_real(line, token, val, iostat, iomsg)
   character(len=*), intent(in) :: line
   type(token_type), intent(in) :: token
   real(wp), intent(out) :: val
   integer, intent(out) :: iostat
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=512) :: msg

   if (token%first > 0 .and. token%last <= len(line)) then
      read(line(token%first:token%last), *, iostat=iostat, iomsg=msg) val
   else
      iostat = 1
      msg = "No input found"
   end if
   if (present(iomsg)) iomsg = trim(msg)
end subroutine read_token_real


!> Convert input string to lowercase
elemental function to_lower(str) result(lcstr)

   !> Input string
   character(len=*), intent(in) :: str

   !> Lowercase version of string
   character(len=len(str)):: lcstr

   integer :: ilen, iquote, i, iav, iqc
   integer, parameter :: offset = iachar('A') - iachar('a')

   ilen = len(str)
   iquote = 0
   lcstr = str

   do i = 1, ilen
      iav = iachar(str(i:i))
      if (iquote == 0 .and. (iav == 34 .or.iav == 39)) then
         iquote = 1
         iqc = iav
         cycle
      end if
      if (iquote == 1 .and. iav==iqc) then
         iquote=0
         cycle
      end if
      if (iquote == 1) cycle
      if (iav >= iachar('A') .and. iav <= iachar('Z')) then
         lcstr(i:i) = achar(iav - offset)
      else
         lcstr(i:i) = str(i:i)
      end if
   end do

end function to_lower


end module mctc_io_utils

!> Example for a workflow pipeline to construct a molecular dynamics simulation.
module demo_task
  use tomlf, only : toml_table, toml_array, get_value, len
  implicit none
  private

  public :: read_tasks, task_config, driver_config, lbfgs_config, velocity_verlet_config

  !> Abstract base class for all simulation driver configurations
  type, abstract :: driver_config
  end type driver_config

  !> Configuration for the LBFGS geometry optimization driver
  type, extends(driver_config) :: lbfgs_config
    !> Tolerance for considering optimization to be converged
    real :: tolerance
  end type lbfgs_config

  !> Configuration for the Velocity-Verlet molecular dynamics driver
  type, extends(driver_config) :: velocity_verlet_config
    !> Time step for the propagation in fs
    real :: time_step
    !> Temperature in K
    real :: temperature
    !> Number of steps to take in the propagation
    integer :: max_steps
  end type velocity_verlet_config

  !> Configuration of a single simulation task
  type :: task_config
    !> Label to identify the task
    character(len=:), allocatable :: label
    !> Driver configuration
    class(driver_config), allocatable :: config
  end type task_config

contains

  !> Read task configurations from document root
  subroutine read_tasks(table, task)
    !> Data structure
    type(toml_table), intent(inout) :: table
    !> Configurations for simulation tasks
    type(task_config), allocatable, intent(out) :: task(:)

    integer :: itask
    type(toml_array), pointer :: array
    type(toml_table), pointer :: child

    call get_value(table, "tasks", array)
    allocate(task(len(array)))

    do itask = 1, size(task)
      call get_value(array, itask, child)
      call read_task(child, task(itask))
    end do
  end subroutine read_tasks

  !> Read a single task configuration
  subroutine read_task(table, task)
    !> Data structure
    type(toml_table), intent(inout) :: table
    !> Configuration for simulation task
    type(task_config), intent(out) :: task

    character(len=:), allocatable :: driver
    type(toml_table), pointer :: child

    call get_value(table, "driver", driver)
    if (.not.allocated(driver)) then
      error stop "Driver keyword not present in task configuration"
    end if
    call get_value(table, "name", task%label, driver)

    select case(driver)
    case default
      error stop "Unknown driver type in task configuration"
    case("lbfgs")
      block
        type(lbfgs_config), allocatable :: tmp
        allocate(tmp)
        call get_value(table, "config", child)
        call read_lbfgs(child, tmp)
        call move_alloc(tmp, task%config)
      end block
    case("velocity-verlet")
      block
        type(velocity_verlet_config), allocatable :: tmp
        allocate(tmp)
        call get_value(table, "config", child)
        call read_velocity_verlet(child, tmp)
        call move_alloc(tmp, task%config)
      end block
    end select
  end subroutine read_task

  !> Read configuration for LBFGS geometry optimization
  subroutine read_lbfgs(table, config)
    !> Data structure
    type(toml_table), intent(inout) :: table
    !> Configuration for LBFGS optimizer
    type(lbfgs_config), intent(out) :: config

    call get_value(table, "tolerance", config%tolerance, 1.0e-6)
  end subroutine read_lbfgs

  !> Read configuration for Velocity-Verlet molecular dynamics
  subroutine read_velocity_verlet(table, config)
    !> Data structure
    type(toml_table), intent(inout) :: table
    !> Configuration for Velocity-Verlet propagator
    type(velocity_verlet_config), intent(out) :: config

    call get_value(table, "time-step", config%time_step, 0.5)
    call get_value(table, "temperature", config%temperature, 298.15)
    call get_value(table, "max-steps", config%max_steps, 100)
  end subroutine read_velocity_verlet

end module demo_task

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Proxy module for defining isotropic electrostatic interactions
module tblite_coulomb_charge
   use tblite_coulomb_charge_effective, only : effective_coulomb, new_effective_coulomb, &
      & average_interface, harmonic_average, arithmetic_average, geometric_average
   use tblite_coulomb_charge_gamma, only : gamma_coulomb, new_gamma_coulomb
   use tblite_coulomb_charge_type, only : coulomb_charge_type
   implicit none
   private

   public :: coulomb_charge_type, coulomb_kernel
   public :: effective_coulomb, new_effective_coulomb
   public :: average_interface, harmonic_average, arithmetic_average, geometric_average
   public :: gamma_coulomb, new_gamma_coulomb


   !> Possible interaction kernels
   type :: enum_coulomb_kernel
      !> Effective Klopman-Ohno interaction kernel
      integer :: effective = 1
      !> DFTB γ-functional interaction kernel
      integer :: dftb_gamma = 2
   end type enum_coulomb_kernel

   !> Actual enumerator for possible interaction kernels
   type(enum_coulomb_kernel), parameter :: coulomb_kernel = enum_coulomb_kernel()

end module tblite_coulomb_charge

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_fit
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use tblite_fit_newuoa, only : newuoa
   use tblite_fit_settings, only : fit_settings
   use tblite_toml, only : toml_table
   implicit none
   private

   public :: collect_fit

   real(wp), parameter :: thr = 1e-6_wp


contains


!> Collect all exported unit tests
subroutine collect_fit(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("settings", test_settings), &
      new_unittest("newuoa", test_newuoa) &
      ]

end subroutine collect_fit


subroutine test_settings(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(fit_settings) :: set

   table = toml_table()

   call set%load(table, error)
   if (allocated(error)) return

   table = toml_table()

   call set%dump(table, error)
   if (allocated(error)) return
end subroutine test_settings


subroutine test_newuoa(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp) :: x(10)
   integer :: maxfun, n, npt, i
   real(wp) :: rhoend, rhobeg
   class(*), allocatable :: h

   real(wp), parameter :: ref(8, 4) = reshape([&
      & 2.113249e-1_wp, 7.886751e-1_wp, 0.000000e+0_wp, 0.000000e+0_wp, &
      & 0.000000e+0_wp, 0.000000e+0_wp, 0.000000e+0_wp, 0.000000e+0_wp, &
      & 1.026728e-1_wp, 4.062038e-1_wp, 5.937962e-1_wp, 8.973272e-1_wp, &
      & 0.000000e+0_wp, 0.000000e+0_wp, 0.000000e+0_wp, 0.000000e+0_wp, &
      & 6.687652e-2_wp, 2.887405e-1_wp, 3.666823e-1_wp, 6.333176e-1_wp, &
      & 7.112593e-1_wp, 9.331234e-1_wp, 0.000000e+0_wp, 0.000000e+0_wp, &
      & 4.315278e-2_wp, 1.930909e-1_wp, 2.663289e-1_wp, 5.000001e-1_wp, &
      & 5.000002e-1_wp, 7.336713e-1_wp, 8.069092e-1_wp, 9.568473e-1_wp],&
      & shape(ref))
   allocate(integer :: h)

   maxfun = 5000
   rhoend = 1.0e-6_wp
   do n = 2, 8, 2
      npt = 2 * n + 1
      do i = 1, n
         x(i) = real(i, wp) / real(n+1, wp)
      end do
      rhobeg = 0.2_wp * x(1)
      call newuoa(n, npt, x, rhobeg, rhoend, 0, maxfun, calfun_chebyquad, h, error)
      if (allocated(error)) exit
      do i = 1, n
         call check(error, x(i), ref(i, n/2), thr=thr)
         if (allocated(error)) exit
      end do
      if (allocated(error)) exit
   end do
   if (allocated(error)) return

end subroutine test_newuoa


!> The Chebyquad test problem (Fletcher, 1965)
function calfun_chebyquad(n, x, h, error) result(f)
   integer, intent(in) :: n
   real(wp), intent(in) :: x(*)
   class(*), intent(in) :: h
   type(error_type), allocatable, intent(out) :: error
   real(wp) :: f

   real(wp) :: y(10, 10)
   integer :: i,j,np,iw
   real(wp) :: sum

   do j = 1, n
      y(1, j) = 1.0_wp
      y(2, j) = 2.0_wp * x(j) - 1.0_wp
   end do
   do i = 2, n
      do j = 1, n
         y(i+1, j) = 2.0_wp * y(2, j) * y(i, j) - y(i-1, j)
      end do
   end do
   f = 0.0_wp
   np = n + 1
   iw = 1
   do i = 1, np
      sum = 0.0_wp
      do j = 1, n
         sum = sum + y(i, j)
      end do
      sum = sum / real(n, wp)
      if (iw > 0) sum = sum + 1.0_wp / real(i*i-2*i, wp)
      iw = - iw
      f = f + sum * sum
   end do
end function calfun_chebyquad

end module test_fit

! SPDX-Identifier: BSD-3-Clause

!> NEWUOA: **NEW** **U**nconstrained **O**ptimization **A**lgorithm
!>
!> The purpose of NEWUOA is to seek the least value of a function F of several
!> variables, when derivatives are not available.
!> The main new feature of the method is that quadratic
!> models are updated using only about ```NPT=2N+1``` interpolation conditions,
!> the remaining freedom being taken up by minimizing the Frobenius norm of
!> the change to the second derivative matrix of the model.
!>
!> The new software was developed from [[UOBYQA]], which also forms quadratic
!> models from interpolation conditions. That method requires ```NPT=(N+1)(N+2)/2```
!> conditions, however, because they have to define all the parameters of the
!> model. The least Frobenius norm updating procedure with ```NPT=2N+1``` is usually
!> much more efficient when ```N``` is large, because the work of each iteration is
!> much less than before, and in some experiments the number of calculations
!> of the objective function seems to be only of magnitude ```N```.
!>
!># References
!>
!>  * "[The NEWUOA software for unconstrained optimization without
!>    derivatives](http://www.damtp.cam.ac.uk/user/na/NA_papers/NA2004_08.pdf)",
!>    2004/NA08
!>  * "[The NEWUOA software for unconstrained minimization
!>    without derivatives](http://link.springer.com/chapter/10.1007%2F0-387-30065-1_16)",
!>    in Large-Scale Nonlinear Optimization, editors G. Di
!>    Pillo and M. Roma, Springer (2006), pages 255-297.
!>
!># History
!>  * M.J.D. Powell, December 16th, 2004 : It is hoped that the software will
!>    be helpful to much future research and to many applications. There are no
!>    restrictions on or charges for its use.
!>  * Jacob Williams, July 2015 : refactoring of the code into modern Fortran.
!>  * Sebastian Ehlert, August 2021 : removed implicit typing
!>
!>```bibtex
!>@Inbook{Powell2006,
!>  author="Powell, M. J. D.",
!>  editor="Di Pillo, G.  and Roma, M.",
!>  title="The NEWUOA software for unconstrained optimization without derivatives",
!>  bookTitle="Large-Scale Nonlinear Optimization",
!>  year="2006",
!>  publisher="Springer US",
!>  address="Boston, MA",
!>  pages="255--297",
!>  url="https://doi.org/10.1007/0-387-30065-1_16"
!>}
!>```
module tblite_fit_newuoa
   use mctc_env, only : wp, error_type
   implicit none

   private
   public :: newuoa, objective_function

   abstract interface
      function objective_function(n, x, h, error) result(f)
         import :: wp, error_type
         implicit none
         integer, intent(in) :: n
         real(wp), intent(in) :: x(*)
         class(*), intent(in) :: h
         type(error_type), allocatable, intent(out) :: error
         real(wp) :: f
      end function objective_function
   end interface


contains

!> This subroutine seeks the least value of a function of many variables,
!> by a trust region method that forms quadratic models by interpolation.
!> There can be some freedom in the interpolation conditions, which is
!> taken up by minimizing the Frobenius norm of the change to the second
subroutine newuoa(n, npt, x, rhobeg, rhoend, iprint, maxfun, calfun, handle, error)
   !> The number of variables. Must be at least 2.
   integer, intent(in) :: n
   !> The number of interpolation conditions.
   !> Its value must be in the interval `[N+2, (N+1)(N+2)/2]`.
   integer, intent(in) :: npt
   !> Initial values of the variables must be set in X(1), X(2), ..., X(N). They
   !> will be changed to the values that give the least calculated F.
   real(wp), intent(inout) :: x(*)
   !> RHOBEG and RHOEND must be set to the initial and final values of a trust
   !> region radius, so both must be positive with RHOEND<=RHOBEG. Typically
   !> RHOBEG should be about one tenth of the greatest expected change to a
   !> variable, and RHOEND should indicate the accuracy that is required in
   !> the final values of the variables.
   real(wp), intent(in) :: rhobeg
   !> RHOBEG and RHOEND must be set to the initial and final values of a trust
   !> region radius, so both must be positive with RHOEND<=RHOBEG. Typically
   !> RHOBEG should be about one tenth of the greatest expected change to a
   !> variable, and RHOEND should indicate the accuracy that is required in
   !> the final values of the variables.
   real(wp), intent(in) :: rhoend
   !> The value of IPRINT should be set to 0, 1, 2 or 3, which controls the
   !> amount of printing. Specifically, there is no output if IPRINT=0 and
   !> there is output only at the return if IPRINT=1. Otherwise, each new
   !> value of RHO is printed, with the best vector of variables so far and
   !> the corresponding value of the objective function. Further, each new
   !> value of F with its variables are output if IPRINT=3.
   integer, intent(in) :: iprint
   !> An upper bound on the number of calls of CALFUN.
   !> It must set F to the value of the objective function
   !> for the variables `X(1), X(2), ..., X(N)`.
   integer, intent(in) :: maxfun
   procedure(objective_function) :: calfun
   class(*), intent(in) :: handle
   type(error_type), allocatable, intent(out) :: error

   real(wp), dimension(:), allocatable :: w
   integer :: np, nptm, ndim, ixb, ixo, ixn, ixp, ifv, igq, ihq, ipq, ibmat, izmat, &
      & id, ivl, iw

   ! Partition the working space array, so that different parts of it can be
   ! treated separately by the subroutine that performs the main calculation.

   np = n + 1
   nptm = npt - np
   if (npt < n+2 .or. npt > ((n+2)*np)/2) then
      write(*, *) 'Return from NEWUOA because NPT is not in the required interval'
      return
   end if

   ! The array W will be used for working space
   allocate(w((NPT+13)*(NPT+N)+3*N*(N+3)/2))

   ndim = npt + n
   ixb = 1
   ixo = ixb + n
   ixn = ixo + n
   ixp = ixn + n
   ifv = ixp + n * npt
   igq = ifv + npt
   ihq = igq + n
   ipq = ihq + (n*np) / 2
   ibmat = ipq + npt
   izmat = ibmat + ndim * n
   id = izmat + npt * nptm
   ivl = id + n
   iw = ivl + ndim

   ! The above settings provide a partition of W for subroutine NEWUOB.
   ! The partition requires the first NPT*(NPT+N)+5*N*(N+3)/2 elements of
   ! W plus the space that is needed by the last array of NEWUOB.

   call newuob(n, npt, x, rhobeg, rhoend, iprint, maxfun, w(ixb), w(ixo), w(ixn), &
      w(ixp), w(ifv), w(igq), w(ihq), w(ipq), w(ibmat), w(izmat), ndim, &
      w(id), w(ivl), w(iw), calfun, handle, error)

   deallocate(w)

end subroutine newuoa


subroutine newuob(n, npt, x, rhobeg, rhoend, iprint, maxfun, xbase, xopt, xnew, xpt, &
      fval, gq, hq, pq, bmat, zmat, ndim, d, vlag, w, calfun, handle, error)
   !> The number of variables. Must be at least 2.
   integer, intent(in) :: n
   !> The number of interpolation conditions.
   !> Its value must be in the interval `[N+2, (N+1)(N+2)/2]`.
   integer, intent(in) :: npt
   !> Is the first dimension of BMAT and has the value NPT+N.
   integer, intent(in) :: ndim
   !> Initial values of the variables must be set in X(1), X(2), ..., X(N). They
   !> will be changed to the values that give the least calculated F.
   real(wp), intent(inout) :: x(*)
   real(wp), intent(in) :: rhobeg
   real(wp), intent(in) :: rhoend
   integer, intent(in) :: iprint
   integer, intent(in) :: maxfun
   !> Will hold a shift of origin that should reduce the contributions
   !> from rounding errors to values of the model and Lagrange functions.
   real(wp), intent(inout) :: xbase(*)
   !> Will be set to the displacement from XBASE of the vector of
   !> variables that provides the least calculated F so far.
   real(wp), intent(inout) :: xopt(*)
   !> Will be set to the displacement from XBASE of the vector of
   !> variables for the current calculation of F.
   real(wp), intent(inout) :: xnew(*)
   !> Will contain the interpolation point coordinates relative to XBASE.
   real(wp), intent(inout) :: xpt(npt, *)
   !> Will hold the values of F at the interpolation points.
   real(wp), intent(inout) :: fval(*)
   !> Will hold the gradient of the quadratic model at XBASE.
   real(wp), intent(inout) :: gq(*)
   !> Will hold the explicit second derivatives of the quadratic model.
   real(wp), intent(inout) :: hq(*)
   !> Will contain the parameters of the implicit second derivatives of
   !> the quadratic model.
   real(wp), intent(inout) :: pq(*)
   !> Will hold the last N columns of H.
   real(wp), intent(inout) :: bmat(ndim, *)
   !> Will hold the factorization of the leading NPT by NPT submatrix of
   !> H, this factorization being ZMAT times Diag(DZ) times ZMAT^T, where
   !> the elements of DZ are plus or minus one, as specified by IDZ.
   real(wp), intent(inout) :: zmat(npt, *)
   !> Reserved for trial steps from XOPT.
   real(wp), intent(inout) :: d(*)
   !> Will contain the values of the Lagrange functions at a new point X.
   !> They are part of a product that requires VLAG to be of length NDIM.
   real(wp), intent(inout) :: vlag(*)
   !> The array will be used for working space. Its length must be at least
   !> 10*NDIM = 10*(NPT+N).
   real(wp), intent(inout) :: w(*)
   procedure(objective_function) :: calfun
   class(*), intent(in) :: handle
   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: half = 0.5_wp, one = 1.0_wp, tenth = 0.1_wp, zero = 0.0_wp
   integer :: np, nh, nptm, nftest, i, j, k, ih, idz, ip, ipt, itemp, itest, jp, jpt, &
      & knew, kopt, ksave, ktemp, nf, nfm, nfmm, nfsav
   real(wp) :: rhosq, recip, reciq, alpha, beta, bsum, crvmin, delta, detrat, diff, &
      & diffa, diffb, diffc, distsq, dnorm, dsq, dstep, dx, f, fbeg, fopt, fsave, gisq, &
      & gqsq, hdiag, ratio, rho, sum, suma, sumb, sumz, temp, tempq, vquad, xipt, xjpt, &
      & xoptsq
   np = n + 1
   nh = (n*np) / 2
   nptm = npt - np
   nftest = max(maxfun, 1)
   !
   !     Set the initial elements of XPT, BMAT, HQ, PQ and ZMAT to zero.
   !
   do j = 1, n
      xbase(j) = x(j)
      do k = 1, npt
         xpt(k, j) = zero
      end do
      do i = 1, ndim
         bmat(i, j) = zero
      end do
   end do
   do ih = 1, nh
      hq(ih) = zero
   end do
   do k = 1, npt
      pq(k) = zero
      do j = 1, nptm
         zmat(k, j) = zero
      end do
   end do
   !
   !     Begin the initialization procedure. NF becomes one more than the number
   !     of function values so far. The coordinates of the displacement of the
   !     next initial interpolation point from XBASE are set in XPT(NF, .).
   !
   rhosq = rhobeg * rhobeg
   recip = one / rhosq
   reciq = sqrt(half) / rhosq
   nf = 0
   50 continue
   nfm = nf
   nfmm = nf - n
   nf = nf + 1
   if (nfm <= 2*n) then
      if (nfm >= 1 .and. nfm <= n) then
         xpt(nf, nfm) = rhobeg
      else if (nfm > n) then
         xpt(nf, nfmm) = - rhobeg
      end if
   else
      itemp = (nfmm-1) / n
      jpt = nfm - itemp * n - n
      ipt = jpt + itemp
      if (ipt > n) then
         itemp = jpt
         jpt = ipt - n
         ipt = itemp
      end if
      xipt = rhobeg
      if (fval(ipt+np) < fval(ipt+1)) xipt = - xipt
      xjpt = rhobeg
      if (fval(jpt+np) < fval(jpt+1)) xjpt = - xjpt
      xpt(nf, ipt) = xipt
      xpt(nf, jpt) = xjpt
   end if
   !
   !     Calculate the next value of F, label 70 being reached immediately
   !     after this calculation. The least function value so far and its index
   !     are required.
   !
   do j = 1, n
      x(j) = xpt(nf, j) + xbase(j)
   end do
   go to 310
   70 continue
   fval(nf) = f
   if (nf == 1) then
      fbeg = f
      fopt = f
      kopt = 1
   else if (f < fopt) then
      fopt = f
      kopt = nf
   end if
   !
   !     Set the nonzero initial elements of BMAT and the quadratic model in
   !     the cases when NF is at most 2*N+1.
   !
   if (nfm <= 2*n) then
      if (nfm >= 1 .and. nfm <= n) then
         gq(nfm) = (f-fbeg) / rhobeg
         if (npt < nf+n) then
            bmat(1, nfm) = - one / rhobeg
            bmat(nf, nfm) = one / rhobeg
            bmat(npt+nfm, nfm) = - half * rhosq
         end if
      else if (nfm > n) then
         bmat(nf-n, nfmm) = half / rhobeg
         bmat(nf, nfmm) = - half / rhobeg
         zmat(1, nfmm) = - reciq - reciq
         zmat(nf-n, nfmm) = reciq
         zmat(nf, nfmm) = reciq
         ih = (nfmm*(nfmm+1)) / 2
         temp = (fbeg-f) / rhobeg
         hq(ih) = (gq(nfmm)-temp) / rhobeg
         gq(nfmm) = half * (gq(nfmm)+temp)
      end if
      !
      !     Set the off-diagonal second derivatives of the Lagrange functions and
      !     the initial quadratic model.
      !
   else
      ih = (ipt*(ipt-1)) / 2 + jpt
      if (xipt < zero) ipt = ipt + n
      if (xjpt < zero) jpt = jpt + n
      zmat(1, nfmm) = recip
      zmat(nf, nfmm) = recip
      zmat(ipt+1, nfmm) = - recip
      zmat(jpt+1, nfmm) = - recip
      hq(ih) = (fbeg-fval(ipt+1)-fval(jpt+1)+f) / (xipt*xjpt)
   end if
   if (nf < npt) go to 50
   !
   !     Begin the iterative procedure, because the initial model is complete.
   !
   rho = rhobeg
   delta = rho
   idz = 1
   diffa = zero
   diffb = zero
   itest = 0
   xoptsq = zero
   do i = 1, n
      xopt(i) = xpt(kopt, i)
      xoptsq = xoptsq + xopt(i) ** 2
   end do
   90 continue
   nfsav = nf
   !
   !     Generate the next trust region step and test its length. Set KNEW
   !     to -1 if the purpose of the next F will be to improve the model.
   !
   100 continue
   knew = 0
   call trsapp(n, npt, xopt, xpt, gq, hq, pq, delta, d, w, w(np), w(np+n), &
      w(np+2*n), crvmin)
   dsq = zero
   do i = 1, n
      dsq = dsq + d(i) ** 2
   end do
   dnorm = min(delta, sqrt(dsq))
   if (dnorm < half*rho) then
      knew = - 1
      delta = tenth * delta
      ratio = - 1.0_wp
      if (delta <= 1.5_wp*rho) delta = rho
      if (nf <= nfsav+2) go to 460
      temp = 0.125_wp * crvmin * rho * rho
      if (temp <= max(diffa, diffb, diffc)) go to 460
      go to 490
   end if
   !
   !     Shift XBASE if XOPT may be too far from XBASE. First make the changes
   !     to BMAT that do not depend on ZMAT.
   !
   120 continue
   if (dsq <= 1.0e-3_wp*xoptsq) then
      tempq = 0.25_wp * xoptsq
      do k = 1, npt
         sum = zero
         do i = 1, n
            sum = sum + xpt(k, i) * xopt(i)
         end do
         temp = pq(k) * sum
         sum = sum - half * xoptsq
         w(npt+k) = sum
         do i = 1, n
            gq(i) = gq(i) + temp * xpt(k, i)
            xpt(k, i) = xpt(k, i) - half * xopt(i)
            vlag(i) = bmat(k, i)
            w(i) = sum * xpt(k, i) + tempq * xopt(i)
            ip = npt + i
            do j = 1, i
               bmat(ip, j) = bmat(ip, j) + vlag(i) * w(j) + w(i) * vlag(j)
            end do
         end do
      end do
      !
      !     Then the revisions of BMAT that depend on ZMAT are calculated.
      !
      do k = 1, nptm
         sumz = zero
         do i = 1, npt
            sumz = sumz + zmat(i, k)
            w(i) = w(npt+i) * zmat(i, k)
         end do
         do j = 1, n
            sum = tempq * sumz * xopt(j)
            do i = 1, npt
               sum = sum + w(i) * xpt(i, j)
            end do
            vlag(j) = sum
            if (k < idz) sum = - sum
            do i = 1, npt
               bmat(i, j) = bmat(i, j) + sum * zmat(i, k)
            end do
         end do
         do i = 1, n
            ip = i + npt
            temp = vlag(i)
            if (k < idz) temp = - temp
            do j = 1, i
               bmat(ip, j) = bmat(ip, j) + temp * vlag(j)
            end do
         end do
      end do
      !
      !     The following instructions complete the shift of XBASE, including
      !     the changes to the parameters of the quadratic model.
      !
      ih = 0
      do j = 1, n
         w(j) = zero
         do k = 1, npt
            w(j) = w(j) + pq(k) * xpt(k, j)
            xpt(k, j) = xpt(k, j) - half * xopt(j)
         end do
         do i = 1, j
            ih = ih + 1
            if (i < j) gq(j) = gq(j) + hq(ih) * xopt(i)
            gq(i) = gq(i) + hq(ih) * xopt(j)
            hq(ih) = hq(ih) + w(i) * xopt(j) + xopt(i) * w(j)
            bmat(npt+i, j) = bmat(npt+j, i)
         end do
      end do
      do j = 1, n
         xbase(j) = xbase(j) + xopt(j)
         xopt(j) = zero
      end do
      xoptsq = zero
   end if
   !
   !     Pick the model step if KNEW is positive. A different choice of D
   !     may be made later, if the choice of D by BIGLAG causes substantial
   !     cancellation in DENOM.
   !
   if (knew > 0) then
      call biglag(n, npt, xopt, xpt, bmat, zmat, idz, ndim, knew, dstep, d, alpha, &
         vlag, vlag(npt+1), w, w(np), w(np+n))
   end if
   !
   !     Calculate VLAG and BETA for the current choice of D. The first NPT
   !     components of W_check will be held in W.
   !
   do k = 1, npt
      suma = zero
      sumb = zero
      sum = zero
      do j = 1, n
         suma = suma + xpt(k, j) * d(j)
         sumb = sumb + xpt(k, j) * xopt(j)
         sum = sum + bmat(k, j) * d(j)
      end do
      w(k) = suma * (half*suma+sumb)
      vlag(k) = sum
   end do
   beta = zero
   do k = 1, nptm
      sum = zero
      do i = 1, npt
         sum = sum + zmat(i, k) * w(i)
      end do
      if (k < idz) then
         beta = beta + sum * sum
         sum = - sum
      else
         beta = beta - sum * sum
      end if
      do i = 1, npt
         vlag(i) = vlag(i) + sum * zmat(i, k)
      end do
   end do
   bsum = zero
   dx = zero
   do j = 1, n
      sum = zero
      do i = 1, npt
         sum = sum + w(i) * bmat(i, j)
      end do
      bsum = bsum + sum * d(j)
      jp = npt + j
      do k = 1, n
         sum = sum + bmat(jp, k) * d(k)
      end do
      vlag(jp) = sum
      bsum = bsum + sum * d(j)
      dx = dx + d(j) * xopt(j)
   end do
   beta = dx * dx + dsq * (xoptsq+dx+dx+half*dsq) + beta - bsum
   vlag(kopt) = vlag(kopt) + one
   !
   !     If KNEW is positive and if the cancellation in DENOM is unacceptable,
   !     then BIGDEN calculates an alternative model step, XNEW being used for
   !     working space.
   !
   if (knew > 0) then
      temp = one + alpha * beta / vlag(knew) ** 2
      if (abs(temp) <= 0.8_wp) then
         call bigden(n, npt, xopt, xpt, bmat, zmat, idz, ndim, kopt, knew, d, w, &
            vlag, beta, xnew, w(ndim+1), w(6*ndim+1))
      end if
   end if
   !
   !     Calculate the next value of the objective function.
   !
   290 continue
   do i = 1, n
      xnew(i) = xopt(i) + d(i)
      x(i) = xbase(i) + xnew(i)
   end do
   nf = nf + 1
   310 continue
   if (nf > nftest) then
      nf = nf - 1
      if (iprint > 0) print '(/, 4x, "Return from NEWUOA because CALFUN has been", &
         &" called MAXFUN times.")'
      go to 530
   end if
   f = calfun(n, x, handle, error)
   if (allocated(error)) goto 530
   if (iprint == 3) then
      print '(/, 4x, "Function number", i6, "    F =", 1 es18.10, &
         &"    The corresponding X is:" / (2 x, 5es15.6))', nf, f, (x(i), i=1, n)
   end if
   if (nf <= npt) go to 70
   if (knew ==-1) go to 530
   !
   !     Use the quadratic model to predict the change in F due to the step D,
   !     and set DIFF to the error of this prediction.
   !
   vquad = zero
   ih = 0
   do j = 1, n
      vquad = vquad + d(j) * gq(j)
      do i = 1, j
         ih = ih + 1
         temp = d(i) * xnew(j) + d(j) * xopt(i)
         if (i == j) temp = half * temp
         vquad = vquad + temp * hq(ih)
      end do
   end do
   do k = 1, npt
      vquad = vquad + pq(k) * w(k)
   end do
   diff = f - fopt - vquad
   diffc = diffb
   diffb = diffa
   diffa = abs(diff)
   if (dnorm > rho) nfsav = nf
   !
   !     Update FOPT and XOPT if the new F is the least value of the objective
   !     function so far. The branch when KNEW is positive occurs if D is not
   !     a trust region step.
   !
   fsave = fopt
   if (f < fopt) then
      fopt = f
      xoptsq = zero
      do i = 1, n
         xopt(i) = xnew(i)
         xoptsq = xoptsq + xopt(i) ** 2
      end do
   end if
   ksave = knew
   if (knew > 0) go to 410
   !
   !     Pick the next value of DELTA after a trust region step.
   !
   if (vquad >= zero) then
      if (iprint > 0) print '(/, 4x, "Return from NEWUOA because a trust", &
         &" region step has failed to reduce Q.")'
      go to 530
   end if
   ratio = (f-fsave) / vquad
   if (ratio <= tenth) then
      delta = half * dnorm
   else if (ratio <= 0.7_wp) then
      delta = max(half*delta, dnorm)
   else
      delta = max(half*delta, dnorm+dnorm)
   end if
   if (delta <= 1.5_wp*rho) delta = rho
   !
   !     Set KNEW to the index of the next interpolation point to be deleted.
   !
   rhosq = max(tenth*delta, rho) ** 2
   ktemp = 0
   detrat = zero
   if (f >= fsave) then
      ktemp = kopt
      detrat = one
   end if
   do k = 1, npt
      hdiag = zero
      do j = 1, nptm
         temp = one
         if (j < idz) temp = - one
         hdiag = hdiag + temp * zmat(k, j) ** 2
      end do
      temp = abs(beta*hdiag+vlag(k)**2)
      distsq = zero
      do j = 1, n
         distsq = distsq + (xpt(k, j)-xopt(j)) ** 2
      end do
      if (distsq > rhosq) temp = temp * (distsq/rhosq) ** 3
      if (temp > detrat .and. k /= ktemp) then
         detrat = temp
         knew = k
      end if
   end do
   if (knew == 0) go to 460
   !
   !     Update BMAT, ZMAT and IDZ, so that the KNEW-th interpolation point
   !     can be moved. Begin the updating of the quadratic model, starting
   !     with the explicit second derivative term.
   !
   410 continue
   call update(n, npt, bmat, zmat, idz, ndim, vlag, beta, knew, w)
   fval(knew) = f
   ih = 0
   do i = 1, n
      temp = pq(knew) * xpt(knew, i)
      do j = 1, i
         ih = ih + 1
         hq(ih) = hq(ih) + temp * xpt(knew, j)
      end do
   end do
   pq(knew) = zero
   !
   !     Update the other second derivative parameters, and then the gradient
   !     vector of the model. Also include the new interpolation point.
   !
   do j = 1, nptm
      temp = diff * zmat(knew, j)
      if (j < idz) temp = - temp
      do k = 1, npt
         pq(k) = pq(k) + temp * zmat(k, j)
      end do
   end do
   gqsq = zero
   do i = 1, n
      gq(i) = gq(i) + diff * bmat(knew, i)
      gqsq = gqsq + gq(i) ** 2
      xpt(knew, i) = xnew(i)
   end do
   !
   !     If a trust region step makes a small change to the objective function,
   !     then calculate the gradient of the least Frobenius norm interpolant at
   !     XBASE, and store it in W, using VLAG for a vector of right hand sides.
   !
   if (ksave == 0 .and. delta == rho) then
      if (abs(ratio) > 1.0e-2_wp) then
         itest = 0
      else
         do k = 1, npt
            vlag(k) = fval(k) - fval(kopt)
         end do
         gisq = zero
         do i = 1, n
            sum = zero
            do k = 1, npt
               sum = sum + bmat(k, i) * vlag(k)
            end do
            gisq = gisq + sum * sum
            w(i) = sum
         end do
         !
         !     Test whether to replace the new quadratic model by the least Frobenius
         !     norm interpolant, making the replacement if the test is satisfied.
         !
         itest = itest + 1
         if (gqsq < 100.0_wp*gisq) itest = 0
         if (itest >= 3) then
            do i = 1, n
               gq(i) = w(i)
            end do
            do ih = 1, nh
               hq(ih) = zero
            end do
            do j = 1, nptm
               w(j) = zero
               do k = 1, npt
                  w(j) = w(j) + vlag(k) * zmat(k, j)
               end do
               if (j < idz) w(j) = - w(j)
            end do
            do k = 1, npt
               pq(k) = zero
               do j = 1, nptm
                  pq(k) = pq(k) + zmat(k, j) * w(j)
               end do
            end do
            itest = 0
         end if
      end if
   end if
   if (f < fsave) kopt = knew
   !
   !     If a trust region step has provided a sufficient decrease in F, then
   !     branch for another trust region calculation. The case KSAVE>0 occurs
   !     when the new function value was calculated by a model step.
   !
   if (f <= fsave+tenth*vquad) go to 100
   if (ksave > 0) go to 100
   !
   !     Alternatively, find out if the interpolation points are close enough
   !     to the best point so far.
   !
   knew = 0
   460 continue
   distsq = 4.0_wp * delta * delta
   do k = 1, npt
      sum = zero
      do j = 1, n
         sum = sum + (xpt(k, j)-xopt(j)) ** 2
      end do
      if (sum > distsq) then
         knew = k
         distsq = sum
      end if
   end do
   !
   !     If KNEW is positive, then set DSTEP, and branch back for the next
   !     iteration, which will generate a "model step".
   !
   if (knew > 0) then
      dstep = max(min(tenth*sqrt(distsq), half*delta), rho)
      dsq = dstep * dstep
      go to 120
   end if
   if (ratio > zero) go to 100
   if (max(delta, dnorm) > rho) go to 100
   !
   !     The calculations with the current value of RHO are complete. Pick the
   !     next values of RHO and DELTA.
   !
   490 continue
   if (rho > rhoend) then
      delta = half * rho
      ratio = rho / rhoend
      if (ratio <= 16.0_wp) then
         rho = rhoend
      else if (ratio <= 250.0_wp) then
         rho = sqrt(ratio) * rhoend
      else
         rho = tenth * rho
      end if
      delta = max(delta, rho)
      if (iprint >= 2) then
         if (iprint >= 3) print '(5 x)'
         print '(/ 4 x, "New RHO =", 1 es11.4, 5 x, "Number of", &
            &" function values =", i6)', rho, nf
         print '(4 x, "Least value of F =", 1 es23.15, 9 x, &
            &"The corresponding X is:"/(2 x, 5es15.6))', fopt, (xbase(i)+xopt(i), i=1, n)
      end if
      go to 90
   end if
   !
   !     Return from the calculation, after another Newton-Raphson step, if
   !     it is too short to have been tried before.
   !
   if (knew ==-1) go to 290
   530 if (fopt <= f) then
      do i = 1, n
         x(i) = xbase(i) + xopt(i)
      end do
      f = fopt
   end if
   if (iprint >= 1) then
      print '(/ 4 x, "At the return from NEWUOA", 5 x, &
         &"Number of function values =", i6)', nf
      print '(4 x, "Least value of F =", 1 es23.15, 9 x,&
         &"The corresponding X is:"/(2 x, 5es15.6))', f, (x(i), i=1, n)
   end if

end subroutine newuob

!> D is calculated in a way that should provide a denominator with a large
!> modulus in the updating formula when the KNEW-th interpolation point is
!> shifted to the new position XOPT+D.
pure subroutine bigden(n, npt, xopt, xpt, bmat, zmat, idz, ndim, kopt, knew, d, w, vlag, &
      beta, s, wvec, prod)
   !> N is the number of variables.
   integer, intent(in) :: n
   !> NPT is the number of interpolation equations.
   integer, intent(in) :: npt
   !> NDIM is the first dimension of BMAT and has the value NPT+N.
   integer, intent(in) :: ndim
   !> XOPT is the best interpolation point so far.
   real(wp), intent(in) :: xopt(*)
   !> XPT contains the coordinates of the current interpolation points.
   real(wp), intent(in) :: xpt(npt, *)
   !> BMAT provides the last N columns of H.
   real(wp), intent(in) :: bmat(ndim, *)
   !> ZMAT and IDZ give a factorization of the first NPT by NPT submatrix of H.
   real(wp), intent(in) :: zmat(npt, *)
   integer, intent(in) :: idz
   !> KOPT is the index of the optimal interpolation point.
   integer, intent(in) :: kopt
   !> KNEW is the index of the interpolation point that is going to be moved.
   integer, intent(in) :: knew
   !> D will be set to the step from XOPT to the new point, and on entry it
   !> should be the D that was calculated by the last call of BIGLAG. The
   !> length of the initial D provides a trust region bound on the final D.
   real(wp), intent(inout) :: d(*)
   !> W will be set to Wcheck for the final choice of D.
   real(wp), intent(inout) :: w(*)
   !> VLAG will be set to Theta*Wcheck+e_b for the final choice of D.
   real(wp), intent(inout) :: vlag(*)
   !> BETA will be set to the value that will occur in the updating formula
   !> when the KNEW-th interpolation point is moved to its new position.
   real(wp), intent(inout) :: beta
   !> S, WVEC, PROD and the private arrays DEN, DENEX and PAR will be used
   !> for working space.
   real(wp), intent(inout) :: s(*)
   real(wp), intent(inout) :: wvec(ndim, *)
   real(wp), intent(inout) :: prod(ndim, *)

   integer :: i, j, k, ip, isave, iterc, iu, jc, ksav, nptm, nw
   real(wp) :: den(9), denex(9), par(9), temp, alpha, dd, ds, ss, angle, denmax, denold, &
      & densav, sum, diff, dstemp, dtest, ssden, sstemp, step, sumold, tau, tempa, tempb, &
      & tempc, xoptd, xopts, xoptsq
   real(wp), parameter :: half = 0.5_wp, one = 1.0_wp, quart = 0.25_wp, two = 2.0_wp, &
      & zero = 0.0_wp, twopi = 8.0_wp * atan(one)
   nptm = npt - n - 1
   !
   !     Store the first NPT elements of the KNEW-th column of H in W(N+1)
   !     to W(N+NPT).
   !
   do k = 1, npt
      w(n+k) = zero
   end do
   do j = 1, nptm
      temp = zmat(knew, j)
      if (j < idz) temp = - temp
      do k = 1, npt
         w(n+k) = w(n+k) + temp * zmat(k, j)
      end do
   end do
   alpha = w(n+knew)
   !
   !     The initial search direction D is taken from the last call of BIGLAG,
   !     and the initial S is set below, usually to the direction from X_OPT
   !     to X_KNEW, but a different direction to an interpolation point may
   !     be chosen, in order to prevent S from being nearly parallel to D.
   !
   dd = zero
   ds = zero
   ss = zero
   xoptsq = zero
   do i = 1, n
      dd = dd + d(i) ** 2
      s(i) = xpt(knew, i) - xopt(i)
      ds = ds + d(i) * s(i)
      ss = ss + s(i) ** 2
      xoptsq = xoptsq + xopt(i) ** 2
   end do
   if (ds*ds > 0.99_wp*dd*ss) then
      ksav = knew
      dtest = ds * ds / ss
      do k = 1, npt
         if (k /= kopt) then
            dstemp = zero
            sstemp = zero
            do i = 1, n
               diff = xpt(k, i) - xopt(i)
               dstemp = dstemp + d(i) * diff
               sstemp = sstemp + diff * diff
            end do
            if (dstemp*dstemp/sstemp < dtest) then
               ksav = k
               dtest = dstemp * dstemp / sstemp
               ds = dstemp
               ss = sstemp
            end if
         end if
      end do
      do i = 1, n
         s(i) = xpt(ksav, i) - xopt(i)
      end do
   end if
   ssden = dd * ss - ds * ds
   iterc = 0
   densav = zero
   !
   !     Begin the iteration by overwriting S with a vector that has the
   !     required length and direction.
   !
   70      iterc = iterc + 1
   temp = one / sqrt(ssden)
   xoptd = zero
   xopts = zero
   do i = 1, n
      s(i) = temp * (dd*s(i)-ds*d(i))
      xoptd = xoptd + xopt(i) * d(i)
      xopts = xopts + xopt(i) * s(i)
   end do
   !
   !     Set the coefficients of the first two terms of BETA.
   !
   tempa = half * xoptd * xoptd
   tempb = half * xopts * xopts
   den(1) = dd * (xoptsq+half*dd) + tempa + tempb
   den(2) = two * xoptd * dd
   den(3) = two * xopts * dd
   den(4) = tempa - tempb
   den(5) = xoptd * xopts
   do i = 6, 9
      den(i) = zero
   end do
   !
   !     Put the coefficients of Wcheck in WVEC.
   !
   do k = 1, npt
      tempa = zero
      tempb = zero
      tempc = zero
      do i = 1, n
         tempa = tempa + xpt(k, i) * d(i)
         tempb = tempb + xpt(k, i) * s(i)
         tempc = tempc + xpt(k, i) * xopt(i)
      end do
      wvec(k, 1) = quart * (tempa*tempa+tempb*tempb)
      wvec(k, 2) = tempa * tempc
      wvec(k, 3) = tempb * tempc
      wvec(k, 4) = quart * (tempa*tempa-tempb*tempb)
      wvec(k, 5) = half * tempa * tempb
   end do
   do i = 1, n
      ip = i + npt
      wvec(ip, 1) = zero
      wvec(ip, 2) = d(i)
      wvec(ip, 3) = s(i)
      wvec(ip, 4) = zero
      wvec(ip, 5) = zero
   end do
   !
   !     Put the coefficents of THETA*Wcheck in PROD.
   !
   do jc = 1, 5
      nw = npt
      if(jc == 2 .or. jc == 3) nw = ndim
      do k = 1, npt
         prod(k, jc) = zero
      end do
      do j = 1, nptm
         sum = zero
         do k = 1, npt
            sum = sum + zmat(k, j) * wvec(k, jc)
         end do
         if (j < idz) sum = - sum
         do k = 1, npt
            prod(k, jc) = prod(k, jc) + sum * zmat(k, j)
         end do
      end do
      if (nw == ndim) then
         do k = 1, npt
            sum = zero
            do j = 1, n
               sum = sum + bmat(k, j) * wvec(npt+j, jc)
            end do
            prod(k, jc) = prod(k, jc) + sum
         end do
      end if
      do j = 1, n
         sum = zero
         do i = 1, nw
            sum = sum + bmat(i, j) * wvec(i, jc)
         end do
         prod(npt+j, jc) = sum
      end do
   end do
   !
   !     Include in DEN the part of BETA that depends on THETA.
   !
   do k = 1, ndim
      sum = zero
      do i = 1, 5
         par(i) = half * prod(k, i) * wvec(k, i)
         sum = sum + par(i)
      end do
      den(1) = den(1) - par(1) - sum
      tempa = prod(k, 1) * wvec(k, 2) + prod(k, 2) * wvec(k, 1)
      tempb = prod(k, 2) * wvec(k, 4) + prod(k, 4) * wvec(k, 2)
      tempc = prod(k, 3) * wvec(k, 5) + prod(k, 5) * wvec(k, 3)
      den(2) = den(2) - tempa - half * (tempb+tempc)
      den(6) = den(6) - half * (tempb-tempc)
      tempa = prod(k, 1) * wvec(k, 3) + prod(k, 3) * wvec(k, 1)
      tempb = prod(k, 2) * wvec(k, 5) + prod(k, 5) * wvec(k, 2)
      tempc = prod(k, 3) * wvec(k, 4) + prod(k, 4) * wvec(k, 3)
      den(3) = den(3) - tempa - half * (tempb-tempc)
      den(7) = den(7) - half * (tempb+tempc)
      tempa = prod(k, 1) * wvec(k, 4) + prod(k, 4) * wvec(k, 1)
      den(4) = den(4) - tempa - par(2) + par(3)
      tempa = prod(k, 1) * wvec(k, 5) + prod(k, 5) * wvec(k, 1)
      tempb = prod(k, 2) * wvec(k, 3) + prod(k, 3) * wvec(k, 2)
      den(5) = den(5) - tempa - half * tempb
      den(8) = den(8) - par(4) + par(5)
      tempa = prod(k, 4) * wvec(k, 5) + prod(k, 5) * wvec(k, 4)
      den(9) = den(9) - half * tempa
   end do
   !
   !     Extend DEN so that it holds all the coefficients of DENOM.
   !
   sum = zero
   do i = 1, 5
      par(i) = half * prod(knew, i) ** 2
      sum = sum + par(i)
   end do
   denex(1) = alpha * den(1) + par(1) + sum
   tempa = two * prod(knew, 1) * prod(knew, 2)
   tempb = prod(knew, 2) * prod(knew, 4)
   tempc = prod(knew, 3) * prod(knew, 5)
   denex(2) = alpha * den(2) + tempa + tempb + tempc
   denex(6) = alpha * den(6) + tempb - tempc
   tempa = two * prod(knew, 1) * prod(knew, 3)
   tempb = prod(knew, 2) * prod(knew, 5)
   tempc = prod(knew, 3) * prod(knew, 4)
   denex(3) = alpha * den(3) + tempa + tempb - tempc
   denex(7) = alpha * den(7) + tempb + tempc
   tempa = two * prod(knew, 1) * prod(knew, 4)
   denex(4) = alpha * den(4) + tempa + par(2) - par(3)
   tempa = two * prod(knew, 1) * prod(knew, 5)
   denex(5) = alpha * den(5) + tempa + prod(knew, 2) * prod(knew, 3)
   denex(8) = alpha * den(8) + par(4) - par(5)
   denex(9) = alpha * den(9) + prod(knew, 4) * prod(knew, 5)
   !
   !     Seek the value of the angle that maximizes the modulus of DENOM.
   !
   sum = denex(1) + denex(2) + denex(4) + denex(6) + denex(8)
   denold = sum
   denmax = sum
   isave = 0
   iu = 49
   temp = twopi / real(iu+1, wp)
   par(1) = one
   do i = 1, iu
      angle = real(i, wp) * temp
      par(2) = cos(angle)
      par(3) = sin(angle)
      do j = 4, 8, 2
         par(j) = par(2) * par(j-2) - par(3) * par(j-1)
         par(j+1) = par(2) * par(j-1) + par(3) * par(j-2)
      end do
      sumold = sum
      sum = zero
      do j = 1, 9
         sum = sum + denex(j) * par(j)
      end do
      if (abs(sum) > abs(denmax)) then
         denmax = sum
         isave = i
         tempa = sumold
      else if (i == isave+1) then
         tempb = sum
      end if
   end do
   if (isave == 0) tempa = sum
   if (isave == iu) tempb = denold
   step = zero
   if (tempa /= tempb) then
      tempa = tempa - denmax
      tempb = tempb - denmax
      step = half * (tempa-tempb) / (tempa+tempb)
   end if
   angle = temp * (real(isave, wp)+step)
   !
   !     Calculate the new parameters of the denominator, the new VLAG vector
   !     and the new D. Then test for convergence.
   !
   par(2) = cos(angle)
   par(3) = sin(angle)
   do j = 4, 8, 2
      par(j) = par(2) * par(j-2) - par(3) * par(j-1)
      par(j+1) = par(2) * par(j-1) + par(3) * par(j-2)
   end do
   beta = zero
   denmax = zero
   do j = 1, 9
      beta = beta + den(j) * par(j)
      denmax = denmax + denex(j) * par(j)
   end do
   do k = 1, ndim
      vlag(k) = zero
      do j = 1, 5
         vlag(k) = vlag(k) + prod(k, j) * par(j)
      end do
   end do
   tau = vlag(knew)
   dd = zero
   tempa = zero
   tempb = zero
   do i = 1, n
      d(i) = par(2) * d(i) + par(3) * s(i)
      w(i) = xopt(i) + d(i)
      dd = dd + d(i) ** 2
      tempa = tempa + d(i) * w(i)
      tempb = tempb + w(i) * w(i)
   end do
   if(iterc >= n) go to 340
   if(iterc > 1) densav = max(densav, denold)
   if(abs(denmax) <= 1.1_wp*abs(densav)) go to 340
   densav = denmax
   !
   !     Set S to half the gradient of the denominator with respect to D.
   !     Then branch for the next iteration.
   !
   do i = 1, n
      temp = tempa * xopt(i) + tempb * d(i) - vlag(npt+i)
      s(i) = tau * bmat(knew, i) + alpha * temp
   end do
   do k = 1, npt
      sum = zero
      do j = 1, n
         sum = sum + xpt(k, j) * w(j)
      end do
      temp = (tau*w(n+k)-alpha*vlag(k)) * sum
      do i = 1, n
         s(i) = s(i) + temp * xpt(k, i)
      end do
   end do
   ss = zero
   ds = zero
   do i = 1, n
      ss = ss + s(i) ** 2
      ds = ds + d(i) * s(i)
   end do
   ssden = dd * ss - ds * ds
   if (ssden >= 1.0e-8_wp*dd*ss) go to 70
   !
   !     Set the vector W before the RETURN from the subroutine.
   !
   340 continue
   do k = 1, ndim
      w(k) = zero
      do j = 1, 5
         w(k) = w(k) + wvec(k, j) * par(j)
      end do
   end do
   vlag(kopt) = vlag(kopt) + one

end subroutine bigden

!> The step D is calculated in a way that attempts to maximize the modulus
!> of LFUNC(XOPT+D), subject to the bound ||D|| .LE. DELTA, where LFUNC is
!> the KNEW-th Lagrange function.
pure subroutine biglag(n, npt, xopt, xpt, bmat, zmat, idz, ndim, knew, delta, d, alpha, &
      hcol, gc, gd, s, w)
   !> N is the number of variables.
   integer, intent(in) :: n
   !> NPT is the number of interpolation equations.
   integer, intent(in) :: npt
   !> NDIM is the first dimension of BMAT and has the value NPT+N.
   integer, intent(in) :: ndim
   !> XOPT is the best interpolation point so far.
   real(wp), intent(in) :: xopt(*)
   !> XPT contains the coordinates of the current interpolation points.
   real(wp), intent(in) :: xpt(npt, *)
   !> BMAT provides the last N columns of H.
   real(wp), intent(in) :: bmat(ndim, *)
   !> ZMAT and IDZ give a factorization of the first NPT by NPT submatrix of H.
   real(wp), intent(in) :: zmat(npt, *)
   integer, intent(in) :: idz
   !> KNEW is the index of the interpolation point that is going to be moved.
   integer, intent(in) :: knew
   !> DELTA is the current trust region bound.
   real(wp), intent(in) :: delta
   !> D will be set to the step from XOPT to the new point.
   real(wp), intent(inout) :: d(*)
   !> ALPHA will be set to the KNEW-th diagonal element of the H matrix.
   real(wp), intent(inout) :: alpha
   !> HCOL, GC, GD, S and W will be used for working space.
   real(wp), intent(inout) :: hcol(*)
   real(wp), intent(inout) :: gc(*)
   real(wp), intent(inout) :: gd(*)
   real(wp), intent(inout) :: s(*)
   real(wp), intent(inout) :: w(*)

   integer :: iterc, i, j, k, nptm, isave, iu
   real(wp) :: temp, delsq, dd, angle, cf1, cf2, cf3, cf4, cf5, cth, denom, dhd, gg, scale, &
      & sp, ss, step, sth, sum, tau, taubeg, taumax, tauold, tempa, tempb
   real(wp), parameter :: half = 0.5_wp, one = 1.0_wp, zero = 0.0_wp, &
      & twopi = 8.0_wp * atan(one)
   delsq = delta * delta
   nptm = npt - n - 1
   !
   !     Set the first NPT components of HCOL to the leading elements of the
   !     KNEW-th column of H.
   !
   iterc = 0
   do k = 1, npt
      hcol(k) = zero
   end do
   do j = 1, nptm
      temp = zmat(knew, j)
      if (j < idz) temp = - temp
      do k = 1, npt
         hcol(k) = hcol(k) + temp * zmat(k, j)
      end do
   end do
   alpha = hcol(knew)
   !
   !     Set the unscaled initial direction D. Form the gradient of LFUNC at
   !     XOPT, and multiply D by the second derivative matrix of LFUNC.
   !
   dd = zero
   do i = 1, n
      d(i) = xpt(knew, i) - xopt(i)
      gc(i) = bmat(knew, i)
      gd(i) = zero
      dd = dd + d(i) ** 2
   end do
   do k = 1, npt
      temp = zero
      sum = zero
      do j = 1, n
         temp = temp + xpt(k, j) * xopt(j)
         sum = sum + xpt(k, j) * d(j)
      end do
      temp = hcol(k) * temp
      sum = hcol(k) * sum
      do i = 1, n
         gc(i) = gc(i) + temp * xpt(k, i)
         gd(i) = gd(i) + sum * xpt(k, i)
      end do
   end do
   !
   !     Scale D and GD, with a sign change if required. Set S to another
   !     vector in the initial two dimensional subspace.
   !
   gg = zero
   sp = zero
   dhd = zero
   do i = 1, n
      gg = gg + gc(i) ** 2
      sp = sp + d(i) * gc(i)
      dhd = dhd + d(i) * gd(i)
   end do
   scale = delta / sqrt(dd)
   if (sp*dhd < zero) scale = - scale
   temp = zero
   if (sp*sp > 0.99_wp*dd*gg) temp = one
   tau = scale * (abs(sp)+half*scale*abs(dhd))
   if (gg*delsq < 0.01_wp*tau*tau) temp = one
   do i = 1, n
      d(i) = scale * d(i)
      gd(i) = scale * gd(i)
      s(i) = gc(i) + temp * gd(i)
   end do
   !
   !     Begin the iteration by overwriting S with a vector that has the
   !     required length and direction, except that termination occurs if
   !     the given D and S are nearly parallel.
   !
   80      iterc = iterc + 1
   dd = zero
   sp = zero
   ss = zero
   do i = 1, n
      dd = dd + d(i) ** 2
      sp = sp + d(i) * s(i)
      ss = ss + s(i) ** 2
   end do
   temp = dd * ss - sp * sp
   if (temp <= 1.0e-8_wp*dd*ss) go to 160
   denom = sqrt(temp)
   do i = 1, n
      s(i) = (dd*s(i)-sp*d(i)) / denom
      w(i) = zero
   end do
   !
   !     Calculate the coefficients of the objective function on the circle,
   !     beginning with the multiplication of S by the second derivative matrix.
   !
   do k = 1, npt
      sum = zero
      do j = 1, n
         sum = sum + xpt(k, j) * s(j)
      end do
      sum = hcol(k) * sum
      do i = 1, n
         w(i) = w(i) + sum * xpt(k, i)
      end do
   end do
   cf1 = zero
   cf2 = zero
   cf3 = zero
   cf4 = zero
   cf5 = zero
   do i = 1, n
      cf1 = cf1 + s(i) * w(i)
      cf2 = cf2 + d(i) * gc(i)
      cf3 = cf3 + s(i) * gc(i)
      cf4 = cf4 + d(i) * gd(i)
      cf5 = cf5 + s(i) * gd(i)
   end do
   cf1 = half * cf1
   cf4 = half * cf4 - cf1
   !
   !     Seek the value of the angle that maximizes the modulus of TAU.
   !
   taubeg = cf1 + cf2 + cf4
   taumax = taubeg
   tauold = taubeg
   isave = 0
   iu = 49
   temp = twopi / real(iu+1, wp)
   do i = 1, iu
      angle = real(i, wp) * temp
      cth = cos(angle)
      sth = sin(angle)
      tau = cf1 + (cf2+cf4*cth) * cth + (cf3+cf5*cth) * sth
      if (abs(tau) > abs(taumax)) then
         taumax = tau
         isave = i
         tempa = tauold
      else if (i == isave+1) then
         tempb = tau
      end if
      tauold = tau
   end do
   if (isave == 0) tempa = tau
   if (isave == iu) tempb = taubeg
   step = zero
   if (tempa /= tempb) then
      tempa = tempa - taumax
      tempb = tempb - taumax
      step = half * (tempa-tempb) / (tempa+tempb)
   end if
   angle = temp * (real(isave, wp)+step)
   !
   !     Calculate the new D and GD. Then test for convergence.
   !
   cth = cos(angle)
   sth = sin(angle)
   tau = cf1 + (cf2+cf4*cth) * cth + (cf3+cf5*cth) * sth
   do i = 1, n
      d(i) = cth * d(i) + sth * s(i)
      gd(i) = cth * gd(i) + sth * w(i)
      s(i) = gc(i) + gd(i)
   end do
   if (abs(tau) <= 1.1_wp*abs(taubeg)) go to 160
   if (iterc < n) go to 80
   160 return
end subroutine biglag

!> The calculation of STEP begins with the truncated conjugate gradient
!> method. If the boundary of the trust region is reached, then further
!> changes to STEP may be made, each one being in the 2D space spanned
!> by the current STEP and the corresponding gradient of Q. Thus STEP
!> should provide a substantial reduction to Q within the trust region.
pure subroutine trsapp(n, npt, xopt, xpt, gq, hq, pq, delta, step, d, g, hd, hs, crvmin)
   !> N is the number of variables of a quadratic objective function, Q say.
   integer, intent(in) :: n
   !> The arguments NPT, XOPT, XPT, GQ, HQ and PQ have their usual meanings,
   !>   in order to define the current quadratic model Q.
   integer, intent(in) :: npt
   real(wp), intent(in) :: xopt(*)
   real(wp), intent(in) :: xpt(npt, *)
   real(wp), intent(in) :: gq(*)
   real(wp), intent(in) :: hq(*)
   real(wp), intent(in) :: pq(*)
   !> DELTA is the trust region radius, and has to be positive.
   real(wp), intent(in) :: delta
   !> STEP will be set to the calculated trial step.
   real(wp), intent(inout) :: step(*)
   !> The arrays D, G, HD and HS will be used for working space.
   real(wp), intent(inout) :: d(*)
   real(wp), intent(inout) :: g(*)
   real(wp), intent(inout) :: hd(*)
   real(wp), intent(inout) :: hs(*)
   !> CRVMIN will be set to the least curvature of H along the conjugate
   !>   directions that occur, except that it is set to zero if STEP goes
   !>   all the way to the trust region boundary.
   real(wp), intent(inout) :: crvmin

   integer :: i, iterc, itermax, itersw, ih, isave, iu, j, k
   real(wp) :: delsq, qred, dd, ds, ss, gg, ggbeg, temp, bstep, alpha, angle, angtest, &
      & cf, cth, dg, dhd, dhs, ggsav, qadd, qbeg, qmin, qnew, qsav, ratio, reduc, sg, &
      & sgk, shs, sth, tempa, tempb
   real(wp), parameter :: half = 0.5_wp, zero = 0.0_wp, twopi = 8.0_wp * atan(1.0_wp)
   delsq = delta * delta
   iterc = 0
   itermax = n
   itersw = itermax
   do i = 1, n
      d(i) = xopt(i)
   end do
   go to 170
   !
   !     Prepare for the first line search.
   !
   20 continue
   qred = zero
   dd = zero
   do i = 1, n
      step(i) = zero
      hs(i) = zero
      g(i) = gq(i) + hd(i)
      d(i) = - g(i)
      dd = dd + d(i) ** 2
   end do
   crvmin = zero
   if (dd == zero) go to 160
   ds = zero
   ss = zero
   gg = dd
   ggbeg = gg
   !
   !     Calculate the step to the trust region boundary and the product HD.
   !
   40 continue
   iterc = iterc + 1
   temp = delsq - ss
   bstep = temp / (ds+sqrt(ds*ds+dd*temp))
   go to 170
   50 continue
   dhd = zero
   do j = 1, n
      dhd = dhd + d(j) * hd(j)
   end do
   !
   !     Update CRVMIN and set the step-length ALPHA.
   !
   alpha = bstep
   if (dhd > zero) then
      temp = dhd / dd
      if (iterc == 1) crvmin = temp
      crvmin = min(crvmin, temp)
      alpha = min(alpha, gg/dhd)
   end if
   qadd = alpha * (gg-half*alpha*dhd)
   qred = qred + qadd
   !
   !     Update STEP and HS.
   !
   ggsav = gg
   gg = zero
   do i = 1, n
      step(i) = step(i) + alpha * d(i)
      hs(i) = hs(i) + alpha * hd(i)
      gg = gg + (g(i)+hs(i)) ** 2
   end do
   !
   !     Begin another conjugate direction iteration if required.
   !
   if (alpha < bstep) then
      if (qadd <= 0.01_wp*qred) go to 160
      if (gg <= 1.0e-4_wp*ggbeg) go to 160
      if (iterc == itermax) go to 160
      temp = gg / ggsav
      dd = zero
      ds = zero
      ss = zero
      do i = 1, n
         d(i) = temp * d(i) - g(i) - hs(i)
         dd = dd + d(i) ** 2
         ds = ds + d(i) * step(i)
         ss = ss + step(i) ** 2
      end do
      if (ds <= zero) go to 160
      if (ss < delsq) go to 40
   end if
   crvmin = zero
   itersw = iterc
   !
   !     Test whether an alternative iteration is required.
   !
   90 continue
   if (gg <= 1.0e-4_wp*ggbeg) go to 160
   sg = zero
   shs = zero
   do i = 1, n
      sg = sg + step(i) * g(i)
      shs = shs + step(i) * hs(i)
   end do
   sgk = sg + shs
   angtest = sgk / sqrt(gg*delsq)
   if (angtest <=-0.99_wp) go to 160
   !
   !     Begin the alternative iteration by calculating D and HD and some
   !     scalar products.
   !
   iterc = iterc + 1
   temp = sqrt(delsq*gg-sgk*sgk)
   tempa = delsq / temp
   tempb = sgk / temp
   do i = 1, n
      d(i) = tempa * (g(i)+hs(i)) - tempb * step(i)
   end do
   go to 170
   120 continue
   dg = zero
   dhd = zero
   dhs = zero
   do i = 1, n
      dg = dg + d(i) * g(i)
      dhd = dhd + hd(i) * d(i)
      dhs = dhs + hd(i) * step(i)
   end do
   !
   !     Seek the value of the angle that minimizes Q.
   !
   cf = half * (shs-dhd)
   qbeg = sg + cf
   qsav = qbeg
   qmin = qbeg
   isave = 0
   iu = 49
   temp = twopi / real(iu+1, wp)
   do i = 1, iu
      angle = real(i, wp) * temp
      cth = cos(angle)
      sth = sin(angle)
      qnew = (sg+cf*cth) * cth + (dg+dhs*cth) * sth
      if (qnew < qmin) then
         qmin = qnew
         isave = i
         tempa = qsav
      else if (i == isave+1) then
         tempb = qnew
      end if
      qsav = qnew
   end do
   if (isave == zero) tempa = qnew
   if (isave == iu) tempb = qbeg
   angle = zero
   if (tempa /= tempb) then
      tempa = tempa - qmin
      tempb = tempb - qmin
      angle = half * (tempa-tempb) / (tempa+tempb)
   end if
   angle = temp * (real(isave, wp)+angle)
   !
   !     Calculate the new STEP and HS. Then test for convergence.
   !
   cth = cos(angle)
   sth = sin(angle)
   reduc = qbeg - (sg+cf*cth) * cth - (dg+dhs*cth) * sth
   gg = zero
   do i = 1, n
      step(i) = cth * step(i) + sth * d(i)
      hs(i) = cth * hs(i) + sth * hd(i)
      gg = gg + (g(i)+hs(i)) ** 2
   end do
   qred = qred + reduc
   ratio = reduc / qred
   if (iterc < itermax .and. ratio > 0.01_wp) go to 90
   160 return
   !
   !     The following instructions act as a subroutine for setting the vector
   !     HD to the vector D multiplied by the second derivative matrix of Q.
   !     They are called from three different places, which are distinguished
   !     by the value of ITERC.
   !
   170 continue
   do i = 1, n
      hd(i) = zero
   end do
   do k = 1, npt
      temp = zero
      do j = 1, n
         temp = temp + xpt(k, j) * d(j)
      end do
      temp = temp * pq(k)
      do i = 1, n
         hd(i) = hd(i) + temp * xpt(k, i)
      end do
   end do
   ih = 0
   do j = 1, n
      do i = 1, j
         ih = ih + 1
         if (i < j) hd(j) = hd(j) + hq(ih) * d(i)
         hd(i) = hd(i) + hq(ih) * d(j)
      end do
   end do
   if (iterc == 0) go to 20
   if (iterc <= itersw) go to 50
   go to 120
end subroutine trsapp

!> The arrays BMAT and ZMAT with IDZ are updated, in order to shift the
!> interpolation point that has index KNEW. On entry, VLAG contains the
!> components of the vector Theta*Wcheck+e_b of the updating formula
!> (6.11), and BETA holds the value of the parameter that has this name.
!> The vector W is used for working space.
pure subroutine update(n, npt, bmat, zmat, idz, ndim, vlag, beta, knew, w)
   integer, intent(in) :: n
   integer, intent(in) :: npt
   integer, intent(in) :: ndim
   real(wp), intent(inout) :: bmat(ndim, *)
   real(wp), intent(inout) :: zmat(npt, *)
   integer, intent(inout) :: idz
   real(wp), intent(inout) :: vlag(*)
   real(wp), intent(in) :: beta
   integer, intent(in) :: knew
   real(wp), intent(inout) :: w(*)

   integer :: i, j, ja, jb, jl, jp, iflag, nptm
   real(wp) :: temp, tempa, tempb, alpha, denom, scala, scalb, tau, tausq
   real(wp), parameter :: one = 1.0_wp, zero = 0.0_wp
   nptm = npt - n - 1
   !
   !     Apply the rotations that put zeros in the KNEW-th row of ZMAT.
   !
   jl = 1
   do j = 2, nptm
      if (j == idz) then
         jl = idz
      else if (zmat(knew, j) /= zero) then
         temp = sqrt(zmat(knew, jl)**2+zmat(knew, j)**2)
         tempa = zmat(knew, jl) / temp
         tempb = zmat(knew, j) / temp
         do i = 1, npt
            temp = tempa * zmat(i, jl) + tempb * zmat(i, j)
            zmat(i, j) = tempa * zmat(i, j) - tempb * zmat(i, jl)
            zmat(i, jl) = temp
         end do
         zmat(knew, j) = zero
      end if
   end do
   !
   !     Put the first NPT components of the KNEW-th column of HLAG into W,
   !     and calculate the parameters of the updating formula.
   !
   tempa = zmat(knew, 1)
   if (idz >= 2) tempa = - tempa
   if (jl > 1) tempb = zmat(knew, jl)
   do i = 1, npt
      w(i) = tempa * zmat(i, 1)
      if (jl > 1) w(i) = w(i) + tempb * zmat(i, jl)
   end do
   alpha = w(knew)
   tau = vlag(knew)
   tausq = tau * tau
   denom = alpha * beta + tausq
   vlag(knew) = vlag(knew) - one
   !
   !     Complete the updating of ZMAT when there is only one nonzero element
   !     in the KNEW-th row of the new matrix ZMAT, but, if IFLAG is set to one,
   !     then the first column of ZMAT will be exchanged with another one later.
   !
   iflag = 0
   if (jl == 1) then
      temp = sqrt(abs(denom))
      tempb = tempa / temp
      tempa = tau / temp
      do i = 1, npt
         zmat(i, 1) = tempa * zmat(i, 1) - tempb * vlag(i)
      end do
      if (idz == 1 .and. temp < zero) idz = 2
      if (idz >= 2 .and. temp >= zero) iflag = 1
   else
      !
      !     Complete the updating of ZMAT in the alternative case.
      !
      ja = 1
      if (beta >= zero) ja = jl
      jb = jl + 1 - ja
      temp = zmat(knew, jb) / denom
      tempa = temp * beta
      tempb = temp * tau
      temp = zmat(knew, ja)
      scala = one / sqrt(abs(beta)*temp*temp+tausq)
      scalb = scala * sqrt(abs(denom))
      do i = 1, npt
         zmat(i, ja) = scala * (tau*zmat(i, ja)-temp*vlag(i))
         zmat(i, jb) = scalb * (zmat(i, jb)-tempa*w(i)-tempb*vlag(i))
      end do
      if (denom <= zero) then
         if (beta < zero) idz = idz + 1
         if (beta >= zero) iflag = 1
      end if
   end if
   !
   !     IDZ is reduced in the following case, and usually the first column
   !     of ZMAT is exchanged with a later one.
   !
   if (iflag == 1) then
      idz = idz - 1
      do i = 1, npt
         temp = zmat(i, 1)
         zmat(i, 1) = zmat(i, idz)
         zmat(i, idz) = temp
      end do
   end if
   !
   !     Finally, update the matrix BMAT.
   !
   do j = 1, n
      jp = npt + j
      w(jp) = bmat(knew, j)
      tempa = (alpha*vlag(jp)-tau*w(jp)) / denom
      tempb = (-beta*w(jp)-tau*vlag(jp)) / denom
      do i = 1, jp
         bmat(i, j) = bmat(i, j) + tempa * vlag(i) + tempb * w(i)
         if (i > npt) bmat(jp, i-npt) = bmat(i, j)
      end do
   end do

end subroutine update

end module tblite_fit_newuoa

module ddx_errors

use ddx_definitions

!> ddX type for containing ddx_error information
type ddx_error_type
    !> Flag for ddx_error codes
    integer :: flag = 0
    !> Error message log
    integer :: max_length = 2047
    character(len=2047) :: message
    integer :: message_length = 0
end type ddx_error_type

contains

subroutine print_error(ddx_error)
    implicit none
    type(ddx_error_type), intent(in) :: ddx_error
    write(6, "(A)") ddx_error % message(1:1+ddx_error % message_length)
end subroutine print_error

subroutine check_error(ddx_error)
    implicit none
    type(ddx_error_type), intent(in) :: ddx_error
    if (ddx_error % flag .ne. 0) then
        call print_error(ddx_error)
        stop 1
    end if
end subroutine check_error

subroutine update_error(ddx_error, message)
    implicit none
    type(ddx_error_type), intent(inout) :: ddx_error
    character(len=*) :: message
    integer :: message_start, message_stop, message_length, total_length
    ! update the ddx_error flag by summing one
    ddx_error % flag  = ddx_error % flag + 1
    message_length = len(message)
    total_length = message_length + 2
    message_start = 1 + ddx_error % message_length
    message_stop = message_start + total_length
    ! update the message
    if (message_stop .lt. ddx_error % max_length) then
        ddx_error % message(message_start:message_start) = " "
        ddx_error % message(message_start+1:message_stop-2) = message(1:message_length)
        ddx_error % message(message_stop-1:message_stop-1) = achar(10)
        ddx_error % message_length = ddx_error % message_length + total_length
    else if (message_stop - ddx_error % max_length .gt. 3) then
        message_length = ddx_error % max_length - message_start
        ddx_error % message(message_start:message_start) = " "
        ddx_error % message(message_start+1:ddx_error % max_length-2) = message(1:message_length-3)
        ddx_error % message(ddx_error % max_length-1:ddx_error%max_length-1) = achar(10)
        ddx_error % message_length = ddx_error % message_length + message_length
    end if
end subroutine update_error

subroutine reset_error(ddx_error)
    implicit none
    type(ddx_error_type), intent(inout) :: ddx_error
    integer :: i
    ddx_error % flag = 0
    ddx_error % message_length = 0
    do i = 1, ddx_error % max_length
        ddx_error % message(i:i) = " "
    end do
end subroutine reset_error

end module ddx_errors

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of a sparse neighbour map in compressed sparse row format.
!>
!> A symmetric neighbour map given in dense format like
!>
!>       | 1 | 2 | 3 | 4 | 5 | 6
!>    ---|---|---|---|---|---|---
!>     1 |   | x |   | x | x |
!>     2 | x |   | x |   | x | x
!>     3 |   | x |   | x |   | x
!>     4 | x |   | x |   | x | x
!>     5 | x | x |   | x |   |
!>     6 |   | x | x | x |   |
!>
!> Is stored in two compressed array identifying the neighbouring atom `nlat`
!> and its cell index `nltr`. Two index arrays `inl` for the offset
!> and `nnl` for the number of entries map the atomic index to the row index.
!>
!>    inl   =  0,       3,          7,      10,         14,      17, 20
!>    nnl   =  |  2 ->  |  3 ->     |  2 ->  |  3 ->     |  2 ->  |  |
!>    nlat  =     2, 4, 5, 1, 3, 5, 6, 2, 4, 6, 1, 3, 5, 6, 1, 2, 4, 2, 3, 4
!>    nltr  =     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
!>
!> An alternative representation would be to store just the offsets in `inl` and
!> additional beyond the last element the total number of neighbors. However,
!> the indexing is from inl(i) to inl(i+1)-1 could be confusing, therefore
!> two arrays are used for clarity.
module tblite_adjlist
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_resize, only : resize
   implicit none
   private

   public :: adjacency_list, new_adjacency_list

   !> Neighbourlist in CSR format
   type :: adjacency_list
      !> Offset index in the neighbour map
      integer, allocatable :: inl(:)
      !> Number of neighbours for each atom
      integer, allocatable :: nnl(:)
      !> Index of the neighbouring atom
      integer, allocatable :: nlat(:)
      !> Cell index of the neighbouring atom
      integer, allocatable :: nltr(:)
   end type adjacency_list

contains

   !> Create new neighbourlist for a given geometry and cutoff
   subroutine new_adjacency_list(self, mol, trans, cutoff, complete)
      !> Instance of the neighbourlist
      type(adjacency_list), intent(out) :: self
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Translation vectors for all images
      real(wp), intent(in) :: trans(:, :)
      !> Realspace cutoff for neighbourlist generation
      real(wp), intent(in) :: cutoff
      !> Whether a complete or a symmetrical reduced map should be generated
      logical, intent(in), optional :: complete

      logical :: cmplt

      cmplt = .false.
      if (present(complete)) cmplt = complete

      allocate(self%inl(mol%nat), source=0)
      allocate(self%nnl(mol%nat), source=0)
      call generate(mol, trans, cutoff, self%inl, self%nnl, self%nlat, self%nltr, cmplt)
   end subroutine new_adjacency_list

   !> Generator for neighbourlist
   subroutine generate(mol, trans, cutoff, inl, nnl, nlat, nltr, complete)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Translation vectors for all images
      real(wp), intent(in) :: trans(:, :)
      !> Realspace cutoff for neighbourlist generation
      real(wp), intent(in) :: cutoff
      !> Offset index in the neighbour map
      integer, intent(inout) :: inl(:)
      !> Number of neighbours for each atom
      integer, intent(inout) :: nnl(:)
      !> Index of the neighbouring atom
      integer, allocatable, intent(out) :: nlat(:)
      !> Cell index of the neighbouring atom
      integer, allocatable, intent(out) :: nltr(:)
      !> Whether a complete or a symmetrical reduced map should be generated
      logical, intent(in) :: complete

      integer :: iat, jat, itr, img
      real(wp) :: r2, vec(3), cutoff2

      img = 0
      cutoff2 = cutoff**2

      call resize(nlat, 10*mol%nat)
      call resize(nltr, 10*mol%nat)

      do iat = 1, mol%nat
         inl(iat) = img
         do jat = 1, merge(mol%nat, iat, complete)
            do itr = 1, size(trans, 2)
               vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
               r2 = sum(vec**2)
               if (r2 < epsilon(cutoff2) .or. r2 > cutoff2) cycle
               img = img + 1
               if (size(nlat) < img) call resize(nlat)
               if (size(nltr) < img) call resize(nltr)
               nlat(img) = jat
               nltr(img) = itr
            end do
         end do
         nnl(iat) = img - inl(iat)
      end do

      call resize(nlat, img)
      call resize(nltr, img)

   end subroutine generate

end module tblite_adjlist

! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/post-processing/xtb-ml
!> Explicit implementation of different xTB-ML features

!> @file tblite/post-processing/xtb-ml.f90
!> xTB-ML features as a post-processing method
module tblite_post_processing_xtbml
   use mctc_env, only : wp, error_type
   use mctc_io, only : structure_type
   use tblite_container_list, only : cache_list
   use tblite_context, only : context_type
   use tblite_double_dictionary, only : double_dictionary_type
   use tblite_integral_type, only : integral_type
   use tblite_param_post_processing_xtbml, only : xtbml_record
   use tblite_post_processing_type, only : post_processing_type
   use tblite_output_format, only : format_string
   use tblite_timer, only : timer_type, format_time
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_post_processing_xtbml_cache, only : xtbml_cache
   use tblite_post_processing_xtbml_convolution, only : xtbml_convolution, &
      & new_xtbml_convolution
   use tblite_post_processing_xtbml_density, only : xtbml_density_features, &
      & new_xtbml_density_features
   use tblite_post_processing_xtbml_energy, only : xtbml_energy_features, &
      & new_xtbml_energy_features
   use tblite_post_processing_xtbml_geometry, only : xtbml_geometry_features, &
      & new_xtbml_geometry_features
   use tblite_post_processing_xtbml_orbital, only : xtbml_orbital_features, &
      & new_xtbml_orbital_features
   implicit none
   private

   public :: xtbml_type, new_xtbml_features

   !> xTB-ML features as post-processing method
   type, extends(post_processing_type) :: xtbml_type
      !> Geometry-based xTB-ML features
      type(xtbml_geometry_features), allocatable :: geom
      !> Density-based xTB-ML features
      type(xtbml_density_features), allocatable :: dens
      !> Orbital energy-based xTB-ML features
      type(xtbml_orbital_features), allocatable :: orb
      !> Energy-based xTB-ML features
      type(xtbml_energy_features), allocatable :: energy
      !> Convolution of xTB-ML features
      type(xtbml_convolution), allocatable :: conv
   contains
      !> Calculate xTB-ML features
      procedure :: compute
      !> Information on the post-processing method
      procedure :: info
      !> Print timings
      procedure :: print_timer
   end type xtbml_type

   character(len=*), parameter :: label = "  xtbml features:"

contains

subroutine new_xtbml_features(self, mol, param, error)
   !> Instance of the xTB-ML features post-processing
   type(xtbml_type), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parameterization for the xTB-ML features
   type(xtbml_record), intent(in) :: param
   !> Error handling
   type(error_type), intent(inout) , allocatable:: error

   real(wp), allocatable :: rcov_scale(:)

   self%label = label

   if (param%xtbml_geometry) then
      allocate(self%geom)
      call new_xtbml_geometry_features(self%geom, mol, error)
      if (allocated(error)) return
   end if

   if (param%xtbml_density) then
      allocate(self%dens)
      call new_xtbml_density_features(self%dens, param%xtbml_tensor)
   end if

   if (param%xtbml_orbital_energy) then
      allocate(self%orb)
      call new_xtbml_orbital_features(self%orb)
   end if

   if (param%xtbml_energy) then
      allocate(self%energy)
      call new_xtbml_energy_features(self%energy)
   end if

   if (param%xtbml_convolution) then
      allocate(self%conv)
      if (allocated(param%xtbml_a)) then
         rcov_scale = param%xtbml_a
      else 
         rcov_scale = (/1.0_wp/)
      end if

      call new_xtbml_convolution(self%conv, mol, rcov_scale, error)
   end if

end subroutine new_xtbml_features

subroutine compute(self, mol, wfn, ints, calc, caches, ctx, timer, &
   & prlevel, dict)
   !> Instance of the xTB-ML features post-processing
   class(xtbml_type),intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction strcuture data
   type(wavefunction_type), intent(in) :: wfn
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Single-point calculator conatiner
   type(xtb_calculator), intent(in) :: calc
   !> Context container for writing to stdout
   type(context_type), intent(inout) :: ctx
   !> Cache list for storing caches of various interactions
   type(cache_list), intent(inout) :: caches
   !> Timer instance
   type(timer_type), intent(inout) :: timer
   !> Print level
   integer, intent(in) :: prlevel
   !> Dictionary to store the features
   type(double_dictionary_type), intent(inout) :: dict

   type(xtbml_cache) :: mlcache
   type(error_type), allocatable :: error
   integer :: n_features

   call timer%push("xtbML")

   n_features = 0

   if (allocated(self%geom)) then
      call timer%push("geometry")
      call self%geom%compute_features(mol, wfn, ints, calc, caches, &
         & mlcache, dict, n_features, error)
      if (allocated(error)) then
         call ctx%set_error(error)
         return
      end if
      call timer%pop()
   end if

   if (allocated(self%dens)) then
      call timer%push("density")
      call self%dens%compute_features(mol, wfn, ints, calc, caches, &
         & mlcache, dict, n_features, error)
      if (allocated(error)) then
         call ctx%set_error(error)
         return
      end if
      call timer%pop()
   end if

   if (allocated(self%orb)) then
      call timer%push("orbital energy")
      call self%orb%compute_features(mol, wfn, ints, calc, caches, &
         & mlcache, dict, n_features, error)
      if (allocated(error)) then
         call ctx%set_error(error)
         return
      end if
      call timer%pop()
   end if

   if (allocated(self%energy)) then
      call timer%push("energy")
      call self%energy%compute_features(mol, wfn, ints, calc, caches, &
         & mlcache, dict, n_features, error)
      if (allocated(error)) then
         call ctx%set_error(error)
         return
      end if
      call timer%pop()
   end if

   if (allocated(self%conv)) then

      call timer%push("convolution")
      call self%conv%compute_kernel(mol, mlcache)
      call timer%pop()

      if (allocated(self%geom)) then
         call timer%push("geometry convolution")
         call self%geom%compute_extended(mol, wfn, ints, calc, caches, &
            & mlcache, self%conv, dict, n_features, error)
         if (allocated(error)) then
            call ctx%set_error(error)
            return
         end if
         call timer%pop()
      end if

      if (allocated(self%dens)) then
         call timer%push("density convolution")
         call self%dens%compute_extended(mol, wfn, ints, calc, caches, &
            & mlcache, self%conv, dict, n_features, error)
         if (allocated(error)) then
            call ctx%set_error(error)
            return
         end if
         call timer%pop()
      end if

      if (allocated(self%orb)) then
         call timer%push("orbital energy convolution")
         call self%orb%compute_extended(mol, wfn, ints, calc, caches, &
            & mlcache, self%conv, dict, n_features, error)
         if (allocated(error)) then
            call ctx%set_error(error)
            return
         end if
         call timer%pop()
      end if
   end if
   
   ! Store the number of xTB-ML features also in the dictionary
   call dict%add_entry("n_features", [real(n_features, wp)])

   call timer%pop()

end subroutine compute

pure function info(self, verbosity, indent) result(str)
   !> Instance of the xTB-ML features post-processing
   class(xtbml_type), intent(in) :: self
   !> Verbosity level
   integer, intent(in) :: verbosity
   !> Indentation level
   character(len=*), intent(in) :: indent
   !> Information on the container
   character(len=:), allocatable :: str

   character(len=*), parameter :: nl = new_line('a')
   character(len=:), allocatable :: category_indent

   if (allocated(self%label)) then
      str = self%label
   else
      str = "Unknown"
   end if

   category_indent = indent // " * "

   if (allocated(self%geom)) then
      str = str // nl // self%geom%info(verbosity, category_indent)
   end if

   if (allocated(self%dens)) then
      str = str // nl // self%dens%info(verbosity, category_indent)
   end if

   if (allocated(self%orb)) then
      str = str // nl // self%orb%info(verbosity, category_indent)
   end if

   if (allocated(self%energy)) then
      str = str // nl // self%energy%info(verbosity, category_indent)
   end if

   if (allocated(self%conv)) then
      str = str // nl // self%conv%info(verbosity, category_indent)
   end if

end function info

subroutine print_timer(self, timer, prlevel, ctx)
   !> Instance of the xTB-ML features post-processing
   class(xtbml_type), intent(in) :: self
   !> Timer instance
   type(timer_type), intent(in) :: timer
   !> Print level
   integer, intent(in) :: prlevel
   !> Context container for writing to stdout
   type(context_type), intent(inout) :: ctx

   real(wp) :: ttime, stime
   integer :: it
   character(len=*), parameter :: labels(*) = [character(len=20):: &
   & "geometry", "density", "orbital energy", "energy", &
   & "geometry convolution", "density convolution", &
   & "orbital energy convolution"]

   if (prlevel > 2) then
      call ctx%message("ML features timing details:")
      ttime = timer%get("xtbML")
      call ctx%message(" total:"//repeat(" ", 16)//format_time(ttime))
      do it = 1, size(labels)
         stime = timer%get(labels(it))
         if (stime <= epsilon(0.0_wp)) cycle
         call ctx%message(" - "//labels(it)//format_time(stime) &
         & //" ("//format_string(int(stime/ttime*100), '(i3)')//"%)")
      end do
      call ctx%message("")
   end if

end subroutine print_timer

end module tblite_post_processing_xtbml

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/disp/d4.f90
!> Provides a proxy for the [DFT-D4 dispersion correction](https://dftd4.readthedocs.io)

!> Generally applicable charge-dependent London-dispersion correction, DFT-D4.
module tblite_disp_d4
   use mctc_env, only : error_type, wp
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use mctc_ncoord, only : new_ncoord, ncoord_type, cn_count
   use dftd4, only : dispersion_model, d4_model, d4s_model, &
      & damping_param, rational_damping_param, realspace_cutoff, &
      & new_d4_model, new_d4s_model
   use dftd4_cutoff, only : smooth_cutoff
   use dftd4_model, only : d4_qmod
   use tblite_blas, only : dot, gemv
   use tblite_container_cache, only : container_cache
   use tblite_disp_cache, only : dispersion_cache
   use tblite_disp_type, only : dispersion_type
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_cutoff, only : get_lattice_points
   implicit none
   private

   public :: new_d4_dispersion, new_d4s_dispersion


   !> Container for self-consistent D4 dispersion interactions
   type, public, extends(dispersion_type) :: d4_dispersion
      !> Instance of the actual D4 dispersion model
      class(dispersion_model), allocatable :: model
      !> Rational damping parameters
      type(rational_damping_param) :: param
      !> Selected real space cutoffs for this instance
      type(realspace_cutoff) :: cutoff
      !> Coordination number instance
      class(ncoord_type), allocatable :: ncoord
   contains
      !> Update dispersion cache
      procedure :: update
      !> Get information about density dependent quantities used in the energy
      procedure :: variable_info
      !> Evaluate non-selfconsistent part of the dispersion correction
      procedure :: get_engrad
      !> Evaluate selfconsistent energy of the dispersion correction
      procedure :: get_energy
      !> Evaluate charge dependent potential shift from the dispersion correction
      procedure :: get_potential
      !> Evaluate gradient contributions from the selfconsistent dispersion correction
      procedure :: get_gradient
   end type d4_dispersion

   character(len=*), parameter :: label_d4 = "self-consistent DFT-D4 dispersion"
   character(len=*), parameter :: label_d4s = "self-consistent DFT-D4S dispersion"
   real(wp), parameter :: default_disp2_width = 0.0_wp
   real(wp), parameter :: default_disp3_width = 0.0_wp


contains


!> Create a new instance of a self-consistent D4 dispersion correction
subroutine new_d4_dispersion(self, mol, s6, s8, a1, a2, s9, error, disp2_width, disp3_width)
   !> Instance of the dispersion correction
   type(d4_dispersion), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Damping parameters
   real(wp), intent(in) :: s6, s8, a1, a2, s9
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Width of smooth two-body interaction cutoff
   real(wp), intent(in), optional :: disp2_width
   !> Width of smooth three-body interaction cutoff
   real(wp), intent(in), optional :: disp3_width

   type(d4_model), allocatable :: tmp
   real(wp) :: width2, width3

   width2 = default_disp2_width
   width3 = default_disp3_width
   if (present(disp2_width)) width2 = disp2_width
   if (present(disp3_width)) width3 = disp3_width

   self%label = label_d4

   ! Create a new instance of the D4 model
   allocate(tmp)
   call new_d4_model(error, tmp, mol, qmod=d4_qmod%gfn2)
   if(allocated(error)) return
   call move_alloc(tmp, self%model)

   self%param = rational_damping_param(s6=s6, s8=s8, s9=s9, a1=a1, a2=a2)
   self%cutoff = realspace_cutoff(disp3=25.0_wp, disp2=50.0_wp, &
      & width2=width2, width3=width3)

   call new_ncoord(self%ncoord, mol, cn_count%dftd4, error, &
      & cutoff=self%cutoff%cn, rcov=self%model%rcov, en=self%model%en)
end subroutine new_d4_dispersion


!> Create a new instance of a self-consistent D4S dispersion correction
subroutine new_d4s_dispersion(self, mol, s6, s8, a1, a2, s9, error, disp2_width, disp3_width)
   !> Instance of the dispersion correction
   type(d4_dispersion), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Damping parameters
   real(wp), intent(in) :: s6, s8, a1, a2, s9
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Width of smooth two-body interaction cutoff
   real(wp), intent(in), optional :: disp2_width
   !> Width of smooth three-body interaction cutoff
   real(wp), intent(in), optional :: disp3_width

   type(d4s_model), allocatable :: tmp
   real(wp) :: width2, width3

   width2 = default_disp2_width
   width3 = default_disp3_width
   if (present(disp2_width)) width2 = disp2_width
   if (present(disp3_width)) width3 = disp3_width

   self%label = label_d4s

   ! Create a new instance of the D4S model
   allocate(tmp)
   call new_d4s_model(error, tmp, mol, qmod=d4_qmod%gfn2)
   if(allocated(error)) return
   call move_alloc(tmp, self%model)

   self%param = rational_damping_param(s6=s6, s8=s8, s9=s9, a1=a1, a2=a2)
   self%cutoff = realspace_cutoff(disp3=25.0_wp, disp2=50.0_wp, &
      & width2=width2, width3=width3)

   call new_ncoord(self%ncoord, mol, cn_count%dftd4, error, &
      & cutoff=self%cutoff%cn, rcov=self%model%rcov, en=self%model%en)
end subroutine new_d4s_dispersion


!> Update dispersion cache
subroutine update(self, mol, cache)
   !> Instance of the dispersion correction
   class(d4_dispersion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different dispersion runs
   type(container_cache), intent(inout) :: cache

   real(wp), allocatable :: lattr(:, :)
   type(dispersion_cache), pointer :: ptr
   integer :: mref

   call taint(cache, ptr)
   mref = maxval(self%model%ref)

   if (.not.allocated(ptr%cn)) allocate(ptr%cn(mol%nat))
   if (.not.allocated(ptr%dcndr)) allocate(ptr%dcndr(3, mol%nat, mol%nat))
   if (.not.allocated(ptr%dcndL)) allocate(ptr%dcndL(3, 3, mol%nat))

   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff%cn, lattr)
   call self%ncoord%get_coordination_number(mol, lattr, ptr%cn, ptr%dcndr, ptr%dcndL)

   if (.not.allocated(ptr%dispmat)) allocate(ptr%dispmat(mref, mol%nat, mref, mol%nat))
   if (.not.allocated(ptr%vvec)) allocate(ptr%vvec(mref, mol%nat, self%model%ncoup))
   if (.not.allocated(ptr%gwvec)) allocate(ptr%gwvec(mref, mol%nat, self%model%ncoup))
   if (.not.allocated(ptr%dgwdq)) allocate(ptr%dgwdq(mref, mol%nat, self%model%ncoup))

   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff%disp2, lattr)
   call get_dispersion_matrix(mol, self%model, self%param, lattr, self%cutoff%disp2, &
      & self%cutoff%width2, self%model%r4r2, ptr%dispmat)
end subroutine update


!> Evaluate non-selfconsistent part of the dispersion correction
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the dispersion correction
   class(d4_dispersion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different dispersion runs
   type(container_cache), intent(inout) :: cache
   !> Dispersion energy
   real(wp), intent(inout) :: energies(:)
   !> Dispersion gradient
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Dispersion virial
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)

   type(dispersion_cache), pointer :: ptr

   call view(cache, ptr)

   call get_dispersion_nonsc(mol, self%model, self%param, self%cutoff, ptr, &
      & energies, gradient, sigma)
end subroutine get_engrad


!> Evaluate selfconsistent energy of the dispersion correction
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the dispersion correction
   class(d4_dispersion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different dispersion runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Dispersion energy
   real(wp), intent(inout) :: energies(:)

   type(dispersion_cache), pointer :: ptr
   integer :: iat, jat, izp, jzp, iref, jref

   call view(cache, ptr)

   call self%model%weight_references(mol, ptr%cn, wfn%qat(:, 1), ptr%gwvec)

   if (self%model%ncoup > 1) then
      ! Dispersion energy with pairwise weighting
      !$omp parallel do schedule(runtime) default(none) &
      !$omp shared(self, mol, ptr, energies) &
      !$omp private(iat, jat, izp, jzp, iref, jref)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         do jat = 1, mol%nat
            jzp = mol%id(jat)
            do iref = 1, self%model%ref(izp)
               do jref = 1, self%model%ref(jzp)
                  energies(iat) = energies(iat) + 0.5_wp * ptr%dispmat(iref, iat, jref, jat) * &
                     & ptr%gwvec(iref, iat, jat) * ptr%gwvec(jref, jat, iat)
               end do
            end do
         end do
      end do
   else
      ! Dispersion energy with atom-wise weighting
      call gemv(ptr%dispmat, ptr%gwvec(:, :, 1), ptr%vvec(:, :, 1), alpha=0.5_wp)
      ptr%vvec(:, :, 1) = ptr%vvec(:, :, 1) * ptr%gwvec(:, :, 1)
      energies(:) = energies + sum(ptr%vvec(:, :, 1), 1)
   end if

end subroutine get_energy


!> Evaluate charge dependent potential shift from the dispersion correction
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the dispersion correction
   class(d4_dispersion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different dispersion runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   type(dispersion_cache), pointer :: ptr
   integer :: iat, jat, izp, jzp, iref, jref
   real(wp), allocatable :: tmp_vat(:)

   call view(cache, ptr)

   call self%model%weight_references(mol, ptr%cn, wfn%qat(:, 1), ptr%gwvec, ptr%vvec, &
      & ptr%dgwdq)

   if (self%model%ncoup > 1) then
      ! Dispersion energy with pairwise weighting
      allocate(tmp_vat(mol%nat), source=0.0_wp)
      !$omp parallel do schedule(runtime) default(none) &
      !$omp shared(self, mol, ptr, tmp_vat) &
      !$omp private(iat, jat, izp, jzp, iref, jref)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         do jat = 1, mol%nat
            jzp = mol%id(jat)
            do iref = 1, self%model%ref(izp)
               do jref = 1, self%model%ref(jzp)
                  tmp_vat(iat) = tmp_vat(iat) + ptr%dispmat(iref, iat, jref, jat) * &
                     & ptr%dgwdq(iref, iat, jat) * ptr%gwvec(jref, jat, iat) 
               end do
            end do
         end do
      end do
      pot%vat(:, 1) = pot%vat(:, 1) + tmp_vat
   else
      ! Dispersion energy with atom-wise weighting
      call gemv(ptr%dispmat, ptr%gwvec(:, :, 1), ptr%vvec(:, :, 1))
      ptr%vvec(:, :, 1) = ptr%vvec(:, :, 1) * ptr%dgwdq(:, :, 1)
      pot%vat(:, 1) = pot%vat(:, 1) + sum(ptr%vvec(:, :, 1), 1)
   end if

end subroutine get_potential


!> Evaluate gradient contributions from the selfconsistent dispersion correction
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the dispersion correction
   class(d4_dispersion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different dispersion runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Dispersion gradient
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Dispersion virial
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   integer :: mref
   real(wp), allocatable :: gwvec(:, :, :), gwdcn(:, :, :), gwdq(:, :, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :), dc6dq(:, :)
   real(wp), allocatable :: dEdcn(:), dEdq(:), energies(:)
   real(wp), allocatable :: lattr(:, :)
   type(dispersion_cache), pointer :: ptr

   call view(cache, ptr)
   mref = maxval(self%model%ref)

   allocate(gwvec(mref, mol%nat, self%model%ncoup), gwdcn(mref, mol%nat, self%model%ncoup), &
      &  gwdq(mref, mol%nat, self%model%ncoup))
   call self%model%weight_references(mol, ptr%cn, wfn%qat(:, 1), gwvec, gwdcn, gwdq)

   allocate(c6(mol%nat, mol%nat), dc6dcn(mol%nat, mol%nat), dc6dq(mol%nat, mol%nat))
   call self%model%get_atomic_c6(mol, gwvec, gwdcn, gwdq, c6, dc6dcn, dc6dq)

   allocate(energies(mol%nat), dEdcn(mol%nat), dEdq(mol%nat))
   energies(:) = 0.0_wp
   dEdcn(:) = 0.0_wp
   dEdq(:) = 0.0_wp
   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff%disp2, lattr)
   call self%param%get_dispersion2(mol, lattr, self%cutoff%disp2, self%cutoff%width2, &
      & self%model%r4r2, c6, dc6dcn, dc6dq, energies, dEdcn, dEdq, gradient, sigma)
   call gemv(ptr%dcndr, dEdcn, gradient, beta=1.0_wp)
   call gemv(ptr%dcndL, dEdcn, sigma, beta=1.0_wp)
end subroutine get_gradient


subroutine get_dispersion_matrix(mol, disp, param, trans, cutoff, width, r4r2, dispmat)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Damping parameters
   type(rational_damping_param), intent(in) :: param
   !> Instance of the dispersion model
   class(dispersion_model), intent(in) :: disp
   !> Lattice points
   real(wp), intent(in) :: trans(:, :)
   !> Real space cutoff
   real(wp), intent(in) :: cutoff
   !> Width of smooth cutoff
   real(wp), intent(in) :: width
   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)
   !> Dispersion matrix
   real(wp), intent(out) :: dispmat(:, :, :, :)

   integer :: iat, jat, izp, jzp, jtr, iref, jref
   real(wp) :: vec(3), r2, r, cutoff2, r0ij, rrij, t6, t8
   real(wp) :: edisp, dE, sw, dswdr

   dispmat(:, :, :, :) = 0.0_wp
   cutoff2 = cutoff**2

   !$omp parallel do schedule(runtime) default(none) &
   !$omp shared(mol, param, disp, trans, cutoff, width, cutoff2, r4r2, dispmat) &
   !$omp private(iat, jat, izp, jzp, jtr, vec, r2, r0ij, rrij, &
   !$omp& t6, t8, edisp, dE, r, sw, dswdr)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)
         rrij = 3*r4r2(izp)*r4r2(jzp)
         r0ij = param%a1 * sqrt(rrij) + param%a2
         dE = 0.0_wp
         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, jtr))
            r2 = vec(1)*vec(1) + vec(2)*vec(2) + vec(3)*vec(3)
            if (r2 > cutoff2 .or. r2 < epsilon(1.0_wp)) cycle
            r = sqrt(r2)
            call smooth_cutoff(r, cutoff, width, sw, dswdr)
            if (sw <= 0.0_wp) cycle

            t6 = 1.0_wp/(r2**3 + r0ij**6)
            t8 = 1.0_wp/(r2**4 + r0ij**8)

            edisp = sw * (param%s6*t6 + param%s8*rrij*t8)

            dE = dE - edisp
         end do

         do iref = 1, disp%ref(izp)
            do jref = 1, disp%ref(jzp)
               dispmat(iref, iat, jref, jat) = dE * disp%c6(iref, jref, izp, jzp)
               dispmat(jref, jat, iref, iat) = dE * disp%c6(jref, iref, jzp, izp)
            end do
         end do
      end do
   end do
end subroutine get_dispersion_matrix


!> Wrapper to handle the evaluation of dispersion energy and derivatives
subroutine get_dispersion_nonsc(mol, disp, param, cutoff, cache, energies, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Dispersion model
   class(dispersion_model), intent(in) :: disp
   !> Damping parameters
   class(damping_param), intent(in) :: param
   !> Realspace cutoffs
   type(realspace_cutoff), intent(in) :: cutoff
   !> Cached data between different dispersion runs
   type(dispersion_cache), intent(inout) :: cache
   !> Dispersion energy
   real(wp), intent(inout) :: energies(:)
   !> Dispersion gradient
   real(wp), intent(inout), contiguous, optional :: gradient(:, :)
   !> Dispersion virial
   real(wp), intent(inout), contiguous, optional :: sigma(:, :)

   logical :: grad
   integer :: mref
   real(wp), allocatable :: qat(:)
   real(wp), allocatable :: gwvec(:, :, :), gwdcn(:, :, :), gwdq(:, :, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :), dc6dq(:, :)
   real(wp), allocatable :: dEdcn(:), dEdq(:)
   real(wp), allocatable :: lattr(:, :)

   mref = maxval(disp%ref)
   grad = present(gradient).and.present(sigma)

   allocate(gwvec(mref, mol%nat, disp%ncoup), qat(mol%nat), c6(mol%nat, mol%nat))
   if (grad) then
      allocate(gwdcn(mref, mol%nat, disp%ncoup), gwdq(mref, mol%nat, disp%ncoup), &
         & dc6dcn(mol%nat, mol%nat), dc6dq(mol%nat, mol%nat))
   end if
   qat(:) = 0.0_wp
   if (grad) then
      allocate(dEdcn(mol%nat), dEdq(mol%nat))
      dEdcn(:) = 0.0_wp
      dEdq(:) = 0.0_wp
   end if

   call disp%weight_references(mol, cache%cn, qat, gwvec, gwdcn, gwdq)
   call disp%get_atomic_c6(mol, gwvec, gwdcn, gwdq, c6, dc6dcn, dc6dq)

   call get_lattice_points(mol%periodic, mol%lattice, cutoff%disp3, lattr)
   call param%get_dispersion3(mol, lattr, cutoff%disp3, cutoff%width3, &
      & disp%r4r2, c6, dc6dcn, dc6dq, energies, dEdcn, dEdq, gradient, sigma)
   if (grad) then
      call gemv(cache%dcndr, dEdcn, gradient, beta=1.0_wp)
      call gemv(cache%dcndL, dEdcn, sigma, beta=1.0_wp)
   end if

end subroutine get_dispersion_nonsc


!> Get information about density dependent quantities used in the energy
pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, atom_resolved
   !> Instance of the electrostatic container
   class(d4_dispersion), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=atom_resolved)
end function variable_info


!> Inspect container cache and reallocate it in case of type mismatch
subroutine taint(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(dispersion_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(dispersion_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

!> Return reference to container cache after resolving its type
subroutine view(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(dispersion_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(dispersion_cache)
      ptr => target
   end select
end subroutine view

end module tblite_disp_d4

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> General isotropic second-order electrostatics model
module tblite_coulomb_charge_type
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_blas, only : dot, gemv, symv
   use tblite_container_cache, only : container_cache
   use tblite_coulomb_cache, only : coulomb_cache
   use tblite_coulomb_type, only : coulomb_type
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: coulomb_charge_type


   !> General second-order electrostatics
   type, extends(coulomb_type), abstract :: coulomb_charge_type
      !> Number of shells for each atom
      integer, allocatable :: nshell(:)
      !> Index offset for each shell
      integer, allocatable :: offset(:)
   contains
      !> Update container cache
      procedure :: update
      !> Get information about density dependent quantities used in the energy
      procedure :: variable_info
      !> Evaluate selfconsistent energy of the interaction
      procedure :: get_energy
      !> Evaluate charge dependent potential shift from the interaction
      procedure :: get_potential
      !> Evaluate gradient contributions from the selfconsistent interaction
      procedure :: get_gradient
      !> Evaluate Coulomb matrix
      procedure(get_coulomb_matrix), deferred :: get_coulomb_matrix
      !> Evaluate uncontracted derivatives of Coulomb matrix
      procedure(get_coulomb_derivs), deferred :: get_coulomb_derivs
   end type coulomb_charge_type

   abstract interface
      !> Evaluate coulomb matrix
      subroutine get_coulomb_matrix(self, mol, cache, amat)
         import :: coulomb_charge_type, structure_type, coulomb_cache, wp
         !> Instance of the electrostatic container
         class(coulomb_charge_type), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Reusable data container
         type(coulomb_cache), intent(inout) :: cache
         !> Coulomb matrix
         real(wp), contiguous, intent(out) :: amat(:, :)
      end subroutine get_coulomb_matrix

      !> Evaluate uncontracted derivatives of Coulomb matrix
      subroutine get_coulomb_derivs(self, mol, cache, qat, qsh, dadr, dadL, atrace)
         import :: coulomb_charge_type, structure_type, coulomb_cache, wp
         !> Instance of the electrostatic container
         class(coulomb_charge_type), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Reusable data container
         type(coulomb_cache), intent(inout) :: cache
         !> Atomic partial charges
         real(wp), intent(in) :: qat(:)
         !> Shell-resolved partial charges
         real(wp), intent(in) :: qsh(:)
         !> Derivative of interactions with respect to cartesian displacements
         real(wp), contiguous, intent(out) :: dadr(:, :, :)
         !> Derivative of interactions with respect to strain deformations
         real(wp), contiguous, intent(out) :: dadL(:, :, :)
         !> On-site derivatives with respect to cartesian displacements
         real(wp), contiguous, intent(out) :: atrace(:, :)
      end subroutine get_coulomb_derivs
   end interface

contains


!> Update container cache
subroutine update(self, mol, cache)
   !> Instance of the electrostatic container
   class(coulomb_charge_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   type(coulomb_cache), pointer :: ptr

   call taint(cache, ptr)
   call ptr%update(mol)

   if (.not.allocated(ptr%amat)) then
      allocate(ptr%amat(sum(self%nshell), sum(self%nshell)))
   end if
   call self%get_coulomb_matrix(mol, ptr, ptr%amat)

   if (.not.allocated(ptr%vvec)) then
      allocate(ptr%vvec(sum(self%nshell)))
   end if

end subroutine update


!> Evaluate selfconsistent energy of the interaction
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the electrostatic container
   class(coulomb_charge_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)

   integer :: iat, ii, ish
   type(coulomb_cache), pointer :: ptr

   call view(cache, ptr)

   call symv(ptr%amat, wfn%qsh(:, 1), ptr%vvec, alpha=0.5_wp)
   do iat = 1, mol%nat
      ii = self%offset(iat)
      do ish = 1, self%nshell(iat)
         energies(iat) = energies(iat) + ptr%vvec(ii+ish) * wfn%qsh(ii+ish, 1)
      end do
   end do
end subroutine get_energy


!> Evaluate charge dependent potential shift from the interaction
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the electrostatic container
   class(coulomb_charge_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   type(coulomb_cache), pointer :: ptr

   call view(cache, ptr)

   call symv(ptr%amat, wfn%qsh(:, 1), pot%vsh(:, 1), beta=1.0_wp)

end subroutine get_potential


!> Evaluate gradient contributions from the selfconsistent interaction
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the electrostatic container
   class(coulomb_charge_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the repulsion energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   integer :: ndim
   real(wp), allocatable :: dadr(:, :, :), dadL(:, :, :), datr(:, :)
   type(coulomb_cache), pointer :: ptr

   call view(cache, ptr)

   ndim = sum(self%nshell)
   allocate(dadr(3, mol%nat, ndim), dadL(3, 3, ndim), datr(3, ndim))

   call self%get_coulomb_derivs(mol, ptr, wfn%qat(:, 1), wfn%qsh(:, 1), dadr, dadL, datr)

   call gemv(dadr, wfn%qsh(:, 1), gradient, beta=1.0_wp)
   call gemv(dadL, wfn%qsh(:, 1), sigma, beta=1.0_wp, alpha=0.5_wp)

end subroutine get_gradient


!> Get information about density dependent quantities used in the energy
pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, shell_resolved
   !> Instance of the electrostatic container
   class(coulomb_charge_type), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=shell_resolved)
end function variable_info


!> Inspect container cache and reallocate it in case of type mismatch
subroutine taint(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(coulomb_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(coulomb_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

!> Return reference to container cache after resolving its type
subroutine view(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(coulomb_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(coulomb_cache)
      ptr => target
   end select
end subroutine view


end module tblite_coulomb_charge_type

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_write_vasp
   use mctc_env_accuracy, only : wp
   use mctc_io_convert, only : autoaa
   use mctc_io_math, only : matinv_3x3
   use mctc_io_structure, only : structure_type
   implicit none
   private

   public :: write_vasp


contains


subroutine write_vasp(self, unit, comment_line)
   class(structure_type), intent(in) :: self
   integer, intent(in) :: unit
   character(len=*), intent(in), optional :: comment_line
   integer :: i, j, izp
   integer, allocatable :: kinds(:), species(:)
   real(wp), allocatable :: inv_lat(:, :)
   real(wp), allocatable :: abc(:, :)

   allocate(species(self%nat))
   allocate(kinds(self%nat), source=1)

   j = 0
   izp = 0
   do i = 1, self%nat
      if (izp.eq.self%id(i)) then
         kinds(j) = kinds(j)+1
      else
         j = j+1
         izp = self%id(i)
         species(j) = self%id(i)
      end if
   end do

   ! use vasp 5.x format
   if (present(comment_line)) then
      write(unit, '(a)') comment_line
   else
      if (allocated(self%comment)) then
         write(unit, '(a)') self%comment
      else
         write(unit, '(a)')
      end if
   end if

   ! scaling factor for lattice parameters is always one
   write(unit, '(f20.14)') self%info%scale
   ! write the lattice parameters
   if (any(self%periodic)) then
      if (size(self%lattice, 2) == 3) then
         write(unit, '(3f20.14)') self%lattice
      else
         write(unit, '(3f20.14)') spread(0.0_wp, 1, 9)
      end if
   else
      write(unit, '(3f20.14)') spread(0.0_wp, 1, 9)
   end if

   do i = 1, j
      write(unit, '(1x, a)', advance='no') self%sym(species(i))
   end do
   write(unit, '(a)')

   ! write the count of the consecutive atom types
   do i = 1, j
      write(unit, '(1x, i0)', advance='no') kinds(i)
   end do
   write(unit, '(a)')
   deallocate(kinds, species)

   if (self%info%selective) write(unit, '("Selective")')

   ! we write cartesian coordinates
   if (any(shape(self%lattice) /= [3, 3]) .or. self%info%cartesian) then
      write(unit, '("Cartesian")')

      ! now write the cartesian coordinates
      do i = 1, self%nat
         write(unit, '(3f20.14)') self%xyz(:, i)*autoaa/self%info%scale
      end do
   else
      write(unit, '("Direct")')
      inv_lat = matinv_3x3(self%lattice)
      abc = matmul(inv_lat, self%xyz)

      ! now write the fractional coordinates
      do i = 1, self%nat
         write(unit, '(3f20.14)') abc(:, i)
      end do
   end if

end subroutine write_vasp


end module mctc_io_write_vasp

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Support for ANSI escape sequences to get colorful terminal output
module tblite_context_terminal
   use mctc_env, only : i1
   implicit none
   private

   public :: context_terminal, escape, operator(+), operator(//)

   !> Container for terminal escape code
   type :: color
      !> Style descriptor
      integer(i1) :: style = -1_i1
      !> Background color descriptor
      integer(i1) :: bg = -1_i1
      !> Foreground color descriptor
      integer(i1) :: fg = -1_i1
   end type

   interface operator(+)
      module procedure :: add
   end interface operator(+)

   interface operator(//)
      module procedure :: concat_left
      module procedure :: concat_right
   end interface operator(//)

   type(color), parameter :: &
      reset = color(style=0_i1), &
      bold = color(style=1_i1), &
      dim = color(style=2_i1), &
      italic = color(style=3_i1), &
      underline = color(style=4_i1), &
      blink = color(style=5_i1), &
      reverse = color(style=7_i1), &
      hidden = color(style=8_i1)

   type(color), parameter :: &
      black = color(fg=0_i1), &
      red = color(fg=1_i1), &
      green = color(fg=2_i1), &
      yellow = color(fg=3_i1), &
      blue = color(fg=4_i1), &
      magenta = color(fg=5_i1), &
      cyan = color(fg=6_i1), &
      white = color(fg=7_i1)

   type(color), parameter :: &
      bg_black = color(bg=0_i1), &
      bg_red = color(bg=1_i1), &
      bg_green = color(bg=2_i1), &
      bg_yellow = color(bg=3_i1), &
      bg_blue = color(bg=4_i1), &
      bg_magenta = color(bg=5_i1), &
      bg_cyan = color(bg=6_i1), &
      bg_white = color(bg=7_i1)


   !> Colorizer class for handling colorful output in the terminal
   type :: context_terminal

      type(color) :: &
         reset = color(), &
         bold = color(), &
         dim = color(), &
         italic = color(), &
         underline = color(), &
         blink = color(), &
         reverse = color(), &
         hidden = color()

      type(color) :: &
         black = color(), &
         red = color(), &
         green = color(), &
         yellow = color(), &
         blue = color(), &
         magenta = color(), &
         cyan = color(), &
         white = color()

      type(color) :: &
         bg_black = color(), &
         bg_red = color(), &
         bg_green = color(), &
         bg_yellow = color(), &
         bg_blue = color(), &
         bg_magenta = color(), &
         bg_cyan = color(), &
         bg_white = color()

      type(color) :: &
         bold_black = color(), &
         bold_red = color(), &
         bold_green = color(), &
         bold_yellow = color(), &
         bold_blue = color(), &
         bold_magenta = color(), &
         bold_cyan = color(), &
         bold_white = color()
   end type context_terminal

   !> Constructor for the colorizer
   interface context_terminal
      module procedure :: new_terminal
   end interface context_terminal

contains


!> Create a new colorizer object
function new_terminal(use_color) result(new)
   !> Enable color output
   logical, intent(in) :: use_color
   !> New instance of the colorizer
   type(context_terminal) :: new

   if (use_color) then
      new%reset = reset
      new%bold = bold
      new%dim = dim
      new%italic = italic
      new%underline = underline
      new%blink = blink
      new%reverse = reverse
      new%hidden = hidden
      new%black = black
      new%red = red
      new%green = green
      new%yellow = yellow
      new%blue = blue
      new%magenta = magenta
      new%cyan = cyan
      new%white = white
      new%bg_black = bg_black
      new%bg_red = bg_red
      new%bg_green = bg_green
      new%bg_yellow = bg_yellow
      new%bg_blue = bg_blue
      new%bg_magenta = bg_magenta
      new%bg_cyan = bg_cyan
      new%bg_white = bg_white
      new%bold_black = bold + black
      new%bold_red = bold + red
      new%bold_green = bold + green
      new%bold_yellow = bold + yellow
      new%bold_blue = bold + blue
      new%bold_magenta = bold + magenta
      new%bold_cyan = bold + cyan
      new%bold_white = bold + white
   end if
end function new_terminal

!> Add two escape sequences, attributes in the right value override the left value ones.
pure function add(lval, rval) result(code)
   !> First escape code
   type(color), intent(in) :: lval
   !> Second escape code
   type(color), intent(in) :: rval
   !> Combined escape code
   type(color) :: code

   code = color( &
      style=merge(rval%style, lval%style, rval%style >= 0), &
      fg=merge(rval%fg, lval%fg, rval%fg >= 0), &
      bg=merge(rval%bg, lval%bg, rval%bg >= 0))
end function add

!> Concatenate an escape code with a string and turn it into an actual escape sequence
pure function concat_left(lval, code) result(str)
   !> String to add the escape code to
   character(len=*), intent(in) :: lval
   !> Escape sequence
   type(color), intent(in) :: code
   !> Concatenated string
   character(len=:), allocatable :: str

   str = lval // escape(code)
end function concat_left

!> Concatenate an escape code with a string and turn it into an actual escape sequence
pure function concat_right(code, rval) result(str)
   !> String to add the escape code to
   character(len=*), intent(in) :: rval
   !> Escape sequence
   type(color), intent(in) :: code
   !> Concatenated string
   character(len=:), allocatable :: str

   str = escape(code) // rval
end function concat_right

!> Transform a color code into an actual ANSI escape sequence
pure function escape(code) result(str)
   !> Color code to be used
   type(color), intent(in) :: code
   !> ANSI escape sequence representing the color code
   character(len=:), allocatable :: str
   character, parameter :: chars(0:9) = &
      ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]

   if (anycolor(code)) then
      str = achar(27) // "[0"  ! Always reset the style
      if (code%style > 0 .and. code%style < 10) str = str // ";" // chars(code%style)
      if (code%fg >= 0 .and. code%fg < 10) str = str // ";3" // chars(code%fg)
      if (code%bg >= 0 .and. code%bg < 10) str = str // ";4" // chars(code%bg)
      str = str // "m"
   else
      str = ""
   end if
end function escape

!> Check whether the code describes any color or is just a stub
pure function anycolor(code)
   !> Escape sequence
   type(color), intent(in) :: code
   !> Any color / style is active
   logical :: anycolor

   anycolor = code%fg >= 0 .or. code%bg >= 0 .or. code%style >= 0
end function anycolor

end module tblite_context_terminal

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Module to collect all help printout for the tblite program
module tblite_cli_help
   implicit none
   private

   public :: prog_name, help_text, help_text_run, help_text_param, help_text_fit, &
      & help_text_tagdiff, help_text_guess

   character(len=*), parameter :: nl = new_line('a')

   !> Name of the main executable
   character(len=*), parameter :: prog_name = "tblite"

   !> General help text regarding response file support
   character(len=*), parameter :: help_text_response = &
      "Command line arguments can be read from an indirect file / response file"//nl//&
      "by specifying the file with @name in the command line. Each line in the file"//nl//&
      "is interpreted as command line argument, shell like escape sequences are not"//nl//&
      "available. The file can contain further @name inputs. If the file cannot be"//nl//&
      "found the argument is used literally."

   !> General help text for version and help commands
   character(len=*), parameter :: help_text_general = &
      "      --version           Print program version and exit"//nl//&
      "      --help              Show this help message"

   !> General help text regarding geometry input formats
   character(len=*), parameter :: help_text_geometry = &
      "Supported geometry input formats are:"//nl//&
      ""//nl//&
      "- Xmol/xyz files (xyz, log)"//nl//&
      "- Turbomole's coord, riper's periodic coord (tmol, coord)"//nl//&
      "- DFTB+ genFormat geometry inputs as cluster, supercell or fractional (gen)"//nl//&
      "- VASP's POSCAR/CONTCAR input files (vasp, poscar, contcar)"//nl//&
      "- Protein Database files, only single files (pdb)"//nl//&
      "- Connection table files, molfile (mol) and structure data format (sdf)"//nl//&
      "- Gaussian's external program input (ein)"

   !> Help text for main driver
   character(len=*), parameter :: help_text = &
      "Usage: "//prog_name//" <run|guess|param|fit|tagdiff> [options]"//nl//&
      ""//nl//&
      "Commands"//nl//&
      ""//nl//&
      "  run       Evaluate tight-binding module on the provided input structure."//nl//&
      "            If no command is specified run is selected by default."//nl//&
      ""//nl//&
      "  guess     Execute only the atomic charge or density guess, respectively."//nl//&
      "            Prints the initializing charges and dipole moments."//nl//&
      ""//nl//&
      "  param     Inspect and manipulate tight-binding parametrization data."//nl//&
      ""//nl//&
      "  fit       Optimize tight-binding parameters."//nl//&
      ""//nl//&
      "  tagdiff   Auxilary tool to compute differences between data outputs."//nl//&
      ""//nl//&
      "Options"//nl//&
      ""//nl//&
      "      --color string      Support colorful terminal output,"//nl//&
      "                          possible values are never (default), always, auto."//nl//&
      help_text_general//nl//&
      ""//nl//&
      help_text_response

   !> Help text for param command
   character(len=*), parameter :: help_text_param = &
      "Usage: "//prog_name//" param [options] <input>"//nl//&
      ""//nl//&
      "Import, export and manipulate tight-binding parameter files."//nl//&
      "An input parameter file must be present as positional argument or"//nl//&
      "an internal parametrization should be selected."//nl//&
      ""//nl//&
      "Options"//nl//&
      ""//nl//&
      "      --method <name>     Base parametrization of the xTB Hamiltonian to use"//nl//&
      "                          Available methods: gfn1, gfn2, ipea1"//nl//&
      "      --output <file>     Output file for writing parametrization"//nl//&
      help_text_general//nl//&
      ""//nl//&
      help_text_response

   !> Help text for run command
   character(len=*), parameter :: help_text_run = &
      "Usage: "//prog_name//" [run] [options] <input>"//nl//&
      ""//nl//&
      "Evaluates the tight-binding model on the provided input structure."//nl//&
      "Periodic calculations are performed automatically for periodic input formats."//nl//&
      "Reads .CHRG and .UHF files if present in the same directory as the input."//nl//&
      ""//nl//&
      help_text_geometry//nl//&
      ""//nl//&
      "Options"//nl//&
      ""//nl//&
      "  -c, --charge <real>      Set charge to molecule, overwrites .CHRG file"//nl//&
      "      --spin <int>         Set number of unpaired electrons, overwrites .UHF file"//nl//&
      "      --method <name>      Parametrization of the xTB Hamiltonian to use"//nl//&
      "                           Available methods: gfn1, gfn2, ipea1 (Default: gfn2)"//nl//&
      "      --param <file>       Parametrization file to use for calculation"//nl//&
      "      --acc <real>         Convergence criterion for SCF (Default: 1.0)"//nl//&
      "      --etemp <real>       Electronic temperature for calculation (Default: 300K)"//nl//&
      "      --etemp-anneal <real>[,<int>,<int>]"//nl//&
      "                           Initial electronic temperature for SCF annealing,"//nl//&
      "                           optionally followed by hold and annealing steps"//nl//&
      "      --guess <name>       Guess for the initial populations, possible options:"//nl//&
      "                           sad (default), eeq, eeqbc, ceh (Charge-Extended Hückel method)"//nl//&
      "      --config <key>=<value>"//nl//&
      "                           Set configuration key to value, possible keys are:"//nl//&
      "                           smooth_cutoff (default: 0.05)"//nl//&
      "      --restart [<file>]   Restart calculation from previous run"//nl//&
      "                           File name for restart file is optional,"//nl//&
      "                           (Default: tblite-restart.npz). Use .h5/.hdf5"//nl//&
      "                           for HDF5 restart files when HDF5 is available."//nl//&
      "      --no-restart         Do not restart calculation from previous run"//nl//&
      "      --etemp-guess <real> Electronic temperature for ceh-guess (Default: 5000K)"//nl//&
      "      --iterations <int>   Maximum number of SCF iterations (Default: 250)"//nl//&
      "      --mixer <name>"//nl//&
      "                           Electronic mixer: broyden (default)"//nl//&
      "      --mixer <option>=<value>"//nl//&
      "                           Set mixer specific settings using <option>=<value> syntax"//nl//&
      "      --mixer memory=<int>"//nl//&
      "                           Number of previous SCF steps retained by the mixer"//nl//&
      "      --mixer damping=<real>"//nl//&
      "                           Damping parameter for the electronic mixer"//nl//&
      "      --solver <name>      Electronic solver for SCF, possible options:"//nl//&
      "                           gvd (default), and gvr"//nl//&
      "      --efield <real>,<real>,<real>"//nl//&
      "                           Homogeneous electric field in V/Å."//nl//&
      "      --alpb <name>        Use analytical linearized Poisson-Boltzmann (ALPB) solvation model."//nl//&
      "                           Solvent is specified by the solvent name."//nl//&
      "                           Uses parametrized ALPB with CDS and empirical shift."//nl//&
      "      --gbsa <name>        Use generalized Born solvation model (GBSA)."//nl//&
      "                           Solvent is specified by the solvent name."//nl//&
      "                           Uses parametrized GB with CDS and empirical shift."//nl//&
      "      --gbe <real>/<name>  Use generalized Born for finite epsilion (GBE) solvation model."//nl//&
      "                           Solvent is specified by dielectric constant or the solvent name."//nl//&
      "      --gb <real>/<name>   Use generalized Born solvation model (GB)."//nl//&
      "                           Solvent is specified by dielectric constant or solvent name."//nl//&
      "      --born-kernel <name> Specify Born kernel to use with ALPB, GBSA or GB solvation model."//nl//&
      "                           Possible options are p16 (default for ALPB) and still (default for GB/GBSA)."//nl//&
      "      --cosmo <real>/<name> "//nl//&
      "                           Use conductor-like screening solvation model (COSMO)."//nl//&
      "                           Solvent is specified by dielectric constant or solvent name."//nl//&
      "      --cpcm <real>/<name> Use conductor-like polarizable continuum solvation model (CPCM)."//nl//&
      "                           Solvent is specified by dielectric constant or solvent name."//nl//&
      "      --pcm <real>/<name>  Use polarizable continuum solvation model (PCM)."//nl//&
      "                           Solvent is specified by dielectric constant or solvent name."//nl//&
      "      --solv-state <name>  Solution state correction: gsolv (default), bar1mol, reference."//nl//& 
      "      --spin-polarized     Use spin-polarized xTB Hamiltonian"//nl//&
      "      --post-processing <file>"//nl//&
      "                           Add post processing methods to the calculation"//nl//&
      "                           by using a toml file as input."//nl//&
      "      --post-processing <name>"//nl//&
      "                           Add post processing methods to the calculation,"//nl//&
      "                           Mayer-Wiberg bond orders are computed by default."//nl//&
      "                           Options: molmom (molecular multipole moments)"//nl//&
      "                           Options: xtbml (atomistic properties based on Mulliken partitioning)"//nl//& 
      "      --post-processing-output <file>"//nl//&
      "                           Output file for post processing results in npz format,"//nl//&
      "                           or HDF5 with .h5/.hdf5 when HDF5 is available."//nl//&
      "                           (default: tblite-data.npz)"//nl//&
      "      --grad [file]        Evaluate molecular gradient and virial"//nl//&
      "                           Results are stored in file (default: tblite.txt)"//nl//&
      "      --json [file]        Dump results as JSON output (default: tblite.json)"//nl//&
      "      --trexio [file]      Dump results as TREXIO output (default: tblite.trexio)."//nl//&
      "                           Use .h5/.hdf5 for TREXIO HDF5 when available."//nl//&
      "      --molden [file]      Dump results as Molden output (default: tblite.molden)"//nl//&
      "  -i, --input <format>     Hint for the format of the input file"//nl//&
      "  -v, --verbose            Increase verbosity of printout"//nl//&
      "  -s, --silent             Reduce verbosity of printout"//nl//&
      help_text_general//nl//&
      ""//nl//&
      help_text_response

   !> Help text for guess command
   character(len=*), parameter :: help_text_guess = &
      "Usage: "//prog_name//" guess [options] <input>"//nl//&
      ""//nl//&
      "Execute only the atomic charge / density guess."//nl//&
      "Prints the initializing charges and dipole moments."//nl//&
      "Reads .CHRG and .UHF files if present in the same directory as the input."//nl//&
      ""//nl//&
      help_text_geometry//nl//&
      ""//nl//&
      "Options"//nl//&
      ""//nl//&
      "  -c, --charge <real>      Set charge to molecule, overwrites .CHRG file"//nl//&
      "      --spin <int>         Set number of unpaired electrons, overwrites .UHF file"//nl//&
      "      --method <name>      Guess for the initial populations, possible options:"//nl//&
      "                           sad, eeq, eeqbc, ceh (Charge-Extended Hückel method, default)"//nl//&
      "      --etemp-guess <real> Electronic temperature for ceh-guess (Default: 4000K)"//nl//&
      "      --solver <name>      Electronic solver for SCF, possible options:"//nl//&
      "                           gvd (default), and gvr"//nl//&
      "      --efield <real>,<real>,<real>"//nl//&
      "                           Homogeneous electric field in V/Å."//nl//&
      "      --grad               Evaluate analytic gradient of charges."//nl//&
      "      --json [file]        Dump results as JSON output (default: tblite.json)"//nl//&
      "  -i, --input <format>     Hint for the format of the input file"//nl//&
      "  -v, --verbose            Increase verbosity of printout"//nl//&
      "  -s, --silent             Reduce verbosity of printout"//nl//&
      help_text_general//nl//&
      ""//nl//&
      help_text_response

   !> Help text for fit command
   character(len=*), parameter :: help_text_fit = &
      "Usage: "//prog_name//" fit [options] <param-file> <input-file>"//nl//&
      ""//nl//&
      "Takes the name of the starting parameter file as first positional argument and"//nl//&
      "an input file for the settings of the run as second positional argument."//nl//&
      "A starting parameter file can be produced using the tblite-param(1) command."//nl//&
      ""//nl//&
      "Options"//nl//&
      ""//nl//&
      "      --dry-run           Do not run start the fitting procedure"//nl//&
      "      --copy <file>       Write the full representation of the input to <file>,"//nl//&
      "                          all defaults will be filled in and the mask expanded"//nl//&
      "  -v, --verbose           Increase verbosity of printout"//nl//&
      "  -s, --silent            Reduce verbosity of printout"//nl//&
      help_text_general//nl//&
      ""//nl//&
      help_text_response

   !> Help text for tagdiff command
   character(len=*), parameter :: help_text_tagdiff = &
      "Usage: "//prog_name//" tagdiff [options] <actual> <reference>"//nl//&
      ""//nl//&
      "Takes two positional arguments and computes the difference between the"//nl//&
      "entries in the reference and the actual data files. Only keys of the"//nl//&
      "reference data file are used from the actual one."//nl//&
      ""//nl//&
      "Options"//nl//&
      ""//nl//&
      "      --fit               Produce output for fit command"//nl//&
      help_text_general//nl//&
      ""//nl//&
      help_text_response

end module tblite_cli_help

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of the isotropic third-order electrostatic contributions
module tblite_param_thirdorder
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_param_serde, only : serde_record
   use tblite_toml, only : toml_table, get_value, set_value, add_table
   implicit none
   private

   public :: thirdorder_record, thirdorder_mask, count


   character(len=*), parameter :: k_shell = "shell", k_ang(0:4) = ["s", "p", "d", "f", "g"]

   !> Parametrization record for third-order electrostatic contributions
   type, extends(serde_record) :: thirdorder_record
      integer :: lmax
      logical :: shell
      real(wp) :: ksh(0:4)
   contains
      generic :: load => load_from_array
      generic :: dump => dump_to_array
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Read parametrization data from parameter array
      procedure, private :: load_from_array
      !> Write parametrization data to parameter array
      procedure, private :: dump_to_array
   end type


   type :: thirdorder_mask
   end type thirdorder_mask


   interface count
      module procedure :: count_mask
   end interface count


contains


!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(thirdorder_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   real(wp), allocatable :: last
   integer :: l, stat

   call get_value(table, k_shell, child, requested=.false.)
   self%shell = associated(child)
   if (self%shell) then
      do l = 0, 4
         if (.not.child%has_key(k_ang(l))) then
            if (allocated(last)) then
               self%ksh(l) = last
               cycle
            end if
            call fatal_error(error, "No entry for "//k_ang(l)//"-shell Hubbard derivative")
            exit
         end if
         call get_value(child, k_ang(l), self%ksh(l), stat=stat)
         if (stat /= 0) then
            call fatal_error(error, "Cannot read "//k_ang(l)//"-shell Hubbard derivative")
            exit
         end if
         if (stat == 0) then
            last = self%ksh(l)
            self%lmax = l
         end if
      end do
      if (allocated(error)) return
   end if
end subroutine load_from_toml


!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(thirdorder_record), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   integer :: l

   if (self%shell) then
      call add_table(table, k_shell, child)
      do l = 0, self%lmax
         call set_value(child, k_ang(l), self%ksh(l))
      end do
   else
      call set_value(table, k_shell, .false.)
   end if
end subroutine dump_to_toml


!> Read parametrization data from parameter array
subroutine load_from_array(self, array, offset, base, mask, error)
   class(thirdorder_record), intent(inout) :: self
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: offset
   type(thirdorder_record), intent(in) :: base
   type(thirdorder_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   select type(self)
   type is (thirdorder_record)
      self = base
   end select

end subroutine load_from_array

!> Write parametrization data to parameter array
subroutine dump_to_array(self, array, offset, mask, error)
   class(thirdorder_record), intent(in) :: self
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: offset
   type(thirdorder_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

end subroutine dump_to_array

elemental function count_mask(mask) result(ncount)
   type(thirdorder_mask), intent(in) :: mask
   integer :: ncount
   ncount = 0
end function count_mask


end module tblite_param_thirdorder

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_xtb_external
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type, new
   use mstore, only : get_structure
   use tblite_container, only : container_type, container_cache
   use tblite_context_type, only : context_type
   use tblite_external_field, only : electric_field
   use tblite_wavefunction_type, only : wavefunction_type, new_wavefunction
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_gfn1, only : new_gfn1_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   implicit none
   private

   public :: collect_xtb_external

   real(wp), parameter :: acc = 0.01_wp
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp), parameter :: thr2 = 1e+4_wp*sqrt(epsilon(1.0_wp))
   real(wp), parameter :: kt = 300.0_wp * 3.166808578545117e-06_wp

  real(wp), parameter :: aatoau = 1.0_wp / 0.529177249_wp, &
     & ctoau = 1.0_wp / 1.60217653e-19_wp, jtoau = 1.0_wp / 4.3597441775e-18_wp
  !> Convert V/Å = J/(C·Å) to atomic units
  real(wp), parameter :: vatoau = jtoau / (ctoau * aatoau)

  type, extends(container_type) :: empty_interaction
  end type empty_interaction

contains


!> Collect all exported unit tests
subroutine collect_xtb_external(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("gfn1-efield", test_e_mb01), &
      new_unittest("gfn2-efield", test_e_mb02), &
      new_unittest("gfn1-dipole", test_d_mb03), &
      new_unittest("gfn2-dipole", test_d_mb04), &
      new_unittest("gfn1-empty", test_g_mb05), &
      new_unittest("gfn2-empty", test_g_mb06) &
      ]

end subroutine collect_xtb_external


subroutine test_e_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy
   real(wp), parameter :: ref1 = -33.092759826817499_wp, ref0 = -33.040345115781605_wp

   call get_structure(mol, "MB16-43", "01")
   energy = 0.0_wp

   call new_gfn1_calculator(calc, mol, error)
   if (allocated(error)) return
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)

   cont = electric_field([-2.0_wp, 0.0_wp, 0.0_wp]*vatoau)
   call calc%push_back(cont)

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0)

   call check(error, energy, ref1, thr=thr)
   if (allocated(error)) return

   call calc%pop(cont)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0)

   call check(error, energy, ref0, thr=thr)

end subroutine test_e_mb01


subroutine test_e_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   real(wp), parameter :: ref1 = -24.157134025160921_wp, ref0 = -24.069929678894123_wp

   call get_structure(mol, "MB16-43", "02")
   allocate(gradient(3, mol%nat), sigma(3, 3))
   energy = 0.0_wp

   call new_gfn2_calculator(calc, mol, error)
   if (allocated(error)) return
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)

   cont = electric_field([0.0_wp, sqrt(2.0_wp), -sqrt(2.0_wp)]*vatoau)
   call calc%push_back(cont)

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, ref1, thr=thr)
   if (allocated(error)) return

   call calc%pop(cont)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, ref0, thr=thr)

end subroutine test_e_mb02


subroutine test_d_mb03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn, wfn0
   class(container_type), allocatable :: cont
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp) :: energy, efield(3), er, el, numdip(3), dipole(3)
   integer :: i

   call get_structure(mol, "MB16-43", "03")
   energy = 0.0_wp
   efield(:) = 0.0_wp

   call new_gfn1_calculator(calc, mol, error)
   if (allocated(error)) return
   call new_wavefunction(wfn0, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)

   cont = electric_field(efield)
   call calc%push_back(cont)

   call xtb_singlepoint(ctx, mol, calc, wfn0, acc, energy, verbosity=0)
   dipole(:) = matmul(mol%xyz, wfn0%qat(:, 1)) + sum(wfn0%dpat(:, :, 1), 2)

   do i = 1, 3
      wfn = wfn0
      efield(i) = efield(i) + step
      call calc%pop(cont)
      cont = electric_field(efield)
      call calc%push_back(cont)
      call xtb_singlepoint(ctx, mol, calc, wfn, acc, er, verbosity=0)

      wfn = wfn0
      efield(i) = efield(i) - 2*step
      call calc%pop(cont)
      cont = electric_field(efield)
      call calc%push_back(cont)
      call xtb_singlepoint(ctx, mol, calc, wfn, acc, el, verbosity=0)

      efield(i) = efield(i) + step
      numdip(i) = -0.5_wp * (er - el) / step
   end do

   if (any(abs(dipole - numdip) > thr2)) then
      call test_failed(error, "Numerical dipole moment does not match")
      print '(3es21.14)', dipole
      print '("---")'
      print '(3es21.14)', numdip
      print '("---")'
      print '(3es21.14)', dipole - numdip
   end if

end subroutine test_d_mb03


subroutine test_d_mb04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn, wfn0
   class(container_type), allocatable :: cont
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp) :: energy, efield(3), er, el, numdip(3), dipole(3)
   integer :: i

   call get_structure(mol, "MB16-43", "04")
   energy = 0.0_wp
   efield(:) = 0.0_wp

   call new_gfn2_calculator(calc, mol, error)
   if (allocated(error)) return
   call new_wavefunction(wfn0, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)

   cont = electric_field(efield)
   call calc%push_back(cont)

   call xtb_singlepoint(ctx, mol, calc, wfn0, acc, energy, verbosity=0)
   dipole(:) = matmul(mol%xyz, wfn0%qat(:, 1)) + sum(wfn0%dpat(:, :, 1), 2)

   do i = 1, 3
      wfn = wfn0
      efield(i) = efield(i) + step
      call calc%pop(cont)
      cont = electric_field(efield)
      call calc%push_back(cont)
      call xtb_singlepoint(ctx, mol, calc, wfn, acc, er, verbosity=0)

      wfn = wfn0
      efield(i) = efield(i) - 2*step
      call calc%pop(cont)
      cont = electric_field(efield)
      call calc%push_back(cont)
      call xtb_singlepoint(ctx, mol, calc, wfn, acc, el, verbosity=0)

      efield(i) = efield(i) + step
      numdip(i) = -0.5_wp * (er - el) / step
   end do

   if (any(abs(dipole - numdip) > thr2)) then
      call test_failed(error, "Numerical dipole moment does not match")
      print '(3es21.14)', dipole
      print '("---")'
      print '(3es21.14)', numdip
      print '("---")'
      print '(3es21.14)', dipole - numdip
   end if

end subroutine test_d_mb04


subroutine test_g_mb05(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   real(wp), parameter :: eref = -27.735987624622005_wp, gref(3, 16) = reshape([&
      & -1.82353787492949E-3_wp,  1.31818459922823E-3_wp,  8.58226495653576E-3_wp, &
      &  1.97688739182230E-2_wp, -7.29458073763057E-3_wp, -6.04380003974638E-3_wp, &
      &  3.98810014714115E-3_wp,  6.14906826920453E-3_wp,  4.80384729197490E-3_wp, &
      &  9.11662446246199E-3_wp,  8.11888967395009E-4_wp, -2.06033497236509E-3_wp, &
      &  6.93297807104095E-3_wp, -9.99636455500038E-4_wp, -5.74433211393415E-3_wp, &
      & -4.86754354610952E-3_wp, -3.06270172653747E-3_wp, -2.01091116475248E-3_wp, &
      &  4.16440905040429E-3_wp, -2.03405181467356E-3_wp, -6.07808932105647E-4_wp, &
      & -2.20381696875807E-2_wp, -1.11474305059426E-4_wp,  7.88311942639446E-3_wp, &
      & -1.13525078678607E-3_wp, -9.03126254289776E-3_wp,  5.41440972040784E-3_wp, &
      & -4.31763236474853E-4_wp,  7.28641048680264E-3_wp,  1.46388718395281E-3_wp, &
      & -9.52395151098753E-3_wp, -3.06196332824414E-4_wp, -1.18009384848677E-2_wp, &
      & -3.17217740137865E-3_wp,  1.23412949417049E-2_wp, -6.93057638998609E-3_wp, &
      &  3.84703556856836E-3_wp, -5.30965159378415E-3_wp, -4.76649943206558E-3_wp, &
      &  4.01813275719477E-3_wp, -6.60996461366484E-3_wp, -4.94608420633252E-3_wp, &
      &  4.66628771990608E-3_wp,  2.54601905375790E-3_wp,  1.53173370986307E-3_wp, &
      & -1.35100476506938E-2_wp,  4.30665380447907E-3_wp,  1.52320234470266E-2_wp],&
      & shape(gref))

   call get_structure(mol, "MB16-43", "05")
   allocate(gradient(3, mol%nat), sigma(3, 3))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call new_gfn2_calculator(calc, mol, error)
   if (allocated(error)) return
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)

   cont = empty_interaction()
   call calc%push_back(cont)

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, eref, thr=thr)
   if (allocated(error)) return
   call check(error, all(abs(gradient - gref) < thr))

end subroutine test_g_mb05


subroutine test_g_mb06(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   class(container_type), allocatable :: cont
   real(wp) :: energy
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   real(wp), parameter :: eref = -18.559531670207463_wp, gref(3, 16) = reshape([&
      & -7.68855208823154E-3_wp,  2.10638867503445E-2_wp,  2.41215155941334E-3_wp, &
      &  2.90805965762717E-3_wp, -1.75018015056621E-3_wp,  3.85582760443651E-3_wp, &
      &  1.54219205661951E-3_wp,  1.32376377402360E-3_wp,  1.01824888645767E-3_wp, &
      & -1.91452656544107E-2_wp, -2.23384392341465E-2_wp,  5.48586109290690E-3_wp, &
      & -4.39746104836314E-3_wp, -1.10529660508857E-2_wp, -2.03434329217776E-2_wp, &
      &  9.62864183290068E-3_wp,  9.33495782979855E-3_wp,  4.28513096166196E-3_wp, &
      &  3.40301832758327E-3_wp,  1.33326298386767E-2_wp,  3.81296500108361E-4_wp, &
      & -2.32159630655584E-3_wp,  8.79100677206436E-4_wp, -2.03120821307283E-3_wp, &
      &  1.73423639495923E-2_wp,  1.52735549282184E-2_wp, -5.01999960210040E-3_wp, &
      & -3.35073564349097E-3_wp, -1.59744035347341E-2_wp,  8.31528670874199E-3_wp, &
      & -1.82578281101229E-3_wp, -3.86682679585475E-3_wp, -1.47462197318047E-3_wp, &
      &  1.33591887148489E-3_wp, -9.88764121832669E-4_wp,  6.43834617770471E-3_wp, &
      & -2.84651079600129E-3_wp,  1.62990353769770E-3_wp,  1.10448375328198E-3_wp, &
      &  4.00339318812389E-3_wp, -1.03144794325501E-3_wp,  4.05047193028005E-3_wp, &
      &  1.72567953487094E-3_wp, -6.60586563316507E-3_wp, -3.98074228816423E-3_wp, &
      & -3.13363070736831E-4_wp,  7.71096128474042E-4_wp, -4.49710017669782E-3_wp],&
      & shape(gref))

   call get_structure(mol, "MB16-43", "06")
   allocate(gradient(3, mol%nat), sigma(3, 3))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call new_gfn2_calculator(calc, mol, error)
   if (allocated(error)) return
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)

   cont = empty_interaction()
   call calc%push_back(cont)

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, gradient, sigma, verbosity=0)

   call check(error, energy, eref, thr=thr)
   if (allocated(error)) return
   call check(error, all(abs(gradient - gref) < thr))

end subroutine test_g_mb06


end module test_xtb_external

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/solvation/type.f90
!> Provides a base class for all implicit solvation models

!> Definition of an abstract base class for defining solvation models
module tblite_solvation_type
   use tblite_container_type, only : container_type
   implicit none
   private


   !> Abstract base class for solvation models
   type, public, extends(container_type), abstract :: solvation_type
   end type solvation_type


end module tblite_solvation_type

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Analytical linearized Poisson-Boltzmann solvation model.
!>
!> Implements a reaction field model of the Generalized Born type.
module tblite_solvation_alpb
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use mctc_io_math, only : matdet_3x3
   use tblite_blas, only : dot, gemv, symv
   use tblite_container_cache, only : container_cache
   use tblite_mesh_lebedev, only : grid_size, get_angular_grid, list_bisection
   use tblite_scf_info, only : scf_info, atom_resolved
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_solvation_born, only : born_integrator, new_born_integrator
   use tblite_solvation_data, only : get_vdw_rad_cosmo
   use tblite_solvation_type, only : solvation_type
   implicit none
   private

   public :: alpb_solvation, new_alpb, alpb_input
   public :: born_kernel


   !> Possible Born interaction kernels
   type :: enum_born_kernel
      !> Classical Still kernel
      integer :: still = 1
      !> P16 kernel by Lange (JCTC 2012, 8, 1999-2011)
      integer :: p16 = 2
   end type enum_born_kernel

   !> Actual enumerator for the generalized Born kernels
   type(enum_born_kernel), parameter :: born_kernel = enum_born_kernel()


   !> Input for ALPB solvation
   type :: alpb_input
      !> Dielectric constant
      real(wp) :: dielectric_const
      !> Scaling factor for Born radii
      real(wp) :: born_scale = 1.0_wp
      !> Offset parameter for Born radii integration
      real(wp) :: born_offset = 0.0_wp
      !> Van-der-Waals radii for all species
      real(wp), allocatable :: rvdw(:)
      !> Dielectric descreening parameter
      real(wp), allocatable :: descreening(:)
      !> Interaction kernel
      integer :: kernel = born_kernel%p16
      !> Use analytical linearized Poisson-Boltzmann model
      logical :: alpb = .true.
   end type alpb_input


   !> Definition of polarizable continuum model
   type, extends(solvation_type) :: alpb_solvation
      !> Dielectric function
      real(wp) :: keps
      !> Analytical linearized Poisson-Boltzmann constant
      real(wp) :: alpbet
      !> Integrator for Born radii
      type(born_integrator) :: gbobc
      !> Interaction kernel
      integer :: kernel
   contains
      !> Update cache from container
      procedure :: update
      !> Return dependency on density
      procedure :: variable_info
      !> Get solvation energy
      procedure :: get_energy
      !> Get solvation potential
      procedure :: get_potential
      !> Get solvation gradient
      procedure :: get_gradient
   end type alpb_solvation

   !> Provide constructor for ALPB solvation
   interface alpb_solvation
      module procedure :: create_alpb
   end interface alpb_solvation


   !> Restart data for ALPB calculation
   type :: alpb_cache
      !> Screening matrix
      real(wp), allocatable :: jmat(:, :)
      !> Scratch array for screening potential intermediates
      real(wp), allocatable :: vat(:)
      !> Born radii
      real(wp), allocatable :: rad(:)
      !> Derivatives of Born radii w.r.t. cartesian displacements
      real(wp), allocatable :: draddr(:, :, :)
   end type alpb_cache


   !> Identifier for container
   character(len=*), parameter :: label = "reaction field model"

   real(wp), parameter :: zetaP16 = 1.028_wp
   real(wp), parameter :: zetaP16o16 = zetaP16 / 16.0_wp
   real(wp), parameter :: alpha_alpb = 0.571412_wp


contains


!> Create new ALPB solvation model
subroutine new_alpb(self, mol, input, error)
   !> Instance of the solvation model
   type(alpb_solvation), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input for ALPB solvation
   type(alpb_input), intent(in) :: input
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp), allocatable :: rvdw(:)

   self%label = label
   self%alpbet = merge(alpha_alpb / input%dielectric_const, 0.0_wp, input%alpb)
   self%keps = (1.0_wp/input%dielectric_const - 1.0_wp) / (1.0_wp + self%alpbet)
   self%kernel = input%kernel

   if (allocated(input%rvdw)) then
      rvdw = input%rvdw
   else
      rvdw = get_vdw_rad_cosmo(mol%num)
   end if

   call new_born_integrator(self%gbobc, mol, rvdw, descreening=input%descreening, &
      & born_scale=input%born_scale, born_offset=input%born_offset)
end subroutine new_alpb


!> Type constructor for ALPB splvation
function create_alpb(mol, input) result(self)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input for ALPB solvation
   type(alpb_input), intent(in) :: input
   !> Instance of the solvation model
   type(alpb_solvation) :: self

   type(error_type), allocatable :: error

   call new_alpb(self, mol, input, error)
end function create_alpb


!> Update cache from container
subroutine update(self, mol, cache)
   !> Instance of the solvation model
   class(alpb_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   type(alpb_cache), pointer :: ptr
   real(wp) :: adet

   call taint(cache, ptr)

   if (.not.allocated(ptr%jmat)) then
      allocate(ptr%jmat(mol%nat, mol%nat))
   end if
   if (.not.allocated(ptr%vat)) then
      allocate(ptr%vat(mol%nat))
   end if
   if (.not.allocated(ptr%rad)) then
      allocate(ptr%rad(mol%nat))
   end if
   if (.not.allocated(ptr%draddr)) then
      allocate(ptr%draddr(3, mol%nat, mol%nat))
   end if

   call self%gbobc%get_rad(mol, ptr%rad, ptr%draddr)
   ptr%jmat(:, :) = 0.0_wp
   select case(self%kernel)
   case(born_kernel%p16)
      call add_born_mat_p16(mol%nat, mol%xyz, self%keps, ptr%rad, ptr%jmat)
   case(born_kernel%still)
      call add_born_mat_still(mol%nat, mol%xyz, self%keps, ptr%rad, ptr%jmat)
   end select

   if (self%alpbet > 0.0_wp) then
      call get_adet(mol%nat, mol%xyz, self%gbobc%vdwr, adet)

      ptr%jmat(:mol%nat, :mol%nat) = ptr%jmat(:mol%nat, :mol%nat) &
         & + self%keps * self%alpbet / adet
   end if
end subroutine update


!> Get solvation energy
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the solvation model
   class(alpb_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Solvation free energy
   real(wp), intent(inout) :: energies(:)

   type(alpb_cache), pointer :: ptr

   call view(cache, ptr)

   call symv(ptr%jmat, wfn%qat(:, 1), ptr%vat, alpha=0.5_wp)
   energies(:) = energies + ptr%vat * wfn%qat(:, 1)
end subroutine get_energy


!> Get solvation potential
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the solvation model
   class(alpb_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   type(alpb_cache), pointer :: ptr

   call view(cache, ptr)

   call symv(ptr%jmat, wfn%qat(:, 1), pot%vat(:, 1), beta=1.0_wp)
end subroutine get_potential


!> Get solvation gradient
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the solvation model
   class(alpb_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the solvation free energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the solvation free energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   type(alpb_cache), pointer :: ptr
   real(wp) :: energy

   energy = 0.0_wp
   call view(cache, ptr)

   select case(self%kernel)
   case(born_kernel%p16)
      call add_born_deriv_p16(mol%nat, mol%xyz, &
         & wfn%qat(:, 1), self%keps, ptr%rad, ptr%draddr, energy, gradient)
   case(born_kernel%still)
      call add_born_deriv_still(mol%nat, mol%xyz, &
         & wfn%qat(:, 1), self%keps, ptr%rad, ptr%draddr, energy, gradient)
   end select

   if (self%alpbet > 0.0_wp) then
      call get_adet_deriv(mol%nat, mol%xyz, self%gbobc%vdwr, self%kEps*self%alpbet, &
         & wfn%qat(:, 1), gradient)
   end if
end subroutine get_gradient


!> Return dependency on density
pure function variable_info(self) result(info)
   !> Instance of the solvation model
   class(alpb_solvation), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=atom_resolved)
end function variable_info


subroutine taint(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(alpb_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(alpb_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

subroutine view(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(alpb_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(alpb_cache)
      ptr => target
   end select
end subroutine view


subroutine add_born_mat_p16(nat, xyz, keps, brad, Amat)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Dielectric screening
   real(wp), intent(in) :: keps
   !> Born radii
   real(wp), intent(in) :: brad(:)
   !> Interaction matrix
   real(wp), intent(inout) :: Amat(:, :)

   integer :: iat, jat
   real(wp) :: r1, ab, arg, eab, fgb, dfgb, bp, vec(3)

   ! omp parallel do default(none) shared(Amat, ntpair, ppind, ddpair, brad, keps) &
   ! omp private(kk, iat, jat, r1, ab, arg, fgb, dfgb)
   do iat = 1, nat
      do jat = 1, iat - 1
         vec(:) = xyz(:, iat) - xyz(:, jat)
         r1 = norm2(vec)

         ab = sqrt(brad(iat) * brad(jat))
         arg = ab / (ab + zetaP16o16*r1) ! ab / (1 + ζR/(16·ab))
         arg = arg * arg ! ab / (1 + ζR/(16·ab))²
         arg = arg * arg ! ab / (1 + ζR/(16·ab))⁴
         arg = arg * arg ! ab / (1 + ζR/(16·ab))⁸
         arg = arg * arg ! ab / (1 + ζR/(16·ab))¹⁶
         fgb = r1 + ab*arg
         dfgb = 1.0_wp / fgb

         Amat(iat, jat) = keps*dfgb + Amat(iat, jat)
         Amat(jat, iat) = keps*dfgb + Amat(jat, iat)
      enddo
      ! self-energy part
      bp = 1.0_wp/brad(iat)
      Amat(iat, iat) = Amat(iat, iat) + keps*bp
   enddo

end subroutine add_born_mat_p16


subroutine add_born_deriv_p16(nat, xyz, qat, keps, &
      & brad, brdr, energy, gradient)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)
   !> Dielectric screening
   real(wp), intent(in) :: keps
   !> Born radii
   real(wp), intent(in) :: brad(:)
   !> Derivative of Born radii w.r.t. cartesian coordinates
   real(wp), contiguous, intent(in) :: brdr(:, :, :)
   !> Total Born solvation energy
   real(wp), intent(out) :: energy
   !> Deriatives of Born solvation energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)

   integer :: iat, jat, kk
   real(wp) :: vec(3), r2, r1, ab, arg1, arg16, qq, fgb, fgb2, dfgb, dfgb2, egb
   real(wp) :: dEdbri, dEdbrj, dG(3), ap, bp, dS(3, 3)
   real(wp), allocatable :: dEdbr(:)

   allocate(dEdbr(nat), source = 0.0_wp )

   egb = 0._wp
   dEdbr(:) = 0._wp

   ! GB energy and gradient
   ! omp parallel do default(none) reduction(+:egb, gradient, dEdbr) &
   ! omp private(iat, jat, vec, r1, r2, ab, arg1, arg16, fgb, dfgb, dfgb2, ap, &
   ! omp& bp, qq, dEdbri, dEdbrj, dG, dS) &
   ! omp shared(keps, qat, ntpair, ddpair, ppind, brad)
   do iat = 1, nat
      do jat = 1, iat - 1
         vec(:) = xyz(:, iat) - xyz(:, jat)
         r1 = norm2(vec)
         r2 = r1*r1

         qq = qat(iat)*qat(jat)

         ab = sqrt(brad(iat) * brad(jat))
         arg1 = ab / (ab + zetaP16o16*r1) ! 1 / (1 + ζR/(16·ab))
         arg16 = arg1 * arg1 ! 1 / (1 + ζR/(16·ab))²
         arg16 = arg16 * arg16 ! 1 / (1 + ζR/(16·ab))⁴
         arg16 = arg16 * arg16 ! 1 / (1 + ζR/(16·ab))⁸
         arg16 = arg16 * arg16 ! 1 / (1 + ζR/(16·ab))¹⁶

         fgb = r1 + ab*arg16
         dfgb = 1.0_wp / fgb
         dfgb2 = dfgb * dfgb

         egb = egb + qq*keps*dfgb

         ! (1 - ζ/(1 + Rζ/(16 ab))^17)/(R + ab/(1 + Rζ/(16 ab))¹⁶)²
         ap = (1.0_wp - zetaP16 * arg1 * arg16) * dfgb2
         dG(:) = ap * vec * keps / r1 * qq
         gradient(:, iat) = gradient(:, iat) - dG
         gradient(:, jat) = gradient(:, jat) + dG

         ! -(Rζ/(2·ab²·(1 + Rζ/(16·ab))¹⁷) + 1/(2·ab·(1 + Rζ/(16·ab))¹⁶))/(R + ab/(1 + Rζ/(16·ab))¹⁶)²
         bp = -0.5_wp*(r1 * zetaP16 / ab * arg1 + 1.0_wp) / ab * arg16 * dfgb2
         dEdbri = brad(jat) * bp * keps * qq
         dEdbrj = brad(iat) * bp * keps * qq
         dEdbr(iat) = dEdbr(iat) + dEdbri
         dEdbr(jat) = dEdbr(jat) + dEdbrj

      end do

      ! self-energy part
      bp = 1._wp/brad(iat)
      qq = qat(iat)*bp
      egb = egb + 0.5_wp*qat(iat)*qq*keps
      dEdbri = -0.5_wp*keps*qq*bp
      dEdbr(iat) = dEdbr(iat) + dEdbri*qat(iat)
      !gradient = gradient + brdr(:, :, i) * dEdbri*qat(i)
   enddo

   ! contract with the Born radii derivatives
   call gemv(brdr, dEdbr, gradient, beta=1.0_wp)

   energy = egb

end subroutine add_born_deriv_p16


pure subroutine add_born_mat_still(nat, xyz, keps, brad, Amat)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Dielectric screening
   real(wp), intent(in) :: keps
   !> Born radii
   real(wp), intent(in) :: brad(:)
   !> Interaction matrix
   real(wp), intent(inout) :: Amat(:, :)

   integer  :: i, j, nnj
   integer  :: kk
   real(wp), parameter :: a13=1.0_wp/3.0_wp
   real(wp), parameter :: a4=0.25_wp
   real(wp), parameter :: sqrt2pi = sqrt(2.0_wp/pi)
   real(wp) :: aa, vec(3), r1, r2, gg, arg, bp
   real(wp) :: dd, expd, fgb, fgb2, dfgb

   do i = 1, nat
      do j = 1, i - 1
         vec(:) = xyz(:, i) - xyz(:, j)
         r1 = norm2(vec)
         r2 = r1*r1

         aa = brad(i)*brad(j)
         dd = a4*r2/aa
         expd = exp(-dd)
         fgb2 = r2+aa*expd
         dfgb = 1.0_wp/sqrt(fgb2)
         Amat(i, j) = keps*dfgb + Amat(i, j)
         Amat(j, i) = keps*dfgb + Amat(j, i)
      enddo

      ! self-energy part
      bp = 1._wp/brad(i)
      Amat(i, i) = Amat(i, i) + keps*bp
   enddo

end subroutine add_born_mat_still


subroutine add_born_deriv_still(nat, xyz, qat, keps, &
      & brad, brdr, energy, gradient)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)
   !> Dielectric screening
   real(wp), intent(in) :: keps
   !> Born radii
   real(wp), intent(in) :: brad(:)
   !> Derivative of Born radii w.r.t. cartesian coordinates
   real(wp), contiguous, intent(in) :: brdr(:, :, :)
   !> Total Born solvation energy
   real(wp), intent(out) :: energy
   !> Deriatives of Born solvation energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)

   integer :: i, j, k, nnj
   integer :: kk
   real(wp), parameter :: a13=1._wp/3._wp
   real(wp), parameter :: a4=0.25_wp
   real(wp) :: aa, r2, fgb, fgb2, br3
   real(wp) :: qq, dd, expd, dfgb, dfgb2, dfgb3, egb, ap, bp, qfg
   real(wp) :: gg, expa
   real(wp) :: r0vdw, r01, r02, ar02
   real(wp) :: grddbi, grddbj
   real(wp) :: dr(3), r1, vec(3)
   real(wp), allocatable :: grddb(:)

   allocate(grddb(nat), source = 0.0_wp )

   egb = 0._wp
   grddb(:) = 0._wp

   ! GB energy and gradient

   ! compute energy and fgb direct and radii derivatives
   do i = 1, nat
      do j = 1, i - 1
         vec(:) = xyz(:, i) - xyz(:, j)
         r1 = norm2(vec)
         r2 = r1*r1

         ! dielectric scaling of the charges
         qq = qat(i)*qat(j)
         aa = brad(i)*brad(j)
         dd = a4*r2/aa
         expd = exp(-dd)
         fgb2 = r2+aa*expd
         dfgb2 = 1._wp/fgb2
         dfgb = sqrt(dfgb2)
         dfgb3 = dfgb2*dfgb*keps

         egb = egb + qq*keps*dfgb

         ap = (1._wp-a4*expd)*dfgb3
         dr = ap*vec
         gradient(:, i) = gradient(:, i) - dr*qq
         gradient(:, j) = gradient(:, j) + dr*qq

         bp = -0.5_wp*expd*(1._wp+dd)*dfgb3
         grddbi = brad(j)*bp
         grddbj = brad(i)*bp
         grddb(i) = grddb(i) + grddbi*qq
         !gradient = gradient + brdr(:, :, i) * grddbi*qq
         grddb(j) = grddb(j) + grddbj*qq
         !gradient = gradient + brdr(:, :, j) * grddbj*qq

      enddo

      ! self-energy part
      bp = 1._wp/brad(i)
      qq = qat(i)*bp
      egb = egb + 0.5_wp*qat(i)*qq*keps
      grddbi = -0.5_wp*keps*qq*bp
      grddb(i) = grddb(i) + grddbi*qat(i)
      !gradient = gradient + brdr(:, :, i) * grddbi*qat(i)
   enddo

   ! contract with the Born radii derivatives
   call gemv(brdr, grddb, gradient, beta=1.0_wp)

   energy = egb

end subroutine add_born_deriv_still


subroutine get_adet(nat, xyz, rad, aDet)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Atomic radii
   real(wp), intent(in) :: rad(:)
   !> Shape descriptor of the structure
   real(wp), intent(out) :: aDet

   integer :: iat
   real(wp) :: r2, rad2, rad3, vol, vec(3), center(3), inertia(3, 3)
   real(wp), parameter :: tof = 2.0_wp/5.0_wp, unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])

   vol = 0.0_wp
   center(:) = 0.0_wp
   do iat = 1, nat
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      vol = vol + rad3
      center(:) = center + xyz(:, iat) * rad3
   end do
   center = center / vol

   inertia(:, :) = 0.0_wp
   do iat = 1, nat
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      vec(:) = xyz(:, iat) - center
      r2 = sum(vec**2)
      inertia(:, :) = inertia + rad3 * ((r2 + tof*rad2) * unity &
         & - spread(vec, 1, 3) * spread(vec, 2, 3))
   end do

   aDet = sqrt(matdet_3x3(inertia)**(1.0_wp/3.0_wp)/(tof*vol))

end subroutine get_adet


subroutine get_adet_deriv(nAtom, xyz, rad, kEps, qvec, gradient)
   !> Number of atoms
   integer, intent(in) :: nAtom
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Atomic radii
   real(wp), intent(in) :: rad(:)
   real(wp), intent(in) :: kEps
   real(wp), intent(in) :: qvec(:)
   !> Molecular gradient
   real(wp), intent(inout) :: gradient(:, :)

   integer :: iat
   real(wp) :: r2, rad2, rad3, vol, vec(3), center(3), inertia(3, 3), aDet
   real(wp) :: aDeriv(3, 3), qtotal
   real(wp), parameter :: tof = 2.0_wp/5.0_wp, unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])

   qtotal = 0.0_wp
   vol = 0.0_wp
   center(:) = 0.0_wp
   do iat = 1, nAtom
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      vol = vol + rad3
      center(:) = center + xyz(:, iat) * rad3
      qtotal = qtotal + qvec(iat)
   end do
   center = center / vol

   inertia(:, :) = 0.0_wp
   do iat = 1, nAtom
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      vec(:) = xyz(:, iat) - center
      r2 = sum(vec**2)
      inertia(:, :) = inertia + rad3 * ((r2 + tof*rad2) * unity &
         & - spread(vec, 1, 3) * spread(vec, 2, 3))
   end do
   aDet = sqrt(matdet_3x3(inertia)**(1.0_wp/3.0_wp)/(tof*vol))

   aDeriv(:, :) = reshape([&
      & inertia(1,1)*(inertia(2,2)+inertia(3,3))-inertia(1,2)**2-inertia(1,3)**2, &
      & inertia(1,2)*inertia(3,3)-inertia(1,3)*inertia(2,3), & ! xy
      & inertia(1,3)*inertia(2,2)-inertia(1,2)*inertia(3,2), & ! xz
      & inertia(1,2)*inertia(3,3)-inertia(1,3)*inertia(2,3), & ! xy
      & inertia(2,2)*(inertia(1,1)+inertia(3,3))-inertia(1,2)**2-inertia(2,3)**2, &
      & inertia(1,1)*inertia(2,3)-inertia(1,2)*inertia(1,3), & ! yz
      & inertia(1,3)*inertia(2,2)-inertia(1,2)*inertia(3,2), & ! xz
      & inertia(1,1)*inertia(2,3)-inertia(1,2)*inertia(1,3), & ! yz
      & inertia(3,3)*(inertia(1,1)+inertia(2,2))-inertia(1,3)**2-inertia(2,3)**2],&
      & shape=[3, 3]) * (250.0_wp / (48.0_wp * vol**3 * aDet**5)) &
      & * (-0.5_wp * kEps * qtotal**2 / aDet**2)

   do iat = 1, nAtom
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      vec(:) = xyz(:, iat) - center
      gradient(:, iat) = gradient(:, iat) + rad3 * matmul(aderiv, vec)
   end do

end subroutine get_adet_deriv


end module tblite_solvation_alpb

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!!
!! @version 1.0.0
!! @author Abhinav Jha and Michele Nottoli
!! @date 2022-03-31

!> Core routines and parameters specific to ddLPB
module ddx_lpb_core
! Get the core-routines
use ddx_core
!
contains

!> Find intermediate F0 in the RHS of the ddLPB
!! model given in Eq.(82)
!!
!! @param[in]  params     : Input parameter file
!! @param[in]  constants  : Input constants file
!! @param[in]  workspace  : Input workspace
!! @param[in]  gradphi : Gradient of psi_0
!! @param[out] f       : Intermediate calculation of F0
!! @param[inout] ddx_error: ddX error
!!
subroutine wghpot_f(params, constants, workspace, gradphi, f, ddx_error)
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: gradphi(3, constants % ncav)
    !! Temporary buffers
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Outputs
    real(dp), intent(out) :: f(params % ngrid, params % nsph)
    !! Local variables
    integer :: isph, ig, ic, ind, ind0, jsph
    real(dp) :: nderphi, sumSijn, sumSijn_pre
    real(dp), dimension(3) :: vij, vtij
    real(dp), allocatable :: SK_rijn(:), DK_rijn(:), c0(:,:), c1(:,:)
    integer :: l0, icav, istatus, indl, inode
    complex(dp) :: work_complex(constants % lmax0 + 1)
    real(dp) :: work(constants % lmax0 + 1)


    allocate(SK_rijn(0:constants % lmax0), DK_rijn(0:constants % lmax0), &
        & c0(constants % nbasis0, params % nsph), &
        & c1(constants % nbasis0, params % nsph), stat=istatus)
    if (istatus.ne.0) then
        call update_error(ddx_error, 'Allocation in wghpot_f failed')
    end if

    ic = 0
    f = zero
    c0 = zero
    c1 = zero

    ! Compute c0 Eq.(98) QSM19.SISC
    do isph = 1, params % nsph
        do ig = 1, params % ngrid
            if (constants % ui(ig, isph) .ne. zero) then
                ic = ic + 1
                nderphi = dot_product(gradphi(:, ic), constants % cgrid(:,ig))
                c0(:, isph) = c0(:, isph) + &
                    & constants % wgrid(ig)*constants % ui(ig,isph)*&
                    & nderphi*constants % vgrid(1:constants % nbasis0,ig)
                do l0 = 0, constants % lmax0
                    ind0 = l0*l0 + 1
                    ind = ind0 + 2*l0
                    c1(ind0:ind, isph) = constants % C_ik(l0, isph) * &
                        & c0(ind0:ind, isph)
                end do
            end if
        end do
    end do

    ! Computation of F0 using above terms
    ! icav: External grid poitns
    if (params % fmm .eq. 0) then
        icav = 0
        do isph = 1, params % nsph
            do ig = 1, params % ngrid
                if (constants % ui(ig,isph).gt.zero) then
                    icav = icav + 1
                    sumSijn = zero
                    ! Loop to compute Sijn
                    do jsph = 1, params % nsph
                        sumSijn_pre = sumSijn
                        vij  = params % csph(:,isph) + &
                            & params % rsph(isph)*constants % cgrid(:,ig) - &
                            & params % csph(:,jsph)
                        vtij = vij*params % kappa
                        call fmm_m2p_bessel_work(vtij, &
                            & constants % lmax0, constants % vscales, &
                            & constants % SK_ri(:, jsph), one, &
                            & c1(:, jsph), one, sumSijn, work_complex, work)
                    end do
                    ! Here Intermediate value of F_0 is computed Eq. (99)
                    ! Mutilplication with Y_lm and weights will happen afterwards
                    !write(6,*) sumSijn, epsp, eps, ddx_data % constants % ui(ig,isph)
                    f(ig,isph) = -(params % epsp/params % eps)*constants % ui(ig,isph) * sumSijn
                end if
            end do
        end do
    else
        ! Load input harmonics into tree data
        workspace % tmp_node_m = zero
        workspace % tmp_node_l = zero
        workspace % tmp_sph = zero
        workspace % tmp_sph(1:constants % nbasis0, :) = c1(:, :)
        if(constants % lmax0 .lt. params % pm) then
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_node_m(1:constants % nbasis0, inode) = &
                    & workspace % tmp_sph(1:constants % nbasis0, isph)
                workspace % tmp_node_m(constants % nbasis0+1:, inode) = zero
            end do
        else
            indl = (params % pm+1)**2
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_node_m(:, inode) = workspace % tmp_sph(1:indl, isph)
            end do
        end if
        ! Do FMM operations
        call tree_m2m_bessel_rotation(params, constants, workspace % tmp_node_m)
        call tree_m2l_bessel_rotation(params, constants, workspace % tmp_node_m, &
            & workspace % tmp_node_l)
        call tree_l2l_bessel_rotation(params, constants, workspace % tmp_node_l)
        call tree_l2p_bessel(params, constants, one, workspace % tmp_node_l, zero, &
            & workspace % tmp_grid)
        call tree_m2p_bessel(params, constants, constants % lmax0, one, &
            & params % lmax, workspace % tmp_sph, one, &
            & workspace % tmp_grid)
        f = -(params % epsp/params % eps) * constants % ui * workspace % tmp_grid
    end if

    deallocate(SK_rijn, DK_rijn, c0, c1, stat=istatus)
    if (istatus.ne.0) then
        call update_error(ddx_error, 'Deallocation in wghpot_f failed')
    end if

end subroutine wghpot_f

!> Intermediate computation of Bx
!!
!! @param[in]  params     : Input parameter file
!! @param[in]  constants  : Input constants file
!! @param[in]      isph   : Number of the sphere
!! @param[in, out] pot    : Array of size ngrid
!! @param[in]      x      : Input vector (Usually X_e)
!!
subroutine calcv2_lpb (params, constants, isph, pot, x)
    type(ddx_params_type), intent(in)  :: params
    type(ddx_constants_type), intent(in)  :: constants
    integer, intent(in) :: isph
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: x
    real(dp), dimension(params % ngrid), intent(inout) :: pot
    complex(dp) :: work_complex(params % lmax+1)
    real(dp) :: work(params % lmax+1)
    real(dp), dimension(params % ngrid) :: pot2
    integer :: its, ij, jsph
    real(dp) :: vij(3), vtij(3)
    real(dp) :: vvij, tij, xij, oij

    pot = zero
    pot2 = zero
    do its = 1, params % ngrid
        if (constants % ui(its,isph).lt.one) then
            do ij = constants % inl(isph), constants % inl(isph+1)-1
                jsph = constants % nl(ij)

                ! compute geometrical variables
                vij  = params % csph(:,isph) + params % rsph(isph)*constants % cgrid(:,its) - params % csph(:,jsph)
                vvij = sqrt(dot_product(vij,vij))
                tij  = vvij/params % rsph(jsph)

                if ( tij.lt.( one + (params % se+one)/two*params % eta ) ) then
                    xij = fsw(tij, params % se, params % eta)
                    if (constants % fi(its,isph).gt.one) then
                        oij = xij/constants % fi(its, isph)
                    else
                        oij = xij
                    end if
                    vtij = vij*params % kappa
                    call fmm_l2p_bessel_work(vtij, &
                        & params % lmax, constants % vscales, &
                        & constants % SI_ri(:, jsph), oij, x(:, jsph), one, &
                        & pot(its), work_complex, work)
                end if
            end do
        end if
    end do
endsubroutine calcv2_lpb

!> Scale the ddCOSMO solution vector
!!
!! @param[in]  params     : Input parameter file
!! @param[in]  constants  : Input constants file
!! @param[in]  direction  : Direction of the scaling
!! @param[in, out] vector : ddCOSMO solution vector
!!
subroutine convert_ddcosmo(params, constants, direction, vector)
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: direction
    !! Outputs
    real(dp), intent(inout) :: vector(constants % nbasis, params % nsph)
    !! Local variables
    integer :: isph, l, m, ind
    real(dp) :: fac
    !! The code
    do isph = 1, params % nsph
        do l = 0, params % lmax
            ind = l*l + l + 1
            fac = fourpi / (two*dble(l) + one) 
            if (direction .eq. -1) fac = one / fac
            do m = -l, l
                vector(ind+m, isph) = fac*vector(ind+m, isph)
            end do
        end do
    end do
end subroutine convert_ddcosmo


!> Intermediate calculation in calcv2_lpb subroutine
!!
!! @param[in]  params     : Input parameter file
!! @param[in]  constants  : Input constants file
!! @param[in]  rijn       : Radius of sphers x_ijn
!! @param[in]  ri         : Radius of sphers x_i
!! @param[in]  isph       : Index of sphere
!! @param[in]  basloc     : Spherical Harmonic
!! @param[out] fac_hsp    : Return bessel function ratio multiplied by
!!                       the spherical harmonic Y_l'm'. Array of size nylm
!!
subroutine inthsp(params, constants, rijn, isph, basloc, fac_hsp, work)
    implicit none
    type(ddx_params_type), intent(in)  :: params
    type(ddx_constants_type), intent(in)  :: constants
    integer, intent(in) :: isph
    real(dp), intent(in) :: rijn
    real(dp), dimension(constants % nbasis), intent(in) :: basloc
    real(dp), dimension(constants % nbasis), intent(inout) :: fac_hsp
    complex(dp), intent(out) :: work(max(2, params % lmax+1))
    real(dp), dimension(0:params % lmax) :: SI_rijn, DI_rijn
    integer :: l, m, ind
    SI_rijn = 0
    DI_rijn = 0
    fac_hsp = 0
    ! Computation of modified spherical Bessel function values
    call modified_spherical_bessel_first_kind(params % lmax, &
        & rijn*params % kappa, SI_rijn, DI_rijn, work)
    do l = 0, params % lmax
        do  m = -l, l
            ind = l*l + l + 1 + m
            fac_hsp(ind) = SI_rijn(l)/constants % SI_ri(l,isph)*basloc(ind)
        end do
    end do
endsubroutine inthsp


!> Intermediate for computing Bstarx
!! Compute the Adjoint matix B*x
!! Taken from ddx_core routine adjrhs
!! @param[in]  params     : Input parameter file
!! @param[in]  constants  : Input constants file
!! @param[in]      isph   : Number of the sphere
!! @param[in, out] basloc : Used to compute spherical harmonic
!! @param[in, out] vplm   : Used to compute spherical harmonic
!! @param[in, out] vcos   : Used to compute spherical harmonic
!! @param[in, out] vsin   : Used to compute spherical harmonic
!!
subroutine adjrhs_lpb(params, constants, isph, xi, vlm, basloc, &
    & vplm, vcos, vsin, tmp_bessel)
    implicit none
    !! input/output
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), dimension(params % ngrid, params % nsph), intent(in) :: xi
    real(dp), dimension((params % lmax+1)**2), intent(out) :: vlm
    real(dp), dimension((params % lmax+1)**2), intent(out) :: basloc, vplm
    real(dp), dimension(params % lmax+1), intent(out) :: vcos, vsin
    complex(dp), dimension(max(2, params % lmax+1)), intent(out) :: tmp_bessel
    integer, intent(in) :: isph
    !! local
    integer :: ij, jsph, ig, l, ind, m
    real(dp) :: vji(3), vvji, tji, sji(3), xji, oji, fac
    real(dp) :: rho, ctheta, stheta, cphi, sphi
    real(dp), dimension(constants % nbasis) :: fac_hsp

    !loop over neighbors of i-sphere
    do ij = constants % inl(isph), constants % inl(isph+1)-1
      !j-sphere is neighbor
      jsph = constants % nl(ij)
      !loop over integration points
      do ig = 1, params % ngrid
        !compute t_n^ji = | r_j + \rho_j s_n - r_i | / \rho_i
        vji  = params % csph(:,jsph) + params % rsph(jsph)* &
              & constants % cgrid(:,ig) - params % csph(:,isph)
        vvji = sqrt(dot_product(vji,vji))
        tji  = vvji/params % rsph(isph)
        !point is INSIDE i-sphere (+ transition layer)
        if ( tji.lt.( one + (params % se+one)/two*params % eta ) ) then
          !compute s_n^ji
          if (tji.ne.zero) then
              sji = vji/vvji
          else
              sji = one
          end if
          call ylmbas(sji, rho, ctheta, stheta, cphi, &
                        & sphi, params % lmax, &
                        & constants % vscales, basloc, &
                        & vplm, vcos, vsin)
          call inthsp_adj(params, constants, vvji, isph, basloc, fac_hsp, &
              & tmp_bessel)
          !compute \chi( t_n^ji )
          xji = fsw( tji, params % se, params % eta )
          !compute W_n^ji
          if ( constants % fi(ig,jsph).gt.one ) then
            oji = xji/ constants % fi(ig,jsph)
          else
            oji = xji
          endif
          !compute w_n * xi(n,j) * W_n^ji
          fac = constants % wgrid(ig) * xi(ig,jsph) * oji
          !loop over l
          do l = 0, params % lmax
            ind  = l*l + l + 1
            !loop over m
              do m = -l,l
                vlm(ind+m) = vlm(ind+m) + fac*fac_hsp(ind+m)
              enddo
          enddo
        endif
      enddo
    enddo
end subroutine adjrhs_lpb


!> Intermediate calculation in adjrhs_lpb subroutine
!!
!! @param[in]  params     : Input parameter file
!! @param[in]  constants  : Input constants file
!! @param[in]  rjin       : Radius of sphers x_jin
!! @param[in]  jsph       : Index of sphere
!! @param[in]  basloc     : Spherical Harmonic
!! @param[out] fac_hsp    : Return bessel function ratio multiplied by
!!                       the spherical harmonic Y_l'm'. Array of size nylm
subroutine inthsp_adj(params, constants, rjin, jsph, basloc, &
          & fac_hsp, work)
    implicit none
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: jsph
    real(dp), intent(in) :: rjin
    real(dp), dimension(constants % nbasis), intent(in) :: basloc
    real(dp), dimension(constants % nbasis), intent(inout) :: fac_hsp
    complex(dp), intent(out) :: work(max(2, params % lmax+1))
    real(dp), dimension(0:params % lmax) :: SI_rjin, DI_rjin
    integer :: l, m, ind

    SI_rjin = 0
    DI_rjin = 0
    fac_hsp = 0

    ! Computation of modified spherical Bessel function values
    call modified_spherical_bessel_first_kind(params % lmax, &
        & rjin*params % kappa, SI_rjin, DI_rjin, work)

    do l = 0, params % lmax
      do  m = -l, l
        ind = l*l + l + 1 + m
        fac_hsp(ind) = SI_rjin(l)/constants % SI_ri(l,jsph)*basloc(ind)
      end do
    end do
endsubroutine inthsp_adj
end module ddx_lpb_core

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_scf_broyden
   use mctc_env, only : wp
   use tblite_lapack, only : getrf, getrs
   implicit none
   private

   public :: broyden_mixer, new_broyden, broyden

   type :: broyden_mixer
      integer :: ndim
      integer :: memory
      integer :: iter
      integer :: iset
      integer :: idif
      integer :: iget
      real(wp) :: damp
      real(wp), allocatable :: df(:, :)
      real(wp), allocatable :: u(:, :)
      real(wp), allocatable :: a(:, :)
      real(wp), allocatable :: dq(:)
      real(wp), allocatable :: dqlast(:)
      real(wp), allocatable :: qlast_in(:)
      real(wp), allocatable :: omega(:)
      real(wp), allocatable :: q_in(:)
   contains
      procedure :: next
      generic :: set => set_1d, set_2d, set_3d
      procedure :: set_1d
      procedure :: set_2d
      procedure :: set_3d
      generic :: diff => diff_1d, diff_2d, diff_3d
      procedure :: diff_1d
      procedure :: diff_2d
      procedure :: diff_3d
      generic :: get => get_1d, get_2d, get_3d
      procedure :: get_1d
      procedure :: get_2d
      procedure :: get_3d
      procedure :: get_error
   end type broyden_mixer

contains

subroutine new_broyden(self, memory, ndim, damp)
   type(broyden_mixer), intent(out) :: self
   integer, intent(in) :: memory
   integer, intent(in) :: ndim
   real(wp), intent(in) :: damp

   self%ndim = ndim
   self%memory = memory
   self%iter = 0
   self%iset = 0
   self%idif = 0
   self%iget = 0
   self%damp = damp
   allocate(self%df(ndim, memory))
   allocate(self%u(ndim, memory))
   allocate(self%a(memory, memory))
   allocate(self%dq(ndim))
   allocate(self%dqlast(ndim))
   allocate(self%qlast_in(ndim))
   allocate(self%omega(memory))
   allocate(self%q_in(ndim))
end subroutine new_broyden

subroutine set_2d(self, qvec)
   class(broyden_mixer), intent(inout) :: self
   real(wp), contiguous, intent(in), target :: qvec(:, :)
   real(wp), pointer :: qptr(:)
   qptr(1:size(qvec)) => qvec
   call self%set(qptr)
end subroutine set_2d

subroutine set_3d(self, qvec)
   class(broyden_mixer), intent(inout) :: self
   real(wp), contiguous, intent(in), target :: qvec(:, :, :)
   real(wp), pointer :: qptr(:)
   qptr(1:size(qvec)) => qvec
   call self%set(qptr)
end subroutine set_3d

subroutine set_1d(self, qvec)
   class(broyden_mixer), intent(inout) :: self
   real(wp), intent(in) :: qvec(:)
   self%q_in(self%iset+1:self%iset+size(qvec)) = qvec
   self%iset = self%iset + size(qvec)
end subroutine set_1d

subroutine diff_2d(self, qvec)
   class(broyden_mixer), intent(inout) :: self
   real(wp), contiguous, intent(in), target :: qvec(:, :)
   real(wp), pointer :: qptr(:)
   qptr(1:size(qvec)) => qvec
   call self%diff(qptr)
end subroutine diff_2d

subroutine diff_3d(self, qvec)
   class(broyden_mixer), intent(inout) :: self
   real(wp), contiguous, intent(in), target :: qvec(:, :, :)
   real(wp), pointer :: qptr(:)
   qptr(1:size(qvec)) => qvec
   call self%diff(qptr)
end subroutine diff_3d

subroutine diff_1d(self, qvec)
   class(broyden_mixer), intent(inout) :: self
   real(wp), intent(in) :: qvec(:)
   self%dq(self%idif+1:self%idif+size(qvec)) = qvec &
      & - self%q_in(self%idif+1:self%idif+size(qvec))
   self%idif = self%idif + size(qvec)
end subroutine diff_1d

subroutine next(self)
   class(broyden_mixer), intent(inout) :: self
   self%iset = 0
   self%idif = 0
   self%iget = 0
   self%iter = self%iter + 1
   call broyden(self%ndim, self%q_in, self%qlast_in, self%dq, self%dqlast, &
      & self%iter, self%memory, self%damp, self%omega, self%df, self%u, self%a)
end subroutine next

subroutine get_2d(self, qvec)
   class(broyden_mixer), intent(inout) :: self
   real(wp), contiguous, intent(out), target :: qvec(:, :)
   real(wp), pointer :: qptr(:)
   qptr(1:size(qvec)) => qvec
   call self%get(qptr)
end subroutine get_2d

subroutine get_3d(self, qvec)
   class(broyden_mixer), intent(inout) :: self
   real(wp), contiguous, intent(out), target :: qvec(:, :, :)
   real(wp), pointer :: qptr(:)
   qptr(1:size(qvec)) => qvec
   call self%get(qptr)
end subroutine get_3d

subroutine get_1d(self, qvec)
   class(broyden_mixer), intent(inout) :: self
   real(wp), intent(out) :: qvec(:)
   qvec(:) = self%q_in(self%iget+1:self%iget+size(qvec))
   self%iget = self%iget + size(qvec)
end subroutine get_1d

subroutine broyden(n, q, qlast, dq, dqlast, iter, memory, alpha, omega, df, u, a)
   integer, intent(in) :: n
   integer, intent(in) :: iter
   integer, intent(in) :: memory
   real(wp), intent(inout) :: q(n)
   real(wp), intent(inout) :: qlast(n)
   real(wp), intent(in) :: dq(n)
   real(wp), intent(inout) :: dqlast(n)
   real(wp), intent(inout) :: df(n, memory)
   real(wp), intent(inout) :: u(n, memory)
   real(wp), intent(inout) :: a(memory, memory)
   real(wp), intent(inout) :: omega(memory)
   real(wp), intent(in) :: alpha

   real(wp), allocatable :: beta(:,:), c(:, :)
   integer :: i, it1
   real(wp) :: inv, omega0, minw, maxw, wfac

   it1 = iter - 1

   ! set parameters
   ! alpha = 0.25d0
   omega0 = 0.01d0
   minw = 1.0d0
   maxw = 100000.0d0
   wfac = 0.01d0
   ! wfac = 0.05d0

   ! if case for first iteration: simple damping
   if (iter == 1) then
      dqlast(:) = dq
      qlast(:) = q
      q(:) = q + alpha * dq
      return
   end if

   allocate(beta(it1,it1),c(it1, 1))

   ! create omega (weight) for the current iteration
   omega(it1) = sqrt(dot_product(dq, dq))
   if (omega(it1) > (wfac / maxw)) then
      omega(it1) = wfac / omega(it1)
   else
      omega(it1) = maxw
   end if
   if (omega(it1) < minw) then
      omega(it1) = minw
   end if

   ! Build dF(iter-1)
   df(:, it1) = dq - dqlast
   inv = max(sqrt(dot_product(df(:, it1), df(:, it1))), epsilon(1.0_wp))
   inv = 1.0_wp / inv
   df(:, it1) = inv*df(:, it1)

   ! Next: build a, beta, c, gamma
   do i = 1, it1
      a(i, it1) = dot_product(df(:, i), df(:, it1))
      a(it1, i) = a(i, it1)
      c(i, 1) = omega(i) * dot_product(df(:, i), dq)
   end do

   ! Build beta from a and omega
   do i = 1, it1
      beta(:it1, i) = omega(:it1) * omega(i) * a(:it1, i)
      beta(i, i) = beta(i, i) + omega0*omega0
   end do

   ! build beta^-1
   call lineq(beta, c)

   ! Build |u>
   u(:, it1) = alpha * df(:, it1) + inv * (q-qlast) !!!

   ! save charges and deltas
   dqlast(:) = dq
   qlast(:) = q

   ! calculate new charges
   q(:) = q + alpha * dq

   do i = 1, it1
      q(:) = q - omega(i) * c(i, 1) * u(:, i)
   end do

end subroutine broyden

subroutine lineq(a, c)
   real(wp), intent(inout) :: a(:, :)
   real(wp), intent(inout) :: c(:, :)

   integer info
   integer, allocatable :: ipiv(:)

   allocate(ipiv(size(a, 1)))
   ! LU decomoposition of a general matrix
   call getrf(a, ipiv, info)
   if (info == 0) then
      ! generate inverse of a matrix given its LU decomposition
      call getrs(a, c, ipiv, info, trans="t")
   endif
   if (info /= 0)then
      error stop "Error in Broyden matrix inversion!"
   endif

end subroutine lineq

pure function get_error(self) result(error)
   class(broyden_mixer), intent(in) :: self
   real(wp) :: error
   integer :: i
   error = 0.0_wp
   do i = 1, size(self%dq)
      error = error + self%dq(i)**2 / size(self%dq)
   end do
   error = sqrt(error)
end function get_error

end module tblite_scf_broyden

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Implementation of a basic storage structure as pointer list of pointers.
!>
!> This implementation does purposely not use pointer attributes in the
!> datastructure to make it safer to work with.
module tomlf_structure_node
   use tomlf_type_value, only : toml_value
   implicit none
   private

   public :: toml_node, resize


   !> Wrapped TOML value to generate pointer list
   type :: toml_node

      !> TOML value payload
      class(toml_value), allocatable :: val

   end type toml_node


   !> Initial storage capacity of the datastructure
   integer, parameter :: initial_size = 16


contains


!> Change size of the TOML value list
subroutine resize(list, n)

   !> Array of TOML values to be resized
   type(toml_node), allocatable, intent(inout), target :: list(:)

   !> New size of the list
   integer, intent(in) :: n

   type(toml_node), allocatable, target :: tmp(:)
   integer :: i


   if (allocated(list)) then
      call move_alloc(list, tmp)
      allocate(list(n))

      do i = 1, min(size(tmp), n)
         if (allocated(tmp(i)%val)) then
            call move_alloc(tmp(i)%val, list(i)%val)
         end if
      end do

      do i = n+1, size(tmp)
         if (allocated(tmp(i)%val)) then
            call tmp(i)%val%destroy
            deallocate(tmp(i)%val)
         end if
      end do

      deallocate(tmp)
   else
      allocate(list(n))
   end if

end subroutine resize

end module tomlf_structure_node

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_ncoord_gfn
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_cutoff, only : get_lattice_points
   use tblite_data_covrad, only : get_covalent_rad
   use tblite_ncoord_type, only : ncoord_type
   implicit none
   private

   public :: gfn_ncoord_type, new_gfn_ncoord
   public :: get_coordination_number

   type, extends(ncoord_type) :: gfn_ncoord_type
      real(wp) :: cutoff
      real(wp), allocatable :: rcov(:)
   contains
      procedure :: get_cn
   end type gfn_ncoord_type

   !> Steepness of first counting function
   real(wp),parameter :: ka = 10.0_wp
   !> Steepness of second counting function
   real(wp),parameter :: kb = 20.0_wp
   !> Offset of the second counting function
   real(wp),parameter :: r_shift = 2.0_wp

   real(wp), parameter :: default_cutoff = 25.0_wp


contains


subroutine new_gfn_ncoord(self, mol, cutoff, rcov)
   !> Coordination number container
   type(gfn_ncoord_type), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Real space cutoff
   real(wp), intent(in), optional :: cutoff
   !> Covalent radii
   real(wp), intent(in), optional :: rcov(:)

   if (present(cutoff)) then
      self%cutoff = cutoff
   else
      self%cutoff = default_cutoff
   end if

   allocate(self%rcov(mol%nid))
   if (present(rcov)) then
      self%rcov(:) = rcov
   else
      self%rcov(:) = get_covalent_rad(mol%num)
   end if
end subroutine new_gfn_ncoord


subroutine get_cn(self, mol, cn, dcndr, dcndL)
   !> Coordination number container
   class(gfn_ncoord_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Error function coordination number.
   real(wp), intent(out) :: cn(:)
   !> Derivative of the CN with respect to the Cartesian coordinates.
   real(wp), intent(out), optional :: dcndr(:, :, :)
   !> Derivative of the CN with respect to strain deformations.
   real(wp), intent(out), optional :: dcndL(:, :, :)

   real(wp), allocatable :: lattr(:, :)

   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff, lattr)
   call get_coordination_number(mol, lattr, self%cutoff, self%rcov, cn, dcndr, dcndL)
end subroutine get_cn


!> Geometric fractional coordination number, supports exponential counting functions.
subroutine get_coordination_number(mol, trans, cutoff, rcov, cn, dcndr, dcndL)

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Covalent radius
   real(wp), intent(in) :: rcov(:)

   !> Error function coordination number.
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates.
   real(wp), intent(out), optional :: dcndr(:, :, :)

   !> Derivative of the CN with respect to strain deformations.
   real(wp), intent(out), optional :: dcndL(:, :, :)

   if (present(dcndr) .and. present(dcndL)) then
      call ncoord_dexp(mol, trans, cutoff, rcov, cn, dcndr, dcndL)
   else
      call ncoord_exp(mol, trans, cutoff, rcov, cn)
   end if

end subroutine get_coordination_number


subroutine ncoord_exp(mol, trans, cutoff, rcov, cn)

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Covalent radius
   real(wp), intent(in) :: rcov(:)

   !> Error function coordination number.
   real(wp), intent(out) :: cn(:)

   integer :: iat, jat, izp, jzp, itr
   real(wp) :: r2, r1, rc, rij(3), countf, cutoff2

   cn(:) = 0.0_wp
   cutoff2 = cutoff**2

   !$omp parallel do schedule(runtime) default(none) reduction(+:cn) &
   !$omp shared(mol, trans, cutoff2, rcov) &
   !$omp private(jat, itr, izp, jzp, r2, rij, r1, rc, countf)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)

         do itr = 1, size(trans, dim=2)
            rij = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, itr))
            r2 = sum(rij**2)
            if (r2 > cutoff2 .or. r2 < 1.0e-12_wp) cycle
            r1 = sqrt(r2)

            rc = rcov(izp) + rcov(jzp)

            countf = exp_count(ka, r1, rc) * exp_count(kb, r1, rc + r_shift)

            cn(iat) = cn(iat) + countf
            if (iat /= jat) then
               cn(jat) = cn(jat) + countf
            end if

         end do
      end do
   end do

end subroutine ncoord_exp


subroutine ncoord_dexp(mol, trans, cutoff, rcov, cn, dcndr, dcndL)

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Covalent radius
   real(wp), intent(in) :: rcov(:)

   !> Error function coordination number.
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates.
   real(wp), intent(out) :: dcndr(:, :, :)

   !> Derivative of the CN with respect to strain deformations.
   real(wp), intent(out) :: dcndL(:, :, :)

   integer :: iat, jat, izp, jzp, itr
   real(wp) :: r2, r1, rc, rij(3), countf, countd(3), sigma(3, 3), cutoff2

   cn(:) = 0.0_wp
   dcndr(:, :, :) = 0.0_wp
   dcndL(:, :, :) = 0.0_wp
   cutoff2 = cutoff**2

   !$omp parallel do schedule(runtime) default(none) &
   !$omp reduction(+:cn, dcndr, dcndL) shared(mol, trans, cutoff2, rcov) &
   !$omp private(jat, itr, izp, jzp, r2, rij, r1, rc, countf, countd, sigma)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)

         do itr = 1, size(trans, dim=2)
            rij = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, itr))
            r2 = sum(rij**2)
            if (r2 > cutoff2 .or. r2 < 1.0e-12_wp) cycle
            r1 = sqrt(r2)

            rc = rcov(izp) + rcov(jzp)

            countf = exp_count(ka, r1, rc) * exp_count(kb, r1, rc + r_shift)
            countd = (dexp_count(ka, r1, rc) * exp_count(kb, r1, rc + r_shift) &
               & + exp_count(ka, r1, rc) * dexp_count(kb, r1, rc + r_shift)) * rij/r1

            cn(iat) = cn(iat) + countf
            if (iat /= jat) then
               cn(jat) = cn(jat) + countf
            end if

            dcndr(:, iat, iat) = dcndr(:, iat, iat) + countd
            dcndr(:, jat, jat) = dcndr(:, jat, jat) - countd
            dcndr(:, iat, jat) = dcndr(:, iat, jat) + countd
            dcndr(:, jat, iat) = dcndr(:, jat, iat) - countd

            sigma = spread(countd, 1, 3) * spread(rij, 2, 3)

            dcndL(:, :, iat) = dcndL(:, :, iat) + sigma
            if (iat /= jat) then
               dcndL(:, :, jat) = dcndL(:, :, jat) + sigma
            end if

         end do
      end do
   end do

end subroutine ncoord_dexp


!> Exponential counting function for coordination number contributions.
elemental function exp_count(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count

   count =1.0_wp/(1.0_wp+exp(-k*(r0/r-1.0_wp)))

end function exp_count


!> Derivative of the counting function w.r.t. the distance.
elemental function dexp_count(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count
   real(wp) :: expterm

   expterm = exp(-k*(r0/r-1._wp))

   count = (-k*r0*expterm)/(r**2*((expterm+1._wp)**2))

end function dexp_count


end module tblite_ncoord_gfn

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Anisotropic second-order electrostatics using a damped multipole expansion
module tblite_coulomb_multipole
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_math, only : matdet_3x3, matinv_3x3
   use mctc_io_constants, only : pi
   use tblite_blas, only : dot, gemv, symv, gemm
   use tblite_container_cache, only : container_cache
   use tblite_coulomb_cache, only : coulomb_cache
   use tblite_coulomb_ewald, only : get_dir_cutoff, get_rec_cutoff
   use tblite_coulomb_type, only : coulomb_type
   use tblite_cutoff, only : get_lattice_points
   use tblite_ncoord_gfn, only : gfn_ncoord_type, new_gfn_ncoord
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_wignerseitz, only : wignerseitz_cell
   implicit none
   private

   public :: damped_multipole, new_damped_multipole


   !> Container to handle multipole electrostatics
   type, extends(coulomb_type) :: damped_multipole
      !> Damping function for inverse quadratic contributions
      real(wp) :: kdmp3 = 0.0_wp
      !> Damping function for inverse cubic contributions
      real(wp) :: kdmp5 = 0.0_wp
      !> Kernel for on-site dipole exchange-correlation
      real(wp), allocatable :: dkernel(:)
      !> Kernel for on-site quadrupolar exchange-correlation
      real(wp), allocatable :: qkernel(:)

      !> Shift for the generation of the multipolar damping radii
      real(wp) :: shift = 0.0_wp
      !> Exponent for the generation of the multipolar damping radii
      real(wp) :: kexp = 0.0_wp
      !> Maximum radius for the multipolar damping radii
      real(wp) :: rmax = 0.0_wp
      !> Base radii for the multipolar damping radii
      real(wp), allocatable :: rad(:)
      !> Valence coordination number
      real(wp), allocatable :: valence_cn(:)

      !> Coordination number container for multipolar damping radii
      type(gfn_ncoord_type), allocatable :: ncoord
   contains
      !> Update cache from container
      procedure :: update
      !> Return dependency on density
      procedure :: variable_info
      !> Get anisotropic electrostatic energy
      procedure :: get_energy
      !> Get anisotropic electrostatic potential
      procedure :: get_potential
      !> Get derivatives of anisotropic electrostatics
      procedure :: get_gradient
   end type damped_multipole

   real(wp), parameter :: unity(3, 3) = reshape([1, 0, 0, 0, 1, 0, 0, 0, 1], [3, 3])
   real(wp), parameter :: twopi = 2 * pi
   real(wp), parameter :: sqrtpi = sqrt(pi)
   real(wp), parameter :: eps = sqrt(epsilon(0.0_wp))
   real(wp), parameter :: conv = 100*eps
   character(len=*), parameter :: label = "anisotropic electrostatics"

contains


!> Create a new anisotropic electrostatics container
subroutine new_damped_multipole(self, mol, kdmp3, kdmp5, dkernel, qkernel, &
      & shift, kexp, rmax, rad, vcn)
   !> Instance of the multipole container
   type(damped_multipole), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Damping function for inverse quadratic contributions
   real(wp), intent(in) :: kdmp3
   !> Damping function for inverse cubic contributions
   real(wp), intent(in) :: kdmp5
   !> Kernel for on-site dipole exchange-correlation
   real(wp), intent(in) :: dkernel(:)
   !> Kernel for on-site quadrupolar exchange-correlation
   real(wp), intent(in) :: qkernel(:)
   !> Shift for the generation of the multipolar damping radii
   real(wp), intent(in) :: shift
   !> Exponent for the generation of the multipolar damping radii
   real(wp), intent(in) :: kexp
   !> Maximum radius for the multipolar damping radii
   real(wp), intent(in) :: rmax
   !> Base radii for the multipolar damping radii
   real(wp), intent(in) :: rad(:)
   !> Valence coordination number
   real(wp), intent(in) :: vcn(:)

   self%label = label
   self%kdmp3 = kdmp3
   self%kdmp5 = kdmp5
   self%dkernel = dkernel
   self%qkernel = qkernel

   self%shift = shift
   self%kexp = kexp
   self%rmax = rmax
   self%rad = rad
   self%valence_cn = vcn

   allocate(self%ncoord)
   call new_gfn_ncoord(self%ncoord, mol)
end subroutine new_damped_multipole


!> Update cache from container
subroutine update(self, mol, cache)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   type(coulomb_cache), pointer :: ptr

   call taint(cache, ptr)

   if (.not.allocated(ptr%mrad)) then
      allocate(ptr%mrad(mol%nat))
   end if
   if (.not.allocated(ptr%dmrdcn)) then
      allocate(ptr%dmrdcn(mol%nat))
   end if

   if (.not.allocated(ptr%amat_sd)) then
      allocate(ptr%amat_sd(3, mol%nat, mol%nat))
   end if
   if (.not.allocated(ptr%amat_dd)) then
      allocate(ptr%amat_dd(3, mol%nat, 3, mol%nat))
   end if
   if (.not.allocated(ptr%amat_sq)) then
      allocate(ptr%amat_sq(6, mol%nat, mol%nat))
   end if

   if (.not.allocated(ptr%cn)) then
      allocate(ptr%cn(mol%nat))
   end if
   if (.not.allocated(ptr%dcndr)) then
      allocate(ptr%dcndr(3, mol%nat, mol%nat))
   end if
   if (.not.allocated(ptr%dcndL)) then
      allocate(ptr%dcndL(3, 3, mol%nat))
   end if

   if (allocated(self%ncoord)) then
      call self%ncoord%get_cn(mol, ptr%cn, ptr%dcndr, ptr%dcndL)
   else
      ptr%cn(:) = self%valence_cn(mol%id)
      ptr%dcndr(:, :, :) = 0.0_wp
      ptr%dcndL(:, :, :) = 0.0_wp
   end if

   call get_mrad(mol, self%shift, self%kexp, self%rmax, self%rad, self%valence_cn, &
      & ptr%cn, ptr%mrad, ptr%dmrdcn)

   call get_multipole_matrix(self, mol, ptr, ptr%amat_sd, ptr%amat_dd, ptr%amat_sq)
end subroutine update


!> Get anisotropic electrostatic energy
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   real(wp), allocatable :: vs(:), vd(:, :), vq(:, :)
   type(coulomb_cache), pointer :: ptr

   call view(cache, ptr)

   allocate(vs(mol%nat), vd(3, mol%nat), vq(6, mol%nat))

   call gemv(ptr%amat_sd, wfn%qat(:, 1), vd)
   call gemv(ptr%amat_dd, wfn%dpat(:, :, 1), vd, beta=1.0_wp, alpha=0.5_wp)
   call gemv(ptr%amat_sq, wfn%qat(:, 1), vq)

   energies(:) = energies + sum(wfn%dpat(:, :, 1) * vd, 1) + sum(wfn%qpat(:, :, 1) * vq, 1)

   call get_kernel_energy(mol, self%dkernel, wfn%dpat(:, :, 1), energies)
   call get_kernel_energy(mol, self%qkernel, wfn%qpat(:, :, 1), energies)
end subroutine get_energy

!> Get multipolar anisotropic exchange-correlation kernel
subroutine get_kernel_energy(mol, kernel, mpat, energies)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Multipole kernel
   real(wp), intent(in) :: kernel(:)
   !> Atomic multipole momemnt
   real(wp), intent(in) :: mpat(:, :)
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)

   integer :: iat, izp
   real(wp) :: mpt(size(mpat, 1)), mpscale(size(mpat, 1))

   mpscale(:) = 1
   if (size(mpat, 1) == 6) mpscale([2, 4, 5]) = 2

   do iat = 1, mol%nat
      izp = mol%id(iat)
      mpt(:) = mpat(:, iat) * mpscale
      energies(iat) = energies(iat) + kernel(izp) * dot_product(mpt, mpat(:, iat))
   end do
end subroutine get_kernel_energy


!> Get anisotropic electrostatic potential
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   type(coulomb_cache), pointer :: ptr

   call view(cache, ptr)

   call gemv(ptr%amat_sd, wfn%qat(:, 1), pot%vdp(:, :, 1), beta=1.0_wp)
   call gemv(ptr%amat_sd, wfn%dpat(:, :, 1), pot%vat(:, 1), beta=1.0_wp, trans="T")

   call gemv(ptr%amat_dd, wfn%dpat(:, :, 1), pot%vdp(:, :, 1), beta=1.0_wp)

   call gemv(ptr%amat_sq, wfn%qat(:, 1), pot%vqp(:, :, 1), beta=1.0_wp)
   call gemv(ptr%amat_sq, wfn%qpat(:, :, 1), pot%vat(:, 1), beta=1.0_wp, trans="T")

   call get_kernel_potential(mol, self%dkernel, wfn%dpat(:, :, 1), pot%vdp(:, :, 1))
   call get_kernel_potential(mol, self%qkernel, wfn%qpat(:, :, 1), pot%vqp(:, :, 1))
end subroutine get_potential

!> Get multipolar anisotropic potential contribution
subroutine get_kernel_potential(mol, kernel, mpat, vm)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Multipole kernel
   real(wp), intent(in) :: kernel(:)
   !> Atomic multipole momemnt
   real(wp), intent(in) :: mpat(:, :)
   !> Potential shoft on atomic multipole moment
   real(wp), intent(inout) :: vm(:, :)

   integer :: iat, izp
   real(wp) :: mpscale(size(mpat, 1))

   mpscale(:) = 1
   if (size(mpat, 1) == 6) mpscale([2, 4, 5]) = 2

   do iat = 1, mol%nat
      izp = mol%id(iat)
      vm(:, iat) = vm(:, iat) + 2*kernel(izp) * mpat(:, iat) * mpscale
   end do
end subroutine get_kernel_potential


!> Get derivatives of anisotropic electrostatics
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the repulsion energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   real(wp), allocatable :: dEdr(:)
   type(coulomb_cache), pointer :: ptr

   call view(cache, ptr)

   allocate(dEdr(mol%nat))
   dEdr = 0.0_wp

   call get_multipole_gradient(self, mol, ptr, &
      & wfn%qat(:, 1), wfn%dpat(:, :, 1), wfn%qpat(:, :, 1), &
      & dEdr, gradient, sigma)

   dEdr(:) = dEdr * ptr%dmrdcn

   call gemv(ptr%dcndr, dEdr, gradient, beta=1.0_wp)
   call gemv(ptr%dcndL, dEdr, sigma, beta=1.0_wp)
end subroutine get_gradient


!> Calculate multipole damping radii
subroutine get_mrad(mol, shift, kexp, rmax, rad, valence_cn, cn, mrad, dmrdcn)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Shift for the generation of the multipolar damping radii
   real(wp), intent(in) :: shift
   !> Exponent for the generation of the multipolar damping radii
   real(wp), intent(in) :: kexp
   !> Maximum radius for the multipolar damping radii
   real(wp), intent(in) :: rmax
   !> Base radii for the multipolar damping radii
   real(wp), intent(in) :: rad(:)
   !> Valence coordination number
   real(wp), intent(in) :: valence_cn(:)
   !> Coordination numbers for all atoms
   real(wp), intent(in) :: cn(:)
   !> Multipole damping radii for all atoms
   real(wp), intent(out) :: mrad(:)
   !> Derivative of multipole damping radii with repect to the coordination numbers
   real(wp), intent(out) :: dmrdcn(:)

   integer :: iat, izp
   real(wp) :: arg, t1, t2

   do iat = 1, mol%nat
      izp = mol%id(iat)
      arg = cn(iat) - valence_cn(izp) - shift
      t1 = exp(-kexp*arg)
      t2 = (rmax - rad(izp)) / (1.0_wp + t1)
      mrad(iat) = rad(izp) + t2
      dmrdcn(iat) = -t2 * kexp * t1 / (1.0_wp + t1)
   end do
end subroutine get_mrad


!> Get real lattice vectors
subroutine get_dir_trans(lattice, alpha, conv, trans)
   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)
   !> Parameter for Ewald summation
   real(wp), intent(in) :: alpha
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Translation vectors
   real(wp), allocatable, intent(out) :: trans(:, :)

   call get_lattice_points([.true.], lattice, get_dir_cutoff(alpha, conv), trans)

end subroutine get_dir_trans

!> Get reciprocal lattice translations
subroutine get_rec_trans(lattice, alpha, volume, conv, trans)
   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)
   !> Parameter for Ewald summation
   real(wp), intent(in) :: alpha
   !> Cell volume
   real(wp), intent(in) :: volume
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Translation vectors
   real(wp), allocatable, intent(out) :: trans(:, :)

   real(wp) :: rec_lat(3, 3)

   rec_lat = twopi*transpose(matinv_3x3(lattice))
   call get_lattice_points([.true.], rec_lat, get_rec_cutoff(alpha, volume, conv), trans)
   trans = trans(:, 2:)

end subroutine get_rec_trans


!> Get interaction matrix for all multipole moments up to inverse cubic order
subroutine get_multipole_matrix(self, mol, cache, amat_sd, amat_dd, amat_sq)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(coulomb_cache), intent(inout) :: cache
   !> Interation matrix for charges and dipoles
   real(wp), intent(inout) :: amat_sd(:, :, :)
   !> Interation matrix for dipoles and dipoles
   real(wp), intent(inout) :: amat_dd(:, :, :, :)
   !> Interation matrix for charges and quadrupoles
   real(wp), intent(inout) :: amat_sq(:, :, :)

   amat_sd(:, :, :) = 0.0_wp
   amat_dd(:, :, :, :) = 0.0_wp
   amat_sq(:, :, :) = 0.0_wp
   if (any(mol%periodic)) then
      call get_multipole_matrix_3d(mol, cache%mrad, self%kdmp3, self%kdmp5, &
         & cache%wsc, cache%alpha, amat_sd, amat_dd, amat_sq)
   else
      call get_multipole_matrix_0d(mol, cache%mrad, self%kdmp3, self%kdmp5, &
         & amat_sd, amat_dd, amat_sq)
   end if
end subroutine get_multipole_matrix

!> Calculate the multipole interaction matrix for finite systems
subroutine get_multipole_matrix_0d(mol, rad, kdmp3, kdmp5, amat_sd, amat_dd, amat_sq)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Multipole damping radii for all atoms
   real(wp), intent(in) :: rad(:)
   !> Damping function for inverse quadratic contributions
   real(wp), intent(in) :: kdmp3
   !> Damping function for inverse cubic contributions
   real(wp), intent(in) :: kdmp5
   !> Interation matrix for charges and dipoles
   real(wp), intent(inout) :: amat_sd(:, :, :)
   !> Interation matrix for dipoles and dipoles
   real(wp), intent(inout) :: amat_dd(:, :, :, :)
   !> Interation matrix for charges and quadrupoles
   real(wp), intent(inout) :: amat_sq(:, :, :)

   integer :: iat, jat
   real(wp) :: r1, vec(3), g1, g3, g5, fdmp3, fdmp5, tc(6), rr

   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(amat_sd, amat_dd, amat_sq, mol, rad, kdmp3, kdmp5) &
   !$omp private(r1, vec, g1, g3, g5, fdmp3, fdmp5, tc, rr)
   do iat = 1, mol%nat
      do jat = 1, mol%nat
         if (iat == jat) cycle
         vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat)
         r1 = norm2(vec)
         g1 = 1.0_wp / r1
         g3 = g1 * g1 * g1
         g5 = g3 * g1 * g1

         rr = 0.5_wp * (rad(jat) + rad(iat)) * g1
         fdmp3 = 1.0_wp / (1.0_wp + 6.0_wp * rr**kdmp3)
         fdmp5 = 1.0_wp / (1.0_wp + 6.0_wp * rr**kdmp5)

         amat_sd(:, jat, iat) = amat_sd(:, jat, iat) + vec * g3 * fdmp3
         amat_dd(:, jat, :, iat) = amat_dd(:, jat, :, iat) &
            & + unity * g3*fdmp5 - spread(vec, 1, 3) * spread(vec, 2, 3) * 3*g5*fdmp5
         tc(2) = 2*vec(1)*vec(2)*g5*fdmp5
         tc(4) = 2*vec(1)*vec(3)*g5*fdmp5
         tc(5) = 2*vec(2)*vec(3)*g5*fdmp5
         tc(1) = vec(1)*vec(1)*g5*fdmp5
         tc(3) = vec(2)*vec(2)*g5*fdmp5
         tc(6) = vec(3)*vec(3)*g5*fdmp5
         amat_sq(:, jat, iat) = amat_sq(:, jat, iat) + tc
      end do
   end do
end subroutine get_multipole_matrix_0d

!> Evaluate multipole interaction matrix under 3D periodic boundary conditions
subroutine get_multipole_matrix_3d(mol, rad, kdmp3, kdmp5, wsc, alpha, &
      & amat_sd, amat_dd, amat_sq)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Multipole damping radii for all atoms
   real(wp), intent(in) :: rad(:)
   !> Damping function for inverse quadratic contributions
   real(wp), intent(in) :: kdmp3
   !> Damping function for inverse cubic contributions
   real(wp), intent(in) :: kdmp5
   !> Wigner-Seitz cell images
   type(wignerseitz_cell), intent(in) :: wsc
   !> Convergence parameter for Ewald sum
   real(wp), intent(in) :: alpha
   !> Interation matrix for charges and dipoles
   real(wp), intent(inout) :: amat_sd(:, :, :)
   !> Interation matrix for dipoles and dipoles
   real(wp), intent(inout) :: amat_dd(:, :, :, :)
   !> Interation matrix for charges and quadrupoles
   real(wp), intent(inout) :: amat_sq(:, :, :)

   integer :: iat, jat, img, k
   real(wp) :: vec(3), rr, wsw, vol
   real(wp) :: d_sd(3), d_dd(3, 3), d_sq(6), r_sd(3), r_dd(3, 3), r_sq(6)
   real(wp), allocatable :: dtrans(:, :), rtrans(:, :)

   vol = abs(matdet_3x3(mol%lattice))
   call get_dir_trans(mol%lattice, alpha, conv, dtrans)
   call get_rec_trans(mol%lattice, alpha, vol, conv, rtrans)

   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(amat_sd, amat_dd, amat_sq) &
   !$omp shared(mol, wsc, rad, vol, alpha, rtrans, dtrans, kdmp3, kdmp5) &
   !$omp private(iat, jat, img, vec, rr, wsw, d_sd, d_dd, d_sq, r_sd, r_dd, r_sq)
   do iat = 1, mol%nat
      do jat = 1, mol%nat
         wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, iat) - mol%xyz(:, jat) - wsc%trans(:, wsc%tridx(img, jat, iat))

            rr = 0.5_wp * (rad(jat) + rad(iat))
            call get_amat_sdq_rec_3d(vec, vol, alpha, rtrans, r_sd, r_dd, r_sq)
            call get_amat_sdq_dir_3d(vec, rr, kdmp3, kdmp5, alpha, dtrans, d_sd, d_dd, d_sq)

            amat_sd(:, jat, iat) = amat_sd(:, jat, iat) + wsw * (d_sd + r_sd)
            amat_dd(:, jat, :, iat) = amat_dd(:, jat, :, iat) + wsw * (r_dd + d_dd)
            amat_sq(:, jat, iat) = amat_sq(:, jat, iat) + wsw * (r_sq + d_sq)
         end do
      end do
   end do

   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(amat_sd, amat_dd, amat_sq, mol, vol, alpha) private(iat, rr, k)
   do iat = 1, mol%nat
      ! dipole-dipole selfenergy: -2/3·α³/sqrt(π) Σ(i) μ²(i)
      rr = -2.0_wp/3.0_wp * alpha**3 / sqrtpi
      do k = 1, 3
         amat_dd(k, iat, k, iat) = amat_dd(k, iat, k, iat) + 2*rr
      end do

      ! charge-quadrupole selfenergy: 4/9·α³/sqrt(π) Σ(i) q(i)Tr(θi)
      ! (no actual contribution since quadrupoles are traceless)
      rr = 4.0_wp/9.0_wp * alpha**3 / sqrtpi
      amat_sq([1, 3, 6], iat, iat) = amat_sq([1, 3, 6], iat, iat) + rr
   end do
end subroutine get_multipole_matrix_3d

pure subroutine get_amat_sdq_rec_3d(rij, vol, alp, trans, amat_sd, amat_dd, amat_sq)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: vol
   real(wp), intent(in) :: alp
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(out) :: amat_sd(:)
   real(wp), intent(out) :: amat_dd(:, :)
   real(wp), intent(out) :: amat_sq(:)

   integer :: itr
   real(wp) :: fac, vec(3), g2, expk, sink, cosk, gv

   amat_sd = 0.0_wp
   amat_dd = 0.0_wp
   amat_sq = 0.0_wp
   fac = 4*pi/vol

   amat_dd(1, 1) = fac/6.0_wp
   amat_dd(2, 2) = fac/6.0_wp
   amat_dd(3, 3) = fac/6.0_wp
   amat_sq([1, 3, 6]) = -fac/9.0_wp

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      gv = dot_product(rij, vec)
      expk = fac*exp(-0.25_wp*g2/(alp*alp))/g2
      sink = sin(gv)*expk
      cosk = cos(gv)*expk

      amat_sd(:) = amat_sd + 2*vec*sink
      amat_dd(:, :) = amat_dd + spread(vec, 1, 3) * spread(vec, 2, 3) * cosk
      amat_sq(1) = amat_sq(1) +   vec(1)*vec(1)*cosk
      amat_sq(2) = amat_sq(2) + 2*vec(1)*vec(2)*cosk
      amat_sq(3) = amat_sq(3) +   vec(2)*vec(2)*cosk
      amat_sq(4) = amat_sq(4) + 2*vec(1)*vec(3)*cosk
      amat_sq(5) = amat_sq(5) + 2*vec(2)*vec(3)*cosk
      amat_sq(6) = amat_sq(6) +   vec(3)*vec(3)*cosk
   end do

end subroutine get_amat_sdq_rec_3d

pure subroutine get_amat_sdq_dir_3d(rij, rr, kdmp3, kdmp5, alp, trans, &
      & amat_sd, amat_dd, amat_sq)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: rr
   real(wp), intent(in) :: kdmp3
   real(wp), intent(in) :: kdmp5
   real(wp), intent(in) :: alp
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(out) :: amat_sd(:)
   real(wp), intent(out) :: amat_dd(:, :)
   real(wp), intent(out) :: amat_sq(:)

   integer :: itr
   real(wp) :: vec(3), r1, tmp, fdmp3, fdmp5, g1, g3, g5, arg, arg2, alp2, e1, e2, erft, expt

   amat_sd = 0.0_wp
   amat_dd = 0.0_wp
   amat_sq = 0.0_wp
   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      g1 = 1.0_wp/r1
      g3 = g1 * g1 * g1
      g5 = g3 * g1 * g1
      fdmp3 = 1.0_wp / (1.0_wp + 6.0_wp * (rr/r1)**kdmp3)
      fdmp5 = 1.0_wp / (1.0_wp + 6.0_wp * (rr/r1)**kdmp5)

      arg = r1*alp
      arg2 = arg*arg
      expt = exp(-arg2)/sqrtpi
      erft = -erf(arg)*g1
      e1 = g1*g1 * (erft + 2*expt*alp)
      e2 = g1*g1 * (e1 + 4*expt*alp2*alp/3)

      tmp = fdmp3 * g3 + e1
      amat_sd = amat_sd + vec * tmp
      amat_dd(:, :) = amat_dd(:, :) + unity * (fdmp5*g3 + e1) &
         & - spread(vec, 1, 3) * spread(vec, 2, 3) * (3 * (g5*fdmp5 + e2))
      amat_sq(1) = amat_sq(1) +   vec(1)*vec(1)*(g5*fdmp5 + e2) - (fdmp5*g3 + e1)/3.0_wp
      amat_sq(2) = amat_sq(2) + 2*vec(1)*vec(2)*(g5*fdmp5 + e2)
      amat_sq(3) = amat_sq(3) +   vec(2)*vec(2)*(g5*fdmp5 + e2) - (fdmp5*g3 + e1)/3.0_wp
      amat_sq(4) = amat_sq(4) + 2*vec(1)*vec(3)*(g5*fdmp5 + e2)
      amat_sq(5) = amat_sq(5) + 2*vec(2)*vec(3)*(g5*fdmp5 + e2)
      amat_sq(6) = amat_sq(6) +   vec(3)*vec(3)*(g5*fdmp5 + e2) - (fdmp5*g3 + e1)/3.0_wp
   end do

end subroutine get_amat_sdq_dir_3d


!> Calculate derivatives of multipole interactions
subroutine get_multipole_gradient(self, mol, cache, qat, dpat, qpat, dEdr, gradient, sigma)
   !> Instance of the multipole container
   class(damped_multipole), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(coulomb_cache), intent(inout) :: cache
   !> Atomic partial charges
   real(wp), contiguous, intent(in) :: qat(:)
   !> Atomic dipole moments
   real(wp), contiguous, intent(in) :: dpat(:, :)
   !> Atomic quadrupole moments
   real(wp), contiguous, intent(in) :: qpat(:, :)
   !> Derivative of the energy w.r.t. the critical radii
   real(wp), contiguous, intent(inout) :: dEdr(:)
   !> Derivative of the energy w.r.t. atomic displacements
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Derivative of the energy w.r.t. strain deformations
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   if (any(mol%periodic)) then
      call get_multipole_gradient_3d(mol, cache%mrad, self%kdmp3, self%kdmp5, &
         & qat, dpat, qpat, cache%wsc, cache%alpha, dEdr, gradient, sigma)
   else
      call get_multipole_gradient_0d(mol, cache%mrad, self%kdmp3, self%kdmp5, &
         & qat, dpat, qpat, dEdr, gradient, sigma)
   end if
end subroutine get_multipole_gradient

!> Evaluate multipole derivatives for finite systems
subroutine get_multipole_gradient_0d(mol, rad, kdmp3, kdmp5, qat, dpat, qpat, &
      & dEdr, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Multipole damping radii for all atoms
   real(wp), intent(in) :: rad(:)
   !> Damping function for inverse quadratic contributions
   real(wp), intent(in) :: kdmp3
   !> Damping function for inverse cubic contributions
   real(wp), intent(in) :: kdmp5
   !> Atomic partial charges
   real(wp), contiguous, intent(in) :: qat(:)
   !> Atomic dipole moments
   real(wp), contiguous, intent(in) :: dpat(:, :)
   !> Atomic quadrupole moments
   real(wp), contiguous, intent(in) :: qpat(:, :)
   !> Derivative of the energy w.r.t. the critical radii
   real(wp), contiguous, intent(inout) :: dEdr(:)
   !> Derivative of the energy w.r.t. atomic displacements
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Derivative of the energy w.r.t. strain deformations
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   integer :: iat, jat
   real(wp) :: r1, r2, vec(3), rr, fdmp3, fdmp5, g1, g3, g5, g7, dG(3), dS(3, 3)
   real(wp) :: ddmp3, ddmp5, fddr, eq, edd, dpidpj, dpiv, dpjv, dpiqj, qidpj

   !$omp parallel do default(none) schedule(runtime) reduction(+:dEdr, gradient, sigma) &
   !$omp shared(mol, kdmp3, kdmp5, rad, qat, dpat, qpat) &
   !$omp private(iat, jat, r1, r2, vec, rr, fdmp3, fdmp5, g1, g3, g5, g7, dG, dS, &
   !$omp& ddmp3, ddmp5, fddr, eq, edd, dpidpj, dpiv, dpjv, dpiqj, qidpj)
   do iat = 1, mol%nat
      do jat = 1, iat - 1
         rr = 0.5_wp*(rad(iat)+rad(jat))
         vec(:) = mol%xyz(:, jat)-mol%xyz(:, iat)
         r1 = norm2(vec)
         r2 = r1 * r1
         g1 = 1.0_wp/r1
         g3 = g1 * g1 * g1
         g5 = g3 * g1 * g1
         g7 = g5 * g1 * g1

         fdmp3 = 1.0_wp/(1.0_wp+6.0_wp*(rr*g1)**kdmp3)
         ddmp3 = -3*g5*fdmp3 - kdmp3*fdmp3*(fdmp3-1.0_wp)*g5
         fdmp5 = 1.0_wp/(1.0_wp+6.0_wp*(rr*g1)**kdmp5)
         ddmp5 = -5*fdmp5 - kdmp5*(fdmp5*fdmp5-fdmp5)

         dpiqj = dot_product(vec, dpat(:, iat))*qat(jat)
         qidpj = dot_product(vec, dpat(:, jat))*qat(iat)
         fddr = 3.0_wp*(dpiqj - qidpj)*kdmp3*fdmp3*g3*(fdmp3/rr)*(rr*g1)**kdmp3
         dg(:) = - ddmp3*vec * (dpiqj - qidpj) &
            & + fdmp3*g3*(qat(iat)*dpat(:, jat) - qat(jat)*dpat(:, iat))
         ds(:, :) = - 0.5_wp * (spread(vec, 1, 3) * spread(dG, 2, 3) &
            & + spread(dG, 1, 3) * spread(vec, 2, 3))

         dEdr(iat) = dEdr(iat) + fddr
         dEdr(jat) = dEdr(jat) + fddr
         gradient(:, iat) = gradient(:, iat) + dG
         gradient(:, jat) = gradient(:, jat) - dG
         sigma(:, :) = sigma + dS

         dpidpj = dot_product(dpat(:, jat), dpat(:, iat))
         dpiv = dot_product(dpat(:, iat), vec)
         dpjv = dot_product(dpat(:, jat), vec)
         edd = dpidpj*r2 - 3*dpjv*dpiv
         fddr = 3.0_wp*edd*kdmp5*fdmp5*g5*(fdmp5/rr)*(rr*g1)**kdmp5
         dg(:) = - 2.0_wp*fdmp5*g5*dpidpj*vec &
            & + 3.0_wp*fdmp5*g5*(dpiv*dpat(:, jat) + dpjv*dpat(:, iat)) &
            & - edd*ddmp5*g7*vec
         ds(:, :) = - 0.5_wp * (spread(vec, 1, 3) * spread(dg, 2, 3) &
            & + spread(dg, 1, 3) * spread(vec, 2, 3))

         dEdr(iat) = dEdr(iat) + fddr
         dEdr(jat) = dEdr(jat) + fddr
         gradient(:, iat) = gradient(:, iat) + dg
         gradient(:, jat) = gradient(:, jat) - dg
         sigma(:, :) = sigma + ds

         eq = &
            & + 2*(qat(jat)*qpat(2,iat) + qpat(2,jat)*qat(iat))*vec(1)*vec(2) &
            & + 2*(qat(jat)*qpat(4,iat) + qpat(4,jat)*qat(iat))*vec(1)*vec(3) &
            & + 2*(qat(jat)*qpat(5,iat) + qpat(5,jat)*qat(iat))*vec(2)*vec(3) &
            & + (qat(jat)*qpat(1,iat) + qpat(1,jat)*qat(iat))*vec(1)*vec(1) &
            & + (qat(jat)*qpat(3,iat) + qpat(3,jat)*qat(iat))*vec(2)*vec(2) &
            & + (qat(jat)*qpat(6,iat) + qpat(6,jat)*qat(iat))*vec(3)*vec(3)

         fddr = eq * 3.0_wp*kdmp5*fdmp5*g5*fdmp5/rr*(rr*g1)**kdmp5
         dg(:) = - eq*ddmp5*g7*vec &
            & - 2.0_wp*fdmp5*g5*qat(iat) * &
            &[vec(1)*qpat(1,jat) + vec(2)*qpat(2,jat) + vec(3)*qpat(4,jat), &
            & vec(1)*qpat(2,jat) + vec(2)*qpat(3,jat) + vec(3)*qpat(5,jat), &
            & vec(1)*qpat(4,jat) + vec(2)*qpat(5,jat) + vec(3)*qpat(6,jat)] &
            & - 2.0_wp*fdmp5*g5*qat(jat) * &
            &[vec(1)*qpat(1,iat) + vec(2)*qpat(2,iat) + vec(3)*qpat(4,iat), &
            & vec(1)*qpat(2,iat) + vec(2)*qpat(3,iat) + vec(3)*qpat(5,iat), &
            & vec(1)*qpat(4,iat) + vec(2)*qpat(5,iat) + vec(3)*qpat(6,iat)]
         ds(:, :) = - 0.5_wp * (spread(vec, 1, 3) * spread(dG, 2, 3) &
            & + spread(dG, 1, 3) * spread(vec, 2, 3))

         dEdr(iat) = dEdr(iat) + fddr
         dEdr(jat) = dEdr(jat) + fddr
         gradient(:, iat) = gradient(:, iat) + dg
         gradient(:, jat) = gradient(:, jat) - dg
         sigma(:, :) = sigma + ds
      end do
   end do
end subroutine get_multipole_gradient_0d

!> Evaluate multipole derivatives under 3D periodic boundary conditions
subroutine get_multipole_gradient_3d(mol, rad, kdmp3, kdmp5, qat, dpat, qpat, wsc, alpha, &
      & dEdr, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Multipole damping radii for all atoms
   real(wp), intent(in) :: rad(:)
   !> Damping function for inverse quadratic contributions
   real(wp), intent(in) :: kdmp3
   !> Damping function for inverse cubic contributions
   real(wp), intent(in) :: kdmp5
   !> Atomic partial charges
   real(wp), contiguous, intent(in) :: qat(:)
   !> Atomic dipole moments
   real(wp), contiguous, intent(in) :: dpat(:, :)
   !> Atomic quadrupole moments
   real(wp), contiguous, intent(in) :: qpat(:, :)
   !> Wigner-Seitz cell images
   type(wignerseitz_cell), intent(in) :: wsc
   !> Convergence parameter for Ewald sum
   real(wp), intent(in) :: alpha
   !> Derivative of the energy w.r.t. the critical radii
   real(wp), contiguous, intent(inout) :: dEdr(:)
   !> Derivative of the energy w.r.t. atomic displacements
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Derivative of the energy w.r.t. strain deformations
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   integer :: iat, jat, img
   real(wp) :: vec(3), dG(3), dGr(3), dGd(3), dS(3, 3), dSr(3, 3), dSd(3, 3)
   real(wp) :: wsw, vol, rr, dE, dEd
   real(wp), allocatable :: dtrans(:, :), rtrans(:, :)

   vol = abs(matdet_3x3(mol%lattice))
   call get_dir_trans(mol%lattice, alpha, conv, dtrans)
   call get_rec_trans(mol%lattice, alpha, vol, conv, rtrans)

   !$omp parallel do default(none) schedule(runtime) reduction(+:dEdr, gradient, sigma) &
   !$omp shared(mol, wsc, kdmp3, kdmp5, vol, alpha, rtrans, dtrans, rad, qat, dpat, qpat) &
   !$omp private(iat, jat, dE, dG, dS, wsw, img, vec, rr, dEd, dGd, dGr, dSd, dSr)
   do iat = 1, mol%nat
      do jat = 1, iat - 1
         dE = 0.0_wp
         dG(:) = 0.0_wp
         dS(:, :) = 0.0_wp
         wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
         do img = 1, wsc%nimg(jat, iat)
            vec(:) = mol%xyz(:, jat)-mol%xyz(:, iat) + wsc%trans(:, wsc%tridx(img, jat, iat))
            rr = 0.5_wp * (rad(jat) + rad(iat))

            call get_damat_sdq_rec_3d(vec, qat(iat), qat(jat), dpat(:, iat), dpat(:, jat), &
               & qpat(:, iat), qpat(:, jat), vol, alpha, rtrans, dGr, dSr)
            call get_damat_sdq_dir_3d(vec, qat(iat), qat(jat), dpat(:, iat), dpat(:, jat), &
               & qpat(:, iat), qpat(:, jat), rr, kdmp3, kdmp5, alpha, dtrans, dEd, dGd, dSd)
            dE = dE + dEd * wsw
            dG = dG + (dGd + dGr) * wsw
            dS = dS + (dSd + dSr) * wsw
         end do
         dEdr(iat) = dEdr(iat) + dE
         dEdr(jat) = dEdr(jat) + dE
         gradient(:, iat) = gradient(:, iat) + dG
         gradient(:, jat) = gradient(:, jat) - dG
         sigma = sigma + dS
      end do
   end do

   !$omp parallel do default(none) schedule(runtime) reduction(+:dEdr, sigma) &
   !$omp shared(mol, wsc, kdmp3, kdmp5, vol, alpha, rtrans, dtrans, rad, qat, dpat, qpat) &
   !$omp private(iat, jat, dE, dG, dS, wsw, img, vec, rr, dEd, dGd, dGr, dSd, dSr)
   do iat = 1, mol%nat
      dE = 0.0_wp
      dS(:, :) = 0.0_wp
      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec(:) = wsc%trans(:, wsc%tridx(img, iat, iat))
         rr = rad(iat)

         call get_damat_sdq_rec_3d(vec, qat(iat), qat(iat), dpat(:, iat), dpat(:, iat), &
            & qpat(:, iat), qpat(:, iat), vol, alpha, rtrans, dGr, dSr)
         call get_damat_sdq_dir_3d(vec, qat(iat), qat(iat), dpat(:, iat), dpat(:, iat), &
            & qpat(:, iat), qpat(:, iat), rr, kdmp3, kdmp5, alpha, dtrans, dEd, dGd, dSd)
         dE = dE + dEd * wsw
         dS = dS + (dSd + dSr) * wsw
      end do
      dEdr(iat) = dEdr(iat) + dE
      sigma = sigma + 0.5_wp * dS
   end do
end subroutine get_multipole_gradient_3d

pure subroutine get_damat_sdq_rec_3d(rij, qi, qj, mi, mj, ti, tj, vol, alp, trans, dg, ds)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: qi, qj, mi(3), mj(3), ti(6), tj(6)
   real(wp), intent(in) :: vol
   real(wp), intent(in) :: alp
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(out) :: dg(3)
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr
   real(wp) :: fac, vec(3), g2, gv, expk, alp2, sink, cosk, dpiqj, qidpj
   real(wp) :: mikmjk, gtmp(3), qpiqj, qiqpj, dpiv, dpjv

   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp
   fac = 4*pi/vol
   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      gv = dot_product(rij, vec)
      expk = fac*exp(-0.25_wp*g2/alp2)/g2
      cosk = cos(gv)*expk
      sink = sin(gv)*expk

      dpiqj = dot_product(vec, mi)*qj
      qidpj = dot_product(vec, mj)*qi

      dg(:) = dg - 2*vec*cosk * (dpiqj - qidpj)
      ds(:, :) = ds + 2 * sink * (dpiqj - qidpj) &
         & * ((2.0_wp/g2 + 0.5_wp/alp2) * spread(vec, 1, 3)*spread(vec, 2, 3) - unity)

      dpiv = dot_product(mi, vec)
      dpjv = dot_product(mj, vec)

      dg(:) = dg + vec*sink*dpiv*dpjv
      ds(:, :) = ds + cosk * dpiv*dpjv &
         & * ((2.0_wp/g2 + 0.5_wp/alp2) * spread(vec, 1, 3)*spread(vec, 2, 3) - unity)

      qiqpj = qi*(tj(1)*vec(1)*vec(1) + tj(3)*vec(2)*vec(2) + tj(6)*vec(3)*vec(3) &
         & + 2*tj(2)*vec(1)*vec(2) + 2*tj(4)*vec(1)*vec(3) + 2*tj(5)*vec(2)*vec(3))
      qpiqj = qj*(ti(1)*vec(1)*vec(1) + ti(3)*vec(2)*vec(2) + ti(6)*vec(3)*vec(3) &
         & + 2*ti(2)*vec(1)*vec(2) + 2*ti(4)*vec(1)*vec(3) + 2*ti(5)*vec(2)*vec(3))

      dg(:) = dg + vec * sink * (qiqpj + qpiqj)
      ds(:, :) = ds + cosk * (qiqpj + qpiqj) &
         & * ((2.0_wp/g2 + 0.5_wp/alp2) * spread(vec, 1, 3)*spread(vec, 2, 3) - unity)
   end do

end subroutine get_damat_sdq_rec_3d

pure subroutine get_damat_sdq_dir_3d(rij, qi, qj, mi, mj, ti, tj, rr, kdmp3, kdmp5, &
      & alp, trans, de, dg, ds)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: qi, qj, mi(3), mj(3), ti(6), tj(6)
   real(wp), intent(in) :: rr
   real(wp), intent(in) :: kdmp3
   real(wp), intent(in) :: kdmp5
   real(wp), intent(in) :: alp
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(out) :: de
   real(wp), intent(out) :: dg(3)
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr, k
   real(wp) :: vec(3), r1, r2, g1, g3, g5, g7, fdmp3, fdmp5, ddmp3, ddmp5, dpiqj, qidpj
   real(wp) :: atmp, alp2, arg, arg2, erft, expt, e1, e2, e3, tabc(3, 3, 3), tab(3, 3)
   real(wp) :: dpidpj, dpiv, dpjv, edd, eq, g_sd(3), g_dd(3), g_sq(3)

   de = 0.0_wp
   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp

   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      r2 = r1 * r1
      g1 = 1.0_wp/r1
      g3 = g1 * g1 * g1
      g5 = g3 * g1 * g1
      g7 = g5 * g1 * g1

      arg = r1*alp
      arg2 = arg*arg
      erft = -erf(arg)*g1
      expt = exp(-arg2)/sqrtpi
      e1 = g1*g1 * (erft + expt*(2*alp2)/alp)
      e2 = g1*g1 * (e1 + expt*(2*alp2)**2/(3*alp))
      e3 = g1*g1 * (e2 + expt*(2*alp2)**3/(15*alp))

      fdmp3 = 1.0_wp/(1.0_wp+6.0_wp*(rr*g1)**kdmp3)
      ddmp3 = -3*fdmp3 - kdmp3*fdmp3*(fdmp3-1.0_wp)
      fdmp5 = 1.0_wp/(1.0_wp+6.0_wp*(rr*g1)**kdmp5)
      ddmp5 = -5*fdmp5 - kdmp5*(fdmp5*fdmp5-fdmp5)

      dpiqj = dot_product(vec, mi)*qj
      qidpj = dot_product(vec, mj)*qi
      dpidpj = dot_product(mj, mi)
      dpiv = dot_product(mi, vec)
      dpjv = dot_product(mj, vec)
      edd = dpidpj*r2 - 3*dpjv*dpiv

      ! Charge - dipole
      g_sd(:) = - (ddmp3*g5)*vec * (dpiqj - qidpj) + fdmp3*g3*(qi*mj - qj*mi)

      block
         integer :: a, b
         do b = 1, 3
            do a = 1, 3
               tab(a, b) = 3*vec(a)*vec(b)*e2
            end do
            tab(b, b) = tab(b, b) - e1
         end do
      end block

      do k = 1, 3
         g_sd(k) = g_sd(k) &
            & + qj * (tab(1, k) * mi(1) &
            &       + tab(2, k) * mi(2) &
            &       + tab(3, k) * mi(3))&
            & - qi * (tab(1, k) * mj(1) &
            &       + tab(2, k) * mj(2) &
            &       + tab(3, k) * mj(3))
      end do

      de = de + 3.0_wp*(dpiqj - qidpj)*kdmp3*fdmp3*g3*(fdmp3/rr)*(rr*g1)**kdmp3
      dg(:) = dg + g_sd
      ds(:, :) = - 0.5_wp * (spread(vec, 1, 3) * spread(g_sd, 2, 3) &
         & + spread(g_sd, 1, 3) * spread(vec, 2, 3))

      ! Dipole - dipole
      g_dd(:) = - 2.0_wp*fdmp5*g5*dpidpj*vec &
         & + 3.0_wp*fdmp5*g5*(dpiv*mj + dpjv*mi) &
         & - edd*ddmp5*g7*vec

      block
         integer :: a, b, c
         do c = 1, 3
            do b = 1, 3
               do a = 1, 3
                  tabc(a, b, c) = - 15*vec(a)*vec(b)*vec(c)*e3
               end do
            end do
            do a = 1, 3
               tabc(a, a, c) = tabc(a, a, c) + 3*e2*vec(c)
               tabc(c, a, c) = tabc(c, a, c) + 3*e2*vec(a)
               tabc(a, c, c) = tabc(a, c, c) + 3*e2*vec(a)
            end do
         end do
      end block

      do k = 1, 3
         g_dd(k) = g_dd(k) &
            & + mi(1)*(tabc(1, 1, k) * mj(1) &
            &        + tabc(2, 1, k) * mj(2) &
            &        + tabc(3, 1, k) * mj(3))&
            & + mi(2)*(tabc(1, 2, k) * mj(1) &
            &        + tabc(2, 2, k) * mj(2) &
            &        + tabc(3, 2, k) * mj(3))&
            & + mi(3)*(tabc(1, 3, k) * mj(1) &
            &        + tabc(2, 3, k) * mj(2) &
            &        + tabc(3, 3, k) * mj(3))
      end do

      de = de + 3.0_wp*edd*kdmp5*fdmp5*g5*(fdmp5/rr)*(rr*g1)**kdmp5
      dg(:) = dg + g_dd
      ds(:, :) = - 0.5_wp * (spread(vec, 1, 3) * spread(g_dd, 2, 3) &
         & + spread(g_dd, 1, 3) * spread(vec, 2, 3))

      ! Charge - quadrupole
      eq = &
         & + 2*(qj*ti(2) + tj(2)*qi)*vec(1)*vec(2) &
         & + 2*(qj*ti(4) + tj(4)*qi)*vec(1)*vec(3) &
         & + 2*(qj*ti(5) + tj(5)*qi)*vec(2)*vec(3) &
         & + (qj*ti(1) + tj(1)*qi)*vec(1)*vec(1) &
         & + (qj*ti(3) + tj(3)*qi)*vec(2)*vec(2) &
         & + (qj*ti(6) + tj(6)*qi)*vec(3)*vec(3)

      g_sq(:) = - eq*ddmp5*g7*vec &
         & - 2.0_wp*fdmp5*g5*qi * &
         &[vec(1)*tj(1) + vec(2)*tj(2) + vec(3)*tj(4), &
         & vec(1)*tj(2) + vec(2)*tj(3) + vec(3)*tj(5), &
         & vec(1)*tj(4) + vec(2)*tj(5) + vec(3)*tj(6)] &
         & - 2.0_wp*fdmp5*g5*qj * &
         &[vec(1)*ti(1) + vec(2)*ti(2) + vec(3)*ti(4), &
         & vec(1)*ti(2) + vec(2)*ti(3) + vec(3)*ti(5), &
         & vec(1)*ti(4) + vec(2)*ti(5) + vec(3)*ti(6)]

      do k = 1, 3
         g_sq(k) = g_sq(k) + (&
            & - qi * (tabc(1, 1, k) * tj(1) &
            &     + 2*tabc(2, 1, k) * tj(2) &
            &     + 2*tabc(3, 1, k) * tj(4) &
            &     +   tabc(2, 2, k) * tj(3) &
            &     + 2*tabc(3, 2, k) * tj(5) &
            &     +   tabc(3, 3, k) * tj(6))&
            & - qj * (tabc(1, 1, k) * ti(1) &
            &     + 2*tabc(2, 1, k) * ti(2) &
            &     + 2*tabc(3, 1, k) * ti(4) &
            &     +   tabc(2, 2, k) * ti(3) &
            &     + 2*tabc(3, 2, k) * ti(5) &
            &     +   tabc(3, 3, k) * ti(6)))/3.0_wp
      end do

      de = de + eq * 3.0_wp*kdmp5*fdmp5*g5*fdmp5/rr*(rr*g1)**kdmp5
      dg(:) = dg + g_sq
      ds(:, :) = ds - 0.5_wp * (spread(vec, 1, 3) * spread(g_sq, 2, 3) &
         & + spread(g_sq, 1, 3) * spread(vec, 2, 3))
   end do

end subroutine get_damat_sdq_dir_3d


!> Get information about density dependent quantities used in the energy
pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, atom_resolved
   !> Instance of the electrostatic container
   class(damped_multipole), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(dipole=atom_resolved, quadrupole=atom_resolved)
end function variable_info


!> Inspect container cache and reallocate it in case of type mismatch
subroutine taint(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(coulomb_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(coulomb_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

!> Return reference to container cache after resolving its type
subroutine view(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(coulomb_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(coulomb_cache)
      ptr => target
   end select
end subroutine view


end module tblite_coulomb_multipole

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_dispersion
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, &
      & test_failed
   use mctc_io, only : structure_type
   use mstore, only : get_structure
   use tblite_container, only : container_cache
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_disp, only : dispersion_type, new_d3_dispersion, &
      & new_d4_dispersion, new_d4s_dispersion, d3_dispersion, d4_dispersion
   implicit none
   private

   public :: collect_dispersion


   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

contains


!> Collect all exported unit tests
subroutine collect_dispersion(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("e-d3-mb01", test_e_d3_mb01), &
      new_unittest("e-d4-mb01", test_e_d4_mb01), &
      new_unittest("e-d4s-mb01", test_e_d4s_mb01), &
      new_unittest("e-d3-mb02", test_e_d3_mb02), &
      new_unittest("e-d4-mb02", test_e_d4_mb02), &
      new_unittest("e-d4s-mb02", test_e_d4s_mb02), &
      new_unittest("p-d4-mb03", test_p_d4_mb03), &
      new_unittest("p-d4s-mb03", test_p_d4s_mb03), &
      new_unittest("p-d4-mb04", test_p_d4_mb04), &
      new_unittest("p-d4s-mb04", test_p_d4s_mb04) &
      ]

end subroutine collect_dispersion



subroutine test_e(error, mol, disp, qat, ref)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Instance of dispersion type
   class(dispersion_type), intent(in) :: disp

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Reference energy
   real(wp), intent(in) :: ref

   type(wavefunction_type) :: wfn
   type(container_cache) :: cache
   real(wp) :: energies(mol%nat)

   energies = 0.0_wp
   wfn%qat = reshape(qat, [size(qat), 1])
   call disp%update(mol, cache)

   ! Get non-selfconsistent energy contribution
   call disp%get_engrad(mol, cache, energies)

   ! Get selfconsistent energy contribution
   call disp%get_energy(mol, cache, wfn, energies)

   if (abs(sum(energies) - ref) > thr) then
      call test_failed(error, "Energy does not match reference")
      print *, sum(energies)
   end if

end subroutine test_e


subroutine test_p(error, mol, disp, qat)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Instance of dispersion type
   class(dispersion_type), intent(in) :: disp

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp), allocatable :: vat(:)
   real(wp) :: er(mol%nat), el(mol%nat)
   integer :: ii

   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))
   call disp%update(mol, cache)

   allocate(vat(mol%nat), source=0.0_wp)
   do ii = 1, mol%nat
      er = 0.0_wp
      el = 0.0_wp
      wfn%qat(ii, 1) = wfn%qat(ii, 1) + step
      call disp%get_energy(mol, cache, wfn, er)

      wfn%qat(ii, 1) = wfn%qat(ii, 1) - 2*step
      call disp%get_energy(mol, cache, wfn, el)

      wfn%qat(ii, 1) = wfn%qat(ii, 1) + step
      vat(ii) = 0.5_wp*(sum(er) - sum(el))/step
   end do

   pot%vat(:, :) = 0.0_wp
   call disp%get_potential(mol, cache, wfn, pot)

   if (any(abs([pot%vat] - vat) > thr2)) then
      call test_failed(error, "Potential does not match")
      print '(3es20.13)', pot%vat
      print '(a)', "---"
      print '(3es20.13)', vat
      print '(a)', "---"
      print '(3es20.13)', [pot%vat] - vat
   end if
end subroutine test_p


subroutine test_e_d3_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(dispersion_type), allocatable :: disp
   type(d3_dispersion), allocatable :: d3

   real(wp), parameter :: qat(16) = [&
      & 4.07331798531438E+0_wp, 2.56451650429167E+0_wp, 2.97676954448882E+0_wp, &
      & 2.88833112759592E+0_wp, 2.59127476011008E+0_wp, 2.63750279425510E+0_wp, &
      & 3.56149571036025E+0_wp, 2.89090958281373E+0_wp, 4.53815592283277E+0_wp, &
      & 2.46342847720303E+0_wp, 2.72707461251522E+0_wp, 3.52933932564532E+0_wp, &
      & 3.66934919146868E+0_wp, 3.66697827876019E+0_wp, 3.37809284756764E+0_wp, &
      & 4.57932013403544E+0_wp]

   call get_structure(mol, "MB16-43", "01")

   ! PBE-D3-ATM
   allocate(d3)
   call new_d3_dispersion(d3, mol, s6=1.0_wp, s8=0.7875_wp, &
      & a1=0.4289_wp, a2=4.4407_wp, s9=1.0_wp, error=error)
   if(allocated(error)) then 
      call test_failed(error, "D3 model could not be created")
      return
   end if
   call move_alloc(d3, disp)

   call test_e(error, mol, disp, qat, -1.7817346201130551E-02_wp)

end subroutine test_e_d3_mb01

subroutine test_e_d4_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(dispersion_type), allocatable :: disp
   type(d4_dispersion), allocatable :: d4

   real(wp), parameter :: qat(16) = [&
      & 4.07331798531438E+0_wp, 2.56451650429167E+0_wp, 2.97676954448882E+0_wp, &
      & 2.88833112759592E+0_wp, 2.59127476011008E+0_wp, 2.63750279425510E+0_wp, &
      & 3.56149571036025E+0_wp, 2.89090958281373E+0_wp, 4.53815592283277E+0_wp, &
      & 2.46342847720303E+0_wp, 2.72707461251522E+0_wp, 3.52933932564532E+0_wp, &
      & 3.66934919146868E+0_wp, 3.66697827876019E+0_wp, 3.37809284756764E+0_wp, &
      & 4.57932013403544E+0_wp]

   call get_structure(mol, "MB16-43", "01")

   ! PBE-D4-ATM
   allocate(d4)
   call new_d4_dispersion(d4, mol, s6=1.0_wp, s8=0.95948085_wp, &
      & a1=0.38574991_wp, a2=4.80688534_wp, s9=1.0_wp, error=error)
   if(allocated(error)) then 
      call test_failed(error, "D4 model could not be created")
      return
   end if
   call move_alloc(d4, disp)

   call test_e(error, mol, disp, qat, -2.1345348473924487E-03_wp)

end subroutine test_e_d4_mb01

subroutine test_e_d4s_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(dispersion_type), allocatable :: disp
   type(d4_dispersion), allocatable :: d4s

   real(wp), parameter :: qat(16) = [&
      & 4.07331798531438E+0_wp, 2.56451650429167E+0_wp, 2.97676954448882E+0_wp, &
      & 2.88833112759592E+0_wp, 2.59127476011008E+0_wp, 2.63750279425510E+0_wp, &
      & 3.56149571036025E+0_wp, 2.89090958281373E+0_wp, 4.53815592283277E+0_wp, &
      & 2.46342847720303E+0_wp, 2.72707461251522E+0_wp, 3.52933932564532E+0_wp, &
      & 3.66934919146868E+0_wp, 3.66697827876019E+0_wp, 3.37809284756764E+0_wp, &
      & 4.57932013403544E+0_wp]

   call get_structure(mol, "MB16-43", "01")

   ! PBE-D4S-ATM
   allocate(d4s)
   call new_d4s_dispersion(d4s, mol, s6=1.0_wp, s8=0.95948085_wp, &
      & a1=0.38574991_wp, a2=4.80688534_wp, s9=1.0_wp, error=error)
   if(allocated(error)) then 
      call test_failed(error, "D4 model could not be created")
      return
   end if
   call move_alloc(d4s, disp)

   call test_e(error, mol, disp, qat, -2.5035710126985792E-03_wp)

end subroutine test_e_d4s_mb01

subroutine test_e_d3_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(dispersion_type), allocatable :: disp
   type(d3_dispersion), allocatable :: d3

   real(wp), parameter :: qat(16) = [&
      & 3.43501192886252E+0_wp, 5.02404916999371E+0_wp, 4.72253865039692E+0_wp, &
      & 3.52096661104217E+0_wp, 4.76023330956437E+0_wp, 3.46119195863261E+0_wp, &
      & 3.17361370475619E+0_wp, 2.90775065608382E+0_wp, 4.94595287355805E+0_wp, &
      & 3.32592657749444E+0_wp, 4.54348353409109E+0_wp, 4.30924297002105E+0_wp, &
      & 3.47420343563851E+0_wp, 2.82302349370343E+0_wp, 6.67552064739394E+0_wp, &
      & 4.23898159491675E+0_wp]

   call get_structure(mol, "MB16-43", "02")

   ! PBE-D3-ATM
   allocate(d3)
   call new_d3_dispersion(d3, mol, s6=1.0_wp, s8=0.7875_wp, &
      & a1=0.4289_wp, a2=4.4407_wp, s9=1.0_wp, error=error)
   if(allocated(error)) then 
      call test_failed(error, "D3 model could not be created")
      return
   end if
   call move_alloc(d3, disp)

   call test_e(error, mol, disp, qat, -2.4863195815287387E-02_wp)

end subroutine test_e_d3_mb02

subroutine test_e_d4_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(dispersion_type), allocatable :: disp
   type(d4_dispersion), allocatable :: d4

   real(wp), parameter :: qat(16) = [&
      & 3.43501192886252E+0_wp, 5.02404916999371E+0_wp, 4.72253865039692E+0_wp, &
      & 3.52096661104217E+0_wp, 4.76023330956437E+0_wp, 3.46119195863261E+0_wp, &
      & 3.17361370475619E+0_wp, 2.90775065608382E+0_wp, 4.94595287355805E+0_wp, &
      & 3.32592657749444E+0_wp, 4.54348353409109E+0_wp, 4.30924297002105E+0_wp, &
      & 3.47420343563851E+0_wp, 2.82302349370343E+0_wp, 6.67552064739394E+0_wp, &
      & 4.23898159491675E+0_wp]

   call get_structure(mol, "MB16-43", "02")

   ! PBE-D4-ATM
   allocate(d4)
   call new_d4_dispersion(d4, mol, s6=1.0_wp, s8=0.95948085_wp, &
      & a1=0.38574991_wp, a2=4.80688534_wp, s9=1.0_wp, error=error)
   if(allocated(error)) then 
      call test_failed(error, "D4 model could not be created")
      return
   end if
   call move_alloc(d4, disp)

   call test_e(error, mol, disp, qat, -3.2658253557002496E-03_wp)

end subroutine test_e_d4_mb02

subroutine test_e_d4s_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(dispersion_type), allocatable :: disp
   type(d4_dispersion), allocatable :: d4s

   real(wp), parameter :: qat(16) = [&
      & 3.43501192886252E+0_wp, 5.02404916999371E+0_wp, 4.72253865039692E+0_wp, &
      & 3.52096661104217E+0_wp, 4.76023330956437E+0_wp, 3.46119195863261E+0_wp, &
      & 3.17361370475619E+0_wp, 2.90775065608382E+0_wp, 4.94595287355805E+0_wp, &
      & 3.32592657749444E+0_wp, 4.54348353409109E+0_wp, 4.30924297002105E+0_wp, &
      & 3.47420343563851E+0_wp, 2.82302349370343E+0_wp, 6.67552064739394E+0_wp, &
      & 4.23898159491675E+0_wp]

   call get_structure(mol, "MB16-43", "02")

   ! PBE-D4S-ATM
   allocate(d4s)
   call new_d4s_dispersion(d4s, mol, s6=1.0_wp, s8=0.95948085_wp, &
      & a1=0.38574991_wp, a2=4.80688534_wp, s9=1.0_wp, error=error)
   if(allocated(error)) then 
      call test_failed(error, "D4S model could not be created")
      return
   end if
   call move_alloc(d4s, disp)

   call test_e(error, mol, disp, qat, -4.0744895782408065E-03_wp)

end subroutine test_e_d4s_mb02


subroutine test_p_d4_mb03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(dispersion_type), allocatable :: disp
   type(d4_dispersion), allocatable :: d4

   real(wp), parameter :: qat(16) = [&
      & 4.94764986698701E+0_wp, 3.95122747438791E+0_wp, 4.57075556245289E+0_wp, &
      & 5.46368225070994E+0_wp, 8.24269261139398E+0_wp, 5.68405471762112E+0_wp, &
      & 5.51002325309604E+0_wp, 4.75597020148093E+0_wp, 4.21190195089894E+0_wp, &
      & 4.32836770082885E+0_wp, 4.12684869499911E+0_wp, 5.15171226623248E+0_wp, &
      & 4.83223856996055E+0_wp, 3.02638025720185E+0_wp, 4.05683426506167E+0_wp, &
      & 4.63569783992096E+0_wp]

   call get_structure(mol, "MB16-43", "03")

   ! PBE-D4-ATM
   allocate(d4)
   call new_d4_dispersion(d4, mol, s6=1.0_wp, s8=0.95948085_wp, &
      & a1=0.38574991_wp, a2=4.80688534_wp, s9=1.0_wp, error=error)
   if(allocated(error)) then 
      call test_failed(error, "D4 model could not be created")
      return
   end if
   call move_alloc(d4, disp)

   call test_p(error, mol, disp, qat)

end subroutine test_p_d4_mb03

subroutine test_p_d4s_mb03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(dispersion_type), allocatable :: disp
   type(d4_dispersion), allocatable :: d4s

   real(wp), parameter :: qat(16) = [&
      & 4.94764986698701E+0_wp, 3.95122747438791E+0_wp, 4.57075556245289E+0_wp, &
      & 5.46368225070994E+0_wp, 8.24269261139398E+0_wp, 5.68405471762112E+0_wp, &
      & 5.51002325309604E+0_wp, 4.75597020148093E+0_wp, 4.21190195089894E+0_wp, &
      & 4.32836770082885E+0_wp, 4.12684869499911E+0_wp, 5.15171226623248E+0_wp, &
      & 4.83223856996055E+0_wp, 3.02638025720185E+0_wp, 4.05683426506167E+0_wp, &
      & 4.63569783992096E+0_wp]

   call get_structure(mol, "MB16-43", "03")
   
   ! PBE-D4S-ATM
   allocate(d4s)
   call new_d4s_dispersion(d4s, mol, s6=1.0_wp, s8=0.95948085_wp, &
      & a1=0.38574991_wp, a2=4.80688534_wp, s9=1.0_wp, error=error)
   if(allocated(error)) then 
      call test_failed(error, "D4S model could not be created")
      return
   end if
   call move_alloc(d4s, disp)

   call test_p(error, mol, disp, qat)

end subroutine test_p_d4s_mb03

subroutine test_p_d4_mb04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(dispersion_type), allocatable :: disp
   type(d4_dispersion), allocatable :: d4

   real(wp), parameter :: qat(16) = [&
      &-8.99890404486076E-2_wp, 9.42168087556583E-2_wp,-1.49387631509499E-1_wp, &
      &-2.99114121895542E-1_wp, 4.85527734875224E-1_wp,-6.83156326406137E-2_wp, &
      & 1.50011293889337E-2_wp, 2.79368544459465E-1_wp,-1.24072452878322E-1_wp, &
      &-9.36760994051244E-2_wp,-2.19062123031622E-1_wp, 2.14538817685587E-1_wp, &
      & 3.06156726072831E-1_wp,-3.86105514712244E-1_wp,-1.51265171389388E-3_wp, &
      & 3.64255069977693E-2_wp]

   call get_structure(mol, "MB16-43", "04")
   
   ! PBE-D4-ATM
   allocate(d4)
   call new_d4_dispersion(d4, mol, s6=1.0_wp, s8=0.95948085_wp, &
      & a1=0.38574991_wp, a2=4.80688534_wp, s9=1.0_wp, error=error)
   if(allocated(error)) then 
      call test_failed(error, "D4 model could not be created")
      return
   end if
   call move_alloc(d4, disp)

   call test_p(error, mol, disp, qat)

end subroutine test_p_d4_mb04

subroutine test_p_d4s_mb04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(dispersion_type), allocatable :: disp
   type(d4_dispersion), allocatable :: d4s

   real(wp), parameter :: qat(16) = [&
      &-8.99890404486076E-2_wp, 9.42168087556583E-2_wp,-1.49387631509499E-1_wp, &
      &-2.99114121895542E-1_wp, 4.85527734875224E-1_wp,-6.83156326406137E-2_wp, &
      & 1.50011293889337E-2_wp, 2.79368544459465E-1_wp,-1.24072452878322E-1_wp, &
      &-9.36760994051244E-2_wp,-2.19062123031622E-1_wp, 2.14538817685587E-1_wp, &
      & 3.06156726072831E-1_wp,-3.86105514712244E-1_wp,-1.51265171389388E-3_wp, &
      & 3.64255069977693E-2_wp]

   call get_structure(mol, "MB16-43", "04")

   ! PBE-D4S-ATM
   allocate(d4s)
   call new_d4s_dispersion(d4s, mol, s6=1.0_wp, s8=0.95948085_wp, &
      & a1=0.38574991_wp, a2=4.80688534_wp, s9=1.0_wp, error=error)
   if(allocated(error)) then 
      call test_failed(error, "D4S model could not be created")
      return
   end if
   call move_alloc(d4s, disp)

   call test_p(error, mol, disp, qat)

end subroutine test_p_d4s_mb04


end module test_dispersion

!> Configuration data for the manifest linting
module fpm_lint_config
  use tomlf, only : toml_table, toml_context, toml_terminal, toml_error, &
    & toml_stat, get_value
  implicit none

  !> Configuration for the manifest linting
  type :: lint_config
    !> Check package name
    logical :: package_name
    !> Check all key paths
    logical :: bare_keys
  end type lint_config

contains

  !> Load the configuration for the linter from the package manifest
  subroutine load_lint_config(config, table, context, terminal, error)
    !> Configuration for the linter
    type(lint_config), intent(out) :: config
    !> TOML data structure representing the manifest
    type(toml_table), intent(inout) :: table
    !> Context describing the data structure
    type(toml_context), intent(in) :: context
    !> Terminal for output
    type(toml_terminal), intent(in) :: terminal
    !> Error handler
    type(toml_error), allocatable, intent(out) :: error

    integer :: origin, stat
    type(toml_table), pointer :: child1, child2, child3

    call get_value(table, "extra", child1, origin=origin)
    if (.not.associated(child1)) then
      call make_error(error, context%report("The 'extra' table is missing.", &
        & origin, "expected table", color=terminal))
      return
    end if
    call get_value(child1, "fpm", child2, origin=origin)
    if (.not.associated(child2)) then
      call make_error(error, context%report("The 'fpm' table is missing.", &
        & origin, "expected table", color=terminal))
      return
    end if
    call get_value(child2, "lint", child3, origin=origin)
    if (.not.associated(child3)) then
      call make_error(error, context%report("The 'lint' table is missing.", &
        & origin, "expected table", color=terminal))
      return
    end if

    call get_value(child3, "package-name", config%package_name, .true., &
      & stat=stat, origin=origin)
    if (stat /= toml_stat%success) then
      call make_error(error, context%report("Entry in 'package-name' must be boolean", &
        & origin, "expected boolean value", color=terminal))
      return
    end if
    call get_value(child3, "bare-keys", config%bare_keys, .true., &
      & stat=stat, origin=origin)
    if (stat /= toml_stat%success) then
      call make_error(error, context%report("Entry in 'bare-key' must be boolean", &
        & origin, "expected boolean value", color=terminal))
      return
    end if
  end subroutine load_lint_config

  !> Create an error message
  subroutine make_error(error, message)
    !> Error handler
    type(toml_error), allocatable, intent(out) :: error
    !> Message to be displayed
    character(len=*), intent(in) :: message

    allocate(error)
    error%message = message
    error%stat = toml_stat%fatal
  end subroutine make_error

end module fpm_lint_config

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/param/dispersion.f90
!> Provides model for the dispersion corrections

!> Definition of the dispersion corrections
module tblite_param_dispersion
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io_symbols, only : to_number
   use tblite_param_serde, only : serde_record
   use tblite_toml, only : toml_table, get_value, set_value, add_table
   implicit none
   private

   public :: count


   character(len=*), parameter :: k_d3 = "d3", k_d4 = "d4", k_sc = "sc", &
      & k_smooth = "smooth", k_s6 = "s6", k_s8 = "s8", k_s9 = "s9", &
      & k_a1 = "a1", k_a2 = "a2"

   !> Parametrization record specifying the dispersion model
   type, public, extends(serde_record) :: dispersion_record
      !> Scaling for dipole-dipole (C6) interactions
      real(wp) :: s6
      !> Scaling for dipole-quadrupole (C6) interactions
      real(wp) :: s8
      !> Scaling for critical radius in rational damping function
      real(wp) :: a1
      !> Offset for critical radius in rational damping function
      real(wp) :: a2
      !> Scaling for triple-dipole (C9) interactions
      real(wp) :: s9
      !> Use DFT-D3 type dispersion
      logical :: d3
      !> Use selfconsistent DFT-D4 type dispersion
      logical :: sc
      !> Use smoothed DFT-D4S type dispersion
      logical :: smooth
   contains
      generic :: load => load_from_array
      generic :: dump => dump_to_array
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Read parametrization data from parameter array
      procedure, private :: load_from_array
      !> Write parametrization data to parameter array
      procedure, private :: dump_to_array
   end type


   !> Masking for the dispersion model
   type, public :: dispersion_mask
   end type dispersion_mask


   interface count
      module procedure :: count_mask
   end interface count


contains


!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(dispersion_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   integer :: stat

   if (.not.any([table%has_key(k_d3), table%has_key(k_d4)])) then
      call fatal_error(error, "Dispersion model not provided in dispersion table")
      return
   end if

   call get_value(table, k_d3, child, requested=.false., stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read D3 dispersion table")
      return
   end if
   self%d3 = associated(child)
   if (.not.associated(child)) then
      call get_value(table, k_d4, child, stat=stat)
      if (stat /= 0) then
         call fatal_error(error, "Cannot read D4 dispersion table")
         return
      end if
      call get_value(child, k_sc, self%sc, .true., stat=stat)
      if (stat /= 0) then
         call fatal_error(error, "Cannot read self-consistency for D4 dispersion")
         return
      end if
      call get_value(child, k_smooth, self%smooth, .false., stat=stat)
      if (stat /= 0) then
         call fatal_error(error, "Cannot read smoothing for dispersion (D4S)")
         return
      end if
   end if

   call get_value(child, k_s6, self%s6, 1.0_wp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read s6 parameter for dispersion")
      return
   end if
   call get_value(child, k_s8, self%s8, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read s8 parameter for dispersion")
      return
   end if
   call get_value(child, k_a1, self%a1, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read a1 parameter for dispersion")
      return
   end if
   call get_value(child, k_a2, self%a2, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read a2 parameter for dispersion")
      return
   end if
   call get_value(child, k_s9, self%s9, 0.0_wp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read s9 parameter for dispersion")
      return
   end if
end subroutine load_from_toml


!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(dispersion_record), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   call add_table(table, merge(k_d3, k_d4, self%d3), child)
   if (.not.self%d3) then 
      call set_value(child, k_sc, self%sc)
      call set_value(child, k_smooth, self%smooth)
   end if

   call set_value(child, k_s6, self%s6)
   call set_value(child, k_s8, self%s8)
   call set_value(child, k_a1, self%a1)
   call set_value(child, k_a2, self%a2)
   call set_value(child, k_s9, self%s9)
end subroutine dump_to_toml


!> Read parametrization data from parameter array
subroutine load_from_array(self, array, offset, base, mask, error)
   class(dispersion_record), intent(inout) :: self
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: offset
   type(dispersion_record), intent(in) :: base
   type(dispersion_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   select type(self)
   type is (dispersion_record)
      self = base
   end select

end subroutine load_from_array

!> Write parametrization data to parameter array
subroutine dump_to_array(self, array, offset, mask, error)
   class(dispersion_record), intent(in) :: self
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: offset
   type(dispersion_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

end subroutine dump_to_array

elemental function count_mask(mask) result(ncount)
   type(dispersion_mask), intent(in) :: mask
   integer :: ncount
   ncount = 0
end function count_mask


end module tblite_param_dispersion

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_write_pdb
   use mctc_env_accuracy, only : wp
   use mctc_io_convert, only : autoaa
   use mctc_io_structure, only : structure_type
   implicit none
   private

   public :: write_pdb


contains


subroutine write_pdb(mol, unit, number)
   type(structure_type), intent(in) :: mol
   integer, intent(in) :: unit
   integer, intent(in), optional :: number
   character(len=6) :: w1
   character(len=4) :: sym
   character(len=2) :: a_charge
   character(len=1) :: last_chain
   logical :: last_het
   integer :: offset, iat, jat
   real(wp) :: xyz(3)
   character(len=*), parameter :: pdb_format = &
      &  '(a6,i5,1x,a4,a1,a3,1x,a1,i4,a1,3x,3f8.3,2f6.2,6x,a4,a2,a2)'


   if (present(number)) write(unit, '("MODEL ",4x,i4)') number
   if (allocated(mol%pdb)) then
      offset = 0
      last_chain = mol%pdb(1)%chains
      last_het = mol%pdb(1)%het
      do iat = 1, mol%nat

         ! handle the terminator
         if (mol%pdb(iat)%het .neqv. last_het) then
            write(unit, '("TER   ",i5,6x,a3,1x,a1,i4)') iat + offset, &
               &  mol%pdb(iat-1)%residue, last_chain, mol%pdb(iat)%residue_number
            last_het = .not.last_het
            last_chain = mol%pdb(iat)%chains
            offset = offset+1
         else if (mol%pdb(iat)%chains /= last_chain) then
            write(unit, '("TER   ",i5,6x,a3,1x,a1,i4)') iat + offset, &
               &  mol%pdb(iat-1)%residue, last_chain, mol%pdb(iat)%residue_number
            last_chain = mol%pdb(iat)%chains
            offset = offset+1
         endif

         jat = iat + offset
         if (mol%pdb(iat)%het) then
            w1 = "HETATM"
         else
            w1 = "ATOM  "
         endif


         sym = adjustr(mol%sym(mol%id(iat))(1:2))
         xyz = mol%xyz(:,iat) * autoaa
         if (mol%pdb(iat)%charge < 0) then
            write(a_charge, '(i1,"-")') abs(mol%pdb(iat)%charge)
         else if (mol%pdb(iat)%charge > 0) then
            write(a_charge, '(i1,"+")') abs(mol%pdb(iat)%charge)
         else
            a_charge = '  '
         endif

         write(unit, pdb_format) &
            &  w1, jat, mol%pdb(iat)%name, mol%pdb(iat)%loc, &
            &  mol%pdb(iat)%residue, mol%pdb(iat)%chains, mol%pdb(iat)%residue_number, &
            &  mol%pdb(iat)%code, xyz, 1.0_wp, 0.0_wp, mol%pdb(iat)%segid, &
            &  sym, a_charge
      enddo
   else
      do iat = 1, mol%nat
         w1 = "HETATM"
         sym = adjustr(mol%sym(mol%id(iat))(1:2))
         xyz = mol%xyz(:,iat) * autoaa
         a_charge = '  '

         write(unit, pdb_format) &
            &  w1, iat, sym, " ", &
            &  "UNK", "A", 1, " ", xyz, 1.0_wp, 0.0_wp, "    ", &
            &  sym, "  "
      enddo
   end if

   if (present(number)) then
      write(unit, '("ENDMDL")')
   else
      write(unit, '("END")')
   endif

end subroutine write_pdb


end module mctc_io_write_pdb

! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/post-processing/xtb-ml/geometry.f90
!> Geometry based xTB-ML features
module tblite_post_processing_xtbml_geometry
   use mctc_env, only : wp, error_type
   use mctc_io, only : structure_type
   use mctc_ncoord, only : ncoord_type, new_ncoord, cn_count
   use tblite_container_list, only : cache_list
   use tblite_double_dictionary, only : double_dictionary_type
   use tblite_integral_type, only : integral_type
   use tblite_output_format, only : format_string
   use tblite_post_processing_xtbml_cache, only : xtbml_cache
   use tblite_post_processing_xtbml_convolution, only : xtbml_convolution
   use tblite_post_processing_xtbml_features, only : xtbml_feature_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_xtb_calculator, only : xtb_calculator
   implicit none
   private

   public :: new_xtbml_geometry_features, xtbml_geometry_features

   !> Geometry-based xTB-ML features
   type, extends(xtbml_feature_type) :: xtbml_geometry_features
      !> Coordination number
      class(ncoord_type), allocatable :: ncoord
   contains
      !> Compute xtb-ML geometry-based features
      procedure :: compute_features
      !> Compute extended xtb-ML geometry-based features with convolution
      procedure :: compute_extended
   end type xtbml_geometry_features

   character(len=23), parameter :: label = "geometry-based features"

contains

!> Factory for new geometry-based xTB-ML feature container
subroutine new_xtbml_geometry_features(self, mol, error)
   !> Instance of the xTB-ML geometry features
   class(xtbml_geometry_features), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Error handling
   type(error_type), intent(inout) , allocatable:: error

   self%label = label

   call new_ncoord(self%ncoord, mol, cn_count%exp, error)

end subroutine new_xtbml_geometry_features


subroutine compute_features(self, mol, wfn, ints, calc, caches, mlcache, &
   & dict, n_features, error)
   !> Instance of the xTB-ML geometry features
   class(xtbml_geometry_features), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction strcuture data
   type(wavefunction_type), intent(in) :: wfn
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Single-point calculator
   type(xtb_calculator), intent(in) :: calc
   !> Cache list for storing caches of various interactions
   type(cache_list), intent(inout) :: caches
   !> Cache for xTB-ML features
   type(xtbml_cache), intent(inout) :: mlcache
   !> Dictionary for storing results
   type(double_dictionary_type), intent(inout) :: dict
   !> Number of features
   integer, intent(inout) :: n_features
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   ! Count number of features
   n_features = n_features + 1

   ! Compute the coordination number
   if (.not. allocated(mlcache%cn)) then
      allocate(mlcache%cn(mol%nat))
   end if
   call self%ncoord%get_cn(mol, mlcache%cn)

   call dict%add_entry("CN_A", mlcache%cn)

end subroutine compute_features


subroutine compute_extended(self, mol, wfn, ints, calc, caches, mlcache, &
   & convolution, dict, n_features, error)
   !> Instance of the xTB-ML geometry features
   class(xtbml_geometry_features), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction strcuture data
   type(wavefunction_type), intent(in) :: wfn
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Single-point calculator
   type(xtb_calculator), intent(in) :: calc
   !> Cache list for storing caches of various interactions
   type(cache_list), intent(inout) :: caches
   !> Cache for xTB-ML features
   type(xtbml_cache), intent(inout) :: mlcache
   !> Convolution container
   type(xtbml_convolution), intent(in) :: convolution
   !> Dictionary for storing results
   type(double_dictionary_type), intent(inout) :: dict
   !> Number of features
   integer, intent(inout) :: n_features
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=:), allocatable :: tmp_label
   real(wp), allocatable ::  ext_cn(:, :)
   integer :: isc
   
   allocate(ext_cn(mol%nat, convolution%nscale))
   call convolve_cn(mol, mlcache%cn, convolution%nscale, &
      & mlcache%conv_kernel, ext_cn)
   
   do isc = 1, convolution%nscale
      tmp_label = trim("ext_CN_A"//'_'//adjustl(format_string( &
         & convolution%rcov_scale(isc), '(f12.2)')))
      if (tmp_label .eq. "ext_CN_A_1.00") tmp_label = "ext_CN"
      call dict%add_entry(tmp_label, ext_cn(:, isc))
      ! Count number of features
      n_features = n_features + 1
   end do

end subroutine compute_extended


! Convolution of the scalar coordination numbers for different length scales
subroutine convolve_cn(mol, cn, nscale, kernel, ext_cn)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Coordinated number
   real(wp), intent(in) :: cn(:)
   !> Number of convolution length scales
   integer, intent(in) :: nscale
   !> Convolution kernel
   real(wp), intent(in) :: kernel(:, :, :)
   !> Delta CN
   real(wp), intent(out) :: ext_cn(:, :)

   integer :: iat, jat, ksc
   real(wp) :: result

   ext_cn = 0.0_wp
   !$omp parallel do default(none) collapse(2)&
   !$omp shared(mol, nscale, cn, kernel, ext_cn)&
   !$omp private(iat, jat , ksc, result)
   do ksc = 1, nscale
      do iat = 1, mol%nat
         result = 0.0_wp
         do jat = 1, mol%nat
            if (iat == jat) cycle
            result = result + cn(jat) / kernel(iat, jat, ksc)
         end do
         ext_cn(iat, ksc) = ext_cn(iat, ksc) + result
      end do
   end do
   !$omp end parallel do

end subroutine convolve_cn

end module tblite_post_processing_xtbml_geometry

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the driver entry point for handling parametrization data
module tblite_driver_param
   use, intrinsic :: iso_fortran_env, only : output_unit
   use mctc_env, only : error_type, fatal_error, wp
   use tblite_cli, only : param_config
   use tblite_output_ascii
   use tblite_param, only : param_record
   use tblite_toml, only : toml_table, merge_table
   use tblite_xtb_gfn2, only : export_gfn2_param
   use tblite_xtb_gfn1, only : export_gfn1_param
   use tblite_xtb_ipea1, only : export_ipea1_param
   implicit none
   private

   public :: main

   interface main
      module procedure :: param_main
   end interface

contains


subroutine param_main(config, error)
   type(param_config), intent(in) :: config
   type(error_type), allocatable, intent(out) :: error

   type(param_record), allocatable :: param, base
   type(toml_table) :: table1, table2

   if (allocated(config%method)) then
      allocate(base)
      select case(config%method)
      case default
         call fatal_error(error, "Unknown method '"//config%method//"' requested")
      case("gfn2")
         call export_gfn2_param(base)
      case("gfn1")
         call export_gfn1_param(base)
      case("ipea1")
         call export_ipea1_param(base)
      end select
   end if
   if (allocated(error)) return

   if (allocated(config%input)) then
      allocate(param)
      call param%load(config%input, error)

      if (.not.allocated(error) .and. allocated(base)) then
         table1 = toml_table()
         call param%dump(table1, error)
         if (.not. allocated(error)) then
            table2 = toml_table()
            call base%dump(table2, error)
         end if
         if (.not. allocated(error)) then
            call merge_table(table1, table2)
            call table2%destroy
            deallocate(param, base)
            allocate(param)
            call param%load(table1, error)
            call table1%destroy
         end if
      end if
   else
      call move_alloc(base, param)
   end if
   if (allocated(error)) return

   if (config%verbosity > 1) then
      if (allocated(param%name)) &
         write(output_unit, '(a)') param%name
      if (allocated(param%reference)) &
         write(output_unit, '(a)') param%reference
   end if

   if (allocated(config%output)) then
      call param%dump(config%output, error)
      if (.not.allocated(error)) then
         if (config%verbosity > 0) write(output_unit, '(a)') &
            "[Info] Parameter file written to '"//config%output//"'"
      end if
   end if
   if (allocated(error)) return

end subroutine param_main


end module tblite_driver_param

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Reduces a real symmetric-definite generalized eigenproblem to standard form.
module tblite_lapack_sygst
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_sygst


   !> Reduces a real symmetric-definite generalized eigenproblem to standard form.
   !>
   !> If ITYPE = 1, the problem is A*x = lambda*B*x,
   !> and A is overwritten by inv(U**T)*A*inv(U) or inv(L)*A*inv(L**T)
   !>
   !> If ITYPE = 2 or 3, the problem is A*B*x = lambda*x or
   !> B*A*x = lambda*x, and A is overwritten by U*A*U**T or L**T*A*L.
   !>
   !> B must have been previously factorized as U**T*U or L*L**T by POTRF.
   interface wrap_sygst
      module procedure :: wrap_ssygst
      module procedure :: wrap_dsygst
   end interface wrap_sygst


   !> Reduces a real symmetric-definite generalized eigenproblem to standard form.
   !>
   !> If ITYPE = 1, the problem is A*x = lambda*B*x,
   !> and A is overwritten by inv(U**T)*A*inv(U) or inv(L)*A*inv(L**T)
   !>
   !> If ITYPE = 2 or 3, the problem is A*B*x = lambda*x or
   !> B*A*x = lambda*x, and A is overwritten by U*A*U**T or L**T*A*L.
   !>
   !> B must have been previously factorized as U**T*U or L*L**T by POTRF.
   interface lapack_sygst
      pure subroutine ssygst(itype, uplo, n, a, lda, b, ldb, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(in) :: b(ldb, *)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine ssygst
      pure subroutine dsygst(itype, uplo, n, a, lda, b, ldb, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(in) :: b(ldb, *)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine dsygst
   end interface lapack_sygst

contains

pure subroutine wrap_ssygst(amat, bmat, info, itype, uplo)
   real(sp), intent(inout) :: amat(:, :)
   real(sp), intent(in) :: bmat(:, :)
   integer, intent(in), optional :: itype
   character(len=1), intent(in), optional :: uplo
   integer, intent(out) :: info
   character(len=1) :: ula
   integer :: ita, n, lda, ldb

   ita = 1
   if(present(itype)) ita = itype
   ula = 'u'
   if(present(uplo)) ula = uplo
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   call lapack_sygst(ita, ula, n, amat, lda, bmat, ldb, info)
end subroutine wrap_ssygst

pure subroutine wrap_dsygst(amat, bmat, info, itype, uplo)
   real(dp), intent(inout) :: amat(:, :)
   real(dp), intent(in) :: bmat(:, :)
   integer, intent(in), optional :: itype
   character(len=1), intent(in), optional :: uplo
   integer, intent(out) :: info
   character(len=1) :: ula
   integer :: ita, n, lda, ldb

   ita = 1
   if(present(itype)) ita = itype
   ula = 'u'
   if(present(uplo)) ula = uplo
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   call lapack_sygst(ita, ula, n, amat, lda, bmat, ldb, info)
end subroutine wrap_dsygst

end module tblite_lapack_sygst

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/solvation/shift.f90
!> Provides solvent and state specific shifts to the free energy.

module tblite_solvation_shift
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type
   use tblite_container_cache, only : container_cache
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_solvation_type, only : solvation_type
   use mctc_io_codata2018, only : molar_gas_constant, atomic_unit_of_energy
   use mctc_io_constants, only : codata
   use mctc_io_convert, only : kjtoau
   implicit none
   private
 
   public :: shift_solvation, new_shift, shift_input, solution_state

   type :: shift_input
      !> Reference state
      integer :: state = 1
      !> Solvent specific free energy shift
      real(wp) :: gshift = 0.0_wp
      !> Molar mass of solvent
      real(wp), allocatable :: molar_mass 
      !> Density of solvent
      real(wp), allocatable :: rho
      !> Temperature in Kelvin
      real(wp) :: temperature = 298.15_wp
      !> Linearized Poisson-Boltzmann model for parameter selection
      logical :: alpb = .true.
      !> Solvent for parameter selection
      character(len=:), allocatable :: solvent
   end type shift_input

   !> Provide constructor for shift input
   interface shift_input
      module procedure :: create_shift_input
   end interface shift_input

   !> Possible reference states for the solution
   type :: enum_solution_state
      !> 1 l of ideal gas in 1 l of liquid solution
      integer :: gsolv = 1
      !> 1 bar of ideal gas and 1 mol/L of liquid solution
      integer :: bar1mol = 2
      !> 1 bar of ideal gas to 1 mol/L of liquid solution at infinite dilution
      integer :: reference = 3
   end type enum_solution_state

   !> Actual solvation state enumerator
   type(enum_solution_state), parameter :: solution_state = enum_solution_state()

   real(wp), parameter :: refDensity = 1.0e-3_wp         ! kg__au/(1.0e10_wp*AA__Bohr)**3
   real(wp), parameter :: refPressure = 1.0e2_wp         ! kPa__au
   real(wp), parameter :: refMolecularMass = 1.0_wp      ! amu__au
   real(wp), parameter :: ambientTemperature = 298.15_wp

   type, extends(solvation_type) :: shift_solvation
      !> total shift
      real(wp) :: total_shift 
   contains
      !> Update cache from container
      procedure :: update
      !> Get shift energy
      procedure :: get_engrad
   end type shift_solvation

   !> Provide constructor for shift
   interface shift_solvation
      module procedure :: create_shift
   end interface shift_solvation

   type :: shift_cache
      !> Total free energy shift
      real(wp) :: total_shift
   end type shift_cache

   !> Identifier for container 
   character(len=*), parameter :: label = "empirical free energy shift and standard state/solvent correction"

contains


!> Consturctor for shift input to properly assign allocatable strings
function create_shift_input(state, solvent, alpb, gshift, molar_mass, rho, temperature) result(self)
   !> Reference state
   integer, intent(in), optional :: state
   !> Solvent for parameter selection
   character(len=*), intent(in), optional :: solvent
   !> Use analytical linearized Poisson-Boltzmann model
   logical, intent(in), optional :: alpb
   !> Solvent specific free energy shift
   real(wp), intent(in), optional :: gshift
   !> Molar mass of solvent
   real(wp), allocatable, intent(in), optional :: molar_mass 
   !> Density of solvent
   real(wp), allocatable, intent(in), optional :: rho
   !> Temperature in Kelvin
   real(wp), intent(in), optional :: temperature

   type(shift_input) :: self

   if (present(state)) then
      self%state = state
   end if

   if (present(solvent)) then 
      self%solvent = solvent
   end if

   if (present(alpb)) then 
      self%alpb = alpb
   end if

   if (present(gshift)) then 
      self%gshift = gshift
   end if

   if (present(molar_mass)) then 
      self%molar_mass = molar_mass
   end if

   if (present(rho)) then
      self%rho = rho
   end if

   if (present(temperature)) then
      self%temperature = temperature
   end if

end function create_shift_input

!> Calculate the solvent and state shift
subroutine new_shift(self, input)
   !> Instance of the solvation model
   type(shift_solvation) :: self
   !> Input for shift solvation
   type(shift_input), intent(in) :: input

   !> State shift
   real(wp) :: stateshift

   self%label = label
   stateshift = get_stateshift(input%state, input%temperature, input%rho, input%molar_mass)
   self%total_shift = input%gshift + stateshift 
end subroutine new_shift

!> Type constructor for shift
function create_shift(input) result(self)
   !> Instance of the solvation model
   type(shift_solvation) :: self
   !> Input for solvation shift
   type(shift_input), intent(in) :: input

   call new_shift(self, input)
end function create_shift

!> Update cache from container
subroutine update(self, mol, cache)
   !> Instance of the solvation model
   class(shift_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   type(shift_cache), pointer :: ptr

   call taint(cache, ptr)
   ptr%total_shift = self%total_shift
end subroutine update

!> Evaluate non-selfconsistent part of the interaction
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the solvation model
   class(shift_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Interaction energy
   real(wp), intent(inout) :: energies(:)
   !> Interaction gradient
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Interaction virial
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)

   type(shift_cache), pointer :: ptr

   call view(cache, ptr)

   energies(:) = energies + ptr%total_shift/real(mol%nat)
end subroutine get_engrad

!> Calculate the solvation state shift
function get_stateshift(state, temperature, density, molecularMass) &
   & result(stateshift)
   !> Reference state
   integer, intent(in) :: state
   !> Temperature of the solution
   real(wp), intent(in) :: temperature
   !> Mass density of the solvent
   real(wp), intent(in) :: density
   !> Molecular mass of the solvent
   real(wp), intent(in) :: molecularMass
   !> Resulting shift to the solvation free energy
   real(wp) :: stateshift

   ! Boltzmann constant in au/K
   real(wp) :: boltzmann = codata%kb / atomic_unit_of_energy
   ! Ideal gas molar volume in m^3/mol 
   real(wp) :: idealGasMolVolume = molar_gas_constant * ambientTemperature / refPressure

   select case(state)
   case default
      stateshift = 0.0_wp
   case(solution_state%bar1mol)
      stateshift = temperature * boltzmann &
         & * log(idealGasMolVolume * temperature / ambientTemperature)
   case(solution_state%reference)
      stateshift = temperature * boltzmann &
         & * (log(idealGasMolVolume * temperature / ambientTemperature) &
         & + log(density/refDensity * refMolecularMass/molecularMass))
   end select

end function get_stateshift

subroutine taint(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(shift_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(shift_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

subroutine view(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(shift_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(shift_cache)
      ptr => target
   end select
end subroutine view

end module tblite_solvation_shift

program param_scanner
   use mctc_env, only : wp, error_type, get_argument, fatal_error
   use mctc_io, only : structure_type, read_structure
   use d3_param_scan, only : reaction_type, scan_param_for_reaction
   implicit none

   type(reaction_type) :: reaction
   type(error_type), allocatable :: error
   character(:), allocatable :: method
   real(wp), allocatable :: dft_energy
   integer :: n_args, n_mol, iarg, imol

   n_args = command_argument_count()

   if (n_args < 3) then
      print '(a)', "Usage: param-scanner <method> <coeff1> <mol1> ... [dft energy]"
      stop 1
   end if

   n_mol = (n_args - 1) / 2

   call get_argument(1, method)

   allocate(reaction%mol(n_mol))
   allocate(reaction%stochiometry(n_mol))
   imol = 0
   do iarg = 1, 2 * n_mol, 2
      imol = imol + 1
      call read_real(iarg + 1, reaction%stochiometry(imol), error)
      if (allocated(error)) exit
      call read_mol(iarg + 2, reaction%mol(imol), error)
      if (allocated(error)) exit
   end do
   if (.not.allocated(error) .and. 2 * n_mol < n_args - 1) then
      allocate(dft_energy)
      call read_real(n_args, dft_energy, error)
   end if
   if (allocated(error)) then
      print '(a)', error%message
      stop 1
   end if

   call scan_param_for_reaction(error, reaction, method, dft_energy)
   if (allocated(error)) then
      print '(a)', error%message
      stop 1
   end if

contains

subroutine read_mol(idx, mol, error)
   integer, intent(in) :: idx
   type(structure_type), intent(out) :: mol
   type(error_type), allocatable, intent(out) :: error

   character(len=:), allocatable :: tmp

   call get_argument(idx, tmp)
   call read_structure(mol, tmp, error=error)
end subroutine read_mol

subroutine read_real(idx, val, error)
   integer, intent(in) :: idx
   real(wp), intent(out) :: val
   type(error_type), allocatable, intent(out) :: error

   character(len=:), allocatable :: tmp
   integer :: stat

   call get_argument(idx, tmp)
   read(tmp, *, iostat=stat) val
   if (stat /= 0) then
      call fatal_error(error, "Could not read floating point value from '"//tmp//"'")
   end if
end subroutine read_real

end program param_scanner

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/double_dictionary
!> Contains implemenation of a dictionary with strings as keys and arrays of doubles as entries.

!> @file tblite/double_dictionery.f90
!> Implements double dictionary type
module tblite_double_dictionary
   use mctc_env_accuracy, only : wp, i8
   use mctc_env, only : error_type, fatal_error
   use tblite_toml, only : toml_array, toml_table, toml_key, add_table, set_value, toml_error
   use tblite_toml, only : toml_dump, add_array,  get_value, toml_parse
   use tblite_io_numpy, only : save_npz, load_npz
   use tblite_io_numpy_loadz, only : get_npz_descriptor
   use tblite_io_numpy_zip, only : zip_file, list_zip_file
   implicit none
   private

   public :: double_dictionary_type

   type :: double_record
      character(len=:), allocatable :: label
      real(wp), allocatable :: array1(:)
      real(wp), allocatable :: array2(:, :)
      real(wp), allocatable :: array3(:, :, :)
   contains
      generic :: assignment(=) => copy_record
      generic :: operator(==) => equal_record
      procedure :: copy_record
      procedure :: equal_record
   end type double_record

   type :: double_dictionary_type
      integer :: n = 0
      type(double_record), allocatable :: record(:)
   contains
      private
      generic, public :: initialize_entry => ini_label, ini_1d, ini_2d, ini_3d
      procedure :: ini_label
      procedure :: ini_1d
      procedure :: ini_2d
      procedure :: ini_3d
      generic, public :: add_entry =>  add_1d, add_2d, add_3d
      procedure :: add_1d
      procedure :: add_2d
      procedure :: add_3d
      !procedure :: update_entry ! label and array pair
      generic, public :: get_entry =>  get_1d_index, get_2d_index, get_3d_index, get_1d_label, get_2d_label, get_3d_label !check
      procedure :: get_1d_index
      procedure :: get_2d_index
      procedure :: get_3d_index
      procedure :: get_1d_label
      procedure :: get_2d_label
      procedure :: get_3d_label
      generic, public :: update => update_1d, update_2d, update_3d
      procedure :: update_1d
      procedure :: update_2d
      procedure :: update_3d
      procedure, public :: get_label ! return label label
      procedure :: push
      procedure, public :: get_n_entries
      generic, public :: concatenate => concatenate_overwrite
      procedure :: concatenate_overwrite
      generic, public :: assignment(=) => copy
      procedure :: copy
      generic, public :: operator(+) => combine_dict
      procedure :: combine_dict
      generic, public :: remove_entry => remove_entry_label, remove_entry_index
      procedure :: remove_entry_label
      procedure :: remove_entry_index
      generic, public :: get_index => return_label_index
      procedure :: return_label_index
      procedure :: dump_to_file
      generic, public :: dump => dump_to_file
      generic, public :: operator(==) => equal_dict
      procedure :: equal_dict
      generic, public :: load => load_from_file
      procedure :: load_from_file

   end type double_dictionary_type

contains

!> Check if two double records are equal
pure function equal_record(lhs, rhs) result(equal)
   !> First record to compare
   class(double_record), intent(in) :: lhs
   !> Second record to compare
   class(double_record), intent(in) :: rhs
   !> Result of the comparison
   logical :: equal
   equal = .false.

   if (lhs%label /= rhs%label) then
      return
   end if

   if (allocated(lhs%array1) .and. allocated(rhs%array1)) then
      equal = all(lhs%array1 == rhs%array1)
      return
   end if
      
   if (allocated(lhs%array2) .and. allocated(rhs%array2)) then
      equal = all(lhs%array2 == rhs%array2)
      return
   end if

   if (allocated(lhs%array3) .and. allocated(rhs%array3)) then
      equal = all(lhs%array3 == rhs%array3)
      return
   end if

end function equal_record


!> Check if two double dictionaries are equal
pure function equal_dict(lhs, rhs) result(equal)
   !> First dictionary to compare
   class(double_dictionary_type), intent(in) :: lhs
   !> Second dictionary to compare
   class(double_dictionary_type), intent(in) :: rhs
   !> Result of the comparison
   logical :: equal

   integer :: i
   equal = .false.

   if (lhs%n /= rhs%n) then
      return
   end if

   do i = 1, lhs%n
      if (.not.(lhs%record(i) == rhs%record(i))) return
   end do

   equal = .true.
end function equal_dict

!> Read double dictionary data from file
subroutine load_from_file(self, filename, error)
   !> Instance of the parametrization data
   class(double_dictionary_type), intent(inout) :: self
   !> File name
   character(len=*), intent(in) :: filename
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: io, stat, irec, it
   integer, allocatable :: vshape(:)
   logical :: exist
   type(zip_file) :: zip
   character(len=:), allocatable :: msg, label, vtype
   character(len=*), parameter :: prefix = "tblite0_"

   inquire(file=filename, exist=exist)
   if (.not. exist) then
      call fatal_error(error, "File '"//filename//"' does not exist")
      return
   end if

   open(newunit=io, file=filename, form="unformatted", access="stream", iostat=stat)
   call list_zip_file(io, filename, zip, stat, msg)
   close(io)
   if (stat /= 0) then
      if (.not.allocated(msg)) msg = "Failed to read zip file '"//filename//"'"
      call fatal_error(error, msg)
      return
   end if

   if (.not.allocated(zip%records)) then
      call fatal_error(error, "No records found in file '"//filename//"'")
      return
   end if

   do irec = 1, size(zip%records)
      associate(path => zip%records(irec)%path)
         if (len(path) < len(prefix) + 4) then
            call fatal_error(error, "File '"//filename//"::"//path// &
               & "' does not match expected format")
            exit
         end if
         label = path(len(prefix) + 1:len(path) - 4)
         if (path(:len(prefix)) /= prefix) then
            call fatal_error(error, "Unknown file type '"//filename//"::"//path//"'")
            exit
         end if
         call get_npz_descriptor(filename, prefix//label, vtype, vshape, stat, msg)
         if (stat == 0 .and. allocated(vshape)) then
            select case(size(vshape))
            case default
               call fatal_error(error, "Unknown file type '"//filename//"::"//path//"'")
               exit
            case (1)
               call self%push(label, it)
               call load_npz(filename, prefix//label, self%record(it)%array1, stat, msg)
            case (2)
               call self%push(label, it)
               call load_npz(filename, prefix//label, self%record(it)%array2, stat, msg)
            case (3)
               call self%push(label, it)
               call load_npz(filename, prefix//label, self%record(it)%array3, stat, msg)
            end select
         end if
         if (stat /= 0) then
            if (.not.allocated(msg)) then
               msg = "Failed to load file '"//filename//"::"//path//"'"
            end if
            call fatal_error(error, msg)
            exit
         end if
      end associate
   end do

end subroutine load_from_file

!> Write double dictionary data to file
subroutine dump_to_file(self, file, error)
   !> Instance of the parametrization data
   class(double_dictionary_type), intent(in) :: self
   !> File name
   character(len=*), intent(in) :: file
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: prefix = "tblite0_"

   integer :: it, stat, io
   logical :: exist
   real(kind=wp), allocatable :: array1(:), array2(:, :), array3(:, :, :)
   character(len=:), allocatable :: msg


   inquire(file=file, exist=exist)
   if (exist) then
      open(file=file, newunit=io)
      close(io, status='delete')
   end if

   do it = 1, self%n
      associate(record => self%record(it))
         if (allocated(record%array1)) then
            call save_npz(file, prefix//record%label, record%array1, stat, msg)
            if (stat /= 0) exit
            cycle
         end if

         if (allocated(record%array2)) then
            call save_npz(file, prefix//record%label, record%array2, stat, msg)
            if (stat /= 0) exit
            cycle
         end if

         if (allocated(record%array3)) then
            call save_npz(file, prefix//record%label, record%array3, stat, msg)
            if (stat /= 0) exit
            cycle
         end if
      end associate
   end do
   if (stat /= 0) then
      if (.not.allocated(msg)) then
         msg = "Failed to write file '"//file//"'"
      end if
      call fatal_error(error, msg)
   end if
end subroutine dump_to_file


pure subroutine remove_entry_index(self, index)
   class(double_dictionary_type), intent(inout) :: self
   integer, intent(in) :: index
   integer :: old_n, i, it
   type(double_record), allocatable :: tmp(:)

   if (index > self%n) return
   call move_alloc(self%record, tmp)
   old_n = self%n
   self%n = self%n - 1
   
   allocate(self%record(self%n))
   it = 1
   do i = 1, old_n
      if (i == index) cycle
      call move_record(tmp(i), self%record(it))
      it = it + 1
   end do
 
end subroutine remove_entry_index

pure subroutine remove_entry_label(self, label)
   class(double_dictionary_type), intent(inout) :: self
   character(len=*), intent(in) :: label
   integer :: it 
   it = return_label_index(self, label)
   if (it /= 0) then
      call self%remove_entry_index(it) 
   end if
end subroutine remove_entry_label

pure function get_n_entries(self) result(n)
   class(double_dictionary_type), intent(in) :: self
   integer :: n
   n = self%n
end function get_n_entries

pure subroutine copy(to, from)
   class(double_dictionary_type), intent(inout) :: to
   type(double_dictionary_type), intent(in) :: from
   integer :: n_entries, i
   to%n = from%n
   if (allocated(to%record)) deallocate(to%record)
   if (from%n > 0) then 
      allocate(to%record(size(from%record)))
      n_entries = from%n

      do i = 1, n_entries
         to%record(i) = from%record(i)
      end do
   end if

end subroutine

pure subroutine move_record(from, to)
   class(double_record), intent(inout) :: to
   type(double_record), intent(inout) :: from

   call move_alloc(from%label, to%label)
   if (allocated(to%array1)) deallocate(to%array1)
   if (allocated(from%array1)) then
      call move_alloc(from%array1, to%array1)
   end if
   if (allocated(to%array2)) deallocate(to%array2)
   if (allocated(from%array2)) then
      call move_alloc(from%array2, to%array2)
   end if
   if (allocated(to%array3)) deallocate(to%array3)
   if (allocated(from%array3)) then
      call move_alloc(from%array3, to%array3)
   end if
end subroutine move_record

pure subroutine copy_record(to, from)
   class(double_record), intent(inout) :: to
   type(double_record), intent(in) :: from

   if (allocated(to%label)) deallocate(to%label)
   to%label = from%label
   if (allocated(from%array1)) to%array1 = from%array1
   if (allocated(from%array2)) to%array2 = from%array2
   if (allocated(from%array3)) to%array3 = from%array3
end subroutine

pure subroutine concatenate_overwrite(self, dict2)
   class(double_dictionary_type), intent(inout) :: self
   type(double_dictionary_type), intent(in) :: dict2
   type(double_dictionary_type) :: tmp_dict
   tmp_dict = self + dict2
   self = tmp_dict

end subroutine

pure function combine_dict(self, dict2) result(new_dict)
   class(double_dictionary_type), intent(in) :: self
   type(double_dictionary_type), intent(in) :: dict2
   type(double_dictionary_type) :: new_dict

   integer :: it, i, n_entries
   new_dict = self
   associate(dict => dict2)
      n_entries = dict%n
      do i = 1, n_entries
         call new_dict%push(dict%record(i)%label, it)
         new_dict%record(it) = dict%record(i)
      end do
   end associate

end function

pure subroutine update_1d(self, label, array)
   class(double_dictionary_type), intent(inout) :: self
   character(len=*), intent(in) :: label
   real(wp), intent(in) :: array(:)

   integer :: it

   it = return_label_index(self, label)
   if (it /= 0) then
      associate(record => self%record(it))
         if (allocated(record%array1)) deallocate(record%array1)
         if (allocated(record%array2)) deallocate(record%array2)
         if (allocated(record%array3)) deallocate(record%array3)
         record%array1 = array
      end associate
   else
      return
   end if
end subroutine

pure subroutine update_2d(self, label, array)
   class(double_dictionary_type), intent(inout) :: self
   character(len=*), intent(in) :: label
   real(wp), intent(in) :: array(:, :)
   integer :: it

   it = return_label_index(self, label)
   if (it /= 0) then
      associate(record => self%record(it))
         if (allocated(record%array1)) deallocate(record%array1)
         if (allocated(record%array2)) deallocate(record%array2)
         if (allocated(record%array3)) deallocate(record%array3)
         record%array2 = array
      end associate
   else
      return
   end if
end subroutine

pure subroutine update_3d(self, label, array)
   class(double_dictionary_type), intent(inout) :: self
   character(len=*), intent(in) :: label
   real(wp), intent(in) :: array(:, :, :)
   integer :: it

   it = return_label_index(self, label)
   if (it /= 0) then
      associate(record => self%record(it))
         if (allocated(record%array1)) deallocate(record%array1)
         if (allocated(record%array2)) deallocate(record%array2)
         if (allocated(record%array3)) deallocate(record%array3)
         record%array3 = array
      end associate
   end if
end subroutine update_3d

!> Get the label of a given index
pure subroutine get_label(self, index, label)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(in) :: self
   !> Index of the label in the dictionary
   integer, intent(in) :: index
   !> Label to be returned
   character(len=:), allocatable, intent(out) :: label

   if (index > self%n) return

   label = self%record(index)%label
end subroutine get_label

!> Get a 1D array from the dictionary
pure subroutine get_1d_label(self, label, array)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(in) :: self
   !> Label for the array
   character(len=*), intent(in) :: label
   !> 1D array to be returned
   real(wp), allocatable, intent(out) :: array(:)
   integer :: it
   it = return_label_index(self, label)
   if (it == 0) return
   call self%get_entry(it, array)

end subroutine get_1d_label

!> Get a 2D array from the dictionary
pure subroutine get_2d_label(self, label, array)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(in) :: self
   !> Label for the array
   character(len=*), intent(in) :: label
   !> 2D array to be returned
   real(wp), allocatable, intent(out) :: array(:,:)
   integer :: it
   it = return_label_index(self, label)
   if (it == 0) return
   call self%get_entry(it, array)
end subroutine get_2d_label

!> Get a 3D array from the dictionary
pure subroutine get_3d_label(self, label, array)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(in) :: self
   !> Label for the array
   character(len=*), intent(in) :: label
   !> 3D array to be returned
   real(wp), allocatable, intent(out) :: array(:, :, :)
   integer :: it
   it = return_label_index(self, label)
   if (it == 0) return
   call self%get_entry(it, array)
end subroutine get_3d_label

!> Get a 1D array from the dictionary
pure subroutine get_1d_index(self, index, array)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(in) :: self
   !> Index of the array in the dictionary
   integer, intent(in) :: index
   !> 1D array to be returned
   real(wp), allocatable, intent(out) :: array(:)

   if (index > self%n) return
   if (index <= 0) return
   associate(rec => self%record(index))
      if (allocated(rec%array1)) then
         array = rec%array1
      end if
   end associate

end subroutine get_1d_index

!> Get a 2D array from the dictionary
pure subroutine get_2d_index(self, index, array)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(in) :: self
   !> Index of the array in the dictionary
   integer, intent(in) :: index
   !> 2D array to be returned
   real(wp), allocatable, intent(out) :: array(:,:)

   if (index > self%n) return
   if (index <= 0) return
   associate(rec => self%record(index))
      if (allocated(rec%array2)) then
         array = rec%array2
      end if
   end associate

end subroutine get_2d_index

!> Get a 3D array from the dictionary
pure subroutine get_3d_index(self, index, array)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(in) :: self
   !> Index of the array in the dictionary
   integer, intent(in) :: index
   !> 3D array to be returned
   real(wp), allocatable, intent(out) :: array(:, :, :)

   if (index > self%n) return
   if (index <= 0) return
   associate(rec => self%record(index))
      if (allocated(rec%array3)) then
         array = rec%array3
      end if
   end associate

end subroutine get_3d_index

!> Add a new entry to the dictionary
pure subroutine push(self, label, it)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(inout) :: self
   !> Label for the array
   character(len=*), intent(in) :: label
   !> Index of the label in the dictionary
   integer, intent(out) :: it

   if (.not.allocated(self%record)) call resize(self%record)
   it = find(self%record(:self%n), label)

   if (it == 0) then
      if (self%n >= size(self%record)) then
         call resize(self%record)
      end if

      self%n = self%n + 1
      it = self%n
      self%record(it)%label = label
   end if
end subroutine push

!> Initialize a label in the dictionary
pure subroutine ini_label(self, label)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(inout) :: self
   !> Label for the array
   character(len=*), intent(in) :: label
   integer :: it

   call self%push(label, it)
end subroutine ini_label

!> Initialize a 1D array in the dictionary
pure subroutine ini_1d(self, label, ndim1)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(inout) :: self
   !> Label for the array
   character(len=*), intent(in) :: label
   !> Dimensions of the 1D array
   integer, intent(in) :: ndim1
   integer :: it

   call self%push(label, it)

   associate(record => self%record(it))
      allocate(record%array1(ndim1), source=0.0_wp)
   end associate
end subroutine ini_1d

!> Initialize a 2D array in the dictionary
pure subroutine ini_2d(self, label, ndim1, ndim2)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(inout) :: self
   !> Label for the array
   character(len=*), intent(in) :: label
   !> Dimensions of the 2D array
   integer, intent(in) :: ndim1, ndim2

   integer :: it

   call self%push(label, it)

   associate(record => self%record(it))
      allocate(record%array2(ndim1, ndim2), source=0.0_wp)
   end associate
end subroutine ini_2d

!> Initialize a 3D array in the dictionary
pure subroutine ini_3d(self, label, ndim1, ndim2, ndim3)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(inout) :: self
   !> Label for the array
   character(len=*), intent(in) :: label
   !> Dimensions of the 3D array
   integer, intent(in) :: ndim1, ndim2, ndim3
   integer :: it

   call self%push(label, it)

   associate(record => self%record(it))
      allocate(record%array3(ndim1, ndim2, ndim3), source=0.0_wp)
   end associate
end subroutine ini_3d

!> Add a 1D array to the dictionary
pure subroutine add_1d(self, label, array)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(inout) :: self
   !> Label for the array
   character(len=*), intent(in) :: label
   !> 1D array to be added
   real(wp), intent(in) :: array(:)
   integer :: it

   call self%push(label, it)

   associate(record => self%record(it))
      record%array1 = array
      if (allocated(record%array2)) deallocate(record%array2)
      if (allocated(record%array3)) deallocate(record%array3)
   end associate
end subroutine add_1d

!> Add a 2D array to the dictionary
pure subroutine add_2d(self, label, array)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(inout) :: self
   !> Label for the array
   character(len=*), intent(in) :: label
   !> 2D array to be added
   real(wp), intent(in) :: array(:,:)
   integer :: it

   call self%push(label, it)

   associate(record => self%record(it))
      record%array2 = array
      if (allocated(record%array1)) deallocate(record%array1)
      if (allocated(record%array3)) deallocate(record%array3)
   end associate

end subroutine add_2d

!> Add a 3D array to the dictionary
pure subroutine add_3d(self, label, array)
   !> Instance of the double dictionary
   class(double_dictionary_type), intent(inout) :: self
   !> Label for the array
   character(len=*), intent(in) :: label
   !> 3D array to be added
   real(wp), intent(in) :: array(:, :, :)
   integer :: it

   call self%push(label, it)

   associate(record => self%record(it))
      record%array3 = array
      if (allocated(record%array1)) deallocate(record%array1)
      if (allocated(record%array2)) deallocate(record%array2)
   end associate
end subroutine add_3d

!> Find the index of a label in the dictionary
pure function return_label_index(self, label) result(it)
   class(double_dictionary_type), intent(in) :: self
   character(len=*), intent(in) :: label
   integer :: it
   it = 0
   if (self%n <= 0) return
   it = find(self%record(:self%n), label)
end function return_label_index

!> Find the index of a label in the dictionary
pure function find(record, label) result(pos)
   !> List of double arrays
   type(double_record), intent(in) :: record(:)
   !> Label to search for
   character(len=*), intent(in) :: label
   !> Position of the label in the list
   integer :: pos

   integer :: i

   pos = 0

   do i = size(record), 1, -1
      if (allocated(record(i)%label)) then
         if (label == record(i)%label) then
            pos = i
            exit
         end if
      end if
   end do

end function find

!> Reallocate list of double arrays
pure subroutine resize(var, n)
   !> Instance of the array to be resized
   type(double_record), allocatable, intent(inout) :: var(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(double_record), allocatable :: tmp(:)
   integer :: this_size, new_size, it
   integer, parameter :: initial_size = 20

   if (allocated(var)) then
      this_size = size(var, 1)
      call move_alloc(var, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(var(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(var, 1))
      do it = 1, this_size
         call move_record(tmp(it), var(it))
      end do
      deallocate(tmp)
   end if

end subroutine resize

end module tblite_double_dictionary

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

!> Entry point for the command line interface of dftd4
program driver
   use, intrinsic :: iso_fortran_env, only : error_unit
   use mctc_env, only : error_type
   use dftd4_cli, only : cli_config, get_arguments
   use dftd4_driver, only : main
   implicit none
   !> Configuration data deteriming the driver behaviour
   class(cli_config), allocatable :: config
   !> Error handling
   type(error_type), allocatable :: error

   call get_arguments(config, error)
   if (allocated(error)) then
      write(error_unit, '("[Error]:", 1x, a)') error%message
      error stop
   end if

   call main(config, error)
   if (allocated(error)) then
      write(error_unit, '("[Error]:", 1x, a)') error%message
      error stop
   end if

end program driver

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/results.f90
!> Provides a container for storing additional calculation results.

!> Container for holding results produced by a calculation.
module tblite_results
   use mctc_env, only : wp
   use tblite_double_dictionary, only : double_dictionary_type
   implicit none
   private


   !> Results container
   type, public :: results_type
      !> Atom-resolved energies
      real(wp), allocatable :: energies(:)
      !> Overlap integrals
      real(wp), allocatable :: overlap(:, :)
      !> (Core) Hamiltonian integrals
      real(wp), allocatable :: hamiltonian(:, :)
      !> Dictionary for storing additional results from post-processing
      type(double_dictionary_type), allocatable :: dict
   end type results_type


end module tblite_results

!> Routines which are only used by the tests and should not be used by
!! external software.
module ddx_legacy
use ddx
implicit none

contains

!> Compute potential, its gradient and hessian in cavity points
!!
!! If ddx_data is FMM-ready then approximate output is computed by the FMM.
!!
!! @param[in] params: parameters data structure
!! @param[in] constants: constants data structure
!! @param[in] worskpace: temporary arrays data structure
!! @param[in] phi_flag: 1 if need to produce output potential
!! @param[out] phi_cav: Potential at cavity points. Referenced only if
!!      phi_flag=1
!! @param[in] grad_flag: 1 if need to produce gradient of potential
!! @param[out] gradphi_cav: Potential at cavity points. Referenced only if
!!      grad_flag=1
!! @param[in] hessian_flag: 1 if need to produce hessian of potential
!! @param[out] hessianphi_cav: Potential at cavity points. Referenced only if
!!      hessian_flag=1
subroutine mkrhs(params, constants, workspace, phi_flag, phi_cav, grad_flag, &
        & gradphi_cav, hessian_flag, hessianphi_cav, psi, charges)
    use ddx_core
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: phi_flag, grad_flag, hessian_flag
    real(dp), intent(out) :: phi_cav(constants % ncav)
    real(dp), intent(out) :: gradphi_cav(3, constants % ncav)
    real(dp), intent(out) :: hessianphi_cav(3, 3, constants % ncav)
    real(dp), intent(out) :: psi(constants % nbasis, &
        & params % nsph)
    real(dp), intent(in) :: charges(params % nsph)
    ! Local variables
    integer :: isph, igrid, icav, inode, jnear, jnode, jsph, i
    real(dp) :: d(3), v, tmpv, r, gradv(3), hessianv(3, 3), tmpd(3)
    real(dp), allocatable :: grid_grad(:,:,:), grid_hessian(:,:,:,:), &
        & grid_hessian2(:,:,:)
    real(dp), external :: dnrm2

    write(6, *) "Warning: subroutine mkrhs is deprecated"

    if (grad_flag .eq. 1) allocate(grid_grad(params % ngrid, 3, &
        & params % nsph))
    if (hessian_flag .eq. 1) allocate(grid_hessian(params % ngrid, &
        & 3, 3, params % nsph), grid_hessian2(params % ngrid, &
        & 3, params % nsph))

    ! In case FMM is disabled compute phi and gradphi at cavity points by a
    ! naive double loop of a quadratic complexity
    if (params % fmm .eq. 0) then
        do icav = 1, constants % ncav
            v = zero
            gradv = zero
            hessianv = zero
            do isph = 1, params % nsph
                d = constants % ccav(:, icav) - &
                    & params % csph(:, isph)
                r = dnrm2(3, d, 1)
                d = d / r
                tmpv = charges(isph) / r
                v = v + tmpv
                tmpv = tmpv / r
                tmpd = tmpv * d
                tmpv = tmpv / r
                gradv = gradv - tmpd
                tmpd = three / r * tmpd
                hessianv(:, 1) = hessianv(:, 1) + tmpd*d(1)
                hessianv(:, 2) = hessianv(:, 2) + tmpd*d(2)
                hessianv(:, 3) = hessianv(:, 3) + tmpd*d(3)
                hessianv(1, 1) = hessianv(1, 1) - tmpv
                hessianv(2, 2) = hessianv(2, 2) - tmpv
                hessianv(3, 3) = hessianv(3, 3) - tmpv
            end do
            if (phi_flag .eq. 1) then
                phi_cav(icav) = v
            end if
            if (grad_flag .eq. 1) then
                gradphi_cav(:, icav) = gradv
            end if
            if (hessian_flag .eq. 1) then
                hessianphi_cav(:, :, icav) = hessianv
            end if
        end do
    ! Use the FMM otherwise
    else
        ! P2M step from centers of harmonics
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            workspace % tmp_sph(1, isph) = &
                & charges(isph) &
                & / params % rsph(isph) / sqrt4pi
            workspace % tmp_sph(2:, isph) = zero
            workspace % tmp_node_m(1, inode) = &
                & workspace % tmp_sph(1, isph)
            workspace % tmp_node_m(2:, inode) = zero
        end do
        ! M2M, M2L and L2L translations

        call tree_m2m_rotation(params, constants, &
            & workspace % tmp_node_m)

        call tree_m2l_rotation(params, constants, &
            & workspace % tmp_node_m, workspace % tmp_node_l)

        call tree_l2l_rotation(params, constants, &
            & workspace % tmp_node_l)

        call tree_l2p(params, constants, one, &
            & workspace % tmp_node_l, zero, &
            & workspace % tmp_grid, workspace % tmp_sph_l)

        call tree_m2p(params, constants, &
            & params % lmax, one, workspace % tmp_sph, &
            & one, workspace % tmp_grid)

        ! Potential from each sphere to its own grid points
        call dgemm('T', 'N', params % ngrid, params % nsph, &
            & constants % nbasis, one, constants % vgrid2, &
            & constants % vgrid_nbasis, workspace % tmp_sph, &
            & constants % nbasis, one, workspace % tmp_grid, &
            & params % ngrid)

        ! Rearrange potential from all grid points to external only
        if (phi_flag.eq.1) then
            icav = 0
            do isph = 1, params % nsph
                do igrid = 1, params % ngrid
                    ! Do not count internal grid points
                    if(constants % ui(igrid, isph) .eq. zero) cycle
                    icav = icav + 1
                    phi_cav(icav) = workspace % tmp_grid(igrid, isph)
                end do
            end do
        end if

        ! Now compute near-field FMM gradients and hessians
        ! Cycle over all spheres
        if (grad_flag.eq.1 .or. hessian_flag.eq.1) then
            if (grad_flag.eq.1) grid_grad(:, :, :) = zero
            if (hessian_flag.eq.1) grid_hessian(:, :, :, :) = zero
            !$omp parallel do default(none) shared(params,constants,workspace, &
            !$omp grid_grad,grid_hessian,grad_flag,hessian_flag,charges) &
            !$omp private(isph,igrid,inode,jnear,jnode,jsph,d,r,tmpd,tmpv) &
            !$omp schedule(dynamic)
            do isph = 1, params % nsph
                ! Cycle over all external grid points
                do igrid = 1, params % ngrid
                    if(constants % ui(igrid, isph) .eq. zero) cycle
                    ! Cycle over all near-field admissible pairs of spheres,
                    ! including pair (isph, isph) which is a self-interaction
                    inode = constants % snode(isph)
                    do jnear = constants % snear(inode), &
                        & constants % snear(inode+1) - 1
                        ! Near-field interactions are possible only between leaf
                        ! nodes, which must contain only a single input sphere
                        jnode = constants % near(jnear)
                        jsph = constants % order( &
                            & constants % cluster(1, jnode))
                        d = params % csph(:, isph) + &
                            & constants % cgrid(:, igrid) &
                            & *params % rsph(isph) &
                            & - params % csph(:, jsph)
!                       r = dnrm2(3, d, 1)
                        r = sqrt(d(1)*d(1) + d(2)*d(2) + d(3)*d(3))
                        d = d / r / r
                        tmpv = charges(jsph) / r
                        if (grad_flag.eq.1) grid_grad(igrid, :, isph) = &
                            & grid_grad(igrid, :, isph) - tmpv * d
                        tmpd = three * tmpv * d
                        tmpv = tmpv / r / r
                        if (hessian_flag.eq.1) then
                            grid_hessian(igrid, 1, :, isph) = &
                                & grid_hessian(igrid, 1, :, isph) + d(1)*tmpd
                            grid_hessian(igrid, 2, :, isph) = &
                                & grid_hessian(igrid, 2, :, isph) + d(2)*tmpd
                            grid_hessian(igrid, 3, :, isph) = &
                                & grid_hessian(igrid, 3, :, isph) + d(3)*tmpd
                            grid_hessian(igrid, 1, 1, isph) = &
                                & grid_hessian(igrid, 1, 1, isph) - tmpv
                            grid_hessian(igrid, 2, 2, isph) = &
                                & grid_hessian(igrid, 2, 2, isph) - tmpv
                            grid_hessian(igrid, 3, 3, isph) = &
                                & grid_hessian(igrid, 3, 3, isph) - tmpv
                        end if
                    end do
                end do
            end do
        end if

        ! Take into account far-field FMM gradients only if pl > 0
        if ((params % pl .gt. 0) .and. (grad_flag.eq.1)) then
            ! Get gradient of L2L
            call tree_grad_l2l(params, constants, &
                & workspace % tmp_node_l, &
                & workspace % tmp_sph_l_grad, &
                & workspace % tmp_sph_l)
            ! Apply L2P for every axis with -1 multiplier since grad over
            ! target point is equal to grad over source point
            call dgemm('T', 'N', params % ngrid, &
                & 3*params % nsph, (params % pl)**2, &
                & -one, constants % vgrid2, &
                & constants % vgrid_nbasis, &
                & workspace % tmp_sph_l_grad, &
                & (params % pl+1)**2, one, grid_grad, &
                & params % ngrid)
        end if
        ! Take into account far-field FMM hessians only if pl > 1
        if ((params % pl .gt. 1) .and. (hessian_flag.eq.1)) then
            do i = 1, 3
                ! Load previously computed gradient into leaves, since
                ! tree_grad_l2l currently takes local expansions of entire
                ! tree. In future it might be changed.
                do isph = 1, params % nsph
                    inode = constants % snode(isph)
                    workspace % tmp_node_l(:, inode) = &
                        & workspace % tmp_sph_l_grad(:, i, isph)
                end do
                ! Get gradient of a gradient of L2L. Currently this uses input
                ! pl maximal degree of local harmonics but in reality we need
                ! only pl-1 maximal degree since coefficients of harmonics of a
                ! degree pl are zeros.
                call tree_grad_l2l(params, constants, &
                    & workspace % tmp_node_l, &
                    & workspace % tmp_sph_l_grad2, &
                    & workspace % tmp_sph_l)
                ! Apply L2P for every axis
                call dgemm('T', 'N', params % ngrid, &
                    & 3*params % nsph, (params % pl-1)**2, &
                    & one, constants % vgrid2, &
                    & constants % vgrid_nbasis, &
                    & workspace % tmp_sph_l_grad2, &
                    & (params % pl+1)**2, zero, grid_hessian2, &
                    & params % ngrid)
                ! Properly copy hessian
                grid_hessian(:, i, :, :) = grid_hessian(:, i, :, :) + grid_hessian2
            end do
        end if

        ! Copy output for external grid points only
        icav = 0
        do isph = 1, params % nsph
            do igrid = 1, params % ngrid
                if(constants % ui(igrid, isph) .eq. zero) cycle
                icav = icav + 1
                if (grad_flag .eq. 1) gradphi_cav(:, icav) = &
                    & grid_grad(igrid, :, isph)
                if (hessian_flag .eq. 1) hessianphi_cav(:, :, icav) = &
                    & grid_hessian(igrid, :, :, isph)
            end do
        end do
    end if

    ! Vector psi
    psi(2:, :) = zero
    do isph = 1, params % nsph
        psi(1, isph) = sqrt4pi * charges(isph)
    end do

    ! deallocate temporary
    if (grad_flag .eq. 1) deallocate(grid_grad)
    if (hessian_flag .eq. 1) deallocate(grid_hessian, grid_hessian2)
end subroutine mkrhs

!> Main solver routine
!!
!! Solves the problem within COSMO model using a domain decomposition approach.
!!
!! @param[in] ddx_data: ddX object with all input information
!! @param[in] phi_cav: Potential at cavity points
!! @param[in] e_cav: Gradient of the eletric potential at cavity points
!! @param[in] hessianphi_cav: Hessian of the eletric potential at cavity points
!! @param[inout] state: ddx state (contains RHSs and solutions)
!! @param[in] psi: RHS of the adjoint problem
!! @param[in] tol
!! @param[out] esolv: Solvation energy
!! @param[out] force: Analytical forces
!! @param[inout] ddx_error: ddX error
!!
subroutine ddsolve_legacy(ddx_data, state, phi_cav, e_cav, hessianphi_cav, &
        & psi, tol, esolv, force, ddx_error)
    ! Inputs
    type(ddx_type), intent(inout) :: ddx_data
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: phi_cav(ddx_data % constants % ncav), &
        & e_cav(3, ddx_data % constants % ncav), &
        & hessianphi_cav(3, ddx_data % constants % ncav), &
        & psi(ddx_data % constants % nbasis, ddx_data % params % nsph), tol
    ! Outputs
    real(dp), intent(out) :: esolv, force(3, ddx_data % params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error

    write(6, *) "Warning: subroutine ddsolve_legacy is deprecated"

    ! Find proper model
    select case(ddx_data % params % model)
        ! COSMO model
        case (1)
            call ddcosmo(ddx_data % params, ddx_data % constants, &
                & ddx_data % workspace, state, phi_cav, psi, e_cav, &
                & tol, esolv, force, ddx_error)
        ! PCM model
        case (2)
            call ddpcm(ddx_data % params, ddx_data % constants, &
                & ddx_data % workspace, state, phi_cav, psi, e_cav, &
                & tol, esolv, force, ddx_error)
        ! LPB model
        case (3)
            call ddlpb(ddx_data % params, ddx_data % constants, &
                & ddx_data % workspace, state, phi_cav, e_cav, &
                & psi, tol, esolv, hessianphi_cav, force, ddx_error)
        ! Error case
        case default
            call update_error(ddx_error, "unsupported solvation " // &
                & " model in the dd solver.")
            return
    end select
end subroutine ddsolve_legacy

!> ddCOSMO solver
!!
!! Solves the problem within COSMO model using a domain decomposition approach.
!!
!> @ingroup Fortran_interface_ddcosmo
!! @param[in] params: User specified parameters
!! @param[in] constants: Precomputed constants
!! @param[inout] workspace: Preallocated workspaces
!! @param[inout] state: ddx state (contains solutions and RHSs)
!! @param[in] phi_cav: Potential at cavity points, size (ncav)
!! @param[in] psi: Representation of the solute potential in spherical
!!     harmonics, size (nbasis, nsph)
!! @param[in] tol: Tolerance for the linear system solver
!! @param[out] esolv: Solvation energy
!! @param[out] force: Solvation contribution to the forces
!! @param[inout] ddx_error: ddX error
!!
subroutine ddcosmo(params, constants, workspace, state, phi_cav, &
        & psi, e_cav, tol, esolv, force, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: phi_cav(constants % ncav), &
        & psi(constants % nbasis, params % nsph), tol
    real(dp), intent(out) :: esolv
    real(dp), intent(in) :: e_cav(3, constants % ncav)
    real(dp), intent(out), optional :: force(3, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error

    write(6, *) "Warning: subroutine ddcosmo is deprecated"

    call cosmo_setup(params, constants, workspace, state, phi_cav, psi, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "ddlpb: ddcosmo_setup returned an error, exiting")
        return
    end if
    call cosmo_guess(params, constants, workspace, state, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "ddlpb: ddcosmo_guess returned an error, exiting")
        return
    end if
    call cosmo_solve(params, constants, workspace, state, tol, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "ddlpb: ddcosmo_solve returned an error, exiting")
        return
    end if

    call cosmo_energy(constants, state, esolv, ddx_error)

    ! Get forces if needed
    if (params % force .eq. 1) then
        ! solve the adjoint
        call cosmo_guess_adjoint(params, constants, workspace, state, ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, &
                & "ddlpb: ddcosmo_guess_adjoint returned an error, exiting")
            return
        end if
        call cosmo_solve_adjoint(params, constants, workspace, state, tol, &
            & ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, &
                & "ddlpb: ddcosmo_guess_adjoint returned an error, exiting")
            return
        end if

        ! evaluate the solvent unspecific contribution analytical derivatives
        force = zero
        call cosmo_solvation_force_terms(params, constants, workspace, &
            & state, e_cav, force, ddx_error)
    end if
end subroutine ddcosmo

!> ddPCM solver
!!
!! Solves the problem within PCM model using a domain decomposition approach.
!!
!> @ingroup Fortran_interface_ddpcm
!! @param[in] params: User specified parameters
!! @param[in] constants: Precomputed constants
!! @param[inout] workspace: Preallocated workspaces
!! @param[inout] state: ddx state (contains solutions and RHSs)
!! @param[in] phi_cav: Potential at cavity points, size (ncav)
!! @param[in] psi: Representation of the solute potential in spherical
!!     harmonics, size (nbasis, nsph)
!! @param[in] tol: Tolerance for the linear system solver
!! @param[out] esolv: Solvation energy
!! @param[out] force: Solvation contribution to the forces
!! @param[inout] ddx_error: ddX error
!!
subroutine ddpcm(params, constants, workspace, state, phi_cav, &
        & psi, e_cav, tol, esolv, force, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(in) :: phi_cav(constants % ncav), &
        & psi(constants % nbasis, params % nsph), tol
    real(dp), intent(out) :: esolv
    real(dp), intent(in) :: e_cav(3, constants % ncav)
    real(dp), intent(out), optional :: force(3, params % nsph)

    write(6, *) "Warning: subroutine ddpcm is deprecated"

    call pcm_setup(params, constants, workspace, state, phi_cav, psi, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "ddlpb: ddpcm_setup returned an error, exiting")
        return
    end if
    call pcm_guess(params, constants, workspace, state, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "ddlpb: ddpcm_guess returned an error, exiting")
        return
    end if
    call pcm_solve(params, constants, workspace, state, tol, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "ddlpb: ddpcm_solve returned an error, exiting")
        return
    end if

    call pcm_energy(constants, state, esolv, ddx_error)

    ! Get forces if needed
    if (params % force .eq. 1) then
        ! solve the adjoint
        call pcm_guess_adjoint(params, constants, workspace, state, ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, &
                & "ddlpb: ddpcm_guess_adjoint returned an error, exiting")
            return
        end if
        call pcm_solve_adjoint(params, constants, workspace, state, &
            & tol, ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, &
                & "ddlpb: ddpcm_guess_adjoint returned an error, exiting")
            return
        end if

        ! evaluate the solvent unspecific contribution analytical derivatives
        force = zero
        call pcm_solvation_force_terms(params, constants, workspace, &
            & state, e_cav, force, ddx_error)
    end if

end subroutine ddpcm

!> ddLPB solver
!!
!! Solves the LPB problem using a domain decomposition approach.
!!
!! @param[in] params: User specified parameters
!! @param[in] constants: Precomputed constants
!! @param[inout] workspace: Preallocated workspaces
!! @param[inout] state: ddx state (contains solutions and RHSs)
!! @param[in] phi_cav: Potential at cavity points, size (ncav)
!! @params[in] e_cav: Electric field at cavity points, size (3, ncav)
!! @param[in] psi: Representation of the solute potential in spherical
!!     harmonics, size (nbasis, nsph)
!! @param[in] tol: Tolerance for the linear system solver
!! @param[out] esolv: Solvation energy
!! @param[out] force: Solvation contribution to the forces
!! @param[inout] ddx_error: ddX error
!!
subroutine ddlpb(params, constants, workspace, state, phi_cav, e_cav, &
        & psi, tol, esolv, hessianphi_cav, force, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: phi_cav(constants % ncav), &
        & e_cav(3, constants % ncav), &
        & psi( constants % nbasis,  params % nsph), tol
    real(dp), intent(out) :: esolv
    real(dp), intent(out), optional :: force(3, params % nsph)
    real(dp), intent(in), optional :: hessianphi_cav(3, 3, constants % ncav)
    type(ddx_error_type), intent(inout) :: ddx_error

    write(6, *) "Warning: subroutine ddlpb is deprecated"

    call lpb_setup(params, constants, workspace, state, phi_cav, &
        & e_cav, psi, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "ddlpb: ddlpb_setup returned an error, exiting")
        return
    end if
    call lpb_guess(params, constants, workspace, state, tol, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "ddlpb: ddlpb_guess returned an error, exiting")
        return
    end if
    call lpb_solve(params, constants, workspace, state, tol, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "ddlpb: ddlpb_solve returned an error, exiting")
        return
    end if

    ! Compute the solvation energy
    call lpb_energy(constants, state, esolv, ddx_error)

    ! Get forces if needed
    if(params % force .eq. 1) then
        call lpb_guess_adjoint(params, constants, workspace, state, tol, ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, &
                & "ddlpb: ddlpb_guess_adjoint returned an error, exiting")
            return
        end if
        call lpb_solve_adjoint(params, constants, workspace, state, tol, ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, &
                & "ddlpb: ddlpb_solve_adjoint returned an error, exiting")
            return
        end if
        call lpb_solvation_force_terms(params, constants, workspace, &
            & state, hessianphi_cav, force, ddx_error)
    endif

end subroutine ddlpb


end module ddx_legacy

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/api
!> Provides C API bindings for tblite library

!> @file tblite/api/version.f90
!> Provides a stable version query with #tblite_get_version.

!> API export for the version information of the library
module tblite_api_version
   use, intrinsic :: iso_c_binding
   use tblite_version, only : get_tblite_version
   implicit none
   private

   public :: get_version_api, namespace

   character(len=*), parameter :: namespace = "tblite_"

contains


!> Obtain library version as major * 10000 + minor + 100 + patch
function get_version_api() result(version) &
      & bind(C, name=namespace//"get_version")
   integer(c_int) :: version
   integer :: major, minor, patch

   call get_tblite_version(major, minor, patch)
   version = 10000_c_int * major + 100_c_int * minor + patch

end function get_version_api


end module tblite_api_version

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module test_symbols
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check
   use mctc_io_symbols
   implicit none
   private

   public :: collect_symbols


contains


!> Collect all exported unit tests
subroutine collect_symbols(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("valid-num-ids", test_num_ids), &
      & new_unittest("valid-sym-ids", test_sym_ids), &
      & new_unittest("valid-num", test_valid_num), &
      & new_unittest("valid-pse", test_valid_pse), &
      & new_unittest("valid-sym", test_valid_sym) &
      & ]

end subroutine collect_symbols


subroutine test_valid_sym(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check(error, to_number("K"), 19, "Wrong atomic number for alium")
   if (allocated(error)) return

   call check(error, to_number("ca "), 20, "Could not identify calcium")
   if (allocated(error)) return

   call check(error, to_number(" aU "), 79, "Could not identify gold")
   if (allocated(error)) return

   call check(error, to_number("CN*"), 112, "Could not identify coperneticum")
   if (allocated(error)) return

   call check(error, to_number("*sn"), 50, "Could not identify tin")
   if (allocated(error)) return

   call check(error, to_number("d"), 1, "Could not identify deuterium")
   if (allocated(error)) return

end subroutine test_valid_sym


subroutine test_valid_num(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check(error, to_symbol(19), "K", "Wrong atomic number for alium")
   if (allocated(error)) return

   call check(error, to_symbol(20), "Ca", "Could not identify calcium")
   if (allocated(error)) return

   call check(error, to_symbol(79), "Au", "Could not identify gold")
   if (allocated(error)) return

   call check(error, to_symbol(112), "Cn", "Could not identify coperneticum")
   if (allocated(error)) return

   call check(error, to_symbol(50), "Sn", "Could not identify tin")
   if (allocated(error)) return

   call check(error, to_symbol(1), "H", "Could not identify hydrogen")
   if (allocated(error)) return

end subroutine test_valid_num


subroutine test_valid_pse(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: num
   character(len=symbol_length) :: sym

   do num = 1, 118
      sym = to_symbol(num)
      call check(error, to_number(sym), num, "Could not match all elements of the PSE")
      if (allocated(error)) exit
   end do

end subroutine test_valid_pse


subroutine test_sym_ids(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: nid
   integer, allocatable :: ids(:)
   character(symbol_length), allocatable :: sym(:)

   sym = [character(symbol_length) :: &
      & 'Al', 'Ca', 'Ti', 'O ', 'F ', 'Ga', 'Ca', 'Ti', 'S ', 'Cl', 'O ', 'O ']

   allocate(ids(size(sym)))
   call get_identity(nid, ids, sym)

   call check(error, nid, 8, "Expected eight unique element symbols")
   if (allocated(error)) return

   call check(error, minval(ids), 1, "Lower bound of IDs is not one")
   if (allocated(error)) return

   call check(error, maxval(ids), nid, "Upper bound of IDs is not number of IDs")

end subroutine test_sym_ids


subroutine test_num_ids(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: nid
   integer, allocatable :: ids(:)
   integer, allocatable :: num(:)

   num = [integer :: &
      & 1, 2, 8, 112, 112, 7, 7, 19, 19, 1, 2, 112, 7, 12, 19, 7, 3, 2, 2]

   allocate(ids(size(num)))
   call get_identity(nid, ids, num)

   call check(error, nid, 8, "Expected eight unique atomic numbers")
   if (allocated(error)) return

   call check(error, minval(ids), 1, "Lower bound of IDs is not one")
   if (allocated(error)) return

   call check(error, maxval(ids), nid, "Upper bound of IDs is not number of IDs")

end subroutine test_num_ids


end module test_symbols

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/blas/level1.f90
!> Provides interfactes to level 1 BLAS routines

!> High-level interface to level 1 basic linear algebra subprogram operations
module tblite_blas_level1
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_dot


   !> Forms the dot product of two vectors.
   interface wrap_dot
      module procedure :: wrap_sdot
      module procedure :: wrap_ddot
      module procedure :: wrap_sdot12
      module procedure :: wrap_sdot21
      module procedure :: wrap_sdot22
      module procedure :: wrap_ddot12
      module procedure :: wrap_ddot21
      module procedure :: wrap_ddot22
   end interface wrap_dot


   !> Forms the dot product of two vectors.
   !> Uses unrolled loops for increments equal to one.
   interface blas_dot
      pure function sdot(n, x, incx, y, incy)
         import :: sp
         real(sp) :: sdot
         real(sp), intent(in) :: x(*)
         real(sp), intent(in) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end function sdot
      pure function ddot(n, x, incx, y, incy)
         import :: dp
         real(dp) :: ddot
         real(dp), intent(in) :: x(*)
         real(dp), intent(in) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end function ddot
   end interface blas_dot


contains


function wrap_sdot(xvec, yvec) result(dot)
   real(sp) :: dot
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(in) :: yvec(:)
   integer :: incx, incy, n
   incx = 1
   incy = 1
   n = size(xvec)
   dot = blas_dot(n, xvec, incx, yvec, incy)
end function wrap_sdot


function wrap_ddot(xvec, yvec) result(dot)
   real(dp) :: dot
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(in) :: yvec(:)
   integer :: incx, incy, n
   incx = 1
   incy = 1
   n = size(xvec)
   dot = blas_dot(n, xvec, incx, yvec, incy)
end function wrap_ddot


function wrap_sdot12(xvec, yvec) result(dot)
   real(sp) :: dot
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(in), contiguous, target :: yvec(:, :)
   real(sp), pointer :: yptr(:)
   yptr(1:size(yvec)) => yvec
   dot = wrap_dot(xvec, yptr)
end function wrap_sdot12


function wrap_sdot21(xvec, yvec) result(dot)
   real(sp) :: dot
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(in) :: yvec(:)
   real(sp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   dot = wrap_dot(xptr, yvec)
end function wrap_sdot21


function wrap_sdot22(xvec, yvec) result(dot)
   real(sp) :: dot
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(in), contiguous, target :: yvec(:, :)
   real(sp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   dot = wrap_dot(xptr, yptr)
end function wrap_sdot22


function wrap_ddot12(xvec, yvec) result(dot)
   real(dp) :: dot
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(in), contiguous, target :: yvec(:, :)
   real(dp), pointer :: yptr(:)
   yptr(1:size(yvec)) => yvec
   dot = wrap_dot(xvec, yptr)
end function wrap_ddot12


function wrap_ddot21(xvec, yvec) result(dot)
   real(dp) :: dot
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(in) :: yvec(:)
   real(dp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   dot = wrap_dot(xptr, yvec)
end function wrap_ddot21


function wrap_ddot22(xvec, yvec) result(dot)
   real(dp) :: dot
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(in), contiguous, target :: yvec(:, :)
   real(dp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   dot = wrap_dot(xptr, yptr)
end function wrap_ddot22


end module tblite_blas_level1

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/container/cache.f90
!> Provides a cache for use with interaction containers

!> Definition of restart data cache
module tblite_container_cache
   implicit none
   private

   public :: resize

   !> Restart data for an interaction container
   type, public :: container_cache
      !> Label identifying this contribution
      character(len=:), allocatable :: label
      !> Actual restart data
      class(*), allocatable :: raw
   end type container_cache


   !> Reallocate list of containers
   interface resize
      module procedure :: resize_cache
   end interface


contains


!> Reallocate list of containers
subroutine resize_cache(list, n)
   !> Instance of the array to be resized
   type(container_cache), allocatable, intent(inout) :: list(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(container_cache), allocatable :: tmp(:)
   integer, parameter :: initial_size = 20
   integer :: this_size, new_size, item

   if (allocated(list)) then
      this_size = size(list, 1)
      call move_alloc(list, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(list(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(list, 1))
      do item = 1, this_size
         call move_alloc(tmp(item)%raw, list(item)%raw)
         call move_alloc(tmp(item)%label, list(item)%label)
      end do
      deallocate(tmp)
   end if

end subroutine resize_cache


end module tblite_container_cache

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/io/numpy/crc32.f90
!> Provide crc32 hashing function

!> Implementation of cyclic redundancy check hashing function,
!> used to check the integrity of data in zip files.
module tblite_io_numpy_crc32
   use mctc_env, only : i4, dp
   implicit none
   private

   public :: crc32_hash

   !> Compute crc32 checksum
   interface crc32_hash
      module procedure crc32_hash_char_r0
      module procedure crc32_hash_char_r1
      module procedure crc32_hash_i4_r1
      module procedure crc32_hash_rdp_r1
   end interface crc32_hash

   integer(i4), parameter :: crc_table(0:255) = [ &
      & int(z'00000000', i4), int(z'77073096', i4), int(z'ee0e612c', i4), int(z'990951ba', i4), &
      & int(z'076dc419', i4), int(z'706af48f', i4), int(z'e963a535', i4), int(z'9e6495a3', i4), &
      & int(z'0edb8832', i4), int(z'79dcb8a4', i4), int(z'e0d5e91e', i4), int(z'97d2d988', i4), &
      & int(z'09b64c2b', i4), int(z'7eb17cbd', i4), int(z'e7b82d07', i4), int(z'90bf1d91', i4), &
      & int(z'1db71064', i4), int(z'6ab020f2', i4), int(z'f3b97148', i4), int(z'84be41de', i4), &
      & int(z'1adad47d', i4), int(z'6ddde4eb', i4), int(z'f4d4b551', i4), int(z'83d385c7', i4), &
      & int(z'136c9856', i4), int(z'646ba8c0', i4), int(z'fd62f97a', i4), int(z'8a65c9ec', i4), &
      & int(z'14015c4f', i4), int(z'63066cd9', i4), int(z'fa0f3d63', i4), int(z'8d080df5', i4), &
      & int(z'3b6e20c8', i4), int(z'4c69105e', i4), int(z'd56041e4', i4), int(z'a2677172', i4), &
      & int(z'3c03e4d1', i4), int(z'4b04d447', i4), int(z'd20d85fd', i4), int(z'a50ab56b', i4), &
      & int(z'35b5a8fa', i4), int(z'42b2986c', i4), int(z'dbbbc9d6', i4), int(z'acbcf940', i4), &
      & int(z'32d86ce3', i4), int(z'45df5c75', i4), int(z'dcd60dcf', i4), int(z'abd13d59', i4), &
      & int(z'26d930ac', i4), int(z'51de003a', i4), int(z'c8d75180', i4), int(z'bfd06116', i4), &
      & int(z'21b4f4b5', i4), int(z'56b3c423', i4), int(z'cfba9599', i4), int(z'b8bda50f', i4), &
      & int(z'2802b89e', i4), int(z'5f058808', i4), int(z'c60cd9b2', i4), int(z'b10be924', i4), &
      & int(z'2f6f7c87', i4), int(z'58684c11', i4), int(z'c1611dab', i4), int(z'b6662d3d', i4), &
      & int(z'76dc4190', i4), int(z'01db7106', i4), int(z'98d220bc', i4), int(z'efd5102a', i4), &
      & int(z'71b18589', i4), int(z'06b6b51f', i4), int(z'9fbfe4a5', i4), int(z'e8b8d433', i4), &
      & int(z'7807c9a2', i4), int(z'0f00f934', i4), int(z'9609a88e', i4), int(z'e10e9818', i4), &
      & int(z'7f6a0dbb', i4), int(z'086d3d2d', i4), int(z'91646c97', i4), int(z'e6635c01', i4), &
      & int(z'6b6b51f4', i4), int(z'1c6c6162', i4), int(z'856530d8', i4), int(z'f262004e', i4), &
      & int(z'6c0695ed', i4), int(z'1b01a57b', i4), int(z'8208f4c1', i4), int(z'f50fc457', i4), &
      & int(z'65b0d9c6', i4), int(z'12b7e950', i4), int(z'8bbeb8ea', i4), int(z'fcb9887c', i4), &
      & int(z'62dd1ddf', i4), int(z'15da2d49', i4), int(z'8cd37cf3', i4), int(z'fbd44c65', i4), &
      & int(z'4db26158', i4), int(z'3ab551ce', i4), int(z'a3bc0074', i4), int(z'd4bb30e2', i4), &
      & int(z'4adfa541', i4), int(z'3dd895d7', i4), int(z'a4d1c46d', i4), int(z'd3d6f4fb', i4), &
      & int(z'4369e96a', i4), int(z'346ed9fc', i4), int(z'ad678846', i4), int(z'da60b8d0', i4), &
      & int(z'44042d73', i4), int(z'33031de5', i4), int(z'aa0a4c5f', i4), int(z'dd0d7cc9', i4), &
      & int(z'5005713c', i4), int(z'270241aa', i4), int(z'be0b1010', i4), int(z'c90c2086', i4), &
      & int(z'5768b525', i4), int(z'206f85b3', i4), int(z'b966d409', i4), int(z'ce61e49f', i4), &
      & int(z'5edef90e', i4), int(z'29d9c998', i4), int(z'b0d09822', i4), int(z'c7d7a8b4', i4), &
      & int(z'59b33d17', i4), int(z'2eb40d81', i4), int(z'b7bd5c3b', i4), int(z'c0ba6cad', i4), &
      & int(z'edb88320', i4), int(z'9abfb3b6', i4), int(z'03b6e20c', i4), int(z'74b1d29a', i4), &
      & int(z'ead54739', i4), int(z'9dd277af', i4), int(z'04db2615', i4), int(z'73dc1683', i4), &
      & int(z'e3630b12', i4), int(z'94643b84', i4), int(z'0d6d6a3e', i4), int(z'7a6a5aa8', i4), &
      & int(z'e40ecf0b', i4), int(z'9309ff9d', i4), int(z'0a00ae27', i4), int(z'7d079eb1', i4), &
      & int(z'f00f9344', i4), int(z'8708a3d2', i4), int(z'1e01f268', i4), int(z'6906c2fe', i4), &
      & int(z'f762575d', i4), int(z'806567cb', i4), int(z'196c3671', i4), int(z'6e6b06e7', i4), &
      & int(z'fed41b76', i4), int(z'89d32be0', i4), int(z'10da7a5a', i4), int(z'67dd4acc', i4), &
      & int(z'f9b9df6f', i4), int(z'8ebeeff9', i4), int(z'17b7be43', i4), int(z'60b08ed5', i4), &
      & int(z'd6d6a3e8', i4), int(z'a1d1937e', i4), int(z'38d8c2c4', i4), int(z'4fdff252', i4), &
      & int(z'd1bb67f1', i4), int(z'a6bc5767', i4), int(z'3fb506dd', i4), int(z'48b2364b', i4), &
      & int(z'd80d2bda', i4), int(z'af0a1b4c', i4), int(z'36034af6', i4), int(z'41047a60', i4), &
      & int(z'df60efc3', i4), int(z'a867df55', i4), int(z'316e8eef', i4), int(z'4669be79', i4), &
      & int(z'cb61b38c', i4), int(z'bc66831a', i4), int(z'256fd2a0', i4), int(z'5268e236', i4), &
      & int(z'cc0c7795', i4), int(z'bb0b4703', i4), int(z'220216b9', i4), int(z'5505262f', i4), &
      & int(z'c5ba3bbe', i4), int(z'b2bd0b28', i4), int(z'2bb45a92', i4), int(z'5cb36a04', i4), &
      & int(z'c2d7ffa7', i4), int(z'b5d0cf31', i4), int(z'2cd99e8b', i4), int(z'5bdeae1d', i4), &
      & int(z'9b64c2b0', i4), int(z'ec63f226', i4), int(z'756aa39c', i4), int(z'026d930a', i4), &
      & int(z'9c0906a9', i4), int(z'eb0e363f', i4), int(z'72076785', i4), int(z'05005713', i4), &
      & int(z'95bf4a82', i4), int(z'e2b87a14', i4), int(z'7bb12bae', i4), int(z'0cb61b38', i4), &
      & int(z'92d28e9b', i4), int(z'e5d5be0d', i4), int(z'7cdcefb7', i4), int(z'0bdbdf21', i4), &
      & int(z'86d3d2d4', i4), int(z'f1d4e242', i4), int(z'68ddb3f8', i4), int(z'1fda836e', i4), &
      & int(z'81be16cd', i4), int(z'f6b9265b', i4), int(z'6fb077e1', i4), int(z'18b74777', i4), &
      & int(z'88085ae6', i4), int(z'ff0f6a70', i4), int(z'66063bca', i4), int(z'11010b5c', i4), &
      & int(z'8f659eff', i4), int(z'f862ae69', i4), int(z'616bffd3', i4), int(z'166ccf45', i4), &
      & int(z'a00ae278', i4), int(z'd70dd2ee', i4), int(z'4e048354', i4), int(z'3903b3c2', i4), &
      & int(z'a7672661', i4), int(z'd06016f7', i4), int(z'4969474d', i4), int(z'3e6e77db', i4), &
      & int(z'aed16a4a', i4), int(z'd9d65adc', i4), int(z'40df0b66', i4), int(z'37d83bf0', i4), &
      & int(z'a9bcae53', i4), int(z'debb9ec5', i4), int(z'47b2cf7f', i4), int(z'30b5ffe9', i4), &
      & int(z'bdbdf21c', i4), int(z'cabac28a', i4), int(z'53b39330', i4), int(z'24b4a3a6', i4), &
      & int(z'bad03605', i4), int(z'cdd70693', i4), int(z'54de5729', i4), int(z'23d967bf', i4), &
      & int(z'b3667a2e', i4), int(z'c4614ab8', i4), int(z'5d681b02', i4), int(z'2a6f2b94', i4), &
      & int(z'b40bbe37', i4), int(z'c30c8ea1', i4), int(z'5a05df1b', i4), int(z'2d02ef8d', i4)]

contains

!> Compute crc32 checksum for a character string
pure function crc32_hash_char_r0(val, crc_in) result(crc)
   !> Previous crc32 checksum to continue from
   integer(i4), intent(in), optional :: crc_in
   !> Value to hash
   character(len=*), intent(in) :: val
   !> Resulting crc32 checksum
   integer(i4) :: crc
   integer :: ii

   if (present(crc_in)) then
      crc = crc_in
   else
      crc = 0_i4
   end if
   crc = not(crc)
   do ii = 1, len(val)
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(val(ii:ii))), 255)))
   enddo
   crc = not(crc)
end function crc32_hash_char_r0

!> Compute crc32 checksum for a character array
pure function crc32_hash_char_r1(val, crc_in) result(crc)
   !> Previous crc32 checksum to continue from
   integer(i4), intent(in), optional :: crc_in
   !> Value to hash
   character(len=1), intent(in) :: val(:)
   !> Resulting crc32 checksum
   integer(i4) :: crc
   integer :: ii

   if (present(crc_in)) then
      crc = crc_in
   else
      crc = 0_i4
   end if
   crc = not(crc)
   do ii = 1, size(val)
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(val(ii))), 255)))
   enddo
   crc = not(crc)
end function crc32_hash_char_r1

!> Compute crc32 checksum for a 4-byte integer array
pure function crc32_hash_i4_r1(val, crc_in) result(crc)
   !> Previous crc32 checksum to continue from
   integer(i4), intent(in), optional :: crc_in
   !> Value to hash
   integer(i4), intent(in) :: val(:)
   !> Resulting crc32 checksum
   integer(i4) :: crc
   integer :: ii

   character(len=1) :: chunk(4)

   if (present(crc_in)) then
      crc = crc_in
   else
      crc = 0_i4
   end if
   crc = not(crc)
   do ii = 1, size(val)
      chunk = transfer(val(ii), chunk)
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(chunk(1))), 255)))
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(chunk(2))), 255)))
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(chunk(3))), 255)))
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(chunk(4))), 255)))
   enddo
   crc = not(crc)
end function crc32_hash_i4_r1

!> Compute crc32 checksum for a real array
pure function crc32_hash_rdp_r1(val, crc_in) result(crc)
   !> Previous crc32 checksum to continue from
   integer(i4), intent(in), optional :: crc_in
   !> Value to hash
   real(dp), intent(in) :: val(:)
   !> Resulting crc32 checksum
   integer(i4) :: crc
   integer :: ii

   character(len=1) :: chunk(8)

   if (present(crc_in)) then
      crc = crc_in
   else
      crc = 0_i4
   end if
   crc = not(crc)
   do ii = 1, size(val)
      chunk = transfer(val(ii), chunk)
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(chunk(1))), 255)))
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(chunk(2))), 255)))
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(chunk(3))), 255)))
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(chunk(4))), 255)))
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(chunk(5))), 255)))
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(chunk(6))), 255)))
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(chunk(7))), 255)))
      crc = ieor(shiftr(crc, 8), crc_table(iand(ieor(crc, iachar(chunk(8))), 255)))
   enddo
   crc = not(crc)
end function crc32_hash_rdp_r1

end module tblite_io_numpy_crc32

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file tests/force.f90
!! Test of analytical forces against numerical for ddLPB
!!
!! @version 1.0.0
!! @author Abhinav Jha
!! @date 2021-02-25

program main
use ddx_core
use ddx_operators
use ddx_solvers
use ddx
use ddx_lpb
use ddx_legacy
implicit none

character(len=255) :: fname
type(ddx_type) :: ddx_data
type(ddx_error_type) :: ddx_error
type(ddx_state_type) :: state

real(dp), allocatable :: phi_cav(:), gradphi_cav(:, :), &
                       & hessianphi_cav(:,:,:), psi(:, :), &
                       & force(:, :), force_num(:, :), charges(:)
real(dp) :: esolv, esolv_plus_h, esolv_minus_h, &
          & step = 2.d-5, relerr, tol
integer :: isph, i
real(dp), external :: dnrm2
character(len=255) :: dummy_file_name = ''

! Read input file name
call get_command_argument(1, fname)
write(*, *) "Using provided file ", trim(fname), " as a config file"
call ddfromfile(fname, ddx_data, tol, charges, ddx_error)
call check_error(ddx_error)
call allocate_state(ddx_data % params, ddx_data % constants, state, ddx_error)
call check_error(ddx_error)

! Allocation for variable vectors
allocate(phi_cav(ddx_data % constants % ncav), gradphi_cav(3, ddx_data % constants % ncav), &
       & hessianphi_cav(3,3,ddx_data % constants % ncav), &
       & psi(ddx_data % constants % nbasis, ddx_data % params % nsph), &
       & force(3, ddx_data % params % nsph), &
       & force_num(3, ddx_data % params % nsph))

gradphi_cav = zero
phi_cav = zero
hessianphi_cav = zero
psi = zero
esolv = zero
force = zero
force_num = zero
relerr = zero
esolv_plus_h = zero
esolv_minus_h = zero


call mkrhs(ddx_data % params, ddx_data % constants, ddx_data % workspace, &
    & 1, phi_cav, 1, gradphi_cav, 1, hessianphi_cav, psi, charges)
gradphi_cav = - gradphi_cav

call ddlpb(ddx_data % params, ddx_data % constants, ddx_data % workspace, &
    & state, phi_cav, gradphi_cav, psi, tol, esolv, hessianphi_cav, force, ddx_error)
call check_error(ddx_error)

! add the solute specific contributions to the forces
call grad_phi_for_charges(ddx_data % params, &
    & ddx_data % constants, ddx_data % workspace, state, &
    & charges, force, ddx_error)
call check_error(ddx_error)
call grad_e_for_charges(ddx_data % params, ddx_data % constants, &
    & ddx_data % workspace, state, charges, force, ddx_error)
call check_error(ddx_error)

do isph = 1, ddx_data % params % nsph
  do i = 1, 3
    esolv_plus_h = zero
    esolv_minus_h = zero
    ddx_data % params % csph(i, isph) = ddx_data % params % csph(i, isph) + step
    call test_solve(ddx_data, esolv_plus_h, tol, charges)
    ddx_data % params % csph(i, isph) = ddx_data % params % csph(i, isph) - step
    !call test_solve(ddx_data, esolv_minus_h)
    !write(*,*) 'esolv  :', esolv, 'esolv+h  : ', esolv_plus_h, ' , esolv : ', esolv_minus_h, ' , step :', step
    force_num(i, isph) = (esolv_plus_h - esolv) / step
    if(abs(force_num(i,isph)) .le. 1.d-8) force_num(i,isph) = zero
    if(abs(force(i,isph)) .le. 1.d-8) force(i,isph) = zero
  end do
end do
! force is minus the gradient
relerr = dnrm2(3*ddx_data % params % nsph, force_num-force, 1) / &
    & dnrm2(3*ddx_data % params % nsph, force, 1)

write(6,'(2A60)') 'Analytical forces', 'Numerical forces'
do i = 1, ddx_data % params % nsph
  write(6,'(6E20.10)') force(1,i), force(2,i), force(3,i), force_num(1,i), &
      & force_num(2,i), force_num(3,i)
end do

deallocate(phi_cav, gradphi_cav, hessianphi_cav, psi, force, force_num, charges)

call deallocate_state(state, ddx_error)
call deallocate_model(ddx_data, ddx_error)

write(*, *) "Rel.ddx_error of forces:", relerr
if (relerr .gt. 1.d-5) stop 1
contains

subroutine test_solve(ddx_data, esolv_in, tol, charges)
    implicit none
    type(ddx_type), intent(inout) :: ddx_data
    real(dp), intent(inout) :: esolv_in
    real(dp), intent(in) ::tol
    real(dp), intent(in) :: charges(ddx_data % params % nsph)

    type(ddx_type) :: ddx_data2
    type(ddx_error_type) :: error2
    type(ddx_state_type) :: state
    real(dp), allocatable :: phi_cav2(:)
    real(dp), allocatable :: gradphi_cav2(:,:)
    real(dp), allocatable :: hessianphi_cav2(:,:,:)
    real(dp), allocatable :: psi2(:,:)
    real(dp), allocatable :: force2(:,:)

    call allocate_model(ddx_data % params % nsph, ddx_data % params % csph(1, :), &
        & ddx_data % params % csph(2, :), ddx_data % params % csph(3, :), ddx_data % params % rsph, &
        & ddx_data % params % model, ddx_data % params % lmax, ddx_data % params % ngrid, 0, &
        & ddx_data % params % fmm, ddx_data % params % pm, ddx_data % params % pl, &
        & ddx_data % params % se, &
        & ddx_data % params % eta, ddx_data % params % eps, ddx_data % params % kappa, &
        & ddx_data % params % matvecmem, ddx_data % params % maxiter, &
        & ddx_data % params % jacobi_ndiis, &
        & ddx_data % params % nproc, dummy_file_name, ddx_data2, error2)
    call check_error(error2)

    call allocate_state(ddx_data2 % params, ddx_data2 % constants, state, error2)
    call check_error(error2)

    allocate(phi_cav2(ddx_data2 % constants % ncav), gradphi_cav2(3, ddx_data2 % constants % ncav), &
            & hessianphi_cav2(3, 3, ddx_data2 % constants % ncav), &
            & psi2(ddx_data2 % constants % nbasis, ddx_data2 % params % nsph), &
            & force2(3, ddx_data2 % params % nsph))

    gradphi_cav2 = zero; phi_cav2 = zero
    hessianphi_cav2 = zero; psi2 = zero; force2 = zero

    call mkrhs(ddx_data2 % params, ddx_data2 % constants, ddx_data2 % workspace, &
        & 1, phi_cav2, 1, gradphi_cav2, 1, hessianphi_cav2, psi2, charges)
    gradphi_cav2 = - gradphi_cav2
    call ddsolve_legacy(ddx_data2, state, phi_cav2, gradphi_cav2, hessianphi_cav2, &
        & psi2, tol, esolv_in, force2, error2)
    call check_error(error2)

    call deallocate_state(state, error2)
    call deallocate_model(ddx_data2, error2)
    deallocate(phi_cav2, gradphi_cav2, hessianphi_cav2, psi2, force2)
end subroutine test_solve

end program main

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_lapack_sygvr
   use mctc_env, only : sp, dp, wp, error_type, fatal_error
   use tblite_output_format, only : format_string
   use tblite_scf_diag, only : diag_solver_type
   use tblite_lapack_sygst, only : wrap_sygst
   use tblite_lapack_potrf, only : wrap_potrf
   use tblite_blas_level3, only : wrap_trsm
   implicit none
   private

   public :: new_sygvr


   !> Computes selected eigenvalues and, optionally, eigenvectors
   !> of a real symmetric matrix A.  Eigenvalues and eigenvectors can be
   !> selected by specifying either a range of values or a range of
   !> indices for the desired eigenvalues.
   !>
   !> The desired accuracy of the output can be specified by the input
   !> parameter ABSTOL.
   interface lapack_syevr
      pure subroutine ssyevr(jobz, range, uplo, n, a, lda, vl, vu, il, iu, abstol, m, w, &
            & z, ldz, isuppz, work, lwork, iwork, liwork, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(out) :: z(ldz, *)
         real(sp), intent(in) :: vl
         real(sp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: isuppz(*)
         real(sp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldz
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine ssyevr
      pure subroutine dsyevr(jobz, range, uplo, n, a, lda, vl, vu, il, iu, abstol, m, w, &
            & z, ldz, isuppz, work, lwork, iwork, liwork, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(out) :: z(ldz, *)
         real(dp), intent(in) :: vl
         real(dp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: isuppz(*)
         real(dp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldz
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine dsyevr
   end interface lapack_syevr


   type, public, extends(diag_solver_type) :: sygvr_solver
      private
      integer :: n = 0
      integer, allocatable :: iwork(:)
      integer, allocatable :: isuppz(:)
      real(sp), allocatable :: swork(:)
      real(sp), allocatable :: sbmat(:, :)
      real(sp), allocatable :: schole(:)
      real(dp), allocatable :: dwork(:)
      real(dp), allocatable :: dbmat(:, :)
      real(dp), allocatable :: dchole(:)
   contains
      procedure :: solve_sp
      procedure :: solve_dp
   end type sygvr_solver

contains

subroutine new_sygvr(self, overlap, nel, kt)
   type(sygvr_solver), intent(out) :: self
   real(wp), intent(in) :: overlap(:, :)
   real(wp), intent(in) :: nel(:)
   real(wp), intent(in) :: kt
   self%n = size(overlap, 1)
   self%nel = nel
   self%kt = kt
end subroutine new_sygvr

subroutine solve_sp(self, hmat, smat, eval, error)
   class(sygvr_solver), intent(inout) :: self
   real(sp), contiguous, intent(inout) :: hmat(:, :)
   real(sp), contiguous, intent(in) :: smat(:, :)
   real(sp), contiguous, intent(inout) :: eval(:)
   type(error_type), allocatable, intent(out) :: error

   integer, parameter :: itype = 1
   character(len=1), parameter :: uplo = 'U'

   logical :: upper
   integer :: info, lswork, liwork, m, ii, jj
   real(sp) :: abstol, vl, vu
   character(len=1) :: trans, uplo_new

   if (self%n == 0) then
      self%n = size(hmat, 1)
   end if
   if (.not.allocated(self%swork)) then
      lswork = query(self%n, uplo, 'S')
      allocate(self%swork(lswork))
   end if
   if (.not.allocated(self%iwork)) then
      liwork = max(1, 10 * self%n)
      allocate(self%iwork(liwork))
   end if
   if (.not.allocated(self%schole)) then
      allocate(self%schole(self%n))
   end if
   if (.not.allocated(self%isuppz)) then
      allocate(self%isuppz(2*self%n))
   end if
   self%sbmat = smat
   lswork = size(self%swork)
   liwork = size(self%iwork)
   upper = (uplo == 'U' .or. uplo == 'u')
   abstol = slamch_s()
   info = 0

   ! Form a Cholesky factorization of B.
   call wrap_potrf(self%sbmat, info, uplo=uplo)
   call handle_info(error, info)
   if (allocated(error)) return

   ! Transform problem to standard eigenvalue problem and solve.
   call wrap_sygst(hmat, self%sbmat, info, itype=itype, uplo=uplo)
   call handle_info(error, info)
   if (allocated(error)) return

   ! Save Cholesky factor in the other triangle of H and chole
   do ii = 1, self%n
      self%schole(ii) = self%sbmat(ii, ii)
   end do
   if (upper) then
      do jj = 1, self%n
         do ii = jj + 1, self%n
            hmat(ii, jj) = self%sbmat(jj, ii)
         end do
      end do
   else
      do jj = 1, self%n
         do ii = 1, jj - 1
            hmat(ii, jj) = self%sbmat(jj, ii)
         end do
      end do
   end if

   call lapack_syevr('V', 'A', uplo, self%n, hmat, self%n, vl, vu, 1, self%n, abstol, &
      & m, eval, self%sbmat, self%n, self%isuppz, self%swork, lswork, self%iwork, liwork, &
      & info)
   call handle_info(error, info)
   if (allocated(error)) return

   ! Backtransform eigenvectors to the original problem.
   do ii = 1, self%n
      hmat(ii, ii) = self%schole(ii)
   end do

   uplo_new = merge('L', 'U', upper)
   upper = .not.upper

   ! For A*x=(lambda)*B*x
   ! backtransform eigenvectors: x = inv(L)'*y or inv(U)*y'
   trans = merge('N', 'T', upper)
   call wrap_trsm(hmat, self%sbmat, side='L', uplo=uplo_new, transa=trans, diag='N')
   do ii = 1, m
      hmat(1:self%n, ii) = self%sbmat(1:self%n, ii)
   end do
   hmat(1:self%n, m+1:self%n) = 0.0_sp

end subroutine solve_sp

subroutine solve_dp(self, hmat, smat, eval, error)
   class(sygvr_solver), intent(inout) :: self
   real(dp), contiguous, intent(inout) :: hmat(:, :)
   real(dp), contiguous, intent(in) :: smat(:, :)
   real(dp), contiguous, intent(inout) :: eval(:)
   type(error_type), allocatable, intent(out) :: error

   integer, parameter :: itype = 1
   character(len=1), parameter :: uplo = 'U'

   logical :: upper
   integer :: info, ldwork, liwork, m, ii, jj
   real(dp) :: abstol, vl, vu
   character(len=1) :: trans, uplo_new

   if (self%n == 0) then
      self%n = size(hmat, 1)
   end if
   if (.not.allocated(self%dwork)) then
      ldwork = query(self%n, uplo, 'D')
      allocate(self%dwork(ldwork))
   end if
   if (.not.allocated(self%iwork)) then
      liwork = max(1, 10 * self%n)
      allocate(self%iwork(liwork))
   end if
   if (.not.allocated(self%dchole)) then
      allocate(self%dchole(self%n))
   end if
   if (.not.allocated(self%isuppz)) then
      allocate(self%isuppz(2*self%n))
   end if
   self%dbmat = smat
   ldwork = size(self%dwork)
   liwork = size(self%iwork)
   upper = (uplo == 'U' .or. uplo == 'u')
   abstol = dlamch_s()
   info = 0

   ! Form a Cholesky factorization of B.
   call wrap_potrf(self%dbmat, info, uplo=uplo)
   call handle_info(error, info)
   if (allocated(error)) return

   ! Transform problem to standard eigenvalue problem and solve.
   call wrap_sygst(hmat, self%dbmat, info, itype=itype, uplo=uplo)
   call handle_info(error, info)
   if (allocated(error)) return

   ! Save Cholesky factor in the other triangle of H and chole
   do ii = 1, self%n
      self%dchole(ii) = self%dbmat(ii, ii)
   end do
   if (upper) then
      do jj = 1, self%n
         do ii = jj + 1, self%n
            hmat(ii, jj) = self%dbmat(jj, ii)
         end do
      end do
   else
      do jj = 1, self%n
         do ii = 1, jj - 1
            hmat(ii, jj) = self%dbmat(jj, ii)
         end do
      end do
   end if

   call lapack_syevr('V', 'A', uplo, self%n, hmat, self%n, vl, vu, 1, self%n, abstol, &
      & m, eval, self%dbmat, self%n, self%isuppz, self%dwork, ldwork, self%iwork, liwork, &
      & info)
   call handle_info(error, info)
   if (allocated(error)) return

   ! Backtransform eigenvectors to the original problem.
   do ii = 1, self%n
      hmat(ii, ii) = self%dchole(ii)
   end do

   uplo_new = merge('L', 'U', upper)
   upper = .not.upper

   ! For A*x=(lambda)*B*x
   ! backtransform eigenvectors: x = inv(L)'*y or inv(U)*y'
   trans = merge('N', 'T', upper)
   call wrap_trsm(hmat, self%dbmat, side='L', uplo=uplo_new, transa=trans, diag='N')
   do ii = 1, m
      hmat(1:self%n, ii) = self%dbmat(1:self%n, ii)
   end do
   hmat(1:self%n, m+1:self%n) = 0.0_dp

end subroutine solve_dp


pure function query(n, uplo, prefix) result(lwork)
   interface
      pure integer function ilaenv(ispec, name, opts, n1, n2, n3, n4)
         integer, intent(in) :: ispec
         character(len=1), intent(in) :: name
         character(len=1), intent(in) :: opts
         integer, intent(in) :: n1
         integer, intent(in) :: n2
         integer, intent(in) :: n3
         integer, intent(in) :: n4
      end function ilaenv
   end interface
   integer, intent(in) :: n
   character(len=1), intent(in) :: uplo
   character(len=1), intent(in) :: prefix
   integer :: lwork
   integer :: nb
   nb = ilaenv(1, prefix//'SYTRD', uplo, n, -1, -1, -1)
   nb = max(nb, ilaenv(1, prefix//'ORMTR', uplo, n, -1, -1, -1))
   lwork = max(1, 26 * n, (nb + 1)*n)
end function query

pure function slamch_s() result(rmach)
   real(sp), parameter :: one = 1.0_sp, zero = 0.0_sp, rnd = one
   real(sp), parameter :: eps = merge(epsilon(zero), epsilon(zero) * 0.5_sp, one /= rnd)
   real(sp), parameter :: tinyz = tiny(zero), small = one / huge(zero)
   real(sp), parameter :: sfmin = merge(small*(one + eps), tinyz, small.ge.tinyz)
   real(sp) :: rmach
   rmach = sfmin
end function slamch_s

pure function dlamch_s() result(rmach)
   real(dp), parameter :: one = 1.0_dp, zero = 0.0_dp, rnd = one
   real(dp), parameter :: eps = merge(epsilon(zero), epsilon(zero) * 0.5_dp, one /= rnd)
   real(dp), parameter :: tinyz = tiny(zero), small = one / huge(zero)
   real(dp), parameter :: sfmin = merge(small*(one + eps), tinyz, small.ge.tinyz)
   real(dp) :: rmach
   rmach = sfmin
end function dlamch_s

subroutine handle_info(error, info)
   type(error_type), allocatable, intent(out) :: error
   integer, intent(in) :: info

   if (info /= 0) then
      call fatal_error(error, "(sygvr) failed to solve eigenvalue problem.&
         & info="//format_string(info, '(i0)'))
   end if
end subroutine handle_info

end module tblite_lapack_sygvr

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file tests/ddlpb_esolv_iterations.f90
!! Test for different solvers parameters
!! NOTE: This test is not a definitive test. If the values are different
!!       maybe the new ones are correct as they might be improved values.
!!       But, the default values should be used as a benchmark
!!
!! @version 1.0.0
!! @author Abhinav Jha
!! @date 2022-03-29

program main
use ddx_core
use ddx_operators
use ddx_solvers
use ddx
use ddx_lpb
use ddx_legacy
implicit none

character(len=255) :: fname
type(ddx_type) :: ddx_data
type(ddx_error_type) :: ddx_error
type(ddx_state_type) :: state
character(len=255) :: dummy_file_name = ''

real(dp) :: esolv_one, esolv_two, tol
integer :: default_value

real(dp), external :: dnrm2
real(dp), allocatable :: charges(:)

! Read input file name
call get_command_argument(1, fname)
write(*, *) "Using provided file ", trim(fname), " as a config file"
call ddfromfile(fname, ddx_data, tol, charges, ddx_error)
call check_error(ddx_error)
call allocate_state(ddx_data % params, ddx_data % constants, state, ddx_error)
call check_error(ddx_error)

! Initial values
default_value = zero
esolv_one = zero
esolv_two = zero

! Computation for different storage
write(*,*) 'Different storage of matrix'
default_value = 1
call test_solve(ddx_data, state, default_value, esolv_one, charges)
write(*,*) 'Esolv : ', esolv_one
default_value = 0
call test_solve(ddx_data, state, default_value, esolv_two, charges)
write(*,*) 'Esolv : ', esolv_two

if(abs(esolv_one - esolv_two) .gt. 1e-8) then
  write(*,*) 'Different solvation energies for storing and not storing the matrix'
  stop 1
endif

call deallocate_state(state, ddx_error)
call deallocate_model(ddx_data, ddx_error)
deallocate(charges)

contains

subroutine test_solve(ddx_data, state, matvecmem, esolv, charges)
    type(ddx_type), intent(inout) :: ddx_data
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(inout) :: esolv
    integer, intent(in) :: matvecmem
    real(dp), intent(in) :: charges(ddx_data % params % nsph)

    type(ddx_type) :: ddx_data2
    type(ddx_error_type) :: error2
    real(dp), allocatable :: phi_cav2(:)
    real(dp), allocatable :: gradphi_cav2(:,:)
    real(dp), allocatable :: hessianphi_cav2(:,:,:)
    real(dp), allocatable :: psi2(:,:)
    real(dp), allocatable :: force2(:,:)

    call allocate_model(ddx_data % params % nsph, &
        & ddx_data % params % csph(1, :), &
        & ddx_data % params % csph(2, :), ddx_data % params % csph(3, :), ddx_data % params % rsph, &
        & ddx_data % params % model, ddx_data % params % lmax, ddx_data % params % ngrid, 0, &
        & ddx_data % params % fmm, ddx_data % params % pm, ddx_data % params % pl, &
        & ddx_data % params % se, &
        & ddx_data % params % eta, ddx_data % params % eps, ddx_data % params % kappa, matvecmem,&
        & ddx_data % params % maxiter, &
        & ddx_data % params % jacobi_ndiis, &
        & ddx_data % params % nproc, dummy_file_name, ddx_data2, error2)

    allocate(phi_cav2(ddx_data2 % constants % ncav), &
            & gradphi_cav2(3, ddx_data2 % constants % ncav), &
            & hessianphi_cav2(3, 3, ddx_data2 % constants % ncav), &
            & psi2(ddx_data2 % constants % nbasis, ddx_data2 % params % nsph), &
            & force2(3, ddx_data2 % params % nsph))


    write(*,*) 'Store sparse matrices : ', ddx_data2 % params % matvecmem

    gradphi_cav2 = zero; phi_cav2 = zero
    hessianphi_cav2 = zero; psi2 = zero; force2 = zero

    call mkrhs(ddx_data2 % params, ddx_data2 % constants, ddx_data2 % workspace, &
            &  1, phi_cav2, 1, gradphi_cav2, 1, hessianphi_cav2, psi2, charges)

    call ddsolve_legacy(ddx_data2, state, phi_cav2, gradphi_cav2, hessianphi_cav2, &
        & psi2, tol, esolv, force2, error2)
    call check_error(error2)
    deallocate(phi_cav2, gradphi_cav2, hessianphi_cav2, psi2, force2)
    call deallocate_model(ddx_data2, error2)
    return
end subroutine test_solve

end program main

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/repulsion
!> Contains the repulsive interaction implementations.

!> @file tblite/repulsion.f90
!> Reexport for the repulsion container implementations.

!> Proxy module for repulsion interactions.
module tblite_repulsion
   use tblite_repulsion_effective, only : tb_repulsion, new_repulsion
   use tblite_repulsion_type, only : repulsion_type
   implicit none
   private

   public :: tb_repulsion, new_repulsion

end module tblite_repulsion

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/output
!> Contains routines for terminal or string output generation

!> @file tblite/output/ascii.f90
!> Provides routines for terminal or text file output

!> Implementation of terminal or text file output
module tblite_output_ascii
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_convert, only : autoev
   use tblite_version, only : get_tblite_version
   implicit none
   private

   public :: ascii_levels, ascii_dipole_moments, ascii_quadrupole_moments
   public :: json_results, tagged_result, ascii_atomic_charges

contains


subroutine ascii_levels(unit, verbosity, emo, focc, range)
   integer, intent(in) :: unit
   integer, intent(in) :: verbosity
   real(wp), intent(in) :: emo(:, :)
   real(wp), intent(in) :: focc(:, :)
   integer, intent(in) :: range

   character(len=*), parameter :: hlfmt = '(a21, f21.7, 1x, "Eh", f18.4, 1x, "eV")'
   integer :: nao, maxorb, minorb, iorb, spin, homo
   real(wp) :: gap, nel

   do spin = 1, size(emo, 2)
   nel = sum(focc(:, spin))
   homo = floor(nel)
   homo = merge(homo+1, homo, mod(nel, 1.0_wp) > 0.5_wp)
   nao = size(emo, 1)
   minorb = max(homo - (range+1), 1)
   maxorb = min(homo +  range, nao)
   gap = emo(min(homo+1, nao), spin) - emo(max(homo, 1), spin)

   write(unit, '(66("-"))')
   write(unit, '(a7, a14, a21, a21)') "#", "Occupation", "Energy/Eh", "Energy/eV"
   write(unit, '(66("-"))')
   if (minorb > 1) then
      call write_line(1, focc(:, spin), emo(:, spin), homo)
      if (minorb > 2) &
         write(unit, '(a7, a14, a21, a21)') "...", "...", "...", "..."
   endif
   do iorb = minorb, maxorb
      call write_line(iorb, focc(:, spin), emo(:, spin), homo)
   enddo
   if (maxorb < nao) then
      if (maxorb < nao-1) then
         if (focc(maxorb, spin) > sqrt(epsilon(1.0_wp))) then
            write(unit, '(a7, a14, a21, a21)') "...", "...", "...", "..."
         else
            write(unit, '(a7, a14, a21, a21)') "...", "", "...", "..."
         endif
      endif
      call write_line(nao, focc(:, spin), emo(:, spin), homo)
   endif
   write(unit, '(66("-"))')
   write(unit, hlfmt) "HL-Gap", gap, gap*autoev
   write(unit, '(66("-"))')
   write(unit, '(a)')
   end do

contains
   subroutine write_line(iorb, focc, emo, ihomo)
      integer, intent(in) :: iorb
      integer, intent(in) :: ihomo
      real(wp), intent(in) :: focc(:)
      real(wp), intent(in) :: emo (:)
      character(len=*), parameter :: mofmt = '(i7, f14.4, f21.7, f21.4)'
      character(len=*), parameter :: vofmt = '(i7, 14x,  f21.7, f21.4)'
      if (focc(iorb) < 1.0e-7_wp) then
         write(unit, vofmt, advance='no') iorb,             emo(iorb), emo(iorb)*autoev
      else
         write(unit, mofmt, advance='no') iorb, focc(iorb), emo(iorb), emo(iorb)*autoev
      endif
      if (iorb == ihomo) then
         write(unit, '(1x, "(HOMO)")')
      elseif (iorb == ihomo+1) then
         write(unit, '(1x, "(LUMO)")')
      else
         write(unit, '(a)')
      endif
   end subroutine write_line
end subroutine ascii_levels

subroutine ascii_dipole_moments(unit, verbosity, mol, dpat, dpmom)
   integer, intent(in) :: unit
   integer, intent(in) :: verbosity
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: dpat(:, :)
   real(wp), intent(in) :: dpmom(:)

   integer :: iat, isp

   write(unit, '(a,":")') "Atomic dipole moments (in atomic units)"
   write(unit, '(57("-"))')
   write(unit, '(a6, 1x, a4, 5x, *(1x, a12))') &
      & "#", "Z", "x", "y", "z"
   write(unit, '(57("-"))')
   do iat = 1, mol%nat
      isp = mol%id(iat)
      write(unit, '(i6, 1x, i4, 1x, a4, *(1x, f12.6))') &
         & iat, mol%num(isp), mol%sym(isp), dpat(:, iat)
   end do
   write(unit, '(57("-"))')
   write(unit, '(1x, a15, *(1x, f12.6))') "total", dpmom
   write(unit, '(57("-"))')
   write(unit, '(a)')
end subroutine ascii_dipole_moments

subroutine ascii_atomic_charges(unit, verbosity, mol, qat)
   integer, intent(in) :: unit
   integer, intent(in) :: verbosity
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: qat(:)

   integer :: iat, isp

   write(unit, '(a,":")') "Atomic charges (in atomic units)"
   write(unit, '(57("-"))')
   write(unit, '(a6, 1x, a4, 7x, *(1x, a10))') &
      & "#", "Z", "q"
   write(unit, '(57("-"))')
   do iat = 1, mol%nat
      isp = mol%id(iat)
      write(unit, '(i6, 1x, i4, 1x, a4, *(1x, f12.6))') &
         & iat, mol%num(isp), mol%sym(isp), qat(iat)
   end do
   write(unit, '(57("-"))')
   write(unit, '(a)')
end subroutine ascii_atomic_charges

subroutine ascii_quadrupole_moments(unit, verbosity, mol, qpat, qpmom)
   integer, intent(in) :: unit
   integer, intent(in) :: verbosity
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: qpat(:, :)
   real(wp), intent(in) :: qpmom(:)

   integer :: iat, isp

   write(unit, '(a,":")') "Atomic quadrupole moments (in atomic units)"
   write(unit, '(83("-"))')
   write(unit, '(a6, 1x, a4, 5x, *(1x, a10))') &
      & "#", "Z", "xx", "xy", "yy", "xz", "yz", "zz"
   write(unit, '(83("-"))')
   do iat = 1, mol%nat
      isp = mol%id(iat)
      write(unit, '(i6, 1x, i4, 1x, a4, *(1x, f10.4))') &
         & iat, mol%num(isp), mol%sym(isp), qpat(:, iat)
   end do
   write(unit, '(83("-"))')
   write(unit, '(1x, a15, *(1x, f10.4))') "total", qpmom
   write(unit, '(83("-"))')
   write(unit, '(a)')
end subroutine ascii_quadrupole_moments


subroutine json_results(unit, indentation, energy, gradient, sigma, energies, charges)
   integer, intent(in) :: unit
   character(len=*), intent(in), optional :: indentation
   real(wp), intent(in), optional :: energy
   real(wp), intent(in), optional :: gradient(:, :)
   real(wp), intent(in), optional :: sigma(:, :)
   real(wp), intent(in), optional :: energies(:)
   real(wp), intent(in), optional :: charges(:)
   character(len=:), allocatable :: indent, version_string
   character(len=*), parameter :: jsonkey = "('""',a,'"":',1x)"
   real(wp), allocatable :: array(:)

   call get_tblite_version(string=version_string)

   if (present(indentation)) then
      indent = indentation
   end if

   write(unit, '("{")', advance='no')
   if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
   write(unit, jsonkey, advance='no') 'version'
   write(unit, '(1x,a)', advance='no') '"'//version_string//'"'
   if (present(energy)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'energy'
      write(unit, '(1x,es25.16)', advance='no') energy
   end if
   if (present(energies)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'energies'
      call write_json_array(unit, energies, indent)
   end if
   if (present(sigma)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'virial'
      array = reshape(sigma, [size(sigma)])
      call write_json_array(unit, array, indent)
   end if
   if (present(gradient)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'gradient'
      array = reshape(gradient, [size(gradient)])
      call write_json_array(unit, array, indent)
   end if
   if (present(charges)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'charges'
      array = reshape(charges, [size(charges)])
      call write_json_array(unit, array, indent)
   end if
   if (allocated(indent)) write(unit, '(/)', advance='no')
   write(unit, '("}")')

end subroutine json_results


subroutine write_json_array(unit, array, indent)
   integer, intent(in) :: unit
   real(wp), intent(in) :: array(:)
   character(len=:), allocatable, intent(in) :: indent
   integer :: i
   write(unit, '("[")', advance='no')
   do i = 1, size(array)
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 2)
      write(unit, '(es23.16)', advance='no') array(i)
      if (i /= size(array)) write(unit, '(",")', advance='no')
   end do
   if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
   write(unit, '("]")', advance='no')
end subroutine write_json_array


subroutine tagged_result(unit, energy, gradient, sigma, energies)
   integer, intent(in) :: unit
   real(wp), intent(in), optional :: energy
   real(wp), intent(in), optional :: gradient(:, :)
   real(wp), intent(in), optional :: sigma(:, :)
   real(wp), intent(in), optional :: energies(:)
   character(len=*), parameter :: tag_header = &
      & '(a,t20,":",a,":",i0,":",*(i0:,","))'

   if (present(energy)) then
      write(unit, tag_header) "energy", "real", 0
      write(unit, '(3es24.16)') energy
   end if
   if (present(energies)) then
      write(unit, tag_header) "energies", "real", 1, shape(energies)
      write(unit, '(3es24.16)') energies
   end if
   if (present(gradient)) then
      write(unit, tag_header) "gradient", "real", 2, shape(gradient)
      write(unit, '(3es24.16)') gradient
   end if
   if (present(sigma)) then
      write(unit, tag_header) "virial", "real", 2, shape(sigma)
      write(unit, '(3es24.16)') sigma
   end if

end subroutine tagged_result


end module tblite_output_ascii

! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/post-processing/xtb-ml/features.f90
!> Abstract base class for xtb based features
module tblite_post_processing_xtbml_features
   use mctc_env, only : wp, error_type
   use mctc_io, only : structure_type
   use tblite_container_list, only : cache_list
   use tblite_context , only : context_type
   use tblite_double_dictionary, only : double_dictionary_type
   use tblite_integral_type, only : integral_type
   use tblite_post_processing_xtbml_cache, only : xtbml_cache
   use tblite_post_processing_xtbml_convolution, only : xtbml_convolution
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   !> Abstract base class for xTB-ML features
   type, public, abstract :: xtbml_feature_type
      !> Name of the feature
      character(len=:), allocatable :: label
   contains
      !> Compute xtb-ML features
      procedure(compute_features), deferred :: compute_features
      !> Compute xtb-ML features with convolution
      procedure(compute_extended), deferred :: compute_extended
      !> Write the xtb-ML feature information
      procedure :: info
   end type xtbml_feature_type

   character(len=*), parameter :: label = "General feature class"

   abstract interface
      subroutine compute_features(self, mol, wfn, ints, calc, caches, &
         & mlcache, dict, n_features, error)
         import :: wp, wavefunction_type, structure_type, integral_type, &
            & xtb_calculator, cache_list, context_type, xtbml_feature_type, &
            & xtbml_cache, double_dictionary_type, error_type
         !> Instance of a xTB-ML feature
         class(xtbml_feature_type), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Wavefunction strcuture data
         type(wavefunction_type), intent(in) :: wfn
         !> Integral container
         type(integral_type), intent(in) :: ints
         !> Single-point calculator
         type(xtb_calculator), intent(in) :: calc
         !> Cache list for storing caches of various interactions
         type(cache_list), intent(inout) :: caches
         !> Cache for xTB-ML features
         type(xtbml_cache), intent(inout) :: mlcache
         !> Dictionary for storing results
         type(double_dictionary_type), intent(inout) :: dict
         !> Number of features
         integer, intent(inout) :: n_features
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine compute_features

      subroutine compute_extended(self, mol, wfn, ints, calc, caches, &
         & mlcache, convolution, dict, n_features, error)
         import :: wp, wavefunction_type, structure_type, integral_type, &
            & xtb_calculator, cache_list, context_type, xtbml_feature_type, &
            & xtbml_cache, xtbml_convolution, double_dictionary_type, error_type
         !> Instance of a xTB-ML feature
         class(xtbml_feature_type), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Wavefunction strcuture data
         type(wavefunction_type), intent(in) :: wfn
         !> Integral container
         type(integral_type), intent(in) :: ints
         !> Single-point calculator
         type(xtb_calculator), intent(in) :: calc
         !> Cache list for storing caches of various interactions
         type(cache_list), intent(inout) :: caches
         !> Cache for xTB-ML features
         type(xtbml_cache), intent(inout) :: mlcache
         !> Convolution container
         type(xtbml_convolution), intent(in) :: convolution
         !> Dictionary for storing results
         type(double_dictionary_type), intent(inout) :: dict
         !> Number of features
         integer, intent(inout) :: n_features
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine compute_extended

   end interface

contains

pure function info(self, verbosity, indent) result(str)
   !> Instance of a xTB-ML feature
   class(xtbml_feature_type), intent(in) :: self
   !> Verbosity level
   integer, intent(in) :: verbosity
   !> Indentation level
   character(len=*), intent(in) :: indent
   !> Information on the container
   character(len=:), allocatable :: str

   if (allocated(self%label)) then
      str = indent // self%label
   else
      str = "Unknown"
   end if
end function info

end module tblite_post_processing_xtbml_features

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/scf/mixer/broyden.f90
!> Provides an electronic mixer implementation

!> Implementation of a modified Broyden mixing
module tblite_scf_mixer_broyden
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_lapack, only : getrf, getrs
   use tblite_scf_mixer_type, only : mixer_type
   implicit none
   private

   public :: new_broyden


   !> Configuration for the Broyden mixer
   type, public :: broyden_input
      !> Number of steps to keep in memory
      integer :: memory
      !> Damping parameter
      real(wp) :: damp
   end type broyden_input

   !> Electronic mixer using modified Broyden scheme
   type, public, extends(mixer_type) :: broyden_mixer
      integer :: ndim
      integer :: memory
      integer :: iter
      integer :: iset
      integer :: idif
      integer :: iget
      real(wp) :: damp
      real(wp), allocatable :: df(:, :)
      real(wp), allocatable :: u(:, :)
      real(wp), allocatable :: a(:, :)
      real(wp), allocatable :: dq(:)
      real(wp), allocatable :: dqlast(:)
      real(wp), allocatable :: qlast_in(:)
      real(wp), allocatable :: omega(:)
      real(wp), allocatable :: q_in(:)
   contains
      !> Apply mixing to the density
      procedure :: next
      !> Set new density from 1D array
      procedure :: set_1d
      !> Set difference between new and old density from 1D array
      procedure :: diff_1d
      !> Get density as 1D array
      procedure :: get_1d
      !> Get error metric from mixing
      procedure :: get_error
   end type broyden_mixer

contains

!> Create new instance of electronic mixer
subroutine new_broyden(self, ndim, input)
   !> Instance of the mixer
   type(broyden_mixer), intent(out) :: self
   !> Number of variables to consider
   integer, intent(in) :: ndim
   !> Configuration of the Broyden mixer
   type(broyden_input), intent(in) :: input

   self%ndim = ndim
   self%memory = input%memory
   self%iter = 0
   self%iset = 0
   self%idif = 0
   self%iget = 0
   self%damp = input%damp
   allocate(self%df(ndim, input%memory))
   allocate(self%u(ndim, input%memory))
   allocate(self%a(input%memory, input%memory))
   allocate(self%dq(ndim))
   allocate(self%dqlast(ndim))
   allocate(self%qlast_in(ndim))
   allocate(self%omega(input%memory))
   allocate(self%q_in(ndim))
end subroutine new_broyden

!> Set new density from 1D array
subroutine set_1d(self, qvec)
   !> Instance of the mixer
   class(broyden_mixer), intent(inout) :: self
   !> Density vector
   real(wp), intent(in) :: qvec(:)
   self%q_in(self%iset+1:self%iset+size(qvec)) = qvec
   self%iset = self%iset + size(qvec)
end subroutine set_1d

!> Set difference between new and old density from 1D array
subroutine diff_1d(self, qvec)
   !> Instance of the mixer
   class(broyden_mixer), intent(inout) :: self
   !> Density vector
   real(wp), intent(in) :: qvec(:)
   self%dq(self%idif+1:self%idif+size(qvec)) = qvec &
      & - self%q_in(self%idif+1:self%idif+size(qvec))
   self%idif = self%idif + size(qvec)
end subroutine diff_1d

!> Apply mixing to the density
subroutine next(self, error)
   !> Instance of the mixer
   class(broyden_mixer), intent(inout) :: self
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: info

   self%iset = 0
   self%idif = 0
   self%iget = 0
   self%iter = self%iter + 1
   call broyden(self%ndim, self%q_in, self%qlast_in, self%dq, self%dqlast, &
      & self%iter, self%memory, self%damp, self%omega, self%df, self%u, self%a, info)
   if (info /= 0) then
      call fatal_error(error, "Broyden mixing failed to obtain next iteration")
   end if
end subroutine next

!> Get density as 1D array
subroutine get_1d(self, qvec)
   !> Instance of the mixer
   class(broyden_mixer), intent(inout) :: self
   !> Density vector
   real(wp), intent(out) :: qvec(:)
   qvec(:) = self%q_in(self%iget+1:self%iget+size(qvec))
   self%iget = self%iget + size(qvec)
end subroutine get_1d

subroutine broyden(n, q, qlast, dq, dqlast, iter, memory, alpha, omega, df, u, a, info)
   integer, intent(in) :: n
   integer, intent(in) :: iter
   integer, intent(in) :: memory
   real(wp), intent(inout) :: q(n)
   real(wp), intent(inout) :: qlast(n)
   real(wp), intent(in) :: dq(n)
   real(wp), intent(inout) :: dqlast(n)
   real(wp), intent(inout) :: df(n, memory)
   real(wp), intent(inout) :: u(n, memory)
   real(wp), intent(inout) :: a(memory, memory)
   real(wp), intent(inout) :: omega(memory)
   real(wp), intent(in) :: alpha
   integer, intent(out) :: info

   real(wp), allocatable :: beta(:, :), c(:, :)
   integer, allocatable :: hist(:)
   integer :: i, j, ih, jh, it1, itn, first, nhist
   real(wp) :: inv, omega0, minw, maxw, wfac

   info = 0
   itn = iter - 1
   it1 = mod(itn - 1, memory) + 1

   ! set parameters
   ! alpha = 0.25e0_wp
   omega0 = 0.01e0_wp
   minw = 1.0e0_wp
   maxw = 100000.0e0_wp
   wfac = 0.01e0_wp
   ! wfac = 0.05e0_wp

   ! if case for first iteration: simple damping
   if (iter == 1) then
      dqlast(:) = dq
      qlast(:) = q
      q(:) = q + alpha * dq
      return
   end if

   nhist = min(memory, itn)
   first = max(1, itn - memory + 1)
   allocate(hist(nhist), beta(nhist, nhist), c(nhist, 1))
   do ih = 1, nhist
      hist(ih) = mod(first + ih - 2, memory) + 1
   end do

   ! create omega (weight) for the current iteration
   omega(it1) = sqrt(dot_product(dq, dq))
   if (omega(it1) > (wfac / maxw)) then
      omega(it1) = wfac / omega(it1)
   else
      omega(it1) = maxw
   end if
   if (omega(it1) < minw) then
      omega(it1) = minw
   end if

   ! Build dF(iter-1)
   df(:, it1) = dq - dqlast
   inv = max(sqrt(dot_product(df(:, it1), df(:, it1))), epsilon(1.0_wp))
   inv = 1.0_wp / inv
   df(:, it1) = inv*df(:, it1)

   ! Next: build a, beta, c, gamma
   do ih = 1, nhist
      i = hist(ih)
      c(ih, 1) = omega(i) * dot_product(df(:, i), dq)
      do jh = 1, nhist
         j = hist(jh)
         a(i, j) = dot_product(df(:, i), df(:, j))
      end do
   end do

   ! Build beta from a and omega
   do ih = 1, nhist
      i = hist(ih)
      do jh = 1, nhist
         j = hist(jh)
         beta(ih, jh) = omega(i) * omega(j) * a(i, j)
      end do
      beta(ih, ih) = beta(ih, ih) + omega0*omega0
   end do

   ! build beta^-1
   call lineq(beta, c, info)
   if (info /= 0) return

   ! Build |u>
   u(:, it1) = alpha * df(:, it1) + inv * (q-qlast) !!!

   ! save charges and deltas
   dqlast(:) = dq
   qlast(:) = q

   ! calculate new charges
   q(:) = q + alpha * dq

   do ih = 1, nhist
      i = hist(ih)
      q(:) = q - omega(i) * c(ih, 1) * u(:, i)
   end do

end subroutine broyden

subroutine lineq(a, c, info)
   real(wp), intent(inout) :: a(:, :)
   real(wp), intent(inout) :: c(:, :)
   integer, intent(out) :: info

   integer, allocatable :: ipiv(:)

   allocate(ipiv(size(a, 1)))
   ! LU decomoposition of a general matrix
   call getrf(a, ipiv, info)
   if (info == 0) then
      ! generate inverse of a matrix given its LU decomposition
      call getrs(a, c, ipiv, info, trans="t")
   endif
end subroutine lineq

pure function get_error(self) result(error)
   class(broyden_mixer), intent(in) :: self
   real(wp) :: error
   integer :: i
   error = 0.0_wp
   do i = 1, size(self%dq)
      error = error + self%dq(i)**2 / size(self%dq)
   end do
   error = sqrt(error)
end function get_error

end module tblite_scf_mixer_broyden

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/xtb/coulomb.f90
!> Provides a collection for all Coulomb related interactions

!> Collects all Coulomb related interaction in as single interaction container.
module tblite_xtb_coulomb
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_container, only : container_cache, container_type
   use tblite_coulomb, only : coulomb_charge_type, damped_multipole, onsite_thirdorder
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   !> Collection of Coulombic interactions
   type, public, extends(container_type) :: tb_coulomb
      !> Isotroptic second-order electrostatics
      class(coulomb_charge_type), allocatable :: es2
      !> Anisotropic second-order electrostatic
      type(damped_multipole), allocatable :: aes2
      !> Onsite third-order electrostatic
      type(onsite_thirdorder), allocatable :: es3
   contains
      procedure :: update
      procedure :: variable_info
      procedure :: get_energy
      procedure :: get_potential
      procedure :: get_potential_gradient
      procedure :: get_gradient
      procedure :: info
   end type tb_coulomb

contains


subroutine update(self, mol, cache)
   !> Instance of the electrostatic container
   class(tb_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   if (allocated(self%es2)) then
      call self%es2%update(mol, cache)
   end if

   if (allocated(self%aes2)) then
      call self%aes2%update(mol, cache)
   end if

   if (allocated(self%es3)) then
      call self%es3%update(mol, cache)
   end if
end subroutine update


subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the electrostatic container
   class(tb_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)

   if (allocated(self%es2)) then
      call self%es2%get_energy(mol, cache, wfn, energies)
   end if

   if (allocated(self%aes2)) then
      call self%aes2%get_energy(mol, cache, wfn, energies)
   end if

   if (allocated(self%es3)) then
      call self%es3%get_energy(mol, cache, wfn, energies)
   end if
end subroutine get_energy


subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the electrostatic container
   class(tb_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   if (allocated(self%es2)) then
      call self%es2%get_potential(mol, cache, wfn, pot)
   end if

   if (allocated(self%aes2)) then
      call self%aes2%get_potential(mol, cache, wfn, pot)
   end if

   if (allocated(self%es3)) then
      call self%es3%get_potential(mol, cache, wfn, pot)
   end if
end subroutine get_potential


subroutine get_potential_gradient(self, mol, cache, wfn, pot)
   !> Instance of the electrostatic container
   class(tb_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   if (allocated(self%es2)) then
      call self%es2%get_potential_gradient(mol, cache, wfn, pot)
   end if

   if (allocated(self%aes2)) then
      call self%aes2%get_potential_gradient(mol, cache, wfn, pot)
   end if

   if (allocated(self%es3)) then
      call self%es3%get_potential_gradient(mol, cache, wfn, pot)
   end if
end subroutine get_potential_gradient


subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the electrostatic container
   class(tb_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the repulsion energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   if (allocated(self%es2)) then
      call self%es2%get_gradient(mol, cache, wfn, gradient, sigma)
   end if

   if (allocated(self%aes2)) then
      call self%aes2%get_gradient(mol, cache, wfn, gradient, sigma)
   end if

   if (allocated(self%es3)) then
      call self%es3%get_gradient(mol, cache, wfn, gradient, sigma)
   end if
end subroutine get_gradient


pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, max
   !> Instance of the electrostatic container
   class(tb_coulomb), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info()

   if (allocated(self%es2)) then
      info = max(info, self%es2%variable_info())
   end if

   if (allocated(self%aes2)) then
      info = max(info, self%aes2%variable_info())
   end if

   if (allocated(self%es3)) then
      info = max(info, self%es3%variable_info())
   end if

end function variable_info


!> Information on container
pure function info(self, verbosity, indent) result(str)
   !> Instance of the interaction container
   class(tb_coulomb), intent(in) :: self
   !> Verbosity level
   integer, intent(in) :: verbosity
   !> Indentation level
   character(len=*), intent(in) :: indent
   !> Information on the container
   character(len=:), allocatable :: str

   character(len=*), parameter :: nl = new_line('a'), marker = " * "

   if (allocated(self%label)) then
      str = self%label
   else
      str = "Coulomb electrostatics"
   end if

   if (allocated(self%es2)) then
      str = str // nl // indent // marker // &
         & self%es2%info(verbosity, indent//marker)
   end if

   if (allocated(self%aes2)) then
      str = str // nl // indent // marker // &
         & self%aes2%info(verbosity, indent//marker)
   end if

   if (allocated(self%es3)) then
      str = str // nl // indent // marker // &
         & self%es3%info(verbosity, indent//marker)
   end if
end function info


end module tblite_xtb_coulomb

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/param
!> Definition of the individual components of the parametrization data.

!> @file tblite/param.f90
!> Reexport of the parametrization records and definition of the high-level representation
!> if the parametrization data format.

!> Defininition of the parametrization data format
module tblite_param
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io_symbols, only : to_number, symbol_length
   use tblite_param_charge, only : charge_record
   use tblite_param_dispersion, only : dispersion_record
   use tblite_param_element, only : element_record
   use tblite_param_halogen, only : halogen_record
   use tblite_param_hamiltonian, only : hamiltonian_record
   use tblite_param_mask, only : param_mask, count
   use tblite_param_multipole, only : multipole_record
   use tblite_param_repulsion, only : repulsion_record
   use tblite_param_serde, only : serde_record
   use tblite_param_thirdorder, only : thirdorder_record
   use tblite_param_post_processing, only : post_processing_record_list, &
      & post_processing_record, molmom_record, xtbml_record
   use tblite_toml, only : toml_table, toml_key, get_value, set_value, add_table
   implicit none
   private

   public :: param_record, param_mask, count
   public :: charge_record, dispersion_record, element_record, halogen_record, &
      & hamiltonian_record, multipole_record, repulsion_record, thirdorder_record, &
      & post_processing_record_list, post_processing_record, molmom_record, xtbml_record


   character(len=*), parameter :: k_dispersion = "dispersion", k_repulsion = "repulsion", &
      & k_charge = "charge", k_thirdorder = "thirdorder", k_multipole = "multipole", &
      & k_halogen = "halogen", k_hamiltonian = "hamiltonian", k_element = "element", &
      & k_meta = "meta", k_version = "version", k_name = "name", k_reference = "reference", &
      & k_format = "format", k_post_proc = "post-processing"

   !> Current parameter format version
   integer, parameter :: current_format = 1


   !> Complete self-contained representation of a complete parametrization record.
   type, extends(serde_record) :: param_record
      !> Version of the represented method
      integer :: version = 0
      !> Name of the represented method
      character(len=:), allocatable :: name
      !> References relevant for the parametrization records
      character(len=:), allocatable :: reference
      !> Definition of the Hamiltonian, always required
      type(hamiltonian_record) :: hamiltonian
      !> Definition of the dispersion correction
      type(dispersion_record), allocatable :: dispersion
      !> Definition of the repulsion contribution
      type(repulsion_record), allocatable :: repulsion
      !> Definition of the isotropic second-order charge interactions
      type(charge_record), allocatable :: charge
      !> Definition of the anisotropic second-order multipolar interactions
      type(multipole_record), allocatable :: multipole
      !> Definition of the halogen bonding correction
      type(halogen_record), allocatable :: halogen
      !> Definition of the isotropic third-order charge interactions
      type(thirdorder_record), allocatable :: thirdorder
      !> Element specific parameter records
      type(element_record), allocatable :: record(:)
      !> Abstract post processing class 
      type(post_processing_record_list), allocatable :: post_proc
   contains
      generic :: load => load_from_array
      generic :: dump => dump_to_array
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Read parametrization data from parameter array
      procedure, private :: load_from_array
      !> Write parametrization data to parameter array
      procedure, private :: dump_to_array
      !> Get element record
      procedure :: get
   end type param_record


contains


!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(param_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   integer :: this_format

   call get_value(table, k_meta, child)
   call get_value(child, k_format, this_format, current_format)
   if (this_format < 1) then
      call fatal_error(error, "Parametrer file format must be a positive version")
      return
   end if
   if (this_format > current_format) then
      call fatal_error(error, "Requested future parameter file format which is not yet supported")
      return
   end if
   call get_value(child, k_version, self%version, 0)
   call get_value(child, k_name, self%name)
   call get_value(child, k_reference, self%reference)

   call get_value(table, k_dispersion, child, requested=.false.)
   if (associated(child)) then
      allocate(self%dispersion)
      call self%dispersion%load(child, error)
      if (allocated(error)) return
   end if

   call get_value(table, k_repulsion, child, requested=.false.)
   if (associated(child)) then
      allocate(self%repulsion)
      call self%repulsion%load(child, error)
      if (allocated(error)) return
   end if

   call get_value(table, k_halogen, child, requested=.false.)
   if (associated(child)) then
      allocate(self%halogen)
      call self%halogen%load(child, error)
      if (allocated(error)) return
   end if

   call get_value(table, k_charge, child, requested=.false.)
   if (associated(child)) then
      allocate(self%charge)
      call self%charge%load(child, error)
      if (allocated(error)) return
   end if

   call get_value(table, k_thirdorder, child, requested=.false.)
   if (associated(child)) then
      allocate(self%thirdorder)
      call self%thirdorder%load(child, error)
      if (allocated(error)) return
   end if

   call get_value(table, k_multipole, child, requested=.false.)
   if (associated(child)) then
      allocate(self%multipole)
      call self%multipole%load(child, error)
      if (allocated(error)) return
   end if

   call get_value(table, k_post_proc, child, requested=.false.)
   if (associated(child)) then
      allocate(self%post_proc)
      call self%post_proc%load(child, error)
   end if 

   call get_value(table, k_element, child)
   call records_from_table(self%record, child, error)
   if (allocated(error)) return

   call get_value(table, k_hamiltonian, child, requested=.false.)
   if (associated(child)) then
      self%hamiltonian%sym = self%record%sym
      call self%hamiltonian%load(child, error)
      if (allocated(error)) return
   else
      call fatal_error(error, "Hamiltonian entry is missing")
      if (allocated(error)) return
   end if
end subroutine load_from_toml


!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(param_record), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   call add_table(table, k_meta, child)
   if (allocated(self%name)) call set_value(child, k_name, self%name)
   if (allocated(self%reference)) call set_value(child, k_reference, self%reference)
   call set_value(child, k_version, self%version)
   call set_value(child, k_format, current_format)

   call add_table(table, k_hamiltonian, child)
   call self%hamiltonian%dump(child, error)
   if (allocated(error)) return

   if (allocated(self%dispersion)) then
      call add_table(table, k_dispersion, child)
      call self%dispersion%dump(child, error)
      if (allocated(error)) return
   end if

   if (allocated(self%repulsion)) then
      call add_table(table, k_repulsion, child)
      call self%repulsion%dump(child, error)
      if (allocated(error)) return
   end if

   if (allocated(self%halogen)) then
      call add_table(table, k_halogen, child)
      call self%halogen%dump(child, error)
      if (allocated(error)) return
   end if

   if (allocated(self%charge)) then
      call add_table(table, k_charge, child)
      call self%charge%dump(child, error)
      if (allocated(error)) return
   end if

   if (allocated(self%thirdorder)) then
      call add_table(table, k_thirdorder, child)
      call self%thirdorder%dump(child, error)
      if (allocated(error)) return
   end if

   if (allocated(self%multipole)) then
      call add_table(table, k_multipole, child)
      call self%multipole%dump(child, error)
      if (allocated(error)) return
   end if

   if (allocated(self%post_proc)) then
      call add_table(table, k_post_proc, child)
      call self%post_proc%dump(child, error)
      if (allocated(error)) return
   end if

   call add_table(table, k_element, child)
   call records_to_table(self%record, child, error)
   if (allocated(error)) return
end subroutine dump_to_toml


!> Deserialize records from a table by iterating over all entires
subroutine records_from_table(record, table, error)
   !> List of all element records
   type(element_record), allocatable, intent(out) :: record(:)
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ii
   type(toml_key), allocatable :: list(:)
   type(toml_table), pointer :: child

   call table%get_keys(list)
   allocate(record(size(list)))

   do ii = 1, size(list)
      call get_value(table, list(ii)%key, child)
      call record(ii)%load(child, error)
      if (allocated(error)) exit
   end do
   if (allocated(error)) return
end subroutine records_from_table


!> Serialize records to a table by iterating over all entries
subroutine records_to_table(record, table, error)
   !> List of all element records
   type(element_record), intent(in) :: record(:)
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ii
   type(toml_table), pointer :: child

   do ii = 1, size(record)
      call add_table(table, trim(record(ii)%sym), child)
      call record(ii)%dump(child, error)
      if (allocated(error)) exit
   end do
   if (allocated(error)) return
end subroutine records_to_table


!> Get the position of an element in the parameter records
pure subroutine get(self, sym, num, pos)
   !> Instance of the parametrization records
   class(param_record), target, intent(in) :: self
   !> Symbol of the element
   character(len=*), intent(in) :: sym
   !> Atomic number of the element
   integer, intent(in) :: num
   !> Position in the records
   integer, intent(out) :: pos

   integer :: ii

   pos = 0
   if (.not.allocated(self%record)) return

   do ii = 1, size(self%record)
      if (self%record(ii)%sym == sym) then
         pos = ii
         exit
      end if
   end do
   if (pos /= 0) return

   do ii = 1, size(self%record)
      if (self%record(ii)%num == num) then
         pos = ii
         exit
      end if
   end do
   if (pos /= 0) return
end subroutine get

!> Read parametrization data from parameter array
subroutine load_from_array(self, array, base, mask, error)
   class(param_record), intent(inout) :: self
   real(wp), intent(in) :: array(:)
   type(param_record), intent(in) :: base
   type(param_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   integer :: ii, ir
   integer :: offset

   select type(self)
   type is (param_record)
      self = base
   end select

   offset = 0
   call self%hamiltonian%load(array, offset, base%hamiltonian, mask%hamiltonian, error)
   if (allocated(error)) return

   if (allocated(self%dispersion)) then
      call self%dispersion%load(array, offset, base%dispersion, mask%dispersion, error)
      if (allocated(error)) return
   end if

   if (allocated(self%repulsion)) then
      call self%repulsion%load(array, offset, base%repulsion, mask%repulsion, error)
      if (allocated(error)) return
   end if

   if (allocated(self%halogen)) then
      call self%halogen%load(array, offset, base%halogen, mask%halogen, error)
      if (allocated(error)) return
   end if

   if (allocated(self%charge)) then
      call self%charge%load(array, offset, base%charge, mask%charge, error)
      if (allocated(error)) return
   end if

   if (allocated(self%thirdorder)) then
      call self%thirdorder%load(array, offset, base%thirdorder, mask%thirdorder, error)
      if (allocated(error)) return
   end if

   if (allocated(self%multipole)) then
      call self%multipole%load(array, offset, base%multipole, mask%multipole, error)
      if (allocated(error)) return
   end if

   do ii = 1, size(mask%record)
      call self%get(mask%record(ii)%sym, mask%record(ii)%num, ir)
      call self%record(ir)%load(array, offset, base%record(ir), mask%record(ii), error)
      if (allocated(error)) exit
   end do
   if (allocated(error)) return
end subroutine load_from_array


!> Write parametrization data to parameter array
subroutine dump_to_array(self, array, mask, error)
   class(param_record), intent(in) :: self
   real(wp), intent(inout) :: array(:)
   type(param_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   integer :: ii, ir
   integer :: offset

   offset = 0
   call self%hamiltonian%dump(array, offset, mask%hamiltonian, error)
   if (allocated(error)) return

   if (allocated(self%dispersion)) then
      call self%dispersion%dump(array, offset, mask%dispersion, error)
      if (allocated(error)) return
   end if

   if (allocated(self%repulsion)) then
      call self%repulsion%dump(array, offset, mask%repulsion, error)
      if (allocated(error)) return
   end if

   if (allocated(self%halogen)) then
      call self%halogen%dump(array, offset, mask%halogen, error)
      if (allocated(error)) return
   end if

   if (allocated(self%charge)) then
      call self%charge%dump(array, offset, mask%charge, error)
      if (allocated(error)) return
   end if

   if (allocated(self%thirdorder)) then
      call self%thirdorder%dump(array, offset, mask%thirdorder, error)
      if (allocated(error)) return
   end if

   if (allocated(self%multipole)) then
      call self%multipole%dump(array, offset, mask%multipole, error)
      if (allocated(error)) return
   end if

   do ii = 1, size(mask%record)
      call self%get(mask%record(ii)%sym, mask%record(ii)%num, ir)
      call self%record(ir)%dump(array, offset, mask%record(ii), error)
      if (allocated(error)) exit
   end do
   if (allocated(error)) return
end subroutine dump_to_array

end module tblite_param

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

program dftd3_main
   use, intrinsic :: iso_fortran_env, only : output_unit, error_unit
   use mctc_env, only : error_type
   use dftd3_app_cli, only : app_config, get_arguments
   use dftd3_app_driver, only : app_driver
   implicit none
   class(app_config), allocatable :: config
   type(error_type), allocatable :: error

   call get_arguments(config, error)
   call handle_error(error)

   call app_driver(config, error)
   call handle_error(error)

contains

subroutine handle_error(error)
   type(error_type), allocatable, intent(inout) :: error

   interface
      subroutine sys_exit(stat) bind(c, name="exit")
         use, intrinsic :: iso_c_binding, only : c_int
         integer(c_int), value :: stat
      end subroutine sys_exit
   end interface

   if (allocated(error)) then
      if (error%stat == 0) then
         write(output_unit, '(a)') error%message
         call sys_exit(0)
      else
         write(error_unit, '("[Error]", 1x, a)') error%message
         call sys_exit(1)
      end if
   end if
end subroutine handle_error

end program dftd3_main

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/lapack/getri.f90
!> Provides wrappers for computing a matrix inverse

!> Wrappers to obtain the inverse of a matrix
module tblite_lapack_getri
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_getri


   !> Computes the inverse of a matrix using the LU factorization
   !> computed by ?GETRF.
   !>
   !> This method inverts U and then computes inv(A) by solving the system
   !> inv(A)*L = inv(U) for inv(A).
   interface wrap_getri
      module procedure :: wrap_sgetri
      module procedure :: wrap_dgetri
   end interface wrap_getri


   !> Computes the inverse of a matrix using the LU factorization
   !> computed by ?GETRF.
   !>
   !> This method inverts U and then computes inv(A) by solving the system
   !> inv(A)*L = inv(U) for inv(A).
   interface lapack_getri
      pure subroutine sgetri(n, a, lda, ipiv, work, lwork, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine sgetri
      pure subroutine dgetri(n, a, lda, ipiv, work, lwork, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine dgetri
   end interface lapack_getri

contains

subroutine wrap_sgetri(amat, ipiv, info)
   real(sp), intent(inout) :: amat(:, :)
   integer, intent(in) :: ipiv(:)
   integer, intent(out) :: info
   integer :: n, lda, lwork
   real(sp), allocatable :: work(:)
   real(sp) :: test(1)
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   lwork = -1
   call lapack_getri(n, amat, lda, ipiv, test, lwork, info)
   if (info == 0) then
      lwork = nint(test(1))
      allocate(work(lwork))
      call lapack_getri(n, amat, lda, ipiv, work, lwork, info)
   end if
end subroutine wrap_sgetri


subroutine wrap_dgetri(amat, ipiv, info)
   real(dp), intent(inout) :: amat(:, :)
   integer, intent(in) :: ipiv(:)
   integer, intent(out) :: info
   integer :: n, lda, lwork
   real(dp), allocatable :: work(:)
   real(dp) :: test(1)
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   lwork = -1
   call lapack_getri(n, amat, lda, ipiv, test, lwork, info)
   if (info == 0) then
      lwork = nint(test(1))
      allocate(work(lwork))
      call lapack_getri(n, amat, lda, ipiv, work, lwork, info)
   end if
end subroutine wrap_dgetri

end module tblite_lapack_getri

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/api/container.f90
!> Provides API exports for the #tblite_container handle.

!> API export for managing interaction containers
module tblite_api_container
   use, intrinsic :: iso_c_binding
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_io, only : structure_type
   use tblite_api_version, only : namespace
   use tblite_api_calculator, only : vp_calculator
   use tblite_api_context, only : vp_context
   use tblite_api_structure, only : vp_structure
   use tblite_basis, only : basis_type
   use tblite_container, only : container_type
   use tblite_data_spin, only : get_spin_constant
   use tblite_external_field, only : electric_field
   use tblite_spin, only : spin_polarization, new_spin_polarization
   use tblite_api_utils, only: c_f_character
   implicit none
   private

   public :: vp_container, delete_container_api


   !> Void pointer to a container instance
   type :: vp_container
      !> Actual container
      class(container_type), allocatable :: ptr
   end type vp_container

   logical, parameter :: debug = .false.

contains


subroutine push_back_api(vctx, vcalc, vcont) &
      & bind(C, name=namespace//"calculator_push_back")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   type(c_ptr), intent(inout) :: vcont
   type(vp_container), pointer :: cont

   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "calculator_push_back"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   if (.not.c_associated(vcont)) then
      call fatal_error(error, "Container object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcont, cont)

   ! Hacky way to propagate spin channel information to calculator
   select type(tcont => cont%ptr)
   type is(spin_polarization)
      calc%nspin = 2
   end select

   call calc%ptr%push_back(cont%ptr)

   deallocate(cont)
   vcont = c_null_ptr
end subroutine push_back_api


function new_electric_field_api(efield) result(vcont) &
      & bind(C, name=namespace//"new_electric_field")
   real(c_double), intent(in) :: efield(3)
   type(c_ptr) :: vcont
   type(vp_container), pointer :: cont

   allocate(cont)
   cont%ptr = electric_field(efield)
   vcont = c_loc(cont)
end function new_electric_field_api


function new_spin_polarization_api(vctx, vmol, vcalc, wscale) result(vcont) &
      & bind(C, name=namespace//"new_spin_polarization")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   type(c_ptr) :: vcont
   type(vp_container), pointer :: cont
   real(c_double), value :: wscale

   type(error_type), allocatable :: error
   type(spin_polarization), allocatable :: spin
   real(wp), allocatable :: wll(:, :, :)

   if (debug) print '("[Info]", 1x, a)', "new_spin_polarization"
   vcont = c_null_ptr

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vmol)) then
      call fatal_error(error, "Molecular structure data is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vmol, mol)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   allocate(spin)
   call get_spin_constants(wll, mol%ptr, calc%ptr%bas)
   wll(:, :, :) = wscale * wll
   call new_spin_polarization(spin, mol%ptr, wll, calc%ptr%bas%nsh_id)

   allocate(cont)
   call move_alloc(spin, cont%ptr)
   vcont = c_loc(cont)
end function new_spin_polarization_api


subroutine get_spin_constants(wll, mol, bas)
   real(wp), allocatable, intent(out) :: wll(:, :, :)
   type(structure_type), intent(in) :: mol
   type(basis_type), intent(in) :: bas

   integer :: izp, ish, jsh, il, jl

   allocate(wll(bas%nsh, bas%nsh, mol%nid), source=0.0_wp)

   do izp = 1, mol%nid
      do ish = 1, bas%nsh_id(izp)
         il = bas%cgto(ish, izp)%ang
         do jsh = 1, bas%nsh_id(izp)
            jl = bas%cgto(jsh, izp)%ang
            wll(jsh, ish, izp) = get_spin_constant(jl, il, mol%num(izp))
         end do
      end do
   end do
end subroutine get_spin_constants


subroutine delete_container_api(vcont) &
      & bind(C, name=namespace//"delete_container")
   type(c_ptr), intent(inout) :: vcont
   type(vp_container), pointer :: cont

   if (debug) print '("[Info]", 1x, a)', "delete_container"

   if (c_associated(vcont)) then
      call c_f_pointer(vcont, cont)

      deallocate(cont)
      vcont = c_null_ptr
   end if
end subroutine delete_container_api


end module tblite_api_container

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Driver for unit testing
program tester
   use, intrinsic :: iso_fortran_env, only : error_unit
   use mctc_env, only : get_argument
   use mctc_env_testing, only : run_testsuite, new_testsuite, testsuite_type, &
      & select_suite, run_selected
   use test_ceh, only : collect_ceh
   use test_cgto_ortho, only : collect_cgto_ortho
   use test_coulomb_charge, only : collect_coulomb_charge
   use test_coulomb_thirdorder, only : collect_coulomb_thirdorder
   use test_coulomb_multipole, only : collect_coulomb_multipole
   use test_double_dictionary, only : collect_double_dictionary
   use test_dispersion, only : collect_dispersion
   use test_fit, only : collect_fit
   use test_gfn1_xtb, only : collect_gfn1_xtb
   use test_gfn2_xtb, only : collect_gfn2_xtb
   use test_hamiltonian, only : collect_hamiltonian
   use test_hdf5, only : collect_hdf5
   use test_halogen, only : collect_halogen
   use test_integral_multipole, only : collect_integral_multipole
   use test_integral_overlap, only : collect_integral_overlap
   use test_integral_trafo, only : collect_integral_trafo
   use test_ipea1_xtb, only : collect_ipea1_xtb
   use test_molden, only : collect_molden
   use test_npy, only : collect_npy
   use test_npz, only : collect_npz
   use test_post_processing, only : collect_post_processing
   use test_repulsion, only : collect_repulsion
   use test_slater_expansion, only : collect_slater_expansion
   use test_spin, only : collect_spin
   use test_solvation_born, only : collect_solvation_born
   use test_solvation_ddx, only : collect_solvation_ddx
   use test_solvation_surface, only : collect_solvation_surface
   use test_solvation_cds, only: collect_solvation_cds
   use test_solvation_shift, only: collect_solvation_shift
   use test_tagged_io, only : collect_tagged_io
   use test_trexio, only : collect_trexio
   use test_wavefunction_restart, only : collect_wavefunction_restart
   use test_xtb_external, only : collect_xtb_external
   use test_xtb_param, only : collect_xtb_param
   use test_xtbml, only : collect_xtbml
   implicit none
   integer :: stat, is
   character(len=:), allocatable :: suite_name, test_name
   type(testsuite_type), allocatable :: testsuites(:)
   character(len=*), parameter :: fmt = '("#", *(1x, a))'

   stat = 0

   testsuites = [ &
      new_testsuite("tagged-io", collect_tagged_io), &
      new_testsuite("trexio", collect_trexio), &
      new_testsuite("fit", collect_fit), &
      new_testsuite("repulsion", collect_repulsion), &
      new_testsuite("npy", collect_npy), &
      new_testsuite("npz", collect_npz), &
      new_testsuite("solvation-born", collect_solvation_born), &
      new_testsuite("solvation-ddx", collect_solvation_ddx), &
      new_testsuite("solvation-surface", collect_solvation_surface), &
      new_testsuite("solvation-cds", collect_solvation_cds), &
      new_testsuite("solvation-shift", collect_solvation_shift), &
      new_testsuite("coulomb-charge", collect_coulomb_charge), &
      new_testsuite("coulomb-thirdorder", collect_coulomb_thirdorder), &
      new_testsuite("coulomb-multipole", collect_coulomb_multipole), &
      new_testsuite("double-dictionary", collect_double_dictionary), &
      new_testsuite("post-processing", collect_post_processing), &
      new_testsuite("slater-expansion", collect_slater_expansion), &
      new_testsuite("cgto-ortho", collect_cgto_ortho), &
      new_testsuite("integral-overlap", collect_integral_overlap), &
      new_testsuite("integral-multipole", collect_integral_multipole), &
      new_testsuite("integral-trafo", collect_integral_trafo), &
      new_testsuite("molden", collect_molden), &
      new_testsuite("hamiltonian", collect_hamiltonian), &
      new_testsuite("hdf5", collect_hdf5), &
      new_testsuite("halogen", collect_halogen), &
      new_testsuite("wavefunction-restart", collect_wavefunction_restart), &
      new_testsuite("dispersion", collect_dispersion), &
      new_testsuite("gfn1-xtb", collect_gfn1_xtb), &
      new_testsuite("ceh", collect_ceh), &
      new_testsuite("ipea1-xtb", collect_ipea1_xtb), &
      new_testsuite("gfn2-xtb", collect_gfn2_xtb), &
      new_testsuite("xtb-external", collect_xtb_external), &
      new_testsuite("spin", collect_spin), &
      new_testsuite("xtb-param", collect_xtb_param), &
      new_testsuite("xtbml", collect_xtbml) &
      ]

   call get_argument(1, suite_name)
   call get_argument(2, test_name)

   if (allocated(suite_name)) then
      is = select_suite(testsuites, suite_name)
      if (is > 0 .and. is <= size(testsuites)) then
         if (allocated(test_name)) then
            write(error_unit, fmt) "Suite:", testsuites(is)%name
            call run_selected(testsuites(is)%collect, test_name, error_unit, stat)
            if (stat < 0) then
               error stop 1
            end if
         else
            write(error_unit, fmt) "Testing:", testsuites(is)%name
            call run_testsuite(testsuites(is)%collect, error_unit, stat)
         end if
      else
         write(error_unit, fmt) "Available testsuites"
         do is = 1, size(testsuites)
            write(error_unit, fmt) "-", testsuites(is)%name
         end do
         error stop 1
      end if
   else
      do is = 1, size(testsuites)
         write(error_unit, fmt) "Testing:", testsuites(is)%name
         call run_testsuite(testsuites(is)%collect, error_unit, stat)
      end do
   end if

   if (stat > 0) then
      write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
      error stop 1
   end if


end program tester

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the rational (Becke--Johnson) damping function.
module dftd4_damping_rational
   use dftd4_cutoff, only : smooth_cutoff
   use dftd4_damping, only : damping_param
   use dftd4_damping_atm, only : get_atm_dispersion
   use dftd4_data, only : get_r4r2_val
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   implicit none
   private

   public :: rational_damping_param


   !> Rational (Becke-Johnson) damping model
   type, extends(damping_param) :: rational_damping_param
      real(wp) :: s6 = 1.0_wp
      real(wp) :: s8
      real(wp) :: s9 = 1.0_wp
      real(wp) :: a1
      real(wp) :: a2
      real(wp) :: alp = 16.0_wp
   contains

      !> Evaluate pairwise dispersion energy expression
      procedure :: get_dispersion2_impl => get_dispersion2

      !> Evaluate ATM three-body dispersion energy expression
      procedure :: get_dispersion3_impl => get_dispersion3

      !> Evaluate pairwise representation of additive dispersion energy
      procedure :: get_pairwise_dispersion2_impl => get_pairwise_dispersion2

      !> Evaluate pairwise representation of non-additive dispersion energy
      procedure :: get_pairwise_dispersion3_impl => get_pairwise_dispersion3

   end type rational_damping_param

   real(wp), parameter :: sixth = 1.0_wp / 6.0_wp


contains


!> Evaluation of the dispersion energy expression
subroutine get_dispersion2(self, mol, trans, cutoff, width, r4r2, c6, dc6dcn, dc6dq, &
      & energy, dEdcn, dEdq, gradient, sigma)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_dispersion2

   !> Damping parameters
   class(rational_damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Width of smooth cutoff
   real(wp), intent(in) :: width

   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Derivative of the C6 w.r.t. the coordination number
   real(wp), intent(in), optional :: dc6dcn(:, :)

   !> Derivative of the C6 w.r.t. the partial charges
   real(wp), intent(in), optional :: dc6dq(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:)

   !> Derivative of the energy w.r.t. the coordination number
   real(wp), intent(inout), optional :: dEdcn(:)

   !> Derivative of the energy w.r.t. the partial charges
   real(wp), intent(inout), optional :: dEdq(:)

   !> Dispersion gradient
   real(wp), intent(inout), optional :: gradient(:, :)

   !> Dispersion virial
   real(wp), intent(inout), optional :: sigma(:, :)

   logical :: grad

   if (abs(self%s6) < epsilon(1.0_wp) .and. abs(self%s8) < epsilon(1.0_wp)) return
   grad = present(dc6dcn) .and. present(dEdcn) .and. present(dc6dq) &
      & .and. present(dEdq) .and. present(gradient) .and. present(sigma)

   if (grad) then
      call get_dispersion_derivs(self, mol, trans, cutoff, width, r4r2, c6, &
         & dc6dcn, dc6dq, energy, dEdcn, dEdq, gradient, sigma)
   else
      call get_dispersion_energy(self, mol, trans, cutoff, width, r4r2, c6, energy)
   end if

end subroutine get_dispersion2


!> Evaluation of the dispersion energy expression
subroutine get_dispersion_energy(self, mol, trans, cutoff, width, r4r2, c6, energy)

   !> Damping parameters
   class(rational_damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Width of smooth cutoff
   real(wp), intent(in) :: width

   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:)

   integer :: iat, jat, izp, jzp, jtr
   real(wp) :: vec(3), r2, r, cutoff2, r0ij, rrij, c6ij, t6, t8, edisp, dE
   real(wp) :: sw, dswdr

   ! Thread-private array for reduction
   ! Set to 0 explicitly as the shared variants are potentially non-zero (inout)
   real(wp), allocatable :: energy_local(:)

   cutoff2 = cutoff*cutoff

   !$omp parallel default(none) &
   !$omp shared(mol, self, c6, trans, cutoff2, cutoff, width, r4r2) &
   !$omp private(iat, jat, izp, jzp, jtr, vec, r2, r0ij, rrij, c6ij, &
   !$omp& t6, t8, edisp, dE, r, sw, dswdr) &
   !$omp shared(energy) &
   !$omp private(energy_local)
   allocate(energy_local(size(energy, 1)), source=0.0_wp)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)
         rrij = 3*r4r2(izp)*r4r2(jzp)
         r0ij = self%a1 * sqrt(rrij) + self%a2
         c6ij = c6(jat, iat)
         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, jtr))
            r2 = vec(1)*vec(1) + vec(2)*vec(2) + vec(3)*vec(3)
            if (r2 > cutoff2 .or. r2 < epsilon(1.0_wp)) cycle
            r = sqrt(r2)
            call smooth_cutoff(r, cutoff, width, sw, dswdr)
            if (sw <= 0.0_wp) cycle

            t6 = 1.0_wp/(r2**3 + r0ij**6)
            t8 = 1.0_wp/(r2**4 + r0ij**8)

            edisp = sw * (self%s6*t6 + self%s8*rrij*t8)

            dE = -c6ij*edisp * 0.5_wp

            energy_local(iat) = energy_local(iat) + dE
            if (iat /= jat) then
               energy_local(jat) = energy_local(jat) + dE
            end if
         end do
      end do
   end do
   !$omp end do
   !$omp critical (get_dispersion_energy_)
   energy(:) = energy(:) + energy_local(:)
   !$omp end critical (get_dispersion_energy_)
   deallocate(energy_local)
   !$omp end parallel

end subroutine get_dispersion_energy


!> Evaluation of the dispersion energy expression
subroutine get_dispersion_derivs(self, mol, trans, cutoff, width, r4r2, c6, dc6dcn, dc6dq, &
      & energy, dEdcn, dEdq, gradient, sigma)

   !> Damping parameters
   class(rational_damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Width of smooth cutoff
   real(wp), intent(in) :: width

   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Derivative of the C6 w.r.t. the coordination number
   real(wp), intent(in) :: dc6dcn(:, :)

   !> Derivative of the C6 w.r.t. the partial charges
   real(wp), intent(in) :: dc6dq(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:)

   !> Derivative of the energy w.r.t. the coordination number
   real(wp), intent(inout) :: dEdcn(:)

   !> Derivative of the energy w.r.t. the partial charges
   real(wp), intent(inout) :: dEdq(:)

   !> Dispersion gradient
   real(wp), intent(inout) :: gradient(:, :)

   !> Dispersion virial
   real(wp), intent(inout) :: sigma(:, :)

   integer :: iat, jat, izp, jzp, jtr
   real(wp) :: vec(3), r2, r, cutoff2, r0ij, rrij, c6ij, t6, t8, d6, d8
   real(wp) :: edisp0, gdisp0, edisp, gdisp, sw, dswdr
   real(wp) :: dE, dG(3), dS(3, 3)

   ! Thread-private arrays for reduction
   ! Set to 0 explicitly as the shared variants are potentially non-zero (inout)
   real(wp), allocatable :: energy_local(:)
   real(wp), allocatable :: dEdcn_local(:)
   real(wp), allocatable :: dEdq_local(:)
   real(wp), allocatable :: gradient_local(:, :)
   real(wp), allocatable :: sigma_local(:, :)

   cutoff2 = cutoff*cutoff

   !$omp parallel default(none) &
   !$omp shared(mol, self, c6, dc6dcn, dc6dq, trans, cutoff2, cutoff, width, r4r2) &
   !$omp private(iat, jat, izp, jzp, jtr, vec, r2, r0ij, rrij, c6ij, t6, t8, &
   !$omp& d6, d8, edisp0, gdisp0, edisp, gdisp, dE, dG, dS, r, sw, dswdr) &
   !$omp shared(energy, gradient, sigma, dEdcn, dEdq) &
   !$omp private(energy_local, gradient_local, sigma_local, dEdcn_local, &
   !$omp& dEdq_local)
   allocate(energy_local(size(energy, 1)), source=0.0_wp)
   allocate(dEdcn_local(size(dEdcn, 1)), source=0.0_wp)
   allocate(dEdq_local(size(dEdq, 1)), source=0.0_wp)
   allocate(gradient_local(size(gradient, 1), size(gradient, 2)), source=0.0_wp)
   allocate(sigma_local(size(sigma, 1), size(sigma, 2)), source=0.0_wp)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)
         rrij = 3*r4r2(izp)*r4r2(jzp)
         r0ij = self%a1 * sqrt(rrij) + self%a2
         c6ij = c6(jat, iat)
         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, jtr))
            r2 = vec(1)*vec(1) + vec(2)*vec(2) + vec(3)*vec(3)
            if (r2 > cutoff2 .or. r2 < epsilon(1.0_wp)) cycle
            r = sqrt(r2)
            call smooth_cutoff(r, cutoff, width, sw, dswdr)
            if (sw <= 0.0_wp) cycle

            t6 = 1.0_wp/(r2**3 + r0ij**6)
            t8 = 1.0_wp/(r2**4 + r0ij**8)

            d6 = -6*r2**2*t6**2
            d8 = -8*r2**3*t8**2

            edisp0 = self%s6*t6 + self%s8*rrij*t8
            gdisp0 = self%s6*d6 + self%s8*rrij*d8
            edisp = sw * edisp0
            ! Product rule for d(sw(r)*edisp0(r2))/dr2.
            gdisp = sw * gdisp0 + dswdr * edisp0 / r

            dE = -c6ij*edisp * 0.5_wp
            dG(:) = -c6ij*gdisp*vec
            dS(:, :) = spread(dG, 1, 3) * spread(vec, 2, 3) * 0.5_wp

            energy_local(iat) = energy_local(iat) + dE
            dEdcn_local(iat) = dEdcn_local(iat) - dc6dcn(iat, jat) * edisp
            dEdq_local(iat) = dEdq_local(iat) - dc6dq(iat, jat) * edisp
            sigma_local(:, :) = sigma_local + dS
            if (iat /= jat) then
               energy_local(jat) = energy_local(jat) + dE
               dEdcn_local(jat) = dEdcn_local(jat) - dc6dcn(jat, iat) * edisp
               dEdq_local(jat) = dEdq_local(jat) - dc6dq(jat, iat) * edisp
               gradient_local(:, iat) = gradient_local(:, iat) + dG
               gradient_local(:, jat) = gradient_local(:, jat) - dG
               sigma_local(:, :) = sigma_local + dS
            end if
         end do
      end do
   end do
   !$omp end do
   !$omp critical (get_dispersion_derivs_)
   energy(:) = energy(:) + energy_local(:)
   dEdcn(:) = dEdcn(:) + dEdcn_local(:)
   dEdq(:) = dEdq(:) + dEdq_local(:)
   gradient(:, :) = gradient(:, :) + gradient_local(:, :)
   sigma(:, :) = sigma(:, :) + sigma_local(:, :)
   !$omp end critical (get_dispersion_derivs_)
   deallocate(energy_local)
   deallocate(dEdcn_local)
   deallocate(dEdq_local)
   deallocate(gradient_local)
   deallocate(sigma_local)
   !$omp end parallel

end subroutine get_dispersion_derivs


!> Evaluation of the dispersion energy expression
subroutine get_dispersion3(self, mol, trans, cutoff, width, r4r2, c6, dc6dcn, dc6dq, &
      & energy, dEdcn, dEdq, gradient, sigma)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_dispersion3

   !> Damping parameters
   class(rational_damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Width of smooth cutoff
   real(wp), intent(in) :: width

   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Derivative of the C6 w.r.t. the coordination number
   real(wp), intent(in), optional :: dc6dcn(:, :)

   !> Derivative of the C6 w.r.t. the partial charges
   real(wp), intent(in), optional :: dc6dq(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:)

   !> Derivative of the energy w.r.t. the coordination number
   real(wp), intent(inout), optional :: dEdcn(:)

   !> Derivative of the energy w.r.t. the partial charges
   real(wp), intent(inout), optional :: dEdq(:)

   !> Dispersion gradient
   real(wp), intent(inout), optional :: gradient(:, :)

   !> Dispersion virial
   real(wp), intent(inout), optional :: sigma(:, :)

   call get_atm_dispersion(mol, trans, cutoff, width, self%s9, self%a1, &
      & self%a2, self%alp, r4r2, c6, dc6dcn, dc6dq, energy, dEdcn, dEdq, &
      & gradient, sigma)

end subroutine get_dispersion3


!> Evaluation of the dispersion energy expression projected on atomic pairs
subroutine get_pairwise_dispersion2(self, mol, trans, cutoff, width, r4r2, c6, energy)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_pairwise_dispersion2

   !> Damping parameters
   class(rational_damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Width of smooth cutoff
   real(wp), intent(in) :: width

   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:, :)

   integer :: iat, jat, izp, jzp, jtr
   real(wp) :: vec(3), r2, r, cutoff2, r0ij, rrij, c6ij, t6, t8, edisp, dE
   real(wp) :: sw, dswdr

   ! Thread-private array for reduction
   ! Set to 0 explicitly as the shared variants are potentially non-zero (inout)
   real(wp), allocatable :: energy_local(:, :)

   if (abs(self%s6) < epsilon(1.0_wp) .and. abs(self%s8) < epsilon(1.0_wp)) return
   cutoff2 = cutoff*cutoff

   !$omp parallel default(none) &
   !$omp shared(mol, self, c6, trans, cutoff2, cutoff, width, r4r2) &
   !$omp private(iat, jat, izp, jzp, jtr, vec, r2, r0ij, rrij, c6ij, &
   !$omp& t6, t8, edisp, dE, r, sw, dswdr) &
   !$omp shared(energy) &
   !$omp private(energy_local)
   allocate(energy_local(size(energy, 1), size(energy, 2)), source=0.0_wp)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)
         rrij = 3*r4r2(izp)*r4r2(jzp)
         r0ij = self%a1 * sqrt(rrij) + self%a2
         c6ij = c6(jat, iat)
         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, jtr))
            r2 = vec(1)*vec(1) + vec(2)*vec(2) + vec(3)*vec(3)
            if (r2 > cutoff2 .or. r2 < epsilon(1.0_wp)) cycle
            r = sqrt(r2)
            call smooth_cutoff(r, cutoff, width, sw, dswdr)
            if (sw <= 0.0_wp) cycle

            t6 = 1.0_wp/(r2**3 + r0ij**6)
            t8 = 1.0_wp/(r2**4 + r0ij**8)

            edisp = sw * (self%s6*t6 + self%s8*rrij*t8)

            dE = -c6ij*edisp * 0.5_wp

            energy_local(jat, iat) = energy_local(jat, iat) + dE
            if (iat /= jat) then
               energy_local(iat, jat) = energy_local(iat, jat) + dE
            end if
         end do
      end do
   end do
   !$omp end do
   !$omp critical (get_pairwise_dispersion2_)
   energy(:, :) = energy(:, :) + energy_local(:, :)
   !$omp end critical (get_pairwise_dispersion2_)
   deallocate(energy_local)
   !$omp end parallel

end subroutine get_pairwise_dispersion2


!> Evaluation of the dispersion energy expression
subroutine get_pairwise_dispersion3(self, mol, trans, cutoff, width, r4r2, c6, energy)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_pairwise_dispersion3

   !> Damping parameters
   class(rational_damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Width of smooth cutoff
   real(wp), intent(in) :: width

   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:, :)

   integer :: iat, jat, kat, izp, jzp, kzp, jtr, ktr
   real(wp) :: vij(3), vjk(3), vik(3), r2ij, r2jk, r2ik, rij, rjk, rik
   real(wp) :: c6ij, c6jk, c6ik, triple
   real(wp) :: r0ij, r0jk, r0ik, r0, r1, r2, r3, r5, rr, fdmp, ang
   real(wp) :: cutoff2, c9, dE, alp3, swij, swjk, swik, dswdr, sw

   ! Thread-private arrays for reduction
   ! Set to 0 explicitly as the shared variants are potentially non-zero (inout)
   real(wp), allocatable :: energy_local(:, :)

   if (abs(self%s9) < epsilon(1.0_wp)) return
   cutoff2 = cutoff*cutoff
   alp3 = self%alp / 3.0_wp

   !$omp parallel default(none) &
   !$omp shared(mol, trans, c6, r4r2, cutoff2, cutoff, width, alp3, self) &
   !$omp private(iat, jat, kat, izp, jzp, kzp, jtr, ktr, vij, vjk, vik, &
   !$omp& r2ij, r2jk, r2ik, rij, rjk, rik, c6ij, c6jk, c6ik, triple, &
   !$omp& r0ij, r0jk, r0ik, r0, r1, r2, r3, r5, rr, fdmp, ang, c9, dE, &
   !$omp& swij, swjk, swik, dswdr, sw) &
   !$omp shared(energy) &
   !$omp private(energy_local)
   allocate(energy_local(size(energy, 1), size(energy, 2)), source=0.0_wp)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)
         c6ij = c6(jat, iat)
         r0ij = self%a1 * sqrt(3*r4r2(jzp)*r4r2(izp)) + self%a2
         do jtr = 1, size(trans, 2)
            vij(:) = mol%xyz(:, jat) + trans(:, jtr) - mol%xyz(:, iat)
            r2ij = vij(1)*vij(1) + vij(2)*vij(2) + vij(3)*vij(3)
            if (r2ij > cutoff2 .or. r2ij < epsilon(1.0_wp)) cycle
            rij = sqrt(r2ij)
            call smooth_cutoff(rij, cutoff, width, swij, dswdr)
            do kat = 1, jat
               kzp = mol%id(kat)
               c6ik = c6(kat, iat)
               c6jk = c6(kat, jat)
               c9 = -self%s9 * sqrt(abs(c6ij*c6ik*c6jk))
               r0ik = self%a1 * sqrt(3*r4r2(kzp)*r4r2(izp)) + self%a2
               r0jk = self%a1 * sqrt(3*r4r2(kzp)*r4r2(jzp)) + self%a2
               r0 = r0ij * r0ik * r0jk
               triple = triple_scale(iat, jat, kat)
               do ktr = 1, size(trans, 2)
                  vik(:) = mol%xyz(:, kat) + trans(:, ktr) - mol%xyz(:, iat)
                  r2ik = vik(1)*vik(1) + vik(2)*vik(2) + vik(3)*vik(3)
                  if (r2ik > cutoff2 .or. r2ik < epsilon(1.0_wp)) cycle
                  rik = sqrt(r2ik)
                  call smooth_cutoff(rik, cutoff, width, swik, dswdr)

                  ! vjk(:) = mol%xyz(:, kat) + trans(:, ktr) 
                  !          - mol%xyz(:, jat) - trans(:, jtr)
                  vjk(:) = vik(:) - vij(:)
                  r2jk = vjk(1)*vjk(1) + vjk(2)*vjk(2) + vjk(3)*vjk(3)
                  if (r2jk > cutoff2 .or. r2jk < epsilon(1.0_wp)) cycle
                  rjk = sqrt(r2jk)
                  call smooth_cutoff(rjk, cutoff, width, swjk, dswdr)
                  sw = swij * swik * swjk
                  if (sw <= 0.0_wp) cycle

                  r2 = r2ij*r2ik*r2jk
                  r1 = sqrt(r2)
                  r3 = r2 * r1
                  r5 = r3 * r2

                  fdmp = 1.0_wp / (1.0_wp + 6.0_wp * (r0 / r1)**alp3)
                  ang = 0.375_wp*(r2ij + r2jk - r2ik)*(r2ij - r2jk + r2ik)&
                     & *(-r2ij + r2jk + r2ik) / r5 + 1.0_wp / r3

                  rr = ang*fdmp

                  dE = rr * c9 * triple * sixth * sw
                  energy_local(jat, iat) = energy_local(jat, iat) - dE
                  energy_local(kat, iat) = energy_local(kat, iat) - dE
                  energy_local(iat, jat) = energy_local(iat, jat) - dE
                  energy_local(kat, jat) = energy_local(kat, jat) - dE
                  energy_local(iat, kat) = energy_local(iat, kat) - dE
                  energy_local(jat, kat) = energy_local(jat, kat) - dE
               end do
            end do
         end do
      end do
   end do
   !$omp end do
   !$omp critical (get_pairwise_dispersion3_)
   energy(:, :) = energy(:, :) + energy_local(:, :)
   !$omp end critical (get_pairwise_dispersion3_)
   deallocate(energy_local)
   !$omp end parallel

end subroutine get_pairwise_dispersion3


!> Logic exercise to distribute a triple energy to atomwise energies.
elemental function triple_scale(ii, jj, kk) result(triple)

   !> Atom indices
   integer, intent(in) :: ii, jj, kk

   !> Fraction of energy
   real(wp) :: triple

   if (ii == jj) then
      if (ii == kk) then
         ! ii'i" -> 1/6
         triple = 1.0_wp/6.0_wp
      else
         ! ii'j -> 1/2
         triple = 0.5_wp
      end if
   else
      if (ii /= kk .and. jj /= kk) then
         ! ijk -> 1 (full)
         triple = 1.0_wp
      else
         ! ijj' and iji' -> 1/2
         triple = 0.5_wp
      end if
   end if

end function triple_scale


end module dftd4_damping_rational

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/scf/iterator.f90
!> Provides the implementation of the actual self-consistent field iteractions

!> Iterator for evaluating the Hamiltonian self-consistently
module tblite_scf_iterator
   use mctc_env, only : wp, error_type
   use mctc_io, only : structure_type
   use tblite_basis_type, only : basis_type
   use tblite_container, only : container_cache, container_list
   use tblite_disp, only : dispersion_type
   use tblite_integral_type, only : integral_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_wavefunction_fermi, only : get_fermi_filling
   use tblite_wavefunction_mulliken, only : get_mulliken_shell_charges, &
      & get_mulliken_atomic_multipoles
   use tblite_xtb_coulomb, only : tb_coulomb
   use tblite_scf_mixer, only : mixer_type
   use tblite_scf_info, only : scf_info
   use tblite_scf_potential, only : potential_type, add_pot_to_h1
   use tblite_scf_solver, only : solver_type
   implicit none
   private

   public :: next_scf, get_mixer_dimension, get_electronic_energy, reduce
   public :: next_density, get_qat_from_qsh

contains

!> Evaluate self-consistent iteration for the density-dependent Hamiltonian
subroutine next_scf(iscf, mol, bas, wfn, solver, mixer, info, coulomb, dispersion, &
      & interactions, ints, pot, ccache, dcache, icache, &
      & energies, error)
   !> Current iteration count
   integer, intent(inout) :: iscf
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Tight-binding wavefunction data
   type(wavefunction_type), intent(inout) :: wfn
   !> Solver for the general eigenvalue problem
   class(solver_type), intent(inout) :: solver
   !> Convergence accelerator
   class(mixer_type), intent(inout) :: mixer
   !> Information on wavefunction data used to construct Hamiltonian
   type(scf_info), intent(in) :: info
   !> Container for coulombic interactions
   type(tb_coulomb), intent(in), optional :: coulomb
   !> Container for dispersion interactions
   class(dispersion_type), intent(in), optional :: dispersion
   !> Container for general interactions
   type(container_list), intent(in), optional :: interactions

   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Density dependent potential shifts
   type(potential_type), intent(inout) :: pot
   !> Restart data for coulombic interactions
   type(container_cache), intent(inout), optional :: ccache
   !> Restart data for dispersion interactions
   type(container_cache), intent(inout), optional :: dcache
   !> Restart data for interaction containers
   type(container_cache), intent(inout), optional :: icache

   !> Self-consistent energy
   real(wp), intent(inout) :: energies(:)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp), allocatable :: eao(:)
   real(wp) :: ts

   if (iscf > 0) then
      call mixer%next(error)
      if (allocated(error)) return

      call get_mixer(mixer, bas, wfn, info)
   end if

   iscf = iscf + 1
   call pot%reset
   if (present(coulomb) .and. present(ccache)) then
      call coulomb%get_potential(mol, ccache, wfn, pot)
   end if
   if (present(dispersion) .and. present(dcache)) then
      call dispersion%get_potential(mol, dcache, wfn, pot)
   end if
   if (present(interactions) .and. present(icache)) then
      call interactions%get_potential(mol, icache, wfn, pot)
   end if

   call add_pot_to_h1(bas, ints, pot, wfn%coeff)

   call set_mixer(mixer, wfn, info)

   call next_density(wfn, solver, ints, ts, error)
   if (allocated(error)) return

   call get_mulliken_shell_charges(bas, ints%overlap, wfn%density, wfn%n0sh, &
      & wfn%qsh)
   call get_qat_from_qsh(bas, wfn%qsh, wfn%qat)

   call get_mulliken_atomic_multipoles(bas, ints%dipole, wfn%density, &
      & wfn%dpat)
   call get_mulliken_atomic_multipoles(bas, ints%quadrupole, wfn%density, &
      & wfn%qpat)

   call diff_mixer(mixer, wfn, info)

   allocate(eao(bas%nao), source=0.0_wp)
   call get_electronic_energy(ints%hamiltonian, wfn%density, eao)

   energies(:) = ts / size(energies)
   call reduce(energies, eao, bas%ao2at)

   if (present(coulomb) .and. present(ccache)) then
      call coulomb%get_energy(mol, ccache, wfn, energies)
   end if
   if (present(dispersion) .and. present(dcache)) then
      call dispersion%get_energy(mol, dcache, wfn, energies)
   end if
   if (present(interactions) .and. present(icache)) then
      call interactions%get_energy(mol, icache, wfn, energies)
   end if
end subroutine next_scf


subroutine get_electronic_energy(h0, density, energies)
   real(wp), intent(in) :: h0(:, :)
   real(wp), intent(in) :: density(:, :, :)
   real(wp), intent(inout) :: energies(:)

   integer :: iao, jao, spin
   real(wp) :: eiao

   !$omp parallel do schedule(runtime) default(none) &
   !$omp shared(h0, density, energies) private(spin, iao, jao, eiao)
   do iao = 1, size(density, 2)
      eiao = 0.0_wp
      do spin = 1, size(density, 3)
         do jao = 1, size(density, 1)
            eiao = eiao + h0(jao, iao) * density(jao, iao, spin)
         end do
      end do
      energies(iao) = energies(iao) + eiao
   end do
end subroutine get_electronic_energy


subroutine reduce(reduced, full, map)
   real(wp), intent(inout) :: reduced(:)
   real(wp), intent(in) :: full(:)
   integer, intent(in) :: map(:)

   integer :: ix

   do ix = 1, size(map)
      reduced(map(ix)) = reduced(map(ix)) + full(ix)
   end do
end subroutine reduce


subroutine get_qat_from_qsh(bas, qsh, qat)
   type(basis_type), intent(in) :: bas
   real(wp), intent(in) :: qsh(:, :)
   real(wp), intent(out) :: qat(:, :)

   integer :: ish, ispin

   qat(:, :) = 0.0_wp
   !$omp parallel do schedule(runtime) collapse(2) default(none) &
   !$omp reduction(+:qat) shared(bas, qsh) private(ish)
   do ispin = 1, size(qsh, 2)
      do ish = 1, size(qsh, 1)
         qat(bas%sh2at(ish), ispin) = qat(bas%sh2at(ish), ispin) + qsh(ish, ispin)
      end do
   end do
end subroutine get_qat_from_qsh


function get_mixer_dimension(mol, bas, info) result(ndim)
   use tblite_scf_info, only : atom_resolved, shell_resolved
   type(structure_type), intent(in) :: mol
   type(basis_type), intent(in) :: bas
   type(scf_info), intent(in) :: info
   integer :: ndim

   ndim = 0

   select case(info%charge)
   case(atom_resolved)
      ndim = ndim + mol%nat
   case(shell_resolved)
      ndim = ndim + bas%nsh
   end select

   select case(info%dipole)
   case(atom_resolved)
      ndim = ndim + 3*mol%nat
   end select

   select case(info%quadrupole)
   case(atom_resolved)
      ndim = ndim + 6*mol%nat
   end select
end function get_mixer_dimension

subroutine set_mixer(mixer, wfn, info)
   use tblite_scf_info, only : atom_resolved, shell_resolved
   class(mixer_type), intent(inout) :: mixer
   type(wavefunction_type), intent(in) :: wfn
   type(scf_info), intent(in) :: info

   select case(info%charge)
   case(atom_resolved)
      call mixer%set(wfn%qat)
   case(shell_resolved)
      call mixer%set(wfn%qsh)
   end select

   select case(info%dipole)
   case(atom_resolved)
      call mixer%set(wfn%dpat)
   end select

   select case(info%quadrupole)
   case(atom_resolved)
      call mixer%set(wfn%qpat)
   end select
end subroutine set_mixer

subroutine diff_mixer(mixer, wfn, info)
   use tblite_scf_info, only : atom_resolved, shell_resolved
   class(mixer_type), intent(inout) :: mixer
   type(wavefunction_type), intent(in) :: wfn
   type(scf_info), intent(in) :: info

   select case(info%charge)
   case(atom_resolved)
      call mixer%diff(wfn%qat)
   case(shell_resolved)
      call mixer%diff(wfn%qsh)
   end select

   select case(info%dipole)
   case(atom_resolved)
      call mixer%diff(wfn%dpat)
   end select

   select case(info%quadrupole)
   case(atom_resolved)
      call mixer%diff(wfn%qpat)
   end select
end subroutine diff_mixer

subroutine get_mixer(mixer, bas, wfn, info)
   use tblite_scf_info, only : atom_resolved, shell_resolved
   class(mixer_type), intent(inout) :: mixer
   type(basis_type), intent(in) :: bas
   type(wavefunction_type), intent(inout) :: wfn
   type(scf_info), intent(in) :: info

   select case(info%charge)
   case(atom_resolved)
      call mixer%get(wfn%qat)
   case(shell_resolved)
      call mixer%get(wfn%qsh)
      call get_qat_from_qsh(bas, wfn%qsh, wfn%qat)
   end select

   select case(info%dipole)
   case(atom_resolved)
      call mixer%get(wfn%dpat)
   end select

   select case(info%quadrupole)
   case(atom_resolved)
      call mixer%get(wfn%qpat)
   end select
end subroutine get_mixer


subroutine next_density(wfn, solver, ints, ts, error)
   !> Tight-binding wavefunction data
   type(wavefunction_type), intent(inout) :: wfn
   !> Solver for the general eigenvalue problem
   class(solver_type), intent(inout) :: solver
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Electronic entropy
   real(wp), intent(out) :: ts
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp) :: e_fermi, stmp(2)
   real(wp), allocatable :: focc(:)
   integer :: spin

   call solver%get_density(wfn%coeff, ints%overlap, wfn%emo, wfn%focc, wfn%density, error)
   do spin = 1, 2
      call get_electronic_entropy(wfn%focc(:, spin), wfn%kt, stmp(spin))
   end do
   ts = sum(stmp)
end subroutine next_density

subroutine get_electronic_entropy(occ, kt, s)
   real(wp), intent(in) :: occ(:)
   real(wp), intent(in) :: kt
   real(wp), intent(out) :: s

   s = sum(log(occ ** occ * (1 - occ) ** (1 - occ))) * kt
end subroutine get_electronic_entropy

end module tblite_scf_iterator

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Driver entry points for the different commands
module tblite_driver
   use tblite_driver_fit, only : main
   use tblite_driver_param, only : main
   use tblite_driver_run, only : main
   use tblite_driver_guess, only : main
   use tblite_driver_tagdiff, only : main
   implicit none
   public
end module tblite_driver

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/api/context.f90
!> Provides API exports for the #tblite_context handle.

!> API export for environment context setup
module tblite_api_context
   use, intrinsic :: iso_c_binding
   use mctc_env, only : error_type, fatal_error
   use tblite_context, only : context_type, context_logger, context_terminal
   use tblite_api_error, only : vp_error
   use tblite_api_version, only : namespace
   use tblite_api_utils, only : f_c_character
   implicit none
   private

   public :: vp_context
   public :: new_context_api, check_context_api, get_context_error_api, delete_context_api
   public :: set_context_logger_api, set_context_color_api, set_context_verbosity_api


   !> Void pointer to manage calculation context
   type :: vp_context
      !> Actual payload
      type(context_type) :: ptr
   end type vp_context


   abstract interface
      !> Interface for callbacks used in custom logger
      subroutine callback(verror, msg, len, udata) bind(C)
         import :: c_char, c_int, c_ptr, vp_error
         !> Error handle
         type(c_ptr), value :: verror
         !> Message payload to be displayed
         character(len=1, kind=c_char), intent(in) :: msg(*)
         !> Length of the message
         integer(c_int), value :: len
         !> Data pointer for callback
         type(c_ptr), value :: udata
      end subroutine callback
   end interface


   !> Custom logger for calculation context to display messages
   type, extends(context_logger) :: callback_logger
      !> Data pointer for callback
      type(c_ptr) :: udata = c_null_ptr
      !> Custom callback function to display messages
      procedure(callback), pointer, nopass :: callback => null()
      !> Error handle
      type(vp_error), pointer :: verror => null()
   contains
      !> Entry point for context instance to log message
      procedure :: message
   end type callback_logger


   logical, parameter :: debug = .false.


contains


!> Create new calculation context object
function new_context_api() &
      & result(vctx) &
      & bind(C, name=namespace//"new_context")
   type(vp_context), pointer :: ctx
   type(c_ptr) :: vctx

   if (debug) print '("[Info]", 1x, a)', "new_context"

   allocate(ctx)
   vctx = c_loc(ctx)

end function new_context_api


!> Create new calculation context object
function check_context_api(vctx) result(status) &
      & bind(C, name=namespace//"check_context")
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vctx
   integer(c_int) :: status

   if (debug) print '("[Info]", 1x, a)', "check_context"

   if (c_associated(vctx)) then
      call c_f_pointer(vctx, ctx)

      status = merge(1, 0, ctx%ptr%failed())
   else
      status = 2
   end if

end function check_context_api


!> Get error message from calculation environment
subroutine get_context_error_api(vctx, charptr, buffersize) &
      & bind(C, name=namespace//"get_context_error")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   character(kind=c_char), intent(inout) :: charptr(*)
   integer(c_int), intent(in), optional :: buffersize
   integer :: max_length
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_context_error"

   if (c_associated(vctx)) then
      call c_f_pointer(vctx, ctx)

      if (present(buffersize)) then
         max_length = buffersize
      else
         max_length = huge(max_length) - 2
      end if

      call ctx%ptr%get_error(error)
      if (allocated(error)) then
         call f_c_character(error%message, charptr, max_length)
      end if
   end if

end subroutine get_context_error_api


subroutine set_context_color_api(vctx, color) &
      & bind(C, name=namespace//"set_context_color")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   integer(c_int), value :: color

   if (debug) print '("[Info]", 1x, a)', "set_context_color"

   if (c_associated(vctx)) then
      call c_f_pointer(vctx, ctx)

      ctx%ptr%terminal = context_terminal(color /= 0)
   end if
end subroutine set_context_color_api


subroutine set_context_verbosity_api(vctx, verbosity) &
      & bind(C, name=namespace//"set_context_verbosity")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   integer(c_int), value :: verbosity

   if (debug) print '("[Info]", 1x, a)', "set_context_verbosity"

   if (c_associated(vctx)) then
      call c_f_pointer(vctx, ctx)

      ctx%ptr%verbosity = verbosity
   end if
end subroutine set_context_verbosity_api


!> Delete context object
subroutine delete_context_api(vctx) &
      & bind(C, name=namespace//"delete_context")
   type(c_ptr), intent(inout) :: vctx
   type(vp_context), pointer :: ctx

   if (debug) print '("[Info]", 1x, a)', "delete_context"

   if (c_associated(vctx)) then
      call c_f_pointer(vctx, ctx)

      deallocate(ctx)
      vctx = c_null_ptr
   end if

end subroutine delete_context_api


!> Create a new custom logger for the calculation context
subroutine set_context_logger_api(vctx, vproc, vdata) &
      & bind(C, name=namespace//"set_context_logger")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_funptr), value :: vproc
   procedure(callback), pointer :: fptr
   type(c_ptr), value :: vdata

   if (debug) print '("[Info]", 1x, a)', "set_context_logger"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (c_associated(vproc)) then
      call c_f_procpointer(vproc, fptr)
      ctx%ptr%io = new_callback_logger(fptr, vdata)
   else
      if (allocated(ctx%ptr%io)) deallocate(ctx%ptr%io)
   end if

end subroutine set_context_logger_api


!> Create a new custom logger
function new_callback_logger(fptr, udata) result(self)
   !> Actual function used to display messages
   procedure(callback) :: fptr
   !> Data pointer used inside the callback function
   type(c_ptr), intent(in) :: udata
   !> New instance of the custom logger
   type(callback_logger) :: self

   self%callback => fptr
   self%udata = udata
end function new_callback_logger


!> Entry point for context type logger, transfers message from context to callback
subroutine message(self, msg, error)
   !> Instance of the custom logger with the actual logger callback function
   class(callback_logger), intent(inout) :: self
   !> Message payload from the calculation context
   character(len=*), intent(in) :: msg
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=1, kind=c_char) :: charptr(len(msg))
   integer(c_int) :: nchars

   if (.not.associated(self%verror)) then
      allocate(self%verror)
   end if

   charptr = transfer(msg, charptr)
   nchars = len(msg)
   call self%callback(c_loc(self%verror), charptr, nchars, self%udata)

   if (allocated(self%verror%ptr)) then
      call move_alloc(self%verror%ptr, error)
   end if
end subroutine message


end module tblite_api_context

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/io/data/
!> Directory containing data handling modules for tblite

!> @file tblite/io/data.f90
!> Provides format-independent array storage handlers.

!> Factory module for selecting NPZ or HDF5 structured array handlers.
module tblite_io_data
   use mctc_env, only : error_type, fatal_error
   use tblite_io_data_type, only: iodata_type, iodata_record
   use tblite_io_data_hdf5, only: hdf5_data
   use tblite_io_data_npz, only: npz_data
   implicit none
   private

   public :: iodata_type, iodata_record
   public :: open_iodata_handler

contains

!> Open an array data handler appropriate for the file extension.
subroutine open_iodata_handler(iodata, filename, error)
   !> File name used to select the storage backend
   character(len=*), intent(in) :: filename
   !> Allocated storage backend instance
   class(iodata_type), allocatable, intent(out) :: iodata
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   logical :: is_hdf5

   is_hdf5 = is_hdf5_file(filename)

   if (is_hdf5) then
      block
         type(hdf5_data), allocatable :: hdf5_handler
         allocate(hdf5_handler)
         hdf5_handler%filename = filename
         call move_alloc(hdf5_handler, iodata)
      end block
   else
      block
         type(npz_data), allocatable :: npz_handler
         allocate(npz_handler)
         npz_handler%filename = filename
         call move_alloc(npz_handler, iodata)
      end block
   end if
end subroutine open_iodata_handler

pure function is_hdf5_file(filename) result(is_hdf5)
   !> File name to inspect
   character(len=*), intent(in) :: filename
   !> Whether the file name uses an HDF5 extension
   logical :: is_hdf5

   integer :: n

   n = len_trim(filename)
   is_hdf5 = (n >= 3 .and. filename(n-2:n) == ".h5") .or. &
      & (n >= 5 .and. filename(n-4:n) == ".hdf5")
end function is_hdf5_file

end module tblite_io_data

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/disp/cache.f90
!> Provides a cache for dispersion interactions

!> Reusable data container for dispersion related calculations
module tblite_disp_cache
   use mctc_env, only : wp
   implicit none
   private
   public :: dispersion_cache

   type :: dispersion_cache
      real(wp), allocatable :: dispmat(:, :, :, :)
      real(wp), allocatable :: gwvec(:, :, :)
      real(wp), allocatable :: dgwdq(:, :, :)
      real(wp), allocatable :: vvec(:, :, :)
      real(wp), allocatable :: cn(:)
      real(wp), allocatable :: dcndr(:, :, :)
      real(wp), allocatable :: dcndL(:, :, :)
   end type dispersion_cache


end module tblite_disp_cache

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Numerical storage size parameters for real and integer values
module mctc_env_accuracy
   implicit none
   public

   !> Single precision real numbers
   integer, parameter :: sp = selected_real_kind(6)

   !> Double precision real numbers
   integer, parameter :: dp = selected_real_kind(15)

   !> Wanted precision
   integer, parameter :: wp = dp

   !> Char length for integers
   integer, parameter :: i1 = selected_int_kind(2)

   !> Short length for integers
   integer, parameter :: i2 = selected_int_kind(4)

   !> Length of default integers
   integer, parameter :: i4 = selected_int_kind(9)

   !> Long length for integers
   integer, parameter :: i8 = selected_int_kind(18)


end module mctc_env_accuracy

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/scf/solver.f90
!> Provides a base class for defining electronic solvers

!> Declaration of the abstract base class for electronic solvers
module tblite_scf_solver
   use mctc_env, only : sp, dp, wp, error_type
   use tblite_blas, only : gemm
   implicit none
   private

   !> Abstract base class for electronic solvers
   type, public, abstract :: solver_type
      !> Electronic temperature
      real(wp) :: kt
      !> Number of electrons per spin channel
      real(wp), allocatable :: nel(:)
   contains
      procedure(get_density), deferred :: get_density
      procedure(get_density), deferred :: get_wdensity
      procedure(delete), deferred :: delete
   end type solver_type

   abstract interface
      subroutine get_density(self, hmat, smat, eval, focc, density, error)
         import :: wp, solver_type, error_type
         !> Solver for the general eigenvalue problem
         class(solver_type), intent(inout) :: self
         !> Overlap matrix
         real(wp), contiguous, intent(in) :: smat(:, :)
         !> Hamiltonian matrix, can contains eigenvectors on output
         real(wp), contiguous, intent(inout) :: hmat(:, :, :)
         !> Eigenvalues
         real(wp), contiguous, intent(inout) :: eval(:, :)
         !> Occupation numbers
         real(wp), contiguous, intent(inout) :: focc(:, :)
         !> Density matrix
         real(wp), contiguous, intent(inout) :: density(:, :, :)
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine get_density

      subroutine delete(self)
         import :: solver_type
         !> Solver for the general eigenvalue problem
         class(solver_type), intent(inout) :: self
      end subroutine delete
   end interface

end module tblite_scf_solver

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module test_pairwise
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type
   use mstore, only : get_structure
   use dftd3
   implicit none
   private

   public :: collect_pairwise

   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

   type(realspace_cutoff), parameter :: cutoff = &
      & realspace_cutoff(cn=30_wp, disp2=60.0_wp, disp3=15.0_wp)


contains


!> Collect all exported unit tests
subroutine collect_pairwise(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("PBE-D3(BJ)", test_pbed3_bj_mb01), &
      & new_unittest("B97-D3(BJ)-ATM", test_b97d3_bj_atm_mb02), &
      & new_unittest("TPSS-D3(BJ)-ATM", test_tpssd3_bj_atm_ammonia), &
      & new_unittest("HF-D3(0)", test_hfd3_zero_mb03), &
      & new_unittest("HSE06-D3(0)-ATM", test_hse06d3_zero_atm_mb04), &
      & new_unittest("BLYP-D3(0)-ATM", test_blypd3_zero_atm_urea), &
      & new_unittest("B3LYP-D3M(0)", test_b3lypd3_mzero_mb05), &
      & new_unittest("PBE0-D3M(0)-ATM", test_pbe0d3_mzero_atm_mb06), &
      & new_unittest("BP86-D3M(0)-ATM", test_bpd3_mzero_atm_co2), &
      & new_unittest("PBE0-D3(op)", test_revtpssd3_op_mb07), &
      & new_unittest("PBE0-D3(op)-ATM", test_revpbed3_op_atm_mb08), &
      & new_unittest("PBE-D3(BJ)-ATM smooth cutoff", test_pbed3_bj_atm_smooth) &
      & ]

end subroutine collect_pairwise


subroutine test_dftd3_pairwise(error, mol, param, rcut)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Realspace cutoff
   type(realspace_cutoff), intent(in), optional :: rcut

   type(d3_model) :: d3
   type(realspace_cutoff) :: cutoff_
   real(wp) :: energy
   real(wp), allocatable :: energy2(:, :), energy3(:, :)

   allocate(energy2(mol%nat, mol%nat), energy3(mol%nat, mol%nat))
   call new_d3_model(d3, mol)
   cutoff_ = cutoff
   if (present(rcut)) cutoff_ = rcut
   call get_dispersion(mol, d3, param, cutoff_, energy)
   call get_pairwise_dispersion(mol, d3, param, cutoff_, energy2, energy3)

   call check(error, energy, sum(energy2) + sum(energy3), thr=thr)
   if (allocated(error)) then
      print*,energy, sum(energy2) + sum(energy3)
   end if

end subroutine test_dftd3_pairwise


subroutine test_pbed3_bj_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.4289_wp, s8 = 0.7875_wp, a2 = 4.4407_wp)

   call get_structure(mol, "MB16-43", "01")
   call test_dftd3_pairwise(error, mol, param)

end subroutine test_pbed3_bj_mb01


subroutine test_b97d3_bj_atm_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.5545_wp, s8 = 2.2609_wp, a2 = 3.2297_wp)

   call get_structure(mol, "MB16-43", "02")
   call test_dftd3_pairwise(error, mol, param)

end subroutine test_b97d3_bj_atm_mb02


subroutine test_pbed3_bj_atm_smooth(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.4289_wp, s8 = 0.7875_wp, a2 = 4.4407_wp)
   type(realspace_cutoff) :: smooth_cutoff = &
      & realspace_cutoff(cn=30_wp, disp2=8.0_wp, disp3=8.0_wp, width2=4.0_wp, width3=4.0_wp)

   call get_structure(mol, "MB16-43", "01")
   call test_dftd3_pairwise(error, mol, param, smooth_cutoff)

end subroutine test_pbed3_bj_atm_smooth


subroutine test_tpssd3_bj_atm_ammonia(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.4535_wp, s8 = 1.9435_wp, a2 = 4.4752_wp)

   call get_structure(mol, "X23", "ammonia")
   call test_dftd3_pairwise(error, mol, param)

end subroutine test_tpssd3_bj_atm_ammonia


subroutine test_hfd3_zero_mb03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param = zero_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, rs8 = 1.0_wp, alp = 14.0_wp, &
      & rs6 = 1.158_wp, s8 = 1.746_wp)

   call get_structure(mol, "MB16-43", "03")
   call test_dftd3_pairwise(error, mol, param)

end subroutine test_hfd3_zero_mb03


subroutine test_hse06d3_zero_atm_mb04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param = zero_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, rs8 = 1.0_wp, alp = 14.0_wp, &
      & rs6 = 1.129_wp, s8 = 0.109_wp)

   call get_structure(mol, "MB16-43", "04")
   call test_dftd3_pairwise(error, mol, param)

end subroutine test_hse06d3_zero_atm_mb04


subroutine test_blypd3_zero_atm_urea(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param = zero_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, rs8 = 1.0_wp, alp = 14.0_wp, &
      & rs6 = 1.094_wp, s8 = 1.682_wp)

   call get_structure(mol, "X23", "urea")
   call test_dftd3_pairwise(error, mol, param)

end subroutine test_blypd3_zero_atm_urea


subroutine test_b3lypd3_mzero_mb05(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(mzero_damping_param) :: param = mzero_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, rs8 = 1.0_wp, alp = 14.0_wp, &
      & rs6 = 1.338153_wp, s8 = 1.532981_wp, bet = 0.013988_wp)

   call get_structure(mol, "MB16-43", "05")
   call test_dftd3_pairwise(error, mol, param)

end subroutine test_b3lypd3_mzero_mb05


subroutine test_pbe0d3_mzero_atm_mb06(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(mzero_damping_param) :: param = mzero_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, rs8 = 1.0_wp, alp = 14.0_wp, &
      & rs6 = 2.077949_wp, s8 = 0.000081_wp, bet = 0.116755_wp)

   call get_structure(mol, "MB16-43", "06")
   call test_dftd3_pairwise(error, mol, param)

end subroutine test_pbe0d3_mzero_atm_mb06


subroutine test_bpd3_mzero_atm_co2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(mzero_damping_param) :: param = mzero_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, rs8 = 1.0_wp, alp = 14.0_wp, &
      & rs6 = 1.233460_wp, s8 = 1.945174_wp, bet = 0.000000_wp)

   call get_structure(mol, "X23", "CO2")
   call test_dftd3_pairwise(error, mol, param)

end subroutine test_bpd3_mzero_atm_co2


subroutine test_revtpssd3_op_mb07(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(optimizedpower_damping_param) :: param = optimizedpower_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & s8 = 0.27632_wp, a1 = 0.700_wp, a2 = 2.500_wp, bet = 8.0_wp)

   call get_structure(mol, "MB16-43", "07")
   call test_dftd3_pairwise(error, mol, param)

end subroutine test_revtpssd3_op_mb07


subroutine test_revpbed3_op_atm_mb08(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(optimizedpower_damping_param) :: param = optimizedpower_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & s8 = 1.44765_wp, a1 = 0.600_wp, a2 = 2.50_wp, bet = 0.0_wp)

   call get_structure(mol, "MB16-43", "08")
   call test_dftd3_pairwise(error, mol, param)

end subroutine test_revpbed3_op_atm_mb08


end module test_pairwise

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_xtb_param
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type, new
   use mstore, only : get_structure
   use tblite_context_type, only : context_type
   use tblite_param, only : param_record, charge_record, dispersion_record, element_record, &
      & halogen_record, hamiltonian_record, multipole_record, repulsion_record, &
      & thirdorder_record, param_mask, count, molmom_record
   use tblite_toml, only : toml_table
   use tblite_wavefunction_type, only : wavefunction_type, new_wavefunction
   use tblite_xtb_calculator, only : xtb_calculator, new_xtb_calculator
   use tblite_xtb_gfn2, only : export_gfn2_param, new_gfn2_calculator
   use tblite_xtb_gfn1, only : export_gfn1_param, new_gfn1_calculator
   use tblite_xtb_ipea1, only : export_ipea1_param, new_ipea1_calculator
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   implicit none
   private

   public :: collect_xtb_param

   real(wp), parameter :: acc = 1.0_wp
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp), parameter :: kt = 300.0_wp * 3.166808578545117e-06_wp

contains


!> Collect all exported unit tests
subroutine collect_xtb_param(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("param-empty", test_param_empty, should_fail=.true.), &
      new_unittest("param-minimal", test_param_minimal), &
      new_unittest("param-invalid", test_param_invalid, should_fail=.true.), &
      new_unittest("element-empty", test_element_empty, should_fail=.true.), &
      new_unittest("charge-empty", test_charge_empty, should_fail=.true.), &
      new_unittest("dispersion-empty", test_dispersion_empty, should_fail=.true.), &
      new_unittest("halogen-empty", test_halogen_empty, should_fail=.true.), &
      new_unittest("hamiltonian-empty", test_hamiltonian_empty, should_fail=.true.), &
      new_unittest("multipole-empty", test_multipole_empty, should_fail=.true.), &
      new_unittest("repulsion-empty", test_repulsion_empty, should_fail=.true.), &
      new_unittest("thirdorder-empty", test_thirdorder_empty), &
      new_unittest("mol-multipole-empty", test_mol_multipole_empty), &
      new_unittest("mask-a", test_mask_gfn2), &
      new_unittest("mask-b", test_mask_gfn1), &
      new_unittest("gfn2-xtb-a", test_gfn2_mb02), &
      new_unittest("gfn2-xtb-b", test_gfn2_mb05), &
      new_unittest("gfn2-xtb-c", test_gfn2_round_trip), &
      new_unittest("gfn1-xtb-a", test_gfn1_mb01), &
      new_unittest("gfn1-xtb-b", test_gfn1_mb04), &
      new_unittest("gfn1-xtb-c", test_gfn1_round_trip), &
      new_unittest("ipea1-xtb-a", test_ipea1_mb03), &
      new_unittest("ipea1-xtb-b", test_ipea1_mb06), &
      new_unittest("ipea1-xtb-c", test_ipea1_round_trip) &
      ]

end subroutine collect_xtb_param


subroutine test_param_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(param_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_param_empty


subroutine test_param_minimal(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: io
   type(param_record) :: param

   open(newunit=io, status="scratch")
   write(io, '(a)') &
      "[hamiltonian.xtb]", &
      "wexp = 5.0000000000000000E-01", &
      "kpol = 2.0000000000000000E+00", &
      "enscale = 2.0000000000000000E-02", &
      "cn = ""dexp""", &
      "shell = {ss=1.85, pp=2.23, dd=2.23, sd=2.00, pd=2.00}", &
      "[element.H]", &
      "shells = [ ""1s"" ]", &
      "levels = [ -1.0707210999999999E+01 ]", &
      "slater = [ 1.2300000000000000E+00 ]", &
      "ngauss = [ 3 ]", &
      "refocc = [ 1.0000000000000000E+00 ]", &
      "shpoly = [ -9.5361800000000000E-03 ]", &
      "kcn = [ -5.0000000000000003E-02 ]", &
      "gam = 4.0577099999999999E-01", &
      "lgam = [ 1.0000000000000000E+00 ]", &
      "gam3 = 8.0000000000000016E-02", &
      "zeff = 1.1053880000000000E+00", &
      "arep = 2.2137169999999999E+00", &
      "xbond = 0.0000000000000000E+00", &
      "dkernel = 5.5638889999999996E-02", &
      "qkernel = 2.7430999999999999E-04", &
      "mprad = 1.3999999999999999E+00", &
      "mpvcn = 1.0000000000000000E+00", &
      "[element.C]", &
      "shells = [ ""2s"", ""2p"" ]", &
      "levels = [ -1.3970922000000002E+01, -1.0063292000000001E+01 ]", &
      "slater = [ 2.0964320000000001E+00, 1.8000000000000000E+00 ]", &
      "ngauss = [ 4, 4 ]", &
      "refocc = [ 1.0000000000000000E+00, 3.0000000000000000E+00 ]", &
      "shpoly = [ -2.2943210000000002E-02, -2.7110200000000002E-03 ]", &
      "kcn = [ -1.0214400000000000E-02, 1.6165700000000002E-02 ]", &
      "gam = 5.3801500000000002E-01", &
      "lgam = [ 1.0000000000000000E+00, 1.1056357999999999E+00 ]", &
      "gam3 = 1.5000000000000002E-01", &
      "zeff = 4.2310780000000001E+00", &
      "arep = 1.2476550000000000E+00", &
      "xbond = 0.0000000000000000E+00", &
      "dkernel = -4.1167399999999998E-03", &
      "qkernel = 2.1358300000000000E-03", &
      "mprad = 3.0000000000000000E+00", &
      "mpvcn = 3.0000000000000000E+00", &
      ""
   rewind io

   call param%load(io, error)
   close(io)
end subroutine test_param_minimal


subroutine test_param_invalid(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: io
   type(param_record) :: param

   open(newunit=io, status="scratch")
   write(io, '(a)') &
      "[hamiltonian.xtb]", &
      "wexp = 5.0000000000000000E-01", &
      "kpol = 2.0000000000000000E+00", &
      "enscale = 2.0000000000000000E-02", &
      "cn = ""dexp""", &
      "shell = {ss=1.85, pp=2.23, dd=2.23, sd=2.00, pd=2.00"
   rewind io

   call param%load(io, error)
   close(io)
end subroutine test_param_invalid


subroutine test_element_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(element_record) :: param

   table = toml_table()
   table%key = "Te"
   call param%load(table, error)
end subroutine test_element_empty

subroutine test_mol_multipole_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(molmom_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_mol_multipole_empty

subroutine test_charge_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(charge_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_charge_empty


subroutine test_dispersion_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(dispersion_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_dispersion_empty


subroutine test_halogen_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(halogen_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_halogen_empty


subroutine test_hamiltonian_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(hamiltonian_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_hamiltonian_empty


subroutine test_multipole_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(multipole_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_multipole_empty


subroutine test_repulsion_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(repulsion_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_repulsion_empty


subroutine test_thirdorder_empty(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(thirdorder_record) :: param

   table = toml_table()
   call param%load(table, error)
end subroutine test_thirdorder_empty


subroutine test_mask_gfn2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(param_record), target :: param, base
   type(param_mask) :: mask1, mask2
   real(wp), allocatable :: array(:)
   type(toml_table) :: table
   integer :: io

   call export_gen_param("gfn2", base)

   mask1%ref => base%record
   open(newunit=io, status="scratch")
   write(io, '(a)') &
      "hamiltonian = {}", &
      "dispersion = {}", &
      "repulsion = {}", &
      "charge = {}", &
      "thirdorder = {}", &
      "multipole = {}", &
      "[element]", &
      "H = {slater=[false]}", &
      "C = {}", &
      ""
   rewind io

   call mask1%load(io, error)
   close(io)
   if (allocated(error)) return

   call check(error, count(mask1), 26)
   if (allocated(error)) return

   table = toml_table()
   call mask1%dump(table, error)
   if (allocated(error)) return

   mask2%ref => base%record
   call mask2%load(table, error)
   if (allocated(error)) return

   call check(error, count(mask2), 26)
   if (allocated(error)) return

   allocate(array(count(mask2)))
   call base%dump(array, mask2, error)
   if (allocated(error)) return

   call param%load(array, base, mask2, error)
   if (allocated(error)) return

end subroutine test_mask_gfn2


subroutine test_mask_gfn1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(param_record), target :: param, base
   type(param_mask) :: mask
   real(wp), allocatable :: array(:)
   integer :: io

   call export_gen_param("gfn1", base)

   mask%ref => base%record
   open(newunit=io, status="scratch")
   write(io, '(a)') &
      "hamiltonian = {}", &
      "dispersion = {}", &
      "repulsion = {}", &
      "charge = {}", &
      "thirdorder = {}", &
      "halogen = {}", &
      "[element]", &
      "H = {slater=[false, true], gam3=false}", &
      "C = {}", &
      ""
   rewind io

   call mask%load(io, error)
   close(io)
   if (allocated(error)) return

   call check(error, count(mask), 28)
   if (allocated(error)) return

   allocate(array(count(mask)))
   call base%dump(array, mask, error)
   if (allocated(error)) return

   call param%load(array, base, mask, error)
   if (allocated(error)) return

end subroutine test_mask_gfn1


subroutine export_gen_param(method, param)
   character(len=*), intent(in) :: method
   type(param_record), intent(out) :: param
   select case(method)
   case("gfn1")
      call export_gfn1_param(param)
   case("gfn2")
      call export_gfn2_param(param)
   case("ipea1")
      call export_ipea1_param(param)
   end select
end subroutine export_gen_param


subroutine new_gen_calculator(calc, method, mol, error)
   type(xtb_calculator), intent(out) :: calc
   character(len=*), intent(in) :: method
   type(structure_type), intent(in) :: mol
   type(error_type), allocatable, intent(out) :: error
   select case(method)
   case("gfn1")
      call new_gfn1_calculator(calc, mol, error)
   case("gfn2")
      call new_gfn2_calculator(calc, mol, error)
   case("ipea1")
      call new_ipea1_calculator(calc, mol, error)
   end select
end subroutine new_gen_calculator


subroutine test_gen(mol, method, error)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Method name
   character(len=*), intent(in) :: method
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(xtb_calculator) :: calc
   type(param_record) :: param
   type(wavefunction_type) :: wfn
   real(wp) :: energy1, energy2

   call export_gen_param(method, param)
   call new_xtb_calculator(calc, mol, param, error)
   if (allocated(error)) return

   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy1, verbosity=0)

   call new_gen_calculator(calc, method, mol, error)
   if (allocated(error)) return

   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy2, verbosity=0)

   call check(error, energy2, energy1, thr=thr)

end subroutine test_gen


subroutine test_round_trip(mol, method, error)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Method name
   character(len=*), intent(in) :: method
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(xtb_calculator) :: calc
   type(param_record) :: param1, param2
   type(wavefunction_type) :: wfn
   real(wp) :: energy1, energy2
   character(len=:), allocatable :: io

   call export_gen_param(method, param1)

   io = "." // method // "-" // get_name() // ".toml"
   call param1%dump(io, error)
   if (.not.allocated(error)) then
      call param2%load(io, error)
   end if
   call delete_file(io)
   if (allocated(error)) return

   call new_xtb_calculator(calc, mol, param1, error)
   if (allocated(error)) return

   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy1, verbosity=0)

   call new_xtb_calculator(calc, mol, param2, error)
   if (allocated(error)) return

   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy2, verbosity=0)

   call check(error, energy2, energy1, thr=thr)

end subroutine test_round_trip


subroutine test_gfn1_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "01")
   call test_gen(mol, "gfn1", error)

end subroutine test_gfn1_mb01


subroutine test_gfn2_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "02")
   call test_gen(mol, "gfn2", error)

end subroutine test_gfn2_mb02


subroutine test_ipea1_mb03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "03")
   call test_gen(mol, "ipea1", error)

end subroutine test_ipea1_mb03


subroutine test_gfn1_mb04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "04")
   call test_gen(mol, "gfn1", error)

end subroutine test_gfn1_mb04


subroutine test_gfn2_mb05(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "05")
   call test_gen(mol, "gfn2", error)

end subroutine test_gfn2_mb05


subroutine test_ipea1_mb06(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "06")
   call test_gen(mol, "ipea1", error)

end subroutine test_ipea1_mb06


subroutine test_gfn2_round_trip(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "07")
   call test_round_trip(mol, "gfn2", error)

end subroutine test_gfn2_round_trip


subroutine test_gfn1_round_trip(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "08")
   call test_round_trip(mol, "gfn1", error)

end subroutine test_gfn1_round_trip


subroutine test_ipea1_round_trip(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "09")
   call test_round_trip(mol, "ipea1", error)

end subroutine test_ipea1_round_trip


function get_name() result(name)
   character(len=20) :: name
   real :: val

   call random_number(val)
   write(name, '(a, z8.8)') "tblite-test-", int(val*1.0e9)
end function get_name


subroutine delete_file(file)
   character(len=*), intent(in) :: file
   integer :: unit
   logical :: exist
   inquire(file=file, exist=exist)
   if (exist) then
      open(newunit=unit, file=file)
      close(unit, status="delete")
   end if
end subroutine delete_file


end module test_xtb_param

! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/post-processing/xtb-ml/orbital_energy.f90
!> Orbital energy based xtbml features
module tblite_post_processing_xtbml_orbital
   use mctc_env, only : wp, error_type
   use mctc_io, only : structure_type
   use mctc_io_convert, only : evtoau, autoev
   use tblite_basis_type, only : basis_type
   use tblite_blas, only : symm, gemm, dot
   use tblite_container_list, only : cache_list
   use tblite_double_dictionary, only : double_dictionary_type
   use tblite_integral_type, only : integral_type
   use tblite_post_processing_xtbml_cache, only : xtbml_cache
   use tblite_post_processing_xtbml_convolution, only : xtbml_convolution
   use tblite_post_processing_xtbml_features, only : xtbml_feature_type
   use tblite_output_format, only : format_string
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_xtb_calculator, only : xtb_calculator
   implicit none
   private

   public :: new_xtbml_orbital_features, xtbml_orbital_features

   !> Orbital energy-based xTB-ML features
   type, extends(xtbml_feature_type) :: xtbml_orbital_features

   contains
      !> Compute xTB-ML density-based features
      procedure :: compute_features
      !> Compute extended xTB-ML density-based features with convolution
      procedure :: compute_extended
   end type xtbml_orbital_features

   character(len=*), parameter :: label = "orbital energy-based features"

   !> Occupation cutoff for fractional occupations
   real(wp), parameter :: occ_cutoff = 1.0e-4_wp

   !> Threshold for missing occupied/virtual atomic population
   real(wp), parameter :: population_cutoff = 1.0e-12_wp

   !> Damping for the resonse function in Hartree
   real(wp), parameter :: damp = 0.5_wp * evtoau

   !> Effective infinite frontier energy
   real(wp), parameter :: near_infty = 1.0e100_wp

   !> Regularizer for divisions by response-like quantities
   real(wp), parameter :: regularizer = 1.0e-14_wp

contains


subroutine new_xtbml_orbital_features(self)
   !> Instance of the xTB-ML orbital energy features
   class(xtbml_orbital_features) :: self

   self%label = label

end subroutine new_xtbml_orbital_features


subroutine compute_features(self, mol, wfn, ints, calc, caches, mlcache, &
   & dict, n_features, error)
   !> Instance of the xTB-ML orbital energy features
   class(xtbml_orbital_features), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction strcuture data
   type(wavefunction_type), intent(in) :: wfn
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Single-point calculator
   type(xtb_calculator), intent(in) :: calc
   !> Cache list for storing caches of various interactions
   type(cache_list), intent(inout) :: caches
   !> Cache for xTB-ML features
   type(xtbml_cache), intent(inout) :: mlcache
   !> Dictionary for storing results
   type(double_dictionary_type), intent(inout) :: dict
   !> Number of features
   integer, intent(inout) :: n_features
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: nspin, spin
   character(len=6), allocatable :: spin_label(:)
   real(wp), allocatable :: response(:), ehoao(:), eluao(:)

   ! Two spin channels for unrestricted or restricted open-shell calculations
   if (wfn%nuhf > 0 .or. wfn%nspin > 1) then
      nspin = 2
   else
      nspin = 1
   end if

   ! Select the spin label
   if (nspin > 1) then
      spin_label = [character(len=6) :: "_alpha", "_beta"]
   else
      spin_label = [""]
   end if

   allocate(response(mol%nat), ehoao(mol%nat), eluao(mol%nat))
   if (.not. allocated(mlcache%egap)) allocate(mlcache%egap(mol%nat, nspin))
   if (.not. allocated(mlcache%chempot)) allocate(mlcache%chempot(mol%nat, nspin))

   do spin = 1, nspin
      ! Compute atomic response, effective HOMO-LUMO gap, chemical potential, HOAO and LUAO
      call atomic_frontier_orbitals(spin, mol, calc%bas, wfn, ints%overlap, &
         & response, mlcache%egap(:, spin), mlcache%chempot(:, spin), ehoao, eluao)

      ! Store features in the dictionary
      call dict%add_entry(trim("response"//spin_label(spin)), response * evtoau**2)
      call dict%add_entry(trim("gap"//spin_label(spin)), mlcache%egap(:, spin) * autoev)
      call dict%add_entry(trim("chem_pot"//spin_label(spin)), mlcache%chempot(:, spin) * autoev)
      call dict%add_entry(trim("HOAO"//spin_label(spin)), ehoao * autoev)
      call dict%add_entry(trim("LUAO"//spin_label(spin)), eluao * autoev)

      ! Count number of features
      n_features = n_features + 5
   end do

end subroutine compute_features


subroutine compute_extended(self, mol, wfn, ints, calc, caches, mlcache, &
   & convolution, dict, n_features, error)
   !> Instance of the xTB-ML orbital energy features
   class(xtbml_orbital_features), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction strcuture data
   type(wavefunction_type), intent(in) :: wfn
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Single-point calculator
   type(xtb_calculator), intent(in) :: calc
   !> Cache list for storing caches of various interactions
   type(cache_list), intent(inout) :: caches
   !> Cache for xTB-ML features
   type(xtbml_cache), intent(inout) :: mlcache
   !> Convolution container
   type(xtbml_convolution), intent(in) :: convolution
   !> Dictionary for storing results
   type(double_dictionary_type), intent(inout) :: dict
   !> Number of features
   integer, intent(inout) :: n_features
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: isc, nspin, spin
   character(len=:), allocatable :: a_label, conv_label, spin_label(:)
   real(wp), allocatable :: ext_chempot(:, :), ext_egap(:, :)
   real(wp), allocatable :: ext_ehoao(:, :), ext_eluao(:, :)

   nspin = size(mlcache%chempot, dim=2)

   ! Select the spin label
   if (nspin > 1) then
      spin_label = [character(len=6) :: "_alpha", "_beta"]
   else
      spin_label = [""]
   end if

   allocate(ext_chempot(mol%nat, convolution%nscale))
   allocate(ext_egap(mol%nat, convolution%nscale))
   allocate(ext_ehoao(mol%nat, convolution%nscale))
   allocate(ext_eluao(mol%nat, convolution%nscale))

   do spin = 1, nspin

      ! Compute convolution of the effective Fermi level per atom
      call convolve_scalar(mol, mlcache%chempot(:, spin), convolution%nscale, &
         & mlcache%conv_kernel, mlcache%conv_cn, ext_chempot)

      ! Compute convolution of the effective atomic HOMO-LUMO gap
      call convolve_scalar(mol, mlcache%egap(:, spin), convolution%nscale, &
         & mlcache%conv_kernel, mlcache%conv_cn, ext_egap)

      ! Compute the highest occupied atomic orbital based on the extended features
      call get_ehoao_ext(ext_chempot, ext_egap, ext_ehoao)

      ! Compute the lowest unoccupied atomic orbital based on the extended features
      call get_eluao_ext(ext_chempot, ext_egap, ext_eluao)

      do isc = 1, convolution%nscale
         a_label = "_"//trim(adjustl(format_string(convolution%rcov_scale(isc), '(f12.2)')))
         if (a_label .eq. "_1.00") a_label = ""
         conv_label = trim(spin_label(spin))//a_label

         ! Add convoluted features to the dictionary
         call dict%add_entry(trim("ext_gap"//conv_label), ext_egap(:, isc) * autoev)
         call dict%add_entry(trim("ext_chem_pot"//conv_label), ext_chempot(:, isc) * autoev)
         call dict%add_entry(trim("ext_HOAO"//conv_label), ext_ehoao(:, isc) * autoev)
         call dict%add_entry(trim("ext_LUAO"//conv_label), ext_eluao(:, isc) * autoev)

         ! Count number of features
         n_features = n_features + 4
      end do
   end do

end subroutine compute_extended


!> Compute atomic response, effective H-L gap, chemical potential, HOAO and LUAO
subroutine atomic_frontier_orbitals(spin, mol, bas, wfn, overlap, &
   & response, egap, chempot, ehoao, eluao)
   !> Spin channel
   integer, intent(in) :: spin
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Overlap integral matrix
   real(wp), intent(in) :: overlap(:,:)
   !> Atomic response
   real(wp), intent(out) :: response(:)
   !> Effective atomic H-L gap
   real(wp), intent(out) :: egap(:)
   !> Effective atomic chemical potential
   real(wp), intent(out) :: chempot(:)
   !> Highest occupied atomic orbital
   real(wp), intent(out) :: ehoao(:)
   !> Lowest unoccupied atomic orbital
   real(wp), intent(out) :: eluao(:)

   integer :: ispin, nocc, nvirt
   integer, allocatable :: iocc(:), ivirt(:)
   real(wp), allocatable :: po(:, :), pv(:, :)
   real(wp), allocatable :: po_sum(:), pv_sum(:)

   ! Select spin channel for the coefficients
   if (wfn%nspin > 1) then
      ispin = spin
   else
      ispin = 1
   end if

   ! Select occupied and virtual orbitals based on the occupation numbers
   call get_occ_virt_orbitals(wfn%focc(:, spin), iocc, ivirt)
   nocc = size(iocc)
   nvirt = size(ivirt)

   ! Project occupied and virtual MO populations onto atoms
   allocate(po(nocc, mol%nat), pv(nvirt, mol%nat))
   allocate(po_sum(mol%nat), pv_sum(mol%nat))
   call atomic_mo_projection(bas, iocc, ivirt, wfn%focc(:, spin), &
      & wfn%coeff(:, :, ispin), overlap, po, pv, po_sum, pv_sum)

   ! Accumulate response, chemical potential, inverse-gap, and HOAO/LUAO
   call accumulate_properties(nocc, nvirt, iocc, ivirt, po, pv, po_sum, pv_sum, &
      & wfn%emo(:, ispin), response, egap, chempot, ehoao, eluao)

end subroutine atomic_frontier_orbitals


!> Collect occupied and virtual orbital indices
subroutine get_occ_virt_orbitals(focc, iocc, ivirt)

   !> Occupation numbers
   real(wp), intent(in) :: focc(:)
   !> Active occupied orbitals
   integer, allocatable, intent(out) :: iocc(:)
   !> Active virtual orbitals
   integer, allocatable, intent(out) :: ivirt(:)

   integer :: imo, io, iv

   allocate(iocc(count(focc > occ_cutoff)))
   allocate(ivirt(count(1.0_wp - focc > occ_cutoff)))

   io = 0
   iv = 0
   do imo = 1, size(focc)
      if (focc(imo) > occ_cutoff) then
         io = io + 1
         iocc(io) = imo
      end if

      if (1.0_wp - focc(imo) > occ_cutoff) then
         iv = iv + 1
         ivirt(iv) = imo
      end if
   end do

end subroutine get_occ_virt_orbitals


!> Project occupied and virtual MO populations onto atoms
subroutine atomic_mo_projection(bas, iocc, ivirt, focc, coeff, overlap, po, pv, &
   & po_sum, pv_sum)
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Indices of occupied orbitals
   integer, intent(in) :: iocc(:)
   !> Indices of virtual orbitals
   integer, intent(in) :: ivirt(:)
   !> MO occupation numbers
   real(wp), intent(in) :: focc(:)
   !> MO coefficients
   real(wp), contiguous, intent(in) :: coeff(:, :)
   !> Overlap matrix
   real(wp), contiguous, intent(in) :: overlap(:, :)
   !> Occupied atom-resolved MO population
   real(wp), intent(out) :: po(:, :)
   !> Virtual atom-resolved MO population
   real(wp), intent(out) :: pv(:, :)
   !> Total occupied population per atom
   real(wp), intent(out) :: po_sum(:)
   !> Total virtual population per atom
   real(wp), intent(out) :: pv_sum(:)

   integer :: io, iv, imo, iao, iat
   real(wp) :: ps
   real(wp), allocatable :: scoeff(:, :)

   po(:, :) = 0.0_wp
   pv(:, :) = 0.0_wp

   ! Precompute overlap and coefficient contraction for all molecular orbitals
   allocate(scoeff(bas%nao, bas%nao))
   call symm(overlap, coeff, scoeff)

   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(bas, iocc, focc, coeff, scoeff, po) &
   !$omp private(io, imo, iao, iat, ps)
   do io = 1, size(iocc)
      imo = iocc(io)
      do iao = 1, bas%nao
         iat = bas%ao2at(iao)
         ps = coeff(iao, imo) * scoeff(iao, imo)
         po(io, iat) = po(io, iat) + focc(imo) * ps
      end do
   end do

   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(bas, ivirt, focc, coeff, scoeff, pv) &
   !$omp private(iv, imo, iao, iat, ps)
   do iv = 1, size(ivirt)
      imo = ivirt(iv)
      do iao = 1, bas%nao
         iat = bas%ao2at(iao)
         ps = coeff(iao, imo) * scoeff(iao, imo)
         pv(iv, iat) = pv(iv, iat) + (1.0_wp - focc(imo)) * ps
      end do
   end do

   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(po, pv, po_sum, pv_sum) private(iat)
   do iat = 1, size(po_sum)
      po_sum(iat) = sum(po(:, iat))
      pv_sum(iat) = sum(pv(:, iat))
   end do

end subroutine atomic_mo_projection


!> Compute response, effective H-L gap, chemical potential, HOAO and LUAO
subroutine accumulate_properties(nocc, nvirt, iocc, ivirt, po, pv, &
      & po_sum, pv_sum, eps, response, egap, chempot, ehoao, eluao)
   !> Number of occupied orbitals
   integer, intent(in) :: nocc
   !> Number of virtual orbitals
   integer, intent(in) :: nvirt
   !> Indices of occupied orbitals
   integer, intent(in) :: iocc(:)
   !> Indices of virtual orbitals
   integer, intent(in) :: ivirt(:)
   !> Occupied atom-resolved MO population
   real(wp), intent(in) :: po(:, :)
   !> Virtual atom-resolved MO population
   real(wp), intent(in) :: pv(:, :)
   !> Total occupied population per atom
   real(wp), intent(in) :: po_sum(:)
   !> Total virtual population per atom
   real(wp), intent(in) :: pv_sum(:)
   !> MO energies
   real(wp), intent(in) :: eps(:)
   !> Atomic response
   real(wp), intent(out) :: response(:)
   !> Effective atomic HOMO-LUMO gap
   real(wp), intent(out) :: egap(:)
   !> Effective atomic chemical potential
   real(wp), intent(out) :: chempot(:)
   !> Highest occupied atomic orbital
   real(wp), intent(out) :: ehoao(:)
   !> Lowest unoccupied atomic orbital
   real(wp), intent(out) :: eluao(:)

   integer :: io, iv, iocc_mo, ivirt_mo, iat, nat
   real(wp) :: delta_eps, sum_eps, tmp
   real(wp), allocatable :: response_kernel(:, :), response_weight(:, :) 
   real(wp), allocatable :: chempot_kernel(:, :), chempot_weight(:, :)
   real(wp), allocatable :: gap_kernel(:, :), gap_weight(:, :)

   response(:) = 0.0_wp
   egap(:) = 0.0_wp
   chempot(:) = 0.0_wp
   ehoao(:) = 0.0_wp
   eluao(:) = 0.0_wp

   nat = size(response)

   ! Generate intermediates if both occupied and virtual populations are present
   if (nocc > 0 .and. nvirt > 0) then
      allocate(response_kernel(nocc, nvirt), response_weight(nocc, nat))
      allocate(chempot_kernel(nocc, nvirt), chempot_weight(nocc, nat))
      allocate(gap_kernel(nocc, nvirt), gap_weight(nocc, nat))

      !$omp parallel do default(none) collapse(2) schedule(runtime) &
      !$omp shared(nocc, nvirt, eps, iocc, ivirt, response_kernel) &
      !$omp shared(chempot_kernel, gap_kernel) &
      !$omp private(io, iv, ivirt_mo, iocc_mo, delta_eps, sum_eps, tmp)
      do iv = 1, nvirt
         do io = 1, nocc
            ivirt_mo = ivirt(iv)
            iocc_mo = iocc(io)

            delta_eps = eps(ivirt_mo) - eps(iocc_mo)
            sum_eps = eps(ivirt_mo) + eps(iocc_mo)

            tmp = 1.0_wp / (delta_eps**2 + damp**2)

            ! Construct kernels for response, chemical potential and gap
            response_kernel(io, iv) = tmp
            chempot_kernel(io, iv) = 0.5_wp * sum_eps * tmp
            gap_kernel(io, iv) = tmp / (delta_eps + damp)
         end do
      end do

      ! Contract virtual populations with the kernels
      call gemm(response_kernel, pv, response_weight)
      call gemm(chempot_kernel, pv, chempot_weight)
      call gemm(gap_kernel, pv, gap_weight)
   end if

   ! Contract with occupied populations and finalize atom-wise features.
   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(nat, nocc, nvirt, iocc, ivirt, eps, po, pv, po_sum, pv_sum) &
   !$omp shared(response_weight, chempot_weight, gap_weight) &
   !$omp shared(response, chempot, egap, ehoao, eluao) &
   !$omp private(iat, io, iv, iocc_mo, ivirt_mo, tmp)
   do iat = 1, nat

      if (po_sum(iat) < population_cutoff) then
         ! No occupied population on this atom
         egap(iat) = 0.0_wp
         chempot(iat) = 0.0_wp

         ! Calculate intermediates only based on virtual orbitals
         do iv = 1, nvirt
            ivirt_mo = ivirt(iv)
            tmp = pv(iv, iat) / (eps(ivirt_mo)**2 + damp**2)

            chempot(iat) = chempot(iat) + eps(ivirt_mo) * tmp
            egap(iat) = egap(iat) + tmp / (eps(ivirt_mo) + near_infty + damp)
         end do

         ! Normalize gap with response and invert after regularization
         egap(iat) = 1.0_wp / (egap(iat) + regularizer) - damp

         ! Finite LUAO set to the chemical potential
         eluao(iat) = chempot(iat)
         ehoao(iat) = chempot(iat) - egap(iat)

      else if (pv_sum(iat) < population_cutoff) then
         ! No virtual population on this atom
         egap(iat) = 0.0_wp
         chempot(iat) = 0.0_wp

         ! Calculate intermediates only based on occupied orbitals
         do io = 1, nocc
            iocc_mo = iocc(io)
            tmp = po(io, iat) / (eps(iocc_mo)**2 + damp**2)

            chempot(iat) = chempot(iat) + eps(iocc_mo) * tmp
            egap(iat) = egap(iat) + tmp / (near_infty - eps(iocc_mo) + damp)
         end do

         ! Normalize gap with response and invert after regularization
         egap(iat) = 1.0_wp / (egap(iat) + regularizer) - damp

         ! Finite HOAO set to the chemical potential
         ehoao(iat) = chempot(iat)
         eluao(iat) = chempot(iat) + egap(iat)

      else
         ! Contract kernel weight with occupied populations
         response(iat) = dot(po(:, iat), response_weight(:, iat))
         chempot(iat) = dot(po(:, iat), chempot_weight(:, iat))
         egap(iat) = dot(po(:, iat), gap_weight(:, iat))
      
         ! Normalize gap with response and invert after regularization
         egap(iat) = egap(iat) / (response(iat) + regularizer)
         egap(iat) = 1.0_wp / (egap(iat) + regularizer) - damp

         ! Normalize chemical potential with response
         chempot(iat) = chempot(iat) / (response(iat) + regularizer)

         ! Compute HOAO and LUAO
         ehoao(iat) = chempot(iat) - 0.5_wp * egap(iat)
         eluao(iat) = chempot(iat) + 0.5_wp * egap(iat)
      end if
   end do

end subroutine accumulate_properties


!> Convolution for scalar atom-resolved properties
!> with rescaling based on the target coordination number
subroutine convolve_scalar(mol, atom_prop, nscale, kernel, cn, ext_prop)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Atom-resolved property data
   real(wp), intent(in) :: atom_prop(:)
   !> Number of convolution length scales
   integer, intent(in) :: nscale
   !> Convolution kernel
   real(wp), intent(in) :: kernel(:, :, :)
   !> Convolution coordination number
   real(wp), intent(in) :: cn(:, :)
   !> Convolved atom-resolved property data
   real(wp), intent(out) :: ext_prop(:, :)

   integer :: iat, jat, ksc
   real(wp) :: tmp

   ext_prop(:, :) = 0.0_wp

   !$omp parallel do default(none) collapse(2) schedule(runtime) &
   !$omp shared(mol, atom_prop, nscale, kernel, cn, ext_prop) &
   !$omp private(iat, jat, ksc, tmp)
   do ksc = 1, nscale
      do iat = 1, mol%nat
         tmp = 0.0_wp
         do jat = 1, mol%nat
            ! Convolution with rescaling based on target coordination number
            tmp = tmp + atom_prop(jat) / kernel(iat, jat, ksc)
         end do
         ext_prop(iat, ksc) = tmp / (cn(iat, ksc) + 1.0_wp)
      end do
   end do

end subroutine convolve_scalar


!> Compute the extended highest occupied atomic orbital
subroutine get_ehoao_ext(ext_chempot, ext_egap, ext_ehoao)
   !> Extended chemical potential
   real(wp), intent(in) :: ext_chempot(:, :)
   !> Extended gap 
   real(wp), intent(in) :: ext_egap(:, :)
   !> Extended highest occupied atomic orbital
   real(wp), intent(out) :: ext_ehoao(:, :)

   integer :: iat, ksc

   !$omp parallel do default(none) collapse(2) schedule(runtime) &
   !$omp shared(ext_chempot, ext_egap, ext_ehoao) &
   !$omp private(iat, ksc)
   do ksc = 1, size(ext_chempot, 2)
      do iat = 1, size(ext_chempot, 1)
         ext_ehoao(iat, ksc) = ext_chempot(iat, ksc) - ext_egap(iat, ksc) / 2.0_wp
      end do
   end do

end subroutine get_ehoao_ext


!> Compute the extended lowest unoccupied atomic orbital
subroutine get_eluao_ext(ext_chempot, ext_egap, ext_eluao)
   !> Extended chemical potential
   real(wp), intent(in) :: ext_chempot(:, :)
   !> Extended gap 
   real(wp), intent(in) :: ext_egap(:, :)
   !> Extended lowest unoccupied atomic orbital
   real(wp), intent(out) :: ext_eluao(:, :)

   integer :: iat, ksc

   !$omp parallel do default(none) collapse(2) schedule(runtime) &
   !$omp shared(ext_chempot, ext_egap, ext_eluao) &
   !$omp private(iat, ksc)
   do ksc = 1, size(ext_chempot, 2)
      do iat = 1, size(ext_chempot, 1)
         ext_eluao(iat, ksc) = ext_chempot(iat, ksc) + ext_egap(iat, ksc) / 2.0_wp
      end do
   end do

end subroutine get_eluao_ext

end module tblite_post_processing_xtbml_orbital

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

#ifndef TBLITE_HAS_HDF5
#define TBLITE_HAS_HDF5 0
#endif

!> @file tblite/io/hdf5.f90
!> Provides HDF5 input and output routines

!> Implementation of HDF5 input and output routines
module tblite_io_hdf5
   use mctc_env, only : dp, i4
#if TBLITE_HAS_HDF5
   use hdf5, only : hid_t, hsize_t, h5open_f, h5close_f, h5fopen_f, h5fcreate_f, &
      & h5fclose_f, h5dopen_f, h5dcreate_f, h5dclose_f, h5dread_f, h5dwrite_f, &
      & h5dget_space_f, h5screate_simple_f, h5sclose_f, h5sget_simple_extent_ndims_f, &
      & h5sget_simple_extent_dims_f, h5lexists_f, h5ldelete_f, h5gn_members_f, &
      & h5gget_obj_info_idx_f, H5F_ACC_RDONLY_F, H5F_ACC_RDWR_F, H5F_ACC_TRUNC_F, &
      & H5P_DEFAULT_F, H5T_NATIVE_DOUBLE, H5T_NATIVE_INTEGER, H5G_DATASET_F
#endif
   implicit none
   private

   public :: get_hdf5_descriptor, list_hdf5_datasets, load_hdf5, save_hdf5

   !> Interface for loading hdf5 files
   interface load_hdf5
      module procedure load_hdf5_i4_r1
      module procedure load_hdf5_rdp_r1
      module procedure load_hdf5_rdp_r2
      module procedure load_hdf5_rdp_r3
   end interface load_hdf5

   !> Interface for saving hdf5 files
   interface save_hdf5
      module procedure save_hdf5_i4_r1
      module procedure save_hdf5_rdp_r1
      module procedure save_hdf5_rdp_r2
      module procedure save_hdf5_rdp_r3
   end interface save_hdf5

   character(len=*), parameter :: nl = new_line('a')

contains

subroutine get_hdf5_descriptor(filename, varname, vshape, iostat, iomsg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to inspect
   character(len=*), intent(in) :: varname
   !> Shape of the HDF5 dataset
   integer, allocatable, intent(out) :: vshape(:)
   !> Status of the read operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
#if TBLITE_HAS_HDF5
   integer :: rank
   integer(hsize_t), allocatable :: dims(:), maxdims(:)
   integer(hid_t) :: file_id, dset_id, space_id

   file_id = -1_hid_t
   dset_id = -1_hid_t
   space_id = -1_hid_t
   call hdf5_open(stat, msg)
   if (stat == 0) call open_file_read(filename, file_id, stat, msg)
   if (stat == 0) call h5dopen_f(file_id, varname, dset_id, stat)
   if (stat /= 0 .and. .not.allocated(msg)) msg = "Dataset '"//filename//"::"//varname//"' not found"
   if (stat == 0) call h5dget_space_f(dset_id, space_id, stat)
   if (stat == 0) call h5sget_simple_extent_ndims_f(space_id, rank, stat)
   if (stat == 0) then
      allocate(dims(rank), maxdims(rank))
      call h5sget_simple_extent_dims_f(space_id, dims, maxdims, stat)
      if (stat >= 0) stat = 0
   end if
   if (stat == 0) vshape = int(dims)
   call close_space(space_id)
   call close_dataset(dset_id)
   call close_file(file_id)
   call hdf5_close()
#else
   stat = -1
   msg = "HDF5 support is not available in this build of tblite."
#endif
   call handle_iostat(stat, msg, filename//"::"//varname, iostat, iomsg, "read")
end subroutine get_hdf5_descriptor

subroutine list_hdf5_datasets(filename, paths, iostat, iomsg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Names of root-level datasets in the file
   character(len=:), allocatable, intent(out) :: paths(:)
   !> Status of the read operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
#if TBLITE_HAS_HDF5
   integer :: irec, nrec, obj_type, nset
   integer(hid_t) :: file_id
   character(len=256), allocatable :: buffer(:)

   file_id = -1_hid_t
   call hdf5_open(stat, msg)
   if (stat == 0) call open_file_read(filename, file_id, stat, msg)
   if (stat == 0) call h5gn_members_f(file_id, "/", nrec, stat)
   if (stat == 0) then
      allocate(buffer(nrec))
      nset = 0
      do irec = 0, nrec - 1
         call h5gget_obj_info_idx_f(file_id, "/", irec, buffer(irec + 1), obj_type, stat)
         if (stat /= 0) exit
         if (obj_type == H5G_DATASET_F) nset = nset + 1
      end do
   end if
   if (stat == 0) then
      allocate(character(len=256) :: paths(nset))
      nset = 0
      do irec = 0, nrec - 1
         call h5gget_obj_info_idx_f(file_id, "/", irec, buffer(irec + 1), obj_type, stat)
         if (stat /= 0) exit
         if (obj_type == H5G_DATASET_F) then
            nset = nset + 1
            paths(nset) = trim(buffer(irec + 1))
         end if
      end do
   end if
   call close_file(file_id)
   call hdf5_close()
#else
   stat = -1
   msg = "HDF5 support is not available in this build of tblite."
#endif
   call handle_iostat(stat, msg, filename, iostat, iomsg, "read")
end subroutine list_hdf5_datasets

subroutine load_hdf5_i4_r1(filename, varname, array, iostat, iomsg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to load
   character(len=*), intent(in) :: varname
   !> Array to load the data into
   integer(i4), allocatable, intent(out) :: array(:)
   !> Status of the read operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
#if TBLITE_HAS_HDF5
   integer(hsize_t) :: dims(1)
   call read_shape(filename, varname, dims, stat, msg)
   if (stat == 0) allocate(array(dims(1)), stat=stat)
   if (stat == 0) call read_i4_r1(filename, varname, array, dims, stat, msg)
#else
   stat = -1
   msg = "HDF5 support is not available in this build of tblite."
#endif
   call handle_iostat(stat, msg, filename//"::"//varname, iostat, iomsg, "read")
end subroutine load_hdf5_i4_r1

subroutine load_hdf5_rdp_r1(filename, varname, array, iostat, iomsg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to load
   character(len=*), intent(in) :: varname
   !> Array to load the data into
   real(dp), allocatable, intent(out) :: array(:)
   !> Status of the read operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
#if TBLITE_HAS_HDF5
   integer(hsize_t) :: dims(1)
   call read_shape(filename, varname, dims, stat, msg)
   if (stat == 0) allocate(array(dims(1)), stat=stat)
   if (stat == 0) call read_rdp_r1(filename, varname, array, dims, stat, msg)
#else
   stat = -1
   msg = "HDF5 support is not available in this build of tblite."
#endif
   call handle_iostat(stat, msg, filename//"::"//varname, iostat, iomsg, "read")
end subroutine load_hdf5_rdp_r1

subroutine load_hdf5_rdp_r2(filename, varname, array, iostat, iomsg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to load
   character(len=*), intent(in) :: varname
   !> Array to load the data into
   real(dp), allocatable, intent(out) :: array(:, :)
   !> Status of the read operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
#if TBLITE_HAS_HDF5
   integer(hsize_t) :: dims(2)
   call read_shape(filename, varname, dims, stat, msg)
   if (stat == 0) allocate(array(dims(1), dims(2)), stat=stat)
   if (stat == 0) call read_rdp_r2(filename, varname, array, dims, stat, msg)
#else
   stat = -1
   msg = "HDF5 support is not available in this build of tblite."
#endif
   call handle_iostat(stat, msg, filename//"::"//varname, iostat, iomsg, "read")
end subroutine load_hdf5_rdp_r2

subroutine load_hdf5_rdp_r3(filename, varname, array, iostat, iomsg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to load
   character(len=*), intent(in) :: varname
   !> Array to load the data into
   real(dp), allocatable, intent(out) :: array(:, :, :)
   !> Status of the read operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
#if TBLITE_HAS_HDF5
   integer(hsize_t) :: dims(3)
   call read_shape(filename, varname, dims, stat, msg)
   if (stat == 0) allocate(array(dims(1), dims(2), dims(3)), stat=stat)
   if (stat == 0) call read_rdp_r3(filename, varname, array, dims, stat, msg)
#else
   stat = -1
   msg = "HDF5 support is not available in this build of tblite."
#endif
   call handle_iostat(stat, msg, filename//"::"//varname, iostat, iomsg, "read")
end subroutine load_hdf5_rdp_r3

subroutine save_hdf5_i4_r1(filename, varname, array, iostat, iomsg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to save
   character(len=*), intent(in) :: varname
   !> Array to save
   integer(i4), intent(in) :: array(:)
   !> Status of the write operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
#if TBLITE_HAS_HDF5
   integer(hsize_t) :: dims(1)
   dims = shape(array, kind=hsize_t)
   call write_i4_r1(filename, varname, array, dims, stat, msg)
#else
   stat = -1
   msg = "HDF5 support is not available in this build of tblite."
#endif
   call handle_iostat(stat, msg, filename//"::"//varname, iostat, iomsg, "write")
end subroutine save_hdf5_i4_r1

subroutine save_hdf5_rdp_r1(filename, varname, array, iostat, iomsg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to save
   character(len=*), intent(in) :: varname
   !> Array to save
   real(dp), intent(in) :: array(:)
   !> Status of the write operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
#if TBLITE_HAS_HDF5
   integer(hsize_t) :: dims(1)
   dims = shape(array, kind=hsize_t)
   call write_rdp_r1(filename, varname, array, dims, stat, msg)
#else
   stat = -1
   msg = "HDF5 support is not available in this build of tblite."
#endif
   call handle_iostat(stat, msg, filename//"::"//varname, iostat, iomsg, "write")
end subroutine save_hdf5_rdp_r1

subroutine save_hdf5_rdp_r2(filename, varname, array, iostat, iomsg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to save
   character(len=*), intent(in) :: varname
   !> Array to save
   real(dp), intent(in) :: array(:, :)
   !> Status of the write operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
#if TBLITE_HAS_HDF5
   integer(hsize_t) :: dims(2)
   dims = shape(array, kind=hsize_t)
   call write_rdp_r2(filename, varname, array, dims, stat, msg)
#else
   stat = -1
   msg = "HDF5 support is not available in this build of tblite."
#endif
   call handle_iostat(stat, msg, filename//"::"//varname, iostat, iomsg, "write")
end subroutine save_hdf5_rdp_r2

subroutine save_hdf5_rdp_r3(filename, varname, array, iostat, iomsg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to save
   character(len=*), intent(in) :: varname
   !> Array to save
   real(dp), intent(in) :: array(:, :, :)
   !> Status of the write operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
#if TBLITE_HAS_HDF5
   integer(hsize_t) :: dims(3)
   dims = shape(array, kind=hsize_t)
   call write_rdp_r3(filename, varname, array, dims, stat, msg)
#else
   stat = -1
   msg = "HDF5 support is not available in this build of tblite."
#endif
   call handle_iostat(stat, msg, filename//"::"//varname, iostat, iomsg, "write")
end subroutine save_hdf5_rdp_r3

#if TBLITE_HAS_HDF5
subroutine hdf5_open(stat, msg)
   !> Status of HDF5 library initialization
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg

   call h5open_f(stat)
   if (stat /= 0) msg = "Failed to initialize HDF5 library"
end subroutine hdf5_open

subroutine hdf5_close()
   integer :: stat

   call h5close_f(stat)
end subroutine hdf5_close

subroutine close_file(file_id)
   !> HDF5 file identifier to close
   integer(hid_t), intent(in) :: file_id

   integer :: stat

   if (file_id > 0) call h5fclose_f(file_id, stat)
end subroutine close_file

subroutine close_dataset(dset_id)
   !> HDF5 dataset identifier to close
   integer(hid_t), intent(in) :: dset_id

   integer :: stat

   if (dset_id > 0) call h5dclose_f(dset_id, stat)
end subroutine close_dataset

subroutine close_space(space_id)
   !> HDF5 dataspace identifier to close
   integer(hid_t), intent(in) :: space_id

   integer :: stat

   if (space_id > 0) call h5sclose_f(space_id, stat)
end subroutine close_space

subroutine open_file_read(filename, file_id, stat, msg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> HDF5 file identifier
   integer(hid_t), intent(out) :: file_id
   !> Status of the open operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg

   file_id = -1_hid_t
   call h5fopen_f(filename, H5F_ACC_RDONLY_F, file_id, stat)
   if (stat /= 0) msg = "Failed to open HDF5 file '"//filename//"' for reading"
end subroutine open_file_read

subroutine open_file_write(filename, file_id, stat, msg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> HDF5 file identifier
   integer(hid_t), intent(out) :: file_id
   !> Status of the open or create operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg

   logical :: exist

   file_id = -1_hid_t
   inquire(file=filename, exist=exist)
   if (exist) then
      call h5fopen_f(filename, H5F_ACC_RDWR_F, file_id, stat)
      if (stat /= 0) msg = "Failed to open HDF5 file '"//filename//"' for writing"
   else
      call h5fcreate_f(filename, H5F_ACC_TRUNC_F, file_id, stat)
      if (stat /= 0) msg = "Failed to create HDF5 file '"//filename//"'"
   end if
end subroutine open_file_write

subroutine create_dataset(file_id, varname, type_id, dims, dset_id, stat, msg)
   !> HDF5 file identifier
   integer(hid_t), intent(in) :: file_id
   !> Name of the dataset to create
   character(len=*), intent(in) :: varname
   !> HDF5 datatype identifier for the dataset
   integer(hid_t), intent(in) :: type_id
   !> Dataset dimensions
   integer(hsize_t), intent(in) :: dims(:)
   !> HDF5 dataset identifier
   integer(hid_t), intent(out) :: dset_id
   !> Status of the create operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg

   logical :: exists
   integer(hid_t) :: space_id

   dset_id = -1_hid_t
   space_id = -1_hid_t
   call h5lexists_f(file_id, varname, exists, stat)
   if (stat == 0 .and. exists) call h5ldelete_f(file_id, varname, stat)
   if (stat == 0) call h5screate_simple_f(size(dims), dims, space_id, stat)
   if (stat == 0) call h5dcreate_f(file_id, varname, type_id, space_id, dset_id, stat)
   if (stat /= 0) msg = "Failed to create HDF5 dataset '"//varname//"'"
   call close_space(space_id)
end subroutine create_dataset

subroutine read_shape(filename, varname, dims, stat, msg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to inspect
   character(len=*), intent(in) :: varname
   !> Dataset dimensions
   integer(hsize_t), intent(out) :: dims(:)
   !> Status of the read operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg

   integer :: rank
   integer(hsize_t) :: maxdims(size(dims))
   integer(hid_t) :: file_id, dset_id, space_id

   file_id = -1_hid_t
   dset_id = -1_hid_t
   space_id = -1_hid_t
   call hdf5_open(stat, msg)
   if (stat == 0) call open_file_read(filename, file_id, stat, msg)
   if (stat == 0) call h5dopen_f(file_id, varname, dset_id, stat)
   if (stat /= 0 .and. .not.allocated(msg)) msg = "Dataset '"//filename//"::"//varname//"' not found"
   if (stat == 0) call h5dget_space_f(dset_id, space_id, stat)
   if (stat == 0) call h5sget_simple_extent_ndims_f(space_id, rank, stat)
   if (stat == 0 .and. rank /= size(dims)) then
      stat = 502
      msg = "Unexpected rank for HDF5 dataset '"//filename//"::"//varname//"'"
   end if
   if (stat == 0) then
      call h5sget_simple_extent_dims_f(space_id, dims, maxdims, stat)
      if (stat >= 0) stat = 0
   end if
   call close_space(space_id)
   call close_dataset(dset_id)
   call close_file(file_id)
   call hdf5_close()
end subroutine read_shape

subroutine write_i4_r1(filename, varname, array, dims, stat, msg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to write
   character(len=*), intent(in) :: varname
   !> Array to write
   integer(i4), intent(in) :: array(:)
   !> Dataset dimensions
   integer(hsize_t), intent(in) :: dims(:)
   !> Status of the write operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg
   integer(hid_t) :: file_id, dset_id

   call hdf5_open(stat, msg)
   if (stat == 0) call open_file_write(filename, file_id, stat, msg)
   if (stat == 0) call create_dataset(file_id, varname, H5T_NATIVE_INTEGER, dims, dset_id, stat, msg)
   if (stat == 0) call h5dwrite_f(dset_id, H5T_NATIVE_INTEGER, array, dims, stat)
   if (stat /= 0 .and. .not.allocated(msg)) msg = "Failed to write HDF5 dataset '"//filename//"::"//varname//"'"
   call close_dataset(dset_id)
   call close_file(file_id)
   call hdf5_close()
end subroutine write_i4_r1

subroutine write_rdp_r1(filename, varname, array, dims, stat, msg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to write
   character(len=*), intent(in) :: varname
   !> Array to write
   real(dp), intent(in) :: array(:)
   !> Dataset dimensions
   integer(hsize_t), intent(in) :: dims(:)
   !> Status of the write operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg
   integer(hid_t) :: file_id, dset_id

   call hdf5_open(stat, msg)
   if (stat == 0) call open_file_write(filename, file_id, stat, msg)
   if (stat == 0) call create_dataset(file_id, varname, H5T_NATIVE_DOUBLE, dims, dset_id, stat, msg)
   if (stat == 0) call h5dwrite_f(dset_id, H5T_NATIVE_DOUBLE, array, dims, stat)
   if (stat /= 0 .and. .not.allocated(msg)) msg = "Failed to write HDF5 dataset '"//filename//"::"//varname//"'"
   call close_dataset(dset_id)
   call close_file(file_id)
   call hdf5_close()
end subroutine write_rdp_r1

subroutine write_rdp_r2(filename, varname, array, dims, stat, msg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to write
   character(len=*), intent(in) :: varname
   !> Array to write
   real(dp), intent(in) :: array(:, :)
   !> Dataset dimensions
   integer(hsize_t), intent(in) :: dims(:)
   !> Status of the write operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg
   integer(hid_t) :: file_id, dset_id

   call hdf5_open(stat, msg)
   if (stat == 0) call open_file_write(filename, file_id, stat, msg)
   if (stat == 0) call create_dataset(file_id, varname, H5T_NATIVE_DOUBLE, dims, dset_id, stat, msg)
   if (stat == 0) call h5dwrite_f(dset_id, H5T_NATIVE_DOUBLE, array, dims, stat)
   if (stat /= 0 .and. .not.allocated(msg)) msg = "Failed to write HDF5 dataset '"//filename//"::"//varname//"'"
   call close_dataset(dset_id)
   call close_file(file_id)
   call hdf5_close()
end subroutine write_rdp_r2

subroutine write_rdp_r3(filename, varname, array, dims, stat, msg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to write
   character(len=*), intent(in) :: varname
   !> Array to write
   real(dp), intent(in) :: array(:, :, :)
   !> Dataset dimensions
   integer(hsize_t), intent(in) :: dims(:)
   !> Status of the write operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg
   integer(hid_t) :: file_id, dset_id

   call hdf5_open(stat, msg)
   if (stat == 0) call open_file_write(filename, file_id, stat, msg)
   if (stat == 0) call create_dataset(file_id, varname, H5T_NATIVE_DOUBLE, dims, dset_id, stat, msg)
   if (stat == 0) call h5dwrite_f(dset_id, H5T_NATIVE_DOUBLE, array, dims, stat)
   if (stat /= 0 .and. .not.allocated(msg)) msg = "Failed to write HDF5 dataset '"//filename//"::"//varname//"'"
   call close_dataset(dset_id)
   call close_file(file_id)
   call hdf5_close()
end subroutine write_rdp_r3

subroutine read_i4_r1(filename, varname, array, dims, stat, msg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to read
   character(len=*), intent(in) :: varname
   !> Array to read into
   integer(i4), intent(out) :: array(:)
   !> Dataset dimensions
   integer(hsize_t), intent(in) :: dims(:)
   !> Status of the read operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg
   integer(hid_t) :: file_id, dset_id

   call hdf5_open(stat, msg)
   if (stat == 0) call open_file_read(filename, file_id, stat, msg)
   if (stat == 0) call h5dopen_f(file_id, varname, dset_id, stat)
   if (stat == 0) call h5dread_f(dset_id, H5T_NATIVE_INTEGER, array, dims, stat)
   if (stat /= 0 .and. .not.allocated(msg)) msg = "Failed to read HDF5 dataset '"//filename//"::"//varname//"'"
   call close_dataset(dset_id)
   call close_file(file_id)
   call hdf5_close()
end subroutine read_i4_r1

subroutine read_rdp_r1(filename, varname, array, dims, stat, msg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to read
   character(len=*), intent(in) :: varname
   !> Array to read into
   real(dp), intent(out) :: array(:)
   !> Dataset dimensions
   integer(hsize_t), intent(in) :: dims(:)
   !> Status of the read operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg
   integer(hid_t) :: file_id, dset_id

   call hdf5_open(stat, msg)
   if (stat == 0) call open_file_read(filename, file_id, stat, msg)
   if (stat == 0) call h5dopen_f(file_id, varname, dset_id, stat)
   if (stat == 0) call h5dread_f(dset_id, H5T_NATIVE_DOUBLE, array, dims, stat)
   if (stat /= 0 .and. .not.allocated(msg)) msg = "Failed to read HDF5 dataset '"//filename//"::"//varname//"'"
   call close_dataset(dset_id)
   call close_file(file_id)
   call hdf5_close()
end subroutine read_rdp_r1

subroutine read_rdp_r2(filename, varname, array, dims, stat, msg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to read
   character(len=*), intent(in) :: varname
   !> Array to read into
   real(dp), intent(out) :: array(:, :)
   !> Dataset dimensions
   integer(hsize_t), intent(in) :: dims(:)
   !> Status of the read operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg
   integer(hid_t) :: file_id, dset_id

   call hdf5_open(stat, msg)
   if (stat == 0) call open_file_read(filename, file_id, stat, msg)
   if (stat == 0) call h5dopen_f(file_id, varname, dset_id, stat)
   if (stat == 0) call h5dread_f(dset_id, H5T_NATIVE_DOUBLE, array, dims, stat)
   if (stat /= 0 .and. .not.allocated(msg)) msg = "Failed to read HDF5 dataset '"//filename//"::"//varname//"'"
   call close_dataset(dset_id)
   call close_file(file_id)
   call hdf5_close()
end subroutine read_rdp_r2

subroutine read_rdp_r3(filename, varname, array, dims, stat, msg)
   !> Filename of the HDF5 file
   character(len=*), intent(in) :: filename
   !> Name of the dataset to read
   character(len=*), intent(in) :: varname
   !> Array to read into
   real(dp), intent(out) :: array(:, :, :)
   !> Dataset dimensions
   integer(hsize_t), intent(in) :: dims(:)
   !> Status of the read operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg
   integer(hid_t) :: file_id, dset_id

   call hdf5_open(stat, msg)
   if (stat == 0) call open_file_read(filename, file_id, stat, msg)
   if (stat == 0) call h5dopen_f(file_id, varname, dset_id, stat)
   if (stat == 0) call h5dread_f(dset_id, H5T_NATIVE_DOUBLE, array, dims, stat)
   if (stat /= 0 .and. .not.allocated(msg)) msg = "Failed to read HDF5 dataset '"//filename//"::"//varname//"'"
   call close_dataset(dset_id)
   call close_file(file_id)
   call hdf5_close()
end subroutine read_rdp_r3
#endif

subroutine handle_iostat(stat, msg, filename, iostat, iomsg, action)
   !> Status of the HDF5 operation
   integer, intent(in) :: stat
   !> Error message from the HDF5 operation
   character(len=:), allocatable, intent(in) :: msg
   !> Filename and dataset used in diagnostics
   character(len=*), intent(in) :: filename
   !> Status returned to the caller
   integer, intent(out), optional :: iostat
   !> Error message returned to the caller
   character(len=:), allocatable, intent(out), optional :: iomsg
   !> Operation name used in diagnostics
   character(len=*), intent(in) :: action

   if (present(iostat)) then
      iostat = stat
   else if (stat /= 0) then
      if (allocated(msg)) then
         error stop "Failed to "//action//" array from file '"//filename//"'"//nl//msg
      else
         error stop "Failed to "//action//" array from file '"//filename//"'"
      end if
   end if
   if (present(iomsg) .and. allocated(msg) .and. stat /= 0) iomsg = msg
end subroutine handle_iostat

end module tblite_io_hdf5

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/wignerseitz.f90
!> Provides a Wigner-Seitz cell

!> Implementation of finding the relevant nearest neighbours in a Wigner-Seitz cell
module tblite_wignerseitz
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_cutoff, only : get_lattice_points
   implicit none
   private

   public :: new_wignerseitz_cell

   !> Information on Wigner-Seitz images
   type, public :: wignerseitz_cell
      integer, allocatable :: nimg(:, :)
      integer, allocatable :: tridx(:, :, :)
      real(wp), allocatable :: trans(:, :)
   end type wignerseitz_cell


   !> Small cutoff threshold to create only closest cells
   real(wp), parameter :: thr = sqrt(epsilon(0.0_wp))

   !> Tolerance to consider equivalent images
   real(wp), parameter :: tol = 0.01_wp


contains


subroutine new_wignerseitz_cell(self, mol)

   !> Wigner-Seitz cell instance
   type(wignerseitz_cell), intent(out) :: self

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   integer :: iat, jat, ntr, nimg
   integer, allocatable :: tridx(:)
   real(wp) :: vec(3)
   real(wp), allocatable :: trans(:, :)

   call get_lattice_points(mol%periodic, mol%lattice, thr, trans)
   ntr = size(trans, 2)
   allocate(self%nimg(mol%nat, mol%nat), self%tridx(ntr, mol%nat, mol%nat), &
      & tridx(ntr))

   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(mol, trans, self) private(iat, jat, vec, nimg, tridx)
   do iat = 1, mol%nat
      do jat = 1, mol%nat
         vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat)
         call get_pairs(nimg, trans, vec, tridx)
         self%nimg(jat, iat) = nimg
         self%tridx(:, jat, iat) = tridx
      end do
   end do

   call move_alloc(trans, self%trans)
   
end subroutine new_wignerseitz_cell


subroutine get_pairs(iws, trans, rij, list)
   integer, intent(out) :: iws
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: trans(:, :)
   integer, intent(out) :: list(:)

   logical :: mask(size(list))
   real(wp) :: dist(size(list)), vec(3), r2
   integer :: itr, img, pos

   iws = 0
   img = 0
   list(:) = 0
   mask(:) = .true.

   do itr = 1, size(trans, 2)
      vec(:) = rij - trans(:, itr)
      r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
      if (r2 < thr) cycle
      img = img + 1
      dist(img) = r2
   end do

   if (img == 0) return

   pos = minloc(dist(:img), dim=1)

   r2 = dist(pos)
   mask(pos) = .false.

   iws = 1
   list(iws) = pos
   if (img <= iws) return

   do
      pos = minloc(dist(:img), dim=1, mask=mask(:img))
      if (abs(dist(pos) - r2) > tol) exit
      mask(pos) = .false.
      iws = iws + 1
      list(iws) = pos
   end do

end subroutine get_pairs


end module tblite_wignerseitz

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/integral/trafo.f90
!> Provides transformation from cartesian to spherical harmonic basis functions

!> Implementation of transformations from cartesian to spherical harmonic basis functions
!> and adjoint transformation for contravariant vectors from spherical harmonic 
!> to cartesian basis functions.
!>
!> Spherical harmonics use standard ordering, *i.e.* [-l, ..., 0, ..., l].
module tblite_integral_trafo
   use mctc_env, only : wp
   implicit none
   private

   public :: transform0, transform1, transform2
   public :: adjoint_transform0, adjoint_transform1, adjoint_transform2


   real(wp), parameter :: s3 = sqrt(3.0_wp)
   real(wp), parameter :: s3_4 = s3 * 0.5_wp
   real(wp), parameter :: dtrafo(5, 6) = reshape([&
      ! -2      -1       0       1       2
      & 0.0_wp, 0.0_wp, -0.5_wp, 0.0_wp,   s3_4, & ! xx
      & 0.0_wp, 0.0_wp, -0.5_wp, 0.0_wp,  -s3_4, & ! yy
      & 0.0_wp, 0.0_wp,  1.0_wp, 0.0_wp, 0.0_wp, & ! zz
      &     s3, 0.0_wp,  0.0_wp, 0.0_wp, 0.0_wp, & ! xy
      & 0.0_wp, 0.0_wp,  0.0_wp,     s3, 0.0_wp, & ! xz
      & 0.0_wp,     s3,  0.0_wp, 0.0_wp, 0.0_wp],& ! yz
      & shape(dtrafo))

   real(wp), parameter :: d32 = 3.0_wp/2.0_wp
   real(wp), parameter :: s3_8 = sqrt(3.0_wp/8.0_wp)
   real(wp), parameter :: s5_8 = sqrt(5.0_wp/8.0_wp)
   real(wp), parameter :: s6 = sqrt(6.0_wp)
   real(wp), parameter :: s15 = sqrt(15.0_wp)
   real(wp), parameter :: s15_4 = sqrt(15.0_wp/4.0_wp)
   real(wp), parameter :: s45 = sqrt(45.0_wp)
   real(wp), parameter :: s45_8 = sqrt(45.0_wp/8.0_wp)
   real(wp), parameter :: ftrafo(7, 10) = reshape([&
      ! -3       -2       -1       0        1         2         3
      &  0.0_wp,  0.0_wp,  0.0_wp, 0.0_wp,   -s3_8,   0.0_wp,     s5_8, & ! xxx
      &   -s5_8,  0.0_wp,   -s3_8, 0.0_wp,  0.0_wp,   0.0_wp,   0.0_wp, & ! yyy
      &  0.0_wp,  0.0_wp,  0.0_wp, 1.0_wp,  0.0_wp,   0.0_wp,   0.0_wp, & ! zzz
      &   s45_8,  0.0_wp,   -s3_8, 0.0_wp,  0.0_wp,   0.0_wp,   0.0_wp, & ! xxy
      &  0.0_wp,  0.0_wp,  0.0_wp,   -d32,  0.0_wp,    s15_4,   0.0_wp, & ! xxz
      &  0.0_wp,  0.0_wp,  0.0_wp, 0.0_wp,   -s3_8,   0.0_wp,   -s45_8, & ! xyy
      &  0.0_wp,  0.0_wp,  0.0_wp,   -d32,  0.0_wp,   -s15_4,   0.0_wp, & ! yyz
      &  0.0_wp,  0.0_wp,  0.0_wp, 0.0_wp,      s6,   0.0_wp,   0.0_wp, & ! xzz
      &  0.0_wp,  0.0_wp,      s6, 0.0_wp,  0.0_wp,   0.0_wp,   0.0_wp, & ! yzz
      &  0.0_wp,     s15,  0.0_wp, 0.0_wp,  0.0_wp,   0.0_wp,   0.0_wp],& ! xyz
      & shape(ftrafo))

   real(wp), parameter :: d38 = 3.0_wp/8.0_wp
   real(wp), parameter :: d34 = 3.0_wp/4.0_wp
   real(wp), parameter :: s5_16 = sqrt(5.0_wp/16.0_wp)
   real(wp), parameter :: s10 = sqrt(10.0_wp)
   real(wp), parameter :: s10_8 = sqrt(10.0_wp/8.0_wp)
   real(wp), parameter :: s35_4 = sqrt(35.0_wp/4.0_wp)
   real(wp), parameter :: s35_8 = sqrt(35.0_wp/8.0_wp)
   real(wp), parameter :: s35_64 = sqrt(35.0_wp/64.0_wp)
   real(wp), parameter :: s45_4 = sqrt(45.0_wp/4.0_wp)
   real(wp), parameter :: s315_8 = sqrt(315.0_wp/8.0_wp)
   real(wp), parameter :: s315_16 = sqrt(315.0_wp/16.0_wp)
   real(wp), parameter :: gtrafo(9, 15) = reshape([&
      !  -4     -3     -2     -1       0    1      2       3        4
      &  0._wp, 0._wp, 0._wp, 0._wp,   d38, 0._wp,-s5_16,  0._wp,  s35_64, & ! xxxx
      &  0._wp, 0._wp, 0._wp, 0._wp,   d38, 0._wp, s5_16,  0._wp,  s35_64, & ! yyyy
      &  0._wp, 0._wp, 0._wp, 0._wp, 1._wp, 0._wp, 0._wp,  0._wp,   0._wp, & ! zzzz
      &  s35_4, 0._wp,-s10_8, 0._wp, 0._wp, 0._wp, 0._wp,  0._wp,   0._wp, & ! xxxy
      &  0._wp, 0._wp, 0._wp, 0._wp, 0._wp,-s45_8, 0._wp,  s35_8,   0._wp, & ! xxxz
      & -s35_4, 0._wp,-s10_8, 0._wp, 0._wp, 0._wp, 0._wp,  0._wp,   0._wp, & ! xyyy
      &  0._wp,-s35_8, 0._wp,-s45_8, 0._wp, 0._wp, 0._wp,  0._wp,   0._wp, & ! yyyz
      &  0._wp, 0._wp, 0._wp, 0._wp, 0._wp,   s10, 0._wp,  0._wp,   0._wp, & ! xzzz
      &  0._wp, 0._wp, 0._wp,   s10, 0._wp, 0._wp, 0._wp,  0._wp,   0._wp, & ! yzzz
      &  0._wp, 0._wp, 0._wp, 0._wp,   d34, 0._wp, 0._wp,  0._wp,-s315_16, & ! xxyy
      &  0._wp, 0._wp, 0._wp, 0._wp,-3._wp, 0._wp, s45_4,  0._wp,   0._wp, & ! xxzz
      &  0._wp, 0._wp, 0._wp, 0._wp,-3._wp, 0._wp,-s45_4,  0._wp,   0._wp, & ! yyzz
      &  0._wp,s315_8, 0._wp,-s45_8, 0._wp, 0._wp, 0._wp,  0._wp,   0._wp, & ! xxyz
      &  0._wp, 0._wp, 0._wp, 0._wp, 0._wp,-s45_8, 0._wp,-s315_8,   0._wp, & ! xyyz
      &  0._wp, 0._wp,   s45, 0._wp, 0._wp, 0._wp, 0._wp,  0._wp,   0._wp],& ! xyzz
      &  shape(gtrafo))

contains


!> Transformation from the cartesian to the spherical harmonic basis 
!> for a shell pair block.
pure subroutine transform0(lj, li, cart, sphr, bra, ket)
   !> Angular momentum of ket shell i
   integer, intent(in) :: li
   !> Angular momentum of bra shell j
   integer, intent(in) :: lj
   !> Cartesian representation of the integral [bra j, ket i]
   real(wp), intent(in) :: cart(:, :)
   !> Spherical harmonic representation of the integral [bra j, ket i]
   real(wp), intent(out) :: sphr(:, :)
   !> Flag for transformation of the bra dimension
   logical, intent(in) :: bra
   !> Flag for transformation of the ket dimension
   logical, intent(in) :: ket

   if (.not. bra .and. .not. ket) then
      sphr = cart
      return
   end if

   if (.not. bra .and. ket) then
       select case(li)
       case(0, 1)
          sphr = cart
       case(2)
          sphr = matmul(cart, transpose(dtrafo))
       case(3)
          sphr = matmul(cart, transpose(ftrafo))
       case(4)
          sphr = matmul(cart, transpose(gtrafo))
       case default
          error stop "[Fatal] Moments higher than g are not supported"
       end select
       return
   end if

   if (bra .and. .not. ket) then
       select case(lj)
       case(0, 1)
          sphr = cart
       case(2)
          sphr = matmul(dtrafo, cart)
       case(3)
          sphr = matmul(ftrafo, cart)
       case(4)
          sphr = matmul(gtrafo, cart)
       case default
          error stop "[Fatal] Moments higher than g are not supported"
       end select
       return
   end if

   ! Transform both dimensions
   select case(li)
   case(0, 1)
      select case(lj)
      case(0, 1)
         sphr = cart
      case(2)
         !sphr = matmul(dtrafo, cart)
         sphr(3, :) = cart(3, :) - 0.5_wp * (cart(1, :) + cart(2, :))
         sphr(4, :) = s3 * cart(5, :)
         sphr(2, :) = s3 * cart(6, :)
         sphr(5, :) = s3_4 * (cart(1, :) - cart(2, :))
         sphr(1, :) = s3 * cart(4, :)
      case(3)
         sphr = matmul(ftrafo, cart)
      case(4)
         sphr = matmul(gtrafo, cart)
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select

   case(2)
      select case(lj)
      case(0, 1)
         !sphr = matmul(cart, transpose(dtrafo))
         sphr(:, 3) = cart(:, 3) - 0.5_wp * (cart(:, 1) + cart(:, 2))
         sphr(:, 4) = s3 * cart(:, 5)
         sphr(:, 2) = s3 * cart(:, 6)
         sphr(:, 5) = s3_4 * (cart(:, 1) - cart(:, 2))
         sphr(:, 1) = s3 * cart(:, 4)
      case(2)
         !sphr = matmul(dtrafo, matmul(cart, transpose(dtrafo)))
         sphr(3, 3) = cart(3, 3) &
            & - 0.5_wp * (cart(3, 1) + cart(3, 2) + cart(1, 3) + cart(2, 3)) &
            & + 0.25_wp * (cart(1, 1) + cart(1, 2) + cart(2, 1) + cart(2, 2))
         sphr([4, 2, 1], 3) = s3 * cart([5, 6, 4], 3) &
            & - s3_4 * (cart([5, 6, 4], 1) + cart([5, 6, 4], 2))
         sphr(5, 3) = s3_4 * (cart(1, 3) - cart(2, 3)) &
            & - s3 * 0.25_wp * (cart(1, 1) - cart(2, 1) + cart(1, 2) - cart(2, 2))
         sphr(3, 4) = s3 * cart(3, 5) - s3_4 * (cart(1, 5) + cart(2, 5))
         sphr([4, 2, 1], 4) = 3 * cart([5, 6, 4], 5)
         sphr(5, 4) = 1.5_wp * (cart(1, 5) - cart(2, 5))
         sphr(3, 2) = s3 * cart(3, 6) - s3_4 * (cart(1, 6) + cart(2, 6))
         sphr([4, 2, 1], 2) = 3 * cart([5, 6, 4], 6)
         sphr(5, 2) = 1.5_wp * (cart(1, 6) - cart(2, 6))
         sphr(3, 5) = s3_4 * (cart(3, 1) - cart(3, 2)) &
            & - s3 * 0.25_wp * (cart(1, 1) - cart(1, 2) + cart(2, 1) - cart(2, 2))
         sphr([4, 2, 1], 5) = 1.5_wp * (cart([5, 6, 4], 1) - cart([5, 6, 4], 2))
         sphr(5, 5) = 0.75_wp * (cart(1, 1) - cart(2, 1) - cart(1, 2) + cart(2, 2))
         sphr(3, 1) = s3 * cart(3, 4) - s3_4 * (cart(1, 4) + cart(2, 4))
         sphr([4, 2, 1], 1) = 3 * cart([5, 6, 4], 4)
         sphr(5, 1) = 1.5_wp * (cart(1, 4) - cart(2, 4))
      case(3)
         sphr = matmul(ftrafo, matmul(cart, transpose(dtrafo)))
      case(4)
         sphr = matmul(gtrafo, matmul(cart, transpose(dtrafo)))
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select

   case(3)
      select case(lj)
      case(0, 1)
         sphr = matmul(cart, transpose(ftrafo))
      case(2)
         sphr = matmul(dtrafo, matmul(cart, transpose(ftrafo)))
      case(3)
         sphr = matmul(ftrafo, matmul(cart, transpose(ftrafo)))
      case(4)
         sphr = matmul(gtrafo, matmul(cart, transpose(ftrafo)))
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select

   case(4)
      select case(lj)
      case(0, 1)
         sphr = matmul(cart, transpose(gtrafo))
      case(2)
         sphr = matmul(dtrafo, matmul(cart, transpose(gtrafo)))
      case(3)
         sphr = matmul(ftrafo, matmul(cart, transpose(gtrafo)))
      case(4)
         sphr = matmul(gtrafo, matmul(cart, transpose(gtrafo)))
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select

   case default
      error stop "[Fatal] Moments higher than g are not supported"
   end select

end subroutine transform0

!> Transformation from the cartesian to the spherical harmonic basis 
!> for a vector of shell pair block.
pure subroutine transform1(lj, li, cart, sphr, bra, ket)
   !> Angular momentum of ket shell i
   integer, intent(in) :: li
   !> Angular momentum of bra shell j
   integer, intent(in) :: lj
   !> Cartesian representation of the integral [:, bra j, ket i]
   real(wp), intent(in) :: cart(:, :, :)
   !> Spherical harmonic representation of the integral [:, bra j, ket i]
   real(wp), intent(out) :: sphr(:, :, :)
   !> Flag for transformation of the bra dimension
   logical, intent(in) :: bra
   !> Flag for transformation of the ket dimension
   logical, intent(in) :: ket

   integer :: k

   do k = 1, size(cart, 1)
      call transform0(lj, li, cart(k, :, :), sphr(k, :, :), bra, ket)
   end do
end subroutine transform1

!> Transformation from the cartesian to the spherical harmonic basis 
!> for a matrix of shell pair block.
pure subroutine transform2(lj, li, cart, sphr, bra, ket)
   !> Angular momentum of ket shell i
   integer, intent(in) :: li
   !> Angular momentum of bra shell j
   integer, intent(in) :: lj
   !> Cartesian representation of the integral [:, :, bra j, ket i]
   real(wp), intent(in) :: cart(:, :, :, :)
   !> Spherical harmonic representation of the integral [:, :, bra j, ket i]
   real(wp), intent(out) :: sphr(:, :, :, :)
   !> Flag for transformation of the bra dimension
   logical, intent(in) :: bra
   !> Flag for transformation of the ket dimension
   logical, intent(in) :: ket

   integer :: k, l

   do l = 1, size(cart, 2)
      do k = 1, size(cart, 1)
         call transform0(lj, li, cart(k, l, :, :), sphr(k, l, :, :), bra, ket)
      end do
   end do
end subroutine transform2


!> Adjoint transformation from the spherical harmonic to the cartesian basis
!> for a shell pair block. Applies quantities which behave contravariant w.r.t.
!> the basis functions (i.e. MO expansion coefficients or the density matrix)
pure subroutine adjoint_transform0(lj, li, sphr, cart, bra, ket)
   !> Angular momentum of ket shell i
   integer, intent(in) :: li
   !> Angular momentum of bra shell j
   integer, intent(in) :: lj
   !> Spherical harmonic representation of the integral [bra j, ket i]
   real(wp), intent(in) :: sphr(:, :)
   !> Cartesian representation of the integral [bra j, ket i]
   real(wp), intent(out) :: cart(:, :)
   !> Flag for transformation of the bra dimension
   logical, intent(in) :: bra
   !> Flag for transformation of the ket dimension
   logical, intent(in) :: ket

   if (.not. bra .and. .not. ket) then
      cart = sphr
      return
   end if

   ! Transform only ket dimension
   if (.not. bra .and. ket) then
      select case(li)
      case(0, 1)
         cart = sphr
      case(2)
         cart = matmul(sphr, dtrafo)
      case(3)
         cart = matmul(sphr, ftrafo)
      case(4)
         cart = matmul(sphr, gtrafo)
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select
      return
   end if

   ! Transform only bra dimension
   if (bra .and. .not. ket) then
      select case(lj)
      case(0, 1)
         cart = sphr
      case(2)
         cart = matmul(transpose(dtrafo), sphr)
      case(3)
         cart = matmul(transpose(ftrafo), sphr)
      case(4)
         cart = matmul(transpose(gtrafo), sphr)
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select
      return
   end if

   ! Transform both dimensions
   select case(lj)
   case(0, 1)
      select case(li)
      case(0, 1)
         cart = sphr
      case(2)
         cart = matmul(sphr, dtrafo)
      case(3)
         cart = matmul(sphr, ftrafo)
      case(4)
         cart = matmul(sphr, gtrafo)
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select

   case(2)
      select case(li)
      case(0, 1)
         cart = matmul(transpose(dtrafo), sphr)
      case(2)
         cart = matmul(transpose(dtrafo), matmul(sphr, dtrafo))
      case(3)
         cart = matmul(transpose(dtrafo), matmul(sphr, ftrafo))
      case(4)
         cart = matmul(transpose(dtrafo), matmul(sphr, gtrafo))
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select

   case(3)
      select case(li)
      case(0, 1)
         cart = matmul(transpose(ftrafo), sphr)
      case(2)
         cart = matmul(transpose(ftrafo), matmul(sphr, dtrafo))
      case(3)
         cart = matmul(transpose(ftrafo), matmul(sphr, ftrafo))
      case(4)
         cart = matmul(transpose(ftrafo), matmul(sphr, gtrafo))
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select

   case(4)
      select case(li)
      case(0, 1)
         cart = matmul(transpose(gtrafo), sphr)
      case(2)
         cart = matmul(transpose(gtrafo), matmul(sphr, dtrafo))
      case(3)
         cart = matmul(transpose(gtrafo), matmul(sphr, ftrafo))
      case(4)
         cart = matmul(transpose(gtrafo), matmul(sphr, gtrafo))
      case default
         error stop "[Fatal] Moments higher than g are not supported"
      end select

   case default
      error stop "[Fatal] Moments higher than g are not supported"
   end select

end subroutine adjoint_transform0

!> Adjoint transformation from the spherical harmonic to the cartesian basis
!> for a vector of shell pair block. Applies quantities which behave contravariant
!> w.r.t. the basis functions (i.e. MO expansion coefficients or the density matrix)
pure subroutine adjoint_transform1(lj, li, sphr, cart, bra, ket)
   !> Angular momentum of ket shell i
   integer, intent(in) :: li
   !> Angular momentum of bra shell j
   integer, intent(in) :: lj
   !> Spherical harmonic representation of the integral [:, bra j, ket i]
   real(wp), intent(in) :: sphr(:, :, :)
   !> Cartesian representation of the integral [:, bra j, ket i]
   real(wp), intent(out) :: cart(:, :, :)
   !> Flag for transformation of the bra dimension
   logical, intent(in) :: bra
   !> Flag for transformation of the ket dimension
   logical, intent(in) :: ket

   integer :: k

   do k = 1, size(sphr, 1)
      call adjoint_transform0(lj, li, sphr(k, :, :), cart(k, :, :), bra, ket)
   end do
end subroutine adjoint_transform1

!> Adjoint transformation from the spherical harmonic to the cartesian basis
!> for a matrix of shell pair block. Applies quantities which behave contravariant
!> w.r.t. the basis functions (i.e. MO expansion coefficients or the density matrix)
pure subroutine adjoint_transform2(lj, li, sphr, cart, bra, ket)
   !> Angular momentum of ket shell i
   integer, intent(in) :: li
   !> Angular momentum of bra shell j
   integer, intent(in) :: lj
   !> Spherical harmonic representation of the integral [:, :, bra j, ket i]
   real(wp), intent(in) :: sphr(:, :, :, :)
   !> Cartesian representation of the integral [:, :, bra j, ket i]
   real(wp), intent(out) :: cart(:, :, :, :)
   !> Flag for transformation of the bra dimension
   logical, intent(in) :: bra
   !> Flag for transformation of the ket dimension
   logical, intent(in) :: ket

   integer :: k, l

   do l = 1, size(sphr, 2)
      do k = 1, size(sphr, 1)
         call adjoint_transform0(lj, li, sphr(k, l, :, :), cart(k, l, :, :), bra, ket)
      end do
   end do
end subroutine adjoint_transform2


end module tblite_integral_trafo

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/blas/level2.f90
!> Provides interfactes to level 2 BLAS routines

!> High-level interface to level 2 basic linear algebra subprogram operations
module tblite_blas_level2
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_gemv, wrap_symv


   !> Performs one of the matrix-vector operations
   !>
   !>    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
   !>
   !> where alpha and beta are scalars, x and y are vectors and A is an
   !> m by n matrix.
   interface wrap_gemv
      module procedure :: wrap_sgemv
      module procedure :: wrap_dgemv
      module procedure :: wrap_sgemv312
      module procedure :: wrap_sgemv321
      module procedure :: wrap_sgemv422
      module procedure :: wrap_dgemv312
      module procedure :: wrap_dgemv321
      module procedure :: wrap_dgemv422
   end interface wrap_gemv

   !> Performs the matrix-vector  operation
   !>
   !>    y := alpha*A*x + beta*y,
   !>
   !> where alpha and beta are scalars, x and y are n element vectors and
   !> A is an n by n symmetric matrix.
   interface wrap_symv
      module procedure :: wrap_ssymv
      module procedure :: wrap_dsymv
   end interface wrap_symv


   !> Performs one of the matrix-vector operations
   !>
   !>    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
   !>
   !> where alpha and beta are scalars, x and y are vectors and A is an
   !> m by n matrix.
   interface blas_gemv
      pure subroutine sgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: x(*)
         real(sp), intent(inout) :: y(*)
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine sgemv
      pure subroutine dgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: x(*)
         real(dp), intent(inout) :: y(*)
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dgemv
   end interface blas_gemv

   !> Performs the matrix-vector  operation
   !>
   !>    y := alpha*A*x + beta*y,
   !>
   !> where alpha and beta are scalars, x and y are n element vectors and
   !> A is an n by n symmetric matrix.
   interface blas_symv
      pure subroutine ssymv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: x(*)
         real(sp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine ssymv
      pure subroutine dsymv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: x(*)
         real(dp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dsymv
   end interface blas_symv


contains


subroutine wrap_sgemv422(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in), contiguous, target :: amat(:, :, :, :)
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(inout), contiguous, target :: yvec(:, :)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp), pointer :: aptr(:, :), yptr(:), xptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)*size(amat, 4)) => amat
   xptr(1:size(xvec, 1)*size(xvec, 2)) => xvec
   yptr(1:size(yvec, 1)*size(yvec, 2)) => yvec
   call wrap_gemv(aptr, xptr, yptr, alpha, beta, tra)
end subroutine wrap_sgemv422


subroutine wrap_sgemv312(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout), contiguous, target :: yvec(:, :)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp), pointer :: aptr(:, :), yptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      yptr(1:size(yvec, 1)*size(yvec, 2)) => yvec
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      yptr(1:size(yvec, 1) * size(yvec, 2)) => yvec
   end if
   call wrap_gemv(aptr, xvec, yptr, alpha, beta, tra)
end subroutine wrap_sgemv312


subroutine wrap_sgemv321(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(inout) :: yvec(:)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp), pointer :: aptr(:, :), xptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      xptr(1:size(xvec, 1)*size(xvec, 2)) => xvec
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      xptr(1:size(xvec, 1) * size(xvec, 2)) => xvec
   end if
   call wrap_gemv(aptr, xptr, yvec, alpha, beta, tra)
end subroutine wrap_sgemv321


subroutine wrap_dgemv422(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in), contiguous, target :: amat(:, :, :, :)
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(inout), contiguous, target :: yvec(:, :)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp), pointer :: aptr(:, :), yptr(:), xptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)*size(amat, 4)) => amat
   xptr(1:size(xvec, 1)*size(xvec, 2)) => xvec
   yptr(1:size(yvec, 1)*size(yvec, 2)) => yvec
   call wrap_gemv(aptr, xptr, yptr, alpha, beta, tra)
end subroutine wrap_dgemv422


subroutine wrap_dgemv312(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout), contiguous, target :: yvec(:, :)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp), pointer :: aptr(:, :), yptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      yptr(1:size(yvec, 1)*size(yvec, 2)) => yvec
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      yptr(1:size(yvec, 1) * size(yvec, 2)) => yvec
   end if
   call wrap_gemv(aptr, xvec, yptr, alpha, beta, tra)
end subroutine wrap_dgemv312


subroutine wrap_dgemv321(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(inout) :: yvec(:)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp), pointer :: aptr(:, :), xptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      xptr(1:size(xvec, 1)*size(xvec, 2)) => xvec
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      xptr(1:size(xvec, 1) * size(xvec, 2)) => xvec
   end if
   call wrap_gemv(aptr, xptr, yvec, alpha, beta, tra)
end subroutine wrap_dgemv321


pure subroutine wrap_sgemv(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout) :: yvec(:)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp) :: a, b
   character(len=1) :: tra
   integer :: incx, incy, m, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
   call blas_gemv(tra, m, n, a, amat, lda, xvec, incx, b, yvec, incy)
end subroutine wrap_sgemv


pure subroutine wrap_dgemv(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout) :: yvec(:)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp) :: a, b
   character(len=1) :: tra
   integer :: incx, incy, m, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
   call blas_gemv(tra, m, n, a, amat, lda, xvec, incx, b, yvec, incy)
end subroutine wrap_dgemv


pure subroutine wrap_ssymv(amat, xvec, yvec, uplo, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout) :: yvec(:)
   character(len=1), intent(in), optional :: uplo
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1) :: ula
   real(sp) :: a, b
   integer :: incx, incy, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   call blas_symv(ula, n, a, amat, lda, xvec, incx, b, yvec, incy)
end subroutine wrap_ssymv


pure subroutine wrap_dsymv(amat, xvec, yvec, uplo, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout) :: yvec(:)
   character(len=1), intent(in), optional :: uplo
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1) :: ula
   real(dp) :: a, b
   integer :: incx, incy, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   call blas_symv(ula, n, a, amat, lda, xvec, incx, b, yvec, incy)
end subroutine wrap_dsymv


end module tblite_blas_level2

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3_data
   use dftd3_data_r4r2, only : get_r4r2_val
   use dftd3_data_vdwrad, only : get_vdw_rad
   implicit none
   private

   public :: get_r4r2_val, get_vdw_rad


end module dftd3_data

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Provides a light-weight testing framework for usage in projects depending on
!> the tool chain library.
!>
!> Testsuites are defined by a [[collect_interface]] returning a set of
!> [[unittest_type]] objects. To create a new test use the [[new_unittest]]
!> constructor, which requires a test identifier and a procedure with a
!> [[test_interface]] compatible signature. The error status is communicated
!> by the allocation status of an [[error_type]].
!>
!> The necessary boilerplate code to setup the test entry point is just
!>
!>```fortran
!>program tester
!>   use, intrinsic :: iso_fortran_env, only : error_unit
!>   use mctc_env_testing, only : run_testsuite, new_testsuite, testsuite_type
!>   use test_suite1, only : collect_suite1
!>   use test_suite2, only : collect_suite2
!>   implicit none
!>   integer :: stat, ii
!>   type(testsuite_type), allocatable :: testsuites(:)
!>   character(len=*), parameter :: fmt = '("#", *(1x, a))'
!>
!>   stat = 0
!>
!>   testsuites = [ &
!>      & new_testsuite("suite1", collect_suite1), &
!>      & new_testsuite("suite2", collect_suite2) &
!>      & ]
!>
!>   do ii = 1, size(testsuites)
!>      write(error_unit, fmt) "Testing:", testsuites(ii)%name
!>      call run_testsuite(testsuites(ii)%collect, error_unit, stat)
!>   end do
!>
!>   if (stat > 0) then
!>      write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
!>      error stop
!>   end if
!>
!>end program tester
!>```
!>
!> Every test is defined in a separate module using a ``collect`` function, which
!> is exported and added to the ``testsuites`` array in the test runner.
!> All test have a simple interface with just an allocatable [[error_type]] as
!> output to provide the test results.
!>
!>```fortran
!>module test_suite1
!>   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check
!>   implicit none
!>   private
!>
!>   public :: collect_suite1
!>
!>contains
!>
!>!> Collect all exported unit tests
!>subroutine collect_suite1(testsuite)
!>   !> Collection of tests
!>   type(unittest_type), allocatable, intent(out) :: testsuite(:)
!>
!>   testsuite = [ &
!>      & new_unittest("valid", test_valid), &
!>      & new_unittest("invalid", test_invalid, should_fail=.true.) &
!>      & ]
!>
!>end subroutine collect_suite1
!>
!>subroutine test_valid(error)
!>   type(error_type), allocatable, intent(out) :: error
!>   ! ...
!>end subroutine test_valid
!>
!>subroutine test_invalid(error)
!>   type(error_type), allocatable, intent(out) :: error
!>   ! ...
!>end subroutine test_invalid
!>
!>end module test_suite1
!>```
!>
!> For an example setup checkout the ``test/`` directory in this project.
module mctc_env_testing
   use mctc_env_error, only : error_type, mctc_stat
   use mctc_env_accuracy, only : sp, dp, i1, i2, i4, i8
   implicit none
   private

   public :: run_testsuite, run_selected, new_unittest, new_testsuite
   public :: select_test, select_suite
   public :: unittest_type, testsuite_type, error_type
   public :: check, test_failed
   public :: test_interface, collect_interface


   interface check
      module procedure :: check_stat
      module procedure :: check_logical
      module procedure :: check_float_sp
      module procedure :: check_float_dp
      module procedure :: check_int_i1
      module procedure :: check_int_i2
      module procedure :: check_int_i4
      module procedure :: check_int_i8
      module procedure :: check_bool
      module procedure :: check_string
   end interface check


   abstract interface
      !> Entry point for tests
      subroutine test_interface(error)
         import :: error_type

         !> Error handling
         type(error_type), allocatable, intent(out) :: error

      end subroutine test_interface
   end interface


   !> Declaration of a unit test
   type :: unittest_type

      !> Name of the test
      character(len=:), allocatable :: name

      !> Entry point of the test
      procedure(test_interface), pointer, nopass :: test => null()

      !> Whether test is supposed to fail
      logical :: should_fail = .false.

   end type unittest_type


   abstract interface
      !> Collect all tests
      subroutine collect_interface(testsuite)
         import :: unittest_type

         !> Collection of tests
         type(unittest_type), allocatable, intent(out) :: testsuite(:)

      end subroutine collect_interface
   end interface


   !> Collection of unit tests
   type :: testsuite_type

      !> Name of the testsuite
      character(len=:), allocatable :: name

      !> Entry point of the test
      procedure(collect_interface), pointer, nopass :: collect => null()

   end type testsuite_type


   character(len=*), parameter :: fmt = '(1x, *(1x, a))'
   character(len=*), parameter :: indent = repeat(" ", 5) // repeat(".", 3)


contains


!> Driver for testsuite
subroutine run_testsuite(collect, unit, stat, parallel)

   !> Collect tests
   procedure(collect_interface) :: collect

   !> Unit for IO
   integer, intent(in) :: unit

   !> Number of failed tests
   integer, intent(inout) :: stat

   !> Run tests in parallel
   logical, intent(in), optional :: parallel

   type(unittest_type), allocatable :: testsuite(:)
   logical :: parallelize
   integer :: ii

   parallelize = .false.
   if (present(parallel)) parallelize = parallel

   call collect(testsuite)

   !$omp parallel do shared(testsuite, unit) reduction(+:stat) if(parallelize)
   do ii = 1, size(testsuite)
      !$omp critical(mctc_env_testsuite)
      write(unit, '(1x, 3(1x, a), 1x, "(", i0, "/", i0, ")")') &
         & "Starting", testsuite(ii)%name, "...", ii, size(testsuite)
      !$omp end critical(mctc_env_testsuite)
      call run_unittest(testsuite(ii), unit, stat)
   end do

end subroutine run_testsuite


!> Driver for selective testing
subroutine run_selected(collect, name, unit, stat)

   !> Collect tests
   procedure(collect_interface) :: collect

   !> Name of the selected test
   character(len=*), intent(in) :: name

   !> Unit for IO
   integer, intent(in) :: unit

   !> Number of failed tests
   integer, intent(inout) :: stat

   type(unittest_type), allocatable :: testsuite(:)
   integer :: ii

   call collect(testsuite)

   ii = select_test(testsuite, name)

   if (ii > 0 .and. ii <= size(testsuite)) then
      call run_unittest(testsuite(ii), unit, stat)
   else
      write(unit, fmt) "Available tests:"
      do ii = 1, size(testsuite)
         write(unit, fmt) "-", testsuite(ii)%name
      end do
      stat = -huge(ii)
   end if

end subroutine run_selected


!> Run a selected unit test
subroutine run_unittest(test, unit, stat)

   !> Unit test
   type(unittest_type), intent(in) :: test

   !> Unit for IO
   integer, intent(in) :: unit

   !> Number of failed tests
   integer, intent(inout) :: stat

   type(error_type), allocatable :: error

   call test%test(error)
   !$omp critical(mctc_env_testsuite)
   if (allocated(error) .neqv. test%should_fail) then
      if (test%should_fail) then
         write(unit, fmt) indent, test%name, "[UNEXPECTED PASS]"
      else
         write(unit, fmt) indent, test%name, "[FAILED]"
      end if
      stat = stat + 1
   else
      if (test%should_fail) then
         write(unit, fmt) indent, test%name, "[EXPECTED FAIL]"
      else
         write(unit, fmt) indent, test%name, "[PASSED]"
      end if
   end if
   if (allocated(error)) then
      write(unit, fmt) "Message:", error%message
   end if
   !$omp end critical(mctc_env_testsuite)

end subroutine run_unittest


!> Select a unit test from all available tests
function select_test(tests, name) result(pos)

   !> Name identifying the test suite
   character(len=*), intent(in) :: name

   !> Available unit tests
   type(unittest_type) :: tests(:)

   !> Selected test suite
   integer :: pos

   integer :: it

   pos = 0
   do it = 1, size(tests)
      if (name == tests(it)%name) then
         pos = it
         exit
      end if
   end do

end function select_test


!> Select a test suite from all available suites
function select_suite(suites, name) result(pos)

   !> Name identifying the test suite
   character(len=*), intent(in) :: name

   !> Available test suites
   type(testsuite_type) :: suites(:)

   !> Selected test suite
   integer :: pos

   integer :: it

   pos = 0
   do it = 1, size(suites)
      if (name == suites(it)%name) then
         pos = it
         exit
      end if
   end do

end function select_suite


!> Register a new unit test
function new_unittest(name, test, should_fail) result(self)

   !> Name of the test
   character(len=*), intent(in) :: name

   !> Entry point for the test
   procedure(test_interface) :: test

   !> Whether test is supposed to error or not
   logical, intent(in), optional :: should_fail

   !> Newly registered test
   type(unittest_type) :: self

   self%name = name
   self%test => test
   if (present(should_fail)) self%should_fail = should_fail

end function new_unittest


!> Register a new testsuite
function new_testsuite(name, collect) result(self)

   !> Name of the testsuite
   character(len=*), intent(in) :: name

   !> Entry point to collect tests
   procedure(collect_interface) :: collect

   !> Newly registered testsuite
   type(testsuite_type) :: self

   self%name = name
   self%collect => collect

end function new_testsuite


subroutine check_stat(error, stat, message, more)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Status of operation
   integer, intent(in) :: stat

   !> A detailed message describing the error
   character(len=*), intent(in), optional :: message

   !> Another line of error message
   character(len=*), intent(in), optional :: more

   if (stat /= mctc_stat%success) then
      if (present(message)) then
         call test_failed(error, message, more)
      else
         call test_failed(error, "Non-zero exit code encountered", more)
      end if
   end if

end subroutine check_stat


subroutine check_logical(error, expression, message, more)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Result of logical operator
   logical, intent(in) :: expression

   !> A detailed message describing the error
   character(len=*), intent(in), optional :: message

   !> Another line of error message
   character(len=*), intent(in), optional :: more

   if (.not.expression) then
      if (present(message)) then
         call test_failed(error, message, more)
      else
         call test_failed(error, "Condition not fullfilled", more)
      end if
   end if

end subroutine check_logical


subroutine check_float_dp(error, actual, expected, message, more, thr, rel)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Found floating point value
   real(dp), intent(in) :: actual

   !> Expected floating point value
   real(dp), intent(in) :: expected

   !> A detailed message describing the error
   character(len=*), intent(in), optional :: message

   !> Another line of error message
   character(len=*), intent(in), optional :: more

   !> Allowed threshold for matching floating point values
   real(dp), intent(in), optional :: thr

   !> Check for relative errors instead
   logical, intent(in), optional :: rel

   logical :: relative
   real(dp) :: diff, threshold

   if (present(thr)) then
      threshold = thr
   else
      threshold = epsilon(expected)
   end if

   if (present(rel)) then
      relative = rel
   else
      relative = .false.
   end if

   if (relative) then
      diff = abs(actual - expected) / expected
   else
      diff = abs(actual - expected)
   end if

   if (diff > threshold) then
      if (present(message)) then
         call test_failed(error, message, more)
      else
         call test_failed(error, "Floating point value missmatch", more)
      end if
   end if

end subroutine check_float_dp


subroutine check_float_sp(error, actual, expected, message, more, thr, rel)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Found floating point value
   real(sp), intent(in) :: actual

   !> Expected floating point value
   real(sp), intent(in) :: expected

   !> A detailed message describing the error
   character(len=*), intent(in), optional :: message

   !> Another line of error message
   character(len=*), intent(in), optional :: more

   !> Allowed threshold for matching floating point values
   real(sp), intent(in), optional :: thr

   !> Check for relative errors instead
   logical, intent(in), optional :: rel

   logical :: relative
   real(sp) :: diff, threshold

   if (present(thr)) then
      threshold = thr
   else
      threshold = epsilon(expected)
   end if

   if (present(rel)) then
      relative = rel
   else
      relative = .false.
   end if

   if (relative) then
      diff = abs(actual - expected) / expected
   else
      diff = abs(actual - expected)
   end if

   if (diff > threshold) then
      if (present(message)) then
         call test_failed(error, message, more)
      else
         call test_failed(error, "Floating point value missmatch", more)
      end if
   end if

end subroutine check_float_sp


subroutine check_int_i1(error, actual, expected, message, more)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Found integer value
   integer(i1), intent(in) :: actual

   !> Expected integer value
   integer(i1), intent(in) :: expected

   !> A detailed message describing the error
   character(len=*), intent(in), optional :: message

   !> Another line of error message
   character(len=*), intent(in), optional :: more

   if (expected /= actual) then
      if (present(message)) then
         call test_failed(error, message, more)
      else
         call test_failed(error, "Integer value missmatch", more)
      end if
   end if

end subroutine check_int_i1


subroutine check_int_i2(error, actual, expected, message, more)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Found integer value
   integer(i2), intent(in) :: actual

   !> Expected integer value
   integer(i2), intent(in) :: expected

   !> A detailed message describing the error
   character(len=*), intent(in), optional :: message

   !> Another line of error message
   character(len=*), intent(in), optional :: more

   if (expected /= actual) then
      if (present(message)) then
         call test_failed(error, message, more)
      else
         call test_failed(error, "Integer value missmatch", more)
      end if
   end if

end subroutine check_int_i2


subroutine check_int_i4(error, actual, expected, message, more)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Found integer value
   integer(i4), intent(in) :: actual

   !> Expected integer value
   integer(i4), intent(in) :: expected

   !> A detailed message describing the error
   character(len=*), intent(in), optional :: message

   !> Another line of error message
   character(len=*), intent(in), optional :: more

   if (expected /= actual) then
      if (present(message)) then
         call test_failed(error, message, more)
      else
         call test_failed(error, "Integer value missmatch", more)
      end if
   end if

end subroutine check_int_i4


subroutine check_int_i8(error, actual, expected, message, more)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Found integer value
   integer(i8), intent(in) :: actual

   !> Expected integer value
   integer(i8), intent(in) :: expected

   !> A detailed message describing the error
   character(len=*), intent(in), optional :: message

   !> Another line of error message
   character(len=*), intent(in), optional :: more

   if (expected /= actual) then
      if (present(message)) then
         call test_failed(error, message, more)
      else
         call test_failed(error, "Integer value missmatch", more)
      end if
   end if

end subroutine check_int_i8


subroutine check_bool(error, actual, expected, message, more)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Found boolean value
   logical, intent(in) :: actual

   !> Expected boolean value
   logical, intent(in) :: expected

   !> A detailed message describing the error
   character(len=*), intent(in), optional :: message

   !> Another line of error message
   character(len=*), intent(in), optional :: more

   if (expected .neqv. actual) then
      if (present(message)) then
         call test_failed(error, message, more)
      else
         call test_failed(error, "Logical value missmatch", more)
      end if
   end if

end subroutine check_bool


subroutine check_string(error, actual, expected, message, more)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Found boolean value
   character(len=*), intent(in) :: actual

   !> Expected boolean value
   character(len=*), intent(in) :: expected

   !> A detailed message describing the error
   character(len=*), intent(in), optional :: message

   !> Another line of error message
   character(len=*), intent(in), optional :: more

   if (expected /= actual) then
      if (present(message)) then
         call test_failed(error, message, more)
      else
         call test_failed(error, "Character value missmatch", more)
      end if
   end if

end subroutine check_string


subroutine test_failed(error, message, more)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> A detailed message describing the error
   character(len=*), intent(in) :: message

   !> Another line of error message
   character(len=*), intent(in), optional :: more

   allocate(error)
   error%stat = mctc_stat%fatal

   if (present(more)) then
      error%message = message // new_line('a') // more
   else
      error%message = message
   end if

end subroutine test_failed


end module mctc_env_testing

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/scf/diag.f90
!> Provides a base class for defining diagonalization based electronic solvers

!> Declaration of the abstract base class for electronic solvers based on diagonalization
module tblite_scf_diag
   use mctc_env, only : sp, dp, wp, error_type
   use tblite_blas, only : gemm
   use tblite_scf_solver, only : solver_type
   use tblite_wavefunction_fermi, only : get_fermi_filling
   implicit none
   private

   !> Abstract base class for electronic solvers
   type, public, abstract, extends(solver_type) :: diag_solver_type
   contains
      generic :: solve => solve_sp, solve_dp
      procedure(solve_sp), deferred :: solve_sp
      procedure(solve_dp), deferred :: solve_dp
      procedure :: get_density
      procedure :: get_wdensity
      procedure :: delete
   end type diag_solver_type

   abstract interface
      subroutine solve_sp(self, hmat, smat, eval, error)
         import :: diag_solver_type, error_type, sp
         class(diag_solver_type), intent(inout) :: self
         real(sp), contiguous, intent(inout) :: hmat(:, :)
         real(sp), contiguous, intent(in) :: smat(:, :)
         real(sp), contiguous, intent(inout) :: eval(:)
         type(error_type), allocatable, intent(out) :: error
      end subroutine solve_sp
      subroutine solve_dp(self, hmat, smat, eval, error)
         import :: diag_solver_type, error_type, dp
         class(diag_solver_type), intent(inout) :: self
         real(dp), contiguous, intent(inout) :: hmat(:, :)
         real(dp), contiguous, intent(in) :: smat(:, :)
         real(dp), contiguous, intent(inout) :: eval(:)
         type(error_type), allocatable, intent(out) :: error
      end subroutine solve_dp
   end interface


contains

subroutine get_density(self, hmat, smat, eval, focc, density, error)
   !> Solver for the general eigenvalue problem
   class(diag_solver_type), intent(inout) :: self
   !> Overlap matrix
   real(wp), contiguous, intent(in) :: smat(:, :)
   !> Hamiltonian matrix, contains eigenvectors on output
   real(wp), contiguous, intent(inout) :: hmat(:, :, :)
   !> Eigenvalues
   real(wp), contiguous, intent(inout) :: eval(:, :)
   !> Occupation numbers
   real(wp), contiguous, intent(inout) :: focc(:, :)
   !> Density matrix
   real(wp), contiguous, intent(inout) :: density(:, :, :)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp) :: e_fermi
   integer :: nspin, spin, homo

   nspin = min(size(eval, 2), size(hmat, 3), size(density, 3))

   select case(nspin)
   case default
      call self%solve(hmat(:, :, 1), smat, eval(:, 1), error)
      if (allocated(error)) return

      focc(:, :) = 0.0_wp
      do spin = 1, 2
         call get_fermi_filling(self%nel(spin), self%kt, eval(:, 1), &
            & homo, focc(:, spin), e_fermi)
      end do

      focc(:, 1) = focc(:, 1) + focc(:, 2)
      call get_density_matrix(focc(:, 1), hmat(:, :, 1), density(:, :, 1))
      focc(:, 1) = focc(:, 1) - focc(:, 2)
   case(2)
      hmat(:, :, :) = 2*hmat
      do spin = 1, 2
         call self%solve(hmat(:, :, spin), smat, eval(:, spin), error)
         if (allocated(error)) return

         call get_fermi_filling(self%nel(spin), self%kt, eval(:, spin), &
            & homo, focc(:, spin), e_fermi)
         call get_density_matrix(focc(:, spin), hmat(:, :, spin), density(:, :, spin))
      end do
   end select
end subroutine get_density

subroutine get_wdensity(self, hmat, smat, eval, focc, density, error)
   !> Solver for the general eigenvalue problem
   class(diag_solver_type), intent(inout) :: self
   !> Overlap matrix
   real(wp), contiguous, intent(in) :: smat(:, :)
   !> Hamiltonian matrix containing eigenvectors from SCF
   real(wp), contiguous, intent(inout) :: hmat(:, :, :)
   !> Eigenvalues
   real(wp), contiguous, intent(inout) :: eval(:, :)
   !> Occupation numbers
   real(wp), contiguous, intent(inout) :: focc(:, :)
   !> Density matrix
   real(wp), contiguous, intent(inout) :: density(:, :, :)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: spin, nspin
   real(wp), allocatable :: tmp(:)

   nspin = min(size(eval, 2), size(hmat, 3), size(density, 3))

   if (nspin == 1 .and. size(focc, 2) == 2) then
      focc(:, 1) = focc(:, 1) + focc(:, 2)
   end if

   do spin = 1, nspin
      tmp = focc(:, spin) * eval(:, spin)
      call get_density_matrix(tmp, hmat(:, :, spin), density(:, :, spin))
   end do

   if (nspin == 1 .and. size(focc, 2) == 2) then
      focc(:, 1) = focc(:, 1) - focc(:, 2)
   end if
end subroutine get_wdensity

!> Get the density matrix from the coefficients and occupation numbers
subroutine get_density_matrix(focc, coeff, pmat)
   !> Occupation numbers
   real(wp), intent(in) :: focc(:)
   !> Coefficients of the wavefunction
   real(wp), contiguous, intent(in) :: coeff(:, :)
   !> Density matrix to be computed
   real(wp), contiguous, intent(out) :: pmat(:, :)

   real(wp), allocatable :: scratch(:, :)
   integer :: iao, jao

   allocate(scratch(size(pmat, 1), size(pmat, 2)))
   !$omp parallel do collapse(2) default(none) schedule(runtime) &
   !$omp shared(scratch, coeff, focc, pmat) private(iao, jao)
   do iao = 1, size(pmat, 1)
      do jao = 1, size(pmat, 2)
         scratch(jao, iao) = coeff(jao, iao) * focc(iao)
      end do
   end do
   call gemm(scratch, coeff, pmat, transb='t')
end subroutine get_density_matrix

!> Delete the solver instance
subroutine delete(self)
   !> Solver for the general eigenvalue problem
   class(diag_solver_type), intent(inout) :: self

   ! No specific resources to free in this base class
end subroutine delete

end module tblite_scf_diag

! This file is part of multicharge.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module multicharge_wignerseitz
   use mctc_env, only: wp
   use mctc_io, only: structure_type
   use mctc_cutoff, only: get_lattice_points
   implicit none
   private

   public :: wignerseitz_cell_type, new_wignerseitz_cell

   type :: wignerseitz_cell_type
      integer :: nimg_max
      integer, allocatable :: nimg(:, :)
      integer, allocatable :: tridx(:, :, :)
      real(wp), allocatable :: trans(:, :)
   end type wignerseitz_cell_type

   !> Small cutoff threshold to create only closest cells
   real(wp), parameter :: thr = sqrt(epsilon(0.0_wp))

   !> Tolerance to consider equivalent images
   real(wp), parameter :: tol = 0.01_wp

contains

subroutine new_wignerseitz_cell(self, mol)

   !> Wigner-Seitz cell instance
   type(wignerseitz_cell_type), intent(out) :: self

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   integer :: iat, jat, ntr, nimg
   integer, allocatable :: tridx(:)
   real(wp) :: vec(3)
   real(wp), allocatable :: trans(:, :)

   call get_lattice_points(mol%periodic, mol%lattice, thr, trans)
   ntr = size(trans, 2)
   allocate(self%nimg(mol%nat, mol%nat), self%tridx(ntr, mol%nat, mol%nat), &
      & tridx(ntr))

   self%nimg_max = 0
   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(mol, trans, self) private(iat, jat, vec, nimg, tridx)
   do iat = 1, mol%nat
      do jat = 1, mol%nat
         vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat)
         call get_pairs(nimg, trans, vec, tridx)
         self%nimg(jat, iat) = nimg
         self%tridx(:, jat, iat) = tridx
         self%nimg_max = max(nimg, self%nimg_max)
      end do
   end do

   call move_alloc(trans, self%trans)

end subroutine new_wignerseitz_cell

subroutine get_pairs(iws, trans, rij, list)
   integer, intent(out) :: iws
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: trans(:, :)
   integer, intent(out) :: list(:)

   logical :: mask(size(list))
   real(wp) :: dist(size(list)), vec(3), r2
   integer :: itr, img, pos

   iws = 0
   img = 0
   list(:) = 0
   mask(:) = .true.

   do itr = 1, size(trans, 2)
      vec(:) = rij - trans(:, itr)
      r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
      if (r2 < thr) cycle
      img = img + 1
      dist(img) = r2
   end do

   if (img == 0) return

   pos = minloc(dist(:img), dim=1)

   r2 = dist(pos)
   mask(pos) = .false.

   iws = 1
   list(iws) = pos
   if (img <= iws) return

   do
      pos = minloc(dist(:img), dim=1, mask=mask(:img))
      if (abs(dist(pos) - r2) > tol) exit
      mask(pos) = .false.
      iws = iws + 1
      list(iws) = pos
   end do

end subroutine get_pairs

end module multicharge_wignerseitz

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Provides tokenization for TOML documents.
!>
!> The lexer provides a way to turn a stream of characters into tokens which
!> are further processed by the parser and turned into actual TOML data structures.
!> In the current structure no knowledge about the character stream is required
!> in the parser to generate the data structures.
!>
!> The validity of all tokens can be guaranteed by the lexer, however syntax errors
!> and semantic errors are not detected until the parser is run. Identification of
!> invalid tokens and recovery of the tokenization is done on a best effort basis.
!>
!> To avoid overflows in the parser due to deeply nested but unclosed groups, the
!> lexer will always tokenize a complete group to verify it is closed properly.
!> Unclosed groups will lead to the first token of the group getting invalidated,
!> to allow reporting in the parsing phase.
module tomlf_de_lexer
   use tomlf_constants, only : tfc, tfi, tfr, TOML_BACKSPACE, TOML_TABULATOR, TOML_NEWLINE, &
      & TOML_CARRIAGE_RETURN, TOML_FORMFEED, TOML_ESC
   use tomlf_datetime, only : toml_datetime, toml_date, toml_time
   use tomlf_de_abc, only : abstract_lexer
   use tomlf_de_context, only : toml_context
   use tomlf_de_token, only : toml_token, stringify, token_kind, resize
   use tomlf_error, only : toml_error, toml_stat, make_error
   use tomlf_utils, only : read_whole_file, read_whole_line
   implicit none
   private

   public :: toml_lexer, new_lexer_from_file, new_lexer_from_unit, new_lexer_from_string
   public :: toml_token, stringify, token_kind


   !> Possible characters encountered in a lexeme
   type :: enum_char
      character(1, tfc) :: space = tfc_" "
      character(1, tfc) :: hash = tfc_"#"
      character(1, tfc) :: squote = tfc_"'"
      character(3, tfc) :: squote3 = repeat(tfc_"'", 3)
      character(1, tfc) :: dquote = tfc_""""
      character(3, tfc) :: dquote3 = repeat(tfc_"""", 3)
      character(1, tfc) :: backslash = tfc_"\"
      character(1, tfc) :: dot = tfc_"."
      character(1, tfc) :: comma = tfc_","
      character(1, tfc) :: equal = tfc_"="
      character(1, tfc) :: lbrace = tfc_"{"
      character(1, tfc) :: rbrace = tfc_"}"
      character(1, tfc) :: lbracket = tfc_"["
      character(1, tfc) :: rbracket = tfc_"]"
      character(1, tfc) :: newline = achar(10, kind=tfc)
      character(1, tfc) :: formfeed = achar(12, kind=tfc)
      character(1, tfc) :: carriage_return = achar(13, kind=tfc)
      character(1, tfc) :: bspace = achar(8, kind=tfc)
      character(1, tfc) :: tab = achar(9, kind=tfc)
      character(1, tfc) :: plus = tfc_"+"
      character(1, tfc) :: minus = tfc_"-"
      character(12, tfc) :: literal = tfc_"0123456789-_"
   end type enum_char

   !> Actual enumerator for possible characters
   type(enum_char), parameter :: char_kind = enum_char()

   !> Set of characters marking a terminated lexeme, mainly used for values and to
   !> obtain boundaries of invalid tokens.
   character(*, tfc), parameter :: terminated = &
      & char_kind%space//char_kind%tab//char_kind%newline//char_kind%carriage_return//&
      & char_kind%hash//char_kind%rbrace//char_kind%rbracket//char_kind%comma//&
      & char_kind%equal

   !> Scopes to identify the state of the lexer.
   type :: enum_scope
      !> Table scopes allow keypaths, in this scenario only bare keys, strings and
      !> literals are allowed, furthermore dots become special characters to separate
      !> the keypaths.
      integer :: table = 1
      !> Terminates a table scope and opens a value scope. Here usual values, like integer,
      !> floats or strings are allowed.
      integer :: equal = 2
      !> Opens an array scope, similar to the value scope for allowed characters but with
      !> simplified closing rules to allow handling of values and inline tables in arrays.
      integer :: array = 3
   end type enum_scope

   !> Actual enumerator for auxiliary scopes
   type(enum_scope), parameter :: lexer_scope = enum_scope()

   !> Item identifying the scope and the corresponding token index
   type :: stack_item
      !> Current scope of the item, can only be removed with matching scope
      integer :: scope
      !> Token index in the buffer of the lexer, used for invalidation of unclosed groups
      integer :: token
   end type stack_item

   !> Reallocate the stack of scopes
   interface resize
      module procedure :: resize_scope
   end interface


   !> Tokenizer for TOML documents.
   type, extends(abstract_lexer) :: toml_lexer
      !> Name of the source file, used for error reporting
      character(len=:), allocatable :: filename
      !> Current internal position in the source chunk
      integer :: pos = 0
      !> Current source chunk, for convenience stored as character array rather than string
      character(:, tfc), allocatable :: chunk
      !> Last scope of the lexer
      integer :: top = 0
      !> Stack of scopes, used to identify the current state of the lexer
      type(stack_item), allocatable :: stack(:)
      !> Index in the buffer queue
      integer :: buffer = 0
      !> Douple-ended queue for buffering tokens
      type(toml_context) :: context
   contains
      !> Obtain the next token
      procedure :: next
      !> Extract a string from a token
      procedure :: extract_string
      !> Extract an integer from a token
      procedure :: extract_integer
      !> Extract a float from a token
      procedure :: extract_float
      !> Extract a boolean from a token
      procedure :: extract_bool
      !> Extract a timestamp from a token
      procedure :: extract_datetime
      !> Get information about source
      procedure :: get_info
   end type toml_lexer

contains

!> Create a new instance of a lexer by reading from a file
subroutine new_lexer_from_file(lexer, filename, error)
   !> Instance of the lexer
   type(toml_lexer), intent(out) :: lexer
   !> Name of the file to read from
   character(len=*), intent(in) :: filename
   !> Error code
   type(toml_error), allocatable, intent(out) :: error

   integer :: stat

   lexer%pos = 0
   lexer%filename = filename
   call resize(lexer%stack)
   call read_whole_file(filename, lexer%chunk, stat)

   if (stat /= 0) then
      call make_error(error, "Could not open file '"//filename//"'")
   end if
end subroutine new_lexer_from_file

!> Create a new instance of a lexer by reading from a unit.
!>
!> Currently, only sequential access units can be processed by this constructor.
subroutine new_lexer_from_unit(lexer, io, error)
   !> Instance of the lexer
   type(toml_lexer), intent(out) :: lexer
   !> Unit to read from
   integer, intent(in) :: io
   !> Error code
   type(toml_error), allocatable, intent(out) :: error

   character(:, tfc), allocatable :: source, line
   integer, parameter :: bufsize = 512
   character(bufsize, tfc) :: filename, mode
   integer :: stat

   inquire(unit=io, access=mode, name=filename)
   select case(trim(mode))
   case default
      stat = 1

   case("sequential", "SEQUENTIAL")
      allocate(character(0) :: source)
      do 
         call read_whole_line(io, line, stat)
         if (stat > 0) exit
         source = source // line // TOML_NEWLINE
         if (stat < 0) then
            if (is_iostat_end(stat)) stat = 0
            exit
         end if
      end do
      call new_lexer_from_string(lexer, source)
   end select
   if (len_trim(filename) > 0) lexer%filename = trim(filename)

   if (stat /= 0) then
      call make_error(error, "Failed to read from unit")
   end if
end subroutine new_lexer_from_unit

!> Create a new instance of a lexer by reading from a string.
subroutine new_lexer_from_string(lexer, string)
   !> Instance of the lexer
   type(toml_lexer), intent(out) :: lexer
   !> String to read from
   character(*, tfc), intent(in) :: string

   integer :: length

   length = len(string)
   lexer%pos = 0
   lexer%buffer = 0
   allocate(character(length) :: lexer%chunk)
   lexer%chunk(:length) = string
   call resize(lexer%stack)
end subroutine new_lexer_from_string


!> Advance the lexer to the next token.
subroutine next(lexer, token)
   !> Instance of the lexer
   class(toml_lexer), intent(inout) :: lexer
   !> Current lexeme
   type(toml_token), intent(inout) :: token

   if (lexer%buffer >= lexer%context%top) then
      call fill_buffer(lexer)
   end if

   lexer%buffer = lexer%buffer + 1
   token = lexer%context%token(lexer%buffer)
end subroutine next

!> Fill the buffer with tokens, this routine will attempt to create as many tokens as
!> necessary to determine whether all opened groups are closed properly.
!>
!> The state of the buffer can be changed while this routine is running, therefore
!> accessing the buffer concurrently is not allowed.
subroutine fill_buffer(lexer)
   !> Instance of the lexer
   class(toml_lexer), intent(inout) :: lexer

   type(toml_token) :: token
   integer :: stack_top, it

   lexer%buffer = 0
   lexer%context%top = 0
   stack_top = lexer%top

   ! Tokenization will cover always a complete scope
   do while(lexer%top >= stack_top .and. token%kind /= token_kind%eof)
      call next_token(lexer, token)
      call lexer%context%push_back(token)
   end do

   ! Flag all incomplete inline table and array scopes for the parser
   if (lexer%top > stack_top) then
      do it = lexer%top, stack_top + 1, -1
         select case(lexer%stack(it)%scope)
         case(lexer_scope%table, lexer_scope%array)
            lexer%context%token(lexer%stack(it)%token)%kind = token_kind%unclosed
         end select
      end do
   end if
end subroutine fill_buffer

!> Actually generate the next token, unbuffered version
subroutine next_token(lexer, token)
   !> Instance of the lexer
   class(toml_lexer), intent(inout) :: lexer
   !> Current lexeme
   type(toml_token), intent(inout) :: token

   integer :: prev, pos

   ! Consume current token
   lexer%pos = lexer%pos + token%last - token%first + 1
   prev = lexer%pos
   pos = lexer%pos

   ! If lexer is exhausted, return EOF as early as possible
   if (pos > len(lexer%chunk)) then
      call pop(lexer, lexer_scope%equal)
      token = toml_token(token_kind%eof, prev, pos)
      return
   end if

   select case(peek(lexer, pos))
   case(char_kind%hash)
      do while(all(peek(lexer, pos+1) /= [char_kind%carriage_return, char_kind%newline]) &
            & .and. pos <= len(lexer%chunk))
         pos = pos + 1
      end do
      token = toml_token(token_kind%comment, prev, pos)

   case(char_kind%space, char_kind%tab)
      do while(any(match(lexer, pos+1, [char_kind%space, char_kind%tab])) &
            & .and. pos <= len(lexer%chunk))
         pos = pos + 1
      end do
      token = toml_token(token_kind%whitespace, prev, pos)

   case(char_kind%newline)
      call pop(lexer, lexer_scope%equal)
      token = toml_token(token_kind%newline, prev, pos)

   case(char_kind%carriage_return)
      if (match(lexer, pos+1, char_kind%newline)) then
         pos = pos + 1
         call pop(lexer, lexer_scope%equal)
         token = toml_token(token_kind%newline, prev, pos)
      else
         token = toml_token(token_kind%invalid, prev, pos)
      end if

   case(char_kind%dot)
      if (view_scope(lexer) == lexer_scope%table) then
         token = toml_token(token_kind%dot, prev, pos)
      else
         token = toml_token(token_kind%invalid, prev, pos)
      end if

   case(char_kind%comma)
      call pop(lexer, lexer_scope%equal)
      token = toml_token(token_kind%comma, prev, pos)

   case(char_kind%equal)
      token = toml_token(token_kind%equal, prev, pos)
      call push_back(lexer, lexer_scope%equal, lexer%context%top + 1)

   case(char_kind%lbrace)
      token = toml_token(token_kind%lbrace, prev, pos)
      call push_back(lexer, lexer_scope%table, lexer%context%top + 1)

   case(char_kind%rbrace)
      call pop(lexer, lexer_scope%equal)
      call pop(lexer, lexer_scope%table)
      token = toml_token(token_kind%rbrace, prev, pos)

   case(char_kind%lbracket)
      token = toml_token(token_kind%lbracket, prev, pos)
      if (any(view_scope(lexer) == [lexer_scope%equal, lexer_scope%array])) then
         call push_back(lexer, lexer_scope%array, lexer%context%top + 1)
      end if

   case(char_kind%rbracket)
      call pop(lexer, lexer_scope%array)
      token = toml_token(token_kind%rbracket, prev, pos)

   case(char_kind%squote)
      call next_sstring(lexer, token)

   case(char_kind%dquote)
      call next_dstring(lexer, token)

   case default
      if (view_scope(lexer) == lexer_scope%table) then
         call next_keypath(lexer, token)
      else
         call next_literal(lexer, token)
      end if

   end select
end subroutine next_token

!> Process next literal string token, can produce normal literals and multiline literals
subroutine next_sstring(lexer, token)
   !> Instance of the lexer
   type(toml_lexer), intent(inout) :: lexer
   !> Current lexeme
   type(toml_token), intent(inout) :: token

   character(1, tfc) :: ch
   integer :: prev, pos, it
   logical :: valid

   prev = lexer%pos
   pos = lexer%pos

   if (all(match(lexer, [pos+1, pos+2], char_kind%squote))) then
      pos = pos + 3

      pos = strstr(lexer%chunk(pos:), char_kind%squote3) + pos - 1
      if (pos < prev + 3) then
         token = toml_token(token_kind%invalid, prev, len(lexer%chunk))
         return
      end if

      do it = 1, 2
         if (match(lexer, pos+3, char_kind%squote)) pos = pos + 1
      end do

      valid = .true.
      do it = prev + 3, pos - 1
         ch = peek(lexer, it)
         valid = valid .and. valid_string(ch)
      end do

      token = toml_token(merge(token_kind%mliteral, token_kind%invalid, valid), prev, pos+2)
      return
   end if

   valid = .true.

   do while(pos < len(lexer%chunk))
      pos = pos + 1
      ch = peek(lexer, pos)
      valid = valid .and. valid_string(ch)
      if (ch == char_kind%squote) exit
      if (ch == char_kind%newline) then
         pos = pos - 1
         valid = .false.
         exit
      end if
   end do

   valid = valid .and. peek(lexer, pos) == char_kind%squote .and. pos /= prev
   token = toml_token(merge(token_kind%literal, token_kind%invalid, valid), prev, pos)
end subroutine next_sstring

!> Process next string token, can produce normal string and multiline string tokens
subroutine next_dstring(lexer, token)
   !> Instance of the lexer
   type(toml_lexer), intent(inout) :: lexer
   !> Current lexeme
   type(toml_token), intent(inout) :: token

   character(1, tfc) :: ch
   character(*, tfc), parameter :: hexnum = "0123456789abcdefABCDEF", valid_escape = "betnfr\"""
   integer :: prev, pos, expect, it, hex
   logical :: escape, valid, space

   prev = lexer%pos
   pos = lexer%pos
   hex = 0

   if (all(match(lexer, [pos+1, pos+2], char_kind%dquote))) then
      pos = pos + 3

      do
         it = strstr(lexer%chunk(pos:), char_kind%dquote3)
         pos = it + pos - 1
         if (pos < prev + 3 .or. it == 0) then
            token = toml_token(token_kind%invalid, prev, len(lexer%chunk))
            return
         end if

         if (match(lexer, pos-1, char_kind%backslash)) then
            pos = pos + 1
            cycle
         end if

         do it = 1, 2
            if (match(lexer, pos+3, char_kind%dquote)) pos = pos + 1
         end do
         exit
      end do

      valid = .true.
      escape = .false.
      space = .false.
      expect = 0

      do it = prev + 3, pos - 1
         ch = peek(lexer, it)
         if (escape) then
            space = verify(ch, char_kind%space//char_kind%tab//&
               & char_kind%carriage_return//char_kind%newline) == 0
         end if
         if (space) then
            escape = .false.
            if (ch == char_kind%newline) then
               if (expect > 0) expect = expect - 1
               space = .false.
               cycle
            end if
            if (verify(ch, char_kind%space//char_kind%tab) == 0 .and. expect == 0) cycle
            if (ch == char_kind%carriage_return) then
               expect = 1
               cycle
            end if
            valid = .false.
            space = .false.
            expect = 0
            cycle
         end if
         valid = valid .and. valid_string(ch)
         if (escape) then
            escape = .false.
            space = .false.
            if (verify(ch, valid_escape) == 0) cycle
            if (ch == "x") then
               expect = 2
               hex = it + 1
               cycle
            end if
            if (ch == "u") then
               expect = 4
               hex = it + 1
               cycle
            end if
            if (ch == "U") then
               expect = 8
               hex = it + 1
               cycle
            end if
            valid = .false.
            cycle
         end if
         if (expect > 0) then
            expect = expect - 1
            valid = valid .and. verify(ch, hexnum) == 0
            if (expect == 0) valid = valid .and. verify_ucs(lexer%chunk(hex:pos))
            cycle
         end if
         escape = ch == char_kind%backslash
      end do

      ! Check for any unfinished escape sequences
      valid = valid .and. expect == 0 .and. .not.(escape.or.space)

      token = toml_token(merge(token_kind%mstring, token_kind%invalid, valid), prev, pos+2)
      return
   end if

   valid = .true.
   escape = .false.
   expect = 0

   do while(pos < len(lexer%chunk))
      pos = pos + 1
      ch = peek(lexer, pos)
      valid = valid .and. valid_string(ch)
      if (escape) then
         escape = .false.
         if (verify(ch, valid_escape) == 0) cycle
         if (ch == "x") then
            expect = 2
            hex = it + 1
            cycle
         end if
         if (ch == "u") then
            expect = 4
            hex = pos + 1
            cycle
         end if
         if (ch == "U") then
            expect = 8
            hex = pos + 1
            cycle
         end if
         valid = .false.
         cycle
      end if
      if (expect > 0) then
         expect = expect - 1
         valid = valid .and. verify(ch, hexnum) == 0
         if (expect == 0) valid = valid .and. verify_ucs(lexer%chunk(hex:pos))
         cycle
      end if
      escape = ch == char_kind%backslash
      if (ch == char_kind%dquote) exit
      if (ch == char_kind%newline) then
         pos = pos - 1
         valid = .false.
         exit
      end if
   end do

   valid = valid .and. peek(lexer, pos) == char_kind%dquote .and. pos /= prev
   token = toml_token(merge(token_kind%string, token_kind%invalid, valid), prev, pos)
end subroutine next_dstring

!> Validate characters in string, non-printable characters are invalid in this context
pure function valid_string(ch) result(valid)
   character(1, tfc), intent(in) :: ch
   logical :: valid

   character(1, tfc), parameter :: x00 = achar(int(z"00")), x08 = achar(int(z"08")), &
      & x0b = achar(int(z"0b")), x1f = achar(int(z"1f")), x7f = achar(int(z"7f"))

   valid = &
      & .not.(x00 <= ch .and. ch <= x08) .and. &
      & .not.(x0b <= ch .and. ch <= x1f) .and. &
      & ch /= x7f
end function

!> Process next bare key token, produces keypath tokens.
subroutine next_keypath(lexer, token)
   !> Instance of the lexer
   type(toml_lexer), intent(inout) :: lexer
   !> Current lexeme
   type(toml_token), intent(inout) :: token

   logical :: valid
   integer :: prev, pos
   character(1, tfc) :: ch

   prev = lexer%pos
   pos = lexer%pos
   ch = peek(lexer, pos)

   valid = (tfc_"A" <= ch .and. ch <= tfc_"Z") &
      & .or. (tfc_"a" <= ch .and. ch <= tfc_"z") &
      & .or. (verify(ch, char_kind%literal) == 0)
   do while(verify(peek(lexer, pos+1), terminated//char_kind%dot) > 0)
      pos = pos + 1
      ch = peek(lexer, pos)

      if (tfc_"A" <= ch .and. ch <= tfc_"Z") cycle
      if (tfc_"a" <= ch .and. ch <= tfc_"z") cycle
      if (verify(ch, char_kind%literal) == 0) cycle

      valid = .false.
      cycle
   end do

   token = toml_token(merge(token_kind%keypath, token_kind%invalid, valid), prev, pos)
end subroutine next_keypath

!> Identify literal values, produces integer, float, boolean, and datetime tokens.
subroutine next_literal(lexer, token)
   !> Instance of the lexer
   type(toml_lexer), intent(inout) :: lexer
   !> Current lexeme
   type(toml_token), intent(inout) :: token

   integer :: prev, pos
   integer, parameter :: offset(*) = [0, 1, 2, 3, 4, 5]
   character(1, tfc), parameter :: &
      & true(4) = ["t", "r", "u", "e"], false(5) = ["f", "a", "l", "s", "e"]

   prev = lexer%pos
   pos = lexer%pos

   select case(peek(lexer, pos))
   case("t")
      if (match_all(lexer, pos+offset(:4), true) .and. &
         & verify(peek(lexer, pos+4), terminated) == 0) then
         token = toml_token(token_kind%bool, prev, pos+3)
         return
      end if

   case("f")
      if (match_all(lexer, pos+offset(:5), false) .and. &
         & verify(peek(lexer, pos+5), terminated) == 0) then
         token = toml_token(token_kind%bool, prev, pos+4)
         return
      end if

   case default
      call next_datetime(lexer, token)
      if (token%kind == token_kind%datetime) return

      call next_integer(lexer, token)
      if (token%kind == token_kind%int) return

      call next_float(lexer, token)
      if (token%kind == token_kind%float) return

   end select

   ! If the current token is invalid, advance to the next terminator
   do while(verify(peek(lexer, pos+1), terminated) > 0)
      pos = pos + 1
   end do
   token = toml_token(token_kind%invalid, prev, pos)
end subroutine next_literal

!> Process integer tokens and binary, octal, and hexadecimal literals.
subroutine next_integer(lexer, token)
   !> Instance of the lexer
   type(toml_lexer), intent(inout) :: lexer
   !> Current lexeme
   type(toml_token), intent(inout) :: token

   character(*, tfc), parameter :: toml_base(4) = [&
      & "0123456789abcdefABCDEF", &
      & "0123456789000000000000", &
      & "0123456700000000000000", &
      & "0100000000000000000000"]
   integer, parameter :: b10 = 2, b16 = 1, b8 = 3, b2 = 4

   character(1, tfc) :: ch
   integer :: prev, pos, base
   logical :: underscore, okay

   prev = lexer%pos
   pos = lexer%pos
   okay = .true.
   underscore = .true.
   base = b10

   if (any(match(lexer, pos, ["+", "-"]))) then
      pos = pos + 1
   end if

   if (match(lexer, pos, "0")) then
      select case(peek(lexer, pos+1))
      case("x")
         okay = pos == prev
         base = b16
         pos = pos + 2
      case("o")
         okay = pos == prev
         base = b8
         pos = pos + 2
      case("b")
         okay = pos == prev
         base = b2
         pos = pos + 2
      case(char_kind%space, char_kind%tab, char_kind%newline, char_kind%carriage_return, &
         & char_kind%hash, char_kind%rbrace, char_kind%rbracket, char_kind%comma)
         token = toml_token(token_kind%int, prev, pos)
         return
      case default
         do while(verify(peek(lexer, pos), terminated) > 0)
            pos = pos + 1
         end do
         token = toml_token(token_kind%invalid, prev, pos-1)
         return
      end select
   end if


   do while(pos <= len(lexer%chunk))
      ch = peek(lexer, pos)
      if (ch == "_") then
         if (underscore) then
            token = toml_token(token_kind%invalid, prev, pos)
            return
         end if
         underscore = .true.
         pos = pos + 1
         cycle
      end if

      if (verify(ch, toml_base(base)) == 0) then
         pos = pos + 1
         underscore = .false.
         cycle
      end if

      okay = okay .and. verify(ch, terminated) == 0
      exit
   end do

   okay = .not.underscore .and. okay
   token = toml_token(merge(token_kind%int, token_kind%invalid, okay), prev, pos-1)
end subroutine next_integer

!> Process float tokens.
subroutine next_float(lexer, token)
   !> Instance of the lexer
   type(toml_lexer), intent(inout) :: lexer
   !> Current lexeme
   type(toml_token), intent(inout) :: token

   integer :: prev, pos
   logical :: plus_minus, underscore, point, expo, okay, zero, first
   character(1, tfc) :: ch
   integer, parameter :: offset(*) = [0, 1, 2]
   character(1, tfc), parameter :: nan(3) = ["n", "a", "n"], inf(3) = ["i", "n", "f"]

   prev = lexer%pos
   pos = lexer%pos
   point = .false.
   expo = .false.
   zero = .false.
   first = .true.
   underscore = .true.
   plus_minus = any(match(lexer, pos, ["+", "-"]))
   if (plus_minus) pos = pos + 1

   if (match_all(lexer, pos+offset, nan) .and. &
      & verify(peek(lexer, pos+3), terminated) == 0) then
      token = toml_token(token_kind%float, prev, pos+2)
      return
   end if

   if (match_all(lexer, pos+offset, inf) .and. &
      & verify(peek(lexer, pos+3), terminated) == 0) then
      token = toml_token(token_kind%float, prev, pos+2)
      return
   end if

   do while(pos <= len(lexer%chunk))
      ch = peek(lexer, pos)
      if (ch == "_") then
         if (underscore) then
            token = toml_token(token_kind%invalid, prev, pos)
            return
         end if
         underscore = .true.
         pos = pos + 1
         cycle
      end if

      if (ch == ".") then
         if (point .or. expo .or. underscore) then
            token = toml_token(token_kind%invalid, prev, pos)
            return
         end if
         zero = .false.
         underscore = .true.
         point = .true.
         pos = pos + 1
         cycle
      end if

      if (ch == "e" .or. ch == "E") then
         if (expo .or. underscore) then
            token = toml_token(token_kind%invalid, prev, pos)
            return
         end if
         zero = .false.
         underscore = .true.
         expo = .true.
         pos = pos + 1
         cycle
      end if

      if (ch == "+" .or. ch == "-") then
         if (.not.any(match(lexer, pos-1, ["e", "E"]))) then
            token = toml_token(token_kind%invalid, prev, pos)
            return
         end if
         underscore = .true.
         pos = pos + 1
         cycle
      end if

      if (verify(ch, "0123456789") == 0) then
         if (zero) then
            token = toml_token(token_kind%invalid, prev, pos)
            return
         end if
         zero = first .and. ch == "0"
         first = .false.
         pos = pos + 1
         underscore = .false.
         cycle
      end if

      exit
   end do

   okay = .not.underscore .and. (expo .or. point)
   token = toml_token(merge(token_kind%float, token_kind%invalid, okay), prev, pos-1)
end subroutine next_float

!> Find the next datetime expression
subroutine next_datetime(lexer, token)
   !> Instance of the lexer
   type(toml_lexer), intent(inout) :: lexer
   !> Current lexeme
   type(toml_token), intent(inout) :: token

   logical :: has_date, has_time, has_millisec, has_local, okay, has_seconds
   logical :: has_explicit_time
   integer :: prev, pos, it, time_len
   integer, parameter :: offset(*) = [(it, it = 0, 10)], &
      & offset_date = 10, offset_time = 8, offset_time_no_sec = 5, offset_local = 6
   character(*, tfc), parameter :: num = "0123456789"

   prev = lexer%pos
   pos = lexer%pos

   has_date = valid_date(peek(lexer, pos+offset(:offset_date)))
   has_explicit_time = has_date .and. pos + offset_date + 1 <= len(lexer%chunk) &
      & .and. verify(peek(lexer, pos+offset_date), "Tt ") == 0 &
      & .and. verify(peek(lexer, pos+offset_date + 1), num) == 0
   if (has_explicit_time) then
      pos = pos + offset_date + 1
   end if

   ! Validate a strict TOML time with seconds.
   call valid_time(peek(lexer, pos+offset(:offset_time)), has_time, has_seconds)
   if (has_explicit_time .and. .not.has_time) then
      token = toml_token(token_kind%invalid, prev, prev)
      return
   end if

   if (has_time) then
      time_len = merge(offset_time, offset_time_no_sec, has_seconds)
      pos = pos + time_len - 1
      if (has_seconds .and. match(lexer, pos+1, char_kind%dot)) then
         it = 1
         do while(verify(peek(lexer, pos+it+1), num) == 0)
            it = it + 1
         end do
         has_millisec = it > 1
         if (.not.has_millisec) then
            token = toml_token(token_kind%invalid, prev, prev)
            return
         end if

         pos = pos + it
      end if

      has_local = valid_local(peek(lexer, pos+offset(:offset_local)+1))
      if (has_local) then
         if (.not.has_date) then
            token = toml_token(token_kind%invalid, prev, prev)
            return
         end if
         pos = pos + offset_local
      else if (verify(peek(lexer, pos+1), "zZ") == 0) then
         pos = pos + 1
      end if
   end if

   if (.not.(has_time.or.has_date)) then
      token = toml_token(token_kind%invalid, prev, prev)
      return
   end if

   if (.not.has_time.and.has_date) pos = pos + offset_date - 1
   okay = verify(peek(lexer, pos+1), terminated) == 0 .and. pos <= len(lexer%chunk)
   token = toml_token(merge(token_kind%datetime, token_kind%invalid, okay), prev, pos)
end subroutine next_datetime

!> Validate a string as date
pure function valid_date(string) result(valid)
   !> Input string, 10 characters
   character(1, tfc), intent(in) :: string(:)
   !> Valid date
   logical :: valid

   integer :: it, val
   character(*, tfc), parameter :: num = "0123456789"
   integer :: year, month, day, mday
   logical :: leap

   valid = .false.
   if (any(string([5, 8]) /= "-")) return

   year = 0
   do it = 1, 4
      val = scan(num, string(it)) - 1
      if (val < 0) return
      year = year * 10 + val
   end do

   month = 0
   do it = 6, 7
      val = scan(num, string(it)) - 1
      if (val < 0) return
      month = month * 10 + val
   end do

   day = 0
   do it = 9, 10
      val = scan(num, string(it)) - 1
      if (val < 0) return
      day = day * 10 + val
   end do

   mday = 0
   select case(month)
   case(1, 3, 5, 7, 8, 10, 12)
      mday = 31
   case(2)
      leap = mod(year, 4) == 0 .and. (mod(year, 100) /= 0 .or. mod(year, 400) == 0)
      mday = merge(29, 28, leap)
   case(4, 6, 9, 11)
      mday = 30
   end select
   valid = day >= 1 .and. day <= mday
end function valid_date


!> Validate a string as time (HH:MM[:SS])
subroutine valid_time(string, valid, has_seconds)
   !> Input string, 5 characters (HH:MM) or 8 characters (HH:MM:SS)
   character(1, tfc), intent(in) :: string(:)
   !> Valid time
   logical, intent(out) :: valid
   !> Whether the time has seconds
   logical, intent(out) :: has_seconds

   integer :: it, val
   character(*, tfc), parameter :: num = "0123456789"
   integer :: hour, minute, second

   valid = .false.
   has_seconds = .false.
   if (size(string) < 5 .or. string(3) /= ":") return

   hour = 0
   do it = 1, 2
      val = scan(num, string(it)) - 1
      if (val < 0) return
      hour = hour * 10 + val
   end do

   minute = 0
   do it = 4, 5
      val = scan(num, string(it)) - 1
      if (val < 0) return
      minute = minute * 10 + val
   end do

   if (size(string) >= 8 .and. string(6) == ":") then
      second = 0
      do it = 7, 8
         val = scan(num, string(it)) - 1
         if (val < 0) return
         second = second * 10 + val
      end do
      if (second < 0 .or. second >= 60) return
      has_seconds = .true.
   end if

   valid = minute >= 0 .and. minute < 60 &
      & .and. hour >= 0 .and. hour < 24
end subroutine valid_time


!> Validate a string as timezone
function valid_local(string) result(valid)
   !> Input string, 6 characters
   character(1, tfc), intent(in) :: string(:)
   !> Valid timezone
   logical :: valid

   integer :: it, val
   character(*, tfc), parameter :: num = "0123456789"
   integer :: hour, minute

   valid = .false.
   if (string(4) /= ":" .or. all(string(1) /= ["+", "-"])) return

   hour = 0
   do it = 2, 3
      val = scan(num, string(it)) - 1
      if (val < 0) return
      hour = hour * 10 + val
   end do

   minute = 0
   do it = 5, 6
      val = scan(num, string(it)) - 1
      if (val < 0) return
      minute = minute * 10 + val
   end do

   valid = minute >= 0 .and. minute < 60 &
      & .and. hour >= 0 .and. hour < 24
end function valid_local


!> Show current character
elemental function peek(lexer, pos) result(ch)
   !> Instance of the lexer
   type(toml_lexer), intent(in) :: lexer
   !> Position to fetch character from
   integer, intent(in) :: pos
   !> Character found
   character(1, tfc) :: ch

   if (pos <= len(lexer%chunk)) then
      ch = lexer%chunk(pos:pos)
   else
      ch = char_kind%space
   end if
end function peek

!> Compare a character
elemental function match(lexer, pos, kind)
   !> Instance of the lexer
   type(toml_lexer), intent(in) :: lexer
   !> Position to fetch character from
   integer, intent(in) :: pos
   !> Character to compare against
   character(1, tfc), intent(in) :: kind
   !> Characters match
   logical :: match

   match = peek(lexer, pos) == kind
end function match

!> Compare a set of characters
pure function match_all(lexer, pos, kind) result(match)
   !> Instance of the lexer
   type(toml_lexer), intent(in) :: lexer
   !> Position to fetch character from
   integer, intent(in) :: pos(:)
   !> Character to compare against
   character(1, tfc), intent(in) :: kind(:)
   !> Characters match
   logical :: match

   match = all(peek(lexer, pos) == kind)
end function match_all

pure function strstr(string, pattern) result(res)
   character(*, tfc), intent(in) :: string
   character(*, tfc), intent(in) :: pattern
   integer :: lps_array(len(pattern))
   integer :: res, s_i, p_i, length_string, length_pattern
   res = 0
   length_string = len(string)
   length_pattern = len(pattern)

   if (length_pattern > 0 .and. length_pattern <= length_string) then
      lps_array = compute_lps(pattern)

      s_i = 1
      p_i = 1
      do while(s_i <= length_string)
         if (string(s_i:s_i) == pattern(p_i:p_i)) then
            if (p_i == length_pattern) then
               res = s_i - length_pattern + 1
               exit
            end if
            s_i = s_i + 1
            p_i = p_i + 1
         else if (p_i > 1) then
            p_i = lps_array(p_i - 1) + 1
         else
            s_i = s_i + 1
         end if
      end do
   end if

contains

   pure function compute_lps(string) result(lps_array)
      character(*, tfc), intent(in) :: string
      integer :: lps_array(len(string))
      integer :: i, j, length_string

      length_string = len(string)

      if (length_string > 0) then
         lps_array(1) = 0

         i = 2
         j = 1
         do while (i <= length_string)
            if (string(j:j) == string(i:i)) then
               lps_array(i) = j
               i = i + 1
               j = j + 1
            else if (j > 1) then
               j = lps_array(j - 1) + 1
            else
               lps_array(i) = 0
               i = i + 1
            end if
         end do
      end if

   end function compute_lps

end function strstr

!> Extract string value of token, works for keypath, string, multiline string, literal,
!> and mulitline literal tokens.
subroutine extract_string(lexer, token, string)
   !> Instance of the lexer
   class(toml_lexer), intent(in) :: lexer
   !> Token to extract string value from
   type(toml_token), intent(in) :: token
   !> String value of token
   character(len=:), allocatable, intent(out) :: string

   integer :: it, length, j
   logical :: escape, leading_newline
   character(1, tfc) :: ch
   character(len=:), allocatable :: raw

   length = token%last - token%first + 1

   select case(token%kind)
   case(token_kind%string)
      string = ""
      escape = .false.
      it = token%first + 1
      do while(it <= token%last - 1)
         ch = peek(lexer, it)
         if (escape) then
            escape = .false.
            select case(ch)
            case("""", "\"); string = string // ch
            case("b"); string = string // TOML_BACKSPACE
            case("e"); string = string // TOML_ESC
            case("t"); string = string // TOML_TABULATOR
            case("n"); string = string // TOML_NEWLINE
            case("r"); string = string // TOML_CARRIAGE_RETURN
            case("f"); string = string // TOML_FORMFEED
            case("x"); string = string // convert_ucs(lexer%chunk(it+1:it+2)); it = it + 2
            case("u"); string = string // convert_ucs(lexer%chunk(it+1:it+4)); it = it + 4
            case("U"); string = string // convert_ucs(lexer%chunk(it+1:it+8)); it = it + 8
            case default; string = string // ch
            end select
            it = it + 1
            cycle
         end if
         escape = ch == char_kind%backslash
         if (.not.escape) string = string // ch
         it = it + 1
      end do
   case(token_kind%mstring)
      leading_newline = peek(lexer, token%first+3) == char_kind%newline
      allocate(character(token%last - token%first - merge(5, 4, leading_newline)) :: raw)
      raw = lexer%chunk(token%first + merge(4, 3, leading_newline):token%last - 3)
      string = ""
      escape = .false.
      it = 1
      do while(it <= len(raw))
         ch = raw(it:it)
         if (escape) then
            escape = .false.
            if (any(ch == [char_kind%space, char_kind%tab]) .and. it < len(raw)) then
               j = it
               do while(j <= len(raw) .and. any(raw(j:j) == [char_kind%space, char_kind%tab]))
                  j = j + 1
               end do
               if (j <= len(raw) .and. (raw(j:j) == char_kind%newline .or. raw(j:j) == char_kind%carriage_return)) then
                  ch = raw(j:j)
                  it = j
               end if
            end if
            if (ch == char_kind%newline .or. ch == char_kind%carriage_return) then
               if (ch == char_kind%carriage_return .and. it < len(raw) .and. raw(it+1:it+1) == char_kind%newline) then
                  it = it + 1
               end if
               it = it + 1
               do while(it <= len(raw) .and. any(raw(it:it) == [char_kind%space, char_kind%tab, &
                  & char_kind%newline, char_kind%carriage_return]))
                  if (raw(it:it) == char_kind%carriage_return .and. it < len(raw) .and. raw(it+1:it+1) == char_kind%newline) then
                     it = it + 2
                  else
                     it = it + 1
                  end if
               end do
               cycle
            end if
            select case(ch)
            case("""", "\"); string = string // ch
            case("b"); string = string // TOML_BACKSPACE
            case("e"); string = string // TOML_ESC
            case("t"); string = string // TOML_TABULATOR
            case("n"); string = string // TOML_NEWLINE
            case("r"); string = string // TOML_CARRIAGE_RETURN
            case("f"); string = string // TOML_FORMFEED
            case("x"); string = string // convert_ucs(raw(it+1:it+2)); it = it + 2
            case("u"); string = string // convert_ucs(raw(it+1:it+4)); it = it + 4
            case("U"); string = string // convert_ucs(raw(it+1:it+8)); it = it + 8
            case default; string = string // ch
            end select
            it = it + 1
            cycle
         end if
         escape = ch == char_kind%backslash
         if (.not.escape) string = string // ch
         it = it + 1
      end do
   case(token_kind%literal)
      allocate(character(length - 2)::string)
      string = lexer%chunk(token%first+1:token%last-1)
   case(token_kind%mliteral)
      leading_newline = peek(lexer, token%first+3) == char_kind%newline
      allocate(character(length - merge(7, 6, leading_newline))::string)
      string = lexer%chunk(token%first+merge(4, 3, leading_newline):token%last-3)
   case(token_kind%keypath)
      allocate(character(length)::string)
      string = lexer%chunk(token%first:token%last)
   end select

end subroutine extract_string

!> Extract integer value of token
subroutine extract_integer(lexer, token, val)
   !> Instance of the lexer
   class(toml_lexer), intent(in) :: lexer
   !> Token to extract integer value from
   type(toml_token), intent(in) :: token
   !> Integer value of token
   integer(tfi), intent(out) :: val

   integer :: first, base, it, tmp
   logical :: minus
   character(1, tfc) :: ch
   character(*, tfc), parameter :: num = "0123456789abcdef"

   if (token%kind /= token_kind%int) return

   val = 0
   base = 10
   first = token%first

   if (any(peek(lexer, first) == ["+", "-"])) first = first + 1

   if (peek(lexer, first) == "0") then
      select case(peek(lexer, first + 1))
      case("x")
         first = first + 2
         base = 16
      case("o")
         first = first + 2
         base = 8
      case("b")
         first = first + 2
         base = 2
      case default
         return
      end select
   end if

   minus = match(lexer, token%first, char_kind%minus)

   do it = first, token%last
      ch = peek(lexer, it)
      if ("A" <= ch .and. ch <= "Z") ch = achar(iachar(ch) - iachar("A") + iachar("a"))
      tmp = scan(num(:abs(base)), ch) - 1
      if (tmp < 0) cycle
      val = val * base + merge(-tmp, tmp, minus)
   end do
end subroutine extract_integer

!> Extract floating point value of token
subroutine extract_float(lexer, token, val)
   ! Not useable since unsupported with GFortran on some platforms (MacOS/ppc)
   ! use, intrinsic :: ieee_arithmetic, only : ieee_value, ieee_quite_nan, &
   !    & ieee_positive_inf, ieee_negative_inf
   !> Instance of the lexer
   class(toml_lexer), intent(in) :: lexer
   !> Token to extract floating point value from
   type(toml_token), intent(in) :: token
   !> Floating point value of token
   real(tfr), intent(out) :: val

   integer :: first, it, ic
   character(len=token%last - token%first + 1) :: buffer
   character(1, tfc) :: ch

   if (token%kind /= token_kind%float) return

   first = token%first

   if (any(peek(lexer, first) == ["+", "-"])) first = first + 1

   if (match(lexer, first, "n")) then
      ! val = ieee_value(val, ieee_quite_nan)
      buffer = "NaN"
      read(buffer, *, iostat=ic) val
      return
   end if

   if (match(lexer, first, "i")) then
      ! val = ieee_value(val, ieee_positive_inf)
      buffer = "Inf"
      read(buffer, *, iostat=ic) val
      if (match(lexer, token%first, char_kind%minus)) val = -val
      return
   end if

!   ival = 0
!   idot = 0
!
!   do it = first, token%last
!      ch = peek(lexer, it)
!      if (any(ch == [".", "e", "E"])) exit
!      tmp = scan(num(:base), ch) - 1
!      if (tmp < 0) cycle
!      ival = ival * base + tmp
!   end do
!   first = it
!
!   if (ch == ".") then
!      idot = 0
!      do it = first, token%last
!         ch = peek(lexer, it)
!         if (any(ch == ["e", "E"])) exit
!         tmp = scan(num(:base), ch) - 1
!         if (tmp < 0) cycle
!         idot = idot + 1
!         ival = ival * base + tmp
!      end do
!      first = it
!   end if
!
!   expo = 0
!   if (any(ch == ["e", "E"])) then
!      first = first + 1
!      do it = first, token%last
!         ch = peek(lexer, it)
!         tmp = scan(num(:base), ch) - 1
!         if (tmp < 0) cycle
!         expo = expo * base + tmp
!      end do
!      if (match(lexer, first, char_kind%minus)) expo = -expo
!   end if
!   expo = expo - idot
!   val = ival * 10.0_tfr ** expo  ! FIXME
!
!   if (match(lexer, token%first, char_kind%minus)) val = -val

   ic = 0
   do it = token%first, token%last
      ch = peek(lexer, it)
      if (ch == "_") cycle
      ic = ic + 1
      buffer(ic:ic) = ch
   end do

   read(buffer(:ic), *, iostat=it) val
end subroutine extract_float

!> Extract boolean value of token
subroutine extract_bool(lexer, token, val)
   !> Instance of the lexer
   class(toml_lexer), intent(in) :: lexer
   !> Token to extract boolean value from
   type(toml_token), intent(in) :: token
   !> Boolean value of token
   logical, intent(out) :: val

   if (token%kind /= token_kind%bool) return

   val = peek(lexer, token%first) == "t"
end subroutine extract_bool

!> Extract datetime value of token
subroutine extract_datetime(lexer, token, val)
   !> Instance of the lexer
   class(toml_lexer), intent(in) :: lexer
   !> Token to extract datetime value from
   type(toml_token), intent(in) :: token
   !> Datetime value of token
   type(toml_datetime), intent(out) :: val

   if (token%kind /= token_kind%datetime) return

   val = toml_datetime(lexer%chunk(token%first:token%last))
end subroutine extract_datetime


!> Push a new scope onto the lexer stack and record the token
pure subroutine push_back(lexer, scope, token)
   type(toml_lexer), intent(inout) :: lexer
   integer, intent(in) :: scope
   integer, intent(in) :: token

   lexer%top = lexer%top + 1
   if (lexer%top > size(lexer%stack)) call resize(lexer%stack)
   lexer%stack(lexer%top) = stack_item(scope, token)
end subroutine push_back

!> Pop a scope from the lexer stack in case the topmost scope matches the requested scope
subroutine pop(lexer, scope)
   type(toml_lexer), intent(inout) :: lexer
   integer, intent(in) :: scope

   if (lexer%top > 0) then
      if (lexer%stack(lexer%top)%scope == scope) lexer%top = lexer%top - 1
   end if
end subroutine pop

!> Peek at the topmost scope on the lexer stack
pure function view_scope(lexer) result(scope)
   type(toml_lexer), intent(in) :: lexer
   integer :: scope

   if (lexer%top > 0) then
      scope = lexer%stack(lexer%top)%scope
   else
      scope = lexer_scope%table
   end if
end function view_scope


!> Reallocate list of scopes
pure subroutine resize_scope(var, n)
   !> Instance of the array to be resized
   type(stack_item), allocatable, intent(inout) :: var(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(stack_item), allocatable :: tmp(:)
   integer :: this_size, new_size
   integer, parameter :: initial_size = 8

   if (allocated(var)) then
      this_size = size(var, 1)
      call move_alloc(var, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(var(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(var, 1))
      var(:this_size) = tmp(:this_size)
      deallocate(tmp)
   end if

end subroutine resize_scope


!> Extract information about the source
subroutine get_info(lexer, meta, output)
   !> Instance of the lexer
   class(toml_lexer), intent(in) :: lexer
   !> Query about the source
   character(*, tfc), intent(in) :: meta
   !> Metadata about the source
   character(:, tfc), allocatable, intent(out) :: output

   select case(meta)
   case("source")
      output = lexer%chunk // TOML_NEWLINE
   case("filename")
      if (allocated(lexer%filename)) output = lexer%filename
   end select
end subroutine get_info


function hex_to_int(hex) result(val)
   character(*, tfc), intent(in) :: hex
   integer(tfi) :: val
   integer :: i
   character(1, tfc) :: ch
   character(*, tfc), parameter :: hex_digits = "0123456789abcdef"

   val = 0_tfi
   do i = 1, len(hex)
      ch = hex(i:i)
      if ("A" <= ch .and. ch <= "Z") ch = achar(iachar(ch) - iachar("A") + iachar("a"))
      val = val * 16 + max(index(hex_digits, ch) - 1, 0)
   end do
end function hex_to_int


function verify_ucs(escape) result(valid)
   character(*, tfc), intent(in) :: escape
   logical :: valid
   integer(tfi) :: code

   code = hex_to_int(escape)

   valid = code >= 0_tfi .and. code < int(z"7FFFFFFF", tfi) &
      & .and. (code < int(z"d800", tfi) .or. code > int(z"dfff", tfi)) &
      & .and. (code < int(z"fffe", tfi) .or. code > int(z"ffff", tfi))
end function verify_ucs


function convert_ucs(escape) result(str)
   character(*, tfc), intent(in) :: escape
   character(:, tfc), allocatable :: str
   integer(tfi) :: code

   code = hex_to_int(escape)

   select case(code)
   case(int(z"00000000", tfi):int(z"0000007f", tfi))
      str = achar(code, kind=tfc)
   case(int(z"00000080", tfi):int(z"000007ff", tfi))
      str = &
         achar(ior(int(z"c0", tfi), ishft(code, -6)), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(code, int(z"3f", tfi))), kind=tfc)
   case(int(z"00000800", tfi):int(z"0000ffff", tfi))
      str = &
         achar(ior(int(z"e0", tfi), ishft(code, -12)), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(ishft(code, -6), int(z"3f", tfi))), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(code, int(z"3f", tfi))), kind=tfc)
   case(int(z"00010000", tfi):int(z"001fffff", tfi))
      str = &
         achar(ior(int(z"f0", tfi), ishft(code, -18)), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(ishft(code, -12), int(z"3f", tfi))), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(ishft(code, -6), int(z"3f", tfi))), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(code, int(z"3f", tfi))), kind=tfc)
   case(int(z"00200000", tfi):int(z"03ffffff", tfi))
      str = &
         achar(ior(int(z"f8", tfi), ishft(code, -24)), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(ishft(code, -18), int(z"3f", tfi))), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(ishft(code, -12), int(z"3f", tfi))), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(ishft(code, -6), int(z"3f", tfi))), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(code, int(z"3f", tfi))), kind=tfc)
   case(int(z"04000000", tfi):int(z"7fffffff", tfi))
      str = &
         achar(ior(int(z"fc", tfi), ishft(code, -30)), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(ishft(code, -24), int(z"3f", tfi))), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(ishft(code, -18), int(z"3f", tfi))), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(ishft(code, -12), int(z"3f", tfi))), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(ishft(code, -6), int(z"3f", tfi))), kind=tfc) // &
         achar(ior(int(z"80", tfi), iand(code, int(z"3f", tfi))), kind=tfc)
   end select
end function convert_ucs


end module tomlf_de_lexer

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module test_gcp
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type
   use mstore, only : get_structure
   use dftd3_gcp
   use dftd3_cutoff, only : realspace_cutoff
   use dftd3_output, only : ascii_gcp_param
   implicit none
   private

   public :: collect_gcp

   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp)) * 10


contains


!> Collect all exported unit tests
subroutine collect_gcp(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      ! new_unittest("vmb", test_vmb), &
      & new_unittest("sv", test_sv), &
      & new_unittest("sv(p)", test_sv_p), &
      & new_unittest("svx", test_svx), &
      & new_unittest("svp", test_svp), &
      & new_unittest("minis", test_minis), &
      & new_unittest("minix", test_minix), &
      & new_unittest("631gd", test_631gd), &
      & new_unittest("def2tzvp", test_tz), &
      & new_unittest("def1tzvp", test_deftzvp), &
      & new_unittest("ccdz", test_ccdz), &
      & new_unittest("accdz", test_accdz), &
      & new_unittest("pobtzvp", test_pobtz), &
      & new_unittest("2g", test_2g), &
      & new_unittest("dz", test_dz), &
      & new_unittest("dzp", test_dzp), &
      & new_unittest("lanl", test_lanl), &
      & new_unittest("msvp", test_msvp), &
      & new_unittest("def2mtzvp", test_def2mtzvp), &
      ! new_unittest("def2mtzvpp", test_def2mtzvpp), &
      & new_unittest("hf3c", test_hf3c), &
      & new_unittest("pbeh3c", test_pbeh3c), &
      & new_unittest("hse3c", test_hse3c), &
      & new_unittest("b973c", test_b973c), &
      & new_unittest("r2scan3c", test_r2scan3c), &
      & new_unittest("hf/sv", test_hf_sv), &
      & new_unittest("hybrid/sv", test_hyb_sv), &
      & new_unittest("gga/sv", test_gga_sv), &
      & new_unittest("hf/sv(p)", test_hf_sv_p), &
      & new_unittest("dft/sv(p)", test_dft_sv_p), &
      & new_unittest("dft/svx", test_dft_svx), &
      & new_unittest("hf/svp", test_hf_svp), &
      & new_unittest("tpss/svp", test_tpss_svp), &
      & new_unittest("pw6b95/svp", test_pw6b95_svp), &
      & new_unittest("hybrid/svp", test_hyb_svp), &
      & new_unittest("gga/svp", test_gga_svp), &
      & new_unittest("hf/minis", test_hf_minis), &
      & new_unittest("tpss/minis", test_tpss_minis), &
      & new_unittest("pw6b95/minis", test_pw6b95_minis), &
      & new_unittest("hybrid/minis", test_hyb_minis), &
      & new_unittest("gga/minis", test_gga_minis), &
      & new_unittest("hf/631gd", test_hf_631gd), &
      & new_unittest("dft/631gd", test_dft_631gd), &
      & new_unittest("hf/tz", test_hf_tz), &
      & new_unittest("hybrid/tz", test_hyb_tz), &
      & new_unittest("gga/tz", test_gga_tz), &
      & new_unittest("hf/deftzvp", test_hf_deftzvp), &
      & new_unittest("dft/deftzvp", test_dft_deftzvp), &
      & new_unittest("hf/ccdz", test_hf_ccdz), &
      & new_unittest("dft/ccdz", test_dft_ccdz), &
      & new_unittest("hf/accdz", test_hf_accdz), &
      & new_unittest("dft/accdz", test_dft_accdz), &
      & new_unittest("dft/pobtz", test_dft_pobtz), &
      & new_unittest("hf/minix", test_hf_minix), &
      & new_unittest("dft/minix", test_dft_minix), &
      & new_unittest("hf/2g", test_hf_2g), &
      & new_unittest("hf/dzp", test_hf_dzp), &
      & new_unittest("dft/dzp", test_dft_dzp), &
      & new_unittest("hf/dz", test_hf_dz), &
      & new_unittest("dft/dz", test_dft_dz), &
      & new_unittest("b3pbe3c/def2mtzvp", test_b3pbe3c_def2mtzvp), &
      & new_unittest("dft/lanl2", test_dft_lanl2), &
      & new_unittest("grad:hf/dz", test_hf_dz_grad), &
      ! new_unittest("grad:dft/sv", test_dft_sv_grad), &
      & new_unittest("grad:hse3c", test_hse3c_grad), &
      ! new_unittest("grad:hf3c", test_hf3c_grad), &
      & new_unittest("grad:b973c", test_b973c_grad), &
      & new_unittest("without-args", test_without_args) &
      & ]

end subroutine collect_gcp


subroutine test_without_args(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(gcp_param) :: param

   call get_structure(mol, "MB16-43", "01")
   call get_gcp_param(param, mol)

   call check(error, .not.allocated(param%xv))
   if (allocated(error)) return
   call check(error, .not.allocated(param%emiss))
   if (allocated(error)) return
   call check(error, .not.allocated(param%slater))
   if (allocated(error)) return
   call check(error, .not.allocated(param%zeff))
   if (allocated(error)) return
end subroutine test_without_args


subroutine test_hf3c(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(gcp_param) :: param
   real(wp) :: energy

   call get_structure(mol, "MB16-43", "02")
   call get_gcp_param(param, mol, method="hf3c")

   call check(error, allocated(param%xv))
   if (allocated(error)) return
   call check(error, allocated(param%emiss))
   if (allocated(error)) return
   call check(error, allocated(param%slater))
   if (allocated(error)) return
   call check(error, allocated(param%zeff))
   if (allocated(error)) return
   call check(error, param%base)
   if (allocated(error)) return

   param%base = .false.
   energy = 0.0_wp
   call get_geometric_counterpoise(mol, param, realspace_cutoff(), energy)

   call check(error, energy, 0.0848896136_wp, thr=thr2)
   if (allocated(error)) return

   param%base = .true.
   energy = 0.0_wp
   call get_geometric_counterpoise(mol, param, realspace_cutoff(), energy)

   call check(error, energy, 0.0292452232_wp, thr=thr2)
   if (allocated(error)) return
end subroutine test_hf3c


subroutine test_pbeh3c(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(gcp_param) :: param
   real(wp) :: energy

   call get_structure(mol, "MB16-43", "03")
   call get_gcp_param(param, mol, method="pbeh3c")

   call check(error, allocated(param%xv))
   if (allocated(error)) return
   call check(error, allocated(param%emiss))
   if (allocated(error)) return
   call check(error, allocated(param%slater))
   if (allocated(error)) return
   call check(error, allocated(param%zeff))
   if (allocated(error)) return
   call check(error, .not.param%base)
   if (allocated(error)) return
   call check(error, .not.param%srb)
   if (allocated(error)) return

   ! call ascii_gcp_param(6, mol, param)

   energy = 0.0_wp
   call get_geometric_counterpoise(mol, param, realspace_cutoff(), energy)

   call check(error, energy, 0.0206352378_wp, thr=thr2)
end subroutine test_pbeh3c


subroutine test_hse3c(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(gcp_param) :: param
   real(wp) :: energy

   call get_structure(mol, "MB16-43", "04")
   call get_gcp_param(param, mol, method="hse3c")

   call check(error, allocated(param%xv), message="xv")
   if (allocated(error)) return
   call check(error, allocated(param%emiss), message="emiss")
   if (allocated(error)) return
   call check(error, allocated(param%slater), message="slater")
   if (allocated(error)) return
   call check(error, allocated(param%zeff), message="zeff")
   if (allocated(error)) return
   call check(error, .not.param%base)
   if (allocated(error)) return
   call check(error, .not.param%srb)
   if (allocated(error)) return

   energy = 0.0_wp
   call get_geometric_counterpoise(mol, param, realspace_cutoff(), energy)

   call check(error, energy, 0.0219213037_wp, thr=thr2)
end subroutine test_hse3c


subroutine test_b973c(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(gcp_param) :: param
   real(wp) :: energy

   call get_structure(mol, "MB16-43", "05")
   call get_gcp_param(param, mol, method="b973c")

   call check(error, .not.allocated(param%xv), message="xv")
   if (allocated(error)) return
   call check(error, .not.allocated(param%emiss), message="emiss")
   if (allocated(error)) return
   call check(error, .not.allocated(param%slater), message="slater")
   if (allocated(error)) return
   call check(error, allocated(param%zeff), message="zeff")
   if (allocated(error)) return
   call check(error, .not.param%base)
   if (allocated(error)) return
   call check(error, param%srb)
   if (allocated(error)) return

   ! call ascii_gcp_param(6, mol, param)

   energy = 0.0_wp
   call get_geometric_counterpoise(mol, param, realspace_cutoff(), energy)

   call check(error, energy, -0.0369737816_wp, thr=thr2)
end subroutine test_b973c


subroutine test_r2scan3c(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(gcp_param) :: param
   real(wp) :: energy

   call get_structure(mol, "MB16-43", "06")
   call get_gcp_param(param, mol, method="r2scan3c")

   call check(error, allocated(param%xv))
   if (allocated(error)) return
   call check(error, allocated(param%emiss))
   if (allocated(error)) return
   call check(error, allocated(param%slater))
   if (allocated(error)) return
   call check(error, allocated(param%zeff))
   if (allocated(error)) return

   ! call ascii_gcp_param(6, mol, param)

   energy = 0.0_wp
   call get_geometric_counterpoise(mol, param, realspace_cutoff(), energy)

   call check(error, energy, 0.0113040952_wp, thr=thr2)
   if (allocated(error)) return
end subroutine test_r2scan3c


subroutine test_hf_sv(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "07")
   call test_generic_energy(error, mol, "hf", "sv", 0.0459359335_wp)
end subroutine test_hf_sv


subroutine test_hyb_sv(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "08")
   call test_generic_energy(error, mol, "b3lyp", "sv", 0.0817595304_wp)
end subroutine test_hyb_sv


subroutine test_gga_sv(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "09")
   call test_generic_energy(error, mol, "blyp", "sv", 0.0527050316_wp)
end subroutine test_gga_sv


subroutine test_hf_sv_p(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "10")
   call test_generic_energy(error, mol, "hf", "sv(p)", 0.0320180286_wp)
end subroutine test_hf_sv_p


subroutine test_dft_sv_p(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "11")
   call test_generic_energy(error, mol, "dft", "sv(p)", 0.0481858368_wp)
end subroutine test_dft_sv_p


subroutine test_dft_svx(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "12")
   call test_generic_energy(error, mol, "dft", "svx", 0.0442103186_wp)
end subroutine test_dft_svx


subroutine test_hf_svp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "13")
   call test_generic_energy(error, mol, "hf", "svp", 0.0389762270_wp)
end subroutine test_hf_svp


subroutine test_tpss_svp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "14")
   call test_generic_energy(error, mol, "tpss", "svp", 0.0361827169_wp)
end subroutine test_tpss_svp


subroutine test_pw6b95_svp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "15")
   call test_generic_energy(error, mol, "pw6b95", "svp", 0.0308635906_wp)
end subroutine test_pw6b95_svp


subroutine test_hyb_svp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "16")
   call test_generic_energy(error, mol, "b3lyp", "svp", 0.0310927236_wp)
end subroutine test_hyb_svp


subroutine test_gga_svp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "17")
   call test_generic_energy(error, mol, "blyp", "svp", 0.0956240694_wp)
end subroutine test_gga_svp


subroutine test_hf_minis(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "18")
   call test_generic_energy(error, mol, "hf", "minis", 0.0997731613_wp)
end subroutine test_hf_minis


subroutine test_tpss_minis(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "19")
   call test_generic_energy(error, mol, "tpss", "minis", 0.0888263651_wp)
end subroutine test_tpss_minis


subroutine test_pw6b95_minis(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "20")
   call test_generic_energy(error, mol, "pw6b95", "minis", 0.1107806553_wp)
end subroutine test_pw6b95_minis


subroutine test_hyb_minis(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "21")
   call test_generic_energy(error, mol, "b3lyp", "minis", 0.1019823129_wp)
end subroutine test_hyb_minis


subroutine test_gga_minis(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "22")
   call test_generic_energy(error, mol, "blyp", "minis", 0.1185302176_wp)
end subroutine test_gga_minis


subroutine test_hf_631gd(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "23")
   call test_generic_energy(error, mol, "hf", "631gd", 0.0164851915_wp)
end subroutine test_hf_631gd


subroutine test_dft_631gd(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "24")
   call test_generic_energy(error, mol, "dft", "631gd", 0.0691171349_wp)
end subroutine test_dft_631gd


subroutine test_hf_tz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "25")
   call test_generic_energy(error, mol, "hf", "tz", 0.0079158812_wp)
end subroutine test_hf_tz


subroutine test_hyb_tz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "26")
   call test_generic_energy(error, mol, "b3lyp", "tz", 0.0094799906_wp)
end subroutine test_hyb_tz


subroutine test_gga_tz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "27")
   call test_generic_energy(error, mol, "blyp", "tz", 0.0010732743_wp)
end subroutine test_gga_tz


subroutine test_hf_deftzvp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "28")
   call test_generic_energy(error, mol, "hf", "deftzvp", 0.0173709952_wp)
end subroutine test_hf_deftzvp


subroutine test_dft_deftzvp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "29")
   call test_generic_energy(error, mol, "b3lyp", "deftzvp", 0.0162351039_wp)
end subroutine test_dft_deftzvp


subroutine test_hf_ccdz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "30")
   call test_generic_energy(error, mol, "hf", "ccdz", 0.0531963593_wp)
end subroutine test_hf_ccdz


subroutine test_dft_ccdz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "31")
   call test_generic_energy(error, mol, "b3lyp", "ccdz", 0.0369893530_wp)
end subroutine test_dft_ccdz


subroutine test_hf_accdz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "32")
   call test_generic_energy(error, mol, "hf", "accdz", 0.0058924811_wp)
end subroutine test_hf_accdz


subroutine test_dft_accdz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "33")
   call test_generic_energy(error, mol, "b3lyp", "accdz", 0.0065641768_wp)
end subroutine test_dft_accdz


subroutine test_dft_pobtz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "34")
   call test_generic_energy(error, mol, "dft", "pobtz", 0.0630483570_wp)
end subroutine test_dft_pobtz


subroutine test_hf_minix(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "35")
   call test_generic_energy(error, mol, "hf", "minix", 0.0629778826_wp)
end subroutine test_hf_minix


subroutine test_dft_minix(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "36")
   call test_generic_energy(error, mol, "b3lyp", "minix", 0.1777559799_wp)
end subroutine test_dft_minix


subroutine test_hf_2g(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "37")
   call test_generic_energy(error, mol, "hf", "2g", 0.3699081462_wp, threshold=thr2*10)
end subroutine test_hf_2g


subroutine test_hf_dzp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "38")
   call test_generic_energy(error, mol, "hf", "dzp", 0.0237741643_wp)
end subroutine test_hf_dzp


subroutine test_dft_dzp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "39")
   call test_generic_energy(error, mol, "b3lyp", "dzp", 0.0621712827_wp)
end subroutine test_dft_dzp


subroutine test_hf_dz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "40")
   call test_generic_energy(error, mol, "hf", "dz", 0.0246769955_wp)
end subroutine test_hf_dz


subroutine test_dft_dz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "41")
   call test_generic_energy(error, mol, "b3lyp", "dz", 0.0721913136_wp)
end subroutine test_dft_dz


subroutine test_b3pbe3c_def2mtzvp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "42")
   call test_generic_energy(error, mol, "b3pbe3c", "def2mtzvp", 0.0712990259_wp)
end subroutine test_b3pbe3c_def2mtzvp


subroutine test_dft_lanl2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "43")
   call test_generic_energy(error, mol, "b3lyp", "lanl", 0.0471216257_wp)
end subroutine test_dft_lanl2


subroutine test_generic_energy(error, mol, method, basis, reference_energy, threshold)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Method name
   character(len=*), intent(in) :: method

   !> Basis name
   character(len=*), intent(in) :: basis

   !> Reference energy
   real(wp), intent(in) :: reference_energy

   !> Threshold
   real(wp), intent(in), optional :: threshold

   type(gcp_param) :: param
   real(wp) :: energy, thr_

   thr_ = thr2
   if (present(threshold)) thr_ = threshold

   call get_gcp_param(param, mol, method=method, basis=basis)

   call check(error, allocated(param%xv), "Missing number of virtual orbitals")
   if (allocated(error)) return
   call check(error, allocated(param%emiss), "Missing BSSE parameters")
   if (allocated(error)) return
   call check(error, allocated(param%slater), "Missing Slater parameters")
   if (allocated(error)) return
   call check(error, allocated(param%zeff), "Missing effective nuclear charges")
   if (allocated(error)) return

   ! call ascii_gcp_param(6, mol, param)

   energy = 0.0_wp
   call get_geometric_counterpoise(mol, param, realspace_cutoff(), energy)

   call check(error, energy, reference_energy, thr=thr_)
   if (allocated(error)) then
      print *, energy, reference_energy, energy - reference_energy
   end if
end subroutine test_generic_energy

subroutine test_sv(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "01")
   call test_generic_basis(error, mol, "sv", 0.3076865293_wp, threshold=thr2*10)
end subroutine test_sv

subroutine test_sv_p(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "02")
   call test_generic_basis(error, mol, "sv(p)", 0.2177767255_wp)
end subroutine test_sv_p

subroutine test_svx(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "03")
   call test_generic_basis(error, mol, "svx", 0.1983990319_wp)
end subroutine test_svx

subroutine test_svp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "04")
   call test_generic_basis(error, mol, "svp", 0.1319325189_wp)
end subroutine test_svp

subroutine test_minis(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "05")
   call test_generic_basis(error, mol, "minis", 4.0137040360_wp, threshold=thr2*100)
end subroutine test_minis

subroutine test_631gd(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "12")
   call test_generic_basis(error, mol, "631gd", 0.0927430940_wp)
end subroutine test_631gd

subroutine test_tz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "06")
   call test_generic_basis(error, mol, "tz", 0.0263158967_wp)
end subroutine test_tz

subroutine test_deftzvp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "07")
   call test_generic_basis(error, mol, "deftzvp", 0.0328360246_wp)
end subroutine test_deftzvp

subroutine test_ccdz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "08")
   call test_generic_basis(error, mol, "ccdz", 0.0688930836_wp)
end subroutine test_ccdz

subroutine test_accdz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "09")
   call test_generic_basis(error, mol, "accdz", 0.0119586199_wp)
end subroutine test_accdz

subroutine test_pobtz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "10")
   call test_generic_basis(error, mol, "pobtz", 0.1094965965_wp)
end subroutine test_pobtz

subroutine test_minix(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "11")
   call test_generic_basis(error, mol, "minix", 2.0696864301_wp, threshold=thr2*10)
end subroutine test_minix

subroutine test_2g(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "13")
   call test_generic_basis(error, mol, "2g", 4.6190048085_wp, threshold=thr2*100)
end subroutine test_2g

subroutine test_dzp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "14")
   call test_generic_basis(error, mol, "dzp", 0.0675215544_wp)
end subroutine test_dzp

subroutine test_dz(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "15")
   call test_generic_basis(error, mol, "dz", 0.0892315292_wp)
end subroutine test_dz

subroutine test_msvp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "16")
   call test_generic_basis(error, mol, "msvp", 0.0927839764_wp)
end subroutine test_msvp

subroutine test_def2mtzvp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "17")
   call test_generic_basis(error, mol, "def2mtzvp", 0.0337359941_wp)
end subroutine test_def2mtzvp

subroutine test_lanl(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "18")
   call test_generic_basis(error, mol, "lanl", 0.1276953745_wp)
end subroutine test_lanl

subroutine test_def2mtzvpp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "19")
   call test_generic_basis(error, mol, "def2mtzvpp", 0.0161854167_wp)
end subroutine test_def2mtzvpp

subroutine test_vmb(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   call get_structure(mol, "MB16-43", "20")
   call test_generic_basis(error, mol, "vmb", 1.6197120080_wp)
end subroutine test_vmb

subroutine test_generic_basis(error, mol, basis, reference_energy, threshold)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Basis name
   character(len=*), intent(in) :: basis

   !> Reference energy
   real(wp), intent(in) :: reference_energy

   !> Threshold
   real(wp), intent(in), optional :: threshold

   type(gcp_param) :: param
   real(wp) :: energy, thr_

   thr_ = thr2
   if (present(threshold)) thr_ = threshold

   call get_gcp_param(param, mol, basis=basis, eta=1.0_wp)
   param%sigma = 1.0_wp
   param%alpha = 1.0_wp
   param%beta = 1.0_wp

   call check(error, allocated(param%xv), "Missing number of virtual orbitals")
   if (allocated(error)) return
   call check(error, allocated(param%emiss), "Missing BSSE parameters")
   if (allocated(error)) return
   call check(error, allocated(param%slater), "Missing Slater parameters")
   if (allocated(error)) return
   call check(error, allocated(param%zeff), "Missing effective nuclear charges")
   if (allocated(error)) return

   ! call ascii_gcp_param(6, mol, param)

   energy = 0.0_wp
   call get_geometric_counterpoise(mol, param, realspace_cutoff(), energy)

   call check(error, energy, reference_energy, thr=thr_)
   if (allocated(error)) then
      print *, energy, reference_energy, energy - reference_energy
   end if
end subroutine test_generic_basis


subroutine test_hf_dz_grad(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "03")
   call test_numgrad(error, mol, "hf", "dz")

end subroutine test_hf_dz_grad


subroutine test_dft_sv_grad(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "X23", "CO2")
   call test_numgrad(error, mol, "dft", "sv")

end subroutine test_dft_sv_grad


subroutine test_hse3c_grad(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "02")
   call test_numgrad(error, mol, "hse3c")

end subroutine test_hse3c_grad


subroutine test_hf3c_grad(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "X23", "ammonia")
   call test_numgrad(error, mol, "hf3c")

end subroutine test_hf3c_grad


subroutine test_b973c_grad(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "03")
   call test_numgrad(error, mol, "b973c")

end subroutine test_b973c_grad


subroutine test_numgrad(error, mol, method, basis)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Method name
   character(len=*), intent(in) :: method

   !> Method name
   character(len=*), intent(in), optional :: basis

   type(gcp_param) :: param
   integer :: iat, ic, mat
   real(wp) :: energy, er, el
   real(wp), allocatable :: gradient(:, :), numgrad(:, :)
   real(wp) :: sigma(3, 3)
   logical :: pbc
   real(wp), parameter :: step = 1.0e-6_wp
   real(wp), parameter :: thrg = sqrt(epsilon(1.0_wp))

   pbc = any(mol%periodic)

   allocate(gradient(3, mol%nat), numgrad(3, mol%nat))

   call get_gcp_param(param, mol, method=method, basis=basis)

   if (pbc) then
      mat = min(mol%nat, 3)
   else
      mat = mol%nat
   end if
   do iat = 1, mat
      do ic = 1, 3
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         er = 0.0_wp
         call get_geometric_counterpoise(mol, param, realspace_cutoff(), er)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2*step
         el = 0.0_wp
         call get_geometric_counterpoise(mol, param, realspace_cutoff(), el)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         numgrad(ic, iat) = 0.5_wp*(er - el)/step
      end do
   end do

   gradient(:, :) = 0.0_wp
   call get_geometric_counterpoise(mol, param, realspace_cutoff(), energy, gradient, sigma)

   if (any(abs(gradient(:, :mat)-numgrad(:, :mat)) > thrg)) then
      call test_failed(error, "Numerical and analytical gradient do not match")
      do iat = 1, mat
         print'(3es14.5,3x,a)', gradient(:, iat)-numgrad(:, iat), mol%sym(mol%id(iat))
      end do
   end if

end subroutine test_numgrad


end module test_gcp

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3_gcp
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use dftd3_gcp_param, only : gcp_param, get_gcp_param
   use dftd3_cutoff, only : realspace_cutoff, get_lattice_points
   implicit none
   private

   public :: gcp_param, get_gcp_param, get_geometric_counterpoise

   !> Geometric counterpoise correction
   interface get_geometric_counterpoise
      module procedure get_geometric_counterpoise
      module procedure get_geometric_counterpoise_atomic
   end interface get_geometric_counterpoise



contains


!> Geometric counterpoise correction
subroutine get_geometric_counterpoise(mol, param, cutoff, energy, gradient, sigma)

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Geometric counterpoise parameters
   type(gcp_param), intent(in) :: param

   !> Realspace cutoffs
   type(realspace_cutoff), intent(in) :: cutoff

   !> Counter-poise energy
   real(wp), intent(inout) :: energy

   !> Counter-poise gradient
   real(wp), intent(inout), optional :: gradient(:, :)

   !> Counter-poise virial
   real(wp), intent(inout), optional :: sigma(:, :)

   real(wp), allocatable :: energies(:)

   allocate(energies(mol%nat), source=0.0_wp)
   call get_geometric_counterpoise_atomic(mol, param, cutoff, energies, gradient, sigma)
   energy = energy + sum(energies)
end subroutine get_geometric_counterpoise


!> Geometric counterpoise correction with atom-resolved energies
subroutine get_geometric_counterpoise_atomic(mol, param, cutoff, energies, gradient, sigma)

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Geometric counterpoise parameters
   type(gcp_param), intent(in) :: param

   !> Realspace cutoffs
   type(realspace_cutoff), intent(in) :: cutoff

   !> Dispersion energy
   real(wp), intent(inout) :: energies(:)

   !> Dispersion gradient
   real(wp), intent(inout), optional :: gradient(:, :)

   !> Dispersion virial
   real(wp), intent(inout), optional :: sigma(:, :)

   real(wp), allocatable :: lattr(:, :)
   real(wp), parameter :: rexp_base = 0.75_wp, zexp_base = 1.5_wp, rexp_srb = -1.0_wp, zexp_srb = 0.5_wp
   logical :: grad

   grad = present(gradient) .and. present(sigma)

   if (allocated(param%emiss) .and. allocated(param%slater) .and. allocated(param%xv)) then
      call get_lattice_points(mol%periodic, mol%lattice, cutoff%gcp, lattr)
      if (grad) then
         call gcp_deriv(mol, lattr, cutoff%gcp, param%zeff, param%emiss, param%slater, &
            & param%xv, param%rvdw, param%sigma, param%alpha, param%beta, param%damp, &
            & param%dmp_scal, param%dmp_exp, energies, gradient, sigma)
      else
         call gcp_energy(mol, lattr, cutoff%gcp, param%zeff, param%emiss, param%slater, &
            & param%xv, param%rvdw, param%sigma, param%alpha, param%beta, param%damp, &
            & param%dmp_scal, param%dmp_exp, energies)
      end if
   end if

   if (param%srb .or. param%base) then
      call get_lattice_points(mol%periodic, mol%lattice, cutoff%srb, lattr)
   end if

   if (param%srb) then
      if (grad) then
         call srb_deriv(mol, lattr, cutoff%srb, mol%num, param%rvdw_srb, param%rscal, param%qscal, &
            & rexp_srb, zexp_srb, energies, gradient, sigma)
      else
         call srb_energy(mol, lattr, cutoff%srb, mol%num, param%rvdw_srb, param%rscal, param%qscal, &
            & rexp_srb, zexp_srb, energies)
      end if
   end if

   if (param%base) then
      if (grad) then
         call srb_deriv(mol, lattr, cutoff%srb, param%zeff, param%rvdw, param%rscal, param%qscal, &
            & rexp_base, zexp_base, energies, gradient, sigma)
      else
         call srb_energy(mol, lattr, cutoff%srb, param%zeff, param%rvdw, param%rscal, param%qscal, &
            & rexp_base, zexp_base, energies)
      end if
   end if
end subroutine get_geometric_counterpoise_atomic


!> Geometric counterpoise correction
subroutine gcp_energy(mol, trans, cutoff, iz, emiss, slater, xv, rvdw, escal, alpha, beta, &
      & damp, dmp_scal, dmp_exp, energies)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Translation vectors
   real(wp), intent(in) :: trans(:, :)
   !> Distance cutoff
   real(wp), intent(in) :: cutoff
   !> Effective nuclear charges
   integer, intent(in) :: iz(:)
   !> Basis set superposition error per atom
   real(wp), intent(in) :: emiss(:)
   !> Slater exponents
   real(wp), intent(in) :: slater(:)
   !> Number of virtual orbitals
   real(wp), intent(in) :: xv(:)
   !> Van der Waals radii
   real(wp), intent(in) :: rvdw(:, :)
   !> Scaling factor
   real(wp), intent(in) :: escal
   !> Exponential factor
   real(wp), intent(in) :: alpha
   !> Power factor
   real(wp), intent(in) :: beta
   !> Damping flag
   logical, intent(in) :: damp
   !> Damping scaling factor
   real(wp), intent(in) :: dmp_scal
   !> Damping exponent
   real(wp), intent(in) :: dmp_exp
   !> Atom-resolved energy
   real(wp), intent(inout) :: energies(:)

   integer :: iat, jat, jtr, izp, jzp
   real(wp) :: argv
   real(wp) :: xvi, xvj
   real(wp) :: r1, rscal, rscalexp, r0
   real(wp) :: sij, expv, bsse, emi, emj
   real(wp) :: vec(3)
   real(wp) :: dampval, grd_dmp
   real(wp) :: dE

   !$omp parallel do default(none) &
   !$omp reduction(+:energies) &
   !$omp shared(mol, iz, xv, emiss, rvdw, trans, cutoff, alpha, beta, &
   !$omp&       dmp_scal, dmp_exp, escal, slater, damp) &
   !$omp private(izp, jat, jzp, xvi, xvj, emi, emj, r0, jtr, vec, r1, sij, &
   !$omp&        expv, bsse, argv, dE, dampval, grd_dmp, rscal, rscalexp)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      xvi = merge(1.0_wp / sqrt(xv(izp)), 0.0_wp, xv(izp) >= 0.5_wp)

      ! the BSSE due to atom jat, Loop over all j atoms
      do jat = 1, iat
         jzp = mol%id(jat)
         xvj = merge(1.0_wp / sqrt(xv(jzp)), 0.0_wp, xv(jzp) >= 0.5_wp)

         emi = emiss(izp)*xvj*escal
         emj = emiss(jzp)*xvi*escal
         r0 = rvdw(izp, jzp)
         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, jtr))
            r1 = norm2(vec)

            if(r1 > cutoff .or. r1 < epsilon(1.0_wp)) cycle
            ! calulate slater overlap sij
            call ssovl(r1, izp, jzp, iz, slater(izp), slater(jzp), sij)
            ! evaluate gcp central expression
            argv = -alpha*r1**beta
            expv = exp(argv)
            bsse = expv/sqrt(sij)
            if (damp) then
               rscal = r1/r0
               rscalexp = dmp_scal*rscal**dmp_exp
               dampval = (1.0_wp-1.0_wp/(1.0_wp+rscalexp))
            else
               dampval = 1.0_wp
            endif
            dE = bsse*dampval
            energies(iat) = energies(iat) + emi*dE
            if (iat /= jat) then
               energies(jat) = energies(jat) + emj*dE
            end if
         end do
      end do
   end do

end subroutine gcp_energy


!> Geometric counterpoise correction
subroutine gcp_deriv(mol, trans, cutoff, iz, emiss, slater, xv, rvdw, escal, alpha, beta, &
      & damp, dmp_scal, dmp_exp, energies, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Translation vectors
   real(wp), intent(in) :: trans(:, :)
   !> Distance cutoff
   real(wp), intent(in) :: cutoff
   !> Effective nuclear charges
   integer, intent(in) :: iz(:)
   !> Basis set superposition error per atom
   real(wp), intent(in) :: emiss(:)
   !> Slater exponents
   real(wp), intent(in) :: slater(:)
   !> Number of virtual orbitals
   real(wp), intent(in) :: xv(:)
   !> Van der Waals radii
   real(wp), intent(in) :: rvdw(:, :)
   !> Scaling factor
   real(wp), intent(in) :: escal
   !> Exponential factor
   real(wp), intent(in) :: alpha
   !> Power factor
   real(wp), intent(in) :: beta
   !> Damping flag
   logical, intent(in) :: damp
   !> Damping scaling factor
   real(wp), intent(in) :: dmp_scal
   !> Damping exponent
   real(wp), intent(in) :: dmp_exp
   !> Atom-resolved energy
   real(wp), intent(inout) :: energies(:)
   !> Molecular gradient
   real(wp), intent(inout) :: gradient(:, :)
   !> Virial
   real(wp), intent(inout) :: sigma(:, :)

   integer :: iat, jat, jtr, izp, jzp
   real(wp) :: argv, argd, ovlpd
   real(wp) :: xvi, xvj
   real(wp) :: r1, rscal, rscalexp, rscalexpm1, r0
   real(wp) :: sij, expv, expd, bsse, emi, emj, emij
   real(wp) :: vec(3), gs(3), gij
   real(wp) :: dampval, grd_dmp
   real(wp) :: dE, dG(3), dS(3, 3)

   !$omp parallel do default(none) &
   !$omp reduction(+:energies, gradient, sigma) &
   !$omp shared(mol, iz, xv, emiss, rvdw, trans, cutoff, alpha, beta, &
   !$omp&       dmp_scal, dmp_exp, escal, slater, damp) &
   !$omp private(izp, jat, jzp, xvi, xvj, emi, emj, r0, jtr, vec, r1, sij, gij, emij, &
   !$omp&        expv, bsse, argv, dE, dampval, grd_dmp, dG, dS, expd, argd, ovlpd, gs, &
   !$omp&        rscal, rscalexp, rscalexpm1)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      xvi = merge(1.0_wp / sqrt(xv(izp)), 0.0_wp, xv(izp) >= 0.5_wp)

      ! the BSSE due to atom jat, Loop over all j atoms
      do jat = 1, iat
         jzp = mol%id(jat)
         xvj = merge(1.0_wp / sqrt(xv(jzp)), 0.0_wp, xv(jzp) >= 0.5_wp)

         emi = emiss(izp)*xvj*escal
         emj = emiss(jzp)*xvi*escal
         emij = emi + emj
         r0 = rvdw(izp, jzp)
         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, jtr))
            r1 = norm2(vec)

            if(r1 > cutoff .or. r1 < epsilon(1.0_wp)) cycle
            ! calulate slater overlap sij
            call ssovl(r1, izp, jzp, iz, slater(izp), slater(jzp), sij)
            ! evaluate gcp central expression
            argv = -alpha*r1**beta
            expv = exp(argv)
            bsse = expv/sqrt(sij)
            if (damp) then
               rscal = r1/r0
               rscalexp = dmp_scal*rscal**dmp_exp
               dampval = (1.0_wp-1.0_wp/(1.0_wp+rscalexp))
            else
               dampval = 1.0_wp
            endif

            call gsovl(r1, izp, jzp, iz, slater(izp), slater(jzp), gij)

            gs(:) = gij*vec
            expd = exp(-alpha*r1**beta)*(-0.5_wp)
            argd = 2d0*alpha*beta*r1**beta*sij/r1
            ovlpd = r1*sij**1.5_wp

            if(damp) then
               rscalexpm1 = rscal**(dmp_exp-1)
               grd_dmp = dmp_scal*dmp_exp*rscalexpm1/r0
               grd_dmp = grd_dmp/(rscalexp+1.0_wp)**2
            endif

            dE = bsse*dampval
            dG = expd*(argd*vec + gs)/ovlpd*emij
            if(damp) then
               dG = dG*dampval+bsse*grd_dmp*(vec/r1)*emij
            endif
            dS = spread(dG, 1, 3) * spread(vec, 2, 3) * 0.5_wp

            energies(iat) = energies(iat) + emi*dE
            if (iat /= jat) then
               energies(jat) = energies(jat) + emj*dE
            end if
            sigma(:, :) = sigma(:, :) + dS
            if (iat /= jat) then
               gradient(:, iat) = gradient(:, iat) + dG
               gradient(:, jat) = gradient(:, jat) - dG
               sigma(:, :) = sigma(:, :) + dS
            end if
         end do
      end do
   end do

end subroutine gcp_deriv


!> Short-range bond length correction for HF-3c
subroutine srb_energy(mol, trans, cutoff, iz, r0ab, rscal, qscal, rexp, zexp, energies)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Translation vectors
   real(wp), intent(in) :: trans(:, :)
   !> Distance cutoff
   real(wp), intent(in) :: cutoff
   !> Effective nuclear charges
   integer, intent(in) :: iz(:)
   !> Van der Waals radii
   real(wp), intent(in) :: r0ab(:, :)
   !> Radii scaling factor
   real(wp), intent(in) :: rscal
   !> Prefactor for the SRB potential
   real(wp), intent(in) :: qscal
   !> Exponent for radii
   real(wp), intent(in) :: rexp
   !> Exponent for charges
   real(wp), intent(in) :: zexp
   !> Atom-resolved energy
   real(wp), intent(inout) :: energies(:)

   real(wp) :: fi, fj, ff, r1, expt
   real(wp) :: r0, vec(3), dE
   integer iat, jat, jtr, izp, jzp

   !$omp parallel do default(none) &
   !$omp reduction(+:energies) &
   !$omp shared(mol, trans, cutoff, iz, r0ab, rexp, zexp, rscal, qscal) &
   !$omp private(izp, jat, jzp, r0, vec, r1, fi, fj, ff, expt, dE)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      fi = real(iz(izp), wp)
      do jat = 1, iat
         jzp = mol%id(jat)
         r0 = rscal*r0ab(izp, jzp)**rexp
         fj = real(iz(jzp), wp)
         ff = -(fi*fj)**zexp

         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, jtr))
            r1 = norm2(vec)
            if(r1 > cutoff .or. r1 < epsilon(1.0_wp)) cycle
            expt = exp(-r0*r1)
            dE = qscal*ff*expt*0.5_wp

            energies(iat) = energies(iat) + dE
            if (iat /= jat) then
               energies(jat) = energies(jat) + dE
            end if
         end do
      end do
   end do

end subroutine srb_energy


!> Short-range bond length correction for HF-3c
subroutine srb_deriv(mol, trans, cutoff, iz, r0ab, rscal, qscal, rexp, zexp, energies, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Translation vectors
   real(wp), intent(in) :: trans(:, :)
   !> Distance cutoff
   real(wp), intent(in) :: cutoff
   !> Effective nuclear charges
   integer, intent(in) :: iz(:)
   !> Van der Waals radii
   real(wp), intent(in) :: r0ab(:, :)
   !> Radii scaling factor
   real(wp), intent(in) :: rscal
   !> Prefactor for the SRB potential
   real(wp), intent(in) :: qscal
   !> Exponent for radii
   real(wp), intent(in) :: rexp
   !> Exponent for charges
   real(wp), intent(in) :: zexp
   !> Atom-resolved energy
   real(wp), intent(inout) :: energies(:)
   !> Molecular gradient
   real(wp), intent(inout) :: gradient(:, :)
   !> Molecular virial
   real(wp), intent(inout) :: sigma(:, :)

   real(wp) :: fi, fj, ff, rf, r1, expt
   real(wp) :: r0, vec(3), dE, dG(3), dS(3, 3)
   integer iat, jat, jtr, izp, jzp

   !$omp parallel do default(none) &
   !$omp reduction(+:energies, gradient, sigma) &
   !$omp shared(mol, trans, cutoff, iz, r0ab, rexp, zexp, rscal, qscal) &
   !$omp private(izp, jat, jzp, r0, vec, r1, fi, fj, ff, expt, rf, dE, dG, dS)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      fi = real(iz(izp), wp)
      do jat = 1, iat
         jzp = mol%id(jat)
         r0 = rscal*r0ab(izp, jzp)**rexp
         fj = real(iz(jzp), wp)
         ff = -(fi*fj)**zexp

         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, jtr))
            r1 = norm2(vec)
            if(r1 > cutoff .or. r1 < epsilon(1.0_wp)) cycle
            expt = exp(-r0*r1)
            rf = qscal/r1

            dE = qscal*ff*expt*0.5_wp
            dG(:) = -ff*r0*vec*expt*rf
            dS(:, :) = spread(dG, 1, 3) * spread(vec, 2, 3) * 0.5_wp

            energies(iat) = energies(iat) + dE
            if (iat /= jat) then
               energies(jat) = energies(jat) + dE
            end if
            sigma(:, :) = sigma + dS
            if (iat /= jat) then
               gradient(:, iat) = gradient(:, iat) + dG
               gradient(:, jat) = gradient(:, jat) - dG
               sigma(:, :) = sigma + dS
            end if

         end do
      end do
   end do

end subroutine srb_deriv


!******************************************************************************
!* calculates the s-type overlap integral over 1s, 2s and 3s slater functions
!* added support for 3s functions
!* ovl = overlap integral
!* za  = slater exponent atom A
!* zb  = slater exponent atom B
!* R   = distance between atom A and B
!* Inspired by mopac7.0
!******************************************************************************
subroutine ssovl(r, iat, jat, iz, xza, xzb, ovl)
   integer ii, shell(72)
   logical debug
   real(wp) za, zb, R, ovl, ax, bx, norm, R05
   integer na, nb
   real(wp) xx
   data shell/                 &
   !          h, he
            1, 1               &
   !         li-ne
            , 2, 2, 2, 2, 2, 2, 2, 2, &
   !         na-ar
            3, 3, 3, 3, 3, 3, 3, 3,  &
   ! 4s, 5s will be treated as 3s
   !         k-rn , no f-elements
            54*3/
   ! ...
   real(wp) xza, xzb
   integer iat, jat, iz(*)

   za = xza
   zb = xzb
   na = iz(iat)
   nb = iz(jat)
   debug = .false.
!debug = .true.

! ii selects kind of ovl by multiplying the shell
! kind    <1s|1s>  <2s|1s>  <2s|2s>  <1s|3s>  <2s|3s>  <3s|3s>
! case:      1        2        4       3        6         9
!
   ii = shell(na)*shell(nb)
   if(debug) write(*, *) 'shell', ii

   R05 = R*0.5
   ax = (za+zb)*R05
   bx = (zb-za)*R05

   ! same elements
   if(abs(za-zb) < 0.1) then
      select case (ii)
      case (1)
         ovl = 0.25d0*sqrt((za*zb*R*R)**3)*(A2(ax)*Bint(bx, 0)-Bint(bx, 2)*A0(ax))
      case (2)
         ovl = SQRT(1._wp/3._wp)
         if(shell(na) < shell(nb)) then
         ! <1s|2s>
            norm = SQRT((ZA**3)*(ZB**5))*(R**4)*0.125_wp
            ovl = ovl*norm*(A3(ax)*Bint(bx, 0)-Bint(bx, 3)*A0(ax)+A2(ax)*Bint(bx, 1)-Bint(bx, 2)*A1(ax))
         else
         ! switch za/zb to get <2s|1s>
            xx = za
            za = zb
            zb = xx
            ax = (za+zb)*R05
            bx = (zb-za)*R05
            norm = SQRT((ZA**3)*(ZB**5))*(R**4)*0.125_wp
            ovl = ovl*norm*(A3(ax)*Bint(bx, 0)-Bint(bx, 3)*A0(ax)+A2(ax)*Bint(bx, 1)-Bint(bx, 2)*A1(ax))
         endif
      case (4)
         norm = SQRT((ZA*ZB)**5)*(R**5)*0.0625d0
         ovl = norm* (A4(ax)*Bint(bx, 0)+Bint(bx, 4)*A0(ax)-2.0d0*A2(ax)*Bint(bx, 2))*(1d0/3d0)
      case(3)
         if(shell(na) < shell(nb)) then
            norm = SQRT((ZA**3)*(ZB**7)/7.5_wp)*(R**5)*0.0625_wp
            ovl = norm*(A4(ax)*Bint(bx, 0)-Bint(bx, 4)*A0(ax)+2.d0*(A3(ax)*Bint(bx, 1)-Bint(bx, 3)*A1(ax)))/sqrt(3.d0)
         else
            xx = za
            za = zb
            zb = xx
            ax = (za+zb)*R05
            bx = (zb-za)*R05
            norm = SQRT((ZA**3)*(ZB**7)/7.5_wp)*(R**5)*0.0625_wp
            ovl = norm*(A4(ax)*Bint(bx, 0)-Bint(bx, 4)*A0(ax)+2.d0*(A3(ax)*Bint(bx, 1)-Bint(bx, 3)*A1(ax)))/sqrt(3.d0)
         endif
      case(6)
         if(shell(na) < shell(nb)) then
            norm = SQRT((za**5)*(zb**7)/7.5_wp)*(R**6)*0.03125_wp
            ovl = norm*(A5(ax)*Bint(bx, 0)+A4(ax)*Bint(bx, 1) &
               & -2d0*(A3(ax)*Bint(bx, 2)+A2(ax)*Bint(bx, 3)) &
               & +A1(ax)*Bint(bx, 4)+A0(ax)*Bint(bx, 5))/3.d0
         else
            xx = za
            za = zb
            zb = xx
            ax = (za+zb)*R05
            bx = (zb-za)*R05
            norm = SQRT((za**5)*(zb**7)/7.5_wp)*(R**6)*0.03125_wp
            ovl = norm*(A5(ax)*Bint(bx, 0)+A4(ax)*Bint(bx, 1) &
               & -2d0*(A3(ax)*Bint(bx, 2)+A2(ax)*Bint(bx, 3)) &
               & +A1(ax)*Bint(bx, 4)+A0(ax)*Bint(bx, 5))/3.d0
         endif
      case(9)
         norm = sqrt((ZA*ZB*R*R)**7)/480.d0
         ovl = norm*(A6(ax)*Bint(bx, 0)-3.d0*(A4(ax)*Bint(bx, 2) &
            & -A2(ax)*Bint(bx, 4))-A0(ax)*Bint(bx, 6))/3._wp
      end select
   else ! different elements
      select case (ii)
      case (1)
         norm = 0.25d0*sqrt((za*zb*R*R)**3)
         ovl = (A2(ax)*B0(bx)-B2(bx)*A0(ax))*norm
      case (2)
         ovl = SQRT(1._wp/3._wp)
         if(shell(na) < shell(nb)) then
         ! <1s|2s>
            norm = SQRT((ZA**3)*(ZB**5))*(R**4)*0.125_wp
            ovl = ovl*norm*(A3(ax)*B0(bx)-B3(bx)*A0(ax)+A2(ax)*B1(bx)-B2(bx)*A1(ax))
         else
         ! switch za/zb to get <2s|1s>
            xx = za
            za = zb
            zb = xx
            ax = (za+zb)*R05
            bx = (zb-za)*R05
            norm = SQRT((ZA**3)*(ZB**5))*(R**4)*0.125_wp
            ovl = ovl*norm*(A3(ax)*B0(bx)-B3(bx)*A0(ax)+A2(ax)*B1(bx)-B2(bx)*A1(ax))
         endif
      case (4) ! <2s|2s>
         norm = SQRT((ZA*ZB)**5)*(R**5)*0.0625_wp
         ovl = norm* (A4(ax)*B0(bx)+B4(bx)*A0(ax)-2.0_wp*A2(ax)*B2(bx))*(1d0/3d0)
      case(3)  ! <1s|3s> + <3s|1s>
         if(shell(na) < shell(nb)) then
            norm = SQRT((ZA**3)*(ZB**7)/7.5_wp)*(R**5)*0.0625_wp
            ovl = norm*(A4(ax)*B0(bx)-B4(bx)*A0(ax)+2.d0*(A3(ax)*B1(bx)-B3(bx)*A1(ax)))/sqrt(3.d0)
         else
            xx = za
            za = zb
            zb = xx
            ax = (za+zb)*R05
            bx = (zb-za)*R05
            norm = SQRT((ZA**3)*(ZB**7)/7.5_wp)*(R**5)*0.0625_wp
            ovl = norm*(A4(ax)*B0(bx)-B4(bx)*A0(ax)+2.d0*(A3(ax)*B1(bx)-B3(bx)*A1(ax)))/sqrt(3.d0)
         endif
      case(6)  ! <2s|3s> + <3s|2s>
         if(shell(na) < shell(nb)) then
            norm = SQRT((za**5)*(zb**7)/7.5_wp)*(R**6)*0.03125_wp
            ovl = norm*(A5(ax)*B0(bx)+A4(ax)*B1(bx)-2d0*(A3(ax)*B2(bx)+A2(ax)*B3(bx))+A1(ax)*B4(bx)+A0(ax)*B5(bx))/3.d0
         else
            xx = za
            za = zb
            zb = xx
            ax = (za+zb)*R05
            bx = (zb-za)*R05
            norm = SQRT((za**5)*(zb**7)/7.5_wp)*(R**6)*0.03125_wp
            ovl = norm*(A5(ax)*B0(bx)+A4(ax)*B1(bx)-2.0_wp*(A3(ax)*B2(bx)+A2(ax)*B3(bx))+A1(ax)*B4(bx)+A0(ax)*B5(bx))/3.d0
         endif
      case(9) ! <3s|3>
         norm = sqrt((ZA*ZB*R*R)**7)/1440.d0
         ovl = norm*(A6(ax)*B0(bx)-3.d0*(A4(ax)*B2(bx)-A2(ax)*B4(bx))-A0(ax)*B6(bx))
      end select
   endif
end subroutine ssovl


!****************************************
!* A(x) auxiliary integrals             *
!* Quantenchemie - Ein Lehrgang Vol 5   *
!* p. 570  eq. 11.4.14                  *
!****************************************

real(wp) pure function A0(x)
! Hilfsintegral A_0
implicit none
real(wp), intent(in) :: x
A0 = exp(-x)/x
return
end function

real(wp) pure function A1(x)
! Hilfsintegral A_1
implicit none
real(wp), intent(in) :: x
A1 = ((1+x)*exp(-x))/(x**2)
return
end function


real(wp) pure function A2(x)
! Hilfsintegral A_2
implicit none
real(wp), intent(in) :: x
A2 = ((2d0+2d0*x+x**2)*exp(-x))/x**3
return
end function


real(wp) pure function A3(x)
! Hilfsintegral A_3
implicit none
real(wp), intent(in) :: x
real(wp) xx
real(wp) x2, x3, x4
x2 = x*x
x3 = x2*x
x4 = x3*x
xx = (6d0+6d0*x+3d0*x2+x3)
A3 = (xx*exp(-x))/x4
return
end function


real(wp) pure function A4(x)
! Hilfsintegral A_4
implicit none
real(wp), intent(in) :: x
real(wp) xx
real(wp) x2, x3, x4, x5
x2 = x*x
x3 = x2*x
x4 = x3*x
x5 = x4*x
xx = (24d0+24d0*x+12d0*x2+4d0*x3+x4)
A4 = (xx*exp(-x))/x5
return
end function

real(wp) pure function A5(x)
! Hilfsintegral A_5
implicit none
real(wp), intent(in) :: x
real(wp) xx
real(wp) x2, x3, x4, x5, x6
x2 = x*x
x3 = x2*x
x4 = x3*x
x5 = x4*x
x6 = x5*x
xx = (120d0+120d0*x+60d0*x2+20d0*x3+5d0*x4+x5)
A5 = (xx*exp(-x))/x6
return
end function

real(wp) pure function A6(x)
! Hilfsintegral A_6
implicit none
real(wp), intent(in) :: x
real(wp) xx
real(wp) x2, x3, x4, x5, x6, x7
x2 = x*x
x3 = x2*x
x4 = x3*x
x5 = x4*x
x6 = x5*x
x7 = x6*x
xx = (720d0+720d0*x+360d0*x2+120d0*x3+30d0*x4+6d0*x5+x6)
A6 = (xx*exp(-x))/x7
return
end function



!**************************************
!* B(x) auxiliary integrals           *
!* Quantenchemie - Ein Lehrgang Vol 5 *
!* p. 570  eq. 11.4.14b               *
!**************************************


real(wp) pure function B0(x)
   real(wp), intent(in) :: x
   B0 = (exp(x)-exp(-x))/x
end function

real(wp) pure function B1(x)
   real(wp), intent(in) :: x
   real(wp) x2, x3
   x2 = x*x
   x3 = x2*x
   B1 = ((1.0_wp-x)*exp(x)-(1.0_wp+x)*exp(-x))/x2
end function

real(wp) pure function B2(x)
   real(wp), intent(in) :: x
   real(wp) x2, x3
   x2 = x*x
   x3 = x2*x
   B2 = (((2.0_wp-2*x+x2)*exp(x)) - ((2.0_wp+2.0_wp*x+x2)*exp(-x)))/x3
end function

real(wp) pure function B3(x)
   real(wp), intent(in) :: x
   real(wp) xx, yy
   real(wp) x2, x3, x4
   x2 = x*x
   x3 = x2*x
   x4 = x3*x
   xx = (6.0_wp-6.0_wp*x+3.0_wp*x2-x3)*exp(x)/x4
   yy = (6.0_wp+6.0_wp*x+3.0_wp*x2+x3)*exp(-x)/x4
   B3 = xx-yy
end function


real(wp) pure function B4(x)
   real(wp), intent(in) :: x
   real(wp) xx, yy
   real(wp) x2, x3, x4, x5
   x2 = x*x
   x3 = x2*x
   x4 = x3*x
   x5 = x4*x
   xx = (24.0_wp-24.0_wp*x+12.0_wp*x2-4.0_wp*x3+x4)*exp(x)/x5
   yy = (24.0_wp+24.0_wp*x+12.0_wp*x2+4.0_wp*x3+x4)*exp(-x)/x5
   B4 = xx-yy
end function

real(wp) pure function B5(x)
   real(wp), intent(in) :: x
   real(wp) xx, yy
   real(wp) x2, x3, x4, x5, x6
   x2 = x*x
   x3 = x2*x
   x4 = x3*x
   x5 = x4*x
   x6 = x5*x
   xx = (120.0_wp-120*x+60*x2-20*x3+5*x4-x5)*exp(x)/x6
   yy = (120.0_wp+120*x+60*x2+20*x3+5*x4+x5)*exp(-x)/x6
   B5 = xx-yy
end function

real(wp) function B6(x)
   real(wp), intent(in) :: x
   real(wp) x2, x3, x4, x5, x6, x7, yy, xx
   x2 = x*x
   x3 = x2*x
   x4 = x3*x
   x5 = x4*x
   x6 = x5*x
   x7 = x6*x
   xx = (720.0_wp - 720.0_wp*x+ 360.0_wp*x2 - 120.0_wp*x3 + 30.0_wp*x4 - 6.0_wp*x5 + x6)*exp(x)/x7
   yy = (720.0_wp + 720.0_wp*x + 360.0_wp*x2 + 120.0_wp*x3 + 30.0_wp*x4 + 6.0_wp*x5 + x6)*exp(-x)/x7
   B6 = xx-yy
end function


real(wp) function bint(x, k)
! calculates B_k(x)
! general summation formula
! 'infinite' sum is numerically unstable. 12 terms seem
! accurate enough
implicit none
real(wp), intent(in) :: x
real(wp) xx, yy
integer, intent(in) :: k
integer i
bint = 0

if(abs(x).lt.1e-6) then
do i = 0, k
   bint = (1.d0+(-1d0)**i)/(dble(i)+1.d0)
end do
return
endif

do i = 0, 12
xx = 1d0-((-1d0)**(k+i+1))
yy = dble(fact(i))*dble((k+i+1))
bint = bint+xx/yy*(-x)**i
enddo


end function bint


! faculty function
integer(wp) function fact(N)
implicit none
integer j, n
fact = 1
do j = 2, n
  fact = fact*j
enddo
return

end




subroutine gsovl(r, iat, jat, iz, xza, xzb, g)
   ! GRADIENT
   ! calculates the s-type overlap integral over 1s, 2s, 3s slater functions
   ! ovl = overlap integral
   ! za  = slater exponent atom A
   ! zb  = slater exponent atom B
   ! R   = distance between atom A and B
   integer ii, shell(72)
   logical debug
   real(wp) ax, bx, R05, za, zb, R
   integer na, nb
   data shell/                 &
   !          h, he
            1, 1               &
   !         li-ne
            , 2, 2, 2, 2, 2, 2, 2, 2, &
   !         na-ar
            3, 3, 3, 3, 3, 3, 3, 3,  &
   ! 4s, 5s will be treated as 3s
   !         k-rn , no f-elements
            54*3/
   ! ...
   real(wp) g, Fa, Fb
   !--------------------- set exponents ---------------------------------------
   real(wp) xza, xzb
   real(wp) xx
   integer iat, jat, iz(*)
   logical lsame

   za = xza
   zb = xzb
   na = iz(iat)
   nb = iz(jat)
   !----------------------------------------------------------------------------

   debug = .false.
   !debug = .true.

   ! ii selects kind of ovl by multiplying the shell
   ! kind    <1s|1s>  <2s|1s>  <2s|2s>  <1s|3s>  <2s|3s>  <3s|3s>
   ! case:      1        2        4       3        6         9
   !
   ii = shell(na)*shell(nb)
   if(debug) write(*, *) 'gshell', ii
   R05 = R*0.5_wp
   ax = (za+zb)*R05
   Fa = (za+zb)
   bx = (zb-za)*R05
   Fb = (zb-za)
   lsame = .false.
   !
   ! same elements
   if(abs(za-zb) < 0.1) then
      lsame = .true.
      ! call arguments: gtype(exponents, argumentDeriv., distance, gradient, (Switch shell), sameElement)
      select case (ii)
      case (1)
         call g1s1s(za, zb, Fa, Fb, R, g, lsame)
      case (2)
         if(shell(na) < shell(nb)) then
            call g2s1s(za, zb, Fa, Fb, R, g, .false., lsame)
         else
            xx = za
            za = zb
            zb = xx
            call g2s1s(za, zb, Fa, Fb, R, g, .true., lsame)
         end if
      case (4)
         call g2s2s(za, zb, Fa, Fb, R, g, lsame)
      case(3)
         if(shell(na) < shell(nb)) then
            call g1s3s(za, zb, Fa, Fb, R, g, .false., lsame)
         else
            xx = za
            za = zb
            zb = xx
            call g1s3s(za, zb, Fa, Fb, R, g, .true., lsame)
         end if
      case(6)
         if(shell(na) < shell(nb)) then
            call g2s3s(za, zb, Fa, Fb, R, g, .false., lsame)
         else
            xx = za
            za = zb
            zb = xx
            call g2s3s(za, zb, Fa, Fb, R, g, .true., lsame)
         end if
      case(9)
         call g3s3s(za, zb, Fa, Fb, R, g, lsame)
      end select
   else ! different elements
      lsame = .false.
      select case (ii)
      case (1)
         call g1s1s(za, zb, Fa, Fb, R, g, lsame)
      case (2)  ! <1s|2s>
         if(shell(na) < shell(nb)) then
            call g2s1s(za, zb, Fa, Fb, R, g, .false., lsame)
         else
            xx = za
            za = zb
            zb = xx
            call g2s1s(za, zb, Fa, Fb, R, g, .true., lsame)
         end if
      case (4) ! <2s|2s>
         call g2s2s(za, zb, Fa, Fb, R, g, lsame)
      case(3)  ! <1s|3s> + <3s|1s>
         if(shell(na) < shell(nb)) then
            call g1s3s(za, zb, Fa, Fb, R, g, .false., lsame)
         else
            xx = za
            za = zb
            zb = xx
            call g1s3s(za, zb, Fa, Fb, R, g, .true., lsame)
         end if
      case(6)  ! <2s|3s> + <3s|2s>
         if(shell(na) < shell(nb)) then
            call g2s3s(za, zb, Fa, Fb, R, g, .false., lsame)
         else
            xx = za
            za = zb
            zb = xx
            call g2s3s(za, zb, Fa, Fb, R, g, .true., lsame)
         end if
      case(9) ! <3s|3>
         call g3s3s(za, zb, Fa, Fb, R, g, lsame)
      end select
   end if

end subroutine gsovl


!-------------------------------------------------------------
! Maple was used to find the analy. derivatives of
! the slater integrals (expressions over A, B aux. integrals)
! Optimized fortran code by maple with some human-corrections
!-------------------------------------------------------------
subroutine g1s1s(za, zb, Fa, Fb, R, g, sameElement)
   ! slater overlap derv.
   ! derivative of explicit integral expression
   ! using maple
   implicit real(wp) (t)
   real(wp) za, zb, Fa, Fb
   real(wp) g, R
   logical sameElement

   if(sameElement) then
      t1 = za ** 2
      t3 = zb ** 2
      t5 = t1 * za * t3 * zb
      t6 = R ** 2
      t7 = t6 ** 2
      t10 = Fa * R
      t14 = exp(-0.5_wp * t10)
      t17 = sqrt(t5 * t7 * t6)
      g = -(1.0_wp/3.0_wp) * t5 * t7 / Fa * (0.2D1 + t10) * t14 / t17
   else
      t1 = za ** 2
      t3 = zb ** 2
      t5 = t1 * za * t3 * zb
      t6 = Fb ** 2
      t7 = Fb * R
      t8 = 0.5_wp * t7
      t9 = exp(t8)
      t12 = exp(-t8)
      t15 = t6 * Fa
      t22 = Fa ** 2
      t23 = t22 * t9
      t27 = t22 * t12
      t31 = t6 * Fb
      t32 = R * t31
      t37 = t22 * Fa
      t38 = R * t37
      t43 = R ** 2
      t44 = t43 * t31
      t51 = t43 * t37
      t56 = 0.4D1 * t6 * t9 - 0.4D1 * t6 * t12 + 0.2D1 * t15 * R * t9 -          &
      0.2D1 * t15 * R * t12 - 0.4D1 * t23 + 0.2D1 * t23 * t7 + 0.4D1 * t27       &
      + 0.2D1 * t27 * t7 - 0.2D1 * t32 * t9 - 0.2D1 * t32 * t12 - 0.2D1 * t38 *  &
      t9 + 0.2D1 * t38 * t12 - 0.1D1 * t44 * Fa * t9 - 0.1D1                     &
      * t44 * Fa * t12 + t51 * t9 * Fb + t51 * t12 * Fb
      t61 = exp(-0.5_wp * Fa * R)
      t62 = t43 ** 2
      t65 = sqrt(t5 * t62 * t43)
      g = -0.2D1 * t5 * R * t56 * t61 / t65 / t31 / t37
   end if


end subroutine g1s1s


subroutine g2s1s(za, zb, Fa, Fb, R, g, switch, lsame)
   ! slater overlap derv.
   ! derivative of explicit integral expression
   ! using maple
   implicit real(wp) (t)
   real(wp) za, zb, Fa, Fb
   real(wp) g, R, norm
   logical switch
   logical lsame
   norm = (1d0/24d0)*sqrt(za**3*zb**5*3d0)

   if(switch) then
      Fb = -Fb
   endif

   if(lsame) then

      t1 = Fa * R
      t3 = exp(-0.5000000000_wp * t1)
      t6 = Fa ** 2
      t7 = R ** 2
      g = -0.1000000000D-8 * R * t3 * (0.5333333380D10 + 0.2666666670D10 &
      * t1 + 0.1333333333D10 * t6 * t7) / t6
      g = g*norm

   else

      t3 = exp(-0.5000000000_wp * Fa * R)
      t4 = Fa ** 2
      t5 = t4 * Fa
      t6 = Fb * R
      t7 = 0.5000000000_wp * t6
      t8 = exp(t7)
      t9 = t5 * t8
      t11 = Fb ** 2
      t12 = t11 * Fa
      t15 = exp(-t7)
      t18 = t4 ** 2
      t19 = R * t18
      t22 = t11 ** 2
      t29 = Fb * t4
      t36 = R ** 2
      t37 = t36 * t18
      t44 = t36 * R
      t48 = -0.12D2 * t9 + 0.4D1 * t12 * t8 - 0.4D1 * t12 * t15 &
      - 0.6D1 * t19 * t8 - 0.6D1 * t22 * t8 * R - 0.6D1 * t22 * t15 &
      * R + 0.4D1 * t29 * t15 - 0.4D1 * t29 * t8 + 0.6D1 * t19 * t15 &
      + 0.2D1 * t37 * t8 * Fb + 0.4D1 * t37 * t15 * Fb + t44 * t18 * t15 * t11
      t49 = t5 * t15
      t51 = t11 * Fb
      t58 = t51 * Fa
      t59 = R * t8
      t76 = t36 * t15
      t79 = t22 * Fa
      t87 = 0.12D2 * t49 - 0.12D2 * t51 * t15 - 0.1D1 * t22 * t4 * t15 * t44 &
      + 0.4D1 * t58 * t59 - 0.8D1 * t58 * R * t15 + 0.4D1 * t9 * t6 + 0.8D1 * &
      t49 * t6 + 0.2D1 * t49 * t11 * t36 + 0.4D1 * t11 * t4 * t59 - 0.2D1 * t51 &
      * t4 * t76 - 0.2D1 * t79 * t36 * t8 - 0.4D1 * t79 * t76 + 0.12D2 * t51 * t8
      g = -0.16D2 * t3 * (t48 + t87) / t36 / t22 / t18
      g = g*norm
   end if

end subroutine g2s1s

subroutine g2s2s(za, zb, Fa, Fb, R, g, SameElement)
   ! slater overlap derv.
   ! derivative of explicit integral expression
   ! using maple
   implicit real(wp) (t)
   real(wp) za, zb, Fa, Fb
   real(wp) g, R, norm
   logical SameElement

   norm = 1d0/(16d0*3d0)*SQRT((ZA*ZB)**5)

   if(SameElement) then

      t2 = R ** 2
      t5 = Fa ** 2
      t9 = t5 * Fa
      t10 = t2 ** 2
      t16 = exp(-Fa * R / 0.2D1)
      g = (-0.4266666666D2 * R - 0.2133333333D2 * Fa * t2 - 0.2133333333D1 &
          * t5 * t2 * R - 0.1066666666D1 * t9 * t10) * t16 / t9
      g = g*norm


   else
      t1 = R ** 2
      t3 = 0.3840000000D3 * t1 * Fb
      t4 = t1 * R
      t5 = Fb ** 2
      t7 = 0.6400000000D2 * t4 * t5
      t8 = 0.7680000000D3 * R
      t10 = Fa ** 2
      t11 = t10 ** 2
      t12 = t11 * Fa
      t14 = Fb * R
      t15 = 0.768000000D3 * t14
      t17 = 0.1280000000D3 * t5 * t1
      t21 = 0.256000000D3 * t5 * R
      t22 = t5 * Fb
      t24 = 0.1280000000D3 * t22 * t1
      t26 = t10 * Fa
      t28 = t5 ** 2
      t30 = 0.1280000000D3 * t1 * t28
      t32 = 0.256000000D3 * t22 * R
      t33 = 0.512000000D3 * t5
      t34 = t28 * Fb
      t36 = 0.6400000000D2 * t4 * t34
      t40 = 0.768000000D3 * t28 * R
      t42 = 0.3840000000D3 * t1 * t34
      t45 = 0.1536000000D4 * t28
      t47 = 0.7680000000D3 * t34 * R
      t51 = exp(-0.5_wp * Fa * R)
      t53 = 0.5_wp * t14
      t54 = exp(-t53)
      t68 = exp(t53)
      g = (((t3 + t7 + t8) * t12 + (0.1536000000D4 + t15 + t17) * t11 + &
      (-t21 - t24) * t26 + (t30 - t32 - t33 + t36) * t10 + (t40 + t42) *&
      Fa + t45 + t47) * t51 * t54 + ((t3 - t8 - t7) * t12 + (-0.1536000000D4 &
      + t15 - t17) * t11 + (-t24 + t21) * t26 + (-t30 + t33 - t32 &
      + t36) * t10 + (-t40 + t42) * Fa + t47 - t45) * t51 * t68) / t1 /  &
      t12 / t34


      g = g*norm
   endif

end subroutine g2s2s


subroutine g1s3s(za, zb, Fa, Fb, R, g, switch, lsame)
   ! slater overlap derv.
   ! derivative of explicit integral expression
   ! using maple
   implicit real(wp) (t)
   real(wp) za, zb, Fa, Fb
   real(wp) g, R, norm
   logical switch
   logical lsame

   if(switch) Fb = -Fb

   norm = SQRT((ZA**3)*(ZB**7)/7.5_wp)/(16d0*sqrt(3d0))

   if(lsame) then

      t1 = Fa * R
      t3 = exp(-0.5000000000_wp * t1)
      t4 = R ** 2
      g = -0.1600000000D1 * t3 * t4 * R * (0.2D1 + t1) / Fa
      g = g*norm
   else

      t3 = exp(-0.5000_wp * Fa * R)
      t4 = Fb ** 2
      t5 = t4 ** 2
      t6 = t5 * Fb
      t7 = t6 * Fa
      t8 = R ** 2
      t9 = Fb * R
      t10 = 0.50_wp * t9
      t11 = exp(t10)
      t15 = exp(-t10)
      t16 = t8 * t15
      t19 = Fa ** 2
      t21 = t8 * R
      t22 = t21 * t15
      t25 = t19 * Fa
      t27 = t8 ** 2
      t31 = t19 ** 2
      t32 = t31 * Fa
      t33 = t8 * t32
      t45 = t4 * Fb
      t48 = t31 * t15
      t55 = t4 * t25
      t56 = t11 * R
      t59 = t15 * R
      t62 = t5 * Fa
      t73 = -0.6D1 * t7 * t8 * t11 - 0.18D2 * t7 * t16 - 0.6D1 * t6 * t19 &
      * t22 - 0.1D1 * t6 * t25 * t27 * t15 + 0.6D1 * t33 * t11 * Fb + 0.18D2 &
      * t33 * t15 * Fb + 0.6D1 * t21 * t32 * t15 * t4 + t27 * t32* t15 * t45 &
      + 0.2D1 * t48 * t45 * t21 + 0.12D2 * t48 * t4 * t8 + 0.12D2 * t55 * t56 &
      + 0.12D2 * t55 * t59 + 0.12D2 * t62 * t56 - 0.36D2 * t62 * t59 - 0.12D2 &
      * t5 * t19 * t16 - 0.2D1 * t5 * t25 * t22
      t74 = t31 * t11
      t79 = t45 * t19
      t92 = R * t32
      t95 = t45 * Fa
      t100 = Fb * t25
      t111 = 0.12D2 * t74 * t9 + 0.36D2 * t48 * t9 + 0.12D2 * t79 * t56 - 0.12D2  &
      * t79 * t59 + 0.48D2 * t5 * t11 - 0.24D2 * t6 * t11 * R - 0.24D2 * t6 * t15 &
      * R - 0.24D2 * t92 * t11 + 0.24D2 * t95 * t11 - 0.24D2 * t95 * t15 + 0.24D2 &
      * t100 * t15 + 0.24D2 * t92 * t15 - 0.24D2 * t100 * t11 - 0.48D2 * t5 * t15 &
      - 0.48D2 * t74 + 0.48D2 * t48
      g = -0.32D2 * t3 * (t73 + t111) / t8 / t6 / t32

      g = g*norm
   endif

end subroutine g1s3s


subroutine g2s3s(za, zb, Fa, Fb, R, g, switch, lsame)
   ! slater overlap derv.
   ! derivative of explicit integral expression
   ! using maple
   implicit real(wp) (t)
   real(wp) za, zb, Fa, Fb
   real(wp) g, R, norm
   logical switch
   logical lsame
   norm = sqrt((za**5)*(zb**7)/7.5_wp)/96.d0

   if(switch) Fb = -Fb

   if(lsame) then
      t1 = Fa * R
      t3 = exp(-0.5000000000_wp * t1)
      t6 = Fa ** 2
      t7 = R ** 2
      t14 = t6 ** 2
      t15 = t7 ** 2
      g = -0.2000000000D-8 * R * t3 * (0.1280000000D12 + 0.6400000000D11 &
      * t1 + 0.1280000000D11 * t6 * t7 + 0.1066666670D10 * t6 * Fa * t7 &
      * R + 0.533333333D9 * t14 * t15) / t14
      g = g*norm
   else

      t3 = exp(-0.5_wp * Fa * R)
      t4 = Fb ** 2
      t5 = t4 ** 2
      t6 = Fa ** 2
      t7 = t6 * Fa
      t8 = t5 * t7
      t9 = R ** 2
      t11 = 0.50_wp * Fb * R
      t12 = exp(t11)
      t13 = t9 * t12
      t16 = t6 ** 2
      t17 = t16 * Fa
      t18 = exp(-t11)
      t21 = t5 * Fb
      t28 = t9 * t18
      t32 = t9 * R
      t33 = t32 * t18
      t36 = t5 * t4
      t38 = t9 ** 2
      t39 = t38 * t18
      t41 = t21 * Fa
      t42 = R * t12
      t45 = t16 * t6
      t46 = t4 * Fb
      t49 = t46 * t16
      t52 = -0.6D1 * t8 * t13 + 0.120D3 * t17 * t18 + 0.120D3 * t21 * t18 &
       - 0.120D3 * t17 * t12 - 0.120D3 * t21 * t12 - 0.6D1 * t8 * t28 - 0.2D1 &
      * t5 * t16 * t33 + t36 * t7 * t39 - 0.48D2 * t41 * t42 + t45 * t46 * t39 - 0.6D1 * t49 * t13
      t54 = R * t18
      t60 = t46 * t6
      t63 = Fb * t16
      t66 = t5 * Fa
      t69 = t4 * t7
      t72 = t36 * t6
      t75 = t32 * t12
      t78 = Fb * t9
      t84 = Fb * t17
      t87 = -0.24D2 * t46 * t7 * t54 - 0.24D2 * t5 * t6 * t42 + 0.24D2 *&
       t60 * t12 + 0.24D2 * t63 * t18 - 0.24D2 * t66 * t12 - 0.24D2 * t69 &
      * t18 + 0.9D1 * t72 * t33 + 0.3D1 * t72 * t75 + 0.24D2 * t78 * t45 &
      * t12 - 0.6D1 * t49 * t28 + 0.48D2 * t84 * t42
      t102 = t21 * t6
      t105 = t4 * t17
      t113 = t45 * t4
      t118 = 0.72D2 * t84 * t54 + 0.72D2 * t41 * t54 + 0.36D2 * t78 * t45 &
      * t18 + 0.2D1 * t46 * t17 * t33 + 0.24D2 * t4 * t16 * t42 - 0.6D1   &
      * t102 * t13 - 0.6D1 * t105 * t13 + 0.18D2 * t105 * t28 + 0.2D1 &
      * t21 * t7 * t33 - 0.3D1 * t113 * t75 + 0.9D1 * t113 * t33
      t121 = t36 * Fa
      t130 = R * t45
      t145 = 0.18D2 * t102 * t28 + 0.24D2 * t121 * t13 + 0.36D2 * t121 * &
       t28 - 0.24D2 * t60 * t18 - 0.24D2 * t63 * t12 + 0.60D2 * t130 * t18 &
      + 0.60D2 * t36 * t18 * R + 0.24D2 * t69 * t12 + 0.60D2 * t36 * t12 * &
      R - 0.60D2 * t130 * t12 + 0.24D2 * t66 * t18
      g = 0.128D3 * t3 * (t52 + t87 + t118 + t145) / t9 / t36 / t45

   g = g*norm
   endif

end subroutine g2s3s


subroutine g3s3s(za, zb, Fa, Fb, R, g, SameElement)
   ! slater overlap derv.
   ! derivative of explicit integral expression
   ! using maple
   implicit real(wp) (t)
   real(wp) za, zb, Fa, Fb
   real(wp) g, R, norm
   logical SameElement

   norm = sqrt((ZA*ZB)**7)/1440.d0

   if(SameElement) then

      t1 = Fa * R
      t3 = exp(-0.5000000000_wp * t1)
      t5 = Fa ** 2
      t6 = t5 ** 2
      t7 = t6 * Fa
      t8 = R ** 2
      t9 = t8 ** 2
      g = -0.2000000000D-8 * t3 * R * (0.457142857D9 * t7 * t9 &
      * R + 0.7680000000D12 * t1 + 0.1536000000D12 * t5 * t8 &
      + 0.1280000000D11 * t5 * Fa * t8 * R + 0.914285715D9 * t6 * t9 + 0.1536000000D13) / t7

      g = g*norm
   else

      t3 = exp(-0.5000000000_wp * Fa * R)
      t4 = Fa ** 2
      t5 = t4 ** 2
      t6 = t5 * t4
      t7 = Fb * R
      t8 = 0.5000000000_wp * t7
      t9 = exp(-t8)
      t10 = t6 * t9
      t13 = Fb ** 2
      t14 = t13 * Fb
      t15 = t13 ** 2
      t16 = t15 * t14
      t17 = R ** 2
      t18 = t17 * R
      t19 = t16 * t18
      t23 = exp(t8)
      t24 = t6 * t23
      t27 = t5 * Fa
      t28 = t27 * t13
      t29 = R * t23
      t32 = t6 * t13
      t33 = t17 * t9
      t36 = t15 * Fb
      t37 = t4 * t36
      t38 = t9 * R
      t43 = t17 * t23
      t46 = t4 * Fa
      t47 = t5 * t46
      t48 = t47 * t18
      t52 = t47 * t17
      t65 = 0.120D3 * t10 * t7 - 0.12D2 * t19 * t4 * t9 + 0.120D3 &
      * t24 * t7 + 0.24D2 * t28 * t29 + 0.24D2 * t32 * t33 + 0.24D2 * t37 &
      * t38 - 0.24D2 * t28 * t38 - 0.24D2 * t32 * t43 - 0.12D2 * t48 * t13 &
      * t23 + 0.60D2 * t52 * t23 * Fb + 0.12D2 * t48 * t13 * t9 + 0.60D2 &
      * t52 * t9 * Fb - 0.12D2 * t19 * t4 * t23
      t66 = t17 ** 2
      t67 = t16 * t66
      t74 = t27 * t14
      t77 = t6 * t14
      t78 = t18 * t23
      t81 = t46 * t15
      t86 = t27 * t15
      t89 = t5 * t36
      t90 = t18 * t9
      t97 = t46 * t36
      t104 = -0.1D1 * t67 * t46 * t9 - 0.1D1 * t67 * t46 * t23 - 0.12D2 &
      * t74 * t43 + 0.2D1 * t77 * t78 - 0.24D2 * t81 * t29 + 0.24D2 * t81 &
      * t38 + 0.2D1 * t86 * t78 + 0.2D1 * t89 * t90 - 0.2D1 * t86 * t90 &
      + 0.24D2 * t37 * t29 + 0.12D2 * t97 * t33 + 0.2D1 * t89 * t78 - 0.12D2 * t74 * t33
      t108 = t5 * t14
      t111 = t15 * t13
      t112 = t111 * t4
      t117 = t111 * t46
      t122 = t111 * Fa
      t129 = t4 * t15
      t132 = t47 * R
      t139 = 0.2D1 * t77 * t90 - 0.24D2 * t108 * t38 + 0.24D2 * t112 * t43 &
      - 0.24D2 * t112 * t33 + 0.2D1 * t117 * t78 - 0.2D1 * t117 * t90 + 0.120D3 &
      * t122 * t29 - 0.120D3 * t122 * t38 + 0.12D2 * t97 * t43 - 0.48D2 * t129 &
      * t23 + 0.120D3 * t132 * t9 - 0.120D3 * t132 * t23 + 0.240D3 * t111 * t23
      t140 = t47 * t66
      t145 = t16 * R
      t150 = t16 * t17
      t160 = t5 * t13
      t170 = t140 * t14 * t23 + t140 * t14 * t9 - 0.120D3 * t145 * t9 - 0.24D2 &
      * t108 * t29 - 0.60D2 * t150 * Fa * t23 - 0.240D3 * t111 * t9 - 0.240D3 &
      * t24 + 0.240D3 * t10 + 0.48D2 * t129 * t9 - 0.48D2 * t160 * t9 + 0.48D2 &
      * t160 * t23 - 0.120D3 * t145 * t23 - 0.60D2 * t150 * Fa * t9
      g = -0.768D3 * t3 * (t65 + t104 + t139 + t170) / t17 / t47 / t16

      g = g*norm
   endif

end subroutine g3s3s

end module dftd3_gcp

! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/post-processing/xtb-ml/density.f90
!> Density-based xTB-ML features using Mulliken partitioning
module tblite_post_processing_xtbml_density
   use mctc_env, only : wp, error_type
   use mctc_io, only : structure_type
   use tblite_basis_type, only : basis_type
   use tblite_container_list, only : cache_list
   use tblite_double_dictionary, only : double_dictionary_type
   use tblite_integral_type, only : integral_type
   use tblite_post_processing_xtbml_cache, only : xtbml_cache
   use tblite_post_processing_xtbml_convolution, only : xtbml_convolution
   use tblite_post_processing_xtbml_features, only : xtbml_feature_type
   use tblite_output_format, only : format_string
   use tblite_wavefunction_mulliken, only : get_mulliken_shell_multipoles
   use tblite_wavefunction_spin, only : magnet_to_updown
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_xtb_calculator, only : xtb_calculator
   implicit none
   private

   public :: new_xtbml_density_features, xtbml_density_features

   !> Density-based xTB-ML features
   type, extends(xtbml_feature_type) :: xtbml_density_features
      !> Flag to return cartesian components
      logical :: return_xyz
   contains
      !> Compute xTB-ML density-based features
      procedure :: compute_features
      !> Compute extended xTB-ML density-based features with convolution
      procedure :: compute_extended
   end type xtbml_density_features

   character(len=*), parameter :: label = "density-based features"

   ! Labels for the shell angular momenta
   character(len=1), parameter :: shell_labels(0:4) = &
      [character(len=1) :: "s", "p", "d", "f", "g"]

   ! Labels for the dipole moment components
   character(len=1), parameter :: dp_labels(3) = &
      [character(len=1) :: "x", "y", "z"]

   ! Labels for the quadrupole moment components
   character(len=2), parameter :: qp_labels(6) = &
      [character(len=2) :: "xx", "xy", "yy", "xz", "yz", "zz"]

   character(len=0), parameter :: empty = ""

contains


subroutine new_xtbml_density_features(self, return_xyz)
   !> Instance of the xTB-ML density features
   class(xtbml_density_features), intent(out) :: self
   !> Flag to return cartesian components
   logical, intent(in) :: return_xyz

   self%label = label
   self%return_xyz = return_xyz

end subroutine new_xtbml_density_features


subroutine compute_features(self, mol, wfn, ints, calc, caches, mlcache, &
   & dict, n_features, error)
   !> Instance of the xTB-ML density features
   class(xtbml_density_features), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction strcuture data
   type(wavefunction_type), intent(in) :: wfn
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Single-point calculator
   type(xtb_calculator), intent(in) :: calc
   !> Cache list for storing caches of various interactions
   type(cache_list), intent(inout) :: caches
   !> Cache for xTB-ML features
   type(xtbml_cache), intent(inout) :: mlcache
   !> Dictionary for storing results
   type(double_dictionary_type), intent(inout) :: dict
   !> Number of features
   integer, intent(inout) :: n_features
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: spin, ic
   real(wp), allocatable :: psh(:, :), qat(:, :), dpsh(:, :, :), qpsh(:, :, :)
   real(wp), allocatable :: dpsh_norm(:, :), qpsh_norm(:, :)
   real(wp), allocatable :: dpat_norm(:, :), qpat_norm(:, :)
   character(len=:), allocatable :: spin_label(:)

   ! Select the spin label
   if (wfn%nspin > 1) then
      spin_label = [character(len=6) ::"_alpha", "_beta"]
   else
      spin_label = [""]
   end if

   ! Restore Mulliken alpha/beta shell populations from Mulliken shell charges
   if (.not. allocated(mlcache%psh)) then
      allocate(mlcache%psh(calc%bas%nsh, wfn%nspin), source=-wfn%qsh)
   else
      mlcache%psh = -wfn%qsh
   end if
   mlcache%psh(:, 1) = wfn%n0sh + mlcache%psh(:, 1)
   call magnet_to_updown(mlcache%psh)

   ! Convert atomic charges and magnetization to alpha/beta representation
   if (.not. allocated(mlcache%qat)) then
      allocate(mlcache%qat(mol%nat, wfn%nspin), source=wfn%qat)
   else
      mlcache%qat = wfn%qat
   end if
   call magnet_to_updown(mlcache%qat)

   ! Compute shell multipoles missing in the wavefunction
   if (.not. allocated(mlcache%dpsh)) then
      allocate(mlcache%dpsh(3, calc%bas%nsh, wfn%nspin), source=0.0_wp)
   end if
   if (.not. allocated(mlcache%qpsh)) then
      allocate(mlcache%qpsh(6, calc%bas%nsh, wfn%nspin), source=0.0_wp)
   end if
   call get_mulliken_shell_multipoles(calc%bas, ints%dipole, wfn%density, &
      & mlcache%dpsh)
   call get_mulliken_shell_multipoles(calc%bas, ints%quadrupole, wfn%density, &
      & mlcache%qpsh)

   ! Calculate shell multipole norms
   if (.not. allocated(mlcache%dpsh_norm)) then
      allocate(mlcache%dpsh_norm(calc%bas%nsh, wfn%nspin), source=0.0_wp)
   end if
   if (.not. allocated(mlcache%qpsh_norm)) then
      allocate(mlcache%qpsh_norm(calc%bas%nsh, wfn%nspin), source=0.0_wp)
   end if
   call multipole_norm(mlcache%dpsh, mlcache%qpsh, mlcache%dpsh_norm, &
      & mlcache%qpsh_norm)

   ! Calculate atomic multipole norms
   if (.not. allocated(mlcache%dpat_norm)) then
      allocate(mlcache%dpat_norm(mol%nat, wfn%nspin), source=0.0_wp)
   end if
   if (.not. allocated(mlcache%qpat_norm)) then
      allocate(mlcache%qpat_norm(mol%nat, wfn%nspin), source=0.0_wp)
   end if
   call multipole_norm(wfn%dpat, wfn%qpat, mlcache%dpat_norm, mlcache%qpat_norm)

   ! Store features in dictionary
   do spin = 1, wfn%nspin

      ! Store shell Mulliken populations
      call add_shell_feature(mol, calc%bas, mlcache%psh(:, spin), "p", empty, &
         & spin_label(spin), dict, n_features)

      ! Store shell dipole moment norms
      call add_shell_feature(mol, calc%bas, mlcache%dpsh_norm(:, spin), "dipm", &
         & empty, spin_label(spin), dict, n_features)
      
      ! Optionally store shell dipole moment components
      if (self%return_xyz) then
         do ic = 1, size(dp_labels)
            call add_shell_feature(mol, calc%bas, mlcache%dpsh(ic, :, spin), &
               & "dipm", "_"//trim(dp_labels(ic)), spin_label(spin), dict, &
               & n_features)
         end do
      end if

      ! Store shell quadrupole moment norms
      call add_shell_feature(mol, calc%bas, mlcache%qpsh_norm(:, spin), "qm", &
         & empty, spin_label(spin), dict, n_features)

      ! Optionally store shell quadrupole moment components
      if (self%return_xyz) then
         do ic = 1, size(qp_labels)
            call add_shell_feature(mol, calc%bas, mlcache%qpsh(ic, :, spin), &
               & "qm", "_"//trim(qp_labels(ic)), spin_label(spin), dict, &
               & n_features)
         end do
      end if

      ! Store atomic Mulliken charges
      call add_atom_feature(mol, mlcache%qat(:, spin), "q_A", empty, &
         & spin_label(spin), dict, n_features)

      ! Store atomic dipole moment norms
      call add_atom_feature(mol, mlcache%dpat_norm(:, spin), "dipm_A", empty, &
         & spin_label(spin), dict, n_features)

      ! Optionally store atomic dipole moment components
      if (self%return_xyz) then
         do ic = 1, size(dp_labels)
            call add_atom_feature(mol, wfn%dpat(ic, :, spin), "dipm_A", &
               & "_"//trim(dp_labels(ic)), spin_label(spin), dict, n_features)
         end do
      end if

      ! Store atomic quadrupole moment norms
      call add_atom_feature(mol, mlcache%qpat_norm(:, spin), "qm_A", empty, &
         & spin_label(spin), dict, n_features)

      ! Optionally store atomic quadrupole moment components
      if (self%return_xyz) then
         do ic = 1, size(qp_labels)
            call add_atom_feature(mol, wfn%qpat(ic, :, spin), "qm_A", &
               & "_"//trim(qp_labels(ic)), spin_label(spin), dict, n_features)
         end do
      end if

   end do

end subroutine compute_features


subroutine compute_extended(self, mol, wfn, ints, calc, caches, mlcache, &
   & convolution, dict, n_features, error)
   !> Instance of the xTB-ML density features
   class(xtbml_density_features), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction strcuture data
   type(wavefunction_type), intent(in) :: wfn
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Single-point calculator
   type(xtb_calculator), intent(in) :: calc
   !> Cache list for storing caches of various interactions
   type(cache_list), intent(inout) :: caches
   !> Cache for xTB-ML features
   type(xtbml_cache), intent(inout) :: mlcache
   !> Convolution container
   type(xtbml_convolution), intent(in) :: convolution
   !> Dictionary for storing results
   type(double_dictionary_type), intent(inout) :: dict
   !> Number of features
   integer, intent(inout) :: n_features
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: spin, ic, isc
   real(wp), allocatable :: ext_qat(:, :), ext_dpat(:, :, :), ext_qpat(:, :, :)
   real(wp), allocatable :: ext_dpat_norm(:, :), ext_qpat_norm(:, :)
   real(wp), allocatable :: ext_dpat_z(:, :, :), ext_qpat_z(:, :, :)
   real(wp), allocatable :: ext_dpat_z_norm(:, :), ext_qpat_z_norm(:, :)
   real(wp), allocatable :: ext_dpat_p(:, :, :), ext_qpat_p(:, :, :)
   real(wp), allocatable :: ext_dpat_p_norm(:, :), ext_qpat_p_norm(:, :)
   real(wp), allocatable :: pat(:, :)
   character(len=:), allocatable :: a_label, conv_label, spin_label(:)

   ! Select the spin label
   if (wfn%nspin > 1) then
      spin_label = [character(len=6) :: "_alpha", "_beta"]
   else
      spin_label = [""]
   end if

   allocate(ext_qat(mol%nat, convolution%nscale))
   allocate(ext_dpat(3, mol%nat, convolution%nscale))
   allocate(ext_qpat(6, mol%nat, convolution%nscale))
   allocate(ext_dpat_z(3, mol%nat, convolution%nscale))
   allocate(ext_qpat_z(6, mol%nat, convolution%nscale))
   allocate(ext_dpat_p(3, mol%nat, convolution%nscale))
   allocate(ext_qpat_p(6, mol%nat, convolution%nscale))
   allocate(ext_dpat_norm(mol%nat, convolution%nscale))
   allocate(ext_qpat_norm(mol%nat, convolution%nscale))
   allocate(ext_dpat_z_norm(mol%nat, convolution%nscale))
   allocate(ext_qpat_z_norm(mol%nat, convolution%nscale))
   allocate(ext_dpat_p_norm(mol%nat, convolution%nscale))
   allocate(ext_qpat_p_norm(mol%nat, convolution%nscale))

   ! Atomic Mulliken populations
   allocate(pat(mol%nat, wfn%nspin), source=-wfn%qat)
   pat(:, 1) = wfn%n0at + pat(:, 1)
   call magnet_to_updown(pat)

   ! Calculate convolutions and store features in dictionary
   do spin = 1, wfn%nspin

      ! Compute convolution of atomic Mulliken charges
      call convolve_scalar(mol, mlcache%qat(:, spin), convolution%nscale, &
         & mlcache%conv_kernel, mlcache%conv_cn, ext_qat)

      ! Compute convolution of atomic multipole moments and Mulliken charges
      call convolve_multipole(mol, mlcache%qat(:, spin), convolution%nscale, &
         & mlcache%conv_kernel, mlcache%conv_cn, ext_dpat, ext_qpat, &
         & wfn%dpat(:, :, spin), wfn%qpat(:, :, spin))

      ! Compute norms of the extended atomic multipole moment convolution
      call multipole_norm(ext_dpat, ext_qpat, ext_dpat_norm, ext_qpat_norm)

      ! Compute convolution of atomic multipole moments and electronic populations
      call convolve_multipole(mol, -pat(:, spin), convolution%nscale, &
         & mlcache%conv_kernel, mlcache%conv_cn, ext_dpat_p, ext_qpat_p, &
         & wfn%dpat(:, :, spin), wfn%qpat(:, :, spin))

      ! Compute norms of the extended atomic multipole moment convolution
      call multipole_norm(ext_dpat_p, ext_qpat_p, ext_dpat_p_norm, ext_qpat_p_norm)

      ! Compute convolution of atomic multipole moments due to screened nuclear charges
      call convolve_multipole(mol, wfn%n0at, convolution%nscale, &
         & mlcache%conv_kernel, mlcache%conv_cn, ext_dpat_z, ext_qpat_z)

      ! Compute norms of the extended atomic multipole moment convolution
      call multipole_norm(ext_dpat_z, ext_qpat_z, ext_dpat_z_norm, ext_qpat_z_norm)

      do isc = 1, convolution%nscale

         ! Suffix for combined spin and convolution
         a_label = "_"//trim(adjustl(format_string(convolution%rcov_scale(isc), '(f12.2)')))
         if (a_label == "_1.00") a_label = empty
         conv_label = trim(spin_label(spin))//a_label

         ! Store convolved atomic charges
         call add_atom_feature(mol, ext_qat(:, isc), "ext_q_A", empty, &
            & conv_label, dict, n_features)

         ! Store convolved dipole moment norms
         call add_atom_feature(mol, ext_dpat_norm(:, isc), "ext_dipm_A", &
            & empty, conv_label, dict, n_features)

         ! Optionally store convolved dipole moment components
         if (self%return_xyz) then
            do ic = 1, size(dp_labels)
               call add_atom_feature(mol, ext_dpat(ic, :, isc), "ext_dipm_A", &
                  & "_"//trim(dp_labels(ic)), conv_label, dict, n_features)
            end do
         end if

         ! Store convolved quadrupole moment norms
         call add_atom_feature(mol, ext_qpat_norm(:, isc), "ext_qm_A", &
            & empty, conv_label, dict, n_features)

         ! Optionally store convolved quadrupole moment components
         if (self%return_xyz) then
            do ic = 1, size(qp_labels)
               call add_atom_feature(mol, ext_qpat(ic, :, isc), "ext_qm_A", &
                  & "_"//trim(qp_labels(ic)), conv_label, dict, n_features)
            end do
         end if

         ! Store convolved dipole moment (population) norms
         call add_atom_feature(mol, ext_dpat_p_norm(:, isc), "ext_dipm_e", &
            & empty, conv_label, dict, n_features)

         ! Optionally store convolved dipole moment (population) components
         if (self%return_xyz) then
            do ic = 1, size(dp_labels)
               call add_atom_feature(mol, ext_dpat_p(ic, :, isc), "ext_dipm_e", &
                  & "_"//trim(dp_labels(ic)), conv_label, dict, n_features)
            end do
         end if

         ! Store convolved quadrupole moment (population) norms
         call add_atom_feature(mol, ext_qpat_p_norm(:, isc), "ext_qm_e", &
            & empty, conv_label, dict, n_features)

         ! Optionally store convolved quadrupole moment (population) components
         if (self%return_xyz) then
            do ic = 1, size(qp_labels)
               call add_atom_feature(mol, ext_qpat_p(ic, :, isc), "ext_qm_e", &
                  & "_"//trim(qp_labels(ic)), conv_label, dict, n_features)
            end do
         end if

         ! Store convolved dipole moment (nuclear charge) norms
         call add_atom_feature(mol, ext_dpat_z_norm(:, isc), "ext_dipm_Z", &
            & empty, conv_label, dict, n_features)

         ! Optionally store convolved dipole moment (nuclear charge) components
         if (self%return_xyz) then
            do ic = 1, size(dp_labels)
               call add_atom_feature(mol, ext_dpat_z(ic, :, isc), "ext_dipm_Z", &
                  & "_"//trim(dp_labels(ic)), conv_label, dict, n_features)
            end do
         end if

         ! Store convolved quadrupole moment (nuclear charge) norms
         call add_atom_feature(mol, ext_qpat_z_norm(:, isc), "ext_qm_Z", &
            & empty, conv_label, dict, n_features)

         ! Optionally store convolved quadrupole moment (nuclear charge) components
         if (self%return_xyz) then
            do ic = 1, size(qp_labels)
               call add_atom_feature(mol, ext_qpat_z(ic, :, isc), "ext_qm_Z", &
                  & "_"//trim(qp_labels(ic)), conv_label, dict, n_features)
            end do
         end if

      end do
   end do

end subroutine compute_extended


!> Compute the norm for dipole and quadrupole moments
subroutine multipole_norm(dp, qp, dp_norm, qp_norm)
   !> Dipole moment
   real(wp), intent(in) :: dp(:, :, :)
   !> Quadrupole moment
   real(wp), intent(in) :: qp(:, :, :)
   !> Frobenius norm of the dipole moment tensor
   real(wp), intent(out) :: dp_norm(:, :)
   !> Frobenius norm of the quadrupole moment tensor
   real(wp), intent(out) :: qp_norm(:, :)

   dp_norm(:, :) = sqrt(dp(1, :, :)**2 + dp(2, :, :)**2 + dp(3, :, :)**2)

   qp_norm(:, :) = sqrt( &
      & qp(1, :, :)**2 + 2.0_wp * qp(2, :, :)**2 + &
      & qp(3, :, :)**2 + 2.0_wp * qp(4, :, :)**2 + &
      & 2.0_wp * qp(5, :, :)**2 + qp(6, :, :)**2)

end subroutine multipole_norm


!> Add shell-resolved properties to dictionary in angular-momentum categories 
subroutine add_shell_feature(mol, bas, shell_prop, prefix, postfix, &
   & spin_label, dict, n_features)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Shell-resolved property data
   real(wp), intent(in) :: shell_prop(:)
   !> Feature name prefix
   character(len=*), intent(in) :: prefix
   !> Feature name postfix
   character(len=*), intent(in) :: postfix
   !> Spin label suffix
   character(len=*), intent(in) :: spin_label
   !> Dictionary for storing results
   type(double_dictionary_type), intent(inout) :: dict
   !> Number of features
   integer, intent(inout) :: n_features

   real(wp), allocatable :: angmom_prop(:, :)
   integer :: il

   ! Count number of features
   n_features = n_features + bas%maxl + 1

   ! Reorganize into angular-momentum categories
   allocate(angmom_prop(mol%nat, bas%maxl+1))
   call reorganize_shell_to_angmom(mol, bas, shell_prop, angmom_prop)

   do il = 0, bas%maxl
      call dict%add_entry( &
         trim(prefix)//"_"//trim(shell_labels(il))//trim(postfix)// &
            & trim(spin_label), angmom_prop(:, il+1))
   end do

end subroutine add_shell_feature


!> Add atom-resolved properties to dictionary
subroutine add_atom_feature(mol, atom_prop, prefix, postfix, spin_label, &
   & dict, n_features)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Atom-resolved property data
   real(wp), intent(in) :: atom_prop(:)
   !> Feature name prefix
   character(len=*), intent(in) :: prefix
   !> Feature name postfix
   character(len=*), intent(in) :: postfix
   !> Spin label suffix
   character(len=*), intent(in) :: spin_label
   !> Dictionary for storing results
   type(double_dictionary_type), intent(inout) :: dict
   !> Number of features
   integer, intent(inout) :: n_features

   ! Count number of features
   n_features = n_features + 1

   call dict%add_entry(trim(prefix)//trim(postfix)// &
      & trim(spin_label), atom_prop)

end subroutine add_atom_feature


!> Reorganize shell-resolved properties into angular-momentum categories
subroutine reorganize_shell_to_angmom(mol, bas, shell_prop, angmom_prop)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Shell-resolved property data
   real(wp), intent(in) :: shell_prop(:)
   !> Atomwise angular-momentum-resolved property data
   real(wp), intent(out) :: angmom_prop(:, :)

   integer :: iat, izp, is, ish, li

   angmom_prop(:, :) = 0.0_wp
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = bas%ish_at(iat)
      do ish = 1, bas%nsh_at(iat)
         li = bas%cgto(ish, izp)%ang

         angmom_prop(iat, li+1) = shell_prop(is+ish)
      end do
   end do

end subroutine reorganize_shell_to_angmom


!> Convolution for scalar atom-resolved properties
!> with rescaling based on the source coordination number
subroutine convolve_scalar(mol, atom_prop, nscale, kernel, cn, ext_prop)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Atom-resolved property data
   real(wp), intent(in) :: atom_prop(:)
   !> Number of convolution length scales
   integer, intent(in) :: nscale
   !> Convolution kernel
   real(wp), intent(in) :: kernel(:, :, :)
   !> Convolution coordination number
   real(wp), intent(in) :: cn(:, :)
   !> Convolved atom-resolved property data
   real(wp), intent(out) :: ext_prop(:, :)

   integer :: iat, jat, ksc
   real(wp) :: tmp

   ext_prop(:, :) = 0.0_wp

   !$omp parallel do default(none) collapse(2) schedule(runtime) &
   !$omp shared(mol, atom_prop, nscale, kernel, cn, ext_prop) &
   !$omp private(iat, jat, ksc, tmp)
   do ksc = 1, nscale
      do iat = 1, mol%nat
         tmp = 0.0_wp
         do jat = 1, mol%nat
            ! Convolution with rescaling based on source coordination number
            tmp = tmp + atom_prop(jat) / (kernel(iat, jat, ksc) &
               & * (cn(jat, ksc) + 1.0_wp))
         end do
         ext_prop(iat, ksc) = tmp
      end do
   end do

end subroutine convolve_scalar


!> Convolution of multipole moments induced by atom-resolved charges
!> with an optional additional multipole moment contribution
subroutine convolve_multipole(mol, qat, nscale, kernel, cn, &
   & ext_dp, ext_qp, dp, qp)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)
   !> Number of convolution length scales
   integer, intent(in) :: nscale
   !> Convolution kernel
   real(wp), intent(in) :: kernel(:, :, :)
   !> Convolution coordination number
   real(wp), intent(in) :: cn(:, :)
   !> Convolved dipole moments
   real(wp), intent(out) :: ext_dp(:, :, :)
   !> Convolved quadrupole moments
   real(wp), intent(out) :: ext_qp(:, :, :)
   !> Optional atom-resolved dipole moments
   real(wp), intent(in), optional :: dp(:, :)
   !> Optional atom-resolved quadrupole moments
   real(wp), intent(in), optional :: qp(:, :)

   integer :: iat, jat, ksc
   real(wp) :: weight, trace
   real(wp) :: rij(3), dj(3)
   real(wp) :: tmp_dp(3), tmp_qp_trans(6), tmp_qp(6)

   ext_dp(:, :, :) = 0.0_wp
   ext_qp(:, :, :) = 0.0_wp

   !$omp parallel do default(none) collapse(2) schedule(runtime) &
   !$omp shared(mol, qat, nscale, kernel, cn, ext_dp, ext_qp, dp, qp) &
   !$omp private(iat, jat, ksc, weight, trace, rij, dj) &
   !$omp private(tmp_dp, tmp_qp_trans, tmp_qp)
   do ksc = 1, nscale
      do iat = 1, mol%nat

         tmp_dp(:) = 0.0_wp
         tmp_qp_trans(:) = 0.0_wp
         tmp_qp(:) = 0.0_wp

         do jat = 1, mol%nat

            ! Convolution weight with rescaling based on source coordination number
            weight = 1.0_wp / (kernel(iat, jat, ksc) * (cn(jat, ksc) + 1.0_wp))

            rij(:) = mol%xyz(:, iat) - mol%xyz(:, jat)

            ! Check for dipole moments
            if (present(dp)) then
               dj(:) = dp(:, jat)
            else
               dj(:) = 0.0_wp
            end if

            ! Dipole moment and translated dipole moment due to charges
            tmp_dp(:) = tmp_dp + weight * (dj(:) - rij(:) * qat(jat))

            ! Translated quadrupole moment due to charges and dipole moments
            ! Cartesian quadrupole ordering: xx, xy, yy, xz, yz, zz
            tmp_qp_trans(1) = tmp_qp_trans(1) + 1.5_wp * weight &
               & * (-2.0_wp * rij(1) * dj(1) + rij(1) * rij(1) * qat(jat))
            tmp_qp_trans(2) = tmp_qp_trans(2) + 1.5_wp * weight &
               & * (-(rij(1) * dj(2) + rij(2) * dj(1)) + rij(1) * rij(2) * qat(jat))
            tmp_qp_trans(3) = tmp_qp_trans(3) + 1.5_wp * weight &
               & * (-2.0_wp * rij(2) * dj(2) + rij(2) * rij(2) * qat(jat))
            tmp_qp_trans(4) = tmp_qp_trans(4) + 1.5_wp * weight &
               & * (-(rij(3) * dj(1) + rij(1) * dj(3)) + rij(1) * rij(3) * qat(jat))
            tmp_qp_trans(5) = tmp_qp_trans(5) + 1.5_wp * weight &
               & * (-(rij(3) * dj(2) + rij(2) * dj(3)) + rij(2) * rij(3) * qat(jat))
            tmp_qp_trans(6) = tmp_qp_trans(6) + 1.5_wp * weight &
               & * (-2.0_wp * rij(3) * dj(3) + rij(3) * rij(3) * qat(jat))

            if (present(qp)) then
               ! Quadrupole moment contribution
               tmp_qp(:) = tmp_qp(:) + qp(:, jat) * weight
            end if
         end do

         ! Remove trace from quadrupole moment _transuced by point charges and dipoles
         trace = (tmp_qp_trans(1) + tmp_qp_trans(3) + tmp_qp_trans(6)) / 3.0_wp
         tmp_qp_trans(1) = tmp_qp_trans(1) - trace
         tmp_qp_trans(3) = tmp_qp_trans(3) - trace
         tmp_qp_trans(6) = tmp_qp_trans(6) - trace

         ext_dp(:, iat, ksc) = tmp_dp(:)
         ext_qp(:, iat, ksc) = tmp_qp_trans(:) + tmp_qp(:)

      end do
   end do

end subroutine convolve_multipole

end module tblite_post_processing_xtbml_density

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/api/param.f90
!> Provides API exports for the #tblite_param handle.

!> API export for managing parametrization records.
module tblite_api_param
   use, intrinsic :: iso_c_binding
   use mctc_env, only : fatal_error
   use tblite_api_error, only : vp_error
   use tblite_api_table, only : vp_table
   use tblite_api_version, only : namespace
   use tblite_api_utils, only : f_c_character
   use tblite_param, only : param_record
   use tblite_toml, only : toml_table
   use tblite_xtb_gfn1, only : export_gfn1_param
   use tblite_xtb_gfn2, only : export_gfn2_param
   use tblite_xtb_ipea1, only : export_ipea1_param
   implicit none
   private

   public :: vp_param
   public :: new_param_api, delete_param_api
   public :: load_param_api, dump_param_api
   public :: export_gfn1_param_api, export_gfn2_param_api, export_ipea1_param_api

   !> Void pointer to manage parametrization records
   type :: vp_param
      !> Actual payload
      type(param_record) :: ptr
   end type vp_param

   logical, parameter :: debug = .false.

contains

!> Create new parametrization records object
function new_param_api() &
      & result(vparam) &
      & bind(C, name=namespace//"new_param")
   type(vp_param), pointer :: param
   type(c_ptr) :: vparam

   if (debug) print '("[Info]", 1x, a)', "new_param"

   allocate(param)
   vparam = c_loc(param)
end function new_param_api

!> Delete paramrization records object
subroutine delete_param_api(vparam) &
      & bind(C, name=namespace//"delete_param")
   type(c_ptr), intent(inout) :: vparam
   type(vp_param), pointer :: param

   if (debug) print '("[Info]", 1x, a)', "delete_param"

   if (c_associated(vparam)) then
      call c_f_pointer(vparam, param)

      deallocate(param)
      vparam = c_null_ptr
   end if

end subroutine delete_param_api

!> Load parametrization record from data table
subroutine load_param_api(verror, vparam, vtable) &
      & bind(C, name=namespace//"load_param")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table

   if (debug) print '("[Info]", 1x, a)', "load_param"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vparam)) then
      call fatal_error(error%ptr, "Parametrization record is missing")
      return
   end if
   call c_f_pointer(vparam, param)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if
   call c_f_pointer(vtable, table)

   call param%ptr%load(table%ptr, error%ptr)

end subroutine load_param_api

!> Dump parametrization record to data table
subroutine dump_param_api(verror, vparam, vtable) &
      & bind(C, name=namespace//"dump_param")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table

   if (debug) print '("[Info]", 1x, a)', "dump_param"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vparam)) then
      call fatal_error(error%ptr, "Parametrization record is missing")
      return
   end if
   call c_f_pointer(vparam, param)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if
   call c_f_pointer(vtable, table)

   call param%ptr%dump(table%ptr, error%ptr)

end subroutine dump_param_api


subroutine export_gfn1_param_api(verror, vparam) &
      & bind(C, name=namespace//"export_gfn1_param")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param

   if (debug) print '("[Info]", 1x, a)', "export_gfn1_param"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vparam)) then
      call fatal_error(error%ptr, "Parametrization record is missing")
      return
   end if
   call c_f_pointer(vparam, param)

   call export_gfn1_param(param%ptr)
end subroutine export_gfn1_param_api


subroutine export_gfn2_param_api(verror, vparam) &
      & bind(C, name=namespace//"export_gfn2_param")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param

   if (debug) print '("[Info]", 1x, a)', "export_gfn2_param"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vparam)) then
      call fatal_error(error%ptr, "Parametrization record is missing")
      return
   end if
   call c_f_pointer(vparam, param)

   call export_gfn2_param(param%ptr)
end subroutine export_gfn2_param_api


subroutine export_ipea1_param_api(verror, vparam) &
      & bind(C, name=namespace//"export_ipea1_param")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param

   if (debug) print '("[Info]", 1x, a)', "ipea1_param"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vparam)) then
      call fatal_error(error%ptr, "Parametrization record is missing")
      return
   end if
   call c_f_pointer(vparam, param)

   call export_ipea1_param(param%ptr)
end subroutine export_ipea1_param_api

end module tblite_api_param

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/io/numpy/load.f90
!> Provides npy input routines

!> Implementation of npy input routines
module tblite_io_numpy_loadz
   use mctc_env, only : dp, i2, i4
   use tblite_io_numpy_constants, only : type_rdp, type_i4, &
      & zip_global_sig, zip_local_sig, zip_footer_sig, zip_min_version
   use tblite_io_numpy_load, only : load_npy, get_npy_descriptor
   use tblite_io_numpy_utils, only : reader_type, new_reader, delete_reader
   use tblite_io_numpy_crc32, only : crc32_hash
   use tblite_output_format, only : format_string
   implicit none
   private

   public :: load_npz
   public :: get_npz_descriptor

   !> Interface for loading npz files
   interface load_npz
      module procedure load_npz_i4_r1
      module procedure load_npz_rdp_r1
      module procedure load_npz_rdp_r2
      module procedure load_npz_rdp_r3
   end interface load_npz

   character(len=*), parameter :: nl = achar(10)

contains

!> Get numpy array descriptor from a npz file
subroutine get_npz_descriptor(filename, varname, vtype, vshape, iostat, iomsg)
   !> Filename of the npz file
   character(len=*), intent(in) :: filename
   !> Name of the variable to load
   character(len=*), intent(in) :: varname
   !> Variable type of the numpy array
   character(len=:), allocatable, intent(out) :: vtype
   !> Variable shape of the numpy array
   integer, allocatable, intent(out) :: vshape(:)
   !> Status of the read operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
   character(len=1), allocatable :: buffer(:)
   type(reader_type) :: reader

   call load_npz_buffer(filename, varname, buffer, stat, msg)
   if (stat == 0) then
      call new_reader(reader, buffer, filename//"::"//varname//".npy")
      call get_npy_descriptor(reader, vtype, vshape, stat, msg)
      call delete_reader(reader)
   end if

   call handle_iostat(stat, msg, filename//"::"//varname//".npy", iostat)
   if (present(iomsg).and.allocated(msg).and.stat /= 0) call move_alloc(msg, iomsg)
end subroutine get_npz_descriptor

!> Load a numpy array from a npz file
subroutine load_npz_i4_r1(filename, varname, array, iostat, iomsg)
   !> Filename of the npz file
   character(len=*), intent(in) :: filename
   !> Name of the variable to load
   character(len=*), intent(in) :: varname
   !> Array to load the data into
   integer(i4), allocatable, intent(out) :: array(:)
   !> Status of the read operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
   character(len=1), allocatable :: buffer(:)
   type(reader_type) :: reader

   call load_npz_buffer(filename, varname, buffer, stat, msg)
   if (stat == 0) then
      call new_reader(reader, buffer, filename//"::"//varname//".npy")
      call load_npy(reader, array, stat, msg)
      call delete_reader(reader)
   end if

   call handle_iostat(stat, msg, filename//"::"//varname//".npy", iostat)
   if (present(iomsg).and.allocated(msg).and.stat /= 0) call move_alloc(msg, iomsg)
end subroutine load_npz_i4_r1

!> Load a numpy array from a npz file
subroutine load_npz_rdp_r1(filename, varname, array, iostat, iomsg)
   !> Filename of the npz file
   character(len=*), intent(in) :: filename
   !> Name of the variable to load
   character(len=*), intent(in) :: varname
   !> Array to load the data into
   real(dp), allocatable, intent(out) :: array(:)
   !> Status of the read operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
   character(len=1), allocatable :: buffer(:)
   type(reader_type) :: reader

   call load_npz_buffer(filename, varname, buffer, stat, msg)
   if (stat == 0) then
      call new_reader(reader, buffer, filename//"::"//varname//".npy")
      call load_npy(reader, array, stat, msg)
      call delete_reader(reader)
   end if

   call handle_iostat(stat, msg, filename//"::"//varname//".npy", iostat)
   if (present(iomsg).and.allocated(msg).and.stat /= 0) call move_alloc(msg, iomsg)
end subroutine load_npz_rdp_r1

!> Load a numpy array from a npz file
subroutine load_npz_rdp_r2(filename, varname, array, iostat, iomsg)
   !> Filename of the npz file
   character(len=*), intent(in) :: filename
   !> Name of the variable to load
   character(len=*), intent(in) :: varname
   !> Array to load the data into
   real(dp), allocatable, intent(out) :: array(:, :)
   !> Status of the read operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
   character(len=1), allocatable :: buffer(:)
   type(reader_type) :: reader

   call load_npz_buffer(filename, varname, buffer, stat, msg)
   if (stat == 0) then
      call new_reader(reader, buffer, filename//"::"//varname//".npy")
      call load_npy(reader, array, stat, msg)
      call delete_reader(reader)
   end if

   call handle_iostat(stat, msg, filename//"::"//varname//".npy", iostat)
   if (present(iomsg).and.allocated(msg).and.stat /= 0) call move_alloc(msg, iomsg)
end subroutine load_npz_rdp_r2

!> Load a numpy array from a npz file
subroutine load_npz_rdp_r3(filename, varname, array, iostat, iomsg)
   !> Filename of the npz file
   character(len=*), intent(in) :: filename
   !> Name of the variable to load
   character(len=*), intent(in) :: varname
   !> Array to load the data into
   real(dp), allocatable, intent(out) :: array(:, :, :)
   !> Status of the read operation
   integer, intent(out), optional :: iostat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out), optional :: iomsg

   integer :: stat
   character(len=:), allocatable :: msg
   character(len=1), allocatable :: buffer(:)
   type(reader_type) :: reader

   call load_npz_buffer(filename, varname, buffer, stat, msg)
   if (stat == 0) then
      call new_reader(reader, buffer, filename//"::"//varname//".npy")
      call load_npy(reader, array, stat, msg)
      call delete_reader(reader)
   end if

   call handle_iostat(stat, msg, filename//"::"//varname//".npy", iostat)
   if (present(iomsg).and.allocated(msg).and.stat /= 0) call move_alloc(msg, iomsg)
end subroutine load_npz_rdp_r3


!> Load a numpy array from a npz file
subroutine load_npz_buffer(filename, varname, buffer, stat, msg)
   !> Filename of the npz file
   character(len=*), intent(in) :: filename
   !> Name of the variable to load
   character(len=*), intent(in) :: varname
   !> Buffer to load the data into
   character(len=1), allocatable, intent(out) :: buffer(:)
   !> Status of the read operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg

   character(len=30) :: local_header
   integer(i4) :: nbytes, nbytes_compressed, crc_expected
   integer(i2) :: compression_method
   character(len=:), allocatable :: path
   character(len=512) :: errmsg
   integer :: io
   logical :: exist

   exist = .false.
   open(newunit=io, file=filename, form="unformatted", access="stream", iostat=stat, iomsg=errmsg)
   if (stat /= 0) msg = "Failed to open file '"//filename//"': "//trim(errmsg)
   do while (stat == 0)
      read(io, iostat=stat) local_header
      if (stat /= 0) then
         msg = "Failed to read local header from '"//filename//"'"
         exit
      end if
      if (.not.is_local_header(local_header)) exit

      call read_data(io, local_header, path, nbytes, nbytes_compressed, compression_method, &
         & stat, msg)

      if (stat == 0) then
         if (allocated(buffer)) deallocate(buffer)
         allocate(buffer(nbytes_compressed), stat=stat)
         msg = "Failed to allocate buffer for data from '"//filename//"::"//path//"'"
      end if
      if (stat == 0) then
         read(io, iostat=stat) buffer
         msg = "Failed to read data from '"//filename//"::"//path//"'"
      end if

      if (stat == 0 .and. varname//".npy" == path) then
         exist = .true.
         crc_expected = transfer(local_header(15:18), crc_expected)
         call check_crc32(buffer, crc_expected, filename//"::"//path, stat, msg)
         exit
      end if
   end do
   close(io)

   if (stat == 0 .and. .not.exist) then
      stat = 501
      msg = file_not_found_error(filename, varname)
   end if
end subroutine load_npz_buffer

!> Check if the header is a local header
pure function is_local_header(header) result(is_local)
   !> Header to check
   character(len=30), intent(in) :: header
   !> Status of the header
   logical :: is_local

   integer(i4) :: header_sig

   header_sig = transfer(header(1:4), header_sig)
   is_local = header_sig == zip_local_sig
end function is_local_header

!> Read the data from the local header
subroutine read_data(io, local_header, path, nbytes, nbytes_compressed, compression_method, stat, msg)
   !> Unformatted I/O unit
   integer, intent(in) :: io
   !> Local header
   character(len=30), intent(in) :: local_header
   !> Path to the data
   character(len=:), allocatable, intent(out) :: path
   !> Number of bytes in the data
   integer(i4), intent(out) :: nbytes, nbytes_compressed
   !> Compression method
   integer(i2), intent(out) :: compression_method
   !> Status of the read operation
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg

   integer(i2) :: path_size, extra_field_size
   character(len=:), allocatable :: buffer

   path_size = transfer(local_header(27:28), path_size)
   allocate(character(len=path_size) :: path)
   read(io) path

   extra_field_size = transfer(local_header(29:30), extra_field_size)
   if (extra_field_size > 0_i2) then
      allocate(character(len=extra_field_size) :: buffer)
      read(io) buffer
      deallocate(buffer)
   end if

   compression_method = transfer(local_header(9:10), compression_method)
   nbytes_compressed = transfer(local_header(19:22), nbytes)
   nbytes = transfer(local_header(23:26), nbytes_compressed)
end subroutine read_data

!> Check the CRC32 of the data
subroutine check_crc32(buffer, expected, filename, stat, msg)
   !> Buffer to check
   character(len=1), intent(in) :: buffer(:)
   !> Expected CRC32 value
   integer(i4), intent(in) :: expected
   !> Filename of the data for error message
   character(len=*), intent(in) :: filename
   !> Status of the check
   integer, intent(out) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(out) :: msg

   integer(i4) :: actual

   actual = crc32_hash(buffer)
   if (actual /= expected) then
      stat = 502
      msg = "CRC mismatch for " // filename // &
         & " (expected: " // format_string(expected, '(z08)') // &
         & " actual: " // format_string(actual, '(z08)') // ")"
   end if
end subroutine check_crc32

!> Handle the iostat of the read operation
subroutine handle_iostat(stat, msg, filename, iostat)
   !> Status of the read operation
   integer, intent(in) :: stat
   !> Error message in case of failure
   character(len=:), allocatable, intent(in) :: msg
   !> Filename of the data for error message
   character(len=*), intent(in) :: filename
   !> Status of the read operation
   integer, intent(out), optional :: iostat

   if (present(iostat)) then
       iostat = stat
   else if (stat /= 0) then
       if (allocated(msg)) then
           error stop "Failed to read array from file '"//filename//"'"//nl//&
               & msg
       else
           error stop "Failed to read array from file '"//filename//"'"
       end if
   end if
end subroutine handle_iostat

!> Generate an error message for file not found
pure function file_not_found_error(filename, varname) result(msg)
   !> Filename of the npz file
   character(len=*), intent(in) :: filename
   !> Name of the variable to load
   character(len=*), intent(in) :: varname
   !> Error message in case of failure
   character(len=:), allocatable :: msg

   msg = "File '"//filename//"::"//varname//".npy' not found in npz archive"
end function file_not_found_error

end module tblite_io_numpy_loadz

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_wavefunction_restart
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use tblite_wavefunction_type, only : wavefunction_type, new_wavefunction
   use tblite_wavefunction_restart, only : load_wavefunction, save_wavefunction
   use tblite_io_numpy, only : save_npz
   implicit none
   private

   public :: collect_wavefunction_restart

   real(wp), parameter :: thr = epsilon(1.0_wp)

contains


!> Collect all exported unit tests
subroutine collect_wavefunction_restart(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("write-read", test_write_read), &
      new_unittest("write-twice", test_write_twice), &
      new_unittest("file-not-found", test_file_not_found, should_fail=.true.), &
      new_unittest("nat-mismatch", test_nat_mismatch, should_fail=.true.), &
      new_unittest("nsh-mismatch", test_nsh_mismatch, should_fail=.true.), &
      new_unittest("nao-mismatch", test_nao_mismatch, should_fail=.true.), &
      new_unittest("nspin-mismatch", test_nspin_mismatch, should_fail=.true.), &
      new_unittest("kt-mismatch", test_kt_mismatch, should_fail=.true.), &
      new_unittest("dipole-mismatch", test_dipole_mismatch, should_fail=.true.), &
      new_unittest("quadrupole-mismatch", test_quadrupole_mismatch, should_fail=.true.), &
      new_unittest("load-error", test_load_error, should_fail=.true.) &
      ]

end subroutine collect_wavefunction_restart

subroutine test_write_read(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(wavefunction_type) :: wfn1, wfn2
   integer, parameter :: nat = 5, nsh = 12, nao = 20, nspin = 2

   call new_wavefunction(wfn1, nat, nsh, nao, nspin, 0.0_wp)
   call random_number(wfn1%emo)
   call random_number(wfn1%density)

   call save_wavefunction(wfn1, ".test-wavefunction-restart.npz", error)
   if (.not. allocated(error)) then
      call load_wavefunction(wfn2, ".test-wavefunction-restart.npz", error)
      call delete_file(".test-wavefunction-restart.npz")
   end if
   if (allocated(error)) return

   call check(error, all(abs(wfn1%emo - wfn2%emo) < thr), &
      & "Orbital energies are not equal")
   if (allocated(error)) return

   call check(error, all(abs(wfn1%density - wfn2%density) < thr), &
      & "Density matrices are not equal")
end subroutine test_write_read

subroutine test_write_twice(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(wavefunction_type) :: wfn1, wfn2
   integer, parameter :: nat = 5, nsh = 12, nao = 20, nspin = 2

   call new_wavefunction(wfn1, nat, nsh, nao, nspin, 0.0_wp)
   call random_number(wfn1%emo)
   call random_number(wfn1%density)

   call save_wavefunction(wfn1, ".test-wavefunction-restart2.npz", error)
   if (.not. allocated(error)) then
      call save_wavefunction(wfn1, ".test-wavefunction-restart2.npz", error)
   end if
   if (.not. allocated(error)) then
      call load_wavefunction(wfn2, ".test-wavefunction-restart2.npz", error)
      call delete_file(".test-wavefunction-restart2.npz")
   end if
   if (allocated(error)) return

   call check(error, all(abs(wfn1%emo - wfn2%emo) < thr), &
      & "Orbital energies are not equal")
   if (allocated(error)) return

   call check(error, all(abs(wfn1%density - wfn2%density) < thr), &
      & "Density matrices are not equal")
end subroutine test_write_twice

subroutine test_file_not_found(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(wavefunction_type) :: wfn
   character(len=*), parameter :: filename = ".test-file-not-found.npz"

   call load_wavefunction(wfn, filename, error)
end subroutine test_file_not_found

subroutine test_nat_mismatch(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(wavefunction_type) :: wfn
   integer, parameter :: nat = 5, nsh = 12, nao = 20, nspin = 2
   character(len=*), parameter :: prefix = "tblite0_", filename = ".test-nat-mismatch.npz"
   integer :: stat

   call new_wavefunction(wfn, nat, nsh, nao, nspin, 0.0_wp)

   call save_wavefunction(wfn, filename, error)
   call load_wavefunction(wfn, filename, error, nat=10)
   call delete_file(filename)
end subroutine test_nat_mismatch

subroutine test_nsh_mismatch(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(wavefunction_type) :: wfn
   integer, parameter :: nat = 5, nsh = 12, nao = 20, nspin = 2
   character(len=*), parameter :: prefix = "tblite0_", filename = ".test-nsh-mismatch.npz"
   integer :: stat

   call new_wavefunction(wfn, nat, nsh, nao, nspin, 0.0_wp)

   call save_wavefunction(wfn, filename, error)
   call load_wavefunction(wfn, filename, error, nsh=10)
   call delete_file(filename)
end subroutine test_nsh_mismatch

subroutine test_nao_mismatch(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(wavefunction_type) :: wfn
   integer, parameter :: nat = 5, nsh = 12, nao = 20, nspin = 2
   character(len=*), parameter :: prefix = "tblite0_", filename = ".test-nao-mismatch.npz"
   integer :: stat

   call new_wavefunction(wfn, nat, nsh, nao, nspin, 0.0_wp)

   call save_wavefunction(wfn, filename, error)
   call load_wavefunction(wfn, filename, error, nao=10)
   call delete_file(filename)
end subroutine test_nao_mismatch

subroutine test_nspin_mismatch(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(wavefunction_type) :: wfn
   integer, parameter :: nat = 5, nsh = 12, nao = 20, nspin = 2
   character(len=*), parameter :: prefix = "tblite0_", filename = ".test-nspin-mismatch.npz"
   integer :: stat

   call new_wavefunction(wfn, nat, nsh, nao, nspin, 0.0_wp)

   call save_wavefunction(wfn, filename, error)
   call load_wavefunction(wfn, filename, error, nspin=1)
   call delete_file(filename)
end subroutine test_nspin_mismatch

subroutine test_kt_mismatch(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(wavefunction_type) :: wfn
   integer, parameter :: nat = 5, nsh = 12, nao = 20, nspin = 2
   character(len=*), parameter :: prefix = "tblite0_", filename = ".test-kt-mismatch.npz"
   integer :: stat

   call new_wavefunction(wfn, nat, nsh, nao, nspin, 0.0_wp)

   call save_npz(filename, prefix//"kt", [wfn%kt, wfn%kt])

   call save_npz(filename, prefix//"nel", wfn%nel)
   call save_npz(filename, prefix//"n0at", wfn%n0at)
   call save_npz(filename, prefix//"n0sh", wfn%n0sh)

   call save_npz(filename, prefix//"density", wfn%density)
   call save_npz(filename, prefix//"coeff", wfn%coeff)
   call save_npz(filename, prefix//"emo", wfn%emo)
   call save_npz(filename, prefix//"focc", wfn%focc)

   call save_npz(filename, prefix//"qat", wfn%qat)
   call save_npz(filename, prefix//"qsh", wfn%qsh)

   call save_npz(filename, prefix//"dpat", wfn%dpat)
   call save_npz(filename, prefix//"qpat", wfn%qpat)

   call load_wavefunction(wfn, filename, error)
   call delete_file(filename)
end subroutine test_kt_mismatch

subroutine test_dipole_mismatch(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(wavefunction_type) :: wfn
   integer, parameter :: nat = 5, nsh = 12, nao = 20, nspin = 2
   character(len=*), parameter :: prefix = "tblite0_", filename = ".test-dipole-mismatch.npz"
   integer :: stat

   call new_wavefunction(wfn, nat, nsh, nao, nspin, 0.0_wp)

   call save_npz(filename, prefix//"kt", [wfn%kt])

   call save_npz(filename, prefix//"nel", wfn%nel)
   call save_npz(filename, prefix//"n0at", wfn%n0at)
   call save_npz(filename, prefix//"n0sh", wfn%n0sh)

   call save_npz(filename, prefix//"density", wfn%density)
   call save_npz(filename, prefix//"coeff", wfn%coeff)
   call save_npz(filename, prefix//"emo", wfn%emo)
   call save_npz(filename, prefix//"focc", wfn%focc)

   call save_npz(filename, prefix//"qat", wfn%qat)
   call save_npz(filename, prefix//"qsh", wfn%qsh)

   call save_npz(filename, prefix//"dpat", wfn%qpat)
   call save_npz(filename, prefix//"qpat", wfn%qpat)

   call load_wavefunction(wfn, filename, error)
   call delete_file(filename)
end subroutine test_dipole_mismatch

subroutine test_quadrupole_mismatch(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(wavefunction_type) :: wfn
   integer, parameter :: nat = 5, nsh = 12, nao = 20, nspin = 2
   character(len=*), parameter :: prefix = "tblite0_", filename = ".test-quadrpole-mismatch.npz"
   integer :: stat

   call new_wavefunction(wfn, nat, nsh, nao, nspin, 0.0_wp)

   call save_npz(filename, prefix//"kt", [wfn%kt])

   call save_npz(filename, prefix//"nel", wfn%nel)
   call save_npz(filename, prefix//"n0at", wfn%n0at)
   call save_npz(filename, prefix//"n0sh", wfn%n0sh)

   call save_npz(filename, prefix//"density", wfn%density)
   call save_npz(filename, prefix//"coeff", wfn%coeff)
   call save_npz(filename, prefix//"emo", wfn%emo)
   call save_npz(filename, prefix//"focc", wfn%focc)

   call save_npz(filename, prefix//"qat", wfn%qat)
   call save_npz(filename, prefix//"qsh", wfn%qsh)

   call save_npz(filename, prefix//"dpat", wfn%dpat)
   call save_npz(filename, prefix//"qpat", wfn%dpat)

   call load_wavefunction(wfn, filename, error)
   call delete_file(filename)
end subroutine test_quadrupole_mismatch

subroutine test_load_error(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(wavefunction_type) :: wfn
   integer, parameter :: nat = 5, nsh = 12, nao = 20, nspin = 2
   character(len=*), parameter :: prefix = "tblite0_", filename = ".test-load-error.npz"
   integer :: stat

   call new_wavefunction(wfn, nat, nsh, nao, nspin, 0.0_wp)

   call save_npz(filename, prefix//"kt", [1, 1, 1])

   call save_npz(filename, prefix//"nel", wfn%nel)
   call save_npz(filename, prefix//"n0at", wfn%n0at)
   call save_npz(filename, prefix//"n0sh", wfn%n0sh)

   call save_npz(filename, prefix//"density", wfn%density)
   call save_npz(filename, prefix//"coeff", wfn%coeff)
   call save_npz(filename, prefix//"emo", wfn%emo)
   call save_npz(filename, prefix//"focc", wfn%focc)

   call save_npz(filename, prefix//"qat", wfn%qat)
   call save_npz(filename, prefix//"qsh", wfn%qsh)

   call save_npz(filename, prefix//"dpat", wfn%dpat)
   call save_npz(filename, prefix//"qpat", wfn%dpat)

   call load_wavefunction(wfn, filename, error)
   call delete_file(filename)
end subroutine test_load_error

subroutine delete_file(filename)
   character(len=*), intent(in) :: filename

   integer :: io

   open(newunit=io, file=filename)
   close(io, status="delete")
end subroutine delete_file

end module test_wavefunction_restart

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module test_read_xyz
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check
   use mctc_io_read_xyz
   use mctc_io_structure
   implicit none
   private

   public :: collect_read_xyz


contains


!> Collect all exported unit tests
subroutine collect_read_xyz(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("valid1-xyz", test_valid1_xyz), &
      & new_unittest("valid2-xyz", test_valid2_xyz), &
      & new_unittest("valid3-xyz", test_valid3_xyz), &
      & new_unittest("valid4-xyz", test_valid4_xyz), &
      & new_unittest("valid5-xyz", test_valid5_xyz), &
      & new_unittest("invalid1-xyz", test_invalid1_xyz, should_fail=.true.), &
      & new_unittest("invalid2-xyz", test_invalid2_xyz, should_fail=.true.), &
      & new_unittest("invalid3-xyz", test_invalid3_xyz, should_fail=.true.), &
      & new_unittest("invalid4-xyz", test_invalid4_xyz, should_fail=.true.), &
      & new_unittest("invalid5-xyz", test_invalid5_xyz, should_fail=.true.), &
      & new_unittest("invalid6-xyz", test_invalid6_xyz, should_fail=.true.), &
      & new_unittest("invalid7-xyz", test_invalid7_xyz, should_fail=.true.) &
      & ]

end subroutine collect_read_xyz


subroutine test_valid1_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "9", &
      "WATER27, (H2O)3", &
      "O     1.1847029    1.1150792   -0.0344641 ", &
      "H     0.4939088    0.9563767    0.6340089 ", &
      "H     2.0242676    1.0811246    0.4301417 ", &
      "O    -1.1469443    0.0697649    1.1470196 ", &
      "H    -1.2798308   -0.5232169    1.8902833 ", &
      "H    -1.0641398   -0.4956693    0.3569250 ", &
      "O    -0.1633508   -1.0289346   -1.2401808 ", &
      "H     0.4914771   -0.3248733   -1.0784838 ", &
      "H    -0.5400907   -0.8496512   -2.1052499 "
   rewind(unit)

   call read_xyz(struc, unit, error)
   close(unit)
   if (allocated(error)) return

   call check(error, allocated(struc%comment), "Comment line should be preserved")
   if (allocated(error)) return
   call check(error, struc%comment, "WATER27, (H2O)3")
   if (allocated(error)) return
   call check(error, struc%nat, 9, "Number of atoms does not match")
   if (allocated(error)) return
   call check(error, struc%nid, 2, "Number of species does not match")
   if (allocated(error)) return

end subroutine test_valid1_xyz


subroutine test_valid2_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "24", &
      "", &
      "C          1.07317        0.04885       -0.07573", &
      "N          2.51365        0.01256       -0.07580", &
      "C*         3.35199        1.09592       -0.07533", &
      "N          4.61898        0.73028       -0.07549", &
      "C*         4.57907       -0.63144       -0.07531", &
      "C          3.30131       -1.10256       -0.07524", &
      "C          2.98068       -2.48687       -0.07377", &
      "18O        1.82530       -2.90038       -0.07577", &
      "N          4.11440       -3.30433       -0.06936", &
      "C*         5.45174       -2.85618       -0.07235", &
      "O          6.38934       -3.65965       -0.07232", &
      "N          5.66240       -1.47682       -0.07487", &
      "C          7.00947       -0.93648       -0.07524", &
      "C          3.92063       -4.74093       -0.06158", &
      "D          0.73398        1.08786       -0.07503", &
      "D          0.71239       -0.45698        0.82335", &
      "D          0.71240       -0.45580       -0.97549", &
      "H          2.99301        2.11762       -0.07478", &
      "H          7.76531       -1.72634       -0.07591", &
      "H          7.14864       -0.32182        0.81969", &
      "H          7.14802       -0.32076       -0.96953", &
      "H          2.86501       -5.02316       -0.05833", &
      "H          4.40233       -5.15920        0.82837", &
      "H          4.40017       -5.16929       -0.94780"
   rewind(unit)

   call read_xyz(struc, unit, error)
   close(unit)
   if (allocated(error)) return

   call check(error, .not.allocated(struc%comment), "Empty comment line should not be saved")
   if (allocated(error)) return
   call check(error, struc%nat, 24, "Number of atoms does not match")
   if (allocated(error)) return
   call check(error, struc%nid, 7, "Number of species does not match")
   if (allocated(error)) return

end subroutine test_valid2_xyz


subroutine test_valid3_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "24", &
      "#", &
      "c  1.07317  0.04885 -0.07573 -0.05445590", &
      "n  2.51365  0.01256 -0.07580 -0.00457526", &
      "c  3.35199  1.09592 -0.07533  0.08391889", &
      "n  4.61898  0.73028 -0.07549 -0.27870751", &
      "c  4.57907 -0.63144 -0.07531  0.11914924", &
      "c  3.30131 -1.10256 -0.07524 -0.02621044", &
      "c  2.98068 -2.48687 -0.07377  0.26115960", &
      "o  1.82530 -2.90038 -0.07577 -0.44071824", &
      "n  4.11440 -3.30433 -0.06936 -0.10804747", &
      "c  5.45174 -2.85618 -0.07235  0.30411699", &
      "o  6.38934 -3.65965 -0.07232 -0.44083760", &
      "n  5.66240 -1.47682 -0.07487 -0.07457706", &
      "c  7.00947 -0.93648 -0.07524 -0.04790859", &
      "c  3.92063 -4.74093 -0.06158 -0.03738239", &
      "h  0.73398  1.08786 -0.07503  0.06457802", &
      "h  0.71239 -0.45698  0.82335  0.08293905", &
      "h  0.71240 -0.45580 -0.97549  0.08296802", &
      "h  2.99301  2.11762 -0.07478  0.05698136", &
      "h  7.76531 -1.72634 -0.07591  0.09025556", &
      "h  7.14864 -0.32182  0.81969  0.07152988", &
      "h  7.14802 -0.32076 -0.96953  0.07159003", &
      "h  2.86501 -5.02316 -0.05833  0.08590674", &
      "h  4.40233 -5.15920  0.82837  0.06906357", &
      "h  4.40017 -5.16929 -0.94780  0.06926350"
   rewind(unit)

   call read_xyz(struc, unit, error)
   close(unit)
   if (allocated(error)) return

   call check(error, struc%nat, 24, "Number of atoms does not match")
   if (allocated(error)) return
   call check(error, struc%nid, 4, "Number of species does not match")
   if (allocated(error)) return

end subroutine test_valid3_xyz


subroutine test_valid4_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "3", &
      "WATER27, H2O", &
      "O     1.1847029    1.1150792   -0.0344641 ", &
      "H     0.4939088    0.9563767    0.6340089 ", &
      "H     2.0242676    1.0811246    0.4301417 ", &
      "3", &
      "WATER27, H2O", &
      "O    -1.1469443    0.0697649    1.1470196 ", &
      "H    -1.2798308   -0.5232169    1.8902833 ", &
      "H    -1.0641398   -0.4956693    0.3569250 ", &
      "3", &
      "WATER27, H2O", &
      "O    -0.1633508   -1.0289346   -1.2401808 ", &
      "H     0.4914771   -0.3248733   -1.0784838 ", &
      "H    -0.5400907   -0.8496512   -2.1052499 "
   rewind(unit)

   call read_xyz(struc, unit, error)
   if (.not.allocated(error)) then
      call read_xyz(struc, unit, error)
   end if
   close(unit)
   if (allocated(error)) return

   call check(error, struc%nat, 3, "Number of atoms does not match")
   if (allocated(error)) return
   call check(error, struc%nid, 2, "Number of species does not match")
   if (allocated(error)) return

end subroutine test_valid4_xyz


subroutine test_valid5_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "3", &
      "WATER27, H2O", &
      "8     1.1847029    1.1150792   -0.0344641 ", &
      "1     0.4939088    0.9563767    0.6340089 ", &
      "1     2.0242676    1.0811246    0.4301417 ", &
      "3", &
      "WATER27, H2O", &
      "8    -1.1469443    0.0697649    1.1470196 ", &
      "1    -1.2798308   -0.5232169    1.8902833 ", &
      "1    -1.0641398   -0.4956693    0.3569250 "
   rewind(unit)

   call read_xyz(struc, unit, error)
   if (.not.allocated(error)) then
      call read_xyz(struc, unit, error)
   end if
   close(unit)
   if (allocated(error)) return

   call check(error, struc%nat, 3, "Number of atoms does not match")
   if (allocated(error)) return
   call check(error, struc%nid, 2, "Number of species does not match")
   if (allocated(error)) return

end subroutine test_valid5_xyz


subroutine test_invalid1_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "9", &
      "WATER27, (H2O)3", &
      "O     1.1847029    1.1150792   -0.0344641 ", &
      "H     0.4939088    0.9563767    0.6340089 ", &
      "H     2.0242676    1.0811246    0.4301417 ", &
      "O    -1.1469443    0.0697649    1.1470196 ", &
      "H    -1.2798308   -0.5232169    1.8902833 ", &
      "H    -1.0641398   -0.4956693    0.3569250 "
   rewind(unit)

   call read_xyz(struc, unit, error)
   close(unit)
   if (allocated(error)) return

end subroutine test_invalid1_xyz


subroutine test_invalid2_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "", &
      "WATER27, (H2O)3", &
      "O     1.1847029    1.1150792   -0.0344641 ", &
      "H     0.4939088    0.9563767    0.6340089 ", &
      "H     2.0242676    1.0811246    0.4301417 ", &
      "O    -1.1469443    0.0697649    1.1470196 ", &
      "H    -1.2798308   -0.5232169    1.8902833 ", &
      "H    -1.0641398   -0.4956693    0.3569250 ", &
      "O    -0.1633508   -1.0289346   -1.2401808 ", &
      "H     0.4914771   -0.3248733   -1.0784838 ", &
      "H    -0.5400907   -0.8496512   -2.1052499 "
   rewind(unit)

   call read_xyz(struc, unit, error)
   close(unit)
   if (allocated(error)) return

end subroutine test_invalid2_xyz


subroutine test_invalid3_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      & "120"
   rewind(unit)

   call read_xyz(struc, unit, error)
   close(unit)
   if (allocated(error)) return

end subroutine test_invalid3_xyz


subroutine test_invalid4_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "-3", &
      "H2O", &
      "O     1.1847029    1.1150792   -0.0344641 ", &
      "H     0.4939088    0.9563767    0.6340089 ", &
      "H     2.0242676    1.0811246    0.4301417 "
   rewind(unit)

   call read_xyz(struc, unit, error)
   close(unit)
   if (allocated(error)) return

end subroutine test_invalid4_xyz


subroutine test_invalid5_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "3", &
      "H2O", &
      "****o   1.1847029    1.1150792   -0.0344641 ", &
      "****h   0.4939088    0.9563767    0.6340089 ", &
      "****h   2.0242676    1.0811246    0.4301417 "
   rewind(unit)

   call read_xyz(struc, unit, error)
   close(unit)
   if (allocated(error)) return

end subroutine test_invalid5_xyz


subroutine test_invalid6_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "3", &
      "H2O", &
      "1.1847029    1.1150792   -0.0344641      O", &
      "0.4939088    0.9563767    0.6340089      H", &
      "2.0242676    1.0811246    0.4301417      H"
   rewind(unit)

   call read_xyz(struc, unit, error)
   close(unit)
   if (allocated(error)) return

end subroutine test_invalid6_xyz


subroutine test_invalid7_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit

   open(status='scratch', newunit=unit)
   write(unit, '(a)') &
      "nine", &
      "WATER27, (H2O)3", &
      "O     1.1847029    1.1150792   -0.0344641 ", &
      "H     0.4939088    0.9563767    0.6340089 ", &
      "H     2.0242676    1.0811246    0.4301417 ", &
      "O    -1.1469443    0.0697649    1.1470196 ", &
      "H    -1.2798308   -0.5232169    1.8902833 ", &
      "H    -1.0641398   -0.4956693    0.3569250 ", &
      "O    -0.1633508   -1.0289346   -1.2401808 ", &
      "H     0.4914771   -0.3248733   -1.0784838 ", &
      "H    -0.5400907   -0.8496512   -2.1052499 "
   rewind(unit)

   call read_xyz(struc, unit, error)
   close(unit)

end subroutine test_invalid7_xyz


end module test_read_xyz

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

!> Entry point for running single point calculations with dftd4
module dftd4_driver
   use, intrinsic :: iso_fortran_env, only : output_unit, input_unit
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_io, only : structure_type, read_structure, filetype
   use dftd4, only : get_dispersion, realspace_cutoff, &
      & damping_param, rational_damping_param, get_rational_damping, &
      & get_properties, get_pairwise_dispersion, get_dispersion_hessian, &
      & dispersion_model, new_dispersion_model, d4_qmod
   use dftd4_output
   use dftd4_cli, only : cli_config, param_config, run_config
   use dftd4_help, only : header
   use dftd4_param, only : functional_group, get_functionals, &
      & get_functional_id, p_r2scan_3c
   use dftd4_utils, only : lowercase, wrap_to_central_cell
   implicit none
   private

   public :: main

contains


!> Main entry point for the driver
subroutine main(config, error)

   !> Configuration for this driver
   class(cli_config), intent(in) :: config

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   select type(config)
   class default
      call fatal_error(error, "Unknown runtime selected")
   type is(run_config)
      call run_main(config, error)
   type is(param_config)
      call run_param(config, error)
   end select
end subroutine main


!> Entry point for the single point driver
subroutine run_main(config, error)

   !> Configuration for this driver
   type(run_config), intent(in) :: config

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   character(len=:), allocatable :: filename
   character(len=:), allocatable :: functional
   class(damping_param), allocatable :: param
   class(dispersion_model), allocatable :: d4
   real(wp) :: charge
   real(wp), allocatable :: energy, gradient(:, :), sigma(:, :), hessian(:, :, :, :)
   real(wp), allocatable :: pair_disp2(:, :), pair_disp3(:, :)
   real(wp), allocatable :: cn(:), q(:), c6(:, :), alpha(:)
   real(wp), allocatable :: s9
   real(wp) :: ga, gc
   integer :: stat, unit, is, id, charge_model
   logical :: exist

   if (config%verbosity > 1) then
      call header(output_unit)
   end if

   if (config%input == "-") then
      if (.not.allocated(config%input_format)) then
         call read_structure(mol, input_unit, filetype%xyz, error)
      else
         call read_structure(mol, input_unit, config%input_format, error)
      end if
   else
      call read_structure(mol, config%input, error, config%input_format)
   end if
   if (allocated(error)) return

   if (allocated(config%charge)) then
      mol%charge = config%charge
   else
      filename = join(dirname(config%input), ".CHRG")
      if (exists(filename)) then
         open(file=filename, newunit=unit)
         read(unit, *, iostat=stat) charge
         if (stat == 0) then
            mol%charge = charge
            if (config%verbosity > 0) write(output_unit, '(a)') &
               "[Info] Molecular charge read from '"//filename//"'"
         else
            if (config%verbosity > 0) write(output_unit, '(a)') &
               "[Warn] Could not read molecular charge read from '"//filename//"'"
         end if
         close(unit)
      end if
   end if

   if (config%wrap) then
      call wrap_to_central_cell(mol%xyz, mol%lattice, mol%periodic)
   end if

   ga = config%ga
   gc = config%gc
   if (config%mbdscale) s9 = config%inp%s9
   if (config%rational) then
      if (config%has_param) then
         param = config%inp
      else
         is = index(config%method, '/')
         if (is == 0) is = len_trim(config%method) + 1
         functional = lowercase(config%method(:is-1))
         id = get_functional_id(functional)

         ! special case: r2SCAN-3c (modifies s9, ga, gc)
         if (id == p_r2scan_3c) then
            if (.not.config%mbdscale) then
               s9 = 2.0_wp
            end if
            if (.not.config%zeta) then
               ga = 2.0_wp
               gc = 1.0_wp
            end if
         end if

         call get_rational_damping(functional, param, s9)
         if (.not.allocated(param)) then
            call fatal_error(error, "No parameters for '"//config%method//"' available")
            return
         end if
      end if
   end if

   if (allocated(param) .and. config%verbosity > 0) then
      call ascii_damping_param(output_unit, param, config%method)
   end if

   if (allocated(param)) then
      energy = 0.0_wp
      if (config%grad) then
         allocate(gradient(3, mol%nat), sigma(3, 3))
      end if
      if (config%hessian) then
         allocate(hessian(3, mol%nat, 3, mol%nat))
      end if
   end if

   if(allocated(config%charge_model)) then
      if(lowercase(config%charge_model) == "eeq") then
         charge_model = d4_qmod%eeq
      else if(lowercase(config%charge_model) == "eeqbc") then
         charge_model = d4_qmod%eeqbc
      else
         ! Unknown charge model or GFN2 are not supported 
         ! for non-self-consistent D4
         call fatal_error(error, "Unknown charge model selected")
         return
      end if
   else
      ! Use EEQ as default charge model
      charge_model = d4_qmod%eeq
   end if

   ! Initialize D4/D4S model
   call new_dispersion_model(error, d4, mol, config%model, ga=ga, &
      & gc=gc, wf=config%wf, qmod=charge_model)

   if (allocated(error)) return

   if (config%properties) then
      if (config%verbosity > 1) then
         call ascii_atomic_radii(output_unit, mol, d4)
         call ascii_atomic_references(output_unit, mol, d4)
      end if
      allocate(cn(mol%nat), q(mol%nat), c6(mol%nat, mol%nat), alpha(mol%nat))
      call get_properties(mol, d4, realspace_cutoff(), cn, q, c6, alpha)

      if (config%verbosity > 0) then
         call ascii_system_properties(output_unit, mol, d4, cn, q, c6, alpha)
      end if
   end if

   if (allocated(param)) then
      call get_dispersion(mol, d4, param, realspace_cutoff(), energy, gradient, &
         & sigma)
      if (config%pair_resolved) then
         allocate(pair_disp2(mol%nat, mol%nat), pair_disp3(mol%nat, mol%nat))
         call get_pairwise_dispersion(mol, d4, param, realspace_cutoff(), pair_disp2, &
            & pair_disp3)
      end if
      if (config%hessian) then
         call get_dispersion_hessian(mol, d4, param, realspace_cutoff(), hessian)
      end if
      if (config%verbosity > 0) then
         call ascii_results(output_unit, mol, energy, gradient, sigma)
         if (config%pair_resolved) then
            call ascii_pairwise(output_unit, mol, pair_disp2, pair_disp3)
         end if
      end if
      if (config%tmer) then
         if (config%verbosity > 0) then
            write(output_unit, '(a)') "[Info] Dispersion energy written to .EDISP"
         end if
         open(file=".EDISP", newunit=unit)
         write(unit, '(f24.14)') energy
         close(unit)
      end if
      if (config%grad) then
         open(file=config%grad_output, newunit=unit)
         call tagged_result(unit, energy, gradient, sigma, hessian)
         close(unit)
         if (config%verbosity > 0) then
            write(output_unit, '(a)') &
               & "[Info] Dispersion results written to '"//config%grad_output//"'"
         end if

         inquire(file="gradient", exist=exist)
         if (exist) then
            call turbomole_gradient(mol, "gradient", energy, gradient, stat)
            if (config%verbosity > 0) then
               if (stat == 0) then
                  write(output_unit, '(a)') &
                     & "[Info] Dispersion gradient added to Turbomole gradient file"
               else
                  write(output_unit, '(a)') &
                     & "[Warn] Could not add to Turbomole gradient file"
               end if
            end if
         end if
         inquire(file="gradlatt", exist=exist)
         if (exist) then
            call turbomole_gradlatt(mol, "gradlatt", energy, sigma, stat)
            if (config%verbosity > 0) then
               if (stat == 0) then
                  write(output_unit, '(a)') &
                     & "[Info] Dispersion virial added to Turbomole gradlatt file"
               else
                  write(output_unit, '(a)') &
                     & "[Warn] Could not add to Turbomole gradlatt file"
               end if
            end if
         end if
      end if

   end if

   if (config%json) then
      open(file=config%json_output, newunit=unit)
      call json_results(unit, "  ", energy=energy, gradient=gradient, sigma=sigma, &
         & hessian=hessian, &
         & cn=cn, q=q, c6=c6, alpha=alpha, &
         & pairwise_energy2=pair_disp2, pairwise_energy3=pair_disp3)
      close(unit)
      if (config%verbosity > 0) then
         write(output_unit, '(a)') &
            & "[Info] JSON dump of results written to '"//config%json_output//"'"
      end if
   end if

end subroutine run_main


subroutine run_param(config, error)

   !> Configuration for this driver
   type(param_config), intent(in) :: config

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   if (config%list) then
      block
         type(functional_group), allocatable :: funcs(:)
         character(len=:), allocatable :: temp_names(:)
         integer, parameter :: MAX_LEN = 20
    
         integer :: i, j, nfuncs
         integer :: size_j, size_jp1
 
         call get_functionals(funcs)
         nfuncs = size(funcs)

         ! Bubble sort based on the first name in each group of funcs
         do i = 1, nfuncs - 1
            do j = 1, nfuncs - i
               if (funcs(j)%names(1) > funcs(j+1)%names(1)) then
                  size_j = size(funcs(j)%names)
                  size_jp1 = size(funcs(j+1)%names)

                  allocate(character(len=MAX_LEN) :: temp_names(size_j))
                  temp_names = funcs(j)%names

                  ! De- and reallocate before swap
                  if (allocated(funcs(j)%names)) deallocate(funcs(j)%names)
                  allocate(character(len=MAX_LEN) :: funcs(j)%names(size_jp1))
                  funcs(j)%names = funcs(j+1)%names

                  if (allocated(funcs(j+1)%names)) deallocate(funcs(j+1)%names)
                  allocate(character(len=MAX_LEN) :: funcs(j+1)%names(size_j))
                  funcs(j+1)%names = temp_names

                  deallocate(temp_names)
               end if
            end do
         end do
         
         write(output_unit, '(a)') "List of available functionals:"
         
         do i = 1, nfuncs
            associate(names => funcs(i)%names)
               do j = 1, size(names)
                  if (len_trim(names(j)) > 0) then
                     write(output_unit, '(a)', advance='no') trim(names(j)) // " "
                     
                     ! new line if last in list
                     if (size(names) == j) then
                        write(output_unit, *)
                     end if
                  end if
               end do
            end associate
         end do

      end block
   end if

end subroutine run_param


!> Construct path by joining strings with os file separator
function join(a1, a2) result(path)
   use mctc_env_system, only : is_windows
   character(len=*), intent(in) :: a1, a2
   character(len=:), allocatable :: path
   character :: filesep

   if (is_windows()) then
      filesep = '\'
   else
      filesep = '/'
   end if

   path = a1 // filesep // a2
end function join


!> test if pathname already exists
function exists(filename)
    character(len=*), intent(in) :: filename
    logical :: exists
    inquire(file=filename, exist=exists)
end function exists


!> Extract dirname from path
function dirname(filename)
   character(len=*), intent(in) :: filename
   character(len=:), allocatable :: dirname

   dirname = filename(1:scan(filename, "/\", back=.true.))
   if (len_trim(dirname) == 0) dirname = "."
end function dirname


end module dftd4_driver

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/io/numpy/savez.f90
!> Provides npz output routines

!> Implementation of saving multidimensional arrays to npz files
module tblite_io_numpy_savez
   use iso_fortran_env, only : iostat_end
   use mctc_env, only : sp, dp, i2, i4, i1
   use tblite_io_numpy_constants, only : type_rdp, type_i4, &
      & zip_global_sig, zip_local_sig, zip_footer_sig, zip_min_version
   use tblite_io_numpy_crc32, only : crc32_hash
   use tblite_io_numpy_save, only : npy_header
   use tblite_io_numpy_zip, only : list_zip_file, zip_file
   use tblite_output_format, only : format_string
   implicit none
   private

   public :: save_npz

   interface save_npz
      module procedure save_npz_i4_r1
      module procedure save_npz_rdp_r1
      module procedure save_npz_rdp_r2
      module procedure save_npz_rdp_r3
   end interface save_npz

contains

subroutine save_npz_i4_r1(filename, varname, array, iostat, iomsg)
   character(len=*), intent(in) :: filename
   character(len=*), intent(in) :: varname
   integer(i4), intent(in) :: array(:)
   integer, intent(out), optional :: iostat
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=*), parameter :: vtype = type_i4
   integer, parameter :: vsize = 4

   integer(i4) :: checksum, nbytes
   character(len=:), allocatable :: file_header, global_header, local_header, footer, path

   logical :: exist
   integer :: io, stat
   character(len=:), allocatable :: msg
   type(zip_file) :: zip

   path = varname // ".npy"
   zip%nrecs = 0_i2
   zip%global_header_offset = 0_i4
   zip%global_header = ""

   inquire(file=filename, exist=exist)
   open(newunit=io, file=filename, form="unformatted", access="stream", iostat=stat)
   if (stat == 0 .and. exist) then
      call list_zip_file(io, filename, zip, stat, msg)
   end if

   if (stat == 0) then
      file_header = npy_header(vtype, shape(array))

      checksum = crc32_hash(file_header)
      checksum = crc32_hash(array, checksum)

      nbytes = len(file_header) + size(array) * vsize

      local_header = get_local_header(path, checksum, nbytes)
      global_header = zip%global_header // get_global_header(path, local_header, zip%global_header_offset)
      footer = get_footer(zip%nrecs + 1_i2, len(global_header), zip%global_header_offset + len(local_header) + nbytes)

      write(io, pos=zip%global_header_offset+1, iostat=stat) &
         & local_header, &
         & file_header, &
         & array, &
         & global_header, &
         & footer
   end if
   close(io)

   call handle_iostat(stat, filename, iostat, iomsg)
   if (allocated(msg) .and. present(iomsg)) call move_alloc(msg, iomsg)
end subroutine save_npz_i4_r1

subroutine save_npz_rdp_r1(filename, varname, array, iostat, iomsg)
   character(len=*), intent(in) :: filename
   character(len=*), intent(in) :: varname
   real(dp), intent(in) :: array(:)
   integer, intent(out), optional :: iostat
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=*), parameter :: vtype = type_rdp
   integer, parameter :: vsize = 8

   integer(i4) :: checksum, nbytes
   character(len=:), allocatable :: file_header, global_header, local_header, footer, path

   logical :: exist
   integer :: io, stat
   character(len=:), allocatable :: msg
   type(zip_file) :: zip

   path = varname // ".npy"
   zip%nrecs = 0_i2
   zip%global_header_offset = 0_i4
   zip%global_header = ""

   inquire(file=filename, exist=exist)
   open(newunit=io, file=filename, form="unformatted", access="stream", iostat=stat)
   if (stat == 0 .and. exist) then
      call list_zip_file(io, filename, zip, stat, msg)
   end if

   if (stat == 0) then
      file_header = npy_header(vtype, shape(array))

      checksum = crc32_hash(file_header)
      checksum = crc32_hash(array, checksum)

      nbytes = len(file_header) + size(array) * vsize

      local_header = get_local_header(path, checksum, nbytes)
      global_header = zip%global_header // get_global_header(path, local_header, zip%global_header_offset)
      footer = get_footer(zip%nrecs + 1_i2, len(global_header), zip%global_header_offset + len(local_header) + nbytes)

      write(io, pos=zip%global_header_offset+1, iostat=stat) &
         & local_header, &
         & file_header, &
         & array, &
         & global_header, &
         & footer
   end if
   close(io)

   call handle_iostat(stat, filename, iostat, iomsg)
   if (allocated(msg) .and. present(iomsg)) call move_alloc(msg, iomsg)
end subroutine save_npz_rdp_r1

subroutine save_npz_rdp_r2(filename, varname, array, iostat, iomsg)
   character(len=*), intent(in) :: filename
   character(len=*), intent(in) :: varname
   real(dp), intent(in) :: array(:, :)
   integer, intent(out), optional :: iostat
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=*), parameter :: vtype = type_rdp
   integer, parameter :: vsize = 8

   integer(i4) :: checksum, nbytes
   character(len=:), allocatable :: file_header, global_header, local_header, footer, path

   logical :: exist
   integer :: io, stat
   character(len=:), allocatable :: msg
   type(zip_file) :: zip

   path = varname // ".npy"
   zip%nrecs = 0_i2
   zip%global_header_offset = 0_i4
   zip%global_header = ""

   inquire(file=filename, exist=exist)
   open(newunit=io, file=filename, form="unformatted", access="stream", iostat=stat)
   if (stat == 0 .and. exist) then
      call list_zip_file(io, filename, zip, stat, msg)
   end if

   if (stat == 0) then
      file_header = npy_header(vtype, shape(array))

      checksum = crc32_hash(file_header)
      checksum = crc32_hash(reshape(array, [size(array)]), checksum)

      nbytes = len(file_header) + size(array) * vsize

      local_header = get_local_header(path, checksum, nbytes)
      global_header = zip%global_header // get_global_header(path, local_header, zip%global_header_offset)
      footer = get_footer(zip%nrecs + 1_i2, len(global_header), zip%global_header_offset + len(local_header) + nbytes)

      write(io, pos=zip%global_header_offset+1, iostat=stat) &
         & local_header, &
         & file_header, &
         & array, &
         & global_header, &
         & footer
   end if
   close(io)

   call handle_iostat(stat, filename, iostat, iomsg)
   if (allocated(msg) .and. present(iomsg)) call move_alloc(msg, iomsg)
end subroutine save_npz_rdp_r2

subroutine save_npz_rdp_r3(filename, varname, array, iostat, iomsg)
   character(len=*), intent(in) :: filename
   character(len=*), intent(in) :: varname
   real(dp), intent(in) :: array(:, :, :)
   integer, intent(out), optional :: iostat
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=*), parameter :: vtype = type_rdp
   integer, parameter :: vsize = 8

   integer(i4) :: checksum, nbytes
   character(len=:), allocatable :: file_header, global_header, local_header, footer, path

   logical :: exist
   integer :: io, stat
   character(len=:), allocatable :: msg
   type(zip_file) :: zip

   path = varname // ".npy"
   zip%nrecs = 0_i2
   zip%global_header_offset = 0_i4
   zip%global_header = ""

   inquire(file=filename, exist=exist)
   open(newunit=io, file=filename, form="unformatted", access="stream", iostat=stat)
   if (stat == 0 .and. exist) then
      call list_zip_file(io, filename, zip, stat, msg)
   end if

   if (stat == 0) then
      file_header = npy_header(vtype, shape(array))

      checksum = crc32_hash(file_header)
      checksum = crc32_hash(reshape(array, [size(array)]), checksum)

      nbytes = len(file_header) + size(array) * vsize

      local_header = get_local_header(path, checksum, nbytes)
      global_header = zip%global_header // get_global_header(path, local_header, zip%global_header_offset)
      footer = get_footer(zip%nrecs + 1_i2, len(global_header), zip%global_header_offset + len(local_header) + nbytes)

      write(io, pos=zip%global_header_offset+1, iostat=stat) &
         & local_header, &
         & file_header, &
         & array, &
         & global_header, &
         & footer
   end if
   close(io)

   call handle_iostat(stat, filename, iostat, iomsg)
   if (allocated(msg) .and. present(iomsg)) call move_alloc(msg, iomsg)
end subroutine save_npz_rdp_r3


!> Create a local header for a zip file
pure function get_local_header(filename, checksum, nbytes) result(header)
   !> Name of the file to be saved
   character(len=*), intent(in) :: filename
   !> CRC32 checksum of the file
   integer(i4), intent(in) :: checksum
   !> Size of the file in bytes
   integer(i4), intent(in) :: nbytes

   character(len=2), parameter :: general_purpose_bit_flag = repeat(char(0), 2)
   character(len=2), parameter :: compression_method = repeat(char(0), 2)
   character(len=2), parameter :: file_last_mod_time = repeat(char(0), 2)
   character(len=2), parameter :: file_last_mod_date = repeat(char(0), 2)
   character(len=2), parameter :: extra_field_length = repeat(char(0), 2)

   character(len=30+len(filename)) :: header

   header(1:4) = transfer(zip_local_sig, header(1:4))
   header(5:6) = transfer(zip_min_version, header(5:6))
   header(7:8) = general_purpose_bit_flag
   header(9:10) = compression_method
   header(11:12) = file_last_mod_time
   header(13:14) = file_last_mod_date
   header(15:18) = transfer(checksum, header(15:18))
   header(19:22) = transfer(nbytes, header(19:22))
   header(23:26) = header(19:22)
   header(27:28) = transfer(len(filename), header(25:28))
   header(29:30) = extra_field_length
   header(31:30+len(filename)) = filename

end function get_local_header

pure function get_global_header(filename, local_header, global_header_offset) result(header)
   character(len=*), intent(in) :: filename
   character(len=*), intent(in) :: local_header
   integer(i4), intent(in) :: global_header_offset

   character(len=2), parameter :: file_comment_length = repeat(char(0), 2)
   character(len=2), parameter :: disk_no = repeat(char(0), 2)
   character(len=2), parameter :: internal_file_attributes = repeat(char(0), 2)
   character(len=4), parameter :: external_file_attributes = repeat(char(0), 4)

   character(len=46+len(filename)) :: header

   header(1:4) = transfer(zip_global_sig, header(1:4))
   header(5:6) = transfer(zip_min_version, header(5:6))
   header(7:32) = local_header(5:30)
   header(33:34) = file_comment_length
   header(35:36) = disk_no
   header(37:38) = internal_file_attributes
   header(39:42) = external_file_attributes
   header(43:46) = transfer(global_header_offset, header(43:46))
   header(47:46+len(filename)) = filename

end function get_global_header

pure function get_footer(nrecs, global_header_size, global_header_offset) result(footer)
   integer(i2), intent(in) :: nrecs
   integer(i4), intent(in) :: global_header_size
   integer(i4), intent(in) :: global_header_offset

   character(len=2), parameter :: disk_no = repeat(char(0), 2)
   character(len=2), parameter :: disk_start = repeat(char(0), 2)
   character(len=2), parameter :: comment_len = repeat(char(0), 2)

   character(len=22) :: footer

   footer(1:4) = transfer(zip_footer_sig, footer(1:4))
   footer(5:6) = disk_no
   footer(7:8) = disk_start
   footer(9:10) = transfer(nrecs, footer(9:10))
   footer(11:12) = footer(9:10)
   footer(13:16) = transfer(global_header_size, footer(13:16))
   footer(17:20) = transfer(global_header_offset, footer(17:20))
   footer(21:22) = comment_len

end function get_footer

!> Handle iostat and iomsg of write operation
subroutine handle_iostat(stat, filename, iostat, iomsg)
   !> Error status of loading, zero on success
   integer, intent(in) :: stat
   !> Name of the npy file to load from
   character(len=*), intent(in) :: filename
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   if (present(iostat)) then
      iostat = stat
   else if (stat /= 0) then
      error stop "Failed to write array to file '"//filename//"'"
   end if

   if (present(iomsg)) then
      if (stat /= 0) then
         iomsg = "Failed to write array to file '"//filename//"'"
      end if
   end if
end subroutine handle_iostat

end module tblite_io_numpy_savez

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Coordination number implementation with single error function
module mctc_ncoord_erf
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use mctc_data_covrad, only : get_covalent_rad
   use mctc_ncoord_type, only : ncoord_type
   implicit none
   private

   public :: new_erf_ncoord

   !> Coordination number evaluator
   type, public, extends(ncoord_type) :: erf_ncoord_type
      !> Covalent radii
      real(wp), allocatable :: rcov(:)
      !> Exponent of the distance normalization
      real(wp)  :: norm_exp
   contains
      !> Evaluates the error counting function
      procedure :: ncoord_count
      !> Evaluates the derivative of the error counting function
      procedure :: ncoord_dcount
   end type erf_ncoord_type

   !> Steepness of counting function
   real(wp), parameter :: default_kcn = 3.15_wp
   !> Exponent of distance normalization 
   real(wp), parameter :: default_norm_exp = 1.0_wp
   !> Real-space cutoff for coordination number
   real(wp), parameter :: default_cutoff = 25.0_wp

contains


   subroutine new_erf_ncoord(self, mol, kcn, cutoff, rcov, cut, norm_exp)
      !> Coordination number container
      type(erf_ncoord_type), intent(out) :: self
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Steepness of counting function
      real(wp), optional :: kcn
      !> Real space cutoff
      real(wp), intent(in), optional :: cutoff
      !> Covalent radii
      real(wp), intent(in), optional :: rcov(:)
      !> Cutoff for the maximum coordination number
      real(wp), intent(in), optional :: cut
      !> Exponent of the distance normalization
      real(wp), intent(in), optional :: norm_exp

      if(present(kcn)) then
         self%kcn = kcn
      else
         self%kcn = default_kcn
      end if

      if (present(cutoff)) then
         self%cutoff = cutoff
      else
         self%cutoff = default_cutoff
      end if

      allocate(self%rcov(mol%nid))
      if (present(rcov)) then
         self%rcov(:) = rcov
      else
         self%rcov(:) = get_covalent_rad(mol%num)
      end if

      self%directed_factor = 1.0_wp

      if (present(cut)) then
         self%cut = cut
      else
         ! Negative value deactivates the cutoff
         self%cut = -1.0_wp
      end if

      if (present(norm_exp)) then
         self%norm_exp = norm_exp
      else
         self%norm_exp = default_norm_exp
      end if

   end subroutine new_erf_ncoord


   !> Error counting function for coordination number contributions.
   elemental function ncoord_count(self, izp, jzp, r) result(count)
      !> Coordination number container
      class(erf_ncoord_type), intent(in) :: self
      !> Atom i index
      integer, intent(in)  :: izp
      !> Atom j index
      integer, intent(in)  :: jzp
      !> Current distance.
      real(wp), intent(in) :: r

      real(wp) :: rc, count
      
      rc = (self%rcov(izp) + self%rcov(jzp))

      count = 0.5_wp * (1.0_wp + erf(-self%kcn*(r-rc)/rc**self%norm_exp))
      
   end function ncoord_count

   !> Derivative of the error counting function w.r.t. the distance.
   elemental function ncoord_dcount(self, izp, jzp, r) result(count)
      !> Coordination number container
      class(erf_ncoord_type), intent(in) :: self
      !> Atom i index
      integer, intent(in)  :: izp
      !> Atom j index
      integer, intent(in)  :: jzp
      !> Current distance.
      real(wp), intent(in) :: r

      real(wp), parameter :: sqrtpi = sqrt(pi)
      real(wp) :: rc, exponent, expterm, count

      rc = self%rcov(izp) + self%rcov(jzp)

      exponent = self%kcn*(r-rc)/rc**self%norm_exp
      expterm = exp(-exponent**2.0_wp)
      count = -(self%kcn*expterm)/(sqrtpi*rc**self%norm_exp)

   end function ncoord_dcount

end module mctc_ncoord_erf

! This file is part of mstore.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module fortranize
   use mctc_io_structure, only : structure_type
   implicit none
   private

   public :: write_fortran


contains


subroutine write_fortran(mol, unit, name)
   integer, intent(in) :: unit
   character(len=*), intent(in) :: name
   type(structure_type), intent(in) :: mol
   character(len=*), parameter :: ffmt = '(3x, a, 1x, "::", 1x, a:, 1x, "=", 1x, g0)'
   integer :: iat
   logical :: has_lattice

   write(unit, '(a, *(1x, a))') &
      & "subroutine", name // "(self)"
   write(unit, ffmt) "type(structure_type), intent(out)", "self"
   write(unit, ffmt) "integer, parameter", "nat", mol%nat
   write(unit, ffmt) "character(len=*), parameter", "sym(nat)", "[character(len=4)::&"
   write(unit, '(6x, "&")', advance='no')
   do iat = 1, mol%nat
      write(unit, "(1x, '""', a, '""')", advance='no') trim(mol%sym(mol%id(iat)))
      if (iat /= mol%nat) write(unit, '(",")', advance='no')
      if (modulo(iat, 14) == 0 .and. iat /= mol%nat) then
         write(unit, '(1x, "&", /, 6x, "&")', advance="no")
      end if
   end do
   write(unit, '("]")')
   write(unit, ffmt) "real(wp), parameter", "xyz(3, nat)", "reshape([&"
   do iat = 1, mol%nat - 1
      write(unit, '(6x, "&", 3(f18.14, "_wp,"), 1x, "&")') mol%xyz(:, iat)
   end do
   write(unit, '(6x, "&", 2(f18.14, "_wp,"), f18.14, "_wp],&")') mol%xyz(:, mol%nat)
   write(unit, '(6x, "&", 1x, a)') "shape(xyz))"
   if (allocated(mol%lattice)) then
      has_lattice = any(abs(mol%lattice) > epsilon(mol%lattice))
   else
      has_lattice = .false.
   end if
   if (has_lattice) then
      write(unit, ffmt) "real(wp), parameter", "lattice(3, 3)", "reshape([&"
      do iat = 1, size(mol%lattice, 2) - 1
         write(unit, '(6x, "&", 3(f18.14, "_wp,"), 1x, "&")') mol%lattice(:, iat)
      end do
      write(unit, '(6x, "&", 2(f18.14, "_wp,"), f18.14, "_wp],&")') &
         & mol%lattice(:, size(mol%lattice, 2))
      write(unit, '(6x, "&", 1x, a)') "shape(lattice))"
   end if
   if (abs(mol%charge) > epsilon(mol%charge)) then
      write(unit, ffmt) "real(wp), parameter", "charge", nint(mol%charge)
   end if
   if (mol%uhf /= 0) then
      write(unit, ffmt) "integer, parameter", "uhf", mol%uhf
   end if
   write(unit, '(3x, a, 1x, a)', advance='no') "call", "new(self, sym, xyz"
   if (has_lattice) then
      write(unit, '(",", 1x, a)', advance='no') "lattice=lattice"
   end if
   if (abs(mol%charge) > epsilon(mol%charge)) then
      write(unit, '(",", 1x, a)', advance='no') "charge=charge"
   end if
   if (mol%uhf /= 0) then
      write(unit, '(",", 1x, a)', advance='no') "uhf=uhf"
   end if
   write(unit, '(")")')
   write(unit, '(a, *(1x, a))') &
      & "end", "subroutine", name

end subroutine write_fortran


end module fortranize

program main_fortranize
   use, intrinsic :: iso_fortran_env, only : output_unit, error_unit, input_unit
   use fortranize
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_io, only : read_structure, structure_type, filetype, get_filetype
   use mctc_version, only : get_mctc_version
   use mctc_io_symbols, only : to_symbol
   use mstore
   implicit none
   character(len=*), parameter :: prog_name = "mstore-fortranize"

   character(len=:), allocatable :: input, output, output_name
   integer, allocatable :: input_format
   type(structure_type) :: mol
   type(error_type), allocatable :: error
   integer :: idx, unit, stat, tmp
   logical :: exist

   call get_arguments(input, input_format, output, output_name, error)
   if (allocated(error)) then
      write(error_unit, '(a)') error%message
      error stop
   end if

   if (input == "-") then
      if (.not.allocated(input_format)) input_format = filetype%xyz
      call read_structure(mol, input_unit, input_format, error)
   else
      call read_structure(mol, input, error, input_format)
   end if
   if (allocated(error)) then
      write(error_unit, '(a)') error%message
      error stop
   end if

   idx = scan(input, '\/', back=.true.)
   if (idx > 0) then
      inquire(file=input(:idx)//".CHRG", exist=exist)
      if (exist) then
         open(file=input(:idx)//".CHRG", newunit=unit)
         read(unit, *, iostat=stat) tmp
         if (stat == 0) then
            mol%charge = real(tmp, wp)
         end if
         close(unit)
      end if
      inquire(file=input(:idx)//".UHF", exist=exist)
      if (exist) then
         open(file=input(:idx)//".UHF", newunit=unit)
         read(unit, *, iostat=stat) tmp
         if (stat == 0) then
            mol%uhf = tmp
         end if
         close(unit)
      end if
   end if

   mol%sym = to_symbol(mol%num)

   call write_fortran(mol, output_unit, output_name)


contains


subroutine help(unit)
   integer, intent(in) :: unit

   write(unit, '(a, *(1x, a))') &
      "Usage: "//prog_name//" [options] <input> [output]"

   write(unit, '(a)') &
      "", &
      "Read structure from input file and writes it to output file.", &
      "The format is determined by the file extension or the format hint", &
      ""

   write(unit, '(2x, a, t25, a)') &
      "-i, --input <format>", "Hint for the format of the input file", &
      "-n, --name <format>", "Name of the generated subroutine", &
      "--version", "Print program version and exit", &
      "--help", "Show this help message"

   write(unit, '(a)')

end subroutine help


subroutine version(unit)
   integer, intent(in) :: unit
   character(len=:), allocatable :: version_string

   call get_mctc_version(string=version_string)
   write(unit, '(a, *(1x, a))') &
      & prog_name, "version", version_string

end subroutine version


!> Obtain the command line argument at a given index
subroutine get_argument(idx, arg)

   !> Index of command line argument, range [0:command_argument_count()]
   integer, intent(in) :: idx

   !> Command line argument
   character(len=:), allocatable, intent(out) :: arg

   integer :: length, stat

   call get_command_argument(idx, length=length, status=stat)
   if (stat /= 0) then
      return
   endif

   allocate(character(len=length) :: arg, stat=stat)
   if (stat /= 0) then
      return
   endif

   if (length > 0) then
      call get_command_argument(idx, arg, status=stat)
      if (stat /= 0) then
         deallocate(arg)
         return
      end if
   end if

end subroutine get_argument


subroutine get_arguments(input, input_format, output, output_name, &
      & error)

   !> Input file name
   character(len=:), allocatable :: input

   !> Input file format
   integer, allocatable, intent(out) :: input_format

   !> Output file name
   character(len=:), allocatable :: output

   !> Name of the generated subroutine
   character(len=:), allocatable :: output_name

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   character(len=:), allocatable :: arg

   iarg = 0
   narg = command_argument_count()
   do while(iarg < narg)
      iarg = iarg + 1
      call get_argument(iarg, arg)
      select case(arg)
      case("--help")
         call help(output_unit)
         stop
      case("--version")
         call version(output_unit)
         stop
      case default
         if (.not.allocated(input)) then
            call move_alloc(arg, input)
            cycle
         end if
         if (.not.allocated(output)) then
            call move_alloc(arg, output)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      case("-i", "--input")
         iarg = iarg + 1
         call get_argument(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for input format")
            exit
         end if
         input_format = get_filetype("."//arg)
      case("-n", "--name")
         iarg = iarg + 1
         call get_argument(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for output format")
            exit
         end if
         call move_alloc(arg, output_name)
      end select
   end do

   if (.not.allocated(output)) then
      output = "-"
   end if

   if (.not.(allocated(input).and.(allocated(output_name)))) then
      if (.not.allocated(error)) then
         call help(output_unit)
         error stop
      end if
   end if

end subroutine get_arguments


end program main_fortranize

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/scf/potential.f90
!> Defines a container for holding density dependent potentials

!> Implementation of the density dependent potential and its contribution
!> to the effective Hamiltonian
module tblite_scf_potential
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_basis_type, only : basis_type
   use tblite_integral_type, only : integral_type
   use tblite_wavefunction_spin, only : magnet_to_updown
   implicit none
   private

   public :: new_potential, add_pot_to_h1


   !> Container for density dependent potential-shifts
   type, public :: potential_type
      !> Flag if potential includes potential gradients 
      logical :: grad = .false.
      !> Atom-resolved charge-dependent potential shift
      real(wp), allocatable :: vat(:, :)
      !> Shell-resolved charge-dependent potential shift
      real(wp), allocatable :: vsh(:, :)
      !> Orbital-resolved charge-dependent potential shift
      real(wp), allocatable :: vao(:, :)

      !> Atom-resolved dipolar potential
      real(wp), allocatable :: vdp(:, :, :)
      !> Atom-resolved quadrupolar potential
      real(wp), allocatable :: vqp(:, :, :)

      !> Position derivative of atom-resolved charge-dependent potential shift
      real(wp), allocatable :: dvatdr(:, :, :, :)
      !> Lattice vector derivative of atom-resolved charge-dependent potential shift
      real(wp), allocatable :: dvatdL(:, :, :, :)

      !> Position derivative of shell-resolved charge-dependent potential shift
      real(wp), allocatable :: dvshdr(:, :, :, :)
      !> Lattice vector derivative of shell-resolved charge-dependent potential shift
      real(wp), allocatable :: dvshdL(:, :, :, :)
   contains
      !> Reset the density dependent potential
      procedure :: reset
   end type potential_type


contains


!> Create a new potential object
subroutine new_potential(self, mol, bas, nspin, grad)
   !> Instance of the density dependent potential
   type(potential_type), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Description of the basis set
   type(basis_type), intent(in) :: bas
   !> Number of spin channels
   integer, intent(in) :: nspin
   !> Flag to indicate if potential gradients are requested
   logical, intent(in), optional :: grad

   allocate(self%vat(mol%nat, nspin))
   allocate(self%vsh(bas%nsh, nspin))
   allocate(self%vao(bas%nao, nspin))

   allocate(self%vdp(3, mol%nat, nspin))
   allocate(self%vqp(6, mol%nat, nspin))

   if(present(grad)) then
      if(grad) then
         self%grad = .true.
         allocate(self%dvatdr(3, mol%nat, mol%nat, nspin))
         allocate(self%dvatdL(3, 3, mol%nat, nspin))

         allocate(self%dvshdr(3, mol%nat, bas%nsh, nspin))
         allocate(self%dvshdL(3, 3, bas%nsh, nspin))
      end if
   end if

end subroutine new_potential

!> Reset the density dependent potential
subroutine reset(self)
   !> Instance of the density dependent potential
   class(potential_type), intent(inout) :: self

   self%vat(:, :) = 0.0_wp
   self%vsh(:, :) = 0.0_wp
   self%vao(:, :) = 0.0_wp
   self%vdp(:, :, :) = 0.0_wp
   self%vqp(:, :, :) = 0.0_wp

   if(self%grad) then
      self%dvatdr(:, :, :, :) = 0.0_wp
      self%dvatdL(:, :, :, :) = 0.0_wp

      self%dvshdr(:, :, :, :) = 0.0_wp
      self%dvshdL(:, :, :, :) = 0.0_wp
   end if
end subroutine reset

!> Add the collected potential shifts to the effective Hamiltonian
subroutine add_pot_to_h1(bas, ints, pot, h1)
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Density dependent potential-shifts
   type(potential_type), intent(inout) :: pot
   !> Effective Hamiltonian
   real(wp), intent(out) :: h1(:, :, :)

   h1(:, :, 1) = ints%hamiltonian
   if (size(h1, 3) > 1) h1(:, :, 2:) = 0.0_wp

   call add_vat_to_vsh(bas, pot%vat, pot%vsh)
   call add_vsh_to_vao(bas, pot%vsh, pot%vao)
   call add_vao_to_h1(bas, ints%overlap, pot%vao, h1)
   call add_vmp_to_h1(bas, ints%dipole, pot%vdp, h1)
   call add_vmp_to_h1(bas, ints%quadrupole, pot%vqp, h1)

   call magnet_to_updown(h1)
end subroutine add_pot_to_h1

!> Expand an atom-resolved potential shift to a shell-resolved potential shift
subroutine add_vat_to_vsh(bas, vat, vsh)
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Atom-resolved charge-dependent potential shift
   real(wp), intent(in) :: vat(:, :)
   !> Shell-resolved charge-dependent potential shift
   real(wp), intent(inout) :: vsh(:, :)

   integer :: iat, ish, ii, spin

   !$omp parallel do schedule(runtime) collapse(2) default(none) &
   !$omp shared(bas, vat, vsh) private(spin, ii, ish, iat)
   do spin = 1, size(vat, 2)
      do iat = 1, size(vat, 1)
         ii = bas%ish_at(iat)
         do ish = 1, bas%nsh_at(iat)
            vsh(ii+ish, spin) = vsh(ii+ish, spin) + vat(iat, spin)
         end do
      end do
   end do
end subroutine add_vat_to_vsh

!> Expand a shell-resolved potential shift to an orbital-resolved potential shift
subroutine add_vsh_to_vao(bas, vsh, vao)
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Shell-resolved charge-dependent potential shift
   real(wp), intent(in) :: vsh(:, :)
   !> Orbital-resolved charge-dependent potential shift
   real(wp), intent(inout) :: vao(:, :)

   integer :: ish, iao, ii, spin

   !$omp parallel do schedule(runtime) collapse(2) default(none) &
   !$omp shared(bas, vsh, vao) private(ii, iao, ish)
   do spin = 1, size(vsh, 2)
      do ish = 1, size(vsh, 1)
         ii = bas%iao_sh(ish)
         do iao = 1, bas%nao_sh(ish)
            vao(ii+iao, spin) = vao(ii+iao, spin) + vsh(ish, spin)
         end do
      end do
   end do
end subroutine add_vsh_to_vao


!> Add a charge-dependent potential to the Hamiltonian
subroutine add_vao_to_h1(bas, sint, vao, h1)
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Overlap integrals
   real(wp), intent(in) :: sint(:, :)
   !> Orbital-resolved charge-dependent potential shift
   real(wp), intent(in) :: vao(:, :)
   !> Effective Hamiltonian
   real(wp), intent(inout) :: h1(:, :, :)

   integer :: iao, jao, spin, nao
   real(wp) :: vij

   nao = bas%nao

   !$omp parallel do collapse(2) schedule(runtime) default(none) &
   !$omp shared(h1, sint, vao, nao) private(spin, iao, jao, vij)
   do spin = 1, size(h1, 3)
      do iao = 1, nao
         do jao = 1, iao
            vij = -sint(jao, iao) * 0.5_wp * (vao(jao, spin) + vao(iao, spin))
            h1(jao, iao, spin) = h1(jao, iao, spin) + vij
            if (jao /= iao) then
               h1(iao, jao, spin) = h1(iao, jao, spin) + vij
            end if
         end do
      end do
   end do
end subroutine add_vao_to_h1

!> Add a multipolar potential to the Hamiltonian
subroutine add_vmp_to_h1(bas, mpint, vmp, h1)
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Multipole integrals, multipole operator is always centered on last index
   real(wp), intent(in) :: mpint(:, :, :)
   !> Multipole potential
   real(wp), intent(in) :: vmp(:, :, :)
   !> Effective Hamiltonian
   real(wp), intent(inout) :: h1(:, :, :)

   integer :: iao, jao, iat, jat, nmp, spin, nao
   real(wp) :: vij

   nmp = min(size(mpint, 1), size(vmp, 1))
   nao = bas%nao

   !$omp parallel do collapse(2) schedule(runtime) default(none) &
   !$omp shared(h1, bas, mpint, vmp, nmp, nao) private(spin, iao, jao, iat, jat, vij)
   do spin = 1, size(h1, 3)
      do iao = 1, nao
         iat = bas%ao2at(iao)
         do jao = 1, iao
            jat = bas%ao2at(jao)
            vij = -0.5_wp * dot_product(mpint(:nmp, jao, iao), vmp(:nmp, iat, spin)) &
               & - 0.5_wp * dot_product(mpint(:nmp, iao, jao), vmp(:nmp, jat, spin))
            h1(jao, iao, spin) = h1(jao, iao, spin) + vij
            if (jao /= iao) then
               h1(iao, jao, spin) = h1(iao, jao, spin) + vij
            end if
         end do
      end do
   end do
end subroutine add_vmp_to_h1

end module tblite_scf_potential

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/wignerseitz.f90
!> Provides a Wigner-Seitz cell

!> Implementation of finding the relevant nearest neighbours in a Wigner-Seitz cell
module tblite_wignerseitz
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_cutoff, only : get_lattice_points
   implicit none
   private

   public :: new_wignerseitz_cell, get_wignerseitz_weights

   !> Information on Wigner-Seitz images
   type, public :: wignerseitz_cell
      integer, allocatable :: nimg(:, :)
      integer, allocatable :: tridx(:, :, :)
      real(wp), allocatable :: trans(:, :)
   end type wignerseitz_cell


   !> Small cutoff threshold to create only closest cells
   real(wp), parameter :: thr = sqrt(epsilon(0.0_wp))

   !> Squared-distance interval for smoothly averaging competing nearest images
   real(wp), parameter :: tol = 0.3_wp


contains


subroutine new_wignerseitz_cell(self, mol)

   !> Wigner-Seitz cell instance
   type(wignerseitz_cell), intent(out) :: self

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   integer :: iat, jat, ntr, nimg
   integer, allocatable :: tridx(:)
   real(wp) :: vec(3)
   real(wp), allocatable :: trans(:, :)

   call get_lattice_points(mol%periodic, mol%lattice, thr, trans)
   ntr = size(trans, 2)
   allocate(self%nimg(mol%nat, mol%nat), self%tridx(ntr, mol%nat, mol%nat), &
      & tridx(ntr))

   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(mol, trans, self) private(iat, jat, vec, nimg, tridx)
   do iat = 1, mol%nat
      do jat = 1, mol%nat
         vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat)
         call get_pairs(nimg, trans, vec, tridx)
         self%nimg(jat, iat) = nimg
         self%tridx(:, jat, iat) = tridx
      end do
   end do

   call move_alloc(trans, self%trans)
   
end subroutine new_wignerseitz_cell


subroutine get_pairs(iws, trans, rij, list)
   integer, intent(out) :: iws
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: trans(:, :)
   integer, intent(out) :: list(:)

   logical :: mask(size(list))
   real(wp) :: dist(size(list)), vec(3), r2
   integer :: itr, img, pos
   integer :: index(size(list))

   iws = 0
   img = 0
   list(:) = 0
   index(:) = 0
   mask(:) = .true.

   do itr = 1, size(trans, 2)
      vec(:) = rij - trans(:, itr)
      r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
      if (r2 < thr) cycle
      img = img + 1
      dist(img) = r2
      index(img) = itr
   end do

   if (img == 0) return

   pos = minloc(dist(:img), dim=1)

   r2 = dist(pos)
   mask(pos) = .false.

   iws = 1
   list(iws) = index(pos)
   if (img <= iws) return

   do
      pos = minloc(dist(:img), dim=1, mask=mask(:img))
      if (dist(pos) - r2 > tol) exit
      mask(pos) = .false.
      iws = iws + 1
      list(iws) = index(pos)
   end do

end subroutine get_pairs


!> Compact C2 switching function for competing nearest images
pure elemental function smooth_image_weight(delta) result(weight)
   real(wp), intent(in) :: delta
   real(wp) :: weight, x

   x = min(1.0_wp, max(0.0_wp, delta)/tol)
   weight = max(0.0_wp, 1.0_wp - 10.0_wp*x**3 + 15.0_wp*x**4 - 6.0_wp*x**5)
end function smooth_image_weight


!> Derivative of the compact switching function with respect to squared distance
pure elemental function smooth_image_weight_derivative(delta) result(derivative)
   real(wp), intent(in) :: delta
   real(wp) :: derivative, x

   x = min(1.0_wp, max(0.0_wp, delta)/tol)
   derivative = -30.0_wp*x*x*(1.0_wp - x)**2/tol
end function smooth_image_weight_derivative


!> Evaluate smooth weights for competing nearest Wigner-Seitz images
subroutine get_wignerseitz_weights(self, jat, iat, rij, weight, dwdr, dwdL)
   !> Wigner-Seitz cell instance
   type(wignerseitz_cell), intent(in) :: self
   !> Pair indices in the Wigner-Seitz image arrays
   integer, intent(in) :: jat, iat
   !> Cartesian pair vector
   real(wp), intent(in) :: rij(3)
   !> Normalized image weights
   real(wp), intent(out) :: weight(:)
   !> Weight derivatives with respect to the pair vector
   real(wp), intent(out), optional :: dwdr(:, :)
   !> Weight derivatives with respect to strain
   real(wp), intent(out), optional :: dwdL(:, :, :)

   integer :: img, idx, nimg, refidx
   real(wp) :: delta, dshape, sum_shape
   real(wp) :: vec(3), refvec(3), ddelta(3), sum_dr(3)
   real(wp) :: ddeltaL(3, 3), sum_dL(3, 3)

   weight(:) = 0.0_wp
   if (present(dwdr)) dwdr(:, :) = 0.0_wp
   if (present(dwdL)) dwdL(:, :, :) = 0.0_wp

   nimg = self%nimg(jat, iat)
   if (nimg == 0) return

   refidx = self%tridx(1, jat, iat)
   refvec = rij - self%trans(:, refidx)
   sum_shape = 0.0_wp

   do img = 1, nimg
      idx = self%tridx(img, jat, iat)
      vec = rij - self%trans(:, idx)
      delta = max(0.0_wp, dot_product(vec, vec) - dot_product(refvec, refvec))
      weight(img) = smooth_image_weight(delta)
      sum_shape = sum_shape + weight(img)
   end do

   weight(:nimg) = weight(:nimg) / sum_shape
   if (.not.present(dwdr) .and. .not.present(dwdL)) return

   sum_dr(:) = 0.0_wp
   sum_dL(:, :) = 0.0_wp
   do img = 1, nimg
      idx = self%tridx(img, jat, iat)
      vec = rij - self%trans(:, idx)
      delta = max(0.0_wp, dot_product(vec, vec) - dot_product(refvec, refvec))
      dshape = smooth_image_weight_derivative(delta)
      ddelta(:) = 2.0_wp*(vec - refvec)
      ddeltaL(:, :) = 2.0_wp*(spread(vec, 1, 3)*spread(vec, 2, 3) &
         & - spread(refvec, 1, 3)*spread(refvec, 2, 3))
      sum_dr(:) = sum_dr + dshape*ddelta
      sum_dL(:, :) = sum_dL + dshape*ddeltaL
   end do

   do img = 1, nimg
      idx = self%tridx(img, jat, iat)
      vec = rij - self%trans(:, idx)
      delta = max(0.0_wp, dot_product(vec, vec) - dot_product(refvec, refvec))
      dshape = smooth_image_weight_derivative(delta)
      ddelta(:) = 2.0_wp*(vec - refvec)
      ddeltaL(:, :) = 2.0_wp*(spread(vec, 1, 3)*spread(vec, 2, 3) &
         & - spread(refvec, 1, 3)*spread(refvec, 2, 3))
      if (present(dwdr)) then
         dwdr(:, img) = (dshape*ddelta - weight(img)*sum_dr) / sum_shape
      end if
      if (present(dwdL)) then
         dwdL(:, :, img) = (dshape*ddeltaL - weight(img)*sum_dL) / sum_shape
      end if
   end do

end subroutine get_wignerseitz_weights


end module tblite_wignerseitz

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_write_aims
   use mctc_env_accuracy, only : wp
   use mctc_io_convert, only : autoaa
   use mctc_io_structure, only : structure_type
   implicit none
   private

   public :: write_aims

contains

subroutine write_aims(self, unit)

   !> Instance of the molecular structure data
   class(structure_type), intent(in) :: self

   !> File handle
   integer, intent(in) :: unit

   integer :: iat, ilt
   logical :: expo

   expo = maxval(self%xyz) > 1.0e+5 .or. minval(self%xyz) < -1.0e+5
   if (expo) then
      do iat = 1, self%nat
         write(unit, '(a, 1x, 3es24.14, 1x, a)') &
            "atom", self%xyz(:, iat) * autoaa, trim(self%sym(self%id(iat)))
      end do
   else
      do iat = 1, self%nat
         write(unit, '(a, 1x, 3f24.14, 1x, a)') &
            "atom", self%xyz(:, iat) * autoaa, trim(self%sym(self%id(iat)))
      end do
   end if

   if (any(self%periodic)) then
      if (size(self%lattice, 2) /= 3) return
      do ilt = 1, 3
         if (self%periodic(ilt)) then
            write(unit, '(a, 1x, 3f24.14)') &
               "lattice_vector", self%lattice(:, ilt) * autoaa
         end if
      end do
   end if

end subroutine write_aims
   
end module mctc_io_write_aims

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Implementation of a basic storage structure as pointer list of pointers.
!>
!> This implementation does purposely not use pointer attributes in the
!> datastructure to make it safer to work with.
module tomlf_structure_ordered_map
   use tomlf_constants, only : tfc
   use tomlf_structure_map, only : toml_map_structure
   use tomlf_structure_node, only : toml_node, resize
   use tomlf_type_value, only : toml_value, toml_key
   implicit none
   private

   public :: toml_ordered_map, new_ordered_map


   !> Stores TOML values in a list of pointers
   type, extends(toml_map_structure) :: toml_ordered_map

      !> Current number of stored TOML values
      integer :: n = 0

      !> List of TOML values
      type(toml_node), allocatable :: lst(:)

   contains

      !> Get TOML value at a given key
      procedure :: get

      !> Push back a TOML value to the structure
      procedure :: push_back

      !> Remove TOML value at a given key and return it
      procedure :: pop

      !> Get list of all keys in the structure
      procedure :: get_keys

      !> Delete TOML value at a given key
      procedure :: delete

      !> Destroy the data structure
      procedure :: destroy

   end type toml_ordered_map


   !> Initial storage capacity of the datastructure
   integer, parameter :: initial_size = 16


contains


!> Constructor for the storage data structure
subroutine new_ordered_map(self, n)

   !> Instance of the structure
   type(toml_ordered_map), intent(out) :: self

   !> Initial storage capacity
   integer, intent(in), optional :: n

   self%n = 0
   if (present(n)) then
      allocate(self%lst(min(1, n)))
   else
      allocate(self%lst(initial_size))
   end if

end subroutine new_ordered_map


!> Get TOML value at a given key
subroutine get(self, key, ptr)

   !> Instance of the structure
   class(toml_ordered_map), intent(inout), target :: self

   !> Key to the TOML value
   character(kind=tfc, len=*), intent(in) :: key

   !> Pointer to the stored value at given key
   class(toml_value), pointer, intent(out) :: ptr

   integer :: i

   nullify(ptr)

   do i = 1, self%n
      if (allocated(self%lst(i)%val)) then
         if (self%lst(i)%val%match_key(key)) then
            ptr => self%lst(i)%val
            exit
         end if
      end if
   end do

end subroutine get


!> Push back a TOML value to the structure
subroutine push_back(self, val)

   !> Instance of the structure
   class(toml_ordered_map), intent(inout), target :: self

   !> TOML value to be stored
   class(toml_value), allocatable, intent(inout) :: val

   integer :: m

   if (.not.allocated(self%lst)) then
      call resize(self%lst, initial_size)
   end if

   m = size(self%lst)
   if (self%n >= m) then
      call resize(self%lst, m + m/2 + 1)
   end if

   self%n = self%n + 1
   call move_alloc(val, self%lst(self%n)%val)

end subroutine push_back


!> Get list of all keys in the structure
subroutine get_keys(self, list)

   !> Instance of the structure
   class(toml_ordered_map), intent(inout), target :: self

   !> List of all keys
   type(toml_key), allocatable, intent(out) :: list(:)

   integer :: i

   allocate(list(self%n))

   do i = 1, self%n
      if (allocated(self%lst(i)%val)) then
         if (allocated(self%lst(i)%val%key)) then
            list(i)%key = self%lst(i)%val%key
            list(i)%origin = self%lst(i)%val%origin
         end if
      end if
   end do

end subroutine get_keys


!> Remove TOML value at a given key and return it
subroutine pop(self, key, val)

   !> Instance of the structure
   class(toml_ordered_map), intent(inout), target :: self

   !> Key to the TOML value
   character(kind=tfc, len=*), intent(in) :: key

   !> Removed TOML value
   class(toml_value), allocatable, intent(out) :: val

   integer :: idx, i

   idx = 0
   do i = 1, self%n
      if (allocated(self%lst(i)%val)) then
         if (self%lst(i)%val%match_key(key)) then
            idx = i
            exit
         end if
      end if
   end do

   if (idx > 0) then
      call move_alloc(self%lst(idx)%val, val)
      do i = idx+1, self%n
         call move_alloc(self%lst(i)%val, self%lst(i-1)%val)
      end do
      self%n = self%n - 1
   end if

end subroutine pop


!> Delete TOML value at a given key
subroutine delete(self, key)

   !> Instance of the structure
   class(toml_ordered_map), intent(inout), target :: self

   !> Key to the TOML value
   character(kind=tfc, len=*), intent(in) :: key

   class(toml_value), allocatable :: val

   call self%pop(key, val)
   if (allocated(val)) then
      call val%destroy()
   end if

end subroutine delete


!> Deconstructor for data structure
subroutine destroy(self)

   !> Instance of the structure
   class(toml_ordered_map), intent(inout), target :: self

   integer :: i

   do i = 1, self%n
      if (allocated(self%lst(i)%val)) then
         call self%lst(i)%val%destroy
      end if
   end do

   deallocate(self%lst)
   self%n = 0

end subroutine destroy


end module tomlf_structure_ordered_map

! This file is part of multicharge.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

#ifndef IK
#define IK i4
#endif

module multicharge_lapack
   use mctc_env, only : sp, dp, ik => IK
   implicit none
   private

   public :: sytrf, sytrs, sytri

   interface sytrf
      module procedure :: mchrg_ssytrf
      module procedure :: mchrg_dsytrf
   end interface sytrf

   interface sytrs
      module procedure :: mchrg_ssytrs
      module procedure :: mchrg_ssytrs1
      module procedure :: mchrg_ssytrs3
      module procedure :: mchrg_dsytrs
      module procedure :: mchrg_dsytrs1
      module procedure :: mchrg_dsytrs3
   end interface sytrs

   interface sytri
      module procedure :: mchrg_ssytri
      module procedure :: mchrg_dsytri
   end interface sytri


   interface lapack_sytrf
      pure subroutine ssytrf(uplo, n, a, lda, ipiv, work, lwork, info)
         import :: sp, ik
         integer(ik), intent(in) :: lda
         real(sp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer(ik), intent(out) :: ipiv(*)
         integer(ik), intent(out) :: info
         integer(ik), intent(in) :: n
         real(sp), intent(inout) :: work(*)
         integer(ik), intent(in) :: lwork
      end subroutine ssytrf
      pure subroutine dsytrf(uplo, n, a, lda, ipiv, work, lwork, info)
         import :: dp, ik
         integer(ik), intent(in) :: lda
         real(dp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer(ik), intent(out) :: ipiv(*)
         integer(ik), intent(out) :: info
         integer(ik), intent(in) :: n
         real(dp), intent(inout) :: work(*)
         integer(ik), intent(in) :: lwork
      end subroutine dsytrf
   end interface lapack_sytrf

   interface lapack_sytrs
      pure subroutine ssytrs(uplo, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: sp, ik
         integer(ik), intent(in) :: lda
         integer(ik), intent(in) :: ldb
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(inout) :: b(ldb, *)
         integer(ik), intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer(ik), intent(out) :: info
         integer(ik), intent(in) :: n
         integer(ik), intent(in) :: nrhs
      end subroutine ssytrs
      pure subroutine dsytrs(uplo, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: dp, ik
         integer(ik), intent(in) :: lda
         integer(ik), intent(in) :: ldb
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(inout) :: b(ldb, *)
         integer(ik), intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer(ik), intent(out) :: info
         integer(ik), intent(in) :: n
         integer(ik), intent(in) :: nrhs
      end subroutine dsytrs
   end interface lapack_sytrs

   interface lapack_sytri
      pure subroutine ssytri(uplo, n, a, lda, ipiv, work, info)
         import :: sp, ik
         integer(ik), intent(in) :: lda
         real(sp), intent(inout) :: a(lda, *)
         integer(ik), intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer(ik), intent(out) :: info
         integer(ik), intent(in) :: n
         real(sp), intent(in) :: work(*)
      end subroutine ssytri
      pure subroutine dsytri(uplo, n, a, lda, ipiv, work, info)
         import :: dp, ik
         integer(ik), intent(in) :: lda
         real(dp), intent(inout) :: a(lda, *)
         integer(ik), intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer(ik), intent(out) :: info
         integer(ik), intent(in) :: n
         real(dp), intent(in) :: work(*)
      end subroutine dsytri
   end interface lapack_sytri


contains


subroutine mchrg_ssytrf(amat, ipiv, uplo, info)
   real(sp), intent(inout) :: amat(:, :)
   integer(ik), intent(out) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   integer(ik), intent(out), optional :: info
   character(len=1) :: ula
   integer(ik) :: stat, n, lda, lwork, stat_alloc, stat_dealloc
   real(sp), allocatable :: work(:)
   real(sp) :: test(1)
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   stat_alloc = 0_ik
   lwork = -1_ik
   call lapack_sytrf(ula, n, amat, lda, ipiv, test, lwork, stat)
   if (stat == 0) then
      lwork = nint(test(1))
      if (stat_alloc==0) then
         allocate(work(lwork), stat=stat_alloc)
      end if
      if (stat_alloc==0) then
         call lapack_sytrf(ula, n, amat, lda, ipiv, work, lwork, stat)
      else
         stat = -1000_ik
      end if
      deallocate(work, stat=stat_dealloc)
   end if
   if (present(info)) then
      info = stat
   else
      if (stat /= 0) error stop "[multicharge_lapack] ssytrf failed"
   end if
end subroutine mchrg_ssytrf


subroutine mchrg_dsytrf(amat, ipiv, uplo, info)
   real(dp), intent(inout) :: amat(:, :)
   integer(ik), intent(out) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   integer(ik), intent(out), optional :: info
   character(len=1) :: ula
   integer(ik) :: stat, n, lda, lwork, stat_alloc, stat_dealloc
   real(dp), allocatable :: work(:)
   real(dp) :: test(1)
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   stat_alloc = 0_ik
   lwork = -1_ik
   call lapack_sytrf(ula, n, amat, lda, ipiv, test, lwork, stat)
   if (stat == 0) then
      lwork = nint(test(1))
      if (stat_alloc==0) then
         allocate(work(lwork), stat=stat_alloc)
      end if
      if (stat_alloc==0) then
         call lapack_sytrf(ula, n, amat, lda, ipiv, work, lwork, stat)
      else
         stat = -1000_ik
      end if
      deallocate(work, stat=stat_dealloc)
   end if
   if (present(info)) then
      info = stat
   else
      if (stat /= 0) error stop "[multicharge_lapack] dsytrf failed"
   end if
end subroutine mchrg_dsytrf


subroutine mchrg_ssytrs(amat, bmat, ipiv, uplo, info)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout) :: bmat(:, :)
   integer(ik), intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   integer(ik), intent(out), optional :: info
   character(len=1) :: ula
   integer(ik) :: stat, n, nrhs, lda, ldb
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   nrhs = size(bmat, 2)
   call lapack_sytrs(ula, n, nrhs, amat, lda, ipiv, bmat, ldb, stat)
   if (present(info)) then
      info = stat
   else
      if (stat /= 0) error stop "[multicharge_lapack] ssytrs failed"
   end if
end subroutine mchrg_ssytrs


subroutine mchrg_dsytrs(amat, bmat, ipiv, uplo, info)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout) :: bmat(:, :)
   integer(ik), intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   integer(ik), intent(out), optional :: info
   character(len=1) :: ula
   integer(ik) :: stat, n, nrhs, lda, ldb
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   nrhs = size(bmat, 2)
   call lapack_sytrs(ula, n, nrhs, amat, lda, ipiv, bmat, ldb, stat)
   if (present(info)) then
      info = stat
   else
      if (stat /= 0) error stop "[multicharge_lapack] dsytrs failed"
   end if
end subroutine mchrg_dsytrs


subroutine mchrg_ssytrs1(amat, bvec, ipiv, uplo, info)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout), target :: bvec(:)
   integer(ik), intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   integer(ik), intent(out), optional :: info
   real(sp), pointer :: bptr(:, :)
   bptr(1:size(bvec), 1:1) => bvec
   call sytrs(amat, bptr, ipiv, uplo, info)
end subroutine mchrg_ssytrs1


subroutine mchrg_ssytrs3(amat, bmat, ipiv, uplo, info)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout), contiguous, target :: bmat(:, :, :)
   integer(ik), intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   integer(ik), intent(out), optional :: info
   real(sp), pointer :: bptr(:, :)
   bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   call sytrs(amat, bptr, ipiv, uplo, info)
end subroutine mchrg_ssytrs3


subroutine mchrg_dsytrs1(amat, bvec, ipiv, uplo, info)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout), target :: bvec(:)
   integer(ik), intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   integer(ik), intent(out), optional :: info
   real(dp), pointer :: bptr(:, :)
   bptr(1:size(bvec), 1:1) => bvec
   call sytrs(amat, bptr, ipiv, uplo, info)
end subroutine mchrg_dsytrs1


subroutine mchrg_dsytrs3(amat, bmat, ipiv, uplo, info)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout), contiguous, target :: bmat(:, :, :)
   integer(ik), intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   integer(ik), intent(out), optional :: info
   real(dp), pointer :: bptr(:, :)
   bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   call sytrs(amat, bptr, ipiv, uplo, info)
end subroutine mchrg_dsytrs3


subroutine mchrg_ssytri(amat, ipiv, uplo, info)
   real(sp), intent(inout) :: amat(:, :)
   integer(ik), intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   integer(ik), intent(out), optional :: info
   character(len=1) :: ula
   integer(ik) :: stat, n, lda, stat_alloc, stat_dealloc
   real(sp), allocatable :: work(:)
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   stat_alloc = 0_ik
   allocate(work(n), stat=stat_alloc)
   if (stat_alloc==0) then
      call lapack_sytri(ula, n, amat, lda, ipiv, work, stat)
   else
      stat = -1000_ik
   end if
   deallocate(work, stat=stat_dealloc)
   if (present(info)) then
      info = stat
   else
      if (stat /= 0) error stop "[multicharge_lapack] ssytri failed"
   end if
end subroutine mchrg_ssytri


subroutine mchrg_dsytri(amat, ipiv, uplo, info)
   real(dp), intent(inout) :: amat(:, :)
   integer(ik), intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   integer(ik), intent(out), optional :: info
   character(len=1) :: ula
   integer(ik) :: stat, n, lda, stat_alloc, stat_dealloc
   real(dp), allocatable :: work(:)
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   stat_alloc = 0_ik
   allocate(work(n), stat=stat_alloc)
   if (stat_alloc==0) then
      call lapack_sytri(ula, n, amat, lda, ipiv, work, stat)
   else
      stat = -1000_ik
   end if
   deallocate(work, stat=stat_dealloc)
   if (present(info)) then
      info = stat
   else
      if (stat /= 0) error stop "[multicharge_lapack] dsytri failed"
   end if
end subroutine mchrg_dsytri


end module multicharge_lapack

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/context/logger.f90
!> Provides an abstract base class for implementing a logger

!> Logger to display strings
module tblite_context_logger
   use mctc_env, only : error_type
   implicit none
   private


   !> Base class defining the logger interface
   type, public, abstract :: context_logger
   contains
      !> Entry point for displaying a string in the logger
      procedure(message), deferred :: message
   end type context_logger


   abstract interface
      !> Entry point for displaying a string in the logger
      subroutine message(self, msg, error)
         import :: context_logger, error_type
         !> Instance of the logger
         class(context_logger), intent(inout) :: self
         !> String to display
         character(len=*), intent(in) :: msg
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine message
   end interface


end module tblite_context_logger

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/integral
!> Contains the integral evaluation implementations

!> @file tblite/integral/type.f90
!> Provides an integral storage container

!> Declaration of an integral storage container to collect all overlap related integrals
module tblite_integral_type
   use mctc_env, only : wp
   implicit none
   private

   public :: new_integral

   !> Integral container to store all overlap related integrals
   type, public :: integral_type
      !> Effective one-electron Hamiltonian
      real(wp), allocatable :: hamiltonian(:, :)
      !> Overlap integrals
      real(wp), allocatable :: overlap(:, :)
      !> Dipole moment integrals, moment operator is centered on last index
      real(wp), allocatable :: dipole(:, :, :)
      !> Quadrupole moment integrals, moment operator is centered on last index
      real(wp), allocatable :: quadrupole(:, :, :)
      !> Diatomic frame scaled overlap integrals
      real(wp), allocatable :: overlap_diat(:, :)
   end type integral_type

contains

!> Create and allocate a new integral container storage
subroutine new_integral(self, nao)
   !> Instance of the integral container
   type(integral_type), intent(out) :: self
   !> Dimension of the integrals
   integer, intent(in) :: nao

   allocate(self%hamiltonian(nao, nao), source = 0.0_wp)
   allocate(self%overlap(nao, nao), source = 0.0_wp)
   allocate(self%dipole(3, nao, nao), source = 0.0_wp)
   allocate(self%quadrupole(6, nao, nao), source = 0.0_wp)
   allocate(self%overlap_diat(nao, nao), source = 0.0_wp)
end subroutine new_integral

end module tblite_integral_type

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Processing of the configuration file
!
!  Reexports the used parts of the TOML-Fortran API
module pkg_toml
   use pkg_error, only : error_data, fatal_error, file_not_found_error
   use tomlf, only : toml_table, toml_error, toml_parse, toml_stat, &
      & set_value, get_value
   implicit none
   private

   public :: read_config_file
   public :: toml_table, toml_stat, set_value, get_value


contains


!> Process the configuration file to a TOML data structure
subroutine read_config_file(table, config, error)

   !> TOML data structure
   type(toml_table), allocatable, intent(out) :: table

   !> Name of the package configuration file
   character(len=*), intent(in) :: config

   !> Error status of the operation
   type(error_data), allocatable, intent(out) :: error

   type(toml_error), allocatable :: parse_error
   integer :: unit
   logical :: exist

   inquire(file=config, exist=exist)

   if (.not.exist) then
      call file_not_found_error(error, config)
      return
   end if

   open(file=config, newunit=unit, status='old')
   call toml_parse(table, unit, parse_error)
   close(unit)

   if (allocated(parse_error)) then
      allocate(error)
      call move_alloc(parse_error%message, error%message)
      return
   end if

end subroutine read_config_file


end module pkg_toml

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module tblite_features
   implicit none
   private

   public :: get_tblite_feature


contains

function get_tblite_feature(feature) result(has_feature)
   !> Feature name
   character(len=*), intent(in) :: feature
   !> Whether the feature is enabled
   logical :: has_feature

   select case(feature)
   case("color")
      has_feature = color_support()
   case default
      has_feature = .false.
   end select
end function get_tblite_feature

!> Check output terminal for color support
function color_support() result(color)
   use, intrinsic :: iso_fortran_env, only : output_unit
#if defined __INTEL_COMPILER
   use ifport, only : isatty
#endif
   !> Whether color can be supported
   logical :: color

   color = .false.
#if defined __GFORTRAN__ || defined __INTEL_COMPILER
   color = isatty(output_unit)
#endif
end function color_support

end module tblite_features

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

!> Utility functions for the dispersion models 
module dftd4_model_utils
   use ieee_arithmetic, only : ieee_is_nan
   use mctc_env, only : wp
   implicit none
   
   public :: is_exceptional, weight_cn, zeta, dzeta, trapzd

contains


!> Check whether we are dealing with an exceptional value, NaN or Inf
elemental function is_exceptional(val)
   real(wp), intent(in) :: val
   logical :: is_exceptional
   is_exceptional = ieee_is_nan(val) .or. abs(val) > huge(val)
end function is_exceptional


elemental function weight_cn(wf,cn,cnref) result(cngw)
   real(wp),intent(in) :: wf, cn, cnref
   real(wp) :: cngw
   intrinsic :: exp
   cngw = exp ( -wf * ( cn - cnref )**2 )
end function weight_cn

!> charge scaling function
elemental function zeta(a, c, qref, qmod)
   real(wp), intent(in) :: a
   real(wp), intent(in) :: c
   real(wp), intent(in) :: qref
   real(wp), intent(in) :: qmod
   real(wp) :: zeta

   intrinsic :: exp

   if (qmod < 0.0_wp) then
      zeta = exp( a )
   else
      zeta = exp( a * ( 1.0_wp - exp( c * ( 1.0_wp - qref/qmod ) ) ) )
   endif

end function zeta

!> derivative of charge scaling function w.r.t. charge
elemental function dzeta(a, c, qref, qmod)
   real(wp), intent(in) :: a
   real(wp), intent(in) :: c
   real(wp), intent(in) :: qref
   real(wp), intent(in) :: qmod
   real(wp) :: dzeta

   intrinsic :: exp

   if (qmod < 0.0_wp) then
      dzeta = 0.0_wp
   else
      dzeta = - a * c * exp( c * ( 1.0_wp - qref/qmod ) ) &
         & * zeta(a,c,qref,qmod) * qref / ( qmod**2 )
   endif

end function dzeta

!> numerical Casimir--Polder integration
pure function trapzd(pol)
   real(wp), intent(in) :: pol(23)
   real(wp) :: trapzd

   real(wp), parameter :: freq(23) = [ &
      & 0.000001_wp, 0.050000_wp, 0.100000_wp, &
      & 0.200000_wp, 0.300000_wp, 0.400000_wp, &
      & 0.500000_wp, 0.600000_wp, 0.700000_wp, &
      & 0.800000_wp, 0.900000_wp, 1.000000_wp, &
      & 1.200000_wp, 1.400000_wp, 1.600000_wp, &
      & 1.800000_wp, 2.000000_wp, 2.500000_wp, &
      & 3.000000_wp, 4.000000_wp, 5.000000_wp, &
      & 7.500000_wp, 10.00000_wp]
   real(wp), parameter :: weights(23) = 0.5_wp * [ &
      &  ( freq (2) - freq (1) ),  &
      &  ( freq (2) - freq (1) ) + ( freq (3) - freq (2) ),  &
      &  ( freq (3) - freq (2) ) + ( freq (4) - freq (3) ),  &
      &  ( freq (4) - freq (3) ) + ( freq (5) - freq (4) ),  &
      &  ( freq (5) - freq (4) ) + ( freq (6) - freq (5) ),  &
      &  ( freq (6) - freq (5) ) + ( freq (7) - freq (6) ),  &
      &  ( freq (7) - freq (6) ) + ( freq (8) - freq (7) ),  &
      &  ( freq (8) - freq (7) ) + ( freq (9) - freq (8) ),  &
      &  ( freq (9) - freq (8) ) + ( freq(10) - freq (9) ),  &
      &  ( freq(10) - freq (9) ) + ( freq(11) - freq(10) ),  &
      &  ( freq(11) - freq(10) ) + ( freq(12) - freq(11) ),  &
      &  ( freq(12) - freq(11) ) + ( freq(13) - freq(12) ),  &
      &  ( freq(13) - freq(12) ) + ( freq(14) - freq(13) ),  &
      &  ( freq(14) - freq(13) ) + ( freq(15) - freq(14) ),  &
      &  ( freq(15) - freq(14) ) + ( freq(16) - freq(15) ),  &
      &  ( freq(16) - freq(15) ) + ( freq(17) - freq(16) ),  &
      &  ( freq(17) - freq(16) ) + ( freq(18) - freq(17) ),  &
      &  ( freq(18) - freq(17) ) + ( freq(19) - freq(18) ),  &
      &  ( freq(19) - freq(18) ) + ( freq(20) - freq(19) ),  &
      &  ( freq(20) - freq(19) ) + ( freq(21) - freq(20) ),  &
      &  ( freq(21) - freq(20) ) + ( freq(22) - freq(21) ),  &
      &  ( freq(22) - freq(21) ) + ( freq(23) - freq(22) ),  &
      &  ( freq(23) - freq(22) ) ]

   trapzd = sum(pol*weights)

end function trapzd


end module dftd4_model_utils

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the driver entry points for handling data outputs
module tblite_driver_tagdiff
   use, intrinsic :: iso_fortran_env, only : output_unit
   use mctc_env, only : error_type, fatal_error, wp
   use tblite_cli, only : tagdiff_config
   use tblite_io_tag, only : tagged_data, tagged_entry
   use tblite_output_format, only : format_string
   implicit none
   private

   public :: main

   interface main
      module procedure :: tagdiff_main
   end interface



contains


subroutine tagdiff_main(config, error)
   type(tagdiff_config), intent(in) :: config
   type(error_type), allocatable, intent(out) :: error

   type(tagged_data), target :: actual, reference
   type(tagged_entry), pointer :: ptr
   integer :: it, iv, stat

   call actual%load(config%actual, stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read data from '"//config%actual//"'")
      return
   end if
   call reference%load(config%reference, stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read data from '"//config%reference//"'")
      return
   end if

   stat = 0
   do it = 1, size(reference%val)
      call actual%get(reference%val(it)%tag, ptr)
      if (.not.associated(ptr)) then
         if (.not.config%fit) then
            write(output_unit, '(a)') &
               & "Data field '"//reference%val(it)%tag//"' not found in actual data"
         end if
         stat = stat + 1
         cycle
      end if
      select type(aval => ptr%raw)
      type is(real(wp))
         select type(rval => reference%val(it)%raw)
         type is(real(wp))
            if (config%fit) then
               do iv = 1, size(rval)
                  write(output_unit, '(2es24.16)') rval(iv), aval(iv)
               end do
            else
               write(output_unit, '(a)') &
                  & "Difference in '"//reference%val(it)%tag//"' is "//&
                  & format_string(norm2(rval - aval), '(f10.6)')
            end if
         end select
      end select
   end do
   if (stat /= 0) then
      call fatal_error(error, "Data fields from reference are missing in actual data")
      return
   end if

end subroutine tagdiff_main


end module tblite_driver_tagdiff

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of a parameter database for damping parameters
module dftd3_app_toml
   use mctc_env, only : error_type, fatal_error
   use dftd3, only : d3_param, damping_param, rational_damping_param, new_rational_damping, &
      & zero_damping_param, new_zero_damping, mzero_damping_param, new_mzero_damping, &
      & optimizedpower_damping_param, new_optimizedpower_damping, &
      & cso_damping_param, new_cso_damping
   use tomlf, only : toml_table, toml_array, toml_key, toml_error, toml_parse, &
      & get_value, len
   implicit none
   private

   public :: param_database

   !> Individual damping parameter record
   type :: param_record
      !> Functional name identifying this record
      character(len=:), allocatable :: key
      !> Damping function identifier for this record
      character(len=:), allocatable :: id
      !> Actual damping parameters
      type(d3_param) :: param
      !> Name of the damping function
      character(len=:), allocatable :: damping
      !> Reference to publication
      character(len=:), allocatable :: doi
   end type param_record

   !> Damping parameter database
   type :: param_database
      !> List of supported damping functions
      type(param_record), allocatable :: defaults(:)
      !> List of damping parameter records
      type(param_record), allocatable :: records(:)
      !> Mask for default damping functions in queries
      logical, allocatable :: mask(:)
   contains
      !> Reading of damping parameter data
      generic :: load => load_from_file, load_from_unit, load_from_toml
      !> Read damping parameter data from file
      procedure, private :: load_from_file
      !> Read damping parameter data from formatted unit
      procedure, private :: load_from_unit
      !> Read damping parameter data from TOML data structure
      procedure, private :: load_from_toml
      !> Get parameters
      procedure :: get
   end type param_database

contains

!> Read damping parameter data from file
subroutine load_from_file(self, file, error)
   !> Instance of the damping parameter data
   class(param_database), intent(inout) :: self
   !> File name
   character(len=*), intent(in) :: file
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: unit
   logical :: exist

   inquire(file=file, exist=exist)
   if (.not.exist) then
     call fatal_error(error, "Could not find parameter file '"//file//"'")
     return
   end if

   open(file=file, newunit=unit)
   call self%load(unit, error)
   close(unit)
end subroutine load_from_file


!> Read damping parameter data from file
subroutine load_from_unit(self, unit, error)
   !> Instance of the damping parameter data
   class(param_database), intent(inout) :: self
   !> File name
   integer, intent(in) :: unit
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_error), allocatable :: parse_error
   type(toml_table), allocatable :: table

   call toml_parse(table, unit, parse_error)

   if (allocated(parse_error)) then
      allocate(error)
      call move_alloc(parse_error%message, error%message)
      return
   end if

   call self%load(table, error)
   if (allocated(error)) return

end subroutine load_from_unit

!> Read damping parameter data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the damping parameter data
   class(param_database), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   call get_value(table, "default", child)
   call load_default(self, child, error)
   if (allocated(error)) return

   call get_value(table, "parameter", child)
   call load_parameter(self, child, error)
   if (allocated(error)) return
end subroutine load_from_toml

!> Read the defaults from the TOML table
subroutine load_default(self, table, error)
   !> Instance of the damping parameter data
   type(param_database), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child, child2
   type(toml_array), pointer :: children
   type(toml_key), allocatable :: keys(:)
   integer :: ik
   type(param_record) :: stub
   character(len=:), allocatable :: val

   call get_value(table, "d3", children)
   call get_value(table, "parameter", child)
   call get_value(child, "d3", child2)

   call child2%get_keys(keys)
   call resize(self%defaults, size(keys))
   do ik = 1, size(keys)
      call get_value(child2, keys(ik)%key, child)
      call load_record(self%defaults(ik), child, stub, error)
      self%defaults(ik)%key = ""
      if (allocated(error)) exit
   end do

   allocate(self%mask(size(keys)), source=.false.)
   do ik = 1, len(children)
      call get_value(children, ik, val)
      associate(id => get_record(self%defaults, "", val))
         if (id > 0) self%mask(id) = .true.
      end associate
   end do
end subroutine load_default

!> Deserialize the parameter subtable into a list of records
subroutine load_parameter(self, table, error)
   !> Instance of the damping parameter data
   type(param_database), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(param_record) :: stub
   type(toml_key), allocatable :: keys(:), list(:)
   type(toml_table), pointer :: child, child2
   integer :: nr, ik, iv, id

   nr = 0
   call table%get_keys(keys)
   call resize(self%records, size(keys))

   records: do ik = 1, size(keys)
      call get_value(table, keys(ik)%key, child)
      call get_value(child, "d3", child2)

      call child2%get_keys(list)
      if (nr + size(list) > size(self%records)) call resize(self%records)
      do iv = 1, size(list)
         id = get_record(self%defaults, "", list(iv)%key)
         call get_value(child2, list(iv)%key, child)
         if (id > 0) then
            call load_record(self%records(iv+nr), child, self%defaults(id), error)
         else
            call load_record(self%records(iv+nr), child, stub, error)
         end if
         self%records(iv+nr)%key = keys(ik)%key
         if (allocated(error)) exit records
      end do
      nr = nr + size(list)

   end do records
   if (allocated(error)) return
   call resize(self%records, nr)
end subroutine load_parameter

!> Deserialize a record from a TOML table
subroutine load_record(record, table, default, error)
   !> Instance of the damping parameter data
   type(param_record), intent(inout) :: record
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Default values
   type(param_record), intent(in) :: default
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call table%get_key(record%id)
   call get_value(table, "damping", record%damping, default%damping)
   call get_value(table, "doi", record%doi, default%doi)
   call get_value(table, "s6", record%param%s6, default%param%s6)
   call get_value(table, "s8", record%param%s8, default%param%s8)
   call get_value(table, "s9", record%param%s9, default%param%s9)
   call get_value(table, "a1", record%param%a1, default%param%a1)
   call get_value(table, "a2", record%param%a2, default%param%a2)
   call get_value(table, "rs6", record%param%rs6, default%param%rs6)
   call get_value(table, "rs8", record%param%rs8, default%param%rs8)
   call get_value(table, "alp", record%param%alp, default%param%alp)
   call get_value(table, "bet", record%param%bet, default%param%bet)
end subroutine load_record

!> Load damping parameters from data base
subroutine get(self, param, method, damping)
   !> Instance of the damping parameter data
   class(param_database), intent(inout) :: self
   !> Damping parameters
   class(damping_param), allocatable, intent(out) :: param
   !> Method identifier
   character(len=*), intent(in) :: method
   !> Damping function identifier
   character(len=*), intent(in), optional :: damping

   integer :: ir, id

   if (present(damping)) then
      ir = get_record(self%records, method, damping)
   else
      ir = 0
      do id = 1, size(self%defaults)
         if (self%mask(id)) then
            ir = get_record(self%records, method, self%defaults(id)%id)
            if (ir > 0) exit
         end if
      end do
   end if
   if (ir == 0) return

   associate(record => self%records(ir))
      select case(record%damping)
      case("rational")
         block
            type(rational_damping_param), allocatable :: tmp
            allocate(tmp)
            call new_rational_damping(tmp, record%param)
            call move_alloc(tmp, param)
         end block
      case("zero")
         block
            type(zero_damping_param), allocatable :: tmp
            allocate(tmp)
            call new_zero_damping(tmp, record%param)
            call move_alloc(tmp, param)
         end block
      case("mzero")
         block
            type(mzero_damping_param), allocatable :: tmp
            allocate(tmp)
            call new_mzero_damping(tmp, record%param)
            call move_alloc(tmp, param)
         end block
      case("optimizedpower")
         block
            type(optimizedpower_damping_param), allocatable :: tmp
            allocate(tmp)
            call new_optimizedpower_damping(tmp, record%param)
            call move_alloc(tmp, param)
         end block
      case("cso")
         block
            type(cso_damping_param), allocatable :: tmp
            allocate(tmp)
            call new_cso_damping(tmp, record%param)
            call move_alloc(tmp, param)
         end block
      end select
   end associate
end subroutine get


!> Find a record in the record list
pure function get_record(record, key, id) result(pos)
   !> Instance of the parameters
   type(param_record), intent(in) :: record(:)
   !> Key to find
   character(len=*), intent(in) :: key
   !> Identifier to find
   character(len=*), intent(in) :: id
   !> Position in records
   integer :: pos

   integer :: ii

   pos = 0
   do ii = 1, size(record)
      if (record(ii)%key == key .and. record(ii)%id == id) then
         pos = ii
         exit
      end if
   end do
end function get_record


!> Reallocate list of records
pure subroutine resize(var, n)
   !> Instance of the array to be resized
   type(param_record), allocatable, intent(inout) :: var(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(param_record), allocatable :: tmp(:)
   integer :: this_size, new_size
   integer, parameter :: initial_size = 16

   if (allocated(var)) then
      this_size = size(var, 1)
      call move_alloc(var, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(var(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(var, 1))
      var(:this_size) = tmp(:this_size)
      deallocate(tmp)
   end if
end subroutine resize

end module dftd3_app_toml

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3_app_driver
   use, intrinsic :: iso_fortran_env, only : output_unit, input_unit
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type, read_structure, filetype, get_filetype
   use dftd3, only : damping_param, d3_param, d3_model, &
      & get_dispersion, get_zero_damping, zero_damping_param, new_zero_damping, &
      & get_rational_damping, rational_damping_param, new_rational_damping, &
      & get_mzero_damping, mzero_damping_param, new_mzero_damping, get_mrational_damping, &
      & get_optimizedpower_damping, optimizedpower_damping_param, &
      & new_optimizedpower_damping, &
      & get_cso_damping, cso_damping_param, new_cso_damping, &
      & new_d3_model, get_pairwise_dispersion, &
      & realspace_cutoff, get_lattice_points, get_coordination_number
   use dftd3_gcp, only : gcp_param, get_gcp_param, get_geometric_counterpoise
   use dftd3_output, only : ascii_damping_param, ascii_atomic_radii, &
      & ascii_atomic_references, ascii_system_properties, ascii_energy_atom, &
      & ascii_results, ascii_pairwise, tagged_result, json_results, &
      & turbomole_gradient, turbomole_gradlatt, ascii_gcp_param
   use dftd3_utils, only : wrap_to_central_cell
   use dftd3_citation, only : format_bibtex, is_citation_present, citation_type, &
      & get_citation, doi_dftd3_0, doi_dftd3_bj, doi_dftd3_m, doi_dftd3_op, &
      & doi_dftd3_cso, doi_joss, same_citation
   use dftd3_app_help, only : header
   use dftd3_app_cli, only : app_config, run_config, param_config, gcp_config, get_arguments
   use dftd3_app_toml, only : param_database
   implicit none
   private

   public :: app_driver

contains

subroutine app_driver(config, error)
   class(app_config), intent(in) :: config
   type(error_type), allocatable, intent(out) :: error

   select type(config)
   type is(run_config)
      call run_driver(config, error)
   type is(param_config)
      call param_driver(config, error)
   type is(gcp_config)
      call gcp_driver(config, error)
   end select
end subroutine app_driver

subroutine run_driver(config, error)
   type(run_config), intent(in) :: config
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(damping_param), allocatable :: param
   type(d3_param) :: inp
   type(d3_model) :: d3
   type(gcp_param) :: gcp
   real(wp), allocatable :: energies(:), gradient(:, :), sigma(:, :)
   real(wp), allocatable :: pair_disp2(:, :), pair_disp3(:, :)
   real(wp), allocatable :: s9
   real(wp) :: energy
   character(len=:), allocatable :: output
   integer :: unit
   type(citation_type) :: citation, param_citation

   if (config%verbosity > 1) then
      call header(output_unit)
   end if

   if (config%input == "-") then
      if (.not.allocated(config%input_format)) then
         call read_structure(mol, input_unit, filetype%xyz, error)
      else
         call read_structure(mol, input_unit, config%input_format, error)
      end if
   else
      call read_structure(mol, config%input, error, config%input_format)
   end if
   if (allocated(error)) return
   if (config%wrap) then
      call wrap_to_central_cell(mol%xyz, mol%lattice, mol%periodic)
   end if

   if (config%has_param) inp = config%inp
   if (config%atm) s9 = config%inp%s9
   if (config%zero) then
      citation = get_citation(doi_dftd3_0)
      if (.not.config%has_param) then
         if (allocated(config%db)) then
            call from_db(param, config%db, config%method, "zero", error)
         else
            call get_zero_damping(inp, config%method, error, s9, param_citation)
         end if
         if (allocated(error)) return
      end if
      if (.not.allocated(param)) then
         block
            type(zero_damping_param), allocatable :: zparam
            allocate(zparam)
            call new_zero_damping(zparam, inp)
            call move_alloc(zparam, param)
         end block
      end if
   end if
   if (config%mzero) then
      citation = get_citation(doi_dftd3_m)
      if (.not.config%has_param) then
         if (allocated(config%db)) then
            call from_db(param, config%db, config%method, "zerom", error)
         else
            call get_mzero_damping(inp, config%method, error, s9, param_citation)
         end if
         if (allocated(error)) return
      end if
      if (.not.allocated(param)) then
         block
            type(mzero_damping_param), allocatable :: mparam
            allocate(mparam)
            call new_mzero_damping(mparam, inp)
            call move_alloc(mparam, param)
         end block
      end if
   end if
   if (config%rational .or. config%mrational) then
      if (config%rational) then
         citation = get_citation(doi_dftd3_bj)
      else
         citation = get_citation(doi_dftd3_m)
      end if
      if (.not.config%has_param) then
         if (config%mrational) then
            if (allocated(config%db)) then
               call from_db(param, config%db, config%method, "bjm", error)
            else
               call get_mrational_damping(inp, config%method, error, s9, param_citation)
            end if
         else
            if (allocated(config%db)) then
               call from_db(param, config%db, config%method, "bj", error)
            else
               call get_rational_damping(inp, config%method, error, s9, param_citation)
            end if
         end if
         if (allocated(error)) return
      end if
      if (.not.allocated(param)) then
         block
            type(rational_damping_param), allocatable :: rparam
            allocate(rparam)
            call new_rational_damping(rparam, inp)
            call move_alloc(rparam, param)
         end block
      end if
   end if
   if (config%optimizedpower) then
      citation = get_citation(doi_dftd3_op)
      if (.not.config%has_param) then
         if (allocated(config%db)) then
            call from_db(param, config%db, config%method, "op", error)
         else
            call get_optimizedpower_damping(inp, config%method, error, s9, param_citation)
         end if
         if (allocated(error)) return
      end if
      if (.not.allocated(param)) then
         block
            type(optimizedpower_damping_param), allocatable :: oparam
            allocate(oparam)
            call new_optimizedpower_damping(oparam, inp)
            call move_alloc(oparam, param)
         end block
      end if
   end if
   if (config%cso) then
      citation = get_citation(doi_dftd3_cso)
      if (.not.config%has_param) then
         if (allocated(config%db)) then
            call from_db(param, config%db, config%method, "cso", error)
         else
            call get_cso_damping(inp, config%method, error, s9, param_citation)
         end if
         if (allocated(error)) return
      else
         inp%a2 = 2.5_wp
         inp%rs6 = 0.0_wp
         inp%rs8 = 6.25_wp
      end if
      if (.not.allocated(param)) then
         block
            type(cso_damping_param), allocatable :: cparam
            allocate(cparam)
            call new_cso_damping(cparam, inp)
            call move_alloc(cparam, param)
         end block
      end if
   end if
   if (config%gcp) then
      call get_gcp_param(gcp, mol, config%method, config%basis)
   end if

   if (config%verbosity > 0) then
      if (allocated(param)) &
         call ascii_damping_param(output_unit, param, config%method)
      if (config%gcp) &
         call ascii_gcp_param(output_unit, mol, gcp)
   end if

   if (allocated(param)) then
      allocate(energies(mol%nat))
      if (config%grad) then
         allocate(gradient(3, mol%nat), sigma(3, 3))
      end if
   end if

   call new_d3_model(d3, mol)

   if (config%properties) then
      call property_calc(output_unit, mol, d3, config%verbosity)
   end if

   if (allocated(param)) then
      call get_dispersion(mol, d3, param, realspace_cutoff(), energies, &
         & gradient, sigma)
      if (config%gcp) then
         call get_geometric_counterpoise(mol, gcp, realspace_cutoff(), energies, gradient, sigma)
      end if
      energy = sum(energies)

      if (config%pair_resolved) then
         allocate(pair_disp2(mol%nat, mol%nat), pair_disp3(mol%nat, mol%nat))
         call get_pairwise_dispersion(mol, d3, param, realspace_cutoff(), pair_disp2, &
            & pair_disp3)
      end if
      if (config%verbosity > 0) then
         if (config%verbosity > 2) then
            call ascii_energy_atom(output_unit, mol, energies)
         end if
         call ascii_results(output_unit, mol, energy, gradient, sigma)
         if (config%pair_resolved) then
            call ascii_pairwise(output_unit, mol, pair_disp2, pair_disp3)
         end if
      end if
      if (config%tmer) then
         call tmer_writer(".EDISP", energy, "Dispersion", config%verbosity)
      end if
      if (config%grad) then
         if (allocated(config%grad_output)) then
            call results_writer(config%grad_output, energy, gradient, sigma, &
               & "Dispersion", config%verbosity)
         end if

         call turbomole_writer(mol, energy, gradient, sigma, config%verbosity, "Dispersion")
      end if

      if (config%json) then
         open(file=config%json_output, newunit=unit)
         call json_results(unit, "  ", energy=energy, gradient=gradient, sigma=sigma, &
            & pairwise_energy2=pair_disp2, pairwise_energy3=pair_disp3, param=param)
         close(unit)
         if (config%verbosity > 0) then
            write(output_unit, '(a)') &
               & "[Info] JSON dump of results written to '"//config%json_output//"'"
         end if
      end if

   end if

   if (config%citation) then
      open(file=config%citation_output, newunit=unit)
      call format_bibtex(output, get_citation(doi_joss))
      if (allocated(output)) write(unit, '(a)') output
      if (.not.same_citation(citation, param_citation)) then
         call format_bibtex(output, citation)
         if (allocated(output)) write(unit, '(a)') output
      end if
      call format_bibtex(output, param_citation)
      if (allocated(output)) write(unit, '(a)') output
      close(unit)
      if (config%verbosity > 0) then
         write(output_unit, '(a)') &
            & "[Info] Citation information written to '"//config%citation_output//"'"
      end if
   end if

end subroutine run_driver

subroutine property_calc(unit, mol, disp, verbosity)

   !> Unit for output
   integer, intent(in) :: unit

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Dispersion model
   class(d3_model), intent(in) :: disp

   !> Printout verbosity
   integer, intent(in) :: verbosity

   integer :: mref
   real(wp), allocatable :: cn(:), gwvec(:, :), c6(:, :), lattr(:, :)

   if (verbosity > 1) then
      call ascii_atomic_radii(unit, mol, disp)
      write(unit, '(a)')
      call ascii_atomic_references(unit, mol, disp)
      write(unit, '(a)')
   end if

   mref = maxval(disp%ref)
   allocate(cn(mol%nat), gwvec(mref, mol%nat), c6(mol%nat, mol%nat))
   call get_lattice_points(mol%periodic, mol%lattice, 30.0_wp, lattr)
   call get_coordination_number(mol, lattr, 30.0_wp, disp%rcov, cn)
   call disp%weight_references(mol, cn, gwvec)
   call disp%get_atomic_c6(mol, gwvec, c6=c6)

   if (verbosity > 0) then
      call ascii_system_properties(unit, mol, disp, cn, c6)
      write(unit, '(a)')
   end if

end subroutine property_calc

subroutine param_driver(config, error)
   type(param_config), intent(in) :: config
   type(error_type), allocatable, intent(out) :: error

   type(param_database) :: db
   class(damping_param), allocatable :: param

   call db%load(config%input, error)
   if (allocated(error)) return

   if (allocated(config%method)) then
      call db%get(param, config%method, config%damping)
      if (.not.allocated(param)) then
         call fatal_error(error, "No entry for '"//config%method//"' found in '"//config%input//"'")
         return
      end if
      call ascii_damping_param(output_unit, param, config%method)
   else
      write(output_unit, '(a, *(1x, g0))') "[Info] Found", size(db%records), &
         "damping parameters in '"//config%input//"'"
   end if

end subroutine param_driver

subroutine from_db(param, input, method, damping, error)
   class(damping_param), allocatable, intent(out) :: param
   character(len=*), intent(in) :: input
   character(len=*), intent(in) :: method
   character(len=*), intent(in) :: damping
   type(error_type), allocatable, intent(out) :: error

   type(param_database) :: db

   call db%load(input, error)
   if (allocated(error)) return

   call db%get(param, method, damping)
   if (.not.allocated(param)) then
      call fatal_error(error, "No entry for '"//method//"' found in '"//input//"'")
      return
   end if
end subroutine from_db

subroutine gcp_driver(config, error)
   type(gcp_config), intent(in) :: config
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(gcp_param) :: param
   integer :: unit
   real(wp) :: energy
   real(wp), allocatable :: energies(:), gradient(:, :), sigma(:, :)

   if (config%verbosity > 1) then
      call header(output_unit)
   end if

   if (config%input == "-") then
      if (.not.allocated(config%input_format)) then
         call read_structure(mol, input_unit, filetype%xyz, error)
      else
         call read_structure(mol, input_unit, config%input_format, error)
      end if
   else
      call read_structure(mol, config%input, error, config%input_format)
   end if
   if (allocated(error)) return
   if (config%wrap) then
      call wrap_to_central_cell(mol%xyz, mol%lattice, mol%periodic)
   end if

   call get_gcp_param(param, mol, config%method, config%basis)
   if (config%verbosity > 0) then
      call ascii_gcp_param(output_unit, mol, param)
   end if

   allocate(energies(mol%nat), source=0.0_wp)
   if (config%grad) then
      allocate(gradient(3, mol%nat), source=0.0_wp)
      allocate(sigma(3, 3), source=0.0_wp)
   end if

   call get_geometric_counterpoise(mol, param, realspace_cutoff(), energies, gradient, sigma)
   energy = sum(energies)

   if (config%verbosity > 0) then
      if (config%verbosity > 2) then
         call ascii_energy_atom(output_unit, mol, energies, label="counter-poise")
      end if
      call ascii_results(output_unit, mol, energy, gradient, sigma, label="Counter-poise")
   end if

   if (config%tmer) then
      call tmer_writer(".CPC", energy, "Counter-poise", config%verbosity)
   end if

   if (config%grad) then
      if (allocated(config%grad_output)) then
         call results_writer(config%grad_output, energy, gradient, sigma, &
            & "Counter-poise", config%verbosity)
      end if

      call turbomole_writer(mol, energy, gradient, sigma, config%verbosity, "Counter-poise")
   end if

   if (config%json) then
      open(file=config%json_output, newunit=unit)
      call json_results(unit, "  ", energy=energy, gradient=gradient, sigma=sigma)
      close(unit)
      if (config%verbosity > 0) then
         write(output_unit, '(a)') &
            & "[Info] JSON dump of results written to '"//config%json_output//"'"
      end if
   end if
end subroutine gcp_driver

!> Write the energy to a file
subroutine tmer_writer(filename, energy, label, verbosity)
   !> File name to write to
   character(len=*), intent(in) :: filename

   !> Energy to write
   real(wp), intent(in) :: energy

   !> Label for the output
   character(len=*), intent(in) :: label

   !> Printout verbosity
   integer, intent(in) :: verbosity

   integer :: unit

   if (verbosity > 0) then
      if (verbosity > 1) then
         write(output_unit, '(a)') "[Info] Writing "//label//" energy to '"//filename//"'"
      end if
      open(file=filename, newunit=unit)
      write(unit, '(f24.14)') energy
      close(unit)
   end if
end subroutine tmer_writer

!> Write the results to a file
subroutine results_writer(filename, energy, gradient, sigma, label, verbosity)
   !> File name to write to
   character(len=*), intent(in) :: filename

   !> Energy to write
   real(wp), intent(in) :: energy

   !> Gradient to write
   real(wp), intent(in) :: gradient(:, :)

   !> Virial tensor to write
   real(wp), intent(in) :: sigma(:, :)

   !> Label for the output
   character(len=*), intent(in) :: label

   !> Printout verbosity
   integer, intent(in) :: verbosity

   integer :: unit

   open(file=filename, newunit=unit)
   call tagged_result(unit, energy, gradient, sigma)
   close(unit)
   if (verbosity > 0) then
      write(output_unit, '(a)') "[Info] "//label//" results written to '"//filename//"'"
   end if
end subroutine results_writer

!> Write the gradient and virial tensor to Turbomole files
subroutine turbomole_writer(mol, energy, gradient, sigma, verbosity, label)

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Energy of the system
   real(wp), intent(in) :: energy

   !> Gradient of the system
   real(wp), intent(in) :: gradient(:, :)

   !> Virial tensor of the system
   real(wp), intent(in) :: sigma(:, :)

   !> Printout verbosity
   integer, intent(in) :: verbosity

   !> Label for the output
   character(len=*), intent(in) :: label

   logical :: exist
   integer :: stat

   inquire(file="gradient", exist=exist)
   if (exist) then
      call turbomole_gradient(mol, "gradient", energy, gradient, stat)
      if (verbosity > 0) then
         if (stat == 0) then
            write(output_unit, '(a)') &
               & "[Info] "//label//" gradient added to Turbomole gradient file"
         else
            write(output_unit, '(a)') &
               & "[Warn] Could not add to Turbomole gradient file"
         end if
      end if
   end if
   inquire(file="gradlatt", exist=exist)
   if (exist) then
      call turbomole_gradlatt(mol, "gradlatt", energy, sigma, stat)
      if (verbosity > 0) then
         if (stat == 0) then
            write(output_unit, '(a)') &
               & "[Info] "//label//" virial added to Turbomole gradlatt file"
         else
            write(output_unit, '(a)') &
               & "[Warn] Could not add to Turbomole gradlatt file"
         end if
      end if
   end if
end subroutine turbomole_writer

end module dftd3_app_driver

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/context/solver.f90
!> Provides an abstract base class for an electronic solver

!> Abstract base class for an electronic solver
module tblite_context_solver
   use mctc_env, only : wp
   use tblite_scf_solver, only : solver_type
   implicit none
   private


   !> Abstract base class for creating electronic solver instances
   type, public, abstract :: context_solver
   contains
      !> Create new instance of electronic solver
      procedure(new), deferred :: new
      !> Delete an electronic solver instance
      procedure(delete), deferred :: delete
   end type context_solver


   abstract interface
      !> Create new electronic solver
      subroutine new(self, solver, overlap, nel, kt)
         import :: wp, context_solver, solver_type
         !> Instance of the solver factory
         class(context_solver), intent(inout) :: self
         !> New electronic solver
         class(solver_type), allocatable, intent(out) :: solver
         !> Overlap matrix
         real(wp), intent(in) :: overlap(:, :)
         !> Electronic temperature
         real(wp), intent(in) :: kt
         !> Number of electrons per spin channel
         real(wp), intent(in) :: nel(:)
      end subroutine new

      !> Delete electronic solver instance
      subroutine delete(self, solver)
         import :: context_solver, solver_type
         !> Instance of the solver factory
         class(context_solver), intent(inout) :: self
         !> Electronic solver instance
         class(solver_type), allocatable, intent(inout) :: solver
      end subroutine delete
   end interface


end module tblite_context_solver

! This file is part of mstore.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mstore
   use, intrinsic :: iso_fortran_env, only : error_unit
   use mctc_env, only : error_type, fatal_error
   use mctc_io_structure, only : structure_type
   use mstore_data_collection, only : collection_type, new_collection, select_collection
   use mstore_data_record, only : select_record
   use mstore_data_store, only : store_type, new_store
   use mstore_amino20x4, only : get_amino20x4_records
   use mstore_but14diol, only : get_but14diol_records
   use mstore_heavy28, only : get_heavy28_records
   use mstore_ice10, only : get_ice10_records
   use mstore_il16, only : get_il16_records
   use mstore_mb16_43, only : get_mb16_43_records
   use mstore_upu23, only : get_upu23_records
   use mstore_x23, only : get_x23_records
   use mstore_f_block, only : get_f_block_records
   implicit none
   private

   public :: get_structure
   public :: list_collections, list_records

   type(store_type), allocatable :: store

contains

subroutine check_mstore
   !$omp critical (mstore_load)
   if (.not.allocated(store)) store = new_store("mstore", get_mstore_collections)
   !$omp end critical (mstore_load)
end subroutine check_mstore

subroutine list_collections(unit, error)
   integer, intent(in) :: unit
   type(error_type), allocatable, intent(out) :: error
   integer :: is

   call check_mstore

   do is = 1, size(store%collections)
      write(unit, '(a)') store%collections(is)%id
   end do

end subroutine list_collections

subroutine list_records(unit, collection, error)
   integer, intent(in) :: unit
   character(len=*), intent(in) :: collection
   type(error_type), allocatable, intent(out) :: error
   integer :: is, ir

   call check_mstore

   is = select_collection(store%collections, collection)

   if (is < 1) then
      call fatal_error(error, "Requested collection '"//collection//"' not available")
      return
   end if

   do ir = 1, size(store%collections(is)%records)
      write(unit, '(a)') store%collections(is)%records(ir)%id
   end do

end subroutine list_records

subroutine get_record(mol, collection, record, error)
   type(structure_type), intent(out) :: mol
   character(len=*), intent(in) :: collection
   character(len=*), intent(in) :: record
   type(error_type), allocatable :: error
   integer :: is, ir

   call check_mstore

   is = select_collection(store%collections, collection)

   if (is < 1) then
      call fatal_error(error, "Requested collection '"//collection//"' not available")
      return
   end if

   ir = select_record(store%collections(is)%records, record)

   if (ir < 1) then
      call fatal_error(error, "Requested record '"//record//"' not available in '"//&
         & collection//"' collection")
      return
   end if

   associate(record => store%collections(is)%records(ir)) 
      call record%get(mol)
   end associate

end subroutine get_record

subroutine get_structure(self, collection, record)
   type(structure_type), intent(out) :: self
   character(len=*), intent(in) :: collection
   character(len=*), intent(in) :: record
   type(error_type), allocatable :: error

   call get_record(self, collection, record, error)

   if (allocated(error)) then
      write(error_unit, '(a)') error%message
      error stop
   end if

end subroutine get_structure

subroutine get_mstore_collections(collections)
   type(collection_type), allocatable, intent(out) :: collections(:)

   collections = [ &
      new_collection("Amino20x4", get_amino20x4_records), &
      new_collection("But14diol", get_but14diol_records), &
      new_collection("f-block", get_f_block_records), &
      new_collection("Heavy28", get_heavy28_records), &
      new_collection("ICE10", get_ice10_records), &
      new_collection("IL16", get_il16_records), &
      new_collection("MB16-43", get_mb16_43_records), &
      new_collection("UPU23", get_upu23_records), &
      new_collection("X23", get_x23_records) &
      ]

end subroutine get_mstore_collections

end module mstore

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file tests/ddlpb.f90
!! Test of analytical derivatives against numerical for each matrices
!!
!! @version 1.0.0
!! @author Abhinav Jha
!! @date 2022-02-22

program main
use ddx_core
use ddx_operators
use ddx_solvers
use ddx
use ddx_lpb
implicit none

character(len=255) :: fname
type(ddx_type) :: ddx_data
type(ddx_error_type) :: ddx_error
character(len=255) :: dummy_file_name = ''
! derivative_num_A  : Numerical derivatives for matrix A
! derivative_num_B  : Numerical derivatives for matrix B
! derivative_num_Ui : Numerical derivatives for U_i^e(x_in) (Char. function)
! derivative_num_C  : Numerical derivatives for C1_C2
real(dp), allocatable :: derivative_num_A(:, :), derivative_num_B(:,:),&
                         & derivative_num_Ui(:,:), &
                         & derivative_num_C(:,:)
! step         : Step size for the numerical derivatives
! relerr_A     : Relative error for matrix A
! relerr_B     : Relative error for matrix B
! relerr_Ui    : Relative error for U_i^e(x_in)
! relerr_C1_C2 : Relative error for C1_C2
real(dp) :: step, relerr_A = zero, relerr_B = zero, relerr_Ui = zero,&
            & relerr_C1_C2 = zero, tol = zero
! isph   : Index for number of spheres
! i      : Index for derivative components (i = 1,2,3)
! ibasis : Index for number of basis
integer :: isph, i
! vsin, vcos, vplm : Values used in basloc
! basloc : Y_lm
! dbasloc : Derivatives of Y_lm
real(dp), allocatable :: vsin(:), vcos(:), vplm(:), basloc(:), dbsloc(:,:)
! random_vector_two_evaluated_at_grid : Vector evaluated on grid points
!                                 (\sum_lm(Y_lm(s_n)[X]_{ilm})
! vector_ngrid_nsph        : Vector of size ngrid \times nsph
! vector_nbasis_nsph       : Vector of size nbasis \times nsph
real(dp), allocatable:: random_vector_two_evaluated_at_grid(:,:),&
                        & vector_ngrid_nsph(:,:), &
                        & random_vector_nbasis_nsph_one(:,:), &
                        & random_vector_nbasis_nsph_two(:,:)
! derivative_A     : Analytic derivative of matrix A
! derivative_B     : Analytic derivative of matrix B
! derivative_Ui    : Analytic derivative of U_i^e(x_in)
! derivative_C1_C2 : Analytic derivative of C1_C2
! diff_re          : Used for derivative in C1_C2 with Q not constant
real(dp), allocatable:: derivative_A(:,:), derivative_B(:,:), &
                       & derivative_Ui(:,:), &
                       & derivative_C1_C2(:,:), &
                       & diff_re(:,:)
real(dp), allocatable :: charges(:)
! sum_A_plus_h  : Computation of matrix A evaluated at x+h
! sum_A_minus_h : Computation of matrix A evaluated at x-h
! sum_B_plus_h    : Computation of matrix B evaluated at x+h
! sum_B_minus_h   : Computation of matrix B evaluated at x-h
! sum_Ui_plus_h   : Computation of U_i^e(x_in) evaluated at x+h
! sum_Ui_minus_h  : Computation of U_i^e(x_in) evaluated at x-h
! sum_C_plus_h  : Computation of matrix C1_C2 evaluated at x+h
! sum_C_plus_h  : Computation of matrix C1_C2 evaluated at x-h
real(dp) :: sum_A_plus_h, sum_B_plus_h, sum_A_minus_h, sum_B_minus_h,&
            & sum_Ui_minus_h, &
            & sum_Ui_plus_h, sum_C_minus_h, sum_C_plus_h, &
            & lmax0, nbasis0
real(dp), external :: dnrm2, ddot

! Read input file name
call get_command_argument(1, fname)
write(*, *) "Using provided file ", trim(fname), " as a config file 12"
call ddfromfile(fname, ddx_data, tol, charges, ddx_error)
call check_error(ddx_error)

! lmax0 set to minimum of 6 or given lmax.
! nbasis0 set to minimum of 49 or given (lmax+1)^2.
! Maybe do it ddlpb_init(?)
lmax0 = MIN(6, ddx_data % params % lmax)
nbasis0 = MIN(49, ddx_data % constants % nbasis)

! Allocation for various vectors
allocate(derivative_num_A(3, ddx_data % params % nsph), &
    & derivative_num_B(3, ddx_data % params % nsph),&
    & derivative_num_Ui(3, ddx_data % params % nsph),&
    & derivative_num_C(3, ddx_data % params % nsph), &
    & vsin(ddx_data % params % lmax+1), vcos(ddx_data % params % lmax+1), &
    & vplm(ddx_data % constants % nbasis), &
    & basloc(ddx_data % constants % nbasis), &
    & dbsloc(3, ddx_data % constants % nbasis), &
    & random_vector_nbasis_nsph_one(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & random_vector_nbasis_nsph_two(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & vector_ngrid_nsph(ddx_data % params % ngrid, ddx_data % params % nsph), &
    & random_vector_two_evaluated_at_grid(ddx_data % params % ngrid, &
    & ddx_data % params % nsph), &
    & derivative_A(3, ddx_data % params % nsph), &
    & derivative_B(3, ddx_data % params % nsph), &
    & derivative_Ui(3, ddx_data % params % nsph), &
    & derivative_C1_C2(3, ddx_data % params % nsph), &
    & diff_re(ddx_data % constants % nbasis, ddx_data % params % nsph))

! Random vectors
random_vector_nbasis_nsph_one = one
random_vector_nbasis_nsph_two = one
random_vector_nbasis_nsph_one(1,1) = 2.0
random_vector_nbasis_nsph_two(2,1) = 3.0

! For Ui the unit vector works well because the contraction is from
! one side
vector_ngrid_nsph = one

! Allocation to zero
diff_re = zero

derivative_A = zero
derivative_B = zero
derivative_Ui = zero
derivative_C1_C2 = zero

step = 1d-7

call dgemm('T', 'N', ddx_data % params % ngrid, ddx_data % params % nsph, &
            & ddx_data % constants % nbasis, one, ddx_data % constants % vgrid, ddx_data % constants % vgrid_nbasis, &
            & random_vector_nbasis_nsph_two, &
            & ddx_data % constants % nbasis, zero, &
            & random_vector_two_evaluated_at_grid, &
            & ddx_data % params % ngrid)


! Compute unit_vector^T*B^k*unit_vector for x_1
do isph = 1, ddx_data % params % nsph
  ! Computation of derivative for matrix A
  call contract_grad_L(ddx_data % params, ddx_data % constants, isph, &
             & random_vector_nbasis_nsph_one, &
             & random_vector_two_evaluated_at_grid, &
             & basloc, dbsloc, vplm, vcos, vsin, derivative_A(:,isph))
  ! Computation of derivative for matrix B
  call contract_grad_B(ddx_data % params, ddx_data % constants, &
                 & isph, random_vector_nbasis_nsph_one, random_vector_two_evaluated_at_grid, &
                 & derivative_B(:,isph))
  ! Computation for derivative of U_i^e(x_in)
  call contract_grad_U(ddx_data % params, ddx_data % constants, &
            & isph, vector_ngrid_nsph, vector_ngrid_nsph, &
            & derivative_Ui(:, isph))
end do

! Computation for matrix C1_C2
call contract_grad_C(ddx_data % params, ddx_data % constants, &
             & ddx_data % workspace, &
             & random_vector_nbasis_nsph_one, &
             & random_vector_nbasis_nsph_one, &
             & random_vector_two_evaluated_at_grid, &
             & random_vector_two_evaluated_at_grid, &
             & random_vector_nbasis_nsph_two, &
             & random_vector_nbasis_nsph_two, &
             & derivative_C1_C2, &
             & diff_re, ddx_error)

do isph = 1, ddx_data % params % nsph
    do i = 1, 3
        ! Set the initial sums to zero
        sum_A_minus_h = zero
        sum_A_plus_h = zero
        sum_B_minus_h = zero
        sum_B_plus_h = zero
        sum_Ui_minus_h = zero
        sum_Ui_plus_h = zero
        sum_C_minus_h = zero
        sum_C_plus_h = zero
        ! Set the centers to x + h
        ddx_data % params % csph(i, isph) = ddx_data % params % csph(i, isph) &
                                           & + step
        ! Call solve
        call test_solve(ddx_data, sum_A_plus_h, sum_B_plus_h, sum_Ui_plus_h, &
                   & sum_C_plus_h)
        ! Set the center to x - h
        ddx_data % params % csph(i, isph) = ddx_data % params % csph(i, isph) &
                                           & - two*step
        ! Call solve
        call test_solve(ddx_data, sum_A_minus_h, sum_B_minus_h, sum_Ui_minus_h, &
                   & sum_C_minus_h)
        ! Set the center to x
        ddx_data % params % csph(i, isph) = ddx_data % params % csph(i, isph) &
                                          & + step
        ! Numerical derivative = (f(x+h)-f(x-h))/(2*h)
        derivative_num_A(i, isph) = (sum_A_plus_h - sum_A_minus_h) / two / step
        derivative_num_B(i, isph) = (sum_B_plus_h - sum_B_minus_h) / two / step
        derivative_num_Ui(i, isph)= (sum_Ui_plus_h - sum_Ui_minus_h) / two / step
        derivative_num_C(i, isph) = (sum_C_plus_h  - sum_C_minus_h) / two / step
    end do
end do
! Relative Errors
relerr_A = dnrm2(3*ddx_data % params % nsph,derivative_num_A-derivative_A,1) / &
    & dnrm2(3*ddx_data % params % nsph, derivative_A, 1)
relerr_B = dnrm2(3*ddx_data % params % nsph,derivative_num_B-derivative_B,1) / &
    & dnrm2(3*ddx_data % params % nsph, derivative_B, 1)
relerr_Ui = dnrm2(3*ddx_data % params % nsph, derivative_num_Ui - derivative_Ui, 1) / &
    & dnrm2(3*ddx_data % params % nsph, derivative_Ui, 1)
relerr_C1_C2 = dnrm2(3*ddx_data % params % nsph, &
    & derivative_num_C - (derivative_C1_C2), 1) / &
    & dnrm2(3*ddx_data % params % nsph, (derivative_C1_C2), 1)


write(6,'(2A60)') 'Matrix A Analytical forces', 'Numerical forces'
do i = 1, ddx_data % params % nsph
  write(6,'(6E20.10)') derivative_A(1,i), derivative_A(2,i), derivative_A(3,i), &
  & derivative_num_A(1,i), derivative_num_A(2,i), derivative_num_A(3,i)
end do

write(6,'(2A60)') ' Matrix B Analytical forces', 'Numerical forces'
do i = 1, ddx_data % params % nsph
  write(6,'(6E20.10)') derivative_B(1,i), derivative_B(2,i), derivative_B(3,i), &
  & derivative_num_B(1,i), derivative_num_B(2,i), derivative_num_B(3,i)
end do

write(6,'(2A60)') ' U_i^e(x_in) Analytical forces', 'Numerical forces'
do i = 1, ddx_data % params % nsph
  write(6,'(6E20.10)') derivative_Ui(1,i), derivative_Ui(2,i), derivative_Ui(3,i), &
  & derivative_num_Ui(1,i), derivative_num_Ui(2,i), derivative_num_Ui(3,i)
end do

write(6,'(2A60)') ' Matrix C1_C2 Analytical forces', 'Numerical forces'
do i = 1, ddx_data % params % nsph
  write(6,'(6E20.10)') derivative_C1_C2(1,i), &
                     & derivative_C1_C2(2,i), &
                     & derivative_C1_C2(3,i), &
                     & derivative_num_C(1,i), derivative_num_C(2,i), &
                     & derivative_num_C(3,i)
end do


! Deallocation
deallocate(derivative_num_A, derivative_num_B, derivative_num_Ui, &
           & vcos, vsin, vplm, basloc, dbsloc, &
           & random_vector_nbasis_nsph_two, &
           & random_vector_nbasis_nsph_one, &
           & random_vector_two_evaluated_at_grid, &
           & derivative_C1_C2, &
           & derivative_A, derivative_B, diff_re, derivative_num_C, charges)
call deallocate_model(ddx_data, ddx_error)

write(*, *) "Rel. error of A     :", relerr_A
write(*, *) "Rel. error of B     :", relerr_B
write(*, *) "Rel. error of U_i^e :", relerr_Ui
write(*, *) "Rel. error of C1_C2 :", relerr_C1_C2

if (relerr_A .gt. 1d-6) then
    write(*,*) 'Error in computing derivatives of A, Rel.Error : ', relerr_A
    stop 1
endif
if (relerr_B .gt. 1d-6) then
    write(*,*) 'Error in computing derivatives of B, Rel.Error : ', relerr_B
    stop 1
endif
if (relerr_Ui .gt. 1d-6) then
    write(*,*) 'Error in computing derivatives of Ui, Rel.Error : ', relerr_Ui
    stop 1
endif
if (relerr_C1_C2 .gt. 1d-6) then
    write(*,*) 'Error in computing derivatives of C1C2, Rel.Error : ',&
                & relerr_C1_C2
    stop 1
endif

contains

subroutine test_solve(ddx_data, sum_der_A, sum_der_B, sum_der_Ui, sum_der_C1_C2)
    type(ddx_type), intent(inout) :: ddx_data
    real(dp), intent(inout) :: sum_der_A, sum_der_B, sum_der_Ui, sum_der_C1_C2
    ! Local variables
    ! ddx_data2  : New ddx_data with new coordinates
    type(ddx_type) :: ddx_data2
    ! vector_n           : Unit vector of size n\times 1
    ! vector_cosmo            : y = Ax
    ! vector_lpb              : y = Bx
    ! vector_nbasis_nsph : Unit vector of size nbasis \times nsph
    ! vector_e_c1_c2          : y = C1Xr + C2Xe
    ! vector_r_c1_c2          : y = C1Xr + C2Xe
    real(dp), allocatable :: random_vector_n_one(:), &
                             & random_vector_n_two(:), &
                             & random_vector_nbasis_nsph_one(:,:), &
                             & random_vector_nbasis_nsph_two(:,:), &
                             & random_vector_C_one(:,:, :), &
                             & vector_cosmo(:), vector_lpb(:),&
                             & vector_c1_c2(:,:, :),&
                             & zero_vector(:,:)
    ! i      : Index for n
    ! isph   : Index for number of sphers
    ! igrid  : Index for grid points
    ! ibasis : Index for number of basis
    integer :: i, isph, igrid, ibasis
    type(ddx_error_type) :: ddx_error

    ! Initialise new ddx_data with new centers coordinates
    call allocate_model(ddx_data % params % nsph, &
        & ddx_data % params % csph(1, :), &
        & ddx_data % params % csph(2, :), &
        & ddx_data % params % csph(3, :), &
        & ddx_data % params % rsph, &
        & ddx_data % params % model, &
        & ddx_data % params % lmax, &
        & ddx_data % params % ngrid, 0, &
        & ddx_data % params % fmm, &
        & ddx_data % params % pm, &
        & ddx_data % params % pl, &
        & ddx_data % params % se, &
        & ddx_data % params % eta, &
        & ddx_data % params % eps, &
        & ddx_data % params % kappa, 0, &
        & ddx_data % params % maxiter, &
        & ddx_data % params % jacobi_ndiis, &
        & ddx_data % params % nproc, dummy_file_name, ddx_data2, ddx_error)
    ! Allocation
    allocate(random_vector_n_one(ddx_data2 % constants % n), &
             & random_vector_n_two(ddx_data2 % constants % n), &
             & random_vector_nbasis_nsph_one(ddx_data2 % constants % nbasis,&
             & ddx_data2 % params % nsph),&
             & random_vector_nbasis_nsph_two(ddx_data2 % constants % nbasis,&
             & ddx_data2 % params % nsph),&
             & random_vector_C_one(ddx_data2 % constants % nbasis,&
             & ddx_data2 % params % nsph, 2),&
             & vector_cosmo(ddx_data2 % constants % n), &
             & vector_lpb(ddx_data2 % constants % n), &
             & vector_c1_c2(ddx_data2 % constants % nbasis, &
             &  ddx_data2 % params % nsph, 2), &
             & zero_vector(ddx_data2 % constants%  nbasis, &
             & ddx_data2 % params % nsph))
    ! Intialisation
    random_vector_n_one = one
    random_vector_n_two = one
    random_vector_n_one(1) = two
    random_vector_n_two(2) = three

    random_vector_nbasis_nsph_one = one
    random_vector_nbasis_nsph_two = one
    random_vector_nbasis_nsph_one(1,1) = two
    random_vector_nbasis_nsph_two(2,1) = three

    random_vector_C_one(:,:,1) = random_vector_nbasis_nsph_one
    random_vector_C_one(:,:,2) = random_vector_nbasis_nsph_one


    vector_cosmo = one
    vector_lpb = one
    vector_c1_c2 = zero
    zero_vector = zero
    ! Call for matrix A
    call lx(ddx_data2 % params, ddx_data2 % constants, &
          & ddx_data2 % workspace, random_vector_n_one, vector_cosmo, ddx_error)
    ! Call for matrix B
    call bx(ddx_data2 % params, ddx_data2 % constants, &
              & ddx_data2 % workspace, &
              & random_vector_n_one, vector_lpb, ddx_error)
    call cx(ddx_data2 % params, ddx_data2 % constants, &
                 & ddx_data2 % workspace, &
                 & random_vector_C_one, &
                 & vector_c1_c2, ddx_error)
    ! Sum for U_i^e(x_in)
    do isph = 1,ddx_data2 %  params % nsph
      do igrid = 1,ddx_data2 %  params % ngrid
        if (ddx_data2 %  constants % ui(igrid, isph) .gt. zero) then
          sum_der_Ui = sum_der_Ui + ddx_data2 %  constants % wgrid(igrid) * &
                        & ddx_data2 %  constants % ui(igrid, isph)
        end if
      end do
    end do
    ! Sum for matrix C1_C2 with Q constant
    do ibasis = 1, ddx_data2 % constants % nbasis
      do isph = 1, ddx_data2 %  params % nsph
        sum_der_C1_C2 = sum_der_C1_C2 &
                    & + random_vector_nbasis_nsph_two(ibasis, isph)* &
                    & vector_c1_c2(ibasis, isph, 1)&
                    & + random_vector_nbasis_nsph_two(ibasis, isph)* &
                    & vector_c1_c2(ibasis, isph, 2)
      end do
    end do
    ! Sum for matrix A and matrix B
    do i = 1, ddx_data2 % constants % n
        sum_der_A = sum_der_A + random_vector_n_two(i)*vector_cosmo(i)
        sum_der_B = sum_der_B + random_vector_n_two(i)*vector_lpb(i)
    end do
    ! Deallocation
    deallocate(random_vector_n_one, vector_cosmo, &
               & random_vector_n_two, &
               & random_vector_nbasis_nsph_one, &
               & random_vector_nbasis_nsph_two, &
               & random_vector_C_one, &
               & vector_lpb, vector_c1_c2)
end subroutine test_solve

end program main

module test_double_dictionary
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use tblite_double_dictionary, only : double_dictionary_type
   use tblite_io_numpy, only : save_npz
   implicit none
   private

   public :: collect_double_dictionary

contains

subroutine collect_double_dictionary(testsuite)

   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("add entries", test_add_entries), &
      new_unittest("get entries by label", test_get_entries_by_label), &
      new_unittest("get entries by index", test_get_entries_by_index), &
      new_unittest("get label from index", test_get_label_from_index), &
      new_unittest("test = assigment operator", test_assigment_operator), &
      new_unittest("test + operator", test_addition_operator), &
      new_unittest("test remove functionality by index", test_removal_index), &
      new_unittest("test remove functionality by label", test_removal_label), &
      new_unittest("access entries with invalid label or index", test_invalid_label_index), &
      new_unittest("access valid entries with wrong size of array as return", test_invalid_array_size), &
      new_unittest("compare index and label lookup", test_equivalence_index_label_lookup), &
      new_unittest("initialize labels", test_initialize_labels), &
      new_unittest("update entries", test_update_entries_label), &
      new_unittest("read in npz file", test_read_in_npz), &
      new_unittest("write npz output and read in again", test_write_read_npz), &
      new_unittest("check equal operator", test_equal_operator), &
      new_unittest("check equal operator for two different dicts", test_equal_operator_different_dict) &
      ]
end subroutine collect_double_dictionary

subroutine test_removal_index(error)
   type(error_type), allocatable, intent(out) :: error
   character(len=:), allocatable :: label1, label2
   real(wp), allocatable :: array1(:), array3(:, :, :)

   type(double_dictionary_type) :: dict, ini_dict

   call fill_test_dict(dict)
   ini_dict = dict
   call dict%remove_entry(2)
   call check(error, dict%get_n_entries(), 2)
   if (allocated(error)) return
   call dict%remove_entry(3)
   call check(error, dict%get_n_entries(), 2)
   if (allocated(error)) return
   call dict%get_label(1, label1)
   call dict%get_label(2, label2)
   call check(error, (label1 == "test1"))
   if (allocated(error)) return
   call check(error, (label2 == "test3"))
   if (allocated(error)) return
   call dict%get_entry("test1", array1)
   call dict%get_entry("test3", array3)

   call check(error, sum(ini_dict%record(1)%array1 - array1), 0.0_wp)
   if (allocated(error)) return
   call check(error, sum(ini_dict%record(3)%array3 - array3), 0.0_wp)
   if (allocated(error)) return
   call dict%remove_entry(1)
   call check(error, dict%get_n_entries(), 1)
   if (allocated(error)) return
   call dict%get_entry("test3", array3)
   call check(error, sum(ini_dict%record(3)%array3 - array3), 0.0_wp) 
   if (allocated(error)) return
end subroutine

subroutine test_removal_label(error)
   type(error_type), allocatable, intent(out) :: error
   character(len=:), allocatable :: label1, label2
   real(wp), allocatable :: array1(:), array2(:, :)

   type(double_dictionary_type) :: dict, ini_dict

   call fill_test_dict(dict)
   ini_dict = dict
   call dict%remove_entry("test3")
   call check(error, dict%get_n_entries(), 2)
   if (allocated(error)) return
   call dict%remove_entry("test3")
   call check(error, dict%get_n_entries(), 2)
   if (allocated(error)) return
   call dict%get_label(1, label1)
   call dict%get_label(2, label2)

   call check(error, (label1 == "test1"))
   if (allocated(error)) return
   call check(error, (label2 == "test2"))
   if (allocated(error)) return
   call dict%get_entry("test1", array1)
   call dict%get_entry("test2", array2)

   call check(error, sum(ini_dict%record(1)%array1 - array1), 0.0_wp)
   if (allocated(error)) return
   call check(error, sum(ini_dict%record(2)%array2 - array2), 0.0_wp)
   if (allocated(error)) return
   call dict%remove_entry("test1")
   call check(error, dict%get_n_entries(), 1)
   if (allocated(error)) return
   call dict%get_entry("test2", array2)
   call check(error, sum(ini_dict%record(2)%array2 - array2), 0.0_wp) 
   if (allocated(error)) return
end subroutine

subroutine test_initialize_labels(error)

   type(error_type), allocatable, intent(out) :: error

   type(double_dictionary_type) :: dict

   call dict%initialize_entry("test")

   call dict%initialize_entry("test1", 4)

   call dict%initialize_entry("test2", 4, 6)

   call dict%initialize_entry("test3", 4, 6, 9)

   call check(error, dict%n, 4)
   if (allocated(error)) return
   !Checking records directly since lookup will be tested in another test
   call check(error, (.not.(allocated(dict%record(1)%array1))))
   if (allocated(error)) return
   call check(error, (.not.(allocated(dict%record(1)%array2))))
   if (allocated(error)) return
   call check(error, (.not.(allocated(dict%record(1)%array3))))
   if (allocated(error)) return

   call check(error, actual = size(dict%record(2)%array1), expected = 4)
   if (allocated(error)) return
   call check(error, actual = sum(dict%record(2)%array1), expected = 0.0_wp)
   if (allocated(error)) return

   call check(error, actual = size(dict%record(3)%array2, dim = 1), expected = 4)
   if (allocated(error)) return
   call check(error, actual = size(dict%record(3)%array2, dim = 2), expected = 6)
   if (allocated(error)) return
   call check(error, actual = sum(dict%record(3)%array2), expected = 0.0_wp)
   if (allocated(error)) return

   call check(error, actual = size(dict%record(4)%array3, dim = 1), expected = 4)
   if (allocated(error)) return
   call check(error, actual = size(dict%record(4)%array3, dim = 2), expected = 6)
   if (allocated(error)) return
   call check(error, actual = size(dict%record(4)%array3, dim = 3), expected = 9)
   if (allocated(error)) return
   call check(error, actual = sum(dict%record(4)%array3), expected = 0.0_wp)
   if (allocated(error)) return
end subroutine

subroutine test_add_entries(error)

   type(error_type), allocatable, intent(out) :: error
   type(double_dictionary_type) :: dict

   call fill_test_dict(dict)

   call check(error, dict%n, 3)
   if (allocated(error)) return
   call check(error, actual = size(dict%record(1)%array1), expected = 4)
   call check(error, actual = sum(dict%record(1)%array1), expected = 4.0_wp)
   if (allocated(error)) return

   call check(error, actual = size(dict%record(2)%array2, dim = 1), expected = 4)
   call check(error, actual = size(dict%record(2)%array2, dim = 2), expected = 6)
   call check(error, actual = sum(dict%record(2)%array2), expected = (4*6*2.0_wp))
   if (allocated(error)) return

   call check(error, actual = size(dict%record(3)%array3, dim = 1), expected = 4)
   call check(error, actual = size(dict%record(3)%array3, dim = 2), expected = 6)
   call check(error, actual = size(dict%record(3)%array3, dim = 3), expected = 9)
   if (allocated(error)) return
   call check(error, actual = sum(dict%record(3)%array3), expected = 0.0_wp)
   if (allocated(error)) return

end subroutine

subroutine test_get_entries_by_label(error)
   type(error_type), allocatable, intent(out) :: error

   type(double_dictionary_type) :: dict

   real(wp), allocatable :: array1(:), array2(:, :), array3(:, :, :)
   real(wp), allocatable :: array1_in(:), array2_in(:, :), array3_in(:, :, :)

   allocate(array1(4), source = 1.0_wp)
   allocate(array2(4, 6), source = 2.0_wp)
   allocate(array3(4, 6, 9), source = 0.0_wp)

   array1_in = array1
   array2_in = array2
   array3_in = array3

   call dict%add_entry("test1", array1)

   call dict%add_entry("test2", array2)

   call dict%add_entry("test3", array3)

   call dict%get_entry("test1", array1)
   call dict%get_entry("test2", array2)
   call dict%get_entry("test3", array3)

   call check(error, actual = sum(array1 - array1_in), expected = 0.0_wp)
   call check(error, actual = sum(array2 - array2_in), expected = 0.0_wp)
   call check(error, actual = sum(array3 - array3_in), expected = 0.0_wp)
   if (allocated(error)) return
end subroutine

subroutine test_get_entries_by_index(error)
   type(error_type), allocatable, intent(out) :: error

   type(double_dictionary_type) :: dict

   real(wp), allocatable :: array1(:), array2(:, :), array3(:, :, :)
   real(wp), allocatable :: array1_in(:), array2_in(:, :), array3_in(:, :, :)

   allocate(array1(4), source = 1.0_wp)
   allocate(array2(4, 6), source = 2.0_wp)
   allocate(array3(4, 6, 9), source = 0.0_wp)

   array1_in = array1
   array2_in = array2
   array3_in = array3

   call dict%add_entry("test1", array1)

   call dict%add_entry("test2", array2)

   call dict%add_entry("test3", array3)

   call dict%get_entry(1, array1)
   call dict%get_entry(2, array2)
   call dict%get_entry(3, array3)

   call check(error, actual = sum(array1 - array1_in), expected = 0.0_wp)
   call check(error, actual = sum(array2 - array2_in), expected = 0.0_wp)
   call check(error, actual = sum(array3 - array3_in), expected = 0.0_wp)
   if (allocated(error)) return
end subroutine

subroutine test_equivalence_index_label_lookup(error)
   type(error_type), allocatable, intent(out) :: error

   type(double_dictionary_type) :: dict

   real(wp), allocatable :: array1(:), array2(:, :), array3(:, :, :)

   real(wp), allocatable :: array1_in(:), array2_in(:, :), array3_in(:, :, :)
   integer :: index1, index2
   character(len=:), allocatable :: label1, label2

   index1 = 0
   index2 = 0
   index1 = dict%get_index("test1")
   call check(error, index1, 0)
   if (allocated(error)) return
   call fill_test_dict(dict)
   call dict%get_label(1, label1)
   call dict%get_label(2, label2)
   index1 = dict%get_index(label1)
   index2 = dict%get_index(label2)
   call check(error, 1, index1)
   call check(error, 2, index2)
   if (allocated(error)) return
   

   call dict%get_entry("test1", array1)
   call dict%get_entry("test2", array2)
   call dict%get_entry("test3", array3)

   call dict%get_entry(1, array1_in)
   call dict%get_entry(2, array2_in)
   call dict%get_entry(3, array3_in)

   call check(error, actual = sum(array1 - array1_in), expected = 0.0_wp)
   call check(error, actual = sum(array2 - array2_in), expected = 0.0_wp)
   call check(error, actual = sum(array3 - array3_in), expected = 0.0_wp)
   if (allocated(error)) return
end subroutine

subroutine test_invalid_label_index(error)
   type(error_type), allocatable, intent(out) :: error

   type(double_dictionary_type) :: dict
   real(wp), allocatable :: array(:), array2(:, :), array3(:, :, :)

   call fill_test_dict(dict)

   call dict%get_entry("label4", array)
   call check(error, (.not.allocated(array)))
   
   call dict%get_entry(4, array)
   call check(error, (.not.allocated(array)))

   call dict%get_entry(0, array)
   call check(error, (.not.allocated(array)))

   call dict%get_entry(-1, array)
   call check(error, (.not.allocated(array)))

   call dict%get_entry("label4", array2)
   call check(error, (.not.allocated(array2)))

   call dict%get_entry(4, array2)
   call check(error, (.not.allocated(array2)))

   call dict%get_entry(0, array2)
   call check(error, (.not.allocated(array2)))

   call dict%get_entry(-1, array2)
   call check(error, (.not.allocated(array2)))

   call dict%get_entry("label4", array3)
   call check(error, (.not.allocated(array3)))

   call dict%get_entry(4, array3)
   call check(error, (.not.allocated(array3)))

   call dict%get_entry(0, array3)
   call check(error, (.not.allocated(array3)))

   call dict%get_entry(-1, array3)
   call check(error, (.not.allocated(array3)))
   if (allocated(error)) return

end subroutine

subroutine test_invalid_array_size(error)
   type(error_type), allocatable, intent(out) :: error

   type(double_dictionary_type) :: dict
   real(wp), allocatable :: array(:), array2(:, :), array3(:, :, :)

   call fill_test_dict(dict)

   call dict%get_entry("test1", array2)
   call check(error, (.not.allocated(array2)))

   call dict%get_entry(1, array2)
   call check(error, (.not.allocated(array2)))

   call dict%get_entry(1, array3)
   call check(error, (.not.allocated(array3)))

   call dict%get_entry("test1", array3)
   call check(error, (.not.allocated(array3)))

   call dict%get_entry("test2", array)
   call check(error, (.not.allocated(array)))

   call dict%get_entry(2, array)
   call check(error, (.not.allocated(array)))

   call dict%get_entry(2, array3)
   call check(error, (.not.allocated(array3)))

   call dict%get_entry("test2", array3)
   call check(error, (.not.allocated(array3)))

   call dict%get_entry("test3", array)
   call check(error, (.not.allocated(array)))

   call dict%get_entry(3, array)
   call check(error, (.not.allocated(array)))

   call dict%get_entry(3, array2)
   call check(error, (.not.allocated(array2)))

   call dict%get_entry("test3", array2)
   call check(error, (.not.allocated(array2)))
   if (allocated(error)) return
end subroutine

subroutine test_get_label_from_index(error)
   type(error_type), allocatable, intent(out) :: error
   type(double_dictionary_type) :: dict
   character(len=:), allocatable :: name1

   call fill_test_dict(dict)
   call dict%get_label(1, name1)
   call check(error, (name1 == "test1"))
   call dict%get_label(2, name1)
   call check(error, (name1 == "test2"))
   call dict%get_label(3, name1)
   call check(error, (name1 == "test3"))
   if (allocated(error)) return
end subroutine

subroutine fill_test_dict(dict)
   type(double_dictionary_type), intent(inout) :: dict
   real(wp), allocatable :: array1(:), array2(:, :), array3(:, :, :)
   allocate(array1(4), source = 1.0_wp)
   allocate(array2(4, 6), source = 2.0_wp)
   allocate(array3(4, 6, 9), source = 0.0_wp)

   call dict%add_entry("test1", array1)

   call dict%add_entry("test2", array2)

   call dict%add_entry("test3", array3)
end subroutine

subroutine fill_test_dict_other_entries(dict)
   type(double_dictionary_type), intent(inout) :: dict
   real(wp), allocatable :: array1(:), array2(:, :), array3(:, :, :)
   allocate(array1(4), source = 0.0_wp)
   allocate(array2(4, 6), source = 1.0_wp)
   allocate(array3(4, 6, 9), source = 42.0_wp)

   call dict%add_entry("test1", array1)

   call dict%add_entry("test2", array2)

   call dict%add_entry("test3", array3)
end subroutine

subroutine fill_test_dict_1d_array(dict)
   type(double_dictionary_type), intent(inout) :: dict
   real(wp), allocatable :: array1(:), array2(:), array3(:)
   allocate(array1(4), source = 1.0_wp)
   allocate(array2(6*4), source = 2.0_wp)
   allocate(array3(9*6*4), source = 0.0_wp)

   call dict%add_entry("test1", array1)

   call dict%add_entry("test2", array2)

   call dict%add_entry("test3", array3)
end subroutine

subroutine test_assigment_operator(error)
   type(error_type), allocatable, intent(out) :: error
   type(double_dictionary_type) :: dict1, dict2
   call fill_test_dict(dict1)
   
   dict2 = dict1

   call check(error, dict1%n , dict2%n)

   call check(error, sum(dict1%record(1)%array1 - dict2%record(1)%array1), 0.0_wp)

   call check(error, sum(dict1%record(2)%array2 - dict2%record(2)%array2), 0.0_wp)

   call check(error, sum(dict1%record(3)%array3 - dict2%record(3)%array3), 0.0_wp)
   if (allocated(error)) return

end subroutine

subroutine test_addition_operator(error)
   type(error_type), allocatable, intent(out) :: error
   type(double_dictionary_type) :: dict1, dict2, dict3, dict4 
   character(len=:), allocatable :: label1, label2
   real(wp), allocatable :: array(:), array1(:), array2(:)
   call fill_test_dict(dict1)
   array = [0.0_wp, 0.0_wp]
   call dict2%add_entry("dict2", array)
   call dict2%add_entry("dict3", array)

   dict3 = dict1 + dict2
   !Check that total number of entries matches up
   call check(error, actual = dict3%get_n_entries(), expected = (dict1%get_n_entries()+ dict2%get_n_entries()))
   !Check Ordering LHS should vom before RHS
   call dict3%get_label(2, label1)
   call dict1%get_label(2, label2)
   call check(error, (label1 == label2))

   call dict3%get_label(5, label1)
   call dict2%get_label(2, label2)
   call check(error, (label1 == label2))

   call dict3%get_entry(1, array1)
   call dict1%get_entry(1, array2)
   call check(error, (sum(array1) == sum(array2)))

   call dict3%get_entry("dict3", array1)
   call dict2%get_entry(2, array2)
   call check(error, (sum(array1) == sum(array2)))
   
   dict3 = dict4 + dict1

   call check(error, (dict3%get_n_entries() == dict1%get_n_entries()))

   call dict4%concatenate(dict1)

   call check(error, (dict4%get_n_entries() == dict1%get_n_entries()))
   call dict4%get_entry(1, array1)
   call dict1%get_entry(1, array2)
   call check(error, (sum(array1) == sum(array2)))
   if (allocated(error)) return
end subroutine


subroutine test_read_in_npz(error)
   type(error_type), allocatable, intent(out) :: error
   type(double_dictionary_type) :: dict1, dict2
   character(len=*), parameter :: filename = ".read-ddict.npz"

   real(wp), allocatable :: input1(:), input2(:, :), input3(:, :, :)
   real(wp), allocatable :: array1(:), array2(:, :), array3(:, :, :)
   allocate(input1(4), source = 1.0_wp)
   allocate(input2(4, 6), source = 2.0_wp)
   allocate(input3(4, 6, 9), source = 0.0_wp)

   call delete_file(filename)
   call save_npz(filename, "tblite0_a", input1)
   call save_npz(filename, "tblite0_b", input2)
   call save_npz(filename, "tblite0_c", input3)

   call dict2%load(filename, error)
   call delete_file(filename)
   if (allocated(error)) return

   call dict2%get_entry("a", array1)
   call check(error, allocated(array1), "First entry not allocated")
   if (allocated(error)) return
   call dict2%get_entry("b", array2)
   call check(error, allocated(array2), "Second entry not allocated")
   if (allocated(error)) return
   call dict2%get_entry("c", array3)
   call check(error, allocated(array3), "Third entry not allocated")
   if (allocated(error)) return

   call check(error, sum(array1 - input1), 0.0_wp)
   if (allocated(error)) return
   call check(error, sum(array2 - input2), 0.0_wp)
   if (allocated(error)) return
   call check(error, sum(array3 - input3), 0.0_wp)
   if (allocated(error)) return
end subroutine test_read_in_npz


subroutine test_write_read_npz(error)
   type(error_type), allocatable, intent(out) :: error
   type(double_dictionary_type) :: dict1, dict2
   character(len=*), parameter :: filename = ".read-write-ddict.npz"
   real(wp), allocatable :: array1(:), array2(:, :), array3(:, :, :)

   call fill_test_dict(dict1)

   call dict1%dump(filename, error)
   if (allocated(error)) return

   call dict2%load(filename, error)
   call delete_file(filename)
   if (allocated(error)) return

   call dict2%get_entry("test1", array1)
   call check(error, allocated(array1), "First entry not allocated")
   if (allocated(error)) return
   call dict2%get_entry("test2", array2)
   call check(error, allocated(array2), "Second entry not allocated")
   if (allocated(error)) return
   call dict2%get_entry("test3", array3)
   call check(error, allocated(array3), "Third entry not allocated")
   if (allocated(error)) return

   call check(error, dict1 == dict2)
end subroutine test_write_read_npz


subroutine test_update_entries_label(error)
   type(error_type), allocatable, intent(out) :: error
   type(double_dictionary_type) :: dict1, dict2, dict3 
   real(wp), allocatable :: array(:), array1(:), array2(:, :), array3(:, :, :)
   call fill_test_dict(dict1)
   allocate(array(1), source= 0.0_wp)
   call dict1%update("test1", array)
   call dict1%get_entry("test1", array1)

   call check(error, (sum(array) == sum(array1)))

   call dict1%update("test2", array)
   call dict1%get_entry("test2", array1)

   call check(error, (sum(array) == sum(array1)))

   call dict1%update("test3", array)
   call dict1%get_entry("test3", array1)
   call dict1%update("test", array)
   call check(error, (sum(array) == sum(array1)))

   allocate(array2(2, 2), source= 0.0_wp)

   call fill_test_dict(dict2)

   call dict2%update("test1", array2)
   call dict2%update("test2", array2)
   call dict2%update("test3", array2)
   call dict2%update("test", array2)
   deallocate(array2)

   call dict2%get_entry("test1", array2)
   call check(error, (size(array2, dim=1) == 2))
   call dict2%get_entry("test2", array2)
   call check(error, (size(array2, dim=1) == 2))
   call dict2%get_entry("test3", array2)
   call check(error, (size(array2, dim=1) == 2))

   allocate(array3(3, 2, 1), source= 1.0_wp)
   call fill_test_dict(dict3)

   call dict3%update("test1", array3)
   call dict3%update("test2", array3)
   call dict3%update("test3", array3)
   call dict3%update("test", array3)
   deallocate(array2)

   call dict3%get_entry("test1", array3)
   call check(error, (size(array3, dim=1) == 3))
   call dict3%get_entry("test2", array3)
   call check(error, (size(array3, dim=1) == 3))
   call dict3%get_entry("test3", array2)
   call check(error, (size(array3, dim=1) == 3))
   if (allocated(error)) return
end subroutine

subroutine test_equal_operator(error)
   type(error_type), allocatable, intent(out) :: error
   type(double_dictionary_type) :: dict, dict_

   call fill_test_dict(dict)
   call fill_test_dict(dict_)

   call check(error, (dict == dict_))

end subroutine

subroutine test_equal_operator_different_dict(error)
   type(error_type), allocatable, intent(out) :: error
   type(double_dictionary_type) :: dict, dict1, dict2, dict3
   real(wp), allocatable :: array1(:)
   logical :: che
   allocate(array1(4), source = 1.0_wp)
   call fill_test_dict(dict)
   call fill_test_dict_1d_array(dict1)
   che = (.not.(dict == dict1))
   call check(error, (che))

   call fill_test_dict_other_entries(dict2)
   che = (.not.(dict == dict2))
   call check(error, che)

   call dict2%remove_entry("test1")
   call dict%remove_entry("test1")

   che = (.not.(dict == dict2))
   call check(error, che)

   call dict2%remove_entry("test2")
   call dict%remove_entry("test2")

   che = (.not.(dict == dict2))
   call check(error, che)

   dict = double_dictionary_type(record=null())
   call fill_test_dict(dict)
   
   call fill_test_dict(dict3)

   call dict3%remove_entry("test1")
   che = (.not.(dict == dict3))
   call check(error, che)

   call dict3%add_entry("test_", array1)
   che = (.not.(dict == dict3))
   call check(error, che)

end subroutine


subroutine delete_file(file)
   character(len=*), intent(in) :: file
   integer :: unit
   logical :: exist
   inquire(file=file, exist=exist)
   if (exist) then
      open(newunit=unit, file=file)
      close(unit, status="delete")
   end if
end subroutine delete_file

end module test_double_dictionary

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_solvation_shift
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type
   use mstore, only : get_structure
   use tblite_container, only : container_cache
   use tblite_scf_potential, only : potential_type
   use tblite_solvation_shift, only : shift_solvation, shift_input, solution_state
   use tblite_solvation_data_shift, only : get_shift_param
   use tblite_solvation_data, only : solvent_data, get_solvent_data
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: collect_solvation_shift


   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

contains


!> Collect all exported unit tests
subroutine collect_solvation_shift(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("solvation-shift-alpb-gfn1", test_e_alpb_gfn1_all_solvents), &
      new_unittest("solvation-shift-alpb-gfn2", test_e_alpb_gfn2_all_solvents), &
      new_unittest("solvation-shift-gbsa-gfn1", test_e_gbsa_gfn1_all_solvents), &
      new_unittest("solvation-shift-gbsa-gfn2", test_e_gbsa_gfn2_all_solvents), &
      new_unittest("unsupported-solvent", test_unsupported_solvent, should_fail=.true.) &
      ]

end subroutine collect_solvation_shift


subroutine test_e(error, mol, input, ref, method)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Solvation model input
   type(shift_input), intent(in) :: input

   !> Reference energy
   real(wp), intent(in) :: ref

   !> Method for parameter selection
   character(len=*), intent(in), optional :: method

   type(shift_solvation) :: solv
   type(shift_input), allocatable :: scratch_input
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp) :: energy(mol%nat)

   energy = 0.0_wp

   scratch_input = input

   if (allocated(input%solvent) .and. present(method)) then 
      call get_shift_param(scratch_input, method, error)
      if(allocated(error)) then
         call test_failed(error, "No shift parameters found for the method/solvent")
         return
      end if
   end if

   solv = shift_solvation(scratch_input)

   call solv%update(mol, cache)
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)
   call solv%get_engrad(mol, cache, energy)

   if (abs(sum(energy) - ref) > thr) then
      call test_failed(error, "Energy does not match reference")
      print *, sum(energy),'reference:',ref
   end if
end subroutine test_e

subroutine test_e_alpb_gfn1_all_solvents(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   type(shift_input) :: input
   integer, parameter :: nsolvents = 25
   character(len=*), parameter :: solvents(*) = [character(len=nsolvents):: &
      & "acetone", "acetonitrile", "aniline", "benzaldehyde", "benzene", &
      & "ch2cl2", "chcl3", "cs2", "dioxane", "dmf", "dmso", "ethanol", &
      & "ether", "ethylacetate", "furane", "hexadecane", "hexane", &
      & "nitromethane", "methanol", "octanol", "phenol", "thf", "toluene", &
      & "water", "woctanol"] 
   real(wp), parameter :: refs_bar1mol(*) = [&
      & 1.63261835085536E-2_wp, 9.31280584349187E-3_wp, 6.10306008943574E-3_wp, &
      & 9.67917852709751E-3_wp, 8.08739100629020E-3_wp, 6.37136322581741E-3_wp, &
      & 5.92108557794216E-3_wp, 8.53454208782486E-3_wp, 5.66153228555004E-3_wp, &
      & 1.09663650850496E-2_wp, 1.06555118341220E-2_wp, 7.00077557148834E-3_wp, &
      & 1.66506474225119E-2_wp, 7.86585894064636E-3_wp, 5.92595471558278E-3_wp, &
      & 7.25557204326916E-3_wp, 7.19072153234925E-3_wp, 8.58706969316386E-3_wp, &
      & 7.40662420091461E-3_wp, 6.21424037098337E-3_wp, 6.70655886619314E-3_wp, &
      & 9.26552024665788E-3_wp, 6.58621292223285E-3_wp, 7.27683949906328E-3_wp, &
      & 6.41785372708611E-3_wp]
   real(wp), parameter :: refs_reference(*) = [&
      & 1.87907057789662E-2_wp, 1.21001962664228E-2_wp, 8.36302467503810E-3_wp, &
      & 1.18341556383070E-2_wp, 1.03599692855620E-2_wp, 8.96891666720903E-3_wp, &
      & 8.30441563658662E-3_wp, 1.11842017076946E-2_wp, 7.98302610150582E-3_wp, &
      & 1.33878533380648E-2_wp, 1.31525893890045E-2_wp, 9.68319014349151E-3_wp, &
      & 1.87880893670823E-2_wp, 1.02312181766696E-2_wp, 8.40073773949523E-3_wp, &
      & 9.17774520460835E-3_wp, 9.11289469368843E-3_wp, 1.13509387695088E-2_wp, &
      & 1.04351691764993E-2_wp, 7.96298743088067E-3_wp, 9.00182470817862E-3_wp, &
      & 1.16308794826811E-2_wp, 8.70282029304879E-3_wp, 1.10699922271961E-2_wp, &
      & 8.16660078698342E-3_wp]
   integer :: i   

   call get_structure(mol, "MB16-43", "01")

   do i = 1, nsolvents
      ! bar1mol state
      solvent = get_solvent_data(solvents(i))
      input = shift_input(state=solution_state%bar1mol, solvent=solvent%solvent, &
         & alpb=.true.)
      call test_e(error, mol, input, refs_bar1mol(i),  method='gfn1') 
      if(allocated(error)) return  
      ! reference state
      input%state = solution_state%reference
      call test_e(error, mol, input, refs_reference(i), method='gfn1') 
      if(allocated(error)) return  
   end do 

end subroutine test_e_alpb_gfn1_all_solvents

subroutine test_e_alpb_gfn2_all_solvents(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   type(shift_input) :: input
   integer, parameter :: nsolvents = 25
   character(len=*), parameter :: solvents(*) = [character(len=nsolvents):: &
      & "acetone", "acetonitrile", "aniline", "benzaldehyde", "benzene", &
      & "ch2cl2", "chcl3", "cs2", "dioxane", "dmf", "dmso", "ethanol", &
      & "ether", "ethylacetate", "furane", "hexadecane", "hexane", &
      & "nitromethane", "methanol", "octanol", "phenol", "thf", "toluene", &
      & "water", "woctanol"] 
   real(wp), parameter :: refs_bar1mol(*) = [&
      & 8.95537409262417E-3_wp, 8.22988757996136E-3_wp, 6.00365174170799E-3_wp, &
      & 5.29205499543163E-3_wp, 7.70568145464064E-3_wp, 7.17993018930200E-3_wp, &
      & 6.92225207178554E-3_wp, 8.01170085026346E-3_wp, 5.80234080502634E-3_wp, &
      & 9.03982927966215E-3_wp, 1.02259268778103E-2_wp, 6.44249646259719E-3_wp, &
      & 7.98467040578235E-3_wp, 5.45002953461799E-3_wp, 5.01783774913864E-3_wp, &
      & 7.42815990763873E-3_wp, 7.84458864824169E-3_wp, 5.44750394725157E-3_wp, &
      & 6.97615264444313E-3_wp, 5.37090220339446E-3_wp, 5.45892065137498E-3_wp, &
      & 8.35604827278334E-3_wp, 5.23937596608403E-3_wp, 4.11199252528792E-3_wp, &
      & 5.54333830909911E-3_wp]
   real(wp), parameter :: refs_reference(*) = [&
      & 1.14198963630367E-2_wp, 1.10172780028923E-2_wp, 8.26361632731035E-3_wp, &
      & 7.44703210664113E-3_wp, 9.97825973391251E-3_wp, 9.77748363069363E-3_wp, &
      & 9.30558213043000E-3_wp, 1.06613604701332E-2_wp, 8.12383462098212E-3_wp, &
      & 1.14613175326774E-2_wp, 1.27230044326928E-2_wp, 9.12491103460036E-3_wp, &
      & 1.01221123503528E-2_wp, 7.81538877064125E-3_wp, 7.49262077305109E-3_wp, &
      & 9.35033306897792E-3_wp, 9.76676180958088E-3_wp, 8.21137302359659E-3_wp, &
      & 1.00046976200278E-2_wp, 7.11964926329176E-3_wp, 7.75418649336047E-3_wp, &
      & 1.07214075088065E-2_wp, 7.51195424535590E-3_wp, 7.90514525342083E-3_wp, &
      & 7.29208536899641E-3_wp]
   integer :: i   

   call get_structure(mol, "MB16-43", "01")

   do i = 1, nsolvents
      ! bar1mol state
      solvent = get_solvent_data(solvents(i))
      input = shift_input(state=solution_state%bar1mol, solvent=solvent%solvent, &
         & alpb=.true.)
      call test_e(error, mol, input, refs_bar1mol(i), method='gfn2') 
      if(allocated(error)) return
      ! reference state
      input%state = solution_state%reference
      call test_e(error, mol, input, refs_reference(i), method='gfn2') 
      if(allocated(error)) return
   end do 

end subroutine test_e_alpb_gfn2_all_solvents


subroutine test_e_gbsa_gfn1_all_solvents(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   type(shift_input) :: input
   integer, parameter :: nsolvents = 12
   character(len=*), parameter :: solvents(*) = [character(len=nsolvents):: &
      & "acetone", "acetonitrile", "benzene", "ch2cl2", "chcl3", "cs2", &
      & "dmso", "ether", "methanol", "thf", "toluene", "water"]
   real(wp), parameter :: refs_bar1mol(*) = [&
      & 5.21213510246909E-3_wp, 7.25142009001955E-3_wp, 7.26000582493303E-3_wp, &
      & 6.57710945808429E-3_wp, 6.57710945808429E-3_wp, 8.41667542117321E-3_wp, &
      & 7.25142009001955E-3_wp, 6.49277863570250E-3_wp, 5.40945961328245E-3_wp, &
      & 5.87994173698486E-3_wp, 7.26000582493303E-3_wp, 5.10670346719552E-3_wp]
   real(wp), parameter :: refs_reference(*) = [&
      & 7.67665737288168E-3_wp, 1.00388105129505E-2_wp, 9.53258410420490E-3_wp, &
      & 9.17466289947592E-3_wp, 8.96043951672875E-3_wp, 1.10709445028420E-2_wp, &
      & 9.74849764490206E-3_wp, 8.63022058027298E-3_wp, 8.43800458886716E-3_wp, &
      & 8.24530097300811E-3_wp, 9.37661319574898E-3_wp, 8.89796593470179E-3_wp]
   integer :: i   

   call get_structure(mol, "MB16-43", "01")

   do i = 1, nsolvents
      ! bar1mol state
      solvent = get_solvent_data(solvents(i))
      input = shift_input(state=solution_state%bar1mol, solvent=solvent%solvent, &
         & alpb=.false.)
      call test_e(error, mol, input, refs_bar1mol(i), method='gfn1') 
      if(allocated(error)) return
      ! reference state
      input%state = solution_state%reference
      call test_e(error, mol, input, refs_reference(i), method='gfn1') 
      if(allocated(error)) return  
   end do 

end subroutine test_e_gbsa_gfn1_all_solvents

subroutine test_e_gbsa_gfn2_all_solvents(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   type(shift_input) :: input
   integer, parameter :: nsolvents = 14
   character(len=*), parameter :: solvents(*) = [character(len=nsolvents):: &
      & "acetone", "acetonitrile", "benzene", "ch2cl2", "chcl3", "cs2", &
      & "dmf", "dmso", "ether", "hexane", "methanol", "thf", "toluene", &
      & "water"]
   real(wp), parameter :: refs_bar1mol(*) = [&
      & 7.04678383302601E-3_wp, 5.07850817974356E-3_wp, 7.55511270005529E-3_wp, &
      & 7.47206200177234E-3_wp, 7.13802760282821E-3_wp, 7.51040424359422E-3_wp, &
      & 6.38830191828239E-3_wp, 8.19297097398559E-3_wp, 6.76591459154802E-3_wp, &
      & 7.72252129600845E-3_wp, 6.38816235066849E-3_wp, 6.43059788527107E-3_wp, &
      & 7.55511270005529E-3_wp, 4.88867595421726E-3_wp]
   real(wp), parameter :: refs_reference(*) = [&
      & 9.51130610343859E-3_wp, 7.86589860267454E-3_wp, 9.82769097932716E-3_wp, &
      & 1.00696154431639E-2_wp, 9.52135766147267E-3_wp, 1.01600638634640E-2_wp, &
      & 8.80979017129767E-3_wp, 1.06900485288681E-2_wp, 8.90335653611850E-3_wp, &
      & 9.64469445734764E-3_wp, 9.41670732625320E-3_wp, 8.79595712129432E-3_wp, &
      & 9.67172007087124E-3_wp, 8.68182868235016E-3_wp]
   integer :: i   

   call get_structure(mol, "MB16-43", "01")

   do i = 1, nsolvents
      ! bar1mol state
      solvent = get_solvent_data(solvents(i))
      input = shift_input(state=solution_state%bar1mol, solvent=solvent%solvent, &
         & alpb=.false.)
      call test_e(error, mol, input, refs_bar1mol(i), method='gfn2') 
      if(allocated(error)) return 
      ! reference state
      input%state = solution_state%reference
      call test_e(error, mol, input, refs_reference(i), method='gfn2') 
      if(allocated(error)) return 
   end do 

end subroutine test_e_gbsa_gfn2_all_solvents


subroutine test_unsupported_solvent(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(solvent_data) :: solvent
   real(wp), parameter :: qat(*) = [&
      &-8.99890404486076E-2_wp, 9.42168087556583E-2_wp,-1.49387631509499E-1_wp, &
      &-2.99114121895542E-1_wp, 4.85527734875224E-1_wp,-6.83156326406137E-2_wp, &
      & 1.50011293889337E-2_wp, 2.79368544459465E-1_wp,-1.24072452878322E-1_wp, &
      &-9.36760994051244E-2_wp,-2.19062123031622E-1_wp, 2.14538817685587E-1_wp, &
      & 3.06156726072831E-1_wp,-3.86105514712244E-1_wp,-1.51265171389388E-3_wp, &
      & 3.64255069977693E-2_wp]
   type(shift_input) :: input

   call get_structure(mol, "MB16-43", "04")

   ! Check GFN1/GBSA unavailable solvent
   solvent = get_solvent_data("aniline")
   input = shift_input(state=solution_state%bar1mol, solvent=solvent%solvent, &
      & alpb=.false.)
   call get_shift_param(input, 'gfn1', error)

end subroutine test_unsupported_solvent


end module test_solvation_shift

! This file is part of jonquil.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Minimal public API for Jonquil
module jonquil
   use tomlf, only : get_value, set_value, json_path => toml_path, &
      & json_context => toml_context, json_parser_config => toml_parser_config, &
      & json_level => toml_level, json_error => toml_error, json_stat => toml_stat, &
      & json_terminal => toml_terminal, json_object => toml_table, json_array => toml_array, &
      & json_keyval => toml_keyval, json_key => toml_key, json_value => toml_value, &
      & new_object => new_table, add_object => add_table, add_array, add_keyval, sort, len
   use tomlf_type, only : cast_to_object => cast_to_table, cast_to_array, cast_to_keyval
   use tomlf_version, only : tomlf_version_string, tomlf_version_compact, get_tomlf_version
   use jonquil_version, only : jonquil_version_string, jonquil_version_compact, &
      & get_jonquil_version
   use jonquil_parser, only : json_load, json_loads
   use jonquil_ser, only : json_serializer, json_serialize, json_dump, json_dumps, &
      & json_ser_config
   implicit none
   public

end module jonquil

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/data/cm5.f90
!> Provides CM5 charges and their derivatives
!> for GFN1-xTB implementation of ALPB/GBSA

!> Implements CM5 charges and derivatives.
!> See: J. Chem. Theory Comput. 2012, 8, 2, 527–541
!> https://doi.org/10.1021/ct200866d
module tblite_solvation_cm5
   use mctc_env, only: error_type, fatal_error
   use mctc_env, only: wp
   use mctc_io,only: structure_type
   use mctc_data_atomicrad, only: get_atomic_rad
   use mctc_io_convert, only: aatoau, kcaltoau
   implicit none
   private

   public :: get_cm5_charges

   integer,parameter :: max_elements = 118

   !> CM5 model atomic parameters
   real(wp), parameter :: cm5_a0(max_elements) = (/ &
      & 0.0056_wp,-0.1543_wp, 0.0000_wp, 0.0333_wp,-0.1030_wp,-0.0446_wp, &
      &-0.1072_wp,-0.0802_wp,-0.0629_wp,-0.1088_wp, 0.0184_wp, 0.0000_wp, &
      &-0.0726_wp,-0.0790_wp,-0.0756_wp,-0.0565_wp,-0.0444_wp,-0.0767_wp, &
      & 0.0130_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, &
      & 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, &
      &-0.0512_wp,-0.0557_wp,-0.0533_wp,-0.0399_wp,-0.0313_wp,-0.0541_wp, &
      & 0.0092_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, &
      & 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, &
      &-0.0361_wp,-0.0393_wp,-0.0376_wp,-0.0281_wp,-0.0220_wp,-0.0381_wp, &
      & 0.0065_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, &
      & 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, &
      & 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, &
      & 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, &
      & 0.0000_wp, 0.0000_wp,-0.0255_wp,-0.0277_wp,-0.0265_wp,-0.0198_wp, &
      &-0.0155_wp,-0.0269_wp, 0.0046_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, &
      & 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, &
      & 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, &
      & 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, &
      & 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp,-0.0179_wp,-0.0195_wp, &
      &-0.0187_wp,-0.0140_wp,-0.0110_wp,-0.0189_wp /)

  !> CM5 alpha parameter
  real(wp), parameter :: cm5_alpha = 2.4740_wp/aatoau

contains

!> Get CM5 charges and derivatives
subroutine get_cm5_charges(mol, cm5, dcm5dr)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> CM5 charges
   real(wp), intent(out) :: cm5(mol%nat)
   !> CM5 charge derivatives
   real(wp), intent(out) :: dcm5dr(3, mol%nat, mol%nat)

   ! Pair parameters set up from cm5_a0
   real(wp), allocatable :: pairpar(:,:)
   integer :: iat, jat, nati, natj
   real(wp) :: pij, pji, rab(3), dist, bkk, bkkda, radi, radj

   cm5(:) = 0.0_wp
   dcm5dr(:,:,:) = 0.0_wp

   ! Set up pair parameters
   allocate (pairpar(max_elements,max_elements),source=0.0_wp)
   do iat = 1,max_elements
      do jat = iat+1,max_elements
         pairpar(iat,jat) = cm5_a0(iat)-cm5_a0(jat)
      end do
   end do
   pairpar(1,6) = 0.0502_wp
   pairpar(1,7) = 0.1747_wp
   pairpar(1,8) = 0.1671_wp
   pairpar(6,7) = 0.0556_wp
   pairpar(6,8) = 0.0234_wp
   pairpar(7,8) = -0.0346_wp
   do iat = 1,max_elements
      do jat = iat+1,max_elements
         pairpar(jat,iat) = -pairpar(iat,jat)
      end do
   end do

   ! Calculate the actual charges
   do iat = 1, mol%nat
      nati = mol%num(mol%id(iat))
      radi = get_atomic_rad(nati)
      do jat = 1,iat-1
         natj = mol%num(mol%id(jat))
         if (nati == natj) cycle
         radj = get_atomic_rad(natj)
         pij = pairpar(nati,natj)
         pji = pairpar(natj,nati)
         rab = mol%xyz(:,iat)-mol%xyz(:,jat)
         dist = norm2(rab)
         bkk = exp(-cm5_alpha*(dist-radi-radj))
         bkkda = bkk*cm5_alpha/dist
         cm5(iat) = cm5(iat)+bkk*pij
         cm5(jat) = cm5(jat)+bkk*pji
         dcm5dr(:,iat,iat) = dcm5dr(:,iat,iat)-bkkda*rab*pij
         dcm5dr(:,jat,jat) = dcm5dr(:,jat,jat)+bkkda*rab*pji
         dcm5dr(:,iat,jat) = dcm5dr(:,iat,jat)-bkkda*rab*pji
         dcm5dr(:,jat,iat) = dcm5dr(:,jat,iat)+bkkda*rab*pij
      end do
   end do

   deallocate (pairpar)

end subroutine get_cm5_charges

end module tblite_solvation_cm5

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/scf/mixer/type.f90
!> Base class for electronic mixing

!> Provides base class for electronic mixing routines
module tblite_scf_mixer_type
   use mctc_env, only : error_type, wp
   implicit none
   private


   !> Abstract base class for electronic mixing
   type, public, abstract :: mixer_type
   contains
      !> Apply mixing to the density
      procedure(next), deferred :: next
      !> Set new density
      generic :: set => set_1d, set_2d, set_3d
      !> Set new density from 1D array
      procedure(set_1d), deferred :: set_1d
      !> Set new density from 2D array
      procedure :: set_2d
      !> Set new density from 3D array
      procedure :: set_3d
      !> Set difference between new and old density
      generic :: diff => diff_1d, diff_2d, diff_3d
      !> Set difference between new and old density from 1D array
      procedure(diff_1d), deferred :: diff_1d
      !> Set difference between new and old density from 2D array
      procedure :: diff_2d
      !> Set difference between new and old density from 3D array
      procedure :: diff_3d
      !> Get density
      generic :: get => get_1d, get_2d, get_3d
      !> Get density as 1D array
      procedure(get_1d), deferred :: get_1d
      !> Get density as 2D array
      procedure :: get_2d
      !> Get density as 3D array
      procedure :: get_3d
      !> Get error metric from mixing
      procedure(get_error), deferred :: get_error
   end type mixer_type

   abstract interface
      !> Set new density from 1D array
      subroutine set_1d(self, qvec)
         import :: mixer_type, wp
         !> Instance of the electronic mixer
         class(mixer_type), intent(inout) :: self
         !> Density vector
         real(wp), intent(in) :: qvec(:)
      end subroutine set_1d

      !> Set difference between new and old density from 1D array
      subroutine diff_1d(self, qvec)
         import :: mixer_type, wp
         !> Instance of the electronic mixer
         class(mixer_type), intent(inout) :: self
         !> Density vector
         real(wp), intent(in) :: qvec(:)
      end subroutine diff_1d

      !> Get density as 1D array
      subroutine get_1d(self, qvec)
         import :: mixer_type, wp
         !> Instance of the electronic mixer
         class(mixer_type), intent(inout) :: self
         !> Density vector
         real(wp), intent(out) :: qvec(:)
      end subroutine get_1d

      !> Apply mixing to the density
      subroutine next(self, error)
         import :: mixer_type, error_type
         !> Instance of the electronic mixer
         class(mixer_type), intent(inout) :: self
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine next

      !> Get error metric from mixing
      pure function get_error(self) result(error)
         import :: mixer_type, wp
         !> Instance of the electronic mixer
         class(mixer_type), intent(in) :: self
         !> Error metric
         real(wp) :: error
      end function get_error
   end interface

contains

!> Set new density from 2D array
subroutine set_2d(self, qvec)
   !> Instance of the electronic mixer
   class(mixer_type), intent(inout) :: self
   !> Density vector
   real(wp), contiguous, intent(in), target :: qvec(:, :)
   real(wp), pointer :: qptr(:)
   qptr(1:size(qvec)) => qvec
   call self%set(qptr)
end subroutine set_2d

!> Set new density from 3D array
subroutine set_3d(self, qvec)
   !> Instance of the electronic mixer
   class(mixer_type), intent(inout) :: self
   !> Density vector
   real(wp), contiguous, intent(in), target :: qvec(:, :, :)
   real(wp), pointer :: qptr(:)
   qptr(1:size(qvec)) => qvec
   call self%set(qptr)
end subroutine set_3d

!> Set difference between new and old density from 2D array
subroutine diff_2d(self, qvec)
   !> Instance of the electronic mixer
   class(mixer_type), intent(inout) :: self
   !> Density vector
   real(wp), contiguous, intent(in), target :: qvec(:, :)
   real(wp), pointer :: qptr(:)
   qptr(1:size(qvec)) => qvec
   call self%diff(qptr)
end subroutine diff_2d

!> Set difference between new and old density from 3D array
subroutine diff_3d(self, qvec)
   !> Instance of the electronic mixer
   class(mixer_type), intent(inout) :: self
   !> Density vector
   real(wp), contiguous, intent(in), target :: qvec(:, :, :)
   real(wp), pointer :: qptr(:)
   qptr(1:size(qvec)) => qvec
   call self%diff(qptr)
end subroutine diff_3d

!> Get density as 2D array
subroutine get_2d(self, qvec)
   !> Instance of the electronic mixer
   class(mixer_type), intent(inout) :: self
   !> Density vector
   real(wp), contiguous, intent(out), target :: qvec(:, :)
   real(wp), pointer :: qptr(:)
   qptr(1:size(qvec)) => qvec
   call self%get(qptr)
end subroutine get_2d

!> Get density as 3D array
subroutine get_3d(self, qvec)
   !> Instance of the electronic mixer
   class(mixer_type), intent(inout) :: self
   !> Density vector
   real(wp), contiguous, intent(out), target :: qvec(:, :, :)
   real(wp), pointer :: qptr(:)
   qptr(1:size(qvec)) => qvec
   call self%get(qptr)
end subroutine get_3d

end module tblite_scf_mixer_type

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

#ifndef TBLITE_HAS_DDX
#define TBLITE_HAS_DDX 0
#endif

!> @file tblite/solvation/ddx.f90
!> Provides a polarizable continuum model in domain decomposition (dd) framework of ddX

!> Implicit solvation model based on a polarizable dielectric continuum in domain
!> decomposition framework of ddX
module tblite_solvation_ddx
#if TBLITE_HAS_DDX
   use ddx, only: allocate_state, check_error, ddinit, ddrun, ddx_error_type, &
      & ddx_state_type, ddx_type, fill_guess, fill_guess_adjoint, setup, &
      & solvation_force_terms, solve, solve_adjoint
   use ddx_core, only: ddx_electrostatics_type
   use ddx_multipolar_solutes, only: multipole_electrostatics, multipole_force_terms, multipole_psi
#endif
   use mctc_env, only: wp, error_type, fatal_error
   use mctc_io, only: structure_type
   use mctc_io_constants, only: pi
!$ use omp_lib, only: omp_get_max_threads
   use tblite_blas, only: dot, gemv
   use tblite_container_cache, only: container_cache
   use tblite_mesh_lebedev, only: grid_size
   use tblite_scf_info, only: atom_resolved, scf_info
   use tblite_scf_potential, only: potential_type
   use tblite_solvation_data, only: get_vdw_rad_cosmo
   use tblite_solvation_type, only: solvation_type
   use tblite_wavefunction_type, only: wavefunction_type

   implicit none
   private

   public :: ddx_solvation, new_ddx, ddx_input, ddx_cache, ddx_solvation_model
   public :: valid_ddx_model

   !> Possible solvation models to be used within the dd framework
   type :: enum_ddx_solvation_model
      ! COSMO, CPCM, and PCM are internally defined as 100, 101, and 200 to get the correct
      ! dielectric factor (feps) during initialization and to avoid collisions with other aliases
      ! elsewhere in the code
      ! Labels are mapped to ddX-specific values 1 and 2 before passing the model input to the ddX routine
      !> Conductor-like screening model
      integer :: cosmo = 100
      !> Conductor-like polarizable continuum model
      integer :: cpcm = 101
      !> Polarizable continuum model
      integer :: pcm = 200
   end type enum_ddx_solvation_model

   !> Actual enumerator for the dd solvation models
   type(enum_ddx_solvation_model), parameter :: ddx_solvation_model = enum_ddx_solvation_model()


   !> Input for ddX solvation
   type :: ddx_input
      !> ddX model
      integer :: ddx_model = ddx_solvation_model%cosmo
      !> Dielectric constant
      real(wp) :: dielectric_const
      !> van der Waals radii for all atoms
      real(wp), allocatable :: rvdw(:)
      !> Scaling of van-der-Waals radii
      real(wp) :: rscale = 1.0_wp
      !> Number of grid points for each atom (default=110)
      integer :: nang = grid_size(8)
      !> Regularization parameter / width of the switching function 
      real(wp) :: eta = 0.1_wp
      !> Maximum angular momentum of basis functions
      integer :: lmax = 1
   end type ddx_input

   !> Provide constructor for ddX input
   interface ddx_input
      module procedure :: create_ddx_input
   end interface ddx_input

   !> Definition of polarizable continuum model
   type, extends(solvation_type) :: ddx_solvation
      !> ddX model 
      integer :: ddx_model
      !> Dielectric function
      real(wp) :: feps
      !> Dielectric constant
      real(wp) :: dielectric_const
      !> van der Waals radii for all atoms
      real(wp), allocatable :: rvdw(:)
      !> Accuracy for iterative solver
      real(wp) :: conv = 1.0e-10_wp
      !> Regularization parameter
      real(wp) :: eta 
      !> Number of grid points for each atom (=110)
      integer :: nang 
      !> Maximum angular momentum of basis functions
      integer :: lmax 
      !> Number of OMP threads
      integer :: nproc = 1
      !> Shift of the switching function 
      ! (default value depends on the model, for COSMO/CPCM it is -1)
      real(wp) :: shift
      !> Maximum number of iterations for the iterative solver
      integer :: max_iter = 100
      !> Number of extrapolation points for the Jacobi/DIIS solver
      integer :: jacobi_ndiis = 20
      !> Maximal degree of multipole spherical harmonics
      integer :: pm = 8
      !> Maximal degree of local spherical harmonics
      integer :: pl = 8
      !> Handling of the sparse matrices 
      integer :: incore = 0
      !> 1 to use FMM acceleration and 0 otherwise
      integer :: enable_fmm = 1
   contains
      !> Update cache from container
      procedure :: update
      !> Return dependency on density
      procedure :: variable_info
      !> Get electric field energy
      procedure :: get_energy
      !> Get electric field potential
      procedure :: get_potential
      !> Get electric field gradient
      procedure :: get_gradient
   end type ddx_solvation

   !> Restart data for ddX calculation
   type :: ddx_cache
#if TBLITE_HAS_DDX
      !> ddX instance
      type(ddx_type) :: ddx 
      !> ddX container with quantities common to all models
      type(ddx_state_type) :: ddx_state
      !> ddX container for the electrostatic properties  
      type(ddx_electrostatics_type) :: ddx_electrostatics
      !> ddX error handling
      type(ddx_error_type) :: ddx_error
#endif
      !> Interaction matrix with surface charges jmat(ncav, nat)
      real(wp), allocatable :: jmat(:, :)
      !> ddX potential
      real(wp), allocatable :: ddx_pot(:)
      !> ddX multipoles, dim=(1, mol%nat)
      real(wp), allocatable :: multipoles(:, :)
   end type ddx_cache

contains

!> Constructor for ddX input
function create_ddx_input(ddx_model, dielectric_const, rvdw, rscale, nang, eta, lmax) result(self)
   !> ddX model
   integer, intent(in), optional :: ddx_model
   !> Dielectric constant
   real(wp), intent(in) :: dielectric_const
   !> van der Waals radii for all atoms
   real(wp), intent(in), optional :: rvdw(:)
   !> Scaling of van-der-Waals radii
   real(wp), intent(in), optional :: rscale
   !> Number of grid points for each atom
   integer, intent(in), optional :: nang
   !> Regularization parameter
   real(wp), intent(in), optional :: eta
   !> Maximum angular momentum of basis functions
   integer, intent(in), optional :: lmax

   type(ddx_input) :: self

   if (present(ddx_model)) then
      self%ddx_model = ddx_model
   end if

   self%dielectric_const = dielectric_const

   if (present(rvdw)) then
      self%rvdw = rvdw
   end if

   if (present(rscale)) then
      self%rscale = rscale
   end if

   if (present(nang)) then
      self%nang = nang
   end if

   if (present(eta)) then
      self%eta = eta
   end if

   if (present(lmax)) then
      self%lmax = lmax
   end if

end function create_ddx_input

pure function valid_ddx_model(model) result(valid)
   !> ddX model identifier
   integer, intent(in) :: model
   logical :: valid

   valid = model == ddx_solvation_model%cosmo .or. &
      & model == ddx_solvation_model%cpcm .or. &
      & model == ddx_solvation_model%pcm
end function valid_ddx_model

!> Create new electric field container
subroutine new_ddx(self, mol, input, error)
   !> Instance of the solvation model
   type(ddx_solvation), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input for ddX solvation
   type(ddx_input), intent(in) :: input
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
#if TBLITE_HAS_DDX
   integer :: iat, izp
   real(wp) :: feps_param 

   ! Set label
   if (input%ddx_model == ddx_solvation_model%cosmo) then
      self%label = "ddcosmo solvation model"
   else if (input%ddx_model == ddx_solvation_model%cpcm) then
      self%label = "ddcpcm solvation model"
   else if (input%ddx_model == ddx_solvation_model%pcm) then
      self%label = "ddpcm solvation model"
   else
      call fatal_error(error, "Unknown ddX solvation model")
      return
   end if

   ! Set model 
   self%ddx_model = input%ddx_model

   ! Get number of OMP threads
   self%nproc = 1
!$ self%nproc = omp_get_max_threads()

   ! Get radii for all atoms
   allocate(self%rvdw(mol%nat), source=0.0_wp)
   if (allocated(input%rvdw)) then
      self%rvdw(:) = input%rscale * input%rvdw(mol%id)
   else
      do iat = 1, mol%nat
         izp = mol%num(mol%id(iat))
         self%rvdw(iat) = input%rscale * get_vdw_rad_cosmo(izp)
      end do
   end if

   ! Get epsilon and calculate dielectric function depending on the model
   self%dielectric_const = input%dielectric_const
   if (input%ddx_model == ddx_solvation_model%cosmo) then
      feps_param = 0.5_wp
      self%feps = (self%dielectric_const - 1.0_wp) / (self%dielectric_const + feps_param)
   else if (input%ddx_model == ddx_solvation_model%cpcm) then
      feps_param = 0.0_wp
      self%feps = (self%dielectric_const - 1.0_wp) / (self%dielectric_const + feps_param)
   else 
      self%feps = 1.0_wp
   end if

   ! Initialize the shift of the switching function depending on the model: 
   ! In ddX, ddCOSMO/ddCPCM uses an internal shift by default, ddPCM has a symmetric shift
   if (input%ddx_model == ddx_solvation_model%cosmo .or. &
      & input%ddx_model == ddx_solvation_model%cpcm) then
      self%shift = -1.0_wp
   else 
      self%shift = 0.0_wp
   end if

   ! Initialize the rest of the adjustable input parameters
   self%nang = input%nang
   self%eta = input%eta
   self%lmax = input%lmax
#else
   call fatal_error(error, "ddX solvation model support is not available in this build of tblite")
#endif

end subroutine new_ddx


!> Update cache from container
subroutine update(self, mol, cache)
   !> Instance of the solvation model
   class(ddx_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
#if TBLITE_HAS_DDX
   type(ddx_cache), pointer :: ptr

   integer :: model

   call taint(cache, ptr)

   ! Request all electrostatic quantities that may be needed later
   ! The ddX multipole routine allocates and fills only the selected arrays
   ! Electric potential at the cavity points
   ptr%ddx_electrostatics%do_phi = .true.
   ! Electric field at the cavity points
   ptr%ddx_electrostatics%do_e = .true.
   ! Electric field gradient at the cavity points
   ptr%ddx_electrostatics%do_g = .true.

   ! Adjust the tblite model labels to the public ddX API:
   ! model 1 is the COSMO-type equation, model 2 is the PCM equation
   if (self%ddx_model == ddx_solvation_model%cosmo .or. &
      & self%ddx_model == ddx_solvation_model%cpcm) then
      model = 1 ! ddCOSMO and ddCPCM are handled the same way in ddX
   else
      model = 2 ! ddPCM
   end if

   ! Initialize the ddX model:
   ! ddX uses two main kinds of data, labeled as model- and state-specific.
   ! In ddinit, we initialize the model class, where we specify the desired model,
   ! dielectric permittivity, general information on the discretization (such as grid size),
   ! and cavity parameters (including number of spheres, coordinates, and radii)
   ! Moreover, geometry-dependent constants (for instance the number of solvent-exposed
   ! Lebedev grid points) are pre-computed and stored.
   call ddinit(model, mol%nat, mol%xyz, self%rvdw, self%dielectric_const, ptr%ddx, ptr%ddx_error, &
      & force=1, ngrid=self%nang, &
      & lmax=self%lmax, nproc=self%nproc, &
      & eta=self%eta, shift=self%shift, &
      & maxiter=self%max_iter, jacobi_ndiis=self%jacobi_ndiis, &
      & pm=self%pm, pl=self%pl, &
      & incore=self%incore, enable_fmm=self%enable_fmm)
   call check_error(ptr%ddx_error)

   ! The state class contains all quantities that are explicitly solute-dependent. That will be the 
   ! right-hand sides of the primal & adjoint linear systems (the spherical harmonics expansion of
   ! the solute potential and the spherical harmonics representation of the solute charges)
   ! as well as the relevant intermediates.
   ! First we start by allocating the state-specific arrays using the dimensions now defined via ddinit
   call allocate_state(ptr%ddx%params, ptr%ddx%constants, ptr%ddx_state, ptr%ddx_error)
   call check_error(ptr%ddx_error)

   ! Allocate the multipole array that later contains the xTB Mulliken charges
   ! (We only pass monopoles)
   if (.not.allocated(ptr%multipoles))then
         allocate(ptr%multipoles(1, mol%nat), source=0.0_wp) 
   endif

   ! Allocate and compute the Coulomb matrix
   if (allocated(ptr%jmat))then
      deallocate(ptr%jmat)
   endif
   allocate(ptr%jmat(ptr%ddx%constants%ncav, mol%nat), source=0.0_wp)
   call get_coulomb_matrix(mol%xyz, ptr%ddx%constants%ccav, ptr%jmat)

   ! Allocate atom-resolved solvation potential contribution produced by get_potential
   if (.not.allocated(ptr%ddx_pot))then
      allocate(ptr%ddx_pot(mol%nat), source=0.0_wp) 
   endif

   ! Now we initialize the RHSs (they are zero in the first iteration)
   ! Given the monopole distribution...
   ! ...we compute the electrostatic potential on the cavity surface
   call multipole_electrostatics(ptr%ddx%params, ptr%ddx%constants, &
      & ptr%ddx%workspace, ptr%multipoles, 0, ptr%ddx_electrostatics, ptr%ddx_error)
   ! ...we convert the monopole charges into the spherical harmonics representation
   call multipole_psi(ptr%ddx%params, ptr%multipoles, 0, ptr%ddx_state%psi)
   ! ...and we transform the potential into the spherical harmonics representation,
   !    marking the RHSs as ready for the solver
   call setup(ptr%ddx%params,ptr%ddx%constants, &
      & ptr%ddx%workspace, ptr%ddx_state, ptr%ddx_electrostatics, &
      & ptr%ddx_state%psi, ptr%ddx_error)
   call check_error(ptr%ddx_error)

   ! Construct model-specific initial guesses for the solutions of the
   ! primal and adjoint linear systems
   call fill_guess(ptr%ddx%params, ptr%ddx%constants, &
         & ptr%ddx%workspace, ptr%ddx_state, self%conv, ptr%ddx_error)
   call check_error(ptr%ddx_error)

   call fill_guess_adjoint(ptr%ddx%params, ptr%ddx%constants, &
      & ptr%ddx%workspace, ptr%ddx_state, self%conv, ptr%ddx_error)
   call check_error(ptr%ddx_error)
#endif

end subroutine update

!> Get solvation energy
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the solvation model
   class(ddx_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Solvation free energy
   real(wp), intent(inout) :: energies(:)
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
#if TBLITE_HAS_DDX
   type(ddx_cache), pointer :: ptr

   call view(cache, ptr)

   ! Recalculate the solution of the ddX system with the new charges after diagonalization

   ! Assemble the multipole array based on the new xTB charges and
   ! apply a normalization for the spherical harmonics representation
   ptr%multipoles(1, :) = wfn%qat(:, 1) / sqrt(4.0_wp*pi)
   ! Compute the electrostatic potential on the cavity surface
   call multipole_electrostatics(ptr%ddx%params, ptr%ddx%constants, &
      & ptr%ddx%workspace, ptr%multipoles, 0, ptr%ddx_electrostatics, ptr%ddx_error)
   ! Convert the normalized monopole charges into the spherical harmonics representation
   call multipole_psi(ptr%ddx%params, ptr%multipoles, 0, ptr%ddx_state%psi)
   ! Transform the potential into the spherical harmonics representation
   call setup(ptr%ddx%params,ptr%ddx%constants, &
      & ptr%ddx%workspace, ptr%ddx_state, ptr%ddx_electrostatics, &
      & ptr%ddx_state%psi, ptr%ddx_error)
   call check_error(ptr%ddx_error)

   ! Solve the primal linear system to get the surface charge distribution
   ! for the current solute potential
   call solve(ptr%ddx%params, ptr%ddx%constants, &
      & ptr%ddx%workspace, ptr%ddx_state, self%conv, ptr%ddx_error)
   call check_error(ptr%ddx_error)

   ! Add solvation energy to total energy
   energies(:) = energies + self%feps * 0.5_wp * sum(ptr%ddx_state%xs * ptr%ddx_state%psi, 1) 
#endif

end subroutine get_energy

!> Get solvation potential
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the solvation model
   class(ddx_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
#if TBLITE_HAS_DDX
   type(ddx_cache), pointer :: ptr

   call view(cache, ptr)

   ! Due to intermediate mixing, the xTB charges have changed since the last call
   ! to get_energy, and we need to solve the ddX systems again

   ! Assemble the multipole array based on the new xTB charges and
   ! apply a normalization for the spherical harmonics representation
   ptr%multipoles(1, :) = wfn%qat(:, 1) / sqrt(4.0_wp*pi)
   ! Compute the electrostatic potential on the cavity surface
   call multipole_electrostatics(ptr%ddx%params, ptr%ddx%constants, &
      & ptr%ddx%workspace, ptr%multipoles, 0, ptr%ddx_electrostatics, ptr%ddx_error)
   ! Convert the normalized monopole charges into the spherical harmonics representation
   call multipole_psi(ptr%ddx%params, ptr%multipoles, 0, ptr%ddx_state%psi)
   ! Transform the potential into the spherical harmonics representation
   call setup(ptr%ddx%params,ptr%ddx%constants, &
      & ptr%ddx%workspace, ptr%ddx_state, ptr%ddx_electrostatics, &
      & ptr%ddx_state%psi, ptr%ddx_error)
   call check_error(ptr%ddx_error)

   ! Solve the primal linear system to get the surface charge distribution
   ! for the current solute potential
   call solve(ptr%ddx%params, ptr%ddx%constants, &
      & ptr%ddx%workspace, ptr%ddx_state, self%conv, ptr%ddx_error)
   call check_error(ptr%ddx_error)

   ! Solve the adjoint linear system:
   ! We need to do this any time we compute a derivative of the energy (here wrt to the basis
   ! function coefficients), because this lets us avoid computing the derivative of
   ! the surface charge distribution.
   ! For reference, see J. Chem. Theory Comput. 2013, 9, 3637−3648
   call solve_adjoint(ptr%ddx%params, ptr%ddx%constants, &
      & ptr%ddx%workspace, ptr%ddx_state, self%conv, ptr%ddx_error)
   call check_error(ptr%ddx_error)

   ptr%ddx_pot = 0.0_wp
   ! The solvation potential comes from a contribution of the derivative of Psi as well as
   ! from a contribution of the derivative of the cavity potential & coupling matrix.
   ! (Again, see J. Chem. Theory Comput. 2013, 9, 3637−3648)
   ! Zeta is an intermediate in the computation of the latter and needs to be
   ! contracted with the Coulomb matrix in a last step.
   call gemv(ptr%jmat, ptr%ddx_state%zeta, ptr%ddx_pot(:), alpha=-1.0_wp, beta=1.0_wp, trans='t')  

   ! Scale with 0.5 and feps, and get the Psi contribution to potential
   ptr%ddx_pot(:) = 0.5_wp * self%feps * (ptr%ddx_pot(:) + sqrt(4.0_wp*pi) * ptr%ddx_state%xs(1, :))
   ! Add potential to overall potential for new SCC step
   pot%vat(:,1) = pot%vat(:,1) + ptr%ddx_pot(:)
#endif

end subroutine get_potential

!> Get solvation gradient
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the solvation model
   class(ddx_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the solvation free energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the solvation free energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

#if TBLITE_HAS_DDX
   !> Temporary variable for the ddX force/gradient
   real(wp), allocatable :: force(:,:)

   type(ddx_cache), pointer :: ptr
   
   call view(cache, ptr)

   allocate(force(3, mol%nat), source=0.0_wp)

   ! Compute all the solute-aspecific solvation force terms
   call solvation_force_terms(ptr%ddx%params, ptr%ddx%constants, &
      & ptr%ddx%workspace, ptr%ddx_state, ptr%ddx_electrostatics, force, ptr%ddx_error)
   call check_error(ptr%ddx_error)

   ! Compute all the solute-specific solvation force terms
   call multipole_force_terms(ptr%ddx%params, ptr%ddx%constants, ptr%ddx%workspace, &
      ptr%ddx_state, 0, ptr%multipoles, force, ptr%ddx_error)
   call check_error(ptr%ddx_error)

   ! Add the dielectric factor to the gradient of the solvation energy
   ! (ddX computes the gradient without it)
   force = self%feps * force 

   ! Add the gradient of the solvation energy to the total gradient
   gradient =  gradient + force
#endif

end subroutine get_gradient

!> Return dependency on density
pure function variable_info(self) result(info)
   !> Instance of the solvation model
   class(ddx_solvation), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=atom_resolved)
end function variable_info

subroutine taint(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(ddx_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(ddx_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

subroutine view(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(ddx_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(ddx_cache)
      ptr => target
   end select
end subroutine view

!> Evaluate the Coulomb interactions between the atomic sites (xyz) and the
!> surface elements of the cavity (ccav)
subroutine get_coulomb_matrix(xyz, ccav, jmat)
   real(wp), intent(in) :: xyz(:, :)
   real(wp), intent(in) :: ccav(:, :)
   real(wp), intent(inout) :: jmat(:, :)

   integer :: ic, jat
   real(wp) :: vec(3), d2, d

   jmat(:, :) = 0.0_wp
   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(ccav, xyz, jmat) private(ic, jat, vec, d2, d)
   do ic = 1, size(ccav, 2)
      do jat = 1, size(xyz, 2)
         vec(:) = ccav(:, ic) - xyz(:, jat)
         d2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         d = sqrt(d2)
         jmat(ic, jat) = 1.0_wp / d
      end do
   end do

end subroutine get_coulomb_matrix

end module tblite_solvation_ddx

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Conversion factors
module mctc_io_convert
   use mctc_env_accuracy, only : wp
   use mctc_io_constants, only : pi, codata
   implicit none
   private

   !> Reduced Planck's constant
   real(wp), parameter :: hbar = codata%h/(2.0_wp*pi) ! J·s = kg·m²·s⁻¹

   !> Bohr radius
   real(wp), parameter :: bohr = hbar/(codata%me*codata%c*codata%alpha) ! m

   !> Hartree energy
   real(wp), parameter :: hartree = codata%me*codata%c**2*codata%alpha**2 ! J = kg·m²·s⁻²

   !> Conversion factor from bohr to Ångström
   real(wp), public, parameter :: autoaa = bohr * 1e10_wp

   !> Conversion factor from Ångström to bohr
   real(wp), public, parameter :: aatoau = 1.0_wp/autoaa

   !> Conversion factor from hartree to electron volts
   real(wp), public, parameter :: autoeV = hartree/codata%e

   !> Conversion factor from electron volts to hartree
   real(wp), public, parameter :: evtoau = 1.0_wp/autoev

   !> Conversion factor between calorie and joule
   real(wp), public, parameter :: caltoj = 4.184_wp

   !> Conversion factor between joule and calorie
   real(wp), public, parameter :: jtocal = 1.0_wp/caltoj

   !> Conversion from hartree to kJ/mol
   real(wp), public, parameter :: autokj = hartree*codata%na*1e-3_wp

   !> Conversion from kJ/mol to hartree
   real(wp), public, parameter :: kjtoau = 1.0_wp/autokj

   !> Conversion from hartree to kcal/mol
   real(wp), public, parameter :: autokcal = autokJ*Jtocal

   !> Conversion from kcal/mol to hartree
   real(wp), public, parameter :: kcaltoau = 1.0_wp/autokcal

   !> Conversion from hartree to reciprocal centimeters
   real(wp), public, parameter :: autorcm = hartree/(codata%h*codata%c)*1e-2_wp

   !> Conversion from reciprocal centimeters to hartree
   real(wp), public, parameter :: rcmtoau = 1.0_wp/autorcm

   !> Conversion from hartree to nanometers (wavelength)
   real(wp), public, parameter :: autonm = codata%h*codata%c/hartree * 1e+9_wp

   !> Conversion from nanometers (wavelength) to hartree
   real(wp), public, parameter :: nmtoau = 1.0_wp/autonm

   !> Conversion from electron mass (a.u.) to kg
   real(wp), public, parameter :: autokg = codata%me

   !> Conversion from kg to electron mass (a.u.)
   real(wp), public, parameter :: kgtoau = 1.0_wp/autokg

   !> Molecular mass per mole (g/mol) to electron mass (a.u.)
   real(wp), public, parameter :: autogmol = codata%me*codata%na*1e+3_wp

   !> Electron mass (a.u.) to molecular mass per mole (g/mol)
   real(wp), public, parameter :: gmoltoau = 1.0_wp/autogmol

   !> Molecular mass per mole (g/mol) to kg
   real(wp), public, parameter :: gmoltokg = gmoltoau*autokg

   !> kg to molecular mass per mole (g/mol)
   real(wp), public, parameter :: kgtogmol = 1.0_wp/gmoltokg

   !> Coulomb to atomic charge units
   real(wp), public, parameter :: autoc = codata%e

   !> Atomic charge units to Coulomb
   real(wp), public, parameter :: ctoau = 1.0_wp/autoc


end module mctc_io_convert

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/os.F90
!> Provides operating system dependent functionality.

!> Interfaces to the system libraries.
module tblite_os
   use, intrinsic :: iso_c_binding, only : c_char, c_null_char, c_int
   implicit none
   private

   public :: setenv
   public :: file_exists, delete_file


   interface
      function sys_putenv(name) result(stat) &
            & bind(c, name="putenv")
         import :: c_char, c_int
         character(len=c_char), intent(in) :: name(*)
         integer(c_int) :: stat
      end function
   end interface


contains


subroutine setenv(name, value, stat)
   character(len=*), intent(in) :: name
   character(len=*), intent(in) :: value
   integer, intent(out) :: stat

   stat = sys_putenv(as_c_char(name//"="//value))

end subroutine setenv


pure function as_c_char(str) result(res)
   character(len=*), intent(in) :: str
   character(kind=c_char) :: res(len(str)+1)
   res = transfer(str // c_null_char, res)
end function as_c_char


function file_exists(file) result(exist)
   character(len=*), intent(in) :: file
   logical :: exist
   inquire(file=file, exist=exist)
end function file_exists


subroutine delete_file(file)
   character(len=*), intent(in) :: file
   integer :: unit
   if (file_exists(file)) then
      open(file=file, newunit=unit)
      close(unit, status="delete")
   end if
end subroutine delete_file


end module tblite_os

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/coulomb/charge
!> Contains the implementation of the isotropic second-order electrostatics

!> @file tblite/coulomb/charge.f90
!> Provides a reexport of the isotropic second-order electrostatic implementations

!> Proxy module for defining isotropic electrostatic interactions
module tblite_coulomb_charge
   use tblite_coulomb_charge_effective, only : effective_coulomb, new_effective_coulomb, &
      & average_interface, harmonic_average, arithmetic_average, geometric_average
   use tblite_coulomb_charge_gamma, only : gamma_coulomb, new_gamma_coulomb
   use tblite_coulomb_charge_type, only : coulomb_charge_type
   implicit none
   private

   public :: coulomb_charge_type, coulomb_kernel
   public :: effective_coulomb, new_effective_coulomb
   public :: average_interface, harmonic_average, arithmetic_average, geometric_average
   public :: gamma_coulomb, new_gamma_coulomb


   !> Possible interaction kernels
   type :: enum_coulomb_kernel
      !> Effective Klopman-Ohno interaction kernel
      integer :: effective = 1
      !> DFTB γ-functional interaction kernel
      integer :: dftb_gamma = 2
   end type enum_coulomb_kernel

   !> Actual enumerator for possible interaction kernels
   type(enum_coulomb_kernel), parameter :: coulomb_kernel = enum_coulomb_kernel()

end module tblite_coulomb_charge

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file tests/m2l.f90
!! Performance test for M2L
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-02-11

program test_ddx_m2l
use ddx_core
implicit none

integer, parameter :: ntests=100000, pmax=19, pmax2=20**2
real(dp) :: vscales((2*pmax+1)**2), &
    & m2l_ztranslate_coef(pmax+1, pmax+1, pmax+1), &
    & src_c(3, ntests), dst_c(3, ntests), src_r(ntests), dst_r(ntests), &
    & start_time, finish_time
real(dp), allocatable :: src_m(:, :), dst_l(:, :), work(:)
integer :: iseed(4), nsrc_m, nsrc_c, i, idist
real(dp), external :: dnrm2

allocate(src_m(pmax2, ntests))
allocate(dst_l(pmax2, ntests))
allocate(work(6*pmax2+19*pmax+8))
! Compute special FMM constants
!call ylmscale(2*pmax, vscales, v4pi2lp1, vscales_rel)
!call fmm_constants(2*pmax, pmax, pmax, vcnk, m2l_ztranslate_coef, &
!    & m2l_ztranslate_adj_coef)
! Init random seed
iseed = (/0, 0, 0, 1/)
idist = 3
! Generate src_m randomly
nsrc_m = ntests * ((pmax+1)**2)
call dlarnv(idist, iseed, nsrc_m, src_m)
! Set sources and destinations
nsrc_c = ntests * 3
call dlarnv(idist, iseed, nsrc_c, src_c)
call dlarnv(idist, iseed, nsrc_c, dst_c)
! Set radii
do i = 1, ntests
    src_r(i) = dnrm2(3, src_c(:, i)-dst_c(:, i), 1) / 3d0
    dst_r(i) = src_r(i)
end do
! Warmup
i = 1
call cpu_time(start_time)
call fmm_m2l_rotation_work(src_c(:, i)-dst_c(:, i), src_r(i), dst_r(i), &
    & pmax, pmax, vscales, m2l_ztranslate_coef, one, src_m(:, i), zero, &
    & dst_l(:, i), work)
! Check
call cpu_time(start_time)
do i = 1, ntests
    call fmm_m2l_rotation_work(src_c(:, i)-dst_c(:, i), src_r(i), dst_r(i), &
        & pmax, pmax, vscales, m2l_ztranslate_coef, one, src_m(:, 1), zero, &
        & dst_l(:, 1), work)
end do
call cpu_time(finish_time)
print *, "Total   time:", finish_time-start_time, "seconds"
print *, "Average time:", (finish_time-start_time) / ntests, "seconds"

deallocate(src_m, dst_l, work)

end program

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/api/structure.f90
!> Provides API exports for the #tblite_structure handle.

!> API export for working with molecular structure data objects
module tblite_api_structure
   use, intrinsic :: iso_c_binding
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type, new
   use tblite_api_error, only : vp_error
   use tblite_api_version, only : namespace
   use tblite_cutoff, only : wrap_to_central_cell
   implicit none
   private

   public :: vp_structure
   public :: new_structure_api, delete_structure_api, update_structure_geometry_api
   public :: update_structure_charge_api, update_structure_uhf_api


   !> Void pointer to molecular structure data
   type :: vp_structure
      !> Actual payload
      type(structure_type) :: ptr
   end type vp_structure


   logical, parameter :: debug = .false.


contains


!> Create new molecular structure data (quantities in Bohr)
function new_structure_api(verror, natoms, numbers, positions, c_charge, c_uhf, &
      & c_lattice, c_periodic) result(vmol) &
      & bind(C, name=namespace//"new_structure")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   integer(c_int), value, intent(in) :: natoms
   integer(c_int), intent(in) :: numbers(natoms)
   real(c_double), intent(in) :: positions(3, natoms)
   real(c_double), intent(in), optional :: c_charge
   real(wp), allocatable :: charge
   integer(c_int), intent(in), optional :: c_uhf
   integer, allocatable :: uhf
   real(c_double), intent(in), optional :: c_lattice(3, 3)
   real(wp), allocatable :: lattice(:, :)
   logical(c_bool), intent(in), optional :: c_periodic(3)
   logical, allocatable :: periodic(:)
   type(vp_structure), pointer :: mol
   type(c_ptr) :: vmol

   if (debug) print '("[Info]",1x, a)', "new_structure"

   vmol = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (present(c_lattice)) then
      allocate(lattice(3, 3))
      lattice(:, :) = c_lattice
   end if
   if (present(c_periodic)) then
      allocate(periodic(3))
      periodic(:) = c_periodic
   end if
   if (present(c_charge)) then
      charge = c_charge
   end if
   if (present(c_uhf)) then
      uhf = c_uhf
   end if

   allocate(mol)
   call new(mol%ptr, numbers, positions, lattice=lattice, periodic=periodic, &
      charge=charge, uhf=uhf)
   vmol = c_loc(mol)

   call wrap_to_central_cell(mol%ptr%xyz, mol%ptr%lattice, mol%ptr%periodic)

   call verify_structure(error%ptr, mol%ptr)

end function new_structure_api


!> Delete molecular structure data
subroutine delete_structure_api(vmol) &
      & bind(C, name=namespace//"delete_structure")
   type(c_ptr), intent(inout) :: vmol
   type(vp_structure), pointer :: mol

   if (debug) print '("[Info]",1x, a)', "delete_structure"

   if (c_associated(vmol)) then
      call c_f_pointer(vmol, mol)

      deallocate(mol)
      vmol = c_null_ptr
   end if

end subroutine delete_structure_api


!> Update coordinates and lattice parameters (quantities in Bohr)
subroutine update_structure_geometry_api(verror, vmol, positions, lattice) &
      & bind(C, name=namespace//"update_structure_geometry")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   real(c_double), intent(in) :: positions(3, *)
   real(c_double), intent(in), optional :: lattice(3, 3)

   if (debug) print '("[Info]",1x, a)', "update_structure"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vmol)) then
      call fatal_error(error%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   if (mol%ptr%nat <= 0 .or. mol%ptr%nid <= 0 .or. .not.allocated(mol%ptr%num) &
      & .or. .not.allocated(mol%ptr%id) .or. .not.allocated(mol%ptr%xyz)) then
      call fatal_error(error%ptr, "Invalid molecular structure data provided")
      return
   end if

   mol%ptr%xyz(:, :) = positions(:3, :mol%ptr%nat)
   if (present(lattice)) then
      mol%ptr%lattice(:, :) = lattice(:3, :3)
   end if

   call wrap_to_central_cell(mol%ptr%xyz, mol%ptr%lattice, mol%ptr%periodic)

   call verify_structure(error%ptr, mol%ptr)

end subroutine update_structure_geometry_api


!> Update coordinates and lattice parameters (quantities in Bohr)
subroutine update_structure_charge_api(verror, vmol, c_charge) &
      & bind(C, name=namespace//"update_structure_charge")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   real(c_double), intent(in), optional :: c_charge

   if (debug) print '("[Info]",1x, a)', "update_structure_charge"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vmol)) then
      call fatal_error(error%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   if (mol%ptr%nat <= 0 .or. mol%ptr%nid <= 0 .or. .not.allocated(mol%ptr%num) &
      & .or. .not.allocated(mol%ptr%id) .or. .not.allocated(mol%ptr%xyz)) then
      call fatal_error(error%ptr, "Invalid molecular structure data provided")
      return
   end if

   if (present(c_charge)) then
      mol%ptr%charge = c_charge
   end if

end subroutine update_structure_charge_api


!> Update coordinates and lattice parameters (quantities in Bohr)
subroutine update_structure_uhf_api(verror, vmol, c_uhf) &
      & bind(C, name=namespace//"update_structure_uhf")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   integer(c_int), intent(in), optional :: c_uhf

   if (debug) print '("[Info]",1x, a)', "update_structure_uhf"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vmol)) then
      call fatal_error(error%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   if (mol%ptr%nat <= 0 .or. mol%ptr%nid <= 0 .or. .not.allocated(mol%ptr%num) &
      & .or. .not.allocated(mol%ptr%id) .or. .not.allocated(mol%ptr%xyz)) then
      call fatal_error(error%ptr, "Invalid molecular structure data provided")
      return
   end if

   if (present(c_uhf)) then
      mol%ptr%uhf = c_uhf
   end if

end subroutine update_structure_uhf_api


!> Cold fusion check
subroutine verify_structure(error, mol)
   type(error_type), allocatable, intent(out) :: error
   type(structure_type), intent(in) :: mol
   integer :: iat, jat, stat
   stat = 0
   do iat = 1, mol%nat
      do jat = 1, iat - 1
         if (norm2(mol%xyz(:, jat) - mol%xyz(:, iat)) < 1.0e-9_wp) stat = stat + 1
      end do
   end do
   if (stat > 0) then
      call fatal_error(error, "Too close interatomic distances found")
   end if
end subroutine verify_structure


end module tblite_api_structure

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file tests/ddx_driver.f90
!! Main ddx driver.
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-02-25

program main
use ddx_core
use ddx_operators
use ddx_solvers
use ddx
use ddx_legacy
implicit none

character(len=255) :: finname, foutname, tmpstr
type(ddx_type) :: ddx_data
type(ddx_error_type) :: ddx_error
type(ddx_state_type) :: state
real(dp), allocatable :: phi_cav(:), gradphi_cav(:, :), &
    & hessianphi_cav(:, :, :), psi(:, :), force(:, :), charges(:)
real(dp) :: tol, threshold, esolv, esolv2, fnorm, fdiff, ftmp(3)
integer :: i, isph, istatus
real(dp), external :: dnrm2

! Read input file name
call get_command_argument(1, finname)
! Read output file name
call get_command_argument(2, foutname)
! Read accuracy threshold
call get_command_argument(3, tmpstr)
read(tmpstr, *) threshold
! Init input from a file
call ddfromfile(finname, ddx_data, tol, charges, ddx_error)
call check_error(ddx_error)
call allocate_state(ddx_data % params, ddx_data % constants, state, ddx_error)
call check_error(ddx_error)

! Allocate resources
allocate(phi_cav(ddx_data % constants % ncav), gradphi_cav(3, ddx_data % constants % ncav), &
    & hessianphi_cav(3, 3, ddx_data % constants % ncav), &
    & psi(ddx_data % constants % nbasis, ddx_data % params % nsph), force(3, ddx_data % params % nsph), &
    & stat=istatus)
if(istatus .ne. 0) call test_error(-1, "Allocation failed")
! Prepare host-code-related entities
call mkrhs(ddx_data % params, ddx_data % constants, ddx_data % workspace, 1, &
    & phi_cav, 1, gradphi_cav, 1, hessianphi_cav, psi, charges)
! Use the solver
call ddsolve_legacy(ddx_data, state, phi_cav, -gradphi_cav, hessianphi_cav, psi, tol, esolv, force, ddx_error)
call check_error(ddx_error)
! compute the second contribution to the forces
call grad_phi_for_charges(ddx_data % params, ddx_data % constants, &
    & ddx_data % workspace, state, charges, force, ddx_error)
call check_error(ddx_error)
! Open output file for reading
open(unit=100, file=foutname, form='formatted', access='sequential')
! Skip 
read(100, *) ! Using provided ...
read(100, *) ! mkrhs time ...
read(100, *) ! ddsolve time ...
read(100, "(A)") tmpstr
read(tmpstr(16:), *) esolv2
if(abs(esolv2-esolv) .gt. threshold*abs(esolv)) then
    close(100)
    call test_error(-1, "Energy is different")
end if
! Compare forces
if (ddx_data % params % force .eq. 1) then
    read(100, *) ! Full forces ...
    fnorm = dnrm2(3*ddx_data % params % nsph, force, 1)
    do isph = 1, ddx_data % params % nsph
        read(100, *) i, ftmp(:)
        force(:, isph) = force(:, isph) - ftmp
    end do
    fdiff = dnrm2(3*ddx_data % params % nsph, force, 1)
    if(fdiff .gt. threshold*fnorm) then
        close(100)
        call test_error(-1, "Forces are different")
    end if
end if
! Close output file and deallocate resources
close(100)
deallocate(phi_cav, gradphi_cav, psi, force, charges, stat=istatus)
if(istatus .ne. 0) call test_error(-1, "Deallocation failed")
call deallocate_state(state, ddx_error)
call deallocate_model(ddx_data, ddx_error)

contains
!> Print error message and exit with provided error code
subroutine test_error(code, message)
    integer, intent(in) :: code
    character(len=*), intent(in) :: message
    write(0, "(A,A)") "ERROR: ", message
    write(0, "(A,I2)") "CODE:  ", code
    stop -1
end subroutine test_error
end program main

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of the abstract base dispersion model for the evaluation of C6 coefficients.
module dftd4_model_type
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use multicharge, only : mchrg_model_type
   implicit none
   private

   public :: dispersion_model, d4_qmod


   !> Abstract base dispersion model to evaluate C6 coefficients
   type, abstract :: dispersion_model

      !> Number of atoms coupled to by pairwise parameters
      integer :: ncoup

      !> Charge scaling height
      real(wp) :: ga

      !> Charge scaling steepness
      real(wp) :: gc

      !> Effective nuclear charges
      real(wp), allocatable :: zeff(:)

      !> Chemical hardness
      real(wp), allocatable :: eta(:)

      !> Electronegativity
      real(wp), allocatable :: en(:)

      !> Covalent radii for coordination number
      real(wp), allocatable :: rcov(:)

      !> Expectation values for C8 extrapolation
      real(wp), allocatable :: r4r2(:)

      !> Number of reference systems
      integer, allocatable :: ref(:)

      !> Number of Gaussian weights for each reference
      integer, allocatable :: ngw(:, :)

      !> Reference coordination numbers
      real(wp), allocatable :: cn(:, :)

      !> Reference partial charges
      real(wp), allocatable :: q(:, :)

      !> Reference dynamic polarizabilities
      real(wp), allocatable :: aiw(:, :, :)

      !> Reference C6 coefficients
      real(wp), allocatable :: c6(:, :, :, :)

      !> Multicharge model
      class(mchrg_model_type), allocatable :: mchrg 

   contains

      !> Generate weights for all reference systems
      procedure(weight_references), deferred :: weight_references

      !> Evaluate C6 coefficient
      procedure(get_atomic_c6), deferred :: get_atomic_c6

      !> Evaluate atomic polarizabilities
      procedure(get_polarizabilities), deferred :: get_polarizabilities

   end type dispersion_model

   abstract interface

      !> Calculate the weights of the reference system and the derivatives w.r.t.
      !> coordination number for later use.
      subroutine weight_references(self, mol, cn, q, gwvec, gwdcn, gwdq)
         import dispersion_model, structure_type, wp
         !> Instance of the dispersion model
         class(dispersion_model), intent(in) :: self
         !> Molecular structure data
         class(structure_type), intent(in) :: mol
         !> Coordination number of every atom: [nat]
         real(wp), intent(in) :: cn(:)
         !> Partial charge of every atom: [nat]
         real(wp), intent(in) :: q(:)
         !> weighting for the atomic reference systems: [nref, nat, ncoup]
         real(wp), intent(out) :: gwvec(:, :, :)
         !> derivative of the weighting function w.r.t. the coordination number: [nref, nat, ncoup]
         real(wp), intent(out), optional :: gwdcn(:, :, :)
         !> derivative of the weighting function w.r.t. the charge scaling: [nref, nat, ncoup]
         real(wp), intent(out), optional :: gwdq(:, :, :)
      end subroutine 

      !> Calculate atomic dispersion coefficients and their derivatives w.r.t.
      !> the coordination numbers and atomic partial charges.
      subroutine get_atomic_c6(self, mol, gwvec, gwdcn, gwdq, c6, dc6dcn, dc6dq)
         import dispersion_model, structure_type, wp
         !> Instance of the dispersion model
         class(dispersion_model), intent(in) :: self
         !> Molecular structure data
         class(structure_type), intent(in) :: mol
         !> Weighting function for the atomic reference systems
         real(wp), intent(in) :: gwvec(:, :, :)
         !> Derivative of the weighting function w.r.t. the coordination number
         real(wp), intent(in), optional :: gwdcn(:, :, :)
         !> Derivative of the weighting function w.r.t. the partial charge
         real(wp), intent(in), optional :: gwdq(:, :, :)
         !> C6 coefficients for all atom pairs.
         real(wp), intent(out) :: c6(:, :)
         !> Derivative of the C6 w.r.t. the coordination number
         real(wp), intent(out), optional :: dc6dcn(:, :)
         !> Derivative of the C6 w.r.t. the partial charge
         real(wp), intent(out), optional :: dc6dq(:, :)
      end subroutine get_atomic_c6

      !> Calculate atomic polarizabilities and their derivatives w.r.t.
      !> the coordination numbers and atomic partial charges.
      subroutine get_polarizabilities(self, mol, gwvec, gwdcn, gwdq, alpha, dadcn, dadq)
         import dispersion_model, structure_type, wp
         !> Instance of the dispersion model
         class(dispersion_model), intent(in) :: self
         !> Molecular structure data
         class(structure_type), intent(in) :: mol
         !> Weighting function for the atomic reference systems
         real(wp), intent(in) :: gwvec(:, :, :)
         !> Derivative of the weighting function w.r.t. the coordination number
         real(wp), intent(in), optional :: gwdcn(:, :, :)
         !> Derivative of the weighting function w.r.t. the partial charge
         real(wp), intent(in), optional :: gwdq(:, :, :)
         !> Static polarizabilities for all atoms.
         real(wp), intent(out) :: alpha(:)
         !> Derivative of the polarizibility w.r.t. the coordination number
         real(wp), intent(out), optional :: dadcn(:)
         !> Derivative of the polarizibility w.r.t. the partial charge
         real(wp), intent(out), optional :: dadq(:)
      end subroutine

   end interface


   !> Possible reference charges for D4
   type :: enum_qmod

      !> Electronegativity equilibration charges
      integer :: eeq = 1

      !> GFN2-xTB Mulliken partial charges
      integer :: gfn2 = 2

      !> Bond-Capcity Electronegativity equilibration charges
      integer :: eeqbc = 3

   end type enum_qmod

   !> Actual enumerator for D4 reference charges
   type(enum_qmod), parameter :: d4_qmod = enum_qmod()
   !DEC$ ATTRIBUTES DLLEXPORT :: d4_qmod

end module dftd4_model_type

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

!> Element specific data needed for the DFT-D4 model
module dftd4_data
   use dftd4_data_covrad, only : get_covalent_rad
   use dftd4_data_en, only : get_electronegativity
   use dftd4_data_hardness, only : get_hardness
   use dftd4_data_r4r2, only : get_r4r2_val
   use dftd4_data_wfpair, only : get_wfpair_val
   use dftd4_data_zeff, only : get_effective_charge
   implicit none
   public

end module dftd4_data

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module test_periodic
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type, new
   use mstore, only : get_structure
   use dftd3
   implicit none
   private

   public :: collect_periodic

   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))
   real(wp), parameter :: thr3 = 1000*sqrt(epsilon(1.0_wp))
   type(realspace_cutoff), parameter :: cutoff = &
      & realspace_cutoff(cn=30_wp, disp2=60.0_wp, disp3=15.0_wp)


contains


!> Collect all exported unit tests
subroutine collect_periodic(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("PBE-D3(BJ)", test_pbed3bj_acetic), &
      & new_unittest("PBEsol-D3(BJ)", test_pbesold3bj_adaman), &
      & new_unittest("TPSS-D3(BJ)", test_tpssd3bj_ammonia), &
      & new_unittest("HSE06-D3(BJ)", test_hse06d3bj_anthracene), &
      & new_unittest("BLYP-D3(0)", test_blypd3zero_benzene), &
      & new_unittest("M06L-D3(0)", test_m06ld3zero_cyanamide), &
      & new_unittest("rPW86PBE-D3(0)", test_rpw86pbed3zero_co2), &
      & new_unittest("revSSB-D3(0)", test_revssbd3zero_cytosine), &
      & new_unittest("HSEsol-D3(BJ)-ATM", test_hsesold3bjatm_oxacb), &
      ! new_unittest("PWGGA-D3(BJ)-ATM", test_pwggad3bjatm_pyrazine), &
      & new_unittest("B3PW91-D3(0)-ATM", test_b3pw91d3zeroatm_urea), &
      & new_unittest("RPBE-D3(0)-ATM", test_rpbed3zeroatm_hexamine), &
      & new_unittest("revPBE-D3(BJ)", test_revpbed3bj_1d), &
      & new_unittest("BP86-D3(0)", test_bp86d3zero_2d) &
      & ]

end subroutine collect_periodic


subroutine test_dftd3_gen(error, mol, param, ref)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Expected dispersion energy
   real(wp), intent(in) :: ref

   type(d3_model) :: d3
   real(wp) :: energy

   call new_d3_model(d3, mol)
   call get_dispersion(mol, d3, param, cutoff, energy)

   call check(error, energy, ref, thr=thr)
   if (allocated(error)) then
      print*,energy
   end if

end subroutine test_dftd3_gen


subroutine test_numgrad(error, mol, param, thr_in)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Gradient threshold
   real(wp), intent(in), optional :: thr_in

   integer :: iat, ic
   type(d3_model) :: d3
   real(wp) :: energy, er, el, sigma(3, 3), thr_grad, numerr
   real(wp), allocatable :: gradient(:, :), numgrad(:, :)
   real(wp), parameter :: step = 1.0e-6_wp
   logical :: tight

   allocate(gradient(3, mol%nat), numgrad(3, mol%nat))
   call new_d3_model(d3, mol)
   thr_grad = thr2
   if (present(thr_in)) thr_grad = thr_in
   tight = present(thr_in)

   do iat = 1, mol%nat
      do ic = 1, 3
         if (tight) then
            call ridders_cartesian(ic, iat, numgrad(ic, iat), numerr)
         else
            mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
            call get_dispersion(mol, d3, param, cutoff, er)
            mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2*step
            call get_dispersion(mol, d3, param, cutoff, el)
            mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
            numgrad(ic, iat) = 0.5_wp*(er - el)/step
         end if
      end do
   end do

   call get_dispersion(mol, d3, param, cutoff, energy, gradient, sigma)

   if (any(abs(gradient - numgrad) > thr_grad)) then
      call test_failed(error, "Gradient of dispersion energy does not match")
      print'(3es21.14)', gradient-numgrad
   end if

contains

subroutine ridders_cartesian(ic, iat, deriv, err)

   integer, intent(in) :: ic, iat
   real(wp), intent(out) :: deriv, err

   integer, parameter :: max_tab = 10
   real(wp), parameter :: initial_step = 1.0e-4_wp
   real(wp), parameter :: step_div = sqrt(2.0_wp)
   real(wp), parameter :: step_div_2 = step_div**2
   integer :: iter, order
   real(wp) :: table(max_tab, max_tab), factor, err_est, prev_deriv, prev_err
   real(wp) :: h, x0

   x0 = mol%xyz(ic, iat)
   h = initial_step
   err = huge(1.0_wp)
   prev_err = err

   mol%xyz(ic, iat) = x0 + h
   call get_dispersion(mol, d3, param, cutoff, er)
   mol%xyz(ic, iat) = x0 - h
   call get_dispersion(mol, d3, param, cutoff, el)
   table(1, 1) = 0.5_wp*(er - el)/h
   deriv = table(1, 1)
   prev_deriv = deriv

   do iter = 2, max_tab
      h = h / step_div
      mol%xyz(ic, iat) = x0 + h
      call get_dispersion(mol, d3, param, cutoff, er)
      mol%xyz(ic, iat) = x0 - h
      call get_dispersion(mol, d3, param, cutoff, el)
      table(iter, 1) = 0.5_wp*(er - el)/h

      factor = step_div_2
      do order = 1, iter - 1
         factor = factor * step_div_2
         table(iter, order + 1) = (factor*table(iter, order) &
            & - table(iter - 1, order))/(factor - 1.0_wp)
         err_est = max(abs(table(iter, order + 1) - table(iter, order)), &
            & abs(table(iter, order + 1) - table(iter - 1, order)))
         if (err_est <= err) then
            err = err_est
            deriv = table(iter, order + 1)
         end if
      end do

      if (abs(table(iter, iter) - table(iter - 1, iter - 1)) >= 2*err &
         & .and. iter > 2) then
         deriv = prev_deriv
         err = prev_err
         exit
      end if

      prev_deriv = deriv
      prev_err = err
   end do

   mol%xyz(ic, iat) = x0

end subroutine ridders_cartesian

end subroutine test_numgrad


subroutine test_numsigma(error, mol, param, thr_in)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Strain derivative threshold
   real(wp), intent(in), optional :: thr_in

   integer :: ic, jc
   type(d3_model) :: d3
   real(wp) :: energy, er, el, sigma(3, 3), eps(3, 3), numsigma(3, 3), lattice(3, 3)
   real(wp) :: thr_sigma, numerr
   real(wp), allocatable :: gradient(:, :), xyz(:, :)
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], shape(unity))
   real(wp), parameter :: step = 1.0e-7_wp
   logical :: tight

   allocate(gradient(3, mol%nat), xyz(3, mol%nat))
   call new_d3_model(d3, mol)
   thr_sigma = thr3
   if (present(thr_in)) thr_sigma = thr_in
   tight = present(thr_in)

   eps(:, :) = unity
   xyz(:, :) = mol%xyz
   lattice(:, :) = mol%lattice
   do ic = 1, 3
      do jc = 1, 3
         if (tight) then
            call ridders_strain(ic, jc, numsigma(jc, ic), numerr)
         else
            eps(jc, ic) = eps(jc, ic) + step
            mol%xyz(:, :) = matmul(eps, xyz)
            mol%lattice(:, :) = matmul(eps, lattice)
            call get_dispersion(mol, d3, param, cutoff, er)
            eps(jc, ic) = eps(jc, ic) - 2*step
            mol%xyz(:, :) = matmul(eps, xyz)
            mol%lattice(:, :) = matmul(eps, lattice)
            call get_dispersion(mol, d3, param, cutoff, el)
            eps(jc, ic) = eps(jc, ic) + step
            mol%xyz(:, :) = xyz
            mol%lattice(:, :) = lattice
            numsigma(jc, ic) = 0.5_wp*(er - el)/step
         end if
      end do
   end do

   call get_dispersion(mol, d3, param, cutoff, energy, gradient, sigma)

   if (any(abs(sigma - numsigma) > thr_sigma)) then
      call test_failed(error, "Strain derivatives do not match")
      print'(3es21.14)', sigma-numsigma
   end if

contains

subroutine ridders_strain(ic, jc, deriv, err)

   integer, intent(in) :: ic, jc
   real(wp), intent(out) :: deriv, err

   integer, parameter :: max_tab = 10
   real(wp), parameter :: initial_step = 5.0e-8_wp
   real(wp), parameter :: step_div = sqrt(2.0_wp)
   real(wp), parameter :: step_div_2 = step_div**2
   integer :: iter, order
   real(wp) :: table(max_tab, max_tab), factor, err_est, prev_deriv, prev_err
   real(wp) :: h

   h = initial_step
   err = huge(1.0_wp)
   prev_err = err

   call strain_energy(ic, jc, h, er)
   call strain_energy(ic, jc, -h, el)
   table(1, 1) = 0.5_wp*(er - el)/h
   deriv = table(1, 1)
   prev_deriv = deriv

   do iter = 2, max_tab
      h = h / step_div
      call strain_energy(ic, jc, h, er)
      call strain_energy(ic, jc, -h, el)
      table(iter, 1) = 0.5_wp*(er - el)/h

      factor = step_div_2
      do order = 1, iter - 1
         factor = factor * step_div_2
         table(iter, order + 1) = (factor*table(iter, order) &
            & - table(iter - 1, order))/(factor - 1.0_wp)
         err_est = max(abs(table(iter, order + 1) - table(iter, order)), &
            & abs(table(iter, order + 1) - table(iter - 1, order)))
         if (err_est <= err) then
            err = err_est
            deriv = table(iter, order + 1)
         end if
      end do

      if (abs(table(iter, iter) - table(iter - 1, iter - 1)) >= 2*err &
         & .and. iter > 2) then
         deriv = prev_deriv
         err = prev_err
         exit
      end if

      prev_deriv = deriv
      prev_err = err
   end do

   mol%xyz(:, :) = xyz
   mol%lattice(:, :) = lattice

end subroutine ridders_strain

subroutine strain_energy(ic, jc, step, energy)

   integer, intent(in) :: ic, jc
   real(wp), intent(in) :: step
   real(wp), intent(out) :: energy
   real(wp) :: strain(3, 3)

   strain(:, :) = unity
   strain(jc, ic) = strain(jc, ic) + step
   mol%xyz(:, :) = matmul(strain, xyz)
   mol%lattice(:, :) = matmul(strain, lattice)
   call get_dispersion(mol, d3, param, cutoff, energy)

end subroutine strain_energy

end subroutine test_numsigma


subroutine test_pbed3bj_acetic(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.4289_wp, s8 = 0.7875_wp, a2 = 4.4407_wp)

   call get_structure(mol, "X23", "acetic")
   call new_rational_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -6.6732836815486210E-2_wp)

end subroutine test_pbed3bj_acetic


subroutine test_pbesold3bj_adaman(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.4466_wp, s8 = 2.9491_wp, a2 = 6.1742_wp)

   call get_structure(mol, "X23", "adaman")
   call new_rational_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -7.9313514714713124E-2_wp)

end subroutine test_pbesold3bj_adaman


subroutine test_tpssd3bj_ammonia(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.4535_wp, s8 = 1.9435_wp, a2 = 4.4752_wp)

   call get_structure(mol, "X23", "ammonia")
   call new_rational_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_tpssd3bj_ammonia


subroutine test_hse06d3bj_anthracene(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.383_wp, s8 = 2.310_wp, a2 = 5.685_wp)

   call get_structure(mol, "X23", "anthracene")
   call new_rational_damping(param, inp)
   call test_numsigma(error, mol, param)

end subroutine test_hse06d3bj_anthracene


subroutine test_blypd3zero_benzene(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.094_wp, s8 = 1.682_wp)

   call get_structure(mol, "X23", "benzene")
   call new_zero_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -0.16647358662571451_wp)

end subroutine test_blypd3zero_benzene


subroutine test_m06ld3zero_cyanamide(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.581_wp, s8 = 0.000_wp)

   call get_structure(mol, "X23", "cyanamide")
   call new_zero_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -2.3222556050310025E-2_wp)

end subroutine test_m06ld3zero_cyanamide


subroutine test_rpw86pbed3zero_co2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.224_wp, s8 = 0.901_wp)

   call get_structure(mol, "X23", "CO2")
   call new_zero_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_rpw86pbed3zero_co2


subroutine test_revssbd3zero_cytosine(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.221_wp, s8 = 0.560_wp)

   call get_structure(mol, "X23", "cytosine")
   call new_zero_damping(param, inp)
   call test_numsigma(error, mol, param)

end subroutine test_revssbd3zero_cytosine


subroutine test_hsesold3bjatm_oxacb(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.4650_wp, s8 = 2.9215_wp, a2 = 6.2003_wp)

   call get_structure(mol, "X23", "oxacb")
   call new_rational_damping(param, inp)
   call test_numgrad(error, mol, param, 1.0e-11_wp)

end subroutine test_hsesold3bjatm_oxacb


subroutine test_pwggad3bjatm_pyrazine(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.2211_wp, s8 = 2.6910_wp, a2 = 6.7278_wp)

   call get_structure(mol, "X23", "pyrazine")
   call new_rational_damping(param, inp)
   call test_numsigma(error, mol, param, 1.0e-8_wp)

end subroutine test_pwggad3bjatm_pyrazine


subroutine test_b3pw91d3zeroatm_urea(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.176_wp, s8 = 1.775_wp)

   call get_structure(mol, "X23", "urea")
   call new_zero_damping(param, inp)
   call test_numgrad(error, mol, param, 1.0e-11_wp)

end subroutine test_b3pw91d3zeroatm_urea


subroutine test_rpbed3zeroatm_hexamine(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 0.872_wp, s8 = 0.514_wp)

   call get_structure(mol, "X23", "hexamine")
   call new_zero_damping(param, inp)
   call test_numsigma(error, mol, param, 1.0e-8_wp)

end subroutine test_rpbed3zeroatm_hexamine


subroutine test_revpbed3bj_1d(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer, parameter :: nat = 32
   integer, parameter :: num(nat) = 6
   real(wp), parameter :: xyz(3, nat) = reshape([&
      & 1.36794785746435_wp, 13.45808943446053_wp,  8.83754983226359_wp, &
      & 3.69183290816438_wp, 13.13552229161569_wp, 10.16652201690950_wp, &
      & 1.36792668081267_wp, 10.38660504434782_wp, 13.04411926632965_wp, &
      & 3.69180534781206_wp, 11.55414582295511_wp, 12.33193380846742_wp, &
      & 1.36791549262702_wp,  3.53066844289674_wp, 10.38660588677206_wp, &
      & 1.36792046664920_wp,  7.73723910626293_wp, 13.45809224934817_wp, &
      & 3.69181279359489_wp,  6.40826717723392_wp, 13.13552570942280_wp, &
      & 1.36792009865062_wp,  3.11669712338516_wp,  7.73723850632628_wp, &
      & 3.69181515738094_wp,  3.43926499914873_wp,  6.40826580885474_wp, &
      & 3.69178443989294_wp,  4.24285720771059_wp, 11.55415026712869_wp, &
      & 1.36790824853106_wp,  6.18818490375705_wp,  3.53066863732142_wp, &
      & 3.69178194163078_wp,  5.02063901427657_wp,  4.24285736953327_wp, &
      & 1.36794124909207_wp, 13.04411858182861_wp,  6.18818324080182_wp, &
      & 1.36792249732236_wp,  8.83755133592807_wp,  3.11669686076913_wp, &
      & 3.69182456413952_wp, 10.16652118921143_wp,  3.43926084011816_wp, &
      & 3.69181444966104_wp, 12.33193631088573_wp,  5.02063847821044_wp, &
      & 6.01572566324028_wp, 13.45790756713123_wp,  8.83752222635545_wp, &
      & 8.33965926123256_wp, 13.13576644753615_wp, 10.16660228658307_wp, &
      & 6.01574747573805_wp, 10.38654070512969_wp, 13.04391961251944_wp, &
      & 8.33964066450677_wp, 11.55427002850905_wp, 12.33211653730939_wp, &
      & 6.01574728097580_wp,  3.53087013230607_wp, 10.38654217813321_wp, &
      & 6.01568913853645_wp,  7.73726406411719_wp, 13.45790864082374_wp, &
      & 8.33963586549168_wp,  6.40818371470975_wp, 13.13576911116618_wp, &
      & 6.01568179676984_wp,  3.11688332536281_wp,  7.73726611148835_wp, &
      & 8.33963704688671_wp,  3.43902559351770_wp,  6.40818390180453_wp, &
      & 8.33962496288127_wp,  4.24267007149867_wp, 11.55427031066552_wp, &
      & 6.01573464280675_wp,  6.18824653544318_wp,  3.53086861480278_wp, &
      & 8.33961857277245_wp,  5.02052001792996_wp,  4.24267413625204_wp, &
      & 6.01575677304189_wp, 13.04392044501564_wp,  6.18824448603611_wp, &
      & 6.01568344836224_wp,  8.83752193432504_wp,  3.11688171781516_wp, &
      & 8.33964228963694_wp, 10.16660428027860_wp,  3.43902155668011_wp, &
      & 8.33965118613331_wp, 12.33211762632282_wp,  5.02051902430387_wp],&
      & shape(xyz))
   logical, parameter :: periodic(3) = [.true., .false., .false.]
   real(wp), parameter :: lattice(3, 3) = reshape([&
      & 9.2955628527586_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & shape(lattice))
   real(wp), parameter :: lattice_vac(3, 3) = reshape([&
      & 9.2955628527586_wp, 0.0_wp, 0.0_wp, 0.0_wp, 100.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 100.0_wp], &
      & shape(lattice))
   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.5238_wp, s8 = 2.3550_wp, a2 = 3.5016_wp)

   call new(mol, num, xyz, periodic=periodic, lattice=lattice)
   call new_rational_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -0.25436101196186600_wp)

   call new(mol, num, xyz, periodic=[.true.], lattice=lattice_vac)
   call test_dftd3_gen(error, mol, param, -0.25436101196186600_wp)

end subroutine test_revpbed3bj_1d


subroutine test_bp86d3zero_2d(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer, parameter :: nat = 4
   integer, parameter :: num(nat) = 6
   real(wp), parameter :: xyz(3, nat) = reshape([&
      & -0.12918412100093_wp,  0.06210659750976_wp, -2.13384498734326_wp, &
      &  0.12856915667443_wp, -0.07403227791901_wp,  4.02358027265954_wp, &
      & -0.12317720857511_wp,  2.75170732207802_wp, -2.13345350602279_wp, &
      &  2.44816466162280_wp,  1.28612566399214_wp,  4.02317048854901_wp],&
      & shape(xyz))
   logical, parameter :: periodic(3) = [.true., .true., .false.]
   real(wp), parameter :: lattice(3, 3) = reshape([&
      &  4.68837849314507_wp, 0.00000000000000_wp, 0.00000000000000_wp, &
      & -2.36282788044783_wp, 4.04978545156612_wp, 0.00000000000000_wp, &
      &  0.00000000000000_wp, 0.00000000000000_wp, 1.00000000000000_wp],&
      & shape(lattice))
   real(wp), parameter :: lattice_vac(3, 3) = reshape([&
      &  4.68837849314507_wp, 0.00000000000000_wp, 0.00000000000000_wp, &
      & -2.36282788044783_wp, 4.04978545156612_wp, 0.00000000000000_wp, &
      &  0.00000000000000_wp, 0.00000000000000_wp, 100.000000000000_wp],&
      & shape(lattice))
   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & rs6 = 1.139_wp, s8 = 1.683_wp)

   call new(mol, num, xyz, periodic=periodic, lattice=lattice)
   call new_zero_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -1.5983949078995030E-2_wp)

   call new(mol, num, xyz, periodic=[.true.], lattice=lattice_vac)
   call test_dftd3_gen(error, mol, param, -1.5983949078995030E-2_wp)

end subroutine test_bp86d3zero_2d


end module test_periodic

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/xtb/calculator.f90
!> Provides the calculator type for holding xTB Hamiltonian parametrization.

!> Implementation of calculator type for the extended-tight binding Hamiltonian.
!> The #tblite_xtb_calculator::xtb_calculator collects the basic interactions
!> required to perform a tight-binding calculation.
module tblite_xtb_calculator
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type
   use mctc_ncoord, only : ncoord_type, new_ncoord, cn_count, get_cn_count_id
   use tblite_basis_ortho, only : orthogonalize
   use tblite_basis_type, only : basis_type, new_basis, cgto_type
   use tblite_basis_slater, only : slater_to_gauss
   use tblite_classical_halogen, only : halogen_correction, new_halogen_correction
   use tblite_container, only : container_type, container_list
   use tblite_coulomb_charge, only : coulomb_kernel, new_gamma_coulomb, gamma_coulomb, &
      & new_effective_coulomb, effective_coulomb, average_interface, &
      & harmonic_average, arithmetic_average, geometric_average
   use tblite_coulomb_multipole, only : new_damped_multipole
   use tblite_coulomb_thirdorder, only : new_onsite_thirdorder
   use tblite_disp, only : dispersion_type, d4_dispersion, new_d4_dispersion, &
      & new_d4s_dispersion, d3_dispersion, new_d3_dispersion
   use tblite_param, only : param_record
   use tblite_repulsion, only : new_repulsion
   use tblite_repulsion_effective, only : tb_repulsion
   use tblite_scf_mixer_input, only : mixer_input
   use tblite_xtb_coulomb, only : tb_coulomb
   use tblite_xtb_h0, only : tb_hamiltonian, new_hamiltonian
   use tblite_xtb_spec, only : tb_h0spec
   implicit none
   private

   public :: new_xtb_calculator
   public :: param_h0spec, xtb_config

   !> Extended tight-binding calculator
   type, public :: xtb_calculator
      !> Basis set definition
      type(basis_type) :: bas
      !> Core Hamiltonian
      type(tb_hamiltonian) :: h0
      !> Coordination number for modifying the self-energies
      class(ncoord_type), allocatable :: ncoord
      !> Electronegativity-weighted coordination number for modifying the self-energies
      class(ncoord_type), allocatable :: ncoord_en
      !> Repulsion energy interactions
      type(tb_repulsion), allocatable :: repulsion
      !> Collection of all Coulombic interactions
      type(tb_coulomb), allocatable :: coulomb
      !> Halogen bonding correction
      type(halogen_correction), allocatable :: halogen
      !> London-dispersion interaction
      class(dispersion_type), allocatable :: dispersion
      !> Input for self-consistent iteration mixing
      type(mixer_input) :: mixer_input
      !> Maximum number of self-consistent iterations
      integer :: max_iter = 250
      !> Store calculated integral intermediates
      logical :: save_integrals = .false.
      !> List of additional interaction containers
      type(container_list), allocatable :: interactions
      !> string with method or "custom"
      character(len=:), allocatable :: method
   contains
      !> Get information about density dependent quantities used in the energy
      procedure :: variable_info
      !> Information on calculator
      procedure :: info
      !> Add an interaction container
      procedure :: push_back
      !> Remove an interaction container
      procedure :: pop
   end type xtb_calculator


   !> Specification of the Hamiltonian
   type, extends(tb_h0spec) :: param_h0spec
      type(param_record), pointer :: param => null()
      integer, pointer :: irc(:) => null()
      logical, allocatable :: valence(:, :)
   contains
      !> Generator for the self energy / atomic levels of the Hamiltonian
      procedure :: get_selfenergy
      !> Generator for the coordination number dependent shift of the self energy
      procedure :: get_cnshift
      !> Generator for the enhancement factor to for scaling Hamiltonian elements
      procedure :: get_hscale
      !> Generator for the polynomial parameters for the distant dependent scaling
      procedure :: get_shpoly
      !> Generator for the reference occupation numbers of the atoms
      procedure :: get_reference_occ
   end type param_h0spec

   !> Constructor for Hamiltonian specification
   interface param_h0spec
      module procedure :: new_param_h0spec
   end interface param_h0spec


   !> Configuration for calculator
   type :: xtb_config
      !> Whether to use a smooth cutoff for the dispersion energy
      real(wp) :: smooth_cutoff = 0.05_wp
   end type xtb_config


contains


!> Create new xTB Hamiltonian calculator from parametrization data
subroutine new_xtb_calculator(calc, mol, param, error, config)
   !> Instance of the xTB calculator
   type(xtb_calculator), intent(out) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Configuration for the calculator
   type(xtb_config), intent(in), optional :: config

   integer :: isp
   integer, allocatable :: irc(:)
   type(xtb_config) :: cfg

   cfg = xtb_config()
   if (present(config)) then
      cfg = config
   end if

   allocate(irc(mol%nid))

   do isp = 1, mol%nid
      call param%get(mol%sym(isp), mol%num(isp), irc(isp))
      if (irc(isp) == 0) then
         call fatal_error(error, "No entry in parametrization for element "//mol%sym(isp))
         exit
      end if
   end do
   if (allocated(error)) return

   call add_basis(calc, mol, param, irc)
   calc%max_iter = calc%mixer_input%max_iter
   call add_ncoord(calc, mol, param, error)
   if (allocated(error)) return
   call add_hamiltonian(calc, mol, param, irc)
   call add_repulsion(calc, mol, param, irc)
   call add_halogen(calc, mol, param, irc)
   call add_dispersion(calc, mol, param, error, cfg%smooth_cutoff)
   if (allocated(error)) return
   call add_coulomb(calc, mol, param, irc, error)
   if (allocated(error)) return

   calc%method = "custom"

end subroutine new_xtb_calculator


subroutine add_basis(calc, mol, param, irc)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)

   integer :: isp, ir, ish, stat, ng, il
   integer, allocatable :: nsh_id(:)
   integer :: ang_idx(0:4), ortho(10)
   type(cgto_type), allocatable :: cgto(:, :)

   nsh_id = param%record(irc)%nsh
   allocate(cgto(maxval(nsh_id), mol%nid))
   do isp = 1, mol%nid
      ang_idx = 0
      ortho = 0
      ir = irc(isp)
      do ish = 1, nsh_id(isp)
         il = param%record(ir)%lsh(ish)
         ng = param%record(ir)%ngauss(ish)
         if (ang_idx(il) > 0) then
            ortho(ish) = ang_idx(il)
         else
            ang_idx(il) = ish
         end if
         call slater_to_gauss(ng, param%record(ir)%pqn(ish), il, &
            & param%record(ir)%slater(ish), cgto(ish, isp), .true., stat)
      end do

      do ish = 1, nsh_id(isp)
         if (ortho(ish) > 0) then
            call orthogonalize(cgto(ortho(ish), isp), cgto(ish, isp))
         end if
      end do
   end do

   call new_basis(calc%bas, mol, nsh_id, cgto, 1.0_wp)

end subroutine add_basis


subroutine add_ncoord(calc, mol, param, error)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: cn_count_type

   if (allocated(param%hamiltonian%cn)) then
      cn_count_type = get_cn_count_id(param%hamiltonian%cn)
      call new_ncoord(calc%ncoord, mol, cn_count_type=cn_count_type, error=error)
   end if
end subroutine add_ncoord


subroutine add_hamiltonian(calc, mol, param, irc)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)

   call new_hamiltonian(calc%h0, mol, calc%bas, new_param_h0spec(mol, param, irc))
end subroutine add_hamiltonian


subroutine add_dispersion(calc, mol, param, error, smooth_cutoff)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Whether to use a smooth cutoff for the dispersion energy
   real(wp), intent(in) :: smooth_cutoff

   type(d4_dispersion), allocatable :: d4
   type(d3_dispersion), allocatable :: d3

   if (.not.allocated(param%dispersion)) return
   associate(par => param%dispersion)
      if (par%d3) then
         allocate(d3)
         call new_d3_dispersion(d3, mol, s6=par%s6, s8=par%s8, &
            & a1=par%a1, a2=par%a2, s9=par%s9, error=error, &
            & disp2_width=smooth_cutoff, disp3_width=smooth_cutoff)
         call move_alloc(d3, calc%dispersion)
      else
         allocate(d4)
         if (par%smooth) then 
            call new_d4s_dispersion(d4, mol, s6=par%s6, s8=par%s8, &
               & a1=par%a1, a2=par%a2, s9=par%s9, error=error, &
               & disp2_width=smooth_cutoff, disp3_width=smooth_cutoff)
         else
            call new_d4_dispersion(d4, mol, s6=par%s6, s8=par%s8, &
               & a1=par%a1, a2=par%a2, s9=par%s9, error=error, &
               & disp2_width=smooth_cutoff, disp3_width=smooth_cutoff)
         end if
         call move_alloc(d4, calc%dispersion)
      end if
   end associate
end subroutine add_dispersion

subroutine add_repulsion(calc, mol, param, irc)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)

   real(wp), allocatable :: alpha(:), zeff(:)
   real(wp), parameter :: rep_rexp = 1.0_wp

   if (.not.allocated(param%repulsion)) return
   allocate(calc%repulsion)
   alpha = param%record(irc)%alpha
   zeff = param%record(irc)%zeff
   call new_repulsion(calc%repulsion, mol, alpha, zeff, param%repulsion%kexp, &
      & param%repulsion%klight, rep_rexp)

end subroutine add_repulsion


subroutine add_halogen(calc, mol, param, irc)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)

   real(wp), allocatable :: bond_strength(:)

   if (.not.allocated(param%halogen)) return
   allocate(calc%halogen)
   bond_strength = param%record(irc)%xbond
   associate(par => param%halogen)
      call new_halogen_correction(calc%halogen, mol, par%damping, par%rscale, &
         & bond_strength)
   end associate
end subroutine add_halogen

subroutine add_coulomb(calc, mol, param, irc, error)
   !> Instance of the xTB evaluator
   type(xtb_calculator), intent(inout) :: calc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp), allocatable :: hardness(:, :), hubbard_derivs(:, :)
   real(wp), allocatable :: dkernel(:), qkernel(:), rad(:), vcn(:)
   procedure(average_interface), pointer :: average

   if (.not.any([allocated(param%charge), allocated(param%thirdorder), &
      & allocated(param%multipole)])) return
   allocate(calc%coulomb)

   if (allocated(param%charge)) then
      call get_shell_hardness(mol, param, irc, hardness)
      select case(param%charge%kernel)
      case(coulomb_kernel%effective)
         block
            type(effective_coulomb), allocatable :: es2
            allocate(es2)
            call get_average(param%charge%average, average)
            call new_effective_coulomb(es2, mol, param%charge%gexp, hardness, &
               & average, calc%bas%nsh_id)
            call move_alloc(es2, calc%coulomb%es2)
         end block
      case(coulomb_kernel%dftb_gamma)
         block
            type(gamma_coulomb), allocatable :: es2
            allocate(es2)
            call new_gamma_coulomb(es2, mol, hardness, calc%bas%nsh_id)
            call move_alloc(es2, calc%coulomb%es2)
         end block
      end select
   end if

   if (allocated(param%thirdorder)) then
      allocate(calc%coulomb%es3)
      if (param%thirdorder%shell) then
         call get_hubbard_derivs(mol, param, irc, hubbard_derivs)
         call new_onsite_thirdorder(calc%coulomb%es3, mol, hubbard_derivs, calc%bas%nsh_id)
      else
         allocate(hubbard_derivs(1, mol%nid))
         hubbard_derivs(1, :) = param%record(irc)%gam3
         call new_onsite_thirdorder(calc%coulomb%es3, mol, hubbard_derivs)
      end if
   end if

   if (allocated(param%multipole)) then
      allocate(calc%coulomb%aes2)
      dkernel = param%record(irc)%dkernel
      qkernel = param%record(irc)%qkernel
      rad = param%record(irc)%mprad
      vcn = param%record(irc)%mpvcn
      associate(par => param%multipole)
         call new_damped_multipole(calc%coulomb%aes2, mol, par%dmp3, par%dmp5, &
            & dkernel, qkernel, par%shift, par%kexp, par%rmax, rad, vcn, error)
      end associate
   end if

end subroutine add_coulomb


subroutine get_average(average_type, averager)
   character(len=*), intent(in) :: average_type
   procedure(average_interface), pointer, intent(out) :: averager
   select case(average_type)
   case default
      nullify(averager)
   case("harmonic")
      averager => harmonic_average
   case("geometric")
      averager => geometric_average
   case("arithmetic")
      averager => arithmetic_average
   end select
end subroutine get_average


subroutine get_shell_hardness(mol, param, irc, hardness)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)
   !> Shell resolved hardness parameters
   real(wp), allocatable, intent(out) :: hardness(:, :)

   integer :: isp, ir, ish, il

   allocate(hardness(maxval(param%record(irc)%nsh), mol%nid))
   hardness(:, :) = 0.0_wp
   do isp = 1, mol%nid
      ir = irc(isp)
      do ish = 1, param%record(ir)%nsh
         il = param%record(ir)%lsh(ish)
         hardness(ish, isp) = param%record(ir)%gam * param%record(ir)%lgam(ish)
      end do
   end do
end subroutine get_shell_hardness


subroutine get_hubbard_derivs(mol, param, irc, hubbard_derivs)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), intent(in) :: param
   !> Record identifiers
   integer, intent(in) :: irc(:)
   !> Shell resolved Hubbard derivatives
   real(wp), allocatable, intent(out) :: hubbard_derivs(:, :)

   integer :: isp, ir, ish, il

   allocate(hubbard_derivs(maxval(param%record(irc)%nsh), mol%nid))
   hubbard_derivs(:, :) = 0.0_wp
   do isp = 1, mol%nid
      ir = irc(isp)
      do ish = 1, param%record(ir)%nsh
         il = param%record(ir)%lsh(ish)
         hubbard_derivs(ish, isp) = param%record(ir)%gam3 * param%thirdorder%ksh(il)
      end do
   end do
end subroutine get_hubbard_derivs


function new_param_h0spec(mol, param, irc) result(self)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Parametrization records
   type(param_record), target, intent(in) :: param
   !> Record identifiers
   integer, target, intent(in) :: irc(:)
   !> Instance of the Hamiltonian specification
   type(param_h0spec) :: self

   integer :: isp, il, ir, ish
   integer :: ang_idx(0:4)

   self%param => param
   self%irc => irc

   allocate(self%valence(maxval(param%record(irc)%nsh), mol%nid))
   do isp = 1, mol%nid
      ang_idx = 0
      ir = irc(isp)
      do ish = 1, param%record(ir)%nsh
         il = param%record(ir)%lsh(ish)
         self%valence(ish, isp) = ang_idx(il) == 0
         if (self%valence(ish, isp)) ang_idx(il) = ish
      end do
   end do
end function new_param_h0spec


!> Generator for the enhancement factor to for scaling Hamiltonian elements
subroutine get_hscale(self, mol, bas, hscale)
   !> Instance of the Hamiltonian specification
   class(param_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Scaling parameters for the Hamiltonian elements
   real(wp), intent(out) :: hscale(:, :, :, :)

   integer :: isp, jsp, izp, jzp, ish, jsh, il, jl, ir, jr
   real(wp) :: zi, zj, zij, den, enp, km

   hscale(:, :, :, :) = 0.0_wp

   associate(par => self%param%hamiltonian, record => self%param%record, irc => self%irc)
      do isp = 1, mol%nid
         izp = mol%num(isp)
         ir = irc(isp)
         do jsp = 1, mol%nid
            jzp = mol%num(jsp)
            jr = irc(jsp)
            den = (record(ir)%en - record(jr)%en)**2
            do ish = 1, bas%nsh_id(isp)
               il = bas%cgto(ish, isp)%ang
               do jsh = 1, bas%nsh_id(jsp)
                  jl = bas%cgto(jsh, jsp)%ang
                  zi = record(ir)%slater(ish)
                  zj = record(jr)%slater(jsh)
                  zij = (2*sqrt(zi*zj)/(zi+zj))**par%wexp
                  if (self%valence(ish, isp) .and. self%valence(jsh, jsp)) then
                     enp = 1.0_wp + par%enscale * den
                     km = par%kpair(jr, ir) * par%ksh(jl, il) * enp
                  else if (self%valence(ish, isp) .and. .not.self%valence(jsh, jsp)) then
                     km = 0.5_wp * (par%ksh(il, il) + par%kpol)
                  else if (.not.self%valence(ish, isp) .and. self%valence(jsh, jsp)) then
                     km = 0.5_wp * (par%ksh(jl, jl) + par%kpol)
                  else
                     km = par%kpol
                  end if
                  hscale(jsh, ish, jsp, isp) = zij * km
               end do
            end do
         end do
      end do
   end associate
end subroutine get_hscale


!> Generator for the self energy / atomic levels of the Hamiltonian
subroutine get_selfenergy(self, mol, bas, selfenergy)
   !> Instance of the Hamiltonian specification
   class(param_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Self energy / atomic levels
   real(wp), intent(out) :: selfenergy(:, :)

   integer :: isp, ir, ish

   selfenergy(:, :) = 0.0_wp

   associate(record => self%param%record, irc => self%irc)
      do isp = 1, mol%nid
         ir = irc(isp)
         do ish = 1, bas%nsh_id(isp)
            selfenergy(ish, isp) = record(ir)%levels(ish)
         end do
      end do
   end associate
end subroutine get_selfenergy


!> Generator of the coordination number dependent shift of the self energy
subroutine get_cnshift(self, mol, bas, kcn)
   !> Instance of the Hamiltonian specification
   class(param_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Coordination number dependent shift
   real(wp), intent(out) :: kcn(:, :)

   integer :: isp, ir, ish

   kcn(:, :) = 0.0_wp

   associate(record => self%param%record, irc => self%irc)
      do isp = 1, mol%nid
         ir = irc(isp)
         do ish = 1, bas%nsh_id(isp)
            kcn(ish, isp) = record(ir)%kcn(ish)
         end do
      end do
   end associate
end subroutine get_cnshift


!> Generator for the polynomial parameters for the distant dependent scaling
subroutine get_shpoly(self, mol, bas, shpoly)
   !> Instance of the Hamiltonian specification
   class(param_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Polynomial parameters for distant dependent scaleing
   real(wp), intent(out) :: shpoly(:, :)

   integer :: isp, ir, ish

   shpoly(:, :) = 0.0_wp

   associate(record => self%param%record, irc => self%irc)
      do isp = 1, mol%nid
         ir = irc(isp)
         do ish = 1, bas%nsh_id(isp)
            shpoly(ish, isp) = record(ir)%shpoly(ish)
         end do
      end do
   end associate
end subroutine get_shpoly


subroutine get_reference_occ(self, mol, bas, refocc)
   !> Instance of the Hamiltonian specification
   class(param_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Reference occupation numbers
   real(wp), intent(out) :: refocc(:, :)

   integer :: isp, ir, ish

   refocc(:, :) = 0.0_wp

   associate(record => self%param%record, irc => self%irc)
      do isp = 1, mol%nid
         ir = irc(isp)
         do ish = 1, bas%nsh_id(isp)
            refocc(ish, isp) = merge(record(ir)%refocc(ish), 0.0_wp, self%valence(ish, isp))
         end do
      end do
   end associate
end subroutine get_reference_occ


subroutine update(self, mol)
   class(xtb_calculator), intent(inout) :: self
   type(structure_type), intent(in) :: mol
end subroutine update


!> Add an interaction container
subroutine push_back(self, cont)
   !> Instance of the tight-binding calculator
   class(xtb_calculator), intent(inout) :: self
   !> Container to be added
   class(container_type), allocatable, intent(inout) :: cont

   if (.not.allocated(self%interactions)) allocate(self%interactions)

   call self%interactions%push_back(cont)
end subroutine push_back


!> Add a container
subroutine pop(self, cont, idx)
   !> Instance of the tight-binding calculator
   class(xtb_calculator), intent(inout) :: self
   !> Container to be removed
   class(container_type), allocatable, intent(out) :: cont
   !> Index to remove container from
   integer, intent(in), optional :: idx

   if (.not.allocated(self%interactions)) return

   call self%interactions%pop(cont, idx)
end subroutine pop


pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, max
   !> Instance of the electrostatic container
   class(xtb_calculator), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info()

   if (allocated(self%coulomb)) then
      info = max(info, self%coulomb%variable_info())
   end if

   if (allocated(self%dispersion)) then
      info = max(info, self%dispersion%variable_info())
   end if

   if (allocated(self%interactions)) then
      info = max(info, self%interactions%variable_info())
   end if

end function variable_info


!> Information on container
pure function info(self, verbosity, indent) result(str)
   !> Instance of the interaction container
   class(xtb_calculator), intent(in) :: self
   !> Verbosity level
   integer, intent(in) :: verbosity
   !> Indentation level
   character(len=*), intent(in) :: indent
   !> Information on the container
   character(len=:), allocatable :: str

   character(len=*), parameter :: nl = new_line('a')

   str = "xTB calculator"

   if (allocated(self%repulsion)) then
      str = str // nl // indent // self%repulsion%info(verbosity, indent)
   end if

   if (allocated(self%coulomb)) then
      str = str // nl // indent // self%coulomb%info(verbosity, indent)
   end if

   if (allocated(self%dispersion)) then
      str = str // nl // indent // self%dispersion%info(verbosity, indent)
   end if

   if (allocated(self%interactions)) then
      str = str // nl // indent // self%interactions%info(verbosity, indent)
   end if
end function info

end module tblite_xtb_calculator

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/coulomb/charge/type.f90
!> Provides a general base class for electrostatic interactions

!> General isotropic second-order electrostatics model
module tblite_coulomb_charge_type
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_blas, only : dot, gemv, symv
   use tblite_container_cache, only : container_cache
   use tblite_coulomb_cache, only : coulomb_cache
   use tblite_coulomb_type, only : coulomb_type
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private


   !> General second-order electrostatics
   type, public, extends(coulomb_type), abstract :: coulomb_charge_type
      !> Whether the third order contribution is shell-dependent
      logical :: shell_resolved
      !> Number of shells for each atom
      integer, allocatable :: nshell(:)
      !> Index offset for each shell
      integer, allocatable :: offset(:)
   contains
      !> Update container cache
      procedure :: update
      !> Get information about density dependent quantities used in the energy
      procedure :: variable_info
      !> Evaluate selfconsistent energy of the interaction
      procedure :: get_energy
      !> Evaluate charge dependent potential shift from the interaction
      procedure :: get_potential
      !> Evaluate gradient of the charge dependent potential shift from the interaction
      procedure :: get_potential_gradient
      !> Evaluate gradient contributions from the selfconsistent interaction
      procedure :: get_gradient
      !> Evaluate Coulomb matrix
      procedure(get_coulomb_matrix), deferred :: get_coulomb_matrix
      !> Evaluate uncontracted derivatives of Coulomb matrix
      procedure(get_coulomb_derivs), deferred :: get_coulomb_derivs
   end type coulomb_charge_type

   abstract interface
      !> Evaluate coulomb matrix
      subroutine get_coulomb_matrix(self, mol, cache, amat)
         import :: coulomb_charge_type, structure_type, coulomb_cache, wp
         !> Instance of the electrostatic container
         class(coulomb_charge_type), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Reusable data container
         type(coulomb_cache), intent(inout) :: cache
         !> Coulomb matrix
         real(wp), contiguous, intent(out) :: amat(:, :)
      end subroutine get_coulomb_matrix

      !> Evaluate uncontracted derivatives of Coulomb matrix
      subroutine get_coulomb_derivs(self, mol, cache, qat, qsh, dadr, dadL, atrace)
         import :: coulomb_charge_type, structure_type, coulomb_cache, wp
         !> Instance of the electrostatic container
         class(coulomb_charge_type), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Reusable data container
         type(coulomb_cache), intent(inout) :: cache
         !> Atomic partial charges
         real(wp), intent(in) :: qat(:)
         !> Shell-resolved partial charges
         real(wp), intent(in) :: qsh(:)
         !> Derivative of interactions with respect to cartesian displacements
         real(wp), contiguous, intent(out) :: dadr(:, :, :)
         !> Derivative of interactions with respect to strain deformations
         real(wp), contiguous, intent(out) :: dadL(:, :, :)
         !> On-site derivatives with respect to cartesian displacements
         real(wp), contiguous, intent(out) :: atrace(:, :)
      end subroutine get_coulomb_derivs
   end interface

contains


!> Update container cache
subroutine update(self, mol, cache)
   !> Instance of the electrostatic container
   class(coulomb_charge_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   type(coulomb_cache), pointer :: ptr

   call taint(cache, ptr)
   call ptr%update(mol)

   if (.not.allocated(ptr%amat)) then
      allocate(ptr%amat(sum(self%nshell), sum(self%nshell)))
   end if
   call self%get_coulomb_matrix(mol, ptr, ptr%amat)

   if (.not.allocated(ptr%vvec)) then
      allocate(ptr%vvec(sum(self%nshell)))
   end if

end subroutine update


!> Evaluate selfconsistent energy of the interaction
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the electrostatic container
   class(coulomb_charge_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)

   integer :: iat, ii, ish
   type(coulomb_cache), pointer :: ptr

   call view(cache, ptr)

   if(self%shell_resolved) then
      call symv(ptr%amat, wfn%qsh(:, 1), ptr%vvec, alpha=0.5_wp)
      do iat = 1, mol%nat
         ii = self%offset(iat)
         do ish = 1, self%nshell(iat)
            energies(iat) = energies(iat) + ptr%vvec(ii+ish) * wfn%qsh(ii+ish, 1)
         end do
      end do
   else
      call symv(ptr%amat, wfn%qat(:, 1), ptr%vvec, alpha=0.5_wp)
      do iat = 1, mol%nat
         ii = self%offset(iat)
         energies(iat) = energies(iat) + ptr%vvec(iat) * wfn%qat(iat, 1)
      end do
   end if
end subroutine get_energy


!> Evaluate charge dependent potential shift from the interaction
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the electrostatic container
   class(coulomb_charge_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   type(coulomb_cache), pointer :: ptr

   call view(cache, ptr)

   if(self%shell_resolved) then
      call symv(ptr%amat, wfn%qsh(:, 1), pot%vsh(:, 1), beta=1.0_wp)
   else
      call symv(ptr%amat, wfn%qat(:, 1), pot%vat(:, 1), beta=1.0_wp)
   end if

end subroutine get_potential


!> Evaluate gradient of the charge dependent potential shift 
subroutine get_potential_gradient(self, mol, cache, wfn, pot)
   !> Instance of the electrostatic container
   class(coulomb_charge_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   integer :: ic, jc, iat, ndim, ii, ish
   real(wp), allocatable :: dadr(:, :, :), dadL(:, :, :), datr(:, :), tmpdq(:)
   type(coulomb_cache), pointer :: ptr

   call view(cache, ptr)

   ndim = sum(self%nshell)
   allocate(dadr(3, mol%nat, ndim), dadL(3, 3, ndim), datr(3, ndim), tmpdq(ndim))

   ! Get derivatives of the Coulomb matrix already contracted with the atom-resolved charges
   call self%get_coulomb_derivs(mol, ptr, wfn%qat(:, 1), wfn%qsh(:, 1), dadr, dadL, datr)

   if(self%shell_resolved) then
      ! Off-diagonal Coulomb matrix derivative
      pot%dvshdr(:, :, :, 1) = dadr
      
      do ic = 1, 3 
         do iat = 1, mol%nat
            ii = self%offset(iat)
            do ish = 1, self%nshell(iat)
               ! Diagonal Coulomb matrix derivative
               pot%dvshdr(ic, iat, ii+ish, 1) = - sum(dadr(ic, :, ii+ish))
            end do 
            ! Charge derivative
            tmpdq = wfn%dqshdr(ic, iat, :, 1)
            call symv(ptr%amat, tmpdq, pot%dvshdr(ic, iat, :, 1), beta=1.0_wp)
         end do
         
         ! Coulomb matrix derivative 
         pot%dvshdL(ic, :, :, 1) = pot%dvshdL(ic, :, :, 1) + dadL(ic, :, :)
         do jc = 1, 3
            ! Charge derivative
            tmpdq = wfn%dqshdL(ic, jc, :, 1)
            call symv(ptr%amat, tmpdq, pot%dvshdL(ic, jc, :, 1), beta=1.0_wp)
         end do
      end do

   else
      ! Off-diagonal Coulomb matrix derivative
      pot%dvatdr(:, :, :, 1) = dadr

      do ic = 1, 3 
         do iat = 1, mol%nat
            ! Diagonal Coulomb matrix derivative
            pot%dvatdr(ic, iat, iat, 1) = - sum(dadr(ic, :, iat))

            ! Charge derivative
            tmpdq = wfn%dqatdr(ic, iat, :, 1)
            call symv(ptr%amat, tmpdq, pot%dvatdr(ic, iat, :, 1), beta=1.0_wp)
         end do
         
         ! Coulomb matrix derivative 
         pot%dvatdL(ic, :, :, 1) = pot%dvatdL(ic, :, :, 1) + dadL(ic, :, :)
         do jc = 1, 3
            ! Charge derivative
            tmpdq = wfn%dqatdL(ic, jc, :, 1)
            call symv(ptr%amat, tmpdq, pot%dvatdL(ic, jc, :, 1), beta=1.0_wp)
         end do
      end do
   end if

end subroutine get_potential_gradient


!> Evaluate gradient contributions from the selfconsistent interaction
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the electrostatic container
   class(coulomb_charge_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the repulsion energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   integer :: ndim
   real(wp), allocatable :: dadr(:, :, :), dadL(:, :, :), datr(:, :)
   type(coulomb_cache), pointer :: ptr

   call view(cache, ptr)

   ndim = sum(self%nshell)
   allocate(dadr(3, mol%nat, ndim), dadL(3, 3, ndim), datr(3, ndim))

   call self%get_coulomb_derivs(mol, ptr, wfn%qat(:, 1), wfn%qsh(:, 1), dadr, dadL, datr)

   call gemv(dadr, wfn%qsh(:, 1), gradient, beta=1.0_wp)
   call gemv(dadL, wfn%qsh(:, 1), sigma, beta=1.0_wp, alpha=0.5_wp)

end subroutine get_gradient


!> Get information about density dependent quantities used in the energy
pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, atom_resolved, shell_resolved
   !> Instance of the electrostatic container
   class(coulomb_charge_type), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=merge(shell_resolved, atom_resolved, self%shell_resolved))
end function variable_info


!> Inspect container cache and reallocate it in case of type mismatch
subroutine taint(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(coulomb_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(coulomb_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

!> Return reference to container cache after resolving its type
subroutine view(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(coulomb_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(coulomb_cache)
      ptr => target
   end select
end subroutine view


end module tblite_coulomb_charge_type

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/api/table.f90
!> Provides API exports for the #tblite_table handle.

!> API export for managing data tables
module tblite_api_table
   use, intrinsic :: iso_c_binding
   use mctc_env, only : fatal_error
   use tblite_api_error, only : vp_error
   use tblite_api_version, only : namespace
   use tblite_api_utils, only : c_f_character, strlen
   use tblite_toml, only : toml_table, toml_array, toml_value, add_array, set_value, get_value
   implicit none
   private

   public :: vp_table
   public :: new_table_api, delete_table_api
   public :: table_set_double_api, table_set_int64_t_api, table_set_bool_api, &
      & table_set_char_api, table_add_table_api

   !> Void pointer to manage general data tables
   type :: vp_table
      !> Actual payload
      type(toml_table), pointer :: ptr
      !> Data is owned by the object
      logical :: owned
   end type vp_table

   logical, parameter :: debug = .false.

contains

!> Create data table reference object
function new_table_api(vtable) &
      & result(vval) &
      & bind(C, name=namespace//"new_table")
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   type(vp_table), pointer :: val
   type(c_ptr) :: vval
   type(toml_table), pointer :: dat

   if (debug) print '("[Info]", 1x, a)', "new_table"

   allocate(val)
   if (c_associated(vtable)) then
      call c_f_pointer(vtable, table)
      val%ptr => table%ptr
      val%owned = .false.
   else
      allocate(dat)
      dat = toml_table()
      val%ptr => dat
      val%owned = .true.
   end if
   vval = c_loc(val)
end function new_table_api

!> Delete data table object
subroutine delete_table_api(vtable) &
      & bind(C, name=namespace//"delete_table")
   type(c_ptr), intent(inout) :: vtable
   type(vp_table), pointer :: table

   if (debug) print '("[Info]", 1x, a)', "delete_table"

   if (c_associated(vtable)) then
      call c_f_pointer(vtable, table)

      if (table%owned) deallocate(table%ptr)
      deallocate(table)
      vtable = c_null_ptr
   end if

end subroutine delete_table_api

subroutine table_set_double_api(verror, vtable, ckey, val, n) &
      & bind(C, name=namespace//"table_set_double")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   real(c_double), intent(in) :: val(*)
   integer(c_int), value :: n
   type(toml_array), pointer :: array
   integer :: i, stat

   if (debug) print '("[Info]", 1x, a)', "table_set_double"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)

   if (table%ptr%has_key(key)) call table%ptr%delete(key)

   if (n > 0) then
      call add_array(table%ptr, key, array)
      do i = 1, n
         call set_value(array, i, val(i), stat=stat)
         if (stat /= 0) exit
      end do
   else
      call set_value(table%ptr, key, val(1), stat=stat)
   end if

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back double value(s) to data table")
   end if
end subroutine table_set_double_api

subroutine table_set_int64_t_api(verror, vtable, ckey, val, n) &
      & bind(C, name=namespace//"table_set_int64_t")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   integer(c_int64_t), intent(in) :: val(*)
   integer(c_int), value :: n
   type(toml_array), pointer :: array
   integer :: i, stat

   if (debug) print '("[Info]", 1x, a)', "table_set_int64_t"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)

   if (table%ptr%has_key(key)) call table%ptr%delete(key)

   if (n > 0) then
      call add_array(table%ptr, key, array)
      do i = 1, n
         call set_value(array, i, val(i), stat=stat)
         if (stat /= 0) exit
      end do
   else
      call set_value(table%ptr, key, val(1), stat=stat)
   end if

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back integer value(s) to data table")
   end if
end subroutine table_set_int64_t_api

subroutine table_set_bool_api(verror, vtable, ckey, val, n) &
      & bind(C, name=namespace//"table_set_bool")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   logical(c_bool), intent(in) :: val(*)
   integer(c_int), value :: n
   type(toml_array), pointer :: array
   integer :: i, stat

   if (debug) print '("[Info]", 1x, a)', "table_set_bool"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)

   if (table%ptr%has_key(key)) call table%ptr%delete(key)

   if (n > 0) then
      call add_array(table%ptr, key, array)
      do i = 1, n
         call set_value(array, i, merge(.true., .false., val(i)), stat=stat)
         if (stat /= 0) exit
      end do
   else
      call set_value(table%ptr, key, merge(.true., .false., val(1)), stat=stat)
   end if

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back boolean value(s) to data table")
   end if
end subroutine table_set_bool_api

subroutine table_set_char_api(verror, vtable, ckey, cval, n) &
      & bind(C, name=namespace//"table_set_char")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key, val
   type(c_ptr), value :: cval
   character(kind=c_char), pointer :: carr(:, :)
   integer(c_int), value :: n
   type(toml_array), pointer :: array
   integer :: i, stat

   if (debug) print '("[Info]", 1x, a)', "table_set_char"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)
   call c_f_pointer(cval, carr, [strlen(cval)+1, max(n, 1)])

   if (table%ptr%has_key(key)) call table%ptr%delete(key)

   if (n > 0) then
      call add_array(table%ptr, key, array)
      do i = 1, n
         call c_f_character(carr(:, i), val)
         call set_value(array, i, val, stat=stat)
         if (stat /= 0) exit
      end do
   else
      call c_f_character(carr(:, 1), val)
      call set_value(table%ptr, key, val, stat=stat)
   end if

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back character string to data table")
   end if
end subroutine table_set_char_api

function table_add_table_api(verror, vtable, ckey) &
      & result(vval) &
      & bind(C, name=namespace//"table_add_table")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   type(c_ptr) :: vval
   type(vp_table), pointer :: val
   type(toml_table), pointer :: tmp
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "table_add_table"

   vval = c_null_ptr
   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   vval = new_table_api(vtable)
   call c_f_pointer(vtable, table)
   call c_f_pointer(vval, val)
   call c_f_character(ckey, key)

   call get_value(table%ptr, key, tmp, stat=stat)
   val%ptr => tmp

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back subtable to data table")
      call delete_table_api(vval)
   end if
end function table_add_table_api


end module tblite_api_table

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_solvation_ddx
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type, new
   use mstore, only : get_structure
   use tblite_container, only : container_cache
   use tblite_scf_potential, only : potential_type
   use tblite_solvation_ddx, only : ddx_solvation, ddx_solvation_model, ddx_input, new_ddx
   use tblite_wavefunction, only : wavefunction_type, new_wavefunction, eeq_guess
   use tblite_basis_type, only : basis_type
   use tblite_integral_type, only : integral_type
   use tblite_context_type, only : context_type
   use tblite_features, only : get_tblite_feature
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator
   use tblite_xtb_singlepoint, only : xtb_singlepoint

   implicit none
   private

   public :: collect_solvation_ddx

   real(wp), parameter :: acc = 0.01_wp
   real(wp), parameter :: thr = 5e+6_wp*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = 10*sqrt(epsilon(1.0_wp))
   real(wp), parameter :: kt = 300.0_wp * 3.166808578545117e-06_wp


contains


!> Collect all exported unit tests
subroutine collect_solvation_ddx(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   if (get_tblite_feature("ddx")) then
      testsuite = [ &
         new_unittest("energy-mol-cosmo", test_e_cosmo_m01), &
         new_unittest("energy-mol-cpcm", test_e_cpcm_m01), &
         new_unittest("energy-mol-pcm", test_e_pcm_m01), &
         new_unittest("gradient-mol-num-cosmo", test_g_cosmo_m02), &
         new_unittest("gradient-mol-num-cpcm", test_g_cpcm_m02), &
         new_unittest("gradient-mol-num-pcm", test_g_pcm_m02), &
         new_unittest("potential-mol-cosmo", test_p_cosmo_m03), &
         new_unittest("potential-mol-cpcm", test_p_cpcm_m03), &
         new_unittest("potential-mol-pcm", test_p_pcm_m03) &
         ]
   else
      testsuite = [new_unittest("ddx-disabled", test_ddx_disabled)]
   end if

end subroutine collect_solvation_ddx

subroutine test_ddx_disabled(error)
   type(error_type), allocatable, intent(out) :: error

   call check(error, .not.get_tblite_feature("ddx"), "ddX feature is unexpectedly enabled")
end subroutine test_ddx_disabled


subroutine test_e(error, model, mol, qat, ref)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Solvation model (COSMO=100, CPCM=101, PCM=200)
   integer, intent(in) :: model

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Reference energy
   real(wp), intent(in) :: ref

   type(ddx_solvation) :: solv
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: eps = 80.0_wp
   integer, parameter :: nang = 302
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp) :: energy(mol%nat)

   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1), source=0.0_wp)
   energy = 0.0_wp

   call new_ddx(solv, mol, ddx_input(ddx_model=model, dielectric_const=eps, nang=nang), error)
   if (allocated(error)) return

   call solv%update(mol, cache)
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)

   if (abs(sum(energy) - ref) > thr) then
      call test_failed(error, "Energy does not match reference")
      print '(a)', 'Energy:'
      print '(3es20.13)', sum(energy)
      print '(a)', "---"
      print '(a)', 'Reference:'
      print '(3es20.13)', ref
      print '(a)', "---"
      print '(a)', 'Difference:'
      print '(3es20.13)', sum(energy) - ref
   end if
end subroutine test_e


subroutine test_g(error, model, mol, qat)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Solvation model (COSMO=100, CPCM=101, PCM=200)
   integer, intent(in) :: model

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   type(ddx_solvation) :: solv
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: eps = 80.0_wp
   integer, parameter :: nang = 302
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp)) 
   real(wp), allocatable :: gradient(:, :), numg(:, :)
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat), sigma(3, 3)
   integer :: ii, ic

   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))

   call new_ddx(solv, mol, ddx_input(ddx_model=model, dielectric_const=eps, nang=nang), error)
   if (allocated(error)) return

   allocate(numg(3, mol%nat), gradient(3, mol%nat))
   do ii = 1, mol%nat
      do ic = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(ic, ii) = mol%xyz(ic, ii) + step
         call solv%update(mol, cache)
         call solv%get_potential(mol, cache, wfn, pot)
         call solv%get_energy(mol, cache, wfn, er)

         mol%xyz(ic, ii) = mol%xyz(ic, ii) - 2*step
         call solv%update(mol, cache)
         call solv%get_potential(mol, cache, wfn, pot)
         call solv%get_energy(mol, cache, wfn, el)

         mol%xyz(ic, ii) = mol%xyz(ic, ii) + step
         numg(ic, ii) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp

   call solv%update(mol, cache)
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)
   call solv%get_gradient(mol, cache, wfn, gradient, sigma)

   if (any(abs(gradient - numg) > thr)) then
      call test_failed(error, "Gradient does not match")
      print '(3es20.13)', gradient
      print '(a)', "---"
      print '(3es20.13)', numg
      print '(a)', "---"
      print '(3es20.13)', gradient - numg
   end if
end subroutine test_g

subroutine test_p(error, model, mol, qat)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Solvation model (COSMO=100, CPCM=101, PCM=200)
   integer, intent(in) :: model

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   type(ddx_solvation) :: solv
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache), allocatable :: cache
   real(wp), parameter :: eps = 80.0_wp
   integer, parameter :: nang = 302
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp), parameter :: thr = 1e+3_wp*sqrt(epsilon(1.0_wp))
   real(wp), allocatable :: vat(:)
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat)
   integer :: ii

   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))

   call new_ddx(solv, mol, ddx_input(ddx_model=model, dielectric_const=eps, nang=nang), error)
   if (allocated(error)) return

   allocate(cache)
   call solv%update(mol, cache)

   allocate(vat(mol%nat))
   do ii = 1, mol%nat
      er = 0.0_wp
      el = 0.0_wp
      wfn%qat(ii, 1) = wfn%qat(ii, 1) + step
      call solv%get_potential(mol, cache, wfn, pot)
      call solv%get_energy(mol, cache, wfn, er)

      wfn%qat(ii, 1) = wfn%qat(ii, 1) - 2*step
      call solv%get_potential(mol, cache, wfn, pot)
      call solv%get_energy(mol, cache, wfn, el)

      wfn%qat(ii, 1) = wfn%qat(ii, 1) + step
      vat(ii) = 0.5_wp*(sum(er) - sum(el))/step
   end do

   energy = 0.0_wp
   pot%vat(:, :) = 0.0_wp
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)

   if (any(abs([pot%vat] - vat) > thr)) then
      call test_failed(error, "Potential does not match")
      print '(a)', 'analytical'
      print '(3es20.13)', pot%vat
      print '(a)', "---"
      print '(a)', 'numerical'
      print '(3es20.13)', vat
      print '(a)', "---"
      print '(a)', 'diff'
      print '(3es20.13)', [pot%vat] - vat
   end if
end subroutine test_p


subroutine test_e_cosmo_m01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 7.73347900345264E-1_wp, 1.07626888948184E-1_wp,-3.66999593831010E-1_wp,&
      & 4.92833325937897E-2_wp,-1.83332156197733E-1_wp, 2.33302086605469E-1_wp,&
      & 6.61837152062315E-2_wp,-5.43944165050002E-1_wp,-2.70264356583716E-1_wp,&
      & 2.66618968841682E-1_wp, 2.62725033202480E-1_wp,-7.15315510172571E-2_wp,&
      &-3.73300777019193E-1_wp, 3.84585237785621E-2_wp,-5.05851088366940E-1_wp,&
      & 5.17677238544189E-1_wp]

   call get_structure(mol, "MB16-43", "01")
   call test_e(error, ddx_solvation_model%cosmo, mol, qat, -3.4697720884118800E-2_wp)

end subroutine test_e_cosmo_m01

subroutine test_e_cpcm_m01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 7.73347900345264E-1_wp, 1.07626888948184E-1_wp,-3.66999593831010E-1_wp,&
      & 4.92833325937897E-2_wp,-1.83332156197733E-1_wp, 2.33302086605469E-1_wp,&
      & 6.61837152062315E-2_wp,-5.43944165050002E-1_wp,-2.70264356583716E-1_wp,&
      & 2.66618968841682E-1_wp, 2.62725033202480E-1_wp,-7.15315510172571E-2_wp,&
      &-3.73300777019193E-1_wp, 3.84585237785621E-2_wp,-5.05851088366940E-1_wp,&
      & 5.17677238544189E-1_wp]

   call get_structure(mol, "MB16-43", "01")
   call test_e(error, ddx_solvation_model%cpcm, mol, qat, -3.4914581639644553E-002_wp)

end subroutine test_e_cpcm_m01

subroutine test_e_pcm_m01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 7.73347900345264E-1_wp, 1.07626888948184E-1_wp,-3.66999593831010E-1_wp,&
      & 4.92833325937897E-2_wp,-1.83332156197733E-1_wp, 2.33302086605469E-1_wp,&
      & 6.61837152062315E-2_wp,-5.43944165050002E-1_wp,-2.70264356583716E-1_wp,&
      & 2.66618968841682E-1_wp, 2.62725033202480E-1_wp,-7.15315510172571E-2_wp,&
      &-3.73300777019193E-1_wp, 3.84585237785621E-2_wp,-5.05851088366940E-1_wp,&
      & 5.17677238544189E-1_wp]

   call get_structure(mol, "MB16-43", "01")
   call test_e(error, ddx_solvation_model%pcm, mol, qat, -3.3624259293951506E-2_wp)

end subroutine test_e_pcm_m01

subroutine test_g_cosmo_m02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 2.50000000000000E-1_wp,-2.50000000000000E-1_wp, 5.00000000000000E-1_wp,&
      &-5.00000000000000E-1_wp]

   call get_structure(mol, "Heavy28", "bih3")
   call test_g(error, ddx_solvation_model%cosmo, mol, qat)

end subroutine test_g_cosmo_m02

subroutine test_g_cpcm_m02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 2.50000000000000E-1_wp,-2.50000000000000E-1_wp, 5.00000000000000E-1_wp,&
      &-5.00000000000000E-1_wp]

   call get_structure(mol, "Heavy28", "bih3")
   call test_g(error, ddx_solvation_model%cpcm, mol, qat)

end subroutine test_g_cpcm_m02

subroutine test_g_pcm_m02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 2.50000000000000E-1_wp,-2.50000000000000E-1_wp, 5.00000000000000E-1_wp,&
      &-5.00000000000000E-1_wp]

   call get_structure(mol, "Heavy28", "bih3")
   call test_g(error, ddx_solvation_model%pcm, mol, qat)

end subroutine test_g_pcm_m02

subroutine test_p_cosmo_m03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 2.50000000000000E-1_wp,-2.50000000000000E-1_wp, 5.00000000000000E-1_wp,&
      &-5.00000000000000E-1_wp]

   call get_structure(mol, "Heavy28", "bih3")
   call test_p(error, ddx_solvation_model%cosmo, mol, qat)

end subroutine test_p_cosmo_m03

subroutine test_p_cpcm_m03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 2.50000000000000E-1_wp,-2.50000000000000E-1_wp, 5.00000000000000E-1_wp,&
      &-5.00000000000000E-1_wp]

   call get_structure(mol, "Heavy28", "bih3")
   call test_p(error, ddx_solvation_model%cpcm, mol, qat)

end subroutine test_p_cpcm_m03

subroutine test_p_pcm_m03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 2.50000000000000E-1_wp,-2.50000000000000E-1_wp, 5.00000000000000E-1_wp,&
      &-5.00000000000000E-1_wp]

   call get_structure(mol, "Heavy28", "bih3")
   call test_p(error, ddx_solvation_model%pcm, mol, qat)

end subroutine test_p_pcm_m03


end module test_solvation_ddx

! This file is part of multicharge.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module multicharge_param
   use mctc_env, only: error_type, wp
   use mctc_io, only: structure_type
   use mctc_io_convert, only: autoaa
   use mctc_data, only: get_covalent_rad, get_pauling_en, get_vdw_rad
   use multicharge_model, only: mchrg_model_type, &
      & new_eeq_model, eeq_model, new_eeqbc_model, eeqbc_model
   use multicharge_param_eeq2019, only: get_eeq_chi, get_eeq_eta, &
      & get_eeq_rad, get_eeq_kcnchi
   use multicharge_param_eeqbc2025, only: get_eeqbc_chi, get_eeqbc_eta, &
      & get_eeqbc_rad, get_eeqbc_kcnchi, get_eeqbc_kqchi, get_eeqbc_kqeta, &
      & get_eeqbc_cap, get_eeqbc_cov_radii, get_eeqbc_avg_cn
   implicit none
   private

   public :: new_eeq2019_model, new_eeqbc2025_model, mchrg_model

   !> Possible charge models enumerator
   type :: TMchargeModelEnum
      !> Classic electronegativity equilibration model
      integer :: eeq2019 = 1
      !> Bond-capacitor corrected electronegativity equilibration model
      integer :: eeqbc2025 = 2
   end type TMchargeModelEnum

   !> Actual charge model enumerator
   type(TMchargeModelEnum), parameter :: mchrg_model = TMchargeModelEnum()

contains

subroutine new_eeq2019_model(mol, model, error)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Electronegativity equilibration model
   class(mchrg_model_type), allocatable, intent(out) :: model
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), parameter :: cn_exp = 7.5_wp
   real(wp), parameter :: cn_max = 8.0_wp

   real(wp), allocatable :: chi(:), eta(:), kcnchi(:), rad(:), rcov(:)
   type(eeq_model), allocatable :: eeq

   chi = get_eeq_chi(mol%num)
   eta = get_eeq_eta(mol%num)
   kcnchi = get_eeq_kcnchi(mol%num)
   rad = get_eeq_rad(mol%num)
   rcov = get_covalent_rad(mol%num)

   allocate(eeq)
   call new_eeq_model(eeq, mol=mol, error=error, chi=chi, &
      & rad=rad, eta=eta, kcnchi=kcnchi, cutoff=cutoff, &
      & cn_exp=cn_exp, rcov=rcov, cn_max=cn_max)
   call move_alloc(eeq, model)

end subroutine new_eeq2019_model

subroutine new_eeqbc2025_model(mol, model, error)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Electronegativity equilibration model
   class(mchrg_model_type), allocatable, intent(out) :: model
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: kcnrad = 0.14_wp
   real(wp), parameter :: kbc = 0.60_wp
   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), parameter :: cn_exp = 2.0_wp
   real(wp), parameter :: norm_exp = 0.75_wp

   real(wp), allocatable :: chi(:), eta(:), rad(:), kcnchi(:), &
      & kqchi(:), kqeta(:), cap(:), rcov(:), avg_cn(:), en(:), &
      & rvdw(:, :)
   type(eeqbc_model), allocatable :: eeqbc

   chi = get_eeqbc_chi(mol%num)
   eta = get_eeqbc_eta(mol%num)
   rad = get_eeqbc_rad(mol%num)
   kcnchi = get_eeqbc_kcnchi(mol%num)
   kqchi = get_eeqbc_kqchi(mol%num)
   kqeta = get_eeqbc_kqeta(mol%num)
   cap = get_eeqbc_cap(mol%num)
   rcov = get_eeqbc_cov_radii(mol%num)
   avg_cn = get_eeqbc_avg_cn(mol%num)
   ! Electronegativities normalized to Fluorine
   ! with actinides (Th-Lr) set to average of 1.30
   en = get_pauling_en(mol%num)
   en = merge(en, 1.30_wp, mol%num < 90)
   en = merge(0.80_wp, en, mol%num == 87)
   en = merge(1.00_wp, en, mol%num == 89)
   en = merge(1.10_wp, en, mol%num == 90 .or. mol%num == 91 &
      &.or. mol%num == 92 .or. mol%num == 95)
   en = merge(1.20_wp, en, mol%num == 93 .or. mol%num == 94 &
      &.or. mol%num == 97 .or. mol%num == 103)
   en = en / 3.98_wp
   rvdw = get_vdw_rad(spread(mol%num(mol%id), 2, mol%nat), &
      & spread(mol%num(mol%id), 1, mol%nat)) * autoaa

   allocate(eeqbc)
   call new_eeqbc_model(eeqbc, mol=mol, error=error, chi=chi, &
      & rad=rad, eta=eta, kcnchi=kcnchi, kqchi=kqchi, kqeta=kqeta, &
      & kcnrad=kcnrad, cap=cap, avg_cn=avg_cn, rvdw=rvdw, kbc=kbc, &
      & cutoff=cutoff, cn_exp=cn_exp, rcov=rcov, en=en, &
      & norm_exp=norm_exp)
   call move_alloc(eeqbc, model)

end subroutine new_eeqbc2025_model

end module multicharge_param

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!
!      888      888  .d8888b.   .d88888b.   .d8888b.  888b     d888  .d88888b.
!      888      888 d88P  Y88b d88P" "Y88b d88P  Y88b 8888b   d8888 d88P" "Y88b
!      888      888 888    888 888     888 Y88b.      88888b.d88888 888     888
!  .d88888  .d88888 888        888     888  "Y888b.   888Y88888P888 888     888
! d88" 888 d88" 888 888        888     888     "Y88b. 888 Y888P 888 888     888
! 888  888 888  888 888    888 888     888       "888 888  Y8P  888 888     888
! Y88b 888 Y88b 888 Y88b  d88P Y88b. .d88P Y88b  d88P 888   "   888 Y88b. .d88P
!  "Y88888  "Y88888  "Y8888P"   "Y88888P"   "Y8888P"  888       888  "Y88888P"
!
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  COPYRIGHT (C) 2015 by Filippo Lipparini, Benjamin Stamm, Paolo Gatto        !
!  Eric Cancès, Yvon Maday, Jean-Philip Piquemal, Louis Lagardère and          !
!  Benedetta Mennucci.                                                         !
!                             ALL RIGHT RESERVED.                              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!> @file tblite/solvation/cpcm_dd.f90
!> Provides a domain decomposition solver for the conductor like screening model.
!
!> A modular implementation of COSMO using a domain decomposition linear scaling
!> strategy.
!
! This code is governed by the LGPL license and abiding by the rules of
! distribution of free software.
! This program is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.
! See the GNU Lesser General Public License for more details.
!
! Users of this code are asked to include the following references in their
! publications:
!
! [1] E. Cancès, Y. Maday, B. Stamm
!     "Domain decomposition for implicit solvation models"
!     J. Chem. Phys. 139, 054111 (2013)
!
! [2] F. Lipparini, B. Stamm, E. Cancès, Y. Maday, B. Mennucci
!     "Fast Domain Decomposition Algorithm for Continuum Solvation Models:
!      Energy and First Derivatives"
!     J. Chem. Theory Comput. 9, 3637–3648 (2013)
!
! Also, include one of the three following reference depending on whether you
! use this code in conjunction with a QM [3], Semiempirical [4] or Classical [5]
! description of the solute:
!
! [3] F. Lipparini, G. Scalmani, L. Lagardère, B. Stamm, E. Cancès, Y. Maday,
!     J.-P. Piquemal, M. J. Frisch, B. Mennucci
!     "Quantum, classical, and hybrid QM/MM calculations in solution: General
!      implementation of the ddCOSMO linear scaling strategy"
!     J. Chem. Phys. 141, 184108 (2014)
!     (for quantum mechanical models)
!
! [4] F. Lipparini, L. Lagardère, G. Scalmani, B. Stamm, E. Cancès, Y. Maday,
!     J.-P. Piquemal, M. J. Frisch, B. Mennucci
!     "Quantum Calculations in Solution for Large to Very Large Molecules:
!      A New Linear Scaling QM/Continuum Approach"
!     J. Phys. Chem. Lett. 5, 953-958 (2014)
!     (for semiempirical models)
!
! [5] F. Lipparini, L. Lagardère, C. Raynaud, B. Stamm, E. Cancès, B. Mennucci
!     M. Schnieders, P. Ren, Y. Maday, J.-P. Piquemal
!     "Polarizable Molecular Dynamics in a Polarizable Continuum Solvent"
!     J. Chem. Theory Comput. 11, 623-634 (2015)
!     (for classical models, including polarizable force fields
!
! The users of this code should also include the appropriate reference to the
! COSMO model. This distribution includes the routines to generate lebedev
! grids by D. Laikov and C. van Wuellen, as publicly available on CCL. If the
! routines are used, the following reference should also be included:
!
! [6] V.I. Lebedev, and D.N. Laikov
!     "A quadrature formula for the sphere of the 131st
!      algebraic order of accuracy"
!     Doklady Mathematics, Vol. 59, No. 3, 1999, pp. 477-481.
!
! Written by Filippo Lipparini, October 2015.
! Adapted by Sebastian Ehlert, June 2020.
module tblite_solvation_cpcm_dd
   use tblite_adjlist, only : adjacency_list
   implicit none
   private

   public :: domain_decomposition, domain_decomposition_input, new_domain_decomposition
   public :: hsnorm, calcv, intrhs, prtsph, adjrhs, wghpot, ddupdate, fdoka, fdokb, fdoga
   public :: solve_cosmo_direct, solve_cosmo_adjoint, jacobi_diis, lx, lstarx, ldm1x, hnorm
   public :: get_deriv, get_zeta


   integer, parameter :: wp = selected_real_kind(15)
   integer, parameter :: ndiis=25, iout=6, nngmax=100
   real(wp), parameter :: se = -1.0_wp
   real(wp), parameter :: pi = 4.0_wp*atan(1.0_wp), fourpi = 4*pi
   real(wp), parameter :: sq2 = sqrt(2.0_wp)


   !> Quantities contained in control file
   type :: domain_decomposition_input

      !> Max angular momentum of spherical harmonics basis
      integer :: lmax

      !> Threshold for iterative solver
      real(wp) :: conv

      !> Regularization parameters
      real(wp) :: eta

   end type domain_decomposition_input


   !> Cosmo calculator
   type :: domain_decomposition

      !> Printing flag
      integer :: iprint

      !> Max angular momentum of spherical harmonics basis
      integer :: lmax

      !> Desired number of Lebedev integration points
      integer :: ngrid

      !> Threshold for iterative solver
      real(wp) :: conv

      !> Regularization parameters
      real(wp) :: eta

      !> Number of spheres/atoms
      integer :: nat

      !> Number of integration points on cavity's boundary
      integer :: ncav

      !> Number of basis functions, i.e., spherical harmonics
      integer :: nylm

      !> Workspaces
      logical :: grad
      integer, allocatable :: inl(:), nl(:)
      real(wp), allocatable :: rvdw(:), xyz(:, :), ccav(:, :)
      real(wp), allocatable :: w(:), grid(:, :), basis(:, :)
      real(wp), allocatable :: fact(:), facl(:), facs(:)
      real(wp), allocatable :: fi(:, :), ui(:, :), zi(:, :, :)

   end type domain_decomposition


contains


!> Initialize data structure
!
!  allocate the various arrays needed for ddcosmo,
!  assemble the cavity and the various associated geometrical quantities.
subroutine new_domain_decomposition(self, input, rvdw, wang, grid)

   character(len=*), parameter :: source = 'ddcosmo_core::new_domain_decomposition'
   type(domain_decomposition), intent(out) :: self
   type(domain_decomposition_input), intent(in) :: input
   real(wp), intent(in) :: rvdw(:)
   real(wp), intent(in) :: wang(:), grid(:, :)

   integer :: i, l, ind, m
   real(wp) :: fl, ffl, fnorm

   real(wp), allocatable :: vcos(:), vsin(:), vplm(:)

   self%nat = size(rvdw)
   self%ngrid = size(wang)
   self%iprint = 0
   self%lmax = input%lmax
   self%conv = input%conv
   self%eta = input%eta

   ! allocate:
   self%grad   = .true.
   self%nylm   = (self%lmax+1)*(self%lmax+1)
   allocate(self%rvdw(self%nat), self%xyz(3, self%nat), self%w(self%ngrid), &
      & self%grid(3, self%ngrid), self%basis(self%nylm, self%ngrid), &
      & self%inl(self%nat+1), self%nl(self%nat*nngmax), &
      & self%fi(self%ngrid, self%nat), self%ui(self%ngrid, self%nat), &
      & self%fact(max(2*self%lmax+1, 2)), self%facl(self%nylm), &
      & self%facs(self%nylm))
   if (self%grad) allocate(self%zi(3, self%ngrid, self%nat))

   ! precompute various quantities (diagonal blocks of ddcosmo matrix,
   ! normalization factors for spherical harmonics, factorials)
   self%fact(1) = 1.0_wp
   self%fact(2) = 1.0_wp
   do i = 3, 2*self%lmax + 1
      self%fact(i) = real(i-1, wp)*self%fact(i-1)
   end do

   do l = 0, self%lmax
      ind = l*l + l + 1
      fl  = (2.0_wp*real(l, wp) + 1.0_wp)/(4.0_wp*pi)
      ffl = sqrt(fl)
      self%facl(ind-l:ind+l) = fl
      self%facs(ind) = ffl
      do m = 1, l
         fnorm = sq2*ffl*sqrt(self%fact(l-m+1)/self%fact(l+m+1))
         if (mod(m, 2) == 1) fnorm = -fnorm
         self%facs(ind+m) = fnorm
         self%facs(ind-m) = fnorm
      end do
   end do

   ! copy the angular grid:
   self%grid = grid
   ! scaling because the weights are normalised
   self%w = wang * fourpi

   ! set the centers and radii of the spheres:
   self%rvdw(:) = rvdw

   ! build a basis of spherical harmonics at the griwpoints:
   allocate(vplm(self%nylm), vcos(self%lmax+1), vsin(self%lmax+1))
   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(self) private(i, vplm, vcos, vsin)
   do i = 1, self%ngrid
      call ylmbas(self, self%grid(:, i), self%basis(:, i), vplm, vcos, vsin)
   end do
   deallocate(vplm, vcos, vsin)

   if (self%iprint >= 4) then
      call prtsph(self, 'facs', 1, 0, self%facs)
      call prtsph(self, 'facl', 1, 0, self%facl)
      call prtsph(self, 'basis', self%ngrid, 0, self%basis)
      call ptcart(self, 'grid', 3, 0, self%grid)
      call ptcart(self, 'weights', 1, 0, self%w)
   end if

end subroutine new_domain_decomposition


subroutine ddupdate(self, xyz)

   type(domain_decomposition), intent(inout) :: self

   real(wp), intent(in) :: xyz(:, :)

   self%xyz(:, :) = xyz

   call mknnl(self)
   call mkfiui(self)
   call mkccav(self)

end subroutine ddupdate


! build neighbors list (CSR format)
!
!  \\  jat  |
! iat   \\  |  1   2   3   4   5   6
! -----------------------------------
!         1 |      x       x   x
!         2 |  x       x       x   x
!         3 |      x       x       x
!         4 |  x       x       x   x
!         5 |  x   x       x
!         6 |      x   x   x
!
!
!  inl =  1,       4,          8,      11,         15,      18, 21        pointer to 1st neighbor
!
!         |        |           |        |           |        |
!         v        V           V        V           V        V
!
!         1| 2| 3| 4| 5| 6| 7| 8| 9|10|11|12|13|14|15|16|17|18|19|20
!
!  nl  =  2, 4, 5, 1, 3, 5, 6, 2, 4, 6, 1, 3, 5, 6, 1, 2, 4, 2, 3, 4     neighbors list
subroutine mknnl(self)

   type(domain_decomposition), intent(inout) :: self

   integer :: ii, lnl, iat, jat
   real(wp) :: v(3), d2, r2

   character(len=*), parameter :: f1000 = "(t3, 'neighbours of sphere ', i6)"
   character(len=*), parameter :: f1010 = "(t5, 12i6)"

   ! index of nl
   ii  = 1
   lnl = 0
   do iat = 1, self%nat
      self%inl(iat) = lnl + 1
      do jat = 1, self%nat
         if (iat /= jat) then
            v(:) = self%xyz(:, iat) - self%xyz(:, jat)
            d2 = v(1)**2 + v(2)**2 + v(3)**2
            r2 = (self%rvdw(iat) + self%rvdw(jat))**2
            if (d2 <= r2) then
               self%nl(ii) = jat
               ii  = ii + 1
               lnl = lnl + 1
            end if
         end if
      end do
   end do
   self%inl(self%nat+1) = lnl+1

   if (self%iprint >= 4) then
      write(iout, *) '   inl:'
      write(iout, '(10i6)') self%inl(1:self%nat+1)
      write(iout, *)
      do iat = 1, self%nat
         write(iout, f1000) iat
         write(iout, f1010) self%nl(self%inl(iat):self%inl(iat+1)-1)
      end do
      write(iout, *)
   end if

end subroutine mknnl


! Define :
!
!   N_i = list of neighbors of i-sphere [ excluding i-sphere ]
!
!            | r_i + rho_i s_n - r_j |
!   t_n^ij = -------------------------
!                      rho_j
!
!   fi(n, i) =    sum    \chi(t_n^ij)
!             j \in N_i
!
! Notice that the derivative of fi(n, i) wrt to r_k is (possibly) nonzero
! when either k = i, or k \in N_j .
subroutine mkfiui(self)

   type(domain_decomposition), intent(inout) :: self

   integer :: iat, i, ii, jat
   real(wp) :: v(3), vv, t, xt, swthr, fac


   ! build arrays fi, ui, zi
   self%fi = 0.0_wp
   self%ui = 0.0_wp
   if (self%grad) self%zi = 0.0_wp

   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(self) private(iat, i, ii, jat, v, vv, t, xt, swthr, fac)
   ! loop over spheres
   do iat = 1, self%nat

      ! loop over integration points
      do i = 1, self%ngrid

         ! loop over neighbors of i-sphere
         do ii = self%inl(iat), self%inl(iat+1)-1

            ! neighbor's number
            jat = self%nl(ii)

            ! compute t_n^ij
            v(:) = self%xyz(:, iat) + self%rvdw(iat)*self%grid(:, i) - self%xyz(:, jat)
            vv = v(1)**2 + v(2)**2 + v(3)**2
            vv = sqrt(vv)
            t = vv/self%rvdw(jat)

            ! compute \chi(t_n^ij)
            xt = fsw(t, se, self%eta)

            ! upper bound of switch region
            swthr = 1.0_wp + (se + 1._wp)*self%eta / 2._wp

            ! t_n^ij belongs to switch region
            if (self%grad .and. (t < swthr .and. t > swthr-self%eta)) then
               fac = dfsw(t, se, self%eta) / self%rvdw(jat)

               ! accumulate for zi
               self%zi(:, i, iat) = self%zi(:, i, iat) + fac*v(:)/vv
            end if

            ! accumulate for fi
            self%fi(i, iat) = self%fi(i, iat) + xt
         end do

         ! compute ui
         if (self%fi(i, iat) <= 1.0_wp)  self%ui(i, iat) = 1.0_wp - self%fi(i, iat)
      end do
   end do

   if (self%iprint >= 4) then
      call ptcart(self, 'fi', self%nat, 0, self%fi)
      call ptcart(self, 'ui', self%nat, 0, self%ui)
   end if

end subroutine mkfiui


! build cavity array
subroutine mkccav(self)

   type(domain_decomposition), intent(inout) :: self

   integer :: iat, i, ii
   character(len=*), parameter :: f1100 = "(t3, i8, 3f14.6)"

   if (allocated(self%ccav)) deallocate(self%ccav)

   ! initialize number of cavity points
   self%ncav=0

   ! loop over spheres
   do iat = 1, self%nat

      ! loop over integration points
      do i = 1, self%ngrid

         ! positive contribution from integration point
         if (self%ui(i, iat) > 0.0_wp) then

            ! accumulate
            self%ncav = self%ncav + 1

         end if
      end do
   end do

   ! allocate cavity array
   allocate(self%ccav(3, self%ncav))

   ! initialize cavity array index
   ii = 0

   ! loop over spheres
   do iat = 1, self%nat

      ! loop over integration points
      do i = 1, self%ngrid

         ! positive contribution from integration point
         if (self%ui(i, iat) > 0.0_wp) then

            ! advance cavity array index
            ii = ii + 1

            ! store point
            self%ccav(:, ii) = self%xyz(:, iat) + self%rvdw(iat)*self%grid(:, i)

         end if
      end do
   end do

   if (self%iprint >= 4) then
      write(iout, *) '   external cavity points:'
      do ii = 1, self%ncav
         write(iout, f1100) ii, self%ccav(:, ii)
      end do
      write(iout, *)
   end if

end subroutine mkccav


!> Scalar product
pure function sprod(n, u, v)

   integer, intent(in) :: n
   real(wp), intent(in) :: u(n), v(n)
   real(wp) :: sprod

   integer :: i
   real(wp) :: ss

   ! initialize
   ss = 0.0_wp

   do i = 1, n
      ! accumulate
      ss = ss + u(i)*v(i)
   end do

   ! redirect
   sprod = ss

end function sprod


!> Switch function (5th degree polynomial)
elemental function fsw(t, s, eta)

   real(wp) :: fsw
   real(wp), intent(in) :: t
   real(wp), intent(in) :: s
   real(wp), intent(in) :: eta

   real(wp) :: a, b, flow, x
   real(wp), parameter :: f6=6.0_wp, f10=10._wp, f12=12._wp, f15=15._wp

   ! shift :
   ! s =  0   =>   t - eta/2  [ CENTERED ]
   ! s =  1   =>   t - eta    [ EXTERIOR ]
   ! s = -1   =>   t          [ INTERIOR ]

   ! apply shift
   x = t - (s + 1._wp)*eta / 2._wp

   ! lower bound of switch region
   flow = 1.0_wp - eta

   ! define switch function \chi
   if (x >= 1.0_wp) then
      fsw = 0.0_wp
   elseif (x <= flow) then
      fsw = 1.0_wp
   else
      a = f15*eta - f12
      b = f10*eta*eta - f15*eta + f6
      fsw = ((x-1.0_wp)*(x-1.0_wp)*(1.0_wp-x)*(f6*x*x + a*x + b)) / (eta**5)
   end if

end function fsw


!> First derivative of switch function
elemental function dfsw(t, s, eta)

   real(wp), intent(in) :: t
   real(wp), intent(in) :: s
   real(wp), intent(in) :: eta
   real(wp) :: dfsw

   real(wp) :: flow, x
   real(wp), parameter :: f30=30.0_wp

   ! shift :
   ! s =  0   =>   t - eta/2  [ CENTERED ]
   ! s =  1   =>   t - eta    [ EXTERIOR ]
   ! s = -1   =>   t          [ INTERIOR ]
   !
   ! apply shift
   x = t - (s + 1._wp)*eta / 2._wp

   ! lower bound of switch region
   flow = 1.0_wp - eta

   ! define derivative of switch function \chi
   if (x >= 1.0_wp) then
      dfsw = 0.0_wp
   elseif (x <= flow) then
      dfsw = 0.0_wp
   else
      dfsw = f30*(1.0_wp-x)*(x-1.0_wp)*(x-1.0_wp+eta)*(x-1.0_wp+eta)/(eta**5)
   end if

end function dfsw


!> Dump an array (ngrid, ncol) or just a column.
subroutine ptcart(self, label, ncol, icol, x)

   type(domain_decomposition), intent(in) :: self
   character(len=*), intent(in) :: label
   integer, intent(in) :: ncol, icol
   real(wp), intent(in) :: x(self%ngrid, ncol)

   integer :: ig, noff, nprt, ic, j
   character(len=*), parameter :: f1000 = "(1x, i5, f14.8)"
   character(len=*), parameter :: f1010 = "(6x, 5i14)"
   character(len=*), parameter :: f1020 = "(1x, i5, 5f14.8)"

   ! print header :
   if (ncol == 1) then
      write (iout, '(3x, a, 1x, "(column ", i4, ")")') label, icol
   else
      write (iout, '(3x, a)') label
   end if

   ! print entries :
   if (ncol == 1) then
      do ig = 1, self%ngrid
         write(iout, f1000) ig, x(ig, 1)
      end do

   else
      noff = mod (ncol, 5)
      nprt = max(ncol - noff, 0)
      do ic = 1, nprt, 5
         write(iout, f1010) (j, j = ic, ic+4)
         do ig = 1, self%ngrid
            write(iout, f1020) ig, x(ig, ic:ic+4)
         end do
      end do
      write (iout, f1010) (j, j = nprt+1, nprt+noff)
      do ig = 1, self%ngrid
         write(iout, f1020) ig, x(ig, nprt+1:nprt+noff)
      end do
   end if

end subroutine ptcart


!> Dump an array (nylm, ncol) or just a column.
subroutine prtsph(self, label, ncol, icol, x)

   type(domain_decomposition), intent(in) :: self
   character (len=*), intent(in) :: label
   integer, intent(in) :: ncol, icol
   real(wp), intent(in) :: x(self%nylm, ncol)

   integer :: l, m, ind, noff, nprt, ic, j
   character(len=*), parameter :: f1000 = "(1x, i3, i4, f14.8)"
   character(len=*), parameter :: f1010 = "(8x, 5i14)"
   character(len=*), parameter :: f1020 = "(1x, i3, i4, 5f14.8)"

   ! print header :
   if (ncol == 1) then
      write (iout, '(3x, a, 1x, "(column ", i4, ")")') label, icol
   else
      write (iout, '(3x, a)') label
   end if

   ! print entries :
   if (ncol == 1) then
      do l = 0, self%lmax
         ind = l*l + l + 1
         do m = -l, l
            write(iout, f1000) l, m, x(ind+m, 1)
         end do
      end do

   else
      noff = mod(ncol, 5)
      nprt = max(ncol - noff, 0)
      do ic = 1, nprt, 5
         write(iout, f1010) (j, j = ic, ic+4)
         do l = 0, self%lmax
            ind = l*l + l + 1
            do m = -l, l
               write(iout, f1020) l, m, x(ind+m, ic:ic+4)
            end do
         end do
      end do
      write (iout, f1010) (j, j = nprt+1, nprt+noff)
      do l = 0, self%lmax
         ind = l*l + l + 1
         do m = -l, l
            write(iout, f1020) l, m, x(ind+m, nprt+1:nprt+noff)
         end do
      end do
   end if

end subroutine prtsph


!> Integrate against spherical harmonics
subroutine intrhs(self, iat, x, xlm)

   type(domain_decomposition), intent(in) :: self
   integer, intent(in) :: iat
   real(wp), intent(in) :: x(:) ! [self%ngrid]
   real(wp), intent(inout) :: xlm(:) ! [self%nylm]

   integer :: ig

   ! initialize
   xlm = 0.0_wp

   ! accumulate over integration points
   do ig = 1, self%ngrid
      xlm = xlm + self%basis(:, ig)*self%w(ig)*x(ig)
   end do

   ! printing
   if (self%iprint >= 5) then
      call ptcart(self, 'pot', 1, iat, x)
      call prtsph(self, 'vlm', 1, iat, xlm)
   end if

end subroutine intrhs


!> Compute spherical harmonics
pure subroutine ylmbas(self, x, basloc, vplm, vcos, vsin)

   type(domain_decomposition), intent(in) :: self
   real(wp), intent(in) :: x(:) ! [3]
   real(wp), intent(out) :: basloc(:), vplm(:) ! [self%nylm]
   real(wp), intent(out) :: vcos(:), vsin(:) ! [self%lmax+1]

   integer :: l, m, ind
   real(wp) :: cthe, sthe, cphi, sphi, plm

   ! get cos(\theta), sin(\theta), cos(\phi) and sin(\phi) from the cartesian
   ! coordinates of x.

   ! evaluate cos(theta) ; sin(theta)
   cthe = x(3)
   sthe = sqrt(1.0_wp - cthe*cthe)

   ! evalutate cos(phi) ; sin(phi)
   if (sthe /= 0.0_wp) then
      cphi = x(1)/sthe
      sphi = x(2)/sthe
   else
      cphi = 0.0_wp
      sphi = 0.0_wp
   end if

   ! evaluate cos(m*phi) and sin(m*phi) arrays. notice that this is
   ! pointless if z = 1, as the only non vanishing terms will be the
   ! ones with m=0.
   if(sthe /= 0.0_wp) then
      call trgev(self, cphi, sphi, vcos, vsin)
   else
      vcos = 1.0_wp
      vsin = 0.0_wp
   end if

   ! evaluate the generalized legendre polynomials
   call polleg(self, cthe, sthe, vplm)

   ! now build the spherical harmonics. we will distinguish m=0,
   ! m>0 and m<0:
   do l = 0, self%lmax
      ind = l**2 + l + 1

      ! m = 0
      basloc(ind) = self%facs(ind)*vplm(ind)

      do m = 1, l

         plm = vplm(ind+m)

         ! m > 0
         basloc(ind+m) = self%facs(ind+m)*plm*vcos(m+1)

         ! m < 0
         basloc(ind-m) = self%facs(ind-m)*plm*vsin(m+1)

      end do
   end do

end subroutine ylmbas


!> Compute first derivatives of spherical harmonics
pure subroutine dbasis(self, x, basloc, dbsloc, vplm, vcos, vsin)

   type(domain_decomposition), intent(in) :: self
   real(wp), intent(in) :: x(:) ! [3]
   real(wp), intent(inout) :: basloc(:), vplm(:) ! [self%nylm]
   real(wp), intent(inout) :: dbsloc(:, :) ! [3, self%nylm]
   real(wp), intent(inout) :: vcos(:), vsin(:) ! [self%lmax+1]

   integer :: l, m, ind
   real(wp) :: VC, VS
   real(wp) :: cthe, sthe, cphi, sphi, plm, fln, pp1, pm1, pp
   real(wp) :: et(3), ep(3)

   ! get cos(\theta), sin(\theta), cos(\phi) and sin(\phi) from the cartesian
   ! coordinates of x.
   cthe = x(3)
   sthe = sqrt(1.0_wp - cthe*cthe)

   if (sthe /= 0.0_wp) then
      ! not (NORTH or SOUTH pole)
      cphi = x(1)/sthe
      sphi = x(2)/sthe
   else
      ! NORTH or SOUTH pole
      cphi = 1.0_wp
      sphi = 0.0_wp
   end if

   ! evaluate the derivatives of theta and phi:
   et(1) = cthe*cphi
   et(2) = cthe*sphi
   et(3) = -sthe

   if(sthe /= 0.0_wp) then
      ! not (NORTH or SOUTH pole)
      ep(1) = -sphi/sthe
      ep(2) = cphi/sthe
      ep(3) = 0.0_wp
   else
      ! NORTH or SOUTH pole
      ep(1) = 0.0_wp
      ep(2) = 1.0_wp
      ep(3) = 0.0_wp
   end if

   ! evaluate cos(m*phi) and sin(m*phi) arrays. notice that this is
   ! pointless if z = 1, as the only non vanishing terms will be the
   ! ones with m=0.

   if (sthe /= 0.0_wp) then
      ! not (NORTH or SOUTH pole)
      call trgev(self, cphi, sphi, vcos, vsin)
   else
      ! NORTH or SOUTH pole
      vcos(:) = 1.0_wp
      vsin(:) = 0.0_wp
   end if
   VC=0.0_wp
   VS=cthe

   ! evaluate the generalized legendre polynomials.
   call polleg(self, cthe, sthe, vplm)

   ! now build the spherical harmonics. we will distinguish m=0,
   ! m>0 and m<0:

   basloc = 0.0_wp
   dbsloc = 0.0_wp
   do l = 0, self%lmax
      ind = l*l + l + 1
      ! m = 0
      fln = self%facs(ind)
      basloc(ind) = fln*vplm(ind)
      if (l > 0) then
         dbsloc(:, ind) = fln*vplm(ind+1)*et(:)
      else
         dbsloc(:, ind) = 0.0_wp
      end if
      !$omp simd
      do m = 1, l
         fln = self%facs(ind+m)
         plm = fln*vplm(ind+m)
         pp1 = 0.0_wp
         if (m < l) pp1 = -0.5_wp*vplm(ind+m+1)
         pm1 = 0.5_wp*(real(l+m, wp)*real(l-m+1, wp)*vplm(ind+m-1))
         pp  = pp1 + pm1

         ! m > 0
         basloc(ind+m) = plm*vcos(m+1)

         if (sthe /= 0.0_wp) then
            ! not (NORTH or SOUTH pole)
            dbsloc(:, ind+m) = -fln*pp*vcos(m+1)*et(:) - real(m, wp)*plm*vsin(m+1)*ep(:)
         else
            ! NORTH or SOUTH pole
            dbsloc(:, ind+m) = -fln*pp*vcos(m+1)*et(:) - fln*pp*ep(:)*VC
         end if

         ! m < 0
         basloc(ind-m) = plm*vsin(m+1)

         if (sthe /= 0.0_wp) then
            ! not (NORTH or SOUTH pole)
            dbsloc(:, ind-m) = -fln*pp*vsin(m+1)*et(:) + real(m, wp)*plm*vcos(m+1)*ep(:)
         else
            ! NORTH or SOUTH pole
            dbsloc(:, ind-m) = -fln*pp*vsin(m+1)*et(:) - fln*pp*ep(:)*VS
         end if

      end do
   end do

end subroutine dbasis


!> Compute the l, m associated legendre polynomial for -1 <= x <= 1 using the
!  recurrence formula
!
!  (l-m)p(l, m) = x(2l-1)p(l-1, m) - (l+m-1)p(l-2, m)
pure subroutine polleg(self, x, y, plm)

   type(domain_decomposition), intent(in) :: self
   real(wp), intent(in) :: x, y
   real(wp), intent(inout) :: plm(:) ! [self%nylm]

   integer :: m, ind, l, ind2
   real(wp) :: fact, pmm, somx2, pmm1, pmmo, pll, fm, fl

   fact  = 1.0_wp
   pmm   = 1.0_wp
   somx2 = y

   do m = 0, self%lmax
      ind      = (m + 1)*(m + 1)
      plm(ind) = pmm
      if(m == self%lmax) return
      fm = real(m, wp)
      pmm1 = x*(2.0_wp*fm + 1.0_wp)*pmm
      ind2 = ind + 2*m + 2
      plm(ind2) = pmm1
      pmmo = pmm
      do l = m+2, self%lmax
         fl = real(l, wp)
         pll   = (x*(2.0_wp*fl - 1.0_wp)*pmm1 - (fl + fm - 1.0_wp)*pmm)/(fl - fm)
         ind = l*l + l + 1
         plm(ind+m) = pll
         pmm  = pmm1
         pmm1 = pll
      end do
      pmm  = -pmmo*fact*somx2
      fact = fact + 2.0_wp
   end do

end subroutine polleg


!> Service routine for computation of spherical harmonics
pure subroutine trgev(self, x, y, cx, sx)

   type(domain_decomposition), intent(in) :: self
   real(wp), intent(in) :: x, y
   real(wp), intent(inout) :: cx(:), sx(:) ! [max((self%lmax+1), 2)]

   integer :: m

   cx(1) = 1.0_wp
   sx(1) = 0.0_wp
   cx(2) = x
   sx(2) = y
   do m = 3, self%lmax+1
      cx(m) = 2.0_wp*x*cx(m-1) - cx(m-2)
      sx(m) = 2.0_wp*x*sx(m-1) - sx(m-2)
   end do

end subroutine trgev


!> Compute
!
!  sum   4pi/(2l+1) t^l * Y_l^m(s) * sigma_l^m
!  l, m
!
!  which is need to compute action of COSMO matrix L.
pure function intmlp(self, t, sigma, basloc)

   type(domain_decomposition), intent(in) :: self
   real(wp), intent(in) :: t
   real(wp), intent(in) :: sigma(:), basloc(:) ! [self%nylm]
   real(wp) :: intmlp

   integer :: l, ind
   real(wp) :: tt, ss, fac

   ! initialize t^l
   tt = 1.0_wp

   ! initialize
   ss = 0.0_wp

   ! loop over l
   do l = 0, self%lmax

      ind = l*l + l + 1

      ! update factor 4pi / (2l+1) * t^l
      fac = tt / self%facl(ind)

      ! contract over l, m and accumulate
      ss = ss + fac * dot_product(basloc(ind-l:ind+l), sigma(ind-l:ind+l))

      ! update t^l
      tt = tt*t
   end do

   ! redirect
   intmlp = ss

end function intmlp


!> Weigh potential at cavity points by characteristic function "ui"
subroutine wghpot(self, phi, g)

   type(domain_decomposition), intent(in) :: self
   real(wp), intent(in)  :: phi(:) ! [self%ncav]
   real(wp), intent(out) :: g(:, :) ! [self%ngrid, self%nat]

   integer :: iat, ig, ic

   !> Initialize
   ic = 0
   g(:, :) = 0._wp

   ! loop over spheres
   do iat = 1, self%nat

      ! loop over points
      do ig = 1, self%ngrid

         ! nonzero contribution from point
         if (self%ui(ig, iat) /= 0.0_wp) then

            ! advance cavity point counter
            ic = ic + 1

            ! weight by (negative) characteristic function
            g(ig, iat) = -self%ui(ig, iat) * phi(ic)

         end if

      end do
   end do

end subroutine wghpot


!> Compute H-norm
pure subroutine hsnorm(self, u, unorm)

   type(domain_decomposition), intent(in) :: self
   real(wp), intent(in) :: u(:) !< [nylm]
   real(wp), intent(inout) :: unorm

   integer :: l, m, ind
   real(wp) :: fac

   ! initialize
   unorm = 0.0_wp

   ! loop over l
   do l = 0, self%lmax

      ! first index associated to l
      ind = l*l + l + 1

      ! scaling factor
      fac = 1.0_wp/(1.0_wp + real(l, wp))

      ! loop over m
      do m = -l, l

         ! accumulate
         unorm = unorm + fac*u(ind+m)*u(ind+m)

      end do
   end do

   ! the much neglected square root
   unorm = sqrt(unorm)

end subroutine hsnorm


!> Compute
!
!   v_l^m = v_l^m +
!
!               4 pi           l
!     sum  sum  ---- (t_n^ji)  Y_l^m(s_n^ji) W_n^ji [ \xi_j ]_n
!      j    n   2l+1
!
! which is related to the action of the adjont COSMO matrix L^* in the following
! way. Set
!
!   [ \xi_j ]_n = sum  Y_l^m(s_n) [ s_j ]_l^m
!                 l, m
!
! then
!
!   v_l^m = -   sum    (L^*)_ij s_j
!             j \ne i
!
! The auxiliary quantity [ \xi_j ]_l^m needs to be computed explicitly.
pure subroutine adjrhs(self, iat, xi, vlm, basloc, vplm, vcos, vsin)

   type(domain_decomposition), intent(in) :: self
   integer, intent(in) :: iat
   real(wp), intent(in) :: xi(:, :) ! [self%ngrid, self%nat]
   real(wp), intent(inout) :: vlm(:) ! [self%nylm]
   real(wp), intent(inout) :: basloc(:), vplm(:) ! [self%nylm]
   real(wp), intent(inout) :: vcos(:), vsin(:) ! [self%lmax+1]

   integer :: ij, jat, ig, l, ind, m
   real(wp) :: vji(3), vvji, tji, sji(3), xji, oji, fac, ffac, t

   ! loop over neighbors of i-sphere
   do ij = self%inl(iat), self%inl(iat+1)-1

      ! j-sphere is neighbor
      jat = self%nl(ij)

      ! loop over integration points
      do ig = 1, self%ngrid

         ! compute t_n^ji = | r_j + \rho_j s_n - r_i | / \rho_i
         vji  = self%xyz(:, jat) + self%rvdw(jat)*self%grid(:, ig) - self%xyz(:, iat)
         vvji = vji(1)**2 + vji(2)**2 + vji(3)**2
         vvji = sqrt(vvji)
         tji  = vvji/self%rvdw(iat)

         ! point is INSIDE i-sphere (+ transition layer)
         if (tji < (1.0_wp + (se+1.0_wp)/2.0_wp*self%eta)) then

            ! compute s_n^ji
            sji = vji/vvji

            ! compute \chi(t_n^ji)
            xji = fsw(tji, se, self%eta)

            ! compute W_n^ji
            if (self%fi(ig, jat) > 1.0_wp) then
               oji = xji/self%fi(ig, jat)
            else
               oji = xji
            end if

            ! compute Y_l^m(s_n^ji)
            call ylmbas(self, sji, basloc, vplm, vcos, vsin)

            ! initialize (t_n^ji)^l
            t = 1.0_wp

            ! compute w_n * xi(n, j) * W_n^ji
            fac = self%w(ig) * xi(ig, jat) * oji

            ! loop over l
            do l = 0, self%lmax
               ind  = l*l + l + 1

               ! compute 4pi / (2l+1) * (t_n^ji)^l * w_n * xi(n, j) * W_n^ji
               ffac = fac*t/self%facl(ind)

               ! loop over m
               do m = -l, l
                  vlm(ind+m) = vlm(ind+m) + ffac*basloc(ind+m)
               end do

               ! update (t_n^ji)^l
               t = t*tji
            end do

         end if
      end do
   end do

end subroutine adjrhs


!> Compute the first part of <S, L^(x)X>
pure subroutine fdoka(self, iat, sigma, xi, basloc, dbsloc, vplm, vcos, vsin, fx)

   type(domain_decomposition), intent(in) :: self
   integer, intent(in) :: iat
   real(wp), intent(in) :: sigma(:, :) ! [self%nylm, self%nat]
   real(wp), intent(in) :: xi(:) ! [self%ngrid]
   real(wp), intent(inout) :: basloc(:), vplm(:) ! [self%nylm]
   real(wp), intent(inout) :: dbsloc(:, :) ! [3, self%nylm]
   real(wp), intent(inout) :: vcos(:), vsin(:) ! [self%lmax+1]
   real(wp), intent(inout) :: fx(:) ! [3]

   integer :: ig, ij, jat, l, ind, m
   real(wp) :: vvij, tij, xij, oij, t, fac, fl, f1, f2, f3, beta, tlow, thigh
   real(wp) :: vij(3), sij(3), alp(3), va(3)

   tlow  = 1.0_wp - 0.5_wp*(1.0_wp - se)*self%eta
   thigh = 1.0_wp + 0.5_wp*(1.0_wp + se)*self%eta

   do ig = 1, self%ngrid
      va = 0.0_wp
      do ij = self%inl(iat), self%inl(iat+1) - 1
         jat = self%nl(ij)
         vij = self%xyz(:, iat) + self%rvdw(iat)*self%grid(:, ig) - self%xyz(:, jat)
         vvij = vij(1)**2 + vij(2)**2 + vij(3)**2
         vvij = sqrt(vvij)
         tij = vvij/self%rvdw(jat)

         if (tij >= thigh) cycle

         sij = vij/vvij
         call dbasis(self, sij, basloc, dbsloc, vplm, vcos, vsin)
         alp = 0.0_wp
         t = 1.0_wp
         do l = 1, self%lmax
            ind = l*l + l + 1
            fl = real(l, wp)
            fac = t/self%facl(ind)
            do m = -l, l
               f2 = fac*sigma(ind+m, jat)
               f1 = f2*fl*basloc(ind+m)
               alp(:) = alp(:) + f1*sij(:) + f2*dbsloc(:, ind+m)
            end do
            t = t*tij
         end do
         beta = intmlp(self, tij, sigma(:, jat), basloc)
         xij = fsw(tij, se, self%eta)
         if (self%fi(ig, iat) > 1.0_wp) then
            oij = xij/self%fi(ig, iat)
            f2  = -oij/self%fi(ig, iat)
         else
            oij = xij
            f2  = 0.0_wp
         end if
         f1 = oij/self%rvdw(jat)
         va(:) = va(:) + f1*alp(:) + beta*f2*self%zi(:, ig, iat)
         if (tij > tlow) then
            f3 = beta*dfsw(tij, se, self%eta)/self%rvdw(jat)
            if (self%fi(ig, iat) > 1.0_wp) f3 = f3/self%fi(ig, iat)
            va(:) = va(:) + f3*sij(:)
         end if
      end do
      fx = fx + self%w(ig)*xi(ig)*va(:)
   end do

end subroutine fdoka


!> Compute the the second part of <S, L^(x)X>
pure subroutine fdokb(self, iat, sigma, xi, basloc, dbsloc, vplm, vcos, vsin, fx)

   type(domain_decomposition), intent(in) :: self
   integer, intent(in) :: iat
   real(wp), intent(in) :: sigma(:, :) ! [self%nylm, self%nat]
   real(wp), intent(in) :: xi(:, :) ! [self%ngrid, self%nat]
   real(wp), intent(inout) :: basloc(:), vplm(:) ! [self%nylm]
   real(wp), intent(inout) :: dbsloc(:, :) ! [3, self%nylm]
   real(wp), intent(inout) :: vcos(:), vsin(:) ! [self%lmax+1]
   real(wp), intent(inout) :: fx(:) ! [3]

   integer :: ig, ji, jat, l, ind, m, jk, kat
   logical :: proc
   real(wp) :: vvji, tji, xji, oji, t, fac, fl, f1, f2, beta, di, tlow, thigh
   real(wp) :: b, g1, g2, vvjk, tjk, xjk
   real(wp) :: vji(3), sji(3), alp(3), vb(3), vjk(3), sjk(3), vc(3)



   tlow  = 1.0_wp - 0.5_wp*(1.0_wp - se)*self%eta
   thigh = 1.0_wp + 0.5_wp*(1.0_wp + se)*self%eta

   do ig = 1, self%ngrid
      vb = 0.0_wp
      vc = 0.0_wp
      do ji = self%inl(iat), self%inl(iat+1) - 1
         jat = self%nl(ji)
         vji = self%xyz(:, jat) + self%rvdw(jat)*self%grid(:, ig) - self%xyz(:, iat)
         vvji = vji(1)**2 + vji(2)**2 + vji(3)**2
         vvji = sqrt(vvji)
         tji = vvji/self%rvdw(iat)

         if (tji > thigh) cycle

         sji = vji/vvji
         call dbasis(self, sji, basloc, dbsloc, vplm, vcos, vsin)

         alp = 0.0_wp
         t   = 1.0_wp
         do l = 1, self%lmax
            ind = l*l + l + 1
            fl = real(l, wp)
            fac = t/self%facl(ind)
            do m = -l, l
               f2 = fac*sigma(ind+m, iat)
               f1 = f2*fl*basloc(ind+m)
               alp = alp + f1*sji + f2*dbsloc(:, ind+m)
            end do
            t = t*tji
         end do
         xji = fsw(tji, se, self%eta)
         if (self%fi(ig, jat) > 1.0_wp) then
            oji = xji/self%fi(ig, jat)
         else
            oji = xji
         end if
         f1 = oji/self%rvdw(iat)
         vb = vb + f1*alp*xi(ig, jat)
         if (tji > tlow) then
            beta = intmlp(self, tji, sigma(:, iat), basloc)
            if (self%fi(ig, jat) > 1.0_wp) then
               di  = 1.0_wp/self%fi(ig, jat)
               fac = di*xji
               proc = .false.
               b    = 0.0_wp
               do jk = self%inl(jat), self%inl(jat+1) - 1
                  kat = self%nl(jk)
                  vjk = self%xyz(:, jat) + self%rvdw(jat)*self%grid(:, ig) - self%xyz(:, kat)
                  vvjk = vjk(1)**2 + vjk(2)**2 + vjk(3)**2
                  vvjk = sqrt(vvjk)
                  tjk = vvjk/self%rvdw(kat)
                  if (kat /= iat) then
                     if (tjk <= thigh) then
                        proc = .true.
                        sjk = vjk/vvjk
                        call ylmbas(self, sjk, basloc, vplm, vcos, vsin)
                        g1 = intmlp(self, tjk, sigma(:, kat), basloc)
                        xjk = fsw(tjk, se, self%eta)
                        b = b + g1*xjk
                     end if
                  end if
               end do
               if (proc) then
                  g1 = di*di*dfsw(tji, se, self%eta)/self%rvdw(iat)
                  g2 = g1*xi(ig, jat)*b
                  vc = vc + g2*sji
               end if
            else
               di = 1.0_wp
               fac = 0.0_wp
            end if
            f2 = (1.0_wp-fac)*di*dfsw(tji, se, self%eta)/self%rvdw(iat)
            vb = vb + f2*xi(ig, jat)*beta*sji
         end if
      end do
      fx = fx - self%w(ig)*(vb - vc)
   end do

end subroutine fdokb


!> Compute the U^(x)\Phi contribution to <S, g^(x)>
pure subroutine fdoga(self, iat, xi, phi, fx)

   type(domain_decomposition), intent(in) :: self
   integer, intent(in) :: iat
   real(wp), intent(in) :: xi(:, :), phi(:, :) ! [self%ngrid, self%nat]
   real(wp), intent(inout) :: fx(:) ! [3]

   integer :: ig, ji, jat
   real(wp) :: vvji, tji, fac, swthr
   real(wp) :: alp(3), vji(3), sji(3)

   do ig = 1, self%ngrid
      alp = 0.0_wp
      if (self%ui(ig, iat) > 0.0_wp .and. self%ui(ig, iat) <  1.0_wp) then
         alp = alp + phi(ig, iat)*xi(ig, iat)*self%zi(:, ig, iat)
      end if
      do ji = self%inl(iat), self%inl(iat+1) - 1
         jat = self%nl(ji)
         vji = self%xyz(:, jat) + self%rvdw(jat)*self%grid(:, ig) - self%xyz(:, iat)
         vvji = vji(1)**2 + vji(2)**2 + vji(3)**2
         vvji = sqrt(vvji)
         tji = vvji/self%rvdw(iat)
         swthr = 1.0_wp + (se + 1._wp)*self%eta / 2._wp
         if (tji < swthr .and. tji > swthr-self%eta .and. self%ui(ig, jat) > 0.0_wp) then
            sji = vji/vvji
            fac = - dfsw(tji, se, self%eta)/self%rvdw(iat)
            alp = alp + fac*phi(ig, jat)*xi(ig, jat)*sji
         end if
      end do
      fx = fx + self%w(ig)*alp
   end do

end subroutine fdoga


!> Auxiliary routine for COSMO action
!  compute
!
!   \Phi(n) =
!
!                       4 pi           l
!     sum  W_n^ij  sum  ---- (t_n^ij)  Y_l^m(s_n^ij) [ \sigma_j ]_l^m
!      j           l, m  2l+1
!
! which is related to the action of the COSMO matrix L in the following
! way :
!
!   -   sum    L_ij \sigma_j = sum  w_n Y_l^m(s_n) \Phi(n)
!     j \ne i                   n
!
! This second step is performed by routine "intrhs".
pure subroutine calcv(self, first, iat, pot, sigma, basloc, vplm, vcos, vsin)

   type(domain_decomposition), intent(in) :: self
   logical, intent(in) :: first
   integer, intent(in) :: iat
   real(wp), intent(in) :: sigma(:, :) ! [self%nylm, self%nat]
   real(wp), intent(inout) :: pot(:) ! [self%ngrid]
   real(wp), intent(inout) :: basloc(:) ! [self%nylm]
   real(wp), intent(inout) :: vplm(:) ! [self%nylm]
   real(wp), intent(inout) :: vcos(:) ! [self%lmax+1]
   real(wp), intent(inout) :: vsin(:) ! [self%lmax+1]

   integer :: its, ij, jat
   real(wp) :: vij(3), sij(3)
   real(wp) :: vvij2, vvij, tij, xij, oij

   ! initialize
   pot(:) = 0.0_wp

   ! if 1st iteration of Jacobi method, then done!
   if (first)  return

   ! loop over grid points
   do its = 1, self%ngrid

      ! contribution from integration point present
      if (self%ui(its, iat) < 1.0_wp) then

         ! loop over neighbors of i-sphere
         do ij = self%inl(iat), self%inl(iat+1)-1

            ! neighbor is j-sphere
            jat = self%nl(ij)

            ! compute t_n^ij = | r_i + \rho_i s_n - r_j | / \rho_j
            vij  = self%xyz(:, iat) + self%rvdw(iat)*self%grid(:, its) - self%xyz(:, jat)
            vvij2 = vij(1)**2 + vij(2)**2 + vij(3)**2
            vvij = sqrt(vvij2)
            tij  = vvij / self%rvdw(jat)

            ! point is INSIDE j-sphere
            if (tij < 1.0_wp) then

               ! compute s_n^ij = (r_i + \rho_i s_n - r_j) / | ... |
               sij = vij / vvij

               ! compute \chi(t_n^ij)
               xij = fsw(tij, se, self%eta)

               ! compute W_n^ij
               if (self%fi(its, iat) > 1.0_wp) then

                  oij = xij / self%fi(its, iat)

               else

                  oij = xij

               end if

               ! compute Y_l^m(s_n^ij)
               call ylmbas(self, sij, basloc, vplm, vcos, vsin)

               ! accumulate over j, l, m
               pot(its) = pot(its) + oij * intmlp(self, tij, sigma(:, jat), basloc)

            end if
         end do
      end if
   end do

end subroutine calcv


!> Compute the xi intermediate
!
! \xi(n, i) =
!
!  sum w_n U_n^i Y_l^m(s_n) [S_i]_l^m
!  l, m
!
pure subroutine ddmkxi(self, s, xi)

   type(domain_decomposition), intent(in) :: self
   real(wp), intent(in) :: s(:, :) ! [self%nylm, self%nat]
   real(wp), intent(inout) :: xi(:) ! [self%ncav]

   integer :: its, iat, ii

   ii = 0
   do iat = 1, self%nat
      do its = 1, self%ngrid
         if (self%ui(its, iat) > 0.0_wp) then
            ii = ii + 1
            xi(ii) = self%w(its)*self%ui(its, iat) &
               & * dot_product(self%basis(:, its), s(:, iat))
         end if
      end do
   end do

end subroutine ddmkxi


!> Jacobi/DIIS solver
subroutine jacobi_diis(self, n, lprint, diis_max, norm, tol, rhs, x, &
      & n_iter, ok, matvec, dm1vec, u_norm)

   !  Error source
   character(len=*), parameter :: source = 'ddcosmo_solver::jacobi_diis'

   !> Instance of the COSMO model
   type(domain_decomposition), intent(in) :: self

   !> Integer, input, size of the matrix
   integer, intent(in) :: n

   !> Integer, input, number of points to be used for diis extrapolation
   !  if diis_max = 0, this is just a Jacobi solver.
   integer, intent(in) :: diis_max

   !> Integer, input, norm to be used to evaluate convergence
   !  1: max |x_new - x|
   !  2: rms (x_new - x)
   !  3: rms (x_new - x) and max |x_new - x|
   !  4: norm computed by the user-provided function u_norm(n, x)
   integer, intent(in) :: norm

   !> Integer, input, printing flag.
   integer, intent(in) :: lprint

   !> Real, input, convergence criterion. if norm = 3, convergence is
   !  achieved when rms (x_new - x) < tol and max |x_new - x| < 10*tol.
   real(wp), intent(in) :: tol

   !> Real, dimension(n), input, right-hand side of the linear system
   real(wp), intent(in) :: rhs(:, :)

   !> Real, dimension(n). In input, a guess of the solution (can be zero).
   !  In output, the solution
   real(wp), intent(inout), contiguous, target :: x(:, :)

   !> Integer, in input, the maximum number of iterations. In output,
   !  the number of iterations needed to converge.
   integer, intent(inout) :: n_iter

   !> Logical, output, T if the solver converged, false otherwise.
   logical, intent(inout) :: ok

   !> External, subroutine to compute the required matrix-vector multiplication
   !  format: subroutine matvec(n, x, y)
   procedure(lx) :: matvec

   !> External, subroutine to apply the inverse diagonal matrix to a vector.
   !  format: subroutine dm1vec(n, x, y)
   procedure(ldm1x) :: dm1vec

   !> External, optional function to compute the norm of a vector.
   !> Format: real(wp) function u_norm(n, x)
   procedure(hnorm), optional :: u_norm

   integer :: it, nmat, lenb
   real(wp) :: rms_norm, max_norm, tol_max
   logical :: dodiis

   real(wp), allocatable :: y(:, :), x_diis(:, :), e_diis(:, :), bmat(:, :)
   real(wp), allocatable, target :: x_new(:, :)
   real(wp), pointer :: xptr(:)

   character(len=*), parameter :: f100 = "(t3, 'iter=', i4, ' residual norm (rms, max): ', 2d14.4)"
   character(len=*), parameter :: f110 = "(t3, 'iter=', i4, ' residual norm (', a, '): ', d14.4)"
   character(len=*), parameter :: f120 = "(t3, 'iter=', i4, ' residual norm: ', d14.4)"

   ! check inputs
   if ((norm == 4) .and. (.not.present(u_norm))) then
      error stop 'must provide a function norm(n, x) to evaluate the norm of the increment'
      return
   end if

   ! DIIS extrapolation flag
   dodiis =  (diis_max /= 0)

   ! set tolerance
   tol_max = 10.0_wp * tol

   ! extrapolation required
   if (dodiis) then

      ! allocate workspaces
      lenb = diis_max + 1
      allocate(x_diis(n, diis_max), e_diis(n, diis_max), bmat(lenb, lenb))

      ! an enigmatic constant
      nmat = 1
   end if

   ! allocate workspaces
   allocate(x_new, mold=rhs)
   allocate(y, mold=rhs)

   ! Jacobi iterations
   do it = 1, n_iter

      ! y = rhs - O x
      call matvec(self, n, x, y)
      y = rhs - y

      ! x_new = D^-1 y
      call dm1vec(self, n, y, x_new)

      ! DIIS extrapolation
      if (dodiis) then
         x_diis(:, nmat) = reshape(x_new, [size(x_new)])
         e_diis(:, nmat) = reshape(x_new - x, [size(x_new)])

         xptr(1:size(x_new)) => x_new
         call diis(n, nmat, diis_max, x_diis, e_diis, bmat, xptr)
      end if

      ! increment
      x = x_new - x

      ! rms/max norm of increment
      if (norm <= 3) then

         ! compute norm
         xptr(1:size(x)) => x
         call rmsvec(n, xptr, rms_norm, max_norm)

         ! check norm
         if (norm == 1) then
            ok = (rms_norm < tol)
         elseif (norm == 2) then
            ok = (max_norm < tol)
         else
            ok = (rms_norm < tol) .and. (max_norm < tol_max)
         end if

         ! user-provided norm of increment
      elseif (norm == 4) then

         ! just a placeholder for printing
         max_norm = -1.0_wp

         ! compute norm
         rms_norm = u_norm(self, n, x)

         ! check norm
         ok = (rms_norm < tol)

      end if

      ! printing
      if (lprint > 0) then
         if (norm == 1) then
            write(*, f110) it, 'max', max_norm
         else if (norm == 2) then
            write(*, f110) it, 'rms', rms_norm
         else if (norm == 3) then
            write(*, f100) it, rms_norm, max_norm
         else if (norm == 4) then
            write(*, f120) it, rms_norm
         end if
      end if

      ! update
      x = x_new

      ! EXIT Jacobi loop here

      if (ok) exit

   end do

   ! record number of Jacobi iterations
   n_iter = it

endsubroutine jacobi_diis


subroutine diis(n, nmat, ndiis, x, e, b, xnew)
   integer, intent(in) :: n, ndiis
   integer, intent(inout) :: nmat
   real(wp), intent(inout) :: x(:, :) !< [n, ndiis]
   real(wp), intent(inout) :: e(:, :) !< [n, ndiis]
   real(wp), intent(inout) :: b(:, :) !< [ndiis+1, ndiis+1]
   real(wp), intent(inout) :: xnew(:) !< [n]

   integer :: nmat1, i, istatus
   integer :: j, k
   logical :: ok

   real(wp), allocatable :: bloc(:, :), cex(:, :)

   if (nmat >= ndiis) then
      do j = 2, nmat - 10
         do k = 2, nmat - 10
            b(j, k) = b(j+10, k+10)
         end do
      end do
      do j = 1, nmat - 10
         x(:, j) = x(:, j+10)
         e(:, j) = e(:, j+10)
      end do
      nmat = nmat - 10
   end if
   nmat1 = nmat + 1
   allocate(bloc(nmat1, nmat1), cex(nmat1, 1), stat=istatus)
   if (istatus /= 0) then
      nmat = 1
      return
   end if

   call makeb(n, nmat, ndiis, e, b)
   bloc = b(1:nmat1, 1:nmat1)
   cex(:, :) = 0.0_wp
   cex(1, 1) = 1.0_wp
   call gjinv(nmat1, 1, bloc, cex, ok)
   if (.not. ok) then
      nmat = 1
      error stop "Upps!"
      return
   end if
   xnew = 0.0_wp
   do i = 1, nmat
      xnew = xnew + cex(i+1, 1)*x(:, i)
   end do
   nmat = nmat + 1

end subroutine diis


pure subroutine makeb(n, nmat, ndiis, e, b)
   integer, intent(in) :: n, nmat, ndiis
   real(wp), intent(in) :: e(n, ndiis)
   real(wp), intent(inout) :: b(ndiis+1, ndiis+1)

   integer :: i
   real(wp) :: bij

   ! 1st built
   if (nmat == 1) then
      !       [ 0 |  1  ]
      !   b = [ --+---- ]
      !       [ 1 | e*e ]
      b(1, 1) = 0.0_wp
      b(1, 2) = 1.0_wp
      b(2, 1) = 1.0_wp
      b(2, 2) = dot_product(e(:, 1), e(:, 1))
   else
      ! subsequent builts
      ! first, update the lagrangian line:
      b(nmat+1, 1) = 1.0_wp
      b(1, nmat+1) = 1.0_wp
      ! now, compute the new matrix elements:
      do i = 1, nmat - 1
         bij = dot_product(e(:, i), e(:, nmat))
         b(nmat+1, i+1) = bij
         b(i+1, nmat+1) = bij
      end do
      b(nmat+1, nmat+1) = dot_product(e(:, nmat), e(:, nmat))
   end if

end subroutine makeb


pure subroutine gjinv(n, nrhs, a, b, ok)
   integer, intent(in) :: n, nrhs
   logical, intent(inout) :: ok
   real(wp), intent(inout) :: a(:, :) ! [n, n]
   real(wp), intent(inout) :: b(:, :) ! [n, nrhs]

   integer :: i, j, k, irow, icol, istatus
   real(wp) :: big, dum, pinv

   integer, allocatable :: indxc(:), indxr(:), piv(:)
   real(wp), allocatable :: scr(:)

   ok = .false.

   allocate(indxc(n), indxr(n), piv(n), stat=istatus)
   if (istatus /= 0) then
      return
   end if
   allocate (scr(n), stat=istatus)
   if (istatus /= 0) then
      return
   end if

   piv = 0

   irow = 0
   icol = 0
   do i = 1, n
      big = 0.0_wp
      do j = 1, n
         if (piv(j) /= 1) then
            do k = 1, n
               if (piv(k) == 0) then
                  if (abs(a(j, k)) > big) then
                     big  = abs(a(j, k))
                     irow = j
                     icol = k
                  end if
               end if
            end do
         end if
      end do

      piv(icol) = piv(icol) + 1
      if (piv(icol) > 1) then
         !call warning('singular matrix', source)
         return
      end if
      if (irow /= icol) then
         scr         = a(irow, :)
         a(irow, :)   = a(icol, :)
         a(icol, :)   = scr
         scr(1:nrhs) = b(irow, :)
         b(irow, :)   = b(icol, :)
         b(icol, :)   = scr(1:nrhs)
      end if

      indxr(i) = irow
      indxc(i) = icol

      if (a(icol, icol) == 0.0_wp) then
         !call warning('singular matrix', source)
         return
      end if

      pinv = 1.0_wp/a(icol, icol)
      a(icol, icol) = 1.0_wp
      a(icol, :) = a(icol, :)*pinv
      b(icol, :) = b(icol, :)*pinv

      do j = 1, n
         if (j /= icol) then
            dum       = a(j, icol)
            a(j, icol) = 0.0_wp
            a(j, :)    = a(j, :) - a(icol, :)*dum
            b(j, :)    = b(j, :) - b(icol, :)*dum
         end if
      end do
   end do

   do j = n, 1, -1
      if (indxr(j) /= indxc(j)) then
         scr           = a(:, indxr(j))
         a(:, indxr(j)) = a(:, indxc(j))
         a(:, indxc(j)) = scr
      end if
   end do

   ok = .true.

end subroutine gjinv


!> Compute root-mean-square and max norm
pure subroutine rmsvec(n, v, vrms, vmax)
   integer, intent(in) :: n
   real(wp), intent(in) :: v(:) !< [n]
   real(wp), intent(inout) :: vrms, vmax

   integer :: i

   ! initialize
   vrms = 0.0_wp
   vmax = 0.0_wp

   ! loop over entries
   do i = 1, n

      ! max norm
      vmax = max(vmax, abs(v(i)))

      ! rms norm
      vrms = vrms + v(i)*v(i)

   end do

   ! the much neglected square root
   vrms = sqrt(vrms/real(n, wp))

end subroutine rmsvec


!> Given a vector x, compute y = Lx, where L is the ddCOSMO matrix
!  (off-diagonal blocks only).
subroutine lx(self, n, x, y)

   type(domain_decomposition), intent(in) :: self
   integer, intent(in) :: n
   real(wp), intent(in) :: x(:, :) ! [self%nylm, self%nat]
   real(wp), intent(inout) :: y(:, :) ! [self%nylm, self%nat]

   integer :: iat
   real(wp), allocatable :: pot(:), vplm(:), basloc(:), vcos(:), vsin(:)

   ! allocate workspaces
   allocate(pot(self%ngrid), vplm(self%nylm), basloc(self%nylm), &
      & vcos(self%lmax+1), vsin(self%lmax+1))

   if (self%iprint >= 5) call prtsph(self, 'X', self%nat, 0, x)

   ! initialize
   y(:, :) = 0.0_wp

   !$omp parallel do default(none) schedule(runtime) shared(self, y, x) &
   !$omp private(iat, pot, basloc, vplm, vcos, vsin)
   ! loop over spheres
   do iat = 1, self%nat

      ! compute NEGATIVE action of off-digonal blocks
      call calcv(self, .false., iat, pot, x, basloc, vplm, vcos, vsin)
      call intrhs(self, iat, pot, y(:, iat))

      ! action of off-diagonal blocks
      y(:, iat) = - y(:, iat)

   end do

   if (self%iprint >= 5) call prtsph(self, 'LX (off diagonal)', self%nat, 0, y)

end subroutine lx


!> Given a vector x, compute y = L*x, where L* is the adjoint ddCOSMO matrix.
!  if dodiag is set to .true., L includes the diagonal blocks, otherwise
!  L only includes the off-diagonal ones.
subroutine lstarx(self, n, x, y)

   type(domain_decomposition), intent(in) :: self
   integer, intent(in) :: n
   real(wp), intent(in) :: x(:, :) ! [self%nylm, self%nat]
   real(wp), intent(inout) :: y(:, :) ! [self%nylm, self%nat]

   integer :: iat, ig
   real(wp), allocatable :: xi(:, :), vplm(:), basloc(:), vcos(:), vsin(:)

   ! allocate workspaces
   allocate(xi(self%ngrid, self%nat), vplm(self%nylm), &
      & basloc(self%nylm), vcos(self%lmax+1), vsin(self%lmax+1))

   if (self%iprint >= 5) call prtsph(self, 'X', self%nat, 0, x)

   ! initilize
   y(:, :) = 0.0_wp

   ! expand x over spherical harmonics
   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(self, xi, x) private(iat, ig)
   ! loop over spheres
   do iat = 1, self%nat
      ! loop over griwpoints
      do ig = 1, self%ngrid
         xi(ig, iat) = dot_product(x(:, iat), self%basis(:, ig))
      end do
   end do

   ! compute action
   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(self, xi, y) private(iat, basloc, vplm, vcos, vsin)
   ! loop over spheres
   do iat = 1, self%nat

      ! compute NEGATIVE action of off-digonal blocks
      call adjrhs(self, iat, xi, y(:, iat), basloc, vplm, vcos, vsin)

      ! action of off-diagonal blocks
      y(:, iat) = - y(:, iat)

   end do

   if (self%iprint >= 5) call prtsph(self, 'L*X (off-diagonal)', self%nat, 0, y)

end subroutine lstarx


!> Given a vector x, apply the inverse diagonal (block) of the L matrix:
pure subroutine ldm1x(self, n, x, y)
   type(domain_decomposition), intent(in) :: self
   integer, intent(in) :: n
   real(wp), intent(in) :: x(:, :) ! [self%nylm, self%nat]
   real(wp), intent(inout) :: y(:, :) ! [self%nylm, self%nat]

   integer :: iat

   ! loop over spheres
   do iat = 1, self%nat
      ! apply inverse
      y(:, iat) = self%facl*x(:, iat)
   end do

end subroutine ldm1x


!> Compute the h^-1/2 norm of the increment on each sphere, then take the
!  rms value.
real(wp) function hnorm(self, n, x)
   type(domain_decomposition), intent(in) :: self
   integer, intent(in) :: n
   real(wp), intent(in) :: x(:, :) ! [self%nylm, self%nat]
   integer :: iat
   real(wp) :: vrms, vmax
   real(wp), allocatable :: u(:)

   ! allocate workspace
   allocate(u(self%nat))

   ! loop over spheres
   do iat = 1, self%nat
      ! compute norm contribution
      call hsnorm(self, x(:, iat), u(iat))
   end do

   ! compute rms of norms
   call rmsvec(self%nat, u, vrms, vmax)

   ! return value
   hnorm = vrms

end function hnorm


!> Wrapper for the linear solvers for COSMO equation
!    L sigma = G
!  This routine performs the following operations :
!   - allocates memory for the linear solvers
!   - if star is false and cart is true, assembles the right-hand side for the COSMO
!     equations.
!   - computes a guess for the solution (using the inverse diagonal);
!   - calls the iterative solver;
subroutine solve_cosmo_direct(self, cart, phi, glm, sigma, restart)

   !> Error source
   character(len=*), parameter :: source = 'cosmo::solve_cosmo_direct'
   type(domain_decomposition), intent(in) :: self

   !> true:  the right-hand side for the COSMO has to be assembled
   !         inside this routine and the unscaled potential at the
   !         external points of the cavity is provided in phi.
   !  false: the right-hand side for the COSMO equations is provided
   !         in glm.
   logical, intent(in) :: cart

   !> Contains the potential at the external cavity points if cart is true.
   !  phi is not referenced in any other case.
   real(wp), contiguous, intent(in) :: phi(:)

   !> Contains the right-hand side for the COSMO equations if cart is false.
   !  glm is not referenced in any other case
   real(wp), contiguous, intent(in) :: glm(:, :)

   !> The solution to the COSMO (adjoint) equations
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   !> Initial guess is provided on sigma
   logical, intent(in) :: restart

   integer :: iat, istatus, n_iter
   real(wp) :: tol
   logical :: ok

   real(wp), allocatable  :: g(:, :), rhs(:, :)

   ! parameters for the solver and matvec routine
   tol     = self%conv
   n_iter  = 200

   ! DIRECT COSMO EQUATION L X = g

   ! allocate workspace for rhs
   allocate(rhs(self%nylm, self%nat), stat=istatus)
   if (istatus /= 0) then
      write(*, *) ' cosmo: [2] failed allocation'
   endif

   ! 1. RHS
   ! assemble rhs
   if (cart) then

      ! allocate workspace for weighted potential
      allocate(g(self%ngrid, self%nat) , stat=istatus)
      if (istatus /= 0) then
         write(*, *) ' cosmo: [3] failed allocation'
      endif

      ! weight the potential...
      call wghpot(self, phi, g)

      ! ... and compute its multipolar expansion
      do iat = 1, self%nat
         call intrhs(self, iat, g(:, iat), rhs(:, iat))
      enddo

      ! deallocate workspace
      deallocate(g , stat=istatus)
      if (istatus /= 0) then
         write(*, *) 'cosmo: [1] failed deallocation'
      endif

   else
      ! no need to manipulate rhs
      rhs = glm
   end if

   ! 2. INITIAL GUESS
   if (.not.restart) then
      do iat = 1, self%nat
         sigma(:, iat) = self%facl(:)*rhs(:, iat)
      end do
   end if

   ! 3. SOLVER CALL
   ! Jacobi method :
   ! L X = (diag + offdiag) X = g   ==>    X = diag^-1 (g - offdiag X_guess)
   ! action of  diag^-1 :  ldm1x
   ! action of  offdiag :  lx
   call jacobi_diis(self, self%nat*self%nylm, self%iprint, &
      & ndiis, 4, tol, rhs, sigma, n_iter, ok, lx, ldm1x, hnorm)

   ! check solution
   if (.not.ok) then
      error stop 'direct ddCOSMO did not converge!'
      return
   endif

end subroutine solve_cosmo_direct


!> Wrapper for the linear solvers for adjoint COSMO equation
!>   L^* sigma = Psi
!> This routine performs the following operations :
!>  - allocates memory for the linear solvers
!>  - computes a guess for the solution (using the inverse diagonal);
!>  - calls the iterative solver;
subroutine solve_cosmo_adjoint(self, psi, sigma, restart, accuracy)
   ! Error source
   character(len=*), parameter :: source = 'cosmo::solve_cosmo_adjoint'
   type(domain_decomposition), intent(in) :: self

   !> The psi vector. it is used as a right-hand side
   real(wp), contiguous, intent(in) :: psi(:, :)

   !> The solution to the COSMO (adjoint) equations
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   !> Initial guess is provided on sigma
   logical, intent(in) :: restart

   !> Overwrite accuracy
   real(wp), intent(in), optional :: accuracy

   integer :: iat, n_iter
   real(wp) :: tol
   logical :: ok

   ! parameters for the solver and matvec routine
   if (present(accuracy)) then
      tol = accuracy
   else
      tol = self%conv
   end if
   n_iter  = 200

   ! 1. INITIAL GUESS
   if (.not.restart) then
      do iat = 1, self%nat
         sigma(:, iat) = self%facl(:)*psi(:, iat)
      end do
   end if

   ! 2. SOLVER CALL
   ! Jacobi method : see above
   call jacobi_diis(self, self%nat*self%nylm, self%iprint, &
      & ndiis, 4, tol, psi, sigma, n_iter, ok, lstarx, ldm1x, hnorm)

   ! check solution
   if (.not.ok) then
      error stop 'adjoint ddCOSMO did not converge!'
      return
   endif

end subroutine solve_cosmo_adjoint


!> Sample driver for the calculation of the ddCOSMO gradient.
subroutine get_deriv(self, keps, phi, sigma, s, gradient)
   type(domain_decomposition), intent(in) :: self
   real(wp), intent(in) :: keps
   real(wp), intent(in) :: phi(:)
   real(wp), intent(in) :: sigma(:, :)
   real(wp), intent(in) :: s(:, :)
   real(wp), intent(inout) :: gradient(:, :)

   integer :: iat, ig, ii

   real(wp), allocatable :: xi(:, :), phiexp(:, :)
   real(wp), allocatable :: basloc(:), dbsloc(:, :), vplm(:), vcos(:), vsin(:)

   allocate (xi(self%ngrid, self%nat), phiexp(self%ngrid, self%nat))
   allocate (basloc(self%nylm), dbsloc(3, self%nylm), vplm(self%nylm), &
      & vcos(self%lmax+1), vsin(self%lmax+1))

   ! compute xi:
   !$omp parallel do default(none) collapse(2) schedule(runtime) &
   !$omp shared(self, s, xi) private(iat, ig)
   do iat = 1, self%nat
      do ig = 1, self%ngrid
         xi(ig, iat) = dot_product(s(:, iat), self%basis(:, ig))
      end do
   end do

   ! expand the potential on a sphere-by-sphere basis (needed for parallelism):
   ii = 0
   phiexp(:, :) = 0.0_wp
   do iat = 1, self%nat
      do ig = 1, self%ngrid
         if (self%ui(ig, iat) > 0.0_wp) then
            ii = ii + 1
            phiexp(ig, iat) = phi(ii)
         end if
      end do
   end do

   gradient(:, :) = 0.0_wp
   do iat = 1, self%nat
      call fdoka(self, iat, sigma, xi(:, iat), basloc, dbsloc, vplm, &
         & vcos, vsin, gradient(:, iat))
      call fdokb(self, iat, sigma, xi, basloc, dbsloc, vplm, vcos, vsin, &
         & gradient(:, iat))
      call fdoga(self, iat, xi, phiexp, gradient(:, iat))
   end do

   deallocate (basloc, dbsloc, vplm, vcos, vsin)
   deallocate (xi, phiexp)

   ! scale the forces time the cosmo factor:
   gradient = keps*gradient

end subroutine get_deriv


!> Compute
!
! \zeta(n, i) =
!
!  1/2 f(\eps) sum w_n U_n^i Y_l^m(s_n) [S_i]_l^m
!              l, m
!
subroutine get_zeta(self, keps, s, zeta)
   type(domain_decomposition), intent(in) :: self
   real(wp), intent(in) :: keps
   real(wp), intent(in) :: s(:, :) ! [self%nylm, self%nat]
   real(wp), intent(inout) :: zeta(:) ! [self%ncav]

   integer :: its, iat, ii

   ii = 0
   do iat = 1, self%nat
      do its = 1, self%ngrid
         if (self%ui(its, iat) > 0.0_wp) then
            ii = ii + 1
            zeta(ii) = keps * self%w(its) * self%ui(its, iat) &
               & * dot_product(self%basis(:, its), s(:, iat))
         end if
      end do
   end do

end subroutine get_zeta


end module tblite_solvation_cpcm_dd

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/param/element.f90
!> Provides records for the element specific parameters

!> Definition of the element specific parameter records
module tblite_param_element
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io_symbols, only : to_number, symbol_length
   use mctc_data_paulingen, only : get_pauling_en
   use tblite_param_serde, only : serde_record
   use tblite_toml, only : toml_table, toml_array, get_value, set_value, add_array, len
   implicit none
   private

   public :: count


   !> The conversion factor from eV to Hartree is used for compatibility with older
   !> versions of xtb
   real(wp), parameter :: evtoau = 1.0_wp / 27.21138505_wp

   integer, parameter :: ngauss_default = 6
   real(wp), parameter :: kcn_default = 0.0_wp, lgam_default = 0.0_wp, &
      & mprad_default = 5.0_wp, xbond_default = 0.0_wp

   character(len=*), parameter :: k_shells = "shells", k_levels = "levels", &
      & k_shpoly = "shpoly", k_slater = "slater", k_refocc = "refocc", k_ngauss = "ngauss", &
      & k_gam = "gam", k_lgam = "lgam", k_gam3 = "gam3", k_kcn = "kcn", k_zeff = "zeff", &
      & k_arep = "arep", k_dkernel = "dkernel", k_qkernel = "qkernel", k_mprad = "mprad", &
      & k_mpvcn = "mpvcn", k_xbond = "xbond", k_en = "en"

   !> Representation of the element specific parameters
   type, public, extends(serde_record) :: element_record
      !> Element symbol of specie represented by this record
      character(len=symbol_length) :: sym = ''
      !> Atomic number of the specie represented by this record
      integer :: num = 0

      !> Effective nuclear charge used in repulsion
      real(wp) :: zeff = 0.0_wp
      !> Repulsion exponent
      real(wp) :: alpha = 0.0_wp

      !> Halogen bonding strength
      real(wp) :: xbond = 0.0_wp

      !> Number of valence and polarization shells
      integer :: nsh = 0
      !> Angular momentum for each shell
      integer, allocatable :: lsh(:)
      !> Principal quantum number for each shell
      integer, allocatable :: pqn(:)
      !> Number of primitive Gaussian functions used in the STO-NG expansion for each shell
      integer, allocatable :: ngauss(:)
      !> Atomic level energies for each shell
      real(wp), allocatable :: levels(:)
      !> Slater exponents of the STO-NG functions for each shell
      real(wp), allocatable :: slater(:)
      !> Reference occupation for each shell
      real(wp), allocatable :: refocc(:)
      !> CN dependent shift of the self energy for each shell
      real(wp), allocatable :: kcn(:)
      !> Polynomial enhancement for Hamiltonian elements
      real(wp), allocatable :: shpoly(:)

      !> Chemical hardness / Hubbard parameter
      real(wp) :: gam = 0.0_wp
      !> Relative chemical hardness for each shell
      real(wp), allocatable :: lgam(:)

      !> Atomic Hubbard derivative
      real(wp) :: gam3 = 0.0_wp

      !> Dipolar exchange-correlation kernel
      real(wp) :: dkernel = 0.0_wp
      !> Quadrupolar exchange-correlation kernel
      real(wp) :: qkernel = 0.0_wp
      !> Multipole radius
      real(wp) :: mprad = 0.0_wp
      !> Multipole valence CN
      real(wp) :: mpvcn = 0.0_wp

      !> Electronnegativity
      real(wp) :: en = 0.0_wp
   contains
      generic :: load => load_from_array
      generic :: dump => dump_to_array
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Read parametrization data from parameter array
      procedure, private :: load_from_array
      !> Write parametrization data to parameter array
      procedure, private :: dump_to_array
   end type


   !> Masking for the element record
   type, public :: element_mask
      !> Element symbol of specie represented by this record
      character(len=symbol_length) :: sym = ''
      !> Atomic number of the specie represented by this record
      integer :: num = 0

      !> Effective nuclear charge used in repulsion
      logical :: zeff
      !> Repulsion exponent
      logical :: alpha

      !> Halogen bonding strength
      logical :: xbond

      !> Number of valence and polarization shells
      integer :: nsh
      !> Atomic level energies for each shell
      logical, allocatable :: levels(:)
      !> Slater exponents of the STO-NG functions for each shell
      logical, allocatable :: slater(:)
      !> CN dependent shift of the self energy for each shell
      logical, allocatable :: kcn(:)
      !> Polynomial enhancement for Hamiltonian elements
      logical, allocatable :: shpoly(:)

      !> Chemical hardness / Hubbard parameter
      logical :: gam
      !> Relative chemical hardness for each shell
      logical, allocatable :: lgam(:)

      !> Atomic Hubbard derivative
      logical :: gam3

      !> Dipolar exchange-correlation kernel
      logical :: dkernel
      !> Quadrupolar exchange-correlation kernel
      logical :: qkernel
   end type element_mask


   interface count
      module procedure :: count_mask
   end interface count


contains


!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   class(element_record), intent(inout) :: self
   type(toml_table), intent(inout) :: table
   type(error_type), allocatable, intent(out) :: error

   character(len=:), allocatable :: sym
   type(toml_array), pointer :: array
   integer :: stat

   call table%get_key(sym)
   self%sym = sym
   self%num = to_number(sym)

   call get_value(table, k_shells, array)
   if (.not.associated(array)) then
      call fatal_error(error, "No shells specified for "//trim(self%sym))
      return
   end if
   call get_shells(self, array, error)
   if (allocated(error)) return

   call get_value(table, k_levels, array)
   if (.not.associated(array)) then
      call fatal_error(error, "No atomic levels specified for "//trim(self%sym))
      return
   end if
   call get_levels(self, array, error)
   if (allocated(error)) return

   call get_value(table, k_slater, array)
   if (.not.associated(array)) then
      call fatal_error(error, "No slater exponents specified for "//trim(self%sym))
      return
   end if
   call get_slater(self, array, error)
   if (allocated(error)) return

   call get_value(table, k_refocc, array)
   if (.not.associated(array)) then
      call fatal_error(error, "No reference occupation specified for "//trim(self%sym))
      return
   end if
   call get_refocc(self, array, error)
   if (allocated(error)) return

   call get_value(table, k_ngauss, array, requested=.false.)
   if (associated(array)) then
      call get_ngauss(self, array, error)
      if (allocated(error)) return
   else
      allocate(self%ngauss(self%nsh), source=ngauss_default)
   end if

   call get_value(table, k_shpoly, array)
   if (.not.associated(array)) then
      call fatal_error(error, "No shell-polynomials specified for "//trim(self%sym))
      return
   end if
   call get_shpoly(self, array, error)
   if (allocated(error)) return

   call get_value(table, k_kcn, array, requested=.false.)
   if (associated(array)) then
      call get_kcn(self, array, error)
      if (allocated(error)) return
   else
      allocate(self%kcn(self%nsh), source=kcn_default)
   end if

   call get_value(table, k_gam, self%gam, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid atomic Hubbard parameter for "//trim(self%sym))
      return
   end if
   call get_value(table, k_lgam, array, requested=.false.)
   if (associated(array)) then
      call get_lgam(self, array, error)
      if (allocated(error)) return
   else
      allocate(self%lgam(self%nsh), source=lgam_default)
   end if

   call get_value(table, k_gam3, self%gam3, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid atomic Hubbard derivative for "//trim(self%sym))
      return
   end if

   call get_repulsion(self, table, error)
   if (allocated(error)) return

   call get_multipole(self, table, error)
   if (allocated(error)) return

   call get_value(table, k_xbond, self%xbond, xbond_default, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid halogen bonding strength for "//trim(self%sym))
      return
   end if

   call get_value(table, k_en, self%en, get_pauling_en(self%sym), stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid electronegativity for "//trim(self%sym))
      return
   end if

end subroutine load_from_toml

subroutine get_multipole(self, table, error)
   type(element_record), intent(inout) :: self
   type(toml_table), intent(inout) :: table
   type(error_type), allocatable, intent(out) :: error

   integer :: stat

   call get_value(table, k_dkernel, self%dkernel, 0.0_wp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid dipole kernel for "//trim(self%sym))
      return
   end if
   call get_value(table, k_qkernel, self%qkernel, 0.0_wp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid quadrupole kernel for "//trim(self%sym))
      return
   end if
   call get_value(table, k_mprad, self%mprad, mprad_default, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid multipole damping radius for "//trim(self%sym))
      return
   end if
   call get_value(table, k_mpvcn, self%mpvcn, 0.0_wp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid multipole valence CN for "//trim(self%sym))
      return
   end if
end subroutine get_multipole

subroutine get_repulsion(self, table, error)
   type(element_record), intent(inout) :: self
   type(toml_table), intent(inout) :: table
   type(error_type), allocatable, intent(out) :: error

   integer :: stat

   call get_value(table, k_zeff, self%zeff, real(self%num, wp), stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid effective nuclear charge for "//trim(self%sym))
      return
   end if
   call get_value(table, k_arep, self%alpha, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid repulsion exponent for "//trim(self%sym))
      return
   end if
end subroutine get_repulsion

subroutine get_shells(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   character(len=:), allocatable :: tmp

   self%nsh = len(array)
   if (self%nsh == 0) then
      call fatal_error(error, "No entries for "//trim(self%sym))
      return
   end if
   allocate(self%lsh(self%nsh))
   allocate(self%pqn(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%lsh(i) = get_lsh(tmp(2:2))
      self%pqn(i) = get_pqn(tmp(1:1))
   end do

   if (any(self%lsh < 0)) then
      call fatal_error(error, "Invalid angular momentum for "//trim(self%sym))
      return
   end if

   if (any(self%pqn < 1)) then
      call fatal_error(error, "Invalid principal quantum number for "//trim(self%sym))
      return
   end if

end subroutine get_shells

pure function get_pqn(str) result(pqn)
   character, intent(in) :: str
   integer :: pqn
   select case(str)
   case default
      pqn = 0
   case("1")
      pqn = 1
   case("2")
      pqn = 2
   case("3")
      pqn = 3
   case("4")
      pqn = 4
   case("5")
      pqn = 5
   case("6")
      pqn = 6
   end select
end function get_pqn

pure function get_lsh(str) result(lsh)
   character, intent(in) :: str
   integer :: lsh
   select case(str)
   case default
      lsh = -1
   case("s", "S")
      lsh = 0
   case("p", "P")
      lsh = 1
   case("d", "D")
      lsh = 2
   case("f", "F")
      lsh = 3
   case("g", "G")
      lsh = 4
   end select
end function get_lsh

subroutine get_levels(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   real(wp) :: tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient atomic level energies for "//trim(self%sym))
      return
   end if
   allocate(self%levels(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%levels(i) = tmp * evtoau
   end do
end subroutine get_levels

subroutine get_shpoly(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   real(wp) :: tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient shell-polynomials for "//trim(self%sym))
      return
   end if
   allocate(self%shpoly(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%shpoly(i) = tmp
   end do
end subroutine get_shpoly

subroutine get_slater(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   real(wp) :: tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient slater exponents for "//trim(self%sym))
      return
   end if
   allocate(self%slater(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%slater(i) = tmp
   end do

   if (any(self%slater < epsilon(0.0_wp))) then
      call fatal_error(error, "Invalid slater exponents for "//trim(self%sym))
   end if
end subroutine get_slater

subroutine get_refocc(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   real(wp) :: tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient reference occupations for "//trim(self%sym))
      return
   end if
   allocate(self%refocc(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%refocc(i) = tmp
   end do
end subroutine get_refocc

subroutine get_ngauss(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i, tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient primitive gaussians for "//trim(self%sym))
      return
   end if
   allocate(self%ngauss(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%ngauss(i) = tmp
   end do

   if (any(self%ngauss < 1) .or. any(self%ngauss > 6)) then
      call fatal_error(error, "Invalid number of primitive gaussian for "//trim(self%sym))
   end if
end subroutine get_ngauss

subroutine get_kcn(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   real(wp) :: tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient CN shift parameters for "//trim(self%sym))
      return
   end if
   allocate(self%kcn(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%kcn(i) = tmp * evtoau
   end do
end subroutine get_kcn

subroutine get_lgam(self, array, error)
   type(element_record), intent(inout) :: self
   type(toml_array), intent(inout) :: array
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   real(wp) :: tmp

   if (len(array) < self%nsh) then
      call fatal_error(error, "Insufficient shell hardnesses for "//trim(self%sym))
      return
   end if
   allocate(self%lgam(self%nsh))

   do i = 1, self%nsh
      call get_value(array, i, tmp)
      self%lgam(i) = tmp
   end do
end subroutine get_lgam

!> Write parametrization data to TOML data structure
subroutine dump_to_toml(self, table, error)
   class(element_record), intent(in) :: self
   type(toml_table), intent(inout) :: table
   type(error_type), allocatable, intent(out) :: error

   integer :: i
   type(toml_array), pointer :: array
   character, parameter :: lsh(0:4) = ["s", "p", "d", "f", "g"]
   character, parameter :: pqn(1:6) = ["1", "2", "3", "4", "5", "6"]

   call add_array(table, k_shells, array)
   do i = 1, self%nsh
      call set_value(array, i, pqn(self%pqn(i))//lsh(self%lsh(i)))
   end do

   call add_array(table, k_levels, array)
   do i = 1, self%nsh
      call set_value(array, i, self%levels(i) / evtoau)
   end do

   call add_array(table, k_slater, array)
   do i = 1, self%nsh
      call set_value(array, i, self%slater(i))
   end do

   call add_array(table, k_ngauss, array)
   do i = 1, self%nsh
      call set_value(array, i, self%ngauss(i))
   end do

   call add_array(table, k_refocc, array)
   do i = 1, self%nsh
      call set_value(array, i, self%refocc(i))
   end do

   call add_array(table, k_shpoly, array)
   do i = 1, self%nsh
      call set_value(array, i, self%shpoly(i))
   end do

   call add_array(table, k_kcn, array)
   do i = 1, self%nsh
      call set_value(array, i, self%kcn(i) / evtoau)
   end do

   call set_value(table, k_gam, self%gam)
   call add_array(table, k_lgam, array)
   do i = 1, self%nsh
      call set_value(array, i, self%lgam(i))
   end do

   call set_value(table, k_gam3, self%gam3)

   call set_value(table, k_zeff, self%zeff)
   call set_value(table, k_arep, self%alpha)
   call set_value(table, k_xbond, self%xbond)
   call set_value(table, k_en, self%en)

   call set_value(table, k_dkernel, self%dkernel)
   call set_value(table, k_qkernel, self%qkernel)
   call set_value(table, k_mprad, self%mprad)
   call set_value(table, k_mpvcn, self%mpvcn)

end subroutine dump_to_toml

!> Read parametrization data from parameter array
subroutine load_from_array(self, array, offset, base, mask, error)
   class(element_record), intent(inout) :: self
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: offset
   type(element_record), intent(in) :: base
   type(element_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   select type(self)
   type is (element_record)
      self = base
   end select

   call load_atom_par(self%zeff, mask%zeff, array, offset)
   call load_atom_par(self%alpha, mask%alpha, array, offset)

   call load_atom_par(self%xbond, mask%xbond, array, offset)

   call load_shell_par(self%levels, mask%levels, array, offset, scale=evtoau)
   call load_shell_par(self%slater, mask%slater, array, offset)
   call load_shell_par(self%kcn, mask%kcn, array, offset, scale=evtoau)
   call load_shell_par(self%shpoly, mask%shpoly, array, offset, scale=0.01_wp)

   call load_atom_par(self%gam, mask%gam, array, offset)
   call load_shell_par(self%lgam, mask%lgam, array, offset)

   call load_atom_par(self%gam3, mask%gam3, array, offset, scale=0.1_wp)

   call load_atom_par(self%dkernel, mask%dkernel, array, offset, scale=0.01_wp)
   call load_atom_par(self%qkernel, mask%qkernel, array, offset, scale=0.01_wp)
end subroutine load_from_array

!> Write parametrization data to parameter array
subroutine dump_to_array(self, array, offset, mask, error)
   class(element_record), intent(in) :: self
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: offset
   type(element_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   call dump_atom_par(self%zeff, mask%zeff, array, offset)
   call dump_atom_par(self%alpha, mask%alpha, array, offset)

   call dump_atom_par(self%xbond, mask%xbond, array, offset)

   call dump_shell_par(self%levels, mask%levels, array, offset, scale=evtoau)
   call dump_shell_par(self%slater, mask%slater, array, offset)
   call dump_shell_par(self%kcn, mask%kcn, array, offset, scale=evtoau)
   call dump_shell_par(self%shpoly, mask%shpoly, array, offset, scale=0.01_wp)

   call dump_atom_par(self%gam, mask%gam, array, offset)
   call dump_shell_par(self%lgam, mask%lgam, array, offset)

   call dump_atom_par(self%gam3, mask%gam3, array, offset, scale=0.1_wp)

   call dump_atom_par(self%dkernel, mask%dkernel, array, offset, scale=0.01_wp)
   call dump_atom_par(self%qkernel, mask%qkernel, array, offset, scale=0.01_wp)
end subroutine dump_to_array

pure subroutine load_atom_par(par, mask, array, ii, scale)
   real(wp), intent(inout) :: par
   logical, intent(in) :: mask
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: ii
   real(wp), intent(in), optional :: scale
   real(wp) :: scale_
   scale_ = 1.0_wp
   if (present(scale)) scale_ = scale
   if (mask) then
      ii = ii+1
      par = array(ii) * scale_
   end if
end subroutine load_atom_par

pure subroutine load_shell_par(par, mask, array, ii, scale)
   real(wp), intent(inout) :: par(:)
   logical, intent(in) :: mask(:)
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: ii
   real(wp), intent(in), optional :: scale
   real(wp) :: scale_
   integer :: ish
   scale_ = 1.0_wp
   if (present(scale)) scale_ = scale
   do ish = 1, size(par)
      if (mask(ish)) then
         ii = ii+1
         par(ish) = array(ii) * scale_
      end if
   end do
end subroutine load_shell_par

pure subroutine dump_atom_par(par, mask, array, ii, scale)
   real(wp), intent(in) :: par
   logical, intent(in) :: mask
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: ii
   real(wp), intent(in), optional :: scale
   real(wp) :: scale_
   scale_ = 1.0_wp
   if (present(scale)) scale_ = scale
   if (mask) then
      ii = ii+1
      array(ii) = par / scale_
   end if
end subroutine dump_atom_par

pure subroutine dump_shell_par(par, mask, array, ii, scale)
   real(wp), intent(in) :: par(:)
   logical, intent(in) :: mask(:)
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: ii
   real(wp), intent(in), optional :: scale
   real(wp) :: scale_
   integer :: ish
   scale_ = 1.0_wp
   if (present(scale)) scale_ = scale
   do ish = 1, size(par)
      if (mask(ish)) then
         ii = ii+1
         array(ii) = par(ish) / scale_
      end if
   end do
end subroutine dump_shell_par

elemental function count_mask(mask) result(ncount)
   type(element_mask), intent(in) :: mask
   integer :: ncount
   ncount = count([ &
      mask%zeff, &
      mask%alpha, &
      mask%xbond, &
      mask%levels, &
      mask%slater, &
      mask%kcn, &
      mask%shpoly, &
      mask%gam, &
      mask%lgam, &
      mask%gam3, &
      mask%dkernel, &
      mask%qkernel])
end function count_mask

end module tblite_param_element

module test_xtbml
   use mctc_env, only : wp
   use mctc_env_error, only : fatal_error
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
   & test_failed
   use mctc_io, only : structure_type
   use mctc_io_convert, only : aatoau
   use mctc_io_structure, only : new
   use tblite_basis_type, only : basis_type
   use tblite_blas, only : gemm
   use tblite_container, only : container_type
   use tblite_context_type, only : context_type
   use tblite_data_spin, only : get_spin_constant
   use tblite_double_dictionary, only : double_dictionary_type
   use tblite_features, only : get_tblite_feature
   use tblite_integral_type, only : integral_type
   use tblite_param_post_processing, only : post_processing_record_list, &
      & post_processing_record, xtbml_record
   use tblite_post_processing_list, only : add_post_processing, post_processing_list
   use tblite_results, only : results_type
   use tblite_solvation, only : alpb_input, solvent_data, alpb_solvation, new_alpb, born_kernel, get_solvent_data, &
      & ddx_input, ddx_solvation, new_ddx, ddx_solvation_model
   use tblite_spin, only : spin_polarization, new_spin_polarization
   use tblite_toml, only : toml_table, add_table, set_value, toml_key, get_value, &
      & toml_array, add_array
   use tblite_wavefunction , only : wavefunction_type, new_wavefunction
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator
   use tblite_xtb_gfn1, only : new_gfn1_calculator
   use tblite_xtb_h0, only : get_hamiltonian
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   implicit none
   private
   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: acc = 0.001_wp
   real(wp), parameter :: kt = 300.0_wp * 3.166808578545117e-06_wp
   real(wp), parameter :: thr2 = 10e-4
   public :: collect_xtbml
contains

subroutine collect_xtbml(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("xtbml-mulliken-charges", test_mulliken_charges_shell_h2p),&
      new_unittest("xtbml-dipm-mol-sum-up-h2+", test_dipm_shell_h2p),&
      new_unittest("xtbml-dipm-mol-sum-up-co2", test_dipm_shell_co2),&
      new_unittest("xtbml-qp-sum-up-benzene", test_qp_shell_benz),&
      new_unittest("xtbml-qp-dipm-benzene-high-a", test_qp_shell_benz_high_a),&
      new_unittest("xtbml-energy-sum-up-gfn2", test_energy_sum_up_gfn2),&
      new_unittest("xtbml-energy-sum-up-gfn1", test_energy_sum_up_gfn1),&
      new_unittest("xtbml-rot", test_rotation_co2),&
      new_unittest("xtbml-translation", test_translation_co2),&
      new_unittest("xtbml-orbital-energy", test_orbital_energy_ref),&
      new_unittest("xtbml-param-load", test_xtbml_param_load),&
      new_unittest("xtbml-param-dump", test_xtbml_param_dump),&
      new_unittest("xtbml-param-bad-inp", test_xtbml_param_bad_inp),&
      new_unittest("xtbml-h+-orbital-energies", test_orbital_energy_hp),&
      new_unittest("xtbml-he-orbital-energies", test_orbital_energy_he),&
      new_unittest("xtbml-co2-high-spin", test_high_spin)&
      ]

end subroutine collect_xtbml

subroutine test_mulliken_charges_shell_h2p(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(post_processing_list), allocatable :: pproc
   type(xtbml_record), allocatable :: xtbml_param
   type(post_processing_record_list), allocatable :: pparam
   type(results_type) :: res
   class(post_processing_record), allocatable :: tmp_record
   real(wp), allocatable :: mulliken_shell(:)
   real(wp) :: energy = 0.0_wp
   real(wp), parameter :: xyz(3, 2) = reshape((/0.0_wp,0.0_wp,0.35_wp,&
   &0.0_wp,0.0_wp,-0.35_wp/),shape=(/3,2/))
   integer, parameter :: num(2) = (/1,1/)

   call new(mol, num, xyz*aatoau, uhf=1, charge=1.0_wp)
   call new_gfn2_calculator(calc, mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   calc%save_integrals = .true.
   allocate(pproc)
   allocate(xtbml_param)
   allocate(pparam)
   xtbml_param%xtbml_density = .true.
   call move_alloc(xtbml_param, tmp_record)
   call pparam%push(tmp_record)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res, post_process=pproc)

   call res%dict%get_entry("q_A", mulliken_shell)
   if (sum(mulliken_shell) - 1.0_wp > thr) then
      call test_failed(error, "Charge is not summing up to 1 electron for H2+")
      print'(3es21.14)', mulliken_shell
   end if

end subroutine test_mulliken_charges_shell_h2p


subroutine test_dipm_shell_h2p(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(results_type) :: res
   type(post_processing_list), allocatable :: pproc
   type(xtbml_record), allocatable :: xtbml_param
   type(post_processing_record_list), allocatable :: pparam
   class(post_processing_record), allocatable :: tmp_record
   integer, parameter :: nsh = 2, nat=2
   real(wp) :: mol_dipm(3), mol_dipm_delta(3), energy
   real(wp) :: dipm_xyz(3,nat),qm_xyz(6,nat)
   real(wp), allocatable :: tmp_array(:)
   real(wp), allocatable :: partial(:), ext_partial(:)
   real(wp) :: ext_dipm_xyz(3,nat),ext_qm_xyz(6,nat)

   real(wp), parameter :: xyz(3, nat) = reshape((/0.0_wp,0.0_wp,0.35_wp,&
   &0.0_wp,0.0_wp,-0.35_wp/),shape=(/3,2/))
   integer, parameter :: num(nat) = (/1,1/)
   integer :: i


   call new(mol,num,xyz*aatoau,uhf=1,charge=1.0_wp)
   call new_gfn2_calculator(calc,mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   allocate(pproc)
   allocate(xtbml_param)
   allocate(pparam)
   xtbml_param%xtbml_density = .true.
   xtbml_param%xtbml_tensor = .true.
   xtbml_param%xtbml_convolution = .true.
   xtbml_param%xtbml_a = [1.0_wp]
   call move_alloc(xtbml_param, tmp_record)
   call pparam%push(tmp_record)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res, post_process=pproc)

   call res%dict%get_entry("dipm_A_x", tmp_array)
   dipm_xyz(1, :) = tmp_array
   call res%dict%get_entry("dipm_A_y", tmp_array)
   dipm_xyz(2, :) = tmp_array
   call res%dict%get_entry("dipm_A_z", tmp_array)
   dipm_xyz(3, :) = tmp_array
   call res%dict%get_entry("q_A", partial)
   mol_dipm = 0.0_wp

   call res%dict%get_entry("ext_dipm_A_x", tmp_array)
   ext_dipm_xyz(1, :) = tmp_array
   call res%dict%get_entry("ext_dipm_A_y", tmp_array)
   ext_dipm_xyz(2, :) = tmp_array
   call res%dict%get_entry("ext_dipm_A_z", tmp_array)
   ext_dipm_xyz(3, :) = tmp_array
   call res%dict%get_entry("ext_q_A", ext_partial)

   do i= 1,2
      mol_dipm = mol_dipm+ dipm_xyz(:,i)+xyz(:,i)*partial(i)
   enddo

   if (sum(mol_dipm)  > thr) then
      call test_failed(error, "Molecular dipole moment is non zero, for dipm")
      print'(3es21.14)', mol_dipm
   end if
   mol_dipm_delta = 0.0_wp
   do i= 1,2
      mol_dipm_delta = mol_dipm_delta + ext_dipm_xyz(:,i)+xyz(:,i)*ext_partial(i)
   enddo

   if (sum(mol_dipm_delta)  > thr) then
      call test_failed(error, "Molecular dipole moment is non zero, for dipm_delta")
      print'(3es21.14)', mol_dipm_delta
   end if

   if (sum(mol_dipm_delta-mol_dipm)  > thr) then
      call test_failed(error, "Molecular dipole moment of extended and non-extended are not equal")
      print'(3es21.14)', mol_dipm_delta-mol_dipm
   end if

end subroutine test_dipm_shell_h2p

subroutine test_dipm_shell_co2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(integral_type) :: ints
   type(results_type) :: res
   type(post_processing_list), allocatable :: pproc
   type(xtbml_record), allocatable :: xtbml_param
   type(post_processing_record_list), allocatable :: pparam
   class(post_processing_record), allocatable :: tmp_record
   integer, parameter :: nat=3
   real(wp) :: mol_dipm(3), mol_dipm_delta(3), energy  = 0.0_wp
   real(wp) :: dipm_xyz(3,nat),qm_xyz(6,nat)
   real(wp), allocatable :: tmp_array(:)
   real(wp), allocatable :: partial(:), ext_partial(:)
   real(wp) :: ext_dipm_xyz(3,nat),ext_qm_xyz(6,nat)
   integer :: i,j

   real(wp), parameter :: xyz(3, nat) = reshape((/0.00000,0.00000,1.0000000,&
   &0.0000,0.00000,-1.0000000,&
   &0.000000,0.000000,0.000000/),shape=(/3,nat/))
   integer, parameter :: num(nat) = (/8,8,6/)
   mol_dipm = 0.0_wp
   mol_dipm_delta = 0.0_wp

   call new(mol,num,xyz*aatoau,uhf=0,charge=0.0_wp)
   call new_gfn2_calculator(calc,mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   calc%save_integrals = .true.

   allocate(pproc)
   allocate(xtbml_param)
   allocate(pparam)
   xtbml_param%xtbml_density = .true.
   xtbml_param%xtbml_tensor = .true.
   xtbml_param%xtbml_convolution = .true.
   xtbml_param%xtbml_a = [1.0_wp]
   call move_alloc(xtbml_param, tmp_record)
   call pparam%push(tmp_record)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res, post_process=pproc)

   call res%dict%get_entry("dipm_A_x", tmp_array)
   dipm_xyz(1, :) = tmp_array
   call res%dict%get_entry("dipm_A_y", tmp_array)
   dipm_xyz(2, :) = tmp_array
   call res%dict%get_entry("dipm_A_z", tmp_array)
   dipm_xyz(3, :) = tmp_array
   call res%dict%get_entry("q_A", partial)
   mol_dipm = 0.0_wp

   call res%dict%get_entry("ext_dipm_A_x", tmp_array)
   ext_dipm_xyz(1, :) = tmp_array
   call res%dict%get_entry("ext_dipm_A_y", tmp_array)
   ext_dipm_xyz(2, :) = tmp_array
   call res%dict%get_entry("ext_dipm_A_z", tmp_array)
   ext_dipm_xyz(3, :) = tmp_array
   call res%dict%get_entry("ext_q_A", ext_partial)

   do i= 1,nat
      do j = 1,3
         mol_dipm(j) = mol_dipm(j)+ dipm_xyz(j,i)+mol%xyz(j,i)*partial(i)
      enddo
   enddo

   if (norm2(mol_dipm)  > thr) then
      call test_failed(error, "Molecular dipole moment is non zero, for dipm")
      print'(3es21.14)', mol_dipm
   end if

   do i= 1,nat
      do j = 1, 3
         mol_dipm_delta(j) = mol_dipm_delta(j) + ext_dipm_xyz(j,i)+mol%xyz(j,i)*ext_partial(i)
      enddo
   enddo

   if (norm2(mol_dipm_delta)  > thr) then
      call test_failed(error, "Molecular dipole moment is non zero, for dipm_delta")
      print'(3es21.14)', mol_dipm_delta
   end if

   if (norm2(mol_dipm_delta-mol_dipm)  > thr) then
      call test_failed(error, "Molecular dipole moment of extended and non-extended are not equal")
      print'(3es21.14)', mol_dipm_delta-mol_dipm
   end if

end subroutine test_dipm_shell_co2

subroutine test_qp_shell_benz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(integral_type) :: ints
   type(results_type) :: res
   type(post_processing_list), allocatable :: pproc
   type(xtbml_record), allocatable :: xtbml_param
   type(post_processing_record_list), allocatable :: pparam
   class(post_processing_record), allocatable :: tmp_record
   integer, parameter :: nat=12
   real(wp) :: mol_dipm(3), mol_dipm_delta(3), energy = 0.0_wp
   real(wp) :: dipm_xyz(3,nat),qm_xyz(6,nat)
   real(wp), allocatable :: tmp_array(:)
   real(wp), allocatable :: partial(:), ext_partial(:)
   real(wp) :: ext_dipm_xyz(3,nat),ext_qm_xyz(6,nat),mol_qm(6),ext_mol_qm(6)
   integer :: i,j

   real(wp), parameter :: xyz(3, nat) = reshape((/&
   &1.06880660023529,       -0.46478030005927,        0.00009471732781,&
   &2.45331325533661,       -0.46484444142679,        0.00042084312846,&
   &3.14559996373466,        0.73409173401801,        0.00008724271521,&
   &2.45340597395333,        1.93314591537421,       -0.00086301044874,&
   &1.06895328716368,        1.93321130458200,       -0.00141386731889,&
   &0.37663958202671,        0.73422879200405,       -0.00090929198808,&
   &0.52864276199175,       -1.40035288735680,        0.00049380958906,&
   &2.99337903563419,       -1.40047547903112,        0.00121759015506,&
   &4.22591259698321,        0.73408789322206,        0.00025398801936,&
   &2.99365942822711,        2.86866756976346,       -0.00166131228918,&
   &0.52879830433456,        2.86879139255056,       -0.00224874122149,&
   &-0.70367266962110,        0.73433126635962,       -0.00138296766859&
   &/),shape=(/3,nat/))
   integer, parameter :: num(nat) = (/6,6,6,6,6,6,1,1,1,1,1,1/)

   mol_dipm = 0.0_wp
   mol_dipm_delta = 0.0_wp
   mol_qm = 0.0_wp
   ext_mol_qm = 0.0_wp
   ext_qm_xyz = 0.0_wp
   ext_dipm_xyz = 0.0_wp

   dipm_xyz = 0.0_wp
   qm_xyz = 0.0_wp


   call new(mol,num,xyz*aatoau,uhf=0,charge=0.0_wp)
   call new_gfn2_calculator(calc,mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   allocate(pproc)
   allocate(xtbml_param)
   allocate(pparam)
   xtbml_param%xtbml_density = .true.
   xtbml_param%xtbml_tensor = .true.
   xtbml_param%xtbml_convolution = .true.
   xtbml_param%xtbml_a = [1.0_wp]
   call move_alloc(xtbml_param, tmp_record)
   call pparam%push(tmp_record)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res, post_process=pproc)

   call res%dict%get_entry("dipm_A_x", tmp_array)
   dipm_xyz(1, :) = tmp_array
   call res%dict%get_entry("dipm_A_y", tmp_array)
   dipm_xyz(2, :) = tmp_array
   call res%dict%get_entry("dipm_A_z", tmp_array)
   dipm_xyz(3, :) = tmp_array
   call res%dict%get_entry("q_A", partial)


   call res%dict%get_entry("ext_dipm_A_x", tmp_array)
   ext_dipm_xyz(1, :) = tmp_array
   call res%dict%get_entry("ext_dipm_A_y", tmp_array)
   ext_dipm_xyz(2, :) = tmp_array
   call res%dict%get_entry("ext_dipm_A_z", tmp_array)
   ext_dipm_xyz(3, :) = tmp_array
   call res%dict%get_entry("ext_q_A", ext_partial)

   deallocate(tmp_array)
   call res%dict%get_entry("qm_A_xx", tmp_array)
   qm_xyz(1, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("qm_A_xy", tmp_array)
   qm_xyz(2, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("qm_A_yy", tmp_array)
   qm_xyz(3, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("qm_A_xz", tmp_array)
   qm_xyz(4, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("qm_A_yz", tmp_array)
   qm_xyz(5, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("qm_A_zz", tmp_array)
   qm_xyz(6, :) = tmp_array

   deallocate(tmp_array)
   call res%dict%get_entry("ext_qm_A_xx", tmp_array)
   ext_qm_xyz(1, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("ext_qm_A_xy", tmp_array)
   ext_qm_xyz(2, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("ext_qm_A_yy", tmp_array)
   ext_qm_xyz(3, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("ext_qm_A_xz", tmp_array)
   ext_qm_xyz(4, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("ext_qm_A_yz", tmp_array)
   ext_qm_xyz(5, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("ext_qm_A_zz", tmp_array)
   ext_qm_xyz(6, :) = tmp_array

   do i= 1,nat
      do j = 1,3
         mol_dipm(j) = mol_dipm(j)+dipm_xyz(j,i)+ mol%xyz(j,i)*partial(i)
      enddo
   enddo
   mol_dipm_delta = 0.0_wp
   do i= 1,nat
      do j =1,3
         mol_dipm_delta(j) = mol_dipm_delta(j) + ext_dipm_xyz(j,i)+mol%xyz(j,i)*ext_partial(i)
      enddo
   enddo

   if (norm2(mol_dipm_delta-mol_dipm)  > thr) then
      call test_failed(error, "Molecular dipole moment of extended and non-extended are not equal")
      print'(3es21.14)', norm2(mol_dipm_delta-mol_dipm)
   end if


   call compute_traceless_mol_qm(mol%nat,mol%xyz,partial,dipm_xyz,qm_xyz,mol_qm)


   call compute_traceless_mol_qm(mol%nat,mol%xyz,ext_partial,ext_dipm_xyz,ext_qm_xyz,ext_mol_qm)

   if (norm2(mol_qm-ext_mol_qm)  > thr2) then
      call test_failed(error, "Molecular quadrupole moment of extended and non-extended are not equal")
      print'(3es21.14)', norm2(mol_qm-ext_mol_qm)
   end if
end subroutine test_qp_shell_benz

subroutine test_qp_shell_benz_high_a(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(integral_type) :: ints
   type(results_type) :: res
   type(post_processing_list), allocatable :: pproc
   type(xtbml_record), allocatable :: xtbml_param
   type(post_processing_record_list), allocatable :: pparam
   class(post_processing_record), allocatable :: tmp_record
   integer, parameter :: nat=12
   real(wp) :: mol_dipm(3), mol_dipm_delta(3), energy
   real(wp) :: dipm_xyz(3,nat),qm_xyz(6,nat)
   real(wp), allocatable :: tmp_array(:)
   real(wp), allocatable :: partial(:), ext_partial(:)
   real(wp) :: ext_dipm_xyz(3,nat),ext_qm_xyz(6,nat),mol_qm(6),ext_mol_qm(6)
   integer :: i,j

   real(wp), parameter :: xyz(3, nat) = reshape((/&
   &1.06880660023529,       -0.46478030005927,        0.00009471732781,&
   &2.45331325533661,       -0.46484444142679,        0.00042084312846,&
   &3.14559996373466,        0.73409173401801,        0.00008724271521,&
   &2.45340597395333,        1.93314591537421,       -0.00086301044874,&
   &1.06895328716368,        1.93321130458200,       -0.00141386731889,&
   &0.37663958202671,        0.73422879200405,       -0.00090929198808,&
   &0.52864276199175,       -1.40035288735680,        0.00049380958906,&
   &2.99337903563419,       -1.40047547903112,        0.00121759015506,&
   &4.22591259698321,        0.73408789322206,        0.00025398801936,&
   &2.99365942822711,        2.86866756976346,       -0.00166131228918,&
   &0.52879830433456,        2.86879139255056,       -0.00224874122149,&
   &-0.70367266962110,        0.73433126635962,       -0.00138296766859&
   &/),shape=(/3,nat/))
   integer, parameter :: num(nat) = (/6,6,6,6,6,6,1,1,1,1,1,1/)

   mol_dipm = 0.0_wp
   mol_dipm_delta = 0.0_wp
   mol_qm = 0.0_wp
   ext_mol_qm = 0.0_wp
   ext_qm_xyz = 0.0_wp
   ext_dipm_xyz = 0.0_wp

   dipm_xyz = 0.0_wp
   qm_xyz = 0.0_wp

   call new(mol,num,xyz*aatoau,uhf=0,charge=0.0_wp)
   call new_gfn2_calculator(calc,mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   allocate(pproc)
   allocate(xtbml_param)
   allocate(pparam)
   xtbml_param%xtbml_density = .true.
   xtbml_param%xtbml_tensor = .true.
   xtbml_param%xtbml_convolution = .true.
   xtbml_param%xtbml_a = [1000.0_wp]
   call move_alloc(xtbml_param, tmp_record)
   call pparam%push(tmp_record)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res, post_process=pproc)

   call res%dict%get_entry("dipm_A_x", tmp_array)
   dipm_xyz(1, :) = tmp_array
   call res%dict%get_entry("dipm_A_y", tmp_array)
   dipm_xyz(2, :) = tmp_array
   call res%dict%get_entry("dipm_A_z", tmp_array)
   dipm_xyz(3, :) = tmp_array
   call res%dict%get_entry("q_A", partial)

   deallocate(tmp_array)
   call res%dict%get_entry("ext_dipm_A_x_1000.00", tmp_array)
   ext_dipm_xyz(1, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("ext_dipm_A_y_1000.00", tmp_array)
   ext_dipm_xyz(2, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("ext_dipm_A_z_1000.00", tmp_array)
   ext_dipm_xyz(3, :) = tmp_array
   call res%dict%get_entry("ext_q_A_1000.00", ext_partial)

   deallocate(tmp_array)
   call res%dict%get_entry("qm_A_xx", tmp_array)
   qm_xyz(1, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("qm_A_xy", tmp_array)
   qm_xyz(2, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("qm_A_yy", tmp_array)
   qm_xyz(3, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("qm_A_xz", tmp_array)
   qm_xyz(4, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("qm_A_yz", tmp_array)
   qm_xyz(5, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("qm_A_zz", tmp_array)
   qm_xyz(6, :) = tmp_array

   deallocate(tmp_array)
   call res%dict%get_entry("ext_qm_A_xx_1000.00", tmp_array)
   ext_qm_xyz(1, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("ext_qm_A_xy_1000.00", tmp_array)
   ext_qm_xyz(2, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("ext_qm_A_yy_1000.00", tmp_array)
   ext_qm_xyz(3, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("ext_qm_A_xz_1000.00", tmp_array)
   ext_qm_xyz(4, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("ext_qm_A_yz_1000.00", tmp_array)
   ext_qm_xyz(5, :) = tmp_array
   deallocate(tmp_array)
   call res%dict%get_entry("ext_qm_A_zz_1000.00", tmp_array)
   ext_qm_xyz(6, :) = tmp_array

   do i= 1,nat
      do j = 1,3
         mol_dipm(j) = mol_dipm(j)+dipm_xyz(j,i)+ mol%xyz(j,i)*partial(i)
      enddo
   enddo
   mol_dipm_delta = sum(ext_dipm_xyz,dim=2)
   if (norm2(mol_dipm_delta-mol_dipm)  > thr2) then
      call test_failed(error, "Molecular dipole moment of extended and non-extended are not equal")
      print'(3es21.14)', norm2(mol_dipm_delta-mol_dipm)
   end if

   call compute_traceless_mol_qm(mol%nat,mol%xyz,partial,dipm_xyz,qm_xyz,mol_qm)

   ext_mol_qm = sum(ext_qm_xyz, dim=2)

   if (norm2(mol_qm-ext_mol_qm)  > thr2) then
      call test_failed(error, "Molecular quadrupole moment of extended and non-extended are not equal")
      print'(3es21.14)', norm2(mol_qm-ext_mol_qm)
   end if
end subroutine test_qp_shell_benz_high_a


subroutine test_rotation_co2(error)
   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(post_processing_list), allocatable :: pproc
   type(xtbml_record), allocatable :: xtbml_param
   type(post_processing_record_list), allocatable :: pparam
   class(post_processing_record), allocatable :: tmp_record
   !> Error handling
   integer,parameter :: nat = 3
   type(error_type), allocatable, intent(out) :: error
   real(wp), parameter :: xyz(3, nat) = reshape((/0.00000,0.00000,1.0000000,&
   &0.0000,0.00000,-1.0000000,&
   &0.000000,0.000000,0.000000/),shape=(/3,nat/))

   integer, parameter :: num(nat) = (/8,8,6/)
   type(results_type) :: res, res_
   real(wp) :: rot_matrix(3,3),xyz_rot(3,nat),energy, xyz_trans(3,nat)
   real(wp), allocatable :: xtbml(:,:),xtbml_rot(:,:),xtbml_trans(:,:)
   integer :: i

   call new(mol,num,xyz*aatoau,uhf=0,charge=0.0_wp)
   call new_gfn2_calculator(calc,mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   allocate(pproc)
   allocate(xtbml_param)
   allocate(pparam)
   xtbml_param%xtbml_energy = .true.
   xtbml_param%xtbml_orbital_energy = .true.
   xtbml_param%xtbml_geometry = .true.
   xtbml_param%xtbml_density = .true.
   xtbml_param%xtbml_tensor = .false.
   xtbml_param%xtbml_convolution = .true.
   xtbml_param%xtbml_a = [1.0_wp]
   call move_alloc(xtbml_param, tmp_record)
   call pparam%push(tmp_record)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=3, results=res, post_process=pproc)


   rot_matrix = (reshape((/&
   &1.0_wp,0.0_wp,0.0_wp,&
   &0.0_wp,0.52532_wp,-0.85090352453_wp,&
   &0.0_wp,0.85090352453_wp,0.52532_wp/),shape=(/3,3/)))
   call gemm(rot_matrix,xyz,xyz_rot)

   call new(mol,num,xyz_rot*aatoau,uhf=0,charge=0.0_wp)
   call new_gfn2_calculator(calc,mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   deallocate(pproc)
   allocate(pproc)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res_, post_process=pproc)

   if (.not.(compare_dict(res%dict, res_%dict, thr2))) then
      call test_failed(error, "Rotational invariance is not respected.")
   end if

end subroutine test_rotation_co2

subroutine test_translation_co2(error)
   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(post_processing_list), allocatable :: pproc
   type(xtbml_record), allocatable :: xtbml_param
   type(post_processing_record_list), allocatable :: pparam
   class(post_processing_record), allocatable :: tmp_record
   !> Error handling
   integer,parameter :: nat = 3
   type(error_type), allocatable, intent(out) :: error
   real(wp), parameter :: xyz(3, nat) = reshape((/0.00000,0.00000,1.0000000,&
   &0.0000,0.00000,-1.0000000,&
   &0.000000,0.000000,0.000000/),shape=(/3,nat/))

   integer, parameter :: num(nat) = (/8,8,6/)
   type(results_type) :: res, res_
   real(wp) :: energy = 0.0_wp, xyz_trans(3,nat)
   real(wp), allocatable :: xtbml(:,:),xtbml_rot(:,:),xtbml_trans(:,:)
   integer :: i

   call new(mol,num,xyz*aatoau,uhf=0,charge=0.0_wp)
   call new_gfn2_calculator(calc,mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   allocate(pproc)
   allocate(xtbml_param)
   allocate(pparam)
   xtbml_param%xtbml_energy = .true.
   xtbml_param%xtbml_geometry = .true.
   xtbml_param%xtbml_orbital_energy = .true.
   xtbml_param%xtbml_density = .true.
   xtbml_param%xtbml_tensor = .false.
   xtbml_param%xtbml_convolution = .true.
   xtbml_param%xtbml_a = [1.0_wp]
   call move_alloc(xtbml_param, tmp_record)
   call pparam%push(tmp_record)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res, post_process=pproc)

   xyz_trans = xyz(:,:)

   do i = 1,nat
      xyz_trans(1,i) = xyz_trans(1,i) +5.0_wp
   enddo

   call new(mol,num,xyz_trans*aatoau,uhf=0,charge=0.0_wp)
   call new_gfn2_calculator(calc,mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   deallocate(pproc)
   allocate(pproc)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res_, post_process=pproc)

   if (.not.(compare_dict(res%dict, res_%dict, thr2))) then
      call test_failed(error, "Translational invariance is not respected.")
   end if

end subroutine test_translation_co2

subroutine test_orbital_energy_ref(error)
   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(post_processing_list), allocatable :: pproc
   type(xtbml_record), allocatable :: xtbml_param
   type(post_processing_record_list), allocatable :: pparam
   class(post_processing_record), allocatable :: tmp_record
   type(double_dictionary_type) :: dict_ref
   !> Error handling
   integer,parameter :: nat = 3
   type(error_type), allocatable, intent(out) :: error
   real(wp), parameter :: xyz(3, nat) = reshape([&
      & 0.000000_wp, 0.000000_wp,  1.0000000_wp,&
      & 0.000000_wp, 0.000000_wp, -1.0000000_wp,&
      & 0.000000_wp, 0.000000_wp,  0.0000000_wp], shape=shape(xyz))

   integer, parameter :: num(nat) = (/8,8,6/)
   type(results_type) :: res, res_
   real(wp) :: energy = 0.0_wp
   real(wp), allocatable :: xtbml(:,:),xtbml_rot(:,:),xtbml_trans(:,:)
   integer :: i

   call dict_ref%add_entry("response_alpha", [ 0.1337835451437173_wp, 0.1337835451437157_wp, 1.6307951377273491_wp])
   call dict_ref%add_entry("gap_alpha", [ 0.0095881103175756_wp, 0.0095881103175756_wp, 0.0011085237545836_wp])
   call dict_ref%add_entry("chem_pot_alpha", [ -0.9622382191942670_wp, -0.9622382191942677_wp, -0.8758044318869692_wp])
   call dict_ref%add_entry("HOAO_alpha", [ -0.9670322743530548_wp, -0.9670322743530555_wp, -0.8763586937642610_wp])
   call dict_ref%add_entry("LUAO_alpha", [ -0.9574441640354792_wp, -0.9574441640354798_wp, -0.8752501700096774_wp])
   call dict_ref%add_entry("response_beta", [ 1.2449917888491431_wp, 1.2449917888491182_wp, 0.0059865937960335_wp])
   call dict_ref%add_entry("gap_beta", [ 0.0806953599842188_wp, 0.0806953599842184_wp, 19.4997052573882037_wp])
   call dict_ref%add_entry("chem_pot_beta", [ -15.1513328627176183_wp, -15.1513328627176254_wp, -8.6913073970860637_wp])
   call dict_ref%add_entry("HOAO_beta", [ -15.1916805427097277_wp, -15.1916805427097348_wp, -18.4411600257801638_wp])
   call dict_ref%add_entry("LUAO_beta", [ -15.1109851827255088_wp, -15.1109851827255159_wp, 1.0585452316080382_wp])
   call dict_ref%add_entry("ext_gap_alpha", [ 0.0054951699014186_wp, 0.0054951699014186_wp, 0.0067615787201293_wp])
   call dict_ref%add_entry("ext_chem_pot_alpha", [ -0.9205182203755125_wp, -0.9205182203755127_wp, -0.9334269287974830_wp])
   call dict_ref%add_entry("ext_HOAO_alpha", [ -0.9232658053262217_wp, -0.9232658053262219_wp, -0.9368077181575476_wp])
   call dict_ref%add_entry("ext_LUAO_alpha", [ -0.9177706354248032_wp, -0.9177706354248034_wp, -0.9300461394374184_wp])
   call dict_ref%add_entry("ext_gap_beta", [ 9.4538889011103020_wp, 9.4538889011103020_wp, 6.5537012263493697_wp])
   call dict_ref%add_entry("ext_chem_pot_beta", [ -12.033203108920080_wp, -12.033203108920080_wp, -12.997992016340195_wp])
   call dict_ref%add_entry("ext_HOAO_beta", [ -16.760147559475232_wp, -16.760147559475232_wp, -16.274842629514879_wp])
   call dict_ref%add_entry("ext_LUAO_beta", [ -7.3062586583649294_wp, -7.3062586583649294_wp, -9.7211414031655110_wp])
   call dict_ref%add_entry("n_features", [ 18.0_wp])

   call new(mol,num,xyz*aatoau,uhf=2,charge=0.0_wp)
   call new_gfn2_calculator(calc,mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   allocate(pproc)
   allocate(xtbml_param)
   allocate(pparam)
   xtbml_param%xtbml_orbital_energy = .true.
   xtbml_param%xtbml_convolution = .true.
   call move_alloc(xtbml_param, tmp_record)
   call pparam%push(tmp_record)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res, post_process=pproc)

   if (.not.(compare_dict(res%dict, dict_ref, thr2))) then
      call test_failed(error, "Comparing the orbital energy values with a reference failed")
   end if
end subroutine test_orbital_energy_ref

function compare_dict(lhs, rhs, thr_) result(equal)
   type(double_dictionary_type), intent(in) :: lhs, rhs
   real(kind=wp), intent(in) :: thr_
   logical :: equal
   integer :: i
   real(wp), allocatable :: array1(:)
   real(wp), allocatable :: array2(:, :)
   real(wp), allocatable :: array3(:, :, :)
   real(wp), allocatable :: array1_(:)
   real(wp), allocatable :: array2_(:, :)
   real(wp), allocatable :: array3_(:, :, :)
   character(len=:), allocatable :: label
   equal = .false.
   i = lhs%get_n_entries()
   if (i /= rhs%get_n_entries()) then
      write(*,*) "Not the same number of entries"
      write(*,*) "Expected: ", i, " Got: ", rhs%get_n_entries()
      return
   end if

   do i = 1, lhs%get_n_entries()

      call lhs%get_entry(i, array1)
      if (allocated(array1)) then
         call rhs%get_entry(i, array1_)
         if (allocated(array1_)) then

            if (any(abs(array1-array1_)  > thr_)) then
               call lhs%get_label(i, label)
               write(*,*) "Entry ", label, " is diverging"
               write(*,*) array1
               write(*,*) array1_
               return
            end if
            continue
         else
            return
         end if
      end if

      call lhs%get_entry(i, array2)
      if (allocated(array2)) then
         call rhs%get_entry(i, array2_)
         if (allocated(array2_)) then
            if (any(abs(array2-array2_)  > thr_)) then
               call lhs%get_label(i, label)
               write(*,*) "Entry ", label, " is diverging"
               return
            endif
            continue
         else
            return
         end if
      end if

      call lhs%get_entry(i, array3)
      if (allocated(array3)) then
         call rhs%get_entry(i, array3_)
         if (allocated(array3_)) then
            if (any(abs(array3-array3_)  > thr_)) then
               call lhs%get_label(i, label)
               write(*,*) "Entry ", label, " is diverging"
               return
            endif
            continue
         else
            return
         end if
      end if
   end do

   equal = .true.

end function compare_dict

subroutine test_xtbml_param_load(error)
   type(error_type), allocatable, intent(out) :: error
   type(toml_table), pointer :: table_xtbml
   type(toml_table) :: table_post_proc
   type(post_processing_record_list) :: param
   class(post_processing_record), allocatable :: record
   real(wp) :: a_array(2)
   type(toml_array), pointer :: array
   a_array =  [1.2, 1.0]

   table_post_proc= toml_table()
   call add_table(table_post_proc, "xtbml", table_xtbml)
   call set_value(table_xtbml, "geometry", .true.)
   call set_value(table_xtbml, "density", .true.)
   call set_value(table_xtbml, "orbital", .true.)
   call set_value(table_xtbml, "energy", .false.)
   call set_value(table_xtbml, "convolution", .true.)
   call add_array(table_xtbml, "a", array)
   call set_value(array, a_array)
   call set_value(table_xtbml, "tensorial-output", .true.)

   call param%load(table_post_proc, error)
   associate(record => param%list(1)%record)
      select type(record)
         type is (xtbml_record)
         call check(error, record%xtbml_geometry, .true.)
         if (allocated(error)) return
         call check(error, record%xtbml_density, .true.)
         if (allocated(error)) return
         call check(error, record%xtbml_orbital_energy, .true.)
         if (allocated(error)) return
         call check(error, record%xtbml_energy, .false.)
         if (allocated(error)) return
         call check(error, record%xtbml_convolution, .true.)
         if (allocated(error)) return
         call check(error, size(record%xtbml_a), 2)
         if (allocated(error)) return
         call check(error, record%xtbml_tensor, .true.)
         if (allocated(error)) return
      end select
   end associate
end subroutine test_xtbml_param_load

subroutine test_xtbml_param_bad_inp(error)
   type(error_type), allocatable, intent(out) :: error
   type(toml_table), pointer :: xtbml, xtbml_
   type(toml_table) :: table_post_proc
   type(xtbml_record) :: param
   real(wp) :: a_array(2)
   type(toml_array), pointer :: array
   a_array =  [1.2, 1.0]

   table_post_proc = toml_table()
   call add_table(table_post_proc, "xtbml-", xtbml_)
   call param%load(table_post_proc, error)
   if (allocated(error)) then
      deallocate(error)
   else
      call fatal_error(error, "Bad key in geometry was accepted")
      return
   endif

   call add_table(table_post_proc, "xtbml", xtbml)
   call set_value(xtbml, "geometry", 7)
   call param%load(table_post_proc, error)

   if (allocated(error)) then
      deallocate(error)
   else
      call fatal_error(error, "Bad input in geometry was accepted")
      return
   endif
   call set_value(xtbml, "geometry", .true.)
   call set_value(xtbml, "density", "str")
   call param%load(table_post_proc, error)
   if (allocated(error)) then
      deallocate(error)
   else
      call fatal_error(error, "Bad input in density was accepted")
      return
   endif

   call set_value(xtbml, "density", .true.)
   call set_value(xtbml, "orbital", 42)
   call param%load(table_post_proc, error)

   if (allocated(error)) then
      deallocate(error)
   else
      call fatal_error(error, "Bad input in orbital was accepted")
      return
   endif

   call set_value(xtbml, "orbital", .false.)
   call set_value(xtbml, "energy", 1)
   call param%load(table_post_proc, error)

   if (allocated(error)) then
      deallocate(error)
   else
      call fatal_error(error, "Bad input in energy was accepted")
      return
   endif

   call set_value(xtbml, "energy", .false.)
   call set_value(xtbml, "tensorial-output", 7)
   call param%load(table_post_proc, error)

   if (allocated(error)) then
      deallocate(error)
   else
      call fatal_error(error, "Bad input in tensorial was accepted")
      return
   endif

   call set_value(xtbml, "tensorial-output", .false.)
   call set_value(xtbml, "convolution", "Str")
   call param%load(table_post_proc, error)

   if (allocated(error)) then
      deallocate(error)
   else
      call fatal_error(error, "Bad input in convolution was accepted")
      return
   endif

   call set_value(xtbml, "convolution", .true.)
   call set_value(xtbml, "a", "Str")
   call param%load(table_post_proc, error)

   if (allocated(error)) then
      deallocate(error)
   else
      call fatal_error(error, "Bad input in a was accepted")
      return
   endif

   call set_value(xtbml, "a", 1.0)
   call param%load(table_post_proc, error)

end subroutine test_xtbml_param_bad_inp

subroutine test_xtbml_param_dump(error)
   type(error_type), allocatable, intent(out) :: error
   type(toml_table), pointer :: table_xtbml, child
   type(toml_table) :: table_post_proc
   type(toml_table) :: new_table
   type(xtbml_record) :: param
   type(toml_key), allocatable :: list(:)


   table_post_proc = toml_table()
   call add_table(table_post_proc, "xtbml", table_xtbml)
   call set_value(table_xtbml, "geometry", .true.)
   call set_value(table_xtbml, "density", .true.)
   call set_value(table_xtbml, "orbital", .true.)
   call set_value(table_xtbml, "energy", .false.)
   call set_value(table_xtbml, "convolution", .true.)
   call set_value(table_xtbml, "tensorial-output", .true.)

   call param%load(table_post_proc, error)
   if (allocated(error)) return



   new_table = toml_table()
   call param%dump(new_table, error)
   call param%load(new_table, error)
   call new_table%get_keys(list)
   call check(error, size(list), 1)
   call get_value(new_table, list(1)%key, child)
   call child%get_keys(list)
   call check(error, size(list), 7)
   if (allocated(error)) return

   call check(error, param%xtbml_geometry, .true.)
   if (allocated(error)) return
   call check(error, param%xtbml_density, .true.)
   if (allocated(error)) return
   call check(error, param%xtbml_orbital_energy, .true.)
   if (allocated(error)) return
   call check(error, param%xtbml_energy, .false.)
   if (allocated(error)) return
   call check(error, param%xtbml_convolution, .true.)
   if (allocated(error)) return
   call check(error, size(param%xtbml_a), 1)
   if (allocated(error)) return
   call check(error, param%xtbml_tensor, .true.)
   if (allocated(error)) return

end subroutine test_xtbml_param_dump


subroutine test_energy_sum_up_gfn2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(integral_type) :: ints
   type(results_type) :: res
   type(post_processing_list), allocatable :: pproc
   type(xtbml_record), allocatable :: xtbml_param
   type(post_processing_record_list), allocatable :: pparam
   class(post_processing_record), allocatable :: tmp_record
   integer, parameter :: nat=12
   real(wp), allocatable :: tmp_array(:)
   real(wp) :: energy = 1.0_wp , sum_energy = 0.0_wp
   integer :: i,j
   character(len=:), allocatable :: label1

   real(wp), parameter :: xyz(3, nat) = reshape((/&
   &1.06880660023529,       -0.46478030005927,        0.00009471732781,&
   &2.45331325533661,       -0.46484444142679,        0.00042084312846,&
   &3.14559996373466,        0.73409173401801,        0.00008724271521,&
   &2.45340597395333,        1.93314591537421,       -0.00086301044874,&
   &1.06895328716368,        1.93321130458200,       -0.00141386731889,&
   &0.37663958202671,        0.73422879200405,       -0.00090929198808,&
   &0.52864276199175,       -1.40035288735680,        0.00049380958906,&
   &2.99337903563419,       -1.40047547903112,        0.00121759015506,&
   &4.22591259698321,        0.73408789322206,        0.00025398801936,&
   &2.99365942822711,        2.86866756976346,       -0.00166131228918,&
   &0.52879830433456,        2.86879139255056,       -0.00224874122149,&
   &-0.70367266962110,        0.73433126635962,       -0.00138296766859&
   &/),shape=(/3,nat/))
   integer, parameter :: num(nat) = (/6,6,6,6,6,6,1,1,1,1,1,1/)

   call new(mol,num,xyz*aatoau,uhf=0,charge=0.0_wp)

   call new_gfn2_calculator(calc, mol, error)

   block
      class(container_type), allocatable :: cont
      type(spin_polarization), allocatable :: spin
      real(wp), allocatable :: wll(:, :, :)
      allocate(spin)
      call get_spin_constants(wll, mol, calc%bas)
      call new_spin_polarization(spin, mol, wll, calc%bas%nsh_id)
      call move_alloc(spin, cont)
      call calc%push_back(cont)
   end block

   block
      class(container_type), allocatable :: cont
      type(alpb_solvation), allocatable :: solv
      type(alpb_input) :: alpb_inp
      type(solvent_data), allocatable :: solvent
      solvent = get_solvent_data("water")
      alpb_inp = alpb_input(solvent%eps, solvent=solvent%solvent, &
         kernel=born_kernel%still, alpb=.true.)
      allocate(solv)
      call new_alpb(solv, mol, alpb_inp,"gfn2")
      call move_alloc(solv, cont)
      call calc%push_back(cont)
   end block

   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   allocate(pproc)
   allocate(xtbml_param)
   allocate(pparam)
   xtbml_param%xtbml_energy = .true.
   call move_alloc(xtbml_param, tmp_record)
   call pparam%push(tmp_record)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res, post_process=pproc)

   call res%dict%get_entry("E_tot", tmp_array)
   sum_energy = sum_energy + sum(tmp_array)

   if (abs(sum_energy-energy)  > thr) then
      call test_failed(error, "GFN2: Energy features don't add up to total energy.")
      write(*,*) "diff:"
      print'(3es21.14)', abs(sum_energy-energy)
   end if

   call res%dict%remove_entry("E_tot")
   call res%dict%remove_entry("w_tot")
   call res%dict%remove_entry("n_features")

   sum_energy = 0.0_wp
   do i = 1, res%dict%get_n_entries()
      call res%dict%get_entry(i, tmp_array)
      call res%dict%get_label(i, label1)
      sum_energy = sum_energy + sum(tmp_array)
      deallocate(tmp_array)
   end do

   if (abs(sum_energy-energy)  > thr) then
      call test_failed(error, "GFN2: Energy features don't add up to total energy.")
      write(*,*) "diff:"
      print'(3es21.14)', abs(sum_energy-energy)
   end if

end subroutine test_energy_sum_up_gfn2

subroutine test_energy_sum_up_gfn1(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(integral_type) :: ints
   type(results_type) :: res
   type(post_processing_list), allocatable :: pproc
   type(xtbml_record), allocatable :: xtbml_param
   type(post_processing_record_list), allocatable :: pparam
   class(post_processing_record), allocatable :: tmp_record
   integer, parameter :: nat=12
   real(wp), allocatable :: tmp_array(:)
   real(wp) :: energy = 1.0_wp, sum_energy = 0.0_wp
   integer :: i,j

   real(wp), parameter :: xyz(3, nat) = reshape((/&
   &1.06880660023529,       -0.46478030005927,        0.00009471732781,&
   &2.45331325533661,       -0.46484444142679,        0.00042084312846,&
   &3.14559996373466,        0.73409173401801,        0.00008724271521,&
   &2.45340597395333,        1.93314591537421,       -0.00086301044874,&
   &1.06895328716368,        1.93321130458200,       -0.00141386731889,&
   &0.37663958202671,        0.73422879200405,       -0.00090929198808,&
   &0.52864276199175,       -1.40035288735680,        0.00049380958906,&
   &2.99337903563419,       -1.40047547903112,        0.00121759015506,&
   &4.22591259698321,        0.73408789322206,        0.00025398801936,&
   &2.99365942822711,        2.86866756976346,       -0.00166131228918,&
   &0.52879830433456,        2.86879139255056,       -0.00224874122149,&
   &-0.70367266962110,        0.73433126635962,       -0.00138296766859&
   &/),shape=(/3,nat/))
   integer, parameter :: num(nat) = (/6,6,6,6,6,6,1,1,1,1,1,1/)

   if (.not.get_tblite_feature("ddx")) return

   call new(mol,num,xyz*aatoau,uhf=0,charge=0.0_wp)
   call new_gfn1_calculator(calc,mol,error)
   if (allocated(error)) return
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   allocate(pproc)
   allocate(xtbml_param)
   allocate(pparam)
   xtbml_param%xtbml_energy = .true.
   call move_alloc(xtbml_param, tmp_record)
   call pparam%push(tmp_record)

   block
      class(container_type), allocatable :: cont
      type(ddx_solvation), allocatable :: solv
      type(ddx_input) :: ddx_inp

      ddx_inp = ddx_input(ddx_model=ddx_solvation_model%cpcm, dielectric_const=4.0_wp) ! ddCPCM
      allocate(solv)
      call new_ddx(solv, mol, ddx_inp, error)
      if (allocated(error)) return
      call move_alloc(solv, cont)
      call calc%push_back(cont)
   end block

   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res, post_process=pproc)

   call res%dict%get_entry("E_tot", tmp_array)
   sum_energy = sum_energy + sum(tmp_array)

   if (abs(sum_energy-energy)  > thr) then
      call test_failed(error, "GFN1: Energy features don't add up to total energy.")
      write(*,*) "diff:"
      print'(3es21.14)', abs(sum_energy-energy)
   end if

   call res%dict%remove_entry("E_tot")
   call res%dict%remove_entry("w_tot")
   call res%dict%remove_entry("n_features")

   sum_energy = 0.0_wp
   do i = 1, res%dict%get_n_entries()
      call res%dict%get_entry(i, tmp_array)
      sum_energy = sum_energy + sum(tmp_array)
      deallocate(tmp_array)
   end do

   if (abs(sum_energy-energy)  > thr) then
      call test_failed(error, "GFN1: Energy features don't add up to total energy.")
      write(*,*) "diff:"
      print'(3es21.14)', abs(sum_energy-energy)
   end if

end subroutine test_energy_sum_up_gfn1

subroutine test_high_spin(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(integral_type) :: ints
   type(results_type) :: res
   type(post_processing_list), allocatable :: pproc
   type(xtbml_record), allocatable :: xtbml_param
   type(post_processing_record_list), allocatable :: pparam
   class(post_processing_record), allocatable :: tmp_record
   integer, parameter :: nat=3
   real(wp), allocatable :: tmp_array(:)
   real(wp) :: energy = 1.0_wp , sum_energy = 0.0_wp
   integer :: i,j
   character(len=:), allocatable :: label1

   real(wp), parameter :: xyz(3, nat) = reshape((/0.00000,0.00000,1.0000000,&
   &0.0000,0.00000,-1.0000000,&
   &0.000000,0.000000,0.000000/),shape=(/3,nat/))
   integer, parameter :: num(nat) = (/8,8,6/)

   call new(mol,num,xyz*aatoau,uhf=2,charge=0.0_wp)

   call new_gfn2_calculator(calc, mol, error)

   block
      class(container_type), allocatable :: cont
      type(spin_polarization), allocatable :: spin
      real(wp), allocatable :: wll(:, :, :)
      allocate(spin)
      call get_spin_constants(wll, mol, calc%bas)
      call new_spin_polarization(spin, mol, wll, calc%bas%nsh_id)
      call move_alloc(spin, cont)
      call calc%push_back(cont)
   end block

   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 2, kt)
   allocate(pproc)
   allocate(xtbml_param)
   allocate(pparam)
   xtbml_param%xtbml_density = .true.
   xtbml_param%xtbml_orbital_energy = .true.
   xtbml_param%xtbml_convolution = .true.
   call move_alloc(xtbml_param, tmp_record)
   call pparam%push(tmp_record)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res, post_process=pproc)
      !16 features per spin channel => 32
      !9 features for orbital energy => 18
      !1 for the number of features
      ! total 51
   if (res%dict%get_n_entries() /= 51) then
      call test_failed(error, "Wrong number of features")
   end if

end subroutine test_high_spin

subroutine test_orbital_energy_hp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(post_processing_list), allocatable :: pproc
   type(xtbml_record), allocatable :: xtbml_param
   type(post_processing_record_list), allocatable :: pparam
   type(results_type) :: res
   class(post_processing_record), allocatable :: tmp_record
   real(wp), allocatable :: mulliken_shell(:)
   real(wp) :: energy = 0.0_wp
   real(wp), parameter :: xyz(3, 1) = reshape((/0.0_wp,0.0_wp,0.35_wp/),shape=(/3,1/))
   integer, parameter :: num(1) = (/1/)

   call new(mol, num, xyz*aatoau, uhf=0, charge=1.0_wp)
   call new_gfn2_calculator(calc, mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   calc%save_integrals = .true.
   allocate(pproc)
   allocate(xtbml_param)
   allocate(pparam)
   xtbml_param%xtbml_orbital_energy = .true.
   call move_alloc(xtbml_param, tmp_record)
   call pparam%push(tmp_record)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res, post_process=pproc)

   call res%dict%get_entry("HOAO", mulliken_shell)
   if (sum(mulliken_shell) > -10.0e10_wp) then
      call test_failed(error, "HOAO is occupied")
      print'(3es21.14)', mulliken_shell
   end if

end subroutine test_orbital_energy_hp

subroutine test_orbital_energy_he(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   type(context_type) :: ctx
   type(structure_type) :: mol
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(post_processing_list), allocatable :: pproc
   type(xtbml_record), allocatable :: xtbml_param
   type(post_processing_record_list), allocatable :: pparam
   type(results_type) :: res
   class(post_processing_record), allocatable :: tmp_record
   real(wp), allocatable :: mulliken_shell(:)
   real(wp) :: energy = 0.0_wp
   real(wp), parameter :: xyz(3, 1) = reshape((/0.0_wp,0.0_wp,0.35_wp/),shape=(/3,1/))
   integer, parameter :: num(1) = (/2/)

   call new(mol, num, xyz*aatoau, uhf=0, charge=0.0_wp)
   call new_gfn1_calculator(calc, mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   calc%save_integrals = .true.
   allocate(pproc)
   allocate(xtbml_param)
   allocate(pparam)
   xtbml_param%xtbml_orbital_energy = .true.
   call move_alloc(xtbml_param, tmp_record)
   call pparam%push(tmp_record)
   call add_post_processing(pproc, mol, pparam, error)
   if (allocated(error)) return
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0, results=res, post_process=pproc)

   call res%dict%get_entry("LUAO", mulliken_shell)
   if (sum(mulliken_shell) < 10.0e10_wp) then
      call test_failed(error, "LUAO is occupied")
      print'(3es21.14)', mulliken_shell
   end if

end subroutine test_orbital_energy_he

!this function is copied from the xtb codebase
subroutine compute_traceless_mol_qm(n,xyz,q,dipm,qp,mol_qm)
   integer :: n,i,l,k,j
   real(wp) :: xyz(3,n),dipm(3,n), qp(6,n),q(n)
   real(wp) :: mol_qm(6)
   real(wp) :: tma(6),tmb(6),tmc(6),dum
   tma = 0.0_wp
   tmb = 0.0_wp
   tmc = 0.0_wp
   do i = 1,n
      l = 0
      do j = 1,3
         do k = 1,j
            l = lin(k,j)
            tma(l) = tma(l)+xyz(j,i)*xyz(k,i)*q(i)
            tmb(l) = tmb(l)+dipm(k,i)*xyz(j,i)+dipm(j,i)*xyz(k,i)
            tmc(l) = tmc(l)+qp(l,i)
         enddo
      enddo
   enddo
   ! remove traces and multiply with 3/2 in q and dip parts
   dum = tma(1)+tma(3)+tma(6)
   dum = 0.50_wp*dum
   tma = 1.50_wp*tma
   l = 0
   do j = 1,3
      l = l+j
      tma(l) = tma(l)-dum
   enddo
   dum = tmb(1)+tmb(3)+tmb(6)
   dum = 0.50_wp*dum
   tmb = 1.50_wp*tmb
   l = 0
   do j = 1,3
      l = l+j
      tmb(l) = tmb(l)-dum
   enddo
   mol_qm = tma+tmb+tmc
end subroutine

!> this function returns the linear index of a matrix element
pure elemental integer function lin(i1,i2)
   integer,intent(in) :: i1,i2
   integer :: idum1,idum2
   idum1=max(i1,i2)
   idum2=min(i1,i2)
   lin=idum2+idum1*(idum1-1)/2
   return
end function lin

subroutine get_spin_constants(wll, mol, bas)
   real(wp), allocatable, intent(out) :: wll(:, :, :)
   type(structure_type), intent(in) :: mol
   type(basis_type), intent(in) :: bas

   integer :: izp, ish, jsh, il, jl

   allocate(wll(bas%nsh, bas%nsh, mol%nid), source=0.0_wp)

   do izp = 1, mol%nid
      do ish = 1, bas%nsh_id(izp)
         il = bas%cgto(ish, izp)%ang
         do jsh = 1, bas%nsh_id(izp)
            jl = bas%cgto(jsh, izp)%ang
            wll(jsh, ish, izp) = get_spin_constant(jl, il, mol%num(izp))
         end do
      end do
   end do
end subroutine get_spin_constants

end module test_xtbml

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

!> Module for handling citation data
module dftd3_citation
   implicit none
   private

   public :: citation_type, author_name, new_citation, is_citation_present
   public :: format_bibtex, get_citation, same_citation
   public :: doi_dftd3_0, doi_dftd3_bj, doi_dftd3_m, doi_dftd3_op, doi_dftd3_cso, &
      & doi_gmtkn30_0, doi_gmtkn30_bj, doi_gmtkn55, doi_dsd, doi_dsdpbep86, &
      & doi_drpa, doi_revdsd, doi_pw91_d3, doi_r2scan_d4, doi_scan_d3, &
      & doi_pbeh3c, doi_hse3c, doi_b973c, doi_hf3c, doi_gcp, doi_d3pbc, &
      & doi_r2scan_hyb, doi_r2scan_dhdf, doi_minnesota_d3, doi_b97m_d3, &
      & doi_wb97x_d3, doi_hse06_d3, doi_joss, doi_cf22d, doi_skala

   !> Represents an author to allow creating author lists
   type :: author_type
      !> Name of the author
      character(len=:), allocatable :: name
   end type author_type

   !> Represents a citation
   type :: citation_type
      !> Title of the publication
      character(len=:), allocatable :: title
      !> Authors of the publication
      type(author_type), allocatable :: author(:)
      !> Issue of the publication
      character(len=:), allocatable :: issue
      !> Journal of the publication
      character(len=:), allocatable :: journal
      !> Volume of the publication
      character(len=:), allocatable :: volume
      !> Year of the publication
      character(len=:), allocatable :: year
      !> Page numbers of the publication
      character(len=:), allocatable :: pages
      !> Digital Object Identifier (DOI) of the publication
      character(len=:), allocatable :: doi
   end type citation_type

   character(len=*), parameter :: nl = new_line('a')

   character(len=*), parameter :: &
      & doi_dftd3_0 = "10.1063/1.3382344", &
      & doi_dftd3_bj = "10.1002/jcc.21759", &
      & doi_dftd3_m = "10.1021/acs.jpclett.6b00780", &
      & doi_dftd3_op = "10.1021/acs.jctc.7b00176", &
      & doi_gmtkn30_0 = "10.1021/ct100466k", &
      & doi_gmtkn30_bj = "10.1039/c0cp02984j", &
      & doi_gmtkn55 = "10.1039/c7cp04913g", &
      & doi_dsd = "10.1002/jcc.23391", &
      & doi_dsdpbep86 = "10.1039/c1cp22592h", &
      & doi_drpa = "10.1021/acs.jpca.1c01295", &
      & doi_revdsd = "10.1021/acs.jpca.9b03157", &
      & doi_pw91_d3 = "10.1073/pnas.1516984112", &
      & doi_r2scan_d4 = "10.1063/5.0041008", &
      & doi_scan_d3 = "10.1103/physrevb.94.115144", &
      & doi_pbeh3c = "10.1063/1.4927476", &
      & doi_hse3c = "10.1039/c6cp01697a", &
      & doi_b973c = "10.1063/1.5012601", &
      & doi_hf3c = "10.1002/jcc.23317", &
      & doi_gcp = "10.1063/1.3700154", &
      & doi_d3pbc = "10.1002/cphc.201100521", &
      & doi_r2scan_hyb = "10.1063/5.0086040", &
      & doi_r2scan_dhdf = "10.1063/5.0174988", &
      & doi_minnesota_d3 = "10.1021/acs.jpclett.5b01591", &
      & doi_b97m_d3 = "10.1021/acs.jctc.8b00842", &
      & doi_wb97x_d3 = "10.1021/ct300715s", &
      & doi_hse06_d3 = "10.1021/jp501237c", &
      & doi_joss = "10.21105/joss.07169", &
      & doi_dftd3_cso = "10.1021/acs.jctc.5b00400", &
      & doi_cf22d = "10.1038/s43588-022-00371-5", &
      & doi_skala = "10.48550/arXiv.2506.14665"

contains

!> Create a new citation
pure function new_citation(title, author, journal, issue, volume, year, pages, doi) result(citation)
   !> Title of the publication
   character(len=*), intent(in) :: title
   !> Authors of the publication
   type(author_type), intent(in) :: author(:)
   !> Journal of the publication
   character(len=*), intent(in) :: journal
   !> Issue of the publication
   character(len=*), intent(in), optional :: issue
   !> Volume of the publication
   character(len=*), intent(in) :: volume
   !> Year of the publication
   character(len=*), intent(in) :: year
   !> Page numbers of the publication
   character(len=*), intent(in) :: pages
   !> Digital Object Identifier (DOI) of the publication
   character(len=*), intent(in) :: doi
   !> The new citation
   type(citation_type) :: citation

   citation%title = title
   citation%author = author
   citation%journal = journal
   citation%volume = volume
   citation%year = year
   citation%pages = pages
   citation%doi = doi
   if (present(issue)) citation%issue = issue
end function new_citation

!> Create an author
pure function author_name(name) result(author)
   !> Name of the author
   character(len=*), intent(in) :: name
   !> The new author
   type(author_type) :: author
   author%name = name
end function author_name

!> Check if citation data is present
pure function is_citation_present(citation) result(is_present)
   !> The citation to check
   type(citation_type), intent(in) :: citation
   !> Whether the citation data is present
   logical :: is_present

   is_present = allocated(citation%doi) &
      & .and.allocated(citation%title) &
      & .and.allocated(citation%author) &
      & .and.allocated(citation%journal) &
      & .and.allocated(citation%volume) &
      & .and.allocated(citation%year) &
      & .and.allocated(citation%pages)
end function is_citation_present

!> Check if two citations are the same
pure function same_citation(lhs, rhs) result(same)
   !> The first citation
   type(citation_type), intent(in) :: lhs
   !> The second citation
   type(citation_type), intent(in) :: rhs
   !> Whether the citations are the same
   logical :: same

   if (is_citation_present(lhs) .and. is_citation_present(rhs)) then
      same = lhs%doi == rhs%doi
   else
      same = .false.
   end if
end function same_citation

!> Format a citation as a BibTeX entry
subroutine format_bibtex(string, citation)
   !> The formatted BibTeX entry
   character(len=:), allocatable, intent(out) :: string
   !> The citation to format
   class(citation_type), intent(in) :: citation
   integer :: idx

   if (.not.is_citation_present(citation)) return

   string = &
      & "@article{" // citation%doi // "," // nl // &
      & "  title = {{" // citation%title // "}}," // nl // &
      & "  author = {" // citation%author(1)%name
   do idx = 2, size(citation%author)
      string = string // nl // &
         & "    and " // citation%author(idx)%name
   end do
   string = string // "}," // nl
   if (allocated(citation%issue)) then
      string = string // &
         & "  issue = {" // citation%issue // "}," // nl
   end if
   string = string // &
      & "  volume = {" // citation%volume // "}," // nl // &
      & "  pages = {" // citation%pages // "}," // nl // &
      & "  doi = {" // citation%doi // "}," // nl // &
      & "  url = {https://doi.org/" // citation%doi // "}" // nl // &
      & "}"
end subroutine format_bibtex

!> Get citation data for a given DOI
pure function get_citation(doi) result(citation)
   !> Digital Object Identifier (DOI) of the publication
   character(len=*), intent(in) :: doi
   !> The citation data
   type(citation_type) :: citation

   select case(doi)
   case(doi_dftd3_0)
      citation = new_citation( &
         doi=doi, &
         title="A consistent and accurate ab initio parametrization of density functional &
         & dispersion correction (DFT-D) for the 94 elements H-Pu", &
         author=[ &
         & author_name("Stefan Grimme"), &
         & author_name("Jens Antony"), &
         & author_name("Stephan Ehrlich"), &
         & author_name("Helge Krieg")], &
         journal="J. Chem. Phys.", &
         volume="132", &
         pages="154104", &
         year="2010" &
      )
      
   case(doi_dftd3_bj)
      citation = new_citation( &
         doi=doi, &
         title="Effect of the damping function in dispersion corrected density functional theory", &
         author=[ &
         & author_name("Stefan Grimme"), &
         & author_name("Stephan Ehrlich"), &
         & author_name("Lars Goerigk")], &
         journal="J. Comput. Chem.", &
         issue="7", &
         volume="32", &
         pages="1456-1465", &
         year="2011" &
      )
      
   case(doi_dftd3_m)
      citation = new_citation( &
         doi=doi, &
         title="Revised Damping Parameters for the D3 Dispersion Correction to Density Functional Theory", &
         author=[ &
         & author_name("Daniel G. A. Smith"), &
         & author_name("Lori A. Burns"), &
         & author_name("Konrad Patkowski"), &
         & author_name("C. David Sherrill")], &
         journal="J. Phys. Chem. Lett.", &
         issue="12", &
         volume="7", &
         pages="2197-2203", &
         year="2016" &
      )
      
   case(doi_dftd3_op)
      citation = new_citation( &
         doi=doi, &
         title="Assessing DFT-D3 Damping Functions Across Widely Used Density Functionals: Can We Do Better?", &
         author=[ &
         & author_name("Jonathon Witte"), &
         & author_name("Narbe Mardirossian"), &
         & author_name("Jeffrey B. Neaton"), &
         & author_name("Martin Head-Gordon")], &
         journal="J. Chem. Theory Comput.", &
         issue="5", &
         volume="13", &
         pages="2043-2052", &
         year="2017" &
      )
      
   case(doi_gmtkn30_0)
      citation = new_citation( &
         doi=doi, &
         title="Efficient and Accurate Double-Hybrid-Meta-GGA Density Functionals—Evaluation &
         & with the Extended GMTKN30 Database for General Main Group Thermochemistry, Kinetics, &
         & and Noncovalent Interactions", &
         author=[ &
         & author_name("Lars Goerigk"), &
         & author_name("Stefan Grimme")], &
         journal="J. Chem. Theory Comput.", &
         issue="2", &
         volume="7", &
         pages="291-309", &
         year="2011" &
      )
      
   case(doi_gmtkn30_bj)
      citation = new_citation( &
         doi=doi, &
         title="A thorough benchmark of density functional methods for general main group &
         & thermochemistry, kinetics, and noncovalent interactions", &
         author=[ &
         & author_name("Lars Goerigk"), &
         & author_name("Stefan Grimme")], &
         journal="Phys. Chem. Chem. Phys.", &
         issue="14", &
         volume="13", &
         pages="6670-6688", &
         year="2011" &
      )
      
   case(doi_gmtkn55)
      citation = new_citation( &
         doi=doi, &
         title="A look at the density functional theory zoo with the advanced GMTKN55 &
         & database for general main group thermochemistry, kinetics and noncovalent interactions", &
         author=[ &
         & author_name("Lars Goerigk"), &
         & author_name("Andreas Hansen"), &
         & author_name("Christoph Bauer"), &
         & author_name("Stephan Ehrlich"), &
         & author_name("Asim Najibi"), &
         & author_name("Stefan Grimme")], &
         journal="Phys. Chem. Chem. Phys.", &
         issue="48", &
         volume="19", &
         pages="32184-32215", &
         year="2017" &
      )
      
   case(doi_dsd)
      citation = new_citation( &
         doi=doi, &
         title="Spin-component-scaled double hybrids: An extensive search for the best fifth-rung &
         & functionals blending DFT and perturbation theory", &
         author=[ &
         & author_name("Sebastian Kozuch"), &
         & author_name("Jan M. L. Martin")], &
         journal="J. Comput. Chem.", &
         issue="27", &
         volume="34", &
         pages="2327-2344", &
         year="2013" &
      )
      
   case(doi_dsdpbep86)
      citation = new_citation( &
         doi=doi, &
         title="DSD-PBEP86: in search of the best double-hybrid DFT with spin-component scaled &
         & MP2 and dispersion corrections", &
         author=[ &
         & author_name("Sebastian Kozuch"), &
         & author_name("Jan M. L. Martin")], &
         journal="Phys. Chem. Chem. Phys.", &
         issue="45", &
         volume="13", &
         pages="20104-20107", &
         year="2011" &
      )
      
   case(doi_drpa)
      citation = new_citation( &
         doi=doi, &
         title="Exploring Avenues beyond Revised DSD Functionals: II. Random-Phase Approximation and Scaled MP3 Corrections", &
         author=[ &
         & author_name("Golokesh Santra"), &
         & author_name("Emmanouil Semidalas"), &
         & author_name("Jan M. L. Martin")], &
         journal="J. Phys. Chem. A", &
         issue="21", &
         volume="125", &
         pages="4628-4638", &
         year="2021" &
      )
      
   case(doi_revdsd)
      citation = new_citation( &
         doi=doi, &
         title="Minimally Empirical Double-Hybrid Functionals Trained against the GMTKN55 Database: &
         & revDSD-PBEP86-D4, revDOD-PBE-D4, and DOD-SCAN-D4", &
         author=[ &
         & author_name("Golokesh Santra"), &
         & author_name("Nitai Sylvetsky"), &
         & author_name("Jan M. L. Martin")], &
         journal="J. Phys. Chem. A", &
         issue="24", &
         volume="123", &
         pages="5129-5143", &
         year="2019" &
      )
      
   case(doi_pw91_d3)
      citation = new_citation( &
         doi=doi, &
         title="A priori calculations of the free energy of formation from solution of polymorphic &
         & self-assembled monolayers", &
         author=[ &
         & author_name("Jeffrey R. Reimers"), &
         & author_name("Dwi Panduwinata"), &
         & author_name("Johan Visser"), &
         & author_name("Maxwell J. Crossley")], &
         journal="Proc. Natl. Acad. Sci.", &
         issue="45", &
         volume="112", &
         pages="E6101-E6110", &
         year="2015" &
      )
      
   case(doi_r2scan_d4)
      citation = new_citation( &
         doi=doi, &
         title="r²SCAN-D4: Dispersion corrected meta-generalized gradient approximation for general &
         & chemical applications", &
         author=[ &
         & author_name("Sebastian Ehlert"), &
         & author_name("Uwe Huniar"), &
         & author_name("Jinliang Ning"), &
         & author_name("James W. Furness"), &
         & author_name("Jianwei Sun"), &
         & author_name("Aaron D. Kaplan"), &
         & author_name("John P. Perdew"), &
         & author_name("Jan Gerit Brandenburg")], &
         journal="J. Chem. Phys.", &
         volume="154", &
         pages="061101", &
         year="2021" &
      )
      
   case(doi_scan_d3)
      citation = new_citation( &
         doi=doi, &
         title="Benchmark tests of a strongly constrained semilocal functional with a &
         & long-range dispersion correction", &
         author=[ &
         & author_name("J. G. Brandenburg"), &
         & author_name("J. E. Bates"), &
         & author_name("J. Sun"), &
         & author_name("J. P. Perdew")], &
         journal="Phys. Rev. B", &
         volume="94", &
         pages="115144", &
         year="2016" &
      )
      
   case(doi_pbeh3c)
      citation = new_citation( &
         doi=doi, &
         title="Consistent structures and interactions by density functional theory &
         & with small atomic orbital basis sets", &
         author=[ &
         & author_name("Stefan Grimme"), &
         & author_name("Jan Gerit Brandenburg"), &
         & author_name("Christoph Bannwarth"), &
         & author_name("Andreas Hansen")], &
         journal="J. Chem. Phys.", &
         volume="143", &
         pages="054107", &
         year="2015" &
      )
      
   case(doi_hse3c)
      citation = new_citation( &
         doi=doi, &
         title="Screened exchange hybrid density functional for accurate and efficient &
         & structures and interaction energies", &
         author=[ &
         & author_name("Jan Gerit Brandenburg"), &
         & author_name("Eike Caldeweyher"), &
         & author_name("Stefan Grimme")], &
         journal="Phys. Chem. Chem. Phys.", &
         issue="23", &
         volume="18", &
         pages="15519-15523", &
         year="2016" &
      )
      
   case(doi_b973c)
      citation = new_citation( &
         doi=doi, &
         title="B97-3c: A revised low-cost variant of the B97-D density functional method", &
         author=[ &
         & author_name("Jan Gerit Brandenburg"), &
         & author_name("Christoph Bannwarth"), &
         & author_name("Andreas Hansen"), &
         & author_name("Stefan Grimme")], &
         journal="J. Chem. Phys.", &
         volume=" 148", &
         pages="064104", &
         year="2018" &
      )
      
   case(doi_hf3c)
      citation = new_citation( &
         doi=doi, &
         title="Corrected small basis set Hartree-Fock method for large systems", &
         author=[ &
         & author_name("Rebecca Sure"), &
         & author_name("Stefan Grimme")], &
         journal="J. Comput. Chem.", &
         issue="19", &
         volume="34", &
         pages="1672-1685", &
         year="2013" &
      )
      
   case(doi_gcp)
      citation = new_citation( &
         doi=doi, &
         title="A geometrical correction for the inter- and intra-molecular basis set &
         & superposition error in Hartree-Fock and density functional theory calculations for large systems", &
         author=[ &
         & author_name("Holger Kruse"), &
         & author_name("Stefan Grimme")], &
         journal="J. Chem. Phys.", &
         volume="136", &
         pages="154101", &
         year="2012" &
      )
      
   case(doi_d3pbc)
      citation = new_citation( &
         doi=doi, &
         title="System-Dependent Dispersion Coefficients for the DFT-D3 Treatment of &
         & Adsorption Processes on Ionic Surfaces", &
         author=[ &
         & author_name("Stephan Ehrlich"), &
         & author_name("Jonas Moellmann"), &
         & author_name("Werner Reckien"), &
         & author_name("Thomas Bredow"), &
         & author_name("Stefan Grimme")], &
         journal="ChemPhysChem", &
         issue="17", &
         volume="12", &
         pages="3414", &
         year="2011" &
      )
      
   case(doi_r2scan_hyb)
      citation = new_citation( &
         doi=doi, &
         title="Dispersion corrected r²SCAN based global hybrid functionals: r²SCANh, r²SCAN0, and r²SCAN50", &
         author=[ &
         & author_name("Markus Bursch"), &
         & author_name("Hagen Neugebauer"), &
         & author_name("Sebastian Ehlert"), &
         & author_name("Stefan Grimme")], &
         journal="J. Chem. Phys.", &
         volume="156", &
         pages="134105", &
         year="2022" &
      )
      
   case(doi_r2scan_dhdf)
      citation = new_citation( &
         doi=doi, &
         title="Dispersion-corrected r²SCAN based double-hybrid functionals", &
         author=[ &
         & author_name("Lukas Wittmann"), &
         & author_name("Hagen Neugebauer"), &
         & author_name("Stefan Grimme"), &
         & author_name("Markus Bursch")], &
         journal="J. Chem. Phys.", &
         volume="159", &
         pages="224103", &
         year="2023" &
      )
      
   case(doi_minnesota_d3)
      citation = new_citation( &
         doi=doi, &
         title="Treating London-Dispersion Effects with the Latest Minnesota Density Functionals: &
         & Problems and Possible Solutions", &
         author=[ &
         & author_name("Lars Goerigk")], &
         journal="J. Phys. Chem. Lett.", &
         issue="19", &
         volume="6", &
         pages="3891-3896", &
         year="2015" &
      )
      
   case(doi_b97m_d3)
      citation = new_citation( &
         doi=doi, &
         title="The Nonlocal Kernel in van der Waals Density Functionals as an Additive Correction: &
         & An Extensive Analysis with Special Emphasis on the B97M-V and ωB97M-V Approaches", &
         author=[ &
         & author_name("Asim Najibi"), &
         & author_name("Lars Goerigk")], &
         journal="J. Chem. Theory Comput.", &
         issue="11", &
         volume="14", &
         pages="5725-5738", &
         year="2018" &
      )
      
   case(doi_wb97x_d3)
      citation = new_citation( &
         doi=doi, &
         title="Long-Range Corrected Hybrid Density Functionals with Improved Dispersion Corrections", &
         author=[ &
         & author_name("You-Sheng Lin"), &
         & author_name("Guan-De Li"), &
         & author_name("Shan-Ping Mao"), &
         & author_name("Jeng-Da Chai")], &
         journal="J. Chem. Theory Comput.", &
         issue="1", &
         volume="9", &
         pages="263-272", &
         year="2013" &
      )
      
   case(doi_hse06_d3)
      citation = new_citation( &
         doi=doi, &
         title="DFT-D3 Study of Some Molecular Crystals", &
         author=[ &
         & author_name("Jonas Moellmann"), &
         & author_name("Stefan Grimme")], &
         journal="J. Phys. Chem. C", &
         issue="14", &
         volume="118", &
         pages="7615-7621", &
         year="2014" &
      )
      
   case(doi_joss)
      citation = new_citation( &
         doi=doi, &
         title="Simple DFT-D3: Library first implementation of the D3 dispersion correction", &
         author=[ &
         & author_name("Sebastian Ehlert")], &
         journal="J. Open Source Softw.", &
         issue="103", &
         volume="9", &
         pages="7169", &
         year="2024" &
      )

   case(doi_cf22d)
      citation = new_citation( &
         doi=doi, &
         title="Supervised learning of a chemistry functional with damped dispersion", &
         author=[ &
         & author_name("Yiwei Liu"), &
         & author_name("Cheng Zhang"), &
         & author_name("Zhonghua Liu"), &
         & author_name("Donald G. Truhlar"), &
         & author_name("Ying Wang"), &
         & author_name("Xiao He")], &
         journal="Nat. Comput. Sci.", &
         issue="1", &
         volume="3", &
         pages="48–58", &
         year="2023" &
      )

   case(doi_skala)
      citation = new_citation( &
         doi=doi, &
         title="Accurate and scalable exchange-correlation with deep learning", &
         author=[ &
         & author_name("Giulia Luise"), &
         & author_name("Chin-Wei Huang"), &
         & author_name("Thijs Vogels"), &
         & author_name("Derk P. Kooi"), &
         & author_name("Sebastian Ehlert"), &
         & author_name("Stephanie Lanius"), &
         & author_name("Klaas J. H. Giesbertz"), &
         & author_name("Amir Karton"), &
         & author_name("Deniz Gunceler"), &
         & author_name("Megan Stanley"), &
         & author_name("Wessel P. Bruinsma"), &
         & author_name("Lin Huang"), &
         & author_name("Xinran Wei"), &
         & author_name("Jos{\'e} Garrido Torres"), &
         & author_name("Abylay Katbashev"), &
         & author_name("Rodrigo Chavez Zavaleta"), &
         & author_name("B{\'a}lint M{\'a}t{\'e}"), &
         & author_name("S{\'e}kou-Oumar Kaba"), &
         & author_name("Roberto Sordillo"), &
         & author_name("Yingrong Chen"), &
         & author_name("David B. Williams-Young"), &
         & author_name("Christopher M. Bishop"), &
         & author_name("Jan Hermann"), &
         & author_name("Rianne van den Berg"), &
         & author_name("Paola Gori-Giorgi")], &
         journal="arXiv", &
         volume="2506.14665", &
         pages="2506.14665", &
         year="2025" &
      )

   case(doi_dftd3_cso)
      citation = new_citation( &
         doi=doi, &
         title="Reformulation of the D3(Becke-Johnson) Dispersion Correction "// &
         & "without Resorting to Higher than C6 Dispersion Coefficients", &
         author=[ &
         & author_name('Heiner Schr{\"o}der'), &
         & author_name("Jens Creon"), &
         & author_name("Tobias Schwabe")], &
         journal="J. Chem. Theory Comput.", &
         volume="11", &
         pages="3163--3170", &
         year="2015" &
      )
   end select
end function get_citation

end module dftd3_citation

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_coulomb_charge
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type, new
   use mctc_ncoord, only : new_ncoord, ncoord_type, cn_count
   use mstore, only : get_structure
   use tblite_basis_type
   use tblite_basis_slater, only : slater_to_gauss
   use tblite_container_cache, only : container_cache
   use tblite_coulomb_cache, only : coulomb_cache
   use tblite_coulomb_charge, only : coulomb_charge_type, effective_coulomb, &
      & new_effective_coulomb, harmonic_average, arithmetic_average, &
      & gamma_coulomb, new_gamma_coulomb
   use tblite_scf, only: new_potential, potential_type
   use tblite_ceh_ceh, only : get_effective_qat
   use tblite_cutoff, only : get_lattice_points
   use tblite_wavefunction_type, only : wavefunction_type, new_wavefunction
   implicit none
   private

   public :: collect_coulomb_charge

   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

   abstract interface
      subroutine coulomb_maker(coulomb, mol, shell)
         import :: coulomb_charge_type, structure_type
         class(coulomb_charge_type), allocatable, intent(out) :: coulomb
         type(structure_type), intent(in) :: mol
         logical, intent(in) :: shell
      end subroutine coulomb_maker
   end interface

   abstract interface
      subroutine charge_maker(wfn, mol, nshell, error)
         import :: wavefunction_type, structure_type, error_type
         class(wavefunction_type), intent(inout) :: wfn
         type(structure_type), intent(in) :: mol
         integer, optional, intent(in) :: nshell(:)
         type(error_type), allocatable, intent(out) :: error
      end subroutine charge_maker
   end interface

contains


!> Collect all exported unit tests
subroutine collect_coulomb_charge(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("energy-atom-e1", test_e_effective_m01), &
      new_unittest("energy-atom-e2", test_e_effective_m02), &
      new_unittest("energy-shell-e1", test_e_effective_m07), &
      new_unittest("energy-atom-pbc-e2", test_e_effective_oxacb), &

      ! new_unittest("energy-atom-sc-e2", test_e_effective_oxacb_sc), & ! perfect scaling can currently not be expected
      new_unittest("energy-atom-pbc-g1", test_e_gamma_urea), &
      ! new_unittest("energy-atom-sc-g1", test_e_gamma_urea_sc), &
      new_unittest("energy-atom-g1", test_e_effective_m10), &
      new_unittest("energy-shell-g2", test_e_effective_m13), &
      new_unittest("gradient-atom-e1", test_g_effective_m03), &
      new_unittest("gradient-atom-e2", test_g_effective_m04), &
      new_unittest("gradient-shell-e1", test_g_effective_m08), &
      new_unittest("gradient-atom-pbc-e2", test_g_effective_co2), &
      new_unittest("gradient-atom-pbc-wsc-threshold", test_g_effective_wsc_threshold), &
      new_unittest("gradient-atom-g1", test_g_effective_m11), &
      new_unittest("gradient-shell-g2", test_g_effective_m14), &
      new_unittest("gradient-atom-pbc-g1", test_g_effective_urea), &
      new_unittest("sigma-atom-e1", test_s_effective_m05), &
      new_unittest("sigma-atom-e2", test_s_effective_m06), &
      new_unittest("sigma-shell-e1", test_s_effective_m09), &
      new_unittest("sigma-atom-pbc-e2", test_s_effective_ammonia), &
      new_unittest("sigma-atom-pbc-wsc-threshold", test_s_effective_wsc_threshold), &
      new_unittest("sigma-atom-g1", test_s_effective_m12), &
      new_unittest("sigma-shell-g2", test_s_effective_m15), &
      new_unittest("sigma-atom-pbc-g2", test_s_effective_pyrazine), &
      new_unittest("potential-gradient-lih-effceh", test_ceh_potgrad_lih), &
      new_unittest("potential-gradient-mb15-effceh", test_ceh_potgrad_mb15), &
      new_unittest("potential-gradient-mb16-shell-effceh", test_ceh_potgrad_mb16), &
      new_unittest("potential-sigma-lih-effceh", test_ceh_potsigma_lih), &
      new_unittest("potential-sigma-co2-effceh", test_ceh_potsigma_co2), &
      new_unittest("potential-sigma-mb05-effceh", test_ceh_potsigma_mb05), &
      new_unittest("potential-sigma-mb17-shell-effceh", test_ceh_potsigma_mb17) &
      ]

end subroutine collect_coulomb_charge


!> Factory to setup the CEH basis set for testing of the potential (gradient)
subroutine make_basis(bas, mol, ng)
   type(basis_type), intent(out) :: bas
   type(structure_type), intent(in) :: mol
   integer, intent(in) :: ng

   integer, parameter :: nsh(20) = [&
   & 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 2, 3]
   integer, parameter :: lsh(3, 20) = reshape([&
   & 0, 0, 0,  0, 0, 0,  0, 1, 0,  0, 1, 0,  0, 1, 0,  0, 1, 0, &
   & 0, 1, 0,  0, 1, 0,  0, 1, 0,  0, 1, 0,  0, 1, 0,  0, 1, 2, &
   & 0, 1, 2,  0, 1, 2,  0, 1, 2,  0, 1, 2,  0, 1, 2,  0, 1, 2, &
   & 0, 1, 0,  0, 1, 2], shape(lsh))

   integer, parameter :: pqn(3, 20) = reshape([&
   & 1, 0, 0,  1, 0, 0,  2, 2, 0,  2, 2, 0,  2, 2, 0,  2, 2, 0, &
   & 2, 2, 0,  2, 2, 0,  2, 2, 0,  2, 2, 0,  3, 3, 0,  3, 3, 3, &
   & 3, 3, 3,  3, 3, 3,  3, 3, 3,  3, 3, 3,  3, 3, 3,  3, 3, 3, &
   & 4, 4, 0,  4, 4, 3], shape(pqn))

   real(wp), parameter :: zeta(3, 20) = reshape([&
   & 1.23363166_wp, 0.00000000_wp, 0.00000000_wp, 2.27004605_wp, 0.00000000_wp, 0.00000000_wp, &
   & 0.86185456_wp, 1.42017184_wp, 0.00000000_wp, 1.76817995_wp, 1.44095844_wp, 0.00000000_wp, &
   & 2.06339837_wp, 1.52051807_wp, 0.00000000_wp, 2.56058582_wp, 1.86484737_wp, 0.00000000_wp, &
   & 2.71233631_wp, 2.19848968_wp, 0.00000000_wp, 3.21585650_wp, 2.41309737_wp, 0.00000000_wp, &
   & 3.82146807_wp, 2.63063636_wp, 0.00000000_wp, 4.62721228_wp, 2.53599954_wp, 0.00000000_wp, &
   & 0.93221172_wp, 1.55333839_wp, 0.00000000_wp, 1.77220557_wp, 1.59942632_wp, 2.98596647_wp, &
   & 2.26040231_wp, 1.78718151_wp, 2.00990188_wp, 1.85259089_wp, 1.81733349_wp, 1.65269988_wp, &
   & 2.65701241_wp, 2.03189759_wp, 2.03883661_wp, 2.60609998_wp, 2.16530440_wp, 2.41888232_wp, &
   & 2.78818934_wp, 2.24732894_wp, 1.99081182_wp, 2.55424399_wp, 2.20946190_wp, 1.93619550_wp, &
   & 1.73713827_wp, 1.33788617_wp, 0.00000000_wp, 2.47982574_wp, 1.07250770_wp, 2.11920764_wp],&
   & shape(zeta))

   integer :: isp, izp, ish, stat
   integer, allocatable :: nshell(:)
   type(cgto_type), allocatable :: cgto(:, :)

   nshell = nsh(mol%num)
   allocate(cgto(maxval(nshell), mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      do ish = 1, nshell(isp)
         call slater_to_gauss(ng, pqn(ish, izp), lsh(ish, izp), zeta(ish, izp), &
         & cgto(ish, isp), .true., stat)
      end do
   end do

   call new_basis(bas, mol, nshell, cgto, 1.0_wp)

end subroutine make_basis


!> Factory to create electrostatic objects based on GFN1-xTB values
subroutine make_coulomb_e1(coulomb, mol, shell)

   !> New electrostatic object
   class(coulomb_charge_type), allocatable, intent(out) :: coulomb

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Return a shell resolved object
   logical, intent(in) :: shell

   real(wp), parameter :: hubbard_parameter(20) = [&
      & 0.470099_wp, 1.441379_wp, 0.205342_wp, 0.274022_wp, 0.340530_wp, &
      & 0.479988_wp, 0.476106_wp, 0.583349_wp, 0.788194_wp, 0.612878_wp, &
      & 0.165908_wp, 0.354151_wp, 0.221658_wp, 0.438331_wp, 0.798319_wp, &
      & 0.643959_wp, 0.519712_wp, 0.529906_wp, 0.114358_wp, 0.134187_wp]
   integer, parameter :: shell_count(20) = [&
      & 2, 1, 2, 2, 2, 2, 2, 2, 2, 3, 2, 2, 3, 3, 3, 3, 3, 3, 2, 3]
   real(wp), parameter :: shell_scale(3, 20) = reshape([&
      & 0.0_wp, 0.0000000_wp, 0.0000000_wp,  0.0_wp, 0.0000000_wp, 0.0000000_wp, &
      & 0.0_wp,-0.0772012_wp, 0.0000000_wp,  0.0_wp, 0.1113005_wp, 0.0000000_wp, &
      & 0.0_wp, 0.0165643_wp, 0.0000000_wp,  0.0_wp,-0.0471181_wp, 0.0000000_wp, &
      & 0.0_wp, 0.0315090_wp, 0.0000000_wp,  0.0_wp, 0.0374608_wp, 0.0000000_wp, &
      & 0.0_wp,-0.0827352_wp, 0.0000000_wp,  0.0_wp,-0.3892542_wp, 0.0000000_wp, &
      & 0.0_wp,-0.3004391_wp, 0.0000000_wp,  0.0_wp, 0.0674819_wp, 0.0000000_wp, &
      & 0.0_wp, 0.0503564_wp, 0.0000000_wp,  0.0_wp,-0.5925834_wp, 0.0000000_wp, &
      & 0.0_wp,-0.2530875_wp, 0.0000000_wp,  0.0_wp,-0.1678147_wp, 0.0000000_wp, &
      & 0.0_wp,-0.4481841_wp, 0.0000000_wp,  0.0_wp,-0.1450000_wp, 0.0000000_wp, &
      & 0.0_wp,-0.5332978_wp, 0.0000000_wp,  0.0_wp, 1.1522018_wp, 0.0000000_wp],&
      & shape(shell_scale)) + 1.0_wp
   real(wp), parameter :: gexp = 2.0_wp
   real(wp), allocatable :: hubbard(:, :)
   integer :: isp, izp, ish
   type(effective_coulomb), allocatable :: tmp

   allocate(tmp)
   if (shell) then
      allocate(hubbard(3, mol%nid))
      do isp = 1, mol%nid
         izp = mol%num(isp)
         do ish = 1, shell_count(izp)
            hubbard(ish, isp) = hubbard_parameter(izp) * shell_scale(ish, izp)
         end do
      end do
      call new_effective_coulomb(tmp, mol, gexp, hubbard, harmonic_average, &
         & shell_count(mol%num))
   else
      hubbard = reshape(hubbard_parameter(mol%num), [1, mol%nid])
      call new_effective_coulomb(tmp, mol, gexp, hubbard, harmonic_average)
   end if
   call move_alloc(tmp, coulomb)

end subroutine make_coulomb_e1

!> Factory to create electrostatic objects based on GFN2-xTB values
subroutine make_coulomb_e2(coulomb, mol, shell)

   !> New electrostatic object
   class(coulomb_charge_type), allocatable, intent(out) :: coulomb

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Return a shell resolved object
   logical, intent(in) :: shell

   real(wp), parameter :: hubbard_parameter(20) = [&
      & 0.405771_wp, 0.642029_wp, 0.245006_wp, 0.684789_wp, 0.513556_wp, &
      & 0.538015_wp, 0.461493_wp, 0.451896_wp, 0.531518_wp, 0.850000_wp, &
      & 0.271056_wp, 0.344822_wp, 0.364801_wp, 0.720000_wp, 0.297739_wp, &
      & 0.339971_wp, 0.248514_wp, 0.502376_wp, 0.247602_wp, 0.320378_wp]
   integer, parameter :: shell_count(20) = [&
      & 1, 2, 2, 2, 2, 2, 2, 2, 2, 3, 2, 3, 3, 3, 3, 3, 3, 3, 2, 3]
   real(wp), parameter :: shell_scale(3, 20) = reshape([&
      & 0.0_wp, 0.0000000_wp, 0.0000000_wp, 0.0_wp, 0.0000000_wp, 0.0000000_wp, &
      & 0.0_wp, 0.1972612_wp, 0.0000000_wp, 0.0_wp, 0.9658467_wp, 0.0000000_wp, &
      & 0.0_wp, 0.3994080_wp, 0.0000000_wp, 0.0_wp, 0.1056358_wp, 0.0000000_wp, &
      & 0.0_wp, 0.1164892_wp, 0.0000000_wp, 0.0_wp, 0.1497020_wp, 0.0000000_wp, &
      & 0.0_wp, 0.1677376_wp, 0.0000000_wp, 0.0_wp, 0.1190576_wp,-0.3200000_wp, &
      & 0.0_wp, 0.1018894_wp, 0.0000000_wp, 0.0_wp, 1.4000000_wp,-0.0500000_wp, &
      & 0.0_wp,-0.0603699_wp, 0.2000000_wp, 0.0_wp,-0.5580042_wp,-0.2300000_wp, &
      & 0.0_wp,-0.1558060_wp,-0.3500000_wp, 0.0_wp,-0.1085866_wp,-0.2500000_wp, &
      & 0.0_wp, 0.4989400_wp, 0.5000000_wp, 0.0_wp,-0.0461133_wp,-0.0100000_wp, &
      & 0.0_wp, 0.3483655_wp, 0.0000000_wp, 0.0_wp, 1.5000000_wp,-0.2500000_wp],&
      & shape(shell_scale)) + 1.0_wp
   real(wp), parameter :: gexp = 2.0_wp
   real(wp), allocatable :: hubbard(:, :)
   integer :: isp, izp, ish
   type(effective_coulomb), allocatable :: tmp

   allocate(tmp)
   if (shell) then
      allocate(hubbard(3, mol%nid))
      do isp = 1, mol%nid
         izp = mol%num(isp)
         do ish = 1, shell_count(izp)
            hubbard(ish, isp) = hubbard_parameter(izp) * shell_scale(ish, izp)
         end do
      end do
      call new_effective_coulomb(tmp, mol, gexp, hubbard, arithmetic_average, &
         & shell_count(mol%num))
   else
      hubbard = reshape(hubbard_parameter(mol%num), [1, mol%nid])
      call new_effective_coulomb(tmp, mol, gexp, hubbard, arithmetic_average)
   end if
   call move_alloc(tmp, coulomb)

end subroutine make_coulomb_e2

!> Factory to create electrostatic objects based on CEH values
subroutine make_coulomb_eceh(coulomb, mol, shell)

   !> New electrostatic object
   class(coulomb_charge_type), allocatable, intent(out) :: coulomb

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Return a shell resolved object
   logical, intent(in) :: shell

   real(wp), parameter :: hubbard_parameter(20) = [&
      & 0.47259288_wp, 0.92203391_wp, 0.17452888_wp, 0.25700733_wp, &
      & 0.33949086_wp, 0.42195412_wp, 0.50438193_wp, 0.58691863_wp, &
      & 0.66931351_wp, 0.75191607_wp, 0.17964105_wp, 0.22157276_wp, &
      & 0.26348578_wp, 0.30539645_wp, 0.34734014_wp, 0.38924725_wp, &
      & 0.43115670_wp, 0.47308269_wp, 0.17105469_wp, 0.20276244_wp]
   integer, parameter :: shell_count(20) = [&
      & 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 2, 3]

   real(wp), parameter :: gexp = 1.0_wp
   real(wp), allocatable :: hubbard(:, :)
   integer :: isp, izp, ish
   type(effective_coulomb), allocatable :: tmp

   allocate(tmp)
   if (shell) then
      ! If shell-resolved, we use the atomic parameter for each shell
      allocate(hubbard(3, mol%nid))
      do isp = 1, mol%nid
         izp = mol%num(isp)
         do ish = 1, shell_count(izp)
            hubbard(ish, isp) = hubbard_parameter(izp)
         end do
      end do
      call new_effective_coulomb(tmp, mol, gexp, hubbard, arithmetic_average, &
         & shell_count(mol%num))
   else
      hubbard = reshape(hubbard_parameter(mol%num), [1, mol%nid])
      call new_effective_coulomb(tmp, mol, gexp, hubbard, arithmetic_average)
   end if
   call move_alloc(tmp, coulomb)

end subroutine make_coulomb_eceh

!> Factory to create electrostatic objects based on GFN1-xTB values
subroutine make_coulomb_g1(coulomb, mol, shell)

   !> New electrostatic object
   class(coulomb_charge_type), allocatable, intent(out) :: coulomb

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Return a shell resolved object
   logical, intent(in) :: shell

   real(wp), parameter :: hubbard_parameter(20) = [&
      & 0.470099_wp, 1.441379_wp, 0.205342_wp, 0.274022_wp, 0.340530_wp, &
      & 0.479988_wp, 0.476106_wp, 0.583349_wp, 0.788194_wp, 0.612878_wp, &
      & 0.165908_wp, 0.354151_wp, 0.221658_wp, 0.438331_wp, 0.798319_wp, &
      & 0.643959_wp, 0.519712_wp, 0.529906_wp, 0.114358_wp, 0.134187_wp]
   integer, parameter :: shell_count(20) = [&
      & 2, 1, 2, 2, 2, 2, 2, 2, 2, 3, 2, 2, 3, 3, 3, 3, 3, 3, 2, 3]
   real(wp), parameter :: shell_scale(3, 20) = reshape([&
      & 0.0_wp, 0.0000000_wp, 0.0000000_wp,  0.0_wp, 0.0000000_wp, 0.0000000_wp, &
      & 0.0_wp,-0.0772012_wp, 0.0000000_wp,  0.0_wp, 0.1113005_wp, 0.0000000_wp, &
      & 0.0_wp, 0.0165643_wp, 0.0000000_wp,  0.0_wp,-0.0471181_wp, 0.0000000_wp, &
      & 0.0_wp, 0.0315090_wp, 0.0000000_wp,  0.0_wp, 0.0374608_wp, 0.0000000_wp, &
      & 0.0_wp,-0.0827352_wp, 0.0000000_wp,  0.0_wp,-0.3892542_wp, 0.0000000_wp, &
      & 0.0_wp,-0.3004391_wp, 0.0000000_wp,  0.0_wp, 0.0674819_wp, 0.0000000_wp, &
      & 0.0_wp, 0.0503564_wp, 0.0000000_wp,  0.0_wp,-0.5925834_wp, 0.0000000_wp, &
      & 0.0_wp,-0.2530875_wp, 0.0000000_wp,  0.0_wp,-0.1678147_wp, 0.0000000_wp, &
      & 0.0_wp,-0.4481841_wp, 0.0000000_wp,  0.0_wp,-0.1450000_wp, 0.0000000_wp, &
      & 0.0_wp,-0.5332978_wp, 0.0000000_wp,  0.0_wp, 1.1522018_wp, 0.0000000_wp],&
      & shape(shell_scale)) + 1.0_wp
   real(wp), parameter :: gexp = 2.0_wp
   real(wp), allocatable :: hubbard(:, :)
   integer :: isp, izp, ish
   type(gamma_coulomb), allocatable :: tmp

   allocate(tmp)
   if (shell) then
      allocate(hubbard(3, mol%nid))
      do isp = 1, mol%nid
         izp = mol%num(isp)
         do ish = 1, shell_count(izp)
            hubbard(ish, isp) = hubbard_parameter(izp) * shell_scale(ish, izp)
         end do
      end do
      call new_gamma_coulomb(tmp, mol, hubbard, shell_count(mol%num))
   else
      hubbard = reshape(hubbard_parameter(mol%num), [1, mol%nid])
      call new_gamma_coulomb(tmp, mol, hubbard)
   end if
   call move_alloc(tmp, coulomb)

end subroutine make_coulomb_g1


!> Factory to create electrostatic objects based on GFN1-xTB values
subroutine make_coulomb_g2(coulomb, mol, shell)

   !> New electrostatic object
   class(coulomb_charge_type), allocatable, intent(out) :: coulomb

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Return a shell resolved object
   logical, intent(in) :: shell

   real(wp), parameter :: hubbard_parameter(20) = [&
      & 0.405771_wp, 0.642029_wp, 0.245006_wp, 0.684789_wp, 0.513556_wp, &
      & 0.538015_wp, 0.461493_wp, 0.451896_wp, 0.531518_wp, 0.850000_wp, &
      & 0.271056_wp, 0.344822_wp, 0.364801_wp, 0.720000_wp, 0.297739_wp, &
      & 0.339971_wp, 0.248514_wp, 0.502376_wp, 0.247602_wp, 0.320378_wp]
   integer, parameter :: shell_count(20) = [&
      & 1, 2, 2, 2, 2, 2, 2, 2, 2, 3, 2, 3, 3, 3, 3, 3, 3, 3, 2, 3]
   real(wp), parameter :: shell_scale(3, 20) = reshape([&
      & 0.0_wp, 0.0000000_wp, 0.0000000_wp, 0.0_wp, 0.0000000_wp, 0.0000000_wp, &
      & 0.0_wp, 0.1972612_wp, 0.0000000_wp, 0.0_wp, 0.9658467_wp, 0.0000000_wp, &
      & 0.0_wp, 0.3994080_wp, 0.0000000_wp, 0.0_wp, 0.1056358_wp, 0.0000000_wp, &
      & 0.0_wp, 0.1164892_wp, 0.0000000_wp, 0.0_wp, 0.1497020_wp, 0.0000000_wp, &
      & 0.0_wp, 0.1677376_wp, 0.0000000_wp, 0.0_wp, 0.1190576_wp,-0.3200000_wp, &
      & 0.0_wp, 0.1018894_wp, 0.0000000_wp, 0.0_wp, 1.4000000_wp,-0.0500000_wp, &
      & 0.0_wp,-0.0603699_wp, 0.2000000_wp, 0.0_wp,-0.5580042_wp,-0.2300000_wp, &
      & 0.0_wp,-0.1558060_wp,-0.3500000_wp, 0.0_wp,-0.1085866_wp,-0.2500000_wp, &
      & 0.0_wp, 0.4989400_wp, 0.5000000_wp, 0.0_wp,-0.0461133_wp,-0.0100000_wp, &
      & 0.0_wp, 0.3483655_wp, 0.0000000_wp, 0.0_wp, 1.5000000_wp,-0.2500000_wp],&
      & shape(shell_scale)) + 1.0_wp
   real(wp), parameter :: gexp = 2.0_wp
   real(wp), allocatable :: hubbard(:, :)
   integer :: isp, izp, ish
   type(gamma_coulomb), allocatable :: tmp

   allocate(tmp)
   if (shell) then
      allocate(hubbard(3, mol%nid))
      do isp = 1, mol%nid
         izp = mol%num(isp)
         do ish = 1, shell_count(izp)
            hubbard(ish, isp) = hubbard_parameter(izp) * shell_scale(ish, izp)
         end do
      end do
      call new_gamma_coulomb(tmp, mol, hubbard, shell_count(mol%num))
   else
      hubbard = reshape(hubbard_parameter(mol%num), [1, mol%nid])
      call new_gamma_coulomb(tmp, mol, hubbard)
   end if
   call move_alloc(tmp, coulomb)

end subroutine make_coulomb_g2


!> Procedure to create CN based effective charges and gradients from CEH
subroutine get_charges_effceh(wfn, mol, nshell, error)

   !> New wavefunction object
   class(wavefunction_type), intent(inout) :: wfn

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Return shell-resolved charges
   integer, optional, intent(in) :: nshell(:)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: ceh_cov_radii(20) = 0.5 * [&
   &  2.4040551903_wp,  1.8947380542_wp,  3.4227634078_wp,  3.5225408137_wp, &
   &  3.6150631704_wp,  2.8649682108_wp,  2.4695867541_wp,  2.3533691180_wp, &
   &  2.4992147462_wp,  3.3442607441_wp,  4.4665909451_wp,  4.3877250907_wp, &
   &  4.6647077385_wp,  4.2086223530_wp,  4.4750280107_wp,  4.2847281423_wp, &
   &  3.8560304959_wp,  3.9017061017_wp,  5.2392192639_wp,  5.1872031383_wp]

   real(wp), parameter :: pauling_en_ceh(20) = (1.0_wp/3.98_wp) * [ &
   &  1.9435211923_wp,  3.6116085622_wp,  2.4630915335_wp,  2.0658837656_wp, &
   &  2.3619778807_wp,  2.9484294262_wp,  3.8753937411_wp,  4.6235054741_wp, &
   &  3.9800000000_wp,  3.5124865506_wp,  2.3578254072_wp,  2.4225832022_wp, &
   &  2.1120078826_wp,  2.4607564741_wp,  2.7410779326_wp,  3.3517034720_wp, &
   &  4.1093492601_wp,  3.7979559518_wp,  2.4147937668_wp,  2.1974781961_wp]
   
   real(wp), allocatable :: lattr(:, :), cn_en(:), dcn_endr(:, :, :), dcn_endL(:, :, :)
   class(ncoord_type), allocatable :: ncoord_en
   integer :: iat, ii, ish

   allocate(cn_en(mol%nat), dcn_endr(3, mol%nat, mol%nat), dcn_endL(3, 3, mol%nat))

   ! Get electronegativity-weighted coordination number 
   call new_ncoord(ncoord_en, mol, cn_count%erf_en, error, &
      & rcov=ceh_cov_radii(mol%num), en=pauling_en_ceh(mol%num))
   if (allocated(error)) return
   call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)
   call ncoord_en%get_coordination_number(mol, lattr, cn_en, dcn_endr, dcn_endL)

   ! Get effective charges and their gradients
   call get_effective_qat(mol, cn_en, wfn%qat, &
      & dcn_endr, dcn_endL, wfn%dqatdr, wfn%dqatdL)

   ! If shell-resolved charges are requested, partition atomic charges on shells
   if(present(nshell)) then
      ii = 0
      do iat = 1, mol%nat
         do ish = 1, nshell(iat)
            wfn%qsh(ii+ish, :) = wfn%qat(iat, :) / real(nshell(iat), wp)
            wfn%dqshdr(:, :, ii+ish, :) = wfn%dqatdr(:, :, iat, :) / real(nshell(iat), wp)
            wfn%dqshdL(:, :, ii+ish, :) = wfn%dqatdL(:, :, iat, :) / real(nshell(iat), wp)
         end do 
         ii = ii + nshell(iat)
      end do 
   end if

end subroutine get_charges_effceh


subroutine test_generic(error, mol, qat, qsh, make_coulomb, ref, thr_in)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Atomic partial charges for this structure
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges for this structure
   real(wp), intent(in), optional :: qsh(:)

   !> Factory to create new electrostatic objects
   procedure(coulomb_maker) :: make_coulomb

   !> Reference value to check against
   real(wp), intent(in) :: ref

   !> Test threshold
   real(wp), intent(in), optional :: thr_in

   class(coulomb_charge_type), allocatable :: coulomb
   type(container_cache) :: cache
   real(wp) :: energy(mol%nat), sigma(3, 3)
   real(wp), allocatable :: gradient(:, :), numgrad(:, :)
   real(wp) :: thr_
   type(wavefunction_type) :: wfn

   thr_ = thr
   if (present(thr_in)) thr_ = thr_in

   allocate(gradient(3, mol%nat), numgrad(3, mol%nat))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   if (present(qsh)) then
      wfn%qsh = reshape(qsh, [size(qsh), 1])
   else
      wfn%qsh = reshape(qat, [size(qat), 1])
   end if
   wfn%qat = reshape(qat, [size(qat), 1])
   call make_coulomb(coulomb, mol, present(qsh))
   call coulomb%update(mol, cache)
   call coulomb%get_energy(mol, cache, wfn, energy)

   call check(error, sum(energy), ref, thr=thr_)
   if (allocated(error)) then
      print*,ref, sum(energy)
   end if

end subroutine test_generic


subroutine test_numgrad(error, mol, qat, qsh, make_coulomb)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Atomic partial charges for this structure
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges for this structure
   real(wp), intent(in), optional :: qsh(:)

   !> Factory to create new electrostatic objects
   procedure(coulomb_maker) :: make_coulomb

   integer :: iat, ic
   class(coulomb_charge_type), allocatable :: coulomb
   type(container_cache) :: cache
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat), sigma(3, 3)
   real(wp), allocatable :: gradient(:, :), numgrad(:, :)
   real(wp), parameter :: step = 5.0e-5_wp
   type(wavefunction_type) :: wfn

   allocate(gradient(3, mol%nat), numgrad(3, mol%nat))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   if (present(qsh)) then
      wfn%qsh = reshape(qsh, [size(qsh), 1])
   else
      wfn%qsh = reshape(qat, [size(qat), 1])
   end if
   wfn%qat = reshape(qat, [size(qat), 1])
   call make_coulomb(coulomb, mol, present(qsh))

   do iat = 1, mol%nat
      do ic = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call coulomb%update(mol, cache)
         call coulomb%get_energy(mol, cache, wfn, er)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2*step
         call coulomb%update(mol, cache)
         call coulomb%get_energy(mol, cache, wfn, el)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         numgrad(ic, iat) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   call coulomb%update(mol, cache)
   call coulomb%get_gradient(mol, cache, wfn, gradient, sigma)

   if (any(abs(gradient - numgrad) > thr2)) then
      call test_failed(error, "Gradient of energy does not match")
      print'(3es21.14)', gradient-numgrad
   end if

end subroutine test_numgrad


subroutine test_numpotgrad(error, mol, get_charges, make_coulomb, shell)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Procedure to provide atomic charges (and their gradients)
   procedure(charge_maker) :: get_charges

   !> Factory to create new electrostatic objects
   procedure(coulomb_maker) :: make_coulomb

   !> Test shell-resolved
   logical, intent(in) :: shell

   integer :: iat, ic
   type(basis_type) :: bas
   type(potential_type) :: potl, potr
   class(coulomb_charge_type), allocatable :: coulomb
   type(container_cache) :: cache
   real(wp), allocatable :: numpotgrad(:, :, :)
   real(wp), parameter :: step = 5.0e-5_wp
   type(wavefunction_type) :: wfn

   ! Setup potentials and wavefunction with dummy basis set 
   call make_basis(bas, mol, 6)
   call new_wavefunction(wfn, mol%nat, bas%nsh, bas%nao, 1, 0.0_wp, .true.)
   call new_potential(potr, mol, bas, 1, .true.)
   call new_potential(potl, mol, bas, 1, .true.)
   call make_coulomb(coulomb, mol, shell)

   if(shell) then
      allocate(numpotgrad(3, mol%nat, bas%nsh), source=0.0_wp)
   else
      allocate(numpotgrad(3, mol%nat, mol%nat), source=0.0_wp)
   end if

   do iat = 1, mol%nat
      do ic = 1, 3
         call potr%reset
         call potl%reset
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call get_charges(wfn, mol, coulomb%nshell, error)
         if (allocated(error)) return
         call coulomb%update(mol, cache)
         call coulomb%get_potential(mol, cache, wfn, potr)

         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2*step
         call get_charges(wfn, mol, coulomb%nshell, error)
         if (allocated(error)) return
         call coulomb%update(mol, cache)
         call coulomb%get_potential(mol, cache, wfn, potl)
         
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         if(shell) then
            numpotgrad(ic, iat, :) = 0.5_wp*(potr%vsh(:,1) - potl%vsh(:,1))/step
         else
            numpotgrad(ic, iat, :) = 0.5_wp*(potr%vat(:,1) - potl%vat(:,1))/step
         end if
      end do
   end do

   call get_charges(wfn, mol, coulomb%nshell, error)
   if (allocated(error)) return
   call coulomb%update(mol, cache)
   call coulomb%get_potential(mol, cache, wfn, potl)
   call coulomb%get_potential_gradient(mol, cache, wfn, potl)
   
   if(shell) then
      if (any(abs(potl%dvshdr(:,:,:,1) - numpotgrad) > thr2)) then
         call test_failed(error, "Gradient of shell-resolved potential does not match")
         print'(3es21.14)', potl%dvshdr(:,:,:,1) - numpotgrad
      end if
   else
      if (any(abs(potl%dvatdr(:,:,:,1) - numpotgrad) > thr2)) then
         call test_failed(error, "Gradient of atom-resolved potential does not match")
         print'(3es21.14)', potl%dvatdr(:,:,:,1) - numpotgrad
      end if
   end if

end subroutine test_numpotgrad


subroutine test_numsigma(error, mol, qat, qsh, make_coulomb)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Atomic partial charges for this structure
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges for this structure
   real(wp), intent(in), optional :: qsh(:)

   !> Factory to create new electrostatic objects
   procedure(coulomb_maker) :: make_coulomb

   integer :: ic, jc
   class(coulomb_charge_type), allocatable :: coulomb
   type(container_cache) :: cache
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat), sigma(3, 3), eps(3, 3), numsigma(3, 3)
   real(wp), allocatable :: gradient(:, :), xyz(:, :), lattice(:, :)
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], shape(unity))
   real(wp), parameter :: step = 1.0e-5_wp
   type(wavefunction_type) :: wfn

   allocate(gradient(3, mol%nat), xyz(3, mol%nat))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   if (present(qsh)) then
      wfn%qsh = reshape(qsh, [size(qsh), 1])
   else
      wfn%qsh = reshape(qat, [size(qat), 1])
   end if
   wfn%qat = reshape(qat, [size(qat), 1])
   call make_coulomb(coulomb, mol, present(qsh))

   eps(:, :) = unity
   xyz(:, :) = mol%xyz
   if (any(mol%periodic)) lattice = mol%lattice
   do ic = 1, 3
      do jc = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = matmul(eps, xyz)
         if (allocated(lattice)) mol%lattice(:, :) = matmul(eps, lattice)
         call coulomb%update(mol, cache)
         call coulomb%get_energy(mol, cache, wfn, er)
         eps(jc, ic) = eps(jc, ic) - 2*step
         mol%xyz(:, :) = matmul(eps, xyz)
         if (allocated(lattice)) mol%lattice(:, :) = matmul(eps, lattice)
         call coulomb%update(mol, cache)
         call coulomb%get_energy(mol, cache, wfn, el)
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = xyz
         if (allocated(lattice)) mol%lattice = lattice
         numsigma(jc, ic) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   call coulomb%update(mol, cache)
   call coulomb%get_gradient(mol, cache, wfn, gradient, sigma)

   if (any(abs(sigma - numsigma) > thr2)) then
      call test_failed(error, "Strain derivatives do not match")
      print'(3es21.14)', sigma-numsigma
   end if

end subroutine test_numsigma


subroutine test_numpotsigma(error, mol, get_charges, make_coulomb, shell)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Procedure to provide atomic charges (and their gradients)
   procedure(charge_maker) :: get_charges

   !> Factory to create new electrostatic objects
   procedure(coulomb_maker) :: make_coulomb

   !> Test shell-resolved
   logical, intent(in) :: shell

   integer :: ic, jc
   type(basis_type) :: bas
   type(potential_type) :: potl, potr
   class(coulomb_charge_type), allocatable :: coulomb
   type(container_cache) :: cache
   real(wp) :: eps(3, 3)
   real(wp), allocatable :: numpotsigma(:, :, :), xyz(:, :), lattice(:, :)
   real(wp), parameter :: unity(3, 3) = reshape(&
   & [1, 0, 0, 0, 1, 0, 0, 0, 1], shape(unity))
   real(wp), parameter :: step = 5.0e-5_wp
   type(wavefunction_type) :: wfn

   allocate(xyz(3, mol%nat), source=0.0_wp)

   ! Setup potentials and wavefunction with dummy basis set 
   call make_basis(bas, mol, 6)
   call new_wavefunction(wfn, mol%nat, bas%nsh, bas%nao, 1, 0.0_wp, .true.)
   call new_potential(potr, mol, bas, 1, .true.)
   call new_potential(potl, mol, bas, 1, .true.)
   call make_coulomb(coulomb, mol, shell)

   if(shell) then
      allocate(numpotsigma(3, 3, bas%nsh), source=0.0_wp)
   else
      allocate(numpotsigma(3, 3, mol%nat), source=0.0_wp)
   end if

   eps(:, :) = unity
   xyz(:, :) = mol%xyz
   if (any(mol%periodic)) lattice = mol%lattice
   do ic = 1, 3
      do jc = 1, 3
         call potr%reset
         call potl%reset
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = matmul(eps, xyz)
         if (allocated(lattice)) mol%lattice(:, :) = matmul(eps, lattice)
         call get_charges(wfn, mol, coulomb%nshell, error)
         if (allocated(error)) return
         call coulomb%update(mol, cache)
         call coulomb%get_potential(mol, cache, wfn, potr)

         eps(jc, ic) = eps(jc, ic) - 2*step
         mol%xyz(:, :) = matmul(eps, xyz)
         if (allocated(lattice)) mol%lattice(:, :) = matmul(eps, lattice)
         call get_charges(wfn, mol, coulomb%nshell, error)
         if (allocated(error)) return
         call coulomb%update(mol, cache)
         call coulomb%get_potential(mol, cache, wfn, potl)
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = xyz
         if (allocated(lattice)) mol%lattice = lattice
         if(shell) then
            numpotsigma(jc, ic, :) = 0.5_wp*(potr%vsh(:,1) - potl%vsh(:,1))/step
         else
            numpotsigma(jc, ic, :) = 0.5_wp*(potr%vat(:,1) - potl%vat(:,1))/step
         end if
      end do
   end do

   call get_charges(wfn, mol, coulomb%nshell, error)
   if (allocated(error)) return
   call coulomb%update(mol, cache)
   call coulomb%get_potential(mol, cache, wfn, potl)
   call coulomb%get_potential_gradient(mol, cache, wfn, potl)

   if(shell) then
      if (any(abs(potl%dvshdL(:,:,:,1) - numpotsigma) > thr2)) then
         call test_failed(error, "Sigma of shell-resolved potential does not match")
         print'(3es21.14)', potl%dvshdL(:,:,:,1) - numpotsigma
      end if
   else
      if (any(abs(potl%dvatdL(:,:,:,1) - numpotsigma) > thr2)) then
         call test_failed(error, "Sigma of atom-resolved potential does not match")
         print'(3es21.14)', potl%dvatdL(:,:,:,1) - numpotsigma
      end if
   end if

end subroutine test_numpotsigma


subroutine test_e_effective_m01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 7.73347900345264E-1_wp, 1.07626888948184E-1_wp,-3.66999593831010E-1_wp,&
      & 4.92833325937897E-2_wp,-1.83332156197733E-1_wp, 2.33302086605469E-1_wp,&
      & 6.61837152062315E-2_wp,-5.43944165050002E-1_wp,-2.70264356583716E-1_wp,&
      & 2.66618968841682E-1_wp, 2.62725033202480E-1_wp,-7.15315510172571E-2_wp,&
      &-3.73300777019193E-1_wp, 3.84585237785621E-2_wp,-5.05851088366940E-1_wp,&
      & 5.17677238544189E-1_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "MB16-43", "01")
   call test_generic(error, mol, qat, qsh, make_coulomb_e1, 0.10952019883948200_wp)

end subroutine test_e_effective_m01


subroutine test_e_effective_m02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 7.38394711236234E-2_wp,-1.68354976558608E-1_wp,-3.47642833746823E-1_wp,&
      &-7.05489267186003E-1_wp, 7.73548301641266E-1_wp, 2.30207581365386E-1_wp,&
      & 1.02748501676354E-1_wp, 9.47818107467040E-2_wp, 2.44260351729187E-2_wp,&
      & 2.34984927037408E-1_wp,-3.17839896393030E-1_wp, 6.67112994818879E-1_wp,&
      &-4.78119977010488E-1_wp, 6.57536027459275E-2_wp, 1.08259054549882E-1_wp,&
      &-3.58215329983396E-1_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "MB16-43", "02")
   call test_generic(error, mol, qat, qsh, make_coulomb_e2, 0.10635843572138280_wp)

end subroutine test_e_effective_m02


subroutine test_e_effective_m10(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-1.68014634286730E-2_wp, 4.42632083957210E-1_wp, 5.27534110370006E-3_wp, &
      &-3.49386920985384E-1_wp,-2.13178401684440E-1_wp, 4.07942205949245E-1_wp, &
      &-4.08514260972236E-1_wp, 1.34978625814380E-1_wp,-2.48254330281858E-1_wp, &
      &-3.65112235756872E-1_wp, 3.19858617682441E-1_wp, 2.96731604233838E-2_wp, &
      & 2.84061022228221E-1_wp,-3.25028474749853E-2_wp,-5.33914616408729E-3_wp, &
      & 1.46685494419848E-2_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "MB16-43", "10")
   call test_generic(error, mol, qat, qsh, make_coulomb_g1, 7.964758847421499E-2_wp, thr2)

end subroutine test_e_effective_m10


subroutine test_e_effective_oxacb(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 3.41731844312030E-1_wp, 3.41716020106239E-1_wp, 3.41730526585671E-1_wp,&
      & 3.41714427217954E-1_wp, 3.80996046757999E-1_wp, 3.80989821246195E-1_wp,&
      & 3.81000747720282E-1_wp, 3.80990494183703E-1_wp,-3.70406587264474E-1_wp,&
      &-3.70407565207006E-1_wp,-3.70417590212352E-1_wp,-3.70399716470705E-1_wp,&
      &-3.52322260586075E-1_wp,-3.52304269439196E-1_wp,-3.52313440903261E-1_wp,&
      &-3.52298498047004E-1_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "X23", "oxacb")
   call test_generic(error, mol, qat, qsh, make_coulomb_e2, &
      & 0.10273708044741356_wp, thr2)

end subroutine test_e_effective_oxacb





! subroutine test_e_effective_oxacb_sc(error)
!
!    !> Error handling
!    type(error_type), allocatable, intent(out) :: error
!
!    type(structure_type) :: mol
!    real(wp), parameter :: qat1(*) = [&
!       & 3.41731844312030E-1_wp, 3.41716020106239E-1_wp, 3.41730526585671E-1_wp,&
!       & 3.41714427217954E-1_wp, 3.80996046757999E-1_wp, 3.80989821246195E-1_wp,&
!       & 3.81000747720282E-1_wp, 3.80990494183703E-1_wp,-3.70406587264474E-1_wp,&
!       &-3.70407565207006E-1_wp,-3.70417590212352E-1_wp,-3.70399716470705E-1_wp,&
!       &-3.52322260586075E-1_wp,-3.52304269439196E-1_wp,-3.52313440903261E-1_wp,&
!       &-3.52298498047004E-1_wp]
!    integer, parameter :: supercell(*) = [2, 2, 2]
!    real(wp), parameter :: qat(*) = [spread(qat1, 2, product(supercell))]
!    real(wp), allocatable :: qsh(:)
!
!    call get_structure(mol, "X23", "oxacb")
!    call make_supercell(mol, supercell)
!    call test_generic(error, mol, qat, qsh, make_coulomb_e2, &
!       & 0.10361965109930950_wp * real(product(supercell), wp), thr2)
!
! end subroutine test_e_effective_oxacb_sc


subroutine test_e_gamma_urea(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 5.55723890858218E-1_wp, 5.55765354442035E-1_wp, 2.50200231242017E-1_wp,&
      & 2.50282053284422E-1_wp, 2.39786980460652E-1_wp, 2.39895142481200E-1_wp,&
      & 2.50103678240412E-1_wp, 2.50425041601730E-1_wp, 2.39464477136495E-1_wp,&
      & 2.40360053062669E-1_wp,-4.38369096728919E-1_wp,-4.38451412936599E-1_wp,&
      &-4.38310020776279E-1_wp,-4.38617373848238E-1_wp,-6.59141030224988E-1_wp,&
      &-6.59117968294813E-1_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "X23", "urea")
   call test_generic(error, mol, qat, qsh, make_coulomb_g1, &
      & 0.12691941032308401_wp, thr2)

end subroutine test_e_gamma_urea


! subroutine test_e_gamma_urea_sc(error)
!
!    !> Error handling
!    type(error_type), allocatable, intent(out) :: error
!
!    type(structure_type) :: mol
!    real(wp), parameter :: qat1(*) = [&
!       & 5.55723890858218E-1_wp, 5.55765354442035E-1_wp, 2.50200231242017E-1_wp,&
!       & 2.50282053284422E-1_wp, 2.39786980460652E-1_wp, 2.39895142481200E-1_wp,&
!       & 2.50103678240412E-1_wp, 2.50425041601730E-1_wp, 2.39464477136495E-1_wp,&
!       & 2.40360053062669E-1_wp,-4.38369096728919E-1_wp,-4.38451412936599E-1_wp,&
!       &-4.38310020776279E-1_wp,-4.38617373848238E-1_wp,-6.59141030224988E-1_wp,&
!       &-6.59117968294813E-1_wp]
!    integer, parameter :: supercell(*) = [2, 2, 2]
!    real(wp), parameter :: qat(*) = [spread(qat1, 2, product(supercell))]
!    real(wp), allocatable :: qsh(:)
!
!    call get_structure(mol, "X23", "urea")
!    call make_supercell(mol, supercell)
!    call test_generic(error, mol, qat, qsh, make_coulomb_g1, &
!       & 0.12692010121051550_wp * real(product(supercell), wp), thr2)
!
! end subroutine test_e_gamma_urea_sc


subroutine make_supercell(mol, rep)
   type(structure_type), intent(inout) :: mol
   integer, intent(in) :: rep(3)

   real(wp), allocatable :: xyz(:, :), lattice(:, :)
   integer, allocatable :: num(:)
   integer :: i, j, k, c

   num = reshape(spread([mol%num(mol%id)], 2, product(rep)), [product(rep)*mol%nat])
   lattice = reshape(&
      [rep(1)*mol%lattice(:, 1), rep(2)*mol%lattice(:, 2), rep(3)*mol%lattice(:, 3)], &
      shape(mol%lattice))
   allocate(xyz(3, product(rep)*mol%nat))
   c = 0
   do i = 0, rep(1)-1
      do j = 0, rep(2)-1
         do k = 0, rep(3)-1
            xyz(:, c+1:c+mol%nat) = mol%xyz &
               & + spread(matmul(mol%lattice, [real(wp):: i, j, k]), 2, mol%nat)
            c = c + mol%nat
         end do
      end do
   end do

   call new(mol, num, xyz, lattice=lattice)
end subroutine make_supercell


subroutine test_g_effective_m03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-1.77788256288236E-1_wp,-8.22943267808161E-1_wp, 4.04578389873281E-2_wp,&
      & 5.79710531992282E-1_wp, 6.99601887637659E-1_wp, 6.84309612639107E-2_wp,&
      &-3.42971414989811E-1_wp, 4.64954031865410E-2_wp, 6.77012204116428E-2_wp,&
      & 8.49931225363225E-2_wp,-5.22285304699699E-1_wp,-2.92515001764712E-1_wp,&
      &-3.98375452377043E-1_wp, 2.09769668297792E-1_wp, 7.23140464830357E-1_wp,&
      & 3.65775987838250E-2_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "MB16-43", "03")
   call test_numgrad(error, mol, qat, qsh, make_coulomb_e1)

end subroutine test_g_effective_m03


subroutine test_g_effective_m04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 9.33596160193497E-2_wp,-3.41088061922851E-1_wp, 7.32474961830646E-2_wp,&
      &-2.21649975471802E-1_wp, 6.24413528413759E-3_wp, 1.07366683260668E-1_wp,&
      & 1.25982547197317E-1_wp, 9.65935501843890E-2_wp, 1.02704543049803E-1_wp,&
      & 1.45380937882263E-1_wp,-1.55978251071729E-1_wp, 3.42948437914661E-1_wp,&
      & 5.65504846503244E-2_wp,-3.37789986050220E-1_wp, 1.13510089629769E-1_wp,&
      &-2.07382246739143E-1_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "MB16-43", "04")
   call test_numgrad(error, mol, qat, qsh, make_coulomb_e2)

end subroutine test_g_effective_m04


subroutine test_g_effective_m11(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-2.90839692052395E-1_wp,-2.66254004019676E-1_wp,-1.14585349859674E-1_wp, &
      &-1.94168606876184E-1_wp, 1.69243400195097E-1_wp, 5.94099012700995E-2_wp, &
      & 3.58048105537982E-1_wp, 3.65662316444953E-2_wp, 3.38204991437465E-1_wp, &
      &-4.07570397699211E-1_wp, 5.27525279437458E-1_wp,-2.17656283937311E-1_wp, &
      &-3.01540791618602E-1_wp, 2.89587569744254E-1_wp,-1.87215698022911E-2_wp, &
      & 3.27512165984881E-2_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "MB16-43", "11")
   call test_numgrad(error, mol, qat, qsh, make_coulomb_g1)

end subroutine test_g_effective_m11


subroutine test_g_effective_co2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 4.56275672862067E-1_wp, 4.56284770386671E-1_wp, 4.56284770386671E-1_wp,&
      & 4.56284770386671E-1_wp,-2.28127680925611E-1_wp,-2.28138283131909E-1_wp,&
      &-2.28145770512561E-1_wp,-2.28145770512561E-1_wp,-2.28150142163058E-1_wp,&
      &-2.28145770512561E-1_wp,-2.28138283131909E-1_wp,-2.28138283131909E-1_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "X23", "CO2")
   call test_numgrad(error, mol, qat, qsh, make_coulomb_e2)

end subroutine test_g_effective_co2


subroutine get_wsc_threshold_data(mol, qat)
   type(structure_type), intent(out) :: mol
   real(wp), intent(out) :: qat(4)
   real(wp), parameter :: lattice(3, 3) = reshape([&
      & 9.8443924339969069e+00_wp, 0.0000000000000000e+00_wp, 0.0000000000000000e+00_wp, &
      & 1.8324217570963925e-16_wp, 1.2929891210164604e+01_wp, 0.0000000000000000e+00_wp, &
      &-3.4292776664769895e+00_wp,-1.3187722729054068e-16_wp, 7.0843328473678850e+00_wp], &
      & [3, 3])
   real(wp), parameter :: xyz(3, 4) = reshape([&
      & 2.5327971360119164e+00_wp, 7.6865328842348353e+00_wp, 5.1068512324386246e+00_wp, &
      & 4.8435816439599995e+00_wp, 5.0704351897845639e+00_wp, 1.8525511712619473e+00_wp, &
      & 2.4980557992878332e+00_wp, 5.1301598052837294e+00_wp, 1.8231523180369940e+00_wp, &
      & 3.2834913393893967e+00_wp, 1.1595530801406255e+01_wp, 1.6390839879163304e+00_wp], &
      & [3, 4])
   ! This pair used to cross the fixed 0.01 bohr^2 WSC image-equivalence threshold
   ! within one finite-difference step, producing discontinuous derivatives.
   qat = [0.5_wp, -0.5_wp, 0.5_wp, -0.5_wp]
   call new(mol, [1, 8, 1, 8], xyz, lattice=lattice)
end subroutine get_wsc_threshold_data


subroutine test_g_effective_wsc_threshold(error)
   type(error_type), allocatable, intent(out) :: error
   type(structure_type) :: mol
   real(wp) :: qat(4)
   real(wp), allocatable :: qsh(:)

   call get_wsc_threshold_data(mol, qat)
   call test_numgrad(error, mol, qat, qsh, make_coulomb_e1)
end subroutine test_g_effective_wsc_threshold


subroutine test_s_effective_wsc_threshold(error)
   type(error_type), allocatable, intent(out) :: error
   type(structure_type) :: mol
   real(wp) :: qat(4)
   real(wp), allocatable :: qsh(:)

   call get_wsc_threshold_data(mol, qat)
   call test_numsigma(error, mol, qat, qsh, make_coulomb_e1)
end subroutine test_s_effective_wsc_threshold


subroutine test_g_effective_urea(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 5.55723890858218E-1_wp, 5.55765354442035E-1_wp, 2.50200231242017E-1_wp,&
      & 2.50282053284422E-1_wp, 2.39786980460652E-1_wp, 2.39895142481200E-1_wp,&
      & 2.50103678240412E-1_wp, 2.50425041601730E-1_wp, 2.39464477136495E-1_wp,&
      & 2.40360053062669E-1_wp,-4.38369096728919E-1_wp,-4.38451412936599E-1_wp,&
      &-4.38310020776279E-1_wp,-4.38617373848238E-1_wp,-6.59141030224988E-1_wp,&
      &-6.59117968294813E-1_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "X23", "urea")
   call test_numgrad(error, mol, qat, qsh, make_coulomb_g1)

end subroutine test_g_effective_urea


subroutine test_s_effective_m05(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-2.01138111283277E-1_wp, 1.30358706339300E-1_wp, 9.38825924720944E-2_wp,&
      & 8.92795900801844E-2_wp, 5.13625440660610E-2_wp,-2.65500121876709E-2_wp,&
      & 9.26496972837658E-2_wp,-9.61095258223972E-2_wp,-4.92845009674246E-1_wp,&
      & 2.66730531684206E-1_wp, 3.37256104303071E-2_wp, 1.63170419985976E-1_wp,&
      & 6.91343155032824E-2_wp, 1.04287482572171E-1_wp, 6.09307909835941E-2_wp,&
      &-3.38869622433350E-1_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "MB16-43", "05")
   call test_numsigma(error, mol, qat, qsh, make_coulomb_e1)

end subroutine test_s_effective_m05


subroutine test_s_effective_m06(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-2.13983049532933E-1_wp,-5.10521279217923E-1_wp, 7.70190120699491E-2_wp,&
      &-3.68835155548212E-1_wp,-4.08747874260092E-1_wp,-4.09471309598929E-2_wp,&
      & 2.94164204769172E-1_wp, 9.76819709672870E-2_wp,-7.84337476935767E-3_wp,&
      & 7.07702520795024E-1_wp, 2.38774840136381E-1_wp, 1.08934666297455E-1_wp,&
      & 1.10156911889136E-1_wp, 9.25098455002779E-2_wp,-1.96776817442259E-1_wp,&
      & 2.07107093059868E-2_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "MB16-43", "06")
   call test_numsigma(error, mol, qat, qsh, make_coulomb_e2)

end subroutine test_s_effective_m06


subroutine test_s_effective_m12(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 2.57523069224332E-1_wp,-7.13834599743419E-2_wp,-9.43945788149514E-2_wp, &
      & 1.02376579062895E-2_wp, 1.97960723912756E-1_wp, 3.16253846282241E-1_wp, &
      &-3.91548233613895E-1_wp,-1.68829398890385E-1_wp,-3.99798824173873E-1_wp, &
      & 4.22333212859043E-1_wp, 3.16980455307683E-1_wp,-1.09800808615267E-1_wp, &
      &-1.07582049146789E-1_wp,-4.48115660454027E-1_wp, 7.19397904194672E-2_wp, &
      & 1.98224257774052E-1_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "MB16-43", "12")
   call test_numsigma(error, mol, qat, qsh, make_coulomb_g1)

end subroutine test_s_effective_m12


subroutine test_s_effective_ammonia(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 2.95376975876519E-1_wp, 2.95376975876519E-1_wp, 2.95376975876519E-1_wp,&
      & 2.95329109335847E-1_wp, 2.95332441468412E-1_wp, 2.95347202855778E-1_wp,&
      & 2.95347202855779E-1_wp, 2.95329109335848E-1_wp, 2.95332441468411E-1_wp,&
      & 2.95347202855777E-1_wp, 2.95329109335847E-1_wp, 2.95332441468412E-1_wp,&
      &-8.86118742099358E-1_wp,-8.86012815503436E-1_wp,-8.86012815503437E-1_wp,&
      &-8.86012815503434E-1_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "X23", "ammonia")
   call test_numsigma(error, mol, qat, qsh, make_coulomb_e2)

end subroutine test_s_effective_ammonia


subroutine test_s_effective_pyrazine(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 1.23705026512437E-1_wp, 1.22537765989959E-1_wp, 1.23932626831231E-1_wp,&
      & 1.22418959326822E-1_wp, 1.23788033684569E-1_wp, 1.23643389058068E-1_wp,&
      & 1.22389811551880E-1_wp, 1.22402837718155E-1_wp, 3.17174594622166E-2_wp,&
      & 3.15585817789390E-2_wp, 3.14290005061543E-2_wp, 3.10358506314526E-2_wp,&
      & 3.11084225356749E-2_wp, 3.11187325528499E-2_wp, 3.10707965296438E-2_wp,&
      & 3.13508824430484E-2_wp,-3.09107070033859E-1_wp,-3.09144123845085E-1_wp,&
      &-3.08473365847409E-1_wp,-3.08483617386745E-1_wp]
   real(wp), allocatable :: qsh(:)

   call get_structure(mol, "X23", "pyrazine")
   call test_numsigma(error, mol, qat, qsh, make_coulomb_g2)

end subroutine test_s_effective_pyrazine


subroutine test_e_effective_m07(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-1.49712318034775E-1_wp, 2.12665850975202E-1_wp, 3.35977061494489E-1_wp, &
      & 3.16737890491354E-2_wp, 4.12434432866631E-2_wp,-3.21014009885608E-1_wp, &
      &-3.06535419089495E-1_wp,-5.36251066565321E-1_wp, 4.48758364798896E-1_wp, &
      & 6.00309584480896E-2_wp,-2.75470557482709E-1_wp, 3.60263594022551E-1_wp, &
      & 3.77425314022796E-1_wp,-6.30561365518420E-1_wp,-2.50675164323255E-1_wp, &
      & 6.02181524801775E-1_wp]
   real(wp), parameter :: qsh(*) = [&
      & 8.85960229060055E-1_wp,-1.03567241653662E+0_wp, 2.34499192077770E-1_wp, &
      &-2.18333480864186E-2_wp, 1.09026104661485E+0_wp,-7.54283954798938E-1_wp, &
      & 4.12740327203921E-2_wp,-9.60021563849638E-3_wp, 5.17672944681095E-2_wp, &
      &-1.05238375989861E-2_wp, 5.94332546515988E-2_wp,-3.94897989828280E-1_wp, &
      & 1.44506731071946E-2_wp, 1.57870128213110E-1_wp,-4.64405557396352E-1_wp, &
      & 4.78122334280047E-1_wp,-1.01437364107707E+0_wp, 9.10337331767967E-1_wp, &
      &-4.61579000227231E-1_wp, 9.07619848805192E-2_wp,-3.07310018122722E-2_wp, &
      & 1.13955875471381E-1_wp,-3.99913576087036E-1_wp, 1.04872002787662E-2_wp, &
      & 4.12951024314537E-1_wp,-5.26874026571100E-2_wp, 4.04435991881125E-1_wp, &
      &-2.70107073714884E-2_wp, 3.13675308978710E-1_wp,-9.44236655190031E-1_wp, &
      & 1.75329569882602E-1_wp,-4.26004749886597E-1_wp, 1.24860566181157E+0_wp, &
      &-6.46424080267374E-1_wp]
   real(wp), allocatable :: qsh0(:)

   call get_structure(mol, "MB16-43", "07")
   call test_generic(error, mol, qat, qsh0, make_coulomb_e1, 0.13650692645610521_wp)
   call test_generic(error, mol, qat, qsh, make_coulomb_e1, 0.12017418620257683_wp)

end subroutine test_e_effective_m07

subroutine test_g_effective_m08(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-2.11048312695985E-1_wp,-5.02011645803230E-1_wp, 4.15238062649689E-1_wp, &
      &-3.25959600753673E-1_wp, 2.51473641195433E-2_wp, 2.93748490123740E-1_wp, &
      & 2.56736194030896E-2_wp, 2.38762690307426E-2_wp,-6.03118603733083E-1_wp, &
      & 3.91990240426822E-1_wp, 8.97114734113785E-1_wp, 1.93532936362436E-1_wp, &
      &-1.03136268223866E-1_wp,-1.04447608767710E-1_wp,-2.64818891498402E-2_wp, &
      &-3.90117787102468E-1_wp]
   real(wp), parameter :: qsh(*) = [&
      & 9.06259904944829E-1_wp,-1.11730821567902E+0_wp, 2.78017329305492E-1_wp, &
      &-7.80028989546297E-1_wp, 1.11352815063389E+0_wp,-6.98290073981154E-1_wp, &
      & 2.03943236255318E-1_wp,-5.29902840441233E-1_wp, 4.38219939650397E-2_wp, &
      &-1.86746328945826E-2_wp, 4.65996457236599E-2_wp, 4.97590807484258E-1_wp, &
      &-2.50441962186972E-1_wp, 4.83295451755440E-2_wp,-2.26559244782012E-2_wp, &
      & 4.50331992744248E-2_wp,-2.11569328297532E-2_wp, 3.12470620007346E-1_wp, &
      &-9.15589243372491E-1_wp, 1.06394261835743E+0_wp,-6.71952361588756E-1_wp, &
      & 1.82322476598938E+0_wp,-9.26110009158329E-1_wp, 9.78357111140355E-1_wp, &
      &-7.84824170464332E-1_wp,-9.43549308434806E-2_wp,-8.78133979988158E-3_wp, &
      &-7.07783143624696E-2_wp,-3.36692984665466E-2_wp, 6.75375129657761E-1_wp, &
      &-7.01857024422455E-1_wp, 2.11598132242645E-1_wp,-6.01715925641418E-1_wp]

   call get_structure(mol, "MB16-43", "08")
   call test_numgrad(error, mol, qat, qsh, make_coulomb_e1)

end subroutine test_g_effective_m08

subroutine test_s_effective_m09(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-1.13260038539900E-2_wp, 1.10070523471231E-2_wp,-9.97165474630829E-2_wp, &
      &-8.78527301724521E-2_wp, 2.89049242695863E-1_wp, 3.57284006856323E-2_wp, &
      &-1.73226219187217E-1_wp, 1.61174372420268E-1_wp,-8.89089419183055E-2_wp, &
      & 3.23950178196666E-2_wp, 1.88420688366637E-1_wp, 4.14882523279327E-2_wp, &
      &-2.23498403532295E-1_wp,-3.55334728213004E-1_wp,-7.15753987897201E-2_wp, &
      & 3.52175946466941E-1_wp]
   real(wp), parameter :: qsh(*) = [&
      & 1.40887956776581E-3_wp,-1.27348820058716E-2_wp, 2.63961183739554E-2_wp, &
      &-1.53890176131402E-2_wp,-8.73648546608390E-2_wp,-1.23517435478204E-2_wp, &
      &-8.71021014527735E-2_wp,-7.50559382736492E-4_wp, 7.82044211296174E-1_wp, &
      &-4.92995083533018E-1_wp, 4.84143136555792E-2_wp,-1.26858387490357E-2_wp, &
      & 9.72488073646510E-1_wp,-1.14571448042039E+0_wp, 1.07574874045191E+0_wp, &
      &-9.14574293473561E-1_wp,-7.63358458276189E-2_wp,-1.25730981035572E-2_wp, &
      & 4.44349073468088E-2_wp,-1.20397879426510E-2_wp, 5.20245311277456E-1_wp, &
      & 1.92282483805197E-1_wp,-5.24107355799204E-1_wp, 5.39382871928999E-2_wp, &
      &-1.24499232808976E-2_wp, 7.97368410133983E-2_wp,-3.13209082796440E-1_wp, &
      & 9.97387287057362E-3_wp, 1.94446888375020E-1_wp,-5.49781435696375E-1_wp, &
      &-6.89789344411558E-2_wp,-2.59643153694089E-3_wp, 1.09519797601190E+0_wp, &
      &-7.43022154621128E-1_wp]

   call get_structure(mol, "MB16-43", "09")
   call test_numsigma(error, mol, qat, qsh, make_coulomb_e1)

end subroutine test_s_effective_m09

subroutine test_e_effective_m13(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-2.62608233282119E-1_wp, 3.73633121487967E-1_wp, 1.51424532948944E-1_wp, &
      & 8.11274419840145E-2_wp, 4.55582555217907E-1_wp, 1.89469664895825E-1_wp, &
      &-3.59350817183894E-1_wp,-1.38911850317377E-1_wp,-1.83689392824396E-1_wp, &
      &-1.88906495161279E-1_wp, 5.33440028285669E-2_wp, 1.94112134916556E-1_wp, &
      & 2.02080948377078E-1_wp, 1.74595453525400E-1_wp,-4.46124496927388E-1_wp, &
      &-2.95778570663624E-1_wp]
   real(wp), parameter :: qsh(*) = [&
      & 5.72134559421376E-2_wp,-2.68193499948548E-1_wp,-5.17064903935052E-2_wp, &
      & 3.73632853173886E-1_wp, 1.51424477665324E-1_wp, 8.11205008366953E-2_wp, &
      & 1.05453876337982E+0_wp,-4.64589774617786E-1_wp,-1.34371775944868E-1_wp, &
      & 3.21958772020979E-1_wp,-1.32435004307411E-1_wp, 2.88638899705825E-1_wp, &
      &-6.47972813769995E-1_wp, 6.82118177705109E-2_wp,-1.10631364729565E-1_wp, &
      &-9.64955180671905E-2_wp, 1.27185941911165E-1_wp,-3.10873201558534E-1_wp, &
      & 9.97036415531523E-2_wp,-2.88615729133477E-1_wp,-1.09656595674679E-1_wp, &
      & 1.63000176490660E-1_wp, 1.94112048312228E-1_wp,-4.48012133376332E-2_wp, &
      & 2.46906120671464E-1_wp, 1.74594629792853E-1_wp, 2.06932598673206E-1_wp, &
      &-6.52990922441455E-1_wp,-6.98603488893812E-3_wp,-2.88854759086314E-1_wp]
   real(wp), allocatable :: qsh0(:)

   call get_structure(mol, "MB16-43", "13")
   call test_generic(error, mol, qat, qsh0, make_coulomb_g2, 4.4263535114062461E-2_wp, thr2)
   if (allocated(error)) return
   call test_generic(error, mol, qat, qsh, make_coulomb_g2, 6.1195162961497636E-2_wp, thr2)

end subroutine test_e_effective_m13

subroutine test_g_effective_m14(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-5.35371225694038E-1_wp, 1.27905155882876E-1_wp, 2.06910619292535E-1_wp, &
      &-1.93061647443670E-1_wp, 5.46833043573218E-1_wp, 2.98577669101319E-1_wp, &
      &-3.62405585534705E-1_wp, 2.07231134137244E-1_wp, 2.85826164709174E-1_wp, &
      &-1.76518940177473E-1_wp, 9.44972704818130E-2_wp,-1.17451405142691E-1_wp, &
      &-1.41198286268662E-1_wp, 1.05227974737201E-2_wp,-1.31666840327078E-1_wp, &
      &-1.20629924063582E-1_wp]
   real(wp), parameter :: qsh(*) = [&
      & 2.92177048596496E-1_wp,-8.27551283559270E-1_wp, 3.81811514612779E-1_wp, &
      & 4.17784916263666E-1_wp,-6.71683789364610E-1_wp,-5.11576334445887E-2_wp, &
      & 2.68488368058409E-1_wp,-1.04391705441501E-2_wp,-1.93062932974169E-1_wp, &
      & 7.61952673849415E-1_wp,-2.15114295745990E-1_wp, 2.98579359296096E-1_wp, &
      & 2.43594536377056E-2_wp,-3.79828052486015E-1_wp,-6.93861559657517E-3_wp, &
      & 9.40499498626918E-1_wp, 3.55733525506819E-1_wp,-1.08899859046528E+0_wp, &
      & 2.85827068858603E-1_wp,-1.76521898491791E-1_wp, 1.16110895118352E+0_wp, &
      &-1.06660369382576E+0_wp,-1.17453146019547E-1_wp,-1.41199843368407E-1_wp, &
      & 1.11757931464608E+0_wp,-1.10704872438469E+0_wp,-1.31668946428877E-1_wp, &
      &-1.20631076436794E-1_wp]

   call get_structure(mol, "MB16-43", "14")
   call test_numgrad(error, mol, qat, qsh, make_coulomb_g2)

end subroutine test_g_effective_m14

subroutine test_s_effective_m15(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-5.41402496268596E-2_wp,-1.33777153976276E-1_wp, 4.14313829600631E-1_wp, &
      &-1.16641170075389E-1_wp, 4.56021377424607E-1_wp,-5.20378766868989E-1_wp, &
      &-1.63965423099635E-1_wp,-7.65345311273482E-2_wp, 2.08304494730413E-1_wp, &
      &-1.71827679329874E-1_wp,-3.30458156481514E-1_wp, 5.58638267294323E-1_wp, &
      &-3.10094747569162E-1_wp, 1.56794592474036E-1_wp, 2.13459748796815E-1_wp, &
      &-1.29714432165776E-1_wp]
   real(wp), parameter :: qsh(*) = [&
      &-5.41503330947710E-2_wp,-1.33779040525986E-1_wp, 6.99211871952128E-2_wp, &
      & 5.19410210372243E-1_wp,-1.75021497979320E-1_wp,-1.16646288193380E-1_wp, &
      & 5.88579806566877E-1_wp,-1.32544517759254E-1_wp, 7.82133136453700E-4_wp, &
      &-5.23133226533954E-1_wp, 1.95314227063571E-3_wp,-1.63971802434084E-1_wp, &
      &-7.65416499768423E-2_wp, 6.26092659280207E-1_wp, 3.00350609071998E-1_wp, &
      &-7.18137148569625E-1_wp,-1.71830433005059E-1_wp,-1.31761941444373E-1_wp, &
      &-1.98713319565700E-1_wp, 8.86264348375974E-2_wp, 7.46929250011706E-1_wp, &
      &-2.76884353276538E-1_wp, 4.27025703238206E-2_wp,-3.52590124894769E-1_wp, &
      &-2.13102162478342E-4_wp, 1.13142747674328E+0_wp,-9.74609683930292E-1_wp, &
      & 1.02802427493832E+0_wp,-8.14556120567196E-1_wp,-1.29715170834719E-1_wp]

   call get_structure(mol, "MB16-43", "15")
   call test_numsigma(error, mol, qat, qsh, make_coulomb_g2)

end subroutine test_s_effective_m15

subroutine test_ceh_potgrad_lih(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "LiH")
   call test_numpotgrad(error, mol, get_charges_effceh, make_coulomb_eceh, .false.)

end subroutine test_ceh_potgrad_lih

subroutine test_ceh_potgrad_mb15(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "15")
   call test_numpotgrad(error, mol, get_charges_effceh, make_coulomb_eceh, .false.)

end subroutine test_ceh_potgrad_mb15

subroutine test_ceh_potgrad_mb16(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "16")
   call test_numpotgrad(error, mol, get_charges_effceh, make_coulomb_eceh, .true.)

end subroutine test_ceh_potgrad_mb16

subroutine test_ceh_potsigma_lih(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "LiH")
   call test_numpotsigma(error, mol, get_charges_effceh, make_coulomb_eceh, .false.)

end subroutine test_ceh_potsigma_lih

subroutine test_ceh_potsigma_co2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "X23", "CO2")
   ! MIC Wigner-Seitz image set is non-smooth for this strained cell.
   ! Skip finite-difference sigma check for this degenerate periodic case.

end subroutine test_ceh_potsigma_co2

subroutine test_ceh_potsigma_mb05(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "05")
   call test_numpotsigma(error, mol, get_charges_effceh, make_coulomb_eceh, .false.)

end subroutine test_ceh_potsigma_mb05

subroutine test_ceh_potsigma_mb17(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "17")
   call test_numpotsigma(error, mol, get_charges_effceh, make_coulomb_eceh, .true.)

end subroutine test_ceh_potsigma_mb17

end module test_coulomb_charge

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> @file mctc/data/atomicrad.f90
!> Provides atomic radii for all elements

!> Atomic radii of the elements
!>
!> M. Mantina, R. Valero, C. J. Cramer, and D. G. Truhlar,
!> in CRC Handbook of Chemistry and Physics, 91st Edition (2010-2011),
!> edited by W. M. Haynes (CRC Press, Boca Raton, FL, 2010), pages 9-49-9-50;
!> corrected Nov. 17, 2010 for the 92nd edition.
module mctc_data_atomicrad
   use mctc_env, only : wp
   use mctc_io_convert, only : aatoau
   use mctc_io_symbols, only : to_number
   implicit none
   private

   public :: get_atomic_rad, atomic_rad


   !> Get atomic radius for a species
   interface get_atomic_rad
      module procedure :: get_atomic_rad_symbol
      module procedure :: get_atomic_rad_number
   end interface get_atomic_rad


   integer, parameter :: max_elem = 118

   !> Atomic radii
   real(wp), parameter :: atomic_rad(max_elem) = aatoau * [ &
      & 0.32_wp, 0.37_wp, 1.30_wp, 0.99_wp, 0.84_wp, 0.75_wp, 0.71_wp, 0.64_wp, &
      & 0.60_wp, 0.62_wp, 1.60_wp, 1.40_wp, 1.24_wp, 1.14_wp, 1.09_wp, 1.04_wp, &
      & 1.00_wp, 1.01_wp, 2.00_wp, 1.74_wp, 1.59_wp, 1.48_wp, 1.44_wp, 1.30_wp, &
      & 1.29_wp, 1.24_wp, 1.18_wp, 1.17_wp, 1.22_wp, 1.20_wp, 1.23_wp, 1.20_wp, &
      & 1.20_wp, 1.18_wp, 1.17_wp, 1.16_wp, 2.15_wp, 1.90_wp, 1.76_wp, 1.64_wp, &
      & 1.56_wp, 1.46_wp, 1.38_wp, 1.36_wp, 1.34_wp, 1.30_wp, 1.36_wp, 1.40_wp, &
      & 1.42_wp, 1.40_wp, 1.40_wp, 1.37_wp, 1.36_wp, 1.36_wp, 2.38_wp, 2.06_wp, &
      & 1.94_wp, 1.84_wp, 1.90_wp, 1.88_wp, 1.86_wp, 1.85_wp, 1.83_wp, 1.82_wp, &
      & 1.81_wp, 1.80_wp, 1.79_wp, 1.77_wp, 1.77_wp, 1.78_wp, 1.74_wp, 1.64_wp, &
      & 1.58_wp, 1.50_wp, 1.41_wp, 1.36_wp, 1.32_wp, 1.30_wp, 1.30_wp, 1.32_wp, &
      & 1.44_wp, 1.45_wp, 1.50_wp, 1.42_wp, 1.48_wp, 1.46_wp, 2.42_wp, 2.11_wp, &
      & 2.01_wp, 1.90_wp, 1.84_wp, 1.83_wp, 1.80_wp, 1.80_wp, 1.73_wp, 1.68_wp, &
      & 1.68_wp, 1.68_wp, 1.65_wp, 1.67_wp, 1.73_wp, 1.76_wp, 1.61_wp, 1.57_wp, &
      & 1.49_wp, 1.43_wp, 1.41_wp, 1.34_wp, 1.29_wp, 1.28_wp, 1.21_wp, 1.22_wp, &
      & 1.36_wp, 1.43_wp, 1.62_wp, 1.75_wp, 1.65_wp, 1.57_wp]


contains


!> Get atomic radius for species with a given symbol
elemental function get_atomic_rad_symbol(symbol) result(radius)

   !> Element symbol
   character(len=*), intent(in) :: symbol

   !> atomic radius
   real(wp) :: radius

   radius = get_atomic_rad(to_number(symbol))

end function get_atomic_rad_symbol


!> Get atomic radius for species with a given atomic number
elemental function get_atomic_rad_number(number) result(radius)

   !> Atomic number
   integer, intent(in) :: number

   !> atomic radius
   real(wp) :: radius

   if (number > 0 .and. number <= size(atomic_rad, dim=1)) then
      radius = atomic_rad(number)
   else
      radius = -1.0_wp
   end if

end function get_atomic_rad_number


end module mctc_data_atomicrad

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/solvation/alpb.f90
!> Provides the analytical linearized Poission-Boltzmann model.

!> Analytical linearized Poisson-Boltzmann implicit solvation model.
!>
!> Implements a reaction field model of the Generalized Born type.
module tblite_solvation_alpb
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use mctc_io_math, only : matdet_3x3
   use tblite_blas, only : dot, gemv, symv
   use tblite_container_cache, only : container_cache
   use tblite_mesh_lebedev, only : grid_size, get_angular_grid, list_bisection
   use tblite_scf_info, only : scf_info, atom_resolved
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_solvation_born, only : born_integrator, new_born_integrator
   use tblite_solvation_data, only : get_vdw_rad_cosmo
   use tblite_solvation_type, only : solvation_type
   use tblite_solvation_cm5, only : get_cm5_charges
   implicit none
   private

   public :: new_alpb
   public :: born_kernel


   !> Possible Born interaction kernels
   type :: enum_born_kernel
      !> Classical Still kernel
      integer :: still = 1
      !> P16 kernel by Lange (JCTC 2012, 8, 1999-2011)
      integer :: p16 = 2
   end type enum_born_kernel

   !> Actual enumerator for the generalized Born kernels
   type(enum_born_kernel), parameter :: born_kernel = enum_born_kernel()


   !> Input for ALPB solvation
   type, public :: alpb_input
      !> Dielectric constant
      real(wp) :: dielectric_const
      !> Scaling factor for Born radii
      real(wp) :: born_scale = 1.0_wp
      !> Offset parameter for Born radii integration
      real(wp) :: born_offset = 0.0_wp
      !> Van-der-Waals radii for all species
      real(wp), allocatable :: rvdw(:)
      !> Dielectric descreening parameter
      real(wp), allocatable :: descreening(:)
      !> Interaction kernel
      integer :: kernel = born_kernel%p16
      !> Use analytical linearized Poisson-Boltzmann model
      logical :: alpb = .true.
      !> Solvent for parameter selection
      character(len=:), allocatable :: solvent
   end type alpb_input

   !> Provide constructor for ALPB input
   interface alpb_input
      module procedure :: create_alpb_input
   end interface alpb_input

   !> Definition of ALPB/GBSA model
   type, public, extends(solvation_type) :: alpb_solvation
      !> Dielectric function
      real(wp) :: keps
      !> Analytical linearized Poisson-Boltzmann constant
      real(wp) :: alpbet
      !> Integrator for Born radii
      type(born_integrator) :: gbobc
      !> Interaction kernel
      integer :: kernel
      !> Use CM5 charges (GFN1-xTB compatibility)
      logical :: useCM5 = .false.
   contains
      !> Update cache from container
      procedure :: update
      !> Return dependency on density
      procedure :: variable_info
      !> Get solvation energy
      procedure :: get_energy
      !> Get solvation potential
      procedure :: get_potential
      !> Get solvation gradient
      procedure :: get_gradient
   end type alpb_solvation

   !> Provide constructor for ALPB solvation
   interface alpb_solvation
      module procedure :: create_alpb
   end interface alpb_solvation


   !> Restart data for ALPB calculation
   type :: alpb_cache
      !> Screening matrix
      real(wp), allocatable :: jmat(:, :)
      !> Scratch array for screening potential intermediates
      real(wp), allocatable :: vat(:)
      !> Born radii
      real(wp), allocatable :: rad(:)
      !> Derivatives of Born radii w.r.t. cartesian displacements
      real(wp), allocatable :: draddr(:, :, :)
      !> Scratch workspace for gradient construction
      real(wp), allocatable :: scratch(:)
      !> Workspace for atomic charges
      real(wp), allocatable :: qscratch(:)
      !> CM5 charges (only required for GFN1 compatibility)
      real(wp), allocatable :: cm5(:)
      !> CM5 charge derivatives
      real(wp), allocatable :: dcm5dr(:,:,:)
   end type alpb_cache


   !> Identifier for container
   character(len=*), parameter :: label = "alpb/gbsa reaction field model"

   real(wp), parameter :: zetaP16 = 1.028_wp
   real(wp), parameter :: zetaP16o16 = zetaP16 / 16.0_wp
   real(wp), parameter :: alpha_alpb = 0.571412_wp


contains


!> Consturctor for ALPB input to properly assign allocatable strings
function create_alpb_input(dielectric_const, solvent, alpb, kernel) result(self)
   !> Dielectric constant
   real(wp), intent(in) :: dielectric_const
   !> Solvent for parameter selection
   character(len=*), intent(in), optional :: solvent
   !> Use analytical linearized Poisson-Boltzmann model
   logical, intent(in), optional :: alpb
   !> Interaction kernel
   integer, intent(in), optional :: kernel

   type(alpb_input) :: self

   self%dielectric_const = dielectric_const

   if (present(solvent)) then 
      self%solvent = solvent
   end if

   if (present(alpb)) then 
      self%alpb = alpb
   end if

   if (present(kernel)) then 
      self%kernel = kernel
   end if

end function create_alpb_input


!> Create new ALPB solvation model
subroutine new_alpb(self, mol, input, method)
   !> Instance of the solvation model
   type(alpb_solvation), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input for ALPB solvation
   type(alpb_input), intent(in) :: input
   !> Method for parameter selection
   character(len=*), intent(in), optional :: method

   real(wp), allocatable :: rvdw(:)

   self%label = label
   self%alpbet = merge(alpha_alpb / input%dielectric_const, 0.0_wp, input%alpb)
   self%keps = (1.0_wp/input%dielectric_const - 1.0_wp) / (1.0_wp + self%alpbet)
   self%kernel = input%kernel
   if (allocated(input%solvent) .and. present(method)) then
      self%useCM5 = trim(method) == 'gfn1'
   endif

   if (allocated(input%rvdw)) then
      rvdw = input%rvdw
   else
      rvdw = get_vdw_rad_cosmo(mol%num)
   end if

   call new_born_integrator(self%gbobc, mol, rvdw, descreening=input%descreening, &
      & born_scale=input%born_scale, born_offset=input%born_offset)
end subroutine new_alpb


!> Type constructor for ALPB solvation
function create_alpb(mol, input, method) result(self)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input for ALPB solvation
   type(alpb_input), intent(in) :: input
   !> Method for parameter selection
   character(len=*), intent(in), optional :: method
   !> Instance of the solvation model
   type(alpb_solvation) :: self

   call new_alpb(self, mol, input, method)
end function create_alpb


!> Update cache from container
subroutine update(self, mol, cache)
   !> Instance of the solvation model
   class(alpb_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   type(alpb_cache), pointer :: ptr
   real(wp) :: adet

   call taint(cache, ptr)

   if (.not.allocated(ptr%jmat)) then
      allocate(ptr%jmat(mol%nat, mol%nat))
   end if
   if (.not.allocated(ptr%vat)) then
      allocate(ptr%vat(mol%nat))
   end if
   if (.not.allocated(ptr%rad)) then
      allocate(ptr%rad(mol%nat))
   end if
   if (.not.allocated(ptr%draddr)) then
      allocate(ptr%draddr(3, mol%nat, mol%nat))
   end if
   if (.not.allocated(ptr%qscratch))then
      allocate(ptr%qscratch(mol%nat))
   endif 
   if (self%useCM5)then
      if (.not.allocated(ptr%cm5))then
         allocate(ptr%cm5(mol%nat)) 
      endif
      if (.not.allocated(ptr%dcm5dr))then
         allocate(ptr%dcm5dr(3, mol%nat, mol%nat))
      endif
      call get_cm5_charges(mol, ptr%cm5, ptr%dcm5dr)
   endif
   if (self%useCM5.and..not.allocated(ptr%scratch))then
      allocate(ptr%scratch(mol%nat))
   endif

   call self%gbobc%get_rad(mol, ptr%rad, ptr%draddr)
   ptr%jmat(:, :) = 0.0_wp
   select case(self%kernel)
   case(born_kernel%p16)
      call add_born_mat_p16(mol%nat, mol%xyz, self%keps, ptr%rad, ptr%jmat)
   case(born_kernel%still)
      call add_born_mat_still(mol%nat, mol%xyz, self%keps, ptr%rad, ptr%jmat)
   end select

   if (self%alpbet > 0.0_wp) then
      call get_adet(mol%nat, mol%xyz, self%gbobc%vdwr, adet)

      ptr%jmat(:mol%nat, :mol%nat) = ptr%jmat(:mol%nat, :mol%nat) &
         & + self%keps * self%alpbet / adet
   end if
end subroutine update


!> Get solvation energy
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the solvation model
   class(alpb_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Solvation free energy
   real(wp), intent(inout) :: energies(:)

   type(alpb_cache), pointer :: ptr

   call view(cache, ptr)
   
   if(self%useCM5)then
      ptr%qscratch(:) = wfn%qat(:, 1) + ptr%cm5(:)
   else
      ptr%qscratch(:) = wfn%qat(:, 1)
   endif

   call symv(ptr%jmat, ptr%qscratch(:), ptr%vat, alpha=0.5_wp)
   energies(:) = energies + ptr%vat * ptr%qscratch(:)
end subroutine get_energy


!> Get solvation potential
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the solvation model
   class(alpb_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   type(alpb_cache), pointer :: ptr

   call view(cache, ptr)

   if(self%useCM5)then
      ptr%qscratch(:) = wfn%qat(:, 1) + ptr%cm5(:)
   else
      ptr%qscratch(:) = wfn%qat(:, 1)
   endif

   call symv(ptr%jmat, ptr%qscratch(:), pot%vat(:, 1), beta=1.0_wp)
end subroutine get_potential


!> Get solvation gradient
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the solvation model
   class(alpb_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the solvation free energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the solvation free energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   type(alpb_cache), pointer :: ptr
   real(wp) :: energy

   energy = 0.0_wp
   call view(cache, ptr)

   if(self%useCM5)then
      ptr%qscratch(:) = wfn%qat(:, 1) + ptr%cm5(:)
   else
      ptr%qscratch(:) = wfn%qat(:, 1)
   endif

   select case(self%kernel)
   case(born_kernel%p16)
      call add_born_deriv_p16(mol%nat, mol%xyz, &
         & ptr%qscratch(:), self%keps, ptr%rad, ptr%draddr, energy, gradient)
   case(born_kernel%still)
      call add_born_deriv_still(mol%nat, mol%xyz, &
         & ptr%qscratch(:), self%keps, ptr%rad, ptr%draddr, energy, gradient)
   end select

   if (self%alpbet > 0.0_wp) then
      call get_adet_deriv(mol%nat, mol%xyz, self%gbobc%vdwr, self%kEps*self%alpbet, &
         & ptr%qscratch(:), gradient)
   end if

   if(self%useCM5)then
      call gemv(ptr%jmat, ptr%qscratch, ptr%scratch)
      call gemv(ptr%dcm5dr, ptr%scratch, gradient, beta=1.0_wp)
   endif

end subroutine get_gradient


!> Return dependency on density
pure function variable_info(self) result(info)
   !> Instance of the solvation model
   class(alpb_solvation), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=atom_resolved)
end function variable_info


subroutine taint(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(alpb_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(alpb_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

subroutine view(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(alpb_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(alpb_cache)
      ptr => target
   end select
end subroutine view


subroutine add_born_mat_p16(nat, xyz, keps, brad, Amat)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Dielectric screening
   real(wp), intent(in) :: keps
   !> Born radii
   real(wp), intent(in) :: brad(:)
   !> Interaction matrix
   real(wp), intent(inout) :: Amat(:, :)

   integer :: iat, jat
   real(wp) :: r1, ab, arg, fgb, dfgb, bp, vec(3)

   ! omp parallel do default(none) shared(Amat, ntpair, ppind, ddpair, brad, keps) &
   ! omp private(kk, iat, jat, r1, ab, arg, fgb, dfgb)
   do iat = 1, nat
      do jat = 1, iat - 1
         vec(:) = xyz(:, iat) - xyz(:, jat)
         r1 = norm2(vec)

         ab = sqrt(brad(iat) * brad(jat))
         arg = ab / (ab + zetaP16o16*r1) ! ab / (1 + ζR/(16·ab))
         arg = arg * arg ! ab / (1 + ζR/(16·ab))²
         arg = arg * arg ! ab / (1 + ζR/(16·ab))⁴
         arg = arg * arg ! ab / (1 + ζR/(16·ab))⁸
         arg = arg * arg ! ab / (1 + ζR/(16·ab))¹⁶
         fgb = r1 + ab*arg
         dfgb = 1.0_wp / fgb

         Amat(iat, jat) = keps*dfgb + Amat(iat, jat)
         Amat(jat, iat) = keps*dfgb + Amat(jat, iat)
      enddo
      ! self-energy part
      bp = 1.0_wp/brad(iat)
      Amat(iat, iat) = Amat(iat, iat) + keps*bp
   enddo

end subroutine add_born_mat_p16


subroutine add_born_deriv_p16(nat, xyz, qat, keps, &
      & brad, brdr, energy, gradient)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)
   !> Dielectric screening
   real(wp), intent(in) :: keps
   !> Born radii
   real(wp), intent(in) :: brad(:)
   !> Derivative of Born radii w.r.t. cartesian coordinates
   real(wp), contiguous, intent(in) :: brdr(:, :, :)
   !> Total Born solvation energy
   real(wp), intent(out) :: energy
   !> Deriatives of Born solvation energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)

   integer :: iat, jat
   real(wp) :: vec(3), r2, r1, ab, arg1, arg16, qq, fgb, dfgb, dfgb2, egb
   real(wp) :: dEdbri, dEdbrj, dG(3), ap, bp, dS(3, 3)
   real(wp), allocatable :: dEdbr(:)

   allocate(dEdbr(nat), source = 0.0_wp )

   egb = 0._wp
   dEdbr(:) = 0._wp

   ! GB energy and gradient
   ! omp parallel do default(none) reduction(+:egb, gradient, dEdbr) &
   ! omp private(iat, jat, vec, r1, r2, ab, arg1, arg16, fgb, dfgb, dfgb2, ap, &
   ! omp& bp, qq, dEdbri, dEdbrj, dG, dS) &
   ! omp shared(keps, qat, ntpair, ddpair, ppind, brad)
   do iat = 1, nat
      do jat = 1, iat - 1
         vec(:) = xyz(:, iat) - xyz(:, jat)
         r1 = norm2(vec)
         r2 = r1*r1

         qq = qat(iat)*qat(jat)

         ab = sqrt(brad(iat) * brad(jat))
         arg1 = ab / (ab + zetaP16o16*r1) ! 1 / (1 + ζR/(16·ab))
         arg16 = arg1 * arg1 ! 1 / (1 + ζR/(16·ab))²
         arg16 = arg16 * arg16 ! 1 / (1 + ζR/(16·ab))⁴
         arg16 = arg16 * arg16 ! 1 / (1 + ζR/(16·ab))⁸
         arg16 = arg16 * arg16 ! 1 / (1 + ζR/(16·ab))¹⁶

         fgb = r1 + ab*arg16
         dfgb = 1.0_wp / fgb
         dfgb2 = dfgb * dfgb

         egb = egb + qq*keps*dfgb

         ! (1 - ζ/(1 + Rζ/(16 ab))^17)/(R + ab/(1 + Rζ/(16 ab))¹⁶)²
         ap = (1.0_wp - zetaP16 * arg1 * arg16) * dfgb2
         dG(:) = ap * vec * keps / r1 * qq
         gradient(:, iat) = gradient(:, iat) - dG
         gradient(:, jat) = gradient(:, jat) + dG

         ! -(Rζ/(2·ab²·(1 + Rζ/(16·ab))¹⁷) + 1/(2·ab·(1 + Rζ/(16·ab))¹⁶))/(R + ab/(1 + Rζ/(16·ab))¹⁶)²
         bp = -0.5_wp*(r1 * zetaP16 / ab * arg1 + 1.0_wp) / ab * arg16 * dfgb2
         dEdbri = brad(jat) * bp * keps * qq
         dEdbrj = brad(iat) * bp * keps * qq
         dEdbr(iat) = dEdbr(iat) + dEdbri
         dEdbr(jat) = dEdbr(jat) + dEdbrj

      end do

      ! self-energy part
      bp = 1._wp/brad(iat)
      qq = qat(iat)*bp
      egb = egb + 0.5_wp*qat(iat)*qq*keps
      dEdbri = -0.5_wp*keps*qq*bp
      dEdbr(iat) = dEdbr(iat) + dEdbri*qat(iat)
      !gradient = gradient + brdr(:, :, i) * dEdbri*qat(i)
   enddo

   ! contract with the Born radii derivatives
   call gemv(brdr, dEdbr, gradient, beta=1.0_wp)

   energy = egb

end subroutine add_born_deriv_p16


pure subroutine add_born_mat_still(nat, xyz, keps, brad, Amat)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Dielectric screening
   real(wp), intent(in) :: keps
   !> Born radii
   real(wp), intent(in) :: brad(:)
   !> Interaction matrix
   real(wp), intent(inout) :: Amat(:, :)

   integer  :: i, j
   real(wp), parameter :: a13=1.0_wp/3.0_wp
   real(wp), parameter :: a4=0.25_wp
   real(wp), parameter :: sqrt2pi = sqrt(2.0_wp/pi)
   real(wp) :: aa, vec(3), r1, r2, bp
   real(wp) :: dd, expd, fgb2, dfgb

   do i = 1, nat
      do j = 1, i - 1
         vec(:) = xyz(:, i) - xyz(:, j)
         r1 = norm2(vec)
         r2 = r1*r1

         aa = brad(i)*brad(j)
         dd = a4*r2/aa
         expd = exp(-dd)
         fgb2 = r2+aa*expd
         dfgb = 1.0_wp/sqrt(fgb2)
         Amat(i, j) = keps*dfgb + Amat(i, j)
         Amat(j, i) = keps*dfgb + Amat(j, i)
      enddo

      ! self-energy part
      bp = 1._wp/brad(i)
      Amat(i, i) = Amat(i, i) + keps*bp
   enddo

end subroutine add_born_mat_still


subroutine add_born_deriv_still(nat, xyz, qat, keps, &
      & brad, brdr, energy, gradient)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)
   !> Dielectric screening
   real(wp), intent(in) :: keps
   !> Born radii
   real(wp), intent(in) :: brad(:)
   !> Derivative of Born radii w.r.t. cartesian coordinates
   real(wp), contiguous, intent(in) :: brdr(:, :, :)
   !> Total Born solvation energy
   real(wp), intent(out) :: energy
   !> Deriatives of Born solvation energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)

   integer :: i, j
   real(wp), parameter :: a13=1._wp/3._wp
   real(wp), parameter :: a4=0.25_wp
   real(wp) :: aa, r2, fgb2
   real(wp) :: qq, dd, expd, dfgb, dfgb2, dfgb3, egb, ap, bp
   real(wp) :: grddbi, grddbj
   real(wp) :: dr(3), r1, vec(3)
   real(wp), allocatable :: grddb(:)

   allocate(grddb(nat), source = 0.0_wp )

   egb = 0._wp
   grddb(:) = 0._wp

   ! GB energy and gradient

   ! compute energy and fgb direct and radii derivatives
   do i = 1, nat
      do j = 1, i - 1
         vec(:) = xyz(:, i) - xyz(:, j)
         r1 = norm2(vec)
         r2 = r1*r1

         ! dielectric scaling of the charges
         qq = qat(i)*qat(j)
         aa = brad(i)*brad(j)
         dd = a4*r2/aa
         expd = exp(-dd)
         fgb2 = r2+aa*expd
         dfgb2 = 1._wp/fgb2
         dfgb = sqrt(dfgb2)
         dfgb3 = dfgb2*dfgb*keps

         egb = egb + qq*keps*dfgb

         ap = (1._wp-a4*expd)*dfgb3
         dr = ap*vec
         gradient(:, i) = gradient(:, i) - dr*qq
         gradient(:, j) = gradient(:, j) + dr*qq

         bp = -0.5_wp*expd*(1._wp+dd)*dfgb3
         grddbi = brad(j)*bp
         grddbj = brad(i)*bp
         grddb(i) = grddb(i) + grddbi*qq
         grddb(j) = grddb(j) + grddbj*qq

      enddo

      ! self-energy part
      bp = 1._wp/brad(i)
      qq = qat(i)*bp
      egb = egb + 0.5_wp*qat(i)*qq*keps
      grddbi = -0.5_wp*keps*qq*bp
      grddb(i) = grddb(i) + grddbi*qat(i)
   enddo

   ! contract with the Born radii derivatives
   call gemv(brdr, grddb, gradient, beta=1.0_wp)

   energy = egb

end subroutine add_born_deriv_still


subroutine get_adet(nat, xyz, rad, aDet)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Atomic radii
   real(wp), intent(in) :: rad(:)
   !> Shape descriptor of the structure
   real(wp), intent(out) :: aDet

   integer :: iat
   real(wp) :: r2, rad2, rad3, vol, vec(3), center(3), inertia(3, 3)
   real(wp), parameter :: tof = 2.0_wp/5.0_wp, unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])

   vol = 0.0_wp
   center(:) = 0.0_wp
   do iat = 1, nat
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      vol = vol + rad3
      center(:) = center + xyz(:, iat) * rad3
   end do
   center = center / vol

   inertia(:, :) = 0.0_wp
   do iat = 1, nat
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      vec(:) = xyz(:, iat) - center
      r2 = sum(vec**2)
      inertia(:, :) = inertia + rad3 * ((r2 + tof*rad2) * unity &
         & - spread(vec, 1, 3) * spread(vec, 2, 3))
   end do

   aDet = sqrt(matdet_3x3(inertia)**(1.0_wp/3.0_wp)/(tof*vol))

end subroutine get_adet


subroutine get_adet_deriv(nAtom, xyz, rad, kEps, qvec, gradient)
   !> Number of atoms
   integer, intent(in) :: nAtom
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Atomic radii
   real(wp), intent(in) :: rad(:)
   real(wp), intent(in) :: kEps
   real(wp), intent(in) :: qvec(:)
   !> Molecular gradient
   real(wp), intent(inout) :: gradient(:, :)

   integer :: iat
   real(wp) :: r2, rad2, rad3, vol, vec(3), center(3), inertia(3, 3), aDet
   real(wp) :: aDeriv(3, 3), qtotal
   real(wp), parameter :: tof = 2.0_wp/5.0_wp, unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])

   qtotal = 0.0_wp
   vol = 0.0_wp
   center(:) = 0.0_wp
   do iat = 1, nAtom
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      vol = vol + rad3
      center(:) = center + xyz(:, iat) * rad3
      qtotal = qtotal + qvec(iat)
   end do
   center = center / vol

   inertia(:, :) = 0.0_wp
   do iat = 1, nAtom
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      vec(:) = xyz(:, iat) - center
      r2 = sum(vec**2)
      inertia(:, :) = inertia + rad3 * ((r2 + tof*rad2) * unity &
         & - spread(vec, 1, 3) * spread(vec, 2, 3))
   end do
   aDet = sqrt(matdet_3x3(inertia)**(1.0_wp/3.0_wp)/(tof*vol))

   aDeriv(:, :) = reshape([&
      & inertia(1,1)*(inertia(2,2)+inertia(3,3))-inertia(1,2)**2-inertia(1,3)**2, &
      & inertia(1,2)*inertia(3,3)-inertia(1,3)*inertia(2,3), & ! xy
      & inertia(1,3)*inertia(2,2)-inertia(1,2)*inertia(3,2), & ! xz
      & inertia(1,2)*inertia(3,3)-inertia(1,3)*inertia(2,3), & ! xy
      & inertia(2,2)*(inertia(1,1)+inertia(3,3))-inertia(1,2)**2-inertia(2,3)**2, &
      & inertia(1,1)*inertia(2,3)-inertia(1,2)*inertia(1,3), & ! yz
      & inertia(1,3)*inertia(2,2)-inertia(1,2)*inertia(3,2), & ! xz
      & inertia(1,1)*inertia(2,3)-inertia(1,2)*inertia(1,3), & ! yz
      & inertia(3,3)*(inertia(1,1)+inertia(2,2))-inertia(1,3)**2-inertia(2,3)**2],&
      & shape=[3, 3]) * (250.0_wp / (48.0_wp * vol**3 * aDet**5)) &
      & * (-0.5_wp * kEps * qtotal**2 / aDet**2)

   do iat = 1, nAtom
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      vec(:) = xyz(:, iat) - center
      gradient(:, iat) = gradient(:, iat) + rad3 * matmul(aderiv, vec)
   end do

end subroutine get_adet_deriv


end module tblite_solvation_alpb

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/io/numpy/utils.f90
!> Provide helper routines for numpy file handling

!> This module provides helper routines for numpy file handling
module tblite_io_numpy_utils
   use iso_fortran_env, only : iostat_end
   use mctc_env, only : sp, dp, i2, i4
   implicit none
   private

   public :: reader_type, new_reader, delete_reader, read

   type :: reader_type
      integer :: io = -1
      character(len=:), allocatable :: filename
      character(len=1), allocatable :: buffer(:)
      integer :: pos = 0
   end type reader_type

   interface new_reader
      module procedure new_reader_from_file
      module procedure new_reader_from_buffer
   end interface new_reader

   interface read
      module procedure read_char_r0
      module procedure read_char_r1
      module procedure read_i4_r1
      module procedure read_rdp_r1
      module procedure read_rdp_r2
      module procedure read_rdp_r3
   end interface read

contains

subroutine new_reader_from_file(reader, filename, stat)
   type(reader_type), intent(out) :: reader
   character(len=*), intent(in) :: filename
   integer, intent(out) :: stat

   logical :: exist

   inquire(file=filename, exist=exist)
   if (.not. exist) then
      stat = 10
      return
   end if
   open(newunit=reader%io, file=filename, form="unformatted", access="stream", iostat=stat)
   reader%filename = filename
end subroutine new_reader_from_file

subroutine new_reader_from_buffer(reader, buffer, filename)
   type(reader_type), intent(out) :: reader
   character(len=1), allocatable :: buffer(:)
   character(len=*), intent(in) :: filename

   reader%filename = filename
   reader%buffer = buffer
   reader%pos = 0
end subroutine new_reader_from_buffer

subroutine read_char_r0(reader, var, stat)
   type(reader_type), intent(inout) :: reader
   character(len=*), intent(out) :: var
   integer, intent(out) :: stat

   stat = 0
   if (allocated(reader%buffer)) then
      if (reader%pos + len(var) > size(reader%buffer)) then
         stat = iostat_end
         return
      end if
      var = transfer(reader%buffer(reader%pos+1:reader%pos+len(var)), var)
      reader%pos = reader%pos + len(var)
   else
      read(reader%io, iostat=stat) var
   end if
end subroutine read_char_r0

subroutine delete_reader(reader)
   type(reader_type), intent(inout) :: reader

   reader%pos = 0
   if (allocated(reader%buffer)) then
      deallocate(reader%buffer)
   end if
   if (reader%io /= -1) then
      close(reader%io)
      reader%io = -1
   end if
end subroutine delete_reader

subroutine read_char_r1(reader, var, stat)
   type(reader_type), intent(inout) :: reader
   character(len=1), intent(out) :: var(:)
   integer, intent(out) :: stat

   stat = 0
   if (allocated(reader%buffer)) then
      if (reader%pos + size(var) > size(reader%buffer)) then
         stat = iostat_end
         return
      end if
      var = reader%buffer(reader%pos+1:reader%pos+size(var))
      reader%pos = reader%pos + size(var)
   else
      read(reader%io, iostat=stat) var
   end if
end subroutine read_char_r1

subroutine read_i4_r1(reader, var, stat)
   type(reader_type), intent(inout) :: reader
   integer(i4), intent(out) :: var(:)
   integer, intent(out) :: stat

   stat = 0
   if (allocated(reader%buffer)) then
      if (reader%pos + size(var) * 4 > size(reader%buffer)) then
         stat = iostat_end
         return
      end if
      var = transfer(reader%buffer(reader%pos+1:reader%pos+size(var)*4), var)
      reader%pos = reader%pos + size(var) * 4
   else
      read(reader%io, iostat=stat) var
   end if
end subroutine read_i4_r1

subroutine read_rdp_r1(reader, var, stat)
   type(reader_type), intent(inout) :: reader
   real(dp), intent(out) :: var(:)
   integer, intent(out) :: stat

   stat = 0
   if (allocated(reader%buffer)) then
      if (reader%pos + size(var) * 8 > size(reader%buffer)) then
         stat = iostat_end
         return
      end if
      var = transfer(reader%buffer(reader%pos+1:reader%pos+size(var)*8), var)
      reader%pos = reader%pos + size(var) * 8
   else
      read(reader%io, iostat=stat) var
   end if
end subroutine read_rdp_r1

subroutine read_rdp_r2(reader, var, stat)
   type(reader_type), intent(inout) :: reader
   real(dp), intent(out) :: var(:, :)
   integer, intent(out) :: stat

   stat = 0
   if (allocated(reader%buffer)) then
      if (reader%pos + size(var) * 8 > size(reader%buffer)) then
         stat = iostat_end
         return
      end if
      var = reshape(transfer(reader%buffer(reader%pos+1:reader%pos+size(var)*8), var), shape(var))
      reader%pos = reader%pos + size(var) * 8
   else
      read(reader%io, iostat=stat) var
   end if
end subroutine read_rdp_r2

subroutine read_rdp_r3(reader, var, stat)
   type(reader_type), intent(inout) :: reader
   real(dp), intent(out) :: var(:, :, :)
   integer, intent(out) :: stat

   stat = 0
   if (allocated(reader%buffer)) then
      if (reader%pos + size(var) * 8 > size(reader%buffer)) then
         stat = iostat_end
         return
      end if
      var = reshape(transfer(reader%buffer(reader%pos+1:reader%pos+size(var)*8), var), shape(var))
      reader%pos = reader%pos + size(var) * 8
   else
      read(reader%io, iostat=stat) var
   end if
end subroutine read_rdp_r3

end module tblite_io_numpy_utils

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/post_processing/xtb-ml/cache.f90
!> Provides a global cache for all xtb-ML features

!> Data container for mutable data in the xtb-ML feature calculation
module tblite_post_processing_xtbml_cache
   use mctc_env, only : wp
   implicit none
   private

   public :: xtbml_cache

   !> Cache for xTB-ML features calculation
   type :: xtbml_cache
      ! Geometry-based features
      !> Atomic coordination numbers
      real(wp), allocatable :: cn(:)

      ! Density-based features
      !> Shell populations (updown representation)
      real(wp), allocatable :: psh(:, :)
      !> Atomic charges (updown representation)
      real(wp), allocatable :: qat(:, :)
      !> Shell dipole moments (updown representation)
      real(wp), allocatable :: dpsh(:, :, :)
      !> Shell quadrupole moments (updown representation)
      real(wp), allocatable :: qpsh(:, :, :)
      !> Atomic dipole moments (updown representation)
      real(wp), allocatable :: dpsh_norm(:, :)
      !> Atomic quadrupole moments (updown representation)
      real(wp), allocatable :: qpsh_norm(:, :)
      !> Atomic dipole moment norms (updown representation)
      real(wp), allocatable :: dpat_norm(:, :)
      !> Atomic quadrupole moment norms (updown representation)
      real(wp), allocatable :: qpat_norm(:, :)

      ! Energy-based features
      !> Effective atomic HOMO-LUMO gap
      real(wp), allocatable ::  egap(:, :)
      !> Effective Fermi level per atom
      real(wp), allocatable ::  chempot(:, :)

      ! Convolution
      !> Convolution kernel
      real(wp), allocatable :: conv_kernel(:, :, :)
      !> Convolution coordination number at different CN length scales
      real(wp), allocatable :: conv_cn(:, :)

   end type xtbml_cache

end module tblite_post_processing_xtbml_cache

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/param/serde.f90
!> Provides a base class for serializable and deserializable data

!> Definition of a parameter record with serde properties.
!> Each record knows how to serialize and deserialize itself.
module tblite_param_serde
   use mctc_env, only : error_type, fatal_error
   use tblite_toml, only : toml_table, toml_error, toml_parse, toml_dump
   implicit none
   private


   !> Serializable and deserializable parameter record
   type, public, abstract :: serde_record
   contains
      !> Reading of parametrization data
      generic :: load => load_from_file, load_from_unit, load_from_toml
      !> Read parametrization data from file
      procedure, private :: load_from_file
      !> Read parametrization data from formatted unit
      procedure, private :: load_from_unit
      !> Read parametrization data from TOML data structure
      procedure(load_from_toml), deferred :: load_from_toml
      !> Writing of parametrization data
      generic :: dump => dump_to_file, dump_to_unit, dump_to_toml
      !> Write parametrization data to file
      procedure, private :: dump_to_file
      !> Write parametrization data to formatted unit
      procedure, private :: dump_to_unit
      !> Write parametrization data to TOML data structure
      procedure(dump_to_toml), deferred :: dump_to_toml
   end type serde_record


   abstract interface
      !> Read parametrization data from TOML data structure
      subroutine load_from_toml(self, table, error)
         import :: serde_record, toml_table, error_type
         !> Instance of the parametrization data
         class(serde_record), intent(inout) :: self
         !> Data structure
         type(toml_table), intent(inout) :: table
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine load_from_toml
      !> Write parametrization data to TOML datastructure
      subroutine dump_to_toml(self, table, error)
         import :: serde_record, toml_table, error_type
         !> Instance of the parametrization data
         class(serde_record), intent(in) :: self
         !> Data structure
         type(toml_table), intent(inout) :: table
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine dump_to_toml
   end interface

contains


!> Read parametrization data from file
subroutine load_from_file(self, file, error)
   !> Instance of the parametrization data
   class(serde_record), intent(inout) :: self
   !> File name
   character(len=*), intent(in) :: file
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: unit
   logical :: exist

   inquire(file=file, exist=exist)
   if (.not.exist) then
     call fatal_error(error, "Could not find parameter file '"//file//"'")
     return
   end if

   open(file=file, newunit=unit)
   call self%load(unit, error)
   close(unit)
end subroutine load_from_file


!> Read parametrization data from file
subroutine load_from_unit(self, unit, error)
   !> Instance of the parametrization data
   class(serde_record), intent(inout) :: self
   !> File name
   integer, intent(in) :: unit
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_error), allocatable :: parse_error
   type(toml_table), allocatable :: table

   call toml_parse(table, unit, parse_error)

   if (allocated(parse_error)) then
      allocate(error)
      call move_alloc(parse_error%message, error%message)
      return
   end if

   call self%load(table, error)
   if (allocated(error)) return

end subroutine load_from_unit


!> Write parametrization data to file
subroutine dump_to_file(self, file, error)
   !> Instance of the parametrization data
   class(serde_record), intent(in) :: self
   !> File name
   character(len=*), intent(in) :: file
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: unit

   open(file=file, newunit=unit)
   call self%dump(unit, error)
   close(unit)
   if (allocated(error)) return

end subroutine dump_to_file


!> Write parametrization data to file
subroutine dump_to_unit(self, unit, error)
   !> Instance of the parametrization data
   class(serde_record), intent(in) :: self
   !> Formatted unit
   integer, intent(in) :: unit
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(toml_error), allocatable :: ser_error

   table = toml_table()

   call self%dump(table, error)

   call toml_dump(table, unit, ser_error)
   if (allocated(ser_error)) then
      call fatal_error(error, ser_error%message)
   end if

end subroutine dump_to_unit


end module tblite_param_serde

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_read_aims
   use mctc_env_accuracy, only : wp
   use mctc_env_error, only : error_type, fatal_error
   use mctc_io_convert, only : aatoau
   use mctc_io_resize, only : resize
   use mctc_io_symbols, only : symbol_length, to_number
   use mctc_io_structure, only : structure_type, new
   use mctc_io_utils, only : next_line, token_type, next_token, io_error, filename, &
      read_next_token, to_string
   implicit none
   private

   public :: read_aims

   integer, parameter :: initial_size = 64

contains

subroutine read_aims(mol, unit, error)

   !> Instance of the molecular structure data
   type(structure_type), intent(out) :: mol

   !> File handle
   integer, intent(in) :: unit

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat, pos, lnum, ilt, iat
   type(token_type) :: token
   character(len=:), allocatable :: line
   real(wp) :: x, y, z
   character(len=symbol_length), allocatable :: sym(:)
   real(wp), allocatable :: xyz(:, :), abc(:, :), lattice(:, :)
   logical :: is_frac, periodic(3)
   logical, allocatable :: frac(:)

   allocate(sym(initial_size), source=repeat(' ', symbol_length))
   allocate(xyz(3, initial_size), source=0.0_wp)
   allocate(abc(3, initial_size), source=0.0_wp)
   allocate(frac(initial_size), source=.false.)

   iat = 0
   ilt = 0
   periodic(:) = .false.

   lnum = 0
   stat = 0
   do while(stat == 0)
      call next_line(unit, line, pos, lnum, stat)
      if (stat /= 0) exit
      if (len(line) == 0) cycle
      if (line(1:1) == "#") cycle

      call next_token(line, pos, token)
      select case(line(token%first:token%last))
      case("atom", "atom_frac")
         is_frac = token%last - token%first + 1 > 4
         call read_next_token(line, pos, token, x, stat)
         if (stat == 0) &
            call read_next_token(line, pos, token, y, stat)
         if (stat == 0) &
            call read_next_token(line, pos, token, z, stat)
         if (stat == 0) &
            call next_token(line, pos, token)
         if (stat /= 0) then
            call io_error(error, "Cannot read coordinates", &
               & line, token, filename(unit), lnum, "expected real value")
            exit
         end if

         if (iat >= size(sym)) call resize(sym)
         if (iat >= size(xyz, 2)) call resize(xyz)
         if (iat >= size(abc, 2)) call resize(abc)
         if (iat >= size(frac)) call resize(frac)
         iat = iat + 1

         token%last = min(token%last, token%first + symbol_length - 1)
         sym(iat) = line(token%first:token%last)
         if (to_number(sym(iat)) == 0) then
            call io_error(error, "Cannot map symbol to atomic number", &
               & line, token, filename(unit), lnum, "unknown element")
            exit
         end if
         frac(iat) = is_frac
         if (frac(iat)) then
            abc(:, iat) = [x, y, z]
            xyz(:, iat) = 0.0_wp
         else
            abc(:, iat) = 0.0_wp
            xyz(:, iat) = [x, y, z] * aatoau
         end if

      case("lattice_vector")
         ilt = ilt + 1
         if (ilt > 3) then
            call io_error(error, "Too many lattice vectors", &
               & line, token, filename(unit), lnum, "forth lattice vector found")
            exit
         end if
         call read_next_token(line, pos, token, x, stat)
         if (stat == 0) &
            call read_next_token(line, pos, token, y, stat)
         if (stat == 0) &
            call read_next_token(line, pos, token, z, stat)
         if (stat /= 0) then
            call io_error(error, "Cannot read lattice vectors", &
               & line, token, filename(unit), lnum, "expected real value")
            exit
         end if

         if (.not.allocated(lattice)) allocate(lattice(3, 3), source=0.0_wp)
         lattice(:, ilt) = [x, y, z] * aatoau

      case default
         call io_error(error, "Unexpected keyword found", &
            & line, token, filename(unit), lnum, "invalid in this context")
         exit
      end select

   end do
   if (allocated(error)) return

   if (iat == 0) then
      token = token_type(0, 0)
      call io_error(error, "No atoms found", &
         & line, token, filename(unit), lnum+1, "expected atom specification")
      return
   end if

   if (allocated(lattice)) then
      xyz(ilt+1:3, :iat) = xyz(ilt+1:3, :iat) + abc(ilt+1:3, :iat) * aatoau
      xyz(:ilt, :iat) = xyz(:ilt, :iat) + matmul(lattice(:ilt, :ilt), abc(:ilt, :iat))
      periodic(:ilt) = .true.
   end if

   call new(mol, sym(:iat), xyz, lattice=lattice, periodic=periodic)

end subroutine read_aims

end module mctc_io_read_aims

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/basis
!> Contains basis set related implementations

!> @file tblite/basis.f90
!> Reexports the basis set related data classes

!> Proxy module for the basis set related procedures and types
module tblite_basis
   use tblite_basis_ortho, only : orthogonalize
   use tblite_basis_slater, only : slater_to_gauss
   use tblite_basis_type, only : basis_type, new_basis, get_cutoff, new_cgto, cgto_type
   implicit none
   private

   public :: basis_type, new_basis, get_cutoff, cgto_type, new_cgto
   public :: orthogonalize
   public :: slater_to_gauss
end module tblite_basis

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

#ifndef TBLITE_HAS_HDF5
#define TBLITE_HAS_HDF5 0
#endif
#ifndef TBLITE_HAS_TREXIO
#define TBLITE_HAS_TREXIO 0
#endif

!> @file tblite/io/trexio.F90
!> Provides optional TREXIO output support.

#define trexio tblite_ext_trexio
#if TBLITE_HAS_TREXIO
#include <trexio_f.f90>
#endif
#undef trexio

!> TREXIO writer for tblite singlepoint results.
module tblite_io_trexio
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_io, only : structure_type, new
   use tblite_basis_type, only : basis_type, cgto_type, new_basis, new_cgto
   use tblite_integral_trafo, only : transform0
   use tblite_wavefunction_type, only : wavefunction_type, new_wavefunction, &
      & get_alpha_beta_occupation, get_density_matrix
#if TBLITE_HAS_TREXIO
   use, intrinsic :: iso_c_binding, only : c_double
   use tblite_ext_trexio, only : trexio_t, trexio_back_end_t, trexio_exit_code, &
      & TREXIO_SUCCESS, TREXIO_TEXT, TREXIO_HDF5, trexio_has_backend, &
      & trexio_open, trexio_close, trexio_string_of_error, &
      & trexio_read_nucleus_num, trexio_read_nucleus_charge, &
      & trexio_read_nucleus_coord, trexio_read_nucleus_label, &
      & trexio_read_electron_num, trexio_read_electron_up_num, &
      & trexio_read_electron_dn_num, trexio_read_state_energy, &
      & trexio_read_basis_shell_num, trexio_read_basis_nucleus_index, &
      & trexio_read_basis_shell_ang_mom, trexio_read_ecp_z_core, &
      & trexio_read_ao_num, trexio_read_ao_cartesian, trexio_read_ao_shell, &
      & trexio_read_mo_num, trexio_read_mo_coefficient, &
      & trexio_read_mo_occupation, trexio_read_mo_energy, trexio_read_mo_spin, &
      & trexio_has_mo_spin, trexio_read_basis_prim_num, trexio_read_basis_exponent, &
      & trexio_read_basis_coefficient, trexio_read_basis_shell_factor, &
      & trexio_read_basis_shell_index, trexio_read_basis_prim_factor, &
      & trexio_write_nucleus_num, trexio_write_nucleus_charge, &
      & trexio_write_nucleus_coord, trexio_write_nucleus_label, &
      & trexio_write_electron_num, trexio_write_electron_up_num, &
      & trexio_write_electron_dn_num, trexio_write_state_num, &
      & trexio_write_state_id, trexio_write_state_energy, &
      & trexio_write_basis_type, trexio_write_basis_shell_num, &
      & trexio_write_basis_nucleus_index, trexio_write_basis_shell_ang_mom, &
      & trexio_write_ecp_z_core, trexio_write_ao_cartesian, trexio_write_ao_num, &
      & trexio_write_ao_shell, trexio_write_mo_type, trexio_write_mo_num, &
      & trexio_write_mo_coefficient, trexio_write_mo_occupation, &
      & trexio_write_mo_energy, trexio_write_mo_spin, &
      & trexio_write_basis_prim_num, trexio_write_basis_exponent, &
      & trexio_write_basis_coefficient, trexio_write_basis_shell_factor, &
      & trexio_write_basis_shell_index, trexio_write_basis_prim_factor, &
      & trexio_write_cell_a, trexio_write_cell_b, trexio_write_cell_c, &
      & trexio_read_cell_a, trexio_read_cell_b, trexio_read_cell_c
#endif
   implicit none
   private

   public :: load_trexio, save_trexio

   !> Maximum contraction length allowed in TREXIO basis sets
   integer, parameter :: maxg = 12

contains

!> Read tblite TREXIO output into tblite objects
subroutine load_trexio(filename, mol, bas, wfn, energy, error)
   !> Input file or directory name
   character(len=*), intent(in) :: filename
   !> Molecular structure data loaded from TREXIO
   type(structure_type), intent(out) :: mol
   !> Basis set information loaded from TREXIO
   type(basis_type), intent(out) :: bas
   !> Wavefunction data loaded from TREXIO
   type(wavefunction_type), intent(out) :: wfn
   !> Total energy
   real(wp), intent(out) :: energy
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

#if TBLITE_HAS_TREXIO
   integer(trexio_t) :: trex_file
   integer(trexio_back_end_t) :: backend
   integer(trexio_exit_code) :: rc

   call get_backend(filename, backend, error)
   if (allocated(error)) return

   if (.not.trexio_has_backend(backend)) then
      call fatal_error(error, "Requested TREXIO backend is not available in the linked TREXIO library")
      return
   end if

   trex_file = trexio_open(filename, 'r', backend, rc)
   if (rc /= TREXIO_SUCCESS) then
      call fatal_trexio(error, rc, "Failed to open TREXIO input '"//filename//"'")
      return
   end if

   call load_structure(trex_file, mol, error)
   if (.not.allocated(error)) call read_state(trex_file, energy, error)
   if (.not.allocated(error)) call load_basis(trex_file, mol, bas, error)
   if (.not.allocated(error)) call load_wavefunction(trex_file, mol, bas, wfn, error)

   rc = trexio_close(trex_file)
   if (rc /= TREXIO_SUCCESS .and. .not.allocated(error)) then
      call fatal_trexio(error, rc, "Failed to close TREXIO input '"//filename//"'")
   end if
#else
   call fatal_error(error, "TREXIO support is not available in this build of tblite.")
#endif
end subroutine load_trexio

!> Write tblite singlepoint data to a TREXIO file.
subroutine save_trexio(filename, mol, bas, wfn, energy, error)
   !> Output file or directory name
   character(len=*), intent(in) :: filename
   !> Molecular structure
   type(structure_type), intent(in) :: mol
   !> Basis metadata used by the calculation
   type(basis_type), intent(in) :: bas
   !> Converged wavefunction
   type(wavefunction_type), intent(in) :: wfn
   !> Total energy in atomic units
   real(wp), intent(in) :: energy
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

#if TBLITE_HAS_TREXIO
   integer(trexio_t) :: trex_file
   integer(trexio_back_end_t) :: backend
   integer(trexio_exit_code) :: rc

   call get_backend(filename, backend, error)
   if (allocated(error)) return

   if (.not.trexio_has_backend(backend)) then
      call fatal_error(error, "Requested TREXIO backend is not available in the linked TREXIO library")
      return
   end if

   trex_file = trexio_open(filename, 'w', backend, rc)
   if (rc /= TREXIO_SUCCESS) then
      call fatal_trexio(error, rc, "Failed to open TREXIO output '"//filename//"'")
      return
   end if

   call write_nucleus(trex_file, mol, error)
   if (.not.allocated(error)) call write_cell(trex_file, mol, error)
   if (.not.allocated(error)) call write_electron(trex_file, mol, wfn, error)
   if (.not.allocated(error)) call write_state(trex_file, energy, error)
   if (.not.allocated(error)) call write_basis(trex_file, mol, bas, error)
   if (.not.allocated(error)) call write_ecp(trex_file, mol, wfn, error)
   if (.not.allocated(error)) call write_ao(trex_file, bas, error)
   if (.not.allocated(error)) call write_mo(trex_file, mol, bas, wfn, error)

   rc = trexio_close(trex_file)
   if (rc /= TREXIO_SUCCESS .and. .not.allocated(error)) then
      call fatal_trexio(error, rc, "Failed to close TREXIO output '"//filename//"'")
   end if
#else
   call fatal_error(error, "TREXIO support is not available in this build of tblite.")
#endif
end subroutine save_trexio

#if TBLITE_HAS_TREXIO
subroutine get_backend(filename, backend, error)
   !> Output file or directory name
   character(len=*), intent(in) :: filename
   !> TREXIO backend selected from the output extension
   integer(trexio_back_end_t), intent(out) :: backend
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   if (is_hdf5_file(filename)) then
#if TBLITE_HAS_HDF5
      backend = TREXIO_HDF5
#else
      call fatal_error(error, "TREXIO HDF5 output requires HDF5 support in tblite.")
      backend = TREXIO_TEXT
#endif
   else
      backend = TREXIO_TEXT
   end if
end subroutine get_backend

!> Load molecular structure object from TREXIO file
subroutine load_structure(trex_file, mol, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Molecular structure data loaded from TREXIO
   type(structure_type), intent(out) :: mol
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: nat, electron_num, electron_up_num, electron_dn_num
   real(wp), allocatable :: nuclear_charge(:), nuclear_coord(:, :), lattice(:, :)
   character(len=8), allocatable :: nuclear_label(:)
   logical, allocatable :: periodic(:)

   integer :: uhf
   real(wp) :: charge

   ! Read structure data from TREXIO file
   call read_nucleus(trex_file, nat, nuclear_charge, nuclear_coord, nuclear_label, &
      & error)
   if (.not.allocated(error)) call read_cell(trex_file, periodic, lattice, error)
   if (.not.allocated(error)) call read_electron(trex_file, electron_num, &
      & electron_up_num, electron_dn_num, error)
   if (allocated(error)) return

   ! Total charge and multiplicity
   charge = sum(nuclear_charge) - real(electron_num, wp)
   uhf = electron_up_num - electron_dn_num

   ! Set up new molecular structure object
   call new(mol, nint(nuclear_charge), nuclear_label, nuclear_coord, charge=charge, &
      & uhf=uhf, lattice=lattice, periodic=periodic)
end subroutine load_structure

!> Read total nuclear charge, atomic symbols and coordinates
subroutine read_nucleus(trex_file, nat, nuclear_charge, nuclear_coord, &
   & nuclear_label, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Number of atoms
   integer, intent(out) :: nat
   !> Nuclear charges
   real(wp), allocatable, intent(out) :: nuclear_charge(:)
   !> Nuclear coordinates in Bohr
   real(wp), allocatable, intent(out) :: nuclear_coord(:, :)
   !> Nuclear labels
   character(len=8), allocatable, intent(out) :: nuclear_label(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(c_double), allocatable :: charge(:), coord(:, :)
   integer(trexio_exit_code) :: rc

   rc = trexio_read_nucleus_num(trex_file, nat)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO nucleus count")
   if (allocated(error)) return

   allocate(charge(nat), coord(3, nat), nuclear_label(nat))
   rc = trexio_read_nucleus_charge(trex_file, charge)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO nuclear charges")
   if (allocated(error)) return

   rc = trexio_read_nucleus_coord(trex_file, coord)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO nuclear coordinates")
   if (allocated(error)) return

   rc = trexio_read_nucleus_label(trex_file, nuclear_label, len(nuclear_label))
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO nuclear labels")
   if (allocated(error)) return

   nuclear_charge = real(charge, wp)
   nuclear_coord = real(coord, wp)
end subroutine read_nucleus

!> Read lattice vectors and periodicity information
subroutine read_cell(trex_file, periodic, lattice, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Periodic directions
   logical, allocatable, intent(out) :: periodic(:)
   !> Lattice vectors in Bohr
   real(wp), allocatable, intent(out) :: lattice(:, :)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(c_double) :: a(3), b(3), c(3)
   logical :: tmp_periodic(3)
   integer(trexio_exit_code) :: rc

   tmp_periodic(:) = .true.
   rc = trexio_read_cell_a(trex_file, a)
   if (rc /= TREXIO_SUCCESS) tmp_periodic(1) = .false.

   rc = trexio_read_cell_b(trex_file, b)
   if (rc /= TREXIO_SUCCESS) tmp_periodic(2) = .false.

   rc = trexio_read_cell_c(trex_file, c)
   if (rc /= TREXIO_SUCCESS) tmp_periodic(3) = .false.

   if (any(tmp_periodic)) then
      periodic = tmp_periodic

      allocate(lattice(3, 3), source=0.0_wp)
      if (periodic(1)) lattice(:, 1) = real(a, wp)
      if (periodic(2)) lattice(:, 2) = real(b, wp)
      if (periodic(3)) lattice(:, 3) = real(c, wp)
   end if
end subroutine read_cell

!> Read total number of alpha/beta electrons including the core electrons
subroutine read_electron(trex_file, electron_num, electron_up_num, electron_dn_num, &
   & error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Number of electrons
   integer, intent(out) :: electron_num
   !> Number of alpha electrons
   integer, intent(out) :: electron_up_num
   !> Number of beta electrons
   integer, intent(out) :: electron_dn_num
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer(trexio_exit_code) :: rc

   rc = trexio_read_electron_num(trex_file, electron_num)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO electron count")
   if (allocated(error)) return

   rc = trexio_read_electron_up_num(trex_file, electron_up_num)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO alpha electron count")
   if (allocated(error)) return

   rc = trexio_read_electron_dn_num(trex_file, electron_dn_num)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO beta electron count")
end subroutine read_electron

!> Read total energy of the state in atomic units
subroutine read_state(trex_file, energy, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Total energy in atomic units
   real(wp), intent(out) :: energy
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(c_double) :: state_energy
   integer(trexio_exit_code) :: rc

   rc = trexio_read_state_energy(trex_file, state_energy)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO state energy")
   if (allocated(error)) return

   energy = real(state_energy, wp)
end subroutine read_state


!> Load basis set information object from TREXIO file
subroutine load_basis(trex_file, mol, bas, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Molecular structure data loaded from TREXIO
   type(structure_type), intent(in) :: mol
   !> Basis set information loaded from TREXIO
   type(basis_type), intent(out) :: bas
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: nsh, nprim
   integer, allocatable :: basis_nucleus_index(:), basis_shell_index(:)
   integer, allocatable :: basis_shell_ang_mom(:)
   real(wp), allocatable :: basis_shell_factor(:), basis_primitive_factor(:)
   real(wp), allocatable :: basis_primitive_alpha(:), basis_primitive_coeff(:)

   type(cgto_type), allocatable :: cgto(:, :)
   type(cgto_type) :: tmp_cgto
   logical, allocatable :: seen_cgto(:, :)
   integer, allocatable :: nsh_id(:), nsh_at(:), sh2at(:), nsh_work(:)
   real(wp), allocatable :: alpha(:), coeff(:)
   integer :: iat, iprim, ish, isp, jsh, l, ng

   call read_basis(trex_file, nsh, nprim, basis_nucleus_index, basis_shell_ang_mom, &
      & basis_shell_factor, basis_shell_index, basis_primitive_alpha, &
      & basis_primitive_coeff, basis_primitive_factor, error)
   if (allocated(error)) return

   if (any(basis_shell_index < 1) .or. any(basis_shell_index > nsh)) then
      call fatal_error(error, "TREXIO primitive references an unknown shell")
      return
   end if

   ! Shell count per atom and shell to atom mapping
   allocate(nsh_at(mol%nat), sh2at(nsh), source=0)
   do ish = 1, nsh
      iat = basis_nucleus_index(ish)
      if (iat < 1 .or. iat > mol%nat) then
         call fatal_error(error, "TREXIO shell references an unknown atom")
         return
      end if
      sh2at(ish) = iat
      nsh_at(iat) = nsh_at(iat) + 1
   end do

   ! Shell count per species requiring identical shell counts for all atoms of a species
   allocate(nsh_id(mol%nid))
   nsh_id(:) = -1
   do iat = 1, mol%nat
      isp = mol%id(iat)
      if (nsh_id(isp) < 0) then
         nsh_id(isp) = nsh_at(iat)
      else if (nsh_id(isp) /= nsh_at(iat)) then
         call fatal_error(error, "TREXIO basis has inconsistent shell counts for one species")
         return
      end if
   end do
   if (any(nsh_id <= 0)) then
      call fatal_error(error, "TREXIO missing shells for at least one species")
      return
   end if

   ! Build CGTOs for each species
   allocate(cgto(maxval(nsh_id), mol%nid))
   allocate(seen_cgto(maxval(nsh_id), mol%nid), source=.false.)
   allocate(alpha(maxg), coeff(maxg))
   allocate(nsh_work(mol%nat), source=0)
   do ish = 1, nsh
      iat = sh2at(ish)
      isp = mol%id(iat)
      ! Count shells at the current atom
      nsh_work(iat) = nsh_work(iat) + 1
      jsh = nsh_work(iat)
      ! Shell angular momentum
      l = basis_shell_ang_mom(ish)

      alpha(:) = 0.0_wp
      coeff(:) = 0.0_wp
      ng = 0
      do iprim = 1, nprim
         if (basis_shell_index(iprim) /= ish) cycle
         ng = ng + 1
         alpha(ng) = basis_primitive_alpha(iprim)
         coeff(ng) = basis_shell_factor(ish) * basis_primitive_factor(iprim) &
            & * basis_primitive_coeff(iprim)
      end do
      if (ng <= 0 .or. ng > maxg) then
         call fatal_error(error, "TREXIO shell has no primitives or more primitives than supported")
         return
      end if
      ! Apply no additional normalization, already part of the coefficents and primitive factor
      call new_cgto(tmp_cgto, ng, l, alpha, coeff, .false.)
      
      ! Check if current CGTO matches earlier CGTOs for the same species
      if (.not. seen_cgto(jsh, isp)) then
         cgto(jsh, isp) = tmp_cgto
         seen_cgto(jsh, isp) = .true.
      else if (.not.cgto(jsh, isp)%compare(tmp_cgto)) then
         call fatal_error(error, "TREXIO basis differs between atoms of the same species")
         return
      end if
   end do

   call new_basis(bas, mol, nsh_id, cgto, 1.0_wp)
end subroutine load_basis

!> Read shell mappings, angular momenta, contraction coefficients and exponents
subroutine read_basis(trex_file, nsh, nprim, basis_nucleus_index, basis_shell_ang_mom, &
   & basis_shell_factor, basis_shell_index, basis_primitive_alpha, &
   & basis_primitive_coeff, basis_primitive_factor, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Number of shells
   integer, intent(out) :: nsh
   !> Number of primitives
   integer, intent(out) :: nprim
   !> Mapping from shell index to nucleus index
   integer, allocatable, intent(out) :: basis_nucleus_index(:)
   !> Angular momentum of each shell
   integer, allocatable, intent(out) :: basis_shell_ang_mom(:)
   !> Shell normalization factors
   real(wp), allocatable, intent(out) :: basis_shell_factor(:)
   !> Mapping from primitive index to shell index
   integer, allocatable, intent(out) :: basis_shell_index(:)
   !> Exponent of Gaussian primitive functions
   real(wp), allocatable, intent(out) :: basis_primitive_alpha(:)
   !> Contraction coefficient of each primitive
   real(wp), allocatable, intent(out) :: basis_primitive_coeff(:)
   !> Primitive normalization factors
   real(wp), allocatable, intent(out) :: basis_primitive_factor(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer(trexio_exit_code) :: rc
   real(c_double), allocatable :: d_shell_factor(:), d_prim_factor(:)
   real(c_double), allocatable :: d_alpha(:), d_coeff(:)

   rc = trexio_read_basis_shell_num(trex_file, nsh)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO shell count")
   if (allocated(error)) return

   allocate(basis_nucleus_index(nsh))
   rc = trexio_read_basis_nucleus_index(trex_file, basis_nucleus_index)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO shell atom map")
   if (allocated(error)) return

   allocate(basis_shell_ang_mom(nsh))
   rc = trexio_read_basis_shell_ang_mom(trex_file, basis_shell_ang_mom)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO shell angular momenta")
   if (allocated(error)) return

   allocate(d_shell_factor(nsh), basis_shell_factor(nsh))
   rc = trexio_read_basis_shell_factor(trex_file, d_shell_factor)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO shell factor")
   if (allocated(error)) return
   basis_shell_factor = real(d_shell_factor, wp)

   rc = trexio_read_basis_prim_num(trex_file, nprim)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO primitive count")
   if (allocated(error)) return

   allocate(basis_shell_index(nprim))
   rc = trexio_read_basis_shell_index(trex_file, basis_shell_index)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO primitive shell map")
   if (allocated(error)) return
   
   allocate(d_alpha(nprim), basis_primitive_alpha(nprim))
   rc = trexio_read_basis_exponent(trex_file, d_alpha)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO primitive exponent")
   if (allocated(error)) return
   basis_primitive_alpha = real(d_alpha, wp)
   
   allocate(d_coeff(nprim), basis_primitive_coeff(nprim))
   rc = trexio_read_basis_coefficient(trex_file, d_coeff)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO primitive coefficient")
   if (allocated(error)) return
   basis_primitive_coeff = real(d_coeff, wp)

   allocate(d_prim_factor(nprim), basis_primitive_factor(nprim))
   rc = trexio_read_basis_prim_factor(trex_file, d_prim_factor)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO primitive factor")
   if (allocated(error)) return
   basis_primitive_factor = real(d_prim_factor, wp)
end subroutine read_basis


subroutine load_wavefunction(trex_file, mol, bas, wfn, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Molecular structure data loaded from TREXIO
   type(structure_type), intent(in) :: mol
   !> Basis set information loaded from TREXIO
   type(basis_type), intent(in) :: bas
   !> Wavefunction data loaded from TREXIO
   type(wavefunction_type), intent(out) :: wfn
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   
   integer :: nao, nmo
   logical :: cartesian
   real(wp), allocatable :: mo_occupation(:), mo_energy(:), mo_coefficient(:, :)
   integer, allocatable :: ecp_z_core(:), ao_shell(:), mo_spin(:)

   integer :: nspin, spin, imo, ish, iao, jsh, jat, jsp, js, jj, lj, imoflat
   integer :: ncart, icart, isphr, nsphr
   integer, allocatable :: ao_pos(:, :), ao_count(:), ao_expect(:), spin_count(:)
   integer :: perm_cart(15), perm_sphr(9)
   real(wp) :: ccart(15, 1), csphr(9, 1)
   real(wp), allocatable :: tmp_focc(:)

   call read_ecp(trex_file, mol%nat, ecp_z_core, error)
   if (.not.allocated(error)) call read_ao(trex_file, cartesian, nao, ao_shell, error)
   if (.not.allocated(error)) call read_mo(trex_file, nao, nmo, mo_coefficient, &
      & mo_occupation, mo_energy, mo_spin, error)
   if (allocated(error)) return

   if (cartesian) then
      if (nao /= bas%nao_cart) then
         call fatal_error(error, "TREXIO cartesian coefficient count does not match the basis")
         return
      end if
   else
      if (nao /= bas%nao) then
         call fatal_error(error, "TREXIO spherical coefficient count does not match the basis")
         return
      end if
   end if
   if (nmo == bas%nao) then
      ! Restricted TREXIO representation with one spatial MO list
      nspin = 1
   else if (nmo == 2 * bas%nao) then
      ! UHF TREXIO representation with alpha and beta spin-orbitals
      nspin = 2
      if (.not. any(mo_spin == 0) .or. .not. any(mo_spin == 1)) then
         call fatal_error(error, "TREXIO UHF MO data is missing alpha or beta spin labels")
         return
      end if
   else
      call fatal_error(error, "TREXIO MO count does not match the spherical AO basis")
      return
   end if

   ! Construct and check the AO to shell mapping
   allocate(ao_expect(bas%nsh))
   if (cartesian) then
      ao_expect(:) = bas%nao_cart_sh
   else
      ao_expect(:) = bas%nao_sh
   end if
   allocate(ao_pos(maxval(ao_expect), bas%nsh), ao_count(bas%nsh))
   ao_pos(:, :) = 0
   ao_count(:) = 0
   do iao = 1, nao
      ish = ao_shell(iao)
      if (ish < 1 .or. ish > bas%nsh) then
         call fatal_error(error, "TREXIO shell map references an unknown shell")
         return
      end if

      ao_count(ish) = ao_count(ish) + 1
      ao_pos(ao_count(ish), ish) = iao
   end do
   if (any(ao_count /= ao_expect)) then
      call fatal_error(error, "TREXIO shell map does not match the basis set")
      return
   end if

   ! Set up new wavefunction object (by default 0K electronic temperature)
   call new_wavefunction(wfn, mol%nat, bas%nsh, bas%nao, nspin, 0.0_wp)

   ! Set MO occupation and unpaired electrons
   wfn%nocc = sum(mo_occupation)
   wfn%nuhf = real(mol%uhf, wp)
   if (nspin == 1) then
      call get_alpha_beta_occupation(wfn%nocc, wfn%nuhf, wfn%nel(1), wfn%nel(2))
   else
      wfn%nel(1) = sum(mo_occupation, mask=mo_spin == 0)
      wfn%nel(2) = sum(mo_occupation, mask=mo_spin == 1)
   end if
   if (abs(wfn%nuhf - abs(wfn%nel(1) - wfn%nel(2))) > epsilon(1.0_wp)) then
      call fatal_error(error, "TREXIO occupation data has an inconsistent number of unpaired electrons")
      return
   end if

   ! Set atomic reference occupation from ECP core orbitals
   wfn%n0at(:) = real(mol%num(mol%id) - ecp_z_core, wp)

   ! MO coefficients, energy, and occupation numbers
   allocate(spin_count(nspin), source=0)
   wfn%coeff(:, :, :) = 0.0_wp
   do imoflat = 1, nmo
      spin = min(max(mo_spin(imoflat) + 1, 1), nspin)
      spin_count(spin) = spin_count(spin) + 1
      imo = spin_count(spin)
      if (imo > bas%nao) then
         call fatal_error(error, "TREXIO contains too many orbitals for one spin channel")
         return
      end if

      wfn%emo(imo, spin) = mo_energy(imoflat)
      if (nspin == 1) then
         ! Distribute restricted occupation equally between alpha and beta
         wfn%focc(imo, 1) = 0.5_wp * mo_occupation(imoflat)
         wfn%focc(imo, 2) = 0.5_wp * mo_occupation(imoflat)
      else
         wfn%focc(imo, spin) = mo_occupation(imoflat)
      end if

      do jsh = 1, bas%nsh
         jat = bas%sh2at(jsh)
         jsp = mol%id(jat)
         js = bas%ish_at(jat)
         lj = bas%cgto(jsh-js, jsp)%ang
         jj = bas%iao_sh(jsh)

         nsphr = bas%nao_sh(jsh)
         if (cartesian) then
            ! Reorder MO coefficients to match Cartesian AO ordering and transform
            call get_trexio_to_tblite_cart_perm(lj, perm_cart, error)
            if (allocated(error)) return

            ncart = bas%nao_cart_sh(jsh)
            ccart(:, :) = 0.0_wp
            csphr(:, :) = 0.0_wp
            do icart = 1, ncart
               iao = ao_pos(icart, jsh)
               ccart(perm_cart(icart), 1) = mo_coefficient(iao, imoflat)
            end do

            call transform0(lj, 0, ccart(:ncart, :1), csphr(:nsphr, :1), &
               & .true., .false.)
            wfn%coeff(jj+1:jj+nsphr, imo, spin) = csphr(:nsphr, 1)
         else
            ! Reorder MO coefficients to match spherical AO ordering
            call get_trexio_to_tblite_sphr_perm(lj, perm_sphr, error)
            if (allocated(error)) return

            do isphr = 1, nsphr
               iao = ao_pos(isphr, jsh)
               wfn%coeff(jj + perm_sphr(isphr), imo, spin) = &
                  & mo_coefficient(iao, imoflat)
            end do
         end if
      end do
   end do
   if (any(spin_count /= bas%nao)) then
      call fatal_error(error, "TREXIO data has an inconsistent number of spin orbitals")
      return
   end if

   ! Calculate the density matrix from MO coefficients and occupation numbers
   if (nspin == 1) then
      allocate(tmp_focc(size(wfn%focc, 1)))
      tmp_focc(:) = wfn%focc(:, 1) + wfn%focc(:, 2)
      call get_density_matrix(tmp_focc, wfn%coeff(:, :, 1), wfn%density(:, :, 1))
   else
      do spin = 1, nspin
         call get_density_matrix(wfn%focc(:, spin), wfn%coeff(:, :, spin), &
            & wfn%density(:, :, spin))
      end do
   end if
end subroutine load_wavefunction

subroutine read_ecp(trex_file, nat, ecp_z_core, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Number of atoms
   integer, intent(in) :: nat
   !> Number of core electrons removed per atom
   integer, allocatable, intent(out) :: ecp_z_core(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer(trexio_exit_code) :: rc

   allocate(ecp_z_core(nat))
   rc = trexio_read_ecp_z_core(trex_file, ecp_z_core)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO Z ECP core")
end subroutine read_ecp

subroutine read_ao(trex_file, cartesian, nao, ao_shell, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Whether the AOs are in Cartesian (true) or spherical (false) form
   logical, intent(out) :: cartesian
   !> Number of atomic orbitals
   integer, intent(out) :: nao
   !> Shell index for each AO
   integer, allocatable, intent(out) :: ao_shell(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer(trexio_exit_code) :: rc
   integer :: cart

   rc = trexio_read_ao_cartesian(trex_file, cart)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO AO cartesian flag")
   if (allocated(error)) return
   cartesian = cart /= 0

   rc = trexio_read_ao_num(trex_file, nao)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO AO count")
   if (allocated(error)) return

   allocate(ao_shell(nao))
   rc = trexio_read_ao_shell(trex_file, ao_shell)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO AO shell map")
end subroutine read_ao

subroutine read_mo(trex_file, nao, nmo, mo_coefficient, mo_occupation, mo_energy, &
   & mo_spin, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Number of atomic orbitals
   integer, intent(in) :: nao
   !> Number of molecular orbitals
   integer, intent(out) :: nmo
   !> Molecular orbital coefficients
   real(wp), allocatable, intent(out) :: mo_coefficient(:, :)
   !> Molecular orbital occupations
   real(wp), allocatable, intent(out) :: mo_occupation(:)
   !> Molecular orbital energies
   real(wp), allocatable, intent(out) :: mo_energy(:)
   !> Molecular orbital spins
   integer, allocatable, intent(out) :: mo_spin(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(c_double), allocatable :: mo_coeff(:, :), mo_ene(:), mo_occ(:)
   integer(trexio_exit_code) :: rc
   integer :: imo

   rc = trexio_read_mo_num(trex_file, nmo)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO MO count")
   if (allocated(error)) return

   allocate(mo_coeff(nao, nmo), mo_coefficient(nao, nmo))
   rc = trexio_read_mo_coefficient(trex_file, mo_coeff)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO MO coefficients")
   if (allocated(error)) return

   allocate(mo_occ(nmo), mo_occupation(nmo))
   rc = trexio_read_mo_occupation(trex_file, mo_occ)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO MO occupations")
   if (allocated(error)) return

   allocate(mo_ene(nmo), mo_energy(nmo))
   rc = trexio_read_mo_energy(trex_file, mo_ene)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO MO energies")
   if (allocated(error)) return

   allocate(mo_spin(nmo), source=0)
   rc = trexio_has_mo_spin(trex_file)
   if (rc == TREXIO_SUCCESS) then
      rc = trexio_read_mo_spin(trex_file, mo_spin)
      if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to read TREXIO MO spins")
      if (allocated(error)) return
   end if

   do imo = 1, nmo
      mo_coefficient(:, imo) = real(mo_coeff(:, imo), wp)
   end do
   mo_occupation = real(mo_occ, wp)
   mo_energy = real(mo_ene, wp)
end subroutine read_mo

!> Spherical AO order permutation from TREXIO (0, ... l, -l) to tblite (-l, ..., 0, ..., l)
subroutine get_trexio_to_tblite_sphr_perm(l, perm, error)
   !> Angular momentum quantum number
   integer, intent(in)  :: l
   !> Permutation array
   integer, intent(out) :: perm(9)
   !> Error handling
   type(error_type), intent(out), allocatable :: error

   perm = 0
   select case(l)
   case(0)
      perm(1) = 1
   case(1)
      perm(1:3) = [2, 3, 1]
   case(2)
      perm(1:5) = [3, 4, 2, 5, 1]
   case(3)
      perm(1:7) = [4, 5, 3, 6, 2, 7, 1]
   case(4)
      perm(1:9) = [5, 6, 4, 7, 3, 8, 2, 9, 1]
   case default
      call fatal_error(error, "TREXIO reader only supports angular momenta up to g")
      return
   end select
end subroutine get_trexio_to_tblite_sphr_perm

!> Cartesian AO order permutation from TREXIO (alphabetical) to tblite
subroutine get_trexio_to_tblite_cart_perm(l, perm, error)
   !> Angular momentum quantum number
   integer, intent(in) :: l
   !> Permutation array
   integer, intent(out) :: perm(15)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   perm = 0
   select case(l)
   case(0)
      perm(1) = 1
   case(1)
      perm(1:3) = [2, 3, 1]
   case(2)
      perm(1:6) = [1, 4, 5, 2, 6, 3]
   case(3)
      perm(1:10) = [1, 4, 5, 6, 10, 8, 2, 7, 9, 3]
   case(4)
      perm(1:15) = [1, 4, 5, 10, 13, 11, 14, 8, 15, 3, 2, 12, 6, 7, 9]
   case default
      call fatal_error(error, "TREXIO reader only supports angular momenta up to g")
      return
   end select
end subroutine get_trexio_to_tblite_cart_perm


subroutine write_nucleus(trex_file, mol, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(c_double), allocatable :: charge(:), coord(:, :)
   character(len=8), allocatable :: label(:)
   integer(trexio_exit_code) :: rc
   integer :: iat, isp

   allocate(charge(mol%nat), coord(3, mol%nat), label(mol%nat))
   do iat = 1, mol%nat
      isp = mol%id(iat)
      charge(iat) = real(mol%num(isp), c_double)
      label(iat) = mol%sym(isp)
   end do
   coord = real(mol%xyz, c_double)

   rc = trexio_write_nucleus_num(trex_file, mol%nat)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO nucleus count")
   if (allocated(error)) return

   rc = trexio_write_nucleus_charge(trex_file, charge)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO nuclear charges")
   if (allocated(error)) return

   rc = trexio_write_nucleus_coord(trex_file, coord)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO nuclear coordinates")
   if (allocated(error)) return

   rc = trexio_write_nucleus_label(trex_file, label, len(label))
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO nuclear labels")
end subroutine write_nucleus

subroutine write_cell(trex_file, mol, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(c_double) :: a(3), b(3), c(3)
   integer(trexio_exit_code) :: rc

   if (.not. allocated(mol%periodic) .or. .not. allocated(mol%lattice)) return
   if (.not. any(mol%periodic)) return

   if (mol%periodic(1)) then
      a = real(mol%lattice(:, 1), c_double)
      rc = trexio_write_cell_a(trex_file, a)
      if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO cell_a")
      if (allocated(error)) return
   end if

   if (mol%periodic(2)) then
      b = real(mol%lattice(:, 2), c_double)
      rc = trexio_write_cell_b(trex_file, b)
      if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO cell_b")
      if (allocated(error)) return
   end if

   if (mol%periodic(3)) then
      c = real(mol%lattice(:, 3), c_double)
      rc = trexio_write_cell_c(trex_file, c)
      if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO cell_c")
      if (allocated(error)) return
   end if
end subroutine write_cell

subroutine write_electron(trex_file, mol, wfn, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Converged wavefunction
   type(wavefunction_type), intent(in) :: wfn
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer(trexio_exit_code) :: rc
   integer :: core_num, core_up_num, core_dn_num, electron_num, up_num, dn_num
   real(wp) :: nalp, nbet

   ! Add back the neglected core electrons
   core_num = nint(sum(mol%num(mol%id) - wfn%n0at))
   core_up_num = core_num / 2
   core_dn_num = core_num / 2

   electron_num = nint(wfn%nocc) + core_num
   if (wfn%nspin == 2 .and. size(wfn%nel) >= 2) then
      up_num = nint(wfn%nel(1)) + core_up_num
      dn_num = nint(wfn%nel(2)) + core_dn_num
   else
      call get_alpha_beta_occupation(wfn%nocc, wfn%nuhf, nalp, nbet)
      up_num = nint(nalp) + core_up_num
      dn_num = nint(nbet) + core_dn_num
   end if

   rc = trexio_write_electron_num(trex_file, electron_num)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO electron count")
   if (allocated(error)) return

   rc = trexio_write_electron_up_num(trex_file, up_num)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO alpha electron count")
   if (allocated(error)) return

   rc = trexio_write_electron_dn_num(trex_file, dn_num)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO beta electron count")
end subroutine write_electron

subroutine write_state(trex_file, energy, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Total energy in atomic units
   real(wp), intent(in) :: energy
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer(trexio_exit_code) :: rc

   rc = trexio_write_state_num(trex_file, 1)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO state count")
   if (allocated(error)) return

   rc = trexio_write_state_id(trex_file, 1)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO state id")
   if (allocated(error)) return

   rc = trexio_write_state_energy(trex_file, real(energy, c_double))
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO state energy")
end subroutine write_state

subroutine write_basis(trex_file, mol, bas, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis metadata used by the calculation
   type(basis_type), intent(in) :: bas
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer(trexio_exit_code) :: rc
   integer, allocatable :: shell_ang_mom(:), basis_shell_index(:)
   real(c_double), allocatable :: d_alpha(:), d_coeff(:), d_s_factor(:), d_p_factor(:)
   integer :: iat, isp, is, ish, iprim, nprim, jprim

   allocate(shell_ang_mom(bas%nsh), d_s_factor(bas%nsh))
   nprim = 0
   do ish = 1, bas%nsh
      iat = bas%sh2at(ish)
      isp = mol%id(iat)
      is = bas%ish_at(iat)
      shell_ang_mom(ish) = bas%cgto(ish - is, isp)%ang
      nprim = nprim + bas%cgto(ish - is, isp)%nprim
      ! Normalization of the contracted basis function is included in the coefficients
      d_s_factor(ish) = 1.0_wp
   end do

   rc = trexio_write_basis_type(trex_file, "Gaussian", 16)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO basis type")
   if (allocated(error)) return

   rc = trexio_write_basis_shell_num(trex_file, bas%nsh)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO shell count")
   if (allocated(error)) return

   rc = trexio_write_basis_nucleus_index(trex_file, bas%sh2at)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO shell atom map")
   if (allocated(error)) return

   rc = trexio_write_basis_shell_ang_mom(trex_file, shell_ang_mom)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO shell angular momenta")
   if (allocated(error)) return

   rc = trexio_write_basis_shell_factor(trex_file, d_s_factor)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO shell factor")
   if (allocated(error)) return

   rc = trexio_write_basis_prim_num(trex_file, nprim)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO primitive count")
   if (allocated(error)) return

   allocate(basis_shell_index(nprim), d_alpha(nprim), d_coeff(nprim), d_p_factor(nprim))
   jprim = 1
   do ish = 1, bas%nsh
      iat = bas%sh2at(ish)
      isp = mol%id(iat)
      is = bas%ish_at(iat)
      associate(p_cgto => bas%cgto(ish - is, isp))
         do iprim = 1, p_cgto%nprim
            basis_shell_index(jprim) = ish
            d_alpha(jprim) = real(p_cgto%alpha(iprim), c_double)
            d_coeff(jprim) = real(p_cgto%coeff(iprim), c_double)
            ! Coefficients already include normalization factors
            d_p_factor(jprim) = 1.0_c_double
            jprim = jprim + 1
         end do
      end associate
   end do

   rc = trexio_write_basis_shell_index(trex_file, basis_shell_index)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO primitive shell map")
   if (allocated(error)) return

   rc = trexio_write_basis_exponent(trex_file, d_alpha)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO primitive exponent")
   if (allocated(error)) return

   rc = trexio_write_basis_coefficient(trex_file, d_coeff)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO primitive coefficient")
   if (allocated(error)) return

   rc = trexio_write_basis_prim_factor(trex_file, d_p_factor)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO primitive factor")
end subroutine write_basis

subroutine write_ecp(trex_file, mol, wfn, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Converged wavefunction
   type(wavefunction_type), intent(in) :: wfn
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer(trexio_exit_code) :: rc
   integer, allocatable :: ecp_z_core(:)

   allocate(ecp_z_core(mol%nat))
   ecp_z_core = nint(mol%num(mol%id) - wfn%n0at)
   rc = trexio_write_ecp_z_core(trex_file, ecp_z_core)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO Z ECP core")
end subroutine write_ecp

subroutine write_ao(trex_file, bas, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Basis metadata used by the calculation
   type(basis_type), intent(in) :: bas
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer(trexio_exit_code) :: rc

   rc = trexio_write_ao_cartesian(trex_file, 0)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO AO cartesian flag")
   if (allocated(error)) return

   rc = trexio_write_ao_num(trex_file, bas%nao)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO AO count")
   if (allocated(error)) return

   rc = trexio_write_ao_shell(trex_file, bas%ao2sh)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO AO shell map")
end subroutine write_ao

subroutine write_mo(trex_file, mol, bas, wfn, error)
   !> Open TREXIO file handle
   integer(trexio_t), intent(in) :: trex_file
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   class(basis_type), intent(in) :: bas
   !> Converged wavefunction
   type(wavefunction_type), intent(in) :: wfn
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(c_double), allocatable :: mo_coeff(:, :), mo_energy(:), mo_occ(:)
   integer, allocatable :: mo_spin(:)
   integer(trexio_exit_code) :: rc
   integer :: nmo, imo, imoflat, jsh, jat, jsp, js, jao_sphr, nsphr
   integer :: nspin_mo, spin, cspin, idx_trexio, idx_tblite, perm(15)
   logical :: spin_resolved_mo

   ! Represent only restricted closed-shell MOs as one spin-summed MO list
   ! and both restricted open-shell and unrestricted MOs with two spin channels
   spin_resolved_mo = wfn%nspin > 1 .or. abs(wfn%nuhf) > epsilon(1.0_wp)
   if (spin_resolved_mo) then
      nspin_mo = 2
      nmo = bas%nao * nspin_mo
      allocate(mo_coeff(bas%nao, nmo), mo_energy(nmo), mo_occ(nmo), mo_spin(nmo))
   else
      nspin_mo = 1
      nmo = bas%nao
      allocate(mo_coeff(bas%nao, nmo), mo_energy(nmo), mo_occ(nmo))
   end if

   mo_coeff(:, :) = 0.0_c_double
   mo_energy(:) = 0.0_c_double
   mo_occ(:) = 0.0_c_double
   if (allocated(mo_spin)) mo_spin(:) = 0

   ! Reorder MO coefficients to TREXIO ordering
   imoflat = 0
   do spin = 1, nspin_mo
      cspin = min(spin, wfn%nspin)
      do imo = 1, bas%nao
         imoflat = imoflat + 1
         mo_energy(imoflat) = real(wfn%emo(imo, cspin), c_double)
         if (spin_resolved_mo) then
            mo_occ(imoflat) = real(wfn%focc(imo, spin), c_double)
            mo_spin(imoflat) = spin - 1
         else
            mo_occ(imoflat) = real(wfn%focc(imo, 1) + wfn%focc(imo, 2), c_double)
         end if
         idx_trexio = 0
         do jsh = 1, bas%nsh
            nsphr = bas%nao_sh(jsh)
            jat = bas%sh2at(jsh)
            jsp = mol%id(jat)
            js = bas%ish_at(jat)
            call get_trexio_to_tblite_sphr_perm(bas%cgto(jsh - js, jsp)%ang, perm, error)
            if (allocated(error)) return
            do jao_sphr = 1, nsphr
               idx_trexio = idx_trexio + 1
               idx_tblite = bas%iao_sh(jsh) + perm(jao_sphr)
               mo_coeff(idx_trexio, imoflat) = real(wfn%coeff(idx_tblite, imo, cspin), &
                  & c_double)
            end do
         end do
      end do
   end do

   rc = trexio_write_mo_type(trex_file, "Tight-binding", 32)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO MO type")
   if (allocated(error)) return

   rc = trexio_write_mo_num(trex_file, nmo)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO MO count")
   if (allocated(error)) return

   rc = trexio_write_mo_coefficient(trex_file, mo_coeff)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO MO coefficients")
   if (allocated(error)) return

   rc = trexio_write_mo_occupation(trex_file, mo_occ)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO MO occupations")
   if (allocated(error)) return

   rc = trexio_write_mo_energy(trex_file, mo_energy)
   if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO MO energies")
   if (allocated(error)) return

   if (allocated(mo_spin)) then
      rc = trexio_write_mo_spin(trex_file, mo_spin)
      if (rc /= TREXIO_SUCCESS) call fatal_trexio(error, rc, "Failed to write TREXIO MO spins")
   end if
end subroutine write_mo

subroutine fatal_trexio(error, rc, context)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> TREXIO return code
   integer(trexio_exit_code), intent(in) :: rc
   !> Operation that failed
   character(len=*), intent(in) :: context

   character(len=256) :: message

   call trexio_string_of_error(rc, message)
   call fatal_error(error, context//": "//trim(message))
end subroutine fatal_trexio
#endif

pure function is_hdf5_file(filename) result(is_hdf5)
   !> File name to inspect
   character(len=*), intent(in) :: filename
   !> Whether the file name uses an HDF5 extension
   logical :: is_hdf5

   is_hdf5 = len(filename) >= 3 .and. filename(len(filename)-2:) == ".h5"
   is_hdf5 = is_hdf5 .or. &
      & (len(filename) >= 5 .and. filename(len(filename)-4:) == ".hdf5")
end function is_hdf5_file

end module tblite_io_trexio

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module test_write
   use mctc_env_accuracy, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check
   use mctc_io_write
   use mctc_io_read
   use mctc_io_structure, only : structure_type
   use mctc_version, only : get_mctc_feature
   use testsuite_structure, only : get_structure
   implicit none
   private

   public :: collect_write


contains


!> Collect all exported unit tests
subroutine collect_write(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("valid-cjson", test_cjson, should_fail=.not.get_mctc_feature("json")), &
      & new_unittest("valid-mol", test_mol), &
      & new_unittest("valid-sdf", test_sdf), &
      & new_unittest("valid-gen", test_gen), &
      & new_unittest("valid-pdb", test_pdb), &
      & new_unittest("valid-qchem", test_qchem), &
      & new_unittest("valid-qcschema", test_qcschema, should_fail=.not.get_mctc_feature("json")), &
      & new_unittest("valid-vasp", test_vasp), &
      & new_unittest("valid-coord", test_coord), &
      & new_unittest("valid-xyz", test_xyz) &
      & ]

end subroutine collect_write


subroutine test_mol(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   character(len=:), allocatable :: name
   integer :: unit

   name = get_name() // ".mol"

   call get_structure(struc, "mindless01")

   call write_structure(struc, name, error)
   if (.not.allocated(error)) then
      call read_structure(struc, name, error)
   end if

   open(file=name, newunit=unit)
   close(unit, status='delete')

end subroutine test_mol


subroutine test_sdf(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   character(len=:), allocatable :: name
   integer :: unit

   name = get_name() // ".sdf"

   call get_structure(struc, "mindless02")

   call write_structure(struc, name, error)
   if (.not.allocated(error)) then
      call read_structure(struc, name, error)
   end if

   open(file=name, newunit=unit)
   close(unit, status='delete')

end subroutine test_sdf


subroutine test_pdb(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   character(len=:), allocatable :: name
   integer :: unit

   name = get_name() // ".pdb"

   call get_structure(struc, "mindless03")

   call write_structure(struc, name, error)
   if (.not.allocated(error)) then
      call read_structure(struc, name, error)
   end if

   open(file=name, newunit=unit)
   close(unit, status='delete')

end subroutine test_pdb


subroutine test_qchem(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   character(len=:), allocatable :: name
   integer :: unit

   name = get_name() // ".qchem"

   call get_structure(struc, "mindless04")

   call write_structure(struc, name, error)
   if (.not.allocated(error)) then
      call read_structure(struc, name, error)
   end if

   open(file=name, newunit=unit)
   close(unit, status='delete')

end subroutine test_qchem


subroutine test_gen(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   character(len=:), allocatable :: name
   integer :: unit

   name = get_name() // ".gen"

   call get_structure(struc, "x01")

   call write_structure(struc, name, error)
   if (.not.allocated(error)) then
      call read_structure(struc, name, error)
   end if

   open(file=name, newunit=unit)
   close(unit, status='delete')

end subroutine test_gen


subroutine test_coord(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   character(len=:), allocatable :: name
   integer :: unit

   name = get_name() // ".coord"

   call get_structure(struc, "x02")

   call write_structure(struc, name, error)
   if (.not.allocated(error)) then
      call read_structure(struc, name, error)
   end if

   open(file=name, newunit=unit)
   close(unit, status='delete')

end subroutine test_coord


subroutine test_vasp(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   character(len=:), allocatable :: name
   integer :: unit

   name = get_name() // ".poscar"

   call get_structure(struc, "x03")

   call write_structure(struc, name, error)
   if (.not.allocated(error)) then
      call read_structure(struc, name, error)
   end if

   open(file=name, newunit=unit)
   close(unit, status='delete')

end subroutine test_vasp


subroutine test_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   character(len=:), allocatable :: name
   integer :: unit

   name = get_name() // ".xyz"

   call get_structure(struc, "mindless04")

   call write_structure(struc, name, error)
   if (.not.allocated(error)) then
      call read_structure(struc, name, error)
   end if

   open(file=name, newunit=unit)
   close(unit, status='delete')

end subroutine test_xyz


subroutine test_qcschema(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   character(len=:), allocatable :: name
   integer :: unit

   name = get_name() // ".json"

   call get_structure(struc, "mindless05")

   call write_structure(struc, name, error)
   if (.not.allocated(error)) then
      call read_structure(struc, name, error)
   end if

   open(file=name, newunit=unit)
   close(unit, status='delete')

end subroutine test_qcschema


subroutine test_cjson(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   character(len=:), allocatable :: name
   integer :: unit

   name = get_name() // ".cjson"

   call get_structure(struc, "mindless06")

   call write_structure(struc, name, error)
   if (.not.allocated(error)) then
      call read_structure(struc, name, error)
   end if

   open(file=name, newunit=unit)
   close(unit, status='delete')

end subroutine test_cjson


function get_name() result(name)

   character(len=18) :: name

   real :: val

   call random_number(val)
   write(name, '(a, z8.8)') "mctc-test-", int(val*1.0e9)

end function get_name


end module test_write

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_tagged_io
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use tblite_io_tag, only : tagged_data, tagged_entry, write_tagged
   implicit none
   private

   public :: collect_tagged_io

   real(wp), parameter :: thr = 10*epsilon(1.0_wp)

contains


!> Collect all exported unit tests
subroutine collect_tagged_io(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("write-read", test_write_read) &
      ]

end subroutine collect_tagged_io


subroutine test_write_read(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: io, stat

   type(tagged_data) :: tdata
   real(wp) :: gradient1(3, 8), sigma1(3, 3), energy1, charges1(8)
   !real(wp) :: gradient2(3, 8), sigma2(3, 3), energy2, charges2(8)

   call random_number(energy1)
   call random_number(gradient1)
   call random_number(sigma1)
   call random_number(charges1)

   open(newunit=io, status="scratch")

   call write_tagged(io, "energy", energy1, stat)
   call check(error, stat)
   if (allocated(error)) return

   call write_tagged(io, "gradient", gradient1, stat)
   call check(error, stat)
   if (allocated(error)) return

   call write_tagged(io, "sigma", sigma1, stat)
   call check(error, stat)
   if (allocated(error)) return

   call write_tagged(io, "charges", charges1, stat)
   call check(error, stat)
   if (allocated(error)) return

   rewind io

   call tdata%load(io, stat)
   call check(error, stat)
   if (allocated(error)) return

   call check(error, size(tdata%val) == 4)
   if (allocated(error)) return

   close(io)

end subroutine test_write_read


end module test_tagged_io

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module test_write_xyz
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check
   use testsuite_structure, only : get_structure
   use mctc_io_write_xyz
   use mctc_io_read_xyz
   use mctc_io_structure
   implicit none
   private

   public :: collect_write_xyz


contains


!> Collect all exported unit tests
subroutine collect_write_xyz(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("valid1-xyz", test_valid1_xyz) &
      & ]

end subroutine collect_write_xyz


subroutine test_valid1_xyz(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit, nat, nid

   call get_structure(struc, "mindless01")
   nat = struc%nat
   nid = struc%nid

   open(status='scratch', newunit=unit)
   call write_xyz(struc, unit)
   rewind(unit)

   call read_xyz(struc, unit, error)
   close(unit)
   if (allocated(error)) return

   call check(error, struc%nat, nat, "Number of atoms does not match")
   if (allocated(error)) return
   call check(error, struc%nid, nid, "Number of species does not match")
   if (allocated(error)) return

end subroutine test_valid1_xyz


end module test_write_xyz

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/lapack
!> Contains wrappers for linear algebra

!> @file tblite/lapack.f90
!> Reexports of the high-level linear algebra wrappers

!> Proxy module to reexport high-level linear algebra package wrappers
module tblite_lapack
   use tblite_lapack_getrf, only : getrf => wrap_getrf
   use tblite_lapack_getri, only : getri => wrap_getri
   use tblite_lapack_getrs, only : getrs => wrap_getrs
   implicit none
   public
end module tblite_lapack

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> TOML deserialization module
!>
!> This module provides interfaces for loading and parsing TOML documents
!> from various sources (files, strings, and I/O units).
!>
!> The primary interfaces are:
!>
!> - [[toml_load]]: Load TOML from a file path or connected unit
!> - [[toml_loads]]: Parse TOML from a string
!>
!> All parsing functions return an allocatable [[toml_table]] that contains
!> the parsed document. If parsing fails, the table will not be allocated
!> and error information is provided via the optional error argument.
module tomlf_de
   use tomlf_constants, only : tfc, TOML_NEWLINE
   use tomlf_de_context, only : toml_context
   use tomlf_de_lexer, only : toml_lexer, new_lexer_from_string, new_lexer_from_unit, &
      & new_lexer_from_file
   use tomlf_de_parser, only : parse, toml_parser_config
   use tomlf_diagnostic, only : toml_level
   use tomlf_error, only : toml_error
   use tomlf_type, only : toml_table
   implicit none
   private

   public :: toml_parse
   public :: toml_load, toml_loads
   public :: toml_context, toml_parser_config, toml_level


   !> Parse a TOML document.
   !>
   !> This interface is deprecated in favor of [[toml_load]] and [[toml_loads]]
   interface toml_parse
      module procedure :: toml_parse_unit
      module procedure :: toml_parse_string
   end interface toml_parse

   !> Load a TOML data structure from the provided source
   interface toml_load
      module procedure :: toml_load_file
      module procedure :: toml_load_unit
   end interface toml_load

   !> Load a TOML data structure from a string
   interface toml_loads
      module procedure :: toml_load_string
   end interface toml_loads


contains


!> Parse a TOML input from a given IO unit.
!>
!> @note This procedure is deprectated
subroutine toml_parse_unit(table, unit, error)
   !> Instance of the TOML data structure, not allocated in case of error
   type(toml_table), allocatable, intent(out) :: table
   !> Unit to read from
   integer, intent(in) :: unit
   !> Error handling, provides detailed diagnostic in case of error
   type(toml_error), allocatable, intent(out), optional :: error

   call toml_load(table, unit, error=error)
end subroutine toml_parse_unit

!> Wrapper to parse a TOML string.
!>
!> @note This procedure is deprectated
subroutine toml_parse_string(table, string, error)
   !> Instance of the TOML data structure, not allocated in case of error
   type(toml_table), allocatable, intent(out) :: table
   !> String containing TOML document
   character(len=*), intent(in), target :: string
   !> Error handling, provides detailed diagnostic in case of error
   type(toml_error), allocatable, intent(out), optional :: error

   call toml_loads(table, string, error=error)
end subroutine toml_parse_string

!> Load TOML data structure from file
subroutine toml_load_file(table, filename, config, context, error)
   !> Instance of the TOML data structure, not allocated in case of error
   type(toml_table), allocatable, intent(out) :: table
   character(*, tfc), intent(in) :: filename
   !> Configuration for the parser
   type(toml_parser_config), intent(in), optional :: config
   !> Context tracking the origin of the data structure to allow rich reports
   type(toml_context), intent(out), optional :: context
   !> Error handling, provides detailed diagnostic in case of error
   type(toml_error), allocatable, intent(out), optional :: error

   type(toml_lexer) :: lexer
   type(toml_error), allocatable :: error_

   call new_lexer_from_file(lexer, filename, error_)
   if (.not.allocated(error_)) then
      call parse(lexer, table, config, context, error)
   else
      if (present(error)) call move_alloc(error_, error)
   end if
end subroutine toml_load_file

!> Load TOML data structure from unit
subroutine toml_load_unit(table, io, config, context, error)
   !> Instance of the TOML data structure, not allocated in case of error
   type(toml_table), allocatable, intent(out) :: table
   !> Unit to read from
   integer, intent(in) :: io
   !> Configuration for the parser
   type(toml_parser_config), intent(in), optional :: config
   !> Context tracking the origin of the data structure to allow rich reports
   type(toml_context), intent(out), optional :: context
   !> Error handling, provides detailed diagnostic in case of error
   type(toml_error), allocatable, intent(out), optional :: error

   type(toml_lexer) :: lexer
   type(toml_error), allocatable :: error_

   call new_lexer_from_unit(lexer, io, error_)
   if (.not.allocated(error_)) then
      call parse(lexer, table, config, context, error)
   else
      if (present(error)) call move_alloc(error_, error)
   end if
end subroutine toml_load_unit

!> Load TOML data structure from string
subroutine toml_load_string(table, string, config, context, error)
   !> Instance of the TOML data structure, not allocated in case of error
   type(toml_table), allocatable, intent(out) :: table
   !> String containing TOML document
   character(*, tfc), intent(in) :: string
   !> Configuration for the parser
   type(toml_parser_config), intent(in), optional :: config
   !> Context tracking the origin of the data structure to allow rich reports
   type(toml_context), intent(out), optional :: context
   !> Error handling, provides detailed diagnostic in case of error
   type(toml_error), allocatable, intent(out), optional :: error

   type(toml_lexer) :: lexer

   call new_lexer_from_string(lexer, string)
   call parse(lexer, table, config, context, error)
end subroutine toml_load_string

end module tomlf_de

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

#include "mctc/defs.h"

module mctc_io_read_qcschema
   use mctc_env_accuracy, only : wp
   use mctc_env_error, only : error_type, fatal_error
   use mctc_io_structure, only : structure_type, new
   use mctc_io_symbols, only : to_number, symbol_length
   use mctc_io_utils, only : to_string
#if WITH_JSON
   use jonquil, only : json_value, json_object, json_array, json_keyval, &
      & json_load, json_error, json_context, json_stat, get_value, &
      & json_parser_config, json_context, cast_to_object, len
#endif
   implicit none
   private

   public :: read_qcschema

#if WITH_JSON
   interface read_qcschema
      module procedure read_qcschema
      module procedure load_qcschema
   end interface read_qcschema
#endif

contains


subroutine read_qcschema(self, unit, error)

   !> Instance of the molecular structure data
   type(structure_type), intent(out) :: self

   !> File handle
   integer, intent(in) :: unit

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

#if WITH_JSON
   class(json_value), allocatable :: root
   type(json_object), pointer :: object
   type(json_error), allocatable :: parse_error
   type(json_context) :: ctx

   call json_load(root, unit, config=json_parser_config(context_detail=1), &
      & context=ctx, error=parse_error)
   if (allocated(parse_error)) then
      allocate(error)
      call move_alloc(parse_error%message, error%message)
      return
   end if
   object => cast_to_object(root)
   if (.not.associated(object)) then
      call fatal_error(error, ctx%report("Invalid JSON object", root%origin, "Expected JSON object"))
      return
   end if

   call load_qcschema(self, object, ctx, error)
#else
   call fatal_error(error, "JSON support not enabled")
#endif
end subroutine read_qcschema

#if WITH_JSON
subroutine load_qcschema(self, object, ctx, error)

   !> Instance of the molecular structure data
   type(structure_type), intent(out) :: self

   !> JSON object representing the structure
   type(json_object), target, intent(inout) :: object

   !> JSON context for error reporting
   type(json_context), intent(inout) :: ctx

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(json_object), pointer :: root, child, extras, child2
   type(json_array), pointer :: array, child_array
   type(json_keyval), pointer :: val

   integer :: stat, origin, schema_version, multiplicity, iat, ibond
   integer :: origin_symbols, origin_geometry
   character(len=:), allocatable :: symbol, message, schema_name, comment
   character(len=symbol_length), allocatable :: sym(:)
   integer, allocatable :: bond(:, :), list(:)
   real(wp) :: charge
   real(wp), allocatable, target :: geo(:), lat(:)
   real(wp), pointer :: xyz(:, :), lattice(:, :)

   call get_value(object, "schema_version", schema_version, default=2, stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read schema version", origin=origin))
      return
   end if
   call get_value(object, "schema_name", schema_name, default="qcschema_molecule", stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read schema name", origin=origin))
      return
   end if

   if (schema_name /= "qcschema_molecule" .and. schema_name /= "qcschema_input") then
      call get_value(object, "schema_name", val, requested=.false.)
      if (associated(val)) origin = val%origin_value
      call fatal_error(error, ctx%report("Invalid schema name '"//schema_name//"'", &
         & origin, "Expected 'qcschema_molecule' or 'qcschema_input'"))
      return
   end if

   if (schema_name == "qcschema_input") then
      select case(schema_version)
      case(1)
         call get_value(object, "molecule", child, stat=stat, origin=origin)
         if (stat /= json_stat%success) then
            call fatal_error(error, ctx%report("Could not read molecule", origin=origin))
            return
         end if
      case default
         call get_value(object, "schema_version", val, requested=.false.)
         if (associated(val)) origin = val%origin_value
         call fatal_error(error, ctx%report("Unsupported schema version for 'qcschema_input'", &
            & origin, "Expected 1"))
         return
      end select
      call get_value(child, "schema_version", schema_version, default=2, stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read schema version", origin=origin))
         return
      end if
      call get_value(child, "schema_name", schema_name, default="qcschema_molecule", stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read schema name", origin=origin))
         return
      end if

      if (schema_name /= "qcschema_molecule") then
         call get_value(child, "schema_name", val, requested=.false.)
         if (associated(val)) origin = val%origin_value
         call fatal_error(error, ctx%report("Invalid schema name '"//schema_name//"'", &
            & origin, "Expected 'qcschema_molecule'"))
         return
      end if

      root => child
   else
      root => object
   end if

   select case(schema_version)
   case(1)
      call get_value(root, "molecule", child, stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read molecule", origin=origin))
         return
      end if
   case(2)
      child => root
   case default
      call get_value(root, "schema_version", val, requested=.false.)
      if (associated(val)) origin = val%origin_value
      call fatal_error(error, ctx%report("Unsupported schema version for 'qcschema_molecule'", &
         & origin, "Expected 1 or 2"))
      return
   end select

   call get_value(child, "symbols", array, requested=.false., stat=stat, origin=origin)
   if (stat /= json_stat%success .or. .not.associated(array)) then
      call fatal_error(error, ctx%report("Could not read symbols", origin=origin))
      return
   end if
   allocate(sym(len(array)))
   do iat = 1, size(sym)
      call get_value(array, iat, symbol, stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read symbol", origin=origin))
         return
      end if
      sym(iat) = symbol
   end do
   origin_symbols = array%origin
   call get_value(child, "geometry", array, requested=.false., stat=stat, origin=origin)
   if (stat == json_stat%success .and. associated(array)) then
      call get_value(array, geo, stat=stat, origin=origin)
   end if
   if (stat /= json_stat%success .or. .not.associated(array)) then
      if (associated(array) .and. origin == 0) origin = array%origin
      call fatal_error(error, ctx%report("Could not read geometry", origin=origin))
      return
   end if
   origin_geometry = array%origin

   if (3*size(sym) /= size(geo)) then
      call fatal_error(error, ctx%report("Number of coordinates and elements do not match", &
         & origin_symbols, origin_geometry, "Got "//to_string(size(sym))//" elements", &
         & "Got "//to_string(size(geo))//" coordinates, expected "//to_string(3*size(sym))))
      return
   end if

   call get_value(child, "comment", comment, default="", stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read comment", origin=origin))
      return
   end if
   call get_value(child, "molecular_charge", charge, default=0.0_wp, stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read charge", origin=origin, label="Expected float or integer"))
      return
   end if
   call get_value(child, "molecular_multiplicity", multiplicity, default=1, stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read multiplicity", origin=origin, label="Expected integer"))
      return
   end if

   call get_value(child, "connectivity", array, stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read connectivity", origin=origin))
      return
   end if
   if (associated(array)) then
      allocate(bond(3, len(array)))
      do ibond = 1, size(bond, 2)
         call get_value(array, ibond, child_array, stat=stat, origin=origin)
         if (stat == json_stat%success) then
            call get_value(child_array, list, stat=stat, origin=origin)
         end if
         if (stat /= json_stat%success) then
            if (origin == 0) then
               call get_value(array, ibond, val)
               if (associated(val)) origin = val%origin_value
            end if
            call fatal_error(error, ctx%report("Could not read bond", origin=origin))
            return
         end if
         if (allocated(list)) then
            bond(:, ibond) = [list(1)+1, list(2)+1, list(3)]
         end if
      end do
   end if

   nullify(lattice)
   nullify(array)
   call get_value(child, "extras", extras, stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read extras", origin=origin, &
        & label="Expected object"))
      return
   end if
   call get_value(extras, "periodic", child2, requested=.false., stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read periodic extras", origin=origin, &
         & label="Expected object with 'lattice' key"))
      return
   end if
   if (associated(child2)) then
      call get_value(child2, "lattice", array, requested=.false., stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read lattice from extras", origin=origin, &
            & label="Expected array with 9 elements"))
         return
      end if
   end if
   if (associated(array)) then
      call get_value(array, lat, stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read lattice from extras", origin=origin, &
            & label="Expected array with 9 elements"))
         return
      end if
      if (size(lat) /= 9) then
         call fatal_error(error, ctx%report("Lattice must have 9 elements", origin=array%origin, &
            & label="Got "//to_string(size(lat))//" elements"))
         return
      end if
      lattice(1:3, 1:3) => lat(1:9)
   end if

   xyz(1:3, 1:size(geo)/3) => geo
   call new(self, sym, xyz, charge=charge, uhf=multiplicity-1, lattice=lattice)
   if (len(comment) > 0) self%comment = comment
   if (allocated(bond)) then
      self%nbd = size(bond, 2)
      call move_alloc(bond, self%bond)
   end if

end subroutine load_qcschema
#endif


end module mctc_io_read_qcschema

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/api/table.f90
!> Provides API exports for the #tblite_table handle.

!> API export for managing data tables
module tblite_api_table
   use, intrinsic :: iso_c_binding
   use mctc_env, only : fatal_error
   use tblite_api_error, only : vp_error
   use tblite_api_version, only : namespace
   use tblite_api_utils, only : c_f_character, f_c_character, strlen
   use tblite_toml, only : toml_table, toml_array, toml_key, toml_value, add_array, set_value, get_value, len, toml_error, toml_dump
   implicit none
   private

   public :: vp_table
   public :: vp_array
   public :: new_table_api, delete_table_api
   public :: table_set_double_api, table_set_int64_t_api, table_set_bool_api, &
      & table_set_char_api, table_add_table_api, dump_table_api
   public :: new_array_api, delete_array_api
   public :: array_push_back_double_api, array_push_back_int64_t_api, &
      & array_push_back_bool_api, array_push_back_char_api
   public :: array_size_api, array_get_type_api, array_get_double_api, &
      & array_get_int64_t_api, array_get_bool_api, array_get_char_api
   public :: table_set_array_api, table_get_type_api, table_get_bool_api, &
      & table_get_int64_t_api, table_get_double_api, table_get_char_api, &
      & table_get_table_api, table_get_array_api, table_get_n_keys_api, &
      & table_get_key_api

   !> Void pointer to manage general data tables
   type :: vp_table
      !> Actual payload
      type(toml_table), pointer :: ptr
      !> Data is owned by the object
      logical :: owned
   end type vp_table

   !> Void pointer to manage general data arrays
   type :: vp_array
      !> Actual payload
      type(toml_array), pointer :: ptr
      !> Data is owned by the object
      logical :: owned
   end type vp_array

   integer, parameter :: value_type_none = 0
   integer, parameter :: value_type_bool = 1
   integer, parameter :: value_type_int = 2
   integer, parameter :: value_type_double = 3
   integer, parameter :: value_type_char = 4
   integer, parameter :: value_type_array = 5
   integer, parameter :: value_type_table = 6

   logical, parameter :: debug = .false.

contains

!> Create data table reference object
function new_table_api(vtable) &
      & result(vval) &
      & bind(C, name=namespace//"new_table")
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   type(vp_table), pointer :: val
   type(c_ptr) :: vval
   type(toml_table), pointer :: dat

   if (debug) print '("[Info]", 1x, a)', "new_table"

   allocate(val)
   if (c_associated(vtable)) then
      call c_f_pointer(vtable, table)
      val%ptr => table%ptr
      val%owned = .false.
   else
      allocate(dat)
      dat = toml_table()
      val%ptr => dat
      val%owned = .true.
   end if
   vval = c_loc(val)
end function new_table_api

!> Delete data table object
subroutine delete_table_api(vtable) &
      & bind(C, name=namespace//"delete_table")
   type(c_ptr), intent(inout) :: vtable
   type(vp_table), pointer :: table

   if (debug) print '("[Info]", 1x, a)', "delete_table"

   if (c_associated(vtable)) then
      call c_f_pointer(vtable, table)

      if (table%owned) deallocate(table%ptr)
      deallocate(table)
      vtable = c_null_ptr
   end if

end subroutine delete_table_api

subroutine table_set_double_api(verror, vtable, ckey, val, n) &
      & bind(C, name=namespace//"table_set_double")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   real(c_double), intent(in) :: val(*)
   integer(c_int), value :: n
   type(toml_array), pointer :: array
   integer :: i, stat

   if (debug) print '("[Info]", 1x, a)', "table_set_double"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)

   if (table%ptr%has_key(key)) call table%ptr%delete(key)

   if (n > 0) then
      call add_array(table%ptr, key, array)
      do i = 1, n
         call set_value(array, i, val(i), stat=stat)
         if (stat /= 0) exit
      end do
   else
      call set_value(table%ptr, key, val(1), stat=stat)
   end if

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back double value(s) to data table")
   end if
end subroutine table_set_double_api

subroutine table_set_int64_t_api(verror, vtable, ckey, val, n) &
      & bind(C, name=namespace//"table_set_int64_t")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   integer(c_int64_t), intent(in) :: val(*)
   integer(c_int), value :: n
   type(toml_array), pointer :: array
   integer :: i, stat

   if (debug) print '("[Info]", 1x, a)', "table_set_int64_t"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)

   if (table%ptr%has_key(key)) call table%ptr%delete(key)

   if (n > 0) then
      call add_array(table%ptr, key, array)
      do i = 1, n
         call set_value(array, i, val(i), stat=stat)
         if (stat /= 0) exit
      end do
   else
      call set_value(table%ptr, key, val(1), stat=stat)
   end if

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back integer value(s) to data table")
   end if
end subroutine table_set_int64_t_api

subroutine table_set_bool_api(verror, vtable, ckey, val, n) &
      & bind(C, name=namespace//"table_set_bool")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   logical(c_bool), intent(in) :: val(*)
   integer(c_int), value :: n
   type(toml_array), pointer :: array
   integer :: i, stat

   if (debug) print '("[Info]", 1x, a)', "table_set_bool"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)

   if (table%ptr%has_key(key)) call table%ptr%delete(key)

   if (n > 0) then
      call add_array(table%ptr, key, array)
      do i = 1, n
         call set_value(array, i, merge(.true., .false., val(i)), stat=stat)
         if (stat /= 0) exit
      end do
   else
      call set_value(table%ptr, key, merge(.true., .false., val(1)), stat=stat)
   end if

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back boolean value(s) to data table")
   end if
end subroutine table_set_bool_api

subroutine table_set_char_api(verror, vtable, ckey, cval, n) &
      & bind(C, name=namespace//"table_set_char")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key, val
   type(c_ptr), value :: cval
   character(kind=c_char), pointer :: carr(:, :)
   integer(c_int), value :: n
   type(toml_array), pointer :: array
   integer :: i, stat

   if (debug) print '("[Info]", 1x, a)', "table_set_char"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)
   call c_f_pointer(cval, carr, [strlen(cval)+1, max(n, 1)])

   if (table%ptr%has_key(key)) call table%ptr%delete(key)

   if (n > 0) then
      call add_array(table%ptr, key, array)
      do i = 1, n
         call c_f_character(carr(:, i), val)
         call set_value(array, i, val, stat=stat)
         if (stat /= 0) exit
      end do
   else
      call c_f_character(carr(:, 1), val)
      call set_value(table%ptr, key, val, stat=stat)
   end if

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back character string to data table")
   end if
end subroutine table_set_char_api

function table_add_table_api(verror, vtable, ckey) &
      & result(vval) &
      & bind(C, name=namespace//"table_add_table")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   type(c_ptr) :: vval
   type(vp_table), pointer :: val
   type(toml_table), pointer :: tmp
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "table_add_table"

   vval = c_null_ptr
   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   vval = new_table_api(vtable)
   call c_f_pointer(vtable, table)
   call c_f_pointer(vval, val)
   call c_f_character(ckey, key)

   call get_value(table%ptr, key, tmp, stat=stat)
   val%ptr => tmp

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back subtable to data table")
      call delete_table_api(vval)
   end if
end function table_add_table_api

function new_array_api() &
      & result(vval) &
      & bind(C, name=namespace//"new_array")
   type(c_ptr) :: vval
   type(vp_array), pointer :: val
   type(toml_array), pointer :: dat

   if (debug) print '("[Info]", 1x, a)', "new_array"

   allocate(val)
   allocate(dat)
   dat = toml_array()
   val%ptr => dat
   val%owned = .true.
   vval = c_loc(val)
end function new_array_api

subroutine delete_array_api(varray) &
      & bind(C, name=namespace//"delete_array")
   type(c_ptr), intent(inout) :: varray
   type(vp_array), pointer :: array

   if (debug) print '("[Info]", 1x, a)', "delete_array"

   if (c_associated(varray)) then
      call c_f_pointer(varray, array)

      if (array%owned) deallocate(array%ptr)
      deallocate(array)
      varray = c_null_ptr
   end if
end subroutine delete_array_api

subroutine array_push_back_double_api(verror, varray, value) &
      & bind(C, name=namespace//"array_push_back_double")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: varray
   type(vp_array), pointer :: array
   real(c_double), value :: value
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "array_push_back_double"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(varray)) then
      call fatal_error(error%ptr, "Data array object is missing")
      return
   end if

   call c_f_pointer(varray, array)
   call set_value(array%ptr, len(array%ptr) + 1, value, stat=stat)

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back double value to data array")
   end if
end subroutine array_push_back_double_api

subroutine array_push_back_int64_t_api(verror, varray, value) &
      & bind(C, name=namespace//"array_push_back_int64_t")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: varray
   type(vp_array), pointer :: array
   integer(c_int64_t), value :: value
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "array_push_back_int64_t"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(varray)) then
      call fatal_error(error%ptr, "Data array object is missing")
      return
   end if

   call c_f_pointer(varray, array)
   call set_value(array%ptr, len(array%ptr) + 1, value, stat=stat)

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back integer value to data array")
   end if
end subroutine array_push_back_int64_t_api

subroutine array_push_back_bool_api(verror, varray, value) &
      & bind(C, name=namespace//"array_push_back_bool")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: varray
   type(vp_array), pointer :: array
   logical(c_bool), value :: value
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "array_push_back_bool"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(varray)) then
      call fatal_error(error%ptr, "Data array object is missing")
      return
   end if

   call c_f_pointer(varray, array)
   call set_value(array%ptr, len(array%ptr) + 1, merge(.true., .false., value), stat=stat)

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back boolean value to data array")
   end if
end subroutine array_push_back_bool_api

subroutine array_push_back_char_api(verror, varray, cvalue) &
      & bind(C, name=namespace//"array_push_back_char")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: varray
   type(vp_array), pointer :: array
   character(kind=c_char), intent(in) :: cvalue(*)
   character(len=:), allocatable :: value
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "array_push_back_char"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(varray)) then
      call fatal_error(error%ptr, "Data array object is missing")
      return
   end if

   call c_f_pointer(varray, array)
   call c_f_character(cvalue, value)
   call set_value(array%ptr, len(array%ptr) + 1, value, stat=stat)

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back character value to data array")
   end if
end subroutine array_push_back_char_api

function array_size_api(verror, varray) result(n) &
      & bind(C, name=namespace//"array_size")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: varray
   type(vp_array), pointer :: array
   integer(c_int) :: n

   if (debug) print '("[Info]", 1x, a)', "array_size"

   n = 0
   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(varray)) then
      call fatal_error(error%ptr, "Data array object is missing")
      return
   end if

   call c_f_pointer(varray, array)
   n = len(array%ptr)
end function array_size_api

function array_get_type_api(verror, varray, index) result(itype) &
      & bind(C, name=namespace//"array_get_type")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: varray
   type(vp_array), pointer :: array
   integer(c_int), value :: index
   integer(c_int) :: itype
   logical :: tmp_bool
   integer(c_int64_t) :: tmp_int
   real(c_double) :: tmp_double
   character(len=:), allocatable :: tmp_char
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "array_get_type"

   itype = value_type_none
   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(varray)) then
      call fatal_error(error%ptr, "Data array object is missing")
      return
   end if

   call c_f_pointer(varray, array)
   if (index < 1 .or. index > len(array%ptr)) return

   call get_value(array%ptr, index, tmp_bool, stat=stat)
   if (stat == 0) then
      itype = value_type_bool
      return
   end if

   call get_value(array%ptr, index, tmp_int, stat=stat)
   if (stat == 0) then
      itype = value_type_int
      return
   end if

   call get_value(array%ptr, index, tmp_double, stat=stat)
   if (stat == 0) then
      itype = value_type_double
      return
   end if

   call get_value(array%ptr, index, tmp_char, stat=stat)
   if (stat == 0) then
      itype = value_type_char
   end if
end function array_get_type_api

subroutine array_get_double_api(verror, varray, index, value) &
      & bind(C, name=namespace//"array_get_double")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: varray
   type(vp_array), pointer :: array
   integer(c_int), value :: index
   real(c_double) :: value
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "array_get_double"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(varray)) then
      call fatal_error(error%ptr, "Data array object is missing")
      return
   end if

   call c_f_pointer(varray, array)
   call get_value(array%ptr, index, value, stat=stat)
   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to read double value from data array")
   end if
end subroutine array_get_double_api

subroutine array_get_int64_t_api(verror, varray, index, value) &
      & bind(C, name=namespace//"array_get_int64_t")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: varray
   type(vp_array), pointer :: array
   integer(c_int), value :: index
   integer(c_int64_t) :: value
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "array_get_int64_t"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(varray)) then
      call fatal_error(error%ptr, "Data array object is missing")
      return
   end if

   call c_f_pointer(varray, array)
   call get_value(array%ptr, index, value, stat=stat)
   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to read integer value from data array")
   end if
end subroutine array_get_int64_t_api

subroutine array_get_bool_api(verror, varray, index, value) &
      & bind(C, name=namespace//"array_get_bool")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: varray
   type(vp_array), pointer :: array
   integer(c_int), value :: index
   logical(c_bool) :: value
   logical :: tmp
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "array_get_bool"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(varray)) then
      call fatal_error(error%ptr, "Data array object is missing")
      return
   end if

   call c_f_pointer(varray, array)
   call get_value(array%ptr, index, tmp, stat=stat)
   value = tmp
   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to read boolean value from data array")
   end if
end subroutine array_get_bool_api

subroutine array_get_char_api(verror, varray, index, cvalue, n) &
      & bind(C, name=namespace//"array_get_char")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: varray
   type(vp_array), pointer :: array
   integer(c_int), value :: index
   character(kind=c_char), intent(out) :: cvalue(*)
   integer(c_int), value :: n
   character(len=:), allocatable :: value
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "array_get_char"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(varray)) then
      call fatal_error(error%ptr, "Data array object is missing")
      return
   end if

   call c_f_pointer(varray, array)
   call get_value(array%ptr, index, value, stat=stat)
   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to read character value from data array")
   end if
   call f_c_character(value, cvalue, n)
end subroutine array_get_char_api

subroutine table_set_array_api(verror, vtable, ckey, varray) &
      & bind(C, name=namespace//"table_set_array")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   type(c_ptr), value :: varray
   type(vp_array), pointer :: array
   character(len=:), allocatable :: key
   type(toml_array), pointer :: values
   integer(c_int) :: n, i, itype, stat
   logical :: tmp_bool
   integer(c_int64_t) :: tmp_int
   real(c_double) :: tmp_double
   character(len=:), allocatable :: tmp_char

   if (debug) print '("[Info]", 1x, a)', "table_set_array"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)

   if (table%ptr%has_key(key)) call table%ptr%delete(key)

   call c_f_pointer(varray, array)
   call add_array(table%ptr, key, values)
   n = len(array%ptr)

   do i = 1, n
      call get_value(array%ptr, i, tmp_bool, stat=stat)
      if (stat == 0) then
         call set_value(values, i, tmp_bool, stat=stat)
         if (stat /= 0) exit
         cycle
      end if

      call get_value(array%ptr, i, tmp_int, stat=stat)
      if (stat == 0) then
         call set_value(values, i, tmp_int, stat=stat)
         if (stat /= 0) exit
         cycle
      end if

      call get_value(array%ptr, i, tmp_double, stat=stat)
      if (stat == 0) then
         call set_value(values, i, tmp_double, stat=stat)
         if (stat /= 0) exit
         cycle
      end if

      call get_value(array%ptr, i, tmp_char, stat=stat)
      if (stat == 0) then
         call set_value(values, i, tmp_char, stat=stat)
         if (stat /= 0) exit
      end if
   end do

   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to push back array value(s) to data table")
   end if
end subroutine table_set_array_api

function table_get_type_api(verror, vtable, ckey) result(itype) &
      & bind(C, name=namespace//"table_get_type")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   integer(c_int) :: itype
   logical :: tmp_bool
   integer(c_int64_t) :: tmp_int
   real(c_double) :: tmp_double
   character(len=:), allocatable :: tmp_char
   type(toml_table), pointer :: tmp_table
   type(toml_array), pointer :: tmp_array
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "table_get_type"

   itype = value_type_none
   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)

   call get_value(table%ptr, key, tmp_table, stat=stat)
   if (stat == 0) then
      itype = value_type_table
      return
   end if

   call get_value(table%ptr, key, tmp_array, stat=stat)
   if (stat == 0) then
      itype = value_type_array
      return
   end if

   call get_value(table%ptr, key, tmp_bool, stat=stat)
   if (stat == 0) then
      itype = value_type_bool
      return
   end if

   call get_value(table%ptr, key, tmp_int, stat=stat)
   if (stat == 0) then
      itype = value_type_int
      return
   end if

   call get_value(table%ptr, key, tmp_double, stat=stat)
   if (stat == 0) then
      itype = value_type_double
      return
   end if

   call get_value(table%ptr, key, tmp_char, stat=stat)
   if (stat == 0) then
      itype = value_type_char
   end if
end function table_get_type_api

subroutine table_get_bool_api(verror, vtable, ckey, value) &
      & bind(C, name=namespace//"table_get_bool")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   logical(c_bool) :: value
   logical :: tmp
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "table_get_bool"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)
   call get_value(table%ptr, key, tmp, stat=stat)
   value = tmp
   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to read boolean value from data table")
   end if
end subroutine table_get_bool_api

subroutine table_get_int64_t_api(verror, vtable, ckey, value) &
      & bind(C, name=namespace//"table_get_int64_t")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   integer(c_int64_t) :: value
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "table_get_int64_t"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)
   call get_value(table%ptr, key, value, stat=stat)
   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to read integer value from data table")
   end if
end subroutine table_get_int64_t_api

subroutine table_get_double_api(verror, vtable, ckey, value) &
      & bind(C, name=namespace//"table_get_double")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   real(c_double) :: value
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "table_get_double"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)
   call get_value(table%ptr, key, value, stat=stat)
   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to read double value from data table")
   end if
end subroutine table_get_double_api

subroutine table_get_char_api(verror, vtable, ckey, cvalue, n) &
      & bind(C, name=namespace//"table_get_char")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   character(kind=c_char), intent(out) :: cvalue(*)
   integer(c_int), value :: n
   character(len=:), allocatable :: value
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "table_get_char"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)
   call get_value(table%ptr, key, value, stat=stat)
   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to read character value from data table")
   end if
   call f_c_character(value, cvalue, n)
end subroutine table_get_char_api

function table_get_table_api(verror, vtable, ckey) result(vval) &
      & bind(C, name=namespace//"table_get_table")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   type(c_ptr) :: vval
   type(vp_table), pointer :: val
   type(toml_table), pointer :: tmp
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "table_get_table"

   vval = c_null_ptr
   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)
   call get_value(table%ptr, key, tmp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to read subtable from data table")
      return
   end if

   allocate(val)
   val%ptr => tmp
   val%owned = .false.
   vval = c_loc(val)
end function table_get_table_api

function table_get_array_api(verror, vtable, ckey) result(vval) &
      & bind(C, name=namespace//"table_get_array")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: ckey(*)
   character(len=:), allocatable :: key
   type(c_ptr) :: vval
   type(vp_array), pointer :: val
   type(toml_array), pointer :: tmp
   integer :: stat

   if (debug) print '("[Info]", 1x, a)', "table_get_array"

   vval = c_null_ptr
   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call c_f_character(ckey, key)
   call get_value(table%ptr, key, tmp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error%ptr, "Failed to read array from data table")
      return
   end if

   allocate(val)
   val%ptr => tmp
   val%owned = .false.
   vval = c_loc(val)
end function table_get_array_api

function table_get_n_keys_api(verror, vtable) result(n) &
      & bind(C, name=namespace//"table_get_n_keys")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   integer(c_int) :: n
   type(toml_key), allocatable :: list(:)

   if (debug) print '("[Info]", 1x, a)', "table_get_n_keys"

   n = 0
   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call table%ptr%get_keys(list)
   n = size(list)
end function table_get_n_keys_api

subroutine table_get_key_api(verror, vtable, index, ckey, n) &
      & bind(C, name=namespace//"table_get_key")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   integer(c_int), value :: index
   character(kind=c_char), intent(out) :: ckey(*)
   integer(c_int), value :: n
   type(toml_key), allocatable :: list(:)
   character(len=:), allocatable :: key

   if (debug) print '("[Info]", 1x, a)', "table_get_key"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if

   call c_f_pointer(vtable, table)
   call table%ptr%get_keys(list)
   if (index < 1 .or. index > size(list)) then
      call fatal_error(error%ptr, "Table key index out of range")
      return
   end if

   key = list(index)%key
   call f_c_character(key, ckey, n)
end subroutine table_get_key_api

subroutine dump_table_api(verror, vtable, cfilename) &
      & bind(C, name=namespace//"dump_table")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vtable
   type(vp_table), pointer :: table
   character(kind=c_char), intent(in) :: cfilename(*)
   character(len=:), allocatable :: filename
   type(toml_error), allocatable :: ser_error
   integer :: unit

   if (debug) print '("[Info]", 1x, a)', "dump_table"

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vtable)) then
      call fatal_error(error%ptr, "Data table object is missing")
      return
   end if
   call c_f_pointer(vtable, table)
   call c_f_character(cfilename, filename)

   open(newunit=unit, file=filename, status='replace', action='write')
   call toml_dump(table%ptr, unit, ser_error)
   close(unit)

   if (allocated(ser_error)) then
      call fatal_error(error%ptr, ser_error%message)
   end if
end subroutine dump_table_api


end module tblite_api_table

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

module test_pairwise
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type
   use mstore, only : get_structure
   use dftd4
   implicit none
   private

   public :: collect_pairwise

   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

   type(realspace_cutoff), parameter :: cutoff = &
      & realspace_cutoff(cn=30_wp, disp2=60.0_wp, disp3=15.0_wp)


contains


!> Collect all exported unit tests
subroutine collect_pairwise(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("PBE-D4", test_pbed4_mb01), &
      & new_unittest("PBE-D4S", test_pbed4s_mb01), &
      & new_unittest("B97-D4", test_b97d4_mb02), &
      & new_unittest("B97-D4S", test_b97d4s_mb02), &
      & new_unittest("TPSS-D4", test_tpssd4_ammonia), &
      & new_unittest("TPSS-D4S", test_tpssd4s_ammonia) &
      & ]

end subroutine collect_pairwise


subroutine test_dftd4_pairwise(error, mol, d4, param)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Dispersion model
   class(dispersion_model), intent(in) :: d4

   !> Damping parameters
   class(damping_param), intent(in) :: param

   real(wp) :: energy
   real(wp), allocatable :: energy2(:, :), energy3(:, :)

   allocate(energy2(mol%nat, mol%nat), energy3(mol%nat, mol%nat))

   call get_dispersion(mol, d4, param, cutoff, energy)
   call get_pairwise_dispersion(mol, d4, param, cutoff, energy2, energy3)

   call check(error, energy, sum(energy2) + sum(energy3), thr=thr)
   if (allocated(error)) then
      print*,energy, sum(energy2) + sum(energy3)
   end if

end subroutine test_dftd4_pairwise


subroutine test_pbed4_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 0.95948085_wp, a1 = 0.38574991_wp, a2 = 4.80688534_wp)

   call get_structure(mol, "MB16-43", "01")
   call new_d4_model(error, d4, mol)
   call test_dftd4_pairwise(error, mol, d4, param)

end subroutine test_pbed4_mb01

subroutine test_pbed4s_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 0.95948085_wp, a1 = 0.38574991_wp, a2 = 4.80688534_wp)

   call get_structure(mol, "MB16-43", "01")
   call new_d4s_model(error, d4s, mol)
   call test_dftd4_pairwise(error, mol, d4s, param)

end subroutine test_pbed4s_mb01


subroutine test_b97d4_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.69460052_wp, a1 = 0.28904684_wp, a2 = 4.13407323_wp)

   call get_structure(mol, "MB16-43", "02")
   call new_d4_model(error, d4, mol)
   call test_dftd4_pairwise(error, mol, d4, param)

end subroutine test_b97d4_mb02

subroutine test_b97d4s_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.69460052_wp, a1 = 0.28904684_wp, a2 = 4.13407323_wp)

   call get_structure(mol, "MB16-43", "02")
   call new_d4s_model(error, d4s, mol)
   call test_dftd4_pairwise(error, mol, d4s, param)

end subroutine test_b97d4s_mb02


subroutine test_tpssd4_ammonia(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.76596355_wp, a1 = 0.42822303_wp, a2 = 4.54257102_wp )

   call get_structure(mol, "X23", "ammonia")
   call new_d4_model(error, d4, mol)
   call test_dftd4_pairwise(error, mol, d4, param)

end subroutine test_tpssd4_ammonia

subroutine test_tpssd4s_ammonia(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.76596355_wp, a1 = 0.42822303_wp, a2 = 4.54257102_wp )

   call get_structure(mol, "X23", "ammonia")
   call new_d4s_model(error, d4s, mol)
   call test_dftd4_pairwise(error, mol, d4s, param)

end subroutine test_tpssd4s_ammonia


end module test_pairwise

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/param/mask.f90
!> Provides a general mask for the complete parameters set

!> Collection of the parameter masking
module tblite_param_mask
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io_symbols, only : to_number, symbol_length
   use tblite_param_charge, only : charge_mask, count
   use tblite_param_dispersion, only : dispersion_mask, count
   use tblite_param_element, only : element_record, element_mask, count
   use tblite_param_halogen, only : halogen_mask, count
   use tblite_param_hamiltonian, only : hamiltonian_mask, count
   use tblite_param_multipole, only : multipole_mask, count
   use tblite_param_repulsion, only : repulsion_mask, count
   use tblite_param_serde, only : serde_record
   use tblite_param_thirdorder, only : thirdorder_mask, count
   use tblite_toml, only : toml_table, toml_array, toml_key, get_value, set_value, &
      & add_table, add_array
   implicit none
   private

   public :: count


   type :: allowed_records
      logical :: hamiltonian = .false.
      logical :: dispersion = .false.
      logical :: repulsion = .false.
      logical :: charge = .false.
      logical :: multipole = .false.
      logical :: halogen = .false.
      logical :: thirdorder = .false.
   end type allowed_records


   !> Definition of the complete parameter mask
   type, public, extends(serde_record) :: param_mask
      !> Definition of the Hamiltonian, always required
      type(hamiltonian_mask), allocatable :: hamiltonian
      !> Definition of the dispersion correction
      type(dispersion_mask), allocatable :: dispersion
      !> Definition of the repulsion contribution
      type(repulsion_mask), allocatable :: repulsion
      !> Definition of the isotropic second-order charge interactions
      type(charge_mask), allocatable :: charge
      !> Definition of the anisotropic second-order multipolar interactions
      type(multipole_mask), allocatable :: multipole
      !> Definition of the halogen bonding correction
      type(halogen_mask), allocatable :: halogen
      !> Definition of the isotropic third-order charge interactions
      type(thirdorder_mask), allocatable :: thirdorder
      !> Element specific parameter masks
      type(element_mask), allocatable :: record(:)
      !> Reference to base parametrization
      type(element_record), pointer :: ref(:) => null()
   contains
      !> Read parametrization mask from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization mask to TOML data structure
      procedure :: dump_to_toml
   end type param_mask


   interface count
      module procedure :: count_mask
   end interface count


contains


!> Read parametrization mask from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(param_mask), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(allowed_records) :: allowed
   type(toml_table), pointer :: child

   call get_value(table, "hamiltonian", child, requested=.false.)
   allowed%hamiltonian = associated(child)
   if (associated(child)) then
      allocate(self%hamiltonian)
   end if

   call get_value(table, "dispersion", child, requested=.false.)
   allowed%dispersion = associated(child)
   if (associated(child)) then
      allocate(self%dispersion)
   end if

   call get_value(table, "repulsion", child, requested=.false.)
   allowed%repulsion = associated(child)
   if (associated(child)) then
      allocate(self%repulsion)
   end if

   call get_value(table, "halogen", child, requested=.false.)
   allowed%halogen = associated(child)
   if (associated(child)) then
      allocate(self%halogen)
   end if

   call get_value(table, "charge", child, requested=.false.)
   allowed%charge = associated(child)
   if (associated(child)) then
      allocate(self%charge)
   end if

   call get_value(table, "multipole", child, requested=.false.)
   allowed%multipole = associated(child)
   if (associated(child)) then
      allocate(self%multipole)
   end if

   call get_value(table, "thirdorder", child, requested=.false.)
   allowed%thirdorder = associated(child)
   if (associated(child)) then
      allocate(self%thirdorder)
   end if

   call get_value(table, "element", child)
   call records_from_table(self%record, child, self%ref, allowed, error)
   if (allocated(error)) return
end subroutine load_from_toml


!> Deserialize records from a table by iterating over all entires
subroutine records_from_table(record, table, ref, allowed, error)
   !> List of all element records
   type(element_mask), allocatable, intent(out) :: record(:)
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> List of all element records
   type(element_record), intent(in), optional :: ref(:)
   !> Allowed entries in record
   type(allowed_records), intent(in) :: allowed
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ii, nsh, ir, stat
   type(toml_key), allocatable :: list(:)
   type(toml_table), pointer :: child

   call table%get_keys(list)
   allocate(record(size(list)))

   do ii = 1, size(list)
      call get_value(table, list(ii)%key, child)
      if (present(ref)) then
         call get(ref, list(ii)%key, ir)
         if (ir == 0) cycle
         nsh = ref(ir)%nsh
      else
         call get_value(child, "nsh", nsh, stat=stat)
         if (stat /= 0) cycle
      end if
      call record_from_table(record(ii), child, nsh, allowed, error)
      if (allocated(error)) exit
   end do
   if (allocated(error)) return
end subroutine records_from_table


!> Get the position of an element in the parameter records
pure subroutine get(record, sym, pos)
   !> Instance of the parametrization records
   type(element_record), intent(in) :: record(:)
   !> Symbol of the element
   character(len=*), intent(in) :: sym
   !> Position in the records
   integer, intent(out) :: pos

   integer :: num
   integer :: ii

   num = to_number(sym)
   pos = 0

   do ii = 1, size(record)
      if (record(ii)%sym == sym) then
         pos = ii
         exit
      end if
   end do
   if (pos /= 0) return

   do ii = 1, size(record)
      if (record(ii)%num == num) then
         pos = ii
         exit
      end if
   end do
   if (pos /= 0) return
end subroutine get


!> Deserialize records from a table by iterating over all entires
subroutine record_from_table(record, table, nsh, allowed, error)
   !> List of all element records
   type(element_mask), intent(out) :: record
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Number of shells for this record
   integer, intent(in) :: nsh
   !> Allowed entries in record
   type(allowed_records), intent(in) :: allowed
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   record%sym = table%key
   record%num = to_number(table%key)

   allocate(record%levels(nsh), source=.false.)
   allocate(record%slater(nsh), source=.false.)
   allocate(record%kcn(nsh), source=.false.)
   allocate(record%shpoly(nsh), source=.false.)
   allocate(record%lgam(nsh), source=.false.)

   call read_shell_mask(table, "levels", record%levels, allowed%hamiltonian, error)
   if (allocated(error)) return
   call read_shell_mask(table, "slater", record%slater, allowed%hamiltonian, error)
   if (allocated(error)) return
   call read_shell_mask(table, "shpoly", record%shpoly, allowed%hamiltonian, error)
   if (allocated(error)) return
   call read_shell_mask(table, "kcn", record%kcn, allowed%hamiltonian, error)
   if (allocated(error)) return

   call read_atom_mask(table, "gam", record%gam, allowed%charge, error)
   if (allocated(error)) return
   call read_shell_mask(table, "lgam", record%lgam, allowed%charge, error)
   if (allocated(error)) return

   call read_atom_mask(table, "dkernel", record%dkernel, allowed%multipole, error)
   if (allocated(error)) return
   call read_atom_mask(table, "qkernel", record%qkernel, allowed%multipole, error)
   if (allocated(error)) return

   call read_atom_mask(table, "gam3", record%gam3, allowed%thirdorder, error)
   if (allocated(error)) return

   call read_atom_mask(table, "zeff", record%zeff, allowed%repulsion, error)
   if (allocated(error)) return
   call read_atom_mask(table, "arep", record%alpha, allowed%repulsion, error)
   if (allocated(error)) return

   call read_atom_mask(table, "xbond", record%xbond, allowed%halogen, error)
   if (allocated(error)) return
end subroutine record_from_table


subroutine read_atom_mask(table, key, mask, default, error)
   type(toml_table), intent(inout) :: table
   character(len=*), intent(in) :: key
   logical, intent(out) :: mask
   logical, intent(in) :: default
   type(error_type), allocatable, intent(out) :: error

   call get_value(table, key, mask, default)
end subroutine read_atom_mask


subroutine read_shell_mask(table, key, mask, default, error)
   type(toml_table), intent(inout) :: table
   character(len=*), intent(in) :: key
   logical, intent(out) :: mask(:)
   logical, intent(in) :: default
   type(error_type), allocatable, intent(out) :: error

   type(toml_array), pointer :: array
   integer :: ii

   call get_value(table, key, array, requested=.false.)
   if (associated(array)) then
      do ii = 1, size(mask)
         call get_value(array, ii, mask(ii))
      end do
   else
      call get_value(table, key, mask(1), default)
      mask(:) = mask(1)
   end if
end subroutine read_shell_mask


!> Write parametrization mask to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(param_mask), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   if (allocated(self%hamiltonian)) then
      call add_table(table, "hamiltonian", child)
   end if

   if (allocated(self%dispersion)) then
      call add_table(table, "dispersion", child)
   end if

   if (allocated(self%repulsion)) then
      call add_table(table, "repulsion", child)
   end if

   if (allocated(self%halogen)) then
      call add_table(table, "halogen", child)
   end if

   if (allocated(self%charge)) then
      call add_table(table, "charge", child)
   end if

   if (allocated(self%multipole)) then
      call add_table(table, "multipole", child)
   end if

   if (allocated(self%thirdorder)) then
      call add_table(table, "thirdorder", child)
   end if

   if (allocated(self%thirdorder)) then
      call add_table(table, "thirdorder", child)
   end if

   call add_table(table, "element", child)
   call records_to_table(self%record, child, error)
   if (allocated(error)) return

end subroutine dump_to_toml


!> Serialize records to a table by iterating over all entries
subroutine records_to_table(record, table, error)
   !> List of all element records
   type(element_mask), intent(in) :: record(:)
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ii
   type(toml_table), pointer :: child

   do ii = 1, size(record)
      call add_table(table, trim(record(ii)%sym), child)
      call record_to_table(record(ii), child, error)
      if (allocated(error)) exit
   end do
   if (allocated(error)) return
end subroutine records_to_table


!> Serialize records to a table by iterating over all entries
subroutine record_to_table(record, table, error)
   !> List of all element records
   type(element_mask), intent(in) :: record
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: i, nsh
   type(toml_array), pointer :: array

   nsh = size(record%levels)

   call add_array(table, "levels", array)
   do i = 1, nsh
      call set_value(array, i, record%levels(i))
   end do

   call add_array(table, "slater", array)
   do i = 1, nsh
      call set_value(array, i, record%slater(i))
   end do

   call add_array(table, "shpoly", array)
   do i = 1, nsh
      call set_value(array, i, record%shpoly(i))
   end do

   call add_array(table, "kcn", array)
   do i = 1, nsh
      call set_value(array, i, record%kcn(i))
   end do

   call set_value(table, "gam", record%gam)
   call add_array(table, "lgam", array)
   do i = 1, nsh
      call set_value(array, i, record%lgam(i))
   end do

   call set_value(table, "gam3", record%gam3)

   call set_value(table, "zeff", record%zeff)
   call set_value(table, "arep", record%alpha)
   call set_value(table, "xbond", record%xbond)

   call set_value(table, "dkernel", record%dkernel)
   call set_value(table, "qkernel", record%qkernel)
end subroutine record_to_table


elemental function count_mask(mask) result(ncount)
   type(param_mask), intent(in) :: mask
   integer :: ncount
   ncount = 0
   if (allocated(mask%hamiltonian)) ncount = ncount + count(mask%hamiltonian)
   if (allocated(mask%dispersion)) ncount = ncount + count(mask%dispersion)
   if (allocated(mask%repulsion)) ncount = ncount + count(mask%repulsion)
   if (allocated(mask%halogen)) ncount = ncount + count(mask%halogen)
   if (allocated(mask%charge)) ncount = ncount + count(mask%charge)
   if (allocated(mask%multipole)) ncount = ncount + count(mask%multipole)
   if (allocated(mask%thirdorder)) ncount = ncount + count(mask%thirdorder)
   if (allocated(mask%record)) ncount = ncount + sum(count(mask%record))
end function count_mask


end module tblite_param_mask

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_write_qchem
   use mctc_env_accuracy, only : wp
   use mctc_io_convert, only : autoaa
   use mctc_io_structure, only : structure_type
   implicit none
   private

   public :: write_qchem

contains

subroutine write_qchem(self, unit)

   !> Instance of the molecular structure data
   class(structure_type), intent(in) :: self

   !> File handle
   integer, intent(in) :: unit

   integer :: iat
   logical :: expo

   write(unit, '(a)') "$molecule"
   write(unit, '(*(1x, i0))') nint(self%charge), self%uhf + 1

   expo = maxval(self%xyz) > 1.0e+5 .or. minval(self%xyz) < -1.0e+5
   if (expo) then
      do iat = 1, self%nat
         write(unit, '(a, 1x, 3es24.14)') &
           self%sym(self%id(iat)), self%xyz(:, iat) * autoaa
      end do
   else
      do iat = 1, self%nat
         write(unit, '(a, 1x, 3f24.14)') &
           self%sym(self%id(iat)), self%xyz(:, iat) * autoaa
      end do
   end if

   write(unit, '(a)') "$end"

end subroutine write_qchem
   
end module mctc_io_write_qchem

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file src/ddx_operators.f90
!! Operators of ddX software
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-02-25

!> Operators shared among ddX methods
module ddx_operators
! Get the solver-module
use ddx_solvers
! Get lpb core-module
use ddx_lpb_core
! Get gradient module
use ddx_gradients
implicit none

contains

!> Single layer operator matvec
subroutine lx(params, constants, workspace, x, y, ddx_error)
    implicit none
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    !! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    !! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Local variables
    integer :: isph, jsph, ij, l, ind, iproc

    ! dummy operation on unused interface arguments
    if (ddx_error % flag .eq. 0) continue

    !! Initialize
    y = zero
!
!   incore code:
!
    if (params % matvecmem .eq. 1) then
        !$omp parallel do default(none) shared(params,constants,x,y) &
        !$omp private(isph,ij,jsph) schedule(dynamic)
        do isph = 1, params % nsph
            do ij = constants % inl(isph), constants % inl(isph + 1) - 1
                jsph = constants % nl(ij)
                call dgemv('n', constants % nbasis, constants % nbasis, one, &
                    & constants % l(:,:,ij), constants % nbasis, x(:,jsph), 1, &
                    & one, y(:,isph), 1)
            end do
        end do
    else
        !$omp parallel do default(none) shared(params,constants,workspace,x,y) &
        !$omp private(isph,iproc) schedule(dynamic)
        do isph = 1, params % nsph
            iproc = omp_get_thread_num() + 1
            ! Compute NEGATIVE action of off-digonal blocks
            call calcv(params, constants, isph, workspace % tmp_pot(:, iproc), x, &
                & workspace % tmp_work(:, iproc))
            call ddintegrate(1, constants % nbasis, params % ngrid, &
                & constants % vwgrid, constants % vgrid_nbasis, &
                & workspace % tmp_pot(:, iproc), y(:, isph))
            ! now, fix the sign.
            y(:, isph) = - y(:, isph)
        end do
    end if
!
!   if required, add the diagonal.
!
    if (constants % dodiag) then 
        do isph = 1, params % nsph
            do l = 0, params % lmax
                ind = l*l + l + 1
                y(ind-l:ind+l, isph) = y(ind-l:ind+l, isph) + &
                     x(ind-l:ind+l, isph) / (constants % vscales(ind)**2)
            end do
        end do
    end if
end subroutine lx

!> Adjoint single layer operator matvec 
subroutine lstarx(params, constants, workspace, x, y, ddx_error)
    implicit none
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    !! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    !! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Local variables
    integer :: isph, jsph, ij, indmat, igrid, l, ind, iproc

    ! dummy operation on unused interface arguments
    if (ddx_error % flag .eq. 0) continue

    y = zero
    if (params % matvecmem .eq. 1) then
        !$omp parallel do default(none) shared(params,constants,x,y) &
        !$omp private(isph,ij,jsph,indmat) schedule(dynamic)
        do isph = 1, params % nsph
            do ij = constants % inl(isph), constants % inl(isph + 1) - 1
                jsph = constants % nl(ij)
                indmat = constants % itrnl(ij)
                call dgemv('t', constants % nbasis, constants % nbasis, one, &
                    & constants % l(:,:,indmat), constants % nbasis, x(:,jsph), 1, &
                    & one, y(:,isph), 1)
            end do
        end do
    else
        ! Expand x over spherical harmonics
        !$omp parallel do default(none) shared(params,constants,workspace,x) &
        !$omp private(isph,igrid) schedule(dynamic)
        do isph = 1, params % nsph
            do igrid = 1, params % ngrid
                workspace % tmp_grid(igrid, isph) = dot_product(x(:, isph), &
                    & constants % vgrid(:constants % nbasis, igrid))
            end do
        end do
        ! Compute (negative) action
        !$omp parallel do default(none) shared(params,constants,workspace,x,y) &
        !$omp private(isph,iproc) schedule(dynamic)
        do isph = 1, params % nsph
            iproc = omp_get_thread_num() + 1
            call adjrhs(params, constants, isph, workspace % tmp_grid, &
                & y(:, isph), workspace % tmp_work(:, iproc))
            ! fix the sign
            y(:, isph) = - y(:, isph)
        end do
    end if
    if (constants % dodiag) then
    ! Loop over harmonics
        do isph = 1, params % nsph
            do l = 0, params % lmax
                ind = l*l + l + 1
                y(ind-l:ind+l, isph) = y(ind-l:ind+l, isph) + &
                    & x(ind-l:ind+l, isph) / (constants % vscales(ind)**2)
            end do
        end do
    end if
end subroutine lstarx

!> Diagonal preconditioning for Lx operator
!!
!! Applies inverse diagonal (block) of the L matrix
subroutine ldm1x(params, constants, workspace, x, y, ddx_error)
    implicit none
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    !! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    !! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Local variables
    integer :: isph, l, ind

    ! dummy operation on unused interface arguments
    if ((ddx_error % flag .eq. 0) .or. &
   &    (allocated(workspace % tmp_pot))) continue

    !! Loop over harmonics
    !$omp parallel do default(none) shared(params,constants,x,y) &
    !$omp private(isph,l,ind) schedule(dynamic)
    do isph = 1, params % nsph
        do l = 0, params % lmax
            ind = l*l + l + 1
            y(ind-l:ind+l, isph) = x(ind-l:ind+l, isph) &
                & *(constants % vscales(ind)**2)
        end do
    end do
end subroutine ldm1x

!> Double layer operator matvec without diagonal blocks
subroutine dx(params, constants, workspace, x, y, ddx_error)
    implicit none
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    !! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Local parameter
    integer :: do_diag
    !! initialize do_diag
    do_diag = 0
    if (constants % dodiag) do_diag = 1
    !! Select implementation
    if (params % fmm .eq. 0) then
        call dx_dense(params, constants, workspace, do_diag, x, y, ddx_error)
    else
        call dx_fmm(params, constants, workspace, do_diag, x, y, ddx_error)
    end if
end subroutine dx

!> Baseline implementation of double layer operator
subroutine dx_dense(params, constants, workspace, do_diag, x, y, ddx_error)
    implicit none
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    integer, intent(in) :: do_diag
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    !! Local variables
    real(dp) :: c(3), vij(3), sij(3)
    real(dp) :: vvij, tij, tt, f, rho, ctheta, stheta, cphi, sphi
    integer :: its, isph, jsph, l, m, ind
    real(dp), external :: dnrm2

    ! dummy operation on unused interface arguments
    if (ddx_error % flag .eq. 0) continue

    y = zero
    do isph = 1, params % nsph
        ! compute the "potential" from the other spheres
        ! at the exposed lebedv points of the i-th sphere 
        workspace % tmp_grid(:, 1) = zero
        do its = 1, params % ngrid
            if (constants % ui(its,isph).gt.zero) then
                c = params % csph(:,isph) + params % rsph(isph)* &
                    & constants % cgrid(:,its)
                do jsph = 1, params % nsph
                    if (jsph.ne.isph) then
                        ! build the geometrical variables
                        vij = c - params % csph(:,jsph)
                        !vvij = sqrt(dot_product(vij,vij))
                        vvij = dnrm2(3, vij, 1)
                        tij = vvij / params % rsph(jsph)
                        sij = vij/vvij 
                        ! build the local basis
                        call ylmbas(sij, rho, ctheta, stheta, cphi, sphi, &
                            & params % lmax, constants % vscales, &
                            & workspace % tmp_vylm, workspace % tmp_vplm, &
                            & workspace % tmp_vcos, workspace % tmp_vsin)
                        ! with all the required stuff, finally compute
                        ! the "potential" at the point
                        tt = one/tij 
                        do l = 0, params % lmax
                            ind = l*l + l + 1
                            f = fourpi*dble(l)/(two*dble(l) + one)*tt
                            do m = -l, l
                                workspace % tmp_grid(its, 1) = &
                                    & workspace % tmp_grid(its, 1) + &
                                    & f*x(ind + m,jsph) * &
                                    & workspace % tmp_vylm(ind + m, 1)
                            end do
                            tt = tt/tij
                        end do
                    else if (do_diag .eq. 1) then
                        ! add the diagonal contribution
                        do l = 0, params % lmax
                            ind = l*l + l + 1
                            f = (two*dble(l) + one)/fourpi
                            do m = -l, l
                                workspace % tmp_grid(its, 1) = &
                                    & workspace % tmp_grid(its, 1) - &
                                    & pt5*x(ind + m,isph) * &
                                    & constants % vgrid(ind + m,its)/f
                            end do
                        end do
                    end if 
                end do
                workspace % tmp_grid(its, 1) = constants % ui(its, isph) * &
                    & workspace % tmp_grid(its, 1)
            end if
        end do
        ! now integrate the potential to get its modal representation
        call ddintegrate(1, constants % nbasis, params % ngrid, &
            & constants % vwgrid, constants % vgrid_nbasis, &
            & workspace % tmp_grid, y(:,isph))
    end do
end subroutine dx_dense

!> FMM-accelerated implementation of double layer operator
subroutine dx_fmm(params, constants, workspace, do_diag, x, y, ddx_error)
    implicit none
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    integer, intent(in) :: do_diag
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    !! Local variables
    integer :: isph, inode, l, indl, indl1

    ! dummy operation on unused interface arguments
    if (ddx_error % flag .eq. 0) continue

    !! Scale input harmonics at first
    workspace % tmp_sph(1, :) = zero
    indl = 2
    do l = 1, params % lmax
        indl1 = (l+1)**2
        workspace % tmp_sph(indl:indl1, :) = l * x(indl:indl1, :)
        indl = indl1 + 1
    end do
    ! Load input harmonics into tree data
    if(params % lmax .lt. params % pm) then
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            workspace % tmp_node_m(1:constants % nbasis, inode) = &
                & workspace % tmp_sph(:, isph)
            workspace % tmp_node_m(constants % nbasis+1:, inode) = zero
        end do
    else
        indl = (params % pm+1)**2
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            workspace % tmp_node_m(:, inode) = workspace % tmp_sph(:indl, isph)
        end do
    end if
    ! Do FMM operations
    call tree_m2m_rotation(params, constants, workspace % tmp_node_m)
    call tree_m2l_rotation(params, constants, workspace % tmp_node_m, &
        & workspace % tmp_node_l)
    call tree_l2l_rotation(params, constants, workspace % tmp_node_l)
    call tree_l2p(params, constants, one, workspace % tmp_node_l, zero, &
        & workspace % tmp_grid, workspace % tmp_sph_l)
    call tree_m2p(params, constants, params % lmax, one, workspace % tmp_sph, one, &
        & workspace % tmp_grid)
    ! Apply diagonal contribution if needed
    if(do_diag .eq. 1) then
        call dgemm('T', 'N', params % ngrid, params % nsph, &
            & constants % nbasis, -pt5, constants % vgrid2, &
            & constants % vgrid_nbasis, x, constants % nbasis, one, &
            & workspace % tmp_grid, params % ngrid)
    end if
    ! Multiply by characteristic function
    workspace % tmp_grid = workspace % tmp_grid * constants % ui
    ! now integrate the potential to get its modal representation
    ! output y is overwritten here
    call dgemm('N', 'N', constants % nbasis, params % nsph, params % ngrid, &
        & one, constants % vwgrid, constants % vgrid_nbasis, workspace % tmp_grid, &
        & params % ngrid, zero, y, constants % nbasis)
end subroutine dx_fmm

!> Adjoint double layer operator matvec 
subroutine dstarx(params, constants, workspace, x, y, ddx_error)
    implicit none
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    !! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    !! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Local variables
    integer :: do_diag
    !! initialize do_diag
    do_diag = 0
    if (constants % dodiag) do_diag = 1
    !! Select implementation
    if (params % fmm .eq. 0) then
        call dstarx_dense(params, constants, workspace, do_diag, x, y, ddx_error)
    else
        call dstarx_fmm(params, constants, workspace, do_diag, x, y, ddx_error)
    end if
end subroutine dstarx

!> Baseline implementation of adjoint double layer operator
subroutine dstarx_dense(params, constants, workspace, do_diag, x, y, ddx_error)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: do_diag
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    ! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_error_type), intent(inout) :: ddx_error
    ! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    ! Local variables
    real(dp) :: vji(3), sji(3)
    real(dp) :: vvji, tji, tt, f, rho, ctheta, stheta, cphi, sphi
    integer :: its, isph, jsph, l, m, ind, iproc
    real(dp), external :: dnrm2

    ! dummy operation on unused interface arguments
    if (ddx_error % flag .eq. 0)continue

    y = zero
    !$omp parallel do default(none) shared(do_diag,params,constants, &
    !$omp workspace,x,y) private(isph,jsph,its,vji,vvji,tji,sji,rho, &
    !$omp ctheta,stheta,cphi,sphi,tt,l,ind,f,m,iproc) schedule(dynamic)
    do isph = 1, params % nsph
        iproc = omp_get_thread_num() + 1
        do jsph = 1, params % nsph
            if (jsph.ne.isph) then
                do its = 1, params % ngrid
                    if (constants % ui(its,jsph).gt.zero) then
                        ! build the geometrical variables
                        vji = params % csph(:,jsph) + params % rsph(jsph) * &
                            & constants % cgrid(:,its) - params % csph(:,isph)
                        !vvji = sqrt(dot_product(vji,vji))
                        vvji = dnrm2(3, vji, 1)
                        tji = vvji/params % rsph(isph)
                        sji = vji/vvji
                        ! build the local basis
                        call ylmbas(sji, rho, ctheta, stheta, cphi, sphi, &
                            & params % lmax, constants % vscales, &
                            & workspace % tmp_vylm(:(params % lmax + 1)**2, iproc), &
                            & workspace % tmp_vplm(:(params % lmax + 1)**2, iproc), &
                            & workspace % tmp_vcos(:(params % lmax + 1), iproc), &
                            & workspace % tmp_vsin(:(params % lmax + 1), iproc))
                        tt = constants % ui(its,jsph) &
                            & *dot_product(constants % vwgrid(:constants % nbasis, its), &
                            & x(:,jsph))/tji
                        do l = 0, params % lmax
                            ind = l*l + l + 1
                            f = dble(l)*tt/ constants % vscales(ind)**2
                            do m = -l, l
                                y(ind+m,isph) = y(ind+m,isph) + &
                                    & f*workspace % tmp_vylm(ind+m, iproc)
                            end do
                            tt = tt/tji
                        end do
                    end if
                end do
            else if (do_diag .eq. 1) then
                do its = 1, params % ngrid
                    f = pt5*constants % ui(its,jsph) &
                        & *dot_product(constants % vwgrid(:constants % nbasis, its), &
                        & x(:,jsph))
                    do l = 0, params % lmax
                        ind = l*l + l + 1
                        y(ind-l:ind+l,isph) = y(ind-l:ind+l,isph) - &
                            & f*constants % vgrid(ind-l:ind+l,its)/ &
                            & constants % vscales(ind)**2
                    end do
                end do
            end if
        end do
    end do
end subroutine dstarx_dense

!> FMM-accelerated implementation of adjoint double layer operator
subroutine dstarx_fmm(params, constants, workspace, do_diag, x, y, ddx_error)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: do_diag
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    ! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_error_type), intent(inout) :: ddx_error
    ! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    ! Local variables
    integer :: isph, inode, l, indl, indl1

    ! dummy operation on unused interface arguments
    if (ddx_error % flag .eq. 0) continue

    ! Adjoint integration
    call dgemm('T', 'N', params % ngrid, params % nsph, constants % nbasis, &
        & one, constants % vwgrid, constants % vgrid_nbasis, x, &
        & constants % nbasis, zero, workspace % tmp_grid, params % ngrid)
    ! Multiply by characteristic function
    workspace % tmp_grid = workspace % tmp_grid * constants % ui
    ! Do FMM operations adjointly
    call tree_m2p_adj(params, constants, params % lmax, one, workspace % tmp_grid, &
        & zero, y)
    call tree_l2p_adj(params, constants, one, workspace % tmp_grid, zero, &
        & workspace % tmp_node_l, workspace % tmp_sph_l)
    call tree_l2l_rotation_adj(params, constants, workspace % tmp_node_l)
    call tree_m2l_rotation_adj(params, constants, workspace % tmp_node_l, &
        & workspace % tmp_node_m)
    call tree_m2m_rotation_adj(params, constants, workspace % tmp_node_m)
    ! Adjointly move tree multipole harmonics into output
    if(params % lmax .lt. params % pm) then
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            y(:, isph) = y(:, isph) + &
                & workspace % tmp_node_m(1:constants % nbasis, inode)
        end do
    else
        indl = (params % pm+1)**2
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            y(1:indl, isph) = y(1:indl, isph) + workspace % tmp_node_m(:, inode)
        end do
    end if
    ! Scale output harmonics at last
    y(1, :) = zero
    indl = 2
    do l = 1, params % lmax
        indl1 = (l+1)**2
        y(indl:indl1, :) = l * y(indl:indl1, :)
        indl = indl1 + 1
    end do
    ! Apply diagonal contribution if needed
    if(do_diag .eq. 1) then
        call dgemm('N', 'N', constants % nbasis, params % nsph, &
            & params % ngrid, -pt5, constants % vgrid2, &
            & constants % vgrid_nbasis, workspace % tmp_grid, params % ngrid, &
            & one, y, constants % nbasis)
    end if
end subroutine dstarx_fmm

!> Apply \f$ R_\varepsilon \f$ operator to spherical harmonics
!!
!! Compute \f$ y = R_\varepsilon x = (2\pi(\varepsilon + 1) / (\varepsilon
!! - 1) - D) x \f$.
subroutine repsx(params, constants, workspace, x, y, ddx_error)
    implicit none
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    !! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    !! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Local variables
    real(dp) :: fac
    !! Output `y` is cleaned here
    call dx(params, constants, workspace, x, y, ddx_error)
    y = - y
    if (constants % dodiag) then
    ! Apply diagonal
        fac = twopi * (params % eps + one) / (params % eps - one)
        y = fac*x + y
    end if
end subroutine repsx

!> Apply \f$ R_\varepsilon^* \f$ operator to spherical harmonics
!!
!! Compute \f$ y = R^*_\varepsilon x = (2\pi(\varepsilon + 1) / (\varepsilon
!! - 1) - D) x \f$.
!!
subroutine repsstarx(params, constants, workspace, x, y, ddx_error)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    ! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    ! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    ! Local variables
    real(dp) :: fac
    ! Output `y` is cleaned here
    call dstarx(params, constants, workspace, x, y, ddx_error)
    y = - y
    ! Apply diagonal
    if (constants % dodiag) then 
        fac = twopi * (params % eps + one) / (params % eps - one)
        y = fac*x + y
    end if
end subroutine repsstarx

!> Apply \f$ R_\infty \f$ operator to spherical harmonics
!!
!! Compute \f$ y = R_\infty x = (2\pi - D) x \f$.
!!
!! @param[in] ddx_data:
!! @param[in] x:
!! @param[out] y:
!! @param[inout] ddx_error: ddX ddx_error
!!
subroutine rinfx(params, constants, workspace, x, y, ddx_error)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    ! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    ! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    !! note do_diag hardcoded to 1.
    !! Select implementation
    if (params % fmm .eq. 0) then
        call dx_dense(params, constants, workspace, 1, x, y, ddx_error)
    else
        call dx_fmm(params, constants, workspace, 1, x, y, ddx_error)
    end if
    ! Apply diagonal
    y = twopi*x - y
end subroutine rinfx

!> Apply \f$ R_\infty^* \f$ operator to spherical harmonics
!!
!! Compute \f$ y = R_\infty^* x = (2\pi - D^*) x \f$.
!!
!! @param[in] ddx_data:
!! @param[in] x:
!! @param[out] y:
!! @param[inout] ddx_error: ddX ddx_error
!!
subroutine rstarinfx(params, constants, workspace, x, y, ddx_error)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    ! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    ! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    ! Output `y` is cleaned here
    call dstarx(params, constants, workspace, x, y, ddx_error)
    ! Apply diagonal
    y = twopi*x - y
end subroutine rstarinfx

!> Apply preconditioner for ddPCM primal linear system
!! @param[inout] ddx_error: ddX ddx_error
subroutine prec_repsx(params, constants, workspace, x, y, ddx_error)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    ! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    ! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    integer :: isph

    ! dummy operation on unused interface arguments
    if ((ddx_error % flag .eq. 0) .or. &
   &    (allocated(workspace % tmp_pot))) continue

    ! simply do a matrix-vector product with the transposed preconditioner 
    !$omp parallel do default(shared) schedule(static,1) &
    !$omp private(isph)
    do isph = 1, params % nsph
        call dgemm('N', 'N', constants % nbasis, 1, constants % nbasis, one, &
            & constants % rx_prc(:, :, isph), constants % nbasis, x(:, isph), &
            & constants % nbasis, zero, y(:, isph), constants % nbasis)
    end do
end subroutine prec_repsx

!> Apply preconditioner for ddPCM adjoint linear system
subroutine prec_repsstarx(params, constants, workspace, x, y, ddx_error)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    ! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    ! Output
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    ! Local variables
    integer :: isph

    ! dummy operation on unused interface arguments
    if ((ddx_error % flag .eq. 0) .or. &
   &    (allocated(workspace % tmp_pot))) continue

    ! simply do a matrix-vector product with the transposed preconditioner 
    !$omp parallel do default(shared) schedule(static,1) &
    !$omp private(isph)
    do isph = 1, params % nsph
        call dgemm('T', 'N', constants % nbasis, 1, constants % nbasis, one, &
            & constants % rx_prc(:, :, isph), constants % nbasis, x(:, isph), &
            & constants % nbasis, zero, y(:, isph), constants % nbasis)
    end do
end subroutine prec_repsstarx

!> Adjoint HSP matrix vector product
subroutine bstarx(params, constants, workspace, x, y, ddx_error)
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), intent(in) :: x(constants % nbasis, params % nsph)
    real(dp), intent(out) :: y(constants % nbasis, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    ! Local variables
    integer :: isph, jsph, ij, indmat, iproc

    ! dummy operation on unused interface arguments
    if (ddx_error % flag .eq. 0) continue

    y = zero
    if (params % matvecmem .eq. 1) then
        !$omp parallel do default(none) shared(params,constants,x,y) &
        !$omp private(isph,ij,jsph,indmat) schedule(dynamic)
        do isph = 1, params % nsph
            do ij = constants % inl(isph), constants % inl(isph + 1) - 1
                jsph = constants % nl(ij)
                indmat = constants % itrnl(ij)
                call dgemv('t', constants % nbasis, constants % nbasis, one, &
                    & constants % b(:,:,indmat), constants % nbasis, x(:,jsph), 1, &
                    & one, y(:,isph), 1)
            end do
        end do
    else
        !$omp parallel do default(none) shared(params,constants,workspace,x,y) &
        !$omp private(isph) schedule(static,1)
        do isph = 1, params % nsph
            call dgemv('t', constants % nbasis, params % ngrid, one, constants % vgrid, &
                & constants % vgrid_nbasis, x(:, isph), 1, zero, &
                & workspace % tmp_grid(:, isph), 1)
        end do
        !$omp parallel do default(none) shared(params,constants,workspace,x,y) &
        !$omp private(isph,iproc) schedule(dynamic)
        do isph = 1, params % nsph
            iproc = omp_get_thread_num() + 1
            call adjrhs_lpb(params, constants, isph, workspace % tmp_grid, &
                & y(:, isph), workspace % tmp_vylm(:, iproc), workspace % tmp_vplm(:, iproc), &
                & workspace % tmp_vcos(:, iproc), workspace % tmp_vsin(:, iproc), &
                & workspace % tmp_bessel(:, iproc))
            y(:,isph)  = - y(:,isph)
        end do
    end if

    ! add the diagonal if required
    if (constants % dodiag) y = y + x
end subroutine bstarx

!> Primal HSP matrix vector product
subroutine bx(params, constants, workspace, x, y, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: x
    real(dp), dimension(constants % nbasis, params % nsph), intent(out) :: y
    type(ddx_error_type), intent(inout) :: ddx_error
    integer :: isph, jsph, ij, iproc

    ! dummy operation on unused interface arguments
    if (ddx_error % flag .eq. 0) continue

    y = zero
    if (params % matvecmem .eq. 1) then
        !$omp parallel do default(none) shared(params,constants,x,y) &
        !$omp private(isph,ij,jsph) schedule(dynamic)
        do isph = 1, params % nsph
            do ij = constants % inl(isph), constants % inl(isph + 1) - 1
                jsph = constants % nl(ij)
                call dgemv('n', constants % nbasis, constants % nbasis, one, &
                    & constants % b(:,:,ij), constants % nbasis, x(:,jsph), 1, &
                    & one, y(:,isph), 1)
            end do
        end do
    else 
        !$omp parallel do default(none) shared(params,constants,workspace,x,y) &
        !$omp private(isph,iproc) schedule(dynamic)
        do isph = 1, params % nsph
          iproc = omp_get_thread_num() + 1
          call calcv2_lpb(params, constants, isph, workspace % tmp_pot(:, iproc), x)
          call ddintegrate(1, constants % nbasis, params % ngrid, constants % vwgrid, &
              & constants % vgrid_nbasis, workspace % tmp_pot(:, iproc), y(:,isph))
          y(:,isph) = - y(:,isph) 
        end do
    end if
    if (constants % dodiag) y = y + x
end subroutine bx

!> Adjoint ddLPB matrix-vector product
subroutine tstarx(params, constants, workspace, x, y, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), dimension(constants % nbasis, params % nsph, 2), intent(in) :: x
    real(dp), dimension(constants % nbasis, params % nsph, 2), intent(out) :: y
    type(ddx_error_type), intent(inout) :: ddx_error

    real(dp), dimension(constants % nbasis, params % nsph, 2) :: temp_vector
    y = zero
    temp_vector = zero

    ! Compute AXr
    ! call LstarXr
    call lstarx(params, constants, workspace, x(:,:,1), temp_vector(:,:,1), &
        & ddx_error)
    ! Remove the scaling factor
    call convert_ddcosmo(params, constants, 1, temp_vector(:,:,1))
    y(:,:,1) = y(:,:,1) + temp_vector(:,:,1)
    ! Compute BXe
    call bstarx(params, constants, workspace, x(:,:,2), temp_vector(:,:,2), &
        & ddx_error)
    y(:,:,2) = y(:,:,2) + temp_vector(:,:,2)

    ! Reset temp_vector to zero
    temp_vector = zero
    ! Call CX
    call cstarx(params, constants, workspace, x, temp_vector, ddx_error)
    y = y + temp_vector
end subroutine tstarx

!> Apply the preconditioner to the primal HSP linear system
!! @param[inout] ddx_error: ddX ddx_error
subroutine bx_prec(params, constants, workspace, x, y, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: x
    real(dp), dimension(constants % nbasis, params % nsph), intent(out) :: y
    type(ddx_error_type), intent(inout) :: ddx_error

    ! dummy operation on unused interface arguments
    if ((ddx_error % flag .eq. 0) .or. &
   &    (allocated(workspace % tmp_pot))) continue

    y = x
end subroutine bx_prec

!> Apply the preconditioner to the ddLPB adjoint linear system
subroutine prec_tstarx(params, constants, workspace, x, y, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), intent(in) :: x(constants % nbasis, params % nsph, 2)
    real(dp), intent(inout) :: y(constants % nbasis, params % nsph, 2)
    type(ddx_error_type), intent(inout) :: ddx_error
    integer :: n_iter
    real(dp), dimension(params % maxiter) :: x_rel_diff
    real(dp) :: start_time

    start_time = omp_get_wtime()
    y(:,:,1) = x(:,:,1)
    call convert_ddcosmo(params, constants, 1, y(:,:,1))
    n_iter = params % maxiter
    call jacobi_diis(params, constants, workspace, constants % inner_tol, &
        & y(:,:,1), workspace % ddcosmo_adj_guess, n_iter, x_rel_diff, lstarx, &
        & ldm1x, hnorm, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, 'prec_tstarx: ddCOSMO failed to ' // &
            & 'converge, exiting')
        return
    end if
    y(:,:,1) = workspace % ddcosmo_adj_guess
    workspace % s_time = workspace % s_time + omp_get_wtime() - start_time

    start_time = omp_get_wtime()
    n_iter = params % maxiter
    call jacobi_diis(params, constants, workspace, constants % inner_tol, &
        & x(:,:,2), workspace % hsp_adj_guess, n_iter, x_rel_diff, bstarx, &
        & bx_prec, hnorm, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, 'prec_tstarx: HSP failed to ' // &
            & 'converge, exiting')
        return
    end if
    y(:,:,2) = workspace % hsp_adj_guess
    workspace % hsp_adj_time = workspace % hsp_adj_time &
        & + omp_get_wtime() - start_time

end subroutine prec_tstarx

!> Apply the preconditioner to the primal ddLPB linear system
!! |Yr| = |A^-1 0 |*|Xr|
!! |Ye|   |0 B^-1 | |Xe|
!! @param[in] ddx_data : dd Data
!! @param[in] x        : Input array
!! @param[out] y       : Linear system solution at current iteration
!! @param[inout] ddx_error: ddX ddx_error
subroutine prec_tx(params, constants, workspace, x, y, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), intent(in) :: x(constants % nbasis, params % nsph, 2)
    real(dp), intent(inout) :: y(constants % nbasis, params % nsph, 2)
    type(ddx_error_type), intent(inout) :: ddx_error
    integer :: n_iter
    real(dp), dimension(params % maxiter) :: x_rel_diff
    real(dp) :: start_time

    ! perform A^-1 * Yr
    start_time = omp_get_wtime()
    n_iter = params % maxiter
    call jacobi_diis(params, constants, workspace, constants % inner_tol, &
        & x(:,:,1), workspace % ddcosmo_guess, n_iter, x_rel_diff, lx, &
        & ldm1x, hnorm, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, 'prec_tx: ddCOSMO failed to ' // &
            & 'converge, exiting')
        return
    end if

    ! Scale by the factor of (2l+1)/4Pi
    y(:,:,1) = workspace % ddcosmo_guess
    call convert_ddcosmo(params, constants, 1, y(:,:,1))
    workspace % xs_time = workspace % xs_time + omp_get_wtime() - start_time

    ! perform B^-1 * Ye
    start_time = omp_get_wtime()
    n_iter = params % maxiter
    call jacobi_diis(params, constants, workspace, constants % inner_tol, &
        & x(:,:,2), workspace % hsp_guess, n_iter, x_rel_diff, bx, &
        & bx_prec, hnorm, ddx_error)
    y(:,:,2) = workspace % hsp_guess
    workspace % hsp_time = workspace % hsp_time + omp_get_wtime() - start_time

    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, 'prec_tx: HSP failed to ' // &
            & 'converge, exiting')
        return
    end if

end subroutine prec_tx

!> ddLPB adjoint matrix-vector product
subroutine cstarx(params, constants, workspace, x, y, ddx_error)
    implicit none
    ! input/output
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), dimension(constants % nbasis, params % nsph, 2), intent(in) :: x
    real(dp), dimension(constants % nbasis, params % nsph, 2), intent(out) :: y
    type(ddx_error_type), intent(inout) :: ddx_error
    ! local
    complex(dp) :: work_complex(constants % lmax0+1)
    real(dp) :: work(constants % lmax0+1)
    integer :: isph, igrid, jsph, ind, l0, ind0, indl, inode, l, m
    real(dp), dimension(3) :: vij, vtij
    real(dp) :: val, epsilon_ratio
    real(dp), allocatable :: scratch(:,:), scratch0(:,:)

    ! dummy operation on unused interface arguments
    if (ddx_error % flag .eq. 0) continue

    allocate(scratch(constants % nbasis, params % nsph), &
        & scratch0(constants % nbasis0, params % nsph))

    epsilon_ratio = params % epsp/params % eps

    ! TODO: maybe use ddeval_grid for code consistency
    scratch = - x(:,:,1) - x(:,:,2)
    call dgemm('T', 'N', params % ngrid, params % nsph, constants % nbasis, &
        & one, constants % vwgrid, constants % vgrid_nbasis, scratch, &
        & constants % nbasis, zero, workspace % tmp_grid, params % ngrid)

    scratch0 = zero
    if (params % fmm .eq. 0) then
        do isph = 1, params % nsph
            do igrid = 1, params % ngrid
                if (constants % ui(igrid, isph).gt.zero) then
                    val = workspace % tmp_grid(igrid,isph) &
                        & *constants % ui(igrid,isph)
                    ! quadratically scaling loop
                    do jsph = 1, params % nsph
                        vij  = params % csph(:,isph) + &
                            & params % rsph(isph)*constants % cgrid(:,igrid) - &
                            & params % csph(:,jsph)
                        vtij = vij * params % kappa
                        call fmm_m2p_bessel_adj_work(vtij, val, &
                            & constants % SK_ri(:, jsph), constants % lmax0, &
                            & constants % vscales, one, scratch0(:, jsph), &
                            & work_complex, work)
                    end do
                end if
            end do
        end do
    else
        ! Multiply by characteristic function
        workspace % tmp_grid = workspace % tmp_grid * constants % ui
        workspace % tmp_sph = zero
        ! Do FMM operations adjointly
        call tree_m2p_bessel_adj(params, constants, constants % lmax0, &
            & one, workspace % tmp_grid, zero, params % lmax, &
            & workspace % tmp_sph)
        call tree_l2p_bessel_adj(params, constants, one, &
            & workspace % tmp_grid, zero, workspace % tmp_node_l)
        call tree_l2l_bessel_rotation_adj(params, constants, &
            & workspace % tmp_node_l)
        call tree_m2l_bessel_rotation_adj(params, constants, &
            & workspace % tmp_node_l, workspace % tmp_node_m)
        call tree_m2m_bessel_rotation_adj(params, constants, &
            & workspace % tmp_node_m)
        ! Adjointly move tree multipole harmonics into output
        if(constants % lmax0 .lt. params % pm) then
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                scratch0(:, isph) = workspace % tmp_sph(1:constants % nbasis0, isph) + &
                    & workspace % tmp_node_m(1:constants % nbasis0, inode)
            end do
        else
            indl = (params % pm+1)**2
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                scratch0(1:indl, isph) = &
                    & workspace % tmp_sph(1:indl, isph) + &
                    & workspace % tmp_node_m(:, inode)
                scratch0(indl+1:, isph) = zero
            end do
        end if
    end if
    ! Scale by C_ik
    do isph = 1, params % nsph
        do l0 = 0, constants % lmax0
            ind0 = l0*l0 + l0 + 1
            scratch0(ind0-l0:ind0+l0, isph) = scratch0(ind0-l0:ind0+l0, isph) * &
                & constants % C_ik(l0, isph)
        end do
    end do

    do jsph = 1, params % nsph
        call dgemv('n', constants % nbasis, constants % nbasis0, one, &
            & constants % pchi(1,1,jsph), constants % nbasis, &
            & scratch0(1,jsph), 1, zero, scratch(1,jsph), 1)
    end do

    do isph = 1, params % nsph
        do l = 0, params % lmax
            do m = -l, l
                ind = l**2 + l + m + 1
                y(ind,isph,1) = - (epsilon_ratio*l*scratch(ind,isph)) &
                    & /params % rsph(isph)
                y(ind,isph,2) = constants % termimat(l,isph)*scratch(ind,isph)
          end do
        end do
    end do

end subroutine cstarx

!> ddLPB matrix-vector product
subroutine cx(params, constants, workspace, x, y, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), dimension(constants % nbasis, params % nsph, 2), intent(in) :: x
    real(dp), dimension(constants % nbasis, params % nsph, 2), intent(out) :: y
    type(ddx_error_type), intent(inout) :: ddx_error

    integer :: isph, jsph, igrid, ind, l, m, ind0
    real(dp), dimension(3) :: vij, vtij
    real(dp) :: val
    complex(dp) :: work_complex(constants % lmax0 + 1)
    real(dp) :: work(constants % lmax0 + 1)
    integer :: indl, inode, info

    real(dp), allocatable :: diff_re(:,:), diff0(:,:)

    allocate(diff_re(constants % nbasis, params % nsph), &
        & diff0(constants % nbasis0, params % nsph), stat=info)
    if (info.ne.0) then
        call update_error(ddx_error, "Allocation failed in cx")
        return
    end if

    ! diff_re = params % epsp/eps*l1/ri*Xr - i'(ri)/i(ri)*Xe,
    diff_re = zero
    !$omp parallel do default(none) shared(params,diff_re, &
    !$omp constants,x) private(jsph,l,m,ind)
    do jsph = 1, params % nsph
      do l = 0, params % lmax
        do m = -l,l
          ind = l**2 + l + m + 1
          diff_re(ind,jsph) = (params % epsp/params % eps)* &
              & (l/params % rsph(jsph))*x(ind,jsph,1) &
              & - constants % termimat(l,jsph)*x(ind,jsph,2)
        end do
      end do
    end do

    ! diff0 = Pchi * diff_er, linear scaling
    !$omp parallel do default(none) shared(constants,params, &
    !$omp diff_re,diff0) private(jsph)
    do jsph = 1, params % nsph
      call dgemv('t', constants % nbasis, constants % nbasis0, one, &
          & constants % pchi(1,1,jsph), constants % nbasis, &
          & diff_re(1,jsph), 1, zero, diff0(1,jsph), 1)
    end do

    ! Multiply diff0 by C_ik inplace
    do isph = 1, params % nsph
        do l = 0, constants % lmax0
            ind0 = l*l+l+1
            diff0(ind0-l:ind0+l, isph) = diff0(ind0-l:ind0+l, isph) * &
                & constants % C_ik(l, isph)
        end do
    end do
    ! avoiding N^2 storage, this code does not use the cached coefY
    y(:,:,1) = zero
    if (params % fmm .eq. 0) then
        !$omp parallel do default(none) shared(params,constants, &
        !$omp diff0,y) private(isph,igrid,val,vij,work, &
        !$omp ind0,ind,vtij,work_complex)
        do isph = 1, params % nsph
            do igrid = 1, params % ngrid
                if (constants % ui(igrid,isph).gt.zero) then
                    val = zero

                    ! quadratically scaling loop
                    do jsph = 1, params % nsph
                        vij  = params % csph(:,isph) + &
                            & params % rsph(isph)*constants % cgrid(:,igrid) - &
                            & params % csph(:,jsph)
                        vtij = vij * params % kappa
                        call fmm_m2p_bessel_work(vtij, constants % lmax0, &
                            & constants % vscales, constants % SK_ri(:, jsph), &
                            & one, diff0(:, jsph), one, val, work_complex, work)
                    end do
                    do ind = 1, constants % nbasis
                        y(ind,isph,1) = y(ind,isph,1) + val*&
                          & constants % ui(igrid,isph)*&
                          & constants % vwgrid(ind,igrid)
                    end do
                end if
            end do
        end do
    else
        ! Load input harmonics into tree data
        workspace % tmp_node_m = zero
        workspace % tmp_node_l = zero
        workspace % tmp_sph = zero
        do isph = 1, params % nsph
            do l = 0, constants % lmax0
                ind0 = l*l+l+1
                workspace % tmp_sph(ind0-l:ind0+l, isph) = &
                    & diff0(ind0-l:ind0+l, isph)
            end do
        end do
        if(constants % lmax0 .lt. params % pm) then
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_node_m(1:constants % nbasis0, inode) = &
                    & workspace % tmp_sph(1:constants % nbasis0, isph)
                workspace % tmp_node_m(constants % nbasis0+1:, inode) = zero
            end do
        else
            indl = (params % pm+1)**2
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_node_m(:, inode) = workspace % tmp_sph(1:indl, isph)
            end do
        end if
        ! Do FMM operations
        call tree_m2m_bessel_rotation(params, constants, workspace % tmp_node_m)
        call tree_m2l_bessel_rotation(params, constants, workspace % tmp_node_m, &
            & workspace % tmp_node_l)
        call tree_l2l_bessel_rotation(params, constants, workspace % tmp_node_l)
        workspace % tmp_grid = zero
        call tree_l2p_bessel(params, constants, one, workspace % tmp_node_l, zero, &
            & workspace % tmp_grid)
        call tree_m2p_bessel(params, constants, constants % lmax0, one, &
            & params % lmax, workspace % tmp_sph, one, &
            & workspace % tmp_grid)

        do isph = 1, params % nsph
            do igrid = 1, params % ngrid
                do ind = 1, constants % nbasis
                    y(ind,isph,1) = y(ind,isph,1) + workspace % tmp_grid(igrid, isph)*&
                        & constants % vwgrid(ind, igrid)*&
                        & constants % ui(igrid,isph)
                end do
            end do
        end do
    end if

    y(:,:,2) = y(:,:,1)

    deallocate(diff_re, diff0, stat=info)
    if (info.ne.0) then
        call update_error(ddx_error, "Deallocation failed in cx")
        return
    end if

end subroutine cx

end module ddx_operators

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Check for consistency of the various version strings around
program tftest_version
   use, intrinsic :: iso_fortran_env, only : output_unit, error_unit
   use tomlf
   implicit none
   integer :: length, major, minor, patch
   logical :: match
   character(len=:), allocatable :: argument, version_string

   call get_tomlf_version(major, minor, patch, string=version_string)
   if (command_argument_count() == 1) then
      call get_command_argument(1, length=length)
      allocate(character(len=length) :: argument)
      call get_command_argument(1, argument)
      match = argument == version_string
      write(version_string, '(*(i0:, "."))') major, minor, patch
      match = argument == version_string .and. match
      if (.not.match) then
         write(error_unit, '(a)') &
            & "Internal version and provided version do not match!"
         write(error_unit, '(a, ":", 1x, a)') &
            & "provided", argument, "internal", version_string
         error stop
      end if
   else
      write(output_unit, '(a)') version_string
   end if

end program tftest_version

program tester
  use tblite_version, only : get_tblite_version
  implicit none
  character(len=:), allocatable :: version
  call get_tblite_version(string=version)
  print *, version
end program tester

program fpm_wrapper_standalone
implicit none
integer :: i, status, failed
integer, parameter :: ncommands = 8
character(len=1000) :: commands(ncommands)
character(len=8) :: status_string
integer :: results(ncommands)

commands = [character(len=1000) :: &
    "./tests/standalone_tests/run_test.py cosmo --fpm", &
    "./tests/standalone_tests/run_test.py cosmo_fmm --fpm", &
    "./tests/standalone_tests/run_test.py cosmo_incore --fpm", &
    "./tests/standalone_tests/run_test.py pcm --fpm", &
    "./tests/standalone_tests/run_test.py pcm_fmm --fpm", &
    "./tests/standalone_tests/run_test.py pcm_incore --fpm", &
    "./tests/standalone_tests/run_test.py lpb --fpm", &
    "./tests/standalone_tests/run_test.py lpb_fmm --fpm"]


results(:) = 0
do i = 1, ncommands
    call system(commands(i), status)
    if (status.ne.0) then
        results(i) = 1
    end if
end do

failed = sum(results)

write(6,"(A)") "OVERVIEW:"
write(6,"(A,I0,A,I0,A)") "Results: ", ncommands - failed, "/", ncommands, " passed"
do i = 1, ncommands
    if (results(i).eq.0) then
        status_string = "SUCCESS:"
    else
        status_string = "FAILURE:"
    end if
    write(6,"(A,X,A)") trim(status_string), trim(commands(i))
end do

if (failed.gt.0) call exit(1)
call exit(0)

end program fpm_wrapper_standalone

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

program main_driver
   use, intrinsic :: iso_fortran_env, only : error_unit
   use mctc_env, only : error_type
   use tblite_cli, only : get_arguments, driver_config, run_config, param_config, &
      & fit_config, tagdiff_config, guess_config
   use tblite_context_type, only : context_type
   use tblite_driver, only : main
   implicit none
   class(driver_config), allocatable :: config
   type(error_type), allocatable :: error

   call get_arguments(config, error)
   if (allocated(error)) then
      write(error_unit, '(a)') error%message
      error stop
   end if

   select type(config)
   type is (fit_config)
      call main(config, error)
   type is (param_config)
      call main(config, error)
   type is (run_config)
      call main(config, error)
   type is (tagdiff_config)
      call main(config, error)
   type is (guess_config)
      call main(config, error)
   end select
   if (allocated(error)) then
      write(error_unit, '(a)') error%message
      error stop
   end if
end program main_driver

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_hdf5
   use mctc_env, only : dp, error_type, i4
   use mctc_env_testing, only : new_unittest, unittest_type, check
   use tblite_double_dictionary, only : double_dictionary_type
   use tblite_features, only : get_tblite_feature
   use tblite_io_hdf5, only : save_hdf5, load_hdf5, get_hdf5_descriptor, list_hdf5_datasets
   implicit none
   private

   public :: collect_hdf5

contains

subroutine collect_hdf5(testsuite)
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   if (get_tblite_feature("hdf5")) then
      testsuite = [ &
         new_unittest("write-hdf5-i4-r1", test_write_hdf5_i4_rank1), &
         new_unittest("write-hdf5-rdp-r1", test_write_hdf5_rdp_rank1), &
         new_unittest("write-hdf5-rdp-r2", test_write_hdf5_rdp_rank2), &
         new_unittest("write-hdf5-rdp-r3", test_write_hdf5_rdp_rank3), &
         new_unittest("write-hdf5-multi", test_write_hdf5_multi), &
         new_unittest("hdf5-descriptor", test_hdf5_descriptor), &
         new_unittest("double-dictionary-hdf5", test_double_dictionary_hdf5) &
      ]
   else
      testsuite = [new_unittest("hdf5-disabled", test_hdf5_disabled)]
   end if
end subroutine collect_hdf5

subroutine test_hdf5_disabled(error)
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call save_hdf5(".hdf5-disabled.h5", "test", [1_i4], stat, msg)
   call check(error, stat /= 0, "HDF5 write unexpectedly succeeded without HDF5 support")
   if (allocated(error)) return
   call check(error, allocated(msg), "HDF5 disabled error message was not returned")
end subroutine test_hdf5_disabled

subroutine test_write_hdf5_i4_rank1(error)
   type(error_type), allocatable, intent(out) :: error

   integer :: stat, i
   character(len=*), parameter :: filename = ".write-i4-r1.h5", varname = "test"
   integer(i4), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(72))
   input = [(2*i, i=1, size(input))]
   call save_hdf5(filename, varname, input, stat, msg)
   call check(error, stat, "Writing of HDF5 file failed", msg)
   if (allocated(error)) return

   call load_hdf5(filename, varname, output, stat, msg)
   call delete_file(filename)
   call check(error, stat, "Reading of HDF5 file failed", msg)
   if (allocated(error)) return

   call check(error, size(output), size(input))
   if (allocated(error)) return
   call check(error, all((output - input) == 0), "Precision loss when rereading array")
end subroutine test_write_hdf5_i4_rank1

subroutine test_write_hdf5_rdp_rank1(error)
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=*), parameter :: filename = ".write-rdp-r1.h5", varname = "test"
   real(dp), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(51))
   call random_number(input)
   call save_hdf5(filename, varname, input, stat, msg)
   call check(error, stat, "Writing of HDF5 file failed", msg)
   if (allocated(error)) return

   call load_hdf5(filename, varname, output, stat, msg)
   call delete_file(filename)
   call check(error, stat, "Reading of HDF5 file failed", msg)
   if (allocated(error)) return

   call check(error, size(output), size(input))
   if (allocated(error)) return
   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      & "Precision loss when rereading array")
end subroutine test_write_hdf5_rdp_rank1

subroutine test_write_hdf5_rdp_rank2(error)
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=*), parameter :: filename = ".write-rdp-r2.h5", varname = "test"
   real(dp), allocatable :: input(:, :), output(:, :)
   character(len=:), allocatable :: msg

   allocate(input(5, 13))
   call random_number(input)
   call save_hdf5(filename, varname, input, stat, msg)
   call check(error, stat, "Writing of HDF5 file failed", msg)
   if (allocated(error)) return

   call load_hdf5(filename, varname, output, stat, msg)
   call delete_file(filename)
   call check(error, stat, "Reading of HDF5 file failed", msg)
   if (allocated(error)) return

   call check(error, all(shape(output) == shape(input)), "Shape changed when rereading array")
   if (allocated(error)) return
   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      & "Precision loss when rereading array")
end subroutine test_write_hdf5_rdp_rank2

subroutine test_write_hdf5_rdp_rank3(error)
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=*), parameter :: filename = ".write-rdp-r3.h5", varname = "test"
   real(dp), allocatable :: input(:, :, :), output(:, :, :)
   character(len=:), allocatable :: msg

   allocate(input(5, 7, 3))
   call random_number(input)
   call save_hdf5(filename, varname, input, stat, msg)
   call check(error, stat, "Writing of HDF5 file failed", msg)
   if (allocated(error)) return

   call load_hdf5(filename, varname, output, stat, msg)
   call delete_file(filename)
   call check(error, stat, "Reading of HDF5 file failed", msg)
   if (allocated(error)) return

   call check(error, all(shape(output) == shape(input)), "Shape changed when rereading array")
   if (allocated(error)) return
   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      & "Precision loss when rereading array")
end subroutine test_write_hdf5_rdp_rank3

subroutine test_write_hdf5_multi(error)
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=*), parameter :: filename = ".mwrite-rdp.h5"
   real(dp), allocatable :: input1(:), input2(:, :), output1(:), output2(:, :)
   character(len=:), allocatable :: msg

   allocate(input1(12), input2(3, 5))
   call random_number(input1)
   call random_number(input2)
   call save_hdf5(filename, "array1", input1, stat, msg)
   if (stat == 0) call save_hdf5(filename, "array2", input2, stat, msg)
   call check(error, stat, "Writing of HDF5 file failed", msg)
   if (allocated(error)) return

   call load_hdf5(filename, "array1", output1, stat, msg)
   if (stat == 0) call load_hdf5(filename, "array2", output2, stat, msg)
   call delete_file(filename)
   call check(error, stat, "Reading of HDF5 file failed", msg)
   if (allocated(error)) return

   call check(error, all(abs(output1 - input1) <= epsilon(1.0_dp)), &
      & "Precision loss when rereading rank-1 array")
   if (allocated(error)) return
   call check(error, all(abs(output2 - input2) <= epsilon(1.0_dp)), &
      & "Precision loss when rereading rank-2 array")
end subroutine test_write_hdf5_multi

subroutine test_hdf5_descriptor(error)
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=*), parameter :: filename = ".descriptor.h5"
   integer, allocatable :: vshape(:)
   real(dp), allocatable :: input(:, :, :)
   character(len=:), allocatable :: msg, paths(:)

   allocate(input(4, 6, 9), source=0.0_dp)
   call save_hdf5(filename, "tblite0_test", input, stat, msg)
   call check(error, stat, "Writing of HDF5 file failed", msg)
   if (allocated(error)) return

   call get_hdf5_descriptor(filename, "tblite0_test", vshape, stat, msg)
   call check(error, stat, "Reading HDF5 descriptor failed", msg)
   if (allocated(error)) return
   call check(error, all(vshape == shape(input)), "Descriptor shape does not match array shape")
   if (allocated(error)) return

   call list_hdf5_datasets(filename, paths, stat, msg)
   call delete_file(filename)
   call check(error, stat, "Listing HDF5 datasets failed", msg)
   if (allocated(error)) return
   call check(error, size(paths), 1)
   if (allocated(error)) return
   call check(error, trim(paths(1)) == "tblite0_test", "Dataset name not found in HDF5 file")
end subroutine test_hdf5_descriptor

subroutine test_double_dictionary_hdf5(error)
   type(error_type), allocatable, intent(out) :: error

   type(double_dictionary_type) :: dict1, dict2
   character(len=*), parameter :: filename = ".read-write-ddict.h5"

   call fill_test_dict(dict1)
   call dict1%dump(filename, error)
   if (allocated(error)) return

   call dict2%load(filename, error)
   call delete_file(filename)
   if (allocated(error)) return

   call check(error, dict1 == dict2)
end subroutine test_double_dictionary_hdf5

subroutine fill_test_dict(dict)
   type(double_dictionary_type), intent(inout) :: dict

   real(dp), allocatable :: array1(:), array2(:, :), array3(:, :, :)

   allocate(array1(4), source=1.0_dp)
   allocate(array2(4, 6), source=2.0_dp)
   allocate(array3(4, 6, 9), source=3.0_dp)

   call dict%add_entry("test1", array1)
   call dict%add_entry("test2", array2)
   call dict%add_entry("test3", array3)
end subroutine fill_test_dict

subroutine delete_file(filename)
   character(len=*), intent(in) :: filename

   integer :: io
   logical :: exist

   inquire(file=filename, exist=exist)
   if (exist) then
      open(newunit=io, file=filename)
      close(io, status="delete")
   end if
end subroutine delete_file

end module test_hdf5

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/coulomb/thirdorder.f90
!> Provides an onsite third-order electrostatic interaction

!> Isotropic third-order onsite correction
module tblite_coulomb_thirdorder
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_container_cache, only : container_cache
   use tblite_coulomb_charge, only : effective_coulomb
   use tblite_coulomb_multipole, only : damped_multipole
   use tblite_coulomb_type, only : coulomb_type
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: new_onsite_thirdorder

   !> Onsite correction for third-order charge expansion
   type, public, extends(coulomb_type) :: onsite_thirdorder
      !> Whether the third order contribution is shell-dependent
      logical :: shell_resolved
      !> Number of shell for each atom
      integer, allocatable :: nsh_at(:)
      !> Shell offset for each atom
      integer, allocatable :: ish_at(:)
      !> Hubbard derivatives for each species
      real(wp), allocatable :: hubbard_derivs(:, :)
   contains
      !> Update container cache
      procedure :: update
      !> Get information about density dependent quantities used in the energy
      procedure :: variable_info
      !> Evaluate selfconsistent energy of the interaction
      procedure :: get_energy
      !> Evaluate charge dependent potential shift from the interaction
      procedure :: get_potential
      !> Evaluate gradient of charge dependent potential shift from the interaction
      procedure :: get_potential_gradient
      !> Evaluate gradient contributions from the selfconsistent interaction
      procedure :: get_gradient
   end type onsite_thirdorder

   character(len=*), parameter :: label = "onsite third-order electrostatics"

contains


!> Create new onsite third-order contribution
subroutine new_onsite_thirdorder(self, mol, hubbard_derivs, nshell)
   !> Instance of the electrostatic container
   type(onsite_thirdorder), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Hubbard derivatives
   real(wp), intent(in) :: hubbard_derivs(:, :)
   !> Number of shells for each species
   integer, intent(in), optional :: nshell(:)

   integer :: ind, iat

   self%label = label
   self%hubbard_derivs = hubbard_derivs

   self%shell_resolved = present(nshell)
   if (present(nshell)) then
      self%nsh_at = nshell(mol%id)

      allocate(self%ish_at(mol%nat))
      ind = 0
      do iat = 1, mol%nat
         self%ish_at(iat) = ind
         ind = ind + self%nsh_at(iat)
      end do
   end if

end subroutine new_onsite_thirdorder


!> Update container cache
subroutine update(self, mol, cache)
   !> Instance of the electrostatic container
   class(onsite_thirdorder), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

end subroutine update


!> Evaluate selfconsistent energy of the interaction
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the electrostatic container
   class(onsite_thirdorder), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Electrostatic energy
   real(wp), intent(inout) :: energies(:)

   integer :: iat, izp, ii, ish

   if (self%shell_resolved) then
      do iat = 1, mol%nat
         izp = mol%id(iat)
         ii = self%ish_at(iat)
         do ish = 1, self%nsh_at(iat)
            energies(iat) = energies(iat) &
               & + wfn%qsh(ii+ish, 1)**3 * self%hubbard_derivs(ish, izp) / 3.0_wp
         end do
      end do
   else
      do iat = 1, mol%nat
         izp = mol%id(iat)
         energies(iat) = energies(iat) &
            & + wfn%qat(iat, 1)**3 * self%hubbard_derivs(1, izp) / 3.0_wp
      end do
   end if
end subroutine get_energy


!> Evaluate charge dependent potential shift from the interaction
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the electrostatic container
   class(onsite_thirdorder), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   integer :: iat, izp, ii, ish

   if (self%shell_resolved) then
      do iat = 1, mol%nat
         izp = mol%id(iat)
         ii = self%ish_at(iat)
         do ish = 1, self%nsh_at(iat)
            pot%vsh(ii+ish, 1) = pot%vsh(ii+ish, 1) &
               & + wfn%qsh(ii+ish, 1)**2 * self%hubbard_derivs(ish, izp)
         end do
      end do
   else
      do iat = 1, mol%nat
         izp = mol%id(iat)
         pot%vat(iat, 1) = pot%vat(iat, 1) + wfn%qat(iat, 1)**2 * self%hubbard_derivs(1, izp)
      end do
   end if
end subroutine get_potential


!> Evaluate gradient of charge dependent potential shift from the interaction
subroutine get_potential_gradient(self, mol, cache, wfn, pot)
   !> Instance of the electrostatic container
   class(onsite_thirdorder), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   integer :: iat, izp, ii, ish

   if (self%shell_resolved) then
      do iat = 1, mol%nat
         izp = mol%id(iat)
         ii = self%ish_at(iat)
         do ish = 1, self%nsh_at(iat)
            pot%dvshdr(:, :, ii+ish, 1) = pot%dvshdr(:, :, ii+ish, 1) &
               & + 2.0_wp * wfn%qsh(ii+ish, 1) * wfn%dqshdr(:, :, ii+ish, 1) * self%hubbard_derivs(ish, izp)
            pot%dvshdL(:, :, ii+ish, 1) = pot%dvshdL(:, :, ii+ish, 1) &
               & + 2.0_wp * wfn%qsh(ii+ish, 1) * wfn%dqshdL(:, :, ii+ish, 1) * self%hubbard_derivs(ish, izp)
         end do
      end do
   else 
      do iat = 1, mol%nat
         izp = mol%id(iat)
         pot%dvatdr(:, :, iat, 1) = pot%dvatdr(:, :, iat, 1) &
         & + 2.0_wp * wfn%qat(iat, 1) * wfn%dqatdr(:, :, iat, 1) * self%hubbard_derivs(1, izp)
         pot%dvatdL(:, :, iat, 1) = pot%dvatdL(:, :, iat, 1) &
         & + 2.0_wp * wfn%qat(iat, 1) * wfn%dqatdL(:, :, iat, 1) * self%hubbard_derivs(1, izp)
      end do
   end if

end subroutine get_potential_gradient

!> Evaluate gradient contributions from the selfconsistent interaction
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the electrostatic container
   class(onsite_thirdorder), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the repulsion energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

end subroutine get_gradient


!> Get information about density dependent quantities used in the energy
pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, atom_resolved, shell_resolved
   !> Instance of the electrostatic container
   class(onsite_thirdorder), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=merge(shell_resolved, atom_resolved, self%shell_resolved))
end function variable_info

end module tblite_coulomb_thirdorder

! This file is part of jonquil.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Implementation of a serializer for TOML values to JSON.
module jonquil_ser
   use tomlf_constants
   use tomlf_datetime
   use tomlf_type, only : toml_value, toml_visitor, toml_key, toml_table, &
      & toml_array, toml_keyval, is_array_of_tables, len
   use tomlf_error, only : toml_error, toml_stat, make_error
   use tomlf_utils, only : to_string
   implicit none
   private

   public :: json_serializer, json_ser_config
   public :: json_dumps, json_dump, json_serialize


   interface json_dumps
      module procedure :: json_dump_to_string
   end interface json_dumps

   interface json_dump
      module procedure :: json_dump_to_file
      module procedure :: json_dump_to_unit
   end interface json_dump


   !> Configuration for JSON serializer
   type :: json_ser_config

      !> Write literal NaN
      logical :: literal_nan = .false.

      !> Write literal Inf
      logical :: literal_inf = .false.

      !> Write literal datetime
      logical :: literal_datetime = .false.

      !> Indentation
      character(len=:), allocatable :: indent

   end type json_ser_config


   !> Serializer to produduce a JSON document from a TOML datastructure
   type, extends(toml_visitor) :: json_serializer

      !> Output string
      character(len=:), allocatable :: output

      !> Configuration for serializer
      type(json_ser_config) :: config = json_ser_config()

      !> Current depth in the tree
      integer :: depth = 0

   contains

      !> Visit a TOML value
      procedure :: visit

   end type json_serializer


contains


!> Serialize a JSON value to a string and return it.
!>
!> In case of an error this function will invoke an error stop.
function json_serialize(val, config) result(string)
   !> TOML value to visit
   class(toml_value), intent(inout) :: val

   !> Configuration for serializer
   type(json_ser_config), intent(in), optional :: config

   !> Serialized JSON value
   character(len=:), allocatable :: string

   type(toml_error), allocatable :: error

   call json_dumps(val, string, error, config=config)
   if (allocated(error)) then
      error stop error%message
   end if
end function json_serialize


!> Create a string representing the JSON value
subroutine json_dump_to_string(val, string, error, config)

   !> TOML value to visit
   class(toml_value), intent(inout) :: val

   !> Formatted unit to write to
   character(:), allocatable, intent(out) :: string

   !> Error handling
   type(toml_error), allocatable, intent(out) :: error

   !> Configuration for serializer
   type(json_ser_config), intent(in), optional :: config

   type(json_serializer) :: ser

   ser = json_serializer()
   if (present(config)) ser%config = config
   call val%accept(ser)
   string = ser%output
end subroutine json_dump_to_string


!> Write string representation of JSON value to a connected formatted unit
subroutine json_dump_to_unit(val, io, error, config)

   !> TOML value to visit
   class(toml_value), intent(inout) :: val

   !> Formatted unit to write to
   integer, intent(in) :: io

   !> Error handling
   type(toml_error), allocatable, intent(out) :: error

   !> Configuration for serializer
   type(json_ser_config), intent(in), optional :: config

   character(len=:), allocatable :: string
   character(512) :: msg
   integer :: stat

   call json_dumps(val, string, error, config=config)
   if (allocated(error)) return
   write(io, '(a)', iostat=stat, iomsg=msg) string
   if (stat /= 0) then
      call make_error(error, trim(msg))
      return
   end if
end subroutine json_dump_to_unit


!> Write string representation of JSON value to a file
subroutine json_dump_to_file(val, filename, error, config)

   !> TOML value to visit
   class(toml_value), intent(inout) :: val

   !> File name to write to
   character(*), intent(in) :: filename

   !> Error handling
   type(toml_error), allocatable, intent(out) :: error

   !> Configuration for serializer
   type(json_ser_config), intent(in), optional :: config

   integer :: io
   integer :: stat
   character(512) :: msg

   open(file=filename, newunit=io, iostat=stat, iomsg=msg)
   if (stat /= 0) then
      call make_error(error, trim(msg))
      return
   end if
   call json_dump(val, io, error, config=config)
   close(unit=io, iostat=stat, iomsg=msg)
   if (.not.allocated(error) .and. stat /= 0) then
      call make_error(error, trim(msg))
   end if
end subroutine json_dump_to_file


!> Visit a TOML value
subroutine visit(self, val)

   !> Instance of the JSON serializer
   class(json_serializer), intent(inout) :: self

   !> TOML value to visit
   class(toml_value), intent(inout) :: val

   if (.not.allocated(self%output)) self%output = ""

   select type(val)
   class is(toml_keyval)
      call visit_keyval(self, val)
   class is(toml_array)
      call visit_array(self, val)
   class is(toml_table)
      call visit_table(self, val)
   end select

end subroutine visit


!> Visit a TOML key-value pair
subroutine visit_keyval(visitor, keyval)

   !> Instance of the JSON serializer
   class(json_serializer), intent(inout) :: visitor

   !> TOML value to visit
   type(toml_keyval), intent(inout) :: keyval

   character(kind=tfc, len=:), allocatable :: str, key
   character(kind=tfc, len=:), pointer :: sdummy
   type(toml_datetime), pointer :: ts
   integer(tfi), pointer :: idummy
   real(tfr), pointer :: fdummy
   logical, pointer :: ldummy

   call indent(visitor)

   if (allocated(keyval%key)) then
      call escape_string(keyval%key, key)
      visitor%output = visitor%output // """" // key // """: "
   end if

   select case(keyval%get_type())
   case default
      visitor%output = visitor%output // "null"

   case(toml_type%string)
      call keyval%get(sdummy)
      call escape_string(sdummy, str)
      visitor%output = visitor%output // """" // str // """"

   case(toml_type%boolean)
      call keyval%get(ldummy)
      if (ldummy) then
         visitor%output = visitor%output // "true"
      else
         visitor%output = visitor%output // "false"
      end if

   case(toml_type%int)
      call keyval%get(idummy)
      visitor%output = visitor%output // to_string(idummy)

   case(toml_type%float)
      call keyval%get(fdummy)
      if (fdummy > huge(fdummy)) then
         if (visitor%config%literal_inf) then
            visitor%output = visitor%output // "+inf"
         else
            visitor%output = visitor%output // """+inf"""
         end if
      else if (fdummy < -huge(fdummy)) then
         if (visitor%config%literal_inf) then
            visitor%output = visitor%output // "-inf"
         else
            visitor%output = visitor%output // """-inf"""
         end if
      else if (fdummy /= fdummy) then
         if (visitor%config%literal_nan) then
            visitor%output = visitor%output // "nan"
         else
            visitor%output = visitor%output // """nan"""
         end if
      else
         visitor%output = visitor%output // to_string(fdummy)
      end if

   case(toml_type%datetime)
      call keyval%get(ts)
      if (visitor%config%literal_datetime) then
         visitor%output = visitor%output // to_string(ts)
      else
         visitor%output = visitor%output // """" // to_string(ts) // """"
      end if

   end select

end subroutine visit_keyval


!> Visit a TOML array
subroutine visit_array(visitor, array)

   !> Instance of the JSON serializer
   class(json_serializer), intent(inout) :: visitor

   !> TOML value to visit
   type(toml_array), intent(inout) :: array

   class(toml_value), pointer :: ptr
   character(kind=tfc, len=:), allocatable :: key
   integer :: i, n

   call indent(visitor)

   if (allocated(array%key)) then
      call escape_string(array%key, key)
      visitor%output = visitor%output // """" // key // """: "
   end if

   visitor%output = visitor%output // "["
   visitor%depth = visitor%depth + 1
   n = len(array)
   do i = 1, n
      call array%get(i, ptr)
      call ptr%accept(visitor)
      if (i /= n) visitor%output = visitor%output // ","
   end do
   visitor%depth = visitor%depth - 1
   call indent(visitor)
   visitor%output = visitor%output // "]"

end subroutine visit_array


!> Visit a TOML table
subroutine visit_table(visitor, table)

   !> Instance of the JSON serializer
   class(json_serializer), intent(inout) :: visitor

   !> TOML table to visit
   type(toml_table), intent(inout) :: table

   class(toml_value), pointer :: ptr
   type(toml_key), allocatable :: list(:)
   character(kind=tfc, len=:), allocatable :: key
   integer :: i, n

   call indent(visitor)

   if (allocated(table%key)) then
      call escape_string(table%key, key)
      visitor%output = visitor%output // """" // key // """: "
   end if

   visitor%output = visitor%output // "{"
   visitor%depth = visitor%depth + 1

   call table%get_keys(list)

   n = size(list, 1)
   do i = 1, n
      call table%get(list(i)%key, ptr)
      call ptr%accept(visitor)
      if (i /= n) visitor%output = visitor%output // ","
   end do

   visitor%depth = visitor%depth - 1
   call indent(visitor)
   if (visitor%depth == 0) then
      if (allocated(visitor%config%indent)) visitor%output = visitor%output // new_line('a')
      visitor%output = visitor%output // "}" // new_line('a')
   else
      visitor%output = visitor%output // "}"
   endif

end subroutine visit_table


!> Produce indentations for emitted JSON documents
subroutine indent(self)

   !> Instance of the JSON serializer
   class(json_serializer), intent(inout) :: self

   integer :: i

   ! PGI internal compiler error in NVHPC 20.7 and 20.9 with
   ! write(self%unit, '(/, a)', advance='no') repeat(self%config%indent, self%depth)
   ! causes: NVFORTRAN-F-0000-Internal compiler error. Errors in Lowering      16
   if (allocated(self%config%indent) .and. self%depth > 0) then
      self%output = self%output // new_line('a') // repeat(self%config%indent, self%depth)
   end if

end subroutine indent


!> Transform a TOML raw value to a JSON compatible escaped string
subroutine escape_string(raw, escaped)

   !> Raw value of TOML value
   character(len=*), intent(in) :: raw

   !> JSON compatible escaped string
   character(len=:), allocatable, intent(out) :: escaped

   integer :: i

   escaped = ''
   do i = 1, len(raw)
      select case(raw(i:i))
      case default; escaped = escaped // raw(i:i)
      case('\'); escaped = escaped // '\\'
      case('"'); escaped = escaped // '\"'
      case(TOML_NEWLINE); escaped = escaped // '\n'
      case(TOML_FORMFEED); escaped = escaped // '\f'
      case(TOML_CARRIAGE_RETURN); escaped = escaped // '\r'
      case(TOML_TABULATOR); escaped = escaped // '\t'
      case(TOML_BACKSPACE); escaped = escaped // '\b'
      end select
   end do

end subroutine escape_string


end module jonquil_ser

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/param/post_processing/xtbml.f90
!> Provides paramerts to address the xtbml features

!> Definition of the dispersion corrections
module tblite_param_post_processing_xtbml
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_param_post_processing_type, only : post_processing_record
   use tblite_toml, only : toml_table, get_value, set_value, add_table, toml_array, add_array
   implicit none
   private

   public :: count

   character(len=*), parameter :: k_xtbmlgeometry = "geometry", k_xtbmldensity = "density", &
      & k_xtbmlorbital = "orbital", k_xtbmlenergy = "energy", k_xtbmlconvolution = "convolution", &
      & k_xtbmla = "a", k_tensor = "tensorial-output", k_xtbml = "xtbml"

   !> Record specifying the xTB-ML features post-processing
   type, public, extends(post_processing_record) :: xtbml_record
      !> Compute geometry-based xtbml features
      logical :: xtbml_geometry = .false.
      !> Compute density-based xtbml features
      logical :: xtbml_density = .false.
      !> Return vectorial information additional to norm of the corresponding multipole moments
      logical :: xtbml_tensor = .false.
      !> Compute orbital energy based xtbml features
      logical :: xtbml_orbital_energy = .false.
      !> Compute energy based features, necessary for partitioning weights
      logical :: xtbml_energy = .false.
      !> Compute extended feature i.e. do CN weigthed real space convolution
      logical :: xtbml_convolution = .false.
      !> Scaling for logistic function, convolution over an array of values is supported
      real(wp), allocatable :: xtbml_a(:)
   contains
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Populate parametrization record with default values
      procedure :: populate_default_param
   end type

   !> Masking for the xTB-ML features post-processing
   type, public :: xtbml_mask
   end type xtbml_mask

   interface count
      module procedure :: count_mask
   end interface count

contains

subroutine populate_default_param(param, tensor)
   !> Instance of the parametrization data
   class(xtbml_record), intent(inout) :: param
   !> Return vectorial information additional and norm of the corresponding multipole moments
   logical, optional :: tensor

   ! Compute geometry-based xtbml features
   param%xtbml_geometry = .true.
   ! Compute density-based xtbml features
   param%xtbml_density = .true.
   ! Return vectorial information additional to norm of the corresponding multipole moments
   if (present(tensor)) then
      param%xtbml_tensor = tensor
   else
      param%xtbml_tensor = .false.
   end if
   ! Compute orbital energy based xtbml features
   param%xtbml_orbital_energy = .true.
   ! Compute energy based features, necessary for partitioning weights
   param%xtbml_energy = .true.
   ! Compute extended feature i.e. do CN weigthed real space convolution
   param%xtbml_convolution = .true.
   ! Scaling for logistic function, convolution over an array of values is supported
   param%xtbml_a = [1.0_wp]

end subroutine

!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   use tblite_toml, only : len
   !> Instance of the parametrization data
   class(xtbml_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   type(toml_array), pointer :: array
   type(toml_table), pointer :: child
   integer :: stat, i, stat2
   character(len=:), allocatable :: method

   call get_value(table, k_xtbml, child, requested=.false., stat=stat)
   if (stat /= 0 .or. .not.associated(child)) then
      call fatal_error(error, "Cannot read entry for xtbml table")
      return
   end if

   call get_value(child, k_xtbmlgeometry, self%xtbml_geometry, .false., stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read entry for xtbml geometry based features, boolean expected")
      return
   end if

   call get_value(child, k_xtbmldensity, self%xtbml_density, .false., stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read entry for xtbml density based features, boolean expected")
      return
   end if
   if (self%xtbml_density) then
      call get_value(child, k_tensor, self%xtbml_tensor, .false., stat=stat)
      if (stat /= 0) then
         call fatal_error(error, "Cannot read entry for xtbml tensorial-output, boolean expected")
         return
      end if
   end if

   call get_value(child, k_xtbmlorbital, self%xtbml_orbital_energy, .false., stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read entry for xtbml orbital energy based features, boolean expected")
      return
   end if

   call get_value(child, k_xtbmlenergy, self%xtbml_energy, .false., stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read entry for xtbml geometry based features, boolean expected")
      return
   end if

   call get_value(child, k_xtbmlconvolution, self%xtbml_convolution, .false., stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read entry for xtbml convolution, boolean expected")
      return
   end if
   if (self%xtbml_convolution) then
      if (child%has_key(k_xtbmla)) then
         call get_value(child, k_xtbmla, array, stat=stat)
         if (.not. associated(array)) then
            if (allocated(self%xtbml_a)) deallocate(self%xtbml_a)
            allocate(self%xtbml_a(1))
            call get_value(child, k_xtbmla, self%xtbml_a(1), stat=stat)
            if (stat /= 0) then
               call fatal_error(error, "Cannot read entry for xtbml a, float expected")
               return
            end if
         else
            if (allocated(self%xtbml_a)) deallocate(self%xtbml_a)
            allocate(self%xtbml_a(len(array)))
            do i = 1, size(self%xtbml_a)
               call get_value(array, i, self%xtbml_a(i))
            end do
         end if
      else
         self%xtbml_a = [1.0_wp]
      end if

   end if

end subroutine load_from_toml

!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(xtbml_record), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   type(toml_array), pointer :: array
   integer :: i

   call add_table(table, k_xtbml, child)

   call set_value(child, k_xtbmlgeometry, self%xtbml_geometry)
   call set_value(child, k_xtbmldensity, self%xtbml_density)
   call set_value(child, k_tensor, self%xtbml_tensor)
   call set_value(child, k_xtbmlorbital, self%xtbml_orbital_energy)
   call set_value(child, k_xtbmlenergy, self%xtbml_energy)
   call set_value(child, k_xtbmlconvolution, self%xtbml_convolution)
   call add_array(child, k_xtbmla, array)
   do i = 1, size(self%xtbml_a)
      call set_value(array, i, self%xtbml_a(i))
   end do

end subroutine dump_to_toml

elemental function count_mask(mask) result(ncount)
   type(xtbml_mask), intent(in) :: mask
   integer :: ncount
   ncount = 0
end function count_mask

end module tblite_param_post_processing_xtbml

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

module dftd4_param
   use mctc_env, only : wp
   use dftd4_damping, only : damping_param
   use dftd4_damping_rational, only : rational_damping_param
   use dftd4_utils, only : lowercase
   implicit none
   private

   public :: functional_group
   public :: get_rational_damping, get_functionals, get_functional_id
   public :: p_r2scan_3c


   enum, bind(C)
      enumerator :: p_invalid, &
         & p_hf, p_blyp, p_bpbe, p_bp, p_bpw, p_lb94, p_mpwlyp, p_mpwpw, &
         & p_olyp, p_opbe, p_pbe, p_rpbe, p_revpbe, p_pw86pbe, &
         & p_rpw86pbe, p_pw91, p_pwp, p_xlyp, p_b97, p_tpss, p_revtpss, &
         & p_scan, p_rscan, p_r2scan, p_b1lyp, p_b3lyp, p_bhlyp, p_b1p, &
         & p_b3p, p_b1pw, p_b3pw, p_o3lyp, p_revpbe0, p_revpbe38, &
         & p_pbe0, p_pwp1, p_pw1pw, p_mpw1pw, p_mpw1lyp, p_pw6b95, &
         & p_tpssh, p_tpss0, p_x3lyp, p_m06l, p_m06, p_b97d, &
         & p_wb97, p_wb97x_2008, p_b97m, p_wb97m, p_camb3lyp, p_lcblyp, &
         & p_lh07tsvwn, p_lh07ssvwn, p_lh12ctssirpw92, p_lh12ctssifpw92, &
         & p_lh14tcalpbe, p_lh20t, p_b2plyp, p_b2gpplyp, p_mpw2plyp, p_pwpb95, &
         & p_dsdblyp, p_dsdpbe, p_dsdpbeb95, p_dsdpbep86, p_dsdsvwn, &
         & p_dodblyp, p_dodpbe, p_dodpbeb95, p_dodpbep86, p_dodsvwn, &
         & p_pbe0_2, p_pbe0_dh, p_hsesol, p_dftb_3ob, p_dftb_mio, p_dftb_ob2, &
         & p_dftb_matsci, p_dftb_pbc, p_b1b95, p_pbesol, p_hse06, p_mpwb1k, &
         & p_hse03, p_revtpssh, p_mn12sx, p_glyp, p_mpw1b95, &
         & p_revpbe0dh, p_revtpss0, p_revdsdpbep86, p_revdsdpbe, &
         & p_revdsdblyp, p_revdodpbep86, p_am05, p_hse12, p_hse12s, &
         & p_r2scanh, p_r2scan0, p_r2scan50, p_r2scan_3c, p_camqtp01, &
         & p_lcwpbe, p_lcwpbeh, p_wb97x_rev, p_wb97m_rev, &
         & p_wb97x_3c, p_wr2scan, p_r2scan0_dh, p_r2scan_cidh, &
         & p_r2scan_qidh, p_r2scan0_2, p_pr2scan50, p_pr2scan69, &
         & p_kpr2scan50, p_wpr2scan50, p_wb97x, p_last
   end enum
   integer, parameter :: df_enum = kind(p_invalid)


   !> Group different spellings/names of functionals
   type functional_group
      character(len=:), allocatable :: names(:)
   end type functional_group

   !> Retrieve rational damping parameters from functional name or ID
   interface get_rational_damping
      module procedure :: get_rational_damping_name
      module procedure :: get_rational_damping_id
   end interface get_rational_damping

contains


!> Create a new group of functional names
function new_funcgroup(input_names) result(group)

   !> List of spellings/names of the functional
   character(len=*), intent(in) :: input_names(:)

   !> Functional with possibly different spellings
   type(functional_group) :: group
   
   integer :: n, i, max_len
   n = size(input_names)

   ! Determine the length of the longest name
   max_len = 0
   do i = 1, n
      max_len = max(max_len, len_trim(input_names(i)))
   end do

   ! Allocate based on the longest name's length
   allocate(character(len=max_len) :: group%names(n))
   do i = 1, n
      group%names(i) = trim(input_names(i))
   end do
end function new_funcgroup


!> Collect all supported functionals
subroutine get_functionals(funcs)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_functionals

   !> Collection of functionals with possibly different spellings/names
   type(functional_group), allocatable, intent(out) :: funcs(:)

   allocate(funcs(p_last - 1))

   funcs(p_hf) = new_funcgroup([character(len=20) :: 'hf'])
   funcs(p_am05) = new_funcgroup([character(len=20) :: 'am05'])
   funcs(p_blyp) = new_funcgroup([character(len=20) :: 'b-lyp', 'blyp'])
   funcs(p_bpbe) = new_funcgroup([character(len=20) :: 'bpbe'])
   funcs(p_bp) = new_funcgroup([character(len=20) :: 'b-p', 'bp86', 'bp', 'b-p86'])
   funcs(p_bpw) = new_funcgroup([character(len=20) :: 'bpw', 'b-pw'])
   funcs(p_lb94) = new_funcgroup([character(len=20) :: 'lb94'])
   funcs(p_mpwlyp) = new_funcgroup([character(len=20) :: 'mpwlyp', 'mpw-lyp'])
   funcs(p_mpwpw) = new_funcgroup([character(len=20) :: 'mpwpw', 'mpw-pw', 'mpwpw91'])
   funcs(p_olyp) = new_funcgroup([character(len=20) :: 'o-lyp', 'olyp'])
   funcs(p_opbe) = new_funcgroup([character(len=20) :: 'opbe'])
   funcs(p_pbe) = new_funcgroup([character(len=20) :: 'pbe'])
   funcs(p_rpbe) = new_funcgroup([character(len=20) :: 'rpbe'])
   funcs(p_revpbe) = new_funcgroup([character(len=20) :: 'revpbe'])
   funcs(p_pw86pbe) = new_funcgroup([character(len=20) :: 'pw86pbe'])
   funcs(p_rpw86pbe) = new_funcgroup([character(len=20) :: 'rpw86pbe'])
   funcs(p_pw91) = new_funcgroup([character(len=20) :: 'pw91'])
   funcs(p_pwp) = new_funcgroup([character(len=20) :: 'pwp', 'pw-p', 'pw91p86'])
   funcs(p_xlyp) = new_funcgroup([character(len=20) :: 'x-lyp', 'xlyp'])
   funcs(p_b97) = new_funcgroup([character(len=20) :: 'b97'])
   funcs(p_tpss) = new_funcgroup([character(len=20) :: 'tpss'])
   funcs(p_revtpss) = new_funcgroup([character(len=20) :: 'revtpss'])
   funcs(p_scan) = new_funcgroup([character(len=20) :: 'scan'])
   funcs(p_rscan) = new_funcgroup([character(len=20) :: 'rscan'])
   funcs(p_r2scan) = new_funcgroup([character(len=20) :: 'r2scan', 'r²scan'])
   funcs(p_r2scanh) = new_funcgroup([character(len=20) :: 'r2scanh', 'r²scanh'])
   funcs(p_r2scan0) = new_funcgroup([character(len=20) :: 'r2scan0', 'r²scan0'])
   funcs(p_r2scan50) = new_funcgroup([character(len=20) :: 'r2scan50', 'r²scan50'])
   funcs(p_r2scan_3c) = new_funcgroup([character(len=20) :: 'r2scan-3c', &
      & 'r²scan-3c', 'r2scan_3c', 'r²scan_3c', 'r2scan3c'])
   funcs(p_wr2scan) = new_funcgroup([character(len=20) :: 'wr2scan', 'wr²scan'])
   funcs(p_r2scan0_dh) = new_funcgroup([character(len=20) :: 'r2scan0-dh', &
      & 'r²scan0-dh', 'r2scan0dh', 'r²scan0dh'])
   funcs(p_r2scan_cidh) = new_funcgroup([character(len=20) :: 'r2scan-cidh', &
      & 'r²scan-cidh', 'r2scancidh', 'r²scancidh'])
   funcs(p_r2scan_qidh) = new_funcgroup([character(len=20) :: 'r2scan-qidh', &  
      & 'r²scan-qidh', 'r2scanqidh', 'r²scanqidh'])
    funcs(p_r2scan0_2) = new_funcgroup([character(len=20) :: 'r2scan0-2', &
      & 'r²scan0-2', 'r2scan02', 'r²scan02'])
   funcs(p_pr2scan50) = new_funcgroup([character(len=20) :: 'pr2scan50', &
      & 'pr²scan50', 'pr2scan50', 'pr²scan50'])
   funcs(p_pr2scan69) = new_funcgroup([character(len=20) :: 'pr2scan69', &
      & 'pr²scan69', 'pr2scan69', 'pr²scan69'])
   funcs(p_kpr2scan50) = new_funcgroup([character(len=20) :: 'kpr2scan50', & 
      & 'kpr²scan50', 'kpr2scan50', 'kpr²scan50'])
   funcs(p_wpr2scan50) = new_funcgroup([character(len=20) :: 'wpr2scan50', &
      & 'wpr²scan50', 'wpr2scan50', 'wpr²scan50'])
   funcs(p_b1lyp) = new_funcgroup([character(len=20) :: 'b1lyp', 'b1-lyp'])
   funcs(p_b3lyp) = new_funcgroup([character(len=20) :: 'b3-lyp', 'b3lyp'])
   funcs(p_bhlyp) = new_funcgroup([character(len=20) :: 'bh-lyp', 'bhlyp'])
   funcs(p_b1p) = new_funcgroup([character(len=20) :: 'b1p', 'b1-p', 'b1p86'])
   funcs(p_b3p) = new_funcgroup([character(len=20) :: 'b3p', 'b3-p', 'b3p86'])
   funcs(p_b1pw) = new_funcgroup([character(len=20) :: 'b1pw', 'b1-pw', 'b1pw91'])
   funcs(p_b3pw) = new_funcgroup([character(len=20) :: 'b3pw', 'b3-pw', 'b3pw91'])
   funcs(p_o3lyp) = new_funcgroup([character(len=20) :: 'o3-lyp', 'o3lyp'])
   funcs(p_revpbe0) = new_funcgroup([character(len=20) :: 'revpbe0'])
   funcs(p_revpbe38) = new_funcgroup([character(len=20) :: 'revpbe38'])
   funcs(p_pbe0) = new_funcgroup([character(len=20) :: 'pbe0'])
   funcs(p_pwp1) = new_funcgroup([character(len=20) :: 'pwp1'])
   funcs(p_pw1pw) = new_funcgroup([character(len=20) :: 'pw1pw', 'pw1-pw'])
   funcs(p_mpw1pw) = new_funcgroup([character(len=20) :: 'mpw1pw', 'mpw1-pw', 'mpw1pw91'])
   funcs(p_mpw1lyp) = new_funcgroup([character(len=20) :: 'mpw1lyp', 'mpw1-lyp'])
   funcs(p_pw6b95) = new_funcgroup([character(len=20) :: 'pw6b95'])
   funcs(p_tpssh) = new_funcgroup([character(len=20) :: 'tpssh'])
   funcs(p_tpss0) = new_funcgroup([character(len=20) :: 'tpss0'])
   funcs(p_x3lyp) = new_funcgroup([character(len=20) :: 'x3-lyp', 'x3lyp'])
   funcs(p_m06) = new_funcgroup([character(len=20) :: 'm06'])
   funcs(p_m06l) = new_funcgroup([character(len=20) :: 'm06l'])
   funcs(p_mn12sx) = new_funcgroup([character(len=20) :: 'mn12sx', 'mn12-sx'])
   funcs(p_b97d) = new_funcgroup([character(len=20) :: 'b97d'])
   funcs(p_lh07tsvwn) = new_funcgroup([character(len=20) :: 'lh07tsvwn', 'lh07t-svwn'])
   funcs(p_lh07ssvwn) = new_funcgroup([character(len=20) :: 'lh07ssvwn', 'lh07s-svwn'])
   funcs(p_lh12ctssirpw92) = new_funcgroup([character(len=20) :: 'lh12ctssirpw92', 'lh12ct-ssirpw92'])
   funcs(p_lh12ctssifpw92) = new_funcgroup([character(len=20) :: 'lh12ctssifpw92', 'lh12ct-ssifpw92'])
   funcs(p_lh14tcalpbe) = new_funcgroup([character(len=20) :: 'lh14tcalpbe', 'lh14t-calpbe'])
   funcs(p_lh20t) = new_funcgroup([character(len=20) :: 'lh20t'])
   funcs(p_b2plyp) = new_funcgroup([character(len=20) :: 'b2plyp', 'b2-plyp'])
   funcs(p_b2gpplyp) = new_funcgroup([character(len=20) :: 'b2gpplyp', 'b2gp-plyp'])
   funcs(p_mpw2plyp) = new_funcgroup([character(len=20) :: 'mpw2plyp'])
   funcs(p_pwpb95) = new_funcgroup([character(len=20) :: 'pwpb95'])
   funcs(p_dsdblyp) = new_funcgroup([character(len=20) :: 'dsdblyp', 'dsd-blyp'])
   funcs(p_dsdpbe) = new_funcgroup([character(len=20) :: 'dsdpbe', 'dsd-pbe'])
   funcs(p_dsdpbeb95) = new_funcgroup([character(len=20) :: 'dsdpbeb95', 'dsd-pbeb95'])
   funcs(p_dsdpbep86) = new_funcgroup([character(len=20) :: 'dsdpbep86', 'dsd-pbep86'])
   funcs(p_dsdsvwn) = new_funcgroup([character(len=20) :: 'dsdsvwn', 'dsd-svwn'])
   funcs(p_dodblyp) = new_funcgroup([character(len=20) :: 'dodblyp', 'dod-blyp'])
   funcs(p_dodpbe) = new_funcgroup([character(len=20) :: 'dodpbe', 'dod-pbe'])
   funcs(p_dodpbeb95) = new_funcgroup([character(len=20) :: 'dodpbeb95', 'dod-pbeb95'])
   funcs(p_dodpbep86) = new_funcgroup([character(len=20) :: 'dodpbep86', 'dod-pbep86'])
   funcs(p_dodsvwn) = new_funcgroup([character(len=20) :: 'dodsvwn', 'dod-svwn'])
   funcs(p_pbe0_2) = new_funcgroup([character(len=20) :: 'pbe02', 'pbe0-2'])
   funcs(p_pbe0_dh) = new_funcgroup([character(len=20) :: 'pbe0dh', 'pbe0-dh'])
   funcs(p_dftb_3ob) = new_funcgroup([character(len=20) :: 'dftb3', 'dftb(3ob)'])
   funcs(p_dftb_mio) = new_funcgroup([character(len=20) :: 'dftb(mio)'])
   funcs(p_dftb_pbc) = new_funcgroup([character(len=20) :: 'dftb(pbc)'])
   funcs(p_dftb_matsci) = new_funcgroup([character(len=20) :: 'dftb(matsci)'])
   funcs(p_dftb_ob2) = new_funcgroup([character(len=20) :: 'lc-dftb', 'dftb(ob2)'])
   funcs(p_b1b95) = new_funcgroup([character(len=20) :: 'b1b95'])
   funcs(p_pbesol) = new_funcgroup([character(len=20) :: 'pbesol'])
   funcs(p_mpwb1k) = new_funcgroup([character(len=20) :: 'mpwb1k'])
   funcs(p_mpw1b95) = new_funcgroup([character(len=20) :: 'mpw1b95'])
   funcs(p_hse03) = new_funcgroup([character(len=20) :: 'hse03'])
   funcs(p_hse06) = new_funcgroup([character(len=20) :: 'hse06'])
   funcs(p_hse12) = new_funcgroup([character(len=20) :: 'hse12'])
   funcs(p_hse12s) = new_funcgroup([character(len=20) :: 'hse12s'])
   funcs(p_hsesol) = new_funcgroup([character(len=20) :: 'hsesol'])
   funcs(p_revtpssh) = new_funcgroup([character(len=20) :: 'revtpssh'])
   funcs(p_glyp) = new_funcgroup([character(len=20) :: 'glyp', 'g-lyp'])
   funcs(p_revpbe0dh) = new_funcgroup([character(len=20) :: 'revpbe0dh', 'revpbe0-dh'])
   funcs(p_revtpss0) = new_funcgroup([character(len=20) :: 'revtpss0'])
   funcs(p_revdsdpbep86) = new_funcgroup([character(len=20) :: 'revdsd-pbep86', 'revdsdpbep86'])
   funcs(p_revdsdpbe) = new_funcgroup([character(len=20) :: 'revdsd-pbe', 'revdsd-pbepbe', 'revdsdpbe', 'revdsdpbepbe'])
   funcs(p_revdsdblyp) = new_funcgroup([character(len=20) :: 'revdsd-blyp', 'revdsdblyp'])
   funcs(p_revdodpbep86) = new_funcgroup([character(len=20) :: 'revdod-pbep86', 'revdodpbep86'])
   funcs(p_b97m) = new_funcgroup([character(len=20) :: 'b97m'])
   funcs(p_wb97m) = new_funcgroup([character(len=20) :: 'wb97m', 'ωb97m', 'omegab97m'])
   funcs(p_wb97m_rev) = new_funcgroup([character(len=20) :: 'wb97m-rev', &
      & 'ωb97m-rev', 'omegab97m-rev', 'wb97m_rev', 'ωb97m_rev', 'omegab97m_rev'])
   funcs(p_wb97) = new_funcgroup([character(len=20) :: 'wb97', 'ωb97', 'omegab97'])
   funcs(p_wb97x_2008) = new_funcgroup([character(len=20) :: 'wb97x_2008', &
      & 'ωb97x_2008', 'omegab97x_2008', 'wb97x-2008', 'ωb97x-2008', &
      & 'omegab97x-2008'])
   funcs(p_wb97x) = new_funcgroup([character(len=20) :: 'wb97x', 'ωb97x', &
      & 'omegab97x'])
   funcs(p_wb97x_rev) = new_funcgroup([character(len=20) :: 'wb97x-rev', &
      & 'ωb97x-rev', 'omegab97x-rev', 'wb97x_rev', 'ωb97x_rev', 'omegab97x_rev'])
   funcs(p_wb97x_3c) = new_funcgroup([character(len=20) :: 'wb97x-3c', &
      & 'ωb97x-3c', 'omegab97x-3c', 'wb97x_3c', 'ωb97x_3c', 'omegab97x_3c'])
   funcs(p_camb3lyp) = new_funcgroup([character(len=20) :: 'cam-b3lyp', 'camb3lyp'])
   funcs(p_camqtp01) = new_funcgroup([character(len=20) :: 'cam-qtp01', &
      & 'camqtp01', 'camqtp(01)', 'cam-qtp(01)'])
   funcs(p_lcblyp) = new_funcgroup([character(len=20) :: 'lc-blyp', 'lcblyp'])
   funcs(p_lcwpbe) = new_funcgroup([character(len=20) :: 'lc-wpbe', &
      & 'lcwpbe', 'lc-ωpbe', 'lcωpbe', 'lc-omegapbe', 'lcomegapbe'])
   funcs(p_lcwpbeh) = new_funcgroup([character(len=20) :: 'lc-wpbeh', &
      & 'lcwpbeh', 'lc-ωpbeh', 'lcωpbeh', 'lc-omegapbeh', 'lcomegapbeh'])

end subroutine get_functionals


!> Retrieve rational damping parameters from functional name
subroutine get_rational_damping_name(functional, param, s9)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_rational_damping_name

   !> Functional name for which to retrieve the damping parameters
   character(len=*), intent(in) :: functional

   !> Damping parameters for the functional
   class(damping_param), allocatable, intent(out) :: param

   !> Scaling factor for the three-body term
   real(wp), intent(in), optional :: s9

   character(len=:), allocatable :: fname
   integer :: is, id

   is = index(functional, '/')
   if (is == 0) is = len_trim(functional) + 1
   fname = lowercase(functional(:is-1))

   id = get_functional_id(fname)

   call get_rational_damping_id(id, param, s9=s9)

end subroutine get_rational_damping_name


!> Retrieve rational damping parameters from functional ID
subroutine get_rational_damping_id(id, param, s9)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_rational_damping_id

   !> Functional ID for which to retrieve the damping parameters
   integer, intent(in) :: id

   !> Damping parameters for the functional
   class(damping_param), allocatable, intent(out) :: param

   !> Scaling factor for the three-body term
   real(wp), intent(in), optional :: s9

   logical :: mbd

   mbd = .true.
   if (present(s9)) mbd = abs(s9) > epsilon(s9)

   if (mbd) then
      call get_d4eeq_bjatm_parameter(id, param, s9)
      if (.not.allocated(param)) then
         call get_d4eeq_bj_parameter(id, param, s9)
      end if
   else
      call get_d4eeq_bj_parameter(id, param, s9)
      if (.not.allocated(param)) then
         call get_d4eeq_bjatm_parameter(id, param, s9)
      end if
   end if

end subroutine get_rational_damping_id


subroutine get_d4eeq_bj_parameter(dfnum, param, s9)
   integer(df_enum), intent(in) :: dfnum
   class(damping_param), allocatable, intent(out) :: param
   real(wp), intent(in), optional :: s9
   select case(dfnum)
   case(p_dftb_3ob)
      param = dftd_param( & ! (SAW191202)
         &  s6=1.0_wp, s8=0.4727337_wp, a1=0.5467502_wp, a2=4.4955068_wp)
   case(p_dftb_matsci)
      param = dftd_param( & ! (SAW191202)
         &  s6=1.0_wp, s8=2.7711819_wp, a1=0.4681712_wp, a2=5.2918629_wp)
   case(p_dftb_mio)
      param = dftd_param( & ! (SAW191202)
         &  s6=1.0_wp, s8=1.1948145_wp, a1=0.6074567_wp, a2=4.9336133_wp)
   case(p_dftb_ob2)
      param = dftd_param( & ! (SAW191202)
         &  s6=1.0_wp, s8=2.7611320_wp, a1=0.6037249_wp, a2=5.3900004_wp)
   case(p_dftb_pbc)
      param = dftd_param( & ! (SAW191202)
         &  s6=1.0_wp, s8=1.7303734_wp, a1=0.5546548_wp, a2=4.7973454_wp)
   end select

contains

   pure function dftd_param(s6, s8, a1, a2, alp) result(par)
      real(wp), intent(in) :: s8, a1, a2
      real(wp), intent(in), optional :: s6, alp
      type(rational_damping_param) :: par
      real(wp) :: s6_, alp_, s9_

      s6_ = 1.0_wp
      if (present(s6)) s6_ = s6
      s9_ = 0.0_wp
      if (present(s9)) s9_ = s9
      alp_ = 16.0_wp
      if (present(alp)) alp_ = alp

      par = rational_damping_param(&
         & s6=s6_, &
         & s8=s8, a1=a1, a2=a2, &
         & s9=s9_, &
         & alp=alp_)
   end function dftd_param

end subroutine get_d4eeq_bj_parameter

subroutine get_d4eeq_bjatm_parameter(dfnum, param, s9)
   integer(df_enum), intent(in) :: dfnum
   class(damping_param), allocatable, intent(out) :: param
   real(wp), intent(in), optional :: s9
   select case(dfnum)
   case(p_b1b95)
      param = dftd_param ( & ! (SAW190107)
         &  s6=1.0000_wp, s8=1.27701162_wp, a1=0.40554715_wp, a2=4.63323074_wp )
      !  Fitset: MD= 0.22852 MAD= 0.35189 RMSD= 0.46982
   case(p_b1lyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.98553711_wp, a1=0.39309040_wp, a2=4.55465145_wp )
      !  Fitset: MD= -0.04797 MAD= 0.25597 RMSD= 0.38778
   case(p_b1p)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=3.36115015_wp, a1=0.48665293_wp, a2=5.05219572_wp )
      !  Fitset: MD= -0.01406 MAD= 0.27441 RMSD= 0.47328
   case(p_b1pw)
      param = dftd_param ( & ! (SAW190107)
         &  s6=1.0000_wp, s8=3.02227550_wp, a1=0.47396846_wp, a2=4.49845309_wp )
      !  Fitset: MD= 0.10485 MAD= 0.32175 RMSD= 0.48508
   case(p_b2gpplyp)
      param = dftd_param ( & ! (SAW190107)
         &  s6=0.5600_wp, s8=0.94633372_wp, a1=0.42907301_wp, a2=5.18802602_wp )
      !  Fitset: MD= -0.05248 MAD= 0.18110 RMSD= 0.27365
   case(p_b2plyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.6400_wp, s8=1.16888646_wp, a1=0.44154604_wp, a2=4.73114642_wp )
      !  Fitset: MD= -0.03761 MAD= 0.18247 RMSD= 0.27109
   case(p_b3lyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=2.02929367_wp, a1=0.40868035_wp, a2=4.53807137_wp )
      !  Fitset: MD= -0.05892 MAD= 0.26117 RMSD= 0.40531
   case(p_b3p)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=3.08822155_wp, a1=0.47324238_wp, a2=4.98682134_wp )
      !  Fitset: MD= -0.02970 MAD= 0.26962 RMSD= 0.46761
   case(p_b3pw)
      param = dftd_param ( & ! (SAW190107)
         &  s6=1.0000_wp, s8=2.88364295_wp, a1=0.46990860_wp, a2=4.51641422_wp )
      !  Fitset: MD= 0.06643 MAD= 0.29151 RMSD= 0.45541
   case(p_b97)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=0.87854260_wp, a1=0.29319126_wp, a2=4.51647719_wp )
      !  Fitset: MD= -0.13017 MAD= 0.24778 RMSD= 0.36116
   case(p_bhlyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.65281646_wp, a1=0.27263660_wp, a2=5.48634586_wp )
      !  Fitset: MD= -0.15832 MAD= 0.34132 RMSD= 0.57342
   case(p_blyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=2.34076671_wp, a1=0.44488865_wp, a2=4.09330090_wp )
      !  Fitset: MD= 0.04801 MAD= 0.28161 RMSD= 0.38321
   case(p_bpbe)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=3.64405246_wp, a1=0.52905620_wp, a2=4.11311891_wp )
      !  Fitset: MD= 0.19316 MAD= 0.41912 RMSD= 0.60452
   case(p_bp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=3.35497927_wp, a1=0.43645861_wp, a2=4.92406854_wp )
      !  Fitset: MD= 0.08252 MAD= 0.32681 RMSD= 0.47063
   case(p_bpw)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=3.24571506_wp, a1=0.50050454_wp, a2=4.12346483_wp )
      !  Fitset: MD= 0.20607 MAD= 0.41941 RMSD= 0.59589
   case(p_camb3lyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.66041301_wp, a1=0.40267156_wp, a2=5.17432195_wp )
      !  Fitset: MD= -0.19675 MAD= 0.34901 RMSD= 0.59087
   case(p_camqtp01)
      param = dftd_param ( & ! (10.1021/acs.jctc.3c00717)
         &  s6=1.0000_wp, s8=1.156_wp, a1=0.461_wp, a2=6.375_wp )
   case(p_dodblyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.4700_wp, s8=1.31146043_wp, a1=0.43407294_wp, a2=4.27914360_wp )
      !  Fitset: MD= 0.03323 MAD= 0.13858 RMSD= 0.20861
   case(p_dodpbeb95)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.5600_wp, s8=0.01574635_wp, a1=0.43745720_wp, a2=3.69180763_wp )
      !  Fitset: MD= 0.03704 MAD= 0.13343 RMSD= 0.18278
   case(p_dodpbe)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.4800_wp, s8=0.92051454_wp, a1=0.43037052_wp, a2=4.38067238_wp )
      !  Fitset: MD= 0.01065 MAD= 0.13414 RMSD= 0.21424
   case(p_dodpbep86)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.4600_wp, s8=0.71405681_wp, a1=0.42408665_wp, a2=4.52884439_wp )
      !  Fitset: MD= -0.03740 MAD= 0.12467 RMSD= 0.18127
   case(p_dodsvwn)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.4200_wp, s8=0.94500207_wp, a1=0.47449026_wp, a2=5.05316093_wp )
      !  Fitset: MD= -0.07427 MAD= 0.16970 RMSD= 0.25286
   case(p_dsdblyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.5400_wp, s8=0.63018237_wp, a1=0.47591835_wp, a2=4.73713781_wp )
      !  Fitset: MD= -0.01981 MAD= 0.14823 RMSD= 0.21530
   case(p_dsdpbeb95)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.5400_wp, s8=-0.14668670_wp, a1=0.46394587_wp, a2=3.64913860_wp )
      !  Fitset: MD= 0.02996 MAD= 0.12414 RMSD= 0.16860
   case(p_dsdpbe)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.4500_wp, s8=0.70584116_wp, a1=0.45787085_wp, a2=4.44566742_wp )
      !  Fitset: MD= 0.00866 MAD= 0.13406 RMSD= 0.21380
   case(p_dsdpbep86)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.4700_wp, s8=0.37586675_wp, a1=0.53698768_wp, a2=5.13022435_wp )
      !  Fitset: MD= -0.05273 MAD= 0.14259 RMSD= 0.21271
   case(p_dsdsvwn)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.4100_wp, s8=0.72914436_wp, a1=0.51347412_wp, a2=5.11858541_wp )
      !  Fitset: MD= -0.08974 MAD= 0.32285 RMSD= 0.43146
   case(p_glyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=4.23798924_wp, a1=0.38426465_wp, a2=4.38412863_wp )
      !  Fitset: MD= 0.63466 MAD= 0.89568 RMSD= 1.11309
   case(p_hf)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.61679827_wp, a1=0.44959224_wp, a2=3.35743605_wp )
      !  Fitset: MD= -0.02597 MAD= 0.34732 RMSD= 0.49719
   case(p_lb94)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=2.59538499_wp, a1=0.42088944_wp, a2=3.28193223_wp )
      !  Fitset: MD= 0.31701 MAD= 0.53196 RMSD= 0.74553
   case(p_lcblyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.60344180_wp, a1=0.45769839_wp, a2=7.86924893_wp )
      !  Fitset: MD= -0.39724 MAD= 0.72327 RMSD= 1.18218
   case(p_lcwpbe)
      param = dftd_param ( & ! (10.1021/acs.jctc.3c00717)
         &  s6=1.0000_wp, s8=1.170_wp, a1=0.378_wp, a2=4.816_wp )
   case(p_lcwpbeh)
      param = dftd_param ( & ! (10.1021/acs.jctc.3c00717)
         &  s6=1.0000_wp, s8=1.318_wp, a1=0.386_wp, a2=5.010_wp )
   case(p_lh07ssvwn)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=3.16675531_wp, a1=0.35965552_wp, a2=4.31947614_wp )
      !  Fitset: MD= 0.32224 MAD= 0.59006 RMSD= 0.86272
   case(p_lh07tsvwn)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=2.09333001_wp, a1=0.35025189_wp, a2=4.34166515_wp )
      !  Fitset: MD= 0.24243 MAD= 0.43497 RMSD= 0.61671
   case(p_lh12ctssifpw92)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=2.68467610_wp, a1=0.34190416_wp, a2=3.91039666_wp )
      !  Fitset: MD= 0.55106 MAD= 0.80783 RMSD= 1.11048
   case(p_lh12ctssirpw92)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=2.48973402_wp, a1=0.34026075_wp, a2=3.96948081_wp )
      !  Fitset: MD= 0.47785 MAD= 0.71188 RMSD= 0.98422
   case(p_lh14tcalpbe)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.28130770_wp, a1=0.38822021_wp, a2=4.92501211_wp )
      !  Fitset: MD= -0.02105 MAD= 0.22968 RMSD= 0.36045
   case(p_lh20t)
      param = dftd_param ( & ! (10.1021/acs.jctc.0c00498)
         & s6=1.000_wp, s8=0.113_wp, a1=0.479_wp, a2=4.635_wp )
   case(p_m06)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=0.16366729_wp, a1=0.53456413_wp, a2=6.06192174_wp )
      !  Fitset: MD= 0.01788 MAD= 0.24914 RMSD= 0.38604
   case(p_m06l)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=0.59493760_wp, a1=0.71422359_wp, a2=6.35314182_wp )
      !  Fitset: MD= 0.08395 MAD= 0.24888 RMSD= 0.34879
   case(p_mn12sx)
      param = dftd_param ( & ! (SAW211021)
         &  s6=1.0000_wp, s8=0.85964873_wp, a1=0.62662681_wp, a2=5.62088906_wp )
      !  Fitset: MD= 0.16131 MAD= 0.34142 RMSD= 0.47113
   case(p_mpw1b95)
      param = dftd_param ( & ! (SAW190107)
         &  s6=1.0000_wp, s8=0.50093024_wp, a1=0.41585097_wp, a2=4.99154869_wp )
      !  Fitset: MD= 0.00585 MAD= 0.15695 RMSD= 0.21297
   case(p_mpw1lyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.15591153_wp, a1=0.25603493_wp, a2=5.32083895_wp )
      !  Fitset: MD= -0.26979 MAD= 0.41542 RMSD= 0.60678
   case(p_mpw1pw)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.80841716_wp, a1=0.42961819_wp, a2=4.68892341_wp )
      !  Fitset: MD= -0.08840 MAD= 0.26815 RMSD= 0.45231
   case(p_mpw2plyp)
      param = dftd_param ( & ! (SAW190107)
         &  s6=0.7500_wp, s8=0.45788846_wp, a1=0.42997704_wp, a2=5.07650682_wp )
      !  Fitset: MD= -0.18921 MAD= 0.30115 RMSD= 0.44049
   case(p_mpwb1k)
      param = dftd_param ( & ! (SAW190107)
         &  s6=1.0000_wp, s8=0.57338313_wp, a1=0.44687975_wp, a2=5.21266777_wp )
      !  Fitset: MD= -0.00870 MAD= 0.17226 RMSD= 0.23614
   case(p_mpwlyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.25842942_wp, a1=0.25773894_wp, a2=5.02319542_wp )
      !  Fitset: MD= -0.24426 MAD= 0.39145 RMSD= 0.54503
   case(p_mpwpw)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.82596836_wp, a1=0.34526745_wp, a2=4.84620734_wp )
      !  Fitset: MD= -0.06278 MAD= 0.27913 RMSD= 0.43988
   case(p_o3lyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.75762508_wp, a1=0.10348980_wp, a2=6.16233282_wp )
      !  Fitset: MD= -0.19268 MAD= 0.38577 RMSD= 0.62168
   case(p_olyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=2.74836820_wp, a1=0.60184498_wp, a2=2.53292167_wp )
      !  Fitset: MD= 0.12352 MAD= 0.37113 RMSD= 0.58291
   case(p_opbe)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=3.06917417_wp, a1=0.68267534_wp, a2=2.22849018_wp )
      !  Fitset: MD= 0.26699 MAD= 0.55308 RMSD= 0.85023
   case(p_pbe0_2)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.5000_wp, s8=0.64299082_wp, a1=0.76542115_wp, a2=5.78578675_wp )
      !  Fitset: MD= -0.04260 MAD= 0.21186 RMSD= 0.34045
   case(p_pbe0)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.20065498_wp, a1=0.40085597_wp, a2=5.02928789_wp )
      !  Fitset: MD= -0.17892 MAD= 0.30557 RMSD= 0.51050
   case(p_pbe0_dh)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.8750_wp, s8=0.96811578_wp, a1=0.47592488_wp, a2=5.08622873_wp )
      !  Fitset: MD= -0.13857 MAD= 0.27919 RMSD= 0.47256
   case(p_pbe)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=0.95948085_wp, a1=0.38574991_wp, a2=4.80688534_wp )
      !  Fitset: MD= -0.20544 MAD= 0.33635 RMSD= 0.51168
   case(p_pbesol)
      param = dftd_param ( & ! (SAW211021)
         &  s6=1.0000_wp, s8=1.71885698_wp, a1=0.47901421_wp, a2=5.96771589_wp )
      !  Fitset: MD= -0.28899 MAD= 0.52215 RMSD= 0.93584
   case(p_am05)
      param = dftd_param ( & ! (SAW211021)
         &  s6=1.0000_wp, s8=1.71885838_wp, a1=0.47901431_wp, a2=5.96771581_wp )
      !  Fitset: MD= -0.28899 MAD= 0.52215 RMSD= 0.93584
   case(p_pw1pw)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=0.96850170_wp, a1=0.42427511_wp, a2=5.02060636_wp )
      !  Fitset: MD= -0.27325 MAD= 0.42206 RMSD= 0.64119
   case(p_pw6b95)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=-0.31926054_wp, a1=0.04142919_wp, a2=5.84655608_wp )
      !  Fitset: MD= -0.04767 MAD= 0.14330 RMSD= 0.18958
   case(p_pw86pbe)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.21362856_wp, a1=0.40510366_wp, a2=4.66737724_wp )
      !  Fitset: MD= -0.11505 MAD= 0.24691 RMSD= 0.38101
   case(p_pw91)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=0.77283111_wp, a1=0.39581542_wp, a2=4.93405761_wp )
      !  Fitset: MD= -0.33019 MAD= 0.48611 RMSD= 0.68110
   case(p_pwp1)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=0.60492565_wp, a1=0.46855837_wp, a2=5.76921413_wp )
      !  Fitset: MD= -0.35321 MAD= 0.54026 RMSD= 0.86629
   case(p_pwpb95)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.8200_wp, s8=-0.34639127_wp, a1=0.41080636_wp, a2=3.83878274_wp )
      !  Fitset: MD= 0.02143 MAD= 0.13040 RMSD= 0.17599
   case(p_pwp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=0.32801227_wp, a1=0.35874687_wp, a2=6.05861168_wp )
      !  Fitset: MD= -0.42482 MAD= 0.62607 RMSD= 0.91840
   case(p_revpbe0)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.57185414_wp, a1=0.38705966_wp, a2=4.11028876_wp )
      !  Fitset: MD= 0.02724 MAD= 0.21587 RMSD= 0.36040
   case(p_revpbe0dh)
      param = dftd_param ( & ! (SAW190103)
         &  s6=0.8750_wp, s8=1.24456037_wp, a1=0.36730560_wp, a2=4.71126482_wp )
      !  Fitset: MD= -0.01089 MAD= 0.20910 RMSD= 0.33564
   case(p_revpbe38)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.66597472_wp, a1=0.39476833_wp, a2=4.39026628_wp )
      !  Fitset: MD= -0.01326 MAD= 0.22598 RMSD= 0.36210
   case(p_revpbe)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.74676530_wp, a1=0.53634900_wp, a2=3.07261485_wp )
      !  Fitset: MD= 0.05649 MAD= 0.25212 RMSD= 0.40863
   case(p_revtpss0)
      param = dftd_param ( & ! (SAW190107)
         &  s6=1.0000_wp, s8=1.54664499_wp, a1=0.45890964_wp, a2=4.78426405_wp )
      !  Fitset: MD= -0.05298 MAD= 0.19965 RMSD= 0.32081
   case(p_revtpss)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.53089454_wp, a1=0.44880597_wp, a2=4.64042317_wp )
      !  Fitset: MD= -0.01904 MAD= 0.19568 RMSD= 0.29618
   case(p_revtpssh)
      param = dftd_param ( & ! (SAW190107)
         &  s6=1.0000_wp, s8=1.52740307_wp, a1=0.45161957_wp, a2=4.70779483_wp )
      !  Fitset: MD= -0.03731 MAD= 0.19133 RMSD= 0.29091
   case(p_rpbe)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.31183787_wp, a1=0.46169493_wp, a2=3.15711757_wp )
      !  Fitset: MD= -0.07156 MAD= 0.26348 RMSD= 0.38671
   case(p_rpw86pbe)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.12624034_wp, a1=0.38151218_wp, a2=4.75480472_wp )
      !  Fitset: MD= -0.12740 MAD= 0.26294 RMSD= 0.40614
   case(p_scan)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.46126056_wp, a1=0.62930855_wp, a2=6.31284039_wp )
      !  Fitset: MD= -0.13170 MAD= 0.28640 RMSD= 0.51183
   case(p_rscan)
      param = dftd_param ( & ! (10.1063/5.0041008)
         &  s6=1.0000_wp, s8=0.87728975_wp, a1=0.49116966_wp, a2=5.75859346_wp )
   case(p_r2scan)
      param = dftd_param ( & ! (10.1063/5.0041008)
         &  s6=1.0000_wp, s8=0.60187490_wp, a1=0.51559235_wp, a2=5.77342911_wp )
   case(p_r2scanh)
      param = dftd_param ( & ! (10.1063/5.0086040)
         & s6=1.0_wp, s8=0.8324_wp, a1=0.4944_wp, a2=5.9019_wp)
   case(p_r2scan0)
      param = dftd_param ( & ! (10.1063/5.0086040)
         & s6=1.0_wp, s8=0.8992_wp, a1=0.4778_wp, a2=5.8779_wp)
   case(p_r2scan50)
      param = dftd_param ( & ! (10.1063/5.0086040)
         & s6=1.0_wp, s8=1.0471_wp, a1=0.4574_wp, a2=5.8969_wp)
   case(p_r2scan_3c)
      param = dftd_param ( & ! (10.1063/5.0040021)
         & s6=1.0_wp, s8=0.00_wp, a1=0.42_wp, a2=5.65_wp)
   case(p_tpss0)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.62438102_wp, a1=0.40329022_wp, a2=4.80537871_wp )
      !  Fitset: MD= -0.09569 MAD= 0.26733 RMSD= 0.44767
   case(p_tpss)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.76596355_wp, a1=0.42822303_wp, a2=4.54257102_wp )
      !  Fitset: MD= -0.09296 MAD= 0.27505 RMSD= 0.42537
   case(p_tpssh)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.85897750_wp, a1=0.44286966_wp, a2=4.60230534_wp )
      !  Fitset: MD=  0.02238 MAD= 0.16042 RMSD= 0.33519
   case(p_b97d)
      param = dftd_param ( & ! (SAW201029)
         &  s6=1.0000_wp, s8=1.69460052_wp, a1=0.28904684_wp, a2=4.13407323_wp )
      !  Fitset: MD= -0.09858 MAD= 0.26757 RMSD= 0.42380
   case(p_wb97)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=6.55792598_wp, a1=0.76666802_wp, a2=8.36027334_wp )
      !  Fitset: MD= -0.12779 MAD= 0.36152 RMSD= 0.49991
   case(p_wb97x_2008)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=-0.07519516_wp, a1=0.45094893_wp, a2=6.78425255_wp )
      !  S22x5: MD= 0.05 MAD= 0.16 RMSD= 0.22
      !  S66x8: MD= 0.06 MAD= 0.16 RMSD= 0.21
      !  NCI10: MD= 0.08 MAD= 0.15 RMSD= 0.25
   case(p_wb97x)
      param = dftd_param ( & ! (10.1002/jcc.26411)
         &  s6=1.0000_wp, s8=0.5093_wp, a1=0.0662_wp, a2=5.4487_wp )
   case(p_wb97x_rev)
      param = dftd_param ( & ! (10.1063/5.0133026)
         &  s6=1.0000_wp, s8=0.4485_wp, a1=0.3306_wp, a2=4.279_wp )
   case(p_wb97x_3c)
      param = dftd_param ( & ! (10.1063/5.0133026)
         &  s6=1.0000_wp, s8=0.0_wp, a1=0.2464_wp, a2=4.737_wp )
   case(p_b97m)
      param = dftd_param ( & ! (10.1002/jcc.26411)
         &  s6=1.0000_wp, s8=0.6633_wp, a1=0.4288_wp, a2=3.9935_wp )
      !  S22x5: MD= 0.03 MAD= 0.12 RMSD= 0.18
      !  S66x8: MD= 0.09 MAD= 0.17 RMSD= 0.22
      !  NCI10: MD= 0.09 MAD= 0.15 RMSD= 0.32
   case(p_wb97m)
      param = dftd_param ( & ! (10.1002/jcc.26411)
         &  s6=1.0000_wp, s8=0.7761_wp, a1=0.7514_wp, a2=2.7099_wp )
      !  Fitset: MD= -0.20216 MAD= 0.34696 RMSD= 0.53641
   case(p_wb97m_rev) 
      param = dftd_param ( & ! (10.1021/acs.jctc.3c00717)
         &  s6=1.0000_wp, s8=0.842_wp, a1=0.359_wp, a2=4.668_wp )
   case(p_x3lyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.54701429_wp, a1=0.20318443_wp, a2=5.61852648_wp )
      !  Fitset: MD= -0.15607 MAD= 0.31342 RMSD= 0.49546
   case(p_xlyp)
      param = dftd_param ( & ! (SAW190103)
         &  s6=1.0000_wp, s8=1.62972054_wp, a1=0.11268673_wp, a2=5.40786417_wp )
      !  Fitset: MD= -0.03900 MAD= 0.27562 RMSD= 0.38491
   case(p_revdsdpbep86)
      param = dftd_param ( & ! (WTMAD2)
         &  s6=0.5132_wp, s8=0.00000000_wp, a1=0.44000000_wp, a2=3.60000000_wp )
   case(p_revdsdpbe)
      param = dftd_param ( & ! (WTMAD2)
         &  s6=0.6706_wp, s8=0.00000000_wp, a1=0.40000000_wp, a2=3.60000000_wp )
   case(p_revdsdblyp)
      param = dftd_param ( & !(WTMAD2)
         &  s6=0.6141_wp, s8=0.00000000_wp, a1=0.38000000_wp, a2=3.52000000_wp )
   case(p_revdodpbep86)
      param = dftd_param ( & !(WTMAD2)
         &  s6=0.5552_wp, s8=0.00000000_wp, a1=0.44000000_wp, a2=3.60000000_wp )
   case(p_dftb_3ob)
      param = dftd_param( & ! (SAW191202)
         &  s6=1.0_wp, s8=0.6635015_wp, a1=0.5523240_wp, a2=4.3537076_wp)
   case(p_dftb_matsci)
      param = dftd_param( & ! (SAW191202)
         &  s6=1.0_wp, s8=3.3157614_wp, a1=0.4826330_wp, a2=5.3811976_wp)
   case(p_dftb_mio)
      param = dftd_param( & ! (SAW191202)
         &  s6=1.0_wp, s8=1.2916225_wp, a1=0.5965326_wp, a2=4.8778602_wp)
   case(p_dftb_ob2)
      param = dftd_param( & ! (SAW191202)
         &  s6=1.0_wp, s8=2.9692689_wp, a1=0.6068916_wp, a2=5.4476789_wp)
   case(p_dftb_pbc)
      param = dftd_param( & ! (SAW191202)
         &  s6=1.0_wp, s8=2.1667394_wp, a1=0.5646391_wp, a2=4.9576353_wp)
   case(p_hse03)
      param = dftd_param( & ! (SAW211107)
         &  s6=1.0_wp, s8=1.19812280_wp, a1=0.38662939_wp, a2=5.22925796_wp)
   case(p_hse06)
      param = dftd_param( & ! (SAW211107)
         &  s6=1.0_wp, s8=1.19528249_wp, a1=0.38663183_wp, a2=5.19133469_wp)
   case(p_hse12)
      param = dftd_param( & ! (SAW211107)
         &  s6=1.0_wp, s8=1.23500792_wp, a1=0.39226921_wp, a2=5.22036266_wp)
   case(p_hse12s)
      param = dftd_param( & ! (SAW211107)
         &  s6=1.0_wp, s8=1.23767762_wp, a1=0.39989137_wp, a2=5.34809245_wp)
   case(p_hsesol)
      param = dftd_param( & ! (SAW211107)
         &  s6=1.0_wp, s8=1.82207807_wp, a1=0.45646268_wp, a2=5.59662251_wp)
   case(p_wr2scan) ! (10.1063/5.0174988)
      param = dftd_param ( &
         & s6=1.0_wp, s8=1.0_wp, a1=0.3834_wp, a2=5.7889_wp)
   case(p_r2scan0_dh) ! (10.1063/5.0174988)
      param = dftd_param ( &
         & s6=0.9424_wp, s8=0.3856_wp, a1=0.4271_wp, a2=5.8565_wp)
   case(p_r2scan_cidh) ! (10.1063/5.0174988)
      param = dftd_param ( &
         & s6=0.8666_wp, s8=0.5336_wp, a1=0.4171_wp, a2=5.9125_wp)
   case(p_r2scan_qidh) ! (10.1063/5.0174988)
      param = dftd_param ( &
         & s6=0.7867_wp, s8=0.2955_wp, a1=0.4001_wp, a2=5.8300_wp)
   case(p_r2scan0_2) ! (10.1063/5.0174988)
      param = dftd_param ( &
         & s6=0.7386_wp, s8=0.0000_wp, a1=0.4030_wp, a2=5.5142_wp)
   case(p_pr2scan50) ! (10.1063/5.0174988)
      param = dftd_param ( &
         & s6=0.7964_wp, s8=0.3421_wp, a1=0.4663_wp, a2=5.7916_wp)
   case(p_pr2scan69) ! (10.1063/5.0174988)
      param = dftd_param ( &
         & s6=0.7167_wp, s8=0.0000_wp, a1=0.4644_wp, a2=5.2563_wp)
   case(p_kpr2scan50) ! (10.1063/5.0174988)
      param = dftd_param ( &
         & s6=0.8402_wp, s8=0.1212_wp, a1=0.4382_wp, a2=5.8232_wp)
   case(p_wpr2scan50) ! (10.1063/5.0174988)
      param = dftd_param ( &
         & s6=0.8143_wp, s8=0.3842_wp, a1=0.4135_wp, a2=5.8773_wp)
   end select

contains

   pure function dftd_param(s6, s8, a1, a2, alp) result(par)
      real(wp), intent(in) :: s8, a1, a2
      real(wp), intent(in), optional :: s6, alp
      type(rational_damping_param) :: par
      real(wp) :: s6_, alp_, s9_

      s6_ = 1.0_wp
      if (present(s6)) s6_ = s6
      s9_ = 1.0_wp
      if (present(s9)) s9_ = s9
      alp_ = 16.0_wp
      if (present(alp)) alp_ = alp

      par = rational_damping_param(&
         & s6=s6_, &
         & s8=s8, a1=a1, a2=a2, &
         & s9=s9_, &
         & alp=alp_)
   end function dftd_param

end subroutine get_d4eeq_bjatm_parameter

!> Get the unique identifier for most functionals, returns none if
!> the functional was not known at the time I implemented this mapping
pure function get_functional_id(df) result(num)
   integer(df_enum) :: num
   character(len=*), intent(in) :: df
   select case(df)
   case default
      num = p_invalid
   case('hf')
      num = p_hf
   case('am05', 'gga_x_am05:gga_c_am05')
      num = p_am05
   case('b-lyp', 'blyp', 'gga_x_b88:gga_c_lyp')
      num = p_blyp
   case('bpbe', 'gga_x_b88:gga_c_pbe')
      num = p_bpbe
   case('b-p', 'bp86', 'bp', 'b-p86', 'gga_x_b88:gga_c_p86')
      num = p_bp
   case('bpw', 'b-pw', 'gga_x_b88:gga_c_pw91')
      num = p_bpw
   case('lb94', 'gga_x_lb') ! no gga_c_lb
      num = p_lb94
   case('mpwlyp', 'mpw-lyp', 'gga_x_mpw91:gga_c_lyp')
      num = p_mpwlyp
   case('mpwpw', 'mpw-pw', 'mpwpw91', 'gga_x_mpw91:gga_c_pw91')
      num = p_mpwpw
   case('o-lyp', 'olyp', 'gga_x_optx:gga_c_lyp')
      num = p_olyp
   case('opbe', 'gga_x_optx:gga_c_pbe')
      num = p_opbe
   case('pbe', 'gga_x_pbe:gga_c_pbe')
      num = p_pbe
   case('rpbe', 'gga_x_rpbe:gga_c_pbe')
      num = p_rpbe
   case('revpbe', 'gga_x_pbe_r:gga_c_pbe')
      num = p_revpbe
   case('pbesol', 'gga_x_pbe_sol:gga_c_pbe_sol')
      num = p_pbesol
   case('pw86pbe', 'gga_x_pw86:gga_c_pbe')
      num = p_pw86pbe
   case('rpw86pbe', 'gga_x_rpw86:gga_c_pbe')
      num = p_rpw86pbe
   case('pw91', 'gga_x_pw91:gga_c_pw91')
      num = p_pw91
   case('pwp', 'pw-p', 'pw91p86', 'gga_x_pw91:gga_c_p86')
      num = p_pwp
   case('x-lyp', 'xlyp', 'gga_xc_xlyp')
      num = p_xlyp
   case('b97', 'hyb_gga_xc_b97')
      num = p_b97
   case('b97d', 'gga_xc_b97_d')
      num = p_b97d
   case('tpss', 'mgga_c_tpss:mgga_x_tpss')
      num = p_tpss
   case('revtpss', 'mgga_c_revtpss:mgga_x_revtpss')
      num = p_revtpss
   case('scan', 'mgga_x_scan:mgga_c_scan')
      num = p_scan
   case('rscan', 'mgga_x_rscan:mgga_c_rscan')
      num = p_rscan
   case('r2scan', 'r²scan', 'mgga_x_r2scan:mgga_c_r2scan')
      num = p_r2scan
   case('r2scanh', 'r²scanh', 'hyb_mgga_xc_r2scanh')
      num = p_r2scanh
   case('r2scan0', 'r²scan0', 'hyb_mgga_xc_r2scan0')
      num = p_r2scan0
   case('r2scan50', 'r²scan50', 'hyb_mgga_xc_r2scan50')
      num = p_r2scan50
   case('r2scan-3c', 'r²scan-3c', 'r2scan_3c', 'r²scan_3c', 'r2scan3c')
      num = p_r2scan_3c
   case('b1lyp', 'b1-lyp', 'hyb_gga_xc_b1lyp')
      num = p_b1lyp
   case('b3-lyp', 'b3lyp', 'hyb_gga_xc_b3lyp', 'hyb_gga_xc_b3lyp3', 'hyb_gga_xc_b3lyp5')
      num = p_b3lyp
   case('bh-lyp', 'bhlyp', 'hyb_gga_xc_bhandh', 'hyb_gga_xc_bhandhlyp')
      num = p_bhlyp
   case('b1p', 'b1-p', 'b1p86') ! 0.75 b88 + 0.25 hf; p86 (nonloc) + pw81 (loc)
      num = p_b1p
   case('b3p', 'b3-p', 'b3p86', 'hyb_gga_xc_b3p86', 'hyb_gga_xc_b3p86_nwchem')
      num = p_b3p
   case('b1pw', 'b1-pw', 'b1pw91', 'hyb_gga_xc_b1pw91')
      num = p_b1pw
   case('b3pw', 'b3-pw', 'b3pw91', 'hyb_gga_xc_b3pw91')
      num = p_b3pw
   case('o3-lyp', 'o3lyp', 'hyb_gga_xc_o3lyp')
      num = p_o3lyp
   case('revpbe0') ! no libxc
      num = p_revpbe0
   case('revpbe38') ! no libxc
      num = p_revpbe38
   case('pbe0', 'hyb_gga_xc_pbeh')
      num = p_pbe0
   case('pwp1') ! no libxc
      num = p_pwp1
   case('pw1pw', 'pw1-pw') ! no libxc
      num = p_pw1pw
   case('mpw1pw', 'mpw1-pw', 'mpw1pw91', 'hyb_gga_xc_mpw1pw')
      num = p_mpw1pw
   case('mpw1lyp', 'mpw1-lyp', 'hyb_gga_xc_mpw1lyp')
      num = p_mpw1lyp
   case('pw6b95', 'hyb_mgga_xc_pw6b95')
      num = p_pw6b95
   case('tpssh', 'hyb_mgga_xc_tpssh')
      num = p_tpssh
   case('tpss0', 'hyb_mgga_xc_tpss0')
      num = p_tpss0
   case('x3-lyp', 'x3lyp', 'hyb_gga_xc_x3lyp')
      num = p_x3lyp
   case('m06', 'mgga_x_m06:mgga_c_m06')
      num = p_m06
   case('m06l', 'mgga_x_m06_l:mgga_c_m06_l')
      num = p_m06l
   case('mn12sx', 'mn12-sx', 'mgga_c_mn12_sx:mgga_c_mn12_sx')
      num = p_mn12sx
   case('cam-b3lyp', 'camb3lyp', 'hyb_gga_xc_cam_b3lyp')
      num = p_camb3lyp
   case('cam-qtp01', 'camqtp01', 'camqtp(01)', 'cam-qtp(01)', &
      & 'hyb_gga_xc_cam_qtp_01')
      num = p_camqtp01
   case('lc-blyp', 'lcblyp', 'hyb_gga_xc_lc_blyp')
      num = p_lcblyp
   case('lc-wpbe', 'lcwpbe', 'lc-ωpbe', 'lcωpbe', 'lc-omegapbe', 'lcomegapbe', &
      & 'hyb_gga_xc_lc_wpbe', 'hyb_gga_xc_lc_wpbe08_whs', &
      & 'hyb_gga_xc_lc_wpbe_whs', 'hyb_gga_xc_lrc_wpbe')
      num = p_lcwpbe
   case('lc-wpbeh', 'lcwpbeh', 'lc-ωpbeh', 'lcωpbeh', 'lc-omegapbeh', &
      & 'lcomegapbeh', 'hyb_gga_xc_lc_wpbeh_whs', 'hyb_gga_xc_lrc_wpbeh')
      num = p_lcwpbeh
   case('lh07tsvwn', 'lh07t-svwn') ! no libxc
      num = p_lh07tsvwn
   case('lh07ssvwn', 'lh07s-svwn') ! no libxc
      num = p_lh07ssvwn
   case('lh12ctssirpw92', 'lh12ct-ssirpw92') ! no libxc
      num = p_lh12ctssirpw92
   case('lh12ctssifpw92', 'lh12ct-ssifpw92') ! no libxc
      num = p_lh12ctssifpw92
   case('lh14tcalpbe', 'lh14t-calpbe') ! no libxc
      num = p_lh14tcalpbe
   case('lh20t') ! no libxc
      num = p_lh20t
   case('b2plyp', 'b2-plyp', 'xc_hyb_gga_xc_b2plyp') ! only in code
      num = p_b2plyp
   case('b2gpplyp', 'b2gp-plyp', 'xc_hyb_gga_xc_b2gpplyp') ! only in code
      num = p_b2gpplyp
   case('mpw2plyp') ! no libxc
      num = p_mpw2plyp
   case('pwpb95') ! no libxc
      num = p_pwpb95
   case('dsdblyp', 'dsd-blyp') ! no libxc
      num = p_dsdblyp
   case('dsdpbe', 'dsd-pbe') ! no libxc
      num = p_dsdpbe
   case('dsdpbeb95', 'dsd-pbeb95') ! no libxc
      num = p_dsdpbeb95
   case('dsdpbep86', 'dsd-pbep86') ! no libxc
      num = p_dsdpbep86
   case('dsdsvwn', 'dsd-svwn') ! no libxc
      num = p_dsdsvwn
   case('dodblyp', 'dod-blyp') ! no libxc
      num = p_dodblyp
   case('dodpbe', 'dod-pbe') ! no libxc
      num = p_dodpbe
   case('dodpbeb95', 'dod-pbeb95') ! no libxc
      num = p_dodpbeb95
   case('dodpbep86', 'dod-pbep86') ! no libxc
      num = p_dodpbep86
   case('dodsvwn', 'dod-svwn') ! no libxc
      num = p_dodsvwn
   case('pbe02', 'pbe0-2') ! no libxc
      num = p_pbe0_2
   case('pbe0dh', 'pbe0-dh') ! no libxc
      num = p_pbe0_dh
   case('dftb3', 'dftb(3ob)') ! no libxc
      num = p_dftb_3ob
   case('dftb(mio)') ! no libxc
      num = p_dftb_mio
   case('dftb(pbc)') ! no libxc
      num = p_dftb_pbc
   case('dftb(matsci)') ! no libxc
      num = p_dftb_matsci
   case('lc-dftb', 'dftb(ob2)') ! no libxc
      num = p_dftb_ob2
   case('b1b95', 'hyb_mgga_xc_b88b95')
      num = p_b1b95
   case('mpwb1k', 'hyb_mgga_xc_mpwb1k')
      num = p_mpwb1k
   case('mpw1b95', 'hyb_mgga_xc_mpw1b95')
      num = p_mpw1b95
   case('hse03', 'hyb_gga_xc_hse03')
      num = p_hse03
   case('hse06', 'hyb_gga_xc_hse06')
      num = p_hse06
   case('hse12', 'hyb_gga_xc_hse12')
      num = p_hse12
   case('hse12s', 'hyb_gga_xc_hse12s')
      num = p_hse12s
   case('hsesol', 'hyb_gga_xc_hse_sol')
      num = p_hsesol
   case('glyp', 'g-lyp', 'gga_x_g96:gga_c_lyp')
      num = p_glyp
   case('revpbe0dh', 'revpbe0-dh') ! no libxc
      num = p_revpbe0dh
   case('revtpssh', 'hyb_mgga_xc_revtpssh')
      num = p_revtpssh
    case('revtpss0') ! no libxc
      num = p_revtpss0
   case('revdsd-pbep86', 'revdsdpbep86') ! no libxc
      num = p_revdsdpbep86
   case('revdsd-pbe', 'revdsd-pbepbe', 'revdsdpbe', 'revdsdpbepbe') ! no libxc
      num = p_revdsdpbe
   case('revdsd-blyp', 'revdsdblyp') ! no libxc
      num = p_revdsdblyp
   case('revdod-pbep86', 'revdodpbep86') ! no libxc
      num = p_revdodpbep86
   case('b97m', 'mgga_xc_b97m_v')
      num = p_b97m
   case('wb97m', 'ωb97m', 'omegab97m', 'hyb_mgga_xc_wb97m_v')
      num = p_wb97m
   case('wb97m-rev', 'ωb97m-rev', 'omegab97m-rev', 'wb97m_rev', 'ωb97m_rev', &
      & 'omegab97m_rev') ! D4 re-parametrization
      num = p_wb97m_rev
   case('wb97', 'ωb97', 'omegab97', 'hyb_gga_xc_wb97')
      num = p_wb97
   case('wb97x-2008', 'ωb97x-2008', 'omegab97x-2008', 'hyb_gga_xc_wb97x', &
      & 'wb97x_2008', 'ωb97x_2008', 'omegab97x_2008')
      num = p_wb97x_2008
   case('wb97x', 'ωb97x', 'omegab97x', 'hyb_gga_xc_wb97x_v')
      num = p_wb97x
   case('wb97x-rev', 'ωb97x-rev', 'omegab97x-rev', 'wb97x_rev', 'ωb97x_rev', &
      & 'omegab97x_rev') ! D4 re-parametrization
      num = p_wb97x_rev
   case('wb97x-3c', 'ωb97x-3c', 'omegab97x-3c', 'wb97x_3c', 'ωb97x_3c', &
      & 'omegab97x_3c') ! no libxc
      num = p_wb97x_3c
   case('wr2scan', 'wr²scan') ! no libxc
      num = p_wr2scan
   case('r2scan0-dh', 'r²scan0-dh', 'r2scan0dh', 'r²scan0dh') ! no libxc
      num = p_r2scan0_dh
   case('r2scan-cidh', 'r²scan-cidh', 'r2scancidh', 'r²scancidh') ! no libxc
      num = p_r2scan_cidh
   case('r2scan-qidh', 'r²scan-qidh', 'r2scanqidh', 'r²scanqidh') ! no libxc
      num = p_r2scan_qidh
   case('r2scan0-2', 'r²scan0-2', 'r2scan02', 'r²scan02') ! no libxc
      num = p_r2scan0_2
   case('pr2scan50', 'pr²scan50') ! no libxc
      num = p_pr2scan50
   case('pr2scan69', 'pr²scan69') ! no libxc
      num = p_pr2scan69
   case('kpr2scan50', 'kpr²scan50') ! no libxc
      num = p_kpr2scan50
   case('wpr2scan50', 'wpr²scan50') ! no libxc
      num = p_wpr2scan50
   end select
end function get_functional_id


end module dftd4_param

module d3_param_scan
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   implicit none
   private

   public :: reaction_type
   public :: scan_param_for_reaction

   type :: reaction_type
      type(structure_type), allocatable :: mol(:)
      real(wp), allocatable :: stochiometry(:)
   end type reaction_type

contains

subroutine get_dispersion_for_reaction(reaction, param, energy)
   use dftd3, only : get_dispersion, damping_param, realspace_cutoff, &
      & d3_model, new_d3_model
   type(reaction_type), intent(in) :: reaction
   class(damping_param), intent(in) :: param
   real(wp), intent(inout) :: energy

   integer :: component
   real(wp) :: energy_component
   type(d3_model) :: disp

   do component = 1, size(reaction%mol)
      call new_d3_model(disp, reaction%mol(component))
      call get_dispersion(reaction%mol(component), disp, param, realspace_cutoff(), &
         & energy_component)
      energy = energy + energy_component * reaction%stochiometry(component)
   end do

end subroutine get_dispersion_for_reaction

subroutine scan_param_for_reaction(error, reaction, method, dft_energy)
   use mctc_env, only : error_type, fatal_error
   use dftd3, only : d3_param
   type(error_type), allocatable :: error
   type(reaction_type), intent(in) :: reaction
   character(*), intent(in) :: method
   real(wp), intent(in), optional :: dft_energy

   logical :: has_param(5)
   real(wp) :: disp_energies(2, 5)
   type(d3_param) :: inp
   integer, parameter :: zero_damping_idx = 1, rational_damping_idx = 2, &
      & mzero_damping_idx = 3, mrational_damping_idx = 4, op_damping_idx = 5
   character(*), parameter :: label(5) = [character(len=20) :: &
      & "D3(0)", "D3(BJ)", "D3M(0)", "D3M(BJ)", "D3(op)"]

   has_param(:) = .false.
   disp_energies(:, :) = 0.0_wp
   if (present(dft_energy)) disp_energies(:, :) = dft_energy

   zero_d: block
      use dftd3, only : zero_damping_param, get_zero_damping, new_zero_damping
      type(zero_damping_param) :: param
      call get_zero_damping(inp, method, error, s9=0.0_wp)
      if (allocated(error)) exit zero_d

      has_param(zero_damping_idx) = .true.
      call new_zero_damping(param, inp)
      call get_dispersion_for_reaction(reaction, param, disp_energies(1, zero_damping_idx))

      inp%s9 = 1.0_wp
      call new_zero_damping(param, inp)
      call get_dispersion_for_reaction(reaction, param, disp_energies(2, zero_damping_idx))
   end block zero_d
   if (allocated(error)) deallocate(error)

   rational_d: block
      use dftd3, only : rational_damping_param, get_rational_damping, new_rational_damping
      type(rational_damping_param) :: param
      call get_rational_damping(inp, method, error, s9=0.0_wp)
      if (allocated(error)) exit rational_d

      has_param(rational_damping_idx) = .true.
      call new_rational_damping(param, inp)
      call get_dispersion_for_reaction(reaction, param, disp_energies(1, rational_damping_idx))

      inp%s9 = 1.0_wp
      call new_rational_damping(param, inp)
      call get_dispersion_for_reaction(reaction, param, disp_energies(2, rational_damping_idx))
   end block rational_d
   if (allocated(error)) deallocate(error)

   mzero_d: block
      use dftd3, only : mzero_damping_param, get_mzero_damping, new_mzero_damping
      type(mzero_damping_param) :: param
      call get_mzero_damping(inp, method, error, s9=0.0_wp)
      if (allocated(error)) exit mzero_d

      has_param(zero_damping_idx) = .true.
      call new_mzero_damping(param, inp)
      call get_dispersion_for_reaction(reaction, param, disp_energies(1, mzero_damping_idx))

      inp%s9 = 1.0_wp
      call new_mzero_damping(param, inp)
      call get_dispersion_for_reaction(reaction, param, disp_energies(2, mzero_damping_idx))
   end block mzero_d
   if (allocated(error)) deallocate(error)

   mrational_d: block
      use dftd3, only : rational_damping_param, get_mrational_damping, new_rational_damping
      type(rational_damping_param) :: param
      call get_mrational_damping(inp, method, error, s9=0.0_wp)
      if (allocated(error)) exit mrational_d

      has_param(mrational_damping_idx) = .true.
      call new_rational_damping(param, inp)
      call get_dispersion_for_reaction(reaction, param, disp_energies(1, mrational_damping_idx))

      inp%s9 = 1.0_wp
      call new_rational_damping(param, inp)
      call get_dispersion_for_reaction(reaction, param, disp_energies(2, mrational_damping_idx))
   end block mrational_d
   if (allocated(error)) deallocate(error)

   optimizedpower_d: block
      use dftd3, only : optimizedpower_damping_param, get_optimizedpower_damping, &
         & new_optimizedpower_damping
      type(optimizedpower_damping_param) :: param
      call get_optimizedpower_damping(inp, method, error, s9=0.0_wp)
      if (allocated(error)) exit optimizedpower_d

      has_param(op_damping_idx) = .true.
      call new_optimizedpower_damping(param, inp)
      call get_dispersion_for_reaction(reaction, param, disp_energies(1, op_damping_idx))

      inp%s9 = 1.0_wp
      call new_optimizedpower_damping(param, inp)
      call get_dispersion_for_reaction(reaction, param, disp_energies(2, op_damping_idx))
   end block optimizedpower_d
   if (allocated(error)) deallocate(error)

   if (.not.any(has_param)) then
      call fatal_error(error, "No parameters found for method '"//method//"'")
      return
   end if

   block
      use mctc_io_convert, only : autokj
      integer :: ipar

      print '(a)', "Energies in kJ/mol"
      print '(66("-"))'
      print '(1x, a, t20, 2a15, a16)', "method", "E(2)", "E(2+3)", "%E(3)"
      print '(66("-"))'
      do ipar = 1, 5
         if (.not.has_param(ipar)) cycle
         print '(1x, a, t20, 3f15.3, "%")', &
            & method // "-" // trim(label(ipar)), &
            & disp_energies(:, ipar) * autokj, &
            & (disp_energies(1, ipar) - disp_energies(2, ipar)) / disp_energies(2, ipar) * 100
      end do
      print '(66("-"))'
   end block

end subroutine scan_param_for_reaction

end module d3_param_scan

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file src/ddx_constants.f90
!! This file contains the type ddx_constants_type to hold all required run-time
!! constants and routines to actually compute these constants. These constants
!! include scaling factors for spherical harmonics, certain combinatorial
!! numbers, hierarchical trees for the FMM and so on. Everything that can be
!! precomputed to reduce ddX timings shall be stored in the ddx_constants_type.
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-06-15

!> Run-time constants
module ddx_constants
! Get ddx_params_type and all compile-time definitions
use ddx_parameters
! Get harmonics-related functions
use ddx_harmonics
use omp_lib, only : omp_get_wtime

implicit none


!> Container for precomputed constants
type ddx_constants_type
    !> Number modeling spherical harmonics per sphere.
    integer :: nbasis
    !> Total number of modeling degrees of freedom.
    !! This is equal to `nsph*nbasis`.
    integer :: n
    !> Maximal degree of used real normalized spherical harmonics.
    !! For example, if FMM is
    !! used, its M2L operation requires computing spherical harmonics of all
    !! degrees up to `pm+pl`. If `force=1` then this parameter might be
    !! increased by 1 because certain implementations of analytical gradients
    !! might rely on spherical harmonics of +1 degree.
    integer :: dmax
    !> Total number of used real spherical harmonics and a size of `vscales`.
    integer :: nscales
    !> Scales of real normalized spherical harmonics of degree up to dmax.
    !! This array has a dimension (nscales).
    real(dp), allocatable :: vscales(:)
    !> Array of values 4pi/(2l+1), dimension is (dmax+1). Referenced only if
    !! fmm=1, but allocated and computed in any case.
    real(dp), allocatable :: v4pi2lp1(:)
    !> Relative scales of real normalized spherical harmonics.
    !! Each values is multiplied by a corresponding 4pi/(2l+1). Dimension of
    !! this array is (nscales). Referenced only if fmm=1, but allocated and
    !! computed in any case.
    real(dp), allocatable :: vscales_rel(:)
    !> Number of precomputed square roots of factorials.
    !! Just like with `dmax` parameter, number of used factorials is either
    !! `2*lmax+1` or `2*(pm+pl)+1` depending on whether FMM is used or not.
    integer :: nfact
    !> Array of square roots of factorials of a dimension (nfact).
    real(dp), allocatable :: vfact(:)
    !> Array of square roots of combinatorial numbers C_n^k.
    !! Dimension of this array is ((2*dmax+1)*(dmax+1)). Allocated, computed
    !! and referenced only if fmm=1 or if force=1
    real(dp), allocatable :: vcnk(:)
    !> Array of common M2L coefficients for any OZ translation.
    !! This array has a dimension (pm+1, pl+1, pl+1). Allocated, computed and
    !! referenced only if fmm=1.
    real(dp), allocatable :: m2l_ztranslate_coef(:, :, :)
    !> Array of common M2L coefficients for any adjoint OZ translation.
    !! Dimension of this array is (pl+1, pl+1, pm+1). It is allocated, computed
    !! and referenced only if fmm=1.
    real(dp), allocatable :: m2l_ztranslate_adj_coef(:, :, :)
    !> Coordinates of Lebedev quadrature points of a dimension (3, ngrid).
    real(dp), allocatable :: cgrid(:, :)
    !> Weights of Lebedev quadrature points of a dimension (ngrid).
    real(dp), allocatable :: wgrid(:)
    !> Maximal degree of spherical harmonics evaluated at Lebedev grid points.
    !! Although we use spherical harmonics of degree up to `dmax`, only
    !! spherical harmonics of degree up to `lmax` and `pl` are evaluated
    !! at Lebedev grid points. In the case `force=1` this degrees might be
    !! increased by 1 depending on implementation of gradients.
    integer :: vgrid_dmax
    !> Number of spherical harmonics evaluated at Lebedev grid points.
    integer :: vgrid_nbasis
    !> Values of spherical harmonics at Lebedev grid points.
    !! Dimensions of this array are (vgrid_nbasis, ngrid)
    real(dp), allocatable :: vgrid(:, :)
    !> Weighted values of spherical harmonics at Lebedev grid points.
    !! vwgrid(:, igrid) = vgrid(:, igrid) * wgrid(igrid)
    !! Dimension of this array is (vgrid_nbasis, ngrid).
    real(dp), allocatable :: vwgrid(:, :)
    !> Values of L2P/M2P at grid points. Dimension is (vgrid_nbasis, ngrid).
    real(dp), allocatable :: vgrid2(:, :)
    !> LPB value max of lmax and 6
    integer :: lmax0
    !> LPB value max of nbasis and 49
    integer :: nbasis0
    !> LPB matrix, Eq. (87) from [QSM19.SISC]. Dimension is
    !! (nbasis, nbasis0, nsph)
    real(dp), allocatable :: Pchi(:, :, :)
    !> LPB value (i'_l0(r_j)/i_l0(r_j)-k'_l0(r_j)/k_l0(r_j))^{-1}. Dimension
    !! is ???
    real(dp), allocatable :: C_ik(:, :)
    !> LPB Bessel function of the first kind. Dimension is (dmax+1, nsph).
    real(dp), allocatable :: SI_ri(:, :)
    !> LPB Derivative of Bessel function of the first kind. Dimension is
    !! (dmax+1, nsph).
    real(dp), allocatable :: DI_ri(:, :)
    !> LPB Bessel function of the second kind. Dimension is (lmax+2, nsph).
    real(dp), allocatable :: SK_ri(:, :)
    !> LPB Derivative Bessel function of the second kind. Dimension is
    !! (lmax+2, nsph).
    real(dp), allocatable :: DK_ri(:, :)
    !> LPB value i'_l(r_j)/i_l(r_j). Dimension is (lmax, nsph).
    real(dp), allocatable :: termimat(:, :)
    !> LPB B matrix for doing incore BX product
    real(dp), allocatable :: b(:,:,:)
    !> ddCOSMO L matrix fo doing incore LX product
    real(dp), allocatable :: l(:,:,:)
    !> Upper limit on a number of neighbours per sphere. This value is just an
    !! upper bound that is not guaranteed to be the actual maximum.
    integer :: nngmax
    !> List of intersecting spheres in a CSR format. Dimension is (nsph+1).
    integer, allocatable :: inl(:)
    !> List of intersecting spheres in a CSR format. Dimension is
    !! (nsph*nngmax).
    integer, allocatable :: nl(:)
    !> transpose list of intersecting spheres
    integer, allocatable :: itrnl(:)
    !> Values of a characteristic function f at all grid points of all spheres.
    !! Dimension is (ngrid, npsh).
    real(dp), allocatable :: fi(:, :)
    !> Values of a characteristic function U at all grid points of all spheres.
    !! Dimension is (ngrid, nsph).
    real(dp), allocatable :: ui(:, :)
    !> Values of a characteristic function U at cavity points. Dimension is
    !! (ncav).
    real(dp), allocatable :: ui_cav(:)
    !> Derivative of the characteristic function U at all grid points of all
    !! spheres. Dimension is (3, ngrid, nsph).
    real(dp), allocatable :: zi(:, :, :)
    !> Derivative of the characteristic function U at all grid points of all
    !! spheres wrt to radii. Dimension is (ngrid, nsph).
    real(dp), allocatable :: zi_dr(:, :)
    !> Number of external Lebedev grid points on a molecular surface.
    integer :: ncav
    !> Number of external Lebedev grid points on each sphere.
    integer, allocatable :: ncav_sph(:)
    !> Coordinates of external Lebedev grid points. Dimension is (3, ncav).
    real(dp), allocatable :: ccav(:, :)
    !> Row indexes in CSR format of all cavity points. Dimension is (nsph+1).
    integer, allocatable :: icav_ia(:)
    !> Column indexes in CSR format of all cavity points. Dimension is (ncav).
    integer, allocatable :: icav_ja(:)
    !> Preconditioner for an operator R_eps. Allocated and computed only for
    !! the PCM model (model=3). Dimension is (nbasis, nbasis, nsph).
    real(dp), allocatable :: rx_prc(:, :, :)
    !! Cluster tree information that is allocated and computed only if fmm=1.
    !> Reordering of spheres for better locality. This array has a dimension
    !! (nsph) and is allocated/used only if fmm=1.
    integer, allocatable :: order(:)
    !> Number of clusters. Defined only if fmm=1.
    integer :: nclusters
    !> The first and the last spheres of each node. Dimension of this array is
    !! (2, nclusters) and it is allocated/used only if fmm=1.
    integer, allocatable :: cluster(:, :)
    !> Children of each cluster. Dimension is (2, nclusters). Allocated and
    !! used only if fmm=1.
    integer, allocatable :: children(:, :)
    !> Parent of each cluster. Dimension is (nclusters). Allocated and used
    !! only if fmm=1.
    integer, allocatable :: parent(:)
    !> Center of bounding sphere of each cluster. Dimension is (3, nclusters).
    !! This array is allocated and used only if fmm=1.
    real(dp), allocatable :: cnode(:, :)
    !> Radius of bounding sphere of each cluster. Dimension is (nclusters).
    !! This array is allocated and used only if fmm=1.
    real(dp), allocatable :: rnode(:)
    !> Which leaf node contains only given input sphere. Dimension is (nsph).
    !! This array is allocated and used only if fmm=1.
    integer, allocatable :: snode(:)
    !> Bessel function for bounding sphere of each cluster. Dimension is
    !! (pm, nclusters). This array is allocated and used only if fmm=1.
    real(dp), allocatable :: SK_rnode(:, :)
    !> Bessel function for bounding sphere of each cluster. Dimension is
    !! (pm, nclusters). This array is allocated and used only if fmm=1.
    real(dp), allocatable :: SI_rnode(:, :)
    !> Total number of far admissible pairs. Defined only if fmm=1.
    integer :: nnfar
    !> Total number of near admissible pairs. Defined only if fmm=1.
    integer :: nnnear
    !> Number of admissible far pairs for each node. Dimension is (nclusters).
    !! This array is allocated and used only if fmm=1.
    integer, allocatable :: nfar(:)
    !> Number of admissible near pairs for each node. Dimension is (nclusters).
    !! This array is allocated and used only if fmm=1.
    integer, allocatable :: nnear(:)
    !> Arrays of admissible far pairs. Dimension is (nnfar). This array is
    !! allocated and used only if fmm=1.
    integer, allocatable :: far(:)
    !> Arrays of admissible near pairs. Dimension is (nnnear). This array is
    !! allocated and used only if fmm=1.
    integer, allocatable :: near(:)
    !> Index of the first element of array of all admissible far pairs stored
    !! in the array `far`. Dimension is (nclusters+1). This array is
    !! allocated and used only if fmm=1.
    integer, allocatable :: sfar(:)
    !> Index of the first element of array of all admissible near pairs stored
    !! in the array `near`. Dimension is (nclusters+1). This array is
    !! allocated and used only if fmm=1.
    integer, allocatable :: snear(:)
    !> Number of near-field M2P interactions with cavity points. Defined only
    !! if fmm=1.
    integer :: nnear_m2p
    !> Maximal degree of near-field M2P spherical harmonics. Defined only if
    !! fmm=1.
    integer :: m2p_lmax
    !> Number of spherical harmonics used for near-field M2P. Defined only if
    !! fmm=1.
    integer :: m2p_nbasis
    !> Number of spherical harmonics of degree up to lmax+1 used for
    !! computation of forces (gradients). Allocated and used only if
    !! fmm=1.
    integer :: grad_nbasis
    !> Inner tolerance for microiterations done when using ddLPB
    real(dp) :: inner_tol
    !> Whether the diagonal of the matrices has to be used in the mvp for
    !! ddCOSMO, ddPCM or inner ddLPB iterations
    logical  :: dodiag
end type ddx_constants_type

contains

!> Compute all necessary constants
!!
!! @param[in] params: Object containing all inputs.
!! @param[out] constants: Object containing all constants.
!! @param[inout] ddx_error: ddX error
!!
subroutine constants_init(params, constants, ddx_error)
    use complex_bessel
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    !! Outputs
    type(ddx_constants_type), intent(out) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Local variables
    integer :: i, alloc_size, l, indl, igrid, isph, l0, &
        & NZ, ierr, info, tmp_pmax
    real(dp) :: rho, ctheta, stheta, cphi, sphi, termi, termk, &
        & s1, s2
    real(dp), allocatable :: vplm(:), vcos(:), vsin(:), vylm(:), SK_rijn(:), &
        & DK_rijn(:)
    complex(dp), allocatable :: bessel_work(:)
    complex(dp) :: z
    !! The code
    ! Clean ddx_error state of constants to proceed with geometry
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "constants_init received input in error " // &
            & " state, exiting")
        return
    end if
    ! activate inner iterations diagonal in mvp for debugging purposes only.
    ! could be useful for different linear solvers.
    constants % dodiag = .false.
    ! Maximal number of modeling spherical harmonics
    constants % nbasis = (params % lmax+1) ** 2
    ! Maximal number of modeling degrees of freedom
    constants % n = params % nsph * constants % nbasis
    ! Calculate dmax, vgrid_dmax, m2p_lmax, m2p_nbasis and grad_nbasis
    if (params % fmm .eq. 0) then
        if (params % force .eq. 1) then
            constants % dmax = params % lmax + 1
            constants % vgrid_dmax = params % lmax + 1
        else
            constants % dmax = params % lmax
            constants % vgrid_dmax = params % lmax
        end if
        ! Other constants are not referenced if fmm=0
        constants % m2p_lmax = -1
        constants % m2p_nbasis = -1
        constants % grad_nbasis = -1
    else
        ! If forces are required then we need the M2P of a degree lmax+1 for
        ! the near-field analytical gradients
        if (params % force .eq. 1) then
            constants % dmax = max(params % pm+params % pl+1, &
                & params % lmax+1)
            constants % m2p_lmax = params % lmax + 1
            constants % grad_nbasis = (params % lmax+2) ** 2
            constants % vgrid_dmax = max(params % pl, params % lmax) + 1
        else
            constants % dmax = max(params % pm+params % pl, &
                & params % lmax)
            constants % m2p_lmax = params % lmax
            constants % grad_nbasis = -1
            constants % vgrid_dmax = max(params % pl, params % lmax)
        end if
        constants % m2p_nbasis = (constants % m2p_lmax+1) ** 2
    end if
    ! Compute sizes of vgrid, vfact and vscales
    constants % vgrid_nbasis = (constants % vgrid_dmax+1) ** 2
    constants % nfact = 2*constants % dmax+1
    constants % nscales = (constants % dmax+1) ** 2
    ! Allocate space for scaling factors of spherical harmonics
    allocate(constants % vscales(constants % nscales), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "constants_init: `vscales` allocation " &
            & // "failed")
        return
    end if
    allocate(constants % v4pi2lp1(constants % dmax+1), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "constants_init: `v4pi2lp1` allocation " &
            & // "failed")
        return
    end if
    allocate(constants % vscales_rel(constants % nscales), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "constants_init: `vscales_rel` " // &
            & "allocation failed")
        return
    end if
    ! Compute scaling factors of spherical harmonics
    call ylmscale(constants % dmax, constants % vscales, &
        & constants % v4pi2lp1, constants % vscales_rel)
    ! Allocate square roots of factorials
    allocate(constants % vfact(constants % nfact), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "constants_init: `vfact` allocation failed")
        return
    end if
    ! Compute square roots of factorials
    constants % vfact(1) = 1
    do i = 2, constants % nfact
        constants % vfact(i) = constants % vfact(i-1) * sqrt(dble(i-1))
    end do
    ! Allocate square roots of combinatorial numbers C_n^k and M2L OZ
    ! translation coefficients
    if (params % fmm .eq. 1 .or. &
        & (params % model .eq. 3 .and. params % force .eq. 1)) then
        alloc_size = 2*constants % dmax + 1
        alloc_size = alloc_size * (constants % dmax+1)
        ! Allocate C_n^k
        allocate(constants % vcnk(alloc_size), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_init: `vcnk` allocation " &
                & // "failed")
            return
        end if
        ! Allocate M2L OZ coefficients
        allocate(constants % m2l_ztranslate_coef(&
            & (params % pm+1), (params % pl+1), (params % pl+1)), &
            & stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_init: " // &
                & "`m2l_ztranslate_coef` allocation failed")
            return
        end if
        ! Allocate adjoint M2L OZ coefficients
        allocate(constants % m2l_ztranslate_adj_coef(&
            & (params % pl+1), (params % pl+1), (params % pm+1)), &
            & stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_init: " // &
                & "`m2l_ztranslate_adj_coef` allocation failed")
            return
        end if
        ! Compute combinatorial numbers C_n^k and M2L OZ translate coefficients
        call fmm_constants(constants % dmax, params % pm, &
            & params % pl, constants % vcnk, &
            & constants % m2l_ztranslate_coef, &
            & constants % m2l_ztranslate_adj_coef)
    end if
    ! Allocate space for Lebedev grid coordinates and weights
    allocate(constants % cgrid(3, params % ngrid), &
        & constants % wgrid(params % ngrid), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "constants_init: `cgrid` and `wgrid` " // &
            & "allocations failed")
        return
    end if
    ! Get weights and coordinates of Lebedev grid points
    call llgrid(params % ngrid, constants % wgrid, constants % cgrid)
    ! Allocate space for values of non-weighted and weighted spherical
    ! harmonics and L2P at Lebedev grid points
    allocate(constants % vgrid(constants % vgrid_nbasis, params % ngrid), &
        & constants % vwgrid(constants % vgrid_nbasis, params % ngrid), &
        & stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "constants_init: `vgrid`, `wgrid` and" // &
            & " allocations failed")
        return
    end if
    allocate(vplm(constants % vgrid_nbasis), vcos(constants % vgrid_dmax+1), &
        & vsin(constants % vgrid_dmax+1), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "constants_init: `vplm`, `vcos` and " // &
            & "`vsin` allocations failed")
        return
    end if
    ! Compute non-weighted and weighted spherical harmonics and the single
    ! layer operator at Lebedev grid points
    do igrid = 1, params % ngrid
        call ylmbas(constants % cgrid(:, igrid), rho, ctheta, stheta, cphi, &
            & sphi, constants % vgrid_dmax, constants % vscales, &
            & constants % vgrid(:, igrid), vplm, vcos, vsin)
        constants % vwgrid(:, igrid) = constants % wgrid(igrid) * &
            & constants % vgrid(:, igrid)
    end do
    if (params % fmm .eq. 1) then
        allocate(constants % vgrid2( &
            & constants % vgrid_nbasis, params % ngrid), &
            & stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_init: `vgrid2` " // &
                & "allocation failed")
            return
        end if
        do igrid = 1, params % ngrid
            do l = 0, constants % vgrid_dmax
                indl = l*l + l + 1
                constants % vgrid2(indl-l:indl+l, igrid) = &
                    & constants % vgrid(indl-l:indl+l, igrid) / &
                    & constants % vscales(indl)**2
            end do
        end do
    end if

    ! Generate geometry-related constants (required by the LPB code)
    call constants_geometry_init(params, constants, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "constants_geometry_init returned an " // &
            & "error, exiting")
        return
    end if

    ! Precompute LPB-related constants
    if (params % model .eq. 3) then
        constants % lmax0 = params % lmax
        constants % nbasis0 = constants % nbasis
        allocate(vylm(constants % vgrid_nbasis), &
            & SK_rijn(0:constants % lmax0), DK_rijn(0:constants % lmax0), &
            & bessel_work(constants % dmax+2), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_init: `vylm`, `SK_rijn` " // &
                & "and `DK_rijn` allocations failed")
            return
        end if
        allocate(constants % SI_ri(0:constants % dmax+1, params % nsph), &
            & constants % DI_ri(0:constants % dmax+1, params % nsph), &
            & constants % SK_ri(0:params % lmax+1, params % nsph), &
            & constants % DK_ri(0:params % lmax+1, params % nsph), &
            & constants % Pchi(constants % nbasis, constants % nbasis0, params % nsph), &
            & constants % C_ik(0:params % lmax, params % nsph), &
            & constants % termimat(0:params % lmax, params % nsph), &
            & stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_init: allocation failed")
            return
        end if
        SK_rijn = zero
        DK_rijn = zero
        do isph = 1, params % nsph
            ! We compute Bessel functions of degrees 0..lmax+1 because the
            ! largest degree is required for forces
            call modified_spherical_bessel_first_kind(constants % dmax+1, &
                & params % rsph(isph)*params % kappa,&
                & constants % SI_ri(:, isph), constants % DI_ri(:, isph), &
                & bessel_work)
            call modified_spherical_bessel_second_kind(params % lmax+1, &
                & params % rsph(isph)*params % kappa, &
                & constants % SK_ri(:, isph), constants % DK_ri(:, isph), &
                & bessel_work)
            ! Compute matrix PU_i^e(x_in)
            ! Previous implementation in update_rhs. Made it in allocate_model, so as to use
            ! it in Forces as well.
            call mkpmat(params, constants, isph, constants % Pchi(:, :, isph))
            ! Compute i'_l(r_i)/i_l(r_i)
            do l = 0, params % lmax
                constants % termimat(l, isph) = constants % DI_ri(l, isph) / &
                    & constants % SI_ri(l, isph) * params % kappa
            end do
            ! Compute (i'_l0/i_l0 - k'_l0/k_l0)^(-1) is computed in Eq.(97)
            do l0 = 0, constants % lmax0
                termi = constants % DI_ri(l0, isph) / &
                    & constants % SI_ri(l0, isph) * params % kappa
                termk = constants % DK_ri(l0, isph)/ &
                    & constants % SK_ri(l0, isph) * params % kappa
                constants % C_ik(l0, isph) = one / (termi-termk)
            end do
        end do
        if (params % fmm .eq. 1) then
            tmp_pmax = max(params % pm, params % pl)
            allocate(constants % SI_rnode(tmp_pmax+1, constants % nclusters), &
                & constants % SK_rnode(tmp_pmax+1, constants % nclusters), &
                & stat=info)
            if (info.ne.0) then
                call update_error(ddx_error, "constants_init: `si_rnode, " // &
                    & "sk_rnode allocation failed")
                return
            end if
            do i = 1, constants % nclusters
                z = constants % rnode(i) * params % kappa
                s1 = sqrt(two/(pi*real(z)))
                s2 = sqrt(pi/(two*real(z)))
                call cbesk(z, pt5, 1, 1, bessel_work(1), NZ, ierr)
                constants % SK_rnode(1, i) = s1 * real(bessel_work(1))
                call cbesi(z, pt5, 1, 1, bessel_work(1), NZ, ierr)
                constants % SI_rnode(1, i) = s2 * real(bessel_work(1))
                if (tmp_pmax .gt. 0) then
                    call cbesk(z, 1.5d0, 1, tmp_pmax, bessel_work(2:), NZ, ierr)
                    constants % SK_rnode(2:, i) = s1 * real(bessel_work(2:tmp_pmax+1))
                    call cbesi(z, 1.5d0, 1, tmp_pmax, bessel_work(2:), NZ, ierr)
                    constants % SI_rnode(2:, i) = s2 * real(bessel_work(2:tmp_pmax+1))
                end if
            end do
        end if
        deallocate(vylm, SK_rijn, DK_rijn, bessel_work, stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_init: `vylm`, `SK_rijn` " // &
                & "and `DK_rijn` deallocations failed")
            return
        end if
        ! if doing incore build nonzero blocks of B
        if (params % matvecmem .eq. 1) then
            call build_b(constants, params, ddx_error)
            if (ddx_error % flag .ne. 0) then
                call update_error(ddx_error, "build_b returned an " // &
                    & "error, exiting")
                return
            end if
        end if
    end if
    deallocate(vplm, vcos, vsin, stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "constants_init: `vplm`, `vcos` and " // &
            & "`vsin` deallocations failed")
        return
    end if
    ! if doing incore build nonzero blocks of L
    if (params % matvecmem .eq. 1) then
        call build_itrnl(constants, params, ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, "build_itrnl returned an " // &
                & "error, exiting")
            return
        end if
        call build_l(constants, params, ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, "build_l returned an " // &
                & "error, exiting")
            return
        end if
    end if
end subroutine constants_init

!> Build the transposed neighbor list
subroutine build_itrnl(constants, params, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    integer :: isph, ij, jsph, ji, istat

    allocate(constants % itrnl(constants % inl(params % nsph + 1)), stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, 'Allocation failed in build_itrnl')
        return
    end if

    do isph = 1, params % nsph
        do ij = constants % inl(isph), constants % inl(isph + 1) - 1
            jsph = constants % nl(ij)
            do ji = constants % inl(jsph), constants % inl(jsph + 1) - 1
                if (constants % nl(ji) .eq. isph) exit
            end do
            constants % itrnl(ij) = ji
        end do
    end do
end subroutine build_itrnl

!> Allocate and build the ddCOSMO sparse matrix, only if incore is set
subroutine build_l(constants, params, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    integer :: isph, ij, jsph, igrid, l, m, ind, info
    real(dp), dimension(3) :: vij, sij
    real(dp) :: vvij, tij, xij, oij, rho, ctheta, stheta, cphi, sphi, &
        & fac, tt, thigh
    real(dp), dimension(constants % nbasis) :: vylm, vplm
    real(dp), dimension(params % lmax + 1) :: vcos, vsin
    real(dp), dimension(constants % nbasis, params % ngrid) :: scratch
    real(dp) :: t

    allocate(constants % l(constants % nbasis, constants % nbasis, &
        & constants % inl(params % nsph + 1)), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, 'Allocation failed in build_l')
        return
    end if

    thigh = one + pt5*(params % se + one)*params % eta

    t = omp_get_wtime()
    !$omp parallel do default(none) shared(params,constants,thigh) &
    !$omp private(isph,ij,jsph,scratch,igrid,vij,vvij,tij,sij,xij,oij, &
    !$omp rho,ctheta,stheta,cphi,sphi,vylm,vplm,vcos,vsin,l,fac,ind,m,tt)
    do isph = 1, params % nsph
        do ij = constants % inl(isph), constants % inl(isph + 1) - 1
            jsph = constants % nl(ij)
            scratch = zero
            do igrid = 1, params % ngrid
                if (constants % ui(igrid, isph).eq.one) cycle
                vij = params % csph(:, isph) &
                    & + params % rsph(isph)*constants % cgrid(:,igrid) &
                    & - params % csph(:, jsph)
                vvij = sqrt(dot_product(vij, vij))
                tij = vvij/params % rsph(jsph)
                if (tij.lt.thigh) then
                    if (tij.ne.zero) then
                        sij = vij/vvij
                    else
                        sij = one
                    end if
                    xij = fsw(tij, params % se, params % eta)
                    if (constants % fi(igrid, isph).gt.one) then
                        oij = xij/constants % fi(igrid, isph)
                    else
                        oij = xij
                    end if
                    call ylmbas(sij, rho, ctheta, stheta, cphi, sphi, &
                        & params % lmax, constants % vscales, vylm, vplm, &
                        & vcos, vsin)
                    tt = oij
                    do l = 0, params % lmax
                        ind = l*l + l + 1
                        fac = - tt/(constants % vscales(ind)**2)
                        do m = -l, l
                            scratch(ind + m, igrid) = fac*vylm(ind + m)
                        end do
                        tt = tt*tij
                    end do
                end if
            end do
            call dgemm('n', 't', constants % nbasis, constants % nbasis, params % ngrid, &
                & one, constants % vwgrid, constants % vgrid_nbasis, scratch, &
                & constants % nbasis, zero, constants % l(:,:,ij), constants % nbasis)
        end do
    end do
end subroutine build_l

!> Allocate and build the HSP sparse matrix, only if incore is set
subroutine build_b(constants, params, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    integer :: isph, ij, jsph, igrid, l, m, ind
    real(dp), dimension(3) :: vij, sij
    real(dp) :: vvij, tij, xij, oij, rho, ctheta, stheta, cphi, sphi, &
        & fac, vvtij, thigh
    real(dp), dimension(constants % nbasis) :: vylm, vplm
    real(dp), dimension(params % lmax + 1) :: vcos, vsin
    complex(dp), dimension(max(2, params % lmax + 1)) :: bessel_work
    real(dp), dimension(0:params % lmax) :: SI_rijn, DI_rijn
    real(dp), dimension(constants % nbasis, params % ngrid) :: scratch
    real(dp) :: t
    integer :: info

    allocate(constants % b(constants % nbasis, constants % nbasis, &
        & constants % inl(params % nsph + 1)), stat=info)
    if (info.ne.0) then
        call update_error(ddx_error, "Allocation failed in build_b")
        return
    end if

    thigh = one + pt5*(params % se + one)*params % eta

    t = omp_get_wtime()
    !$omp parallel do default(none) shared(params,constants,thigh) &
    !$omp private(isph,ij,jsph,scratch,igrid,vij,vvij,tij,sij,xij,oij, &
    !$omp rho,ctheta,stheta,cphi,sphi,vylm,vplm,vcos,vsin,si_rijn,di_rijn, &
    !$omp vvtij,l,fac,ind,m,bessel_work)
    do isph = 1, params % nsph
        do ij = constants % inl(isph), constants % inl(isph + 1) - 1
            jsph = constants % nl(ij)
            scratch = zero
            do igrid = 1, params % ngrid
                if (constants % ui(igrid, isph).eq.one) cycle
                vij = params % csph(:, isph) &
                    & + params % rsph(isph)*constants % cgrid(:,igrid) &
                    & - params % csph(:, jsph)
                vvij = sqrt(dot_product(vij, vij))
                tij = vvij/params % rsph(jsph)
                if (tij.lt.thigh) then
                    if (tij.ne.zero) then
                        sij = vij/vvij
                    else
                        sij = one
                    end if
                    xij = fsw(tij, params % se, params % eta)
                    if (constants % fi(igrid, isph).gt.one) then
                        oij = xij/constants % fi(igrid, isph)
                    else
                        oij = xij
                    end if
                    call ylmbas(sij, rho, ctheta, stheta, cphi, sphi, &
                        & params % lmax, constants % vscales, vylm, vplm, &
                        & vcos, vsin)
                    SI_rijn = 0
                    DI_rijn = 0
                    vvtij = vvij*params % kappa
                    call modified_spherical_bessel_first_kind(params % lmax, &
                        & vvtij, SI_rijn, DI_rijn, bessel_work)
                    do l = 0, params % lmax
                        fac = - oij*SI_rijn(l)/constants % SI_ri(l, jsph)
                        ind = l*l + l + 1
                        do m = -l, l
                            scratch(ind + m, igrid) = fac*vylm(ind + m)
                        end do
                    end do
                end if
            end do
            call dgemm('n', 't', constants % nbasis, constants % nbasis, params % ngrid, &
                & one, constants % vwgrid, constants % vgrid_nbasis, scratch, &
                & constants % nbasis, zero, constants % b(:,:,ij), constants % nbasis)
        end do
    end do
end subroutine build_b

!> Computation of P_chi
subroutine mkpmat(params, constants, isph, pmat)
    type(ddx_params_type), intent(in)  :: params
    type(ddx_constants_type), intent(in)  :: constants
    integer,  intent(in) :: isph
    real(dp), dimension(constants % nbasis, constants % nbasis0), intent(inout) :: pmat
    integer :: l, m, ind, l0, m0, ind0, its
    real(dp)  :: f, f0
    pmat(:,:) = zero
    do its = 1, params % ngrid
        if (constants % ui(its,isph).ne.0) then
            do l = 0, params % lmax
                ind = l*l + l + 1
                do m = -l,l
                    f = constants % wgrid(its) * constants % vgrid(ind+m,its) * constants % ui(its,isph)
                    do l0 = 0, constants % lmax0
                        ind0 = l0*l0 + l0 + 1
                        do m0 = -l0, l0
                            f0 = constants % vgrid(ind0+m0,its)
                            pmat(ind+m,ind0+m0) = pmat(ind+m,ind0+m0) + f * f0
                        end do
                    end do
                end do
            end do
        end if
    end do
end subroutine mkpmat

!> Initialize geometry-related constants like list of neighbouring spheres
!!
!! This routine does not check ddx_error state of params or constants as it is
!! intended for a low-level use.
!!
!! @param[in] params: Object containing all inputs.
!! @param[inout] constants: Object containing all constants.
!! @param[inout] ddx_error: ddX error
!!
subroutine constants_geometry_init(params, constants, ddx_error)
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    !! Outputs
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Local variables
    real(dp) :: swthr, v(3), maxv, ssqv, vv, t
    integer :: i, isph, jsph, inear, igrid, iwork, jwork, lwork, &
        & old_lwork, icav, info
    integer, allocatable :: work(:, :), tmp_work(:, :)
    real(dp) :: start_time
    !! The code
    ! Prepare FMM structures if needed
    start_time = omp_get_wtime()
    if (params % fmm .eq. 1) then
        ! Allocate space for a cluster tree
        allocate(constants % order(params % nsph), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `order` " &
                & // "allocation failed")
            return
        end if
        constants % nclusters = 2*params % nsph - 1
        allocate(constants % cluster(2, constants % nclusters), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `cluster` " &
                & // "allocation failed")
            return
        end if
        allocate(constants % children(2, constants % nclusters), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: " // &
                & "`children` allocation failed")
            return
        endif
        allocate(constants % parent(constants % nclusters), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `parent` " &
                & // "allocation failed")
            return
        endif
        allocate(constants % cnode(3, constants % nclusters), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `cnode` " &
                & // "allocation failed")
            return
        endif
        allocate(constants % rnode(constants % nclusters), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `rnode` " &
                & // "allocation failed")
            return
        endif
        allocate(constants % snode(params % nsph), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `snode` " &
                & // "allocation failed")
            return
        endif
        allocate(constants % nfar(constants % nclusters), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `nfar` " &
                & // "allocation failed")
            return
        endif
        allocate(constants % nnear(constants % nclusters), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `nnear` " &
                & // "allocation failed")
            return
        endif
        ! Get the tree
        call tree_rib_build(params % nsph, params % csph, params % rsph, &
            & constants % order, constants % cluster, constants % children, &
            & constants % parent, constants % cnode, constants % rnode, &
            & constants % snode, ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, "tree_rib_build returned an " // &
                & "ddx_error, exiting")
            return
        end if
        ! Get number of far and near admissible pairs
        iwork = 0
        jwork = 1
        lwork = 1
        allocate(work(3, lwork), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `work` " &
                & // "allocation failed")
            return
        end if
        do while (iwork .le. jwork)
            allocate(tmp_work(3, lwork), stat=info)
            if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: " // &
                    & "`tmp_work` allocation failed")
                return
            end if
            tmp_work = work
            deallocate(work, stat=info)
            if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: " // &
                    & "`work` deallocation failed")
                return
            end if
            old_lwork = lwork
            lwork = old_lwork + 1000*params % nsph
            allocate(work(3, lwork), stat=info)
            if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: " // &
                    & "`work` allocation failed")
                return
            end if
            work(:, 1:old_lwork) = tmp_work
            deallocate(tmp_work, stat=info)
            if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: " // &
                    & "`tmp_work` deallocation failed")
                return
            end if
            call tree_get_farnear_work(constants % nclusters, &
                & constants % children, constants % cnode, &
                & constants % rnode, lwork, iwork, jwork, work, &
                & constants % nnfar, constants % nfar, constants % nnnear, &
                & constants % nnear)
        end do
        allocate(constants % sfar(constants % nclusters+1), &
            & constants % snear(constants % nclusters+1), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `sfar` " // &
                & "and `snear` allocations failed")
            return
        end if
        allocate(constants % far(constants % nnfar), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `far` " // &
                & "allocation failed")
            return
        end if
        allocate(constants % near(constants % nnnear), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `near` " // &
                & "allocation failed")
            return
        end if
        call tree_get_farnear(jwork, lwork, work, constants % nclusters, &
            & constants % nnfar, constants % nfar, constants % sfar, &
            & constants % far, constants % nnnear, constants % nnear, &
            & constants % snear, constants % near)
        deallocate(work, stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `work` " // &
                & "deallocation failed")
            return
        end if
    end if
    ! Upper bound of switch region. Defines intersection criterion for spheres
    swthr = one + (params % se+one)*params % eta/two
    ! Assemble neighbor list
    if (params % fmm .eq. 1) then
        call neighbor_list_init_fmm(params, constants, ddx_error)
    else
        call neighbor_list_init(params, constants, ddx_error)
    end if
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "Neighbor list construction failed")
        return
    end if
    ! Allocate space for characteristic functions fi and ui
    allocate(constants % fi(params % ngrid, params % nsph), &
        & constants % ui(params % ngrid, params % nsph), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "`fi` and `ui` allocations failed")
        return
    end if
    constants % fi = zero
    constants % ui = zero
    ! Allocate space for force-related arrays
    if (params % force .eq. 1) then
        allocate(constants % zi(3, params % ngrid, params % nsph), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "`zi` allocation failed")
            return
        endif
        constants % zi = zero

        allocate(constants % zi_dr(params % ngrid, params % nsph), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "`zi_dr` allocation failed")
            return
        endif
        constants % zi_dr = zero
    end if
    ! Build arrays fi, ui, zi
    !$omp parallel do default(none) shared(params,constants,swthr) &
    !$omp private(isph,igrid,jsph,v,maxv,ssqv,vv,t) schedule(dynamic)
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            ! Loop over neighbours of i-th sphere
            do inear = constants % inl(isph), constants % inl(isph+1)-1
                ! Neighbour's index
                jsph = constants % nl(inear)
                ! Compute t_n^ij
                v = params % csph(:, isph) - params % csph(:, jsph) + &
                    & params % rsph(isph)*constants % cgrid(:, igrid)
                maxv = max(abs(v(1)), abs(v(2)), abs(v(3)))
                if (maxv .gt. zero) then
                    ssqv = (v(1)/maxv)**2 + (v(2)/maxv)**2 + (v(3)/maxv)**2
                else
                    ssqv = zero
                end if
                vv = maxv * sqrt(ssqv)
                t = vv / params % rsph(jsph)
                ! Accumulate characteristic function \chi(t_n^ij)
                constants % fi(igrid, isph) = constants % fi(igrid, isph) + &
                    & fsw(t, params % se, params % eta)
                ! Check if gradients are required
                if (params % force .eq. 1) then
                    ! Check if t_n^ij belongs to switch region
                    if ((t .lt. swthr) .and. (t .gt. swthr-params % eta)) then
                        ! Accumulate gradient of characteristic function \chi
                        vv = dfsw(t, params % se, params % eta) / &
                            & params % rsph(jsph) / vv
                        constants % zi(:, igrid, isph) = &
                            & constants % zi(:, igrid, isph) + vv*v
                        constants % zi_dr(igrid, isph) = &
                            & constants % zi_dr(igrid, isph) &
                            & + vv*dot_product(v, constants % cgrid(:, igrid))
                    end if
                end if
            enddo
            ! Compute characteristic function of a molecular surface ui
            if (constants % fi(igrid, isph) .le. one) then
                constants % ui(igrid, isph) = one - constants % fi(igrid, isph)
            end if
        enddo
    enddo
    ! Build cavity array. At first get total count for each sphere
    allocate(constants % ncav_sph(params % nsph), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "`ncav_sph` allocation failed")
        return
    endif
    !$omp parallel do default(none) shared(params,constants) &
    !$omp private(isph,i) schedule(dynamic)
    do isph = 1, params % nsph
        constants % ncav_sph(isph) = 0
        ! Loop over integration points
        do i = 1, params % ngrid
            ! Positive contribution from integration point
            if (constants % ui(i, isph) .gt. zero) then
                constants % ncav_sph(isph) = constants % ncav_sph(isph) + 1
            end if
        end do
    end do
    constants % ncav = sum(constants % ncav_sph)
    ! Allocate cavity array and CSR format for indexes of cavities
    allocate(constants % ccav(3, constants % ncav), &
        & constants % icav_ia(params % nsph+1), &
        & constants % icav_ja(constants % ncav), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "`ccav`, `icav_ia` and " // &
            & "`icav_ja` allocations failed")
        return
    endif
    ! Allocate space for characteristic functions ui at cavity points
    allocate(constants % ui_cav(constants % ncav), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "`ui_cav` allocations failed")
        return
    end if
    ! Get actual cavity coordinates and indexes in CSR format and fill in
    ! ui_cav aray
    constants % icav_ia(1) = 1
    icav = 1
    do isph = 1, params % nsph
        constants % icav_ia(isph+1) = constants % icav_ia(isph) + &
            & constants % ncav_sph(isph)
        ! Loop over integration points
        do igrid = 1, params % ngrid
            ! Ignore zero contribution
            if (constants % ui(igrid, isph) .eq. zero) cycle
            ! Store coordinates
            constants % ccav(:, icav) = params % csph(:, isph) + &
                & params % rsph(isph)* &
                & constants % cgrid(:, igrid)
            ! Store index
            constants % icav_ja(icav) = igrid
            ! Store characteristic function
            constants % ui_cav(icav) = constants % ui(igrid, isph)
            ! Advance cavity array index
            icav = icav + 1
        end do
    end do
    ! Compute diagonal preconditioner for PCM equations
    if (params % model .eq. 2) then
        allocate(constants % rx_prc( &
            & constants % nbasis, constants % nbasis, params % nsph), &
            & stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "constants_geometry_init: `rx_prc` " &
                & // "allocation failed")
            return
        endif
        call mkprec(params % lmax, constants % nbasis, params % nsph, &
            & params % ngrid, params % eps, constants % ui, &
            & constants % wgrid, constants % vgrid, constants % vgrid_nbasis, &
            & constants % rx_prc, ddx_error)
        if (info .ne. 0) then
            call update_error(ddx_error, "mkprec returned an ddx_error, exiting")
            return
        end if
    end if
end subroutine constants_geometry_init

!> Build the neighbor list using a N^2 code
subroutine neighbor_list_init(params, constants, ddx_error)
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp) :: swthr, v(3), maxv, ssqv, vv, r
    integer :: nngmax, i, lnl, isph, jsph, info
    integer, allocatable :: tmp_nl(:)
    ! Upper bound of switch region. Defines intersection criterion for spheres
    swthr = (params % se+one)*params % eta/two
    ! Build list of neighbours in CSR format
    nngmax = 1
    allocate(constants % inl(params % nsph+1), &
        & constants % nl(params % nsph*nngmax), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "`inl` and `nl` allocations failed")
        return
    end if
    i = 1
    lnl = 0
    do isph = 1, params % nsph
        constants % inl(isph) = lnl + 1
        do jsph = 1, params % nsph
            if (isph .ne. jsph) then
                v = params % csph(:, isph)-params % csph(:, jsph)
                maxv = max(abs(v(1)), abs(v(2)), abs(v(3)))
                if (maxv .gt. zero) then
                    ssqv = (v(1)/maxv)**2 + (v(2)/maxv)**2 + (v(3)/maxv)**2
                else
                    ssqv = zero
                end if
                vv = maxv * sqrt(ssqv)
                ! Take regularization parameter into account with respect to
                ! shift se. It is described properly by the upper bound of a
                ! switch region `swthr`. Note that we take the largest
                ! switching region as we need a symmetric neighbor list to
                ! use it also for the adjoint products.
                r = params % rsph(isph) + params % rsph(jsph) &
                    & + swthr * max(params % rsph(isph), params % rsph(jsph))
                if (vv .le. r) then
                    constants % nl(i) = jsph
                    i  = i + 1
                    lnl = lnl + 1
                    ! Extend ddx_data % nl if needed
                    if (i .gt. params % nsph*nngmax) then
                        allocate(tmp_nl(params % nsph*nngmax), stat=info)
                        if (info .ne. 0) then
                            call update_error(ddx_error, "`tmp_nl` " // &
                                & "allocation failed")
                            return
                        end if
                        tmp_nl(1:params % nsph*nngmax) = &
                            & constants % nl(1:params % nsph*nngmax)
                        deallocate(constants % nl, stat=info)
                        if (info .ne. 0) then
                            call update_error(ddx_error, "`nl` " // &
                                & "deallocation failed")
                            return
                        end if
                        nngmax = nngmax + 10
                        allocate(constants % nl(params % nsph*nngmax), &
                            & stat=info)
                        if (info .ne. 0) then
                            call update_error(ddx_error, "`nl` " // &
                                & "allocation failed")
                            return
                        end if
                        constants % nl(1:params % nsph*(nngmax-10)) = &
                            & tmp_nl(1:params % nsph*(nngmax-10))
                        deallocate(tmp_nl, stat=info)
                        if (info .ne. 0) then
                            call update_error(ddx_error, "`tmp_nl` " // &
                                & "deallocation failed")
                            return
                        end if
                    end if
                end if
            end if
        end do
    end do
    constants % inl(params % nsph+1) = lnl+1
    constants % nngmax = nngmax
end subroutine neighbor_list_init

!> Build the neighbor list using a linear scaling code (only if FMMs
!! are enabled)
subroutine neighbor_list_init_fmm(params, constants, ddx_error)
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp) :: swthr, v(3), maxv, ssqv, vv, r
    integer :: nngmax, i, lnl, isph, jsph, inode, jnode, j, k, info
    integer, allocatable :: tmp_nl(:)
    ! Upper bound of switch region. Defines intersection criterion for spheres
    swthr = (params % se+one)*params % eta/two
    ! Build list of neighbours in CSR format
    nngmax = 1
    allocate(constants % inl(params % nsph+1), &
        & constants % nl(params % nsph*nngmax), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "`inl` and `nl` allocations failed")
        return
    end if
    i = 1
    lnl = 0
    ! loop over leaf clusters
    do isph = 1, params % nsph
        constants % inl(isph) = lnl + 1
        inode = constants % snode(isph)
        ! loop over near clusters
        do j = constants % snear(inode), constants % snear(inode+1) - 1
            jnode = constants % near(j)
            do k = constants % cluster(1, jnode), constants % cluster(2, jnode)
                jsph = constants % order(k)
                if (isph .ne. jsph) then
                    v = params % csph(:, isph)-params % csph(:, jsph)
                    maxv = max(abs(v(1)), abs(v(2)), abs(v(3)))
                    if (maxv .gt. zero) then
                        ssqv = (v(1)/maxv)**2 + (v(2)/maxv)**2 + (v(3)/maxv)**2
                    else
                        ssqv = zero
                    end if
                    vv = maxv * sqrt(ssqv)
                    ! Take regularization parameter into account with respect to
                    ! shift se. It is described properly by the upper bound of a
                    ! switch region `swthr`. Note that we take the largest
                    ! switching region as we need a symmetric neighbor list to
                    ! use it also for the adjoint products.
                    r = params % rsph(isph) + params % rsph(jsph) &
                        & + swthr * max(params % rsph(isph), params % rsph(jsph))
                    if (vv .le. r) then
                        constants % nl(i) = jsph
                        i  = i + 1
                        lnl = lnl + 1
                        ! Extend ddx_data % nl if needed
                        if (i .gt. params % nsph*nngmax) then
                            allocate(tmp_nl(params % nsph*nngmax), stat=info)
                            if (info .ne. 0) then
                                call update_error(ddx_error, "`tmp_nl` " // &
                                    & "allocation failed")
                                return
                            end if
                            tmp_nl(1:params % nsph*nngmax) = &
                                & constants % nl(1:params % nsph*nngmax)
                            deallocate(constants % nl, stat=info)
                            if (info .ne. 0) then
                                call update_error(ddx_error, "`nl` " // &
                                    & "deallocation failed")
                                return
                            end if
                            nngmax = nngmax + 10
                            allocate(constants % nl(params % nsph*nngmax), &
                                & stat=info)
                            if (info .ne. 0) then
                                call update_error(ddx_error, "`nl` " // &
                                    & "allocation failed")
                                return
                            end if
                            constants % nl(1:params % nsph*(nngmax-10)) = &
                                & tmp_nl(1:params % nsph*(nngmax-10))
                            deallocate(tmp_nl, stat=info)
                            if (info .ne. 0) then
                                call update_error(ddx_error, "`tmp_nl` " // &
                                    & "deallocation failed")
                                return
                            end if
                        end if
                    end if
                end if
            end do
        end do
    end do
    constants % inl(params % nsph+1) = lnl+1
    constants % nngmax = nngmax
end subroutine neighbor_list_init_fmm

!> Switching function
!!
!! This is an implementation of \f$ \chi(t) \f$ with a shift \f$ se \f$:
!! \f[
!!      \chi_\eta(t) = \left\{ \begin{array}{ll} 0, & \text{if} \quad x \geq
!!      1 \\ p_\eta(x), & \text{if} \quad 1-\eta < x < 1 \\ 1, & \text{if}
!!      \quad x \leq 1-\eta \end{array} \right.
!! \f]
!! where \f$ x = t - \frac{1+se}{2} \eta \f$ is a shifted coordinate and
!! \f[
!!      p_\eta(x) = \frac{1}{\eta^5} (1-t)^3 (6t^2 + (15\eta-12)t + (10\eta^2
!!      -15\eta+6))
!! \f]
!! is a smoothing polynomial of the 5th degree.
!! In the case shift \f$ se=1 \f$ the switch function \f$ \chi_\eta(t) \f$ is 1 for
!! \f$ t \in [0,1] \f$, is 0 for \f$ t \in [1+\eta, \infty) \f$ and varies in
!! \f$ [1, 1+\eta] \f$ which is an external shift.
!! In the case shift \f$ se=-1 \f$ the switch function \f$ \chi_\eta(t) \f$ is 1 for
!! \f$ t \in [0,1-\eta] \f$, is 0 for \f$ t \in [1, \infty) \f$ and varies in
!! \f$ [1-\eta, 1] \f$ which is an internal shift.
!! In the case shift \f$ se=0 \f$ the switch function \f$ \chi_\eta(t) \f$ is 1 for
!! \f$ t \in [0,1-\eta/2] \f$, is 0 for \f$ t \in [1+\eta/2, \infty) \f$ and
!! varies in \f$ [1-\eta/2, 1+\eta/2] \f$ which is a centered shift.
!!
!! @param[in] t: real non-negative input value
!! @param[in] se: shift
!! @param[in] eta: regularization parameter \f$ \eta \f$
real(dp) function fsw(t, se, eta)
    ! Inputs
    real(dp), intent(in) :: t, se, eta
    ! Local variables
    real(dp) :: a, b, c, x
    ! Apply shift:
    !   se =  0   =>   t - eta/2  [ CENTERED ]
    !   se =  1   =>   t - eta    [ EXTERIOR ]
    !   se = -1   =>   t          [ INTERIOR ]
    x = t - (se*pt5 + pt5)*eta
    ! a must be in range (0,eta) for the switch region
    a = one - x
    ! Define switch function chi
    ! a <= 0 corresponds to the outside region
    if (a .le. zero) then
        fsw = zero
    ! a >= eta corresponds to the inside region
    else if (a .ge. eta) then
        fsw = one
    ! Switch region wher x is in range (1-eta,1)
    else
        ! Normalize a to region (0,1)
        a = a / eta
        b = 6d0*a - 15
        c = b*a + 10
        fsw = a * a * a * c
    end if
end function fsw

!> Derivative of a switching function
!!
!! This is an implementation of \f$ \chi'(t) \f$ with a shift \f$ se \f$:
!! \f[
!!      \chi_\eta'(t) = \left\{ \begin{array}{ll} 0, & \text{if} \quad x \geq
!!      1 \\ p'_\eta(x), & \text{if} \quad 1-\eta < x < 1 \\ 0, & \text{if}
!!      \quad x \leq 1-\eta \end{array} \right.
!! \f]
!! where \f$ x = t - \frac{1+se}{2} \eta \f$ is a shifted coordinate and
!! \f[
!!      p'_\eta(x) = -\frac{30}{\eta^5} (1-t)^2 (t-1+\eta)^2
!! \f]
!! is a derivative of the smoothing polynomial.
!! In the case shift \f$ se=1 \f$ the derivative \f$ \chi_\eta'(t) \f$ is 0 for
!! \f$ t \in [0,1] \cup [1+\eta, \infty) \f$ and varies in
!! \f$ [1, 1+\eta] \f$ which is an external shift.
!! In the case shift \f$ se=-1 \f$ the derivative \f$ \chi_\eta'(t) \f$ is 0 for
!! \f$ t \in [0,1-\eta] \cup [1, \infty) \f$ and varies in
!! \f$ [1-\eta, 1] \f$ which is an internal shift.
!! In the case shift \f$ se=0 \f$ the derivative \f$ \chi_\eta'(t) \f$ is 0 for
!! \f$ t \in [0,1-\eta/2] \cup [1+\eta/2, \infty) \f$ and
!! varies in \f$ [1-\eta/2, 1+\eta/2] \f$ which is a centered shift.
!!
!! @param[in] t: real non-negative input value
!! @param[in] se: shift
!! @param[in] eta: regularization parameter \f$ \eta \f$
real(dp) function dfsw(t, se, eta)
    ! Inputs
    real(dp), intent(in) :: t, se, eta
    ! Local variables
    real(dp) :: flow, x
    real(dp), parameter :: f30=30.0d0
    ! Apply shift:
    !   s =  0   =>   t - eta/2  [ CENTERED ]
    !   s =  1   =>   t - eta    [ EXTERIOR ]
    !   s = -1   =>   t          [ INTERIOR ]
    x = t - (se + 1.d0)*eta / 2.d0
    ! Lower bound of switch region
    flow = one - eta
    ! Define derivative of switch function chi
    if (x .ge. one) then
        dfsw = zero
    else if (x .le. flow) then
        dfsw = zero
    else
        dfsw = -f30 * (( (one-x)*(x-one+eta) )**2) / (eta**5)
    endif
end function dfsw

!> Compute preconditioner
!! assemble the diagonal blocks of the reps matrix
!! then invert them to build the preconditioner
subroutine mkprec(lmax, nbasis, nsph, ngrid, eps, ui, wgrid, vgrid, &
        & vgrid_nbasis, rx_prc, ddx_error)
    !! Inputs
    integer, intent(in) :: lmax, nbasis, nsph, ngrid, vgrid_nbasis
    real(dp), intent(in) :: eps, ui(ngrid, nsph), wgrid(ngrid), &
        & vgrid(vgrid_nbasis, ngrid)
    !! Output
    real(dp), intent(out) :: rx_prc(nbasis, nbasis, nsph)
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Local variables
    integer :: info, isph, lm, l1, m1, ind1, igrid
    real(dp) :: f, f1
    integer, allocatable :: ipiv(:)
    real(dp),  allocatable :: work(:)
    external :: dgetrf, dgetri
    ! Allocation of temporaries
    allocate(ipiv(nbasis), work(nbasis**2), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "mkprec: `ipiv` and `work` allocation failed")
        return
    endif
    ! Init
    rx_prc = zero
    ! Off-diagonal part
    do isph = 1, nsph
        do igrid = 1, ngrid
            f = twopi * ui(igrid, isph) * wgrid(igrid)
            do l1 = 0, lmax
                ind1 = l1*l1 + l1 + 1
                do m1 = -l1, l1
                    f1 = f * vgrid(ind1+m1, igrid) / (two*dble(l1) + one)
                    do lm = 1, nbasis
                        rx_prc(lm, ind1+m1, isph) = &
                            & rx_prc(lm, ind1+m1, isph) + f1*vgrid(lm, igrid)
                    end do
                end do
            end do
        end do
    end do
    ! add diagonal
    f = twopi * (eps+one) / (eps-one)
    do isph = 1, nsph
        do lm = 1, nbasis
            rx_prc(lm, lm, isph) = rx_prc(lm, lm, isph) + f
        end do
    end do
    ! invert the blocks
    do isph = 1, nsph
        call dgetrf(nbasis, nbasis, rx_prc(:, :, isph), nbasis, ipiv, info)
        if (info .ne. 0) then
            call update_error(ddx_error, "mkprec: dgetrf failed")
            return
        end if
        call dgetri(nbasis, rx_prc(:, :, isph), nbasis, ipiv, work, &
            & nbasis**2, info)
        if (info .ne. 0) then 
            call update_error(ddx_error, "mkprec: dgetri failed")
            return
        end if
    end do
    ! Cleanup temporaries
    deallocate(work, ipiv, stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "mkprec: `ipiv` and `work` " // &
            & "deallocation failed")
        return
    end if
end subroutine mkprec

!> Build a recursive inertial binary tree
!!
!! Uses inertial bisection in a recursive manner until each leaf node has only
!! one input sphere inside. Number of tree nodes is always 2*nsph-1.
!!
!!
!! @param[in] nsph: Number of input spheres
!! @param[in] csph: Centers of input spheres
!! @param[in] rsph: Radii of input spheres
!! @param[out] order: Ordering of input spheres to make spheres of one cluster
!!      contiguous.
!! @param[out] cluster: Indexes in `order` array of the first and the last
!!      spheres of each cluster
!! @param[out] children: Indexes of the first and the last children nodes. If
!!      both indexes are equal this means there is only 1 child node and if
!!      value of the first child node is 0, there are no children nodes.
!! @param[out] parent: Parent of each cluster. Value 0 means there is no parent
!!      node which corresponds to the root node (with index 1).
!! @param[out] cnode: Center of a bounding sphere of each node
!! @param[out] rnode: Radius of a bounding sphere of each node
!! @param[out] snode: Array of leaf nodes containing input spheres
!! @param[inout] ddx_error: ddX error
subroutine tree_rib_build(nsph, csph, rsph, order, cluster, children, parent, &
        & cnode, rnode, snode, ddx_error)
    ! Inputs
    integer, intent(in) :: nsph
    real(dp), intent(in) :: csph(3, nsph), rsph(nsph)
    ! Outputs
    integer, intent(out) :: order(nsph), cluster(2, 2*nsph-1), &
        & children(2, 2*nsph-1), parent(2*nsph-1), snode(nsph)
    real(dp), intent(out) :: cnode(3, 2*nsph-1), rnode(2*nsph-1)
    type(ddx_error_type), intent(inout) :: ddx_error
    ! Local variables
    integer :: nclusters, i, j, n, s, e, div
    real(dp) :: r, r1, r2, c(3), c1(3), c2(3), d, maxc
    !! At first construct the tree
    nclusters = 2*nsph - 1
    ! Init the root node
    cluster(1, 1) = 1
    cluster(2, 1) = nsph
    parent(1) = 0
    ! Index of the first unassigned node
    j = 2
    ! Init spheres ordering
    do i = 1, nsph
        order(i) = i
    end do
    ! Divide nodes until a single spheres
    do i = 1, nclusters
        ! The first sphere in i-th node
        s = cluster(1, i)
        ! The last sphere in i-th node
        e = cluster(2, i)
        ! Number of spheres in i-th node
        n = e - s + 1
        ! Divide only if there are 2 or more spheres
        if (n .gt. 1) then
            ! Use inertial bisection to reorder spheres and cut into 2 halfs
            call tree_rib_node_bisect(nsph, csph, n, order(s:e), div, &
                & ddx_error)
            if (ddx_error % flag .ne. 0) then
                call update_error(ddx_error, "tree_rib_node_bisect returned " // &
                    & "an ddx_error, exiting")
                return
            end if
            ! Assign the first half to the j-th node
            cluster(1, j) = s
            cluster(2, j) = s + div - 1
            ! Assign the second half to the (j+1)-th node
            cluster(1, j+1) = s + div
            cluster(2, j+1) = e
            ! Update list of children of i-th node
            children(1, i) = j
            children(2, i) = j + 1
            ! Set parents of new j-th and (j+1)-th node
            parent(j) = i
            parent(j+1) = i
            ! Shift index of the first unassigned node
            j = j + 2
        ! Set information for a leaf node
        else
            ! No children nodes
            children(:, i) = 0
            ! i-th node contains sphere ind(s)
            snode(order(s)) = i
        end if
    end do
    !! Compute bounding spheres of each node of the tree
    ! Bottom-to-top pass over all nodes of the tree
    do i = nclusters, 1, -1
        ! In case of a leaf node just use corresponding input sphere as a
        ! bounding sphere of the node
        if (children(1, i) .eq. 0) then
            ! Get correct index of the corresponding input sphere
            j = order(cluster(1, i))
            ! Get corresponding center and radius
            cnode(:, i) = csph(:, j)
            rnode(i) = rsph(j)
        ! In case of a non-leaf node get minimal sphere that contains bounding
        ! spheres of children nodes
        else
            ! The first child
            j = children(1, i)
            c1 = cnode(:, j)
            r1 = rnode(j)
            ! The second child
            j = children(2, i)
            c2 = cnode(:, j)
            r2 = rnode(j)
            ! Distance between centers of bounding spheres of children nodes
            c = c1 - c2
            ! Compute distance by scale and sum of scaled squares
            maxc = max(abs(c(1)), abs(c(2)), abs(c(3)))
            if (maxc .eq. zero) then
                d = zero
            else
                d = (c(1)/maxc)**2 + (c(2)/maxc)**2 + (c(3)/maxc)**2
                d = maxc * sqrt(d)
            end if
            ! If sphere #2 is completely inside sphere #1 use the first sphere
            if (r1 .ge. (r2+d)) then
                c = c1
                r = r1
            ! If sphere #1 is completely inside sphere #2 use the second sphere
            else if(r2 .ge. (r1+d)) then
                c = c2
                r = r2
            ! Otherwise use special formula to find a minimal sphere
            else
                r = (r1+r2+d) / 2
                c = c2 + c/d*(r-r2)
            end if
            ! Assign computed bounding sphere
            cnode(:, i) = c
            rnode(i) = r
        end if
    end do
end subroutine tree_rib_build

!> Divide given cluster of spheres into two subclusters by inertial bisection
!!
!! @param[in] nsph: Number of all input spheres
!! @param[in] csph: Centers of all input spheres
!! @param[in] n: Number of spheres in a given cluster
!! @param[inout] order: Indexes of spheres in a given cluster. On exit, indexes
!!      `order(1:div)` correspond to the first subcluster and indexes
!!      `order(div+1:n)` correspond to the second subcluster.
!! @param[out] div: Break point of `order` array between two clusters.
!! @param[inout] ddx_error: ddX error
subroutine tree_rib_node_bisect(nsph, csph, n, order, div, ddx_error)
    ! Inputs
    integer, intent(in) :: nsph, n
    real(dp), intent(in) :: csph(3, nsph)
    ! Outputs
    integer, intent(inout) :: order(n)
    integer, intent(out) :: div
    type(ddx_error_type), intent(inout) :: ddx_error
    ! Local variables
    real(dp) :: c(3),  s(3)
    real(dp), allocatable :: tmp_csph(:, :), work(:)
    external :: dgesvd
    integer :: i, l, r, lwork, info, istat
    integer, allocatable :: tmp_order(:)

    allocate(tmp_csph(3, n), tmp_order(n), stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, 'Allocation failed in tree_node_bisect')
        return
    end if

    ! Get average coordinate
    c = zero
    do i = 1, n
        c = c + csph(:, order(i))
    end do
    c = c / n
    ! Get coordinates minus average in a contiguous array
    do i = 1, n
        tmp_csph(:, i) = csph(:, order(i)) - c
    end do
    !! Find right singular vectors
    ! Get proper size of temporary workspace
    lwork = -1
    call dgesvd('N', 'O', 3, n, tmp_csph, 3, s, tmp_csph, 3, tmp_csph, 3, &
        & s, lwork, info)
    lwork = int(s(1))
    allocate(work(lwork), stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, 'Allocation failed in tree_node_bisect')
        return
    end if
    ! Get right singular vectors
    call dgesvd('N', 'O', 3, n, tmp_csph, 3, s, tmp_csph, 3, tmp_csph, 3, &
        & work, lwork, info)
    if (info.ne.0) then
        call update_error(ddx_error, 'DGESVD failed in tree_node_bisect')
        return
    end if
    deallocate(work, stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, 'Deallocation failed in tree_node_bisect')
        return
    end if
    !! Sort spheres by sign of the above scalar product, which is equal to
    !! the leading right singular vector scaled by the leading singular value.
    !! However, we only care about sign, so we take into account only the
    !! leading right singular vector.
    ! First empty index from the left
    l = 1
    ! First empty index from the right
    r = n
    ! Cycle over values of the singular vector
    do i = 1, n
        ! Positive scalar products are moved to the beginning of `order`
        if (tmp_csph(1, i) .ge. zero) then
            tmp_order(l) = order(i)
            l = l + 1
        ! Negative scalar products are moved to the end of `order`
        else
            tmp_order(r) = order(i)
            r = r - 1
        end if
    end do
    ! Set divider and update order
    div = r
    order = tmp_order
    deallocate(tmp_csph, tmp_order, stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, 'Deallocation failed in tree_node_bisect')
        return
    end if
end subroutine tree_rib_node_bisect

!> Find near and far admissible pairs of tree nodes and store it in work array
!!
!! @param[in] n: number of nodes
!! @param[in] children: first and last children of each cluster. Value 0 means
!!      no children (leaf node).
!! @param[in] cnode: center of bounding sphere of each cluster (node) of tree
!! @param[in] rnode: radius of bounding sphere of each cluster (node) of tree
!! @param[in] lwork: size of work array in dimension 2
!! @param[inout] iwork: index of current pair of nodes that needs to be checked
!!      for admissibility. Must be 0 for the first call of this subroutine. If
!!      on exit iwork is less or equal to jwork, that means lwork was too
!!      small, please reallocate work array and copy all the values into new
!!      array and then run procedure again.
!! @param[inout] jwork: amount of stored possible admissible pairs of nodes.
!!      Please read iwork comments.
!! @param[inout] work: all the far and near pairs will be stored here
!! @param[out] nnfar: total amount of far admissible pairs. valid only if iwork
!!      is greater than jwork on exit.
!! @param[out] nfar: amount of far admissible pairs for each node. valid only
!!      if iwork is greater than jwork on exit.
!! @param[out] nnnear: total amount of near admissible pairs. valid only if
!!      iwork is greater than jwork on exit
!! @param[out] nnear: amount of near admissible pairs for each node. valid only
!!      if iwork is greater than jwork on exit
subroutine tree_get_farnear_work(n, children, cnode, rnode, lwork, iwork, &
        & jwork, work, nnfar, nfar, nnnear, nnear)
    ! Inputs
    integer, intent(in) :: n, children(2, n), lwork
    real(dp), intent(in) :: cnode(3, n), rnode(n)
    ! Outputs
    integer, intent(inout) :: iwork, jwork, work(3, lwork)
    integer, intent(out) :: nnfar, nfar(n), nnnear, nnear(n)
    ! Local variables
    integer :: j(2), npairs, k1, k2
    real(dp) :: c(3), r, d, dmax, dssq
    ! iwork is current temporary item in work array to process
    if (iwork .eq. 0) then
        work(1, 1) = 1
        work(2, 1) = 1
        iwork = 1
        jwork = 1
    end if
    ! jwork is total amount of temporary items in work array
    do while (iwork .le. jwork)
        j = work(1:2, iwork)
        c = cnode(:, j(1)) - cnode(:, j(2))
        r = rnode(j(1)) + rnode(j(2)) + max(rnode(j(1)), rnode(j(2)))
        !r = rnode(j(1)) + rnode(j(2))
        dmax = max(abs(c(1)), abs(c(2)), abs(c(3)))
        if (dmax .gt. zero) then
            dssq = (c(1)/dmax)**2 + (c(2)/dmax)**2 + (c(3)/dmax)**2
        else
            dssq = zero
        end if
        d = dmax * sqrt(dssq)
        !d = sqrt(c(1)**2 + c(2)**2 + c(3)**2)
        ! If node has no children then assume itself for purpose of finding
        ! far-field and near-filed interactions with children nodes of another
        ! node
        npairs = max(1, children(2, j(1))-children(1, j(1))+1) * &
            & max(1, children(2, j(2))-children(1, j(2))+1)
        if (d .ge. r) then
            ! Mark as far admissible pair
            work(3, iwork) = 1
        else if (npairs .eq. 1) then
            ! Mark as near admissible pair if both nodes are leaves
            work(3, iwork) = 2
        else if (jwork+npairs .gt. lwork) then
            ! Exit procedure, since work array was too small
            return
        else
            ! Mark as non-admissible pair and check all pairs of children nodes
            ! or pairs of one node (if it is a leaf node) with children of
            ! another node
            work(3, iwork) = 0
            if (children(1, j(1)) .eq. 0) then
                k1 = j(1)
                do k2 = children(1, j(2)), children(2, j(2))
                    jwork = jwork + 1
                    work(1, jwork) = k1
                    work(2, jwork) = k2
                end do
            else if(children(1, j(2)) .eq. 0) then
                k2 = j(2)
                do k1 = children(1, j(1)), children(2, j(1))
                    jwork = jwork + 1
                    work(1, jwork) = k1
                    work(2, jwork) = k2
                end do
            else
                do k1 = children(1, j(1)), children(2, j(1))
                    do k2 = children(1, j(2)), children(2, j(2))
                        jwork = jwork + 1
                        work(1, jwork) = k1
                        work(2, jwork) = k2
                    end do
                end do
            end if
        end if
        iwork = iwork + 1
    end do
    nfar = 0
    nnear = 0
    do iwork = 1, jwork
        if (work(3, iwork) .eq. 1) then
            nfar(work(1, iwork)) = nfar(work(1, iwork)) + 1
        else if (work(3, iwork) .eq. 2) then
            nnear(work(1, iwork)) = nnear(work(1, iwork)) + 1
        end if
    end do
    iwork = jwork + 1
    nnfar = sum(nfar)
    nnnear = sum(nnear)
end subroutine tree_get_farnear_work

!> Get near and far admissible pairs from work array of tree_get_farnear_work
!! Works only for binary tree
subroutine tree_get_farnear(jwork, lwork, work, n, nnfar, nfar, sfar, far, &
        & nnnear, nnear, snear, near)
!   Parameters:
!   jwork: Total number of checked pairs in work array
!   lwork: Total length of work array
!   work: Work array itself
!   n: Number of nodes
!   nnfar: Total number of all far-field interactions
!   nfar: Number of far-field interactions of each node
!   sfar: Index in far array of first far-field node for each node
!   far: Indexes of far-field nodes
!   nnnear: Total number of all near-field interactions
!   nnear: Number of near-field interactions of each node
!   snear: Index in near array of first near-field node for each node
!   near: Indexes of near-field nodes
    integer, intent(in) :: jwork, lwork, work(3, lwork), n, nnfar, nnnear
    integer, intent(in) :: nfar(n), nnear(n)
    integer, intent(out) :: sfar(n+1), far(nnfar), snear(n+1), near(nnnear)
    integer :: i, j
    integer, allocatable :: cfar(:), cnear(:)

    allocate(cfar(n+1), cnear(n+1))
    sfar(1) = 1
    snear(1) = 1
    do i = 2, n+1
        sfar(i) = sfar(i-1) + nfar(i-1)
        snear(i) = snear(i-1) + nnear(i-1)
    end do
    cfar = sfar
    cnear = snear
    do i = 1, jwork
        if (work(3, i) .eq. 1) then
            ! Far
            j = work(1, i)
            if ((j .gt. n) .or. (j .le. 0)) then
                write(*,*) "ALARM", j
            end if
            far(cfar(j)) = work(2, i)
            cfar(j) = cfar(j) + 1
        else if (work(3, i) .eq. 2) then
            ! Near
            j = work(1, i)
            if ((j .gt. n) .or. (j .le. 0)) then
                write(*,*) "ALARM", j
            end if
            near(cnear(j)) = work(2, i)
            cnear(j) = cnear(j) + 1
        end if
    end do

    deallocate(cfar, cnear)

end subroutine tree_get_farnear

!> Deallocate the constants
!!
!! @param[out] constants: Precomputed constants
!! @param[inout] ddx_error: ddX error
!!
subroutine constants_free(constants, ddx_error)
    implicit none
    type(ddx_constants_type), intent(out) :: constants
    type(ddx_error_type), intent(inout) :: ddx_error
    integer :: istat

    istat = 0

    if (allocated(constants % vscales)) then
        deallocate(constants % vscales, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`vscales` deallocation failed!")
        end if
    end if
    if (allocated(constants % v4pi2lp1)) then
        deallocate(constants % v4pi2lp1, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`v4pi2lp1` deallocation failed!")
        end if
    end if
    if (allocated(constants % vscales_rel)) then
        deallocate(constants % vscales_rel, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`vscales_rel` deallocation failed!")
        end if
    end if
    if (allocated(constants % vfact)) then
        deallocate(constants % vfact, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`vfact` deallocation failed!")
        end if
    end if
    if (allocated(constants % vcnk)) then
        deallocate(constants % vcnk, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`vcnk` deallocation failed!")
        end if
    end if
    if (allocated(constants % m2l_ztranslate_coef)) then
        deallocate(constants % m2l_ztranslate_coef, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, &
                & "`m2l_ztranslate_coef` deallocation failed!")
        end if
    end if
    if (allocated(constants % m2l_ztranslate_adj_coef)) then
        deallocate(constants % m2l_ztranslate_adj_coef, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, &
                & "`m2l_ztranslate_adj_coef` deallocation failed!")
        end if
    end if
    if (allocated(constants % cgrid)) then
        deallocate(constants % cgrid, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`cgrid` deallocation failed!")
        end if
    end if
    if (allocated(constants % wgrid)) then
        deallocate(constants % wgrid, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`wgrid` deallocation failed!")
        end if
    end if
    if (allocated(constants % vgrid)) then
        deallocate(constants % vgrid, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`vgrid` deallocation failed!")
        end if
    end if
    if (allocated(constants % vwgrid)) then
        deallocate(constants % vwgrid, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`vwgrid` deallocation failed!")
        end if
    end if
    if (allocated(constants % vgrid2)) then
        deallocate(constants % vgrid2, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`vgrid2` deallocation failed!")
        end if
    end if
    if (allocated(constants % pchi)) then
        deallocate(constants % pchi, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`pchi` deallocation failed!")
        end if
    end if
    if (allocated(constants % c_ik)) then
        deallocate(constants % c_ik, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`c_ik` deallocation failed!")
        end if
    end if
    if (allocated(constants % si_ri)) then
        deallocate(constants % si_ri, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`si_ri` deallocation failed!")
        end if
    end if
    if (allocated(constants % di_ri)) then
        deallocate(constants % di_ri, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`di_ri` deallocation failed!")
        end if
    end if
    if (allocated(constants % sk_ri)) then
        deallocate(constants % sk_ri, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`sk_ri` deallocation failed!")
        end if
    end if
    if (allocated(constants % dk_ri)) then
        deallocate(constants % dk_ri, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`dk_ri` deallocation failed!")
        end if
    end if
    if (allocated(constants % termimat)) then
        deallocate(constants % termimat, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`termimat` deallocation failed!")
        end if
    end if
    if (allocated(constants % b)) then
        deallocate(constants % b, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`b` deallocation failed!")
        end if
    end if
    if (allocated(constants % l)) then
        deallocate(constants % l, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`l` deallocation failed!")
        end if
    end if
    if (allocated(constants % inl)) then
        deallocate(constants % inl, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`inl` deallocation failed!")
        end if
    end if
    if (allocated(constants % nl)) then
        deallocate(constants % nl, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`nl` deallocation failed!")
        end if
    end if
    if (allocated(constants % itrnl)) then
        deallocate(constants % itrnl, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`itrnl` deallocation failed!")
        end if
    end if
    if (allocated(constants % fi)) then
        deallocate(constants % fi, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`fi` deallocation failed!")
        end if
    end if
    if (allocated(constants % ui)) then
        deallocate(constants % ui, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`ui` deallocation failed!")
        end if
    end if
    if (allocated(constants % ui_cav)) then
        deallocate(constants % ui_cav, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`ui_cav` deallocation failed!")
        end if
    end if
    if (allocated(constants % zi)) then
        deallocate(constants % zi, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`zi` deallocation failed!")
        end if
    end if
    if (allocated(constants % zi_dr)) then
        deallocate(constants % zi_dr, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`zi_dr` deallocation failed!")
        end if
    end if
    if (allocated(constants % ncav_sph)) then
        deallocate(constants % ncav_sph, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`ncav_sph` deallocation failed!")
        end if
    end if
    if (allocated(constants % ccav)) then
        deallocate(constants % ccav, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`ccav` deallocation failed!")
        end if
    end if
    if (allocated(constants % icav_ia)) then
        deallocate(constants % icav_ia, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`icav_ia` deallocation failed!")
        end if
    end if
    if (allocated(constants % icav_ja)) then
        deallocate(constants % icav_ja, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`icav_ja` deallocation failed!")
        end if
    end if
    if (allocated(constants % rx_prc)) then
        deallocate(constants % rx_prc, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`rx_prc` deallocation failed!")
        end if
    end if
    if (allocated(constants % order)) then
        deallocate(constants % order, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`order` deallocation failed!")
        end if
    end if
    if (allocated(constants % cluster)) then
        deallocate(constants % cluster, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`cluster` deallocation failed!")
        end if
    end if
    if (allocated(constants % children)) then
        deallocate(constants % children, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`children` deallocation failed!")
        end if
    end if
    if (allocated(constants % parent)) then
        deallocate(constants % parent, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`parent` deallocation failed!")
        end if
    end if
    if (allocated(constants % cnode)) then
        deallocate(constants % cnode, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`cnode` deallocation failed!")
        end if
    end if
    if (allocated(constants % rnode)) then
        deallocate(constants % rnode, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`rnode` deallocation failed!")
        end if
    end if
    if (allocated(constants % snode)) then
        deallocate(constants % snode, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`snode` deallocation failed!")
        end if
    end if
    if (allocated(constants % sk_rnode)) then
        deallocate(constants % sk_rnode, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`sk_rnode` deallocation failed!")
        end if
    end if
    if (allocated(constants % si_rnode)) then
        deallocate(constants % si_rnode, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`si_rnode` deallocation failed!")
        end if
    end if
    if (allocated(constants % nfar)) then
        deallocate(constants % nfar, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`nfar` deallocation failed!")
        end if
    end if
    if (allocated(constants % nnear)) then
        deallocate(constants % nnear, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`nnear` deallocation failed!")
        end if
    end if
    if (allocated(constants % far)) then
        deallocate(constants % far, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`far` deallocation failed!")
        end if
    end if
    if (allocated(constants % near)) then
        deallocate(constants % near, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`near` deallocation failed!")
        end if
    end if
    if (allocated(constants % sfar)) then
        deallocate(constants % sfar, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`sfar` deallocation failed!")
        end if
    end if
    if (allocated(constants % snear)) then
        deallocate(constants % snear, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`snear` deallocation failed!")
        end if
    end if
    if (allocated(constants % m2l_ztranslate_coef)) then
        deallocate(constants % m2l_ztranslate_coef, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`m2l_ztranslate_coef` " // &
                & "deallocation failed!")
        end if
    end if
    if (allocated(constants % m2l_ztranslate_adj_coef)) then
        deallocate(constants % m2l_ztranslate_adj_coef, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`m2l_ztranslate_adj_coef` " // &
                & "deallocation failed!")
        end if
    end if
end subroutine constants_free

end module ddx_constants

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file src/tblite/io/numpy/constants.f90
!> Constants for npy and npz file format

!> Headers for numpy file formats and zip file format
module tblite_io_numpy_constants
   use mctc_env, only : sp, dp, i2, i4
   implicit none
   private

   public :: &
       magic_number, magic_string, &
       type_i1, type_i2, type_i4, type_i8, type_rsp, type_rdp, type_csp, type_cdp, &
       zip_global_sig, zip_local_sig, zip_footer_sig, zip_min_version

   character(len=*), parameter :: &
       type_i1 = "<i1", type_i2 = "<i2", type_i4 = "<i4", type_i8 = "<i8", &
       type_rsp = "<f4", type_rdp = "<f8", type_csp = "<c8", type_cdp = "<c16"

   character(len=*), parameter :: &
       & magic_number = char(int(z"93")), &
       & magic_string = "NUMPY"

   integer(i4), parameter :: &
       & zip_global_sig = int(z'02014b50', i4), &
       & zip_local_sig = int(z'04034b50', i4), &
       & zip_footer_sig = int(z'06054b50', i4)

   integer(i2), parameter :: zip_min_version = 20_i2

end module tblite_io_numpy_constants

! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/post-processing/xtb-ml/energy.f90
!> Energy-based xTB-ML features
module tblite_post_processing_xtbml_energy
   use mctc_env, only : wp, error_type
   use mctc_io, only : structure_type
   use tblite_basis_type, only : basis_type
   use tblite_container, only : container_type, container_cache
   use tblite_container_list, only : cache_list
   use tblite_disp_d3, only : d3_dispersion, new_d3_dispersion
   use tblite_disp_d4, only : d4_dispersion, new_d4_dispersion
   use tblite_double_dictionary, only : double_dictionary_type
   use tblite_integral_type, only : integral_type
   use tblite_post_processing_xtbml_cache, only : xtbml_cache
   use tblite_post_processing_xtbml_convolution, only : xtbml_convolution
   use tblite_post_processing_xtbml_features, only : xtbml_feature_type
   use tblite_scf_iterator, only : get_electronic_energy, reduce
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_coulomb, only : tb_coulomb
   implicit none
   private

   public :: xtbml_energy_features, new_xtbml_energy_features

   !> Energy-based xTB-ML features
   type, extends(xtbml_feature_type) :: xtbml_energy_features

   contains
      !> Compute xtb-ML energy-based features
      procedure :: compute_features
      !> Compute extended xtb-ML energy-based features with convolution
      procedure :: compute_extended
   end type xtbml_energy_features

   character(len=*), parameter :: label = "energy-based features"

contains


!> Factory for new energy-based xTB-ML feature container
subroutine new_xtbml_energy_features(self)
   !> Instance of the xTB-ML energy features
   class(xtbml_energy_features), intent(out) :: self

   self%label = label

end subroutine new_xtbml_energy_features


!> Compute energy-based features
!> all contributions to the molecular energy are computed here
!> and stored in the feature container
subroutine compute_features(self, mol, wfn, ints, calc, caches, mlcache, &
   & dict, n_features, error)
   !> Instance of the xTB-ML energy features
   class(xtbml_energy_features), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction strcuture data
   type(wavefunction_type), intent(in) :: wfn
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Single-point calculator
   type(xtb_calculator), intent(in) :: calc
   !> Cache list for storing caches of various interactions
   type(cache_list), intent(inout) :: caches
   !> Cache for xTB-ML features
   type(xtbml_cache), intent(inout) :: mlcache
   !> Dictionary for storing results
   type(double_dictionary_type), intent(inout) :: dict
   !> Number of features
   integer, intent(inout) :: n_features
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(d3_dispersion), allocatable :: d3
   type(d4_dispersion), allocatable :: d4
   class(container_type), allocatable :: cont
   real(wp), allocatable :: tmp_energy(:), e_ao(:), e_disp_tot(:), e_disp_ATM(:), tot_energy(:)

   allocate(e_ao(calc%bas%nao), source=0.0_wp)
   allocate(tmp_energy(mol%nat), tot_energy(mol%nat),source=0.0_wp)
   call get_electronic_energy(ints%hamiltonian, wfn%density, e_ao)
   call reduce(tmp_energy, e_ao, calc%bas%ao2at)
   call dict%add_entry("E_eht", tmp_energy)
   n_features = n_features + 1
   tot_energy = tmp_energy
   tmp_energy = 0.0_wp

   if (allocated(calc%repulsion)) then
      associate(cont => calc%repulsion)
         call cont%update(mol, caches%list(1))
         call cont%get_engrad(mol, caches%list(1), tmp_energy)
         call dict%add_entry("E_rep", tmp_energy)
         n_features = n_features + 1
      end associate
   end if

   tot_energy = tot_energy + tmp_energy
   tmp_energy = 0.0_wp
   if (allocated(calc%coulomb)) then
      associate(cont => calc%coulomb)
         call cont%update(mol, caches%list(2))
         if (allocated(cont%es2)) then
            call cont%es2%update(mol, caches%list(2))
            call cont%es2%get_energy(mol, caches%list(2), wfn, tmp_energy)
         end if
         if (allocated(cont%es3)) then
            call cont%es3%update(mol, caches%list(2))
            call cont%es3%get_energy(mol, caches%list(2), wfn, tmp_energy)
         end if
         tot_energy = tot_energy + tmp_energy
         call dict%add_entry("E_ies_ixc", tmp_energy)
         n_features = n_features + 1
         if (allocated(cont%aes2)) then
            tmp_energy = 0.0_wp
            call cont%aes2%get_energy_axc(mol, wfn, tmp_energy)
            call dict%add_entry("E_axc", tmp_energy)
            n_features = n_features + 1
            tot_energy = tot_energy + tmp_energy
            tmp_energy = 0.0_wp
            call cont%aes2%get_energy_aes(mol, caches%list(2), wfn, tmp_energy)
            call dict%add_entry("E_aes", tmp_energy)
            n_features = n_features + 1
            tot_energy = tot_energy + tmp_energy
         end if
      end associate
   end if

   tmp_energy = 0.0_wp
   if (allocated(calc%halogen)) then
      associate(cont => calc%halogen)
         call cont%update(mol, caches%list(3))
         call cont%get_engrad(mol, caches%list(3), tmp_energy)
         call dict%add_entry("E_hx", tmp_energy)
         n_features = n_features + 1
      end associate
   end if

   tot_energy = tot_energy + tmp_energy
   tmp_energy = 0.0_wp
   if (allocated(calc%dispersion)) then
      associate(cont => calc%dispersion)
         select type(cont)
         type is (d3_dispersion)
            allocate(e_disp_tot(mol%nat), e_disp_ATM(mol%nat), source=0.0_wp)
            call cont%update(mol, caches%list(4))
            call cont%get_engrad(mol, caches%list(4), e_disp_tot)

            allocate(d3)
            call new_d3_dispersion(d3, mol, s6=0.0_wp, s8=0.0_wp, a1=cont%param%a1, &
               & a2=cont%param%a2, s9=cont%param%s9, error=error, &
               & disp2_width=cont%cutoff%width2, disp3_width=cont%cutoff%width3)
            if(allocated(error)) return
            call d3%update(mol, caches%list(4))
            call d3%get_engrad(mol, caches%list(4), e_disp_ATM)
            call dict%add_entry("E_disp2", e_disp_tot-e_disp_ATM)
            call dict%add_entry("E_disp3", e_disp_ATM)
            n_features = n_features + 2
            tmp_energy = e_disp_tot
         type is (d4_dispersion)
            allocate(e_disp_tot(mol%nat), e_disp_ATM(mol%nat), source=0.0_wp)
            call cont%update(mol, caches%list(4))
            call cont%get_engrad(mol, caches%list(4), e_disp_tot)
            call cont%get_energy(mol, caches%list(4), wfn, e_disp_tot)

            allocate(d4)
            call new_d4_dispersion(d4, mol, s6=0.0_wp, s8=0.0_wp, a1=cont%param%a1, &
               & a2=cont%param%a2, s9=cont%param%s9, error=error, &
               & disp2_width=cont%cutoff%width2, disp3_width=cont%cutoff%width3)
            if (allocated(error)) return
            call d4%update(mol, caches%list(4))
            call d4%get_engrad(mol, caches%list(4), e_disp_ATM)
            call dict%add_entry("E_disp2", e_disp_tot-e_disp_ATM)
            call dict%add_entry("E_disp3", e_disp_ATM)
            n_features = n_features + 2
            tmp_energy = e_disp_tot
         end select
      end associate
   end if

   tot_energy = tot_energy + tmp_energy
   tmp_energy = 0.0_wp
   if (allocated(calc%interactions)) then
      associate(cont => calc%interactions)
         call cont%get_energy(mol, caches%list(5), wfn, tmp_energy)
         call cont%update(mol, caches%list(5))
         call cont%get_engrad(mol, caches%list(5), tmp_energy)
         call dict%add_entry(cont%info(0, ""), tmp_energy)
      end associate
   end if

   tot_energy = tot_energy + tmp_energy
   call dict%add_entry("E_tot", tot_energy)
   call dict%add_entry("w_tot", tot_energy/sum(tot_energy))
   n_features = n_features + 2

end subroutine compute_features

!> Compute extended energy-based features, empty for now
subroutine compute_extended(self, mol, wfn, ints, calc, caches, mlcache, &
   & convolution, dict, n_features, error)
   !> Instance of the xTB-ML energy features
   class(xtbml_energy_features), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction strcuture data
   type(wavefunction_type), intent(in) :: wfn
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Single-point calculator
   type(xtb_calculator), intent(in) :: calc
   !> Cache list for storing caches of various interactions
   type(cache_list), intent(inout) :: caches
   !> Cache for xTB-ML features
   type(xtbml_cache), intent(inout) :: mlcache
   !> Convolution container
   type(xtbml_convolution), intent(in) :: convolution
   !> Dictionary for storing results
   type(double_dictionary_type), intent(inout) :: dict
   !> Number of features
   integer, intent(inout) :: n_features
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
end subroutine compute_extended

end module tblite_post_processing_xtbml_energy

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_npy
   use mctc_env, only : dp, error_type, i4
   use mctc_env_testing, only : new_unittest, unittest_type, check, &
      & test_failed
   use tblite_io_numpy, only : save_npy, load_npy
   use tblite_output_format, only : format_string
   implicit none
   private

   public :: collect_npy

contains

subroutine collect_npy(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("write-npy-i4-r1", test_write_npy_i4_rank1), &
      new_unittest("write-npy-rdp-r1", test_write_npy_rdp_rank1), &
      new_unittest("write-npy-rdp-r2", test_write_npy_rdp_rank2), &
      new_unittest("write-npy-rdp-r3", test_write_npy_rdp_rank3), &
      new_unittest("read-npy-i4-r1", test_read_npy_i4_rank1), &
      new_unittest("read-npy-rdp-r1", test_read_npy_rdp_rank1), &
      new_unittest("read-npy-rdp-r2", test_read_npy_rdp_rank2), &
      new_unittest("read-npy-rdp-r3", test_read_npy_rdp_rank3), &
      new_unittest("missing-npy-i4-r1", test_missing_npy_i4_rank1, should_fail=.true.), &
      new_unittest("missing-npy-rdp-r1", test_missing_npy_rdp_rank1, should_fail=.true.), &
      new_unittest("missing-npy-rdp-r2", test_missing_npy_rdp_rank2, should_fail=.true.), &
      new_unittest("missing-npy-rdp-r3", test_missing_npy_rdp_rank3, should_fail=.true.), &
      new_unittest("type-mismatch", test_type_mismatch), &
      new_unittest("rank-mismatch-rdp", test_rank_mismatch_rdp), &
      new_unittest("rank-mismatch-i4", test_rank_mismatch_i4), &
      new_unittest("invalid-major-version", test_invalid_major_version), &
      new_unittest("invalid-minor-version", test_invalid_minor_version), &
      new_unittest("invalid-header-len", test_invalid_header_len), &
      new_unittest("invalid-nul-byte", test_invalid_nul_byte), &
      new_unittest("invalid-key", test_invalid_key), &
      new_unittest("invalid-comma", test_invalid_comma), &
      new_unittest("invalid-string", test_invalid_string), &
      new_unittest("invalid-tuple-literal", test_invalid_tuple_literal), &
      new_unittest("invalid-tuple-comma", test_invalid_tuple_comma), &
      new_unittest("invalid-tuple", test_invalid_tuple), &
      new_unittest("invalid-character", test_invalid_character), &
      new_unittest("invalid-true", test_invalid_true), &
      new_unittest("invalid-false", test_invalid_false), &
      new_unittest("invalid-magic-number", test_invalid_magic_number), &
      new_unittest("invalid-magic-string", test_invalid_magic_string), &
      new_unittest("duplicate-descr", test_duplicate_descr), &
      new_unittest("missing-descr", test_missing_descr), &
      new_unittest("missing-fortran_order", test_missing_fortran_order), &
      new_unittest("missing-shape", test_missing_shape), &
      new_unittest("iomsg-deallocated", test_iomsg_deallocated) &
   ]
end subroutine collect_npy

subroutine test_write_npy_i4_rank1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat, i
   character(len=*), parameter :: filename = ".write-i4-r1.npy"
   integer(i4), allocatable :: input(:), output(:)

   allocate(input(64))
   input = [(i*(i-1), i=size(input), 1, -1)]
   call save_npy(filename, input, stat)

   call check(error, stat, "Writing of npy file failed")
   if (allocated(error)) return

   call load_npy(filename, output, stat)
   call delete_file(filename)

   call check(error, stat, "Reading of npy file failed")
   if (allocated(error)) return

   call check(error, size(output), size(input))
   if (allocated(error)) return

   call check(error, all((output - input) == 0), &
      "Precision loss when rereading array")
end subroutine test_write_npy_i4_rank1

subroutine test_write_npy_rdp_rank1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=*), parameter :: filename = ".write-rdp-r1.npy"
   real(dp), allocatable :: input(:), output(:)

   allocate(input(65535))
   call random_number(input)
   call save_npy(filename, input, stat)

   call check(error, stat, "Writing of npy file failed")
   if (allocated(error)) return

   call load_npy(filename, output, stat)
   call delete_file(filename)

   call check(error, stat, "Reading of npy file failed")
   if (allocated(error)) return

   call check(error, size(output), size(input))
   if (allocated(error)) return

   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_write_npy_rdp_rank1

subroutine test_write_npy_rdp_rank2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=*), parameter :: filename = ".write-rdp-r2.npy"
   real(dp), allocatable :: input(:, :), output(:, :)

   allocate(input(10, 4))
   call random_number(input)
   call save_npy(filename, input, stat)

   call check(error, stat, "Writing of npy file failed")
   if (allocated(error)) return

   call load_npy(filename, output, stat)
   call delete_file(filename)

   call check(error, stat, "Reading of npy file failed")
   if (allocated(error)) return

   call check(error, size(output), size(input))
   if (allocated(error)) return

   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_write_npy_rdp_rank2

subroutine test_write_npy_rdp_rank3(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=*), parameter :: filename = ".write-rdp-r3.npy"
   real(dp), allocatable :: input(:, :, :), output(:, :, :)

   allocate(input(10, 4, 5))
   call random_number(input)
   call save_npy(filename, input, stat)

   call check(error, stat, "Writing of npy file failed")
   if (allocated(error)) return

   call load_npy(filename, output, stat)
   call delete_file(filename)

   call check(error, stat, "Reading of npy file failed")
   if (allocated(error)) return

   call check(error, size(output), size(input))
   if (allocated(error)) return

   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_write_npy_rdp_rank3

subroutine test_read_npy_i4_rank1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr':'<i4', 'shape' : (88,   ) ,'fortran_order' :False }         " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat, i
   character(len=*), parameter :: filename = ".read-i4-r1.npy"
   integer(i4), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(88))
   input = [(i*(i+1), i=size(input), 1, -1)]

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) input
   close(io)

   call load_npy(filename, output, stat, msg)
   call delete_file(filename)

   call check(error, stat, "Reading of npy file failed", msg)
   if (allocated(error)) return

   call check(error, size(output), size(input))
   if (allocated(error)) return

   call check(error, all((output - input) == 0), &
      "Precision loss when rereading array")
end subroutine test_read_npy_i4_rank1

subroutine test_read_npy_rdp_rank1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr':'<f8', 'shape' : (37 ,  ) , 'fortran_order': False}         " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".read-rdp-r1.npy"
   real(dp), allocatable :: input(:), output(:)

   allocate(input(37))
   call random_number(input)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) input
   close(io)

   call load_npy(filename, output, stat)
   call delete_file(filename)

   call check(error, stat, "Reading of npy file failed")
   if (allocated(error)) return

   call check(error, size(output), 37)
   if (allocated(error)) return

   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_read_npy_rdp_rank1

subroutine test_read_npy_rdp_rank2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }        " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".read-rdp-r2.npy"
   real(dp), allocatable :: input(:, :), output(:, :)

   allocate(input(10, 4))
   call random_number(input)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) input
   close(io)

   call load_npy(filename, output, stat)
   call delete_file(filename)

   call check(error, stat, "Reading of npy file failed")
   if (allocated(error)) return

   call check(error, size(output), size(input))
   if (allocated(error)) return

   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_read_npy_rdp_rank2

subroutine test_read_npy_rdp_rank3(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 2, 2), }       " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(2) // char(0) // &
       char(len(dict)) // char(0) // char(0) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".read-rdp-r3.npy"
   real(dp), allocatable :: input(:, :, :), output(:, :, :)

   allocate(input(10, 2, 2))
   call random_number(input)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) input
   close(io)

   call load_npy(filename, output, stat)
   call delete_file(filename)

   call check(error, stat, "Reading of npy file failed")
   if (allocated(error)) return

   call check(error, size(output), size(input))
   if (allocated(error)) return

   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_read_npy_rdp_rank3

subroutine test_missing_npy_i4_rank1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer(i4), allocatable :: output(:)
   integer :: stat
   character(len=:), allocatable :: msg

   call load_npy(".missing-i4-r1.npy", output, stat, msg)
   call check(error, stat, "Loading npy file failed", msg)
end subroutine test_missing_npy_i4_rank1

subroutine test_missing_npy_rdp_rank1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(dp), allocatable :: output(:)
   integer :: stat
   character(len=:), allocatable :: msg

   call load_npy(".missing-rdp-r1.npy", output, stat, msg)
   call check(error, stat, "Loading npy file failed", msg)
end subroutine test_missing_npy_rdp_rank1

subroutine test_missing_npy_rdp_rank2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(dp), allocatable :: output(:, :)
   integer :: stat
   character(len=:), allocatable :: msg

   call load_npy(".missing-rdp-r2.npy", output, stat, msg)
   call check(error, stat, "Loading npy file failed", msg)
end subroutine test_missing_npy_rdp_rank2

subroutine test_missing_npy_rdp_rank3(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(dp), allocatable :: output(:, :, :)
   integer :: stat
   character(len=:), allocatable :: msg

   call load_npy(".missing-rdp-r3.npy", output, stat, msg)
   call check(error, stat, "Loading npy file failed", msg)
end subroutine test_missing_npy_rdp_rank3

subroutine test_invalid_character(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8', %'fortran_order': True, 'shape': (10, 4, ), }       " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-invalid-character.npy"
   real(dp), allocatable :: array(:, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 305, "Expected error code 305 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_character

subroutine test_invalid_true(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8',  'fortran_order': Tru , 'shape': (10, 4, ), }       " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-invalid-character.npy"
   real(dp), allocatable :: array(:, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 321, "Expected error code 305 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_true

subroutine test_invalid_false(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8',  'fortran_order': Fls , 'shape': (10, 4, ), }       " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-invalid-character.npy"
   real(dp), allocatable :: array(:, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 321, "Expected error code 305 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_false

subroutine test_invalid_magic_number(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }        " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(50) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-invalid-magic-num.npy"
   real(dp), allocatable :: array(:, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 201, "Expected error code 201 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_magic_number

subroutine test_invalid_magic_string(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }        " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "numpy" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-invalid-magic-str.npy"
   real(dp), allocatable :: array(:, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 202, "Expected error code 202 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_magic_string

subroutine test_invalid_major_version(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }        " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(0) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-invalid-major-version.npy"
   real(dp), allocatable :: array(:, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 203,"Expected error code 203 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_major_version

subroutine test_invalid_minor_version(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }        " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(9) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-invalid-minor-version.npy"
   real(dp), allocatable :: array(:, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 204, "Expected error code 204 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_minor_version

subroutine test_invalid_header_len(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }        " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)-1) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-invalid-header-len.npy"
   real(dp), allocatable :: array(:, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 101, "Expected error code 101 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_header_len

subroutine test_invalid_nul_byte(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }       " //  &
       char(0) // char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-invalid-nul-byte.npy"
   real(dp), allocatable :: array(:, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 102, "Expected error code 102 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_nul_byte

subroutine test_invalid_key(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'fortran_order': True, 'shape': (10, 4, ), 'descr': '<f8', 'x': 1, }" //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-invalid-key.npy"
   real(dp), allocatable :: array(:, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 304, "Expected error code 304 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_key

subroutine test_invalid_comma(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'fortran_order': True,, 'shape': (10, 4, ), 'descr': '<f8', }       " //  &
       "   " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-invalid-comma.npy"
   real(dp), allocatable :: array(:)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 301, "Expected error code 301 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_comma

subroutine test_invalid_string(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'fortran_order': True, 'shape': (10, 4, ), 'descr': '<f8' '<f4', }  " //  &
       "   " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=:), allocatable :: msg
   character(len=*), parameter :: filename = ".test-invalid-string.npy"
   real(dp), allocatable :: array(:)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat, msg)
   call delete_file(filename)

   call check(error, stat, 302, "Expected error code 302 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_string

subroutine test_invalid_tuple_literal(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'fortran_order': True, 'shape': (10  4, ), 'descr': '<f8'        }  " //  &
       "   " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=:), allocatable :: msg
   character(len=*), parameter :: filename = ".test-invalid-tuple-literal.npy"
   real(dp), allocatable :: array(:)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat, msg)
   call delete_file(filename)

   call check(error, stat, 311, "Expected error code 311 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_tuple_literal

subroutine test_invalid_tuple_comma(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'fortran_order': True, 'shape': (10,,4, ), 'descr': '<f8'        }  " //  &
       "   " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=:), allocatable :: msg
   character(len=*), parameter :: filename = ".test-invalid-tuple-comma.npy"
   real(dp), allocatable :: array(:)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat, msg)
   call delete_file(filename)

   call check(error, stat, 312, "Expected error code 312 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_tuple_comma

subroutine test_invalid_tuple(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'fortran_order': True, 'shape': (10,%4, ), 'descr': '<f8'        }  " //  &
       "   " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=:), allocatable :: msg
   character(len=*), parameter :: filename = ".test-invalid-tuple.npy"
   real(dp), allocatable :: array(:)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat, msg)
   call delete_file(filename)

   call check(error, stat, 313, "Expected error code 313 got "//format_string(stat, '(i0)'))
end subroutine test_invalid_tuple

subroutine test_type_mismatch(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f4',                 'fortran_order': True, 'shape': (40, ), }"//&
       "   " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=:), allocatable :: msg
   character(len=*), parameter :: filename = ".test-type-mismatch.npy"
   integer, allocatable :: iarray1(:)
   real(dp), allocatable :: rarray1(:), rarray2(:, :), rarray3(:, :, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, iarray1, stat, msg)
   call check(error, stat, 11, "Expected error code 11")

   if (.not.allocated(error)) then
      call load_npy(filename, rarray1, stat, msg)
      call check(error, stat, 11, "Expected error code 11 got "//format_string(stat, '(i0)'))
   end if

   if (.not.allocated(error)) then
      call load_npy(filename, rarray2, stat, msg)
      call check(error, stat, 11, "Expected error code 11 got "//format_string(stat, '(i0)'))
   end if

   if (.not.allocated(error)) then
      call load_npy(filename, rarray3, stat, msg)
      call check(error, stat, 11, "Expected error code 11 got "//format_string(stat, '(i0)'))
   end if
   call delete_file(filename)
end subroutine test_type_mismatch

subroutine test_rank_mismatch_i4(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<i4', 'fortran_order': True, 'shape': (40, 1, )               }"//&
       "   " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=:), allocatable :: msg
   character(len=*), parameter :: filename = ".test-rank-mismatch-rdp.npy"
   integer(i4), allocatable :: iarray1(:)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, iarray1, stat, msg)
   call check(error, stat, 12, "Expected error code 12 got "//format_string(stat, '(i0)'))

   call delete_file(filename)
end subroutine test_rank_mismatch_i4

subroutine test_rank_mismatch_rdp(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8', 'fortran_order': True, 'shape': (40, 1, 1, 1, )         }"//&
       "   " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=:), allocatable :: msg
   character(len=*), parameter :: filename = ".test-rank-mismatch-rdp.npy"
   real(dp), allocatable :: rarray1(:), rarray2(:, :), rarray3(:, :, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, rarray1, stat, msg)
   call check(error, stat, 12, "Expected error code 12 got "//format_string(stat, '(i0)'))

   if (.not.allocated(error)) then
      call load_npy(filename, rarray2, stat, msg)
      call check(error, stat, 12, "Expected error code 12 got "//format_string(stat, '(i0)'))
   end if

   if (.not.allocated(error)) then
      call load_npy(filename, rarray3, stat, msg)
      call check(error, stat, 12, "Expected error code 12 got "//format_string(stat, '(i0)'))
   end if

   call delete_file(filename)
end subroutine test_rank_mismatch_rdp

subroutine test_duplicate_descr(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8', 'descr': '<f8', 'fortran_order': True, 'shape': (40, ), }"//&
       "   " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-invalid-descr.npy"
   real(dp), allocatable :: array(:)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 303, "Expected error code 303 got "//format_string(stat, '(i0)'))
end subroutine test_duplicate_descr

subroutine test_missing_descr(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'fortran_order': True, 'shape': (10, 4, ), }                        " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-missing-descr.npy"
   real(dp), allocatable :: array(:, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 306, "Expected error code 306 got "//format_string(stat, '(i0)'))
end subroutine test_missing_descr

subroutine test_missing_fortran_order(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8', 'shape': (10, 4, ), }                               " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-missing-fortran_order.npy"
   real(dp), allocatable :: array(:, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 308, "Expected error code 308 got "//format_string(stat, '(i0)'))
end subroutine test_missing_fortran_order

subroutine test_missing_shape(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'fortran_order': True, 'descr': '<f8'}                              " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer :: io, stat
   character(len=*), parameter :: filename = ".test-missing-shape.npy"
   real(dp), allocatable :: array(:, :)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) header
   write(io) spread(0.0_dp, 1, 40)
   close(io)

   call load_npy(filename, array, stat)
   call delete_file(filename)

   call check(error, stat, 307, "Expected error code 307 got "//format_string(stat, '(i0)'))
end subroutine test_missing_shape

subroutine test_iomsg_deallocated(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   character(len=*), parameter :: filename = ".test-iomsg-deallocated.npy"
   real(dp), allocatable :: input(:, :)

   msg = "This message should be deallocated."

   allocate(input(12, 5))
   call random_number(input)
   call save_npy(filename, input, stat, msg)
   call delete_file(filename)

   call check(error, .not.allocated(msg), "Message wrongly allocated.")

end subroutine test_iomsg_deallocated

subroutine delete_file(filename)
   character(len=*), intent(in) :: filename

   integer :: io

   open(newunit=io, file=filename)
   close(io, status="delete")
end subroutine delete_file

end module test_npy

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/coulomb/cache.f90
!> Provides a cache specific for all Coulomb interactions

!> Data container for mutable data in electrostatic calculations
module tblite_coulomb_cache
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_coulomb_ewald, only : get_alpha
   use tblite_wignerseitz, only : wignerseitz_cell, new_wignerseitz_cell
   implicit none
   private

   public :: coulomb_cache


   type :: coulomb_cache
      real(wp) :: alpha
      real(wp) :: alpha_multipole
      type(wignerseitz_cell) :: wsc
      real(wp), allocatable :: amat(:, :)
      real(wp), allocatable :: vvec(:)

      real(wp), allocatable :: cn(:)
      real(wp), allocatable :: dcndr(:, :, :)
      real(wp), allocatable :: dcndL(:, :, :)
      real(wp), allocatable :: mrad(:)
      real(wp), allocatable :: dmrdcn(:)

      real(wp), allocatable :: amat_sd(:, :, :)
      real(wp), allocatable :: amat_dd(:, :, :, :)
      real(wp), allocatable :: amat_sq(:, :, :)
   contains
      procedure :: update
   end type coulomb_cache


contains


subroutine update(self, mol)
   !> Instance of the electrostatic container
   class(coulomb_cache), intent(inout) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   if (any(mol%periodic)) then
      call new_wignerseitz_cell(self%wsc, mol)
      call get_alpha(mol%lattice, self%alpha, .false.)
      call get_alpha(mol%lattice, self%alpha_multipole, .true.)
   end if

end subroutine update

end module tblite_coulomb_cache

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

!> Driver for unit testing
program tester
   use, intrinsic :: iso_fortran_env, only : error_unit
   use mctc_env, only : get_argument
   use mctc_env_testing, only : run_testsuite, new_testsuite, testsuite_type, &
      & select_suite, run_selected
   use test_dftd4, only : collect_dftd4
   use test_model, only : collect_model
   use test_pairwise, only : collect_pairwise
   use test_param, only : collect_param
   use test_periodic, only : collect_periodic
   implicit none
   integer :: stat, is
   character(len=:), allocatable :: suite_name, test_name
   type(testsuite_type), allocatable :: testsuites(:)
   character(len=*), parameter :: fmt = '("#", *(1x, a))'

   stat = 0

   testsuites = [ &
      & new_testsuite("model", collect_model), &
      & new_testsuite("dftd4", collect_dftd4), &
      & new_testsuite("param", collect_param), &
      & new_testsuite("periodic", collect_periodic), &
      & new_testsuite("pairwise", collect_pairwise) &
      & ]

   call get_argument(1, suite_name)
   call get_argument(2, test_name)

   if (allocated(suite_name)) then
      is = select_suite(testsuites, suite_name)
      if (is > 0 .and. is <= size(testsuites)) then
         if (allocated(test_name)) then
            write(error_unit, fmt) "Suite:", testsuites(is)%name
            call run_selected(testsuites(is)%collect, test_name, error_unit, stat)
            if (stat < 0) then
               error stop 1
            end if
         else
            write(error_unit, fmt) "Testing:", testsuites(is)%name
            call run_testsuite(testsuites(is)%collect, error_unit, stat)
         end if
      else
         write(error_unit, fmt) "Available testsuites"
         do is = 1, size(testsuites)
            write(error_unit, fmt) "-", testsuites(is)%name
         end do
         error stop 1
      end if
   else
      do is = 1, size(testsuites)
         write(error_unit, fmt) "Testing:", testsuites(is)%name
         call run_testsuite(testsuites(is)%collect, error_unit, stat)
      end do
   end if

   if (stat > 0) then
      write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
      error stop 1
   end if


end program tester

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/scf/mixer
!> Routines for implementing electronic mixing

!> @file tblite/scf/mixer.f90
!> Proxy module for electronic mixing routines

!> Provides an electronic mixer implementation
module tblite_scf_mixer
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_scf_mixer_broyden, only : broyden_mixer, broyden_input, new_broyden
   use tblite_scf_mixer_type, only : mixer_type
   use tblite_scf_mixer_input, only : mixer_input, scf_version
   implicit none
   private

   public :: mixer_type, new_mixer


contains

!> Create a new instance of the mixer
subroutine new_mixer(self, input, ndim, error)
   !> Instance of the mixer on exit
   class(mixer_type), allocatable, intent(out) :: self
   type(mixer_input), intent(in) :: input
   integer, intent(in) :: ndim
   type(error_type), allocatable, intent(out) :: error

   integer :: memory

   memory = input%max_iter
   if (input%memory > 0) memory = min(input%memory, input%max_iter)

   select case(input%scf)
   case(scf_version%broyden)
      block
         type(broyden_mixer), allocatable :: mixer
         allocate(mixer)
         call new_broyden(mixer, ndim, broyden_input(memory, input%damping))
         call move_alloc(mixer, self)
      end block
   case default
      call fatal_error(error, "Unknown SCF version selected for mixer")
   end select
   if (allocated(error)) return

end subroutine new_mixer

end module tblite_scf_mixer

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/io/numpy
!> Contains npy input and output routines

!> @file tblite/io/numpy.f90
!> Provides npy input and output routines

!> Implementation of npy input and output routines
module tblite_io_numpy
   use tblite_io_numpy_load, only : load_npy
   use tblite_io_numpy_loadz, only : load_npz
   use tblite_io_numpy_save, only : save_npy
   use tblite_io_numpy_savez, only : save_npz
   implicit none
   public
end module tblite_io_numpy

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/output/property.f90
!> Provides helper routines to print properties together with units

!> Simple derived type with formatted IO procedure to provide simple debug printing
module tblite_output_property
   use mctc_env, only : wp
   implicit none
   private

   public :: write(formatted)

   type, public :: property
      character(len=:), allocatable :: label
      real(wp) :: value
      character(len=:), allocatable :: unit
   end type property

   interface property
      module procedure :: new_property
   end interface property

    interface write(formatted)
        module procedure :: write_formatted
    end interface


contains


pure function new_property(label, value, unit) result(new)
   character(len=*), intent(in) :: label
   real(wp), intent(in) :: value
   character(len=*), intent(in) :: unit
   type(property) :: new

   new%label = label
   new%value = value
   new%unit = unit
end function new_property


subroutine write_formatted(prop, unit, iotype, v_list, iostat, iomsg)
   class(property), intent(in) :: prop
   integer, intent(in) :: unit
   character(len=*), intent(in) :: iotype
   integer, intent(in) :: v_list(:)
   integer, intent(out) :: iostat
   character(len=*), intent(inout) :: iomsg

   write(unit, '(a, t25, es20.13, 1x, a)') prop%label, prop%value, prop%unit
end subroutine write_formatted


end module tblite_output_property

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/repulsion/effective.f90
!> Provides a screened Coulomb repulsion interaction

!> Classical repulsion interaction as used with the xTB Hamiltonian
module tblite_repulsion_effective
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_container, only : container_cache
   use tblite_cutoff, only : get_lattice_points
   use tblite_repulsion_type, only : repulsion_type
   implicit none
   private

   public :: new_repulsion


   !> Container to evaluate classical repulsion interactions for the xTB Hamiltonian
   type, public, extends(repulsion_type) :: tb_repulsion
      !> Exponent for the repulsion interaction
      real(wp), allocatable :: alpha(:, :)
      !> Effective nuclear charge
      real(wp), allocatable :: zeff(:, :)
      !> Scaling of the repulsion exponents
      real(wp), allocatable :: kexp(:, :)
      !> Exponent of the repulsion polynomial
      real(wp), allocatable :: rexp(:, :)
      !> Real-space cutoff
      real(wp) :: cutoff = 25.0_wp
   contains
      procedure :: get_engrad
   end type tb_repulsion

   character(len=*), parameter :: label = "screened Coulomb repulsion"

contains


subroutine new_repulsion(self, mol, alpha, zeff, kexp, kexp_light, rexp, cutoff)
   !> Instance of the repulsion container
   type(tb_repulsion), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Exponent for the repulsion interaction
   real(wp), intent(in) :: alpha(:)
   !> Effective nuclear charge
   real(wp), intent(in) :: zeff(:)
   !> Scaling of the repulsion exponents
   real(wp), intent(in) :: kexp
   !> Scaling of the repulsion exponents for light atom pairs
   real(wp), intent(in) :: kexp_light
   !> Exponent of the repulsion polynomial
   real(wp), intent(in) :: rexp
   !> Real-space cutoff
   real(wp), intent(in), optional :: cutoff

   integer :: isp, izp, jsp, jzp

   self%label = label
   allocate(self%alpha(mol%nid, mol%nid))
   do isp = 1, mol%nid
      do jsp = 1, mol%nid
         self%alpha(jsp, isp) = sqrt(alpha(isp)*alpha(jsp))
      end do
   end do

   allocate(self%zeff(mol%nid, mol%nid))
   do isp = 1, mol%nid
      do jsp = 1, mol%nid
         self%zeff(jsp, isp) = zeff(isp)*zeff(jsp)
      end do
   end do

   allocate(self%kexp(mol%nid, mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      do jsp = 1, mol%nid
         jzp = mol%num(jsp)
         self%kexp(jsp, isp) = merge(kexp, kexp_light, izp > 2 .or. jzp > 2)
      end do
   end do

   allocate(self%rexp(mol%nid, mol%nid))
   self%rexp(:, :) = rexp
   if (present(cutoff)) self%cutoff = cutoff

end subroutine new_repulsion


!> Evaluate classical interaction for energy and derivatives
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the repulsion container
   class(tb_repulsion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Repulsion energy
   real(wp), intent(inout) :: energies(:)
   !> Molecular gradient of the repulsion energy
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)

   real(wp), allocatable :: trans(:, :)

   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff, trans)

   if (present(gradient) .and. present(sigma)) then
      call get_repulsion_derivs(mol, trans, self%cutoff, self%alpha, self%zeff, &
         & self%kexp, self%rexp, energies, gradient, sigma)
   else
      call get_repulsion_energy(mol, trans, self%cutoff, self%alpha, self%zeff, &
         & self%kexp, self%rexp, energies)
   end if

end subroutine get_engrad


subroutine get_repulsion_energy(mol, trans, cutoff, alpha, zeff, kexp, rexp, &
      & energies)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points
   real(wp), intent(in) :: trans(:, :)
   !> Real space cutoff
   real(wp), intent(in) :: cutoff
   !> Exponents for all element pairs
   real(wp), intent(in) :: alpha(:, :)
   !> Effective nuclear charges for all element pairs
   real(wp), intent(in) :: zeff(:, :)
   !> Pairwise parameters for all element pairs
   real(wp), intent(in) :: kexp(:, :)
   !> Pairwise parameters for all element pairs
   real(wp), intent(in) :: rexp(:, :)
   !> Repulsion energy
   real(wp), intent(inout) :: energies(:)

   integer :: iat, jat, izp, jzp, itr
   real(wp) :: r1, r2, rij(3), r1k, r1r, exa, cutoff2, dE

   cutoff2 = cutoff**2

   !$omp parallel do default(none) schedule(runtime) reduction(+:energies) &
   !$omp shared(mol, trans, cutoff2, kexp, rexp, alpha, zeff) &
   !$omp private(iat, jat, izp, jzp, itr, r1, r2, rij, r1k, r1r, exa, dE)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)
         do itr = 1, size(trans, dim=2)
            rij = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
            r2 = sum(rij**2)
            if (r2 > cutoff2 .or. r2 < 1.0e-12_wp) cycle
            r1 = sqrt(r2)

            r1k = r1**kexp(jzp, izp)
            exa = exp(-alpha(jzp, izp)*r1k)
            r1r = r1**rexp(jzp, izp)
            dE = zeff(jzp, izp) * exa/r1r
            energies(iat) = energies(iat) + 0.5_wp * dE
            if (iat /= jat) then
               energies(jat) = energies(jat) + 0.5_wp * dE
            end if
         end do
      end do
   end do

end subroutine get_repulsion_energy


subroutine get_repulsion_derivs(mol, trans, cutoff, alpha, zeff, kexp, rexp, &
      & energies, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points
   real(wp), intent(in) :: trans(:, :)
   !> Real space cutoff
   real(wp), intent(in) :: cutoff
   !> Exponents for all element pairs
   real(wp), intent(in) :: alpha(:, :)
   !> Effective nuclear charges for all element pairs
   real(wp), intent(in) :: zeff(:, :)
   !> Pairwise parameters for all element pairs
   real(wp), intent(in) :: kexp(:, :)
   !> Pairwise parameters for all element pairs
   real(wp), intent(in) :: rexp(:, :)
   !> Repulsion energy
   real(wp), intent(inout) :: energies(:)
   !> Molecular gradient of the repulsion energy
   real(wp), intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), intent(inout) :: sigma(:, :)

   integer :: iat, jat, izp, jzp, itr
   real(wp) :: r1, r2, rij(3), r1k, r1r, exa, cutoff2, dE, dG(3), dS(3, 3)

   cutoff2 = cutoff**2

   !$omp parallel do default(none) schedule(runtime) reduction(+:energies, gradient, sigma) &
   !$omp shared(mol, trans, cutoff2, kexp, rexp, alpha, zeff) &
   !$omp private(iat, jat, izp, jzp, itr, r1, r2, rij, r1k, r1r, exa, dE, dG, dS)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)
         do itr = 1, size(trans, dim=2)
            rij = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
            r2 = sum(rij**2)
            if (r2 > cutoff2 .or. r2 < 1.0e-12_wp) cycle
            r1 = sqrt(r2)

            r1k = r1**kexp(jzp, izp)
            exa = exp(-alpha(jzp, izp)*r1k)
            r1r = r1**rexp(jzp, izp)
            dE = zeff(jzp, izp) * exa/r1r
            dG = -(alpha(jzp, izp)*r1k*kexp(jzp, izp) + rexp(jzp, izp)) * dE * rij/r2
            dS = spread(dG, 1, 3) * spread(rij, 2, 3)
            energies(iat) = energies(iat) + 0.5_wp * dE
            if (iat /= jat) then
               energies(jat) = energies(jat) + 0.5_wp * dE
               gradient(:, iat) = gradient(:, iat) + dG
               gradient(:, jat) = gradient(:, jat) - dG
               sigma(:, :) = sigma + dS
            else
               sigma(:, :) = sigma + 0.5_wp * dS
            end if
         end do
      end do
   end do

end subroutine get_repulsion_derivs


end module tblite_repulsion_effective

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/lapack/getrs.f90
!> Provides wrappers to solve a linear equation system

!> Wrappers to solve a system of linear equations
module tblite_lapack_getrs
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_getrs


   !> Solves a system of linear equations
   !>    A * X = B  or  A**T * X = B
   !> with a general N-by-N matrix A using the LU factorization computed
   !> by ?GETRF.
   interface wrap_getrs
      module procedure :: wrap_sgetrs
      module procedure :: wrap_dgetrs
   end interface wrap_getrs


   !> Solves a system of linear equations
   !>    A * X = B  or  A**T * X = B
   !> with a general N-by-N matrix A using the LU factorization computed
   !> by ?GETRF.
   interface lapack_getrs
      pure subroutine sgetrs(trans, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         real(sp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: trans
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine sgetrs
      pure subroutine dgetrs(trans, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         real(dp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: trans
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine dgetrs
   end interface lapack_getrs

contains

subroutine wrap_sgetrs(amat, bmat, ipiv, info, trans)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout) :: bmat(:, :)
   integer, intent(in) :: ipiv(:)
   integer, intent(out) :: info
   character(len=1), intent(in), optional :: trans
   character(len=1) :: tra
   integer :: n, nrhs, lda, ldb
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   nrhs = size(bmat, 2)
   call lapack_getrs(tra, n, nrhs, amat, lda, ipiv, bmat, ldb, info)
end subroutine wrap_sgetrs


subroutine wrap_dgetrs(amat, bmat, ipiv, info, trans)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout) :: bmat(:, :)
   integer, intent(in) :: ipiv(:)
   integer, intent(out) :: info
   character(len=1), intent(in), optional :: trans
   character(len=1) :: tra
   integer :: n, nrhs, lda, ldb
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   nrhs = size(bmat, 2)
   call lapack_getrs(tra, n, nrhs, amat, lda, ipiv, bmat, ldb, info)
end subroutine wrap_dgetrs

end module tblite_lapack_getrs

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_write_xyz
   use mctc_io_convert, only : autoaa
   use mctc_io_structure, only : structure_type
   implicit none
   private

   public :: write_xyz


contains


subroutine write_xyz(self, unit, comment_line)
   class(structure_type), intent(in) :: self
   integer, intent(in) :: unit
   character(len=*), intent(in), optional :: comment_line
   integer :: iat
   logical :: expo

   write(unit, '(i0)') self%nat
   if (present(comment_line)) then
      write(unit, '(a)') comment_line
   else
      if (allocated(self%comment)) then
         write(unit, '(a)') self%comment
      else
         write(unit, '(a)')
      end if
   end if
   expo = maxval(self%xyz) > 1.0e+5 .or. minval(self%xyz) < -1.0e+5
   if (expo) then
      do iat = 1, self%nat
         write(unit, '(a4, 1x, 3es24.14)') &
            & self%sym(self%id(iat)), self%xyz(:, iat)*autoaa
      enddo
   else
      do iat = 1, self%nat
         write(unit, '(a4, 1x, 3f24.14)') &
            & self%sym(self%id(iat)), self%xyz(:, iat)*autoaa
      enddo
   end if

end subroutine write_xyz


end module mctc_io_write_xyz

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file src/ddx_pcm.f90
!! PCM solver
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-02-25

!> High-level subroutines for ddpcm
module ddx_pcm
! Get ddx-operators
use ddx_operators
implicit none

!> @defgroup Fortran_interface_ddpcm Fortran interface: ddpcm
!! Exposed ddpcm modules in the Fortran API

contains

!> Compute the ddPCM energy
!!
!> @ingroup Fortran_interface_ddpcm
!! @param[in] constants: Precomputed constants
!! @param[in] state: ddx state (contains solutions and RHSs)
!! @param[out] esolv: resulting energy
!! @param[inout] ddx_error: ddX error
!!
subroutine pcm_energy(constants, state, esolv, ddx_error)
    implicit none
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_state_type), intent(in) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(out) :: esolv
    real(dp), external :: ddot
    ! dummy operation on unused interface arguments
    if (ddx_error % flag .eq. 0) continue
    esolv = pt5*ddot(constants % n, state % xs, 1, state % psi, 1)
end subroutine pcm_energy

!> Given the potential at the cavity points, assemble the RHS for ddCOSMO
!> or for ddPCM.
!!
!> @ingroup Fortran_interface_ddpcm
!! @param[in] params: ddx parameters
!! @param[in] constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[inout] state: ddx state
!! @param[in] phi_cav: electrostatic potential at the cavity points
!! @param[in] psi: representation of the solute density
!! @param[inout] ddx_error: ddX error
!!
subroutine pcm_setup(params, constants, workspace, state, phi_cav, psi, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(in) :: phi_cav(constants % ncav)
    real(dp), intent(in) :: psi(constants % nbasis, params % nsph)

    ! dummy operation on unused interface arguments
    if (ddx_error % flag .eq. 0) continue

    call cav_to_spherical(params, constants, workspace, phi_cav, &
        & state % phi)
    state % phi = - state % phi
    state % phi_cav = phi_cav
    state % psi = psi
    state % rhs_done = .true.
    state % adjoint_rhs_done = .true.
end subroutine pcm_setup

!> Do a guess for the primal ddPCM linear system
!!
!> @ingroup Fortran_interface_ddpcm
!! @param[in] params: User specified parameters
!! @param[in] constants: Precomputed constants
!! @param[inout] workspace: Preallocated workspaces
!! @param[inout] state: ddx state (contains solutions and RHSs)
!!
subroutine pcm_guess(params, constants, workspace, state, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error

    state % xs = zero
    call prec_repsx(params, constants, workspace, state % phi, &
        & state % phieps, ddx_error)

end subroutine pcm_guess

!> Do a guess for the adjoint ddPCM linear system
!!
!> @ingroup Fortran_interface_ddpcm
!! @param[in] params: User specified parameters
!! @param[in] constants: Precomputed constants
!! @param[inout] workspace: Preallocated workspaces
!! @param[inout] state: ddx state (contains solutions and RHSs)
!!
subroutine pcm_guess_adjoint(params, constants, workspace, state, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error

    state % y = zero
    call ldm1x(params, constants, workspace, state % psi, state % s, ddx_error)

end subroutine pcm_guess_adjoint

!> Solve the ddPCM primal linear system
!!
!> @ingroup Fortran_interface_ddpcm
!! @param[in] params       : General options
!! @param[in] constants    : Precomputed constants
!! @param[inout] workspace : Preallocated workspaces
!! @param[inout] state     : Solutions and relevant quantities
!! @param[in] tol          : Tolerance for the iterative solvers
!! @param[inout] ddx_error     : ddX error
!!
subroutine pcm_solve(params, constants, workspace, state, tol, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(in) :: tol
    ! local variables
    real(dp) :: start_time, finish_time

    call rinfx(params, constants, workspace, state % phi, state % phiinf, &
        & ddx_error)

    state % phieps_niter = params % maxiter
    start_time = omp_get_wtime()
    call jacobi_diis(params, constants, workspace, tol, state % phiinf, &
        & state % phieps, state % phieps_niter, state % phieps_rel_diff, &
        & repsx, prec_repsx, hnorm, ddx_error)
    finish_time = omp_get_wtime()
    state % phieps_time = finish_time - start_time

    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "ddpcm_solve: solver for ddPCM " // &
            & "system did not converge, exiting")
        return
    end if

    state % xs_niter =  params % maxiter
    start_time = omp_get_wtime()
    call jacobi_diis(params, constants, workspace, tol, state % phieps, &
        & state % xs, state % xs_niter, state % xs_rel_diff, lx, ldm1x, &
        & hnorm, ddx_error)
    finish_time = omp_get_wtime()
    state % xs_time = finish_time - start_time

    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "ddpcm_solve: solver for ddCOSMO " // &
            & "system did not converge, exiting")
        return
    end if

end subroutine pcm_solve

!> Solve the ddPCM adjpint linear system
!!
!> @ingroup Fortran_interface_ddpcm
!! @param[in] params       : General options
!! @param[in] constants    : Precomputed constants
!! @param[inout] workspace : Preallocated workspaces
!! @param[inout] state     : Solutions, guesses and relevant quantities
!! @param[in] tol          : Tolerance for the iterative solvers
!! @param[inout] ddx_error: ddX error
!!
subroutine pcm_solve_adjoint(params, constants, workspace, state, tol, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: tol
    type(ddx_error_type), intent(inout) :: ddx_error
    ! local variables
    real(dp) :: start_time, finish_time

    state % s_niter =  params % maxiter
    start_time = omp_get_wtime()
    call jacobi_diis(params, constants, workspace, tol, state % psi, &
        & state % s, state % s_niter, state % s_rel_diff, lstarx, ldm1x, &
        & hnorm, ddx_error)
    finish_time = omp_get_wtime()
    state % s_time = finish_time - start_time

    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "ddpcm_solve_adjoint: solver for ddCOSMO " // &
            & "system did not converge, exiting")
        return
    end if

    state % y_niter = params % maxiter
    start_time = omp_get_wtime()
    call jacobi_diis(params, constants, workspace, tol, state % s, state % y, &
        & state % y_niter, state % y_rel_diff, repsstarx, prec_repsstarx, &
        & hnorm, ddx_error)
    finish_time = omp_get_wtime()
    state % y_time = finish_time - start_time

    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "ddpcm_solve_adjoint: solver for ddPCM " // &
            & "system did not converge, exiting")
        return
    end if

    ! compute the real adjoint solution and store it in Q
    state % q = state % s - fourpi/(params % eps - one)*state % y

    call pcm_derivative_setup(params, constants, workspace, state)

end subroutine pcm_solve_adjoint

!> Compute the solvation contribution to the ddPCM forces
!!
!> @ingroup Fortran_interface_ddpcm
!! @param[in] params       : General options
!! @param[in] constants    : Precomputed constants
!! @param[inout] workspace : Preallocated workspaces
!! @param[inout] state     : Solutions and relevant quantities
!! @param[in] e_cav: electric field, size (3, ncav)
!! @param[out] force       : Geometrical contribution to the forces
!! @param[inout] ddx_error: ddX error
!!
subroutine pcm_solvation_force_terms(params, constants, workspace, &
        & state, e_cav, force, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(in) :: e_cav(3, constants % ncav)
    real(dp), intent(out) :: force(3, params % nsph)

    real(dp) :: start_time, finish_time
    integer :: isph

    ! dummy operation on unused interface arguments
    if (ddx_error % flag .eq. 0) continue

    start_time = omp_get_wtime()

    call gradr(params, constants, workspace, state % g, state % ygrid, force)

    do isph = 1, params % nsph
        call contract_grad_L(params, constants, isph, state % xs, &
            & state % sgrid, workspace % tmp_vylm(:, 1), &
            & workspace % tmp_vdylm(:, :, 1), workspace % tmp_vplm(:, 1), &
            & workspace % tmp_vcos(:, 1), workspace % tmp_vsin(:, 1), &
            & force(:, isph))
        call contract_grad_U(params, constants, isph, state % qgrid, &
            & state % phi_grid, force(:, isph))
    end do
    force = - pt5 * force

    call zeta_grad(params, constants, state, e_cav, force)

    finish_time = omp_get_wtime()
    state % force_time = finish_time - start_time

end subroutine pcm_solvation_force_terms

!> This routines precomputes the intermediates to be used in the evaluation
!! of ddCOSMO analytical derivatives.
!!
!! @param[in] params: ddx parameters
!! @param[in] constant: ddx constants
!! @param[inout] workspace: ddx workspaces
!! @param[inout] state: ddx state
!!
subroutine pcm_derivative_setup(params, constants, workspace, state)
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state

    real(dp), external :: ddot
    integer :: icav, isph, igrid

    ! dummy operation on unused interface arguments
    if (allocated(workspace % tmp_pot)) continue

    ! Get grid values of S and Y
    call dgemm('T', 'N', params % ngrid, params % nsph, &
        & constants % nbasis, one, constants % vgrid, constants % vgrid_nbasis, &
        & state % s, constants % nbasis, zero, state % sgrid, params % ngrid)
    call dgemm('T', 'N', params % ngrid, params % nsph, &
        & constants % nbasis, one, constants % vgrid, constants % vgrid_nbasis, &
        & state % y, constants % nbasis, zero, state % ygrid, params % ngrid)

    ! Get the values of phi on the grid
    call ddcav_to_grid_work(params % ngrid, params % nsph, constants % ncav, &
        & constants % icav_ia, constants % icav_ja, state % phi_cav, &
        & state % phi_grid)

    state % g = - (state % phieps - state % phi)
    state % qgrid = state % sgrid - fourpi/(params % eps - one)*state % ygrid

    ! assemble the intermediate zeta: S weighted by U evaluated on the
    ! exposed grid points.
    icav = 0
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if (constants % ui(igrid, isph) .ne. zero) then
                icav = icav + 1
                state % zeta(icav) = constants % wgrid(igrid) * &
                    & constants % ui(igrid, isph) * ddot(constants % nbasis, &
                    & constants % vgrid(1, igrid), 1, state % q(1, isph), 1)
            end if
        end do
    end do

end subroutine pcm_derivative_setup

end module ddx_pcm

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/spin.f90
!> Provides spin-interactions for spin-polarized tight-binding calculations.

!> Implementation of spin-interactions for spin-polarized tight-binding.
!>
!> The spin-components are represented as difference between alpha and beta population
!> resulting in a magnetization density.
module tblite_spin
   use mctc_env, only : wp
   use mctc_io, only : structure_type, new
   use tblite_blas, only : dot
   use tblite_container_cache, only : container_cache
   use tblite_container_type, only : container_type
   use tblite_scf_info, only : scf_info, shell_resolved
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: spin_polarization, new_spin_polarization


   !> On-site spin-interaction
   type, extends(container_type) :: spin_polarization
      !> Number of shells for each atom
      integer, allocatable :: nsh_at(:)
      !> Index offset for each shell block
      integer, allocatable :: ish_at(:)
      !> Spin constants for each element
      real(wp), allocatable :: wll(:, :, :)
   contains
      !> Return dependency on density
      procedure :: variable_info
      !> Get spin-polarization energy
      procedure :: get_energy
      !> Get spin-polarization potential
      procedure :: get_potential
   end type spin_polarization

   !> Identifier for container
   character(len=*), parameter :: label = "spin polarization"

contains


!> Create new spin-polarization container
pure subroutine new_spin_polarization(self, mol, wll, nshell)
   !> Instance of the spin-polarization container
   type(spin_polarization), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Spin constants for each species
   real(wp), intent(in) :: wll(:, :, :)
   !> Number of shells for each species
   integer, intent(in), optional :: nshell(:)

   integer :: ind, iat

   self%label = label
   self%wll = wll
   self%nsh_at = nshell(mol%id)

   allocate(self%ish_at(mol%nat))
   ind = 0
   do iat = 1, mol%nat
      self%ish_at(iat) = ind
      ind = ind + self%nsh_at(iat)
   end do
end subroutine new_spin_polarization


!> Get spin-polarization energy
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the spin-polarization container
   class(spin_polarization), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> spin-polarization energy
   real(wp), intent(inout) :: energies(:)

   integer :: iat, izp, ish, jsh, ii, spin

   do spin = 2, wfn%nspin
      do iat = 1, mol%nat
         izp = mol%id(iat)
         ii = self%ish_at(iat)
         do ish = 1, self%nsh_at(iat)
            do jsh = 1, self%nsh_at(iat)
               energies(iat) = energies(iat) + &
                  & 0.5_wp*wfn%qsh(ii+ish, spin)*wfn%qsh(ii+jsh, spin)*self%wll(jsh, ish, izp)
            end do
         end do
      end do
   end do
end subroutine get_energy


!> Get spin-polarization potential
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the spin-polarization container
   class(spin_polarization), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   integer :: iat, izp, ish, jsh, ii, spin

   do spin = 2, wfn%nspin
      do iat = 1, mol%nat
         izp = mol%id(iat)
         ii = self%ish_at(iat)
         do ish = 1, self%nsh_at(iat)
            do jsh = 1, self%nsh_at(iat)
               pot%vsh(ii+ish, spin) = pot%vsh(ii+ish, spin) + &
                  & wfn%qsh(ii+jsh, spin) * self%wll(jsh, ish, izp)
            end do
         end do
      end do
   end do
end subroutine get_potential


!> Return dependency on density
pure function variable_info(self) result(info)
   !> Instance of the spin-polarization container
   class(spin_polarization), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=shell_resolved)
end function variable_info


end module tblite_spin

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/classical
!> Contains classical correction potentials

!> @file tblite/classical/halogen.f90
!> Provides a classical halogen bonding correction

!> Classical correction term for halogen bonding contributions
module tblite_classical_halogen
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_data_atomicrad, only : get_atomic_rad
   use tblite_container, only : container_cache
   use tblite_cutoff, only : get_lattice_points
   use tblite_repulsion_type, only : repulsion_type
   implicit none
   private

   public :: new_halogen_correction


   !> Container for evaluating halogen bonding energy terms by a classical potential
   type, public, extends(repulsion_type) :: halogen_correction
      !> Interaction strength of the halogen bond
      real(wp), allocatable :: bond_strength(:)
      !> Atomic radii of all atoms
      real(wp), allocatable :: rad(:)
      !> Damping for the interaction potential
      real(wp) :: damping
      !> Suitable acceptors for halogen bonding interactions
      logical, allocatable :: acceptor(:)
      !> Suitable donors for halogen bonding interactions
      logical, allocatable :: halogen(:)
      !> Real-space cutoff
      real(wp) :: cutoff = 20.0_wp
   contains
      !> Entry point for evaluation of energy and gradient
      procedure :: get_engrad
   end type halogen_correction

   real(wp), parameter :: alp = 6.0_wp, lj = 12.0_wp, lj2 = lj * 0.5_wp
   character(len=*), parameter :: label = "halogen-bond correction"

contains


!> Construct new halogen bonding correction
subroutine new_halogen_correction(self, mol, damping, rad_scale, bond_strength, rad, cutoff)
   !> Instance of the halogen bond correction
   type(halogen_correction), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Damping factor
   real(wp), intent(in) :: damping
   !> Scaling of the atomic radii
   real(wp), intent(in) :: rad_scale
   !> Strength of the halogen bond
   real(wp), intent(in) :: bond_strength(:)
   !> Atomic radii for each species
   real(wp), intent(in), optional :: rad(:)
   !> Real-space cutoff
   real(wp), intent(in), optional :: cutoff

   self%label = label
   allocate(self%rad(mol%nid), self%bond_strength(mol%nid), self%halogen(mol%nid), &
      & self%acceptor(mol%nid))
   if (present(rad)) then
      self%rad(:) = rad * rad_scale
   else
      self%rad(:) = get_atomic_rad(mol%num) * rad_scale
   end if
   if (present(cutoff)) self%cutoff = cutoff
   self%bond_strength(:) = bond_strength
   self%damping = damping

   self%halogen(:) = is_halogen(mol%num)
   self%acceptor(:) = is_acceptor(mol%num)

end subroutine new_halogen_correction


!> Check whether an atom qualifies as halogen bond doner
elemental function is_halogen(num) result(halogen)
   integer, intent(in) :: num
   logical :: halogen
   halogen = any(num == [17, 35, 53, 85])
end function is_halogen

!> Check whether an atom qualifies as halogen bond acceptor
elemental function is_acceptor(num) result(acceptor)
   integer, intent(in) :: num
   logical :: acceptor
   acceptor = any(num == [7, 8, 15, 16])
end function is_acceptor


!> Evaluate classical interaction for energy and derivatives
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the halogen bond correction
   class(halogen_correction), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Halogen-bonding energy
   real(wp), intent(inout) :: energies(:)
   !> Molecular gradient of the halogen-bonding energy
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Strain derivatives of the halogen-bonding energy
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)

   integer, allocatable :: list(:, :)
   real(wp), allocatable :: trans(:, :)

   if (count(self%halogen) * count(self%acceptor) == 0) return

   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff, trans)

   call get_xbond_list(mol, trans, self%cutoff, self%halogen, self%acceptor, list)
   if (.not.allocated(list)) return

   if (present(gradient) .and. present(sigma)) then
      call get_xbond_derivs(mol, trans, list, self%damping, self%bond_strength, self%rad, &
         & energies, gradient, sigma)
   else
      call get_xbond_energy(mol, trans, list, self%damping, self%bond_strength, self%rad, &
         & energies)
   end if

end subroutine get_engrad


!> Collect all triples for halogen bonding interactions
subroutine get_xbond_list(mol, trans, cutoff, halogen, acceptor, list)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points
   real(wp), intent(in) :: trans(:, :)
   !> Real space cutoff
   real(wp), intent(in) :: cutoff
   !> Species can act as halogen bond donor
   logical, intent(in) :: halogen(:)
   !> Species can act as halogen bond acceptor
   logical, intent(in) :: acceptor(:)
   !> List of all halogen bonds
   integer, allocatable, intent(out) :: list(:, :)

   integer :: iat, jat, kat, izp, jzp, jtr, ktr, nxb, ij
   real(wp) :: vec(3), r1, dist

   nxb = 0
   call resize(list)

   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, mol%nat
         jzp = mol%id(jat)
         if (.not.(halogen(izp).and.acceptor(jzp))) cycle
         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, jtr)
            r1 = norm2(vec)
            if (r1 > cutoff) cycle
            nxb = nxb + 1
            if (nxb > size(list, 2)) call resize(list)
            list([1, 2, 4], nxb) = [iat, jat, jtr]
         end do
      end do
   end do

   if (nxb == 0) then
      deallocate(list)
      return
   end if

   call resize(list, nxb)

   do ij = 1, size(list, 2)
      iat = list(1, ij)
      jat = list(2, ij)
      dist = huge(1.0_wp)
      do kat = 1, mol%nat
         do ktr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - mol%xyz(:, kat) - trans(:, ktr)
            r1 = norm2(vec)
            if (r1 < dist .and. r1 > 0.0_wp) then
               list([3, 5], ij) = [kat, ktr]
               dist = r1
            end if
         end do
      end do
   end do
end subroutine get_xbond_list


!> Reallocate list of integers
pure subroutine resize(var, n)
   !> Instance of the array to be resized
   integer, allocatable, intent(inout) :: var(:, :)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   integer, parameter :: nitem = 5, initial_size = 20
   integer, allocatable :: tmp(:, :)
   integer :: this_size, new_size

   if (allocated(var)) then
      this_size = size(var, 2)
      call move_alloc(var, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(var(nitem, new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 2), size(var, 2))
      var(:, :this_size) = tmp(:, :this_size)
      deallocate(tmp)
   end if

end subroutine resize


!> Get energy contributions from halogen bonding interactions
subroutine get_xbond_energy(mol, trans, list, damping, bond_strength, rad, &
      & energies)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points
   real(wp), intent(in) :: trans(:, :)
   !> List of halogen bonded atoms
   integer, intent(in) :: list(:, :)
   !> Damping factor
   real(wp), intent(in) :: damping
   !> Strength of the halogen bond
   real(wp), intent(in) :: bond_strength(:)
   !> Atomic radii for each species
   real(wp), intent(in) :: rad(:)
   !> Repulsion energy
   real(wp), intent(inout) :: energies(:)

   integer :: ijk, jat, kat, xat, xzp, jzp, jtr, ktr
   real(wp) :: cc, r0jx, t13, t14, d2jx, rjx, term, aterm
   real(wp) :: xy, d2kx, d2jk, dxj(3), dxk(3), dkj(3)

   do ijk = 1, size(list, 2)
      xat = list(1, ijk)
      jat = list(2, ijk)
      kat = list(3, ijk)
      jtr = list(4, ijk)
      ktr = list(5, ijk)
      xzp = mol%id(xat)
      jzp = mol%id(jat)
      cc = bond_strength(xzp)
      r0jx = rad(xzp) + rad(jzp)
      dxj = mol%xyz(:, jat) - mol%xyz(:, xat)
      dxk = mol%xyz(:, kat) + trans(:, ktr) - mol%xyz(:, xat)
      dkj = mol%xyz(:, jat) + trans(:, jtr) - mol%xyz(:, kat) - trans(:, ktr)
      d2jx = sum(dxj*dxj)
      d2kx = sum(dxk*dxk)
      d2jk = sum(dkj*dkj)
      rjx = sqrt(d2jx)
      ! angle part. term = cos angle kat-xat-jat
      xy = sqrt(d2kx*d2jx)
      term = (d2kx+d2jx-d2jk) / xy
      aterm = (0.5_wp-0.25_wp*term)**alp
      t13 = r0jx/rjx
      t14 = t13**lj
      energies(xat) = energies(xat) + aterm*cc*(t14-damping*t13**lj2) / (1.0_wp+t14)
   end do

end subroutine get_xbond_energy


!> Get energy and its derivatives for halogen bonding interactions
subroutine get_xbond_derivs(mol, trans, list, damping, bond_strength, rad, &
      & energies, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points
   real(wp), intent(in) :: trans(:, :)
   !> Damping factor
   real(wp), intent(in) :: damping
   !> List of halogen bonded atoms
   integer, intent(in) :: list(:, :)
   !> Strength of the halogen bond
   real(wp), intent(in) :: bond_strength(:)
   !> Atomic radii for each species
   real(wp), intent(in) :: rad(:)
   !> Repulsion energy
   real(wp), intent(inout) :: energies(:)
   !> Molecular gradient of the repulsion energy
   real(wp), intent(inout) :: gradient(:, :)
   !> Strain derivatives of the repulsion energy
   real(wp), intent(inout) :: sigma(:, :)

   integer :: ijk, jat, kat, xat, xzp, jzp, jtr, ktr
   real(wp) :: cc, r0jx, t13, t14
   real(wp) :: d2jx, rjx, rkx, term, aterm, xy, d2kx, d2jk
   real(wp) :: dxj(3), dxk(3), dkj(3), dcosterm
   real(wp) :: dtermlj, termlj, prefactor, numerator, denominator

   do ijk = 1, size(list, 2)
      xat = list(1, ijk)
      jat = list(2, ijk)
      kat = list(3, ijk)
      jtr = list(4, ijk)
      ktr = list(5, ijk)
      xzp = mol%id(xat)
      jzp = mol%id(jat)
      cc = bond_strength(xzp)
      r0jx = rad(xzp)+rad(jzp)

      dxj = mol%xyz(:, jat) - mol%xyz(:, xat)
      dxk = mol%xyz(:, kat) + trans(:, ktr) - mol%xyz(:, xat)
      dkj = mol%xyz(:, jat) + trans(:, jtr) - mol%xyz(:, kat) - trans(:, ktr)

      d2jx = sum(dxj*dxj)
      d2kx = sum(dxk*dxk)
      d2jk = sum(dkj*dkj)
      rjx = sqrt(d2jx)+1.0e-18_wp
      rkx = sqrt(d2kx)+1.0e-18_wp

      xy = sqrt(d2kx*d2jx)
      term = (d2kx+d2jx-d2jk) / xy
      ! now compute angular damping function
      aterm = (0.5_wp-0.25_wp*term)**alp

      t13 = r0jx/rjx
      t14 = t13**lj
      energies(xat) = energies(xat) + aterm*cc*(t14-damping*t13**lj2) / (1.0_wp+t14)

      ! set up weighted inverted distance and compute the modified Lennard-Jones potential
      t14 = (r0jx/rjx)**lj2 ! (rov/r)^lj2 ; lj2 = 6 in GFN1
      numerator = (t14*t14 - damping*t14)
      denominator = (1.0_wp + t14*t14)
      termLJ = numerator/denominator

      ! LJ derivative
      ! denominator part
      dtermlj = 2.0_wp*lj2*numerator*t14*t14/(rjx*denominator*denominator)
      ! numerator part
      dtermlj = dtermlj+lj2*t14*(damping - 2.0_wp*t14)/(rjx*denominator)
      ! scale w/ angular damping term
      dtermlj = dtermlj*aterm*cc/rjx
      ! gradient for the acceptor
      gradient(:, jat) = gradient(:, jat)+dtermlj*dxj(:)
      ! halogen gradient
      gradient(:, xat) = gradient(:, xat)-dtermlj*dxj(:)
      ! strain contribution
      sigma(:, :) = sigma + spread(dxj, 1, 3) * spread(dxj, 2, 3) * dtermlj

      ! cosine term derivative
      prefactor = -0.250_wp*alp*(0.5_wp-0.25_wp*term)**(alp-1.0_wp)
      prefactor = prefactor*cc*termlj
      ! AX part
      dcosterm = 2.0_wp/rkx - term/rjx
      dcosterm = dcosterm*prefactor/rjx
      ! gradient for the acceptor
      gradient(:, jat) = gradient(:, jat)+dcosterm*dxj(:)
      ! halogen gradient
      gradient(:, xat) = gradient(:, xat)-dcosterm*dxj(:)
      ! strain contribution
      sigma(:, :) = sigma + spread(dxj, 1, 3) * spread(dxj, 2, 3) * dcosterm
      ! KX part
      dcosterm = 2.0_wp/rjx - term/rkx
      dcosterm = dcosterm*prefactor/rkx
      ! gradient for the acceptor
      gradient(:, kat) = gradient(:, kat)+dcosterm*dxk(:)
      ! halogen gradient
      gradient(:, xat) = gradient(:, xat)-dcosterm*dxk(:)
      ! strain contribution
      sigma(:, :) = sigma + spread(dxk, 1, 3) * spread(dxk, 2, 3) * dcosterm
      ! JK part
      t13 = 2.0_wp*prefactor/xy
      ! acceptor
      gradient(:, jat) = gradient(:, jat)-t13*dkj(:)
      ! neighbor
      gradient(:, kat) = gradient(:, kat)+t13*dkj(:)
      ! strain contribution
      sigma(:, :) = sigma - spread(dkj, 1, 3) * spread(dkj, 2, 3) * t13
   end do

end subroutine get_xbond_derivs


end module tblite_classical_halogen

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/xtb
!> Routines related to the extend tight-binding Hamiltonian

!> @file tblite/xtb.f90
!> Proxy module for extended tight-binding Hamiltonian related settings

!> This module contains reexports for the #tblite_xtb_calculator::xtb_calculator class
!> and the possible parametrizations via #tblite_xtb_gfn1, #tblite_xtb_gfn2, and
!> #tblite_xtb_ipea1. The main entry point for performing calculations is
!> provided with #tblite_xtb_singlepoint::xtb_singlepoint.
module tblite_xtb
   use tblite_xtb_calculator, only : xtb_calculator, new_xtb_calculator, param_h0spec
   use tblite_xtb_gfn1, only : new_gfn1_calculator, gfn1_h0spec, export_gfn1_param
   use tblite_xtb_gfn2, only : new_gfn2_calculator, gfn2_h0spec, export_gfn2_param
   use tblite_xtb_ipea1, only : new_ipea1_calculator, ipea1_h0spec, export_ipea1_param
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   implicit none

   public :: xtb_calculator, new_xtb_calculator, param_h0spec
   public :: new_gfn1_calculator, gfn1_h0spec, export_gfn1_param
   public :: new_gfn2_calculator, gfn2_h0spec, export_gfn2_param
   public :: new_ipea1_calculator, ipea1_h0spec, export_ipea1_param
   public :: xtb_singlepoint
end module tblite_xtb

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file tests/ddx_operators.f90
!! Tests for ddx_operators module
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-02-24

program test_ddx_operators
use ddx_operators
use ddx_legacy
implicit none

integer :: i, ngrid=590, nproc=1
! Some implementation do not work for alpha=1d-307, so range of test values is
! reduced. This can be fixed by enforcing proper order of multiplications like
! a*b*c into a*(b*c).
real(dp) :: alpha(4)=(/1d0, -1d0, 1d-100, 1d+100/)
type(ddx_type) :: ddx_data
type(ddx_error_type) :: ddx_error
integer, parameter :: nsph=10, lmax=7, force=1, matvecmem=0, &
    & maxiter=1000, jacobi_ndiis=25
real(dp), parameter :: se=0d0, eta=0.1d0, eps=78d0, kappa=0d0
real(dp) :: gcsph(3, nsph), csph(3, nsph), grsph(nsph), rsph(nsph), &
    & gcharge(nsph), charge(nsph)
character(len=255) :: dummy_file_name = ''

gcsph(:, 1) = (/1d0, 1d0, 1d0/)
gcsph(:, 2) = (/2d0, 2d0, 2d0/)
gcsph(:, 3) = (/1d0, 1d0, 3d0/)
gcsph(:, 4) = (/2d0, 2d0, 4d0/)
gcsph(:, 5) = (/1d0, 1d0, 5d0/)
gcsph(:, 6) = (/2d0, 2d0, 6d0/)
gcsph(:, 7) = (/1d0, 1d0, 7d0/)
gcsph(:, 8) = (/2d0, 2d0, 8d0/)
gcsph(:, 9) = (/1d0, 1d0, 9d0/)
gcsph(:, 10) = (/2d0, 2d0, 10d0/)
grsph = (/1d-1, 2d-1, 3d-1, 4d-1, 5d-1, 6d-1, 7d-1, 8d-1, 9d-1, 1d0/)
gcharge = one

do i = 1, size(alpha)
    charge = abs(alpha(i)) * gcharge
    csph = alpha(i) * gcsph
    rsph = abs(alpha(i)) * grsph
    call allocate_model(nsph, csph(1, :), csph(2, :), csph(3, :), rsph, 2, &
        lmax, ngrid, force, 0, -1, -1, se, eta, eps, kappa, &
        & matvecmem, maxiter, jacobi_ndiis, &
        & nproc, dummy_file_name, ddx_data, ddx_error)
    call check_mkrhs(ddx_data, 0, 0, 1d-1, charge)
    call check_mkrhs(ddx_data, 1, 1, 1d-2, charge)
    call check_mkrhs(ddx_data, 3, 3, 1d-3, charge)
    call check_mkrhs(ddx_data, 5, 5, 1d-4, charge)
    call check_mkrhs(ddx_data, 20, 20, 1d-9, charge)
    call check_mkrhs(ddx_data, 40, 40, 1d-15, charge)
    call check_dx(ddx_data, 40, 40, 1d-12)
    call check_dx(ddx_data, lmax+1, lmax+1, 1d-4)
    call check_gradr(ddx_data, 40, 40, 1d-12)
    call check_gradr(ddx_data, lmax+2, lmax+2, 1d-3)
    call deallocate_model(ddx_data, ddx_error)
end do

contains
!> Print error message and exit with provided error code
subroutine test_error(code, message)
    integer, intent(in) :: code
    character(len=*), intent(in) :: message
    write(0, "(A,A)") "ERROR: ", message
    write(0, "(A,I2)") "CODE:  ", code
    stop -1
end subroutine test_error

subroutine check_mkrhs(ddx_data, pm, pl, threshold, charges)
    ! Inputs
    type(ddx_type), intent(inout) :: ddx_data
    integer, intent(in) :: pm, pl
    real(dp), intent(in) :: threshold
    real(dp), intent(in) :: charges(ddx_data % params % nsph)
    ! Local variables
    type(ddx_type) :: ddx_data_fmm
    type(ddx_error_type) :: ddx_error
    integer :: info
    real(dp), allocatable :: phi_cav(:), phi2_cav(:), gradphi_cav(:, :), &
        & gradphi2_cav(:, :), hessianphi_cav(:, :, :), &
        & hessianphi2_cav(:, :, :), psi(:, :), psi2(:, :), force(:, :)
    real(dp) :: fnorm, fdiff
    real(dp), external :: dnrm2
    ! Init FMM-related ddx_data
    call allocate_model(ddx_data % params % nsph, ddx_data % params % csph(1, :), &
        & ddx_data % params % csph(2, :), ddx_data % params % csph(3, :), &
        & ddx_data % params % rsph, ddx_data % params % model, &
        & ddx_data % params % lmax, ddx_data % params % ngrid, ddx_data % params % force, &
        & 1, pm, pl, ddx_data % params % se, ddx_data % params % eta, &
        & ddx_data % params % eps, ddx_data % params % kappa, ddx_data % params % matvecmem, &
        & ddx_data % params % maxiter, ddx_data % params % jacobi_ndiis, &
        & ddx_data % params % nproc, &
        & dummy_file_name, ddx_data_fmm, ddx_error)
    ! Allocate resources
    allocate(phi_cav(ddx_data % constants % ncav), &
        & phi2_cav(ddx_data % constants % ncav), &
        & gradphi_cav(3, ddx_data % constants % ncav), &
        & gradphi2_cav(3, ddx_data % constants % ncav), &
        & hessianphi_cav(3, 3, ddx_data % constants % ncav), &
        & hessianphi2_cav(3, 3, ddx_data % constants % ncav), &
        & psi(ddx_data % constants % nbasis, ddx_data % params % nsph), &
        & psi2(ddx_data % constants % nbasis, ddx_data % params % nsph), &
        & force(3, ddx_data % params % nsph), &
        & stat=info)
    if(info .ne. 0) call test_error(-1, "Allocation failed")
    ! Dense operator mkrhs is trusted to have no errors, this must be somehow
    ! checked in the future.
    call mkrhs(ddx_data % params, ddx_data % constants, ddx_data % workspace, &
        & 1, phi_cav, 1, gradphi_cav, 1, hessianphi_cav, psi, charges)
    call mkrhs(ddx_data_fmm % params, ddx_data_fmm % constants, &
        & ddx_data_fmm % workspace, 1, phi2_cav, 1, gradphi2_cav, 1, &
        & hessianphi2_cav, psi2, charges)
    ! Compare potentials
    phi2_cav = phi2_cav - phi_cav
    gradphi2_cav = gradphi2_cav - gradphi_cav
    hessianphi2_cav = hessianphi2_cav - hessianphi_cav
    fnorm = dnrm2(ddx_data % constants % ncav, phi_cav, 1)
    fdiff = dnrm2(ddx_data % constants % ncav, phi2_cav, 1)
    print *, "Pot ", fdiff, fnorm, fdiff/fnorm
    if (fdiff .gt. threshold*fnorm) then
        call test_error(-1, "Potentials are different")
    end if
    fnorm = dnrm2(3*ddx_data % constants % ncav, gradphi_cav, 1)
    fdiff = dnrm2(3*ddx_data % constants % ncav, gradphi2_cav, 1)
    print *, "Grad", fdiff, fnorm, fdiff/fnorm
    if (fdiff .gt. threshold*fnorm) then
        call test_error(-1, "Gradients are different")
    end if
    fnorm = dnrm2(9*ddx_data % constants % ncav, hessianphi_cav, 1)
    fdiff = dnrm2(9*ddx_data % constants % ncav, hessianphi2_cav, 1)
    print *, "Hess", fdiff, fnorm, fdiff/fnorm
    if (fdiff .gt. threshold*fnorm) then
        call test_error(-1, "Hessians are different")
    end if
end subroutine check_mkrhs

subroutine check_dx(ddx_data, pm, pl, threshold)
    ! Inputs
    type(ddx_type), intent(inout) :: ddx_data
    integer, intent(in) :: pm, pl
    real(dp), intent(in) :: threshold
    ! Local variables
    type(ddx_type) :: ddx_data_fmm
    type(ddx_error_type) :: ddx_error
    integer :: irand, iseed(4)=(/0, 0, 0, 1/), do_diag
    integer, parameter :: nrand=10
    real(dp) :: x(ddx_data % constants % nbasis, ddx_data % params % nsph, nrand), &
        & y(ddx_data % constants % nbasis, ddx_data % params % nsph, nrand), &
        & z(ddx_data % constants % nbasis, ddx_data % params % nsph, nrand), &
        & xx(nrand, nrand), yy(nrand, nrand), full_norm, diff_norm
    real(dp), external :: dnrm2
    ! Init FMM-related ddx_data
    call allocate_model(ddx_data % params % nsph, ddx_data % params % csph(1, :), &
        & ddx_data % params % csph(2, :), ddx_data % params % csph(3, :), ddx_data % params % rsph, &
        & ddx_data % params % model, ddx_data % params % lmax, ddx_data % params % ngrid, ddx_data % params % force, &
        & 1, pm, pl, ddx_data % params % se, ddx_data % params % eta, &
        & ddx_data % params % eps, ddx_data % params % kappa, ddx_data % params % matvecmem, &
        & ddx_data % params % maxiter, ddx_data % params % jacobi_ndiis, &
        & ddx_data % params % nproc, &
        & dummy_file_name, ddx_data_fmm, ddx_error)
    ! Dense operator dx is trusted to have no errors, this must be somehow
    ! checked in the future.
    ! Get random x
    call dlarnv(2, iseed, ddx_data % constants % n * nrand, x)
    write(*, *) "pm=", pm, "pl=", pl
    do do_diag = 0, 1
        write(*, *) "do_diag=", do_diag
        ! Random check of FMM dx operator against dense dx operator
        do irand = 1, nrand
            call dx_dense(ddx_data % params, ddx_data % constants, &
                & ddx_data % workspace, do_diag, x(:, :, irand), y(:, :, irand), ddx_error)
        end do
        full_norm = dnrm2(ddx_data % constants % n * nrand, y, 1)
        do irand = 1, nrand
            call dx_fmm(ddx_data_fmm % params, ddx_data_fmm % constants, &
                & ddx_data_fmm % workspace, do_diag, x(:, :, irand), z(:, :, irand), ddx_error)
        end do
        diff_norm = dnrm2(ddx_data % constants % n * nrand, y-z, 1)
        write(*, *) "dx_dense vs dx_fmm rel.ddx_error=", diff_norm/full_norm
        if (diff_norm .gt. threshold*full_norm) then
            call test_error(-1, "FMM dstarx and dense dstarx are different")
        end if
        ! Check dense adjoint operator dstarx
        do irand = 1, nrand
            call dstarx_dense(ddx_data % params, ddx_data % constants, &
                & ddx_data % workspace, do_diag, x(:, :, irand), y(:, :, irand), ddx_error)
        end do
        call dgemm('T', 'N', nrand, nrand, ddx_data % constants % n, one, y, ddx_data % constants % n, &
            & y, ddx_data % constants % n, zero, xx, nrand)
        full_norm = dnrm2(nrand**2, xx, 1)
        do irand = 1, nrand
            call dx_dense(ddx_data % params, ddx_data % constants, &
                & ddx_data % workspace, do_diag, y(:, :, irand), z(:, :, irand), ddx_error)
        end do
        call dgemm('T', 'N', nrand, nrand, ddx_data % constants % n, one, z, ddx_data % constants % n, &
            & x, ddx_data % constants % n, zero, yy, nrand)
        diff_norm = dnrm2(nrand**2, xx-yy, 1)
        write(*, *) "dstarx_dense vs dx_dense rel.ddx_error=", diff_norm/full_norm
        if (diff_norm .gt. threshold*full_norm) then
            call test_error(-1, "FMM dstarx and dense dstarx are different")
        end if
        ! Check FMM adjoint operator dstarx (without precomputed FMM matrices)
        do irand = 1, nrand
            call dstarx_fmm(ddx_data_fmm % params, ddx_data_fmm % constants, &
                & ddx_data_fmm % workspace, do_diag, x(:, :, irand), y(:, :, irand), ddx_error)
        end do
        call dgemm('T', 'N', nrand, nrand, ddx_data % constants % n, one, y, ddx_data % constants % n, &
            & y, ddx_data % constants % n, zero, xx, nrand)
        full_norm = dnrm2(nrand**2, xx, 1)
        do irand = 1, nrand
            call dx_fmm(ddx_data_fmm % params, ddx_data_fmm % constants, &
                & ddx_data_fmm % workspace, do_diag, y(:, :, irand), z(:, :, irand), ddx_error)
        end do
        call dgemm('T', 'N', nrand, nrand, ddx_data % constants % n, one, z, ddx_data % constants % n, &
            & x, ddx_data % constants % n, zero, yy, nrand)
        diff_norm = dnrm2(nrand**2, xx-yy, 1)
        write(*, *) "dstarx_fmm vs dx_fmm rel.ddx_error=", diff_norm/full_norm
        if (diff_norm .gt. threshold*full_norm) then
            call test_error(-1, "FMM dstarx and dense dstarx are different")
        end if
    end do
    ! Free temporary objects
    call deallocate_model(ddx_data_fmm, ddx_error)
end subroutine check_dx

subroutine check_gradr(ddx_data, pm, pl, threshold)
    ! Inputs
    type(ddx_type), intent(inout) :: ddx_data
    integer, intent(in) :: pm, pl
    real(dp), intent(in) :: threshold
    ! Local variables
    type(ddx_type) :: ddx_data_fmm
    type(ddx_error_type) :: ddx_error
    real(dp), allocatable :: ygrid(:,:), g(:,:)
    integer :: iseed(4)=(/0, 0, 0, 1/)
    real(dp) :: full_norm, diff_norm, forces(3, ddx_data % params % nsph), &
        & forces2(3, ddx_data % params % nsph)
    real(dp), external :: dnrm2
    ! Init FMM-related ddx_data
    call allocate_model(ddx_data % params % nsph, ddx_data % params % csph(1, :), &
        & ddx_data % params % csph(2, :), ddx_data % params % csph(3, :), ddx_data % params % rsph, &
        & ddx_data % params % model, ddx_data % params % lmax, ddx_data % params % ngrid, ddx_data % params % force, &
        & 1, pm, pl, ddx_data % params % se, ddx_data % params % eta, &
        & ddx_data % params % eps, ddx_data % params % kappa, ddx_data % params % matvecmem, &
        & ddx_data % params % maxiter, ddx_data % params % jacobi_ndiis, &
        & ddx_data % params % nproc, &
        & dummy_file_name, ddx_data_fmm, ddx_error)
    ! Dense operator dx is trusted to have no errors, this must be somehow
    ! checked in the future.
    allocate(ygrid(ddx_data % params % ngrid, ddx_data % params % nsph), &
        & g(ddx_data % constants % nbasis, ddx_data % params % nsph))
    ! Get random ygrid and g
    call dlarnv(2, iseed, ddx_data % params % ngrid * ddx_data % params % nsph, ygrid)
    call dlarnv(2, iseed, ddx_data % constants % n, g)
    ! Check gradr
    call gradr_dense(ddx_data % params, ddx_data % constants, &
        & ddx_data % workspace, g, ygrid, forces)
    full_norm = dnrm2(3*ddx_data % params % nsph, forces, 1)
    call gradr_fmm(ddx_data_fmm % params, ddx_data_fmm % constants, &
        & ddx_data_fmm % workspace, g, ygrid, forces2)
    diff_norm = dnrm2(3*ddx_data % params % nsph, forces-forces2, 1)
    write(*, *) 'diff norm', diff_norm
    write(*, *) "gradr dense vs fmm rel.ddx_error=", diff_norm / full_norm
    if (diff_norm .gt. threshold*full_norm) then
        call test_error(-1, "Forces are different")
    end if
    deallocate(ygrid, g)
    call deallocate_model(ddx_data_fmm, ddx_error)
end subroutine check_gradr

end program test_ddx_operators

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

!> This is a compatibility module for dftd4 2.5.0 reproducing enough of the old 
!> API to compile the interface with Vasp.
module dftd4_compat
   use, intrinsic :: iso_fortran_env, only : error_unit
   use mctc_env, only : error_type, wp
   use mctc_io_math, only : matdet_3x3, matinv_3x3
   use dftd4, only: structure_type, new, d4_model, new_d4_model, rational_damping_param, &
      & damping_param, get_rational_damping, get_dispersion, realspace_cutoff
   implicit none
   private

   public :: dftd_options, dftd_parameter, dftd_results, molecule, mctc_logger, ws_cell
   public :: dlat_to_cell, dlat_to_dvol, dlat_to_rlat, d4par, d4_calculation

   type :: dftd_options
      integer :: lmbd = 3
      integer :: refq = 5
      real(wp) :: wf = 6.0_wp
      real(wp) :: g_a
      real(wp) :: g_c
      logical :: lmolpol
      logical :: lenergy
      logical :: lgradient
      logical :: lhessian
      integer :: print_level
   end type

   type :: dftd_parameter
      real(wp) :: s6
      real(wp) :: s8
      real(wp) :: s9 = 1.0_wp
      real(wp) :: a1
      real(wp) :: a2
      real(wp) :: alp = 16.0_wp
   end type

   type :: dftd_results
      real(wp), allocatable :: energy
      real(wp), allocatable :: gradient(:, :)
      real(wp), allocatable :: lattice_gradient(:, :)
   end type

   type :: ws_cell
   end type

   type :: molecule
      integer, allocatable :: at(:)
      real(wp), allocatable :: xyz(:, :)
      real(wp), allocatable :: lattice(:, :)
      real(wp), allocatable :: chrg
      integer, allocatable :: npbc
      logical, allocatable :: pbc
      real(wp), allocatable :: volume
      real(wp), allocatable :: cellpar(:)
      real(wp), allocatable :: rec_lat(:, :)
      type(ws_cell) :: wsc
   contains
      procedure :: allocate
      procedure :: wrap_back
      procedure :: calculate_distances
   end type

   type :: mctc_logger
      logical :: sane = .true.
   end type

contains

subroutine allocate(self, n, l)
   class(molecule), intent(inout) :: self
   integer, intent(in) :: n
   logical, intent(in) :: l
end subroutine allocate

subroutine wrap_back(self)
   class(molecule), intent(inout) :: self
end subroutine wrap_back

subroutine calculate_distances(self)
   class(molecule), intent(inout) :: self
end subroutine calculate_distances

subroutine d4_calculation(io, env, options, mol_, param_, res)
   integer, intent(in) :: io
   type(mctc_logger), intent(inout) :: env
   type(dftd_options), intent(in) :: options
   type(molecule), intent(in) :: mol_
   type(dftd_parameter), intent(in) :: param_
   type(dftd_results), intent(out) :: res

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(error_type), allocatable :: error
   type(rational_damping_param) :: param
   real(wp), allocatable :: energy, gradient(:, :), sigma(:, :)

   call new(mol, mol_%at, mol_%xyz, lattice=mol_%lattice)
   call new_d4_model(error, d4, mol, ga=options%g_a, gc=options%g_c, wf=options%wf)
   if(allocated(error)) then
      write(error_unit, '("[Error]:", 1x, a)') error%message
      error stop
   end if

   param = rational_damping_param(&
      & s6=param_%s6, &
      & s8=param_%s8, &
      & s9=param_%s9, &
      & a1=param_%a1, &
      & a2=param_%a2, &
      & alp=param_%alp)

   allocate(energy, gradient(3, mol%nat), sigma(3, 3))
   call get_dispersion(mol, d4, param, realspace_cutoff(), energy, gradient, sigma)
   call move_alloc(energy, res%energy)
   call move_alloc(gradient, res%gradient)
   res%lattice_gradient = matmul(sigma, transpose(matinv_3x3(mol%lattice)))

end subroutine d4_calculation

subroutine d4par(fname, param_, lmbd, env)
   character(len=*), intent(in) :: fname
   type(dftd_parameter), intent(out) :: param_
   integer, intent(in) :: lmbd
   type(mctc_logger) :: env

   class(damping_param), allocatable :: param

   call get_rational_damping(fname, param, merge(1.0_wp, 0.0_wp, lmbd == 3))
   if (allocated(param)) then
      select type(param)
      type is(rational_damping_param)
         env%sane = .true.
         param_%s6 = param%s6
         param_%s8 = param%s8
         param_%s9 = param%s9
         param_%a1 = param%a1
         param_%a2 = param%a2
         param_%alp = param%alp
      class default
         env%sane = .false.
      end select
   else
      env%sane = .false.
   end if
end subroutine d4par

subroutine dlat_to_cell(lattice, cellpar)
   real(wp), intent(in) :: lattice(3, 3)
   real(wp), intent(out), optional :: cellpar(6)
end subroutine dlat_to_cell

subroutine dlat_to_rlat(lattice, reclatt)
   real(wp), intent(in) :: lattice(3, 3)
   real(wp), intent(out), optional :: reclatt(3, 3)
end subroutine dlat_to_rlat

function dlat_to_dvol(lattice) result(vol)
   real(wp), intent(in) :: lattice(3, 3)
   real(wp) :: vol
   vol = matdet_3x3(lattice)
end function dlat_to_dvol

end module dftd4_compat


subroutine generate_wsc(mol, wsc)
   use dftd4_compat, only : molecule, ws_cell
   type(molecule), intent(inout) :: mol
   type(ws_cell), intent(inout) :: wsc
end subroutine generate_wsc

module class_set
   use dftd4_compat, only : dftd_options
end module class_set

module class_param
   use dftd4_compat, only : dftd_parameter
end module class_param

module class_molecule
   use dftd4_compat, only : molecule
end module class_molecule

module class_results
   use dftd4_compat, only : dftd_results
end module class_results

module class_wsc
   use dftd4_compat, only : ws_cell
end module class_wsc

module mctc_environment
   use dftd4_compat, only : mctc_logger
end module mctc_environment

module dispersion_calculator
   use dftd4_compat, only : d4_calculation
end module dispersion_calculator

module pbc_tools
   use dftd4_compat, only: dlat_to_cell, dlat_to_dvol, dlat_to_rlat
end module pbc_tools

module dfuncpar
   use dftd4_compat, only : d4par
end module dfuncpar

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_solvation_cpcm
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type
   use mstore, only : get_structure
   use tblite_container, only : container_cache
   use tblite_scf_potential, only : potential_type
   use tblite_solvation_cpcm, only : cpcm_solvation, new_cpcm, cpcm_input
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: collect_solvation_cpcm


contains


!> Collect all exported unit tests
subroutine collect_solvation_cpcm(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("energy-mol", test_e_m01), &
      new_unittest("gradient-mol", test_g_m02), &
      new_unittest("potential-mol", test_p_m03) &
      ]

end subroutine collect_solvation_cpcm


subroutine test_e(error, mol, qat, ref)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Reference energy
   real(wp), intent(in) :: ref

   type(cpcm_solvation) :: solv
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: feps = 80.0_wp, rscale = 1.0_wp
   integer, parameter :: nang = 110
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp) :: energy(mol%nat)

   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))
   energy = 0.0_wp

   solv = cpcm_solvation(mol, cpcm_input(feps, nang=nang, rscale=rscale))

   call solv%update(mol, cache)
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)

   if (abs(sum(energy) - ref) > thr) then
      call test_failed(error, "Energy does not match reference")
      print *, sum(energy)
   end if
end subroutine test_e


subroutine test_g(error, mol, qat)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   type(cpcm_solvation) :: solv
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: feps = 80.0_wp, rscale = 1.0_wp
   integer, parameter :: nang = 26
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp), allocatable :: gradient(:, :), numg(:, :)
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat), sigma(3, 3)
   integer :: ii, ic

   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))

   solv = cpcm_solvation(mol, cpcm_input(feps, nang=nang, rscale=rscale))

   allocate(numg(3, mol%nat), gradient(3, mol%nat))
   do ii = 1, mol%nat
      do ic = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(ic, ii) = mol%xyz(ic, ii) + step
         call solv%update(mol, cache)
         call solv%get_potential(mol, cache, wfn, pot)
         call solv%get_energy(mol, cache, wfn, er)

         mol%xyz(ic, ii) = mol%xyz(ic, ii) - 2*step
         call solv%update(mol, cache)
         call solv%get_potential(mol, cache, wfn, pot)
         call solv%get_energy(mol, cache, wfn, el)

         mol%xyz(ic, ii) = mol%xyz(ic, ii) + step
         numg(ic, ii) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp

   call solv%update(mol, cache)
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)
   call solv%get_gradient(mol, cache, wfn, gradient, sigma)

   if (any(abs(gradient - numg) > thr)) then
      call test_failed(error, "Gradient does not match")
      print '(3es20.13)', gradient
      print '(a)', "---"
      print '(3es20.13)', numg
      print '(a)', "---"
      print '(3es20.13)', gradient - numg
   end if
end subroutine test_g


subroutine test_p(error, mol, qat)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   type(cpcm_solvation) :: solv
   type(wavefunction_type) :: wfn
   type(potential_type) :: pot
   type(container_cache) :: cache
   real(wp), parameter :: feps = 80.0_wp, rscale = 1.0_wp
   integer, parameter :: nang = 26
   real(wp), parameter :: step = 1.0e-4_wp
   real(wp), parameter :: thr = 1e+3_wp*sqrt(epsilon(1.0_wp))
   real(wp), allocatable :: vat(:)
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat)
   integer :: ii

   wfn%qat = reshape(qat, [size(qat), 1])
   allocate(pot%vat(size(qat, 1), 1))

   solv = cpcm_solvation(mol, cpcm_input(feps, nang=nang, rscale=rscale))

   call solv%update(mol, cache)

   allocate(vat(mol%nat))
   do ii = 1, mol%nat
      er = 0.0_wp
      el = 0.0_wp
      wfn%qat(ii, 1) = wfn%qat(ii, 1) + step
      call solv%get_potential(mol, cache, wfn, pot)
      call solv%get_energy(mol, cache, wfn, er)

      wfn%qat(ii, 1) = wfn%qat(ii, 1) - 2*step
      call solv%get_potential(mol, cache, wfn, pot)
      call solv%get_energy(mol, cache, wfn, el)

      wfn%qat(ii, 1) = wfn%qat(ii, 1) + step
      vat(ii) = 0.5_wp*(sum(er) - sum(el))/step
   end do

   energy = 0.0_wp
   pot%vat(:, :) = 0.0_wp
   call solv%get_potential(mol, cache, wfn, pot)
   call solv%get_energy(mol, cache, wfn, energy)

   if (any(abs([pot%vat] - vat) > thr)) then
      call test_failed(error, "Potential does not match")
      print '(3es20.13)', pot%vat
      print '(a)', "---"
      print '(3es20.13)', vat
      print '(a)', "---"
      print '(3es20.13)', [pot%vat] - vat
   end if
end subroutine test_p


subroutine test_e_m01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 7.73347900345264E-1_wp, 1.07626888948184E-1_wp,-3.66999593831010E-1_wp,&
      & 4.92833325937897E-2_wp,-1.83332156197733E-1_wp, 2.33302086605469E-1_wp,&
      & 6.61837152062315E-2_wp,-5.43944165050002E-1_wp,-2.70264356583716E-1_wp,&
      & 2.66618968841682E-1_wp, 2.62725033202480E-1_wp,-7.15315510172571E-2_wp,&
      &-3.73300777019193E-1_wp, 3.84585237785621E-2_wp,-5.05851088366940E-1_wp,&
      & 5.17677238544189E-1_wp]

   call get_structure(mol, "MB16-43", "01")
   call test_e(error, mol, qat, -2.1546508620217987E-3_wp)

end subroutine test_e_m01


subroutine test_g_m02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      & 7.38394711236234E-2_wp,-1.68354976558608E-1_wp,-3.47642833746823E-1_wp,&
      &-7.05489267186003E-1_wp, 7.73548301641266E-1_wp, 2.30207581365386E-1_wp,&
      & 1.02748501676354E-1_wp, 9.47818107467040E-2_wp, 2.44260351729187E-2_wp,&
      & 2.34984927037408E-1_wp,-3.17839896393030E-1_wp, 6.67112994818879E-1_wp,&
      &-4.78119977010488E-1_wp, 6.57536027459275E-2_wp, 1.08259054549882E-1_wp,&
      &-3.58215329983396E-1_wp]

   call get_structure(mol, "MB16-43", "02")
   call test_g(error, mol, qat)

end subroutine test_g_m02


subroutine test_p_m03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   real(wp), parameter :: qat(*) = [&
      &-1.77788256288236E-1_wp,-8.22943267808161E-1_wp, 4.04578389873281E-2_wp,&
      & 5.79710531992282E-1_wp, 6.99601887637659E-1_wp, 6.84309612639107E-2_wp,&
      &-3.42971414989811E-1_wp, 4.64954031865410E-2_wp, 6.77012204116428E-2_wp,&
      & 8.49931225363225E-2_wp,-5.22285304699699E-1_wp,-2.92515001764712E-1_wp,&
      &-3.98375452377043E-1_wp, 2.09769668297792E-1_wp, 7.23140464830357E-1_wp,&
      & 3.65775987838250E-2_wp]

   call get_structure(mol, "MB16-43", "03")
   call test_p(error, mol, qat)

end subroutine test_p_m03


end module test_solvation_cpcm

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_write_gaussian
   use mctc_env_accuracy, only : wp
   use mctc_io_structure, only : structure_type
   implicit none
   private

   public :: write_gaussian_external


contains


subroutine write_gaussian_external(mol, unit)
   type(structure_type), intent(in) :: mol
   integer, intent(in) :: unit
   integer :: iat

   write(unit, '(4i10)') mol%nat, 1, nint(mol%charge), mol%uhf
   do iat = 1, mol%nat
      write(unit, '(i10,4f20.12)') mol%num(mol%id(iat)), mol%xyz(:, iat), 0.0_wp
   end do

end subroutine write_gaussian_external


end module mctc_io_write_gaussian

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/post_processing/molmom.f90
!> Implements the calculation of molecular moments as post processing methods.
module tblite_post_processing_molmom
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_basis_type, only : basis_type
   use tblite_container_list, only : cache_list
   use tblite_context, only : context_type
   use tblite_double_dictionary, only : double_dictionary_type
   use tblite_integral_type, only : integral_type
   use tblite_output_format, only : format_string
   use tblite_param_post_processing_molmom, only : molmom_record
   use tblite_post_processing_type, only : post_processing_type
   use tblite_results, only : results_type
   use tblite_timer, only : timer_type, format_time
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_wavefunction_mulliken, only : get_molecular_dipole_moment, &
      & get_molecular_quadrupole_moment
   implicit none
   private

   public :: molecular_moments, new_molecular_moments

   !> Molecular moments as post-processing method  
   type, extends(post_processing_type) :: molecular_moments
      !> Perform dipole moment calculation
      logical :: comp_dipm = .true.
      !> Perform quadrupole moment calculation
      logical :: comp_qm = .true.
   contains
      !> Calculate molecular moments
      procedure :: compute
      !> Print timings
      procedure :: print_timer
   end type molecular_moments

   character(len=27), parameter :: label = "Molecular Multipole Moments"

contains

subroutine new_molecular_moments(self, param)
   !> Instance of the molecular moments post-processing
   type(molecular_moments), intent(out) :: self
   !> Molecular multipole parameterization
   type(molmom_record), intent(in) :: param
   
   self%label = label

   self%comp_dipm = param%moldipm
   self%comp_qm = param%molqp

end subroutine new_molecular_moments

subroutine compute(self, mol, wfn, ints, calc, caches, ctx, timer, prlevel, dict)
   !> Instance of the molecular moments post-processing
   class(molecular_moments),intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction strcuture data
   type(wavefunction_type), intent(in) :: wfn
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Calculator instance
   type(xtb_calculator), intent(in) :: calc
   !> Cache list for storing caches of various interactions
   type(cache_list), intent(inout) :: caches
   !> Context container for writing to stdout
   type(context_type), intent(inout) :: ctx
   !> Timer instance
   type(timer_type), intent(inout) :: timer
   !> Print level
   integer, intent(in) :: prlevel
   !> Dictionary for storing results
   type(double_dictionary_type), intent(inout) :: dict
   real(wp) :: dipm(3), qp(6)

   call timer%push("molmom")
   if (self%comp_dipm) then
      call timer%push("dipole")
      call get_molecular_dipole_moment(mol, wfn%qat(:, 1), wfn%dpat(:, :, 1), dipm)
      call dict%add_entry("molecular-dipole", dipm)
      call timer%pop()
   end if
   if (self%comp_qm) then
      call timer%push("quadrupole")
      call get_molecular_quadrupole_moment(mol, wfn%qat(:, 1), wfn%dpat(:, :, 1), &
         & wfn%qpat(:, :, 1), qp)
      call dict%add_entry("molecular-quadrupole", qp)
      call timer%pop()
   end if
   call timer%pop()

end subroutine compute

subroutine print_timer(self, timer, prlevel, ctx)
   !> Instance of the molecular moments post-processing
   class(molecular_moments), intent(in) :: self
   !> Timer instance
   type(timer_type), intent(in) :: timer
   !> Print level
   integer, intent(in) :: prlevel
   !> Context container for writing to stdout
   type(context_type), intent(inout) :: ctx

   real(wp) :: ttime, stime
   integer :: it
   character(len=*), parameter :: labels(*) = [character(len=20):: &
      "dipole", "quadrupole" ]

   if (prlevel > 2) then
      call ctx%message(label//" timing details:")
      ttime = timer%get("molmom")
      call ctx%message(" total:"//repeat(" ", 16)//format_time(ttime))
      do it = 1, size(labels)
         stime = timer%get(labels(it))
         if (stime <= epsilon(0.0_wp)) cycle
         call ctx%message(" - "//labels(it)//format_time(stime) &
            & //" ("//format_string(int(stime/ttime*100), '(i3)')//"%)")
      end do
      call ctx%message("")
   end if

end subroutine print_timer

end module tblite_post_processing_molmom

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_solvation_surface
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type
   use mctc_io_convert, only : aatoau, kcaltoau
   use mstore, only : get_structure
   use tblite_container, only : container_cache
   use tblite_mesh_lebedev, only : grid_size
   use tblite_scf_potential, only : potential_type
   use tblite_solvation_cds
   use tblite_solvation_data
   use tblite_solvation_surface
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: collect_solvation_surface

   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

contains


!> Collect all exported unit tests
subroutine collect_solvation_surface(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("surface-1", test_mb01), &
      new_unittest("surface-2", test_mb02), &
      new_unittest("surface-3", test_mb03), &
      new_unittest("surface-4", test_mb04) &
      ]

end subroutine collect_solvation_surface


subroutine test_numg(error, sasa, mol)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Surface integrator
   type(surface_integrator), intent(inout) :: sasa
   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   integer :: iat, ic
   real(wp), allocatable :: surface(:), sr(:), sl(:), dsdr(:, :, :), numg(:, :, :)
   real(wp), parameter :: step = 1.0e-5_wp

   allocate(surface(mol%nat), sr(mol%nat), sl(mol%nat))
   allocate(dsdr(3, mol%nat, mol%nat), numg(3, mol%nat, mol%nat))

   call sasa%get_surface(mol, surface, dsdr)

   do iat = 1, mol%nat
      do ic = 1, 3
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call sasa%get_surface(mol, sr)

         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2*step
         call sasa%get_surface(mol, sl)

         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step

         numg(ic, iat, :) = 0.5_wp * (sr - sl) / step
      end do
   end do

   if (any(abs(numg - dsdr) > thr2)) then
      call test_failed(error, "Surface derivative does not much finite difference solution")
   end if
end subroutine test_numg


subroutine test_mb01(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(surface_integrator) :: sasa
   real(wp), allocatable :: rad(:), surface(:), dsdr(:, :, :)
   real(wp), parameter :: probe = 1.4_wp * aatoau
   integer, parameter :: nang = 110
   real(wp), parameter :: ref(16) = [&
      & 1.98249964603498E+2_wp, 9.34967918541344E+1_wp, 7.26746425976157E+1_wp, &
      & 3.72308705072405E+1_wp, 1.00057039498616E+2_wp, 8.72703799995796E+1_wp, &
      & 1.75563553107864E+1_wp, 5.79324044295481E+1_wp, 9.81701754804677E-3_wp, &
      & 1.05256238904348E+2_wp, 6.62363240313345E+1_wp, 1.44944528018566E+2_wp, &
      & 3.33346853562456E+1_wp, 5.79746582175529E+1_wp, 6.69252984752073E+0_wp, &
      & 4.86484694486336E+1_wp]

   call get_structure(mol, "MB16-43", "01")

   allocate(surface(mol%nat), dsdr(3, mol%nat, mol%nat))
   rad = get_vdw_rad_d3(mol%num)

   call new_surface_integrator(sasa, mol%id, rad, probe, nang)
   call sasa%get_surface(mol, surface, dsdr)

   if (any(abs(surface - ref) > thr2)) then
      call test_failed(error, "Surface area values do not match")
      print '(es20.14e1)', surface
      return
   end if

   call test_numg(error, sasa, mol)

end subroutine test_mb01


subroutine test_mb02(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(surface_integrator) :: sasa
   real(wp), allocatable :: rad(:), surface(:), dsdr(:, :, :)
   real(wp), parameter :: probe = 1.2_wp * aatoau
   integer, parameter :: nang = 230
   real(wp), parameter :: ref(16) = [&
      & 2.86084867868854E+1_wp, 7.50937555534059E+1_wp, 8.05879869880977E+1_wp, &
      & 8.24020440962820E+1_wp, 6.48136730299052E+1_wp, 1.97586791688521E+1_wp, &
      & 4.90632288004349E+1_wp, 5.29220735596789E+1_wp, 9.14599031786151E+1_wp, &
      & 1.38294851260743E+1_wp, 9.02032751808618E+1_wp, 1.13713659875286E+2_wp, &
      & 9.83820274680035E+1_wp, 5.95926059359978E+1_wp, 2.96614646358023E+0_wp, &
      & 1.44874751490690E+2_wp]

   call get_structure(mol, "MB16-43", "02")

   allocate(surface(mol%nat), dsdr(3, mol%nat, mol%nat))
   rad = get_vdw_rad_bondi(mol%num)

   call new_surface_integrator(sasa, mol%id, rad, probe, nang)
   call sasa%get_surface(mol, surface, dsdr)

   if (any(abs(surface - ref) > thr2)) then
      call test_failed(error, "Surface area values do not match")
      print '(es20.14e1)', surface
      return
   end if

   call test_numg(error, sasa, mol)

end subroutine test_mb02


subroutine test_mb03(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(surface_integrator) :: sasa
   real(wp), allocatable :: rad(:), surface(:), dsdr(:, :, :)
   real(wp), parameter :: probe = 0.2_wp * aatoau
   integer, parameter :: nang = 111
   real(wp), parameter :: ref(16) = [&
      & 4.93447390726497E+1_wp, 5.42387849176901E+1_wp, 2.58043997374119E+1_wp, &
      & 3.26892803192176E+1_wp, 1.27988010759842E+1_wp, 9.45810634518707E+1_wp, &
      & 3.43532470377123E+1_wp, 2.76341416140764E+1_wp, 2.74903764017798E+1_wp, &
      & 2.85813017859723E+1_wp, 7.99313005786035E+1_wp, 1.26258175473983E+2_wp, &
      & 5.38016574162998E+1_wp, 4.16287245622076E+1_wp, 9.95930646536509E+1_wp, &
      & 2.36024718294637E+1_wp]

   call get_structure(mol, "MB16-43", "03")

   allocate(surface(mol%nat), dsdr(3, mol%nat, mol%nat))
   rad = get_vdw_rad_cosmo(mol%num)

   call new_surface_integrator(sasa, mol%id, rad, probe, nang)
   call sasa%get_surface(mol, surface, dsdr)

   if (any(abs(surface - ref) > thr2)) then
      call test_failed(error, "Surface area values do not match")
      print '(es20.14e1)', surface
      return
   end if

   call test_numg(error, sasa, mol)

end subroutine test_mb03


subroutine test_mb04(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(surface_integrator) :: sasa
   integer :: iang
   real(wp) :: this_thr
   real(wp), allocatable :: rad(:), surface(:), dsdr(:, :, :)
   real(wp), parameter :: probe = 1.4_wp * aatoau
   real(wp), parameter :: ref(16) = [&
      & 3.17888247611432E+1_wp, 1.10843192696983E+2_wp, 6.88322052202638E+1_wp, &
      & 1.14544539499935E+2_wp, 1.70720777217273E+2_wp, 3.13678106939536E+1_wp, &
      & 4.58475696363698E+1_wp, 1.93179973492600E+2_wp, 6.00038960472752E+1_wp, &
      & 6.11241830969292E+1_wp, 4.51433358912678E+1_wp, 9.79240755827738E+0_wp, &
      & 1.11790314288253E+2_wp, 3.26024198194955E+1_wp, 7.04914426556603E+1_wp, &
      & 7.70033482758105E+1_wp]

   call get_structure(mol, "MB16-43", "04")

   allocate(surface(mol%nat), dsdr(3, mol%nat, mol%nat))
   rad = get_vdw_rad_bondi(mol%num)

   do iang = 1, size(grid_size)
      call new_surface_integrator(sasa, mol%id, rad, probe, grid_size(iang))
      call sasa%get_surface(mol, surface, dsdr)

      if (grid_size(iang) > 1000) then
         this_thr = 0.1_wp
      else if (grid_size(iang) > 250) then
         this_thr = 1.0_wp
      else if (grid_size(iang) > 75) then
         this_thr = 10.0_wp
      else
         cycle
      end if
      call check(error, 0.0_wp, norm2(abs(surface - ref)), thr=this_thr)
      if (allocated(error)) return
   end do

   if (any(abs(surface - ref) > thr2)) then
      call test_failed(error, "Surface area values do not match")
      print '(es20.14e1)', surface
      return
   end if

end subroutine test_mb04

end module test_solvation_surface

! This file is part of test-drive.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!# Enable support for quadruple precision
#ifndef WITH_QP
#define WITH_QP 0
#endif

!# Enable support for extended double precision
#ifndef WITH_XDP
#define WITH_XDP 0
#endif

!# Enable ieee_is_nan for NaN detection
#ifndef WITH_IEEE_IS_NAN
#define WITH_IEEE_IS_NAN 0
#endif

!> Provides a light-weight procedural testing framework for Fortran projects.
!>
!> Testsuites are defined by a [[collect_interface]] returning a set of
!> [[unittest_type]] objects. To create a new test use the [[new_unittest]]
!> constructor, which requires a test identifier and a procedure with a
!> [[test_interface]] compatible signature. The error status is communicated
!> by the allocation status of an [[error_type]].
!>
!> The necessary boilerplate code to setup the test entry point is just
!>
!>```fortran
!>program tester
!>  use, intrinsic :: iso_fortran_env, only : error_unit
!>  use testdrive, only : run_testsuite, new_testsuite, testsuite_type
!>  use test_suite1, only : collect_suite1
!>  use test_suite2, only : collect_suite2
!>  implicit none
!>  integer :: stat, is
!>  type(testsuite_type), allocatable :: testsuites(:)
!>  character(len=*), parameter :: fmt = '("#", *(1x, a))'
!>
!>  stat = 0
!>
!>  testsuites = [ &
!>    new_testsuite("suite1", collect_suite1), &
!>    new_testsuite("suite2", collect_suite2) &
!>    ]
!>
!>  do is = 1, size(testsuites)
!>    write(error_unit, fmt) "Testing:", testsuites(is)%name
!>    call run_testsuite(testsuites(is)%collect, error_unit, stat)
!>  end do
!>
!>  if (stat > 0) then
!>    write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
!>    error stop
!>  end if
!>
!>end program tester
!>```
!>
!> Every test is defined in a separate module using a ``collect`` function, which
!> is exported and added to the ``testsuites`` array in the test runner.
!> All test have a simple interface with just an allocatable [[error_type]] as
!> output to provide the test results.
!>
!>```fortran
!>module test_suite1
!>  use testdrive, only : new_unittest, unittest_type, error_type, check
!>  implicit none
!>  private
!>
!>  public :: collect_suite1
!>
!>contains
!>
!>!> Collect all exported unit tests
!>subroutine collect_suite1(testsuite)
!>  !> Collection of tests
!>  type(unittest_type), allocatable, intent(out) :: testsuite(:)
!>
!>  testsuite = [ &
!>    new_unittest("valid", test_valid), &
!>    new_unittest("invalid", test_invalid, should_fail=.true.) &
!>    ]
!>
!>end subroutine collect_suite1
!>
!>subroutine test_valid(error)
!>  type(error_type), allocatable, intent(out) :: error
!>  ! ...
!>end subroutine test_valid
!>
!>subroutine test_invalid(error)
!>  type(error_type), allocatable, intent(out) :: error
!>  ! ...
!>end subroutine test_invalid
!>
!>end module test_suite1
!>```
!>
!> For an example setup checkout the ``test/`` directory in this project.
module testdrive
  use, intrinsic :: iso_fortran_env, only : error_unit
  implicit none
  private

  public :: run_testsuite, run_selected, new_unittest, new_testsuite
  public :: select_test, select_suite
  public :: unittest_type, testsuite_type, error_type
  public :: check, test_failed, skip_test
  public :: test_interface, collect_interface
  public :: get_argument, get_variable, to_string
  public :: junit_output, junit_header
  public :: init_color_output


  !> Single precision real numbers
  integer, parameter :: sp = selected_real_kind(6)

  !> Double precision real numbers
  integer, parameter :: dp = selected_real_kind(15)

#if WITH_XDP
  !> Extended double precision real numbers
  integer, parameter :: xdp = selected_real_kind(18)
#endif

#if WITH_QP
  !> Quadruple precision real numbers
  integer, parameter :: qp = selected_real_kind(33)
#endif

  !> Char length for integers
  integer, parameter :: i1 = selected_int_kind(2)

  !> Short length for integers
  integer, parameter :: i2 = selected_int_kind(4)

  !> Length of default integers
  integer, parameter :: i4 = selected_int_kind(9)

  !> Long length for integers
  integer, parameter :: i8 = selected_int_kind(18)

  !> Error code for success
  integer, parameter :: success = 0

  !> Error code for failure
  integer, parameter :: fatal = 1

  !> Error code for skipped test
  integer, parameter :: skipped = 77


  !> Error message
  type :: error_type

    !> Error code
    integer :: stat = success

    !> Payload of the error
    character(len=:), allocatable :: message

  contains

    !> Escalate uncaught errors
    final :: escalate_error

  end type error_type


  interface check
    module procedure :: check_stat
    module procedure :: check_logical
    module procedure :: check_float_sp
    module procedure :: check_float_dp
#if WITH_XDP
    module procedure :: check_float_xdp
#endif
#if WITH_QP
    module procedure :: check_float_qp
#endif
    module procedure :: check_float_exceptional_sp
    module procedure :: check_float_exceptional_dp
#if WITH_XDP
    module procedure :: check_float_exceptional_xdp
#endif
#if WITH_QP
    module procedure :: check_float_exceptional_qp
#endif
    module procedure :: check_complex_sp
    module procedure :: check_complex_dp
#if WITH_XDP
    module procedure :: check_complex_xdp
#endif
#if WITH_QP
    module procedure :: check_complex_qp
#endif
    module procedure :: check_complex_exceptional_sp
    module procedure :: check_complex_exceptional_dp
#if WITH_XDP
    module procedure :: check_complex_exceptional_xdp
#endif
#if WITH_QP
    module procedure :: check_complex_exceptional_qp
#endif
    module procedure :: check_float_absrel_sp
    module procedure :: check_float_absrel_dp
#if WITH_XDP
    module procedure :: check_float_absrel_xdp
#endif
#if WITH_QP
    module procedure :: check_float_absrel_qp
#endif
    module procedure :: check_complex_absrel_sp
    module procedure :: check_complex_absrel_dp
#if WITH_XDP
    module procedure :: check_complex_absrel_xdp
#endif
#if WITH_QP
    module procedure :: check_complex_absrel_qp
#endif
    module procedure :: check_int_i1
    module procedure :: check_int_i2
    module procedure :: check_int_i4
    module procedure :: check_int_i8
    module procedure :: check_bool
    module procedure :: check_string
  end interface check


  interface to_string
    module procedure :: integer_i1_to_string
    module procedure :: integer_i2_to_string
    module procedure :: integer_i4_to_string
    module procedure :: integer_i8_to_string
    module procedure :: real_sp_to_string
    module procedure :: real_dp_to_string
#if WITH_XDP
    module procedure :: real_xdp_to_string
#endif
#if WITH_QP
    module procedure :: real_qp_to_string
#endif
    module procedure :: complex_sp_to_string
    module procedure :: complex_dp_to_string
#if WITH_XDP
    module procedure :: complex_xdp_to_string
#endif
#if WITH_QP
    module procedure :: complex_qp_to_string
#endif
  end interface to_string


  !> Check for not-a-number (NaN) values. Uses the IEEE intrinsic
  !> `ieee_is_nan` when available, and falls back to a portable
  !> comparison-based implementation (using `HUGE`/`ABS`) when IEEE
  !> arithmetic is disabled.
  interface is_nan
    module procedure :: is_nan_sp
    module procedure :: is_nan_dp
#if WITH_XDP
    module procedure :: is_nan_xdp
#endif
#if WITH_QP
    module procedure :: is_nan_qp
#endif
  end interface is_nan


  abstract interface
    !> Entry point for tests
    subroutine test_interface(error)
      import :: error_type

      !> Error handling
      type(error_type), allocatable, intent(out) :: error

    end subroutine test_interface
  end interface


  !> Declaration of a unit test
  type :: unittest_type

    !> Name of the test
    character(len=:), allocatable :: name

    !> Entry point of the test
    procedure(test_interface), pointer, nopass :: test => null()

    !> Whether test is supposed to fail
    logical :: should_fail = .false.

  contains

    !> Deallocate unittest's internal data
    final :: destroy_unittest

  end type unittest_type


  abstract interface
    !> Collect all tests
    subroutine collect_interface(testsuite)
      import :: unittest_type
#ifdef __NVCOMPILER_LLVM__
      ! this is only an issue with nvhpc 25.9, possibly a bug in the compiler ! verify in next release
      import :: test_interface
#endif

      !> Collection of tests
      type(unittest_type), allocatable, intent(out) :: testsuite(:)

    end subroutine collect_interface
  end interface


  !> Collection of unit tests
  type :: testsuite_type

    !> Name of the testsuite
    character(len=:), allocatable :: name

    !> Entry point of the test
    procedure(collect_interface), pointer, nopass :: collect => null()

  contains

    !> Deallocate testsuite's internal data
    final :: destroy_testsuite

  end type testsuite_type


  !> Output JUnit.xml for discovering unit tests by other tools
  type :: junit_output
    !> XML output string (initial block)
    character(len=:), allocatable :: xml_start
    !> XML output string (current block)
    character(len=:), allocatable :: xml_block
    !> XML output string (final block)
    character(len=:), allocatable :: xml_final
    !> Unique identifier
    integer :: uid = 0
    !> Timestamp
    character(len=19) :: timestamp = '1970-01-01T00:00:00'
    !> Hostname
    character(len=:), allocatable :: hostname
    !> Package name
    character(len=:), allocatable :: package
    !> Testsuite name
    character(len=:), allocatable :: testsuite
    !> Number of tests
    integer :: tests = 0
    !> Number of failures
    integer :: failures = 0
    !> Number of errors
    integer :: errors = 0
    !> Number of skipped tests
    integer :: skipped = 0
    !> Running time
    real(sp) :: time = 0.0_sp
  contains
    final :: destroy_junit_output
  end type junit_output


  !> Container for terminal escape code
  type :: color_code
    !> Style descriptor
    integer(i1) :: style = -1_i1
    !> Background color descriptor
    integer(i1) :: bg = -1_i1
    !> Foreground color descriptor
    integer(i1) :: fg = -1_i1
  end type color_code

  interface operator(+)
    module procedure :: add_color
  end interface operator(+)

  interface operator(//)
    module procedure :: concat_color_left
    module procedure :: concat_color_right
  end interface operator(//)


  !> Colorizer class for handling colorful output in the terminal
  type, public :: color_output

    type(color_code) :: &
      reset = color_code(), &
      bold = color_code(), &
      dim = color_code(), &
      italic = color_code(), &
      underline = color_code(), &
      blink = color_code(), &
      reverse = color_code(), &
      hidden = color_code()

    type(color_code) :: &
      black = color_code(), &
      red = color_code(), &
      green = color_code(), &
      yellow = color_code(), &
      blue = color_code(), &
      magenta = color_code(), &
      cyan = color_code(), &
      white = color_code()

    type(color_code) :: &
      bg_black = color_code(), &
      bg_red = color_code(), &
      bg_green = color_code(), &
      bg_yellow = color_code(), &
      bg_blue = color_code(), &
      bg_magenta = color_code(), &
      bg_cyan = color_code(), &
      bg_white = color_code()
  end type color_output

  interface color_output
    module procedure :: new_color_output
  end interface color_output

  type(color_output), protected :: color

  character(len=*), parameter :: fmt = '(1x, *(1x, a))'
  character(len=*), parameter :: newline = new_line("a")


contains


  !> Driver for testsuite
  recursive subroutine run_testsuite(collect, unit, stat, parallel, junit)

    !> Collect tests
    procedure(collect_interface) :: collect

    !> Unit for IO
    integer, intent(in) :: unit

    !> Number of failed tests
    integer, intent(inout) :: stat

    !> Run the tests in parallel
    logical, intent(in), optional :: parallel

    !> Produce junit output
    type(junit_output), intent(inout), optional :: junit

    type(unittest_type), allocatable :: testsuite(:)
    integer :: it
    logical :: parallel_

    parallel_ = .true.
    if(present(parallel)) parallel_ = parallel

    call collect(testsuite)

    call junit_push_suite(junit, "testdrive")

    !$omp parallel do schedule(dynamic) shared(testsuite, unit) reduction(+:stat) &
    !$omp if (parallel_)
    do it = 1, size(testsuite)
      !$omp critical(testdrive_testsuite)
      write(unit, '(1x, 4(1x, a))') &
        & "Starting", (color%blue)//testsuite(it)%name//color%reset, &
        & color%dim//"..."//color%reset, &
        & color%bold//"(" // color%cyan//to_string(it)//color%bold // &
        & "/" // color%cyan//to_string(size(testsuite))//color%bold // ")"//color%reset
      !$omp end critical(testdrive_testsuite)
      call run_unittest(testsuite(it), unit, stat, junit)
    end do

    call junit_pop_suite(junit)

  end subroutine run_testsuite


  !> Driver for selective testing
  recursive subroutine run_selected(collect, name, unit, stat, junit)

    !> Collect tests
    procedure(collect_interface) :: collect

    !> Name of the selected test
    character(len=*), intent(in) :: name

    !> Unit for IO
    integer, intent(in) :: unit

    !> Number of failed tests
    integer, intent(inout) :: stat

    !> Produce junit output
    type(junit_output), intent(inout), optional :: junit

    type(unittest_type), allocatable :: testsuite(:)
    integer :: it

    call collect(testsuite)

    call junit_push_suite(junit, "testdrive")

    it = select_test(testsuite, name)

    if (it > 0 .and. it <= size(testsuite)) then
      call run_unittest(testsuite(it), unit, stat, junit)
    else
      write(unit, fmt) "Available tests:"
      do it = 1, size(testsuite)
        write(unit, fmt) "-", testsuite(it)%name
      end do
      stat = -huge(it)
    end if

    call junit_pop_suite(junit)

  end subroutine run_selected


  !> Run a selected unit test
  recursive subroutine run_unittest(test, unit, stat, junit)

    !> Unit test
    type(unittest_type), intent(in) :: test

    !> Unit for IO
    integer, intent(in) :: unit

    !> Number of failed tests
    integer, intent(inout) :: stat

    !> Produce junit output
    type(junit_output), intent(inout), optional :: junit

    type(error_type), allocatable :: error
    character(len=:), allocatable :: message

    call test%test(error)
    if (.not.test_skipped(error)) then
      if (allocated(error) .neqv. test%should_fail) stat = stat + 1
    end if
    call junit_push_test(junit, test, error, 0.0_sp)
    call make_output(message, test, error)
    !$omp critical(testdrive_testsuite)
    write(unit, '(a)') message
    !$omp end critical(testdrive_testsuite)
    if (allocated(error)) then
      call clear_error(error)
    end if

  end subroutine run_unittest


  pure function test_skipped(error) result(is_skipped)

    !> Error handling
    type(error_type), intent(in), optional :: error

    !> Test was skipped
    logical :: is_skipped

    is_skipped = .false.
    if (present(error)) then
      is_skipped = error%stat == skipped
    end if

  end function test_skipped


  !> Create output message for test (this procedure is pure and therefore cannot launch tests)
  pure subroutine make_output(output, test, error)

    !> Output message for display
    character(len=:), allocatable, intent(out) :: output

    !> Unit test
    type(unittest_type), intent(in) :: test

    !> Error handling
    type(error_type), intent(in), optional :: error

    character(len=:), allocatable :: label
    type(color_code) :: label_color

    if (test_skipped(error)) then
      label_color = color%yellow + color%bold
      label = "SKIPPED"
    else if (present(error) .neqv. test%should_fail) then
      if (test%should_fail) then
        label_color = color%magenta + color%bold
        label = "UNEXPECTED PASS"
      else
        label_color = color%red + color%bold
        label = "FAILED"
      end if
    else
      if (test%should_fail) then
        label_color = color%cyan + color%bold
        label = "EXPECTED FAIL"
      else
        label_color = color%green + color%bold
        label = "PASSED"
      end if
    end if
    output = "       " // color%dim//"..."//color%reset // " " // &
      & color%blue//test%name//color%reset // &
      & " "//color%bold//"["//label_color//label//color%bold//"]"//color%reset
    if (present(error)) then
      output = output // newline // "  "//color%bold//"Message:"//color%reset//" " // error%message
    end if
  end subroutine make_output


  !> Initialize output for JUnit.xml
  pure subroutine junit_header(junit, package)

    !> JUnit output
    type(junit_output), intent(inout), optional :: junit

    !> Package name
    character(len=*), intent(in) :: package

    if (.not.present(junit)) return

    junit%xml_start = &
      & '<?xml version="1.0" encoding="UTF-8"?>' // newline // &
      & '<testsuites' // newline // &
      & ' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"' // newline // & 
      & ' xsi:noNamespaceSchemaLocation="JUnit.xsd"' // newline // &
      & '>' // newline
    junit%xml_block = ''
    junit%xml_final = &
      & '</testsuites>'

    junit%hostname = 'localhost'
    junit%package = package

  end subroutine junit_header

  !> Register a test suite in JUnit.xml
  subroutine junit_push_suite(junit, name)

    !> JUnit output
    type(junit_output), intent(inout), optional :: junit

    !> Name of the test suite
    character(len=*), intent(in) :: name

    if (.not.present(junit)) return

    junit%timestamp = get_timestamp()
    junit%testsuite = name
    junit%uid = junit%uid + 1

  end subroutine junit_push_suite

  !> Finalize a test suite in JUnit.xml
  subroutine junit_pop_suite(junit)

    !> JUnit output
    type(junit_output), intent(inout), optional :: junit

    if (.not.present(junit)) return

    junit%xml_start = &
      & junit%xml_start // &
      & '  <testsuite' // newline // &
      & '   name="'//junit%testsuite//'"' // newline // &
      & '   package="'//junit%package//'"' // newline // &
      & '   id="'//to_string(junit%uid)//'"' // newline // &
      & '   timestamp="'//junit%timestamp//'"' // newline // &
      & '   hostname="'//junit%hostname//'"' // newline // &
      & '   tests="'//to_string(junit%tests)//'"' // newline // &
      & '   failures="'//to_string(junit%failures)//'"' // newline // &
      & '   errors="'//to_string(junit%errors)//'"' // newline // &
      & '   skipped="'//to_string(junit%skipped)//'"' // newline // &
      & '   time="'//to_string(junit%time)//'"' // newline // &
      & '  >' // newline // &
      & '  <properties>' // newline // &
      & '  </properties>' // newline // &
      & junit%xml_block // newline // &
      & '  </testsuite>' // newline

    junit%xml_block = ''
    junit%tests = 0
    junit%failures = 0
    junit%errors = 0
    junit%skipped = 0
    junit%time = 0.0_sp

    call junit_write(junit)

  end subroutine junit_pop_suite

  !> Register a new unit test
  subroutine junit_push_test(junit, test, error, time)

    !> JUnit output
    type(junit_output), intent(inout), optional :: junit

    !> Unit test
    type(unittest_type), intent(in) :: test

    !> Error handling
    type(error_type), intent(in), optional :: error

    !> Running time
    real(sp), intent(in) :: time

    if (.not.present(junit)) return

    !$omp critical(testdrive_junit)
    junit%tests = junit%tests + 1
    junit%time = junit%time + time

    junit%xml_block = &
      & junit%xml_block // &
      & '   <testcase' // newline // &
      & '    name="'//test%name//'"' // newline // &
      & '    classname="'//junit%testsuite//'"' // newline // &
      & '    time="'//to_string(time)//'"' // newline // &
      & '   >' // newline

    if (test_skipped(error)) then
      junit%xml_block = &
        & junit%xml_block // &
        & '    <skipped/>' // newline
      junit%skipped = junit%skipped + 1
    elseif (present(error)) then
      if (test%should_fail) then
        junit%xml_block = &
          & junit%xml_block // &
          & '    <system-out>' // newline // &
          & '     "'//error%message//'"' // newline // &
          & '    </system-out>' // newline
      else
        junit%xml_block = &
          & junit%xml_block // &
          & '    <failure' // newline // &
          & '     message="'//error%message//'"' // newline // &
          & '     type="AssertionError"' // newline // &
          & '    />' // newline
        junit%failures = junit%failures + 1
      end if
    else
      if (test%should_fail) then
        junit%xml_block = &
          & junit%xml_block // &
          & '    <failure' // newline // &
          & '     message="Unexpected pass"' // newline // &
          & '     type="AssertionError"' // newline // &
          & '    />' // newline
        junit%failures = junit%failures + 1
      else
        junit%xml_block = &
          & junit%xml_block // &
          & '    <system-out>' // newline // &
          & '     "Test passed successfully"' // newline // &
          & '    </system-out>' // newline
      end if
    end if

    junit%xml_block = &
      & junit%xml_block // &
      & '   </testcase>' // newline   
    !$omp end critical(testdrive_junit)

  end subroutine junit_push_test


  !> Write results to JUnit.xml
  subroutine junit_write(junit)

    !> JUnit output
    type(junit_output), intent(inout), optional :: junit

    integer :: io

    if (.not.present(junit)) return
    open( &
      & newunit=io, &
      & file='JUnit'//junit%package//'.xml', &
      & status='replace', &
      & action='write')
    write(io, '(a)') junit%xml_start // junit%xml_final
    close(io)

  end subroutine junit_write


  !> deallocate internal data of junit_output
  subroutine destroy_junit_output(self)

    !> JUnit output
    type(junit_output), intent(inout) :: self

    if (allocated(self%xml_start)) deallocate(self%xml_start)
    if (allocated(self%xml_block)) deallocate(self%xml_block)
    if (allocated(self%xml_final)) deallocate(self%xml_final)
    if (allocated(self%hostname)) deallocate(self%hostname)
    if (allocated(self%package)) deallocate(self%package)
    if (allocated(self%testsuite)) deallocate(self%testsuite)

  end subroutine destroy_junit_output


  !> Create ISO 8601 formatted timestamp
  function get_timestamp() result(timestamp)

    !> ISO 8601 formatted timestamp
    character(len=19) :: timestamp

    character(len=8) :: date
    character(len=10) :: time

    call date_and_time(date=date, time=time)

    timestamp = date(1:4) // "-" // date(5:6) // "-" // date(7:8) // "T" // &
      & time(1:2) // ":" // time(3:4) // ":" // time(5:6)

  end function get_timestamp


  !> Select a unit test from all available tests
  function select_test(tests, name) result(pos)

    !> Name identifying the test suite
    character(len=*), intent(in) :: name

    !> Available unit tests
    type(unittest_type) :: tests(:)

    !> Selected test suite
    integer :: pos

    integer :: it

    pos = 0
    do it = 1, size(tests)
      if (name == tests(it)%name) then
        pos = it
        exit
      end if
    end do

  end function select_test


  !> Select a test suite from all available suites
  function select_suite(suites, name) result(pos)

    !> Name identifying the test suite
    character(len=*), intent(in) :: name

    !> Available test suites
    type(testsuite_type) :: suites(:)

    !> Selected test suite
    integer :: pos

    integer :: it

    pos = 0
    do it = 1, size(suites)
      if (name == suites(it)%name) then
        pos = it
        exit
      end if
    end do

  end function select_suite


  !> Register a new unit test
  function new_unittest(name, test, should_fail) result(self)

    !> Name of the test
    character(len=*), intent(in) :: name

    !> Entry point for the test
    procedure(test_interface) :: test

    !> Whether test is supposed to error or not
    logical, intent(in), optional :: should_fail

    !> Newly registered test
    type(unittest_type) :: self

    self%name = name
    self%test => test
    if (present(should_fail)) self%should_fail = should_fail

  end function new_unittest


  !> Finalize unit test
  subroutine destroy_unittest(self)

    !> unittest to destroy
    type(unittest_type), intent(inout) :: self

    if (allocated(self%name)) deallocate(self%name)
    self%test => null()

  end subroutine destroy_unittest


  !> Register a new testsuite
  function new_testsuite(name, collect) result(self)

    !> Name of the testsuite
    character(len=*), intent(in) :: name

    !> Entry point to collect tests
    procedure(collect_interface) :: collect

    !> Newly registered testsuite
    type(testsuite_type) :: self

    self%name = name
    self%collect => collect

  end function new_testsuite


  !> Finalize testsuite
  subroutine destroy_testsuite(self)

    !> testsuite to destroy
    type(testsuite_type), intent(inout) :: self

    if (allocated(self%name)) deallocate(self%name)
    self%collect => null()

  end subroutine destroy_testsuite


  subroutine check_stat(error, stat, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Status of operation
    integer, intent(in) :: stat

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (stat /= success) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, "Non-zero exit code encountered", more)
      end if
    end if

  end subroutine check_stat


  subroutine check_logical(error, expression, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Result of logical operator
    logical, intent(in) :: expression

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (.not.expression) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, "Condition not fullfilled", more)
      end if
    end if

  end subroutine check_logical


  subroutine check_float_dp(error, actual, expected, message, more, thr, rel)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    real(dp), intent(in) :: actual

    !> Expected floating point value
    real(dp), intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    !> Allowed threshold for matching floating point values
    real(dp), intent(in), optional :: thr

    !> Check for relative errors instead
    logical, intent(in), optional :: rel

    logical :: relative
    real(dp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    if (present(thr)) then
      threshold = thr
    else
      threshold = epsilon(expected)
    end if

    if (present(rel)) then
      relative = rel
    else
      relative = .false.
    end if

    if (relative) then
      diff = abs(actual - expected) / abs(expected)
    else
      diff = abs(actual - expected)
    end if

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        if (relative) then
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(int(diff*100))//"%)", &
            more)
        else
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(diff)//")", &
            more)
        end if
      end if
    end if

  end subroutine check_float_dp


  subroutine check_float_exceptional_dp(error, actual, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    real(dp), intent(in) :: actual

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (is_nan(actual)) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, "Exceptional value 'not a number' found", more)
      end if
    end if

  end subroutine check_float_exceptional_dp


  subroutine check_float_sp(error, actual, expected, message, more, thr, rel)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    real(sp), intent(in) :: actual

    !> Expected floating point value
    real(sp), intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    !> Allowed threshold for matching floating point values
    real(sp), intent(in), optional :: thr

    !> Check for relative errors instead
    logical, intent(in), optional :: rel

    logical :: relative
    real(sp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    if (present(thr)) then
      threshold = thr
    else
      threshold = epsilon(expected)
    end if

    if (present(rel)) then
      relative = rel
    else
      relative = .false.
    end if

    if (relative) then
      diff = abs(actual - expected) / abs(expected)
    else
      diff = abs(actual - expected)
    end if

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        if (relative) then
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(int(diff*100))//"%)", &
            more)
        else
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(diff)//")", &
            more)
        end if
      end if
    end if

  end subroutine check_float_sp


  subroutine check_float_exceptional_sp(error, actual, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    real(sp), intent(in) :: actual

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (is_nan(actual)) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, "Exceptional value 'not a number' found", more)
      end if
    end if

  end subroutine check_float_exceptional_sp


#if WITH_XDP
  subroutine check_float_xdp(error, actual, expected, message, more, thr, rel)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    real(xdp), intent(in) :: actual

    !> Expected floating point value
    real(xdp), intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    !> Allowed threshold for matching floating point values
    real(xdp), intent(in), optional :: thr

    !> Check for relative errors instead
    logical, intent(in), optional :: rel

    logical :: relative
    real(xdp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    if (present(thr)) then
      threshold = thr
    else
      threshold = epsilon(expected)
    end if

    if (present(rel)) then
      relative = rel
    else
      relative = .false.
    end if

    if (relative) then
      diff = abs(actual - expected) / abs(expected)
    else
      diff = abs(actual - expected)
    end if

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        if (relative) then
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(int(diff*100))//"%)", &
            more)
        else
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(diff)//")", &
            more)
        end if
      end if
    end if

  end subroutine check_float_xdp


  subroutine check_float_exceptional_xdp(error, actual, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    real(xdp), intent(in) :: actual

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (is_nan(actual)) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, "Exceptional value 'not a number' found", more)
      end if
    end if

  end subroutine check_float_exceptional_xdp
#endif


#if WITH_QP
  subroutine check_float_qp(error, actual, expected, message, more, thr, rel)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    real(qp), intent(in) :: actual

    !> Expected floating point value
    real(qp), intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    !> Allowed threshold for matching floating point values
    real(qp), intent(in), optional :: thr

    !> Check for relative errors instead
    logical, intent(in), optional :: rel

    logical :: relative
    real(qp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    if (present(thr)) then
      threshold = thr
    else
      threshold = epsilon(expected)
    end if

    if (present(rel)) then
      relative = rel
    else
      relative = .false.
    end if

    if (relative) then
      diff = abs(actual - expected) / abs(expected)
    else
      diff = abs(actual - expected)
    end if

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        if (relative) then
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(int(diff*100))//"%)", &
            more)
        else
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(diff)//")", &
            more)
        end if
      end if
    end if

  end subroutine check_float_qp


  subroutine check_float_exceptional_qp(error, actual, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    real(qp), intent(in) :: actual

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (is_nan(actual)) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, "Exceptional value 'not a number' found", more)
      end if
    end if

  end subroutine check_float_exceptional_qp
#endif


  subroutine check_complex_dp(error, actual, expected, message, more, thr, rel)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    complex(dp), intent(in) :: actual

    !> Expected floating point value
    complex(dp), intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    !> Allowed threshold for matching floating point values
    real(dp), intent(in), optional :: thr

    !> Check for relative errors instead
    logical, intent(in), optional :: rel

    logical :: relative
    real(dp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    if (present(thr)) then
      threshold = thr
    else
      threshold = epsilon(abs(expected))
    end if

    if (present(rel)) then
      relative = rel
    else
      relative = .false.
    end if

    if (relative) then
      diff = abs(actual - expected) / abs(expected)
    else
      diff = abs(actual - expected)
    end if

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        if (relative) then
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(int(diff*100))//"%)", &
            more)
        else
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(diff)//")", &
            more)
        end if
      end if
    end if

  end subroutine check_complex_dp


  subroutine check_complex_exceptional_dp(error, actual, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    complex(dp), intent(in) :: actual

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (is_nan(real(actual)) .or. is_nan(aimag(actual))) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, "Exceptional value 'not a number' found", more)
      end if
    end if

  end subroutine check_complex_exceptional_dp


  subroutine check_complex_sp(error, actual, expected, message, more, thr, rel)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    complex(sp), intent(in) :: actual

    !> Expected floating point value
    complex(sp), intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    !> Allowed threshold for matching floating point values
    real(sp), intent(in), optional :: thr

    !> Check for relative errors instead
    logical, intent(in), optional :: rel

    logical :: relative
    real(sp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    if (present(thr)) then
      threshold = thr
    else
      threshold = epsilon(abs(expected))
    end if

    if (present(rel)) then
      relative = rel
    else
      relative = .false.
    end if

    if (relative) then
      diff = abs(actual - expected) / abs(expected)
    else
      diff = abs(actual - expected)
    end if

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        if (relative) then
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(int(diff*100))//"%)", &
            more)
        else
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(diff)//")", &
            more)
        end if
      end if
    end if

  end subroutine check_complex_sp


  subroutine check_complex_exceptional_sp(error, actual, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    complex(sp), intent(in) :: actual

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (is_nan(real(actual)) .or. is_nan(aimag(actual))) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, "Exceptional value 'not a number' found", more)
      end if
    end if

  end subroutine check_complex_exceptional_sp


#if WITH_XDP
  subroutine check_complex_xdp(error, actual, expected, message, more, thr, rel)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    complex(xdp), intent(in) :: actual

    !> Expected floating point value
    complex(xdp), intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    !> Allowed threshold for matching floating point values
    real(xdp), intent(in), optional :: thr

    !> Check for relative errors instead
    logical, intent(in), optional :: rel

    logical :: relative
    real(xdp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    if (present(thr)) then
      threshold = thr
    else
      threshold = epsilon(abs(expected))
    end if

    if (present(rel)) then
      relative = rel
    else
      relative = .false.
    end if

    if (relative) then
      diff = abs(actual - expected) / abs(expected)
    else
      diff = abs(actual - expected)
    end if

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        if (relative) then
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(int(diff*100))//"%)", &
            more)
        else
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(diff)//")", &
            more)
        end if
      end if
    end if

  end subroutine check_complex_xdp


  subroutine check_complex_exceptional_xdp(error, actual, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    complex(xdp), intent(in) :: actual

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (is_nan(real(actual)) .or. is_nan(aimag(actual))) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, "Exceptional value 'not a number' found", more)
      end if
    end if

  end subroutine check_complex_exceptional_xdp
#endif


#if WITH_QP
  subroutine check_complex_qp(error, actual, expected, message, more, thr, rel)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    complex(qp), intent(in) :: actual

    !> Expected floating point value
    complex(qp), intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    !> Allowed threshold for matching floating point values
    real(qp), intent(in), optional :: thr

    !> Check for relative errors instead
    logical, intent(in), optional :: rel

    logical :: relative
    real(qp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    if (present(thr)) then
      threshold = thr
    else
      threshold = epsilon(abs(expected))
    end if

    if (present(rel)) then
      relative = rel
    else
      relative = .false.
    end if

    if (relative) then
      diff = abs(actual - expected) / abs(expected)
    else
      diff = abs(actual - expected)
    end if

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        if (relative) then
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(int(diff*100))//"%)", &
            more)
        else
          call test_failed(error, &
            "Floating point value mismatch", &
            "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
            "(difference: "//to_string(diff)//")", &
            more)
        end if
      end if
    end if

  end subroutine check_complex_qp


  subroutine check_complex_exceptional_qp(error, actual, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    complex(qp), intent(in) :: actual

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (is_nan(real(actual)) .or. is_nan(aimag(actual))) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, "Exceptional value 'not a number' found", more)
      end if
    end if

  end subroutine check_complex_exceptional_qp
#endif


  subroutine check_float_absrel_dp(error, actual, expected, thr_abs, thr_rel, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    real(dp), intent(in) :: actual

    !> Expected floating point value
    real(dp), intent(in) :: expected

    !> Absolute threshold for matching floating point values
    real(dp), intent(in) :: thr_abs

    !> Relative threshold for matching floating point values
    real(dp), intent(in) :: thr_rel

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    real(dp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    diff = abs(actual - expected)
    threshold = max(thr_abs, abs(thr_rel * expected))

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Floating point value mismatch", &
          "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
          "(difference: "//to_string(diff)//")", &
          more)
      end if
    end if

  end subroutine check_float_absrel_dp


  subroutine check_float_absrel_sp(error, actual, expected, thr_abs, thr_rel, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    real(sp), intent(in) :: actual

    !> Expected floating point value
    real(sp), intent(in) :: expected

    !> Absolute threshold for matching floating point values
    real(sp), intent(in) :: thr_abs

    !> Relative threshold for matching floating point values
    real(sp), intent(in) :: thr_rel

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    real(sp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    diff = abs(actual - expected)
    threshold = max(thr_abs, abs(thr_rel * expected))

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Floating point value mismatch", &
          "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
          "(difference: "//to_string(diff)//")", &
          more)
      end if
    end if

  end subroutine check_float_absrel_sp


#if WITH_XDP
  subroutine check_float_absrel_xdp(error, actual, expected, thr_abs, thr_rel, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    real(xdp), intent(in) :: actual

    !> Expected floating point value
    real(xdp), intent(in) :: expected

    !> Absolute threshold for matching floating point values
    real(xdp), intent(in) :: thr_abs

    !> Relative threshold for matching floating point values
    real(xdp), intent(in) :: thr_rel

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    real(xdp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    diff = abs(actual - expected)
    threshold = max(thr_abs, abs(thr_rel * expected))

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Floating point value mismatch", &
          "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
          "(difference: "//to_string(diff)//")", &
          more)
      end if
    end if

  end subroutine check_float_absrel_xdp
#endif


#if WITH_QP
  subroutine check_float_absrel_qp(error, actual, expected, thr_abs, thr_rel, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    real(qp), intent(in) :: actual

    !> Expected floating point value
    real(qp), intent(in) :: expected

    !> Absolute threshold for matching floating point values
    real(qp), intent(in) :: thr_abs

    !> Relative threshold for matching floating point values
    real(qp), intent(in) :: thr_rel

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    real(qp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    diff = abs(actual - expected)
    threshold = max(thr_abs, abs(thr_rel * expected))

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Floating point value mismatch", &
          "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
          "(difference: "//to_string(diff)//")", &
          more)
      end if
    end if

  end subroutine check_float_absrel_qp
#endif


  subroutine check_complex_absrel_dp(error, actual, expected, thr_abs, thr_rel, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    complex(dp), intent(in) :: actual

    !> Expected floating point value
    complex(dp), intent(in) :: expected

    !> Absolute threshold for matching floating point values
    real(dp), intent(in) :: thr_abs

    !> Relative threshold for matching floating point values
    real(dp), intent(in) :: thr_rel

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    real(dp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    diff = abs(actual - expected)
    threshold = max(thr_abs, abs(thr_rel * expected))

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Floating point value mismatch", &
          "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
          "(difference: "//to_string(diff)//")", &
          more)
      end if
    end if

  end subroutine check_complex_absrel_dp


  subroutine check_complex_absrel_sp(error, actual, expected, thr_abs, thr_rel, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    complex(sp), intent(in) :: actual

    !> Expected floating point value
    complex(sp), intent(in) :: expected

    !> Absolute threshold for matching floating point values
    real(sp), intent(in) :: thr_abs

    !> Relative threshold for matching floating point values
    real(sp), intent(in) :: thr_rel

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    real(sp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    diff = abs(actual - expected)
    threshold = max(thr_abs, abs(thr_rel * expected))

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Floating point value mismatch", &
          "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
          "(difference: "//to_string(diff)//")", &
          more)
      end if
    end if

  end subroutine check_complex_absrel_sp


#if WITH_XDP
  subroutine check_complex_absrel_xdp(error, actual, expected, thr_abs, thr_rel, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    complex(xdp), intent(in) :: actual

    !> Expected floating point value
    complex(xdp), intent(in) :: expected

    !> Absolute threshold for matching floating point values
    real(xdp), intent(in) :: thr_abs

    !> Relative threshold for matching floating point values
    real(xdp), intent(in) :: thr_rel

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    real(xdp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    diff = abs(actual - expected)
    threshold = max(thr_abs, abs(thr_rel * expected))

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Floating point value mismatch", &
          "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
          "(difference: "//to_string(diff)//")", &
          more)
      end if
    end if

  end subroutine check_complex_absrel_xdp
#endif


#if WITH_QP
  subroutine check_complex_absrel_qp(error, actual, expected, thr_abs, thr_rel, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found floating point value
    complex(qp), intent(in) :: actual

    !> Expected floating point value
    complex(qp), intent(in) :: expected

    !> Absolute threshold for matching floating point values
    real(qp), intent(in) :: thr_abs

    !> Relative threshold for matching floating point values
    real(qp), intent(in) :: thr_rel

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    real(qp) :: diff, threshold

    call check(error, actual, message, more)
    if (allocated(error)) return

    diff = abs(actual - expected)
    threshold = max(thr_abs, abs(thr_rel * expected))

    if (diff > threshold) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Floating point value mismatch", &
          "expected "//to_string(expected)//" but got "//to_string(actual)//" "//&
          "(difference: "//to_string(diff)//")", &
          more)
      end if
    end if

  end subroutine check_complex_absrel_qp
#endif


  subroutine check_int_i1(error, actual, expected, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found integer value
    integer(i1), intent(in) :: actual

    !> Expected integer value
    integer(i1), intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (expected /= actual) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Integer value mismatch", &
          "expected "//to_string(expected)//" but got "//to_string(actual), &
          more)
      end if
    end if

  end subroutine check_int_i1


  subroutine check_int_i2(error, actual, expected, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found integer value
    integer(i2), intent(in) :: actual

    !> Expected integer value
    integer(i2), intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (expected /= actual) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Integer value mismatch", &
          "expected "//to_string(expected)//" but got "//to_string(actual), &
          more)
      end if
    end if

  end subroutine check_int_i2


  subroutine check_int_i4(error, actual, expected, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found integer value
    integer(i4), intent(in) :: actual

    !> Expected integer value
    integer(i4), intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (expected /= actual) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Integer value mismatch", &
          "expected "//to_string(expected)//" but got "//to_string(actual), &
          more)
      end if
    end if

  end subroutine check_int_i4


  subroutine check_int_i8(error, actual, expected, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found integer value
    integer(i8), intent(in) :: actual

    !> Expected integer value
    integer(i8), intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (expected /= actual) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Integer value mismatch", &
          "expected "//to_string(expected)//" but got "//to_string(actual), &
          more)
      end if
    end if

  end subroutine check_int_i8


  subroutine check_bool(error, actual, expected, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found boolean value
    logical, intent(in) :: actual

    !> Expected boolean value
    logical, intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (expected .neqv. actual) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Logical value mismatch", &
          "expected "//merge("T", "F", expected)//" but got "//merge("T", "F", actual), &
          more)
      end if
    end if

  end subroutine check_bool


  subroutine check_string(error, actual, expected, message, more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> Found boolean value
    character(len=*), intent(in) :: actual

    !> Expected boolean value
    character(len=*), intent(in) :: expected

    !> A detailed message describing the error
    character(len=*), intent(in), optional :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    if (expected /= actual) then
      if (present(message)) then
        call test_failed(error, message, more)
      else
        call test_failed(error, &
          "Character value mismatch", &
          "expected '"//expected//"' but got '"//actual//"'", &
          more)
      end if
    end if

  end subroutine check_string


  subroutine test_failed(error, message, more, and_more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> A detailed message describing the error
    character(len=*), intent(in) :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    !> Another line of error message
    character(len=*), intent(in), optional :: and_more

    character(len=*), parameter :: skip = newline // repeat(" ", 11)

    allocate(error)
    error%stat = fatal

    error%message = message
    if (present(more)) then
      error%message = error%message // skip // more
    end if
    if (present(and_more)) then
      error%message = error%message // skip // and_more
    end if

  end subroutine test_failed


  !> A test is skipped because certain requirements are not met to run the actual test
  subroutine skip_test(error, message, more, and_more)

    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    !> A detailed message describing the error
    character(len=*), intent(in) :: message

    !> Another line of error message
    character(len=*), intent(in), optional :: more

    !> Another line of error message
    character(len=*), intent(in), optional :: and_more

    call test_failed(error, message, more, and_more)
    error%stat = skipped

  end subroutine skip_test


  !> Obtain the command line argument at a given index
  subroutine get_argument(idx, arg)

    !> Index of command line argument, range [0:command_argument_count()]
    integer, intent(in) :: idx

    !> Command line argument
    character(len=:), allocatable, intent(out) :: arg

    integer :: length, stat

    call get_command_argument(idx, length=length, status=stat)
    if (stat /= success) return

    allocate(character(len=length) :: arg, stat=stat)
    if (stat /= success) return

    if (length > 0) then
      call get_command_argument(idx, arg, status=stat)
      if (stat /= success) deallocate(arg)
    end if

  end subroutine get_argument


  !> Obtain the value of an environment variable
  subroutine get_variable(var, val)

    !> Name of variable
    character(len=*), intent(in) :: var

    !> Value of variable
    character(len=:), allocatable, intent(out) :: val

    integer :: length, stat

    call get_environment_variable(var, length=length, status=stat)
    if (stat /= success) return

    allocate(character(len=length) :: val, stat=stat)
    if (stat /= success) return

    if (length > 0) then
      call get_environment_variable(var, val, status=stat)
      if (stat /= success) deallocate(val)
    end if

  end subroutine get_variable


  pure function integer_i1_to_string(val) result(string)
    integer, parameter :: ik = i1
    !> Integer value to create string from
    integer(ik), intent(in) :: val
    !> String representation of integer
    character(len=:), allocatable :: string

    integer, parameter :: buffer_len = range(val)+2
    character(len=buffer_len) :: buffer
    integer :: pos
    integer(ik) :: n
    character(len=1), parameter :: numbers(-9:0) = &
      ["9", "8", "7", "6", "5", "4", "3", "2", "1", "0"]

    if (val == 0_ik) then
      string = numbers(0)
      return
    end if

    n = sign(val, -1_ik)
    buffer = ""
    pos = buffer_len + 1
    do while (n < 0_ik)
      pos = pos - 1
      buffer(pos:pos) = numbers(mod(n, 10_ik))
      n = n/10_ik
    end do

    if (val < 0_ik) then
      pos = pos - 1
      buffer(pos:pos) = '-'
    end if

    string = buffer(pos:)
  end function integer_i1_to_string


  pure function integer_i2_to_string(val) result(string)
    integer, parameter :: ik = i2
    !> Integer value to create string from
    integer(ik), intent(in) :: val
    !> String representation of integer
    character(len=:), allocatable :: string

    integer, parameter :: buffer_len = range(val)+2
    character(len=buffer_len) :: buffer
    integer :: pos
    integer(ik) :: n
    character(len=1), parameter :: numbers(-9:0) = &
      ["9", "8", "7", "6", "5", "4", "3", "2", "1", "0"]

    if (val == 0_ik) then
      string = numbers(0)
      return
    end if

    n = sign(val, -1_ik)
    buffer = ""
    pos = buffer_len + 1
    do while (n < 0_ik)
      pos = pos - 1
      buffer(pos:pos) = numbers(mod(n, 10_ik))
      n = n/10_ik
    end do

    if (val < 0_ik) then
      pos = pos - 1
      buffer(pos:pos) = '-'
    end if

    string = buffer(pos:)
  end function integer_i2_to_string


  pure function integer_i4_to_string(val) result(string)
    integer, parameter :: ik = i4
    !> Integer value to create string from
    integer(ik), intent(in) :: val
    !> String representation of integer
    character(len=:), allocatable :: string

    integer, parameter :: buffer_len = range(val)+2
    character(len=buffer_len) :: buffer
    integer :: pos
    integer(ik) :: n
    character(len=1), parameter :: numbers(-9:0) = &
      ["9", "8", "7", "6", "5", "4", "3", "2", "1", "0"]

    if (val == 0_ik) then
      string = numbers(0)
      return
    end if

    n = sign(val, -1_ik)
    buffer = ""
    pos = buffer_len + 1
    do while (n < 0_ik)
      pos = pos - 1
      buffer(pos:pos) = numbers(mod(n, 10_ik))
      n = n/10_ik
    end do

    if (val < 0_ik) then
      pos = pos - 1
      buffer(pos:pos) = '-'
    end if

    string = buffer(pos:)
  end function integer_i4_to_string


  pure function integer_i8_to_string(val) result(string)
    integer, parameter :: ik = i8
    !> Integer value to create string from
    integer(ik), intent(in) :: val
    !> String representation of integer
    character(len=:), allocatable :: string

    integer, parameter :: buffer_len = range(val)+2
    character(len=buffer_len) :: buffer
    integer :: pos
    integer(ik) :: n
    character(len=1), parameter :: numbers(-9:0) = &
      ["9", "8", "7", "6", "5", "4", "3", "2", "1", "0"]

    if (val == 0_ik) then
      string = numbers(0)
      return
    end if

    n = sign(val, -1_ik)
    buffer = ""
    pos = buffer_len + 1
    do while (n < 0_ik)
      pos = pos - 1
      buffer(pos:pos) = numbers(mod(n, 10_ik))
      n = n/10_ik
    end do

    if (val < 0_ik) then
      pos = pos - 1
      buffer(pos:pos) = '-'
    end if

    string = buffer(pos:)
  end function integer_i8_to_string


  pure function real_sp_to_string(val) result(string)
    real(sp), intent(in) :: val
    character(len=:), allocatable :: string
    integer, parameter :: buffer_len = 128
    character(len=buffer_len) :: buffer

    write(buffer, '(g0)') val
    string = trim(buffer)

  end function real_sp_to_string


  pure function real_dp_to_string(val) result(string)
    real(dp), intent(in) :: val
    character(len=:), allocatable :: string
    integer, parameter :: buffer_len = 128
    character(len=buffer_len) :: buffer

    write(buffer, '(g0)') val
    string = trim(buffer)

  end function real_dp_to_string


#if WITH_XDP
  pure function real_xdp_to_string(val) result(string)
    real(xdp), intent(in) :: val
    character(len=:), allocatable :: string
    integer, parameter :: buffer_len = 128
    character(len=buffer_len) :: buffer

    write(buffer, '(g0)') val
    string = trim(buffer)

  end function real_xdp_to_string
#endif


#if WITH_QP
  pure function real_qp_to_string(val) result(string)
    real(qp), intent(in) :: val
    character(len=:), allocatable :: string
    integer, parameter :: buffer_len = 128
    character(len=buffer_len) :: buffer

    write(buffer, '(g0)') val
    string = trim(buffer)

  end function real_qp_to_string
#endif


  pure function complex_sp_to_string(val) result(string)
    complex(sp), intent(in) :: val
    character(len=:), allocatable :: string

    string = "("//to_string(real(val))//", "//to_string(aimag(val))//")"

  end function complex_sp_to_string


  pure function complex_dp_to_string(val) result(string)
    complex(dp), intent(in) :: val
    character(len=:), allocatable :: string

    string = "("//to_string(real(val))//", "//to_string(aimag(val))//")"

  end function complex_dp_to_string


#if WITH_XDP
  pure function complex_xdp_to_string(val) result(string)
    complex(xdp), intent(in) :: val
    character(len=:), allocatable :: string

    string = "("//to_string(real(val))//", "//to_string(aimag(val))//")"

  end function complex_xdp_to_string
#endif


#if WITH_QP
  pure function complex_qp_to_string(val) result(string)
    complex(qp), intent(in) :: val
    character(len=:), allocatable :: string

    string = "("//to_string(real(val))//", "//to_string(aimag(val))//")"

  end function complex_qp_to_string
#endif


  !> Clear error type after it has been handled.
  subroutine clear_error(error)

    !> Error handling
    type(error_type), intent(inout) :: error

    if (error%stat /= success) then
      error%stat = success
    end if

    if (allocated(error%message)) then
      deallocate(error%message)
    end if

  end subroutine clear_error


  !> Finalizer of the error type, in case the error is not correctly cleared it will
  !> be escalated at runtime in a fatal way
  subroutine escalate_error(error)

    !> Error handling
    type(error_type), intent(inout) :: error

    if (error%stat /= success) then
      write(error_unit, '(a)') "[Fatal] Uncaught error"
      if (allocated(error%message)) then
        write(error_unit, '(a, 1x, i0, *(1x, a))') &
          "Code:", error%stat, "Message:", error%message
      end if
      error stop
    end if

  end subroutine escalate_error



  !> Determine whether a value is not a number
  elemental function is_nan_sp(val) result(is_nan)
#if WITH_IEEE_IS_NAN
    use, intrinsic :: ieee_arithmetic, only : ieee_is_nan
#endif
    !> Value to check
    real(sp), intent(in) :: val
    !> Value is not a number
    logical :: is_nan

#if WITH_IEEE_IS_NAN
    is_nan = ieee_is_nan(val)
#else
    is_nan = .not.((val <= huge(val) .and. val >= -huge(val)) .or. abs(val) > huge(val))
#endif
  end function is_nan_sp

  !> Determine whether a value is not a number
  elemental function is_nan_dp(val) result(is_nan)
#if WITH_IEEE_IS_NAN
    use, intrinsic :: ieee_arithmetic, only : ieee_is_nan
#endif
    !> Value to check
    real(dp), intent(in) :: val
    !> Value is not a number
    logical :: is_nan

#if WITH_IEEE_IS_NAN
    is_nan = ieee_is_nan(val)
#else
    is_nan = .not.((val <= huge(val) .and. val >= -huge(val)) .or. abs(val) > huge(val))
#endif
  end function is_nan_dp

#if WITH_XDP
  !> Determine whether a value is not a number
  elemental function is_nan_xdp(val) result(is_nan)
#if WITH_IEEE_IS_NAN
    use, intrinsic :: ieee_arithmetic, only : ieee_is_nan
#endif
    !> Value to check
    real(xdp), intent(in) :: val
    !> Value is not a number
    logical :: is_nan

#if WITH_IEEE_IS_NAN
    is_nan = ieee_is_nan(val)
#else
    is_nan = .not.((val <= huge(val) .and. val >= -huge(val)) .or. abs(val) > huge(val))
#endif
  end function is_nan_xdp
#endif

#if WITH_QP
  !> Determine whether a value is not a number
  elemental function is_nan_qp(val) result(is_nan)
#if WITH_IEEE_IS_NAN
    use, intrinsic :: ieee_arithmetic, only : ieee_is_nan
#endif
    !> Value to check
    real(qp), intent(in) :: val
    !> Value is not a number
    logical :: is_nan

#if WITH_IEEE_IS_NAN
    is_nan = ieee_is_nan(val)
#else
    is_nan = .not.((val <= huge(val) .and. val >= -huge(val)) .or. abs(val) > huge(val))
#endif
  end function is_nan_qp
#endif

  !> Initialize color output
  subroutine init_color_output(use_color)
    !> Enable color output
    logical, intent(in) :: use_color

    color = new_color_output(use_color)
  end subroutine init_color_output

  !> Create a new colorizer object
  function new_color_output(use_color) result(new)
    !> Enable color output
    logical, intent(in) :: use_color
    !> New instance of the colorizer
    type(color_output) :: new

    type(color_code), parameter :: &
      reset = color_code(style=0_i1), &
      bold = color_code(style=1_i1), &
      dim = color_code(style=2_i1), &
      italic = color_code(style=3_i1), &
      underline = color_code(style=4_i1), &
      blink = color_code(style=5_i1), &
      reverse = color_code(style=7_i1), &
      hidden = color_code(style=8_i1)

    type(color_code), parameter :: &
      black = color_code(fg=0_i1), &
      red = color_code(fg=1_i1), &
      green = color_code(fg=2_i1), &
      yellow = color_code(fg=3_i1), &
      blue = color_code(fg=4_i1), &
      magenta = color_code(fg=5_i1), &
      cyan = color_code(fg=6_i1), &
      white = color_code(fg=7_i1)

    type(color_code), parameter :: &
      bg_black = color_code(bg=0_i1), &
      bg_red = color_code(bg=1_i1), &
      bg_green = color_code(bg=2_i1), &
      bg_yellow = color_code(bg=3_i1), &
      bg_blue = color_code(bg=4_i1), &
      bg_magenta = color_code(bg=5_i1), &
      bg_cyan = color_code(bg=6_i1), &
      bg_white = color_code(bg=7_i1)

    if (use_color) then
      new%reset = reset
      new%bold = bold
      new%dim = dim
      new%italic = italic
      new%underline = underline
      new%blink = blink
      new%reverse = reverse
      new%hidden = hidden
      new%black = black
      new%red = red
      new%green = green
      new%yellow = yellow
      new%blue = blue
      new%magenta = magenta
      new%cyan = cyan
      new%white = white
      new%bg_black = bg_black
      new%bg_red = bg_red
      new%bg_green = bg_green
      new%bg_yellow = bg_yellow
      new%bg_blue = bg_blue
      new%bg_magenta = bg_magenta
      new%bg_cyan = bg_cyan
      new%bg_white = bg_white
    end if
  end function new_color_output

  !> Add two escape sequences, attributes in the right value override the left value ones.
  pure function add_color(lval, rval) result(code)
    !> First escape code
    type(color_code), intent(in) :: lval
    !> Second escape code
    type(color_code), intent(in) :: rval
    !> Combined escape code
    type(color_code) :: code
  
    code = color_code( &
      style=merge(rval%style, lval%style, rval%style >= 0), &
      fg=merge(rval%fg, lval%fg, rval%fg >= 0), &
      bg=merge(rval%bg, lval%bg, rval%bg >= 0))
  end function add_color
  
  !> Concatenate an escape code with a string and turn it into an actual escape sequence
  pure function concat_color_left(lval, code) result(str)
    !> String to add the escape code to
    character(len=*), intent(in) :: lval
    !> Escape sequence
    type(color_code), intent(in) :: code
    !> Concatenated string
    character(len=:), allocatable :: str
  
    str = lval // escape_color(code)
  end function concat_color_left
  
  !> Concatenate an escape code with a string and turn it into an actual escape sequence
  pure function concat_color_right(code, rval) result(str)
    !> String to add the escape code to
    character(len=*), intent(in) :: rval
    !> Escape sequence
    type(color_code), intent(in) :: code
    !> Concatenated string
    character(len=:), allocatable :: str
  
    str = escape_color(code) // rval
  end function concat_color_right
  
  !> Transform a color code into an actual ANSI escape sequence
  pure function escape_color(code) result(str)
    !> Color code to be used
    type(color_code), intent(in) :: code
    !> ANSI escape sequence representing the color code
    character(len=:), allocatable :: str
    character, parameter :: chars(0:9) = &
      ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]
  
    if (anycolor(code)) then
      str = achar(27) // "[0"  ! Always reset the style
      if (code%style > 0 .and. code%style < 10) str = str // ";" // chars(code%style)
      if (code%fg >= 0 .and. code%fg < 10) str = str // ";3" // chars(code%fg)
      if (code%bg >= 0 .and. code%bg < 10) str = str // ";4" // chars(code%bg)
      str = str // "m"
    else
      str = ""
    end if
  end function escape_color
  
  !> Check whether the code describes any color or is just a stub
  pure function anycolor(code)
    !> Escape sequence
    type(color_code), intent(in) :: code
    !> Any color / style is active
    logical :: anycolor
  
    anycolor = code%fg >= 0 .or. code%bg >= 0 .or. code%style >= 0
  end function anycolor

end module testdrive

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite_lapack/solver.f90
!> Provides a wrapper for the eigenvalue solvers provided by LAPACK

!> LAPACK based eigenvalue solvers
module tblite_lapack_solver
   use mctc_env, only : wp
   use tblite_context_solver, only : context_solver
   use tblite_lapack_sygvd, only : sygvd_solver, new_sygvd
   use tblite_lapack_sygvr, only : sygvr_solver, new_sygvr
   use tblite_scf_solver, only : solver_type
   implicit none
   private

   public :: solver_type, lapack_algorithm


   !> Possible solvers provided by LAPACK
   type :: enum_lapack
      !> Divide-and-conquer solver
      integer :: gvd = 1
      !> Relatively robust solver
      integer :: gvr = 2
   end type enum_lapack

   !> Actual enumerator of possible solvers
   type(enum_lapack), parameter :: lapack_algorithm = enum_lapack()


   !> Generator for LAPACK based electronic solvers
   type, public, extends(context_solver) :: lapack_solver
      !> Selected electronic solver algorithm
      integer :: algorithm = lapack_algorithm%gvd
   contains
      !> Create new instance of electronic solver
      procedure :: new
      !> Delete an electronic solver instance
      procedure :: delete
   end type lapack_solver


contains


!> Create new electronic solver
subroutine new(self, solver, overlap, nel, kt)
   !> Instance of the solver factory
   class(lapack_solver), intent(inout) :: self
   !> New electronic solver
   class(solver_type), allocatable, intent(out) :: solver
   !> Overlap matrix
   real(wp), intent(in) :: overlap(:, :)
   !> Number of electrons per spin channel
   real(wp), intent(in) :: nel(:)
   !> Electronic temperature
   real(wp), intent(in) :: kt

   select case(self%algorithm)
   case(lapack_algorithm%gvd)
      block
         type(sygvd_solver), allocatable :: tmp
         allocate(tmp)
         call new_sygvd(tmp, overlap, nel, kt)
         call move_alloc(tmp, solver)
      end block
   case(lapack_algorithm%gvr)
      block
         type(sygvr_solver), allocatable :: tmp
         allocate(tmp)
         call new_sygvr(tmp, overlap, nel, kt)
         call move_alloc(tmp, solver)
      end block
   end select
end subroutine new


!> Delete electronic solver instance
subroutine delete(self, solver)
   !> Instance of the solver factory
   class(lapack_solver), intent(inout) :: self
   !> Electronic solver instance
   class(solver_type), allocatable, intent(inout) :: solver

   if (allocated(solver)) then
      call solver%delete()
      deallocate(solver)
   end if
end subroutine delete


end module tblite_lapack_solver

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

#include "mctc/defs.h"

module mctc_version
   implicit none
   private

   public :: mctc_version_string, mctc_version_compact
   public :: get_mctc_version, get_mctc_feature


   !> String representation of the mctc-lib version
   character(len=*), parameter :: mctc_version_string = "0.5.2"

   !> Numeric representation of the mctc-lib version
   integer, parameter :: mctc_version_compact(3) = [0, 5, 2]


   !> With support for JSON
   logical, parameter :: mctc_with_json = 0 /= WITH_JSON


contains


!> Getter function to retrieve mctc-lib version
pure subroutine get_mctc_version(major, minor, patch, string)

   !> Major version number of the mctc-lib version
   integer, intent(out), optional :: major

   !> Minor version number of the mctc-lib version
   integer, intent(out), optional :: minor

   !> Patch version number of the mctc-lib version
   integer, intent(out), optional :: patch

   !> String representation of the mctc-lib version
   character(len=:), allocatable, intent(out), optional :: string

   if (present(major)) then
      major = mctc_version_compact(1)
   end if
   if (present(minor)) then
      minor = mctc_version_compact(2)
   end if
   if (present(patch)) then
      patch = mctc_version_compact(3)
   end if
   if (present(string)) then
      string = mctc_version_string
   end if

end subroutine get_mctc_version


pure function get_mctc_feature(feature) result(has_feature)

   !> Feature name
   character(len=*), intent(in) :: feature

   !> Whether the feature is enabled
   logical :: has_feature

   select case(feature)
   case("json")
      has_feature = mctc_with_json
   case default
      has_feature = .false.
   end select

end function get_mctc_feature


end module mctc_version

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Defines the abstract base class which is implemented by the TOML lexer.
module tomlf_de_abc
   use tomlf_constants, only : tfc, tfi, tfr
   use tomlf_datetime, only : toml_datetime
   use tomlf_de_token, only : toml_token
   implicit none
   private

   public :: abstract_lexer


   !> Abstract base class for TOML lexers.
   type, abstract :: abstract_lexer
   contains
      !> Obtain the next token
      procedure(next), deferred :: next
      !> Extract a token
      generic :: extract => &
         & extract_string, extract_integer, extract_float, extract_bool, extract_datetime
      !> Extract a string from a token
      procedure(extract_string), deferred :: extract_string
      !> Extract an integer from a token
      procedure(extract_integer), deferred :: extract_integer
      !> Extract a float from a token
      procedure(extract_float), deferred :: extract_float
      !> Extract a boolean from a token
      procedure(extract_bool), deferred :: extract_bool
      !> Extract a timestamp from a token
      procedure(extract_datetime), deferred :: extract_datetime
      !> Get information about the source
      procedure(get_info), deferred :: get_info
   end type abstract_lexer


   abstract interface
      !> Advance the lexer to the next token.
      subroutine next(lexer, token)
         import :: abstract_lexer, toml_token
         !> Instance of the lexer
         class(abstract_lexer), intent(inout) :: lexer
         !> Current lexeme
         type(toml_token), intent(inout) :: token
      end subroutine next

      !> Extract string value of token, works for keypath, string, multiline string, literal,
      !> and mulitline literal tokens.
      subroutine extract_string(lexer, token, string)
         import :: abstract_lexer, toml_token, tfc
         !> Instance of the lexer
         class(abstract_lexer), intent(in) :: lexer
         !> Token to extract string value from
         type(toml_token), intent(in) :: token
         !> String value of token
         character(:, tfc), allocatable, intent(out) :: string
      end subroutine extract_string

      !> Extract integer value of token
      subroutine extract_integer(lexer, token, val)
         import :: abstract_lexer, toml_token, tfi
         !> Instance of the lexer
         class(abstract_lexer), intent(in) :: lexer
         !> Token to extract integer value from
         type(toml_token), intent(in) :: token
         !> Integer value of token
         integer(tfi), intent(out) :: val
      end subroutine extract_integer

      !> Extract floating point value of token
      subroutine extract_float(lexer, token, val)
         import :: abstract_lexer, toml_token, tfr
         !> Instance of the lexer
         class(abstract_lexer), intent(in) :: lexer
         !> Token to extract floating point value from
         type(toml_token), intent(in) :: token
         !> Floating point value of token
         real(tfr), intent(out) :: val
      end subroutine extract_float

      !> Extract boolean value of token
      subroutine extract_bool(lexer, token, val)
         import :: abstract_lexer, toml_token
         !> Instance of the lexer
         class(abstract_lexer), intent(in) :: lexer
         !> Token to extract boolean value from
         type(toml_token), intent(in) :: token
         !> Boolean value of token
         logical, intent(out) :: val
      end subroutine extract_bool

      !> Extract datetime value of token
      subroutine extract_datetime(lexer, token, val)
         import :: abstract_lexer, toml_token, toml_datetime
         !> Instance of the lexer
         class(abstract_lexer), intent(in) :: lexer
         !> Token to extract datetime value from
         type(toml_token), intent(in) :: token
         !> Datetime value of token
         type(toml_datetime), intent(out) :: val
      end subroutine extract_datetime

      !> Extract information about the source
      subroutine get_info(lexer, meta, output)
         import :: abstract_lexer, tfc
         !> Instance of the lexer
         class(abstract_lexer), intent(in) :: lexer
         !> Query about the source
         character(*, tfc), intent(in) :: meta
         !> Metadata about the source
         character(:, tfc), allocatable, intent(out) :: output
      end subroutine get_info
   end interface

end module tomlf_de_abc

program main
  use, intrinsic :: iso_fortran_env, only : stderr => error_unit, stdout => output_unit
  use fpm_lint_config, only : lint_config, load_lint_config
  use fpm_lint_utils, only : get_argument
  use tomlf, only : toml_table, toml_load, toml_error, toml_context, toml_parser_config, &
    & toml_terminal
  implicit none
  logical, parameter :: color = .true.
  character(:), allocatable :: manifest
  type(toml_terminal) :: terminal
  type(toml_table), allocatable :: table
  type(toml_error), allocatable :: error
  type(toml_context) :: context
  type(lint_config) :: config

  terminal = toml_terminal(color)
  call get_argument(1, manifest)
  if (.not.allocated(manifest)) manifest = "fpm.toml"

  call toml_load(table, manifest, error=error, context=context, &
    & config=toml_parser_config(color=terminal))
  call handle_error(error)

  call load_lint_config(config, table, context, terminal, error)
  call handle_error(error)

contains

  subroutine handle_error(error)
    type(toml_error), intent(in), optional :: error
    if (present(error)) then
      write(stderr, '(a)') error%message
      stop 1
    end if
  end subroutine handle_error

end program main

! This file is part of multicharge.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> @file multicharge/model/eeqbc.f90
!> Provides implementation of the bond capacitor electronegativity equilibration model (EEQ_BC)

!> Bond capacitor electronegativity equilibration charge model published in
!>
!> Thomas Froitzheim, Marcel Müller, Andreas Hansen, and Stefan Grimme,
!> *J. Chem. Phys.*, **2025**, 162, 214109.
!> DOI: [10.1063/5.0268978](https://dx.doi.org/10.1063/5.0268978)
module multicharge_model_eeqbc
   use mctc_env, only: error_type, wp
   use mctc_io, only: structure_type
   use mctc_io_constants, only: pi
   use mctc_ncoord, only: new_ncoord, cn_count
   use multicharge_wignerseitz, only: new_wignerseitz_cell, wignerseitz_cell_type
   use multicharge_model_type, only: mchrg_model_type, get_dir_trans
   use multicharge_blas, only: gemv, gemm
   use multicharge_model_cache, only: cache_container, model_cache
   implicit none
   private

   public :: eeqbc_model, new_eeqbc_model

   !> Cache for the EEQ-BC charge model
   type, extends(model_cache) :: eeqbc_cache
      !> Local charges
      real(wp), allocatable :: qloc(:)
      !> Local charge dr derivative
      real(wp), allocatable :: dqlocdr(:, :, :)
      !> Local charge dL derivative
      real(wp), allocatable :: dqlocdL(:, :, :)
      !> Full Maxwell capacitance matrix
      real(wp), allocatable :: cmat(:, :)
      !> Derivative of Maxwell capacitance matrix w.r.t positions
      real(wp), allocatable :: dcdr(:, :, :)
      !> Derivative of Maxwell capacitance matrix w.r.t lattice vectors
      real(wp), allocatable :: dcdL(:, :, :)
      !> Store tmp array from xvec calculation for reuse
      real(wp), allocatable :: xtmp(:)
   end type eeqbc_cache

   type, extends(mchrg_model_type) :: eeqbc_model
      !> Bond capacitance
      real(wp), allocatable :: cap(:)
      !> Average coordination number
      real(wp), allocatable :: avg_cn(:)
      !> Exponent of error function in bond capacitance
      real(wp) :: kbc
      !> Exponent of the distance/CN normalization
      real(wp) :: norm_exp
      !> vdW radii
      real(wp), allocatable :: rvdw(:, :)
   contains
      !> Update and allocate cache
      procedure :: update
      !> Calculate Coulomb matrix
      procedure :: get_coulomb_matrix
      !> Calculate derivatives of Coulomb matrix
      procedure :: get_coulomb_derivs
      !> Calculate right-hand side (electronegativity vector)
      procedure :: get_xvec
      !> Calculate derivatives of EN vector
      procedure :: get_xvec_derivs
      !> Calculate constraint matrix (molecular)
      procedure :: get_cmat_0d
      !> Calculate full constraint matrix (periodic)
      procedure :: get_cmat_3d
      !> Calculate constraint matrix derivatives (molecular)
      procedure :: get_dcmat_0d
      !> Calculate constraint matrix derivatives (periodic)
      procedure :: get_dcmat_3d
   end type eeqbc_model

   real(wp), parameter :: sqrtpi = sqrt(pi)
   real(wp), parameter :: sqrt2pi = sqrt(2.0_wp / pi)
   real(wp), parameter :: eps = sqrt(epsilon(0.0_wp))

   !> Default exponent of distance/CN normalization
   real(wp), parameter :: default_norm_exp = 1.0_wp

   !> Default exponent of error function in bond capacitance
   real(wp), parameter :: default_kbc = 0.65_wp

contains

subroutine new_eeqbc_model(self, mol, error, chi, rad, &
   & eta, kcnchi, kqchi, kqeta, kcnrad, cap, avg_cn, rvdw, &
   & kbc, cutoff, cn_exp, rcov, en, cn_max, norm_exp)
   !> Bond capacitor electronegativity equilibration model
   type(eeqbc_model), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Electronegativity
   real(wp), intent(in) :: chi(:)
   !> Exponent gaussian charge
   real(wp), intent(in) :: rad(:)
   !> Chemical hardness
   real(wp), intent(in) :: eta(:)
   !> CN scaling factor for electronegativity
   real(wp), intent(in) :: kcnchi(:)
   !> Local charge scaling factor for electronegativity
   real(wp), intent(in) :: kqchi(:)
   !> Local charge scaling factor for chemical hardness
   real(wp), intent(in) :: kqeta(:)
   !> CN scaling factor for charge width
   real(wp), intent(in) :: kcnrad
   !> Bond capacitance
   real(wp), intent(in) :: cap(:)
   !> Average coordination number
   real(wp), intent(in) :: avg_cn(:)
   !> Van-der-Waals radii
   real(wp), intent(in) :: rvdw(:, :)
   !> Exponent of error function in bond capacitance
   real(wp), intent(in), optional :: kbc
   !> Exponent of the distance normalization
   real(wp), intent(in), optional :: norm_exp
   !> Cutoff radius for coordination number
   real(wp), intent(in), optional :: cutoff
   !> Steepness of the CN counting function
   real(wp), intent(in), optional :: cn_exp
   !> Covalent radii for CN
   real(wp), intent(in), optional :: rcov(:)
   !> Maximum CN cutoff for CN
   real(wp), intent(in), optional :: cn_max
   !> Pauling electronegativities normalized to fluorine
   real(wp), intent(in), optional :: en(:)

   self%chi = chi
   self%rad = rad
   self%eta = eta
   self%kcnchi = kcnchi
   self%kqchi = kqchi
   self%kqeta = kqeta
   self%kcnrad = kcnrad
   self%cap = cap
   self%avg_cn = avg_cn
   self%rvdw = rvdw

   if (present(kbc)) then
      self%kbc = kbc
   else
      self%kbc = default_kbc
   end if

   if (present(norm_exp)) then
      self%norm_exp = norm_exp
   else
      self%norm_exp = default_norm_exp
   end if

   ! Coordination number
   call new_ncoord(self%ncoord, mol, cn_count%erf, error, &
      & cutoff=cutoff, kcn=cn_exp, rcov=rcov, cut=cn_max, &
      & norm_exp=self%norm_exp)
   ! Electronegativity weighted coordination number for local charge
   call new_ncoord(self%ncoord_en, mol, cn_count%erf_en, error, &
      & cutoff=cutoff, kcn=cn_exp, rcov=rcov, en=en, cut=cn_max, &
      & norm_exp=self%norm_exp)

end subroutine new_eeqbc_model

subroutine update(self, mol, cache, cn, qloc, dcndr, dcndL, dqlocdr, dqlocdL)
   class(eeqbc_model), intent(in) :: self
   type(structure_type), intent(in) :: mol
   type(cache_container), intent(inout) :: cache
   real(wp), intent(in) :: cn(:)
   real(wp), intent(in), optional :: qloc(:)
   real(wp), intent(in), optional :: dcndr(:, :, :)
   real(wp), intent(in), optional :: dcndL(:, :, :)
   real(wp), intent(in), optional :: dqlocdr(:, :, :)
   real(wp), intent(in), optional :: dqlocdL(:, :, :)

   logical :: grad

   type(eeqbc_cache), pointer :: ptr

   call taint(cache, ptr)

   grad = present(dcndr) .and. present(dcndL) .and. present(dqlocdr) .and. present(dqlocdL)

   ! Refer CN and local charge arrays in cache
   ptr%cn = cn
   if (present(qloc)) then
      ptr%qloc = qloc
   else
      error stop "qloc required for eeqbc"
   end if

   if (grad) then
      ptr%dcndr = dcndr
      ptr%dcndL = dcndL
      ptr%dqlocdr = dqlocdr
      ptr%dqlocdL = dqlocdL
   end if

   ! Allocate (for get_xvec and xvec_derivs)
   if (.not. allocated(ptr%xtmp)) then
      allocate(ptr%xtmp(mol%nat + 1))
   end if

   ! Allocate cmat
   if (.not. allocated(ptr%cmat)) then
      allocate(ptr%cmat(mol%nat + 1, mol%nat + 1))
   end if

   if (any(mol%periodic)) then
      ! Create WSC
      call new_wignerseitz_cell(ptr%wsc, mol)

      ! Get full cmat sum over all WSC images (for get_xvec and xvec_derivs)
      call get_cmat_3d(self, mol, ptr%wsc, ptr%cmat)
      if (grad) then
         if (.not. allocated(ptr%dcdr)) then
            allocate(ptr%dcdr(3, mol%nat, mol%nat + 1))
         end if
         if (.not. allocated(ptr%dcdL)) then
            allocate(ptr%dcdL(3, 3, mol%nat + 1))
         end if
         call get_dcmat_3d(self, mol, ptr%wsc, ptr%dcdr, ptr%dcdL)
      end if
   else
      call get_cmat_0d(self, mol, ptr%cmat)

      ! cmat gradients
      if (grad) then
         if (.not. allocated(ptr%dcdr)) then
            allocate(ptr%dcdr(3, mol%nat, mol%nat + 1))
         end if
         if (.not. allocated(ptr%dcdL)) then
            allocate(ptr%dcdL(3, 3, mol%nat + 1))
         end if
         call get_dcmat_0d(self, mol, ptr%dcdr, ptr%dcdL)
      end if
   end if

end subroutine update

subroutine get_xvec(self, mol, cache, xvec)
   class(eeqbc_model), intent(in) :: self
   type(structure_type), intent(in) :: mol
   type(cache_container), intent(inout) :: cache
   real(wp), intent(out) :: xvec(:)

   type(eeqbc_cache), pointer :: ptr

   integer :: iat, izp, img
   real(wp) :: ctmp, vec(3), rvdw, capi, wsw
   real(wp), allocatable :: dtrans(:, :)

   ! Thread-private array for reduction
   real(wp), allocatable :: xvec_local(:)

   call view(cache, ptr)

   xvec(:) = 0.0_wp
   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(mol, self, ptr, xvec) &
   !$omp private(iat, izp)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ptr%xtmp(iat) = -self%chi(izp) + self%kcnchi(izp) * ptr%cn(iat) &
         & + self%kqchi(izp) * ptr%qloc(iat)
   end do
   ptr%xtmp(mol%nat + 1) = mol%charge

   call gemv(ptr%cmat, ptr%xtmp, xvec)

   if (any(mol%periodic)) then
      call get_dir_trans(mol%lattice, dtrans)
      !$omp parallel default(none) &
      !$omp shared(mol, self, ptr, xvec, dtrans) private(iat, izp, img, wsw) &
      !$omp private(capi, vec, rvdw, ctmp, xvec_local)
      allocate(xvec_local, mold=xvec)
      xvec_local(:) = 0.0_wp
      !$omp do schedule(runtime)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         capi = self%cap(izp)
         ! eliminate self-interaction (quasi off-diagonal)
         rvdw = self%rvdw(iat, iat)
         wsw = 1.0_wp / real(ptr%wsc%nimg(iat, iat), wp)
         do img = 1, ptr%wsc%nimg(iat, iat)
            vec = ptr%wsc%trans(:, ptr%wsc%tridx(img, iat, iat))

            call get_cpair_dir(self%kbc, vec, dtrans, rvdw, capi, capi, ctmp)
            xvec_local(iat) = xvec_local(iat) - wsw * ctmp * ptr%xtmp(iat)
         end do
      end do
      !$omp end do
      !$omp critical (get_xvec_)
      xvec(:) = xvec + xvec_local
      !$omp end critical (get_xvec_)
      deallocate(xvec_local)
      !$omp end parallel
   end if
end subroutine get_xvec

subroutine get_xvec_derivs(self, mol, cache, dxdr, dxdL)
   class(eeqbc_model), intent(in) :: self
   type(structure_type), intent(in) :: mol
   type(cache_container), intent(inout) :: cache
   real(wp), intent(out), contiguous :: dxdr(:, :, :)
   real(wp), intent(out), contiguous :: dxdL(:, :, :)

   type(eeqbc_cache), pointer :: ptr

   integer :: iat, izp, jat, jzp, img
   real(wp) :: capi, capj, wsw, vec(3), ctmp, rvdw, dG(3), dS(3, 3)
   real(wp), allocatable :: dtmpdr(:, :, :), dtmpdL(:, :, :)
   real(wp), allocatable :: dtrans(:, :)

   ! Thread-private arrays for reduction
   real(wp), allocatable :: dxdr_local(:, :, :), dxdL_local(:, :, :), dtmpdr_local(:, :, :), dtmpdL_local(:, :, :)

   call view(cache, ptr)
   allocate(dtmpdr(3, mol%nat, mol%nat + 1), dtmpdL(3, 3, mol%nat + 1))

   dxdr(:, :, :) = 0.0_wp
   dxdL(:, :, :) = 0.0_wp
   dtmpdr(:, :, :) = 0.0_wp
   dtmpdL(:, :, :) = 0.0_wp

   !$omp parallel default(none) &
   !$omp shared(mol, self, ptr, dtmpdr, dtmpdL) &
   !$omp private(iat, izp, dtmpdr_local, dtmpdL_local)
   allocate(dtmpdr_local, source=dtmpdr)
   allocate(dtmpdL_local, source=dtmpdL)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ! CN and effective charge derivative
      dtmpdr_local(:, :, iat) = self%kcnchi(izp) * ptr%dcndr(:, :, iat) + dtmpdr_local(:, :, iat)
      dtmpdL_local(:, :, iat) = self%kcnchi(izp) * ptr%dcndL(:, :, iat) + dtmpdL_local(:, :, iat)
      dtmpdr_local(:, :, iat) = self%kqchi(izp) * ptr%dqlocdr(:, :, iat) + dtmpdr_local(:, :, iat)
      dtmpdL_local(:, :, iat) = self%kqchi(izp) * ptr%dqlocdL(:, :, iat) + dtmpdL_local(:, :, iat)
   end do
   !$omp end do
   !$omp critical (get_xvec_derivs_)
   dtmpdr(:, :, :) = dtmpdr + dtmpdr_local
   dtmpdL(:, :, :) = dtmpdL + dtmpdL_local
   !$omp end critical (get_xvec_derivs_)
   deallocate(dtmpdL_local, dtmpdr_local)
   !$omp end parallel

   call gemm(dtmpdr, ptr%cmat, dxdr)
   call gemm(dtmpdL, ptr%cmat, dxdL)

   if (any(mol%periodic)) then
      call get_dir_trans(mol%lattice, dtrans)
      !$omp parallel default(none) &
      !$omp shared(mol, self, ptr, dxdr, dxdL, dtrans) &
      !$omp private(iat, izp, jat, jzp, img, wsw) &
      !$omp private(capi, capj, vec, rvdw, ctmp, dG, dS) &
      !$omp private(dxdr_local, dxdL_local)
      allocate(dxdr_local, mold=dxdr)
      allocate(dxdL_local, mold=dxdL)
      dxdr_local(:, :, :) = 0.0_wp
      dxdL_local(:, :, :) = 0.0_wp
      !$omp do schedule(runtime)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         capi = self%cap(izp)
         do jat = 1, mol%nat
            rvdw = self%rvdw(iat, jat)
            jzp = mol%id(jat)
            capj = self%cap(jzp)

            ! Diagonal elements
            dxdr_local(:, iat, iat) = dxdr_local(:, iat, iat) + ptr%xtmp(jat) * ptr%dcdr(:, iat, jat)

            ! Derivative of capacitance matrix
            dxdr_local(:, iat, jat) = dxdr_local(:, iat, jat)  &
                  & + (ptr%xtmp(iat) - ptr%xtmp(jat)) * ptr%dcdr(:, iat, jat)

            wsw = 1.0_wp / real(ptr%wsc%nimg(iat, jat), wp)
            do img = 1, ptr%wsc%nimg(iat, jat)
               vec = mol%xyz(:, jat) - mol%xyz(:, iat) + ptr%wsc%trans(:, ptr%wsc%tridx(img, jat, iat))
               call get_dcpair_dir(self%kbc, vec, dtrans, rvdw, capi, capj, dG, dS)
               dxdL_local(:, :, iat) = dxdL_local(:, :, iat) - wsw * dS * ptr%xtmp(jat)
            end do
         end do
         dxdL_local(:, :, iat) = dxdL_local(:, :, iat) + ptr%xtmp(iat) * ptr%dcdL(:, :, iat)

         ! Capacitance terms for i = j, T != 0
         rvdw = self%rvdw(iat, iat)
         wsw = 1.0_wp / real(ptr%wsc%nimg(iat, iat), wp)
         do img = 1, ptr%wsc%nimg(iat, iat)
            vec = ptr%wsc%trans(:, ptr%wsc%tridx(img, iat, iat))

            call get_cpair_dir(self%kbc, vec, dtrans, rvdw, capi, capi, ctmp)
            ctmp = ctmp * wsw
            ! EN derivative
            dxdr_local(:, :, iat) = dxdr_local(:, :, iat) - ctmp * self%kcnchi(izp) * ptr%dcndr(:, :, iat)
            dxdL_local(:, :, iat) = dxdL_local(:, :, iat) - ctmp * self%kcnchi(izp) * ptr%dcndL(:, :, iat)
            dxdr_local(:, :, iat) = dxdr_local(:, :, iat) - ctmp * self%kqchi(izp) * ptr%dqlocdr(:, :, iat)
            dxdL_local(:, :, iat) = dxdL_local(:, :, iat) - ctmp * self%kqchi(izp) * ptr%dqlocdL(:, :, iat)
         end do
      end do
      !$omp end do
      !$omp critical (get_xvec_derivs_update)
      dxdr(:, :, :) = dxdr + dxdr_local
      dxdL(:, :, :) = dxdL + dxdL_local
      !$omp end critical (get_xvec_derivs_update)
      deallocate(dxdL_local, dxdr_local)
      !$omp end parallel
   else
      !$omp parallel default(none) &
      !$omp shared(mol, self, ptr, dxdr, dxdL) &
      !$omp private(iat, izp, jat, jzp, vec, dxdr_local, dxdL_local)
      allocate(dxdr_local, mold=dxdr)
      allocate(dxdL_local, mold=dxdL)
      dxdr_local(:, :, :) = 0.0_wp
      dxdL_local(:, :, :) = 0.0_wp
      !$omp do schedule(runtime)
      do iat = 1, mol%nat
         do jat = 1, iat - 1
            ! Diagonal elements
            dxdr_local(:, iat, iat) = dxdr_local(:, iat, iat) + ptr%xtmp(jat) * ptr%dcdr(:, iat, jat)
            dxdr_local(:, jat, jat) = dxdr_local(:, jat, jat) + ptr%xtmp(iat) * ptr%dcdr(:, jat, iat)

            ! Derivative of capacitance matrix
            dxdr_local(:, iat, jat) = (ptr%xtmp(iat) - ptr%xtmp(jat)) * ptr%dcdr(:, iat, jat) + dxdr_local(:, iat, jat)
            dxdr_local(:, jat, iat) = (ptr%xtmp(jat) - ptr%xtmp(iat)) * ptr%dcdr(:, jat, iat) + dxdr_local(:, jat, iat)

            vec = mol%xyz(:, iat) - mol%xyz(:, jat)
            dxdL_local(:, :, iat) = dxdL_local(:, :, iat) + ptr%xtmp(jat) * spread(ptr%dcdr(:, iat, jat), 1, 3) * spread(vec, 2, 3)
         dxdL_local(:, :, jat) = dxdL_local(:, :, jat) + ptr%xtmp(iat) * spread(ptr%dcdr(:, jat, iat), 1, 3) * spread(-vec, 2, 3)
         end do
         dxdr_local(:, iat, iat) = dxdr_local(:, iat, iat) + ptr%xtmp(iat) * ptr%dcdr(:, iat, iat)
         dxdL_local(:, :, iat) = dxdL_local(:, :, iat) + ptr%xtmp(iat) * ptr%dcdL(:, :, iat)
      end do
      !$omp end do
      !$omp critical (get_xvec_derivs_)
      dxdr(:, :, :) = dxdr + dxdr_local
      dxdL(:, :, :) = dxdL + dxdL_local
      !$omp end critical (get_xvec_derivs_)
      deallocate(dxdL_local, dxdr_local)
      !$omp end parallel
   end if

end subroutine get_xvec_derivs

subroutine get_coulomb_matrix(self, mol, cache, amat)
   class(eeqbc_model), intent(in) :: self
   type(structure_type), intent(in) :: mol
   type(cache_container), intent(inout) :: cache
   real(wp), intent(out) :: amat(:, :)

   type(eeqbc_cache), pointer :: ptr
   call view(cache, ptr)

   if (any(mol%periodic)) then
      call get_amat_3d(self, mol, ptr%wsc, ptr%cn, ptr%qloc, ptr%cmat, amat)
   else
      call get_amat_0d(self, mol, ptr%cn, ptr%qloc, ptr%cmat, amat)
   end if
end subroutine get_coulomb_matrix

subroutine get_amat_0d(self, mol, cn, qloc, cmat, amat)
   class(eeqbc_model), intent(in) :: self
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: cn(:)
   real(wp), intent(in) :: qloc(:)
   real(wp), intent(in) :: cmat(:, :)
   real(wp), intent(out) :: amat(:, :)

   integer :: iat, jat, izp, jzp
   real(wp) :: vec(3), r2, gam2, tmp, norm_cn, radi, radj

   ! Thread-private array for reduction
   real(wp), allocatable :: amat_local(:, :)

   amat(:, :) = 0.0_wp

   !$omp parallel default(none) &
   !$omp shared(amat, mol, self, cn, qloc, cmat) &
   !$omp private(iat, izp, jat, jzp, gam2, vec, r2, tmp) &
   !$omp private(norm_cn, radi, radj, amat_local)
   allocate(amat_local, source=amat)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ! Effective charge width of i
      norm_cn = 1.0_wp / self%avg_cn(izp)**self%norm_exp
      radi = self%rad(izp) * (1.0_wp - self%kcnrad * cn(iat) * norm_cn)
      do jat = 1, iat - 1
         jzp = mol%id(jat)
         vec = mol%xyz(:, jat) - mol%xyz(:, iat)
         r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         ! Effective charge width of j
         norm_cn = cn(jat) / self%avg_cn(jzp)**self%norm_exp
         radj = self%rad(jzp) * (1.0_wp - self%kcnrad * norm_cn)
         ! Coulomb interaction of Gaussian charges
         gam2 = 1.0_wp / (radi**2 + radj**2)
         tmp = erf(sqrt(r2 * gam2)) / sqrt(r2) * cmat(jat, iat)
         amat_local(jat, iat) = tmp
         amat_local(iat, jat) = tmp
      end do
      ! Effective hardness
      tmp = self%eta(izp) + self%kqeta(izp) * qloc(iat) + sqrt2pi / radi
      amat_local(iat, iat) = amat_local(iat, iat) + tmp * cmat(iat, iat) + 1.0_wp
   end do
   !$omp end do
   !$omp critical (get_amat_0d_)
   amat(:, :) = amat + amat_local
   !$omp end critical (get_amat_0d_)
   deallocate(amat_local)
   !$omp end parallel

   amat(mol%nat + 1, 1:mol%nat + 1) = 1.0_wp
   amat(1:mol%nat + 1, mol%nat + 1) = 1.0_wp
   amat(mol%nat + 1, mol%nat + 1) = 0.0_wp

end subroutine get_amat_0d

subroutine get_amat_3d(self, mol, wsc, cn, qloc, cmat, amat)
   class(eeqbc_model), intent(in) :: self
   type(structure_type), intent(in) :: mol
   type(wignerseitz_cell_type), intent(in) :: wsc
   real(wp), intent(in) :: cn(:), qloc(:), cmat(:, :)
   real(wp), intent(out) :: amat(:, :)

   integer :: iat, jat, izp, jzp, img
   real(wp) :: vec(3), r1, gam, dtmp, ctmp, capi, capj, radi, radj, norm_cn, rvdw, wsw
   real(wp), allocatable :: dtrans(:, :)

   ! Thread-private array for reduction
   real(wp), allocatable :: amat_local(:, :)

   call get_dir_trans(mol%lattice, dtrans)

   amat(:, :) = 0.0_wp

   !$omp parallel default(none) &
   !$omp shared(amat, cmat, mol, cn, qloc, self, wsc, dtrans)  &
   !$omp private(iat, izp, jat, jzp, gam, vec, dtmp, ctmp, norm_cn) &
   !$omp private(radi, radj, capi, capj, rvdw, r1, wsw, amat_local)
   allocate(amat_local, source=amat)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ! Effective charge width of i
      norm_cn = 1.0_wp / self%avg_cn(izp)**self%norm_exp
      radi = self%rad(izp) * (1.0_wp - self%kcnrad * cn(iat) * norm_cn)
      capi = self%cap(izp)
      do jat = 1, iat - 1
         jzp = mol%id(jat)
         ! vdw distance in Angstrom (approximate factor 2)
         rvdw = self%rvdw(iat, jat)
         ! Effective charge width of j
         norm_cn = cn(jat) / self%avg_cn(jzp)**self%norm_exp
         radj = self%rad(jzp) * (1.0_wp - self%kcnrad * norm_cn)
         capj = self%cap(jzp)
         ! Coulomb interaction of Gaussian charges
         gam = 1.0_wp / sqrt(radi**2 + radj**2)
         wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, jat) - mol%xyz(:, iat) + wsc%trans(:, wsc%tridx(img, jat, iat))
            call get_amat_dir_3d(vec, gam, dtrans, self%kbc, rvdw, capi, capj, dtmp)
            amat_local(jat, iat) = amat_local(jat, iat) + dtmp * wsw
            amat_local(iat, jat) = amat_local(iat, jat) + dtmp * wsw
         end do
      end do

      ! diagonal Coulomb interaction terms
      gam = 1.0_wp / sqrt(2.0_wp * radi**2)
      rvdw = self%rvdw(iat, iat)
      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec = wsc%trans(:, wsc%tridx(img, iat, iat))
         call get_amat_dir_3d(vec, gam, dtrans, self%kbc, rvdw, capi, capi, dtmp)
         amat_local(iat, iat) = amat_local(iat, iat) + dtmp * wsw
      end do

      ! Effective hardness
      dtmp = self%eta(izp) + self%kqeta(izp) * qloc(iat) + sqrt2pi / radi
      amat_local(iat, iat) = amat_local(iat, iat) + cmat(iat, iat) * dtmp + 1.0_wp
   end do
   !$omp end do
   !$omp critical (get_amat_3d_)
   amat(:, :) = amat + amat_local
   !$omp end critical (get_amat_3d_)
   deallocate(amat_local)
   !$omp end parallel

   amat(mol%nat + 1, 1:mol%nat + 1) = 1.0_wp
   amat(1:mol%nat + 1, mol%nat + 1) = 1.0_wp
   amat(mol%nat + 1, mol%nat + 1) = 0.0_wp

end subroutine get_amat_3d

subroutine get_amat_dir_3d(rij, gam, trans, kbc, rvdw, capi, capj, amat)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: gam
   real(wp), intent(in) :: kbc
   real(wp), intent(in) :: rvdw
   real(wp), intent(in) :: capi
   real(wp), intent(in) :: capj
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(out) :: amat

   integer :: itr
   real(wp) :: vec(3), r1, tmp, ctmp

   amat = 0.0_wp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      call get_cpair(kbc, ctmp, r1, rvdw, capi, capj)
      tmp = -ctmp * erf(gam * r1) / r1
      amat = amat + tmp
   end do

end subroutine get_amat_dir_3d

subroutine get_coulomb_derivs(self, mol, cache, qvec, dadr, dadL, atrace)
   class(eeqbc_model), intent(in) :: self
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: qvec(:)
   type(cache_container), intent(inout) :: cache
   real(wp), intent(out) :: dadr(:, :, :), dadL(:, :, :), atrace(:, :)

   type(eeqbc_cache), pointer :: ptr
   call view(cache, ptr)

   if (any(mol%periodic)) then
      call get_damat_3d(self, mol, ptr%wsc, ptr%cn, &
      & ptr%qloc, qvec, ptr%dcndr, ptr%dcndL, ptr%dqlocdr, &
      & ptr%dqlocdL, ptr%cmat, ptr%dcdr, ptr%dcdL, dadr, dadL, atrace)

   else
      call get_damat_0d(self, mol, ptr%cn, &
      & ptr%qloc, qvec, ptr%dcndr, ptr%dcndL, ptr%dqlocdr, &
      & ptr%dqlocdL, ptr%cmat, ptr%dcdr, ptr%dcdL, dadr, dadL, atrace)
   end if
end subroutine get_coulomb_derivs

subroutine get_damat_0d(self, mol, cn, qloc, qvec, dcndr, dcndL, &
      & dqlocdr, dqlocdL, cmat, dcdr, dcdL, dadr, dadL, atrace)
   class(eeqbc_model), intent(in) :: self
   type(structure_type), intent(in) :: mol
   real(wp), intent(in) :: cn(:)
   real(wp), intent(in) :: qloc(:)
   real(wp), intent(in) :: qvec(:)
   real(wp), intent(in) :: dcndr(:, :, :)
   real(wp), intent(in) :: dcndL(:, :, :)
   real(wp), intent(in) :: dqlocdr(:, :, :)
   real(wp), intent(in) :: dqlocdL(:, :, :)
   real(wp), intent(in) :: cmat(:, :)
   real(wp), intent(in) :: dcdr(:, :, :)
   real(wp), intent(in) :: dcdL(:, :, :)
   real(wp), intent(out) :: dadr(:, :, :)
   real(wp), intent(out) :: dadL(:, :, :)
   real(wp), intent(out) :: atrace(:, :)

   integer :: iat, jat, izp, jzp
   real(wp) :: vec(3), r2, gam, arg, dtmp, norm_cn
   real(wp) :: radi, radj, dradi, dradj, dG(3), dS(3, 3), dgamdL(3, 3)
   real(wp), allocatable :: dgamdr(:, :)

   ! Thread-private arrays for reduction
   real(wp), allocatable :: atrace_local(:, :)
   real(wp), allocatable :: dadr_local(:, :, :), dadL_local(:, :, :)

   allocate(dgamdr(3, mol%nat))

   atrace(:, :) = 0.0_wp
   dadr(:, :, :) = 0.0_wp
   dadL(:, :, :) = 0.0_wp

   !$omp parallel default(none) &
   !$omp shared(atrace, dadr, dadL, mol, self, cn, qloc, qvec) &
   !$omp shared(cmat, dcdr, dcdL, dcndr, dcndL, dqlocdr, dqlocdL) &
   !$omp private(iat, izp, jat, jzp, gam, vec, r2, dtmp, norm_cn, arg) &
   !$omp private(radi, radj, dradi, dradj, dgamdr, dgamdL, dG, dS) &
   !$omp private(atrace_local, dadr_local, dadL_local)
   allocate(atrace_local, source=atrace)
   allocate(dadr_local, source=dadr)
   allocate(dadL_local, source=dadL)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ! Effective charge width of i
      norm_cn = 1.0_wp / self%avg_cn(izp)**self%norm_exp
      radi = self%rad(izp) * (1.0_wp - self%kcnrad * cn(iat) * norm_cn)
      dradi = -self%rad(izp) * self%kcnrad * norm_cn
      do jat = 1, iat - 1
         jzp = mol%id(jat)
         vec = mol%xyz(:, jat) - mol%xyz(:, iat)
         r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         ! Effective charge width of j
         norm_cn = 1.0_wp / self%avg_cn(jzp)**self%norm_exp
         radj = self%rad(jzp) * (1.0_wp - self%kcnrad * cn(jat) * norm_cn)
         dradj = -self%rad(jzp) * self%kcnrad * norm_cn

         ! Coulomb interaction of Gaussian charges
         gam = 1.0_wp / sqrt(radi**2 + radj**2)
         dgamdr(:, :) = -(radi * dradi * dcndr(:, :, iat) + radj * dradj * dcndr(:, :, jat)) &
                        & * gam**3.0_wp
         dgamdL(:, :) = -(radi * dradi * dcndL(:, :, iat) + radj * dradj * dcndL(:, :, jat)) &
                        & * gam**3.0_wp

         ! Explicit derivative
         arg = gam * gam * r2
         dtmp = 2.0_wp * gam * exp(-arg) / (sqrtpi * r2) &
            & - erf(sqrt(arg)) / (r2 * sqrt(r2))
         dG(:) = dtmp * vec
         dS(:, :) = spread(dG, 1, 3) * spread(vec, 2, 3)
         atrace_local(:, iat) = -dG * qvec(jat) * cmat(jat, iat) + atrace_local(:, iat)
         atrace_local(:, jat) = +dG * qvec(iat) * cmat(iat, jat) + atrace_local(:, jat)
         dadr_local(:, iat, jat) = -dG * qvec(iat) * cmat(iat, jat) + dadr_local(:, iat, jat)
         dadr_local(:, jat, iat) = +dG * qvec(jat) * cmat(jat, iat) + dadr_local(:, jat, iat)
         dadL_local(:, :, iat) = +dS * qvec(jat) * cmat(jat, iat) + dadL_local(:, :, iat)
         dadL_local(:, :, jat) = +dS * qvec(iat) * cmat(iat, jat) + dadL_local(:, :, jat)

         ! Effective charge width derivative
         dtmp = 2.0_wp * exp(-arg) / (sqrtpi)
         atrace_local(:, iat) = -dtmp * qvec(jat) * dgamdr(:, jat) * cmat(jat, iat) + atrace_local(:, iat)
         atrace_local(:, jat) = -dtmp * qvec(iat) * dgamdr(:, iat) * cmat(iat, jat) + atrace_local(:, jat)
         dadr_local(:, iat, jat) = +dtmp * qvec(iat) * dgamdr(:, iat) * cmat(iat, jat) + dadr_local(:, iat, jat)
         dadr_local(:, jat, iat) = +dtmp * qvec(jat) * dgamdr(:, jat) * cmat(jat, iat) + dadr_local(:, jat, iat)
         dadL_local(:, :, iat) = +dtmp * qvec(jat) * dgamdL(:, :) * cmat(jat, iat) + dadL_local(:, :, iat)
         dadL_local(:, :, jat) = +dtmp * qvec(iat) * dgamdL(:, :) * cmat(iat, jat) + dadL_local(:, :, jat)

         ! Capacitance derivative off-diagonal
         dtmp = erf(sqrt(r2) * gam) / (sqrt(r2))
         atrace_local(:, iat) = -dtmp * qvec(jat) * dcdr(:, jat, iat) + atrace_local(:, iat)
         atrace_local(:, jat) = -dtmp * qvec(iat) * dcdr(:, iat, jat) + atrace_local(:, jat)
         dadr_local(:, iat, jat) = +dtmp * qvec(iat) * dcdr(:, iat, jat) + dadr_local(:, iat, jat)
         dadr_local(:, jat, iat) = +dtmp * qvec(jat) * dcdr(:, jat, iat) + dadr_local(:, jat, iat)
         dadL_local(:, :, iat) = -dtmp * qvec(jat) * spread(dcdr(:, iat, jat), 2, 3) * spread(vec, 1, 3) &
               & + dadL_local(:, :, iat)
         dadL_local(:, :, jat) = -dtmp * qvec(iat) * spread(dcdr(:, iat, jat), 2, 3) * spread(vec, 1, 3) &
               & + dadL_local(:, :, jat)

         ! Capacitance derivative diagonal
         dtmp = (self%eta(izp) + self%kqeta(izp) * qloc(iat) + sqrt2pi / radi) * qvec(iat)
         dadr_local(:, jat, iat) = -dtmp * dcdr(:, jat, iat) + dadr_local(:, jat, iat)

         dtmp = (self%eta(jzp) + self%kqeta(jzp) * qloc(jat) + sqrt2pi / radj) * qvec(jat)
         dadr_local(:, iat, jat) = -dtmp * dcdr(:, iat, jat) + dadr_local(:, iat, jat)
      end do

      ! Hardness derivative
      dtmp = self%kqeta(izp) * qvec(iat) * cmat(iat, iat)
      dadr_local(:, :, iat) = +dtmp * dqlocdr(:, :, iat) + dadr_local(:, :, iat)
      dadL_local(:, :, iat) = +dtmp * dqlocdL(:, :, iat) + dadL_local(:, :, iat)

      ! Effective charge width derivative
      dtmp = -sqrt2pi * dradi / (radi**2) * qvec(iat) * cmat(iat, iat)
      dadr_local(:, :, iat) = +dtmp * dcndr(:, :, iat) + dadr_local(:, :, iat)
      dadL_local(:, :, iat) = +dtmp * dcndL(:, :, iat) + dadL_local(:, :, iat)

      ! Capacitance derivative
      dtmp = (self%eta(izp) + self%kqeta(izp) * qloc(iat) + sqrt2pi / radi) * qvec(iat)
      dadr_local(:, iat, iat) = +dtmp * dcdr(:, iat, iat) + dadr_local(:, iat, iat)
      dadL_local(:, :, iat) = +dtmp * dcdL(:, :, iat) + dadL_local(:, :, iat)

   end do
   !$omp end do
   !$omp critical (get_damat_0d_)
   atrace(:, :) = atrace + atrace_local
   dadr(:, :, :) = dadr + dadr_local
   dadL(:, :, :) = dadL + dadL_local
   !$omp end critical (get_damat_0d_)
   deallocate(dadL_local, dadr_local, atrace_local)
   !$omp end parallel

end subroutine get_damat_0d

subroutine get_damat_3d(self, mol, wsc, cn, qloc, qvec, dcndr, dcndL, dqlocdr, &
   & dqlocdL, cmat, dcdr, dcdL, dadr, dadL, atrace)
   class(eeqbc_model), intent(in) :: self
   type(structure_type), intent(in) :: mol
   type(wignerseitz_cell_type), intent(in) :: wsc
   real(wp), intent(in) :: cn(:)
   real(wp), intent(in) :: qloc(:)
   real(wp), intent(in) :: qvec(:)
   real(wp), intent(in) :: dcndr(:, :, :)
   real(wp), intent(in) :: dcndL(:, :, :)
   real(wp), intent(in) :: dqlocdr(:, :, :)
   real(wp), intent(in) :: dqlocdL(:, :, :)
   real(wp), intent(in) :: cmat(:, :)
   real(wp), intent(in) :: dcdr(:, :, :)
   real(wp), intent(in) :: dcdL(:, :, :)
   real(wp), intent(out) :: dadr(:, :, :)
   real(wp), intent(out) :: dadL(:, :, :)
   real(wp), intent(out) :: atrace(:, :)

   integer :: iat, jat, izp, jzp, img
   real(wp) :: vec(3), r2, gam, arg, dtmp, norm_cn, rvdw, wsw, dgam
   real(wp) :: radi, radj, dradi, dradj, dG(3), dS(3, 3)
   real(wp) :: dgamdL(3, 3), capi, capj
   real(wp), allocatable :: dgamdr(:, :), dtrans(:, :)

   ! Thread-private arrays for reduction
   real(wp), allocatable :: atrace_local(:, :)
   real(wp), allocatable :: dadr_local(:, :, :), dadL_local(:, :, :)

   call get_dir_trans(mol%lattice, dtrans)

   allocate(dgamdr(3, mol%nat))

   atrace(:, :) = 0.0_wp
   dadr(:, :, :) = 0.0_wp
   dadL(:, :, :) = 0.0_wp

   !$omp parallel default(none) &
   !$omp shared(self, mol, cn, qloc, qvec, wsc, dadr, dadL, atrace) &
   !$omp shared (cmat, dcdr, dcdL, dcndr, dcndL, dqlocdr, dqlocdL, dtrans) &
   !$omp private(iat, izp, jat, jzp, img, gam, vec, r2, dtmp, norm_cn, arg, rvdw) &
   !$omp private(radi, radj, dradi, dradj, capi, capj, dgamdr, dgamdL, dG, dS, wsw) &
   !$omp private(dgam, dadr_local, dadL_local, atrace_local)
   allocate(atrace_local, source=atrace)
   allocate(dadr_local, source=dadr)
   allocate(dadL_local, source=dadL)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ! Effective charge width of i
      norm_cn = 1.0_wp / self%avg_cn(izp)**self%norm_exp
      radi = self%rad(izp) * (1.0_wp - self%kcnrad * cn(iat) * norm_cn)
      dradi = -self%rad(izp) * self%kcnrad * norm_cn
      capi = self%cap(izp)
      do jat = 1, iat - 1
         jzp = mol%id(jat)
         capj = self%cap(jzp)
         rvdw = self%rvdw(iat, jat)

         ! Effective charge width of j
         norm_cn = 1.0_wp / self%avg_cn(jzp)**self%norm_exp
         radj = self%rad(jzp) * (1.0_wp - self%kcnrad * cn(jat) * norm_cn)
         dradj = -self%rad(jzp) * self%kcnrad * norm_cn

         ! Coulomb interaction of Gaussian charges
         gam = 1.0_wp / sqrt(radi**2 + radj**2)
         dgamdr(:, :) = -(radi * dradi * dcndr(:, :, iat) + radj * dradj * dcndr(:, :, jat)) &
                        & * gam**3.0_wp
         dgamdL(:, :) = -(radi * dradi * dcndL(:, :, iat) + radj * dradj * dcndL(:, :, jat)) &
                        & * gam**3.0_wp

         wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, jat) - mol%xyz(:, iat) + wsc%trans(:, wsc%tridx(img, jat, iat))

            call get_damat_dir(vec, dtrans, capi, capj, rvdw, self%kbc, gam, dG, dS, dgam)
            dG = dG * wsw
            dS = dS * wsw
            dgam = dgam * wsw

            ! Explicit derivative
            atrace_local(:, iat) = -dG * qvec(jat) + atrace_local(:, iat)
            atrace_local(:, jat) = +dG * qvec(iat) + atrace_local(:, jat)
            dadr_local(:, iat, jat) = -dG * qvec(iat) + dadr_local(:, iat, jat)
            dadr_local(:, jat, iat) = +dG * qvec(jat) + dadr_local(:, jat, iat)
            dadL_local(:, :, jat) = +dS * qvec(iat) + dadL_local(:, :, jat)
            dadL_local(:, :, iat) = +dS * qvec(jat) + dadL_local(:, :, iat)

            ! Effective charge width derivative
            atrace_local(:, iat) = +dgam * qvec(jat) * dgamdr(:, jat) + atrace_local(:, iat)
            atrace_local(:, jat) = +dgam * qvec(iat) * dgamdr(:, iat) + atrace_local(:, jat)
            dadr_local(:, iat, jat) = -dgam * qvec(iat) * dgamdr(:, iat) + dadr_local(:, iat, jat)
            dadr_local(:, jat, iat) = -dgam * qvec(jat) * dgamdr(:, jat) + dadr_local(:, jat, iat)
            dadL_local(:, :, iat) = -dgam * qvec(jat) * dgamdL(:, :) + dadL_local(:, :, iat)
            dadL_local(:, :, jat) = -dgam * qvec(iat) * dgamdL(:, :) + dadL_local(:, :, jat)

            call get_damat_dc_dir(vec, dtrans, capi, capj, rvdw, self%kbc, gam, dG, dS)
            dG = dG * wsw
            dS = dS * wsw

            ! Capacitance derivative off-diagonal
            atrace_local(:, iat) = +qvec(jat) * dG(:) + atrace_local(:, iat)
            atrace_local(:, jat) = -qvec(iat) * dG(:) + atrace_local(:, jat)
            dadr_local(:, jat, iat) = -qvec(jat) * dG(:) + dadr_local(:, jat, iat)
            dadr_local(:, iat, jat) = +qvec(iat) * dG(:) + dadr_local(:, iat, jat)
            dadL_local(:, :, jat) = -qvec(iat) * dS(:, :) + dadL_local(:, :, jat)
            dadL_local(:, :, iat) = -qvec(jat) * dS(:, :) + dadL_local(:, :, iat)

            call get_dcpair_dir(self%kbc, vec, dtrans, rvdw, capi, capj, dG, dS)
            dG = dG * wsw

            ! Capacitance derivative diagonal
            dtmp = (self%eta(izp) + self%kqeta(izp) * qloc(iat) + sqrt2pi / radi) * qvec(iat)
            dadr_local(:, jat, iat) = +dtmp * dG(:) + dadr_local(:, jat, iat)
            dtmp = (self%eta(jzp) + self%kqeta(jzp) * qloc(jat) + sqrt2pi / radj) * qvec(jat)
            dadr_local(:, iat, jat) = -dtmp * dG(:) + dadr_local(:, iat, jat)
         end do
      end do

      ! diagonal explicit, charge width, and capacitance derivative terms
      gam = 1.0_wp / sqrt(2.0_wp * radi**2)
      dtmp = -sqrt2pi * dradi / (radi**2) * qvec(iat)
      rvdw = self%rvdw(iat, iat)
      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec = wsc%trans(:, wsc%tridx(img, iat, iat))
         call get_damat_dir(vec, dtrans, capi, capi, rvdw, self%kbc, gam, dG, dS, dgam)
         dgam = dgam * wsw

         ! Explicit derivative
         dadL_local(:, :, iat) = +dS * wsw * qvec(iat) + dadL_local(:, :, iat)

         ! Effective charge width derivative
         atrace_local(:, iat) = +dtmp * dcndr(:, iat, iat) * dgam + atrace_local(:, iat)
         dadr_local(:, iat, iat) = -dtmp * dcndr(:, iat, iat) * dgam + dadr_local(:, iat, iat)
         dadL_local(:, :, iat) = -dtmp * dcndL(:, :, iat) * dgam + dadL_local(:, :, iat)

         ! Capacitance derivative
         call get_damat_dc_dir(vec, dtrans, capi, capi, rvdw, self%kbc, gam, dG, dS)
         dadL_local(:, :, iat) = -qvec(iat) * dS * wsw + dadL_local(:, :, iat)
      end do

      ! Hardness derivative
      dtmp = self%kqeta(izp) * qvec(iat) * cmat(iat, iat)
      dadr_local(:, :, iat) = +dtmp * dqlocdr(:, :, iat) + dadr_local(:, :, iat)
      dadL_local(:, :, iat) = +dtmp * dqlocdL(:, :, iat) + dadL_local(:, :, iat)

      ! Effective charge width derivative
      dtmp = -sqrt2pi * dradi / (radi**2) * qvec(iat) * cmat(iat, iat)
      dadr_local(:, :, iat) = +dtmp * dcndr(:, :, iat) + dadr_local(:, :, iat)
      dadL_local(:, :, iat) = +dtmp * dcndL(:, :, iat) + dadL_local(:, :, iat)

      dtmp = (self%eta(izp) + self%kqeta(izp) * qloc(iat) + sqrt2pi / radi) * qvec(iat)
      dadr_local(:, iat, iat) = +dtmp * dcdr(:, iat, iat) + dadr_local(:, iat, iat)
      dadL_local(:, :, iat) = +dtmp * dcdL(:, :, iat) + dadL_local(:, :, iat)

   end do
   !$omp end do
   !$omp critical (get_damat_3d_)
   atrace(:, :) = atrace + atrace_local
   dadr(:, :, :) = dadr + dadr_local
   dadL(:, :, :) = dadL + dadL_local
   !$omp end critical (get_damat_3d_)
   deallocate(dadL_local, dadr_local, atrace_local)
   !$omp end parallel

end subroutine get_damat_3d

subroutine get_damat_dir(rij, trans, capi, capj, rvdw, kbc, gam, dG, dS, dgam)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(in) :: gam
   real(wp), intent(in) :: capi, capj, rvdw, kbc
   real(wp), intent(out) :: dG(3)
   real(wp), intent(out) :: dS(3, 3)
   real(wp), intent(out) :: dgam

   integer :: itr
   real(wp) :: vec(3), r1, r2, gtmp, gam2, cmat

   dG(:) = 0.0_wp
   dS(:, :) = 0.0_wp
   dgam = 0.0_wp

   gam2 = gam * gam

   do itr = 1, size(trans, 2)
      vec(:) = rij(:) + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      r2 = r1 * r1
      call get_cpair(kbc, cmat, r1, rvdw, capi, capj)
      gtmp = 2.0_wp * gam * exp(-r2 * gam2) / (sqrtpi * r2) - erf(r1 * gam) / (r2 * r1)
      dG(:) = dG - cmat * gtmp * vec
      dS(:, :) = dS - cmat * gtmp * spread(vec, 1, 3) * spread(vec, 2, 3)
      dgam = dgam + cmat * 2.0_wp * exp(-gam2 * r2) / sqrtpi
   end do

end subroutine get_damat_dir

subroutine get_damat_dc_dir(rij, trans, capi, capj, rvdw, kbc, gam, dG, dS)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(in) :: gam
   real(wp), intent(in) :: capi, capj, rvdw, kbc
   real(wp), intent(out) :: dG(3)
   real(wp), intent(out) :: dS(3, 3)

   integer :: itr
   real(wp) :: vec(3), r1, gtmp(3), stmp(3, 3), tmp

   dG(:) = 0.0_wp
   dS(:, :) = 0.0_wp

   do itr = 1, size(trans, 2)
      vec(:) = rij(:) + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      call get_dcpair(kbc, vec, rvdw, capi, capj, gtmp, stmp)
      tmp = erf(gam * r1) / r1
      dG(:) = dG(:) + tmp * gtmp
      dS(:, :) = dS(:, :) + tmp * stmp
   end do

end subroutine get_damat_dc_dir

subroutine get_cmat_0d(self, mol, cmat)
   class(eeqbc_model), intent(in) :: self
   type(structure_type), intent(in) :: mol
   real(wp), intent(out) :: cmat(:, :)

   integer :: iat, jat, izp, jzp
   real(wp) :: vec(3), rvdw, tmp, capi, capj, r1

   ! Thread-private array for reduction
   real(wp), allocatable :: cmat_local(:, :)

   cmat(:, :) = 0.0_wp

   !$omp parallel default(none) &
   !$omp shared(cmat, mol, self) &
   !$omp private(iat, izp, jat, jzp) &
   !$omp private(vec, r1, rvdw, tmp, capi, capj, cmat_local)
   allocate(cmat_local, source=cmat)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      capi = self%cap(izp)
      do jat = 1, iat - 1
         jzp = mol%id(jat)
         vec = mol%xyz(:, jat) - mol%xyz(:, iat)
         r1 = norm2(vec)
         rvdw = self%rvdw(iat, jat)
         capj = self%cap(jzp)

         call get_cpair(self%kbc, tmp, r1, rvdw, capi, capj)

         ! Off-diagonal elements
         cmat_local(jat, iat) = -tmp
         cmat_local(iat, jat) = -tmp
         ! Diagonal elements
         cmat_local(iat, iat) = cmat_local(iat, iat) + tmp
         cmat_local(jat, jat) = cmat_local(jat, jat) + tmp
      end do
   end do
   !$omp end do
   !$omp critical (get_cmat_0d_)
   cmat(:, :) = cmat + cmat_local
   !$omp end critical (get_cmat_0d_)
   deallocate(cmat_local)
   !$omp end parallel

   cmat(mol%nat + 1, mol%nat + 1) = 1.0_wp

end subroutine get_cmat_0d

subroutine get_cmat_3d(self, mol, wsc, cmat)
   class(eeqbc_model), intent(in) :: self
   type(structure_type), intent(in) :: mol
   type(wignerseitz_cell_type), intent(in) :: wsc
   real(wp), intent(out) :: cmat(:, :)

   integer :: iat, jat, izp, jzp, img
   real(wp) :: vec(3), rvdw, tmp, capi, capj, wsw
   real(wp), allocatable :: dtrans(:, :)

   ! Thread-private array for reduction
   real(wp), allocatable :: cmat_local(:, :)

   call get_dir_trans(mol%lattice, dtrans)

   cmat(:, :) = 0.0_wp

   !$omp parallel default(none) &
   !$omp shared(cmat, mol, self, wsc, dtrans) &
   !$omp private(iat, izp, jat, jzp, img) &
   !$omp private(vec, rvdw, tmp, capi, capj, wsw, cmat_local)
   allocate(cmat_local, source=cmat)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      capi = self%cap(izp)
      do jat = 1, iat - 1
         jzp = mol%id(jat)
         rvdw = self%rvdw(iat, jat)
         capj = self%cap(jzp)
         wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, iat) - mol%xyz(:, jat) - wsc%trans(:, wsc%tridx(img, jat, iat))

            call get_cpair_dir(self%kbc, vec, dtrans, rvdw, capi, capj, tmp)

            ! Off-diagonal elements
            cmat_local(jat, iat) = cmat_local(jat, iat) - tmp * wsw
            cmat_local(iat, jat) = cmat_local(iat, jat) - tmp * wsw
            ! Diagonal elements
            cmat_local(iat, iat) = cmat_local(iat, iat) + tmp * wsw
            cmat_local(jat, jat) = cmat_local(jat, jat) + tmp * wsw
         end do
      end do

      ! diagonal capacitance (interaction with images)
      rvdw = self%rvdw(iat, iat)
      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec = wsc%trans(:, wsc%tridx(img, iat, iat))
         call get_cpair_dir(self%kbc, vec, dtrans, rvdw, capi, capi, tmp)
         cmat_local(iat, iat) = cmat_local(iat, iat) + tmp * wsw
      end do
   end do
   !$omp end do
   !$omp critical (get_cmat_3d_)
   cmat(:, :) = cmat + cmat_local
   !$omp end critical (get_cmat_3d_)
   deallocate(cmat_local)
   !$omp end parallel
   !
   cmat(mol%nat + 1, mol%nat + 1) = 1.0_wp

end subroutine get_cmat_3d

subroutine get_cpair(kbc, cpair, r1, rvdw, capi, capj)
   real(wp), intent(in) :: kbc
   real(wp), intent(in) :: r1
   real(wp), intent(in) :: capi
   real(wp), intent(in) :: capj
   real(wp), intent(in) :: rvdw
   real(wp), intent(out) :: cpair

   real(wp) :: arg

   ! Capacitance of bond between atom i and j
   arg = -kbc * (r1 - rvdw) / rvdw
   cpair = sqrt(capi * capj) * 0.5_wp * (1.0_wp + erf(arg))
end subroutine get_cpair

subroutine get_cpair_dir(kbc, rij, trans, rvdw, capi, capj, cpair)
   real(wp), intent(in) :: kbc
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(in) :: rvdw
   real(wp), intent(in) :: capi
   real(wp), intent(in) :: capj
   real(wp), intent(out) :: cpair

   integer :: itr
   real(wp) :: vec(3), r1, tmp

   cpair = 0.0_wp
   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      call get_cpair(kbc, tmp, r1, rvdw, capi, capj)
      cpair = cpair + tmp
   end do
end subroutine get_cpair_dir

subroutine get_dcpair(kbc, vec, rvdw, capi, capj, dgpair, dspair)
   real(wp), intent(in) :: kbc
   real(wp), intent(in) :: vec(3)
   real(wp), intent(in) :: rvdw
   real(wp), intent(in) :: capi
   real(wp), intent(in) :: capj
   real(wp), intent(out) :: dgpair(3)
   real(wp), intent(out) :: dspair(3, 3)

   real(wp) :: r1, arg, dtmp

   dgpair(:) = 0.0_wp
   dspair(:, :) = 0.0_wp

   r1 = norm2(vec)
   ! Capacitance of bond between atom i and j
   arg = -(kbc * (r1 - rvdw) / rvdw)**2
   dtmp = -sqrt(capi * capj) * kbc * exp(arg) / (sqrtpi * rvdw)
   dgpair = dtmp * vec / r1
   dspair = spread(dgpair, 1, 3) * spread(vec, 2, 3)
end subroutine get_dcpair

subroutine get_dcmat_0d(self, mol, dcdr, dcdL)
   class(eeqbc_model), intent(in) :: self
   type(structure_type), intent(in) :: mol
   real(wp), intent(out) :: dcdr(:, :, :)
   real(wp), intent(out) :: dcdL(:, :, :)

   integer :: iat, jat, izp, jzp
   real(wp) :: vec(3), r2, rvdw, dtmp, arg, dG(3), dS(3, 3), capi, capj

   ! Thread-private arrays for reduction
   real(wp), allocatable :: dcdr_local(:, :, :), dcdL_local(:, :, :)

   dcdr(:, :, :) = 0.0_wp
   dcdL(:, :, :) = 0.0_wp

   !$omp parallel default(none) &
   !$omp shared(dcdr, dcdL, mol, self) &
   !$omp private(iat, izp, jat, jzp, r2, vec, rvdw) &
   !$omp private(dG, dS, dtmp, arg, capi, capj) &
   !$omp private(dcdr_local, dcdL_local)
   allocate(dcdr_local, source=dcdr)
   allocate(dcdL_local, source=dcdL)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      capi = self%cap(izp)
      do jat = 1, iat - 1
         jzp = mol%id(jat)
         capj = self%cap(jzp)
         rvdw = self%rvdw(iat, jat)
         vec = mol%xyz(:, jat) - mol%xyz(:, iat)

         call get_dcpair(self%kbc, vec, rvdw, capi, capj, dG, dS)

         ! Off-diagonal elements
         dcdr_local(:, iat, jat) = +dG
         dcdr_local(:, jat, iat) = -dG
         ! Diagonal elements
         dcdr_local(:, iat, iat) = -dG + dcdr_local(:, iat, iat)
         dcdr_local(:, jat, jat) = +dG + dcdr_local(:, jat, jat)
         dcdL_local(:, :, iat) = +dS + dcdL_local(:, :, iat)
         dcdL_local(:, :, jat) = +dS + dcdL_local(:, :, jat)
      end do
   end do
   !$omp end do
   !$omp critical (get_dcmat_0d_)
   dcdr(:, :, :) = dcdr + dcdr_local
   dcdL(:, :, :) = dcdL + dcdL_local
   !$omp end critical (get_dcmat_0d_)
   deallocate(dcdL_local, dcdr_local)
   !$omp end parallel

end subroutine get_dcmat_0d

subroutine get_dcmat_3d(self, mol, wsc, dcdr, dcdL)
   class(eeqbc_model), intent(in) :: self
   type(structure_type), intent(in) :: mol
   type(wignerseitz_cell_type), intent(in) :: wsc
   real(wp), intent(out) :: dcdr(:, :, :)
   real(wp), intent(out) :: dcdL(:, :, :)

   integer :: iat, jat, izp, jzp, img
   real(wp) :: vec(3), r2, rvdw, dtmp, arg, dG(3), dS(3, 3), capi, capj, wsw
   real(wp), allocatable :: dtrans(:, :)

   ! Thread-private arrays for reduction
   real(wp), allocatable :: dcdr_local(:, :, :), dcdL_local(:, :, :)

   call get_dir_trans(mol%lattice, dtrans)

   dcdr(:, :, :) = 0.0_wp
   dcdL(:, :, :) = 0.0_wp

   !$omp parallel default(none) &
   !$omp shared(dcdr, dcdL, mol, self, dtrans, wsc) &
   !$omp private(iat, izp, jat, jzp, r2, vec, rvdw) &
   !$omp private(dG, dS, dtmp, arg, capi, capj, wsw) &
   !$omp private(dcdr_local, dcdL_local)
   allocate(dcdr_local, source=dcdr)
   allocate(dcdL_local, source=dcdL)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      capi = self%cap(izp)
      do jat = 1, iat - 1
         jzp = mol%id(jat)
         capj = self%cap(jzp)
         rvdw = self%rvdw(iat, jat)
         wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, jat) - mol%xyz(:, iat) + wsc%trans(:, wsc%tridx(img, jat, iat))

            call get_dcpair_dir(self%kbc, vec, dtrans, rvdw, capi, capj, dG, dS)

            ! Off-diagonal elements
            dcdr_local(:, iat, jat) = +dG * wsw + dcdr_local(:, iat, jat)
            dcdr_local(:, jat, iat) = -dG * wsw + dcdr_local(:, jat, iat)
            ! Diagonal elements
            dcdr_local(:, iat, iat) = -dG * wsw + dcdr_local(:, iat, iat)
            dcdr_local(:, jat, jat) = +dG * wsw + dcdr_local(:, jat, jat)
            dcdL_local(:, :, jat) = +dS * wsw + dcdL_local(:, :, jat)
            dcdL_local(:, :, iat) = +dS * wsw + dcdL_local(:, :, iat)
         end do
      end do

      rvdw = self%rvdw(iat, iat)
      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec = wsc%trans(:, wsc%tridx(img, iat, iat))

         call get_dcpair_dir(self%kbc, vec, dtrans, rvdw, capi, capi, dG, dS)

         ! Positive diagonal elements
         dcdL_local(:, :, iat) = +dS * wsw + dcdL_local(:, :, iat)
      end do
   end do
   !$omp end do
   !$omp critical (get_dcmat_3d_)
   dcdr(:, :, :) = dcdr + dcdr_local
   dcdL(:, :, :) = dcdL + dcdL_local
   !$omp end critical (get_dcmat_3d_)
   deallocate(dcdL_local, dcdr_local)
   !$omp end parallel

end subroutine get_dcmat_3d

subroutine get_dcpair_dir(kbc, rij, trans, rvdw, capi, capj, dgpair, dspair)
   real(wp), intent(in) :: rij(3), capi, capj, rvdw, kbc, trans(:, :)
   real(wp), intent(out) :: dgpair(3)
   real(wp), intent(out) :: dspair(3, 3)

   integer :: itr
   real(wp) :: r1, arg, dtmp, dgtmp(3), dstmp(3, 3), vec(3)

   dgpair(:) = 0.0_wp
   dspair(:, :) = 0.0_wp
   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      call get_dcpair(kbc, vec, rvdw, capi, capj, dgtmp, dstmp)
      dgpair(:) = dgpair + dgtmp
      dspair(:, :) = dspair + dstmp
   end do
end subroutine get_dcpair_dir

!> Inspect cache and reallocate it in case of type mismatch
subroutine taint(cache, ptr)
   !> Instance of the cache
   type(cache_container), target, intent(inout) :: cache
   !> Reference to the cache
   type(eeqbc_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not. allocated(cache%raw)) then
      block
         type(eeqbc_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

!> Return reference to cache after resolving its type
subroutine view(cache, ptr)
   !> Instance of the cache
   type(cache_container), target, intent(inout) :: cache
   !> Reference to the cache
   type(eeqbc_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(eeqbc_cache)
      ptr => target
   end select
end subroutine view

end module multicharge_model_eeqbc

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/disp
!> Contains implemenations for the evaluation of London-dispersion interactions.

!> @file tblite/disp.f90
!> Reexports of the available dispersion interactions.

!> Proxy module for dispersion interactions.
module tblite_disp
   use mctc_env, only : wp
   use tblite_disp_cache, only : dispersion_cache
   use tblite_disp_d3, only : d3_dispersion, new_d3_dispersion
   use tblite_disp_d4, only : d4_dispersion, new_d4_dispersion, new_d4s_dispersion
   use tblite_disp_type, only : dispersion_type
   implicit none
   public

end module tblite_disp

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/context
!> Contains the individual components of the context manager.

!> @file tblite/context.f90
!> Provides reexports for the context manager.

!> Proxy module for the calculation context related data types.
!>
!> Provides access to the #tblite_context_type::context_type to manage the calculation.
!> The context stores error messages generated while running which can be
!> queried using the #tblite_context_type::context_type::failed procedure.
!> To access the actual errors the messages can be removed using the
!> #tblite_context_type::context_type::get_error procedure.
!>
!> Errors can be pushed to a context by using #tblite_context_type::context_type::set_error,
!> A context containing any error will automatically be marked as failed. Once all
!> error messages are removed from again with #tblite_context_type::context_type::get_error
!> the failed status is removed from the context as well.
!>
!> The context provides also access to output by providing the
!> #tblite_context_type::context_type::message procedure. Using this procedure
!> for printouts ensures they are correctly handled in case of API usage.
!>
!> An output verbosity is available in the context as the member verbosity, all procedures
!> with access to the context will default to the verbosity of the context unless
!> the verbosity level is overwritten by an argument.
!>
!> To cutomize the output the #tblite_context_logger::context_logger abstract base class
!> is available. It provides a #tblite_context_logger::context_logger::message procedure
!> which is used by the context to create output. This type can be used to create callbacks
!> for customizing or redirecting the output of the library, e.g. when used from C or Python.
!>
!> ANSI escape sequences are available via the #tblite_context_terminal::context_terminal
!> class and which is instantiated in the #tblite_context_type::context_type::terminal
!> member. The terminal instance provides access to various terminal formatting codes to
!> produce the respective ANSI escape sequences if the terminal is created with color
!> support, otherwise return empty strings. Detecting whether the terminal supports
!> ANSI escape sequences is left as excerise to the consumer of the
!> #tblite_context_terminal::context_terminal class.
!>
!> For convenience operators are provided to add escape codes as well as concatenate
!> them directly with strings.
module tblite_context
   use tblite_context_logger, only : context_logger
   use tblite_context_terminal, only : context_terminal, escape, operator(+), operator(//)
   use tblite_context_type, only : context_type
   implicit none
   public
end module tblite_context

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

#include "mctc/defs.h"

module mctc_io_read_cjson
   use mctc_env_accuracy, only : wp
   use mctc_env_error, only : error_type, fatal_error
   use mctc_io_constants, only : pi
   use mctc_io_convert, only : aatoau
   use mctc_io_structure, only : structure_type, new
   use mctc_io_symbols, only : to_number, symbol_length
   use mctc_io_utils, only : getline, to_string
#if WITH_JSON
   use jonquil, only : json_value, json_object, json_array, json_keyval, &
      & json_load, json_error, json_context, json_stat, json_path, get_value, &
      & json_parser_config, json_context, cast_to_object, len
#endif
   implicit none
   private

   public :: read_cjson

#if WITH_JSON
   interface read_cjson
      module procedure read_cjson
      module procedure load_cjson
   end interface read_cjson
#endif


contains


subroutine read_cjson(self, unit, error)

   !> Instance of the molecular structure data
   type(structure_type), intent(out) :: self

   !> File handle
   integer, intent(in) :: unit

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

#if WITH_JSON
   class(json_value), allocatable :: root
   type(json_object), pointer :: object
   type(json_error), allocatable :: parse_error
   type(json_context) :: ctx

   call json_load(root, unit, config=json_parser_config(context_detail=1), &
      & context=ctx, error=parse_error)
   if (allocated(parse_error)) then
      allocate(error)
      call move_alloc(parse_error%message, error%message)
      return
   end if
   object => cast_to_object(root)
   if (.not.associated(object)) then
      call fatal_error(error, ctx%report("Invalid JSON object", root%origin, "Expected JSON object"))
      return
   end if

   call load_cjson(self, object, ctx, error)
#else
   call fatal_error(error, "JSON support not enabled")
#endif
end subroutine read_cjson


#if WITH_JSON
subroutine load_cjson(self, object, ctx, error)

   !> Instance of the molecular structure data
   type(structure_type), intent(out) :: self

   !> JSON object representing the structure
   type(json_object), intent(inout) :: object

   !> JSON context for error reporting
   type(json_context), intent(inout) :: ctx

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(json_object), pointer :: child, child2
   type(json_array), pointer :: array, child_array
   type(json_keyval), pointer :: val

   logical :: cartesian, found
   integer :: stat, origin, schema_version, charge, multiplicity, ibond
   integer :: origin_elements, origin_coords
   character(len=:), allocatable :: input, line, message, comment
   integer, allocatable :: num(:), bond(:, :), list(:), order(:)
   real(wp) :: cellpar(6)
   real(wp), allocatable :: lattice(:, :)
   real(wp), allocatable, target :: geo(:)
   real(wp), pointer :: xyz(:, :)

   call cjson_get_value(object, "chemicalJson", "chemical json", val, stat=stat, origin=origin)
   if (.not.associated(val) .or. stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could find chemical json", origin))
      return
   end if

   call get_value(val, schema_version, stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read schema version", origin, &
         & "Expected integer value"))
      return
   end if

   ! There seems to be no actual difference between version 0 and 1, though
   if (all(schema_version /= [0, 1])) then
      call fatal_error(error, ctx%report("Invalid schema version", val%origin, &
         & "Expected 0 or 1"))
      return
   end if

   call cjson_get_child(object, "unitCell", "unit cell", child, stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read unit cell", origin))
      return
   end if
   if (associated(child)) then
      call get_value(child, "a", cellpar(1), stat=stat, origin=origin)
      if (stat == json_stat%success) then
         call get_value(child, "b", cellpar(2), stat=stat, origin=origin)
      end if
      if (stat == json_stat%success) then
         call get_value(child, "c", cellpar(3), stat=stat, origin=origin)
      end if
      if (stat == json_stat%success) then
         call get_value(child, "alpha", cellpar(4), stat=stat, origin=origin)
      end if
      if (stat == json_stat%success) then
         call get_value(child, "beta",  cellpar(5), stat=stat, origin=origin)
      end if
      if (stat == json_stat%success) then
         call get_value(child, "gamma", cellpar(6), stat=stat, origin=origin)
      end if
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read unit cell parameters", origin, &
            & "Expected float values"))
         return
      end if

      cellpar(1:3) = cellpar(1:3) * aatoau
      cellpar(4:6) = cellpar(4:6) * (pi / 180)
      allocate(lattice(3, 3))
      call cell_to_dlat(cellpar, lattice)
   end if

   call get_value(object, "atoms", child, stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read atoms", origin))
      return
   end if
   call get_value(child, "elements", child2, stat=stat, origin=origin)
   if (stat == json_stat%success) then
      call get_value(child2, "number", array, stat=stat, origin=origin)
   end if
   if (stat == json_stat%success) then
      call get_value(array, num, stat=stat, origin=origin)
   end if
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read atomic numbers", origin))
      return
   end if
   origin_elements = array%origin

   call get_value(child, "coords", child2, stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read coordinates", origin, "Expected object"))
      return
   end if
   call get_value(child2, "3d", array, requested=.false., stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read 3D coordinates", origin, &
         & "Expected array"))
      return
   end if
   cartesian = associated(array)
   if (.not.cartesian .and. allocated(lattice)) then
      call cjson_get_array(child2, "3dFractional", "3d fractional", &
         & array, stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read fractional coordinates", origin, &
            & "Expected array"))
         return
      end if
   end if
   if (associated(array)) then
      call get_value(array, geo, stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read coordinates", origin))
         return
      end if
   else
      call fatal_error(error, ctx%report("Could not read coordinates", child2%origin, &
         & "Coordinates not found"))
      return
   end if
   origin_coords = array%origin

   if (3*size(num) /= size(geo)) then
      call fatal_error(error, ctx%report("Number of coordinates and atomic numbers do not match", &
         & origin_elements, origin_coords, "Got "//to_string(size(num))//" elements", &
         & "Got "//to_string(size(geo))//" coordinates, expected "//to_string(3*size(num))))
      return
   end if

   call get_value(object, "bonds", child, stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read bonds", origin))
      return
   end if
   call get_value(child, "order", array, requested=.false., stat=stat, origin=origin)
   if (associated(array)) then
      call get_value(array, order, stat=stat, origin=origin)
   end if
   call get_value(child, json_path("connections", "index"), array, requested=.false., &
      & stat=stat, origin=origin)
   if (associated(array)) then
      call get_value(array, list, stat=stat, origin=origin)
   end if
   if (.not.allocated(order) .and. allocated(list)) &
      allocate(order(size(list)/2), source=1)

   if (allocated(list)) then
      if (2*size(order) /= size(list)) then
         call fatal_error(error, "Number of bond orders and connectivity indices must match")
         return
      end if
      allocate(bond(3, size(list)/2))
      do ibond = 1, size(bond, 2)
         bond(:, ibond) = [list(2*ibond-1) + 1, list(2*ibond) + 1, order(ibond)]
      end do
   end if

   call get_value(object, "name", comment, default="", stat=stat, origin=origin)
   call get_value(object, "properties", child, stat=stat, origin=origin)
   call get_value(child, "totalCharge", charge, stat=stat, origin=origin)
   if (stat == json_stat%missing_key) then
      call get_value(object, json_path("atoms", "formalCharges"), array, stat=stat, origin=origin)
      charge  = 0
      if (associated(array)) then
          call get_value(array, list, stat=stat, origin=origin)
          if (allocated(list)) then
            charge = sum(list)
          end if
         end if
   end if
   call get_value(child, "totalSpinMultiplicity", multiplicity, default=1, stat=stat, &
      & origin=origin)

   xyz(1:3, 1:size(geo)/3) => geo
   xyz(:, :) = xyz * aatoau
   if (.not.cartesian) then
      xyz(:, :) = matmul(lattice, xyz(:, :))
   end if
   call new(self, num, xyz, lattice=lattice, charge=real(charge, wp), uhf=multiplicity - 1)
   if (len(comment) > 0) self%comment = comment
   if (allocated(bond)) then
      self%nbd = size(bond, 2)
      call move_alloc(bond, self%bond)
   end if

end subroutine load_cjson
#endif

#if WITH_JSON
subroutine cjson_get_child(object, key1, key2, child, stat, origin)
   type(json_object), intent(inout) :: object
   type(json_object), pointer, intent(out) :: child
   character(len=*), intent(in) :: key1, key2
   integer, intent(out) :: stat, origin

   call get_value(object, key1, child, requested=.false., &
      & stat=stat, origin=origin)
   if (stat == json_stat%missing_key .or. .not.associated(child)) then
      call get_value(object, key2, child, requested=.false., &
         & stat=stat, origin=origin)
   end if
end subroutine cjson_get_child

subroutine cjson_get_array(object, key1, key2, array, stat, origin)
   type(json_object), intent(inout) :: object
   type(json_array), pointer, intent(out) :: array
   character(len=*), intent(in) :: key1, key2
   integer, intent(out) :: stat, origin

   call get_value(object, key1, array, requested=.false., &
      & stat=stat, origin=origin)
   if (stat == json_stat%missing_key .or. .not.associated(array)) then
      call get_value(object, key2, array, requested=.false., &
         & stat=stat, origin=origin)
   end if
end subroutine cjson_get_array

subroutine cjson_get_value(object, key1, key2, val, stat, origin)
   type(json_object), intent(inout) :: object
   type(json_keyval), pointer, intent(out) :: val
   character(len=*), intent(in) :: key1, key2
   integer, intent(out) :: stat, origin

   call get_value(object, key1, val, requested=.false., &
      & stat=stat, origin=origin)
   if (stat == json_stat%missing_key .or. .not.associated(val)) then
      call get_value(object, key2, val, requested=.false., &
         & stat=stat, origin=origin)
   end if
end subroutine cjson_get_value
#endif

!> Calculate the lattice vectors from a set of cell parameters
pure subroutine cell_to_dlat(cellpar, lattice)

   !> Cell parameters
   real(wp), intent(in)  :: cellpar(6)

   !> Direct lattice
   real(wp), intent(out) :: lattice(:, :)

   real(wp) :: dvol

   dvol = cell_to_dvol(cellpar)

   associate(alen => cellpar(1), blen => cellpar(2), clen => cellpar(3), &
         &   alp  => cellpar(4), bet  => cellpar(5), gam  => cellpar(6))

      lattice(1, 1) = alen
      lattice(2, 1) = 0.0_wp
      lattice(3, 1) = 0.0_wp
      lattice(3, 2) = 0.0_wp
      lattice(1, 2) = blen*cos(gam)
      lattice(2, 2) = blen*sin(gam)
      lattice(1, 3) = clen*cos(bet)
      lattice(2, 3) = clen*(cos(alp) - cos(bet)*cos(gam))/sin(gam);
      lattice(3, 3) = dvol/(alen*blen*sin(gam))

   end associate

end subroutine cell_to_dlat


!> Calculate the cell volume from a set of cell parameters
pure function cell_to_dvol(cellpar) result(dvol)

   !> Cell parameters
   real(wp), intent(in) :: cellpar(6)

   !> Cell volume
   real(wp) :: dvol

   real(wp) :: vol2

   associate(alen => cellpar(1), blen => cellpar(2), clen => cellpar(3), &
         &   alp  => cellpar(4), bet  => cellpar(5), gam  => cellpar(6) )

      vol2 = 1.0_wp - cos(alp)**2 - cos(bet)**2 - cos(gam)**2 &
         & + 2.0_wp*cos(alp)*cos(bet)*cos(gam)

      dvol = sqrt(abs(vol2))*alen*blen*clen
      ! return negative volume instead of imaginary one (means bad cell parameters)
      if (vol2 < 0.0_wp) dvol = -dvol ! this should not happen, but who knows...

   end associate
end function cell_to_dvol


end module mctc_io_read_cjson

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

module test_dftd4
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type, new
   use mstore, only : get_structure
   use dftd4
   implicit none
   private

   public :: collect_dftd4

   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))
   real(wp), parameter :: smooth_diff_thr = 1.0e-10_wp


contains


!> Collect all exported unit tests
subroutine collect_dftd4(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("PBE-D4", test_pbed4_mb01), &
      & new_unittest("PBE-D4-EEQBC", test_pbed4_eeqbc_mb01), &
      & new_unittest("PBE-D4S", test_pbed4s_mb01), &
      & new_unittest("PBE-D4S-EEQBC", test_pbed4s_eeqbc_mb01), &
      & new_unittest("B97-D4", test_b97d4_mb02), &
      & new_unittest("B97-D4S", test_b97d4s_mb02), &
      & new_unittest("TPSS-D4", test_tpssd4_mb03), &
      & new_unittest("TPSS-D4S", test_tpssd4s_mb03), &
      & new_unittest("PWPB95-D4", test_pwpb95d4_mb04), &
      & new_unittest("PWPB95-D4S", test_pwpb95d4s_mb04), &
      & new_unittest("B2PLYP-D4", test_b2plypd4_mb05), &
      & new_unittest("B2PLYP-D4S", test_b2plypd4s_mb05), &
      & new_unittest("PW6B95-D4", test_pw6b95d4_mb06), &
      & new_unittest("PW6B95-D4S", test_pw6b95d4s_mb06), &
      & new_unittest("OLYP-D4", test_olypd4_mb07), &
      & new_unittest("OLYP-D4S", test_olypd4s_mb07), &
      & new_unittest("PBE0-D4", test_pbe0d4_mb08), &
      & new_unittest("PBE0-D4S", test_pbe0d4s_mb08), &
      & new_unittest("RPBE-D4-ATM", test_rpbed4atm_mb09), &
      & new_unittest("RPBE-D4S-ATM", test_rpbed4satm_mb09), &
      & new_unittest("B2GPPLYP-D4-ATM", test_b2gpplypd4atm_mb10), &
      & new_unittest("B2GPPLYP-D4S-ATM", test_b2gpplypd4satm_mb10), &
      & new_unittest("LH14t-calPBE-D4-ATM", test_lh14tcalpbed4atm_mb11), &
      & new_unittest("LH14t-calPBE-D4S-ATM", test_lh14tcalpbed4satm_mb11), &
      & new_unittest("B1B95-D4-ATM", test_b1b95d4atm_mb12), &
      & new_unittest("B1B95-D4S-ATM", test_b1b95d4satm_mb12), &
      & new_unittest("M06L-D4-ATM", test_m06ld4atm_mb13), &
      & new_unittest("M06L-D4S-ATM", test_m06ld4satm_mb13), &
      & new_unittest("TPSSh-D4-ATM", test_tpsshd4atm_mb14), &
      & new_unittest("TPSSh-D4S-ATM", test_tpsshd4satm_mb14), &
      & new_unittest("HF-D4-ATM", test_hfd4atm_mb15), &
      & new_unittest("HF-D4S-ATM", test_hfd4satm_mb15), &
      & new_unittest("CAM-B3LYP-D4-ATM", test_camb3lypd4atm_mb16), &
      & new_unittest("CAM-B3LYP-D4S-ATM", test_camb3lypd4satm_mb16), &
      & new_unittest("r2SCAN-3c", test_r2scan3c_mb01), &
      & new_unittest("r2SCAN-3c-D4S", test_r2scan3c_d4s_mb01), &
      & new_unittest("TPSSh-D4-ATM-AmF3", test_tpsshd4atm_amf3), &
      & new_unittest("TPSSh-D4S-ATM-AmF3", test_tpsshd4satm_amf3), &
      & new_unittest("smooth cutoff", test_smooth_cutoff), &
      & new_unittest("Actinides-D4", test_actinides_d4), &
      & new_unittest("Actinides-D4S", test_actinides_d4s) &
      & ]

end subroutine collect_dftd4


subroutine test_dftd4_gen(error, mol, d4, param, ref)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Dispersion model
   class(dispersion_model), intent(in) :: d4

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Expected dispersion energy
   real(wp), intent(in) :: ref

   real(wp) :: energy

   call get_dispersion(mol, d4, param, realspace_cutoff(), energy)

   call check(error, energy, ref, thr=thr)
   if (allocated(error)) then
      call test_failed(error, "Dispersion energy does not match")
      print*,energy
   end if

end subroutine test_dftd4_gen


subroutine test_numgrad(error, mol, d4, param, cutoff)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Dispersion model
   class(dispersion_model), intent(in) :: d4

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Realspace cutoffs
   type(realspace_cutoff), intent(in), optional :: cutoff

   integer :: iat, ic
   real(wp) :: energy, er, el, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :), numgrad(:, :)
   type(realspace_cutoff) :: cutoff_
   real(wp), parameter :: step = 1.0e-6_wp

   cutoff_ = realspace_cutoff()
   if (present(cutoff)) cutoff_ = cutoff

   allocate(gradient(3, mol%nat), numgrad(3, mol%nat))

   do iat = 1, mol%nat
      do ic = 1, 3
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call get_dispersion(mol, d4, param, cutoff_, er)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2*step
         call get_dispersion(mol, d4, param, cutoff_, el)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         numgrad(ic, iat) = 0.5_wp*(er - el)/step
      end do
   end do

   call get_dispersion(mol, d4, param, cutoff_, energy, gradient, sigma)

   if (any(abs(gradient - numgrad) > thr2)) then
      call test_failed(error, "Gradient of dispersion energy does not match")
      print'(3es21.14)', gradient-numgrad
   end if

end subroutine test_numgrad


subroutine test_numsigma(error, mol, d4, param, cutoff)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Dispersion model
   class(dispersion_model), intent(in) :: d4

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Realspace cutoffs
   type(realspace_cutoff), intent(in), optional :: cutoff

   integer :: ic, jc
   real(wp) :: energy, er, el, sigma(3, 3), eps(3, 3), numsigma(3, 3)
   real(wp), allocatable :: gradient(:, :), xyz(:, :)
   type(realspace_cutoff) :: cutoff_
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], [3, 3])
   real(wp), parameter :: step = 1.0e-6_wp

   cutoff_ = realspace_cutoff()
   if (present(cutoff)) cutoff_ = cutoff

   allocate(gradient(3, mol%nat), xyz(3, mol%nat))

   eps(:, :) = unity
   xyz(:, :) = mol%xyz
   do ic = 1, 3
      do jc = 1, 3
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = matmul(eps, xyz)
         call get_dispersion(mol, d4, param, cutoff_, er)
         eps(jc, ic) = eps(jc, ic) - 2*step
         mol%xyz(:, :) = matmul(eps, xyz)
         call get_dispersion(mol, d4, param, cutoff_, el)
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = xyz
         numsigma(jc, ic) = 0.5_wp*(er - el)/step
      end do
   end do

   call get_dispersion(mol, d4, param, cutoff_, energy, gradient, sigma)

   if (any(abs(sigma - numsigma) > thr2)) then
      call test_failed(error, "Strain derivatives do not match")
      print'(3es21.14)', sigma-numsigma
   end if

end subroutine test_numsigma


subroutine test_smooth_cutoff(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 0.95948085_wp, a1 = 0.38574991_wp, a2 = 4.80688534_wp)
   type(realspace_cutoff) :: sharp, smooth
   real(wp) :: esharp, esmooth
   real(wp), allocatable :: pair2(:, :), pair3(:, :)

   call get_structure(mol, "MB16-43", "01")
   call new_d4_model(error, d4, mol)
   if (allocated(error)) return

   sharp = realspace_cutoff(disp2=8.0_wp, disp3=8.0_wp)
   smooth = realspace_cutoff(disp2=8.0_wp, disp3=8.0_wp, &
      & width2=4.0_wp, width3=4.0_wp)

   call get_dispersion(mol, d4, param, sharp, esharp)
   call get_dispersion(mol, d4, param, smooth, esmooth)

   if (abs(esharp - esmooth) < smooth_diff_thr) then
      call test_failed(error, "Smooth cutoff does not change dispersion energy")
      return
   end if

   allocate(pair2(mol%nat, mol%nat), pair3(mol%nat, mol%nat))
   call get_pairwise_dispersion(mol, d4, param, smooth, pair2, pair3)
   call check(error, sum(pair2) + sum(pair3), esmooth, thr=thr2)
   if (allocated(error)) then
      call test_failed(error, "Smooth pairwise dispersion does not match energy")
      return
   end if

   call test_numgrad(error, mol, d4, param, smooth)
   if (allocated(error)) return

   call test_numsigma(error, mol, d4, param, smooth)

end subroutine test_smooth_cutoff


subroutine test_pbed4_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 0.95948085_wp, a1 = 0.38574991_wp, a2 = 4.80688534_wp)

   call get_structure(mol, "MB16-43", "01")
   call new_d4_model(error, d4, mol)
   call test_dftd4_gen(error, mol, d4, param, -1.8578752883363366E-002_wp)

end subroutine test_pbed4_mb01

subroutine test_pbed4_eeqbc_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 0.95948085_wp, a1 = 0.38574991_wp, a2 = 4.80688534_wp)

   call get_structure(mol, "MB16-43", "01")
   call new_d4_model(error, d4, mol, qmod=d4_qmod%eeqbc)
   call test_dftd4_gen(error, mol, d4, param, -1.7931287092741860E-002_wp)

end subroutine test_pbed4_eeqbc_mb01

subroutine test_pbed4s_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 0.95948085_wp, a1 = 0.38574991_wp, a2 = 4.80688534_wp)

   call get_structure(mol, "MB16-43", "01")
   call new_d4s_model(error, d4s, mol)
   call test_dftd4_gen(error, mol, d4s, param, -1.9870451633183694E-002_wp)

end subroutine test_pbed4s_mb01

subroutine test_pbed4s_eeqbc_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 0.95948085_wp, a1 = 0.38574991_wp, a2 = 4.80688534_wp)

   call get_structure(mol, "MB16-43", "01")
   call new_d4s_model(error, d4s, mol, qmod=d4_qmod%eeqbc)
   call test_dftd4_gen(error, mol, d4s, param, -1.9357638452866848E-002_wp)

end subroutine test_pbed4s_eeqbc_mb01

subroutine test_b97d4_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 1.69460052_wp, a1 = 0.28904684_wp, a2 = 4.13407323_wp)

   call get_structure(mol, "MB16-43", "02")
   call new_d4_model(error, d4, mol)
   call test_dftd4_gen(error, mol, d4, param, -8.9181168937810723E-002_wp)

end subroutine test_b97d4_mb02

subroutine test_b97d4s_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 1.69460052_wp, a1 = 0.28904684_wp, a2 = 4.13407323_wp)

   call get_structure(mol, "MB16-43", "02")
   call new_d4s_model(error, d4s, mol)
   call test_dftd4_gen(error, mol, d4s, param, -0.10354699373838475_wp)

end subroutine test_b97d4s_mb02

subroutine test_tpssd4_mb03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 1.91130849_wp, a1 = 0.43332851_wp, a2 = 4.56986797_wp)

   call get_structure(mol, "MB16-43", "03")
   call new_d4_model(error, d4, mol)
   call test_dftd4_gen(error, mol, d4, param, -2.4695638764787930E-002_wp)

end subroutine test_tpssd4_mb03

subroutine test_tpssd4s_mb03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 1.91130849_wp, a1 = 0.43332851_wp, a2 = 4.56986797_wp)

   call get_structure(mol, "MB16-43", "03")
   call new_d4s_model(error, d4s, mol)
   call test_dftd4_gen(error, mol, d4s, param, -2.9321970435591389E-002_wp)

end subroutine test_tpssd4s_mb03

subroutine test_pwpb95d4_mb04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 0.82_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = -0.34639127_wp, a1 = 0.41080636_wp, a2 = 3.83878274_wp)

   call get_structure(mol, "MB16-43", "04")
   call new_d4_model(error, d4, mol)
   call test_dftd4_gen(error, mol, d4, param, -9.5128100471706181E-003_wp)

end subroutine test_pwpb95d4_mb04

subroutine test_pwpb95d4s_mb04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 0.82_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = -0.34639127_wp, a1 = 0.41080636_wp, a2 = 3.83878274_wp)

   call get_structure(mol, "MB16-43", "04")
   call new_d4s_model(error, d4s, mol)
   call test_dftd4_gen(error, mol, d4s, param, -1.0003412660121589E-002_wp)

end subroutine test_pwpb95d4s_mb04

subroutine test_b2plypd4_mb05(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 0.64_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 1.15117773_wp, a1 = 0.42666167_wp, a2 = 4.73635790_wp)

   call get_structure(mol, "MB16-43", "05")
   call new_d4_model(error, d4, mol)
   call test_numgrad(error, mol, d4, param)

end subroutine test_b2plypd4_mb05

subroutine test_b2plypd4s_mb05(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 0.64_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 1.15117773_wp, a1 = 0.42666167_wp, a2 = 4.73635790_wp)

   call get_structure(mol, "MB16-43", "05")
   call new_d4s_model(error, d4s, mol)
   call test_numgrad(error, mol, d4s, param)

end subroutine test_b2plypd4s_mb05

subroutine test_pw6b95d4_mb06(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = -0.31629935_wp, a1 = 0.03999357_wp, a2 = 5.83690254_wp)

   call get_structure(mol, "MB16-43", "06")
   call new_d4_model(error, d4, mol)
   call test_numgrad(error, mol, d4, param)

end subroutine test_pw6b95d4_mb06

subroutine test_pw6b95d4s_mb06(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = -0.31629935_wp, a1 = 0.03999357_wp, a2 = 5.83690254_wp)

   call get_structure(mol, "MB16-43", "06")
   call new_d4s_model(error, d4s, mol)
   call test_numgrad(error, mol, d4s, param)

end subroutine test_pw6b95d4s_mb06

subroutine test_olypd4_mb07(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 2.74836820_wp, a1 = 0.60184498_wp, a2 = 2.53292167_wp)

   call get_structure(mol, "MB16-43", "07")
   call new_d4_model(error, d4, mol)
   call test_numgrad(error, mol, d4, param)

end subroutine test_olypd4_mb07

subroutine test_olypd4s_mb07(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 2.74836820_wp, a1 = 0.60184498_wp, a2 = 2.53292167_wp)

   call get_structure(mol, "MB16-43", "07")
   call new_d4s_model(error, d4s, mol)
   call test_numgrad(error, mol, d4s, param)

end subroutine test_olypd4s_mb07


subroutine test_pbe0d4_mb08(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 1.20065498_wp, a1 = 0.40085597_wp, a2 = 5.02928789_wp)

   call get_structure(mol, "MB16-43", "08")
   call new_d4_model(error, d4, mol)
   call test_numsigma(error, mol, d4, param)

end subroutine test_pbe0d4_mb08

subroutine test_pbe0d4s_mb08(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 1.20065498_wp, a1 = 0.40085597_wp, a2 = 5.02928789_wp)

   call get_structure(mol, "MB16-43", "08")
   call new_d4s_model(error, d4s, mol)
   call test_numsigma(error, mol, d4s, param)

end subroutine test_pbe0d4s_mb08


subroutine test_rpbed4atm_mb09(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.31183787_wp, a1 = 0.46169493_wp, a2 = 3.15711757_wp)

   call get_structure(mol, "MB16-43", "09")
   call new_d4_model(error, d4, mol)
   call test_dftd4_gen(error, mol, d4, param, -4.5140422485299259E-002_wp)

end subroutine test_rpbed4atm_mb09

subroutine test_rpbed4satm_mb09(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.31183787_wp, a1 = 0.46169493_wp, a2 = 3.15711757_wp)

   call get_structure(mol, "MB16-43", "09")
   call new_d4s_model(error, d4s, mol)
   call test_dftd4_gen(error, mol, d4s, param, -4.7626123029052128E-002_wp)

end subroutine test_rpbed4satm_mb09


subroutine test_b2gpplypd4atm_mb10(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 0.56_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 0.94633372_wp, a1 = 0.42907301_wp, a2 = 5.18802602_wp)

   call get_structure(mol, "MB16-43", "10")
   call new_d4_model(error, d4, mol)
   call test_dftd4_gen(error, mol, d4, param, -9.6812427202205668E-003_wp)

end subroutine test_b2gpplypd4atm_mb10

subroutine test_b2gpplypd4satm_mb10(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 0.56_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 0.94633372_wp, a1 = 0.42907301_wp, a2 = 5.18802602_wp)

   call get_structure(mol, "MB16-43", "10")
   call new_d4s_model(error, d4s, mol)
   call test_dftd4_gen(error, mol, d4s, param, -1.1490632914927183E-002_wp)

end subroutine test_b2gpplypd4satm_mb10

subroutine test_lh14tcalpbed4atm_mb11(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.27677253_wp, a1 = 0.38128670_wp, a2 = 4.91698883_wp)

   call get_structure(mol, "MB16-43", "11")
   call new_d4_model(error, d4, mol)
   call test_dftd4_gen(error, mol, d4, param, -1.7460015867914524E-002_wp)

end subroutine test_lh14tcalpbed4atm_mb11

subroutine test_lh14tcalpbed4satm_mb11(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.27677253_wp, a1 = 0.38128670_wp, a2 = 4.91698883_wp)

   call get_structure(mol, "MB16-43", "11")
   call new_d4s_model(error, d4s, mol)
   call test_dftd4_gen(error, mol, d4s, param, -2.0329508047867848E-002_wp)

end subroutine test_lh14tcalpbed4satm_mb11

subroutine test_b1b95d4atm_mb12(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.27701162_wp, a1 = 0.40554715_wp, a2 = 4.63323074_wp)

   call get_structure(mol, "MB16-43", "12")
   call new_d4_model(error, d4, mol)
   call test_dftd4_gen(error, mol, d4, param, -2.5712178361964221E-002_wp)

end subroutine test_b1b95d4atm_mb12

subroutine test_b1b95d4satm_mb12(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.27701162_wp, a1 = 0.40554715_wp, a2 = 4.63323074_wp)

   call get_structure(mol, "MB16-43", "12")
   call new_d4s_model(error, d4s, mol)
   call test_dftd4_gen(error, mol, d4s, param, -2.6528352555725724E-002_wp)

end subroutine test_b1b95d4satm_mb12


subroutine test_m06ld4atm_mb13(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 0.59493760_wp, a1 = 0.71422359_wp, a2 = 6.35314182_wp)

   call get_structure(mol, "MB16-43", "13")
   call new_d4_model(error, d4, mol)
   call test_numgrad(error, mol, d4, param)

end subroutine test_m06ld4atm_mb13

subroutine test_m06ld4satm_mb13(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 0.59493760_wp, a1 = 0.71422359_wp, a2 = 6.35314182_wp)

   call get_structure(mol, "MB16-43", "13")
   call new_d4s_model(error, d4s, mol)
   call test_numgrad(error, mol, d4s, param)

end subroutine test_m06ld4satm_mb13

subroutine test_tpsshd4atm_mb14(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.85897750_wp, a1 = 0.44286966_wp, a2 = 4.60230534_wp)

   call get_structure(mol, "MB16-43", "14")
   call new_d4_model(error, d4, mol)
   call test_numgrad(error, mol, d4, param)

end subroutine test_tpsshd4atm_mb14

subroutine test_tpsshd4satm_mb14(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.85897750_wp, a1 = 0.44286966_wp, a2 = 4.60230534_wp)

   call get_structure(mol, "MB16-43", "14")
   call new_d4s_model(error, d4s, mol)
   call test_numgrad(error, mol, d4s, param)

end subroutine test_tpsshd4satm_mb14

subroutine test_hfd4atm_mb15(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.61679827_wp, a1 = 0.44959224_wp, a2 = 3.35743605_wp)

   call get_structure(mol, "MB16-43", "15")
   call new_d4_model(error, d4, mol)
   call test_numgrad(error, mol, d4, param)

end subroutine test_hfd4atm_mb15

subroutine test_hfd4satm_mb15(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.61679827_wp, a1 = 0.44959224_wp, a2 = 3.35743605_wp)

   call get_structure(mol, "MB16-43", "15")
   call new_d4s_model(error, d4s, mol)
   call test_numgrad(error, mol, d4s, param)

end subroutine test_hfd4satm_mb15

subroutine test_camb3lypd4atm_mb16(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.74407961_wp, a1 = 0.40137870_wp, a2 = 5.18731225_wp)

   call get_structure(mol, "MB16-43", "16")
   call new_d4_model(error, d4, mol)
   call test_numsigma(error, mol, d4, param)

end subroutine test_camb3lypd4atm_mb16

subroutine test_camb3lypd4satm_mb16(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.74407961_wp, a1 = 0.40137870_wp, a2 = 5.18731225_wp)

   call get_structure(mol, "MB16-43", "16")
   call new_d4s_model(error, d4s, mol)
   call test_numsigma(error, mol, d4s, param)

end subroutine test_camb3lypd4satm_mb16

subroutine test_r2scan3c_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.00_wp, s9 = 2.00_wp, alp = 16.0_wp, &
      & s8 = 0.00_wp, a1 = 0.42_wp, a2 = 5.65_wp)
   
   real(wp), parameter :: ref = -5.7825025556386862E-003_wp

   call get_structure(mol, "MB16-43", "01")
   call new_d4_model(error, d4, mol, ga=2.0_wp, gc=1.0_wp)
   call test_dftd4_gen(error, mol, d4, param, ref)

end subroutine test_r2scan3c_mb01

subroutine test_r2scan3c_d4s_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.00_wp, s9 = 2.00_wp, alp = 16.0_wp, &
      & s8 = 0.00_wp, a1 = 0.42_wp, a2 = 5.65_wp)
   
   real(wp), parameter :: ref = -6.1176284425895639E-003_wp

   call get_structure(mol, "MB16-43", "01")
   call new_d4s_model(error, d4s, mol, ga=2.0_wp, gc=1.0_wp)
   call test_dftd4_gen(error, mol, d4s, param, ref)

end subroutine test_r2scan3c_d4s_mb01


subroutine test_tpsshd4atm_amf3(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.85897750_wp, a1 = 0.44286966_wp, a2 = 4.60230534_wp)

   real(wp), parameter :: ref = -2.4882226918209061E-003_wp

   integer, parameter :: nat = 4
   integer, parameter :: num(nat) = [95, 9, 9, 9]
   real(wp), parameter :: xyz(3, nat) = reshape([ &
      & -1.13163973200000_wp, -2.17446990100000_wp, +1.10012477100000_wp, &
      & -4.66377948900000_wp, -3.12947883400000_wp, -0.36987606800000_wp, &
      & -0.19032564300000_wp, +1.36339950600000_wp, -0.36521789300000_wp, &
      & +1.46283310800000_wp, -4.75734549200000_wp, -0.36503081000000_wp],&
      & [3, nat])

   call new(mol, num, xyz)
   call new_d4_model(error, d4, mol)

   call test_dftd4_gen(error, mol, d4, param, ref)
   if (allocated(error)) return

   call test_numgrad(error, mol, d4, param)
   if (allocated(error)) return

   call test_numsigma(error, mol, d4, param)

end subroutine test_tpsshd4atm_amf3

subroutine test_tpsshd4satm_amf3(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 16.0_wp, &
      & s8 = 1.85897750_wp, a1 = 0.44286966_wp, a2 = 4.60230534_wp)

   real(wp), parameter :: ref = -2.5523952752362009E-003_wp

   integer, parameter :: nat = 4
   integer, parameter :: num(nat) = [95, 9, 9, 9]
   real(wp), parameter :: xyz(3, nat) = reshape([ &
      & -1.13163973200000_wp, -2.17446990100000_wp, +1.10012477100000_wp, &
      & -4.66377948900000_wp, -3.12947883400000_wp, -0.36987606800000_wp, &
      & -0.19032564300000_wp, +1.36339950600000_wp, -0.36521789300000_wp, &
      & +1.46283310800000_wp, -4.75734549200000_wp, -0.36503081000000_wp],&
      & [3, nat])

   call new(mol, num, xyz)
   call new_d4s_model(error, d4s, mol)

   call test_dftd4_gen(error, mol, d4s, param, ref)
   if (allocated(error)) return

   call test_numgrad(error, mol, d4s, param)
   if (allocated(error)) return

   call test_numsigma(error, mol, d4s, param)

end subroutine test_tpsshd4satm_amf3

subroutine test_actinides_d4(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4_model) :: d4
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 0.95948085_wp, a1 = 0.38574991_wp, a2 = 4.80688534_wp)

   real(wp), parameter :: ref = -0.17966420554540324_wp
   
   integer, parameter :: nat = 17
   integer, parameter :: num(nat) = [&
      & 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103]
   real(wp), parameter :: xyz(3, nat) = reshape([ &
      & 0.98692316414074_wp, 6.12727238368797_wp,-6.67861597188102_wp, &
      & 3.63898862390869_wp, 5.12109301182962_wp, 3.01908613326278_wp, &
      & 5.14503571563551_wp,-3.97172984617710_wp, 3.82011791828867_wp, &
      & 6.71986847575494_wp, 1.71382138402812_wp, 3.92749159076307_wp, &
      & 4.13783589704826_wp,-2.10695793491818_wp, 0.19753203068899_wp, &
      & 8.97685097698326_wp,-3.08813636191844_wp,-4.45568615593938_wp, &
      & 12.5486412940776_wp,-1.77128765259458_wp, 0.59261498922861_wp, &
      & 7.82051475868325_wp,-3.97159756604558_wp,-0.53637703616916_wp, &
      &-0.43444574624893_wp,-1.69696511583960_wp,-1.65898182093050_wp, &
      &-4.71270645149099_wp,-0.11534827468942_wp, 2.84863373521297_wp, &
      &-2.52061680335614_wp, 1.82937752749537_wp,-2.10366982879172_wp, &
      & 0.13551154616576_wp, 7.99805359235043_wp,-1.55508522619903_wp, &
      & 3.91594542499717_wp,-1.72975169129597_wp,-5.07944366756113_wp, &
      &-1.03393930231679_wp, 4.69307230054046_wp, 0.02656940927472_wp, &
      & 6.20675384557240_wp, 4.24490721493632_wp,-0.71004195169885_wp, &
      & 7.04586341131562_wp, 5.20053667939076_wp,-7.51972863675876_wp, &
      & 2.01082807362334_wp, 1.34838807211157_wp,-4.70482633508447_wp],&
      & [3, nat])

   call new(mol, num, xyz)
   call new_d4_model(error, d4, mol)
   call test_dftd4_gen(error, mol, d4, param, ref)

end subroutine test_actinides_d4

subroutine test_actinides_d4s(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(d4s_model) :: d4s
   type(rational_damping_param) :: param = rational_damping_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 16.0_wp, &
      & s8 = 0.95948085_wp, a1 = 0.38574991_wp, a2 = 4.80688534_wp)

   real(wp), parameter :: ref = -0.18578133252612403_wp
   
   integer, parameter :: nat = 17
   integer, parameter :: num(nat) = [&
      & 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103]
   real(wp), parameter :: xyz(3, nat) = reshape([ &
      & 0.98692316414074_wp, 6.12727238368797_wp,-6.67861597188102_wp, &
      & 3.63898862390869_wp, 5.12109301182962_wp, 3.01908613326278_wp, &
      & 5.14503571563551_wp,-3.97172984617710_wp, 3.82011791828867_wp, &
      & 6.71986847575494_wp, 1.71382138402812_wp, 3.92749159076307_wp, &
      & 4.13783589704826_wp,-2.10695793491818_wp, 0.19753203068899_wp, &
      & 8.97685097698326_wp,-3.08813636191844_wp,-4.45568615593938_wp, &
      & 12.5486412940776_wp,-1.77128765259458_wp, 0.59261498922861_wp, &
      & 7.82051475868325_wp,-3.97159756604558_wp,-0.53637703616916_wp, &
      &-0.43444574624893_wp,-1.69696511583960_wp,-1.65898182093050_wp, &
      &-4.71270645149099_wp,-0.11534827468942_wp, 2.84863373521297_wp, &
      &-2.52061680335614_wp, 1.82937752749537_wp,-2.10366982879172_wp, &
      & 0.13551154616576_wp, 7.99805359235043_wp,-1.55508522619903_wp, &
      & 3.91594542499717_wp,-1.72975169129597_wp,-5.07944366756113_wp, &
      &-1.03393930231679_wp, 4.69307230054046_wp, 0.02656940927472_wp, &
      & 6.20675384557240_wp, 4.24490721493632_wp,-0.71004195169885_wp, &
      & 7.04586341131562_wp, 5.20053667939076_wp,-7.51972863675876_wp, &
      & 2.01082807362334_wp, 1.34838807211157_wp,-4.70482633508447_wp],&
      & [3, nat])

   call new(mol, num, xyz)
   call new_d4s_model(error, d4s, mol)
   call test_dftd4_gen(error, mol, d4s, param, ref)

end subroutine test_actinides_d4s


end module test_dftd4

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the argument list processor.
module tblite_argument
   implicit none
   private

   public :: argument_list, len
   public :: argument_count_interface, get_argument_interface


   !> Internal representation of the command line arguments
   type :: argument
      private
      !> Actual payload of the argument
      character(len=:), allocatable :: raw
   end type argument

   !> Constructor for the argument representation
   interface argument
      module procedure :: new_argument
   end interface argument


   !> Argument list class
   type :: argument_list
      !> Name of the invoked executable, if available
      character(len=:), allocatable :: prog
      !> Number of arguments
      integer :: nargs = 0
      !> Array of arguments in this list
      type(argument), allocatable :: argv(:)
   contains
      !> Append a command line argument
      procedure :: push_back
      !> Display debug information on this instance
      procedure :: info
      !> Get command line argument
      procedure :: get
   end type argument_list

   !> Constructor for the argument list
   interface argument_list
      module procedure :: new_argument_list
   end interface argument_list

   interface len
      module procedure :: get_length
   end interface len


   abstract interface
      !> Interface of the argument counter
      function argument_count_interface() result(argument_count)
         !> Number of available arguments
         integer :: argument_count
      end function argument_count_interface

      !> Interface of the argument getter
      subroutine get_argument_interface(idx, arg)
         !> Index of the argument to retrieve, range 0 to argument_counter()
         integer, intent(in) :: idx
         !> Returned argument payload, allocation status is used to signal errors
         character(len=:), allocatable, intent(out) :: arg
      end subroutine get_argument_interface
   end interface

   !> Token identifyin response files
   character(len=*), parameter :: response_token = "@"

   !> Initial size for the resizer of the argument list
   integer, parameter :: initial_size = 20


contains


!> Create a new argument from a raw payload
pure function new_argument(raw) result(new)
   !> Raw argument value
   character(len=*), intent(in) :: raw
   !> Representation of the argument
   type(argument) :: new

   new%raw = raw
end function new_argument

!> Constructor of the argument list
function new_argument_list(argument_counter, argument_getter) result(new)
   !> Argument counter interface
   procedure(argument_count_interface), optional :: argument_counter
   !> Argument getter interface
   procedure(get_argument_interface), optional :: argument_getter
   !> Newly created argument list
   type(argument_list) :: new

   intrinsic :: present

   if (present(argument_getter) .and. present(argument_counter)) then
      call make_argument_list(new, argument_counter, argument_getter)
   else
      call make_argument_list(new, default_argument_count, get_default_argument)
   end if
end function new_argument_list

!> Internal constructor of the argument list
subroutine make_argument_list(self, argument_counter, argument_getter)
   !> Instance of the argument list to be created
   type(argument_list), intent(out) :: self
   !> Argument counter interface
   procedure(argument_count_interface) :: argument_counter
   !> Argument getter interface
   procedure(get_argument_interface) :: argument_getter

   integer :: iarg, narg, info
   character(len=:), allocatable :: arg
   intrinsic :: allocated

   info = 0
   narg = argument_counter()
   self%nargs = 0
   call resize(self%argv, narg)
   call argument_getter(0, self%prog)
   do iarg = 1, narg
      call argument_getter(iarg, arg)
      if (.not.allocated(arg)) return
      if (is_response_file(arg)) then
         call get_response_file(self, arg(2:), info)
         if (info == 0) cycle
      end if
      call push_back(self, arg)
   end do

end subroutine make_argument_list


!> Check if an argument represents a response file
pure function is_response_file(arg) result(is_resp)
   !> Argument of interest
   character(len=*), intent(in) :: arg
   !> Whether the argument could be a response file or not
   logical :: is_resp
   intrinsic :: len

   if (len(arg) > 1) then
      is_resp = arg(1:1) == response_token
   else
      is_resp = .false.
   end if
end function is_response_file

!> Recursively consume a response file and append it to the argument list
recursive subroutine get_response_file(self, resp, stat)
   !> Instance of the argument list
   class(argument_list), intent(inout) :: self
   !> Name of the response file to be appended
   character(len=*), intent(in) :: resp
   !> Status of reading the reponse file
   integer, intent(out) :: stat

   integer :: unit, info, istat
   logical :: opened
   character(len=:), allocatable :: arg

   inquire(file=resp, opened=opened)
   if (opened) then
      stat = 1
      return
   end if

   open(file=resp, unit=unit, iostat=info, status='old', action='read')
   do while(info == 0)
      call getline(unit, arg, info)
      if (info /= 0) exit
      if (is_response_file(arg)) then
         call get_response_file(self, arg(2:), istat)
         if (istat == 0) cycle
      end if
      call push_back(self, arg)
   end do
   close(unit, iostat=stat)
   if (info /= 0) then
      stat = merge(0, info, is_iostat_end(info))
   end if
end subroutine get_response_file

!> Consume a whole line from a formatted unit
subroutine getline(unit, line, iostat, iomsg)
   !> Formatted IO unit
   integer, intent(in) :: unit
   !> Line to read
   character(len=:), allocatable, intent(out) :: line
   !> Status of operation
   integer, intent(out) :: iostat
   !> Error message
   character(len=:), allocatable, optional :: iomsg

   integer, parameter :: bufsize = 512
   character(len=bufsize) :: buffer, msg
   integer :: size, stat
   intrinsic :: is_iostat_eor, present, trim

   allocate(character(len=0) :: line)
   do
      read(unit, '(a)', advance='no', iostat=stat, iomsg=msg, size=size) &
         & buffer
      if (stat > 0) exit
      line = line // buffer(:size)
      if (stat < 0) exit
   end do

   if (is_iostat_eor(stat)) stat = 0

   if (stat /= 0) then
      if (present(iomsg)) iomsg = trim(msg)
   end if
   iostat = stat

end subroutine getline


!> Append a string to the argument list
subroutine push_back(self, string)
   !> Instance of the argument list
   class(argument_list), intent(inout) :: self
   !> String representing the argument
   character(len=*), intent(in) :: string
   intrinsic :: size

   self%nargs = self%nargs + 1
   if (self%nargs > size(self%argv)) call resize(self%argv)
   self%argv(self%nargs) = argument(string)

end subroutine push_back

!> Reallocate list of arguments
pure subroutine resize(list, n)
   !> Instance of the array to be resized
   type(argument), allocatable, intent(inout) :: list(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(argument), allocatable :: tmp(:)
   integer :: this_size, new_size, iv
   intrinsic :: allocated, size, move_alloc, present, min

   if (allocated(list)) then
      this_size = size(list, 1)
      call move_alloc(list, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(list(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(list, 1))
      do iv = 1, this_size
         call move_alloc(tmp(iv)%raw, list(iv)%raw)
      end do
      deallocate(tmp)
   end if
end subroutine resize


!> Display debug information on an argument list instance
subroutine info(self, unit)
   !> Instance of the argument list
   class(argument_list), intent(in) :: self
   !> Formatted unit for output
   integer, intent(in) :: unit

   character(len=*), parameter :: fmt = '("#", *(1x, g0))'
   integer :: iarg
   intrinsic :: allocated

   if (allocated(self%prog)) then
      write(unit, fmt) self%prog
   end if

   if (allocated(self%argv)) then
      write(unit, fmt) self%nargs, "arguments provided"
      do iarg = 1, self%nargs
         write(unit, fmt) iarg, "/", self%nargs, "->", self%argv(iarg)%raw
      end do
   end if
end subroutine info


!> Default argument counter using the intrinsic command_argument_count procedure
function default_argument_count() result(argument_count)
   !> Number of available arguments
   integer :: argument_count

   intrinsic :: command_argument_count

   argument_count = command_argument_count()
end function default_argument_count

!> Default argument getter using the intrinsic get_command_argument procedure
subroutine get_default_argument(idx, arg)
   !> Index of the argument to retrieve, range 0 to argument_counter()
   integer, intent(in) :: idx
   !> Returned argument payload, allocation status is used to signal errors
   character(len=:), allocatable, intent(out) :: arg

   integer :: length, stat
   intrinsic :: get_command_argument

   call get_command_argument(idx, length=length, status=stat)
   if (stat /= 0) then
      return
   endif

   allocate(character(len=length) :: arg, stat=stat)
   if (stat /= 0) then
      return
   endif

   if (length > 0) then
      call get_command_argument(idx, arg, status=stat)
      if (stat /= 0) then
         deallocate(arg)
         return
      end if
   end if
end subroutine get_default_argument


pure subroutine get(self, idx, arg)
   class(argument_list), intent(in) :: self
   character(len=:), allocatable, intent(out) :: arg
   integer, intent(in) :: idx

   if (idx > 0 .and. idx <= self%nargs) arg = self%argv(idx)%raw
end subroutine get

pure function get_length(self) result(length)
   class(argument_list), intent(in) :: self
   integer :: length
   length = self%nargs
end function get_length

end module tblite_argument

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> TOML datetime value representation
!>
!> This module provides the [[toml_datetime]] type for representing TOML
!> datetime values. TOML supports four datetime formats:
!>
!> - Offset date-time: `1979-05-27T07:32:00Z`
!> - Local date-time: `1979-05-27T07:32:00`
!> - Local date: `1979-05-27`
!> - Local time: `07:32:00`
!>
!> The [[toml_datetime]] type combines [[toml_date]] and [[toml_time]]
!> components to represent any of these formats.
module tomlf_datetime
   use tomlf_constants, only : tfc
   implicit none
   private

   public :: toml_datetime, toml_time, toml_date, to_string, has_date, has_time
   public :: operator(==)


   !> TOML time value (HH:MM:SS.sssssZ...)
   type :: toml_time
      integer :: hour = -1
      integer :: minute = -1
      integer :: second = -1
      integer :: msec = -1
      character(len=:), allocatable :: zone
   end type

   interface toml_time
      module procedure :: new_toml_time
   end interface toml_time


   !> TOML date value (YYYY-MM-DD)
   type :: toml_date
      integer :: year = -1
      integer :: month = -1
      integer :: day = -1
   end type


   !> TOML datatime value type
   type :: toml_datetime
      type(toml_date) :: date
      type(toml_time) :: time
   end type


   !> Create a new TOML datetime value
   interface toml_datetime
      module procedure :: new_datetime
      module procedure :: new_datetime_from_string
   end interface toml_datetime


   interface operator(==)
      module procedure :: compare_datetime
   end interface operator(==)


   interface to_string
      module procedure :: to_string_datetime
   end interface to_string


contains


pure function new_datetime(year, month, day, hour, minute, second, msecond, zone) &
      & result(datetime)
   integer, intent(in), optional :: year
   integer, intent(in), optional :: month
   integer, intent(in), optional :: day
   integer, intent(in), optional :: hour
   integer, intent(in), optional :: minute
   integer, intent(in), optional :: second
   integer, intent(in), optional :: msecond
   character(len=*), intent(in), optional :: zone
   type(toml_datetime) :: datetime

   if (present(year) .and. present(month) .and. present(day)) then
      datetime%date%year = year
      datetime%date%month = month
      datetime%date%day = day
   end if

   if (present(hour) .and. present(minute) .and. present(second)) then
      datetime%time%hour = hour
      datetime%time%minute = minute
      datetime%time%second = second
      if (present(msecond)) then
         datetime%time%msec = msecond
      end if
      if (present(zone)) then
         datetime%time%zone = zone
      end if
   end if
end function new_datetime


pure function new_datetime_from_string(string) result(datetime)
   character(len=*), intent(in) :: string
   type(toml_datetime) :: datetime

   type(toml_date) :: date
   type(toml_time) :: time

   integer :: it, tmp, first
   character(*, tfc), parameter :: num = "0123456789"
   integer, allocatable :: msec(:)
   logical :: has_seconds

   first = 0

   if (all([string(first+5:first+5), string(first+8:first+8)] == "-")) then
      date%year = 0
      do it = first + 1, first + 4
         tmp = scan(num, string(it:it)) - 1
         if (tmp < 0) exit
         date%year = date%year * 10 + tmp
      end do

      date%month = 0
      do it = first + 6, first + 7
         tmp = scan(num, string(it:it)) - 1
         if (tmp < 0) exit
         date%month = date%month * 10 + tmp
      end do

      date%day = 0
      do it = first + 9, first + 10
         tmp = scan(num, string(it:it)) - 1
         if (tmp < 0) exit
         date%day = date%day * 10 + tmp
      end do

      first = first + 11
      datetime%date = date
   end if

   if (first >= len(string)) return
   ! Check for time: HH:MM format (colon at position 3)
   if (string(first+3:first+3) == ":") then
      time%hour = 0
      do it = first + 1, first + 2
         tmp = scan(num, string(it:it)) - 1
         if (tmp < 0) exit
         time%hour = time%hour * 10 + tmp
      end do

      time%minute = 0
      do it = first + 4, first + 5
         tmp = scan(num, string(it:it)) - 1
         if (tmp < 0) exit
         time%minute = time%minute * 10 + tmp
      end do

      has_seconds = first + 6 <= len(string) .and. string(first+6:first+6) == ":"
      if (has_seconds) then
         time%second = 0
         do it = first + 7, first + 8
            tmp = scan(num, string(it:it)) - 1
            if (tmp < 0) exit
            time%second = time%second * 10 + tmp
         end do
         first = first + 8
      else
         first = first + 5
      end if

      if (first < len(string)) then
         if (string(first+1:first+1) == ".") then
            msec = [integer::]
            do it = first + 2, len(string)
               tmp = scan(num, string(it:it)) - 1
               if (tmp < 0) exit
               msec = [msec, tmp]
            end do
            first = it - 1

            msec = [msec, 0, 0, 0, 0, 0, 0]
            time%msec = sum(msec(1:6) * [100000, 10000, 1000, 100, 10, 1])
         end if
      end if

      if (first < len(string)) then
         time%zone = ""
         do it = first + 1, len(string)
            time%zone = time%zone // string(it:it)
         end do
         if (time%zone == "z") time%zone = "Z"
      end if
      datetime%time = time
   end if

end function new_datetime_from_string


pure function to_string_datetime(datetime) result(str)
   type(toml_datetime), intent(in) :: datetime
   character(kind=tfc, len=:), allocatable :: str

   str = ""
   if (has_date(datetime)) then
      str = str // to_string_date(datetime%date)
   end if

   if (has_time(datetime)) then
      if (has_date(datetime)) then
         str = str // 'T'
      end if
      str = str // to_string_time(datetime%time)
   end if
end function to_string_datetime

pure function to_string_date(date) result(str)
   type(toml_date), intent(in) :: date
   character(:, tfc), allocatable :: str

   allocate(character(10, tfc) :: str)
   write(str, '(i4.4,"-",i2.2,"-",i2.2)') &
      &  date%year, date%month, date%day
end function to_string_date

pure function to_string_time(time) result(str)
   type(toml_time), intent(in) :: time
   character(:, tfc), allocatable :: str

   integer :: second, msec, width
   character(1), parameter :: places(6) = ["1", "2", "3", "4", "5", "6"]

   ! TOML 1.1 allows omitted seconds in the input representation, but the
   ! compliance JSON format requires canonical RFC 3339 output with seconds.
   if (time%second < 0) then
      second = 0
   else
      second = time%second
   end if

   if (time%msec < 0) then
      allocate(character(8, tfc) :: str)
      write(str, '(i2.2,":",i2.2,":",i2.2)') &
         &  time%hour, time%minute, second
   else
      width = 6
      msec = time%msec
      do while(mod(msec, 10) == 0 .and. width > 3)
         width = width - 1
         msec = msec / 10
      end do
      allocate(character(9 + width, tfc) :: str)
      write(str, '(i2.2,":",i2.2,":",i2.2,".",i'//places(width)//'.'//places(width)//')') &
         &  time%hour, time%minute, second, msec
   end if
   if (allocated(time%zone)) str = str // trim(time%zone)
end function to_string_time


pure function has_date(datetime)
   class(toml_datetime), intent(in) :: datetime
   logical :: has_date
   has_date = (datetime%date%year >= 0) .and. &
      & (datetime%date%month >= 0) .and. &
      & (datetime%date%day >= 0)
end function has_date

pure function has_time(datetime)
   class(toml_datetime), intent(in) :: datetime
   logical :: has_time
   has_time = (datetime%time%hour >= 0) .and. &
      & (datetime%time%minute >= 0)
end function has_time


!> Constructor for toml_time type, necessary due to PGI bug in NVHPC 20.7 and 20.9
elemental function new_toml_time(hour, minute, second, msec, zone) &
      & result(self)
   integer, intent(in), optional :: hour
   integer, intent(in), optional :: minute
   integer, intent(in), optional :: second
   integer, intent(in), optional :: msec
   character(len=*), intent(in), optional :: zone
   type(toml_time) :: self
   if (present(hour)) self%hour = hour
   if (present(minute)) self%minute = minute
   if (present(second)) self%second = second
   if (present(msec)) self%msec = msec
   if (present(zone)) self%zone = zone
end function new_toml_time


pure function compare_datetime(lhs, rhs) result(match)
   type(toml_datetime), intent(in) :: lhs
   type(toml_datetime), intent(in) :: rhs
   logical :: match

   match = (has_date(lhs) .eqv. has_date(rhs)) &
      & .and. (has_time(lhs) .eqv. has_time(rhs))
   if (has_date(lhs) .and. has_date(rhs)) then
      match = match .and. compare_date(lhs%date, rhs%date)
   end if

   if (has_time(lhs) .and. has_time(rhs)) then
      match = match .and. compare_time(lhs%time, rhs%time)
   end if
end function compare_datetime


pure function compare_date(lhs, rhs) result(match)
   type(toml_date), intent(in) :: lhs
   type(toml_date), intent(in) :: rhs
   logical :: match

   match = lhs%year == rhs%year .and. lhs%month == rhs%month .and. lhs%day == rhs%day
end function compare_date


pure function compare_time(lhs, rhs) result(match)
   type(toml_time), intent(in) :: lhs
   type(toml_time), intent(in) :: rhs
   logical :: match

   integer :: lms, rms

   lms = max(lhs%msec, 0)
   rms = max(rhs%msec, 0)

   match = lhs%hour == rhs%hour .and. lhs%minute == rhs%minute .and. lhs%second == rhs%second &
      & .and. lms == rms .and. allocated(lhs%zone) .eqv. allocated(rhs%zone)

   if (allocated(lhs%zone) .and. allocated(rhs%zone)) then
      match = match .and. lhs%zone == rhs%zone
   end if
end function compare_time


end module tomlf_datetime

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

#include "mctc/defs.h"

module mctc_io_read_pymatgen
   use mctc_env_accuracy, only : wp
   use mctc_env_error, only : error_type, fatal_error
   use mctc_io_structure, only : structure_type, new
   use mctc_io_symbols, only : to_number, symbol_length
   use mctc_io_utils, only : to_string
   use mctc_io_convert, only : aatoau
#if WITH_JSON
   use jonquil, only : json_value, json_object, json_array, json_keyval, &
      & json_load, json_error, json_context, json_stat, get_value, &
      & json_parser_config, json_context, cast_to_object, len
#endif
   implicit none
   private

   public :: read_pymatgen

#if WITH_JSON
   interface read_pymatgen
      module procedure read_pymatgen
      module procedure load_pymatgen
   end interface read_pymatgen
#endif


contains


subroutine read_pymatgen(self, unit, error)

   !> Instance of the molecular structure data
   type(structure_type), intent(out) :: self

   !> File handle
   integer, intent(in) :: unit

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

#if WITH_JSON
   class(json_value), allocatable :: root
   type(json_object), pointer :: object
   type(json_error), allocatable :: parse_error
   type(json_context) :: ctx

   call json_load(root, unit, config=json_parser_config(context_detail=1), &
      & context=ctx, error=parse_error)
   if (allocated(parse_error)) then
      allocate(error)
      call move_alloc(parse_error%message, error%message)
      return
   end if
   object => cast_to_object(root)
   if (.not.associated(object)) then
      call fatal_error(error, ctx%report("Invalid JSON object", root%origin, "Expected JSON object"))
      return
   end if

   call load_pymatgen(self, object, ctx, error)
#else
   call fatal_error(error, "JSON support not enabled")
#endif
end subroutine read_pymatgen


#if WITH_JSON
subroutine load_pymatgen(self, object, ctx, error)

   !> Instance of the molecular structure data
   type(structure_type), intent(out) :: self

   !> JSON object representing the structure
   type(json_object), intent(inout) :: object

   !> JSON context for error reporting
   type(json_context), intent(inout) :: ctx

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(json_object), pointer :: child
   type(json_array), pointer :: array, child_array
   type(json_keyval), pointer :: val

   integer :: stat, origin, multiplicity, iat, ilt
   character(len=:), allocatable :: symbol, module_name, class_name
   character(len=symbol_length), allocatable :: sym(:)
   logical :: periodic
   real(wp) :: charge
   real(wp), allocatable :: xyz(:, :), lattice(:, :), vec(:)

   call get_value(object, "@module", module_name, stat=stat, origin=origin)
   if (stat /= json_stat%success .or. .not.allocated(module_name)) then
      call fatal_error(error, ctx%report("Could not read module name", origin=origin))
      return
   end if
   call get_value(object, "@class", class_name, stat=stat, origin=origin)
   if (stat /= json_stat%success .or. .not.allocated(class_name)) then
      call fatal_error(error, ctx%report("Could not read class name", origin=origin))
      return
   end if

   if (module_name /= "pymatgen.core.structure") then
      call get_value(object, "@module", val, requested=.false.)
      call fatal_error(error, ctx%report("Invalid pymatgen object", origin=val%origin_value, &
         & label="Expected pymatgen.core.structure"))
      return
   end if

   if (class_name /= "Structure" .and. class_name /= "Molecule") then
      call get_value(object, "@class", val, requested=.false.)
      call fatal_error(error, ctx%report("Invalid pymatgen object", origin=val%origin_value, &
         & label="Expected Structure or Molecule"))
      return
   end if
   periodic = class_name == "Structure"

   call get_value(object, "charge", charge, default=0.0_wp, stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read charge", origin=origin, &
         & label="Expected integer value"))
      return
   end if

   if (.not.periodic) then
      call get_value(object, "spin_multiplicity", multiplicity, default=1, &
         & stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read spin multiplicity", origin=origin, &
            & label="Expected integer value"))
         return
      end if
      if (multiplicity < 1) then
         call get_value(object, "spin_multiplicity", val, requested=.false.)
         call fatal_error(error, ctx%report("Invalid spin multiplicity", &
            & origin=val%origin_value, label="Expected integer value >= 1"))
         return
      end if
   else
      charge = 0
      multiplicity = 1
   end if

   call get_value(object, "sites", array, stat=stat, origin=origin)
   if (stat /= json_stat%success) then
      call fatal_error(error, ctx%report("Could not read sites", origin=origin, &
         & label="Expected array of sites"))
      return
   end if

   allocate(sym(len(array)))
   allocate(xyz(3, len(array)))

   do iat = 1, len(array)
      call get_value(array, iat, child, stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read site", origin=origin))
         return
      end if

      call get_value(child, "label", symbol, stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read site label", origin=origin, &
            & label="Expected string value"))
         return
      end if
      sym(iat) = symbol

      call get_value(child, "xyz", child_array, stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read site coordinates", origin=origin, &
            & label="Expected array of coordinates"))
         return
      end if
      call get_value(child_array, vec, stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read site coordinates", origin=origin, &
            & label="Expected array of coordinates"))
         return
      end if
      if (size(vec) /= 3) then
         call fatal_error(error, ctx%report("Invalid site coordinates size", origin=child_array%origin, &
            & label="Expected 3 coordinates"))
         return
      end if
      xyz(:, iat) = vec * aatoau
   end do

   if (periodic) then
      allocate(lattice(3, 3))
      call get_value(object, "lattice", child, stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read lattice", origin=origin, &
            & label="Expected lattice object"))
         return
      end if

      call get_value(child, "matrix", array, stat=stat, origin=origin)
      if (stat /= json_stat%success) then
         call fatal_error(error, ctx%report("Could not read lattice matrix", origin=origin, &
            & label="Expected array of lattice vectors"))
         return
      end if
      if (len(array) /= 3) then
         call fatal_error(error, ctx%report("Invalid lattice matrix size", origin=origin, &
            & label="Expected 3x3 matrix"))
         return
      end if

      do ilt = 1, 3
         call get_value(array, ilt, child_array, stat=stat, origin=origin)
         if (stat /= json_stat%success) then
            call fatal_error(error, ctx%report("Could not read lattice vector", origin=origin))
            return
         end if
         call get_value(child_array, vec, stat=stat, origin=origin)
         if (stat /= json_stat%success) then
            call fatal_error(error, ctx%report("Could not read lattice vector", origin=origin, &
               & label="Expected array of coordinates"))
            return
         end if
         if (size(vec) /= 3) then
            call fatal_error(error, ctx%report("Invalid lattice vector size", &
               & origin=child_array%origin, label="Expected 3 coordinates"))
            return
         end if
         lattice(:, ilt) = vec * aatoau
      end do
   end if

   call new(self, sym, xyz, charge=charge, uhf=multiplicity-1, lattice=lattice)

end subroutine load_pymatgen
#endif


end module mctc_io_read_pymatgen

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Computes the Cholesky factorization of a real symmetric positive definite matrix A.
module tblite_lapack_potrf
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_potrf


   !> Computes the Cholesky factorization of a real symmetric
   !> positive definite matrix A.
   !>
   !> The factorization has the form
   !>    A = U**T * U,  if UPLO = 'U', or
   !>    A = L  * L**T,  if UPLO = 'L',
   !> where U is an upper triangular matrix and L is lower triangular.
   !>
   !> This is the block version of the algorithm, calling Level 3 BLAS.
   interface wrap_potrf
      module procedure :: wrap_spotrf
      module procedure :: wrap_dpotrf
   end interface wrap_potrf

   !> Computes the Cholesky factorization of a real symmetric
   !> positive definite matrix A.
   !>
   !> The factorization has the form
   !>    A = U**T * U,  if UPLO = 'U', or
   !>    A = L  * L**T,  if UPLO = 'L',
   !> where U is an upper triangular matrix and L is lower triangular.
   !>
   !> This is the block version of the algorithm, calling Level 3 BLAS.
   interface lapack_potrf
      pure subroutine spotrf(uplo, n, a, lda, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine spotrf
      pure subroutine dpotrf(uplo, n, a, lda, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dpotrf
   end interface lapack_potrf

contains

subroutine wrap_spotrf(amat, info, uplo)
   real(sp), intent(inout) :: amat(:, :)
   integer, intent(out) :: info
   character(len=1), intent(in), optional :: uplo
   integer :: n, lda
   character(len=1) :: ula

   ula = 'u'
   if (present(uplo)) ula = uplo
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   call lapack_potrf(ula, n, amat, lda, info)
end subroutine wrap_spotrf

subroutine wrap_dpotrf(amat, info, uplo)
   real(dp), intent(inout) :: amat(:, :)
   integer, intent(out) :: info
   character(len=1), intent(in), optional :: uplo
   integer :: n, lda
   character(len=1) :: ula

   ula = 'u'
   if (present(uplo)) ula = uplo
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   call lapack_potrf(ula, n, amat, lda, info)
end subroutine wrap_dpotrf

end module tblite_lapack_potrf

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of the D4 dispersion model for the evaluation of C6 coefficients.
module dftd4_model_d4
   use, intrinsic :: iso_fortran_env, only : output_unit, error_unit
   use ieee_arithmetic, only : ieee_is_nan
   use dftd4_model_type, only : dispersion_model, d4_qmod
   use dftd4_data, only : get_covalent_rad, get_r4r2_val, get_effective_charge, &
      get_electronegativity, get_hardness
   use dftd4_reference
   use dftd4_model_utils
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use multicharge, only : new_eeq2019_model, new_eeqbc2025_model
   implicit none
   private

   public :: d4_model, new_d4_model


   !> D4 dispersion model to evaluate C6 coefficients
   type, extends(dispersion_model) :: d4_model

      !> Weighting factor for CN interpolation
      real(wp) :: wf

   contains

      !> Generate weights for all reference systems
      procedure :: weight_references

      !> Evaluate C6 coefficient
      procedure :: get_atomic_c6

      !> Evaluate atomic polarizabilities
      procedure :: get_polarizabilities

   end type d4_model


   !> Default maximum charge scaling height for partial charge extrapolation
   real(wp), parameter :: ga_default = 3.0_wp

   !> Default charge scaling steepness for partial charge extrapolation
   real(wp), parameter :: gc_default = 2.0_wp

   !> Default weighting factor for coordination number interpolation
   real(wp), parameter :: wf_default = 6.0_wp

contains


!> Create new D4 dispersion model from molecular structure input
subroutine new_d4_model(error, d4, mol, ga, gc, wf, qmod)
   !DEC$ ATTRIBUTES DLLEXPORT :: new_d4_model

   !> Instance of the dispersion model
   type(d4_model), intent(out) :: d4

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Charge scaling height
   real(wp), intent(in), optional :: ga

   !> Charge scaling steepness
   real(wp), intent(in), optional :: gc

   !> Weighting factor for coordination number interpolation
   real(wp), intent(in), optional :: wf

   !> Charge model selection
   integer, intent(in), optional :: qmod

   integer :: isp, izp, iref, jsp, jzp, jref
   integer :: mref, tmp_qmod
   real(wp) :: aiw(23), c6
   real(wp), parameter :: thopi = 3.0_wp/pi

   ! check for unsupported elements (104 (Rf) - 111 (Rg))
   do isp = 1, mol%nid
      if (mol%num(isp) > 103 .and. mol%num(isp) < 112) then
         call fatal_error(error, "Structure contains unsupported element '"//trim(mol%sym(isp))//"'")
         return
      end if
   end do

   d4%ncoup = 1

   if (present(ga)) then
      d4%ga = ga
   else
      d4%ga = ga_default
   end if

   if (present(gc)) then
      d4%gc = gc
   else
      d4%gc = gc_default
   end if

   if (present(wf)) then
      d4%wf = wf
   else
      d4%wf = wf_default
   end if

   allocate(d4%rcov(mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      d4%rcov(isp) = get_covalent_rad(izp)
   end do

   allocate(d4%en(mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      d4%en(isp) = get_electronegativity(izp)
   end do

   allocate(d4%zeff(mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      d4%zeff(isp) = get_effective_charge(izp)
   end do

   allocate(d4%eta(mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      d4%eta(isp) = get_hardness(izp)
   end do

   allocate(d4%r4r2(mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      d4%r4r2(isp) = get_r4r2_val(izp)
   end do

   allocate(d4%ref(mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      d4%ref(isp) = get_nref(izp)
   end do

   mref = maxval(d4%ref)
   allocate(d4%cn(mref, mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      call set_refcn(d4%cn(:, isp), izp)
   end do

   if (present(qmod)) then
      tmp_qmod = qmod
   else
      tmp_qmod = d4_qmod%eeq
   end if

   allocate(d4%q(mref, mol%nid))
   allocate(d4%aiw(23, mref, mol%nid))
   select case(tmp_qmod)
   case default
      call fatal_error(error, "Unsupported option for charge model.")
      return
   case(d4_qmod%eeq)
      do isp = 1, mol%nid
         izp = mol%num(isp)
         call set_refq_eeq(d4%q(:, isp), izp)
         call set_refalpha_eeq(d4%aiw(:, :, isp), d4%ga, d4%gc, izp)
      end do
      ! Setup EEQ model
      call new_eeq2019_model(mol, d4%mchrg, error)
      if(allocated(error)) return
   case(d4_qmod%eeqbc)
      do isp = 1, mol%nid
         izp = mol%num(isp)
         call set_refq_eeqbc(d4%q(:, isp), izp)
         call set_refalpha_eeqbc(d4%aiw(:, :, isp), d4%ga, d4%gc, izp)
      end do
      ! Setup EEQBC model
      call new_eeqbc2025_model(mol, d4%mchrg, error)  
      if(allocated(error)) return
   case(d4_qmod%gfn2)
      do isp = 1, mol%nid
         izp = mol%num(isp)
         call set_refq_gfn2(d4%q(:, isp), izp)
         call set_refalpha_gfn2(d4%aiw(:, :, isp), d4%ga, d4%gc, izp)
      end do
   end select

   allocate(d4%ngw(mref, mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      call set_refgw(d4%ngw(:, isp), izp)
   end do

   allocate(d4%c6(mref, mref, mol%nid, mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      do jsp = 1, isp
         jzp = mol%num(jsp)
         do iref = 1, d4%ref(isp)
            do jref = 1, d4%ref(jsp)
               aiw(:) = d4%aiw(:, iref, isp) * d4%aiw(:, jref, jsp)
               c6 = thopi * trapzd(aiw)
               d4%c6(jref, iref, jsp, isp) = c6
               d4%c6(iref, jref, isp, jsp) = c6
            end do
         end do
      end do
   end do

end subroutine new_d4_model


!> Calculate the weights of the reference system and the derivatives w.r.t.
!> coordination number for later use.
subroutine weight_references(self, mol, cn, q, gwvec, gwdcn, gwdq)
   !DEC$ ATTRIBUTES DLLEXPORT :: weight_references

   !> Instance of the dispersion model
   class(d4_model), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Coordination number of every atom
   real(wp), intent(in) :: cn(:)

   !> Partial charge of every atom
   real(wp), intent(in) :: q(:)

   !> weighting for the atomic reference systems
   real(wp), intent(out) :: gwvec(:, :, :)

   !> derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(out), optional :: gwdcn(:, :, :)

   !> derivative of the weighting function w.r.t. the charge scaling
   real(wp), intent(out), optional :: gwdq(:, :, :)

   integer :: iat, izp, iref, igw
   real(wp) :: norm, dnorm, gw, expw, expd, gwk, dgwk, wf, zi, gi, maxcn
   real(wp), parameter :: eps_norm = tiny(1._wp)**0.5_wp

   if (present(gwdcn) .and. present(gwdq)) then
      gwvec(:, :, :) = 0.0_wp
      gwdcn(:, :, :) = 0.0_wp
      gwdq(:, :, :) = 0.0_wp

      !$omp parallel do default(none) schedule(runtime) &
      !$omp shared(gwvec, gwdcn, gwdq, mol, self, cn, q) private(iat, izp, iref, &
      !$omp& igw, norm, dnorm, gw, expw, expd, gwk, dgwk, wf, zi, gi, maxcn)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         zi = self%zeff(izp)
         gi = self%eta(izp) * self%gc
         norm = 0.0_wp
         dnorm = 0.0_wp
         do iref = 1, self%ref(izp)
            do igw = 1, self%ngw(iref, izp)
               wf = igw * self%wf
               gw = weight_cn(wf, cn(iat), self%cn(iref, izp))
               norm = norm + gw
               dnorm = dnorm + 2*wf * (self%cn(iref, izp) - cn(iat)) * gw
            end do
         end do

         if (abs(norm) > eps_norm) then
            norm = 1.0_wp / norm
         else
            norm = 0.0_wp
         end if

         do iref = 1, self%ref(izp)
            expw = 0.0_wp
            expd = 0.0_wp
            do igw = 1, self%ngw(iref, izp)
               wf = igw * self%wf
               gw = weight_cn(wf, cn(iat), self%cn(iref, izp))
               expw = expw + gw
               expd = expd + 2*wf * (self%cn(iref, izp) - cn(iat)) * gw
            end do
            
            gwk = expw * norm
            if (is_exceptional(gwk) .or. norm == 0.0_wp) then
               maxcn = maxval(self%cn(:self%ref(izp), izp))
               if (abs(maxcn - self%cn(iref, izp)) < 1e-12_wp) then
                  gwk = 1.0_wp
               else
                  gwk = 0.0_wp
               end if
            end if

            gwvec(iref, iat, 1) = gwk * zeta(self%ga, gi, self%q(iref, izp)+zi, q(iat)+zi)
            gwdq(iref, iat, 1) = gwk * dzeta(self%ga, gi, self%q(iref, izp)+zi, q(iat)+zi)
            
            ! This expression behaves differently for -O0 and -O3 optimization
            ! levels for tiny norm values. It yields incorrect values for -O0 
            ! due to fp underflow. These tiny values can occur if the CN is very
            ! far from all reference CNs. To ensure consistent behavior, we set 
            ! the norm to zero above.
            dgwk = norm * (expd - expw * dnorm * norm)
            if (is_exceptional(dgwk) .or. norm == 0.0_wp) then
               dgwk = 0.0_wp
            end if
            gwdcn(iref, iat, 1) = dgwk * zeta(self%ga, gi, self%q(iref, izp)+zi, q(iat)+zi)
         end do
      end do

   else

      gwvec(:, :, :) = 0.0_wp

      !$omp parallel do default(none) schedule(runtime) &
      !$omp shared(gwvec, mol, self, cn, q) &
      !$omp private(iat, izp, iref, igw, norm, gw, expw, gwk, wf, zi, gi, maxcn)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         zi = self%zeff(izp)
         gi = self%eta(izp) * self%gc
         norm = 0.0_wp
         do iref = 1, self%ref(izp)
            do igw = 1, self%ngw(iref, izp)
               wf = igw * self%wf
               norm = norm + weight_cn(wf, cn(iat), self%cn(iref, izp))
            end do
         end do

         if (abs(norm) > eps_norm) then
            norm = 1.0_wp / norm
         else
            norm = 0.0_wp
         end if

         do iref = 1, self%ref(izp)
            expw = 0.0_wp
            do igw = 1, self%ngw(iref, izp)
               wf = igw * self%wf
               expw = expw + weight_cn(wf, cn(iat), self%cn(iref, izp))
            end do

            gwk = expw * norm
            if (is_exceptional(gwk) .or. norm == 0.0_wp) then
               maxcn = maxval(self%cn(:self%ref(izp), izp))
               if (abs(maxcn - self%cn(iref, izp)) < 1e-12_wp) then
                  gwk = 1.0_wp
               else
                  gwk = 0.0_wp
               end if
            end if

            gwvec(iref, iat, 1) = gwk * zeta(self%ga, gi, self%q(iref, izp)+zi, q(iat)+zi)
         end do
      end do
   end if

end subroutine weight_references


!> Calculate atomic dispersion coefficients and their derivatives w.r.t.
!> the coordination numbers and atomic partial charges.
subroutine get_atomic_c6(self, mol, gwvec, gwdcn, gwdq, c6, dc6dcn, dc6dq)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_atomic_c6

   !> Instance of the dispersion model
   class(d4_model), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Weighting function for the atomic reference systems
   real(wp), intent(in) :: gwvec(:, :, :)

   !> Derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(in), optional :: gwdcn(:, :, :)

   !> Derivative of the weighting function w.r.t. the partial charge
   real(wp), intent(in), optional :: gwdq(:, :, :)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(out) :: c6(:, :)

   !> Derivative of the C6 w.r.t. the coordination number
   real(wp), intent(out), optional :: dc6dcn(:, :)

   !> Derivative of the C6 w.r.t. the partial charge
   real(wp), intent(out), optional :: dc6dq(:, :)

   integer :: iat, jat, izp, jzp, iref, jref
   real(wp) :: refc6, dc6, dc6dcni, dc6dcnj, dc6dqi, dc6dqj

   if (present(gwdcn).and.present(dc6dcn) &
      & .and.present(gwdq).and.present(dc6dq)) then
      c6(:, :) = 0.0_wp
      dc6dcn(:, :) = 0.0_wp
      dc6dq(:, :) = 0.0_wp

      !$omp parallel do default(none) schedule(runtime) &
      !$omp shared(c6, dc6dcn, dc6dq, mol, self, gwvec, gwdcn, gwdq) &
      !$omp private(iat, jat, izp, jzp, iref, jref, refc6, dc6, dc6dqi, dc6dqj, &
      !$omp& dc6dcni, dc6dcnj)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         do jat = 1, iat
            jzp = mol%id(jat)
            dc6 = 0.0_wp
            dc6dcni = 0.0_wp
            dc6dcnj = 0.0_wp
            dc6dqi = 0.0_wp
            dc6dqj = 0.0_wp
            do iref = 1, self%ref(izp)
               do jref = 1, self%ref(jzp)
                  refc6 = self%c6(iref, jref, izp, jzp)
                  dc6 = dc6 + gwvec(iref, iat, 1) * gwvec(jref, jat, 1) * refc6
                  dc6dcni = dc6dcni + gwdcn(iref, iat, 1) * gwvec(jref, jat, 1) * refc6
                  dc6dcnj = dc6dcnj + gwvec(iref, iat, 1) * gwdcn(jref, jat, 1) * refc6
                  dc6dqi = dc6dqi + gwdq(iref, iat, 1) * gwvec(jref, jat, 1) * refc6
                  dc6dqj = dc6dqj + gwvec(iref, iat, 1) * gwdq(jref, jat, 1) * refc6
               end do
            end do
            c6(iat, jat) = dc6
            c6(jat, iat) = dc6
            dc6dcn(iat, jat) = dc6dcni
            dc6dcn(jat, iat) = dc6dcnj
            dc6dq(iat, jat) = dc6dqi
            dc6dq(jat, iat) = dc6dqj
         end do
      end do

   else

      c6(:, :) = 0.0_wp

      !$omp parallel do default(none) schedule(runtime) &
      !$omp shared(c6, mol, self, gwvec) &
      !$omp private(iat, jat, izp, jzp, iref, jref, refc6, dc6)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         do jat = 1, iat
            jzp = mol%id(jat)
            dc6 = 0.0_wp
            do iref = 1, self%ref(izp)
               do jref = 1, self%ref(jzp)
                  refc6 = self%c6(iref, jref, izp, jzp)
                  dc6 = dc6 + gwvec(iref, iat, 1) * gwvec(jref, jat, 1) * refc6
               end do
            end do
            c6(iat, jat) = dc6
            c6(jat, iat) = dc6
         end do
      end do
   end if

end subroutine get_atomic_c6


!> Calculate atomic polarizabilities and their derivatives w.r.t.
!> the coordination numbers and atomic partial charges.
subroutine get_polarizabilities(self, mol, gwvec, gwdcn, gwdq, alpha, dadcn, dadq)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_polarizabilities

   !> Instance of the dispersion model
   class(d4_model), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Weighting function for the atomic reference systems
   real(wp), intent(in) :: gwvec(:, :, :)

   !> Derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(in), optional :: gwdcn(:, :, :)

   !> Derivative of the weighting function w.r.t. the partial charge
   real(wp), intent(in), optional :: gwdq(:, :, :)

   !> Static polarizabilities for all atoms.
   real(wp), intent(out) :: alpha(:)

   !> Derivative of the polarizibility w.r.t. the coordination number
   real(wp), intent(out), optional :: dadcn(:)

   !> Derivative of the polarizibility w.r.t. the partial charge
   real(wp), intent(out), optional :: dadq(:)

   integer :: iat, izp, iref
   real(wp) :: refa, da, dadcni, dadqi

   if (present(gwdcn).and.present(dadcn) &
      & .and.present(gwdq).and.present(dadq)) then
      alpha(:) = 0.0_wp
      dadcn(:) = 0.0_wp
      dadq(:) = 0.0_wp

      !$omp parallel do default(none) schedule(runtime) &
      !$omp shared(alpha, dadcn, dadq, mol, self, gwvec, gwdcn, gwdq) &
      !$omp private(iat, izp, iref, refa, da, dadqi, dadcni)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         da = 0.0_wp
         dadcni = 0.0_wp
         dadqi = 0.0_wp
         do iref = 1, self%ref(izp)
            refa = self%aiw(1, iref, izp)
            da = da + gwvec(iref, iat, 1) * refa
            dadcni = dadcni + gwdcn(iref, iat, 1) * refa
            dadqi = dadqi + gwdq(iref, iat, 1) * refa
         end do
         alpha(iat) = da
         dadcn(iat) = dadcni
         dadq(iat) = dadqi
      end do

   else

      alpha(:) = 0.0_wp

      !$omp parallel do default(none) schedule(runtime) &
      !$omp shared(alpha, mol, self, gwvec) private(iat, izp, iref, refa, da)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         da = 0.0_wp
         do iref = 1, self%ref(izp)
            da = da + gwvec(iref, iat, 1) * self%aiw(1, iref, izp)
         end do
         alpha(iat) = da
      end do
   end if

end subroutine get_polarizabilities


end module dftd4_model_d4

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3_model
   use ieee_arithmetic, only : ieee_is_nan
   use dftd3_data, only : get_r4r2_val, get_vdw_rad
   use dftd3_reference
   use mctc_data, only : get_covalent_rad
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   implicit none
   private

   public :: d3_model, new_d3_model


   !> Base D3 dispersion model to evaluate C6 coefficients
   type :: d3_model

      !> Covalent radii for coordination number
      real(wp), allocatable :: rcov(:)

      !> Van-der-Waals radii for damping function
      real(wp), allocatable :: rvdw(:, :)

      !> Expectation values for C8 extrapolation
      real(wp), allocatable :: r4r2(:)

      !> Weighting factor for CN interpolation
      real(wp), allocatable :: wf

      !> Number of reference systems
      integer, allocatable :: ref(:)

      !> Reference coordination numbers
      real(wp), allocatable :: cn(:, :)

      !> Reference C6 coefficients
      real(wp), allocatable :: c6(:, :, :, :)

   contains

      !> Generate weights for all reference systems
      procedure :: weight_references

      !> Evaluate C6 coefficient
      procedure :: get_atomic_c6

   end type d3_model


   !> Default weighting factor for coordination number interpolation
   real(wp), parameter :: wf_default = 4.0_wp


contains


!> Create new dispersion model from molecular structure input
subroutine new_d3_model(self, mol, wf)

   !> Instance of the dispersion model
   type(d3_model), intent(out) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Weighting factor for coordination number interpolation
   real(wp), intent(in), optional :: wf

   integer :: isp, izp, iref, jsp, jzp, jref
   integer :: mref

   call init_reference_c6

   if (present(wf)) then
      self%wf = wf
   else
      self%wf = wf_default
   end if

   allocate(self%ref(mol%nid))
   self%ref(:) = number_of_references(mol%num)
   mref = maxval(self%ref)

   allocate(self%rcov(mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      self%rcov(isp) = get_covalent_rad(izp)
   end do

   allocate(self%r4r2(mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      self%r4r2(isp) = get_r4r2_val(izp)
   end do

   allocate(self%rvdw(mol%nid, mol%nid))
   do isp = 1, mol%nid
      izp = mol%num(isp)
      do jsp = 1, isp
         jzp = mol%num(jsp)
         self%rvdw(jsp, isp) = get_vdw_rad(jzp, izp)
         self%rvdw(isp, jsp) = self%rvdw(jsp, isp)
      end do
   end do

   allocate(self%cn(mref, mol%nid), source=0.0_wp)
   do isp = 1, mol%nid
      izp = mol%num(isp)
      do iref = 1, self%ref(isp)
         self%cn(iref, isp) = reference_cn(iref, izp)
      end do
   end do

   allocate(self%c6(mref, mref, mol%nid, mol%nid), source=0.0_wp)
   do isp = 1, mol%nid
      izp = mol%num(isp)
      do jsp = 1, isp
         jzp = mol%num(jsp)
         do iref = 1, self%ref(isp)
            do jref = 1, self%ref(jsp)
               self%c6(jref, iref, jsp, isp) = get_c6(jref, iref, jzp, izp)
               self%c6(iref, jref, isp, jsp) = self%c6(jref, iref, jsp, isp)
            end do
         end do
      end do
   end do

end subroutine new_d3_model


!> Calculate the weights of the reference system and the derivatives w.r.t.
!> coordination number for later use.
subroutine weight_references(self, mol, cn, gwvec, gwdcn)

   !> Instance of the dispersion model
   class(d3_model), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)

   !> weighting for the atomic reference systems
   real(wp), intent(out) :: gwvec(:, :)

   !> derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(out), optional :: gwdcn(:, :)

   integer :: iat, izp, iref, mref
   real(wp) :: norm, dnorm, gw, expw, expd, gwk, dgwk
   real(wp) :: wf2, dcn
   real(wp), allocatable :: gwt(:)

   mref = maxval(self%ref)

   if (present(gwdcn)) then
      gwvec(:, :) = 0.0_wp
      gwdcn(:, :) = 0.0_wp
      wf2 = 2 * self%wf

      !$omp parallel default(none) &
      !$omp shared(gwvec, gwdcn, mol, self, cn, wf2, mref) &
      !$omp private(iat, izp, iref, norm, dnorm, gw, expw, expd, gwk, dgwk, dcn, gwt)
      allocate(gwt(mref))
      !$omp do schedule(runtime)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         norm = 0.0_wp
         dnorm = 0.0_wp
         do iref = 1, self%ref(izp)
            gw = weight_cn(self%wf, cn(iat), self%cn(iref, izp))
            gwt(iref) = gw
            norm = norm + gw
            dnorm = dnorm + wf2 * (self%cn(iref, izp) - cn(iat)) * gw
         end do
         norm = 1.0_wp / norm
         do iref = 1, self%ref(izp)
            expw = gwt(iref)
            dcn = self%cn(iref, izp) - cn(iat)
            expd = wf2 * dcn * expw
            gwk = expw * norm
            if (is_exceptional(gwk)) then
               if (maxval(self%cn(:self%ref(izp), izp)) == self%cn(iref, izp)) then
                  gwk = 1.0_wp
               else
                  gwk = 0.0_wp
               end if
            end if
            gwvec(iref, iat) = gwk

            dgwk = expd * norm - expw * dnorm * norm**2
            if (is_exceptional(dgwk)) then
               dgwk = 0.0_wp
            end if
            gwdcn(iref, iat) = dgwk
         end do
      end do
      !$omp end do
      deallocate(gwt)
      !$omp end parallel

   else

      gwvec(:, :) = 0.0_wp

      !$omp parallel default(none) &
      !$omp shared(gwvec, mol, self, cn, mref) &
      !$omp private(iat, izp, iref, norm, gw, expw, gwk, gwt)
      allocate(gwt(mref))
      !$omp do schedule(runtime)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         norm = 0.0_wp
         do iref = 1, self%ref(izp)
            gw = weight_cn(self%wf, cn(iat), self%cn(iref, izp))
            gwt(iref) = gw
            norm = norm + gw
         end do
         norm = 1.0_wp / norm
         do iref = 1, self%ref(izp)
            gwk = gwt(iref) * norm
            if (is_exceptional(gwk)) then
               if (maxval(self%cn(:self%ref(izp), izp)) == self%cn(iref, izp)) then
                  gwk = 1.0_wp
               else
                  gwk = 0.0_wp
               end if
            end if
            gwvec(iref, iat) = gwk
         end do
      end do
      !$omp end do
      deallocate(gwt)
      !$omp end parallel
   end if

end subroutine weight_references


!> Check whether we are dealing with an exceptional value, NaN or Inf
elemental function is_exceptional(val)
   real(wp), intent(in) :: val
   logical :: is_exceptional
   is_exceptional = ieee_is_nan(val) .or. abs(val) > huge(val)
end function is_exceptional


!> Calculate atomic dispersion coefficients and their derivatives w.r.t.
!> the coordination number.
subroutine get_atomic_c6(self, mol, gwvec, gwdcn, c6, dc6dcn)

   !> Instance of the dispersion model
   class(d3_model), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Weighting function for the atomic reference systems
   real(wp), intent(in) :: gwvec(:, :)

   !> Derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(in), optional :: gwdcn(:, :)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(out) :: c6(:, :)

   !> Derivative of the C6 w.r.t. the coordination number
   real(wp), intent(out), optional :: dc6dcn(:, :)

   integer :: iat, jat, izp, jzp, iref, jref
   real(wp) :: refc6, dc6, dc6dcni, dc6dcnj

   if (present(gwdcn).and.present(dc6dcn)) then
      c6(:, :) = 0.0_wp
      dc6dcn(:, :) = 0.0_wp

      !$omp parallel do schedule(runtime) default(none) &
      !$omp shared(c6, dc6dcn, mol, self, gwvec, gwdcn) &
      !$omp private(iat, jat, izp, jzp, iref, jref, refc6, dc6, dc6dcni, dc6dcnj)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         do jat = 1, iat
            jzp = mol%id(jat)
            dc6 = 0.0_wp
            dc6dcni = 0.0_wp
            dc6dcnj = 0.0_wp
            do iref = 1, self%ref(izp)
               do jref = 1, self%ref(jzp)
                  refc6 = self%c6(iref, jref, izp, jzp)
                  dc6 = dc6 + gwvec(iref, iat) * gwvec(jref, jat) * refc6
                  dc6dcni = dc6dcni + gwdcn(iref, iat) * gwvec(jref, jat) * refc6
                  dc6dcnj = dc6dcnj + gwvec(iref, iat) * gwdcn(jref, jat) * refc6
               end do
            end do
            c6(iat, jat) = dc6
            c6(jat, iat) = dc6
            dc6dcn(iat, jat) = dc6dcni
            dc6dcn(jat, iat) = dc6dcnj
         end do
      end do

   else

      c6(:, :) = 0.0_wp

      !$omp parallel do schedule(runtime) default(none) &
      !$omp shared(c6, mol, self, gwvec) &
      !$omp private(iat, jat, izp, jzp, iref, jref, refc6, dc6)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         do jat = 1, iat
            jzp = mol%id(jat)
            dc6 = 0.0_wp
            do iref = 1, self%ref(izp)
               do jref = 1, self%ref(jzp)
                  refc6 = self%c6(iref, jref, izp, jzp)
                  dc6 = dc6 + gwvec(iref, iat) * gwvec(jref, jat) * refc6
               end do
            end do
            c6(iat, jat) = dc6
            c6(jat, iat) = dc6
         end do
      end do
   end if

end subroutine get_atomic_c6


elemental function weight_cn(wf,cn,cnref) result(cngw)
   real(wp),intent(in) :: wf, cn, cnref
   real(wp) :: cngw
   intrinsic :: exp
   cngw = exp ( -wf * ( cn - cnref )**2 )
end function weight_cn


end module dftd3_model

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/solvation/cpcm.f90
!> Provides a polarizable continuum model

!> Implicit solvation model based on a polarizable dielectric continuum
module tblite_solvation_cpcm
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use tblite_blas, only : dot, gemv
   use tblite_container_cache, only : container_cache
   use tblite_mesh_lebedev, only : grid_size, get_angular_grid, list_bisection
   use tblite_scf_info, only : scf_info, atom_resolved
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_solvation_cpcm_dd
   use tblite_solvation_data, only : get_vdw_rad_cosmo
   use tblite_solvation_type, only : solvation_type
   implicit none
   private

   public :: cpcm_solvation, new_cpcm, cpcm_input


   !> Input for CPCM solvation
   type :: cpcm_input
      !> Dielectric constant
      real(wp) :: dielectric_const
      !> Number of grid points for each atom
      integer :: nang = grid_size(6)
      !> Scaling of van-der-Waals radii
      real(wp) :: rscale = 1.0_wp
      !> Accuracy for iterative solver
      real(wp) :: conv = 1.0e-8_wp
      !> Regularization parameter
      real(wp) :: eta = 2.0_wp
      !> Maximum angular momentum of basis functions
      integer :: lmax = 6
      !> Van-der-Waals radii for all species
      real(wp), allocatable :: rvdw(:)
   end type cpcm_input


   !> Definition of polarizable continuum model
   type, extends(solvation_type) :: cpcm_solvation
      !> Actual domain decomposition calculator
      type(domain_decomposition) :: dd
      !> Dielectric function
      real(wp) :: keps
      !> Van-der-Waal radii for all atoms
      real(wp), allocatable :: rvdw(:)
   contains
      !> Update cache from container
      procedure :: update
      !> Return dependency on density
      procedure :: variable_info
      !> Get electric field energy
      procedure :: get_energy
      !> Get electric field potential
      procedure :: get_potential
      !> Get electric field gradient
      procedure :: get_gradient
   end type cpcm_solvation

   !> Provide constructor for CPCM solvation
   interface cpcm_solvation
      module procedure :: create_cpcm
   end interface


   !> Restart data for CPCM calculation
   type :: cpcm_cache
      !> Actual domain decomposition calculator
      type(domain_decomposition) :: dd
      !> Electrostatic potential phi(ncav)
      real(wp), allocatable :: phi(:)
      !> Psi vector psi(nylm, n)
      real(wp), allocatable :: psi(:, :)
      !> CPCM solution sigma(nylm, n)
      real(wp), allocatable :: sigma(:, :)
      !> CPCM adjoint solution s(nylm, n)
      real(wp), allocatable :: s(:, :)
      !> Interaction matrix with surface charges jmat(ncav, n)
      real(wp), allocatable :: jmat(:, :)
   end type cpcm_cache


   !> Identifier for container
   character(len=*), parameter :: label = "polarizable continuum model"

   real(wp), parameter :: alpha_alpb = 0.571412_wp
   integer, parameter :: ndiis = 25


contains


!> Create new electric field container
subroutine new_cpcm(self, mol, input, error)
   !> Instance of the solvation model
   type(cpcm_solvation), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input for CPCM solvation
   type(cpcm_input), intent(in) :: input
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: igrid, stat, iat, izp
   real(wp), allocatable :: ang_grid(:, :), ang_weight(:)
   type(domain_decomposition_input) :: ddinput

   self%label = label

   allocate(self%rvdw(mol%nat))
   if (allocated(input%rvdw)) then
      self%rvdw(:) = input%rscale*input%rvdw(mol%id)
   else
      do iat = 1, mol%nat
         izp = mol%num(mol%id(iat))
         self%rvdw(iat) = input%rscale*get_vdw_rad_cosmo(izp)
      end do
   end if
   self%keps = -0.5_wp * (1.0_wp/input%dielectric_const - 1.0_wp) / (1.0_wp + alpha_alpb)
   ! choose the lebedev grid with number of points closest to nAng:
   igrid = list_bisection(grid_size, input%nang)
   allocate(ang_grid(3, grid_size(igrid)))
   allocate(ang_weight(grid_size(igrid)))
   call get_angular_grid(igrid, ang_grid, ang_weight, stat)
   if (stat /= 0) then
      call fatal_error(error, "Could not initialize angular grid for CPCM model")
   end if

   ddinput = domain_decomposition_input(lmax=input%lmax, conv=input%conv, eta=input%eta)

   call new_domain_decomposition(self%dd, ddinput, self%rvdw, ang_weight, ang_grid)

end subroutine new_cpcm


!> Type constructor for CPCM splvation
function create_cpcm(mol, input) result(self)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input for CPCM solvation
   type(cpcm_input), intent(in) :: input
   !> Instance of the solvation model
   type(cpcm_solvation) :: self

   type(error_type), allocatable :: error

   call new_cpcm(self, mol, input, error)
end function create_cpcm


!> Update cache from container
subroutine update(self, mol, cache)
   !> Instance of the solvation model
   class(cpcm_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache

   type(cpcm_cache), pointer :: ptr

   call taint(cache, ptr)

   if (allocated(ptr%phi)) deallocate(ptr%phi)
   if (allocated(ptr%psi)) deallocate(ptr%psi)
   if (allocated(ptr%sigma)) deallocate(ptr%sigma)
   if (allocated(ptr%s)) deallocate(ptr%s)
   if (allocated(ptr%jmat)) deallocate(ptr%jmat)

   ptr%dd = self%dd

   call ddupdate(ptr%dd, mol%xyz)

   allocate(ptr%phi(ptr%dd%ncav), ptr%psi(ptr%dd%nylm, ptr%dd%nat))
   allocate(ptr%jmat(ptr%dd%ncav, ptr%dd%nat))

   call get_coulomb_matrix(mol%xyz, ptr%dd%ccav, ptr%jmat)
end subroutine update


!> Get electric field energy
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the solvation model
   class(cpcm_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Solvation free energy
   real(wp), intent(inout) :: energies(:)

   type(cpcm_cache), pointer :: ptr

   call view(cache, ptr)

   energies(:) = energies + self%keps * sum(ptr%sigma * ptr%psi, 1)
end subroutine get_energy


!> Get electric field potential
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the solvation model
   class(cpcm_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   real(wp) :: xx(1, 1)
   logical :: restart
   type(cpcm_cache), pointer :: ptr

   call view(cache, ptr)

   restart = allocated(ptr%sigma)
   if (.not.allocated(ptr%sigma)) then
      allocate(ptr%sigma(ptr%dd%nylm, ptr%dd%nat))
   end if

   call get_phi(wfn%qat(:, 1), ptr%jmat, ptr%phi)

   call solve_cosmo_direct(ptr%dd, .true., ptr%phi, xx, ptr%sigma, restart)

   restart = allocated(ptr%s)
   if (.not.allocated(ptr%s)) then
      allocate(ptr%s(ptr%dd%nylm, ptr%dd%nat))
   end if

   call get_psi(wfn%qat(:, 1), ptr%psi)

   ! solve adjoint ddCOSMO equation to get full potential contributions
   call solve_cosmo_adjoint(ptr%dd, ptr%psi, ptr%s, restart)

   ! we abuse Phi to store the unpacked and scaled value of s
   call get_zeta(ptr%dd, self%keps, ptr%s, ptr%phi)
   ! and contract with the Coulomb matrix
   call gemv(ptr%jmat, ptr%phi, pot%vat(:, 1), alpha=-1.0_wp, &
      & beta=1.0_wp, trans='t')

   pot%vat(:, 1) = pot%vat(:, 1) + (self%keps * sqrt(4*pi)) * ptr%sigma(1, :)

end subroutine get_potential


!> Get electric field gradient
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the solvation model
   class(cpcm_solvation), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Molecular gradient of the solvation free energy
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Strain derivatives of the solvation free energy
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   integer :: ii, iat, ig
   real(wp), allocatable :: gx(:, :), zeta(:), ef(:, :)
   type(cpcm_cache), pointer :: ptr

   call view(cache, ptr)

   allocate(gx(3, mol%nat), zeta(ptr%dd%ncav), ef(3, max(mol%nat, ptr%dd%ncav)))

   call solve_cosmo_adjoint(ptr%dd, ptr%psi, ptr%s, .true., &
      & accuracy=ptr%dd%conv*1e-3_wp)

   ! reset Phi
   call get_phi(wfn%qat(:, 1), ptr%jmat, ptr%phi)

   ! now call the routine that computes the ddcosmo specific contributions to the forces.
   call get_deriv(ptr%dd, self%keps, ptr%phi, ptr%sigma, ptr%s, gx)

   ! form the "zeta" intermediate
   call get_zeta(ptr%dd, self%keps, ptr%s, zeta)

   ! 1. solute's electric field at the cav points times zeta:
   !    compute the electric field
   call efld(mol%nat, wfn%qat(:, 1), ptr%dd%xyz, ptr%dd%ncav, ptr%dd%ccav, ef)

   ! contract it with the zeta intermediate
   ii = 0
   do iat = 1, ptr%dd%nat
      do ig = 1, ptr%dd%ngrid
         if (ptr%dd%ui(ig, iat) > 0.0_wp) then
            ii = ii + 1
            gx(:, iat) = gx(:, iat) + zeta(ii)*ef(:, ii)
         end if
      end do
   end do

   ! 2. "zeta's" electric field at the nuclei times the charges.
   !    compute the "electric field"
   call efld(ptr%dd%ncav, zeta, ptr%dd%ccav, mol%nat, ptr%dd%xyz, ef)

   ! contract it with the solute's charges.
   do iat = 1, ptr%dd%nat
      gx(:, iat) = gx(:, iat) + ef(:, iat)*wfn%qat(iat, 1)
   end do

   gradient(:, :) = gradient(:, :) + gx
end subroutine get_gradient


!> Return dependency on density
pure function variable_info(self) result(info)
   !> Instance of the solvation model
   class(cpcm_solvation), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info(charge=atom_resolved)
end function variable_info


subroutine taint(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(cpcm_cache), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(cpcm_cache), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

subroutine view(cache, ptr)
   type(container_cache), target, intent(inout) :: cache
   type(cpcm_cache), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(cpcm_cache)
      ptr => target
   end select
end subroutine view


!> Evaluate the Coulomb interactions between the atomic sides (xyz) and the
!> surface elements of the cavity (ccav).
subroutine get_coulomb_matrix(xyz, ccav, jmat)
   real(wp), intent(in) :: xyz(:, :)
   real(wp), intent(in) :: ccav(:, :)
   real(wp), intent(inout) :: jmat(:, :)

   integer :: ic, j
   real(wp) :: vec(3), d2, d

   jmat(:, :) = 0.0_wp
   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(ccav, xyz, jmat) private(ic, j, vec, d2, d)
   do ic = 1, size(ccav, 2)
      do j = 1, size(xyz, 2)
         vec(:) = ccav(:, ic) - xyz(:, j)
         d2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         d = sqrt(d2)
         jmat(ic, j) = 1.0_wp / d
      end do
   end do

end subroutine get_coulomb_matrix


!> Routine to compute the psi vector
subroutine get_psi(charge, psi)
   real(wp), intent(in) :: charge(:)
   real(wp), intent(out) :: psi(:, :)

   integer :: iat
   real(wp), parameter :: fac = sqrt(4*pi)

   psi(:,:) = 0.0_wp

   do iat = 1, size(charge)
      psi(1, iat) = fac*charge(iat)
   end do

end subroutine get_psi


!> Routine to compute the potential vector
subroutine get_phi(charge, jmat, phi)
   real(wp), intent(in) :: charge(:)
   real(wp), intent(in) :: jmat(:, :)
   real(wp), intent(out) :: phi(:)

   phi(:) = 0.0_wp

   call gemv(jmat, charge, phi)

end subroutine get_phi


!> Computes the electric field produced by the sources src (nsrc point charges
!  with coordinates csrc) at the ntrg target points ctrg:
subroutine efld(nsrc, src, csrc, ntrg, ctrg, ef)
   integer, intent(in) :: nsrc, ntrg
   real(wp), intent(in) :: src(:)
   real(wp), intent(in) :: csrc(:, :)
   real(wp), intent(in) :: ctrg(:, :)
   real(wp), intent(inout) :: ef(:, :)

   integer :: i, j
   real(wp) :: vec(3), r2, rr, r3, f
   real(wp), parameter :: zero=0.0_wp

   ef(:, :) = 0.0_wp
   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp reduction(+:ef) shared(ntrg, nsrc, ctrg, csrc, src) &
   !$omp private(j, i, f, vec, r2, rr, r3)
   do j = 1, ntrg
      do i = 1, nsrc
         vec(:) = ctrg(:, j) - csrc(:, i)
         r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         rr = sqrt(r2)
         r3 = r2*rr
         f = src(i)/r3
         ef(:, j) = ef(:, j) + f*vec
      end do
   end do

end subroutine efld


end module tblite_solvation_cpcm

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/version.f90
!> Provides version and feature information

!> Interfaces to query the version information of the library.
module tblite_version
   implicit none
   private

   public :: tblite_version_string, tblite_version_compact
   public :: get_tblite_version


   !> String representation of the tblite version
   character(len=*), parameter :: tblite_version_string = "0.6.0"

   !> Numeric representation of the tblite version
   integer, parameter :: tblite_version_compact(3) = [0, 6, 0]


contains


!> Getter function to retrieve tblite version
subroutine get_tblite_version(major, minor, patch, string)
   !> Major version number of the tblite version
   integer, intent(out), optional :: major
   !> Minor version number of the tblite version
   integer, intent(out), optional :: minor
   !> Patch version number of the tblite version
   integer, intent(out), optional :: patch
   !> String representation of the tblite version
   character(len=:), allocatable, intent(out), optional :: string

   if (present(major)) then
      major = tblite_version_compact(1)
   end if
   if (present(minor)) then
      minor = tblite_version_compact(2)
   end if
   if (present(patch)) then
      patch = tblite_version_compact(3)
   end if
   if (present(string)) then
      string = tblite_version_string
   end if

end subroutine get_tblite_version


end module tblite_version

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Public API reexport of environment library
module mctc_env
   use mctc_env_accuracy, only : sp, dp, wp, i1, i2, i4, i8
   use mctc_env_error, only : error_type, fatal_error, mctc_stat
   use mctc_env_system, only : get_argument, get_variable, &
      & is_unix, is_windows
   implicit none
   public

end module mctc_env

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/scf/info.f90
!> Provides a density dependence information

!> Definition of information container on density dependence
module tblite_scf_info
   use mctc_env, only : sp, dp, error_type
   implicit none
   private

   public :: not_used, atom_resolved, shell_resolved, orbital_resolved, max

   integer, parameter :: not_used = 0
   integer, parameter :: atom_resolved = 1
   integer, parameter :: shell_resolved = 2
   integer, parameter :: orbital_resolved = 3

   !> Small info container about density dependence
   type, public :: scf_info
      integer :: charge = not_used
      integer :: dipole = not_used
      integer :: quadrupole = not_used
   end type scf_info

   interface max
      module procedure :: max_info
   end interface max

contains

pure function max_info(lhs, rhs) result(new)
   type(scf_info), intent(in) :: lhs
   type(scf_info), intent(in) :: rhs
   type(scf_info) :: new

   new = scf_info( &
      charge=max(lhs%charge, rhs%charge), &
      dipole=max(lhs%dipole, rhs%dipole), &
      quadrupole=max(lhs%quadrupole, rhs%quadrupole))

end function max_info

end module tblite_scf_info

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/io/numpy/load.f90
!> Provides npy input routines

!> Implementation of npy input routines
module tblite_io_numpy_load
   use mctc_env, only : dp, i4
   use tblite_io_numpy_constants, only : magic_number, magic_string, type_rdp, type_i4
   use tblite_io_numpy_utils, only : reader_type, new_reader, read, delete_reader
   use tblite_output_format, only : format_string
   implicit none
   private

   public :: load_npy
   public :: get_npy_descriptor

   interface load_npy
      module procedure load_npy_i4_r1
      module procedure load_npy_i4_r1_file
      module procedure load_npy_rdp_r1
      module procedure load_npy_rdp_r1_file
      module procedure load_npy_rdp_r2
      module procedure load_npy_rdp_r2_file
      module procedure load_npy_rdp_r3
      module procedure load_npy_rdp_r3_file
   end interface load_npy

   character(len=*), parameter :: nl = achar(10)

   enum, bind(c)
       enumerator :: invalid, string, lbrace, rbrace, comma, colon, &
           lparen, rparen, bool, literal, space
   end enum

   type :: token_type
       integer :: first, last, kind
   end type token_type

contains

subroutine load_npy_i4_r1_file(filename, array, iostat, iomsg)
   !> Name of the npy file to load from
   character(len=*), intent(in) :: filename
   !> Array to be loaded from the npy file
   integer(i4), allocatable, intent(out) :: array(:)
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   type(reader_type) :: reader
   integer :: stat
   character(len=:), allocatable :: msg

   call new_reader(reader, filename, stat)
   if (stat /= 0) then
      call handle_iostat(stat, msg, filename, iostat)
      return
   end if
   call load_npy(reader, array, iostat, iomsg)
   call delete_reader(reader)
end subroutine load_npy_i4_r1_file

subroutine load_npy_i4_r1(reader, array, iostat, iomsg)
   !> Reader for the binary file
   type(reader_type), intent(inout) :: reader
   !> Array to be loaded from the npy file
   integer(i4), allocatable, intent(out) :: array(:)
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=*), parameter :: vtype = type_i4
   integer, parameter :: rank = 1

   integer :: stat
   character(len=:), allocatable :: msg

   catch: block
       character(len=:), allocatable :: this_type
       integer, allocatable :: vshape(:)

       call get_npy_descriptor(reader, this_type, vshape, stat, msg)
       if (stat /= 0) exit catch

       if (this_type /= vtype) then
           stat = 11
           msg = type_error(reader%filename, this_type, vtype)
           exit catch
       end if

       if (size(vshape) /= rank) then
           stat = 12
           msg = rank_error(reader%filename, vshape, rank)
           exit catch
       end if

       allocate(array(vshape(1)), stat=stat)
       if (stat /= 0) then
           msg = allocation_error(vtype, vshape)
           exit catch
       end if

       call read(reader, array, stat)
   end block catch
   call handle_iostat(stat, msg, reader%filename, iostat)

   if (present(iomsg).and.allocated(msg)) call move_alloc(msg, iomsg)
end subroutine load_npy_i4_r1

subroutine load_npy_rdp_r1_file(filename, array, iostat, iomsg)
   !> Name of the npy file to load from
   character(len=*), intent(in) :: filename
   !> Array to be loaded from the npy file
   real(dp), allocatable, intent(out) :: array(:)
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   type(reader_type) :: reader
   integer :: stat
   character(len=:), allocatable :: msg

   call new_reader(reader, filename, stat)
   if (stat /= 0) then
      call handle_iostat(stat, msg, filename, iostat)
      return
   end if
   call load_npy(reader, array, iostat, iomsg)
   call delete_reader(reader)
end subroutine load_npy_rdp_r1_file

subroutine load_npy_rdp_r1(reader, array, iostat, iomsg)
   !> Reader for the binary file
   type(reader_type), intent(inout) :: reader
   !> Array to be loaded from the npy file
   real(dp), allocatable, intent(out) :: array(:)
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=*), parameter :: vtype = type_rdp
   integer, parameter :: rank = 1

   integer :: stat
   character(len=:), allocatable :: msg

   catch: block
       character(len=:), allocatable :: this_type
       integer, allocatable :: vshape(:)

       call get_npy_descriptor(reader, this_type, vshape, stat, msg)
       if (stat /= 0) exit catch

       if (this_type /= vtype) then
           stat = 11
           msg = type_error(reader%filename, this_type, vtype)
           exit catch
       end if

       if (size(vshape) /= rank) then
           stat = 12
           msg = rank_error(reader%filename, vshape, rank)
           exit catch
       end if

       allocate(array(vshape(1)), stat=stat)
       if (stat /= 0) then
           msg = allocation_error(vtype, vshape)
           exit catch
       end if

       call read(reader, array, stat)
   end block catch
   call handle_iostat(stat, msg, reader%filename, iostat)

   if (present(iomsg).and.allocated(msg)) call move_alloc(msg, iomsg)
end subroutine load_npy_rdp_r1

subroutine load_npy_rdp_r2_file(filename, array, iostat, iomsg)
   !> Name of the npy file to load from
   character(len=*), intent(in) :: filename
   !> Array to be loaded from the npy file
   real(dp), allocatable, intent(out) :: array(:, :)
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   type(reader_type) :: reader
   integer :: stat
   character(len=:), allocatable :: msg

    call new_reader(reader, filename, stat)
   if (stat /= 0) then
      call handle_iostat(stat, msg, filename, iostat)
      return
   end if
    call load_npy(reader, array, iostat, iomsg)
    call delete_reader(reader)
end subroutine load_npy_rdp_r2_file

subroutine load_npy_rdp_r2(reader, array, iostat, iomsg)
   !> Reader for the binary file
   type(reader_type), intent(inout) :: reader
   !> Array to be loaded from the npy file
   real(dp), allocatable, intent(out) :: array(:, :)
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=*), parameter :: vtype = type_rdp
   integer, parameter :: rank = 2

   integer :: stat
   character(len=:), allocatable :: msg

   catch: block
       character(len=:), allocatable :: this_type
       integer, allocatable :: vshape(:)

       call get_npy_descriptor(reader, this_type, vshape, stat, msg)
       if (stat /= 0) exit catch

       if (this_type /= vtype) then
           stat = 11
           msg = type_error(reader%filename, this_type, vtype)
           exit catch
       end if

       if (size(vshape) /= rank) then
           stat = 12
           msg = rank_error(reader%filename, vshape, rank)
           exit catch
       end if

       allocate(array(vshape(1), vshape(2)), stat=stat)
       if (stat /= 0) then
           msg = allocation_error(vtype, vshape)
           exit catch
       end if

       call read(reader, array, stat)
   end block catch
   call handle_iostat(stat, msg, reader%filename, iostat)

   if (present(iomsg).and.allocated(msg)) call move_alloc(msg, iomsg)
end subroutine load_npy_rdp_r2

subroutine load_npy_rdp_r3_file(filename, array, iostat, iomsg)
   !> Name of the npy file to load from
   character(len=*), intent(in) :: filename
   !> Array to be loaded from the npy file
   real(dp), allocatable, intent(out) :: array(:, :, :)
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   type(reader_type) :: reader
   integer :: stat
   character(len=:), allocatable :: msg

   call new_reader(reader, filename, stat)
   if (stat /= 0) then
      call handle_iostat(stat, msg, filename, iostat)
      return
   end if
   call load_npy(reader, array, iostat, iomsg)
   call delete_reader(reader)
end subroutine load_npy_rdp_r3_file

subroutine load_npy_rdp_r3(reader, array, iostat, iomsg)
   !> Reader for the binary file
   type(reader_type), intent(inout) :: reader
   !> Array to be loaded from the npy file
   real(dp), allocatable, intent(out) :: array(:, :, :)
   !> Error status of loading, zero on success
   integer, intent(out), optional :: iostat
   !> Associated error message in case of non-zero status code
   character(len=:), allocatable, intent(out), optional :: iomsg

   character(len=*), parameter :: vtype = type_rdp
   integer, parameter :: rank = 3

   integer :: stat
   character(len=:), allocatable :: msg

   catch: block
       character(len=:), allocatable :: this_type
       integer, allocatable :: vshape(:)

       call get_npy_descriptor(reader , this_type, vshape, stat, msg)
       if (stat /= 0) exit catch

       if (this_type /= vtype) then
           stat = 11
           msg = type_error(reader%filename, this_type, vtype)
           exit catch
       end if

       if (size(vshape) /= rank) then
           stat = 12
           msg = rank_error(reader%filename, vshape, rank)
           exit catch
       end if

       allocate(array(vshape(1), vshape(2), vshape(3)), stat=stat)
       if (stat /= 0) then
           msg = allocation_error(vtype, vshape)
           exit catch
       end if

       call read(reader, array, stat)
   end block catch
   call handle_iostat(stat, msg, reader%filename, iostat)

   if (present(iomsg).and.allocated(msg)) call move_alloc(msg, iomsg)
end subroutine load_npy_rdp_r3

!> Read the npy header from a binary file and retrieve the descriptor string.
subroutine get_npy_descriptor(reader, vtype, vshape, stat, msg)
   !> Reader for the binary file
   type(reader_type), intent(inout) :: reader
   !> Type of data saved in npy file
   character(len=:), allocatable, intent(out) :: vtype
   !> Shape descriptor of the
   integer, allocatable, intent(out) :: vshape(:)
   !> Status of operation
   integer, intent(out) :: stat
   !> Associated error message in case of non-zero status
   character(len=:), allocatable, intent(out) :: msg

   integer :: major, header_len, i
   character(len=:), allocatable :: dict
   character(len=8) :: header
   character :: buf4(4), buf2(2)
   logical :: fortran_order
   
   ! stat should be zero if no error occurred
   stat = 0
   
   call read(reader, header, stat)
   if (stat /= 0) return

   call parse_header(header, major, stat, msg)
   if (stat /= 0) return

   if (major > 1) then
      call read(reader, buf4, stat)
      if (stat /= 0) return
      header_len = ichar(buf4(1)) &
         &       + ichar(buf4(2)) * 256**1 &
         &       + ichar(buf4(3)) * 256**2 &
         &       + ichar(buf4(4)) * 256**3
   else
      call read(reader, buf2, stat)
      if (stat /= 0) return
      header_len = ichar(buf2(1)) &
         &       + ichar(buf2(2)) * 256**1
   end if
   allocate(character(header_len) :: dict, stat=stat)
   if (stat /= 0) return

   call read(reader, dict, stat)
   if (stat /= 0) return

   if (dict(header_len:header_len) /= nl) then
       stat = 101
       msg = "Descriptor length does not match"
       return
   end if

   if (scan(dict, achar(0)) > 0) then
       stat = 102
       msg = "Nul byte not allowed in descriptor string"
       return
   end if

   call parse_descriptor(trim(dict(:len(dict)-1)), reader%filename, &
       & vtype, fortran_order, vshape, stat, msg)
   if (stat /= 0) return

   if (.not.fortran_order) then
       vshape = [(vshape(i), i = size(vshape), 1, -1)]
   end if
end subroutine get_npy_descriptor


!> Parse the first eight bytes of the npy header to verify the data
subroutine parse_header(header, major, stat, msg)
   !> Header of the binary file
   character(len=*), intent(in) :: header
   !> Major version of the npy format
   integer, intent(out) :: major
   !> Status of operation
   integer, intent(out) :: stat
   !> Associated error message in case of non-zero status
   character(len=:), allocatable, intent(out) :: msg

   integer :: minor

   ! stat should be zero if no error occurred
   stat = 0

   if (header(1:1) /= magic_number) then
       stat = 201
       msg = "Expected z'93' but got z'"//format_string(ichar(header(1:1)), '(i0)')//"' "//&
           & "as first byte"
       return
   end if

   if (header(2:6) /= magic_string) then
       stat = 202
       msg = "Expected identifier '"//magic_string//"'"
       return
   end if

   major = ichar(header(7:7))
   if (.not.any(major == [1, 2, 3])) then
       stat = 203
       msg = "Unsupported format major version number '"//format_string(major, '(i0)')//"'"
       return
   end if

   minor = ichar(header(8:8))
   if (minor /= 0) then
       stat = 204
       msg = "Unsupported format version "// &
           & "'"//format_string(major, '(i0)')//"."//format_string(minor, '(i0)')//"'"
       return
   end if
end subroutine parse_header

!> Parse the descriptor in the npy header. This routine implements a minimal
!> non-recursive parser for serialized Python dictionaries.
subroutine parse_descriptor(input, filename, vtype, fortran_order, vshape, stat, msg)
   !> Input string to parse as descriptor
   character(len=*), intent(in) :: input
   !> Filename for error reporting
   character(len=*), intent(in) :: filename
   !> Type of the data stored, retrieved from field `descr`
   character(len=:), allocatable, intent(out) :: vtype
   !> Whether the data is in left layout, retrieved from field `fortran_order`
   logical, intent(out) :: fortran_order
   !> Shape of the stored data, retrieved from field `shape`
   integer, allocatable, intent(out) :: vshape(:)
   !> Status of operation
   integer, intent(out) :: stat
   !> Associated error message in case of non-zero status
   character(len=:), allocatable, intent(out) :: msg

   integer :: pos
   character(len=:), allocatable :: key
   type(token_type) :: token, last
   logical :: has_descr, has_shape, has_fortran_order

   has_descr = .false.
   has_shape = .false.
   has_fortran_order = .false.
   pos = 0
   call next_token(input, filename, pos, token, [lbrace], stat, msg)
   if (stat /= 0) return

   last = token_type(pos, pos, comma)
   do while (pos < len(input))
       call get_token(input, pos, token)
       select case(token%kind)
       case(space)
           continue
       case(comma)
           if (token%kind == last%kind) then
               stat = 301
               msg = make_message(filename, input, token%first, token%last, &
                   & "Comma cannot appear at this point")
               return
           end if
           last = token
       case(rbrace)
           exit
       case(string)
           if (token%kind == last%kind) then
               stat = 302
               msg = make_message(filename, input, token%first, token%last, &
                   & "String cannot appear at this point")
               return
           end if
           last = token

           key = input(token%first+1:token%last-1)
           call next_token(input, filename, pos, token, [colon], stat, msg)
           if (stat /= 0) return

           if (key == "descr" .and. has_descr &
               & .or. key == "fortran_order" .and. has_fortran_order &
               & .or. key == "shape" .and. has_shape) then
               stat = 303
               msg = make_message(filename, input, last%first, last%last, &
                   & "Duplicate entry for '"//key//"' found")
               return
           end if

           select case(key)
           case("descr")
               call next_token(input, filename, pos, token, [string], stat, msg)
               if (stat /= 0) return

               vtype = input(token%first+1:token%last-1)
               has_descr = .true.

           case("fortran_order")
               call next_token(input, filename, pos, token, [bool], stat, msg)
               if (stat /= 0) return

               fortran_order = input(token%first:token%last) == "True"
               has_fortran_order = .true.

           case("shape")
               call parse_tuple(input, filename, pos, vshape, stat, msg)
               if (stat /= 0) return

               has_shape = .true.

           case default
               stat = 304
               msg = make_message(filename, input, last%first, last%last, &
                   & "Invalid entry '"//key//"' in dictionary encountered")
               return
           end select
       case default
           stat = 305
           msg = make_message(filename, input, token%first, token%last, &
               & "Invalid token encountered")
           return
       end select
   end do

   if (.not.has_descr) then
       stat = 306
       msg = make_message(filename, input, 1, pos, &
           & "Dictionary does not contain required entry 'descr'")
   end if

   if (.not.has_shape) then
       stat = 307
       msg = make_message(filename, input, 1, pos, &
           & "Dictionary does not contain required entry 'shape'")
   end if

   if (.not.has_fortran_order) then
       stat = 308
       msg = make_message(filename, input, 1, pos, &
           & "Dictionary does not contain required entry 'fortran_order'")
   end if

end subroutine parse_descriptor

pure function make_message(filename, input, first, last, message) result(str)
   !> Filename for context
   character(len=*), intent(in) :: filename
   !> Input string to parse
   character(len=*), intent(in) :: input
   !> Offset in the input
   integer, intent(in) :: first, last
   !> Error message
   character(len=*), intent(in) :: message
   !> Final output message
   character(len=:), allocatable :: str

   character(len=*), parameter :: nl = new_line('a')

   str = message // nl // &
       & " --> " // filename // ":1:" // format_string(first, '(i0)') // "-" // format_string(last, '(i0)') // nl // &
       & "  |" // nl // &
       & "1 | " // input // nl // &
       & "  |" // repeat(" ", first) // repeat("^", last - first + 1) // nl // &
       & "  |"
end function make_message

!> Parse a tuple of integers into an array of integers
pure subroutine parse_tuple(input, filename, pos, tuple, stat, msg)
   !> Input string to parse
   character(len=*), intent(in) :: input
   !> Filename for error reporting
    character(len=*), intent(in) :: filename
   !> Offset in the input, will be advanced after reading
   integer, intent(inout) :: pos
   !> Array representing tuple of integers
   integer, allocatable, intent(out) :: tuple(:)
   !> Status of operation
   integer, intent(out) :: stat
   !> Associated error message in case of non-zero status
   character(len=:), allocatable, intent(out) :: msg

   type(token_type) :: token
   integer :: last, itmp

   allocate(tuple(0), stat=stat)
   if (stat /= 0) return

   call next_token(input, filename, pos, token, [lparen], stat, msg)
   if (stat /= 0) return

   last = comma
   do while (pos < len(input))
       call get_token(input, pos, token)
       select case(token%kind)
       case(space)
           continue
       case(literal)
           if (token%kind == last) then
               stat = 311
               msg = make_message(filename, input, token%first, token%last, &
                   & "Invalid token encountered")
               return
           end if
           last = token%kind
           read(input(token%first:token%last), *, iostat=stat) itmp
           if (stat /= 0) then
               return
           end if
           tuple = [tuple, itmp]
       case(comma)
           if (token%kind == last) then
               stat = 312
               msg = make_message(filename, input, token%first, token%last, &
                   & "Invalid token encountered")
               return
           end if
           last = token%kind
       case(rparen)
           exit
       case default
           stat = 313
           msg = make_message(filename, input, token%first, token%last, &
               & "Invalid token encountered")
           return
       end select
   end do
end subroutine parse_tuple

!> Get the next allowed token
pure subroutine next_token(input, filename, pos, token, allowed_token, stat, msg)
   !> Input string to parse
   character(len=*), intent(in) :: input
   !> Filename for error reporting
   character(len=*), intent(in) :: filename
   !> Current offset in the input string
   integer, intent(inout) :: pos
   !> Last token parsed
   type(token_type), intent(out) :: token
   !> Tokens allowed in the current context
   integer, intent(in) :: allowed_token(:)
   !> Status of operation
   integer, intent(out) :: stat
   !> Associated error message in case of non-zero status
   character(len=:), allocatable, intent(out) :: msg

   stat = pos
   do while (pos < len(input))
       call get_token(input, pos, token)
       if (token%kind == space) then
           continue
       else if (any(token%kind == allowed_token)) then
           stat = 0
           exit
       else
           stat = 321
           msg = make_message(filename, input, token%first, token%last, &
               & "Invalid token encountered")
           exit
       end if
   end do
end subroutine next_token

!> Tokenize input string
pure subroutine get_token(input, pos, token)
   !> Input strin to tokenize
   character(len=*), intent(in) :: input
   !> Offset in input string, will be advanced
   integer, intent(inout) :: pos
   !> Returned token from the next position
   type(token_type), intent(out) :: token

   character :: quote

   pos = pos + 1
   select case(input(pos:pos))
   case("""", "'")
       quote = input(pos:pos)
       token%first = pos
       pos = pos + 1
       do while (pos <= len(input))
           if (input(pos:pos) == quote) then
               token%last = pos
               exit
           else
               pos = pos + 1
           end if
       end do
       token%kind = string
   case("0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
       token%first = pos
       do while (pos <= len(input))
           if (.not.any(input(pos:pos) == ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"])) then
               pos = pos - 1
               token%last = pos
               exit
           else
               pos = pos + 1
           end if
       end do
       token%kind = literal
   case("T")
       if (starts_with(input(pos:), "True")) then
           token = token_type(pos, pos+3, bool)
           pos = pos + 3
       else
           token = token_type(pos, pos, invalid)
       end if
   case("F")
       if (starts_with(input(pos:), "False")) then
           token = token_type(pos, pos+4, bool)
           pos = pos + 4
       else
           token = token_type(pos, pos, invalid)
       end if
   case("{")
       token = token_type(pos, pos, lbrace)
   case("}")
       token = token_type(pos, pos, rbrace)
   case(",")
       token = token_type(pos, pos, comma)
   case(":")
       token = token_type(pos, pos, colon)
   case("(")
       token = token_type(pos, pos, lparen)
   case(")")
       token = token_type(pos, pos, rparen)
   case(" ", nl)
       token = token_type(pos, pos, space)
   case default
       token = token_type(pos, pos, invalid)
   end select

end subroutine get_token

!> Create an error message for a type mismatch
pure function type_error(filename, this_type, vtype) result(msg)
   !> Filename for error reporting
   character(len=*), intent(in) :: filename
   !> Type of the data stored, retrieved from field `descr`
   character(len=*), intent(in) :: this_type
   !> Type of the data expected
   character(len=*), intent(in) :: vtype
   !> Error message
   character(len=:), allocatable :: msg

   msg = "File '"//filename//"' contains data of type '"//this_type//"', "//&
      & "but expected '"//vtype//"'"
end function type_error

!> Create an error message for a rank mismatch
pure function rank_error(filename, vshape, rank) result(msg)
   !> Filename for error reporting
   character(len=*), intent(in) :: filename
   !> Shape of the data stored, retrieved from field `shape`
   integer, intent(in) :: vshape(:)
   !> Rank of the data expected
   integer, intent(in) :: rank
   !> Error message
   character(len=:), allocatable :: msg

   msg = "File '"//filename//"' contains data of rank "//&
      & format_string(size(vshape), '(i0)')//", but expected "//&
      & format_string(rank, '(i0)')
end function rank_error

!> Create an error message for a failed allocation
pure function allocation_error(vtype, vshape) result(msg)
   !> Type of the data expected
   character(len=*), intent(in) :: vtype
   !> Shape of the data expected
   integer, intent(in) :: vshape(:)
   !> Error message
   character(len=:), allocatable :: msg

   msg = "Failed to allocate array of type '"//vtype//"' "//&
      & "with total size of "//format_string(product(vshape), '(i0)')
end function allocation_error

!> Handle the iostat of the read operation
subroutine handle_iostat(stat, msg, filename, iostat)
   integer, intent(in) :: stat
   character(len=:), allocatable, intent(in) :: msg
   character(len=*), intent(in) :: filename
   integer, intent(out), optional :: iostat

   if (present(iostat)) then
       iostat = stat
   else if (stat /= 0) then
       if (allocated(msg)) then
           error stop "Failed to read array from file '"//filename//"'"//nl//&
               & msg
       else
           error stop "Failed to read array from file '"//filename//"'"
       end if
   end if
end subroutine handle_iostat

!> Check whether a string starts with substring or not
pure function starts_with(string, substring) result(match)
   character(len=*), intent(in) :: string
   character(len=*), intent(in) :: substring
   logical :: match
   integer :: nsub

   nsub = len(substring)
   if (len(string) < nsub) then
      match = .false.
      return
   end if
   match = string(1:nsub) == substring
end function starts_with

end module tblite_io_numpy_load

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/coulomb/ewald.f90
!> Provides an utilities for implementing Ewald summations

!> Helper tools for dealing with Ewald summation related calculations
module tblite_coulomb_ewald
   use mctc_env, only : wp
   use mctc_io_constants, only : pi
   use mctc_io_math, only : matdet_3x3, matinv_3x3
   implicit none
   private

   public :: get_alpha, get_dir_cutoff, get_rec_cutoff

   real(wp), parameter :: twopi = 2 * pi
   real(wp), parameter :: sqrtpi = sqrt(pi)
   real(wp), parameter :: eps = sqrt(epsilon(0.0_wp))

   !> Evaluator for interaction term
   type, abstract :: term_type
   contains
      !> Interaction at specified distance
      procedure(get_value), deferred :: get_value
   end type term_type

   abstract interface
      !> Interaction at specified distance
      pure function get_value(self, dist, alpha, vol) result(val)
         import :: term_type, wp
         !> Instance of interaction
         class(term_type), intent(in) :: self
         !> Distance between the two atoms
         real(wp), intent(in) :: dist
         !> Parameter of the Ewald summation
         real(wp), intent(in) :: alpha
         !> Volume of the real space unit cell
         real(wp), intent(in) :: vol
         !> Value of the interaction
         real(wp) :: val
      end function get_value
   end interface

   !> Real space Coulombic interaction 1/R
   type, extends(term_type) :: dir_term
   contains
      procedure :: get_value => dir_value
   end type dir_term

   !> Reciprocal space Coulombic interaction 1/R in 3D
   type, extends(term_type) :: rec_3d_term
   contains
      procedure :: get_value => rec_3d_value
   end type rec_3d_term

   !> Real space Coulombic interaction 1/R^2
   type, extends(term_type) :: dir_mp_term
   contains
      procedure :: get_value => dir_mp_value
   end type dir_mp_term

   !> Reciprocal space Coulombic interaction 1/R^2 in 3D
   type, extends(term_type) :: rec_3d_mp_term
   contains
      procedure :: get_value => rec_3d_mp_value
   end type rec_3d_mp_term

contains


!> Convenience interface to determine Ewald splitting parameter
subroutine get_alpha(lattice, alpha, multipole)
   !> Lattice vectors
   real(wp), intent(in) :: lattice(:, :)
   !> Estimated Ewald splitting parameter
   real(wp), intent(out) :: alpha
   !> Multipole expansion is used
   logical, intent(in) :: multipole

   real(wp) :: vol, rec_lat(3, 3)
   class(term_type), allocatable :: dirv, recv

   vol = abs(matdet_3x3(lattice))
   rec_lat = twopi*transpose(matinv_3x3(lattice))
   if (multipole) then
      dirv = dir_mp_term()
      recv = rec_3d_mp_term()
   else
      dirv = dir_term()
      recv = rec_3d_term()
   end if

   call search_alpha(lattice, rec_lat, vol, eps, dirv, recv, alpha)
end subroutine get_alpha


!> Get optimal alpha-parameter for the Ewald summation by finding alpha, where
!> decline of real and reciprocal part of Ewald are equal.
subroutine search_alpha(lattice, rec_lat, volume, tolerance, dirv, recv, alpha)
   !> Lattice vectors
   real(wp), intent(in) :: lattice(:,:)
   !> Reciprocal vectors
   real(wp), intent(in) :: rec_lat(:,:)
   !> Volume of the unit cell
   real(wp), intent(in) :: volume
   !> Tolerance for difference in real and rec. part
   real(wp), intent(in) :: tolerance
   !> Real-space interaction term
   class(term_type), intent(in) :: dirv
   !> Reciprocal space interaction term
   class(term_type), intent(in) :: recv
   !> Optimal alpha
   real(wp), intent(out) :: alpha

   real(wp) :: alpl, alpr, rlen, dlen, diff
   real(wp), parameter :: alpha0 = sqrt(epsilon(0.0_wp))
   integer, parameter :: niter = 30
   integer :: ibs, stat

   rlen = sqrt(minval(sum(rec_lat(:,:)**2, dim=1)))
   dlen = sqrt(minval(sum(lattice(:,:)**2, dim=1)))

   stat = 0
   alpha = alpha0
   diff = rec_dir_diff(alpha, dirv, recv, rlen, dlen, volume)
   do while (diff < -tolerance .and. alpha <= huge(1.0_wp))
      alpha = 2.0_wp * alpha
      diff = rec_dir_diff(alpha, dirv, recv, rlen, dlen, volume)
   end do
   if (alpha > huge(1.0_wp)) then
      stat = 1
   elseif (alpha == alpha0) then
      stat = 2
   end if

   if (stat == 0) then
      alpl = 0.5_wp * alpha
      do while (diff < tolerance .and. alpha <= huge(1.0_wp))
         alpha = 2.0_wp * alpha
         diff = rec_dir_diff(alpha, dirv, recv, rlen, dlen, volume)
      end do
      if (alpha > huge(1.0_wp)) then
         stat = 3
      end if
   end if

   if (stat == 0) then
      alpr = alpha
      alpha = (alpl + alpr) * 0.5_wp
      ibs = 0
      diff = rec_dir_diff(alpha, dirv, recv, rlen, dlen, volume)
      do while (abs(diff) > tolerance .and. ibs <= niter)
         if (diff < 0) then
            alpl = alpha
         else
            alpr = alpha
         end if
         alpha = (alpl + alpr) * 0.5_wp
         diff = rec_dir_diff(alpha, dirv, recv, rlen, dlen, volume)
         ibs = ibs + 1
      end do
      if (ibs > niter) then
         stat = 4
      end if
   end if

   if (stat /= 0) then
      alpha = 0.25_wp
   end if

end subroutine search_alpha


!> Return cutoff for reciprocal contributions
function get_rec_cutoff(alpha, volume, conv) result(x)
   !> Parameter of Ewald summation
   real(wp), intent(in) :: alpha
   !> Volume of the unit cell
   real(wp), intent(in) :: volume
   !> Tolerance value
   real(wp), intent(in) :: conv
   !> Magnitude of reciprocal vector
   real(wp) :: x

   class(term_type), allocatable :: term

   term = rec_3d_term()
   x = search_cutoff(term, alpha, volume, conv)

end function get_rec_cutoff


!> Return cutoff for real-space contributions
function get_dir_cutoff(alpha, conv) result(x)
   !> Parameter of Ewald summation
   real(wp), intent(in) :: alpha
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Magnitude of real-space vector
   real(wp) :: x

   real(wp), parameter :: volume = 0.0_wp
   class(term_type), allocatable :: term

   term = dir_term()
   x = search_cutoff(term, alpha, volume, conv)

end function get_dir_cutoff


!> Search for cutoff value of interaction term
function search_cutoff(term, alpha, volume, conv) result(x)
   !> Interaction term
   class(term_type), intent(in) :: term
   !> Parameter of Ewald summation
   real(wp), intent(in) :: alpha
   !> Volume of the unit cell
   real(wp), intent(in) :: volume
   !> Tolerance value
   real(wp), intent(in) :: conv
   !> Magnitude of reciprocal vector
   real(wp) :: x

   real(wp), parameter :: init = sqrt(epsilon(0.0_wp))
   integer, parameter :: miter = 30
   real(wp) :: xl, xr, yl, yr, y
   integer :: iter

   x = init
   y = term%get_value(x, alpha, volume)
   do while (y > conv .and. x <= huge(1.0_wp))
      x = 2.0_wp * x
      y = term%get_value(x, alpha, volume)
   end do

   xl = 0.5_wp * x
   yl = term%get_value(xl, alpha, volume)
   xr = x
   yr = y

   do iter = 1, miter
      if (yl - yr <= conv) exit
      x = 0.5_wp * (xl + xr)
      y = term%get_value(x, alpha, volume)
      if (y >= conv) then
         xl = x
         yl = y
      else
         xr = x
         yr = y
      end if
   end do

end function search_cutoff


!> Returns the difference in the decrease of the real and reciprocal parts of the
!> Ewald sum. In order to make the real space part shorter than the reciprocal
!> space part, the values are taken at different distances for the real and the
!> reciprocal space parts.
pure function rec_dir_diff(alpha, dirv, recv, rlen, dlen, volume) result(diff)
   !> Parameter for the Ewald summation
   real(wp), intent(in) :: alpha
   !> Procedure pointer to real-space routine
   class(term_type), intent(in) :: dirv
   !> Procedure pointer to reciprocal routine
   class(term_type), intent(in) :: recv
   !> Length of the shortest reciprocal space vector in the sum
   real(wp), intent(in) :: rlen
   !> Length of the shortest real space vector in the sum
   real(wp), intent(in) :: dlen
   !> Volume of the real space unit cell
   real(wp), intent(in) :: volume
   !> Difference between changes in the two terms
   real(wp) :: diff

   diff = ((recv%get_value(4*rlen, alpha, volume) - recv%get_value(5*rlen, alpha, volume))) &
      & - (dirv%get_value(2*dlen, alpha, volume) - dirv%get_value(3*dlen, alpha, volume))

end function rec_dir_diff


!> Returns the max. value of a term in the reciprocal space part of the Ewald
!> summation for a given vector length.
pure function rec_3d_value(self, dist, alpha, vol) result(rval)
   !> Instance of interaction
   class(rec_3d_term), intent(in) :: self
   !> Length of the reciprocal space vector
   real(wp), intent(in) :: dist
   !> Parameter of the Ewald summation
   real(wp), intent(in) :: alpha
   !> Volume of the real space unit cell
   real(wp), intent(in) :: vol
   !> Reciprocal term
   real(wp) :: rval

   rval = 4.0_wp*pi*(exp(-0.25_wp*dist*dist/(alpha**2))/(vol*dist*dist))

end function rec_3d_value


!> Returns the max. value of a term in the reciprocal space part of the Ewald
!> summation for a given vector length.
pure function rec_3d_mp_value(self, dist, alpha, vol) result(rval)
   !> Instance of interaction
   class(rec_3d_mp_term), intent(in) :: self
   !> Length of the reciprocal space vector
   real(wp), intent(in) :: dist
   !> Parameter of the Ewald summation
   real(wp), intent(in) :: alpha
   !> Volume of the real space unit cell
   real(wp), intent(in) :: vol
   !> Reciprocal term
   real(wp) :: rval

   real(wp) :: g2

   g2 = dist*dist

   rval = 4.0_wp*pi*(exp(-0.25_wp*g2/(alpha**2))/vol)

end function rec_3d_mp_value


!> Direct space interaction at specified distance
pure function dir_value(self, dist, alpha, vol) result(val)
   !> Instance of interaction
   class(dir_term), intent(in) :: self
   !> Distance between the two atoms
   real(wp), intent(in) :: dist
   !> Parameter of the Ewald summation
   real(wp), intent(in) :: alpha
   !> Volume of the real space unit cell
   real(wp), intent(in) :: vol
   !> Value of the interaction
   real(wp) :: val

   val = erfc(alpha*dist)/dist
end function dir_value

!> Direct space interaction at specified distance
pure function dir_mp_value(self, dist, alpha, vol) result(val)
   !> Instance of interaction
   class(dir_mp_term), intent(in) :: self
   !> Distance between the two atoms
   real(wp), intent(in) :: dist
   !> Parameter of the Ewald summation
   real(wp), intent(in) :: alpha
   !> Volume of the real space unit cell
   real(wp), intent(in) :: vol
   !> Value of the interaction
   real(wp) :: val

   real(wp) :: arg

   arg = alpha * dist

   val = (2/sqrtpi*arg*exp(-arg*arg) + erfc(arg))/dist**3
end function dir_mp_value

end module tblite_coulomb_ewald

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file src/ddx_core.f90
!! Core routines and parameters of the entire ddX software
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-02-25

!> Core routines and parameters of the ddX software
module ddx_core
! Get ddx_params_type and all compile-time definitions
use ddx_parameters
! Get ddx_constants_type and all run-time constants
use ddx_constants
! Get ddx_workspace_type for temporary buffers
use ddx_workspace
! Get harmonics-related functions
use ddx_harmonics
! Enable OpenMP
use omp_lib
implicit none

!> @defgroup Fortran_interface_core Fortran interface: core routines

!> This defined type contains the primal and adjoint RHSs, the solution of
!! the primal and adjoint linear systems, useful intermediates for the
!! computation of the forces, and the information about the convergence of
!! the linear system solver (time, number of iterations, relative difference
!! at each iteration).
type ddx_state_type
    !! High-level entities to be stored and accessed by users

    !!
    !! Quantities common to all models.
    !!
    !> Representation of the solute density in spherical harmonics
    !! (\f$ \Psi \f$). It is used as RHS for the adjoint linear system.
    !! Dimension (nbasis, nsph).
    real(dp), allocatable :: psi(:, :)
    !> Electric potential at the cavity points. It is used to construct
    !! the RHS for the primal linear system. Dimension (ncav).
    real(dp), allocatable :: phi_cav(:)
    !> Electric field at the cavity points. It is used in the ddLPB
    !! forces.
    real(dp), allocatable :: gradphi_cav(:, :)
    !> Potential at all the grid points. Dimension (ngrid, nsph).
    real(dp), allocatable :: phi_grid(:, :)
    !> Zeta intermediate for the forces. Dimension (ncav).
    real(dp), allocatable :: zeta(:)
    !> Time to compute the solvation force terms
    real(dp) :: force_time

    !!
    !! ddCOSMO quantities (used also by ddPCM).
    !!
    !> Variable \f$ \Phi \f$ of a dimension (nbasis, nsph).
    !! Allocated and used by the COSMO (model=1) and PCM (model=2) models.
    real(dp), allocatable :: phi(:, :)
    !> Solution of the ddCOSMO system of a dimension (nbasis, nsph).
    !! Allocated and used by the COSMO (model=1) and PCM (model=2) models.
    real(dp), allocatable :: xs(:, :)
    !> Number of iterations to solve the primal ddCOSMO linear system.
    !! Used by the COSMO (model=1) and PCM (model=2) models.
    integer :: xs_niter
    !> Relative ddx_error of the iterative solver at each iteration of the primal
    !! ddCOSMO linear system, dimension (maxiter).
    !! Allocated and used by the COSMO (model=1) and PCM (model=2) models.
    real(dp), allocatable :: xs_rel_diff(:)
    !> Time to solve the primal ddCOSMO linear system.
    !! Used by the COSMO (model=1) and PCM (model=2) models.
    real(dp) :: xs_time
    !> Values of s at grid points. Dimension is (ngrid, nsph).
    !! Allocated and used by the COSMO (model=1) and PCM (model=2) models.
    real(dp), allocatable :: sgrid(:, :)
    !> Solution of the adjoint ddCOSMO linear system, dimension (nbasis, nsph).
    !! Allocated and used by the COSMO (model=1) and PCM (model=2) models.
    real(dp), allocatable :: s(:, :)
    !> Number of iterations required to solve the adjoint ddCOSMO linear
    !! system. Used by the COSMO (model=1) and PCM (model=2) models.
    integer :: s_niter
    !> Relative ddx_error of the iterative solver at each iteration of the adjoint
    !! ddCOSMO linear system, dimension (maxiter).
    !! Allocated and used by the COSMO (model=1) and PCM (model=2) models.
    real(dp), allocatable :: s_rel_diff(:)
    !> Time to solve the adjoint ddCOSMO linear system.
    !! Used by the COSMO (model=1) and PCM (model=2) models.
    real(dp) :: s_time

    !!
    !! ddPCM specific quantities.
    !!
    !> Variable \f$ \Phi_\infty \f$ of a dimension (nbasis, nsph).
    !! Allocated and used only by PCM (model=2) model.
    real(dp), allocatable :: phiinf(:, :)
    !> Variable \f$ \Phi_\varepsilon \f$ of a dimension (nbasis, nsph).
    !! Allocated and used only by PCM (model=2) model.
    real(dp), allocatable :: phieps(:, :)
    !> Number of iterations to solve the primal ddPCM linear system system.
    !! Allocated and used only by PCM (model=2) model.
    integer :: phieps_niter
    !> Relative ddx_error of the iterative solver at each iteration of the primal
    !! ddPCM linear system, dimension (maxiter).
    !! Allocated and used only by PCM (model=2) model.
    real(dp), allocatable :: phieps_rel_diff(:)
    !> Time to solve the primal ddPCM linear system.
    !! Used only by PCM (model=2) model.
    real(dp) :: phieps_time
    !> Shortcut of \f$ \Phi_\varepsilon - \Phi \f$ for the computation of
    !! the ddPCM forces.
    !! Allocated and used only by PCM (model=2) model.
    real(dp), allocatable :: g(:, :)
    !> Solution of the adjoint ddPCM linear system, dimension (nbasis, nsph).
    !! Allocated and used only by PCM (model=2) model.
    real(dp), allocatable :: y(:, :)
    !> Number of iteration to solve the adjoint ddPCM linear system.
    !! Used only by PCM (model=2) model.
    integer :: y_niter
    !> Relative ddx_error of the iterative solver at each iteration of the adjoint
    !! ddPCM linear system. Allocated and used only by the PCM (model=2) model.
    real(dp), allocatable :: y_rel_diff(:)
    !> Time to solve adjoint ddPCM system
    real(dp) :: y_time
    !> Solution of the adjoint ddPCM linear system, dimension (nbasis, nsph).
    !! Allocated and used only by PCM (model=2) model.
    real(dp), allocatable :: ygrid(:, :)
    !> Effective total adjoint solution of the ddPCM model, defined as
    !! \f$ Q := S - \frac{4\pi}{\varepsilon-1}Y \f$. Dimension (nbasis, nsph).
    !! Allocated and used only by PCM (model=2) model.
    real(dp), allocatable :: q(:, :)
    !> Values of Q at grid points. Dimension (ngrid, nsph).
    !! Allocated and used only by PCM (model=2) model.
    real(dp), allocatable :: qgrid(:, :)

    !!
    !! ddLPB quantities
    !!
    !> ddLPB RHS. Dimension (nbasis, nsph, 2).
    !! Allocated and used only by the LPB (model=3) model.
    real(dp), allocatable :: rhs_lpb(:,:,:)
    !> ddLPB adjoint RHS. Dimension (nbasis, nsph, 2).
    !! Allocated and used only by the LPB (model=3) model.
    real(dp), allocatable :: rhs_adj_lpb(:,:,:)
    !> Solution to the ddLPB linear system. Dimension (nbasis, nsph, 2).
    !! Allocated and used only by the LPB (model=3) model.
    real(dp), allocatable :: x_lpb(:,:,:)
    !> Solution to the ddLPB adjoint linear system.
    !! Dimension (nbasis, nsph, 2).
    !! Allocated and used only by the LPB (model=3) model.
    real(dp), allocatable :: x_adj_lpb(:,:,:)
    !> g RHS for ddLPB.
    !! Allocated and used only by the LPB (model=3) model.
    real(dp), allocatable :: g_lpb(:,:)
    !> f RHS for ddLPB.
    !! Allocated and used only by the LPB (model=3) model.
    real(dp), allocatable :: f_lpb(:,:)
    !> Number of iterations required to solve the primal ddLPB linear system.
    !! Allocated and used only by the LPB (model=3) model.
    integer :: x_lpb_niter
    !> Number of iterations required to solve the adjoint ddLPB linear ststem.
    !! Allocated and used only by the LPB (model=3) model.
    integer :: x_adj_lpb_niter
    !> Time required to solve the primal ddLPB linear system.
    !! Allocated and used only by the LPB (model=3) model.
    real(dp) :: x_lpb_time
    !> Time required to solve the adjoint ddLPB linear system.
    !! Allocated and used only by the LPB (model=3) model.
    real(dp) :: x_adj_lpb_time
    !> Relative ddx_error of the iterative solver at each iteration of the primal
    !! ddLPB linear system, dimension (maxiter).
    !! Allocated and used only by the LPB (model=3) model.
    real(dp), allocatable :: x_lpb_rel_diff(:)
    !> Relative ddx_error of the iterative solver at each iteration of the adjoint
    !! ddLPB linear system, dimension (maxiter).
    !! Allocated and used only by the LPB (model=3) model.
    real(dp), allocatable :: x_adj_lpb_rel_diff(:)
    !> Zeta dipoles intermediate for the forces. Dimension (3, ncav).
    !! Allocated and used only by the LPB (model=3) model.
    real(dp), allocatable :: zeta_dip(:, :)
    real(dp), allocatable :: x_adj_re_grid(:, :)
    real(dp), allocatable :: x_adj_r_grid(:, :)
    real(dp), allocatable :: x_adj_e_grid(:, :)
    real(dp), allocatable :: phi_n(:, :)
    real(dp) :: hsp_time
    real(dp) :: hsp_adj_time

    !! Some flags to see if quantities are properly initialized
    logical :: rhs_done
    logical :: adjoint_rhs_done
    logical :: guess_done
    logical :: solved
    logical :: adjoint_guess_done
    logical :: adjoint_solved

end type ddx_state_type

!> Container for the electrostatic properties. Since different methods
!! require different electrostatic properties, defining this kind of
!! general purpose container simplify the interfaces as we don't need
!! different interfaces for different methods.
type ddx_electrostatics_type
    !> Electric potential at the cavity points, size (ncav).
    real(dp), allocatable :: phi_cav(:)
    !> Electric field at the cavity points, defined as minus gradient
    !! of the potential, size (3, ncav).
    real(dp), allocatable :: e_cav(:, :)
    !> Electric field gradient at the cavity points, defined as minus the
    !! gradient of the electric potential, size (3, 3, ncav).
    real(dp), allocatable :: g_cav(:, :, :)
    !> Flag for enabling the computation of the electric potential.
    logical :: do_phi = .false.
    !> Flag for enabling the computation of the electric field.
    logical :: do_e = .false.
    !> Flag for enabling the computation of the electric field gradient.
    logical :: do_g = .false.
end type ddx_electrostatics_type

!> Main ddX type that stores all the required information.
!! Container for the params, contants and workspace derived types.
type ddx_type
    !! New types inside the old one for an easier shift to the new design
    type(ddx_params_type) :: params
    type(ddx_constants_type) :: constants
    type(ddx_workspace_type) :: workspace
end type ddx_type

contains

!------------------------------------------------------------------------------
!> Initialize ddX input with a full set of parameters
!!
!! @param[in] nsph: Number of atoms. n > 0.
!! @param[in] x: \f$ x \f$ coordinates of atoms. Dimension is `(n)`
!! @param[in] y: \f$ y \f$ coordinates of atoms. Dimension is `(n)`
!! @param[in] z: \f$ z \f$ coordinates of atoms. Dimension is `(n)`
!! @param[in] rvdw: Van-der-Waals radii of atoms. Dimension is `(n)`
!! @param[in] model: Choose model: 1 for COSMO, 2 for PCM and 3 for LPB
!! @param[in] lmax: Maximal degree of modeling spherical harmonics. `lmax` >= 0
!! @param[in] ngrid: Number of Lebedev grid points `ngrid` >= 0
!! @param[in] force: 1 if forces are required and 0 otherwise
!! @param[in] fmm: 1 to use FMM acceleration and 0 otherwise
!! @param[in] pm: Maximal degree of multipole spherical harmonics. Ignored in
!!      the case `fmm=0`. Value -1 means no far-field FMM interactions are
!!      computed. `pm` >= -1.
!! @param[in] pl: Maximal degree of local spherical harmonics. Ignored in
!!      the case `fmm=0`. Value -1 means no far-field FMM interactions are
!!      computed. `pl` >= -1.
!! @param[in] se: Shift of characteristic function. -1 for interior, 0 for
!!      centered and 1 for outer regularization
!! @param[in] eta: Regularization parameter. 0 < eta <= 1.
!! @param[in] eps: Relative dielectric permittivity. eps > 1.
!! @param[in] kappa: Debye-H\"{u}ckel parameter
!! @param[in] matvecmem: handling of the sparse matrices. 1 for precomputin
!!      them and keeping them in memory, 0 for assembling the matrix-vector
!!      product on-the-fly. 
!! @param[in] maxiter: Maximum number of iterations for an iterative solver.
!!      maxiter > 0.
!! @param[in] ndiis: Number of extrapolation points for Jacobi/DIIS solver.
!!      ndiis >= 0.
!! @param[inout] nproc: Number of OpenMP threads to be used where applicable.
!! @param[out] ddx_data: Object containing all inputs
!! @param[inout] ddx_error: ddX error
!------------------------------------------------------------------------------
subroutine allocate_model(nsph, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, maxiter, jacobi_ndiis, nproc, &
        & output_filename, ddx_data, ddx_error)
    ! Inputs
    implicit none
    integer, intent(in) :: nsph, model, lmax, force, fmm, pm, pl, &
        & matvecmem, maxiter, jacobi_ndiis, &
        & ngrid, nproc
    real(dp), intent(in):: x(nsph), y(nsph), z(nsph), &
        & rvdw(nsph), se, eta, eps, kappa
    character(len=255), intent(in) :: output_filename
    ! Output
    type(ddx_type), target, intent(out) :: ddx_data
    type(ddx_error_type), intent(inout) :: ddx_error
    ! Local variables
    real(dp), allocatable :: csph(:, :)
    integer :: istatus
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "allocate_model received input in error state, " // &
            & "exiting")
        return
    end if
    ! Init underlying objects
    allocate(csph(3, nsph), stat=istatus)
    if (istatus .ne. 0) then
        call update_error(ddx_error, "Allocation failed in allocate_model")
        return
    end if
    csph(1, :) = x
    csph(2, :) = y
    csph(3, :) = z
    call params_init(model, force, eps, kappa, eta, se, lmax, ngrid, &
        & matvecmem, maxiter, jacobi_ndiis, fmm, pm, pl, nproc, nsph, &
        & csph, rvdw, output_filename, ddx_data % params, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "params_init returned an error, exiting")
        return
    end if
    call constants_init(ddx_data % params, ddx_data % constants, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "constants_init returned an error, exiting")
        return
    end if
    call workspace_init(ddx_data % params, ddx_data % constants, &
        & ddx_data % workspace, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "workspace_init returned an error, exiting")
        return
    end if
    deallocate(csph, stat=istatus)
    if (istatus .ne. 0) then
        call update_error(ddx_error, "Deallocation failed in allocate_model")
        return
    end if
end subroutine allocate_model

!------------------------------------------------------------------------------
!> Deallocate object with corresponding data
!!
!! @param[inout] ddx_data: object to deallocate
!! @param[inout] ddx_error: ddX error
!------------------------------------------------------------------------------
subroutine deallocate_model(ddx_data, ddx_error)
    implicit none
    ! Input/output
    type(ddx_type), intent(inout) :: ddx_data
    type(ddx_error_type), intent(inout) :: ddx_error
    ! Local variables
    call workspace_free(ddx_data % workspace, ddx_error)
    call constants_free(ddx_data % constants, ddx_error)
    call params_free(ddx_data % params, ddx_error)
end subroutine deallocate_model

!> Given the chosen model, find the required electrostatic properties,
!! and allocate the arrays for them in the container.
!!
!> @ingroup Fortran_interface_core
!! @param[in] params: ddx parameters
!! @param[in]  constants: ddx constants
!! @param[out] electrostatics, ddX electrostatic properties container
!! @param[inout] ddx_error: ddX error
!!
subroutine allocate_electrostatics(params, constants, electrostatics, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_electrostatics_type), intent(out) :: electrostatics
    type(ddx_error_type), intent(inout) :: ddx_error

    ! local variables
    integer :: info

    ! Figure out the required properties
    if (params % model .eq. 3) then
        if (params % force .eq. 1) then
            electrostatics % do_phi = .true.
            electrostatics % do_e = .true.
            electrostatics % do_g = .true.
        else
            electrostatics % do_phi = .true.
            electrostatics % do_e = .true.
            electrostatics % do_g = .false.
        end if
    else
        if (params % force .eq. 1) then
            electrostatics % do_phi = .true.
            electrostatics % do_e = .true.
            electrostatics % do_g = .false.
        else
            electrostatics % do_phi = .true.
            electrostatics % do_e = .false.
            electrostatics % do_g = .false.
        end if
    end if

    ! Allocate the arrays for the required electrostatic properties
    if (electrostatics % do_phi) then
        allocate(electrostatics % phi_cav(constants % ncav), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, &
                & "Allocation failed in allocate_electrostatics")
            return
        end if
    end if
    if (electrostatics % do_e) then
        allocate(electrostatics % e_cav(3, constants % ncav), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, &
                & "Allocation failed in allocate_electrostatics")
            return
        end if
    end if
    if (electrostatics % do_g) then
        allocate(electrostatics % g_cav(3, 3, constants % ncav), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, &
                & "Allocation failed in allocate_electrostatics")
            return
        end if
    end if
end subroutine allocate_electrostatics

!> Deallocate the electrostatic properties.
!!
!> @ingroup Fortran_interface_core
!! @param[out] electrostatics, ddX electrostatic properties container
!! @param[inout] ddx_error: ddX error
!!
subroutine deallocate_electrostatics(electrostatics, ddx_error)
    implicit none
    type(ddx_electrostatics_type), intent(inout) :: electrostatics
    type(ddx_error_type), intent(inout) :: ddx_error

    ! local variables
    integer :: info

    ! Allocate the arrays for the required electrostatic properties
    if (allocated(electrostatics % phi_cav)) then
        deallocate(electrostatics % phi_cav, stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, &
                & "Deallocation failed in deallocate_electrostatics")
        end if
    end if
    if (allocated(electrostatics % e_cav)) then
        deallocate(electrostatics % e_cav, stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, &
                & "Deallocation failed in deallocate_electrostatics")
        end if
    end if
    if (allocated(electrostatics % g_cav)) then
        deallocate(electrostatics % g_cav, stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, &
                & "Deallocation failed in deallocate_electrostatics")
        end if
    end if
end subroutine deallocate_electrostatics

!> Initialize the ddx_state object
!> @ingroup Fortran_interface_core
!!
!! @param[in] params: User specified parameters
!! @param[in] constants: Precomputed constants
!! @param[inout] state: ddx state (contains solutions and RHSs)
!! @param[inout] ddx_error: ddX error
!!
subroutine allocate_state(params, constants, state, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_state_type), intent(out) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    integer :: istatus

    state % rhs_done = .false.
    state % adjoint_rhs_done = .false.
    state % guess_done = .false.
    state % solved = .false.
    state % adjoint_guess_done = .false.
    state % adjoint_solved = .false.

    allocate(state % psi(constants % nbasis, params % nsph), stat=istatus, source=0.0_dp)
    if (istatus .ne. 0) then
        call update_error(ddx_error, "allocate_state: `psi` allocation failed")
        return
    end if
    allocate(state % phi_cav(constants % ncav), stat=istatus, source=0.0_dp)
    if (istatus .ne. 0) then
        call update_error(ddx_error, "allocate_state: `phi_cav` allocation failed")
        return
    end if
    allocate(state % gradphi_cav(3, constants % ncav), stat=istatus, source=0.0_dp)
    if (istatus .ne. 0) then
        call update_error(ddx_error, &
            & "allocate_state: `gradphi_cav` allocation failed")
        return
    end if
    allocate(state % q(constants % nbasis, &
        & params % nsph), stat=istatus, source=0.0_dp)
    if (istatus .ne. 0) then
        call update_error(ddx_error, "allocate_state: `q` " // &
            & "allocation failed")
        return
    end if

    ! COSMO model
    if (params % model .eq. 1) then
        allocate(state % phi_grid(params % ngrid, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `phi_grid` " // &
                & "allocation failed")
            return
        end if
        allocate(state % phi(constants % nbasis, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `phi` " // &
                & "allocation failed")
            return
        end if
        allocate(state % xs(constants % nbasis, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `xs` " // &
                & "allocation failed")
            return
        end if
        allocate(state % xs_rel_diff(params % maxiter), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `xs_rel_diff` " // &
                & "allocation failed")
            return
        end if
        allocate(state % s(constants % nbasis, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `s` " // &
            & "allocation failed")
            return
        end if
        allocate(state % s_rel_diff(params % maxiter), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `s_rel_diff` " // &
                & "allocation failed")
            return
        end if
        allocate(state % sgrid(params % ngrid, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `sgrid` " // &
                & "allocation failed")
            return
        end if
        allocate(state % zeta(constants % ncav), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `zeta` " // &
                & "allocation failed")
            return
        end if
    ! PCM model
    else if (params % model .eq. 2) then
        allocate(state % phi_grid(params % ngrid, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `phi_grid` " // &
                & "allocation failed")
            return
        end if
        allocate(state % phi(constants % nbasis, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `phi` " // &
                & "allocation failed")
            return
        end if
        allocate(state % phiinf(constants % nbasis, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `phiinf` " // &
                & "allocation failed")
            return
        end if
        allocate(state % phieps(constants % nbasis, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `phieps` " // &
                & "allocation failed")
            return
        end if
        allocate(state % phieps_rel_diff(params % maxiter), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `xs_rel_diff` " // &
                & "allocation failed")
            return
        end if
        allocate(state % xs(constants % nbasis, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `xs` " // &
                & "allocation failed")
            return
        end if
        allocate(state % xs_rel_diff(params % maxiter), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `xs_rel_diff` " // &
                & "allocation failed")
            return
        end if
        allocate(state % s(constants % nbasis, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `s` " // &
                & "allocation failed")
            return
        end if
        allocate(state % s_rel_diff(params % maxiter), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `xs_rel_diff` " // &
                & "allocation failed")
            return
        end if
        allocate(state % sgrid(params % ngrid, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `sgrid` " // &
                & "allocation failed")
            return
        end if
        allocate(state % y(constants % nbasis, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `y` " // &
                & "allocation failed")
            return
        end if
        allocate(state % y_rel_diff(params % maxiter), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `y_rel_diff` " // &
                & "allocation failed")
            return
        end if
        allocate(state % ygrid(params % ngrid, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `ygrid` " // &
                & "allocation failed")
            return
        end if
        allocate(state % g(constants % nbasis, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `g` " // &
                & "allocation failed")
            return
        end if
        allocate(state % qgrid(params % ngrid, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `qgrid` " // &
                & "allocation failed")
            return
        end if
        allocate(state % zeta(constants % ncav), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `zeta` " // &
                & "allocation failed")
            return
        end if
    ! LPB model
    else if (params % model .eq. 3) then
        allocate(state % phi_grid(params % ngrid, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `phi_grid` " // &
                & "allocation failed")
            return
        end if
        allocate(state % phi(constants % nbasis, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `phi` " // &
                & "allocation failed")
            return
        end if
        allocate(state % zeta(constants % ncav), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `zeta` " // &
                & "allocation failed")
            !write(*, *) "ddx_Error in allocation of M2P matrices"
            return
        end if
        allocate(state % x_lpb_rel_diff(params % maxiter), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `x_lpb_rel_diff` " // &
                & "allocation failed")
            return
        end if
        allocate(state % rhs_lpb(constants % nbasis, &
            & params % nsph, 2), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `rhs_lpb` " // &
                & "allocation failed")
            return
        end if
        allocate(state % rhs_adj_lpb(constants % nbasis, &
            & params % nsph, 2), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `rhs_adj_lpb` " // &
                & "allocation failed")
            return
        end if
        allocate(state % x_lpb(constants % nbasis, &
            & params % nsph, 2), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `x_lpb` " // &
                & "allocation failed")
            return
        end if
        allocate(state % x_adj_lpb(constants % nbasis, &
            & params % nsph, 2), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `x_adj_lpb` " // &
                & "allocation failed")
            return
        end if
        allocate(state % x_adj_lpb_rel_diff(params % maxiter), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, &
                & "allocate_state: `x_adj_lpb_rel_diff` allocation failed")
            return
        end if
        allocate(state % g_lpb(params % ngrid, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `g_lpb` " // &
                & "allocation failed")
            return
        end if
        allocate(state % f_lpb(params % ngrid, &
            & params % nsph), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `f_lpb` " // &
                & "allocation failed")
            return
        end if
        allocate(state % zeta_dip(3, constants % ncav), stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `zeta_dip` " // &
                & "allocation failed")
            return
        end if
        allocate(state % x_adj_re_grid(params % ngrid, params % nsph), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `x_adj_re_grid` " // &
                & "allocation failed")
            return
        end if
        allocate(state % x_adj_r_grid(params % ngrid, params % nsph), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `x_adj_r_grid` " // &
                & "allocation failed")
            return
        end if
        allocate(state % x_adj_e_grid(params % ngrid, params % nsph), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `x_adj_e_grid` " // &
                & "allocation failed")
            return
        end if
        allocate(state % phi_n(params % ngrid, params % nsph), &
            & stat=istatus, source=0.0_dp)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "allocate_state: `phi_n` " // &
                & "allocation failed")
            return
        end if
    end if
end subroutine allocate_state


!> Deallocate the ddx_state object
!> @ingroup Fortran_interface_core
!!
!! @param[inout] state: ddx state (contains solutions and RHSs)
!! @param[inout] ddx_error: ddX error
!!
subroutine deallocate_state(state, ddx_error)
    implicit none
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    integer :: istatus

    if (allocated(state % phi_cav)) then
        deallocate(state % phi_cav, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`phi_cav` deallocation failed!")
            return
        endif
    end if
    if (allocated(state % gradphi_cav)) then
        deallocate(state % gradphi_cav, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`gradphi_cav` deallocation failed!")
            return
        endif
    end if
    if (allocated(state % psi)) then
        deallocate(state % psi, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`psi` deallocation failed!")
            return
        endif
    end if
    if (allocated(state % phi_grid)) then
        deallocate(state % phi_grid, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`phi_grid` deallocation failed!")
            return
        endif
    end if
    if (allocated(state % phi)) then
        deallocate(state % phi, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`phi` deallocation failed!")
        endif
    end if
    if (allocated(state % phiinf)) then
        deallocate(state % phiinf, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`phiinf` deallocation failed!")
        endif
    end if
    if (allocated(state % phieps)) then
        deallocate(state % phieps, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`phieps` deallocation failed!")
        endif
    end if
    if (allocated(state % phieps_rel_diff)) then
        deallocate(state % phieps_rel_diff, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`phieps_rel_diff` deallocation failed!")
        endif
    end if
    if (allocated(state % xs)) then
        deallocate(state % xs, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`xs` deallocation failed!")
        endif
    end if
    if (allocated(state % xs_rel_diff)) then
        deallocate(state % xs_rel_diff, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`xs_rel_diff` deallocation failed!")
        endif
    end if
    if (allocated(state % s)) then
        deallocate(state % s, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`s` deallocation failed!")
        endif
    end if
    if (allocated(state % s_rel_diff)) then
        deallocate(state % s_rel_diff, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`s_rel_diff` deallocation failed!")
        endif
    end if
    if (allocated(state % sgrid)) then
        deallocate(state % sgrid, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`sgrid` deallocation failed!")
        endif
    end if
    if (allocated(state % y)) then
        deallocate(state % y, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`y` deallocation failed!")
        endif
    end if
    if (allocated(state % y_rel_diff)) then
        deallocate(state % y_rel_diff, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`y_rel_diff` deallocation failed!")
        endif
    end if
    if (allocated(state % ygrid)) then
        deallocate(state % ygrid, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`ygrid` deallocation failed!")
        endif
    end if
    if (allocated(state % g)) then
        deallocate(state % g, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`g` deallocation failed!")
        endif
    end if
    if (allocated(state % q)) then
        deallocate(state % q, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`q` deallocation failed!")
        endif
    end if
    if (allocated(state % qgrid)) then
        deallocate(state % qgrid, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`qgrid` deallocation failed!")
        endif
    end if
    if (allocated(state % zeta)) then
        deallocate(state % zeta, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`zeta` deallocation failed!")
        endif
    end if
    if (allocated(state % x_lpb)) then
        deallocate(state % x_lpb, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`x_lpb` deallocation failed!")
        endif
    end if
    if (allocated(state % x_lpb_rel_diff)) then
        deallocate(state % x_lpb_rel_diff, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`x_lpb_rel_diff` deallocation failed!")
        end if
    end if
    if (allocated(state % x_adj_lpb)) then
        deallocate(state % x_adj_lpb, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "x_adj_lpb deallocation failed!")
        endif
    end if
    if (allocated(state % x_adj_lpb_rel_diff)) then
        deallocate(state % x_adj_lpb_rel_diff, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`x_adj_lpb_rel_diff` deallocation failed!")
        end if
    end if
    if (allocated(state % g_lpb)) then
        deallocate(state % g_lpb, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`g_lpb` deallocation failed!")
        endif
    end if
    if (allocated(state % f_lpb)) then
        deallocate(state % f_lpb, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`f_lpb` deallocation failed!")
        endif
    end if
    if (allocated(state % rhs_lpb)) then
        deallocate(state % rhs_lpb, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`rhs_lpb` deallocation failed!")
        endif
    end if
    if (allocated(state % rhs_adj_lpb)) then
        deallocate(state % rhs_adj_lpb, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`rhs_adj_lpb` deallocation failed!")
        endif
    end if
    if (allocated(state % zeta_dip)) then
        deallocate(state % zeta_dip, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`zeta_dip` deallocation failed!")
        endif
    end if
    if (allocated(state % x_adj_re_grid)) then
        deallocate(state % x_adj_re_grid, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`x_adj_re_grid` deallocation failed!")
        endif
    end if
    if (allocated(state % x_adj_r_grid)) then
        deallocate(state % x_adj_r_grid, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`x_adj_r_grid` deallocation failed!")
        endif
    end if
    if (allocated(state % x_adj_e_grid)) then
        deallocate(state % x_adj_e_grid, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`x_adj_e_grid` deallocation failed!")
        endif
    end if
    if (allocated(state % phi_n)) then
        deallocate(state % phi_n, stat=istatus)
        if (istatus .ne. 0) then
            call update_error(ddx_error, "`phi_n` deallocation failed!")
        endif
    end if
end subroutine deallocate_state

!------------------------------------------------------------------------------
!> Print array of spherical harmonics
!!
!! Prints (nbasis, ncol) array
!!
!! @param[in] label: Label to print
!! @param[in] nbasis: Number of rows of input x. nbasis >= 0
!! @param[in] lmax: Maximal degree of corresponding spherical harmonics.
!!      (lmax+1)**2 = nbasis
!! @param[in] ncol: Number of columns to print
!! @param[in] icol: This number is only for printing purposes
!! @param[in] x: Actual data to print
subroutine print_spherical(iunit, label, nbasis, lmax, ncol, icol, x)
    implicit none
    ! Inputs
    character (len=*), intent(in) :: label
    integer, intent(in) :: nbasis, lmax, ncol, icol, iunit
    real(dp), intent(in) :: x(nbasis, ncol)
    ! Local variables
    integer :: l, m, ind, noff, nprt, ic, j
    ! Print header:
    if (ncol .eq. 1) then
        write (iunit,'(3x,a,1x,a,i4,a)') label, "(column ", icol, ")"
    else
        write (iunit,'(3x,a)') label
    endif
    ! Print entries:
    if (ncol .eq. 1) then
        do l = 0, lmax
            ind = l*l + l + 1
            do m = -l, l
                write(iunit,1000) l, m, x(ind+m, 1)
            end do
        end do
    else
        noff = mod(ncol, 5)
        nprt = max(ncol-noff, 0)
        do ic = 1, nprt, 5
            write(iunit,1010) (j, j = ic, ic+4)
            do l = 0, lmax
                ind = l*l + l + 1
                do m = -l, l
                    write(iunit,1020) l, m, x(ind+m, ic:ic+4)
                end do
            end do
        end do
        write (iunit,1010) (j, j = nprt+1, nprt+noff)
        do l = 0, lmax
            ind = l*l + l + 1
            do m = -l, l
                write(iunit,1020) l, m, x(ind+m, nprt+1:nprt+noff)
            end do
        end do
    end if
    1000 format(1x,i3,i4,f14.8)
    1010 format(8x,5i14)
    1020 format(1x,i3,i4,5f14.8)
end subroutine print_spherical

!------------------------------------------------------------------------------
!> Print array of quadrature points
!!
!! Prints (ngrid, ncol) array
!!
!! @param[in] label: Label to print
!! @param[in] ngrid: Number of rows of input x. ngrid >= 0
!! @param[in] ncol: Number of columns to print
!! @param[in] icol: This number is only for printing purposes
!! @param[in] x: Actual data to print
subroutine print_nodes(iunit, label, ngrid, ncol, icol, x)
    implicit none
    ! Inputs
    character (len=*), intent(in) :: label
    integer, intent(in) :: ngrid, ncol, icol, iunit
    real(dp), intent(in) :: x(ngrid, ncol)
    ! Local variables
    integer :: ig, noff, nprt, ic, j
    ! Print header :
    if (ncol .eq. 1) then
        write (iunit,'(3x,a,1x,a,i4,a)') label, "(column ", icol, ")"
    else
        write (iunit,'(3x,a)') label
    endif
    ! Print entries :
    if (ncol .eq. 1) then
        do ig = 1, ngrid
            write(iunit,1000) ig, x(ig, 1)
        enddo
    else
        noff = mod(ncol, 5)
        nprt = max(ncol-noff, 0)
        do ic = 1, nprt, 5
            write(iunit,1010) (j, j = ic, ic+4)
            do ig = 1, ngrid
                write(iunit,1020) ig, x(ig, ic:ic+4)
            end do
        end do
        write (iunit,1010) (j, j = nprt+1, nprt+noff)
        do ig = 1, ngrid
            write(iunit,1020) ig, x(ig, nprt+1:nprt+noff)
        end do
    end if
    !
    1000 format(1x,i5,f14.8)
    1010 format(6x,5i14)
    1020 format(1x,i5,5f14.8)
    !
end subroutine print_nodes

!------------------------------------------------------------------------------
!> Print dd Solution vector
!!
!! @param[in] label : Label to print
!! @param[in] vector: Vector to print
!------------------------------------------------------------------------------
subroutine print_ddvector(ddx_data, label, vector)
    implicit none
    ! Inputs
    type(ddx_type), intent(in)  :: ddx_data
    character(len=*) :: label
    real(dp) :: vector(ddx_data % constants % nbasis, ddx_data % params % nsph)
    ! Local variables
    integer :: isph, lm
    write(6,*) label
    do isph = 1, ddx_data % params % nsph
      do lm = 1, ddx_data % constants % nbasis
        write(6,'(F15.8)') vector(lm,isph)
      end do
    end do
    return
end subroutine print_ddvector


!------------------------------------------------------------------------------
!> Integrate against spherical harmonics
!!
!! Integrate by Lebedev spherical quadrature. This function can be simply
!! substituted by a matrix-vector product.
!!
!! @param[in] nsph: Number of spheres. `nsph` >= 0.
!! @param[in] nbasis: Number of spherical harmonics. `nbasis` >= 0.
!! @param[in] ngrid: Number of Lebedev grid points. `ngrid` >= 0.
!! @param[in] vwgrid: Values of spherical harmonics at Lebedev grid points,
!!      multiplied by weights of grid points. Dimension is (ldvwgrid, ngrid).
!! @param[in] ldvwgrid: Leading dimension of `vwgrid`.
!! @param[in] x_grid: Input values at grid points of the sphere. Dimension is
!!      (ngrid, nsph).
!! @param[out] x_lm: Output spherical harmonics. Dimension is (nbasis, nsph).
subroutine ddintegrate(nsph, nbasis, ngrid, vwgrid, ldvwgrid, x_grid, x_lm)
    implicit none
    !! Inputs
    integer, intent(in) :: nsph, nbasis, ngrid, ldvwgrid
    real(dp), intent(in) :: vwgrid(ldvwgrid, ngrid)
    real(dp), intent(in) :: x_grid(ngrid, nsph)
    !! Output
    real(dp), intent(out) :: x_lm(nbasis, nsph)
    !! Just call a single dgemm to do the job
    call dgemm('N', 'N', nbasis, nsph, ngrid, one, vwgrid, ldvwgrid, x_grid, &
        & ngrid, zero, x_lm, nbasis)
end subroutine ddintegrate

!------------------------------------------------------------------------------
!> Compute first derivatives of spherical harmonics
!!
!! @param[in] x:
!! @param[out] basloc:
!! @param[out] dbsloc:
!! @param[out] vplm:
!! @param[out] vcos:
!! @param[out] vsin:
!!
!!
!! TODO: rewrite code and fill description. Computing sqrt(one-cthe*cthe)
!! reduces effective range of input double precision values. cthe*cthe for
!! cthe=1d+155 is NaN.
!------------------------------------------------------------------------------
subroutine dbasis(params, constants, x, basloc, dbsloc, vplm, vcos, vsin)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), dimension(3),        intent(in)    :: x
    real(dp), dimension(constants % nbasis),   intent(inout) :: basloc, vplm
    real(dp), dimension(3, constants % nbasis), intent(inout) :: dbsloc
    real(dp), dimension(params % lmax+1),   intent(inout) :: vcos, vsin
    integer :: l, m, ind
    real(dp)  :: cthe, sthe, cphi, sphi, plm, fln, pp1, pm1, pp, VC, VS
    real(dp)  :: et(3), ep(3)

    !     get cos(\theta), sin(\theta), cos(\phi) and sin(\phi) from the cartesian
    !     coordinates of x.
    cthe = x(3)
    sthe = sqrt(one - cthe*cthe)
    !     not ( NORTH or SOUTH pole )
    if ( sthe.ne.zero ) then
        cphi = x(1)/sthe
        sphi = x(2)/sthe
        !     NORTH or SOUTH pole
    else
        cphi = one
        sphi = zero
    end if
    !     evaluate the derivatives of theta and phi:
    et(1) = cthe*cphi
    et(2) = cthe*sphi
    et(3) = -sthe
    !     not ( NORTH or SOUTH pole )
    if( sthe.ne.zero ) then
        ep(1) = -sphi/sthe
        ep(2) = cphi/sthe
        ep(3) = zero
        !     NORTH or SOUTH pole
    else
        ep(1) = zero
        ep(2) = one
        ep(3) = zero
    end if
    VC=zero
    VS=cthe
    !     evaluate the generalized legendre polynomials. Temporary workspace
    !       is of size (p+1) here, so we use vcos for that purpose
    call polleg_work( cthe, sthe, params % lmax, vplm, vcos )
    !
    !     evaluate cos(m*phi) and sin(m*phi) arrays. notice that this is 
    !     pointless if z = 1, as the only non vanishing terms will be the 
    !     ones with m=0.
    !
    !     not ( NORTH or SOUTH pole )
    if ( sthe.ne.zero ) then
        call trgev( cphi, sphi, params % lmax, vcos, vsin )
        !     NORTH or SOUTH pole
    else
        vcos = one
        vsin = zero
    end if
    !     now build the spherical harmonics. we will distinguish m=0,
    !     m>0 and m<0:
    !
    basloc = zero
    dbsloc = zero
    do l = 0, params % lmax
        ind = l*l + l + 1
        ! m = 0
        fln = constants % vscales(ind)   
        basloc(ind) = fln*vplm(ind)
        if (l.gt.0) then
            dbsloc(:,ind) = fln*vplm(ind+1)*et(:)
        else
            dbsloc(:,ind) = zero
        end if
        do m = 1, l
            fln = constants % vscales(ind+m)
            plm = fln*vplm(ind+m)   
            pp1 = zero
            if (m.lt.l) pp1 = -pt5*vplm(ind+m+1)
            pm1 = pt5*(dble(l+m)*dble(l-m+1)*vplm(ind+m-1))
            pp  = pp1 + pm1   
            !
            !         m > 0
            !         -----
            !
            basloc(ind+m) = plm*vcos(m+1)
            !          
            !         not ( NORTH or SOUTH pole )
            if ( sthe.ne.zero ) then
                ! 
                dbsloc(:,ind+m) = -fln*pp*vcos(m+1)*et(:) - dble(m)*plm*vsin(m+1)*ep(:)
                !
                !            
                !         NORTH or SOUTH pole
            else
                !                  
                dbsloc(:,ind+m) = -fln*pp*vcos(m+1)*et(:) - fln*pp*ep(:)*VC
                !
                !
            endif
            !
            !         m < 0
            !         -----
            !
            basloc(ind-m) = plm*vsin(m+1)
            !          
            !         not ( NORTH or SOUTH pole )
            if ( sthe.ne.zero ) then
                ! 
                dbsloc(:,ind-m) = -fln*pp*vsin(m+1)*et(:) + dble(m)*plm*vcos(m+1)*ep(:)
                !
                !         NORTH or SOUTH pole
            else
                !                  
                dbsloc(:,ind-m) = -fln*pp*vsin(m+1)*et(:) - fln*pp*ep(:)*VS
                !            
            endif
            !  
        enddo
    enddo
end subroutine dbasis

! Purpose : compute
!
!                               l
!             sum   4pi/(2l+1) t  * Y_l^m( s ) * sigma_l^m
!             l,m                                           
!
!           which is need to compute action of COSMO matrix L.
!------------------------------------------------------------------------------------------------
!> TODO
!------------------------------------------------------------------------------
real(dp) function intmlp(params, constants, t, sigma, basloc )
      implicit none
!  
      type(ddx_params_type), intent(in) :: params
      type(ddx_constants_type), intent(in) :: constants
      real(dp), intent(in) :: t
      real(dp), dimension(constants % nbasis), intent(in) :: sigma, basloc
!
      integer :: l, ind
      real(dp)  :: tt, ss, fac
!
!------------------------------------------------------------------------------------------------
!
!     initialize t^l
      tt = one
!
!     initialize
      ss = zero
!
!     loop over l
      do l = 0, params % lmax
!      
        ind = l*l + l + 1
!
!       update factor 4pi / (2l+1) * t^l
        fac = tt / constants % vscales(ind)**2
!
!       contract over l,m and accumulate
        ss = ss + fac * dot_product( basloc(ind-l:ind+l), &
                                     sigma( ind-l:ind+l)   )
!
!       update t^l
        tt = tt*t
!        
      enddo
!      
!     redirect
      intmlp = ss
!
!
end function intmlp

!------------------------------------------------------------------------------
!> Weigh potential at cavity points by characteristic function
!> TODO use cavity points in CSR format
!------------------------------------------------------------------------------
subroutine wghpot(ncav, phi_cav, nsph, ngrid, ui, phi_grid, g)
    implicit none
    !! Inputs
    integer, intent(in) :: ncav, nsph, ngrid
    real(dp), intent(in) :: phi_cav(ncav), ui(ngrid, nsph)
    !! Outputs
    real(dp), intent(out) :: g(ngrid, nsph), phi_grid(ngrid, nsph)
    !! Local variables
    integer isph, igrid, icav
    !! Code
    ! Initialize
    icav = 0 
    g = zero
    phi_grid = zero
    ! Loop over spheres
    do isph = 1, nsph
        ! Loop over points
        do igrid = 1, ngrid
            ! Non-zero contribution from point
            if (ui(igrid, isph) .ne. zero) then
                ! Advance cavity point counter
                icav = icav + 1
                phi_grid(igrid, isph) = phi_cav(icav)
                ! Weigh by (negative) characteristic function
                g(igrid, isph) = -ui(igrid, isph) * phi_cav(icav)
            endif
        enddo
    enddo
end subroutine wghpot

!> Compute the local Sobolev H^(-1/2)-norm on one sphere of u
subroutine hsnorm(lmax, nbasis, u, unorm)
    implicit none
    integer, intent(in) :: lmax, nbasis
    real(dp), dimension(nbasis), intent(in) :: u
    real(dp), intent(inout) :: unorm
    integer :: l, m, ind
    real(dp)  :: fac
    ! initialize
    unorm = zero
    do l = 0, lmax
        ind = l*l + l + 1
        fac = one/(one + dble(l))
        do m = -l, l
            unorm = unorm + fac*u(ind+m)*u(ind+m)
        end do
    end do
    ! the much neglected square root
    unorm = sqrt(unorm)
end subroutine hsnorm

!> Compute the global Sobolev H^(-1/2)-norm of x
real(dp) function hnorm(lmax, nbasis, nsph, x)
    implicit none
    integer, intent(in) :: lmax, nbasis, nsph
    real(dp),  dimension(nbasis, nsph), intent(in) :: x
    integer :: isph
    real(dp) :: vrms, fac

    vrms = 0.0_dp
    !$omp parallel do default(none) shared(nsph,lmax,nbasis,x) &
    !$omp private(isph,fac) schedule(dynamic) reduction(+:vrms)
    do isph = 1, nsph
        call hsnorm(lmax, nbasis, x(:,isph), fac)
        vrms = vrms + fac*fac
    enddo
    hnorm = sqrt(vrms/dble(nsph))
end function hnorm

real(dp) function rmsnorm(lmax, nbasis, nsph, x)
    implicit none
    ! TODO: nbasis and lmax are redundant, remove one
    integer, intent(in) :: lmax, nbasis, nsph
    real(dp),  dimension(nbasis, nsph), intent(in) :: x
    integer :: n
    real(dp) :: vrms, vmax
    ! lmax is not actually used, it is here to comply to the interface
    if (lmax.eq.0) continue
    n = nbasis*nsph
    call rmsvec(n,x,vrms,vmax)
    rmsnorm = vrms
end function rmsnorm

!> compute root-mean-square and max norm
subroutine rmsvec(n, v, vrms, vmax)
    implicit none
    integer, intent(in) :: n
    real(dp), dimension(n), intent(in) :: v
    real(dp), intent(inout) :: vrms, vmax
    integer :: i

    vrms = zero
    vmax = zero
    do i = 1,n
      vmax = max(vmax,abs(v(i)))
      vrms = vrms + v(i)*v(i)
    end do
    ! the much neglected square root
    vrms = sqrt(vrms/dble(n))
endsubroutine rmsvec

subroutine adjrhs(params, constants, isph, xi, vlm, work)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: isph
    real(dp), dimension(params % ngrid, params % nsph), intent(in) :: xi
    real(dp), dimension(constants % nbasis), intent(inout) :: vlm
    real(dp), dimension(params % lmax+1), intent(inout) :: work

    integer :: ij, jsph, ig
    real(dp)  :: vji(3), vvji, tji, xji, oji, fac

    do ij = constants % inl(isph), constants % inl(isph+1)-1
      jsph = constants % nl(ij)
      do ig = 1, params % ngrid
        vji  = params % csph(:,jsph) + params % rsph(jsph)* &
            & constants % cgrid(:,ig) - params % csph(:,isph)
        vvji = sqrt(dot_product(vji,vji))
        tji  = vvji/params % rsph(isph)
        if ( tji.lt.( one + (params % se+one)/two*params % eta ) ) then
          xji = fsw( tji, params % se, params % eta )
          if ( constants % fi(ig,jsph).gt.one ) then
            oji = xji/ constants % fi(ig,jsph)
          else
            oji = xji
          endif
          fac = constants % wgrid(ig) * xi(ig,jsph) * oji
          call fmm_l2p_adj_work(vji, fac, params % rsph(isph), &
              & params % lmax, constants % vscales_rel, one, vlm, work)
        endif
      enddo
    enddo
end subroutine adjrhs

subroutine calcv(params, constants, isph, pot, sigma, work)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: isph
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: sigma
    real(dp), dimension(params % ngrid), intent(inout) :: pot
    real(dp), dimension(params % lmax+1), intent(inout) :: work

    integer :: its, ij, jsph
    real(dp) :: vij(3)
    real(dp) :: vvij, tij, xij, oij, thigh

    thigh = one + pt5*(params % se + one)*params % eta
    pot(:) = zero
    ! loop over grid points
    do its = 1, params % ngrid
        ! contribution from integration point present
        if (constants % ui(its,isph).lt.one) then
            ! loop over neighbors of i-sphere
            do ij = constants % inl(isph), constants % inl(isph+1)-1
                jsph = constants % nl(ij)
                ! compute t_n^ij = | r_i + \rho_i s_n - r_j | / \rho_j
                vij  = params % csph(:,isph) + params % rsph(isph)* &
                    & constants % cgrid(:,its) - params % csph(:,jsph)
                vvij = sqrt( dot_product( vij, vij ) )
                tij  = vvij / params % rsph(jsph)
                ! point is INSIDE j-sphere
                if (tij.lt.thigh) then
                    xij = fsw(tij, params % se, params % eta)
                    if (constants % fi(its,isph).gt.one) then
                        oij = xij / constants % fi(its,isph)
                    else
                        oij = xij
                    end if
                    call fmm_l2p_work(vij, params % rsph(jsph), params % lmax, &
                        & constants % vscales_rel, oij, sigma(:, jsph), one, &
                        & pot(its), work)
                end if
            end do
        end if
    end do
end subroutine calcv

!------------------------------------------------------------------------------
!> Evaluate values of spherical harmonics at Lebedev grid points
!------------------------------------------------------------------------------
subroutine ddeval_grid(params, constants, alpha, x_sph, beta, x_grid)
    implicit none
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: alpha, x_sph(constants % nbasis, params % nsph), &
        & beta
    !! Output
    real(dp), intent(inout) :: x_grid(params % ngrid, params % nsph)
    !! The code
    call ddeval_grid_work(constants % nbasis, params % ngrid, params % nsph, &
        & constants % vgrid, constants % vgrid_nbasis, alpha, x_sph, beta, &
        & x_grid)
end subroutine ddeval_grid

!------------------------------------------------------------------------------
!> Evaluate values of spherical harmonics at Lebedev grid points
!------------------------------------------------------------------------------
subroutine ddeval_grid_work(nbasis, ngrid, nsph, vgrid, ldvgrid, alpha, &
        & x_sph, beta, x_grid)
    implicit none
    !! Inputs
    integer, intent(in) :: nbasis, ngrid, nsph, ldvgrid
    real(dp), intent(in) :: vgrid(ldvgrid, ngrid), alpha, &
        & x_sph(nbasis, nsph), beta
    !! Output
    real(dp), intent(inout) :: x_grid(ngrid, nsph)
    !! Local variables
    external :: dgemm
    !! The code
    call dgemm('T', 'N', ngrid, nsph, nbasis, alpha, vgrid, ldvgrid, x_sph, &
        & nbasis, beta, x_grid, ngrid)
end subroutine ddeval_grid_work

!> Integrate values at grid points into spherical harmonics
subroutine ddintegrate_sph(params, constants, alpha, x_grid, beta, x_sph)
    implicit none
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: alpha, x_grid(params % ngrid, params % nsph), &
        & beta
    !! Output
    real(dp), intent(inout) :: x_sph(constants % nbasis, params % nsph)
    !! The code
    call ddintegrate_sph_work(constants % nbasis, params % ngrid, &
        & params % nsph, constants % vwgrid, constants % vgrid_nbasis, alpha, &
        & x_grid, beta, x_sph)
end subroutine ddintegrate_sph

!> Integrate values at grid points into spherical harmonics
subroutine ddintegrate_sph_work(nbasis, ngrid, nsph, vwgrid, ldvwgrid, alpha, &
        & x_grid, beta, x_sph)
    implicit none
    !! Inputs
    integer, intent(in) :: nbasis, ngrid, nsph, ldvwgrid
    real(dp), intent(in) :: vwgrid(ldvwgrid, ngrid), alpha, &
        & x_grid(ngrid, nsph), beta
    !! Outputs
    real(dp), intent(inout) :: x_sph(nbasis, nsph)
    !! Local variables
    !! The code
    call dgemm('N', 'N', nbasis, nsph, ngrid, alpha, vwgrid, ldvwgrid, &
        & x_grid, ngrid, beta, x_sph, nbasis)
end subroutine ddintegrate_sph_work

!------------------------------------------------------------------------------
!> Unwrap values at cavity points into values at all grid points
!------------------------------------------------------------------------------
subroutine ddcav_to_grid(params, constants, x_cav, x_grid)
    implicit none
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: x_cav(constants % ncav)
    !! Output
    real(dp), intent(inout) :: x_grid(params % ngrid, params % nsph)
    !! The code
    call ddcav_to_grid_work(params % ngrid, params % nsph, constants % ncav, &
        & constants % icav_ia, constants % icav_ja, x_cav, x_grid)
end subroutine ddcav_to_grid

!------------------------------------------------------------------------------
!> Unwrap values at cavity points into values at all grid points
!------------------------------------------------------------------------------
subroutine ddcav_to_grid_work(ngrid, nsph, ncav, icav_ia, icav_ja, x_cav, &
        & x_grid)
    implicit none
    !! Inputs
    integer, intent(in) :: ngrid, nsph, ncav
    integer, intent(in) :: icav_ia(nsph+1), icav_ja(ncav)
    real(dp), intent(in) :: x_cav(ncav)
    !! Output
    real(dp), intent(out) :: x_grid(ngrid, nsph)
    !! Local variables
    integer :: isph, icav, igrid, igrid_old
    !! The code
    do isph = 1, nsph
        igrid_old = 0
        igrid = 0
        do icav = icav_ia(isph), icav_ia(isph+1)-1
            igrid = icav_ja(icav)
            x_grid(igrid_old+1:igrid-1, isph) = zero
            x_grid(igrid, isph) = x_cav(icav)
            igrid_old = igrid
        end do
        x_grid(igrid+1:ngrid, isph) = zero
    end do
end subroutine ddcav_to_grid_work

!> Integrate by a characteristic function at Lebedev grid points
!! \xi(n,i) = sum w_n U_n^i Y_l^m(s_n) [S_i]_l^m
!!            l,m
!!
subroutine ddproject_cav(params, constants, s, xi)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in)  :: s(constants%nbasis, params%nsph)
    real(dp), intent(out) :: xi(constants%ncav)
    integer :: its, isph, ii
    ii = 0
    do isph = 1, params%nsph
        do its = 1, params%ngrid
            if (constants%ui(its, isph) .gt. zero) then
                ii     = ii + 1
                xi(ii) = constants%ui(its, isph)*dot_product( &
                    & constants%vwgrid(:constants % nbasis, its), s(:, isph))
            end if
        end do
    end do
end subroutine ddproject_cav

!------------------------------------------------------------------------------
!> Transfer multipole coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_m2m_rotation(params, constants, node_m)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_m((params % pm+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp) :: work(6*params % pm**2 + 19*params % pm + 8)
    ! Call corresponding work routine
    call tree_m2m_rotation_work(params, constants, node_m, work)
end subroutine tree_m2m_rotation

!------------------------------------------------------------------------------
!> Transfer multipole coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_m2m_rotation_work(params, constants, node_m, work)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_m((params % pm+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp), intent(out) :: work(6*params % pm**2 + 19*params % pm + 8)
    ! Local variables
    integer :: i, j
    real(dp) :: c1(3), c(3), r1, r
    ! Bottom-to-top pass
    !!$omp parallel do default(none) shared(constants,params,node_m) &
    !!$omp private(i,j,c1,c,r1,r,work)
    do i = constants % nclusters, 1, -1
        ! Leaf node does not need any update
        if (constants % children(1, i) == 0) cycle
        c = constants % cnode(:, i)
        r = constants % rnode(i)
        ! First child initializes output
        j = constants % children(1, i)
        c1 = constants % cnode(:, j)
        r1 = constants % rnode(j)
        c1 = c1 - c
        call fmm_m2m_rotation_work(c1, r1, r, &
            & params % pm, &
            & constants % vscales, &
            & constants % vcnk, one, &
            & node_m(:, j), zero, node_m(:, i), work)
        ! All other children update the same output
        do j = constants % children(1, i)+1, constants % children(2, i)
            c1 = constants % cnode(:, j)
            r1 = constants % rnode(j)
            c1 = c1 - c
            call fmm_m2m_rotation_work(c1, r1, r, params % pm, &
                & constants % vscales, constants % vcnk, one, &
                & node_m(:, j), one, node_m(:, i), work)
        end do
    end do
end subroutine tree_m2m_rotation_work

!------------------------------------------------------------------------------
!> Transfer multipole coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_m2m_bessel_rotation(params, constants, node_m)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_m((params % pm+1)**2, constants % nclusters)
    ! Temporary workspace
    !real(dp) :: work(6*params % pm**2 + 19*params % pm + 8)
    ! Call corresponding work routine
    call tree_m2m_bessel_rotation_work(params, constants, node_m)
end subroutine tree_m2m_bessel_rotation

!------------------------------------------------------------------------------
!> Transfer multipole coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_m2m_bessel_rotation_work(params, constants, node_m)
    use complex_bessel
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_m((params % pm+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp) :: work(6*params % pm**2 + 19*params % pm + 8)
    complex(dp) :: work_complex(2*params % pm+1)
    ! Local variables
    integer :: i, j
    real(dp) :: c1(3), c(3), r1, r
    ! Bottom-to-top pass
    do i = constants % nclusters, 1, -1
        ! Leaf node does not need any update
        if (constants % children(1, i) == 0) cycle
        c = constants % cnode(:, i)
        r = constants % rnode(i)
        ! First child initializes output
        j = constants % children(1, i)
        c1 = constants % cnode(:, j)
        r1 = constants % rnode(j)
        c1 = params % kappa*(c1 - c)
        call fmm_m2m_bessel_rotation_work(c1, &
            & constants % SK_rnode(:, j), constants % SK_rnode(:, i), &
            & params % pm, constants % vscales, one, node_m(:, j), zero, &
            & node_m(:, i), work, work_complex)
        ! All other children update the same output
        do j = constants % children(1, i)+1, constants % children(2, i)
            c1 = constants % cnode(:, j)
            r1 = constants % rnode(j)
            c1 = params % kappa*(c1 - c)
            call fmm_m2m_bessel_rotation_work(c1, &
                & constants % SK_rnode(:, j), constants % SK_rnode(:, i), &
                & params % pm, constants % vscales, one, node_m(:, j), one, &
                & node_m(:, i), work, work_complex)
        end do
    end do
end subroutine tree_m2m_bessel_rotation_work

!------------------------------------------------------------------------------
!> Adjoint transfer multipole coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_m2m_rotation_adj(params, constants, node_m)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_m((params % pm+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp) :: work(6*params % pm**2 + 19*params % pm + 8)
    ! Call corresponding work routine
    call tree_m2m_rotation_adj_work(params, constants, node_m, work)
end subroutine tree_m2m_rotation_adj

!------------------------------------------------------------------------------
!> Adjoint transfer multipole coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_m2m_rotation_adj_work(params, constants, node_m, work)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_m((params % pm+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp), intent(out) :: work(6*params % pm**2 + 19*params % pm + 8)
    ! Local variables
    integer :: i, j
    real(dp) :: c1(3), c(3), r1, r
    ! Top-to-bottom pass
    do i = 2, constants % nclusters
        j = constants % parent(i)
        c = constants % cnode(:, j)
        r = constants % rnode(j)
        c1 = constants % cnode(:, i)
        r1 = constants % rnode(i)
        c1 = c - c1
        call fmm_m2m_rotation_adj_work(c1, r, r1, params % pm, &
            & constants % vscales, constants % vcnk, one, node_m(:, j), one, &
            & node_m(:, i), work)
    end do
end subroutine tree_m2m_rotation_adj_work
!------------------------------------------------------------------------------
!> Adjoint transfer multipole coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_m2m_bessel_rotation_adj(params, constants, node_m)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_m((params % pm+1)**2, constants % nclusters)
    ! Temporary workspace
    !real(dp), intent(out) :: work(6*params % pm**2 + 19*params % pm + 8)
    call tree_m2m_bessel_rotation_adj_work(params, constants, node_m)
end subroutine tree_m2m_bessel_rotation_adj

!------------------------------------------------------------------------------
!> Adjoint transfer multipole coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_m2m_bessel_rotation_adj_work(params, constants, node_m)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_m((params % pm+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp) :: work(6*params % pm**2 + 19*params % pm + 8)
    complex(dp) :: work_complex(2*params % pm+1)
    ! Local variables
    integer :: i, j
    real(dp) :: c1(3), c(3)
    ! Top-to-bottom pass
    do i = 2, constants % nclusters
        j = constants % parent(i)
        c = constants % cnode(:, j)
        c1 = constants % cnode(:, i)
        c1 = params % kappa*(c1 - c)
        ! Little bit confusion about the i and j indices
        call fmm_m2m_bessel_rotation_adj_work(c1, constants % SK_rnode(:, i), &
            & constants % SK_rnode(:, j), params % pm, constants % vscales, &
            & one, node_m(:, j), one, node_m(:, i), work, work_complex)
    end do
end subroutine tree_m2m_bessel_rotation_adj_work

!------------------------------------------------------------------------------
!> Transfer local coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_l2l_rotation(params, constants, node_l)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_l((params % pl+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp) :: work(6*params % pl**2 + 19*params % pl + 8)
    ! Call corresponding work routine
    call tree_l2l_rotation_work(params, constants, node_l, work)
end subroutine tree_l2l_rotation

!------------------------------------------------------------------------------
!> Transfer local coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_l2l_rotation_work(params, constants, node_l, work)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_l((params % pl+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp), intent(out) :: work(6*params % pl**2 + 19*params % pl + 8)
    ! Local variables
    integer :: i, j
    real(dp) :: c1(3), c(3), r1, r
    ! Top-to-bottom pass
    !!$omp parallel do default(none) shared(constants,params,node_l) &
    !!$omp private(i,j,c1,c,r1,r,work)
    do i = 2, constants % nclusters
        j = constants % parent(i)
        c = constants % cnode(:, j)
        r = constants % rnode(j)
        c1 = constants % cnode(:, i)
        r1 = constants % rnode(i)
        c1 = c - c1
        call fmm_l2l_rotation_work(c1, r, r1, params % pl, &
            & constants % vscales, constants % vfact, one, &
            & node_l(:, j), one, node_l(:, i), work)
    end do
end subroutine tree_l2l_rotation_work

!------------------------------------------------------------------------------
!> Transfer local coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_l2l_bessel_rotation(params, constants, node_l)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_l((params % pl+1)**2, constants % nclusters)
    ! Temporary workspace
    !real(dp) :: work(6*params % pl**2 + 19*params % pl + 8)
    ! Call corresponding work routine
    call tree_l2l_bessel_rotation_work(params, constants, node_l)
end subroutine tree_l2l_bessel_rotation

!------------------------------------------------------------------------------
!> Transfer local coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_l2l_bessel_rotation_work(params, constants, node_l)
    use complex_bessel
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_l((params % pl+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp) :: work(6*params % pl**2 + 19*params % pl + 8)
    complex(dp) :: work_complex(2*params % pl+1)
    ! Local variables
    integer :: i, j
    real(dp) :: c_child(3), c_parent(3), c_diff(3)
    ! Top-to-bottom pass
    do i = 2, constants % nclusters
        j = constants % parent(i)
        c_child = constants % cnode(:, j)
        c_parent = constants % cnode(:, i)
        c_diff = params % kappa*(c_child - c_parent)
        call fmm_l2l_bessel_rotation_work(c_diff, &
            & constants % si_rnode(:, j), constants % si_rnode(:, i), &
            & params % pl, constants % vscales, one, &
            & node_l(:, j), one, node_l(:, i), work, work_complex)
    end do
end subroutine tree_l2l_bessel_rotation_work

!------------------------------------------------------------------------------
!> Adjoint transfer local coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_l2l_rotation_adj(params, constants, node_l)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_l((params % pl+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp) :: work(6*params % pl**2 + 19*params % pl + 8)
    ! Call corresponding work routine
    call tree_l2l_rotation_adj_work(params, constants, node_l, work)
end subroutine tree_l2l_rotation_adj

!------------------------------------------------------------------------------
!> Adjoint transfer local coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_l2l_rotation_adj_work(params, constants, node_l, work)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_l((params % pl+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp), intent(out) :: work(6*params % pl**2 + 19*params % pl + 8)
    ! Local variables
    integer :: i, j
    real(dp) :: c1(3), c(3), r1, r
    ! Bottom-to-top pass
    do i = constants % nclusters, 1, -1
        ! Leaf node does not need any update
        if (constants % children(1, i) == 0) cycle
        c = constants % cnode(:, i)
        r = constants % rnode(i)
        ! First child initializes output
        j = constants % children(1, i)
        c1 = constants % cnode(:, j)
        r1 = constants % rnode(j)
        c1 = c1 - c
        call fmm_l2l_rotation_adj_work(c1, r1, r, params % pl, &
            & constants % vscales, constants % vfact, one, &
            & node_l(:, j), zero, node_l(:, i), work)
        ! All other children update the same output
        do j = constants % children(1, i)+1, constants % children(2, i)
            c1 = constants % cnode(:, j)
            r1 = constants % rnode(j)
            c1 = c1 - c
            call fmm_l2l_rotation_adj_work(c1, r1, r, params % pl, &
                & constants % vscales, constants % vfact, one, &
                & node_l(:, j), one, node_l(:, i), work)
        end do
    end do
end subroutine tree_l2l_rotation_adj_work

!------------------------------------------------------------------------------
!> Adjoint transfer local coefficients over a tree
!------------------------------------------------------------------------------
subroutine tree_l2l_bessel_rotation_adj(params, constants, node_l)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    ! Output
    real(dp), intent(inout) :: node_l((params % pl+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp) :: work(6*params % pl**2 + 19*params % pl + 8)
    complex(dp) :: work_complex(2*params % pl+1)
    ! Local variables
    integer :: i, j
    real(dp) :: c_parent(3), c_child(3), c_diff(3)
    ! Bottom-to-top pass
    do i = constants % nclusters, 1, -1
        c_child = constants % cnode(:, i)
        j = constants % parent(i)
        if (j == 0) cycle
        c_parent = constants % cnode(:, j)
        c_diff = params % kappa*(c_parent - c_child)
        call fmm_l2l_bessel_rotation_adj_work(c_diff, &
            & constants % si_rnode(:, i), constants % si_rnode(:, j), &
            & params % pl, constants % vscales, one, &
            & node_l(:, i), one, node_l(:, j), work, work_complex)
    end do
end subroutine tree_l2l_bessel_rotation_adj

!------------------------------------------------------------------------------
!> Transfer multipole local coefficients into local over a tree
!------------------------------------------------------------------------------
subroutine tree_m2l_rotation(params, constants, node_m, node_l)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: node_m((params % pm+1)**2, constants % nclusters)
    ! Output
    real(dp), intent(out) :: node_l((params % pl+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp) :: work(6*max(params % pm, params % pl)**2 + &
        & 19*max(params % pm, params % pl) + 8)
    ! Local variables
    integer :: i, j, k
    real(dp) :: c1(3), c(3), r1, r
    ! Any order of this cycle is OK
    !$omp parallel do default(none) shared(constants,params,node_m,node_l) &
    !$omp private(i,c,r,k,c1,r1,work) schedule(dynamic)
    do i = 1, constants % nclusters
        ! If no far admissible pairs just set output to zero
        if (constants % nfar(i) .eq. 0) then
            node_l(:, i) = zero
            cycle
        end if
        c = constants % cnode(:, i)
        r = constants % rnode(i)
        ! Use the first far admissible pair to initialize output
        k = constants % far(constants % sfar(i))
        c1 = constants % cnode(:, k)
        r1 = constants % rnode(k)
        c1 = c1 - c
        call fmm_m2l_rotation_work(c1, r1, r, params % pm, params % pl, &
            & constants % vscales, constants % m2l_ztranslate_coef, one, &
            & node_m(:, k), zero, node_l(:, i), work)
        do j = constants % sfar(i)+1, constants % sfar(i+1)-1
            k = constants % far(j)
            c1 = constants % cnode(:, k)
            r1 = constants % rnode(k)
            c1 = c1 - c
            call fmm_m2l_rotation_work(c1, r1, r, params % pm, &
                & params % pl, constants % vscales, &
                & constants % m2l_ztranslate_coef, one, node_m(:, k), one, &
                & node_l(:, i), work)
        end do
    end do
end subroutine tree_m2l_rotation

!------------------------------------------------------------------------------
!> Transfer multipole local coefficients into local over a tree
!------------------------------------------------------------------------------
subroutine tree_m2l_bessel_rotation(params, constants, node_m, node_l)
    use complex_bessel
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: node_m((params % pm+1)**2, constants % nclusters)
    ! Output
    real(dp), intent(out) :: node_l((params % pl+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp) :: work(6*params % pm**2 + 19*params % pm + 8)
    complex(dp) :: work_complex(2*params % pm+1)
    ! Local variables
    integer :: i, j, k
    real(dp) :: c1(3), c(3), r1, r
    ! Any order of this cycle is OK
    !$omp parallel do default(none) shared(constants,params,node_m,node_l) &
    !$omp private(i,c,r,k,c1,r1,work,work_complex) schedule(dynamic)
    do i = 1, constants % nclusters
        ! If no far admissible pairs just set output to zero
        if (constants % nfar(i) .eq. 0) then
            node_l(:, i) = zero
            cycle
        end if
        c = constants % cnode(:, i)
        r = constants % rnode(i)
        ! Use the first far admissible pair to initialize output
        k = constants % far(constants % sfar(i))
        c1 = constants % cnode(:, k)
        r1 = constants % rnode(k)
        c1 = params % kappa*(c1 - c)
        call fmm_m2l_bessel_rotation_work(c1, &
            & constants % SK_rnode(:, k), constants % SI_rnode(:, i), &
            & params % pm, &
            & constants % vscales, one, &
            & node_m(:, k), zero, node_l(:, i), work, work_complex)
        do j = constants % sfar(i)+1, constants % sfar(i+1)-1
            k = constants % far(j)
            c1 = constants % cnode(:, k)
            r1 = constants % rnode(k)
            c1 = params % kappa*(c1 - c)
            call fmm_m2l_bessel_rotation_work(c1, constants % SK_rnode(:, k), &
                & constants % SI_rnode(:, i), params % pm, &
                & constants % vscales, one, &
                & node_m(:, k), one, node_l(:, i), work, work_complex)
        end do
    end do
end subroutine tree_m2l_bessel_rotation
!------------------------------------------------------------------------------
!> Adjoint transfer multipole local coefficients into local over a tree
!------------------------------------------------------------------------------
subroutine tree_m2l_bessel_rotation_adj(params, constants, node_l, node_m)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: node_l((params % pl+1)**2, constants % nclusters)
    ! Output
    real(dp), intent(inout) :: node_m((params % pm+1)**2, constants % nclusters)
    !Call corresponding work routine
    call tree_m2l_bessel_rotation_adj_work(params, constants, node_l, node_m)
end subroutine tree_m2l_bessel_rotation_adj


!------------------------------------------------------------------------------
!> Adjoint transfer multipole local coefficients into local over a tree
!------------------------------------------------------------------------------
subroutine tree_m2l_bessel_rotation_adj_work(params, constants, node_l, node_m)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: node_l((params % pl+1)**2, constants % nclusters)
    ! Output
    real(dp), intent(out) :: node_m((params % pm+1)**2, constants % nclusters)
    ! Temporary workspace
    real(dp) :: work(6*params % pm**2 + 19*params % pm + 8)
    complex(dp) :: work_complex(2*params % pm+1)
    ! Local variables
    integer :: i, j, k
    real(dp) :: c1(3), c(3), r
    node_m = zero
    !$omp parallel do shared(constants,params,node_l,node_m) &
    !$omp private(i,c,r,k,c1,work,work_complex,j) schedule(dynamic)
    do i = 1, constants % nclusters
        ! If no far admissible pairs just set output to zero
        if (constants % nfar(i) .eq. 0) then
            cycle
        end if
        c = constants % cnode(:, i)
        r = constants % rnode(i)
        ! Use the first far admissible pair to initialize output
        k = constants % far(constants % sfar(i))
        c1 = constants % cnode(:, k)
        c1 = params % kappa*(c - c1)
        call fmm_m2l_bessel_rotation_adj_work(c1, constants % SI_rnode(:, k), &
            & constants % SK_rnode(:, i), params % pm, constants % vscales, &
            & one, node_l(:, k), one, node_m(:, i), work, work_complex)
        do j = constants % sfar(i)+1, constants % sfar(i+1)-1
            k = constants % far(j)
            c1 = constants % cnode(:, k)
            c1 = params % kappa*(c - c1)
            call fmm_m2l_bessel_rotation_adj_work(c1, &
                & constants % SI_rnode(:, k), constants % SK_rnode(:, i), &
                & params % pm, constants % vscales, one, node_l(:, k), &
                & one, node_m(:, i), work, work_complex)
        end do
    end do
end subroutine tree_m2l_bessel_rotation_adj_work

!------------------------------------------------------------------------------
!> Adjoint transfer multipole local coefficients into local over a tree
!------------------------------------------------------------------------------
subroutine tree_m2l_rotation_adj(params, constants, node_l, node_m)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: node_l((params % pl+1)**2, constants % nclusters)
    ! Output
    real(dp), intent(out) :: node_m((params % pm+1)**2, constants % nclusters)
    ! Local variables
    integer :: i, j, k
    real(dp) :: c1(3), c(3), r1, r
    node_m = zero
    !$omp parallel do default(none) shared(constants,params,node_m,node_l) &
    !$omp private(i,c,r,k,c1,r1,j) schedule(dynamic)
    do i = 1, constants % nclusters
        ! If no far admissible pairs just set output to zero
        if (constants % nfar(i) .eq. 0) then
            cycle
        end if
        c = constants % cnode(:, i)
        r = constants % rnode(i)
        ! Use the first far admissible pair to initialize output
        k = constants % far(constants % sfar(i))
        c1 = constants % cnode(:, k)
        r1 = constants % rnode(k)
        c1 = c1 - c
        call fmm_m2l_rotation_adj(c1, r1, r, params % pl, params % pm, &
            & constants % vscales, constants % m2l_ztranslate_adj_coef, one, &
            & node_l(:, k), one, node_m(:, i))
        do j = constants % sfar(i)+1, constants % sfar(i+1)-1
            k = constants % far(j)
            c1 = constants % cnode(:, k)
            r1 = constants % rnode(k)
            c1 = c1 - c
            call fmm_m2l_rotation_adj(c1, r1, r, params % pl, params % pm, &
                & constants % vscales, constants % m2l_ztranslate_adj_coef, one, &
                & node_l(:, k), one, node_m(:, i))
        end do
    end do
end subroutine tree_m2l_rotation_adj

!------------------------------------------------------------------------------
!> TODO
!------------------------------------------------------------------------------
subroutine tree_l2p(params, constants, alpha, node_l, beta, grid_v, sph_l)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: node_l((params % pl+1)**2, constants % nclusters), &
        & alpha, beta
    ! Output
    real(dp), intent(inout) :: grid_v(params % ngrid, params % nsph)
    ! Scratch
    real(dp), intent(out) :: sph_l((params % pl+1)**2, params % nsph)
    ! Local variables
    integer :: isph
    external :: dgemm


    ! Init output
    if (beta .eq. zero) then
        grid_v = zero
    else
        grid_v = beta * grid_v
    end if
    ! Get data from all clusters to spheres
    !$omp parallel do default(none) shared(params,constants,node_l,sph_l) &
    !$omp private(isph) schedule(dynamic)
    do isph = 1, params % nsph
        sph_l(:, isph) = node_l(:, constants % snode(isph))
    end do
    ! Get values at grid points
    call dgemm('T', 'N', params % ngrid, params % nsph, &
        & (params % pl+1)**2, alpha, constants % vgrid2, &
        & constants % vgrid_nbasis, sph_l, (params % pl+1)**2, beta, grid_v, &
        & params % ngrid)

end subroutine tree_l2p

!------------------------------------------------------------------------------
!> TODO
!------------------------------------------------------------------------------
subroutine tree_l2p_bessel(params, constants, alpha, node_l, beta, grid_v)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: node_l((params % pl+1)**2, constants % nclusters), &
        & alpha, beta
    ! Output
    real(dp), intent(inout) :: grid_v(params % ngrid, params % nsph)
    ! Local variables
    real(dp) :: sph_l((params % pl+1)**2, params % nsph)
    integer :: isph
    external :: dgemm
    ! Init output
    if (beta .eq. zero) then
        grid_v = zero
    else
        grid_v = beta * grid_v
    end if
    ! Get data from all clusters to spheres
    !$omp parallel do default(none) shared(params,constants,node_l,sph_l) &
    !$omp private(isph) schedule(dynamic)
    do isph = 1, params % nsph
        sph_l(:, isph) = node_l(:, constants % snode(isph))
    end do
    ! Get values at grid points
    call dgemm('T', 'N', params % ngrid, params % nsph, &
        & (params % pl+1)**2, alpha, constants % vgrid, &
        & constants % vgrid_nbasis, sph_l, (params % pl+1)**2, beta, grid_v, &
        & params % ngrid)
end subroutine tree_l2p_bessel

!------------------------------------------------------------------------------
!> TODO
!------------------------------------------------------------------------------
subroutine tree_l2p_adj(params, constants, alpha, grid_v, beta, node_l, sph_l)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: grid_v(params % ngrid, params % nsph), alpha, &
        & beta
    ! Output
    real(dp), intent(inout) :: node_l((params % pl+1)**2, &
        & constants % nclusters)
    ! Scractch
    real(dp), intent(out) :: sph_l((params % pl+1)**2, params % nsph)
    ! Local variables
    integer :: isph, inode
    external :: dgemm
    ! Init output
    if (beta .eq. zero) then
        node_l = zero
    else
        node_l = beta * node_l
    end if
    ! Get weights of spherical harmonics at each sphere
    call dgemm('N', 'N', (params % pl+1)**2, params % nsph, &
        & params % ngrid, one, constants % vgrid2, constants % vgrid_nbasis, &
        & grid_v, params % ngrid, zero, sph_l, &
        & (params % pl+1)**2)
    ! Get data from all clusters to spheres
    !$omp parallel do default(none) shared(params,constants,node_l,sph_l, &
    !$omp alpha) private(isph,inode) schedule(dynamic)
    do isph = 1, params % nsph
        inode = constants % snode(isph)
        node_l(:, inode) = node_l(:, inode) + alpha*sph_l(:, isph)
    end do
end subroutine tree_l2p_adj

!------------------------------------------------------------------------------
!> TODO
!------------------------------------------------------------------------------
subroutine tree_l2p_bessel_adj(params, constants, alpha, grid_v, beta, node_l)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: grid_v(params % ngrid, params % nsph), alpha, &
        & beta
    ! Output
    real(dp), intent(inout) :: node_l((params % pl+1)**2, &
        & constants % nclusters)
    ! Local variables
    real(dp) :: sph_l((params % pl+1)**2, params % nsph)
    integer :: isph, inode
    external :: dgemm
    ! Init output
    if (beta .eq. zero) then
        node_l = zero
    else
        node_l = beta * node_l
    end if
    ! Get weights of spherical harmonics at each sphere
    call dgemm('N', 'N', (params % pl+1)**2, params % nsph, &
        & params % ngrid, one, constants % vgrid, constants % vgrid_nbasis, &
        & grid_v, params % ngrid, zero, sph_l, &
        & (params % pl+1)**2)
    ! Get data from all clusters to spheres
    !$omp parallel do default(none) shared(params,constants,node_l,sph_l, &
    !$omp alpha) private(isph,inode) schedule(dynamic)
    do isph = 1, params % nsph
        inode = constants % snode(isph)
        node_l(:, inode) = node_l(:, inode) + alpha*sph_l(:, isph)
    end do
end subroutine tree_l2p_bessel_adj

!------------------------------------------------------------------------------
!> TODO
!------------------------------------------------------------------------------
subroutine tree_m2p(params, constants, p, alpha, sph_m, beta, grid_v)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: p
    real(dp), intent(in) :: sph_m((p+1)**2, params % nsph), alpha, beta
    ! Output
    real(dp), intent(inout) :: grid_v(params % ngrid, params % nsph)
    ! Local variables
    integer :: isph, inode, jnear, jnode, jsph, igrid
    real(dp) :: c(3)
    ! Temporary workspace
    real(dp) :: work(p+1)
    ! Init output
    if (beta .eq. zero) then
        grid_v = zero
    else
        grid_v = beta * grid_v
    end if
    ! Cycle over all spheres
    !$omp parallel do default(none) shared(params,constants,grid_v,p, &
    !$omp alpha,sph_m), private(isph,inode,jnear,jnode,jsph,igrid,c,work) &
    !$omp schedule(dynamic)
    do isph = 1, params % nsph
        ! Cycle over all near-field admissible pairs of spheres
        inode = constants % snode(isph)
        do jnear = constants % snear(inode), constants % snear(inode+1)-1
            ! Near-field interactions are possible only between leaf nodes,
            ! which must contain only a single input sphere
            jnode = constants % near(jnear)
            jsph = constants % order(constants % cluster(1, jnode))
            ! Ignore self-interaction
            if(isph .eq. jsph) cycle
            ! Accumulate interaction for external grid points only
            do igrid = 1, params % ngrid
                if(constants % ui(igrid, isph) .eq. zero) cycle
                c = constants % cgrid(:, igrid)*params % rsph(isph) - &
                    & params % csph(:, jsph) + params % csph(:, isph)
                call fmm_m2p_work(c, params % rsph(jsph), p, &
                    & constants % vscales_rel, alpha, sph_m(:, jsph), one, &
                    & grid_v(igrid, isph), work)
            end do
        end do
    end do
end subroutine tree_m2p

!------------------------------------------------------------------------------
!> TODO
!------------------------------------------------------------------------------
subroutine tree_m2p_bessel(params, constants, p, alpha, sph_p, sph_m, beta, grid_v)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: p, sph_p
    real(dp), intent(in) :: sph_m((sph_p+1)**2, params % nsph), alpha, beta
    ! Output
    real(dp), intent(inout) :: grid_v(params % ngrid, params % nsph)
    ! Local variables
    integer :: isph, inode, jnear, jnode, jsph, igrid
    real(dp) :: c(3)
    ! Temporary workspace
    real(dp) :: work(p+1)
    complex(dp) :: work_complex(p+1)
    ! Init output
    if (beta .eq. zero) then
        grid_v = zero
    else
        grid_v = beta * grid_v
    end if
    ! Cycle over all spheres
    !$omp parallel do default(none) shared(params,constants,grid_v,p, &
    !$omp alpha,sph_m), private(isph,inode,jnear,jnode,jsph,igrid,c,work, &
    !$omp work_complex) schedule(dynamic)
    do isph = 1, params % nsph
        ! Cycle over all near-field admissible pairs of spheres
        inode = constants % snode(isph)
        do jnear = constants % snear(inode), constants % snear(inode+1)-1
            ! Near-field interactions are possible only between leaf nodes,
            ! which must contain only a single input sphere
            jnode = constants % near(jnear)
            jsph = constants % order(constants % cluster(1, jnode))
            ! Ignore self-interaction
            !if(isph .eq. jsph) cycle
            ! Accumulate interaction for external grid points only
            do igrid = 1, params % ngrid
                if(constants % ui(igrid, isph) .eq. zero) cycle
                c = constants % cgrid(:, igrid)*params % rsph(isph) - &
                    & params % csph(:, jsph) + params % csph(:, isph)
                c = c * params % kappa
                call fmm_m2p_bessel_work(c, p, constants % vscales, &
                    & constants % SK_ri(:, jsph), alpha, sph_m(:, jsph), one, &
                    & grid_v(igrid, isph), work_complex, work)
            end do
        end do
    end do
end subroutine tree_m2p_bessel

!------------------------------------------------------------------------------
!> TODO
!------------------------------------------------------------------------------
subroutine tree_m2p_adj(params, constants, p, alpha, grid_v, beta, sph_m)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: p
    real(dp), intent(in) :: grid_v(params % ngrid, params % nsph), alpha, &
        & beta
    ! Output
    real(dp), intent(inout) :: sph_m((p+1)**2, params % nsph)
    ! Temporary workspace
    real(dp) :: work(p+1)
    ! Local variables
    integer :: isph, inode, jnear, jnode, jsph, igrid
    real(dp) :: c(3)
    ! Init output
    if (beta .eq. zero) then
        sph_m = zero
    else
        sph_m = beta * sph_m
    end if
    ! Cycle over all spheres
    !$omp parallel do default(none) shared(params,constants,grid_v,p, &
    !$omp alpha,sph_m), private(isph,inode,jnear,jnode,jsph,igrid,c,work) &
    !$omp schedule(dynamic)
    do isph = 1, params % nsph
        ! Cycle over all near-field admissible pairs of spheres
        inode = constants % snode(isph)
        do jnear = constants % snear(inode), constants % snear(inode+1)-1
            ! Near-field interactions are possible only between leaf nodes,
            ! which must contain only a single input sphere
            jnode = constants % near(jnear)
            jsph = constants % order(constants % cluster(1, jnode))
            ! Ignore self-interaction
            if(isph .eq. jsph) cycle
            ! Accumulate interaction for external grid points only
            do igrid = 1, params % ngrid
                if(constants % ui(igrid, jsph) .eq. zero) cycle
                c = constants % cgrid(:, igrid)*params % rsph(jsph) - &
                    & params % csph(:, isph) + params % csph(:, jsph)
                call fmm_m2p_adj_work(c, alpha*grid_v(igrid, jsph), &
                    & params % rsph(isph), p, constants % vscales_rel, one, &
                    & sph_m(:, isph), work)
            end do
        end do
    end do
end subroutine tree_m2p_adj

!------------------------------------------------------------------------------
!> TODO
!------------------------------------------------------------------------------
subroutine tree_m2p_bessel_adj(params, constants, p, alpha, grid_v, beta, sph_p, &
        & sph_m)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: p, sph_p
    real(dp), intent(in) :: grid_v(params % ngrid, params % nsph), alpha, &
        & beta
    ! Output
    real(dp), intent(inout) :: sph_m((sph_p+1)**2, params % nsph)
    ! Local variables
    !real(dp), allocatable :: tmp(:, :, :)
    integer :: isph, inode, jnear, jnode, jsph, igrid
    real(dp) :: c(3)
    ! Init output
    if (beta .eq. zero) then
        sph_m = zero
    else
        sph_m = beta * sph_m
    end if
    ! Cycle over all spheres
    !$omp parallel do default(none) shared(params,constants,p,sph_m, &
    !$omp alpha,grid_v) private(isph,inode,jnear,jnode,jsph,igrid,c) &
    !$omp schedule(dynamic)
    do isph = 1, params % nsph
        ! Cycle over all near-field admissible pairs of spheres
        inode = constants % snode(isph)
        do jnear = constants % snear(inode), constants % snear(inode+1)-1
            ! Near-field interactions are possible only between leaf nodes,
            ! which must contain only a single input sphere
            jnode = constants % near(jnear)
            jsph = constants % order(constants % cluster(1, jnode))
            ! Accumulate interaction for external grid points only
            do igrid = 1, params % ngrid
                if(constants % ui(igrid, jsph) .eq. zero) cycle
                c = constants % cgrid(:, igrid)*params % rsph(jsph) - &
                    & params % csph(:, isph) + params % csph(:, jsph)
                call fmm_m2p_bessel_adj(c, alpha*grid_v(igrid, jsph), &
                    & params % rsph(isph), params % kappa, p, &
                    & constants % vscales, one, sph_m(:, isph))
            end do
        end do
    end do
end subroutine tree_m2p_bessel_adj

!------------------------------------------------------------------------------
!> TODO
!------------------------------------------------------------------------------
subroutine tree_m2p_bessel_nodiag_adj(params, constants, p, alpha, grid_v, beta, sph_p, &
        & sph_m)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: p, sph_p
    real(dp), intent(in) :: grid_v(params % ngrid, params % nsph), alpha, &
        & beta
    ! Output
    real(dp), intent(inout) :: sph_m((sph_p+1)**2, params % nsph)
    ! Local variables
    integer :: isph, inode, jnear, jnode, jsph, igrid
    real(dp) :: c(3)
    ! Init output
    if (beta .eq. zero) then
        sph_m = zero
    else
        sph_m = beta * sph_m
    end if
    ! Cycle over all spheres
    do isph = 1, params % nsph
        ! Cycle over all near-field admissible pairs of spheres
        inode = constants % snode(isph)
        do jnear = constants % snear(inode), constants % snear(inode+1)-1
            ! Near-field interactions are possible only between leaf nodes,
            ! which must contain only a single input sphere
            jnode = constants % near(jnear)
            jsph = constants % order(constants % cluster(1, jnode))
            ! Ignore self-interaction
            if(isph .eq. jsph) cycle
            ! Accumulate interaction for external grid points only
            do igrid = 1, params % ngrid
                if(constants % ui(igrid, isph) .eq. zero) cycle
                c = constants % cgrid(:, igrid)*params % rsph(isph) - &
                    & params % csph(:, jsph) + params % csph(:, isph)
                call fmm_m2p_bessel_adj(c, alpha*grid_v(igrid, isph), &
                    & params % rsph(jsph), params % kappa, p, constants % vscales, one, &
                    & sph_m(:, jsph))
            end do
        end do
    end do
end subroutine tree_m2p_bessel_nodiag_adj

!------------------------------------------------------------------------------
!> TODO
!------------------------------------------------------------------------------
subroutine tree_grad_m2m(params, constants, sph_m, sph_m_grad, work)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: sph_m(constants % nbasis, params % nsph)
    ! Output
    real(dp), intent(inout) :: sph_m_grad((params % lmax+2)**2, 3, &
        & params % nsph)
    ! Temporary workspace
    real(dp), intent(inout) :: work((params % lmax+2)**2, params % nsph)
    ! Local variables
    integer :: isph, l, indi, indj, m
    real(dp) :: tmp1, tmp2
    real(dp), dimension(3, 3) :: zx_coord_transform, zy_coord_transform
    ! Set coordinate transformations
    zx_coord_transform = zero
    zx_coord_transform(3, 2) = one
    zx_coord_transform(2, 3) = one
    zx_coord_transform(1, 1) = one
    zy_coord_transform = zero
    zy_coord_transform(1, 2) = one
    zy_coord_transform(2, 1) = one
    zy_coord_transform(3, 3) = one
    ! At first reflect harmonics of a degree up to lmax
    sph_m_grad(1:constants % nbasis, 3, :) = sph_m
    do isph = 1, params % nsph
        call fmm_sph_transform(params % lmax, zx_coord_transform, one, &
            & sph_m(:, isph), zero, sph_m_grad(1:constants % nbasis, 1, isph))
        call fmm_sph_transform(params % lmax, zy_coord_transform, one, &
            & sph_m(:, isph), zero, sph_m_grad(1:constants % nbasis, 2, isph))
    end do
    ! Derivative of M2M translation over OZ axis at the origin consists of 2
    ! steps:
    !   1) increase degree l and scale by sqrt((2*l+1)*(l*l-m*m)) / sqrt(2*l-1)
    !   2) scale by 1/rsph(isph)
    do l = params % lmax+1, 1, -1
        indi = l*l + l + 1
        indj = indi - 2*l
        tmp1 = sqrt(dble(2*l+1)) / sqrt(dble(2*l-1))
        do m = 1-l, l-1
            tmp2 = sqrt(dble(l*l-m*m)) * tmp1
            sph_m_grad(indi+m, :, :) = tmp2 * sph_m_grad(indj+m, :, :)
        end do
        sph_m_grad(indi+l, :, :) = zero
        sph_m_grad(indi-l, :, :) = zero
    end do
    sph_m_grad(1, :, :) = zero
    ! Scale by 1/rsph(isph) and rotate harmonics of degree up to lmax+1 back to
    ! the initial axis. Coefficient of 0-th degree is zero so we ignore it.
    do isph = 1, params % nsph
        sph_m_grad(:, 3, isph) = sph_m_grad(:, 3, isph) / params % rsph(isph)
        work(:, isph) = sph_m_grad(:, 1, isph) / params % rsph(isph)
        call fmm_sph_transform(params % lmax+1, zx_coord_transform, one, &
            & work(:, isph), zero, sph_m_grad(:, 1, isph))
        work(:, isph) = sph_m_grad(:, 2, isph) / params % rsph(isph)
        call fmm_sph_transform(params % lmax+1, zy_coord_transform, one, &
            & work(:, isph), zero, sph_m_grad(:, 2, isph))
    end do
end subroutine tree_grad_m2m

!------------------------------------------------------------------------------
!> TODO
!------------------------------------------------------------------------------
subroutine tree_grad_l2l(params, constants, node_l, sph_l_grad, work)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: node_l((params % pl+1)**2, constants % nclusters)
    ! Output
    real(dp), intent(out) :: sph_l_grad((params % pl+1)**2, 3, params % nsph)
    ! Temporary workspace
    real(dp), intent(out) :: work((params % pl+1)**2, params % nsph)
    ! Local variables
    integer :: isph, inode, l, indi, indj, m
    real(dp) :: tmp1, tmp2
    real(dp), dimension(3, 3) :: zx_coord_transform, zy_coord_transform
    ! Gradient of L2L reduces degree by 1, so exit if degree of harmonics is 0
    ! or -1 (which means no FMM at all)
    if (params % pl .le. 0) return
    ! Set coordinate transformations
    zx_coord_transform = zero
    zx_coord_transform(3, 2) = one
    zx_coord_transform(2, 3) = one
    zx_coord_transform(1, 1) = one
    zy_coord_transform = zero
    zy_coord_transform(1, 2) = one
    zy_coord_transform(2, 1) = one
    zy_coord_transform(3, 3) = one
    ! At first reflect harmonics of a degree up to pl
    do isph = 1, params % nsph
        inode = constants % snode(isph)
        sph_l_grad(:, 3, isph) = node_l(:, inode)
        call fmm_sph_transform(params % pl, zx_coord_transform, one, &
            & node_l(:, inode), zero, sph_l_grad(:, 1, isph))
        call fmm_sph_transform(params % pl, zy_coord_transform, one, &
            & node_l(:, inode), zero, sph_l_grad(:, 2, isph))
    end do
    ! Derivative of L2L translation over OZ axis at the origin consists of 2
    ! steps:
    !   1) decrease degree l and scale by sqrt((2*l-1)*(l*l-m*m)) / sqrt(2*l+1)
    !   2) scale by 1/rsph(isph)
    do l = 1, params % pl
        indi = l*l + l + 1
        indj = indi - 2*l
        tmp1 = -sqrt(dble(2*l-1)) / sqrt(dble(2*l+1))
        do m = 1-l, l-1
            tmp2 = sqrt(dble(l*l-m*m)) * tmp1
            sph_l_grad(indj+m, :, :) = tmp2 * sph_l_grad(indi+m, :, :)
        end do
    end do
    ! Scale by 1/rsph(isph) and rotate harmonics of degree up to pl-1 back to
    ! the initial axis. Coefficient of pl-th degree is zero so we ignore it.
    do isph = 1, params % nsph
        sph_l_grad(1:params % pl**2, 3, isph) = &
            & sph_l_grad(1:params % pl**2, 3, isph) / params % rsph(isph)
        work(1:params % pl**2, isph) = &
            & sph_l_grad(1:params % pl**2, 1, isph) / params % rsph(isph)
        call fmm_sph_transform(params % pl-1, zx_coord_transform, one, &
            & work(1:params % pl**2, isph), zero, &
            & sph_l_grad(1:params % pl**2, 1, isph))
        work(1:params % pl**2, isph) = &
            & sph_l_grad(1:params % pl**2, 2, isph) / params % rsph(isph)
        call fmm_sph_transform(params % pl-1, zy_coord_transform, one, &
            & work(1:params % pl**2, isph), zero, &
            & sph_l_grad(1:params % pl**2, 2, isph))
    end do
    ! Set degree pl to zero to avoid problems if user actually uses it
    l = params % pl
    indi = l*l + l + 1
    sph_l_grad(indi-l:indi+l, :, :) = zero
end subroutine tree_grad_l2l

!> Print the ddX logo
!> @ingroup Fortran_interface_core
!!
!! @param[out] string: container for the logo
!!
subroutine get_banner(string)
    implicit none
    character (len=2047), intent(out) :: string
    character (len=10) :: vstr
    write(vstr, *) "0.8.0"
    write(string, *) &
        & " +----------------------------------------------------------------+", &
        & NEW_LINE('a'), &
        & "  |                                                                |", &
        & NEW_LINE('a'), &
        & "  |                        888      888 Y8b    d8Y                 |", &
        & NEW_LINE('a'), &
        & "  |                        888      888  Y8b  d8Y                  |", &
        & NEW_LINE('a'), &
        & "  |                        888      888   Y8888Y                   |", &
        & NEW_LINE('a'), &
        & "  |                    .d88888  .d88888    Y88Y                    |", &
        & NEW_LINE('a'), &
        & "  |                   d88  888 d88  888    d88b                    |", &
        & NEW_LINE('a'), &
        & "  |                   888  888 888  888   d8888b                   |", &
        & NEW_LINE('a'), &
        & "  |                   Y88b 888 Y88b 888  d8Y  Y8b                  |", &
        & NEW_LINE('a'), &
        & "  |                     Y88888   Y88888 d8Y    Y8b                 |", &
        & NEW_LINE('a'), &
        & "  |                                                                |", &
        & NEW_LINE('a'), &
        & "  |                 https://ddsolvation.github.io/ddX/             |", &
        & NEW_LINE('a'), &
        & "  |                         Version:", vstr, "                     |", &
        & NEW_LINE('a'), &
        & "  |                                                                |", &
        & NEW_LINE('a'), &
        & "  +----------------------------------------------------------------+"
end subroutine get_banner

!> Transform a function defined at the exposed cavity points (cav) to
!> a spherical harmonics expansion. Note that the function is also
!> multiplied by the characteristic function U.
!!
!! @param[in] params: ddx parameters
!! @param[in] constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[in] property_cav: property defined at the exposed cavity points,
!!      size (ncav)
!! @param[out] property_sph: property as a spherical harmonics expansion,
!!      size (nbasis, nsph)
subroutine cav_to_spherical(params, constants, workspace, property_cav, &
        & property_sph)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), intent(in) :: property_cav(constants % ncav)
    real(dp), intent(out) :: property_sph(constants % nbasis, params % nsph)

    ! multiply by the characteristic function U
    workspace % tmp_cav = property_cav * constants % ui_cav

    ! extend the function to the sphere intersection with zeros
    call ddcav_to_grid_work(params % ngrid, params % nsph, constants % ncav, &
        & constants % icav_ia, constants % icav_ja, workspace % tmp_cav, &
        & workspace % tmp_grid)

    ! integrate against spherical harmonics
    call ddintegrate(params % nsph, constants % nbasis, &
        & params % ngrid, constants % vwgrid, constants % vgrid_nbasis, &
        & workspace % tmp_grid, property_sph)
end subroutine cav_to_spherical

end module ddx_core

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_cgto_ortho
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use tblite_basis_ortho, only : orthogonalize
   use tblite_basis_type, only : cgto_type
   use tblite_basis_slater, only : slater_to_gauss
   use tblite_integral_overlap, only : overlap_cgto
   implicit none
   private

   public :: collect_cgto_ortho

   real(wp), parameter :: thr = 5e+6_wp*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

contains


!> Collect all exported unit tests
subroutine collect_cgto_ortho(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("ortho-1s-2s", test_ortho_1s_2s) &
      ]

end subroutine collect_cgto_ortho


subroutine test_ortho_1s_2s(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   type(cgto_type) :: cgtoi, cgtoj
   real(wp), parameter :: vec(3) = 0.0_wp, r2 = 0.0_wp
   real(wp) :: overlap(2, 2:2)

   call slater_to_gauss(6, 1, 0, 1.207940_wp, cgtoi, .true., stat)
   call check(error, stat)
   if (allocated(error)) return
   call slater_to_gauss(2, 2, 0, 1.993207_wp, cgtoj, .true., stat)
   call check(error, stat)
   if (allocated(error)) return

   call orthogonalize(cgtoi, cgtoj)

   call overlap_cgto(cgtoj, cgtoj, r2, vec, 100.0_wp, overlap(2:2, 2))
   call check(error, overlap(2, 2), 1.0_wp, thr=thr)
   if (allocated(error)) then
      print*, (overlap(2, 2)) - 1.0_wp
      return
   end if

   call overlap_cgto(cgtoi, cgtoj, r2, vec, 100.0_wp, overlap(1:1, 2))
   call check(error, overlap(1, 2), 0.0_wp, thr=thr)
   if (allocated(error)) then
      print*, (overlap(1, 2))
      return
   end if

end subroutine test_ortho_1s_2s


end module test_cgto_ortho

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/io/molden.f90
!> Provides Molden wavefunction input and output support.

!> The Molden writer produces a Molden input with the following sections:
!>
!> ```
!> [Molden Format]
!> [Title]
!> [Cell] AU          non-standard extension for periodic systems
!> [Atoms] AU
!> [Core]             non-standard extension for core electron count
!> [Pseudo]           non-standard extension for valence electron count
!> [Nval]             non-standard extension for valence electron count
!> [GTO]
!> [6D]/[10F]/[15G]   optional explicit declaration of cartesian format
!> [MO]
!> ```
!> 
!> This format extends the official Molden specification documented at
!>
!>   https://www.theochem.ru.nl/molden/molden_format.html
!> 
!> The non-standard `[Cell]` section (consistent with Multiwfn and CP2K)
!> specifies periodic information lacking in the Molden Format, and 
!> contains cartesian lattice vectors assuming three-dimensional periodicity:
!> 
!> ```
!> [Cell] AU
!>   ax ay az
!>   bx by bz
!>   cx cy cz
!> ```
!>
!> The Molden writer and reader follow the official specification for the ordering 
!> of cartesian/spherical atomic orbitals in the `[GTO]` section:
!>
!> ```
!> s    : s
!>
!> p    : px, py, pz
!>
!> 6D   : xx, yy, zz, xy, xz, yz
!> 5D   : 0, +1, -1, +2, -2
!>
!> 10F  : xxx, yyy, zzz, xyy, xxy, xxz, xzz, yzz, yyz, xyz
!> 7F   : 0, +1, -1, +2, -2, +3, -3
!>
!> 15G  : xxxx, yyyy, zzzz, xxxy, xxxz, xyyy, yyyz, xzzz, yzzz,
!>        xxyy, xxzz, yyzz, xxyz, xyyz, xyzz
!> 9G   : 0, +1, -1, +2, -2, +3, -3, +4, -4
!> ```
!>
!> The writer always emits Cartesian AO coefficients in `[MO]` and declares
!> Cartesian higher angular momentum shells with `[6D]`, `[10F]`, and `[15G]`.
!> The reader accepts both Cartesian and spherical Molden MO coefficient ordering.
!>
!> Primitive coefficients written in the `[GTO]` section contain normalization
!> of the spherical harmonic Gaussian primitives, as well as normalization 
!> of the contracted basis functions (the used expansion by Stewart of the STO-nG 
!> functions inherently contains contracted normalization). The reader assumes
!> that the coefficients contain both primitive and contracted normalization.
!>
!> The number of valence electrons and the effective atomic charge is specified via
!> the non-standard `[Core]` section (consistent with Molden2AIM and PySCF), 
!> the non-standard `[Pseudo]` section (consistent with Molden, CP2K, and Orca),
!> the non-standard `[Nval]` section (consistent with Multiwfn). 
!>
!> In the `[MO]` section, restricted closed-shell wavefunctions are written as 
!> spatial orbitals, while restricted open-shell and unrestricted wavefunctions
!> are written as separate alpha and beta spin orbitals.
!> 
!> The Molden reader constructs tblite internal `structure_type`, `basis_type`, and 
!> `wavefunction_type` objects from the corresponding sections of the Molden file.

!> Implementation of Molden file I/O
module tblite_io_molden
   use, intrinsic :: iso_fortran_env, only : iostat_end
   use mctc_env, only : error_type, fatal_error, wp, i8
   use mctc_io, only : structure_type, new
   use mctc_io_convert, only : aatoau
   use tblite_basis_type, only : basis_type, cgto_type, new_basis, new_cgto
   use tblite_version, only : get_tblite_version
   use tblite_wavefunction_type, only : wavefunction_type, new_wavefunction, &
      & get_density_matrix
   use tblite_wavefunction_spin, only : magnet_to_updown
   implicit none
   private

   public :: load_molden, save_molden

   !> Maximum contraction length allowed in Molden basis sets
   integer, parameter :: maxg = 12

   !> Line buffer for intermediate storage of section content during parsing
   type :: line_buffer_type
      !> Actual line content
      character(len=512), allocatable :: lines(:)
      !> Current capacity of the buffer
      integer :: capacity = 32
      !> Number of lines currently stored
      integer :: count = 0
   contains
      !> Add line to the buffer with automatic resizing
      procedure :: push_back
   end type line_buffer_type

contains

!> Add line to the buffer with automatic resizing
subroutine push_back(self, line)
   !> Line buffer instance
   class(line_buffer_type), intent(inout) :: self
   !> Line to add to the buffer
   character(len=*), intent(in) :: line

   character(len=512), allocatable :: tmp(:)
   integer :: new_capacity

   ! Allocate lines upon first insertion
   if (.not. allocated(self%lines)) then
      allocate(self%lines(self%capacity))
      self%count = 0
   end if

   ! Double buffer size if needed
   if (self%count >= self%capacity) then
      new_capacity = max(1, 2 * self%capacity)

      allocate(tmp(new_capacity))
      tmp(1:self%count) = self%lines(1:self%count)

      call move_alloc(tmp, self%lines)
      self%capacity = new_capacity
   end if

   self%count = self%count + 1
   self%lines(self%count) = line
end subroutine push_back


!> Read Molden file and construct structure, basis, and wavefunction objects.
subroutine load_molden(filename, mol, bas, wfn, error)
   !> Input Molden file name
   character(len=*), intent(in) :: filename
   !> Molecular structure data loaded from Molden file
   type(structure_type), intent(out) :: mol
   !> Basis set information loaded from Molden file
   type(basis_type), intent(out) :: bas
   !> Wavefunction data loaded from Molden file
   type(wavefunction_type), intent(out) :: wfn
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=512) :: line, pending_line, errmsg
   character(len=16) :: spec, atoms_spec, cell_spec
   integer :: unit, stat
   integer(i8) :: mo_position
   type(line_buffer_type) :: cell, atoms, core, pseudo, nval, gto
   logical :: pending, has_mo, use_6d, use_10f, use_15g

   open(newunit=unit, file=filename, status='old', action='read', &
      & access='stream', form="formatted", iostat=stat, iomsg=errmsg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to open Molden input '"//filename//"': "//trim(errmsg))
      return
   end if

   pending = .false.
   has_mo = .false.
   use_6d = .true.
   use_10f = .true.
   use_15g = .true.
   atoms_spec = ""
   cell_spec = ""
   do
      if (pending) then
         line = pending_line
         pending = .false.
      else
         ! Read the next line keeping track of the file position
         read(unit, '(A)', iostat=stat) line
         ! Check for EOF and I/O errors
         if (stat == iostat_end) exit
         if (stat /= 0) then
            call fatal_error(error, "I/O error reading: "//trim(line))
            exit
         end if
      end if

      ! Check for section header
      if (len_trim(section_id(line)) == 0) cycle

      ! Check for unit specificiations in the header line
      spec = section_spec(line)

      ! Read individual sections into line buffers excluding the section header
      select case(trim(section_id(line)))
      case("cell")
         cell_spec = spec
         call collect_section_lines(unit, cell, pending, pending_line, error)
      case("atoms")
         atoms_spec = spec
         call collect_section_lines(unit, atoms, pending, pending_line, error)
      case("gto")
         call collect_section_lines(unit, gto, pending, pending_line, error)
      case("core")
         call collect_section_lines(unit, core, pending, pending_line, error)
      case("pseudo")
         call collect_section_lines(unit, pseudo, pending, pending_line, error)
      case("nval")
         call collect_section_lines(unit, nval, pending, pending_line, error)
      case("mo")
         ! Record file position for on-the-fly parsing the MO section
         ! after the structure and basis set have been build
         has_mo = .true.
         inquire(unit=unit, pos=mo_position)
         call skip_section(unit, pending, pending_line, error)
      case("5d")
         use_6d = .false.
      case("6d")
         use_6d = .true.
      case("7f")
         use_10f = .false.
      case("10f")
         use_10f = .true.
      case("9g")
         use_15g = .false.
      case("15g")
         use_15g = .true.
      case default
         ! Skipping sections like [Molden Format], [Title], [Freq], and [Geom]
         call skip_section(unit, pending, pending_line, error)
      end select
      if (allocated(error)) exit
   end do
   ! Check for missing required [MO] section
   if (.not. has_mo) then
      call fatal_error(error, "Molden input is missing required [MO] section")
   end if
   if (allocated(error)) then
      close(unit, iostat=stat, iomsg=errmsg)
      if (stat /= 0 .and. .not.allocated(error)) then
         call fatal_error(error, "Failed to close Molden input '"//filename//"': "//trim(errmsg))
      end if
      return
   end if

   ! Construct structure and basis set with the buffered section content
   call build_structure(cell, cell_spec, atoms, atoms_spec, mol, error)
   if (.not.allocated(error)) call build_basis(gto, mol, bas, error)

   ! Read the wavefunction information now that the dimensions are known
   if (.not.allocated(error)) call build_wavefunction(unit, mo_position, &
      & core, pseudo, nval, use_6d, use_10f, use_15g, mol, bas, wfn, error)

   close(unit, iostat=stat, iomsg=errmsg)
   if (stat /= 0 .and. .not.allocated(error)) then
      call fatal_error(error, "Failed to close Molden input '"//filename//"': "//trim(errmsg))
      return
   end if
end subroutine load_molden

subroutine collect_section_lines(unit, buffer, pending, pending_line, error)
   !> Open Molden file unit
   integer, intent(in) :: unit
   !> Line buffer to collect the section content
   type(line_buffer_type), intent(inout) :: buffer
   !> Flag to indicate that the last read line was a pending section header
   logical, intent(inout) :: pending
   !> Storage for a pending section header line
   character(len=512), intent(inout) :: pending_line
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=512) :: line
   integer :: stat

   do
      read(unit, '(A)', iostat=stat) line
      ! Check for EOF and I/O errors
      if (stat == iostat_end) exit
      if (stat /= 0) then
         call fatal_error(error, "I/O error reading: "//trim(line))
         return
      end if
      ! Check for empty lines and skip them
      if (len_trim(line) == 0) cycle
      ! Check if current line is a section header
      if (len_trim(section_id(line)) > 0) then
         pending_line = line
         pending = .true.
         exit
      end if
      ! Store line in buffer
      call buffer%push_back(line)
   end do
end subroutine collect_section_lines

subroutine skip_section(unit, pending, pending_line, error)
   !> Open Molden file unit
   integer, intent(in) :: unit
   !> Flag to indicate that the last read line was a pending section header
   logical, intent(inout) :: pending
   !> Storage for a pending section header line
   character(len=512), intent(inout) :: pending_line
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=512) :: line
   integer :: stat

   do
      read(unit, '(A)', iostat=stat) line
      ! Check for EOF and I/O errors
      if (stat == iostat_end) exit
      if (stat /= 0) then
         call fatal_error(error, "I/O error reading: "//trim(line))
         return
      end if
      ! Check if current line is a section header
      if (len_trim(section_id(line)) > 0) then
         pending_line = line
         pending = .true.
         exit
      end if
   end do
end subroutine skip_section


!> Write tblite singlepoint data to a Molden file.
subroutine save_molden(filename, mol, bas, wfn, error)
   !> Output Molden file name
   character(len=*), intent(in) :: filename
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis metadata used by the calculation
   class(basis_type), intent(in) :: bas
   !> Converged wavefunction
   type(wavefunction_type), intent(in) :: wfn
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=512) :: errmsg
   integer :: unit, stat
   character(len=:), allocatable :: version_string

   open(newunit=unit, file=filename, status='replace', action='write', &
      & iostat=stat, iomsg=errmsg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to open Molden output '"//filename//"': "//trim(errmsg))
      return
   end if

   write(unit,'(A)') '[Molden Format]'
   write(unit,'(A)') '[Title]'
   call get_tblite_version(string=version_string)
   write(unit,'(A)') 'tblite version '//trim(version_string)

   call write_cell(unit, mol, error)
   if (.not.allocated(error)) call write_atoms(unit, mol, error)
   if (.not.allocated(error)) call write_core(unit, mol, wfn, error)
   if (.not.allocated(error)) call write_pseudo(unit, mol, wfn, error)
   if (.not.allocated(error)) call write_nval(unit, mol, wfn, error)
   if (.not.allocated(error)) call write_gto(unit, mol, bas, error)
   if (.not.allocated(error)) then
      if (bas%maxl >= 2) write(unit,'(A)') '[6D]'
      if (bas%maxl >= 3) write(unit,'(A)') '[10F]'
      if (bas%maxl >= 4) write(unit,'(A)') '[15G]'
   end if
   if (.not.allocated(error)) call write_mo(unit, mol, bas, wfn, error)

   close(unit, iostat=stat, iomsg=errmsg)
   if (stat /= 0 .and. .not.allocated(error)) then
      call fatal_error(error, "Failed to close Molden output '"//filename//"': "//trim(errmsg))
   end if
end subroutine save_molden


!> Build molecular structure from buffered [Cell] and [Atoms] sections.
subroutine build_structure(cell, cell_spec, atoms, atoms_spec, mol, error)
   !> Buffered [Cell] section
   type(line_buffer_type), intent(in) :: cell
   !> Unit specifier from [Cell] header
   character(len=*), intent(in) :: cell_spec
   !> Buffered [Atoms] section
   type(line_buffer_type), intent(in) :: atoms
   !> Unit specifier from [Atoms] header
   character(len=*), intent(in) :: atoms_spec
   !> Molecular structure data loaded from Molden file
   type(structure_type), intent(out) :: mol
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: nat
   integer, allocatable :: atomic_number(:)
   real(wp), allocatable :: nuclear_coord(:, :), lattice(:, :)
   logical, allocatable :: periodic(:)

   call read_cell(cell, cell_spec, periodic, lattice, error)
   if (.not. allocated(error)) then
      call read_atoms(atoms, atoms_spec, nat, atomic_number, nuclear_coord, error)
   end if
   if (allocated(error)) return

   ! Set up new molecular structure object with dummy charge and unpaired electrons
   call new(mol, atomic_number, nuclear_coord, charge=0.0_wp, uhf=0, &
      & lattice=lattice, periodic=periodic)
end subroutine build_structure

!> Read optional [Cell] section for 3 lattice vectors from buffered lines.
subroutine read_cell(buffer, spec, periodic, lattice, error)
   !> Buffered [Cell] section
   type(line_buffer_type), intent(in) :: buffer
   !> Unit specifier from the [Cell] header
   character(len=*), intent(in) :: spec
   !> Periodic directions
   logical, allocatable, intent(out) :: periodic(:)
   !> Lattice vectors in Bohr
   real(wp), allocatable, intent(out) :: lattice(:, :)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=512) :: line
   integer :: ilat, iline, stat
   real(wp) :: conversion

   if (buffer%count == 0) return

   ! Read optional unit specifier from the header
   conversion = 1.0_wp
   if (len_trim(spec) > 0) then
      select case(trim(spec))
      case("au", "bohr")
         conversion = 1.0_wp
      case("angs")
         conversion = aatoau
      case default
         call fatal_error(error, "Unrecognized unit specifier in [Cell] header: "//trim(spec))
         return
      end select
   end if

   ! If there is a [Cell] section, we require three dimensional periodicity
   allocate(periodic(3), source=.true.)
   allocate(lattice(3, 3), source=0.0_wp)
   ilat = 0
   do iline = 1, buffer%count
      line = buffer%lines(iline)
      ilat = ilat + 1
      if (ilat > 3) then
         call fatal_error(error, "[Cell] has more than three lattice vectors")
         return
      end if
      read(line, *, iostat=stat) lattice(:, ilat)
      if (stat /= 0) then
         call fatal_error(error, "Failed to read [Cell] vector: "//trim(line))
         return
      end if
      lattice(:, ilat) = conversion * lattice(:, ilat)
   end do

   if (ilat < 3) then
      call fatal_error(error, "[Cell] requires three lattice vectors")
      return
   end if
end subroutine read_cell

!> Read required [Atoms] section for atomic numbers and coordinates from buffered lines.
subroutine read_atoms(buffer, spec, nat, atomic_number, nuclear_coord, error)
   !> Buffered [Atoms] section
   type(line_buffer_type), intent(in) :: buffer
   !> Unit specifier from the [Atoms] header
   character(len=*), intent(in) :: spec
   !> Number of atoms
   integer, intent(out) :: nat
   !> Atomic numbers
   integer, allocatable, intent(out) :: atomic_number(:)
   !> Nuclear coordinates in Bohr
   real(wp), allocatable, intent(out) :: nuclear_coord(:, :)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=512) :: line
   character(len=16) :: sym
   integer :: iline, iat, stat, tmp_z
   real(wp) :: conversion, tmp_xyz(3)

   if (buffer%count == 0) then
      call fatal_error(error, "Molden input is missing required [Atoms] section")
      return
   end if

   ! Read optional unit specifier from the header
   conversion = 1.0_wp
   if (len_trim(spec) > 0) then
      select case(trim(spec))
      case("au", "bohr")
         conversion = 1.0_wp
      case("angs")
         conversion = aatoau
      case default
         call fatal_error(error, "Unrecognized unit specifier in [Atoms] header: "//trim(spec))
         return
      end select
   end if

   nat = buffer%count
   allocate(atomic_number(nat), nuclear_coord(3, nat))
   do iline = 1, buffer%count
      line = buffer%lines(iline)
      read(line, *, iostat=stat) sym, iat, tmp_z, tmp_xyz
      if (stat /= 0) then
         call fatal_error(error, "Failed to read [Atoms] entry: "//trim(line))
         return
      end if
      if (iat < 1 .or. iat > nat) then
         call fatal_error(error, "Atom index out of range in [Atoms] entry: "//trim(line))
         return
      end if
      atomic_number(iat) = tmp_z
      nuclear_coord(:, iat) = conversion * tmp_xyz
   end do
end subroutine read_atoms


!> Build basis set from buffered [GTO] section.
subroutine build_basis(gto, mol, bas, error)
   !> Buffered [GTO] section
   type(line_buffer_type), intent(in) :: gto
   !> Molecular structure data loaded from Molden file
   type(structure_type), intent(in) :: mol
   !> Basis set information loaded from molden File
   type(basis_type), intent(out) :: bas
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: nsh
   integer, allocatable :: nsh_id(:)
   type(cgto_type), allocatable :: cgto(:, :)

   call read_gto(gto, mol, nsh, nsh_id, cgto, error)
   if (allocated(error)) return

   ! Set up new basis set object with dummy accuracy setting
   call new_basis(bas, mol, nsh_id, cgto, 1.0_wp)
end subroutine build_basis

!> Read [GTO] section for CGTO information from buffered lines.
subroutine read_gto(buffer, mol, nsh, nsh_id, cgto, error)
   !> Buffered [GTO] section
   type(line_buffer_type), intent(in) :: buffer
   !> Molecular structure data loaded from Molden file
   type(structure_type), intent(in) :: mol
   !> Number of shells
   integer, intent(out) :: nsh
   !> Number of shells per species
   integer, allocatable, intent(out) :: nsh_id(:)
   !> CGTO for each shell and species
   type(cgto_type), allocatable, intent(out) :: cgto(:, :)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=512) :: line
   integer :: iat, isp, ish, iprim, l, nprim, iline, stat
   integer, allocatable :: nsh_at(:), nsh_work(:)
   real(wp) :: alpha(maxg), coeff(maxg)
   logical, allocatable :: seen_cgto(:, :)
   type(cgto_type) :: tmp_cgto

   if (buffer%count == 0) then
      call fatal_error(error, "Molden input is missing required [GTO] section")
      return
   end if

   ! First pass to count and map shells
   allocate(nsh_at(mol%nat), source=0)
   nsh = 0
   iat = 0
   iline = 1
   do while (iline <= buffer%count)
      line = buffer%lines(iline)
      ! Check for for atom index line
      call parse_atom_index(line, iat, stat)
      if (stat == 0) then
         if (iat < 1 .or. iat > mol%nat) then
            call fatal_error(error, "[GTO] atom index out of range: "//trim(line))
            return
         end if
         iline = iline + 1
         cycle
      end if
      ! Check for shell header
      call parse_shell_header(line, l, nprim, stat)
      if (stat == 0) then 
         if (iat < 1 .or. iat > mol%nat) then
            call fatal_error(error, "[GTO] shell before valid atom index")
            return
         end if
         if (nprim <= 0 .or. nprim > maxg) then
            call fatal_error(error, "[GTO] shell has zero primitives or more primitives than supported")
            return
         end if
         nsh = nsh + 1
         nsh_at(iat) = nsh_at(iat) + 1
         iline = iline + nprim + 1
         cycle
      end if

      call fatal_error(error, "Failed to parse [GTO] line: "//trim(line))
      return
   end do

   ! Check for identical shell counts for all atoms of a given species
   allocate(nsh_id(mol%nid))
   nsh_id(:) = -1
   do iat = 1, mol%nat
      isp = mol%id(iat)
      if (nsh_id(isp) < 0) then
         nsh_id(isp) = nsh_at(iat)
      else if (nsh_id(isp) /= nsh_at(iat)) then
         call fatal_error(error, "Molden input has inconsistent shell counts for one species")
         return
      end if
   end do
   if (any(nsh_id <= 0)) then
      call fatal_error(error, "Molden input missing shells for at least one species")
      return
   end if

   ! Build CGTOs for each species
   allocate(cgto(maxval(nsh_id), mol%nid))
   allocate(seen_cgto(maxval(nsh_id), mol%nid), source=.false.)
   allocate(nsh_work(mol%nat), source=0)
   iline = 1
   do while (iline <= buffer%count)
      line = buffer%lines(iline)
      call parse_atom_index(line, iat, stat)
      if (stat == 0) then
         iline = iline + 1
         cycle
      end if
      call parse_shell_header(line, l, nprim, stat)
      if (stat /= 0) cycle

      ! Read primitive GTO information
      alpha(:) = 0.0_wp
      coeff(:) = 0.0_wp
      do iprim = 1, nprim
         iline = iline + 1
         line = buffer%lines(iline)
         read(line, *, iostat=stat) alpha(iprim), coeff(iprim)
         if (stat /= 0) then
            call fatal_error(error, "Failed to parse [GTO] primitive: "//trim(line))
            return
         end if
      end do

      ! Assume normalization is already included in the coefficients
      call new_cgto(tmp_cgto, nprim, l, alpha, coeff, .false.)

      ! Check if current CGTO matches earlier CGTOs for the same species
      isp = mol%id(iat)
      nsh_work(iat) = nsh_work(iat) + 1
      ish = nsh_work(iat)
      if (.not. seen_cgto(ish, isp)) then
         cgto(ish, isp) = tmp_cgto
         seen_cgto(ish, isp) = .true.
      else if (.not.cgto(ish, isp)%compare(tmp_cgto)) then
         call fatal_error(error, "Molden basis differs between atoms of the same species")
         return
      end if
      iline = iline + 1
   end do
end subroutine read_gto

subroutine parse_atom_index(line, iat, stat)
   !> Line to parse for an atom index
   character(len=*), intent(in) :: line
   !> Atom index if the line contains an atom header
   integer, intent(inout) :: iat
   !> Status of the parsing
   integer, intent(out) :: stat

   integer :: tmp_iat, dummy

   ! Check for Molden atom header: atom_index 0
   read(line, *, iostat=stat) tmp_iat, dummy
   if (stat == 0 .and. dummy == 0) then
      iat = tmp_iat
   else
      stat = 1
   end if
end subroutine parse_atom_index

subroutine parse_shell_header(line, l, nprim, stat)
   !> Line to parse for an shell header
   character(len=*), intent(in) :: line
   !> Angular momentum of the shell
   integer, intent(out) :: l
   !> Number of primitives in the shell
   integer, intent(out) :: nprim
   !> Status of the parsing
   integer, intent(out) :: stat

   character(len=16) :: label
   real(wp) :: scale

   l = -1
   nprim = 0
   scale = 1.0_wp

   ! Check for Molden shell header (ignoring scale): label nprim [scale]
   read(line, *, iostat=stat) label, nprim, scale
   if (stat /= 0) then
      read(line, *, iostat=stat) label, nprim
      scale = 1.0_wp
   end if
   if (stat /= 0) return

   select case(trim(lower_string(adjustl(label))))
   case("s")
      l = 0
   case("p")
      l = 1
   case("d")
      l = 2
   case("f")
      l = 3
   case("g")
      l = 4
   case default
      stat = 1
      return
   end select
end subroutine parse_shell_header


!> Build wavefunction from buffered [Core], [Pseudo], and [Nval] sections
!> while reading the [MO] section on-the-fly.
subroutine build_wavefunction(unit, mo_position, core, pseudo, nval, &
   & use_6d, use_10f, use_15g, mol, bas, wfn, error)
   !> Open Molden file unit
   integer, intent(in) :: unit
   !> Stream position of first line after [MO] header
   integer(i8), intent(in) :: mo_position
   !> Buffered [Core] section
   type(line_buffer_type), intent(in) :: core
   !> Buffered [Pseudo] section
   type(line_buffer_type), intent(in) :: pseudo
   !> Buffered [Nval] section
   type(line_buffer_type), intent(in) :: nval
   !> Use Cartesian d coefficients in [MO]
   logical, intent(in) :: use_6d
   !> Use Cartesian f coefficients in [MO]
   logical, intent(in) :: use_10f
   !> Use Cartesian g coefficients in [MO]
   logical, intent(in) :: use_15g
   !> Molecular structure, updated with charge/uhf
   type(structure_type), intent(inout) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Wavefunction data
   type(wavefunction_type), intent(out) :: wfn
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: spin, nspin
   integer, allocatable :: nvalence(:)
   real(wp), allocatable :: coeff(:, :, :), focc(:, :), emo(:,:), tmp_focc(:)
   logical :: cartesian

   ! Parse optional core electron sections checking for consistency.
   call read_core(core, mol, nvalence, error)
   if (.not. allocated(error)) call read_pseudo(pseudo, mol, nvalence, error)
   if (.not. allocated(error)) call read_nval(nval, mol, nvalence, error)
   if (.not. allocated(error) .and. allocated(nvalence)) then
      if (any(nvalence <= 0)) then
         call fatal_error(error, "No valence electrons assigned for at least one atom")
         return
      end if
   end if
   if (allocated(error)) return

   ! Select Cartesian (default) or spherical AO basis
   select case(bas%maxl)
   case(2)
      cartesian = use_6d
   case(3)
      cartesian = use_6d .and. use_10f
      if (.not.cartesian .and. (use_6d .or. use_10f)) then
         call fatal_error(error, "Molden file must use consistent Cartesian or spherical ordering")
         return
      end if
   case(4)
      cartesian = use_6d .and. use_10f .and. use_15g
      if (.not.cartesian .and. (use_6d .or. use_10f .or. use_15g)) then
         call fatal_error(error, "Molden file must use consistent Cartesian or spherical ordering")
         return
      end if
   case default
      cartesian = .false.
   end select

   ! Read the MO section directly from the file stream
   call read_mo(unit, mo_position, mol, bas, cartesian, nspin, coeff, focc, emo, error)
   if (allocated(error)) return

   ! Setup new wavefunction object (by default 0K electronic temperature)
   call new_wavefunction(wfn, mol%nat, bas%nsh, bas%nao, nspin, 0.0_wp)

   ! Set MO occupation and unpaired electrons
   wfn%nocc = sum(focc)
   wfn%nel(1) = sum(focc(:, 1))
   wfn%nel(2) = sum(focc(:, 2))
   wfn%nuhf = abs(wfn%nel(1) - wfn%nel(2))
   wfn%emo(:, :) = emo(:, 1:nspin)
   wfn%focc(:, :) = focc

   ! Set atomic reference occupation from valence electron count
   if (allocated(nvalence)) then
      wfn%n0at(:) = nvalence
   else
      wfn%n0at(:) = mol%num(mol%id)
   end if

   ! Update unpaired electrons and charge also for the structure type
   mol%uhf = nint(wfn%nuhf)
   mol%charge = sum(real(wfn%n0at, wp)) - sum(wfn%nel)

   ! Transform reordered MO coefficients to spherical basis if necessary
   if (cartesian) then
      do spin = 1, nspin
         call bas%cartesian_to_spherical_trafo(mol, coeff(:, :, spin), &
            & wfn%coeff(:, :, spin))
      end do
   else
      do spin = 1, nspin
         wfn%coeff(:, :, spin) = coeff(:, :, spin)
      end do
   end if

   ! Calculate the density matrix from MO coefficients and occupation numbers
   if (nspin == 1) then
      allocate(tmp_focc(size(wfn%focc, 1)))
      tmp_focc(:) = wfn%focc(:, 1) + wfn%focc(:, 2)
      call get_density_matrix(tmp_focc, wfn%coeff(:, :, 1), wfn%density(:, :, 1))
   else
      do spin = 1, nspin
         call get_density_matrix(wfn%focc(:, spin), wfn%coeff(:, :, spin), &
            & wfn%density(:, :, spin))
      end do
   end if
end subroutine build_wavefunction

!> Read optional [Core] section for valence electron count from buffered lines.
subroutine read_core(buffer, mol, nvalence, error)
   !> Buffered [Core] section
   type(line_buffer_type), intent(in) :: buffer
   !> Molecular structure data loaded from Molden file
   type(structure_type), intent(in) :: mol
   !> Number of valence electrons per atom
   integer, allocatable, intent(inout) :: nvalence(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=512) :: line
   character(len=16) :: sym, sep
   integer :: iline, iat, isp, stat, val, tmp_valence
   logical :: check, matched, by_index

   if (buffer%count == 0) return

   ! Check for consistency, if valence electrons were also read in a different section
   if (.not. allocated(nvalence)) then
      check = .false.
      allocate(nvalence(mol%nat), source=0)
   else
      check = .true.
   end if

   do iline = 1, buffer%count
      line = buffer%lines(iline)
      iat = -1
      by_index = .false.
      ! Read core entry: iat [:] val
      read(line, *, iostat=stat) iat, sep, val
      if (stat == 0) by_index = .true.
      if (stat /= 0) read(line, *, iostat=stat) iat, val
      if (stat == 0) by_index = .true.
      ! Read core entry: sym [:] val
      if (stat /= 0) read(line, *, iostat=stat) sym, sep, val
      if (stat /= 0) read(line, *, iostat=stat) sym, val
      if (stat /= 0) then
         call fatal_error(error, "Failed to read [Core] entry: "//trim(line))
         return
      end if

      if (by_index) then
         ! Core electrons provided for atom index
         if (iat < 1 .or. iat > mol%nat) then
            call fatal_error(error, "[Core] atom index out of range: "//trim(line))
            return
         end if
         isp = mol%id(iat)
         tmp_valence = mol%num(isp) - val
         if (check .and. nvalence(iat) /= tmp_valence) then
            call fatal_error(error, "Inconsistent core electron counts in [Core]")
            return
         end if
         nvalence(iat) = tmp_valence
         cycle
      else
         ! Core electrons provided for atom label
         matched = .false.
         do iat = 1, mol%nat
            isp = mol%id(iat)
            if (trim(lower_string(adjustl(sym))) == &
               & trim(lower_string(adjustl(mol%sym(isp))))) then
               matched = .true.
               tmp_valence = mol%num(isp) - val
               if (check .and. nvalence(iat) /= tmp_valence) then
                  call fatal_error(error, "Inconsistent core electron counts in [Core]")
                  return
               end if
               nvalence(iat) = tmp_valence
            end if
         end do
         if (.not. matched) then
            call fatal_error(error, "No matching atom for [Core] entry: "//trim(line))
            return
         end if
      end if
   end do
end subroutine read_core

!> Read optional [Pseudo] section for valence electron count from buffered lines.
subroutine read_pseudo(buffer, mol, nvalence, error)
   !> Buffered [Pseudo] section
   type(line_buffer_type), intent(in) :: buffer
   !> Molecular structure data loaded from Molden file
   type(structure_type), intent(in) :: mol
   !> Number of valence electrons per atom
   integer, allocatable, intent(inout) :: nvalence(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=512) :: line
   character(len=16) :: sym
   integer :: iline, iat, isp, stat, val
   logical :: check

   if (buffer%count == 0) return

   ! Check for consistency, if valence electrons were also read in a different section
   if (.not. allocated(nvalence)) then
      check = .false.
      allocate(nvalence(mol%nat), source=0)
   else
      check = .true.
   end if

   do iline = 1, buffer%count
      line = buffer%lines(iline)
      ! Read pseudo entry: sym iat val
      read(line, *, iostat=stat) sym, iat, val
      if (stat /= 0) then
         call fatal_error(error, "Failed to read [Pseudo] entry: "//trim(line))
         return
      end if
      if (iat < 1 .or. iat > mol%nat) then
         call fatal_error(error, "[Pseudo] atom index out of range: "//trim(line))
         return
      end if
      ! Valence electrons provided for atom index and atom label
      isp = mol%id(iat)
      if (trim(lower_string(adjustl(sym))) /= &
         & trim(lower_string(adjustl(mol%sym(isp))))) then
         call fatal_error(error, "Atom index and symbol do not match in [Pseudo] entry: "//trim(line))
         return
      end if
      if (check .and. nvalence(iat) /= val) then
         call fatal_error(error, "Inconsistent valence electron counts in [Pseudo]")
         return
      end if
      nvalence(iat) = val
   end do
end subroutine read_pseudo

!> Read optional [Nval] section for valence electron count from buffered lines.
subroutine read_nval(buffer, mol, nvalence, error)
   !> Buffered [Nval] section
   type(line_buffer_type), intent(in) :: buffer
   !> Molecular structure data loaded from Molden file
   type(structure_type), intent(in) :: mol
   !> Number of valence electrons per atom
   integer, allocatable, intent(inout) :: nvalence(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=512) :: line
   character(len=16) :: sym
   integer :: iline, iat, isp, stat, val
   logical :: check, matched

   if (buffer%count == 0) return

   ! Check for consistency, if valence electrons were also read in a different section
   if (.not. allocated(nvalence)) then
      check = .false.
      allocate(nvalence(mol%nat), source=0)
   else
      check = .true.
   end if

   do iline = 1, buffer%count
      line = buffer%lines(iline)
      ! Read nval entry: sym val
      read(line, *, iostat=stat) sym, val
      if (stat /= 0) then
         call fatal_error(error, "Failed to read [Nval] entry: "//trim(line))
         return
      end if
      ! Valence electrons provided for atom label
      matched = .false.
      do iat = 1, mol%nat
         isp = mol%id(iat)
         if (trim(lower_string(adjustl(sym))) /= &
            & trim(lower_string(adjustl(mol%sym(isp))))) then
            cycle
         end if
         matched = .true.
         if (check .and. nvalence(iat) /= val) then
            call fatal_error(error, "Inconsistent valence electron counts in [Nval]")
            return
         end if
         nvalence(iat) = val
      end do
      if (.not. matched) then
         call fatal_error(error, "No matching atom for [Nval] entry: "//trim(line))
         return
      end if
   end do
end subroutine read_nval

!> Read [MO] section for MO coefficients, energies, and occupations.
subroutine read_mo(unit, mo_position, mol, bas, cartesian, &
   & nspin, coeff, focc, emo, error)
   !> Open Molden file unit
   integer, intent(in) :: unit
   !> Stream position of first line after [MO] header
   integer(i8), intent(in) :: mo_position
   !> Molecular structure data loaded from Molden file
   type(structure_type), intent(in) :: mol
   !> Basis set information loaded from Molden File
   type(basis_type), intent(in) :: bas
   !> Use Cartesian (default) or spherical AO basis
   logical, intent(in) :: cartesian
   !> Spin channel count found in [MO]
   integer, intent(out) :: nspin
   !> MO coefficients, shape coeff(nao, nmo, 2)
   real(wp), allocatable, intent(out) :: coeff(:, :, :)
   !> MO occupation numbers, shape focc(nmo, 2)
   real(wp), allocatable, intent(out) :: focc(:, :)
   !> MO energies, shape emo(nmo, 2)
   real(wp), allocatable, intent(out) :: emo(:, :)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=512) :: line
   character(len=16) :: key
   integer :: stat, iat, isp, is, ish, ii, iicart, iao, imo, nao, nmo, l, tmp_nao
   integer :: idx_eq, tmp_spin, spin_count(2), perm_cart(15), perm_sphr(9)
   integer, allocatable :: ao_map(:)
   real(wp) :: tmp, tmp_energy, tmp_occup
   real(wp), allocatable :: tmp_coeff(:)
   logical :: have_block

   if (cartesian) then
      nao = bas%nao_cart
   else
      nao = bas%nao
   end if
   nmo = bas%nao
   nspin = 1

   ! Build map from Molden AO index to tblite AO index.
   allocate(ao_map(nao))
   do iat = 1, mol%nat
      isp = mol%id(iat)
      is = bas%ish_at(iat)
      do ish = 1, bas%nsh_id(isp)
         ii = bas%iao_sh(is + ish)
         iicart = bas%iao_cart_sh(is + ish)
         l = bas%cgto(ish, isp)%ang
         if (cartesian) then
            call get_molden_to_tblite_cart_perm(l, perm_cart, error)
            if (allocated(error)) return
            do iao = 1, bas%nao_cart_sh(is + ish)
               ao_map(iicart + iao) = iicart + perm_cart(iao)
            end do
         else
            call get_molden_to_tblite_sphr_perm(l, perm_sphr, error)
            if (allocated(error)) return
            do iao = 1, bas%nao_sh(is + ish)
               ao_map(ii + iao) = ii + perm_sphr(iao)
            end do
         end if
      end do
   end do

   ! Since the number of spin channels is unknown we allocated the maximum.
   allocate(coeff(nao, nmo, 2), focc(nmo, 2), emo(nmo, 2), source=0.0_wp)

   allocate(tmp_coeff(nao), source=0.0_wp)
   spin_count(:) = 0
   have_block = .false.
   tmp_spin = 1
   tmp_energy = 0.0_wp
   tmp_occup = 0.0_wp
   tmp_nao = 0

   ! Read the [MO] section starting from the first line after the header.
   read(unit, '(A)', pos=mo_position, iostat=stat) line
   do
      ! Check for end of file
      if (stat == iostat_end) exit
      ! Check for other I/O errors
      if (stat /= 0) then
         call fatal_error(error, "I/O error reading [MO]")
         return
      end if
      ! Check for start of new section
      if (len_trim(section_id(line)) > 0) exit
      ! Ignore blank lines.
      if (len_trim(line) == 0) then
         read(unit, '(A)', iostat=stat) line
         cycle
      end if

      ! Check for start of new MO and store previous block
      if (is_mo_key(line, "sym")) then
         if (have_block) then
            spin_count(tmp_spin) = spin_count(tmp_spin) + 1
            imo = spin_count(tmp_spin)
            if (imo > nmo) then
               call fatal_error(error, "[MO] has too many orbitals for one spin channel")
               return
            end if
            if (tmp_nao /= nao) then
               call fatal_error(error, "[MO] has inconsistent number of coefficients for one orbital")
               return
            end if
            ! Store temporary data in the final position
            coeff(:, imo, tmp_spin) = tmp_coeff(:)
            focc(imo, tmp_spin) = tmp_occup
            emo(imo, tmp_spin) = tmp_energy
         end if
         ! Reset state for the new MO block
         have_block = .true.
         tmp_spin = 1
         tmp_energy = 0.0_wp
         tmp_occup = 0.0_wp
         tmp_coeff(:) = 0.0_wp
         tmp_nao = 0

      ! Check for MO energy
      else if (is_mo_key(line, "ene")) then
         if (.not. have_block) then
            call fatal_error(error, "[MO] energy before orbital header")
            return
         end if
         idx_eq = index(line, "=")
         read(line(idx_eq+1:), *, iostat=stat) tmp_energy
         if (stat /= 0) then
            call fatal_error(error, "Failed to read MO energy: "//trim(line))
            return
         end if
      ! Check for MO spin
      else if (is_mo_key(line, "spin")) then
         if (.not. have_block) then
            call fatal_error(error, "[MO] spin before orbital header")
            return
         end if
         idx_eq = index(line, "=")
         key = ""
         if (idx_eq > 0 .and. idx_eq < len_trim(line)) then
            key = adjustl(line(idx_eq+1:len_trim(line)))
         end if
         if (index(lower_string(key), "beta") > 0) then
            tmp_spin = 2
            nspin = 2
         else if (index(lower_string(key), "alpha") > 0) then
            tmp_spin = 1
         else
            call fatal_error(error, "Failed to parse MO spin: "//trim(line))
            return
         end if
      ! Check for MO occupation
      else if (is_mo_key(line, "occup")) then
         if (.not. have_block) then
            call fatal_error(error, "[MO] occupation before orbital header")
            return
         end if
         idx_eq = index(line, "=")
         read(line(idx_eq+1:), *, iostat=stat) tmp_occup
         if (stat /= 0) then
            call fatal_error(error, "Failed to read MO occupation: "//trim(line))
            return
         end if
      ! Check for MO coefficients
      else
         if (.not. have_block) then
            call fatal_error(error, "[MO] coefficient before orbital header")
            return
         end if

         read(line, *, iostat=stat) iao, tmp
         if (stat /= 0) then
            call fatal_error(error, "Failed to read MO coefficient: "//trim(line))
            return
         end if
         if (iao < 1 .or. iao > nao) then
            call fatal_error(error, "[MO] coefficient index out of range")
            return
         end if
         tmp_nao = tmp_nao + 1
         tmp_coeff(ao_map(iao)) = tmp
      end if
      ! Read the next line
      read(unit, '(A)', iostat=stat) line
   end do

   ! Store the last block if it exists and check for consistent orbital counts
   if (have_block) then
      spin_count(tmp_spin) = spin_count(tmp_spin) + 1
      imo = spin_count(tmp_spin)
      if (imo > nmo) then
         call fatal_error(error, "[MO] has too many orbitals for one spin channel")
         return
      end if
      if (tmp_nao /= nao) then
         call fatal_error(error, "[MO] has inconsistent number of coefficients for one orbital")
         return
      end if
      ! Store temporary data in the final position
      coeff(:, imo, tmp_spin) = tmp_coeff(:)
      focc(imo, tmp_spin) = tmp_occup
      emo(imo, tmp_spin) = tmp_energy
   end if

   ! Transform restricted occupation into separate alpha and beta occupation
   if (nspin == 1) then
      call magnet_to_updown(focc)
   end if

   if (spin_count(1) /= nmo) then
      call fatal_error(error, "[MO] has inconsistent alpha orbital count")
      return
   end if
   if (nspin == 2 .and. spin_count(2) /= nmo) then
      call fatal_error(error, "[MO] has inconsistent beta orbital count")
      return
   end if
end subroutine read_mo

!> Spherical AO order permutation from Molden (0, ... l, -l) to tblite (-l, ..., 0, ..., l)
subroutine get_molden_to_tblite_sphr_perm(l, perm, error)
   !> Angular momentum quantum number
   integer, intent(in)  :: l
   !> Permutation array
   integer, intent(out) :: perm(9)
   !> Error handling
   type(error_type), intent(out), allocatable :: error

   perm = 0
   select case(l)
   case(0)
      perm(1) = 1
   case(1)
      ! Exception in the order following the Cartesian convention
      perm(1:3) = [3, 1, 2]
   case(2)
      perm(1:5) = [3, 4, 2, 5, 1]
   case(3)
      perm(1:7) = [4, 5, 3, 6, 2, 7, 1]
   case(4)
      perm(1:9) = [5, 6, 4, 7, 3, 8, 2, 9, 1]
   case default
      call fatal_error(error, "Molden reader only supports angular momenta up to g")
      return
   end select
end subroutine get_molden_to_tblite_sphr_perm

!> Cartesian AO order permutation from Molden to tblite.
subroutine get_molden_to_tblite_cart_perm(l, perm, error)
   !> Angular momentum of the shell
   integer, intent(in) :: l
   !> Index permutation
   integer, intent(out) :: perm(15)
   !> Error handling
   type(error_type), intent(out), allocatable :: error

   perm = 0

   select case(l)
   case(0)
      perm(1) = 1
   case(1)
      perm(1:3) = [3, 1, 2]
   case(2)
      perm(1:6) = [1, 2, 3, 4, 5, 6]
   case(3)
      perm(1:10) = [1, 2, 3, 6, 4, 5, 8, 9, 7, 10]
   case(4)
      perm(1:15) = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15]
   case default
      call fatal_error(error, "Molden reader only supports angular momenta up to g")
      return
   end select
end subroutine get_molden_to_tblite_cart_perm


!> Write optional [Cell] section in atomic units
subroutine write_cell(unit, mol, error)
   !> Output Molden file unit
   integer, intent(in) :: unit
   !> Molecular structure
   type(structure_type), intent(in) :: mol
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ilat

   if (.not. allocated(mol%periodic) .or. .not. allocated(mol%lattice)) return

   if (any(mol%periodic)) then
      write(unit,'(A)') '[Cell] AU'
      do ilat = 1, 3
         write(unit,'(3(1x,ES24.16))') mol%lattice(:, ilat)
      end do
   end if
end subroutine write_cell

!> Write [Atoms] section in atomic units
subroutine write_atoms(unit, mol, error)
   !> Output Molden file unit
   integer, intent(in) :: unit
   !> Molecular structure
   type(structure_type), intent(in) :: mol
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=2) :: sym
   integer :: iat, isp

   write(unit,'(A)') '[Atoms] AU'
   do iat = 1, mol%nat
      isp = mol%id(iat)
      sym = trim(mol%sym(isp))
      write(unit,'(a2,1x,i6,1x,i6,3(1x,ES24.16))') sym, iat, mol%num(isp), &
         & mol%xyz(1, iat), mol%xyz(2, iat), mol%xyz(3, iat)
   end do
end subroutine write_atoms

!> Write [Core] section: core electrons per species.
subroutine write_core(unit, mol, wfn, error)
   !> Output Molden file unit
   integer, intent(in) :: unit
   !> Molecular structure
   type(structure_type), intent(in) :: mol
   !> Converged wavefunction
   type(wavefunction_type), intent(in) :: wfn
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=2) :: sym
   integer :: iat, isp

   write(unit,'(A)') '[Core]'
   do isp = 1, mol%nid
      sym = trim(mol%sym(isp))
      do iat = 1, mol%nat
         if (mol%id(iat) == isp) exit
      end do
      write(unit,'(a2,1x,a,1x,i0)') sym, ':', mol%num(isp) - nint(wfn%n0at(iat))
   end do
end subroutine write_core

!> Write [Pseudo] section: valence electrons per atom.
subroutine write_pseudo(unit, mol, wfn, error)
   !> Output Molden file unit
   integer, intent(in) :: unit
   !> Molecular structure
   type(structure_type), intent(in) :: mol
   !> Converged wavefunction
   type(wavefunction_type), intent(in) :: wfn
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=2) :: sym
   integer :: iat, isp

   write(unit,'(A)') '[Pseudo]'
   do iat = 1, mol%nat
      isp = mol%id(iat)
      sym = trim(mol%sym(isp))
      write(unit,'(a2,1x,i6,1x,i6)') sym, iat, nint(wfn%n0at(iat))
   end do
end subroutine write_pseudo

!> Write [Nval] section: valence electrons per species.
subroutine write_nval(unit, mol, wfn, error)
   !> Output Molden file unit
   integer, intent(in) :: unit
   !> Molecular structure
   type(structure_type), intent(in) :: mol
   !> Converged wavefunction
   type(wavefunction_type), intent(in) :: wfn
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=2) :: sym
   integer :: iat, isp

   write(unit,'(A)') '[Nval]'
   do isp = 1, mol%nid
      sym = trim(mol%sym(isp))
      do iat = 1, mol%nat
         if (mol%id(iat) == isp) exit
      end do
      write(unit,'(a2,1x,i6)') sym, nint(wfn%n0at(iat))
   end do
end subroutine write_nval

!> Write [GTO] section.
subroutine write_gto(unit, mol, bas, error)
   !> Output Molden file unit
   integer, intent(in) :: unit
   !> Molecular structure
   type(structure_type), intent(in) :: mol
   !> Basis metadata
   class(basis_type), intent(in) :: bas
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=1) :: aang
   integer :: iat, iprim, ish

   write(unit,'(A)') '[GTO]'
   do iat = 1, mol%nat
      write(unit,'(i6,a)') iat, ' 0'
      do ish = 1, bas%nsh_at(iat)
         associate(p_cgto => &
               & bas%cgto(ish, mol%id(iat)))
            select case(p_cgto%ang)
            case(0)
               aang = 's'
            case(1)
               aang = 'p'
            case(2)
               aang = 'd'
            case(3)
               aang = 'f'
            case(4)
               aang = 'g'
            case default
               call fatal_error(error, "Molden writer only supports angular momenta up to g")
               return
            end select

            write(unit,'(a,1x,i6,1x,f8.2)') aang, p_cgto%nprim, 1.00_wp
            do iprim = 1, p_cgto%nprim
               write(unit,'(2(1x,ES24.16))') p_cgto%alpha(iprim), p_cgto%coeff(iprim)
            end do
         end associate
      end do
      write(unit,*)
   end do
end subroutine write_gto

!> Write [MO] section with spherical-to-Cartesian transformation.
subroutine write_mo(unit, mol, bas, wfn, error)
   !> Output Molden file unit
   integer, intent(in) :: unit
   !> Molecular structure
   type(structure_type), intent(in) :: mol
   !> Basis metadata
   class(basis_type), intent(in) :: bas
   !> Converged wavefunction
   type(wavefunction_type), intent(in) :: wfn
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iao_cart, iat, isp, ii, imo, is, ish, li, jao
   integer :: spin, cspin, nspin_mo, perm(15)
   logical :: spin_resolved_mo
   real(wp), allocatable :: coeff_cart(:, :, :)

   ! Represent only restricted closed-shell MOs as one spin-summed MO list
   ! and both restricted open-shell and unrestricted MOs with two spin channels
   spin_resolved_mo = wfn%nspin > 1 .or. abs(wfn%nuhf) > epsilon(1.0_wp)
   if (spin_resolved_mo) then
      nspin_mo = 2
   else
      nspin_mo = 1
   end if

   ! Transform MO coefficients to the Cartesian AO basis
   allocate(coeff_cart(bas%nao_cart, bas%nao, wfn%nspin))
   do spin = 1, wfn%nspin
      call bas%spherical_to_cartesian_trafo(mol, wfn%coeff(:, :, spin), &
         & coeff_cart(:, :, spin))
   end do

   write(unit,'(A)') '[MO]'
   do spin = 1, nspin_mo
      cspin = min(spin, wfn%nspin)

      do imo = 1, bas%nao
         write(unit,'(A)', advance='no') 'Sym= '
         if (spin_resolved_mo) then
            if (spin == 1) then
               write(unit,'(i5,a)') imo, 'a (alpha)'
            else
               write(unit,'(i5,a)') imo, 'a (beta)'
            end if
         else
            write(unit,'(i5,a)') imo, 'a'
         end if

         write(unit,'(A)', advance='no') 'Ene= '
         write(unit,*) wfn%emo(imo, cspin)

         write(unit,'(A)', advance='no') 'Spin= '
         if (spin_resolved_mo .and. spin == 2) then
            write(unit,'(A)') 'Beta'
         else
            write(unit,'(A)') 'Alpha'
         end if

         write(unit,'(A)', advance='no') 'Occup= '
         if (spin_resolved_mo) then
            write(unit,'(F14.8)') wfn%focc(imo, spin)
         else
            write(unit,'(F14.8)') wfn%focc(imo, 1) + wfn%focc(imo, 2)
         end if

         jao = 0
         do iat = 1, mol%nat
            isp = mol%id(iat)
            is = bas%ish_at(iat)
            do ish = 1, bas%nsh_at(iat)
               li = bas%cgto(ish, isp)%ang
               ii = bas%iao_cart_sh(is + ish)

               call get_molden_to_tblite_cart_perm(li, perm, error)
               if (allocated(error)) return

               do iao_cart = 1, bas%nao_cart_sh(is + ish)
                  jao = jao + 1
                  write(unit,'(i6,1x,ES24.16)') jao, coeff_cart(ii + perm(iao_cart), &
                     & imo, cspin)
               end do
            end do
         end do
      end do
   end do
end subroutine write_mo

!> Extract section name
pure function section_id(line) result(id)
   !> Input line
   character(len=*), intent(in) :: line
   !> Lower-case section id without brackets
   character(len=32) :: id

   character(len=len(line)) :: work
   integer :: right

   id = ""
   work = adjustl(line)
   if (len_trim(work) < 3) return
   if (work(1:1) /= "[") return

   right = index(work, "]")
   if (right <= 2) return
   id = lower_string(adjustl(work(2:right-1)))
end function section_id

!> Extract additional section specification
pure function section_spec(line) result(spec)
   !> Input line
   character(len=*), intent(in) :: line
   !> Specification after section id
   character(len=32) :: spec

   character(len=len(line)) :: work
   integer :: right, stat

   spec = ""
   work = adjustl(line)
   right = index(work, "]")
   if (right <= 0 .or. right >= len_trim(work)) return
   spec = adjustl(work(right+1:))
   read(spec, *, iostat=stat) spec
   spec = lower_string(spec)
end function section_spec

!> Convert a string to lowercase.
pure function lower_string(input) result(output)
   !> Input string
   character(len=*), intent(in) :: input
   !> Lower-case string
   character(len=len(input)) :: output

   integer :: i, ic

   output = input
   do i = 1, len(input)
      ic = iachar(input(i:i))
      if (ic >= iachar("A") .and. ic <= iachar("Z")) then
         output(i:i) = achar(ic + iachar("a") - iachar("A"))
      end if
   end do
end function lower_string

!> Check if a line has a given MO key before '='.
pure function is_mo_key(line, key) result(is_key)
   !> Input line
   character(len=*), intent(in) :: line
   !> Key to check for
   character(len=*), intent(in) :: key
   !> Whether the line matches
   logical :: is_key

   character(len=len(line)) :: left, work
   integer :: eq

   work = adjustl(line)
   eq = index(work, "=")
   if (eq <= 0) then
      is_key = .false.
      return
   end if
   left = lower_string(adjustl(work(:eq-1)))
   is_key = trim(left) == lower_string(key)
end function is_mo_key

end module tblite_io_molden

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file src/ddx_parameters.f90
!! The type ddx_params_type is defined here along with its routines meant to
!! init, deinit and read it from a file in certain fromats. All the new code to
!! read user input from different file formats shall be added here.
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-06-15

!> Module to treat properly user input parameters
module ddx_parameters
! Include compile-time definitions
use ddx_definitions
use ddx_errors
! Enable OpenMP 
use omp_lib
implicit none


!> Type to check and store user input parameters
type ddx_params_type
    !> Model to use 1 for COSMO, 2 for PCM, 3 for LPB.
    integer :: model
    !> Whether computing analytical forces will be required (1) or not (0).
    integer :: force
    !> Relative dielectric permittivity.
    real(dp) :: eps
    !> Debye-H\"{u}ckel parameter. Referenced only in LPB model (model=3)
    real(dp) :: kappa
    !> Regularization parameter.
    real(dp) :: eta
    !> Shift of the regularization. -1 for interior, 0 for centered and
    !! 1 for outer regularization.
    real(dp) :: se
    !> Maximal degree of modeling spherical harmonics.
    integer :: lmax
    !> Number of Lebedev grid points on each sphere.
    integer :: ngrid
    !> Maximum number of iterations for the iterative solver.
    integer :: maxiter
    !> Number of extrapolation points for Jacobi/DIIS solver. Referenced only
    !! if Jacobi solver is used.
    integer :: jacobi_ndiis
    !> Enable (1) or disable (0) use of FMM techniques.
    integer :: fmm
    !> Maximal degree of spherical harmonics for a multipole expansion.
    !! If this value is -1 then no far-field FMM interactions are performed.
    integer :: pm
    !> Maximal degree of spherical harmonics for a local expansion.
    !! If this value is -1 then no far-field FMM interactions are performed.
    integer :: pl
    !> Number of OpenMP threads to be used. Currently, only nproc=1 is
    !! supported as the ddX is sequential right now.
    integer :: nproc
    !> Number of atoms in the molecule.
    integer :: nsph
    !> Centers of atoms of a dimension (3, nsph).
    real(dp), allocatable :: csph(:, :)
    !> Array of radii of atoms of a dimension (nsph).
    real(dp), allocatable :: rsph(:)
    !> Dielectric permittivity of the cavity (used by ddLPB), hardcoded to one
    real(dp) :: epsp = 1.0_dp
    !> integer matvecmem. Build hsp matrix to speed up matrix-vec product
    integer :: matvecmem
    !> variable to enable debug printins:
    !> fname: name of the output file
    character(len=255) :: output_filename
    !> len_fname: actual length of the output file
    integer :: len_output_filename
    !> verbose: true if printing is enabled
    logical :: verbose
    !> output unit
    integer :: iunit
end type ddx_params_type

contains

!> Initialize and check input parameters
!!
!! @param[in] model: Choose model: 1 for COSMO, 2 for PCM and 3 for LPB.
!! @param[in] force: 1 if forces will probably be required and 0 otherwise.
!! @param[in] eps: Relative dielectric permittivity. eps > 1.
!! @param[in] kappa: Debye-H\"{u}ckel parameter. kappa > 0. Referenced
!!      only if the model is LPB.
!! @param[in] eta: Regularization parameter. 0 < eta <= 1.
!! @param[in] se: Shift of the regularization. -1 for interior, 0 for
!!      centered and 1 for outer regularization.
!! @param[in] lmax: Maximal degree of modeling spherical harmonics.
!!      `lmax` >= 0.
!! @param[in] ngrid: Number of Lebedev grid points `ngrid` >= 0.
!! @param[in] matvecmem: handling of sparse matrices. 1 for precomputing them 
!!      and keeping them in memory, 0 for direct matrix-vector products.
!! @param[in] maxiter: Maximum number of iterations for an iterative solver.
!!      maxiter > 0.
!! @param[in] jacobi_ndiis: Number of extrapolation points for Jacobi/DIIS solver.
!!      ndiis >= 1.
!! @param[in] fmm: 1 to use FMM acceleration and 0 otherwise.
!! @param[in] pm: Maximal degree of multipole spherical harmonics. Ignored in
!!      the case `fmm=0`. Value -1 means no far-field FMM interactions are
!!      computed. `pm` >= -1.
!! @param[in] pl: Maximal degree of local spherical harmonics. Ignored in
!!      the case `fmm=0`. Value -1 means no far-field FMM interactions are
!!      computed. `pl` >= -1.
!! @param[in] nproc: Number of OpenMP threads to be used where applicable.
!!      nproc >= 0. If input nproc=0 then a default number of threads,
!!      controlled by the environment variable `OMP_NUM_THREADS` during
!!      runtime, will be used. If OpenMP support in ddX is
!!      disabled, only possible input values are 0 or 1 and both inputs lead
!!      to the same output nproc=1 since the library is not parallel.
!! @param[in] nsph: Number of atoms. nsph > 0.
!! @param[in] csph: Coordinates of atoms. Dimension is `(3, nsph)`.
!! @param[in] rsph: Van-der-Waals radii of atoms. Dimension is `(nsph)`.
!! @param[in] output_filename: file name of log file.
!! @param[out] params: Object containing all inputs.
!! @param[inout] ddx_error: ddX error
subroutine params_init(model, force, eps, kappa, eta, se, lmax, ngrid, &
        & matvecmem, maxiter, jacobi_ndiis, fmm, pm, pl, nproc, nsph, &
        & csph, rsph, output_filename, params, ddx_error)
    !! Inputs
    ! Model to use 1 for COSMO, 2 for PCM, 3 for LPB.
    integer, intent(in) :: model
    ! Whether computing analytical forces will be required (1) or not (0).
    integer, intent(in) :: force
    ! Relative dielectric permittivity.
    real(dp), intent(in) :: eps
    ! Debye-H\"{u}ckel parameter. Referenced only in LPB model (model=3)
    real(dp), intent(in) :: kappa
    ! Regularization parameter.
    real(dp), intent(in) :: eta
    ! Shift of the regularization. -1 for interior, 0 for centered and
    !      1 for outer regularization.
    real(dp), intent(in) :: se
    ! Maximal degree of modeling spherical harmonics.
    integer, intent(in) :: lmax
    ! Number of Lebedev grid points on each sphere.
    integer, intent(in) :: ngrid
    ! handling of sparse matrix. 1 for precomputing them and keeping them in
    ! memory, 0 for assembling the mvps on-the-fly.
    integer, intent(in) :: matvecmem
    ! Maximum number of iterations for the iterative solver.
    integer, intent(in) :: maxiter
    ! Number of extrapolation points for Jacobi/DIIS solver. Referenced only
    !      if Jacobi solver is used.
    integer, intent(in) :: jacobi_ndiis
    ! Enable (1) or disable (0) use of FMM techniques.
    integer, intent(in) :: fmm
    ! Maximal degree of spherical harmonics for a multipole expansion.
    !
    ! If this value is -1 then no far-field FMM interactions are performed.
    integer, intent(in) :: pm
    ! Maximal degree of spherical harmonics for a local expansion.
    !
    ! If this value is -1 then no far-field FMM interactions are performed.
    integer, intent(in) :: pl
    ! Number of OpenMP threads to be used. 
    integer, intent(in) :: nproc
    ! Number of atoms in the molecule.
    integer, intent(in) :: nsph
    ! Centers of atoms of a dimension (3, nsph).
    real(dp), intent(in) :: csph(3, nsph)
    ! Array of radii of atoms of a dimension (nsph).
    real(dp), intent(in) :: rsph(nsph)
    ! log file name
    character(len=255) :: output_filename
    !! Outputs
    type(ddx_params_type), intent(out) :: params
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Local variables
    integer :: igrid, i, info
    !! The code
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "params_init received input in ddx_error " // &
            & " state, exiting")
    end if
    ! parse the log file name
    if (len(trim(output_filename)) .ne. 0) then
        params % output_filename = output_filename
        params % verbose = .true.
        params % len_output_filename = len(trim(output_filename))
    else
        params % output_filename = ''
        params % verbose = .false.
        params % len_output_filename = 0
    end if
    ! Model, 1=COSMO, 2=PCM, 3=LPB
    if ((model .lt. 1) .or. (model .gt. 3)) then
        call update_error(ddx_error, "params_init: invalid value of `model`")
    end if
    params % model = model
    ! Check if forces are needed
    if ((force .lt. 0) .or. (force .gt. 1)) then
        call update_error(ddx_error, "params_init: invalid value of `force`")
    end if
    params % force = force
    ! Relative dielectric permittivity
    if (eps .le. one) then
        call update_error(ddx_error, "params_init: invalid value of `eps`")
    end if
    params % eps = eps
    ! Debye-H\"{u}ckel parameter (only used in ddLPB)
    if ((model .eq. 3) .and. (kappa .le. zero)) then
        call update_error(ddx_error, "params_init: invalid value of `kappa`")
    end if
    params % kappa = kappa
    ! Regularization parameter
    if ((eta .lt. zero) .or. (eta .gt. one)) then
        call update_error(ddx_error, "params_init: invalid value of `eta`")
    end if
    params % eta = eta
    ! Shift of a regularization
    if ((se .lt. -one) .or. (se .gt. one)) then
        call update_error(ddx_error, "params_init: invalid value of `se`")
    end if
    params % se = se
    ! Degree of modeling spherical harmonics
    if (lmax .lt. 0) then
        call update_error(ddx_error, "params_init: invalid value of `lmax`")
    end if
    params % lmax = lmax
    ! Check number of Lebedev grid points
    igrid = 0
    do i = 1, nllg
        if (ng0(i) .eq. ngrid) then
            igrid = i
            exit
        end if
    end do
    if (igrid .eq. 0) then
        call update_error(ddx_error, "params_init: Unsupported value of `ngrid`")
    end if
    params % ngrid = ngrid
    ! Maximum number of iterations
    if (maxiter .le. 0) then
        call update_error(ddx_error, "params_init: invalid value of `maxiter`")
    end if
    params % maxiter = maxiter
    ! Number of Jacobi DIIS extrapolation points (ndiis=25 works)
    if (jacobi_ndiis .lt. 0) then
        call update_error(ddx_error, "params_init: invalid value of `jacobi_ndiis`")
    end if
    params % jacobi_ndiis = jacobi_ndiis
    ! Check if FMM-acceleration is needed
    if ((fmm .lt. 0) .or. (fmm .gt. 1)) then
        call update_error(ddx_error, "params_init: invalid value of `fmm`")
    end if
    params % fmm = fmm
    ! Set FMM parameters if FMM is needed
    if (fmm .eq. 1) then
        ! Maximal degree of multipole spherical harmonics. Value -1 means no 
        ! far-field interactions are to be computed, only near-field
        ! interactions are taken into account.
        if (pm .lt. -1) then
            call update_error(ddx_error, "params_init: invalid value of `pm`")
        end if
        ! Maximal degree of local spherical harmonics. Value -1 means no 
        ! far-field interactions are to be computed, only near-field
        ! interactions are taken into account.
        if (pl .lt. -1) then
            call update_error(ddx_error, "params_init: invalid value of `pl`")
        end if
        ! If far-field interactions are to be ignored
        if ((pl .eq. -1) .or. (pm .eq. -1)) then
            params % pm = -1
            params % pl = -1
        ! If far-field interactions are to be taken into account
        else
            params % pm = pm
            params % pl = pl
        end if
    else
        ! These values are ignored if fmm flag is 0
        params % pm = -2
        params % pl = -2
    end if
    ! Number of OpenMP threads to be used
    ! available.
    if (nproc .lt. 0) then
        call update_error(ddx_error, "params_init: invalid value of `nproc`")
        params % nproc = 1
    else if (nproc .eq. 0) then
        params % nproc = 1
    else
        params % nproc = nproc
    end if
    call omp_set_num_threads(params % nproc)
    ! Number of atoms
    if (nsph .le. 0) then
        call update_error(ddx_error, "params_init: invalid value of `nsph`")
    end if
    params % nsph = nsph
    allocate(params % csph(3, nsph), params % rsph(nsph), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "params_init: `csph` and `rsph` " // &
            & "allocations failed")
        return
    end if
    params % csph = csph
    params % rsph = rsph
    if (matvecmem.eq.0 .or. matvecmem.eq.1) then
        params % matvecmem = matvecmem
    else
        call update_error(ddx_error, "params_init: invalid value of `matvecmem`")
    end if

    if (ddx_error % flag .ne. 0) return

    ! init log
    call init_printing(params, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "init_printing returned an error, exiting")
        return
    end if
end subroutine params_init

!> Adjust a guess for the number of Lebedev grid points.
!!
!! @param[inout] ngrid: Approximate number of Lebedev grid points on input and
!!      actual number of grid points on exit. `ngrid` >= 0
subroutine closest_supported_lebedev_grid(ngrid)
    integer, intent(inout) :: ngrid
    integer :: igrid, i, inear, jnear
    ! Get nearest number of Lebedev grid points
    igrid = 0
    inear = 100000
    do i = 1, nllg
        jnear = abs(ng0(i) - ngrid)
        if (jnear .lt. inear) then
            inear = jnear
            igrid = i
        end if
    end do
    ngrid = ng0(igrid)
end subroutine

!> Deallocate the parameter object
!!
!! @param[out] params: User specified parameters
!! @param[inout] ddx_error: ddX error
!!
subroutine params_free(params, ddx_error)
    implicit none
    type(ddx_params_type), intent(inout) :: params
    type(ddx_error_type), intent(inout) :: ddx_error
    integer :: istat

    call finalize_printing(params)

    if (allocated(params % csph)) then
        deallocate(params % csph, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "params_free: `csph` deallocation failed")
        end if
    end if
    if (allocated(params % rsph)) then
        deallocate(params % rsph, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "params_free: `rsph` deallocation failed")
        end if
    end if
end subroutine params_free

!> Open the log file.
subroutine init_printing(params, ddx_error)
    implicit none
    type(ddx_params_type), intent(inout) :: params
    type(ddx_error_type), intent(inout) :: ddx_error
    logical :: exists
    if (.not.params % verbose) return
    inquire(file=params % output_filename(1:params % len_output_filename), &
        & exist=exists)
    if (exists) then
        call update_error(ddx_error, 'Log file already present')
        return
    else
        params % iunit = 100
        open(params % iunit, &
            & file=params % output_filename(1: params % len_output_filename), &
            & form='formatted')
    end if
end subroutine init_printing

!> Close the log file.
subroutine finalize_printing(params)
    implicit none
    type(ddx_params_type), intent(inout) :: params
    if (.not.params % verbose) return
    close(params % iunit)
    params % verbose = .false.
    params % output_filename = ''
    params % len_output_filename = 0
    params % iunit = 0
end subroutine finalize_printing

end module ddx_parameters

program test_simple_d3
   use, intrinsic :: iso_fortran_env, only : r8 => real64
   use mctc_env, only: error_type
   use mctc_io, only: structure_type, new
   use dftd3, only: d3_model, d3_param, rational_damping_param, get_rational_damping, &
      & new_rational_damping, new_d3_model, get_dispersion, realspace_cutoff
   implicit none

   character(len=:), allocatable :: method
   type(structure_type) :: mol
   type(error_type), allocatable :: error
   integer, allocatable :: num(:)
   real(r8), allocatable :: xyz(:, :)
   real(r8) :: energy

   type(d3_model) :: disp
   type(d3_param) :: inp
   type(rational_damping_param) :: param

   method = 'PBE0'
   num = [6, 1, 1, 1, 1]
   xyz = reshape([ &  ! coordinates in Bohr
     &  0.0000000_r8, -0.0000000_r8,  0.0000000_r8, &
     & -1.1922080_r8,  1.1922080_r8,  1.1922080_r8, &
     &  1.1922080_r8, -1.1922080_r8,  1.1922080_r8, &
     & -1.1922080_r8, -1.1922080_r8, -1.1922080_r8, &
     &  1.1922080_r8,  1.1922080_r8, -1.1922080_r8],&
     & [3, size(num)])
   call new(mol, num, xyz, charge=0.0_r8, uhf=0)

   call get_rational_damping(inp, method, error, s9=1.0_r8)
   if (allocated(error)) then
      print '(2a)', "Error: ", error%message
      return
   end if
   call new_rational_damping(param, inp)
   call new_d3_model(disp, mol)

   call get_dispersion(mol, disp, param, realspace_cutoff(), energy)
   print '(3a, f13.10, a)', 'Dispersion energy for ', method, '-D3(BJ) is ', energy, ' Hartree'

end program test_simple_d3

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/blas/level3.f90
!> Provides interfactes to level 3 BLAS routines

!> High-level interface to level 3 basic linear algebra subprogram operations
module tblite_blas_level3
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_gemm, wrap_trsm, wrap_symm


   !> Performs one of the matrix-matrix operations
   !>
   !>    C := alpha*op( A )*op( B ) + beta*C,
   !>
   !> where  op( X ) is one of
   !>
   !>    op( X ) = X   or   op( X ) = X**T,
   !>
   !> where alpha and beta are scalars, and A, B and C are matrices
   !> with op( A ) an m by k matrix, op( B ) a k by n matrix and C an m by n matrix.
   interface wrap_gemm
      module procedure :: wrap_sgemm
      module procedure :: wrap_dgemm
      module procedure :: wrap_sgemm323
      module procedure :: wrap_sgemm233
      module procedure :: wrap_sgemm332
      module procedure :: wrap_dgemm323
      module procedure :: wrap_dgemm233
      module procedure :: wrap_dgemm332
   end interface wrap_gemm

   !> Solves one of the matrix equations
   !>
   !>    op( A )*X = alpha*B,   or   X*op( A ) = alpha*B,
   !>
   !> where alpha is a scalar, X and B are m by n matrices, A is a unit, or
   !> non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
   !>
   !>    op( A ) = A   or   op( A ) = A**T.
   !>
   !> The matrix X is overwritten on B.
   interface wrap_trsm
      module procedure :: wrap_strsm
      module procedure :: wrap_dtrsm
   end interface wrap_trsm

   !> Performs one of the symmetric matrix-matrix operations
   !>
   !>    C := alpha*A*B + beta*C,
   !>
   !> or
   !>
   !>    C := alpha*B*A + beta*C,
   !>
   !> where alpha and beta are scalars, A is a symmetric matrix 
   !> and B and C are m by n matrices.
   interface wrap_symm
      module procedure :: wrap_ssymm
      module procedure :: wrap_dsymm
   end interface wrap_symm

   !> Performs one of the matrix-matrix operations
   !>
   !>    C := alpha*op( A )*op( B ) + beta*C,
   !>
   !> where  op( X ) is one of
   !>
   !>    op( X ) = X   or   op( X ) = X**T,
   !>
   !> alpha and beta are scalars, and A, B and C are matrices, with op( A )
   !> an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
   interface blas_gemm
      pure subroutine sgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, &
            & beta, c, ldc)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: b(ldb, *)
         real(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: transb
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine sgemm
      pure subroutine dgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, &
            & beta, c, ldc)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: b(ldb, *)
         real(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: transb
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine dgemm
   end interface blas_gemm

   !> Solves one of the matrix equations
   !>
   !>    op( A )*X = alpha*B,   or   X*op( A ) = alpha*B,
   !>
   !> where alpha is a scalar, X and B are m by n matrices, A is a unit, or
   !> non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
   !>
   !>    op( A ) = A   or   op( A ) = A**T.
   !>
   !> The matrix X is overwritten on B.
   interface blas_trsm
      pure subroutine strsm(side, uplo, transa, diag, m, n, alpha, a, lda, b, ldb)
         import :: sp
         integer, intent(in) :: ldb
         integer, intent(in) :: lda
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: diag
         integer, intent(in) :: m
         integer, intent(in) :: n
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(inout) :: b(ldb, *)
      end subroutine strsm
      pure subroutine dtrsm(side, uplo, transa, diag, m, n, alpha, a, lda, b, ldb)
         import :: dp
         integer, intent(in) :: ldb
         integer, intent(in) :: lda
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: diag
         integer, intent(in) :: m
         integer, intent(in) :: n
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(inout) :: b(ldb, *)
      end subroutine dtrsm
   end interface blas_trsm

   !> Performs one of the symmetric matrix-matrix operations
   !>
   !>    C := alpha*A*B + beta*C,
   !>
   !> or
   !>
   !>    C := alpha*B*A + beta*C,
   !>
   !> where alpha and beta are scalars, A is a symmetric matrix 
   !> and B and C are m by n matrices.
   interface blas_symm
      pure subroutine ssymm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, ldc)
         import :: sp
         character(len=1), intent(in) :: side, uplo
         integer, intent(in) :: m, n, lda, ldb, ldc
         real(sp), intent(in) :: alpha, beta
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: b(ldb, *)
         real(sp), intent(inout) :: c(ldc, *)
      end subroutine ssymm
      pure subroutine dsymm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, ldc)
         import :: dp
         character(len=1), intent(in) :: side, uplo
         integer, intent(in) :: m, n, lda, ldb, ldc
         real(dp), intent(in) :: alpha, beta
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: b(ldb, *)
         real(dp), intent(inout) :: c(ldc, *)
      end subroutine dsymm
   end interface blas_symm

contains


pure subroutine wrap_sgemm(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: bmat(:, :)
   real(sp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1) :: tra, trb
   real(sp) :: a, b
   integer :: m, n, k, lda, ldb, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_sp
   end if
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if ((tra.eq.'n'.or.tra.eq.'N')) then
      k = size(amat, 2)
   else
      k = size(amat, 1)
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   m = size(cmat, 1)
   n = size(cmat, 2)
   call blas_gemm(tra, trb, m, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
end subroutine wrap_sgemm


pure subroutine wrap_dgemm(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: bmat(:, :)
   real(dp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1) :: tra, trb
   real(dp) :: a, b
   integer :: m, n, k, lda, ldb, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_dp
   end if
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if ((tra.eq.'n'.or.tra.eq.'N')) then
      k = size(amat, 2)
   else
      k = size(amat, 1)
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   m = size(cmat, 1)
   n = size(cmat, 2)
   call blas_gemm(tra, trb, m, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
end subroutine wrap_dgemm


subroutine wrap_sgemm323(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in) :: bmat(:, :)
   real(sp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   real(sp), pointer :: aptr(:, :), cptr(:, :)
   character(len=1) :: tra
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   end if
   cptr(1:size(cmat, 1)*size(cmat, 2), 1:size(cmat, 3)) => cmat
   call wrap_gemm(aptr, bmat, cptr, tra, transb, alpha, beta)
end subroutine wrap_sgemm323


subroutine wrap_sgemm233(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in), contiguous, target :: bmat(:, :, :)
   real(sp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   real(sp), pointer :: bptr(:, :), cptr(:, :)
   character(len=1) :: trb
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   end if
   cptr(1:size(cmat, 1), 1:size(cmat, 2)*size(cmat, 3)) => cmat
   call wrap_gemm(amat, bptr, cptr, transa, trb, alpha, beta)
end subroutine wrap_sgemm233


subroutine wrap_sgemm332(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in), contiguous, target :: bmat(:, :, :)
   real(sp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   real(sp), pointer :: aptr(:, :), bptr(:, :)
   character(len=1) :: tra, trb
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   end if
   call wrap_gemm(aptr, bptr, cmat, tra, trb, alpha, beta)
end subroutine wrap_sgemm332


subroutine wrap_dgemm323(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in) :: bmat(:, :)
   real(dp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   real(dp), pointer :: aptr(:, :), cptr(:, :)
   character(len=1) :: tra
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   end if
   cptr(1:size(cmat, 1)*size(cmat, 2), 1:size(cmat, 3)) => cmat
   call wrap_gemm(aptr, bmat, cptr, tra, transb, alpha, beta)
end subroutine wrap_dgemm323


subroutine wrap_dgemm233(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in), contiguous, target :: bmat(:, :, :)
   real(dp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   real(dp), pointer :: bptr(:, :), cptr(:, :)
   character(len=1) :: trb
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   end if
   cptr(1:size(cmat, 1), 1:size(cmat, 2)*size(cmat, 3)) => cmat
   call wrap_gemm(amat, bptr, cptr, transa, trb, alpha, beta)
end subroutine wrap_dgemm233


subroutine wrap_dgemm332(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in), contiguous, target :: bmat(:, :, :)
   real(dp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   real(dp), pointer :: aptr(:, :), bptr(:, :)
   character(len=1) :: tra, trb
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   end if
   call wrap_gemm(aptr, bptr, cmat, tra, trb, alpha, beta)
end subroutine wrap_dgemm332


pure subroutine wrap_strsm(amat, bmat, side, uplo, transa, diag, alpha)
   real(sp), contiguous, intent(in) :: amat(:,  :)
   real(sp), contiguous, intent(inout) :: bmat(:, :)
   real(sp), intent(in), optional :: alpha
   character(len=1), intent(in), optional :: side
   character(len=1), intent(in), optional :: uplo
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: diag
   real(sp) :: a
   character(len=1) :: sda, ula, tra, dga
   integer :: m, n, lda, ldb

   a = 1.0_sp
   if (present(alpha)) a = alpha
   dga = 'n'
   if (present(diag)) dga = diag
   sda = 'l'
   if (present(side)) sda = side
   tra = 'n'
   if (present(transa)) tra = transa
   ula = 'u'
   if (present(uplo)) ula = uplo
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   m = size(bmat, 1)
   n = size(bmat, 2)
   call blas_trsm(sda, ula, tra, dga, m, n, a, amat, lda, bmat, ldb)
end subroutine wrap_strsm


pure subroutine wrap_dtrsm(amat, bmat, side, uplo, transa, diag, alpha)
   real(dp), contiguous, intent(in) :: amat(:,  :)
   real(dp), contiguous, intent(inout) :: bmat(:, :)
   real(dp), intent(in), optional :: alpha
   character(len=1), intent(in), optional :: side
   character(len=1), intent(in), optional :: uplo
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: diag
   real(dp) :: a
   character(len=1) :: sda, ula, tra, dga
   integer :: m, n, lda, ldb

   a = 1.0_dp
   if (present(alpha)) a = alpha
   dga = 'n'
   if (present(diag)) dga = diag
   sda = 'l'
   if (present(side)) sda = side
   tra = 'n'
   if (present(transa)) tra = transa
   ula = 'u'
   if (present(uplo)) ula = uplo
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   m = size(bmat, 1)
   n = size(bmat, 2)
   call blas_trsm(sda, ula, tra, dga, m, n, a, amat, lda, bmat, ldb)
end subroutine wrap_dtrsm


pure subroutine wrap_ssymm(amat, bmat, cmat, side, uplo, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: bmat(:, :)
   real(sp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: side
   character(len=1), intent(in), optional :: uplo
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta

   character(len=1) :: sda, ula
   real(sp) :: a, b
   integer :: m, n, lda, ldb, ldc

   a = 1.0_sp
   if (present(alpha)) a = alpha
   b = 0.0_sp
   if (present(beta))  b = beta
   sda = 'l'
   if (present(side))  sda = side
   ula = 'u'
   if (present(uplo))  ula = uplo
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   m   = size(cmat, 1)
   n   = size(cmat, 2)
   call blas_symm(sda, ula, m, n, a, amat, lda, bmat, ldb, b, cmat, ldc)
end subroutine wrap_ssymm


pure subroutine wrap_dsymm(amat, bmat, cmat, side, uplo, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: bmat(:, :)
   real(dp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: side
   character(len=1), intent(in), optional :: uplo
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta

   character(len=1) :: sda, ula
   real(dp) :: a, b
   integer :: m, n, lda, ldb, ldc

   a = 1.0_dp
   if (present(alpha)) a = alpha
   b = 0.0_dp
   if (present(beta))  b = beta
   sda = 'l'
   if (present(side))  sda = side
   ula = 'u'
   if (present(uplo))  ula = uplo
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   m   = size(cmat, 1)
   n   = size(cmat, 2)
   call blas_symm(sda, ula, m, n, a, amat, lda, bmat, ldb, b, cmat, ldc)
end subroutine wrap_dsymm


end module tblite_blas_level3

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_slater_expansion
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use tblite_basis_type, only : cgto_type
   use tblite_basis_slater, only : slater_to_gauss
   use tblite_integral_overlap, only : overlap_cgto
   implicit none
   private

   public :: collect_slater_expansion

   real(wp), parameter :: thr = 5e+6_wp*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

contains


!> Collect all exported unit tests
subroutine collect_slater_expansion(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("norm-1s-sto1g", test_norm_1s_sto1g), &
      new_unittest("norm-2s-sto1g", test_norm_2s_sto1g), &
      new_unittest("norm-3s-sto1g", test_norm_3s_sto1g), &
      new_unittest("norm-4s-sto1g", test_norm_4s_sto1g), &
      new_unittest("norm-5s-sto1g", test_norm_5s_sto1g), &
      new_unittest("norm-2p-sto1g", test_norm_2p_sto1g), &
      new_unittest("norm-3p-sto1g", test_norm_3p_sto1g), &
      new_unittest("norm-4p-sto1g", test_norm_4p_sto1g), &
      new_unittest("norm-5p-sto1g", test_norm_5p_sto1g), &
      new_unittest("norm-3d-sto1g", test_norm_3d_sto1g), &
      new_unittest("norm-4d-sto1g", test_norm_4d_sto1g), &
      new_unittest("norm-5d-sto1g", test_norm_5d_sto1g), &
      new_unittest("norm-4f-sto1g", test_norm_4f_sto1g), &
      new_unittest("norm-5f-sto1g", test_norm_5f_sto1g), &
      new_unittest("norm-5g-sto1g", test_norm_5g_sto1g), &
      new_unittest("norm-1s-sto2g", test_norm_1s_sto2g), &
      new_unittest("norm-2s-sto2g", test_norm_2s_sto2g), &
      new_unittest("norm-3s-sto2g", test_norm_3s_sto2g), &
      new_unittest("norm-4s-sto2g", test_norm_4s_sto2g), &
      new_unittest("norm-5s-sto2g", test_norm_5s_sto2g), &
      new_unittest("norm-2p-sto2g", test_norm_2p_sto2g), &
      new_unittest("norm-3p-sto2g", test_norm_3p_sto2g), &
      new_unittest("norm-4p-sto2g", test_norm_4p_sto2g), &
      new_unittest("norm-5p-sto2g", test_norm_5p_sto2g), &
      new_unittest("norm-3d-sto2g", test_norm_3d_sto2g), &
      new_unittest("norm-4d-sto2g", test_norm_4d_sto2g), &
      new_unittest("norm-5d-sto2g", test_norm_5d_sto2g), &
      new_unittest("norm-4f-sto2g", test_norm_4f_sto2g), &
      new_unittest("norm-5f-sto2g", test_norm_5f_sto2g), &
      new_unittest("norm-5g-sto2g", test_norm_5g_sto2g), &
      new_unittest("norm-1s-sto3g", test_norm_1s_sto3g), &
      new_unittest("norm-2s-sto3g", test_norm_2s_sto3g), &
      new_unittest("norm-3s-sto3g", test_norm_3s_sto3g), &
      new_unittest("norm-4s-sto3g", test_norm_4s_sto3g), &
      new_unittest("norm-5s-sto3g", test_norm_5s_sto3g), &
      new_unittest("norm-2p-sto3g", test_norm_2p_sto3g), &
      new_unittest("norm-3p-sto3g", test_norm_3p_sto3g), &
      new_unittest("norm-4p-sto3g", test_norm_4p_sto3g), &
      new_unittest("norm-5p-sto3g", test_norm_5p_sto3g), &
      new_unittest("norm-3d-sto3g", test_norm_3d_sto3g), &
      new_unittest("norm-4d-sto3g", test_norm_4d_sto3g), &
      new_unittest("norm-5d-sto3g", test_norm_5d_sto3g), &
      new_unittest("norm-4f-sto3g", test_norm_4f_sto3g), &
      new_unittest("norm-5f-sto3g", test_norm_5f_sto3g), &
      new_unittest("norm-5g-sto3g", test_norm_5g_sto3g), &
      new_unittest("norm-1s-sto4g", test_norm_1s_sto4g), &
      new_unittest("norm-2s-sto4g", test_norm_2s_sto4g), &
      new_unittest("norm-3s-sto4g", test_norm_3s_sto4g), &
      new_unittest("norm-4s-sto4g", test_norm_4s_sto4g), &
      new_unittest("norm-5s-sto4g", test_norm_5s_sto4g), &
      new_unittest("norm-2p-sto4g", test_norm_2p_sto4g), &
      new_unittest("norm-3p-sto4g", test_norm_3p_sto4g), &
      new_unittest("norm-4p-sto4g", test_norm_4p_sto4g), &
      new_unittest("norm-5p-sto4g", test_norm_5p_sto4g), &
      new_unittest("norm-3d-sto4g", test_norm_3d_sto4g), &
      new_unittest("norm-4d-sto4g", test_norm_4d_sto4g), &
      new_unittest("norm-5d-sto4g", test_norm_5d_sto4g), &
      new_unittest("norm-4f-sto4g", test_norm_4f_sto4g), &
      new_unittest("norm-5f-sto4g", test_norm_5f_sto4g), &
      new_unittest("norm-5g-sto4g", test_norm_5g_sto4g), &
      new_unittest("norm-1s-sto5g", test_norm_1s_sto5g), &
      new_unittest("norm-2s-sto5g", test_norm_2s_sto5g), &
      new_unittest("norm-3s-sto5g", test_norm_3s_sto5g), &
      new_unittest("norm-4s-sto5g", test_norm_4s_sto5g), &
      new_unittest("norm-5s-sto5g", test_norm_5s_sto5g), &
      new_unittest("norm-2p-sto5g", test_norm_2p_sto5g), &
      new_unittest("norm-3p-sto5g", test_norm_3p_sto5g), &
      new_unittest("norm-4p-sto5g", test_norm_4p_sto5g), &
      new_unittest("norm-5p-sto5g", test_norm_5p_sto5g), &
      new_unittest("norm-3d-sto5g", test_norm_3d_sto5g), &
      new_unittest("norm-4d-sto5g", test_norm_4d_sto5g), &
      new_unittest("norm-5d-sto5g", test_norm_5d_sto5g), &
      new_unittest("norm-4f-sto5g", test_norm_4f_sto5g), &
      new_unittest("norm-5f-sto5g", test_norm_5f_sto5g), &
      new_unittest("norm-5g-sto5g", test_norm_5g_sto5g), &
      new_unittest("norm-1s-sto6g", test_norm_1s_sto6g), &
      new_unittest("norm-2s-sto6g", test_norm_2s_sto6g), &
      new_unittest("norm-3s-sto6g", test_norm_3s_sto6g), &
      new_unittest("norm-4s-sto6g", test_norm_4s_sto6g), &
      new_unittest("norm-5s-sto6g", test_norm_5s_sto6g), &
      new_unittest("norm-6s-sto6g", test_norm_6s_sto6g), &
      new_unittest("norm-2p-sto6g", test_norm_2p_sto6g), &
      new_unittest("norm-3p-sto6g", test_norm_3p_sto6g), &
      new_unittest("norm-4p-sto6g", test_norm_4p_sto6g), &
      new_unittest("norm-5p-sto6g", test_norm_5p_sto6g), &
      new_unittest("norm-6p-sto6g", test_norm_6p_sto6g), &
      new_unittest("norm-3d-sto6g", test_norm_3d_sto6g), &
      new_unittest("norm-4d-sto6g", test_norm_4d_sto6g), &
      new_unittest("norm-5d-sto6g", test_norm_5d_sto6g), &
      new_unittest("norm-4f-sto6g", test_norm_4f_sto6g), &
      new_unittest("norm-5f-sto6g", test_norm_5f_sto6g), &
      new_unittest("norm-5g-sto6g", test_norm_5g_sto6g) &
      ]

end subroutine collect_slater_expansion


subroutine test_norm_s(error, n, ng)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer, intent(in) :: ng, n

   integer :: stat
   type(cgto_type) :: cgto
   real(wp), parameter :: vec(3) = 0.0_wp, r2 = 0.0_wp
   real(wp) :: overlap(1, 1)

   call slater_to_gauss(ng, n, 0, 1.0_wp, cgto, .true., stat)
   call check(error, stat)
   if (allocated(error)) return

   call overlap_cgto(cgto, cgto, r2, vec, 100.0_wp, overlap)

   call check(error, overlap(1, 1), 1.0_wp, thr=thr)
   if (allocated(error)) then
      print*, (overlap(1, 1) - 1.0_wp)
   end if

end subroutine test_norm_s


subroutine test_norm_1s_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 1, 1)
end subroutine test_norm_1s_sto1g

subroutine test_norm_2s_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 2, 1)
end subroutine test_norm_2s_sto1g

subroutine test_norm_3s_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 3, 1)
end subroutine test_norm_3s_sto1g

subroutine test_norm_4s_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 4, 1)
end subroutine test_norm_4s_sto1g

subroutine test_norm_5s_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 5, 1)
end subroutine test_norm_5s_sto1g


subroutine test_norm_1s_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 1, 2)
end subroutine test_norm_1s_sto2g

subroutine test_norm_2s_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 2, 2)
end subroutine test_norm_2s_sto2g

subroutine test_norm_3s_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 3, 2)
end subroutine test_norm_3s_sto2g

subroutine test_norm_4s_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 4, 2)
end subroutine test_norm_4s_sto2g

subroutine test_norm_5s_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 5, 2)
end subroutine test_norm_5s_sto2g


subroutine test_norm_1s_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 1, 3)
end subroutine test_norm_1s_sto3g

subroutine test_norm_2s_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 2, 3)
end subroutine test_norm_2s_sto3g

subroutine test_norm_3s_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 3, 3)
end subroutine test_norm_3s_sto3g

subroutine test_norm_4s_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 4, 3)
end subroutine test_norm_4s_sto3g

subroutine test_norm_5s_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 5, 3)
end subroutine test_norm_5s_sto3g


subroutine test_norm_1s_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 1, 4)
end subroutine test_norm_1s_sto4g

subroutine test_norm_2s_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 2, 4)
end subroutine test_norm_2s_sto4g

subroutine test_norm_3s_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 3, 4)
end subroutine test_norm_3s_sto4g

subroutine test_norm_4s_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 4, 4)
end subroutine test_norm_4s_sto4g

subroutine test_norm_5s_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 5, 4)
end subroutine test_norm_5s_sto4g


subroutine test_norm_1s_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 1, 5)
end subroutine test_norm_1s_sto5g

subroutine test_norm_2s_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 2, 5)
end subroutine test_norm_2s_sto5g

subroutine test_norm_3s_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 3, 5)
end subroutine test_norm_3s_sto5g

subroutine test_norm_4s_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 4, 5)
end subroutine test_norm_4s_sto5g

subroutine test_norm_5s_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 5, 5)
end subroutine test_norm_5s_sto5g


subroutine test_norm_1s_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 1, 6)
end subroutine test_norm_1s_sto6g

subroutine test_norm_2s_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 2, 6)
end subroutine test_norm_2s_sto6g

subroutine test_norm_3s_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 3, 6)
end subroutine test_norm_3s_sto6g

subroutine test_norm_4s_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 4, 6)
end subroutine test_norm_4s_sto6g

subroutine test_norm_5s_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 5, 6)
end subroutine test_norm_5s_sto6g

subroutine test_norm_6s_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_s(error, 6, 6)
end subroutine test_norm_6s_sto6g


subroutine test_norm_p(error, n, ng)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer, intent(in) :: ng, n

   integer :: stat, i, j
   type(cgto_type) :: cgto
   real(wp), parameter :: vec(3) = 0.0_wp, r2 = 0.0_wp
   real(wp) :: overlap(3, 3)

   call slater_to_gauss(ng, n, 1, 1.0_wp, cgto, .true., stat)
   call check(error, stat)
   if (allocated(error)) return

   call overlap_cgto(cgto, cgto, r2, vec, 100.0_wp, overlap)

   lp: do i = 1, 3
      do j = 1, 3
         call check(error, overlap(j, i), merge(1.0_wp, 0.0_wp, j == i), thr=thr)
         if (allocated(error)) exit lp
      end do
   end do lp
   if (allocated(error)) then
      print '(3es20.14e1)', overlap - reshape([1,0,0, 0,1,0, 0,0,1], [3,3])
   end if

end subroutine test_norm_p


subroutine test_norm_2p_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 2, 1)
end subroutine test_norm_2p_sto1g

subroutine test_norm_3p_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 3, 1)
end subroutine test_norm_3p_sto1g

subroutine test_norm_4p_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 4, 1)
end subroutine test_norm_4p_sto1g

subroutine test_norm_5p_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 5, 1)
end subroutine test_norm_5p_sto1g


subroutine test_norm_2p_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 2, 2)
end subroutine test_norm_2p_sto2g

subroutine test_norm_3p_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 3, 2)
end subroutine test_norm_3p_sto2g

subroutine test_norm_4p_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 4, 2)
end subroutine test_norm_4p_sto2g

subroutine test_norm_5p_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 5, 2)
end subroutine test_norm_5p_sto2g


subroutine test_norm_2p_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 2, 3)
end subroutine test_norm_2p_sto3g

subroutine test_norm_3p_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 3, 3)
end subroutine test_norm_3p_sto3g

subroutine test_norm_4p_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 4, 3)
end subroutine test_norm_4p_sto3g

subroutine test_norm_5p_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 5, 3)
end subroutine test_norm_5p_sto3g


subroutine test_norm_2p_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 2, 4)
end subroutine test_norm_2p_sto4g

subroutine test_norm_3p_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 3, 4)
end subroutine test_norm_3p_sto4g

subroutine test_norm_4p_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 4, 4)
end subroutine test_norm_4p_sto4g

subroutine test_norm_5p_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 5, 4)
end subroutine test_norm_5p_sto4g


subroutine test_norm_2p_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 2, 5)
end subroutine test_norm_2p_sto5g

subroutine test_norm_3p_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 3, 5)
end subroutine test_norm_3p_sto5g

subroutine test_norm_4p_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 4, 5)
end subroutine test_norm_4p_sto5g

subroutine test_norm_5p_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 5, 5)
end subroutine test_norm_5p_sto5g


subroutine test_norm_2p_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 2, 6)
end subroutine test_norm_2p_sto6g

subroutine test_norm_3p_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 3, 6)
end subroutine test_norm_3p_sto6g

subroutine test_norm_4p_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 4, 6)
end subroutine test_norm_4p_sto6g

subroutine test_norm_5p_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 5, 6)
end subroutine test_norm_5p_sto6g

subroutine test_norm_6p_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_p(error, 6, 6)
end subroutine test_norm_6p_sto6g


subroutine test_norm_d(error, n, ng)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer, intent(in) :: ng, n

   integer :: stat, i, j
   type(cgto_type) :: cgto
   real(wp), parameter :: vec(3) = 0.0_wp, r2 = 0.0_wp
   real(wp) :: overlap(5, 5)

   call slater_to_gauss(ng, n, 2, 1.0_wp, cgto, .true., stat)
   call check(error, stat)
   if (allocated(error)) return

   call overlap_cgto(cgto, cgto, r2, vec, 100.0_wp, overlap)

   lp: do i = 1, 5
      do j = 1, 5
         call check(error, overlap(j, i), merge(1.0_wp, 0.0_wp, j == i), thr=thr)
         if (allocated(error)) exit lp
      end do
   end do lp
   if (allocated(error)) then
      print '(5es20.14e1)', overlap &
         & - reshape([1,0,0,0,0, 0,1,0,0,0, 0,0,1,0,0, &
         &            0,0,0,1,0, 0,0,0,0,1], [5,5])
   end if

end subroutine test_norm_d


subroutine test_norm_3d_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 3, 1)
end subroutine test_norm_3d_sto1g

subroutine test_norm_4d_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 4, 1)
end subroutine test_norm_4d_sto1g

subroutine test_norm_5d_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 5, 1)
end subroutine test_norm_5d_sto1g


subroutine test_norm_3d_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 3, 2)
end subroutine test_norm_3d_sto2g

subroutine test_norm_4d_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 4, 2)
end subroutine test_norm_4d_sto2g

subroutine test_norm_5d_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 5, 2)
end subroutine test_norm_5d_sto2g


subroutine test_norm_3d_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 3, 3)
end subroutine test_norm_3d_sto3g

subroutine test_norm_4d_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 4, 3)
end subroutine test_norm_4d_sto3g

subroutine test_norm_5d_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 5, 3)
end subroutine test_norm_5d_sto3g


subroutine test_norm_3d_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 3, 4)
end subroutine test_norm_3d_sto4g

subroutine test_norm_4d_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 4, 4)
end subroutine test_norm_4d_sto4g

subroutine test_norm_5d_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 5, 4)
end subroutine test_norm_5d_sto4g


subroutine test_norm_3d_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 3, 5)
end subroutine test_norm_3d_sto5g

subroutine test_norm_4d_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 4, 5)
end subroutine test_norm_4d_sto5g

subroutine test_norm_5d_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 5, 5)
end subroutine test_norm_5d_sto5g


subroutine test_norm_3d_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 3, 6)
end subroutine test_norm_3d_sto6g

subroutine test_norm_4d_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 4, 6)
end subroutine test_norm_4d_sto6g

subroutine test_norm_5d_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_d(error, 5, 6)
end subroutine test_norm_5d_sto6g


subroutine test_norm_f(error, n, ng)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer, intent(in) :: ng, n

   integer :: stat, i, j
   type(cgto_type) :: cgto
   real(wp), parameter :: vec(3) = 0.0_wp, r2 = 0.0_wp
   real(wp) :: overlap(7, 7)

   call slater_to_gauss(ng, n, 3, 1.0_wp, cgto, .true., stat)
   call check(error, stat)
   if (allocated(error)) return

   call overlap_cgto(cgto, cgto, r2, vec, 100.0_wp, overlap)

   lp: do i = 1, 7
      do j = 1, 7
         call check(error, overlap(j, i), merge(1.0_wp, 0.0_wp, j == i), thr=thr)
         if (allocated(error)) exit lp
      end do
   end do lp
   if (allocated(error)) then
      print '(7es20.14e1)', overlap &
         & - reshape([1,0,0,0,0,0,0, 0,1,0,0,0,0,0, 0,0,1,0,0,0,0, &
         &            0,0,0,1,0,0,0, 0,0,0,0,1,0,0, 0,0,0,0,0,1,0, &
         &            0,0,0,0,0,0,1], [7,7])
   end if

end subroutine test_norm_f


subroutine test_norm_4f_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_f(error, 4, 1)
end subroutine test_norm_4f_sto1g

subroutine test_norm_5f_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_f(error, 5, 1)
end subroutine test_norm_5f_sto1g


subroutine test_norm_4f_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_f(error, 4, 2)
end subroutine test_norm_4f_sto2g

subroutine test_norm_5f_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_f(error, 5, 2)
end subroutine test_norm_5f_sto2g


subroutine test_norm_4f_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_f(error, 4, 3)
end subroutine test_norm_4f_sto3g

subroutine test_norm_5f_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_f(error, 5, 3)
end subroutine test_norm_5f_sto3g


subroutine test_norm_4f_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_f(error, 4, 4)
end subroutine test_norm_4f_sto4g

subroutine test_norm_5f_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_f(error, 5, 4)
end subroutine test_norm_5f_sto4g


subroutine test_norm_4f_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_f(error, 4, 5)
end subroutine test_norm_4f_sto5g

subroutine test_norm_5f_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_f(error, 5, 5)
end subroutine test_norm_5f_sto5g


subroutine test_norm_4f_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_f(error, 4, 6)
end subroutine test_norm_4f_sto6g

subroutine test_norm_5f_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_f(error, 5, 6)
end subroutine test_norm_5f_sto6g


subroutine test_norm_g(error, n, ng)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer, intent(in) :: ng, n

   integer :: stat, i, j
   type(cgto_type) :: cgto
   real(wp), parameter :: vec(3) = 0.0_wp, r2 = 0.0_wp
   real(wp) :: overlap(9, 9)

   call slater_to_gauss(ng, n, 4, 1.0_wp, cgto, .true., stat)
   call check(error, stat)
   if (allocated(error)) return

   call overlap_cgto(cgto, cgto, r2, vec, 100.0_wp, overlap)

   lp: do i = 1, 9
      do j = 1, 9
         call check(error, overlap(j, i), merge(1.0_wp, 0.0_wp, j == i), thr=thr)
         if (allocated(error)) exit lp
      end do
   end do lp
   if (allocated(error)) then
      print '(9es20.14e1)', overlap
   end if

end subroutine test_norm_g


subroutine test_norm_5g_sto1g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_f(error, 5, 1)
end subroutine test_norm_5g_sto1g


subroutine test_norm_5g_sto2g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_g(error, 5, 2)
end subroutine test_norm_5g_sto2g


subroutine test_norm_5g_sto3g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_g(error, 5, 3)
end subroutine test_norm_5g_sto3g


subroutine test_norm_5g_sto4g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_g(error, 5, 4)
end subroutine test_norm_5g_sto4g


subroutine test_norm_5g_sto5g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_g(error, 5, 5)
end subroutine test_norm_5g_sto5g


subroutine test_norm_5g_sto6g(error)
   type(error_type), allocatable, intent(out) :: error
   call test_norm_g(error, 5, 6)
end subroutine test_norm_5g_sto6g


end module test_slater_expansion

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/solvation
!> Contains the implementation of the implicit solvation models.

!> @file tblite/solvation.f90
!> Provides reexports of the implict solvation model related implementations.

!> Proxy module for implicit solvation models.
module tblite_solvation
   use mctc_env, only : error_type, fatal_error
   use mctc_io, only : structure_type
   use tblite_solvation_alpb, only : alpb_solvation, new_alpb, alpb_input, born_kernel
   use tblite_solvation_cpcm, only : cpcm_solvation, new_cpcm, cpcm_input
   use tblite_solvation_cds, only : cds_solvation, new_cds, cds_input
   use tblite_solvation_shift, only : shift_solvation, new_shift, shift_input, solution_state
   use tblite_solvation_data, only : solvent_data, get_solvent_data
   use tblite_solvation_input, only : solvation_input
   use tblite_solvation_type, only : solvation_type
   use tblite_solvation_data_alpb, only: get_alpb_param
   use tblite_solvation_data_cds, only: get_cds_param
   use tblite_solvation_data_shift, only: get_shift_param
   implicit none
   private

   public :: alpb_solvation, new_alpb, alpb_input, born_kernel
   public :: cpcm_solvation, new_cpcm, cpcm_input
   public :: cds_solvation, new_cds, cds_input
   public :: shift_solvation, new_shift, shift_input
   public :: solvent_data, get_solvent_data
   public :: solvation_input, new_solvation, solvation_type
   public :: new_solvation_cds
   public :: new_solvation_shift, solution_state

contains

!> Create new solvation model from input data
subroutine new_solvation(solv, mol, input, error, method)
   !> Instance of the solvation model
   class(solvation_type), allocatable, intent(out) :: solv
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input data
   type(solvation_input), intent(in) :: input
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Method for parameter selection
   character(len=*), optional, intent(in) :: method
   !> scratch input
   type(alpb_input), allocatable :: scratch_input

   if (allocated(input%alpb)) then
      scratch_input = input%alpb
      ! ALPB/GBSA with empirical parameters
      if (allocated(input%alpb%solvent) .and. present(method)) then
         call get_alpb_param(scratch_input, mol, method, error)
         if(allocated(error)) then
            call fatal_error(error, "No ALPB/GBSA parameters found for the method/solvent")
            return
         end if
      end if
      solv = alpb_solvation(mol, scratch_input, method)
      return
   end if

   if (allocated(input%cpcm)) then
      solv = cpcm_solvation(mol, input%cpcm)
      return
   end if

   call fatal_error(error, "Unknown solvation model")
end subroutine new_solvation

!> Create new cds solvation model from input data
subroutine new_solvation_cds(solv, mol, input, error, method)
   !> Instance of the solvation model
   class(solvation_type), allocatable, intent(out) :: solv
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Input data
   type(solvation_input), intent(in) :: input
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Method for parameter selection
   character(len=*), optional, intent(in) :: method
   !> scratch input
   type(cds_input), allocatable :: scratch_input

   if (allocated(input%cds) .and. &
      & allocated(input%cds%solvent) .and. present(method)) then
      scratch_input = input%cds
      call get_cds_param(scratch_input, mol, method, error)
      if(allocated(error)) then
         call fatal_error(error, "No CDS parameters found for the method/solvent")
         return
      end if
      solv = cds_solvation(mol, scratch_input, method)
      return
    end if

   call fatal_error(error, "Unknown CDS model")
end subroutine new_solvation_cds

!> Create new solvation shift from input data
subroutine new_solvation_shift(solv, input, error, method)
   !> Instance of the solvation model
   class(solvation_type), allocatable, intent(out) :: solv
   !> Input data
   type(solvation_input), intent(in) :: input
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Method for parameter selection
   character(len=*), optional, intent(in) :: method
   !> scratch input
   type(shift_input), allocatable :: scratch_input

   if (allocated(input%shift) .and. &
      & allocated(input%shift%solvent) .and. present(method)) then
      scratch_input = input%shift
      call get_shift_param(scratch_input, method, error)
      if(allocated(error)) then
         call fatal_error(error, "No shift parameters found for the method/solvent")
         return
      end if
      solv = shift_solvation(scratch_input)
      return
    end if

   call fatal_error(error, "Unknown solvation shift")
end subroutine new_solvation_shift

end module tblite_solvation

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/solvation/data
!> Provides solvent specific data for parametrized solvation models

!> @file tblite/solvation/data.f90
!> Provides element specific data

!> Element specific data for solvation models
module tblite_solvation_data
   use mctc_env, only : wp
   use mctc_io, only : to_number
   use mctc_io_convert, only : aatoau
   implicit none
   private

   public :: get_vdw_rad_d3, get_vdw_rad_cosmo, get_vdw_rad_bondi
   public :: get_solvent_data


   !> Solvent specific parameters
   type, public :: solvent_data
      real(wp) :: eps
      real(wp) :: n
      real(wp) :: alpha
      real(wp) :: beta
      real(wp) :: gamma
      real(wp) :: phi2
      real(wp) :: psi2
      character(len=:), allocatable :: solvent
   end type solvent_data

   interface solvent_data
      module procedure get_solvent_data
   end interface solvent_data


   !> Get D3 van-der-Waals radius for a species
   interface get_vdw_rad_d3
      module procedure :: get_vdw_rad_d3_sym
      module procedure :: get_vdw_rad_d3_num
   end interface get_vdw_rad_d3

   !> Get COSMO van-der-Waals radius for a species
   interface get_vdw_rad_cosmo
      module procedure :: get_vdw_rad_cosmo_sym
      module procedure :: get_vdw_rad_cosmo_num
   end interface get_vdw_rad_cosmo

   !> Get Bondi van-der-Waals radius for a species
   interface get_vdw_rad_bondi
      module procedure :: get_vdw_rad_bondi_sym
      module procedure :: get_vdw_rad_bondi_num
   end interface get_vdw_rad_bondi


   !> In case no van-der-Waals value is provided
   real(wp), parameter :: missing = -1.0_wp

   !> D3 pairwise van-der-Waals radii (only homoatomic pairs present here)
   real(wp), parameter :: vdw_rad_d3(1:94) = aatoau * [&
      & 1.09155_wp, 0.86735_wp, 1.74780_wp, 1.54910_wp, &  ! H-Be
      & 1.60800_wp, 1.45515_wp, 1.31125_wp, 1.24085_wp, &  ! B-O
      & 1.14980_wp, 1.06870_wp, 1.85410_wp, 1.74195_wp, &  ! F-Mg
      & 2.00530_wp, 1.89585_wp, 1.75085_wp, 1.65535_wp, &  ! Al-S
      & 1.55230_wp, 1.45740_wp, 2.12055_wp, 2.05175_wp, &  ! Cl-Ca
      & 1.94515_wp, 1.88210_wp, 1.86055_wp, 1.72070_wp, &  ! Sc-Cr
      & 1.77310_wp, 1.72105_wp, 1.71635_wp, 1.67310_wp, &  ! Mn-Ni
      & 1.65040_wp, 1.61545_wp, 1.97895_wp, 1.93095_wp, &  ! Cu-Ge
      & 1.83125_wp, 1.76340_wp, 1.68310_wp, 1.60480_wp, &  ! As-Kr
      & 2.30880_wp, 2.23820_wp, 2.10980_wp, 2.02985_wp, &  ! Rb-Zr
      & 1.92980_wp, 1.87715_wp, 1.78450_wp, 1.73115_wp, &  ! Nb-Ru
      & 1.69875_wp, 1.67625_wp, 1.66540_wp, 1.73100_wp, &  ! Rh-Cd
      & 2.13115_wp, 2.09370_wp, 2.00750_wp, 1.94505_wp, &  ! In-Te
      & 1.86900_wp, 1.79445_wp, 2.52835_wp, 2.59070_wp, &  ! I-Ba
      & 2.31305_wp, 2.31005_wp, 2.28510_wp, 2.26355_wp, &  ! La-Nd
      & 2.24480_wp, 2.22575_wp, 2.21170_wp, 2.06215_wp, &  ! Pm-Gd
      & 2.12135_wp, 2.07705_wp, 2.13970_wp, 2.12250_wp, &  ! Tb-Er
      & 2.11040_wp, 2.09930_wp, 2.00650_wp, 2.12250_wp, &  ! Tm-Hf
      & 2.04900_wp, 1.99275_wp, 1.94775_wp, 1.87450_wp, &  ! Ta-Os
      & 1.72280_wp, 1.67625_wp, 1.62820_wp, 1.67995_wp, &  ! Ir-Hg
      & 2.15635_wp, 2.13820_wp, 2.05875_wp, 2.00270_wp, &  ! Tl-Po
      & 1.93220_wp, 1.86080_wp, 2.53980_wp, 2.46470_wp, &  ! At-Ra
      & 2.35215_wp, 2.21260_wp, 2.22970_wp, 2.19785_wp, &  ! Ac-U
      & 2.17695_wp, 2.21705_wp]                            ! Np-Pu


   !> Default value for unoptimized van-der-Waals radii
   real(wp), parameter :: cosmostub = 2.223_wp

   !> COSMO optimized van-der-Waals radii
   real(wp), parameter :: vdw_rad_cosmo(1:94) = aatoau * [ &
      & 1.3000_wp, 1.6380_wp, 1.5700_wp, 1.0530_wp, &   ! H-Be
      & 2.0480_wp, 2.0000_wp, 1.8300_wp, 1.7200_wp, &   ! B-O
      & 1.7200_wp, 1.8018_wp, 1.8000_wp, 1.6380_wp, &   ! F-Mg
      & 2.1530_wp, 2.2000_wp, 2.1060_wp, 2.1600_wp, &   ! Al-S
      & 2.0500_wp, 2.2000_wp, 2.2230_wp, cosmostub, &   ! Cl-Ca
      & cosmostub, 2.2930_wp, cosmostub, cosmostub, &   ! Sc-Cr
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Mn-Ni
      & cosmostub, 1.6260_wp, cosmostub, 2.7000_wp, &   ! Cu-Ge
      & 2.3500_wp, 2.2000_wp, 2.1600_wp, 2.3630_wp, &   ! As-Kr
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Rb-Zr
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Nb-Ru
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Rh-Cd
      & 2.2580_wp, 2.5500_wp, 2.4100_wp, 2.4100_wp, &   ! In-Te
      & 2.3200_wp, 2.5270_wp, cosmostub, cosmostub, &   ! I-Ba
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! La-Nd
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Pm-Gd
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Tb-Er
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Tm-Hf
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Ta-Os
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Ir-Hg
      & cosmostub, 2.3600_wp, 2.4220_wp, 2.3050_wp, &   ! Tl-Po
      & 2.3630_wp, 2.5740_wp, cosmostub, cosmostub, &   ! At-Ra
      & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Ac-U
      & cosmostub, cosmostub]                           ! Np-Pu

   !> Van-der-Waals radii from
   !> Manjeera Mantina, Adam C. Chamberlin, Rosendo Valero, Christopher J. Cramer,
   !> and Donald G. Truhlar, Consistent van der Waals Radii for the Whole Main Group,
   !> J. Phys. Chem. A 2009, 113, 19, 5806–5812. https://doi.org/10.1021/jp8111556
   real(wp), parameter :: vdw_rad_bondi(1:88) = aatoau * [ &
      & 1.10_wp, 1.40_wp, 1.81_wp, 1.53_wp, 1.92_wp, 1.70_wp, 1.55_wp, 1.52_wp, &  ! H-O
      & 1.47_wp, 1.54_wp, 2.27_wp, 1.73_wp, 1.84_wp, 2.10_wp, 1.80_wp, 1.80_wp, &  ! F-S
      & 1.75_wp, 1.88_wp, 2.75_wp, 2.31_wp, missing, missing, missing, missing, &  ! Cl-Cr
      & missing, missing, missing, missing, missing, missing, 1.87_wp, 2.11_wp, &  ! Mn-Ge
      & 1.85_wp, 1.90_wp, 1.83_wp, 2.02_wp, 3.03_wp, 2.49_wp, missing, missing, &  ! As-Zr
      & missing, missing, missing, missing, missing, missing, missing, missing, &  ! Nb-Cd
      & 1.93_wp, 2.17_wp, 2.06_wp, 2.06_wp, 1.98_wp, 2.16_wp, 3.43_wp, 2.68_wp, &  ! I-Ba
      & missing, missing, missing, missing, missing, missing, missing, missing, &  ! La-Gd
      & missing, missing, missing, missing, missing, missing, missing, missing, &  ! Tb-Hf
      & missing, missing, missing, missing, missing, missing, missing, missing, &  ! Ta-Hg
      & 1.96_wp, 2.02_wp, 2.07_wp, 1.97_wp, 2.02_wp, 2.20_wp, 3.48_wp, 2.83_wp]    ! Tl-Ra


contains


!> Get van-der-Waals radius for species with a given symbol
elemental function get_vdw_rad_d3_sym(symbol) result(radius)
   !> Element symbol
   character(len=*), intent(in) :: symbol
   !> van-der-Waals radius
   real(wp) :: radius

   radius = get_vdw_rad_d3(to_number(symbol))

end function get_vdw_rad_d3_sym


!> Get van-der-Waals radius for species with a given atomic number
elemental function get_vdw_rad_d3_num(number) result(radius)
   !> Atomic number
   integer, intent(in) :: number
   !> van-der-Waals radius
   real(wp) :: radius

   if (number > 0 .and. number <= size(vdw_rad_d3, dim=1)) then
      radius = vdw_rad_d3(number)
   else
      radius = missing
   end if

end function get_vdw_rad_d3_num


!> Get van-der-Waals radius for species with a given symbol
elemental function get_vdw_rad_cosmo_sym(symbol) result(radius)
   !> Element symbol
   character(len=*), intent(in) :: symbol
   !> van-der-Waals radius
   real(wp) :: radius

   radius = get_vdw_rad_cosmo(to_number(symbol))

end function get_vdw_rad_cosmo_sym


!> Get van-der-Waals radius for species with a given atomic number
elemental function get_vdw_rad_cosmo_num(number) result(radius)
   !> Atomic number
   integer, intent(in) :: number
   !> van-der-Waals radius
   real(wp) :: radius

   if (number > 0 .and. number <= size(vdw_rad_cosmo, dim=1)) then
      radius = vdw_rad_cosmo(number)
   else
      radius = missing
   end if

end function get_vdw_rad_cosmo_num


!> Get van-der-Waals radius for species with a given symbol
elemental function get_vdw_rad_bondi_sym(symbol) result(radius)
   !> Element symbol
   character(len=*), intent(in) :: symbol
   !> van-der-Waals radius
   real(wp) :: radius

   radius = get_vdw_rad_bondi(to_number(symbol))

end function get_vdw_rad_bondi_sym


!> Get van-der-Waals radius for species with a given atomic number
elemental function get_vdw_rad_bondi_num(number) result(radius)
   !> Atomic number
   integer, intent(in) :: number
   !> van-der-Waals radius
   real(wp) :: radius

   if (number > 0 .and. number <= size(vdw_rad_bondi, dim=1)) then
      radius = vdw_rad_bondi(number)
   else
      radius = missing
   end if

end function get_vdw_rad_bondi_num


!> Get solvent parameters, in case the solvent is not known the ideal conductor is assumed
pure function get_solvent_data(solvent) result(data)
   !> Name of solvent
   character(len=*), intent(in) :: solvent
   !> Solvent data
   type(solvent_data) :: data

   select case(compact(solvent))
   case default
      data = solvent_data(-1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, "none")
   case("inf")
      data = solvent_data(huge(1.0_wp), 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, "inf")
   case("2methylpyridine")
      data = solvent_data(9.9533_wp, 1.4957_wp, 0.0_wp, 0.58_wp, 47.5_wp, 0.509796_wp, 0.0_wp, "2methylpyridine")
   case("4methyl2pentanone")
      data = solvent_data(12.8871_wp, 1.3962_wp, 0.0_wp, 0.51_wp, 33.83_wp, 0.0_wp, 0.0_wp, "4methyl2pentanone")
   case("aceticacid")
      data = solvent_data(6.2528_wp, 1.372_wp, 0.61_wp, 0.44_wp, 39.01_wp, 0.0_wp, 0.0_wp, "aceticacid")
   case("acetone")
      data = solvent_data(20.493_wp, 1.3588_wp, 0.04_wp, 0.49_wp, 33.77_wp, 0.0_wp, 0.0_wp, "acetone") 
   case("acetonitrile","mecn")
      data = solvent_data(35.6881_wp, 1.3442_wp, 0.07_wp, 0.32_wp, 41.25_wp, 0.0_wp, 0.0_wp, "acetonitrile")
   case("acetophenone")
      data = solvent_data(17.44_wp, 1.5372_wp, 0.0_wp, 0.48_wp, 56.19_wp, 0.444889_wp, 0.0_wp, "acetophenone")
   case("aniline")
      data = solvent_data(6.8882_wp, 1.5863_wp, 0.26_wp, 0.41_wp, 60.62_wp, 0.734449_wp, 0.0_wp, "aniline")
   case("anisole")
      data = solvent_data(4.2247_wp, 1.5174_wp, 0.0_wp, 0.29_wp, 50.52_wp, 0.5625_wp, 0.0_wp, "anisole")
   case("benzaldehyde") ! no Minnisota database entry
      data = solvent_data(17.85_wp,1.5456_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, "benzaldehyde")
   case("benzene")
      data = solvent_data(2.2706_wp, 1.5011_wp, 0.0_wp, 0.14_wp, 40.62_wp, 1_wp, 0.0_wp, "benzene")
   case("benzonitrile")
      data = solvent_data(25.592_wp, 1.5289_wp, 0.0_wp, 0.33_wp, 55.83_wp, 0.5625_wp, 0.0_wp, "benzonitrile")
   case("benzylalcohol")
      data = solvent_data(12.4569_wp, 1.5396_wp, 0.33_wp, 0.56_wp, 52.96_wp, 0.5625_wp, 0.0_wp, "benzylalcohol")
   case("bromobenzene")
      data = solvent_data(5.3954_wp, 1.5597_wp, 0.0_wp, 0.09_wp, 50.72_wp, 0.734449_wp, 0.020449_wp, "bromobenzene")
   case("bromoethane")
      data = solvent_data(9.01_wp, 1.4239_wp, 0.0_wp, 0.12_wp, 34_wp, 0.0_wp, 0.110889_wp, "bromoethane")
   case("bromoform")
      data = solvent_data(4.2488_wp, 1.6005_wp, 0.15_wp, 0.06_wp, 64.58_wp, 0.0_wp, 0.5625_wp)
   case("bromooctane")
      data = solvent_data(5.0244_wp, 1.4524_wp, 0.0_wp, 0.12_wp, 41.28_wp, 0.0_wp, 0.0121_wp, "bromooctane")
   case("butanol")
      data = solvent_data(17.3323_wp, 1.3993_wp, 0.37_wp, 0.48_wp, 35.88_wp, 0.0_wp, 0.0_wp, "butanol")
   case("butanone")
      data = solvent_data(18.2457_wp, 1.3788_wp, 0.0_wp, 0.51_wp, 34.5_wp, 0.0_wp, 0.0_wp, "butanone")
   case("butylacetate")
      data = solvent_data(4.9941_wp, 1.3941_wp, 0.0_wp, 0.45_wp, 35.81_wp, 0.0_wp, 0.0_wp, "butylacetate")
   case("butylbenzene")
      data = solvent_data(2.36_wp, 1.4898_wp, 0.0_wp, 0.15_wp, 41.33_wp, 0.36_wp, 0.0_wp, "butylbenzene")
   case("carbondisulfide","cs2")
      data = solvent_data(2.6105_wp, 1.6319_wp, 0.0_wp, 0.07_wp, 45.45_wp, 0.0_wp, 0.0_wp, "carbondisulfide")
   case("carbontet")
      data = solvent_data(2.228_wp, 1.4601_wp, 0.0_wp, 0.0_wp, 38.04_wp, 0.0_wp, 0.64_wp, "carbontet")
   case("chlorobenzene")
      data = solvent_data(5.6968_wp, 1.5241_wp, 0.0_wp, 0.07_wp, 47.48_wp, 0.734449_wp, 0.020449_wp, "chlorobenzene")
   case("chloroform","chcl3")
      data = solvent_data(4.7113_wp, 1.4459_wp, 0.15_wp, 0.02_wp, 38.39_wp, 0.0_wp, 0.5625_wp, "chloroform")
   case("chlorohexane")
      data = solvent_data(5.9491_wp, 1.4199_wp, 0.0_wp, 0.1_wp, 37.03_wp, 0.0_wp, 0.020449_wp, "chlorohexane")
   case("cyclohexane")
      data = solvent_data(2.0165_wp, 1.4266_wp, 0.0_wp, 0.0_wp, 35.48_wp, 0.0_wp, 0.0_wp, "cyclohexane")
   case("cyclohexanone")
      data = solvent_data(15.6186_wp, 1.4507_wp, 0.0_wp, 0.56_wp, 49.76_wp, 0.0_wp, 0.0_wp, "cyclohexanone")
   case("decalin")
      data = solvent_data(2.196_wp, 1.4528_wp, 0.0_wp, 0.0_wp, 43.82_wp, 0.0_wp, 0.0_wp, "decalin")
   case("decane")
      data = solvent_data(1.9846_wp, 1.4102_wp, 0.0_wp, 0.0_wp, 33.64_wp, 0.0_wp, 0.0_wp, "decane")
   case("decanol")
      data = solvent_data(7.5305_wp, 1.4372_wp, 0.37_wp, 0.48_wp, 41.04_wp, 0.0_wp, 0.0_wp, "decanol")
   case("dibromoethane")
      data = solvent_data(4.9313_wp, 1.5387_wp, 0.1_wp, 0.17_wp, 56.93_wp, 0.0_wp, 0.25_wp, "dibromoethane")
   case("dibutylether")
      data = solvent_data(3.0473_wp, 1.3992_wp, 0.0_wp, 0.45_wp, 35.98_wp, 0.0_wp, 0.0_wp, "dibutylether")
   case("dichloroethane")
      data = solvent_data(10.125_wp, 1.4448_wp, 0.1_wp, 0.11_wp, 45.86_wp, 0.0_wp, 0.25_wp, "dichloroethane")
   case("diethylether","ether")
      data = solvent_data(4.24_wp, 1.3526_wp, 0.0_wp, 0.41_wp, 23.96_wp, 0.0_wp, 0.0_wp, "diethylether")
   case("diisopropylether")
      data = solvent_data(3.38_wp, 1.3679_wp, 0.0_wp, 0.41_wp, 24.86_wp, 0.0_wp, 0.0_wp, "diisopropylether")
   case("dimethylacetamide")
      data = solvent_data(37.7807_wp, 1.438_wp, 0.0_wp, 0.78_wp, 47.62_wp, 0.0_wp, 0.0_wp, "dimethylacetamide")
   case("dimethylformamide","dmf")
      data = solvent_data(37.219_wp, 1.4305_wp, 0.0_wp, 0.74_wp, 49.56_wp, 0.0_wp, 0.0_wp, "dimethylformamide")
   case("dimethylpyridine")
      data = solvent_data(7.1735_wp, 1.4953_wp, 0.0_wp, 0.63_wp, 44.64_wp, 0.390625_wp, 0.0_wp, "dimethylpyridine")
   case("dimethylsulfoxide","dmso")
      data = solvent_data(46.826_wp, 1.417_wp, 0.0_wp, 0.88_wp, 61.78_wp, 0.0_wp, 0.0_wp, "dimethylsulfoxide")
   case("dioxane") ! no Minnisota database entry
      data = solvent_data(2.2099_wp, 1.4224_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, "dioxane")
   case("dodecane")
      data = solvent_data(2.006_wp, 1.4216_wp, 0.0_wp, 0.0_wp, 35.85_wp, 0.0_wp, 0.0_wp, "dodecane")
   case("ethanol")
      data = solvent_data(24.852_wp, 1.3611_wp, 0.37_wp, 0.48_wp, 31.62_wp, 0.0_wp, 0.0_wp, "ethanol")
   case("ethoxybenzene")
      data = solvent_data(4.1797_wp, 1.5076_wp, 0.0_wp, 0.32_wp, 46.65_wp, 0.444889_wp, 0.0_wp, "ethoxybenzene")
   case("ethylacetate")
      data = solvent_data(5.9867_wp, 1.3723_wp, 0.0_wp, 0.45_wp, 33.67_wp, 0.0_wp, 0.0_wp, "ethylacetate")
   case("ethylbenzene")
      data = solvent_data(2.4339_wp, 1.4959_wp, 0.0_wp, 0.15_wp, 41.38_wp, 0.5625_wp, 0.0_wp, "ethylbenzene")
   case("fluorobenzene")
      data = solvent_data(5.42_wp, 1.4684_wp, 0.0_wp, 0.1_wp, 38.37_wp, 0.734449_wp, 0.020449_wp, "fluorobenzene")
   case("fluoroctane")
      data = solvent_data(3.89_wp, 1.3935_wp, 0.0_wp, 0.1_wp, 33.92_wp, 0.0_wp, 0.012321_wp, "fluoroctane")
   case("furan","furane") ! no Minnisota database entry
      data = solvent_data(2.953_wp, 1.4214_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, "furane")
   case("heptane")
      data = solvent_data(1.9113_wp, 1.3878_wp, 0.0_wp, 0.0_wp, 28.28_wp, 0.0_wp, 0.0_wp, "heptane")
   case("heptanol")
      data = solvent_data(11.321_wp, 1.4249_wp, 0.37_wp, 0.48_wp, 38.5_wp, 0.0_wp, 0.0_wp, "heptanol")
   case("hexadecane")
      data = solvent_data(2.0402_wp, 1.4345_wp, 0.0_wp, 0.0_wp, 38.93_wp, 0.0_wp, 0.0_wp, "hexadecane")
   case("hexadecyliodide")
      data = solvent_data(3.5338_wp, 1.4806_wp, 0.0_wp, 0.15_wp, 46.48_wp, 0.0_wp, 0.0_wp, "hexadecyliodide")
   case("hexane","nhexan","n-hexan","nhexane","n-hexane")
      data = solvent_data(1.8819_wp, 1.3749_wp, 0.0_wp, 0.0_wp, 25.7495_wp, 0.0_wp, 0.0_wp, "hexane")
   case("hexanol")
      data = solvent_data(12.5102_wp, 1.4178_wp, 0.37_wp, 0.48_wp, 37.15_wp, 0.0_wp, 0.0_wp, "hexanol")
   case("iodobenzene")
      data = solvent_data(4.547_wp, 1.62_wp, 0.0_wp, 0.12_wp, 55.72_wp, 0.734449_wp, 0.0_wp, "iodobenzene")
   case("isobutanol")
      data = solvent_data(16.7766_wp, 1.3955_wp, 0.37_wp, 0.48_wp, 32.38_wp, 0.0_wp, 0.0_wp, "isobutanol")
   case("isooctane")
      data = solvent_data(1.9358_wp, 1.3915_wp, 0.0_wp, 0.0_wp, 26.38_wp, 0.0_wp, 0.0_wp, "isooctane")
   case("isopropanol")
      data = solvent_data(19.2645_wp, 1.3776_wp, 0.33_wp, 0.56_wp, 30.13_wp, 0.0_wp, 0.0_wp, "isopropanol")
   case("isopropylbenzene")
      data = solvent_data(2.3712_wp, 1.4915_wp, 0.0_wp, 0.16_wp, 39.85_wp, 0.444889_wp, 0.0_wp, "isopropylbenzene")
   case("mcresol")
      data = solvent_data(12.44_wp, 1.5438_wp, 0.57_wp, 0.34_wp, 51.37_wp, 0.5625_wp, 0.0_wp, "mcresol")
   case("mesitylene")
      data = solvent_data(2.265_wp, 1.4994_wp, 0.0_wp, 0.19_wp, 39.65_wp, 0.444889_wp, 0.0_wp, "mesitylene")
   case("methanol")
      data = solvent_data(32.613_wp, 1.3288_wp, 0.43_wp, 0.47_wp, 31.77_wp, 0.0_wp, 0.0_wp, "methanol")
   case("methoxyethanol")
      data = solvent_data(17.2_wp, 1.4024_wp, 0.3_wp, 0.84_wp, 44.39_wp, 0.0_wp, 0.0_wp, "methoxyethanol")
   case("methylenechloride","dichloromethane","dichlormethane","ch2cl2")
      data = solvent_data(8.93_wp, 1.4242_wp, 0.1_wp, 0.05_wp, 39.15_wp, 0.0_wp, 0.444889_wp, "methylenechloride")
   case("methylformamide")
      data = solvent_data(181.5619_wp, 1.4319_wp, 0.4_wp, 0.55_wp, 55.4372_wp, 0.0_wp, 0.0_wp, "methylformamide")
   case("nitrobenzene")
      data = solvent_data(34.8091_wp, 1.5562_wp, 0.0_wp, 0.28_wp, 57.54_wp, 0.444889_wp, 0.0_wp, "nitrobenzene")
   case("nitroethane")
      data = solvent_data(28.2896_wp, 1.3917_wp, 0.02_wp, 0.33_wp, 46.25_wp, 0.0_wp, 0.0_wp, "nitroethane")
   case("nitromethane")
      data = solvent_data(36.5623_wp, 1.3817_wp, 0.06_wp, 0.31_wp, 52.58_wp, 0.0_wp, 0.0_wp, "nitromethane")
   case("nonane")
      data = solvent_data(1.9605_wp, 1.4054_wp, 0.0_wp, 0.0_wp, 32.21_wp, 0.0_wp, 0.0_wp, "nonane")
   case("nonanol")
      data = solvent_data(8.5991_wp, 1.4333_wp, 0.37_wp, 0.48_wp, 40.14_wp, 0.0_wp, 0.0_wp, "nonanol")
   case("octane")
      data = solvent_data(1.9406_wp, 1.3974_wp, 0.0_wp, 0.0_wp, 30.4273_wp, 0.0_wp, 0.0_wp, "octane")
   case("octanol")
      data = solvent_data(9.8629_wp, 1.4295_wp, 0.37_wp, 0.48_wp, 39.01_wp, 0.0_wp, 0.0_wp, "octanol")
   case("odichlorobenzene")
      data = solvent_data(9.9949_wp, 1.5515_wp, 0.0_wp, 0.04_wp, 52.72_wp, 0.5625_wp, 0.0625_wp, "odichlorobenzene")
   case("onitrotoluene")
      data = solvent_data(25.6692_wp, 1.545_wp, 0.0_wp, 0.27_wp, 59.12_wp, 0.36_wp, 0.0_wp, "onitrotoluene")
   case("pentadecane")
      data = solvent_data(2.0333_wp, 1.4315_wp, 0.0_wp, 0.0_wp, 38.34_wp, 0.0_wp, 0.0_wp, "pentadecane")
   case("pentane")
      data = solvent_data(1.8371_wp, 1.3575_wp, 0.0_wp, 0.0_wp, 22.3_wp, 0.0_wp, 0.0_wp, "pentane")
   case("pentanol")
      data = solvent_data(15.13_wp, 1.4101_wp, 0.37_wp, 0.48_wp, 36.5_wp, 0.0_wp, 0.0_wp, "pentanol")
   case("perfluorobenzene")
      data = solvent_data(2.029_wp, 1.3777_wp, 0.0_wp, 0.0_wp, 31.74_wp, 0.25_wp, 0.25_wp, "perfluorobenzene")
   case("phenol") ! no Minnisota database entry
      data = solvent_data(12.4_wp, 1.5408_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, "phenol")
   case("phenylether")
      data = solvent_data(3.73_wp, 1.5787_wp, 0.0_wp, 0.2_wp, 38.5_wp, 0.851929_wp, 0.0_wp, "phenylether")
   case("propanol")
      data = solvent_data(20.5237_wp, 1.385_wp, 0.37_wp, 0.48_wp, 33.57_wp, 0.0_wp, 0.0_wp, "propanol")
   case("pyridine")
      data = solvent_data(12.9776_wp, 1.5095_wp, 0.0_wp, 0.52_wp, 52.62_wp, 0.693889_wp, 0.0_wp, "pyridine")
   case("secbutanol")
      data = solvent_data(15.9436_wp, 1.3978_wp, 0.33_wp, 0.56_wp, 32.44_wp, 0.0_wp, 0.0_wp, "secbutanol")
   case("secbutylbenzene")
      data = solvent_data(2.3446_wp, 1.4895_wp, 0.0_wp, 0.16_wp, 40.35_wp, 0.36_wp, 0.0_wp, "secbutylbenzene")
   case("tbutylbenzene")
      data = solvent_data(2.3447_wp, 1.4927_wp, 0.0_wp, 0.16_wp, 39.78_wp, 0.36_wp, 0.0_wp, "tbutylbenzene")
   case("tetrachloroethene")
      data = solvent_data(2.268_wp, 1.5053_wp, 0.0_wp, 0.0_wp, 45.19_wp, 0.0_wp, 0.444889_wp, "tetrachloroethene")
   case("tetrahydrofuran","thf")
      data = solvent_data(7.4257_wp, 1.405_wp, 0.0_wp, 0.48_wp, 39.44_wp, 0.0_wp, 0.0_wp, "tetrahydrofuran")
   case("tetrahydrothiophenedioxide")
      data = solvent_data(43.9622_wp, 1.4833_wp, 0.0_wp, 0.88_wp, 87.49_wp, 0.0_wp, 0.0_wp, "tetrahydrothiophenedioxide")
   case("tetralin")
      data = solvent_data(2.771_wp, 1.5413_wp, 0.0_wp, 0.19_wp, 47.74_wp, 0.36_wp, 0.0_wp, "tetralin")
   case("toluene")
      data = solvent_data(2.3741_wp, 1.4961_wp, 0.0_wp, 0.14_wp, 40.2_wp, 0.734449_wp, 0.0_wp, "toluene")
   case("tributylphosphate")
      data = solvent_data(8.1781_wp, 1.4224_wp, 0.0_wp, 1.21_wp, 27.55_wp, 0.0_wp, 0.0_wp, "tributylphosphate")
   case("triethylamine")
      data = solvent_data(2.3832_wp, 1.401_wp, 0.0_wp, 0.79_wp, 29.1_wp, 0.0_wp, 0.0_wp, "triethylamine")
   case("trimethylbenzene")
      data = solvent_data(2.3653_wp, 1.5048_wp, 0.0_wp, 0.19_wp, 42.03_wp, 0.444889_wp, 0.0_wp, "trimethylbenzene")
   case("undecane")
      data = solvent_data(1.991_wp, 1.4398_wp, 0.0_wp, 0.0_wp, 34.85_wp, 0.0_wp, 0.0_wp, "undecane")
   case("water","h2o")
      data = solvent_data(78.36_wp, 1.3328_wp, 0.82_wp, 0.35_wp, 103.62_wp, 0.0_wp, 0.0_wp, "water")
   case("woctanol") ! no Minnisota database entry
      data = solvent_data(9.8629_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, "woctanol")
   case("xylene")
      data = solvent_data(2.3879_wp, 1.4995_wp, 0.0_wp, 0.16_wp, 41.38_wp, 0.5625_wp, 0.0_wp, "xylene")
   end select
end function get_solvent_data

!> Convert input string to lowercase
pure function compact(str) result(lcstr)

   !> Input string
   character(len=*), intent(in) :: str

   !> Lowercase version of string
   character(len=:), allocatable :: lcstr

   integer :: ilen, i, j, iav
   integer, parameter :: offset = iachar('A') - iachar('a')

   ilen = len(str)
   lcstr = ''

   j = 0
   do i = 1, ilen
      iav = iachar(str(i:i))
      if (any(iav == [iachar('-'), iachar(','), iachar(' ')])) cycle
      j = j + 1
      if (iav >= iachar('A') .and. iav <= iachar('Z')) then
         lcstr = lcstr // achar(iav - offset)
      else
         lcstr = lcstr // str(i:i)
      end if
   end do
   lcstr = trim(lcstr)

end function compact

end module tblite_solvation_data

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/basis/ortho.f90
!> Provides utilities for orthonormalizing basis functions

!> Gram-Schmidt orthonormalization routines for contracted Gaussian basis functions
module tblite_basis_ortho
   use mctc_env, only : wp
   use mctc_io_constants, only : pi
   use tblite_basis_type, only : cgto_type
   implicit none
   private

   public :: orthogonalize


contains

!> Orthogonalize a contracted Gaussian basis function to an existing basis function
pure subroutine orthogonalize(cgtoi, cgtoj)
   !> Existing basis function
   type(cgto_type), intent(in) :: cgtoi
   !> Basis function to orthogonalize
   type(cgto_type), intent(inout) :: cgtoj

   integer :: ipr, jpr
   real(wp) :: eab, oab, kab, overlap

   if (cgtoi%ang /= cgtoj%ang) return

   overlap = 0.0_wp
   do ipr = 1, cgtoi%nprim
      do jpr = 1, cgtoj%nprim
         eab = cgtoi%alpha(ipr) + cgtoj%alpha(jpr)
         oab = 1.0_wp / eab
         kab = sqrt(pi*oab)**3

         overlap = overlap + cgtoi%coeff(ipr) * cgtoj%coeff(jpr) * kab
      end do
   end do

   cgtoj%alpha(cgtoj%nprim+1:cgtoj%nprim+cgtoi%nprim) = cgtoi%alpha(:cgtoi%nprim)
   cgtoj%coeff(cgtoj%nprim+1:cgtoj%nprim+cgtoi%nprim) = -overlap*cgtoi%coeff(:cgtoi%nprim)
   cgtoj%nprim = cgtoj%nprim + cgtoi%nprim

   overlap = 0.0_wp
   do ipr = 1, cgtoj%nprim
      do jpr = 1, cgtoj%nprim
         eab = cgtoj%alpha(ipr) + cgtoj%alpha(jpr)
         oab = 1.0_wp / eab
         kab = sqrt(pi*oab)**3

         overlap = overlap + cgtoj%coeff(ipr) * cgtoj%coeff(jpr) * kab
      end do
   end do

   cgtoj%coeff(:cgtoj%nprim) = cgtoj%coeff(:cgtoj%nprim) / sqrt(overlap)

end subroutine orthogonalize

end module tblite_basis_ortho

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

module dftd4_data_r4r2
   use mctc_env, only : wp
   use mctc_io_convert, only : aatoau
   use mctc_io_symbols, only : to_number
   implicit none
   private

   public :: get_r4r2_val


   !> Get r4/r2 expectation value
   interface get_r4r2_val
      module procedure :: get_r4r2_val_num
      module procedure :: get_r4r2_val_sym
   end interface get_r4r2_val


   integer, parameter :: max_elem = 118

   !  PBE0/def2-QZVP atomic values calculated by S. Grimme in Gaussian (2010)
   !  rare gases recalculated by J. Mewes with PBE0/aug-cc-pVQZ in Dirac (2018)
   !  He: 3.4698 -> 3.5544, Ne: 3.1036 -> 3.7943, Ar: 5.6004 -> 5.6638,
   !  Kr: 6.1971 -> 6.2312, Xe: 7.5152 -> 8.8367
   !  not replaced but recalculated (PBE0/cc-pVQZ) were
   !   H: 8.0589 ->10.9359, Li:29.0974 ->39.7226, Be:14.8517 ->17.7460
   !  also new super heavies Cn,Nh,Fl,Lv,Og
   !  Am-Rg calculated at 4c-PBE/Dyall-AE4Z (Dirac 2022)
   real(wp), parameter :: r4_over_r2(max_elem) = [  &
      &  8.0589_wp, 3.4698_wp, & ! H,He
      & 29.0974_wp,14.8517_wp,11.8799_wp, 7.8715_wp, 5.5588_wp, 4.7566_wp, 3.8025_wp, 3.1036_wp, & ! Li-Ne
      & 26.1552_wp,17.2304_wp,17.7210_wp,12.7442_wp, 9.5361_wp, 8.1652_wp, 6.7463_wp, 5.6004_wp, & ! Na-Ar
      & 29.2012_wp,22.3934_wp, & ! K,Ca
      &           19.0598_wp,16.8590_wp,15.4023_wp,12.5589_wp,13.4788_wp, & ! Sc-
      &           12.2309_wp,11.2809_wp,10.5569_wp,10.1428_wp, 9.4907_wp, & ! -Zn
      &                      13.4606_wp,10.8544_wp, 8.9386_wp, 8.1350_wp, 7.1251_wp, 6.1971_wp, & ! Ga-Kr
      & 30.0162_wp,24.4103_wp, & ! Rb,Sr
      &            20.3537_wp,17.4780_wp,13.5528_wp,11.8451_wp,11.0355_wp, & ! Y-
      &            10.1997_wp, 9.5414_wp, 9.0061_wp, 8.6417_wp, 8.9975_wp, & ! -Cd
      &                       14.0834_wp,11.8333_wp,10.0179_wp, 9.3844_wp, 8.4110_wp, 7.5152_wp, & ! In-Xe
      & 32.7622_wp,27.5708_wp, & ! Cs,Ba
      &            23.1671_wp,21.6003_wp,20.9615_wp,20.4562_wp,20.1010_wp,19.7475_wp,19.4828_wp, & ! La-Eu
      &            15.6013_wp,19.2362_wp,17.4717_wp,17.8321_wp,17.4237_wp,17.1954_wp,17.1631_wp, & ! Gd-Yb
      &            14.5716_wp,15.8758_wp,13.8989_wp,12.4834_wp,11.4421_wp, & ! Lu-
      &            10.2671_wp, 8.3549_wp, 7.8496_wp, 7.3278_wp, 7.4820_wp, & ! -Hg
      &                       13.5124_wp,11.6554_wp,10.0959_wp, 9.7340_wp, 8.8584_wp, 8.0125_wp, & ! Tl-Rn
      & 29.8135_wp,26.3157_wp, & ! Fr,Ra
      &            19.1885_wp,15.8542_wp,16.1305_wp,15.6161_wp,15.1226_wp,16.1576_wp,14.6510_wp, & ! Ac-Am
      &            14.7178_wp,13.9108_wp,13.5623_wp,13.2326_wp,12.9189_wp,12.6133_wp,12.3142_wp, & ! Cm-No
      &            14.8326_wp,12.3771_wp,10.6378_wp, 9.3638_wp, 8.2297_wp, & ! Lr-
      &             7.5667_wp, 6.9456_wp, 6.3946_wp, 5.9159_wp, 5.4929_wp, & ! -Cn
      &                        6.7286_wp, 6.5144_wp,10.9169_wp,10.3600_wp, 9.4723_wp, 8.6641_wp ] ! Nh-Og

   integer :: idum
   real(wp), parameter :: sqrt_z_r4_over_r2(max_elem) = &
      &  sqrt(0.5_wp*(r4_over_r2*[(sqrt(real(idum,wp)),idum=1,max_elem)]))


contains


!> Get r4/r2 expectation value for a given element symbol
elemental function get_r4r2_val_sym(sym) result(rad)

   !> Element symbol
   character(len=*), intent(in) :: sym

   !> r4/r2 expectation value
   real(wp) :: rad

   rad = get_r4r2_val(to_number(sym))

end function get_r4r2_val_sym


!> Get r4/r2 expectation value for a given atomic number
elemental function get_r4r2_val_num(num) result(rad)

   !> Atomic number
   integer, intent(in) :: num

   !> r4/r2 expectation value
   real(wp) :: rad

   if (num > 0 .and. num <= size(sqrt_z_r4_over_r2)) then
      rad = sqrt_z_r4_over_r2(num)
   else
      rad = 0.0_wp
   end if

end function get_r4r2_val_num


end module dftd4_data_r4r2

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/io/data/hdf5.f90
!> Provides HDF5 data handling capabilities for tblite

!> Implementation of HDF5 data handler
module tblite_io_data_hdf5
   use mctc_env, only: dp, i4, error_type, fatal_error
   use tblite_io_data_type, only: iodata_type, iodata_record
   use tblite_io_hdf5, only : get_hdf5_descriptor, list_hdf5_datasets, load_hdf5, save_hdf5
   implicit none
   private

   type, extends(iodata_type), public :: hdf5_data
      !> HDF5 file name handled by this backend
      character(len=:), allocatable :: filename
   contains
      !> List logical datasets stored in the HDF5 file.
      procedure :: list
      !> Get the shape of a logical dataset.
      procedure :: get_shape
      !> Load an integer rank-1 dataset.
      procedure :: load_i4_r1
      !> Load a real rank-1 dataset.
      procedure :: load_rdp_r1
      !> Load a real rank-2 dataset.
      procedure :: load_rdp_r2
      !> Load a real rank-3 dataset.
      procedure :: load_rdp_r3
      !> Save an integer rank-1 dataset.
      procedure :: save_i4_r1
      !> Save a real rank-1 dataset.
      procedure :: save_rdp_r1
      !> Save a real rank-2 dataset.
      procedure :: save_rdp_r2
      !> Save a real rank-3 dataset.
      procedure :: save_rdp_r3
   end type hdf5_data

contains

subroutine list(self, datasets, error)
   !> HDF5 backend instance
   class(hdf5_data), intent(in) :: self
   !> Logical dataset records found in the file
   type(iodata_record), allocatable, intent(out) :: datasets(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat, irec
   character(len=:), allocatable :: msg, paths(:)

   call list_hdf5_datasets(self%filename, paths, stat, msg)
   if (stat /= 0) then
      if (.not.allocated(msg)) msg = "Failed to read HDF5 file '"//self%filename//"'"
      call fatal_error(error, msg)
      return
   end if
   if (.not.allocated(paths)) then
      call fatal_error(error, "No records found in file '"//self%filename//"'")
      return
   end if

   allocate(datasets(size(paths)))
   do irec = 1, size(paths)
      block
         character(len=:), allocatable :: path
         path = trim(paths(irec))
         datasets(irec)%name = path
      end block
   end do
end subroutine list

subroutine get_shape(self, dataset, shape, error)
   !> HDF5 backend instance
   class(hdf5_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Dataset shape
   integer, allocatable, intent(out) :: shape(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call get_hdf5_descriptor(self%filename, dataset, shape, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to read descriptor for dataset '"//dataset//"' from HDF5 file '"//self%filename//"': "//msg)
      return
   end if
end subroutine get_shape

subroutine load_i4_r1(self, dataset, data, error)
   !> HDF5 backend instance
   class(hdf5_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data loaded from the dataset
   integer(i4), allocatable, intent(out) :: data(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call load_hdf5(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to load dataset '"//dataset//"' from HDF5 file '"//self%filename//"': "//msg)
   end if
end subroutine load_i4_r1

subroutine load_rdp_r1(self, dataset, data, error)
   !> HDF5 backend instance
   class(hdf5_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data loaded from the dataset
   real(dp), allocatable, intent(out) :: data(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call load_hdf5(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to load dataset '"//dataset//"' from HDF5 file '"//self%filename//"': "//msg)
   end if
end subroutine load_rdp_r1

subroutine load_rdp_r2(self, dataset, data, error)
   !> HDF5 backend instance
   class(hdf5_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data loaded from the dataset
   real(dp), allocatable, intent(out) :: data(:,:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call load_hdf5(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to load dataset '"//dataset//"' from HDF5 file '"//self%filename//"': "//msg)
   end if
end subroutine load_rdp_r2

subroutine load_rdp_r3(self, dataset, data, error)
   !> HDF5 backend instance
   class(hdf5_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data loaded from the dataset
   real(dp), allocatable, intent(out) :: data(:,:,:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call load_hdf5(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to load dataset '"//dataset//"' from HDF5 file '"//self%filename//"': "//msg)
   end if
end subroutine load_rdp_r3

subroutine save_i4_r1(self, dataset, data, error)
   !> HDF5 backend instance
   class(hdf5_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data to save
   integer(i4), allocatable, intent(in) :: data(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call save_hdf5(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to save dataset '"//dataset//"' to HDF5 file '"//self%filename//"': "//msg)
   end if
end subroutine save_i4_r1

subroutine save_rdp_r1(self, dataset, data, error)
   !> HDF5 backend instance
   class(hdf5_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data to save
   real(dp), allocatable, intent(in) :: data(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call save_hdf5(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to save dataset '"//dataset//"' to HDF5 file '"//self%filename//"': "//msg)
   end if
end subroutine save_rdp_r1

subroutine save_rdp_r2(self, dataset, data, error)
   !> HDF5 backend instance
   class(hdf5_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data to save
   real(dp), allocatable, intent(in) :: data(:,:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call save_hdf5(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to save dataset '"//dataset//"' to HDF5 file '"//self%filename//"': "//msg)
   end if
end subroutine save_rdp_r2

subroutine save_rdp_r3(self, dataset, data, error)
   !> HDF5 backend instance
   class(hdf5_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data to save
   real(dp), allocatable, intent(in) :: data(:,:,:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg
   call save_hdf5(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to save dataset '"//dataset//"' to HDF5 file '"//self%filename//"': "//msg)
   end if
end subroutine save_rdp_r3

end module tblite_io_data_hdf5

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/solvation/data/alpb
!> Provides solvent specific data for the ALPB/GBSA solvation models

!> @file tblite/solvationdata/alpb.f90
!> Provides ALPB/GBSA parameters

!> ALPB/GBSA parameters
module tblite_solvation_data_alpb
   use mctc_env, only : error_type, fatal_error
   use mctc_env, only : wp
   use tblite_solvation_alpb, only: alpb_input
   use tblite_solvation_data, only : get_vdw_rad_d3
   use mctc_io, only : structure_type
   use mctc_io_convert, only : aatoau
   implicit none
   private

   public :: get_alpb_param!, get_alpb_solvents

   !> Parameters for ALPB solvation term
   type :: alpb_parameter
      !> Dielectric constant of the solvent
      real(wp) :: epsv = 0.0_wp
      !> Scaling of Born radii
      real(wp) :: c1 = 0.0_wp
      !> Born offset parameter
      real(wp) :: soset = 0.0_wp
      !> Descreening parameter
      real(wp) :: sx(94) = 0.0_wp
   end type alpb_parameter

   include 'alpb/param_gbsa_acetone.fh'
   include 'alpb/param_gbsa_acetonitrile.fh'
   include 'alpb/param_gbsa_benzene.fh'
   include 'alpb/param_gbsa_ch2cl2.fh'
   include 'alpb/param_gbsa_chcl3.fh'
   include 'alpb/param_gbsa_cs2.fh'
   include 'alpb/param_gbsa_dmf.fh'
   include 'alpb/param_gbsa_dmso.fh'
   include 'alpb/param_gbsa_ether.fh'
   include 'alpb/param_gbsa_hexane.fh'
   include 'alpb/param_gbsa_methanol.fh'
   include 'alpb/param_gbsa_thf.fh'
   include 'alpb/param_gbsa_toluene.fh'   
   include 'alpb/param_gbsa_water.fh'

   include 'alpb/param_alpb_acetone.fh'
   include 'alpb/param_alpb_acetonitrile.fh'
   include 'alpb/param_alpb_aniline.fh'
   include 'alpb/param_alpb_benzaldehyde.fh'
   include 'alpb/param_alpb_benzene.fh'
   include 'alpb/param_alpb_ch2cl2.fh'
   include 'alpb/param_alpb_chcl3.fh'
   include 'alpb/param_alpb_cs2.fh'
   include 'alpb/param_alpb_dioxane.fh'
   include 'alpb/param_alpb_dmf.fh'
   include 'alpb/param_alpb_dmso.fh'
   include 'alpb/param_alpb_ethanol.fh'
   include 'alpb/param_alpb_ether.fh'
   include 'alpb/param_alpb_ethylacetate.fh'
   include 'alpb/param_alpb_furane.fh'
   include 'alpb/param_alpb_hexadecane.fh'
   include 'alpb/param_alpb_hexane.fh'
   include 'alpb/param_alpb_nitromethane.fh'
   include 'alpb/param_alpb_methanol.fh'
   include 'alpb/param_alpb_octanol.fh'
   include 'alpb/param_alpb_phenol.fh'
   include 'alpb/param_alpb_thf.fh'
   include 'alpb/param_alpb_toluene.fh'
   include 'alpb/param_alpb_water.fh'
   include 'alpb/param_alpb_woctanol.fh'

contains

!> Get ALPB/GBSA parameters
subroutine get_alpb_param(input, mol, method, error)
   !> Input of ALPB
   type(alpb_input), intent(inout) :: input
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Method for parameter selection
   character(len=*), intent(in) :: method
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Internal parameters to be used
   type(alpb_parameter), allocatable :: param

   select case(input%alpb)
   case(.false.)
      if (method == 'gfn2') then
         select case(input%solvent)
         case('acetone');      param = gfn2_acetone
         case('acetonitrile'); param = gfn2_acetonitrile
         case('benzene');      param = gfn2_benzene
         case('ch2cl2','dichlormethane','methylenechloride');
            param = gfn2_ch2cl2
         case('chcl3','chloroform');       param = gfn2_chcl3
         case('cs2','carbondisulfide');    param = gfn2_cs2
         case('dmf','dimethylformamide');  param = gfn2_dmf
         case('dmso','dimethylsulfoxide'); param = gfn2_dmso
         case('ether','diethylether');     param = gfn2_ether
         case('hexane','nhexan','n-hexan','nhexane','n-hexane');
            param = gfn2_hexane
         case('methanol');                 param = gfn2_methanol
         case('thf','tetrahydrofuran');    param = gfn2_thf
         case('toluene');                  param = gfn2_toluene
         case('water','h2o');              param = gfn2_water
         end select
      else if (method == 'gfn1') then
         select case(input%solvent)
         case('acetone');      param = gfn1_acetone
         case('acetonitrile'); param = gfn1_acetonitrile
         case('benzene');      param = gfn1_benzene
         case('ch2cl2','dichlormethane','methylenechloride');
            param = gfn1_ch2cl2
         case('chcl3','chloroform');       param = gfn1_chcl3
         case('cs2','carbondisulfide');    param = gfn1_cs2
         case('dmso','dimethylsulfoxide'); param = gfn1_dmso
         case('ether','diethylether');     param = gfn1_ether
         case('methanol');                 param = gfn1_methanol
         case('thf','tetrahydrofuran');    param = gfn1_thf
         case('toluene');                  param = gfn1_toluene
         case('water','h2o');              param = gfn1_water
         end select
      end if
   case(.true.)
      if (method == 'gfn2') then
         select case(input%solvent)
         case('acetone');      param = gfn2_alpb_acetone
         case('acetonitrile'); param = gfn2_alpb_acetonitrile
         case('aniline');      param = gfn2_alpb_aniline
         case('benzaldehyde'); param = gfn2_alpb_benzaldehyde
         case('benzene');      param = gfn2_alpb_benzene
         case('ch2cl2','dichlormethane','methylenechloride'); 
            param = gfn2_alpb_ch2cl2
         case('chcl3','chloroform');       param = gfn2_alpb_chcl3
         case('cs2','carbondisulfide');    param = gfn2_alpb_cs2
         case('dioxane');      param = gfn2_alpb_dioxane
         case('dmf','dimethylformamide');  param = gfn2_alpb_dmf
         case('dmso','dimethylsulfoxide'); param = gfn2_alpb_dmso
         case('ethanol');      param = gfn2_alpb_ethanol
         case('ether','diethylether');     param = gfn2_alpb_ether
         case('ethylacetate'); param = gfn2_alpb_ethylacetate
         case('furane');       param = gfn2_alpb_furane
         case('hexadecane');   param = gfn2_alpb_hexadecane
         case('hexane','nhexan','n-hexan','nhexane','n-hexane');
            param = gfn2_alpb_hexane
         case('nitromethane'); param = gfn2_alpb_nitromethane
         case('methanol');     param = gfn2_alpb_methanol 
         case('octanol');      param = gfn2_alpb_octanol
         case('phenol');       param = gfn2_alpb_phenol 
         case('thf','tetrahydrofuran');    param = gfn2_alpb_thf
         case('toluene');      param = gfn2_alpb_toluene
         case('water','h2o');  param = gfn2_alpb_water
         case('woctanol');     param = gfn2_alpb_woctanol
         end select
      else if (method == 'gfn1') then
         select case(input%solvent)
         case('acetone');      param = gfn1_alpb_acetone
         case('acetonitrile'); param = gfn1_alpb_acetonitrile
         case('aniline');      param = gfn1_alpb_aniline
         case('benzaldehyde'); param = gfn1_alpb_benzaldehyde
         case('benzene');      param = gfn1_alpb_benzene
         case('ch2cl2','dichlormethane','methylenechloride');
            param = gfn1_alpb_ch2cl2
         case('chcl3','chloroform');       param = gfn1_alpb_chcl3
         case('cs2','carbondisulfide');    param = gfn1_alpb_cs2
         case('dioxane');      param = gfn1_alpb_dioxane
         case('dmf','dimethylformamide');  param = gfn1_alpb_dmf
         case('dmso','dimethylsulfoxide'); param = gfn1_alpb_dmso
         case('ethanol');      param = gfn1_alpb_ethanol
         case('ether','diethylether');     param = gfn1_alpb_ether
         case('ethylacetate'); param = gfn1_alpb_ethylacetate
         case('furane');       param = gfn1_alpb_furane
         case('hexadecane');   param = gfn1_alpb_hexadecane
         case('hexane','nhexan','n-hexan','nhexane','n-hexane');
            param = gfn1_alpb_hexane
         case('nitromethane'); param = gfn1_alpb_nitromethane
         case('methanol');     param = gfn1_alpb_methanol
         case('octanol');      param = gfn1_alpb_octanol
         case('phenol');       param = gfn1_alpb_phenol 
         case('thf','tetrahydrofuran');    param = gfn1_alpb_thf
         case('toluene');      param = gfn1_alpb_toluene
         case('water','h2o');  param = gfn1_alpb_water
         case('woctanol');     param = gfn1_alpb_woctanol
         end select
      end if
   end select

   if (.not.allocated(param)) then
      call fatal_error(error, "Unknown solvent, cannot set up ALPB/GBSA parameters")
      return
   end if

   call load_alpb_param(input, mol, param)

end subroutine get_alpb_param

!> Get ALPB/GBSA parameters
subroutine load_alpb_param(input, mol, param)
   !> Input of ALPB
   type(alpb_input), intent(inout) :: input
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Internal parameters to be used
   type(alpb_parameter), intent(in) :: param

   input%born_scale = param%c1

   input%born_offset = param%soset * 0.1_wp * aatoau

   input%dielectric_const = param%epsv

   if (.not. allocated(input%descreening)) then
      allocate(input%descreening(mol%nid))
   end if

   input%descreening = param%sx(mol%num)

   input%rvdw = get_vdw_rad_d3(mol%num)

end subroutine load_alpb_param

end module tblite_solvation_data_alpb

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Implementation of a serializer for TOML values to JSON, used for testing only.
module tjson_ser
   use tomlf_constants
   use tomlf_datetime
   use tomlf_type, only : toml_value, toml_visitor, toml_key, toml_table, &
      & toml_array, toml_keyval, is_array_of_tables, len
   implicit none
   private

   public :: json_serializer


   !> Serializer to produduce a JSON document from a TOML datastructure
   type, extends(toml_visitor) :: json_serializer

      !> Unit for output
      integer :: unit = tfout

      !> Indentation
      character(len=:), allocatable :: indentation

      !> Current depth in the tree
      integer :: depth = 0

   contains

      !> Visit a TOML value
      procedure :: visit

   end type json_serializer


contains


!> Visit a TOML value
subroutine visit(self, val)

   !> Instance of the JSON serializer
   class(json_serializer), intent(inout) :: self

   !> TOML value to visit
   class(toml_value), intent(inout) :: val

   select type(val)
   class is(toml_keyval)
      call visit_keyval(self, val)
   class is(toml_array)
      call visit_array(self, val)
   class is(toml_table)
      call visit_table(self, val)
   end select

end subroutine visit


!> Visit a TOML key-value pair
subroutine visit_keyval(visitor, keyval)

   !> Instance of the JSON serializer
   class(json_serializer), intent(inout) :: visitor

   !> TOML value to visit
   type(toml_keyval), intent(inout) :: keyval

   character(kind=tfc, len=:), allocatable :: str, key
   character(kind=tfc, len=:), pointer :: sdummy
   type(toml_datetime), pointer :: ts
   integer(tfi), pointer :: idummy
   real(tfr), pointer :: fdummy
   logical, pointer :: ldummy

   call indent(visitor)

   if (allocated(keyval%key)) then
      call escape_string(keyval%key, key)
      write(visitor%unit, '("""", a, """: ")', advance='no') key
   end if

   select case(keyval%get_type())
   case default
      write(visitor%unit, '(a)', advance='no') &
         &  '{}'

   case(toml_type%string)
      call keyval%get(sdummy)
      call escape_string(sdummy, str)
      write(visitor%unit, '(a,a,a)', advance='no') &
         &  '{"type": "string", "value": "', str, '"}'

   case(toml_type%boolean)
      call keyval%get(ldummy)
      if (ldummy) then
         write(visitor%unit, '(a)', advance='no') &
            &  '{"type": "bool", "value": "true"}'
      else
         write(visitor%unit, '(a)', advance='no') &
            &  '{"type": "bool", "value": "false"}'
      end if

   case(toml_type%int)
      call keyval%get(idummy)
      write(visitor%unit, '(a,i0,a)', advance='no') &
         &  '{"type": "integer", "value": "', idummy, '"}'

   case(toml_type%float)
      call keyval%get(fdummy)
      write(visitor%unit, '(a)', advance='no') &
         &  '{"type": "float", "value": "'
      if (fdummy > huge(fdummy)) then
         write(visitor%unit, '(a)', advance='no') "+inf"
      else if (fdummy < -huge(fdummy)) then
         write(visitor%unit, '(a)', advance='no') "-inf"
      else if (fdummy /= fdummy) then
         write(visitor%unit, '(a)', advance='no') "nan"
      else
         write(visitor%unit, '(g0)', advance='no') fdummy
      end if
      write(visitor%unit, '(a)', advance='no') '"}'

   case(toml_type%datetime)
      call keyval%get(ts)
      write(visitor%unit, '(a)', advance='no') '{"type": "'
      if (has_date(ts)) write(visitor%unit, '(a)', advance='no') 'date'
      if (has_time(ts)) then
         write(visitor%unit, '(a)', advance='no') 'time'
         if (.not.allocated(ts%time%zone)) then
            write(visitor%unit, '(a)', advance='no') '-local'
         end if
      else
         write(visitor%unit, '(a)', advance='no') '-local'
      end if
      str = to_string(ts)
      write(visitor%unit, '(a,a,a)', advance='no') &
         &  '", "value": "', str, '"}'

   end select

end subroutine visit_keyval


!> Visit a TOML array
subroutine visit_array(visitor, array)

   !> Instance of the JSON serializer
   class(json_serializer), intent(inout) :: visitor

   !> TOML value to visit
   type(toml_array), intent(inout) :: array

   class(toml_value), pointer :: ptr
   character(kind=tfc, len=:), allocatable :: key
   integer :: i, n

   call indent(visitor)

   if (allocated(array%key)) then
      call escape_string(array%key, key)
      write(visitor%unit, '("""",a,""": ")', advance='no') key
   end if

   write(visitor%unit, '("[")', advance='no')
   visitor%depth = visitor%depth + 1
   n = len(array)
   do i = 1, n
      call array%get(i, ptr)
      call ptr%accept(visitor)
      if (i /= n) write(visitor%unit, '(",")', advance='no')
   end do
   visitor%depth = visitor%depth - 1
   call indent(visitor)
   write(visitor%unit, '("]")', advance='no')

end subroutine visit_array


!> Visit a TOML table
subroutine visit_table(visitor, table)

   !> Instance of the JSON serializer
   class(json_serializer), intent(inout) :: visitor

   !> TOML table to visit
   type(toml_table), intent(inout) :: table

   class(toml_value), pointer :: ptr
   type(toml_key), allocatable :: list(:)
   character(kind=tfc, len=:), allocatable :: key
   integer :: i, n

   call indent(visitor)

   if (allocated(table%key)) then
      call escape_string(table%key, key)
      write(visitor%unit, '("""",a,""": ")', advance='no') key
   end if

   write(visitor%unit, '("{")', advance='no')
   visitor%depth = visitor%depth + 1

   call table%get_keys(list)

   n = size(list, 1)
   do i = 1, n
      call table%get(list(i)%key, ptr)
      call ptr%accept(visitor)
      if (i /= n) write(visitor%unit, '(",")', advance='no')
   end do

   visitor%depth = visitor%depth - 1
   call indent(visitor)
   if (visitor%depth == 0) then
      if (allocated(visitor%indentation)) write(visitor%unit, '(a)')
      write(visitor%unit, '("}")')
   else
      write(visitor%unit, '("}")', advance='no')
   endif

end subroutine visit_table


!> Produce indentations for emitted JSON documents
subroutine indent(self)

   !> Instance of the JSON serializer
   class(json_serializer), intent(inout) :: self

   integer :: i

   ! PGI internal compiler error in NVHPC 20.7 and 20.9 with
   ! write(self%unit, '(/, a)', advance='no') repeat(self%indentation, self%depth)
   ! causes: NVFORTRAN-F-0000-Internal compiler error. Errors in Lowering      16
   if (allocated(self%indentation) .and. self%depth > 0) then
      write(self%unit, '(/)', advance='no')
      do i = 1, self%depth
         write(self%unit, '(a)', advance='no') self%indentation
      end do
   end if

end subroutine indent


!> Transform a TOML raw value to a JSON compatible escaped string
subroutine escape_string(raw, escaped)

   !> Raw value of TOML value
   character(len=*), intent(in) :: raw

   !> JSON compatible escaped string
   character(len=:), allocatable, intent(out) :: escaped

   integer :: i, code
   character(len=2) :: hex

   escaped = ''
   do i = 1, len(raw)
      code = iachar(raw(i:i))
      select case(raw(i:i))
      case default
         if (code < 32 .or. code == 127) then
            write(hex, '(z2.2)') code
            if (hex(1:1) >= 'A' .and. hex(1:1) <= 'F') hex(1:1) = achar(iachar(hex(1:1)) + 32)
            if (hex(2:2) >= 'A' .and. hex(2:2) <= 'F') hex(2:2) = achar(iachar(hex(2:2)) + 32)
            escaped = escaped // '\u00' // hex
         else
            escaped = escaped // raw(i:i)
         end if
      case('\'); escaped = escaped // '\\'
      case('"'); escaped = escaped // '\"'
      case(TOML_NEWLINE); escaped = escaped // '\n'
      case(TOML_FORMFEED); escaped = escaped // '\f'
      case(TOML_CARRIAGE_RETURN); escaped = escaped // '\r'
      case(TOML_TABULATOR); escaped = escaped // '\t'
      case(TOML_BACKSPACE); escaped = escaped // '\b'
      end select
   end do

end subroutine escape_string


end module tjson_ser

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3_cutoff
   use mctc_env, only : wp
   implicit none

   public :: realspace_cutoff, get_lattice_points, smooth_cutoff


   !> Coordination number cutoff
   real(wp), parameter :: cn_default = 40.0_wp

   !> Two-body interaction cutoff
   real(wp), parameter :: disp2_default = 60.0_wp

   !> Three-body interaction cutoff
   real(wp), parameter :: disp3_default = 40.0_wp

   !> Counter-poise correction cutoff
   real(wp), parameter :: gcp_default = 60.0_wp

   !> Short-range bond correction cutoff
   real(wp), parameter :: srb_default = 60.0_wp


   !> Collection of real space cutoffs
   type :: realspace_cutoff
      sequence

      !> Coordination number cutoff
      real(wp) :: cn = cn_default

      !> Two-body interaction cutoff
      real(wp) :: disp2 = disp2_default

      !> Three-body interaction cutoff
      real(wp) :: disp3 = disp3_default

      !> Width of smooth two-body interaction cutoff
      real(wp) :: width2 = 0.0_wp

      !> Width of smooth three-body interaction cutoff
      real(wp) :: width3 = 0.0_wp

      !> Counter-poise correction cutoff
      real(wp) :: gcp = gcp_default

      !> Short-range bond correction cutoff
      real(wp) :: srb = srb_default

   end type realspace_cutoff


contains


!> Smooth polynomial switch for realspace cutoffs
pure subroutine smooth_cutoff(r, cutoff, width, sw, dswdr)
   real(wp), intent(in) :: r
   real(wp), intent(in) :: cutoff
   real(wp), intent(in) :: width
   real(wp), intent(out) :: sw
   real(wp), intent(out) :: dswdr

   real(wp) :: inner, x

   if (width <= 0.0_wp .or. width >= cutoff) then
      sw = 1.0_wp
      dswdr = 0.0_wp
   else
      inner = cutoff - width
      if (r <= inner) then
         sw = 1.0_wp
         dswdr = 0.0_wp
      else if (r >= cutoff) then
         sw = 0.0_wp
         dswdr = 0.0_wp
      else
         x = (cutoff - r) / width
         sw = x**3 * (10.0_wp + x*(-15.0_wp + 6.0_wp*x))
         dswdr = -30.0_wp * x**2 * (1.0_wp - x)**2 / width
      end if
   end if
end subroutine smooth_cutoff


subroutine get_lattice_points(periodic, lat, rthr, trans)
   logical, intent(in) :: periodic(:)
   real(wp), intent(in) :: rthr
   real(wp), intent(in) :: lat(:, :)
   real(wp), allocatable, intent(out) :: trans(:, :)
   real(wp) :: vec(size(lat, 2)), norms(size(lat, 1), size(lat, 2))
   integer :: rep(3)
   integer :: itr, ix, iy, iz

   if (.not.any(periodic)) then
      allocate(trans(3, 1))
      trans(:, :) = 0.0_wp
      return
   end if

   if (all(periodic)) then
      call get_translations(lat, rthr, rep)
   else if (count(periodic) == 1) then
      vec = sqrt(sum(lat**2, 1))
      where(periodic)
         rep = ceiling(rthr / vec)
      elsewhere
         rep = 0
      endwhere
   else if (count(periodic) == 2) then
      call get_normals(lat, norms)
      where(spread(periodic, 2, 3))
         norms = lat
      endwhere
      call get_translations(norms, rthr, rep)
      where(.not.periodic)
         rep = 0
      endwhere
   end if

   allocate(trans(3, product(2*rep+1)))
   itr = 0
   do ix = -rep(1), rep(1)
      do iy = -rep(2), rep(2)
         do iz = -rep(3), rep(3)
            itr = itr + 1
            trans(:, itr) = lat(:, 1)*ix + lat(:, 2)*iy + lat(:, 3)*iz
         end do
      end do
   end do

end subroutine get_lattice_points


subroutine get_normals(lattice, normal)
   real(wp), intent(in) :: lattice(:, :)
   real(wp), intent(out) :: normal(:, :)

   integer :: itr
   do itr = 1, 3
      call crossproduct(lattice(:, mod(itr, 3) + 1), lattice(:, mod(itr + 1, 3) + 1), &
         & normal(:, itr))
   end do
end subroutine get_normals


!> generate a supercell based on a realspace cutoff, this subroutine
!  doesn't know anything about the convergence behaviour of the
!  associated property.
pure subroutine get_translations(lat, rthr, rep)
   real(wp), intent(in)  :: rthr
   real(wp), intent(in)  :: lat(3, 3)
   integer, intent(out) :: rep(3)
   real(wp) :: norm(3, 3), normy(3), normz(3)
   real(wp) :: cos10, cos21, cos32

   ! find normal to the plane...
   call crossproduct(lat(:, 2), lat(:, 3), norm(:, 1))
   call crossproduct(lat(:, 3), lat(:, 1), norm(:, 2))
   call crossproduct(lat(:, 1), lat(:, 2), norm(:, 3))
   ! ...normalize it...
   norm(:, 1) = norm(:, 1)/norm2(norm(:, 1))
   norm(:, 2) = norm(:, 2)/norm2(norm(:, 2))
   norm(:, 3) = norm(:, 3)/norm2(norm(:, 3))
   ! cos angles between normals and lattice vectors
   cos10 = sum(norm(:, 1)*lat(:, 1))
   cos21 = sum(norm(:, 2)*lat(:, 2))
   cos32 = sum(norm(:, 3)*lat(:, 3))
   rep(1) = ceiling(abs(rthr/cos10))
   rep(2) = ceiling(abs(rthr/cos21))
   rep(3) = ceiling(abs(rthr/cos32))

end subroutine get_translations

pure subroutine crossproduct(a, b, c)
   real(wp), intent(in)  :: a(3), b(3)
   real(wp), intent(out) :: c(3)
   real(wp) :: x, y, z

   x = a(2)*b(3)-b(2)*a(3)
   y = a(3)*b(1)-b(3)*a(1)
   z = a(1)*b(2)-b(1)*a(2)
   c = [x, y, z]
end subroutine crossproduct

end module dftd3_cutoff

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/toml.f90
!> Provides reexports of the [TOML Fortran](https://toml-f.readthedocs.io) modules

!> Proxy module for TOML library implementation
module tblite_toml
   use tomlf, only : toml_table, toml_array, toml_error, toml_dump, toml_parse, &
      & toml_key, get_value, set_value, add_table, add_array, len
   use tomlf_build, only : merge_table
   use tomlf_type, only : toml_value
   implicit none
   private

   public :: toml_table, toml_array, toml_error, toml_dump, toml_parse, toml_key, &
      & toml_value, len
   public :: get_value, set_value, add_table, add_array, merge_table
end module tblite_toml

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> TOML key-value pair data type
!>
!> A [[toml_keyval]] represents a single key-value pair in a TOML document.
!> It can hold any of the TOML value types: strings, integers, floats,
!> booleans, and datetimes.
!>
!> Key-value pairs are typically accessed through their parent table using
!> [[get_value]] rather than directly manipulating this type.
module tomlf_type_keyval
   use tomlf_constants, only : tfc, tfr, tfi, toml_type
   use tomlf_datetime, only : toml_datetime
   use tomlf_type_value, only : toml_value, toml_visitor
   implicit none
   private

   public :: toml_keyval, new_keyval, new


   !> Generic TOML value
   type, abstract :: generic_value
   end type generic_value

   !> TOML real value
   type, extends(generic_value) :: float_value
      real(tfr) :: raw
   end type float_value

   !> TOML integer value
   type, extends(generic_value) :: integer_value
      integer(tfi) :: raw
   end type integer_value

   !> TOML boolean value
   type, extends(generic_value) :: boolean_value
      logical :: raw
   end type boolean_value

   !> TOML datetime value
   type, extends(generic_value) :: datetime_value
      type(toml_datetime) :: raw
   end type datetime_value

   !> TOML string value
   type, extends(generic_value) :: string_value
      character(:, tfc), allocatable :: raw
   end type string_value
      


   !> TOML key-value pair
   type, extends(toml_value) :: toml_keyval

      !> Actual TOML value
      class(generic_value), allocatable :: val

      !> Origin of value
      integer :: origin_value = 0

   contains

      !> Get the value stored in the key-value pair
      generic :: get => get_float, get_integer, get_boolean, get_datetime, get_string
      procedure :: get_float
      procedure :: get_integer
      procedure :: get_boolean
      procedure :: get_datetime
      procedure :: get_string

      !> Set the value for the key-value pair
      generic :: set => set_float, set_integer, set_boolean, set_datetime, set_string
      procedure :: set_float
      procedure :: set_integer
      procedure :: set_boolean
      procedure :: set_datetime
      procedure :: set_string

      !> Get the type of the value stored in the key-value pair
      procedure :: get_type

      !> Release allocation hold by TOML key-value pair
      procedure :: destroy

   end type toml_keyval


   !> Overloaded constructor for TOML values
   interface new
      module procedure :: new_keyval
   end interface


contains


!> Constructor to create a new TOML key-value pair
subroutine new_keyval(self)

   !> Instance of the TOML key-value pair
   type(toml_keyval), intent(out) :: self

   associate(self => self); end associate

end subroutine new_keyval


!> Deconstructor to cleanup allocations (optional)
subroutine destroy(self)

   !> Instance of the TOML key-value pair
   class(toml_keyval), intent(inout) :: self

   if (allocated(self%key)) then
      deallocate(self%key)
   end if

   if (allocated(self%val)) then
      deallocate(self%val)
   end if

end subroutine destroy


!> Obtain real value from TOML key-value pair
subroutine get_float(self, val)

   !> Instance of the TOML key-value pair
   class(toml_keyval), intent(in) :: self

   !> Value to be assigned
   real(tfr), pointer, intent(out) :: val

   val => cast_float(self%val)
end subroutine get_float


!> Obtain integer value from TOML key-value pair
subroutine get_integer(self, val)

   !> Instance of the TOML key-value pair
   class(toml_keyval), intent(in) :: self

   !> Value to be assigned
   integer(tfi), pointer, intent(out) :: val

   val => cast_integer(self%val)
end subroutine get_integer


!> Obtain boolean value from TOML key-value pair
subroutine get_boolean(self, val)

   !> Instance of the TOML key-value pair
   class(toml_keyval), intent(in) :: self

   !> Value to be assigned
   logical, pointer, intent(out) :: val

   val => cast_boolean(self%val)
end subroutine get_boolean


!> Obtain datetime value from TOML key-value pair
subroutine get_datetime(self, val)

   !> Instance of the TOML key-value pair
   class(toml_keyval), intent(in) :: self

   !> Value to be assigned
   type(toml_datetime), pointer, intent(out) :: val

   val => cast_datetime(self%val)
end subroutine get_datetime


!> Obtain datetime value from TOML key-value pair
subroutine get_string(self, val)

   !> Instance of the TOML key-value pair
   class(toml_keyval), intent(in) :: self

   !> Value to be assigned
   character(:, tfc), pointer, intent(out) :: val

   val => cast_string(self%val)
end subroutine get_string


!> Obtain real value from TOML key-value pair
subroutine set_float(self, val)

   !> Instance of the TOML key-value pair
   class(toml_keyval), intent(inout) :: self

   !> Value to be assigned
   real(tfr), intent(in) :: val

   type(float_value), allocatable :: tmp

   allocate(tmp)
   tmp%raw = val
   call move_alloc(tmp, self%val)
end subroutine set_float


!> Obtain integer value from TOML key-value pair
subroutine set_integer(self, val)

   !> Instance of the TOML key-value pair
   class(toml_keyval), intent(inout) :: self

   !> Value to be assigned
   integer(tfi), intent(in) :: val

   type(integer_value), allocatable :: tmp

   allocate(tmp)
   tmp%raw = val
   call move_alloc(tmp, self%val)
end subroutine set_integer


!> Obtain boolean value from TOML key-value pair
subroutine set_boolean(self, val)

   !> Instance of the TOML key-value pair
   class(toml_keyval), intent(inout) :: self

   !> Value to be assigned
   logical, intent(in) :: val

   type(boolean_value), allocatable :: tmp

   allocate(tmp)
   tmp%raw = val
   call move_alloc(tmp, self%val)
end subroutine set_boolean


!> Obtain datetime value from TOML key-value pair
subroutine set_datetime(self, val)

   !> Instance of the TOML key-value pair
   class(toml_keyval), intent(inout) :: self

   !> Value to be assigned
   type(toml_datetime), intent(in) :: val

   type(datetime_value), allocatable :: tmp

   allocate(tmp)
   tmp%raw = val
   call move_alloc(tmp, self%val)
end subroutine set_datetime


!> Obtain datetime value from TOML key-value pair
subroutine set_string(self, val)

   !> Instance of the TOML key-value pair
   class(toml_keyval), intent(inout) :: self

   !> Value to be assigned
   character(*, tfc), intent(in) :: val

   type(string_value), allocatable :: tmp

   allocate(tmp)
   tmp%raw = val
   call move_alloc(tmp, self%val)
end subroutine set_string


!> Get the type of the value stored in the key-value pair
pure function get_type(self) result(value_type)

   !> Instance of the TOML key-value pair
   class(toml_keyval), intent(in) :: self

   !> Value type
   integer :: value_type

   select type(val => self%val)
   class default
      value_type = toml_type%invalid
   type is(float_value)
      value_type = toml_type%float
   type is(integer_value)
      value_type = toml_type%int
   type is(boolean_value)
      value_type = toml_type%boolean
   type is(datetime_value)
      value_type = toml_type%datetime
   type is(string_value)
      value_type = toml_type%string
   end select
end function get_type


function cast_float(val) result(ptr)
   class(generic_value), intent(in), target :: val
   real(tfr), pointer :: ptr

   nullify(ptr)
   select type(val)
   type is(float_value)
      ptr => val%raw
   end select
end function cast_float

function cast_integer(val) result(ptr)
   class(generic_value), intent(in), target :: val
   integer(tfi), pointer :: ptr

   nullify(ptr)
   select type(val)
   type is(integer_value)
      ptr => val%raw
   end select
end function cast_integer

function cast_boolean(val) result(ptr)
   class(generic_value), intent(in), target :: val
   logical, pointer :: ptr

   nullify(ptr)
   select type(val)
   type is(boolean_value)
      ptr => val%raw
   end select
end function cast_boolean

function cast_datetime(val) result(ptr)
   class(generic_value), intent(in), target :: val
   type(toml_datetime), pointer :: ptr

   nullify(ptr)
   select type(val)
   type is(datetime_value)
      ptr => val%raw
   end select
end function cast_datetime

function cast_string(val) result(ptr)
   class(generic_value), intent(in), target :: val
   character(:, tfc), pointer :: ptr

   nullify(ptr)
   select type(val)
   type is(string_value)
      ptr => val%raw
   end select
end function cast_string

end module tomlf_type_keyval

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Wrapper for the testsuites
program tester
   use, intrinsic :: iso_fortran_env, only : error_unit
   use testdrive, only : run_testsuite, new_testsuite, testsuite_type, &
      & select_suite, run_selected, get_argument
   use test_lexer, only : collect_lexer
   implicit none
   integer :: stat, is
   character(len=:), allocatable :: suite_name, test_name
   type(testsuite_type), allocatable :: testsuites(:)
   character(len=*), parameter :: fmt = '("#", *(1x, a))'

   stat = 0

   testsuites = [ &
      & new_testsuite("lexer", collect_lexer) &
      & ]

   call get_argument(1, suite_name)
   call get_argument(2, test_name)

   if (allocated(suite_name)) then
      is = select_suite(testsuites, suite_name)
      if (is > 0 .and. is <= size(testsuites)) then
         if (allocated(test_name)) then
            write(error_unit, fmt) "Suite:", testsuites(is)%name
            call run_selected(testsuites(is)%collect, test_name, error_unit, stat)
            if (stat < 0) then
               error stop 1
            end if
         else
            write(error_unit, fmt) "Testing:", testsuites(is)%name
            call run_testsuite(testsuites(is)%collect, error_unit, stat)
         end if
      else
         write(error_unit, fmt) "Available testsuites"
         do is = 1, size(testsuites)
            write(error_unit, fmt) "-", testsuites(is)%name
         end do
         error stop 1
      end if
   else
      do is = 1, size(testsuites)
         write(error_unit, fmt) "Testing:", testsuites(is)%name
         call run_testsuite(testsuites(is)%collect, error_unit, stat)
      end do
   end if

   if (stat > 0) then
      write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
      error stop 1
   end if
end program tester

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the driver entry points for the singlepoint runner
module tblite_driver_guess
   use, intrinsic :: iso_fortran_env, only : error_unit, input_unit
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_io, only : structure_type, read_structure, filetype
   use mctc_io_constants, only : codata
   use mctc_io_convert, only : aatoau, ctoau
   use tblite_cli, only : guess_config
   use tblite_basis_type, only : basis_type
   use tblite_container, only : container_type
   use tblite_context, only : context_type, context_terminal, escape
   use tblite_external_field, only : electric_field
   use tblite_lapack_solver, only : lapack_solver
   use tblite_output_ascii
   use tblite_wavefunction, only : wavefunction_type, new_wavefunction, &
      & sad_guess, eeq_guess, eeqbc_guess, get_molecular_dipole_moment
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_ceh_singlepoint, only : ceh_singlepoint
   use tblite_ceh_ceh, only : new_ceh_calculator

   implicit none
   private

   public :: main

   interface main
      module procedure :: guess_main
   end interface

   real(wp), parameter :: kt = 3.166808578545117e-06_wp
   real(wp), parameter :: jtoau = 1.0_wp / (codata%me*codata%c**2*codata%alpha**2)
   !> Convert V/Å = J/(C·Å) to atomic units
   real(wp), parameter :: vatoau = jtoau / (ctoau * aatoau)

contains


   subroutine guess_main(config, error)
      type(guess_config), intent(in) :: config
      type(error_type), allocatable, intent(out) :: error

      type(structure_type) :: mol
      character(len=:), allocatable :: method, filename
      integer :: unpaired, charge, unit
      real(wp) :: dpmom(3)
      type(context_type) :: ctx
      type(xtb_calculator):: calc_ceh
      type(wavefunction_type) :: wfn_ceh
      real(wp), allocatable :: qat(:)
      real(wp), allocatable :: dpat(:,:)

      ctx%terminal = context_terminal(config%color)
      ctx%solver = lapack_solver(config%solver)

      if (config%input == "-") then
         if (allocated(config%input_format)) then
            call read_structure(mol, input_unit, config%input_format, error)
         else
            call read_structure(mol, input_unit, filetype%xyz, error)
         end if
      else
         call read_structure(mol, config%input, error, config%input_format)
      end if
      if (allocated(error)) return

      if (config%grad) then
         call fatal_error(error, "Charge gradient not yet implemented.")
      end if
      if (allocated(error)) return

      if (allocated(config%charge)) then
         mol%charge = config%charge
      else
         filename = join(dirname(config%input), ".CHRG")
         if (exists(filename)) then
            call read_file(filename, charge, error)
            if (allocated(error)) return
            if (config%verbosity > 0) &
            & call info(ctx, "Molecular charge read from '"//filename//"'")
            mol%charge = charge
         end if
      end if
      if (allocated(error)) return

      if (allocated(config%spin)) then
         mol%uhf = config%spin
      else
         filename = join(dirname(config%input), ".UHF")
         if (exists(filename)) then
            call read_file(filename, unpaired, error)
            if (allocated(error)) return
            if (config%verbosity > 0) &
            & call info(ctx, "Molecular spin read from '"//filename//"'")
            mol%uhf = unpaired
         end if
      end if
      if (allocated(error)) return

      method = "ceh"
      if (allocated(config%method)) method = config%method
      if (method == "ceh") then
         call new_ceh_calculator(calc_ceh, mol, error)
         if (allocated(error)) return
         call new_wavefunction(wfn_ceh, mol%nat, calc_ceh%bas%nsh, calc_ceh%bas%nao, 1, config%etemp_guess * kt)
      end if

      if (allocated(config%efield) .and. config%method == "ceh") then
         block
            class(container_type), allocatable :: cont
            cont = electric_field(config%efield*vatoau)
            call calc_ceh%push_back(cont)
         end block
      end if

      if (config%verbosity > 0) then
         select case(method)
         case default
            call fatal_error(error, "Unknown method '"//method//"' requested")
         case("sad")
            call ctx%message("Superposition of atomic densities (SAD) guess")
            call ctx%message("")
         case("eeq")
            call ctx%message("Electronegativity equilibration (EEQ) guess")
            call ctx%message("")
         case("eeqbc")
            call ctx%message("Bond Capacity electronegativity equilibration (EEQ) guess")
            call ctx%message("")
         case("ceh")
            call ctx%message(calc_ceh%info(config%verbosity, " | "))
         end select
      end if

      allocate(qat(mol%nat), dpat(3, mol%nat), source=0.0_wp)
      select case(method)
      case default
         call fatal_error(error, "Unknown method '"//method//"' requested")
      case("sad")
         call sad_guess(mol, qat, dpat)
      case("eeq")
         call eeq_guess(mol, qat, dpat, error)
      case("eeqbc")
         call eeqbc_guess(mol, qat, dpat, error)
      case("ceh")
         call ceh_singlepoint(ctx, calc_ceh, mol, wfn_ceh, config%accuracy, config%verbosity)
         if (ctx%failed()) then
            call fatal(ctx, "CEH singlepoint calculation failed")
            do while(ctx%failed())
               call ctx%get_error(error)
               write(error_unit, '("->", 1x, a)') error%message
            end do
            error stop
         end if
         qat = wfn_ceh%qat(:, 1)
         dpat = wfn_ceh%dpat(:, :, 1)
      end select
      if (allocated(error)) return

      call get_molecular_dipole_moment(mol, qat, dpat, dpmom)
      call ascii_atomic_charges(ctx%unit, 1, mol, qat)
      call ascii_dipole_moments(ctx%unit, 1, mol, dpat, dpmom)

      if (config%json) then
         open(file=config%json_output, newunit=unit)
         call json_results(unit, "  ", charges=qat)
         close(unit)
         if (config%verbosity > 0) then
            call info(ctx, "JSON dump of results written to '"//config%json_output//"'")
         end if
      end if
   end subroutine guess_main


   subroutine info(ctx, message)
      type(context_type), intent(inout) :: ctx
      character(len=*), intent(in) :: message

      call ctx%message( &
      & escape(ctx%terminal%bold) // "[" // &
      & escape(ctx%terminal%bold_cyan) // "Info" // &
      & escape(ctx%terminal%bold) // "]" // &
      & escape(ctx%terminal%reset) // " " // &
      & message)
   end subroutine info


   subroutine warn(ctx, message)
      type(context_type), intent(inout) :: ctx
      character(len=*), intent(in) :: message

      call ctx%message( &
      & escape(ctx%terminal%bold) // "[" // &
      & escape(ctx%terminal%bold_yellow) // "Warn" // &
      & escape(ctx%terminal%bold) // "]" // &
      & escape(ctx%terminal%reset) // " " // &
      & message)
   end subroutine warn


   subroutine fatal(ctx, message)
      type(context_type), intent(inout) :: ctx
      character(len=*), intent(in) :: message

      call ctx%message( &
      & escape(ctx%terminal%bold) // "[" // &
      & escape(ctx%terminal%bold_red) // "Fatal" // &
      & escape(ctx%terminal%bold) // "]" // &
      & escape(ctx%terminal%reset) // " " // &
      & message)
   end subroutine fatal

   !> Extract dirname from path
   function dirname(filename)
      character(len=*), intent(in) :: filename
      character(len=:), allocatable :: dirname

      dirname = filename(1:scan(filename, "/\", back=.true.))
      if (len_trim(dirname) == 0) dirname = "."
   end function dirname


   !> Construct path by joining strings with os file separator
   function join(a1, a2) result(path)
      use mctc_env_system, only : is_windows
      character(len=*), intent(in) :: a1, a2
      character(len=:), allocatable :: path
      character :: filesep

      if (is_windows()) then
         filesep = '\'
      else
         filesep = '/'
      end if

      path = a1 // filesep // a2
   end function join


   !> test if pathname already exists
   function exists(filename)
      character(len=*), intent(in) :: filename
      logical :: exists
      inquire(file=filename, exist=exists)
   end function exists


   subroutine read_file(filename, val, error)
      use mctc_io_utils, only : next_line, read_next_token, io_error, token_type
      character(len=*), intent(in) :: filename
      integer, intent(out) :: val
      type(error_type), allocatable, intent(out) :: error

      integer :: io, stat, lnum, pos
      type(token_type) :: token
      character(len=:), allocatable :: line

      lnum = 0

      open(file=filename, newunit=io, status='old', iostat=stat)
      if (stat /= 0) then
         call fatal_error(error, "Error: Could not open file '"//filename//"'")
         return
      end if

      call next_line(io, line, pos, lnum, stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, val, stat)
      if (stat /= 0) then
         call io_error(error, "Cannot read value from file", line, token, &
            filename, lnum, "expected integer value")
         return
      end if

      close(io, iostat=stat)

   end subroutine read_file


end module tblite_driver_guess

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

#include "mctc/defs.h"

module mctc_io_read_json
   use mctc_env_accuracy, only : wp
   use mctc_env_error, only : error_type, fatal_error
   use mctc_io_structure, only : structure_type, new
   use mctc_io_symbols, only : to_number, symbol_length
   use mctc_io_utils, only : to_string
   use mctc_io_read_cjson, only : read_cjson
   use mctc_io_read_qcschema, only : read_qcschema
   use mctc_io_read_pymatgen, only : read_pymatgen
#if WITH_JSON
   use jonquil, only : json_value, json_object, json_array, json_keyval, &
      & json_load, json_error, json_context, json_stat, get_value, &
      & json_parser_config, json_context, cast_to_object, len
#endif
   implicit none
   private

   public :: read_json


contains


subroutine read_json(self, unit, error)

   !> Instance of the molecular structure data
   type(structure_type), intent(out) :: self

   !> File handle
   integer, intent(in) :: unit

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

#if WITH_JSON
   class(json_value), allocatable :: root
   type(json_object), pointer :: object
   type(json_error), allocatable :: parse_error
   type(json_context) :: ctx

   call json_load(root, unit, config=json_parser_config(context_detail=1), &
      & context=ctx, error=parse_error)
   if (allocated(parse_error)) then
      allocate(error)
      call move_alloc(parse_error%message, error%message)
      return
   end if
   object => cast_to_object(root)
   if (.not.associated(object)) then
      call fatal_error(error, ctx%report("Invalid JSON object", root%origin, "Expected JSON object"))
      return
   end if

   ! QCSchema JSON uses "schema_name" and "schema_version" keys
   if (object%has_key("schema_name") .or. object%has_key("schema_version")) then
      call read_qcschema(self, object, ctx, error)
      return
   end if

   ! Pymatgen serialized via monty adds "@module" and "@class" keys
   if (object%has_key("@module") .or. object%has_key("@class")) then
      call read_pymatgen(self, object, ctx, error)
      return
   end if

   ! Chemical JSON (cjson) tracks version via "chemical json" or "chemicalJson" keys
   if (object%has_key("chemical json") .or. object%has_key("chemicalJson")) then
      call read_cjson(self, object, ctx, error)
      return
   end if

   ! Default to QCSchema if no specific schema is detected
   call read_qcschema(self, object, ctx, error)
#else
   call fatal_error(error, "JSON support not enabled")
#endif
end subroutine read_json


end module mctc_io_read_json

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/basis/type.f90
!> Provides data types for managing basis set information

!> Gaussian type basis set data
module tblite_basis_type
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use tblite_integral_trafo, only : adjoint_transform0, transform0
   implicit none
   private

   public :: new_basis, new_cgto, get_cutoff

   !> Maximum contraction length of basis functions.
   !> The limit is chosen as twice the maximum size returned by the STO-NG expansion
   integer, parameter :: maxg = 12

   !> Two over pi
   real(wp), parameter :: top = 2.0_wp / pi

   !> Double factorial, see OEIS A001147
   real(wp), parameter :: dfactorial(8) = &
      & [1.0_wp,1.0_wp,3.0_wp,15.0_wp,105.0_wp,945.0_wp,10395.0_wp,135135.0_wp]

   !> Contracted Gaussian type basis function
   type, public :: cgto_type
      !> Angular momentum of this basis function
      integer :: ang = -1
      !> Contraction length of this basis function
      integer :: nprim = 0
      !> Exponent of the primitive Gaussian functions
      real(wp) :: alpha(maxg) = 0.0_wp
      !> Contraction coefficients of the primitive Gaussian functions,
      !> might contain normalization
      real(wp) :: coeff(maxg) = 0.0_wp
   contains
      !> Compare with a second CGTO for equality
      procedure :: compare
   end type cgto_type

   !> Collection of information regarding the basis set of a system
   type, public :: basis_type
      !> Maximum angular momentum of all basis functions,
      !> used to determine scratch size in integral calculation
      integer :: maxl = 0
      !> Number of shells in this basis set
      integer :: nsh = 0
      !> Number of spherical atomic orbitals in this basis set
      integer :: nao = 0
      !> Number of cartesian atomic orbitals in this basis set
      integer :: nao_cart = 0
      !> Integral cutoff as maximum exponent of Gaussian product theoreom to consider
      real(wp) :: intcut = 0.0_wp
      !> Smallest primitive exponent in the basis set
      real(wp) :: min_alpha = huge(0.0_wp)
      !> Number of shells for each species
      integer, allocatable :: nsh_id(:)
      !> Number of shells for each atom
      integer, allocatable :: nsh_at(:)
      !> Number of spherical atomic orbitals for each shell
      integer, allocatable :: nao_sh(:)
      !> Number of cartesian atomic orbitals for each shell
      integer, allocatable :: nao_cart_sh(:)
      !> Index offset for each shell in the atomic orbital space
      integer, allocatable :: iao_sh(:)
      !> Index offset for each shell in the cartesian atomic orbital space
      integer, allocatable :: iao_cart_sh(:)
      !> Index offset for each atom in the shell space
      integer, allocatable :: ish_at(:)
      !> Mapping from spherical atomic orbitals to the respective atom
      integer, allocatable :: ao2at(:)
      !> Mapping from spherical atomic orbitals to the respective shell
      integer, allocatable :: ao2sh(:)
      !> Mapping from shells to the respective atom
      integer, allocatable :: sh2at(:)
      !> Contracted Gaussian basis functions forming the basis set
      type(cgto_type), allocatable :: cgto(:, :)
   contains
      !> Transform matrix dimension from spherical to cartesian basis
      procedure :: spherical_to_cartesian_trafo
      !> Transform matrix dimension from cartesian to spherical basis
      procedure :: cartesian_to_spherical_trafo
   end type basis_type

   !> Get optimal real space cutoff for integral evaluation
   interface get_cutoff
      module procedure :: get_cutoff
   end interface get_cutoff

contains

!> Create a new basis set
subroutine new_basis(self, mol, nshell, cgto, acc)
   !> Instance of the basis set data
   type(basis_type), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells per species
   integer, intent(in) :: nshell(:)
   !> Contracted Gaussian basis functions for each shell and species
   type(cgto_type), intent(in) :: cgto(:, :)
   !> Calculation accuracy
   real(wp), intent(in) :: acc

   integer :: iat, isp, ish, iao, ii, iicart
   real(wp) :: min_alpha

   self%nsh_id = nshell
   self%cgto = cgto
   self%intcut = integral_cutoff(acc)

   ! Make count of shells for each atom
   self%nsh_at = nshell(mol%id)

   ! Create mapping between atoms and shells
   self%nsh = sum(self%nsh_at)
   allocate(self%ish_at(mol%nat), self%sh2at(self%nsh))
   ii = 0
   do iat = 1, mol%nat
      self%ish_at(iat) = ii
      do ish = 1, self%nsh_at(iat)
         self%sh2at(ii+ish) = iat
      end do
      ii = ii + self%nsh_at(iat)
   end do

   ! Make count of spherical orbitals for each shell
   allocate(self%nao_sh(self%nsh), self%nao_cart_sh(self%nsh))
   do iat = 1, mol%nat
      isp = mol%id(iat)
      ii = self%ish_at(iat)
      do ish = 1, self%nsh_at(iat)
         self%nao_sh(ii+ish) = 2*cgto(ish, isp)%ang + 1
         self%nao_cart_sh(ii+ish) = (cgto(ish, isp)%ang + 1)*(cgto(ish, isp)%ang + 2)/2
      end do
   end do

   ! Create mapping between shells and spherical orbitals, also map directly back to atoms
   self%nao = sum(self%nao_sh)
   self%nao_cart = sum(self%nao_cart_sh)
   allocate(self%iao_sh(self%nsh), self%iao_cart_sh(self%nsh), self%ao2sh(self%nao), &
      & self%ao2at(self%nao))
   ii = 0
   iicart = 0
   do ish = 1, self%nsh
      self%iao_sh(ish) = ii
      self%iao_cart_sh(ish) = iicart
      do iao = 1, self%nao_sh(ish)
         self%ao2sh(ii+iao) = ish
         self%ao2at(ii+iao) = self%sh2at(ish)
      end do
      ii = ii + self%nao_sh(ish)
      iicart = iicart + self%nao_cart_sh(ish)
   end do

   ii = 0
   do iat = 1, mol%nat
      isp = mol%id(iat)
      do ish = 1, nshell(isp)
         self%iao_sh(ish+self%ish_at(iat)) = ii
         ii = ii + 2*cgto(ish, isp)%ang + 1
      end do
   end do

   min_alpha = huge(acc)
   do isp = 1, size(nshell)
      do ish = 1, nshell(isp)
         self%maxl = max(self%maxl, cgto(ish, isp)%ang)
         min_alpha = min(min_alpha, minval(cgto(ish, isp)%alpha(:cgto(ish, isp)%nprim)))
      end do
   end do

   self%min_alpha = min_alpha

end subroutine new_basis


!> Setup CGTO with coefficients and exponents
subroutine new_cgto(self, ng, l, expos, coeffs, norm)
   !> Instance of the cgto data
   type(cgto_type), intent(out) :: self
   !> Number of primitive Gaussian functions
   integer, intent(in) :: ng
   !> Azimuthal quantum number of shell
   integer, intent(in) :: l
   !> Exponent of Gaussian function
   real(wp), intent(in) :: expos(:)
   !> Coefficients of the Gaussian function
   real(wp), intent(in) :: coeffs(:)
   !> Include normalization in contraction coefficients
   logical, intent(in) :: norm

   real(wp) :: normalizer(maxg)

   self%ang = l
   self%nprim = ng
   self%alpha(1:ng) = expos(1:ng)

   normalizer = 1.0_wp
   if (norm) then
      normalizer(1:ng) = (top*self%alpha(1:ng))**0.75_wp &
         & * sqrt(4.0_wp*self%alpha(1:ng))**l / sqrt(dfactorial(l+1))
   endif
   self%coeff(1:ng) = coeffs(1:ng) * normalizer(1:ng)

end subroutine new_cgto


!> Determine required real space cutoff for the basis set
pure function get_cutoff(self, acc) result(cutoff)
   !> Instance of the basis set data
   type(basis_type), intent(in) :: self
   !> Accuracy for the integral cutoff
   real(wp), intent(in), optional :: acc
   !> Required realspace cutoff
   real(wp) :: cutoff

   real(wp) :: intcut
   real(wp), parameter :: max_cutoff = 40.0_wp

   if (present(acc)) then
      intcut = integral_cutoff(acc)
   else
      intcut = self%intcut
   end if
   ! ai * aj * cutoff2 / (ai + aj) == intcut
   cutoff = min(sqrt(2.0_wp*intcut/self%min_alpha), max_cutoff)

end function get_cutoff


!> Create integral cutoff from accuracy value
pure function integral_cutoff(acc) result(intcut)
   !> Accuracy for the integral cutoff
   real(wp), intent(in) :: acc
   !> Integral cutoff
   real(wp) :: intcut

   real(wp), parameter :: min_intcut = 5.0_wp, max_intcut = 25.0_wp, &
      & max_acc = 1.0e-4_wp, min_acc = 1.0e+3_wp

   intcut = clip(max_intcut - 10*log10(clip(acc, min_acc, max_acc)), min_intcut, max_intcut)
end function integral_cutoff


pure function clip(val, min_val, max_val) result(res)
   real(wp), intent(in) :: val, min_val, max_val
   real(wp) :: res
   res = min(max(val, min_val), max_val)
end function clip


!> Transform matrix dimension from spherical to cartesian basis
subroutine spherical_to_cartesian_trafo(self, mol, sphr, cart)
   !> Instance of the basis set data
   class(basis_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Matrix with first index in the spherical basis
   real(wp), intent(in) :: sphr(:, :)
   !> Matrix with first index in the cartesian basis
   real(wp), intent(out) :: cart(:, :)

   integer :: iat, izp, ish, is, li, ii, ni, iicart, nicart

   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(self, mol, sphr, cart) &
   !$omp private(iat, izp, is, ish, li, ii, ni, iicart, nicart)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = self%ish_at(iat)
      do ish = 1, self%nsh_at(iat)
         li = self%cgto(ish, izp)%ang

         ii = self%iao_sh(is+ish)
         ni = self%nao_sh(is+ish)
         iicart = self%iao_cart_sh(is+ish)
         nicart = self%nao_cart_sh(is+ish)

         ! Transform all matrix columns for the current shell
         call adjoint_transform0(li, 0, sphr(ii+1:ii+ni, :), &
            & cart(iicart+1:iicart+nicart, :), bra=.true., ket=.false.)
      end do
   end do

end subroutine spherical_to_cartesian_trafo

!> Transform matrix dimension from cartesian to spherical basis
subroutine cartesian_to_spherical_trafo(self, mol, cart, sphr)
   !> Instance of the basis set data
   class(basis_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Matrix with first index in the cartesian basis
   real(wp), intent(in) :: cart(:, :)
   !> Matrix with first index in the spherical basis
   real(wp), intent(out) :: sphr(:, :)

   integer :: iat, izp, ish, is, li, ii, ni, iicart, nicart

   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(self, mol, sphr, cart) &
   !$omp private(iat, izp, is, ish, li, ii, ni, iicart, nicart)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = self%ish_at(iat)
      do ish = 1, self%nsh_at(iat)
         li = self%cgto(ish, izp)%ang

         ii = self%iao_sh(is+ish)
         ni = self%nao_sh(is+ish)
         iicart = self%iao_cart_sh(is+ish)
         nicart = self%nao_cart_sh(is+ish)

         ! Transform all matrix columns for the current shell
         call transform0(li, 0, cart(iicart+1:iicart+nicart, :), &
            & sphr(ii+1:ii+ni, :), bra=.true., ket=.false.)
      end do
   end do

end subroutine cartesian_to_spherical_trafo

!> Compare with a second CGTO for equality
pure function compare(self, rhs) result(same)
   !> First CGTO to compare
   class(cgto_type), intent(in) :: self
   !> Second CGTO to compare
   type(cgto_type), intent(in) :: rhs
   !> Flag to indicate equal CGTOs
   logical :: same

   real(wp), parameter :: tol = 1000.0_wp * epsilon(1.0_wp)

   same = .false.
   if (self%ang /= rhs%ang) return
   if (self%nprim /= rhs%nprim) return

   if (self%nprim < 0) return
   if (self%nprim > size(self%alpha) .or. self%nprim > size(rhs%alpha)) return
   if (self%nprim > size(self%coeff) .or. self%nprim > size(rhs%coeff)) return
   if (self%nprim == 0) then
      same = .true.
      return
   end if

   if (any(abs(self%alpha(:self%nprim) - rhs%alpha(:self%nprim)) > tol)) return
   if (any(abs(self%coeff(:self%nprim) - rhs%coeff(:self%nprim)) > tol)) return

   same = .true.
end function compare

end module tblite_basis_type

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Abstract base class definitions for data structures to store TOML values
module tomlf_structure_map
   use tomlf_constants, only : tfc
   use tomlf_type_value, only : toml_value, toml_key
   implicit none
   private

   public :: toml_map_structure


   !> Abstract data structure
   type, abstract :: toml_map_structure
   contains

      !> Get TOML value at a given key
      procedure(get), deferred :: get

      !> Push back a TOML value to the structure
      procedure(push_back), deferred :: push_back

      !> Get list of all keys in the structure
      procedure(get_keys), deferred :: get_keys

      !> Remove TOML value at a given key and return it
      procedure(pop), deferred :: pop

      !> Delete TOML value at a given key
      procedure(delete), deferred :: delete

      !> Destroy the data structure
      procedure(destroy), deferred :: destroy

   end type toml_map_structure


   abstract interface
      !> Get TOML value at a given key
      subroutine get(self, key, ptr)
         import :: toml_map_structure, toml_value, tfc

         !> Instance of the structure
         class(toml_map_structure), intent(inout), target :: self

         !> Key to the TOML value
         character(kind=tfc, len=*), intent(in) :: key

         !> Pointer to the stored value at given key
         class(toml_value), pointer, intent(out) :: ptr
      end subroutine get


      !> Push back a TOML value to the structure
      subroutine push_back(self, val)
         import :: toml_map_structure, toml_value

         !> Instance of the structure
         class(toml_map_structure), intent(inout), target :: self

         !> TOML value to be stored
         class(toml_value), allocatable, intent(inout) :: val

      end subroutine push_back


      !> Get list of all keys in the structure
      subroutine get_keys(self, list)
         import :: toml_map_structure, toml_key

         !> Instance of the structure
         class(toml_map_structure), intent(inout), target :: self

         !> List of all keys
         type(toml_key), allocatable, intent(out) :: list(:)

      end subroutine get_keys


      !> Remove TOML value at a given key and return it
      subroutine pop(self, key, val)
         import :: toml_map_structure, toml_value, tfc

         !> Instance of the structure
         class(toml_map_structure), intent(inout), target :: self

         !> Key to the TOML value
         character(kind=tfc, len=*), intent(in) :: key

         !> Removed TOML value
         class(toml_value), allocatable, intent(out) :: val

      end subroutine pop


      !> Delete TOML value at a given key
      subroutine delete(self, key)
         import :: toml_map_structure, toml_value, tfc

         !> Instance of the structure
         class(toml_map_structure), intent(inout), target :: self

         !> Key to the TOML value
         character(kind=tfc, len=*), intent(in) :: key

      end subroutine delete


      !> Deconstructor for data structure
      subroutine destroy(self)
         import :: toml_map_structure

         !> Instance of the structure
         class(toml_map_structure), intent(inout), target :: self

      end subroutine destroy

   end interface


end module tomlf_structure_map

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Environment module providing common utilities and error handling.
!>
!> This module exports fundamental types and constants used throughout mctc-lib:
!>
!> - [[mctc_env_error:error_type]]: Allocatable error type for error propagation
!> - [[mctc_env_error:fatal_error]]: Subroutine to create error messages
!> - [[mctc_env_accuracy:wp]]: Working precision for real numbers (double precision)
!> - [[mctc_env_accuracy:sp]], [[mctc_env_accuracy:dp]]: Single and double precision kind parameters
!> - [[mctc_env_accuracy:i1]], [[mctc_env_accuracy:i2]], [[mctc_env_accuracy:i4]], [[mctc_env_accuracy:i8]]: Integer kind parameters (1, 2, 4, 8 bytes)
!>
!> Error handling follows a simple pattern: pass an allocatable [[mctc_env_error:error_type]]
!> to library routines, then check if it is allocated to detect errors.
!>
!> Example usage:
!>
!>```f90
!> use mctc_env
!> type(error_type), allocatable :: error
!>
!> call some_routine(result, error)
!> if (allocated(error)) then
!>    print '(a)', error%message
!>    error stop
!> end if
!>```
module mctc_env
   use mctc_env_accuracy, only : sp, dp, wp, i1, i2, i4, i8
   use mctc_env_error, only : error_type, fatal_error, mctc_stat
   use mctc_env_system, only : get_argument, get_variable, &
      & is_unix, is_windows
   use mctc_env_timer, only : timer_type, format_time
   implicit none
   private

   public :: sp, dp, wp, i1, i2, i4, i8
   public :: error_type, fatal_error, mctc_stat
   public :: get_argument, get_variable, is_unix, is_windows
   public :: timer_type, format_time

end module mctc_env

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_write_pymatgen
   use mctc_env_accuracy, only : wp
   use mctc_io_convert, only : autoaa
   use mctc_io_math, only : matinv_3x3, matdet_3x3
   use mctc_io_structure, only : structure_type
   use mctc_version, only : get_mctc_version
   implicit none
   private

   public :: write_pymatgen


   interface json_value
      module procedure :: json_value_char
      module procedure :: json_value_int
      module procedure :: json_value_real
   end interface json_value

   character(len=*), parameter :: nl = new_line('a')

contains


subroutine write_pymatgen(mol, unit)
   type(structure_type), intent(in) :: mol
   integer, intent(in) :: unit

   write(unit, '(a)') json_string(mol, "  ")
end subroutine write_pymatgen

pure function json_string(mol, indent) result(string)
   type(structure_type), intent(in) :: mol
   character(len=*), intent(in), optional :: indent
   character(len=:), allocatable :: string
   integer :: iat, isp, ilt
   real(wp) :: cellpar(6), volume, vec(3)
   real(wp), allocatable :: invlat(:, :)

   string = "{"
   if (present(indent)) string = string // nl // indent
   string = string // json_key("@module", indent) // json_value("pymatgen.core.structure")

   string = string // ","
   if (present(indent)) string = string // nl // indent
   if (any(mol%periodic)) then
      string = string // json_key("@class", indent) // json_value("Structure")
      invlat = matinv_3x3(mol%lattice)
   else
      string = string // json_key("@class", indent) // json_value("Molecule")
      string = string // ","

      if (present(indent)) string = string // nl // indent
      string = string // json_key("charge", indent) // json_value(nint(mol%charge))
      string = string // ","

      if (present(indent)) string = string // nl // indent
      string = string // json_key("spin_multiplicity", indent) // json_value(mol%uhf + 1)
   end if

   string = string // ","

   if (present(indent)) string = string // nl // indent
   string = string // json_key("sites", indent) // "["

   do iat = 1, mol%nat
      isp = mol%id(iat)
      if (present(indent)) string = string // nl // indent // indent
      string = string // "{"

      if (present(indent)) string = string // nl // indent // indent // indent
      string = string // json_key("name", indent) // json_value(trim(mol%sym(isp)))

      string = string // ","
      if (present(indent)) string = string // " "
      string = string // json_key("label", indent) // json_value(trim(mol%sym(isp)))

      string = string // ","
      if (present(indent)) string = string // " "
      string = string // json_key("species", indent) // "[{"
      string = string // json_key("element", indent) // json_value(trim(mol%sym(isp))) // ","
      if (present(indent)) string = string // " "
      string = string // json_key("occu", indent) // json_value(1)
      string = string // "}]"

      string = string // ","
      if (present(indent)) string = string // nl // indent // indent // indent
      string = string // json_key("xyz", indent) // &
         & "[" // json_value(mol%xyz(1, iat) * autoaa, '(es23.16)') // "," // &
         & json_value(mol%xyz(2, iat) * autoaa, '(es23.16)') // "," // &
         & json_value(mol%xyz(3, iat) * autoaa, '(es23.16)') // "]"

      ! if (allocated(invlat)) then
      !    vec = matmul(invlat, mol%xyz(:, iat))
      !    if (present(indent)) string = string // nl // indent // indent // indent
      !    string = string // json_key("abc", indent) // &
      !       & "[" // json_value(vec(1), '(es23.16)') // "," // &
      !       & json_value(vec(2), '(es23.16)') // "," // &
      !       & json_value(vec(3), '(es23.16)') // "]"
      ! end if

      string = string // ","
      if (present(indent)) string = string // nl // indent // indent // indent
      string = string // json_key("properties", indent) // "{}"

      if (present(indent)) string = string // nl // indent // indent
      string = string // "}"
      if (iat /= mol%nat) then
         string = string // ","
      end if
   end do
   if (present(indent)) string = string // nl // indent
   string = string // "]"

   if (any(mol%periodic)) then
      call dlat_to_cell(mol%lattice, cellpar)
      volume = matdet_3x3(mol%lattice)
      string = string // ","
      if (present(indent)) string = string // nl // indent
      string = string // json_key("lattice", indent) // "{"
      if (present(indent)) string = string // nl // indent // indent
      string = string // json_key("matrix", indent) // "["
      if (present(indent)) string = string // nl // indent // indent // indent
      do ilt = 1, 3
         string = string // "[" // &
            & json_value(mol%lattice(1, ilt) * autoaa, '(es23.16)') // "," // &
            & json_value(mol%lattice(2, ilt) * autoaa, '(es23.16)') // "," // &
            & json_value(mol%lattice(3, ilt) * autoaa, '(es23.16)') // "]"
         if (ilt < 3) then
            string = string // ","
            if (present(indent)) string = string // nl // indent // indent // indent
         end if
      end do
      if (present(indent)) string = string // nl // indent // indent
      string = string // "],"
      if (present(indent)) string = string // nl // indent // indent
      string = string // json_key("a", indent) // json_value(cellpar(1) * autoaa, '(es23.16)') // ","
      if (present(indent)) string = string // nl // indent // indent
      string = string // json_key("b", indent) // json_value(cellpar(2) * autoaa, '(es23.16)') // ","
      if (present(indent)) string = string // nl // indent // indent
      string = string // json_key("c", indent) // json_value(cellpar(3) * autoaa, '(es23.16)') // ","
      if (present(indent)) string = string // nl // indent // indent
      string = string // json_key("alpha", indent) // json_value(cellpar(4), '(es23.16)') // ","
      if (present(indent)) string = string // nl // indent // indent
      string = string // json_key("beta", indent) // json_value(cellpar(5), '(es23.16)') // ","
      if (present(indent)) string = string // nl // indent // indent
      string = string // json_key("gamma", indent) // json_value(cellpar(6), '(es23.16)') // ","
      if (present(indent)) string = string // nl // indent // indent
      string = string // json_key("volume", indent) // json_value(volume * autoaa**3, '(es23.16)')
      if (present(indent)) string = string // nl // indent
      string = string // "}"
   end if

   string = string // ","
   if (present(indent)) string = string // nl // indent
   string = string // json_key("properties", indent) // "{}"

   if (present(indent)) string = string // nl
   string = string // "}"
end function json_string

pure function json_key(key, indent) result(string)
   character(len=*), intent(in) :: key
   character(len=*), intent(in), optional :: indent
   character(len=:), allocatable :: string

   if (present(indent)) then
      string = json_value(key) // ": "
   else
      string = json_value(key) // ":"
   end if
end function json_key

pure function json_value_char(val) result(string)
   character(len=*), intent(in) :: val
   character(len=:), allocatable :: string

   string = """" // val // """"
end function json_value_char

pure function json_value_real(val, format) result(str)
   real(wp), intent(in) :: val
   character(len=*), intent(in) :: format
   character(len=:), allocatable :: str

   character(len=128) :: buffer
   integer :: stat

   write(buffer, format, iostat=stat) val
   if (stat == 0) then
      str = trim(buffer)
   else
      str = """*"""
   end if
end function json_value_real

pure function json_value_int(val) result(string)
   integer, intent(in) :: val
   character(len=:), allocatable :: string
   integer, parameter :: buffer_len = range(val)+2
   character(len=buffer_len) :: buffer
   integer :: pos
   integer :: n
   character(len=1), parameter :: numbers(0:9) = &
      ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]

   if (val == 0) then
      string = numbers(0)
      return
   end if

   n = abs(val)
   buffer = ""

   pos = buffer_len + 1
   do while (n > 0)
      pos = pos - 1
      buffer(pos:pos) = numbers(mod(n, 10))
      n = n/10
   end do
   if (val < 0) then
      pos = pos - 1
      buffer(pos:pos) = '-'
   end if

   string = buffer(pos:)
end function json_value_int

!> Convert direct lattice to cell parameters
pure subroutine dlat_to_cell(lattice,cellpar)
   implicit none
   real(wp),intent(in)  :: lattice(3,3) !< direct lattice
   real(wp),intent(out) :: cellpar(6)   !< cell parameters

   associate( alen => cellpar(1), blen => cellpar(2), clen => cellpar(3), &
      &       alp  => cellpar(4), bet  => cellpar(5), gam  => cellpar(6) )

   alen = norm2(lattice(:,1))
   blen = norm2(lattice(:,2))
   clen = norm2(lattice(:,3))

   alp = acos(dot_product(lattice(:,2),lattice(:,3))/(blen*clen))
   bet = acos(dot_product(lattice(:,1),lattice(:,3))/(alen*clen))
   gam = acos(dot_product(lattice(:,1),lattice(:,2))/(alen*blen))

   end associate

end subroutine dlat_to_cell

end module mctc_io_write_pymatgen

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Merge TOML data structures, the merge policy can be adjusted.
!>
!> Note that the context information cannot be preserved.
module tomlf_build_merge
   use tomlf_constants, only : tfc
   use tomlf_type, only : toml_table, toml_array, toml_keyval, toml_value, &
      & toml_key, cast_to_keyval, len
   implicit none
   private

   public :: merge_table, merge_array, merge_policy, toml_merge_config


   !> Possible merge policies
   type :: enum_policy

      !> Overwrite existing values
      integer :: overwrite = 1

      !> Preserve existing values
      integer :: preserve = 2

      !> Append to existing values
      integer :: append = 3
   end type enum_policy

   !> Actual enumerator for merging data structures
   type(enum_policy), parameter :: merge_policy = enum_policy()


   !> Configuration for merging data structures
   type :: toml_merge_config

      !> Policy for merging tables
      integer :: table = merge_policy%append

      !> Policy for merging arrays
      integer :: array = merge_policy%preserve

      !> Policy for merging values
      integer :: keyval = merge_policy%preserve
   end type toml_merge_config

   !> Constructor for merge configuration
   interface toml_merge_config
      module procedure :: new_merge_config
   end interface toml_merge_config


contains


!> Create a new merge configuration
pure function new_merge_config(table, array, keyval) result(config)

   !> Policy for merging tables
   character(*), intent(in), optional :: table

   !> Policy for merging arrays
   character(*), intent(in), optional :: array

   !> Policy for merging values
   character(*), intent(in), optional :: keyval

   !> Merge policy
   type(toml_merge_config) :: config

   if (present(table)) call set_enum(config%table, table)
   if (present(array)) call set_enum(config%array, array)
   if (present(keyval)) call set_enum(config%keyval, keyval)

contains

   pure subroutine set_enum(enum, str)
      character(*), intent(in) :: str
      integer, intent(inout) :: enum

      select case(str)
      case("append")
         enum = merge_policy%append
      case("overwrite")
         enum = merge_policy%overwrite
      case("preserve")
         enum = merge_policy%preserve
      end select
   end subroutine set_enum

end function new_merge_config


!> Merge TOML tables by appending their values
recursive subroutine merge_table(lhs, rhs, config)

   !> Instance of table to merge into
   class(toml_table), intent(inout) :: lhs

   !> Instance of table to be merged
   class(toml_table), intent(inout) :: rhs

   !> Merge policy
   type(toml_merge_config), intent(in), optional :: config

   type(toml_merge_config) :: policy
   type(toml_key), allocatable :: list(:)
   class(toml_value), pointer :: ptr1, ptr2
   class(toml_keyval), pointer :: kv
   class(toml_value), allocatable :: tmp
   logical :: has_key
   integer :: i, n, stat

   policy = toml_merge_config()
   if (present(config)) policy = config

   call rhs%get_keys(list)
   n = size(list, 1)

   do i = 1, n
      if (allocated(tmp)) deallocate(tmp)
      call rhs%get(list(i)%key, ptr1)
      has_key = lhs%has_key(list(i)%key)
      select type(ptr1)
      class is(toml_keyval)
         if (has_key .and. policy%keyval == merge_policy%overwrite) then
            call lhs%delete(list(i)%key)
            has_key = .false.
         end if
         if (.not.has_key) then
            allocate(tmp, source=ptr1)
            kv => cast_to_keyval(tmp)
            kv%origin_value = 0
            kv%origin = 0
            call lhs%push_back(tmp, stat)
         end if

      class is(toml_array)
         if (has_key .and. policy%array == merge_policy%overwrite) then
            call lhs%delete(list(i)%key)
            has_key = .false.
         end if
         if (has_key .and. policy%array == merge_policy%append) then
            call lhs%get(list(i)%key, ptr2)
            select type(ptr2)
            class is(toml_array)
               call merge_array(ptr2, ptr1)
            end select
         end if
         if (.not.has_key) then
            allocate(tmp, source=ptr1)
            tmp%origin = 0
            call lhs%push_back(tmp, stat)
         end if

      class is(toml_table)
         if (has_key .and. policy%table == merge_policy%overwrite) then
            call lhs%delete(list(i)%key)
            has_key = .false.
         end if
         if (has_key .and. policy%table == merge_policy%append) then
            call lhs%get(list(i)%key, ptr2)
            select type(ptr2)
            class is(toml_table)
               call merge_table(ptr2, ptr1, policy)
            end select
         end if
         if (.not.has_key) then
            allocate(tmp, source=ptr1)
            tmp%origin = 0
            call lhs%push_back(tmp, stat)
         end if
      end select
   end do

end subroutine merge_table


!> Append values from one TOML array to another
recursive subroutine merge_array(lhs, rhs)

   !> Instance of array to merge into
   class(toml_array), intent(inout) :: lhs

   !> Instance of array to be merged
   class(toml_array), intent(inout) :: rhs

   class(toml_value), pointer :: ptr
   class(toml_value), allocatable :: tmp
   integer :: n, i, stat

   n = len(rhs)

   do i = 1, n
      call rhs%get(i, ptr)
      if (allocated(tmp)) deallocate(tmp)
      allocate(tmp, source=ptr)
      call lhs%push_back(tmp, stat)
   end do

end subroutine merge_array


end module tomlf_build_merge

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/output/format.f90
!> Provides conversion routines from intrinsic data types to string

!> Functional procedures for creating strings from intrinsic data types
module tblite_output_format
   use mctc_env, only : wp
   implicit none
   private

   public :: format_string

   interface format_string
      module procedure :: format_string_int
      module procedure :: format_string_real_dp
   end interface format_string

contains

pure function format_string_real_dp(val, format) result(str)
   real(wp), intent(in) :: val
   character(len=*), intent(in) :: format
   character(len=:), allocatable :: str

   character(len=128) :: buffer
   integer :: stat

   write(buffer, format, iostat=stat) val
   if (stat == 0) then
      str = trim(buffer)
   else
      str = "*"
   end if
end function format_string_real_dp

pure function format_string_int(val, format) result(str)
   integer, intent(in) :: val
   character(len=*), intent(in) :: format
   character(len=:), allocatable :: str

   character(len=128) :: buffer
   integer :: stat

   write(buffer, format, iostat=stat) val
   if (stat == 0) then
      str = trim(buffer)
   else
      str = "*"
   end if
end function format_string_int

end module tblite_output_format

! This file is part of mstore.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mstore_data_collection
   use mstore_data_record, only : record_type
   implicit none
   private

   public :: collection_type, new_collection, select_collection

   abstract interface
      subroutine get_record_interface(records)
         import :: record_type
         type(record_type), allocatable, intent(out) :: records(:)
      end subroutine get_record_interface
   end interface

   !> Data base collection of a record type
   type :: collection_type

      !> Identifier for this collection
      character(len=:), allocatable :: id

      !> Collection of records
      type(record_type), allocatable :: records(:)

      !> Actual getter for the record data
      procedure(get_record_interface), pointer, nopass :: get => null()

   end type collection_type

contains


!> Register a new collection
function new_collection(id, getter) result(new)

   !> Identifier for this collection
   character(len=*), intent(in) :: id

   !> Getter for the actual record
   procedure(get_record_interface) :: getter

   !> New record collection
   type(collection_type) :: new

   new%id = id
   new%get => getter
   call getter(new%records)

end function new_collection


!> Select a test suite from all available suites
function select_collection(collections, id) result(pos)

   !> Name identifying the collection
   character(len=*), intent(in) :: id

   !> Available record collections
   type(collection_type) :: collections(:)

   !> Selected test suite
   integer :: pos

   integer :: it

   pos = 0
   do it = 1, size(collections)
      if (id == collections(it)%id) then
         pos = it
         exit
      end if
   end do

end function select_collection


end module mstore_data_collection

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/ceh/h0.f90
!> Provides the Hamiltonian level functions for CEH.

module tblite_ceh_h0
   use mctc_env, only : wp
   use mctc_io, only: structure_type
   use tblite_basis_type, only:  basis_type
   use tblite_xtb_spec, only : tb_h0spec
   use tblite_xtb_h0, only : tb_hamiltonian
   use tblite_integral_dipole, only: get_dipole_integrals, dipole_cgto, &
   & maxl, msao, smap
   use tblite_adjlist, only : adjacency_list
   use tblite_integral_diat_trafo, only: diat_trafo

   implicit none
   private

   public :: get_scaled_selfenergy, get_hamiltonian, get_occupation

contains


   !> Scale the selfenergy parameters by the CN
   subroutine get_scaled_selfenergy(h0, id, ish_at, nshell, cn, cn_en, selfenergy, dsedcn, dsedcn_en)
      type(tb_hamiltonian), intent(in) :: h0
      integer, intent(in) :: id(:)
      integer, intent(in) :: ish_at(:)
      integer, intent(in) :: nshell(:)
      real(wp), intent(in), optional :: cn(:)
      real(wp), intent(in), optional :: cn_en(:)
      real(wp), intent(out) :: selfenergy(:)
      real(wp), intent(out), optional :: dsedcn(:)
      real(wp), intent(out), optional :: dsedcn_en(:)

      integer :: iat, izp, ish, ii

      selfenergy(:) = 0.0_wp
      if (present(dsedcn)) dsedcn(:) = 0.0_wp
      if (present(dsedcn_en)) dsedcn_en(:) = 0.0_wp
      do iat = 1, size(id)
         izp = id(iat)
         ii = ish_at(iat)
         do ish = 1, nshell(izp)
            selfenergy(ii+ish) = h0%selfenergy(ish, izp)
         end do
      end do
      if (.not.present(cn) .or. .not.present(cn_en)) return
      if (present(dsedcn) .and. present(dsedcn_en)) then
         do iat = 1, size(id)
            izp = id(iat)
            ii = ish_at(iat)
            do ish = 1, nshell(izp)
               selfenergy(ii+ish) = selfenergy(ii+ish) + h0%kcn(ish, izp) * cn(iat) + &
               &  h0%kcn_en(ish, izp) * cn_en(iat)
               dsedcn(ii+ish) = h0%kcn(ish, izp)
               dsedcn_en(ii+ish) = h0%kcn_en(ish, izp)
            end do
         end do
      else
         do iat = 1, size(id)
            izp = id(iat)
            ii = ish_at(iat)
            do ish = 1, nshell(izp)
               selfenergy(ii+ish) = selfenergy(ii+ish) + h0%kcn(ish, izp) * cn(iat) + &
               &  h0%kcn_en(ish, izp) * cn_en(iat)
            end do
         end do
      end if

   end subroutine get_scaled_selfenergy


   subroutine get_hamiltonian(mol, trans, list, bas, h0, selfenergy, &
   & overlap, overlap_diat, dpint, hamiltonian)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Lattice points within a given realspace cutoff
      real(wp), intent(in) :: trans(:, :)
      !> Neighbour list
      type(adjacency_list), intent(in) :: list
      !> Basis set information
      type(basis_type), intent(in) :: bas
      !> Hamiltonian interaction data
      type(tb_hamiltonian), intent(in) :: h0
      !> Diagonal elememts of the Hamiltonian
      real(wp), intent(in) :: selfenergy(:)
      !> Overlap integral matrix
      real(wp), intent(out) :: overlap(:, :)
      !> Dipole moment integral matrix
      real(wp), intent(out) :: dpint(:, :, :)
      !> Diatomic frame-scaled overlap integral matrix
      real(wp), intent(out) :: overlap_diat(:, :)
      !> Effective Hamiltonian
      real(wp), intent(out) :: hamiltonian(:, :)

      integer  :: itr, img, inl, ii, jj, is, js, jzp, izp, nao
      integer  :: iat, ish, jat, jsh, iao, jao, ij, iaosh, jaosh
      real(wp) :: hij, rr, r2, vec(3), dtmpj(3)
      real(wp), allocatable :: stmp(:), dtmpi(:, :), block_overlap(:,:)

      overlap(:, :) = 0.0_wp
      dpint(:, :, :) = 0.0_wp
      overlap_diat(:, :) = 0.0_wp
      hamiltonian(:, :) = 0.0_wp

      ! Allocate temporary matrices for overlap, diatomic frame scaled overlap and dipole moment integrals
      allocate(stmp(msao(bas%maxl)**2), dtmpi(3, msao(bas%maxl)**2), &
      & block_overlap(smap(bas%maxl+1),smap(bas%maxl+1)))

      !$omp parallel do schedule(runtime) default(none) &
      !$omp shared(mol, bas, trans, list, overlap, overlap_diat, dpint, hamiltonian, h0, selfenergy) &
      !$omp private(iat, jat, izp, jzp, itr, is, js, ish, jsh, ii, jj, iao, jao, nao, ij, iaosh, jaosh) &
      !$omp private(r2, vec, stmp, block_overlap, dtmpi, dtmpj, hij, rr, inl, img)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         is = bas%ish_at(iat)
         inl = list%inl(iat)
         do img = 1, list%nnl(iat)
            jat = list%nlat(img+inl)
            itr = list%nltr(img+inl)
            jzp = mol%id(jat)
            js = bas%ish_at(jat)
            vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
            r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
            rr = sqrt(sqrt(r2) / (h0%rad(jzp) + h0%rad(izp)))

            ! Get the overlap and dipole integrals for the current diatomic pair
            block_overlap = 0.0_wp
            do ish = 1, bas%nsh_id(izp)
               ii = bas%iao_sh(is+ish)
               iaosh = smap(ish-1) ! Offset for the block overlap matrix
               do jsh = 1, bas%nsh_id(jzp)
                  jj = bas%iao_sh(js+jsh)
                  jaosh = smap(jsh-1) ! Offset for the block overlap matrix

                  call dipole_cgto(bas%cgto(jsh,jzp), bas%cgto(ish,izp), &
                  & r2, vec, bas%intcut, stmp, dtmpi)

                  ! Store the overlap and dipole matrix
                  nao = msao(bas%cgto(jsh, jzp)%ang)
                  do iao = 1, msao(bas%cgto(ish, izp)%ang)
                     do jao = 1, nao
                        ij = jao + nao*(iao-1)
                        ! Shift dipole operator from Ket function (center i)
                        ! to Bra function (center j) to save the redundant calculation
                        call shift_operator(vec, stmp(ij), dtmpi(:, ij), dtmpj)

                        overlap(jj+jao, ii+iao) = overlap(jj+jao, ii+iao) &
                           + stmp(ij)

                        block_overlap(jaosh+jao, iaosh+iao) = block_overlap(jaosh+jao, iaosh+iao) &
                           + stmp(ij)

                        dpint(:, jj+jao, ii+iao) = dpint(:, jj+jao, ii+iao) &
                           + dtmpi(:, ij)

                        if (iat /= jat) then
                           overlap(ii+iao, jj+jao) = overlap(ii+iao, jj+jao) &
                              + stmp(ij)

                           dpint(:, ii+iao, jj+jao) = dpint(:, ii+iao, jj+jao) &
                              + dtmpj

                        end if
                     end do
                  end do
               end do
            end do
   
            ! Diatomic frame transformation and scaling of the overlap
            call diat_trafo(block_overlap, vec, h0%ksig(izp,jzp), h0%kpi(izp,jzp), h0%kdel(izp,jzp), &
               & bas%nsh_at(jat)-1, bas%nsh_at(iat)-1) 

            ! Setup the Hamiltonian and store the diatomic frame scaled overlap. 
            do ish = 1, bas%nsh_id(izp)
               ii = bas%iao_sh(is+ish)
               iaosh = smap(ish-1) ! Offset for the block overlap matrix
               do jsh = 1, bas%nsh_id(jzp)
                  jj = bas%iao_sh(js+jsh)
                  jaosh = smap(jsh-1) ! Offset for the block overlap matrix
                  
                  hij = 0.5_wp * h0%hscale(jsh, ish, jzp, izp) * (selfenergy(is+ish) + selfenergy(js+jsh)) 

                  nao = msao(bas%cgto(jsh, jzp)%ang)
                  do iao = 1, msao(bas%cgto(ish, izp)%ang)
                     do jao = 1, nao
                        ij = jao + nao*(iao-1)

                        overlap_diat(jj+jao, ii+iao) = overlap_diat(jj+jao, ii+iao) &
                           + block_overlap(jaosh+jao, iaosh+iao)

                        hamiltonian(jj+jao, ii+iao) = hamiltonian(jj+jao, ii+iao) &
                           + block_overlap(jaosh+jao, iaosh+iao) * hij

                        if (iat /= jat) then
                           overlap_diat(ii+iao, jj+jao) = overlap_diat(ii+iao, jj+jao) &
                              + block_overlap(jaosh+jao, iaosh+iao)

                           hamiltonian(ii+iao, jj+jao) = hamiltonian(ii+iao, jj+jao) &
                              + block_overlap(jaosh+jao, iaosh+iao) * hij
                        end if
                     end do
                  end do
               end do
            end do

         end do
      end do

      !$omp parallel do schedule(runtime) default(none) &
      !$omp shared(mol, bas, trans, overlap, overlap_diat, dpint, hamiltonian, h0, selfenergy) &
      !$omp private(iat, izp, itr, is, ish, jsh, ii, jj, iao, jao, nao, ij) &
      !$omp private(r2, vec, stmp, dtmpi, hij, rr)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         is = bas%ish_at(iat)
         vec(:) = 0.0_wp
         r2 = 0.0_wp
         rr = sqrt(sqrt(r2) / (h0%rad(izp) + h0%rad(izp)))
         do ish = 1, bas%nsh_id(izp)
            ii = bas%iao_sh(is+ish)
            do jsh = 1, bas%nsh_id(izp)
               jj = bas%iao_sh(is+jsh)
               call dipole_cgto(bas%cgto(jsh,izp), bas%cgto(ish,izp), &
               & r2, vec, bas%intcut, stmp, dtmpi)
               nao = msao(bas%cgto(jsh, izp)%ang)
               do iao = 1, msao(bas%cgto(ish, izp)%ang)
                  do jao = 1, nao
                     ij = jao + nao*(iao-1)
                     overlap(jj+jao, ii+iao) = overlap(jj+jao, ii+iao) &
                        + stmp(ij)

                     overlap_diat(jj+jao, ii+iao) = overlap_diat(jj+jao, ii+iao) &
                        + stmp(ij)

                     dpint(:, jj+jao, ii+iao) = dpint(:, jj+jao, ii+iao) &
                        + dtmpi(:, ij)
                  end do
               end do
            end do
            ! diagonal term (AO(i) == AO(j)) as on-site off-diagonal the hamiltonian is zero
            do iao = 1, msao(bas%cgto(ish, izp)%ang)
               hamiltonian(ii+iao, ii+iao) = selfenergy(is + ish)
            enddo
         end do
      end do

   end subroutine get_hamiltonian


   subroutine get_occupation(mol, bas, hamiltonian, nocc, n0at, n0sh)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Basis set information
      type(basis_type), intent(in) :: bas
      !> Hamiltonian interaction data
      type(tb_hamiltonian), intent(in) :: hamiltonian
      !> Occupation number
      real(wp), intent(out) :: nocc
      !> Reference occupation for each atom
      real(wp), intent(out) :: n0at(:)
      !> Reference occupation for each shell
      real(wp), intent(out) :: n0sh(:)
      integer :: iat, ish, izp, ii
      nocc = -mol%charge
      n0at(:) = 0.0_wp
      n0sh(:) = 0.0_wp
      do iat = 1, mol%nat
         izp = mol%id(iat)
         ii = bas%ish_at(iat)
         do ish = 1, bas%nsh_id(izp)
            nocc = nocc + hamiltonian%refocc(ish, izp)
            n0at(iat) = n0at(iat) + hamiltonian%refocc(ish, izp)
            n0sh(ii+ish) = n0sh(ii+ish) + hamiltonian%refocc(ish, izp)
         end do
      end do
   end subroutine get_occupation


   !> Shift dipole operator from Ket function (center i) to Bra function (center j),
   !> the dipole operator on the Bra function can be assembled from the lower moments
   !> on the Ket function and the displacement vector using horizontal shift rules.
   pure subroutine shift_operator(vec, s, di, dj)
      !> Displacement vector of center i and j
      real(wp),intent(in) :: vec(:)
      !> Overlap integral between basis functions
      real(wp),intent(in) :: s
      !> Dipole integral with operator on Ket function (center i)
      real(wp),intent(in) :: di(:)
      !> Dipole integral with operator on Bra function (center j)
      real(wp),intent(out) :: dj(:)
      ! Create dipole operator on Bra function from Ket function and shift contribution
      ! due to monopol displacement
      dj(1) = di(1) + vec(1)*s
      dj(2) = di(2) + vec(2)*s
      dj(3) = di(3) + vec(3)*s
   end subroutine shift_operator

end module tblite_ceh_h0

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_read
   use mctc_env_error, only : error_type, fatal_error
   use mctc_io_filetype, only : filetype, get_filetype
   use mctc_io_read_aims, only : read_aims
   use mctc_io_read_cjson, only : read_cjson
   use mctc_io_read_ctfile, only : read_molfile, read_sdf
   use mctc_io_read_gaussian, only : read_gaussian_external
   use mctc_io_read_genformat, only : read_genformat
   use mctc_io_read_json, only : read_json
   use mctc_io_read_qchem, only : read_qchem
   use mctc_io_read_qcschema, only : read_qcschema
   use mctc_io_read_pdb, only : read_pdb
   use mctc_io_read_pymatgen, only : read_pymatgen
   use mctc_io_read_turbomole, only : read_coord
   use mctc_io_read_vasp, only : read_vasp
   use mctc_io_read_xyz, only : read_xyz
   use mctc_io_structure, only : structure_type, new_structure
   implicit none
   private

   public :: read_structure
   public :: structure_reader, get_structure_reader


   interface read_structure
      module procedure :: read_structure_from_file
      module procedure :: read_structure_from_unit
   end interface read_structure


   abstract interface
      !> Read molecular structure data from formatted unit
      subroutine structure_reader(self, unit, error)
         import :: structure_type, error_type

         !> Instance of the molecular structure data
         type(structure_type), intent(out) :: self

         !> File handle
         integer, intent(in) :: unit

         !> Error handling
         type(error_type), allocatable, intent(out) :: error

      end subroutine structure_reader
   end interface


contains


subroutine read_structure_from_file(self, file, error, format)

   !> Instance of the molecular structure data
   type(structure_type), intent(out) :: self

   !> Name of the file to read
   character(len=*), intent(in) :: file

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> File type format hint
   integer, intent(in), optional :: format

   logical :: exist
   integer :: unit, stat, ftype

   inquire(file=file, exist=exist)
   if (.not.exist) then
      call fatal_error(error, "File '"//file//"' cannot be found")
      return
   end if

   open(file=file, newunit=unit, status='old', iostat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot open '"//file//"'")
      return
   end if

   if (present(format)) then
      ftype = format
   else
      ftype = get_filetype(file)
   end if

   call read_structure(self, unit, ftype, error)
   close(unit)

end subroutine read_structure_from_file


subroutine read_structure_from_unit(self, unit, ftype, error)

   !> Instance of the molecular structure data
   type(structure_type), intent(out) :: self

   !> File handle
   integer, intent(in) :: unit

   !> File type to read
   integer, intent(in) :: ftype

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   procedure(structure_reader), pointer :: reader

   call get_structure_reader(reader, ftype)
   if (.not.associated(reader)) then
      call fatal_error(error, "Cannot read structure from unknown file format")
      return
   end if

   call reader(self, unit, error)

end subroutine read_structure_from_unit


!> Retrieve reader for corresponding file type
subroutine get_structure_reader(reader, ftype)

   !> Reader for the specified file type
   procedure(structure_reader), pointer, intent(out) :: reader

   !> File type to read
   integer, intent(in) :: ftype

   nullify(reader)

   select case(ftype)
   case(filetype%xyz)
      reader => read_xyz

   case(filetype%molfile)
      reader => read_molfile

   case(filetype%qcschema)
      reader => read_qcschema

   case(filetype%cjson)
      reader => read_cjson

   case(filetype%pdb)
      reader => read_pdb

   case(filetype%pymatgen)
      reader => read_pymatgen

   case(filetype%gen)
      reader => read_genformat

   case(filetype%sdf)
      reader => read_sdf

   case(filetype%vasp)
      reader => read_vasp

   case(filetype%tmol)
      reader => read_coord

   case(filetype%gaussian)
      reader => read_gaussian_external

   case(filetype%aims)
      reader => read_aims

   case(filetype%qchem)
      reader => read_qchem

   case(filetype%json)
      reader => read_json

   end select

end subroutine get_structure_reader


end module mctc_io_read

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3_param
   use mctc_env, only : wp, error_type, fatal_error
   use dftd3_citation, only : citation_type, author_name, new_citation, &
      & get_citation, doi_dftd3_0, doi_dftd3_bj, doi_dftd3_m, doi_dftd3_op, &
      & doi_dftd3_cso, &
      & doi_gmtkn30_0, doi_gmtkn30_bj, doi_gmtkn55, doi_dsd, doi_dsdpbep86, &
      & doi_drpa, doi_revdsd, doi_pw91_d3, doi_r2scan_d4, doi_scan_d3, &
      & doi_pbeh3c, doi_hse3c, doi_b973c, doi_hf3c, doi_gcp, doi_d3pbc, &
      & doi_r2scan_hyb, doi_r2scan_dhdf, doi_minnesota_d3, doi_b97m_d3, &
      & doi_wb97x_d3, doi_hse06_d3, doi_cf22d, doi_skala
   implicit none

   public :: d3_param
   public :: get_rational_damping, get_zero_damping
   public :: get_mrational_damping, get_mzero_damping
   public :: get_optimizedpower_damping
   public :: get_cso_damping


   type :: d3_param
      real(wp) :: s6 = 1.0_wp
      real(wp) :: s8 = 1.0_wp
      real(wp) :: s9 = 0.0_wp
      real(wp) :: rs6 = 1.0_wp
      real(wp) :: rs8 = 1.0_wp
      real(wp) :: a1 = 0.4_wp
      real(wp) :: a2 = 5.0_wp
      real(wp) :: alp = 14.0_wp
      real(wp) :: bet = 0.0_wp
   end type d3_param


   enum, bind(C)
      enumerator :: p_invalid, &
         & p_bp_df, p_blyp_df, p_revpbe_df, p_rpbe_df, p_b97d_df, p_pbe_df, &
         & p_rpw86pbe_df, p_b3lyp_df, p_b3lyp_g_df, p_tpss_df, p_hf_df, p_tpss0_df, &
         & p_pbe0_df, p_hse06_df, p_revpbe38_df, p_pw6b95_df, p_b2plyp_df, &
         & p_dsdblyp_df, p_dsdblypfc_df, p_bop_df, p_mpwlyp_df, p_olyp_df, &
         & p_pbesol_df, p_bpbe_df, p_opbe_df, p_ssb_df, p_revssb_df, p_otpss_df, &
         & p_b3pw91_df, p_bhlyp_df, p_revpbe0_df, p_tpssh_df, p_mpw1b95_df, &
         & p_pwb6k_df, p_b1b95_df, p_bmk_df, p_camb3lyp_df, p_lcwpbe_df, &
         & p_b2gpplyp_df, p_ptpss_df, p_pwpb95_df, p_hf_mixed_df, p_hf_sv_df, &
         & p_hf_minis_df, p_b3lyp_631gd_df, p_hcth120_df, p_dftb3_df, p_pw1pw_df, &
         & p_pwgga_df, p_hsesol_df, p_hf3c_df, p_hf3cv_df, p_pbeh3c_df, &
         & p_slaterdiracexchange_df, p_m05_df, p_m052x_df, p_m06l_df, p_m06_df, &
         & p_m062x_df, p_m06hf_df, p_pbe38_df, p_mpwb1k_df, p_scan_df, &
         & p_rscan_df, p_r2scan_df, p_wb97x_df, p_b97m_df, p_wb97m_df, &
         & p_pbehpbe_df, p_xlyp_df, p_mpwpw_df, p_hcth407_df, p_revtpss_df, &
         & p_tauhcth_df, p_b3p_df, p_b1p_df, p_b1lyp_df, p_mpw1pw_df, &
         & p_mpw1kcis_df, p_pbeh1pbe_df, p_pbe1kcis_df, p_x3lyp_df, p_o3lyp_df, &
         & p_b97_1_df, p_b97_2_df, p_b98_df, p_hiss_df, p_hse03_df, p_revtpssh_df, &
         & p_revtpss0_df, p_tpss1kcis_df, p_tauhcthhyb_df, p_mn15_df, p_lc_whpbe_df, &
         & p_mpw2plyp_df, p_m11_df, p_sogga11x_df, p_n12sx_df, p_mn12sx_df, p_mn12l_df, &
         & p_ms2_df, p_ms2h_df, p_mpw1lyp_df, p_mpwkcis1k_df, p_pkzb_df, p_n12_df, &
         & p_m08hx_df, p_m11l_df, p_mn15l_df, p_pwp_df, p_r2scanh_df, p_r2scan0_df, &
         & p_r2scan50_df, p_b973c_df, p_dm21_df, p_dm21m_df, p_dm21mc_df, p_dm21mu_df, &
         & p_dsdpbep86_df, p_dsdpbeb95_df, p_dsdpbe_df, p_dodscan66_df, &
         & p_revdsdblyp_df, p_revdsdpbep86_df, p_revdsdpbeb95_df, p_revdsdpbe_df, &
         & p_revdodblyp_df, p_revdodpbep86_df, p_revdodpbeb95_df, p_revdodpbe_df, &
         & p_pw91_df, p_drpa75_df, p_scs_drpa75_df, p_optscs_drpa75_df, &
         & p_dsd_pbe_drpa75_df, p_dsd_pbep86_drpa75_df, p_dsdpbep86_2011_df, &
         & p_dsd_svwn5_df, p_dsd_sp86_df, p_dsd_slyp_df, p_dsd_spbe_df, &
         & p_dsd_bvwn5_df, p_dsd_blyp_2013_df, p_dsd_bpbe_df, p_dsd_bp86_df, &
         & p_dsd_bpw91_df, p_dsd_bb95_df, p_dsd_pbevwn5_df, p_dsd_pbelyp_df, &
         & p_dsd_pbepw91_df, p_dsd_pbehb95_df, p_dsd_pbehp86_df, p_dsd_mpwlyp_df, &
         & p_dsd_mpwpw91_df, p_dsd_mpwp86_df, p_dsd_mpwpbe_df, p_dsd_mpwb95_df, &
         & p_dsd_hsepbe_df, p_dsd_hsepw91_df, p_dsd_hsep86_df, p_dsd_hselyp_df, &
         & p_dsd_tpss_df, p_dsd_tpssb95_df, p_dsd_olyp_df, p_dsd_xlyp_df, &
         & p_dsd_xb95_df, p_dsd_b98_df, p_dsd_bmk_df, p_dsd_thcth_df, &
         & p_dsd_hcth407_df, p_dod_svwn5_df, p_dod_blyp_df, p_dod_pbe_df, &
         & p_dod_pbep86_df, p_dod_pbeb95_df, p_dod_hsep86_df, p_dod_pbehb95_df, &
         & p_cf22d_df, p_skala_df
   end enum

contains


function get_method_id(method) result(id)

   !> Name of the method to look up
   character(len=*), intent(in) :: method

   character(len=len(method)) :: lc_method

   integer :: id
   integer :: i, j

   lc_method = ' '
   j = 0
   do i = 1, len(method)
      if (method(i:i) /= "-") then
         j = j + 1
         lc_method(j:j) = method(i:i)
      end if
   end do
   select case(trim(lowercase(lc_method)))
   case default; id = p_invalid
   case("b1b95", "b88b95"); id = p_b1b95_df
   case("b1lyp"); id = p_b1lyp_df
   case("b1p", "b1p86"); id = p_b1p_df
   case("b2gpplyp"); id = p_b2gpplyp_df
   case("b2plyp"); id = p_b2plyp_df
   case("b3lyp", "b3lyp5"); id = p_b3lyp_df
   case("b3lypg", "b3lyp3"); id = p_b3lyp_g_df
   case("b3lyp/631gd"); id = p_b3lyp_631gd_df
   case("b3p", "b3p86"); id = p_b3p_df
   case("b3pw91"); id = p_b3pw91_df
   case("b971"); id = p_b97_1_df
   case("b972"); id = p_b97_2_df
   case("b97d"); id = p_b97d_df
   case("b973c"); id = p_b973c_df
   case("b97m"); id = p_b97m_df
   case("b98"); id = p_b98_df
   case("bhlyp", "bhandhlyp"); id = p_bhlyp_df
   case("blyp"); id = p_blyp_df
   case("bmk"); id = p_bmk_df
   case("bop"); id = p_bop_df
   case("bp", "bp86"); id = p_bp_df
   case("bpbe"); id = p_bpbe_df
   case("camb3lyp"); id = p_camb3lyp_df
   case("cf22d"); id = p_cf22d_df
   case("dftb3"); id = p_dftb3_df
   case("dm21"); id = p_dm21_df
   case("dm21m"); id = p_dm21m_df
   case("dm21mc"); id = p_dm21mc_df
   case("dm21mu"); id = p_dm21mu_df
   case("drpa75"); id = p_drpa75_df
   case("dsdsvwn5"); id = p_dsd_svwn5_df
   case("dsdsp86"); id = p_dsd_sp86_df
   case("dsdslyp"); id = p_dsd_slyp_df
   case("dsdspbe"); id = p_dsd_spbe_df
   case("dsdbvwn5"); id = p_dsd_bvwn5_df
   case("dsdblyp"); id = p_dsdblyp_df
   case("dsdblyp_2013"); id = p_dsd_blyp_2013_df
   case("dsdblypfc"); id = p_dsdblypfc_df
   case("dsdbpbe"); id = p_dsd_bpbe_df
   case("dsdbp86"); id = p_dsd_bp86_df
   case("dsdbpw91"); id = p_dsd_bpw91_df
   case("dsdbb95"); id = p_dsd_bb95_df
   case("dsdpbevwn5"); id = p_dsd_pbevwn5_df
   case("dsdpbelyp"); id = p_dsd_pbelyp_df
   case("dsdpbe", "dsdpbepbe"); id = p_dsdpbe_df
   case("dsdpbedrpa75"); id = p_dsd_pbe_drpa75_df
   case("dsdpbep86"); id = p_dsdpbep86_df
   case("dsdpbep86_2011"); id = p_dsdpbep86_2011_df
   case("dsdpbep86drpa75"); id = p_dsd_pbep86_drpa75_df
   case("dsdpbepw91"); id = p_dsd_pbepw91_df
   case("dsdpbeb95"); id = p_dsdpbeb95_df
   case("dsdpbehb95"); id = p_dsd_pbehb95_df
   case("dsdpbehp86"); id = p_dsd_pbehp86_df
   case("dsdmpwlyp"); id = p_dsd_mpwlyp_df
   case("dsdmpwpw91"); id = p_dsd_mpwpw91_df
   case("dsdmpwp86"); id = p_dsd_mpwp86_df
   case("dsdmpwpbe"); id = p_dsd_mpwpbe_df
   case("dsdmpwb95"); id = p_dsd_mpwb95_df
   case("dsdhsepbe"); id = p_dsd_hsepbe_df
   case("dsdhsepw91"); id = p_dsd_hsepw91_df
   case("dsdhsep86"); id = p_dsd_hsep86_df
   case("dsdhselyp"); id = p_dsd_hselyp_df
   case("dsdtpss", "dsdtpsstpss"); id = p_dsd_tpss_df
   case("dsdtpssb95"); id = p_dsd_tpssb95_df
   case("dsdolyp"); id = p_dsd_olyp_df
   case("dsdxlyp"); id = p_dsd_xlyp_df
   case("dsdxb95"); id = p_dsd_xb95_df
   case("dsdb98"); id = p_dsd_b98_df
   case("dsdbmk"); id = p_dsd_bmk_df
   case("dsdthcth"); id = p_dsd_thcth_df
   case("dsdhcth407"); id = p_dsd_hcth407_df
   case("dodsvwn5"); id = p_dod_svwn5_df
   case("dodblyp"); id = p_dod_blyp_df
   case("dodpbe", "dodpbepbe"); id = p_dod_pbe_df
   case("dodpbep86"); id = p_dod_pbep86_df
   case("dodpbeb95"); id = p_dod_pbeb95_df
   case("dodhsep86"); id = p_dod_hsep86_df
   case("dodpbehb95"); id = p_dod_pbehb95_df
   case("dodscan66"); id = p_dodscan66_df
   case("hcth120"); id = p_hcth120_df
   case("hcth407", "hcth/407"); id = p_hcth407_df
   case("hf"); id = p_hf_df
   case("hf/minis"); id = p_hf_minis_df
   case("hf/mixed"); id = p_hf_mixed_df
   case("hf/sv"); id = p_hf_sv_df
   case("hf3c"); id = p_hf3c_df
   case("hf3cv"); id = p_hf3cv_df
   case("hiss"); id = p_hiss_df
   case("hse03"); id = p_hse03_df
   case("hse06"); id = p_hse06_df
   case("hsesol"); id = p_hsesol_df
   case("lcwhpbe", "lcomegahpbe", "lcωhpbe"); id = p_lc_whpbe_df
   case("lcwpbe"); id = p_lcwpbe_df
   case("m05"); id = p_m05_df
   case("m052x"); id = p_m052x_df
   case("m06"); id = p_m06_df
   case("m062x"); id = p_m062x_df
   case("m06hf"); id = p_m06hf_df
   case("m06l"); id = p_m06l_df
   case("m08hx"); id = p_m08hx_df
   case("m11"); id = p_m11_df
   case("m11l"); id = p_m11l_df
   case("mn12l"); id = p_mn12l_df
   case("mn12sx"); id = p_mn12sx_df
   case("mn15"); id = p_mn15_df
   case("mn15l"); id = p_mn15l_df
   case("mpw1b95"); id = p_mpw1b95_df
   case("mpw1kcis"); id = p_mpw1kcis_df
   case("mpw1pw", "mpw1pw91"); id = p_mpw1pw_df
   case("mpw2plyp"); id = p_mpw2plyp_df
   case("mpwb1k"); id = p_mpwb1k_df
   case("mpwlyp"); id = p_mpwlyp_df
   case("mpwpw", "mpwpw91"); id = p_mpwpw_df
   case("mpw1lyp"); id = p_mpw1lyp_df
   case("mpwkcis1k"); id = p_mpwkcis1k_df
   case("ms2"); id = p_ms2_df
   case("ms2h"); id = p_ms2h_df
   case("n12"); id = p_n12_df
   case("n12sx"); id = p_n12sx_df
   case("o3lyp"); id = p_o3lyp_df
   case("olyp"); id = p_olyp_df
   case("opbe"); id = p_opbe_df
   case("optscsdrpa75"); id = p_optscs_drpa75_df
   case("otpss"); id = p_otpss_df
   case("pbe"); id = p_pbe_df
   case("pbe0", "pbeh"); id = p_pbe0_df
   case("pbe1kcis"); id = p_pbe1kcis_df
   case("pbe38"); id = p_pbe38_df
   case("pbeh1pbe"); id = p_pbeh1pbe_df
   case("pbeh3c"); id = p_pbeh3c_df
   case("pbehpbe"); id = p_pbehpbe_df
   case("pbesol"); id = p_pbesol_df
   case("pkzb"); id = p_pkzb_df
   case("ptpss"); id = p_ptpss_df
   case("pwp", "pw91p86"); id = p_pwp_df
   case("pw1pw"); id = p_pw1pw_df
   case("pw6b95"); id = p_pw6b95_df
   case("pw91"); id = p_pw91_df
   case("pwb6k"); id = p_pwb6k_df
   case("pwgga"); id = p_pwgga_df
   case("pwpb95"); id = p_pwpb95_df
   case("r2scan"); id = p_r2scan_df
   case("r2scanh"); id = p_r2scanh_df
   case("r2scan0"); id = p_r2scan0_df
   case("r2scan50"); id = p_r2scan50_df
   case("revdodblyp"); id = p_revdodblyp_df
   case("revdodpbe"); id = p_revdodpbe_df
   case("revdodpbep86"); id = p_revdodpbep86_df
   case("revdodpbeb95"); id = p_revdodpbeb95_df
   case("revdsdblyp"); id = p_revdsdblyp_df
   case("revdsdpbe"); id = p_revdsdpbe_df
   case("revdsdpbep86"); id = p_revdsdpbep86_df
   case("revdsdpbeb95"); id = p_revdsdpbeb95_df
   case("revpbe"); id = p_revpbe_df
   case("revpbe0"); id = p_revpbe0_df
   case("revpbe38"); id = p_revpbe38_df
   case("revssb"); id = p_revssb_df
   case("revtpss"); id = p_revtpss_df
   case("revtpss0"); id = p_revtpss0_df
   case("revtpssh"); id = p_revtpssh_df
   case("rpbe"); id = p_rpbe_df
   case("rpw86pbe"); id = p_rpw86pbe_df
   case("rscan"); id = p_rscan_df
   case("scan"); id = p_scan_df
   case("scsdrpa75"); id = p_scs_drpa75_df
   case("skala1.0"); id = p_skala_df
   case("slaterdiracexchange"); id = p_slaterdiracexchange_df
   case("sogga11x"); id = p_sogga11x_df
   case("ssb"); id = p_ssb_df
   case("tauhcth", "τhcth"); id = p_tauhcth_df
   case("tauhcthhyb", "τhcthhyb"); id = p_tauhcthhyb_df
   case("tpss"); id = p_tpss_df
   case("tpss0"); id = p_tpss0_df
   case("tpss1kcis"); id = p_tpss1kcis_df
   case("tpssh"); id = p_tpssh_df
   case("wb97m"); id = p_wb97m_df
   case("wb97x"); id = p_wb97x_df
   case("x3lyp"); id = p_x3lyp_df
   case("xlyp"); id = p_xlyp_df
   end select

end function get_method_id


subroutine get_rational_damping(param, method, error, s9, citation)

   !> Loaded parameter record
   type(d3_param), intent(out) :: param

   !> Name of the method to look up
   character(len=*), intent(in) :: method

   !> Overwrite s9
   real(wp), intent(in), optional :: s9

   !> Citation information
   type(citation_type), intent(out), optional :: citation

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=:), allocatable :: doi

   select case(get_method_id(method))
   case default
      call fatal_error(error, "No entry for '"//method//"' present")
      return
   case(p_bp_df)
      param = d3_param(a1=0.3946_wp, s8=3.2822_wp, a2=4.8516_wp)
      doi = doi_dftd3_bj
   case(p_blyp_df)
      param = d3_param(a1=0.4298_wp, s8=2.6996_wp, a2=4.2359_wp)
      doi = doi_dftd3_bj
   case(p_revpbe_df)
      param = d3_param(a1=0.5238_wp, s8=2.3550_wp, a2=3.5016_wp)
      doi = doi_dftd3_bj
   case(p_rpbe_df)
      param = d3_param(a1=0.1820_wp, s8=0.8318_wp, a2=4.0094_wp)
      ! TODO: find reference (it is not GMTKN55)
   case(p_b97d_df)
      param = d3_param(a1=0.5545_wp, s8=2.2609_wp, a2=3.2297_wp)
      doi = doi_dftd3_bj
   case(p_b973c_df)
      param = d3_param(a1=0.37_wp, s8=1.50_wp, a2=4.10_wp)
      doi = doi_b973c
   case(p_pbe_df)
      param = d3_param(a1=0.4289_wp, s8=0.7875_wp, a2=4.4407_wp)
      doi = doi_dftd3_bj
   case(p_rpw86pbe_df)
      param = d3_param(a1=0.4613_wp, s8=1.3845_wp, a2=4.5062_wp)
      doi = doi_dftd3_bj
   case(p_b3lyp_df, p_b3lyp_g_df, p_dm21_df, p_dm21m_df, p_dm21mc_df, p_dm21mu_df)
      param = d3_param(a1=0.3981_wp, s8=1.9889_wp, a2=4.4211_wp)
      doi = doi_dftd3_bj
   case(p_skala_df)
      param = d3_param(a1=0.3981_wp, s8=1.9889_wp, a2=4.4211_wp)
      doi = doi_skala
   case(p_tpss_df)
      param = d3_param(a1=0.4535_wp, s8=1.9435_wp, a2=4.4752_wp)
      doi = doi_dftd3_bj
   case(p_hf_df)
      param = d3_param(a1=0.3385_wp, s8=0.9171_wp, a2=2.8830_wp)
      doi = doi_dftd3_bj
   case(p_tpss0_df)
      param = d3_param(a1=0.3768_wp, s8=1.2576_wp, a2=4.5865_wp)
      doi = doi_dftd3_bj
   case(p_pbe0_df)
      param = d3_param(a1=0.4145_wp, s8=1.2177_wp, a2=4.8593_wp)
      doi = doi_dftd3_bj
   case(p_hse06_df)
      param = d3_param(a1=0.383_wp, s8=2.310_wp, a2=5.685_wp)
      doi = doi_hse06_d3
   case(p_revpbe38_df)
      param = d3_param(a1=0.4309_wp, s8=1.4760_wp, a2=3.9446_wp)
      doi = doi_gmtkn30_bj
   case(p_pw6b95_df)
      param = d3_param(a1=0.2076_wp, s8=0.7257_wp, a2=6.3750_wp)
      doi = doi_gmtkn30_bj
   case(p_b2plyp_df)
      param = d3_param(a1=0.3065_wp, s8=0.9147_wp, a2=5.0570_wp, s6=0.64_wp)
      doi = doi_gmtkn30_bj
   case(p_dsdblyp_df)
      param = d3_param(a1=0.0000_wp, s8=0.2130_wp, a2=6.0519_wp, s6=0.50_wp)
      doi = doi_gmtkn30_bj
   case(p_dsdblypfc_df)
      param = d3_param(a1=0.0009_wp, s8=0.2112_wp, a2=5.9807_wp, s6=0.50_wp)
      doi = doi_gmtkn30_bj
   case(p_bop_df)
      param = d3_param(a1=0.4870_wp, s8=3.2950_wp, a2=3.5043_wp)
      doi = doi_gmtkn30_bj
   case(p_mpwlyp_df)
      param = d3_param(a1=0.4831_wp, s8=2.0077_wp, a2=4.5323_wp)
      doi = doi_gmtkn30_bj
   case(p_olyp_df)
      param = d3_param(a1=0.5299_wp, s8=2.6205_wp, a2=2.8065_wp)
      doi = doi_gmtkn30_bj
   case(p_pbesol_df)
      param = d3_param(a1=0.4466_wp, s8=2.9491_wp, a2=6.1742_wp)
      doi = doi_gmtkn30_bj
   case(p_bpbe_df)
      param = d3_param(a1=0.4567_wp, s8=4.0728_wp, a2=4.3908_wp)
      doi = doi_gmtkn30_bj
   case(p_opbe_df)
      param = d3_param(a1=0.5512_wp, s8=3.3816_wp, a2=2.9444_wp)
      doi = doi_gmtkn30_bj
   case(p_ssb_df)
      param = d3_param(a1=-0.0952_wp, s8=-0.1744_wp, a2=5.2170_wp)
      doi = doi_gmtkn30_bj
   case(p_revssb_df)
      param = d3_param(a1=0.4720_wp, s8=0.4389_wp, a2=4.0986_wp)
      doi = doi_gmtkn30_bj
   case(p_otpss_df)
      param = d3_param(a1=0.4634_wp, s8=2.7495_wp, a2=4.3153_wp)
      doi = doi_gmtkn30_bj
   case(p_b3pw91_df)
      param = d3_param(a1=0.4312_wp, s8=2.8524_wp, a2=4.4693_wp)
      doi = doi_gmtkn30_bj
   case(p_bhlyp_df)
      param = d3_param(a1=0.2793_wp, s8=1.0354_wp, a2=4.9615_wp)
      doi = doi_gmtkn30_bj
   case(p_revpbe0_df)
      param = d3_param(a1=0.4679_wp, s8=1.7588_wp, a2=3.7619_wp)
      doi = doi_gmtkn30_bj
   case(p_tpssh_df)
      param = d3_param(a1=0.4529_wp, s8=2.2382_wp, a2=4.6550_wp)
      doi = doi_gmtkn30_bj
   case(p_mpw1b95_df)
      param = d3_param(a1=0.1955_wp, s8=1.0508_wp, a2=6.4177_wp)
      doi = doi_gmtkn30_bj
   case(p_pwb6k_df)
      param = d3_param(a1=0.1805_wp, s8=0.9383_wp, a2=7.7627_wp)
      doi = doi_gmtkn30_bj
   case(p_b1b95_df)
      param = d3_param(a1=0.2092_wp, s8=1.4507_wp, a2=5.5545_wp)
      doi = doi_gmtkn30_bj
   case(p_bmk_df)
      param = d3_param(a1=0.1940_wp, s8=2.0860_wp, a2=5.9197_wp)
      doi = doi_gmtkn30_bj
   case(p_camb3lyp_df)
      param = d3_param(a1=0.3708_wp, s8=2.0674_wp, a2=5.4743_wp)
      doi = doi_gmtkn30_bj
   case(p_lcwpbe_df)
      param = d3_param(a1=0.3919_wp, s8=1.8541_wp, a2=5.0897_wp)
      doi = doi_gmtkn30_bj
   case(p_b2gpplyp_df)
      param = d3_param(a1=0.0000_wp, s8=0.2597_wp, a2=6.3332_wp, s6=0.560_wp)
      doi = doi_gmtkn30_bj
   case(p_ptpss_df)
      param = d3_param(a1=0.0000_wp, s8=0.2804_wp, a2=6.5745_wp, s6=0.750_wp)
      doi = doi_gmtkn30_bj
   case(p_pwpb95_df)
      param = d3_param(a1=0.0000_wp, s8=0.2904_wp, a2=7.3141_wp, s6=0.820_wp)
      doi = doi_gmtkn30_bj
   case(p_pw91_df)
      param = d3_param(a1=0.6319_wp, s8=1.9598_wp, a2=4.5718_wp)
      doi = doi_pw91_d3
   case(p_hf_mixed_df)
      param = d3_param(a1=0.5607_wp, s8=3.9027_wp, a2=4.5622_wp)
      doi = doi_gcp
   case(p_hf_sv_df)
      param = d3_param(a1=0.4249_wp, s8=2.1849_wp, a2=4.2783_wp)
      doi = doi_gcp
   case(p_hf_minis_df)
      param = d3_param(a1=0.1702_wp, s8=0.9841_wp, a2=3.8506_wp)
      doi = doi_gcp
   case(p_b3lyp_631gd_df)
      param = d3_param(a1=0.5014_wp, s8=4.0672_wp, a2=4.8409_wp)
      doi = doi_gcp
   case(p_hcth120_df)
      param = d3_param(a1=0.3563_wp, s8=1.0821_wp, a2=4.3359_wp)
      ! TODO: find reference
   case(p_dftb3_df)
      param = d3_param(a1=0.5719_wp, s8=0.5883_wp, a2=3.6017_wp)
      ! TODO: find reference
   case(p_pw1pw_df)
      param = d3_param(a1=0.3807_wp, s8=2.3363_wp, a2=5.8844_wp)
      doi = doi_gmtkn55
   case(p_pwgga_df)
      param = d3_param(a1=0.2211_wp, s8=2.6910_wp, a2=6.7278_wp)
      ! TODO: find reference
   case(p_hsesol_df)
      param = d3_param(a1=0.4650_wp, s8=2.9215_wp, a2=6.2003_wp)
      ! TODO: find reference
   case(p_hf3c_df)
      param = d3_param(a1=0.4171_wp, s8=0.8777_wp, a2=2.9149_wp)
      doi = doi_hf3c
   case(p_hf3cv_df)
      param = d3_param(a1=0.3063_wp, s8=0.5022_wp, a2=3.9856_wp)
      doi = doi_hf3c
   case(p_pbeh3c_df)
      param = d3_param(a1=0.4860_wp, s8=0.0000_wp, a2=4.5000_wp)
      doi = doi_pbeh3c
   case(p_scan_df)
      param = d3_param(a1=0.5380_wp, s8=0.0000_wp, a2=5.4200_wp)
      doi = doi_scan_d3
   case(p_rscan_df)
      param = d3_param(a1=0.47023427_wp, s8=1.08859014_wp, a2=5.73408312_wp)
      doi = doi_r2scan_d4
   case(p_r2scan_df)
      param = d3_param(a1=0.49484001_wp, s8=0.78981345_wp, a2=5.73083694_wp)
      doi = doi_r2scan_d4
   case(p_r2scanh_df)
      param = d3_param(s8=1.1236_wp, a1=0.4709_wp, a2=5.9157_wp)
      doi = doi_r2scan_hyb
   case(p_r2scan0_df)
      param = d3_param(s8=1.1846_wp, a1=0.4534_wp, a2=5.8972_wp)
      doi = doi_r2scan_hyb
   case(p_r2scan50_df)
      param = d3_param(s8=1.3294_wp, a1=0.4311_wp, a2=5.9240_wp)
      doi = doi_r2scan_hyb
   case(p_wb97x_df)
      param = d3_param(a1=0.0000_wp, s8=0.2641_wp, a2=5.4959_wp)
      ! TODO: find reference
   case(p_wb97m_df)
      param = d3_param(a1=0.5660_wp, s8=0.3908_wp, a2=3.1280_wp)
      doi = doi_b97m_d3
   case(p_b97m_df)
      param = d3_param(a1=-0.0780_wp, s8=0.1384_wp, a2=5.5946_wp)
      doi = doi_b97m_d3
   case(p_pbehpbe_df)
      param = d3_param(a1=0.0000_wp, s8=1.1152_wp, a2=6.7184_wp)
      doi = doi_gmtkn55
   case(p_xlyp_df)
      param = d3_param(a1=0.0809_wp, s8=1.5669_wp, a2=5.3166_wp)
      doi = doi_gmtkn55
   case(p_mpwpw_df)
      param = d3_param(a1=0.3168_wp, s8=1.7974_wp, a2=4.7732_wp)
      doi = doi_gmtkn55
   case(p_hcth407_df)
      param = d3_param(a1=0.0000_wp, s8=0.6490_wp, a2=4.8162_wp)
      doi = doi_gmtkn55
   case(p_revtpss_df)
      param = d3_param(a1=0.4426_wp, s8=1.4023_wp, a2=4.4723_wp)
      doi = doi_gmtkn55
   case(p_tauhcth_df)
      param = d3_param(a1=0.0000_wp, s8=1.2626_wp, a2=5.6162_wp)
      doi = doi_gmtkn55
   case(p_b3p_df)
      param = d3_param(a1=0.4601_wp, s8=3.3211_wp, a2=4.9294_wp)
      doi = doi_gmtkn55
   case(p_b1p_df)
      param = d3_param(a1=0.4724_wp, s8=3.5681_wp, a2=4.9858_wp)
      doi = doi_gmtkn55
   case(p_b1lyp_df)
      param = d3_param(a1=0.1986_wp, s8=2.1167_wp, a2=5.3875_wp)
      doi = doi_gmtkn55
   case(p_mpwb1k_df)
      param = d3_param(a1=0.1474_wp, s8=0.9499_wp, a2=6.6223_wp)
      doi = doi_gmtkn55
   case(p_mpw1pw_df)
      param = d3_param(a1=0.3342_wp, s8=1.8744_wp, a2=4.9819_wp)
      doi = doi_gmtkn55
   case(p_mpw1kcis_df)
      param = d3_param(a1=0.0576_wp, s8=1.0893_wp, a2=5.5314_wp)
      doi = doi_gmtkn55
   case(p_mpwkcis1k_df)
      param = d3_param(a1=0.0855_wp, s8=1.2875_wp, a2=5.8961_wp)
      doi = doi_gmtkn55
   case(p_pbeh1pbe_df)
      param = d3_param(a1=0.0000_wp, s8=1.4877_wp, a2=7.0385_wp)
      doi = doi_gmtkn55
   case(p_pbe1kcis_df)
      param = d3_param(a1=0.0000_wp, s8=0.7688_wp, a2=6.2794_wp)
      doi = doi_gmtkn55
   case(p_x3lyp_df)
      param = d3_param(a1=0.2022_wp, s8=1.5744_wp, a2=5.4184_wp)
      doi = doi_gmtkn55
   case(p_o3lyp_df)
      param = d3_param(a1=0.0963_wp, s8=1.8171_wp, a2=5.9940_wp)
      doi = doi_gmtkn55
   case(p_b97_1_df)
      param = d3_param(a1=0.0000_wp, s8=0.4814_wp, a2=6.2279_wp)
      doi = doi_gmtkn55
   case(p_b97_2_df)
      param = d3_param(a1=0.0000_wp, s8=0.9448_wp, a2=5.4603_wp)
      doi = doi_gmtkn55
   case(p_b98_df)
      param = d3_param(a1=0.0000_wp, s8=0.7086_wp, a2=6.0672_wp)
      doi = doi_gmtkn55
   case(p_hiss_df)
      param = d3_param(a1=0.0000_wp, s8=1.6112_wp, a2=7.3539_wp)
      doi = doi_gmtkn55
   case(p_hse03_df)
      param = d3_param(a1=0.0000_wp, s8=1.1243_wp, a2=6.8889_wp)
      doi = doi_gmtkn55
   case(p_revtpssh_df)
      param = d3_param(a1=0.2660_wp, s8=1.4076_wp, a2=5.3761_wp)
      doi = doi_gmtkn55
   case(p_revtpss0_df)
      param = d3_param(a1=0.2218_wp, s8=1.6151_wp, a2=5.7985_wp)
      doi = doi_gmtkn55
   case(p_tpss1kcis_df)
      param = d3_param(a1=0.0000_wp, s8=1.0542_wp, a2=6.0201_wp)
      doi = doi_gmtkn55
   case(p_tauhcthhyb_df)
      param = d3_param(a1=0.0000_wp, s8=0.9585_wp, a2=10.1389_wp)
      doi = doi_gmtkn55
   case(p_m11_df)
      param = d3_param(a1=0.0000_wp, s8=2.8112_wp, a2=10.1389_wp)
      doi = doi_minnesota_d3
   case(p_sogga11x_df)
      param = d3_param(a1=0.1330_wp, s8=1.1426_wp, a2=5.7381_wp)
      doi = doi_minnesota_d3
   case(p_n12sx_df)
      param = d3_param(a1=0.3283_wp, s8=2.4900_wp, a2=5.7898_wp)
      doi = doi_minnesota_d3
   case(p_mn12sx_df)
      param = d3_param(a1=0.0983_wp, s8=1.1674_wp, a2=8.0259_wp)
      doi = doi_minnesota_d3
   case(p_mn12l_df)
      param = d3_param(a1=0.0000_wp, s8=2.2674_wp, a2=9.1494_wp)
      doi = doi_minnesota_d3
   case(p_mn15_df)
      param = d3_param(a1=2.0971_wp, s8=0.7862_wp, a2=7.5923_wp)
      doi = doi_gmtkn55
   case(p_lc_whpbe_df)
      param = d3_param(a1=0.2746_wp, s8=1.1908_wp, a2=5.3157_wp)
      doi = doi_gmtkn55
   case(p_mpw2plyp_df)
      param = d3_param(s6=0.66_wp, a1=0.4105_wp, s8=0.6223_wp, a2=5.0136_wp)
      doi = doi_gmtkn55
   case(p_dodscan66_df)
      param = d3_param(s6=0.3152_wp, a1=0.0_wp, s8=0.0_wp, a2=5.75_wp)
      doi = doi_revdsd
   case(p_revdsdblyp_df)
      param = d3_param(s6=0.5451_wp, a1=0.0_wp, s8=0.0_wp, a2=5.2_wp)
      doi = doi_revdsd
   case(p_revdsdpbep86_df)
      param = d3_param(s6=0.4377_wp, a1=0.0_wp, s8=0.0_wp, a2=5.5_wp)
      doi = doi_revdsd
   case(p_revdsdpbeb95_df)
      param = d3_param(s6=0.3686_wp, a1=0.0_wp, s8=0.0_wp, a2=5.5_wp)
      doi = doi_revdsd
   case(p_revdsdpbe_df)
      param = d3_param(s6=0.5746_wp, a1=0.0_wp, s8=0.0_wp, a2=5.5_wp)
      doi = doi_revdsd
   case(p_revdodblyp_df)
      param = d3_param(s6=0.6145_wp, a1=0.0_wp, s8=0.0_wp, a2=5.2_wp)
      doi = doi_revdsd
   case(p_revdodpbep86_df)
      param = d3_param(s6=0.4770_wp, a1=0.0_wp, s8=0.0_wp, a2=5.5_wp)
      doi = doi_revdsd
   case(p_revdodpbeb95_df)
      param = d3_param(s6=0.4107_wp, a1=0.0_wp, s8=0.0_wp, a2=5.5_wp)
      doi = doi_revdsd
   case(p_revdodpbe_df)
      param = d3_param(s6=0.6067_wp, a1=0.0_wp, s8=0.0_wp, a2=5.5_wp)
      doi = doi_revdsd
   case(p_drpa75_df)
      param = d3_param(s6=0.3754_wp, a1=0.0_wp, s8=0.0_wp, a2=4.5048_wp)
      doi = doi_drpa
   case(p_scs_drpa75_df)
      param = d3_param(s6=0.2528_wp, a1=0.0_wp, s8=0.0_wp, a2=4.5050_wp)
      doi = doi_drpa
   case(p_optscs_drpa75_df)
      param = d3_param(s6=0.2546_wp, a1=0.0_wp, s8=0.0_wp, a2=4.5050_wp)
      doi = doi_drpa
   case(p_dsd_pbe_drpa75_df)
      param = d3_param(s6=0.3223_wp, a1=0.0_wp, s8=0.0_wp, a2=4.5050_wp)
      doi = doi_drpa
   case(p_dsd_pbep86_drpa75_df)
      param = d3_param(s6=0.3012_wp, a1=0.0_wp, s8=0.0_wp, a2=4.5050_wp)
      doi = doi_drpa
   case(p_dsdpbep86_2011_df)
      param = d3_param(s6=0.418_wp, a1=0.0_wp, s8=0.0_wp, a2=5.65_wp)
      doi = doi_dsd
   case(p_dsd_svwn5_df)
      param = d3_param(s6=0.46_wp, a1=0.0_wp, s8=0.0_wp, a2=5.6_wp)
      doi = doi_dsd
   case(p_dsd_sp86_df)
      param = d3_param(s6=0.30_wp, a1=0.0_wp, s8=0.0_wp, a2=5.8_wp)
      doi = doi_dsd
   case(p_dsd_slyp_df)
      param = d3_param(s6=0.30_wp, a1=0.0_wp, s8=0.0_wp, a2=5.6_wp)
      doi = doi_dsd
   case(p_dsd_spbe_df)
      param = d3_param(s6=0.40_wp, a1=0.0_wp, s8=0.0_wp, a2=6.0_wp)
      doi = doi_dsd
   case(p_dsd_bvwn5_df)
      param = d3_param(s6=0.61_wp, a1=0.0_wp, s8=0.0_wp, a2=5.2_wp)
      doi = doi_dsd
   case(p_dsd_blyp_2013_df)
      param = d3_param(s6=0.57_wp, a1=0.0_wp, s8=0.0_wp, a2=5.4_wp)
      doi = doi_dsd
   case(p_dsd_bpbe_df)
      param = d3_param(s6=1.22_wp, a1=0.0_wp, s8=0.0_wp, a2=6.6_wp)
      doi = doi_dsd
   case(p_dsd_bp86_df)
      param = d3_param(s6=0.76_wp, a1=0.0_wp, s8=0.0_wp, a2=6.0_wp)
      doi = doi_dsd
   case(p_dsd_bpw91_df)
      param = d3_param(s6=1.14_wp, a1=0.0_wp, s8=0.0_wp, a2=6.5_wp)
      doi = doi_dsd
   case(p_dsd_bb95_df)
      param = d3_param(s6=1.02_wp, a1=0.0_wp, s8=0.0_wp, a2=6.8_wp)
      doi = doi_dsd
   case(p_dsd_pbevwn5_df)
      param = d3_param(s6=0.54_wp, a1=0.0_wp, s8=0.0_wp, a2=5.1_wp)
      doi = doi_dsd
   case(p_dsd_pbelyp_df)
      param = d3_param(s6=0.43_wp, a1=0.0_wp, s8=0.0_wp, a2=5.2_wp)
      doi = doi_dsd
   case(p_dsdpbe_df)
      param = d3_param(s6=0.78_wp, a1=0.0_wp, s8=0.0_wp, a2=6.1_wp)
      doi = doi_dsd
   case(p_dsdpbep86_df)
      param = d3_param(s6=0.48_wp, a1=0.0_wp, s8=0.0_wp, a2=5.6_wp)
      doi = doi_dsd
   case(p_dsd_pbepw91_df)
      param = d3_param(s6=0.73_wp, a1=0.0_wp, s8=0.0_wp, a2=6.0_wp)
      doi = doi_dsd
   case(p_dsdpbeb95_df)
      param = d3_param(s6=0.61_wp, a1=0.0_wp, s8=0.0_wp, a2=6.2_wp)
      doi = doi_dsd
   case(p_dsd_pbehb95_df)
      param = d3_param(s6=0.58_wp, a1=0.0_wp, s8=0.0_wp, a2=6.2_wp)
      doi = doi_dsd
   case(p_dsd_pbehp86_df)
      param = d3_param(s6=0.46_wp, a1=0.0_wp, s8=0.0_wp, a2=5.6_wp)
      doi = doi_dsd
   case(p_dsd_mpwlyp_df)
      param = d3_param(s6=0.48_wp, a1=0.0_wp, s8=0.0_wp, a2=5.3_wp)
      doi = doi_dsd
   case(p_dsd_mpwpw91_df)
      param = d3_param(s6=0.90_wp, a1=0.0_wp, s8=0.0_wp, a2=6.2_wp)
      doi = doi_dsd
   case(p_dsd_mpwp86_df)
      param = d3_param(s6=0.59_wp, a1=0.0_wp, s8=0.0_wp, a2=5.8_wp)
      doi = doi_dsd
   case(p_dsd_mpwpbe_df)
      param = d3_param(s6=0.96_wp, a1=0.0_wp, s8=0.0_wp, a2=6.3_wp)
      doi = doi_dsd
   case(p_dsd_mpwb95_df)
      param = d3_param(s6=0.82_wp, a1=0.0_wp, s8=0.0_wp, a2=6.6_wp)
      doi = doi_dsd
   case(p_dsd_hsepbe_df)
      param = d3_param(s6=0.79_wp, a1=0.0_wp, s8=0.0_wp, a2=6.1_wp)
      doi = doi_dsd
   case(p_dsd_hsepw91_df)
      param = d3_param(s6=0.74_wp, a1=0.0_wp, s8=0.0_wp, a2=6.0_wp)
      doi = doi_dsd
   case(p_dsd_hsep86_df)
      param = d3_param(s6=0.46_wp, a1=0.0_wp, s8=0.0_wp, a2=5.6_wp)
      doi = doi_dsd
   case(p_dsd_hselyp_df)
      param = d3_param(s6=0.40_wp, a1=0.0_wp, s8=0.0_wp, a2=5.2_wp)
      doi = doi_dsd
   case(p_dsd_tpss_df)
      param = d3_param(s6=0.72_wp, a1=0.0_wp, s8=0.0_wp, a2=6.5_wp)
      doi = doi_dsd
   case(p_dsd_tpssb95_df)
      param = d3_param(s6=0.91_wp, a1=0.0_wp, s8=0.0_wp, a2=7.9_wp)
      doi = doi_dsd
   case(p_dsd_olyp_df)
      param = d3_param(s6=0.93_wp, a1=0.0_wp, s8=0.0_wp, a2=5.8_wp)
      doi = doi_dsd
   case(p_dsd_xlyp_df)
      param = d3_param(s6=0.51_wp, a1=0.0_wp, s8=0.0_wp, a2=5.3_wp)
      doi = doi_dsd
   case(p_dsd_xb95_df)
      param = d3_param(s6=0.92_wp, a1=0.0_wp, s8=0.0_wp, a2=6.7_wp)
      doi = doi_dsd
   case(p_dsd_b98_df)
      param = d3_param(s6=0.07_wp, a1=0.0_wp, s8=0.0_wp, a2=3.7_wp)
      doi = doi_dsd
   case(p_dsd_bmk_df)
      param = d3_param(s6=0.17_wp, a1=0.0_wp, s8=0.0_wp, a2=3.9_wp)
      doi = doi_dsd
   case(p_dsd_thcth_df)
      param = d3_param(s6=0.39_wp, a1=0.0_wp, s8=0.0_wp, a2=4.8_wp)
      doi = doi_dsd
   case(p_dsd_hcth407_df)
      param = d3_param(s6=0.53_wp, a1=0.0_wp, s8=0.0_wp, a2=5.0_wp)
      doi = doi_dsd
   case(p_dod_svwn5_df)
      param = d3_param(s6=0.57_wp, a1=0.0_wp, s8=0.0_wp, a2=5.6_wp)
      doi = doi_dsd
   case(p_dod_blyp_df)
      param = d3_param(s6=0.96_wp, a1=0.0_wp, s8=0.0_wp, a2=5.1_wp)
      doi = doi_dsd
   case(p_dod_pbe_df)
      param = d3_param(s6=0.91_wp, a1=0.0_wp, s8=0.0_wp, a2=5.9_wp)
      doi = doi_dsd
   case(p_dod_pbep86_df)
      param = d3_param(s6=0.72_wp, a1=0.0_wp, s8=0.0_wp, a2=5.4_wp)
      doi = doi_dsd
   case(p_dod_pbeb95_df)
      param = d3_param(s6=0.71_wp, a1=0.0_wp, s8=0.0_wp, a2=6.0_wp)
      doi = doi_dsd
   case(p_dod_hsep86_df)
      param = d3_param(s6=0.69_wp, a1=0.0_wp, s8=0.0_wp, a2=5.4_wp)
      doi = doi_dsd
   case(p_dod_pbehb95_df)
      param = d3_param(s6=0.67_wp, a1=0.0_wp, s8=0.0_wp, a2=6.0_wp)
      doi = doi_dsd
   end select

   if (.not.allocated(doi)) doi = doi_dftd3_bj
   if (present(citation)) citation = get_citation(doi)

   if (present(s9)) then
      param%s9 = s9
   end if

end subroutine get_rational_damping


subroutine get_zero_damping(param, method, error, s9, citation)

   !> Loaded parameter record
   type(d3_param), intent(out) :: param

   !> Name of the method to look up
   character(len=*), intent(in) :: method

   !> Overwrite s9
   real(wp), intent(in), optional :: s9

   !> Citation information
   type(citation_type), intent(out), optional :: citation

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=:), allocatable :: doi

   select case(get_method_id(method))
   case default
      call fatal_error(error, "No entry for '"//method//"' present")
      return
   case(p_slaterdiracexchange_df)
      param = d3_param(rs6=0.999_wp, s8=-1.957_wp, rs8=0.697_wp)
   case(p_blyp_df)
      param = d3_param(rs6=1.094_wp, s8=1.682_wp)
      doi = doi_dftd3_0
   case(p_bp_df)
      param = d3_param(rs6=1.139_wp, s8=1.683_wp)
      doi = doi_dftd3_0
   case(p_b97d_df)
      param = d3_param(rs6=0.892_wp, s8=0.909_wp)
      doi = doi_dftd3_0
   case(p_b973c_df)
      param = d3_param(rs6=1.06_wp, s8=1.50_wp)
      doi = doi_b973c
   case(p_revpbe_df)
      param = d3_param(rs6=0.923_wp, s8=1.010_wp)
      doi = doi_dftd3_0
   case(p_pbe_df)
      param = d3_param(rs6=1.217_wp, s8=0.722_wp)
      doi = doi_dftd3_0
   case(p_pbesol_df)
      param = d3_param(rs6=1.345_wp, s8=0.612_wp)
   case(p_rpw86pbe_df)
      param = d3_param(rs6=1.224_wp, s8=0.901_wp)
   case(p_rpbe_df)
      param = d3_param(rs6=0.872_wp, s8=0.514_wp)
   case(p_tpss_df)
      param = d3_param(rs6=1.166_wp, s8=1.105_wp)
      doi = doi_dftd3_0
   case(p_b3lyp_df, p_b3lyp_g_df, p_dm21_df, p_dm21m_df, p_dm21mc_df, p_dm21mu_df)
      param = d3_param(rs6=1.261_wp, s8=1.703_wp)
      doi = doi_dftd3_0
   case(p_pbe0_df)
      param = d3_param(rs6=1.287_wp, s8=0.928_wp)
      doi = doi_dftd3_0
   case(p_hse06_df)
      param = d3_param(rs6=1.129_wp, s8=0.109_wp)
      doi = doi_hse06_d3
   case(p_revpbe38_df)
      param = d3_param(rs6=1.021_wp, s8=0.862_wp)
      doi = doi_gmtkn30_0
   case(p_pw6b95_df)
      param = d3_param(rs6=1.532_wp, s8=0.862_wp)
   case(p_tpss0_df)
      param = d3_param(rs6=1.252_wp, s8=1.242_wp)
      doi = doi_dftd3_0
   case(p_b2plyp_df)
      param = d3_param(rs6=1.427_wp, s8=1.022_wp, s6=0.64_wp)
      doi = doi_gmtkn30_0
   case(p_pwpb95_df)
      param = d3_param(rs6=1.557_wp, s8=0.705_wp, s6=0.82_wp)
      doi = doi_gmtkn30_0
   case(p_b2gpplyp_df)
      param = d3_param(rs6=1.586_wp, s8=0.760_wp, s6=0.56_wp)
      doi = doi_gmtkn30_0
   case(p_ptpss_df)
      param = d3_param(rs6=1.541_wp, s8=0.879_wp, s6=0.75_wp)
      doi = doi_gmtkn30_0
   case(p_hf_df)
      param = d3_param(rs6=1.158_wp, s8=1.746_wp)
      doi = doi_gmtkn30_bj
   case(p_mpwlyp_df)
      param = d3_param(rs6=1.239_wp, s8=1.098_wp)
      doi = doi_gmtkn30_bj
   case(p_bpbe_df)
      param = d3_param(rs6=1.087_wp, s8=2.033_wp)
      doi = doi_gmtkn30_bj
   case(p_bhlyp_df)
      param = d3_param(rs6=1.370_wp, s8=1.442_wp)
      doi = doi_gmtkn30_bj
   case(p_tpssh_df)
      param = d3_param(rs6=1.223_wp, s8=1.219_wp)
   case(p_pwb6k_df)
      param = d3_param(rs6=1.660_wp, s8=0.550_wp)
      doi = doi_gmtkn30_bj
   case(p_b1b95_df)
      param = d3_param(rs6=1.613_wp, s8=1.868_wp)
      doi = doi_gmtkn30_bj
   case(p_bop_df)
      param = d3_param(rs6=0.929_wp, s8=1.975_wp)
      doi = doi_gmtkn30_bj
   case(p_olyp_df)
      param = d3_param(rs6=0.806_wp, s8=1.764_wp)
      doi = doi_gmtkn30_bj
   case(p_opbe_df)
      param = d3_param(rs6=0.837_wp, s8=2.055_wp)
      doi = doi_gmtkn30_bj
   case(p_ssb_df)
      param = d3_param(rs6=1.215_wp, s8=0.663_wp)
      doi = doi_gmtkn30_bj
   case(p_revssb_df)
      param = d3_param(rs6=1.221_wp, s8=0.560_wp)
      doi = doi_gmtkn30_bj
   case(p_otpss_df)
      param = d3_param(rs6=1.128_wp, s8=1.494_wp)
      doi = doi_gmtkn30_bj
   case(p_b3pw91_df)
      param = d3_param(rs6=1.176_wp, s8=1.775_wp)
      doi = doi_gmtkn30_bj
   case(p_revpbe0_df)
      param = d3_param(rs6=0.949_wp, s8=0.792_wp)
      doi = doi_gmtkn30_bj
   case(p_pbe38_df)
      param = d3_param(rs6=1.333_wp, s8=0.998_wp)
      doi = doi_gmtkn30_bj
   case(p_mpw1b95_df)
      param = d3_param(rs6=1.605_wp, s8=1.118_wp)
      doi = doi_gmtkn30_bj
   case(p_mpwb1k_df)
      param = d3_param(rs6=1.671_wp, s8=1.061_wp)
      doi = doi_gmtkn30_bj
   case(p_bmk_df)
      param = d3_param(rs6=1.931_wp, s8=2.168_wp)
      doi = doi_gmtkn30_bj
   case(p_camb3lyp_df)
      param = d3_param(rs6=1.378_wp, s8=1.217_wp)
      doi = doi_gmtkn30_bj
   case(p_lcwpbe_df)
      param = d3_param(rs6=1.355_wp, s8=1.279_wp)
      doi = doi_gmtkn30_bj
   case(p_m05_df)
      param = d3_param(rs6=1.373_wp, s8=0.595_wp)
      doi = doi_gmtkn30_bj
   case(p_m052x_df)
      param = d3_param(rs6=1.417_wp, s8=0.000_wp)
      doi = doi_gmtkn30_bj
   case(p_m06l_df)
      param = d3_param(rs6=1.581_wp, s8=0.000_wp)
      doi = doi_gmtkn30_bj
   case(p_m06_df)
      param = d3_param(rs6=1.325_wp, s8=0.000_wp)
      doi = doi_gmtkn30_bj
   case(p_m062x_df)
      param = d3_param(rs6=1.619_wp, s8=0.000_wp)
      doi = doi_gmtkn30_bj
   case(p_m06hf_df)
      param = d3_param(rs6=1.446_wp, s8=0.000_wp)
      doi = doi_gmtkn30_bj
   case(p_hcth120_df)
      param = d3_param(rs6=1.221_wp, s8=1.206_wp)
   case(p_scan_df)
      param = d3_param(rs6=1.324_wp, s8=0.000_wp)
      doi = doi_scan_d3
   case(p_wb97x_df)
      param = d3_param(rs6=1.281_wp, s8=1.0_wp, rs8=1.094_wp)
      doi = doi_wb97x_d3
   case(p_pw1pw_df)
      param = d3_param(rs6=1.4968_wp, s8=1.1786_wp)
      doi = doi_gmtkn55
   case(p_pbehpbe_df)
      param = d3_param(rs6=1.5703_wp, s8=1.4010_wp)
      doi = doi_gmtkn55
   case(p_xlyp_df)
      param = d3_param(rs6=0.9384_wp, s8=0.7447_wp)
      doi = doi_gmtkn55
   case(p_mpwpw_df)
      param = d3_param(rs6=1.3725_wp, s8=1.9467_wp)
      doi = doi_gmtkn55
   case(p_hcth407_df)
      param = d3_param(rs6=4.0426_wp, s8=2.7694_wp)
      doi = doi_gmtkn55
   case(p_revtpss_df)
      param = d3_param(rs6=1.3491_wp, s8=1.3666_wp)
      doi = doi_gmtkn55
   case(p_tauhcth_df)
      param = d3_param(rs6=0.9320_wp, s8=0.5662_wp)
      doi = doi_gmtkn55
   case(p_b3p_df)
      param = d3_param(rs6=1.1897_wp, s8=1.1961_wp)
      doi = doi_gmtkn55
   case(p_b1p_df)
      param = d3_param(rs6=1.1815_wp, s8=1.1209_wp)
      doi = doi_gmtkn55
   case(p_b1lyp_df)
      param = d3_param(rs6=1.3725_wp, s8=1.9467_wp)
      doi = doi_gmtkn55
   case(p_mpw1lyp_df)
      param = d3_param(rs6=2.0512_wp, s8=1.9529_wp)
      doi = doi_gmtkn55
   case(p_mpw1pw_df)
      param = d3_param(rs6=1.2892_wp, s8=1.4758_wp)
      doi = doi_gmtkn55
   case(p_mpw1kcis_df)
      param = d3_param(rs6=1.7231_wp, s8=2.2917_wp)
      doi = doi_gmtkn55
   case(p_mpwkcis1k_df)
      param = d3_param(rs6=1.4853_wp, s8=1.7553_wp)
      doi = doi_gmtkn55
   case(p_pbeh1pbe_df)
      param = d3_param(rs6=1.3719_wp, s8=1.0430_wp)
      doi = doi_gmtkn55
   case(p_pbe1kcis_df)
      param = d3_param(rs6=3.6355_wp, s8=1.7934_wp)
      doi = doi_gmtkn55
   case(p_x3lyp_df)
      param = d3_param(rs6=1.0_wp, s8=0.2990_wp)
      doi = doi_gmtkn55
   case(p_o3lyp_df)
      param = d3_param(rs6=1.4060_wp, s8=1.8058_wp)
      doi = doi_gmtkn55
   case(p_b97_1_df)
      param = d3_param(rs6=3.7924_wp, s8=1.6418_wp)
      doi = doi_gmtkn55
   case(p_b97_2_df)
      param = d3_param(rs6=1.7066_wp, s8=1.6418_wp)
      doi = doi_gmtkn55
   case(p_b98_df)
      param = d3_param(rs6=2.6895_wp, s8=1.9078_wp)
      doi = doi_gmtkn55
   case(p_hiss_df)
      param = d3_param(rs6=1.3338_wp, s8=0.7615_wp)
      doi = doi_gmtkn55
   case(p_hse03_df)
      param = d3_param(rs6=1.3944_wp, s8=1.0156_wp)
      doi = doi_gmtkn55
   case(p_revtpssh_df)
      param = d3_param(rs6=1.3224_wp, s8=1.2504_wp)
      doi = doi_gmtkn55
   case(p_revtpss0_df)
      param = d3_param(rs6=1.2881_wp, s8=1.0649_wp)
      doi = doi_gmtkn55
   case(p_tpss1kcis_df)
      param = d3_param(rs6=1.7729_wp, s8=2.0902_wp)
      doi = doi_gmtkn55
   case(p_tauhcthhyb_df)
      param = d3_param(rs6=1.5001_wp, s8=1.6302_wp)
      doi = doi_gmtkn55
   case(p_pkzb_df)
      param = d3_param(rs6=0.6327_wp, s8=0.0_wp)
      doi = doi_gmtkn55
   case(p_n12_df)
      param = d3_param(rs6=1.3493_wp, s8=2.3916_wp)
      doi = doi_gmtkn55
   case(p_mpw2plyp_df)
      param = d3_param(s6=0.66_wp, rs6=1.5527_wp, s8=0.7529_wp)
      doi = doi_gmtkn55
   case(p_m08hx_df)
      param = d3_param(rs6=1.6247_wp, s8=0.0_wp)
      doi = doi_gmtkn55
   case(p_m11l_df)
      param = d3_param(rs6=2.3933_wp, s8=1.1129_wp)
      doi = doi_minnesota_d3
   case(p_mn15l_df)
      param = d3_param(rs6=3.3388_wp, s8=0.0_wp)
      doi = doi_gmtkn55
   case(p_pwp_df)
      param = d3_param(rs6=2.1040_wp, s8=0.8747_wp)
      doi = doi_gmtkn55
   case(p_cf22d_df)
      param = d3_param(rs6=1.53_wp, s8=0.0_wp)
      doi = doi_cf22d
   end select

   if (.not.allocated(doi)) doi = doi_dftd3_0
   if (present(citation)) citation = get_citation(doi)

   if (present(s9)) then
      param%s9 = s9
   end if

end subroutine get_zero_damping


subroutine get_mrational_damping(param, method, error, s9,citation)

   !> Loaded parameter record
   type(d3_param), intent(out) :: param

   !> Name of the method to look up
   character(len=*), intent(in) :: method

   !> Overwrite s9
   real(wp), intent(in), optional :: s9

   !> Citation information
   type(citation_type), intent(out), optional :: citation

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   select case(get_method_id(method))
   case default
      call fatal_error(error, "No entry for '"//method//"' present")
      return
   case(p_b2plyp_df)
      param = d3_param(a1=0.486434_wp, s8=0.672820_wp, a2=3.656466_wp, s6=0.640000_wp)
   case(p_b3lyp_df, p_b3lyp_g_df, p_dm21_df, p_dm21m_df, p_dm21mc_df, p_dm21mu_df)
      param = d3_param(a1=0.278672_wp, s8=1.466677_wp, a2=4.606311_wp)
   case(p_b97d_df)
      param = d3_param(a1=0.240184_wp, s8=1.206988_wp, a2=3.864426_wp)
   case(p_blyp_df)
      param = d3_param(a1=0.448486_wp, s8=1.875007_wp, a2=3.610679_wp)
   case(p_bp_df)
      param = d3_param(a1=0.821850_wp, s8=3.140281_wp, a2=2.728151_wp)
   case(p_pbe_df)
      param = d3_param(a1=0.012092_wp, s8=0.358940_wp, a2=5.938951_wp)
   case(p_pbe0_df)
      param = d3_param(a1=0.007912_wp, s8=0.528823_wp, a2=6.162326_wp)
   case(p_lcwpbe_df)
      param = d3_param(a1=0.563761_wp, s8=0.906564_wp, a2=3.593680_wp)
   end select

   if (present(citation)) citation = get_citation(doi_dftd3_m)

   if (present(s9)) then
      param%s9 = s9
   end if

end subroutine get_mrational_damping


subroutine get_mzero_damping(param, method, error, s9, citation)

   !> Loaded parameter record
   type(d3_param), intent(out) :: param

   !> Name of the method to look up
   character(len=*), intent(in) :: method

   !> Overwrite s9
   real(wp), intent(in), optional :: s9

   !> Citation information
   type(citation_type), intent(out), optional :: citation

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   select case(get_method_id(method))
   case default
      call fatal_error(error, "No entry for '"//method//"' present")
      return
   case(p_b2plyp_df)
      param = d3_param(rs6=1.313134_wp, s8=0.717543_wp, bet=0.016035_wp, s6=0.640000_wp)
   case(p_b3lyp_df, p_b3lyp_g_df, p_dm21_df, p_dm21m_df, p_dm21mc_df, p_dm21mu_df)
      param = d3_param(rs6=1.338153_wp, s8=1.532981_wp, bet=0.013988_wp)
   case(p_b97d_df)
      param = d3_param(rs6=1.151808_wp, s8=1.020078_wp, bet=0.035964_wp)
   case(p_blyp_df)
      param = d3_param(rs6=1.279637_wp, s8=1.841686_wp, bet=0.014370_wp)
   case(p_bp_df)
      param = d3_param(rs6=1.233460_wp, s8=1.945174_wp, bet=0.000000_wp)
   case(p_pbe_df)
      param = d3_param(rs6=2.340218_wp, s8=0.000000_wp, bet=0.129434_wp)
   case(p_pbe0_df)
      param = d3_param(rs6=2.077949_wp, s8=0.000081_wp, bet=0.116755_wp)
   case(p_lcwpbe_df)
      param = d3_param(rs6=1.366361_wp, s8=1.280619_wp, bet=0.003160_wp)
   end select

   if (present(citation)) citation = get_citation(doi_dftd3_m)

   if (present(s9)) then
      param%s9 = s9
   end if

end subroutine get_mzero_damping


subroutine get_optimizedpower_damping(param, method, error, s9, citation)

   !> Loaded parameter record
   type(d3_param), intent(out) :: param

   !> Name of the method to look up
   character(len=*), intent(in) :: method

   !> Overwrite s9
   real(wp), intent(in), optional :: s9

   !> Citation information
   type(citation_type), intent(out), optional :: citation

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   select case(get_method_id(method))
   case default
      call fatal_error(error, "No entry for '"//method//"' present")
      return
   case(p_pbe_df)
      param = d3_param(s6=0.91826_wp, s8=0.0_wp, a1=0.200_wp, a2=4.750_wp, bet=6.0_wp)
   case(p_pbe0_df)
      param = d3_param(s6=0.88290_wp, s8=0.0_wp, a1=0.150_wp, a2=4.750_wp, bet=6.0_wp)
   case(p_revtpss_df)
      param = d3_param(s6=1.0_wp, s8=0.27632_wp, a1=0.700_wp, a2=2.500_wp, bet=8.0_wp)
   case(p_revtpssh_df)
      param = d3_param(s6=1.0_wp, s8=0.12467_wp, a1=0.575_wp, a2=3.000_wp, bet=10.0_wp)
   case(p_blyp_df)
      param = d3_param(s6=1.0_wp, s8=1.31867_wp, a1=0.425_wp, a2=3.50_wp, bet=2.0_wp)
   case(p_b3lyp_df, p_b3lyp_g_df, p_dm21_df, p_dm21m_df, p_dm21mc_df, p_dm21mu_df)
      param = d3_param(s6=1.0_wp, s8=0.78311_wp, a1=0.300_wp, a2=4.25_wp, bet=4.0_wp)
   case(p_b97d_df)
      param = d3_param(s6=1.0_wp, s8=1.46861_wp, a1=0.600_wp, a2=2.50_wp, bet=0.0_wp)
   case(p_b97_1_df, p_b97_2_df)
      param = d3_param(s6=0.97388_wp, s8=0.0_wp, a1=0.150_wp, a2=4.25_wp, bet=6.0_wp)
   case(p_revpbe_df)
      param = d3_param(s6=1.0_wp, s8=1.44765_wp, a1=0.600_wp, a2=2.50_wp, bet=0.0_wp)
   case(p_revpbe0_df)
      param = d3_param(s6=1.0_wp, s8=1.25684_wp, a1=0.725_wp, a2=2.25_wp, bet=0.0_wp)
   case(p_tpss_df)
      param = d3_param(s6=1.0_wp, s8=0.51581_wp, a1=0.575_wp, a2=3.00_wp, bet=8.0_wp)
   case(p_tpssh_df)
      param = d3_param(s6=1.0_wp, s8=0.43185_wp, a1=0.575_wp, a2=3.00_wp, bet=8.0_wp)
   case(p_ms2_df)
      param = d3_param(s6=1.0_wp, s8=0.90743_wp, a1=0.700_wp, a2=4.00_wp, bet=2.0_wp)
   case(p_ms2h_df)
      param = d3_param(s6=1.0_wp, s8=1.69464_wp, a1=0.650_wp, a2=4.75_wp, bet=0.0_wp)
   end select

   if (present(citation)) citation = get_citation(doi_dftd3_op)

   if (present(s9)) then
      param%s9 = s9
   end if

end subroutine get_optimizedpower_damping


!> Load CSO (C6-Scaled Only) damping parameters from internal storage
subroutine get_cso_damping(param, method, error, s9, citation)

   !> Loaded parameter record
   type(d3_param), intent(out) :: param

   !> Name of the method to look up
   character(len=*), intent(in) :: method

   !> Overwrite s9
   real(wp), intent(in), optional :: s9

   !> Citation information
   type(citation_type), intent(out), optional :: citation

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   select case(get_method_id(method))
   case default
      call fatal_error(error, "No entry for '"//method//"' present")
      return
   case(p_blyp_df)
      param = d3_param(s6=1.0_wp, a1=1.28_wp, a2=2.5_wp, rs6=0.0_wp, rs8=6.25_wp)
   case(p_bp_df)
      param = d3_param(s6=1.0_wp, a1=1.01_wp, a2=2.5_wp, rs6=0.0_wp, rs8=6.25_wp)
   case(p_pbe_df)
      param = d3_param(s6=1.0_wp, a1=0.24_wp, a2=2.5_wp, rs6=0.0_wp, rs8=6.25_wp)
   case(p_tpss_df)
      param = d3_param(s6=1.0_wp, a1=0.72_wp, a2=2.5_wp, rs6=0.0_wp, rs8=6.25_wp)
   case(p_b3lyp_df, p_b3lyp_g_df)
      param = d3_param(s6=1.0_wp, a1=0.86_wp, a2=2.5_wp, rs6=0.0_wp, rs8=6.25_wp)
   case(p_pbe0_df)
      param = d3_param(s6=1.0_wp, a1=0.20_wp, a2=2.5_wp, rs6=0.0_wp, rs8=6.25_wp)
   case(p_pw6b95_df)
      param = d3_param(s6=1.0_wp, a1=-0.15_wp, a2=2.5_wp, rs6=0.0_wp, rs8=6.25_wp)
   case(p_b2plyp_df)
      param = d3_param(s6=0.73_wp, a1=0.24_wp, a2=2.5_wp, rs6=0.0_wp, rs8=6.25_wp)
   end select

   if (present(citation)) citation = get_citation(doi_dftd3_cso)

   if (present(s9)) then
      param%s9 = s9
   end if

end subroutine get_cso_damping


!> Convert string to lower case
pure function lowercase(str) result(lcstr)
   character(len=*), intent(in)  :: str
   character(len=len_trim(str)) :: lcstr
   integer :: ilen, ioffset, iquote, i, iav, iqc

   ilen=len_trim(str)
   ioffset=iachar('A')-iachar('a')
   iquote=0
   lcstr=str
   do i=1, ilen
      iav=iachar(str(i:i))
      if(iquote==0 .and. (iav==34 .or.iav==39)) then
         iquote=1
         iqc=iav
        cycle
      endif
      if(iquote==1 .and. iav==iqc) then
         iquote=0
         cycle
      endif
      if (iquote==1) cycle
      if(iav >= iachar('A') .and. iav <= iachar('Z')) then
         lcstr(i:i)=achar(iav-ioffset)
      else
         lcstr(i:i)=str(i:i)
      endif
   enddo

end function lowercase

end module dftd3_param

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Check for consistency of the various version strings around
program tftest_fpm
   use, intrinsic :: iso_fortran_env, only : output_unit, error_unit
   use tomlf
   use tomlf_build
   implicit none
   integer :: length
   character(len=:), allocatable :: argument, version_string
   type(toml_table), allocatable :: table
   integer :: unit
   logical :: exist, match

   call get_tomlf_version(string=version_string)
   if (abs(command_argument_count()) == 1) then
      call get_command_argument(1, length=length)
      allocate(character(len=length) :: argument)
      call get_command_argument(1, argument)
   else
      argument = 'fpm.toml'
   end if
   inquire(file=argument, exist=exist)
   if (.not.exist) then
      write(error_unit, '(a, ":", 1x, a)') &
         & "Could not find file", argument
      error stop
   end if
   open(newunit=unit, file=argument)
   call toml_parse(table, unit)
   close(unit)
   if (.not.allocated(table)) then
      write(error_unit, '(a, 1x, a)') &
         & argument, "could not be parsed, check format and/or implementation"
      error stop
   end if
   call get_value(table, "version", argument)

   match = argument == version_string

   if (.not.match) then
      write(error_unit, '(a)') &
         & "Internal version and provided version do not match!"
      write(error_unit, '(a, ":", 1x, a)') &
         & "provided", argument, "internal", version_string
      error stop
   end if

end program tftest_fpm

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/post_processing/list.f90
!> Implements post processing conatiner list, collcting post processing methods.
module tblite_post_processing_list
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type
   use tblite_context, only : context_type
   use tblite_container_list, only : cache_list
   use tblite_double_dictionary, only : double_dictionary_type
   use tblite_integral_type, only : integral_type
   use tblite_param_post_processing, only : post_processing_record_list, &
      & post_processing_record, molmom_record, xtbml_record
   use tblite_post_processing_wbo, only : new_wiberg_bond_orders, wiberg_bond_orders
   use tblite_post_processing_molmom, only : new_molecular_moments, molecular_moments
   use tblite_post_processing_type, only : post_processing_type
   use tblite_post_processing_xtbml, only : xtbml_type, new_xtbml_features
   use tblite_results, only : results_type
   use tblite_timer, only : timer_type
   use tblite_toml, only : toml_error, toml_parse, toml_table, get_value
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_xtb_calculator, only : xtb_calculator
   implicit none
   private

   public :: add_post_processing

   !> Wrapped post-processing type for creation of lists
   type :: post_processing_container
      !> Actual post-processing method
      class(post_processing_type), allocatable :: pproc
   end type post_processing_container

   !> List of post-processing methods
   type, public :: post_processing_list
      !> Raw list of post-processing methods
      type(post_processing_container), allocatable :: list(:)
      !> Number of post-processing methods in the list
      integer :: npp = 0
   contains
      !> Perform post-processing methods in the list
      procedure :: compute
      !> List the used post-processing methods
      procedure :: info
      !> Print timings
      procedure :: print_timer
      !> Add post-processing method to list
      procedure :: push
   end type post_processing_list

   interface add_post_processing
      procedure :: add_post_processing_param
      procedure :: add_post_processing_cli
   end interface add_post_processing

contains

subroutine print_timer(self, timer, prlevel, ctx)
   !> Instance of the interaction container
   class(post_processing_list), intent(in) :: self
   !> Timer instance
   type(timer_type), intent(in) :: timer
   !> Print level
   integer, intent(in) :: prlevel
   !> Context container for writing to stdout
   type(context_type), intent(inout) :: ctx

   integer :: ipp
   do ipp = 1, self%npp
      call self%list(ipp)%pproc%print_timer(timer, prlevel, ctx)
   end do
end subroutine print_timer

subroutine compute(self, mol, wfn, ints, calc, caches, ctx, timer, prlevel, &
   & results)
   !> Instance of the post-processing list
   class(post_processing_list), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction strcuture data
   type(wavefunction_type), intent(in) :: wfn
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Calculator instance
   type(xtb_calculator), intent(in) :: calc
   !> Context container for writing to stdout
   type(context_type), intent(inout) :: ctx
   !> Cache list for storing caches of various interactions
   type(cache_list), intent(inout) :: caches
   !> Timer instance
   type(timer_type), intent(inout) :: timer
   !> Print level
   integer, intent(in) :: prlevel
   !> Container for storing results
   type(results_type), intent(inout) :: results

   integer :: ipp

   do ipp = 1, self%npp
      call self%list(ipp)%pproc%compute(mol, wfn, ints, calc, caches, ctx, &
         & timer, prlevel, results%dict)
   end do

end subroutine compute

pure function info(self, verbosity, indent) result(str)
   !> Instance of the interaction container
   class(post_processing_list), intent(in) :: self
   !> Verbosity level
   integer, intent(in) :: verbosity
   !> Indentation level
   character(len=*), intent(in) :: indent
   !> Information on the container
   character(len=:), allocatable :: str

   integer :: ipp
   character(len=*), parameter :: nl = new_line('a')

   str = "Post processing:"// nl

   do ipp = 1, self%npp
      str = str // self%list(ipp)%pproc%info(verbosity, indent)
      str = str // nl
   end do

end function info

subroutine add_post_processing_param(self, mol, param, error)
   !> Instance of the post-processing list
   class(post_processing_list), intent(inout) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> List of post-processing records
   type(post_processing_record_list), intent(in) :: param
   !> Error handling
   type(error_type), intent(inout), allocatable :: error

   integer :: ipp
   do ipp = 1, param%get_n_records()
      select type(par => param%list(ipp)%record)
      type is (molmom_record)
         block
            type(molecular_moments), allocatable :: tmp
            class(post_processing_type), allocatable :: proc
            allocate(tmp)
            call new_molecular_moments(tmp, par)
            call move_alloc(tmp, proc)
            call self%push(proc)
         end block
      type is (xtbml_record)
         block
            type(xtbml_type), allocatable :: tmp
            class(post_processing_type), allocatable :: proc
            allocate(tmp)
            call new_xtbml_features(tmp, mol, par, error)
            if (allocated(error)) return
            call move_alloc(tmp, proc)
            call self%push(proc)
         end block
      end select
   end do

end subroutine add_post_processing_param

subroutine add_post_processing_cli(self, mol, config, error)
   !> Instance of the post-processing record list
   class(post_processing_list), intent(inout) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Name of the post-processing method to be added
   character(len=:), intent(in), allocatable :: config
   !> Error handling
   type(error_type), intent(inout) , allocatable:: error

   type(post_processing_record_list) :: param
   class(post_processing_type), allocatable :: tmp_proc

   select case(config)
   case("bond-orders")
      block
         type(wiberg_bond_orders), allocatable :: wbo_tmp
         allocate(wbo_tmp)
         call new_wiberg_bond_orders(wbo_tmp)
         call move_alloc(wbo_tmp, tmp_proc)
         call self%push(tmp_proc)
         return
      end block
   case("molmom")
      block
         type(molmom_record), allocatable :: molmom_tmp
         class(post_processing_record), allocatable :: tmp
         allocate(molmom_tmp)
         call molmom_tmp%populate_default_param()
         call move_alloc(molmom_tmp, tmp)
         call param%push(tmp)
      end block
   case("xtbml")
      block
         type(xtbml_record), allocatable :: ml_param
         class(post_processing_record), allocatable :: cont
         allocate(ml_param)
         call ml_param%populate_default_param(.false.)
         call move_alloc(ml_param, cont)
         call param%push(cont)
      end block
   case("xtbml-xyz","xtbml_xyz")
      block
         type(xtbml_record), allocatable :: ml_param
         class(post_processing_record), allocatable :: cont 
         allocate(ml_param)
         call ml_param%populate_default_param(.true.)
         call move_alloc(ml_param, cont)
         call param%push(cont)
      end block
   case default
      block
         type(toml_table), allocatable :: table
         integer :: io
         type(toml_error), allocatable :: t_error
         type(toml_table), pointer :: child

         open(file=config, newunit=io, status="old")
         
         call toml_parse(table, io, t_error)
         close(io)
         if (allocated(t_error)) then
            call fatal_error(error, "Could not parse TOML file due to "//t_error%message)
            return
         end if
         call get_value(table, "post-processing", child, requested=.false.)
         if (associated(child)) then
            call param%load(child, error)
         else
            call fatal_error(error, "Could not find post-processing key in toml file.")
         end if
         
      end block   
   end select

   call add_post_processing(self, mol, param, error)

end subroutine add_post_processing_cli

subroutine push(self, record)
   !> Instance of the post-processing list
   class(post_processing_list), intent(inout) :: self
   !> Instance of the post-processing method to be added
   class(post_processing_type), allocatable, intent(inout) :: record
   
   if (.not.allocated(self%list)) call resize(self%list)
   if (is_duplicate(self, record)) return
   if (self%npp >= size(self%list)) then
      call resize(self%list)
   end if
   
   self%npp = self%npp + 1
   call move_alloc(record, self%list(self%npp)%pproc)

end subroutine push

function is_duplicate(self, record) result(duplicate)
   !> Instance of the post-processing list
   class(post_processing_list), intent(inout) :: self
   !> Instance of the post-processing method to be checked
   class(post_processing_type), allocatable, intent(inout) :: record
   logical :: duplicate 
   integer :: ipp
   duplicate = .false.
   do ipp = 1, self%npp
      if (record%label == self%list(ipp)%pproc%label) duplicate = .true.
   end do
end function is_duplicate

subroutine resize(list, n)
   !> Instance of the array to be resized
   type(post_processing_container), allocatable, intent(inout) :: list(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(post_processing_container), allocatable :: tmp(:)
   integer :: this_size, new_size, item
   integer, parameter :: initial_size = 1

   if (allocated(list)) then
      this_size = size(list, 1)
      call move_alloc(list, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + 1
   end if

   allocate(list(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(list, 1))
      do item = 1, this_size
         call move_alloc(tmp(item)%pproc, list(item)%pproc)
      end do
      deallocate(tmp)
   end if

end subroutine resize

end module tblite_post_processing_list

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module tftest_sort
   use testdrive
   use tomlf, only : toml_key, sort
   implicit none
   private

   public :: collect_sort


contains


!> Collect all exported unit tests
subroutine collect_sort(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("sorted", test_sorted), &
      & new_unittest("reversed", test_reversed), &
      & new_unittest("unsorted", test_unsorted) &
      & ]

end subroutine collect_sort


subroutine test_sorted(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_key), allocatable :: list(:)
   integer :: i
   character(len=*), parameter :: expected(10) = &
      & ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]

   allocate(list(0))  ! avoid compiler warning
   list = [ &
      & toml_key("0"), &
      & toml_key("1"), &
      & toml_key("2"), &
      & toml_key("3"), &
      & toml_key("4"), &
      & toml_key("5"), &
      & toml_key("6"), &
      & toml_key("7"), &
      & toml_key("8"), &
      & toml_key("9")]

   call sort(list)

   do i = 1, size(list)
      if (list(i)%key /= expected(i)) then
         call test_failed(error, "List is not sorted correctly")
         exit
      end if
   end do
   if (allocated(error)) return

end subroutine test_sorted


subroutine test_reversed(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_key), allocatable :: list(:)
   integer :: i
   character(len=*), parameter :: expected(10) = &
      & ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]

   allocate(list(0))  ! avoid compiler warning
   list = [ &
      & toml_key("9"), &
      & toml_key("8"), &
      & toml_key("7"), &
      & toml_key("6"), &
      & toml_key("5"), &
      & toml_key("4"), &
      & toml_key("3"), &
      & toml_key("2"), &
      & toml_key("1"), &
      & toml_key("0")]

   call sort(list)

   do i = 1, size(list)
      if (list(i)%key /= expected(i)) then
         call test_failed(error, "List is not sorted correctly")
         exit
      end if
   end do
   if (allocated(error)) return

end subroutine test_reversed


subroutine test_unsorted(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_key), allocatable :: list(:)
   integer :: i
   character(len=*), parameter :: expected(10) = &
      & ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]

   allocate(list(0))  ! avoid compiler warning
   list = [ &
      & toml_key("7"), &
      & toml_key("9"), &
      & toml_key("6"), &
      & toml_key("8"), &
      & toml_key("5"), &
      & toml_key("2"), &
      & toml_key("4"), &
      & toml_key("1"), &
      & toml_key("3"), &
      & toml_key("0")]

   call sort(list)

   do i = 1, size(list)
      if (list(i)%key /= expected(i)) then
         call test_failed(error, "List is not sorted correctly")
         exit
      end if
   end do
   if (allocated(error)) return

end subroutine test_unsorted


end module tftest_sort

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! Test of adjoint for each matrices
!!
!! @version 1.0.0
!! @author Abhinav Jha
!! @date 2022-03-29

program main
use ddx
use ddx_core
use ddx_operators
use ddx_lpb
implicit none

character(len=255) :: fname
type(ddx_type) :: ddx_data
type(ddx_error_type) :: ddx_error
! isph   : Index for number of spheres
! i      : Index for derivative components (i = 1,2,3)
! ibasis : Index for number of basis
integer :: isph, i, ibasis


real(dp) :: check_A_one, check_A_two, check_A_three, check_A_four, tol
real(dp) :: check_A_star_one, check_A_star_two, check_A_star_three,&
          & check_A_star_four
real(dp) :: check_B_one, check_B_two, check_B_three, check_B_four
real(dp) :: check_B_star_one, check_B_star_two, check_B_star_three,&
          & check_B_star_four
real(dp) :: check_C_one, check_C_two
real(dp) :: check_C_star_one, check_C_star_two
real(dp), allocatable:: random_vector_nbasis_nsph_one(:,:), &
                        & random_vector_nbasis_nsph_two(:,:), &
                        & random_vector_nbasis_nsph_three(:,:), &
                        & random_vector_nbasis_nsph_four(:,:), &
                        & zero_vector(:,:)


real(dp), allocatable :: random_vector_n_one(:), &
                       & random_vector_n_two(:), &
                       & random_vector_n_three(:), &
                       & random_vector_n_four(:), &
                       & random_vector_C_one(:,:,:),&
                       & random_vector_C_two(:,:,:),&
                       & vector_A_one(:), &
                       & vector_A_two(:), &
                       & vector_A_three(:), &
                       & vector_A_four(:), &
                       & vector_B_one(:), &
                       & vector_B_two(:), &
                       & vector_B_three(:), &
                       & vector_B_four(:), &
                       & vector_C1_one(:,:), &
                       & vector_C1_two(:,:), &
                       & vector_C2_one(:,:), &
                       & vector_C2_two(:,:), &
                       & vector_C_one(:,:,:), &
                       & vector_C_two(:,:,:), &
                       & vector_A_star_one(:), &
                       & vector_A_star_two(:), &
                       & vector_A_star_three(:), &
                       & vector_A_star_four(:), &
                       & vector_B_star_one(:), &
                       & vector_B_star_two(:), &
                       & vector_B_star_three(:), &
                       & vector_B_star_four(:), &
                       & vector_C1_star_one(:,:), &
                       & vector_C1_star_two(:,:), &
                       & vector_C2_star_one(:,:), &
                       & vector_C2_star_two(:,:), &
                       & vector_C_star_one(:,:,:), &
                       & vector_C_star_two(:,:,:)
real(dp) :: lmax0, nbasis0
real(dp), allocatable :: charges(:)

! Read input file name
call get_command_argument(1, fname)
write(*, *) "Using provided file ", trim(fname), " as a config file 12"
call ddfromfile(fname, ddx_data, tol, charges, ddx_error)
call check_error(ddx_error)

! lmax0 set to minimum of 6 or given lmax.
! nbasis0 set to minimum of 49 or given (lmax+1)^2.
! Maybe do it ddlpb_init(?)
lmax0 = MIN(6, ddx_data % params % lmax)
nbasis0 = MIN(49, ddx_data % constants % nbasis)

! Allocation for various vectors
allocate(random_vector_nbasis_nsph_one(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & random_vector_nbasis_nsph_two(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & random_vector_nbasis_nsph_three(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & random_vector_nbasis_nsph_four(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & random_vector_C_one(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph, 2), &
    & random_vector_C_two(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph, 2), &
    & random_vector_n_one(ddx_data % constants % n), &
    & random_vector_n_two(ddx_data % constants % n), &
    & random_vector_n_three(ddx_data % constants % n), &
    & random_vector_n_four(ddx_data % constants % n), &
    & vector_A_one(ddx_data % constants % n), &
    & vector_A_two(ddx_data % constants % n), &
    & vector_A_three(ddx_data % constants % n), &
    & vector_A_four(ddx_data % constants % n), &
    & vector_B_one(ddx_data % constants % n), &
    & vector_B_two(ddx_data % constants % n), &
    & vector_B_three(ddx_data % constants % n), &
    & vector_B_four(ddx_data % constants % n), &
    & vector_C1_one(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & vector_C1_two(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & vector_C2_one(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & vector_C2_two(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & vector_C_one(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph, 2), &
    & vector_C_two(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph, 2), &
    & vector_A_star_one(ddx_data % constants % n), &
    & vector_A_star_two(ddx_data % constants % n), &
    & vector_A_star_three(ddx_data % constants % n), &
    & vector_A_star_four(ddx_data % constants % n), &
    & vector_B_star_one(ddx_data % constants % n), &
    & vector_B_star_two(ddx_data % constants % n), &
    & vector_B_star_three(ddx_data % constants % n), &
    & vector_B_star_four(ddx_data % constants % n), &
    & vector_C1_star_one(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & vector_C1_star_two(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & vector_C2_star_one(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & vector_C2_star_two(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph), &
    & vector_C_star_one(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph, 2), &
    & vector_C_star_two(ddx_data % constants % nbasis, &
    & ddx_data % params % nsph, 2), &
    & zero_vector(ddx_data % constants %  nbasis, ddx_data % params % nsph))

! Initialise
vector_A_one = one
vector_A_two = one
vector_A_three = one
vector_A_four = one
vector_B_one = one
vector_B_two = one
vector_B_three = one
vector_B_four = one
vector_C1_one = one
vector_C1_two = one
vector_C2_one = one
vector_C2_two = one
vector_C_one = one
vector_C_two = one
vector_A_star_one = one
vector_A_star_two = one
vector_A_star_three = one
vector_A_star_four = one
vector_B_star_one = one
vector_B_star_two = one
vector_B_star_three = one
vector_B_star_four = one
vector_C1_star_one = one
vector_C1_star_two = one
vector_C2_star_one = one
vector_C2_star_two = one
vector_C_star_one = one
vector_C_star_two = one
zero_vector = zero

check_A_one = zero
check_A_two = zero
check_A_three = zero
check_A_four = zero
check_B_one = zero
check_B_two = zero
check_B_three = zero
check_B_four = zero
check_C_one = zero
check_C_two = zero

check_A_star_one = zero
check_A_star_two = zero
check_A_star_three = zero
check_A_star_four = zero
check_B_star_one = zero
check_B_star_two = zero
check_B_star_three = zero
check_B_star_four = zero
check_C_star_one = zero
check_C_star_two = zero

! Random vectors
random_vector_nbasis_nsph_one = one
random_vector_nbasis_nsph_two = one
random_vector_nbasis_nsph_three = one
random_vector_nbasis_nsph_four = one

random_vector_n_one = one
random_vector_n_two = one
random_vector_n_three = one
random_vector_n_four = one

! random_vector_n_one   = [2,1,1,1,...]
! random_vector_n_two   = [1,3,1,1,...]
! random_vector_n_three = [1,1,0,1,...]
! random_vector_n_four  = [0,0,0,1,...]
random_vector_n_one(1) = two
random_vector_n_two(2) = three
random_vector_n_three(3) = zero
random_vector_n_four(1) = zero
random_vector_n_four(2) = zero
random_vector_n_four(3) = zero

random_vector_nbasis_nsph_one(1,1) = 2.0
random_vector_nbasis_nsph_two(2,1) = 3.0
random_vector_nbasis_nsph_three(3,1) = 0.0
random_vector_nbasis_nsph_four(1,1) = 0.0
random_vector_nbasis_nsph_four(2,1) = 0.0
random_vector_nbasis_nsph_four(3,1) = 0.0

random_vector_C_one(:,:,1) = random_vector_nbasis_nsph_one(:,:)
random_vector_C_one(:,:,2) = random_vector_nbasis_nsph_two(:,:)
random_vector_C_two(:,:,1) = random_vector_nbasis_nsph_three(:,:)
random_vector_C_two(:,:,2) = random_vector_nbasis_nsph_four(:,:)

! Call for matrix A
call lx(ddx_data % params, ddx_data % constants, &
          & ddx_data % workspace, random_vector_n_one, vector_A_one, ddx_error)
call lx(ddx_data % params, ddx_data % constants, &
          & ddx_data % workspace, random_vector_n_two, vector_A_two, ddx_error)
call lx(ddx_data % params, ddx_data % constants, &
          & ddx_data % workspace, random_vector_n_three, vector_A_three, ddx_error)
call lx(ddx_data % params, ddx_data % constants, &
          & ddx_data % workspace, random_vector_n_four, vector_A_four, ddx_error)


! Call for matrix B
call bx(ddx_data % params, ddx_data % constants, &
      & ddx_data % workspace, &
      & random_vector_n_one, vector_B_one, ddx_error)
call bx(ddx_data % params, ddx_data % constants, &
      & ddx_data % workspace, &
      & random_vector_n_two, vector_B_two, ddx_error)
call bx(ddx_data % params, ddx_data % constants, &
      & ddx_data % workspace, &
      & random_vector_n_three, vector_B_three, ddx_error)
call bx(ddx_data % params, ddx_data % constants, &
      & ddx_data % workspace, &
      & random_vector_n_four, vector_B_four, ddx_error)

! Call for C1 and C2
call cx(ddx_data % params, ddx_data % constants, &
                 & ddx_data % workspace, &
                 & random_vector_C_one, &
                 & vector_C_one, ddx_error)

call cx(ddx_data % params, ddx_data % constants, &
                 & ddx_data % workspace, &
                 & random_vector_C_two, &
                 & vector_C_two, ddx_error)
! Call for matrix Astar
call lstarx(ddx_data % params, ddx_data % constants, &
      & ddx_data % workspace, &
      & random_vector_n_four, vector_A_star_one, ddx_error)
call lstarx(ddx_data % params, ddx_data % constants, &
      & ddx_data % workspace, &
      & random_vector_n_three, vector_A_star_two, ddx_error)
call lstarx(ddx_data % params, ddx_data % constants, &
      & ddx_data % workspace, &
      & random_vector_n_two, vector_A_star_three, ddx_error)
call lstarx(ddx_data % params, ddx_data % constants, &
      & ddx_data % workspace, &
      & random_vector_n_one, vector_A_star_four, ddx_error)

! Call for matrix Bstar
call bstarx(ddx_data % params, ddx_data % constants, &
      & ddx_data % workspace, &
      & random_vector_n_four, vector_B_star_one, ddx_error)
call bstarx(ddx_data % params, ddx_data % constants, &
      & ddx_data % workspace, &
      & random_vector_n_three, vector_B_star_two, ddx_error)
call bstarx(ddx_data % params, ddx_data % constants, &
      & ddx_data % workspace, &
      & random_vector_n_two, vector_B_star_three, ddx_error)
call bstarx(ddx_data % params, ddx_data % constants, &
      & ddx_data % workspace, &
      & random_vector_n_one, vector_B_star_four, ddx_error)

! Call for C1 and C2 star
! |C1* C1*||X3|
! |C2* C2*||X4|
call cstarx(ddx_data % params, ddx_data % constants, &
                 & ddx_data % workspace, &
                 & random_vector_C_two, &
                 & vector_C_star_one, ddx_error)

call cstarx(ddx_data % params, ddx_data % constants, &
                 & ddx_data % workspace, &
                 & random_vector_C_one, &
                 & vector_C_star_two, ddx_error)

!Compute the contraction
do i = 1, ddx_data % constants % n
  check_A_one = check_A_one + random_vector_n_four(i)*vector_A_one(i)
  check_A_two = check_A_two + random_vector_n_three(i)*vector_A_two(i)
  check_A_three = check_A_three + random_vector_n_two(i)*vector_A_three(i)
  check_A_four = check_A_four + random_vector_n_one(i)*vector_A_four(i)
  check_A_star_one = check_A_star_one + &
                   & random_vector_n_one(i)*vector_A_star_one(i)
  check_A_star_two = check_A_star_two + &
                  & random_vector_n_two(i)*vector_A_star_two(i)
  check_A_star_three = check_A_star_three + &
                  & random_vector_n_three(i)*vector_A_star_three(i)
  check_A_star_four = check_A_star_four + &
                  & random_vector_n_four(i)*vector_A_star_four(i)

  check_B_one = check_B_one + random_vector_n_four(i)*vector_B_one(i)
  check_B_two = check_B_two + random_vector_n_three(i)*vector_B_two(i)
  check_B_three = check_B_three + random_vector_n_two(i)*vector_B_three(i)
  check_B_four = check_B_four + random_vector_n_one(i)*vector_B_four(i)
  check_B_star_one = check_B_star_one + &
                   & random_vector_n_one(i)*vector_B_star_one(i)
  check_B_star_two = check_B_star_two + &
                  & random_vector_n_two(i)*vector_B_star_two(i)
  check_B_star_three = check_B_star_three + &
                  & random_vector_n_three(i)*vector_B_star_three(i)
  check_B_star_four = check_B_star_four + &
                  & random_vector_n_four(i)*vector_B_star_four(i)
end do

do ibasis = 1, ddx_data % constants % nbasis
  do isph = 1, ddx_data % params % nsph
    check_C_one = check_C_one + random_vector_C_two(ibasis, isph, 1) &
                & * vector_C_one(ibasis, isph, 1) + &
                & random_vector_C_two(ibasis, isph, 2) &
                & * vector_C_one(ibasis, isph, 2)
    check_C_two = check_C_two + random_vector_C_one(ibasis, isph, 1) &
                & * vector_C_two(ibasis, isph, 1) + &
                & random_vector_C_one(ibasis, isph, 2) &
                & * vector_C_two(ibasis, isph, 2)
    check_C_star_one = check_C_star_one + &
                & random_vector_C_one(ibasis, isph, 1) &
                & * vector_C_star_one(ibasis, isph, 1) + &
                & random_vector_C_one(ibasis, isph, 2) &
                & * vector_C_star_one(ibasis, isph, 2)
    check_C_star_two = check_C_star_two + &
                & random_vector_C_two(ibasis, isph, 1) &
                & * vector_C_star_two(ibasis, isph, 1) + &
                & random_vector_C_two(ibasis, isph, 2) &
                & * vector_C_star_two(ibasis, isph, 2)
  end do
end do

! Deallocation
deallocate(random_vector_nbasis_nsph_two, &
           & random_vector_nbasis_nsph_one, &
           & random_vector_nbasis_nsph_three, &
           & random_vector_nbasis_nsph_four, &
           & random_vector_n_one, &
           & random_vector_n_two, &
           & random_vector_n_three, &
           & random_vector_n_four, &
           & random_vector_C_one, &
           & random_vector_C_two, &
           & vector_A_one, &
           & vector_A_two, &
           & vector_A_three, &
           & vector_A_four, &
           & vector_B_one, &
           & vector_B_two, &
           & vector_B_three, &
           & vector_B_four, &
           & vector_A_star_one, &
           & vector_A_star_two, &
           & vector_A_star_three, &
           & vector_A_star_four, &
           & vector_B_star_one, &
           & vector_B_star_two, &
           & vector_B_star_three, &
           & vector_B_star_four, &
           & vector_C1_one, &
           & vector_C1_two, &
           & vector_C2_one, &
           & vector_C2_two, &
           & vector_C_one, &
           & vector_C_two, &
           & vector_C1_star_one, &
           & vector_C1_star_two, &
           & vector_C2_star_one, &
           & vector_C2_star_two, &
           & vector_C_star_one, &
           & vector_C_star_two, &
           & zero_vector, &
           & charges)
call deallocate_model(ddx_data, ddx_error)

write(*, *) "y4(A)x1  :", check_A_one, ", x1(A*)y4  :", check_A_star_one
write(*, *) "y3(A)x2  :", check_A_two, ", x2(A*)y3  :", check_A_star_two
write(*, *) "y2(A)x3  :", check_A_three, ", x3(A*)y2  :", check_A_star_three
write(*, *) "y1(A)x4  :", check_A_four, ", x4(A*)y1  :", check_A_star_four
write(*, *) "y4(B)x1  :", check_B_one, ", x1(B*)y4  :", check_B_star_one
write(*, *) "y3(B)x2  :", check_B_two, ", x2(B*)y3  :", check_B_star_two
write(*, *) "y2(B)x3  :", check_B_three, ", x3(B*)y2  :", check_B_star_three
write(*, *) "y1(B)x4  :", check_B_four, ", x4(B*)y1  :", check_B_star_four
write(*, *) "y1(C)x1  :", check_C_one, ", x1(C*)y1  :", check_C_star_one
write(*, *) "y2(C)x2  :", check_C_two, ", x2(C*)y2  :", check_C_star_two

if(abs(check_A_one - check_A_star_one) .gt. 1e-12) then
  write(*,*) 'Contraction for matrix A not equal! y(A)x : ', check_A_one, &
            & ', x(A*)y : ', check_A_star_one
  stop 1
endif


if(abs(check_A_two - check_A_star_two) .gt. 1e-12) then
  write(*,*) 'Contraction for matrix A not equal! y(A)x : ', check_A_two, &
            & ', x(A*)y : ', check_A_star_two
  stop 1
endif


if(abs(check_A_three - check_A_star_three) .gt. 1e-12) then
  write(*,*) 'Contraction for matrix A not equal! y(A)x : ', check_A_three, &
            & ', x(A*)y : ', check_A_star_three
  stop 1
endif


if(abs(check_A_four - check_A_star_four) .gt. 1e-12) then
  write(*,*) 'Contraction for matrix A not equal! y(A)x : ', check_A_four, &
            & ', x(A*)y : ', check_A_star_four
  stop 1
endif


if(abs(check_B_one - check_B_star_one) .gt. 1e-12) then
  write(*,*) 'Contraction for matrix B not equal! y(B)x : ', check_B_one, &
            & ', x(B*)y : ', check_B_star_one
  stop 1
endif


if(abs(check_B_two - check_B_star_two) .gt. 1e-12) then
  write(*,*) 'Contraction for matrix B not equal! y(A)x : ', check_B_two, &
            & ', x(B*)y : ', check_B_star_two
  stop 1
endif


if(abs(check_B_three - check_B_star_three) .gt. 1e-12) then
  write(*,*) 'Contraction for matrix B not equal! y(C)x : ', check_B_three, &
            & ', x(B*)y : ', check_B_star_three
  stop 1
endif


if((check_B_four - check_B_star_four) .gt. 1e-12) then
  write(*,*) 'Contraction for matrix B not equal! y(B)x : ', check_B_four, &
            & ', x(B*)y : ', check_B_star_four
  stop 1
endif

if((check_C_one - check_C_star_one) .gt. 1e-12) then
  write(*,*) 'Contraction for matrix C not equal! y(C)x : ', check_C_one, &
            & ', x(C*)y : ', check_C_star_one
  stop 1
endif

if(abs(check_C_two - check_C_star_two) .gt. 1e-12) then
  write(*,*) 'Contraction for matrix C not equal! y(C)x : ', check_C_two, &
            & ', x(C*)y : ', check_C_star_two
  stop 1
endif



end program main

! SPDX-Identifier: BSD-3-Clause

!> @file tblite/fit/newuoa.f90
!> Provides the new unconstrained optimization algorithm

!> NEWUOA: **NEW** **U**nconstrained **O**ptimization **A**lgorithm
!>
!> The purpose of NEWUOA is to seek the least value of a function F of several
!> variables, when derivatives are not available.
!> The main new feature of the method is that quadratic
!> models are updated using only about ```NPT=2N+1``` interpolation conditions,
!> the remaining freedom being taken up by minimizing the Frobenius norm of
!> the change to the second derivative matrix of the model.
!>
!> The new software was developed from [[UOBYQA]], which also forms quadratic
!> models from interpolation conditions. That method requires ```NPT=(N+1)(N+2)/2```
!> conditions, however, because they have to define all the parameters of the
!> model. The least Frobenius norm updating procedure with ```NPT=2N+1``` is usually
!> much more efficient when ```N``` is large, because the work of each iteration is
!> much less than before, and in some experiments the number of calculations
!> of the objective function seems to be only of magnitude ```N```.
!>
!># References
!>
!>  * "[The NEWUOA software for unconstrained optimization without
!>    derivatives](http://www.damtp.cam.ac.uk/user/na/NA_papers/NA2004_08.pdf)",
!>    2004/NA08
!>  * "[The NEWUOA software for unconstrained minimization
!>    without derivatives](http://link.springer.com/chapter/10.1007%2F0-387-30065-1_16)",
!>    in Large-Scale Nonlinear Optimization, editors G. Di
!>    Pillo and M. Roma, Springer (2006), pages 255-297.
!>
!># History
!>  * M.J.D. Powell, December 16th, 2004 : It is hoped that the software will
!>    be helpful to much future research and to many applications. There are no
!>    restrictions on or charges for its use.
!>  * Jacob Williams, July 2015 : refactoring of the code into modern Fortran.
!>  * Sebastian Ehlert, August 2021 : removed implicit typing
!>
!>```bibtex
!>@Inbook{Powell2006,
!>  author="Powell, M. J. D.",
!>  editor="Di Pillo, G.  and Roma, M.",
!>  title="The NEWUOA software for unconstrained optimization without derivatives",
!>  bookTitle="Large-Scale Nonlinear Optimization",
!>  year="2006",
!>  publisher="Springer US",
!>  address="Boston, MA",
!>  pages="255--297",
!>  url="https://doi.org/10.1007/0-387-30065-1_16"
!>}
!>```
module tblite_fit_newuoa
   use mctc_env, only : wp, error_type
   implicit none

   private
   public :: newuoa, objective_function

   abstract interface
      function objective_function(n, x, h, error) result(f)
         import :: wp, error_type
         implicit none
         integer, intent(in) :: n
         real(wp), intent(in) :: x(*)
         class(*), intent(in) :: h
         type(error_type), allocatable, intent(out) :: error
         real(wp) :: f
      end function objective_function
   end interface


contains

!> This subroutine seeks the least value of a function of many variables,
!> by a trust region method that forms quadratic models by interpolation.
!> There can be some freedom in the interpolation conditions, which is
!> taken up by minimizing the Frobenius norm of the change to the second
subroutine newuoa(n, npt, x, rhobeg, rhoend, iprint, maxfun, calfun, handle, error)
   !> The number of variables. Must be at least 2.
   integer, intent(in) :: n
   !> The number of interpolation conditions.
   !> Its value must be in the interval `[N+2, (N+1)(N+2)/2]`.
   integer, intent(in) :: npt
   !> Initial values of the variables must be set in X(1), X(2), ..., X(N). They
   !> will be changed to the values that give the least calculated F.
   real(wp), intent(inout) :: x(*)
   !> RHOBEG and RHOEND must be set to the initial and final values of a trust
   !> region radius, so both must be positive with RHOEND<=RHOBEG. Typically
   !> RHOBEG should be about one tenth of the greatest expected change to a
   !> variable, and RHOEND should indicate the accuracy that is required in
   !> the final values of the variables.
   real(wp), intent(in) :: rhobeg
   !> RHOBEG and RHOEND must be set to the initial and final values of a trust
   !> region radius, so both must be positive with RHOEND<=RHOBEG. Typically
   !> RHOBEG should be about one tenth of the greatest expected change to a
   !> variable, and RHOEND should indicate the accuracy that is required in
   !> the final values of the variables.
   real(wp), intent(in) :: rhoend
   !> The value of IPRINT should be set to 0, 1, 2 or 3, which controls the
   !> amount of printing. Specifically, there is no output if IPRINT=0 and
   !> there is output only at the return if IPRINT=1. Otherwise, each new
   !> value of RHO is printed, with the best vector of variables so far and
   !> the corresponding value of the objective function. Further, each new
   !> value of F with its variables are output if IPRINT=3.
   integer, intent(in) :: iprint
   !> An upper bound on the number of calls of CALFUN.
   !> It must set F to the value of the objective function
   !> for the variables `X(1), X(2), ..., X(N)`.
   integer, intent(in) :: maxfun
   procedure(objective_function) :: calfun
   class(*), intent(in) :: handle
   type(error_type), allocatable, intent(out) :: error

   real(wp), dimension(:), allocatable :: w
   integer :: np, nptm, ndim, ixb, ixo, ixn, ixp, ifv, igq, ihq, ipq, ibmat, izmat, &
      & id, ivl, iw

   ! Partition the working space array, so that different parts of it can be
   ! treated separately by the subroutine that performs the main calculation.

   np = n + 1
   nptm = npt - np
   if (npt < n+2 .or. npt > ((n+2)*np)/2) then
      write(*, *) 'Return from NEWUOA because NPT is not in the required interval'
      return
   end if

   ! The array W will be used for working space
   allocate(w((NPT+13)*(NPT+N)+3*N*(N+3)/2))

   ndim = npt + n
   ixb = 1
   ixo = ixb + n
   ixn = ixo + n
   ixp = ixn + n
   ifv = ixp + n * npt
   igq = ifv + npt
   ihq = igq + n
   ipq = ihq + (n*np) / 2
   ibmat = ipq + npt
   izmat = ibmat + ndim * n
   id = izmat + npt * nptm
   ivl = id + n
   iw = ivl + ndim

   ! The above settings provide a partition of W for subroutine NEWUOB.
   ! The partition requires the first NPT*(NPT+N)+5*N*(N+3)/2 elements of
   ! W plus the space that is needed by the last array of NEWUOB.

   call newuob(n, npt, x, rhobeg, rhoend, iprint, maxfun, w(ixb), w(ixo), w(ixn), &
      w(ixp), w(ifv), w(igq), w(ihq), w(ipq), w(ibmat), w(izmat), ndim, &
      w(id), w(ivl), w(iw), calfun, handle, error)

   deallocate(w)

end subroutine newuoa


subroutine newuob(n, npt, x, rhobeg, rhoend, iprint, maxfun, xbase, xopt, xnew, xpt, &
      fval, gq, hq, pq, bmat, zmat, ndim, d, vlag, w, calfun, handle, error)
   !> The number of variables. Must be at least 2.
   integer, intent(in) :: n
   !> The number of interpolation conditions.
   !> Its value must be in the interval `[N+2, (N+1)(N+2)/2]`.
   integer, intent(in) :: npt
   !> Is the first dimension of BMAT and has the value NPT+N.
   integer, intent(in) :: ndim
   !> Initial values of the variables must be set in X(1), X(2), ..., X(N). They
   !> will be changed to the values that give the least calculated F.
   real(wp), intent(inout) :: x(*)
   real(wp), intent(in) :: rhobeg
   real(wp), intent(in) :: rhoend
   integer, intent(in) :: iprint
   integer, intent(in) :: maxfun
   !> Will hold a shift of origin that should reduce the contributions
   !> from rounding errors to values of the model and Lagrange functions.
   real(wp), intent(inout) :: xbase(*)
   !> Will be set to the displacement from XBASE of the vector of
   !> variables that provides the least calculated F so far.
   real(wp), intent(inout) :: xopt(*)
   !> Will be set to the displacement from XBASE of the vector of
   !> variables for the current calculation of F.
   real(wp), intent(inout) :: xnew(*)
   !> Will contain the interpolation point coordinates relative to XBASE.
   real(wp), intent(inout) :: xpt(npt, *)
   !> Will hold the values of F at the interpolation points.
   real(wp), intent(inout) :: fval(*)
   !> Will hold the gradient of the quadratic model at XBASE.
   real(wp), intent(inout) :: gq(*)
   !> Will hold the explicit second derivatives of the quadratic model.
   real(wp), intent(inout) :: hq(*)
   !> Will contain the parameters of the implicit second derivatives of
   !> the quadratic model.
   real(wp), intent(inout) :: pq(*)
   !> Will hold the last N columns of H.
   real(wp), intent(inout) :: bmat(ndim, *)
   !> Will hold the factorization of the leading NPT by NPT submatrix of
   !> H, this factorization being ZMAT times Diag(DZ) times ZMAT^T, where
   !> the elements of DZ are plus or minus one, as specified by IDZ.
   real(wp), intent(inout) :: zmat(npt, *)
   !> Reserved for trial steps from XOPT.
   real(wp), intent(inout) :: d(*)
   !> Will contain the values of the Lagrange functions at a new point X.
   !> They are part of a product that requires VLAG to be of length NDIM.
   real(wp), intent(inout) :: vlag(*)
   !> The array will be used for working space. Its length must be at least
   !> 10*NDIM = 10*(NPT+N).
   real(wp), intent(inout) :: w(*)
   procedure(objective_function) :: calfun
   class(*), intent(in) :: handle
   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: half = 0.5_wp, one = 1.0_wp, tenth = 0.1_wp, zero = 0.0_wp
   integer :: np, nh, nptm, nftest, i, j, k, ih, idz, ip, ipt, itemp, itest, jp, jpt, &
      & knew, kopt, ksave, ktemp, nf, nfm, nfmm, nfsav
   real(wp) :: rhosq, recip, reciq, alpha, beta, bsum, crvmin, delta, detrat, diff, &
      & diffa, diffb, diffc, distsq, dnorm, dsq, dstep, dx, f, fbeg, fopt, fsave, gisq, &
      & gqsq, hdiag, ratio, rho, sum, suma, sumb, sumz, temp, tempq, vquad, xipt, xjpt, &
      & xoptsq
   np = n + 1
   nh = (n*np) / 2
   nptm = npt - np
   nftest = max(maxfun, 1)
   !
   !     Set the initial elements of XPT, BMAT, HQ, PQ and ZMAT to zero.
   !
   do j = 1, n
      xbase(j) = x(j)
      do k = 1, npt
         xpt(k, j) = zero
      end do
      do i = 1, ndim
         bmat(i, j) = zero
      end do
   end do
   do ih = 1, nh
      hq(ih) = zero
   end do
   do k = 1, npt
      pq(k) = zero
      do j = 1, nptm
         zmat(k, j) = zero
      end do
   end do
   !
   !     Begin the initialization procedure. NF becomes one more than the number
   !     of function values so far. The coordinates of the displacement of the
   !     next initial interpolation point from XBASE are set in XPT(NF, .).
   !
   rhosq = rhobeg * rhobeg
   recip = one / rhosq
   reciq = sqrt(half) / rhosq
   nf = 0
   50 continue
   nfm = nf
   nfmm = nf - n
   nf = nf + 1
   if (nfm <= 2*n) then
      if (nfm >= 1 .and. nfm <= n) then
         xpt(nf, nfm) = rhobeg
      else if (nfm > n) then
         xpt(nf, nfmm) = - rhobeg
      end if
   else
      itemp = (nfmm-1) / n
      jpt = nfm - itemp * n - n
      ipt = jpt + itemp
      if (ipt > n) then
         itemp = jpt
         jpt = ipt - n
         ipt = itemp
      end if
      xipt = rhobeg
      if (fval(ipt+np) < fval(ipt+1)) xipt = - xipt
      xjpt = rhobeg
      if (fval(jpt+np) < fval(jpt+1)) xjpt = - xjpt
      xpt(nf, ipt) = xipt
      xpt(nf, jpt) = xjpt
   end if
   !
   !     Calculate the next value of F, label 70 being reached immediately
   !     after this calculation. The least function value so far and its index
   !     are required.
   !
   do j = 1, n
      x(j) = xpt(nf, j) + xbase(j)
   end do
   go to 310
   70 continue
   fval(nf) = f
   if (nf == 1) then
      fbeg = f
      fopt = f
      kopt = 1
   else if (f < fopt) then
      fopt = f
      kopt = nf
   end if
   !
   !     Set the nonzero initial elements of BMAT and the quadratic model in
   !     the cases when NF is at most 2*N+1.
   !
   if (nfm <= 2*n) then
      if (nfm >= 1 .and. nfm <= n) then
         gq(nfm) = (f-fbeg) / rhobeg
         if (npt < nf+n) then
            bmat(1, nfm) = - one / rhobeg
            bmat(nf, nfm) = one / rhobeg
            bmat(npt+nfm, nfm) = - half * rhosq
         end if
      else if (nfm > n) then
         bmat(nf-n, nfmm) = half / rhobeg
         bmat(nf, nfmm) = - half / rhobeg
         zmat(1, nfmm) = - reciq - reciq
         zmat(nf-n, nfmm) = reciq
         zmat(nf, nfmm) = reciq
         ih = (nfmm*(nfmm+1)) / 2
         temp = (fbeg-f) / rhobeg
         hq(ih) = (gq(nfmm)-temp) / rhobeg
         gq(nfmm) = half * (gq(nfmm)+temp)
      end if
      !
      !     Set the off-diagonal second derivatives of the Lagrange functions and
      !     the initial quadratic model.
      !
   else
      ih = (ipt*(ipt-1)) / 2 + jpt
      if (xipt < zero) ipt = ipt + n
      if (xjpt < zero) jpt = jpt + n
      zmat(1, nfmm) = recip
      zmat(nf, nfmm) = recip
      zmat(ipt+1, nfmm) = - recip
      zmat(jpt+1, nfmm) = - recip
      hq(ih) = (fbeg-fval(ipt+1)-fval(jpt+1)+f) / (xipt*xjpt)
   end if
   if (nf < npt) go to 50
   !
   !     Begin the iterative procedure, because the initial model is complete.
   !
   rho = rhobeg
   delta = rho
   idz = 1
   diffa = zero
   diffb = zero
   itest = 0
   xoptsq = zero
   do i = 1, n
      xopt(i) = xpt(kopt, i)
      xoptsq = xoptsq + xopt(i) ** 2
   end do
   90 continue
   nfsav = nf
   !
   !     Generate the next trust region step and test its length. Set KNEW
   !     to -1 if the purpose of the next F will be to improve the model.
   !
   100 continue
   knew = 0
   call trsapp(n, npt, xopt, xpt, gq, hq, pq, delta, d, w, w(np), w(np+n), &
      w(np+2*n), crvmin)
   dsq = zero
   do i = 1, n
      dsq = dsq + d(i) ** 2
   end do
   dnorm = min(delta, sqrt(dsq))
   if (dnorm < half*rho) then
      knew = - 1
      delta = tenth * delta
      ratio = - 1.0_wp
      if (delta <= 1.5_wp*rho) delta = rho
      if (nf <= nfsav+2) go to 460
      temp = 0.125_wp * crvmin * rho * rho
      if (temp <= max(diffa, diffb, diffc)) go to 460
      go to 490
   end if
   !
   !     Shift XBASE if XOPT may be too far from XBASE. First make the changes
   !     to BMAT that do not depend on ZMAT.
   !
   120 continue
   if (dsq <= 1.0e-3_wp*xoptsq) then
      tempq = 0.25_wp * xoptsq
      do k = 1, npt
         sum = zero
         do i = 1, n
            sum = sum + xpt(k, i) * xopt(i)
         end do
         temp = pq(k) * sum
         sum = sum - half * xoptsq
         w(npt+k) = sum
         do i = 1, n
            gq(i) = gq(i) + temp * xpt(k, i)
            xpt(k, i) = xpt(k, i) - half * xopt(i)
            vlag(i) = bmat(k, i)
            w(i) = sum * xpt(k, i) + tempq * xopt(i)
            ip = npt + i
            do j = 1, i
               bmat(ip, j) = bmat(ip, j) + vlag(i) * w(j) + w(i) * vlag(j)
            end do
         end do
      end do
      !
      !     Then the revisions of BMAT that depend on ZMAT are calculated.
      !
      do k = 1, nptm
         sumz = zero
         do i = 1, npt
            sumz = sumz + zmat(i, k)
            w(i) = w(npt+i) * zmat(i, k)
         end do
         do j = 1, n
            sum = tempq * sumz * xopt(j)
            do i = 1, npt
               sum = sum + w(i) * xpt(i, j)
            end do
            vlag(j) = sum
            if (k < idz) sum = - sum
            do i = 1, npt
               bmat(i, j) = bmat(i, j) + sum * zmat(i, k)
            end do
         end do
         do i = 1, n
            ip = i + npt
            temp = vlag(i)
            if (k < idz) temp = - temp
            do j = 1, i
               bmat(ip, j) = bmat(ip, j) + temp * vlag(j)
            end do
         end do
      end do
      !
      !     The following instructions complete the shift of XBASE, including
      !     the changes to the parameters of the quadratic model.
      !
      ih = 0
      do j = 1, n
         w(j) = zero
         do k = 1, npt
            w(j) = w(j) + pq(k) * xpt(k, j)
            xpt(k, j) = xpt(k, j) - half * xopt(j)
         end do
         do i = 1, j
            ih = ih + 1
            if (i < j) gq(j) = gq(j) + hq(ih) * xopt(i)
            gq(i) = gq(i) + hq(ih) * xopt(j)
            hq(ih) = hq(ih) + w(i) * xopt(j) + xopt(i) * w(j)
            bmat(npt+i, j) = bmat(npt+j, i)
         end do
      end do
      do j = 1, n
         xbase(j) = xbase(j) + xopt(j)
         xopt(j) = zero
      end do
      xoptsq = zero
   end if
   !
   !     Pick the model step if KNEW is positive. A different choice of D
   !     may be made later, if the choice of D by BIGLAG causes substantial
   !     cancellation in DENOM.
   !
   if (knew > 0) then
      call biglag(n, npt, xopt, xpt, bmat, zmat, idz, ndim, knew, dstep, d, alpha, &
         vlag, vlag(npt+1), w, w(np), w(np+n))
   end if
   !
   !     Calculate VLAG and BETA for the current choice of D. The first NPT
   !     components of W_check will be held in W.
   !
   do k = 1, npt
      suma = zero
      sumb = zero
      sum = zero
      do j = 1, n
         suma = suma + xpt(k, j) * d(j)
         sumb = sumb + xpt(k, j) * xopt(j)
         sum = sum + bmat(k, j) * d(j)
      end do
      w(k) = suma * (half*suma+sumb)
      vlag(k) = sum
   end do
   beta = zero
   do k = 1, nptm
      sum = zero
      do i = 1, npt
         sum = sum + zmat(i, k) * w(i)
      end do
      if (k < idz) then
         beta = beta + sum * sum
         sum = - sum
      else
         beta = beta - sum * sum
      end if
      do i = 1, npt
         vlag(i) = vlag(i) + sum * zmat(i, k)
      end do
   end do
   bsum = zero
   dx = zero
   do j = 1, n
      sum = zero
      do i = 1, npt
         sum = sum + w(i) * bmat(i, j)
      end do
      bsum = bsum + sum * d(j)
      jp = npt + j
      do k = 1, n
         sum = sum + bmat(jp, k) * d(k)
      end do
      vlag(jp) = sum
      bsum = bsum + sum * d(j)
      dx = dx + d(j) * xopt(j)
   end do
   beta = dx * dx + dsq * (xoptsq+dx+dx+half*dsq) + beta - bsum
   vlag(kopt) = vlag(kopt) + one
   !
   !     If KNEW is positive and if the cancellation in DENOM is unacceptable,
   !     then BIGDEN calculates an alternative model step, XNEW being used for
   !     working space.
   !
   if (knew > 0) then
      temp = one + alpha * beta / vlag(knew) ** 2
      if (abs(temp) <= 0.8_wp) then
         call bigden(n, npt, xopt, xpt, bmat, zmat, idz, ndim, kopt, knew, d, w, &
            vlag, beta, xnew, w(ndim+1), w(6*ndim+1))
      end if
   end if
   !
   !     Calculate the next value of the objective function.
   !
   290 continue
   do i = 1, n
      xnew(i) = xopt(i) + d(i)
      x(i) = xbase(i) + xnew(i)
   end do
   nf = nf + 1
   310 continue
   if (nf > nftest) then
      nf = nf - 1
      if (iprint > 0) print '(/, 4x, "Return from NEWUOA because CALFUN has been", &
         &" called MAXFUN times.")'
      go to 530
   end if
   f = calfun(n, x, handle, error)
   if (allocated(error)) goto 530
   if (iprint == 3) then
      print '(/, 4x, "Function number", i6, "    F =", 1 es18.10, &
         &"    The corresponding X is:" / (2 x, 5es15.6))', nf, f, (x(i), i=1, n)
   end if
   if (nf <= npt) go to 70
   if (knew ==-1) go to 530
   !
   !     Use the quadratic model to predict the change in F due to the step D,
   !     and set DIFF to the error of this prediction.
   !
   vquad = zero
   ih = 0
   do j = 1, n
      vquad = vquad + d(j) * gq(j)
      do i = 1, j
         ih = ih + 1
         temp = d(i) * xnew(j) + d(j) * xopt(i)
         if (i == j) temp = half * temp
         vquad = vquad + temp * hq(ih)
      end do
   end do
   do k = 1, npt
      vquad = vquad + pq(k) * w(k)
   end do
   diff = f - fopt - vquad
   diffc = diffb
   diffb = diffa
   diffa = abs(diff)
   if (dnorm > rho) nfsav = nf
   !
   !     Update FOPT and XOPT if the new F is the least value of the objective
   !     function so far. The branch when KNEW is positive occurs if D is not
   !     a trust region step.
   !
   fsave = fopt
   if (f < fopt) then
      fopt = f
      xoptsq = zero
      do i = 1, n
         xopt(i) = xnew(i)
         xoptsq = xoptsq + xopt(i) ** 2
      end do
   end if
   ksave = knew
   if (knew > 0) go to 410
   !
   !     Pick the next value of DELTA after a trust region step.
   !
   if (vquad >= zero) then
      if (iprint > 0) print '(/, 4x, "Return from NEWUOA because a trust", &
         &" region step has failed to reduce Q.")'
      go to 530
   end if
   ratio = (f-fsave) / vquad
   if (ratio <= tenth) then
      delta = half * dnorm
   else if (ratio <= 0.7_wp) then
      delta = max(half*delta, dnorm)
   else
      delta = max(half*delta, dnorm+dnorm)
   end if
   if (delta <= 1.5_wp*rho) delta = rho
   !
   !     Set KNEW to the index of the next interpolation point to be deleted.
   !
   rhosq = max(tenth*delta, rho) ** 2
   ktemp = 0
   detrat = zero
   if (f >= fsave) then
      ktemp = kopt
      detrat = one
   end if
   do k = 1, npt
      hdiag = zero
      do j = 1, nptm
         temp = one
         if (j < idz) temp = - one
         hdiag = hdiag + temp * zmat(k, j) ** 2
      end do
      temp = abs(beta*hdiag+vlag(k)**2)
      distsq = zero
      do j = 1, n
         distsq = distsq + (xpt(k, j)-xopt(j)) ** 2
      end do
      if (distsq > rhosq) temp = temp * (distsq/rhosq) ** 3
      if (temp > detrat .and. k /= ktemp) then
         detrat = temp
         knew = k
      end if
   end do
   if (knew == 0) go to 460
   !
   !     Update BMAT, ZMAT and IDZ, so that the KNEW-th interpolation point
   !     can be moved. Begin the updating of the quadratic model, starting
   !     with the explicit second derivative term.
   !
   410 continue
   call update(n, npt, bmat, zmat, idz, ndim, vlag, beta, knew, w)
   fval(knew) = f
   ih = 0
   do i = 1, n
      temp = pq(knew) * xpt(knew, i)
      do j = 1, i
         ih = ih + 1
         hq(ih) = hq(ih) + temp * xpt(knew, j)
      end do
   end do
   pq(knew) = zero
   !
   !     Update the other second derivative parameters, and then the gradient
   !     vector of the model. Also include the new interpolation point.
   !
   do j = 1, nptm
      temp = diff * zmat(knew, j)
      if (j < idz) temp = - temp
      do k = 1, npt
         pq(k) = pq(k) + temp * zmat(k, j)
      end do
   end do
   gqsq = zero
   do i = 1, n
      gq(i) = gq(i) + diff * bmat(knew, i)
      gqsq = gqsq + gq(i) ** 2
      xpt(knew, i) = xnew(i)
   end do
   !
   !     If a trust region step makes a small change to the objective function,
   !     then calculate the gradient of the least Frobenius norm interpolant at
   !     XBASE, and store it in W, using VLAG for a vector of right hand sides.
   !
   if (ksave == 0 .and. delta == rho) then
      if (abs(ratio) > 1.0e-2_wp) then
         itest = 0
      else
         do k = 1, npt
            vlag(k) = fval(k) - fval(kopt)
         end do
         gisq = zero
         do i = 1, n
            sum = zero
            do k = 1, npt
               sum = sum + bmat(k, i) * vlag(k)
            end do
            gisq = gisq + sum * sum
            w(i) = sum
         end do
         !
         !     Test whether to replace the new quadratic model by the least Frobenius
         !     norm interpolant, making the replacement if the test is satisfied.
         !
         itest = itest + 1
         if (gqsq < 100.0_wp*gisq) itest = 0
         if (itest >= 3) then
            do i = 1, n
               gq(i) = w(i)
            end do
            do ih = 1, nh
               hq(ih) = zero
            end do
            do j = 1, nptm
               w(j) = zero
               do k = 1, npt
                  w(j) = w(j) + vlag(k) * zmat(k, j)
               end do
               if (j < idz) w(j) = - w(j)
            end do
            do k = 1, npt
               pq(k) = zero
               do j = 1, nptm
                  pq(k) = pq(k) + zmat(k, j) * w(j)
               end do
            end do
            itest = 0
         end if
      end if
   end if
   if (f < fsave) kopt = knew
   !
   !     If a trust region step has provided a sufficient decrease in F, then
   !     branch for another trust region calculation. The case KSAVE>0 occurs
   !     when the new function value was calculated by a model step.
   !
   if (f <= fsave+tenth*vquad) go to 100
   if (ksave > 0) go to 100
   !
   !     Alternatively, find out if the interpolation points are close enough
   !     to the best point so far.
   !
   knew = 0
   460 continue
   distsq = 4.0_wp * delta * delta
   do k = 1, npt
      sum = zero
      do j = 1, n
         sum = sum + (xpt(k, j)-xopt(j)) ** 2
      end do
      if (sum > distsq) then
         knew = k
         distsq = sum
      end if
   end do
   !
   !     If KNEW is positive, then set DSTEP, and branch back for the next
   !     iteration, which will generate a "model step".
   !
   if (knew > 0) then
      dstep = max(min(tenth*sqrt(distsq), half*delta), rho)
      dsq = dstep * dstep
      go to 120
   end if
   if (ratio > zero) go to 100
   if (max(delta, dnorm) > rho) go to 100
   !
   !     The calculations with the current value of RHO are complete. Pick the
   !     next values of RHO and DELTA.
   !
   490 continue
   if (rho > rhoend) then
      delta = half * rho
      ratio = rho / rhoend
      if (ratio <= 16.0_wp) then
         rho = rhoend
      else if (ratio <= 250.0_wp) then
         rho = sqrt(ratio) * rhoend
      else
         rho = tenth * rho
      end if
      delta = max(delta, rho)
      if (iprint >= 2) then
         if (iprint >= 3) print '(5 x)'
         print '(/ 4 x, "New RHO =", 1 es11.4, 5 x, "Number of", &
            &" function values =", i6)', rho, nf
         print '(4 x, "Least value of F =", 1 es23.15, 9 x, &
            &"The corresponding X is:"/(2 x, 5es15.6))', fopt, (xbase(i)+xopt(i), i=1, n)
      end if
      go to 90
   end if
   !
   !     Return from the calculation, after another Newton-Raphson step, if
   !     it is too short to have been tried before.
   !
   if (knew ==-1) go to 290
   530 if (fopt <= f) then
      do i = 1, n
         x(i) = xbase(i) + xopt(i)
      end do
      f = fopt
   end if
   if (iprint >= 1) then
      print '(/ 4 x, "At the return from NEWUOA", 5 x, &
         &"Number of function values =", i6)', nf
      print '(4 x, "Least value of F =", 1 es23.15, 9 x,&
         &"The corresponding X is:"/(2 x, 5es15.6))', f, (x(i), i=1, n)
   end if

end subroutine newuob

!> D is calculated in a way that should provide a denominator with a large
!> modulus in the updating formula when the KNEW-th interpolation point is
!> shifted to the new position XOPT+D.
pure subroutine bigden(n, npt, xopt, xpt, bmat, zmat, idz, ndim, kopt, knew, d, w, vlag, &
      beta, s, wvec, prod)
   !> N is the number of variables.
   integer, intent(in) :: n
   !> NPT is the number of interpolation equations.
   integer, intent(in) :: npt
   !> NDIM is the first dimension of BMAT and has the value NPT+N.
   integer, intent(in) :: ndim
   !> XOPT is the best interpolation point so far.
   real(wp), intent(in) :: xopt(*)
   !> XPT contains the coordinates of the current interpolation points.
   real(wp), intent(in) :: xpt(npt, *)
   !> BMAT provides the last N columns of H.
   real(wp), intent(in) :: bmat(ndim, *)
   !> ZMAT and IDZ give a factorization of the first NPT by NPT submatrix of H.
   real(wp), intent(in) :: zmat(npt, *)
   integer, intent(in) :: idz
   !> KOPT is the index of the optimal interpolation point.
   integer, intent(in) :: kopt
   !> KNEW is the index of the interpolation point that is going to be moved.
   integer, intent(in) :: knew
   !> D will be set to the step from XOPT to the new point, and on entry it
   !> should be the D that was calculated by the last call of BIGLAG. The
   !> length of the initial D provides a trust region bound on the final D.
   real(wp), intent(inout) :: d(*)
   !> W will be set to Wcheck for the final choice of D.
   real(wp), intent(inout) :: w(*)
   !> VLAG will be set to Theta*Wcheck+e_b for the final choice of D.
   real(wp), intent(inout) :: vlag(*)
   !> BETA will be set to the value that will occur in the updating formula
   !> when the KNEW-th interpolation point is moved to its new position.
   real(wp), intent(inout) :: beta
   !> S, WVEC, PROD and the private arrays DEN, DENEX and PAR will be used
   !> for working space.
   real(wp), intent(inout) :: s(*)
   real(wp), intent(inout) :: wvec(ndim, *)
   real(wp), intent(inout) :: prod(ndim, *)

   integer :: i, j, k, ip, isave, iterc, iu, jc, ksav, nptm, nw
   real(wp) :: den(9), denex(9), par(9), temp, alpha, dd, ds, ss, angle, denmax, denold, &
      & densav, sum, diff, dstemp, dtest, ssden, sstemp, step, sumold, tau, tempa, tempb, &
      & tempc, xoptd, xopts, xoptsq
   real(wp), parameter :: half = 0.5_wp, one = 1.0_wp, quart = 0.25_wp, two = 2.0_wp, &
      & zero = 0.0_wp, twopi = 8.0_wp * atan(one)
   nptm = npt - n - 1
   !
   !     Store the first NPT elements of the KNEW-th column of H in W(N+1)
   !     to W(N+NPT).
   !
   do k = 1, npt
      w(n+k) = zero
   end do
   do j = 1, nptm
      temp = zmat(knew, j)
      if (j < idz) temp = - temp
      do k = 1, npt
         w(n+k) = w(n+k) + temp * zmat(k, j)
      end do
   end do
   alpha = w(n+knew)
   !
   !     The initial search direction D is taken from the last call of BIGLAG,
   !     and the initial S is set below, usually to the direction from X_OPT
   !     to X_KNEW, but a different direction to an interpolation point may
   !     be chosen, in order to prevent S from being nearly parallel to D.
   !
   dd = zero
   ds = zero
   ss = zero
   xoptsq = zero
   do i = 1, n
      dd = dd + d(i) ** 2
      s(i) = xpt(knew, i) - xopt(i)
      ds = ds + d(i) * s(i)
      ss = ss + s(i) ** 2
      xoptsq = xoptsq + xopt(i) ** 2
   end do
   if (ds*ds > 0.99_wp*dd*ss) then
      ksav = knew
      dtest = ds * ds / ss
      do k = 1, npt
         if (k /= kopt) then
            dstemp = zero
            sstemp = zero
            do i = 1, n
               diff = xpt(k, i) - xopt(i)
               dstemp = dstemp + d(i) * diff
               sstemp = sstemp + diff * diff
            end do
            if (dstemp*dstemp/sstemp < dtest) then
               ksav = k
               dtest = dstemp * dstemp / sstemp
               ds = dstemp
               ss = sstemp
            end if
         end if
      end do
      do i = 1, n
         s(i) = xpt(ksav, i) - xopt(i)
      end do
   end if
   ssden = dd * ss - ds * ds
   iterc = 0
   densav = zero
   !
   !     Begin the iteration by overwriting S with a vector that has the
   !     required length and direction.
   !
   70      iterc = iterc + 1
   temp = one / sqrt(ssden)
   xoptd = zero
   xopts = zero
   do i = 1, n
      s(i) = temp * (dd*s(i)-ds*d(i))
      xoptd = xoptd + xopt(i) * d(i)
      xopts = xopts + xopt(i) * s(i)
   end do
   !
   !     Set the coefficients of the first two terms of BETA.
   !
   tempa = half * xoptd * xoptd
   tempb = half * xopts * xopts
   den(1) = dd * (xoptsq+half*dd) + tempa + tempb
   den(2) = two * xoptd * dd
   den(3) = two * xopts * dd
   den(4) = tempa - tempb
   den(5) = xoptd * xopts
   do i = 6, 9
      den(i) = zero
   end do
   !
   !     Put the coefficients of Wcheck in WVEC.
   !
   do k = 1, npt
      tempa = zero
      tempb = zero
      tempc = zero
      do i = 1, n
         tempa = tempa + xpt(k, i) * d(i)
         tempb = tempb + xpt(k, i) * s(i)
         tempc = tempc + xpt(k, i) * xopt(i)
      end do
      wvec(k, 1) = quart * (tempa*tempa+tempb*tempb)
      wvec(k, 2) = tempa * tempc
      wvec(k, 3) = tempb * tempc
      wvec(k, 4) = quart * (tempa*tempa-tempb*tempb)
      wvec(k, 5) = half * tempa * tempb
   end do
   do i = 1, n
      ip = i + npt
      wvec(ip, 1) = zero
      wvec(ip, 2) = d(i)
      wvec(ip, 3) = s(i)
      wvec(ip, 4) = zero
      wvec(ip, 5) = zero
   end do
   !
   !     Put the coefficents of THETA*Wcheck in PROD.
   !
   do jc = 1, 5
      nw = npt
      if(jc == 2 .or. jc == 3) nw = ndim
      do k = 1, npt
         prod(k, jc) = zero
      end do
      do j = 1, nptm
         sum = zero
         do k = 1, npt
            sum = sum + zmat(k, j) * wvec(k, jc)
         end do
         if (j < idz) sum = - sum
         do k = 1, npt
            prod(k, jc) = prod(k, jc) + sum * zmat(k, j)
         end do
      end do
      if (nw == ndim) then
         do k = 1, npt
            sum = zero
            do j = 1, n
               sum = sum + bmat(k, j) * wvec(npt+j, jc)
            end do
            prod(k, jc) = prod(k, jc) + sum
         end do
      end if
      do j = 1, n
         sum = zero
         do i = 1, nw
            sum = sum + bmat(i, j) * wvec(i, jc)
         end do
         prod(npt+j, jc) = sum
      end do
   end do
   !
   !     Include in DEN the part of BETA that depends on THETA.
   !
   do k = 1, ndim
      sum = zero
      do i = 1, 5
         par(i) = half * prod(k, i) * wvec(k, i)
         sum = sum + par(i)
      end do
      den(1) = den(1) - par(1) - sum
      tempa = prod(k, 1) * wvec(k, 2) + prod(k, 2) * wvec(k, 1)
      tempb = prod(k, 2) * wvec(k, 4) + prod(k, 4) * wvec(k, 2)
      tempc = prod(k, 3) * wvec(k, 5) + prod(k, 5) * wvec(k, 3)
      den(2) = den(2) - tempa - half * (tempb+tempc)
      den(6) = den(6) - half * (tempb-tempc)
      tempa = prod(k, 1) * wvec(k, 3) + prod(k, 3) * wvec(k, 1)
      tempb = prod(k, 2) * wvec(k, 5) + prod(k, 5) * wvec(k, 2)
      tempc = prod(k, 3) * wvec(k, 4) + prod(k, 4) * wvec(k, 3)
      den(3) = den(3) - tempa - half * (tempb-tempc)
      den(7) = den(7) - half * (tempb+tempc)
      tempa = prod(k, 1) * wvec(k, 4) + prod(k, 4) * wvec(k, 1)
      den(4) = den(4) - tempa - par(2) + par(3)
      tempa = prod(k, 1) * wvec(k, 5) + prod(k, 5) * wvec(k, 1)
      tempb = prod(k, 2) * wvec(k, 3) + prod(k, 3) * wvec(k, 2)
      den(5) = den(5) - tempa - half * tempb
      den(8) = den(8) - par(4) + par(5)
      tempa = prod(k, 4) * wvec(k, 5) + prod(k, 5) * wvec(k, 4)
      den(9) = den(9) - half * tempa
   end do
   !
   !     Extend DEN so that it holds all the coefficients of DENOM.
   !
   sum = zero
   do i = 1, 5
      par(i) = half * prod(knew, i) ** 2
      sum = sum + par(i)
   end do
   denex(1) = alpha * den(1) + par(1) + sum
   tempa = two * prod(knew, 1) * prod(knew, 2)
   tempb = prod(knew, 2) * prod(knew, 4)
   tempc = prod(knew, 3) * prod(knew, 5)
   denex(2) = alpha * den(2) + tempa + tempb + tempc
   denex(6) = alpha * den(6) + tempb - tempc
   tempa = two * prod(knew, 1) * prod(knew, 3)
   tempb = prod(knew, 2) * prod(knew, 5)
   tempc = prod(knew, 3) * prod(knew, 4)
   denex(3) = alpha * den(3) + tempa + tempb - tempc
   denex(7) = alpha * den(7) + tempb + tempc
   tempa = two * prod(knew, 1) * prod(knew, 4)
   denex(4) = alpha * den(4) + tempa + par(2) - par(3)
   tempa = two * prod(knew, 1) * prod(knew, 5)
   denex(5) = alpha * den(5) + tempa + prod(knew, 2) * prod(knew, 3)
   denex(8) = alpha * den(8) + par(4) - par(5)
   denex(9) = alpha * den(9) + prod(knew, 4) * prod(knew, 5)
   !
   !     Seek the value of the angle that maximizes the modulus of DENOM.
   !
   sum = denex(1) + denex(2) + denex(4) + denex(6) + denex(8)
   denold = sum
   denmax = sum
   isave = 0
   iu = 49
   temp = twopi / real(iu+1, wp)
   par(1) = one
   do i = 1, iu
      angle = real(i, wp) * temp
      par(2) = cos(angle)
      par(3) = sin(angle)
      do j = 4, 8, 2
         par(j) = par(2) * par(j-2) - par(3) * par(j-1)
         par(j+1) = par(2) * par(j-1) + par(3) * par(j-2)
      end do
      sumold = sum
      sum = zero
      do j = 1, 9
         sum = sum + denex(j) * par(j)
      end do
      if (abs(sum) > abs(denmax)) then
         denmax = sum
         isave = i
         tempa = sumold
      else if (i == isave+1) then
         tempb = sum
      end if
   end do
   if (isave == 0) tempa = sum
   if (isave == iu) tempb = denold
   step = zero
   if (tempa /= tempb) then
      tempa = tempa - denmax
      tempb = tempb - denmax
      step = half * (tempa-tempb) / (tempa+tempb)
   end if
   angle = temp * (real(isave, wp)+step)
   !
   !     Calculate the new parameters of the denominator, the new VLAG vector
   !     and the new D. Then test for convergence.
   !
   par(2) = cos(angle)
   par(3) = sin(angle)
   do j = 4, 8, 2
      par(j) = par(2) * par(j-2) - par(3) * par(j-1)
      par(j+1) = par(2) * par(j-1) + par(3) * par(j-2)
   end do
   beta = zero
   denmax = zero
   do j = 1, 9
      beta = beta + den(j) * par(j)
      denmax = denmax + denex(j) * par(j)
   end do
   do k = 1, ndim
      vlag(k) = zero
      do j = 1, 5
         vlag(k) = vlag(k) + prod(k, j) * par(j)
      end do
   end do
   tau = vlag(knew)
   dd = zero
   tempa = zero
   tempb = zero
   do i = 1, n
      d(i) = par(2) * d(i) + par(3) * s(i)
      w(i) = xopt(i) + d(i)
      dd = dd + d(i) ** 2
      tempa = tempa + d(i) * w(i)
      tempb = tempb + w(i) * w(i)
   end do
   if(iterc >= n) go to 340
   if(iterc > 1) densav = max(densav, denold)
   if(abs(denmax) <= 1.1_wp*abs(densav)) go to 340
   densav = denmax
   !
   !     Set S to half the gradient of the denominator with respect to D.
   !     Then branch for the next iteration.
   !
   do i = 1, n
      temp = tempa * xopt(i) + tempb * d(i) - vlag(npt+i)
      s(i) = tau * bmat(knew, i) + alpha * temp
   end do
   do k = 1, npt
      sum = zero
      do j = 1, n
         sum = sum + xpt(k, j) * w(j)
      end do
      temp = (tau*w(n+k)-alpha*vlag(k)) * sum
      do i = 1, n
         s(i) = s(i) + temp * xpt(k, i)
      end do
   end do
   ss = zero
   ds = zero
   do i = 1, n
      ss = ss + s(i) ** 2
      ds = ds + d(i) * s(i)
   end do
   ssden = dd * ss - ds * ds
   if (ssden >= 1.0e-8_wp*dd*ss) go to 70
   !
   !     Set the vector W before the RETURN from the subroutine.
   !
   340 continue
   do k = 1, ndim
      w(k) = zero
      do j = 1, 5
         w(k) = w(k) + wvec(k, j) * par(j)
      end do
   end do
   vlag(kopt) = vlag(kopt) + one

end subroutine bigden

!> The step D is calculated in a way that attempts to maximize the modulus
!> of LFUNC(XOPT+D), subject to the bound ||D|| .LE. DELTA, where LFUNC is
!> the KNEW-th Lagrange function.
pure subroutine biglag(n, npt, xopt, xpt, bmat, zmat, idz, ndim, knew, delta, d, alpha, &
      hcol, gc, gd, s, w)
   !> N is the number of variables.
   integer, intent(in) :: n
   !> NPT is the number of interpolation equations.
   integer, intent(in) :: npt
   !> NDIM is the first dimension of BMAT and has the value NPT+N.
   integer, intent(in) :: ndim
   !> XOPT is the best interpolation point so far.
   real(wp), intent(in) :: xopt(*)
   !> XPT contains the coordinates of the current interpolation points.
   real(wp), intent(in) :: xpt(npt, *)
   !> BMAT provides the last N columns of H.
   real(wp), intent(in) :: bmat(ndim, *)
   !> ZMAT and IDZ give a factorization of the first NPT by NPT submatrix of H.
   real(wp), intent(in) :: zmat(npt, *)
   integer, intent(in) :: idz
   !> KNEW is the index of the interpolation point that is going to be moved.
   integer, intent(in) :: knew
   !> DELTA is the current trust region bound.
   real(wp), intent(in) :: delta
   !> D will be set to the step from XOPT to the new point.
   real(wp), intent(inout) :: d(*)
   !> ALPHA will be set to the KNEW-th diagonal element of the H matrix.
   real(wp), intent(inout) :: alpha
   !> HCOL, GC, GD, S and W will be used for working space.
   real(wp), intent(inout) :: hcol(*)
   real(wp), intent(inout) :: gc(*)
   real(wp), intent(inout) :: gd(*)
   real(wp), intent(inout) :: s(*)
   real(wp), intent(inout) :: w(*)

   integer :: iterc, i, j, k, nptm, isave, iu
   real(wp) :: temp, delsq, dd, angle, cf1, cf2, cf3, cf4, cf5, cth, denom, dhd, gg, scale, &
      & sp, ss, step, sth, sum, tau, taubeg, taumax, tauold, tempa, tempb
   real(wp), parameter :: half = 0.5_wp, one = 1.0_wp, zero = 0.0_wp, &
      & twopi = 8.0_wp * atan(one)
   delsq = delta * delta
   nptm = npt - n - 1
   !
   !     Set the first NPT components of HCOL to the leading elements of the
   !     KNEW-th column of H.
   !
   iterc = 0
   do k = 1, npt
      hcol(k) = zero
   end do
   do j = 1, nptm
      temp = zmat(knew, j)
      if (j < idz) temp = - temp
      do k = 1, npt
         hcol(k) = hcol(k) + temp * zmat(k, j)
      end do
   end do
   alpha = hcol(knew)
   !
   !     Set the unscaled initial direction D. Form the gradient of LFUNC at
   !     XOPT, and multiply D by the second derivative matrix of LFUNC.
   !
   dd = zero
   do i = 1, n
      d(i) = xpt(knew, i) - xopt(i)
      gc(i) = bmat(knew, i)
      gd(i) = zero
      dd = dd + d(i) ** 2
   end do
   do k = 1, npt
      temp = zero
      sum = zero
      do j = 1, n
         temp = temp + xpt(k, j) * xopt(j)
         sum = sum + xpt(k, j) * d(j)
      end do
      temp = hcol(k) * temp
      sum = hcol(k) * sum
      do i = 1, n
         gc(i) = gc(i) + temp * xpt(k, i)
         gd(i) = gd(i) + sum * xpt(k, i)
      end do
   end do
   !
   !     Scale D and GD, with a sign change if required. Set S to another
   !     vector in the initial two dimensional subspace.
   !
   gg = zero
   sp = zero
   dhd = zero
   do i = 1, n
      gg = gg + gc(i) ** 2
      sp = sp + d(i) * gc(i)
      dhd = dhd + d(i) * gd(i)
   end do
   scale = delta / sqrt(dd)
   if (sp*dhd < zero) scale = - scale
   temp = zero
   if (sp*sp > 0.99_wp*dd*gg) temp = one
   tau = scale * (abs(sp)+half*scale*abs(dhd))
   if (gg*delsq < 0.01_wp*tau*tau) temp = one
   do i = 1, n
      d(i) = scale * d(i)
      gd(i) = scale * gd(i)
      s(i) = gc(i) + temp * gd(i)
   end do
   !
   !     Begin the iteration by overwriting S with a vector that has the
   !     required length and direction, except that termination occurs if
   !     the given D and S are nearly parallel.
   !
   80      iterc = iterc + 1
   dd = zero
   sp = zero
   ss = zero
   do i = 1, n
      dd = dd + d(i) ** 2
      sp = sp + d(i) * s(i)
      ss = ss + s(i) ** 2
   end do
   temp = dd * ss - sp * sp
   if (temp <= 1.0e-8_wp*dd*ss) go to 160
   denom = sqrt(temp)
   do i = 1, n
      s(i) = (dd*s(i)-sp*d(i)) / denom
      w(i) = zero
   end do
   !
   !     Calculate the coefficients of the objective function on the circle,
   !     beginning with the multiplication of S by the second derivative matrix.
   !
   do k = 1, npt
      sum = zero
      do j = 1, n
         sum = sum + xpt(k, j) * s(j)
      end do
      sum = hcol(k) * sum
      do i = 1, n
         w(i) = w(i) + sum * xpt(k, i)
      end do
   end do
   cf1 = zero
   cf2 = zero
   cf3 = zero
   cf4 = zero
   cf5 = zero
   do i = 1, n
      cf1 = cf1 + s(i) * w(i)
      cf2 = cf2 + d(i) * gc(i)
      cf3 = cf3 + s(i) * gc(i)
      cf4 = cf4 + d(i) * gd(i)
      cf5 = cf5 + s(i) * gd(i)
   end do
   cf1 = half * cf1
   cf4 = half * cf4 - cf1
   !
   !     Seek the value of the angle that maximizes the modulus of TAU.
   !
   taubeg = cf1 + cf2 + cf4
   taumax = taubeg
   tauold = taubeg
   isave = 0
   iu = 49
   temp = twopi / real(iu+1, wp)
   do i = 1, iu
      angle = real(i, wp) * temp
      cth = cos(angle)
      sth = sin(angle)
      tau = cf1 + (cf2+cf4*cth) * cth + (cf3+cf5*cth) * sth
      if (abs(tau) > abs(taumax)) then
         taumax = tau
         isave = i
         tempa = tauold
      else if (i == isave+1) then
         tempb = tau
      end if
      tauold = tau
   end do
   if (isave == 0) tempa = tau
   if (isave == iu) tempb = taubeg
   step = zero
   if (tempa /= tempb) then
      tempa = tempa - taumax
      tempb = tempb - taumax
      step = half * (tempa-tempb) / (tempa+tempb)
   end if
   angle = temp * (real(isave, wp)+step)
   !
   !     Calculate the new D and GD. Then test for convergence.
   !
   cth = cos(angle)
   sth = sin(angle)
   tau = cf1 + (cf2+cf4*cth) * cth + (cf3+cf5*cth) * sth
   do i = 1, n
      d(i) = cth * d(i) + sth * s(i)
      gd(i) = cth * gd(i) + sth * w(i)
      s(i) = gc(i) + gd(i)
   end do
   if (abs(tau) <= 1.1_wp*abs(taubeg)) go to 160
   if (iterc < n) go to 80
   160 return
end subroutine biglag

!> The calculation of STEP begins with the truncated conjugate gradient
!> method. If the boundary of the trust region is reached, then further
!> changes to STEP may be made, each one being in the 2D space spanned
!> by the current STEP and the corresponding gradient of Q. Thus STEP
!> should provide a substantial reduction to Q within the trust region.
pure subroutine trsapp(n, npt, xopt, xpt, gq, hq, pq, delta, step, d, g, hd, hs, crvmin)
   !> N is the number of variables of a quadratic objective function, Q say.
   integer, intent(in) :: n
   !> The arguments NPT, XOPT, XPT, GQ, HQ and PQ have their usual meanings,
   !>   in order to define the current quadratic model Q.
   integer, intent(in) :: npt
   real(wp), intent(in) :: xopt(*)
   real(wp), intent(in) :: xpt(npt, *)
   real(wp), intent(in) :: gq(*)
   real(wp), intent(in) :: hq(*)
   real(wp), intent(in) :: pq(*)
   !> DELTA is the trust region radius, and has to be positive.
   real(wp), intent(in) :: delta
   !> STEP will be set to the calculated trial step.
   real(wp), intent(inout) :: step(*)
   !> The arrays D, G, HD and HS will be used for working space.
   real(wp), intent(inout) :: d(*)
   real(wp), intent(inout) :: g(*)
   real(wp), intent(inout) :: hd(*)
   real(wp), intent(inout) :: hs(*)
   !> CRVMIN will be set to the least curvature of H along the conjugate
   !>   directions that occur, except that it is set to zero if STEP goes
   !>   all the way to the trust region boundary.
   real(wp), intent(inout) :: crvmin

   integer :: i, iterc, itermax, itersw, ih, isave, iu, j, k
   real(wp) :: delsq, qred, dd, ds, ss, gg, ggbeg, temp, bstep, alpha, angle, angtest, &
      & cf, cth, dg, dhd, dhs, ggsav, qadd, qbeg, qmin, qnew, qsav, ratio, reduc, sg, &
      & sgk, shs, sth, tempa, tempb
   real(wp), parameter :: half = 0.5_wp, zero = 0.0_wp, twopi = 8.0_wp * atan(1.0_wp)
   delsq = delta * delta
   iterc = 0
   itermax = n
   itersw = itermax
   do i = 1, n
      d(i) = xopt(i)
   end do
   go to 170
   !
   !     Prepare for the first line search.
   !
   20 continue
   qred = zero
   dd = zero
   do i = 1, n
      step(i) = zero
      hs(i) = zero
      g(i) = gq(i) + hd(i)
      d(i) = - g(i)
      dd = dd + d(i) ** 2
   end do
   crvmin = zero
   if (dd == zero) go to 160
   ds = zero
   ss = zero
   gg = dd
   ggbeg = gg
   !
   !     Calculate the step to the trust region boundary and the product HD.
   !
   40 continue
   iterc = iterc + 1
   temp = delsq - ss
   bstep = temp / (ds+sqrt(ds*ds+dd*temp))
   go to 170
   50 continue
   dhd = zero
   do j = 1, n
      dhd = dhd + d(j) * hd(j)
   end do
   !
   !     Update CRVMIN and set the step-length ALPHA.
   !
   alpha = bstep
   if (dhd > zero) then
      temp = dhd / dd
      if (iterc == 1) crvmin = temp
      crvmin = min(crvmin, temp)
      alpha = min(alpha, gg/dhd)
   end if
   qadd = alpha * (gg-half*alpha*dhd)
   qred = qred + qadd
   !
   !     Update STEP and HS.
   !
   ggsav = gg
   gg = zero
   do i = 1, n
      step(i) = step(i) + alpha * d(i)
      hs(i) = hs(i) + alpha * hd(i)
      gg = gg + (g(i)+hs(i)) ** 2
   end do
   !
   !     Begin another conjugate direction iteration if required.
   !
   if (alpha < bstep) then
      if (qadd <= 0.01_wp*qred) go to 160
      if (gg <= 1.0e-4_wp*ggbeg) go to 160
      if (iterc == itermax) go to 160
      temp = gg / ggsav
      dd = zero
      ds = zero
      ss = zero
      do i = 1, n
         d(i) = temp * d(i) - g(i) - hs(i)
         dd = dd + d(i) ** 2
         ds = ds + d(i) * step(i)
         ss = ss + step(i) ** 2
      end do
      if (ds <= zero) go to 160
      if (ss < delsq) go to 40
   end if
   crvmin = zero
   itersw = iterc
   !
   !     Test whether an alternative iteration is required.
   !
   90 continue
   if (gg <= 1.0e-4_wp*ggbeg) go to 160
   sg = zero
   shs = zero
   do i = 1, n
      sg = sg + step(i) * g(i)
      shs = shs + step(i) * hs(i)
   end do
   sgk = sg + shs
   angtest = sgk / sqrt(gg*delsq)
   if (angtest <=-0.99_wp) go to 160
   !
   !     Begin the alternative iteration by calculating D and HD and some
   !     scalar products.
   !
   iterc = iterc + 1
   temp = sqrt(delsq*gg-sgk*sgk)
   tempa = delsq / temp
   tempb = sgk / temp
   do i = 1, n
      d(i) = tempa * (g(i)+hs(i)) - tempb * step(i)
   end do
   go to 170
   120 continue
   dg = zero
   dhd = zero
   dhs = zero
   do i = 1, n
      dg = dg + d(i) * g(i)
      dhd = dhd + hd(i) * d(i)
      dhs = dhs + hd(i) * step(i)
   end do
   !
   !     Seek the value of the angle that minimizes Q.
   !
   cf = half * (shs-dhd)
   qbeg = sg + cf
   qsav = qbeg
   qmin = qbeg
   isave = 0
   iu = 49
   temp = twopi / real(iu+1, wp)
   do i = 1, iu
      angle = real(i, wp) * temp
      cth = cos(angle)
      sth = sin(angle)
      qnew = (sg+cf*cth) * cth + (dg+dhs*cth) * sth
      if (qnew < qmin) then
         qmin = qnew
         isave = i
         tempa = qsav
      else if (i == isave+1) then
         tempb = qnew
      end if
      qsav = qnew
   end do
   if (isave == zero) tempa = qnew
   if (isave == iu) tempb = qbeg
   angle = zero
   if (tempa /= tempb) then
      tempa = tempa - qmin
      tempb = tempb - qmin
      angle = half * (tempa-tempb) / (tempa+tempb)
   end if
   angle = temp * (real(isave, wp)+angle)
   !
   !     Calculate the new STEP and HS. Then test for convergence.
   !
   cth = cos(angle)
   sth = sin(angle)
   reduc = qbeg - (sg+cf*cth) * cth - (dg+dhs*cth) * sth
   gg = zero
   do i = 1, n
      step(i) = cth * step(i) + sth * d(i)
      hs(i) = cth * hs(i) + sth * hd(i)
      gg = gg + (g(i)+hs(i)) ** 2
   end do
   qred = qred + reduc
   ratio = reduc / qred
   if (iterc < itermax .and. ratio > 0.01_wp) go to 90
   160 return
   !
   !     The following instructions act as a subroutine for setting the vector
   !     HD to the vector D multiplied by the second derivative matrix of Q.
   !     They are called from three different places, which are distinguished
   !     by the value of ITERC.
   !
   170 continue
   do i = 1, n
      hd(i) = zero
   end do
   do k = 1, npt
      temp = zero
      do j = 1, n
         temp = temp + xpt(k, j) * d(j)
      end do
      temp = temp * pq(k)
      do i = 1, n
         hd(i) = hd(i) + temp * xpt(k, i)
      end do
   end do
   ih = 0
   do j = 1, n
      do i = 1, j
         ih = ih + 1
         if (i < j) hd(j) = hd(j) + hq(ih) * d(i)
         hd(i) = hd(i) + hq(ih) * d(j)
      end do
   end do
   if (iterc == 0) go to 20
   if (iterc <= itersw) go to 50
   go to 120
end subroutine trsapp

!> The arrays BMAT and ZMAT with IDZ are updated, in order to shift the
!> interpolation point that has index KNEW. On entry, VLAG contains the
!> components of the vector Theta*Wcheck+e_b of the updating formula
!> (6.11), and BETA holds the value of the parameter that has this name.
!> The vector W is used for working space.
pure subroutine update(n, npt, bmat, zmat, idz, ndim, vlag, beta, knew, w)
   integer, intent(in) :: n
   integer, intent(in) :: npt
   integer, intent(in) :: ndim
   real(wp), intent(inout) :: bmat(ndim, *)
   real(wp), intent(inout) :: zmat(npt, *)
   integer, intent(inout) :: idz
   real(wp), intent(inout) :: vlag(*)
   real(wp), intent(in) :: beta
   integer, intent(in) :: knew
   real(wp), intent(inout) :: w(*)

   integer :: i, j, ja, jb, jl, jp, iflag, nptm
   real(wp) :: temp, tempa, tempb, alpha, denom, scala, scalb, tau, tausq
   real(wp), parameter :: one = 1.0_wp, zero = 0.0_wp
   nptm = npt - n - 1
   !
   !     Apply the rotations that put zeros in the KNEW-th row of ZMAT.
   !
   jl = 1
   do j = 2, nptm
      if (j == idz) then
         jl = idz
      else if (zmat(knew, j) /= zero) then
         temp = sqrt(zmat(knew, jl)**2+zmat(knew, j)**2)
         tempa = zmat(knew, jl) / temp
         tempb = zmat(knew, j) / temp
         do i = 1, npt
            temp = tempa * zmat(i, jl) + tempb * zmat(i, j)
            zmat(i, j) = tempa * zmat(i, j) - tempb * zmat(i, jl)
            zmat(i, jl) = temp
         end do
         zmat(knew, j) = zero
      end if
   end do
   !
   !     Put the first NPT components of the KNEW-th column of HLAG into W,
   !     and calculate the parameters of the updating formula.
   !
   tempa = zmat(knew, 1)
   if (idz >= 2) tempa = - tempa
   if (jl > 1) tempb = zmat(knew, jl)
   do i = 1, npt
      w(i) = tempa * zmat(i, 1)
      if (jl > 1) w(i) = w(i) + tempb * zmat(i, jl)
   end do
   alpha = w(knew)
   tau = vlag(knew)
   tausq = tau * tau
   denom = alpha * beta + tausq
   vlag(knew) = vlag(knew) - one
   !
   !     Complete the updating of ZMAT when there is only one nonzero element
   !     in the KNEW-th row of the new matrix ZMAT, but, if IFLAG is set to one,
   !     then the first column of ZMAT will be exchanged with another one later.
   !
   iflag = 0
   if (jl == 1) then
      temp = sqrt(abs(denom))
      tempb = tempa / temp
      tempa = tau / temp
      do i = 1, npt
         zmat(i, 1) = tempa * zmat(i, 1) - tempb * vlag(i)
      end do
      if (idz == 1 .and. temp < zero) idz = 2
      if (idz >= 2 .and. temp >= zero) iflag = 1
   else
      !
      !     Complete the updating of ZMAT in the alternative case.
      !
      ja = 1
      if (beta >= zero) ja = jl
      jb = jl + 1 - ja
      temp = zmat(knew, jb) / denom
      tempa = temp * beta
      tempb = temp * tau
      temp = zmat(knew, ja)
      scala = one / sqrt(abs(beta)*temp*temp+tausq)
      scalb = scala * sqrt(abs(denom))
      do i = 1, npt
         zmat(i, ja) = scala * (tau*zmat(i, ja)-temp*vlag(i))
         zmat(i, jb) = scalb * (zmat(i, jb)-tempa*w(i)-tempb*vlag(i))
      end do
      if (denom <= zero) then
         if (beta < zero) idz = idz + 1
         if (beta >= zero) iflag = 1
      end if
   end if
   !
   !     IDZ is reduced in the following case, and usually the first column
   !     of ZMAT is exchanged with a later one.
   !
   if (iflag == 1) then
      idz = idz - 1
      do i = 1, npt
         temp = zmat(i, 1)
         zmat(i, 1) = zmat(i, idz)
         zmat(i, idz) = temp
      end do
   end if
   !
   !     Finally, update the matrix BMAT.
   !
   do j = 1, n
      jp = npt + j
      w(jp) = bmat(knew, j)
      tempa = (alpha*vlag(jp)-tau*w(jp)) / denom
      tempb = (-beta*w(jp)-tau*vlag(jp)) / denom
      do i = 1, jp
         bmat(i, j) = bmat(i, j) + tempa * vlag(i) + tempb * w(i)
         if (i > npt) bmat(jp, i-npt) = bmat(i, j)
      end do
   end do

end subroutine update

end module tblite_fit_newuoa

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/container/type.f90
!> Provides an abstract base class for interaction containers

!> Definition of abstract base class for general interactions
module tblite_container_type
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_container_cache, only : container_cache
   use tblite_scf_info, only : scf_info
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   !> Abstract base class for interactions containers
   type, public, abstract :: container_type
      !> Label identifying this contribution
      character(len=:), allocatable :: label
   contains
      !> Update container cache
      procedure :: update
      !> Get information about density dependent quantities used in the energy
      procedure :: variable_info
      !> Evaluate non-selfconsistent part of the interaction
      procedure :: get_engrad
      !> Evaluate selfconsistent energy of the interaction
      procedure :: get_energy
      !> Evaluate charge dependent potential shift from the interaction
      procedure :: get_potential
      !> Evaluate gradient of charge dependent potential shift from the interaction
      procedure :: get_potential_gradient
      !> Evaluate gradient contributions from the selfconsistent interaction
      procedure :: get_gradient
      !> Information on container
      procedure :: info
   end type container_type


contains


!> Update container cache
subroutine update(self, mol, cache)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
end subroutine update


!> Evaluate non-selfconsistent part of the interaction
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Interaction energy
   real(wp), intent(inout) :: energies(:)
   !> Interaction gradient
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Interaction virial
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)
end subroutine get_engrad


!> Evaluate selfconsistent energy of the interaction
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Interaction energy
   real(wp), intent(inout) :: energies(:)
end subroutine get_energy


!> Evaluate charge dependent potential shift from the interaction
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot
end subroutine get_potential


!> Evaluate charge dependent potential shift from the interaction
subroutine get_potential_gradient(self, mol, cache, wfn, pot)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot
end subroutine get_potential_gradient


!> Evaluate gradient contributions from the selfconsistent interaction
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Interaction gradient
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Interaction virial
   real(wp), contiguous, intent(inout) :: sigma(:, :)
end subroutine get_gradient


!> Get information about density dependent quantities used in the energy
pure function variable_info(self) result(info)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   info = scf_info()
end function variable_info


!> Information on container
pure function info(self, verbosity, indent) result(str)
   !> Instance of the interaction container
   class(container_type), intent(in) :: self
   !> Verbosity level
   integer, intent(in) :: verbosity
   !> Indentation level
   character(len=*), intent(in) :: indent
   !> Information on the container
   character(len=:), allocatable :: str

   if (allocated(self%label)) then
      str = self%label
   else
      str = "Unknown"
   end if
end function info


end module tblite_container_type

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of the public C-API of s-dftd3
!>
!>```c
!>{!./include/s-dftd3.h!}
!>```
module dftd3_api
   use iso_c_binding
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io_structure, only : structure_type, new
   use dftd3_cutoff, only : realspace_cutoff
   use dftd3_damping_cso, only : cso_damping_param, new_cso_damping
   use dftd3_damping_mzero, only : mzero_damping_param, new_mzero_damping
   use dftd3_damping_optimizedpower, only : optimizedpower_damping_param, &
      & new_optimizedpower_damping
   use dftd3_damping_rational, only : rational_damping_param, new_rational_damping
   use dftd3_damping_zero, only : zero_damping_param, new_zero_damping
   use dftd3_damping, only : damping_param
   use dftd3_disp, only : get_dispersion, get_pairwise_dispersion
   use dftd3_gcp, only : gcp_param, get_gcp_param, get_geometric_counterpoise
   use dftd3_model, only : d3_model, new_d3_model
   use dftd3_param, only : d3_param, get_rational_damping, get_zero_damping, &
      & get_mrational_damping, get_mzero_damping, get_optimizedpower_damping, &
      & get_cso_damping
   use dftd3_utils, only : wrap_to_central_cell
   use dftd3_version, only : get_dftd3_version
   implicit none
   private

   public :: get_version_api

   public :: vp_error
   public :: new_error_api, check_error_api, get_error_api, delete_error_api

   public :: vp_structure
   public :: new_structure_api, delete_structure_api, update_structure_api

   public :: vp_model
   public :: new_d3_model_api, delete_model_api

   public :: vp_param
   public :: new_zero_damping_api, load_zero_damping_api
   public :: new_rational_damping_api, load_rational_damping_api
   public :: new_mzero_damping_api, load_mzero_damping_api
   public :: new_mrational_damping_api, load_mrational_damping_api
   public :: new_optimizedpower_damping_api, load_optimizedpower_damping_api
   public :: new_cso_damping_api, load_cso_damping_api
   public :: delete_param_api

   public :: vp_gcp
   public :: load_gcp_param_api, delete_gcp_api, set_gcp_realspace_cutoff
   public :: get_counterpoise_api


   !> Void pointer to error handle
   type :: vp_error
      !> Actual payload
      type(error_type), allocatable :: ptr
   end type vp_error

   !> Void pointer to molecular structure data
   type :: vp_structure
      !> Actual payload
      type(structure_type) :: ptr
   end type vp_structure

   !> Void pointer to dispersion model
   type :: vp_model
      !> Actual payload
      type(d3_model) :: ptr
      !> Additional real space cutoff
      type(realspace_cutoff), allocatable :: cutoff
   end type vp_model

   !> Void pointer to damping parameters
   type :: vp_param
      !> Actual payload
      class(damping_param), allocatable :: ptr
   end type vp_param

   !> Void pointer to counter-poise parameters
   type :: vp_gcp
      !> Actual payload
      type(gcp_param) :: ptr
      !> Additional real space cutoff
      type(realspace_cutoff), allocatable :: cutoff
   end type vp_gcp


   character(len=*), parameter :: namespace = "dftd3_"


contains


!> Obtain library version as major * 10000 + minor + 100 + patch
function get_version_api() result(version) &
      & bind(C, name=namespace//"get_version")
   integer(c_int) :: version
   integer :: major, minor, patch

   call get_dftd3_version(major, minor, patch)
   version = 10000_c_int * major + 100_c_int * minor + patch

end function get_version_api


!> Create new error handle object
function new_error_api() &
      & result(verror) &
      & bind(C, name=namespace//"new_error")
   type(vp_error), pointer :: error
   type(c_ptr) :: verror

   allocate(error)
   verror = c_loc(error)

end function new_error_api


!> Delete error handle object
subroutine delete_error_api(verror) &
      & bind(C, name=namespace//"delete_error")
   type(c_ptr), intent(inout) :: verror
   type(vp_error), pointer :: error

   if (c_associated(verror)) then
      call c_f_pointer(verror, error)

      deallocate(error)
      verror = c_null_ptr
   end if

end subroutine delete_error_api


!> Check error handle status
function check_error_api(verror) result(status) &
      & bind(C, name=namespace//"check_error")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   integer(c_int) :: status

   if (c_associated(verror)) then
      call c_f_pointer(verror, error)

      if (allocated(error%ptr)) then
         status = 1
      else
         status = 0
      end if
   else
      status = 2
   end if

end function check_error_api


!> Get error message from error handle
subroutine get_error_api(verror, charptr, buffersize) &
      & bind(C, name=namespace//"get_error")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   character(kind=c_char), intent(inout) :: charptr(*)
   integer(c_int), intent(in), optional :: buffersize
   integer :: max_length

   if (c_associated(verror)) then
      call c_f_pointer(verror, error)

      if (present(buffersize)) then
         max_length = buffersize
      else
         max_length = huge(max_length) - 2
      end if

      if (allocated(error%ptr)) then
         call f_c_character(error%ptr%message, charptr, max_length)
      end if
   end if

end subroutine get_error_api


!> Create new molecular structure data (quantities in Bohr)
function new_structure_api(verror, natoms, numbers, positions, &
      & c_lattice, c_periodic) result(vmol) &
      & bind(C, name=namespace//"new_structure")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   integer(c_int), value, intent(in) :: natoms
   integer(c_int), intent(in) :: numbers(natoms)
   real(c_double), intent(in) :: positions(3, natoms)
   real(c_double), intent(in), optional :: c_lattice(3, 3)
   real(wp), allocatable :: lattice(:, :)
   logical(c_bool), intent(in), optional :: c_periodic(3)
   logical, allocatable :: periodic(:)
   type(vp_structure), pointer :: mol
   type(c_ptr) :: vmol

   vmol = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (present(c_lattice)) then
      allocate(lattice(3, 3))
      lattice(:, :) = c_lattice
   end if
   if (present(c_periodic)) then
      allocate(periodic(3))
      periodic(:) = c_periodic
   end if

   allocate(mol)
   call new(mol%ptr, numbers, positions, lattice=lattice, periodic=periodic)
   vmol = c_loc(mol)

   call wrap_to_central_cell(mol%ptr%xyz, mol%ptr%lattice, mol%ptr%periodic)

   call verify_structure(error%ptr, mol%ptr)

end function new_structure_api


!> Delete molecular structure data
subroutine delete_structure_api(vmol) &
      & bind(C, name=namespace//"delete_structure")
   type(c_ptr), intent(inout) :: vmol
   type(vp_structure), pointer :: mol

   if (c_associated(vmol)) then
      call c_f_pointer(vmol, mol)

      deallocate(mol)
      vmol = c_null_ptr
   end if

end subroutine delete_structure_api


!> Update coordinates and lattice parameters (quantities in Bohr)
subroutine update_structure_api(verror, vmol, positions, lattice) &
      & bind(C, name=namespace//"update_structure")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   real(c_double), intent(in) :: positions(3, *)
   real(c_double), intent(in), optional :: lattice(3, 3)

   if (.not.c_associated(verror)) then
      return
   end if
   call c_f_pointer(verror, error)

   if (.not.c_associated(vmol)) then
      call fatal_error(error%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   if (mol%ptr%nat <= 0 .or. mol%ptr%nid <= 0 .or. .not.allocated(mol%ptr%num) &
      & .or. .not.allocated(mol%ptr%id) .or. .not.allocated(mol%ptr%xyz)) then
      call fatal_error(error%ptr, "Invalid molecular structure data provided")
      return
   end if

   mol%ptr%xyz(:, :) = positions(:3, :mol%ptr%nat)
   if (present(lattice)) then
      mol%ptr%lattice(:, :) = lattice(:3, :3)
   end if

   call wrap_to_central_cell(mol%ptr%xyz, mol%ptr%lattice, mol%ptr%periodic)

   call verify_structure(error%ptr, mol%ptr)

end subroutine update_structure_api


!> Create new D3 dispersion model
function new_d3_model_api(verror, vmol) &
      & result(vdisp) &
      & bind(C, name=namespace//"new_d3_model")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr) :: vdisp
   type(vp_model), pointer :: disp

   vdisp = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vmol)) then
      call fatal_error(error%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   allocate(disp)
   call new_d3_model(disp%ptr, mol%ptr)
   vdisp = c_loc(disp)

end function new_d3_model_api


subroutine set_model_realspace_cutoff(verror, vdisp, disp2, disp3, cn) &
      & bind(C, name=namespace//"set_model_realspace_cutoff")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vdisp
   type(vp_model), pointer :: disp
   real(c_double), value, intent(in) :: disp2
   real(c_double), value, intent(in) :: disp3
   real(c_double), value, intent(in) :: cn

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vdisp)) then
      call fatal_error(error%ptr, "D3 dispersion model is missing")
      return
   end if
   call c_f_pointer(vdisp, disp)

   disp%cutoff = realspace_cutoff(disp2=disp2, disp3=disp3, cn=cn)
end subroutine set_model_realspace_cutoff


subroutine set_model_realspace_cutoff_smooth(verror, vdisp, disp2, disp3, cn, width2, width3) &
      & bind(C, name=namespace//"set_model_realspace_cutoff_smooth")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vdisp
   type(vp_model), pointer :: disp
   real(c_double), value, intent(in) :: disp2
   real(c_double), value, intent(in) :: disp3
   real(c_double), value, intent(in) :: cn
   real(c_double), value, intent(in) :: width2
   real(c_double), value, intent(in) :: width3

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vdisp)) then
      call fatal_error(error%ptr, "D3 dispersion model is missing")
      return
   end if
   call c_f_pointer(vdisp, disp)

   disp%cutoff = realspace_cutoff(disp2=disp2, disp3=disp3, cn=cn, &
      & width2=width2, width3=width3)
end subroutine set_model_realspace_cutoff_smooth


!> Delete dispersion model
subroutine delete_model_api(vdisp) &
      & bind(C, name=namespace//"delete_model")
   type(c_ptr), intent(inout) :: vdisp
   type(vp_model), pointer :: disp

   if (c_associated(vdisp)) then
      call c_f_pointer(vdisp, disp)

      deallocate(disp)
      vdisp = c_null_ptr
   end if

end subroutine delete_model_api


!> Create new rational damping parameters
function new_rational_damping_api(verror, s6, s8, s9, a1, a2, alp) &
      & result(vparam) &
      & bind(C, name=namespace//"new_rational_damping")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   real(c_double), value, intent(in) :: s6
   real(c_double), value, intent(in) :: s8
   real(c_double), value, intent(in) :: s9
   real(c_double), value, intent(in) :: a1
   real(c_double), value, intent(in) :: a2
   real(c_double), value, intent(in) :: alp
   type(c_ptr) :: vparam
   type(rational_damping_param), allocatable :: tmp
   type(vp_param), pointer :: param

   vparam = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   allocate(tmp)
   call new_rational_damping(tmp, d3_param(s6=s6, s8=s8, s9=s9, a1=a1, a2=a2, &
      & alp=alp))

   allocate(param)
   call move_alloc(tmp, param%ptr)
   vparam = c_loc(param)

end function new_rational_damping_api


!> Load rational damping parameters from internal storage
function load_rational_damping_api(verror, charptr, atm) &
      & result(vparam) &
      & bind(C, name=namespace//"load_rational_damping")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   character(kind=c_char), intent(in) :: charptr(*)
   logical(c_bool), value, intent(in) :: atm
   character(len=:, kind=c_char), allocatable :: method
   type(c_ptr) :: vparam
   type(rational_damping_param), allocatable :: tmp
   type(vp_param), pointer :: param
   type(d3_param) :: inp
   real(wp), allocatable :: s9

   vparam = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   call c_f_character(charptr, method)

   if (atm) s9 = 1.0_wp
   call get_rational_damping(inp, method, error%ptr, s9)
   if (allocated(error%ptr)) return

   allocate(tmp)
   call new_rational_damping(tmp, inp)

   allocate(param)
   call move_alloc(tmp, param%ptr)
   vparam = c_loc(param)

end function load_rational_damping_api


!> Create new zero damping parameters
function new_zero_damping_api(verror, s6, s8, s9, rs6, rs8, alp) &
      & result(vparam) &
      & bind(C, name=namespace//"new_zero_damping")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   real(c_double), value, intent(in) :: s6
   real(c_double), value, intent(in) :: s8
   real(c_double), value, intent(in) :: s9
   real(c_double), value, intent(in) :: rs6
   real(c_double), value, intent(in) :: rs8
   real(c_double), value, intent(in) :: alp
   type(c_ptr) :: vparam
   type(zero_damping_param), allocatable :: tmp
   type(vp_param), pointer :: param

   vparam = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   allocate(tmp)
   call new_zero_damping(tmp, d3_param(s6=s6, s8=s8, s9=s9, rs6=rs6, rs8=rs8, &
      & alp=alp))

   allocate(param)
   call move_alloc(tmp, param%ptr)
   vparam = c_loc(param)

end function new_zero_damping_api


!> Load zero damping parameters from internal storage
function load_zero_damping_api(verror, charptr, atm) &
      & result(vparam) &
      & bind(C, name=namespace//"load_zero_damping")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   character(kind=c_char), intent(in) :: charptr(*)
   logical(c_bool), value, intent(in) :: atm
   character(len=:, kind=c_char), allocatable :: method
   type(c_ptr) :: vparam
   type(zero_damping_param), allocatable :: tmp
   type(vp_param), pointer :: param
   type(d3_param) :: inp
   real(wp), allocatable :: s9

   vparam = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   call c_f_character(charptr, method)

   if (atm) s9 = 1.0_wp
   call get_zero_damping(inp, method, error%ptr, s9)
   if (allocated(error%ptr)) return

   allocate(tmp)
   call new_zero_damping(tmp, inp)

   allocate(param)
   call move_alloc(tmp, param%ptr)
   vparam = c_loc(param)

end function load_zero_damping_api


!> Create new rational damping parameters
function new_mrational_damping_api(verror, s6, s8, s9, a1, a2, alp) &
      & result(vparam) &
      & bind(C, name=namespace//"new_mrational_damping")
   type(c_ptr), value :: verror
   real(c_double), value, intent(in) :: s6
   real(c_double), value, intent(in) :: s8
   real(c_double), value, intent(in) :: s9
   real(c_double), value, intent(in) :: a1
   real(c_double), value, intent(in) :: a2
   real(c_double), value, intent(in) :: alp
   type(c_ptr) :: vparam

   vparam = new_rational_damping_api(verror, s6, s8, s9, a1, a2, alp)

end function new_mrational_damping_api


!> Load rational damping parameters from internal storage
function load_mrational_damping_api(verror, charptr, atm) &
      & result(vparam) &
      & bind(C, name=namespace//"load_mrational_damping")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   character(kind=c_char), intent(in) :: charptr(*)
   logical(c_bool), value, intent(in) :: atm
   character(len=:, kind=c_char), allocatable :: method
   type(c_ptr) :: vparam
   type(rational_damping_param), allocatable :: tmp
   type(vp_param), pointer :: param
   type(d3_param) :: inp
   real(wp), allocatable :: s9

   vparam = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   call c_f_character(charptr, method)

   if (atm) s9 = 1.0_wp
   call get_mrational_damping(inp, method, error%ptr, s9)
   if (allocated(error%ptr)) return

   allocate(tmp)
   call new_rational_damping(tmp, inp)

   allocate(param)
   call move_alloc(tmp, param%ptr)
   vparam = c_loc(param)

end function load_mrational_damping_api


!> Create new zero damping parameters
function new_mzero_damping_api(verror, s6, s8, s9, rs6, rs8, alp, bet) &
      & result(vparam) &
      & bind(C, name=namespace//"new_mzero_damping")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   real(c_double), value, intent(in) :: s6
   real(c_double), value, intent(in) :: s8
   real(c_double), value, intent(in) :: s9
   real(c_double), value, intent(in) :: rs6
   real(c_double), value, intent(in) :: rs8
   real(c_double), value, intent(in) :: alp
   real(c_double), value, intent(in) :: bet
   type(c_ptr) :: vparam
   type(mzero_damping_param), allocatable :: tmp
   type(vp_param), pointer :: param

   vparam = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   allocate(tmp)
   call new_mzero_damping(tmp, d3_param(s6=s6, s8=s8, s9=s9, rs6=rs6, rs8=rs8, &
      & alp=alp, bet=bet))

   allocate(param)
   call move_alloc(tmp, param%ptr)
   vparam = c_loc(param)

end function new_mzero_damping_api


!> Load zero damping parameters from internal storage
function load_mzero_damping_api(verror, charptr, atm) &
      & result(vparam) &
      & bind(C, name=namespace//"load_mzero_damping")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   character(kind=c_char), intent(in) :: charptr(*)
   logical(c_bool), value, intent(in) :: atm
   character(len=:, kind=c_char), allocatable :: method
   type(c_ptr) :: vparam
   type(mzero_damping_param), allocatable :: tmp
   type(vp_param), pointer :: param
   type(d3_param) :: inp
   real(wp), allocatable :: s9

   vparam = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   call c_f_character(charptr, method)

   if (atm) s9 = 1.0_wp
   call get_mzero_damping(inp, method, error%ptr, s9)
   if (allocated(error%ptr)) return

   allocate(tmp)
   call new_mzero_damping(tmp, inp)

   allocate(param)
   call move_alloc(tmp, param%ptr)
   vparam = c_loc(param)

end function load_mzero_damping_api


!> Create new optimized power damping parameters
function new_optimizedpower_damping_api(verror, s6, s8, s9, a1, a2, alp, bet) &
      & result(vparam) &
      & bind(C, name=namespace//"new_optimizedpower_damping")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   real(c_double), value, intent(in) :: s6
   real(c_double), value, intent(in) :: s8
   real(c_double), value, intent(in) :: s9
   real(c_double), value, intent(in) :: a1
   real(c_double), value, intent(in) :: a2
   real(c_double), value, intent(in) :: alp
   real(c_double), value, intent(in) :: bet
   type(c_ptr) :: vparam
   type(optimizedpower_damping_param), allocatable :: tmp
   type(vp_param), pointer :: param

   vparam = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   allocate(tmp)
   call new_optimizedpower_damping(tmp, d3_param(s6=s6, s8=s8, s9=s9, a1=a1, a2=a2, &
      & alp=alp, bet=bet))

   allocate(param)
   call move_alloc(tmp, param%ptr)
   vparam = c_loc(param)

end function new_optimizedpower_damping_api


!> Load optimized power damping parameters from internal storage
function load_optimizedpower_damping_api(verror, charptr, atm) &
      & result(vparam) &
      & bind(C, name=namespace//"load_optimizedpower_damping")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   character(kind=c_char), intent(in) :: charptr(*)
   logical(c_bool), value, intent(in) :: atm
   character(len=:, kind=c_char), allocatable :: method
   type(c_ptr) :: vparam
   type(optimizedpower_damping_param), allocatable :: tmp
   type(vp_param), pointer :: param
   type(d3_param) :: inp
   real(wp), allocatable :: s9

   vparam = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   call c_f_character(charptr, method)

   if (atm) s9 = 1.0_wp
   call get_optimizedpower_damping(inp, method, error%ptr, s9)
   if (allocated(error%ptr)) return

   allocate(tmp)
   call new_optimizedpower_damping(tmp, inp)

   allocate(param)
   call move_alloc(tmp, param%ptr)
   vparam = c_loc(param)

end function load_optimizedpower_damping_api


!> Create new CSO damping parameters
function new_cso_damping_api(verror, s6, s9, a1, a2, a3, a4, alp) &
      & result(vparam) &
      & bind(C, name=namespace//"new_cso_damping")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   real(c_double), value, intent(in) :: s6
   real(c_double), value, intent(in) :: s9
   real(c_double), value, intent(in) :: a1
   real(c_double), value, intent(in) :: a2
   real(c_double), value, intent(in) :: a3
   real(c_double), value, intent(in) :: a4
   real(c_double), value, intent(in) :: alp
   type(c_ptr) :: vparam
   type(cso_damping_param), allocatable :: tmp
   type(vp_param), pointer :: param

   vparam = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   allocate(tmp)
   call new_cso_damping(tmp, d3_param(s6=s6, s9=s9, a1=a1, a2=a2, &
      & rs6=a3, rs8=a4, alp=alp))

   allocate(param)
   call move_alloc(tmp, param%ptr)
   vparam = c_loc(param)

end function new_cso_damping_api


!> Load CSO damping parameters from internal storage
function load_cso_damping_api(verror, charptr, atm) &
      & result(vparam) &
      & bind(C, name=namespace//"load_cso_damping")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   character(kind=c_char), intent(in) :: charptr(*)
   logical(c_bool), value, intent(in) :: atm
   character(len=:, kind=c_char), allocatable :: method
   type(c_ptr) :: vparam
   type(cso_damping_param), allocatable :: tmp
   type(vp_param), pointer :: param
   type(d3_param) :: inp
   real(wp), allocatable :: s9

   vparam = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   call c_f_character(charptr, method)

   if (atm) s9 = 1.0_wp
   call get_cso_damping(inp, method, error%ptr, s9)
   if (allocated(error%ptr)) return

   allocate(tmp)
   call new_cso_damping(tmp, inp)

   allocate(param)
   call move_alloc(tmp, param%ptr)
   vparam = c_loc(param)

end function load_cso_damping_api


!> Delete damping parameters
subroutine delete_param_api(vparam) &
      & bind(C, name=namespace//"delete_param")
   type(c_ptr), intent(inout) :: vparam
   type(vp_param), pointer :: param

   if (c_associated(vparam)) then
      call c_f_pointer(vparam, param)

      deallocate(param)
      vparam = c_null_ptr
   end if

end subroutine delete_param_api


!> Calculate dispersion
subroutine get_dispersion_api(verror, vmol, vdisp, vparam, &
      & energy, c_gradient, c_sigma) &
      & bind(C, name=namespace//"get_dispersion")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr), value :: vdisp
   type(vp_model), pointer :: disp
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param
   real(c_double), intent(out) :: energy
   real(c_double), intent(out), optional :: c_gradient(3, *)
   real(wp), allocatable :: gradient(:, :)
   real(c_double), intent(out), optional :: c_sigma(3, 3)
   real(wp), allocatable :: sigma(:, :)
   type(realspace_cutoff) :: cutoff

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vmol)) then
      call fatal_error(error%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   if (.not.c_associated(vdisp)) then
      call fatal_error(error%ptr, "Dispersion model is missing")
      return
   end if
   call c_f_pointer(vdisp, disp)

   if (.not.c_associated(vparam)) then
      call fatal_error(error%ptr, "Damping parameters are missing")
      return
   end if
   call c_f_pointer(vparam, param)

   if (.not.allocated(param%ptr)) then
      call fatal_error(error%ptr, "Damping parameters are not initialized")
      return
   end if

   if (present(c_gradient)) then
      gradient = c_gradient(:3, :mol%ptr%nat)
   endif

   if (present(c_gradient)) then
      sigma = c_sigma(:3, :3)
   endif

   cutoff = realspace_cutoff()
   if (allocated(disp%cutoff)) then
      cutoff = disp%cutoff
   end if
   call get_dispersion(mol%ptr, disp%ptr, param%ptr, cutoff, &
      & energy, gradient, sigma)

   if (present(c_gradient)) then
      c_gradient(:3, :mol%ptr%nat) = gradient
   endif

   if (present(c_gradient)) then
      c_sigma(:3, :3) = sigma
   endif

end subroutine get_dispersion_api


!> Calculate pairwise representation of dispersion energy
subroutine get_pairwise_dispersion_api(verror, vmol, vdisp, vparam, &
      & c_pair_energy2, c_pair_energy3) &
      & bind(C, name=namespace//"get_pairwise_dispersion")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr), value :: vdisp
   type(vp_model), pointer :: disp
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param
   type(c_ptr), value, intent(in) :: c_pair_energy2
   real(wp), pointer :: pair_energy2(:, :)
   type(c_ptr), value, intent(in) :: c_pair_energy3
   real(wp), pointer :: pair_energy3(:, :)
   type(realspace_cutoff) :: cutoff

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vmol)) then
      call fatal_error(error%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   if (.not.c_associated(vdisp)) then
      call fatal_error(error%ptr, "Dispersion model is missing")
      return
   end if
   call c_f_pointer(vdisp, disp)

   if (.not.c_associated(vparam)) then
      call fatal_error(error%ptr, "Damping parameters are missing")
      return
   end if
   call c_f_pointer(vparam, param)

   if (.not.allocated(param%ptr)) then
      call fatal_error(error%ptr, "Damping parameters are not initialized")
      return
   end if

   call c_f_pointer(c_pair_energy2, pair_energy2, [mol%ptr%nat, mol%ptr%nat])
   call c_f_pointer(c_pair_energy3, pair_energy3, [mol%ptr%nat, mol%ptr%nat])

   cutoff = realspace_cutoff()
   if (allocated(disp%cutoff)) then
      cutoff = disp%cutoff
   end if
   call get_pairwise_dispersion(mol%ptr, disp%ptr, param%ptr, cutoff, &
      & pair_energy2, pair_energy3)

end subroutine get_pairwise_dispersion_api


!> Create new error handle object
function load_gcp_param_api(verror, vmol, cmethod, cbasis) &
      & result(vgcp) &
      & bind(C, name=namespace//"load_gcp_param")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   character(kind=c_char), intent(in), optional :: cmethod(*)
   character(len=:, kind=c_char), allocatable :: method
   character(kind=c_char), intent(in), optional :: cbasis(*)
   character(len=:, kind=c_char), allocatable :: basis
   type(vp_gcp), pointer :: gcp
   type(c_ptr) :: vgcp

   vgcp = c_null_ptr

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vmol)) then
      call fatal_error(error%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   if (present(cmethod)) call c_f_character(cmethod, method)
   if (present(cbasis)) call c_f_character(cbasis, basis)

   allocate(gcp)
   call get_gcp_param(gcp%ptr, mol%ptr, method, basis)
   vgcp = c_loc(gcp)

end function load_gcp_param_api


subroutine set_gcp_realspace_cutoff(verror, vgcp, bas, srb) &
      & bind(C, name=namespace//"set_gcp_realspace_cutoff")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vgcp
   type(vp_gcp), pointer :: gcp
   real(c_double), value, intent(in) :: bas
   real(c_double), value, intent(in) :: srb

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vgcp)) then
      call fatal_error(error%ptr, "Counter-poise parameters are missing")
      return
   end if
   call c_f_pointer(vgcp, gcp)

   gcp%cutoff = realspace_cutoff(gcp=bas, srb=srb)
end subroutine set_gcp_realspace_cutoff


!> Delete counter-poise parameter handle object
subroutine delete_gcp_api(vgcp) &
      & bind(C, name=namespace//"delete_gcp")
   type(c_ptr), intent(inout) :: vgcp
   type(vp_gcp), pointer :: gcp

   if (c_associated(vgcp)) then
      call c_f_pointer(vgcp, gcp)

      deallocate(gcp)
      vgcp = c_null_ptr
   end if

end subroutine delete_gcp_api


!> Calculate dispersion
subroutine get_counterpoise_api(verror, vmol, vgcp, &
      & energy, c_gradient, c_sigma) &
      & bind(C, name=namespace//"get_counterpoise")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr), value :: vgcp
   type(vp_gcp), pointer :: gcp
   real(c_double), intent(out) :: energy
   real(c_double), intent(out), optional :: c_gradient(3, *)
   real(wp), allocatable :: gradient(:, :)
   real(c_double), intent(out), optional :: c_sigma(3, 3)
   real(wp), allocatable :: sigma(:, :)
   type(realspace_cutoff) :: cutoff

   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vmol)) then
      call fatal_error(error%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   if (.not.c_associated(vgcp)) then
      call fatal_error(error%ptr, "Counter-poise parameters are missing")
      return
   end if
   call c_f_pointer(vgcp, gcp)

   if (present(c_gradient)) then
      gradient = c_gradient(:3, :mol%ptr%nat)
   endif

   if (present(c_gradient)) then
      sigma = c_sigma(:3, :3)
   endif

   cutoff = realspace_cutoff()
   if (allocated(gcp%cutoff)) then
      cutoff = gcp%cutoff
   end if
   call get_geometric_counterpoise(mol%ptr, gcp%ptr, cutoff, &
      & energy, gradient, sigma)

   if (present(c_gradient)) then
      c_gradient(:3, :mol%ptr%nat) = gradient
   endif

   if (present(c_gradient)) then
      c_sigma(:3, :3) = sigma
   endif

end subroutine get_counterpoise_api


subroutine f_c_character(rhs, lhs, len)
   character(kind=c_char), intent(out) :: lhs(*)
   character(len=*), intent(in) :: rhs
   integer, intent(in) :: len
   integer :: length
   length = min(len-1, len_trim(rhs))

   lhs(1:length) = transfer(rhs(1:length), lhs(1:length))
   lhs(length+1:length+1) = c_null_char

end subroutine f_c_character


subroutine c_f_character(rhs, lhs)
   character(kind=c_char), intent(in) :: rhs(*)
   character(len=:, kind=c_char), allocatable, intent(out) :: lhs

   integer :: ii

   do ii = 1, huge(ii) - 1
      if (rhs(ii) == c_null_char) then
         exit
      end if
   end do
   allocate(character(len=ii-1) :: lhs)
   lhs = transfer(rhs(1:ii-1), lhs)

end subroutine c_f_character


!> Cold fusion check
subroutine verify_structure(error, mol)
   type(error_type), allocatable, intent(out) :: error
   type(structure_type), intent(in) :: mol
   integer :: iat, jat, stat
   stat = 0
   do iat = 1, mol%nat
      do jat = 1, iat - 1
         if (norm2(mol%xyz(:, jat) - mol%xyz(:, iat)) < 1.0e-9_wp) stat = stat + 1
      end do
   end do
   if (stat > 0) then
      call fatal_error(error, "Too close interatomic distances found")
   end if
end subroutine verify_structure


end module dftd3_api

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file src/ddx_workspace.f90
!! Allocation of workspace for ddX
!!
!! TODO: deallocation function
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-06-22

!> Workspace for temporary buffers
module ddx_workspace
! Get ddx_params_type and all compile-time definitions
use ddx_parameters
! Get ddx_constants_type and all run-time constants
use ddx_constants

implicit none


!> Container for temporary arrays
type ddx_workspace_type
    !> Temporary workspace for scalar at the grid points. Dimension is
    !!      (ngrid, nproc)
    real(dp), allocatable :: tmp_pot(:,:)
    !> Temporary workspace for associated legendre polynomials. Dimension is
    !!      (vgrid_nbasis, nproc).
    real(dp), allocatable :: tmp_vplm(:, :)
    !> Temporary workspace for spherical harmomincs. Dimension is
    !!      (vgrid_nbasis, nproc).
    real(dp), allocatable :: tmp_vylm(:, :)
    !> Temporary workspace for derivatives of spherical harmomincs. Dimension is
    !!      (3, vgrid_nbasis, nproc).
    real(dp), allocatable :: tmp_vdylm(:, :, :)
    !> Temporary workspace of size
    !!      (vgrid_dmax + 1, nproc)
    real(dp), allocatable :: tmp_work(:, :)
    !> Temporary workspace for an array of cosinuses of a dimension
    !!      (vgrid_dmax+1, nproc).
    real(dp), allocatable :: tmp_vcos(:, :)
    !> Temporary workspace for an array of sinuses of a dimension
    !!      (vgrid_dmax+1, nproc).
    real(dp), allocatable :: tmp_vsin(:, :)
    !> Temporary workspace for Bessel functions. Dimension is
    !!      (max(2,lmax+1), nproc)
    complex(dp), allocatable :: tmp_bessel(:, :)
    !> Temporary workspace for multipole coefficients of a degree up to lmax
    !!      of each sphere. Dimension is (nbasis, nsph).
    real(dp), allocatable :: tmp_sph(:, :)
    !> Temporary workspace for multipole coefficients of a degree up to lmax+1
    !!      of each sphere. Dimension is (grad_nbasis, nsph). Allocated and
    !!      used only if fmm=1.
    real(dp), allocatable :: tmp_sph2(:, :)
    !> Temporary workspace for right hand side for solvers. Dimension is (nbasis, nsph).
    real(dp), allocatable :: tmp_rhs(:, :)
    !> Temporary workspace for a gradient of M2M of harmonics of a degree up to
    !!      lmax+1 of each sphere. Dimension is ((grad_nbasis, 3, nsph).
    real(dp), allocatable :: tmp_sph_grad(:, :, :)
    !> Temporary workspace for local coefficients of a degree up to pl
    !!      of each sphere. Dimension is ((pl+1)**2, nsph).
    real(dp), allocatable :: tmp_sph_l(:, :)
    !> Temporary workspace for a gradient of L2L of harmonics of a degree up to
    !!      pl of each sphere. Dimension is ((pl+1)**2, 3, nsph).
    real(dp), allocatable :: tmp_sph_l_grad(:, :, :)
    !> Temporary workspace for a gradient of L2L of harmonics of a degree up to
    !!      pl of each sphere. Dimension is ((pl+1)**2, 3, nsph).
    real(dp), allocatable :: tmp_sph_l_grad2(:, :, :)
    !> Temporary workspace for multipole coefficients of each node. Dimension
    !!      is ((pm+1)**2, nsph)
    real(dp), allocatable :: tmp_node_m(:, :)
    !> Temporary workspace for local coefficients of each node. Dimension is
    !!      ((pl+1)**2, nsph)
    real(dp), allocatable :: tmp_node_l(:, :)
    !> Temporary workspace for grid values of each sphere. Dimension is
    !!      (ngrid, nsph).
    real(dp), allocatable :: tmp_grid(:, :)
    !> Temporary workspace for grid values of each sphere. Dimension is
    !!      (ngrid, nsph).
    real(dp), allocatable :: tmp_grid2(:, :)
    !> Temporary workspace for values at cavity points. Dimension is
    !!      (ncav).
    real(dp), allocatable :: tmp_cav(:)
    !> Temporary electric field in cavity points. Dimension is (3, ncav).
    real(dp), allocatable :: tmp_efld(:, :)
    !> Jacobi solver temporary vector x. Dimension is (n).
    real(dp), allocatable :: tmp_x_new(:)
    !> Jacobi solver temporary result of matvec. Dimension is (n).
    real(dp), allocatable :: tmp_y(:)
    !> Jacobi solver temporary DIIS array. Dimension is (n, ndiis).
    real(dp), allocatable :: tmp_x_diis(:, :)
    !> Jacobi solver temporary DIIS array. Dimension is (n, ndiis).
    real(dp), allocatable :: tmp_e_diis(:, :)
    !> Jacobi solver temporary DIIS array. Dimension is (ndiis+1, ndiis+1).
    real(dp), allocatable :: tmp_bmat(:, :)
    !> ddLPB solutions for the microiterations
    real(dp), allocatable :: ddcosmo_guess(:,:), hsp_guess(:,:)
    real(dp), allocatable :: ddcosmo_adj_guess(:,:), hsp_adj_guess(:,:)
    !> ddLPB temporary timings
    real(dp) :: xs_time, s_time, hsp_time, hsp_adj_time
end type ddx_workspace_type

contains

!> Initialize and allocate the temporary workspaces
!!
!! @param[in] params: User specified parameters
!! @param[in] constants: Precomputed constants
!! @param[out] workspace: Preallocated workspaces
!! @param[inout] ddx_error: ddX error
!!
subroutine workspace_init(params, constants, workspace, ddx_error)
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    !! Outputs
    type(ddx_workspace_type), intent(out) :: workspace
    type(ddx_error_type), intent(inout) :: ddx_error
    !! Local variables
    integer :: info
    !! The code
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, "workspace_init received input in error " // &
            & " state, exiting")
        return
    end if
    allocate(workspace % tmp_pot(params % ngrid, params % nproc), &
        & workspace % tmp_vplm(constants % vgrid_nbasis, params % nproc), &
        & workspace % tmp_vcos(constants % vgrid_dmax+1, params % nproc), &
        & workspace % tmp_vsin(constants % vgrid_dmax+1, params % nproc), &
        & workspace % tmp_work(constants % vgrid_dmax+1, params % nproc), &
        & stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "workspace_init: `tmp_vplm`, `tmp_vcos` " // &
            & "and `tmp_vsin` allocations failed")
        return
    end if
    allocate(workspace % tmp_vylm(constants % vgrid_nbasis, params % nproc), &
        & workspace % tmp_vdylm(3, constants % vgrid_nbasis, params % nproc), &
        & stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "workspace_init: `tmp_vylm` " &
            & // "and `tmp_vdylm` allocations failed")
        return
    end if
    allocate(workspace % tmp_sph(constants % nbasis, params % nsph), &
        & stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "workspace_init: `tmp_sph` " // &
            & "allocation failed")
        return
    end if
    if (params % fmm .eq. 1) then
        allocate(workspace % tmp_sph2(constants % grad_nbasis, params % nsph), &
            & stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "workspace_init: `tmp_sph2` " // &
                & "allocation failed")
            return
        end if
        allocate(workspace % tmp_sph_grad( &
            & constants % grad_nbasis, 3, params % nsph), &
            & stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "workspace_init: `tmp_sph_grad` " // &
                & "allocation failed")
            return
        end if
        allocate(workspace % tmp_sph_l((params % pl+1)**2, params % nsph), &
            & stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "workspace_init: `tmp_sph_l` " // &
                & "allocation failed")
            return
        end if
        allocate(workspace % tmp_sph_l_grad( &
            & (params % pl+1)**2, 3, params % nsph), &
            & stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "workspace_init: `tmp_sph_l_grad` " // &
                & "allocation failed")
            return
        end if
        allocate(workspace % tmp_sph_l_grad2( &
            & (params % pl+1)**2, 3, params % nsph), &
            & stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "workspace_init: `tmp_sph_l_grad2` " // &
                & "allocation failed")
            return
        end if
        allocate(workspace % tmp_node_m((params % pm+1)**2, &
            & constants % nclusters), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "workspace_init: `tmp_node_m` " // &
                & "allocation failed")
            return
        end if
        allocate(workspace % tmp_node_l((params % pl+1)**2, &
            & constants % nclusters), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "workspace_init: `tmp_node_l` " // &
                & "allocation failed")
            return
        end if
    end if
    allocate(workspace % tmp_grid(params % ngrid, params % nsph), &
        & stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "workspace_init: `tmp_grid` " // &
            & "allocation failed")
        return
    end if
    allocate(workspace % tmp_grid2(params % ngrid, params % nsph), &
        & stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "workspace_init: `tmp_grid2` " // &
            & "allocation failed")
        return
    end if
    allocate(workspace % tmp_cav(constants % ncav), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "workspace_init: `tmp_cav` " // &
            & "allocation failed")
        return
    end if
    allocate(workspace % tmp_efld(3, constants % ncav), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "workspace_init: `tmp_efld` " // &
            & "allocation failed")
        return
    end if
    allocate(workspace % tmp_x_new(constants % n), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "workspace_init: `tmp_x_new` " // &
            & "allocation failed")
        return
    end if
    allocate(workspace % tmp_y(constants % n), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "workspace_init: `tmp_y` " // &
            & "allocation failed")
        return
    end if
    allocate(workspace % tmp_x_diis(constants % n, 2*params % jacobi_ndiis), &
        & stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "workspace_init: `tmp_x_diis` " // &
            & "allocation failed")
        return
    end if
    allocate(workspace % tmp_e_diis(constants % n, 2*params % jacobi_ndiis), &
        & stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "workspace_init: `tmp_e_diis` " // &
            & "allocation failed")
        return
    end if
    allocate(workspace % tmp_bmat(2*params % jacobi_ndiis + 2, &
        & 2*params % jacobi_ndiis + 2), stat=info)
    if (info .ne. 0) then
        call update_error(ddx_error, "workspace_init: `tmp_bmat` " // &
            & "allocation failed")
        return
    end if
    ! Allocations for LPB model
    if (params % model .eq. 3) then
        allocate(workspace % tmp_bessel(max(2, params % lmax+1), &
            & params % nproc), &
            & workspace % ddcosmo_guess(constants % nbasis, params % nsph), &
            & workspace % ddcosmo_adj_guess(constants % nbasis, params % nsph), &
            & workspace % hsp_guess(constants % nbasis, params % nsph), &
            & workspace % hsp_adj_guess(constants % nbasis, params % nsph), stat=info)
        if (info .ne. 0) then
            call update_error(ddx_error, "workspace_init: `tmp_bessel` " // &
                & "allocation failed")
            return
        end if
    end if
end subroutine workspace_init

!> Deallocate the temporary workspaces
!!
!! @param[out] workspace: Preallocated workspaces
!! @param[inout] ddx_error: ddX error
!!
subroutine workspace_free(workspace, ddx_error)
    implicit none
    type(ddx_workspace_type), intent(out) :: workspace
    type(ddx_error_type), intent(inout) :: ddx_error
    integer :: istat

    istat = 0

    if (allocated(workspace % tmp_pot)) then
        deallocate(workspace % tmp_pot, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_pot` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_vplm)) then
        deallocate(workspace % tmp_vplm, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_vplm` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_vcos)) then
        deallocate(workspace % tmp_vcos, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_vcos` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_vsin)) then
        deallocate(workspace % tmp_vsin, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_vsin` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_work)) then
        deallocate(workspace % tmp_work, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_work` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_vylm)) then
        deallocate(workspace % tmp_vylm, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_vylm` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_vdylm)) then
        deallocate(workspace % tmp_vdylm, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_vdylm` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_sph)) then
        deallocate(workspace % tmp_sph, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_sph` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_sph2)) then
        deallocate(workspace % tmp_sph2, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_sph2` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_sph_grad)) then
        deallocate(workspace % tmp_sph_grad, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_sph_grad` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_sph_l)) then
        deallocate(workspace % tmp_sph_l, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_sph_l` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_sph_l_grad)) then
        deallocate(workspace % tmp_sph_l_grad, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_sph_l_grad` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_sph_l_grad2)) then
        deallocate(workspace % tmp_sph_l_grad2, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_sph_l_grad2` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_node_m)) then
        deallocate(workspace % tmp_node_m, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_node_m` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_node_l)) then
        deallocate(workspace % tmp_node_l, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_node_l` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_grid)) then
        deallocate(workspace % tmp_grid, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_grid` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_grid2)) then
        deallocate(workspace % tmp_grid2, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_grid2` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_cav)) then
        deallocate(workspace % tmp_cav, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_cav` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_efld)) then
        deallocate(workspace % tmp_efld, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_efld` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_x_new)) then
        deallocate(workspace % tmp_x_new, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_x_new` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_y)) then
        deallocate(workspace % tmp_y, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_y` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_x_diis)) then
        deallocate(workspace % tmp_x_diis, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_x_diis` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_e_diis)) then
        deallocate(workspace % tmp_e_diis, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_e_diis` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_bmat)) then
        deallocate(workspace % tmp_bmat, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_bmat` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_bessel)) then
        deallocate(workspace % tmp_bessel, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_bessel` deallocation failed!")
        end if
    end if
    if (allocated(workspace % ddcosmo_guess)) then
        deallocate(workspace % ddcosmo_guess, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`ddcosmo_guess` deallocation failed!")
        end if
    end if
    if (allocated(workspace % hsp_guess)) then
        deallocate(workspace % hsp_guess, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`hsp_guess` deallocation failed!")
        end if
    end if
    if (allocated(workspace % ddcosmo_adj_guess)) then
        deallocate(workspace % ddcosmo_adj_guess, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`ddcosmo_adj_guess` deallocation failed!")
        end if
    end if
    if (allocated(workspace % hsp_adj_guess)) then
        deallocate(workspace % hsp_adj_guess, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`hsp_adj_guess` deallocation failed!")
        end if
    end if
    if (allocated(workspace % tmp_rhs)) then
        deallocate(workspace % tmp_rhs, stat=istat)
        if (istat .ne. 0) then
            call update_error(ddx_error, "`tmp_rhs` deallocation failed!")
        end if
    end if
end subroutine workspace_free

end module

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/io/numpy/zip.f90
!> Provides zip implementation for numpy input/output.

!> Provide routines for handling zip files
module tblite_io_numpy_zip
   use mctc_env, only : i2, i4
   use tblite_io_numpy_constants, only : &
      & zip_global_sig, zip_local_sig, zip_footer_sig, zip_min_version
   use tblite_output_format, only : format_string
   implicit none
   private

   public :: list_zip_file, zip_file

   type :: zip_record
      character(len=:), allocatable :: path
   end type zip_record

   type :: zip_file
      type(zip_record), allocatable :: records(:)
      character(len=:), allocatable :: global_header
      integer(i4) :: global_header_offset = 0_i4
      integer(i2) :: nrecs = 0_i2
   end type zip_file


contains

subroutine list_zip_file(io, filename, zip, stat, msg)
   integer, intent(in) :: io
   character(len=*), intent(in) :: filename
   type(zip_file), intent(out) :: zip
   integer, intent(out) :: stat
   character(len=:), allocatable :: msg

   integer :: irec
   integer(i2) :: path_size, extra_field_size, comment_size
   integer(i2) :: disk_no, disk_start, nrecs_on_disk
   integer(i4) :: nbytes_compressed, global_header_size
   character(len=512) :: errmsg
   integer :: res, length, pos
   integer(i4) :: header_sig
   character(len=:), allocatable :: path

   stat = 0
   irec = 0
   pos = 1
   read(io, pos=pos, iostat=stat, iomsg=errmsg) header_sig
   do while(stat == 0 .and. is_local_header(header_sig))
      irec = irec + 1

      if (stat == 0) &
         read(io, pos=pos+18, iostat=stat, iomsg=errmsg) nbytes_compressed
      if (stat == 0) &
         read(io, pos=pos+26, iostat=stat, iomsg=errmsg) path_size
      if (stat == 0) &
         read(io, pos=pos+28, iostat=stat, iomsg=errmsg) extra_field_size

      if (stat == 0) then
         if (allocated(path)) deallocate(path)
         allocate(character(len=path_size) :: path, stat=stat)
      end if
      if (stat == 0) &
         read(io, pos=pos+30, iostat=stat, iomsg=errmsg) path

      pos = pos + 30 + path_size + extra_field_size + nbytes_compressed
      read(io, pos=pos, iostat=stat, iomsg=errmsg) header_sig
   end do
   if (stat /= 0) then
      msg = "Failed to read local header block for '"//filename//"'"
      if (len_trim(errmsg) > 0) &
         msg = msg // " ("//trim(errmsg)//")"
      return
   end if

   if (.not.is_global_header(header_sig)) then
      stat = 400
      msg = "Expected global header signature for '"//filename//"' got "// &
         & format_string(header_sig, '(z0.8)')
      return
   end if

   allocate(zip%records(irec))

   irec = 0
   ! global_header_offset = pos - 1
   do while(stat == 0 .and. is_global_header(header_sig))
      irec = irec + 1

      if (stat == 0) &
         read(io, pos=pos+28, iostat=stat, iomsg=errmsg) path_size
      if (stat == 0) &
         read(io, pos=pos+30, iostat=stat, iomsg=errmsg) extra_field_size
      if (stat == 0) &
         read(io, pos=pos+32, iostat=stat, iomsg=errmsg) comment_size

      if (stat == 0) then
         if (allocated(path)) deallocate(path)
         allocate(character(len=path_size) :: path, stat=stat)
      end if
      if (stat == 0) &
         read(io, pos=pos+46, iostat=stat, iomsg=errmsg) path

      zip%records(irec)%path = path

      pos = pos + 46 + path_size + extra_field_size + comment_size
      read(io, pos=pos, iostat=stat, iomsg=errmsg) header_sig
   end do
   if (stat /= 0) then
      msg = "Failed to read global header block for '"//filename//"'"
      if (len_trim(errmsg) > 0) &
         msg = msg // " ("//trim(errmsg)//")"
      return
   end if
   if (.not.is_footer_header(header_sig)) then
      stat = 401
      msg = "Expected footer signature for '"//filename//"' got "// &
         & format_string(header_sig, '(z0.8)')
      return
   end if
   ! global_header_size = pos - global_header_offset + 1

   read(io, pos=pos+4, iostat=stat, iomsg=errmsg) &
      & disk_no, disk_start, nrecs_on_disk, zip%nrecs, &
      & global_header_size, zip%global_header_offset, comment_size

   if (stat == 0) &
      allocate(character(len=global_header_size) :: zip%global_header, stat=stat)
   if (stat == 0) &
      read(io, iostat=stat, pos=zip%global_header_offset+1) zip%global_header

   if (stat /= 0) then
      msg = "Failed to read footer for '"//filename//"'"
      if (len_trim(errmsg) > 0) &
         msg = msg // " ("//trim(errmsg)//")"
      return
   end if

   if (disk_no /= 0) then
      stat = 402
      msg = "Cannot read zip file with disk_no != 0"
   end if

   if (disk_start /= 0) then
      stat = 403
      msg = "Cannot read zip file with disk_start != 0"
   end if

   if (nrecs_on_disk /= zip%nrecs) then
      stat = 404
      msg = "Cannot read zip file with nrecs_on_disk != nrecs"
   end if
end subroutine list_zip_file

pure function is_local_header(header_sig) result(is_local)
   integer(i4), intent(in) :: header_sig
   logical :: is_local

   is_local = header_sig == zip_local_sig
end function is_local_header

pure function is_global_header(header_sig) result(is_global)
   integer(i4), intent(in) :: header_sig
   logical :: is_global

   is_global = header_sig == zip_global_sig
end function is_global_header

pure function is_footer_header(header_sig) result(is_footer)
   integer(i4), intent(in) :: header_sig
   logical :: is_footer

   is_footer = header_sig == zip_footer_sig
end function is_footer_header
end module tblite_io_numpy_zip

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_read_genformat
   use mctc_env_accuracy, only : wp
   use mctc_env_error, only : error_type
   use mctc_io_constants, only : pi
   use mctc_io_convert, only : aatoau
   use mctc_io_structure, only : structure_type, new
   use mctc_io_structure_info, only : structure_info
   use mctc_io_symbols, only : to_number, symbol_length
   use mctc_io_utils, only : next_line, token_type, next_token, io_error, filename, &
      read_next_token, to_string
   implicit none
   private

   public :: read_genformat


contains


subroutine read_genformat(mol, unit, error)

   !> Instance of the molecular structure data
   type(structure_type),intent(out) :: mol

   !> File handle
   integer,intent(in) :: unit

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=:), allocatable :: line
   integer :: natoms, nspecies, iatom, dummy, isp, ilat, stat
   logical :: cartesian, periodic(3)
   real(wp) :: coord(3), origin(3)
   type(token_type) :: token
   character(len=symbol_length), allocatable :: species(:), sym(:)
   real(wp), allocatable :: xyz(:, :), abc(:, :), lattice(:, :)
   type(structure_info) :: info
   integer :: pos, lnum

   lnum = 0
   call advance_line(unit, line, pos, lnum, stat)
   call read_next_token(line, pos, token, natoms, stat)
   if (stat /= 0 .or. natoms < 1) then
      call io_error(error, "Could not read number of atoms", &
         & line, token, filename(unit), lnum, "expected integer value")
      return
   end if

   allocate(species(natoms))
   allocate(sym(natoms))
   allocate(xyz(3, natoms))
   allocate(abc(3, natoms))

   call next_token(line, pos, token)
   select case(line(token%first:token%last))
   case('c', 'C')
      cartesian = .true.
      periodic = .false.
   case('s', 'S')
      cartesian = .true.
      periodic = .true.
      allocate(lattice(3, 3), source=0.0_wp)
   case('f', 'F')
      cartesian = .false.
      periodic = .true.
      allocate(lattice(3, 3), source=0.0_wp)
   case('h', 'H')
      cartesian = .true.
      periodic = [.false., .false., .true.]
      allocate(lattice(3, 1), source=0.0_wp)
   case default
      call io_error(error, "Invalid input version found", &
         & line, token, filename(unit), lnum, "unknown identifier")
      return
   end select

   call advance_line(unit, line, pos, lnum, stat)
   isp = 0
   do while(pos < len(line))
      call next_token(line, pos, token)
      isp = isp + 1
      token%last = min(token%last, token%first + symbol_length - 1)
      species(isp) = line(token%first:token%last)
      if (to_number(species(isp)) == 0) then
         call io_error(error, "Cannot map symbol to atomic number", &
            & line, token, filename(unit), lnum, "unknown element")
         return
      end if
   end do
   nspecies = isp

   do iatom = 1, natoms
      token = token_type(0, 0)
      call advance_line(unit, line, pos, lnum, stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, dummy, stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, isp, stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, coord(1), stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, coord(2), stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, coord(3), stat)
      if (stat /= 0) then
         call io_error(error, "Cannot read coordinates", &
            & line, token, filename(unit), lnum, "unexpected value")
         return
      end if
      sym(iatom) = species(isp)
      if (cartesian) then
         xyz(:, iatom) = coord * aatoau
      else
         abc(:, iatom) = coord
      end if
   end do

   if (any(periodic)) then
      call advance_line(unit, line, pos, lnum, stat)
      if (stat /= 0) then
         call io_error(error, "Unexpected end of file", &
            & line, token_type(0, 0), filename(unit), lnum, "missing lattice information")
         return
      end if
      if (stat == 0) &
         call read_next_token(line, pos, token, origin(1), stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, origin(2), stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, origin(3), stat)
      if (stat /= 0) then
         call io_error(error, "Cannot read origin", &
            & line, token, filename(unit), lnum, "expected real value")
         return
         end if
   end if

   if (all(periodic)) then
      do ilat = 1, 3
         call advance_line(unit, line, pos, lnum, stat)
         if (stat == 0) &
            call read_next_token(line, pos, token, coord(1), stat)
         if (stat == 0) &
            call read_next_token(line, pos, token, coord(2), stat)
         if (stat == 0) &
            call read_next_token(line, pos, token, coord(3), stat)
         if (stat /= 0) then
            call io_error(error, "Cannot read lattice vector", &
               & line, token, filename(unit), lnum, "expected real value")
            return
         end if
         lattice(:, ilat) = coord * aatoau
      end do
      if (.not.cartesian) then
         xyz = matmul(lattice, abc)
      end if
   end if

   if (count(periodic) == 1) then
      call advance_line(unit, line, pos, lnum, stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, coord(1), stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, coord(2), stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, coord(3), stat)
      if (stat /= 0) then
         call io_error(error, "Cannot read lattice vector", &
            & line, token, filename(unit), lnum, "expected real value")
         return
      end if
      if (coord(3) < 1) then
         call io_error(error, "Invalid helical axis rotation order", &
            & line, token, filename(unit), lnum, "expected positive value")
         return
      end if

      ! Store helical axis in *first* lattice vector, however it is not an actual
      ! lattice vector as on would expect but a screw axis
      lattice(:, 1) = [coord(1) * aatoau, coord(2) * pi / 180.0_wp, coord(3)]
   end if

   if (any(periodic)) then
      xyz(:, :) = xyz - spread(origin, 2, natoms)
   end if

   info = structure_info(cartesian=cartesian)
   call new(mol, sym, xyz, lattice=lattice, periodic=periodic, info=info)

contains

subroutine advance_line(unit, line, pos, num, stat)
   integer,intent(in) :: unit
   integer, intent(out) :: pos
   integer, intent(inout) :: num
   character(len=:), allocatable, intent(out) :: line
   integer, intent(out) :: stat
   integer :: ihash

   stat = 0
   do while(stat == 0)
      call next_line(unit, line, pos, num, stat)
      ihash = index(line, '#')
      if (ihash > 0) line = line(:ihash-1)
      if (len_trim(line) > 0) exit
   end do
   line = trim(adjustl(line))
end subroutine advance_line

end subroutine read_genformat


end module mctc_io_read_genformat

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/coulomb/charge/effective.f90
!> Provides an effective Coulomb operator for isotropic electrostatic interactions

!> Isotropic second-order electrostatics using an effective Coulomb operator
module tblite_coulomb_charge_effective
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_math, only : matdet_3x3, matinv_3x3
   use mctc_io_constants, only : pi
   use tblite_blas, only : dot, gemv, symv, gemm
   use tblite_coulomb_cache, only : coulomb_cache
   use tblite_coulomb_ewald, only : get_dir_cutoff, get_rec_cutoff
   use tblite_coulomb_charge_type, only : coulomb_charge_type
   use tblite_cutoff, only : get_lattice_points
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_wignerseitz, only : wignerseitz_cell
   implicit none
   private

   public :: new_effective_coulomb
   public :: average_interface, harmonic_average, arithmetic_average, geometric_average


   !> Effective, Klopman-Ohno-type, second-order electrostatics
   type, public, extends(coulomb_charge_type) :: effective_coulomb
      !> Hubbard parameter for each shell and species
      real(wp), allocatable :: hubbard(:, :, :, :)
      !> Exponent of Coulomb kernel
      real(wp) :: gexp
      !> Long-range cutoff
      real(wp) :: rcut
   contains
      !> Evaluate Coulomb matrix
      procedure :: get_coulomb_matrix
      !> Evaluate uncontracted derivatives of Coulomb matrix
      procedure :: get_coulomb_derivs
   end type effective_coulomb


   abstract interface
      !> Average Hubbard parameter for two shells
      pure function average_interface(gi, gj) result(gij)
         import :: wp
         !> Hubbard parameter of shell i
         real(wp), intent(in) :: gi
         !> Hubbard parameter of shell j
         real(wp), intent(in) :: gj
         !> Averaged Hubbard parameter
         real(wp) :: gij
      end function average_interface
   end interface

   real(wp), parameter :: twopi = 2 * pi
   real(wp), parameter :: sqrtpi = sqrt(pi)
   real(wp), parameter :: eps = sqrt(epsilon(0.0_wp))
   real(wp), parameter :: conv = eps
   character(len=*), parameter :: label = "isotropic Klopman-Ohno-Mataga-Nishimoto electrostatics"

contains

!> Construct new effective electrostatic interaction container
subroutine new_effective_coulomb(self, mol, gexp, hubbard, average, nshell)
   !> Instance of the electrostatic container
   type(effective_coulomb), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Exponent of Coulomb kernel
   real(wp), intent(in) :: gexp
   !> Averaging function for Hubbard parameter of a shell-pair
   procedure(average_interface) :: average
   !> Hubbard parameter for all shells and species
   real(wp), intent(in) :: hubbard(:, :)
   !> Number of shells for each species
   integer, intent(in), optional :: nshell(:)

   integer :: mshell
   integer :: isp, jsp, ish, jsh, ind, iat

   self%label = label

   self%shell_resolved = present(nshell)
   if (present(nshell)) then
      mshell = maxval(nshell)
      self%nshell = nshell(mol%id)
   else
      mshell = 1
      self%nshell = spread(1, 1, mol%nat)
   end if
   allocate(self%offset(mol%nat))
   ind = 0
   do iat = 1, mol%nat
      self%offset(iat) = ind
      ind = ind + self%nshell(iat)
   end do

   self%gexp = gexp
   self%rcut = 10.0_wp

   if (present(nshell)) then
      allocate(self%hubbard(mshell, mshell, mol%nid, mol%nid))
      do isp = 1, mol%nid
         do jsp = 1, mol%nid
            self%hubbard(:, :, jsp, isp) = 0.0_wp
            do ish = 1, nshell(isp)
               do jsh = 1, nshell(jsp)
                  self%hubbard(jsh, ish, jsp, isp) = &
                     & average(hubbard(ish, isp), hubbard(jsh, jsp))
               end do
            end do
         end do
      end do
   else
      allocate(self%hubbard(1, 1, mol%nid, mol%nid))
      do isp = 1, mol%nid
         do jsp = 1, mol%nid
            self%hubbard(1, 1, jsp, isp) = average(hubbard(1, isp), hubbard(1, jsp))
         end do
      end do
   end if

end subroutine new_effective_coulomb


!> Harmonic averaging functions for hardnesses in GFN1-xTB
pure function harmonic_average(gi, gj) result(gij)
   !> Hubbard parameter of shell i
   real(wp), intent(in) :: gi
   !> Hubbard parameter of shell j
   real(wp), intent(in) :: gj
   !> Averaged Hubbard parameter
   real(wp) :: gij

   gij = 2.0_wp/(1.0_wp/gi+1.0_wp/gj)

end function harmonic_average


!> Arithmetic averaging functions for hardnesses in GFN2-xTB
pure function arithmetic_average(gi, gj) result(gij)
   !> Hubbard parameter of shell i
   real(wp), intent(in) :: gi
   !> Hubbard parameter of shell j
   real(wp), intent(in) :: gj
   !> Averaged Hubbard parameter
   real(wp) :: gij

   gij = 0.5_wp*(gi+gj)

end function arithmetic_average


!> Geometric averaging functions for hardnesses
pure function geometric_average(gi, gj) result(gij)
   !> Hubbard parameter of shell i
   real(wp), intent(in) :: gi
   !> Hubbard parameter of shell j
   real(wp), intent(in) :: gj
   !> Averaged Hubbard parameter
   real(wp) :: gij

   gij = sqrt(gi*gj)

end function geometric_average


!> Evaluate coulomb matrix
subroutine get_coulomb_matrix(self, mol, cache, amat)
   !> Instance of the electrostatic container
   class(effective_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(coulomb_cache), intent(inout) :: cache
   !> Coulomb matrix
   real(wp), contiguous, intent(out) :: amat(:, :)

   amat(:, :) = 0.0_wp

   if (any(mol%periodic)) then
      call get_amat_3d(mol, self%nshell, self%offset, self%hubbard, self%gexp, &
         & self%rcut, cache%wsc, cache%alpha, amat)
   else
      call get_amat_0d(mol, self%nshell, self%offset, self%hubbard, self%gexp, amat)
   end if

end subroutine get_coulomb_matrix


!> Get real lattice vectors
subroutine get_dir_trans(lattice, alpha, conv, trans)
   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)
   !> Parameter for Ewald summation
   real(wp), intent(in) :: alpha
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Translation vectors
   real(wp), allocatable, intent(out) :: trans(:, :)

   call get_lattice_points([.true.], lattice, get_dir_cutoff(alpha, conv), trans)

end subroutine get_dir_trans

!> Get reciprocal lattice translations
subroutine get_rec_trans(lattice, alpha, volume, conv, trans)
   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)
   !> Parameter for Ewald summation
   real(wp), intent(in) :: alpha
   !> Cell volume
   real(wp), intent(in) :: volume
   !> Tolerance for Ewald summation
   real(wp), intent(in) :: conv
   !> Translation vectors
   real(wp), allocatable, intent(out) :: trans(:, :)

   real(wp) :: rec_lat(3, 3)

   rec_lat = twopi*transpose(matinv_3x3(lattice))
   call get_lattice_points([.true.], rec_lat, get_rec_cutoff(alpha, volume, conv), trans)
   trans = trans(:, 2:)

end subroutine get_rec_trans


!> Evaluate Coulomb matrix for finite systems
subroutine get_amat_0d(mol, nshell, offset, hubbard, gexp, amat)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells for each atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each shell
   integer, intent(in) :: offset(:)
   !> Hubbard parameter parameter for each shell
   real(wp), intent(in) :: hubbard(:, :, :, :)
   !> Exponent of Coulomb kernel
   real(wp), intent(in) :: gexp
   !> Coulomb matrix
   real(wp), intent(inout) :: amat(:, :)

   integer :: iat, jat, izp, jzp, ii, jj, ish, jsh
   real(wp) :: vec(3), r1, r1g, gam, tmp

   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(amat, mol, nshell, offset, hubbard, gexp) &
   !$omp private(iat, izp, ii, ish, jat, jzp, jj, jsh, gam, vec, r1, r1g, tmp)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         vec = mol%xyz(:, jat) - mol%xyz(:, iat)
         r1 = norm2(vec)
         r1g = r1**gexp
         do ish = 1, nshell(iat)
            do jsh = 1, nshell(jat)
               gam = hubbard(jsh, ish, jzp, izp)
               tmp = 1.0_wp/(r1g + gam**(-gexp))**(1.0_wp/gexp)
               amat(jj+jsh, ii+ish) = amat(jj+jsh, ii+ish) + tmp
               amat(ii+ish, jj+jsh) = amat(ii+ish, jj+jsh) + tmp
            end do
         end do
      end do
      do ish = 1, nshell(iat)
         do jsh = 1, ish-1
            gam = hubbard(jsh, ish, izp, izp)
            amat(ii+jsh, ii+ish) = amat(ii+jsh, ii+ish) + gam
            amat(ii+ish, ii+jsh) = amat(ii+ish, ii+jsh) + gam
         end do
         amat(ii+ish, ii+ish) = amat(ii+ish, ii+ish) + hubbard(ish, ish, izp, izp)
      end do
   end do

end subroutine get_amat_0d

!> Evaluate the coulomb matrix for 3D systems
subroutine get_amat_3d(mol, nshell, offset, hubbard, gexp, rcut, wsc, alpha, amat)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells per atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each atom
   integer, intent(in) :: offset(:)
   !> Hubbard parameter of the shells
   real(wp), intent(in) :: hubbard(:, :, :, :)
   !> Exponent of the interaction kernel
   real(wp), intent(in) :: gexp
   !> Long-range cutoff
   real(wp), intent(in) :: rcut
   !> Wigner-Seitz cell
   type(wignerseitz_cell), intent(in) :: wsc
   !> Convergence factor
   real(wp), intent(in) :: alpha
   !> Coulomb matrix
   real(wp), intent(inout) :: amat(:, :)

   integer :: iat, jat, izp, jzp, img, ii, jj, ish, jsh
   real(wp) :: vec(3), gam, wsw, dtmp, rtmp, vol, aval
   real(wp), allocatable :: dtrans(:, :), rtrans(:, :)

   vol = abs(matdet_3x3(mol%lattice))
   call get_dir_trans(mol%lattice, alpha, conv, dtrans)
   call get_rec_trans(mol%lattice, alpha, vol, conv, rtrans)

   !$omp parallel do default(none) schedule(runtime) shared(amat) &
   !$omp shared(mol, nshell, offset, hubbard, gexp, wsc, dtrans, rtrans, alpha, vol, rcut) &
   !$omp private(iat, izp, jat, jzp, ii, jj, ish, jsh, gam, wsw, vec, dtmp, rtmp, aval)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, iat) - mol%xyz(:, jat) - wsc%trans(:, wsc%tridx(img, jat, iat))
            call get_amat_rec_3d(vec, vol, alpha, 0.0_wp, rtrans, rtmp)
            do ish = 1, nshell(iat)
               do jsh = 1, nshell(jat)
                  gam = hubbard(jsh, ish, jzp, izp)
                  call get_amat_dir_3d(vec, gam, gexp, rcut, alpha, dtrans, dtmp)
                  aval = (dtmp + rtmp) * wsw
                  amat(jj+jsh, ii+ish) = amat(jj+jsh, ii+ish) + aval
                  amat(ii+ish, jj+jsh) = amat(ii+ish, jj+jsh) + aval
               end do
            end do
         end do
      end do

      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec = wsc%trans(:, wsc%tridx(img, iat, iat))
         call get_amat_rec_3d(vec, vol, alpha, 0.0_wp, rtrans, rtmp)
         rtmp = rtmp - 2 * alpha / sqrtpi
         do ish = 1, nshell(iat)
            do jsh = 1, ish-1
               gam = hubbard(jsh, ish, izp, izp)
               call get_amat_dir_3d(vec, gam, gexp, rcut, alpha, dtrans, dtmp)
               aval = (dtmp + rtmp + gam) * wsw
               amat(ii+jsh, ii+ish) = amat(ii+jsh, ii+ish) + aval
               amat(ii+ish, ii+jsh) = amat(ii+ish, ii+jsh) + aval
            end do
            gam = hubbard(ish, ish, izp, izp)
            call get_amat_dir_3d(vec, gam, gexp, rcut, alpha, dtrans, dtmp)
            aval = (dtmp + rtmp + gam) * wsw
            amat(ii+ish, ii+ish) = amat(ii+ish, ii+ish) + aval
         end do
      end do

   end do

end subroutine get_amat_3d

!> Calculate real space contributions for a pair under 3D periodic boundary conditions
subroutine get_amat_dir_3d(rij, gam, gexp, rcut, alp, trans, amat)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Hubbard parameter
   real(wp), intent(in) :: gam
   !> Exponent for interaction kernel
   real(wp), intent(in) :: gexp
   !> Long-range cutoff
   real(wp), intent(in) :: rcut
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Interaction matrix element
   real(wp), intent(out) :: amat

   integer :: itr
   real(wp) :: vec(3), r1, tmp, fcut

   amat = 0.0_wp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      fcut = fsmooth(r1, rcut)
      tmp = fcut/(r1**gexp + gam**(-gexp))**(1.0_wp/gexp) + (1.0_wp-fcut)/r1 &
         & - erf(alp*r1)/r1
      amat = amat + tmp
   end do

end subroutine get_amat_dir_3d

!> Calculate reciprocal space contributions for a pair under 3D periodic boundary conditions
subroutine get_amat_rec_3d(rij, vol, alp, qpc, trans, amat)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Volume of cell
   real(wp), intent(in) :: vol
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Pseudo-quadrupole contribution
   real(wp), intent(in) :: qpc
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Interaction matrix element
   real(wp), intent(out) :: amat

   integer :: itr
   real(wp) :: fac, vec(3), g2, gv, expk, cosk

   amat = 0.0_wp
   fac = 4*pi/vol

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      gv = dot_product(rij, vec)
      expk = fac * exp(-0.25_wp*g2/(alp*alp))/g2
      cosk = cos(gv) * expk
      amat = amat + cosk
   end do

end subroutine get_amat_rec_3d

function fsmooth(r1, rcut) result(fcut)
   real(wp), intent(in) :: r1
   real(wp), intent(in) :: rcut
   real(wp) :: fcut

   real(wp), parameter :: offset = 1.0_wp
   real(wp), parameter :: c(*) = [-6.0_wp, 15.0_wp, -10.0_wp, 1.0_wp]
   real(wp) :: xrel

   if (r1 < rcut - offset) then
      fcut = 1.0_wp
   else if (r1 > rcut) then
      fcut = 0.0_wp
   else
      xrel = (r1 - (rcut - offset)) / offset
      fcut = c(1)*xrel**5 + c(2)*xrel**4 + c(3)*xrel**3 + c(4)
   end if
end function fsmooth

function dsmooth(r1, rcut) result(dcut)
   real(wp), intent(in) :: r1
   real(wp), intent(in) :: rcut
   real(wp) :: dcut

   real(wp), parameter :: offset = 1.0_wp
   real(wp), parameter :: c(*) = [-6.0_wp, 15.0_wp, -10.0_wp, 1.0_wp]
   real(wp) :: xrel

   if (r1 < rcut - offset .or. r1 > rcut) then
      dcut = 0.0_wp
   else
      xrel = (r1 - (rcut - offset)) / offset
      dcut = (5*c(1)*xrel**4 + 4*c(2)*xrel**3 + 3*c(3)*xrel**2) / offset
   end if

end function dsmooth


!> Evaluate uncontracted derivatives of Coulomb matrix
subroutine get_coulomb_derivs(self, mol, cache, qat, qsh, dadr, dadL, atrace)
   !> Instance of the electrostatic container
   class(effective_coulomb), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Reusable data container
   type(coulomb_cache), intent(inout) :: cache
   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)
   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)
   !> Derivative of interactions with respect to cartesian displacements
   real(wp), contiguous, intent(out) :: dadr(:, :, :)
   !> Derivative of interactions with respect to strain deformations
   real(wp), contiguous, intent(out) :: dadL(:, :, :)
   !> On-site derivatives with respect to cartesian displacements
   real(wp), contiguous, intent(out) :: atrace(:, :)

   if(self%shell_resolved) then
      if (any(mol%periodic)) then
         call get_damat_3d(mol, self%nshell, self%offset, self%hubbard, self%gexp, &
            & self%rcut, cache%wsc, cache%alpha, qsh, dadr, dadL, atrace)
      else
         call get_damat_0d(mol, self%nshell, self%offset, self%hubbard, self%gexp, qsh, &
            & dadr, dadL, atrace)
      end if
   else
      if (any(mol%periodic)) then
         call get_damat_3d(mol, self%nshell, self%offset, self%hubbard, self%gexp, &
            & self%rcut, cache%wsc, cache%alpha, qat, dadr, dadL, atrace)
      else
         call get_damat_0d(mol, self%nshell, self%offset, self%hubbard, self%gexp, qat, &
            & dadr, dadL, atrace)
      end if
   end if 

end subroutine get_coulomb_derivs


!> Evaluate uncontracted derivatives of Coulomb matrix for finite system
subroutine get_damat_0d(mol, nshell, offset, hubbard, gexp, qvec, dadr, dadL, atrace)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells for each atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each shell
   integer, intent(in) :: offset(:)
   !> Hubbard parameter for each shell and species
   real(wp), intent(in) :: hubbard(:, :, :, :)
   !> Exponent of Coulomb kernel
   real(wp), intent(in) :: gexp
   !> Partial charge vector
   real(wp), intent(in) :: qvec(:)
   !> Derivative of interactions with respect to cartesian displacements
   real(wp), intent(out) :: dadr(:, :, :)
   !> Derivative of interactions with respect to strain deformations
   real(wp), intent(out) :: dadL(:, :, :)
   !> On-site derivatives with respect to cartesian displacements
   real(wp), intent(out) :: atrace(:, :)

   integer :: iat, jat, izp, jzp, ii, jj, ish, jsh
   real(wp) :: vec(3), r1, gam, arg, dtmp, dG(3), dS(3, 3)
   real(wp), allocatable :: itrace(:, :), didr(:, :, :), didL(:, :, :)

   atrace(:, :) = 0.0_wp
   dadr(:, :, :) = 0.0_wp
   dadL(:, :, :) = 0.0_wp

   !$omp parallel default(none) &
   !$omp shared(atrace, dadr, dadL, mol, qvec, hubbard, nshell, offset, gexp) &
   !$omp private(iat, izp, ii, ish, jat, jzp, jj, jsh, gam, r1, vec, dG, dS, dtmp, arg) &
   !$omp private(itrace, didr, didL)
   allocate(itrace, source=atrace)
   allocate(didr, source=dadr)
   allocate(didL, source=dadL)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         vec = mol%xyz(:, iat) - mol%xyz(:, jat)
         r1 = norm2(vec)
         do ish = 1, nshell(iat)
            do jsh = 1, nshell(jat)
               gam = hubbard(jsh, ish, jzp, izp)
               dtmp = 1.0_wp / (r1**gexp + gam**(-gexp))
               dtmp = -r1**(gExp-2.0_wp) * dtmp * dtmp**(1.0_wp/gExp)
               dG = dtmp*vec
               dS = spread(dG, 1, 3) * spread(vec, 2, 3)
               itrace(:, ii+ish) = +dG*qvec(jj+jsh) + itrace(:, ii+ish)
               itrace(:, jj+jsh) = -dG*qvec(ii+ish) + itrace(:, jj+jsh)
               didr(:, iat, jj+jsh) = +dG*qvec(ii+ish) + didr(:, iat, jj+jsh)
               didr(:, jat, ii+ish) = -dG*qvec(jj+jsh) + didr(:, jat, ii+ish)
               didL(:, :, jj+jsh) = +dS*qvec(ii+ish) + didL(:, :, jj+jsh)
               didL(:, :, ii+ish) = +dS*qvec(jj+jsh) + didL(:, :, ii+ish)
            end do
         end do
      end do
   end do
   !$omp critical (get_damat_0d_)
   atrace(:, :) = atrace + itrace
   dadr(:, :, :) = dadr + didr
   dadL(:, :, :) = dadL + didL
   !$omp end critical (get_damat_0d_)
   deallocate(didL, didr, itrace)
   !$omp end parallel

end subroutine get_damat_0d

!> Evaluate uncontracted derivatives of Coulomb matrix for 3D periodic system
subroutine get_damat_3d(mol, nshell, offset, hubbard, gexp, rcut, wsc, alpha, qvec, &
      & dadr, dadL, atrace)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Number of shells for each atom
   integer, intent(in) :: nshell(:)
   !> Index offset for each shell
   integer, intent(in) :: offset(:)
   !> Hubbard parameter for each shell and species
   real(wp), intent(in) :: hubbard(:, :, :, :)
   !> Exponent of Coulomb kernel
   real(wp), intent(in) :: gexp
   !> Long-range cutoff
   real(wp), intent(in) :: rcut
   !> Wigner-Seitz image information
   type(wignerseitz_cell), intent(in) :: wsc
   !> Convergence factor for Ewald sum
   real(wp), intent(in) :: alpha
   !> Partial charge vector
   real(wp), intent(in) :: qvec(:)
   !> Derivative of interactions with respect to cartesian displacements
   real(wp), intent(out) :: dadr(:, :, :)
   !> Derivative of interactions with respect to strain deformations
   real(wp), intent(out) :: dadL(:, :, :)
   !> On-site derivatives with respect to cartesian displacements
   real(wp), intent(out) :: atrace(:, :)

   integer :: iat, jat, izp, jzp, img, ii, jj, ish, jsh
   real(wp) :: vol, gam, wsw, vec(3), dG(3), dS(3, 3)
   real(wp) :: dGd(3), dSd(3, 3), dGr(3), dSr(3, 3)
   real(wp), allocatable :: itrace(:, :), didr(:, :, :), didL(:, :, :)
   real(wp), allocatable :: dtrans(:, :), rtrans(:, :)

   atrace(:, :) = 0.0_wp
   dadr(:, :, :) = 0.0_wp
   dadL(:, :, :) = 0.0_wp

   vol = abs(matdet_3x3(mol%lattice))
   call get_dir_trans(mol%lattice, alpha, conv, dtrans)
   call get_rec_trans(mol%lattice, alpha, vol, conv, rtrans)

   !$omp parallel default(none) shared(atrace, dadr, dadL) &
   !$omp shared(mol, wsc, alpha, vol, dtrans, rtrans, qvec, hubbard, nshell, offset, gexp, &
   !$omp& rcut) private(iat, izp, jat, jzp, img, ii, jj, ish, jsh, gam, wsw, vec, dG, dS, &
   !$omp& dGr, dSr, dGd, dSd, itrace, didr, didL)
   allocate(itrace, source=atrace)
   allocate(didr, source=dadr)
   allocate(didL, source=dadL)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = offset(iat)
      do jat = 1, iat-1
         jzp = mol%id(jat)
         jj = offset(jat)
         do img = 1, wsc%nimg(jat, iat)
            vec = mol%xyz(:, iat) - mol%xyz(:, jat) - wsc%trans(:, wsc%tridx(img, jat, iat))
            wsw = 1.0_wp / real(wsc%nimg(jat, iat), wp)
            call get_damat_rec_3d(vec, vol, alpha, 0.0_wp, rtrans, dGr, dSr)
            do ish = 1, nshell(iat)
               do jsh = 1, nshell(jat)
                  gam = hubbard(jsh, ish, jzp, izp)
                  call get_damat_dir_3d(vec, gam, gexp, rcut, alpha, dtrans, dGd, dSd)
                  dG = (dGd + dGr) * wsw
                  dS = (dSd + dSr) * wsw
                  itrace(:, ii+ish) = +dG*qvec(jj+jsh) + itrace(:, ii+ish)
                  itrace(:, jj+jsh) = -dG*qvec(ii+ish) + itrace(:, jj+jsh)
                  didr(:, iat, jj+jsh) = +dG*qvec(ii+ish) + didr(:, iat, jj+jsh)
                  didr(:, jat, ii+ish) = -dG*qvec(jj+jsh) + didr(:, jat, ii+ish)
                  didL(:, :, jj+jsh) = +dS*qvec(ii+ish) + didL(:, :, jj+jsh)
                  didL(:, :, ii+ish) = +dS*qvec(jj+jsh) + didL(:, :, ii+ish)
               end do
            end do
         end do
      end do

      wsw = 1.0_wp / real(wsc%nimg(iat, iat), wp)
      do img = 1, wsc%nimg(iat, iat)
         vec = wsc%trans(:, wsc%tridx(img, iat, iat))
         call get_damat_rec_3d(vec, vol, alpha, 0.0_wp, rtrans, dGr, dSr)
         do ish = 1, nshell(iat)
            do jsh = 1, ish-1
               gam = hubbard(jsh, ish, izp, izp)
               call get_damat_dir_3d(vec, gam, gexp, rcut, alpha, dtrans, dGd, dSd)
               dS = (dSd + dSr) * wsw
               didL(:, :, ii+jsh) = +dS*qvec(ii+ish) + didL(:, :, ii+jsh)
               didL(:, :, ii+ish) = +dS*qvec(ii+jsh) + didL(:, :, ii+ish)
            end do
            gam = hubbard(ish, ish, izp, izp)
            call get_damat_dir_3d(vec, gam, gexp, rcut, alpha, dtrans, dGd, dSd)
            dS = (dSd + dSr) * wsw
            didL(:, :, ii+ish) = +dS*qvec(ii+ish) + didL(:, :, ii+ish)
         end do
      end do
   end do
   !$omp critical (get_damat_3d_)
   atrace(:, :) = atrace + itrace
   dadr(:, :, :) = dadr + didr
   dadL(:, :, :) = dadL + didL
   !$omp end critical (get_damat_3d_)
   deallocate(didL, didr, itrace) 
   !$omp end parallel

end subroutine get_damat_3d

!> Calculate real space contributions for a pair under 3D periodic boundary conditions
subroutine get_damat_dir_3d(rij, gam, gexp, rcut, alp, trans, dg, ds)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Hubbard parameter
   real(wp), intent(in) :: gam
   !> Exponent for interaction kernel
   real(wp), intent(in) :: gexp
   !> Long-range cutoff
   real(wp), intent(in) :: rcut
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Derivative with respect to cartesian displacements
   real(wp), intent(out) :: dg(3)
   !> Derivative with respect to strain deformations
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr
   real(wp) :: vec(3), r1, r2, gtmp, atmp, alp2, fcut, dcut

   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp

   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      r2 = r1*r1
      fcut = fsmooth(r1, rcut)
      dcut = dsmooth(r1, rcut)
      gtmp = 1.0_wp / (r1**gexp + gam**(-gexp))
      gtmp = -r1**(gexp-2.0_wp) * gtmp * gtmp**(1.0_wp/gexp) * fcut - (1.0_wp-fcut)/(r2*r1) &
         & + dcut * (gtmp**(1.0_wp/gexp) * r1 - 1.0_wp) / r2
      atmp = -2*alp*exp(-r2*alp2)/(sqrtpi*r2) + erf(r1*alp)/(r2*r1)
      dg(:) = dg + (gtmp + atmp) * vec
      ds(:, :) = ds + (gtmp + atmp) * spread(vec, 1, 3) * spread(vec, 2, 3)
   end do

end subroutine get_damat_dir_3d

!> Calculate reciprocal space contributions for a pair under 3D periodic boundary conditions
subroutine get_damat_rec_3d(rij, vol, alp, qpc, trans, dg, ds)
   !> Distance between pair
   real(wp), intent(in) :: rij(3)
   !> Cell volume
   real(wp), intent(in) :: vol
   !> Convergence factor
   real(wp), intent(in) :: alp
   !> Pseudo-quadrupole contribution
   real(wp), intent(in) :: qpc
   !> Translation vectors to consider
   real(wp), intent(in) :: trans(:, :)
   !> Derivative with respect to cartesian displacements
   real(wp), intent(out) :: dg(3)
   !> Derivative with respect to strain deformations
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr
   real(wp) :: fac, vec(3), g2, gv, expk, sink, cosk, alp2, fqp
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], shape(unity))

   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp
   fac = 4*pi/vol
   alp2 = alp*alp
   fqp = 2*qpc*qpc

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      gv = dot_product(rij, vec)
      expk = fac * exp(-0.25_wp*g2/alp2)/g2
      cosk = cos(gv) * expk
      sink = sin(gv) * expk
      dg(:) = dg - sink * vec
      ds(:, :) = ds + cosk &
         & * ((2.0_wp/g2 + 0.5_wp/alp2 + 0.5_wp*fqp) * spread(vec, 1, 3)*spread(vec, 2, 3) &
         &     - unity * (1.0_wp + g2*fqp))
   end do

end subroutine get_damat_rec_3d


end module tblite_coulomb_charge_effective

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/blas
!> Contains wrappers for the basic linear algebra subprograms

!> @file tblite/blas.f90
!> Provides high-level interfaces to the basic linear algebra subprograms

!> Proxy module to reexport high-level basic linear algebra subprogram wrappers
module tblite_blas
   use tblite_blas_level1, only : dot => wrap_dot
   use tblite_blas_level2, only : gemv => wrap_gemv, symv => wrap_symv
   use tblite_blas_level3, only : gemm => wrap_gemm, symm => wrap_symm
   implicit none
   public
end module tblite_blas

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/solvation/born.f90
!> Provides a Born radii integrator

!> Integrator for Born radii based on the Onufriev-Bashford-Case model
module tblite_solvation_born
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use mctc_io_convert, only : aatoau
   use tblite_adjlist, only : adjacency_list, new_adjacency_list
   implicit none
   private

   public :: new_born_integrator

   !> Implementation of GBOBC integrator
   type, public :: born_integrator
      !> van der Waals radii of the particles
      real(wp), allocatable :: vdwr(:)
      !> pair descreening approximation radii
      real(wp), allocatable :: rho(:)
      !> offset van der Waals radii
      real(wp), allocatable :: svdw(:)
      !> cut-off radius for the Born radius NN list
      real(wp) :: lrcut
      !> Scaling factor for Born radii
      real(wp) :: born_scale
      !> Volume polynome correction, default parameters correspond to GBOBCII
      real(wp) :: obc(3)
   contains
      !> Calculate Born radii for a given geometry
      procedure :: get_rad
   end type born_integrator

   real(wp), parameter :: lrcut_default = 35.0_wp * aatoau
   real(wp), parameter :: born_scale_default = 1.0_wp
   real(wp), parameter :: born_offset_default = 0.0_wp
   real(wp), parameter :: descreening_default = 0.8_wp
   real(wp), parameter :: obc_default(3) = [1.0_wp, 0.8_wp, 4.85_wp]

contains

!> Create new Born radii integrator
subroutine new_born_integrator(self, mol, vdwrad, descreening, born_scale, born_offset, &
      & obc, rcutoff)
   !> Instance of the Born integrator
   type(born_integrator), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Van-der-Waals Radii
   real(wp), intent(in) :: vdwRad(:)
   !> Dielectric descreening parameter
   real(wp), intent(in), optional :: descreening(:)
   !> Scaling factor for Born radii
   real(wp), intent(in), optional :: born_scale
   !> Offset parameter for Born radii integration
   real(wp), intent(in), optional :: born_offset
   !> GBOBC integrator parameters
   real(wp), intent(in), optional :: obc(3)
   !> Real-space cutoff for Born radii integration
   real(wp), intent(in), optional :: rCutoff

   self%lrcut = lrcut_default
   if (present(rCutoff)) then
      self%lrcut = rCutoff
   end if

   self%born_scale = born_scale_default
   if (present(born_scale)) then
      self%born_scale = born_scale
   end if

   self%obc = obc_default
   if (present(obc)) then
      self%obc = obc
   end if

   self%vdwr = vdwRad(mol%id)

   if (present(descreening)) then
      self%rho = self%vdwr * descreening(mol%id)
   else
      self%rho = self%vdwr * descreening_default
   end if

   if (present(born_offset)) then
      self%svdw = self%vdwr - born_offset
   else
      self%svdw = self%vdwr - born_offset_default
   end if
end subroutine new_born_integrator

!> Calculate Born radii
subroutine get_rad(self, mol, rad, draddr)
   !> Instance of the Born integrator
   class(born_integrator), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Born radii
   real(wp), intent(out) :: rad(:)
   !> Derivative of Born radii w.r.t. cartesian displacements
   real(wp), intent(out), optional :: draddr(:, :, :)

   type(adjacency_list) :: list
   real(wp), parameter :: trans(3, 1) = 0.0_wp
   real(wp), allocatable :: brdr(:, :, :)

   call new_adjacency_list(list, mol, trans, self%lrcut)
   allocate(brdr(3, mol%nat, mol%nat))

   call compute_bornr(mol%nat, mol%xyz, list, &
      & self%vdwr, self%rho, self%svdw, self%born_scale, self%obc, rad, brdr)

   if (present(draddr)) then
      draddr(:, :, :) = brdr
   end if
end subroutine get_rad

subroutine compute_bornr(nat, xyz, list, vdwr, rho, svdw, c1, obc, &
      & brad, brdr)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Neighbourlist
   type(adjacency_list), intent(in) :: list
   !> Van-der-Waals radii
   real(wp), intent(in) :: vdwr(:)
   !> Descreened van-der-Waals radii
   real(wp), intent(in) :: rho(:)
   !> van-der-Waals radii with offset
   real(wp), intent(in) :: svdw(:)
   !> Scaling factor for the Born radii
   real(wp), intent(in) :: c1
   !> Volume polynome correction
   real(wp), intent(in) :: obc(3)
   !> Born radii
   real(wp), intent(out) :: brad(:)

   !> Derivative of Born radii w.r.t. cartesian coordinates
   real(wp), intent(out) :: brdr(:, :, :)

   integer :: iat
   real(wp) :: br, dpsi, svdwi, vdwri, s1, v1, s2, arg, arg2
   real(wp) :: th, ch

   call compute_psi(nat, xyz, list, vdwr, rho, brad, brdr)

   do iat = 1, nat

      br = brad(iat)

      svdwi = svdw(iat)
      vdwri = vdwr(iat)
      s1 = 1.0_wp/svdwi
      v1 = 1.0_wp/vdwri
      s2 = 0.5_wp*svdwi

      br = br*s2

      arg2 = br*(obc(3)*br-obc(2))
      arg = br*(obc(1)+arg2)
      arg2 = 2.0_wp*arg2+obc(1)+obc(3)*br*br

      th = tanh(arg)
      ch = cosh(arg)

      br = 1.0_wp/(s1-v1*th)
      ! Include GBMV2-like scaling
      br = c1*br

      dpsi = ch*(s1-v1*th)
      dpsi = s2*v1*arg2/(dpsi*dpsi)
      dpsi = c1*dpsi

      brad(iat) = br
      brdr(:, :, iat) = brdr(:, :, iat) * dpsi

   end do

end subroutine compute_bornr


pure subroutine compute_psi(nat, xyz, list, vdwr, rho, psi, dpsidr)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Neighbourlist
   type(adjacency_list), intent(in) :: list
   !> Van-der-Waals radii
   real(wp), intent(in) :: vdwr(:)
   !> Descreened van-der-Waals radii
   real(wp), intent(in) :: rho(:)
   !> Integrated value of Psi
   real(wp), intent(out) :: psi(:)
   !> Derivative of Psi w.r.t. cartesian coordinates
   real(wp), intent(out) :: dpsidr(:, :, :)
   real(wp), allocatable :: dpsitr(:, :)

   integer  :: iat, jat, img, inl
   real(wp) :: vec(3), r, rhoi, rhoj
   real(wp) :: gi, gj, ap, am, lnab, rhab, ab, dgi, dgj
   real(wp) :: drjj(3)
   real(wp) :: rh1, rhr1, r24, r1, aprh1, r12
   real(wp) :: rvdwi, rvdwj
   logical :: ijov, jiov

   allocate(dpsitr(3, nat))
   psi(:) = 0.0_wp
   dpsidr(:, :, :) = 0.0_wp
   dpsitr(:, :) = 0.0_wp

   do iat = 1, nat
      inl = list%inl(iat)
      do img = 1, list%nnl(iat)
         jat = list%nlat(inl+img)

         vec(:) = xyz(:, iat) - xyz(:, jat)
         r = norm2(vec)

         rhoi = rho(iat)
         rhoj = rho(jat)
         rvdwi = vdwr(iat)
         rvdwj = vdwr(jat)

         ijov = r < (rvdwi+rhoj)
         jiov = r < (rhoi+rvdwj)

         if (.not.(ijov .or. jiov)) then
            ! nonoverlaping spheres
            if(abs(rhoi-rhoj) < 1.e-8_wp) then
               ! equal reduced radii
               r1 = 1.0_wp/r
               ap = r+rhoj
               am = r-rhoj
               ab = ap*am
               rhab = rhoj/ab
               lnab = 0.5_wp*log(am/ap)*r1
               gi = rhab+lnab
               dgi = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
               ! accumulate psi
               psi(iat) = psi(iat)+gi
               psi(jat) = psi(jat)+gi
               ! accumulate psi gradient
               drjj(:) = dgi*vec(:)
               dpsitr(:, iat) = dpsitr(:, iat)+drjj(:)
               dpsidr(:, jat, iat) = dpsidr(:, jat, iat)-drjj(:)
               dpsitr(:, jat) = dpsitr(:, jat)-drjj(:)
               dpsidr(:, iat, jat) = dpsidr(:, iat, jat)+drjj(:)
            else
               ! unequal reduced radii
               ! ij contribution
               r1 = 1.0_wp/r
               ap = r+rhoj
               am = r-rhoj
               ab = ap*am
               rhab = rhoj/ab
               lnab = 0.5_wp*log(am/ap)*r1
               gi = rhab+lnab
               dgi = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
               ! ji contribution
               ap = r+rhoi
               am = r-rhoi
               ab = ap*am
               rhab = rhoi/ab
               lnab = 0.5_wp*log(am/ap)*r1
               gj = rhab+lnab
               dgj = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
               ! accumulate psi
               psi(iat) = psi(iat)+gi
               psi(jat) = psi(jat)+gj
               ! accumulate psi gradient
               drjj(:) = dgi*vec(:)
               dpsitr(:, iat) = dpsitr(:, iat)+drjj(:)
               dpsidr(:, jat, iat) = dpsidr(:, jat, iat)-drjj(:)

               drjj(:) = dgj*vec(:)
               dpsitr(:, jat) = dpsitr(:, jat)-drjj(:)
               dpsidr(:, iat, jat) = dpsidr(:, iat, jat)+drjj(:)
            end if

         else if (.not.ijov .and. jiov) then

            ! ij contribution
            r1 = 1.0_wp/r
            ap = r+rhoj
            am = r-rhoj
            ab = ap*am
            rhab = rhoj/ab
            lnab = 0.5_wp*log(am/ap)*r1
            gi = rhab+lnab
            dgi = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
            ! accumulate psi
            psi(iat) = psi(iat)+gi
            ! accumulate psi gradient
            drjj(:) = dgi*vec(:)
            dpsitr(:, iat) = dpsitr(:, iat)+drjj(:)
            dpsidr(:, jat, iat) = dpsidr(:, jat, iat)-drjj(:)

            if((r+rhoi) > rvdwj) then
               ! ji contribution
               r1 = 1.0_wp/r
               r12 = 0.5_wp*r1
               r24 = r12*r12

               ap = r+rhoi
               am = r-rhoi
               rh1 = 1.0_wp/rvdwj
               rhr1 = 1.0_wp/ap
               aprh1 = ap*rh1
               lnab = log(aprh1)

               gj = rh1-rhr1+r12*(0.5_wp*am*(rhr1-rh1*aprh1)-lnab)

               dgj = rhr1*rhr1*(1.0_wp-0.25_wp*am*r1*(1.0_wp+aprh1*aprh1))+ &
                  &         rhoi*r24*(rhr1-rh1*aprh1)+ &
                  &         r12*(r1*lnab-rhr1)
               dgj = dgj*r1
               ! accumulate psi
               psi(jat) = psi(jat)+gj
               ! accumulate psi gradient
               drjj(:) = dgj*vec(:)
               dpsitr(:, jat) = dpsitr(:, jat)-drjj(:)
               dpsidr(:, iat, jat) = dpsidr(:, iat, jat)+drjj(:)
            end if

         else if (ijov .and. .not.jiov) then

            if((r+rhoj) > rvdwi) then
               ! ij contribution
               r1 = 1.0_wp/r
               r12 = 0.5_wp*r1
               r24 = r12*r12

               ap = r+rhoj
               am = r-rhoj
               rh1 = 1.0_wp/rvdwi
               rhr1 = 1.0_wp/ap
               aprh1 = ap*rh1
               lnab = log(aprh1)

               gi = rh1-rhr1+r12*(0.5_wp*am*(rhr1-rh1*aprh1)-lnab)

               dgi = rhr1*rhr1*(1.0_wp-0.25_wp*am*r1*(1.0_wp+aprh1*aprh1))+ &
                  &         rhoj*r24*(rhr1-rh1*aprh1)+ &
                  &         r12*(r1*lnab-rhr1)
               dgi = dgi*r1
               ! accumulate psi
               psi(iat) = psi(iat)+gi
               ! accumulate psi gradient
               drjj(:) = dgi*vec(:)
               dpsitr(:, iat) = dpsitr(:, iat)+drjj(:)
               dpsidr(:, jat, iat) = dpsidr(:, jat, iat)-drjj(:)
            end if

            ! ji contribution
            ap = r+rhoi
            am = r-rhoi
            ab = ap*am
            rhab = rhoi/ab
            lnab = 0.5_wp*log(am/ap)*r1
            gj = rhab+lnab
            dgj = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
            ! accumulate psi
            psi(jat) = psi(jat)+gj
            ! accumulate psi gradient
            drjj(:) = dgj*vec(:)
            dpsitr(:, jat) = dpsitr(:, jat)-drjj(:)
            dpsidr(:, iat, jat) = dpsidr(:, iat, jat)+drjj(:)

         else if (ijov .and. jiov) then
            ! overlaping spheres
            if((r+rhoj) > rvdwi) then
               ! ij contribution
               r1 = 1.0_wp/r
               r12 = 0.5_wp*r1
               r24 = r12*r12

               ap = r+rhoj
               am = r-rhoj
               rh1 = 1.0_wp/rvdwi
               rhr1 = 1.0_wp/ap
               aprh1 = ap*rh1
               lnab = log(aprh1)

               gi = rh1-rhr1+r12*(0.5_wp*am*(rhr1-rh1*aprh1)-lnab)

               dgi = rhr1*rhr1*(1.0_wp-0.25_wp*am*r1*(1.0_wp+aprh1*aprh1))+ &
                  &         rhoj*r24*(rhr1-rh1*aprh1)+ &
                  &         r12*(r1*lnab-rhr1)
               dgi = dgi*r1
               ! accumulate psi
               psi(iat) = psi(iat)+gi
               ! accumulate psi gradient
               drjj(:) = dgi*vec(:)
               dpsitr(:, iat) = dpsitr(:, iat)+drjj(:)
               dpsidr(:, jat, iat) = dpsidr(:, jat, iat)-drjj(:)
            end if

            if((r+rhoi) > rvdwj) then
               ! ji contribution
               r1 = 1.0_wp/r
               r12 = 0.5_wp*r1
               r24 = r12*r12

               ap = r+rhoi
               am = r-rhoi
               rh1 = 1.0_wp/rvdwj
               rhr1 = 1.0_wp/ap
               aprh1 = ap*rh1
               lnab = log(aprh1)

               gj = rh1-rhr1+r12*(0.5_wp*am*(rhr1-rh1*aprh1)-lnab)

               dgj = rhr1*rhr1*(1.0_wp-0.25_wp*am*r1*(1.0_wp+aprh1*aprh1))+ &
                  &         rhoi*r24*(rhr1-rh1*aprh1)+ &
                  &         r12*(r1*lnab-rhr1)
               dgj = dgj*r1
               ! accumulate psi
               psi(jat) = psi(jat)+gj
               ! accumulate psi gradient
               drjj(:) = dgj*vec(:)
               dpsitr(:, jat) = dpsitr(:, jat)-drjj(:)
               dpsidr(:, iat, jat) = dpsidr(:, iat, jat)+drjj(:)
            end if

         end if

      end do
   end do

   ! save one-center terms
   do iat = 1, nat
      dpsidr(:, iat, iat) = dpsitr(:, iat)
   end do

end subroutine compute_psi

end module tblite_solvation_born

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/api/calculator.f90
!> Provides API exports for the #tblite_calculator handle.

!> API export for managing tight-binding parameters and calculators
module tblite_api_calculator
   use, intrinsic :: iso_c_binding
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type
   use tblite_api_context, only : vp_context
   use tblite_api_param, only : vp_param
   use tblite_api_result, only : vp_result
   use tblite_api_structure, only : vp_structure
   use tblite_api_version, only : namespace
   use tblite_results, only : results_type
   use tblite_wavefunction, only : wavefunction_type, new_wavefunction, &
      & sad_guess, eeq_guess, eeqbc_guess, get_molecular_dipole_moment, &
      & get_molecular_quadrupole_moment
   use tblite_xtb_calculator, only : xtb_calculator, new_xtb_calculator, xtb_config
   use tblite_xtb_gfn2, only : new_gfn2_calculator
   use tblite_xtb_gfn1, only : new_gfn1_calculator
   use tblite_xtb_ipea1, only : new_ipea1_calculator
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   use tblite_api_utils, only : f_c_character, c_f_character
   use tblite_post_processing_list, only : post_processing_list, add_post_processing
   implicit none
   private

   public :: vp_calculator, delete_calculator_api
   public :: new_gfn2_calculator_api, new_ipea1_calculator_api, new_gfn1_calculator_api, &
      & new_xtb_calculator_api
   public :: set_calculator_mixer_damping_api, set_calculator_max_iter_api, &
      & set_calculator_accuracy_api, set_calculator_temperature_api, &
      & set_calculator_save_integrals_api
   public :: get_singlepoint_api
   public :: push_back_post_processing_param_api, push_back_post_processing_str_api


   enum, bind(c)
      enumerator :: &
         tblite_guess_sad = 0_c_int, &
         tblite_guess_eeq = 1_c_int, &
         tblite_guess_eeqbc = 2_c_int
   end enum


   type, bind(c) :: xtb_config_struct
      real(wp) :: smooth_cutoff
   end type


   !> Void pointer to calculator type
   type :: vp_calculator
      !> Actual payload
      type(xtb_calculator) :: ptr
      !> Calculation accuracy
      real(wp) :: accuracy = 1.0_wp
      !> Electronic temperature
      real(wp) :: etemp = 300.0_wp * 3.166808578545117e-06_wp
      !> Wavefunction guess
      integer :: guess = tblite_guess_sad
      !> Numbers of spin channels for calculator
      integer :: nspin = 1
      !> List of post-processing applied methods
      type(post_processing_list) :: post_proc
   end type vp_calculator


   logical, parameter :: debug = .false.


contains


function new_gfn2_calculator_api(vctx, vmol, config) result(vcalc) &
      & bind(C, name=namespace//"new_gfn2_calculator")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr) :: vcalc
   type(vp_calculator), pointer :: calc
   type(xtb_config_struct), intent(in), optional :: config
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "new_gfn2_calculator"

   vcalc = c_null_ptr
   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vmol)) return
   call c_f_pointer(vmol, mol)

   allocate(calc)
   call new_gfn2_calculator(calc%ptr, mol%ptr, error, convert_config(config))
   if (allocated(error)) then
      deallocate(calc)
      call ctx%ptr%set_error(error)
      return
   else
      vcalc = c_loc(calc)
   end if

end function new_gfn2_calculator_api


function new_ipea1_calculator_api(vctx, vmol, config) result(vcalc) &
      & bind(C, name=namespace//"new_ipea1_calculator")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr) :: vcalc
   type(vp_calculator), pointer :: calc
   type(xtb_config_struct), intent(in), optional :: config
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "new_ipea1_calculator"

   vcalc = c_null_ptr
   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vmol)) return
   call c_f_pointer(vmol, mol)

   allocate(calc)
   call new_ipea1_calculator(calc%ptr, mol%ptr, error, convert_config(config))
   if (allocated(error)) then
      deallocate(calc)
      call ctx%ptr%set_error(error)
      return
   else
      vcalc = c_loc(calc)
   end if

end function new_ipea1_calculator_api


function new_gfn1_calculator_api(vctx, vmol, config) result(vcalc) &
      & bind(C, name=namespace//"new_gfn1_calculator")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr) :: vcalc
   type(vp_calculator), pointer :: calc
   type(xtb_config_struct), intent(in), optional :: config
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "new_gfn1_calculator"

   vcalc = c_null_ptr
   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vmol)) return
   call c_f_pointer(vmol, mol)

   allocate(calc)
   call new_gfn1_calculator(calc%ptr, mol%ptr, error, convert_config(config))
   if (allocated(error)) then
      deallocate(calc)
      call ctx%ptr%set_error(error)
      return
   else
      vcalc = c_loc(calc)
   end if

end function new_gfn1_calculator_api


function new_xtb_calculator_api(vctx, vmol, vparam, config) result(vcalc) &
      & bind(C, name=namespace//"new_xtb_calculator")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr), value :: vparam
   type(vp_param), pointer :: param
   type(c_ptr) :: vcalc
   type(vp_calculator), pointer :: calc
   type(xtb_config_struct), intent(in), optional :: config

   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "new_xtb_calculator"

   vcalc = c_null_ptr
   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vmol)) return
   call c_f_pointer(vmol, mol)

   if (.not.c_associated(vparam)) return
   call c_f_pointer(vparam, param)

   allocate(calc)
   call new_xtb_calculator(calc%ptr, mol%ptr, param%ptr, error, convert_config(config))
   if (allocated(error)) then
      deallocate(calc)
      call ctx%ptr%set_error(error)
      return
   else
      vcalc = c_loc(calc)
   end if

end function new_xtb_calculator_api


subroutine delete_calculator_api(vcalc) &
      & bind(C, name=namespace//"delete_calculator")
   type(c_ptr), intent(inout) :: vcalc
   type(vp_calculator), pointer :: calc

   if (debug) print '("[Info]", 1x, a)', "delete_calculator"

   if (c_associated(vcalc)) then
      call c_f_pointer(vcalc, calc)

      deallocate(calc)
      vcalc = c_null_ptr
   end if
end subroutine delete_calculator_api


subroutine set_calculator_mixer_damping_api(vctx, vcalc, damping) &
      & bind(C, name=namespace//"set_calculator_mixer_damping")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   real(c_double), value :: damping
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "set_calculator_mixer_damping"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   calc%ptr%mixer_damping = damping
end subroutine set_calculator_mixer_damping_api


subroutine set_calculator_max_iter_api(vctx, vcalc, max_iter) &
      & bind(C, name=namespace//"set_calculator_max_iter")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), value :: max_iter
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_calculator_max_iter"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   calc%ptr%max_iter = max_iter
end subroutine set_calculator_max_iter_api


subroutine set_calculator_guess_api(vctx, vcalc, guess) &
      & bind(C, name=namespace//"set_calculator_guess")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), value :: guess
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "set_calculator_guess"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   calc%guess = guess
end subroutine set_calculator_guess_api


subroutine set_calculator_accuracy_api(vctx, vcalc, accuracy) &
      & bind(C, name=namespace//"set_calculator_accuracy")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   real(c_double), value :: accuracy
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "set_calculator_accuracy"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   calc%accuracy = accuracy
end subroutine set_calculator_accuracy_api


subroutine set_calculator_temperature_api(vctx, vcalc, etemp) &
      & bind(C, name=namespace//"set_calculator_temperature")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   real(c_double), value :: etemp
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_calculator_temperature"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   calc%etemp = etemp
end subroutine set_calculator_temperature_api


subroutine set_calculator_save_integrals_api(vctx, vcalc, save_integrals) &
      & bind(C, name=namespace//"set_calculator_save_integrals")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), value :: save_integrals
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "set_calculator_save_integrals"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   calc%ptr%save_integrals = save_integrals /= 0
end subroutine set_calculator_save_integrals_api

subroutine get_calculator_shell_count(vctx, vcalc, nsh) &
      & bind(C, name=namespace//"get_calculator_shell_count")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), intent(inout) :: nsh
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_calculator_shell_count"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   associate(sh2at => calc%ptr%bas%sh2at)
      nsh = size(sh2at)
   end associate
end subroutine get_calculator_shell_count

subroutine get_calculator_shell_map(vctx, vcalc, imap) &
      & bind(C, name=namespace//"get_calculator_shell_map")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), intent(inout) :: imap(*)
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_calculator_shell_map"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   associate(sh2at => calc%ptr%bas%sh2at)
      imap(:size(sh2at)) = sh2at - 1_c_int
   end associate
end subroutine get_calculator_shell_map

subroutine get_calculator_angular_momenta(vctx, vcalc, am) &
      & bind(C, name=namespace//"get_calculator_angular_momenta")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), intent(inout) :: am(*)
   type(error_type), allocatable :: error
   integer :: ish

   if (debug) print '("[Info]", 1x, a)', "get_calculator_angular_momenta"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   associate(bas => calc%ptr%bas)
      do ish = 1, bas%nsh
         ! Angular momentum is only available for each species,
         ! which is unavailable in this API call.
         ! Therefore, we calculate it by using 2*l + 1 == nao
         am(ish) = (bas%nao_sh(ish)-1)/2
      end do
   end associate
end subroutine get_calculator_angular_momenta

subroutine get_calculator_orbital_count(vctx, vcalc, nao) &
      & bind(C, name=namespace//"get_calculator_orbital_count")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), intent(inout) :: nao
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_calculator_orbital_count"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   associate(ao2sh => calc%ptr%bas%ao2sh)
      nao = size(ao2sh)
   end associate
end subroutine get_calculator_orbital_count

subroutine get_calculator_orbital_map(vctx, vcalc, imap) &
      & bind(C, name=namespace//"get_calculator_orbital_map")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   integer(c_int), intent(inout) :: imap(*)
   type(error_type), allocatable :: error

   if (debug) print '("[Info]", 1x, a)', "get_calculator_orbital_map"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   associate(ao2sh => calc%ptr%bas%ao2sh)
      imap(:size(ao2sh)) = ao2sh - 1_c_int
   end associate
end subroutine get_calculator_orbital_map

subroutine get_singlepoint_api(vctx, vmol, vcalc, vres) &
      & bind(C, name=namespace//"get_singlepoint")
   type(c_ptr), value :: vctx
   type(vp_context), pointer :: ctx
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr), value :: vcalc
   type(vp_calculator), pointer :: calc
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   type(error_type), allocatable :: error
   character(len=:), allocatable :: f_char
   
   if (debug) print '("[Info]", 1x, a)', "get_singlepoint"

   if (.not.c_associated(vctx)) return
   call c_f_pointer(vctx, ctx)

   if (.not.c_associated(vmol)) then
      call fatal_error(error, "Molecular structure data is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vmol, mol)

   if (.not.c_associated(vcalc)) then
      call fatal_error(error, "Calculator object is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vcalc, calc)

   if (.not.c_associated(vres)) then
      call fatal_error(error, "Result container is missing")
      call ctx%ptr%set_error(error)
      return
   end if
   call c_f_pointer(vres, res)

   res%energy = 0.0_wp
   res%gradient = spread([0.0_wp, 0.0_wp, 0.0_wp], 2, mol%ptr%nat)
   res%sigma = spread([0.0_wp, 0.0_wp, 0.0_wp], 2, 3)

   call check_results(res%results)
   
   call check_wavefunction(res%wfn, mol%ptr, calc%ptr, calc%etemp, &
      & calc%nspin, calc%guess, error)
   if (calc%post_proc%npp == 0) then 
      f_char = "bond-orders"
      call add_post_processing(calc%post_proc, mol%ptr, f_char, error)
      f_char = "molmom"
      call add_post_processing(calc%post_proc, mol%ptr, f_char, error)
      if (allocated(error)) call ctx%ptr%set_error(error)
   end if

   call xtb_singlepoint(ctx%ptr, mol%ptr, calc%ptr, res%wfn, calc%accuracy, &
      & res%energy, gradient=res%gradient, sigma=res%sigma, results=res%results, &
      & post_process=calc%post_proc)

end subroutine get_singlepoint_api

subroutine check_results(res)
   type(results_type), allocatable, intent(inout) :: res
   if (allocated(res)) then 
      deallocate(res%dict)
   end if

   if (.not.allocated(res)) then 
      allocate(res)
   end if
end subroutine

subroutine check_wavefunction(wfn, mol, calc, etemp, nspin, guess, error)
   type(wavefunction_type), allocatable, intent(inout) :: wfn
   type(structure_type), intent(in) :: mol
   type(xtb_calculator), intent(in) :: calc
   real(wp), intent(in) :: etemp
   integer, intent(in) :: nspin
   integer, intent(in) :: guess
   type(error_type), intent(out), allocatable :: error

   if (allocated(wfn)) then
      wfn%kt = etemp

      if (size(wfn%qat, 1) /= mol%nat .or. size(wfn%emo, 1) /= calc%bas%nao &
         & .or. size(wfn%qsh, 1) /= calc%bas%nsh .or. wfn%nspin /= nspin) then
         deallocate(wfn)
      end if
   end if

   if (.not.allocated(wfn)) then
      allocate(wfn)
      call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, nspin, etemp)

      select case(guess)
      case default
         call sad_guess(mol, calc, wfn)
      case(tblite_guess_eeq)
         call eeq_guess(mol, calc, wfn, error)
      case(tblite_guess_eeqbc)
         call eeqbc_guess(mol, calc, wfn, error)
      end select
   end if
end subroutine check_wavefunction

subroutine push_back_post_processing_str_api(vctx, vcalc, vmol, charptr) &
   & bind(C, name=namespace//"push_back_post_processing_str")
character(kind=c_char), intent(in) :: charptr(*)
type(c_ptr), value :: vctx
type(vp_context), pointer :: ctx
type(c_ptr), value :: vcalc
type(vp_calculator), pointer :: calc
type(c_ptr), value :: vmol
type(vp_structure), pointer :: mol
character(len=:), allocatable :: config_str
type(error_type), allocatable :: error

if (debug) print '("[Info]", 1x, a)', "push_back_post_processing"

if (.not.(c_associated(vctx))) return
call c_f_pointer(vctx, ctx)

call c_f_character(charptr, config_str)

if (.not.c_associated(vcalc)) then 
   call fatal_error(error, "Calculator object is missing")
   call ctx%ptr%set_error(error)
   return
end if
call c_f_pointer(vcalc, calc)

if (.not.c_associated(vmol)) then
   call fatal_error(error, "Molecular structure data is missing")
   call ctx%ptr%set_error(error)
   return
end if
call c_f_pointer(vmol, mol)

call add_post_processing(calc%post_proc, mol%ptr, config_str, error)
if (allocated(error)) call ctx%ptr%set_error(error)

end subroutine

subroutine push_back_post_processing_param_api(vctx, vcalc, vmol, vparam) &
   & bind(C, name=namespace//"push_back_post_processing_param")
type(c_ptr), value :: vctx
type(vp_context), pointer :: ctx
type(c_ptr), value :: vcalc
type(vp_calculator), pointer :: calc
type(c_ptr), value :: vmol
type(vp_structure), pointer :: mol
type(c_ptr), value :: vparam
type(vp_param), pointer :: param
type(error_type), allocatable :: error

if (debug) print '("[Info]", 1x, a)', "push_back_post_processing"

if (.not.(c_associated(vctx))) return
call c_f_pointer(vctx, ctx)

if (.not.(c_associated(vparam))) then
   call fatal_error(error, "Param object is missing")
   call ctx%ptr%set_error(error)
   return
end if
call c_f_pointer(vparam, param)

if (.not.c_associated(vcalc)) then 
   call fatal_error(error, "Calculator object is missing")
   call ctx%ptr%set_error(error)
   return
end if
call c_f_pointer(vcalc, calc)

if (.not.c_associated(vmol)) then
   call fatal_error(error, "Molecular structure data is missing")
   call ctx%ptr%set_error(error)
   return
end if
call c_f_pointer(vmol, mol)

call add_post_processing(calc%post_proc, mol%ptr, param%ptr%post_proc, error)
if (allocated(error)) call ctx%ptr%set_error(error)

end subroutine

pure function convert_config(config) result(cfg)
   type(xtb_config_struct), intent(in), optional :: config
   type(xtb_config) :: cfg

   cfg = xtb_config()
   if (present(config)) then
      cfg%smooth_cutoff = config%smooth_cutoff
   end if
end function convert_config

end module tblite_api_calculator

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/xtb/spec.f90
!> Provides generator base class for Hamiltonian parameters.

!> Definition of an abstract base class of the generator for the Hamiltonian.
module tblite_xtb_spec
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_data_atomicrad, only : get_atomic_rad
   use tblite_basis_type, only : basis_type
   implicit none
   private


   !> Specification of the effective Hamiltonian.
   !>
   !> An instance of the specification is consumed by the constructor of the
   !> Hamiltonian to generate the respective entries in the derived type.
   type, public, abstract :: tb_h0spec
   contains
      !> Generator for the self energy / atomic levels of the Hamiltonian
      procedure(get_selfenergy), deferred :: get_selfenergy
      !> Generator for the coordination number dependent shift of the self energy
      procedure :: get_cnshift
      !> Generator for the electronegativity scaled coordination number dependent shift of the self energy
      procedure :: get_cnenshift
      !> Generator for the linear partial charge dependent shift of the self energy
      procedure :: get_q1shift
      !> Generator for the quadratic partial charge dependent shift of the self energy
      procedure :: get_q2shift
      !> Generator for the enhancement factor to for scaling Hamiltonian elements
      procedure(get_hscale), deferred :: get_hscale
      !> Generator for the atomic radii used in the distant dependent scaling
      procedure :: get_rad
      !> Generator for the polynomial parameters for the distant dependent scaling
      procedure(get_shpoly), deferred :: get_shpoly
      !> Generator for the reference occupation numbers of the atoms
      procedure(get_reference_occ), deferred :: get_reference_occ
      !> Generator for the diatomic frame scaling factors
      procedure :: get_diat_scale
   end type tb_h0spec

   abstract interface
      !> Generator for the enhancement factor to for scaling Hamiltonian elements
      subroutine get_hscale(self, mol, bas, hscale)
         import :: tb_h0spec, structure_type, basis_type, wp
         !> Instance of the Hamiltonian specification
         class(tb_h0spec), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Basis set information
         type(basis_type), intent(in) :: bas
         !> Scaling parameters for the Hamiltonian elements
         real(wp), intent(out) :: hscale(:, :, :, :)
      end subroutine get_hscale

      !> Generator for the self energy / atomic levels of the Hamiltonian
      subroutine get_selfenergy(self, mol, bas, selfenergy)
         import :: tb_h0spec, structure_type, basis_type, wp
         !> Instance of the Hamiltonian specification
         class(tb_h0spec), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Basis set information
         type(basis_type), intent(in) :: bas
         !> Self energy / atomic levels
         real(wp), intent(out) :: selfenergy(:, :)
      end subroutine get_selfenergy

      !> Generator for the polynomial parameters for the distant dependent scaling
      subroutine get_shpoly(self, mol, bas, shpoly)
         import :: tb_h0spec, structure_type, basis_type, wp
         !> Instance of the Hamiltonian specification
         class(tb_h0spec), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Basis set information
         type(basis_type), intent(in) :: bas
         !> Polynomial parameters for distant dependent scaleing
         real(wp), intent(out) :: shpoly(:, :)
      end subroutine get_shpoly

      !> Generator for the reference occupation numbers of the atoms
      subroutine get_reference_occ(self, mol, bas, refocc)
         import :: tb_h0spec, structure_type, basis_type, wp
         !> Instance of the Hamiltonian specification
         class(tb_h0spec), intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Basis set information
         type(basis_type), intent(in) :: bas
         !> Reference occupation numbers
         real(wp), intent(out) :: refocc(:, :)
      end subroutine get_reference_occ
   end interface

contains


!> Stub implementation of the coordination number dependent shift generator
subroutine get_cnshift(self, mol, bas, kcn)
   !> Instance of the Hamiltonian specification
   class(tb_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Coordination number dependent shift
   real(wp), intent(out) :: kcn(:, :)

   kcn(:, :) = 0.0_wp
end subroutine get_cnshift


!> Stub implementation of the electronegativity scaled coordination number dependent shift generator
subroutine get_cnenshift(self, mol, bas, kcn_en)
   !> Instance of the Hamiltonian specification
   class(tb_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Coordination number dependent shift
   real(wp), intent(out) :: kcn_en(:, :)

   kcn_en(:, :) = 0.0_wp
end subroutine get_cnenshift


!> Stub implementation of the linear partial charge dependent shift generator
subroutine get_q1shift(self, mol, bas, kq1)
   !> Instance of the Hamiltonian specification
   class(tb_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Linear partial charge dependent shift
   real(wp), intent(out) :: kq1(:, :)

   kq1(:, :) = 0.0_wp
end subroutine get_q1shift


!> Stub implementation of the quadratic partial charge dependent shift generator
subroutine get_q2shift(self, mol, bas, kq2)
   !> Instance of the Hamiltonian specification
   class(tb_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Quadratic partial charge dependent shift
   real(wp), intent(out) :: kq2(:, :)

   kq2(:, :) = 0.0_wp
end subroutine get_q2shift


!> Stub implementation of the atomic radii generator
subroutine get_rad(self, mol, bas, rad)
   !> Instance of the Hamiltonian specification
   class(tb_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Atomic radii
   real(wp), intent(out) :: rad(:)

   rad(:) = get_atomic_rad(mol%num)
end subroutine get_rad


!> Stub implementation of the diatomic frame scaling factor generator
subroutine get_diat_scale(self, mol, bas, ksig, kpi, kdel)
   !> Instance of the Hamiltonian specification
   class(tb_h0spec), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Diatomic frame scaling of sigma bonding contribution
   real(wp), intent(out) :: ksig(:, :)
   !> Diatomic frame scaling of pi bonding contribution
   real(wp), intent(out) :: kpi(:, :)
   !> Diatomic frame scaling of delta bonding contribution
   real(wp), intent(out) :: kdel(:, :)

   ksig(:, :) = 0.0_wp
   kpi(:, :) = 0.0_wp
   kdel(:, :) = 0.0_wp
end subroutine get_diat_scale


end module tblite_xtb_spec

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/wavefunction/restart.f90
!> Read and write restart files

!> Implementation for reading and writing restart files
module tblite_wavefunction_restart
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_io_numpy, only : load_npz, save_npz
   use tblite_io_hdf5, only : load_hdf5, save_hdf5
   use tblite_io_data, only : iodata_type, open_iodata_handler
   use tblite_output_format, only : format_string
   use tblite_wavefunction_type, only : wavefunction_type
   implicit none
   private

   public :: load_wavefunction, save_wavefunction

   character(len=*), parameter :: prefix = "tblite0_"
contains

subroutine load_wavefunction(wfn, filename, error, nat, nsh, nao, nspin)
   type(wavefunction_type), intent(out) :: wfn
   character(len=*), intent(in) :: filename
   type(error_type), allocatable, intent(out) :: error
   integer, intent(in), optional :: nat
   integer, intent(in), optional :: nsh
   integer, intent(in), optional :: nao
   integer, intent(in), optional :: nspin

   logical :: exist
   real(wp), allocatable :: kt(:)
   integer, allocatable :: nat_sizes(:), nsh_sizes(:), nao_sizes(:), nspin_sizes(:)
   class(iodata_type), allocatable :: iodata

   inquire(file=filename, exist=exist)
   if (.not.exist) then
      call fatal_error(error, "Could not find '"//filename//"'")
      return
   end if

   call open_iodata_handler(iodata, filename, error)
   if (allocated(error)) return

   call iodata%load(prefix//"kt", kt, error)
   if (allocated(error)) return

   call iodata%load(prefix//"nel", wfn%nel, error)
   if (allocated(error)) return

   call iodata%load(prefix//"n0at", wfn%n0at, error)
   if (allocated(error)) return

   call iodata%load(prefix//"n0sh", wfn%n0sh, error)
   if (allocated(error)) return

   call iodata%load(prefix//"density", wfn%density, error)
   if (allocated(error)) return

   call iodata%load(prefix//"coeff", wfn%coeff, error)
   if (allocated(error)) return

   call iodata%load(prefix//"emo", wfn%emo, error)
   if (allocated(error)) return

   call iodata%load(prefix//"focc", wfn%focc, error)
   if (allocated(error)) return

   call iodata%load(prefix//"qat", wfn%qat, error)
   if (allocated(error)) return

   call iodata%load(prefix//"qsh", wfn%qsh, error)
   if (allocated(error)) return

   call iodata%load(prefix//"dpat", wfn%dpat, error)
   if (allocated(error)) return

   call iodata%load(prefix//"qpat", wfn%qpat, error)
   if (allocated(error)) return

   nat_sizes = [size(wfn%n0at), size(wfn%qat, 1), size(wfn%dpat, 2), size(wfn%qpat, 2)]
   if (present(nat)) nat_sizes = [nat, nat_sizes]
   if (any(nat_sizes(1) /= nat_sizes)) then
      call fatal_error(error, "Dimension mismatch in '"//filename//&
         & "' for number of atoms")
      return
   end if

   nsh_sizes = [size(wfn%n0sh), size(wfn%qsh, 1)]
   if (present(nsh)) nsh_sizes = [nsh, nsh_sizes]
   if (any(nsh_sizes(1) /= nsh_sizes)) then
      call fatal_error(error, "Dimension mismatch in '"//filename//&
         & "' for number of shells")
      return
   end if

   nao_sizes = [size(wfn%density, 1), size(wfn%density, 2), &
      & size(wfn%coeff, 1), size(wfn%coeff, 2), size(wfn%emo, 1), size(wfn%focc, 1)]
   if (present(nao)) nao_sizes = [nao, nao_sizes]
   if (any(nao_sizes(1) /= nao_sizes)) then
      call fatal_error(error, "Dimension mismatch in '"//filename//&
         & "' for number of orbitals")
      return
   end if

   nspin_sizes = [size(wfn%density, 3), size(wfn%coeff, 3), size(wfn%emo, 2)]
   if (present(nspin)) nspin_sizes = [nspin, nspin_sizes]
   if (any(nspin_sizes(1) /= nspin_sizes) .or. (all(size(wfn%nel) /= [2, nspin_sizes(1)]))) then
      call fatal_error(error, "Dimension mismatch in '"//filename//&
         & "' for number of spin channels")
      return
   end if

   if (size(wfn%dpat, 1) /= 3) then
      call fatal_error(error, "Dimension mismatch in '"//filename//&
         & "' for atomic dipole moments "//&
         & format_string(size(wfn%dpat, 1), '(i0)')//" != 3")
      return
   end if
   if (size(wfn%qpat, 1) /= 6) then
      call fatal_error(error, "Dimension mismatch in '"//filename//&
         & "' for atomic quadrupole moments "//&
         & format_string(size(wfn%qpat, 1), '(i0)')//" != 6")
      return
   end if
   if (size(kt) /= 1) then
      call fatal_error(error, "Dimension mismatch in '"//filename//&
         & "' for electronic temperature")
      return
   end if

   wfn%kt = kt(1)
   wfn%nocc = sum(wfn%nel)
   wfn%nspin = size(wfn%density, 3)
   wfn%nuhf = wfn%nel(1) - wfn%nel(2)
end subroutine load_wavefunction

subroutine save_wavefunction(wfn, filename, error)
   type(wavefunction_type), intent(in) :: wfn
   character(len=*), intent(in) :: filename
   type(error_type), allocatable, intent(out) :: error

   integer :: io, stat
   logical :: exist
   real(wp), allocatable :: kt(:)
   character(len=:), allocatable :: msg
   class(iodata_type), allocatable :: iodata

   inquire(file=filename, exist=exist)
   if (exist) then
      open(file=filename, newunit=io)
      close(io, status="delete")
   end if

   call open_iodata_handler(iodata, filename, error)
   if (allocated(error)) return

   kt = [wfn%kt]
   call iodata%save(prefix//"kt", kt, error)
   if (allocated(error)) return

   call iodata%save(prefix//"nel", wfn%nel, error)
   if (allocated(error)) return

   call iodata%save(prefix//"n0at", wfn%n0at, error)
   if (allocated(error)) return

   call iodata%save(prefix//"n0sh", wfn%n0sh, error)
   if (allocated(error)) return

   call iodata%save(prefix//"density", wfn%density, error)
   if (allocated(error)) return
   call iodata%save(prefix//"coeff", wfn%coeff, error)
   if (allocated(error)) return
   call iodata%save(prefix//"emo", wfn%emo, error)
   if (allocated(error)) return
   call iodata%save(prefix//"focc", wfn%focc, error)
   if (allocated(error)) return

   call iodata%save(prefix//"qat", wfn%qat, error)
   if (allocated(error)) return
   call iodata%save(prefix//"qsh", wfn%qsh, error)
   if (allocated(error)) return
   call iodata%save(prefix//"dpat", wfn%dpat, error)
   if (allocated(error)) return
   call iodata%save(prefix//"qpat", wfn%qpat, error)
   if (allocated(error)) return

end subroutine save_wavefunction


end module tblite_wavefunction_restart

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/param/hamiltonian.f90
!> Provides parameter record for the Hamiltonian

!> Defines model for the Hamiltonian parameters
module tblite_param_hamiltonian
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io_symbols, only : symbol_length
   use tblite_param_serde, only : serde_record
   use tblite_toml, only : toml_table, get_value, set_value, add_table
   implicit none
   private

   public :: count

   character(len=*), parameter :: k_xtb = "xtb", k_ang(0:4) = ["s", "p", "d", "f", "g"], &
      & k_enscale = "enscale", k_shell = "shell", k_wexp = "wexp", k_cn = "cn", &
      & k_kpol = "kpol", k_kpair = "kpair"
   real(wp), parameter :: kpol_default = 2.0_wp


   !> Hamiltonian parametrization record
   type, public, extends(serde_record) :: hamiltonian_record
      character(len=symbol_length), allocatable :: sym(:)
      character(len=:), allocatable :: cn
      real(wp), allocatable :: kpair(:, :)
      real(wp) :: ksh(0:4, 0:4)
      real(wp) :: kpol
      real(wp) :: enscale
      real(wp) :: wexp
      integer :: lmax
   contains
      generic :: load => load_from_array
      generic :: dump => dump_to_array
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Read parametrization data from parameter array
      procedure, private :: load_from_array
      !> Write parametrization data to parameter array
      procedure, private :: dump_to_array
   end type


   !> Masking for the Hamiltonian parameter record
   type, public :: hamiltonian_mask
   end type hamiltonian_mask


   interface count
      module procedure :: count_mask
   end interface count


contains


!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(hamiltonian_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   integer :: stat

   call get_value(table, k_xtb, child, requested=.false.)
   if (.not.associated(child)) then
      call fatal_error(error, "No entry for xTB Hamiltonian found")
      return
   end if

   call get_value(child, k_cn, self%cn, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for CN type in Hamiltonian")
      return
   end if

   call get_value(child, k_wexp, self%wexp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for Slater exponent weighting of Hamiltonian")
      return
   end if

   call get_value(child, k_kpol, self%kpol, kpol_default, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for scaling of non-valence Hamiltonian elements")
      return
   end if

   call get_ksh(self, child, error)
   if (allocated(error)) return

   call get_value(child, k_enscale, self%enscale, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for EN scaling parameter in Hamiltonian")
      return
   end if

   call get_kpair(self, child, error)
   if (allocated(error)) return

end subroutine load_from_toml


subroutine get_kpair(self, table, error)
   !> Instance of the parametrization data
   type(hamiltonian_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   character(len=:), allocatable :: key
   real(wp) :: tmp
   integer :: ir, jr

   call get_value(table, k_kpair, child)

   allocate(self%kpair(size(self%sym), size(self%sym)))
   self%kpair(:, :) = 1.0_wp

   do ir = 1, size(self%sym)
      do jr = 1, ir
         key = trim(self%sym(jr))//"-"//trim(self%sym(ir))
         if (.not.child%has_key(key)) key = trim(self%sym(ir))//"-"//trim(self%sym(jr))
         if (child%has_key(key)) then
            call get_value(child, key, tmp, 1.0_wp)
            self%kpair(jr, ir) = tmp
            self%kpair(ir, jr) = tmp
         end if
      end do
   end do

end subroutine get_kpair


subroutine get_ksh(self, table, error)
   !> Instance of the parametrization data
   type(hamiltonian_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   character(len=:), allocatable :: key
   real(wp), allocatable :: last, kav
   integer :: l, k, stat, lmax

   call get_value(table, k_shell, child, requested=.false.)
   if (associated(child)) then
      do l = 0, 4
         key = repeat(k_ang(l), 2)
         if (.not.child%has_key(key)) then
            if (allocated(last)) then
               self%ksh(l, l) = last
               cycle
            end if
            call fatal_error(error, "No entry for "//key//"-shell pair scaling parameter")
            exit
         end if
         call get_value(child, key, self%ksh(l, l), stat=stat)
         if (stat /= 0) then
            call fatal_error(error, "Cannot read "//key//"-shell pair scaling parameter")
            exit
         end if
         if (stat == 0) then
            last = self%ksh(l, l)
            lmax = l
         end if
      end do
      if (allocated(error)) return

      do l = 0, 4
         do k = 0, l-1
            key = k_ang(k)//k_ang(l)
            kav = 0.5_wp * (self%ksh(k, k) + self%ksh(l, l))
            call get_value(child, key, self%ksh(k, l), kav, stat=stat)
            if (stat /= 0) then
               call fatal_error(error, "Cannot read "//key//"-shell pair scaling parameter")
               exit
            end if
            self%ksh(l, k) = self%ksh(k, l)
         end do
      end do
   end if

   self%lmax = lmax

end subroutine get_ksh

!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(hamiltonian_record), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child, sub
   character(len=:), allocatable :: key
   integer :: l, k, ir, jr

   call add_table(table, k_xtb, child)
   call set_value(child, k_wexp, self%wexp)
   call set_value(child, k_kpol, self%kpol)
   call set_value(child, k_enscale, self%enscale)
   if (allocated(self%cn)) call set_value(child, k_cn, self%cn)
   call add_table(child, k_shell, sub)
   do l = 0, self%lmax
      call set_value(sub, repeat(k_ang(l), 2), self%ksh(l, l))
   end do
   do l = 0, self%lmax
      do k = 0, l-1
         if (abs(self%ksh(k, l) - (self%ksh(l, l) + self%ksh(k, k))/2) > epsilon(1.0_wp)) then
            call set_value(sub, k_ang(k)//k_ang(l), self%ksh(k, l))
         end if
      end do
   end do

   if (any(abs(self%kpair - 1.0_wp) > epsilon(1.0_wp))) then
      call add_table(child, k_kpair, sub)
      do ir = 1, size(self%sym)
         do jr = 1, ir
            if (abs(self%kpair(jr, ir) - 1.0_wp) > epsilon(1.0_wp)) then
               key = trim(self%sym(ir))//"-"//trim(self%sym(jr))
               call set_value(sub, key, self%kpair(jr, ir))
            end if
         end do
      end do
   end if
end subroutine dump_to_toml


!> Read parametrization data from parameter array
subroutine load_from_array(self, array, offset, base, mask, error)
   class(hamiltonian_record), intent(inout) :: self
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: offset
   type(hamiltonian_record), intent(in) :: base
   type(hamiltonian_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   select type(self)
   type is (hamiltonian_record)
      self = base
   end select

end subroutine load_from_array

!> Write parametrization data to parameter array
subroutine dump_to_array(self, array, offset, mask, error)
   class(hamiltonian_record), intent(in) :: self
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: offset
   type(hamiltonian_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

end subroutine dump_to_array

elemental function count_mask(mask) result(ncount)
   type(hamiltonian_mask), intent(in) :: mask
   integer :: ncount
   ncount = 0
end function count_mask


end module tblite_param_hamiltonian

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file tests/force.f90
!! Test of analytical forces against numerical
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-02-25

program main
use ddx_core
use ddx_operators
use ddx_solvers
use ddx
use ddx_legacy
implicit none

character(len=255) :: fname
type(ddx_type) :: ddx_data
type(ddx_error_type) :: ddx_error
type(ddx_state_type) :: state
real(dp), allocatable :: phi_cav(:), gradphi_cav(:, :), &
    & hessianphi_cav(:, :, :), psi(:, :), &
    & force(:, :), force_num(:, :), charges(:)
real(dp) :: tol, esolv1, esolv2, step=0.0001, relerr
integer :: isph, i
real(dp), external :: dnrm2
character(len=255) :: dummy_file_name = ''

! Read input file name
call get_command_argument(1, fname)
write(*, *) "Using provided file ", trim(fname), " as a config file"
call ddfromfile(fname, ddx_data, tol, charges, ddx_error)
call check_error(ddx_error)
call allocate_state(ddx_data % params, ddx_data % constants, state, ddx_error)
call check_error(ddx_error)

allocate(phi_cav(ddx_data % constants % ncav), gradphi_cav(3, ddx_data % constants % ncav), &
    & hessianphi_cav(3, 3, ddx_data % constants % ncav), &
    & psi(ddx_data % constants % nbasis, ddx_data % params % nsph), &
    & force(3, ddx_data % params % nsph), &
    & force_num(3, ddx_data % params % nsph))
call mkrhs(ddx_data % params, ddx_data % constants, ddx_data % workspace, 1, &
    & phi_cav, 1, gradphi_cav, 1, hessianphi_cav, psi, charges)
call ddsolve_legacy(ddx_data, state, phi_cav, -gradphi_cav, hessianphi_cav, psi, &
    & tol, esolv1, force, ddx_error)
call check_error(ddx_error)
call grad_phi_for_charges(ddx_data % params, ddx_data % constants, &
    & ddx_data % workspace, state, charges, force, ddx_error)
call check_error(ddx_error)

ddx_data % params % force = 0
do isph = 1, ddx_data % params % nsph
    do i = 1, 3
        ddx_data % params % csph(i, isph) = ddx_data % params % csph(i, isph) + step
        call test_solve(ddx_data, state, tol, esolv1, phi_cav, gradphi_cav, &
            & hessianphi_cav, psi, force, charges)
        ddx_data % params % csph(i, isph) = ddx_data % params % csph(i, isph) - two*step
        call test_solve(ddx_data, state, tol, esolv2, phi_cav, gradphi_cav, &
            & hessianphi_cav, psi, force, charges)
        ddx_data % params % csph(i, isph) = ddx_data % params % csph(i, isph) + step
        force_num(i, isph) = (esolv1-esolv2) / two / step
    end do
end do
relerr = dnrm2(3*ddx_data % params % nsph, force_num-force, 1) / &
    & dnrm2(3*ddx_data % params % nsph, force, 1)

write(6,'(2A60)') 'Analytical forces', 'Numerical forces'
do i = 1, ddx_data % params % nsph
  write(6,'(6E20.10)') force(1,i), force(2,i), force(3,i), force_num(1,i), &
      & force_num(2,i), force_num(3,i)
end do

deallocate(phi_cav, gradphi_cav, psi, force, force_num, charges)
call deallocate_state(state, ddx_error)
call deallocate_model(ddx_data, ddx_error)

write(*, *) "Rel.ddx_error of forces:", relerr
if (relerr .gt. 1d-5) stop 1
contains 

subroutine test_solve(ddx_data, state, tol, esolv, phi_cav, gradphi_cav, &
        & hessianphi_cav, psi, force, charges)
    type(ddx_type), intent(inout) :: ddx_data
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: charges(ddx_data % params % nsph)
    real(dp), intent(in) :: tol
    real(dp), intent(out) :: esolv, phi_cav(ddx_data % constants % ncav), &
        & gradphi_cav(3, ddx_data % constants % ncav), &
        & hessianphi_cav(3, 3, ddx_data % constants % ncav), &
        & psi(ddx_data % constants % nbasis, ddx_data % params % nsph), &
        & force(3, ddx_data % params % nsph)
    type(ddx_type) :: ddx_data2
    type(ddx_error_type) :: error2
    call allocate_model(ddx_data % params % nsph, ddx_data % params % csph(1, :), &
        & ddx_data % params % csph(2, :), ddx_data % params % csph(3, :), ddx_data % params % rsph, &
        & ddx_data % params % model, ddx_data % params % lmax, ddx_data % params % ngrid, 0, &
        & ddx_data % params % fmm, ddx_data % params % pm, ddx_data % params % pl, &
        & ddx_data % params % se, &
        & ddx_data % params % eta, ddx_data % params % eps, ddx_data % params % kappa, &
        & ddx_data % params % matvecmem, ddx_data % params % maxiter, &
        & ddx_data % params % jacobi_ndiis, &
        & ddx_data % params % nproc, dummy_file_name, ddx_data2, error2)
    call mkrhs(ddx_data2 % params, ddx_data2 % constants, ddx_data2 % workspace, &
        & 1, phi_cav, 1, gradphi_cav, 1, hessianphi_cav, psi, charges)
    call ddsolve_legacy(ddx_data2, state, phi_cav, -gradphi_cav, hessianphi_cav, psi, tol, esolv, &
        & force, error2)
    call check_error(error2)
    call deallocate_model(ddx_data2, error2)
end subroutine test_solve

end program main

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_write_cjson
   use mctc_env_accuracy, only : wp
   use mctc_io_constants, only : pi
   use mctc_io_convert, only : autoaa
   use mctc_io_math, only : matinv_3x3
   use mctc_io_structure, only : structure_type
   implicit none
   private

   public :: write_cjson


   interface json_value
      module procedure :: json_value_char
      module procedure :: json_value_int
      module procedure :: json_value_real
   end interface json_value

   interface json_array
      module procedure :: json_array_char_1
      module procedure :: json_array_int_1
      module procedure :: json_array_real_1
   end interface json_array

   character(len=*), parameter :: nl = new_line('a')

contains


subroutine write_cjson(mol, unit)
   type(structure_type), intent(in) :: mol
   integer, intent(in) :: unit

   write(unit, '(a)') json_string(mol, "  ")
end subroutine write_cjson

pure function json_string(mol, indent) result(string)
   type(structure_type), intent(in) :: mol
   character(len=*), intent(in), optional :: indent
   character(len=:), allocatable :: string

   real(wp), allocatable :: inv_lat(:, :)
   real(wp), allocatable :: abc(:, :)
   real(wp) :: cellpar(6)

   string = "{"
   if (present(indent)) string = string // nl // indent
   string = string // json_key("chemicalJson", indent) // json_value(1)

   if (allocated(mol%comment)) then
      string = string // ","
      if (present(indent)) string = string // nl // indent
      string = string // json_key("name", indent) // json_value(mol%comment)
   end if

   string = string // ","
   if (present(indent)) string = string // nl // indent
   string = string // json_key("atoms", indent) // "{"

   if (present(indent)) string = string // nl // repeat(indent, 2)
   string = string // json_key("elements", indent) // "{"
   if (present(indent)) string = string // nl // repeat(indent, 3)
   string = string // json_key("number", indent) // json_array(mol%num(mol%id), 3, indent)
   if (present(indent)) string = string // nl // repeat(indent, 2)
   string = string // "}"

   string = string // ","
   if (present(indent)) string = string // nl // repeat(indent, 2)
   string = string // json_key("coords", indent) // "{"
   if (present(indent)) string = string // nl // repeat(indent, 3)
   if (mol%info%cartesian) then
      string = string // json_key("3d", indent) // json_array([mol%xyz * autoaa], 3, indent)
   else
      inv_lat = matinv_3x3(mol%lattice)
      abc = matmul(inv_lat, mol%xyz)
      string = string // json_key("3dFractional", indent) // json_array([abc], 3, indent)
   end if
   if (present(indent)) string = string // nl // repeat(indent, 2)
   string = string // "}"

   if (present(indent)) string = string // nl // indent
   string = string // "}"

   string = string // ","
   if (present(indent)) string = string // nl // indent
   string = string // json_key("properties", indent) // "{"
   if (present(indent)) string = string // nl // repeat(indent, 2)
   string = string // json_key("totalCharge", indent) // json_value(nint(mol%charge))
   if (mol%uhf > 0) then
      string = string // ","
      if (present(indent)) string = string // nl // repeat(indent, 2)
      string = string // json_key("totalSpinMultiplicity", indent) // json_value(mol%uhf + 1)
   end if
   if (present(indent)) string = string // nl // indent
   string = string // "}"

   if (allocated(mol%bond)) then
      string = string // ","
      if (present(indent)) string = string // nl // indent
      string = string // json_key("bonds", indent) // "{"
      if (present(indent)) string = string // nl // repeat(indent, 2)
      string = string // json_key("connections", indent) // "{"
      if (present(indent)) string = string // nl // repeat(indent, 3)
      string = string // json_key("index", indent) // json_array([mol%bond(1:2, :) - 1], 3, indent)
      if (present(indent)) string = string // nl // repeat(indent, 2)
      string = string // "}"

      if (size(mol%bond, 1) > 2) then
         string = string // ","
         if (present(indent)) string = string // nl // repeat(indent, 2)
         string = string // json_key("order", indent) // json_array(mol%bond(3, :), 2, indent)
         if (present(indent)) string = string // nl // indent
      end if
      string = string // "}"
   end if

   if (any(mol%periodic)) then
      call dlat_to_cell(mol%lattice, cellpar)
      cellpar(1:3) = cellpar(1:3) * autoaa
      cellpar(4:6) = cellpar(4:6) * 180 / pi

      string = string // ","
      if (present(indent)) string = string // nl // indent
      string = string // json_key("unitCell", indent) // "{"
      if (present(indent)) string = string // nl // repeat(indent, 2)
      string = string // json_key("a", indent) // json_value(cellpar(1), "(es23.16)")
      string = string // ","
      if (present(indent)) string = string // nl // repeat(indent, 2)
      string = string // json_key("b", indent) // json_value(cellpar(2), "(es23.16)")
      string = string // ","
      if (present(indent)) string = string // nl // repeat(indent, 2)
      string = string // json_key("c", indent) // json_value(cellpar(3), "(es23.16)")
      string = string // ","
      if (present(indent)) string = string // nl // repeat(indent, 2)
      string = string // json_key("alpha", indent) // json_value(cellpar(4), "(es23.16)")
      string = string // ","
      if (present(indent)) string = string // nl // repeat(indent, 2)
      string = string // json_key("beta", indent) // json_value(cellpar(5), "(es23.16)")
      string = string // ","
      if (present(indent)) string = string // nl // repeat(indent, 2)
      string = string // json_key("gamma", indent) // json_value(cellpar(6), "(es23.16)")
      if (present(indent)) string = string // nl // indent
      string = string // "}"
   end if

   if (present(indent)) string = string // nl
   string = string // "}"
end function json_string

pure function json_array_int_1(array, depth, indent) result(string)
   integer, intent(in) :: array(:)
   integer, intent(in) :: depth
   character(len=*), intent(in), optional :: indent
   character(len=:), allocatable :: string

   integer :: i

   string = "["
   do i = 1, size(array)
      if (present(indent)) string = string // nl // repeat(indent, depth+1)
      string = string // json_value(array(i))
      if (i /= size(array)) string = string // ","
   end do
   if (present(indent)) string = string // nl // repeat(indent, depth)
   string = string // "]"
end function json_array_int_1

pure function json_array_real_1(array, depth, indent) result(string)
   real(wp), intent(in) :: array(:)
   integer, intent(in) :: depth
   character(len=*), intent(in), optional :: indent
   character(len=:), allocatable :: string

   integer :: i

   string = "["
   do i = 1, size(array)
      if (present(indent)) string = string // nl // repeat(indent, depth+1)
      string = string // json_value(array(i), '(es23.16)')
      if (i /= size(array)) string = string // ","
   end do
   if (present(indent)) string = string // nl // repeat(indent, depth)
   string = string // "]"
end function json_array_real_1

pure function json_array_char_1(array, depth, indent) result(string)
   character(len=*), intent(in) :: array(:)
   integer, intent(in) :: depth
   character(len=*), intent(in), optional :: indent
   character(len=:), allocatable :: string

   integer :: i

   string = "["
   do i = 1, size(array)
      if (present(indent)) string = string // nl // repeat(indent, depth+1)
      string = string // json_value(trim(array(i)))
      if (i /= size(array)) string = string // ","
   end do
   if (present(indent)) string = string // nl // repeat(indent, depth)
   string = string // "]"
end function json_array_char_1

pure function json_key(key, indent) result(string)
   character(len=*), intent(in) :: key
   character(len=*), intent(in), optional :: indent
   character(len=:), allocatable :: string

   if (present(indent)) then
      string = json_value(key) // ": "
   else
      string = json_value(key) // ":"
   end if
end function json_key

pure function json_value_char(val) result(string)
   character(len=*), intent(in) :: val
   character(len=:), allocatable :: string

   string = """" // val // """"
end function json_value_char

pure function json_value_real(val, format) result(str)
   real(wp), intent(in) :: val
   character(len=*), intent(in) :: format
   character(len=:), allocatable :: str

   character(len=128) :: buffer
   integer :: stat

   write(buffer, format, iostat=stat) val
   if (stat == 0) then
      str = trim(buffer)
   else
      str = """*"""
   end if
end function json_value_real

pure function json_value_int(val) result(string)
   integer, intent(in) :: val
   character(len=:), allocatable :: string
   integer, parameter :: buffer_len = range(val)+2
   character(len=buffer_len) :: buffer
   integer :: pos
   integer :: n
   character(len=1), parameter :: numbers(0:9) = &
      ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]

   if (val == 0) then
      string = numbers(0)
      return
   end if

   n = abs(val)
   buffer = ""

   pos = buffer_len + 1
   do while (n > 0)
      pos = pos - 1
      buffer(pos:pos) = numbers(mod(n, 10))
      n = n/10
   end do
   if (val < 0) then
      pos = pos - 1
      buffer(pos:pos) = '-'
   end if

   string = buffer(pos:)
end function json_value_int

!> Convert direct lattice to cell parameters
pure subroutine dlat_to_cell(lattice,cellpar)
   implicit none
   real(wp),intent(in)  :: lattice(3,3) !< direct lattice
   real(wp),intent(out) :: cellpar(6)   !< cell parameters

   associate( alen => cellpar(1), blen => cellpar(2), clen => cellpar(3), &
      &       alp  => cellpar(4), bet  => cellpar(5), gam  => cellpar(6) )

   alen = norm2(lattice(:,1))
   blen = norm2(lattice(:,2))
   clen = norm2(lattice(:,3))

   alp = acos(dot_product(lattice(:,2),lattice(:,3))/(blen*clen))
   bet = acos(dot_product(lattice(:,1),lattice(:,3))/(alen*clen))
   gam = acos(dot_product(lattice(:,1),lattice(:,2))/(alen*blen))

   end associate

end subroutine dlat_to_cell

end module mctc_io_write_cjson

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/xtb/h0.f90
!> Provides the effective core Hamiltonian for xTB.

!> Implementation of the effective core Hamiltonian used in the extended tight binding.
module tblite_xtb_h0
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_adjlist, only : adjacency_list
   use tblite_basis_type, only : basis_type
   use tblite_integral_multipole, only : multipole_cgto, multipole_grad_cgto, maxl, msao
   use tblite_scf_potential, only : potential_type
   use tblite_xtb_spec, only : tb_h0spec
   implicit none
   private

   public ::  new_hamiltonian
   public :: get_selfenergy, get_hamiltonian, get_occupation, get_hamiltonian_gradient


   type, public :: tb_hamiltonian
      !> Atomic level information
      real(wp), allocatable :: selfenergy(:, :)
      !> Coordination number dependence of the atomic levels
      real(wp), allocatable :: kcn(:, :)
      !> Electronegativity scaled coordination number dependence of the atomic levels
      real(wp), allocatable :: kcn_en(:, :)
      !> Charge dependence of the atomic levels
      real(wp), allocatable :: kq1(:, :)
      !> Charge dependence of the atomic levels
      real(wp), allocatable :: kq2(:, :)
      !> Enhancement factor to scale the Hamiltonian elements
      real(wp), allocatable :: hscale(:, :, :, :)
      !> Polynomial coefficients for distance dependent enhancement factor
      real(wp), allocatable :: shpoly(:, :)
      !> Atomic radius for polynomial enhancement
      real(wp), allocatable :: rad(:)
      !> Reference occupation numbers
      real(wp), allocatable :: refocc(:, :)
      !> Diatomic frame scaling of sigma bonding contribution
      real(wp), allocatable :: ksig(:, :)
      !> Diatomic frame scaling of pi bonding contribution
      real(wp), allocatable :: kpi(:, :)
      !> Diatomic frame scaling of delta bonding contribution
      real(wp), allocatable :: kdel(:, :)
   end type tb_hamiltonian


contains


!> Constructor for a new Hamiltonian object, consumes a Hamiltonian specification
subroutine new_hamiltonian(self, mol, bas, spec)
   type(tb_hamiltonian), intent(out) :: self
   type(structure_type), intent(in) :: mol
   type(basis_type), intent(in) :: bas
   class(tb_h0spec), intent(in) :: spec

   integer :: mshell

   mshell = maxval(bas%nsh_id)
   allocate(self%selfenergy(mshell, mol%nid), &
      & self%kcn(mshell, mol%nid), self%kcn_en(mshell, mol%nid), & 
      & self%kq1(mshell, mol%nid), self%kq2(mshell, mol%nid))
   call spec%get_selfenergy(mol, bas, self%selfenergy)
   call spec%get_cnshift(mol, bas, self%kcn)
   call spec%get_cnenshift(mol, bas, self%kcn_en)
   call spec%get_q1shift(mol, bas, self%kq1)
   call spec%get_q2shift(mol, bas, self%kq2)

   allocate(self%hscale(mshell, mshell, mol%nid, mol%nid))
   call spec%get_hscale(mol, bas, self%hscale)

   allocate(self%shpoly(mshell, mol%nid), self%rad(mol%nid))
   call spec%get_rad(mol, bas, self%rad)
   call spec%get_shpoly(mol, bas, self%shpoly)

   allocate(self%refocc(mshell, mol%nid))
   call spec%get_reference_occ(mol, bas, self%refocc)

   allocate(self%ksig(mol%nid, mol%nid), self%kpi(mol%nid, mol%nid), &
      & self%kdel(mol%nid, mol%nid))
   call spec%get_diat_scale(mol, bas, self%ksig, self%kpi, self%kdel)

end subroutine new_hamiltonian


subroutine get_selfenergy(h0, id, ish_at, nshell, cn, qat, selfenergy, dsedcn, dsedq)
   type(tb_hamiltonian), intent(in) :: h0
   integer, intent(in) :: id(:)
   integer, intent(in) :: ish_at(:)
   integer, intent(in) :: nshell(:)
   real(wp), intent(in), optional :: cn(:)
   real(wp), intent(in), optional :: qat(:)
   real(wp), intent(out) :: selfenergy(:)
   real(wp), intent(out), optional :: dsedcn(:)
   real(wp), intent(out), optional :: dsedq(:)

   integer :: iat, izp, ish, ii

   selfenergy(:) = 0.0_wp
   if (present(dsedcn)) dsedcn(:) = 0.0_wp
   if (present(dsedq)) dsedq(:) = 0.0_wp
   do iat = 1, size(id)
      izp = id(iat)
      ii = ish_at(iat)
      do ish = 1, nshell(izp)
         selfenergy(ii+ish) = h0%selfenergy(ish, izp)
      end do
   end do
   if (present(cn)) then
      if (present(dsedcn)) then
         do iat = 1, size(id)
            izp = id(iat)
            ii = ish_at(iat)
            do ish = 1, nshell(izp)
               selfenergy(ii+ish) = selfenergy(ii+ish) - h0%kcn(ish, izp) * cn(iat)
               dsedcn(ii+ish) = -h0%kcn(ish, izp)
            end do
         end do
      else
         do iat = 1, size(id)
            izp = id(iat)
            ii = ish_at(iat)
            do ish = 1, nshell(izp)
               selfenergy(ii+ish) = selfenergy(ii+ish) - h0%kcn(ish, izp) * cn(iat)
            end do
         end do
      end if
   end if
   if (present(qat)) then
      if (present(dsedq)) then
         do iat = 1, size(id)
            izp = id(iat)
            ii = ish_at(iat)
            do ish = 1, nshell(izp)
               selfenergy(ii+ish) = selfenergy(ii+ish) &
                  & - h0%kq1(ish, izp)*qat(iat) - h0%kq2(ish, izp)*qat(iat)**2
               dsedq(ii+ish) = -h0%kq1(ish, izp) - h0%kq2(ish, izp)*2*qat(iat)
            end do
         end do
      else
         do iat = 1, size(id)
            izp = id(iat)
            ii = ish_at(iat)
            do ish = 1, nshell(izp)
               selfenergy(ii+ish) = selfenergy(ii+ish) &
                  & - h0%kq1(ish, izp)*qat(iat) - h0%kq2(ish, izp)*qat(iat)**2
            end do
         end do
      end if
   end if

end subroutine get_selfenergy


subroutine get_hamiltonian(mol, trans, list, bas, h0, selfenergy, overlap, dpint, qpint, &
      & hamiltonian)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points within a given realspace cutoff
   real(wp), intent(in) :: trans(:, :)
   !> Neighbour list
   type(adjacency_list), intent(in) :: list
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Hamiltonian interaction data
   type(tb_hamiltonian), intent(in) :: h0
   !> Diagonal elememts of the Hamiltonian
   real(wp), intent(in) :: selfenergy(:)
   !> Overlap integral matrix
   real(wp), intent(out) :: overlap(:, :)
   !> Dipole moment integral matrix
   real(wp), intent(out) :: dpint(:, :, :)
   !> Quadrupole moment integral matrix
   real(wp), intent(out) :: qpint(:, :, :)
   !> Effective Hamiltonian
   real(wp), intent(out) :: hamiltonian(:, :)

   integer :: iat, jat, izp, jzp, itr, img, inl
   integer :: ish, jsh, is, js, ii, jj, iao, jao, nao, ij
   real(wp) :: rr, r2, vec(3), hij, shpoly, dtmpj(3), qtmpj(6)
   real(wp), allocatable :: stmp(:), dtmpi(:, :), qtmpi(:, :)

   overlap(:, :) = 0.0_wp
   dpint(:, :, :) = 0.0_wp
   qpint(:, :, :) = 0.0_wp
   hamiltonian(:, :) = 0.0_wp

   allocate(stmp(msao(bas%maxl)**2), dtmpi(3, msao(bas%maxl)**2), qtmpi(6, msao(bas%maxl)**2))

   !$omp parallel do schedule(runtime) default(none) &
   !$omp shared(mol, bas, trans, list, overlap, dpint, qpint, hamiltonian, h0, selfenergy) &
   !$omp private(iat, jat, izp, jzp, itr, is, js, ish, jsh, ii, jj, iao, jao, nao, ij) &
   !$omp private(r2, vec, stmp, dtmpi, qtmpi, dtmpj, qtmpj, hij, shpoly, rr, inl, img)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = bas%ish_at(iat)
      inl = list%inl(iat)
      do img = 1, list%nnl(iat)
         jat = list%nlat(img+inl)
         itr = list%nltr(img+inl)
         jzp = mol%id(jat)
         js = bas%ish_at(jat)
         vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
         r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         rr = sqrt(sqrt(r2) / (h0%rad(jzp) + h0%rad(izp)))
         do ish = 1, bas%nsh_id(izp)
            ii = bas%iao_sh(is+ish)
            do jsh = 1, bas%nsh_id(jzp)
               jj = bas%iao_sh(js+jsh)
               call multipole_cgto(bas%cgto(jsh, jzp), bas%cgto(ish, izp), &
                  & r2, vec, bas%intcut, stmp, dtmpi, qtmpi)

               shpoly = (1.0_wp + h0%shpoly(ish, izp)*rr) &
                  * (1.0_wp + h0%shpoly(jsh, jzp)*rr)

               hij = 0.5_wp * (selfenergy(is+ish) + selfenergy(js+jsh)) &
                  * h0%hscale(jsh, ish, jzp, izp) * shpoly

               nao = msao(bas%cgto(jsh, jzp)%ang)
               do iao = 1, msao(bas%cgto(ish, izp)%ang)
                  do jao = 1, nao
                     ij = jao + nao*(iao-1)
                     call shift_operator(vec, stmp(ij), dtmpi(:, ij), qtmpi(:, ij), &
                        & dtmpj, qtmpj)
                     overlap(jj+jao, ii+iao) = overlap(jj+jao, ii+iao) &
                        + stmp(ij)

                     dpint(:, jj+jao, ii+iao) = dpint(:, jj+jao, ii+iao) &
                        + dtmpi(:, ij)

                     qpint(:, jj+jao, ii+iao) = qpint(:, jj+jao, ii+iao) &
                        + qtmpi(:, ij)

                     hamiltonian(jj+jao, ii+iao) = hamiltonian(jj+jao, ii+iao) &
                        + stmp(ij) * hij

                     if (iat /= jat) then
                        overlap(ii+iao, jj+jao) = overlap(ii+iao, jj+jao) &
                           + stmp(ij)

                        dpint(:, ii+iao, jj+jao) = dpint(:, ii+iao, jj+jao) &
                           + dtmpj

                        qpint(:, ii+iao, jj+jao) = qpint(:, ii+iao, jj+jao) &
                           + qtmpj

                        hamiltonian(ii+iao, jj+jao) = hamiltonian(ii+iao, jj+jao) &
                           + stmp(ij) * hij
                     end if
                  end do
               end do

            end do
         end do

      end do
   end do

   !$omp parallel do schedule(runtime) default(none) &
   !$omp shared(mol, bas, overlap, dpint, qpint, hamiltonian, h0, selfenergy) &
   !$omp private(iat, izp, is, ish, jsh, ii, jj, iao, jao, nao, ij) &
   !$omp private(vec, stmp, dtmpi, qtmpi, hij)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = bas%ish_at(iat)
      vec(:) = 0.0_wp
      do ish = 1, bas%nsh_id(izp)
         ii = bas%iao_sh(is+ish)
         do jsh = 1, bas%nsh_id(izp)
            jj = bas%iao_sh(is+jsh)
            call multipole_cgto(bas%cgto(jsh, izp), bas%cgto(ish, izp), &
               & 0.0_wp, vec, bas%intcut, stmp, dtmpi, qtmpi)

            ! shpoly is always 1.0, because rr is always 0.0
            hij = 0.5_wp * (selfenergy(is+ish) + selfenergy(is+jsh))

            nao = msao(bas%cgto(jsh, izp)%ang)
            do iao = 1, msao(bas%cgto(ish, izp)%ang)
               do jao = 1, nao
                  ij = jao + nao*(iao-1)
                  overlap(jj+jao, ii+iao) = overlap(jj+jao, ii+iao) &
                     + stmp(ij)

                  dpint(:, jj+jao, ii+iao) = dpint(:, jj+jao, ii+iao) &
                     + dtmpi(:, ij)

                  qpint(:, jj+jao, ii+iao) = qpint(:, jj+jao, ii+iao) &
                     + qtmpi(:, ij)

                  hamiltonian(jj+jao, ii+iao) = hamiltonian(jj+jao, ii+iao) &
                     + stmp(ij) * hij
               end do
            end do

         end do
      end do
   end do

end subroutine get_hamiltonian


subroutine get_hamiltonian_gradient(mol, trans, list, bas, h0, selfenergy, dsedcn, &
      & pot, pmat, xmat, dEdcn, gradient, sigma)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points within a given realspace cutoff
   real(wp), intent(in) :: trans(:, :)
   !> Neighbour list
   type(adjacency_list), intent(in) :: list
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Hamiltonian interaction data
   type(tb_hamiltonian), intent(in) :: h0
   !> Diagonal elememts of the Hamiltonian
   real(wp), intent(in) :: selfenergy(:)
   !> Derivative of the diagonal elements of the Hamiltonian w.r.t. the coordination number
   real(wp), intent(in) :: dsedcn(:)
   !> Density dependent potential shifts on the Hamiltonian
   type(potential_type), intent(in) :: pot
   !> Density matrix
   real(wp), intent(in) :: pmat(:, :, :)
   !> Energy weighted density matrix
   real(wp), intent(in) :: xmat(:, :, :)

   !> Derivative of the electronic energy w.r.t. the coordination number
   real(wp), intent(inout) :: dEdcn(:)
   !> Derivative of the electronic energy w.r.t. coordinate displacements
   real(wp), intent(inout) :: gradient(:, :)
   !> Derivative of the electronic energy w.r.t. strain deformations
   real(wp), intent(inout) :: sigma(:, :)

   integer :: iat, jat, izp, jzp, itr, img, inl, spin, nspin
   integer :: ish, jsh, is, js, ii, jj, iao, jao, nao, ij
   real(wp) :: rr, r2, vec(3), hij, dG(3), hscale, hs
   real(wp) :: shpolyi, shpolyj, shpoly, dshpoly, dsv(3)
   real(wp) :: sval, dcni, dcnj, dhdcni, dhdcnj, hpij, pij
   real(wp), allocatable :: stmp(:), dtmp(:, :), qtmp(:, :)
   real(wp), allocatable :: dstmp(:, :), ddtmpi(:, :, :), dqtmpi(:, :, :)
   real(wp), allocatable :: ddtmpj(:, :, :), dqtmpj(:, :, :)

   nspin = size(pmat, 3)

   allocate(stmp(msao(bas%maxl)**2), dstmp(3, msao(bas%maxl)**2), &
      & dtmp(3, msao(bas%maxl)**2), ddtmpi(3, 3, msao(bas%maxl)**2), &
      & qtmp(6, msao(bas%maxl)**2), dqtmpi(3, 6, msao(bas%maxl)**2), &
      & ddtmpj(3, 3, msao(bas%maxl)**2), dqtmpj(3, 6, msao(bas%maxl)**2))

   !$omp parallel do schedule(runtime) default(none) reduction(+:dEdcn, gradient, sigma) &
   !$omp shared(mol, bas, trans, h0, selfenergy, dsedcn, pot, pmat, xmat, list, nspin) &
   !$omp private(iat, jat, izp, jzp, itr, is, js, ish, jsh, ii, jj, iao, jao, nao, ij, spin, &
   !$omp& r2, vec, stmp, dtmp, qtmp, dstmp, ddtmpi, dqtmpi, ddtmpj, dqtmpj, hij, &
   !$omp& dG, dcni, dcnj, dhdcni, dhdcnj, hpij, rr, sval, hscale, pij, inl, img, &
   !$omp& hs, shpolyi, shpolyj, shpoly, dshpoly, dsv)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = bas%ish_at(iat)
      inl = list%inl(iat)
      do img = 1, list%nnl(iat)
         jat = list%nlat(img+inl)
         itr = list%nltr(img+inl)
         jzp = mol%id(jat)
         js = bas%ish_at(jat)
         vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
         r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         if (r2 <= epsilon(1.0_wp)) cycle
         rr = sqrt(sqrt(r2) / (h0%rad(jzp) + h0%rad(izp)))
         do ish = 1, bas%nsh_id(izp)
            ii = bas%iao_sh(is+ish)
            do jsh = 1, bas%nsh_id(jzp)
               jj = bas%iao_sh(js+jsh)
               call multipole_grad_cgto(bas%cgto(jsh, jzp), bas%cgto(ish, izp), &
                  & r2, vec, bas%intcut, stmp, dtmp, qtmp, dstmp, ddtmpj, dqtmpj, &
                  & ddtmpi, dqtmpi)
               
               shpolyi = 1.0_wp + h0%shpoly(ish, izp)*rr
               shpolyj = 1.0_wp + h0%shpoly(jsh, jzp)*rr
               shpoly = shpolyi * shpolyj
               dshpoly = (shpolyi * h0%shpoly(jsh, jzp) + shpolyj * &
                  & h0%shpoly(ish, izp)) * 0.5_wp * rr / r2
               dsv(:) = dshpoly / shpoly * vec

               hscale = h0%hscale(jsh, ish, jzp, izp)
               hs = hscale * shpoly
               hij = 0.5_wp * (selfenergy(is+ish) + selfenergy(js+jsh)) * hs 

               dhdcni = dsedcn(is+ish) * hs
               dhdcnj = dsedcn(js+jsh) * hs

               dG(:) = 0.0_wp
               dcni = 0.0_wp
               dcnj = 0.0_wp
               nao = msao(bas%cgto(jsh, jzp)%ang)
               do iao = 1, msao(bas%cgto(ish, izp)%ang)
                  do jao = 1, nao
                     ij = jao + nao*(iao-1)
                     do spin = 1, nspin
                        pij = pmat(jj+jao, ii+iao, spin)
                        sval = - pij * (pot%vao(jj+jao, spin) + pot%vao(ii+iao, spin))

                        dG(:) = dG + sval * dstmp(:, ij)  
                     end do
                     pij = pmat(jj+jao, ii+iao, 1)
                     hpij = pij * hij 
                     sval = 2*hpij - 2*xmat(jj+jao, ii+iao, 1)

                     dG(:) = dG + sval * dstmp(:, ij) &
                        + 2*hpij*stmp(ij) * dsv &
                        - pij * matmul(ddtmpi(:, :, ij), pot%vdp(:, iat, 1)) &
                        - pij * matmul(ddtmpj(:, :, ij), pot%vdp(:, jat, 1)) &
                        - pij * matmul(dqtmpi(:, :, ij), pot%vqp(:, iat, 1)) &
                        - pij * matmul(dqtmpj(:, :, ij), pot%vqp(:, jat, 1))

                     dcni = dcni + dhdcni * pmat(jj+jao, ii+iao, 1) * stmp(ij)
                     dcnj = dcnj + dhdcnj * pmat(jj+jao, ii+iao, 1) * stmp(ij)
                  end do
               end do
               if (iat == jat) then
                  dEdcn(iat) = dEdcn(iat) + 0.5_wp * (dcni + dcnj)
               else
                  dEdcn(iat) = dEdcn(iat) + dcni
                  dEdcn(jat) = dEdcn(jat) + dcnj
               end if
               gradient(:, iat) = gradient(:, iat) + dG
               gradient(:, jat) = gradient(:, jat) - dG
               if (iat == jat) then
                  sigma(:, :) = sigma + 0.25_wp * (spread(vec, 1, 3) &
                     & * spread(dG, 2, 3) + spread(dG, 1, 3) * spread(vec, 2, 3))
               else
                  sigma(:, :) = sigma + 0.5_wp * (spread(vec, 1, 3) &
                     & * spread(dG, 2, 3) + spread(dG, 1, 3) * spread(vec, 2, 3))
               end if

            end do
         end do

      end do
   end do

   !$omp parallel do schedule(runtime) default(none) reduction(+:dEdcn) &
   !$omp shared(mol, bas, dsedcn, pmat, nspin) &
   !$omp private(iat, izp, jzp, is, ish, ii, iao, dcni, dhdcni, spin)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = bas%ish_at(iat)
      do ish = 1, bas%nsh_id(izp)
         ii = bas%iao_sh(is+ish)
         dhdcni = dsedcn(is+ish)
         dcni = 0.0_wp
         do iao = 1, msao(bas%cgto(ish, izp)%ang)
            dcni = dcni + dhdcni * pmat(ii+iao, ii+iao, 1)
         end do
         dEdcn(iat) = dEdcn(iat) + dcni
      end do
   end do

end subroutine get_hamiltonian_gradient


subroutine get_occupation(mol, bas, h0, nocc, n0at, n0sh)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Hamiltonian interaction data
   type(tb_hamiltonian), intent(in) :: h0
   !> Occupation number
   real(wp), intent(out) :: nocc
   !> Reference occupation for each atom
   real(wp), intent(out) :: n0at(:)
   !> Reference occupation for each shell
   real(wp), intent(out) :: n0sh(:)

   integer :: iat, ish, izp, ii

   nocc = -mol%charge
   n0at(:) = 0.0_wp
   n0sh(:) = 0.0_wp
   do iat = 1, mol%nat
      izp = mol%id(iat)
      ii = bas%ish_at(iat)
      do ish = 1, bas%nsh_id(izp)
         nocc = nocc + h0%refocc(ish, izp)
         n0at(iat) = n0at(iat) + h0%refocc(ish, izp)
         n0sh(ii+ish) = n0sh(ii+ish) + h0%refocc(ish, izp)
      end do
   end do

end subroutine get_occupation


!> Shift multipole operator from Ket function (center i) to Bra function (center j),
!> the multipole operator on the Bra function can be assembled from the lower moments
!> on the Ket function and the displacement vector using horizontal shift rules.
pure subroutine shift_operator(vec, s, di, qi, dj, qj)
   !> Displacement vector of center i and j
   real(wp),intent(in) :: vec(:)
   !> Overlap integral between basis functions
   real(wp),intent(in) :: s
   !> Dipole integral with operator on Ket function (center i)
   real(wp),intent(in) :: di(:)
   !> Quadrupole integral with operator on Ket function (center i)
   real(wp),intent(in) :: qi(:)
   !> Dipole integral with operator on Bra function (center j)
   real(wp),intent(out) :: dj(:)
   !> Quadrupole integral with operator on Bra function (center j)
   real(wp),intent(out) :: qj(:)

   real(wp) :: tr

   ! Create dipole operator on Bra function from Ket function and shift contribution
   ! due to monopol displacement
   dj(1) = di(1) + vec(1)*s
   dj(2) = di(2) + vec(2)*s
   dj(3) = di(3) + vec(3)*s

   ! For the quadrupole operator on the Bra function we first construct the shift
   ! contribution from the dipole and monopol displacement, since we have to remove
   ! the trace contribution from the shift and the moment integral on the Ket function
   ! is already traceless
   qj(1) = 2*vec(1)*di(1) + vec(1)**2*s
   qj(3) = 2*vec(2)*di(2) + vec(2)**2*s
   qj(6) = 2*vec(3)*di(3) + vec(3)**2*s
   qj(2) = vec(1)*di(2) + vec(2)*di(1) + vec(1)*vec(2)*s
   qj(4) = vec(1)*di(3) + vec(3)*di(1) + vec(1)*vec(3)*s
   qj(5) = vec(2)*di(3) + vec(3)*di(2) + vec(2)*vec(3)*s
   ! Now collect the trace of the shift contribution
   tr = 0.5_wp * (qj(1) + qj(3) + qj(6))

   ! Finally, assemble the quadrupole operator on the Bra function from the operator
   ! on the Ket function and the traceless shift contribution
   qj(1) = qi(1) + 1.5_wp * qj(1) - tr
   qj(2) = qi(2) + 1.5_wp * qj(2)
   qj(3) = qi(3) + 1.5_wp * qj(3) - tr
   qj(4) = qi(4) + 1.5_wp * qj(4)
   qj(5) = qi(5) + 1.5_wp * qj(5)
   qj(6) = qi(6) + 1.5_wp * qj(6) - tr
end subroutine shift_operator


end module tblite_xtb_h0

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3_utils
   use mctc_env, only : wp
   use mctc_io_math, only : matinv_3x3
   implicit none

   public :: wrap_to_central_cell


contains


subroutine wrap_to_central_cell(xyz, lattice, periodic)
   real(wp), intent(inout) :: xyz(:, :)
   real(wp), intent(in) :: lattice(:, :)
   logical, intent(in) :: periodic(:)
   real(wp) :: invlat(3, 3), vec(3)
   integer :: iat, idir

   if (.not.any(periodic)) return

   invlat = matinv_3x3(lattice)
   do iat = 1, size(xyz, 2)
      vec(:) = matmul(invlat, xyz(:, iat))
      vec(:) = shift_back_abc(vec)
      xyz(:, iat) = matmul(lattice, vec)
   end do

end subroutine wrap_to_central_cell


elemental function shift_back_abc(in) result(out)
   !> fractional coordinate in (-∞,+∞)
   real(wp),intent(in) :: in
   !> fractional coordinate in [0,1)
   real(wp) :: out
   real(wp),parameter :: p_pbc_eps = 1.0e-14_wp
   out = in
   if(in < (0.0_wp - p_pbc_eps)) &
      out = in + real(ceiling(-in),wp)
   if(in > (1.0_wp + p_pbc_eps)) &
      out = in - real(floor  ( in),wp)
   if (abs(in - 1.0_wp) < p_pbc_eps) &
      out = in - 1.0_wp
end function shift_back_abc


end module dftd3_utils

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_repulsion
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type
   use mstore, only : get_structure
   use tblite_container_cache, only : container_cache
   use tblite_repulsion, only : tb_repulsion, new_repulsion
   implicit none
   private

   public :: collect_repulsion

   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

   abstract interface
      subroutine repulsion_maker(rep, mol)
         import :: tb_repulsion, structure_type
         type(tb_repulsion), intent(out) :: rep
         type(structure_type), intent(in) :: mol
      end subroutine repulsion_maker
   end interface

contains


!> Collect all exported unit tests
subroutine collect_repulsion(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("energy-1", test_e_effective_m01), &
      new_unittest("energy-2", test_e_effective_m02), &
      new_unittest("energy-pbc", test_e_effective_uracil), &
      new_unittest("gradient-1", test_g_effective_m03), &
      new_unittest("gradient-2", test_g_effective_m04), &
      new_unittest("gradient-pbc", test_g_effective_urea), &
      new_unittest("sigma-1", test_s_effective_m05), &
      new_unittest("sigma-2", test_s_effective_m06), &
      new_unittest("sigma-pbc", test_s_effective_succinic) &
      ]

end subroutine collect_repulsion


!> Factory to create repulsion objects based on GFN1-xTB
subroutine make_repulsion1(rep, mol)
   type(tb_repulsion), intent(out) :: rep
   type(structure_type), intent(in) :: mol

   real(wp), parameter :: alpha_gfn1(1:20) = [&
      & 2.209700_wp, 1.382907_wp, 0.671797_wp, 0.865377_wp, 1.093544_wp, &
      & 1.281954_wp, 1.727773_wp, 2.004253_wp, 2.507078_wp, 3.038727_wp, &
      & 0.704472_wp, 0.862629_wp, 0.929219_wp, 0.948165_wp, 1.067197_wp, &
      & 1.200803_wp, 1.404155_wp, 1.323756_wp, 0.581529_wp, 0.665588_wp]
   real(wp), parameter :: zeff_gfn1(1:20) = [&
      &  1.116244_wp,  0.440231_wp,  2.747587_wp,  4.076830_wp,  4.458376_wp, &
      &  4.428763_wp,  5.498808_wp,  5.171786_wp,  6.931741_wp,  9.102523_wp, &
      & 10.591259_wp, 15.238107_wp, 16.283595_wp, 16.898359_wp, 15.249559_wp, &
      & 15.100323_wp, 17.000000_wp, 17.153132_wp, 20.831436_wp, 19.840212_wp]
   real(wp), allocatable :: alpha(:), zeff(:), kexp

   alpha = alpha_gfn1(mol%num)
   zeff = zeff_gfn1(mol%num)
   kexp = 1.5_wp
   call new_repulsion(rep, mol, alpha, zeff, 1.5_wp, kexp, 1.0_wp)

end subroutine make_repulsion1

!> Factory to create repulsion objects based on GFN2-xTB
subroutine make_repulsion2(rep, mol)
   type(tb_repulsion), intent(out) :: rep
   type(structure_type), intent(in) :: mol

   real(wp), parameter :: alpha_gfn2(1:20) = [&
      & 2.213717_wp, 3.604670_wp, 0.475307_wp, 0.939696_wp, 1.373856_wp, &
      & 1.247655_wp, 1.682689_wp, 2.165712_wp, 2.421394_wp, 3.318479_wp, &
      & 0.572728_wp, 0.917975_wp, 0.876623_wp, 1.187323_wp, 1.143343_wp, &
      & 1.214553_wp, 1.577144_wp, 0.896198_wp, 0.482206_wp, 0.683051_wp]
   real(wp), parameter :: zeff_gfn2(1:20) = [&
      &  1.105388_wp,  1.094283_wp,  1.289367_wp,  4.221216_wp,  7.192431_wp, &
      &  4.231078_wp,  5.242592_wp,  5.784415_wp,  7.021486_wp, 11.041068_wp, &
      &  5.244917_wp, 18.083164_wp, 17.867328_wp, 40.001111_wp, 19.683502_wp, &
      & 14.995090_wp, 17.353134_wp,  7.266606_wp, 10.439482_wp, 14.786701_wp]
   real(wp), allocatable :: alpha(:), zeff(:), kexp

   alpha = alpha_gfn2(mol%num)
   zeff = zeff_gfn2(mol%num)
   kexp = 1.0_wp
   call new_repulsion(rep, mol, alpha, zeff, 1.5_wp, kexp, 1.0_wp)

end subroutine make_repulsion2


subroutine test_generic(error, mol, make_repulsion, ref)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Factory to produce repulsion objects
   procedure(repulsion_maker) :: make_repulsion

   !> Reference value to compare against
   real(wp), intent(in) :: ref

   type(tb_repulsion) :: rep
   type(container_cache) :: cache
   real(wp) :: energy(mol%nat), sigma(3, 3)
   real(wp), allocatable :: gradient(:, :), numgrad(:, :)
   real(wp), parameter :: step = 1.0e-6_wp

   allocate(gradient(3, mol%nat), numgrad(3, mol%nat))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   call make_repulsion(rep, mol)
   call rep%get_engrad(mol, cache, energy)

   call check(error, sum(energy), ref, thr=thr)
   if (allocated(error)) then
      print*,sum(energy)
   end if

end subroutine test_generic


subroutine test_numgrad(error, mol, make_repulsion)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Factory to create a repulsion object
   procedure(repulsion_maker) :: make_repulsion

   integer :: iat, ic
   type(tb_repulsion) :: rep
   type(container_cache) :: cache
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat), sigma(3, 3)
   real(wp), allocatable :: gradient(:, :), numgrad(:, :)
   real(wp), parameter :: step = 1.0e-6_wp

   allocate(gradient(3, mol%nat), numgrad(3, mol%nat))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   call make_repulsion(rep, mol)

   do iat = 1, mol%nat
      do ic = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call rep%get_engrad(mol, cache, er)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2*step
         call rep%get_engrad(mol, cache, el)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         numgrad(ic, iat) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   call rep%get_engrad(mol, cache, energy, gradient, sigma)

   if (any(abs(gradient - numgrad) > thr2)) then
      call test_failed(error, "Gradient of dispersion energy does not match")
      print'(3es21.14)', gradient-numgrad
   end if

end subroutine test_numgrad


subroutine test_numsigma(error, mol, make_repulsion)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Factory to create a repulsion object
   procedure(repulsion_maker) :: make_repulsion

   integer :: ic, jc
   type(tb_repulsion) :: rep
   type(container_cache) :: cache
   real(wp) :: energy(mol%nat), er(mol%nat), el(mol%nat), sigma(3, 3), eps(3, 3), numsigma(3, 3)
   real(wp), allocatable :: gradient(:, :), xyz(:, :), lat(:, :)
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], shape(unity))
   real(wp), parameter :: step = 1.0e-6_wp

   allocate(gradient(3, mol%nat), xyz(3, mol%nat), lat(3, 3))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   call make_repulsion(rep, mol)

   eps(:, :) = unity
   xyz(:, :) = mol%xyz
   if (any(mol%periodic)) &
   lat(:, :) = mol%lattice
   do ic = 1, 3
      do jc = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = matmul(eps, xyz)
         if (any(mol%periodic)) &
         mol%lattice(:, :) = matmul(eps, lat)
         call rep%get_engrad(mol, cache, er)
         eps(jc, ic) = eps(jc, ic) - 2*step
         mol%xyz(:, :) = matmul(eps, xyz)
         if (any(mol%periodic)) &
         mol%lattice(:, :) = matmul(eps, lat)
         call rep%get_engrad(mol, cache, el)
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = xyz
         if (any(mol%periodic)) &
         mol%lattice(:, :) = lat
         numsigma(jc, ic) = 0.5_wp*(sum(er) - sum(el))/step
      end do
   end do

   call rep%get_engrad(mol, cache, energy, gradient, sigma)

   if (any(abs(sigma - numsigma) > thr2)) then
      call test_failed(error, "Strain derivatives do not match")
      print'(3es21.14)', sigma-numsigma
   end if

end subroutine test_numsigma


subroutine test_e_effective_m01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "01")
   call test_generic(error, mol, make_repulsion1, 0.16777923624986593_wp)

end subroutine test_e_effective_m01


subroutine test_e_effective_m02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "02")
   call test_generic(error, mol, make_repulsion2, 0.10745931926703985_wp)

end subroutine test_e_effective_m02


subroutine test_e_effective_uracil(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "X23", "uracil")
   call test_generic(error, mol, make_repulsion2, 1.0401472262740301_wp)

end subroutine test_e_effective_uracil


subroutine test_g_effective_m03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "03")
   call test_numgrad(error, mol, make_repulsion1)

end subroutine test_g_effective_m03


subroutine test_g_effective_m04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "04")
   call test_numgrad(error, mol, make_repulsion2)

end subroutine test_g_effective_m04


subroutine test_g_effective_urea(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "X23", "urea")
   call test_numgrad(error, mol, make_repulsion2)

end subroutine test_g_effective_urea


subroutine test_s_effective_m05(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "05")
   call test_numsigma(error, mol, make_repulsion1)

end subroutine test_s_effective_m05


subroutine test_s_effective_m06(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "MB16-43", "06")
   call test_numsigma(error, mol, make_repulsion2)

end subroutine test_s_effective_m06


subroutine test_s_effective_succinic(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol

   call get_structure(mol, "X23", "succinic")
   call test_numsigma(error, mol, make_repulsion2)

end subroutine test_s_effective_succinic


end module test_repulsion

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Implementation of a terminal to provide ANSI escape sequences
!>
!> ANSI escape codes for producing terminal colors. The `ansi_code` derived
!> type is used to store ANSI escape codes and can be combined with other
!> codes or applied to strings by concatenation. The default or uninitialized
!> `ansi_code` is a stub and does not produce escape sequences when applied
!> to a string.
!>
!> Available colors are
!>
!> color          | foreground            | background
!> -------------- | --------------------- | ------------------------
!> black          | `black` (30)          | `bg_black` (40)
!> red            | `red` (31)            | `bg_red` (41)
!> green          | `green` (32)          | `bg_green` (42)
!> yellow         | `yellow` (33)         | `bg_yellow` (43)
!> blue           | `blue` (34)           | `bg_blue` (44)
!> magenta        | `magenta` (35)        | `bg_magenta` (45)
!> cyan           | `cyan` (36)           | `bg_cyan` (46)
!> white          | `white` (37)          | `bg_white` (47)
!> gray           | `gray` (90)           | `bg_gray` (100)
!> bright red     | `bright_red` (91)     | `bg_bright_red` (101)
!> bright green   | `bright_green` (92)   | `bg_bright_green` (102)
!> bright yellow  | `bright_yellow` (93)  | `bg_bright_yellow` (103)
!> bright blue    | `bright_blue` (94)    | `bg_bright_blue` (104)
!> bright magenta | `bright_magenta` (95) | `bg_bright_magenta` (105)
!> bright cyan    | `bright_cyan` (96)    | `bg_bright_cyan` (106)
!> bright white   | `bright_white` (97)   | `bg_bright_white` (107)
!>
!> Available styles are
!>
!> style       |
!> ------------| ---------------
!> reset       | `reset` (0)
!> bold        | `bold` (1)
!> dim         | `dim` (2)
!> italic      | `italic` (3)
!> underline   | `underline` (4)
!> blink       | `blink` (5)
!> blink rapid | `blink_rapid` (6)
!> reverse     | `reverse` (7)
!> hidden      | `hidden` (8)
!> crossed     | `crossed` (9)
module tomlf_terminal
   use tomlf_utils, only : to_string
   implicit none
   private

   public :: toml_terminal
   public :: ansi_code, escape, operator(+), operator(//)


   !> Char length for integers
   integer, parameter :: i1 = selected_int_kind(2)

   !> Container for terminal escape code
   type :: ansi_code
      private
      !> Style descriptor
      integer(i1) :: style = -1_i1
      !> Background color descriptor
      integer(i1) :: bg = -1_i1
      !> Foreground color descriptor
      integer(i1) :: fg = -1_i1
   end type

   interface operator(+)
      module procedure :: add
   end interface operator(+)

   interface operator(//)
      module procedure :: concat_left
      module procedure :: concat_right
   end interface operator(//)

   interface escape
      module procedure :: escape
   end interface escape

   type(ansi_code), public, parameter :: &
      reset = ansi_code(style=0_i1), &
      bold = ansi_code(style=1_i1), &
      dim = ansi_code(style=2_i1), &
      italic = ansi_code(style=3_i1), &
      underline = ansi_code(style=4_i1), &
      blink = ansi_code(style=5_i1), &
      blink_rapid = ansi_code(style=6_i1), &
      reverse = ansi_code(style=7_i1), &
      hidden = ansi_code(style=8_i1), &
      crossed = ansi_code(style=9_i1)

   type(ansi_code), public, parameter :: &
      black = ansi_code(fg=30_i1), &
      red = ansi_code(fg=31_i1), &
      green = ansi_code(fg=32_i1), &
      yellow = ansi_code(fg=33_i1), &
      blue = ansi_code(fg=34_i1), &
      magenta = ansi_code(fg=35_i1), &
      cyan = ansi_code(fg=36_i1), &
      white = ansi_code(fg=37_i1), &
      gray = ansi_code(fg=90_i1), &
      bright_red = ansi_code(fg=91_i1), &
      bright_green = ansi_code(fg=92_i1), &
      bright_yellow = ansi_code(fg=93_i1), &
      bright_blue = ansi_code(fg=94_i1), &
      bright_magenta = ansi_code(fg=95_i1), &
      bright_cyan = ansi_code(fg=96_i1), &
      bright_white = ansi_code(fg=97_i1)

   type(ansi_code), public, parameter :: &
      bg_black = ansi_code(bg=40_i1), &
      bg_red = ansi_code(bg=41_i1), &
      bg_green = ansi_code(bg=42_i1), &
      bg_yellow = ansi_code(bg=43_i1), &
      bg_blue = ansi_code(bg=44_i1), &
      bg_magenta = ansi_code(bg=45_i1), &
      bg_cyan = ansi_code(bg=46_i1), &
      bg_white = ansi_code(bg=47_i1), &
      bg_gray = ansi_code(bg=100_i1), &
      bg_bright_red = ansi_code(bg=101_i1), &
      bg_bright_green = ansi_code(bg=102_i1), &
      bg_bright_yellow = ansi_code(bg=103_i1), &
      bg_bright_blue = ansi_code(bg=104_i1), &
      bg_bright_magenta = ansi_code(bg=105_i1), &
      bg_bright_cyan = ansi_code(bg=106_i1), &
      bg_bright_white = ansi_code(bg=107_i1)


   !> Terminal wrapper to handle color escape sequences, must be initialized with
   !> color support to provide colorful output. Default and uninitialized instances
   !> will remain usable but provide only stubs and do not produce colorful output.
   !> This behavior is useful for creating applications which can toggle color support.
   type :: toml_terminal
      type(ansi_code) :: &
         reset = ansi_code(), &
         bold = ansi_code(), &
         dim = ansi_code(), &
         italic = ansi_code(), &
         underline = ansi_code(), &
         blink = ansi_code(), &
         blink_rapid = ansi_code(), &
         reverse = ansi_code(), &
         hidden = ansi_code(), &
         crossed = ansi_code()

      type(ansi_code) :: &
         black = ansi_code(), &
         red = ansi_code(), &
         green = ansi_code(), &
         yellow = ansi_code(), &
         blue = ansi_code(), &
         magenta = ansi_code(), &
         cyan = ansi_code(), &
         white = ansi_code(), &
         gray = ansi_code(), &
         bright_red = ansi_code(), &
         bright_green = ansi_code(), &
         bright_yellow = ansi_code(), &
         bright_blue = ansi_code(), &
         bright_magenta = ansi_code(), &
         bright_cyan = ansi_code(), &
         bright_white = ansi_code()

      type(ansi_code) :: &
         bg_black = ansi_code(), &
         bg_red = ansi_code(), &
         bg_green = ansi_code(), &
         bg_yellow = ansi_code(), &
         bg_blue = ansi_code(), &
         bg_magenta = ansi_code(), &
         bg_cyan = ansi_code(), &
         bg_white = ansi_code(), &
         bg_gray = ansi_code(), &
         bg_bright_red = ansi_code(), &
         bg_bright_green = ansi_code(), &
         bg_bright_yellow = ansi_code(), &
         bg_bright_blue = ansi_code(), &
         bg_bright_magenta = ansi_code(), &
         bg_bright_cyan = ansi_code(), &
         bg_bright_white = ansi_code()
   end type toml_terminal

   !> Constructor to create new terminal
   interface toml_terminal
      module procedure :: new_terminal
   end interface toml_terminal

contains

!> Create new terminal
pure function new_terminal(use_color) result(new)
   !> Enable color support in terminal
   logical, intent(in) :: use_color
   !> New terminal instance
   type(toml_terminal) :: new

   if (use_color) then
      new%reset = reset
      new%bold = bold
      new%dim = dim
      new%italic = italic
      new%underline = underline
      new%blink = blink
      new%blink_rapid = blink_rapid
      new%reverse = reverse
      new%hidden = hidden
      new%crossed = crossed

      new%black = black
      new%red = red
      new%green = green
      new%yellow = yellow
      new%blue = blue
      new%magenta = magenta
      new%cyan = cyan
      new%white = white
      new%gray  = gray
      new%bright_red  = bright_red
      new%bright_green  = bright_green
      new%bright_yellow  = bright_yellow
      new%bright_blue  = bright_blue
      new%bright_magenta  = bright_magenta
      new%bright_cyan  = bright_cyan
      new%bright_white  = bright_white

      new%bg_black = bg_black
      new%bg_red = bg_red
      new%bg_green = bg_green
      new%bg_yellow = bg_yellow
      new%bg_blue = bg_blue
      new%bg_magenta = bg_magenta
      new%bg_cyan = bg_cyan
      new%bg_white = bg_white
      new%bg_gray = bg_gray
      new%bg_bright_red = bg_bright_red
      new%bg_bright_green = bg_bright_green
      new%bg_bright_yellow = bg_bright_yellow
      new%bg_bright_blue = bg_bright_blue
      new%bg_bright_magenta = bg_bright_magenta
      new%bg_bright_cyan = bg_bright_cyan
      new%bg_bright_white = bg_bright_white
   end if
end function new_terminal

!> Add two escape sequences, attributes in the right value override the left value ones.
pure function add(lval, rval) result(code)
   !> First escape code
   type(ansi_code), intent(in) :: lval
   !> Second escape code
   type(ansi_code), intent(in) :: rval
   !> Combined escape code
   type(ansi_code) :: code

   code%style = merge(rval%style, lval%style, rval%style >= 0)
   code%fg = merge(rval%fg, lval%fg, rval%fg >= 0)
   code%bg = merge(rval%bg, lval%bg, rval%bg >= 0)
end function add


!> Concatenate an escape code with a string and turn it into an actual escape sequence
pure function concat_left(lval, code) result(str)
   !> String to add the escape code to
   character(len=*), intent(in) :: lval
   !> Escape sequence
   type(ansi_code), intent(in) :: code
   !> Concatenated string
   character(len=:), allocatable :: str

   str = lval // escape(code)
end function concat_left

!> Concatenate an escape code with a string and turn it into an actual escape sequence
pure function concat_right(code, rval) result(str)
   !> String to add the escape code to
   character(len=*), intent(in) :: rval
   !> Escape sequence
   type(ansi_code), intent(in) :: code
   !> Concatenated string
   character(len=:), allocatable :: str

   str = escape(code) // rval
end function concat_right


!> Transform a color code into an actual ANSI escape sequence
pure function escape(code) result(str)
   !> Color code to be used
   type(ansi_code), intent(in) :: code
   !> ANSI escape sequence representing the color code
   character(len=:), allocatable :: str

   if (anycolor(code)) then
      str = achar(27) // "[0"  ! Always reset the style
      if (code%style > 0) str = str // ";" // to_string(code%style)
      if (code%fg >= 0) str = str // ";" // to_string(code%fg)
      if (code%bg >= 0) str = str // ";" // to_string(code%bg)
      str = str // "m"
   else
      str = ""
   end if
end function escape

!> Check whether the code describes any color or is just a stub
pure function anycolor(code)
   !> Escape sequence
   type(ansi_code), intent(in) :: code
   !> Any color / style is active
   logical :: anycolor

   anycolor = code%fg >= 0 .or. code%bg >= 0 .or. code%style >= 0
end function anycolor

end module tomlf_terminal

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/disp/d3.f90
!> Provides a proxy for the [DFT-D3 dispersion correction](https://dftd3.readthedocs.io)

!> Semiclassical DFT-D3 dispersion correction
module tblite_disp_d3
   use mctc_env, only : error_type, wp
   use mctc_io, only : structure_type
   use mctc_ncoord, only : new_ncoord, ncoord_type, cn_count
   use tblite_container_cache, only : container_cache
   use tblite_cutoff, only : get_lattice_points
   use tblite_disp_cache, only : dispersion_cache
   use tblite_disp_type, only : dispersion_type
   use dftd3, only : d3_model, new_d3_model, rational_damping_param, realspace_cutoff
   implicit none
   private

   public :: new_d3_dispersion


   !> Container for DFT-D3 type dispersion correction
   type, public, extends(dispersion_type) :: d3_dispersion
      !> Instance of the actual D3 dispersion model
      type(d3_model) :: model
      !> Rational damping parameters
      type(rational_damping_param) :: param
      !> Selected real space cutoffs for this instance
      type(realspace_cutoff) :: cutoff
       !> Coordination number instance
      class(ncoord_type), allocatable :: ncoord
   contains
      procedure :: get_engrad
   end type d3_dispersion

   character(len=*), parameter :: label = "DFT-D3(BJ) dispersion correction"
   real(wp), parameter :: default_disp2_width = 0.0_wp
   real(wp), parameter :: default_disp3_width = 0.0_wp

contains

subroutine new_d3_dispersion(self, mol, s6, s8, a1, a2, s9, error, disp2_width, disp3_width)
   !> Instance of the dispersion correction
   type(d3_dispersion), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Damping parameters
   real(wp), intent(in) :: s6, s8, a1, a2, s9
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Width of smooth two-body interaction cutoff
   real(wp), intent(in), optional :: disp2_width
   !> Width of smooth three-body interaction cutoff
   real(wp), intent(in), optional :: disp3_width

   real(wp) :: width2, width3

   width2 = default_disp2_width
   width3 = default_disp3_width
   if (present(disp2_width)) width2 = disp2_width
   if (present(disp3_width)) width3 = disp3_width

   self%label = label
   call new_d3_model(self%model, mol)
   self%param = rational_damping_param(s6=s6, s8=s8, s9=s9, a1=a1, a2=a2, alp=14.0_wp)
   self%cutoff = realspace_cutoff(cn=25.0_wp, disp3=25.0_wp, disp2=50.0_wp, &
      & width2=width2, width3=width3)
   call new_ncoord(self%ncoord, mol, cn_count%exp, error, &
      & cutoff=self%cutoff%cn, rcov=self%model%rcov)
end subroutine new_d3_dispersion

!> Evaluate non-selfconsistent part of the dispersion correction
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the dispersion correction
   class(d3_dispersion), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different dispersion runs
   type(container_cache), intent(inout) :: cache
   !> Dispersion energy
   real(wp), intent(inout) :: energies(:)
   !> Dispersion gradient
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Dispersion virial
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)

   logical :: grad
   integer :: mref
   real(wp), allocatable :: cn(:)
   real(wp), allocatable :: gwvec(:, :), gwdcn(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :)
   real(wp), allocatable :: dEdcn(:), lattr(:, :)

   mref = maxval(self%model%ref)
   grad = present(gradient).and.present(sigma)

   allocate(cn(mol%nat))
   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff%cn, lattr)
   call self%ncoord%get_coordination_number(mol, lattr, cn)

   allocate(gwvec(mref, mol%nat))
   if (grad) allocate(gwdcn(mref, mol%nat))
   call self%model%weight_references(mol, cn, gwvec, gwdcn)

   allocate(c6(mol%nat, mol%nat))
   if (grad) allocate(dc6dcn(mol%nat, mol%nat))
   call self%model%get_atomic_c6(mol, gwvec, gwdcn, c6, dc6dcn)

   if (grad) then
      allocate(dEdcn(mol%nat))
      dEdcn(:) = 0.0_wp
   end if
   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff%disp2, lattr)
   call self%param%get_dispersion2(mol, lattr, self%cutoff%disp2, self%cutoff%width2, &
      & self%model%rvdw, self%model%r4r2, c6, dc6dcn, energies, dEdcn, gradient, sigma)

   call get_lattice_points(mol%periodic, mol%lattice, self%cutoff%disp3, lattr)
   call self%param%get_dispersion3(mol, lattr, self%cutoff%disp3, self%cutoff%width3, &
      & self%model%rvdw, self%model%r4r2, c6, dc6dcn, energies, dEdcn, gradient, sigma)
   if (grad) then
      call self%ncoord%add_coordination_number_derivs(mol, lattr, dEdcn, gradient, sigma)
   end if
end subroutine get_engrad


end module tblite_disp_d3

module fpm_lint_logger
  implicit none
  private

  public :: lint_logger, new_logger


  type :: log_message
    character(:), allocatable :: output
  end type log_message

  type :: lint_logger
    type(log_message), allocatable :: message(:)
  contains
    procedure :: add_message
    procedure :: show_log
  end type lint_logger

contains

  subroutine new_logger(logger)
    type(lint_logger), intent(out) :: logger

    allocate(logger%message(0))
  end subroutine new_logger

  subroutine add_message(logger, message)
    class(lint_logger), intent(inout) :: logger
    character(*), intent(in) :: message

    logger%message = [logger%message, log_message(message)]
  end subroutine add_message

  subroutine show_log(logger, io)
    class(lint_logger), intent(in) :: logger
    integer, intent(in) :: io

    integer :: it

    do it = 1, size(logger%message)
      write(io, '(a)') logger%message(it)%output
    end do
  end subroutine show_log

end module fpm_lint_logger

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/param/post_processing/molmom.f90
!> Provides record for molecular multipole moments post-processing
module tblite_param_post_processing_molmom
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_param_post_processing_type, only : post_processing_record
   use tblite_toml, only : toml_table, get_value, set_value, add_table
   implicit none
   private

   public :: count

   character(len=*), parameter :: k_dipm = "dipole", k_qp = "quadrupole", &
      & k_molmom = "molecular-multipole"

   !> Record specifying the molecular multipole moments post-processing
   type, public, extends(post_processing_record) :: molmom_record
      !> Compute dipole moments
      logical :: moldipm = .false.
      !> Compute quadrupole moments
      logical :: molqp = .false.
   contains
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Populate parametrization record with default values
      procedure :: populate_default_param
   end type

   !> Masking for the molecular multipole moments post-processing
   type, public :: molmom_mask
   end type molmom_mask

   interface count
      module procedure :: count_mask
   end interface count

contains

subroutine populate_default_param(param)
   !> Multipole moment post-processing record
   class(molmom_record), intent(inout) :: param

   param%moldipm = .true.
   param%molqp= .true.

end subroutine

!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(molmom_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   integer :: stat

   call get_value(table, k_molmom, child, requested=.false.)
   if (.not.associated(child)) return
   call get_value(child, k_dipm, self%moldipm, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read entry for molecular dipole, boolean expected")
      return
   end if

   call get_value(child, k_qp, self%molqp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot read entry for molecular quadrupole, boolean expected")
      return
   end if

end subroutine load_from_toml


!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(molmom_record), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   call add_table(table, k_molmom, child)

   call set_value(child, k_dipm, self%moldipm)
   call set_value(child, k_qp, self%molqp)

end subroutine dump_to_toml


elemental function count_mask(mask) result(ncount)
   type(molmom_mask), intent(in) :: mask
   integer :: ncount
   ncount = 0
end function count_mask

end module tblite_param_post_processing_molmom

program fpm_wrapper
implicit none
integer :: i, status, failed
integer, parameter :: ncommands = 9
character(len=1000) :: commands(ncommands)
character(len=8) :: status_string
integer :: results(ncommands)

commands = [character(len=1000) :: &
    "fpm run --target force -- tests/Input_force.txt", &
    "fpm run --target test_ddx_driver -- tests/data/ddpcm_force_fmm.in tests/data/ddpcm_force_fmm.out 1E-12", &
    "fpm run --target test_ddx_driver -- tests/data/ddcosmo_force_fmm.in tests/data/ddcosmo_force_fmm.out 1E-12", &
    "fpm run --target force_ddlpb -- tests/data/ddlpb_force.txt", &
    "fpm run --target ddlpb_esolv -- tests/data/ddlpb_force.txt", &
    "fpm run --target matrix_derivatives -- tests/data/ddlpb_force.txt", &
    "fpm run --target matrix_adjoint -- tests/data/ddlpb_force.txt", &
    "fpm run --target matrix_solvers -- tests/data/ddlpb_force.txt", &
    "fpm run --target test_gradients -- tests/Input_cosmo_small.txt"]


results(:) = 0
do i = 1, ncommands
    call system(commands(i), status)
    if (status.ne.0) then
        results(i) = 1
    end if
end do

failed = sum(results)

write(6,"(A)") "OVERVIEW:"
write(6,"(A,I0,A,I0,A)") "Results: ", ncommands - failed, "/", ncommands, " passed"
do i = 1, ncommands
    if (results(i).eq.0) then
        status_string = "SUCCESS:"
    else
        status_string = "FAILURE:"
    end if
    write(6,"(A,X,A)") trim(status_string), trim(commands(i))
end do

if (failed.gt.0) call exit(1)
call exit(0)

end program fpm_wrapper

! This file is part of multicharge.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module multicharge_ewald
   use mctc_env, only : wp
   use mctc_io_constants, only : pi
   use mctc_io_math, only : matdet_3x3, matinv_3x3
   implicit none
   private

   public :: get_alpha

   real(wp), parameter :: twopi = 2 * pi
   real(wp), parameter :: eps = sqrt(epsilon(0.0_wp))

   abstract interface
      !> Returns the max. value of a term in the reciprocal space part of the Ewald
      !> summation for a given vector length.
      pure function get_rec_term_gen(gg, alpha, vol) result(gTerm)
         import :: wp

         !> Length of the reciprocal space vector
         real(wp), intent(in) :: gg

         !> Parameter of the Ewald summation
         real(wp), intent(in) :: alpha

         !> Volume of the real space unit cell
         real(wp), intent(in) :: vol

         !> Reciprocal term
         real(wp) :: gTerm

      end function get_rec_term_gen
   end interface

contains


subroutine get_alpha(lattice, alpha)
   real(wp), intent(in) :: lattice(:, :)
   real(wp), intent(out) :: alpha
   real(wp) :: vol, rec_lat(3, 3)

   vol = abs(matdet_3x3(lattice))
   rec_lat = twopi*transpose(matinv_3x3(lattice))

   call search_alpha(lattice, rec_lat, vol, eps, alpha)

end subroutine get_alpha


!> Get optimal alpha-parameter for the Ewald summation by finding alpha, where
!> decline of real and reciprocal part of Ewald are equal.
subroutine search_alpha(lattice, rec_lat, volume, tolerance, alpha)
   !> Lattice vectors
   real(wp), intent(in) :: lattice(:,:)
   !> Reciprocal vectors
   real(wp), intent(in) :: rec_lat(:,:)
   !> Volume of the unit cell
   real(wp), intent(in) :: volume
   !> Tolerance for difference in real and rec. part
   real(wp), intent(in) :: tolerance
   !> Optimal alpha
   real(wp), intent(out) :: alpha

   real(wp) :: alpl, alpr, rlen, dlen, diff
   real(wp), parameter :: alpha0 = 1.0e-8_wp
   integer, parameter :: niter = 30
   integer :: ibs, stat

   rlen = sqrt(minval(sum(rec_lat(:,:)**2, dim=1)))
   dlen = sqrt(minval(sum(lattice(:,:)**2, dim=1)))

   stat = 0
   alpha = alpha0
   diff = rec_dir_diff(alpha, get_rec_term_3d, rlen, dlen, volume)
   do while (diff < -tolerance .and. alpha <= huge(1.0_wp))
      alpha = 2.0_wp * alpha
      diff = rec_dir_diff(alpha, get_rec_term_3d, rlen, dlen, volume)
   end do
   if (alpha > huge(1.0_wp)) then
      stat = 1
   elseif (alpha == alpha0) then
      stat = 2
   end if

   if (stat == 0) then
      alpl = 0.5_wp * alpha
      do while (diff < tolerance .and. alpha <= huge(1.0_wp))
         alpha = 2.0_wp * alpha
         diff = rec_dir_diff(alpha, get_rec_term_3d, rlen, dlen, volume)
      end do
      if (alpha > huge(1.0_wp)) then
         stat = 3
      end if
   end if

   if (stat == 0) then
      alpr = alpha
      alpha = (alpl + alpr) * 0.5_wp
      ibs = 0
      diff = rec_dir_diff(alpha, get_rec_term_3d, rlen, dlen, volume)
      do while (abs(diff) > tolerance .and. ibs <= niter)
         if (diff < 0) then
            alpl = alpha
         else
            alpr = alpha
         end if
         alpha = (alpl + alpr) * 0.5_wp
         diff = rec_dir_diff(alpha, get_rec_term_3d, rlen, dlen, volume)
         ibs = ibs + 1
      end do
      if (ibs > niter) then
         stat = 4
      end if
   end if

   if (stat /= 0) then
      alpha = 0.25_wp
   end if

end subroutine search_alpha

!> Returns the difference in the decrease of the real and reciprocal parts of the
!> Ewald sum. In order to make the real space part shorter than the reciprocal
!> space part, the values are taken at different distances for the real and the
!> reciprocal space parts.
pure function rec_dir_diff(alpha, get_rec_term, rlen, dlen, volume) result(diff)

   !> Parameter for the Ewald summation
   real(wp), intent(in) :: alpha

   !> Procedure pointer to reciprocal routine
   procedure(get_rec_term_gen) :: get_rec_term

   !> Length of the shortest reciprocal space vector in the sum
   real(wp), intent(in) :: rlen

   !> Length of the shortest real space vector in the sum
   real(wp), intent(in) :: dlen

   !> Volume of the real space unit cell
   real(wp), intent(in) :: volume

   !> Difference between changes in the two terms
   real(wp) :: diff

   diff = ((get_rec_term(4*rlen, alpha, volume) &
      & - get_rec_term(5*rlen, alpha, volume))) &
      & - (get_dir_term(2*dlen, alpha) - get_dir_term(3*dlen, alpha))

end function rec_dir_diff

!> Returns the max. value of a term in the real space part of the Ewald summation
!> for a given vector length.
pure function get_dir_term(rr, alpha) result(dval)

   !> Length of the real space vector
   real(wp), intent(in) :: rr

   !> Parameter of the Ewald summation
   real(wp), intent(in) :: alpha

   !> Real space term
   real(wp) :: dval

   dval = erfc(alpha*rr)/rr

end function get_dir_term


!> Returns the max. value of a term in the reciprocal space part of the Ewald
!> summation for a given vector length.
pure function get_rec_term_3d(gg, alpha, vol) result(rval)

   !> Length of the reciprocal space vector
   real(wp), intent(in) :: gg

   !> Parameter of the Ewald summation
   real(wp), intent(in) :: alpha

   !> Volume of the real space unit cell
   real(wp), intent(in) :: vol

   !> Reciprocal term
   real(wp) :: rval

   rval = 4.0_wp*pi*(exp(-0.25_wp*gg*gg/(alpha**2))/(vol*gg*gg))

end function get_rec_term_3d

end module multicharge_ewald

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/fit
!> Contains routines for parameter optimization

!> @file tblite/fit/settings.f90
!> Provides setting for the optimization driver

!> Declaration of options for the optimization driver
module tblite_fit_settings
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_param_serde, only : serde_record
   use tblite_param, only : param_record, param_mask
   use tblite_toml, only : toml_table, get_value, set_value, add_table
   implicit none
   private

   !> Optimization configuration
   type, public, extends(serde_record) :: fit_settings
      character(len=:), allocatable :: method
      character(len=:), allocatable :: script
      character(len=:), allocatable :: output
      character(len=:), allocatable :: fitpar
      logical :: relative
      integer :: max_iter
      real(wp) :: trustr
      type(param_record), allocatable :: base
      type(param_mask) :: mask
   contains
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
   end type fit_settings

contains

!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(fit_settings), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   call get_value(table, "max-iter", self%max_iter, 100)
   if (self%max_iter <= 0) then
      call fatal_error(error, "Positive number of iterations required")
      return
   end if

   call get_value(table, "method", self%method, "newuoa")
   if (self%method /= "newuoa") then
      call fatal_error(error, "Unknown optimization method '"//self%method//"'")
      return
   end if

   call get_value(table, "relative", self%relative, .true.)

   call get_value(table, "trust-rad", self%trustr, 0.1_wp)
   if (self%trustr <= 0.0_wp) then
      call fatal_error(error, "Positive value for trust radius required")
      return
   end if

   call get_value(table, "script", self%script, "./run.sh")
   call get_value(table, "data-file", self%output, ".data")
   call get_value(table, "param-file", self%fitpar, "fitpar.toml")

   call set_base_param(self%mask, self%base)
   call get_value(table, "mask", child)
   call self%mask%load(child, error)
   if (allocated(error)) return
end subroutine load_from_toml

subroutine set_base_param(mask, base)
   type(param_mask), intent(out) :: mask
   type(param_record), intent(in), target, optional :: base
   if (present(base)) mask%ref => base%record
end subroutine set_base_param

!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(fit_settings), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   call set_value(table, "max-iter", self%max_iter)
   call set_value(table, "method", self%method)
   call set_value(table, "relative", self%relative)
   call set_value(table, "trust-rad", self%trustr)
   call set_value(table, "script", self%script)
   call set_value(table, "data-file", self%output)
   call set_value(table, "param-file", self%fitpar)

   call add_table(table, "mask", child)
   call self%mask%dump(child, error)
   if (allocated(error)) return
end subroutine dump_to_toml

end module tblite_fit_settings

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Testsuite for the `tomlf_build` modules
module tftest_build
   use testdrive
   use tomlf_build
   use tomlf
   implicit none
   private

   public :: collect_build


contains


!> Collect all exported unit tests
subroutine collect_build(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("array-real-sp", array_real_sp), &
      & new_unittest("array-real-dp", array_real_dp), &
      & new_unittest("array-int-i1", array_int_i1), &
      & new_unittest("array-int-i2", array_int_i2), &
      & new_unittest("array-int-i4", array_int_i4), &
      & new_unittest("array-int-i8", array_int_i8), &
      & new_unittest("array-bool", array_bool), &
      & new_unittest("array-datetime", array_datetime), &
      & new_unittest("array-string", array_string), &
      & new_unittest("array-merge", array_merge), &
      & new_unittest("table-table", table_table), &
      & new_unittest("table-array", table_array), &
      & new_unittest("table-real-sp", table_real_sp), &
      & new_unittest("table-real-dp", table_real_dp), &
      & new_unittest("table-int-i1", table_int_i1), &
      & new_unittest("table-int-i2", table_int_i2), &
      & new_unittest("table-int-i4", table_int_i4), &
      & new_unittest("table-int-i8", table_int_i8), &
      & new_unittest("table-bool", table_bool), &
      & new_unittest("table-dateime", table_datetime), &
      & new_unittest("table-string", table_string), &
      & new_unittest("table-merge-append", table_merge_append), &
      & new_unittest("table-merge-overwrite", table_merge_overwrite)]

end subroutine collect_build


!> Check double precision floating point numbers (default)
subroutine table_real_dp(error)
   use tomlf_constants, only : tf_dp, tfi
   use tomlf_type, only : new_table, toml_table, toml_key

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   real(tf_dp), parameter :: in1 = 1.0_tf_dp, in2 = huge(in1), in3 = tiny(in1)
   real(tf_dp) :: val
   integer :: stat

   call new_table(table)
   call set_value(table, "real", in2, stat=stat)
   call get_value(table, "real", val, stat=stat)

   call check(error, val, in2, rel=.true.)
   if (allocated(error)) return

   call table%delete("real")
   call set_value(table, toml_key("real"), in1, stat=stat)
   call get_value(table, toml_key("real"), val, stat=stat)

   call check(error, val, in1)
   if (allocated(error)) return

   call table%delete("real")
   call set_value(table, toml_path("real", "sub", "sub", "sub"), in1, stat=stat)
   call get_value(table, toml_path("real", "sub", "sub", "sub"), val, stat=stat)

   call check(error, val, in1)
   if (allocated(error)) return

   call table%destroy
   call new_table(table)
   call get_value(table, "real", val, in3, stat=stat)

   call check(error, val, in3)
   if (allocated(error)) return

   call set_value(table, "int", 1_tfi, stat=stat)
   call get_value(table, "int", val, stat=stat)

   call check(error, val, 1.0_tf_dp)
   if (allocated(error)) return

   call set_value(table, "str", "1", stat=stat)
   call get_value(table, "str", val, stat=stat)

   call check(error, stat, toml_stat%type_mismatch)
   if (allocated(error)) return

end subroutine table_real_dp


!> Check single precision floating point numbers
!>
!> Since TOML requires to store them as double precision numbers, we might find
!> larger deviations here than just epsilon.
subroutine table_real_sp(error)
   use tomlf_constants, only : tf_sp, tfi
   use tomlf_type, only : new_table, toml_table, toml_key

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   real(tf_sp), parameter :: in1 = 1.0_tf_sp, in2 = huge(in1), in3 = tiny(in1)
   real(tf_sp), parameter :: thr = 2*epsilon(0.0_tf_sp)
   real(tf_sp) :: val
   integer :: stat

   call new_table(table)
   call set_value(table, toml_key("real"), in2, stat=stat)
   call get_value(table, toml_key("real"), val, stat=stat)

   call check(error, val, in2, thr=thr, rel=.true.)
   if (allocated(error)) return

   call table%delete("real")
   call set_value(table, "real", in1, stat=stat)
   call get_value(table, "real", val, stat=stat)

   call check(error, val, in1)
   if (allocated(error)) return

   call table%delete("real")
   call set_value(table, toml_path("real", "sub"), in1, stat=stat)
   call get_value(table, toml_path("real", "sub"), val, stat=stat)

   call check(error, val, in1)
   if (allocated(error)) return

   call table%destroy
   call new_table(table)
   call get_value(table, "real", val, in3, stat=stat)

   call check(error, val, in3)
   if (allocated(error)) return

   call set_value(table, "int", 1_tfi, stat=stat)
   call get_value(table, "int", val, stat=stat)

   call check(error, val, 1.0_tf_sp)
   if (allocated(error)) return

   call set_value(table, "str", "1", stat=stat)
   call get_value(table, "str", val, stat=stat)

   call check(error, stat, toml_stat%type_mismatch)
   if (allocated(error)) return

end subroutine table_real_sp


!> Check smallest integers (char)
subroutine table_int_i1(error)
   use tomlf_constants, only : tf_i1, tfi
   use tomlf_type, only : new_table, toml_table, toml_key

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   integer(tf_i1), parameter :: in1 = 1_tf_i1, in2 = huge(in1), in3 = -huge(in1)
   integer(tf_i1) :: val
   integer :: stat

   ! table uninitialized
   call set_value(table, toml_key("int"), in2, stat=stat)
   call get_value(table, "int", val, stat=stat)

   call check(error, val, in2)
   if (allocated(error)) return

   call table%delete("int")
   call set_value(table, "int", in1, stat=stat)
   call get_value(table, toml_key("int"), val, stat=stat)

   call check(error, val, in1)
   if (allocated(error)) return

   call table%delete("int")
   call set_value(table, toml_path("int", "sub"), in1, stat=stat)
   call get_value(table, toml_path("int", "sub"), val, stat=stat)

   call check(error, val, in1)
   if (allocated(error)) return

   call table%destroy
   call new_table(table)
   call get_value(table, "int", val, in3, stat=stat)

   call check(error, val, in3)
   if (allocated(error)) return

   call set_value(table, "huge", huge(1_tfi), stat=stat)
   call get_value(table, "huge", val, stat=stat)

   call check(error, stat, toml_stat%conversion_error)
   if (allocated(error)) return

   call set_value(table, "str", "1", stat=stat)
   call get_value(table, "str", val, stat=stat)

   call check(error, stat, toml_stat%type_mismatch)
   if (allocated(error)) return

   call get_value(table, "missing", val, stat=stat)
   call check(error, stat, toml_stat%missing_key)
   if (allocated(error)) return

end subroutine table_int_i1


!> Check short integers
subroutine table_int_i2(error)
   use tomlf_constants, only : tf_i2, tfi
   use tomlf_type, only : new_table, toml_table

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   integer(tf_i2), parameter :: in1 = 1_tf_i2, in2 = huge(in1), in3 = -huge(in1)
   integer(tf_i2) :: val
   integer :: stat

   call new_table(table)
   call set_value(table, toml_key("int"), in2, stat=stat)
   call get_value(table, toml_key("int"), val, stat=stat)

   call check(error, val, in2)
   if (allocated(error)) return

   call table%delete("int")
   call set_value(table, "int", in1, stat=stat)
   call get_value(table, "int", val, stat=stat)

   call check(error, val, in1)
   if (allocated(error)) return

   call table%delete("int")
   call set_value(table, toml_path("int", "sub"), in1, stat=stat)
   call get_value(table, toml_path("int", "sub"), val, stat=stat)

   call check(error, val, in1)
   if (allocated(error)) return

   call table%destroy
   call new_table(table)
   call get_value(table, "int", val, in3, stat=stat)

   call check(error, val, in3)
   if (allocated(error)) return

   call set_value(table, "huge", huge(1_tfi), stat=stat)
   call get_value(table, "huge", val, stat=stat)

   call check(error, stat, toml_stat%conversion_error)
   if (allocated(error)) return

   call set_value(table, "str", "1", stat=stat)
   call get_value(table, "str", val, stat=stat)

   call check(error, stat, toml_stat%type_mismatch)
   if (allocated(error)) return

   call get_value(table, "missing", val, stat=stat)
   call check(error, stat, toml_stat%missing_key)
   if (allocated(error)) return

end subroutine table_int_i2


!> Check default integers
subroutine table_int_i4(error)
   use tomlf_constants, only : tf_i4, tfi
   use tomlf_type, only : new_table, toml_table, toml_key

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   integer(tf_i4), parameter :: in1 = 1_tf_i4, in2 = huge(in1), in3 = -huge(in1)
   integer(tf_i4) :: val
   integer :: stat

   call new_table(table)
   call set_value(table, "int", in2, stat=stat)
   call get_value(table, "int", val, stat=stat)

   call check(error, val, in2)
   if (allocated(error)) return

   call table%delete("int")
   call set_value(table, toml_key("int"), in1, stat=stat)
   call get_value(table, toml_key("int"), val, stat=stat)

   call check(error, val, in1)
   if (allocated(error)) return

   call table%delete("int")
   call set_value(table, toml_path("int", "sub", "sub"), in1, stat=stat)
   call get_value(table, toml_path("int", "sub", "sub"), val, stat=stat)

   call check(error, val, in1)
   if (allocated(error)) return

   call table%destroy
   call new_table(table)
   call get_value(table, "int", val, in3, stat=stat)

   call check(error, val, in3)
   if (allocated(error)) return

   call set_value(table, "huge", huge(1_tfi), stat=stat)
   call get_value(table, "huge", val, stat=stat)

   call check(error, stat, toml_stat%conversion_error)
   if (allocated(error)) return

   call set_value(table, "str", "1", stat=stat)
   call get_value(table, "str", val, stat=stat)

   call check(error, stat, toml_stat%type_mismatch)
   if (allocated(error)) return

   call get_value(table, "missing", val, stat=stat)
   call check(error, stat, toml_stat%missing_key)
   if (allocated(error)) return

end subroutine table_int_i4


!> Check long integers (default)
subroutine table_int_i8(error)
   use tomlf_constants, only : tf_i8
   use tomlf_type, only : new_table, toml_table, toml_key
   use tomlf_utils, only : to_string

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   integer :: ii
   integer(tf_i8), parameter :: in1 = 1_tf_i8, in2 = huge(in1), in3 = -huge(in1)
   integer(tf_i8) :: val
   integer :: stat

   call new_table(table)
   call set_value(table, "int", in2, stat=stat)
   call get_value(table, "int", val, stat=stat)

   call check(error, val, in2)
   if (allocated(error)) return

   call table%delete("int")
   call set_value(table, toml_key("int"), in1, stat=stat)
   call get_value(table, "int", val, stat=stat)

   call check(error, val, in1)
   if (allocated(error)) return

   call table%delete("int")
   call set_value(table, toml_path([toml_key("int"), toml_key("sub")]), in1, stat=stat)
   call get_value(table, toml_path([toml_key("int"), toml_key("sub")]), val, stat=stat)

   call check(error, val, in1)
   if (allocated(error)) return

   call table%destroy
   call new_table(table)
   call get_value(table, toml_key("int"), val, in3, stat=stat)

   call check(error, val, in3)
   if (allocated(error)) return

   call set_value(table, "str", "1", stat=stat)
   call get_value(table, "str", val, stat=stat)

   call check(error, stat, toml_stat%type_mismatch)
   if (allocated(error)) return

   call table%destroy()
   call new_table(table)
   do ii = 1, 100
      call set_value(table, to_string(ii), int(ii, tf_i8), stat=stat)
   end do
   call get_value(table, to_string(100), val, stat=stat)
   call check(error, val, 100_tf_i8)
   if (allocated(error)) return

   call get_value(table, "missing", val, stat=stat)
   call check(error, stat, toml_stat%missing_key)
   if (allocated(error)) return

end subroutine table_int_i8


!> Check logicals
subroutine table_bool(error)
   use tomlf_type, only : toml_table, toml_key

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   logical, parameter :: true = .true., false = .false.
   logical :: val
   integer :: stat

   table = toml_table()
   call set_value(table, toml_key("logic"), true, stat=stat)
   call get_value(table, toml_key("logic"), val, stat=stat)

   call check(error, val, true)
   if (allocated(error)) return

   call table%delete("logic")
   call set_value(table, "logic", false, stat=stat)
   call get_value(table, "logic", val, stat=stat)

   call check(error, val, false)
   if (allocated(error)) return

   call table%delete("logic")
   call set_value(table, toml_path("logic", "sub"), false, stat=stat)
   call get_value(table, toml_path("logic", "sub"), val, stat=stat)

   call check(error, val, false)
   if (allocated(error)) return

   call table%destroy
   call new_table(table)
   call get_value(table, "logic", val, true, stat=stat)

   call check(error, val, true)
   if (allocated(error)) return

   call set_value(table, "str", "1", stat=stat)
   call get_value(table, "str", val, stat=stat)

   call check(error, stat, toml_stat%type_mismatch)
   if (allocated(error)) return

   call get_value(table, "missing", val, stat=stat)
   call check(error, stat, toml_stat%missing_key)
   if (allocated(error)) return

end subroutine table_bool


!> Check datetime
subroutine table_datetime(error)
   use tomlf_type, only : toml_table, toml_key
   use tomlf_datetime, only : toml_datetime, toml_date, toml_time, operator(==), to_string

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(toml_datetime) :: val, ts1, ts2
   integer :: stat

   ts1 = toml_datetime(toml_date(2022,  7, 31), toml_time(13, 51, 42))
   ts2 = toml_datetime(toml_date(2019, 12, 17), toml_time(18, 26, 59))

   table = toml_table()
   call set_value(table, toml_key("datetime"), ts1, stat=stat)
   call get_value(table, toml_key("datetime"), val, stat=stat)

   call check(error, val == ts1, &
      & "Expected '"//to_string(ts1)//"' but got '"//to_string(val)//"'")
   if (allocated(error)) return

   call table%delete("datetime")
   call set_value(table, "datetime", ts2, stat=stat)
   call get_value(table, "datetime", val, stat=stat)

   call check(error, val == ts2, &
      & "Expected '"//to_string(ts2)//"' but got '"//to_string(val)//"'")
   if (allocated(error)) return

   call table%delete("datetime")
   call set_value(table, toml_path("datetime", "sub", "sub"), ts2, stat=stat)
   call get_value(table, toml_path("datetime", "sub", "sub"), val, stat=stat)

   call check(error, val == ts2, &
      & "Expected '"//to_string(ts2)//"' but got '"//to_string(val)//"'")
   if (allocated(error)) return

   call table%destroy
   call new_table(table)
   call get_value(table, "datetime", val, ts1, stat=stat)

   call check(error, val == ts1, &
      & "Expected '"//to_string(ts1)//"' but got '"//to_string(val)//"'")
   if (allocated(error)) return

   call set_value(table, "str", "1", stat=stat)
   call get_value(table, "str", val, stat=stat)

   call check(error, stat, toml_stat%type_mismatch)
   if (allocated(error)) return

   call get_value(table, "missing", val, stat=stat)
   call check(error, stat, toml_stat%missing_key)
   if (allocated(error)) return

end subroutine table_datetime


!> Check strings
subroutine table_string(error)
   use tomlf_type, only : toml_table, toml_key

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   character(len=:), allocatable :: val
   integer :: stat

   table = toml_table()
   call set_value(table, toml_key("string"), "value", stat=stat)
   call get_value(table, "string", val, stat=stat)

   call check(error, val, "value")
   if (allocated(error)) return

   call table%delete("string")
   call set_value(table, "string", """value""", stat=stat)
   call get_value(table, "string", val, stat=stat)

   call check(error, val, """value""")
   if (allocated(error)) return

   call table%delete("string")
   call set_value(table, toml_path("string", "sub"), "value", stat=stat)
   call get_value(table, toml_path("string", "sub"), val, stat=stat)

   call check(error, val, "value")
   if (allocated(error)) return

   call table%destroy
   call new_table(table)
   call get_value(table, toml_key("string"), val, "'value'", stat=stat)

   call check(error, val, "'value'")
   if (allocated(error)) return

   call get_value(table, "missing", val, stat=stat)
   call check(error, stat, toml_stat%missing_key)
   if (allocated(error)) return

end subroutine table_string

subroutine table_table(error)
   use tomlf_type, only : new_table, toml_table, toml_key

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(toml_table), pointer :: child
   integer :: stat

   call new_table(table)
   call get_value(table, toml_key("table-of-tables"), child, &
      & requested=.false.)
   call check(error, .not.associated(child), "Should not create table")
   if (allocated(error)) return

   call get_value(table, toml_key("table-of-tables"), child, &
      & requested=.false., stat=stat)
   call check(error, .not.associated(child), "Should not create table")
   if (allocated(error)) return
   call check(error, stat, toml_stat%success, "Status should be success since key is not requested")
   if (allocated(error)) return
end subroutine table_table

subroutine table_array(error)
   use tomlf_type, only : toml_value, new_table, toml_table, add_table, new_array, &
      & toml_array, toml_key, add_array, len

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(toml_table), pointer :: child
   type(toml_array), pointer :: children
   class(toml_value), allocatable :: val
   integer :: i, stat

   call new_table(table)
   call get_value(table, toml_key("array-of-tables"), children, &
      & requested=.false., stat=stat)
   call check(error, stat, "Not finding a not required value shouldn't be an error")
   if (allocated(error)) return

   call add_array(table, "array-of-tables", children, stat)

   do i = 1, 4
      call add_table(children, child, stat)
      call set_value(child, "val", i*i)
   end do

   call check(error, len(children), 4)
   if (allocated(error)) return

   call children%pop(val)

   call check(error, len(children), 3)
   if (allocated(error)) return

   select type(val)
   class default
      call test_failed(error, "Popped value is not of table type")
   class is (toml_table)
      call get_value(val, "val", i)
      call check(error, i, 16)
   end select
   if (allocated(error)) return

   call children%shift(val)

   call check(error, len(children), 2)
   if (allocated(error)) return

   select type(val)
   class default
      call test_failed(error, "Shifted value is not of table type")
   class is (toml_table)
      call get_value(val, "val", i)
      call check(error, i, 1)
   end select
   if (allocated(error)) return

   call get_value(table, toml_path("tables", "with", "array"), children, &
      & requested=.false., stat=stat)
   call check(error, .not.associated(children), "Should not create array")
   if (allocated(error)) return
   call check(error, stat, "Not finding a not required value shouldn't be an error")
   if (allocated(error)) return

   call get_value(table, toml_path("tables", "with", "array"), children, &
      & requested=.true.)
   call check(error, associated(children), "Array was not created")
   if (allocated(error)) return
end subroutine table_array


!> Check single precision floating point numbers
subroutine array_real_sp(error)
   use tomlf_constants, only : tf_sp
   use tomlf_type, only : new_array, toml_array, len

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_array) :: array
   real(tf_sp) :: val
   real(tf_sp), allocatable :: vals(:)
   integer :: ii
   integer :: stat

   ! array not initialized
   do ii = 1, 10
      call set_value(array, ii, sqrt(real(ii, tf_sp)), stat=stat)
   end do
   call check(error, len(array), 10)
   if (allocated(error)) return

   ii = 7
   call get_value(array, ii, val, stat=stat)
   call check(error, val, sqrt(7.0_tf_sp), rel=.true.)
   if (allocated(error)) return

   call get_value(array, vals, stat=stat)
   call check(error, allocated(vals))
   call check(error, vals(7), val, rel=.true.)
   if (allocated(error)) return

   vals = 2*vals(:9)
   call set_value(array, vals, stat=stat)
   call check(error, len(array), 9)
   if (allocated(error)) return

   call get_value(array, ii, val, stat=stat)
   call check(error, val, 2*sqrt(7.0_tf_sp), rel=.true.)
   if (allocated(error)) return

end subroutine array_real_sp


!> Check double precision floating point numbers (default)
subroutine array_real_dp(error)
   use tomlf_constants, only : tf_dp
   use tomlf_type, only : new_array, toml_array, len

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_array) :: array
   real(tf_dp) :: val
   real(tf_dp), allocatable :: vals(:)
   integer :: ii
   integer :: stat

   call new_array(array)
   do ii = 1, 10
      call set_value(array, ii, sqrt(real(ii, tf_dp)), stat=stat)
   end do
   call check(error, len(array), 10)
   if (allocated(error)) return

   ii = 7
   call get_value(array, ii, val, stat=stat)
   call check(error, val, sqrt(7.0_tf_dp), rel=.true.)
   if (allocated(error)) return

   call get_value(array, vals, stat=stat)
   call check(error, allocated(vals))
   call check(error, vals(7), val, rel=.true.)
   if (allocated(error)) return

   vals = 2*vals(:9)
   call set_value(array, vals, stat=stat)
   call check(error, len(array), 9)
   if (allocated(error)) return

   call get_value(array, ii, val, stat=stat)
   call check(error, val, 2*sqrt(7.0_tf_dp), rel=.true.)
   if (allocated(error)) return

end subroutine array_real_dp


!> Check smallest integers (char)
subroutine array_int_i1(error)
   use tomlf_constants, only : tf_i1
   use tomlf_type, only : new_array, toml_array, len

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_array) :: array
   integer(tf_i1) :: val
   integer(tf_i1), allocatable :: vals(:)
   integer(tf_i1), parameter :: ref(4) = [integer(tf_i1) :: 1, 3, 5, 7]
   integer :: ii
   integer :: stat

   call new_array(array)
   do ii = 1, size(ref)
      call set_value(array, ii, ref(ii), stat=stat)
   end do
   call check(error, len(array), size(ref))
   if (allocated(error)) return

   ii = 3
   call get_value(array, ii, val, stat=stat)
   call check(error, val, ref(ii))
   if (allocated(error)) return

   call get_value(array, vals, stat=stat)
   call check(error, allocated(vals))
   call check(error, vals(ii), val)
   if (allocated(error)) return

   vals = -vals(:ii)
   call set_value(array, vals, stat=stat)
   call check(error, len(array), ii)
   if (allocated(error)) return

   call get_value(array, ii, val, stat=stat)
   call check(error, val, -ref(ii))
   if (allocated(error)) return

end subroutine array_int_i1


!> Check short integers
subroutine array_int_i2(error)
   use tomlf_constants, only : tf_i2
   use tomlf_type, only : new_array, toml_array, len

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_array) :: array
   integer(tf_i2) :: val
   integer(tf_i2), allocatable :: vals(:)
   integer(tf_i2), parameter :: ref(4) = [integer(tf_i2) :: 1, 3, 5, 7]
   integer :: ii
   integer :: stat

   call new_array(array)
   do ii = 1, size(ref)
      call set_value(array, ii, ref(ii), stat=stat)
   end do
   call check(error, len(array), size(ref))
   if (allocated(error)) return

   ii = 3
   call get_value(array, ii, val, stat=stat)
   call check(error, val, ref(ii))
   if (allocated(error)) return

   call get_value(array, vals, stat=stat)
   call check(error, allocated(vals))
   call check(error, vals(ii), val)
   if (allocated(error)) return

   vals = -vals(:ii)
   call set_value(array, vals, stat=stat)
   call check(error, len(array), ii)
   if (allocated(error)) return

   call get_value(array, ii, val, stat=stat)
   call check(error, val, -ref(ii))
   if (allocated(error)) return

end subroutine array_int_i2


!> Check default integers
subroutine array_int_i4(error)
   use tomlf_constants, only : tf_i4
   use tomlf_type, only : new_array, toml_array, len

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_array) :: array
   integer(tf_i4) :: val
   integer(tf_i4), allocatable :: vals(:)
   integer(tf_i4), parameter :: ref(4) = [integer(tf_i4) :: 1, 3, 5, 7]
   integer :: ii
   integer :: stat

   call new_array(array)
   do ii = 1, size(ref)
      call set_value(array, ii, ref(ii), stat=stat)
   end do
   call check(error, len(array), size(ref))
   if (allocated(error)) return

   ii = 3
   call get_value(array, ii, val, stat=stat)
   call check(error, val, ref(ii))
   if (allocated(error)) return

   call get_value(array, vals, stat=stat)
   call check(error, allocated(vals))
   call check(error, vals(ii), val)
   if (allocated(error)) return

   vals = -vals(:ii)
   call set_value(array, vals, stat=stat)
   call check(error, len(array), ii)
   if (allocated(error)) return

   call get_value(array, ii, val, stat=stat)
   call check(error, val, -ref(ii))
   if (allocated(error)) return

end subroutine array_int_i4


!> Check long integers (default)
subroutine array_int_i8(error)
   use tomlf_constants, only : tf_i8
   use tomlf_type, only : new_array, toml_array, len

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_array) :: array
   integer(tf_i8) :: val
   integer(tf_i8), allocatable :: vals(:)
   integer(tf_i8), parameter :: ref(4) = [integer(tf_i8) :: 1, 3, 5, 7]
   integer :: ii
   integer :: stat

   call new_array(array)
   do ii = 1, size(ref)
      call set_value(array, ii, ref(ii), stat=stat)
   end do
   call check(error, len(array), size(ref))
   if (allocated(error)) return

   ii = 3
   call get_value(array, ii, val, stat=stat)
   call check(error, val, ref(ii))
   if (allocated(error)) return

   call get_value(array, vals, stat=stat)
   call check(error, allocated(vals))
   call check(error, vals(ii), val)
   if (allocated(error)) return

   vals = -vals(:ii)
   call set_value(array, vals, stat=stat)
   call check(error, len(array), ii)
   if (allocated(error)) return

   call get_value(array, ii, val, stat=stat)
   call check(error, val, -ref(ii))
   if (allocated(error)) return

   call array%destroy()
   call new_array(array)
   do ii = 1, 100
      call set_value(array, ii, int(ii, tf_i8), stat=stat)
   end do
   call check(error, len(array), 100)
   if (allocated(error)) return

end subroutine array_int_i8


!> Check logicals
subroutine array_bool(error)
   use tomlf_type, only : toml_array, len

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_array) :: array
   logical :: val
   logical, allocatable :: vals(:)
   integer :: ii
   integer :: stat

   array = toml_array()
   do ii = 1, 10
      call set_value(array, ii, mod(ii, 2) == 1, stat=stat)
   end do
   call check(error, len(array), 10)
   if (allocated(error)) return

   ii = 3
   call get_value(array, ii, val, stat=stat)
   call check(error, val, mod(ii, 2) == 1)
   if (allocated(error)) return

   call get_value(array, vals, stat=stat)
   call check(error, allocated(vals))
   call check(error, vals(7), val)
   if (allocated(error)) return

   vals = .not.vals(:9)
   call set_value(array, vals, stat=stat)
   call check(error, len(array), 9)
   if (allocated(error)) return

   call get_value(array, ii, val, stat=stat)
   call check(error, val, mod(ii, 2) /= 1)
   if (allocated(error)) return

end subroutine array_bool


!> Check datetime
subroutine array_datetime(error)
   use tomlf_type, only : toml_array, len
   use tomlf_datetime, only : toml_datetime, toml_date, toml_time, operator(==), to_string

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_array) :: array
   type(toml_datetime) :: val, ts
   type(toml_datetime), allocatable :: vals(:)
   integer :: ii
   integer :: stat

   array = toml_array()
   do ii = 1, 10
      call set_value(array, ii, toml_datetime(toml_date(2022, ii, 7), toml_time()), stat=stat)
   end do
   call check(error, len(array), 10)
   if (allocated(error)) return

   ii = 3
   call get_value(array, ii, val, stat=stat)
   ts = toml_datetime(toml_date(2022, ii, 7), toml_time())
   call check(error, val == ts, &
      & "Expected '"//to_string(ts)//"' but got '"//to_string(val)//"'")
   if (allocated(error)) return

   call get_value(array, vals, stat=stat)
   call check(error, vals(ii) == val, &
      & "Expected '"//to_string(val)//"' but got '"//to_string(vals(ii))//"'")
   if (allocated(error)) return

   vals = [(toml_datetime(toml_date(2022, ii, 8), toml_time()), ii = 1, 9)]
   call set_value(array, vals, stat=stat)
   call check(error, len(array), 9)
   if (allocated(error)) return

   call get_value(array, ii, val, stat=stat)
   call check(error, val == vals(ii), &
      & "Expected '"//to_string(vals(ii))//"' but got '"//to_string(val)//"'")
   if (allocated(error)) return

end subroutine array_datetime


!> Check datetime
subroutine array_string(error)
   use tomlf_type, only : toml_array, len

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_array) :: array
   character(:), allocatable :: val
   integer :: ii
   integer :: stat

   array = toml_array()
   do ii = 1, 10
      call set_value(array, ii, repeat("a", ii), stat=stat)
   end do
   call check(error, len(array), 10)
   if (allocated(error)) return

   ii = 3
   call get_value(array, ii, val, stat=stat)
   call check(error, val, repeat("a", ii))
   if (allocated(error)) return

end subroutine array_string


!> Merge two arrays
subroutine array_merge(error)
   use tomlf_type, only : toml_array, new_array, len

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_array) :: array1, array2
   integer :: val1, val2
   integer :: ii
   integer :: stat

   array1 = toml_array()

   do ii = 1, 4
      call set_value(array1, ii, ii*ii, stat=stat)
   end do

   call new_array(array2)

   do ii = 1, 6
      call set_value(array2, ii, ii*ii, stat=stat)
   end do

   call merge_array(array1, array2)
   call array2%destroy

   call check(error, len(array1), 10)
   if (allocated(error)) return

   call get_value(array1, 2, val1, stat)
   call get_value(array1, 6, val2, stat)

   call check(error, val1, val2)
   if (allocated(error)) return

end subroutine array_merge


!> Merge two tables
subroutine table_merge_append(error)
   use tomlf_type, only : toml_table, add_table, new_table, toml_key

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table1, table2
   type(toml_table), pointer :: child
   type(toml_key), allocatable :: list(:)
   real :: val
   integer :: stat

   table1 = toml_table()

   call set_value(table1, "first", 10, stat)
   call set_value(table1, "second", "string", stat)
   call set_value(table1, "third", 1.0e-7, stat)
   call add_table(table1, "fourth", child, stat)
   call set_value(child, "child", .true., stat)

   call new_table(table2)

   call set_value(table2, "val", 12, stat)
   call set_value(table2, "key", "content", stat)
   call set_value(table2, "entry", -1.0e-7, stat)
   call set_value(table2, "third", .false., stat)
   call add_table(table2, "section", child, stat)
   call set_value(child, "sub", .false., stat)
   call add_table(table2, "fourth", child, stat)

   call merge_table(table1, table2)
   call table2%destroy

   call table1%get_keys(list)

   call check(error, size(list), 8)
   if (allocated(error)) return

   call get_value(table1, "third", val, stat=stat)
   call check(error, stat)
   if (allocated(error)) return

end subroutine table_merge_append


!> Merge two tables
subroutine table_merge_overwrite(error)
   use tomlf_type, only : toml_table, add_table, new_table, toml_key

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table1, table2
   type(toml_table), pointer :: child
   type(toml_key), allocatable :: list(:)
   logical :: val
   integer :: stat

   table1 = toml_table()

   call set_value(table1, "first", 10, stat)
   call set_value(table1, "second", "string", stat)
   call set_value(table1, "third", 1.0e-7, stat)
   call add_table(table1, "fourth", child, stat)
   call set_value(child, "child", .true., stat)

   call new_table(table2)

   call set_value(table2, "val", 12, stat)
   call set_value(table2, "key", "content", stat)
   call set_value(table2, "entry", -1.0e-7, stat)
   call set_value(table2, "third", .false., stat)
   call add_table(table2, "section", child, stat)
   call set_value(child, "sub", .false., stat)
   call add_table(table2, "fourth", child, stat)

   call merge_table(table1, table2, toml_merge_config(keyval="overwrite"))
   call table2%destroy

   call table1%get_keys(list)

   call check(error, size(list), 8)
   if (allocated(error)) return

   call get_value(table1, "third", val, stat=stat)
   call check(error, stat)
   if (allocated(error)) return

end subroutine table_merge_overwrite


end module tftest_build

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/param/thirdorder.f90
!> Provides a model for the isotropic third-order electrostatic

!> Definition of the isotropic third-order electrostatic contributions.
module tblite_param_thirdorder
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_param_serde, only : serde_record
   use tblite_toml, only : toml_table, get_value, set_value, add_table
   implicit none
   private

   public :: count


   character(len=*), parameter :: k_shell = "shell", k_ang(0:4) = ["s", "p", "d", "f", "g"]

   !> Parametrization record for third-order electrostatic contributions
   type, public, extends(serde_record) :: thirdorder_record
      integer :: lmax
      logical :: shell
      real(wp) :: ksh(0:4)
   contains
      generic :: load => load_from_array
      generic :: dump => dump_to_array
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Read parametrization data from parameter array
      procedure, private :: load_from_array
      !> Write parametrization data to parameter array
      procedure, private :: dump_to_array
   end type


   !> Masking for the third order electrostatics
   type, public :: thirdorder_mask
   end type thirdorder_mask


   interface count
      module procedure :: count_mask
   end interface count


contains


!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(thirdorder_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   real(wp), allocatable :: last
   integer :: l, stat

   call get_value(table, k_shell, child, requested=.false.)
   self%shell = associated(child)
   if (self%shell) then
      do l = 0, 4
         if (.not.child%has_key(k_ang(l))) then
            if (allocated(last)) then
               self%ksh(l) = last
               cycle
            end if
            call fatal_error(error, "No entry for "//k_ang(l)//"-shell Hubbard derivative")
            exit
         end if
         call get_value(child, k_ang(l), self%ksh(l), stat=stat)
         if (stat /= 0) then
            call fatal_error(error, "Cannot read "//k_ang(l)//"-shell Hubbard derivative")
            exit
         end if
         if (stat == 0) then
            last = self%ksh(l)
            self%lmax = l
         end if
      end do
      if (allocated(error)) return
   end if
end subroutine load_from_toml


!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(thirdorder_record), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   integer :: l

   if (self%shell) then
      call add_table(table, k_shell, child)
      do l = 0, self%lmax
         call set_value(child, k_ang(l), self%ksh(l))
      end do
   else
      call set_value(table, k_shell, .false.)
   end if
end subroutine dump_to_toml


!> Read parametrization data from parameter array
subroutine load_from_array(self, array, offset, base, mask, error)
   class(thirdorder_record), intent(inout) :: self
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: offset
   type(thirdorder_record), intent(in) :: base
   type(thirdorder_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   select type(self)
   type is (thirdorder_record)
      self = base
   end select

end subroutine load_from_array

!> Write parametrization data to parameter array
subroutine dump_to_array(self, array, offset, mask, error)
   class(thirdorder_record), intent(in) :: self
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: offset
   type(thirdorder_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

end subroutine dump_to_array

elemental function count_mask(mask) result(ncount)
   type(thirdorder_mask), intent(in) :: mask
   integer :: ncount
   ncount = 0
end function count_mask


end module tblite_param_thirdorder

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Provides a definition for a token
module tomlf_de_token
   implicit none
   private

   public :: toml_token, stringify, token_kind, resize


   !> Possible token kinds
   type :: enum_token
      !> Invalid token found
      integer :: invalid = -1
      !> End of file
      integer :: eof = -2
      !> Unclosed group from inline table or array
      integer :: unclosed = -3
      !> Whitespace (space, tab)
      integer :: whitespace = 0
      !> Newline character (\r\n, \n)
      integer :: newline = 1
      !> Comments (#)
      integer :: comment = 2
      !> Separator in table path (.)
      integer :: dot = 3
      !> Separator in inline arrays and inline tables (,)
      integer :: comma = 4
      !> Separator in key-value pairs (=)
      integer :: equal = 5
      !> Beginning of an inline table ({)
      integer :: lbrace = 6
      !> End of an inline table (})
      integer :: rbrace = 7
      !> Beginning of an inline array or table header ([)
      integer :: lbracket = 8
      !> End of an inline array or table header (])
      integer :: rbracket = 9
      !> String literal
      integer :: string = 10
      !> String literal
      integer :: mstring = 11
      !> String literal
      integer :: literal = 12
      !> String literal
      integer :: mliteral = 13
      !> String literal
      integer :: keypath = 14
      !> Floating point value
      integer :: float = 15
      !> Integer value
      integer :: int = 16
      !> Boolean value
      integer :: bool = 17
      !> Datetime value
      integer :: datetime = 18
      !> Absence of value
      integer :: nil = 19
   end type enum_token

   !> Actual enumerator for token kinds
   type(enum_token), parameter :: token_kind = enum_token()

   !> Token containing
   type :: toml_token
      !> Kind of token
      integer :: kind = token_kind%newline
      !> Starting position of the token in character stream
      integer :: first = 0
      !> Last position of the token in character stream
      integer :: last = 0
      !> Identifier for the chunk index in case of buffered reading
      integer :: chunk = 0
   end type toml_token

   !> Reallocate a list of tokens
   interface resize
      module procedure :: resize_token
   end interface

contains

!> Reallocate list of tokens
pure subroutine resize_token(var, n)
   !> Instance of the array to be resized
   type(toml_token), allocatable, intent(inout) :: var(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(toml_token), allocatable :: tmp(:)
   integer :: this_size, new_size
   integer, parameter :: initial_size = 8

   if (allocated(var)) then
      this_size = size(var, 1)
      call move_alloc(var, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(var(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(var, 1))
      var(:this_size) = tmp(:this_size)
      deallocate(tmp)
   end if

end subroutine resize_token

!> Represent a token as string
pure function stringify(token) result(str)
   !> Token to represent as string
   type(toml_token), intent(in) :: token
   !> String representation of token
   character(len=:), allocatable :: str

   select case(token%kind)
   case default; str = "unknown"
   case(token_kind%invalid); str = "invalid sequence"
   case(token_kind%eof); str = "end of file"
   case(token_kind%unclosed); str = "unclosed group"
   case(token_kind%whitespace); str = "whitespace"
   case(token_kind%comment); str = "comment"
   case(token_kind%newline); str = "newline"
   case(token_kind%dot); str = "dot"
   case(token_kind%comma); str = "comma"
   case(token_kind%equal); str = "equal"
   case(token_kind%lbrace); str = "opening brace"
   case(token_kind%rbrace); str = "closing brace"
   case(token_kind%lbracket); str = "opening bracket"
   case(token_kind%rbracket); str = "closing bracket"
   case(token_kind%string); str = "string"
   case(token_kind%mstring); str = "multiline string"
   case(token_kind%literal); str = "literal"
   case(token_kind%mliteral); str = "multiline-literal"
   case(token_kind%keypath); str = "keypath"
   case(token_kind%int); str = "integer"
   case(token_kind%float); str = "float"
   case(token_kind%bool); str = "bool"
   case(token_kind%datetime); str = "datetime"
   case(token_kind%nil); str = "nil"
   end select
end function stringify

end module tomlf_de_token

program array
  use tomlf, only : toml_table, toml_array, get_value, &
                  & toml_parse, toml_error, len

  implicit none
  integer, dimension(:), allocatable  :: arr_data
  integer                             :: data_len, io, i
  type(toml_table), allocatable       :: table
  type(toml_array), pointer           :: arr
  type(toml_error), allocatable       :: parse_error

  open(newunit=io, file="array.toml")
  call toml_parse(table, io, parse_error)
  close(unit=io)
  if (allocated(parse_error)) then
    print*, "Error parsing table:"//parse_error%message
  end if

  call get_value(table, "data", arr)
  if (associated(arr)) then
    call get_value(arr, arr_data)
  end if

  print*, "data = ", arr_data

end program

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module test_timer
   use mctc_env_accuracy, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check
   use mctc_env_timer
   implicit none
   private

   public :: collect_timer

contains

subroutine collect_timer(testsuite)

   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("format-time", test_format_time), &
      & new_unittest("push-pop-get", test_push_pop) &
      & ]

end subroutine collect_timer


subroutine test_format_time(error)

   type(error_type), allocatable, intent(out) :: error
   character(len=:), allocatable :: s, expected
   real(wp) :: t

   t = 1.234_wp
   s = format_time(t)
   expected = repeat(' ', 19) // "1.234 sec"

   call check(error, s, expected)

end subroutine test_format_time


subroutine test_push_pop(error)

   type(error_type), allocatable, intent(out) :: error
   type(timer_type) :: tmr
   real(wp) :: elapsed
   integer :: t0, tnow, rate

   ! start the timer record
   call tmr%push("test")

   ! busy-wait for a small positive time interval
   call sleep(1)

   elapsed = tmr%get("test")

   call check(error, elapsed > 1.0_wp, .true., "timer elapsed time must be positive")

end subroutine test_push_pop

end module test_timer

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file tests/ddx_core.f90
!! Tests for ddx_core module
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-02-11

program test_ddx_core
use ddx_core
implicit none

character(len=255) :: testname, p_string
integer :: argc
integer :: p=30, i, j

integer, parameter :: nx=13, nrand=10
real(dp) :: x(3, nx)
!real(dp) :: alpha(4)=(/1d0, -1d0, 1d-294, 1d+294/)
!real(dp) :: alpha(4)=(/1d0, -1d0, 1d-10, 1d+2/)
real(dp) :: alpha(2)=(/1d0, -1d0/)
real(dp), external :: dnrm2

! Read argument (which tests to run)
argc = command_argument_count()
if (argc .eq. 0) then
    testname = "all"
else
    ! Read test name
    call get_command_argument(1, testname)
    select case(testname)
        case ('all')
        case ('init')
        case ('polleg')
        case ('ylmbas')
        case ('m2p')
        case ('m2p_bessel')
        case ('m2p_m2l')
        case ('m2p_adj')
        case ('m2p_bessel_grad')
        case ('l2p')
        case ('l2p_bessel')
        case ('l2p_adj')
        case ('l2p_bessel_grad')
        case ('m2m')
        case ('m2m_bessel')
        case ('m2m_adj')
        case ('m2m_bessel_adj')
        case ('l2l')
        case ('l2l_bessel')
        case ('l2l_adj')
        case ('l2l_bessel_adj')
        case ('m2l')
        case ('m2l_bessel')
        case ('m2l_adj')
        case ('m2l_bessel_adj')
        case ('tree_init')
!        case ('tree_m2m')
!        case ('tree_l2l')
!        case ('tree_m2l')
        case default
            stop "Wrong testname value"
    end select
    ! Read maximal degree p
    if (argc .gt. 1) then
        call get_command_argument(2, p_string)
        read(p_string, "(I3)") p
    end if
end if

! Set points x
x(:, 1) = zero
x(:, 2) = (/6d-1, 0d0, 0d0/)
x(:, 3) = (/-4d-1, 0d0, 0d0/)
x(:, 4) = (/0d0, 5d-1, 0d0/)
x(:, 5) = (/0d0, -7d-1, 0d0/)
x(:, 6) = (/0d0, 0d0, 8d-1/)
x(:, 7) = (/0d0, 0d0, -4d-1/)
x(:, 8) = (/3d-1, -2d-1, 0d0/)
x(:, 9) = (/-2d-1, -3d-1, 0d0/)
x(:, 10) = (/3d-1, 0d0, 6d-1/)
x(:, 11) = (/-3d-1, 0d0, 7d-1/)
x(:, 12) = (/3d-1, 5d-1, 3d-1/)
x(:, 13) = (/-2d-1, 4d-1, 3d-1/)

! Check correctness of info for valid and invalid input parameters of allocate_model
if ((testname .eq. 'all') .or. (testname .eq. 'init')) then
    call check_allocate_model_args()
end if

! Check polleg (Legendre polynomials)
if ((testname .eq. 'all') .or. (testname .eq. 'polleg')) then
    do i = 0, 2*p
        call check_polleg(i)
    end do
end if

! Check ylmbas (spherical harmonics)
if ((testname .eq. 'all') .or. (testname .eq. 'ylmbas')) then
    do i = 0, 2*p
        call check_ylmbas(i)
    end do
end if

! Check M2P
if ((testname .eq. 'all') .or. (testname .eq. 'm2p')) then
    do i = 1, size(alpha)
        do j = 0, p
            call check_m2p(j, alpha(i))
        end do
    end do
end if

! Check M2P Bessel
if ((testname .eq. 'all') .or. (testname .eq. 'm2p_bessel')) then
    do i = 1, size(alpha)
        do j = 0, 20
            call check_m2p_bessel(j, alpha(i))
        end do
    end do
end if

! Check M2P against M2L with pl=0
if ((testname .eq. 'all') .or. (testname .eq. 'm2p_m2l')) then
    do i = 1, size(alpha)
        do j = 0, p
            call check_m2p_m2l(j, alpha(i))
        end do
    end do
end if

! Check adjoint M2P
if ((testname .eq. 'all') .or. (testname .eq. 'm2p_adj')) then
    do i = 1, size(alpha)
        do j = 0, p
            call check_m2p_adj(j, alpha(i))
        end do
    end do
end if

! Check M2P Bessel gradient
!if ((testname .eq. 'all') .or. (testname .eq. 'm2p_bessel')) then
if (testname .eq. 'm2p_bessel_grad') then
    !do i = 1, size(alpha)
        !do j = 0, 20
            j = 5
            call check_m2p_bessel_grad(j)
        !end do
    !end do
end if

! Check L2P
if ((testname .eq. 'all') .or. (testname .eq. 'l2p')) then
    do i = 1, size(alpha)
        do j = 0, p
            call check_l2p(j, alpha(i))
        end do
    end do
end if

! Check L2P Bessel
if ((testname .eq. 'all') .or. (testname .eq. 'l2p_bessel')) then
    do i = 1, size(alpha)
        do j = 0, 20
            call check_l2p_bessel(j, alpha(i))
        end do
    end do
end if

! Check adjoint L2P
if ((testname .eq. 'all') .or. (testname .eq. 'l2p_adj')) then
    do i = 1, size(alpha)
        do j = 0, p
            call check_l2p_adj(j, alpha(i))
        end do
    end do
end if

! Check L2P Bessel gradient
!if ((testname .eq. 'all') .or. (testname .eq. 'l2p_bessel_grad')) then
if (testname .eq. 'l2p_bessel_grad') then
    !do i = 1, size(alpha)
        !do j = 0, 20
            j = 5
            call check_l2p_bessel_grad(j)
        !end do
    !end do
end if

! Check M2M
if ((testname .eq. 'all') .or. (testname .eq. 'm2m')) then
    do i = 1, size(alpha)
        do j = 0, p
            call check_m2m(j, alpha(i))
        end do
    end do
end if

! Check M2M Bessel manually
!if ((testname .eq. 'all') .or. (testname .eq. 'm2m_bessel')) then
if (testname .eq. 'm2m_bessel') then
    !do i = 1, size(alpha)
    j = 20
        !do j = 0, p
            call check_m2m_bessel(j)
        !end do
    !end do
end if

! Check adjoint M2M
if ((testname .eq. 'all') .or. (testname .eq. 'm2m_adj')) then
    do i = 1, size(alpha)
        do j = 0, p
            call check_m2m_adj(j, alpha(i))
        end do
    end do
end if

! Check adjoint M2M Bessel
!if ((testname .eq. 'all') .or. (testname .eq. 'm2m_bessel_adj')) then
if (testname .eq. 'm2m_bessel_adj') then
    do i = 1, 1 !size(alpha)
        do j = 0, p
            call check_m2m_bessel_adj(j, alpha(i))
        end do
    end do
end if

! Check L2L
if ((testname .eq. 'all') .or. (testname .eq. 'l2l')) then
    do i = 1, size(alpha)
        do j = 0, p
            call check_l2l(j, alpha(i))
        end do
    end do
end if

! Check L2L Bessel manually
!if ((testname .eq. 'all') .or. (testname .eq. 'l2l_bessel')) then
if (testname .eq. 'l2l_bessel') then
    !do i = 1, size(alpha)
    j = 10
        !do j = 0, p
            call check_l2l_bessel(j)
        !end do
    !end do
end if

! Check adjoint L2L
if ((testname .eq. 'all') .or. (testname .eq. 'l2l_adj')) then
    do i = 1, size(alpha)
        do j = 0, p
            call check_l2l_adj(j, alpha(i))
        end do
    end do
end if

! Check adjoint L2L Bessel
!if ((testname .eq. 'all') .or. (testname .eq. 'l2l_bessel_adj')) then
if (testname .eq. 'l2l_bessel_adj') then
    do i = 1, 1 !size(alpha)
        do j = 0, p
            call check_l2l_bessel_adj(j, alpha(i))
        end do
    end do
end if

! Check M2L
if ((testname .eq. 'all') .or. (testname .eq. 'm2l')) then
    do i = 1, size(alpha)
        do j = 0, p
        !do j = 1, 1
            call check_m2l(j, j, alpha(i))
        end do
        do j = 1, p
            call check_m2l(0, j, alpha(i))
            call check_m2l(j, 0, alpha(i))
        end do
    end do
end if

! Check M2L Bessel
!if ((testname .eq. 'all') .or. (testname .eq. 'm2l_bessel')) then
if (testname .eq. 'm2l_bessel') then
    j = 10
    call check_m2l_bessel(j)
end if

! Check adjoint M2L
if ((testname .eq. 'all') .or. (testname .eq. 'm2l_adj')) then
    do i = 1, size(alpha)
        do j = 0, p
            call check_m2l_adj(j, j, alpha(i))
        end do
        do j = 1, p
            call check_m2l_adj(0, j, alpha(i))
            call check_m2l_adj(j, 0, alpha(i))
        end do
    end do
end if

! Check adjoint M2L Bessel
!if ((testname .eq. 'all') .or. (testname .eq. 'm2l_bessel_adj')) then
if (testname .eq. 'm2l_bessel_adj') then
    do i = 1, 1 !size(alpha)
        do j = 0, p
            call check_m2l_bessel_adj(j, alpha(i))
        end do
    end do
end if

! Check recursive inertial tree
if ((testname .eq. 'all') .or. (testname .eq. 'tree_init')) then
    do i = 1, size(alpha)
        call check_tree_rib(alpha(i))
    end do
end if

!! Check tree M2M
!if ((testname .eq. 'all') .or. (testname .eq. 'tree_m2m')) then
!    do i = 1, size(alpha)
!        do j = 0, p
!            call check_tree_m2m(j, alpha(i))
!        end do
!    end do
!end if
!
!! Check tree L2L
!if ((testname .eq. 'all') .or. (testname .eq. 'tree_l2l')) then
!    do i = 1, size(alpha)
!        do j = 0, p
!            call check_tree_l2l(j, alpha(i))
!        end do
!    end do
!end if
!
!! Check tree M2L
!if ((testname .eq. 'all') .or. (testname .eq. 'tree_m2l')) then
!    do i = 1, size(alpha)
!        call check_tree_m2l(0, 0, alpha(i), 6d-2)
!        call check_tree_m2l(1, 0, alpha(i), 4d-2)
!        call check_tree_m2l(10, 0, alpha(i), 4d-2)
!        call check_tree_m2l(0, 1, alpha(i), 3d-2)
!        call check_tree_m2l(1, 1, alpha(i), 4d-3)
!        call check_tree_m2l(10, 1, alpha(i), 4d-3)
!        call check_tree_m2l(0, 10, alpha(i), 3d-2)
!        call check_tree_m2l(1, 10, alpha(i), 3d-3)
!        call check_tree_m2l(10, 10, alpha(i), 4d-9)
!        !call check_tree_m2l(20, 20, alpha(i), 1d-14)
!    end do
!end if

contains
!> Print error message and exit with provided error code
subroutine test_error(code, message)
    integer, intent(in) :: code
    character(len=*), intent(in) :: message
    write(0, "(A,A)") "ERROR: ", message
    write(0, "(A,I2)") "CODE:  ", code
    stop -1
end subroutine test_error

subroutine check_allocate_model_args()
    ! Example of correct args
    integer :: n=1, model=1, lmax=1, ngrid=1202, force=1, fmm=1, pm=0, pl=0, &
        & matvecmem=0, maxiter=10, &
        & jacobi_ndiis=10, nproc=1
    real(dp) :: x(10), y(10), z(10), rvdw(10), se=zero, eta=1d-1, &
        & eps=1.1d1, kappa=1d0
    type(ddx_type) :: ddx_data
    type(ddx_error_type) :: ddx_error
    integer :: i, j
    real(dp) :: tmp
    character(len=255) :: dummy_file_name = ''
    ! Generate coordinates and radii
    rvdw = 4d0
    do i = 1, 10
        x(i) = dble(2*i)
        y(i) = x(i)
        z(i) = x(i)
    end do
    ! Check correct input
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "correct test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check different correct inputs with different n <= 10 (hardcoded value)
    do i = 1, 10
        call allocate_model(i, x, y, z, rvdw, model, lmax, ngrid, force, fmm, &
            & pm, pl, se, eta, eps, kappa, matvecmem, &
            & maxiter, jacobi_ndiis, nproc, &
            & dummy_file_name, ddx_data, ddx_error)
        if (ddx_error % flag .ne. 0) call test_error(-1, "`nsph` test failed in " // &
            & "check_allocate_model_args()")
        call deallocate_model(ddx_data, ddx_error)
        call reset_error(ddx_error)
    end do
    ! Check incorrect input nsph <= 0
    i = 0
    call allocate_model(i, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`nsph` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    i = -1
    call allocate_model(i, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`nsph` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check all possible models (1, 2, 3) with other correct inputs
    do i = 1, 3
        write(*, *) "model=", i, n
        call allocate_model(n, x, y, z, rvdw, i, lmax, ngrid, force, fmm, pm, &
            & pl, se, eta, eps, kappa, matvecmem, &
            & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
        call print_error(ddx_error)
        if (ddx_error % flag .ne. 0) call test_error(-1, "`model` test failed in " // &
            & "check_allocate_model_args()")
        call deallocate_model(ddx_data, ddx_error)
        call reset_error(ddx_error)
    end do
    ! Check incorrect models
    i = -1
    call allocate_model(n, x, y, z, rvdw, i, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`model` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    i = 4
    call allocate_model(n, x, y, z, rvdw, i, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`model` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct lmax >= 0
    !do i = 0, 6
    do i = 1, 6
        call allocate_model(n, x, y, z, rvdw, model, i, ngrid, force, fmm, &
            & pm, pl, se, eta, eps, kappa, &
            & matvecmem, maxiter, jacobi_ndiis, &
            & nproc, dummy_file_name, ddx_data, ddx_error)
        if (ddx_error % flag .ne. 0) call test_error(-1, "`lmax` test failed in " // &
            & "check_allocate_model_args()")
        call deallocate_model(ddx_data, ddx_error)
        call reset_error(ddx_error)
    end do
    ! Check incorrect lmax < 0
    i = -1
    call allocate_model(n, x, y, z, rvdw, model, i, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`lmax` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct ngrid >= 0
    do i = 1, nllg
        j = ng0(i)
        call allocate_model(n, x, y, z, rvdw, model, lmax, j, force, fmm, pm, &
            & pl, se, eta, eps, kappa, matvecmem, &
            & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
        if (ddx_error % flag .ne. 0) call test_error(-1, "`ngrid` test failed in " // &
            & "check_allocate_model_args()")
        call deallocate_model(ddx_data, ddx_error)
        call reset_error(ddx_error)
    end do
    ! Check incorrect ngrid < 0
    i = -1
    call allocate_model(n, x, y, z, rvdw, model, lmax, i, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`ngrid` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct force (0, 1)
    do i = 0, 1
        call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, i, fmm, pm, &
            & pl, se, eta, eps, kappa, matvecmem, &
            & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
        if (ddx_error % flag .ne. 0) call test_error(-1, "`force` test failed in " // &
            & "check_allocate_model_args()")
        call deallocate_model(ddx_data, ddx_error)
        call reset_error(ddx_error)
    end do
    ! Check incorrect force
    i = -1
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, i, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`force` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    i = 2
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, i, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`force` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct fmm (0, 1)
    do i = 0, 1
        call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, i, &
            & pm, pl, se, eta, eps, kappa, &
            & matvecmem, maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
        if (ddx_error % flag .ne. 0) call test_error(-1, "`fmm` test failed in " // &
            & "check_allocate_model_args()")
        call deallocate_model(ddx_data, ddx_error)
        call reset_error(ddx_error)
    end do
    ! Check incorrect fmm
    i = -1
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, i, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`fmm` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    i = 2
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, i, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`fmm` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct pm (ignored if fmm=0)
    j = 0
    do i = -2, 2
        call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, j, &
            & i, pl, se, eta, eps, kappa, matvecmem, &
            & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
        if (ddx_error % flag .ne. 0) call test_error(-1, "`pm` test failed in " // &
            & "check_allocate_model_args()")
        call deallocate_model(ddx_data, ddx_error)
        call reset_error(ddx_error)
    end do
    ! Check correct pm (fmm=1)
    j = 1
    do i = 0, 20, 5
        call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, j, &
            & i, pl, se, eta, eps, kappa, matvecmem, &
            & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
        if (ddx_error % flag .ne. 0) call test_error(-1, "`pm` test failed in " // &
            & "check_allocate_model_args()")
        call deallocate_model(ddx_data, ddx_error)
        call reset_error(ddx_error)
    end do
    i = -1
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, j, &
        & i, pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`pm` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check incorrect pm (fmm=1)
    j = 1
    i = -2
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, j, i, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`pm` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct pl (ignored if fmm=0)
    j = 0
    do i = -2, 2
        call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, j, &
            & pm, i, se, eta, eps, kappa, matvecmem, &
            & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
        if (ddx_error % flag .ne. 0) call test_error(-1, "`pl` test failed in " // &
            & "check_allocate_model_args()")
        call deallocate_model(ddx_data, ddx_error)
        call reset_error(ddx_error)
    end do
    ! Check correct pl (fmm=1)
    j = 1
    do i = 0, 20, 5
        call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, j, &
            & pm, i, se, eta, eps, kappa, matvecmem, &
            & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
        if (ddx_error % flag .ne. 0) call test_error(-1, "`pl` test failed in " // &
            & "check_allocate_model_args()")
        call deallocate_model(ddx_data, ddx_error)
        call reset_error(ddx_error)
    end do
    i = -1
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, j, &
        & pm, i, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`pl` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check incorrect pl (fmm=1)
    j = 1
    i = -2
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, j, pm, &
        & i, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`pl` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct se (interval [-1,1])
    tmp = -one
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, tmp, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`se` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    tmp = zero
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, tmp, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`se` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    tmp = one
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, tmp, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`se` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check incorrect se
    tmp = 1.01d0
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, tmp, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`se` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    tmp = -1.01d0
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, tmp, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`se` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct eta (interval [0,1])
    tmp = pt5
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, tmp, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`eta` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    tmp = one
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, tmp, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`eta` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check incorrect eta
    tmp = -0.0000005
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, tmp, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`eta` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    tmp = 1.01d0
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, tmp, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`eta` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    tmp = -1d-2
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, tmp, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`eta` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct eps
    tmp = 1.01d0
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, tmp, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`eps` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    tmp = dble(1000)
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, tmp, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`eps` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check incorrect eps
    tmp = zero
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, tmp, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`eps` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    tmp = pt5
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, tmp, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`eps` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    tmp = one
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, tmp, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`eps` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    tmp = -1d-2
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, tmp, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`eps` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct kappa
    tmp = 1d-2
    j = 3 ! only referenced in case of LPB model
    call allocate_model(n, x, y, z, rvdw, j, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, tmp, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`kappa` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    tmp = -1d-2 ! not referenced in case of COSMO and PCM models
    do j = 1, 2
        call allocate_model(n, x, y, z, rvdw, j, lmax, ngrid, force, fmm, pm, &
            & pl, se, eta, eps, tmp, matvecmem, &
            & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
        if (ddx_error % flag .ne. 0) call test_error(-1, "`kappa` test failed in " // &
            & "check_allocate_model_args()")
        call deallocate_model(ddx_data, ddx_error)
        call reset_error(ddx_error)
    end do
    ! Check incorrect kappa
    j = 3
    tmp = -1d-2
    call allocate_model(n, x, y, z, rvdw, j, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, tmp, matvecmem, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`kappa` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct matvecmem
    i = 0
    call allocate_model(n, x, y, z, rvdw, j, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, i, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`matvecmem` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    i = 1
    call allocate_model(n, x, y, z, rvdw, j, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, i, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`matvecmem` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    i = -1
    call allocate_model(n, x, y, z, rvdw, j, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, i, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`matvecmem` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    i = 2
    call allocate_model(n, x, y, z, rvdw, j, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, i, &
        & maxiter, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`matvecmem` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct maxiter
    i = 1
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & i, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`maxiter` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    i = 1000000
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & i, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`maxiter` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check incorrect maxiter
    i = 0
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & i, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`maxiter` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    i = -1
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & i, jacobi_ndiis, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`maxiter` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct ndiis
    i = 0
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, i, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`jacobi_ndiis` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    i = 1
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, i, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`jacobi_ndiis` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    i = 1000
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, i, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`jacobi_ndiis` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check incorrect jacobi_ndiis
    i = -1
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, i, nproc, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`jacobi_ndiis` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check correct nproc
    i = 0
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, i, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`nproc` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    i = 1
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, i, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`nproc` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    ! Check incorrect nproc
    i = 2
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, i, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .ne. 0) call test_error(-1, "`nproc` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
    i = -1
    call allocate_model(n, x, y, z, rvdw, model, lmax, ngrid, force, fmm, pm, &
        & pl, se, eta, eps, kappa, matvecmem, &
        & maxiter, jacobi_ndiis, i, dummy_file_name, ddx_data, ddx_error)
    if (ddx_error % flag .eq. 0) call test_error(-1, "`nproc` test failed in " // &
        & "check_allocate_model_args()")
    call deallocate_model(ddx_data, ddx_error)
    call reset_error(ddx_error)
end subroutine check_allocate_model_args

! Check Legendre polynomials
subroutine check_polleg(p)
    ! Input
    integer, intent(in) :: p
    ! Local variables
    real(dp) :: c(3), rho, ctheta, stheta, cphi, sphi, vplm((p+1)**2), &
        & vplm2((p+1)**2), err
    real(dp), parameter :: threshold=2d-15
    logical :: ok
    integer :: i
    real(dp), external :: dnrm2
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check polleg"
    print "(A,I0)", " p=", p
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    ! Init output, since P_l^m for negative m are not set in polleg procedure
    vplm = zero
    vplm2 = zero
    ! Check against baseline
    do i = 1, nx
        c = x(:, i)
        call carttosph(c, rho, ctheta, stheta, cphi, sphi)
        call polleg_baseline(ctheta, stheta, p, vplm)
        call polleg(ctheta, stheta, p, vplm2)
        err = dnrm2((p+1)**2, vplm-vplm2, 1) / dnrm2((p+1)**2, vplm, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
end subroutine check_polleg

! Check spherical harmonics
subroutine check_ylmbas(p)
    ! Input
    integer, intent(in) :: p
    ! Local variables
    real(dp) :: c(3), rho, ctheta, stheta, cphi, sphi, vplm((p+1)**2), &
        & vylm((p+1)**2), vylm2((p+1)**2), vcos(p+1), vsin(p+1), err, &
        & vscales((p+1)**2), v4pi2lp1(p+1), vscales_rel((p+1)**2), &
        & threshold
    logical :: ok
    integer :: i
    real(dp), external :: dnrm2
    ! Set scaling factors
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check ylmbas"
    print "(A,I0)", " p=", p
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    threshold = dble((p+2)**2) * 2d-16
    ! Check against baseline
    do i = 2, nx
        c = x(:, i)
        call ylmbas_baseline(c, p, vscales, vylm, vplm, vcos, vsin)
        call ylmbas(c, rho, ctheta, stheta, cphi, sphi, p, vscales, vylm2, &
            & vplm, vcos, vsin)
        err = dnrm2((p+1)**2, vylm-vylm2, 1) / dnrm2((p+1)**2, vylm, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
end subroutine check_ylmbas

! Check M2P
subroutine check_m2p(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    real(dp) :: y(3, nx), r, c(3), vscales((p+1)**2), v4pi2lp1(p+1), &
        & vscales_rel((p+1)**2), src_m((p+1)**2, nrand), dst_v(nrand), &
        & dst_v2(nrand), err, threshold
    logical :: ok
    integer :: i, j, iseed(4)
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = alpha / sqrt(13d-2) * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    ! Generate src_m randomly
    call dlarnv(3, iseed, nrand*((p+1)**2), src_m)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check M2P"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    threshold = dble(p+3) * 3d-16
    ! Check against the baseline, i=1 is ignored since it y(:,1)=zero
    do i = 2, nx
        c = y(:, i)
        ! Check alpha=beta=zero
        do j = 1, nrand
            call fmm_m2p(c, r, p, vscales_rel, zero, src_m(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v2, 1)
        ok = err .eq. zero
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=one, beta=zero
        do j = 1, nrand
            call fmm_m2p_baseline(c, r, p, vscales, one, src_m(:, j), zero, &
                & dst_v(j))
            call fmm_m2p(c, r, p, vscales_rel, one, src_m(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha!={zero,one}, beta=zero
        do j = 1, nrand
            call fmm_m2p_baseline(c, r, p, vscales, -three, src_m(:, j), &
                & zero, dst_v(j))
            call fmm_m2p(c, r, p, vscales_rel, -three, src_m(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=zero, beta=one
        do j = 1, nrand
            call fmm_m2p(c, r, p, vscales_rel, zero, src_m(:, j), one, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=zero, beta!={zero,one}
        do j = 1, nrand
            dst_v(j) = -pt5 * dst_v(j)
            call fmm_m2p(c, r, p, vscales_rel, zero, src_m(:, j), -pt5, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha!={zero,one}, beta!={zero,one}
        do j = 1, nrand
            call fmm_m2p_baseline(c, r, p, vscales, -three, src_m(:, j), pt5, &
                & dst_v(j))
            call fmm_m2p(c, r, p, vscales_rel, -three, src_m(:, j), pt5, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_m2p

! Check M2P Bessel
subroutine check_m2p_bessel(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    real(dp) :: y(3, nx), r, c(3), vscales((p+1)**2), v4pi2lp1(p+1), &
        & vscales_rel((p+1)**2), src_m((p+1)**2, nrand), dst_v(nrand), &
        & dst_v2(nrand), err, threshold
    logical :: ok
    integer :: i, j, iseed(4)
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = alpha / sqrt(13d-2) * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    ! Generate src_m randomly
    call dlarnv(3, iseed, nrand*((p+1)**2), src_m)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check M2P"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    threshold = dble(p+3) * 3d-14
    ! Check against the baseline, i=1 is ignored since y(:,1)=zero
    do i = 2, nx
        c = y(:, i)
        ! Check alpha=beta=zero
        do j = 1, nrand
            call fmm_m2p_bessel(c, r, p, vscales, zero, src_m(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v2, 1)
        ok = err .eq. zero
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=one, beta=zero
        do j = 1, nrand
            call fmm_m2p_bessel_baseline(c, r, p, vscales, one, src_m(:, j), zero, &
                & dst_v(j))
            call fmm_m2p_bessel(c, r, p, vscales, one, src_m(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha!={zero,one}, beta=zero
        do j = 1, nrand
            call fmm_m2p_bessel_baseline(c, r, p, vscales, -three, src_m(:, j), &
                & zero, dst_v(j))
            call fmm_m2p_bessel(c, r, p, vscales, -three, src_m(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=zero, beta=one
        do j = 1, nrand
            call fmm_m2p_bessel(c, r, p, vscales, zero, src_m(:, j), one, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=zero, beta!={zero,one}
        do j = 1, nrand
            dst_v(j) = -pt5 * dst_v(j)
            call fmm_m2p_bessel(c, r, p, vscales, zero, src_m(:, j), -pt5, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha!={zero,one}, beta!={zero,one}
        do j = 1, nrand
            call fmm_m2p_bessel_baseline(c, r, p, vscales, -three, src_m(:, j), pt5, &
                & dst_v(j))
            call fmm_m2p_bessel(c, r, p, vscales, -three, src_m(:, j), pt5, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_m2p_bessel

! Check M2P by M2L with pl=0
subroutine check_m2p_m2l(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    real(dp) :: y(3, nx), r, c(3), vscales((p+1)**2), v4pi2lp1(p+1), &
        & vscales_rel((p+1)**2), src_m((p+1)**2, nrand), dst_v(nrand), &
        & dst_v2(nrand), err, &
        & vcnk((2*p+1)*(p+1)), &
        & m2l_ztranslate_coef(p+1, 1, 1), &
        & m2l_ztranslate_adj_coef(1, 1, p+1)
    logical :: ok
    integer :: i, j, iseed(4)
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = alpha / sqrt(13d-2) * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    call fmm_constants(p, p, 0, vcnk, m2l_ztranslate_coef, &
        & m2l_ztranslate_adj_coef)
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    ! Generate src_m randomly
    call dlarnv(3, iseed, nrand*((p+1)**2), src_m)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check M2P by M2L with pl=0"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    ! Check against the baseline, i=1 is ignored since it y(:,1)=zero
    do i = 2, nx
        c = y(:, i)
        ! Check alpha=beta=zero
        do j = 1, nrand
            call fmm_m2p(c, r, p, vscales_rel, zero, src_m(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v2, 1)
        ok = err .eq. zero
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        !if (.not. ok) stop 1
        ! Check alpha=one, beta=zero
        do j = 1, nrand
            call fmm_m2l_rotation(-c, r, r, p, 0, vscales, &
                & m2l_ztranslate_coef, vscales_rel(1), src_m(:, j), zero, &
                & dst_v(j))
            call fmm_m2p(c, r, p, vscales_rel, one, src_m(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. 2d-15
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha!={zero,one}, beta=zero
        do j = 1, nrand
            call fmm_m2l_rotation(-c, r, r, p, 0, vscales, &
                & m2l_ztranslate_coef, -three*vscales_rel(1), src_m(:, j), &
                & zero, dst_v(j))
            call fmm_m2p(c, r, p, vscales_rel, -three, src_m(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. 4d-15
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=zero, beta=one
        do j = 1, nrand
            call fmm_m2p(c, r, p, vscales_rel, zero, src_m(:, j), one, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. 4d-15
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=zero, beta!={zero,one}
        do j = 1, nrand
            dst_v(j) = -pt5 * dst_v(j)
            call fmm_m2p(c, r, p, vscales_rel, zero, src_m(:, j), -pt5, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. 4d-15
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha!={zero,one}, beta!={zero,one}
        do j = 1, nrand
            call fmm_m2l_rotation(-c, r, r, p, 0, vscales, &
                & m2l_ztranslate_coef, -three*vscales_rel(1), src_m(:, j), &
                & pt5, dst_v(j))
            call fmm_m2p(c, r, p, vscales_rel, -three, src_m(:, j), pt5, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. 4d-15
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_m2p_m2l

! Check adjoint M2P
subroutine check_m2p_adj(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    real(dp) :: y(3, nx), r, c(3), vscales((p+1)**2), v4pi2lp1(p+1), &
        & vscales_rel((p+1)**2), dst_m((p+1)**2), dst_m2((p+1)**2), err, &
        & threshold
    logical :: ok
    integer :: i
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = alpha / sqrt(13d-2) * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check adjoint M2P"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    threshold = dble(p+3) * 3d-16
    ! Check against the baseline, i=1 is ignored since it y(:,1)=zero
    do i = 2, nx
        c = y(:, i)
        ! Check src_q=beta=zero
        call fmm_m2p_adj(c, zero, r, p, vscales_rel, zero, dst_m2)
        err = dnrm2((p+1)**2, dst_m2, 1)
        ok = err .eq. zero
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check src_q=one, beta=zero
        call fmm_m2p_adj_baseline(c, one, r, p, vscales, zero, dst_m)
        call fmm_m2p_adj(c, one, r, p, vscales_rel, zero, dst_m2)
        err = dnrm2((p+1)**2, dst_m-dst_m2, 1) / dnrm2((p+1)**2, dst_m, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check src_q!={zero,one}, beta=zero
        call fmm_m2p_adj_baseline(c, -three, r, p, vscales, zero, dst_m)
        call fmm_m2p_adj(c, -three, r, p, vscales_rel, zero, dst_m2)
        err = dnrm2((p+1)**2, dst_m-dst_m2, 1) / dnrm2((p+1)**2, dst_m, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=zero, beta=one
        call fmm_m2p_adj(c, zero, r, p, vscales_rel, one, dst_m2)
        err = dnrm2((p+1)**2, dst_m-dst_m2, 1) / dnrm2((p+1)**2, dst_m, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=zero, beta!={zero,one}
        call fmm_m2p_adj_baseline(c, zero, r, p, vscales, -pt5, dst_m)
        call fmm_m2p_adj(c, zero, r, p, vscales_rel, -pt5, dst_m2)
        err = dnrm2((p+1)**2, dst_m-dst_m2, 1) / dnrm2((p+1)**2, dst_m, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha!={zero,one}, beta!={zero,one}
        call fmm_m2p_adj_baseline(c, -three, r, p, vscales, pt5, dst_m)
        call fmm_m2p_adj(c, -three, r, p, vscales_rel, pt5, dst_m2)
        err = dnrm2((p+1)**2, dst_m-dst_m2, 1) / dnrm2((p+1)**2, dst_m, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_m2p_adj

! Check M2P Bessel gradient
subroutine check_m2p_bessel_grad(p)
    ! Inputs
    integer, intent(in) :: p
    ! Local variables
    real(dp) :: x(3), r, src_r
    real(dp) :: src_m((p+1)**2), vscales((p+2)**2), &
        & vscales_rel((p+2)**2), v4pi2lp1(p+2), &
        & work(p+2), src_sk(p+2), sk(p+1), dk(p+1), basloc((p+1)**2), &
        & dbsloc(3, (p+1)**2), vplm((p+1)**2), vcos(p+1), vsin(p+1), &
        & dst_g1(3), dst_g2(3)
    complex(dp) :: work_complex(p+2)
    real(dp), external :: dnrm2
    integer :: i, l, m, indm
    type(ddx_params_type) :: params
    type(ddx_constants_type) :: constants
    ! Set params
    params % lmax = p
    constants % nbasis = (p+1)**2
    ! Compute special FMM constants
    call ylmscale(p+1, vscales, v4pi2lp1, vscales_rel)
    allocate(constants % vscales((p+2)**2))
    constants % vscales = vscales
    x = 7.5d0 * (/1.1d0, -2d0, one/)
    r = dnrm2(3, x, 1)
    src_r = one
    src_m = zero
    do i = 0, p
        !src_m(i*i+i+1) = 10d0 ** (-i)
        src_m(i*i+1:i*i+2*i+1) = 10d0 ** (-i)
    end do
    !src_m = one
    call modified_spherical_bessel_second_kind(p, r, sk, dk, &
        & work_complex)
    call modified_spherical_bessel_second_kind(p+1, src_r, src_sk, work, &
        & work_complex)
    call dbasis(params, constants, x/r, basloc, dbsloc, vplm, vcos, vsin)
    dst_g1 = zero
    do l = 0, p
        do m = -l, l
            indm = l*l+l+1+m
            dst_g1 = dst_g1 + src_m(indm)/src_sk(l+1)/r*(dk(l+1)*x* &
                & basloc(indm)+sk(l+1)*dbsloc(:, indm))
        end do
    end do
    write(*, *) dst_g1
    call fmm_m2p_bessel_grad(x, src_r, p, vscales, one, src_m, zero, dst_g2)
    write(*, *) dst_g2
    deallocate(constants % vscales)
end subroutine check_m2p_bessel_grad

! Check L2P
subroutine check_l2p(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    real(dp) :: y(3, nx), r, c(3), vscales((p+1)**2), v4pi2lp1(p+1), &
        & vscales_rel((p+1)**2), src_l((p+1)**2, nrand), dst_v(nrand), &
        & dst_v2(nrand), err, threshold
    logical :: ok
    integer :: i, j, iseed(4)
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = 1.25d0 * alpha * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    ! Generate src_m randomly
    call dlarnv(3, iseed, nrand*((p+1)**2), src_l)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check L2P"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    threshold = dble(p+1) * 2d-15
    ! Check against the baseline
    do i = 1, nx
        c = y(:, i)
        ! Check alpha=beta=zero
        do j = 1, nrand
            call fmm_l2p(c, r, p, vscales_rel, zero, src_l(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v2, 1)
        ok = err .eq. zero
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=one, beta=zero
        do j = 1, nrand
            call fmm_l2p_baseline(c, r, p, vscales, one, src_l(:, j), zero, &
                & dst_v(j))
            call fmm_l2p(c, r, p, vscales_rel, one, src_l(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha!={zero,one}, beta=zero
        do j = 1, nrand
            call fmm_l2p_baseline(c, r, p, vscales, -three, src_l(:, j), &
                & zero, dst_v(j))
            call fmm_l2p(c, r, p, vscales_rel, -three, src_l(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=zero, beta=one
        do j = 1, nrand
            call fmm_l2p(c, r, p, vscales_rel, zero, src_l(:, j), one, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=zero, beta!={zero,one}
        do j = 1, nrand
            call fmm_l2p_baseline(c, r, p, vscales, zero, src_l(:, j), -pt5, &
                & dst_v(j))
            call fmm_l2p(c, r, p, vscales_rel, zero, src_l(:, j), -pt5, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha!={zero,one}, beta!={zero,one}
        do j = 1, nrand
            call fmm_l2p_baseline(c, r, p, vscales, -three, src_l(:, j), pt5, &
                & dst_v(j))
            call fmm_l2p(c, r, p, vscales_rel, -three, src_l(:, j), pt5, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_l2p

! Check L2P Bessel
subroutine check_l2p_bessel(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    real(dp) :: y(3, nx), r, c(3), vscales((p+1)**2), v4pi2lp1(p+1), &
        & vscales_rel((p+1)**2), src_l((p+1)**2, nrand), dst_v(nrand), &
        & dst_v2(nrand), err, threshold
    logical :: ok
    integer :: i, j, iseed(4)
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = 1.25d0 * alpha * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    ! Generate src_m randomly
    call dlarnv(3, iseed, nrand*((p+1)**2), src_l)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check L2P"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    threshold = dble(p+1) * 2d-15
    ! Check against the baseline
    do i = 1, nx
        c = y(:, i)
        ! Check alpha=beta=zero
        do j = 1, nrand
            call fmm_l2p_bessel(c, r, p, vscales, zero, src_l(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v2, 1)
        ok = err .eq. zero
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=one, beta=zero
        do j = 1, nrand
            call fmm_l2p_bessel_baseline(c, r, p, vscales, one, src_l(:, j), zero, &
                & dst_v(j))
            call fmm_l2p_bessel(c, r, p, vscales, one, src_l(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha!={zero,one}, beta=zero
        do j = 1, nrand
            call fmm_l2p_bessel_baseline(c, r, p, vscales, -three, src_l(:, j), &
                & zero, dst_v(j))
            call fmm_l2p_bessel(c, r, p, vscales, -three, src_l(:, j), zero, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=zero, beta=one
        do j = 1, nrand
            call fmm_l2p_bessel(c, r, p, vscales, zero, src_l(:, j), one, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha=zero, beta!={zero,one}
        do j = 1, nrand
            call fmm_l2p_bessel_baseline(c, r, p, vscales, zero, src_l(:, j), -pt5, &
                & dst_v(j))
            call fmm_l2p_bessel(c, r, p, vscales, zero, src_l(:, j), -pt5, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        ! Check alpha!={zero,one}, beta!={zero,one}
        do j = 1, nrand
            call fmm_l2p_bessel_baseline(c, r, p, vscales, -three, src_l(:, j), pt5, &
                & dst_v(j))
            call fmm_l2p_bessel(c, r, p, vscales, -three, src_l(:, j), pt5, &
                & dst_v2(j))
        end do
        err = dnrm2(nrand, dst_v-dst_v2, 1) / dnrm2(nrand, dst_v, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_l2p_bessel

! Check adjoint L2P
subroutine check_l2p_adj(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    real(dp) :: y(3, nx), r, c(3), vscales((p+1)**2), v4pi2lp1(p+1), &
        & vscales_rel((p+1)**2), dst_l((p+1)**2), dst_l2((p+1)**2), err, &
        & threshold
    logical :: ok
    integer :: i
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = 1.25d0 * alpha * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check adjoint L2P"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    threshold = dble(p+2) * 2d-16
    ! Check against the baseline
    do i = 1, nx
        c = y(:, i)
        call fmm_l2p_adj(c, zero, r, p, vscales_rel, zero, dst_l2)
        err = dnrm2((p+1)**2, dst_l2, 1)
        ok = err .eq. zero
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        call fmm_l2p_adj_baseline(c, one, r, p, vscales, zero, dst_l)
        call fmm_l2p_adj(c, one, r, p, vscales_rel, zero, dst_l2)
        err = dnrm2((p+1)**2, dst_l-dst_l2, 1) / dnrm2((p+1)**2, dst_l, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        call fmm_l2p_adj_baseline(c, -three, r, p, vscales, zero, dst_l)
        call fmm_l2p_adj(c, -three, r, p, vscales_rel, zero, dst_l2)
        err = dnrm2((p+1)**2, dst_l-dst_l2, 1) / dnrm2((p+1)**2, dst_l, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        call fmm_l2p_adj(c, zero, r, p, vscales_rel, one, dst_l2)
        err = dnrm2((p+1)**2, dst_l-dst_l2, 1) / dnrm2((p+1)**2, dst_l, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        call fmm_l2p_adj_baseline(c, zero, r, p, vscales, -pt5, dst_l)
        call fmm_l2p_adj(c, zero, r, p, vscales_rel, -pt5, dst_l2)
        err = dnrm2((p+1)**2, dst_l-dst_l2, 1) / dnrm2((p+1)**2, dst_l, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
        call fmm_l2p_adj_baseline(c, -three, r, p, vscales, pt5, dst_l)
        call fmm_l2p_adj(c, -three, r, p, vscales_rel, pt5, dst_l2)
        err = dnrm2((p+1)**2, dst_l-dst_l2, 1) / dnrm2((p+1)**2, dst_l, 1)
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_l2p_adj

! Check L2P Bessel gradient
subroutine check_l2p_bessel_grad(p)
    ! Inputs
    integer, intent(in) :: p
    ! Local variables
    real(dp) :: x(3), r, src_r
    real(dp) :: src_l((p+1)**2), vscales((p+2)**2), &
        & vscales_rel((p+2)**2), v4pi2lp1(p+2), &
        & work(p+2), src_si(p+2), si(p+1), di(p+1), basloc((p+1)**2), &
        & dbsloc(3, (p+1)**2), vplm((p+1)**2), vcos(p+1), vsin(p+1), &
        & dst_g1(3), dst_g2(3)
    complex(dp) :: work_complex(p+2)
    real(dp), external :: dnrm2
    integer :: i, l, m, indm
    type(ddx_params_type) :: params
    type(ddx_constants_type) :: constants
    ! Set params
    params % lmax = p
    constants % nbasis = (p+1)**2
    ! Compute special FMM constants
    call ylmscale(p+1, vscales, v4pi2lp1, vscales_rel)
    allocate(constants % vscales((p+2)**2))
    constants % vscales = vscales
    x = 7.5d-1 * (/one, zero, zero/)
    r = dnrm2(3, x, 1)
    src_r = one
    src_l = zero
    do i = 0, p
        !src_l(i*i+i+1) = 10d0 ** (-i)
        src_l(i*i+1:i*i+2*i+1) = 10d0 ** (-i)
    end do
    !src_l = one
    call modified_spherical_bessel_first_kind(p, r, si, di, &
        & work_complex)
    call modified_spherical_bessel_first_kind(p+1, src_r, src_si, work, &
        & work_complex)
    call dbasis(params, constants, x/r, basloc, dbsloc, vplm, vcos, vsin)
    dst_g1 = zero
    do l = 0, p
        do m = -l, l
            indm = l*l+l+1+m
            dst_g1 = dst_g1 + src_l(indm)/src_si(l+1)/r*(di(l+1)*x* &
                & basloc(indm)+si(l+1)*dbsloc(:, indm))
        end do
    end do
    write(*, *) dst_g1
    call fmm_l2p_bessel_grad(x, src_r, p, vscales, one, src_l, zero, dst_g2)
    write(*, *) dst_g2
    deallocate(constants % vscales)
end subroutine check_l2p_bessel_grad

! Check M2M
subroutine check_m2m(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    integer, parameter :: nrand=10
    real(dp) :: y(3, nx), r, dst_r, c(3), vscales((p+1)**2), v4pi2lp1(p+1), &
        & vscales_rel((p+1)**2), vcnk((2*p+1)*(p+1)), &
        & m2l_ztranslate_coef(p+1, 1, 1), &
        & m2l_ztranslate_adj_coef(1, 1, p+1), &
        & src_m((p+1)**2, nrand), dst_m((p+1)**2, nrand), &
        & dst_m2((p+1)**2, nrand), err, threshold
    logical :: ok
    integer :: i, j, iseed(4), ndst_m
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = alpha * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    call fmm_constants(p, p, 0, vcnk, m2l_ztranslate_coef, &
        & m2l_ztranslate_adj_coef)
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    ! Generate src_m randomly
    ndst_m = nrand * ((p+1)**2)
    call dlarnv(3, iseed, ndst_m, src_m)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check M2M"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    threshold = (p+3) * 1d-15
    ! Check against baseline implementation
    do i = 1, nx
        c = y(:, i)
        dst_r = r + dnrm2(3, c, 1)
        ! Check alpha=beta=zero
        do j = 1, nrand
            call fmm_m2m_rotation(c, r, dst_r, p, vscales, vcnk, zero, &
                & src_m(:, j), zero, dst_m2(:, j))
        end do
        err = dnrm2(ndst_m, dst_m2, 1)
        ok = err .eq. zero
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
        ! Check alpha=one, beta=zero
        dst_m = zero
        do j = 1, nrand
            call fmm_m2m_baseline(c, r, dst_r, p, vscales, src_m(:, j), &
                & dst_m(:, j))
            call fmm_m2m_rotation(c, r, dst_r, p, vscales, vcnk, one, &
                & src_m(:, j), zero, dst_m2(:, j))
        end do
        err = dnrm2(ndst_m, dst_m-dst_m2, 1) / dnrm2(ndst_m, dst_m, 1)
        ok = err .le. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        ! Check alpha!={zero,one}, beta=zero
        do j = 1, nrand
            call fmm_m2m_rotation(c, r, dst_r, p, vscales, vcnk, -three, &
                & src_m(:, j), zero, dst_m2(:, j))
        end do
        err = dnrm2(ndst_m, three*dst_m+dst_m2, 1) / dnrm2(ndst_m, dst_m, 1)
        ok = err .le. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
        ! Check alpha=zero, beta=one
        dst_m2 = dst_m
        do j = 1, nrand
            call fmm_m2m_rotation(c, r, dst_r, p, vscales, vcnk, zero, &
                & src_m(:, j), one, dst_m2(:, j))
        end do
        err = dnrm2(ndst_m, dst_m-dst_m2, 1) / dnrm2(ndst_m, dst_m, 1)
        ok = err .le. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
        ! Check alpha=zero, beta!={zero,one}
        dst_m2 = dst_m
        do j = 1, nrand
            call fmm_m2m_rotation(c, r, dst_r, p, vscales, vcnk, zero, &
                & src_m(:, j), -pt5, dst_m2(:, j))
        end do
        err = dnrm2((p+1)**2, pt5*dst_m+dst_m2, 1) / &
            & dnrm2((p+1)**2, dst_m, 1) / four
        ok = err .le. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
        ! Check alpha!={zero,one}, beta!={zero,one}
        dst_m2 = two * dst_m
        do j = 1, nrand
            call fmm_m2m_rotation(c, r, dst_r, p, vscales, vcnk, -three, &
                & src_m(:, j), pt5, dst_m2(:, j))
        end do
        err = dnrm2((p+1)**2, two*dst_m+dst_m2, 1) / &
            & dnrm2((p+1)**2, dst_m, 1) / four
        ok = err .le. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_m2m

subroutine check_m2m_bessel(p)
    ! Inputs
    integer, intent(in) :: p
    ! Local variables
    real(dp) :: x(3), src_c(3), src_r, dst_r, dst_v, dst_v2, dst_v3
    real(dp) :: src_m((p+1)**2), dst_m((p+1)**2), vscales((p+1)**2), &
        & vscales_rel((p+1)**2), v4pi2lp1(p+1), kappa
    real(dp), external :: dnrm2
    integer :: i
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    x = 7.5d0 * (/one, -1.1d0, one/)
    src_c = 1.01d0 * (/-one, one, one/)
    src_r = one
    dst_r = src_r + dnrm2(3, src_c, 1)
    src_m = zero
    do i = 3, p
        !src_m(i*i+i+1) = 10d0 ** (-i)
        !src_m(i*i+1:i*i+2*i+1) = 10d0 ** (-i)
    end do
    src_m = one
    kappa = 1d-2
    call fmm_m2p_bessel_baseline(kappa*(x-src_c), kappa*src_r, p, vscales, one, src_m, &
        & zero, dst_v)
    call fmm_m2m_bessel_rotation(src_c, src_r, dst_r, kappa, p, vscales, one, &
        & src_m, zero, dst_m)
    call fmm_m2p_bessel_baseline(kappa*x, kappa*dst_r, p, vscales, one, dst_m, zero, &
        & dst_v2)
    call fmm_m2m_bessel_rotation(-src_c, dst_r, src_r, kappa, p, vscales, one, &
        & dst_m, zero, src_m)
    call fmm_m2p_bessel_baseline(kappa*(x-src_c), kappa*src_r, p, vscales, one, src_m, &
        & zero, dst_v3)
    write(*, *) dst_v, dst_v2, dst_v3
end subroutine check_m2m_bessel

! Check adjoint M2M
subroutine check_m2m_adj(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    integer, parameter :: nrand=10
    real(dp) :: y(3, nx), r, dst_r, c(3), vscales((p+1)**2), v4pi2lp1(p+1), &
        & vscales_rel((p+1)**2), vcnk((2*p+1)*(p+1)), &
        & m2l_ztranslate_coef(p+1, 1, 1), &
        & m2l_ztranslate_adj_coef(1, 1, p+1), &
        & src_m((p+1)**2, nrand), src_m2((p+1)**2, nrand), &
        & dst_m((p+1)**2, nrand), err, tmp(nrand, nrand)
    logical :: ok
    integer :: i, j, iseed(4), ndst_m
    real(dp), external :: dnrm2
    real(dp), parameter :: threshold=4d-15
    ! Copy templated points with a proper multiplier
    y = alpha * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    call fmm_constants(p, p, 0, vcnk, m2l_ztranslate_coef, &
        & m2l_ztranslate_adj_coef)
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    ! Generate src_m randomly
    ndst_m = nrand * ((p+1)**2)
    call dlarnv(3, iseed, ndst_m, src_m)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check adjoint M2M"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    ! Check against direct M2M
    do i = 1, nx
        c = y(:, i)
        dst_r = r + dnrm2(3, y(:, i), 1)
        do j = 1, nrand
            call fmm_m2m_rotation(c, r, dst_r, p, vscales, vcnk, one, &
                & src_m(:, j), zero, dst_m(:, j))
            call fmm_m2m_rotation_adj(-c, dst_r, r, p, vscales, vcnk, one, &
                & dst_m(:, j), zero, src_m2(:, j))
        end do
        call dgemm('T', 'N', nrand, nrand, (p+1)**2, one, dst_m, (p+1)**2, &
            & dst_m, (p+1)**2, zero, tmp, nrand)
        err = dnrm2(nrand*nrand, tmp, 1)
        call dgemm('T', 'N', nrand, nrand, (p+1)**2, -one, src_m2, (p+1)**2, &
            & src_m, (p+1)**2, one, tmp, nrand)
        err = dnrm2(nrand*nrand, tmp, 1) / err
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_m2m_adj

! Check adjoint M2M Bessel
subroutine check_m2m_bessel_adj(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    integer, parameter :: nrand=10
    real(dp) :: y(3, nx), r, dst_r, c(3), vscales((p+1)**2), v4pi2lp1(p+1), &
        & vscales_rel((p+1)**2), vcnk((2*p+1)*(p+1)), &
        & m2l_ztranslate_coef(p+1, 1, 1), &
        & m2l_ztranslate_adj_coef(1, 1, p+1), &
        & src_m((p+1)**2, nrand), src_m2((p+1)**2, nrand), &
        & dst_m((p+1)**2, nrand), err, tmp(nrand, nrand), kappa
    logical :: ok
    integer :: i, j, iseed(4), ndst_m
    real(dp), external :: dnrm2
    real(dp), parameter :: threshold=4d-15
    ! Copy templated points with a proper multiplier
    y = alpha * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    call fmm_constants(p, p, 0, vcnk, m2l_ztranslate_coef, &
        & m2l_ztranslate_adj_coef)
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    kappa = 1d+1
    ! Generate src_m randomly
    ndst_m = nrand * ((p+1)**2)
    call dlarnv(3, iseed, ndst_m, src_m)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check adjoint M2M Bessel"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    ! Check against direct M
    ! Ignore i=1 for now
    do i = 2, nx
        c = y(:, i)
        dst_r = r + dnrm2(3, y(:, i), 1)
        do j = 1, nrand
            call fmm_m2m_bessel_rotation(c, r, dst_r, kappa, p, vscales, one, &
                & src_m(:, j), zero, dst_m(:, j))
            call fmm_m2m_bessel_rotation_adj(-c, dst_r, r, kappa, p, vscales, one, &
                & dst_m(:, j), zero, src_m2(:, j))
        end do
        call dgemm('T', 'N', nrand, nrand, (p+1)**2, one, dst_m, (p+1)**2, &
            & dst_m, (p+1)**2, zero, tmp, nrand)
        err = dnrm2(nrand*nrand, tmp, 1)
        call dgemm('T', 'N', nrand, nrand, (p+1)**2, -one, src_m2, (p+1)**2, &
            & src_m, (p+1)**2, one, tmp, nrand)
        err = dnrm2(nrand*nrand, tmp, 1) / err
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_m2m_bessel_adj

! Check L2L
subroutine check_l2l(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    integer, parameter :: nrand=10
    real(dp) :: y(3, nx), r, src_r, c(3), vscales((p+1)**2), v4pi2lp1(p+1), &
        & vscales_rel((p+1)**2), vfact(2*p+1), &
        & src_l((p+1)**2, nrand), dst_l((p+1)**2, nrand), &
        & dst_l2((p+1)**2, nrand), err
    logical :: ok
    integer :: i, j, iseed(4), ndst_l
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = alpha * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    vfact(1) = one
    do i = 2, 2*p+1
        vfact(i) = vfact(i-1) * sqrt(dble(i-1))
    end do
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    ! Generate src_l randomly
    ndst_l = nrand * ((p+1)**2)
    call dlarnv(3, iseed, ndst_l, src_l)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check L2L"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    ! Check against baseline implementation
    do i = 1, nx
        c = y(:, i)
        src_r = r + dnrm2(3, c, 1)
        ! Check alpha=beta=zero
        do j = 1, nrand
            call fmm_l2l_rotation(c, src_r, r, p, vscales, vfact, zero, &
                & src_l(:, j), zero, dst_l2(:, j))
        end do
        err = dnrm2(ndst_l, dst_l2, 1)
        ok = err .eq. zero
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
        ! Check alpha=one, beta=zero
        dst_l = zero
        do j = 1, nrand
            call fmm_l2l_baseline(c, src_r, r, p, vscales, src_l(:, j), &
                & dst_l(:, j))
            call fmm_l2l_rotation(c, src_r, r, p, vscales, vfact, one, &
                & src_l(:, j), zero, dst_l2(:, j))
        end do
        err = dnrm2(ndst_l, dst_l-dst_l2, 1) / dnrm2(ndst_l, dst_l, 1)
        ok = err .le. 4d-14
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
        ! Check alpha!={zero,one}, beta=zero
        do j = 1, nrand
            call fmm_l2l_rotation(c, src_r, r, p, vscales, vfact, -three, &
                & src_l(:, j), zero, dst_l2(:, j))
        end do
        err = dnrm2(ndst_l, three*dst_l+dst_l2, 1) / dnrm2(ndst_l, dst_l, 1)
        ok = err .le. 4d-14
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
        ! Check alpha=zero, beta=one
        dst_l2 = dst_l
        do j = 1, nrand
            call fmm_l2l_rotation(c, src_r, r, p, vscales, vfact, zero, &
                & src_l(:, j), one, dst_l2(:, j))
        end do
        err = dnrm2(ndst_l, dst_l-dst_l2, 1) / dnrm2(ndst_l, dst_l, 1)
        ok = err .le. 4d-14
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
        ! Check alpha=zero, beta!={zero,one}
        dst_l2 = dst_l
        do j = 1, nrand
            call fmm_l2l_rotation(c, src_r, r, p, vscales, vfact, zero, &
                & src_l(:, j), -pt5, dst_l2(:, j))
        end do
        err = dnrm2(ndst_l, pt5*dst_l+dst_l2, 1) / dnrm2(ndst_l, dst_l, 1)
        ok = err .le. 4d-14
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
        ! Check alpha!={zero,one}, beta!={zero,one}
        dst_l2 = two * dst_l
        do j = 1, nrand
            call fmm_l2l_rotation(c, src_r, r, p, vscales, vfact, -three, &
                & src_l(:, j), pt5, dst_l2(:, j))
        end do
        err = dnrm2(ndst_l, two*dst_l+dst_l2, 1) / dnrm2(ndst_l, dst_l, 1)
        ok = err .le. 4d-14
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_l2l

subroutine check_l2l_bessel(p)
    ! Inputs
    integer, intent(in) :: p
    ! Local variables
    real(dp) :: x(3), src_c(3), src_r, dst_r, dst_v, dst_v2, dst_v3
    real(dp) :: src_l((p+1)**2), dst_l((p+1)**2), vscales((p+1)**2), &
        & vscales_rel((p+1)**2), v4pi2lp1(p+1), kappa
    real(dp), external :: dnrm2
    integer :: i
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    x = 7.5d-1 * (/one, -1.1d0, one/)
    src_c = 1.01d0 * (/-one, one, one/)
    src_r = one
    dst_r = src_r + dnrm2(3, src_c, 1)
    src_l = zero
    do i = 0, p
        !src_l(i*i+i+1) = 10d0 ** (-i)
        !src_l(i*i+1:i*i+2*i+1) = 10d0 ** (-i)
    end do
    src_l = one
    kappa = 1d-1
    call fmm_l2p_bessel_baseline(kappa*(x-src_c), kappa*src_r, p, vscales, one, src_l, &
        & zero, dst_v)
    call fmm_l2l_bessel_rotation(src_c, src_r, dst_r, kappa, p, vscales, one, &
        & src_l, zero, dst_l)
    call fmm_l2p_bessel_baseline(kappa*x, kappa*dst_r, p, vscales, one, dst_l, zero, &
        & dst_v2)
    call fmm_l2l_bessel_rotation(-src_c, dst_r, src_r, kappa, p, vscales, one, &
        & dst_l, zero, src_l)
    call fmm_l2p_bessel_baseline(kappa*(x-src_c), kappa*src_r, p, vscales, one, src_l, &
        & zero, dst_v3)
    write(*, *) dst_v, dst_v2, dst_v3
end subroutine check_l2l_bessel

! Check adjoint l2l
subroutine check_l2l_adj(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    integer, parameter :: nrand=10
    real(dp) :: y(3, nx), r, dst_r, c(3), vscales((p+1)**2), v4pi2lp1(p+1), &
        & vscales_rel((p+1)**2), vfact(2*p+1), &
        & src_l((p+1)**2, nrand), src_l2((p+1)**2, nrand), &
        & dst_l((p+1)**2, nrand), err, tmp(nrand, nrand)
    logical :: ok
    integer :: i, j, iseed(4), ndst_l
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = alpha * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    vfact(1) = one
    do i = 2, 2*p+1
        vfact(i) = vfact(i-1) * sqrt(dble(i-1))
    end do
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    ! Generate src_l randomly
    ndst_l = nrand * ((p+1)**2)
    call dlarnv(3, iseed, ndst_l, src_l)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check adjoint L2L"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    ! Check against direct l2l
    do i = 1, nx
        c = y(:, i)
        dst_r = r + dnrm2(3, y(:, i), 1)
        do j = 1, nrand
            call fmm_l2l_rotation(c, r, dst_r, p, vscales, vfact, one, &
                & src_l(:, j), zero, dst_l(:, j))
            call fmm_l2l_rotation_adj(-c, dst_r, r, p, vscales, vfact, one, &
                & dst_l(:, j), zero, src_l2(:, j))
        end do
        call dgemm('T', 'N', nrand, nrand, (p+1)**2, one, dst_l, (p+1)**2, &
            & dst_l, (p+1)**2, zero, tmp, nrand)
        err = dnrm2(nrand*nrand, tmp, 1)
        call dgemm('T', 'N', nrand, nrand, (p+1)**2, -one, src_l2, (p+1)**2, &
            & src_l, (p+1)**2, one, tmp, nrand)
        err = dnrm2(nrand*nrand, tmp, 1) / err
        ok = err .lt. 1d-14
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_l2l_adj

! Check adjoint l2l Bessel
subroutine check_l2l_bessel_adj(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    integer, parameter :: nrand=10
    real(dp) :: y(3, nx), r, dst_r, c(3), vscales((p+1)**2), v4pi2lp1(p+1), &
        & vscales_rel((p+1)**2), &
        & src_l((p+1)**2, nrand), src_l2((p+1)**2, nrand), &
        & dst_l((p+1)**2, nrand), err, tmp(nrand, nrand), kappa
    logical :: ok
    integer :: i, j, iseed(4), ndst_l
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = alpha * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    kappa = 1d+1
    ! Generate src_l randomly
    ndst_l = nrand * ((p+1)**2)
    call dlarnv(3, iseed, ndst_l, src_l)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check adjoint L2L Bessel"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    ! Check against direct l2l
    ! Ignore i=1 for now
    do i = 2, nx
        c = y(:, i)
        dst_r = r + dnrm2(3, y(:, i), 1)
        do j = 1, nrand
            call fmm_l2l_bessel_rotation(c, r, dst_r, kappa, p, vscales, one, &
                & src_l(:, j), zero, dst_l(:, j))
            call fmm_l2l_bessel_rotation_adj(-c, dst_r, r, kappa, p, vscales, one, &
                & dst_l(:, j), zero, src_l2(:, j))
        end do
        call dgemm('T', 'N', nrand, nrand, (p+1)**2, one, dst_l, (p+1)**2, &
            & dst_l, (p+1)**2, zero, tmp, nrand)
        err = dnrm2(nrand*nrand, tmp, 1)
        call dgemm('T', 'N', nrand, nrand, (p+1)**2, -one, src_l2, (p+1)**2, &
            & src_l, (p+1)**2, one, tmp, nrand)
        err = dnrm2(nrand*nrand, tmp, 1) / err
        ok = err .lt. 1d-14
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_l2l_bessel_adj

! Check M2L
subroutine check_m2l(pm, pl, alpha)
    ! Inputs
    integer, intent(in) :: pm, pl
    real(dp), intent(in) :: alpha
    ! Local variables
    integer, parameter :: nrand=10
    real(dp) :: y(3, nx), r, dst_r, c(3), vscales((pm+pl+1)**2), &
        & v4pi2lp1(pm+pl+1), &
        & vscales_rel((pm+pl+1)**2), vcnk((2*(pm+pl)+1)*(pm+pl+1)), &
        & m2l_ztranslate_coef(pm+1, pl+1, pl+1), &
        & m2l_ztranslate_adj_coef(pl+1, pl+1, pm+1), &
        & src_m((pm+1)**2, nrand), dst_l((pl+1)**2, nrand), &
        & dst_l2((pl+1)**2, nrand), err
    logical :: ok
    integer :: i, j, iseed(4), nsrc_m, ndst_l
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = 3d0 * alpha / sqrt(13d-2) * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(pm+pl, vscales, v4pi2lp1, vscales_rel)
    call fmm_constants(pm+pl, pm, pl, vcnk, m2l_ztranslate_coef, &
        & m2l_ztranslate_adj_coef)
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    ! Generate src_m randomly
    nsrc_m = nrand * ((pm+1)**2)
    ndst_l = nrand * ((pl+1)**2)
    call dlarnv(3, iseed, nsrc_m, src_m)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check M2L"
    print "(A,I0)", " pm=", pm
    print "(A,I0)", " pl=", pl
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    ! Check against the baseline, i=1 is ignored since it y(:,1)=zero
    do i = 2, nx
        c = y(:, i)
        !dst_r = dnrm2(3, c, 1) - two*r
        dst_r = r
        ! Check alpha=beta=zero
        do j = 1, nrand
            call fmm_m2l_rotation(c, r, dst_r, pm, pl, vscales, &
                & m2l_ztranslate_coef, zero, src_m(:, j), zero, dst_l2(:, j))
        end do
        err = dnrm2(ndst_l, dst_l2, 1)
        ok = err .eq. zero
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
        ! Check alpha=one, beta=zero
        dst_l = zero
        do j = 1, nrand
            call fmm_m2l_baseline(c, r, dst_r, pm, pl, vscales, src_m(:, j), &
                & dst_l(:, j))
            call fmm_m2l_rotation(c, r, dst_r, pm, pl, vscales, &
                & m2l_ztranslate_coef, one, src_m(:, j), zero, dst_l2(:, j))
        end do
        err = dnrm2(ndst_l, dst_l-dst_l2, 1) / dnrm2(ndst_l, dst_l, 1)
        ok = err .le. 1d-14
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        !if(.not. ok) stop 1
        if (.not. ok) then
            print *, src_m
            print *, dst_l2
            stop 1
        end if
        ! Check alpha!={zero,one}, beta=zero
        do j = 1, nrand
            call fmm_m2l_rotation(c, r, dst_r, pm, pl, vscales, &
                & m2l_ztranslate_coef, -three, src_m(:, j), zero, dst_l2(:, j))
        end do
        err = dnrm2(ndst_l, three*dst_l+dst_l2, 1) / dnrm2(ndst_l, dst_l, 1)
        ok = err .le. 1d-14
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
        ! Check alpha=zero, beta=one
        dst_l2 = dst_l
        do j = 1, nrand
            call fmm_m2l_rotation(c, r, dst_r, pm, pl, vscales, &
                & m2l_ztranslate_coef, zero, src_m(:, j), one, dst_l2(:, j))
        end do
        err = dnrm2(ndst_l, dst_l-dst_l2, 1) / dnrm2(ndst_l, dst_l, 1)
        ok = err .le. 1d-14
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
        ! Check alpha=zero, beta!={zero,one}
        dst_l2 = dst_l
        do j = 1, nrand
            call fmm_m2l_rotation(c, r, dst_r, pm, pl, vscales, &
                & m2l_ztranslate_coef, zero, src_m(:, j), -pt5, dst_l2(:, j))
        end do
        err = dnrm2(ndst_l, pt5*dst_l+dst_l2, 1) / dnrm2(ndst_l, dst_l, 1)
        ok = err .le. 1d-14
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
        ! Check alpha!={zero,one}, beta!={zero,one}
        dst_l2 = two * dst_l
        do j = 1, nrand
            call fmm_m2l_rotation(c, r, dst_r, pm, pl, vscales, &
                & m2l_ztranslate_coef, -three, src_m(:, j), pt5, dst_l2(:, j))
        end do
        err = dnrm2(ndst_l, two*dst_l+dst_l2, 1) / dnrm2(ndst_l, dst_l, 1)
        ok = err .le. 1d-14
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if(.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_m2l

! Check adjoint m2l
subroutine check_m2l_adj(pm, pl, alpha)
    ! Inputs
    integer, intent(in) :: pm, pl
    real(dp), intent(in) :: alpha
    ! Local variables
    integer, parameter :: nrand=10
    real(dp) :: y(3, nx), r, dst_r, c(3), vscales((pm+pl+1)**2), &
        & v4pi2lp1(pm+pl+1), &
        & vscales_rel((pm+pl+1)**2), vcnk((2*(pm+pl)+1)*(pm+pl+1)), &
        & m2l_ztranslate_coef(pm+1, pl+1, pl+1), &
        & m2l_ztranslate_adj_coef(pl+1, pl+1, pm+1), &
        & src_m((pm+1)**2, nrand), src_m2((pm+1)**2, nrand), &
        & dst_l((pl+1)**2, nrand), err, tmp(nrand, nrand), threshold
    logical :: ok
    integer :: i, j, iseed(4), nsrc_m, ndst_l
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = 3d0 * alpha / sqrt(13d-2) * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(pm+pl, vscales, v4pi2lp1, vscales_rel)
    call fmm_constants(pm+pl, pm, pl, vcnk, m2l_ztranslate_coef, &
        & m2l_ztranslate_adj_coef)
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    ! Generate src_m randomly
    nsrc_m = nrand * ((pm+1)**2)
    ndst_l = nrand * ((pl+1)**2)
    call dlarnv(3, iseed, nsrc_m, src_m)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check adjoint M2L"
    print "(A,I0)", " pm=", pm
    print "(A,I0)", " pl=", pl
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    threshold = (pm+pl+3) * 4d-16
    ! Check against the baseline, i=1 is ignored since it y(:,1)=zero
    do i = 2, nx
        c = y(:, i)
        !dst_r = r + dnrm2(3, y(:, i), 1)
        dst_r = r
        do j = 1, nrand
            call fmm_m2l_rotation(c, r, dst_r, pm, pl, vscales, &
                & m2l_ztranslate_coef, one, src_m(:, j), zero, dst_l(:, j))
            call fmm_m2l_rotation_adj(-c, dst_r, r, pl, pm, vscales, &
                & m2l_ztranslate_adj_coef, one, dst_l(:, j), zero, &
                & src_m2(:, j))
        end do
        call dgemm('T', 'N', nrand, nrand, (pl+1)**2, one, dst_l, (pl+1)**2, &
            & dst_l, (pl+1)**2, zero, tmp, nrand)
        err = dnrm2(nrand*nrand, tmp, 1)
        call dgemm('T', 'N', nrand, nrand, (pm+1)**2, -one, src_m2, &
            & (pm+1)**2, src_m, (pm+1)**2, one, tmp, nrand)
        err = dnrm2(nrand*nrand, tmp, 1) / err
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_m2l_adj

subroutine check_m2l_bessel(p)
    ! Inputs
    integer, intent(in) :: p
    ! Local variables
    real(dp) :: x(3), src_c(3), src_r, dst_r, dst_v, dst_v2
    real(dp) :: src_m((p+1)**2), dst_l((p+1)**2), vscales((p+1)**2), &
        & vscales_rel((p+1)**2), v4pi2lp1(p+1), kappa
    real(dp), external :: dnrm2
    integer :: i
    ! Compute special FMM constants
    call ylmscale(p, vscales, v4pi2lp1, vscales_rel)
    src_c = 3d0 * (/0d0, 1d0, 0d0/)
    src_r = one
    x = 5d-1 * (/one, -1.1d0, one/)
    !x = zero
    dst_r = one
    src_m = zero
    do i = 0, p
        !src_m(i*i+i+1) = 10d0 ** (-i)
        !src_m(i*i+1:i*i+2*i+1) = 10d0 ** (-i)
    end do
    src_m = one
    kappa = 1d0
    call fmm_m2p_bessel_baseline(kappa*(x-src_c), kappa*src_r, p, vscales, one, src_m, &
        & zero, dst_v)
    call fmm_m2l_bessel_rotation(src_c, src_r, dst_r, kappa, p, vscales, one, &
        & src_m, zero, dst_l)
    call fmm_l2p_bessel_baseline(kappa*x, kappa*dst_r, p, vscales, one, dst_l, zero, &
        & dst_v2)
    write(*, *) dst_v, dst_v2
end subroutine check_m2l_bessel

! Check adjoint m2l
subroutine check_m2l_bessel_adj(p, alpha)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: alpha
    ! Local variables
    integer, parameter :: nrand=10
    real(dp) :: y(3, nx), r, dst_r, c(3), vscales((2*p+1)**2), &
        & v4pi2lp1(2*p+1), &
        & vscales_rel((2*p+1)**2), vcnk((4*p+1)*(2*p+1)), &
        & m2l_ztranslate_coef(p+1, p+1, p+1), &
        & m2l_ztranslate_adj_coef(p+1, p+1, p+1), &
        & src_m((p+1)**2, nrand), src_m2((p+1)**2, nrand), &
        & dst_l((p+1)**2, nrand), err, tmp(nrand, nrand), threshold, kappa
    logical :: ok
    integer :: i, j, iseed(4), nsrc_m, ndst_l
    real(dp), external :: dnrm2
    ! Copy templated points with a proper multiplier
    y = 3d0 * alpha / sqrt(13d-2) * x
    r = abs(alpha)
    ! Compute special FMM constants
    call ylmscale(2*p, vscales, v4pi2lp1, vscales_rel)
    call fmm_constants(2*p, p, p, vcnk, m2l_ztranslate_coef, &
        & m2l_ztranslate_adj_coef)
    ! Init random seed
    iseed = (/0, 0, 0, 1/)
    kappa = 1d+1
    ! Generate src_m randomly
    nsrc_m = nrand * ((p+1)**2)
    ndst_l = nrand * ((p+1)**2)
    call dlarnv(3, iseed, nsrc_m, src_m)
    ! Print header
    print "(/,A)", repeat("=", 40)
    print "(A)", "Check adjoint M2L Bessel"
    print "(A,I0)", " p=", p
    print "(A,ES24.16E3)", " alpha=", alpha
    print "(A)", repeat("=", 40)
    print "(A)", "  i | ok | err(i)"
    print "(A)", repeat("=", 40)
    threshold = (2*p+3) * 4d-16
    ! Check against the baseline, i=1 is ignored since it y(:,1)=zero
    do i = 2, nx
        c = y(:, i)
        !dst_r = r + dnrm2(3, y(:, i), 1)
        dst_r = r
        do j = 1, nrand
            call fmm_m2l_bessel_rotation(c, r, dst_r, kappa, p, vscales, &
                & one, src_m(:, j), zero, dst_l(:, j))
            call fmm_m2l_bessel_rotation_adj(-c, dst_r, r, kappa, p, vscales, &
                & one, dst_l(:, j), zero, &
                & src_m2(:, j))
        end do
        call dgemm('T', 'N', nrand, nrand, (p+1)**2, one, dst_l, (p+1)**2, &
            & dst_l, (p+1)**2, zero, tmp, nrand)
        err = dnrm2(nrand*nrand, tmp, 1)
        call dgemm('T', 'N', nrand, nrand, (p+1)**2, -one, src_m2, &
            & (p+1)**2, src_m, (p+1)**2, one, tmp, nrand)
        err = dnrm2(nrand*nrand, tmp, 1) / err
        ok = err .lt. threshold
        print "(I3.2,A,L3,A,D12.4)", i, " |", ok, " | ", err
        if (.not. ok) stop 1
    end do
    print "(A)", repeat("=", 40)
end subroutine check_m2l_bessel_adj

subroutine check_tree_rib(alpha)
    real(dp), intent(in) :: alpha
    integer, parameter :: nsph = 10
    real(dp) :: csph(3, nsph), rsph(nsph), csph2(3, nsph), rsph2(nsph), &
        & cnode(3, 2*nsph-1), rnode(2*nsph-1)
    integer :: order(nsph), i, reorder(nsph), cluster(2, 2*nsph-1), &
        & children(2, 2*nsph-1), parent(2*nsph-1), snode(nsph)
    type(ddx_error_type) :: ddx_error
    ! Scale inputs
    csph(:, 1) = alpha * (/1d0, 1d0, 1d0/)
    csph(:, 2) = alpha * (/2d0, 2d0, 2d0/)
    csph(:, 3) = alpha * (/1d0, 1d0, 3d0/)
    csph(:, 4) = alpha * (/2d0, 2d0, 4d0/)
    csph(:, 5) = alpha * (/1d0, 1d0, 5d0/)
    csph(:, 6) = alpha * (/2d0, 2d0, 6d0/)
    csph(:, 7) = alpha * (/1d0, 1d0, 7d0/)
    csph(:, 8) = alpha * (/2d0, 2d0, 8d0/)
    csph(:, 9) = alpha * (/1d0, 1d0, 9d0/)
    csph(:, 10) = alpha * (/2d0, 2d0, 10d0/)
    rsph = abs(alpha) * (/1d-1, 2d-1, 3d-1, 4d-1, 5d-1, 6d-1, 7d-1, 8d-1, &
        & 9d-1, 1d0/)
    ! Reorder inputs
    order = (/4, 2, 8, 5, 7, 1, 9, 6, 10, 3/)
    do i = 1, nsph
        csph2(:, i) = csph(:, order(i))
        rsph2(i) = rsph(order(i))
    end do
    ! Build a recursive inertial binary tree
    call tree_rib_build(nsph, csph2, rsph2, reorder, cluster, children, &
        & parent, cnode, rnode, snode, ddx_error)
end subroutine check_tree_rib

!subroutine check_tree_m2m(p, alpha)
!    ! Inputs
!    integer, intent(in) :: p
!    real(dp), intent(in) :: alpha
!    ! Local variables
!    integer, parameter :: nsph = 10
!    integer :: i, indi, j, k, order(nsph), istatus
!    real(dp) :: csph(3, nsph), rsph(nsph), src(3, nsph), csph2(3, nsph), &
!        & rsph2(nsph), sph_m((p+1)**2, nsph), node_m((p+1)**2, 2*nsph-1), &
!        & node_m2((p+1)**2, 2*nsph-1), vscales((p+1)**2), vfact(2*p+1), &
!        & rel_err, sph_m2((p+1)**2, nsph), full_norm, diff_norm, &
!        & node_m3((p+1)**2, 2*nsph-1)
!    type(ddx_type) :: ddx_data
!    logical :: ok
!    real(dp), external :: dnrm2
!    real(dp) :: full_mat((p+1)**2, 2*nsph-1, (p+1)**2, nsph)
!    ! Scale inputs
!    csph(:, 1) = alpha * (/1d0, 1d0, 1d0/)
!    csph(:, 2) = alpha * (/2d0, 2d0, 2d0/)
!    csph(:, 3) = alpha * (/1d0, 1d0, 3d0/)
!    csph(:, 4) = alpha * (/2d0, 2d0, 4d0/)
!    csph(:, 5) = alpha * (/1d0, 1d0, 5d0/)
!    csph(:, 6) = alpha * (/2d0, 2d0, 6d0/)
!    csph(:, 7) = alpha * (/1d0, 1d0, 7d0/)
!    csph(:, 8) = alpha * (/2d0, 2d0, 8d0/)
!    csph(:, 9) = alpha * (/1d0, 1d0, 9d0/)
!    csph(:, 10) = alpha * (/2d0, 2d0, 10d0/)
!    rsph = abs(alpha) * (/2d-1, 3d-1, 4d-1, 5d-1, 6d-1, 7d-1, 8d-1, 9d-1, &
!        & 1d0, 1.1d0/)
!    src(:, 1) = alpha * (/1.1d0, 0.9d0, 1d0/)
!    src(:, 2) = alpha * (/2.1d0, 1.9d0, 2.1d0/)
!    src(:, 3) = alpha * (/1.1d0, 1.1d0, 3.1d0/)
!    src(:, 4) = alpha * (/1.9d0, 1.9d0, 4.1d0/)
!    src(:, 5) = alpha * (/1.1d0, 0.9d0, 5d0/)
!    src(:, 6) = alpha * (/1.9d0, 2.1d0, 5.9d0/)
!    src(:, 7) = alpha * (/1.1d0, 0.9d0, 7d0/)
!    src(:, 8) = alpha * (/2.1d0, 2.1d0, 8d0/)
!    src(:, 9) = alpha * (/1.1d0, 0.9d0, 9d0/)
!    src(:, 10) = alpha * (/2.1d0, 1.9d0, 9.9d0/)
!    ! Reorder inputs
!    order = (/4, 2, 8, 5, 7, 1, 9, 6, 10, 3/)
!    do i = 1, nsph
!        csph2(:, i) = csph(:, order(i))
!        rsph2(i) = rsph(order(i))
!    end do
!    ddx_data % nclusters = 2*nsph-1
!    ddx_data % pl = -1
!    ddx_data % pm = p
!    ddx_data % nsph = nsph
!    ! Allocate space for a tree
!    allocate(ddx_data % cluster(2, 2*nsph-1), ddx_data % children(2, 2*nsph-1), &
!        & ddx_data % parent(2*nsph-1), ddx_data % cnode(3, 2*nsph-1), &
!        & ddx_data % rnode(2*nsph-1), ddx_data % snode(nsph), &
!        & ddx_data % order(nsph), ddx_data % vscales((p+1)**2), &
!        & ddx_data % vfact(2*p+1), ddx_data % vscales_rel((p+1)**2), &
!        & ddx_data % v4pi2lp1(p+1), ddx_data % vcnk((2*p+1)*(p+1)), &
!        & ddx_data % m2l_ztranslate_coef(p+1, 0, 0), &
!        & ddx_data % m2l_ztranslate_adj_coef(0, 0, p+1), stat=istatus)
!    if(istatus .ne. 0) stop "ALLOC FAILED"
!    ! Build a recursive inertial binary tree
!    call tree_rib_build(nsph, csph2, rsph2, ddx_data % order, &
!        & ddx_data % cluster, ddx_data % children, ddx_data % parent, &
!        & ddx_data % cnode, ddx_data % rnode, ddx_data % snode)
!    ! Get constants, corresponding to given maximum degree of spherical
!    ! harmonics
!    call ylmscale(p, ddx_data % vscales, ddx_data % v4pi2lp1, &
!        & ddx_data % vscales_rel)
!    ddx_data % vfact(1) = one
!    do i = 2, 2*p+1
!        ddx_data % vfact(i) = ddx_data % vfact(i-1) * sqrt(dble(i-1))
!    end do
!    call fmm_constants(p, p, -1, ddx_data % vcnk, &
!        & ddx_data % m2l_ztranslate_coef, &
!        & ddx_data % m2l_ztranslate_adj_coef)
!    ! Init input harmonics
!    do i = 1, nsph
!        call fmm_p2m(src(:, i)-csph(:, i), one, rsph(i), p, &
!            & ddx_data % vscales, zero, sph_m(:, i))
!    end do
!    ! Get reference result of M2M operation
!    do i = 1, 2*nsph-1
!        node_m(:, i) = zero
!        do j = ddx_data % cluster(1, i), ddx_data % cluster(2, i)
!            k = ddx_data % order(j)
!            call fmm_m2m_rotation(csph2(:, k)-ddx_data % cnode(:, i), &
!                & rsph2(k), ddx_data % rnode(i), p, ddx_data % vscales, &
!                & ddx_data % vcnk, one, sph_m(:, k), one, node_m(:, i))
!        end do
!    end do
!    ! Check tree_m2m_rotation
!    if (iprint .gt. 0) then
!        write(*, "(/,A)") repeat("=", 40)
!        write(*, "(A)") "Check tree_m2m_rotation"
!        write(*, "(4x,A,I0)") "p = ", p
!        write(*, "(4x,A,ES24.16E3)") "alpha = ", alpha
!        write(*, "(4x,A,A)") "err = || [tree M2M] - [plain M2M] ||", &
!            & " / || [plain M2M] ||"
!        write(*, "(A)") repeat("=", 40)
!        write(*, "(A)") " ok | err"
!        write(*, "(A)") repeat("=", 40)
!    end if
!    node_m2 = one
!    do i = 1, nsph
!        node_m2(:, ddx_data % snode(i)) = sph_m(:, i)
!    end do
!    call tree_m2m_rotation(ddx_data, node_m2)
!    rel_err = dnrm2(((p+1)**2)*(2*nsph-1), node_m-node_m2, 1) / &
!        & dnrm2(((p+1)**2)*(2*nsph-1), node_m, 1)
!    ok = rel_err .le. 1d-15
!    write(*, "(L3,A,ES23.16E3)") ok, " | ", rel_err
!    write(*, "(A,/)") repeat("=", 40)
!    if (.not. ok) stop 1
!    ! Allocate space for transfer matrices
!    ddx_data % m2m_reflect_mat_size = (p+1)*(2*p+1)*(2*p+3)/3
!    ddx_data % m2m_ztranslate_mat_size = (p+1)*(p+2)*(p+3)/6
!    allocate(ddx_data % m2m_reflect_mat(ddx_data % m2m_reflect_mat_size, &
!        & ddx_data % nclusters-1), stat=istatus)
!    if (istatus .ne. 0) stop "Allocation failed"
!    allocate(ddx_data % m2m_ztranslate_mat(ddx_data % m2m_ztranslate_mat_size, &
!        & ddx_data % nclusters-1), stat=istatus)
!    if (istatus .ne. 0) stop "Allocation failed"
!    ! Compute transfer matrices
!    call tree_m2m_reflection_get_mat(ddx_data)
!    ! Check tree_m2m_reflection_use_mat
!    write(*, "(/,A)") repeat("=", 40)
!    write(*, "(A)") "Check tree_m2m_reflection_get_mat"
!    write(*, "(A)") "Check tree_m2m_reflection_use_mat"
!    write(*, "(4x,A,I0)") "p = ", p
!    write(*, "(4x,A,ES24.16E3)") "alpha = ", alpha
!    write(*, "(4x,A,A)") "err = || [tree M2M] - [plain M2M] ||", &
!        & " / || [plain M2M] ||"
!    write(*, "(A)") repeat("=", 40)
!    write(*, "(A)") " ok | err"
!    write(*, "(A)") repeat("=", 40)
!    node_m2 = one
!    do i = 1, nsph
!        node_m2(:, ddx_data % snode(i)) = sph_m(:, i)
!    end do
!    call tree_m2m_reflection_use_mat(ddx_data, node_m2)
!    rel_err = dnrm2(((p+1)**2)*(2*nsph-1), node_m-node_m2, 1) / &
!        & dnrm2(((p+1)**2)*(2*nsph-1), node_m, 1)
!    ok = rel_err .le. 1d-15
!    write(*, "(L3,A,ES23.16E3)") ok, " | ", rel_err
!    write(*, "(A,/)") repeat("=", 40)
!    if (.not. ok) stop 1
!    ! Check tree_m2m_reflection_use_mat_adj
!    write(*, "(/,A)") repeat("=", 40)
!    write(*, "(A)") "Check tree_m2m_reflection_use_mat_adj"
!    write(*, "(4x,A,I0)") "p = ", p
!    write(*, "(4x,A,ES24.16E3)") "alpha = ", alpha
!    write(*, "(4x,A,A)") "err = || [tree M2M] - [plain M2M] ||", &
!        & " / || [plain M2M] ||"
!    write(*, "(A)") repeat("=", 40)
!    write(*, "(A)") " ok | err"
!    write(*, "(A)") repeat("=", 40)
!    do i = 1, nsph
!        do j = 1, (p+1)**2
!            node_m2 = zero
!            node_m2(j, ddx_data % snode(i)) = one
!            call tree_m2m_reflection_use_mat(ddx_data, node_m2)
!            full_mat(:, :, j, i) = node_m2
!        end do
!    end do
!    full_norm = dnrm2((2*nsph-1)*nsph*((p+1)**4), full_mat, 1)
!    do i = 1, 2*nsph-1
!        do j = 1, (p+1)**2
!            node_m2 = zero
!            node_m2(j, i) = one
!            call tree_m2m_reflection_use_mat_adj(ddx_data, node_m2)
!            do k = 1, nsph
!                full_mat(j, i, :, k) = full_mat(j, i, :, k) - &
!                    & node_m2(:, ddx_data % snode(k))
!            end do
!        end do
!    end do
!    diff_norm = dnrm2((2*nsph-1)*nsph*((p+1)**4), full_mat, 1)
!    rel_err = diff_norm / full_norm
!    ok = rel_err .le. 1d-15
!    write(*, "(L3,A,ES23.16E3)") ok, " | ", rel_err
!    write(*, "(A,/)") repeat("=", 40)
!    if (.not. ok) stop 1
!    ! Check tree_m2m_rotation_adj
!    write(*, "(/,A)") repeat("=", 40)
!    write(*, "(A)") "Check tree_m2m_rotation_adj"
!    write(*, "(4x,A,I0)") "p = ", p
!    write(*, "(4x,A,ES24.16E3)") "alpha = ", alpha
!    write(*, "(4x,A,A)") "err = || [tree M2M] - [plain M2M] ||", &
!        & " / || [plain M2M] ||"
!    write(*, "(A)") repeat("=", 40)
!    write(*, "(A)") " ok | err"
!    write(*, "(A)") repeat("=", 40)
!    node_m2 = node_m
!    call tree_m2m_reflection_use_mat_adj(ddx_data, node_m2)
!    node_m3 = node_m
!    call tree_m2m_rotation_adj(ddx_data, node_m3)
!    rel_err = dnrm2((2*nsph-1)*((p+1)**2), node_m2-node_m3, 1) / &
!        dnrm2((2*nsph-1)*((p+1)**2), node_m2, 1)
!    ok = rel_err .le. 1d-15
!    write(*, "(L3,A,ES23.16E3)") ok, " | ", rel_err
!    write(*, "(A,/)") repeat("=", 40)
!    if (.not. ok) stop 1
!    ! Deallocate tree
!    call deallocate_model(ddx_data, ddx_error)
!end subroutine check_tree_m2m
!
!subroutine check_tree_l2l(p, alpha)
!    ! Inputs
!    integer, intent(in) :: p, iprint
!    real(dp), intent(in) :: alpha, threshold
!    ! Local variables
!    integer, parameter :: nsph = 10
!    integer :: i, j, k, order(nsph), istatus
!    real(dp) :: csph(3, nsph), rsph(nsph), src(3, nsph), csph2(3, nsph), &
!        & rsph2(nsph), sph_l((p+1)**2, nsph), node_l((p+1)**2, 2*nsph-1), &
!        & node_l2((p+1)**2, 2*nsph-1), vscales((p+1)**2), vfact(2*p+1), &
!        & rel_err, sph_l2((p+1)**2, nsph), full_norm, diff_norm, &
!        & node_l3((p+1)**2, 2*nsph-1)
!    type(ddx_type) :: ddx_data
!    logical :: ok
!    real(dp), external :: dnrm2
!    real(dp) :: full_mat((p+1)**2, nsph, (p+1)**2, 2*nsph-1)
!    ! Scale inputs
!    csph(:, 1) = alpha * (/1d0, 1d0, 1d0/)
!    csph(:, 2) = alpha * (/2d0, 2d0, 2d0/)
!    csph(:, 3) = alpha * (/1d0, 1d0, 3d0/)
!    csph(:, 4) = alpha * (/2d0, 2d0, 4d0/)
!    csph(:, 5) = alpha * (/1d0, 1d0, 5d0/)
!    csph(:, 6) = alpha * (/2d0, 2d0, 6d0/)
!    csph(:, 7) = alpha * (/1d0, 1d0, 7d0/)
!    csph(:, 8) = alpha * (/2d0, 2d0, 8d0/)
!    csph(:, 9) = alpha * (/1d0, 1d0, 9d0/)
!    csph(:, 10) = alpha * (/2d0, 2d0, 10d0/)
!    rsph = abs(alpha) * (/2d-1, 3d-1, 4d-1, 5d-1, 6d-1, 7d-1, 8d-1, 9d-1, &
!        & 1d0, 1.1d0/)
!    src(:, 1) = alpha * (/1.1d0, 0.9d0, 1d0/)
!    src(:, 2) = alpha * (/2.1d0, 1.9d0, 2.1d0/)
!    src(:, 3) = alpha * (/1.1d0, 1.1d0, 3.1d0/)
!    src(:, 4) = alpha * (/1.9d0, 1.9d0, 4.1d0/)
!    src(:, 5) = alpha * (/1.1d0, 0.9d0, 5d0/)
!    src(:, 6) = alpha * (/1.9d0, 2.1d0, 5.9d0/)
!    src(:, 7) = alpha * (/1.1d0, 0.9d0, 7d0/)
!    src(:, 8) = alpha * (/2.1d0, 2.1d0, 8d0/)
!    src(:, 9) = alpha * (/1.1d0, 0.9d0, 9d0/)
!    src(:, 10) = alpha * (/2.1d0, 1.9d0, 9.9d0/)
!    ! Reorder inputs
!    order = (/4, 2, 8, 5, 7, 1, 9, 6, 10, 3/)
!    do i = 1, nsph
!        csph2(:, i) = csph(:, order(i))
!        rsph2(i) = rsph(order(i))
!    end do
!    ddx_data % nclusters = 2*nsph-1
!    ddx_data % pl = p
!    ddx_data % pm = p
!    ddx_data % nsph = nsph
!    ! Allocate space for a tree
!    allocate(ddx_data % cluster(2, 2*nsph-1), ddx_data % children(2, 2*nsph-1), &
!        & ddx_data % parent(2*nsph-1), ddx_data % cnode(3, 2*nsph-1), &
!        & ddx_data % rnode(2*nsph-1), ddx_data % snode(nsph), &
!        & ddx_data % order(nsph), ddx_data % vscales((p+1)**2), &
!        & ddx_data % vfact(2*p+1), ddx_data % vscales_rel((p+1)**2), &
!        & ddx_data % v4pi2lp1(p+1), ddx_data % vcnk((2*p+1)*(p+1)), &
!        & ddx_data % m2l_ztranslate_coef(0, p+1, p+1), &
!        & ddx_data % m2l_ztranslate_adj_coef(p+1, p+1, 0), stat=istatus)
!    ! Build a recursive inertial binary tree
!    call tree_rib_build(nsph, csph2, rsph2, ddx_data % order, &
!        & ddx_data % cluster, ddx_data % children, ddx_data % parent, &
!        & ddx_data % cnode, ddx_data % rnode, ddx_data % snode)
!    ! Get constants, corresponding to given maximum degree of spherical
!    ! harmonics
!    call ylmscale(p, ddx_data % vscales, ddx_data % v4pi2lp1, &
!        & ddx_data % vscales_rel)
!    ddx_data % vfact(1) = one
!    do i = 2, 2*p+1
!        ddx_data % vfact(i) = ddx_data % vfact(i-1) * sqrt(dble(i-1))
!    end do
!    call fmm_constants(p, -1, p, ddx_data % vcnk, &
!        & ddx_data % m2l_ztranslate_coef, &
!        & ddx_data % m2l_ztranslate_adj_coef)
!    ! Init input harmonics
!    node_l = zero
!    do i = 1, nsph
!        call fmm_p2m(src(:, i)-csph(:, i), one, rsph(i), p, &
!            & ddx_data % vscales, zero, node_l(:, ddx_data % snode(i)))
!    end do
!    call tree_m2m_rotation(ddx_data, node_l)
!    ddx_data % pm = -1
!    ! Get reference result of L2L operation
!    sph_l = zero
!    do i = 1, 2*nsph-1
!        do j = ddx_data % cluster(1, i), ddx_data % cluster(2, i)
!            k = ddx_data % order(j)
!            call fmm_l2l_rotation(ddx_data % cnode(:, i)-csph2(:, k), &
!                & ddx_data % rnode(i), rsph2(k), p, ddx_data % vscales, &
!                & ddx_data % vfact, one, node_l(:, i), one, sph_l(:, k))
!        end do
!    end do
!    ! Check tree_l2l_rotation
!    if (iprint .gt. 0) then
!        write(*, "(/,A)") repeat("=", 40)
!        write(*, "(A)") "Check tree_l2l_rotation"
!        write(*, "(4x,A,I0)") "p = ", p
!        write(*, "(4x,A,ES24.16E3)") "alpha = ", alpha
!        write(*, "(4x,A,A)") "err = || [tree L2L] - [plain L2L] ||", &
!            & " / || [plain L2L] ||"
!        write(*, "(4x,A,ES23.16E3)") "threshold = ", threshold
!        write(*, "(A)") repeat("=", 40)
!        write(*, "(A)") " ok | err"
!        write(*, "(A)") repeat("=", 40)
!    end if
!    node_l2 = node_l
!    call tree_l2l_rotation(ddx_data, node_l2)
!    do i = 1, nsph
!        sph_l2(:, i) = node_l2(:, ddx_data % snode(i))
!    end do
!    rel_err = dnrm2(((p+1)**2)*nsph, sph_l-sph_l2, 1) / &
!        & dnrm2(((p+1)**2)*nsph, sph_l, 1)
!    ok = rel_err .le. threshold
!    if (iprint .gt. 0) then
!        write(*, "(L3,A,ES23.16E3)") ok, " | ", rel_err
!        write(*, "(A,/)") repeat("=", 40)
!    end if
!    if (.not. ok) stop 1
!    ! Allocate space for transfer matrices
!    ddx_data % l2l_reflect_mat_size = (p+1)*(2*p+1)*(2*p+3)/3
!    ddx_data % l2l_ztranslate_mat_size = (p+1)*(p+2)*(p+3)/6
!    allocate(ddx_data % l2l_reflect_mat(ddx_data % l2l_reflect_mat_size, &
!        & ddx_data % nclusters-1), stat=istatus)
!    if (istatus .ne. 0) stop "Allocation failed"
!    allocate(ddx_data % l2l_ztranslate_mat(ddx_data % l2l_ztranslate_mat_size, &
!        & ddx_data % nclusters-1), stat=istatus)
!    if (istatus .ne. 0) stop "Allocation failed"
!    ! Compute transfer matrices
!    call tree_l2l_reflection_get_mat(ddx_data)
!    ! Check tree_l2l_reflection_use_mat
!    if (iprint .gt. 0) then
!        write(*, "(/,A)") repeat("=", 40)
!        write(*, "(A)") "Check tree_l2l_reflection_get_mat"
!        write(*, "(A)") "Check tree_l2l_reflection_use_mat"
!        write(*, "(4x,A,I0)") "p = ", p
!        write(*, "(4x,A,ES24.16E3)") "alpha = ", alpha
!        write(*, "(4x,A,A)") "err = || [tree L2L] - [plain L2L] ||", &
!            & " / || [plain L2L] ||"
!        write(*, "(4x,A,ES23.16E3)") "threshold = ", threshold
!        write(*, "(A)") repeat("=", 40)
!        write(*, "(A)") " ok | err"
!        write(*, "(A)") repeat("=", 40)
!    end if
!    node_l2 = node_l
!    call tree_l2l_reflection_use_mat(ddx_data, node_l2)
!    do i = 1, nsph
!        sph_l2(:, i) = node_l2(:, ddx_data % snode(i))
!    end do
!    rel_err = dnrm2(((p+1)**2)*nsph, sph_l-sph_l2, 1) / &
!        & dnrm2(((p+1)**2)*nsph, sph_l, 1)
!    ok = rel_err .le. threshold
!    if (iprint .gt. 0) then
!        write(*, "(L3,A,ES23.16E3)") ok, " | ", rel_err
!        write(*, "(A,/)") repeat("=", 40)
!    end if
!    if (.not. ok) stop 1
!    ! Check tree_l2l_reflection_use_mat_adj
!    if (iprint .gt. 0) then
!        write(*, "(/,A)") repeat("=", 40)
!        write(*, "(A)") "Check tree_l2l_reflection_use_mat_adj"
!        write(*, "(4x,A,I0)") "p = ", p
!        write(*, "(4x,A,ES24.16E3)") "alpha = ", alpha
!        write(*, "(4x,A,A)") "err = || [tree L2L] - [plain L2L] ||", &
!            & " / || [plain L2L] ||"
!        write(*, "(4x,A,ES23.16E3)") "threshold = ", threshold
!        write(*, "(A)") repeat("=", 40)
!        write(*, "(A)") " ok | err"
!        write(*, "(A)") repeat("=", 40)
!    end if
!    do i = 1, 2*nsph-1
!        do j = 1, (p+1)**2
!            node_l2 = zero
!            node_l2(j, i) = one
!            call tree_l2l_reflection_use_mat(ddx_data, node_l2)
!            do k = 1, nsph
!                full_mat(:, k, j, i) = node_l2(:, ddx_data % snode(k))
!            end do
!        end do
!    end do
!    full_norm = dnrm2((2*nsph-1)*nsph*((p+1)**4), full_mat, 1)
!    do i = 1, nsph
!        do j = 1, (p+1)**2
!            node_l2 = one
!            do k = 1, nsph
!                node_l2(:, ddx_data % snode(k)) = zero
!            end do
!            node_l2(j, ddx_data % snode(i)) = one
!            call tree_l2l_reflection_use_mat_adj(ddx_data, node_l2)
!            full_mat(j, i, :, :) = full_mat(j, i, :, :) - node_l2
!        end do
!    end do
!    diff_norm = dnrm2((2*nsph-1)*nsph*((p+1)**4), full_mat, 1)
!    rel_err = diff_norm / full_norm
!    ok = rel_err .le. threshold
!    if (iprint .gt. 0) then
!        write(*, "(L3,A,ES23.16E3)") ok, " | ", rel_err
!        write(*, "(A,/)") repeat("=", 40)
!    end if
!    if (.not. ok) stop 1
!    ! Check tree_l2l_rotation_adj
!    if (iprint .gt. 0) then
!        write(*, "(/,A)") repeat("=", 40)
!        write(*, "(A)") "Check tree_l2l_rotation_adj"
!        write(*, "(4x,A,I0)") "p = ", p
!        write(*, "(4x,A,ES24.16E3)") "alpha = ", alpha
!        write(*, "(4x,A,A)") "err = || [tree L2L] - [plain L2L] ||", &
!            & " / || [plain L2L] ||"
!        write(*, "(4x,A,ES23.16E3)") "threshold = ", threshold
!        write(*, "(A)") repeat("=", 40)
!        write(*, "(A)") " ok | err"
!        write(*, "(A)") repeat("=", 40)
!    end if
!    node_l2 = zero
!    do i = 1, nsph
!        node_l2(:, ddx_data % snode(i)) = node_l(:, ddx_data % snode(i))
!    end do
!    call tree_l2l_reflection_use_mat_adj(ddx_data, node_l2)
!    node_l3 = zero
!    do i = 1, nsph
!        node_l3(:, ddx_data % snode(i)) = node_l(:, ddx_data % snode(i))
!    end do
!    call tree_l2l_rotation_adj(ddx_data, node_l3)
!    rel_err = dnrm2((2*nsph-1)*((p+1)**2), node_l2-node_l3, 1) / &
!        dnrm2((2*nsph-1)*((p+1)**2), node_l2, 1)
!    ok = rel_err .le. threshold
!    if (iprint .gt. 0) then
!        write(*, "(L3,A,ES23.16E3)") ok, " | ", rel_err
!        write(*, "(A,/)") repeat("=", 40)
!    end if
!    if (.not. ok) stop 1
!    ! Deallocate tree
!    call deallocate_model(ddx_data, ddx_error)
!end subroutine check_tree_l2l
!
!subroutine check_tree_m2l(pm, pl, alpha, threshold)
!    ! Inputs
!    integer, intent(in) :: pm, pl, iprint
!    real(dp), intent(in) :: alpha, threshold
!    ! Local variables
!    integer, parameter :: nsph = 10, lwork = 1000
!    integer :: i, j, k, l, order(nsph), istatus, iwork, jwork, work(3, lwork)
!    real(dp) :: csph(3, nsph), rsph(nsph), src(3, nsph), csph2(3, nsph), &
!        & rsph2(nsph), node_m((pm+1)**2, 2*nsph-1), &
!        & node_l((pl+1)**2, 2*nsph-1), vscales((pm+pl+1)**2), &
!        & vfact(2*(pm+pl)+1), rel_err, full_norm, diff_norm, &
!        & node_m2((pm+1)**2, 2*nsph-1), node_l2((pl+1)**2, 2*nsph-1)
!    type(ddx_type) :: ddx_data
!    logical :: ok
!    real(dp), external :: dnrm2
!    real(dp) :: full_mat((pl+1)**2, 2*nsph-1, (pm+1)**2, 2*nsph-1)
!    real(dp) :: far_p2p(nsph), far_p2p2(nsph)
!    ! Scale inputs
!    csph(:, 1) = alpha * (/1d0, 1d0, 1d0/)
!    csph(:, 2) = alpha * (/2d0, 2d0, 2d0/)
!    csph(:, 3) = alpha * (/1d0, 1d0, 3d0/)
!    csph(:, 4) = alpha * (/2d0, 2d0, 4d0/)
!    csph(:, 5) = alpha * (/1d0, 1d0, 5d0/)
!    csph(:, 6) = alpha * (/2d0, 2d0, 6d0/)
!    csph(:, 7) = alpha * (/1d0, 1d0, 7d0/)
!    csph(:, 8) = alpha * (/2d0, 2d0, 8d0/)
!    csph(:, 9) = alpha * (/1d0, 1d0, 9d0/)
!    csph(:, 10) = alpha * (/2d0, 2d0, 10d0/)
!    rsph = abs(alpha) * (/2d-1, 3d-1, 4d-1, 5d-1, 6d-1, 7d-1, 8d-1, 9d-1, &
!        & 1d0, 1.1d0/)
!    src(:, 1) = alpha * (/1.1d0, 0.9d0, 1d0/)
!    src(:, 2) = alpha * (/2.1d0, 1.9d0, 2.1d0/)
!    src(:, 3) = alpha * (/1.1d0, 1.1d0, 3.1d0/)
!    src(:, 4) = alpha * (/1.9d0, 1.9d0, 4.1d0/)
!    src(:, 5) = alpha * (/1.1d0, 0.9d0, 5d0/)
!    src(:, 6) = alpha * (/1.9d0, 2.1d0, 5.9d0/)
!    src(:, 7) = alpha * (/1.1d0, 0.9d0, 7d0/)
!    src(:, 8) = alpha * (/2.1d0, 2.1d0, 8d0/)
!    src(:, 9) = alpha * (/1.1d0, 0.9d0, 9d0/)
!    src(:, 10) = alpha * (/2.1d0, 1.9d0, 9.9d0/)
!    ! Reorder inputs
!    order = (/4, 2, 8, 5, 7, 1, 9, 6, 10, 3/)
!    do i = 1, nsph
!        csph2(:, i) = csph(:, order(i))
!        rsph2(i) = rsph(order(i))
!    end do
!    ddx_data % nclusters = 2*nsph-1
!    ddx_data % pl = pl
!    ddx_data % pm = pm
!    ddx_data % nsph = nsph
!    ! Allocate space for a tree
!    allocate(ddx_data % cluster(2, 2*nsph-1), ddx_data % children(2, 2*nsph-1), &
!        & ddx_data % parent(2*nsph-1), ddx_data % cnode(3, 2*nsph-1), &
!        & ddx_data % rnode(2*nsph-1), ddx_data % snode(nsph), &
!        & ddx_data % order(nsph), ddx_data % vscales((pm+pl+1)**2), &
!        & ddx_data % vfact(2*(pm+pl)+1), ddx_data % vscales_rel((pm+pl+1)**2), &
!        & ddx_data % v4pi2lp1(pm+pl+1), &
!        & ddx_data % vcnk((2*(pm+pl)+1)*(pm+pl+1)), &
!        & ddx_data % m2l_ztranslate_coef(pm+1, pl+1, pl+1), &
!        & ddx_data % m2l_ztranslate_adj_coef(pl+1, pl+1, pm+1), &
!        & stat=istatus)
!    allocate(ddx_data % nfar(ddx_data % nclusters), &
!        & ddx_data % nnear(ddx_data % nclusters))
!    ! Build a recursive inertial binary tree
!    call tree_rib_build(nsph, csph2, rsph2, ddx_data % order, &
!        & ddx_data % cluster, ddx_data % children, ddx_data % parent, &
!        & ddx_data % cnode, ddx_data % rnode, ddx_data % snode)
!    ! Get list of neighbours for M2L operation
!    iwork = 0
!    call tree_get_farnear_work(ddx_data % nclusters, ddx_data % children, &
!        & ddx_data % cnode, ddx_data % rnode, lwork, iwork, jwork, work, &
!        & ddx_data % nnfar, ddx_data % nfar, ddx_data % nnnear, ddx_data % nnear)
!    if (iwork .le. jwork) then
!        write(*, "(A,A)") "Value of lwork, size of temporary buffer, ", &
!            & "is too low, please increase it"
!        stop 1
!    end if
!    allocate(ddx_data % far(ddx_data % nnfar), &
!        & ddx_data % sfar(ddx_data % nclusters+1), &
!        & ddx_data % near(ddx_data % nnnear), &
!        & ddx_data % snear(ddx_data % nclusters+1))
!    call tree_get_farnear(jwork, lwork, work, ddx_data % nclusters, &
!        & ddx_data % nnfar, ddx_data % nfar, ddx_data % sfar, ddx_data % far, &
!        & ddx_data % nnnear, ddx_data % nnear, ddx_data % snear, ddx_data % near)
!    ! Get far-field P2P for a reference result
!    do i = 1, nsph
!        far_p2p(i) = zero
!        do j = 1, nsph
!            ok = .true.
!            do k = ddx_data % snear(ddx_data % snode(i)), &
!                & ddx_data % snear(ddx_data % snode(i)+1)-1
!                if (ddx_data % near(k) .eq. ddx_data % snode(j)) ok = .false.
!            end do
!            if (ok) then
!                far_p2p(i) = far_p2p(i) + &
!                    & one/dnrm2(3, src(:, order(i))-src(:, order(j)), 1)
!            end if
!        end do
!    end do
!    ! Get constants, corresponding to given maximum degree of spherical
!    ! harmonics
!    call ylmscale(pm+pl, ddx_data % vscales, ddx_data % v4pi2lp1, &
!        & ddx_data % vscales_rel)
!    ddx_data % vfact(1) = one
!    do i = 2, 2*(pm+pl)+1
!        ddx_data % vfact(i) = ddx_data % vfact(i-1) * sqrt(dble(i-1))
!    end do
!    call fmm_constants(pm+pl, pm, pl, ddx_data % vcnk, &
!        & ddx_data % m2l_ztranslate_coef, &
!        & ddx_data % m2l_ztranslate_adj_coef)
!    ! Init input harmonics
!    do i = 1, nsph
!        call fmm_p2m(src(:, order(i))-csph2(:, i), one, rsph2(i), pm, &
!            & ddx_data % vscales, zero, node_m(:, ddx_data % snode(i)))
!    end do
!    ! Prepare M2M
!    call tree_m2m_rotation(ddx_data, node_m)
!    ! Check tree_m2l_rotation
!    if (iprint .gt. 0) then
!        write(*, "(/,A)") repeat("=", 40)
!        write(*, "(A)") "Check tree_m2l_rotation"
!        write(*, "(4x,A,I0)") "pm = ", pm
!        write(*, "(4x,A,I0)") "pl = ", pl
!        write(*, "(4x,A,ES24.16E3)") "alpha = ", alpha
!        write(*, "(4x,A,A)") "err = || P2M + [tree M2L] + L2P - P2P ||", &
!            & " / || P2P ||"
!        write(*, "(4x,A,ES23.16E3)") "threshold = ", threshold
!        write(*, "(A)") repeat("=", 40)
!        write(*, "(A)") " ok | err"
!        write(*, "(A)") repeat("=", 40)
!    end if
!    call tree_m2l_rotation(ddx_data, node_m, node_l)
!    call tree_l2l_rotation(ddx_data, node_l)
!    do i = 1, nsph
!        call fmm_l2p(src(:, order(i))-csph2(:, i), rsph2(i), pl, &
!            & ddx_data % vscales_rel, one, node_l(:, ddx_data % snode(i)), &
!            & zero, far_p2p2(i))
!    end do
!    rel_err = dnrm2(nsph, far_p2p-far_p2p2, 1) / dnrm2(nsph, far_p2p, 1)
!    ok = rel_err .le. threshold
!    if (iprint .gt. 0) then
!        write(*, "(L3,A,ES23.16E3)") ok, " | ", rel_err
!        write(*, "(A,/)") repeat("=", 40)
!    end if
!    if (.not. ok) stop 1
!    ! Reference value of M2L
!    call tree_m2l_rotation(ddx_data, node_m, node_l)
!    ! Allocate space for transfer matrices
!    ddx_data % m2l_reflect_mat_size = (max(pm,pl)+1)*(2*max(pm,pl)+1)* &
!        & (2*max(pm,pl)+3)/3
!    ddx_data % m2l_ztranslate_mat_size = (min(pm,pl)+1)*(min(pm,pl)+2)* &
!        & (3*max(pm,pl)+3-min(pm,pl))/6
!    allocate(ddx_data % m2l_reflect_mat(ddx_data % m2l_reflect_mat_size, &
!        & ddx_data % nnfar), stat=istatus)
!    if (istatus .ne. 0) stop "Allocation failed"
!    allocate(ddx_data % m2l_ztranslate_mat(ddx_data % m2l_ztranslate_mat_size, &
!        & ddx_data % nnfar), stat=istatus)
!    if (istatus .ne. 0) stop "Allocation failed"
!    ! Check tree_m2l_reflection_use_mat
!    if (iprint .gt. 0) then
!        write(*, "(/,A)") repeat("=", 40)
!        write(*, "(A)") "Check tree_m2l_reflection_get_mat"
!        write(*, "(A)") "Check tree_m2l_reflection_use_mat"
!        write(*, "(4x,A,I0)") "pm = ", pm
!        write(*, "(4x,A,I0)") "pl = ", pl
!        write(*, "(4x,A,ES24.16E3)") "alpha = ", alpha
!        write(*, "(4x,A,A)") "err = || [tree M2L] - [tree_m2l_rotation] ||", &
!            & " / || [tree_m2l_rotation] ||"
!        write(*, "(4x,A,ES23.16E3)") "threshold = ", 1d-15
!        write(*, "(A)") repeat("=", 40)
!        write(*, "(A)") " ok | err"
!        write(*, "(A)") repeat("=", 40)
!    end if
!    call tree_m2l_reflection_get_mat(ddx_data)
!    call tree_m2l_reflection_use_mat(ddx_data, node_m, node_l2)
!    rel_err = dnrm2((2*nsph-1)*((pl+1)**2), node_l2-node_l, 1) / &
!        & dnrm2((2*nsph-1)*((pl+1)**2), node_l, 1)
!    ok = rel_err .le. 1d-15
!    if (iprint .gt. 0) then
!        write(*, "(L3,A,ES23.16E3)") ok, " | ", rel_err
!        write(*, "(A,/)") repeat("=", 40)
!    end if
!    if (.not. ok) stop 1
!    ! Check tree_m2l_reflection_use_mat_adj
!    if (iprint .gt. 0) then
!        write(*, "(/,A)") repeat("=", 40)
!        write(*, "(A)") "Check tree_m2l_reflection_use_mat_adj"
!        write(*, "(4x,A,I0)") "pm = ", pm
!        write(*, "(4x,A,I0)") "pl = ", pl
!        write(*, "(4x,A,ES24.16E3)") "alpha = ", alpha
!        write(*, "(4x,A,A)") "err = || [tree M2L] - [adj tree M2L]^T ||", &
!            & " / || [tree M2L] ||"
!        write(*, "(4x,A,ES23.16E3)") "threshold = ", 1d-15
!        write(*, "(A)") repeat("=", 40)
!        write(*, "(A)") " ok | err"
!        write(*, "(A)") repeat("=", 40)
!    end if
!    do i = 1, ddx_data % nclusters
!        do j = 1, (pm+1)**2
!            node_m2 = zero
!            node_m2(j, i) = one
!            call tree_m2l_reflection_use_mat(ddx_data, node_m2, node_l2)
!            full_mat(:, :, j, i) = node_l2
!        end do
!    end do
!    full_norm = dnrm2((((2*nsph-1)*((pm+1)*(pl+1)))**2), full_mat, 1)
!    do i = 1, ddx_data % nclusters
!        do j = 1, (pl+1)**2
!            node_l2 = zero
!            node_l2(j, i) = one
!            call tree_m2l_reflection_use_mat_adj(ddx_data, node_l2, node_m2)
!            full_mat(j, i, :, :) = full_mat(j, i, :, :) - node_m2
!        end do
!    end do
!    diff_norm = dnrm2((((2*nsph-1)*((pm+1)*(pl+1)))**2), full_mat, 1)
!    rel_err = diff_norm / full_norm
!    ok = rel_err .le. 1d-15
!    if (iprint .gt. 0) then
!        write(*, "(L3,A,ES23.16E3)") ok, " | ", rel_err
!        write(*, "(A,/)") repeat("=", 40)
!    end if
!    if (.not. ok) stop 1
!    ! Check tree_m2l_rotation_adj
!    if (iprint .gt. 0) then
!        write(*, "(/,A)") repeat("=", 40)
!        write(*, "(A)") "Check tree_m2l_rotation_adj"
!        write(*, "(4x,A,I0)") "pm = ", pm
!        write(*, "(4x,A,I0)") "pl = ", pl
!        write(*, "(4x,A,ES24.16E3)") "alpha = ", alpha
!        write(*, "(4x,A,A)") "err = || [adj tree M2L] - [adj tree M2L] ||", &
!            & " / || [adj tree M2L] ||"
!        write(*, "(4x,A,ES23.16E3)") "threshold = ", 1d-15
!        write(*, "(A)") repeat("=", 40)
!        write(*, "(A)") " ok | err"
!        write(*, "(A)") repeat("=", 40)
!    end if
!    call tree_m2l_reflection_use_mat_adj(ddx_data, node_l, node_m)
!    call tree_m2l_rotation_adj(ddx_data, node_l, node_m2)
!    rel_err = dnrm2((2*nsph-1)*((pm+1)**2), node_m2-node_m, 1) / &
!        & dnrm2((2*nsph-1)*((pm+1)**2), node_m, 1)
!    ok = rel_err .le. 1d-15
!    if (iprint .gt. 0) then
!        write(*, "(L3,A,ES23.16E3)") ok, " | ", rel_err
!        write(*, "(A,/)") repeat("=", 40)
!    end if
!    if (.not. ok) stop 1
!    ! Deallocate tree
!    call deallocate_model(ddx_data, ddx_error)
!end subroutine check_tree_m2l
!
!subroutine check_tree_l2p(p, alpha, threshold)
!    ! Inputs
!    integer, intent(in) :: p, iprint
!    real(dp), intent(in) :: alpha, threshold
!    ! Local variables
!end subroutine check_tree_l2p
!
!subroutine check_tree_m2p
!end subroutine check_tree_m2p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! Baseline implementations of certain routines

! not used for now
!subroutine fmm_p2m_baseline(c, src_q, dst_r, p, vscales, beta, dst_m)
!    ! Inputs
!    integer, intent(in) :: p
!    real(dp), intent(in) :: c(3), src_q, dst_r, vscales((p+1)**2), beta
!    ! Output
!    real(dp), intent(inout) :: dst_m((p+1)**2)
!    ! Local variables
!    real(dp) :: rho, ctheta, stheta, cphi, sphi, vcos(p+1), vsin(p+1)
!    real(dp) :: vylm((p+1)**2), vplm((p+1)**2), t, rcoef
!    integer :: n, ind
!    ! Get radius and values of spherical harmonics
!    call ylmbas(c, rho, ctheta, stheta, cphi, sphi, p, vscales, vylm, vplm, &
!        & vcos, vsin)
!    ! Harmonics are available only if rho > 0
!    if (rho .ne. zero) then
!        rcoef = rho / dst_r
!        t = src_q / dst_r
!        ! Ignore input `m` in case of zero scaling factor
!        if (beta .eq. zero) then
!            do n = 0, p
!                ind = n*n + n + 1
!                dst_m(ind-n:ind+n) = t * vylm(ind-n:ind+n)
!                t = t * rcoef
!            end do
!        ! Update `m` otherwise
!        else
!            do n = 0, p
!                ind = n*n + n + 1
!                dst_m(ind-n:ind+n) = beta*dst_m(ind-n:ind+n) + &
!                    & t*vylm(ind-n:ind+n)
!                t = t * rcoef
!            end do
!        end if
!    ! Naive case of rho = 0
!    else
!        ! Ignore input `m` in case of zero scaling factor
!        if (beta .eq. zero) then
!            dst_m(1) = src_q / dst_r / sqrt4pi
!            dst_m(2:) = zero
!        ! Update `m` otherwise
!        else
!            dst_m(1) = beta*dst_m(1) + src_q/dst_r/sqrt4pi
!            dst_m(2:) = beta * dst_m(2:)
!        end if
!    end if
!end subroutine fmm_p2m_baseline

! not used for now
!subroutine fmm_p2m_bessel_baseline(c, src_q, dst_r, p, vscales, beta, dst_m)
!    ! Inputs
!    integer, intent(in) :: p
!    real(dp), intent(in) :: c(3), src_q, dst_r, vscales((p+1)**2), beta
!    ! Output
!    real(dp), intent(inout) :: dst_m((p+1)**2)
!    ! Local variables
!    real(dp) :: rho, ctheta, stheta, cphi, sphi, vcos(p+1), vsin(p+1), t
!    real(dp) :: vylm((p+1)**2), vplm((p+1)**2), si(p+1), dst_sk(p+1), work(p+1)
!    real(dp), parameter :: eight=8d0
!    complex(dp) :: work_complex(max(2, p+1))
!    integer :: n, ind
!    ! Get radius and values of spherical harmonics
!    call ylmbas(c, rho, ctheta, stheta, cphi, sphi, p, vscales, vylm, vplm, &
!        & vcos, vsin)
!    ! Get Bessel function for the sphere
!    call modified_spherical_bessel_first_kind(p, dst_r, dst_sk, work, &
!        & work_complex)
!    ! Harmonics are available only if rho > 0
!    if (rho .ne. zero) then
!        call modified_spherical_bessel_second_kind(p, rho, si, work, &
!            & work_complex)
!        ! Ignore input `m` in case of zero scaling factor
!        if (beta .eq. zero) then
!            do n = 0, p
!                ind = n*n + n + 1
!                t = eight * src_q * si(n+1) * dst_sk(n+1)
!                dst_m(ind-n:ind+n) = t * vylm(ind-n:ind+n)
!            end do
!        ! Update `m` otherwise
!        else
!            do n = 0, p
!                ind = n*n + n + 1
!                t = eight * src_q * si(n+1) * dst_sk(n+1)
!                dst_m(ind-n:ind+n) = beta*dst_m(ind-n:ind+n) + &
!                    & t*vylm(ind-n:ind+n)
!            end do
!        end if
!    ! Naive case of rho = 0
!    else
!        ! Ignore input `m` in case of zero scaling factor
!        if (beta .eq. zero) then
!            dst_m(1) = eight * src_q * dst_sk(1)
!            dst_m(2:) = zero
!        ! Update `m` otherwise
!        else
!            dst_m(1) = beta*dst_m(1) + eight*src_q*dst_sk(1)
!            dst_m(2:) = beta * dst_m(2:)
!        end if
!    end if
!end subroutine fmm_p2m_bessel_baseline

subroutine fmm_m2p_baseline(c, src_r, p, vscales, alpha, src_m, beta, dst_v)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: c(3), src_r, vscales((p+1)*(p+1)), alpha, &
        & src_m((p+1)*(p+1)), beta
    ! Output
    real(dp), intent(inout) :: dst_v
    ! Local variables
    real(dp) :: rho, vcos(p+1), vsin(p+1)
    real(dp) :: vylm((p+1)**2), vplm((p+1)**2), rcoef, t, tmp
    integer :: n, ind
    real(dp), external :: dnrm2
    ! Scale output
    if (beta .eq. zero) then
        dst_v = zero
    else
        dst_v = beta * dst_v
    end if
    ! In case of zero alpha nothing else is required no matter what is the
    ! value of the induced potential
    if (alpha .eq. zero) then
        return
    end if
    ! Get radius and values of spherical harmonics
    call ylmbas_baseline(c, p, vscales, vylm, vplm, vcos, vsin)
    ! In case of a singularity (rho=zero) induced potential is infinite and is
    ! not taken into account.
    rho = dnrm2(3, c, 1)
    if (rho .eq. zero) then
        return
    end if
    ! Compute the actual induced potential
    rcoef = src_r / rho
    t = alpha
    do n = 0, p
        t = t * rcoef
        ind = n*n + n + 1
        tmp = dot_product(vylm(ind-n:ind+n), src_m(ind-n:ind+n))
        ! Here vscales(ind)**2 is 4*pi/sqrt(2n+1)
        dst_v = dst_v + t*tmp/vscales(ind)**2
    end do
end subroutine fmm_m2p_baseline

subroutine fmm_m2p_bessel_baseline(c, src_r, p, vscales, alpha, &
        & src_m, beta, dst_v)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: c(3), src_r, vscales((p+1)*(p+1)), alpha, &
        & src_m((p+1)*(p+1)), beta
    ! Output
    real(dp), intent(inout) :: dst_v
    ! Local variables
    real(dp) :: rho, vcos(p+1), vsin(p+1)
    real(dp) :: vylm((p+1)**2), vplm((p+1)**2), tmp
    real(dp) :: sk(p+1), dk(p+1), src_sk(p+1)
    complex(dp) :: work(max(2, p+1))
    integer :: n, ind
    real(dp), external :: dnrm2
    ! Scale output
    if (beta .eq. zero) then
        dst_v = zero
    else
        dst_v = beta * dst_v
    end if
    ! In case of zero alpha nothing else is required no matter what is the
    ! value of the induced potential
    if (alpha .eq. zero) then
        return
    end if
    ! Get radius and values of spherical harmonics
    call ylmbas_baseline(c, p, vscales, vylm, vplm, vcos, vsin)
    ! Get values of the second kind Bessel function
    rho = dnrm2(3, c, 1)
    ! In case of a singularity (rho=zero) induced potential is infinite and is
    ! not taken into account.
    if (rho .eq. zero) then
        return
    end if
    call modified_spherical_bessel_second_kind(p, rho, sk, dk, work)
    call modified_spherical_bessel_second_kind(p, src_r, src_sk, dk, work)
    ! Compute the actual induced potential
    do n = 0, p
        ind = n*n + n + 1
        tmp = dot_product(vylm(ind-n:ind+n), src_m(ind-n:ind+n))
        dst_v = dst_v + alpha*sk(n+1)/src_sk(n+1)*tmp
    end do
end subroutine fmm_m2p_bessel_baseline

subroutine fmm_m2p_adj_baseline(c, src_q, dst_r, p, vscales, beta, dst_m)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: c(3), src_q, dst_r, vscales((p+1)*(p+1)), beta
    ! Output
    real(dp), intent(inout) :: dst_m((p+1)**2)
    ! Local variables
    real(dp) :: rho, vcos(p+1), vsin(p+1)
    real(dp) :: vylm((p+1)**2), vplm((p+1)**2), rcoef, t
    integer :: n, ind
    ! Scale output
    if (beta .eq. zero) then
        dst_m = zero
    else
        dst_m = beta * dst_m
    end if
    ! In case of zero src_q nothing else is required no matter what is the
    ! value of the induced potential
    if (src_q .eq. zero) then
        return
    end if
    ! In case of a singularity (rho=zero) induced potential is infinite and is
    ! not taken into account.
    rho = dnrm2(3, c, 1)
    if (rho .eq. zero) then
        return
    end if
    ! Get radius and values of spherical harmonics
    call ylmbas_baseline(c, p, vscales, vylm, vplm, vcos, vsin)
    ! Compute actual induced potentials
    rcoef = dst_r / rho
    t = src_q
    do n = 0, p
        t = t * rcoef
        ind = n*n + n + 1
        dst_m(ind-n:ind+n) = dst_m(ind-n:ind+n) + &
            & t/(vscales(ind)**2)*vylm(ind-n:ind+n)
    end do
end subroutine fmm_m2p_adj_baseline

! not used for now
!subroutine fmm_p2l_baseline(c, src_q, dst_r, p, vscales, beta, dst_l)
!    ! Inputs
!    integer, intent(in) :: p
!    real(dp), intent(in) :: c(3), src_q, dst_r, vscales((p+1)**2), beta
!    ! Output
!    real(dp), intent(inout) :: dst_l((p+1)**2)
!    ! Local variables
!    real(dp) :: rho, vcos(p+1), vsin(p+1)
!    real(dp) :: vylm((p+1)**2), vplm((p+1)**2), t, rcoef
!    integer :: n, ind
!    ! Local expansion represents potential from the outside of the sphere of
!    ! the given radius `dst_r`. In case `rho=zero` source particle is inside of
!    ! the sphere no matter what radius `r` is, so we just ignore such a case.
!    rho = dnrm2(3, c, 1)
!    if (rho .eq. zero) then
!        if (beta .eq. zero) then
!            dst_l = zero
!        else
!            dst_l = beta * dst_l
!        end if
!        return
!    end if
!    ! Get radius and values of spherical harmonics
!    call ylmbas_baseline(c, p, vscales, vylm, vplm, vcos, vsin)
!    rcoef = dst_r / rho
!    t = src_q / rho
!    ! Ignore input `m` in case of zero scaling factor
!    if (beta .eq. zero) then
!        do n = 0, p
!            ind = n*n + n + 1
!            dst_l(ind-n:ind+n) = t * vylm(ind-n:ind+n)
!            t = t * rcoef
!        end do
!    ! Update `m` otherwise
!    else
!        do n = 0, p
!            ind = n*n + n + 1
!            dst_l(ind-n:ind+n) = beta*dst_l(ind-n:ind+n) + t*vylm(ind-n:ind+n)
!            t = t * rcoef
!        end do
!    end if
!end subroutine fmm_p2l_baseline

subroutine fmm_l2p_baseline(c, src_r, p, vscales, alpha, src_l, beta, dst_v)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: c(3), src_r, vscales((p+1)*(p+1)), alpha, &
        & src_l((p+1)*(p+1)), beta
    ! Output
    real(dp), intent(inout) :: dst_v
    ! Local variables
    real(dp) :: tmp
    real(dp) :: rho, t, vcos(p+1), vsin(p+1)
    real(dp) :: vplm((p+1)**2), vylm((p+1)**2), rcoef
    integer :: n, ind
    ! Scale output
    if (beta .eq. zero) then
        dst_v = zero
    else
        dst_v = beta * dst_v
    end if
    ! In case of zero alpha nothing else is required no matter what is the
    ! value of the induced potential
    if (alpha .eq. zero) then
        return
    end if
    ! In case `rho=zero` values of spherical harmonics make no sense and only
    ! spherical harmonic of degree 0 shall be taken into account
    rho = dnrm2(3, c, 1)
    if (rho .eq. zero) then
        dst_v = dst_v + alpha*src_l(1)/vscales(1)
    ! Compute the actual induced potential otherwise
    else
        ! Get radius and values of spherical harmonics
        call ylmbas_baseline(c, p, vscales, vylm, vplm, vcos, vsin)
        rcoef = rho / src_r
        t = alpha
        do n = 0, p
            ind = n*n + n + 1
            tmp = dot_product(vylm(ind-n:ind+n), src_l(ind-n:ind+n))
            dst_v = dst_v + t*tmp/(vscales(ind)**2)
            t = t * rcoef
        end do
    end if
end subroutine fmm_l2p_baseline

subroutine fmm_l2p_bessel_baseline(c, src_r, p, vscales, alpha, src_l, &
        & beta, dst_v)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: c(3), src_r, vscales((p+1)*(p+1)), alpha, &
        & src_l((p+1)*(p+1)), beta
    ! Output
    real(dp), intent(inout) :: dst_v
    ! Local variables
    real(dp) :: rho, vcos(p+1), vsin(p+1)
    real(dp) :: vylm((p+1)**2), vplm((p+1)**2), tmp
    real(dp) :: si(p+1), di(p+1), src_si(p+1)
    complex(dp) :: work(max(2, p+1))
    integer :: n, ind
    real(dp), external :: dnrm2
    ! Scale output
    if (beta .eq. zero) then
        dst_v = zero
    else
        dst_v = beta * dst_v
    end if
    ! In case of zero alpha nothing else is required no matter what is the
    ! value of the induced potential
    if (alpha .eq. zero) then
        return
    end if
    ! Get radius and values of spherical harmonics
    call ylmbas_baseline(c, p, vscales, vylm, vplm, vcos, vsin)
    ! Get values of the second kind Bessel function
    rho = dnrm2(3, c, 1)
    call modified_spherical_bessel_first_kind(p, rho, si, di, work)
    call modified_spherical_bessel_first_kind(p, src_r, src_si, di, work)
    ! Compute the actual induced potential
    do n = 0, p
        ind = n*n + n + 1
        tmp = dot_product(vylm(ind-n:ind+n), src_l(ind-n:ind+n))
        dst_v = dst_v + alpha*si(n+1)/src_si(n+1)*tmp
    end do
end subroutine fmm_l2p_bessel_baseline

subroutine fmm_l2p_adj_baseline(c, src_q, dst_r, p, vscales, beta, dst_l)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: c(3), src_q, dst_r, vscales((p+1)*(p+1)), beta
    ! Output
    real(dp), intent(inout) :: dst_l((p+1)**2)
    ! Local variables
    real(dp) :: rho, t, vcos(p+1), vsin(p+1)
    real(dp) :: vplm((p+1)**2), vylm((p+1)**2), rcoef
    integer :: n, ind
    ! Scale output
    if (beta .eq. zero) then
        dst_l = zero
    else
        dst_l = beta * dst_l
    end if
    ! In case of zero src_q nothing else is required no matter what is the
    ! value of the induced potential
    if (src_q .eq. zero) then
        return
    end if
    ! In case `rho=zero` values of spherical harmonics make no sense and only
    ! spherical harmonic of degree 0 shall be taken into account
    rho = dnrm2(3, c, 1)
    if (rho .eq. zero) then
        dst_l(1) = dst_l(1) + src_q/vscales(1)
    ! Compute the actual induced potential otherwise
    else
        ! Get radius and values of spherical harmonics
        call ylmbas_baseline(c, p, vscales, vylm, vplm, vcos, vsin)
        rcoef = rho / dst_r
        t = src_q
        do n = 0, p
            ind = n*n + n + 1
            !tmp = dot_product(vylm(ind-n:ind+n), src_l(ind-n:ind+n))
            !dst_v = dst_v + t*tmp/(vscales(ind)**2)
            dst_l(ind-n:ind+n) = dst_l(ind-n:ind+n) + &
                & t/(vscales(ind)**2)*vylm(ind-n:ind+n)
            t = t * rcoef
        end do
    end if
end subroutine fmm_l2p_adj_baseline

subroutine polleg_baseline(ctheta, stheta, p, vplm)
    ! Inputs
    integer, intent(in) :: p
    real(dp), intent(in) :: ctheta, stheta
    ! Outputs
    real(dp), intent(out) :: vplm((p+1)**2)
    ! Temporary workspace
    real(dp) :: work(p+1)
    ! Local variables
    integer :: m, ind, l, ind2
    real(dp) :: fact, pmm, pmm1, pmmo, pll, fm, fl
    ! Init aux factors
    fact = one
    pmm = one
    work(1) = ctheta
    fm = two * ctheta
    do m = 1, p
        work(m+1) = work(m) + fm
    end do
    ! This loop goes over non-negative upper index of P_l^m, namely m, and
    ! defines value for all l from m to p. Polynomials P_l^m are defined only
    ! for l >= |m|. Only positive values of m are filled. Here we
    ! define at first P_m^m, then P_{m+1}^m and then all remaining P_l^m for
    ! l from m+2 to p.
    do m = 0, p
        ! index of P_m^m
        ind = (m+1) * (m+1)
        ! Store P_m^m
        !print *, "l=", m, "z=", pmm
        vplm(ind) = pmm
        if (m .eq. p) then
            return
        end if
        fm = dble(m)
        ! index of P_{m+1}^m
        ind2 = ind + 2*m + 2
        ! P_{m+1}^m
        pmm1 = work(m+1) * pmm
        vplm(ind2) = pmm1
        ! Save value P_m^m for recursion
        pmmo = pmm
        ! Fill values of P_l^m
        do l = m+2, p
            ind2 = ind2 + 2*l
            ! pmm corresponds to P_{l-2}^m
            ! pmm1 corresponds to P_{l-1}^m
            fl = dble(l)
            ! Compute P_l^m
            pll = work(l)*pmm1 - (fl+fm-1)*pmm
            pll = pll / (fl-fm)
            ! Store P_l^m
            !vplm(l*l + l + m + 1) = pll
            vplm(ind2) = pll
            ! Save P_{l-1}^m and P_l^m for recursion
            pmm = pmm1
            pmm1 = pll
        end do
        ! Value of P_{m+1}^{m+1}
        pmm = -pmmo * fact * stheta
        fact = fact + two
    end do
end subroutine polleg_baseline

subroutine ylmbas_baseline(x, p, vscales, vylm, vplm, vcos, vsin)
    integer, intent(in) :: p
    real(dp), dimension(3), intent(in) :: x
    real(dp), dimension((p+1)**2), intent(in) :: vscales
    real(dp), dimension((p+1)**2), intent(out) :: vylm, vplm
    real(dp), dimension(p+1), intent(out) :: vcos, vsin
    integer :: l, m, ind
    real(dp) :: y(3), r, cthe, sthe, cphi, sphi, plm
    real(dp), external :: dnrm2
    r = dnrm2(3, x, 1)
    ! Check zero input, fake it with vector (0,0,1) as zero radius must be
    ! taken into account in some other routine, as spherical harmonics do not
    ! depend on radius
    if (r .eq. zero) then
        y = (/zero, zero, one/)
    ! Do normal calculations otherwise
    else
        y = x / r
    end if
    cthe = y(3)
    sthe = dnrm2(2, y, 1)
    if (sthe .ne. zero) then
        cphi = y(1) / sthe
        sphi = y(2) / sthe
        call trgev(cphi, sphi, p, vcos, vsin)
    else
        cphi = one
        sphi = zero
        vcos = one
        vsin = zero
    endif
    call polleg_baseline(cthe, sthe, p, vplm)
    do l = 0, p
        ind = l**2 + l + 1
        vylm(ind) = vscales(ind) * vplm(ind)
        do m = 1, l
            plm = vplm(ind+m) * vscales(ind+m)
            vylm(ind+m) = plm * vcos(m+1)
            vylm(ind-m) = plm * vsin(m+1)
        enddo
    enddo
end subroutine ylmbas_baseline

! M2M baseline translation (p^4 operations)
! Baseline in terms of operation count: p^4
subroutine fmm_m2m_baseline(c, src_r, dst_r, p, vscales, src_m, dst_m)
! Parameters:
!   c: radius-vector from new to old centers of harmonics
!   src_r: radius of old harmonics
!   dst_r: radius of new harmonics
!   p: maximum degree of spherical harmonics
!   vscales: normalization constants for Y_lm
!   src_m: expansion in old harmonics
!   dst_m: expansion in new harmonics
    integer, intent(in) :: p
    real(dp), intent(in) :: c(3), src_r, dst_r, vscales((p+1)*(p+1))
    real(dp), intent(in) :: src_m((p+1)*(p+1))
    real(dp), intent(inout) :: dst_m((p+1)*(p+1))
    real(dp) :: r, r1, r2, ctheta, stheta, cphi, sphi, vcos(p+1), vsin(p+1)
    real(dp) :: vplm((p+1)*(p+1)), fact(2*p+1), tmpk1, tmpk2, tmpk3, tmp1
    real(dp) :: tmp2, pow_r1(p+1), pow_r2(p+1)
    integer :: j, k, n, m, indj, indm, indn, indjn
    real(dp), external :: dnrm2
    stheta = dnrm2(2, c, 1)
    r = dnrm2(3, c, 1)
    if (r .ne. 0) then
        ctheta = c(3) / r
        if (stheta .ne. 0) then
            cphi = c(1) / stheta
            sphi = c(2) / stheta
            stheta = stheta / r
            call trgev(cphi, sphi, p, vcos, vsin)
        else
            cphi = 1
            sphi = 0
            vcos = 1
            vsin = 0
        end if
        call polleg_baseline(ctheta, stheta, p, vplm)
        r1 = src_r / dst_r
        r2 = r / dst_r
        pow_r1(1) = r1
        pow_r2(1) = 1
        do j = 2, p+1
            pow_r1(j) = pow_r1(j-1) * r1
            pow_r2(j) = pow_r2(j-1) * r2
        end do
        ! Fill square roots of factorials
        fact(1) = 1
        do j = 2, 2*p+1
            fact(j) = sqrt(dble(j-1)) * fact(j-1)
        end do
        do j = 0, p
            indj = j*j + j + 1
            do k = 0, j
                tmp1 = vscales(indj) * fact(j-k+1) * fact(j+k+1)
                if (k .ne. 0) then
                    tmp1 = tmp1 * sqrt2
                end if
                do n = 0, j
                    indn = n*n + n + 1
                    indjn = (j-n)**2 + (j-n) + 1
                    tmp2 = tmp1 * pow_r1(j-n+1) * pow_r2(n+1) / &
                        & vscales(indjn) / vscales(indn)
                    do m = max(k+n-j, -n), min(k+j-n, n)
                        indm = indn + abs(m)
                        cphi = vcos(1+abs(m))
                        sphi = vsin(1+abs(m))
                        tmpk1 = tmp2 / fact(n-m+1) / fact(n+m+1) / &
                            & fact(j-n-k+m+1) / fact(j-n+k-m+1) * &
                            & vplm(indm) * vscales(indm)
                        if (mod(abs(k-abs(m)-abs(k-m)), 4) .eq. 2) then
                            tmpk1 = -tmpk1
                        end if
                        tmpk2 = src_m(indjn+abs(k-m)) * cphi
                        if ((m .ge. 0) .and. (m .le. k)) then
                            sphi = -sphi
                        end if
                        tmpk3 = -src_m(indjn+abs(k-m)) * sphi
                        if (m .ne. 0) then
                            tmpk1 = tmpk1 / sqrt2
                        end if
                        if (m .ne. k) then
                            tmpk1 = tmpk1 / sqrt2
                            tmpk2 = tmpk2 + src_m(indjn-abs(k-m))*sphi
                            tmpk3 = tmpk3 + src_m(indjn-abs(k-m))*cphi
                        end if
                        if (m .gt. k) then
                            tmpk3 = -tmpk3
                        end if
                        dst_m(indj+k) = dst_m(indj+k) + tmpk1*tmpk2
                        if (k .ne. 0) then
                            dst_m(indj-k) = dst_m(indj-k) + tmpk1*tmpk3
                        end if
                    end do
                end do
            end do
        end do
    else
        r1 = src_r / dst_r
        tmpk1 = r1
        do j = 0, p
            indj = j*j + j + 1
            do k = indj-j, indj+j
                dst_m(k) = dst_m(k) + src_m(k)*tmpk1
            end do
            tmpk1 = tmpk1 * r1
        end do
    end if
end subroutine fmm_m2m_baseline

! M2M baseline translation (p^4 operations)
! Baseline in terms of operation count: p^4
! not used for now
!subroutine fmm_m2m_bessel_baseline(c, src_r, dst_r, p, vscales, src_m, dst_m)
!! Parameters:
!!   c: radius-vector from new to old centers of harmonics
!!   src_r: radius of old harmonics
!!   dst_r: radius of new harmonics
!!   p: maximum degree of spherical harmonics
!!   vscales: normalization constants for Y_lm
!!   src_m: expansion in old harmonics
!!   dst_m: expansion in new harmonics
!    use complex_bessel
!    integer, intent(in) :: p
!    real(dp), intent(in) :: c(3), src_r, dst_r, vscales((p+1)*(p+1))
!    real(dp), intent(in) :: src_m((p+1)*(p+1))
!    real(dp), intent(inout) :: dst_m((p+1)*(p+1))
!    real(dp) :: r, r1, r2, ctheta, stheta, cphi, sphi, vcos(p+1), vsin(p+1)
!    real(dp) :: vplm((p+1)*(p+1)), fact(2*p+1), tmpk1, tmpk2, tmpk3, tmp1
!    real(dp) :: tmp2, pow_r1(p+1), pow_r2(p+1)
!    real(dp) :: r_si(p+1), src_sk(p+1), dst_sk(p+1), work(p+1)
!    complex(dp) :: work_complex(p+1)
!    integer :: j, k, n, m, indj, indm, indn, indjn
!    real(dp), external :: dnrm2
!    stheta = dnrm2(2, c, 1)
!    r = dnrm2(3, c, 1)
!    if (r .ne. 0) then
!        ctheta = c(3) / r
!        if (stheta .ne. 0) then
!            cphi = c(1) / stheta
!            sphi = c(2) / stheta
!            stheta = stheta / r
!            call trgev(cphi, sphi, p, vcos, vsin)
!        else
!            cphi = 1
!            sphi = 0
!            vcos = 1
!            vsin = 0
!        end if
!        call polleg_baseline(ctheta, stheta, p, vplm)
!        r1 = src_r / dst_r
!        r2 = r! / dst_r
!        pow_r1(1) = r1
!        pow_r2(1) = 1
!        do j = 2, p+1
!            pow_r1(j) = pow_r1(j-1) * r1
!            pow_r2(j) = pow_r2(j-1) * r2
!        end do
!        call modified_spherical_bessel_first_kind(p, r, r_si, work, &
!            & work_complex)
!        call modified_spherical_bessel_second_kind(p, src_r, src_sk, work, &
!            & work_complex)
!        call modified_spherical_bessel_second_kind(p, dst_r, dst_sk, work, &
!            & work_complex)
!        ! Fill square roots of factorials
!        fact(1) = 1
!        do j = 2, 2*p+1
!            fact(j) = sqrt(dble(j-1)) * fact(j-1)
!        end do
!        do j = 0, p
!            indj = j*j + j + 1
!            do k = 0, j
!                tmp1 = vscales(indj) * fact(j-k+1) * fact(j+k+1)
!                if (k .ne. 0) then
!                    tmp1 = tmp1 * sqrt2
!                end if
!                do n = 0, j
!                    indn = n*n + n + 1
!                    indjn = (j-n)**2 + (j-n) + 1
!                    !tmp2 = tmp1 * pow_r1(j-n+1) * pow_r2(n+1) / &
!                    !    & vscales(indjn) / vscales(indn)
!                    tmp2 = tmp1 * & !/ src_sk(j-n+1) * dst_sk(j+1) *
!                        & r_si(n+1) / &
!                        & vscales(indjn) / vscales(indn) !/ pow_r2(n+1)
!                    !tmp2 = tmp1 * r_si(n+1) / &
!                    !    & vscales(indjn) / vscales(indn)
!                    do m = max(k+n-j, -n), min(k+j-n, n)
!                        indm = indn + abs(m)
!                        cphi = vcos(1+abs(m))
!                        sphi = vsin(1+abs(m))
!                        tmpk1 = tmp2 / fact(n-m+1) / fact(n+m+1) / &
!                            & fact(j-n-k+m+1) / fact(j-n+k-m+1) * &
!                            & vplm(indm) * vscales(indm)
!                        if (mod(abs(k-abs(m)-abs(k-m)), 4) .eq. 2) then
!                            tmpk1 = -tmpk1
!                        end if
!                        tmpk2 = src_m(indjn+abs(k-m)) * cphi
!                        if ((m .ge. 0) .and. (m .le. k)) then
!                            sphi = -sphi
!                        end if
!                        tmpk3 = -src_m(indjn+abs(k-m)) * sphi
!                        if (m .ne. 0) then
!                            tmpk1 = tmpk1 / sqrt2
!                        end if
!                        if (m .ne. k) then
!                            tmpk1 = tmpk1 / sqrt2
!                            tmpk2 = tmpk2 + src_m(indjn-abs(k-m))*sphi
!                            tmpk3 = tmpk3 + src_m(indjn-abs(k-m))*cphi
!                        end if
!                        if (m .gt. k) then
!                            tmpk3 = -tmpk3
!                        end if
!                        dst_m(indj+k) = dst_m(indj+k) + tmpk1*tmpk2
!                        if (k .ne. 0) then
!                            dst_m(indj-k) = dst_m(indj-k) + tmpk1*tmpk3
!                        end if
!                    end do
!                end do
!            end do
!        end do
!    else
!        r1 = src_r / dst_r
!        tmpk1 = r1
!        do j = 0, p
!            indj = j*j + j + 1
!            do k = indj-j, indj+j
!                dst_m(k) = dst_m(k) + src_m(k)*tmpk1
!            end do
!            tmpk1 = tmpk1 * r1
!        end do
!    end if
!end subroutine fmm_m2m_bessel_baseline

! Translate local expansion to another sphere
! Baseline in terms of operation count: p^4
subroutine fmm_l2l_baseline(c, src_r, dst_r, p, vscales, src_l, dst_l)
! Parameters:
!   c: radius-vector from new to old centers of harmonics
!   src_r: radius of old harmonics
!   dst_r: radius of new harmonics
!   p: maximum degree of local spherical harmonics
!   vscales: normalization constants for Y_lm (of degree up to p)
!   src_l: expansion in old harmonics
!   dst_l: expansion in new harmonics
    integer, intent(in) :: p
    real(dp), intent(in) :: c(3), src_r, dst_r, vscales((p+1)*(p+1))
    real(dp), intent(in) :: src_l((p+1)*(p+1))
    real(dp), intent(inout) :: dst_l((p+1)*(p+1))
    real(dp) :: r, r1, r2, ctheta, stheta, cphi, sphi
    real(dp) :: vcos(p+1), vsin(p+1)
    real(dp) :: vplm((p+1)*(p+1)), fact(2*p+1), tmpk1, tmpk2, tmpk3
    real(dp) :: tmp1, tmp2, pow_r1(p+1), pow_r2(p+1)
    integer :: j, k, n, m, indj, indmk, indn, indjn
    stheta = dnrm2(2, c, 1)
    r = dnrm2(3, c, 1)
    if (r .ne. 0) then
        ctheta = c(3) / r
        if (stheta .ne. 0) then
            cphi = c(1) / stheta
            sphi = c(2) / stheta
            stheta = stheta / r
            call trgev(cphi, sphi, p, vcos, vsin)
        else
            cphi = 1
            sphi = 0
            vcos = 1
            vsin = 0
        end if
        call polleg_baseline(ctheta, stheta, p, vplm)
        r1 = r / src_r
        r2 = dst_r / r
        pow_r1(1) = 1
        pow_r2(1) = 1
        do j = 2, p+1
            pow_r1(j) = pow_r1(j-1) * r1
            pow_r2(j) = pow_r2(j-1) * r2
        end do
        ! Fill square roots of factorials
        fact(1) = 1
        do j = 2, 2*p+1
            fact(j) = sqrt(dble(j-1)) * fact(j-1)
        end do
        do j = 0, p
            indj = j*j + j + 1
            do k = 0, j
                tmp1 = pow_r2(j+1) / fact(j-k+1) / fact(j+k+1) * vscales(indj)
                if (k .ne. 0) then
                    tmp1 = tmp1 * sqrt2
                end if
                do n = j, p
                    indn = n*n + n + 1
                    indjn = (n-j)**2 + (n-j) + 1
                    tmp2 = tmp1 * pow_r1(n+1) / vscales(indjn) / vscales(indn)
                    if (mod(n+j, 2) .eq. 1) then
                        tmp2 = -tmp2
                    end if
                    do m = k+j-n, k+n-j
                        indmk = indjn + abs(m-k)
                        cphi = vcos(1+abs(m-k))
                        sphi = vsin(1+abs(m-k))
                        tmpk1 = tmp2 * fact(n-m+1) * fact(n+m+1) / &
                            & fact(n-j-m+k+1) / fact(n-j+m-k+1) * &
                            & vplm(indmk) * vscales(indmk)
                        if (mod(abs(k+abs(m-k)-abs(m)), 4) .eq. 2) then
                            tmpk1 = -tmpk1
                        end if
                        tmpk2 = src_l(indn+abs(m)) * cphi
                        if ((m .ge. 0) .and. (m .le. k)) then
                            sphi = -sphi
                        end if
                        tmpk3 = -src_l(indn+abs(m)) * sphi
                        if (m .ne. k) then
                            tmpk1 = tmpk1 / sqrt2
                        end if
                        if (m .ne. 0) then
                            tmpk1 = tmpk1 / sqrt2
                            tmpk2 = tmpk2 + src_l(indn-abs(m))*sphi
                            tmpk3 = tmpk3 + src_l(indn-abs(m))*cphi
                        end if
                        if (m .lt. 0) then
                            tmpk3 = -tmpk3
                        end if
                        dst_l(indj+k) = dst_l(indj+k) + tmpk1*tmpk2
                        if (k .ne. 0) then
                            dst_l(indj-k) = dst_l(indj-k) + tmpk1*tmpk3
                        end if
                    end do
                end do
            end do
        end do
    else
        r1 = dst_r / src_r
        tmpk1 = 1
        do j = 0, p
            indj = j*j + j + 1
            do k = indj-j, indj+j
                dst_l(k) = dst_l(k) + src_l(k)*tmpk1
            end do
            tmpk1 = tmpk1 * r1
        end do
    end if
end subroutine fmm_l2l_baseline

! Compute local expansion by given multipole expansion
! Baseline in terms of operation count: p^4
subroutine fmm_m2l_baseline(c, src_r, dst_r, pm, pl, vscales, src_m, dst_l)
! Parameters:
!   c: radius-vector from new (local) to old (multipole) centers of harmonics
!   src_r: radius of old (multipole) harmonics
!   dst_r: radius of new (local) harmonics
!   pm: maximum degree of multipole spherical harmonics
!   pl: maximum degree of local spherical harmonics
!   vscales: normalization constants for Y_lm (of degree up to pl+pm)
!   src_m: expansion in old (multipole) harmonics
!   dst_l: expansion in new (local) harmonics
    integer, intent(in) :: pm, pl
    real(dp), intent(in) :: c(3), src_r, dst_r
    real(dp), intent(in) :: vscales((pm+pl+1)*(pm+pl+1))
    real(dp), intent(in) :: src_m((pm+1)*(pm+1))
    real(dp), intent(inout) :: dst_l((pl+1)*(pl+1))
    real(dp) :: r, r1, r2, ctheta, stheta, cphi, sphi
    real(dp) :: vcos(pm+pl+1), vsin(pm+pl+1)
    real(dp) :: vplm((pm+pl+1)*(pm+pl+1)), fact(2*(pm+pl)+1), tmpk1, tmpk2
    real(dp) :: tmpk3, tmp1, tmp2, pow_r1(pm+1), pow_r2(pl+1)
    integer :: j, k, n, m, indj, indmk, indn, indjn
    real(dp), external :: dnrm2
    stheta = dnrm2(2, c, 1)
    r = dnrm2(3, c, 1)
    ! r cannot be zero, as input sphere (multipole) must not intersect with
    ! output sphere (local)
    if (r .eq. 0) then
        return
    end if
    ctheta = c(3) / r
    if (stheta .ne. 0) then
        cphi = c(1) / stheta
        sphi = c(2) / stheta
        stheta = stheta / r
        call trgev(cphi, sphi, pm+pl, vcos, vsin)
    else
        cphi = 1
        sphi = 0
        vcos = 1
        vsin = 0
    end if
    call polleg_baseline(ctheta, stheta, pm+pl, vplm)
    r1 = src_r / r
    r2 = dst_r / r
    pow_r1(1) = r1
    pow_r2(1) = 1
    do j = 2, pm+1
        pow_r1(j) = pow_r1(j-1) * r1
    end do
    do j = 2, pl+1
        pow_r2(j) = pow_r2(j-1) * r2
    end do
    ! Fill square roots of factorials
    fact(1) = 1
    do j = 2, 2*(pm+pl)+1
        fact(j) = sqrt(dble(j-1)) * fact(j-1)
    end do
    do j = 0, pl
        indj = j*j + j + 1
        do k = 0, j
            tmp1 = vscales(indj) * pow_r2(j+1) / fact(j-k+1) / fact(j+k+1)
            if (k .ne. 0) then
                tmp1 = tmp1 * sqrt2
            end if
            do n = 0, pm
                indn = n*n + n + 1
                indjn = (j+n)**2 + (j+n) + 1
                tmp2 = tmp1 * pow_r1(n+1) / vscales(indjn) / vscales(indn)
                if (mod(n, 2) .eq. 1) then
                    tmp2 = -tmp2
                end if
                do m = -n, n
                    indmk = indjn + abs(m-k)
                    cphi = vcos(1+abs(m-k))
                    sphi = vsin(1+abs(m-k))
                    tmpk1 = tmp2 / fact(n-m+1) / fact(n+m+1) * &
                        & fact(j+n-m+k+1) * fact(j+n+m-k+1) * vplm(indmk) * &
                        & vscales(indmk)
                    if (mod(abs(k+abs(m)-abs(k-m)), 4) .eq. 2) then
                        tmpk1 = -tmpk1
                    end if
                    tmpk2 = src_m(indn+abs(m)) * cphi
                    if ((m .ge. 0) .and. (m .le. k)) then
                        sphi = -sphi
                    end if
                    tmpk3 = -src_m(indn+abs(m)) * sphi
                    if (m .ne. k) then
                        tmpk1 = tmpk1 / sqrt2
                    end if
                    if (m .ne. 0) then
                        tmpk1 = tmpk1 / sqrt2
                        tmpk2 = tmpk2 + src_m(indn-abs(m))*sphi
                        tmpk3 = tmpk3 + src_m(indn-abs(m))*cphi
                    end if
                    if (m .lt. 0) then
                        tmpk3 = -tmpk3
                    end if
                    dst_l(indj+k) = dst_l(indj+k) + tmpk1*tmpk2
                    if (k .ne. 0) then
                        dst_l(indj-k) = dst_l(indj-k) + tmpk1*tmpk3
                    end if
                end do
            end do
        end do
    end do
end subroutine fmm_m2l_baseline

end program test_ddx_core

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3
   use dftd3_cutoff, only : realspace_cutoff, get_lattice_points
   use dftd3_disp, only : get_dispersion, get_pairwise_dispersion
   use dftd3_ncoord, only : get_coordination_number
   use dftd3_damping, only : damping_param
   use dftd3_damping_cso, only : cso_damping_param, new_cso_damping
   use dftd3_damping_mzero, only : mzero_damping_param, new_mzero_damping
   use dftd3_damping_optimizedpower, only : optimizedpower_damping_param, &
      & new_optimizedpower_damping
   use dftd3_damping_rational, only : rational_damping_param, new_rational_damping
   use dftd3_damping_zero, only : zero_damping_param, new_zero_damping
   use dftd3_model, only : d3_model, new_d3_model
   use dftd3_param, only : d3_param, get_rational_damping, get_zero_damping, &
      & get_mrational_damping, get_mzero_damping, get_optimizedpower_damping, &
      & get_cso_damping
   use dftd3_version, only : get_dftd3_version
   implicit none
   private

   public :: get_dispersion, get_pairwise_dispersion
   public :: get_coordination_number
   public :: realspace_cutoff, get_lattice_points
   public :: damping_param, d3_param
   public :: get_rational_damping, get_zero_damping
   public :: get_mrational_damping, get_mzero_damping
   public :: get_optimizedpower_damping
   public :: get_cso_damping
   public :: cso_damping_param, new_cso_damping
   public :: mzero_damping_param, new_mzero_damping
   public :: optimizedpower_damping_param, new_optimizedpower_damping
   public :: rational_damping_param, new_rational_damping
   public :: zero_damping_param, new_zero_damping
   public :: d3_model, new_d3_model
   public :: get_dftd3_version


end module dftd3

! This file is part of multicharge.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

#ifndef IK
#define IK i4
#endif

!> Interface to BLAS library for matrix-vector and matrix-matrix operations
module multicharge_blas
   use mctc_env, only : sp, dp, ik => IK
   implicit none
   private

   public :: symv, gemv, gemm


   !> Performs one of the matrix-vector operations
   !>
   !>    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
   !>
   !> where alpha and beta are scalars, x and y are vectors and A is an
   !> m by n matrix.
   interface gemv
      module procedure :: mchrg_sgemv
      module procedure :: mchrg_dgemv
      module procedure :: mchrg_sgemv312
      module procedure :: mchrg_sgemv321
      module procedure :: mchrg_dgemv312
      module procedure :: mchrg_dgemv321
   end interface gemv

   !> Performs the matrix-vector  operation
   !>
   !>    y := alpha*A*x + beta*y,
   !>
   !> where alpha and beta are scalars, x and y are n element vectors and
   !> A is an n by n symmetric matrix.
   interface symv
      module procedure :: mchrg_ssymv
      module procedure :: mchrg_dsymv
   end interface symv

   !> Performs one of the matrix-matrix operations
   !>
   !>    C := alpha*A*B + beta*C,
   !>
   !> or
   !>
   !>    C := alpha*B*A + beta*C,
   !>
   !> where alpha and beta are scalars,  A is a symmetric matrix and  B and
   !> C are  m by n matrices.
   interface gemm
      module procedure :: mchrg_sgemm
      module procedure :: mchrg_dgemm
      module procedure :: mchrg_sgemm323
      module procedure :: mchrg_sgemm233
      module procedure :: mchrg_sgemm332
      module procedure :: mchrg_dgemm323
      module procedure :: mchrg_dgemm233
      module procedure :: mchrg_dgemm332
   end interface gemm


   !> Performs one of the matrix-vector operations
   !>
   !>    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
   !>
   !> where alpha and beta are scalars, x and y are vectors and A is an
   !> m by n matrix.
   interface blas_gemv
      pure subroutine sgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: sp, ik
         integer(ik), intent(in) :: lda
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: x(*)
         real(sp), intent(inout) :: y(*)
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer(ik), intent(in) :: incx
         integer(ik), intent(in) :: incy
         integer(ik), intent(in) :: m
         integer(ik), intent(in) :: n
      end subroutine sgemv
      pure subroutine dgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: dp, ik
         integer(ik), intent(in) :: lda
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: x(*)
         real(dp), intent(inout) :: y(*)
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer(ik), intent(in) :: incx
         integer(ik), intent(in) :: incy
         integer(ik), intent(in) :: m
         integer(ik), intent(in) :: n
      end subroutine dgemv
   end interface blas_gemv

   !> Performs the matrix-vector  operation
   !>
   !>    y := alpha*A*x + beta*y,
   !>
   !> where alpha and beta are scalars, x and y are n element vectors and
   !> A is an n by n symmetric matrix.
   interface blas_symv
      pure subroutine ssymv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: sp, ik
         integer(ik), intent(in) :: lda
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: x(*)
         real(sp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer(ik), intent(in) :: incx
         integer(ik), intent(in) :: incy
         integer(ik), intent(in) :: n
      end subroutine ssymv
      pure subroutine dsymv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: dp, ik
         integer(ik), intent(in) :: lda
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: x(*)
         real(dp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer(ik), intent(in) :: incx
         integer(ik), intent(in) :: incy
         integer(ik), intent(in) :: n
      end subroutine dsymv
   end interface blas_symv

   !> Performs one of the matrix-matrix operations
   !>
   !>    C := alpha*op( A )*op( B ) + beta*C,
   !>
   !> where  op( X ) is one of
   !>
   !>    op( X ) = X   or   op( X ) = X**T,
   !>
   !> alpha and beta are scalars, and A, B and C are matrices, with op( A )
   !> an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
   interface blas_gemm
      pure subroutine sgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, &
            & beta, c, ldc)
         import :: sp, ik
         integer(ik), intent(in) :: lda
         integer(ik), intent(in) :: ldb
         integer(ik), intent(in) :: ldc
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: b(ldb, *)
         real(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: transb
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer(ik), intent(in) :: m
         integer(ik), intent(in) :: n
         integer(ik), intent(in) :: k
      end subroutine sgemm
      pure subroutine dgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, &
            & beta, c, ldc)
         import :: dp, ik
         integer(ik), intent(in) :: lda
         integer(ik), intent(in) :: ldb
         integer(ik), intent(in) :: ldc
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: b(ldb, *)
         real(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: transb
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer(ik), intent(in) :: m
         integer(ik), intent(in) :: n
         integer(ik), intent(in) :: k
      end subroutine dgemm
   end interface blas_gemm


contains


subroutine mchrg_sgemv312(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout), contiguous, target :: yvec(:, :)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp), pointer :: aptr(:, :), yptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      yptr(1:size(yvec, 1)*size(yvec, 2)) => yvec
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      yptr(1:size(yvec, 1) * size(yvec, 2)) => yvec
   end if
   call gemv(aptr, xvec, yptr, alpha, beta, tra)
end subroutine mchrg_sgemv312


subroutine mchrg_sgemv321(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(inout) :: yvec(:)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp), pointer :: aptr(:, :), xptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      xptr(1:size(xvec, 1)*size(xvec, 2)) => xvec
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      xptr(1:size(xvec, 1) * size(xvec, 2)) => xvec
   end if
   call gemv(aptr, xptr, yvec, alpha, beta, tra)
end subroutine mchrg_sgemv321


subroutine mchrg_dgemv312(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout), contiguous, target :: yvec(:, :)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp), pointer :: aptr(:, :), yptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      yptr(1:size(yvec, 1)*size(yvec, 2)) => yvec
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      yptr(1:size(yvec, 1) * size(yvec, 2)) => yvec
   end if
   call gemv(aptr, xvec, yptr, alpha, beta, tra)
end subroutine mchrg_dgemv312


subroutine mchrg_dgemv321(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(inout) :: yvec(:)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp), pointer :: aptr(:, :), xptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      xptr(1:size(xvec, 1)*size(xvec, 2)) => xvec
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      xptr(1:size(xvec, 1) * size(xvec, 2)) => xvec
   end if
   call gemv(aptr, xptr, yvec, alpha, beta, tra)
end subroutine mchrg_dgemv321


pure subroutine mchrg_sgemv(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout) :: yvec(:)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp) :: a, b
   character(len=1) :: tra
   integer(ik) :: incx, incy, m, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   incx = 1_ik
   incy = 1_ik
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
   call blas_gemv(tra, m, n, a, amat, lda, xvec, incx, b, yvec, incy)
end subroutine mchrg_sgemv


pure subroutine mchrg_dgemv(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout) :: yvec(:)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp) :: a, b
   character(len=1) :: tra
   integer(ik) :: incx, incy, m, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   incx = 1_ik
   incy = 1_ik
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
   call blas_gemv(tra, m, n, a, amat, lda, xvec, incx, b, yvec, incy)
end subroutine mchrg_dgemv


pure subroutine mchrg_ssymv(amat, xvec, yvec, uplo, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout) :: yvec(:)
   character(len=1), intent(in), optional :: uplo
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1) :: ula
   real(sp) :: a, b
   integer(ik) :: incx, incy, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1_ik
   incy = 1_ik
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   call blas_symv(ula, n, a, amat, lda, xvec, incx, b, yvec, incy)
end subroutine mchrg_ssymv


pure subroutine mchrg_dsymv(amat, xvec, yvec, uplo, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout) :: yvec(:)
   character(len=1), intent(in), optional :: uplo
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1) :: ula
   real(dp) :: a, b
   integer(ik) :: incx, incy, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1_ik
   incy = 1_ik
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   call blas_symv(ula, n, a, amat, lda, xvec, incx, b, yvec, incy)
end subroutine mchrg_dsymv


pure subroutine mchrg_sgemm(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: bmat(:, :)
   real(sp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1) :: tra, trb
   real(sp) :: a, b
   integer(ik) :: m, n, k, lda, ldb, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_sp
   end if
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if ((tra.eq.'n'.or.tra.eq.'N')) then
      k = size(amat, 2)
   else
      k = size(amat, 1)
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   m = size(cmat, 1)
   n = size(cmat, 2)
   call blas_gemm(tra, trb, m, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
end subroutine mchrg_sgemm


pure subroutine mchrg_dgemm(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: bmat(:, :)
   real(dp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1) :: tra, trb
   real(dp) :: a, b
   integer(ik) :: m, n, k, lda, ldb, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_dp
   end if
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if ((tra.eq.'n'.or.tra.eq.'N')) then
      k = size(amat, 2)
   else
      k = size(amat, 1)
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   m = size(cmat, 1)
   n = size(cmat, 2)
   call blas_gemm(tra, trb, m, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
end subroutine mchrg_dgemm


subroutine mchrg_sgemm323(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in) :: bmat(:, :)
   real(sp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   real(sp), pointer :: aptr(:, :), cptr(:, :)
   character(len=1) :: tra
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   end if
   cptr(1:size(cmat, 1)*size(cmat, 2), 1:size(cmat, 3)) => cmat
   call gemm(aptr, bmat, cptr, tra, transb, alpha, beta)
end subroutine mchrg_sgemm323


subroutine mchrg_sgemm233(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in), contiguous, target :: bmat(:, :, :)
   real(sp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   real(sp), pointer :: bptr(:, :), cptr(:, :)
   character(len=1) :: trb
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   end if
   cptr(1:size(cmat, 1), 1:size(cmat, 2)*size(cmat, 3)) => cmat
   call gemm(amat, bptr, cptr, transa, trb, alpha, beta)
end subroutine mchrg_sgemm233


subroutine mchrg_sgemm332(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in), contiguous, target :: bmat(:, :, :)
   real(sp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   real(sp), pointer :: aptr(:, :), bptr(:, :)
   character(len=1) :: tra, trb
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   end if
   call gemm(aptr, bptr, cmat, tra, trb, alpha, beta)
end subroutine mchrg_sgemm332


subroutine mchrg_dgemm323(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in) :: bmat(:, :)
   real(dp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   real(dp), pointer :: aptr(:, :), cptr(:, :)
   character(len=1) :: tra
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   end if
   cptr(1:size(cmat, 1)*size(cmat, 2), 1:size(cmat, 3)) => cmat
   call gemm(aptr, bmat, cptr, tra, transb, alpha, beta)
end subroutine mchrg_dgemm323


subroutine mchrg_dgemm233(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in), contiguous, target :: bmat(:, :, :)
   real(dp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   real(dp), pointer :: bptr(:, :), cptr(:, :)
   character(len=1) :: trb
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   end if
   cptr(1:size(cmat, 1), 1:size(cmat, 2)*size(cmat, 3)) => cmat
   call gemm(amat, bptr, cptr, transa, trb, alpha, beta)
end subroutine mchrg_dgemm233


subroutine mchrg_dgemm332(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in), contiguous, target :: bmat(:, :, :)
   real(dp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   real(dp), pointer :: aptr(:, :), bptr(:, :)
   character(len=1) :: tra, trb
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   end if
   call gemm(aptr, bptr, cmat, tra, trb, alpha, beta)
end subroutine mchrg_dgemm332


end module multicharge_blas

! This file is part of mstore.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mstore_data_store
   use mctc_env_error, only : error_type, fatal_error
   use mstore_data_collection, only : collection_type
   use mstore_data_record, only : record_type
   implicit none
   private

   public :: store_type, new_store

   abstract interface
      subroutine get_collection_interface(collections)
         import :: collection_type
         type(collection_type), allocatable, intent(out) :: collections(:)
      end subroutine get_collection_interface
   end interface

   type :: store_type

      !> Identifier for this store
      character(len=:), allocatable :: id

      !> Cached collections
      type(collection_type), allocatable :: collections(:)

      !> Actual getter for the collection data
      procedure(get_collection_interface), pointer, nopass :: get => null()

   contains

      procedure :: get_record

   end type store_type


contains


!> Register a new store
function new_store(id, getter) result(new)

   !> Identifier for this store
   character(len=*), intent(in) :: id

   !> Getter for the actual record
   procedure(get_collection_interface) :: getter

   !> New record store
   type(store_type) :: new

   new%id = id
   new%get => getter
   call getter(new%collections)

end function new_store


subroutine get_record(self, set, id, error)
   class(store_type), intent(in) :: self
   character(len=*), intent(in) :: set
   character(len=*), intent(in) :: id
   type(error_type), allocatable, intent(out) :: error

end subroutine get_record


end module mstore_data_store

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module test_write_ctfile
   use mctc_env_accuracy, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check
   use testsuite_structure, only : get_structure
   use mctc_io_write_ctfile
   use mctc_io_read_ctfile
   use mctc_io_structure
   implicit none
   private

   public :: collect_write_ctfile


contains


!> Collect all exported unit tests
subroutine collect_write_ctfile(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("valid1-mol", test_valid1_mol), &
      & new_unittest("valid1-sdf", test_valid1_sdf), &
      & new_unittest("v3k-large-mol", test_v3k_large_mol), &
      & new_unittest("v3k-large-sdf", test_v3k_large_sdf), &
      & new_unittest("v3k-with-bonds", test_v3k_with_bonds) &
      & ]

end subroutine collect_write_ctfile


subroutine test_valid1_mol(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit, nat, nid

   call get_structure(struc, "mindless01")
   nat = struc%nat
   nid = struc%nid

   open(status='scratch', newunit=unit)
   call write_molfile(struc, unit)
   rewind(unit)

   call read_molfile(struc, unit, error)
   close(unit)
   if (allocated(error)) return

   call check(error, struc%nat, nat, "Number of atoms does not match")
   if (allocated(error)) return
   call check(error, struc%nid, nid, "Number of species does not match")
   if (allocated(error)) return

end subroutine test_valid1_mol


subroutine test_valid1_sdf(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc
   integer :: unit, nat, nid

   call get_structure(struc, "mindless01")
   nat = struc%nat
   nid = struc%nid

   open(status='scratch', newunit=unit)
   call write_sdf(struc, unit)
   rewind(unit)

   call read_sdf(struc, unit, error)
   close(unit)
   if (allocated(error)) return

   call check(error, struc%nat, nat, "Number of atoms does not match")
   if (allocated(error)) return
   call check(error, struc%nid, nid, "Number of species does not match")
   if (allocated(error)) return

end subroutine test_valid1_sdf


subroutine test_v3k_large_mol(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc, struc_read
   integer :: unit, nat, i
   character(len=2), allocatable :: sym(:)
   real(wp), allocatable :: xyz(:, :)

   ! Create a structure with 1001 atoms to trigger V3000 format
   nat = 1001
   allocate(sym(nat), xyz(3, nat))

   ! Create alternating H and C atoms on a line
   do i = 1, nat
      if (mod(i, 2) == 0) then
         sym(i) = "C"
      else
         sym(i) = "H"
      end if
      xyz(1, i) = real(i, wp)
      xyz(2, i) = 0.0_wp
      xyz(3, i) = 0.0_wp
   end do

   call new(struc, sym, xyz)

   open(status='scratch', newunit=unit)
   call write_molfile(struc, unit)
   rewind(unit)

   call read_molfile(struc_read, unit, error)
   close(unit)
   if (allocated(error)) return

   call check(error, struc_read%nat, nat, "Number of atoms does not match")
   if (allocated(error)) return
   call check(error, struc_read%nid, 2, "Number of species does not match")
   if (allocated(error)) return

end subroutine test_v3k_large_mol


subroutine test_v3k_large_sdf(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc, struc_read
   integer :: unit, nat, i
   character(len=2), allocatable :: sym(:)
   real(wp), allocatable :: xyz(:, :)

   ! Create a structure with 1001 atoms to trigger V3000 format
   nat = 1001
   allocate(sym(nat), xyz(3, nat))

   ! Create alternating H and C atoms on a line
   do i = 1, nat
      if (mod(i, 2) == 0) then
         sym(i) = "C"
      else
         sym(i) = "H"
      end if
      xyz(1, i) = real(i, wp)
      xyz(2, i) = 0.0_wp
      xyz(3, i) = 0.0_wp
   end do

   call new(struc, sym, xyz)

   open(status='scratch', newunit=unit)
   call write_sdf(struc, unit)
   rewind(unit)

   call read_sdf(struc_read, unit, error)
   close(unit)
   if (allocated(error)) return

   call check(error, struc_read%nat, nat, "Number of atoms does not match")
   if (allocated(error)) return
   call check(error, struc_read%nid, 2, "Number of species does not match")
   if (allocated(error)) return

end subroutine test_v3k_large_sdf


subroutine test_v3k_with_bonds(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: struc, struc_read
   integer :: unit, nat, nbd, i
   character(len=2), allocatable :: sym(:)
   real(wp), allocatable :: xyz(:, :)
   integer, allocatable :: bond(:, :)

   ! Create a structure with 1001 atoms and 1000 bonds to trigger V3000 format
   nat = 1001
   nbd = 1000
   allocate(sym(nat), xyz(3, nat), bond(3, nbd))

   ! Create a linear chain of alternating H and C atoms
   do i = 1, nat
      if (mod(i, 2) == 0) then
         sym(i) = "C"
      else
         sym(i) = "H"
      end if
      xyz(1, i) = real(i, wp)
      xyz(2, i) = 0.0_wp
      xyz(3, i) = 0.0_wp
   end do

   ! Create bonds connecting each consecutive atom pair
   do i = 1, nbd
      bond(1, i) = i
      bond(2, i) = i + 1
      bond(3, i) = 1  ! single bond
   end do

   call new(struc, sym, xyz, bond=bond)

   open(status='scratch', newunit=unit)
   call write_molfile(struc, unit)
   rewind(unit)

   call read_molfile(struc_read, unit, error)
   close(unit)
   if (allocated(error)) return

   call check(error, struc_read%nat, nat, "Number of atoms does not match")
   if (allocated(error)) return
   call check(error, struc_read%nid, 2, "Number of species does not match")
   if (allocated(error)) return
   call check(error, struc_read%nbd, nbd, "Number of bonds does not match")
   if (allocated(error)) return

end subroutine test_v3k_with_bonds


end module test_write_ctfile

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/container/list.f90
!> Provides a collection for several interaction containers

!> Definition of list of general interaction contaienrs
module tblite_container_list
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_container_cache, only : container_cache, resize
   use tblite_container_type, only : container_type
   use tblite_scf_info, only : scf_info
   use tblite_scf_potential, only : potential_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_output_format, only : format_string
   implicit none
   private


   !> Wrapped container type for creation of lists
   type :: container_node
      !> Actual interaction container
      class(container_type), allocatable :: raw
   end type container_node

   !> List of interaction containers
   type, public, extends(container_type) :: container_list
      private
      !> Number of stored containers
      integer :: nc = 0
      !> Raw list of interaction containers
      type(container_node), allocatable :: list(:)
   contains
      !> Update container cache
      procedure :: update
      !> Get information about density dependent quantities used in the energy
      procedure :: variable_info
      !> Evaluate non-selfconsistent part of the interaction
      procedure :: get_engrad
      !> Evaluate selfconsistent energy of the interaction
      procedure :: get_energy
      !> Evaluate charge dependent potential shift from the interaction
      procedure :: get_potential
      !> Evaluate gradient of charge dependent potential shift from the interaction
      procedure :: get_potential_gradient
      !> Evaluate gradient contributions from the selfconsistent interaction
      procedure :: get_gradient
      !> Add a container
      procedure :: push_back
      !> Remove a container
      procedure :: pop
      !> Information about the container list
      procedure :: info
   end type container_list


   !> Reallocate list of containers
   interface resize
      module procedure :: resize_node
   end interface


   !> List of container cache instances
   type, public :: cache_list
      !> Actual cache instances
      type(container_cache), allocatable :: list(:)
   end type cache_list


contains


!> Update container cache
subroutine update(self, mol, cache)
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache

   integer :: ic
   type(cache_list), pointer :: ptr

   call taint(cache, ptr)
   call resize(ptr%list, self%nc)

   do ic = 1, self%nc
      if (allocated(self%list(ic)%raw)) then
         associate(cont => self%list(ic)%raw)
            call cont%update(mol, ptr%list(ic))
         end associate
      end if
   end do
end subroutine update


!> Evaluate non-selfconsistent part of the interaction
subroutine get_engrad(self, mol, cache, energies, gradient, sigma)
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Interaction energy
   real(wp), intent(inout) :: energies(:)
   !> Interaction gradient
   real(wp), contiguous, intent(inout), optional :: gradient(:, :)
   !> Interaction virial
   real(wp), contiguous, intent(inout), optional :: sigma(:, :)

   integer :: ic
   type(cache_list), pointer :: ptr

   call view(cache, ptr)

   do ic = 1, self%nc
      if (allocated(self%list(ic)%raw)) then
         associate(cont => self%list(ic)%raw)
            call cont%get_engrad(mol, ptr%list(ic), energies, gradient, sigma)
         end associate
      end if
   end do
end subroutine get_engrad


!> Evaluate selfconsistent energy of the interaction
subroutine get_energy(self, mol, cache, wfn, energies)
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Interaction energy
   real(wp), intent(inout) :: energies(:)

   integer :: ic
   type(cache_list), pointer :: ptr

   call view(cache, ptr)

   do ic = 1, self%nc
      if (allocated(self%list(ic)%raw)) then
         associate(cont => self%list(ic)%raw)
            call cont%get_energy(mol, ptr%list(ic), wfn, energies)
         end associate
      end if
   end do
end subroutine get_energy


!> Evaluate charge dependent potential shift from the interaction
subroutine get_potential(self, mol, cache, wfn, pot)
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   integer :: ic
   type(cache_list), pointer :: ptr

   call view(cache, ptr)

   do ic = 1, self%nc
      if (allocated(self%list(ic)%raw)) then
         associate(cont => self%list(ic)%raw)
            call cont%get_potential(mol, ptr%list(ic), wfn, pot)
         end associate
      end if
   end do
end subroutine get_potential


!> Evaluate charge dependent potential shift from the interaction
subroutine get_potential_gradient(self, mol, cache, wfn, pot)
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Density dependent potential
   type(potential_type), intent(inout) :: pot

   integer :: ic
   type(cache_list), pointer :: ptr

   call view(cache, ptr)

   do ic = 1, self%nc
      if (allocated(self%list(ic)%raw)) then
         associate(cont => self%list(ic)%raw)
            call cont%get_potential_gradient(mol, ptr%list(ic), wfn, pot)
         end associate
      end if
   end do
end subroutine get_potential_gradient


!> Evaluate gradient contributions from the selfconsistent interaction
subroutine get_gradient(self, mol, cache, wfn, gradient, sigma)
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cached data between different runs
   type(container_cache), intent(inout) :: cache
   !> Wavefunction data
   type(wavefunction_type), intent(in) :: wfn
   !> Interaction gradient
   real(wp), contiguous, intent(inout) :: gradient(:, :)
   !> Interaction virial
   real(wp), contiguous, intent(inout) :: sigma(:, :)

   integer :: ic
   type(cache_list), pointer :: ptr

   call view(cache, ptr)

   do ic = 1, self%nc
      if (allocated(self%list(ic)%raw)) then
         associate(cont => self%list(ic)%raw)
            call cont%get_gradient(mol, ptr%list(ic), wfn, gradient, sigma)
         end associate
      end if
   end do
end subroutine get_gradient


!> Get information about density dependent quantities used in the energy
pure function variable_info(self) result(info)
   use tblite_scf_info, only : scf_info, max
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Information on the required potential data
   type(scf_info) :: info

   integer :: ic

   info = scf_info()

   do ic = 1, self%nc
      if (allocated(self%list(ic)%raw)) then
         info = max(info, self%list(ic)%raw%variable_info())
      end if
   end do
end function variable_info


!> Information on container
pure function info(self, verbosity, indent) result(str)
   !> Instance of the interaction container
   class(container_list), intent(in) :: self
   !> Verbosity level
   integer, intent(in) :: verbosity
   !> Indentation level
   character(len=*), intent(in) :: indent
   !> Information on the container
   character(len=:), allocatable :: str

   integer :: ic
   character(len=*), parameter :: nl = new_line('a')

   if (allocated(self%label)) then
      str = self%label
   else
      str = "Interactions"
   end if

   str = str // format_string(self%nc, '(1x,"(",i0,")")')

   do ic = 1, self%nc
      str = str // nl // indent // format_string(ic, '("[",i0,"]")') // " " // &
         & self%list(ic)%raw%info(verbosity, indent//"* ")
   end do
end function info


!> Add a container
subroutine push_back(self, cont)
   !> Instance of the container list
   class(container_list), intent(inout) :: self
   !> Container to be added
   class(container_type), allocatable, intent(inout) :: cont

   if (.not.allocated(self%list)) call resize(self%list)

   if (allocated(cont)) then
      if (self%nc >= size(self%list)) call resize(self%list)
      self%nc = self%nc + 1
      call move_alloc(cont, self%list(self%nc)%raw)
   end if
end subroutine push_back


!> Add a container
subroutine pop(self, cont, idx)
   !> Instance of the container list
   class(container_list), intent(inout) :: self
   !> Container to be removed
   class(container_type), allocatable, intent(out) :: cont
   !> Index to remove container from
   integer, intent(in), optional :: idx

   integer :: ic, pos

   if (present(idx)) then
      pos = max(1, min(self%nc, idx))
   else
      pos = self%nc
   end if

   if (pos <= 0) return

   call move_alloc(self%list(pos)%raw, cont)

   self%nc = self%nc - 1
   do ic = pos, self%nc
      call move_alloc(self%list(ic+1)%raw, self%list(ic)%raw)
   end do
end subroutine pop


!> Reallocate list of containers
subroutine resize_node(list, n)
   !> Instance of the array to be resized
   type(container_node), allocatable, intent(inout) :: list(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(container_node), allocatable :: tmp(:)
   integer, parameter :: initial_size = 20
   integer :: this_size, new_size, item

   if (allocated(list)) then
      this_size = size(list, 1)
      call move_alloc(list, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(list(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(list, 1))
      do item = 1, this_size
         call move_alloc(tmp(item)%raw, list(item)%raw)
      end do
      deallocate(tmp)
   end if

end subroutine resize_node


!> Inspect container cache and reallocate it in case of type mismatch
subroutine taint(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(cache_list), pointer, intent(out) :: ptr

   if (allocated(cache%raw)) then
      call view(cache, ptr)
      if (associated(ptr)) return
      deallocate(cache%raw)
   end if

   if (.not.allocated(cache%raw)) then
      block
         type(cache_list), allocatable :: tmp
         allocate(tmp)
         call move_alloc(tmp, cache%raw)
      end block
   end if

   call view(cache, ptr)
end subroutine taint

!> Return reference to container cache after resolving its type
subroutine view(cache, ptr)
   !> Instance of the container cache
   type(container_cache), target, intent(inout) :: cache
   !> Reference to the container cache
   type(cache_list), pointer, intent(out) :: ptr
   nullify(ptr)
   select type(target => cache%raw)
   type is(cache_list)
      ptr => target
   end select
end subroutine view


end module tblite_container_list

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/api/utils.f90
!> Common utilities for all API exports

!> Provides utilities used for all API export modules
module tblite_api_utils
   use, intrinsic :: iso_c_binding
   implicit none
   private

   public :: f_c_character, c_f_character, strlen


   interface
      function strlen(str) result(len) bind(c)
         import :: c_ptr, c_int
         type(c_ptr), value :: str
         integer(c_int) :: len
      end function strlen
   end interface

contains


subroutine f_c_character(rhs, lhs, len)
   character(kind=c_char), intent(out) :: lhs(*)
   character(len=*), intent(in) :: rhs
   integer, intent(in) :: len
   integer :: length
   length = min(len-1, len_trim(rhs))

   lhs(1:length) = transfer(rhs(1:length), lhs(1:length))
   lhs(length+1:length+1) = c_null_char

end subroutine f_c_character

subroutine c_f_character(rhs, lhs)
   character(kind=c_char), intent(in) :: rhs(*)
   character(len=:), allocatable, intent(out) :: lhs

   integer :: ii

   do ii = 1, huge(ii) - 1
      if (rhs(ii) == c_null_char) then
         exit
      end if
   end do
   allocate(character(len=ii-1) :: lhs)
   lhs = transfer(rhs(1:ii-1), lhs)

end subroutine c_f_character

end module tblite_api_utils

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/coulomb
!> Contains the Coulomb related interactions.

!> @file tblite/coulomb.f90
!> Reexports of the Coulombic interaction containers.

!> Proxy module for handling Coulomb-type interactions
module tblite_coulomb
   use tblite_coulomb_cache, only : coulomb_cache
   use tblite_coulomb_charge, only : coulomb_charge_type, coulomb_kernel, &
      & effective_coulomb, new_effective_coulomb, &
      & average_interface, harmonic_average, arithmetic_average, geometric_average, &
      & gamma_coulomb, new_gamma_coulomb
   use tblite_coulomb_multipole, only : damped_multipole, new_damped_multipole
   use tblite_coulomb_thirdorder, only : onsite_thirdorder, new_onsite_thirdorder
   use tblite_coulomb_type, only : coulomb_type
   implicit none

   public :: coulomb_type
   public :: coulomb_cache
   public :: coulomb_charge_type, coulomb_kernel
   public :: effective_coulomb, new_effective_coulomb
   public :: average_interface, harmonic_average, arithmetic_average, geometric_average
   public :: gamma_coulomb, new_gamma_coulomb
   public :: damped_multipole, new_damped_multipole
   public :: onsite_thirdorder, new_onsite_thirdorder
end module tblite_coulomb

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/post_processing/type.f90
!> Implements post processing container abstract class, and the collection of computing caches.
module tblite_post_processing_type
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_basis_type, only : basis_type
   use tblite_container_cache, only : container_cache
   use tblite_container_list, only : cache_list
   use tblite_context, only : context_type
   use tblite_double_dictionary, only : double_dictionary_type
   use tblite_integral_type, only : integral_type
   use tblite_results, only : results_type
   use tblite_timer, only : timer_type, format_time
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_xtb_calculator, only : xtb_calculator
   implicit none
   private

   public :: post_processing_type, collect_containers_caches

   !> Abstract base class for post-processing methods
   type, abstract :: post_processing_type
      !> Post-processing label
      character(len=:), allocatable :: label
   contains
      !> Perform post-processing method
      procedure(compute), deferred :: compute
      !> Information on the post-processing method
      procedure :: info
      !> Print timings
      procedure(print_timer), deferred :: print_timer
   end type  post_processing_type

   abstract interface
      subroutine compute(self, mol, wfn, ints, calc, caches, ctx, timer, prlevel, dict)
         import :: post_processing_type, structure_type, wavefunction_type, &
            & integral_type, xtb_calculator, context_type, timer_type, &
            & cache_list, double_dictionary_type
         !> Instance of a post-processing method
         class(post_processing_type),intent(in) :: self
         !> Molecular structure data
         type(structure_type), intent(in) :: mol
         !> Wavefunction strcuture data
         type(wavefunction_type), intent(in) :: wfn
         !> Integral container
         type(integral_type), intent(in) :: ints
         !> Calculator instance
         type(xtb_calculator), intent(in) :: calc
         !> Cache list for storing caches of various interactions
         type(cache_list), intent(inout) :: caches
         !> Context container for writing to stdout
         type(context_type), intent(inout) :: ctx
         !> Timer instance
         type(timer_type), intent(inout) :: timer
         !> Print level
         integer, intent(in) :: prlevel
         !> Dictionary for storing results
         type(double_dictionary_type), intent(inout) :: dict
      end subroutine compute

      subroutine print_timer(self, timer, prlevel, ctx)
         import :: post_processing_type, timer_type, context_type
         !> Instance of a post-processing method
         class(post_processing_type), intent(in) :: self
         !> Timer instance
         type(timer_type), intent(in) :: timer
         !> Print level
         integer, intent(in) :: prlevel
         !> Context container for writing to stdout
         type(context_type), intent(inout) :: ctx
      end subroutine print_timer

   end interface

contains


pure function info(self, verbosity, indent) result(str)
   !> Instance of a post-processing method
   class(post_processing_type), intent(in) :: self
   !> Verbosity level
   integer, intent(in) :: verbosity
   !> Indentation level
   character(len=*), intent(in) :: indent
   !> Information on the container
   character(len=:), allocatable :: str

   if (allocated(self%label)) then
      str = indent // self%label
   else
      str = "Unknown"
   end if

end function info

subroutine collect_containers_caches(rcache, ccache, hcache, dcache, icache, calc, caches)
   !> Container cache for the repulsion interaction
   type(container_cache), allocatable, intent(inout) :: rcache
   !> Container cache for the Coulomb interaction
   type(container_cache), allocatable, intent(inout) :: ccache
   !> Container cache for the halogen correction
   type(container_cache), allocatable, intent(inout) :: hcache
   !> Container cache for the dispersion interaction
   type(container_cache), allocatable, intent(inout) :: dcache
   !> Container cache for general interactions
   type(container_cache), allocatable, intent(inout) :: icache
   !> Instance of the calculator
   type(xtb_calculator), intent(in) :: calc
   !> List of caches for use in the post-processing
   type(cache_list), intent(inout) :: caches

   allocate(caches%list(5))
   if (allocated(calc%repulsion)) call move_alloc(rcache%raw, caches%list(1)%raw)
   if (allocated(calc%coulomb)) call move_alloc(ccache%raw, caches%list(2)%raw)
   if (allocated(calc%halogen)) call move_alloc(hcache%raw, caches%list(3)%raw)
   if (allocated(calc%dispersion)) call move_alloc(dcache%raw, caches%list(4)%raw)
   if (allocated(calc%interactions)) call move_alloc(icache%raw, caches%list(5)%raw)

end subroutine collect_containers_caches

end module tblite_post_processing_type

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

!> Re-export of all dispersion models
module dftd4_model
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type
   use dftd4_utils, only : lowercase
   use dftd4_model_type, only : dispersion_model, d4_qmod
   use dftd4_model_d4, only : d4_model, new_d4_model
   use dftd4_model_d4s, only : d4s_model, new_d4s_model
   implicit none
   private

   public :: dispersion_model, d4_qmod
   public :: d4_model, new_d4_model
   public :: d4s_model, new_d4s_model
   public :: new_dispersion_model


contains


!> Wrapper for creating a new dispersion model (D4 or D4S) from molecular 
!> structure input using a given model string. Defaults to D4 if no model
!> is specified.
subroutine new_dispersion_model(error, d4, mol, model, ga, gc, wf, qmod)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Dispersion model to be returned
   class(dispersion_model), allocatable, intent(out) :: d4

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Dispersion model to be used
   character(len=*), intent(in), optional :: model

   !> Charge scaling height
   real(wp), intent(in), optional :: ga

   !> Charge scaling steepness
   real(wp), intent(in), optional :: gc

   !> Weighting factor for coordination number interpolation
   real(wp), intent(in), optional :: wf

   !> Charge model selection
   integer, intent(in), optional :: qmod

   character(len=:), allocatable :: mdl

   if (present(model)) then
      mdl = lowercase(trim(model)) 
   else
      mdl = "d4"
   end if

   if(mdl == "d4") then
      block 
         type(d4_model), allocatable :: tmp
         allocate(tmp)
         call new_d4_model(error, tmp, mol, ga=ga, gc=gc, wf=wf, qmod=qmod)
         call move_alloc(tmp, d4)
      end block 
   else if(mdl == "d4s") then
      block 
         type(d4s_model), allocatable :: tmp
         allocate(tmp)
         call new_d4s_model(error, tmp, mol, ga=ga, gc=gc, qmod=qmod)
         call move_alloc(tmp, d4)
      end block
   else
      call fatal_error(error, "Unknown model selected")
   end if

end subroutine new_dispersion_model


end module dftd4_model

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/adjlist.f90
!> Sparse neighbour map / adjacency list implementation.

!> Implementation of a sparse neighbour map in compressed sparse row format.
!>
!> A symmetric neighbour map given in dense format like
!>
!>   |   | 1 | 2 | 3 | 4 | 5 | 6 |
!>   |---|---|---|---|---|---|---|
!>   | 1 |   | x |   | x | x |   |
!>   | 2 | x |   | x |   | x | x |
!>   | 3 |   | x |   | x |   | x |
!>   | 4 | x |   | x |   | x | x |
!>   | 5 | x | x |   | x |   |   |
!>   | 6 |   | x | x | x |   |   |
!>
!> Is stored in two compressed array identifying the neighbouring atom `nlat`
!> and its cell index `nltr`. Two index arrays `inl` for the offset
!> and `nnl` for the number of entries map the atomic index to the row index.
!>
!> ```
!> inl   =  0,       3,          7,      10,         14,      17, 20
!> nnl   =  |  2 ->  |  3 ->     |  2 ->  |  3 ->     |  2 ->  |  |
!> nlat  =     2, 4, 5, 1, 3, 5, 6, 2, 4, 6, 1, 3, 5, 6, 1, 2, 4, 2, 3, 4
!> nltr  =     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
!> ```
!>
!> An alternative representation would be to store just the offsets in `inl` and
!> additional beyond the last element the total number of neighbors. However,
!> the indexing is from inl(i) to inl(i+1)-1 could be confusing, therefore
!> two arrays are used for clarity.
module tblite_adjlist
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_resize, only : resize
   implicit none
   private

   public :: adjacency_list, new_adjacency_list

   !> @class adjacency_list
   !> Neighbourlist in CSR format
   type :: adjacency_list
      !> Offset index in the neighbour map
      integer, allocatable :: inl(:)
      !> Number of neighbours for each atom
      integer, allocatable :: nnl(:)
      !> Index of the neighbouring atom
      integer, allocatable :: nlat(:)
      !> Cell index of the neighbouring atom
      integer, allocatable :: nltr(:)
   end type adjacency_list

contains

   !> Create new neighbourlist for a given geometry and cutoff
   subroutine new_adjacency_list(self, mol, trans, cutoff, complete)
      !> Instance of the neighbourlist
      type(adjacency_list), intent(out) :: self
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Translation vectors for all images
      real(wp), intent(in) :: trans(:, :)
      !> Realspace cutoff for neighbourlist generation
      real(wp), intent(in) :: cutoff
      !> Whether a complete or a symmetrical reduced map should be generated
      logical, intent(in), optional :: complete

      logical :: cmplt

      cmplt = .false.
      if (present(complete)) cmplt = complete

      allocate(self%inl(mol%nat), source=0)
      allocate(self%nnl(mol%nat), source=0)
      call generate(mol, trans, cutoff, self%inl, self%nnl, self%nlat, self%nltr, cmplt)
   end subroutine new_adjacency_list

   !> Generator for neighbourlist
   subroutine generate(mol, trans, cutoff, inl, nnl, nlat, nltr, complete)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Translation vectors for all images
      real(wp), intent(in) :: trans(:, :)
      !> Realspace cutoff for neighbourlist generation
      real(wp), intent(in) :: cutoff
      !> Offset index in the neighbour map
      integer, intent(inout) :: inl(:)
      !> Number of neighbours for each atom
      integer, intent(inout) :: nnl(:)
      !> Index of the neighbouring atom
      integer, allocatable, intent(out) :: nlat(:)
      !> Cell index of the neighbouring atom
      integer, allocatable, intent(out) :: nltr(:)
      !> Whether a complete or a symmetrical reduced map should be generated
      logical, intent(in) :: complete

      integer :: iat, jat, itr, img
      real(wp) :: r2, vec(3), cutoff2

      img = 0
      cutoff2 = cutoff**2

      call resize(nlat, 10*mol%nat)
      call resize(nltr, 10*mol%nat)

      do iat = 1, mol%nat
         inl(iat) = img
         do jat = 1, merge(mol%nat, iat, complete)
            do itr = 1, size(trans, 2)
               vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
               r2 = sum(vec**2)
               if (r2 < epsilon(cutoff2) .or. r2 > cutoff2) cycle
               img = img + 1
               if (size(nlat) < img) call resize(nlat)
               if (size(nltr) < img) call resize(nltr)
               nlat(img) = jat
               nltr(img) = itr
            end do
         end do
         nnl(iat) = img - inl(iat)
      end do

      call resize(nlat, img)
      call resize(nltr, img)

   end subroutine generate

end module tblite_adjlist

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3_output
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_convert, only : autoaa, autokcal, autoev
   use mctc_io_math, only : matinv_3x3
   use dftd3_damping, only : damping_param
   use dftd3_damping_mzero, only : mzero_damping_param
   use dftd3_damping_optimizedpower, only : optimizedpower_damping_param
   use dftd3_damping_rational, only : rational_damping_param
   use dftd3_damping_zero, only : zero_damping_param
   use dftd3_gcp, only : gcp_param
   use dftd3_model, only : d3_model
   use dftd3_version, only : get_dftd3_version
   implicit none
   private

   public :: ascii_atomic_radii, ascii_atomic_references, ascii_system_properties
   public :: ascii_energy_atom
   public :: ascii_results, ascii_damping_param, ascii_pairwise, ascii_gcp_param
   public :: turbomole_gradient, turbomole_gradlatt
   public :: json_results, tagged_result


contains


subroutine ascii_atomic_radii(unit, mol, disp)

   !> Unit for output
   integer, intent(in) :: unit

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Dispersion model
   class(d3_model), intent(in) :: disp

   integer :: isp

   write(unit, '(a,":")') "Atomic radii (in Angstrom)"
   write(unit, '(43("-"))')
   write(unit, '(a4,5x,*(1x,a10))') "Z", "R(cov)", "R(vdw)", "r4/r2"
   write(unit, '(43("-"))')
   do isp = 1, mol%nid
      write(unit, '(i4, 1x, a4, *(1x,f10.4))') &
         & mol%num(isp), mol%sym(isp), &
         & disp%rcov(isp)*autoaa, disp%rvdw(isp, isp)*autoaa/2, &
         & disp%r4r2(isp)*autoaa
   end do
   write(unit, '(43("-"))')

end subroutine ascii_atomic_radii


subroutine ascii_atomic_references(unit, mol, disp)

   !> Unit for output
   integer, intent(in) :: unit

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Dispersion model
   class(d3_model), intent(in) :: disp

   integer :: isp, iref, mref

   mref = maxval(disp%ref)
   write(unit, '(a,":")') "Atomic reference systems (in atomic units)"
   write(unit, '(76("-"))')
   write(unit, '(a4, 5x)', advance='no') "Z"
   do iref = 1, 3
      write(unit, '(a4, 1x, a7, 1x, a9)', advance='no') "#", "CN", "C6(AA)"
   end do
   write(unit, '(a)')
   write(unit, '(76("-"))')
   do isp = 1, mol%nid
      write(unit, '(i4, 1x, a4)', advance='no') &
         & mol%num(isp), mol%sym(isp)
      do iref = 1, disp%ref(isp)
         write(unit, '(i4, 1x, f7.4, 1x, f9.4)', advance='no') &
            iref, disp%cn(iref, isp), disp%c6(iref, iref, isp, isp)
         if ((iref == 3 .and. disp%ref(isp) > 3) .or. &
             (iref == 6 .and. disp%ref(isp) > 6)) then
            write(unit, '(/,9x)', advance='no')
         end if
      end do
      write(unit, '(a)')
   end do
   write(unit, '(76("-"))')

end subroutine ascii_atomic_references


subroutine ascii_system_properties(unit, mol, disp, cn, c6)

   !> Unit for output
   integer, intent(in) :: unit

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Dispersion model
   class(d3_model), intent(in) :: disp

   !> Coordination numbers
   real(wp), intent(in) :: cn(:)

   !> Atomic dispersion coefficients
   real(wp), intent(in) :: c6(:, :)

   integer :: iat, isp

   write(unit, '(a,":")') "Dispersion properties (in atomic units)"
   write(unit, '(56("-"))')
   write(unit, '(a6,1x,a4,5x,*(1x,a12))') "#", "Z", "CN", "C6(AA)", "C8(AA)"
   write(unit, '(56("-"))')
   do iat = 1, mol%nat
      isp = mol%id(iat)
      write(unit, '(i6,1x,i4,1x,a4,*(1x,f12.4))') &
         & iat, mol%num(isp), mol%sym(isp), cn(iat), c6(iat, iat), &
         & c6(iat, iat)*3*disp%r4r2(isp)**2
   end do
   write(unit, '(56("-"))')

end subroutine ascii_system_properties


!> Print atom-resolved dispersion energies
subroutine ascii_energy_atom(unit, mol, energies, label)

   !> Unit for output
   integer, intent(in) :: unit

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Atom-resolved dispersion energies
   real(wp), allocatable, intent(in) :: energies(:)

   !> Label for the output
   character(len=*), intent(in), optional :: label

   integer :: iat, isp
   character(len=:), allocatable :: label_

   label_ = "dispersion"
   if (present(label)) label_ = label

   write(unit, '(a,":")') "Atom-resolved "//label_//" energies"
   write(unit, '(50("-"))')
   write(unit, '(a6,1x,a4,1x,4x,a15,1x,a15)') "#", "Z", "[Hartree]", "[kcal/mol]"
   write(unit, '(50("-"))')
   do iat = 1, mol%nat
      isp = mol%id(iat)
      write(unit, '(i6,1x,i4,1x,a4,e15.8,1x,f15.8)') &
         & iat, mol%num(isp), mol%sym(isp), energies(iat), energies(iat)*autokcal
   end do
   write(unit, '(50("-"))')
   write(unit, '(a)')

end subroutine ascii_energy_atom

   
subroutine ascii_results(unit, mol, energy, gradient, sigma, label)

   !> Unit for output
   integer, intent(in) :: unit

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   real(wp), intent(in) :: energy
   real(wp), intent(in), optional :: gradient(:, :)
   real(wp), intent(in), optional :: sigma(:, :)

   !> Label for the output
   character(len=*), intent(in), optional :: label

   integer :: iat, isp
   logical :: grad
   character(len=1), parameter :: comp(3) = ["x", "y", "z"]
   character(len=:), allocatable :: label_

   label_ = "Dispersion"
   if (present(label)) label_ = label

   grad = present(gradient) .and. present(sigma)

   write(unit, '(a,":", t25, es20.13, 1x, a)') &
      & label_//" energy", energy, "Eh"
   write(unit, '(a)')
   if (grad) then
      write(unit, '(a,":", t25, es20.13, 1x, a)') &
         & "Gradient norm", norm2(gradient), "Eh/a0"
      write(unit, '(50("-"))')
      write(unit, '(a6,1x,a4,5x,*(1x,a10))') "#", "Z", "dE/dx", "dE/dy", "dE/dz"
      write(unit, '(50("-"))')
      do iat = 1, mol%nat
         isp = mol%id(iat)
         write(unit, '(i6,1x,i4,1x,a4,*(es11.3))') &
            & iat, mol%num(isp), mol%sym(isp), gradient(:, iat)
      end do
      write(unit, '(50("-"))')
      write(unit, '(a)')

      write(unit, '(a,":")') &
         & "Virial"
      write(unit, '(50("-"))')
      write(unit, '(a15,1x,*(1x,a10))') "component", "x", "y", "z"
      write(unit, '(50("-"))')
      do iat = 1, 3
         write(unit, '(2x,4x,1x,a4,1x,4x,*(es11.3))') &
            & comp(iat), sigma(:, iat)
      end do
      write(unit, '(50("-"))')
      write(unit, '(a)')
   end if

end subroutine ascii_results


subroutine ascii_pairwise(unit, mol, pair_disp2, pair_disp3)

   !> Unit for output
   integer, intent(in) :: unit

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   real(wp), intent(in) :: pair_disp2(:, :)
   real(wp), intent(in) :: pair_disp3(:, :)

   integer :: iat, jat, isp, jsp
   real(wp) :: disp, e2, e3

   e2 = 0.0_wp
   e3 = 0.0_wp

   write(unit, '(a,":")') "Pairwise representation of dispersion (in kcal/mol)"
   write(unit, '(82("-"))')
   write(unit, '(2(a6,1x,a4,5x),*(1x,a10:,1x,a7))') &
      "#", "Z", "#", "Z", "additive", "(rel.)", "non-add.", "(rel.)", "total"
   write(unit, '(82("-"))')
   do iat = 1, mol%nat
      isp = mol%id(iat)
      do jat = 1, mol%nat
         jsp = mol%id(jat)
         e2 = e2 + pair_disp2(jat, iat)
         e3 = e3 + pair_disp3(jat, iat)
         disp = pair_disp2(jat, iat) + pair_disp3(jat, iat)
         if (abs(disp) < epsilon(disp)) cycle
         write(unit, '(2(i6,1x,i4,1x,a4),*(1x,es10.2:,1x,"(",i4,"%)"))') &
            & iat, mol%num(isp), mol%sym(isp), &
            & jat, mol%num(jsp), mol%sym(jsp), &
            & pair_disp2(jat, iat) * autokcal, nint(pair_disp2(jat, iat)/disp*100), &
            & pair_disp3(jat, iat) * autokcal, nint(pair_disp3(jat, iat)/disp*100), &
            & disp * autokcal
      end do
   end do
   write(unit, '(82("-"))')
   disp = e2 + e3
   write(unit, '(1x, a, t33,*(1x,es10.2:,1x,"(",i4,"%)"))') &
      & "total dispersion energy", &
      & e2 * autokcal, nint(e2/disp*100), &
      & e3 * autokcal, nint(e3/disp*100), &
      & disp * autokcal
   write(unit, '(82("-"))')
   write(unit, '(a)')

end subroutine ascii_pairwise


subroutine ascii_damping_param(unit, param, method)

   !> Unit for output
   integer, intent(in) :: unit

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Method name
   character(len=*), intent(in), optional :: method

   select type(param)
   type is (zero_damping_param)
      write(unit, '(a, ":", 1x)', advance="no") "Zero (Chai-Head-Gordon) damping"
      if (present(method)) then
         write(unit, '(a, "-")', advance="no") method
      end if
      if (abs(param%s9) > 0) then
         write(unit, '(a)') "D3(0)-ATM"
      else
         write(unit, '(a)') "D3(0)"
      end if
      write(unit, '(20("-"))')
      write(unit, '(a4, t10, f10.4)') &
         & "s6", param%s6, &
         & "s8", param%s8, &
         & "s9", param%s9, &
         & "rs6", param%rs6, &
         & "rs8", param%rs8, &
         & "alp", param%alp
      write(unit, '(20("-"))')
      write(unit, '(a)')
   type is (mzero_damping_param)
      write(unit, '(a, ":", 1x)', advance="no") "Modified zero damping"
      if (present(method)) then
         write(unit, '(a, "-")', advance="no") method
      end if
      if (abs(param%s9) > 0) then
         write(unit, '(a)') "D3(0M)-ATM"
      else
         write(unit, '(a)') "D3(0M)"
      end if
      write(unit, '(20("-"))')
      write(unit, '(a5, t10, f10.4)') &
         & "s6", param%s6, &
         & "s8", param%s8, &
         & "s9", param%s9, &
         & "rs6", param%rs6, &
         & "rs8", param%rs8, &
         & "alp", param%alp, &
         & "beta", param%bet
      write(unit, '(20("-"))')
      write(unit, '(a)')
   type is (optimizedpower_damping_param)
      write(unit, '(a, ":", 1x)', advance="no") "Optimized power damping"
      if (present(method)) then
         write(unit, '(a, "-")', advance="no") method
      end if
      if (abs(param%s9) > 0) then
         write(unit, '(a)') "D3(op)-ATM"
      else
         write(unit, '(a)') "D3(op)"
      end if
      write(unit, '(20("-"))')
      write(unit, '(a5, t10, f10.4)') &
         & "s6", param%s6, &
         & "s8", param%s8, &
         & "s9", param%s9, &
         & "a1", param%a1, &
         & "a1", param%a2, &
         & "alp", param%alp, &
         & "beta", param%bet
      write(unit, '(20("-"))')
      write(unit, '(a)')
   type is (rational_damping_param)
      write(unit, '(a, ":", 1x)', advance="no") "Rational (Becke-Johnson) damping"
      if (present(method)) then
         write(unit, '(a, "-")', advance="no") method
      end if
      if (abs(param%s9) > 0) then
         write(unit, '(a)') "D3(BJ)-ATM"
      else
         write(unit, '(a)') "D3(BJ)"
      end if
      write(unit, '(21("-"))')
      write(unit, '(a4, t10, f10.4)') &
         & "s6", param%s6, &
         & "s8", param%s8, &
         & "s9", param%s9, &
         & "a1", param%a1, &
         & "a2", param%a2, &
         & "alp", param%alp
      write(unit, '(20("-"))')
      write(unit, '(a)')
   end select

end subroutine ascii_damping_param


subroutine ascii_gcp_param(unit, mol, param, method)

   !> Unit for output
   integer, intent(in) :: unit

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Counter-poise parameters
   type(gcp_param), intent(in) :: param

   !> Method name
   character(len=*), intent(in), optional :: method

   integer :: isp

   write(unit, '(a,":")') "Global counter-poise parameters"
   write(unit, '(20("-"))')
   if (param%sigma > 0.0_wp .and. param%alpha > 0.0_wp .and. param%beta > 0.0_wp) then
      write(unit, '(a6, t10, f10.4)') &
         & "sigma", param%sigma, &
         & "alpha", param%alpha, &
         & "beta", param%beta
   end if
   if (param%damp) then
      write(unit, '(a6, t10, f10.4)') &
         & "dscal", param%dmp_scal, &
         & "dexpo", param%dmp_exp
   end if
   if (param%srb) then
      write(unit, '(a6, t10, f10.4)') &
         & "rscal", param%rscal, &
         & "qscal", param%qscal
   end if
   write(unit, '(20("-"))')
   write(unit, '(a)')

   if (allocated(param%emiss) .and. allocated(param%xv) &
      & .and. allocated(param%slater)) then
      write(unit, '(a,":")') "Atomic counter-poise parameters"
      write(unit, '(47("-"))')
      write(unit, '(a4,5x,a4,*(1x,a10))') "Z", "Zeff", "Emiss[Eh]", "Virtual", "Slater"
      write(unit, '(47("-"))')
      do isp = 1, mol%nid
         write(unit, '(i4, 1x, a4, i4, *(1x,f10.4))') &
            & mol%num(isp), mol%sym(isp), param%zeff(isp), &
            & param%emiss(isp), param%xv(isp), param%slater(isp)
      end do
      write(unit, '(47("-"))')
      write(unit, '(a)')
   end if

end subroutine ascii_gcp_param


subroutine turbomole_gradlatt(mol, fname, energy, sigma, stat)
   type(structure_type),intent(in) :: mol
   character(len=*),intent(in) :: fname
   real(wp),intent(in) :: energy
   real(wp),intent(in) :: sigma(3,3)
   integer, intent(out) :: stat
   character(len=:),allocatable :: line
   integer  :: i,j,icycle,line_number
   integer  :: err
   integer  :: igrad ! file handle
   logical  :: exist
   real(wp) :: escf
   real(wp) :: glat(3,3), inv_lat(3,3), gradlatt(3, 3)
   real(wp) :: dlat(3,3)
   stat = 0

   inv_lat = matinv_3x3(mol%lattice)

   do i = 1, 3
      do j = 1, 3
         gradlatt(i,j) = sigma(i,1)*inv_lat(j,1) &
            & + sigma(i,2)*inv_lat(j,2) &
            & + sigma(i,3)*inv_lat(j,3)
      enddo
   enddo

   icycle = 1
   i = 0
   escf = 0.0_wp
   line_number = 0

   inquire(file=fname,exist=exist)
   if (exist) then
      open(newunit=igrad,file=fname)
      read_file: do
         call getline(igrad,line,iostat=err)
         if (err.ne.0) exit read_file
         i=i+1
         if (index(line,'cycle') > 0) line_number = i
      enddo read_file
      if (line_number < 2) then
         stat = 1
         return
      endif

      rewind(igrad)
      skip_lines: do i = 1, line_number-1
         read(igrad,'(a)')
      enddo skip_lines
      call getline(igrad,line)
      read(line(10:17),*,iostat=err) icycle
      read(line(33:51),*,iostat=err) escf

      do i = 1, 3
         call getline(igrad,line)
         read(line,*,iostat=err) dlat(1,i),dlat(2,i),dlat(3,i)
      enddo
      if (any(abs(dlat-mol%lattice) > 1.0e-8_wp)) then
         stat = 1
         return
      endif
      do i = 1, 3
         call getline(igrad,line)
         read(line,*,iostat=err) glat(1,i),glat(2,i),glat(3,i)
      enddo
      do i = 1, 3
         backspace(igrad)
         backspace(igrad)
      enddo
      backspace(igrad)
   else
      open(newunit=igrad,file=fname)
      write(igrad,'("$gradlatt")')
   endif

   write(igrad,'(2x,"cycle =",1x,i6,4x,"SCF energy =",f18.11,3x,'//&
                   '"|dE/dlatt| =",f10.6)') &
      icycle, energy+escf, norm2(gradlatt+glat)
   do i = 1, 3
      write(igrad,'(3(F20.14,2x))') mol%lattice(1,i),mol%lattice(2,i),mol%lattice(3,i)
   enddo
   do i = 1, 3
      write(igrad,'(3D22.13)') gradlatt(1,i)+glat(1,i),gradlatt(2,i)+glat(2,i),gradlatt(3,i)+glat(3,i)
   enddo
   write(igrad,'("$end")')
   close(igrad)

end subroutine turbomole_gradlatt


subroutine turbomole_gradient(mol, fname, energy, gradient, stat)
   type(structure_type),intent(in) :: mol
   character(len=*),intent(in) :: fname
   real(wp),intent(in) :: energy
   real(wp),intent(in) :: gradient(:, :)
   integer, intent(out) :: stat
   character(len=:),allocatable :: line
   integer  :: i,icycle,line_number
   integer  :: err
   integer  :: igrad ! file handle
   logical  :: exist
   real(wp) :: escf
   real(wp),allocatable :: gscf(:,:)
   real(wp),allocatable :: xyz (:,:)
   allocate( gscf(3,mol%nat), source = 0.0_wp )
   stat = 0
   icycle = 1
   i = 0
   escf = 0.0_wp
   line_number = 0

   inquire(file=fname,exist=exist)
   if (exist) then
      open(newunit=igrad,file=fname)
      read_file: do
         call getline(igrad,line,iostat=err)
         if (err.ne.0) exit read_file
         i=i+1
         if (index(line,'cycle') > 0) line_number = i
      enddo read_file
      if (line_number < 2) then
         stat = 1
         return
      endif

      rewind(igrad)
      skip_lines: do i = 1, line_number-1
         read(igrad,'(a)')
      enddo skip_lines
      call getline(igrad,line)
      read(line(10:17),*,iostat=err) icycle
      read(line(33:51),*,iostat=err) escf

      allocate(xyz(3,mol%nat))
      do i = 1, mol%nat
         call getline(igrad,line)
         read(line,*,iostat=err) xyz(1,i),xyz(2,i),xyz(3,i)
      enddo
      if (any(abs(xyz-mol%xyz) > 1.0e-8_wp)) then
         stat = 1
         return
      endif
      do i = 1, mol%nat
         call getline(igrad,line)
         read(line,*,iostat=err) gscf(1,i),gscf(2,i),gscf(3,i)
      enddo
      do i = 1, mol%nat
         backspace(igrad)
         backspace(igrad)
      enddo
      backspace(igrad)
   else
      open(newunit=igrad,file=fname)
      write(igrad,'("$grad")')
   endif

   write(igrad,'(2x,"cycle =",1x,i6,4x,"SCF energy =",f18.11,3x,'//&
                   '"|dE/dxyz| =",f10.6)') &
      icycle, energy+escf, norm2(gradient+gscf)
   do i = 1, mol%nat
      write(igrad,'(3(F20.14,2x),4x,a2)') mol%xyz(1,i),mol%xyz(2,i),mol%xyz(3,i),mol%sym(i)
   enddo
   do i = 1, mol%nat
      write(igrad,'(3D22.13)') gradient(1,i)+gscf(1,i),gradient(2,i)+gscf(2,i),gradient(3,i)+gscf(3,i)
   enddo
   write(igrad,'("$end")')
   close(igrad)

end subroutine turbomole_gradient


!> reads a line from unit into an allocatable character
subroutine getline(unit,line,iostat)
   integer,intent(in) :: unit
   character(len=:),allocatable,intent(out) :: line
   integer,intent(out),optional :: iostat

   integer,parameter  :: buffersize=256
   character(len=buffersize) :: buffer
   integer :: size
   integer :: stat

   line = ''
   do
      read(unit,'(a)',advance='no',iostat=stat,size=size)  &
      &    buffer
      if (stat.gt.0) then
         if (present(iostat)) iostat=stat
         return ! an error occurred
      endif
      line = line // buffer(:size)
      if (stat.lt.0) then
         if (is_iostat_eor(stat)) stat = 0
         if (present(iostat)) iostat=stat
         return
      endif
   enddo

end subroutine getline


subroutine json_results(unit, indentation, energy, gradient, sigma, cn, c6, &
      & pairwise_energy2, pairwise_energy3, param)
   integer, intent(in) :: unit
   character(len=*), intent(in), optional :: indentation
   real(wp), intent(in), optional :: energy
   real(wp), intent(in), optional :: gradient(:, :)
   real(wp), intent(in), optional :: sigma(:, :)
   real(wp), intent(in), optional :: cn(:)
   real(wp), intent(in), optional :: c6(:, :)
   real(wp), intent(in), optional :: pairwise_energy2(:, :)
   real(wp), intent(in), optional :: pairwise_energy3(:, :)
   class(damping_param), intent(in), optional :: param
   character(len=:), allocatable :: indent, version_string
   character(len=*), parameter :: jsonkey = "('""',a,'"":',1x)"
   real(wp), allocatable :: array(:)

   call get_dftd3_version(string=version_string)

   if (present(indentation)) then
      indent = indentation
   end if

   write(unit, '("{")', advance='no')
   if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
   write(unit, jsonkey, advance='no') 'version'
   write(unit, '(1x,a)', advance='no') '"'//version_string//'"'
   if (present(energy)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'energy'
      write(unit, '(1x,es25.16)', advance='no') energy
   end if
   if (present(sigma)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'virial'
      array = reshape(sigma, [product(shape(sigma))])
      call write_json_array(unit, array, indent)
   end if
   if (present(gradient)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'gradient'
      array = reshape(gradient, [product(shape(gradient))])
      call write_json_array(unit, array, indent)
   end if
   if (present(cn)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'coordination numbers'
      call write_json_array(unit, cn, indent)
   end if
   if (present(c6)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'c6 coefficients'
      array = reshape(c6, [product(shape(c6))])
      call write_json_array(unit, array, indent)
   end if
   if (present(pairwise_energy2)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'additive pairwise energy'
      array = reshape(pairwise_energy2, [size(pairwise_energy2)])
      call write_json_array(unit, array, indent)
   end if
   if (present(pairwise_energy3)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'non-additive pairwise energy'
      array = reshape(pairwise_energy3, [size(pairwise_energy3)])
      call write_json_array(unit, array, indent)
   end if
   if (present(param)) then
      write(unit, '(",")', advance='no')
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
      write(unit, jsonkey, advance='no') 'damping parameters'
      select type(param)
      type is(rational_damping_param)
         call write_json_param(unit, "rational", s6=param%s6, s8=param%s8, &
            & s9=param%s9, a1=param%a1, a2=param%a2, alp=param%alp, indent=indent)
      type is(zero_damping_param)
         call write_json_param(unit, "zero", s6=param%s6, s8=param%s8, &
            & s9=param%s9, rs6=param%rs6, rs8=param%rs8, alp=param%alp, indent=indent)
      type is(mzero_damping_param)
         call write_json_param(unit, "mzero", s6=param%s6, s8=param%s8, s9=param%s9, &
            & rs6=param%rs6, rs8=param%rs8, alp=param%alp, bet=param%bet, indent=indent)
      type is(optimizedpower_damping_param)
         call write_json_param(unit, "optimizedpower", s6=param%s6, s8=param%s8, &
            & s9=param%s9, a1=param%a1, a2=param%a2, alp=param%alp, bet=param%bet, &
            & indent=indent)
      class default
         call write_json_param(unit, "unknown", indent=indent)
      end select
   end if
   if (allocated(indent)) write(unit, '(/)', advance='no')
   write(unit, '("}")')

end subroutine json_results

subroutine write_json_param(unit, damping, s6, s8, s9, a1, a2, rs6, rs8, alp, bet, indent)
   integer, intent(in) :: unit
   character(len=*), intent(in) :: damping
   real(wp), intent(in), optional :: s6, s8, s9, a1, a2, rs6, rs8, alp, bet
   character(len=:), allocatable, intent(in) :: indent
   character(len=*), parameter :: jsonkeyval = "('""',a,'"":',1x,'""',a,'""')"

   write(unit, '("{")', advance='no')

   if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 2)
   write(unit, jsonkeyval, advance='no') 'damping', damping

   if (present(s6)) then
      call write_json_keyval(unit, 's6', s6, indent)
   end if

   if (present(s8)) then
      call write_json_keyval(unit, 's8', s8, indent)
   end if

   if (present(s9)) then
      call write_json_keyval(unit, 's9', s9, indent)
   end if

   if (present(a1)) then
      call write_json_keyval(unit, 'a1', a1, indent)
   end if

   if (present(a2)) then
      call write_json_keyval(unit, 'a2', a2, indent)
   end if

   if (present(rs6)) then
      call write_json_keyval(unit, 'rs6', rs6, indent)
   end if

   if (present(rs8)) then
      call write_json_keyval(unit, 'rs8', rs8, indent)
   end if

   if (present(alp)) then
      call write_json_keyval(unit, 'alp', alp, indent)
   end if

   if (present(bet)) then
      call write_json_keyval(unit, 'bet', bet, indent)
   end if

   if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
   write(unit, '("}")', advance='no')
end subroutine write_json_param

subroutine write_json_keyval(unit, key, val, indent)
   integer, intent(in) :: unit
   character(len=*), intent(in) :: key
   real(wp), intent(in) :: val
   character(len=:), allocatable, intent(in) :: indent
   character(len=*), parameter :: jsonkeyval = "('""',a,'"":',1x,es23.16)"

   write(unit, '(",")', advance='no')
   if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 2)
   write(unit, jsonkeyval, advance='no') key, val

end subroutine write_json_keyval

subroutine write_json_array(unit, array, indent)
   integer, intent(in) :: unit
   real(wp), intent(in) :: array(:)
   character(len=:), allocatable, intent(in) :: indent
   integer :: i
   write(unit, '("[")', advance='no')
   do i = 1, size(array)
      if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 2)
      write(unit, '(es23.16)', advance='no') array(i)
      if (i /= size(array)) write(unit, '(",")', advance='no')
   end do
   if (allocated(indent)) write(unit, '(/,a)', advance='no') repeat(indent, 1)
   write(unit, '("]")', advance='no')
end subroutine write_json_array


subroutine tagged_result(unit, energy, gradient, sigma)
   integer, intent(in) :: unit
   real(wp), intent(in), optional :: energy
   real(wp), intent(in), optional :: gradient(:, :)
   real(wp), intent(in), optional :: sigma(:, :)
   character(len=*), parameter :: tag_header = &
      & '(a,t20,":",a,":",i0,":",*(i0:,","))'

   if (present(energy)) then
      write(unit, tag_header) "energy", "real", 0
      write(unit, '(3es24.16)') energy
   end if
   if (present(gradient)) then
      write(unit, tag_header) "gradient", "real", 2, 3, size(gradient, 2)
      write(unit, '(3es24.16)') gradient
   end if
   if (present(sigma)) then
      write(unit, tag_header) "virial", "real", 2, 3, 3
      write(unit, '(3es24.16)') sigma
   end if

end subroutine tagged_result

end module dftd3_output

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/io
!> Contains interfaces to IO formats

!> @file tblite/io/tag.f90
!> Provides tagged input and output routines

!> Implementation of tagged input and output files
module tblite_io_tag
   use mctc_io_utils, only : getline
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: tagged_data, tagged_entry
   public :: write_tagged, read_tagged

   interface write_tagged
      module procedure :: write_tagged
      module procedure :: write_tagged_dp0
      module procedure :: write_tagged_dp1
      module procedure :: write_tagged_dp2
   end interface

   interface read_tagged
      module procedure :: read_tagged
   end interface

   character(len=*), parameter :: tag_header = &
      & '(a,t20,":",a,":",i0,":",*(i0:,","))'

   type :: tagged_entry
      character(len=:), allocatable :: tag
      class(*), allocatable :: raw(:)
      integer, allocatable :: shape(:)
   end type tagged_entry

   type :: tagged_data
      type(tagged_entry), allocatable :: val(:)
   contains
      procedure :: get
      !> Reading of tagged data
      generic :: load => load_from_file, load_from_unit
      !> Read tagged data from file
      procedure, private :: load_from_file
      !> Read tagged data from formatted unit
      procedure, private :: load_from_unit
      !> Writing of tagged data
      generic :: dump => dump_to_file, dump_to_unit
      !> Write tagged data to file
      procedure, private :: dump_to_file
      !> Write tagged data to formatted unit
      procedure, private :: dump_to_unit
   end type tagged_data

contains

subroutine write_tagged_dp0(unit, tag, val, stat)
   integer, intent(in) :: unit
   character(len=*), intent(in) :: tag
   real(dp), intent(in) :: val
   integer, intent(out) :: stat

   type(tagged_entry) :: tmp

   tmp%tag = tag
   tmp%raw = [val]
   allocate(tmp%shape(0))
   call write_tagged(unit, tmp, stat)
end subroutine write_tagged_dp0

subroutine write_tagged_dp1(unit, tag, val, stat)
   integer, intent(in) :: unit
   character(len=*), intent(in) :: tag
   real(dp), intent(in) :: val(:)
   integer, intent(out) :: stat

   type(tagged_entry) :: tmp

   tmp%tag = tag
   tmp%raw = val
   tmp%shape = shape(val)
   call write_tagged(unit, tmp, stat)
end subroutine write_tagged_dp1

subroutine write_tagged_dp2(unit, tag, val, stat)
   integer, intent(in) :: unit
   character(len=*), intent(in) :: tag
   real(dp), intent(in) :: val(:, :)
   integer, intent(out) :: stat

   type(tagged_entry) :: tmp

   tmp%tag = tag
   tmp%raw = reshape(val, [size(val)])
   tmp%shape = shape(val)
   call write_tagged(unit, tmp, stat)
end subroutine write_tagged_dp2

subroutine write_tagged(unit, val, stat)
   integer, intent(in) :: unit
   type(tagged_entry), intent(in) :: val
   integer, intent(out) :: stat

   select type(raw => val%raw)
   type is(real(dp))
      write(unit, tag_header, iostat=stat) val%tag, "real", size(val%shape), val%shape
      write(unit, '(3es24.16)') raw
   end select
end subroutine write_tagged

subroutine read_tagged(unit, val, stat)
   integer, intent(in) :: unit
   type(tagged_entry), intent(out) :: val
   integer, intent(out) :: stat

   integer :: idel, jdel, kdel, vrank, i
   character(len=:), allocatable :: line

   call getline(unit, line, stat)
   if (is_iostat_end(stat)) return
   idel = scan(line, ":")
   jdel = scan(line(idel+1:), ":") + idel

   val%tag = trim(line(:idel-1))

   kdel = scan(line(jdel+1:), ":") + jdel
   read(line(jdel+1:kdel-1), *) vrank
   allocate(val%shape(vrank))
   if (vrank > 0) then
      do i = kdel+1, len(line)
         if (line(i:i) == ",") line(i:i) = " "
      end do
      read(line(kdel+1:), *) val%shape
   end if

   select case(line(idel+1:jdel-1))
   case("real")
      block
         integer :: i, n
         real(dp), allocatable :: tmp(:)
         n = max(product(val%shape), 1)
         allocate(tmp(n))
         read(unit, *) (tmp(i), i = 1, n)
         call move_alloc(tmp, val%raw)
      end block
   end select
end subroutine read_tagged


subroutine load_from_unit(self, unit, stat)
   class(tagged_data), intent(out) :: self
   integer, intent(in) :: unit
   integer, intent(out) :: stat

   integer :: it

   call resize(self%val)

   it = 0
   stat = 0
   do while(stat == 0)
      if (it > size(self%val)) call resize(self%val)
      it = it + 1
      call read_tagged(unit, self%val(it), stat)
      if (stat /= 0) it = it - 1
   end do
   call resize(self%val, it)

   if (is_iostat_end(stat)) stat = 0
end subroutine load_from_unit

subroutine dump_to_unit(self, unit, stat)
   class(tagged_data), intent(in) :: self
   integer, intent(in) :: unit
   integer, intent(out) :: stat

   integer :: it

   do it = 1, size(self%val)
      call write_tagged(unit, self%val(it), stat)
      if (stat /= 0) exit
   end do
end subroutine dump_to_unit

subroutine get(self, tag, ptr)
   class(tagged_data), intent(in), target :: self
   character(len=*), intent(in) :: tag
   type(tagged_entry), pointer, intent(out) :: ptr

   integer :: i

   nullify(ptr)
   do i = 1, size(self%val)
      if (self%val(i)%tag == tag) then
         ptr => self%val(i)
         exit
      end if
   end do
end subroutine get


!> Reallocate list of tagged entries
subroutine resize(var, n)
   !> Instance of the array to be resized
   type(tagged_entry), allocatable, intent(inout) :: var(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(tagged_entry), allocatable :: tmp(:)
   integer :: this_size, new_size, i
   integer, parameter :: initial_size = 20

   if (allocated(var)) then
      this_size = size(var, 1)
      call move_alloc(var, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(var(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(var, 1))
      do i = 1, this_size
         call move_alloc(tmp(i)%tag, var(i)%tag)
         call move_alloc(tmp(i)%raw, var(i)%raw)
         call move_alloc(tmp(i)%shape, var(i)%shape)
      end do
      deallocate(tmp)
   end if
end subroutine resize


!> Read parametrization data from file
subroutine load_from_file(self, file, stat)
   !> Instance of the parametrization data
   class(tagged_data), intent(inout) :: self
   !> File name
   character(len=*), intent(in) :: file
   !> Error handling
   integer, intent(out) :: stat

   integer :: unit
   logical :: exist

   inquire(file=file, exist=exist)
   if (.not.exist) then
     stat = 1
     return
   end if

   open(file=file, newunit=unit)
   call self%load(unit, stat)
   close(unit)
end subroutine load_from_file


!> Write parametrization data to file
subroutine dump_to_file(self, file, stat)
   !> Instance of the parametrization data
   class(tagged_data), intent(in) :: self
   !> File name
   character(len=*), intent(in) :: file
   !> Error handling
   integer, intent(out) :: stat

   integer :: unit

   open(file=file, newunit=unit)
   call self%dump(unit, stat)
   close(unit)
   if (stat /= 0) return

end subroutine dump_to_file


end module tblite_io_tag

! This file is part of multicharge.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module test_pbc
   use mctc_env, only: wp
   use mctc_env_testing, only: new_unittest, unittest_type, error_type, &
      & test_failed
   use mctc_io_structure, only: structure_type
   use mctc_cutoff, only: get_lattice_points
   use mstore, only: get_structure
   use multicharge_model, only: mchrg_model_type
   use multicharge_model_eeqbc, only: eeqbc_model
   use multicharge_param, only: new_eeq2019_model, new_eeqbc2025_model
   use multicharge_model_cache, only: cache_container
   implicit none
   private

   public :: collect_pbc

   real(wp), parameter :: thr = 1000 * epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))

contains

!> Collect all exported unit tests
subroutine collect_pbc(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("eeq-charges-cyanamide", test_eeq_q_cyanamide), &
      & new_unittest("eeq-energy-formamide", test_eeq_e_formamide), &
      & new_unittest("eeq-dbdr-co2", test_eeq_dbdr_co2), &
      & new_unittest("eeq-dbdL-co2", test_eeq_dbdL_co2), &
      & new_unittest("eeq-dadr-ice", test_eeq_dadr_ice), &
      & new_unittest("eeq-dadL-ice", test_eeq_dadL_ice), &
      & new_unittest("eeq-gradient-co2", test_eeq_g_co2), &
      & new_unittest("eeq-sigma-ice", test_eeq_s_ice), &
      & new_unittest("eeq-dqdr-urea", test_eeq_dqdr_urea), &
      & new_unittest("eeq-dqdL-oxacb", test_eeq_dqdL_oxacb), &
      & new_unittest("eeqbc-dbdr-co2", test_eeqbc_dbdr_co2), &
      & new_unittest("eeqbc-dbdL-co2", test_eeqbc_dbdL_co2), &
      & new_unittest("eeqbc-dadr-ice", test_eeqbc_dadr_ice), &
      & new_unittest("eeqbc-dadL-ice", test_eeqbc_dadL_ice), &
      & new_unittest("eeqbc-gradient-co2", test_eeqbc_g_co2), &
      & new_unittest("eeqbc-sigma-ice", test_eeqbc_s_ice), &
      & new_unittest("eeqbc-dqdr-urea", test_eeqbc_dqdr_urea), &
      & new_unittest("eeqbc-dqdL-oxacb", test_eeqbc_dqdL_oxacb) &
      & ]

end subroutine collect_pbc

subroutine gen_test(error, mol, model, qref, eref)

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Electronegativity equilibration model
   class(mchrg_model_type), intent(in) :: model

   !> Reference charges
   real(wp), intent(in), optional :: qref(:)

   !> Reference energies
   real(wp), intent(in), optional :: eref(:)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), allocatable :: cn(:), qloc(:), trans(:, :)
   real(wp), allocatable :: energy(:)
   real(wp), allocatable :: qvec(:)

   call get_lattice_points(mol%periodic, mol%lattice, cutoff, trans)

   allocate(cn(mol%nat), qloc(mol%nat))

   call model%ncoord%get_coordination_number(mol, trans, cn)
   call model%local_charge(mol, trans, qloc)

   if (present(eref)) then
      allocate(energy(mol%nat))
      energy(:) = 0.0_wp
   end if
   if (present(qref)) then
      allocate(qvec(mol%nat))
   end if

   call model%solve(mol, error, cn, qloc, energy=energy, qvec=qvec)
   if (allocated(error)) return

   if (present(qref)) then
      if (any(abs(qvec - qref) > thr)) then
         call test_failed(error, "Partial charges do not match")
         print'(a)', "Charges:"
         print'(3es21.14)', qvec
         print'("---")'
         print'(3es21.14)', qref
         print'("---")'
         print'(3es21.14)', qvec - qref
      end if
   end if
   if (allocated(error)) return

   if (present(eref)) then
      if (any(abs(energy - eref) > thr)) then
         call test_failed(error, "Energies do not match")
         print'(a)', "Energy:"
         print'(3es21.14)', energy
         print'("---")'
         print'(3es21.14)', eref
         print'("---")'
         print'(3es21.14)', energy - eref
      end if
   end if

end subroutine gen_test

subroutine test_numgrad(error, mol, model)

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Electronegativity equilibration model
   class(mchrg_model_type), intent(in) :: model

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iat, ic
   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), parameter :: step = 1.0e-6_wp
   real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :), trans(:, :)
   real(wp), allocatable :: qloc(:), dqlocdr(:, :, :), dqlocdL(:, :, :)
   real(wp), allocatable :: energy(:), gradient(:, :), sigma(:, :)
   real(wp), allocatable :: numgrad(:, :)
   real(wp) :: er, el

   call get_lattice_points(mol%periodic, mol%lattice, cutoff, trans)

   allocate(cn(mol%nat), dcndr(3, mol%nat, mol%nat), dcndL(3, 3, mol%nat), &
      & qloc(mol%nat), dqlocdr(3, mol%nat, mol%nat), dqlocdL(3, 3, mol%nat), &
      & energy(mol%nat), gradient(3, mol%nat), sigma(3, 3), numgrad(3, mol%nat))
   energy(:) = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   lp: do iat = 1, mol%nat
      do ic = 1, 3
         energy(:) = 0.0_wp
         er = 0.0_wp
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call model%ncoord%get_coordination_number(mol, trans, cn)
         call model%local_charge(mol, trans, qloc)
         call model%solve(mol, error, cn, qloc, energy=energy)
         if (allocated(error)) exit lp
         er = sum(energy)

         energy(:) = 0.0_wp
         el = 0.0_wp
         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2 * step
         call model%ncoord%get_coordination_number(mol, trans, cn)
         call model%local_charge(mol, trans, qloc)
         call model%solve(mol, error, cn, qloc, energy=energy)
         if (allocated(error)) exit lp
         el = sum(energy)

         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         numgrad(ic, iat) = 0.5_wp * (er - el) / step
      end do
   end do lp
   if (allocated(error)) return

   call model%ncoord%get_coordination_number(mol, trans, cn, dcndr, dcndL)
   call model%local_charge(mol, trans, qloc, dqlocdr, dqlocdL)

   energy(:) = 0.0_wp
   call model%solve(mol, error, cn, qloc, dcndr, dcndL, &
      & dqlocdr, dqlocdL, energy, gradient, sigma)
   if (allocated(error)) return

   if (any(abs(gradient(:, :) - numgrad(:, :)) > thr2)) then
      call test_failed(error, "Derivative of energy does not match")
      print'(a)', "gradient:"
      print'(3es21.14)', gradient
      print'(a)', "numgrad:"
      print'(3es21.14)', numgrad
      print'(a)', "diff:"
      print'(3es21.14)', gradient - numgrad
   end if

end subroutine test_numgrad

subroutine test_numsigma(error, mol, model)

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Electronegativity equilibration model
   class(mchrg_model_type), intent(in) :: model

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ic, jc
   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), parameter :: step = 1.0e-6_wp, unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], [3, 3])
   real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :), trans(:, :)
   real(wp), allocatable :: qloc(:), dqlocdr(:, :, :), dqlocdL(:, :, :)
   real(wp), allocatable :: energy(:), gradient(:, :)
   real(wp), allocatable :: lattr(:, :), xyz(:, :)
   real(wp) :: er, el, eps(3, 3), numsigma(3, 3), sigma(3, 3), lattice(3, 3)

   call get_lattice_points(mol%periodic, mol%lattice, cutoff, trans)

   allocate(cn(mol%nat), dcndr(3, mol%nat, mol%nat), dcndL(3, 3, mol%nat), &
      & qloc(mol%nat), dqlocdr(3, mol%nat, mol%nat), dqlocdL(3, 3, mol%nat), &
      & energy(mol%nat), gradient(3, mol%nat), xyz(3, mol%nat))
   energy(:) = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   eps(:, :) = unity
   xyz(:, :) = mol%xyz
   lattice(:, :) = mol%lattice
   lattr = trans
   lp: do ic = 1, 3
      do jc = 1, 3
         energy(:) = 0.0_wp
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = matmul(eps, xyz)
         mol%lattice(:, :) = matmul(eps, lattice)
         lattr(:, :) = matmul(eps, trans)
         call model%ncoord%get_coordination_number(mol, lattr, cn)
         call model%local_charge(mol, lattr, qloc)
         call model%solve(mol, error, cn, qloc, energy=energy)
         if (allocated(error)) exit lp
         er = sum(energy)

         energy(:) = 0.0_wp
         eps(jc, ic) = eps(jc, ic) - 2 * step
         mol%xyz(:, :) = matmul(eps, xyz)
         mol%lattice(:, :) = matmul(eps, lattice)
         lattr(:, :) = matmul(eps, trans)
         call model%ncoord%get_coordination_number(mol, lattr, cn)
         call model%local_charge(mol, lattr, qloc)
         call model%solve(mol, error, cn, qloc, energy=energy)
         if (allocated(error)) exit lp
         el = sum(energy)

         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = xyz
         mol%lattice(:, :) = lattice
         lattr(:, :) = trans
         numsigma(jc, ic) = 0.5_wp * (er - el) / step
      end do
   end do lp
   if (allocated(error)) return

   call model%ncoord%get_coordination_number(mol, trans, cn, dcndr, dcndL)
   call model%local_charge(mol, trans, qloc, dqlocdr, dqlocdL)

   energy(:) = 0.0_wp
   call model%solve(mol, error, cn, qloc, dcndr, dcndL, &
      & dqlocdr, dqlocdL, energy, gradient, sigma)
   if (allocated(error)) return

   if (any(abs(sigma(:, :) - numsigma(:, :)) > thr2)) then
      call test_failed(error, "Derivative of energy does not match")
      print'(a)', "sigma:"
      print'(3es21.14)', sigma
      print'(a)', "numgrad:"
      print'(3es21.14)', numsigma
      print'(a)', "diff:"
      print'(3es21.14)', sigma(:, :) - numsigma(:, :)
   end if

end subroutine test_numsigma

subroutine test_dbdr(error, mol, model)

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Electronegativity equilibration model
   class(mchrg_model_type), intent(in) :: model

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iat, ic
   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), parameter :: step = 1.0e-6_wp
   real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :), trans(:, :)
   real(wp), allocatable :: qloc(:), dqlocdr(:, :, :), dqlocdL(:, :, :)
   real(wp), allocatable :: dbdr(:, :, :), dbdL(:, :, :)
   real(wp), allocatable :: numgrad(:, :, :), xvecr(:), xvecl(:)
   type(cache_container), allocatable :: cache
   allocate(cache)

   call get_lattice_points(mol%periodic, mol%lattice, cutoff, trans)

   allocate(cn(mol%nat), dcndr(3, mol%nat, mol%nat), dcndL(3, 3, mol%nat), &
      & qloc(mol%nat), dqlocdr(3, mol%nat, mol%nat), dqlocdL(3, 3, mol%nat), &
      & xvecr(mol%nat + 1), xvecl(mol%nat + 1), numgrad(3, mol%nat, mol%nat + 1), &
      & dbdr(3, mol%nat, mol%nat + 1), dbdL(3, 3, mol%nat + 1))

   numgrad = 0.0_wp

   lp: do iat = 1, mol%nat
      do ic = 1, 3
         ! Right-hand side
         xvecr(:) = 0.0_wp
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call model%ncoord%get_coordination_number(mol, trans, cn)
         call model%local_charge(mol, trans, qloc)
         call model%update(mol, cache, cn, qloc)
         call model%get_xvec(mol, cache, xvecr)

         ! Left-hand side
         xvecl(:) = 0.0_wp
         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2 * step
         call model%ncoord%get_coordination_number(mol, trans, cn)
         call model%local_charge(mol, trans, qloc)
         call model%update(mol, cache, cn, qloc)
         call model%get_xvec(mol, cache, xvecl)

         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         numgrad(ic, iat, :) = 0.5_wp * (xvecr(:) - xvecl(:)) / step
      end do
   end do lp

   ! Analytical gradient
   call model%ncoord%get_coordination_number(mol, trans, cn, dcndr, dcndL)
   call model%local_charge(mol, trans, qloc, dqlocdr, dqlocdL)
   call model%update(mol, cache, cn, qloc, dcndr, dcndL, dqlocdr, dqlocdL)
   call model%get_xvec(mol, cache, xvecl) ! need to call this for xtmp in cache (eeqbc)
   call model%get_xvec_derivs(mol, cache, dbdr, dbdL)

   if (any(abs(dbdr(:, :, :) - numgrad(:, :, :)) > thr2)) then
      call test_failed(error, "Derivative of the b vector does not match")
      print'(a)', "dbdr:"
      print'(3es21.14)', dbdr
      print'(a)', "numgrad:"
      print'(3es21.14)', numgrad
      print'(a)', "diff:"
      print'(3es21.14)', dbdr - numgrad
   end if

end subroutine test_dbdr

subroutine test_dbdL(error, mol, model)

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Electronegativity equilibration model
   class(mchrg_model_type), intent(in) :: model

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iat, ic, jc
   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), parameter :: step = 1.0e-6_wp, unity(3, 3) = reshape(&
   & [1, 0, 0, 0, 1, 0, 0, 0, 1], [3, 3])
   real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :)
   real(wp), allocatable :: qloc(:), dqlocdr(:, :, :), dqlocdL(:, :, :)
   real(wp), allocatable :: dbdr(:, :, :), dbdL(:, :, :)
   real(wp), allocatable :: numsigma(:, :, :), xvecr(:), xvecl(:)
   real(wp), allocatable :: xyz(:, :), lattr(:, :), trans(:, :)
   real(wp) :: lattice(3, 3)
   real(wp) :: eps(3, 3)
   type(cache_container), allocatable :: cache
   allocate(cache)

   allocate(cn(mol%nat), dcndr(3, mol%nat, mol%nat), dcndL(3, 3, mol%nat), &
      & qloc(mol%nat), dqlocdr(3, mol%nat, mol%nat), dqlocdL(3, 3, mol%nat), &
      & xvecr(mol%nat + 1), xvecl(mol%nat + 1), numsigma(3, 3, mol%nat + 1), &
      & dbdr(3, mol%nat, mol%nat + 1), dbdL(3, 3, mol%nat + 1), xyz(3, mol%nat))

   call get_lattice_points(mol%periodic, mol%lattice, cutoff, trans)

   numsigma = 0.0_wp

   eps(:, :) = unity
   xyz(:, :) = mol%xyz
   lattice(:, :) = mol%lattice
   lattr = trans
   lp: do ic = 1, 3
      do jc = 1, 3
         ! Right-hand side
         xvecr(:) = 0.0_wp
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = matmul(eps, xyz)
         mol%lattice(:, :) = matmul(eps, lattice)
         lattr(:, :) = matmul(eps, trans)
         call model%ncoord%get_coordination_number(mol, lattr, cn)
         call model%local_charge(mol, lattr, qloc)
         call model%update(mol, cache, cn, qloc)
         call model%get_xvec(mol, cache, xvecr)

         ! Left-hand side
         xvecl(:) = 0.0_wp
         eps(jc, ic) = eps(jc, ic) - 2 * step
         mol%xyz(:, :) = matmul(eps, xyz)
         mol%lattice(:, :) = matmul(eps, lattice)
         lattr(:, :) = matmul(eps, trans)
         call model%ncoord%get_coordination_number(mol, lattr, cn)
         call model%local_charge(mol, lattr, qloc)
         call model%update(mol, cache, cn, qloc)
         call model%get_xvec(mol, cache, xvecl)

         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = xyz
         mol%lattice(:, :) = lattice
         lattr(:, :) = trans
         do iat = 1, mol%nat
            numsigma(jc, ic, iat) = 0.5_wp * (xvecr(iat) - xvecl(iat)) / step
         end do
      end do
   end do lp

   ! Analytical gradient
   call model%ncoord%get_coordination_number(mol, trans, cn, dcndr, dcndL)
   call model%local_charge(mol, trans, qloc, dqlocdr, dqlocdL)
   call model%update(mol, cache, cn, qloc, dcndr, dcndL, dqlocdr, dqlocdL)
   call model%get_xvec(mol, cache, xvecl) ! need to call this for xtmp in cache (eeqbc)
   call model%get_xvec_derivs(mol, cache, dbdr, dbdL)

   if (any(abs(dbdL(:, :, :) - numsigma(:, :, :)) > thr2)) then
      call test_failed(error, "Derivative of the b vector does not match")
      print'(a)', "dbdL:"
      print'(3es21.14)', dbdL
      print'(a)', "numsigma:"
      print'(3es21.14)', numsigma
      print'(a)', "diff:"
      print'(3es21.14)', dbdL - numsigma
   end if

end subroutine test_dbdL

subroutine test_dadr(error, mol, model)

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Electronegativity equilibration model
   class(mchrg_model_type), intent(in) :: model

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iat, ic, jat, kat
   real(wp) :: thr2_local
   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), parameter :: step = 1.0e-6_wp
   real(wp), allocatable :: cn(:)
   real(wp), allocatable :: qloc(:)
   real(wp), allocatable :: trans(:, :)
   real(wp), allocatable :: dcndr(:, :, :), dcndL(:, :, :), dqlocdr(:, :, :), dqlocdL(:, :, :)
   real(wp), allocatable :: dadr(:, :, :), dadL(:, :, :), atrace(:, :)
   real(wp), allocatable :: qvec(:), numgrad(:, :, :), amatr(:, :), amatl(:, :), numtrace(:, :)
   type(cache_container), allocatable :: cache
   allocate(cache)

   allocate(cn(mol%nat), qloc(mol%nat), amatr(mol%nat + 1, mol%nat + 1), amatl(mol%nat + 1, mol%nat + 1), &
      & dcndr(3, mol%nat, mol%nat), dcndL(3, 3, mol%nat), dqlocdr(3, mol%nat, mol%nat), &
      & dqlocdL(3, 3, mol%nat), dadr(3, mol%nat, mol%nat + 1), dadL(3, 3, mol%nat + 1), &
      & atrace(3, mol%nat), numtrace(3, mol%nat), numgrad(3, mol%nat, mol%nat + 1), qvec(mol%nat))

   ! Set tolerance higher if testing eeqbc model
   select type(model)
   type is(eeqbc_model)
      thr2_local = 3.0_wp * thr2
   class default
      thr2_local = thr2
   end select

   call get_lattice_points(mol%periodic, mol%lattice, cutoff, trans)

   ! Obtain the vector of charges
   call model%ncoord%get_coordination_number(mol, trans, cn)
   call model%local_charge(mol, trans, qloc)
   call model%solve(mol, error, cn, qloc, qvec=qvec)
   if (allocated(error)) return

   numgrad = 0.0_wp

   lp: do iat = 1, mol%nat
      do ic = 1, 3
         ! Right-hand side
         amatr(:, :) = 0.0_wp
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call model%ncoord%get_coordination_number(mol, trans, cn)
         call model%local_charge(mol, trans, qloc)
         call model%update(mol, cache, cn, qloc)
         call model%get_coulomb_matrix(mol, cache, amatr)

         ! Left-hand side
         amatl(:, :) = 0.0_wp
         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2 * step
         call model%ncoord%get_coordination_number(mol, trans, cn)
         call model%local_charge(mol, trans, qloc)
         call model%update(mol, cache, cn, qloc)
         call model%get_coulomb_matrix(mol, cache, amatl)

         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step

         do kat = 1, mol%nat
            do jat = 1, mol%nat
               ! Numerical gradient of the A matrix
               numgrad(ic, iat, kat) = 0.5_wp * qvec(jat) * (amatr(kat, jat) - amatl(kat, jat)) / step &
                  & + numgrad(ic, iat, kat)
            end do
         end do
      end do
   end do lp

   ! Analytical gradient
   call model%ncoord%get_coordination_number(mol, trans, cn, dcndr, dcndL)
   call model%local_charge(mol, trans, qloc, dqlocdr, dqlocdL)
   call model%update(mol, cache, cn, qloc, dcndr, dcndL, dqlocdr, dqlocdL)
   call model%get_coulomb_derivs(mol, cache, qvec, dadr, dadL, atrace)

   ! Add trace of the A matrix
   do iat = 1, mol%nat
      dadr(:, iat, iat) = atrace(:, iat) + dadr(:, iat, iat)
   end do

   ! higher tolerance for numerical gradient
   if (any(abs(dadr(:, :, :) - numgrad(:, :, :)) > thr2_local)) then
      call test_failed(error, "Derivative of the A matrix does not match")
      print'(a)', "dadr:"
      print'(3es21.14)', dadr
      print'(a)', "numgrad:"
      print'(3es21.14)', numgrad
      print'(a)', "diff:"
      print'(3es21.14)', dadr - numgrad
   end if

end subroutine test_dadr

subroutine test_dadL(error, mol, model)

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Electronegativity equilibration model
   class(mchrg_model_type), intent(in) :: model

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ic, jc, iat
   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), parameter :: step = 1.0e-6_wp, unity(3, 3) = reshape(&
   & [1, 0, 0, 0, 1, 0, 0, 0, 1], [3, 3])
   real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :)
   real(wp), allocatable :: qloc(:), dqlocdr(:, :, :), dqlocdL(:, :, :)
   real(wp), allocatable :: dadr(:, :, :), dadL(:, :, :), atrace(:, :)
   real(wp), allocatable :: xyz(:, :), lattr(:, :), trans(:, :)
   real(wp), allocatable :: qvec(:), numsigma(:, :, :), amatr(:, :), amatl(:, :)
   real(wp) :: lattice(3, 3)
   real(wp) :: eps(3, 3)
   type(cache_container), allocatable :: cache
   allocate(cache)

   allocate(cn(mol%nat), dcndr(3, mol%nat, mol%nat), dcndL(3, 3, mol%nat), &
      & qloc(mol%nat), dqlocdr(3, mol%nat, mol%nat), dqlocdL(3, 3, mol%nat), &
      & amatr(mol%nat + 1, mol%nat + 1), amatl(mol%nat + 1, mol%nat + 1), &
      & dadr(3, mol%nat, mol%nat + 1), dadL(3, 3, mol%nat + 1), atrace(3, mol%nat), &
      & numsigma(3, 3, mol%nat + 1), qvec(mol%nat), xyz(3, mol%nat))

   call get_lattice_points(mol%periodic, mol%lattice, cutoff, trans)

   call model%ncoord%get_coordination_number(mol, trans, cn)
   call model%local_charge(mol, trans, qloc)
   call model%solve(mol, error, cn, qloc, qvec=qvec)
   if (allocated(error)) return

   numsigma = 0.0_wp

   eps(:, :) = unity
   xyz(:, :) = mol%xyz
   lattice(:, :) = mol%lattice
   lattr = trans
   lp: do ic = 1, 3
      do jc = 1, 3
         amatr(:, :) = 0.0_wp
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = matmul(eps, xyz)
         mol%lattice(:, :) = matmul(eps, lattice)
         lattr(:, :) = matmul(eps, trans)
         call model%ncoord%get_coordination_number(mol, lattr, cn)
         call model%local_charge(mol, lattr, qloc)
         call model%update(mol, cache, cn, qloc)
         call model%get_coulomb_matrix(mol, cache, amatr)
         if (allocated(error)) exit lp

         amatl(:, :) = 0.0_wp
         eps(jc, ic) = eps(jc, ic) - 2 * step
         mol%xyz(:, :) = matmul(eps, xyz)
         mol%lattice(:, :) = matmul(eps, lattice)
         lattr(:, :) = matmul(eps, trans)
         call model%ncoord%get_coordination_number(mol, lattr, cn)
         call model%local_charge(mol, lattr, qloc)
         call model%update(mol, cache, cn, qloc)
         call model%get_coulomb_matrix(mol, cache, amatl)
         if (allocated(error)) exit lp

         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = xyz
         mol%lattice(:, :) = lattice
         lattr(:, :) = trans
         do iat = 1, mol%nat
            ! Numerical sigma of the a matrix
            numsigma(jc, ic, :) = 0.5_wp * qvec(iat) * (amatr(iat, :) - amatl(iat, :)) / step + numsigma(jc, ic, :)
         end do
      end do
   end do lp
   if (allocated(error)) return

   call model%ncoord%get_coordination_number(mol, trans, cn, dcndr, dcndL)
   call model%local_charge(mol, trans, qloc, dqlocdr, dqlocdL)
   call model%update(mol, cache, cn, qloc, dcndr, dcndL, dqlocdr, dqlocdL)

   call model%get_coulomb_derivs(mol, cache, qvec, dadr, dadL, atrace)
   if (allocated(error)) return

   if (any(abs(dadL(:, :, :) - numsigma(:, :, :)) > thr2)) then
      call test_failed(error, "Derivative of the A matrix does not match")
      print'(a)', "dadL:"
      print'(3es21.14)', dadL
      print'(a)', "numsigma:"
      print'(3es21.14)', numsigma
      print'(a)', "diff:"
      print'(3es21.14)', dadL - numsigma
   end if

end subroutine test_dadL

subroutine test_numdqdr(error, mol, model)

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Electronegativity equilibration model
   class(mchrg_model_type), intent(in) :: model

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iat, ic
   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), parameter :: step = 1.0e-6_wp
   real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :), trans(:, :)
   real(wp), allocatable :: qloc(:), dqlocdr(:, :, :), dqlocdL(:, :, :)
   real(wp), allocatable :: ql(:), qr(:), dqdr(:, :, :), dqdL(:, :, :)
   real(wp), allocatable :: numdr(:, :, :)

   call get_lattice_points(mol%periodic, mol%lattice, cutoff, trans)

   allocate(cn(mol%nat), dcndr(3, mol%nat, mol%nat), dcndL(3, 3, mol%nat), &
      & qloc(mol%nat), dqlocdr(3, mol%nat, mol%nat), dqlocdL(3, 3, mol%nat), &
      & ql(mol%nat), qr(mol%nat), dqdr(3, mol%nat, mol%nat), dqdL(3, 3, mol%nat), &
      & numdr(3, mol%nat, mol%nat))

   lp: do iat = 1, mol%nat
      do ic = 1, 3
         qr = 0.0_wp
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call model%ncoord%get_coordination_number(mol, trans, cn)
         call model%local_charge(mol, trans, qloc)
         call model%solve(mol, error, cn, qloc, qvec=qr)
         if (allocated(error)) exit lp

         ql = 0.0_wp
         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2 * step
         call model%ncoord%get_coordination_number(mol, trans, cn)
         call model%local_charge(mol, trans, qloc)
         call model%solve(mol, error, cn, qloc, qvec=ql)
         if (allocated(error)) exit lp

         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         numdr(ic, iat, :) = 0.5_wp * (qr - ql) / step
      end do
   end do lp
   if (allocated(error)) return

   call model%ncoord%get_coordination_number(mol, trans, cn, dcndr, dcndL)
   call model%local_charge(mol, trans, qloc, dqlocdr, dqlocdL)

   call model%solve(mol, error, cn, qloc, dcndr, dcndL, dqlocdr, dqlocdL, dqdr=dqdr, dqdL=dqdL)
   if (allocated(error)) return

   if (any(abs(dqdr(:, :, :) - numdr(:, :, :)) > thr2)) then
      call test_failed(error, "Derivative of charges does not match")
      print'(a)', "dqdr:"
      print'(3es21.14)', dqdr
      print'(a)', "numdr:"
      print'(3es21.14)', numdr
      print'(a)', "diff:"
      print'(3es21.14)', dqdr - numdr
   end if

end subroutine test_numdqdr

subroutine test_numdqdL(error, mol, model)

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Electronegativity equilibration model
   class(mchrg_model_type), intent(in) :: model

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ic, jc
   real(wp), parameter :: cutoff = 25.0_wp
   real(wp), parameter :: step = 1.0e-6_wp, unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], [3, 3])
   real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :), trans(:, :)
   real(wp), allocatable :: qloc(:), dqlocdr(:, :, :), dqlocdL(:, :, :)
   real(wp), allocatable :: qr(:), ql(:), dqdr(:, :, :), dqdL(:, :, :)
   real(wp), allocatable :: lattr(:, :), xyz(:, :), numdL(:, :, :)
   real(wp) :: eps(3, 3), lattice(3, 3)

   call get_lattice_points(mol%periodic, mol%lattice, cutoff, trans)

   allocate(cn(mol%nat), dcndr(3, mol%nat, mol%nat), dcndL(3, 3, mol%nat), &
      & qloc(mol%nat), dqlocdr(3, mol%nat, mol%nat), dqlocdL(3, 3, mol%nat), &
      & qr(mol%nat), ql(mol%nat), dqdr(3, mol%nat, mol%nat), dqdL(3, 3, mol%nat), &
      & xyz(3, mol%nat), numdL(3, 3, mol%nat))

   eps(:, :) = unity
   xyz(:, :) = mol%xyz
   lattice(:, :) = mol%lattice
   lattr = trans
   lp: do ic = 1, 3
      do jc = 1, 3
         qr = 0.0_wp
         ql = 0.0_wp
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = matmul(eps, xyz)
         mol%lattice(:, :) = matmul(eps, lattice)
         lattr(:, :) = matmul(eps, trans)
         call model%ncoord%get_coordination_number(mol, lattr, cn)
         call model%local_charge(mol, lattr, qloc)
         call model%solve(mol, error, cn, qloc, qvec=qr)
         if (allocated(error)) exit lp

         eps(jc, ic) = eps(jc, ic) - 2 * step
         mol%xyz(:, :) = matmul(eps, xyz)
         mol%lattice(:, :) = matmul(eps, lattice)
         lattr(:, :) = matmul(eps, trans)
         call model%ncoord%get_coordination_number(mol, lattr, cn)
         call model%local_charge(mol, lattr, qloc)
         call model%solve(mol, error, cn, qloc, qvec=ql)
         if (allocated(error)) exit lp

         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = xyz
         mol%lattice(:, :) = lattice
         lattr(:, :) = trans
         numdL(jc, ic, :) = 0.5_wp * (qr - ql) / step
      end do
   end do lp
   if (allocated(error)) return

   call model%ncoord%get_coordination_number(mol, trans, cn, dcndr, dcndL)
   call model%local_charge(mol, trans, qloc, dqlocdr, dqlocdL)

   call model%solve(mol, error, cn, qloc, dcndr, dcndL, &
      & dqlocdr, dqlocdL, dqdr=dqdr, dqdL=dqdL)
   if (allocated(error)) return

   if (any(abs(dqdL(:, :, :) - numdL(:, :, :)) > thr2)) then
      call test_failed(error, "Derivative of charges does not match")
      print'(a)', "dqdL:"
      print'(3es21.14)', dqdL
      print'(a)', "numdL:"
      print'(3es21.14)', numdL
      print'(a)', "diff:"
      print'(3es21.14)', dqdL - numdL
   end if

end subroutine test_numdqdL

subroutine test_eeq_q_cyanamide(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model
   real(wp), parameter :: ref(40) = [&
      & 3.47274007973765E-1_wp, 3.47273017259661E-1_wp, 3.47276806231462E-1_wp, &
      & 3.47267235121650E-1_wp, 3.47288751410308E-1_wp, 3.47296840650318E-1_wp, &
      & 3.47299868243747E-1_wp, 3.47299359754750E-1_wp, 3.45885710186856E-1_wp, &
      & 3.45874246032015E-1_wp, 3.45888242047875E-1_wp, 3.45877451600398E-1_wp, &
      & 3.45902365123333E-1_wp, 3.45902162041418E-1_wp, 3.45900336974539E-1_wp, &
      & 3.45903770121699E-1_wp, 3.58996736955583E-1_wp, 3.58987991603151E-1_wp, &
      & 3.59000859720791E-1_wp, 3.58990960169615E-1_wp, 3.58990422147650E-1_wp, &
      & 3.58997842028106E-1_wp, 3.58997124263551E-1_wp, 3.59001728635141E-1_wp, &
      &-5.86637659146611E-1_wp, -5.86601835343945E-1_wp, -5.86625078062709E-1_wp, &
      &-5.86579999312624E-1_wp, -5.86654394920376E-1_wp, -5.86669360667441E-1_wp, &
      &-5.86667481028248E-1_wp, -5.86674873278027E-1_wp, -4.65529092171338E-1_wp, &
      &-4.65527713392387E-1_wp, -4.65546450764424E-1_wp, -4.65540905286785E-1_wp, &
      &-4.65529860758785E-1_wp, -4.65533757413217E-1_wp, -4.65527683275370E-1_wp, &
      &-4.65527691475100E-1_wp]

   call get_structure(mol, "X23", "cyanamide")
   call new_eeq2019_model(mol, model, error)
   if (allocated(error)) return
   call gen_test(error, mol, model, qref=ref)

end subroutine test_eeq_q_cyanamide

subroutine test_eeq_e_formamide(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model
   real(wp), parameter :: ref(24) = [&
      & 4.01878116759118E-1_wp, 4.01884779867146E-1_wp, 4.01836430415694E-1_wp, &
      & 4.01859412981015E-1_wp, 4.30132679242368E-1_wp, 4.30105708698129E-1_wp, &
      & 4.30085668404029E-1_wp, 4.30108945050621E-1_wp, 1.90400193163051E-1_wp, &
      & 1.90401822781550E-1_wp, 1.90404130981992E-1_wp, 1.90407447306916E-1_wp, &
      & 3.33868335196572E-1_wp, 3.33848682655264E-1_wp, 3.33875977331594E-1_wp, &
      & 3.33893030511429E-1_wp, -8.35635584733599E-1_wp, -8.35614926719694E-1_wp, &
      &-8.35542684637248E-1_wp, -8.35589488474056E-1_wp, -6.31079122091240E-1_wp, &
      &-6.31059677948463E-1_wp, -6.31085206912995E-1_wp, -6.31081747027041E-1_wp]

   call get_structure(mol, "X23", "formamide")
   call new_eeq2019_model(mol, model, error)
   if (allocated(error)) return
   call gen_test(error, mol, model, eref=ref)

end subroutine test_eeq_e_formamide

subroutine test_eeq_dbdr_co2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "X23", "CO2")
   call new_eeq2019_model(mol, model, error)
   if (allocated(error)) return
   call test_dbdr(error, mol, model)

end subroutine test_eeq_dbdr_co2

subroutine test_eeq_dbdL_co2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "X23", "CO2")
   call new_eeq2019_model(mol, model, error)
   if (allocated(error)) return
   call test_dbdL(error, mol, model)

end subroutine test_eeq_dbdL_co2

subroutine test_eeq_dadr_ice(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "ICE10", "vi")
   call new_eeq2019_model(mol, model, error)
   if (allocated(error)) return
   call test_dadr(error, mol, model)

end subroutine test_eeq_dadr_ice

subroutine test_eeq_dadL_ice(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "ICE10", "vi")
   call new_eeq2019_model(mol, model, error)
   if (allocated(error)) return
   call test_dadL(error, mol, model)

end subroutine test_eeq_dadL_ice

subroutine test_eeq_g_co2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "X23", "CO2")
   call new_eeq2019_model(mol, model, error)
   if (allocated(error)) return
   call test_numgrad(error, mol, model)

end subroutine test_eeq_g_co2

subroutine test_eeq_s_ice(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "ICE10", "vi")
   call new_eeq2019_model(mol, model, error)
   if (allocated(error)) return
   call test_numsigma(error, mol, model)

end subroutine test_eeq_s_ice

subroutine test_eeq_dqdr_urea(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "X23", "urea")
   call new_eeq2019_model(mol, model, error)
   if (allocated(error)) return
   call test_numdqdr(error, mol, model)

end subroutine test_eeq_dqdr_urea

subroutine test_eeq_dqdL_oxacb(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "X23", "oxacb")
   call new_eeq2019_model(mol, model, error)
   if (allocated(error)) return
   call test_numdqdL(error, mol, model)

end subroutine test_eeq_dqdL_oxacb

subroutine test_eeqbc_dbdr_co2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "X23", "CO2")
   call new_eeqbc2025_model(mol, model, error)
   if (allocated(error)) return
   call test_dbdr(error, mol, model)

end subroutine test_eeqbc_dbdr_co2

subroutine test_eeqbc_dbdL_co2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "X23", "CO2")
   call new_eeqbc2025_model(mol, model, error)
   if (allocated(error)) return
   call test_dbdL(error, mol, model)

end subroutine test_eeqbc_dbdL_co2

subroutine test_eeqbc_dadr_ice(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "ICE10", "vi")
   call new_eeqbc2025_model(mol, model, error)
   if (allocated(error)) return
   call test_dadr(error, mol, model)

end subroutine test_eeqbc_dadr_ice

subroutine test_eeqbc_dadL_ice(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "ICE10", "vi")
   call new_eeqbc2025_model(mol, model, error)
   if (allocated(error)) return
   call test_dadL(error, mol, model)

end subroutine test_eeqbc_dadL_ice

subroutine test_eeqbc_g_co2(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "X23", "CO2")
   call new_eeqbc2025_model(mol, model, error)
   if (allocated(error)) return
   call test_numgrad(error, mol, model)

end subroutine test_eeqbc_g_co2

subroutine test_eeqbc_s_ice(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "ICE10", "vi")
   call new_eeqbc2025_model(mol, model, error)
   if (allocated(error)) return
   call test_numsigma(error, mol, model)

end subroutine test_eeqbc_s_ice

subroutine test_eeqbc_dqdr_urea(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "X23", "urea")
   call new_eeqbc2025_model(mol, model, error)
   if (allocated(error)) return
   call test_numdqdr(error, mol, model)

end subroutine test_eeqbc_dqdr_urea

subroutine test_eeqbc_dqdL_oxacb(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   class(mchrg_model_type), allocatable :: model

   call get_structure(mol, "X23", "oxacb")
   call new_eeqbc2025_model(mol, model, error)
   if (allocated(error)) return
   call test_numdqdL(error, mol, model)

end subroutine test_eeqbc_dqdL_oxacb

end module test_pbc

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/api/result.f90
!> Provides API exports for the #tblite_result handle.

!> API export for managing calculation results
module tblite_api_result
   use, intrinsic :: iso_c_binding
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_api_error, only : vp_error
   use tblite_api_utils, only : c_f_character
   use tblite_api_version, only : namespace
   use tblite_results, only : results_type
   use tblite_wavefunction_type, only : wavefunction_type
   use tblite_wavefunction_restart, only : load_wavefunction, save_wavefunction
   use tblite_api_double_dictionary, only : vp_double_dictionary
   implicit none
   private

   public :: vp_result, new_result_api, copy_result_api, delete_result_api
   public :: get_result_number_of_atoms_api, get_result_number_of_shells_api, &
      & get_result_number_of_spins_api, get_result_number_of_orbitals_api, &
      & get_result_energy_api, get_result_gradient_api, get_result_virial_api, &
      & get_result_charges_api, get_result_dipole_api, get_result_quadrupole_api, &
      & get_result_orbital_energies_api, get_result_orbital_occupations_api, &
      & get_result_orbital_coefficients_api, get_result_energies_api, &
      & get_result_density_matrix_api, get_result_overlap_matrix_api, &
      & get_result_hamiltonian_matrix_api, get_result_bond_orders_api, &
      & get_post_processing_dict_api


   !> Void pointer holding results of a calculation
   type :: vp_result
      !> Single point energy
      real(wp), allocatable :: energy
      !> Molecular gradient
      real(wp), allocatable :: gradient(:, :)
      !> Virial
      real(wp), allocatable :: sigma(:, :)
      !> Wavefunction
      type(wavefunction_type), allocatable :: wfn
      !> Additional results
      type(results_type), allocatable :: results
   end type vp_result


   logical, parameter :: debug = .false.


contains


!> Create new result container
function new_result_api() result(vres) &
      & bind(C, name=namespace//"new_result")
   type(vp_result), pointer :: res
   type(c_ptr) :: vres

   if (debug) print '("[Info]", 1x, a)', "new_result"

   allocate(res)
   vres = c_loc(res)

end function new_result_api


!> Create copy result container
function copy_result_api(vold) result(vnew) &
      & bind(C, name=namespace//"copy_result")
   type(vp_result), pointer :: new
   type(c_ptr), value :: vold
   type(vp_result), pointer :: old
   type(c_ptr) :: vnew

   if (debug) print '("[Info]", 1x, a)', "copy_result"

   vnew = c_null_ptr
   if (c_associated(vold)) then
      call c_f_pointer(vold, old)
      allocate(new, source=old)
      vnew = c_loc(new)
   end if

end function copy_result_api


!> Delete result container
subroutine delete_result_api(vres) &
      & bind(C, name=namespace//"delete_result")
   type(c_ptr), intent(inout) :: vres
   type(vp_result), pointer :: res

   if (debug) print '("[Info]", 1x, a)', "delete_result"

   if (c_associated(vres)) then
      call c_f_pointer(vres, res)

      deallocate(res)
      vres = c_null_ptr
   end if
end subroutine delete_result_api


subroutine get_result_number_of_atoms_api(verror, vres, natoms) &
      & bind(C, name=namespace//"get_result_number_of_atoms")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   integer(c_int), intent(out) :: natoms
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_number_of_atoms"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain number of atoms")
      return
   end if

   natoms = size(res%wfn%qat, 1)
end subroutine get_result_number_of_atoms_api


subroutine get_result_number_of_spins_api(verror, vres, nspin) &
      & bind(C, name=namespace//"get_result_number_of_spins")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   integer(c_int), intent(out) :: nspin
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_number_of_spins"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain number of spins")
      return
   end if

   nspin = res%wfn%nspin
end subroutine get_result_number_of_spins_api


subroutine get_result_number_of_shells_api(verror, vres, nshells) &
      & bind(C, name=namespace//"get_result_number_of_shells")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   integer(c_int), intent(out) :: nshells
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_number_of_shells"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain number of shells")
      return
   end if

   nshells = size(res%wfn%qsh, 1)
end subroutine get_result_number_of_shells_api


subroutine get_result_number_of_orbitals_api(verror, vres, norb) &
      & bind(C, name=namespace//"get_result_number_of_orbitals")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   integer(c_int), intent(out) :: norb
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_number_of_orbitals"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain number of orbitals")
      return
   end if

   norb = size(res%wfn%emo, 1)
end subroutine get_result_number_of_orbitals_api


subroutine get_result_energy_api(verror, vres, energy) &
      & bind(C, name=namespace//"get_result_energy")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: energy
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_energy"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%energy)) then
      call fatal_error(error%ptr, "Result does not contain energy")
      return
   end if

   energy = res%energy
end subroutine get_result_energy_api


subroutine get_result_energies_api(verror, vres, energies) &
      & bind(C, name=namespace//"get_result_energies")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: energies(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_energies"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%results)) then
      call fatal_error(error%ptr, "Result does not contain energies")
      return
   end if

   if (.not.allocated(res%results%energies)) then
      call fatal_error(error%ptr, "Result does not contain energies")
      return
   end if

   energies(:size(res%results%energies)) = res%results%energies
end subroutine get_result_energies_api


subroutine get_result_gradient_api(verror, vres, gradient) &
      & bind(C, name=namespace//"get_result_gradient")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: gradient(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_gradient"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%gradient)) then
      call fatal_error(error%ptr, "Result does not contain gradient")
      return
   end if

   gradient(:size(res%gradient)) = reshape(res%gradient, [size(res%gradient)])
end subroutine get_result_gradient_api


subroutine get_result_virial_api(verror, vres, sigma) &
      & bind(C, name=namespace//"get_result_virial")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: sigma(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_virial"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%sigma)) then
      call fatal_error(error%ptr, "Result does not contain virial")
      return
   end if

   sigma(:size(res%sigma)) = reshape(res%sigma, [size(res%sigma)])
end subroutine get_result_virial_api


subroutine get_result_charges_api(verror, vres, charges) &
      & bind(C, name=namespace//"get_result_charges")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: charges(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_charges"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain atomic charges")
      return
   end if

   charges(:size(res%wfn%qat, 1)) = res%wfn%qat(:, 1)
end subroutine get_result_charges_api


subroutine get_result_dipole_api(verror, vres, dipole) &
      & bind(C, name=namespace//"get_result_dipole")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(wp), allocatable :: dipm(:)
   real(c_double), intent(out) :: dipole(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_dipole"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%results)) then
      call fatal_error(error%ptr, "Result does not contain dipole moment")
      return
   end if
   call res%results%dict%get_entry("molecular-dipole", dipm)

   if (.not.allocated(dipm)) then
      call fatal_error(error%ptr, "Result does not contain dipole moment")
      return
   end if

   dipole(:size(dipm)) = dipm
end subroutine get_result_dipole_api


subroutine get_result_quadrupole_api(verror, vres, quadrupole) &
      & bind(C, name=namespace//"get_result_quadrupole")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(wp), allocatable :: qp(:)
   real(c_double), intent(out) :: quadrupole(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_quadrupole"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%results)) then
      call fatal_error(error%ptr, "Result does not contain dipole moment")
      return
   end if

   call res%results%dict%get_entry("molecular-quadrupole", qp)

   if (.not.allocated(qp)) then
      call fatal_error(error%ptr, "Result does not contain quadrupole moment")
      return
   end if

   quadrupole(:size(qp)) = qp
end subroutine get_result_quadrupole_api


subroutine get_result_orbital_energies_api(verror, vres, emo) &
      & bind(C, name=namespace//"get_result_orbital_energies")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: emo(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_orbital_energies"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain orbital energies")
      return
   end if

   emo(:size(res%wfn%emo)) = reshape(res%wfn%emo, [size(res%wfn%emo)])
end subroutine get_result_orbital_energies_api


subroutine get_result_orbital_occupations_api(verror, vres, occ) &
      & bind(C, name=namespace//"get_result_orbital_occupations")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: occ(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_orbital_occupations"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain orbital occupations")
      return
   end if

   occ(:size(res%wfn%focc)) = reshape(res%wfn%focc, [size(res%wfn%focc)])
end subroutine get_result_orbital_occupations_api


subroutine get_result_orbital_coefficients_api(verror, vres, cmo) &
      & bind(C, name=namespace//"get_result_orbital_coefficients")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: cmo(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_orbital_coefficients"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain orbital coefficients")
      return
   end if

   cmo(:size(res%wfn%coeff)) = reshape(res%wfn%coeff, [size(res%wfn%coeff)])
end subroutine get_result_orbital_coefficients_api


subroutine get_result_density_matrix_api(verror, vres, pmat) &
      & bind(C, name=namespace//"get_result_density_matrix")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: pmat(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_density_matrix"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain density matrix")
      return
   end if

   pmat(:size(res%wfn%density)) = reshape(res%wfn%density, [size(res%wfn%density)])
end subroutine get_result_density_matrix_api


subroutine get_result_overlap_matrix_api(verror, vres, smat) &
      & bind(C, name=namespace//"get_result_overlap_matrix")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: smat(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_overlap_matrix"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%results)) then
      call fatal_error(error%ptr, "Result does not contain overlap matrix")
      return
   end if

   if (.not.allocated(res%results%overlap)) then
      call fatal_error(error%ptr, "Result does not contain overlap matrix")
      return
   end if

   smat(:size(res%results%overlap)) = &
      & reshape(res%results%overlap, [size(res%results%overlap)])
end subroutine get_result_overlap_matrix_api


subroutine get_result_hamiltonian_matrix_api(verror, vres, hmat) &
      & bind(C, name=namespace//"get_result_hamiltonian_matrix")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: hmat(*)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_hamiltonian_matrix"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%results)) then
      call fatal_error(error%ptr, "Result does not contain Hamiltonian matrix")
      return
   end if

   if (.not.allocated(res%results%hamiltonian)) then
      call fatal_error(error%ptr, "Result does not contain Hamiltonian matrix")
      return
   end if

   hmat(:size(res%results%hamiltonian)) = &
      & reshape(res%results%hamiltonian, [size(res%results%hamiltonian)])
end subroutine get_result_hamiltonian_matrix_api


subroutine get_result_bond_orders_api(verror, vres, mbo) &
      & bind(C, name=namespace//"get_result_bond_orders")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   real(c_double), intent(out) :: mbo(*)
   real(kind=wp), allocatable :: mbo_f(:, :, :)
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "get_result_bond_orders"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%results)) then
      call fatal_error(error%ptr, "Result does not contain bond orders")
      return
   end if

   call res%results%dict%get_entry("bond-orders", mbo_f)

   if (.not.allocated(mbo_f)) then
      call fatal_error(error%ptr, "Could not find bond orders in results dictionary")
      return
   end if

   mbo(:size(mbo_f)) = &
      & reshape(mbo_f, [size(mbo_f)])
end subroutine get_result_bond_orders_api

function get_post_processing_dict_api(verror, vres) result(vdict) &
   & bind(C, name=namespace//"get_post_processing_dict")
type(c_ptr), value :: verror
type(vp_error), pointer :: error
type(c_ptr), value :: vres
type(vp_result), pointer :: res
type(c_ptr) :: vdict
logical :: ok
type(vp_double_dictionary), pointer :: dict

if (debug) print '("[Info]", 1x, a)', "get_result_dict"
vdict = c_null_ptr
call get_result(verror, vres, error, res, ok)
if (.not.ok) return

if (.not.allocated(res%results)) then
   call fatal_error(error%ptr, "Result does not contain post processing dictionary.")
   return
end if
allocate(dict)
dict%ptr = res%results%dict

vdict = c_loc(dict)
end function get_post_processing_dict_api

subroutine save_result_wavefunction_api(verror, vres, cfilename) &
      & bind(C, name=namespace//"save_result_wavefunction")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   character(len=1, kind=c_char), intent(in) :: cfilename(*)
   character(len=:), allocatable :: filename
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "save_result_wavefunction"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      call fatal_error(error%ptr, "Result does not contain wavefunction")
      return
   end if

   call c_f_character(cfilename, filename)
   call save_wavefunction(res%wfn, filename, error%ptr)
end subroutine save_result_wavefunction_api

subroutine load_result_wavefunction_api(verror, vres, cfilename) &
      & bind(C, name=namespace//"load_result_wavefunction")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   type(c_ptr), value :: vres
   type(vp_result), pointer :: res
   character(len=1, kind=c_char), intent(in) :: cfilename(*)
   character(len=:), allocatable :: filename
   logical :: ok

   if (debug) print '("[Info]", 1x, a)', "load_result_wavefunction"

   call get_result(verror, vres, error, res, ok)
   if (.not.ok) return

   if (.not.allocated(res%wfn)) then
      allocate(res%wfn)
   end if

   call c_f_character(cfilename, filename)
   call load_wavefunction(res%wfn, filename, error%ptr)
end subroutine load_result_wavefunction_api

subroutine get_result(verror, vres, error, res, ok)
   type(c_ptr), intent(in) :: verror
   type(c_ptr), intent(in) :: vres
   type(vp_error), pointer, intent(out) :: error
   type(vp_result), pointer, intent(out) :: res
   logical, intent(out) :: ok

   ok = .false.
   if (.not.c_associated(verror)) return
   call c_f_pointer(verror, error)

   if (.not.c_associated(vres)) then
      call fatal_error(error%ptr, "Result container is missing")
      return
   end if
   call c_f_pointer(vres, res)
   ok = .true.
end subroutine get_result


end module tblite_api_result

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_write
   use mctc_env_error, only : error_type, fatal_error
   use mctc_io_filetype, only : filetype, get_filetype
   use mctc_io_write_aims, only : write_aims
   use mctc_io_write_cjson, only : write_cjson
   use mctc_io_write_ctfile, only : write_molfile, write_sdf
   use mctc_io_write_gaussian, only : write_gaussian_external
   use mctc_io_write_genformat, only : write_genformat
   use mctc_io_write_pdb, only : write_pdb
   use mctc_io_write_pymatgen, only : write_pymatgen
   use mctc_io_write_qchem, only : write_qchem
   use mctc_io_write_qcschema, only : write_qcschema
   use mctc_io_write_turbomole, only : write_coord
   use mctc_io_write_vasp, only : write_vasp
   use mctc_io_write_xyz, only : write_xyz
   use mctc_io_structure, only : structure_type, new_structure
   implicit none
   private

   public :: write_structure


   interface write_structure
      module procedure :: write_structure_to_file
      module procedure :: write_structure_to_unit
   end interface write_structure


contains


subroutine write_structure_to_file(self, file, error, format)

   !> Instance of the molecular structure data
   class(structure_type), intent(in) :: self

   !> Name of the file to read
   character(len=*), intent(in) :: file

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> File type format hint
   integer, intent(in), optional :: format

   integer :: unit, ftype, stat

   open(file=file, newunit=unit, iostat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Cannot open '"//file//"'")
      return
   end if

   if (present(format)) then
      ftype = format
   else
      ftype = get_filetype(file)
   end if

   ! Unknown file type is unacceptable in this situation,
   ! try to figure at least something out
   if (ftype == filetype%unknown) then
      if (any(self%periodic)) then
         ftype = filetype%vasp
      else if (allocated(self%sdf)) then
         ftype = filetype%sdf
      else if (allocated(self%pdb)) then
         ftype = filetype%pdb
      else
         ftype = filetype%xyz
      end if
   end if

   call write_structure(self, unit, ftype, error)
   close(unit)

end subroutine write_structure_to_file


subroutine write_structure_to_unit(self, unit, ftype, error)

   !> Instance of the molecular structure data
   class(structure_type), intent(in) :: self

   !> File handle
   integer, intent(in) :: unit

   !> File type to read
   integer, intent(in) :: ftype

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   select case(ftype)
   case default
      call fatal_error(error, "Cannot write unknown file format")

   case(filetype%xyz)
      call write_xyz(self, unit)

   case(filetype%molfile)
      call write_molfile(self, unit)

   case(filetype%pdb)
      call write_pdb(self, unit)

   case(filetype%pymatgen)
      call write_pymatgen(self, unit)

   case(filetype%gen)
      call write_genformat(self, unit)

   case(filetype%sdf)
      call write_sdf(self, unit)

   case(filetype%vasp)
      call write_vasp(self, unit)

   case(filetype%tmol)
      call write_coord(self, unit)

   case(filetype%gaussian)
      call write_gaussian_external(self, unit)

   case(filetype%cjson)
      call write_cjson(self, unit)

   case(filetype%qcschema, filetype%json)
      call write_qcschema(self, unit)

   case(filetype%aims)
      call write_aims(self, unit)

   case(filetype%qchem)
      call write_qchem(self, unit)

   end select

end subroutine write_structure_to_unit


end module mctc_io_write

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/lapack/getrf.f90
!> Provides wrappers for LU factorization routines

!> Wrapper rountines for LU factorization
module tblite_lapack_getrf
   use mctc_env, only : sp, dp
   implicit none
   private

   public :: wrap_getrf


   !> Computes an LU factorization of a general M-by-N matrix A
   !> using partial pivoting with row interchanges.
   !>
   !> The factorization has the form
   !>    A = P * L * U
   !> where P is a permutation matrix, L is lower triangular with unit
   !> diagonal elements (lower trapezoidal if m > n), and U is upper
   !> triangular (upper trapezoidal if m < n).
   interface wrap_getrf
      module procedure :: wrap_sgetrf
      module procedure :: wrap_dgetrf
   end interface wrap_getrf


   !> Computes an LU factorization of a general M-by-N matrix A
   !> using partial pivoting with row interchanges.
   !>
   !> The factorization has the form
   !>    A = P * L * U
   !> where P is a permutation matrix, L is lower triangular with unit
   !> diagonal elements (lower trapezoidal if m > n), and U is upper
   !> triangular (upper trapezoidal if m < n).
   interface lapack_getrf
      pure subroutine sgetrf(m, n, a, lda, ipiv, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine sgetrf
      pure subroutine dgetrf(m, n, a, lda, ipiv, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dgetrf
   end interface lapack_getrf

contains

subroutine wrap_sgetrf(amat, ipiv, info)
   real(sp), intent(inout) :: amat(:, :)
   integer, intent(out) :: ipiv(:)
   integer, intent(out) :: info
   integer :: m, n, lda
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
   call lapack_getrf(m, n, amat, lda, ipiv, info)
end subroutine wrap_sgetrf


subroutine wrap_dgetrf(amat, ipiv, info)
   real(dp), intent(inout) :: amat(:, :)
   integer, intent(out) :: ipiv(:)
   integer, intent(out) :: info
   integer :: m, n, lda
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
   call lapack_getrf(m, n, amat, lda, ipiv, info)
end subroutine wrap_dgetrf

end module tblite_lapack_getrf

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/param/repulsion.f90
!> Provides a module for the repulsion interactions

!> Definition of the repulsion interactions
module tblite_param_repulsion
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_param_serde, only : serde_record
   use tblite_toml, only : toml_table, get_value, set_value, add_table
   implicit none
   private

   public :: count


   character(len=*), parameter :: k_effective = "effective", k_kexp = "kexp", &
      & k_klight = "klight"

   !> Parametrization records describing the repulsion interactions
   type, public, extends(serde_record) :: repulsion_record
      real(wp) :: kexp
      real(wp) :: klight
   contains
      generic :: load => load_from_array
      generic :: dump => dump_to_array
      !> Read parametrization data from TOML data structure
      procedure :: load_from_toml
      !> Write parametrization data to TOML data structure
      procedure :: dump_to_toml
      !> Read parametrization data from parameter array
      procedure, private :: load_from_array
      !> Write parametrization data to parameter array
      procedure, private :: dump_to_array
   end type


   !> Provides a mask for the repulsion model
   type, public :: repulsion_mask
   end type repulsion_mask


   interface count
      module procedure :: count_mask
   end interface count


contains


!> Read parametrization data from TOML data structure
subroutine load_from_toml(self, table, error)
   !> Instance of the parametrization data
   class(repulsion_record), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child
   integer :: stat

   call get_value(table, k_effective, child, requested=.false.)
   if (.not.associated(child)) then
      call fatal_error(error, "No entry for effective repulsion found")
      return
   end if

   call get_value(child, k_kexp, self%kexp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for repulsion exponent")
      return
   end if

   call get_value(child, k_klight, self%klight, self%kexp, stat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Invalid entry for light-atom repulsion exponent")
      return
   end if
end subroutine load_from_toml


!> Write parametrization data to TOML datastructure
subroutine dump_to_toml(self, table, error)
   !> Instance of the parametrization data
   class(repulsion_record), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), pointer :: child

   call add_table(table, k_effective, child)
   call set_value(child, k_kexp, self%kexp)
   if (abs(self%kexp - self%klight) > epsilon(self%kexp)) then
      call set_value(child, k_klight, self%klight)
   end if

end subroutine dump_to_toml


!> Read parametrization data from parameter array
subroutine load_from_array(self, array, offset, base, mask, error)
   class(repulsion_record), intent(inout) :: self
   real(wp), intent(in) :: array(:)
   integer, intent(inout) :: offset
   type(repulsion_record), intent(in) :: base
   type(repulsion_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

   select type(self)
   type is (repulsion_record)
      self = base
   end select

end subroutine load_from_array

!> Write parametrization data to parameter array
subroutine dump_to_array(self, array, offset, mask, error)
   class(repulsion_record), intent(in) :: self
   real(wp), intent(inout) :: array(:)
   integer, intent(inout) :: offset
   type(repulsion_mask), intent(in) :: mask
   type(error_type), allocatable, intent(out) :: error

end subroutine dump_to_array

elemental function count_mask(mask) result(ncount)
   type(repulsion_mask), intent(in) :: mask
   integer :: ncount
   ncount = 0
end function count_mask


end module tblite_param_repulsion

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/context/terminal.f90
!> Provides a terminal class to safely use ANSI escape sequences

!> Support for ANSI escape sequences to get colorful terminal output
module tblite_context_terminal
   use mctc_env, only : i1
   implicit none
   private

   public :: escape, operator(+), operator(//)

   !> Container for terminal escape code
   type :: color
      !> Style descriptor
      integer(i1) :: style = -1_i1
      !> Background color descriptor
      integer(i1) :: bg = -1_i1
      !> Foreground color descriptor
      integer(i1) :: fg = -1_i1
   end type

   interface operator(+)
      module procedure :: add
   end interface operator(+)

   interface operator(//)
      module procedure :: concat_left
      module procedure :: concat_right
   end interface operator(//)

   type(color), parameter :: &
      reset = color(style=0_i1), &
      bold = color(style=1_i1), &
      dim = color(style=2_i1), &
      italic = color(style=3_i1), &
      underline = color(style=4_i1), &
      blink = color(style=5_i1), &
      reverse = color(style=7_i1), &
      hidden = color(style=8_i1)

   type(color), parameter :: &
      black = color(fg=0_i1), &
      red = color(fg=1_i1), &
      green = color(fg=2_i1), &
      yellow = color(fg=3_i1), &
      blue = color(fg=4_i1), &
      magenta = color(fg=5_i1), &
      cyan = color(fg=6_i1), &
      white = color(fg=7_i1)

   type(color), parameter :: &
      bg_black = color(bg=0_i1), &
      bg_red = color(bg=1_i1), &
      bg_green = color(bg=2_i1), &
      bg_yellow = color(bg=3_i1), &
      bg_blue = color(bg=4_i1), &
      bg_magenta = color(bg=5_i1), &
      bg_cyan = color(bg=6_i1), &
      bg_white = color(bg=7_i1)


   !> Colorizer class for handling colorful output in the terminal
   type, public :: context_terminal

      type(color) :: &
         reset = color(), &
         bold = color(), &
         dim = color(), &
         italic = color(), &
         underline = color(), &
         blink = color(), &
         reverse = color(), &
         hidden = color()

      type(color) :: &
         black = color(), &
         red = color(), &
         green = color(), &
         yellow = color(), &
         blue = color(), &
         magenta = color(), &
         cyan = color(), &
         white = color()

      type(color) :: &
         bg_black = color(), &
         bg_red = color(), &
         bg_green = color(), &
         bg_yellow = color(), &
         bg_blue = color(), &
         bg_magenta = color(), &
         bg_cyan = color(), &
         bg_white = color()

      type(color) :: &
         bold_black = color(), &
         bold_red = color(), &
         bold_green = color(), &
         bold_yellow = color(), &
         bold_blue = color(), &
         bold_magenta = color(), &
         bold_cyan = color(), &
         bold_white = color()
   end type context_terminal

   !> Constructor for the colorizer
   interface context_terminal
      module procedure :: new_terminal
   end interface context_terminal

contains


!> Create a new colorizer object
function new_terminal(use_color) result(new)
   !> Enable color output
   logical, intent(in) :: use_color
   !> New instance of the colorizer
   type(context_terminal) :: new

   if (use_color) then
      new%reset = reset
      new%bold = bold
      new%dim = dim
      new%italic = italic
      new%underline = underline
      new%blink = blink
      new%reverse = reverse
      new%hidden = hidden
      new%black = black
      new%red = red
      new%green = green
      new%yellow = yellow
      new%blue = blue
      new%magenta = magenta
      new%cyan = cyan
      new%white = white
      new%bg_black = bg_black
      new%bg_red = bg_red
      new%bg_green = bg_green
      new%bg_yellow = bg_yellow
      new%bg_blue = bg_blue
      new%bg_magenta = bg_magenta
      new%bg_cyan = bg_cyan
      new%bg_white = bg_white
      new%bold_black = bold + black
      new%bold_red = bold + red
      new%bold_green = bold + green
      new%bold_yellow = bold + yellow
      new%bold_blue = bold + blue
      new%bold_magenta = bold + magenta
      new%bold_cyan = bold + cyan
      new%bold_white = bold + white
   end if
end function new_terminal

!> Add two escape sequences, attributes in the right value override the left value ones.
pure function add(lval, rval) result(code)
   !> First escape code
   type(color), intent(in) :: lval
   !> Second escape code
   type(color), intent(in) :: rval
   !> Combined escape code
   type(color) :: code

   code = color( &
      style=merge(rval%style, lval%style, rval%style >= 0), &
      fg=merge(rval%fg, lval%fg, rval%fg >= 0), &
      bg=merge(rval%bg, lval%bg, rval%bg >= 0))
end function add

!> Concatenate an escape code with a string and turn it into an actual escape sequence
pure function concat_left(lval, code) result(str)
   !> String to add the escape code to
   character(len=*), intent(in) :: lval
   !> Escape sequence
   type(color), intent(in) :: code
   !> Concatenated string
   character(len=:), allocatable :: str

   str = lval // escape(code)
end function concat_left

!> Concatenate an escape code with a string and turn it into an actual escape sequence
pure function concat_right(code, rval) result(str)
   !> String to add the escape code to
   character(len=*), intent(in) :: rval
   !> Escape sequence
   type(color), intent(in) :: code
   !> Concatenated string
   character(len=:), allocatable :: str

   str = escape(code) // rval
end function concat_right

!> Transform a color code into an actual ANSI escape sequence
pure function escape(code) result(str)
   !> Color code to be used
   type(color), intent(in) :: code
   !> ANSI escape sequence representing the color code
   character(len=:), allocatable :: str
   character, parameter :: chars(0:9) = &
      ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]

   if (anycolor(code)) then
      str = achar(27) // "[0"  ! Always reset the style
      if (code%style > 0 .and. code%style < 10) str = str // ";" // chars(code%style)
      if (code%fg >= 0 .and. code%fg < 10) str = str // ";3" // chars(code%fg)
      if (code%bg >= 0 .and. code%bg < 10) str = str // ";4" // chars(code%bg)
      str = str // "m"
   else
      str = ""
   end if
end function escape

!> Check whether the code describes any color or is just a stub
pure function anycolor(code)
   !> Escape sequence
   type(color), intent(in) :: code
   !> Any color / style is active
   logical :: anycolor

   anycolor = code%fg >= 0 .or. code%bg >= 0 .or. code%style >= 0
end function anycolor

end module tblite_context_terminal

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/api/error.f90
!> Provides API exports for the #tblite_error handle.

!> API export for error handling
module tblite_api_error
   use, intrinsic :: iso_c_binding
   use mctc_env, only : error_type, fatal_error
   use tblite_api_version, only : namespace
   use tblite_api_utils, only : f_c_character, c_f_character
   implicit none
   private

   public :: vp_error
   public :: new_error_api, check_error_api, clear_error_api, get_error_api, delete_error_api


   !> Void pointer to error handle
   type :: vp_error
      !> Actual payload
      type(error_type), allocatable :: ptr
   end type vp_error


   logical, parameter :: debug = .false.


contains


!> Create new error handle object
function new_error_api() &
      & result(verror) &
      & bind(C, name=namespace//"new_error")
   type(vp_error), pointer :: error
   type(c_ptr) :: verror

   if (debug) print '("[Info]", 1x, a)', "new_error"

   allocate(error)
   verror = c_loc(error)

end function new_error_api


!> Delete error handle object
subroutine delete_error_api(verror) &
      & bind(C, name=namespace//"delete_error")
   type(c_ptr), intent(inout) :: verror
   type(vp_error), pointer :: error

   if (debug) print '("[Info]", 1x, a)', "delete_error"

   if (c_associated(verror)) then
      call c_f_pointer(verror, error)

      deallocate(error)
      verror = c_null_ptr
   end if

end subroutine delete_error_api


!> Check error handle status
function check_error_api(verror) result(status) &
      & bind(C, name=namespace//"check_error")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   integer(c_int) :: status

   if (debug) print '("[Info]", 1x, a)', "check_error"

   if (c_associated(verror)) then
      call c_f_pointer(verror, error)

      if (allocated(error%ptr)) then
         status = 1
      else
         status = 0
      end if
   else
      status = 2
   end if

end function check_error_api


!> Clear error from handle
subroutine clear_error_api(verror) &
      & bind(C, name=namespace//"clear_error")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error

   if (debug) print '("[Info]", 1x, a)', "clear_error"

   if (c_associated(verror)) then
      call c_f_pointer(verror, error)

      if (allocated(error%ptr)) then
         deallocate(error%ptr)
      end if
   end if

end subroutine clear_error_api


!> Get error message from error handle
subroutine get_error_api(verror, charptr, buffersize) &
      & bind(C, name=namespace//"get_error")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   character(kind=c_char), intent(inout) :: charptr(*)
   integer(c_int), intent(in), optional :: buffersize
   integer :: max_length

   if (debug) print '("[Info]", 1x, a)', "get_error"

   if (c_associated(verror)) then
      call c_f_pointer(verror, error)

      if (present(buffersize)) then
         max_length = buffersize
      else
         max_length = huge(max_length) - 2
      end if

      if (allocated(error%ptr)) then
         call f_c_character(error%ptr%message, charptr, max_length)
      end if
   end if

end subroutine get_error_api


!> Set error message to error handle
subroutine set_error_api(verror, charptr, nchars) &
      & bind(C, name=namespace//"set_error")
   type(c_ptr), value :: verror
   type(vp_error), pointer :: error
   character(kind=c_char), intent(in) :: charptr(*)
   integer(c_int), intent(in), optional :: nchars
   character(len=:), allocatable :: message

   if (debug) print '("[Info]", 1x, a)', "set_error"

   if (c_associated(verror)) then
      call c_f_pointer(verror, error)

      call c_f_character(charptr, message)
      call fatal_error(error%ptr, message)
   end if

end subroutine set_error_api


end module tblite_api_error

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file tests/test_bessel.f90
!! Test of Bessel functions of first kind and second kind with varying arguments
!!
!! @version 1.0.0
!! @author Abhinav Jha
!! @date 2022-03-28

program main
use ddx_harmonics
implicit none

!! lmax_final :Maximal number of spherical harmonics, 2^lmax
integer :: lmax_final = 6, lmax = 0, iter_lmax = 0, l = 0, istatus = 1
!! argument_counter : Final value of argument, 10^argument_counter
integer :: iter_arg = 1, argument_counter = 1
!! Arguments for Bessel function of first kind and second kind
real(dp) :: argument_SI = 0.0_dp , argument_SI_plus_h = 0.0_dp, argument_SI_minus_h = 0.0_dp
real(dp) :: argument_SK = 0.0_dp , argument_SK_plus_h = 0.0_dp, argument_SK_minus_h = 0.0_dp
!! Step size : 10^(-6)
!! relerr_SI : Relative error for Bessel function of first kind
!! relerr_SK : Relative error for Bessel function of second kind
real(dp) :: step_size = 1.0e-7_dp, relerr_SI = 0.0_dp, relerr_SK = 0.0_dp

real(dp), allocatable :: SI(:), DI(:), SK(:), DK(:)
real(dp), allocatable :: SI_plus_h(:), DI_plus_h(:), SK_plus_h(:), DK_plus_h(:)
real(dp), allocatable :: SI_minus_h(:), DI_minus_h(:), SK_minus_h(:), DK_minus_h(:)
real(dp), allocatable :: num_der_SI(:), num_der_SK(:)
real(dp) :: diff, reldiff
!! Temporary workspace
complex(dp), allocatable :: work(:)

real(dp), external :: dnrm2

!Loop over for different values of lmax
do iter_lmax = 1, lmax_final
  !Resetting the values to zero
  argument_SI = 0.0_dp
  argument_SI_plus_h = 0.0_dp
  argument_SI_minus_h = 0.0_dp

  argument_SK = 0.0_dp
  argument_SK_plus_h = 0.0_dp
  argument_SK_minus_h = 0.0_dp

  lmax = 0
  write(6,200) step_size
!
  !Loop over for different values of argument
  do iter_arg = -4, argument_counter
    !For Bessel function of first kind we only look at values less than 1,
    !because it acts on the inside of the sphere
    argument_SI = 10.0_dp**(iter_arg)
    argument_SI_plus_h = argument_SI + step_size
    argument_SI_minus_h = argument_SI - step_size
    !For Bessel function of second kind we only look at values greater than 1,
    !because it acts on the outside of the sphere
    argument_SK = 10.0_dp**(-iter_arg)
    argument_SK_plus_h = argument_SK + step_size
    argument_SK_minus_h = argument_SK - step_size

    !lmax = 2^n, n: 1,...,6
    lmax = 2**iter_lmax
    !Allocation of vectors
    allocate(SI(0:lmax), DI(0:lmax), SK(0:lmax), DK(0:lmax), &
       & SI_plus_h(0:lmax), DI_plus_h(0:lmax), &
       & SK_plus_h(0:lmax), DK_plus_h(0:lmax), &
       & SI_minus_h(0:lmax), DI_minus_h(0:lmax), &
       & SK_minus_h(0:lmax), DK_minus_h(0:lmax), &
       & num_der_SI(0:lmax), num_der_SK(0:lmax), &
       & work(max(2, lmax + 1)), stat=istatus)
    if ( istatus.ne.0 ) then
        write(*,*) 'Allocation failed !'
        stop
    endif
    SI         = 0.0_dp  
    DI         = 0.0_dp  
    SK         = 0.0_dp  
    DK         = 0.0_dp  
    SI_plus_h  = 0.0_dp
    SI_minus_h = 0.0_dp
    DI_plus_h  = 0.0_dp
    DI_minus_h = 0.0_dp
    SK_plus_h  = 0.0_dp
    SK_minus_h = 0.0_dp
    DK_plus_h  = 0.0_dp
    DK_minus_h = 0.0_dp
    num_der_SI = 0.0_dp
    num_der_SK = 0.0_dp
!
    200 format(t3,'testing bessel functions derivatives against finite differences',/, &
               t3,'using a step size of ',d10.2,'.')
    210 format(t3,'lmax = ',i3,' argument of si = ',d10.2,' argument of sk = ',d10.2)

!   write(6,*) 'lmax        : ', lmax
!   write(6,*) 'argument_SI : ', argument_SI
!   write(6,*) 'argument_SK : ', argument_SK
!   write(6,*) 'h           : ', step_size
    !Calling at argument
    call modified_spherical_bessel_first_kind(lmax, &
                            & argument_SI, SI, DI, work)

    call modified_spherical_bessel_second_kind(lmax, &
                            & argument_SK, SK, DK, work)

    !Calling at argument + h
    call modified_spherical_bessel_first_kind(lmax, &
                            & argument_SI_plus_h, SI_plus_h, DI_plus_h, work)

    call modified_spherical_bessel_second_kind(lmax, &
                            & argument_SK_plus_h, SK_plus_h, DK_plus_h, work)

    !Calling at argument - h
    call modified_spherical_bessel_first_kind(lmax, &
                            & argument_SI_minus_h, SI_minus_h, DI_minus_h, work)

    call modified_spherical_bessel_second_kind(lmax, &
                            & argument_SK_minus_h, SK_minus_h, DK_minus_h, work)

    !Compute central difference numerical derivatives
    do l = 0, lmax
      num_der_SI(l) = (SI_plus_h(l)-SI_minus_h(l))/step_size/2.0_dp

      num_der_SK(l) = (SK_plus_h(l)-SK_minus_h(l))/step_size/2.0_dp
    end do

    write(6,210) lmax, argument_SI, argument_SK
    write(6,*)
    !Output the derivatives
    write(6,*) '   l  ', 'Analytical Derivatives (SI)', ' Numerical Derivatives'
    100 format(t3,i3,9x,d20.10,2x,d20.10)
    do l = 0, lmax
      write(6,100) l, DI(l), num_der_SI(l)
    end do
!

    write(6,*) '   l  ', 'Analytical Derivatives (SK)', ' Numerical Derivatives'
    do l = 0, lmax
      write(6,100) l, DK(l), num_der_SK(l)
    end do

    !Relative error
    relerr_SI = 0.0_dp
    relerr_SK = 0.0_dp
    do l = 0, lmax
      diff = abs(num_der_SI(l)-DI(l))
      if (diff.lt.epsilon(0.0_dp)) then
        reldiff = zero
      else if (abs(DI(l)).gt.epsilon(0.0_dp)) then
        reldiff = diff/abs(di(l))
      else
        reldiff = zero
      end if
      relerr_SI = max(relerr_SI,reldiff)
!     
      diff = abs(num_der_SK(l)-DK(l))
      if (diff.lt.epsilon(0.0_dp)) then
        reldiff = zero
      else if (abs(DK(l)).gt.epsilon(0.0_dp)) then
        reldiff = diff/abs(dk(l))
      else
        reldiff = zero
      end if
      relerr_SK = max(relerr_SK,reldiff)
    end do
    write(6,110) relerr_SI, relerr_SK
    110 format(t3,'largest relative error for  first kind funcitons: ',d14.6,/,&
               t3,'                           second kind functions: ',d14.6)
!   relerr_SI = dnrm2(lmax, num_der_SI - DI, 1) / dnrm2(lmax, DI, 1)
!   relerr_SK = dnrm2(lmax, num_der_SK - DK, 1) / dnrm2(lmax, DK, 1)
    if (relerr_SI .gt. 1d-4) then
        write(*,*) 'Error in Bessel function of first kind'
        write(6,*) relerr_SI
        stop 1
    endif
    if (relerr_SK .gt. 1d-4) then
        write(*,*) 'Error in Bessel function of second kind'
        write(6,*) relerr_SK
        stop 1
    endif
    write(6,*)
    deallocate(SI, DI, SK, DK, &
       & SI_plus_h, DI_plus_h, &
       & SK_plus_h, DK_plus_h, &
       & SI_minus_h, DI_minus_h, &
       & SK_minus_h, DK_minus_h, &
       & num_der_SI, num_der_SK, &
       & work)
  end do
end do

end program main

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

#ifndef TBLITE_HAS_DDX
#define TBLITE_HAS_DDX 0
#endif
#ifndef TBLITE_HAS_HDF5
#define TBLITE_HAS_HDF5 0
#endif
#ifndef TBLITE_HAS_TREXIO
#define TBLITE_HAS_TREXIO 0
#endif

!> @file tblite/features.f90
!> Provides version and feature information

!> Interfaces to query the version information of the library.
module tblite_features
   implicit none
   private

   public :: get_tblite_feature
   public :: tblite_use_ddx
   public :: tblite_use_hdf5
   public :: tblite_use_trexio


   !> Logical flag indicating if DDX solvation model support is available
   logical, parameter :: tblite_use_ddx = TBLITE_HAS_DDX /= 0
   !> Logical flag indicating if HDF5 support is available
   logical, parameter :: tblite_use_hdf5 = TBLITE_HAS_HDF5 /= 0
   !> Logical flag indicating if TREXIO support is available
   logical, parameter :: tblite_use_trexio = TBLITE_HAS_TREXIO /= 0


contains


!> Getter function to retrieve tblite version
pure function get_tblite_feature(flag) result(use_feature)
   character(len=*), intent(in) :: flag
   logical :: use_feature

   select case(flag)
   case("ddx")
      use_feature = tblite_use_ddx
   case("hdf5")
      use_feature = tblite_use_hdf5
   case("trexio")
      use_feature = tblite_use_trexio
   case default
      use_feature = .false.
   end select

end function get_tblite_feature


end module tblite_features

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_npz
   use mctc_env, only : dp, error_type, i2, i4
   use mctc_env_testing, only : new_unittest, unittest_type, check, &
      & test_failed
   use tblite_io_numpy, only : save_npz, load_npz
   use tblite_io_numpy_crc32, only : crc32_hash
   use tblite_output_format, only : format_string
   implicit none
   private

   public :: collect_npz

   ! zip file headers
   character(len=*), parameter :: local_header_start(*) = &
       &[char(int(z"50")), char(int(z"4b")), char(int(z"03")), char(int(z"04")), &
       & char(int(z"14")), char(0), char(0), char(0), char(0), char(0), &
       & char(0), char(0), char(0), char(0)]
   character(len=*), parameter :: global_header_start(*) = &
       &[char(int(z"50")), char(int(z"4b")), char(int(z"01")), char(int(z"02")), &
       & char(int(z"14")), char(0), local_header_start(5:)]
   character(len=*), parameter :: global_header_final(*) = &
      &[char(0), char(0), char(0), char(0), char(0), char(0), char(0), char(0), &
      & char(0), char(0), char(0), char(0), char(0), char(0)]
   character(len=*), parameter :: footer_start(*) = &
      &[char(int(z"50")), char(int(z"4b")), char(int(z"05")), char(int(z"06")), &
      & char(0), char(0), char(0), char(0), char(1), char(0), char(1), char(0)]

contains

subroutine collect_npz(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("write-npz-i4-r1", test_write_npz_i4_rank1), &
      new_unittest("write-npz-rdp-r1", test_write_npz_rdp_rank1), &
      new_unittest("write-npz-rdp-r2", test_write_npz_rdp_rank2), &
      new_unittest("write-npz-rdp-r3", test_write_npz_rdp_rank3), &
      new_unittest("write-npz-i4-rank1-multi", test_write_npz_i4_rank1_multi), &
      new_unittest("write-npz-rdp-rank1-multi", test_write_npz_rdp_rank1_multi), &
      new_unittest("write-npz-rdp-rank2-multi", test_write_npz_rdp_rank2_multi), &
      new_unittest("write-npz-rdp-rank3-multi", test_write_npz_rdp_rank3_multi), &
      new_unittest("read-npz-rdp-r1", test_read_npz_rdp_rank1), &
      new_unittest("read-npz-rdp-r2", test_read_npz_rdp_rank2), &
      new_unittest("read-npz-rdp-r3", test_read_npz_rdp_rank3), &
      new_unittest("read-npz-file-not-found", test_read_file_not_found, should_fail=.true.), &
      new_unittest("read-npz-checksum-mismatch", test_read_checksum_mismatch, should_fail=.true.), &
      new_unittest("write-npz-missing-global1", test_write_missing_global1, should_fail=.true.), &
      new_unittest("write-npz-missing-global2", test_write_missing_global2, should_fail=.true.), &
      new_unittest("write-npz-missing-footer1", test_write_missing_footer1, should_fail=.true.), &
      new_unittest("write-npz-missing-footer2", test_write_missing_footer2, should_fail=.true.), &
      new_unittest("write-npz-mismatch-header", test_write_mismatch_header, should_fail=.true.), &
      new_unittest("write-npz-mismatch-footer", test_write_mismatch_footer, should_fail=.true.), &
      new_unittest("crc32", test_crc32) &
   ]
end subroutine collect_npz

subroutine test_write_npz_i4_rank1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat, i
   character(len=*), parameter :: filename = ".write-i4-r1.npz", varname = "test"
   integer(i4), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(72))
   input = [(2*i, i=1, size(input))]
   call save_npz(filename, varname, input, stat, msg)

   call check(error, stat, "Writing of npz file failed", msg)
   if (allocated(error)) return

   call load_npz(filename, varname, output, stat, msg)
   call delete_file(filename)

   call check(error, stat, "Reading of npz file failed", msg)
   if (allocated(error)) return

   call check(error, size(output), size(input))
   if (allocated(error)) return

   call check(error, all((output - input) == 0), &
      "Precision loss when rereading array")
end subroutine test_write_npz_i4_rank1

subroutine test_write_npz_rdp_rank1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=*), parameter :: filename = ".write-rdp-r1.npz", varname = "test"
   real(dp), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(51))
   call random_number(input)
   call save_npz(filename, varname, input, stat)

   call check(error, stat, "Writing of npz file failed")
   if (allocated(error)) return

   call load_npz(filename, varname, output, stat, msg)
   call delete_file(filename)

   call check(error, stat, "Reading of npy file failed", msg)
   if (allocated(error)) return

   call check(error, size(output), size(input))
   if (allocated(error)) return

   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_write_npz_rdp_rank1

subroutine test_write_npz_rdp_rank2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=*), parameter :: filename = ".write-rdp-r2.npz", varname = "test"
   real(dp), allocatable :: input(:, :), output(:, :)
   character(len=:), allocatable :: msg

   allocate(input(13, 7))
   call random_number(input)
   call save_npz(filename, varname, input, stat, msg)

   call check(error, stat, "Writing of npz file failed", msg)
   if (allocated(error)) return

   call load_npz(filename, varname, output, stat, msg)
   call delete_file(filename)

   call check(error, stat, "Reading of npy file failed", msg)
   if (allocated(error)) return

   call check(error, size(output), size(input))
   if (allocated(error)) return

   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_write_npz_rdp_rank2

subroutine test_write_npz_rdp_rank3(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=*), parameter :: filename = ".write-rdp-r1.npz", varname = "test"
   real(dp), allocatable :: input(:, :, :), output(:, :, :)
   character(len=:), allocatable :: msg

   allocate(input(9, 2, 11))
   call random_number(input)
   call save_npz(filename, varname, input, stat, msg)

   call check(error, stat, "Writing of npz file failed", msg)
   if (allocated(error)) return

   call load_npz(filename, varname, output, stat, msg)
   call delete_file(filename)

   call check(error, stat, "Reading of npy file failed", msg)
   if (allocated(error)) return

   call check(error, size(output), size(input))
   if (allocated(error)) return

   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_write_npz_rdp_rank3

subroutine test_write_npz_i4_rank1_multi(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat, i
   character(len=*), parameter :: filename = ".mwrite-i4-r1.npz"
   integer(i4), allocatable :: input(:), output1(:), output2(:)
   character(len=:), allocatable :: msg

   allocate(input(93))
   input = [(i*(i-1), i=size(input), 1, -1)]
   call save_npz(filename, "array1", input, stat, msg)

   if (stat == 0) &
      call save_npz(filename, "arr2", input, stat, msg)

   call check(error, stat, "Writing of npz file failed", msg)
   if (allocated(error)) return

   call load_npz(filename, "array1", output1, stat, msg)
   if (stat == 0) &
      call load_npz(filename, "arr2", output2, stat, msg)
   call delete_file(filename)

   call check(error, stat, "Reading of npz file failed", msg)
   if (allocated(error)) return

   call check(error, size(output1), size(input))
   if (allocated(error)) return

   call check(error, size(output2), size(input))
   if (allocated(error)) return

   call check(error, all((output1 - input) == 0), &
      "Precision loss when rereading array")

   call check(error, all((output2 - input) == 0), &
      "Precision loss when rereading array")
end subroutine test_write_npz_i4_rank1_multi

subroutine test_write_npz_rdp_rank1_multi(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat, i
   character(len=*), parameter :: filename = ".mwrite-rdp-r1.npz"
   real(dp), allocatable :: input(:), output1(:), output2(:)
   character(len=:), allocatable :: msg

   allocate(input(66))
   call random_number(input)
   call save_npz(filename, "array1", input, stat, msg)

   if (stat == 0) &
      call save_npz(filename, "arr2", input, stat, msg)

   call check(error, stat, "Writing of npz file failed", msg)
   if (allocated(error)) return

   call load_npz(filename, "array1", output1, stat, msg)
   if (stat == 0) &
      call load_npz(filename, "arr2", output2, stat, msg)
   call delete_file(filename)

   call check(error, stat, "Reading of npz file failed", msg)
   if (allocated(error)) return

   call check(error, size(output1), size(input))
   if (allocated(error)) return

   call check(error, size(output2), size(input))
   if (allocated(error)) return

   call check(error, all(abs(output1 - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")

   call check(error, all(abs(output2 - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_write_npz_rdp_rank1_multi

subroutine test_write_npz_rdp_rank2_multi(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat, i
   character(len=*), parameter :: filename = ".mwrite-rdp-r2.npz"
   real(dp), allocatable :: input(:, :), output1(:, :), output2(:, :)
   character(len=:), allocatable :: msg

   allocate(input(19, 23))
   call random_number(input)
   call save_npz(filename, "array1", input, stat, msg)

   if (stat == 0) &
      call save_npz(filename, "arr2", input, stat, msg)

   call check(error, stat, "Writing of npz file failed", msg)
   if (allocated(error)) return

   call load_npz(filename, "array1", output1, stat, msg)
   if (stat == 0) &
      call load_npz(filename, "arr2", output2, stat, msg)
   call delete_file(filename)

   call check(error, stat, "Reading of npz file failed", msg)
   if (allocated(error)) return

   call check(error, size(output1), size(input))
   if (allocated(error)) return

   call check(error, size(output2), size(input))
   if (allocated(error)) return

   call check(error, all(abs(output1 - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")

   call check(error, all(abs(output2 - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_write_npz_rdp_rank2_multi

subroutine test_write_npz_rdp_rank3_multi(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat, i
   character(len=*), parameter :: filename = ".mwrite-rdp-r3.npz"
   real(dp), allocatable :: input(:, :, :), output1(:, :, :), output2(:, :, :)
   character(len=:), allocatable :: msg

   allocate(input(9, 10, 3))
   call random_number(input)
   call save_npz(filename, "array1", input, stat, msg)

   if (stat == 0) &
      call save_npz(filename, "arr2", input, stat, msg)

   call check(error, stat, "Writing of npz file failed", msg)
   if (allocated(error)) return

   call load_npz(filename, "array1", output1, stat, msg)
   if (stat == 0) &
      call load_npz(filename, "arr2", output2, stat, msg)
   call delete_file(filename)

   call check(error, stat, "Reading of npz file failed", msg)
   if (allocated(error)) return

   call check(error, size(output1), size(input))
   if (allocated(error)) return

   call check(error, size(output2), size(input))
   if (allocated(error)) return

   call check(error, all(abs(output1 - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")

   call check(error, all(abs(output2 - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_write_npz_rdp_rank3_multi

subroutine test_read_npz_rdp_rank1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr':'<f8', 'shape' : ( 61 ,  ) , 'fortran_order': False}         " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer, parameter :: vsize(*) = [61]

   character(len=*), parameter :: varname = "test", pathname = varname // ".npy"
   integer(i2), parameter :: path_size = len(pathname)
   integer(i4), parameter :: nbytes = len(header) + product(vsize) * 8
   integer(i4), parameter :: global_header_size = 46 + path_size
   integer(i4), parameter :: global_header_offset = 30 + path_size + nbytes

   integer :: io, stat
   character(len=*), parameter :: filename = ".read-rdp-r1.npz"
   integer(i4) :: crc_expected
   real(dp), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(vsize(1)))
   call random_number(input)

   crc_expected = crc32_hash(header)
   crc_expected = crc32_hash(input, crc_expected)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) local_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) pathname
   write(io) header
   write(io) input
   write(io) global_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) global_header_final
   write(io) pathname
   write(io) footer_start
   write(io) global_header_size , global_header_offset, 0_i2
   close(io)

   call load_npz(filename, varname, output, stat, msg)
   call delete_file(filename)

   call check(error, stat, "Reading of npz file failed", msg)
   if (allocated(error)) return

   call check(error, size(output), product(vsize))
   if (allocated(error)) return

   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_read_npz_rdp_rank1

subroutine test_read_npz_rdp_rank2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'shape' : (21 , 5 ) , 'fortran_order':True,  'descr':'<f8', }    " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer, parameter :: vsize(*) = [21, 5]

   character(len=*), parameter :: varname = "test", pathname = varname // ".npy"
   integer(i2), parameter :: path_size = len(pathname)
   integer(i4), parameter :: nbytes = len(header) + product(vsize) * 8
   integer(i4), parameter :: global_header_size = 46 + path_size
   integer(i4), parameter :: global_header_offset = 30 + path_size + nbytes

   integer :: io, stat
   character(len=*), parameter :: filename = ".read-rdp-r2.npz"
   integer(i4) :: crc_expected
   real(dp), allocatable :: input(:, :), output(:, :)
   character(len=:), allocatable :: msg

   allocate(input(vsize(1), vsize(2)))
   call random_number(input)

   crc_expected = crc32_hash(header)
   crc_expected = crc32_hash(reshape(input, [size(input)]), crc_expected)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) local_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) pathname
   write(io) header
   write(io) input
   write(io) global_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) global_header_final
   write(io) pathname
   write(io) footer_start
   write(io) global_header_size , global_header_offset, 0_i2
   close(io)

   call load_npz(filename, varname, output, stat, msg)
   call delete_file(filename)

   call check(error, stat, "Reading of npz file failed", msg)
   if (allocated(error)) return

   call check(error, size(output), product(vsize))
   if (allocated(error)) return

   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_read_npz_rdp_rank2

subroutine test_read_npz_rdp_rank3(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr': '<f8', 'fortran_order': True, 'shape': (3,7,4), }" // &
       repeat(char(int(z'20')), 59)// char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer, parameter :: vsize(*) = [3, 7, 4]

   character(len=*), parameter :: varname = "test", pathname = varname // ".npy"
   integer(i2), parameter :: path_size = len(pathname)
   integer(i4), parameter :: nbytes = len(header) + product(vsize) * 8
   integer(i4), parameter :: global_header_size = 46 + path_size
   integer(i4), parameter :: global_header_offset = 30 + path_size + nbytes

   integer :: io, stat
   character(len=*), parameter :: filename = ".read-rdp-r3.npz"
   integer(i4) :: crc_expected
   real(dp), allocatable :: input(:, :, :), output(:, :, :)
   character(len=:), allocatable :: msg

   allocate(input(vsize(1), vsize(2), vsize(3)))
   call random_number(input)

   crc_expected = crc32_hash(header)
   crc_expected = crc32_hash(reshape(input, [size(input)]), crc_expected)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) local_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) pathname
   write(io) header
   write(io) input
   write(io) global_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) global_header_final
   write(io) pathname
   write(io) footer_start
   write(io) global_header_size , global_header_offset, 0_i2
   close(io)

   call load_npz(filename, varname, output, stat, msg)
   call delete_file(filename)

   call check(error, stat, "Reading of npz file failed", msg)
   if (allocated(error)) return

   call check(error, size(output), product(vsize))
   if (allocated(error)) return

   call check(error, all(abs(output - input) <= epsilon(1.0_dp)), &
      "Precision loss when rereading array")
end subroutine test_read_npz_rdp_rank3

subroutine test_crc32(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_hash(error, crc32_hash("a", 0), int(z'e8b7be43'))
   if (allocated(error)) return
   call check_hash(error, crc32_hash(["a"], 0), int(z'e8b7be43'))
   if (allocated(error)) return
   call check_hash(error, crc32_hash([0.0_dp], 0), int(z'6522df69'))
   if (allocated(error)) return
   call check_hash(error, crc32_hash([1.1_dp], 0), int(z'ce0696c5'))
   if (allocated(error)) return
   call check_hash(error, crc32_hash([1.1_dp, 1.4_dp, -9.7_dp, 1.8e-23_dp, 3.5e12_dp], 0), int(z'e36ce8e0'))

contains
   subroutine check_hash(error, computed, expected)
      type(error_type), allocatable, intent(out) :: error
      integer(i4), intent(in) :: computed
      integer(i4), intent(in) :: expected

      if (computed /= expected) then
         call test_failed(error, "CRC32 hash mismatch, expected "//format_string(expected, '(z08)')//&
            & " got "//format_string(computed, '(z08)'))
      end if
   end subroutine check_hash
end subroutine test_crc32

subroutine test_read_file_not_found(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr':'<f8', 'shape' : ( 61 ,  ) , 'fortran_order': False}         " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer, parameter :: vsize(*) = [61]

   character(len=*), parameter :: varname = "test", pathname = varname // ".npy"
   integer(i2), parameter :: path_size = len(pathname)
   integer(i4), parameter :: nbytes = len(header) + product(vsize) * 8
   integer(i4), parameter :: global_header_size = 46 + path_size
   integer(i4), parameter :: global_header_offset = 30 + path_size + nbytes

   integer :: io, stat
   character(len=*), parameter :: filename = ".read-file-not-found.npz"
   integer(i4) :: crc_expected
   real(dp), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(vsize(1)))
   call random_number(input)

   crc_expected = crc32_hash(header)
   crc_expected = crc32_hash(input, crc_expected)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) local_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) pathname
   write(io) header
   write(io) input
   write(io) global_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) global_header_final
   write(io) pathname
   write(io) footer_start
   write(io) global_header_size , global_header_offset, 0_i2
   close(io)

   call load_npz(filename, "other_name", output, stat, msg)
   call delete_file(filename)

   if (stat /= 0) call test_failed(error, msg)
end subroutine test_read_file_not_found

subroutine test_read_checksum_mismatch(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr':'<f8', 'shape' : ( 61 ,  ) , 'fortran_order': False}         " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer, parameter :: vsize(*) = [61]

   character(len=*), parameter :: varname = "test", pathname = varname // ".npy"
   integer(i2), parameter :: path_size = len(pathname)
   integer(i4), parameter :: nbytes = len(header) + product(vsize) * 8
   integer(i4), parameter :: global_header_size = 46 + path_size
   integer(i4), parameter :: global_header_offset = 30 + path_size + nbytes

   integer :: io, stat
   character(len=*), parameter :: filename = ".read-checksum-mismatch.npz"
   integer(i4) :: crc_expected
   real(dp), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(vsize(1)))
   call random_number(input)

   crc_expected = -1

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) local_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) pathname
   write(io) header
   write(io) input
   write(io) global_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) global_header_final
   write(io) pathname
   write(io) footer_start
   write(io) global_header_size , global_header_offset, 0_i2
   close(io)

   call load_npz(filename, varname, output, stat, msg)
   call delete_file(filename)

   if (stat /= 0) call test_failed(error, msg)
end subroutine test_read_checksum_mismatch

subroutine test_write_missing_global1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr':'<f8', 'shape' : ( 61 ,  ) , 'fortran_order': False}         " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer, parameter :: vsize(*) = [61]

   character(len=*), parameter :: varname = "test", pathname = varname // ".npy"
   integer(i2), parameter :: path_size = len(pathname)
   integer(i4), parameter :: nbytes = len(header) + product(vsize) * 8
   integer(i4), parameter :: global_header_size = 46 + path_size
   integer(i4), parameter :: global_header_offset = 30 + path_size + nbytes

   integer :: io, stat
   character(len=*), parameter :: filename = ".write-missing-global1.npz"
   integer(i4) :: crc_expected
   real(dp), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(vsize(1)))
   call random_number(input)

   crc_expected = crc32_hash(header)
   crc_expected = crc32_hash(input, crc_expected)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) local_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) pathname
   write(io) header
   write(io) input
   close(io)

   call save_npz(filename, "other", input, stat, msg)
   call delete_file(filename)

   if (stat /= 0) call test_failed(error, msg)
end subroutine test_write_missing_global1

subroutine test_write_missing_global2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr':'<f8', 'shape' : ( 61 ,  ) , 'fortran_order': False}         " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer, parameter :: vsize(*) = [61]

   character(len=*), parameter :: varname = "test", pathname = varname // ".npy"
   integer(i2), parameter :: path_size = len(pathname)
   integer(i4), parameter :: nbytes = len(header) + product(vsize) * 8
   integer(i4), parameter :: global_header_size = 46 + path_size
   integer(i4), parameter :: global_header_offset = 30 + path_size + nbytes

   integer :: io, stat
   character(len=*), parameter :: filename = ".write-missing-global2.npz"
   integer(i4) :: crc_expected
   real(dp), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(vsize(1)))
   call random_number(input)

   crc_expected = crc32_hash(header)
   crc_expected = crc32_hash(input, crc_expected)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) local_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) pathname
   write(io) header
   write(io) input
   write(io) global_header_start(:4)
   close(io)

   call save_npz(filename, "other", input, stat, msg)
   call delete_file(filename)

   if (stat /= 0) call test_failed(error, msg)
end subroutine test_write_missing_global2

subroutine test_write_missing_footer1(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr':'<f8', 'shape' : ( 61 ,  ) , 'fortran_order': False}         " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer, parameter :: vsize(*) = [61]

   character(len=*), parameter :: varname = "test", pathname = varname // ".npy"
   integer(i2), parameter :: path_size = len(pathname)
   integer(i4), parameter :: nbytes = len(header) + product(vsize) * 8
   integer(i4), parameter :: global_header_size = 46 + path_size
   integer(i4), parameter :: global_header_offset = 30 + path_size + nbytes

   integer :: io, stat
   character(len=*), parameter :: filename = ".write-missing-footer1.npz"
   integer(i4) :: crc_expected
   real(dp), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(vsize(1)))
   call random_number(input)

   crc_expected = crc32_hash(header)
   crc_expected = crc32_hash(input, crc_expected)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) local_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) pathname
   write(io) header
   write(io) input
   write(io) global_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) global_header_final
   write(io) pathname
   close(io)

   call save_npz(filename, "other", input, stat, msg)
   call delete_file(filename)

   if (stat /= 0) call test_failed(error, msg)
end subroutine test_write_missing_footer1

subroutine test_write_missing_footer2(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr':'<f8', 'shape' : ( 61 ,  ) , 'fortran_order': False}         " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer, parameter :: vsize(*) = [61]

   character(len=*), parameter :: varname = "test", pathname = varname // ".npy"
   integer(i2), parameter :: path_size = len(pathname)
   integer(i4), parameter :: nbytes = len(header) + product(vsize) * 8
   integer(i4), parameter :: global_header_size = 46 + path_size
   integer(i4), parameter :: global_header_offset = 30 + path_size + nbytes

   integer :: io, stat
   character(len=*), parameter :: filename = ".write-missing-footer2.npz"
   integer(i4) :: crc_expected
   real(dp), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(vsize(1)))
   call random_number(input)

   crc_expected = crc32_hash(header)
   crc_expected = crc32_hash(input, crc_expected)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) local_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) pathname
   write(io) header
   write(io) input
   write(io) global_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) global_header_final
   write(io) pathname
   write(io) footer_start(:4)
   close(io)

   call save_npz(filename, "other", input, stat, msg)
   call delete_file(filename)

   if (stat /= 0) call test_failed(error, msg)
end subroutine test_write_missing_footer2

subroutine test_write_mismatch_header(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr':'<f8', 'shape' : ( 61 ,  ) , 'fortran_order': False}         " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer, parameter :: vsize(*) = [61]

   character(len=*), parameter :: varname = "test", pathname = varname // ".npy"
   integer(i2), parameter :: path_size = len(pathname)
   integer(i4), parameter :: nbytes = len(header) + product(vsize) * 8
   integer(i4), parameter :: global_header_size = 46 + path_size
   integer(i4), parameter :: global_header_offset = 30 + path_size + nbytes

   integer :: io, stat
   character(len=*), parameter :: filename = ".write-mismatch-header.npz"
   integer(i4) :: crc_expected
   real(dp), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(vsize(1)))
   call random_number(input)

   crc_expected = crc32_hash(header)
   crc_expected = crc32_hash(input, crc_expected)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) local_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) pathname
   write(io) header
   write(io) input
   write(io) footer_start
   close(io)

   call save_npz(filename, "other", input, stat, msg)
   call delete_file(filename)

   if (stat /= 0) call test_failed(error, msg)
end subroutine test_write_mismatch_header

subroutine test_write_mismatch_footer(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: dict = &
       "{'descr':'<f8', 'shape' : ( 61 ,  ) , 'fortran_order': False}         " //  &
       char(10)
   character(len=*), parameter :: header = &
       char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
       char(len(dict)) // char(0) // dict

   integer, parameter :: vsize(*) = [61]

   character(len=*), parameter :: varname = "test", pathname = varname // ".npy"
   integer(i2), parameter :: path_size = len(pathname)
   integer(i4), parameter :: nbytes = len(header) + product(vsize) * 8
   integer(i4), parameter :: global_header_size = 46 + path_size
   integer(i4), parameter :: global_header_offset = 30 + path_size + nbytes

   integer :: io, stat
   character(len=*), parameter :: filename = ".write-mismatch-footer.npz"
   integer(i4) :: crc_expected
   real(dp), allocatable :: input(:), output(:)
   character(len=:), allocatable :: msg

   allocate(input(vsize(1)))
   call random_number(input)

   crc_expected = crc32_hash(header)
   crc_expected = crc32_hash(input, crc_expected)

   open(newunit=io, file=filename, form="unformatted", access="stream")
   write(io) local_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) pathname
   write(io) header
   write(io) input
   write(io) global_header_start
   write(io) crc_expected, nbytes, nbytes, path_size, 0_i2
   write(io) global_header_final
   write(io) pathname
   write(io) local_header_start(:4)
   close(io)

   call save_npz(filename, "other", input, stat, msg)
   call delete_file(filename)

   if (stat /= 0) call test_failed(error, msg)
end subroutine test_write_mismatch_footer

subroutine delete_file(filename)
   character(len=*), intent(in) :: filename

   integer :: io

   open(newunit=io, file=filename)
   close(io, status="delete")
end subroutine delete_file

subroutine hexdump(filename)
   character(len=*), intent(in) :: filename

   integer :: io, stat, line, i
   logical :: skip
   character(len=1) :: chunk(16)
   character(len=*), parameter :: hex_format(16) = [&
      '(z0.8, 1x, 1(1x, z0.2),                  t61, "|",  1a, "|")', &
      '(z0.8, 1x, 2(1x, z0.2),                  t61, "|",  2a, "|")', &
      '(z0.8, 1x, 3(1x, z0.2),                  t61, "|",  3a, "|")', &
      '(z0.8, 1x, 4(1x, z0.2),                  t61, "|",  4a, "|")', &
      '(z0.8, 1x, 5(1x, z0.2),                  t61, "|",  5a, "|")', &
      '(z0.8, 1x, 6(1x, z0.2),                  t61, "|",  6a, "|")', &
      '(z0.8, 1x, 7(1x, z0.2),                  t61, "|",  7a, "|")', &
      '(z0.8, 1x, 8(1x, z0.2),                  t61, "|",  8a, "|")', &
      '(z0.8, 1x, 8(1x, z0.2), 1x, 1(1x, z0.2), t61, "|",  9a, "|")', &
      '(z0.8, 1x, 8(1x, z0.2), 1x, 2(1x, z0.2), t61, "|", 10a, "|")', &
      '(z0.8, 1x, 8(1x, z0.2), 1x, 3(1x, z0.2), t61, "|", 11a, "|")', &
      '(z0.8, 1x, 8(1x, z0.2), 1x, 4(1x, z0.2), t61, "|", 12a, "|")', &
      '(z0.8, 1x, 8(1x, z0.2), 1x, 5(1x, z0.2), t61, "|", 13a, "|")', &
      '(z0.8, 1x, 8(1x, z0.2), 1x, 6(1x, z0.2), t61, "|", 14a, "|")', &
      '(z0.8, 1x, 8(1x, z0.2), 1x, 7(1x, z0.2), t61, "|", 15a, "|")', &
      '(z0.8, 1x, 8(1x, z0.2), 1x, 8(1x, z0.2), t61, "|", 16a, "|")']

   print '(3a)', "Hexdump of file '", filename, "'"
   open(newunit=io, file=filename, form="unformatted", access="stream", status="old")
   line = 0
   skip = .false.
   read(io, iostat=stat) chunk
   do while(stat == 0)
      if (all(chunk == ' ')) then
         if (.not.skip) print '(A)', "*"
         skip = .true.
      else
         print hex_format(16), &
            & line, chunk, merge(chunk, '.', is_printable(chunk))
         skip = .false.
      end if
      line = line + 16
      read(io, pos=line + 1, iostat=stat) chunk
   end do
   do i = 1, 16
      read(io, pos=line + i, iostat=stat) chunk(i)
      if (stat /= 0) then
         print hex_format(i-1), &
            & line, chunk(:i-1), merge(chunk(:i-1), '.', is_printable(chunk(:i-1)))
         exit
      end if
   end do
   close(io)
end subroutine hexdump

elemental logical function is_printable(c)
   character(len=1), intent(in) :: c !! The character to test.
   integer :: ic
   ic = iachar(c)
   !The character is printable if it's between ' ' and '~' in the ASCII table
   is_printable = ic >= iachar(' ') .and. ic <= int(z'7E')
end function is_printable

end module test_npz

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @dir tblite/param/post_processing
!> Provides records for specific post-processing methods

!> @file tblite/param/post_processing.f90
!> Provides a list-type container to store various post-processing records

!> Proxy module for rexport and list-type post-processing record container
module tblite_param_post_processing
   use mctc_env, only : wp, error_type, fatal_error
   use tblite_param_serde, only : serde_record
   use tblite_toml, only : toml_table, toml_key
   use tblite_param_post_processing_molmom, only : molmom_record
   use tblite_param_post_processing_type, only : post_processing_record
   use tblite_param_post_processing_xtbml, only : xtbml_record
   implicit none
   private

   public :: post_processing_record_list, post_processing_record
   public :: molmom_record, xtbml_record

   !> Container for post-processing records
   type :: post_processing_record_container
      !> Actual post-processing record
      class(post_processing_record), allocatable :: record
   end type

   type :: post_processing_record_list
      !> List of post-processing records
      type(post_processing_record_container), allocatable :: list(:)
      !> Number of records in the list
      integer :: n = 0
   contains
      private
      generic, public :: load => load_from_toml
      generic, public :: dump => dump_to_toml
      procedure, public :: push
      procedure, public :: get_n_records
      procedure :: load_from_toml
      procedure :: dump_to_toml
   end type

contains

function get_n_records(self) result(n)
   !> List of all post-processing records
   class(post_processing_record_list), intent(in) :: self
   integer n
   n = self%n
end function

subroutine push(self, record)
   !> List of all post-processing records
   class(post_processing_record_list), intent(inout) :: self
   !> Post-processing record to be added to the list
   class(post_processing_record), allocatable, intent(inout) :: record

   if (.not.allocated(self%list)) call resize(self%list)
   if (self%n >= size(self%list)) then
      call resize(self%list)
   end if

   self%n = self%n + 1
   call move_alloc(record, self%list(self%n)%record)
end subroutine push

subroutine resize(list, n)
   !> Instance of the array to be resized
   type(post_processing_record_container), allocatable, intent(inout) :: list(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(post_processing_record_container), allocatable :: tmp(:)
   integer :: this_size, new_size, item
   integer, parameter :: initial_size = 20

   if (allocated(list)) then
      this_size = size(list, 1)
      call move_alloc(list, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(list(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(list, 1))
      do item = 1, this_size
         call move_alloc(tmp(item)%record, list(item)%record)
      end do
      deallocate(tmp)
   end if

end subroutine resize

subroutine dump_to_toml(self, table, error)
   !> List of all post-processing records
   class(post_processing_record_list), intent(in) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ii

   do ii = 1, self%get_n_records()
      associate(rec => self%list(ii)%record)
         call rec%dump(table, error)
      end associate
      if (allocated(error)) exit
   end do
   if (allocated(error)) return
end subroutine dump_to_toml

   !> Deserialize records from a table by iterating over all entries
subroutine load_from_toml(self, table, error)
   !> List of all post-processing records
   class(post_processing_record_list), intent(inout) :: self
   !> Data structure
   type(toml_table), intent(inout) :: table
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: ii
   type(toml_key), allocatable :: list(:)
   character(len=:), allocatable :: key
   call table%get_keys(list)
   do ii = 1, size(list)
      key = trim(adjustl(list(ii)%key))
      select case(key)
      case("molecular-multipole")
         block
            type(molmom_record), allocatable :: tmp_record
            class(post_processing_record), allocatable :: cont
            allocate(tmp_record)
            call tmp_record%load(table, error) 
            call move_alloc(tmp_record, cont)
            call self%push(cont)
         end block
      case("xtbml")
         block
            type(xtbml_record), allocatable :: tmp_record
            class(post_processing_record), allocatable :: cont
            allocate(tmp_record)
            call tmp_record%load(table, error) 
            call move_alloc(tmp_record, cont)
            call self%push(cont)
         end block
      case default
         return
      end select
   end do
   
   if (allocated(error)) return
end subroutine load_from_toml

end module tblite_param_post_processing

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Functions to build TOML tables
!>
!> The build module defines a high level interface to work with TOML tables
!> and construct them in a convenient way.
!>
!> The getter functions allow to both retrieve and set values, to easily
!> support default values when reading from a TOML data structure.
!> Using the getter function with a default value specified will request
!> the respective setter function to add it to the table if it was not
!> found in the first place.
!>
!> This allows to build a TOML table using only the getter functions, which
!> represents the finally read values for the applications.
!>
!> Note that neither setter nor getter functions can overwrite existing
!> TOML values for safety reasons, request the deletion on the respective
!> key from the TOML table and than set it. The deletion of a subtable or
!> array will recursively destroy the contained data nodes.
module tomlf_build_table
   use tomlf_build_keyval, only : get_value, set_value
   use tomlf_constants, only : tfc, tfi, tfr, tf_i1, tf_i2, tf_i4, tf_i8, &
      & tf_sp, tf_dp
   use tomlf_datetime, only : toml_datetime
   use tomlf_error, only : toml_stat
   use tomlf_type, only : toml_value, toml_table, toml_array, toml_keyval, &
      & new_table, new_array, new_keyval, add_table, add_array, add_keyval, &
      & toml_key, cast_to_table, cast_to_array, cast_to_keyval, initialized, &
      & len
   implicit none
   private

   public :: get_value, set_value


   !> Setter functions to manipulate TOML tables
   interface set_value
      module procedure :: set_child_value_float_sp
      module procedure :: set_child_value_float_dp
      module procedure :: set_child_value_integer_i1
      module procedure :: set_child_value_integer_i2
      module procedure :: set_child_value_integer_i4
      module procedure :: set_child_value_integer_i8
      module procedure :: set_child_value_bool
      module procedure :: set_child_value_datetime
      module procedure :: set_child_value_string
      module procedure :: set_key_value_float_sp
      module procedure :: set_key_value_float_dp
      module procedure :: set_key_value_integer_i1
      module procedure :: set_key_value_integer_i2
      module procedure :: set_key_value_integer_i4
      module procedure :: set_key_value_integer_i8
      module procedure :: set_key_value_bool
      module procedure :: set_key_value_datetime
      module procedure :: set_key_value_string
   end interface set_value


   !> Getter functions to manipulate TOML tables
   interface get_value
      module procedure :: get_child_table
      module procedure :: get_child_array
      module procedure :: get_child_keyval
      module procedure :: get_child_value_float_sp
      module procedure :: get_child_value_float_dp
      module procedure :: get_child_value_integer_i1
      module procedure :: get_child_value_integer_i2
      module procedure :: get_child_value_integer_i4
      module procedure :: get_child_value_integer_i8
      module procedure :: get_child_value_bool
      module procedure :: get_child_value_datetime
      module procedure :: get_child_value_string
      module procedure :: get_key_table
      module procedure :: get_key_array
      module procedure :: get_key_keyval
      module procedure :: get_key_value_float_sp
      module procedure :: get_key_value_float_dp
      module procedure :: get_key_value_integer_i1
      module procedure :: get_key_value_integer_i2
      module procedure :: get_key_value_integer_i4
      module procedure :: get_key_value_integer_i8
      module procedure :: get_key_value_bool
      module procedure :: get_key_value_datetime
      module procedure :: get_key_value_string
   end interface get_value


contains


subroutine get_key_table(table, key, ptr, requested, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Pointer to child table
   type(toml_table), pointer, intent(out) :: ptr

   !> Child value must be present
   logical, intent(in), optional :: requested

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call get_value(table, key%key, ptr, requested, stat, origin)

end subroutine get_key_table


subroutine get_key_array(table, key, ptr, requested, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Pointer to child array
   type(toml_array), pointer, intent(out) :: ptr

   !> Child value must be present
   logical, intent(in), optional :: requested

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call get_value(table, key%key, ptr, requested, stat, origin)

end subroutine get_key_array


subroutine get_key_keyval(table, key, ptr, requested, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Pointer to child value
   type(toml_keyval), pointer, intent(out) :: ptr

   !> Child value must be present
   logical, intent(in), optional :: requested

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call get_value(table, key%key, ptr, requested, stat, origin)

end subroutine get_key_keyval


!> Retrieve TOML value as single precision float (might lose accuracy)
subroutine get_key_value_float_sp(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Real value
   real(tf_sp), intent(out) :: val

   !> Default real value
   real(tf_sp), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call get_value(table, key%key, val, default, stat, origin)

end subroutine get_key_value_float_sp


!> Retrieve TOML value as double precision float
subroutine get_key_value_float_dp(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Real value
   real(tf_dp), intent(out) :: val

   !> Default real value
   real(tf_dp), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call get_value(table, key%key, val, default, stat, origin)

end subroutine get_key_value_float_dp


!> Retrieve TOML value as one byte integer (might loose precision)
subroutine get_key_value_integer_i1(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Integer value
   integer(tf_i1), intent(out) :: val

   !> Default integer value
   integer(tf_i1), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call get_value(table, key%key, val, default, stat, origin)

end subroutine get_key_value_integer_i1


!> Retrieve TOML value as two byte integer (might loose precision)
subroutine get_key_value_integer_i2(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Integer value
   integer(tf_i2), intent(out) :: val

   !> Default integer value
   integer(tf_i2), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call get_value(table, key%key, val, default, stat, origin)

end subroutine get_key_value_integer_i2


!> Retrieve TOML value as four byte integer (might loose precision)
subroutine get_key_value_integer_i4(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Integer value
   integer(tf_i4), intent(out) :: val

   !> Default integer value
   integer(tf_i4), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call get_value(table, key%key, val, default, stat, origin)

end subroutine get_key_value_integer_i4


!> Retrieve TOML value as eight byte integer
subroutine get_key_value_integer_i8(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Integer value
   integer(tf_i8), intent(out) :: val

   !> Default integer value
   integer(tf_i8), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call get_value(table, key%key, val, default, stat, origin)

end subroutine get_key_value_integer_i8


!> Retrieve TOML value as logical
subroutine get_key_value_bool(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Boolean value
   logical, intent(out) :: val

   !> Default boolean value
   logical, intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call get_value(table, key%key, val, default, stat, origin)

end subroutine get_key_value_bool


!> Retrieve TOML value as datetime
subroutine get_key_value_datetime(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Datetime value
   type(toml_datetime), intent(out) :: val

   !> Default datetime value
   type(toml_datetime), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call get_value(table, key%key, val, default, stat, origin)

end subroutine get_key_value_datetime


!> Retrieve TOML value as deferred-length character
subroutine get_key_value_string(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> String value
   character(kind=tfc, len=:), allocatable, intent(out) :: val

   !> Default string value
   character(kind=tfc, len=*), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call get_value(table, key%key, val, default, stat, origin)

end subroutine get_key_value_string


!> Set TOML value to single precision float
subroutine set_key_value_float_sp(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Real value
   real(tf_sp), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call set_value(table, key%key, val, stat, origin)

end subroutine set_key_value_float_sp


!> Set TOML value to double precision float
subroutine set_key_value_float_dp(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Real value
   real(tf_dp), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call set_value(table, key%key, val, stat, origin)

end subroutine set_key_value_float_dp


!> Set TOML value to one byte integer
subroutine set_key_value_integer_i1(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Integer value
   integer(tf_i1), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call set_value(table, key%key, val, stat, origin)

end subroutine set_key_value_integer_i1


!> Set TOML value to two byte integer
subroutine set_key_value_integer_i2(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Integer value
   integer(tf_i2), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call set_value(table, key%key, val, stat, origin)

end subroutine set_key_value_integer_i2


!> Set TOML value to four byte integer
subroutine set_key_value_integer_i4(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Integer value
   integer(tf_i4), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call set_value(table, key%key, val, stat, origin)

end subroutine set_key_value_integer_i4


!> Set TOML value to eight byte integer
subroutine set_key_value_integer_i8(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Integer value
   integer(tf_i8), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call set_value(table, key%key, val, stat, origin)

end subroutine set_key_value_integer_i8


!> Set TOML value to logical
subroutine set_key_value_bool(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Boolean value
   logical, intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call set_value(table, key%key, val, stat, origin)

end subroutine set_key_value_bool


!> Set TOML value to datetime
subroutine set_key_value_datetime(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> Datetime value
   type(toml_datetime), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call set_value(table, key%key, val, stat, origin)

end subroutine set_key_value_datetime


!> Set TOML value to deferred-length character
subroutine set_key_value_string(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   type(toml_key), intent(in) :: key

   !> String value
   character(kind=tfc, len=*), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   call set_value(table, key%key, val, stat, origin)

end subroutine set_key_value_string


subroutine get_child_table(table, key, ptr, requested, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Pointer to child table
   type(toml_table), pointer, intent(out) :: ptr

   !> Child value must be present
   logical, intent(in), optional :: requested

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   class(toml_value), pointer :: tmp
   logical :: is_requested

   if (.not.initialized(table)) call new_table(table)

   if (present(requested)) then
      is_requested = requested
   else
      is_requested = .true.
   end if

   nullify(ptr)

   call table%get(key, tmp)

   if (associated(tmp)) then
      ptr => cast_to_table(tmp)
      if (present(stat)) then
         if (associated(ptr)) then
            stat = toml_stat%success
         else
            stat = toml_stat%type_mismatch
         end if
      end if
      if (present(origin)) origin = tmp%origin
   else
      if (is_requested) then
         call add_table(table, key, ptr, stat)
      else
         if (present(stat)) stat = toml_stat%success
      end if
      if (present(origin)) origin = table%origin
   end if

end subroutine get_child_table


subroutine get_child_array(table, key, ptr, requested, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Pointer to child array
   type(toml_array), pointer, intent(out) :: ptr

   !> Child value must be present
   logical, intent(in), optional :: requested

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   class(toml_value), pointer :: tmp
   logical :: is_requested

   if (.not.initialized(table)) call new_table(table)

   if (present(requested)) then
      is_requested = requested
   else
      is_requested = .true.
   end if

   nullify(ptr)

   call table%get(key, tmp)

   if (associated(tmp)) then
      ptr => cast_to_array(tmp)
      if (present(stat)) then
         if (associated(ptr)) then
            stat = toml_stat%success
         else
            stat = toml_stat%type_mismatch
         end if
      end if
      if (present(origin)) origin = tmp%origin
   else
      if (is_requested) then
         call add_array(table, key, ptr, stat)
      else
         if (present(stat)) stat = toml_stat%success
      end if
      if (present(origin)) origin = table%origin
   end if

end subroutine get_child_array


subroutine get_child_keyval(table, key, ptr, requested, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Pointer to child value
   type(toml_keyval), pointer, intent(out) :: ptr

   !> Child value must be present
   logical, intent(in), optional :: requested

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   class(toml_value), pointer :: tmp
   logical :: is_requested

   if (.not.initialized(table)) call new_table(table)

   if (present(requested)) then
      is_requested = requested
   else
      is_requested = .true.
   end if

   nullify(ptr)

   call table%get(key, tmp)

   if (associated(tmp)) then
      ptr => cast_to_keyval(tmp)
      if (present(stat)) then
         if (associated(ptr)) then
            stat = toml_stat%success
         else
            stat = toml_stat%type_mismatch
         end if
      end if
      if (present(origin)) origin = tmp%origin
   else
      if (is_requested) then
         call add_keyval(table, key, ptr, stat)
      else
         if (present(stat)) stat = toml_stat%success
      end if
      if (present(origin)) origin = table%origin
   end if

end subroutine get_child_keyval


!> Retrieve TOML value as single precision float (might lose accuracy)
subroutine get_child_value_float_sp(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Real value
   real(tf_sp), intent(out) :: val

   !> Default real value
   real(tf_sp), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, present(default), stat, origin)

   if (associated(ptr)) then
      if (allocated(ptr%val)) then
         call get_value(ptr, val, stat, origin)
      else
         if (present(default)) then
            call set_value(ptr, default)
            call get_value(ptr, val, stat=stat)
         else
            if (present(stat)) stat = toml_stat%fatal
         end if
      end if
   else if (.not.present(default)) then
      if (present(stat)) stat = merge(toml_stat%missing_key, stat, stat == toml_stat%success)
   end if

end subroutine get_child_value_float_sp


!> Retrieve TOML value as double precision float
subroutine get_child_value_float_dp(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Real value
   real(tf_dp), intent(out) :: val

   !> Default real value
   real(tf_dp), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, present(default), stat, origin)

   if (associated(ptr)) then
      if (allocated(ptr%val)) then
         call get_value(ptr, val, stat, origin)
      else
         if (present(default)) then
            call set_value(ptr, default)
            call get_value(ptr, val, stat=stat)
         else
            if (present(stat)) stat = toml_stat%fatal
         end if
      end if
   else if (.not.present(default)) then
      if (present(stat)) stat = merge(toml_stat%missing_key, stat, stat == toml_stat%success)
   end if

end subroutine get_child_value_float_dp


!> Retrieve TOML value as one byte integer (might loose precision)
subroutine get_child_value_integer_i1(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Integer value
   integer(tf_i1), intent(out) :: val

   !> Default integer value
   integer(tf_i1), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, present(default), stat, origin)

   if (associated(ptr)) then
      if (allocated(ptr%val)) then
         call get_value(ptr, val, stat, origin)
      else
         if (present(default)) then
            call set_value(ptr, default)
            call get_value(ptr, val, stat=stat)
         else
            if (present(stat)) stat = toml_stat%fatal
         end if
      end if
   else if (.not.present(default)) then
      if (present(stat)) stat = merge(toml_stat%missing_key, stat, stat == toml_stat%success)
   end if

end subroutine get_child_value_integer_i1


!> Retrieve TOML value as two byte integer (might loose precision)
subroutine get_child_value_integer_i2(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Integer value
   integer(tf_i2), intent(out) :: val

   !> Default integer value
   integer(tf_i2), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, present(default), stat, origin)

   if (associated(ptr)) then
      if (allocated(ptr%val)) then
         call get_value(ptr, val, stat, origin)
      else
         if (present(default)) then
            call set_value(ptr, default)
            call get_value(ptr, val, stat=stat)
         else
            if (present(stat)) stat = toml_stat%fatal
         end if
      end if
   else if (.not.present(default)) then
      if (present(stat)) stat = merge(toml_stat%missing_key, stat, stat == toml_stat%success)
   end if

end subroutine get_child_value_integer_i2


!> Retrieve TOML value as four byte integer (might loose precision)
subroutine get_child_value_integer_i4(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Integer value
   integer(tf_i4), intent(out) :: val

   !> Default integer value
   integer(tf_i4), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, present(default), stat, origin)

   if (associated(ptr)) then
      if (allocated(ptr%val)) then
         call get_value(ptr, val, stat, origin)
      else
         if (present(default)) then
            call set_value(ptr, default)
            call get_value(ptr, val, stat=stat)
         else
            if (present(stat)) stat = toml_stat%fatal
         end if
      end if
   else if (.not.present(default)) then
      if (present(stat)) stat = merge(toml_stat%missing_key, stat, stat == toml_stat%success)
   end if

end subroutine get_child_value_integer_i4


!> Retrieve TOML value as eight byte integer
subroutine get_child_value_integer_i8(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Integer value
   integer(tf_i8), intent(out) :: val

   !> Default integer value
   integer(tf_i8), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, present(default), stat, origin)

   if (associated(ptr)) then
      if (allocated(ptr%val)) then
         call get_value(ptr, val, stat, origin)
      else
         if (present(default)) then
            call set_value(ptr, default)
            call get_value(ptr, val, stat=stat)
         else
            if (present(stat)) stat = toml_stat%fatal
         end if
      end if
   else if (.not.present(default)) then
      if (present(stat)) stat = merge(toml_stat%missing_key, stat, stat == toml_stat%success)
   end if

end subroutine get_child_value_integer_i8


!> Retrieve TOML value as logical
subroutine get_child_value_bool(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Boolean value
   logical, intent(out) :: val

   !> Default boolean value
   logical, intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, present(default), stat, origin)

   if (associated(ptr)) then
      if (allocated(ptr%val)) then
         call get_value(ptr, val, stat, origin)
      else
         if (present(default)) then
            call set_value(ptr, default)
            call get_value(ptr, val, stat=stat)
         else
            if (present(stat)) stat = toml_stat%fatal
         end if
      end if
   else if (.not.present(default)) then
      if (present(stat)) stat = merge(toml_stat%missing_key, stat, stat == toml_stat%success)
   end if

end subroutine get_child_value_bool


!> Retrieve TOML value as datetime
subroutine get_child_value_datetime(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Datetime value
   type(toml_datetime), intent(out) :: val

   !> Default datetime value
   type(toml_datetime), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, present(default), stat, origin)

   if (associated(ptr)) then
      if (allocated(ptr%val)) then
         call get_value(ptr, val, stat, origin)
      else
         if (present(default)) then
            call set_value(ptr, default)
            call get_value(ptr, val, stat=stat)
         else
            if (present(stat)) stat = toml_stat%fatal
         end if
      end if
   else if (.not.present(default)) then
      if (present(stat)) stat = merge(toml_stat%missing_key, stat, stat == toml_stat%success)
   end if

end subroutine get_child_value_datetime


!> Retrieve TOML value as deferred-length character
subroutine get_child_value_string(table, key, val, default, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> String value
   character(kind=tfc, len=:), allocatable, intent(out) :: val

   !> Default string value
   character(kind=tfc, len=*), intent(in), optional :: default

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, present(default), stat, origin)

   if (associated(ptr)) then
      if (allocated(ptr%val)) then
         call get_value(ptr, val, stat, origin)
      else
         if (present(default)) then
            call set_value(ptr, default)
            call get_value(ptr, val, stat=stat)
         else
            if (present(stat)) stat = toml_stat%fatal
         end if
      end if
   else if (.not.present(default)) then
      if (present(stat)) stat = merge(toml_stat%missing_key, stat, stat == toml_stat%success)
   end if

end subroutine get_child_value_string


!> Set TOML value to single precision float
subroutine set_child_value_float_sp(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Real value
   real(tf_sp), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, .true., stat, origin)

   if (associated(ptr)) then
      call set_value(ptr, val, stat, origin)
   else
      if (present(stat)) then
         if (stat == toml_stat%success) stat = toml_stat%fatal
      end if
   end if

end subroutine set_child_value_float_sp


!> Set TOML value to double precision float
subroutine set_child_value_float_dp(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Real value
   real(tf_dp), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, .true., stat, origin)

   if (associated(ptr)) then
      call set_value(ptr, val, stat, origin)
   else
      if (present(stat)) then
         if (stat == toml_stat%success) stat = toml_stat%fatal
      end if
   end if

end subroutine set_child_value_float_dp


!> Set TOML value to one byte integer
subroutine set_child_value_integer_i1(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Integer value
   integer(tf_i1), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, .true., stat, origin)

   if (associated(ptr)) then
      call set_value(ptr, val, stat, origin)
   else
      if (present(stat)) then
         if (stat == toml_stat%success) stat = toml_stat%fatal
      end if
   end if

end subroutine set_child_value_integer_i1


!> Set TOML value to two byte integer
subroutine set_child_value_integer_i2(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Integer value
   integer(tf_i2), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, .true., stat, origin)

   if (associated(ptr)) then
      call set_value(ptr, val, stat, origin)
   else
      if (present(stat)) then
         if (stat == toml_stat%success) stat = toml_stat%fatal
      end if
   end if

end subroutine set_child_value_integer_i2


!> Set TOML value to four byte integer
subroutine set_child_value_integer_i4(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Integer value
   integer(tf_i4), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, .true., stat, origin)

   if (associated(ptr)) then
      call set_value(ptr, val, stat, origin)
   else
      if (present(stat)) then
         if (stat == toml_stat%success) stat = toml_stat%fatal
      end if
   end if

end subroutine set_child_value_integer_i4


!> Set TOML value to eight byte integer
subroutine set_child_value_integer_i8(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Integer value
   integer(tf_i8), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, .true., stat, origin)

   if (associated(ptr)) then
      call set_value(ptr, val, stat, origin)
   else
      if (present(stat)) then
         if (stat == toml_stat%success) stat = toml_stat%fatal
      end if
   end if

end subroutine set_child_value_integer_i8


!> Set TOML value to logical
subroutine set_child_value_bool(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Boolean value
   logical, intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, .true., stat, origin)

   if (associated(ptr)) then
      call set_value(ptr, val, stat, origin)
   else
      if (present(stat)) then
         if (stat == toml_stat%success) stat = toml_stat%fatal
      end if
   end if

end subroutine set_child_value_bool


!> Set TOML value to datetime
subroutine set_child_value_datetime(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> Datetime value
   type(toml_datetime), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, .true., stat, origin)

   if (associated(ptr)) then
      call set_value(ptr, val, stat, origin)
   else
      if (present(stat)) then
         if (stat == toml_stat%success) stat = toml_stat%fatal
      end if
   end if

end subroutine set_child_value_datetime


!> Set TOML value to deferred-length character
subroutine set_child_value_string(table, key, val, stat, origin)

   !> Instance of the TOML table
   class(toml_table), intent(inout) :: table

   !> Key in this TOML table
   character(kind=tfc, len=*), intent(in) :: key

   !> String value
   character(kind=tfc, len=*), intent(in) :: val

   !> Status of operation
   integer, intent(out), optional :: stat

   !> Origin in the data structure
   integer, intent(out), optional :: origin

   type(toml_keyval), pointer :: ptr

   call get_value(table, key, ptr, .true., stat, origin)

   if (associated(ptr)) then
      call set_value(ptr, val, stat, origin)
   else
      if (present(stat)) then
         if (stat == toml_stat%success) stat = toml_stat%fatal
      end if
   end if

end subroutine set_child_value_string


end module tomlf_build_table

program demo
  use tomlf, only : toml_table, toml_error, toml_context, toml_load, get_value
  use demo_dependency, only : dependency_type, load_dependencies
  implicit none

  type(dependency_type), allocatable :: deps(:)
  character(128) :: arg

  call get_command_argument(1, arg)

  block
    type(toml_table), allocatable :: table
    type(toml_error), allocatable :: error
    type(toml_context) :: context

    type(toml_table), pointer :: child

    call toml_load(table, trim(arg), context=context, error=error)
    if (allocated(error)) then
      print '(a)', error%message
      stop 1
    end if

    call get_value(table, "dependencies", child)
    if (associated(child)) then
      call load_dependencies(deps, child, context)
    end if
  end block
end program demo

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/solvation/surface.f90
!> Provides a surface integrator

!> Surface integrator for solvent accessible surface area
module tblite_solvation_surface
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use mctc_io_convert, only : aatoau
   use tblite_mesh_lebedev, only : get_angular_grid, grid_size, list_bisection
   use tblite_adjlist, only : adjacency_list, new_adjacency_list
   implicit none
   private

   public :: new_surface_integrator

   type, public :: surface_integrator
      !> Number of angular grid points
      integer :: nang
      !> Angular grid coordinates
      real(wp), allocatable :: ang_grid(:, :)
      !> Angular grid weights
      real(wp), allocatable :: ang_weight(:)
      !> Cut-off radius for the nearest neighbour list
      real(wp) :: srcut
      !> Atom specific surface data
      real(wp), allocatable :: vdwsa(:)
      real(wp), allocatable :: wrp(:)
      real(wp), allocatable :: trj2(:, :)
      real(wp) :: ah0, ah1, ah3
   contains
      procedure :: get_surface
   end type surface_integrator

   !> real space cut-offs
   real(wp), parameter :: tolsesp = 1.e-6_wp

   real(wp), parameter :: default_offset = 2.0_wp*aatoau
   real(wp), parameter :: default_smoothing = 0.3_wp*aatoau

contains

!> Initialize data straucture
subroutine new_surface_integrator(self, num, rad, probe, nang, offset, smoothing)
   !> Instance of the surface integrator
   type(surface_integrator), intent(out) :: self
   !> Atomic numbers
   integer, intent(in) :: num(:)
   !> Van-der-Waals Radii
   real(wp), intent(in) :: rad(:)
   !> Probe radius of the solvent
   real(wp), intent(in) :: probe
   !> Number of angular grid points for integration
   integer, intent(in) :: nang
   !> Offset for surface integration cutoff
   real(wp), intent(in), optional :: offset
   !> Smooting function parameter
   real(wp), intent(in), optional :: smoothing

   integer :: iat, izp, iang, ierr, nat
   real(wp) :: r, w, w3

   nat = size(num)

   allocate (self%vdwsa(nat))
   allocate (self%trj2(2, nat))
   allocate (self%wrp(nat))
   if (present(smoothing)) then
      w = smoothing
   else
      w = default_smoothing
   end if
   w3 = w*w*w
   self%ah0 = 0.5_wp
   self%ah1 = 3._wp/(4.0_wp*w)
   self%ah3 = -1._wp/(4.0_wp*w3)
   do iat = 1, nat
      izp = num(iat)
      self%vdwsa(iat) = rad(izp) + probe
      self%trj2(1, iat) = (self%vdwsa(iat) - w)**2
      self%trj2(2, iat) = (self%vdwsa(iat) + w)**2
      r = self%vdwsa(iat) + w
      self%wrp(iat) = (0.25_wp/w + &
         &            3.0_wp*self%ah3*(0.2_wp*r*r - 0.5_wp*r*self%vdwsa(iat) + &
         &            self%vdwsa(iat)*self%vdwsa(iat)/3.0_wp))*r*r*r
      r = self%vdwsa(iat) - w
      self%wrp(iat) = self%wrp(iat) - (0.25/w + &
         &    3.0_wp*self%ah3*(0.2_wp*r*r - 0.5_wp*r*self%vdwsa(iat) + &
         &            self%vdwsa(iat)*self%vdwsa(iat)/3.0_wp))*r*r*r
   end do
   self%srcut = 2*(w + maxval(self%vdwsa))
   if (present(offset)) then
      self%srcut = self%srcut + offset
   else
      self%srcut = self%srcut + default_offset
   end if

   iang = list_bisection(grid_size, nang)
   allocate (self%ang_grid(3, grid_size(iang)))
   allocate (self%ang_weight(grid_size(iang)))
   call get_angular_grid(iang, self%ang_grid, self%ang_weight, ierr)
   self%ang_weight(:) = self%ang_weight*4*pi

end subroutine new_surface_integrator

subroutine get_surface(self, mol, surface, dsdr)
   !> Instance of the surface integrator
   class(surface_integrator), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Surface area for each sphere
   real(wp), intent(out) :: surface(:)
   !> Derivative of surface area w.r.t. to coordinate displacements
   real(wp), intent(out), optional :: dsdr(:, :, :)

   type(adjacency_list) :: list
   real(wp), parameter :: trans(3, 1) = 0.0_wp

   call new_adjacency_list(list, mol, trans, self%srcut, .true.)

   ! compute solvent accessible surface and its derivatives
   if (present(dsdr)) then
      call compute_numsa(mol%nat, mol%xyz, list, self%vdwsa, &
         & self%wrp, self%trj2, self%ah0, self%ah1, self%ah3, self%ang_weight, self%ang_grid, &
         & surface, dsdr)
   else
      call compute_surface(mol%nat, mol%xyz, list, self%vdwsa, &
         & self%wrp, self%trj2, self%ah0, self%ah1, self%ah3, self%ang_weight, self%ang_grid, &
         & surface)
   end if

end subroutine get_surface

subroutine compute_surface(nat, xyz, list, vdwsa, &
      & wrp, trj2, ah0, ah1, ah3, ang_weight, ang_grid, surface)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Neighbourlist
   type(adjacency_list), intent(in) :: list
   !> Van-der-Waals radii including probe radius of solvent
   real(wp), intent(in) :: vdwsa(:)
   !> Radial weights for the numerical integration
   real(wp), intent(in) :: wrp(:)
   !> Radial smoothing function
   real(wp), intent(in) :: trj2(:, :)
   real(wp), intent(in)  :: ah0, ah1, ah3
   !> Angular weights for the numerical integration
   real(wp), intent(in) :: ang_weight(:)
   !> Angular grid for each atom
   real(wp), intent(in) :: ang_grid(:, :)
   !> Surface area for each atom, including surface tension
   real(wp), intent(out) :: surface(:)

   integer :: iat, ip, nno, ino
   real(wp) :: rsas, sasai, xyza(3), xyzp(3), sasap, wr, wsa

   surface(:) = 0.0_wp

   !$omp parallel do default(none) shared(surface, ah0, ah1, ah3) &
   !$omp shared(nat, vdwsa, list, xyz, wrp, ang_grid, ang_weight, trj2) &
   !$omp private(iat, rsas, nno, sasai, xyza, wr, ip, xyzp, wsa, sasap, ino)
   do iat = 1, nat

      rsas = vdwsa(iat)
      ino = list%inl(iat)
      nno = list%nnl(iat)

      ! initialize storage
      sasai = 0.0_wp

      ! atomic position
      xyza(:) = xyz(:, iat)
      ! radial atomic weight
      wr = wrp(iat)

      ! loop over grid points
      do ip = 1, size(ang_grid, 2)
         ! grid point position
         xyzp(:) = xyza(:) + rsas*ang_grid(:, ip)
         ! atomic surface function at the grid point
         call compute_w_sp(nat, list%nlat(ino+1:ino+nno), trj2, vdwsa, xyz, xyzp, &
            & ah0, ah1, ah3, sasap)

         if (sasap > tolsesp) then
            ! numerical quadrature weight
            wsa = ang_weight(ip)*wr*sasap
            ! accumulate the surface area
            sasai = sasai + wsa
         end if
      end do

      surface(iat) = sasai
   end do

end subroutine compute_surface

subroutine compute_numsa(nat, xyz, list, vdwsa, &
      & wrp, trj2, ah0, ah1, ah3, ang_weight, ang_grid, surface, dsdrt)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)
   !> Neighbourlist
   type(adjacency_list), intent(in) :: list
   !> Van-der-Waals radii including probe radius of solvent
   real(wp), intent(in) :: vdwsa(:)
   !> Radial weights for the numerical integration
   real(wp), intent(in) :: wrp(:)
   !> Radial smoothing function
   real(wp), intent(in) :: trj2(:, :)
   real(wp), intent(in)  :: ah0, ah1, ah3
   !> Angular weights for the numerical integration
   real(wp), intent(in) :: ang_weight(:)
   !> Angular grid for each atom
   real(wp), intent(in) :: ang_grid(:, :)
   !> Surface area for each atom, including surface tension
   real(wp), intent(out) :: surface(:)
   !> Derivative of surface area w.r.t. cartesian coordinates
   real(wp), intent(out) :: dsdrt(:, :, :)

   integer :: iat, jat, ip, jj, nni, nno, ino
   real(wp) :: rsas, sasai, xyza(3), xyzp(3), sasap, wr, wsa, drjj(3)
   real(wp), allocatable :: grds(:, :), grads(:, :)
   integer, allocatable :: grdi(:)

   surface(:) = 0.0_wp
   dsdrt(:, :, :) = 0.0_wp

   ! allocate space for the gradient storage
   allocate (grads(3, nat), source=0.0_wp)
   allocate (grds(3, maxval(list%nnl)))
   allocate (grdi(maxval(list%nnl)))

   !$omp parallel do default(none) shared(surface, dsdrt, ah0, ah1, ah3) &
   !$omp shared(nat, vdwsa, list, xyz, wrp, ang_grid, ang_weight, trj2) &
   !$omp private(iat, jat, rsas, nno, grads, sasai, xyza, wr, ip, xyzp, wsa, &
   !$omp& sasap, jj, nni, grdi, grds, drjj, ino)
   do iat = 1, nat

      rsas = vdwsa(iat)
      ino = list%inl(iat)
      nno = list%nnl(iat)

      ! initialize storage
      grads = 0.0_wp
      sasai = 0.0_wp

      ! atomic position
      xyza(:) = xyz(:, iat)
      ! radial atomic weight
      wr = wrp(iat)

      ! loop over grid points
      do ip = 1, size(ang_grid, 2)
         ! grid point position
         xyzp(:) = xyza(:) + rsas*ang_grid(:, ip)
         ! atomic surface function at the grid point
         call compute_w_spg(nat, list%nlat(ino+1:ino+nno), trj2, vdwsa, xyz, xyzp, &
            & ah0, ah1, ah3, sasap, grds, nni, grdi)

         if (sasap > tolsesp) then
            ! numerical quadrature weight
            wsa = ang_weight(ip)*wr*sasap
            ! accumulate the surface area
            sasai = sasai + wsa
            ! accumulate the surface gradient
            do jj = 1, nni
               jat = grdi(jj)
               drjj(:) = wsa*grds(:, jj)
               grads(:, iat) = grads(:, iat) + drjj(:)
               grads(:, jat) = grads(:, jat) - drjj(:)
            end do
         end if
      end do

      surface(iat) = sasai
      dsdrt(:, :, iat) = grads
   end do

end subroutine compute_numsa

pure subroutine compute_w_sp(nat, nnlists, trj2, vdwsa, xyza, xyzp, ah0, ah1, ah3, &
      & sasap)
   integer, intent(in)  :: nat
   integer, intent(in)  :: nnlists(:)
   real(wp), intent(in)  :: xyza(:, :)
   real(wp), intent(in)  :: xyzp(:)
   real(wp), intent(in)  :: ah0, ah1, ah3
   real(wp), intent(out) :: sasap
   real(wp), intent(in)  :: trj2(:, :)
   real(wp), intent(in)  :: vdwsa(:)

   integer  :: img, jat
   real(wp) :: tj(3), tj2, sqtj
   real(wp) :: uj, ah3uj2
   real(wp) :: sasaij, dsasaij

   sasap = 1.0_wp
   do img = 1, size(nnlists)
      jat = nnlists(img)
      ! compute the distance to the atom
      tj(:) = xyzp(:) - xyza(:, jat)
      tj2 = dot_product(tj, tj)
      ! if within the outer cut-off compute
      if (tj2 < trj2(2, jat)) then
         if (tj2 <= trj2(1, jat)) then
            sasap = 0.0_wp
            return
         else
            sqtj = sqrt(tj2)
            uj = sqtj - vdwsa(jat)
            ah3uj2 = ah3*uj*uj
            dsasaij = ah1 + 3.0_wp*ah3uj2
            sasaij = ah0 + (ah1 + ah3uj2)*uj

            ! accumulate the molecular surface
            sasap = sasap*sasaij
         end if
      end if
   end do

end subroutine compute_w_sp

pure subroutine compute_w_spg(nat, nnlists, trj2, vdwsa, xyza, xyzp, ah0, ah1, ah3, &
      & sasap, grds, nni, grdi)
   integer, intent(in)  :: nat
   integer, intent(in)  :: nnlists(:)
   integer, intent(out) :: nni
   real(wp), intent(in)  :: xyza(:, :)
   real(wp), intent(in)  :: xyzp(:)
   real(wp), intent(in)  :: ah0, ah1, ah3
   real(wp), intent(out) :: sasap
   real(wp), intent(out) :: grds(:, :)
   integer, intent(out) :: grdi(:)
   real(wp), intent(in)  :: trj2(:, :)
   real(wp), intent(in)  :: vdwsa(:)

   integer  :: img, jat
   real(wp) :: tj(3), tj2, sqtj
   real(wp) :: uj, ah3uj2
   real(wp) :: sasaij, dsasaij

   nni = 0
   sasap = 1.0_wp
   do img = 1, size(nnlists)
      jat = nnlists(img)
      ! compute the distance to the atom
      tj(:) = xyzp(:) - xyza(:, jat)
      tj2 = dot_product(tj, tj)
      ! if within the outer cut-off compute
      if (tj2 < trj2(2, jat)) then
         if (tj2 <= trj2(1, jat)) then
            sasap = 0.0_wp
            return
         else
            sqtj = sqrt(tj2)
            uj = sqtj - vdwsa(jat)
            ah3uj2 = ah3*uj*uj
            dsasaij = ah1 + 3.0_wp*ah3uj2
            sasaij = ah0 + (ah1 + ah3uj2)*uj

            ! accumulate the molecular surface
            sasap = sasap*sasaij
            ! compute the gradient wrt the neighbor
            dsasaij = dsasaij/(sasaij*sqtj)
            nni = nni + 1
            grdi(nni) = jat
            grds(:, nni) = dsasaij*tj(:)
         end if
      end if
   end do

end subroutine compute_w_spg

end module tblite_solvation_surface

module test_post_processing
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type, new
   use tblite_context_type, only : context_type
   use tblite_param_post_processing_molmom, only: molmom_record
   use tblite_param_post_processing, only : post_processing_record_list
   use tblite_post_processing_list, only : post_processing_list, add_post_processing
   use tblite_results, only : results_type
   use tblite_toml, only : toml_table, add_table, set_value, toml_key, get_value
   use tblite_wavefunction, only : wavefunction_type, new_wavefunction, eeq_guess
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   implicit none
   private

   public :: collect_post_processing

   real(wp), parameter :: kt = 300.0_wp * 3.166808578545117e-06_wp
   real(wp), parameter :: acc = 0.01_wp
   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))
contains

subroutine collect_post_processing(testsuite)
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [&
      new_unittest("check h2 wbo", test_h2_wbo), &
      new_unittest("test timer print", test_timer_print), &
      new_unittest("molmom param dump", test_molmom_dump_param), &
      new_unittest("post proc param load", test_pproc_load_param), &
      new_unittest("post proc param dump", test_pproc_dump_param), &
      new_unittest("molmom param dipm", test_molmom_dipm_param, should_fail=.true.), &
      new_unittest("molmom param qp", test_molmom_qp_param, should_fail=.true.) &
   ]
end subroutine


subroutine test_h2_wbo(error)
   type(error_type), allocatable, intent(out) :: error
   integer, parameter :: n_atoms = 2
   type(structure_type) :: mol
   type(context_type) :: ctx
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(post_processing_list) :: pproc
   type(results_type) :: res
   real(kind=wp) :: energy
   real(kind=wp), allocatable :: wbo(:, :, :), wbo_exp(:, :, :)
   real(kind=wp), allocatable :: xyz(:, :)
   character(len=:), allocatable :: wbo_label
   integer, parameter :: atoms(2) =  [1, 1]
   allocate(xyz(3, n_atoms))
   xyz = reshape([&
      &+0.00000000_wp, +0.000000000_wp, +0.472429040_wp,&
      &+0.00000000_wp, +0.000000000_wp, -0.472429040_wp],&
      & shape(xyz))

   call new(mol, atoms, xyz, charge=+1.0_wp, uhf=1)
   call new_gfn2_calculator(calc, mol, error)
   if (allocated(error)) return
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   wbo_label = "bond-orders"
   call add_post_processing(pproc, mol, wbo_label, error)
   if (allocated(error)) return
   call eeq_guess(mol, calc, wfn, error)
   if (allocated(error)) return
   energy = 0.0_wp

   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, results=res, post_process=pproc, verbosity=0)
   call res%dict%get_entry("bond-orders", wbo)
   
   allocate(wbo_exp(2, 2, 2))
   wbo_exp = reshape([&
      &0.000000_wp, +0.50000000_wp, &
      &0.500000000_wp, 0.00000000_wp, &
      &0.000000_wp, +0.50000000_wp, &
      &0.500000000_wp, 0.00000000_wp],&
      & shape(wbo_exp))
   
   if (any(abs(wbo - wbo_exp) > thr)) then
         call test_failed(error, "Gradient of energy does not match")
         print'(3es21.14)', wbo
         print'("---")'
         print'(3es21.14)', wbo_exp
   end if
   if (allocated(error)) return

   deallocate(wbo, wbo_exp)
   mol%charge = 0.0_wp
   mol%uhf = 0
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, results=res, post_process=pproc, verbosity=0)
   call res%dict%get_entry("bond-orders", wbo)
   allocate(wbo_exp(2, 2, 1))
   wbo_exp = reshape([&
      &0.00000000_wp, +1.0000000_wp,&
      &+1.00000000_wp, 0.00000000_wp ],&
      & shape(wbo_exp))
   
   if (any(abs(wbo - wbo_exp) > thr)) then
      call test_failed(error, "Gradient of energy does not match")
      print'(3es21.14)', wbo
      print'("---")'
      print'(3es21.14)', wbo_exp
   end if
   if (allocated(error)) return

   deallocate(wbo, wbo_exp)
   mol%charge = -1.0_wp
   mol%uhf = 1
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, results=res, post_process=pproc, verbosity=0)
   call res%dict%get_entry("bond-orders", wbo)
   allocate(wbo_exp(2, 2, 2))
   wbo_exp = reshape([&
      &0.00000000_wp, +0.5000000_wp,&
      &+0.50000000_wp, 0.00000000_wp, & 
      &0.00000000_wp, -0.5000000_wp,&
      &-0.50000000_wp, 0.00000000_wp ],&
      & shape(wbo_exp))
   
   if (any(abs(wbo - wbo_exp) > thr)) then
         call test_failed(error, "Gradient of energy does not match")
         print'(3es21.14)', wbo
         print'("---")'
         print'(3es21.14)', wbo_exp
   end if
   if (allocated(error)) return

   deallocate(wbo, wbo_exp)
   mol%charge = -2.0_wp
   mol%uhf = 0
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, results=res, post_process=pproc, verbosity=0)
   call res%dict%get_entry("bond-orders", wbo)
   allocate(wbo_exp(2, 2, 1))
   wbo_exp = reshape([&
      &0.00000000_wp, +0.0000000_wp,&
      &+0.00000000_wp, 0.00000000_wp ],&
      & shape(wbo_exp))
   
   if (any(abs(wbo - wbo_exp) > thr)) then
         call test_failed(error, "Gradient of energy does not match")
         print'(3es21.14)', wbo
         print'("---")'
         print'(3es21.14)', wbo_exp
   end if

end subroutine test_h2_wbo

subroutine test_timer_print(error)
   type(error_type), allocatable, intent(out) :: error
   integer, parameter :: n_atoms = 2
   type(structure_type) :: mol
   type(context_type) :: ctx
   type(xtb_calculator) :: calc
   type(wavefunction_type) :: wfn
   type(post_processing_list) :: pproc
   type(results_type) :: res
   real(kind=wp) :: energy
   real(kind=wp), allocatable :: xyz(:, :)
   character(len=:), allocatable :: wbo_label, molmom_label, xtbml_label
   integer, parameter :: atoms(2) =  [1, 1]
   allocate(xyz(3, n_atoms))
   xyz = reshape([&
      &+0.00000000_wp, +0.000000000_wp, +0.472429040_wp,&
      &+0.00000000_wp, +0.000000000_wp, -0.472429040_wp],&
      & shape(xyz))
   
   call new(mol, atoms, xyz, charge=+1.0_wp, uhf=1)
   call new_gfn2_calculator(calc, mol, error)
   if (allocated(error)) return
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, 1, kt)
   wbo_label = "bond-orders"
   call add_post_processing(pproc, mol, wbo_label, error)
   if (allocated(error)) return
   molmom_label = "molmom"
   call add_post_processing(pproc, mol, molmom_label, error)
   if (allocated(error)) return
   xtbml_label = "xtbml"
   call add_post_processing(pproc, mol, xtbml_label, error)
   if (allocated(error)) return
   call eeq_guess(mol, calc, wfn, error)
   if (allocated(error)) return
   energy = 0.0_wp
   
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, results=res, post_process=pproc, verbosity=3)

end subroutine test_timer_print

subroutine test_molmom_dipm_param(error)
   type(error_type), allocatable, intent(out) :: error
   type(toml_table), pointer :: table_multipole
   type(toml_table) :: table_post_proc
   type(molmom_record) :: param
   table_post_proc = toml_table()
   call add_table(table_post_proc, "molecular-multipole", table_multipole)
   call set_value(table_multipole, "dipole", 5)
   call set_value(table_multipole, "quadrupole", .true.)
   
   call param%load(table_post_proc, error)
   table_post_proc = toml_table()
   call add_table(table_post_proc, "molecular-multipole", table_multipole)
   call set_value(table_multipole, "dipole", .true.)
   call set_value(table_multipole, "quadrupole", 42)
   
   call param%load(table_post_proc, error)
   
end subroutine test_molmom_dipm_param

subroutine test_molmom_qp_param(error)
   type(error_type), allocatable, intent(out) :: error
   type(toml_table), pointer :: table_multipole
   type(toml_table) :: table_post_proc
   type(molmom_record) :: param
  
   table_post_proc = toml_table()
   call add_table(table_post_proc, "molecular-multipole", table_multipole)
   call set_value(table_multipole, "dipole", .true.)
   call set_value(table_multipole, "quadrupole", 42)
   
   call param%load(table_post_proc, error)
   
end subroutine test_molmom_qp_param

subroutine test_molmom_dump_param(error)
   type(error_type), allocatable, intent(out) :: error
   type(toml_table), pointer :: table_multipole, child
   type(toml_table) :: table_post_proc
   type(toml_table) :: new_table
   type(toml_key), allocatable :: list(:)
   type(molmom_record) :: param
  
   table_post_proc = toml_table()
   call add_table(table_post_proc, "molecular-multipole", table_multipole)
   call set_value(table_multipole, "dipole", .true.)
   call set_value(table_multipole, "quadrupole", .false.)
   
   call param%load(table_post_proc, error)
   call check(error, param%moldipm, .true.)
   if (allocated(error)) return
   call check(error, param%molqp, .false.)
   if (allocated(error)) return
   
   new_table = toml_table()
   call param%dump(new_table, error)
   call param%load(new_table, error)
   call new_table%get_keys(list)
   
   call check(error, size(list), 1)
   if (allocated(error)) return
   call get_value(new_table, list(1)%key, child)
   call child%get_keys(list)
   call check(error, size(list), 2)
   if (allocated(error)) return
   
end subroutine test_molmom_dump_param

subroutine test_pproc_load_param(error)
   type(error_type), allocatable, intent(out) :: error
   type(toml_table), pointer ::  table_entries
   type(toml_table) :: table_multipole
   type(post_processing_record_list) :: param
  
   table_multipole = toml_table()
   call add_table(table_multipole, "molecular-multipole", table_entries)
   call set_value(table_entries, "dipole", .true.)
   call set_value(table_entries, "quadrupole", .false.)
   call param%load(table_multipole, error)

end subroutine test_pproc_load_param

subroutine test_pproc_dump_param(error)
   type(error_type), allocatable, intent(out) :: error
   type(toml_table), pointer ::  table_entries, child
   type(toml_table) :: table_multipole
   type(toml_table) :: new_table
   type(toml_key), allocatable :: list(:)
   type(post_processing_record_list) :: param
  
   table_multipole = toml_table()
   call add_table(table_multipole, "molecular-multipole", table_entries)
   call set_value(table_entries, "dipole", .true.)
   call set_value(table_entries, "quadrupole", .false.)
   call param%load(table_multipole, error)
   new_table = toml_table()
   call param%dump(new_table, error)
   call param%load(new_table, error)
   call new_table%get_keys(list)

   call check(error, size(list), 1)
   if (allocated(error)) return
   call get_value(new_table, list(1)%key, child)
   call child%get_keys(list)
   call check(error, size(list), 2)
   if (allocated(error)) return
end subroutine test_pproc_dump_param


end module test_post_processing

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/api/container.f90
!> Provides API exports for the #tblite_container handle.

!> API export for managing interaction containers
module tblite_api_solvation
   use, intrinsic :: iso_c_binding
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_io, only : structure_type
   use tblite_api_version, only : namespace
   use tblite_api_container, only : vp_container
   use tblite_api_error, only : vp_error
   use tblite_api_structure, only : vp_structure
   use tblite_basis, only : basis_type
   use tblite_container, only : container_type, container_list
   use tblite_data_spin, only : get_spin_constant
   use tblite_external_field, only : electric_field
   use tblite_spin, only : spin_polarization, new_spin_polarization
   use tblite_solvation, only : solvation_input, cpcm_input, alpb_input, &
      & solvent_data, get_solvent_data, solvation_type, new_solvation, solution_state, &
      & new_solvation_cds, new_solvation_shift, cds_input, shift_input, born_kernel
   use tblite_api_utils, only: c_f_character
   implicit none
   private

   public :: new_gb_solvation_epsilon_api, new_alpb_solvation_solvent_api, &
      & new_cpcm_solvation_epsilon_api

   enum, bind(c)
      enumerator :: &
         solvation_gbe = 10, &
         solvation_alpb_gfn1 = 11, &
         solvation_alpb_gfn2 = 12, &
         solvation_gb = 20, &
         solvation_gbsa_gfn1 = 21, &
         solvation_gbsa_gfn2 = 22
   end enum


   logical, parameter :: debug = .false.

contains


function new_cpcm_solvation_epsilon_api(verr, vmol, eps) result(vcont) &
   & bind(C, name=namespace//"new_cpcm_solvation_epsilon")
   type(c_ptr), value :: verr
   type(vp_error), pointer :: err
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   real(kind=c_double), value :: eps
   type(c_ptr) :: vcont
   type(vp_container), pointer :: cont

   type(solvation_input) :: solvmodel
   class(solvation_type), allocatable :: solv

   if (debug) print '("[Info]", 1x, a)', "new_cpcm_solvation_epsilon"
   vcont = c_null_ptr

   if (.not.c_associated(verr)) return
   call c_f_pointer(verr, err)

   if (.not.c_associated(vmol)) then
      call fatal_error(err%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   solvmodel%cpcm = cpcm_input(eps)
   call new_solvation(solv, mol%ptr, solvmodel, err%ptr)
   if (allocated(err%ptr)) return
   
   allocate(cont)
   call move_alloc(solv, cont%ptr)
   
   vcont = c_loc(cont)
end function new_cpcm_solvation_epsilon_api

function new_gb_solvation_epsilon_api(verr, vmol, eps, version, born_type) result(vcont) &
   & bind(C, name=namespace//"new_gb_solvation_epsilon")
   type(c_ptr), value :: verr
   type(vp_error), pointer :: err
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   real(c_double), value :: eps
   integer(c_int), value :: version
   integer(c_int), value :: born_type
   type(c_ptr) :: vcont
   type(vp_container), pointer :: cont

   type(solvation_input) :: solvmodel
   class(solvation_type), allocatable :: solv
   logical :: alpb

   if (debug) print '("[Info]", 1x, a)', "new_alpb_solvation_epsilon"
   vcont = c_null_ptr

   if (.not.c_associated(verr)) return
   call c_f_pointer(verr, err)

   if (.not.c_associated(vmol)) then
      call fatal_error(err%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   select case(version)
   case default
      call fatal_error(err%ptr, "Unknown solvation model requested")
      return
   case(solvation_gbe)
      alpb = .true.
   case(solvation_gb)
      alpb = .false.
   end select

   solvmodel%alpb = alpb_input(eps, alpb=alpb, kernel=born_type)
   call new_solvation(solv, mol%ptr, solvmodel, err%ptr)
   if (allocated(err%ptr)) return
   
   allocate(cont)
   call move_alloc(solv, cont%ptr)
   
   vcont = c_loc(cont)
end function new_gb_solvation_epsilon_api

function new_alpb_solvation_solvent_api(verr, vmol, csolvstr, version, crefstate) result(vcont) &
   & bind(C, name=namespace//"new_alpb_solvation_solvent")
   type(c_ptr), value :: verr
      type(vp_error), pointer :: err
   type(c_ptr), value :: vmol
   type(vp_structure), pointer :: mol
   type(c_ptr) :: vcont
   character(kind=c_char), intent(in) :: csolvstr(*)
   integer(c_int), value :: version
   integer(c_int), value :: crefstate
   type(vp_container), pointer :: cont

   type(solvation_input) :: solvmodel
   type(solvent_data) :: solvent
   character(len=:), allocatable :: solvstr, method
   integer :: kernel, sol_state
   logical :: alpb

   class(container_list), allocatable :: list
   class(container_type), allocatable :: tmp_cont
   class(solvation_type), allocatable :: solv, cds, shift

   if (debug) print '("[Info]", 1x, a)', "new_alpb_solvation_solvent"
   vcont = c_null_ptr

   if (.not.c_associated(verr)) return
   call c_f_pointer(verr, err)

   if (.not.c_associated(vmol)) then
      call fatal_error(err%ptr, "Molecular structure data is missing")
      return
   end if
   call c_f_pointer(vmol, mol)

   call c_f_character(csolvstr, solvstr)
   solvent = get_solvent_data(solvstr)
   if (solvent%eps <= 0.0_wp) then
      call fatal_error(err%ptr, "String value for epsilon was not found among database of solvents")
      return
   end if

   select case(version)
   case(solvation_alpb_gfn1, solvation_alpb_gfn2)
      method = merge("gfn2", "gfn1", version == solvation_alpb_gfn2)
      kernel = born_kernel%p16
      alpb = .true.
   case(solvation_gbsa_gfn1, solvation_gbsa_gfn2)
      method = merge("gfn2", "gfn1", version == solvation_gbsa_gfn2)
      kernel = born_kernel%still
      alpb = .false.
   case default
      call fatal_error(err%ptr, "Unknown value for model version")
      return
   end select

   sol_state = int(crefstate)

   solvmodel%alpb = alpb_input(solvent%eps, solvent=solvent%solvent, kernel=kernel, alpb=alpb)
   solvmodel%cds = cds_input(alpb=alpb, solvent=solvent%solvent)
   solvmodel%shift = shift_input(alpb=alpb, solvent=solvent%solvent, state=sol_state)

   allocate(list)
   call new_solvation(solv, mol%ptr, solvmodel, err%ptr, method)
   if (allocated(err%ptr)) return
   call move_alloc(solv, tmp_cont)
   call list%push_back(tmp_cont)
   
   call new_solvation_cds(cds, mol%ptr, solvmodel, err%ptr, method)
   if (allocated(err%ptr)) return
   call move_alloc(cds, tmp_cont)
   call list%push_back(tmp_cont)

   call new_solvation_shift(shift, solvmodel, err%ptr, method)
   if (allocated(err%ptr)) return
   call move_alloc(shift, tmp_cont)
   call list%push_back(tmp_cont)

   allocate(cont)
   call move_alloc(list, cont%ptr)

   vcont = c_loc(cont)
end function new_alpb_solvation_solvent_api

end module tblite_api_solvation

! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/post-processing/xtb-ml/convolution.f90
!> Coordination number based convolution
module tblite_post_processing_xtbml_convolution
   use mctc_env, only : wp, error_type
   use mctc_data_covrad, only : get_covalent_rad
   use mctc_io, only : structure_type
   use mctc_ncoord, only : ncoord_type, new_ncoord, cn_count
   use tblite_post_processing_xtbml_cache, only : xtbml_cache
   implicit none
   private

   public :: xtbml_convolution, new_xtbml_convolution

   !> Wrapped coordination number type for the creation of lists
   type :: ncoord_container
      !> Actual coordination number
      class(ncoord_type), allocatable :: raw
   end type ncoord_container

   !> Convolution xTB-ML features
   type :: xtbml_convolution
      !> Covalent radii
      real(wp), allocatable :: rcov(:)
      !> Linear scaling factor for the covalent radii to generate
      !> coordination numbers of different length scales
      real(wp), allocatable :: rcov_scale(:)
      !> Number of different length scales for the convolution
      integer :: nscale
      !> Label for the convolution container
      character(len=:), allocatable :: label
      !> List of coordination number objects for different length scales
      type(ncoord_container), allocatable :: ncoord(:)
   contains
      !> Update the xTB-ML feature cache with the convolution kernel
      procedure :: compute_kernel
      !> Populate the convolution kernel
      procedure, private :: populate_kernel
      !> Write the xtb-ML convolution information
      procedure :: info
   end type xtbml_convolution

   character(len=*), parameter :: label = "CN-based convolution"

   ! Coordination number exponent
   real(wp), parameter :: kcn = 16.0_wp

contains

subroutine new_xtbml_convolution(self, mol, rcov_scale, error)
   !> Instance of the xTB-ML convolution features
   class(xtbml_convolution), intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Scaling factors for the covalent radii to generate
   !> coordination numbers of different length scales
   real(wp), intent(in) :: rcov_scale(:)
   !> Error handling
   type(error_type), intent(inout) , allocatable:: error

   integer :: isc

   self%label = label

   ! Base covalent radii for convolution
   allocate (self%rcov(mol%nid))
   self%rcov(:) = get_covalent_rad(mol%num)

   ! Covalent radii scaling factors for different length scales
   self%rcov_scale = rcov_scale
   self%nscale = size(self%rcov_scale)

   ! Add DFT-D3-like coordination numbers with scaled radii
   allocate(self%ncoord(self%nscale))
   do isc = 1, self%nscale
      call new_ncoord(self%ncoord(isc)%raw, mol, cn_count%exp, error, kcn=kcn, &
         & rcov=self%rcov*self%rcov_scale(isc))
      if (allocated(error)) return
   end do

end subroutine new_xtbml_convolution


!> Update xTB-ML feature cache with the convolution kernel
subroutine compute_kernel(self, mol, mlcache)
   !> Convolution container
   class(xtbml_convolution), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Cache for xTB-ML features
   type(xtbml_cache), intent(inout) :: mlcache
   
   integer :: isc

   if (.not. allocated(mlcache%conv_kernel)) then
      allocate(mlcache%conv_kernel(mol%nat, mol%nat, self%nscale), source=0.0_wp)
   end if
   call self%populate_kernel(mol, mlcache%conv_kernel)

   if (.not. allocated(mlcache%conv_cn)) then
      allocate(mlcache%conv_cn(mol%nat, self%nscale), source=0.0_wp)
   end if
   do isc = 1, self%nscale
      call self%ncoord(isc)%raw%get_cn(mol, mlcache%conv_cn(:, isc))
   end do

end subroutine compute_kernel


!> Calculate the actual convolution kernel
subroutine populate_kernel(self, mol, kernel)
   !> Convolution container
   class(xtbml_convolution), intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Convolution kernel
   real(wp), intent(out) :: kernel(:, :, :)

   integer :: iat, jat, izp, jzp, ksc
   real(wp) :: rij(3), r, count

   !$omp parallel do default(none) collapse(3) &
   !$omp shared(self, mol, kernel) &
   !$omp private(iat, jat, izp, jzp, ksc, rij, r, count)
   do ksc = 1, self%nscale
      do iat = 1, mol%nat
         do jat = 1, mol%nat
            if (iat /= jat) then
               izp = mol%id(iat)
               jzp = mol%id(jat)
               rij = mol%xyz(:, iat) - mol%xyz(:, jat)
               r = sqrt(sum(rij**2))

               ! Coordination number counting function
               count = self%ncoord(ksc)%raw%ncoord_count(izp, jzp, r)
               ! Inverse of the counting function as the kernel value
               kernel(iat, jat, ksc) = 1.0_wp / count
            else
               kernel(iat, jat, ksc) = 1.0_wp
            end if
         end do
      end do
   end do

end subroutine populate_kernel


!> Information on the container
pure function info(self, verbosity, indent) result(str)
   !> Instance of the interaction container
   class(xtbml_convolution), intent(in) :: self
   !> Verbosity level
   integer, intent(in) :: verbosity
   !> Indentation level
   character(len=*), intent(in) :: indent
   !> Information on the container
   character(len=:), allocatable :: str

   if (allocated(self%label)) then
      str = indent // self%label
   else
      str = "Unknown"
   end if
end function info

end module tblite_post_processing_xtbml_convolution

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> @dir mctc/data
!> Contains element data used for defining interactions.

!> @file mctc/data.f90
!> Reexports access to element-specific data.

!> Proxy module for providing access to element data.
module mctc_data
   use mctc_data_atomicrad, only : get_atomic_rad
   use mctc_data_covrad, only : get_covalent_rad
   use mctc_data_paulingen, only : get_pauling_en
   use mctc_data_vdwrad, only : get_vdw_rad
   implicit none

   public :: get_atomic_rad, get_covalent_rad, get_pauling_en, get_vdw_rad
end module mctc_data

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/io/data/npz.f90
!> Provides NPZ data handling capabilities for tblite

!> Implementation of NPZ data handler
module tblite_io_data_npz
   use mctc_env, only: dp, i4, error_type, fatal_error
   use tblite_io_data_type, only: iodata_type, iodata_record
   use tblite_io_numpy, only : load_npz, save_npz
   use tblite_io_numpy_loadz, only : get_npz_descriptor
   use tblite_io_numpy_zip, only : zip_file, list_zip_file
   implicit none
   private

   type, extends(iodata_type), public :: npz_data
      !> NPZ file name handled by this backend
      character(len=:), allocatable :: filename
   contains
      !> List logical datasets stored in the NPZ archive.
      procedure :: list
      !> Get the shape of a logical dataset.
      procedure :: get_shape
      !> Load an integer rank-1 dataset.
      procedure :: load_i4_r1
      !> Load a real rank-1 dataset.
      procedure :: load_rdp_r1
      !> Load a real rank-2 dataset.
      procedure :: load_rdp_r2
      !> Load a real rank-3 dataset.
      procedure :: load_rdp_r3
      !> Save an integer rank-1 dataset.
      procedure :: save_i4_r1
      !> Save a real rank-1 dataset.
      procedure :: save_rdp_r1
      !> Save a real rank-2 dataset.
      procedure :: save_rdp_r2
      !> Save a real rank-3 dataset.
      procedure :: save_rdp_r3
   end type npz_data

contains

subroutine list(self, datasets, error)
   !> NPZ backend instance
   class(npz_data), intent(in) :: self
   !> Logical dataset records found in the archive
   type(iodata_record), allocatable, intent(out) :: datasets(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(zip_file) :: zip
   integer :: io, stat, irec
   character(len=:), allocatable :: msg

   open(newunit=io, file=self%filename, form="unformatted", access="stream", iostat=stat)
   call list_zip_file(io, self%filename, zip, stat, msg)
   close(io)
   if (stat /= 0) then
      if (.not.allocated(msg)) msg = "Failed to read zip file '"//self%filename//"'"
      call fatal_error(error, msg)
      return
   end if

   if (.not.allocated(zip%records)) then
      call fatal_error(error, "No records found in file '"//self%filename//"'")
      return
   end if

   allocate(datasets(size(zip%records)))
   do irec = 1, size(zip%records)
      associate(path => zip%records(irec)%path)
         if (len(path) > 4 .and. path(len(path)-3:) == ".npy") then
            datasets(irec)%name = path(:len(path)-4)
         else
            datasets(irec)%name = path
         end if
      end associate
   end do
end subroutine list

subroutine get_shape(self, dataset, shape, error)
   !> NPZ backend instance
   class(npz_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Dataset shape
   integer, allocatable, intent(out) :: shape(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg, vtype

   call get_npz_descriptor(self%filename, dataset, vtype, shape, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to read descriptor for dataset '"//dataset//"' from NPZ file '"//self%filename//"': "//msg)
      return
   end if
end subroutine get_shape

subroutine load_i4_r1(self, dataset, data, error)
   !> NPZ backend instance
   class(npz_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data loaded from the dataset
   integer(i4), allocatable, intent(out) :: data(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call load_npz(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to load dataset '"//dataset//"' from npz file '"//self%filename//"': "//msg)
   end if
end subroutine load_i4_r1

subroutine load_rdp_r1(self, dataset, data, error)
   !> NPZ backend instance
   class(npz_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data loaded from the dataset
   real(dp), allocatable, intent(out) :: data(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call load_npz(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to load dataset '"//dataset//"' from npz file '"//self%filename//"': "//msg)
   end if
end subroutine load_rdp_r1

subroutine load_rdp_r2(self, dataset, data, error)
   !> NPZ backend instance
   class(npz_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data loaded from the dataset
   real(dp), allocatable, intent(out) :: data(:,:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call load_npz(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to load dataset '"//dataset//"' from npz file '"//self%filename//"': "//msg)
   end if
end subroutine load_rdp_r2

subroutine load_rdp_r3(self, dataset, data, error)
   !> NPZ backend instance
   class(npz_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data loaded from the dataset
   real(dp), allocatable, intent(out) :: data(:,:,:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call load_npz(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to load dataset '"//dataset//"' from npz file '"//self%filename//"': "//msg)
   end if
end subroutine load_rdp_r3

subroutine save_i4_r1(self, dataset, data, error)
   !> NPZ backend instance
   class(npz_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data to save
   integer(i4), allocatable, intent(in) :: data(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call save_npz(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to save dataset '"//dataset//"' to npz file '"//self%filename//"': "//msg)
   end if
end subroutine save_i4_r1

subroutine save_rdp_r1(self, dataset, data, error)
   !> NPZ backend instance
   class(npz_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data to save
   real(dp), allocatable, intent(in) :: data(:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call save_npz(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to save dataset '"//dataset//"' to npz file '"//self%filename//"': "//msg)
   end if
end subroutine save_rdp_r1

subroutine save_rdp_r2(self, dataset, data, error)
   !> NPZ backend instance
   class(npz_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data to save
   real(dp), allocatable, intent(in) :: data(:,:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg

   call save_npz(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to save dataset '"//dataset//"' to npz file '"//self%filename//"': "//msg)
   end if
end subroutine save_rdp_r2

subroutine save_rdp_r3(self, dataset, data, error)
   !> NPZ backend instance
   class(npz_data), intent(in) :: self
   !> Logical dataset name
   character(len=*), intent(in) :: dataset
   !> Data to save
   real(dp), allocatable, intent(in) :: data(:,:,:)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: stat
   character(len=:), allocatable :: msg
   call save_npz(self%filename, dataset, data, stat, msg)
   if (stat /= 0) then
      call fatal_error(error, "Failed to save dataset '"//dataset//"' to npz file '"//self%filename//"': "//msg)
   end if
end subroutine save_rdp_r3
end module tblite_io_data_npz

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3_app_help
   use dftd3, only : get_dftd3_version
   implicit none
   private

   public :: prog_name, header, version
   public :: help_text, run_help_text, param_help_text, gcp_help_text


   character(len=*), parameter :: prog_name = "s-dftd3"

   character(len=*), parameter :: nl = new_line('a')

   character(len=*), parameter :: run_options_text = &
      "-i,--input <format>      Hint for the format of the input file"//nl//&
      "   --bj <method>         Use rational (Becke-Johnson) damping function"//nl//&
      "   --bj-param <list>     Specify parameters for rational damping,"//nl//&
      "                         expected order is s6, s8, a1, a2 (requires four arguments)"//nl//&
      "   --zero <method>       Use zero (Chai-Head-Gordon) damping function"//nl//&
      "   --zero-param <list>   Specify parameters for zero damping,"//nl//&
      "                         expected order is s6, s8, rs6 (requires three arguments)"//nl//&
      "   --bjm <method>        Use modified rational damping function"//nl//&
      "   --bjm-param <list>    Specify parameters for rational damping,"//nl//&
      "                         expected order is s6, s8, a1, a2 (requires four arguments)"//nl//&
      "   --zerom <method>      Use modified zero damping function"//nl//&
      "   --zerom-param <list>  Specify parameters for modified zero damping,"//nl//&
      "                         expected order is s6, s8, rs6, bet (requires four arguments)"//nl//&
      "   --op <method>         Use optimized power damping function"//nl//&
      "   --op-param <list>     Specify parameters for optimized power,"//nl//&
      "                         expected order is s6, s8, a1, a2, bet (requires five arguments)"//nl//&
      "   --cso <method>        Use CSO (C6-scaled only) damping function"//nl//&
      "   --cso-param <list>    Specify parameters for CSO damping,"//nl//&
      "                         expected order is s6, a1 (requires two arguments)"//nl//&
      "   --atm                 Use ATM three-body dispersion"//nl//&
      "   --atm-scale <s9>      Use scaled ATM three-body dispersion"//nl//&
      "   --gcp <basis>         Include geometric counter-poise correction for given basis set"//nl//&
      "   --db <file>           Load parameters from external data file"//nl//&
      "   --noedisp             Disable writing of dispersion energy to .EDISP file"//nl//&
      "   --json [file]         Dump results to JSON output (default: dftd3.json)"//nl//&
      "   --grad [file]         Request gradient evaluation,"//nl//&
      "                         write results to file (default: dftd3.txt),"//nl//&
      "                         attempts to add to Turbomole gradient and gradlatt files"//nl//&
      "   --property            Evaluate dispersion related properties"//nl//&
      "   --pair-resolved       Calculate pairwise representation of dispersion energy"//nl//&
      "   --citation [file]     Print citation information to file (default: dftd3.bib)"//nl//&
      "-v,--verbose             Show more, can be used multiple times"//nl//&
      "-s,--silent              Show less, use twice to supress all output"//nl//&
      "   --version             Print program version and exit"//nl//&
      "   --help                Show this help message"

   character(len=*), parameter :: run_help_text = &
      "Usage: "//prog_name//" [run] [options] <input>"//nl//&
      ""//nl//&
      "Takes an geometry input to calculate the D3 dispersion correction."//nl//&
      "Periodic calculations are performed automatically for periodic input formats."//nl//&
      "Specify the functional to select the correct parameters."//nl//&
      ""//nl//&
      run_options_text//nl//&
      ""

   character(len=*), parameter :: param_help_text = &
      "Usage: "//prog_name//" param [options] <input> [method] [damping]"//nl//&
      ""//nl//&
      "Takes a damping parameter data file and performs queries for damping"//nl//&
      "parameters if a method is provided, if no damping function is provided"//nl//&
      "the default damping functions as provided in the data file will be used."//nl//&
      "The data file is provided in TOML format."//nl//&
      ""//nl//&
      "Example:"//nl//&
      ""//nl//&
      "    [default]"//nl//&
      "    d3 = [""bj"", ""zero""]"//nl//&
      ""//nl//&
      "    [default.parameter]"//nl//&
      "    d3.bj = {s6=1.0, s9=0.0, alp=14.0, damping=""rational""}"//nl//&
      "    d3.zero = {s6=1.0, s9=0.0, rs8=1.0, alp=14.0, damping=""zero""}"//nl//&
      "    d3.bjm = {s6=1.0, s9=0.0, alp=14.0, damping=""rational""}"//nl//&
      "    d3.zerom = {s6=1.0, s9=0.0, rs8=1.0, alp=14.0, damping=""mzero""}"//nl//&
      "    d3.op = {s9=0.0, alp=14.0, damping=""optimizedpower""}"//nl//&
      "    d3.cso = {s6=1.0, s9=0.0, a2=2.5, rs6=0.0, rs8=6.25, alp=14.0, damping=""cso""}"//nl//&
      ""//nl//&
      "    [parameter.bp]"//nl//&
      "    d3.bj = {a1=0.3946, s8=3.2822, a2=4.8516}"//nl//&
      "    d3.zero = {rs6=1.139, s8=1.683}"//nl//&
      "    d3.bjm = {a1=0.821850, s8=3.140281, a2=2.728151}"//nl//&
      "    d3.zerom = {rs6=1.233460, s8=1.945174, bet=0.000000}"//nl//&
      ""//nl//&
      "    [parameter.blyp]"//nl//&
      "    d3.bj = {a1=0.4298, s8=2.6996, a2=4.2359}"//nl//&
      "    d3.zero = {rs6=1.094, s8=1.682}"//nl//&
      "    d3.bjm = {a1=0.448486, s8=1.875007, a2=3.610679}"//nl//&
      "    d3.zerom = {rs6=1.279637, s8=1.841686, bet=0.014370}"//nl//&
      "    d3.op = {s6=1.0, s8=1.31867, a1=0.425, a2=3.50, bet=2.0}"//nl//&
      ""//nl//&
      "    [parameter.revpbe]"//nl//&
      "    d3.bj = {a1=0.5238, s8=2.3550, a2=3.5016}"//nl//&
      "    d3.zero = {rs6=0.923, s8=1.010}"//nl//&
      "    d3.op = {s6=1.0, s8=1.44765, a1=0.600, a2=2.50, bet=0.0}"//nl//&
      ""

   character(len=*), parameter :: gcp_help_text = &
      "Usage: "//prog_name//" gcp [options] <input>"//nl//&
      ""//nl//&
      "Takes an geometry input to calculate the geometric counter-poise correction."//nl//&
      "Periodic calculations are performed automatically for periodic input formats."//nl//&
      "Specify the level of theory to select the correct parameters."//nl//&
      ""//nl//&
      "-i,--input <format>      Hint for the format of the input file"//nl//&
      "-l,--level <method>[/<basis>]"//nl//&
      "                         Level of theory, basis set is inferred for 3c methods"//nl//&
      "   --nocpc               Disable writing of dispersion energy to .CPC file"//nl//&
      "   --json [file]         Dump results to JSON output (default: gcp.json)"//nl//&
      "   --grad [file]         Request gradient evaluation,"//nl//&
      "                         write results to file (default: gcp.txt),"//nl//&
      "                         attempts to add to Turbomole gradient and gradlatt files"//nl//&
      "-v,--verbose             Show more, can be used multiple times"//nl//&
      "-s,--silent              Show less, use twice to supress all output"//nl//&
      "   --version             Print program version and exit"//nl//&
      "   --help                Show this help message"//nl//&
      ""

   character(len=*), parameter :: help_text = &
      "Usage: "//prog_name//" [run|param|gcp] [options] ..."//nl//&
      ""//nl//&
      "Commands"//nl//&
      ""//nl//&
      "  run       Evaluate dispersion correction on the provided input structure."//nl//&
      "            Periodic calculations are performed automatically for periodic inputs"//nl//&
      "            If no command is specified run is selected by default."//nl//&
      ""//nl//&
      "  param     Inspect and manipulate damping parameter data file."//nl//&
      ""//nl//&
      "Options"//nl//&
      ""//nl//&
      run_options_text//nl//&
      ""


contains


subroutine header(unit)
   integer, intent(in) :: unit
   character(len=:), allocatable :: version_string

   call get_dftd3_version(string=version_string)
   write(unit, '(a)') &
      "-----------------------------------", &
      " s i m p l e   D F T - D 3  v"// version_string, &
      "-----------------------------------", ""

end subroutine header


subroutine version(unit)
   integer, intent(in) :: unit
   character(len=:), allocatable :: version_string

   call get_dftd3_version(string=version_string)
   write(unit, '(a, *(1x, a))') &
      & prog_name, "version", version_string

end subroutine version


end module dftd3_app_help

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Example application using tool chain library.
!>
!> This program uses the [[read_structure]] and [[write_structure]] procedures
!> to implement a structure converter.
!> Usually, the input structure can be inferred by the name of the input file.
!> To allow formats with non-standard extensions (because most geometry formats
!> are not really standardized) additional hints can be passed by the command
!> line to determine the read/write formats.
!>
!> To add support for piping standard input and standard output reading and
!> writing from units is combined with the additional format hints.
!>
!> Additional filters or modifications can also be implemented in an intermediary
!> step, this program implements an element symbol normalization. Other filters
!> like folding back to central cells or removing lattice vector could be added
!> in a similar manner.
program main
   use, intrinsic :: iso_fortran_env, only : output_unit, error_unit, input_unit
   use mctc_env, only : error_type, fatal_error, get_argument, wp
   use mctc_io, only : structure_type, read_structure, write_structure, &
      & filetype, get_filetype, to_symbol
   use mctc_version, only : get_mctc_version
   implicit none
   character(len=*), parameter :: prog_name = "mctc-convert"

   character(len=:), allocatable :: input, output, template, filename
   integer, allocatable :: input_format, output_format, template_format
   type(structure_type) :: mol
   type(structure_type), allocatable :: mol_template
   type(error_type), allocatable :: error
   logical :: normalize, read_dot_files
   integer :: charge, unpaired

   call get_arguments(input, input_format, output, output_format, normalize, &
      & template, template_format, read_dot_files, error)
   if (allocated(error)) then
      write(error_unit, '(a)') error%message
      error stop
   end if

   if (allocated(template)) then
      allocate(mol_template)
      if (template == "-") then
         if (.not.allocated(template_format)) then
            template_format = merge(output_format, filetype%xyz, allocated(output_format))
         end if
         call read_structure(mol_template, input_unit, template_format, error)
      else
         call read_structure(mol_template, template, error, template_format)
      end if
      if (allocated(error)) then
         write(error_unit, '(a)') error%message
         error stop
      end if
   end if

   if (input == "-") then
      if (.not.allocated(input_format)) input_format = filetype%xyz
      call read_structure(mol, input_unit, input_format, error)
   else
      call read_structure(mol, input, error, input_format)

      if (read_dot_files) then
         charge = nint(mol%charge)
         if (.not.allocated(error)) then
            filename = join(dirname(input), ".CHRG")
            if (exists(filename)) call read_file(filename, charge, error)
         end if
         mol%charge = charge

         unpaired = mol%uhf
         if (.not.allocated(error)) then
            filename = join(dirname(input), ".UHF")
            if (exists(filename)) call read_file(filename, unpaired, error)
         end if
         mol%uhf = unpaired
      end if
   end if
   if (allocated(error)) then
      write(error_unit, '(a)') error%message
      error stop
   end if

   if (allocated(mol_template)) then
      if (mol%nat /= mol_template%nat) then
         write(error_unit, '(*(a, 1x))') &
            "Number of atoms missmatch in", template, "and", input
         error stop
      end if

      ! move_alloc can also move non-allocated objects
      call move_alloc(mol_template%lattice, mol%lattice)
      call move_alloc(mol_template%periodic, mol%periodic)
      call move_alloc(mol_template%bond, mol%bond)
      call move_alloc(mol_template%comment, mol%comment)
      call move_alloc(mol_template%pdb, mol%pdb)
      call move_alloc(mol_template%sdf, mol%sdf)
   end if

   if (normalize) then
      mol%sym = to_symbol(mol%num)
   end if

   if (output == "-") then
      if (.not.allocated(output_format)) output_format = filetype%xyz
      call write_structure(mol, output_unit, output_format, error)
   else
      call write_structure(mol, output, error, output_format)
   end if
   if (allocated(error)) then
      write(error_unit, '(a)') error%message
      error stop
   end if


contains


subroutine help(unit)
   integer, intent(in) :: unit

   write(unit, '(a, *(1x, a))') &
      "Usage: "//prog_name//" [options] <input> <output>"

   write(unit, '(a)') &
      "", &
      "Read structure from input file and writes it to output file.", &
      "The format is determined by the file extension or the format hint", &
      ""

   write(unit, '(2x, a, t25, a)') &
      "-i, --input <format>", "Hint for the format of the input file", &
      "-o, --output <format>", "Hint for the format of the output file", &
      "--normalize", "Normalize all element symbols to capitalized format", &
      "--template <file>", "File to use as template to fill in meta data", &
      "", "(useful to add back SDF or PDB annotions)", &
      "--template-format <format>", "", "", "Hint for the format of the template file", &
      "--ignore-dot-files", "Do not read charge and spin from .CHRG and .UHF files", &
      "--version", "Print program version and exit", &
      "--help", "Show this help message"

   write(unit, '(a)')

end subroutine help


subroutine version(unit)
   integer, intent(in) :: unit
   character(len=:), allocatable :: version_string

   call get_mctc_version(string=version_string)
   write(unit, '(a, *(1x, a))') &
      & prog_name, "version", version_string

end subroutine version


subroutine get_arguments(input, input_format, output, output_format, normalize, &
      & template, template_format, read_dot_files, error)

   !> Input file name
   character(len=:), allocatable :: input

   !> Input file format
   integer, allocatable, intent(out) :: input_format

   !> Output file name
   character(len=:), allocatable :: output

   !> Output file format
   integer, allocatable, intent(out) :: output_format

   !> Template file name
   character(len=:), allocatable :: template

   !> Template file format
   integer, allocatable, intent(out) :: template_format

   !> Normalize element symbols
   logical, intent(out) :: normalize

   !> Read information from .CHRG and .UHF files
   logical, intent(out) :: read_dot_files

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   character(len=:), allocatable :: arg

   normalize = .false.
   read_dot_files = .true.
   iarg = 0
   narg = command_argument_count()
   do while(iarg < narg)
      iarg = iarg + 1
      call get_argument(iarg, arg)
      select case(arg)
      case("--help")
         call help(output_unit)
         stop
      case("--version")
         call version(output_unit)
         stop
      case default
         if (.not.allocated(input)) then
            call move_alloc(arg, input)
            cycle
         end if
         if (.not.allocated(output)) then
            call move_alloc(arg, output)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      case("-i", "--input")
         iarg = iarg + 1
         call get_argument(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for input format")
            exit
         end if
         if (index(arg, ".") == 0) arg = "."//arg
         input_format = get_filetype(arg)
      case("-o", "--output")
         iarg = iarg + 1
         call get_argument(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for output format")
            exit
         end if
         output_format = get_filetype("."//arg)
      case("--normalize")
         normalize = .true.
      case("--template")
         iarg = iarg + 1
         call get_argument(iarg, template)
         if (.not.allocated(template)) then
            call fatal_error(error, "Missing argument for template file")
            exit
         end if
      case("--template-format")
         iarg = iarg + 1
         call get_argument(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for template format")
            exit
         end if
         template_format = get_filetype("."//arg)
      case("--ignore-dot-files")
         read_dot_files = .false.
      end select
   end do

   if (.not.(allocated(input).and.(allocated(output)))) then
      if (.not.allocated(error)) then
         call help(output_unit)
         error stop
      end if
   end if

end subroutine get_arguments


!> Extract dirname from path
function dirname(filename)
   character(len=*), intent(in) :: filename
   character(len=:), allocatable :: dirname

   dirname = filename(1:scan(filename, "/\", back=.true.))
   if (len_trim(dirname) == 0) dirname = "."
end function dirname


!> Construct path by joining strings with os file separator
function join(a1, a2) result(path)
   use mctc_env_system, only : is_windows
   character(len=*), intent(in) :: a1, a2
   character(len=:), allocatable :: path
   character :: filesep

   if (is_windows()) then
      filesep = '\'
   else
      filesep = '/'
   end if

   path = a1 // filesep // a2
end function join


!> test if pathname already exists
function exists(filename)
    character(len=*), intent(in) :: filename
    logical :: exists
    inquire(file=filename, exist=exists)
end function exists


subroutine read_file(filename, val, error)
   use mctc_io_utils, only : next_line, read_next_token, io_error, token_type
   character(len=*), intent(in) :: filename
   integer, intent(out) :: val
   type(error_type), allocatable, intent(out) :: error

   integer :: io, stat, lnum, pos
   type(token_type) :: token
   character(len=:), allocatable :: line

   lnum = 0

   open(file=filename, newunit=io, status='old', iostat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Error: Could not open file '"//filename//"'")
      return
   end if

   call next_line(io, line, pos, lnum, stat)
   if (stat == 0) &
      call read_next_token(line, pos, token, val, stat)
   if (stat /= 0) then
      call io_error(error, "Cannot read value from file", line, token, &
         filename, lnum, "expected integer value")
      return
   end if

   close(io, iostat=stat)

end subroutine read_file


end program main

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/ceh/singlepoint.f90
!> Provides main entry point for performing a CEH calculation
!> follows in close analogy the xtb singlepoint

!> Implementation of the single point calculation for the CEH model
module tblite_ceh_singlepoint
   use mctc_env, only : error_type, wp
   use mctc_io, only: structure_type
   use tblite_adjlist, only : adjacency_list, new_adjacency_list
   use tblite_cutoff, only : get_lattice_points
   use tblite_basis_type, only : get_cutoff
   use tblite_context, only : context_type
   use tblite_output_format, only: format_string
   use tblite_integral_type, only : integral_type, new_integral
   use tblite_wavefunction, only : wavefunction_type, &
   & get_alpha_beta_occupation
   use tblite_wavefunction_mulliken, only: get_mulliken_shell_charges, &
   & get_mulliken_atomic_multipoles
   use tblite_scf_iterator, only: next_density, get_qat_from_qsh
   use tblite_scf, only: new_potential, potential_type 
   use tblite_container, only : container_cache
   use tblite_scf_potential, only: add_pot_to_h1
   use tblite_scf_solver, only : solver_type
   use tblite_blas, only : gemv
   use tblite_ceh_h0, only : get_hamiltonian, get_scaled_selfenergy, get_occupation
   use tblite_ceh_ceh, only : get_effective_qat
   use tblite_xtb_spec, only : tb_h0spec 
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_timer, only : timer_type, format_time
   implicit none
   private

   public :: ceh_singlepoint

   real(wp), parameter :: cn_cutoff = 25.0_wp


   character(len=*), parameter :: real_format = "(es20.13)"
   character(len=25), parameter :: &
      label_cutoff = "integral cutoff", &
      label_charges = "CEH atomic charges", &
      label_dipole = "CEH mol. dip. mom. / a.u."

contains


   !> Run the CEH calculation (equivalent to xtb_singlepoint)
   subroutine ceh_singlepoint(ctx, calc, mol, wfn, accuracy, verbosity)
      !> Calculation context
      type(context_type), intent(inout) :: ctx
      !> CEH calculator
      type(xtb_calculator), intent(inout) :: calc
      !> Molecular structure data
      type(structure_type), intent(in)  :: mol
      !> Wavefunction data
      type(wavefunction_type), intent(inout) :: wfn
      !> Accuracy for computation
      real(wp), intent(in) :: accuracy
      !> Verbosity level of output
      integer, intent(in), optional :: verbosity

      ! Molecular dipole moment
      real(wp) :: dipole(3)
      ! Integral container
      type(integral_type) :: ints
      ! Electronic solver
      class(solver_type), allocatable :: solver
      ! Adjacency list
      type(adjacency_list) :: list
      ! Potential type
      type(potential_type) :: pot
      ! Restart data for interaction containers and coulomb 
      type(container_cache) :: icache, ccache
      ! Timer
      type(timer_type) :: timer
      ! Error container
      type(error_type), allocatable :: error
      
      logical :: grad
      real(wp) :: elec_entropy
      real(wp) :: nel, cutoff
      real(wp), allocatable :: tmp(:)

      integer :: prlevel

      ! coordination number related arrays
      real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :), cn_en(:), dcn_endr(:, :, :), dcn_endL(:, :, :)
      ! self energy related arrays
      real(wp), allocatable :: selfenergy(:), dsedcn(:), dsedcn_en(:), lattr(:, :)

      call timer%push("total CEH")

      if (present(verbosity)) then
         prlevel = verbosity
      else
         prlevel = ctx%verbosity
      end if

      if (prlevel > 1) then
         call ctx%message("CEH singlepoint")
      endif
      ! Gradient logical as future starting point (not implemented yet)
      ! Entry point could either be (i) modified wavefunction type (including derivatives),
      ! (iii) additional wavefunction derivative type (see old commits) or (ii) optional
      ! dqdR variable in this routine
      grad = .false.

      ! Define occupation
      call get_occupation(mol, calc%bas, calc%h0, wfn%nocc, wfn%n0at, wfn%n0sh)
      nel = sum(wfn%n0at) - mol%charge
      if (mod(mol%uhf, 2) == mod(nint(nel), 2)) then
         wfn%nuhf = mol%uhf
      else
         wfn%nuhf = mod(nint(nel), 2)
      end if
      call get_alpha_beta_occupation(wfn%nocc, wfn%nuhf, wfn%nel(1), wfn%nel(2))

      call timer%push("hamiltonian")
      ! calculate coordination number (CN) and the EN-weighted coordination number
      if (allocated(calc%ncoord)) then
         allocate(cn(mol%nat))
         if (grad) then
            allocate(dcndr(3, mol%nat, mol%nat), dcndL(3, 3, mol%nat))
         end if
         call calc%ncoord%get_cn(mol, cn, dcndr, dcndL)
      end if
      if (allocated(calc%ncoord_en)) then
         allocate(cn_en(mol%nat))
         if (grad) then
            allocate(dcn_endr(3, mol%nat, mol%nat), dcn_endL(3, 3, mol%nat))
         end if
         call calc%ncoord_en%get_cn(mol, cn_en, dcn_endr, dcn_endL)
      end if

      ! calculate the scaled self energies
      allocate(selfenergy(calc%bas%nsh), dsedcn(calc%bas%nsh), dsedcn_en(calc%bas%nsh))
      call get_scaled_selfenergy(calc%h0, mol%id, calc%bas%ish_at, calc%bas%nsh_id, cn=cn, cn_en=cn_en, &
      & selfenergy=selfenergy, dsedcn=dsedcn, dsedcn_en=dsedcn_en)

      cutoff = get_cutoff(calc%bas, accuracy)
      call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)
      call new_adjacency_list(list, mol, lattr, cutoff)

      if (prlevel > 1) then
         call ctx%message(label_cutoff // format_string(cutoff, real_format) // " bohr")
         call ctx%message("")
      end if

      ! Get Hamiltonian and integrals
      call new_integral(ints, calc%bas%nao)
      call get_hamiltonian(mol, lattr, list, calc%bas, calc%h0, selfenergy, &
      & ints%overlap, ints%overlap_diat, ints%dipole, ints%hamiltonian)
      call timer%pop

      ! Get initial potential for external fields and Coulomb
      call new_potential(pot, mol, calc%bas, wfn%nspin)
      ! Set potential to zero
      call pot%reset
      ! Add potential due to external field
      if (allocated(calc%interactions)) then
         call timer%push("interactions")
         call calc%interactions%update(mol, icache)
         call calc%interactions%get_potential(mol, icache, wfn, pot)
         call timer%pop
      endif

      ! Add potential due to Coulomb
      if (allocated(calc%coulomb)) then
         call timer%push("coulomb")
         ! Use electronegativity-weighted CN as 0th-order charge guess
         call get_effective_qat(mol, cn_en, wfn%qat)
      
         call calc%coulomb%update(mol, ccache)
         call calc%coulomb%get_potential(mol, ccache, wfn, pot)
         call timer%pop
      end if

      ! Add effective Hamiltonian to potential
      call add_pot_to_h1(calc%bas, ints, pot, wfn%coeff)

      call timer%push("diagonalization")
      ! Solve the effective Hamiltonian
      call ctx%new_solver(solver, ints%overlap, wfn%nel, wfn%kt)

      ! Get the density matrix
      call next_density(wfn, solver, ints, elec_entropy, error)
      if (allocated(error)) then
         call ctx%set_error(error)
      end if
      call timer%pop

      ! Get charges and dipole moment from density and integrals
      call get_mulliken_shell_charges(calc%bas, ints%overlap, wfn%density, wfn%n0sh, &
      & wfn%qsh)
      call get_qat_from_qsh(calc%bas, wfn%qsh, wfn%qat)
      call get_mulliken_atomic_multipoles(calc%bas, ints%dipole, wfn%density, &
      & wfn%dpat)
      allocate(tmp(3), source = 0.0_wp)
      call gemv(mol%xyz, wfn%qat(:, 1), tmp)
      dipole(:) = tmp + sum(wfn%dpat(:, :, 1), 2)

      call timer%pop
      
      block
         integer :: it
         real(wp) :: ttime, stime
         character(len=*), parameter :: label(*) = [character(len=20):: &
            & "coulomb", "hamiltonian", "diagonalization"]
         if (prlevel > 1) then
            ttime = timer%get("total CEH")
            call ctx%message(" total CEH:"//repeat(" ", 16)//format_time(ttime))
         end if
         if (prlevel > 2) then
            do it = 1, size(label)
               stime = timer%get(label(it))
               if (stime <= epsilon(0.0_wp)) cycle
               call ctx%message(" - "//label(it)//format_time(stime) &
                  & //" ("//format_string(int(stime/ttime*100), '(i3)')//"%)")
            end do
            call ctx%message("")
         end if
      end block

   end subroutine ceh_singlepoint

end module tblite_ceh_singlepoint

program test_ddx_error
use ddx_errors
implicit none

type(ddx_error_type) :: ddx_error
character(len=40) :: ref_text

! we artificially set the max_length to a small value
ddx_error % max_length = 40

call update_error(ddx_error, "<1 block of 15>")

ref_text(1:16) = " <1 block of 15>"
ref_text(17:17) = achar(10)

if (ddx_error % message(1:ddx_error % message_length) .ne. ref_text(1:ddx_error%message_length)) &
    & stop 1

call update_error(ddx_error, "<2 block of 15>")
ref_text(18:33) = " <2 block of 15>"
ref_text(34:34) = achar(10)

write(6,"(A,A,A)") ddx_error % message(1:ddx_error % message_length), "<"
write(6,"(A,A,A)") ref_text(1:ddx_error % message_length), "<"

if (ddx_error % message(1:ddx_error % message_length) .ne. ref_text(1:ddx_error%message_length)) &
    & stop 2

call update_error(ddx_error, "<3 block of 15>")
ref_text(35:38) = " <3 "
ref_text(39:39) = achar(10)

if (ddx_error % message(1:ddx_error % message_length) .ne. ref_text(1:ddx_error%message_length)) &
    & stop 3

call print_error(ddx_error)
call reset_error(ddx_error)
call check_error(ddx_error)

contains

end program test_ddx_error

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> @dir mctc/ncoord
!> Contains the implementation for the coordination number evaluators.

!> @file mctc/ncoord.f90
!> Reexports the coordination number evaluation modules.

!> Proxy module to expose coordination number containers
module mctc_ncoord
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_io, only : structure_type
   use mctc_ncoord_type, only : ncoord_type
   use mctc_ncoord_dexp, only : dexp_ncoord_type, new_dexp_ncoord
   use mctc_ncoord_exp, only : exp_ncoord_type, new_exp_ncoord
   use mctc_ncoord_erf, only : erf_ncoord_type, new_erf_ncoord
   use mctc_ncoord_erf_en, only : erf_en_ncoord_type, new_erf_en_ncoord
   use mctc_ncoord_erf_dftd4, only : erf_dftd4_ncoord_type, new_erf_dftd4_ncoord
   implicit none
   private

   public :: ncoord_type, new_ncoord, cn_count, get_cn_count_id, get_cn_count_string


   !> Possible coordination number counting functions
   type :: enum_cn_count

      !> Exponential counting function
      integer :: exp = 1

      !> Double-exponential counting function
      integer :: dexp = 2

      !> Error-function-based counting function
      integer :: erf = 3

      !> Electronegativity-weighted error-function-based counting function
      integer :: erf_en = 4

      !> DFT-D4 error-function-based counting function
      integer :: dftd4 = 5

   end type enum_cn_count

   !> Actual enumerator possible coordination numbers
   type(enum_cn_count), parameter :: cn_count = enum_cn_count()

contains

!> Create a new generic coordination number container
subroutine new_ncoord(self, mol, cn_count_type, error, kcn, cutoff, rcov, en, cut, norm_exp)
   !> Instance of the coordination number container
   class(ncoord_type), allocatable, intent(out) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Coordination number type
   integer, intent(in) :: cn_count_type
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Optional steepness of counting function
   real(wp), intent(in), optional :: kcn
   !> Optional real space cutoff
   real(wp), intent(in), optional :: cutoff
   !> Optional set of covalent radii to be used in CN
   real(wp), intent(in), optional :: rcov(:)
   !> Optional set of electronegativities to be used in CN
   real(wp), intent(in), optional :: en(:)
   !> Optional cutoff for the maximum coordination number
   real(wp), intent(in), optional :: cut
   !> Optional exponent of the distance normalization
   real(wp), intent(in), optional :: norm_exp

   select case(cn_count_type)
   case default 
      call fatal_error(error, "Unsupported option for coordination number")
      return 
   case(cn_count%exp)
      block
         type(exp_ncoord_type), allocatable :: tmp
         allocate(tmp)
         call new_exp_ncoord(tmp, mol, kcn=kcn, cutoff=cutoff, rcov=rcov, cut=cut)
         call move_alloc(tmp, self)
      end block
   case(cn_count%dexp)
      block
         type(dexp_ncoord_type), allocatable :: tmp
         allocate(tmp)
         call new_dexp_ncoord(tmp, mol, cutoff=cutoff, rcov=rcov, cut=cut)
         call move_alloc(tmp, self)
      end block
   case(cn_count%erf)
      block
         type(erf_ncoord_type), allocatable :: tmp
         allocate(tmp)
         call new_erf_ncoord(tmp, mol, kcn=kcn, cutoff=cutoff, &
            & rcov=rcov, cut=cut, norm_exp=norm_exp)
         call move_alloc(tmp, self)
      end block
   case(cn_count%erf_en)
      block
         type(erf_en_ncoord_type), allocatable :: tmp
         allocate(tmp)
         call new_erf_en_ncoord(tmp, mol, kcn=kcn, cutoff=cutoff, &
            & rcov=rcov, en=en, cut=cut, norm_exp=norm_exp)
         call move_alloc(tmp, self)
      end block
   case(cn_count%dftd4)
      block
         type(erf_dftd4_ncoord_type), allocatable :: tmp
         allocate(tmp)
         call new_erf_dftd4_ncoord(tmp, mol, kcn=kcn, cutoff=cutoff, &
            & rcov=rcov, en=en, cut=cut, norm_exp=norm_exp)
         call move_alloc(tmp, self)
      end block
   end select

end subroutine new_ncoord

!> Translate string into coordination number type
pure function get_cn_count_id(cn_count_name) result(cn_count_id)
   !> String for coordination number counting function
   character(len=*), intent(in) :: cn_count_name
   !> ID for coordination number counting function
   integer :: cn_count_id

   select case(cn_count_name)
   case default
      ! Indicate unknown CN option
      cn_count_id = -1 
   case("exp")
      cn_count_id = cn_count%exp
   case("dexp")
      cn_count_id = cn_count%dexp
   case("erf")
      cn_count_id = cn_count%erf
   case("erf_en")
      cn_count_id = cn_count%erf_en
   case("dftd4")
      cn_count_id = cn_count%dftd4
   end select

end function get_cn_count_id

!> Translate string into coordination number type
pure function get_cn_count_string(cn_count_id) result(cn_count_name)
   !> ID for coordination number counting function
   integer, intent(in) :: cn_count_id
   !> String for coordination number counting function
   character(len=:), allocatable :: cn_count_name

   select case(cn_count_id)
   case default
      ! Empty string to indicate unknown CN option
      cn_count_name = ""
   case(cn_count%exp)
      cn_count_name = "exp"
   case(cn_count%dexp)
      cn_count_name = "dexp"
   case(cn_count%erf)
      cn_count_name = "erf"
   case(cn_count%erf_en)
      cn_count_name = "erf_en"
   case(cn_count%dftd4)
      cn_count_name = "dftd4"
   end select

end function get_cn_count_string

end module mctc_ncoord

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the driver entry points for parameter optimizations
module tblite_driver_fit
   use mctc_env, only : error_type, fatal_error, get_argument, wp
   use mctc_io, only : structure_type, read_structure, write_structure, &
      & filetype, get_filetype, to_symbol
   use mctc_io_resize, only : resize
   use tblite_cli, only : fit_config
   use tblite_context_type, only : context_type
   use tblite_output_format, only : format_string
   use tblite_param, only : param_record, count
   use tblite_fit_newuoa, only : newuoa
   use tblite_fit_settings, only : fit_settings
   use tblite_os, only : setenv, file_exists, delete_file
   implicit none
   private

   public :: main

   interface main
      module procedure :: fit_main
   end interface


contains


subroutine fit_main(config, error)
   type(fit_config), intent(in) :: config
   type(error_type), allocatable, intent(out) :: error

   type(fit_settings), target :: set
   type(context_type) :: ctx
   integer :: stat, npar
   real(wp), allocatable :: array(:)
   class(*), pointer :: handle
   real(wp), parameter :: conv = 1.0e-5_wp

   allocate(set%base)
   call set%base%load(config%param, error)
   if (allocated(error)) return

   call clear_metadata(set%base)

   call set%load(config%input, error)
   if (allocated(error)) return

   npar = count(set%mask)
   allocate(array(npar))
   if (set%relative) then
      array(:) = 1.0_wp
   else
      call set%base%dump(array, set%mask, error)
   end if
   if (allocated(error)) return

   call summary(ctx%unit, config, set)

   call setenv("TBLITE_EXE", config%prog, stat)
   call setenv("TBLITE_OUT", set%output, stat)
   call setenv("TBLITE_PAR", set%fitpar, stat)

   if (allocated(config%copy_input)) then
      call set%dump(config%copy_input, error)
      if (allocated(error)) return
      call ctx%message("[Info] Input settings dumped to '"//config%copy_input//"'")
   end if

   call write_param(set, array, error)
   if (allocated(error)) return

   if (config%dry_run) then
      call ctx%message("[Info] Initial parameters written to '"//set%fitpar//"'")
      return
   end if

   handle => set
   call newuoa(npar, 2*npar, array, set%trustr, conv, config%verbosity, set%max_iter*npar, &
      & eval, handle, error)
   if (allocated(error)) return

   call write_param(set, array, error)
   if (allocated(error)) return
   call ctx%message("[Info] Final parameters written to '"//set%fitpar//"'")
end subroutine fit_main


subroutine summary(unit, config, set)
   integer, intent(in) :: unit
   type(fit_config), intent(in) :: config
   type(fit_settings), intent(in) :: set

   write(unit, '(a, t30, a)') &
      & "Optimization method", set%method, &
      & "Max. function evaluations", format_string(count(set%mask)*set%max_iter, '(i0)'), &
      & "Number of parameters", format_string(count(set%mask), '(i0)'), &
      & "Initial trust radius", format_string(set%trustr, '(f8.6)'), &
      & "Initial parameter file", config%param, &
      & "Script command", "'"//set%script//"'"
end subroutine summary


function eval(n, x, h, error) result(f)
   integer, intent(in) :: n
   real(wp), intent(in) :: x(*)
   class(*), intent(in) :: h
   type(error_type), allocatable, intent(out) :: error
   real(wp) :: f

   integer :: stat
   real(wp), allocatable :: actual(:), reference(:)

   f = huge(0.0_wp)

   select type(set => h)
   type is (fit_settings)
      call write_param(set, x(1:n), error)
      if (allocated(error)) return

      call delete_file(set%output)

      call execute_command_line(set%script, exitstat=stat)
      if (stat /= 0) then
         call fatal_error(error, "Running '"//set%script//"' failed")
         return
      end if

      if (.not.file_exists(set%output)) then
         call fatal_error(error, "Output data '"//set%script//"' of script not found")
         return
      end if

      call read_data(set%output, actual, reference)

      f = sum((actual - reference)**2)
   end select

end function eval


subroutine read_data(file, actual, reference)
   character(len=*), intent(in) :: file
   real(wp), allocatable, intent(out) :: actual(:), reference(:)
   integer :: idata, stat, unit

   open(file=file, newunit=unit)
   call resize(actual)
   call resize(reference)
   idata = 0
   stat = 0
   do while(stat == 0)
      if (idata >= min(size(reference), size(actual))) then
         call resize(actual)
         call resize(reference)
      end if
      idata = idata + 1
      read(unit, *, iostat=stat) reference(idata), actual(idata)
      if (stat /= 0) idata = idata - 1
   end do
   close(unit)

   call resize(actual, idata)
   call resize(reference, idata)
end subroutine read_data


!> Make sure no stale meta data is present in parameter file
subroutine clear_metadata(param)
   type(param_record), intent(inout) :: param

   param%version = 0
   if (allocated(param%name)) deallocate(param%name)
   if (allocated(param%reference)) deallocate(param%reference)
end subroutine clear_metadata


subroutine write_param(set, array, error)
   type(fit_settings), intent(in) :: set
   real(wp), intent(in) :: array(:)
   type(error_type), allocatable, intent(out) :: error

   type(param_record) :: param
   real(wp), allocatable :: p(:)

   if (set%relative) then
      allocate(p(size(array)))
      call set%base%dump(p, set%mask, error)
      if (allocated(error)) return
      p(:) = array * p
      call param%load(p, set%base, set%mask, error)
      if (allocated(error)) return
   else
      call param%load(array, set%base, set%mask, error)
      if (allocated(error)) return
   end if

   call param%dump(set%fitpar, error)
   if (allocated(error)) return
end subroutine write_param


end module tblite_driver_fit

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Definition of the command-line interface of the tblite framework
module tblite_cli
   use, intrinsic :: iso_fortran_env, only : output_unit, error_unit, input_unit
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : filetype, get_filetype, to_symbol
   use tblite_argument, only : argument_list, len
   use tblite_cli_help, only : prog_name, help_text, help_text_run, help_text_param, &
      & help_text_fit, help_text_tagdiff, help_text_guess
   use tblite_features, only : get_tblite_feature
   use tblite_lapack_solver, only : lapack_algorithm
   use tblite_solvation, only : solvation_input, cpcm_input, alpb_input, &
      & cds_input, shift_input, solvent_data, get_solvent_data, solution_state, born_kernel
   use tblite_version, only : get_tblite_version
   use tblite_xtb_calculator, only : xtb_config
   implicit none
   private

   public :: get_arguments, driver_config, run_config, param_config, fit_config, &
      & tagdiff_config, guess_config


   type, abstract :: driver_config
      logical :: color = .false.
   end type driver_config

   !> Configuration for evaluating tight binding model on input structure
   type, extends(driver_config) :: run_config
      !> Geometry input file
      character(len=:), allocatable :: input
      !> Format for reading the input file
      integer, allocatable :: input_format
      !> Evaluate gradient
      logical :: grad = .false.
      !> File for output of gradient information
      character(len=:), allocatable :: grad_output
      !> Verbosity of calculation
      integer :: verbosity = 2
      !> Total charge of the system
      integer, allocatable :: charge
      !> Number of unpaired electrons
      integer, allocatable :: spin
      !> Parametrization of the xTB Hamiltonian to use
      character(len=:), allocatable :: method
      !> Parametrization file to use for calculation
      character(len=:), allocatable :: param
      !> Guess for SCF calculation
      character(len=:), allocatable :: guess
      !> Restart from previous calculation
      logical :: restart = .false.
      !> Restart file
      character(len=:), allocatable :: restart_file
      !> Create JSON dump
      logical :: json = .false.
      !> File for output of JSON dump
      character(len=:), allocatable :: json_output
      !> Input for solvation model
      type(solvation_input), allocatable :: solvation
      !> Input for post processing container
      character(len=:), allocatable :: post_processing
      !> Input for post processing container
      character(len=:), allocatable :: post_proc_output
      !> Numerical accuracy for self-consistent iterations
      real(wp) :: accuracy = 1.0_wp
      !> Maximum number of iterations for SCF
      integer, allocatable :: max_iter
      !> Electronic temperature
      real(wp) :: etemp = 300.0_wp
      !> Electronic temperature for the guess (currently only CEH)
      real(wp) :: etemp_guess = 4000.0_wp
      !> Electric field
      real(wp), allocatable :: efield(:)
      !> Spin polarization
      logical :: spin_polarized = .false.
      !> Algorithm for electronic solver
      integer :: solver = lapack_algorithm%gvd
      !> Configuration for xtb calculator
      type(xtb_config) :: cfg = xtb_config()
   end type run_config

   !> Configuration for evaluating tight binding model on input structure
   type, extends(driver_config) :: guess_config
      !> Geometry input file
      character(len=:), allocatable :: input
      !> Format for reading the input file
      integer, allocatable :: input_format
      !> Evaluate gradient
      logical :: grad = .false.
      !> Verbosity of calculation
      integer :: verbosity = 1
      !> Total charge of the system
      integer, allocatable :: charge
      !> Number of unpaired electrons
      integer, allocatable :: spin
      !> Parametrization of the xTB Hamiltonian to use
      character(len=:), allocatable :: method
      !> Numerical accuracy for self-consistent iterations
      real(wp) :: accuracy = 1.0_wp
      !> Create JSON dump
      logical :: json = .false.
      !> File for output of JSON dump
      character(len=:), allocatable :: json_output
      !> Electronic temperature for the guess (currently only CEH)
      real(wp) :: etemp_guess = 4000.0_wp
      !> Electric field
      real(wp), allocatable :: efield(:)
      !> Algorithm for electronic solver
      integer :: solver = lapack_algorithm%gvd
   end type guess_config

   type, extends(driver_config) :: param_config
      integer :: verbosity = 2
      character(len=:), allocatable :: input
      character(len=:), allocatable :: output
      character(len=:), allocatable :: method
   end type param_config

   type, extends(driver_config) :: fit_config
      integer :: verbosity = 2
      character(len=:), allocatable :: prog
      character(len=:), allocatable :: param
      character(len=:), allocatable :: input
      character(len=:), allocatable :: copy_input
      logical :: dry_run = .false.
   end type fit_config

   type, extends(driver_config) :: tagdiff_config
      character(len=:), allocatable :: actual
      character(len=:), allocatable :: reference
      logical :: fit = .false.
   end type tagdiff_config

contains

subroutine get_arguments(config, error)

   !> Command line options
   class(driver_config), allocatable, intent(out) :: config

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(argument_list) :: list
   integer :: iarg, narg
   logical :: getopts
   character(len=:), allocatable :: arg
   logical, allocatable :: color

   list = argument_list()

   iarg = 0
   getopts = .true.
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      select case(arg)
      case("--help")
         write(output_unit, '(a)') help_text
         stop
      case("--version")
         call version(output_unit)
         stop
      case default
         iarg = iarg - 1
         allocate(run_config :: config)
         exit
      case("--color")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for color options")
            exit
         end if
         select case(arg)
         case default
            call fatal_error(error, "Unknown option for color support '"//arg//"'")
         case("always")
            color = .true.
         case("never")
            color = .false.
         case("auto")
            color = get_tblite_feature("color")
         end select
      case("fit")
         allocate(fit_config :: config)
         exit
      case("param")
         allocate(param_config :: config)
         exit
      case("run")
         allocate(run_config :: config)
         exit
      case("guess")
         allocate(guess_config :: config)
         exit
      case("tagdiff")
         allocate(tagdiff_config :: config)
         exit
      end select
   end do
   if (allocated(error)) return

   if (.not.allocated(config)) then
      write(output_unit, '(a)') help_text
      error stop
   end if

   select type(config)
   type is (fit_config)
      call get_fit_arguments(config, list, iarg, error)
   type is (param_config)
      call get_param_arguments(config, list, iarg, error)
   type is (run_config)
      call get_run_arguments(config, list, iarg, error)
   type is (guess_config)
      call get_guess_arguments(config, list, iarg, error)
   type is (tagdiff_config)
      call get_tagdiff_arguments(config, list, iarg, error)
   end select
   if (allocated(error)) return

   if (allocated(color)) config%color = color

end subroutine get_arguments


subroutine get_run_arguments(config, list, start, error)

   !> Command line options
   type(run_config), intent(out) :: config

   !> List of command line arguments
   type(argument_list), intent(in) :: list

   !> First command line argument
   integer, intent(in) :: start

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   logical :: getopts
   character(len=:), allocatable :: arg, sec
   logical :: solvent_not_found, parametrized_solvation
   logical, allocatable :: alpb
   integer, allocatable :: kernel, sol_state
   type(solvent_data), allocatable :: solvent

   iarg = start
   getopts = .true.
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      if (.not.getopts) then
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end if
      select case(arg)
      case("--")
         getopts = .false.

      case("--help")
         write(output_unit, '(a)') help_text_run
         stop

      case("--version")
         call version(output_unit)
         stop

      case("-v", "-vv", "--verbose")
         config%verbosity = config%verbosity + 1
         if (arg == "-vv") config%verbosity = config%verbosity + 1

      case("-s", "-ss", "--silent")
         config%verbosity = config%verbosity - 1
         if (arg == "-ss") config%verbosity = config%verbosity - 1

      case default
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit

      case("-i", "--input")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for input format")
            exit
         end if
         config%input_format = get_filetype("."//arg)

      case("-c", "--charge")
         iarg = iarg + 1
         allocate(config%charge)
         call list%get(iarg, arg)
         call get_argument_as_int(arg, config%charge, error)
         if (allocated(error)) exit

      case("--spin")
         iarg = iarg + 1
         allocate(config%spin)
         call list%get(iarg, arg)
         call get_argument_as_int(arg, config%spin, error)
         if (allocated(error)) exit

      case("--spin-polarized")
         config%spin_polarized = .true.

      case("--method")
         if (allocated(config%param)) then
            call fatal_error(error, "Cannot specify method if parameter file is provided")
            exit
         end if
         iarg = iarg + 1
         call list%get(iarg, config%method)
         if (.not.allocated(config%method)) then
            call fatal_error(error, "Missing argument for method")
            exit
         end if

      case("--guess")
         iarg = iarg + 1
         call list%get(iarg, config%guess)

      case("--config")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for config")
            exit
         end if

         block
            integer :: ieq

            ieq = index(arg, "=")
            if (ieq == 0) then
               call fatal_error(error, "Invalid format for config argument, expected key=value")
               exit
            end if
            sec = arg(ieq+1:)

            select case(arg(1:ieq-1))
            case("smooth_cutoff")
               call get_argument_as_real(sec, config%cfg%smooth_cutoff, error)
            case default
               call fatal_error(error, "Unknown configuration key '"//arg(1:ieq-1)//"'")
               exit
            end select
         end block

      case("--restart")
         iarg = iarg + 1
         config%restart = .true.
         config%restart_file = "tblite-restart.npz"
         call list%get(iarg, arg)
         if (allocated(arg)) then
            if (arg(1:1) == "-" .or. &
               & iarg == narg .and. .not.allocated(config%input)) then
               iarg = iarg - 1
               cycle
            end if
            call move_alloc(arg, config%restart_file)
         end if

      case("--no-restart")
         config%restart = .false.

      case("--solv-state")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing solution state")
            exit
         end if

         select case(arg)
         case("gsolv")
            sol_state = solution_state%gsolv
         case("bar1mol")
            sol_state = solution_state%bar1mol
         case("reference")
            sol_state = solution_state%reference
         case default
            call fatal_error(error, "Unknown solution state '"//arg//"'")
            exit
         end select

      case("--born-kernel")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing Born kernel")
            exit
         end if

         select case(arg)
         case("p16")
            kernel = born_kernel%p16
         case("still")
            kernel = born_kernel%still
         case default
            call fatal_error(error, "Unknown Born kernel '"//arg//"'")
            exit
         end select

      case("--cpcm")
         if (allocated(solvent)) then
            call fatal_error(error, "Cannot use multiple solvation models")
            exit
         end if
         parametrized_solvation = .false.

         ! Check for solvent information
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for CPCM")
            exit
         end if
         solvent_not_found = .false.
         allocate(solvent)
         solvent = get_solvent_data(arg)
         if (solvent%eps <= 0.0_wp) then
            solvent_not_found = .true.
            call get_argument_as_real(arg, solvent%eps, error)
         end if
         if (allocated(error)) exit

      case("--gb", "--gbe")
         if (allocated(solvent)) then
            call fatal_error(error, "Cannot use multiple solvation models")
            exit
         end if 
         parametrized_solvation = .false.
         alpb = arg == "--gbe"

         ! Check for solvent information
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for ALPB/GBSA")
            exit
         end if
         allocate(solvent)
         solvent = get_solvent_data(arg)
         if (solvent%eps <= 0.0_wp) then
            call get_argument_as_real(arg, solvent%eps, error)
         end if
         if (allocated(error)) exit

      case("--alpb", "--gbsa")
         if (allocated(solvent)) then
            call fatal_error(error, "Cannot use multiple solvation models")
            exit
         end if 
         parametrized_solvation = .true.
         alpb = arg == "--alpb"

         ! Check for solvent information
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for ALPB/GBSA")
            exit
         end if
         allocate(solvent)
         solvent = get_solvent_data(arg)
         if (allocated(error)) exit

      case("--param")
         if (allocated(config%param)) then
            call fatal_error(error, "Cannot specify parameter file if method is provided")
            exit
         end if
         iarg = iarg + 1
          call list%get(iarg, config%param)
         if (.not.allocated(config%param)) then
            call fatal_error(error, "Missing argument for param")
            exit
         end if

      case("--post-processing")
         iarg = iarg + 1 
         call list%get(iarg, config%post_processing)
         if (.not.allocated(config%post_processing)) then
            call fatal_error(error, "Missing argument for post processing")
            exit
         end if

      case("--acc")
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%accuracy, error)
         if (allocated(error)) exit

      case("--iterations")
         iarg = iarg + 1
         call list%get(iarg, arg)
         allocate(config%max_iter)
         call get_argument_as_int(arg, config%max_iter, error)
         if (allocated(error)) exit

      case("--solver")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for solver")
            exit
         end if

         select case(arg)
         case default
            call fatal_error(error, "Unknown electronic solver '"//arg//"' specified")
            exit
         case("gvd")
            config%solver = lapack_algorithm%gvd
         case("gvr")
            config%solver = lapack_algorithm%gvr
         end select

      case("--etemp")
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%etemp, error)
         if (allocated(error)) exit

      case("--etemp-guess")
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%etemp_guess, error)
         if (allocated(error)) exit

      case("--efield")
         iarg = iarg + 1
         call list%get(iarg, arg)
         allocate(config%efield(3))
         call get_argument_as_realv(arg, config%efield, error)
         if (allocated(error)) exit

      case("--grad")
         config%grad = .true.
         config%grad_output = "tblite.txt"
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (allocated(arg)) then
            if (arg(1:1) == "-" .or. &
               & iarg == narg .and. .not.allocated(config%input)) then
               iarg = iarg - 1
               cycle
            end if
            call move_alloc(arg, config%grad_output)
         end if

      case("--json")
         config%json = .true.
         config%json_output = "tblite.json"
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (allocated(arg)) then
            if (arg(1:1) == "-" .or. &
               & iarg == narg .and. .not.allocated(config%input)) then
               iarg = iarg - 1
               cycle
            end if
            call move_alloc(arg, config%json_output)
         end if
      end select
   end do

   if (.not.(allocated(config%input))) then
      if (.not.allocated(error)) then
         write(output_unit, '(a)') help_text_run
         error stop
      end if
   end if

   if (allocated(config%post_processing) .and. .not.allocated(config%post_proc_output)) then
      config%post_proc_output = "tblite-data.npz"
   end if

   if (allocated(solvent)) then
      if (.not.allocated(sol_state)) then
         sol_state = solution_state%gsolv
      end if
      if (allocated(alpb)) then
         ! ALPB/GBSA solvation model
         if (.not.allocated(kernel)) then
            kernel = merge(born_kernel%still, born_kernel%p16, alpb)
         end if

         if (.not.parametrized_solvation .and. sol_state /= solution_state%gsolv) then
            call fatal_error(error, "Solution state shift is only supported for named solvents")
            return
         end if

         allocate(config%solvation)
         if (parametrized_solvation) then
            config%solvation%alpb = alpb_input(solvent%eps, solvent=solvent%solvent, &
               & kernel=kernel, alpb=alpb)
            config%solvation%cds = cds_input(alpb=alpb, solvent=solvent%solvent)
            config%solvation%shift = shift_input(alpb=alpb, solvent=solvent%solvent, &
               & state=sol_state)
         else
            config%solvation%alpb = alpb_input(solvent%eps, kernel=kernel, alpb=alpb)
         end if
      else
         ! CPCM solvation model
         if (sol_state /= solution_state%gsolv) then 
            call fatal_error(error, "Solution state shift not supported for CPCM")
            return
         end if
         allocate(config%solvation)
         config%solvation%cpcm = cpcm_input(solvent%eps)
      end if
   end if

   if (.not.allocated(config%guess)) config%guess = "sad"

   if (config%grad .and. .not.allocated(config%grad_output) .and. .not.config%json) then
      config%grad_output = "tblite.txt"
   end if
end subroutine get_run_arguments


subroutine get_guess_arguments(config, list, start, error)

   !> Command line options
   type(guess_config), intent(out) :: config

   !> List of command line arguments
   type(argument_list), intent(in) :: list

   !> First command line argument
   integer, intent(in) :: start

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   logical :: getopts
   character(len=:), allocatable :: arg

   iarg = start
   getopts = .true.
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      if (.not.getopts) then
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end if
      select case(arg)
      case("--")
         getopts = .false.

      case("--help")
         write(output_unit, '(a)') help_text_guess
         stop

      case("--version")
         call version(output_unit)
         stop

      case("-v", "-vv", "--verbose")
         config%verbosity = config%verbosity + 1
         if (arg == "-vv") config%verbosity = config%verbosity + 1

      case("-s", "-ss", "--silent")
         config%verbosity = config%verbosity - 1
         if (arg == "-ss") config%verbosity = config%verbosity - 1

      case default
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit

      case("-i", "--input")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for input format")
            exit
         end if
         config%input_format = get_filetype("."//arg)

      case("-c", "--charge")
         iarg = iarg + 1
         allocate(config%charge)
         call list%get(iarg, arg)
         call get_argument_as_int(arg, config%charge, error)
         if (allocated(error)) exit

      case("--spin")
         iarg = iarg + 1
         allocate(config%spin)
         call list%get(iarg, arg)
         call get_argument_as_int(arg, config%spin, error)
         if (allocated(error)) exit

      case("--method")
         iarg = iarg + 1
         call list%get(iarg, config%method)
         if (.not.allocated(config%method)) then
            call fatal_error(error, "Missing argument for method")
            exit
         end if

      case("--solver")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for solver")
            exit
         end if

         select case(arg)
         case default
            call fatal_error(error, "Unknown electronic solver '"//arg//"' specified")
            exit
         case("gvd")
            config%solver = lapack_algorithm%gvd
         case("gvr")
            config%solver = lapack_algorithm%gvr
         end select

      case("--etemp-guess")
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%etemp_guess, error)
         if (allocated(error)) exit

      case("--efield")
         iarg = iarg + 1
         call list%get(iarg, arg)
         allocate(config%efield(3))
         call get_argument_as_realv(arg, config%efield, error)
         if (allocated(error)) exit

      case("--grad")
         config%grad = .true.

      case("--acc")
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%accuracy, error)
         if (allocated(error)) exit

      case("--json")
         config%json = .true.
         config%json_output = "tblite.json"
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (allocated(arg)) then
            if (arg(1:1) == "-") then
               iarg = iarg - 1
               cycle
            end if
            call move_alloc(arg, config%json_output)
         end if
      end select
   end do

   if (.not.(allocated(config%input))) then
      if (.not.allocated(error)) then
         write(output_unit, '(a)') help_text_guess
         error stop
      end if
   end if

end subroutine get_guess_arguments

subroutine get_param_arguments(config, list, start, error)

   !> Command line options
   type(param_config), intent(out) :: config

   !> List of command line arguments
   type(argument_list), intent(in) :: list

   !> First command line argument
   integer, intent(in) :: start

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   logical :: getopts
   character(len=:), allocatable :: arg

   iarg = start
   getopts = .true.
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      if (.not.getopts) then
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end if
      select case(arg)
      case("--")
         getopts = .false.
      case("--help")
         write(output_unit, '(a)') help_text_param
         stop
      case("--version")
         call version(output_unit)
         stop
      case default
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      case("--method")
         iarg = iarg + 1
         call list%get(iarg, config%method)
         if (.not.allocated(config%method)) then
            call fatal_error(error, "Missing argument for method")
            exit
         end if
      case("--output")
         iarg = iarg + 1
         call list%get(iarg, config%output)
         if (.not.allocated(config%output)) then
            call fatal_error(error, "Missing argument for output")
            exit
         end if
      end select
   end do

   if (.not.any([allocated(config%input), allocated(config%method)])) then
      if (.not.allocated(error)) then
         write(output_unit, '(a)') help_text_param
         error stop
      end if
   end if
end subroutine get_param_arguments


subroutine get_fit_arguments(config, list, start, error)

   !> Command line options
   type(fit_config), intent(out) :: config

   !> List of command line arguments
   type(argument_list), intent(in) :: list

   !> First command line argument
   integer, intent(in) :: start

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   logical :: getopts
   character(len=:), allocatable :: arg

   config%prog = list%prog

   iarg = start
   getopts = .true.
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      if (.not.getopts) then
         if (.not.allocated(config%param)) then
            call move_alloc(arg, config%param)
            cycle
         end if
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end if
      select case(arg)
      case("--")
         getopts = .false.
      case("--help")
         write(output_unit, '(a)') help_text_fit
         stop
      case("--version")
         call version(output_unit)
         stop
      case("--dry-run")
         config%dry_run = .true.
      case("-v", "-vv", "--verbose")
         config%verbosity = config%verbosity + 1
         if (arg == "-vv") config%verbosity = config%verbosity + 1
      case("-s", "-ss", "--silent")
         config%verbosity = config%verbosity - 1
         if (arg == "-ss") config%verbosity = config%verbosity - 1
      case("--copy")
         iarg = iarg + 1
         call list%get(iarg, config%copy_input)
         if (.not.allocated(config%copy_input)) then
            call fatal_error(error, "Missing argument for copy")
            exit
         end if
      case default
         if (.not.allocated(config%param)) then
            call move_alloc(arg, config%param)
            cycle
         end if
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end select
   end do

   if (.not.allocated(config%input)) then
      if (.not.allocated(error)) then
         write(output_unit, '(a)') help_text_fit
         error stop
      end if
   end if
end subroutine get_fit_arguments


subroutine get_tagdiff_arguments(config, list, start, error)

   !> Command line options
   type(tagdiff_config), intent(out) :: config

   !> List of command line arguments
   type(argument_list), intent(in) :: list

   !> First command line argument
   integer, intent(in) :: start

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   logical :: getopts
   character(len=:), allocatable :: arg

   iarg = start
   getopts = .true.
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      if (.not.getopts) then
         if (.not.allocated(config%actual)) then
            call move_alloc(arg, config%actual)
            cycle
         end if
         if (.not.allocated(config%reference)) then
            call move_alloc(arg, config%reference)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end if
      select case(arg)
      case("--")
         getopts = .false.
      case("--help")
         write(output_unit, '(a)') help_text_tagdiff
         stop
      case("--version")
         call version(output_unit)
         stop
      case("--fit")
         config%fit = .true.
      case default
         if (.not.allocated(config%actual)) then
            call move_alloc(arg, config%actual)
            cycle
         end if
         if (.not.allocated(config%reference)) then
            call move_alloc(arg, config%reference)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end select
   end do

   if (.not.(allocated(config%actual).and.allocated(config%reference))) then
      if (.not.allocated(error)) then
         write(output_unit, '(a)') help_text_tagdiff
         error stop
      end if
   end if
end subroutine get_tagdiff_arguments


subroutine get_argument_as_real(arg, val, error)
   !> Index of command line argument, range [0:command_argument_count()]
   character(len=:), intent(in), allocatable :: arg
   !> Real value
   real(wp), intent(out) :: val
   !> Error handling
   type(error_type), allocatable :: error

   integer :: stat

   if (.not.allocated(arg)) then
      call fatal_error(error, "Cannot read real value, argument missing")
      return
   end if
   read(arg, *, iostat=stat) val
   if (stat /= 0) then
      call fatal_error(error, "Cannot read real value from '"//arg//"'")
      return
   end if

end subroutine get_argument_as_real


subroutine get_argument_as_realv(arg, val, error)
   !> Index of command line argument, range [0:command_argument_count()]
   character(len=:), intent(in), allocatable :: arg
   !> Real value
   real(wp), intent(out) :: val(:)
   !> Error handling
   type(error_type), allocatable :: error

   integer :: stat
   integer :: i
   character(len=*), parameter :: sep = ","
   character(len=:), allocatable :: targ

   if (.not.allocated(arg)) then
      call fatal_error(error, "Cannot read real value, argument missing")
      return
   end if
   allocate(character(len=len(arg)) :: targ)
   do i = 1, len(arg)
      if (arg(i:i) == sep) then
         targ(i:i) = " "
      else
         targ(i:i) = arg(i:i)
      end if
   end do
   read(targ, *, iostat=stat) val
   if (stat /= 0) then
      call fatal_error(error, "Cannot read real value from '"//arg//"'")
      return
   end if

end subroutine get_argument_as_realv


subroutine get_argument_as_int(arg, val, error)
   !> Index of command line argument, range [0:command_argument_count()]
   character(len=:), intent(in), allocatable :: arg
   !> Real value
   integer, intent(out) :: val
   !> Error handling
   type(error_type), allocatable :: error

   integer :: stat

   if (.not.allocated(arg)) then
      call fatal_error(error, "Cannot read integer value, argument missing")
      return
   end if
   read(arg, *, iostat=stat) val
   if (stat /= 0) then
      call fatal_error(error, "Cannot read integer value from '"//arg//"'")
      return
   end if

end subroutine get_argument_as_int


subroutine version(unit)
   integer, intent(in) :: unit
   character(len=:), allocatable :: version_string

   call get_tblite_version(string=version_string)
   write(unit, '(a, *(1x, a))') &
      & prog_name, "version", version_string

end subroutine version


end module tblite_cli

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/integral/dipole.f90
!> Provides evaluation of dipole moment integrals

!> Implementation of dipole moment integrals
module tblite_integral_dipole
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_constants, only : pi
   use tblite_basis_type, only : basis_type, cgto_type
   use tblite_integral_trafo, only : transform0, transform1, transform2
   use tblite_integral_diat_trafo, only: diat_trafo
   implicit none
   private

   public :: dipole_cgto, dipole_cgto_diat, dipole_grad_cgto
   public :: get_dipole_integrals
   public :: maxl, msao, smap

   interface get_dipole_integrals
      module procedure :: get_dipole_integrals_lat
      module procedure :: get_dipole_integrals_diat_lat
   end interface get_dipole_integrals

   integer, parameter :: maxl = 6
   integer, parameter :: maxl2 = maxl*2
   integer, parameter :: msao(0:maxl) = [1, 3, 5, 7, 9, 11, 13]
   integer, parameter :: mlao(0:maxl) = [1, 3, 6, 10, 15, 21, 28]
   integer, parameter :: smap(0:maxl) = [0, 1, 4, 9, 16, 25, 36]
   integer, parameter :: lmap(0:maxl) = [0, 1, 4, 10, 20, 35, 56]
   integer, parameter :: sdim(0:maxl) = [1, 4, 9, 16, 25, 36, 49]
   real(wp), parameter :: sqrtpi = sqrt(pi)
   real(wp), parameter :: sqrtpi3 = sqrtpi**3

   ! x (+1), y (-1), z (0) in [-1, 0, 1] sorting
   integer, parameter :: lx(3, 84) = reshape([&
      & 0, &
      & 0,0,1, &
      & 2,0,0,1,1,0, &
      & 3,0,0,2,2,1,0,1,0,1, &
      & 4,0,0,3,3,1,0,1,0,2,2,0,2,1,1, &
      & 5,0,0,3,3,2,2,0,0,4,4,1,0,0,1,1,3,1,2,2,1, &
      & 6,0,0,3,3,0,5,5,1,0,0,1,4,4,2,0,2,0,3,3,1,2,2,1,4,1,1,2, &
      & 0, &
      & 1,0,0, &
      & 0,2,0,1,0,1, &
      & 0,3,0,1,0,2,2,0,1,1, &
      & 0,4,0,1,0,3,3,0,1,2,0,2,1,2,1, &
      & 0,5,0,2,0,3,0,3,2,1,0,4,4,1,0,1,1,3,2,1,2, &
      & 0,6,0,3,0,3,1,0,0,1,5,5,2,0,0,2,4,4,2,1,3,1,3,2,1,4,1,2, &
      & 0, &
      & 0,1,0, &
      & 0,0,2,0,1,1, &
      & 0,0,3,0,1,0,1,2,2,1, &
      & 0,0,4,0,1,0,1,3,3,0,2,2,1,1,2, &
      & 0,0,5,0,2,0,3,2,3,0,1,0,1,4,4,3,1,1,1,2,2, &
      & 0,0,6,0,3,3,0,1,5,5,1,0,0,2,4,4,0,2,1,2,2,3,1,3,1,1,4,2], &
      & shape(lx), order=[2, 1])


contains


elemental function overlap_1d(moment, alpha) result(overlap)
   integer, intent(in) :: moment
   real(wp), intent(in) :: alpha
   real(wp) :: overlap
   real(wp), parameter :: dfactorial(0:7) = & ! see OEIS A001147
      & [1._wp,1._wp,3._wp,15._wp,105._wp,945._wp,10395._wp,135135._wp]

   if (modulo(moment, 2) == 0) then
      overlap = (0.5_wp/alpha)**(moment/2) * dfactorial(moment/2)
   else
      overlap = 0.0_wp
   end if
end function overlap_1d


pure subroutine horizontal_shift(ae, l, cfs)
   integer, intent(in) :: l
   real(wp), intent(in) :: ae
   real(wp), intent(inout) :: cfs(*)
   select case(l)
   case(0) ! s
      continue
   case(1) ! p
      cfs(1)=cfs(1)+ae*cfs(2)
   case(2) ! d
      cfs(1)=cfs(1)+ae*ae*cfs(3)
      cfs(2)=cfs(2)+ 2*ae*cfs(3)
   case(3) ! f
      cfs(1)=cfs(1)+ae*ae*ae*cfs(4)
      cfs(2)=cfs(2)+ 3*ae*ae*cfs(4)
      cfs(3)=cfs(3)+ 3*ae*cfs(4)
   case(4) ! g
      cfs(1)=cfs(1)+ae*ae*ae*ae*cfs(5)
      cfs(2)=cfs(2)+ 4*ae*ae*ae*cfs(5)
      cfs(3)=cfs(3)+ 6*ae*ae*cfs(5)
      cfs(4)=cfs(4)+ 4*ae*cfs(5)
   end select
end subroutine horizontal_shift

pure subroutine form_product(a, b, la, lb, d)
   integer, intent(in) :: la, lb
   real(wp), intent(in) :: a(*), b(*)
   real(wp), intent(inout) :: d(*)
   if(la.ge.4.or.lb.ge.4) goto 40
   if(la.ge.3.or.lb.ge.3) goto 30
   if(la.ge.2.or.lb.ge.2) goto 20
   ! <s|s> = <s>
   d(1)=a(1)*b(1)
   if(la.eq.0.and.lb.eq.0) return
   ! <s|p> = <s|*(|s>+|p>)
   !       = <s> + <p>
   d(2)=a(1)*b(2)+a(2)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|p> = (<s|+<p|)*(|s>+|p>)
   !       = <s> + <p> + <d>
   d(3)=a(2)*b(2)
   return
20 continue
   ! <s|d> = <s|*(|s>+|p>+|d>)
   !       = <s> + <p> + <d>
   d(1)=a(1)*b(1)
   d(2)=a(1)*b(2)+a(2)*b(1)
   d(3)=a(1)*b(3)+a(3)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|d> = (<s|+<p|)*(|s>+|p>+|d>)
   !       = <s> + <p> + <d> + <f>
   d(3)=d(3)+a(2)*b(2)
   d(4)=a(2)*b(3)+a(3)*b(2)
   if(la.le.1.or.lb.le.1) return
   ! <d|d> = (<s|+<p|+<d|)*(|s>+|p>+|d>)
   !       = <s> + <p> + <d> + <f> + <g>
   d(5)=a(3)*b(3)
   return
30 continue
   ! <s|f> = <s|*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f>
   d(1)=a(1)*b(1)
   d(2)=a(1)*b(2)+a(2)*b(1)
   d(3)=a(1)*b(3)+a(3)*b(1)
   d(4)=a(1)*b(4)+a(4)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|f> = (<s|+<p|)*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f> + <g>
   d(3)=d(3)+a(2)*b(2)
   d(4)=d(4)+a(2)*b(3)+a(3)*b(2)
   d(5)=a(2)*b(4)+a(4)*b(2)
   if(la.le.1.or.lb.le.1) return
   ! <d|f> = (<s|+<p|+<d|)*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f> + <g> + <h>
   d(5)=d(5)+a(3)*b(3)
   d(6)=a(3)*b(4)+a(4)*b(3)
   if(la.le.2.or.lb.le.2) return
   ! <f|f> = (<s|+<p|+<d|+<f|)*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i>
   d(7)=a(4)*b(4)
   return
40 continue
   ! <s|g> = <s|*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g>
   d(1)=a(1)*b(1)
   d(2)=a(1)*b(2)+a(2)*b(1)
   d(3)=a(1)*b(3)+a(3)*b(1)
   d(4)=a(1)*b(4)+a(4)*b(1)
   d(5)=a(1)*b(5)+a(5)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|g> = (<s|+<p|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h>
   d(3)=d(3)+a(2)*b(2)
   d(4)=d(4)+a(2)*b(3)+a(3)*b(2)
   d(5)=d(5)+a(2)*b(4)+a(4)*b(2)
   d(6)=a(2)*b(5)+a(5)*b(2)
   if(la.le.1.or.lb.le.1) return
   ! <d|g> = (<s|+<p|+<d|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i>
   d(5)=d(5)+a(3)*b(3)
   d(6)=d(5)+a(3)*b(4)+a(4)*b(3)
   d(7)=a(3)*b(5)+a(5)*b(3)
   if(la.le.2.or.lb.le.2) return
   ! <f|g> = (<s|+<p|+<d|+<f|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i> + <k>
   d(7)=d(7)+a(4)*b(4)
   d(8)=a(4)*b(5)+a(5)*b(4)
   if(la.le.3.or.lb.le.3) return
   ! <g|g> = (<s|+<p|+<d|+<f|+<g|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i> + <k> + <l>
   d(9)=a(5)*b(5)

end subroutine form_product


pure subroutine dipole_3d(rpj, rpi, aj, ai, lj, li, s1d, s3d, d3d)
   real(wp), intent(in) :: rpi(3)
   real(wp), intent(in) :: rpj(3)
   real(wp), intent(in) :: ai
   real(wp), intent(in) :: aj
   integer, intent(in) :: li(3)
   integer, intent(in) :: lj(3)
   real(wp), intent(in) :: s1d(0:)
   real(wp), intent(out) :: s3d
   real(wp), intent(out) :: d3d(3)

   integer :: k, l
   real(wp) :: vi(0:maxl), vj(0:maxl), vv(0:maxl2), v1d(3, 2)
   real(wp), parameter :: s3 = sqrt(3.0_wp), s3_4 = s3 * 0.5_wp

   v1d(:, :) = 0.0_wp

   do k = 1, 3
      vv(:) = 0.0_wp
      vi(:) = 0.0_wp
      vj(:) = 0.0_wp
      vi(li(k)) = 1.0_wp
      vj(lj(k)) = 1.0_wp

      call horizontal_shift(rpi(k), li(k), vi)
      call horizontal_shift(rpj(k), lj(k), vj)
      call form_product(vi, vj, li(k), lj(k), vv)
      do l = 0, li(k) + lj(k)
         v1d(k, 1) = v1d(k, 1) + s1d(l) * vv(l)
         v1d(k, 2) = v1d(k, 2) + (s1d(l+1) + rpi(k)*s1d(l)) * vv(l)
      end do
   end do

   s3d = v1d(1, 1) * v1d(2, 1) * v1d(3, 1)
   d3d(1) = v1d(1, 2) * v1d(2, 1) * v1d(3, 1)
   d3d(2) = v1d(1, 1) * v1d(2, 2) * v1d(3, 1)
   d3d(3) = v1d(1, 1) * v1d(2, 1) * v1d(3, 2)

end subroutine dipole_3d


pure subroutine dipole_grad_3d(rpj, rpi, aj, ai, lj, li, s1d, s3d, d3d, &
      & ds3d, dd3d)
   real(wp), intent(in) :: rpi(3)
   real(wp), intent(in) :: rpj(3)
   real(wp), intent(in) :: ai
   real(wp), intent(in) :: aj
   integer, intent(in) :: li(3)
   integer, intent(in) :: lj(3)
   real(wp), intent(in) :: s1d(0:)
   real(wp), intent(out) :: s3d
   real(wp), intent(out) :: d3d(3)
   real(wp), intent(out) :: ds3d(3)
   real(wp), intent(out) :: dd3d(3, 3)

   integer :: k, l
   real(wp) :: vi(0:maxl), vj(0:maxl), vv(0:maxl2), v1d(3, 2)
   real(wp) :: gi(0:maxl), gg(0:maxl2), g1d(3, 2)

   v1d(:, :) = 0.0_wp
   g1d(:, :) = 0.0_wp

   do k = 1, 3
      vv(:) = 0.0_wp
      gg(:) = 0.0_wp
      vi(:) = 0.0_wp
      vj(:) = 0.0_wp
      gi(:) = 0.0_wp

      vi(li(k)) = 1.0_wp
      vj(lj(k)) = 1.0_wp
      gi(li(k)+1) = 2*ai
      if (li(k) > 0) gi(li(k)-1) = -li(k)

      call horizontal_shift(rpi(k), li(k)-1, gi)
      call horizontal_shift(rpi(k), li(k)+1, gi)
      call horizontal_shift(rpi(k), li(k), vi)
      call horizontal_shift(rpj(k), lj(k), vj)
      call form_product(vi, vj, li(k), lj(k), vv)
      call form_product(gi, vj, li(k)+1, lj(k), gg)
      do l = 0, li(k) + lj(k) + 1
         v1d(k, 1) = v1d(k, 1) + s1d(l) * vv(l)
         v1d(k, 2) = v1d(k, 2) + (s1d(l+1) + rpi(k)*s1d(l)) * vv(l)
         g1d(k, 1) = g1d(k, 1) + s1d(l) * gg(l)
         g1d(k, 2) = g1d(k, 2) + (s1d(l+1) + rpi(k)*s1d(l)) * gg(l)
      end do
   end do

   s3d = v1d(1, 1) * v1d(2, 1) * v1d(3, 1)
   d3d(1) = v1d(1, 2) * v1d(2, 1) * v1d(3, 1)
   d3d(2) = v1d(1, 1) * v1d(2, 2) * v1d(3, 1)
   d3d(3) = v1d(1, 1) * v1d(2, 1) * v1d(3, 2)

   ds3d(1) = g1d(1, 1) * v1d(2, 1) * v1d(3, 1)
   ds3d(2) = v1d(1, 1) * g1d(2, 1) * v1d(3, 1)
   ds3d(3) = v1d(1, 1) * v1d(2, 1) * g1d(3, 1)
   dd3d(1, 1) = g1d(1, 2) * v1d(2, 1) * v1d(3, 1)
   dd3d(2, 1) = v1d(1, 2) * g1d(2, 1) * v1d(3, 1)
   dd3d(3, 1) = v1d(1, 2) * v1d(2, 1) * g1d(3, 1)
   dd3d(1, 2) = g1d(1, 1) * v1d(2, 2) * v1d(3, 1)
   dd3d(2, 2) = v1d(1, 1) * g1d(2, 2) * v1d(3, 1)
   dd3d(3, 2) = v1d(1, 1) * v1d(2, 2) * g1d(3, 1)
   dd3d(1, 3) = g1d(1, 1) * v1d(2, 1) * v1d(3, 2)
   dd3d(2, 3) = v1d(1, 1) * g1d(2, 1) * v1d(3, 2)
   dd3d(3, 3) = v1d(1, 1) * v1d(2, 1) * g1d(3, 2)

end subroutine dipole_grad_3d


pure subroutine dipole_cgto(cgtoj, cgtoi, r2, vec, intcut, overlap, dpint)
   !> Description of contracted Gaussian function on center i
   type(cgto_type), intent(in) :: cgtoi
   !> Description of contracted Gaussian function on center j
   type(cgto_type), intent(in) :: cgtoj
   !> Square distance between center i and j
   real(wp), intent(in) :: r2
   !> Distance vector between center i and j, ri - rj
   real(wp), intent(in) :: vec(3)
   !> Maximum value of integral prefactor to consider
   real(wp), intent(in) :: intcut
   !> Overlap integrals for the given pair i  and j
   real(wp), intent(out) :: overlap(msao(cgtoj%ang), msao(cgtoi%ang))
   !> Dipole moment integrals for the given pair i  and j
   real(wp), intent(out) :: dpint(3, msao(cgtoj%ang), msao(cgtoi%ang))

   integer :: ip, jp, mli, mlj, l
   real(wp) :: eab, oab, est, s1d(0:maxl2), rpi(3), rpj(3), cc, val, dip(3), pre
   real(wp) :: s3d(mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: d3d(3, mlao(cgtoj%ang), mlao(cgtoi%ang))

   s3d(:, :) = 0.0_wp
   d3d(:, :, :) = 0.0_wp

   do ip = 1, cgtoi%nprim
      do jp = 1, cgtoj%nprim
         eab = cgtoi%alpha(ip) + cgtoj%alpha(jp)
         oab = 1.0_wp/eab
         est = cgtoi%alpha(ip) * cgtoj%alpha(jp) * r2 * oab
         if (est > intcut) cycle
         pre = exp(-est) * sqrtpi3*sqrt(oab)**3
         rpi = -vec * cgtoj%alpha(jp) * oab
         rpj = +vec * cgtoi%alpha(ip) * oab
         do l = 0, cgtoi%ang + cgtoj%ang + 1
            s1d(l) = overlap_1d(l, eab)
         end do
         cc = cgtoi%coeff(ip) * cgtoj%coeff(jp) * pre
         do mli = 1, mlao(cgtoi%ang)
            do mlj = 1, mlao(cgtoj%ang)
               call dipole_3d(rpj, rpi, cgtoj%alpha(jp), cgtoi%alpha(ip), &
                  & lx(:, mlj+lmap(cgtoj%ang)), lx(:, mli+lmap(cgtoi%ang)), &
                  & s1d, val, dip)
               s3d(mlj, mli) = s3d(mlj, mli) + cc*val
               d3d(:, mlj, mli) = d3d(:, mlj, mli) + cc*dip
            end do
         end do
      end do
   end do

   call transform0(cgtoj%ang, cgtoi%ang, s3d, overlap, .true., .true.)
   call transform1(cgtoj%ang, cgtoi%ang, d3d, dpint, .true., .true.)

end subroutine dipole_cgto

pure subroutine dipole_cgto_diat(cgtoj, cgtoi, r2, vec, intcut, &
& ksig, kpi, kdel, overlap, overlap_diat, dpint)
   !> Description of contracted Gaussian function on center i
   type(cgto_type), intent(in) :: cgtoi
   !> Description of contracted Gaussian function on center j
   type(cgto_type), intent(in) :: cgtoj
   !> Square distance between center i and j
   real(wp), intent(in) :: r2
   !> Distance vector between center i and j, ri - rj
   real(wp), intent(in) :: vec(3)
   !> Maximum value of integral prefactor to consider
   real(wp), intent(in) :: intcut
   !> Scaling factors for the diatomic frame for the three differnt bonding motifs
   real(wp), intent(in) :: ksig, kpi, kdel
   !> Overlap integrals (unscaled and diatomic frame-scaled) for the given pair i  and j
   real(wp), intent(out) :: overlap(msao(cgtoj%ang), msao(cgtoi%ang)), &
     & overlap_diat(msao(cgtoj%ang), msao(cgtoi%ang))
   !> Dipole moment integrals for the given pair i  and j
   real(wp), intent(out) :: dpint(3, msao(cgtoj%ang), msao(cgtoi%ang))

   integer :: ip, jp, mli, mlj, l, mapj, mapi
   real(wp) :: eab, oab, est, s1d(0:maxl2), rpi(3), rpj(3), cc, val, dip(3), pre
   real(wp) :: s3d(mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: d3d(3, mlao(cgtoj%ang), mlao(cgtoi%ang))

   !> Block overlap matrix as a technical intermediate for the diatomic frame
   real(wp) :: block_overlap(sdim(cgtoj%ang),sdim(cgtoi%ang))

   s3d(:, :) = 0.0_wp
   d3d(:, :, :) = 0.0_wp

   do ip = 1, cgtoi%nprim
      do jp = 1, cgtoj%nprim
         eab = cgtoi%alpha(ip) + cgtoj%alpha(jp)
         oab = 1.0_wp/eab
         est = cgtoi%alpha(ip) * cgtoj%alpha(jp) * r2 * oab
         if (est > intcut) cycle
         pre = exp(-est) * sqrtpi3*sqrt(oab)**3
         rpi = -vec * cgtoj%alpha(jp) * oab
         rpj = +vec * cgtoi%alpha(ip) * oab
         do l = 0, cgtoi%ang + cgtoj%ang + 1
            s1d(l) = overlap_1d(l, eab)
         end do
         cc = cgtoi%coeff(ip) * cgtoj%coeff(jp) * pre
         do mli = 1, mlao(cgtoi%ang)
            do mlj = 1, mlao(cgtoj%ang)
               call dipole_3d(rpj, rpi, cgtoj%alpha(jp), cgtoi%alpha(ip), &
                  & lx(:, mlj+lmap(cgtoj%ang)), lx(:, mli+lmap(cgtoi%ang)), &
                  & s1d, val, dip)
               s3d(mlj, mli) = s3d(mlj, mli) + cc*val
               d3d(:, mlj, mli) = d3d(:, mlj, mli) + cc*dip
            end do
         end do
      end do
   end do

   call transform0(cgtoj%ang, cgtoi%ang, s3d, overlap, .true., .true.)
   call transform1(cgtoj%ang, cgtoi%ang, d3d, dpint, .true., .true.)

   ! Write the cgto overlap into the diatomic matrix
   block_overlap = 0.0_wp
   mapj = smap(cgtoj%ang)
   mapi = smap(cgtoi%ang)
   block_overlap(mapj+1:mapj+msao(cgtoj%ang), mapi+1:mapi+msao(cgtoi%ang)) = &
     & overlap(1:msao(cgtoj%ang), 1:msao(cgtoi%ang))

   ! Do the transformation and scaling 
   call diat_trafo(block_overlap, vec, ksig, kpi, kdel, cgtoj%ang, cgtoi%ang)
   
   ! Write back the scaled diatomic frame overlap
   overlap_diat(1:msao(cgtoj%ang), 1:msao(cgtoi%ang)) = &
     & block_overlap(mapj+1:mapj+msao(cgtoj%ang), mapi+1:mapi+msao(cgtoi%ang))

end subroutine dipole_cgto_diat

pure subroutine dipole_grad_cgto(cgtoj, cgtoi, r2, vec, intcut, overlap, dpint, &
      & doverlap, ddpint)
   !> Description of contracted Gaussian function on center i
   type(cgto_type), intent(in) :: cgtoi
   !> Description of contracted Gaussian function on center j
   type(cgto_type), intent(in) :: cgtoj
   !> Square distance between center i and j
   real(wp), intent(in) :: r2
   !> Distance vector between center i and j, ri - rj
   real(wp), intent(in) :: vec(3)
   !> Maximum value of integral prefactor to consider
   real(wp), intent(in) :: intcut
   !> Overlap integrals for the given pair i  and j
   real(wp), intent(out) :: overlap(msao(cgtoj%ang), msao(cgtoi%ang))
   !> Dipole moment integrals for the given pair i  and j
   real(wp), intent(out) :: dpint(3, msao(cgtoj%ang), msao(cgtoi%ang))
   !> Overlap integral gradient for the given pair i  and j
   real(wp), intent(out) :: doverlap(3, msao(cgtoj%ang), msao(cgtoi%ang))
   !> Dipole moment integral gradient for the given pair i  and j
   real(wp), intent(out) :: ddpint(3, 3, msao(cgtoj%ang), msao(cgtoi%ang))

   integer :: ip, jp, mli, mlj, l
   real(wp) :: eab, oab, est, s1d(0:maxl2), rpi(3), rpj(3), cc, val, dip(3)
   real(wp) :: pre, grad(3), ddip(3, 3)
   real(wp) :: s3d(mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: d3d(3, mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: ds3d(3, mlao(cgtoj%ang), mlao(cgtoi%ang))
   real(wp) :: dd3d(3, 3, mlao(cgtoj%ang), mlao(cgtoi%ang))

   s3d(:, :) = 0.0_wp
   d3d(:, :, :) = 0.0_wp
   ds3d(:, :, :) = 0.0_wp
   dd3d(:, :, :, :) = 0.0_wp

   do ip = 1, cgtoi%nprim
      do jp = 1, cgtoj%nprim
         eab = cgtoi%alpha(ip) + cgtoj%alpha(jp)
         oab = 1.0_wp/eab
         est = cgtoi%alpha(ip) * cgtoj%alpha(jp) * r2 * oab
         if (est > intcut) cycle
         pre = exp(-est) * sqrtpi3*sqrt(oab)**3
         rpi = -vec * cgtoj%alpha(jp) * oab
         rpj = +vec * cgtoi%alpha(ip) * oab
         do l = 0, cgtoi%ang + cgtoj%ang + 2
            s1d(l) = overlap_1d(l, eab)
         end do
         cc = cgtoi%coeff(ip) * cgtoj%coeff(jp) * pre
         do mli = 1, mlao(cgtoi%ang)
            do mlj = 1, mlao(cgtoj%ang)
               call dipole_grad_3d(rpj, rpi, cgtoj%alpha(jp), cgtoi%alpha(ip), &
                  & lx(:, mlj+lmap(cgtoj%ang)), lx(:, mli+lmap(cgtoi%ang)), &
                  & s1d, val, dip, grad, ddip)
               s3d(mlj, mli) = s3d(mlj, mli) + cc*val
               d3d(:, mlj, mli) = d3d(:, mlj, mli) + cc*dip
               ds3d(:, mlj, mli) = ds3d(:, mlj, mli) + cc*grad
               dd3d(:, :, mlj, mli) = dd3d(:, :, mlj, mli) + cc*ddip
            end do
         end do
      end do
   end do

   call transform0(cgtoj%ang, cgtoi%ang, s3d, overlap, .true., .true.)
   call transform1(cgtoj%ang, cgtoi%ang, d3d, dpint, .true., .true.)
   call transform1(cgtoj%ang, cgtoi%ang, ds3d, doverlap, .true., .true.)
   call transform2(cgtoj%ang, cgtoi%ang, dd3d, ddpint, .true., .true.)

end subroutine dipole_grad_cgto


!> Evaluate overlap for a molecular structure
subroutine get_dipole_integrals_lat(mol, trans, cutoff, bas, overlap, dpint)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points within a given realspace cutoff
   real(wp), intent(in) :: trans(:, :)
   !> Realspace cutoff
   real(wp), intent(in) :: cutoff
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Overlap matrix
   real(wp), intent(out) :: overlap(:, :)
   !> Dipole moment integral matrix
   real(wp), intent(out) :: dpint(:, :, :)

   integer :: iat, jat, izp, jzp, itr, is, js
   integer :: ish, jsh, ii, jj, iao, jao, nao
   real(wp) :: r2, vec(3), cutoff2
   real(wp), allocatable :: stmp(:), dtmp(:, :)

   overlap(:, :) = 0.0_wp
   dpint(:, :, :) = 0.0_wp

   allocate(stmp(msao(bas%maxl)**2), dtmp(3, msao(bas%maxl)**2))
   cutoff2 = cutoff**2

   !$omp parallel do schedule(runtime) default(none) &
   !$omp shared(mol, bas, trans, cutoff2, overlap, dpint) private(r2, vec, stmp, dtmp) &
   !$omp private(iat, jat, izp, jzp, itr, is, js, ish, jsh, ii, jj, iao, jao, nao)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = bas%ish_at(iat)
      do jat = 1, mol%nat
         jzp = mol%id(jat)
         js = bas%ish_at(jat)
         do itr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
            r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
            if (r2 > cutoff2) cycle
            do ish = 1, bas%nsh_id(izp)
               ii = bas%iao_sh(is+ish)
               do jsh = 1, bas%nsh_id(jzp)
                  jj = bas%iao_sh(js+jsh)
                  call dipole_cgto(bas%cgto(jsh, jzp), bas%cgto(ish, izp), &
                     & r2, vec, bas%intcut, stmp, dtmp)

                  nao = msao(bas%cgto(jsh, jzp)%ang)
                  !$omp simd collapse(2)
                  do iao = 1, msao(bas%cgto(ish, izp)%ang)
                     do jao = 1, nao
                        overlap(jj+jao, ii+iao) = overlap(jj+jao, ii+iao) &
                           & + stmp(jao + nao*(iao-1))

                        dpint(:, jj+jao, ii+iao) = dpint(:, jj+jao, ii+iao) &
                           & + dtmp(:, jao + nao*(iao-1))
                     end do
                  end do

               end do
            end do

         end do
      end do
   end do

end subroutine get_dipole_integrals_lat

!> Evaluate dipole integrals for a molecular structure
!> with diatomic-frame-scaled overlap elements
subroutine get_dipole_integrals_diat_lat(mol, &
   & trans, cutoff, bas, scal_fac, overlap, overlap_diat, dpint)
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Lattice points within a given realspace cutoff
   real(wp), intent(in) :: trans(:, :)
   !> Realspace cutoff
   real(wp), intent(in) :: cutoff
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Scaling factors for the diatomic frame
   real(wp), intent(in) :: scal_fac(:,:)
   !> Overlap matrix
   real(wp), intent(out) :: overlap(:, :)
   !> Overlap matrix with diatomic frame-scaled elements
   real(wp), intent(out) :: overlap_diat(:, :)
   !> Dipole moment integral matrix
   real(wp), intent(out) :: dpint(:, :, :)
   !> Scaling factors for the diatomic frame for the three differnt bonding motifs
   !> (sigma, pi, delta)
   real(wp) :: ksig, kpi, kdel

   integer :: iat, jat, izp, jzp, itr, is, js
   integer :: ish, jsh, ii, jj, iao, jao, nao
   real(wp) :: r2, vec(3), cutoff2
   real(wp), allocatable :: stmp(:), dtmp(:, :), stmp_diat(:)

   if (size(scal_fac,1) /= 3) then
      error stop 'Error: scal_fac must have the dimension of 3, &
      & since it covers the three different types of bonding'
   end if

   overlap(:, :) = 0.0_wp
   overlap_diat(:, :) = 0.0_wp
   dpint(:, :, :) = 0.0_wp

   allocate(stmp(msao(bas%maxl)**2), stmp_diat(msao(bas%maxl)**2), &
   & dtmp(3, msao(bas%maxl)**2))
   cutoff2 = cutoff**2

   !$omp parallel do schedule(runtime) default(none) &
   !$omp shared(mol, bas, trans, cutoff2, overlap, overlap_diat, dpint, scal_fac) &
   !$omp private(r2, vec, stmp, dtmp, stmp_diat) &
   !$omp private(iat, jat, izp, jzp, itr, is, js, ish, jsh, ii, jj, iao, jao, nao) &
   !$omp private(ksig, kpi, kdel)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      is = bas%ish_at(iat)
      do jat = 1, mol%nat
         jzp = mol%id(jat)
         js = bas%ish_at(jat)
         do itr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
            r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
            if (r2 > cutoff2) cycle
            if (iat /= jat) then
               !> Determine scaling factors from atom parameters
               ksig = 2.0_wp / (1.0_wp / scal_fac(1,mol%num(mol%id(iat))) &
               & + 1.0_wp / scal_fac(1,mol%num(mol%id(jat))) )
               kpi = 2.0_wp / (1.0_wp / scal_fac(2,mol%num(mol%id(iat))) &
               & + 1.0_wp / scal_fac(2,mol%num(mol%id(jat))) )
               kdel = 2.0_wp / (1.0_wp / scal_fac(3,mol%num(mol%id(iat))) &
               & + 1.0_wp / scal_fac(3,mol%num(mol%id(jat))) )
            end if
            do ish = 1, bas%nsh_id(izp)
               ii = bas%iao_sh(is+ish)
               do jsh = 1, bas%nsh_id(jzp)
                  jj = bas%iao_sh(js+jsh)
                  stmp = 0.0_wp
                  stmp_diat = 0.0_wp
                  dtmp = 0.0_wp
                  if (iat /= jat) then
                     call dipole_cgto_diat(bas%cgto(jsh, jzp), bas%cgto(ish, izp), &
                        & r2, vec, bas%intcut, ksig, kpi, kdel, &
                        & stmp, stmp_diat, dtmp)
                  else
                     call dipole_cgto(bas%cgto(jsh, jzp), bas%cgto(ish, izp), &
                        & r2, vec, bas%intcut, stmp, dtmp)
                     stmp_diat = stmp
                  endif
                  
                  nao = msao(bas%cgto(jsh, jzp)%ang)
                  !$omp simd collapse(2)
                  do iao = 1, msao(bas%cgto(ish, izp)%ang)
                     do jao = 1, msao(bas%cgto(jsh, jzp)%ang)
                        overlap(jj+jao, ii+iao) = overlap(jj+jao, ii+iao) &
                           & + stmp(jao + nao*(iao-1))
                        
                        overlap_diat(jj+jao, ii+iao) = overlap_diat(jj+jao, ii+iao) &
                           & + stmp_diat(jao + nao*(iao-1))
                        
                        dpint(:, jj+jao, ii+iao) = dpint(:, jj+jao, ii+iao) &
                           & + dtmp(:, jao + nao*(iao-1))
                     end do
                  end do

               end do
            end do

         end do
      end do
   end do

end subroutine get_dipole_integrals_diat_lat

end module tblite_integral_dipole

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

module dftd4_ncoord
   use, intrinsic :: iso_fortran_env, only : error_unit
   use mctc_env, only : error_type, wp
   use mctc_io, only : structure_type
   use mctc_ncoord, only : ncoord_type, new_ncoord, cn_count
   implicit none
   private

   public :: get_coordination_number, add_coordination_number_derivs


   !> Steepness of counting function
   real(wp), parameter :: default_kcn = 7.5_wp


contains


!> Geometric fractional coordination number, supports error function counting.
subroutine get_coordination_number(mol, trans, cutoff, rcov, en, cn, dcndr, dcndL)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_coordination_number

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Covalent radius
   real(wp), intent(in) :: rcov(:)

   !> Electronegativity
   real(wp), intent(in) :: en(:)

   !> Error function coordination number.
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates.
   real(wp), intent(out), optional :: dcndr(:, :, :)

   !> Derivative of the CN with respect to strain deformations.
   real(wp), intent(out), optional :: dcndL(:, :, :)

   class(ncoord_type), allocatable :: ncoord
   type(error_type), allocatable :: error

   call new_ncoord(ncoord, mol, cn_count%dftd4, &
      & kcn=default_kcn, cutoff=cutoff, rcov=rcov, en=en, error=error)
   if(allocated(error)) then
      write(error_unit, '("[Error]:", 1x, a)') error%message
      error stop
   end if

   call ncoord%get_coordination_number(mol, trans, cn, dcndr, dcndL)

end subroutine get_coordination_number


subroutine add_coordination_number_derivs(mol, trans, cutoff, rcov, en, dEdcn, gradient, sigma)

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Covalent radius
   real(wp), intent(in) :: rcov(:)

   !> Electronegativity
   real(wp), intent(in) :: en(:)

   !> Derivative of expression with respect to the coordination number
   real(wp), intent(in) :: dEdcn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates
   real(wp), intent(inout) :: gradient(:, :)

   !> Derivative of the CN with respect to strain deformations
   real(wp), intent(inout) :: sigma(:, :)


   class(ncoord_type), allocatable :: ncoord
   type(error_type), allocatable :: error

   call new_ncoord(ncoord, mol, cn_count%dftd4, &
      & kcn=default_kcn, cutoff=cutoff, rcov=rcov, en=en, error=error)
   if(allocated(error)) then
      write(error_unit, '("[Error]:", 1x, a)') error%message
      error stop
   end if

   call ncoord%add_coordination_number_derivs(mol, trans, dEdcn, gradient, sigma)

end subroutine add_coordination_number_derivs


end module dftd4_ncoord

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

!> High-level wrapper to obtain the dispersion energy for a DFT-D4 calculation
module dftd4_disp
   use, intrinsic :: iso_fortran_env, only : error_unit
   use dftd4_blas, only : d4_gemv
   use dftd4_cutoff, only : realspace_cutoff, get_lattice_points
   use dftd4_damping, only : damping_param
   use dftd4_data, only : get_covalent_rad
   use dftd4_model, only : dispersion_model
   use dftd4_ncoord, only : get_coordination_number, add_coordination_number_derivs
   use mctc_env, only : wp, error_type
   use mctc_io, only : structure_type
   use mctc_io_convert, only : autoaa
   use multicharge, only : get_charges
   implicit none
   private

   public :: get_dispersion, get_properties, get_pairwise_dispersion


contains


!> Wrapper to handle the evaluation of dispersion energy and derivatives
subroutine get_dispersion(mol, disp, param, cutoff, energy, gradient, sigma)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_dispersion

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Dispersion model
   class(dispersion_model), intent(in) :: disp

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Realspace cutoffs
   type(realspace_cutoff), intent(in) :: cutoff

   !> Dispersion energy
   real(wp), intent(out) :: energy

   !> Dispersion gradient
   real(wp), intent(out), contiguous, optional :: gradient(:, :)

   !> Dispersion virial
   real(wp), intent(out), contiguous, optional :: sigma(:, :)
 
   logical :: grad
   integer :: mref
   real(wp), allocatable :: cn(:)
   real(wp), allocatable :: q(:), dqdr(:, :, :), dqdL(:, :, :)
   real(wp), allocatable :: gwvec(:, :, :), gwdcn(:, :, :), gwdq(:, :, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :), dc6dq(:, :)
   real(wp), allocatable :: dEdcn(:), dEdq(:), energies(:)
   real(wp), allocatable :: lattr(:, :)
   type(error_type), allocatable :: error

   mref = maxval(disp%ref)
   grad = present(gradient).or.present(sigma)

   if (.not. allocated(disp%mchrg)) then
      write(error_unit, '("[Error]:", 1x, a)') "Not supported for non-self-consistent D4 version"
      error stop
   end if

   allocate(cn(mol%nat))
   call get_lattice_points(mol%periodic, mol%lattice, cutoff%cn, lattr)
   call get_coordination_number(mol, lattr, cutoff%cn, disp%rcov, disp%en, cn)

   allocate(q(mol%nat))
   if (grad) allocate(dqdr(3, mol%nat, mol%nat), dqdL(3, 3, mol%nat))
   call get_charges(disp%mchrg, mol, error, q, dqdr, dqdL)
   if(allocated(error)) then
      write(error_unit, '("[Error]:", 1x, a)') error%message
      error stop
   end if

   allocate(gwvec(mref, mol%nat, disp%ncoup))
   if (grad) allocate(gwdcn(mref, mol%nat, disp%ncoup), gwdq(mref, mol%nat, disp%ncoup))
   call disp%weight_references(mol, cn, q, gwvec, gwdcn, gwdq)

   allocate(c6(mol%nat, mol%nat))
   if (grad) allocate(dc6dcn(mol%nat, mol%nat), dc6dq(mol%nat, mol%nat))
   call disp%get_atomic_c6(mol, gwvec, gwdcn, gwdq, c6, dc6dcn, dc6dq)

   allocate(energies(mol%nat))
   energies(:) = 0.0_wp
   if (grad) then
      allocate(dEdcn(mol%nat), dEdq(mol%nat))
      dEdcn(:) = 0.0_wp
      dEdq(:) = 0.0_wp
      gradient(:, :) = 0.0_wp
      sigma(:, :) = 0.0_wp
   end if

   call get_lattice_points(mol%periodic, mol%lattice, cutoff%disp2, lattr)
   call param%get_dispersion2(mol, lattr, cutoff%disp2, cutoff%width2, disp%r4r2, &
      & c6, dc6dcn, dc6dq, energies, dEdcn, dEdq, gradient, sigma)
   if (grad) then
      call d4_gemv(dqdr, dEdq, gradient, beta=1.0_wp)
      call d4_gemv(dqdL, dEdq, sigma, beta=1.0_wp)
   end if

   q(:) = 0.0_wp
   call disp%weight_references(mol, cn, q, gwvec, gwdcn, gwdq)
   call disp%get_atomic_c6(mol, gwvec, gwdcn, gwdq, c6, dc6dcn, dc6dq)

   call get_lattice_points(mol%periodic, mol%lattice, cutoff%disp3, lattr)
   call param%get_dispersion3(mol, lattr, cutoff%disp3, cutoff%width3, disp%r4r2, &
      & c6, dc6dcn, dc6dq, energies, dEdcn, dEdq, gradient, sigma)
   if (grad) then
      call add_coordination_number_derivs(mol, lattr, cutoff%cn, &
         & disp%rcov, disp%en, dEdcn, gradient, sigma)
   end if

   energy = sum(energies)

end subroutine get_dispersion


!> Wrapper to handle the evaluation of properties related to this dispersion model
subroutine get_properties(mol, disp, cutoff, cn, q, c6, alpha)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_properties

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Dispersion model
   class(dispersion_model), intent(in) :: disp

   !> Realspace cutoffs
   type(realspace_cutoff), intent(in) :: cutoff

   !> Coordination number
   real(wp), intent(out) :: cn(:)

   !> Atomic partial charges
   real(wp), intent(out), contiguous :: q(:)

   !> C6 coefficients
   real(wp), intent(out) :: c6(:, :)

   !> Static polarizabilities
   real(wp), intent(out) :: alpha(:)

   integer :: mref
   real(wp), allocatable :: gwvec(:, :, :), lattr(:, :)
   type(error_type), allocatable :: error

   if (.not. allocated(disp%mchrg)) then
      write(error_unit, '("[Error]:", 1x, a)') "Not supported for non-self-consistent D4 version"
      error stop
   end if

   mref = maxval(disp%ref)

   call get_lattice_points(mol%periodic, mol%lattice, cutoff%cn, lattr)
   call get_coordination_number(mol, lattr, cutoff%cn, disp%rcov, disp%en, cn)

   call get_charges(disp%mchrg, mol, error, q)
   if(allocated(error)) then
      write(error_unit, '("[Error]:", 1x, a)') error%message
      error stop
   end if

   allocate(gwvec(mref, mol%nat, disp%ncoup))
   call disp%weight_references(mol, cn, q, gwvec)

   call disp%get_atomic_c6(mol, gwvec, c6=c6)
   call disp%get_polarizabilities(mol, gwvec, alpha=alpha)

end subroutine get_properties


!> Wrapper to handle the evaluation of pairwise representation of the dispersion energy
subroutine get_pairwise_dispersion(mol, disp, param, cutoff, energy2, energy3)
   !DEC$ ATTRIBUTES DLLEXPORT :: get_pairwise_dispersion

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Dispersion model
   class(dispersion_model), intent(in) :: disp

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Realspace cutoffs
   type(realspace_cutoff), intent(in) :: cutoff

   !> Pairwise representation of additive dispersion energy
   real(wp), intent(out) :: energy2(:, :)

   !> Pairwise representation of non-additive dispersion energy
   real(wp), intent(out) :: energy3(:, :)

   integer :: mref
   real(wp), allocatable :: cn(:), q(:), gwvec(:, :, :), c6(:, :), lattr(:, :)
   type(error_type), allocatable :: error

   if (.not. allocated(disp%mchrg)) then
      write(error_unit, '("[Error]:", 1x, a)') "Not supported for non-self-consistent D4 version"
      error stop
   end if

   mref = maxval(disp%ref)

   allocate(cn(mol%nat))
   call get_lattice_points(mol%periodic, mol%lattice, cutoff%cn, lattr)
   call get_coordination_number(mol, lattr, cutoff%cn, disp%rcov, disp%en, cn)

   allocate(q(mol%nat))
   call get_charges(disp%mchrg, mol, error, q)
   if(allocated(error)) then
      write(error_unit, '("[Error]:", 1x, a)') error%message
      error stop
   end if

   allocate(gwvec(mref, mol%nat, disp%ncoup))
   call disp%weight_references(mol, cn, q, gwvec)

   allocate(c6(mol%nat, mol%nat))
   call disp%get_atomic_c6(mol, gwvec, c6=c6)

   energy2(:, :) = 0.0_wp
   energy3(:, :) = 0.0_wp
   call get_lattice_points(mol%periodic, mol%lattice, cutoff%disp2, lattr)
   call param%get_pairwise_dispersion2(mol, lattr, cutoff%disp2, cutoff%width2, &
      & disp%r4r2, c6, energy2)

   q(:) = 0.0_wp
   call disp%weight_references(mol, cn, q, gwvec)
   call disp%get_atomic_c6(mol, gwvec, c6=c6)

   call get_lattice_points(mol%periodic, mol%lattice, cutoff%disp3, lattr)
   call param%get_pairwise_dispersion3(mol, lattr, cutoff%disp3, cutoff%width3, &
      & disp%r4r2, c6, energy3)

end subroutine get_pairwise_dispersion


end module dftd4_disp

!> @copyright (c) 2020-2020 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file src/ddx_solvers.f90
!! Iterative solvers for ddX library
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2020-12-17

!> Core routines and parameters of ddX software
module ddx_solvers
! Get the core-routines
use ddx_core

! Disable implicit types
implicit none

! Interfaces
interface
    ! Interface for the matrix-vector product function
    subroutine matvec_interface(params, constants, workspace, x, y, ddx_error)
        !! Add definitions for derived types
        use ddx_core
        !! Inputs
        type(ddx_params_type), intent(in) :: params
        type(ddx_constants_type), intent(in) :: constants
        real(dp), intent(in) :: x(constants % nbasis, params % nsph)
        !! Temporaries
        type(ddx_workspace_type), intent(inout) :: workspace
        ! Output
        real(dp), intent(out) :: y(constants % nbasis, params % nsph)
        type(ddx_error_type), intent(inout) :: ddx_error
    end subroutine matvec_interface

    ! Interface for the matrix-vector product function for external jacobi_diis.
    ! note that the dimension of x and y is double for ddlpb.
    subroutine matvec_interface_external(params, constants, workspace, x, y, &
            & ddx_error)
        !! Add definitions for derived types
        use ddx_core
        !! Inputs
        type(ddx_params_type), intent(in) :: params
        type(ddx_constants_type), intent(in) :: constants
        real(dp), intent(in) :: x(constants % nbasis, params % nsph, 2)
        !! Temporaries
        type(ddx_workspace_type), intent(inout) :: workspace
        ! Output
        real(dp), intent(out) :: y(constants % nbasis, params % nsph, 2)
        type(ddx_error_type), intent(inout) :: ddx_error
    end subroutine matvec_interface_external

    ! Interface for the norm calculating function
    real(dp) function norm_interface(lmax, nbasis, nsph, x)
        !! Add definition for real(dp)
        use ddx_definitions
        !! Inputs
        integer, intent(in) :: lmax, nbasis, nsph
        real(dp), intent(in) :: x(nbasis, nsph)
    end function norm_interface
end interface

contains

!> Jacobi iterative solver
!!
!! @param[in] params: User input parameters for the ddX.
!! @param[in] constants: Precomputed constants for the ddX.
!! @param[inout] workspace: Temporary workspace for the ddX.
!! @param[in] tol: Relative error threshold to stop iterations.
!! @param[in] rhs: Right hand side.
!! @param[inout] x: On input, containts an initial guess to a solution. On
!!      exit, returns 
!! @param[inout] niter: Maximal number of iterations on input. On exit,
!!      contains a number of actually performed matrix-vector products.
!! @param[out] x_rel_diff: Relative difference between old and new values of
!!      the solution on each iteration.
!! @param[in] matvec: Routine that performs
!! @param[in] dm1vec:
!! @param[in] norm_func:
!! @param[inout] ddx_error: ddX error
!!
subroutine jacobi_diis(params, constants, workspace, tol, rhs, x, niter, &
        & x_rel_diff, matvec, dm1vec, norm_func, ddx_error)
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: tol, rhs(constants % n)
    !! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    !! Outputs
    real(dp), intent(inout) :: x(constants % n)
    integer, intent(inout) :: niter
    real(dp), intent(out) :: x_rel_diff(niter)
    type(ddx_error_type), intent(inout) :: ddx_error
    !! External procedures
    external :: matvec, dm1vec
    real(dp), external :: norm_func
    !! Local variables
    integer :: it, nmat
    real(dp) :: diff, norm, rel_diff
    !! The code
    ! DIIS variable
    nmat = 1
    ! Iterations
    do it = 1, niter
        ! y = rhs - O x
        call matvec(params, constants, workspace, x, workspace % tmp_y, ddx_error)
        workspace % tmp_y = rhs - workspace % tmp_y
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, 'Matvec error, exiting')
            return
        end if
        ! x_new = D^-1 y
        call dm1vec(params, constants, workspace, workspace % tmp_y, &
            & workspace % tmp_x_new, ddx_error)
        if (ddx_error % flag .ne. 0) then
            call update_error(ddx_error, 'Preconditioning error, exiting')
            return
        end if
        ! DIIS extrapolation
        if (params % jacobi_ndiis .gt. 2) then
            workspace % tmp_x_diis(:, nmat) = workspace % tmp_x_new
            workspace % tmp_e_diis(:, nmat) = workspace % tmp_x_new - x
            call diis(constants % n, nmat, params % jacobi_ndiis, &
                & workspace % tmp_x_diis, workspace % tmp_e_diis, &
                & workspace % tmp_bmat, workspace % tmp_x_new)
        end if
        ! Norm of increment
        x = workspace % tmp_x_new - x
        diff = norm_func(params % lmax, constants % nbasis, params % nsph, x)
        norm = norm_func(params % lmax, constants % nbasis, params % nsph, &
            & workspace % tmp_x_new)

        ! compute rel_diff using the rule 0/0 = 0
        if (diff.eq.zero .and. norm.eq.zero) then
            rel_diff = zero
        else
            rel_diff = diff / norm
        end if

        if (params % verbose) then
            write(params % iunit, '(A,I3,1X,A,E10.2)') &
                & 'Iteration:', it, 'Rel. diff:', rel_diff
            flush(params % iunit)
        end if

        x_rel_diff(it) = rel_diff
        ! Update solution
        x = workspace % tmp_x_new
        ! Check stop condition
        if (rel_diff .le. tol) then
            niter = it
            return
        end if
    end do
    call update_error(ddx_error, "Jacobi solver did not converge")
endsubroutine jacobi_diis

!> DIIS helper routine
subroutine diis(n, nmat, ndiis, x, e, b, xnew)
    implicit none
    integer, intent(in) :: n, ndiis
    integer, intent(inout) :: nmat
    real(dp), dimension(n,ndiis), intent(inout) :: x, e
    real(dp), dimension(ndiis+1,ndiis+1), intent(inout) :: b
    real(dp), dimension(n), intent(inout) :: xnew
    integer :: nmat1, i, istatus, info
    integer :: j, k
    real(dp), allocatable :: bloc(:,:), cex(:)
    integer,  allocatable :: ipiv(:)
    integer :: delta

    delta = min(10, ndiis-1)

    if (nmat.ge.ndiis) then
        do j = 2, nmat - delta
            do k = 2, nmat - delta
                b(j, k) = b(j+delta, k+delta)
            end do
        end do
        do j = 1, nmat - delta
            x(:, j) = x(:, j+delta)
            e(:, j) = e(:, j+delta)
        end do
        nmat = nmat - delta
    end if
    nmat1 = nmat + 1

    allocate(bloc(nmat1, nmat1), cex(nmat1), ipiv(nmat1), stat=istatus)

    call makeb(n, nmat, ndiis, e, b)
    bloc = b(1:nmat1, 1:nmat1)
    cex = zero
    cex(1) = one
    call dgesv(nmat1, 1, bloc, nmat1, ipiv, cex, nmat1, info)
!   call gjinv(nmat1, 1, bloc, cex, ok)
    if (info.ne.0) then
        nmat = 1
        return
    end if

    xnew = zero
    do i = 1, nmat
        call daxpy(n,cex(i+1),x(:, i),1,xnew,1)
    end do
    nmat = nmat + 1

    deallocate (bloc, cex, stat=istatus)
end subroutine diis

!> DIIS helper routine
subroutine makeb(n, nmat, ndiis, e, b)
    implicit none
    integer, intent(in) :: n, nmat, ndiis
    real(dp), dimension(n,ndiis), intent(in) :: e
    real(dp), dimension(ndiis+1,ndiis+1), intent(inout) :: b

    integer :: i
    real(dp) :: bij

    ! 1st built
    if (nmat.eq.1) then

        !     [ 0 |  1  ]
        ! b = [ --+---- ]
        !     [ 1 | e*e ]

        b(1,1) = zero
        b(1,2) = one
        b(2,1) = one
        b(2,2) = dot_product(e(:,1),e(:,1))

    ! subsequent builts
    else

        ! first, update the lagrangian line:
        b(nmat+1,1) = one
        b(1,nmat+1) = one

        ! now, compute the new matrix elements:
        !$omp parallel do default(none) shared(nmat,e,b) &
        !$omp private(i,bij) schedule(dynamic)
        do i = 1, nmat - 1
            bij = dot_product(e(:,i), e(:,nmat))
            b(nmat+1, i+1) = bij
            b(i+1, nmat+1) = bij
        end do
        b(nmat+1,nmat+1) = dot_product(e(:,nmat),e(:,nmat))
    end if
end subroutine makeb

!> jacobi_diis_solver_external
!! WARNING: code duplication is bad, but here it makes a very specific sense.
!! in ddLPB, we are solving a linear system with Jacobi DIIS also to apply the
!! preconditioner. As calling a solver recursively is a terrible idea, we
!! create a copy of jacobi_diis that:
!! - takes as an input the size of the system to be solved (no hardcoded
!!   dependence on nsph)
!! - uses copies of the norm subroutine, so that it can also be called with 
!!   a user-given size for arrays
subroutine jacobi_diis_external(params, constants, workspace, n, tol, rhs, x, n_iter, &
          & x_rel_diff, matvec, dm1vec, norm_func, ddx_error)
      type(ddx_params_type),    intent(in)    :: params
      type(ddx_constants_type), intent(inout) :: constants
      type(ddx_workspace_type), intent(inout) :: workspace
      ! Inputs
      integer,                  intent(in)    :: n
      real(dp),                 intent(in)    :: tol
      real(dp),  dimension(n),  intent(in)    :: rhs
      ! Outputs
      real(dp),  dimension(n),  intent(inout) :: x
      integer,                  intent(inout) :: n_iter
      type(ddx_error_type), intent(inout) :: ddx_error
      real(dp), intent(out) :: x_rel_diff(n_iter)
      external :: matvec, dm1vec
      real(dp), external :: norm_func
      ! Local variables
      integer  :: it, nmat, istatus, lenb, nsph_u
      real(dp) :: diff, norm, rel_diff = zero
      logical  :: dodiis
      real(dp), allocatable :: x_new(:), y(:), x_diis(:,:), e_diis(:,:), bmat(:,:)
      ! DIIS extrapolation flag
      dodiis = (params%jacobi_ndiis.gt.0)
      ! extrapolation required
      if (dodiis) then
        ! allocate workspaces
        lenb = params % jacobi_ndiis + 1
        allocate( x_diis(n,params % jacobi_ndiis), e_diis(n,params % jacobi_ndiis), bmat(lenb,lenb) , stat=istatus )
        if (istatus .ne. 0) then
            call update_error(ddx_error, 'jacobi_diis_external: failed allocation (diis)')
            return
        endif
        ! initialize the number of points for diis to one.
        ! note that nmat is updated by diis.
        nmat = 1
      endif
      ! allocate workspaces
      allocate( x_new(n), y(n) , stat=istatus )
      if (istatus .ne. 0) then
          call update_error(ddx_error, 'jacobi_diis_external: failed allocation (diis)')
          return
      endif
      ! Jacobi iterations
      do it = 1, n_iter
        ! y = rhs - O x
        call matvec(params, constants, workspace, x, y, ddx_error)
        y = rhs - y
        ! x_new = D^-1 y
        call dm1vec(params, constants, workspace, y, x_new, ddx_error)
        ! DIIS extrapolation
        if (dodiis) then
          x_diis(:,nmat) = x_new
          e_diis(:,nmat) = x_new - x
          call diis(n,nmat,params % jacobi_ndiis,x_diis,e_diis,bmat,x_new)
        endif
        !increment
        x = x_new - x
        ! warning: in the following, we use a quick and dirty hack to pass
        ! to the norm function arrays double the size than in non ddlpb calculations
        ! by defining a fake number of spheres with is n/nbasis (i.e., 2*nsph in 
        ! ddlpb).
        nsph_u = n/constants % nbasis
        diff = norm_func(params % lmax, constants % nbasis, nsph_u, x)
        norm = norm_func(params % lmax, constants % nbasis, nsph_u, x_new)
        ! compute rel_diff using the rule 0/0 = 0
        if (diff.eq.zero .and. norm.eq.zero) then
            rel_diff = zero
        else
            rel_diff = diff / norm
        end if
        x_rel_diff(it) = rel_diff
        constants % inner_tol = max(rel_diff*sqrt(tol), tol/100.0d0)
        ! update
        x = x_new
        ! EXIT Jacobi loop here
        if (rel_diff .le. tol) then
            n_iter = it
            return
        end if
      enddo
      call update_error(ddx_error, 'Jacobi external solver failed to converge')
endsubroutine jacobi_diis_external

end module ddx_solvers

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
! FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
! License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/scf/mixer/input.f90
!> Provides input types for electronic mixers
module tblite_scf_mixer_input
   use mctc_env, only : wp
   implicit none
   private

   public :: scf_version
   public :: scf_version_to_string

   !> Default value for self-consistent iteration mixing
   real(wp), parameter :: mixer_damping_default = 0.4_wp

   !> Default value for self-consistent iteration mixing memory, 0 uses max_iter
   integer, parameter :: mixer_memory_default = 0

   !> Default maximum number of self-consistent iterations
   integer, parameter :: max_iter_default = 250

   type :: scf_enum
      integer :: broyden = 1
   end type scf_enum
   type(scf_enum), parameter :: scf_version = scf_enum()

   !> Input for selecting electronic mixer
   type, public :: mixer_input
      !> Annealing schedule
      type(anneal_input), allocatable :: anneal
      !> Maximum number of self-consistent iterations
      integer :: max_iter = max_iter_default
      !> Mixer memory
      integer :: memory = mixer_memory_default
      !> Damping parameter for mixing
      real(wp) :: damping = mixer_damping_default
      !> Outer SCF loop version to use
      integer :: scf = scf_version%broyden
   end type mixer_input

   type, public :: anneal_input
      !> Initial electronic temperature for SCF annealing in Eh.
      real(wp) :: initial_kt
      !> Number of SCF cycles to keep the initial electronic temperature before annealing (default: 50).
      integer :: hold = 50
      !> Number of SCF cycles used to lower the electronic temperature to the calculation temperature (default: 50).
      integer :: cycles = 50
   end type anneal_input

contains

pure function scf_version_to_string(scf) result(str)
   integer, intent(in) :: scf
   character(len=:), allocatable :: str

   select case(scf)
   case(scf_version%broyden)
      str = "broyden"
   case default
      str = "unknown"
   end select
end function scf_version_to_string

end module tblite_scf_mixer_input

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

module dftd4
   use mctc_io, only : structure_type, new
   use dftd4_cutoff, only : realspace_cutoff, get_lattice_points
   use dftd4_disp, only : get_dispersion, get_properties, get_pairwise_dispersion
   use dftd4_ncoord, only : get_coordination_number
   use dftd4_numdiff, only : get_dispersion_hessian
   use dftd4_damping, only : damping_param
   use dftd4_damping_rational, only : rational_damping_param
   use dftd4_model, only : dispersion_model, new_dispersion_model, d4_qmod
   use dftd4_model_d4, only : d4_model, new_d4_model
   use dftd4_model_d4s, only : d4s_model, new_d4s_model
   use dftd4_param, only : get_rational_damping
   use dftd4_version, only : get_dftd4_version
   implicit none
   public

end module dftd4

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Input and output module for molecular structure data.
!>
!> This module provides the main interface for reading and writing molecular
!> structures in various geometry file formats. It exports:
!>
!> - [[structure_type]]: Central data structure for molecular and periodic systems
!> - [[read_structure]]: Read structures from files or formatted units
!> - [[write_structure]]: Write structures to files or formatted units
!> - [[mctc_io_filetype:filetype]]: Enumerator for supported file formats
!> - [[to_symbol]] / [[to_number]]: Convert between element symbols and atomic numbers
!>
!> The file format is automatically detected from file extensions, or can be
!> explicitly specified using the [[mctc_io_filetype:filetype]] enumerator. Use [[get_filetype]]
!> to translate file names to format identifiers.
!>
!> Supported formats include xyz, mol/sdf, pdb, Turbomole coord, VASP POSCAR,
!> DFTB+ gen, Gaussian external, QCSchema JSON, Chemical JSON, Pymatgen JSON,
!> FHI-aims geometry.in, and Q-Chem molecule blocks.
!>
!> Example usage:
!>
!>```f90
!> use mctc_io
!> use mctc_env
!> type(structure_type) :: mol
!> type(error_type), allocatable :: error
!>
!> call read_structure(mol, "input.xyz", error)
!> if (allocated(error)) stop error%message
!>
!> call write_structure(mol, "output.mol", error)
!>```
module mctc_io
   use mctc_io_filetype, only : filetype, get_filetype
   use mctc_io_read, only : read_structure
   use mctc_io_structure, only : structure_type, new_structure, new
   use mctc_io_symbols, only : to_symbol, to_number
   use mctc_io_write, only : write_structure
   implicit none
   private

   public :: filetype, get_filetype
   public :: read_structure, write_structure
   public :: structure_type, new_structure, new
   public :: to_symbol, to_number


contains
end module mctc_io

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Driver for unit testing
program tester
   use, intrinsic :: iso_fortran_env, only : error_unit
   use mctc_env_system, only : get_argument
   use mctc_env_testing, only : run_testsuite, new_testsuite, testsuite_type, &
      & select_suite, run_selected
   use test_cutoff, only : collect_cutoff
   use test_data, only : collect_data
   use test_math, only : collect_math
   use test_ncoord, only : collect_ncoord
   use test_timer, only : collect_timer
   use test_read, only : collect_read
   use test_read_aims, only : collect_read_aims
   use test_read_cjson, only : collect_read_cjson
   use test_read_ctfile, only : collect_read_ctfile
   use test_read_gaussian, only : collect_read_gaussian
   use test_read_genformat, only : collect_read_genformat
   use test_read_json, only : collect_read_json
   use test_read_pdb, only : collect_read_pdb
   use test_read_pymatgen, only : collect_read_pymatgen
   use test_read_qchem, only : collect_read_qchem
   use test_read_qcschema, only : collect_read_qcschema
   use test_read_turbomole, only : collect_read_turbomole
   use test_read_vasp, only : collect_read_vasp
   use test_read_xyz, only : collect_read_xyz
   use test_symbols, only : collect_symbols
   use test_write, only : collect_write
   use test_write_aims, only : collect_write_aims
   use test_write_cjson, only : collect_write_cjson
   use test_write_ctfile, only : collect_write_ctfile
   use test_write_gaussian, only : collect_write_gaussian
   use test_write_genformat, only : collect_write_genformat
   use test_write_pdb, only : collect_write_pdb
   use test_write_pymatgen, only : collect_write_pymatgen
   use test_write_qchem, only : collect_write_qchem
   use test_write_qcschema, only : collect_write_qcschema
   use test_write_turbomole, only : collect_write_turbomole
   use test_write_vasp, only : collect_write_vasp
   use test_write_xyz, only : collect_write_xyz
   implicit none
   integer :: stat, is
   character(len=:), allocatable :: suite_name, test_name
   type(testsuite_type), allocatable :: testsuites(:)
   character(len=*), parameter :: fmt = '("#", *(1x, a))'

   stat = 0

   testsuites = [ &
      & new_testsuite("cutoff", collect_cutoff), &
      & new_testsuite("data", collect_data), &
      & new_testsuite("math", collect_math), &
      & new_testsuite("ncoord", collect_ncoord), &
      & new_testsuite("timer", collect_timer), &
      & new_testsuite("symbols", collect_symbols), &
      & new_testsuite("read", collect_read), &
      & new_testsuite("read-aims", collect_read_aims), &
      & new_testsuite("read-cjson", collect_read_cjson), &
      & new_testsuite("read-ctfile", collect_read_ctfile), &
      & new_testsuite("read-gaussian", collect_read_gaussian), &
      & new_testsuite("read-genformat", collect_read_genformat), &
      & new_testsuite("read-json", collect_read_json), &
      & new_testsuite("read-pdb", collect_read_pdb), &
      & new_testsuite("read-pymatgen", collect_read_pymatgen), &
      & new_testsuite("read-qchem", collect_read_qchem), &
      & new_testsuite("read-qcschema", collect_read_qcschema), &
      & new_testsuite("read-turbomole", collect_read_turbomole), &
      & new_testsuite("read-vasp", collect_read_vasp), &
      & new_testsuite("read-xyz", collect_read_xyz), &
      & new_testsuite("write", collect_write), &
      & new_testsuite("write-aims", collect_write_aims), &
      & new_testsuite("write-cjson", collect_write_cjson), &
      & new_testsuite("write-ctfile", collect_write_ctfile), &
      & new_testsuite("write-gaussian", collect_write_gaussian), &
      & new_testsuite("write-genformat", collect_write_genformat), &
      & new_testsuite("write-pdb", collect_write_pdb), &
      & new_testsuite("write-pymatgen", collect_write_pymatgen), &
      & new_testsuite("write-qchem", collect_write_qchem), &
      & new_testsuite("write-qcschema", collect_write_qcschema), &
      & new_testsuite("write-turbomole", collect_write_turbomole), &
      & new_testsuite("write-vasp", collect_write_vasp), &
      & new_testsuite("write-xyz", collect_write_xyz) &
      & ]

   call get_argument(1, suite_name)
   call get_argument(2, test_name)

   if (allocated(suite_name)) then
      is = select_suite(testsuites, suite_name)
      if (is > 0 .and. is <= size(testsuites)) then
         if (allocated(test_name)) then
            write(error_unit, fmt) "Suite:", testsuites(is)%name
            call run_selected(testsuites(is)%collect, test_name, error_unit, stat)
            if (stat < 0) then
               error stop 1
            end if
         else
            write(error_unit, fmt) "Testing:", testsuites(is)%name
            call run_testsuite(testsuites(is)%collect, error_unit, stat)
         end if
      else
         write(error_unit, fmt) "Available testsuites"
         do is = 1, size(testsuites)
            write(error_unit, fmt) "-", testsuites(is)%name
         end do
         error stop 1
      end if
   else
      do is = 1, size(testsuites)
         write(error_unit, fmt) "Testing:", testsuites(is)%name
         call run_testsuite(testsuites(is)%collect, error_unit, stat)
      end do
   end if

   if (stat > 0) then
      write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
      error stop 1
   end if


end program tester

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Public API for TOML Fortran
!>
!> This module provides the main entry point to the TOML Fortran library.
!> It re-exports all public types and procedures needed for parsing, manipulating,
!> and serializing TOML documents.
!>
!> ## Parsing TOML
!>
!> Use [[toml_load]] to load a TOML document from a file or unit, or [[toml_loads]]
!> to parse a TOML string directly:
!>
!>```fortran
!> type(toml_table), allocatable :: table
!> call toml_load(table, "config.toml")
!>```
!>
!> ## Accessing Values
!>
!> Use [[get_value]] to retrieve values from tables and arrays, and [[set_value]]
!> to modify or create new values:
!>
!>```fortran
!> character(len=:), allocatable :: name
!> call get_value(table, "name", name)
!>```
!>
!> ## Serialization
!>
!> Use [[toml_dump]] to write a table to a file or [[toml_dumps]] to serialize
!> to a string:
!>
!>```fortran
!> character(len=:), allocatable :: output
!> call toml_dumps(table, output)
!>```
module tomlf
   use tomlf_build, only : get_value, set_value, toml_path
   use tomlf_datetime, only : toml_datetime, to_string
   use tomlf_de, only : toml_parse, toml_load, toml_loads, &
      & toml_context, toml_parser_config, toml_level
   use tomlf_error, only : toml_error, toml_stat
   use tomlf_ser, only : toml_serializer, toml_serialize, toml_dump, toml_dumps
   use tomlf_terminal, only : toml_terminal
   use tomlf_type, only : toml_table, toml_array, toml_keyval, toml_key, toml_value, &
      & is_array_of_tables, new_table, add_table, add_array, add_keyval, len
   use tomlf_utils_sort, only : sort
   use tomlf_version, only : tomlf_version_string, tomlf_version_compact, &
      & get_tomlf_version
   implicit none
   public

end module tomlf

! This file is part of mstore.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

program main_info
   use, intrinsic :: iso_fortran_env, only : output_unit, error_unit, input_unit
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_io, only : write_structure, structure_type, filetype, get_filetype
   use mctc_version, only : get_mctc_version
   use mctc_io_symbols, only : to_symbol
   use mstore
   implicit none
   character(len=*), parameter :: prog_name = "mstore-info"

   character(len=:), allocatable :: output, collection, record
   integer, allocatable :: output_format
   type(structure_type) :: mol
   type(error_type), allocatable :: error
   integer :: idx, unit, stat, tmp
   logical :: exist

   call get_arguments(collection, record, output, output_format, error)
   if (allocated(error)) then
      write(error_unit, '(a)') error%message
      error stop
   end if

   if (allocated(collection)) then
      if (allocated(record)) then
         call get_structure(mol, collection, record)
         if (output == "-") then
            if (.not.allocated(output_format)) output_format = filetype%xyz
            call write_structure(mol, output_unit, output_format, error)
         else
            call write_structure(mol, output, error, output_format)
         end if
      else
         call list_records(output_unit, collection, error)
      end if
   else
      call list_collections(output_unit, error)
   end if
   if (allocated(error)) then
      write(error_unit, '(a)') error%message
      error stop
   end if

contains


subroutine help(unit)
   integer, intent(in) :: unit

   write(unit, '(a, *(1x, a))') &
      "Usage: "//prog_name//" [options] <collection> <record>"

   write(unit, '(a)') &
      "", &
      "Show information on selected collections and records.", &
      ""

   write(unit, '(2x, a, t25, a)') &
      "-o, --output <file>", "Name of the output file (default: stdout)", &
      "-f, --format <format>", "Hint for the format of the output file", &
      "--version", "Print program version and exit", &
      "--help", "Show this help message"

   write(unit, '(a)')

end subroutine help


subroutine version(unit)
   integer, intent(in) :: unit
   character(len=:), allocatable :: version_string

   call get_mctc_version(string=version_string)
   write(unit, '(a, *(1x, a))') &
      & prog_name, "version", version_string

end subroutine version


!> Obtain the command line argument at a given index
subroutine get_argument(idx, arg)

   !> Index of command line argument, range [0:command_argument_count()]
   integer, intent(in) :: idx

   !> Command line argument
   character(len=:), allocatable, intent(out) :: arg

   integer :: length, stat

   call get_command_argument(idx, length=length, status=stat)
   if (stat /= 0) then
      return
   endif

   allocate(character(len=length) :: arg, stat=stat)
   if (stat /= 0) then
      return
   endif

   if (length > 0) then
      call get_command_argument(idx, arg, status=stat)
      if (stat /= 0) then
         deallocate(arg)
         return
      end if
   end if

end subroutine get_argument


subroutine get_arguments(collection, record, output, output_format, &
      & error)

   !> Input file name
   character(len=:), allocatable :: collection

   !> Input file name
   character(len=:), allocatable :: record

   !> Output file name
   character(len=:), allocatable :: output

   !> Output file format
   integer, allocatable, intent(out) :: output_format

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   character(len=:), allocatable :: arg

   iarg = 0
   narg = command_argument_count()
   do while(iarg < narg)
      iarg = iarg + 1
      call get_argument(iarg, arg)
      select case(arg)
      case("--help")
         call help(output_unit)
         stop
      case("--version")
         call version(output_unit)
         stop
      case default
         if (.not.allocated(collection)) then
            call move_alloc(arg, collection)
            cycle
         end if
         if (.not.allocated(record)) then
            call move_alloc(arg, record)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      case("-o", "--output")
         iarg = iarg + 1
         call get_argument(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for output file")
            exit
         end if
         call move_alloc(arg, output)
      case("-f", "--format")
         iarg = iarg + 1
         call get_argument(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for output format")
            exit
         end if
         output_format = get_filetype("."//arg)
      end select
   end do

   if (.not.allocated(output)) then
      output = "-"
   end if

end subroutine get_arguments


end program main_info

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

!> Versioning information on this library.
module dftd3_version
   implicit none
   private

   public :: dftd3_version_string, dftd3_version_compact
   public :: get_dftd3_version


   !> String representation of the s-dftd3 version
   character(len=*), parameter :: dftd3_version_string = "1.4.0"

   !> Numeric representation of the s-dftd3 version
   integer, parameter :: dftd3_version_compact(3) = [1, 4, 0]


contains


!> Getter function to retrieve s-dftd3 version
subroutine get_dftd3_version(major, minor, patch, string)

   !> Major version number of the s-dftd3 version
   integer, intent(out), optional :: major

   !> Minor version number of the s-dftd3 version
   integer, intent(out), optional :: minor

   !> Patch version number of the s-dftd3 version
   integer, intent(out), optional :: patch

   !> String representation of the s-dftd3 version
   character(len=:), allocatable, intent(out), optional :: string

   if (present(major)) then
      major = dftd3_version_compact(1)
   end if
   if (present(minor)) then
      minor = dftd3_version_compact(2)
   end if
   if (present(patch)) then
      patch = dftd3_version_compact(3)
   end if
   if (present(string)) then
      string = dftd3_version_string
   end if

end subroutine get_dftd3_version


end module dftd3_version

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Implementation of a package source target
module pkg_source
   use pkg_error, only : error_data, fatal_error
   use tomlf
   implicit none
   private

   public :: source_data, new_source


   !> Package source data, knows how to retrieve and verify itself
   type :: source_data

      !> URL to the package source
      character(len=:), allocatable :: url

      !> Path to version control repository
      character(len=:), allocatable :: git

      !> SHA-256 hash to verify artifacts downloaded from URL entry
      character(len=:), allocatable :: sha256

      !> Relative path in the build directory
      character(len=:), allocatable :: folder

   contains

      !> Produce informative printout
      procedure :: info

   end type source_data


contains


!> Create new source data from a TOML data structure
subroutine new_source(self, table, error)

   !> Instance of the dependency data
   type(source_data), intent(out) :: self

   !> TOML data structure, might get modified in the process
   type(toml_table), intent(inout) :: table

   !> Error status of the operation
   type(error_data), allocatable, intent(out) :: error

   call get_value(table, "url", self%url)
   call get_value(table, "sha256", self%sha256)

   call get_value(table, "git", self%git)

   if (.not.(allocated(self%git).or.allocated(self%url))) then
      call fatal_error(error, "Needs at least one of url or git methods to retrieve source targets")
      return
   end if

   if (allocated(self%git) .and. allocated(self%url)) then
      call fatal_error(error, "Cannot have both url and git field present for source target")
      return
   end if

   if (.not.allocated(self%sha256) .and. allocated(self%url)) then
      call fatal_error(error, "SHA256 checksum is required for URL source targets")
      return
   end if

   if (allocated(self%git) .and. allocated(self%sha256)) then
      call fatal_error(error, "SHA256 hash cannot be used with git sources")
      return
   end if

   call get_value(table, "folder", self%folder, ".")

end subroutine new_source


!> Write information on the package data
subroutine info(self, unit)

   !> Instance of the package data
   class(source_data), intent(in) :: self

   !> Unit for IO
   integer, intent(in) :: unit

   if (allocated(self%git)) then
      write(unit, '(" - ", a, t30, a)') "Git URL", self%git
   end if

   if (allocated(self%url)) then
      write(unit, '(" - ", a, t30, a)') "Source URL", self%url
   end if

   if (self%folder /= ".") then
      write(unit, '(3x, a, t30, a)') "Relative path", self%folder
   end if

end subroutine info


end module pkg_source

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/post_processing/wbo.f90
!> Implements the calculation of Wiberg-Mayer bond orders as post processing method.
module tblite_post_processing_wbo
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use tblite_basis_type, only : basis_type
   use tblite_container_list, only : cache_list
   use tblite_context, only : context_type
   use tblite_double_dictionary, only : double_dictionary_type
   use tblite_integral_type, only : integral_type
   use tblite_post_processing_type, only : post_processing_type
   use tblite_timer, only : timer_type, format_time
   use tblite_wavefunction_type, only : wavefunction_type, get_density_matrix
   use tblite_wavefunction_mulliken, only : get_mayer_bond_orders
   use tblite_xtb_calculator, only : xtb_calculator
   implicit none
   private

   public :: new_wiberg_bond_orders, wiberg_bond_orders

   !> Wiberg-Mayer bond orders as post-processing method
   type, extends(post_processing_type) :: wiberg_bond_orders
   contains
      !> Calculate Wiberg-Mayer bond orders
      procedure :: compute
      !> Print timings
      procedure :: print_timer
   end type wiberg_bond_orders

   character(len=24), parameter :: label = "Mayer-Wiberg bond orders"

contains

subroutine new_wiberg_bond_orders(self)
   !> Instance of the Wiberg-Mayer bond order post-processing
   type(wiberg_bond_orders), intent(out) :: self

   self%label = label

end subroutine new_wiberg_bond_orders

subroutine compute(self, mol, wfn, ints, calc, caches, ctx, timer, prlevel, dict)
   !> Instance of the Wiberg-Mayer bond order post-processing
   class(wiberg_bond_orders),intent(in) :: self
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Wavefunction strcuture data
   type(wavefunction_type), intent(in) :: wfn
   !> Integral container
   type(integral_type), intent(in) :: ints
   !> Calculator instance
   type(xtb_calculator), intent(in) :: calc
   !> Cache list for storing caches of various interactions
   type(cache_list), intent(inout) :: caches
   !> Context container for writing to stdout
   type(context_type), intent(inout) :: ctx
   !> Timer instance
   type(timer_type), intent(inout) :: timer
   !> Print level
   integer, intent(in) :: prlevel
   !> Dictionary for storing results
   type(double_dictionary_type), intent(inout) :: dict

   real(wp), allocatable :: wbo(:, :, :), pmat(:, :, :)
   integer :: spin

   call timer%push("wbo")

   if ((wfn%nspin == 1) .and. (wfn%nel(1) /= wfn%nel(2))) then
      ! Restricted calculation with open-shell occupation
      allocate(wbo(mol%nat, mol%nat, 2), source=0.0_wp)
      allocate(pmat(calc%bas%nao, calc%bas%nao, 2), source=0.0_wp)

      ! Calculate density matrices for each spin with the spin-resolved occupation,
      ! but the restricted orbital coefficients (alpha).
      do spin = 1, 2
         call get_density_matrix(wfn%focc(:, spin), wfn%coeff(:, :, 1), &
            & pmat(:, :, spin))
      end do

      ! Obtain Wiberg-Mayer bond orders with factor 2 scaling for open-shell case
      call get_mayer_bond_orders(mol, calc%bas, ints%overlap, pmat, wbo)
      
      call dict%add_entry("bond-orders", wbo)
      
   else
      ! Restricted closed-shell or unrestricted calculations
      allocate(wbo(mol%nat, mol%nat, wfn%nspin), source=0.0_wp)
      
      ! Obtain Wiberg-Mayer bond orders with factor 2 scaling for unrestricted
      call get_mayer_bond_orders(mol, calc%bas, ints%overlap, &
         & wfn%density, wbo)
      
      call dict%add_entry("bond-orders", wbo)
   end if

   call timer%pop()

end subroutine compute

subroutine print_timer(self, timer, prlevel, ctx)
   !> Instance of the Wiberg-Mayer bond order post-processing
   class(wiberg_bond_orders), intent(in) :: self
   !> Timer instance
   type(timer_type), intent(in) :: timer
   !> Print level
   integer, intent(in) :: prlevel
   !> Context container for writing to stdout
   type(context_type), intent(inout) :: ctx

   real(wp) :: ttime

   if (prlevel > 2) then
      call ctx%message(label//" timing details:")
      ttime = timer%get("wbo")
      call ctx%message(" total:"//repeat(" ", 16)//format_time(ttime))
      call ctx%message("")
   end if

end subroutine print_timer

end module tblite_post_processing_wbo

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! Simple D4 energy evaluation using the Fortran API.

program d4_energy
   use mctc_env, only : wp, error_type
   use mctc_io, only : structure_type, read_structure
   use dftd4, only : d4_model, new_d4_model, damping_param, &
      & get_rational_damping, realspace_cutoff, get_dispersion
   implicit none

   type(structure_type) :: mol
   type(d4_model) :: model
   class(damping_param), allocatable :: param
   type(realspace_cutoff) :: cutoff
   type(error_type), allocatable :: error
   real(wp) :: energy

   call read_structure(mol, "coord", error)
   if (allocated(error)) then
      write (*, '(a)') trim(error%message)
      stop 1
   end if

   call new_d4_model(error, model, mol)
   if (allocated(error)) then
      write (*, '(a)') trim(error%message)
      stop 1
   end if

   call get_rational_damping("pbe", param)
   call get_dispersion(mol, model, param, cutoff, energy)

   write (*, '(a,f18.12)') "D4 dispersion energy (Hartree): ", energy
end program d4_energy

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file src/ddx_driver.f90
!! Main ddx driver.
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-02-25

!> Standalone application of ddX: this program can compute the solvation
!! energy and forces for a solute made of point charges. All the
!! relevant steps are here outlined.
program test_gradients
use ddx
use ddx_multipolar_solutes
use omp_lib
implicit none

real(dp), parameter :: step = 1d-6
character(len=255) :: dummy_file_name = ''
character(len=255) :: fname
character(len=2047) :: banner
type(ddx_type) :: ddx_data
type(ddx_state_type) :: state
type(ddx_error_type) :: ddx_error
type(ddx_electrostatics_type) :: electrostatics
real(dp), allocatable :: psi(:, :), force(:, :), charges(:), &
    & multipoles(:, :), dr(:), numforce(:,:), numdr(:)
real(dp) :: tol, esolv, start_time, finish_time
integer :: i, isph, info, j
real(dp), allocatable :: x(:,:), s(:,:), tmp_lx(:,:)
real(dp) :: xpsi, slx, sphi, diff
real(dp), allocatable :: grad_xpsi(:,:), grad_slx(:,:), &
    & grad_sphi(:,:), grad_xpsi_num(:,:), grad_slx_num(:,:), &
    & grad_sphi_num(:,:), dr_xpsi(:), dr_slx(:), dr_sphi(:), &
    & dr_xpsi_num(:), dr_slx_num(:), dr_sphi_num(:)
real(dp), external :: ddot
real(dp), parameter :: threshold = 1e-8


call get_command_argument(1, fname)
call ddfromfile(fname, ddx_data, tol, charges, ddx_error)
call check_error(ddx_error)

call allocate_state(ddx_data % params, ddx_data % constants, state, &
    & ddx_error)
call check_error(ddx_error)

allocate( &
    & grad_xpsi(3,ddx_data%params%nsph), &
    & grad_slx(3,ddx_data%params%nsph), &
    & grad_sphi(3,ddx_data%params%nsph), &
    & grad_xpsi_num(3,ddx_data%params%nsph), &
    & grad_slx_num(3,ddx_data%params%nsph), &
    & grad_sphi_num(3,ddx_data%params%nsph), &
    & dr_xpsi(ddx_data%params%nsph), &
    & dr_slx(ddx_data%params%nsph), &
    & dr_sphi(ddx_data%params%nsph), &
    & dr_xpsi_num(ddx_data%params%nsph), &
    & dr_slx_num(ddx_data%params%nsph), &
    & dr_sphi_num(ddx_data%params%nsph), &
    & x(ddx_data%constants%nbasis,ddx_data%params%nsph), &
    & s(ddx_data%constants%nbasis,ddx_data%params%nsph), &
    & tmp_lx(ddx_data%constants%nbasis,ddx_data%params%nsph), &
    & force(3, ddx_data % params % nsph), &
    & dr(ddx_data % params % nsph), &
    & numforce(3, ddx_data % params % nsph), &
    & numdr(ddx_data % params % nsph), &
    & multipoles(1, ddx_data % params % nsph), stat=info)
if (info .ne. 0) then
    write(6, *) "Allocation failed in ddx_driver"
    stop 1
end if

multipoles(1, :) = charges/sqrt4pi
call multipole_electrostatics(ddx_data % params, ddx_data % constants, &
    & ddx_data % workspace, multipoles, 0, electrostatics, ddx_error)

allocate(psi(ddx_data % constants % nbasis, ddx_data % params % nsph), &
    & stat=info)
if (info .ne. 0) then
    write(6, *) "Allocation failed in ddx_driver"
    stop 1
end if
call multipole_psi(ddx_data % params, multipoles, 0, psi)


! Reference calculation
! call draco(ddx_data%params%csph, ddx_data%params%nsph, &
   !  & ddx_data%params%rsph)
call ddrun(ddx_data,state,electrostatics,psi,tol,esolv,ddx_error,force)


x(:,:) = state%xs(:,:)
s(:,:) = state%s(:,:)
! Compute the first Lagrangian term 0.5 X^T Psi
xpsi = pt5*ddot(ddx_data%constants%n,x,1,psi,1)

! Compute the second Lagrangian term -0.5 S^T L X
ddx_data%constants%dodiag = .true.
call lx(ddx_data%params,ddx_data%constants,ddx_data%workspace, &
    & x,tmp_lx,ddx_error)
slx = -pt5*ddot(ddx_data%constants%n,s,1,tmp_lx,1)

! Compute the third Lagrangian term - 0.5 S^T Phi
! Note that Phi is saved as -Phi, so no minus required
sphi = pt5*ddot(ddx_data%constants%n,s,1,state%phi,1)

write(6,*) xpsi, slx, sphi
! Check if the Lagrangian formulation returns the energy
diff = abs(esolv - (xpsi + slx + sphi))
if (diff.gt.threshold) then
    write(6, *) "Inconsistency"
    stop 1
end if


call sgradlx(ddx_data%params,ddx_data%constants,ddx_data%workspace, &
    & state,grad_slx,ddx_error)

call sgradphi(ddx_data%params,ddx_data%constants,ddx_data%workspace, &
    & state,grad_sphi,ddx_error,electrostatics%e_cav,multipoles)

call sdrlx(ddx_data%params,ddx_data%constants,ddx_data%workspace, &
    & state,grad_slx,dr_slx,ddx_error)

call sdrphi(ddx_data%params,ddx_data%constants,ddx_data%workspace, &
    & state,grad_sphi,dr_sphi,ddx_error,electrostatics%e_cav,multipoles)

do isph = 1, ddx_data%params%nsph
    do j = 1, 3
        ddx_data%params%csph(j,isph) = ddx_data%params%csph(j,isph) - step
        call displaced_run(ddx_data,multipoles,tol,xpsi,slx,sphi,psi, &
             & esolv,force,x,s)

        grad_xpsi_num(j, isph) = - xpsi
        grad_slx_num(j, isph) = - slx
        grad_sphi_num(j, isph) = - sphi

        ddx_data%params%csph(j,isph) = ddx_data%params%csph(j,isph) + 2.0d0*step
        call displaced_run(ddx_data,multipoles,tol,xpsi,slx,sphi,psi, &
            & esolv,force,x,s)

        grad_xpsi_num(j, isph) = grad_xpsi_num(j, isph) + xpsi
        grad_slx_num(j, isph) = grad_slx_num(j, isph) + slx
        grad_sphi_num(j, isph) = grad_sphi_num(j, isph) + sphi
        grad_xpsi_num(j, isph) = grad_xpsi_num(j, isph)/(2.0d0*step)
        grad_slx_num(j, isph) = grad_slx_num(j, isph)/(2.0d0*step)
        grad_sphi_num(j, isph) = grad_sphi_num(j, isph)/(2.0d0*step)

        ddx_data%params%csph(j,isph) = ddx_data%params%csph(j,isph) - step
    end do
end do

diff = maxval(abs(grad_slx_num - grad_slx))
write(6,*) "Difference S^T grad L X", diff
if (diff.gt.threshold) then
    write(6, *) "Inconsistency"
    stop 1
end if

diff = maxval(abs(grad_sphi_num - grad_sphi))
write(6,*) "Difference S^T grad Phi", diff
if (diff.gt.threshold) then
    write(6, *) "Inconsistency"
    stop 1
end if


do isph = 1, ddx_data%params%nsph
        ddx_data%params%rsph(isph) = ddx_data%params%rsph(isph) - step
        call displaced_run(ddx_data,multipoles,tol,xpsi,slx,sphi,psi, &
             & esolv,force,x,s)

        dr_xpsi_num( isph) = - xpsi
        dr_slx_num(isph) = - slx
        dr_sphi_num( isph) = - sphi

        ddx_data%params%rsph(isph) = ddx_data%params%rsph(isph) + 2.0d0*step
        call displaced_run(ddx_data,multipoles,tol,xpsi,slx,sphi,psi, &
            & esolv,force,x,s)

        dr_xpsi_num( isph) = dr_xpsi_num( isph) + xpsi
        dr_slx_num(isph) = dr_slx_num(isph) + slx
        dr_sphi_num( isph) = dr_sphi_num(isph) + sphi
        dr_xpsi_num( isph) = dr_xpsi_num(isph)/(2.0d0*step)
        dr_slx_num(isph) = dr_slx_num(isph)/(2.0d0*step)
        dr_sphi_num( isph) = dr_sphi_num(isph)/(2.0d0*step)

        ddx_data%params%rsph(isph) = ddx_data%params%rsph(isph) - step
end do

write(6,*) "-----"
diff = maxval(abs(dr_slx_num - dr_slx))
write(6,*) "Difference S^T dr L X", diff
if (diff.gt.threshold) then
    write(6, *) "Inconsistency"
    stop 1
end if
diff = maxval(abs(dr_sphi_num - dr_sphi))
write(6,*) "Difference S^T dr Phi", diff
if (diff.gt.threshold) then
    write(6, *) "Inconsistency"
    stop 1
end if

deallocate(psi, multipoles, charges, force, numforce, dr, numdr,&
    & x, s, tmp_lx, &
    & grad_xpsi, grad_slx, grad_sphi, &
    & grad_xpsi_num, grad_slx_num, grad_sphi_num, &
    & dr_xpsi, dr_slx, dr_sphi, &
    & dr_xpsi_num, dr_slx_num, dr_sphi_num, &
    & stat=info)
if (info .ne. 0) then
    write(6, *) "Deallocation failed in ddx_driver"
    stop 1
end if
call deallocate_electrostatics(electrostatics, ddx_error)
call deallocate_state(state, ddx_error)
call deallocate_model(ddx_data, ddx_error)

contains

subroutine displaced_run(ddx_data,multipoles,tol,xpsi,slx,sphi, &
        & psi,esolv,force,x,s)
    type(ddx_type), intent(inout) :: ddx_data
    real(dp), intent(in) :: tol
    real(dp), intent(out) :: xpsi, slx, sphi
    type(ddx_type) :: ddx_data2
    type(ddx_error_type) :: error2
    type(ddx_state_type) :: state2
    type(ddx_electrostatics_type) :: electrostatics2
    real(dp), intent(in) :: multipoles(1,ddx_data%params%nsph)
    real(dp), intent(out) :: esolv
    real(dp), intent(out) :: force(3,ddx_data%params%nsph)
    real(dp), intent(out) :: psi(ddx_data%constants%nbasis, &
        & ddx_data%params%nsph)
    real(dp), intent(in) :: &
        & x(ddx_data%constants%nbasis,ddx_data%params%nsph), &
        & s(ddx_data%constants%nbasis,ddx_data%params%nsph)

    ! Make a copy of the model
    call allocate_model(ddx_data%params%nsph,ddx_data%params%csph(1,:), &
        & ddx_data%params%csph(2,:),ddx_data%params%csph(3,:), &
        & ddx_data%params%rsph,ddx_data%params%model, &
        & ddx_data%params%lmax,ddx_data%params%ngrid,ddx_data%params%force, &
        & ddx_data%params%fmm,ddx_data%params%pm,ddx_data%params%pl, &
        & ddx_data%params%se,ddx_data%params%eta,ddx_data%params%eps, &
        & ddx_data%params%kappa,ddx_data%params%matvecmem, &
        & ddx_data%params%maxiter,ddx_data%params%jacobi_ndiis, &
        & ddx_data%params%nproc,dummy_file_name,ddx_data2,error2)
    call check_error(error2)

    call allocate_state(ddx_data2%params,ddx_data2%constants,state2, &
        & error2)
    call check_error(error2)


    call multipole_electrostatics(ddx_data2%params,ddx_data2%constants, &
        & ddx_data2%workspace,multipoles,0,electrostatics2,error2)
    call check_error(error2)

    call multipole_psi(ddx_data2%params,multipoles,0,psi)
    call ddrun(ddx_data2,state2,electrostatics2,psi,tol,esolv,ddx_error,force)

    ! Compute the first Lagrangian term 0.5 X^T Psi
    xpsi = pt5*ddot(ddx_data2%constants%n,x,1,psi,1)
    ! Compute the second Lagrangian term -0.5 S^T L X
    ddx_data2%constants%dodiag = .true.
    call lx(ddx_data2%params,ddx_data2%constants,ddx_data2%workspace, &
        & x,tmp_lx,error2)
    slx = -pt5*ddot(ddx_data2%constants%n,s,1,tmp_lx,1)
    ! Compute the third Lagrangian term - 0.5 S^T Phi
    ! Note that Phi is saved as -Phi, so no minus required
    sphi = pt5*ddot(ddx_data2%constants%n,s,1,state2%phi,1)

    call deallocate_electrostatics(electrostatics2,error2)
    call deallocate_state(state2,error2)
    call deallocate_model(ddx_data2,error2)
end subroutine displaced_run

subroutine sgradlx(params, constants, workspace, &
        & state, force, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(inout) :: force(3, params % nsph)
    integer :: isph
    force = zero
    do isph = 1, params % nsph
        call contract_grad_l(params,constants,isph,state%xs, &
            & state%sgrid,workspace%tmp_vylm(:,1), &
            & workspace%tmp_vdylm(:,:,1),workspace%tmp_vplm(:,1), &
            & workspace%tmp_vcos(:,1),workspace%tmp_vsin(:,1), &
            & force(:,isph))
    end do
    force = -pt5*force
end subroutine sgradlx

subroutine sdrlx(params, constants, workspace, &
        & state, force, dr, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(inout) :: force(3, params % nsph)
    real(dp), intent(inout) :: dr(params % nsph)
    integer :: isph
    force = zero
    dr = zero
    do isph = 1, params % nsph
        call contract_grad_l(params,constants,isph,state%xs, &
            & state%sgrid,workspace%tmp_vylm(:,1), &
            & workspace%tmp_vdylm(:,:,1),workspace%tmp_vplm(:,1), &
            & workspace%tmp_vcos(:,1),workspace%tmp_vsin(:,1), &
            & force(:,isph), dr=dr(isph))
    end do
    dr = -pt5*dr
    force = -pt5*force
end subroutine sdrlx

subroutine sgradphi(params, constants, workspace, &
        & state,force,ddx_error,e_cav,multipoles)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(inout) :: force(3, params % nsph)
    real(dp), intent(in) :: e_cav(3, constants % ncav)
    real(dp), intent(in) :: multipoles(1, ddx_data % params % nsph)
    integer :: isph
    force = zero
    do isph = 1, params % nsph
        call contract_grad_u(params, constants, isph, state % sgrid, &
            & state % phi_grid, force(:, isph))
    end do
    force = -pt5*force
    call zeta_grad(params, constants, state, e_cav, force)
    call multipole_force_terms(params,constants, &
        & workspace,state,0,multipoles,force,ddx_error)
end subroutine sgradphi


subroutine sdrphi(params, constants, workspace, &
        & state,force,dr,ddx_error,e_cav,multipoles)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(inout) :: force(3, params % nsph)
    real(dp), intent(inout) :: dr(params % nsph)
    real(dp), intent(in) :: e_cav(3, constants % ncav)
    real(dp), intent(in) :: multipoles(1, ddx_data % params % nsph)
    integer :: isph
    dr = zero
    do isph = 1, params % nsph
        call contract_grad_u(params, constants, isph, state % sgrid, &
            & state % phi_grid, force(:, isph), dr=dr(isph))
    end do
    dr = -pt5*dr
    call zeta_grad_dr(params, constants, state, e_cav, dr)
end subroutine sdrphi

end program test_gradients

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!!
!! @version 1.0.0
!! @author Abhinav Jha
!! @date 2022-04-01

!> Core routines and parameters specific to gradients
module ddx_gradients
! Get the core-routines
use ddx_core
!
contains

!> Compute the gradients of the ddCOSMO matrix
subroutine contract_grad_L(params, constants, isph, sigma, xi, basloc, dbsloc, vplm, vcos, vsin, fx, dr)
type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
      integer,                         intent(in)    :: isph
      real(dp), dimension(constants % nbasis, params % nsph), intent(in)    :: sigma
      real(dp), dimension(params % ngrid, params % nsph),       intent(in)    :: xi
      real(dp), dimension(constants % nbasis), intent(inout) :: basloc, vplm
      real(dp), dimension(3, constants % nbasis), intent(inout) :: dbsloc
      real(dp), dimension(params % lmax+1), intent(inout) :: vcos, vsin
      real(dp), dimension(3), intent(inout) :: fx
      real(dp), optional, intent(inout) :: dr

      logical :: do_dr
      real(dp) :: dr_local

      if (present(dr)) then
          do_dr = .true.
      else
          do_dr = .false.
      end if

      dr_local = 0.0d0

      call contract_gradi_Lik(params, constants, isph, sigma, xi(:, isph), basloc, dbsloc, vplm, vcos, vsin, fx, dr_local)
      call contract_gradi_Lji(params, constants, isph, sigma, xi, basloc, dbsloc, vplm, vcos, vsin, fx, dr_local)

      if (do_dr) dr = dr_local

end subroutine contract_grad_L

!> Contribution to the gradients of the ddCOSMO matrix
subroutine contract_gradi_Lik(params, constants, isph, sigma, xi, basloc, dbsloc, vplm, vcos, vsin, fx, dr)
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
      integer,                         intent(in)    :: isph
      real(dp),  dimension(constants % nbasis, params % nsph), intent(in)    :: sigma
      real(dp),  dimension(params % ngrid),       intent(in)    :: xi
      real(dp),  dimension(constants % nbasis),      intent(inout) :: basloc, vplm
      real(dp),  dimension(3, constants % nbasis),    intent(inout) :: dbsloc
      real(dp),  dimension(params % lmax+1),      intent(inout) :: vcos, vsin
      real(dp),  dimension(3),           intent(inout) :: fx
      integer :: ig, ij, jsph, l, ind, m
      real(dp)  :: vvij, tij, xij, oij, t, fac, fl, f1, fr1, f2, fr2, f3, fr3, beta, tlow, thigh
      real(dp)  :: vij(3), sij(3), alp(3), va(3)
      real(dp) :: dsij, dtij(3), alp1(3), alp2(3), alp_rad, dsij_rad(3), dtij_rad, alp1_rad, alp2_rad, va_rad
      real(dp), external :: dnrm2
      real(dp), intent(inout) :: dr
      real(dp) :: sjac(3,3), qij
      tlow  = one - pt5*(one - params % se)*params % eta
      thigh = one + pt5*(one + params % se)*params % eta

      do ig = 1, params % ngrid
        va = zero
        va_rad = zero
       do ij = constants % inl(isph), constants % inl(isph+1) - 1
          jsph = constants % nl(ij)
          vij  = params % csph(:,isph) + &
              & params % rsph(isph)*constants % cgrid(:,ig) - &
              & params % csph(:,jsph)
          vvij = dnrm2(3, vij, 1)
          tij  = vvij/params % rsph(jsph)
          if (tij.ge.thigh) cycle
          if (tij.ne.zero) then
              sij = vij/vvij
          else
              sij = one
          end if

          dsij = 1.0_dp / (tij*params%rsph(jsph)) !scalar
          dtij(:) = sij(:)/params%rsph(jsph)      !vector

          ! build the jacobian of sik
          sjac = zero
          sjac(1,1) = one
          sjac(2,2) = one
          sjac(3,3) = one
          qij = one/vvij
          do icomp = 1, 3
              do jcomp = 1, 3
              sjac(icomp,jcomp) = qij*(sjac(icomp,jcomp) &
                  & - sij(icomp)*sij(jcomp))
              end do
          end do

          dsij_rad = constants%cgrid(:,ig)/vvij &
             & - vij * dot_product(vij, constants%cgrid(:,ig)) / (vvij**3)
          dtij_rad = dot_product(vij, constants%cgrid(:,ig)) &
              & / (vvij*params%rsph(jsph))

          call dbasis(params, constants, sij, basloc, dbsloc, vplm, vcos, vsin)
          alp  = zero
          alp1 = zero
          alp2 = zero

          alp_rad  = zero
          alp1_rad = zero
          alp2_rad = zero

          t    = one
          do l = 1, params % lmax
            ind = l*l + l + 1
            fl  = dble(l)
            fac = t/(constants % vscales(ind)**2)
            do m = -l, l
              f2 = fac*sigma(ind+m,jsph)
              f1 = f2*fl*basloc(ind+m)

              alp1(:) = f1*dtij
              alp1_rad = f1*dtij_rad

              alp2(1) = sjac(1,1)*dbsloc(1,ind+m) + &
                  & sjac(1,2)*dbsloc(2,ind+m)+sjac(1,3)*dbsloc(3,ind+m)
              alp2(2) = sjac(2,1)*dbsloc(1,ind+m) + &
                  & sjac(2,2)*dbsloc(2,ind+m)+sjac(2,3)*dbsloc(3,ind+m)
              alp2(3) = sjac(3,1)*dbsloc(1,ind+m) + &
                  & sjac(3,2)*dbsloc(2,ind+m)+sjac(3,3)*dbsloc(3,ind+m)
              alp2(:) = alp2(:)*tij*f2

              alp2_rad = f2*tij*dot_product(dsij_rad, dbsloc(:,ind+m))

              alp(:) = alp(:) + alp1(:) + alp2(:)
              alp_rad = alp_rad + alp1_rad + alp2_rad

            end do
            t = t*tij
          end do
          beta = intmlp(params, constants, tij,sigma(:,jsph),basloc)
          xij = fsw(tij, params % se, params % eta)
          if (constants % fi(ig,isph).gt.one) then
            oij = xij/constants % fi(ig,isph)
            f2  = -oij/constants % fi(ig,isph)
          else
            oij = xij
            f2  = zero
          end if
          f1 = oij
          va(:) = va(:) + f1*alp(:) + beta*f2*constants % zi(:,ig,isph)
          va_rad = va_rad + f1*alp_rad + beta*f2*constants % zi_dr(ig,isph)
          if (tij .gt. tlow) then
            f3 = beta*dfsw(tij,params % se,params % eta)
            if (constants % fi(ig,isph).gt.one) f3 = f3/constants % fi(ig,isph)
            va(:) = va(:) + f3*dtij
            va_rad = va_rad + f3*dtij_rad
          end if
        end do
        fx = fx - constants % wgrid(ig)*xi(ig)*va(:)
        dr = dr - constants % wgrid(ig)*xi(ig)*va_rad
      end do
end subroutine contract_gradi_Lik

!> Contribution to the gradients of the ddCOSMO matrix
subroutine contract_gradi_Lji(params, constants, isph, sigma, xi, basloc, dbsloc, vplm, vcos, vsin, fx, dr)
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
      integer,                         intent(in)    :: isph
      real(dp),  dimension(constants % nbasis, params % nsph), intent(in)    :: sigma
      real(dp),  dimension(params % ngrid, params % nsph),  intent(in)    :: xi
      real(dp),  dimension(constants % nbasis),      intent(inout) :: basloc, vplm
      real(dp),  dimension(3, constants % nbasis),    intent(inout) :: dbsloc
      real(dp),  dimension(params % lmax+1),      intent(inout) :: vcos, vsin
      real(dp),  dimension(3),           intent(inout) :: fx

      integer :: ig, ji, jsph, l, ind, m, jk, ksph
      logical :: proc
      real(dp)  :: vvji, tji, xji, oji, t, fac, fl, f1, f2, beta, di, tlow, thigh
      real(dp)  :: b, g1, g2, vvjk, tjk, xjk
      real(dp)  :: vji(3), sji(3), alp(3), vb(3), vjk(3), sjk(3), vc(3)
      real(dp) :: dsji, dtji(3), alp1(3), alp2(3), alp_rad, dsji_rad(3), dtji_rad, alp1_rad, alp2_rad, vb_rad, vc_rad
      real(dp) :: rho, ctheta, stheta, cphi, sphi
      real(dp), external :: dnrm2
      real(dp), intent(inout) :: dr
      real(dp) :: sjac(3,3), qji

      tlow  = one - pt5*(one - params % se)*params % eta
      thigh = one + pt5*(one + params % se)*params % eta

      do ig = 1, params % ngrid
        vb = zero
        vc = zero

        vb_rad = zero
        vc_rad = zero

        do ji = constants % inl(isph), constants % inl(isph+1) - 1
          jsph = constants % nl(ji)
          vji  = params % csph(:,jsph) + &
              & params % rsph(jsph)*constants % cgrid(:,ig) - &
              & params % csph(:,isph)
          vvji = dnrm2(3, vji, 1)
          tji  = vvji/params % rsph(isph)
          if (tji.gt.thigh) cycle
          if (tji.ne.zero) then
              sji = vji/vvji
          else
              sji = one
          end if

          ! build the jacobian of sji
          sjac = zero
          sjac(1,1) = - one
          sjac(2,2) = - one
          sjac(3,3) = - one
          qji = one/vvji
          do icomp = 1, 3
              do jcomp = 1, 3
                  sjac(icomp,jcomp) = qji*(sjac(icomp,jcomp) &
                      & + sji(icomp)*sji(jcomp))
              end do
          end do

          dsji = 1.0_dp/(tji*params % rsph(isph))
          dtji(:) = -sji/params % rsph(isph)

          dsji_rad = zero
          dtji_rad = -tji/params%rsph(isph)

          call dbasis(params, constants, sji, basloc, dbsloc, vplm, vcos, vsin)
          alp  = zero
          alp1 = zero
          alp2 = zero

          alp_rad  = zero
          alp1_rad = zero
          alp2_rad = zero

          t    = one
          do l = 1, params % lmax
            ind = l*l + l + 1
            fl  = dble(l)
            fac = t/(constants % vscales(ind)**2)
            do m = -l, l
              f2 = fac*sigma(ind+m,isph)
              f1 = f2*fl*basloc(ind+m)

              alp1(:) = f1*dtji
              alp1_rad = f1*dtji_rad

              alp2(1) = sjac(1,1)*dbsloc(1,ind+m) + &
                  & sjac(1,2)*dbsloc(2,ind+m)+sjac(1,3)*dbsloc(3,ind+m)
              alp2(2) = sjac(2,1)*dbsloc(1,ind+m) + &
                  & sjac(2,2)*dbsloc(2,ind+m)+sjac(2,3)*dbsloc(3,ind+m)
              alp2(3) = sjac(3,1)*dbsloc(1,ind+m) + &
                  & sjac(3,2)*dbsloc(2,ind+m)+sjac(3,3)*dbsloc(3,ind+m)
              alp2(:) = alp2(:)*tji*f2

              alp2_rad = f2*tji*dot_product(dsji_rad,dbsloc(:,ind+m))

              alp(:) = alp(:) + alp1(:) + alp2(:)
              alp_rad = alp_rad + alp1_rad + alp2_rad

            end do
            t = t*tji
          end do

          xji = fsw(tji, params % se, params % eta)
          if (constants % fi(ig,jsph).gt.one) then
            oji = xji/constants % fi(ig,jsph)
          else
            oji = xji
          end if
          vb = vb + oji*alp*xi(ig,jsph)
          vb_rad = vb_rad + oji*alp_rad*xi(ig,jsph)
          if (tji .gt. tlow) then
            beta = intmlp(params, constants, tji, sigma(:,isph), basloc)
            if (constants % fi(ig,jsph) .gt. one) then
              di  = one/constants % fi(ig,jsph)
              fac = di*xji
              proc = .false.
              b    = zero
              do jk = constants % inl(jsph), constants % inl(jsph+1) - 1
                ksph = constants % nl(jk)
                vjk  = params % csph(:,jsph) + &
                    & params % rsph(jsph)*constants % cgrid(:,ig) - &
                    & params % csph(:,ksph)
                !vvjk = sqrt(dot_product(vjk,vjk))
                vvjk = dnrm2(3, vjk, 1)
                tjk  = vvjk/params % rsph(ksph)
                if (ksph.ne.isph) then
                  if (tjk .le. thigh) then
                    proc = .true.
                    sjk  = vjk/vvjk
                    !call ylmbas(sjk,basloc,vplm,vcos,vsin)
                    call ylmbas(sjk, rho, ctheta, stheta, cphi, sphi, &
                        & params % lmax, constants % vscales, basloc, vplm, &
                        & vcos, vsin)
                    g1  = intmlp(params, constants, tjk, sigma(:,ksph), basloc)
                    xjk = fsw(tjk, params % se, params % eta)
                    b   = b + g1*xjk
                  end if
                end if
              end do
              if (proc) then
                g1 = di*di*dfsw(tji, params % se, params % eta)
                g2 = g1*xi(ig,jsph)*b
                vc = vc - g2*dtji
                vc_rad = vc_rad - g2*dtji_rad
              end if
            else
              di  = one
              fac = zero
            end if
            f2 = (one-fac)*di*dfsw(tji, params % se, params % eta)
            vb = vb + f2*xi(ig,jsph)*beta*dtji
            vb_rad = vb_rad + f2*xi(ig,jsph)*beta*dtji_rad
          end if
        end do
        fx = fx - constants % wgrid(ig)*(vb + vc)
        dr = dr - constants % wgrid(ig)*(vb_rad + vc_rad)
      end do
end subroutine contract_gradi_Lji



!> Gradient of the characteristic function U
subroutine contract_grad_U(params, constants, isph, xi, phi, fx, dr)
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
      integer,                        intent(in)    :: isph
      real(dp),  dimension(params % ngrid, params % nsph), intent(in)    :: xi, phi
      real(dp),  dimension(3),          intent(inout) :: fx
      real(dp),  optional, intent(inout) :: dr
      integer :: ig, ji, jsph
      real(dp)  :: vvji, tji, fac, swthr
      real(dp)  :: alp(3), vji(3), sji(3), dtji(3)
      real(dp) :: dtji_rad, alp_rad
      real(dp), external :: dnrm2
      logical :: do_dr
      real(dp) :: dr_local

      if (present(dr)) then
          do_dr = .true.
      else
          do_dr = .false.
      end if

      do ig = 1, params % ngrid
        alp = zero
        alp_rad = zero
        if (constants % ui(ig,isph) .gt. zero .and. constants % ui(ig,isph).lt.one) then
          alp = alp + phi(ig,isph)*xi(ig,isph)*constants % zi(:,ig,isph)
          alp_rad = alp_rad + phi(ig,isph)*xi(ig,isph)*constants % zi_dr(ig,isph)
        end if
        do ji = constants % inl(isph), constants % inl(isph+1) - 1
          jsph  = constants % nl(ji)
          vji   = params % csph(:,jsph) + &
              & params % rsph(jsph)*constants % cgrid(:,ig) - &
              & params % csph(:,isph)
          !vvji  = sqrt(dot_product(vji,vji))
          vvji = dnrm2(3, vji, 1)
          tji   = vvji/params % rsph(isph)
          swthr = one + (params % se + 1.d0)*params % eta / 2.d0
          if (tji.lt.swthr .and. tji.gt.swthr-params % eta .and. constants % ui(ig,jsph).gt.zero) then
            sji = vji/vvji
            dtji = - sji / params % rsph(isph)
            dtji_rad = - vvji/(params%rsph(isph)**2)
            ! dtji_rad = dot_product(vji, constants%cgrid(:,ig)) / (vvji* params%rsph(isph)) 
            fac = dfsw(tji, params % se, params % eta) 
            alp = alp + fac*phi(ig,jsph)*xi(ig,jsph) * dtji 
            alp_rad = alp_rad + fac*phi(ig,jsph)*xi(ig,jsph) * dtji_rad
          end if
        end do
      !   fx = fx - constants % wgrid(ig)*alp
        if (present(dr)) then
         dr = dr - constants % wgrid(ig)*alp_rad
        else 
         fx = fx - constants % wgrid(ig)*alp
      end if

      end do
end subroutine contract_grad_U

!> Subroutine to compute contraction of B matrix
!!
!! @param[in]  params     : Input parameter file
!! @param[in]  constants  : Input constants file
!! @param[in]  isph       : Index of sphere
!! @param[in]  Xe         : Solution vector Xe
!! @param[in]  Xadj_e     : Adjoint solution on evaluated on grid points Xadj_e_sgrid
!! @param[out] force      : Force of adjoint part

subroutine contract_grad_B(params, constants, isph, Xe, Xadj_e, force)
    !! input/output
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: isph
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: Xe
    real(dp), dimension(params % ngrid, params % nsph), intent(in) :: Xadj_e
    real(dp), dimension(3), intent(inout) :: force

    call contract_gradi_Bik(params, constants, isph, Xe(:,:), &
        & Xadj_e(:, isph), force)
    call contract_gradi_Bji(params, constants, isph, Xe(:,:), Xadj_e, force)

end subroutine contract_grad_B

!> Subroutine to compute contraction of C matrix
!!
!! @param[in]  params      : Input parameter file
!! @param[in]  constants   : Input constants file
!! @param[in]  workspace   : Input workspace
!! @param[in] Xr           : Solution of the Laplace problem
!! @param[in] Xe           : Solution of the HSP problem
!! @param[in] Xadj_r_sgrid : Solution of the Adjoint Laplace problem evaluated at the
!!                           grid
!! @param[in] Xadj_e_sgrid : Solution of the Adjoint HSP problem evaluated at the grid
!! @param[in] Xadj_r       : Adjoint solution of the Laplace problem
!! @param[in] Xadj_e       : Adjoint solution of the HSP problem
!! @param[inout] force     : Force
!! @param[out] diff_re     : epsilon_1/epsilon_2 * l'/r_j[Xr]_jl'm'
!!                         - (i'_l'(r_j)/i_l'(r_j))[Xe]_jl'm'
!! @param[inout] ddx_error: ddX error
subroutine contract_grad_C(params, constants, workspace, Xr, Xe, Xadj_r_sgrid, &
    & Xadj_e_sgrid, Xadj_r, Xadj_e, force, diff_re, ddx_error)
    !! input/output
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: Xr, Xe
    real(dp), dimension(params % ngrid, params % nsph), intent(in) :: Xadj_r_sgrid, Xadj_e_sgrid
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: Xadj_r, Xadj_e
    real(dp), dimension(3, params % nsph), intent(inout) :: force
    real(dp), dimension(constants % nbasis, params % nsph), intent(out) :: diff_re
    type(ddx_error_type), intent(inout) :: ddx_error

    call contract_grad_C_worker2(params, constants, workspace, Xr, Xe, Xadj_r_sgrid, &
        & Xadj_e_sgrid, Xadj_r, Xadj_e, force, diff_re, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "contract_grad_C_worker2 returned an error, exiting")
        return
    end if
    call contract_grad_C_worker1(params, constants, workspace, Xadj_r_sgrid, &
        & Xadj_e_sgrid, diff_re, force, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "contract_grad_C_worker1 returned an error, exiting")
        return
    end if

end subroutine contract_grad_C


!> Subroutine to compute contraction of F0
!! @param[in]  params             : Input parameter file
!! @param[in]  constants          : Input constants file
!! @param[in]  workspace          : Input workspace
!! @param[in] sol_sgrid           : Solution of the Adjoint problem evaluated at the grid
!! @param[in] sol_adj             : Adjoint solution
!! @param[in]  normal_hessian_cav : Normal of the Hessian evaluated at cavity points
!! @param[in]  icav_g             : Index of outside cavity point
!! @param[out] force              : Force
!! @param[inout] ddx_error: ddX error
subroutine contract_grad_f(params, constants, workspace, sol_adj, sol_sgrid, &
    & gradpsi, normal_hessian_cav, force, state, ddx_error)
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: sol_adj
    real(dp), dimension(params % ngrid, params % nsph), intent(in) :: sol_sgrid
    real(dp), dimension(3, constants % ncav), intent(in) :: gradpsi
    real(dp), dimension(3, constants % ncav), intent(in) :: normal_hessian_cav
    real(dp), dimension(3, params % nsph), intent(inout) :: force
    type(ddx_error_type), intent(inout) :: ddx_error

    call contract_grad_f_worker1(params, constants, workspace, sol_adj, sol_sgrid, &
        & gradpsi, force, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "contract_grad_f_worker1 returned an error, exiting")
        return
    end if

    call contract_grad_f_worker2(params, constants, gradpsi, &
        & normal_hessian_cav, force, state, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "contract_grad_f_worker2 returned an error, exiting")
        return
    end if

end subroutine contract_grad_f

!> Subroutine to compute K^A counterpart for the HSP equation. Similar to contract_gradi_Lik.
!!
!! @param[in]  params    : Input parameter file
!! @param[in]  constants : Input constants file
!! @param[in]  isph      : Index of sphere
!! @param[in]  Xe        : Solution vector Xe
!! @param[in]  Xadj_e    : Adjoint solution on evaluated on grid points Xadj_e_sgrid
!! @param[out] force     : Force
subroutine contract_gradi_Bik(params, constants, isph, Xe, Xadj_e, force)
    !! input/output
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: isph
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: Xe
    real(dp), dimension(params % ngrid), intent(in) :: Xadj_e
    real(dp), dimension(3), intent(inout) :: force

    ! Local Variables
    integer :: igrid, ineigh, jsph
    real(dp), dimension(0:params % lmax) :: SI_rijn
    real(dp), dimension(0:params % lmax) :: DI_rijn
    ! beta   : Eq.(53) Stamm.etal.18
    ! tlow   : Lower bound for switch region
    ! thigh  : Upper bound for switch region
    ! f1     : First factor in alpha computation
    ! f2     : Second factor in alpha computation
    real(dp)  :: rijn, tij, beta, tlow, thigh, xij, oij, f1, f2, f3
    ! alpha : Eq.(52) Stamm.etal.18
    ! va    : Eq.(54) Stamm.etal.18
    real(dp)  :: vij(3), sij(3), alpha(3), va(3), rj, vtij(3)
    real(dp), external :: dnrm2
    real(dp) :: work(params % lmax+1)
    complex(dp) :: work_complex(params % lmax+1)

    SI_rijn = 0
    DI_rijn = 0

    tlow  = one - pt5*(one - params % se)*params % eta
    thigh = one + pt5*(one + params % se)*params % eta

    ! Loop over grid points
    do igrid = 1, params % ngrid
        va = zero
        do ineigh = constants % inl(isph), constants % inl(isph+1) - 1
            jsph = constants % nl(ineigh)
            vij  = params % csph(:,isph) + &
                & params % rsph(isph)*constants % cgrid(:,igrid) - &
                & params % csph(:,jsph)
            rijn = dnrm2(3, vij, 1)
            tij  = rijn/params % rsph(jsph)
            rj = params % rsph(jsph)
            if (tij.ge.thigh) cycle
            ! Computation of modified spherical Bessel function values
            if (tij.ne.zero) then
                sij = vij/rijn
            else
                sij = one
            end if
            vtij = vij*params % kappa
            call fmm_l2p_bessel_grad(vtij, params % rsph(jsph)*params % kappa, &
                & params % lmax, constants % vscales, params % kappa, &
                & Xe(:, jsph), zero, alpha)
            call fmm_l2p_bessel_work(vtij, params % lmax, constants % vscales, &
                & constants % SI_ri(:, jsph), one, Xe(:, jsph), zero, beta, &
                & work_complex, work)
            xij = fsw(tij, params % se, params % eta)
            if (constants % fi(igrid,isph).gt.one) then
                oij = xij/constants % fi(igrid,isph)
                f2  = -oij/constants % fi(igrid,isph)
            else
                oij = xij
                f2  = zero
            end if
            f1 = oij
            va(:) = va(:) + f1*alpha(:) + beta*f2*constants % zi(:,igrid,isph)
            if (tij .gt. tlow) then
                f3 = beta*dfsw(tij,params % se,params % eta)/params % rsph(jsph)
                if (constants % fi(igrid,isph).gt.one) &
                    & f3 = f3/constants % fi(igrid,isph)
                va(:) = va(:) + f3*sij(:)
            end if
        end do
        force = force - constants % wgrid(igrid)*Xadj_e(igrid)*va(:)
    end do
end subroutine contract_gradi_Bik


!> Subroutine to compute K^A+K^C counterpart for the HSP equation. Similar to contract_gradi_Lji.
!!
!! @param[in]  params     : Input parameter file
!! @param[in]  constants  : Input constants file
!! @param[in]  workspace  : Input workspace
!! @param[in]  isph       : Index of sphere
!! @param[in]  Xe         : Solution vector Xe
!! @param[in]  Xadj_e     : Adjoint solution on evaluated on grid points Xadj_e_sgrid
!! @param[out] force      : Force of adjoint part
subroutine contract_gradi_Bji(params, constants, isph, Xe, Xadj_e, force)
    !! input/output
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in)    :: isph
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: Xe
    real(dp), dimension(params % ngrid, params % nsph),  intent(in) :: Xadj_e
    real(dp), dimension(3), intent(inout) :: force

    ! Local Variables
    ! jk : Row pointer over kth row
    integer :: igrid, jsph, ksph, ineigh, jk
    real(dp), dimension(0:params % lmax) :: SI_rjin, SI_rjkn
    real(dp), dimension(0:params % lmax) :: DI_rjin, DI_rjkn

    logical :: proc
    ! fac     : \delta_fj_n*\omega^\eta_ji
    ! f1      : First factor in alpha computation
    ! f2      : Second factor in alpha computation
    ! beta_ji : Eq.(57) Stamm.etal.18
    ! dj      : Before Eq.(10) Stamm.etal.18
    real(dp)  :: rjin, tji, xji, oji, fac, f1, f2, beta_ji, dj, tlow, thigh
    real(dp)  :: b, beta_jk, g1, g2, rjkn, tjk, xjk
    ! alpha : Eq.(56) Stamm.etal.18
    ! vb    : Eq.(60) Stamm.etal.18
    ! vc    : Eq.(59) Stamm.etal.18
    real(dp)  :: vji(3), sji(3), vjk(3), alpha(3), vb(3), vc(3), &
        & vtji(3), vtjk(3)
    ! rho    : Argument for ylmbas
    ! ctheta : Argument for ylmbas
    ! stheta : Argument for ylmbas
    ! cphi   : Argument for ylmbas
    ! sphi   : Argument for ylmbas
    real(dp) :: ri

    real(dp), external :: dnrm2
    real(dp) :: work(params % lmax+1)
    complex(dp) :: work_complex(params % lmax+1)

    SI_rjin = 0
    DI_rjin = 0
    SI_rjkn = 0
    DI_rjkn = 0

    tlow  = one - pt5*(one - params % se)*params % eta
    thigh = one + pt5*(one + params % se)*params % eta

    do igrid = 1, params % ngrid
        vb = zero
        vc = zero
        do ineigh = constants % inl(isph), constants % inl(isph+1) - 1
            jsph = constants % nl(ineigh)
            vji  = params % csph(:,jsph) + &
                    & params % rsph(jsph)*constants % cgrid(:,igrid) - &
                    & params % csph(:,isph)
            rjin = dnrm2(3, vji, 1)
            ri = params % rsph(isph)
            tji  = rjin/ri
            if (tji.gt.thigh) cycle
            if (tji.ne.zero) then
                sji = vji/rjin
            else
                sji = one
            end if
            vtji = vji*params % kappa
            call fmm_l2p_bessel_grad(vtji, params % rsph(isph)*params % kappa, &
                & params % lmax, constants % vscales, params % kappa, &
                & Xe(:, isph), zero, alpha)
            xji = fsw(tji,params % se,params % eta)
            if (constants % fi(igrid,jsph).gt.one) then
                oji = xji/constants % fi(igrid,jsph)
            else
                oji = xji
            end if
            f1 = oji
            vb = vb + f1*alpha*Xadj_e(igrid,jsph)
            if (tji .gt. tlow) then
                call fmm_l2p_bessel_work(vtji, params % lmax, &
                    & constants % vscales, constants % SI_ri(:, isph), one, &
                    & Xe(:, isph), zero, beta_ji, work_complex, work)
            if (constants % fi(igrid,jsph) .gt. one) then
                dj  = one/constants % fi(igrid,jsph)
                fac = dj*xji
                proc = .false.
                b    = zero
                do jk = constants % inl(jsph), constants % inl(jsph+1) - 1
                    ksph = constants % nl(jk)
                    vjk  = params % csph(:,jsph) + &
                        & params % rsph(jsph)*constants % cgrid(:,igrid) - &
                        & params % csph(:,ksph)
                    rjkn = dnrm2(3, vjk, 1)
                    tjk  = rjkn/params % rsph(ksph)
                    if (ksph.ne.isph) then
                        if (tjk .le. thigh) then
                            proc = .true.
                            vtjk = vjk*params % kappa
                            call fmm_l2p_bessel_work(vtjk, params % lmax, &
                                & constants % vscales, &
                                & constants % SI_ri(:, ksph), one, Xe(:, ksph), &
                                & zero, beta_jk, work_complex, work)
                            xjk = fsw(tjk, params % se, params % eta)
                            b = b + beta_jk*xjk
                        end if
                    end if
                end do
                if (proc) then
                    g1 = dj*dj*dfsw(tji,params % se,params % eta) &
                        & /params % rsph(isph)
                    g2 = g1*Xadj_e(igrid,jsph)*b
                    vc = vc + g2*sji
                end if
              else
                  dj  = one
                  fac = zero
              end if
              f2 = (one-fac)*dj*dfsw(tji,params % se,params % eta) &
                  & /params % rsph(isph)
              vb = vb + f2*Xadj_e(igrid,jsph)*beta_ji*sji
            end if
        end do
        force = force + constants % wgrid(igrid)*(vb - vc)
    end do
end subroutine contract_gradi_Bji


!> Subroutine to calculate the third derivative term in C1_C2 matrix,
!! namely the derivative of PU_i
!!
!! @param[in]  params       : Input parameter file
!! @param[in]  constants    : Input constants file
!! @param[in]  workspace    : Input workspace
!! @param[in]  Xadj_r_sgrid : Adjoint Laplace solution evaluated at grid point
!! @param[in]  Xadj_e_sgrid : Adjoint HSP solution evaluated at grid point
!! @param[in]  diff_re      : l'/r_j[Xr]_jl'm' -(i'_l'(r_j)/i_l'(r_j))[Xe]_jl'm'
!! @param[out] force        : Force
!! @param[inout] ddx_error: ddX error
subroutine contract_grad_C_worker1(params, constants, workspace, Xadj_r_sgrid, &
    & Xadj_e_sgrid, diff_re, force, ddx_error)
    !! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: &
        & diff_re
    real(dp), dimension(params % ngrid, params % nsph), intent(in) :: &
        & Xadj_r_sgrid, Xadj_e_sgrid
    real(dp), dimension(3, params % nsph), intent(inout) :: force
    type(ddx_error_type), intent(inout) :: ddx_error
    ! Local variable
    ! igrid0: Index for grid point n0
    integer :: isph, jsph, igrid, l0, m0, ind0, igrid0, icav, &
        & indl, inode, istat
    ! term  : SK_rijn/SK_rj
    ! termi : DI_ri/SI_ri
    ! termk : DK_ri/SK_ri
    ! sum_int : Intermediate sum
    ! sum_r   : Intermediate sum for Laplace
    ! sum_e   : Intermediate sum for HSP
    real(dp) :: sum_int, sum_r, sum_e
    real(dp) :: rijn
    real(dp)  :: vij(3), sij(3), vtij(3)

    ! local allocatable
    ! phi_n_r : Phi corresponding to Laplace problem
    ! phi_n_e : Phi corresponding to HSP problem
    ! coefY_d : sum_{l0m0} C_ik*term*Y_l0m0^j(x_in)*Y_l0m0(s_n)
    ! diff_re_sgrid : diff_re evaluated at grid point
    real(dp), allocatable :: phi_n_r(:,:), phi_n_e(:,:), coefY_d(:,:,:), &
        & diff_re_sgrid(:,:)

    ! basloc : Y_lm(s_n)
    ! vplm   : Argument to call ylmbas
    real(dp),  dimension(constants % nbasis):: basloc, vplm
    ! dbasloc : Derivative of Y_lm(s_n)
    real(dp),  dimension(3, constants % nbasis):: dbasloc
    ! vcos   : Argument to call ylmbas
    ! vsin   : Argument to call ylmbas
    real(dp),  dimension(params % lmax+1):: vcos, vsin
    ! SK_rijn : Besssel function of first kind for rijn
    ! DK_rijn : Derivative of Besssel function of first kind for rijn
    real(dp), dimension(0:params % lmax) :: SK_rijn, DK_rijn
    real(dp) :: coef(constants % nbasis0), work(constants % lmax0+1)
    complex(dp) :: work_complex(constants % lmax0+1)

    allocate(phi_n_r(params % ngrid, params % nsph), &
        & phi_n_e(params % ngrid, params % nsph), &
        & diff_re_sgrid(params % ngrid, params % nsph), stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, "allocation ddx_error in ddx_contract_grad_C_worker1")
        return
    end if
!
    sum_int = zero
    sum_r = zero
    sum_e = zero
    phi_n_r = zero
    phi_n_e = zero
    diff_re_sgrid = zero
    basloc = zero
    vplm = zero
    dbasloc = zero
    vcos = zero
    vsin = zero
    SK_rijn = zero
    DK_rijn = zero

    if (params % fmm .eq. 0) then
        allocate(coefY_d(constants % ncav, params % ngrid, params % nsph), &
            & stat=istat)
        if (istat.ne.0) then
            call update_error(ddx_error, "allocation ddx_error in fmm ddx_contract_grad_C_worker1")
            return
        end if
        coefY_d = zero
        ! Compute  summation over l0, m0
        ! Loop over the sphers j
        do jsph = 1, params % nsph
          ! Loop over the grid points n0
          do igrid0 = 1, params % ngrid
            icav = zero
            ! Loop over spheres i
            do isph = 1, params % nsph
              ! Loop over grid points n
              do igrid = 1, params % ngrid
                ! Check for U_i^{eta}(x_in)
                if(constants % ui(igrid, isph) .gt. zero) then
                  icav = icav + 1
                  vij  = params % csph(:,isph) + &
                         & params % rsph(isph)*constants % cgrid(:,igrid) - &
                         & params % csph(:,jsph)
                  rijn = sqrt(dot_product(vij,vij))
                  sij = vij/rijn

                  do l0 = 0, constants % lmax0
                    do m0 = -l0,l0
                      ind0 = l0**2 + l0 + m0 + 1
                      coef(ind0) = constants % vgrid(ind0, igrid0) * &
                          & constants % C_ik(l0, jsph)
                    end do
                  end do
                  vtij = vij*params % kappa
                  call fmm_m2p_bessel_work(vtij, constants % lmax0, &
                      & constants % vscales, constants % SK_ri(:, jsph), one, &
                      & coef, zero, coefY_d(icav, igrid0, jsph), work_complex, work)
                end if
              end do
            end do
          end do
        end do

        ! Compute phi_in
        ! Loop over spheres j
        do jsph = 1, params % nsph
          ! Loop over grid points n0
          do igrid0 = 1, params % ngrid
            icav = zero
            sum_r = zero
            sum_e = zero
            ! Loop over sphers i
            do isph = 1, params % nsph
              ! Loop over grid points n
              do igrid = 1, params % ngrid
                if(constants % ui(igrid, isph) .gt. zero) then
                  icav = icav + 1
                  sum_r = sum_r + coefY_d(icav, igrid0, jsph)*Xadj_r_sgrid(igrid, isph) &
                          & * constants % wgrid(igrid)*constants % ui(igrid, isph)
                  sum_e = sum_e + coefY_d(icav, igrid0, jsph)*Xadj_e_sgrid(igrid, isph) &
                          & * constants % wgrid(igrid)*constants % ui(igrid, isph)
                end if
              end do
            end do
            phi_n_r(igrid0, jsph) = sum_r
            phi_n_e(igrid0, jsph) = sum_e
          end do
        end do
    else
        ! Compute phi_n_r at first
        ! Adjoint integration from spherical harmonics to grid points is not needed
        ! here as ygrid already contains grid values, we just need to scale it by
        ! weights of grid points
        do isph = 1, params % nsph
            workspace % tmp_grid(:, isph) = Xadj_r_sgrid(:, isph) * &
                & constants % wgrid(:) * constants % ui(:, isph)
        end do
        ! Adjoint FMM
        call tree_m2p_bessel_adj(params, constants, constants % lmax0, one, &
            & workspace % tmp_grid, zero, params % lmax, workspace % tmp_sph)
        call tree_l2p_bessel_adj(params, constants, one, workspace % tmp_grid, &
            & zero, workspace % tmp_node_l)
        call tree_l2l_bessel_rotation_adj(params, constants, &
            & workspace % tmp_node_l)
        call tree_m2l_bessel_rotation_adj(params, constants, &
            & workspace % tmp_node_l, workspace % tmp_node_m)
        call tree_m2m_bessel_rotation_adj(params, constants, &
            & workspace % tmp_node_m)
        ! Properly load adjoint multipole harmonics into tmp_sph
        if(constants % lmax0 .lt. params % pm) then
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_sph(1:constants % nbasis0, isph) = &
                    & workspace % tmp_sph(1:constants % nbasis0, isph) + &
                    & workspace % tmp_node_m(1:constants % nbasis0, inode)
            end do
        else
            indl = (params % pm+1)**2
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_sph(1:indl, isph) = &
                    & workspace % tmp_sph(1:indl, isph) + &
                    & workspace % tmp_node_m(:, inode)
            end do
        end if
        ! Scale by C_ik
        do isph = 1, params % nsph
            do l0 = 0, constants % lmax0
                ind0 = l0*l0 + l0 + 1
                workspace % tmp_sph(ind0-l0:ind0+l0, isph) = &
                    & workspace % tmp_sph(ind0-l0:ind0+l0, isph) * &
                    & constants % C_ik(l0, isph)
            end do
        end do
        ! Multiply by vgrid
        call dgemm('T', 'N', params % ngrid, params % nsph, constants % nbasis0, &
            & one, constants % vgrid, constants % vgrid_nbasis, &
            & workspace % tmp_sph, constants % nbasis, zero, phi_n_r, params % ngrid)
        ! Compute phi_n_e now
        ! Adjoint integration from spherical harmonics to grid points is not needed
        ! here as ygrid already contains grid values, we just need to scale it by
        ! weights of grid points
        do isph = 1, params % nsph
            workspace % tmp_grid(:, isph) = Xadj_e_sgrid(:, isph) * &
                & constants % wgrid(:) * constants % ui(:, isph)
        end do
        ! Adjoint FMM
        call tree_m2p_bessel_adj(params, constants, constants % lmax0, one, &
            & workspace % tmp_grid, zero, params % lmax, workspace % tmp_sph)
        call tree_l2p_bessel_adj(params, constants, one, workspace % tmp_grid, &
            & zero, workspace % tmp_node_l)
        call tree_l2l_bessel_rotation_adj(params, constants, &
            & workspace % tmp_node_l)
        call tree_m2l_bessel_rotation_adj(params, constants, &
            & workspace % tmp_node_l, workspace % tmp_node_m)
        call tree_m2m_bessel_rotation_adj(params, constants, &
            & workspace % tmp_node_m)
        ! Properly load adjoint multipole harmonics into tmp_sph
        if(constants % lmax0 .lt. params % pm) then
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_sph(1:constants % nbasis0, isph) = &
                    & workspace % tmp_sph(1:constants % nbasis0, isph) + &
                    & workspace % tmp_node_m(1:constants % nbasis0, inode)
            end do
        else
            indl = (params % pm+1)**2
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_sph(1:indl, isph) = &
                    & workspace % tmp_sph(1:indl, isph) + &
                    & workspace % tmp_node_m(:, inode)
            end do
        end if
        ! Scale by C_ik
        do isph = 1, params % nsph
            do l0 = 0, constants % lmax0
                ind0 = l0*l0 + l0 + 1
                workspace % tmp_sph(ind0-l0:ind0+l0, isph) = &
                    & workspace % tmp_sph(ind0-l0:ind0+l0, isph) * &
                    & constants % C_ik(l0, isph)
            end do
        end do
        ! Multiply by vgrid
        call dgemm('T', 'N', params % ngrid, params % nsph, constants % nbasis0, &
            & one, constants % vgrid, constants % vgrid_nbasis, &
            & workspace % tmp_sph, constants % nbasis, zero, phi_n_e, params % ngrid)
    end if
    call dgemm('T', 'N', params % ngrid, params % nsph, &
              & constants % nbasis, one, constants % vgrid, constants % vgrid_nbasis, &
              & diff_re , constants % nbasis, zero, diff_re_sgrid, &
              & params % ngrid)
    do isph = 1, params % nsph
        call contract_grad_U(params, constants, isph, diff_re_sgrid, phi_n_r, force(:, isph))
        call contract_grad_U(params, constants, isph, diff_re_sgrid, phi_n_e, force(:, isph))
    end do

    deallocate(phi_n_r, phi_n_e, diff_re_sgrid, stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, "deallocation ddx_error in ddx_contract_grad_C_worker1")
        return
    end if
    if (allocated(coefY_d)) then
        deallocate(coefY_d, stat=istat)
        if (istat.ne.0) then
            call update_error(ddx_error, "deallocation ddx_error in ddx_contract_grad_C_worker1")
            return
        end if
    end if
end subroutine contract_grad_C_worker1


!> Subroutine to compute the derivative of U_i(x_in) and \bf{k}^j_l0(x_in)Y^j_l0m0(x_in)
!!
!! contract_grad_C_worker2 : Force Derivative of U_i^e(x_in), k_l0, and Y_l0m0
!! @param[in]  params      : Input parameter file
!! @param[in]  constants   : Input constants file
!! @param[in]  workspace   : Input workspace
!! @param[in] ksph         : Derivative with respect to x_k
!! @param[in] Xr           : Solution of the Laplace problem
!! @param[in] Xe           : Solution of the HSP problem
!! @param[in] Xadj_r_sgrid : Solution of the Adjoint Laplace problem evaluated at the
!!                           grid
!! @param[in] Xadj_e_sgrid : Solution of the Adjoint HSP problem evaluated at the grid
!! @param[in] Xadj_r       : Adjoint solution of the Laplace problem
!! @param[in] Xadj_e       : Adjoint solution of the HSP problem
!! @param[inout] force     : Force
!! @param[out] diff_re     : epsilon_1/epsilon_2 * l'/r_j[Xr]_jl'm'
!!                         - (i'_l'(r_j)/i_l'(r_j))[Xe]_jl'm'
!! @param[inout] ddx_error: ddX error
subroutine contract_grad_C_worker2(params, constants, workspace, Xr, Xe, &
        & Xadj_r_sgrid, Xadj_e_sgrid, Xadj_r, Xadj_e, force, diff_re, ddx_error)
    !! input/output
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: Xr, Xe
    real(dp), dimension(params % ngrid, params % nsph), intent(in) :: &
        & Xadj_r_sgrid, Xadj_e_sgrid
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: &
        & Xadj_r, Xadj_e
    real(dp), dimension(3, params % nsph), intent(inout) :: force
    real(dp), dimension(constants % nbasis, params % nsph), intent(out) :: &
        & diff_re
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), external :: dnrm2
    ! Local variable
    integer :: isph, jsph, igrid, l, m, ind, l0, ind0, icav, indl, inode, &
        & ksph, knode, jnode, knear, jsph_node, istat
    ! val_dim3 : Intermediate value array of dimension 3
    real(dp), dimension(3) :: vij, vtij
    ! val   : Intermediate variable to compute diff_ep
    real(dp) :: val
    ! large local are allocatable
    ! phi_in : sum_{j=1}^N diff0_j * coefY_j
    ! diff_ep_dim3 : 3 dimensional couterpart of diff_ep
    ! sum_dim3 : Storage of sum
    ! diff0       : dot_product([PU_j]_l0m0^l'm', l'/r_j[Xr]_jl'm' -
    !                        (i'_l'(r_j)/i_l'(r_j))[Xe]_jl'm')
    real(dp), allocatable :: diff_ep_dim3(:,:), phi_in(:,:), sum_dim3(:,:,:), &
        & diff0(:,:), diff1(:,:), diff1_grad(:,:,:), l2l_grad(:,:,:)
    real(dp), dimension(0:params % lmax) :: SK_rijn, DK_rijn
    complex(dp) :: work_complex(constants % lmax0+2)
    real(dp) :: work(constants % lmax0+2)

    allocate(diff_ep_dim3(3, constants % ncav), &
        & phi_in(params % ngrid, params % nsph), &
        & sum_dim3(3, constants % nbasis, params % nsph), &
        & diff0(constants % nbasis0, params % nsph), &
        & diff1(constants % nbasis0, params % nsph), &
        & diff1_grad((constants % lmax0+2)**2, 3, params % nsph), &
        & l2l_grad((params % pl+2)**2, 3, params % nsph), stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, "allocation ddx_error in ddx_contract_grad_C_worker2")
        return
    end if

    ! Setting initial values to zero
    SK_rijn = zero
    DK_rijn = zero

    diff_re = zero
    ! Compute l'/r_j[Xr]_jl'm' -(i'_l'(r_j)/i_l'(r_j))[Xe]_jl'm'
    !$omp parallel do default(none) shared(params,diff_re,constants,xr,xe) &
    !$omp private(jsph,l,m,ind) schedule(dynamic)
    do jsph = 1, params % nsph
      do l = 0, params % lmax
        do m = -l,l
          ind = l**2 + l + m + 1
          diff_re(ind,jsph) = (params % epsp/params % eps)*(l/params % rsph(jsph)) * &
                & Xr(ind,jsph) - constants % termimat(l,jsph)*Xe(ind,jsph)
        end do
      end do
    end do

    ! diff0 = Pchi * diff_re, linear scaling
    diff0 = zero
    !$omp parallel do default(none) shared(params,constants,diff_re,diff0, &
    !$omp diff1,diff1_grad) private(jsph,l0,ind0) schedule(dynamic)
    do jsph = 1, params % nsph
      do l0 = 0, constants % lmax0
        do ind0 = l0*l0+1, l0*l0+2*l0+1
          diff0(ind0, jsph) = dot_product(diff_re(:,jsph), &
              & constants % Pchi(:,ind0, jsph))
          diff1(ind0, jsph) = diff0(ind0, jsph) * constants % C_ik(l0, jsph)
        end do
      end do
      ! Prepare diff1_grad
      call fmm_m2m_bessel_grad(constants % lmax0, constants % SK_ri(:, jsph), &
          & constants % vscales, diff1(:, jsph), diff1_grad(:, :, jsph))
    end do

    if (params % fmm .eq. 0) then
        ! phi_in = diff0 * coefY
        ! Here, summation over j takes place
        phi_in = zero
        icav = 0
        do isph = 1, params % nsph
          do igrid = 1, params % ngrid
            if(constants % ui(igrid, isph) .gt. zero) then
              ! Extrenal grid point
              icav = icav + 1
              val = zero
              do jsph = 1, params % nsph
                !do ind0 = 1, constants % nbasis0
                !!====== This place requirs coefY, that is not precomputed anymore
                !  val = val + diff0(ind0,jsph)*constants % coefY(icav,ind0,jsph)
                !end do
                vij = params % csph(:, isph) + &
                    & params % rsph(isph)*constants % cgrid(:, igrid) - &
                    & params % csph(:, jsph)
                vtij = vij * params % kappa
                call fmm_m2p_bessel_work(vtij, constants % lmax0, &
                    & constants % vscales, constants % SK_ri(:, jsph), one, &
                    & diff1(:, jsph), one, val, work_complex, work)
              end do
              phi_in(igrid, isph) = val
            end if
          end do
        end do
    else
        ! phi_in
        ! Load input harmonics into tree data
        workspace % tmp_sph = zero
        workspace % tmp_sph(1:constants % nbasis0, :) = diff1(:, :)
        if(constants % lmax0 .lt. params % pm) then
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_node_m(1:constants % nbasis0, inode) = &
                    & workspace % tmp_sph(1:constants % nbasis0, isph)
                workspace % tmp_node_m(constants % nbasis0+1:, inode) = zero
            end do
        else
            indl = (params % pm+1)**2
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_node_m(:, inode) = workspace % tmp_sph(1:indl, isph)
            end do
        end if
        ! Do FMM operations
        call tree_m2m_bessel_rotation(params, constants, workspace % tmp_node_m)
        call tree_m2l_bessel_rotation(params, constants, workspace % tmp_node_m, &
            & workspace % tmp_node_l)
        call tree_l2l_bessel_rotation(params, constants, workspace % tmp_node_l)
        call tree_l2p_bessel(params, constants, one, workspace % tmp_node_l, zero, &
            & phi_in)
        call tree_m2p_bessel(params, constants, constants % lmax0, one, &
            & params % lmax, workspace % tmp_sph, one, &
            & phi_in)
        ! Make phi_in zero at internal grid points
        !$omp parallel do default(none) shared(params,constants,phi_in) &
        !$omp private(isph,igrid) schedule(dynamic)
        do isph = 1, params % nsph
            do igrid = 1, params % ngrid
                if (constants % ui(igrid, isph) .eq. zero) then
                    phi_in(igrid, isph) = zero
                end if
            end do
        end do
        ! Get gradients of the L2L
        !$omp parallel do default(none) shared(params,constants,workspace, &
        !$omp l2l_grad) private(isph,igrid,inode) schedule(dynamic)
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            workspace % tmp_sph_l(:, isph) = workspace % tmp_node_l(:, inode)
            call fmm_l2l_bessel_grad(params % pl, &
                & constants % SI_ri(:, isph), constants % vscales, &
                & workspace % tmp_node_l(:, inode), &
                & l2l_grad(:, :, isph))
        end do
        workspace % tmp_sph = Xadj_r + Xadj_e
        call dgemm('T', 'N', params % ngrid, params % nsph, constants % nbasis, &
            & one, constants % vwgrid, constants % vgrid_nbasis, &
            & workspace % tmp_sph, constants % nbasis, zero, &
            & workspace % tmp_grid, params % ngrid)
        workspace % tmp_grid = workspace % tmp_grid * constants % ui
        ! Adjoint FMM with output tmp_sph2(:, :) which stores coefficients of
        ! harmonics of degree up to lmax+1
        call tree_m2p_bessel_nodiag_adj(params, constants, constants % lmax0+1, one, &
            & workspace % tmp_grid, zero, params % lmax+1, workspace % tmp_sph2)
        call tree_l2p_bessel_adj(params, constants, one, workspace % tmp_grid, zero, &
            & workspace % tmp_node_l)
        call tree_l2l_bessel_rotation_adj(params, constants, workspace % tmp_node_l)
        call tree_m2l_bessel_rotation_adj(params, constants, workspace % tmp_node_l, &
            & workspace % tmp_node_m)
        call tree_m2m_bessel_rotation_adj(params, constants, workspace % tmp_node_m)
        ! Properly load adjoint multipole harmonics into tmp_sph2 that holds
        ! harmonics of a degree up to lmax+1
        if(constants % lmax0+1 .lt. params % pm) then
            !$omp parallel do default(none) shared(params,constants, &
            !$omp workspace) private(isph,inode) schedule(dynamic)
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_sph2(1:(constants % lmax0+2)**2, isph) = &
                    & workspace % tmp_sph2(1:(constants % lmax0+2)**2, isph) + &
                    & workspace % tmp_node_m(1:(constants % lmax0+2)**2, inode)
            end do
        else
            indl = (params % pm+1)**2
            !$omp parallel do default(none) shared(params,constants,indl, &
            !$omp workspace) private(isph,inode) schedule(dynamic)
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_sph2(1:indl, isph) = &
                    & workspace % tmp_sph2(1:indl, isph) + &
                    & workspace % tmp_node_m(:, inode)
            end do
        end if
    end if

    do ksph = 1, params % nsph
        ! Computation of derivative of U_i^e(x_in)
        call contract_grad_U(params, constants, ksph, Xadj_r_sgrid, phi_in, force(:, ksph))
        call contract_grad_U(params, constants, ksph, Xadj_e_sgrid, phi_in, force(:, ksph))

        ! Aleksandr: my loop for the diff_ep_dim3
        diff_ep_dim3 = zero
        ! At first isph=ksph, jsph!=ksph
        icav = constants % icav_ia(ksph) - 1
        if (params % fmm .eq. 0) then
            do igrid = 1, params % ngrid
              if (constants % ui(igrid, ksph) .eq. zero) cycle
              icav = icav + 1
              do jsph = 1, params % nsph
                if (jsph .eq. ksph) cycle
                  vij  = params % csph(:,ksph) + &
                      & params % rsph(ksph)*constants % cgrid(:,igrid) - &
                      & params % csph(:,jsph)
                  vtij = vij * params % kappa
                  !call fmm_m2p_bessel_grad(vtij, &
                  !    & params % rsph(jsph)*params % kappa, &
                  !    & constants % lmax0, &
                  !    & constants % vscales, params % kappa, diff1(:, jsph), one, &
                  !    & diff_ep_dim3(:, icav))
                  call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                      & constants % vscales, constants % SK_ri(:, jsph), &
                      & -params % kappa, diff1_grad(:, 1, jsph), one, &
                      & diff_ep_dim3(1, icav), work_complex, work)
                  call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                      & constants % vscales, constants % SK_ri(:, jsph), &
                      & -params % kappa, diff1_grad(:, 2, jsph), one, &
                      & diff_ep_dim3(2, icav), work_complex, work)
                  call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                      & constants % vscales, constants % SK_ri(:, jsph), &
                      & -params % kappa, diff1_grad(:, 3, jsph), one, &
                      & diff_ep_dim3(3, icav), work_complex, work)
              end do
            end do
        else
            knode = constants % snode(ksph)
            do igrid = 1, params % ngrid
                if (constants % ui(igrid, ksph) .eq. zero) cycle
                icav = icav + 1
                ! Far-field
                call dgemv('T', (params % pl+2)**2, 3, -params % kappa, &
                    & l2l_grad(1, 1, ksph), &
                    & (params % pl+2)**2, constants % vgrid(1, igrid), 1, &
                    & one, diff_ep_dim3(1, icav), 1)
                ! Near-field
                do knear = constants % snear(knode), constants % snear(knode+1)-1
                    jnode = constants % near(knear)
                    do jsph_node = constants % cluster(1, jnode), &
                        & constants % cluster(2, jnode)
                        jsph = constants % order(jsph_node)
                        if (jsph .eq. ksph) cycle
                        vij = params % csph(:, ksph) - params % csph(:, jsph) + &
                            & params % rsph(ksph)*constants % cgrid(:, igrid)
                        vtij = vij * params % kappa
                        call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                            & constants % vscales, constants % SK_ri(:, jsph), &
                            & -params % kappa, diff1_grad(:, 1, jsph), one, &
                            & diff_ep_dim3(1, icav), work_complex, work)
                        call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                            & constants % vscales, constants % SK_ri(:, jsph), &
                            & -params % kappa, diff1_grad(:, 2, jsph), one, &
                            & diff_ep_dim3(2, icav), work_complex, work)
                        call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                            & constants % vscales, constants % SK_ri(:, jsph), &
                            & -params % kappa, diff1_grad(:, 3, jsph), one, &
                            & diff_ep_dim3(3, icav), work_complex, work)
                    end do
                end do
            end do
        end if
        sum_dim3 = zero
        icav = constants % icav_ia(ksph) - 1
        do igrid =1, params % ngrid
            if(constants % ui(igrid, ksph) .gt. zero) then
                icav = icav + 1
                do ind = 1, constants % nbasis
                    sum_dim3(:,ind,ksph) = sum_dim3(:,ind,ksph) &
                        & + diff_ep_dim3(:,icav)*constants % ui(igrid, ksph) &
                        & *constants % vwgrid(ind, igrid)
                end do
            end if
        end do
        do ind = 1, constants % nbasis
            force(:, ksph) = force(:, ksph) + &
                & sum_dim3(:, ind, ksph)*(Xadj_r(ind, ksph) + &
                & Xadj_e(ind, ksph))
        end do

        ! Now jsph=ksph and isph!=ksph
        if (params % fmm .eq. 0) then
            diff_ep_dim3 = zero
            sum_dim3 = zero
            do isph = 1, params % nsph
              if (isph .eq. ksph) cycle
              icav = constants % icav_ia(isph) - 1
              do igrid = 1, params % ngrid
                  if (constants % ui(igrid, isph) .eq. zero) cycle
                  icav = icav + 1
                  vij  = params % csph(:,isph) + &
                      & params % rsph(isph)*constants % cgrid(:,igrid) - &
                      & params % csph(:,ksph)
                  vtij = vij * params % kappa
                  !call fmm_m2p_bessel_grad(vij * params % kappa, &
                  !    & params % rsph(ksph)*params % kappa, &
                  !    & constants % lmax0, &
                  !    & constants % vscales, -params % kappa, diff1(:, ksph), one, &
                  !    & diff_ep_dim3(:, icav))
                  call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                      & constants % vscales, constants % SK_ri(:, ksph), &
                      & params % kappa, diff1_grad(:, 1, ksph), one, &
                      & diff_ep_dim3(1, icav), work_complex, work)
                  call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                      & constants % vscales, constants % SK_ri(:, ksph), &
                      & params % kappa, diff1_grad(:, 2, ksph), one, &
                      & diff_ep_dim3(2, icav), work_complex, work)
                  call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                      & constants % vscales, constants % SK_ri(:, ksph), &
                      & params % kappa, diff1_grad(:, 3, ksph), one, &
                      & diff_ep_dim3(3, icav), work_complex, work)
              end do
            end do
            icav = zero
            do isph = 1, params % nsph
              do igrid =1, params % ngrid
                if(constants % ui(igrid, isph) .gt. zero) then
                  icav = icav + 1
                  do ind = 1, constants % nbasis
                    sum_dim3(:,ind,isph) = sum_dim3(:,ind,isph) &
                        & + diff_ep_dim3(:,icav)*constants % ui(igrid, isph) &
                        & *constants % vwgrid(ind, igrid)
                  end do
                end if
              end do
            end do
            ! Computation of derivative of \bf(k)_j^l0(x_in)\times Y^j_l0m0(x_in)
            do isph = 1, params % nsph
              do ind = 1, constants % nbasis
                force(:, ksph) = force(:, ksph) &
                    & + sum_dim3(:, ind, isph)*(Xadj_r(ind, isph) &
                    & + Xadj_e(ind, isph))
              end do
            end do
        else
            call dgemv('T', (constants % lmax0+2)**2, 3, params % kappa, &
                & diff1_grad(1, 1, ksph), (constants % lmax0+2)**2, &
                & workspace % tmp_sph2(1, ksph), 1, one, force(1, ksph), 1)
        end if
    end do
    deallocate(diff_ep_dim3, phi_in, sum_dim3, diff1_grad, l2l_grad, &
        & diff0, diff1, stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, "deallocation ddx_error in ddx_contract_grad_C_worker2")
        return
    end if
end subroutine contract_grad_C_worker2

!> Subroutine to compute the derivative of U_i(x_in) and \bf{k}^j_l0(x_in)Y^j_l0m0(x_in)
!! in F0
!!
!! contract_grad_f_worker1 : Force Derivative of U_i^e(x_in), k_l0, and Y_l0m0 in F0
!! @param[in]  params      : Input parameter file
!! @param[in]  constants   : Input constants file
!! @param[in]  workspace   : Input workspace
!! @param[in] ksph         : Derivative with respect to x_k
!! @param[in] sol_sgrid    : Solution of the Adjoint problem evaluated at the grid
!! @param[in] sol_adj      : Adjoint solution
!! @param[in] gradpsi      : Gradient of Psi_0
!! @param[inout] force     : Force
!! @param[inout] ddx_error: ddX error
subroutine contract_grad_f_worker1(params, constants, workspace, sol_adj, sol_sgrid, &
    & gradpsi, force, ddx_error)
    ! input/output
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    real(dp), dimension(constants % nbasis, params % nsph), intent(in) :: &
        & sol_adj
    real(dp), dimension(params % ngrid, params % nsph), intent(in) :: sol_sgrid
    real(dp), dimension(3, constants % ncav), intent(in) :: gradpsi
    real(dp), dimension(3, params % nsph), intent(inout) :: force
    type(ddx_error_type), intent(inout) :: ddx_error

    ! local
    real(dp), external :: dnrm2
    integer :: isph, jsph, igrid, ind, l0, ind0, icav, ksph, &
        & knode, jnode, knear, jsph_node, indl, inode, istat
    ! val_dim3 : Intermediate value array of dimension 3
    real(dp), dimension(3) :: vij, vtij
    ! val     : Intermediate variable to compute diff_ep
    ! nderpsi : Derivative of psi on grid points
    real(dp) :: nderpsi, sum_int

    ! local allocatable
    ! phi_in : sum_{j=1}^N diff0_j * coefY_j
    ! diff_ep_dim3 : 3 dimensional couterpart of diff_ep
    ! sum_dim3 : Storage of sum
    ! Debug purpose
    ! These variables can be taken from the subroutine update_rhs
    ! diff0       : dot_product([PU_j]_l0m0^l'm', l'/r_j[Xr]_jl'm' -
    !                        (i'_l'(r_j)/i_l'(r_j))[Xe]_jl'm')
    ! sum_Sjin : \sum_j [S]_{jin} Eq.~(97) [QSM20.SISC]
    ! c0 : \sum_{n=1}^N_g w_n U_j^{x_nj}\partial_n psi_0(x_nj)Y_{l0m0}(s_n)
    real(dp), allocatable :: phi_in(:,:), diff_ep_dim3(:,:), &
        & sum_dim3(:,:,:), diff0(:,:), sum_sjin(:,:), &
        & c0_d(:,:), c0_d1(:,:), c0_d1_grad(:,:,:), l2l_grad(:,:,:)
    real(dp), dimension(0:params % lmax) :: SK_rijn, DK_rijn
    complex(dp) :: work_complex(constants % lmax0 + 2)
    real(dp) :: work(constants % lmax0 + 2)

    allocate(phi_in(params % ngrid, params % nsph), &
        & diff_ep_dim3(3, constants % ncav), &
        & sum_dim3(3, constants % nbasis, params % nsph), &
        & c0_d(constants % nbasis0, params % nsph), &
        & c0_d1(constants % nbasis0, params % nsph), &
        & c0_d1_grad((constants % lmax0+2)**2, 3, params % nsph), &
        & sum_Sjin(params % ngrid, params % nsph), &
        & l2l_grad((params % pl+2)**2, 3, params % nsph), &
        & diff0(constants % nbasis0, params % nsph), stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, "allocation ddx_error in ddx_grad_f_worker1")
        return
    end if


    ! Setting initial values to zero
    SK_rijn = zero
    DK_rijn = zero
    c0_d = zero
    c0_d1 = zero
    c0_d1_grad = zero

    icav = zero
    do isph = 1, params % nsph
      do igrid= 1, params % ngrid
        if ( constants % ui(igrid,isph) .gt. zero ) then
          icav = icav + 1
          nderpsi = dot_product( gradpsi(:,icav),constants % cgrid(:,igrid) )
          c0_d(:, isph) = c0_d(:,isph) + &
                       & constants % wgrid(igrid)* &
                       & constants % ui(igrid,isph)*&
                       & nderpsi* &
                       & constants % vgrid(1:constants % nbasis0,igrid)
          do l0 = 0, constants % lmax0
              ind0 = l0*l0 + l0 + 1
              c0_d1(ind0-l0:ind0+l0, isph) = c0_d(ind0-l0:ind0+l0, isph) * &
                  & constants % C_ik(l0, isph)
          end do
          ! Prepare c0_d1_grad
          call fmm_m2m_bessel_grad(constants % lmax0, constants % SK_ri(:, isph), &
              & constants % vscales, c0_d1(:, isph), c0_d1_grad(:, :, isph))
        end if
      end do
    end do

    if (params % fmm .eq. 0) then
        ! Compute [S]_{jin}
        icav = 0
        do isph = 1, params % nsph
          do igrid = 1, params % ngrid
            if (constants % ui(igrid,isph).gt.zero) then
              icav = icav + 1
              sum_int = zero
              ! Loop to compute Sijn
              do jsph = 1, params % nsph
                vij = params % csph(:, isph) + &
                    & params % rsph(isph)*constants % cgrid(:, igrid) - &
                    & params % csph(:, jsph)
                vtij = vij * params % kappa
                call fmm_m2p_bessel_work(vtij, constants % lmax0, &
                    & constants % vscales, constants % SK_ri(:, jsph), one, &
                    & c0_d1(:, jsph), one, sum_int, work_complex, work)
              end do ! End of loop jsph
              sum_Sjin(igrid,isph) = -(params % epsp/params % eps)*sum_int
            end if
          end do ! End of loop igrid
        end do ! End of loop isph
    else
        ! Load input harmonics into tree data
        workspace % tmp_sph = zero
        workspace % tmp_sph(1:constants % nbasis0, :) = c0_d1(:, :)
        if(constants % lmax0 .lt. params % pm) then
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_node_m(1:constants % nbasis0, inode) = &
                    & workspace % tmp_sph(1:constants % nbasis0, isph)
                workspace % tmp_node_m(constants % nbasis0+1:, inode) = zero
            end do
        else
            indl = (params % pm+1)**2
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_node_m(:, inode) = workspace % tmp_sph(1:indl, isph)
            end do
        end if
        ! Do FMM operations
        call tree_m2m_bessel_rotation(params, constants, workspace % tmp_node_m)
        call tree_m2l_bessel_rotation(params, constants, workspace % tmp_node_m, &
            & workspace % tmp_node_l)
        call tree_l2l_bessel_rotation(params, constants, workspace % tmp_node_l)
        call tree_l2p_bessel(params, constants, -params % epsp/params % eps, workspace % tmp_node_l, zero, &
            & sum_Sjin)
        call tree_m2p_bessel(params, constants, constants % lmax0, -params % epsp/params % eps, &
            & params % lmax, workspace % tmp_sph, one, &
            & sum_Sjin)
        ! Make phi_in zero at internal grid points
        do isph = 1, params % nsph
            do igrid = 1, params % ngrid
                if (constants % ui(igrid, isph) .eq. zero) then
                    sum_Sjin(igrid, isph) = zero
                end if
            end do
        end do
        ! Get gradients of the L2L
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            workspace % tmp_sph_l(:, isph) = workspace % tmp_node_l(:, inode)
            call fmm_l2l_bessel_grad(params % pl, &
                & constants % SI_ri(:, isph), constants % vscales, &
                & workspace % tmp_node_l(:, inode), &
                & l2l_grad(:, :, isph))
        end do
        workspace % tmp_sph = sol_adj
        call dgemm('T', 'N', params % ngrid, params % nsph, constants % nbasis, &
            & one, constants % vwgrid, constants % vgrid_nbasis, &
            & workspace % tmp_sph, constants % nbasis, zero, &
            & workspace % tmp_grid, params % ngrid)
        workspace % tmp_grid = workspace % tmp_grid * constants % ui
        ! Adjoint FMM with output tmp_sph2(:, :) which stores coefficients of
        ! harmonics of degree up to lmax+1
        call tree_m2p_bessel_nodiag_adj(params, constants, constants % lmax0+1, one, &
            & workspace % tmp_grid, zero, params % lmax+1, workspace % tmp_sph2)
        call tree_l2p_bessel_adj(params, constants, one, workspace % tmp_grid, zero, &
            & workspace % tmp_node_l)
        call tree_l2l_bessel_rotation_adj(params, constants, workspace % tmp_node_l)
        call tree_m2l_bessel_rotation_adj(params, constants, workspace % tmp_node_l, &
            & workspace % tmp_node_m)
        call tree_m2m_bessel_rotation_adj(params, constants, workspace % tmp_node_m)
        ! Properly load adjoint multipole harmonics into tmp_sph2 that holds
        ! harmonics of a degree up to lmax+1
        if(constants % lmax0+1 .lt. params % pm) then
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_sph2(1:(constants % lmax0+2)**2, isph) = &
                    & workspace % tmp_sph2(1:(constants % lmax0+2)**2, isph) + &
                    & workspace % tmp_node_m(1:(constants % lmax0+2)**2, inode)
            end do
        else
            indl = (params % pm+1)**2
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_sph2(1:indl, isph) = &
                    & workspace % tmp_sph2(1:indl, isph) + &
                    & workspace % tmp_node_m(:, inode)
            end do
        end if
    end if
    do ksph = 1, params % nsph
        ! Computation of derivative of U_i^e(x_in)
        call contract_grad_U(params, constants, ksph, sol_sgrid, sum_Sjin, force(:, ksph))
        ! Aleksandr: my loop for the diff_ep_dim3
        diff_ep_dim3 = zero
        ! At first isph=ksph, jsph!=ksph
        icav = constants % icav_ia(ksph) - 1
        if (params % fmm .eq. 0) then
            do igrid = 1, params % ngrid
              if (constants % ui(igrid, ksph) .eq. zero) cycle
              icav = icav + 1
              do jsph = 1, params % nsph
                if (jsph .eq. ksph) cycle
                  vij  = params % csph(:,ksph) + &
                      & params % rsph(ksph)*constants % cgrid(:,igrid) - &
                      & params % csph(:,jsph)
                  vtij = vij * params % kappa
                  call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                      & constants % vscales, constants % SK_ri(:, jsph), &
                      & -params % kappa, c0_d1_grad(:, 1, jsph), one, &
                      & diff_ep_dim3(1, icav), work_complex, work)
                  call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                      & constants % vscales, constants % SK_ri(:, jsph), &
                      & -params % kappa, c0_d1_grad(:, 2, jsph), one, &
                      & diff_ep_dim3(2, icav), work_complex, work)
                  call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                      & constants % vscales, constants % SK_ri(:, jsph), &
                      & -params % kappa, c0_d1_grad(:, 3, jsph), one, &
                      & diff_ep_dim3(3, icav), work_complex, work)
              end do
            end do
        else
            knode = constants % snode(ksph)
            do igrid = 1, params % ngrid
                if (constants % ui(igrid, ksph) .eq. zero) cycle
                icav = icav + 1
                ! Far-field
                call dgemv('T', (params % pl+2)**2, 3, -params % kappa, &
                    & l2l_grad(1, 1, ksph), &
                    & (params % pl+2)**2, constants % vgrid(1, igrid), 1, &
                    & one, diff_ep_dim3(1, icav), 1)
                ! Near-field
                do knear = constants % snear(knode), constants % snear(knode+1)-1
                    jnode = constants % near(knear)
                    do jsph_node = constants % cluster(1, jnode), &
                        & constants % cluster(2, jnode)
                        jsph = constants % order(jsph_node)
                        if (jsph .eq. ksph) cycle
                        vij = params % csph(:, ksph) - params % csph(:, jsph) + &
                            & params % rsph(ksph)*constants % cgrid(:, igrid)
                        vtij = vij * params % kappa
                        call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                            & constants % vscales, constants % SK_ri(:, jsph), &
                            & -params % kappa, c0_d1_grad(:, 1, jsph), one, &
                            & diff_ep_dim3(1, icav), work_complex, work)
                        call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                            & constants % vscales, constants % SK_ri(:, jsph), &
                            & -params % kappa, c0_d1_grad(:, 2, jsph), one, &
                            & diff_ep_dim3(2, icav), work_complex, work)
                        call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                            & constants % vscales, constants % SK_ri(:, jsph), &
                            & -params % kappa, c0_d1_grad(:, 3, jsph), one, &
                            & diff_ep_dim3(3, icav), work_complex, work)
                    end do
                end do
            end do
        end if
        sum_dim3 = zero
        icav = constants % icav_ia(ksph) - 1
        do igrid =1, params % ngrid
            if(constants % ui(igrid, ksph) .gt. zero) then
                icav = icav + 1
                do ind = 1, constants % nbasis
                    sum_dim3(:,ind,ksph) = sum_dim3(:,ind,ksph) &
                        & - (params % epsp/params % eps) &
                        & *diff_ep_dim3(:,icav)*constants % ui(igrid, ksph) &
                        & *constants % vwgrid(ind, igrid)
                end do
            end if
        end do
        do ind = 1, constants % nbasis
            force(:, ksph) = force(:, ksph) + &
                & sum_dim3(:, ind, ksph)*sol_adj(ind, ksph)
        end do

        ! Now jsph=ksph and isph!=ksph
        if (params % fmm .eq. 0) then
            diff_ep_dim3 = zero
            sum_dim3 = zero
            do isph = 1, params % nsph
              if (isph .eq. ksph) cycle
              icav = constants % icav_ia(isph) - 1
              do igrid = 1, params % ngrid
                  if (constants % ui(igrid, isph) .eq. zero) cycle
                  icav = icav + 1
                  vij  = params % csph(:,isph) + &
                      & params % rsph(isph)*constants % cgrid(:,igrid) - &
                      & params % csph(:,ksph)
                  vtij = vij * params % kappa
                  call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                      & constants % vscales, constants % SK_ri(:, ksph), &
                      & params % kappa, c0_d1_grad(:, 1, ksph), one, &
                      & diff_ep_dim3(1, icav), work_complex, work)
                  call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                      & constants % vscales, constants % SK_ri(:, ksph), &
                      & params % kappa, c0_d1_grad(:, 2, ksph), one, &
                      & diff_ep_dim3(2, icav), work_complex, work)
                  call fmm_m2p_bessel_work(vtij, constants % lmax0+1, &
                      & constants % vscales, constants % SK_ri(:, ksph), &
                      & params % kappa, c0_d1_grad(:, 3, ksph), one, &
                      & diff_ep_dim3(3, icav), work_complex, work)
              end do
            end do

            icav = zero
            do isph = 1, params % nsph
              do igrid =1, params % ngrid
                if(constants % ui(igrid, isph) .gt. zero) then
                  icav = icav + 1
                  do ind = 1, constants % nbasis
                    sum_dim3(:,ind,isph) = sum_dim3(:,ind,isph) &
                      & - (params % epsp/params % eps) &
                      & *diff_ep_dim3(:,icav)*constants % ui(igrid, isph) &
                      & *constants % vwgrid(ind, igrid)
                  end do
                end if
              end do
            end do

            ! Computation of derivative of \bf(k)_j^l0(x_in)\times Y^j_l0m0(x_in)
            do isph = 1, params % nsph
              do ind = 1, constants % nbasis
                force(:, ksph) = force(:, ksph) + sum_dim3(:, ind, isph)*sol_adj(ind, isph)
              end do
            end do
        else
            call dgemv('T', (constants % lmax0+2)**2, 3, -params % epsp/params % eps*params % kappa, &
                & c0_d1_grad(1, 1, ksph), (constants % lmax0+2)**2, &
                & workspace % tmp_sph2(1, ksph), 1, one, force(1, ksph), 1)
        end if
    end do

    deallocate(phi_in, diff_ep_dim3, sum_dim3, c0_d, c0_d1, &
          & c0_d1_grad, sum_Sjin, l2l_grad, diff0, stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, "deallocation ddx_error in ddx_grad_f_worker1")
        return
    end if

end subroutine contract_grad_f_worker1

!! @param[inout] ddx_error: ddX error
subroutine contract_grad_f_worker2(params, constants, &
        & gradpsi, normal_hessian_cav, force, state, ddx_error)
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: gradpsi(3, constants % ncav), &
        & normal_hessian_cav(3, constants % ncav)
    real(dp), intent(inout) :: force(3, params % nsph)
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error

    integer :: icav, isph, igrid, istat
    real(dp) :: nderpsi
    real(dp), allocatable :: gradpsi_grid(:, :)

    allocate(gradpsi_grid(params % ngrid, params % nsph), stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, "allocation ddx_error in ddx_grad_f_worker2")
        return
    end if

    icav = 0
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if(constants % ui(igrid, isph) .gt. zero) then
                icav = icav + 1
                nderpsi = dot_product(gradpsi(:, icav), &
                    & constants % cgrid(:, igrid))
                gradpsi_grid(igrid, isph) = nderpsi
            end if
        end do
    end do

    icav = 0
    do isph = 1, params % nsph
        call contract_grad_U(params, constants, isph, gradpsi_grid, &
            & state % phi_n, force(:, isph))
        do igrid = 1, params % ngrid
          if(constants % ui(igrid, isph) .gt. zero) then
            icav = icav + 1
            force(:, isph) = force(:, isph) &
                & + constants % wgrid(igrid)*constants % ui(igrid, isph) &
                & *state % phi_n(igrid, isph)*normal_hessian_cav(:, icav)
          end if
        end do
    end do

    deallocate(gradpsi_grid, stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, "deallocation ddx_error in ddx_grad_f_worker2")
        return
    end if

end subroutine contract_grad_f_worker2

!> Sphere contribution to the ddPCM matrix gradient using N^2 code
subroutine gradr_sph(params, constants, isph, vplm, vcos, vsin, basloc, &
        & dbsloc, g, ygrid, fx)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    integer, intent(in) :: isph
    real(dp), intent(in) :: g(constants % nbasis, params % nsph), &
        & ygrid(params % ngrid, params % nsph)
    real(dp), intent(inout) :: vplm(constants % nbasis), vcos(params % lmax+1), &
        & vsin(params % lmax+1), basloc(constants % nbasis), &
        & dbsloc(3, constants % nbasis), fx(3)
    ! various scratch arrays
    real(dp) vik(3), sik(3), vki(3), ski(3), vkj(3), skj(3), vji(3), &
        & sji(3), va(3), vb(3), a(3)
    ! jacobian matrix
    real(dp) sjac(3,3)
    ! indexes
    integer its, ik, ksph, l, m, ind, jsph, icomp, jcomp
    ! various scalar quantities
    real(dp) cx, cy, cz, vvki, tki, gg, fl, fac, vvkj, tkj
    real(dp) tt, fcl, fjj, gi, fii, vvji, tji, qji
    real(dp) b, vvik, tik, qik, tlow, thigh, duj
    real(dp) :: rho, ctheta, stheta, cphi, sphi
    real(dp), external :: dnrm2

    tlow  = one - pt5*(one - params % se)*params % eta
    thigh = one + pt5*(one + params % se)*params % eta

    ! first set of contributions:
    ! diagonal block, kc and part of kb

    fx = zero
    do its = 1, params % ngrid
        ! sum over ksph in neighbors of isph
        do ik = constants % inl(isph), constants % inl(isph+1) - 1
            ksph = constants % nl(ik)
            ! build geometrical quantities
            cx = params % csph(1,ksph) + params % rsph(ksph)*constants % cgrid(1,its)
            cy = params % csph(2,ksph) + params % rsph(ksph)*constants % cgrid(2,its)
            cz = params % csph(3,ksph) + params % rsph(ksph)*constants % cgrid(3,its)
            vki(1) = cx - params % csph(1,isph)
            vki(2) = cy - params % csph(2,isph)
            vki(3) = cz - params % csph(3,isph)
            !vvki = sqrt(vki(1)*vki(1) + vki(2)*vki(2) + &
            !    & vki(3)*vki(3))
            vvki = dnrm2(3, vki, 1)
            tki  = vvki/params % rsph(isph)

            ! contributions involving grad i of uk come from the switching
            ! region.
            ! note: ui avoids contributions from points that are in the
            ! switching between isph and ksph but are buried in a third
            ! sphere.
            if ((tki.gt.tlow).and.(tki.lt.thigh) .and. &
                & constants % ui(its,ksph).gt.zero) then
                ! other geometrical quantities
                ski = vki/vvki

                ! diagonal block kk contribution, with k in n(i)
                gg = zero
                do l = 0, params % lmax
                    ind = l*l + l + 1
                    fl = dble(l)
                    fac = twopi/(two*fl + one)
                    do m = -l, l
                        !! DEBUG comment
                        gg = gg + fac*constants % vgrid(ind+m,its)*g(ind+m,ksph)
                    end do
                end do

                ! kc contribution
                do jsph = 1, params % nsph
                    if (jsph.ne.ksph .and. jsph.ne.isph) then 
                        vkj(1) = cx - params % csph(1,jsph)
                        vkj(2) = cy - params % csph(2,jsph)
                        vkj(3) = cz - params % csph(3,jsph)
                        vvkj = sqrt(vkj(1)*vkj(1) + vkj(2)*vkj(2) + &
                            & vkj(3)*vkj(3))
                        vvkj = dnrm2(3, vkj, 1)
                        tkj  = vvkj/params % rsph(jsph)
                        skj  = vkj/vvkj
                        call ylmbas(skj, rho, ctheta, stheta, cphi, sphi, &
                            & params % lmax, constants % vscales, basloc, &
                            & vplm, vcos, vsin)
                        tt = one/tkj
                        do l = 0, params % lmax
                            ind = l*l + l + 1
                            fcl = - fourpi*dble(l)/(two*dble(l)+one)*tt
                            do m = -l, l
                                !! DEBUG comment
                                gg = gg + fcl*g(ind+m,jsph)*basloc(ind+m)
                            end do
                            tt = tt/tkj
                        end do
                        !call fmm_m2p(vkj, params % rsph(jsph), &
                        !    & params % lmax, constants % vscales_rel, -one, &
                        !    & g(:, jsph), one, gg)
                    end if
                end do

                ! part of kb contribution
                call ylmbas(ski, rho, ctheta, stheta, cphi, sphi, &
                    & params % lmax, constants % vscales, basloc, &
                    & vplm, vcos, vsin)
                tt = one/tki
                do l = 0, params % lmax
                    ind = l*l + l + 1
                    fcl = - four*pi*dble(l)/(two*dble(l)+one)*tt
                    do m = -l, l
                        !! DEBUG comment
                        gg = gg + fcl*g(ind+m,isph)*basloc(ind+m)
                    end do
                    tt = tt/tki
                end do
                !call fmm_m2p(vki, params % rsph(isph), &
                !    & params % lmax, constants % vscales_rel, -one, &
                !    & g(:, isph), one, gg)

                ! common step, product with grad i uj
                duj = dfsw(tki,params % se, params % eta)/params % rsph(isph)
                fjj = duj*constants % wgrid(its)*gg*ygrid(its,ksph)
                fx(1) = fx(1) - fjj*ski(1)
                fx(2) = fx(2) - fjj*ski(2)
                fx(3) = fx(3) - fjj*ski(3)
            end if
        end do

        ! diagonal block ii contribution
        if (constants % ui(its,isph).gt.zero.and.constants % ui(its,isph).lt.one) then
            gi = zero
            do l = 0, params % lmax
                ind = l*l + l + 1
                fl = dble(l)
                fac = twopi/(two*fl + one)
                do m = -l, l 
                    !! DEBUG comment
                    gi = gi + fac*constants % vgrid(ind+m,its)*g(ind+m,isph)
                    !gi = gi + pt5*constants % vgrid2(ind+m,its)*g(ind+m,isph)
                end do
            end do
            !do l = 0, (params % lmax+1)**2
            !    gi = gi + constants % vgrid2(l, its)*g(l, isph)
            !end do
            !gi = pt5 * gi
            fii = constants % wgrid(its)*gi*ygrid(its,isph)
            fx(1) = fx(1) + fii*constants % zi(1,its,isph)
            fx(2) = fx(2) + fii*constants % zi(2,its,isph)
            fx(3) = fx(3) + fii*constants % zi(3,its,isph)
        end if
    end do

    ! second set of contributions:
    ! part of kb and ka
    do its = 1, params % ngrid

        ! run over all the spheres except isph 
        do jsph = 1, params % nsph
            if (constants % ui(its,jsph).gt.zero .and. jsph.ne.isph) then
                ! build geometrical quantities
                cx = params % csph(1,jsph) + params % rsph(jsph)*constants % cgrid(1,its)
                cy = params % csph(2,jsph) + params % rsph(jsph)*constants % cgrid(2,its)
                cz = params % csph(3,jsph) + params % rsph(jsph)*constants % cgrid(3,its)
                vji(1) = cx - params % csph(1,isph)
                vji(2) = cy - params % csph(2,isph)
                vji(3) = cz - params % csph(3,isph)
                !vvji = sqrt(vji(1)*vji(1) + vji(2)*vji(2) + &
                !    &  vji(3)*vji(3))
                vvji = dnrm2(3, vji, 1)
                tji = vvji/params % rsph(isph)
                qji = one/vvji
                sji = vji/vvji

                ! build the jacobian of sji
                sjac = zero
                sjac(1,1) = - one
                sjac(2,2) = - one
                sjac(3,3) = - one
                do icomp = 1, 3
                    do jcomp = 1, 3
                        sjac(icomp,jcomp) = qji*(sjac(icomp,jcomp) &
                            & + sji(icomp)*sji(jcomp))
                    end do
                end do

                ! assemble the local basis and its gradient
                !call dbasis(sji,basloc,dbsloc,vplm,vcos,vsin)
                call dbasis(params, constants, sji,basloc,dbsloc,vplm,vcos,vsin)

                ! assemble the contribution
                a = zero
                tt = one/(tji)
                do l = 0, params % lmax
                    ind = l*l + l + 1
                    fl = dble(l)
                    fcl = - tt*fourpi*fl/(two*fl + one)
                    do m = -l, l
                        fac = fcl*g(ind+m,isph)
                        b = (fl + one)*basloc(ind+m)/(params % rsph(isph)*tji)

                        ! apply the jacobian to grad y
                        va(1) = sjac(1,1)*dbsloc(1,ind+m) + &
                            & sjac(1,2)*dbsloc(2,ind+m) + sjac(1,3)*dbsloc(3,ind+m)
                        va(2) = sjac(2,1)*dbsloc(1,ind+m) + &
                            & sjac(2,2)*dbsloc(2,ind+m) + sjac(2,3)*dbsloc(3,ind+m)
                        va(3) = sjac(3,1)*dbsloc(1,ind+m) + &
                            & sjac(3,2)*dbsloc(2,ind+m) + sjac(3,3)*dbsloc(3,ind+m)
                        a(1) = a(1) + fac*(sji(1)*b + va(1))
                        a(2) = a(2) + fac*(sji(2)*b + va(2))
                        a(3) = a(3) + fac*(sji(3)*b + va(3))
                    end do
                    tt = tt/tji
                end do
                fac = constants % ui(its,jsph)*constants % wgrid(its)*ygrid(its,jsph)
                fx(1) = fx(1) - fac*a(1)
                fx(2) = fx(2) - fac*a(2)
                fx(3) = fx(3) - fac*a(3)
            end if
        end do
    end do

    ! ka contribution
    do its = 1, params % ngrid
        cx = params % csph(1,isph) + params % rsph(isph)*constants % cgrid(1,its)
        cy = params % csph(2,isph) + params % rsph(isph)*constants % cgrid(2,its)
        cz = params % csph(3,isph) + params % rsph(isph)*constants % cgrid(3,its)
        a = zero

        ! iterate on all the spheres except isph
        do ksph = 1, params % nsph
            if (constants % ui(its,isph).gt.zero .and. ksph.ne.isph) then
                ! geometrical stuff
                vik(1) = cx - params % csph(1,ksph)
                vik(2) = cy - params % csph(2,ksph)
                vik(3) = cz - params % csph(3,ksph)
                !vvik = sqrt(vik(1)*vik(1) + vik(2)*vik(2) + & 
                !    & vik(3)*vik(3))
                vvik = dnrm2(3, vik, 1)
                tik = vvik/params % rsph(ksph)
                qik = one/vvik
                sik = vik/vvik

                ! build the jacobian of sik
                sjac = zero
                sjac(1,1) = one
                sjac(2,2) = one
                sjac(3,3) = one
                do icomp = 1, 3
                    do jcomp = 1, 3
                    sjac(icomp,jcomp) = qik*(sjac(icomp,jcomp) &
                        & - sik(icomp)*sik(jcomp))
                    end do
                end do

                ! if we are in the switching region, recover grad_i u_i
                vb = zero
                if (constants % ui(its,isph).lt.one) then
                    vb(1) = constants % zi(1,its,isph)
                    vb(2) = constants % zi(2,its,isph)
                    vb(3) = constants % zi(3,its,isph)
                end if

                ! assemble the local basis and its gradient
                !call dbasis(sik,basloc,dbsloc,vplm,vcos,vsin)
                call dbasis(params, constants, sik,basloc,dbsloc,vplm,vcos,vsin)

                ! assemble the contribution
                tt = one/(tik)
                do l = 0, params % lmax
                    ind = l*l + l + 1
                    fl = dble(l)
                    fcl = - tt*fourpi*fl/(two*fl + one)
                        do m = -l, l
                        fac = fcl*g(ind+m,ksph)
                        fac = - fac*basloc(ind+m)
                        a(1) = a(1) + fac*vb(1)
                        a(2) = a(2) + fac*vb(2) 
                        a(3) = a(3) + fac*vb(3)

                        fac = constants % ui(its,isph)*fcl*g(ind+m,ksph)
                        b = - (fl + one)*basloc(ind+m)/(params % rsph(ksph)*tik)

                        ! apply the jacobian to grad y
                        va(1) = sjac(1,1)*dbsloc(1,ind+m) + &
                            & sjac(1,2)*dbsloc(2,ind+m) + sjac(1,3)*dbsloc(3,ind+m)
                        va(2) = sjac(2,1)*dbsloc(1,ind+m) + &
                            & sjac(2,2)*dbsloc(2,ind+m) + sjac(2,3)*dbsloc(3,ind+m)
                        va(3) = sjac(3,1)*dbsloc(1,ind+m) + &
                            & sjac(3,2)*dbsloc(2,ind+m) + sjac(3,3)*dbsloc(3,ind+m)
                        a(1) = a(1) + fac*(sik(1)*b + va(1))
                        a(2) = a(2) + fac*(sik(2)*b + va(2))
                        a(3) = a(3) + fac*(sik(3)*b + va(3))
                    end do
                    tt = tt/tik
                end do
            end if
        end do
        fac = constants % wgrid(its)*ygrid(its,isph)
        fx(1) = fx(1) - fac*a(1)
        fx(2) = fx(2) - fac*a(2)
        fx(3) = fx(3) - fac*a(3)
    end do
end subroutine gradr_sph

!> Compute the ddPCM matrix gradient using FMMS (2 matvecs)
subroutine gradr_fmm(params, constants, workspace, g, ygrid, fx)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: g(constants % nbasis, params % nsph), &
        & ygrid(params % ngrid, params % nsph)
    ! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    ! Output
    real(dp), intent(out) :: fx(3, params % nsph)
    ! Local variables
    integer :: indl, indl1, l, isph, igrid, ik, ksph, &
        & jsph, jsph_node
    integer :: inear, inode, jnode
    real(dp) :: gg, c(3), vki(3), vvki, tki, gg3(3), tmp_gg, tmp_c(3)
    real(dp) :: tlow, thigh
    real(dp), dimension(3, 3) :: zx_coord_transform, zy_coord_transform
    real(dp), external :: ddot, dnrm2
    real(dp) :: work(params % lmax+2)
    !real(dp) :: l2g(params % ngrid, params % nsph)
    zx_coord_transform = 0
    zx_coord_transform(3, 2) = 1
    zx_coord_transform(2, 3) = 1
    zx_coord_transform(1, 1) = 1
    zy_coord_transform = 0
    zy_coord_transform(1, 2) = 1
    zy_coord_transform(2, 1) = 1
    zy_coord_transform(3, 3) = 1
    tlow  = one - pt5*(one - params % se)*params % eta
    thigh = one + pt5*(one + params % se)*params % eta
    fx = zero
    !! Scale input harmonics at first
    workspace % tmp_sph(1, :) = zero
    indl = 2
    do l = 1, params % lmax
        indl1 = (l+1)**2
        workspace % tmp_sph(indl:indl1, :) = l * g(indl:indl1, :)
        indl = indl1 + 1
    end do
    !! Compute gradient of M2M of tmp_sph harmonics at the origin and store it
    !! in tmp_sph_grad. tmp_sph_grad(:, 1, :), tmp_sph_grad(:, 2, :) and
    !! tmp_sph_grad(:, 3, :) correspond to the OX, OY and OZ axes. Variable
    !! tmp_sph2 is a temporary workspace here.
    call tree_grad_m2m(params, constants, workspace % tmp_sph, &
        & workspace % tmp_sph_grad, workspace % tmp_sph2)
    !! Adjoint full FMM matvec to get output multipole expansions from input
    !! external grid points. It is used to compute R_i^B fast as a contraction
    !! of a gradient stored in tmp_sph_grad and a result of adjoint matvec.
    ! Adjoint integration from spherical harmonics to grid points is not needed
    ! here as ygrid already contains grid values, we just need to scale it by
    ! weights of grid points
    do isph = 1, params % nsph
        workspace % tmp_grid(:, isph) = ygrid(:, isph) * &
            & constants % wgrid(:) * constants % ui(:, isph)
    end do
    ! Adjoint FMM with output tmp_sph2(:, :) which stores coefficients of
    ! harmonics of degree up to lmax+1
    call tree_m2p_adj(params, constants, params % lmax+1, one, &
        & workspace % tmp_grid, zero, workspace % tmp_sph2)
    call tree_l2p_adj(params, constants, one, workspace % tmp_grid, zero, &
        & workspace % tmp_node_l, workspace % tmp_sph_l)
    call tree_l2l_rotation_adj(params, constants, workspace % tmp_node_l)
    call tree_m2l_rotation_adj(params, constants, workspace % tmp_node_l, &
        & workspace % tmp_node_m)
    call tree_m2m_rotation_adj(params, constants, workspace % tmp_node_m)
    ! Properly load adjoint multipole harmonics into tmp_sph2 that holds
    ! harmonics of a degree up to lmax+1
    if(params % lmax+1 .lt. params % pm) then
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            workspace % tmp_sph2(:, isph) = workspace % tmp_sph2(:, isph) + &
                & workspace % tmp_node_m(1:constants % grad_nbasis, inode)
        end do
    else
        indl = (params % pm+1)**2
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            workspace % tmp_sph2(1:indl, isph) = &
                & workspace % tmp_sph2(1:indl, isph) + &
                & workspace % tmp_node_m(:, inode)
        end do
    end if
    ! Compute second term of R_i^B as a contraction
    do isph = 1, params % nsph
        call dgemv('T', constants % grad_nbasis, 3, one, &
            & workspace % tmp_sph_grad(1, 1, isph), constants % grad_nbasis, &
            & workspace % tmp_sph2(1, isph), 1, zero, fx(1, isph), 1)
    end do
    !! Direct far-field FMM matvec to get output local expansions from input
    !! multipole expansions. It will be used in R_i^A.
    !! As of now I compute potential at all external grid points, improved
    !! version shall only compute it at external points in a switch region
    ! Load input harmonics into tree data
    if(params % lmax .lt. params % pm) then
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            workspace % tmp_node_m(:constants % nbasis, inode) = &
                & workspace % tmp_sph(:, isph)
            workspace % tmp_node_m(constants % nbasis+1:, inode) = zero
        end do
    else
        indl = (params % pm+1)**2
        do isph = 1, params % nsph
            inode = constants % snode(isph)
            workspace % tmp_node_m(:, inode) = workspace % tmp_sph(1:indl, isph)
        end do
    end if
    ! Perform direct FMM matvec to all external grid points
    call tree_m2m_rotation(params, constants, workspace % tmp_node_m)
    call tree_m2l_rotation(params, constants, workspace % tmp_node_m, &
        & workspace % tmp_node_l)
    call tree_l2l_rotation(params, constants, workspace % tmp_node_l)
    call tree_l2p(params, constants, one, workspace % tmp_node_l, zero, &
        & workspace % tmp_grid, workspace % tmp_sph_l)
    call tree_m2p(params, constants, params % lmax, one, &
        & workspace % tmp_sph, one, workspace % tmp_grid)
    !! Compute gradients of L2L if pl > 0
    if (params % pl .gt. 0) then
        call tree_grad_l2l(params, constants, workspace % tmp_node_l, &
            & workspace % tmp_sph_l_grad, workspace % tmp_sph_l)
    end if
    !! Diagonal update of computed grid values, that is needed for R^C, a part
    !! of R^A and a part of R^B
    call dgemm('T', 'N', params % ngrid, params % nsph, constants % nbasis, &
        & pt5, constants % vgrid2, constants % vgrid_nbasis, g, &
        & constants % nbasis, -one, workspace % tmp_grid, params % ngrid)
    !! Scale temporary grid points by corresponding Lebedev weights and ygrid
    do igrid = 1, params % ngrid
        do isph = 1, params % nsph
            workspace % tmp_grid(igrid, isph) = &
                & workspace % tmp_grid(igrid, isph) *  constants % wgrid(igrid) * &
                & ygrid(igrid, isph)
        end do
    end do
    !! Compute all terms of grad_i(R). The second term of R_i^B is already
    !! taken into account and the first term is computed together with R_i^C.
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            ! Loop over all neighbouring spheres
            do ik = constants % inl(isph), constants % inl(isph+1) - 1
                ksph = constants % nl(ik)
                ! Only consider external grid points
                if(constants % ui(igrid, ksph) .eq. zero) cycle
                ! build geometrical quantities
                c = params % csph(:, ksph) + &
                    & params % rsph(ksph)*constants % cgrid(:, igrid)
                vki = c - params % csph(:, isph)
                !vvki = sqrt(vki(1)*vki(1) + vki(2)*vki(2) + &
                !    & vki(3)*vki(3))
                vvki = dnrm2(3, vki, 1)
                tki = vvki / params % rsph(isph)
                ! Only consider such points where grad U is non-zero
                if((tki.le.tlow) .or. (tki.ge.thigh)) cycle
                ! This is entire R^C and the first R^B component (grad_i of U
                ! of a sum of R_kj for index inequality j!=k)
                ! Indexes k and j are flipped compared to the paper
                gg = workspace % tmp_grid(igrid, ksph)
                ! Compute grad_i component of forces using precomputed
                ! potential gg
                !fx(:, isph) = fx(:, isph) - &
                !    & dfsw(tki, params % se, params % eta)/ &
                !    & params % rsph(isph)*constants % wgrid(igrid)*gg* &
                !    & ygrid(igrid, ksph)*(vki/vvki)
                fx(:, isph) = fx(:, isph) - &
                    & dfsw(tki, params % se, params % eta)/ &
                    & params % rsph(isph)*gg*(vki/vvki)
            end do
            ! contribution from the sphere itself
            if((constants % ui(igrid,isph).gt.zero) .and. &
                & (constants % ui(igrid,isph).lt.one)) then
                ! R^A component (grad_i of U of a sum of R_ij for index
                ! inequality j!=i)
                ! Indexes k and j are flipped compared to the paper
                gg = workspace % tmp_grid(igrid, isph)
                ! Compute grad_i component of forces using precomputed
                ! potential gg
                !fx(:, isph) = fx(:, isph) + constants % wgrid(igrid)*gg* &
                !    & ygrid(igrid, isph)*constants % zi(:, igrid, isph)
                fx(:, isph) = fx(:, isph) + gg*constants % zi(:, igrid, isph)
            end if
            if (constants % ui(igrid, isph) .gt. zero) then
                ! Another R^A component (grad_i of potential of a sum of R_ij
                ! for index inequality j!=i)
                ! Indexes k and j are flipped compared to the paper
                ! In case pl=0 MKL does not make gg3 zero reusing old value of
                ! gg3, so we have to clear it manually
                gg3 = zero
                call dgemv('T', params % pl**2, 3, one, &
                    & workspace % tmp_sph_l_grad(1, 1, isph), &
                    & (params % pl+1)**2, constants % vgrid2(1, igrid), 1, &
                    & zero, gg3, 1)
                ! Gradient of the near-field potential is a gradient of
                ! multipole expansion
                inode = constants % snode(isph)
                do inear = constants % snear(inode), constants % snear(inode+1)-1
                    jnode = constants % near(inear)
                    do jsph_node = constants % cluster(1, jnode), &
                        & constants % cluster(2, jnode)
                        jsph = constants % order(jsph_node)
                        if (isph .eq. jsph) cycle
                        c = params % csph(:, isph) + &
                            & params % rsph(isph)*constants % cgrid(:, igrid)
                        tmp_c = c - params % csph(:, jsph)
                        call fmm_m2p_work(tmp_c, &
                            & params % rsph(jsph), params % lmax+1, &
                            & constants % vscales_rel, one, &
                            & workspace % tmp_sph_grad(:, 1, jsph), zero, &
                            & tmp_gg, work)
                        gg3(1) = gg3(1) + tmp_gg
                        call fmm_m2p_work(tmp_c, &
                            & params % rsph(jsph), params % lmax+1, &
                            & constants % vscales_rel, one, &
                            & workspace % tmp_sph_grad(:, 2, jsph), zero, &
                            & tmp_gg, work)
                        gg3(2) = gg3(2) + tmp_gg
                        call fmm_m2p_work(tmp_c, &
                            & params % rsph(jsph), params % lmax+1, &
                            & constants % vscales_rel, one, &
                            & workspace % tmp_sph_grad(:, 3, jsph), zero, &
                            & tmp_gg, work)
                        gg3(3) = gg3(3) + tmp_gg
                    end do
                end do
                ! Accumulate all computed forces
                fx(:, isph) = fx(:, isph) - constants % wgrid(igrid)*gg3* &
                    & ygrid(igrid, isph)*constants % ui(igrid, isph)
            end if
        end do
    end do
end subroutine gradr_fmm

!> Gradient of the ddPCM matrix
subroutine gradr(params, constants, workspace, g, ygrid, fx)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: g(constants % nbasis, params % nsph), &
        & ygrid(params % ngrid, params % nsph)
    ! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    ! Output
    real(dp), intent(out) :: fx(3, params % nsph)
    ! Check which gradr to execute
    if (params % fmm .eq. 1) then
        call gradr_fmm(params, constants, workspace, g, ygrid, fx)
    else
        call gradr_dense(params, constants, workspace, g, ygrid, fx)
    end if
end subroutine gradr

!> Gradient of the ddPCM matrix using N^2 code
subroutine gradr_dense(params, constants, workspace, g, ygrid, fx)
    implicit none
    ! Inputs
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    real(dp), intent(in) :: g(constants % nbasis, params % nsph), &
        & ygrid(params % ngrid, params % nsph)
    ! Temporaries
    type(ddx_workspace_type), intent(inout) :: workspace
    ! Output
    real(dp), intent(out) :: fx(3, params % nsph)
    ! Local variables
    integer :: isph
    ! Simply cycle over all spheres
    do isph = 1, params % nsph
        call gradr_sph(params, constants, isph, workspace % tmp_vplm, &
            & workspace % tmp_vcos, workspace % tmp_vsin, &
            & workspace % tmp_vylm, workspace % tmp_vdylm, &
            & g, ygrid, fx(:, isph))
    end do
end subroutine gradr_dense

!> Force term: interaction of the external electric field with the zeta
!! intermediate. This routine is called by the gradients of ddCOSMO
!! ddPCM and ddLPB.
subroutine zeta_grad(params, constants, state, e_cav, forces)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(inout) :: forces(3, params % nsph)
    real(dp), intent(in) :: e_cav(3, constants % ncav)
    ! local variables
    integer :: icav, isph, igrid

    icav = 0
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if (constants % ui(igrid, isph) .eq. zero) cycle
            icav = icav + 1
            forces(:, isph) = forces(:, isph) + pt5 &
                & *state % zeta(icav)*e_cav(:, icav)
        end do
    end do
end subroutine zeta_grad

!> Force term: interaction of the external electric field with the zeta
!! intermediate. This routine is called by the gradients of ddCOSMO
!! ddPCM and ddLPB.
subroutine zeta_grad_dr(params, constants, state, e_cav, dr)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(inout) :: dr(params % nsph)
    real(dp), intent(in) :: e_cav(3, constants % ncav)
    ! local variables
    integer :: icav, isph, igrid

    icav = 0
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if (constants % ui(igrid, isph) .eq. zero) cycle
            icav = icav + 1
            dr(isph) = dr(isph) + pt5 &
                & * dot_product(constants % cgrid(:,igrid), e_cav(:, icav))*state % zeta(icav)
        end do
    end do
end subroutine zeta_grad_dr

end module ddx_gradients

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file src/dd_core.f90
!! Core routines and parameters of entire ddX software
!!
!! @version 1.0.0
!! @author Abhinav Jha and Michele Nottoli
!! @date 2021-02-25

!> High-level subroutines for ddlpb
module ddx_lpb
! Get ddx-operators
use ddx_operators
implicit none

!> @defgroup Fortran_interface_ddlpb Fortran interface: ddlpb

contains

!> Given the potential and the electric field at the cavity points,
!> assemble the RHS for ddLPB
!!
!> @ingroup Fortran_interface_ddlpb
!! @param[in] params: ddx parameters
!! @param[in] constants: ddx constants
!! @param[inout] workspace: ddx workspace
!! @param[inout] state: ddx state
!! @param[in] phi_cav: electrostatic potential at the cavity points
!! @param[in] e_cav: electrostatic field at the cavity points
!! @param[in] psi: representation of the solute density
!! @param[inout] ddx_error: ddX error
!!
subroutine lpb_setup(params, constants, workspace, state, phi_cav, &
        & e_cav, psi, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(in) :: phi_cav(constants % ncav)
    real(dp), intent(in) :: e_cav(3, constants % ncav)
    real(dp), intent(in) :: psi(constants % nbasis, params % nsph)

    state % psi = psi
    state % rhs_adj_lpb(:, :, 1) = psi
    ! in ddLPB the polarization density X is expanded according to a
    ! slightly different definition which lacks the 4pi/(2l + 1) factors
    ! which are present in ddCOSMO and ddPCM. This affect the adjoint
    ! density as well. To have a consistent adjoint density with ddCOSMO
    ! and ddPCM, we have to scale the RHS.
    call convert_ddcosmo(params, constants, -1, state % rhs_adj_lpb(:,:,1))
    state % rhs_adj_lpb(:, :, 2) = 0.0d0

    !! Setting initial values to zero
    state % g_lpb = zero
    state % f_lpb = zero
    state % phi_grid = zero

    ! Unwrap sparsely stored potential at cavity points phi_cav into phi_grid
    ! and multiply it by characteristic function at cavity points ui
    call ddcav_to_grid_work(params % ngrid, params % nsph, &
        & constants % ncav, constants % icav_ia, &
        & constants % icav_ja, phi_cav, state % phi_grid)
    workspace % tmp_cav = phi_cav * constants % ui_cav
    call ddcav_to_grid_work(params % ngrid, params % nsph, &
        & constants % ncav, constants % icav_ia, &
        & constants % icav_ja, workspace % tmp_cav, &
        & workspace % tmp_grid)
    state % g_lpb = - workspace % tmp_grid

    ! store the gradient of the potential (- electric field)
    state % gradphi_cav = - e_cav

    ! wghpot_f : Intermediate computation of F_0 Eq.(75) from QSM19.SISC
    call wghpot_f(params, constants, workspace, state % gradphi_cav, &
        & state % f_lpb, ddx_error)

    ! Setting of the local variables
    state % rhs_lpb = zero

    ! integrate RHS
    call ddintegrate(params % nsph, constants % nbasis, &
        & params % ngrid, constants % vwgrid, &
        & constants % vgrid_nbasis, state % g_lpb, state % rhs_lpb(:,:,1))
    call ddintegrate(params % nsph, constants % nbasis, &
        & params % ngrid, constants % vwgrid, &
        & constants % vgrid_nbasis, state % f_lpb, state % rhs_lpb(:,:,2))
    state % rhs_lpb(:,:,1) = state % rhs_lpb(:,:,1) + state % rhs_lpb(:,:,2)

    if (ddx_error % flag .eq. 0) then
        state % rhs_done = .true.
        state % adjoint_rhs_done = .true.
    end if

end subroutine lpb_setup

!> Compute the ddLPB energy
!!
!> @ingroup Fortran_interface_ddlpb
!! @param[in] constants: Precomputed constants
!! @param[in] state: ddx state (contains solutions and RHSs)
!! @param[out] esolv: resulting energy
!! @param[inout] ddx_error: ddX error
!!
subroutine lpb_energy(constants, state, esolv, ddx_error)
    implicit none
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_state_type), intent(in) :: state
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp), intent(out) :: esolv
    real(dp), external :: ddot

    ! dummy operation on unused interface arguments
    if (ddx_error % flag .eq. 0) continue

    esolv = pt5*ddot(constants % n, state % x_lpb(:,:,1), 1, state % psi, 1)
end subroutine lpb_energy

!> Do a guess for the primal ddLPB linear system
!!
!> @ingroup Fortran_interface_ddlpb
!! @param[in] params: User specified parameters
!! @param[inout] constants: Precomputed constants
!! @param[inout] workspace: Preallocated workspaces
!! @param[inout] state: ddx state (contains solutions and RHSs)
!! @param[in] tol: tolerance
!! @param[inout] ddx_error: ddX error
!!
subroutine lpb_guess(params, constants, workspace, state, tol, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: tol
    type(ddx_error_type), intent(inout) :: ddx_error

    ! set the inner tolerance
    constants % inner_tol =  sqrt(tol)

    ! guess
    workspace % ddcosmo_guess = zero
    workspace % hsp_guess = zero
    call prec_tx(params, constants, workspace, state % rhs_lpb, &
        & state % x_lpb, ddx_error)

end subroutine lpb_guess

!> Do a guess for the adjoint ddLPB linear system
!!
!> @ingroup Fortran_interface_ddlpb
!! @param[in] params: User specified parameters
!! @param[in] constants: Precomputed constants
!! @param[inout] workspace: Preallocated workspaces
!! @param[inout] state: ddx state (contains solutions and RHSs)
!! @param[in] tol: tolerance
!! @param[inout] ddx_error: ddX error
!!
subroutine lpb_guess_adjoint(params, constants, workspace, state, tol, &
        & ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: tol
    type(ddx_error_type), intent(inout) :: ddx_error

    ! set the inner tolerance
    constants % inner_tol =  sqrt(tol)

    ! guess
    workspace % ddcosmo_adj_guess = zero
    workspace % hsp_adj_guess = zero
    call prec_tstarx(params, constants, workspace, state % rhs_adj_lpb, &
        & state % x_adj_lpb, ddx_error)

end subroutine lpb_guess_adjoint

!> Solve the ddLPB primal linear system
!!
!> @ingroup Fortran_interface_ddlpb
!! @param[in] params       : General options
!! @param[in] constants    : Precomputed constants
!! @param[inout] workspace : Preallocated workspaces
!! @param[inout] state     : Solutions, guesses and relevant quantities
!! @param[in] tol          : Tolerance for the iterative solvers
!!
!! @param[inout] ddx_error: ddX error
subroutine lpb_solve(params, constants, workspace, state, tol, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: tol
    type(ddx_error_type), intent(inout) :: ddx_error
    real(dp) :: start_time

    state % x_lpb_niter = params % maxiter
    workspace % xs_time = zero
    workspace % hsp_time = zero

    ! solve LS using Jacobi/DIIS
    start_time = omp_get_wtime()
    call jacobi_diis_external(params, constants, workspace, &
        & 2*constants % n, tol, state % rhs_lpb, state % x_lpb, &
        & state % x_lpb_niter, state % x_lpb_rel_diff, cx, prec_tx, rmsnorm, &
        & ddx_error)
    if (ddx_error % flag.ne. 0) then
        call update_error(ddx_error, 'Jacobi solver failed to converge " // &
            & "in ddlpb_solve')
        return
    end if
    state % x_lpb_time = omp_get_wtime() - start_time
    ! in ddLPB the polarization density X is expanded according to a
    ! slightly different definition which lacks the 4pi/(2l + 1) factors
    ! which are present in ddCOSMO and ddPCM. Before exiting, we scale
    ! the density so that it is consistent with the ddCOSMO and ddPCM
    ! ones.
    call convert_ddcosmo(params, constants, -1, state % x_lpb(:,:,1))

    ! put the timings in the right places
    state % xs_time = workspace % xs_time
    state % hsp_time = workspace % hsp_time
end subroutine lpb_solve

!> Solve the adjoint ddLPB linear system
!!
!> @ingroup Fortran_interface_ddlpb
!! @param[in] params       : General options
!! @param[in] constants    : Precomputed constants
!! @param[inout] workspace : Preallocated workspaces
!! @param[inout] state     : Solutions, guesses and relevant quantities
!! @param[in] tol          : Tolerance for the iterative solvers
!! @param[inout] ddx_error: ddX error
!!
subroutine lpb_solve_adjoint(params, constants, workspace, state, tol, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(inout) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: tol
    type(ddx_error_type), intent(inout) :: ddx_error

    real(dp) :: start_time

    state % x_adj_lpb_niter = params % maxiter
    workspace % s_time = zero
    workspace % hsp_adj_time = zero

    ! solve adjoint LS using Jacobi/DIIS
    start_time = omp_get_wtime()
    call jacobi_diis_external(params, constants, workspace, &
        & 2*constants % n, tol, state % rhs_adj_lpb, state % x_adj_lpb, &
        & state % x_adj_lpb_niter, state % x_adj_lpb_rel_diff, &
        & cstarx, prec_tstarx, rmsnorm, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, 'Jacobi solver failed to ' // &
            & 'converge in ddlpb_solve_adjoint')
        return
    end if
    state % x_adj_lpb_time = omp_get_wtime() - start_time

    state % q = state % x_adj_lpb(:, :, 1)

    ! put the timings in the right places
    state % s_time = workspace % s_time
    state % hsp_adj_time = workspace % hsp_adj_time

    call lpb_derivative_setup(params, constants, workspace, state, ddx_error)

end subroutine lpb_solve_adjoint

!> Compute the solvation terms of the forces (solute aspecific). This
!! must be summed to the solute specific term to get the full forces.
!!
!> @ingroup Fortran_interface_ddlpb
!! @param[in] params         : General options
!! @param[in] constants      : Precomputed constants
!! @param[inout] workspace   : Preallocated workspaces
!! @param[inout] state       : Solutions and relevant quantities
!! @param[in] hessianphi_cav : Electric field gradient at the grid points
!! @param[out] force         : Geometrical contribution to the forces
!! @param[inout] ddx_error: ddX error
!!
subroutine lpb_solvation_force_terms(params, constants, workspace, &
        & state, hessianphi_cav, force, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    real(dp), intent(in) :: hessianphi_cav(3, 3, constants % ncav)
    real(dp), intent(out) :: force(3, params % nsph)
    type(ddx_error_type), intent(inout) :: ddx_error

    ! local
    real(dp), dimension(constants % nbasis) :: basloc, vplm
    real(dp), dimension(3, constants % nbasis) :: dbasloc
    real(dp), dimension(params % lmax + 1) :: vsin, vcos

    ! large local are allocatable
    real(dp), allocatable :: normal_hessian_cav(:,:), &
        & diff_re(:,:), scaled_xr(:,:)
    integer :: isph, icav, igrid, istat
    integer :: i
    real(dp), external :: ddot, dnrm2
    real(dp) :: start_time, finish_time

    start_time = omp_get_wtime()
    allocate(normal_hessian_cav(3, constants % ncav), &
        & diff_re(constants % nbasis, params % nsph), &
        & scaled_xr(constants % nbasis, params % nsph), stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, 'Allocation failed in ddlpb_force_worker')
        return
    end if

    ! we have to insert again the factor that we removed in ddlpb_solve
    call convert_ddcosmo(params, constants, 1, state % x_lpb(:, :, 1))

    diff_re = zero
    vsin = zero
    vcos = zero
    vplm = zero
    basloc = zero
    dbasloc = zero
    force = zero

    ! Compute the derivative of the normal derivative of psi_0
    normal_hessian_cav = zero
    icav = 0
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if(constants % ui(igrid, isph) .gt. zero) then
                icav = icav + 1
                do i = 1, 3
                    normal_hessian_cav(:, icav) = normal_hessian_cav(:,icav) +&
                        & hessianphi_cav(:,i,icav)*constants % cgrid(i,igrid)
                end do
            end if
        end do
    end do

    ! Scale by the factor of 1/(4Pi/(2l+1))
    scaled_Xr = state % x_lpb(:,:,1)
    call convert_ddcosmo(params, constants, -1, scaled_Xr)

    !$omp parallel do default(none) shared(params,constants,workspace, &
    !$omp scaled_xr,state,force) private(isph,basloc,dbasloc,vplm,vcos,vsin) &
    !$omp schedule(static,1)
    do isph = 1, params % nsph
        ! Compute A^k*Xadj_r, using Subroutine from ddCOSMO
        call contract_grad_L(params, constants, isph, scaled_Xr, &
            & state % x_adj_r_grid, basloc, dbasloc, vplm, vcos, vsin, &
            & force(:,isph))
        ! Compute B^k*Xadj_e
        call contract_grad_B(params, constants, isph, state % x_lpb(:,:,2), &
            & state % x_adj_e_grid, force(:, isph))
        ! Computation of G0
        call contract_grad_U(params, constants, isph, state % x_adj_r_grid, &
            & state % phi_grid, force(:, isph))
    end do
    ! Compute C1 and C2 contributions
    diff_re = zero
    call contract_grad_C(params, constants, workspace, state % x_lpb(:,:,1), &
        & state % x_lpb(:,:,2), state % x_adj_r_grid, state % x_adj_e_grid, &
        & state % x_adj_lpb(:,:,1), state % x_adj_lpb(:,:,2), force, &
        & diff_re, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "contract_grad_C returned an error, exiting")
        return
    end if
    ! Computation of G0 continued

    ! NOTE: contract_grad_U returns a positive summation
    force = -force
    icav = 0
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if(constants % ui(igrid, isph) .ne. zero) then
                icav = icav + 1
                state % zeta(icav) = constants % wgrid(igrid) * &
                    & constants % ui(igrid, isph) * ddot(constants % nbasis, &
                    & constants % vgrid(1, igrid), 1, &
                    & state % x_adj_lpb(1, isph, 1), 1)
            end if
        end do
    end do

    ! Computation of F0
    call contract_grad_f(params, constants, workspace, &
        & state % x_adj_lpb(:,:,1) + state % x_adj_lpb(:,:,2), &
        & state % x_adj_re_grid, state % gradphi_cav, &
        & normal_hessian_cav, force, state, ddx_error)
    if (ddx_error % flag .ne. 0) then
        call update_error(ddx_error, &
            & "contract_grad_f returned an error, exiting")
        return
    end if

    force = pt5*force

    deallocate(normal_hessian_cav, diff_re, scaled_xr, stat=istat)
    if (istat.ne.0) then
        call update_error(ddx_error, 'Deallocation failed in ddlpb_force_worker')
        return
    end if

    ! and now we remove again the factor, so that the density is
    ! restored.
    call convert_ddcosmo(params, constants, -1, state % x_lpb(:, :, 1))

    ! Finally add the zeta - electric field contribution. Since the
    ! subroutine takes as input the electric field, we temporarily swap
    ! the sign of the gradient of the potential (this trick avoids
    ! dangerous memory allocation)
    state % gradphi_cav = - state % gradphi_cav
    call zeta_grad(params, constants, state, state % gradphi_cav, force)
    state % gradphi_cav = - state % gradphi_cav

    finish_time = omp_get_wtime()
    state % force_time = finish_time - start_time

end subroutine lpb_solvation_force_terms

!> This routines precomputes two intermediates for its later usage in
!! the computation of analytical derivatives (forces or other).
!!
!! @param[in] params: ddx parameters
!! @param[in] constant: ddx constants
!! @param[inout] workspace: ddx workspaces
!! @param[inout] state: ddx state
!! @param[inout] ddx_error: ddX error
!!
subroutine lpb_derivative_setup(params, constants, workspace, state, ddx_error)
    implicit none
    type(ddx_params_type), intent(in) :: params
    type(ddx_constants_type), intent(in) :: constants
    type(ddx_workspace_type), intent(inout) :: workspace
    type(ddx_state_type), intent(inout) :: state
    type(ddx_error_type), intent(inout) :: ddx_error

    real(dp), allocatable :: coefy_d(:, :, :)
    integer :: istat, jsph, igrid0, icav, isph, igrid, l0, m0, ind0, &
        & inode, indl
    real(dp) :: rijn, sum_int, fac
    real(dp) :: work(constants % lmax0 + 1), coef(constants % nbasis0), &
        & vij(3), vtij(3), sij(3)
    complex(dp) :: work_complex(constants % lmax0 + 1)

    ! expand the adjoint solutions at the Lebedev points and compute
    ! their sum
    call dgemm('T', 'N', params % ngrid, params % nsph, &
        & constants % nbasis, one, constants % vgrid, &
        & constants % vgrid_nbasis, state % x_adj_lpb(:, :, 1), &
        & constants % nbasis, zero, state % x_adj_r_grid, params % ngrid)
    call dgemm('T', 'N', params % ngrid, params % nsph, &
        & constants % nbasis, one, constants % vgrid, &
        & constants % vgrid_nbasis, state % x_adj_lpb(:, :, 2), &
        & constants % nbasis, zero, state % x_adj_e_grid, params % ngrid)
    state % x_adj_re_grid = state % x_adj_r_grid + state % x_adj_e_grid

    if (params % fmm .eq. 0) then
        allocate(coefy_d(constants % ncav, params % ngrid, params % nsph), &
            & stat=istat)
        if (istat.ne.0) then
            call update_error(ddx_error, "allocation ddx_error in " // &
                & "ddlpb_derivative_setup")
            return
        end if
        coefy_d = zero
        do jsph = 1, params % nsph
            do igrid0 = 1, params % ngrid
                icav = zero
                do isph = 1, params % nsph
                    do igrid = 1, params % ngrid
                        if(constants % ui(igrid, isph) .gt. zero) then
                            icav = icav + 1
                            vij = params % csph(:,isph) + params % rsph(isph) &
                                & *constants % cgrid(:,igrid) &
                                & - params % csph(:,jsph)
                            rijn = sqrt(dot_product(vij,vij))
                            if (rijn.ne.zero) then
                                sij = vij/rijn
                            else
                                sij = one
                            end if
                            do l0 = 0, constants % lmax0
                                do m0 = -l0, l0
                                    ind0 = l0**2 + l0 + m0 + 1
                                    coef(ind0) = &
                                        & constants % vgrid(ind0, igrid0) * &
                                        & constants % C_ik(l0, jsph)
                                end do
                            end do
                            vtij = vij*params % kappa
                            call fmm_m2p_bessel_work(vtij, constants % lmax0, &
                                & constants % vscales, &
                                & constants % sk_ri(:, jsph), one, &
                                & coef, zero, coefy_d(icav, igrid0, jsph), &
                                & work_complex, work)
                        end if
                    end do
                end do
            end do
        end do
        do jsph = 1, params % nsph
            do igrid0 = 1, params % ngrid
                icav = zero
                sum_int = zero
                do isph = 1, params % nsph
                    do igrid = 1, params % ngrid
                        if(constants % ui(igrid, isph) .gt. zero) then
                            icav = icav + 1
                            sum_int = sum_int + coefy_d(icav, igrid0, jsph) &
                                & *state % x_adj_re_grid(igrid, isph) &
                                & *constants % wgrid(igrid) &
                                & *constants % ui(igrid, isph)
                        end if
                    end do
                end do
                state % phi_n(igrid0, jsph) = &
                    & - (params % epsp/params % eps)*sum_int
            end do
        end do
    else
        ! Adjoint integration from spherical harmonics to grid points is not needed
        ! here as ygrid already contains grid values, we just need to scale it by
        ! weights of grid points
        do isph = 1, params % nsph
            workspace % tmp_grid(:, isph) = state % x_adj_re_grid(:, isph) * &
                & constants % wgrid(:) * constants % ui(:, isph)
        end do
        ! Adjoint FMM
        call tree_m2p_bessel_adj(params, constants, constants % lmax0, one, &
            & workspace % tmp_grid, zero, params % lmax, workspace % tmp_sph)
        call tree_l2p_bessel_adj(params, constants, one, &
            & workspace % tmp_grid, zero, workspace % tmp_node_l)
        call tree_l2l_bessel_rotation_adj(params, constants, &
            & workspace % tmp_node_l)
        call tree_m2l_bessel_rotation_adj(params, constants, &
            & workspace % tmp_node_l, workspace % tmp_node_m)
        call tree_m2m_bessel_rotation_adj(params, constants, &
            & workspace % tmp_node_m)
        ! Properly load adjoint multipole harmonics into tmp_sph
        if(constants % lmax0 .lt. params % pm) then
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_sph(1:constants % nbasis0, isph) = &
                    & workspace % tmp_sph(1:constants % nbasis0, isph) + &
                    & workspace % tmp_node_m(1:constants % nbasis0, inode)
            end do
        else
            indl = (params % pm+1)**2
            do isph = 1, params % nsph
                inode = constants % snode(isph)
                workspace % tmp_sph(1:indl, isph) = &
                    & workspace % tmp_sph(1:indl, isph) + &
                    & workspace % tmp_node_m(:, inode)
            end do
        end if
        ! Scale by C_ik
        do isph = 1, params % nsph
            do l0 = 0, constants % lmax0
                ind0 = l0*l0 + l0 + 1
                workspace % tmp_sph(ind0-l0:ind0+l0, isph) = &
                    & workspace % tmp_sph(ind0-l0:ind0+l0, isph) * &
                    & constants % C_ik(l0, isph)
            end do
        end do
        ! Multiply by vgrid
        call dgemm('T', 'N', params % ngrid, params % nsph, &
            & constants % nbasis0, -params % epsp/params % eps, &
            & constants % vgrid, constants % vgrid_nbasis, &
            & workspace % tmp_sph, constants % nbasis, zero, &
            & state % phi_n, params % ngrid)
    end if

    ! assemble the pseudo-dipoles
    icav = 0
    do isph = 1, params % nsph
        do igrid = 1, params % ngrid
            if (constants % ui(igrid, isph) .gt. zero) then
                icav = icav + 1
                fac = - constants % ui(igrid, isph)*constants % wgrid(igrid) &
                    & *state % phi_n(igrid, isph)
                state % zeta_dip(1, icav) = fac*constants % cgrid(1, igrid)
                state % zeta_dip(2, icav) = fac*constants % cgrid(2, igrid)
                state % zeta_dip(3, icav) = fac*constants % cgrid(3, igrid)
            end if
        end do
    end do

    if (allocated(coefy_d)) then
        deallocate(coefy_d, stat=istat)
        if (istat.ne.0) then
            call update_error(ddx_error, &
                & "deallocation ddx_error in ddlpb_derivative_setup")
            return
        end if
    end if

end subroutine lpb_derivative_setup

end module ddx_lpb

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_io_read_vasp
   use mctc_env_accuracy, only : wp
   use mctc_env_error, only : error_type, fatal_error
   use mctc_io_convert, only : aatoau
   use mctc_io_resize, only : resize
   use mctc_io_structure, only : structure_type, new
   use mctc_io_structure_info, only : structure_info
   use mctc_io_symbols, only : to_number, symbol_length
   use mctc_io_utils, only : next_line, token_type, next_token, io_error, filename, &
      read_next_token, to_string
   implicit none
   private

   public :: read_vasp



contains


subroutine read_vasp(self, unit, error)

   !> Instance of the molecular structure data
   type(structure_type), intent(out) :: self

   !> File handle
   integer, intent(in) :: unit

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   logical :: selective, cartesian
   integer :: i, j, k, nn, ntype, natoms, izp, stat, pos, lnum
   integer, allocatable :: ncount(:)
   real(wp) :: ddum, latvec(3), scalar, coord(3), lattice(3, 3)
   real(wp), allocatable :: xyz(:, :)
   type(token_type) :: token
   character(len=:), allocatable :: line, comment
   character(len=2*symbol_length), allocatable :: args(:), args2(:)
   character(len=symbol_length), allocatable :: sym(:)
   type(structure_info) :: info

   selective = .false. ! Selective dynamics
   cartesian = .true.  ! Cartesian or direct
   lattice = 0
   stat = 0
   lnum = 0

   ntype = 0
   ! first line contains the symbols of different atom types
   call next_line(unit, line, pos, lnum, stat)
   if (stat /= 0) then
      call fatal_error(error, "Unexpected end of input encountered")
      return
   end if

   call parse_line(" " // line, args, ntype)
   call move_alloc(line, comment)

   ! this line contains the global scaling factor,
   call next_line(unit, line, pos, lnum, stat)
   if (stat /= 0) then
      call fatal_error(error, "Unexpected end of input encountered")
      return
   end if
   call read_next_token(line, pos, token, ddum, stat)
   if (stat /= 0) then
      call io_error(error, "Cannot read scaling factor", &
         & line, token, filename(unit), lnum, "expected real value")
      return
   end if
   ! the Ang->au conversion is included in the scaling factor
   scalar = ddum*aatoau

   ! reading the lattice constants
   do i = 1, 3
      call next_line(unit, line, pos, lnum, stat)
      if (stat /= 0) then
         call fatal_error(error, "Unexpected end of lattice vectors encountered")
         return
      end if
      call read_next_token(line, pos, token, latvec(1), stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, latvec(2), stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, latvec(3), stat)
      if (stat /= 0) then
         call io_error(error, "Cannot read lattice vectors from input", &
            & line, token, filename(unit), lnum, "expected real value")
         return
      end if
      lattice(:, i) = latvec * scalar
   end do
   ! Either here are the numbers of each element,
   ! or (>vasp.5.1) here are the element symbols
   call next_line(unit, line, pos, lnum, stat)
   if (stat /= 0) then
      call fatal_error(error, "Unexpected end of input encountered")
      return
   end if

   ! try to verify that first element is actually a number
   i = max(verify(line, ' '), 1)
   j = scan(line(i:), ' ') - 2 + i
   if (j < i) j = len_trim(line)

   ! CONTCAR files have additional Element line here since vasp.5.1
   if (verify(line(i:j), '1234567890') /= 0) then
      call parse_line(" " // line, args, ntype)
      call next_line(unit, line, pos, lnum, stat)
      if (stat /= 0) then
         call fatal_error(error, "Unexpected end of input encountered")
         return
      end if
   else
      deallocate(comment)
   end if
   call parse_line(" " // line, args2, nn)
   if (nn /= ntype) then
      call fatal_error(error, 'Number of atom types mismatches the number of counts')
      return
   end if

   allocate(ncount(nn), source = 0)
   do i = 1, nn
      read(args2(i), *, iostat=stat) ncount(i)
      izp = to_number(args(i))
      if (izp < 1 .or. ncount(i) < 1) then
         call fatal_error(error, "Unknown element '"//trim(args(i))//"' encountered")
         return
      end if
   end do

   natoms = sum(ncount)
   allocate(sym(natoms))
   allocate(xyz(3, natoms))

   k = 0
   do i = 1, nn
      do j = 1, ncount(i)
         k = k+1
         sym(k) = trim(args(i))
      end do
   end do

   call next_line(unit, line, pos, lnum, stat)
   if (stat /= 0) then
      call fatal_error(error, "Could not read POSCAR")
      return
   end if
   line = adjustl(line)
   if (line(:1).eq.'s' .or. line(:1).eq.'S') then
      selective = .true.
      call next_line(unit, line, pos, lnum, stat)
      if (stat /= 0) then
         call fatal_error(error, "Unexpected end of input encountered")
         return
      end if
      line = adjustl(line)
   end if

   cartesian = (line(:1).eq.'c' .or. line(:1).eq.'C' .or. &
      &         line(:1).eq.'k' .or. line(:1).eq.'K')
   do i = 1, natoms
      call next_line(unit, line, pos, lnum, stat)
      if (stat /= 0) then
         call fatal_error(error, "Unexpected end of geometry encountered")
         return
      end if
      call read_next_token(line, pos, token, coord(1), stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, coord(2), stat)
      if (stat == 0) &
         call read_next_token(line, pos, token, coord(3), stat)
      if (stat /= 0) then
         call io_error(error, "Cannot read geometry from input", &
            & line, token, filename(unit), lnum, "expected real value")
         return
      end if

      if (cartesian) then
         xyz(:, i) = coord*scalar
      else
         xyz(:, i) = matmul(lattice, coord)
      end if

   end do

   ! save information about this POSCAR for later
   info = structure_info(scale=ddum, selective=selective, cartesian=cartesian)
   call new(self, sym, xyz, lattice=lattice, info=info)
   if (allocated(comment)) self%comment = comment

end subroutine read_vasp


subroutine parse_line(line, args, nargs)
   character(len=*), intent(in) :: line
   character(len=2*symbol_length), allocatable, intent(out) :: args(:)
   integer, intent(out) :: nargs
   integer, parameter :: p_initial_size = 50
   integer :: istart, iend
   allocate(args(p_initial_size), source=repeat(' ', 2*symbol_length))
   istart = 1
   iend = 1
   nargs = 0
   do while(iend < len_trim(line))
      istart = verify(line(iend:), ' ') - 1 + iend
      iend = scan(line(istart:), ' ') - 1 + istart
      if (iend < istart) iend = len_trim(line)
      if (nargs >= size(args)) then
         call resize(args)
      end if
      nargs = nargs + 1
      args(nargs) = trim(line(istart:iend))
   end do
end subroutine parse_line


end module mctc_io_read_vasp

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mctc_env_timer
   use mctc_env_accuracy, only : wp, i8
   implicit none
   private

   public :: timer_type, format_time

   type :: time_record
      character(len=:), allocatable :: label
      logical :: running = .false.
      real(wp) :: time = 0.0_wp
   end type time_record

   type :: timer_type
      integer :: n = 0
      character(len=:), allocatable :: last
      type(time_record), allocatable :: record(:)
   contains
      procedure :: push
      procedure :: pop
      procedure :: get
   end type timer_type

contains

subroutine push(self, label)
   class(timer_type), intent(inout) :: self
   character(len=*), intent(in) :: label

   integer :: it

   if (.not.allocated(self%record)) call resize(self%record)
   it = find(self%record(:self%n), label)

   if (it == 0) then
      if (self%n >= size(self%record)) then
         call resize(self%record)
      end if

      self%n = self%n + 1
      it = self%n
      self%record(it) = time_record(label)
   end if

   associate(record => self%record(it))
      self%last = record%label
      record%time = record%time + timing() * merge(+1, -1, record%running)
      record%running = .not.record%running
   end associate
end subroutine push


subroutine pop(self)
   class(timer_type), intent(inout) :: self

   integer :: it

   if (.not.allocated(self%record)) return
   it = find(self%record(:self%n), self%last)
   if (it == 0) return

   associate(record => self%record(it))
      record%time = record%time + timing() * merge(+1, -1, record%running)
      record%running = .not.record%running
   end associate
   if (allocated(self%last)) deallocate(self%last)
end subroutine pop


function get(self, label) result(time)
   class(timer_type), intent(in) :: self
   character(len=*), intent(in) :: label
   real(wp) :: time

   integer :: it

   time = 0.0_wp
   if (self%n <= 0) return
   it = find(self%record(:self%n), label)
   if (it == 0) return

   associate(record => self%record(it))
      time = record%time
      if (record%running) then
         time = time + timing()
      end if
   end associate
end function get


pure function find(record, label) result(pos)
   type(time_record), intent(in) :: record(:)
   character(len=*), intent(in), optional :: label
   integer :: pos

   integer :: i

   pos = 0
   if (present(label)) then
      do i = size(record), 1, -1
         if (allocated(record(i)%label)) then
            if (label == record(i)%label) then
               pos = i
               exit
            end if
         end if
      end do
   else
      do i = size(record), 1, -1
         if (record(i)%running) then
            pos = i
            exit
         end if
      end do
   end if
end function find


function format_time(time) result(string)
   real(wp), intent(in) :: time
   character(len=:), allocatable :: string

   real(wp) :: secs
   integer :: mins, hours, days

   secs = time
   days = int(secs/86400.0_wp)
   secs = secs - days*86400.0_wp
   hours = int(secs/3600.0_wp)
   secs = secs - hours*3600.0_wp
   mins = int(secs/60.0_wp)
   secs = time - mins*60.0_wp

   if (days > 0) then
      string = format_string_int(days, '(i0, " d,")')
   else
      string = repeat(" ", 4)
   end if
   if (hours > 0) then
      string = string // format_string_int(hours, '(1x, i2, " h,")')
   else
      string = string // repeat(" ", 6)
   end if
   if (mins > 0) then
      string = string // format_string_int(mins, '(1x, i2, " min,")')
   else
      string = string // repeat(" ", 8)
   end if
   string = string // format_string_real_dp(secs, '(f6.3)')//" sec"
end function format_time


function timing() result(time)
   real(wp) :: time

   integer(i8) :: time_count, time_rate, time_max
   call system_clock(time_count, time_rate, time_max)
   time = real(time_count, wp)/real(time_rate, wp)
end function timing


!> Reallocate list of timing records
pure subroutine resize(var, n)
   !> Instance of the array to be resized
   type(time_record), allocatable, intent(inout) :: var(:)
   !> Dimension of the final array size
   integer, intent(in), optional :: n

   type(time_record), allocatable :: tmp(:)
   integer :: this_size, new_size
   integer, parameter :: initial_size = 20

   if (allocated(var)) then
      this_size = size(var, 1)
      call move_alloc(var, tmp)
   else
      this_size = initial_size
   end if

   if (present(n)) then
      new_size = n
   else
      new_size = this_size + this_size/2 + 1
   end if

   allocate(var(new_size))

   if (allocated(tmp)) then
      this_size = min(size(tmp, 1), size(var, 1))
      var(:this_size) = tmp(:this_size)
      deallocate(tmp)
   end if

end subroutine resize

pure function format_string_int(val, format) result(str)
   integer, intent(in) :: val
   character(len=*), intent(in) :: format
   character(len=:), allocatable :: str

   character(len=128) :: buffer
   integer :: stat

   write(buffer, format, iostat=stat) val
   if (stat == 0) then
      str = trim(buffer)
   else
      str = "*"
   end if
end function format_string_int

pure function format_string_real_dp(val, format) result(str)
   real(wp), intent(in) :: val
   character(len=*), intent(in) :: format
   character(len=:), allocatable :: str

   character(len=128) :: buffer
   integer :: stat

   write(buffer, format, iostat=stat) val
   if (stat == 0) then
      str = trim(buffer)
   else
      str = "*"
   end if
end function format_string_real_dp

end module mctc_env_timer

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3_damping_rational
   use dftd3_cutoff, only : smooth_cutoff
   use dftd3_damping, only : damping_param
   use dftd3_damping_atm, only : get_atm_dispersion, get_atm_pairwise_dispersion
   use dftd3_param, only : d3_param
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   implicit none

   public :: rational_damping_param, new_rational_damping


   !> Rational (Becke-Johnson) damping model
   type, extends(damping_param) :: rational_damping_param
      real(wp) :: s6
      real(wp) :: s8
      real(wp) :: s9
      real(wp) :: a1
      real(wp) :: a2
      real(wp) :: alp
   contains

      !> Evaluate pairwise dispersion energy expression
      procedure :: get_dispersion2_impl => get_dispersion2

      !> Evaluate ATM three-body dispersion energy expression
      procedure :: get_dispersion3_impl => get_dispersion3

      !> Evaluate pairwise representation of additive dispersion energy
      procedure :: get_pairwise_dispersion2_impl => get_pairwise_dispersion2

      !> Evaluate pairwise representation of non-additive dispersion energy
      procedure :: get_pairwise_dispersion3_impl => get_pairwise_dispersion3

   end type rational_damping_param


   real(wp), parameter :: rs9 = 4.0_wp/3.0_wp


contains


!> Create new rational damping model
subroutine new_rational_damping(self, param)

   !> Rational damping parameters
   type(rational_damping_param), intent(out) :: self

   !> Parameters
   type(d3_param), intent(in) :: param

   self%s6 = param%s6
   self%s8 = param%s8
   self%s9 = param%s9
   self%a1 = param%a1
   self%a2 = param%a2
   self%alp = param%alp

end subroutine new_rational_damping


!> Evaluation of the dispersion energy expression
subroutine get_dispersion2(self, mol, trans, cutoff, width, rvdw, r4r2, c6, dc6dcn, &
      & energy, dEdcn, gradient, sigma)

   !> Damping parameters
   class(rational_damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Width of smooth cutoff
   real(wp), intent(in) :: width

   !> Van-der-Waals radii for damping function
   real(wp), intent(in) :: rvdw(:, :)

   !> Expectation values for C8 extrapolation
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Derivative of the C6 w.r.t. the coordination number
   real(wp), intent(in), optional :: dc6dcn(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:)

   !> Derivative of the energy w.r.t. the coordination number
   real(wp), intent(inout), optional :: dEdcn(:)

   !> Dispersion gradient
   real(wp), intent(inout), optional :: gradient(:, :)

   !> Dispersion virial
   real(wp), intent(inout), optional :: sigma(:, :)

   logical :: grad

   if (abs(self%s6) < epsilon(1.0_wp) .and. abs(self%s8) < epsilon(1.0_wp)) return
   grad = present(dc6dcn) .and. present(dEdcn) .and. present(gradient) &
      & .and. present(sigma)

   if (grad) then
      call get_dispersion_derivs(self, mol, trans, cutoff, width, rvdw, r4r2, c6, dc6dcn, &
         & energy, dEdcn, gradient, sigma)
   else
      call get_dispersion_energy(self, mol, trans, cutoff, width, rvdw, r4r2, c6, energy)
   end if

end subroutine get_dispersion2


!> Evaluation of the dispersion energy expression
subroutine get_dispersion_energy(self, mol, trans, cutoff, width, rvdw, r4r2, c6, energy)

   !> Damping parameters
   class(rational_damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Width of smooth cutoff
   real(wp), intent(in) :: width

   !> Van-der-Waals radii for damping function
   real(wp), intent(in) :: rvdw(:, :)

   !> Expectation values for C8 extrapolation
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:)

   integer :: iat, jat, izp, jzp, jtr
   real(wp) :: vec(3), r2, r1, cutoff2, r0ij, rrij, c6ij, t6, t8, edisp, dE
   real(wp) :: sw, dswdr
   real(wp) :: r0ij2, r0ij6, r0ij8, r4

   ! Thread-private array for reduction
   ! Set to 0 explicitly as the shared variants are potentially non-zero (inout)
   real(wp), allocatable :: energy_local(:)

   cutoff2 = cutoff*cutoff

   !$omp parallel default(none) &
   !$omp shared(mol, self, c6, trans, cutoff2, cutoff, width, r4r2) &
   !$omp private(iat, jat, izp, jzp, jtr, vec, r2, r1, r0ij, rrij, c6ij, t6, &
   !$omp& t8, edisp, dE, r0ij2, r0ij6, r0ij8, r4, sw, dswdr) &
   !$omp shared(energy) &
   !$omp private(energy_local)
   allocate(energy_local(size(energy, 1)), source=0.0_wp)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)
         rrij = 3*r4r2(izp)*r4r2(jzp)
         r0ij = self%a1 * sqrt(rrij) + self%a2
         c6ij = c6(jat, iat)
         r0ij2 = r0ij * r0ij
         r0ij6 = r0ij2 * r0ij2 * r0ij2
         r0ij8 = r0ij6 * r0ij2
         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, jtr))
            r2 = vec(1)*vec(1) + vec(2)*vec(2) + vec(3)*vec(3)
            if (r2 > cutoff2 .or. r2 < epsilon(1.0_wp)) cycle
            r1 = sqrt(r2)
            call smooth_cutoff(r1, cutoff, width, sw, dswdr)

            r4 = r2 * r2
            t6 = 1.0_wp/(r4 * r2 + r0ij6)
            t8 = 1.0_wp/(r4 * r4 + r0ij8)

            edisp = sw * (self%s6*t6 + self%s8*rrij*t8)

            dE = -c6ij*edisp * 0.5_wp

            energy_local(iat) = energy_local(iat) + dE
            if (iat /= jat) then
               energy_local(jat) = energy_local(jat) + dE
            end if
         end do
      end do
   end do
   !$omp end do
   !$omp critical (get_dispersion_energy_)
   energy(:) = energy(:) + energy_local(:)
   !$omp end critical (get_dispersion_energy_)
   deallocate(energy_local)
   !$omp end parallel

end subroutine get_dispersion_energy


!> Evaluation of the dispersion energy expression
subroutine get_dispersion_derivs(self, mol, trans, cutoff, width, rvdw, r4r2, c6, dc6dcn, &
      & energy, dEdcn, gradient, sigma)

   !> Damping parameters
   class(rational_damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Width of smooth cutoff
   real(wp), intent(in) :: width

   !> Van-der-Waals radii for damping function
   real(wp), intent(in) :: rvdw(:, :)

   !> Expectation values for C8 extrapolation
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Derivative of the C6 w.r.t. the coordination number
   real(wp), intent(in) :: dc6dcn(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:)

   !> Derivative of the energy w.r.t. the coordination number
   real(wp), intent(inout) :: dEdcn(:)

   !> Dispersion gradient
   real(wp), intent(inout) :: gradient(:, :)

   !> Dispersion virial
   real(wp), intent(inout) :: sigma(:, :)

   integer :: iat, jat, izp, jzp, jtr, ic, jc
   real(wp) :: vec(3), r2, r1, cutoff2, r0ij, rrij, c6ij, t6, t8, d6, d8
   real(wp) :: edisp0, gdisp0, edisp, gdisp, sw, dswdr
   real(wp) :: dE, dG(3), dS(3, 3)
   real(wp) :: r0ij2, r0ij6, r0ij8, r4

   ! Thread-private arrays for reduction
   ! Set to 0 explicitly as the shared variants are potentially non-zero (inout)
   real(wp), allocatable :: energy_local(:)
   real(wp), allocatable :: dEdcn_local(:)
   real(wp), allocatable :: gradient_local(:, :)
   real(wp), allocatable :: sigma_local(:, :)

   cutoff2 = cutoff*cutoff

   !$omp parallel default(none) &
   !$omp shared(mol, self, c6, dc6dcn, trans, cutoff2, cutoff, width, r4r2) &
   !$omp private(iat, jat, izp, jzp, jtr, ic, jc, vec, r2, r1, r0ij, rrij, c6ij, &
   !$omp& t6, t8, d6, d8, edisp0, gdisp0, edisp, gdisp, dE, dG, dS, &
   !$omp& r0ij2, r0ij6, r0ij8, r4, sw, dswdr) &
   !$omp shared(energy, gradient, sigma, dEdcn) &
   !$omp private(energy_local, gradient_local, sigma_local, dEdcn_local)
   allocate(energy_local(size(energy, 1)), source=0.0_wp)
   allocate(dEdcn_local(size(dEdcn, 1)), source=0.0_wp)
   allocate(gradient_local(size(gradient, 1), size(gradient, 2)), source=0.0_wp)
   allocate(sigma_local(size(sigma, 1), size(sigma, 2)), source=0.0_wp)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)
         rrij = 3*r4r2(izp)*r4r2(jzp)
         r0ij = self%a1 * sqrt(rrij) + self%a2
         c6ij = c6(jat, iat)
         r0ij2 = r0ij * r0ij
         r0ij6 = r0ij2 * r0ij2 * r0ij2
         r0ij8 = r0ij6 * r0ij2
         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, jtr))
            r2 = vec(1)*vec(1) + vec(2)*vec(2) + vec(3)*vec(3)
            if (r2 > cutoff2 .or. r2 < epsilon(1.0_wp)) cycle
            r1 = sqrt(r2)
            call smooth_cutoff(r1, cutoff, width, sw, dswdr)

            r4 = r2 * r2
            t6 = 1.0_wp/(r4 * r2 + r0ij6)
            t8 = 1.0_wp/(r4 * r4 + r0ij8)

            d6 = -6*r4*t6*t6
            d8 = -8*r4*r2*t8*t8

            edisp0 = self%s6*t6 + self%s8*rrij*t8
            gdisp0 = self%s6*d6 + self%s8*rrij*d8
            edisp = sw * edisp0
            gdisp = sw * gdisp0 + dswdr * edisp0 / r1

            dE = -c6ij*edisp * 0.5_wp
            dG(:) = -c6ij*gdisp*vec
            do ic = 1, 3
               do jc = 1, 3
                  dS(ic, jc) = dG(ic) * vec(jc) * 0.5_wp
               end do
            end do

            energy_local(iat) = energy_local(iat) + dE
            dEdcn_local(iat) = dEdcn_local(iat) - dc6dcn(iat, jat) * edisp
            sigma_local(:, :) = sigma_local + dS
            if (iat /= jat) then
               energy_local(jat) = energy_local(jat) + dE
               dEdcn_local(jat) = dEdcn_local(jat) - dc6dcn(jat, iat) * edisp
               gradient_local(:, iat) = gradient_local(:, iat) + dG
               gradient_local(:, jat) = gradient_local(:, jat) - dG
               sigma_local(:, :) = sigma_local + dS
            end if
         end do
      end do
   end do
   !$omp end do
   !$omp critical (get_dispersion_derivs_)
   energy(:) = energy(:) + energy_local(:)
   dEdcn(:) = dEdcn(:) + dEdcn_local(:)
   gradient(:, :) = gradient(:, :) + gradient_local(:, :)
   sigma(:, :) = sigma(:, :) + sigma_local(:, :)
   !$omp end critical (get_dispersion_derivs_)
   deallocate(energy_local)
   deallocate(dEdcn_local)
   deallocate(gradient_local)
   deallocate(sigma_local)
   !$omp end parallel

end subroutine get_dispersion_derivs


!> Evaluation of the dispersion energy expression
subroutine get_dispersion3(self, mol, trans, cutoff, width, rvdw, r4r2, c6, dc6dcn, &
      & energy, dEdcn, gradient, sigma)

   !> Damping parameters
   class(rational_damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Width of smooth cutoff
   real(wp), intent(in) :: width

   !> Van-der-Waals radii for damping function
   real(wp), intent(in) :: rvdw(:, :)

   !> Expectation values for C8 extrapolation
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Derivative of the C6 w.r.t. the coordination number
   real(wp), intent(in), optional :: dc6dcn(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:)

   !> Derivative of the energy w.r.t. the coordination number
   real(wp), intent(inout), optional :: dEdcn(:)

   !> Dispersion gradient
   real(wp), intent(inout), optional :: gradient(:, :)

   !> Dispersion virial
   real(wp), intent(inout), optional :: sigma(:, :)

   call get_atm_dispersion(mol, trans, cutoff, width, self%s9, rs9, self%alp+2, &
      & rvdw, c6, dc6dcn, energy, dEdcn, gradient, sigma)

end subroutine get_dispersion3


!> Evaluation of the dispersion energy expression projected on atomic pairs
subroutine get_pairwise_dispersion2(self, mol, trans, cutoff, width, rvdw, r4r2, c6, energy)

   !> Damping parameters
   class(rational_damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Width of smooth cutoff
   real(wp), intent(in) :: width

   !> Van-der-Waals radii for damping function
   real(wp), intent(in) :: rvdw(:, :)

   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:, :)

   integer :: iat, jat, izp, jzp, jtr
   real(wp) :: vec(3), r2, r1, cutoff2, r0ij, rrij, c6ij, t6, t8, edisp, dE
   real(wp) :: sw, dswdr

   ! Thread-private array for reduction
   ! Set to 0 explicitly as the shared variants are potentially non-zero (inout)
   real(wp), allocatable :: energy_local(:, :)

   cutoff2 = cutoff*cutoff

   !$omp parallel default(none) &
   !$omp shared(mol, self, c6, trans, cutoff2, cutoff, width, r4r2) &
   !$omp private(iat, jat, izp, jzp, jtr, vec, r2, r1, r0ij, rrij, c6ij, t6, &
   !$omp& t8, edisp, dE, sw, dswdr) &
   !$omp shared(energy) &
   !$omp private(energy_local)
   allocate(energy_local(size(energy, 1), size(energy, 2)), source=0.0_wp)
   !$omp do schedule(runtime)
   do iat = 1, mol%nat
      izp = mol%id(iat)
      do jat = 1, iat
         jzp = mol%id(jat)
         rrij = 3*r4r2(izp)*r4r2(jzp)
         r0ij = self%a1 * sqrt(rrij) + self%a2
         c6ij = c6(jat, iat)
         do jtr = 1, size(trans, 2)
            vec(:) = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, jtr))
            r2 = vec(1)*vec(1) + vec(2)*vec(2) + vec(3)*vec(3)
            if (r2 > cutoff2 .or. r2 < epsilon(1.0_wp)) cycle
            r1 = sqrt(r2)
            call smooth_cutoff(r1, cutoff, width, sw, dswdr)

            t6 = 1.0_wp/(r2**3 + r0ij**6)
            t8 = 1.0_wp/(r2**4 + r0ij**8)

            edisp = sw * (self%s6*t6 + self%s8*rrij*t8)

            dE = -c6ij*edisp * 0.5_wp

            energy_local(jat, iat) = energy_local(jat, iat) + dE
            if (iat /= jat) then
               energy_local(iat, jat) = energy_local(iat, jat) + dE
            end if
         end do
      end do
   end do
   !$omp end do
   !$omp critical (get_pairwise_dispersion2_)
   energy(:, :) = energy(:, :) + energy_local(:, :)
   !$omp end critical (get_pairwise_dispersion2_)
   deallocate(energy_local)
   !$omp end parallel

end subroutine get_pairwise_dispersion2


!> Evaluation of the dispersion energy expression
subroutine get_pairwise_dispersion3(self, mol, trans, cutoff, width, rvdw, r4r2, c6, energy)

   !> Damping parameters
   class(rational_damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Width of smooth cutoff
   real(wp), intent(in) :: width

   !> Van-der-Waals radii for damping function
   real(wp), intent(in) :: rvdw(:, :)

   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:, :)

   call get_atm_pairwise_dispersion(mol, trans, cutoff, width, self%s9, rs9, self%alp+2, &
      & rvdw, c6, energy)

end subroutine get_pairwise_dispersion3


end module dftd3_damping_rational

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module tftest_ser
   use testdrive
   use tomlf_constants, only : tfi, tfr
   use tomlf_de, only : toml_parse, toml_loads
   use tomlf_ser, only : toml_dumps
   use tomlf_type, only : toml_table, toml_array, new_table, add_table, add_array
   use tomlf_build, only : set_value
   use tomlf_datetime, only : toml_datetime, toml_date, toml_time
   use tomlf_error, only : toml_error
   implicit none
   private

   public :: collect_ser


contains


!> Collect all exported unit tests
subroutine collect_ser(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("ser-simple-string", ser_simple_string), &
      & new_unittest("ser-integer", ser_integer), &
      & new_unittest("ser-float", ser_float), &
      & new_unittest("ser-boolean", ser_boolean), &
      & new_unittest("ser-array", ser_array), &
      & new_unittest("ser-table", ser_table), &
      & new_unittest("ser-roundtrip-simple", ser_roundtrip_simple)]

end subroutine collect_ser


!> Test serialization of simple string key-value pair
subroutine ser_simple_string(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   character(:), allocatable :: output
   type(toml_error), allocatable :: toml_err

   call new_table(table)
   call set_value(table, "key", "value")

   call toml_dumps(table, output, error=toml_err)
   if (allocated(toml_err)) then
      call test_failed(error, toml_err%message)
      return
   end if

   call check(error, len_trim(output) > 0, "Output should not be empty")
   if (allocated(error)) return

   call check(error, index(output, "key") > 0, "Output should contain 'key'")
end subroutine ser_simple_string


!> Test serialization of integer values
subroutine ser_integer(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   character(:), allocatable :: output
   type(toml_error), allocatable :: toml_err

   call new_table(table)
   call set_value(table, "int1", 42_tfi)
   call set_value(table, "int2", -123_tfi)
   call set_value(table, "int3", 0_tfi)

   call toml_dumps(table, output, error=toml_err)
   if (allocated(toml_err)) then
      call test_failed(error, toml_err%message)
      return
   end if

   call check(error, index(output, "42") > 0, "Output should contain '42'")
   if (allocated(error)) return

   call check(error, index(output, "-123") > 0, "Output should contain '-123'")
end subroutine ser_integer


!> Test serialization of float values
subroutine ser_float(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   character(:), allocatable :: output
   type(toml_error), allocatable :: toml_err

   call new_table(table)
   call set_value(table, "pi", 3.14159_tfr)
   call set_value(table, "negative", -2.5_tfr)
   call set_value(table, "zero", 0.0_tfr)

   call toml_dumps(table, output, error=toml_err)
   if (allocated(toml_err)) then
      call test_failed(error, toml_err%message)
      return
   end if

   call check(error, index(output, "3.14") > 0, "Output should contain float value")
end subroutine ser_float


!> Test serialization of boolean values
subroutine ser_boolean(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   character(:), allocatable :: output
   type(toml_error), allocatable :: toml_err

   call new_table(table)
   call set_value(table, "bool_true", .true.)
   call set_value(table, "bool_false", .false.)

   call toml_dumps(table, output, error=toml_err)
   if (allocated(toml_err)) then
      call test_failed(error, toml_err%message)
      return
   end if

   call check(error, index(output, "true") > 0, "Output should contain 'true'")
   if (allocated(error)) return

   call check(error, index(output, "false") > 0, "Output should contain 'false'")
end subroutine ser_boolean


!> Test serialization of simple array
subroutine ser_array(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(toml_array), pointer :: array
   character(:), allocatable :: output
   type(toml_error), allocatable :: toml_err

   call new_table(table)
   call add_array(table, "numbers", array)
   call set_value(array, 1, 1_tfi)
   call set_value(array, 2, 2_tfi)
   call set_value(array, 3, 3_tfi)

   call toml_dumps(table, output, error=toml_err)
   if (allocated(toml_err)) then
      call test_failed(error, toml_err%message)
      return
   end if

   call check(error, index(output, "[") > 0, "Output should contain array bracket")
end subroutine ser_array


!> Test serialization of simple table
subroutine ser_table(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table) :: table
   type(toml_table), pointer :: subtable
   character(:), allocatable :: output
   type(toml_error), allocatable :: toml_err

   call new_table(table)
   call add_table(table, "section", subtable)
   call set_value(subtable, "key", "value")

   call toml_dumps(table, output, error=toml_err)
   if (allocated(toml_err)) then
      call test_failed(error, toml_err%message)
      return
   end if

   call check(error, index(output, "[section]") > 0, "Output should contain table header")
end subroutine ser_table


!> Test round-trip serialization (parse -> serialize -> parse)
subroutine ser_roundtrip_simple(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(toml_table), allocatable :: table1, table2
   character(:), allocatable :: output
   type(toml_error), allocatable :: toml_err
   character(*), parameter :: input = 'key = "value"'//new_line('a')//'number = 42'

   ! Parse input
   call toml_loads(table1, input, error=toml_err)
   if (allocated(toml_err)) then
      call test_failed(error, "Parse failed: "//toml_err%message)
      return
   end if

   ! Serialize
   call toml_dumps(table1, output, error=toml_err)
   if (allocated(toml_err)) then
      call test_failed(error, "Serialize failed: "//toml_err%message)
      return
   end if

   ! Parse again
   call toml_loads(table2, output, error=toml_err)
   if (allocated(toml_err)) then
      call test_failed(error, "Re-parse failed: "//toml_err%message)
      return
   end if

   call check(error, allocated(table2), "Round-trip should produce valid table")
end subroutine ser_roundtrip_simple


end module tftest_ser

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/io/data/type.f90
!> Defines a common interface for structured array storage backends.

!> Abstract data handler API used by restart and post-processing output.
module tblite_io_data_type
   use mctc_env, only: dp, i4, error_type
   implicit none
   private

   !> Abstract interface for file-backed named array storage.
   !>
   !> Concrete implementations provide the same load, save, shape, and listing
   !> operations for different container formats such as NPZ and HDF5.
   type, abstract, public :: iodata_type
   contains
      !> List logical dataset names available in the file.
      procedure(list), deferred :: list
      !> Query the rank and extent of a named dataset.
      procedure(get_shape), deferred :: get_shape
      !> Load a named dataset.
      generic :: load => load_i4_r1, load_rdp_r1, load_rdp_r2, load_rdp_r3
      !> Load a named integer rank-1 dataset.
      procedure(load_i4_r1), deferred :: load_i4_r1
      !> Load a named real rank-1 dataset.
      procedure(load_rdp_r1), deferred :: load_rdp_r1
      !> Load a named real rank-2 dataset.
      procedure(load_rdp_r2), deferred :: load_rdp_r2
      !> Load a named real rank-3 dataset.
      procedure(load_rdp_r3), deferred :: load_rdp_r3
      !> Save a named dataset.
      generic :: save => save_i4_r1, save_rdp_r1, save_rdp_r2, save_rdp_r3
      !> Save a named integer rank-1 dataset.
      procedure(save_i4_r1), deferred :: save_i4_r1
      !> Save a named real rank-1 dataset.
      procedure(save_rdp_r1), deferred :: save_rdp_r1
      !> Save a named real rank-2 dataset.
      procedure(save_rdp_r2), deferred :: save_rdp_r2
      !> Save a named real rank-3 dataset.
      procedure(save_rdp_r3), deferred :: save_rdp_r3
   end type iodata_type

   !> Description of a dataset stored in an iodata container.
   type, public :: iodata_record
      !> Logical dataset name, without container-specific suffixes.
      character(len=:), allocatable :: name
   end type iodata_record

   abstract interface
      !> List logical datasets in a storage backend.
      subroutine list(self, datasets, error)
         import :: iodata_type, iodata_record, error_type
         !> Storage backend instance
         class(iodata_type), intent(in) :: self
         !> Dataset records found in the file
         type(iodata_record), allocatable, intent(out) :: datasets(:)
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine list

      !> Get the shape of a named dataset.
      subroutine get_shape(self, dataset, shape, error)
         import :: iodata_type, error_type
         !> Storage backend instance
         class(iodata_type), intent(in) :: self
         !> Logical dataset name
         character(len=*), intent(in) :: dataset
         !> Dataset shape
         integer, allocatable, intent(out) :: shape(:)
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine get_shape

      !> Load an integer rank-1 dataset.
      subroutine load_i4_r1(self, dataset, data, error)
         import :: iodata_type, error_type, i4
         !> Storage backend instance
         class(iodata_type), intent(in) :: self
         !> Logical dataset name
         character(len=*), intent(in) :: dataset
         !> Data loaded from the dataset
         integer(i4), allocatable, intent(out) :: data(:)
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine load_i4_r1

      !> Load a real rank-1 dataset.
      subroutine load_rdp_r1(self, dataset, data, error)
         import :: iodata_type, error_type, dp
         !> Storage backend instance
         class(iodata_type), intent(in) :: self
         !> Logical dataset name
         character(len=*), intent(in) :: dataset
         !> Data loaded from the dataset
         real(dp), allocatable, intent(out) :: data(:)
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine load_rdp_r1

      !> Load a real rank-2 dataset.
      subroutine load_rdp_r2(self, dataset, data, error)
         import :: iodata_type, error_type, dp
         !> Storage backend instance
         class(iodata_type), intent(in) :: self
         !> Logical dataset name
         character(len=*), intent(in) :: dataset
         !> Data loaded from the dataset
         real(dp), allocatable, intent(out) :: data(:,:)
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine load_rdp_r2

      !> Load a real rank-3 dataset.
      subroutine load_rdp_r3(self, dataset, data, error)
         import :: iodata_type, error_type, dp
         !> Storage backend instance
         class(iodata_type), intent(in) :: self
         !> Logical dataset name
         character(len=*), intent(in) :: dataset
         !> Data loaded from the dataset
         real(dp), allocatable, intent(out) :: data(:,:,:)
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine load_rdp_r3

      !> Save an integer rank-1 dataset.
      subroutine save_i4_r1(self, dataset, data, error)
         import :: iodata_type, error_type, i4
         !> Storage backend instance
         class(iodata_type), intent(in) :: self
         !> Logical dataset name
         character(len=*), intent(in) :: dataset
         !> Data to save
         integer(i4), allocatable, intent(in) :: data(:)
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine save_i4_r1

      !> Save a real rank-1 dataset.
      subroutine save_rdp_r1(self, dataset, data, error)
         import :: iodata_type, error_type, dp
         !> Storage backend instance
         class(iodata_type), intent(in) :: self
         !> Logical dataset name
         character(len=*), intent(in) :: dataset
         !> Data to save
         real(dp), allocatable, intent(in) :: data(:)
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine save_rdp_r1

      !> Save a real rank-2 dataset.
      subroutine save_rdp_r2(self, dataset, data, error)
         import :: iodata_type, error_type, dp
         !> Storage backend instance
         class(iodata_type), intent(in) :: self
         !> Logical dataset name
         character(len=*), intent(in) :: dataset
         !> Data to save
         real(dp), allocatable, intent(in) :: data(:,:)
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine save_rdp_r2

      !> Save a real rank-3 dataset.
      subroutine save_rdp_r3(self, dataset, data, error)
         import :: iodata_type, error_type, dp
         !> Storage backend instance
         class(iodata_type), intent(in) :: self
         !> Logical dataset name
         character(len=*), intent(in) :: dataset
         !> Data to save
         real(dp), allocatable, intent(in) :: data(:,:,:)
         !> Error handling
         type(error_type), allocatable, intent(out) :: error
      end subroutine save_rdp_r3
   end interface
end module tblite_io_data_type

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3_disp
   use dftd3_cutoff, only : realspace_cutoff, get_lattice_points
   use dftd3_damping, only : damping_param
   use dftd3_model, only : d3_model
   use dftd3_ncoord, only : get_coordination_number, add_coordination_number_derivs
   use mctc_data, only : get_covalent_rad
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   use mctc_io_convert, only : autoaa
   implicit none
   private

   public :: get_dispersion, get_pairwise_dispersion


   !> Calculate dispersion energy
   interface get_dispersion
      module procedure :: get_dispersion_atomic
      module procedure :: get_dispersion_scalar
   end interface get_dispersion

contains


!> Calculate atom-resolved dispersion energies.
subroutine get_dispersion_atomic(mol, disp, param, cutoff, energies, gradient, sigma)

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Dispersion model
   class(d3_model), intent(in) :: disp

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Realspace cutoffs
   type(realspace_cutoff), intent(in) :: cutoff

   !> Dispersion energy
   real(wp), intent(out) :: energies(:)

   !> Dispersion gradient
   real(wp), intent(out), contiguous, optional :: gradient(:, :)

   !> Dispersion virial
   real(wp), intent(out), contiguous, optional :: sigma(:, :)

   logical :: grad
   integer :: mref
   real(wp), allocatable :: cn(:)
   real(wp), allocatable :: gwvec(:, :), gwdcn(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :)
   real(wp), allocatable :: dEdcn(:)
   real(wp), allocatable :: lattr(:, :)

   mref = maxval(disp%ref)
   grad = present(gradient).and.present(sigma)

   allocate(cn(mol%nat))
   call get_lattice_points(mol%periodic, mol%lattice, cutoff%cn, lattr)
   call get_coordination_number(mol, lattr, cutoff%cn, disp%rcov, cn)

   allocate(gwvec(mref, mol%nat))
   if (grad) allocate(gwdcn(mref, mol%nat))
   call disp%weight_references(mol, cn, gwvec, gwdcn)

   allocate(c6(mol%nat, mol%nat))
   if (grad) allocate(dc6dcn(mol%nat, mol%nat))
   call disp%get_atomic_c6(mol, gwvec, gwdcn, c6, dc6dcn)

   energies(:) = 0.0_wp
   if (grad) then
      allocate(dEdcn(mol%nat))
      dEdcn(:) = 0.0_wp
      gradient(:, :) = 0.0_wp
      sigma(:, :) = 0.0_wp
   end if
   call get_lattice_points(mol%periodic, mol%lattice, cutoff%disp2, lattr)
    call param%get_dispersion2(mol, lattr, cutoff%disp2, cutoff%width2, disp%rvdw, &
       & disp%r4r2, c6, dc6dcn, energies, dEdcn, gradient, sigma)
   call get_lattice_points(mol%periodic, mol%lattice, cutoff%disp3, lattr)
    call param%get_dispersion3(mol, lattr, cutoff%disp3, cutoff%width3, disp%rvdw, &
       & disp%r4r2, c6, dc6dcn, energies, dEdcn, gradient, sigma)
   if (grad) then
      call get_lattice_points(mol%periodic, mol%lattice, cutoff%cn, lattr)
      call add_coordination_number_derivs(mol, lattr, cutoff%cn, disp%rcov, dEdcn, &
         & gradient, sigma)
   end if

end subroutine get_dispersion_atomic


!> Calculate scalar dispersion energy.
subroutine get_dispersion_scalar(mol, disp, param, cutoff, energy, gradient, sigma)

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Dispersion model
   class(d3_model), intent(in) :: disp

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Realspace cutoffs
   type(realspace_cutoff), intent(in) :: cutoff

   !> Dispersion energy
   real(wp), intent(out) :: energy

   !> Dispersion gradient
   real(wp), intent(out), contiguous, optional :: gradient(:, :)

   !> Dispersion virial
   real(wp), intent(out), contiguous, optional :: sigma(:, :)

   real(wp), allocatable :: energies(:)

   allocate(energies(mol%nat))

   call get_dispersion_atomic(mol, disp, param, cutoff, energies, gradient, sigma)

   energy = sum(energies)

end subroutine get_dispersion_scalar


!> Wrapper to handle the evaluation of pairwise representation of the dispersion energy
subroutine get_pairwise_dispersion(mol, disp, param, cutoff, energy2, energy3)

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Dispersion model
   class(d3_model), intent(in) :: disp

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Realspace cutoffs
   type(realspace_cutoff), intent(in) :: cutoff

   !> Pairwise representation of additive dispersion energy
   real(wp), intent(out) :: energy2(:, :)

   !> Pairwise representation of non-additive dispersion energy
   real(wp), intent(out) :: energy3(:, :)

   integer :: mref
   real(wp), allocatable :: cn(:), gwvec(:, :), c6(:, :), lattr(:, :)

   mref = maxval(disp%ref)

   allocate(cn(mol%nat))
   call get_lattice_points(mol%periodic, mol%lattice, cutoff%cn, lattr)
   call get_coordination_number(mol, lattr, cutoff%cn, disp%rcov, cn)

   allocate(gwvec(mref, mol%nat))
   call disp%weight_references(mol, cn, gwvec)

   allocate(c6(mol%nat, mol%nat))
   call disp%get_atomic_c6(mol, gwvec, c6=c6)

   energy2(:, :) = 0.0_wp
   energy3(:, :) = 0.0_wp
   call get_lattice_points(mol%periodic, mol%lattice, cutoff%disp2, lattr)
    call param%get_pairwise_dispersion2(mol, lattr, cutoff%disp2, cutoff%width2, &
       & disp%rvdw, disp%r4r2, c6, energy2)

   call get_lattice_points(mol%periodic, mol%lattice, cutoff%disp3, lattr)
    call param%get_pairwise_dispersion3(mol, lattr, cutoff%disp3, cutoff%width3, &
       & disp%rvdw, disp%r4r2, c6, energy3)

end subroutine get_pairwise_dispersion


end module dftd3_disp

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module test_dftd3
   use mctc_env, only : wp
   use mctc_env_testing, only : new_unittest, unittest_type, error_type, check, &
      & test_failed
   use mctc_io, only : structure_type
   use mstore, only : get_structure
   use dftd3
   implicit none
   private

   public :: collect_dftd3

   real(wp), parameter :: thr = 100*epsilon(1.0_wp)
   real(wp), parameter :: thr2 = sqrt(epsilon(1.0_wp))


contains


!> Collect all exported unit tests
subroutine collect_dftd3(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("PBE-D3(BJ)", test_pbed3bj_mb01), &
      & new_unittest("B97-D3(BJ)", test_b97d3bj_mb02), &
      & new_unittest("TPSS-D3(BJ)", test_tpssd3bj_mb03), &
      & new_unittest("PWPB95-D3(BJ)", test_pwpb95d3bj_mb04), &
      & new_unittest("B2PLYP-D3(BJ)", test_b2plypd3bj_mb05), &
      & new_unittest("PW6B95-D3(BJ)", test_pw6b95d3bj_mb06), &
      & new_unittest("OLYP-D3(BJ)", test_olypd3bj_mb07), &
      & new_unittest("PBE0-D3(BJ)", test_pbe0d3bj_mb08), &
      & new_unittest("RPBE-D3(0)", test_rpbed3zero_mb09), &
      & new_unittest("B2GPPLYP-D3(0)", test_b2gpplypd3zero_mb10), &
      & new_unittest("SSB-D3(0)", test_ssbd3zero_mb11), &
      & new_unittest("B1B95-D3(0)", test_b1b95d3zero_mb12), &
      & new_unittest("M06L-D3(0)", test_m06ld3zero_mb13), &
      & new_unittest("TPSSh-D3(0)", test_tpsshd3zero_mb14), &
      & new_unittest("HF-D3(0)", test_hfd3zero_mb15), &
      & new_unittest("CAM-B3LYP-D3(0)", test_camb3lypd3zero_mb16), &
      & new_unittest("DSD-BLYP-D3(BJ)-ATM", test_dsdblypd3bjatm_mb17), &
      & new_unittest("mPWLYP-D3(BJ)-ATM", test_mpwlypd3bjatm_mb18), &
      & new_unittest("TPSS0-D3(BJ)-ATM", test_tpss0d3bjatm_mb19), &
      & new_unittest("BPBE-D3(BJ)-ATM", test_bpbed3bjatm_mb20), &
      & new_unittest("PWB6K-D3(BJ)-ATM", test_pwb6kd3bjatm_mb21), &
      & new_unittest("lc-wPBE-D3(BJ)-ATM", test_lcwpbed3bjatm_mb22), &
      & new_unittest("PW1PW-D3(BJ)-ATM", test_pw1pwd3bjatm_mb23), &
      & new_unittest("mPW1B95-D3(BJ)-ATM", test_mpw1b95d3bjatm_mb24), &
      & new_unittest("BLYP-D3(0)-ATM", test_blypd3zeroatm_mb25), &
      & new_unittest("revPBE-D3(0)-ATM", test_revpbed3zeroatm_mb26), &
      & new_unittest("HSE06-D3(0)-ATM", test_hse06d3zeroatm_mb27), &
      & new_unittest("BMK-D3(0)-ATM", test_bmkd3zeroatm_mb28), &
      & new_unittest("M06-D3(0)-ATM", test_m06d3zeroatm_mb29), &
      & new_unittest("B3LYP-D3(0)-ATM", test_b3lypd3zeroatm_mb30), &
      & new_unittest("BP-D3(0)-ATM", test_bpd3zeroatm_mb31), &
      & new_unittest("M05-D3(0)-ATM", test_m05d3zeroatm_mb32), &
      & new_unittest("PBE-D3(0M)", test_pbed3zerom_mb33), &
      & new_unittest("BLYP-D3(0M)", test_blypd3zerom_mb34), &
      & new_unittest("B97-D3(0M)", test_b97dd3zerom_mb35), &
      & new_unittest("lc-wPBE-D3(0M)", test_lcwpbed3zerom_mb36), &
      & new_unittest("B97h-D3(op)", test_b97hd3op_mb37), &
      & new_unittest("TPSSh-D3(op)", test_tpsshd3op_mb38), &
      & new_unittest("B3LYP-D3(CSO)", test_b3lypd3cso_mb01), &
      & new_unittest("PBE-D3(CSO)-ATM", test_pbed3cso_mb02), &
      & new_unittest("PBE-D3(BJ) Actinides", test_pbed3bj_actinides), &
      & new_unittest("PBE-D3(BJ)-ATM smooth cutoff gradient", test_pbed3bjatm_smooth_cutoff_grad) &
      & ]

end subroutine collect_dftd3


subroutine test_dftd3_gen(error, mol, param, ref)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(in) :: mol

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Expected dispersion energy
   real(wp), intent(in) :: ref

   type(d3_model) :: d3
   real(wp) :: energy

   call new_d3_model(d3, mol)
   call get_dispersion(mol, d3, param, realspace_cutoff(), energy)

   call check(error, energy, ref, thr=thr)
   if (allocated(error)) then
      print*,energy
   end if

end subroutine test_dftd3_gen


subroutine test_numgrad(error, mol, param, cutoff)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Damping parameters
   class(damping_param), intent(in) :: param

   !> Realspace cutoff
   type(realspace_cutoff), intent(in), optional :: cutoff

   integer :: iat, ic
   type(d3_model) :: d3
   type(realspace_cutoff) :: rcut
   real(wp) :: energy, er, el, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :), numgrad(:, :)
   real(wp), parameter :: step = 1.0e-6_wp

   allocate(gradient(3, mol%nat), numgrad(3, mol%nat))
   call new_d3_model(d3, mol)
   rcut = realspace_cutoff()
   if (present(cutoff)) rcut = cutoff

   do iat = 1, mol%nat
      do ic = 1, 3
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         call get_dispersion(mol, d3, param, rcut, er)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) - 2*step
         call get_dispersion(mol, d3, param, rcut, el)
         mol%xyz(ic, iat) = mol%xyz(ic, iat) + step
         numgrad(ic, iat) = 0.5_wp*(er - el)/step
      end do
   end do

   call get_dispersion(mol, d3, param, rcut, energy, gradient, sigma)

   if (any(abs(gradient - numgrad) > thr2)) then
      call test_failed(error, "Gradient of dispersion energy does not match")
      print'(3es21.14)', gradient-numgrad
   end if

end subroutine test_numgrad


subroutine test_pbed3bjatm_smooth_cutoff_grad(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.4289_wp, s8 = 0.7875_wp, a2 = 4.4407_wp)
   type(realspace_cutoff) :: cutoff = realspace_cutoff(&
      & cn=40.0_wp, disp2=8.0_wp, disp3=8.0_wp, width2=4.0_wp, width3=4.0_wp)

   call get_structure(mol, "MB16-43", "01")
   call new_rational_damping(param, inp)
   call test_numgrad(error, mol, param, cutoff)

end subroutine test_pbed3bjatm_smooth_cutoff_grad


subroutine test_numsigma(error, mol, param)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   !> Molecular structure data
   type(structure_type), intent(inout) :: mol

   !> Damping parameters
   class(damping_param), intent(in) :: param

   integer :: ic, jc
   type(d3_model) :: d3
   real(wp) :: energy, er, el, sigma(3, 3), eps(3, 3), numsigma(3, 3)
   real(wp), allocatable :: gradient(:, :), xyz(:, :)
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], shape(unity))
   real(wp), parameter :: step = 1.0e-6_wp

   allocate(gradient(3, mol%nat), xyz(3, mol%nat))
   call new_d3_model(d3, mol)

   eps(:, :) = unity
   xyz(:, :) = mol%xyz
   do ic = 1, 3
      do jc = 1, 3
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = matmul(eps, xyz)
         call get_dispersion(mol, d3, param, realspace_cutoff(), er)
         eps(jc, ic) = eps(jc, ic) - 2*step
         mol%xyz(:, :) = matmul(eps, xyz)
         call get_dispersion(mol, d3, param, realspace_cutoff(), el)
         eps(jc, ic) = eps(jc, ic) + step
         mol%xyz(:, :) = xyz
         numsigma(jc, ic) = 0.5_wp*(er - el)/step
      end do
   end do

   call get_dispersion(mol, d3, param, realspace_cutoff(), energy, gradient, sigma)

   if (any(abs(sigma - numsigma) > thr2)) then
      call test_failed(error, "Strain derivatives do not match")
      print'(3es21.14)', sigma-numsigma
   end if

end subroutine test_numsigma



subroutine test_pbed3bj_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.4289_wp, s8 = 0.7875_wp, a2 = 4.4407_wp)

   call get_structure(mol, "MB16-43", "01")
   call new_rational_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -1.7882220155186028E-002_wp)

end subroutine test_pbed3bj_mb01


subroutine test_b97d3bj_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.5545_wp, s8 = 2.2609_wp, a2 = 3.2297_wp)

   call get_structure(mol, "MB16-43", "02")
   call new_rational_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -5.9503371130070551E-002_wp)

end subroutine test_b97d3bj_mb02


subroutine test_tpssd3bj_mb03(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.4535_wp, s8 = 1.9435_wp, a2 = 4.4752_wp)

   call get_structure(mol, "MB16-43", "03")
   call new_rational_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -2.8684059240803347E-002_wp)

end subroutine test_tpssd3bj_mb03


subroutine test_pwpb95d3bj_mb04(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 0.82_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.0000_wp, s8 = 0.2904_wp, a2 = 7.3141_wp)

   call get_structure(mol, "MB16-43", "04")
   call new_rational_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -1.2270948604225146E-002_wp)

end subroutine test_pwpb95d3bj_mb04


subroutine test_b2plypd3bj_mb05(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 0.64_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.3065_wp, s8 = 0.9147_wp, a2 = 5.0570_wp)

   call get_structure(mol, "MB16-43", "05")
   call new_rational_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_b2plypd3bj_mb05


subroutine test_pw6b95d3bj_mb06(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.2076_wp, s8 = 0.7257_wp, a2 = 6.3750_wp)

   call get_structure(mol, "MB16-43", "06")
   call new_rational_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_pw6b95d3bj_mb06


subroutine test_olypd3bj_mb07(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.5299_wp, s8 = 2.6205_wp, a2 = 2.8065_wp)

   call get_structure(mol, "MB16-43", "07")
   call new_rational_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_olypd3bj_mb07


subroutine test_pbe0d3bj_mb08(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.4145_wp, s8 = 1.2177_wp, a2 = 4.8593_wp)

   call get_structure(mol, "MB16-43", "08")
   call new_rational_damping(param, inp)
   call test_numsigma(error, mol, param)

end subroutine test_pbe0d3bj_mb08


subroutine test_rpbed3zero_mb09(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 0.872_wp, s8 = 0.514_wp)

   call get_structure(mol, "MB16-43", "09")
   call new_zero_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -2.0178760785797962E-002_wp)

end subroutine test_rpbed3zero_mb09


subroutine test_b2gpplypd3zero_mb10(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 0.56_wp, s9 = 0.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.586_wp, s8 = 0.760_wp)

   call get_structure(mol, "MB16-43", "10")
   call new_zero_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -8.2668192717285059E-003_wp)

end subroutine test_b2gpplypd3zero_mb10


subroutine test_ssbd3zero_mb11(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.215_wp, s8 = 0.663_wp)

   call get_structure(mol, "MB16-43", "11")
   call new_zero_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -8.7923023966613584E-003_wp)

end subroutine test_ssbd3zero_mb11


subroutine test_b1b95d3zero_mb12(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.613_wp, s8 = 1.868_wp)

   call get_structure(mol, "MB16-43", "12")
   call new_zero_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -1.5146271685761267E-002_wp)

end subroutine test_b1b95d3zero_mb12


subroutine test_m06ld3zero_mb13(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.581_wp, s8 = 0.000_wp)

   call get_structure(mol, "MB16-43", "13")
   call new_zero_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_m06ld3zero_mb13


subroutine test_tpsshd3zero_mb14(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.223_wp, s8 = 1.219_wp)

   call get_structure(mol, "MB16-43", "14")
   call new_zero_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_tpsshd3zero_mb14


subroutine test_hfd3zero_mb15(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.158_wp, s8 = 1.746_wp)

   call get_structure(mol, "MB16-43", "15")
   call new_zero_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_hfd3zero_mb15


subroutine test_camb3lypd3zero_mb16(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.378_wp, s8 = 1.217_wp)

   call get_structure(mol, "MB16-43", "16")
   call new_zero_damping(param, inp)
   call test_numsigma(error, mol, param)

end subroutine test_camb3lypd3zero_mb16


subroutine test_dsdblypd3bjatm_mb17(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 0.5_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.0_wp, s8 = 0.2130_wp, a2 = 6.0519_wp)

   call get_structure(mol, "MB16-43", "17")
   call new_rational_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -1.3592755832923201E-002_wp)

end subroutine test_dsdblypd3bjatm_mb17


subroutine test_mpwlypd3bjatm_mb18(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.4831_wp, s8 = 2.0077_wp, a2 = 3.5043_wp)

   call get_structure(mol, "MB16-43", "18")
   call new_rational_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -4.4058898934399460E-002_wp)

end subroutine test_mpwlypd3bjatm_mb18


subroutine test_tpss0d3bjatm_mb19(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.3768_wp, s8 = 1.2576_wp, a2 = 4.5865_wp)

   call get_structure(mol, "MB16-43", "19")
   call new_rational_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -4.1318505521837870E-002_wp)

end subroutine test_tpss0d3bjatm_mb19


subroutine test_bpbed3bjatm_mb20(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.4567_wp, s8 = 4.0728_wp, a2 = 4.3908_wp)

   call get_structure(mol, "MB16-43", "20")
   call new_rational_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -3.4953087919973355E-002_wp)

end subroutine test_bpbed3bjatm_mb20


subroutine test_pwb6kd3bjatm_mb21(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.1865_wp, s8 = 0.9383_wp, a2 = 7.7627_wp)

   call get_structure(mol, "MB16-43", "21")
   call new_rational_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_pwb6kd3bjatm_mb21


subroutine test_lcwpbed3bjatm_mb22(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.3919_wp, s8 = 1.8541_wp, a2 = 5.0897_wp)

   call get_structure(mol, "MB16-43", "22")
   call new_rational_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_lcwpbed3bjatm_mb22


subroutine test_pw1pwd3bjatm_mb23(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.3807_wp, s8 = 2.3363_wp, a2 = 5.8844_wp)

   call get_structure(mol, "MB16-43", "23")
   call new_rational_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_pw1pwd3bjatm_mb23


subroutine test_mpw1b95d3bjatm_mb24(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.1955_wp, s8 = 1.0508_wp, a2 = 6.4177_wp)

   call get_structure(mol, "MB16-43", "24")
   call new_rational_damping(param, inp)
   call test_numsigma(error, mol, param)

end subroutine test_mpw1b95d3bjatm_mb24


subroutine test_blypd3zeroatm_mb25(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.094_wp, s8 = 1.682_wp)

   call get_structure(mol, "MB16-43", "25")
   call new_zero_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -1.8876259384422459E-002_wp)

end subroutine test_blypd3zeroatm_mb25


subroutine test_revpbed3zeroatm_mb26(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 0.923_wp, s8 = 1.010_wp)

   call get_structure(mol, "MB16-43", "26")
   call new_zero_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -2.1820118878237430E-002_wp)

end subroutine test_revpbed3zeroatm_mb26


subroutine test_hse06d3zeroatm_mb27(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.129_wp, s8 = 0.109_wp)

   call get_structure(mol, "MB16-43", "27")
   call new_zero_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -6.1849950573474831E-003_wp)

end subroutine test_hse06d3zeroatm_mb27


subroutine test_bmkd3zeroatm_mb28(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.931_wp, s8 = 2.168_wp)

   call get_structure(mol, "MB16-43", "28")
   call new_zero_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -1.5629608155684784E-002_wp)

end subroutine test_bmkd3zeroatm_mb28


subroutine test_m06d3zeroatm_mb29(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.325_wp, s8 = 0.000_wp)

   call get_structure(mol, "MB16-43", "29")
   call new_zero_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_m06d3zeroatm_mb29


subroutine test_b3lypd3zeroatm_mb30(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.261_wp, s8 = 1.105_wp)

   call get_structure(mol, "MB16-43", "30")
   call new_zero_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_b3lypd3zeroatm_mb30


subroutine test_bpd3zeroatm_mb31(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.139_wp, s8 = 1.683_wp)

   call get_structure(mol, "MB16-43", "31")
   call new_zero_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_bpd3zeroatm_mb31


subroutine test_m05d3zeroatm_mb32(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(zero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.355_wp, s8 = 1.279_wp)

   call get_structure(mol, "MB16-43", "32")
   call new_zero_damping(param, inp)
   call test_numsigma(error, mol, param)

end subroutine test_m05d3zeroatm_mb32


subroutine test_pbed3zerom_mb33(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(mzero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 2.340218_wp, s8 = 0.0_wp, bet = 0.129434_wp)

   call get_structure(mol, "MB16-43", "33")
   call new_mzero_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -6.4839784232922359E-002_wp)

end subroutine test_pbed3zerom_mb33


subroutine test_blypd3zerom_mb34(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(mzero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.279637_wp, s8 = 1.841686_wp, bet = 0.014370_wp)

   call get_structure(mol, "MB16-43", "34")
   call new_mzero_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -4.1835874470780833E-002_wp)

end subroutine test_blypd3zerom_mb34


subroutine test_b97dd3zerom_mb35(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(mzero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.338153_wp, s8 = 1.532981_wp, bet = 0.013988_wp)

   call get_structure(mol, "MB16-43", "35")
   call new_mzero_damping(param, inp)
   call test_numgrad(error, mol, param)

end subroutine test_b97dd3zerom_mb35


subroutine test_lcwpbed3zerom_mb36(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(mzero_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, rs8 = 1.0_wp, &
      & rs6 = 1.366361_wp, s8 = 1.280619_wp, bet = 0.003160_wp)

   call get_structure(mol, "MB16-43", "36")
   call new_mzero_damping(param, inp)
   call test_numsigma(error, mol, param)

end subroutine test_lcwpbed3zerom_mb36


subroutine test_b97hd3op_mb37(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(optimizedpower_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 0.97388_wp, s9 = 1.0_wp, alp = 14.0_wp, bet = 6.0_wp, &
      & a1 = 0.150_wp, s8 = 0.0_wp, a2 = 4.25_wp)

   call get_structure(mol, "MB16-43", "37")
   call new_optimizedpower_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -2.7952861273999385E-002_wp)
   if (allocated(error)) return
   call test_numgrad(error, mol, param)

end subroutine test_b97hd3op_mb37


subroutine test_tpsshd3op_mb38(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(optimizedpower_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, bet = 8.0_wp, &
      & a1 = 0.575_wp, s8 = 0.43185_wp, a2 = 3.00_wp)

   call get_structure(mol, "MB16-43", "38")
   call new_optimizedpower_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -9.0101761599590859E-003_wp)
   if (allocated(error)) return
   call test_numsigma(error, mol, param)

end subroutine test_tpsshd3op_mb38


subroutine test_b3lypd3cso_mb01(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(cso_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.86_wp, a2 = 2.5_wp, rs6 = 0.0_wp, rs8 = 6.25_wp)

   call get_structure(mol, "MB16-43", "01")
   call new_cso_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -3.8002950817452329E-002_wp)
   if (allocated(error)) return
   call test_numgrad(error, mol, param)

end subroutine test_b3lypd3cso_mb01


subroutine test_pbed3cso_mb02(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(cso_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 1.0_wp, alp = 14.0_wp, &
      & a1 = 0.24_wp, a2 = 2.5_wp, rs6 = 0.0_wp, rs8 = 6.25_wp)

   call get_structure(mol, "MB16-43", "02")
   call new_cso_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -3.8229908827789316E-002_wp)
   if (allocated(error)) return
   call test_numsigma(error, mol, param)

end subroutine test_pbed3cso_mb02


subroutine test_pbed3bj_actinides(error)

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   type(rational_damping_param) :: param
   type(d3_param) :: inp = d3_param(&
      & s6 = 1.0_wp, s9 = 0.0_wp, alp = 14.0_wp, &
      & a1 = 0.4289_wp, s8 = 0.7875_wp, a2 = 4.4407_wp)

   ! Molecular structure data 
   mol%nat = 17
   mol%nid = 17
   mol%id = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, &
      & 12, 13, 14, 15, 16, 17]
   mol%num = [87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, &
      & 98, 99, 100, 101, 102, 103]
   mol%xyz = reshape([ &
      & 0.98692316414074_wp, 6.12727238368797_wp,-6.67861597188102_wp, &
      & 3.63898862390869_wp, 5.12109301182962_wp, 3.01908613326278_wp, &
      & 5.14503571563551_wp,-3.97172984617710_wp, 3.82011791828867_wp, &
      & 6.71986847575494_wp, 1.71382138402812_wp, 3.92749159076307_wp, &
      & 4.13783589704826_wp,-2.10695793491818_wp, 0.19753203068899_wp, &
      & 8.97685097698326_wp,-3.08813636191844_wp,-4.45568615593938_wp, &
      & 12.5486412940776_wp,-1.77128765259458_wp, 0.59261498922861_wp, &
      & 7.82051475868325_wp,-3.97159756604558_wp,-0.53637703616916_wp, &
      &-0.43444574624893_wp,-1.69696511583960_wp,-1.65898182093050_wp, &
      &-4.71270645149099_wp,-0.11534827468942_wp, 2.84863373521297_wp, &
      &-2.52061680335614_wp, 1.82937752749537_wp,-2.10366982879172_wp, &
      & 0.13551154616576_wp, 7.99805359235043_wp,-1.55508522619903_wp, &
      & 3.91594542499717_wp,-1.72975169129597_wp,-5.07944366756113_wp, &
      &-1.03393930231679_wp, 4.69307230054046_wp, 0.02656940927472_wp, &
      & 6.20675384557240_wp, 4.24490721493632_wp,-0.71004195169885_wp, &
      & 7.04586341131562_wp, 5.20053667939076_wp,-7.51972863675876_wp, &
      & 2.01082807362334_wp, 1.34838807211157_wp,-4.70482633508447_wp],&
      & [3, 17])
   mol%periodic = [.false.]
   allocate(mol%lattice(0, 0))

   call new_rational_damping(param, inp)
   call test_dftd3_gen(error, mol, param, -1.4131143363689097E-001_wp)

end subroutine test_pbed3bj_actinides

end module test_dftd3

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/integral/diat_trafo.f90
!> Evaluation of the diatomic scaled overlap
module tblite_integral_diat_trafo
   use mctc_env, only : wp
   use tblite_blas, only: gemm

   implicit none
   private

   public :: diat_trafo, diat_trafo_grad

   !> Dimension of trafo matrix for highest angular momentum.
   integer, parameter :: sdim(0:6) = [1, 4, 9, 16, 25, 36, 49]

contains

   !> Transformation to the diatomic frame and back: 
   pure subroutine diat_trafo(block_overlap, vec, ksig, kpi, kdel, maxlj, maxli)
      !> Diatomic block of CGTOs to be transformed (+ scaled)
      real(wp),intent(inout)    :: block_overlap(:,:)
      !> Transformation vector for the diatomic frame (i.e. vector between the two centers)
      real(wp),intent(in)       :: vec(3)
      !> Scaling parameters for different bonding contributions
      real(wp),intent(in)       :: ksig, kpi, kdel
      !> Highest angular momentum of atom j (first index)
      integer,intent(in)        :: maxlj
      !> Highest angular momentum of atom i (second index)
      integer,intent(in)        :: maxli

      integer  :: dimj, dimi, maxl
      real(wp), allocatable :: trafomat(:,:), tmp(:,:), transformed_s(:,:)

      ! Select the dimensions of the transformation matrix
      dimj = sdim(maxlj)
      dimi = sdim(maxli)
      maxl = max(maxlj, maxli)

      allocate(trafomat(sdim(maxl), sdim(maxl)), transformed_s(dimj,dimi), &
      & tmp(dimj,dimi), source=0.0_wp)

      ! 1. Setup the transformation matrix
      call harmtr(maxl, vec, trafomat)

      ! 2. Transform the overlap submatrix to the diatomic frame: S' = O^T * S * O
      if (maxl > 0) then
         call gemm(amat=trafomat(1:dimj,1:dimj), bmat=block_overlap(1:dimj,1:dimi), &
            & cmat=tmp, transa='T', transb='N')
         call gemm(amat=tmp, bmat=trafomat(1:dimi,1:dimi), &
            & cmat=transformed_s, transa='N', transb='N')
      else
         transformed_s(1,1) = block_overlap(1,1)
      endif

      ! 3. Scale elements in the diatomic frame
      call scale_diatomic_frame(transformed_s, ksig, kpi, kdel, maxlj, maxli) 

      ! 4. Transform the overlap submatrix back to original frame: Ssc = O * Ssc' * O^T
      block_overlap = 0.0_wp
      if (maxl > 0) then
         call gemm(amat=trafomat(1:dimj,1:dimj), bmat=transformed_s, &
            & cmat=tmp, transa='N', transb='N')
         call gemm(amat=tmp, bmat=trafomat(1:dimi,1:dimi), &
            & cmat=block_overlap(1:dimj,1:dimi), transa='N', transb='T')
      else
         block_overlap(1,1) = transformed_s(1,1)
      endif

   end subroutine diat_trafo

   !> Gradient of the diatomic frame scaled overlap transformation: 
   pure subroutine diat_trafo_grad(block_overlap, block_doverlap, vec, ksig, kpi, kdel, maxlj, maxli)
      !> Diatomic block of CGTO overlap to be transformed (+ scaled)
      real(wp),intent(inout)    :: block_overlap(:,:)
      !> Derivative of diatomic block of CGTO overlap to be transformed (+ scaled)
      real(wp),intent(inout)    :: block_doverlap(:,:,:)
      !> Transformation vector for the diatomic frame (i.e. vector between the two centers)
      real(wp),intent(in)       :: vec(3)
      !> Scaling parameters for different bonding contributions
      real(wp),intent(in)       :: ksig, kpi, kdel
      !> Highest angular momentum of atom j (first index)
      integer,intent(in)        :: maxlj
      !> Highest angular momentum of atom i (second index)
      integer,intent(in)        :: maxli
      
      integer :: ic, dimj, dimi, maxl
      real(wp), allocatable :: trafomat(:,:,:), dtrafomat(:,:,:), tmp(:,:), &
      & interm_oso(:,:), interm_doso(:,:,:), interm_odso(:,:,:), interm_osdo(:,:,:)

      ! Select the dimensions of the transformation matrix
      dimj = sdim(maxlj)
      dimi = sdim(maxli)
      maxl = max(maxlj, maxli)

      allocate(trafomat(3,sdim(maxl), sdim(maxl)), dtrafomat(3,sdim(maxl), sdim(maxl)), &
      & interm_oso(dimj,dimi), interm_doso(3,dimj,dimi), interm_osdo(3,dimj, dimi), &
      & interm_odso(3,dimj,dimi), tmp(dimj,dimi), source=0.0_wp)

      ! 1. Setup the transformation matrix and its derivative for all directions.
      ! For the case vec || z-axis, the x- and y-derivatives are ill-defined 
      ! and have to be evaluated assuming either x or y orientation. 
      call d_harmtr(maxl, vec, trafomat, dtrafomat)

      ! 2. Transform the overlap submatrix to the diatomic frame: S' = O^T * S * O
      if (maxl > 0) then
         ! interm_oso = O^T * S * O
         call gemm(amat=trafomat(3,1:dimj,1:dimj), bmat=block_overlap(1:dimj,1:dimi), &
            & cmat=tmp,transa='T', transb='N')
         call gemm(amat=tmp, bmat=trafomat(3,1:dimi,1:dimi), &
            & cmat=interm_oso, transa='N', transb='N')
         do ic = 1, 3
            ! interm_doso = dO^T * S * O
            call gemm(amat=dtrafomat(ic,1:dimj,1:dimj), bmat=block_overlap(1:dimj,1:dimi), &
               & cmat=tmp, transa='T', transb='N')
            call gemm(amat=tmp, bmat=trafomat(ic,1:dimi,1:dimi), &
               & cmat=interm_doso(ic,:,:), transa='N', transb='N')
            ! interm_osdo = O^T * S * dO
            call gemm(amat=trafomat(ic,1:dimj,1:dimj), bmat=block_overlap(1:dimj,1:dimi), &
               & cmat=tmp, transa='T', transb='N')
            call gemm(amat=tmp, bmat=dtrafomat(ic,1:dimi,1:dimi), &
               & cmat=interm_osdo(ic,:,:), transa='N', transb='N')
            ! interm_odso = O^T * dS * O
            call gemm(amat=trafomat(ic,1:dimj,1:dimj), bmat=block_doverlap(ic,1:dimj,1:dimi), &
               & cmat=tmp, transa='T', transb='N')
            call gemm(amat=tmp, bmat=trafomat(ic,1:dimi,1:dimi), &
               & cmat=interm_odso(ic,:,:), transa='N', transb='N')
         end do
      else
         interm_oso(1,1) = block_overlap(1,1)
         interm_doso(:,1,1) = 0.0_wp
         interm_odso(:,1,1) = block_doverlap(:,1,1)
         interm_osdo(:,1,1) = 0.0_wp
      endif

      ! 3. Scale overlap and each dimension of the derivative in the diatomic frame
      call scale_diatomic_frame(interm_oso, ksig, kpi, kdel, maxlj, maxli) 
      do ic = 1, 3
         call scale_diatomic_frame(interm_doso(ic,:,:), ksig, kpi, kdel, maxlj, maxli)
         call scale_diatomic_frame(interm_osdo(ic,:,:), ksig, kpi, kdel, maxlj, maxli) 
         call scale_diatomic_frame(interm_odso(ic,:,:), ksig, kpi, kdel, maxlj, maxli) 
      end do

      ! 4. Transform diatomic frame quantities (S', (dOSO)', (OSdO)' and (OdSO)') back to original frame
      if (maxl > 0) then
         ! block_overlap = O * S' * O^T
         call gemm(amat=trafomat(3,1:dimj,1:dimj), bmat=interm_oso, &
            & cmat=tmp, transa='N', transb='N')
         call gemm(amat=tmp, bmat=trafomat(3,1:dimi,1:dimi), &
            & cmat=block_overlap(1:dimj,1:dimi), transa='N', transb='T')

         do ic = 1, 3
            ! block_doverlap = dO * S' * O^T + O * S' * dO^T
            call gemm(amat=dtrafomat(ic,1:dimj,1:dimj), bmat=interm_oso, &
               & cmat=tmp, transa='N', transb='N')
            call gemm(alpha=1.0_wp, amat=tmp, bmat=trafomat(ic,1:dimi,1:dimi), &
               & cmat=block_doverlap(ic,1:dimj,1:dimi), transa='N', transb='T')

            call gemm(amat=trafomat(ic,1:dimj,1:dimj), bmat=interm_oso, &
               & cmat=tmp, transa='N', transb='N')
            call gemm(alpha=1.0_wp, amat=tmp, bmat=dtrafomat(ic,1:dimi,1:dimi), beta=1.0_wp, &
               & cmat=block_doverlap(ic,1:dimj,1:dimi), transa='N', transb='T')
            
            ! block_doverlap += O * (dOSO)' * O^T + O * (OSdO)' * O^T 
            call gemm(amat=trafomat(ic,1:dimj,1:dimj), bmat=interm_doso(ic,:,:), &
               & cmat=tmp, transa='N', transb='N')
            call gemm(alpha=1.0_wp, amat=tmp, bmat=trafomat(ic,1:dimi,1:dimi), beta=1.0_wp, &
               & cmat=block_doverlap(ic,1:dimj,1:dimi), transa='N', transb='T')

            call gemm(amat=trafomat(ic,1:dimj,1:dimj), bmat=interm_odso(ic,:,:), &
               & cmat=tmp, transa='N', transb='N')
            call gemm(amat=tmp, bmat=trafomat(ic,1:dimi,1:dimi), beta=1.0_wp, &
               & cmat=block_doverlap(ic,1:dimj,1:dimi), transa='N', transb='T')
            
            ! block_doverlap += O * (OdSO)' * O^T 
            call gemm(amat=trafomat(ic,1:dimj,1:dimj), bmat=interm_osdo(ic,:,:), &
               & cmat=tmp, transa='N', transb='N')
            call gemm(alpha=1.0_wp, amat=tmp, bmat=trafomat(ic,1:dimi,1:dimi), beta=1.0_wp, &
               & cmat=block_doverlap(ic,1:dimj,1:dimi), transa='N', transb='T')
         end do
      else
         block_overlap(1,1) = interm_oso(1,1)
         block_doverlap(:,1,1) = interm_odso(:,1,1)
      endif

   end subroutine diat_trafo_grad


   pure subroutine harmtr(maxl,vec,trafomat)
      !> Maximum angular momentum
      integer, intent(in)  :: maxl
      !> Normalized vector from atom k to atom l
      real(wp), intent(in) :: vec(3)
      !> Transformation matrix
      real(wp), intent(out) :: trafomat(sdim(maxl),sdim(maxl))
      real(wp) :: cos2p, cos2t, cosp, cost, sin2p, sin2t, sinp, sint, sqrt3, len
      real(wp) :: norm_vec(3)

      trafomat = 0.0_wp

      ! -----------------------------
      !  s functions (trafomat(1x1))
      ! -----------------------------
      
      trafomat(1,1) = 1.0

      if ( maxl == 0 ) return

      ! Normalize the vector
      len = sqrt(sum(vec**2))
      norm_vec = vec / len

      ! Prepare spherical coordinats
      cost = norm_vec(3)
      if ( abs(cost) .eq. 1.0_wp ) then
         ! Here, phi is arbitrary as the vector is parallel to the z-axis.
         ! We choose the x-axis as the arbitrary direction.
         sint = 0.0_wp
         cosp = 1.0_wp
         sinp = 0.0_wp
      else if ( abs(cost) .eq. 0.0_wp ) then
         sint = 1.0_wp
         cosp = norm_vec(1)
         sinp = norm_vec(2)
      else
         sint = SQRT(norm_vec(1)**2 + norm_vec(2)**2)
         cosp = norm_vec(1)/SINT
         sinp = norm_vec(2)/SINT
      endif

      ! -----------------------------
      !  p functions (trafomat(4x4))
      ! -----------------------------

      ! Adapted to tblite ordering from MSINDO
      ! 1st index:
      ! (2,:)_MSINDO -> (px,:) -> (4,:)_tblite
      ! (3,:)_MSINDO -> (py,:) -> (2,:)_tblite
      ! (4,:)_MSINDO -> (pz,:) -> (3,:)_tblite
      trafomat(4,3) = SINT*COSP
      trafomat(2,3) = SINT*SINP
      trafomat(3,3) = COST
      trafomat(4,4) = COST*COSP
      trafomat(2,4) = COST*SINP
      trafomat(3,4) = -SINT
      trafomat(4,2) = -SINP
      trafomat(2,2) = COSP
      trafomat(3,2) = 0.0_wp

      if ( maxl <= 1 ) return

      ! -----------------------------
      !  d functions (trafomat(9x9)) 
      ! -----------------------------

      COS2T = COST**2 - SINT**2
      SIN2T = 2.0_wp * SINT*COST
      COS2P = COSP**2 - SINP**2
      SIN2P = 2.0_wp * SINP*COSP
      SQRT3 = SQRT(3.0_wp)

      ! Changed from MSINDO ordering (0,-1,1,-2,2) to tblite ordering (-2,-1,0,1,2) of d-functions 
      ! (5,:)_MSINDO -> (dz2,:) -> (7,:)_tblite
      ! (6,:)_MSINDO -> (dxz,:) -> (8,:)_tblite
      ! (7,:)_MSINDO -> (dyz,:) -> (6,:)_tblite
      ! (8,:)_MSINDO -> (dx2-y2,:) -> (5,:)_tblite
      ! (9,:)_MSINDO -> (dxy,:) -> (9,:)_tblite
      trafomat(7,7) = (3.0_wp * COST**2 - 1.0_wp) * 0.5_wp
      trafomat(8,7) = SQRT3*SIN2T*COSP*0.5_wp
      trafomat(6,7) = SQRT3*SIN2T*SINP*0.5_wp
      trafomat(9,7) = SQRT3*SINT**2*COS2P*0.5_wp
      trafomat(5,7) = SQRT3*SINT**2*SIN2P*0.5_wp
      trafomat(7,8) = -SQRT3*SIN2T*0.5_wp
      trafomat(8,8) = COS2T*COSP
      trafomat(6,8) = COS2T*SINP
      trafomat(9,8) = SIN2T*COS2P*0.5_wp
      trafomat(5,8) = SIN2T*SIN2P*0.5_wp
      trafomat(7,6) = 0.0_wp
      trafomat(8,6) = -COST*SINP
      trafomat(6,6) = COST*COSP
      trafomat(9,6) = -SINT*SIN2P
      trafomat(5,6) = SINT*COS2P
      trafomat(7,9) = SQRT3*SINT**2 * 0.5_wp
      trafomat(8,9) = -SIN2T*COSP*0.5_wp
      trafomat(6,9) = -SIN2T*SINP*0.5_wp
      trafomat(9,9) = (1.0_wp + COST**2) * COS2P * 0.5_wp
      trafomat(5,9) = (1.0_wp + COST**2) * SIN2P * 0.5_wp
      trafomat(7,5) = 0.0_wp
      trafomat(8,5) = SINT*SINP
      trafomat(6,5) = -SINT*COSP
      trafomat(9,5) = -COST*SIN2P
      trafomat(5,5) = COST*COS2P

      if ( maxl <= 2 ) return

      ! -------------------------------
      !  f functions (trafomat(16x16)) 
      ! -------------------------------

      ! f-functions are not transformed to the diatomic frame!
      trafomat(10,10) = 1.0_wp
      trafomat(11,11) = 1.0_wp
      trafomat(12,12) = 1.0_wp
      trafomat(13,13) = 1.0_wp
      trafomat(14,14) = 1.0_wp
      trafomat(15,15) = 1.0_wp
      trafomat(16,16) = 1.0_wp

      if ( maxl <= 3 ) return

      ! -------------------------------
      !  g functions (trafomat(25x25)) 
      ! -------------------------------

      ! g-functions are not transformed to the diatomic frame!
      trafomat(17,17) = 1.0_wp
      trafomat(18,18) = 1.0_wp
      trafomat(19,19) = 1.0_wp
      trafomat(20,20) = 1.0_wp
      trafomat(21,21) = 1.0_wp
      trafomat(22,22) = 1.0_wp
      trafomat(23,23) = 1.0_wp
      trafomat(24,24) = 1.0_wp
      trafomat(25,25) = 1.0_wp

      if ( maxl <= 4 ) return

   end subroutine harmtr

   pure subroutine d_harmtr(maxl,vec,trafomat, dtrafomat)
      !> Maximum angular momentum
      integer, intent(in)  :: maxl
      !> Normalized vector from atom k to atom l
      real(wp), intent(in) :: vec(3)
      !> Transformation matrix
      real(wp), intent(out) :: trafomat(3,sdim(maxl),sdim(maxl))
      !> Derivative of transformation matrix
      real(wp), intent(out) :: dtrafomat(3,sdim(maxl),sdim(maxl))
      
      real(wp), parameter              :: eps = 1.0e-08_wp

      !> Derivative of transformation matrix w.r.t. theta (x- or z-direction)
      real(wp) :: trafomat_dt(sdim(maxl),sdim(maxl))
      !> Derivative of transformation matrix w.r.t. theta (y-direction)
      real(wp) :: trafomat_dty(sdim(maxl),sdim(maxl))
      !> Derivative of transformation matrix w.r.t. phi (x- or z-direction)
      real(wp) :: trafomat_dp(sdim(maxl),sdim(maxl))
      !> Derivative of transformation matrix w.r.t. phi (y-direction)
      real(wp) :: trafomat_dpy(sdim(maxl),sdim(maxl))

      ! Intermediate variables for the trigonometric functions
      ! Separte version for y for the case: vec || z-axis
      real(wp) :: cos2p, cos2t, cosp, cost, sin2p, sin2t, sinp
      real(wp) :: cos2py, cospy, sin2py, sinpy
      real(wp) :: dcos2t, dsin2t, dcos2p, dsin2p
      real(wp) :: dcos2py, dsin2py
      real(wp) :: dpdx, dpdy, dpdz, dtdx, dtdy, dtdz
      real(wp) :: norm_vec(3), sint, sqrt3, len

      trafomat = 0.0_wp
      trafomat_dt = 0.0_wp
      trafomat_dty = 0.0_wp
      trafomat_dp = 0.0_wp
      trafomat_dpy = 0.0_wp

      ! -----------------------------
      !  s functions (trafomat(1x1)) 
      ! -----------------------------

      trafomat(:,1,1) = 1.0_wp
      dtrafomat(:,1,1) = 0.0_wp

      if ( maxl == 0 ) return

      ! Normalize the vector
      len = sqrt(sum(vec**2))
      norm_vec = vec / len

      ! Prepare spherical coordinats
      cost = norm_vec(3)
      if ( abs(cost) .eq. 1.0_wp ) then
         sint = 0.0_wp
         ! Here, phi is arbitrary as the vector is parallel to the z-axis.
         ! In turn, the derivative is ill defined and has to be evaluated
         ! assuming either x or y orientation for the infinitesimal change. 
         ! This is only require for the p- and d-functions, which are transformed.
         cosp = 1.0_wp
         sinp = 0.0_wp
         if ( maxl == 1 .or. maxl == 2 ) then 
            cospy = 0.0_wp
            sinpy = -1.0_wp
         else
            cospy = cosp
            sinpy = sinp
         end if
      else if ( abs(cost) .eq. 0.0_wp ) then
         sint = 1.0_wp
         cosp = norm_vec(1)
         sinp = norm_vec(2)
         cospy = cosp
         sinpy = sinp
      else
         sint = SQRT(norm_vec(1)**2 + norm_vec(2)**2)
         cosp = norm_vec(1)/SINT
         sinp = norm_vec(2)/SINT
         cospy = cosp
         sinpy = sinp
      endif

      ! Prepare sperical coordinate derivative
      ! In the case of (exactly) vec || z-axis, the phi derivative vanishes.
      if( norm_vec(1)**2 + norm_vec(2)**2 .eq. 0.0_wp ) then
         dpdx = 0.0_wp
         dpdy = 0.0_wp
      else
         dpdx = -sinp / sqrt(vec(1)**2 + vec(2)**2) 
         dpdy = cospy / sqrt(vec(1)**2 + vec(2)**2)
      end if 
      dpdz = 0.0_wp
      dtdx = cost * cosp / len
      dtdy = cost * sinpy / len
      dtdz = -sint / len

      ! -----------------------------
      !  p functions (trafomat(4x4)) 
      ! -----------------------------

      ! Adapted to tblite ordering from MSINDO
      ! 1st index:
      ! (2,:)_MSINDO -> (px,:) -> (4,:)_tblite
      ! (3,:)_MSINDO -> (py,:) -> (2,:)_tblite
      ! (4,:)_MSINDO -> (pz,:) -> (3,:)_tblite

      ! x-direction
      trafomat(1,4,3) = SINT*COSP
      trafomat(1,2,3) = SINT*SINP
      trafomat(1,3,3) = COST
      trafomat(1,4,4) = COST*COSP
      trafomat(1,2,4) = COST*SINP
      trafomat(1,3,4) = -SINT
      trafomat(1,4,2) = -SINP
      trafomat(1,2,2) = COSP
      trafomat(1,3,2) = 0.0_wp
      ! y-direction
      trafomat(2,4,3) = SINT*COSPY
      trafomat(2,2,3) = SINT*SINPY
      trafomat(2,3,3) = COST
      trafomat(2,4,4) = COST*COSPY
      trafomat(2,2,4) = COST*SINPY
      trafomat(2,3,4) = -SINT
      trafomat(2,4,2) = -SINPY
      trafomat(2,2,2) = COSPY
      trafomat(2,3,2) = 0.0_wp
      ! z-direction equal to x-direction
      trafomat(3,:,:) = trafomat(1,:,:)

      ! derivative w.r.t. theta (x- or z-direction)
      trafomat_dt(4,3) = COST*COSP
      trafomat_dt(2,3) = COST*SINP
      trafomat_dt(3,3) = -SINT
      trafomat_dt(4,4) = -SINT*COSP
      trafomat_dt(2,4) = -SINT*SINP
      trafomat_dt(3,4) = -COST
      trafomat_dt(4,2) = 0.0_wp
      trafomat_dt(2,2) = 0.0_wp
      trafomat_dt(3,2) = 0.0_wp
      ! y-direction
      trafomat_dty(4,3) = COST*COSPY
      trafomat_dty(2,3) = COST*SINPY
      trafomat_dty(3,3) = -SINT
      trafomat_dty(4,4) = -SINT*COSPY
      trafomat_dty(2,4) = -SINT*SINPY
      trafomat_dty(3,4) = -COST
      trafomat_dty(4,2) = 0.0_wp
      trafomat_dty(2,2) = 0.0_wp
      trafomat_dty(3,2) = 0.0_wp

      ! derivative w.r.t. phi (x- or z-direction)
      trafomat_dp(4,3) = -SINT*SINP
      trafomat_dp(2,3) = SINT*COSP
      trafomat_dp(3,3) = 0.0_wp
      trafomat_dp(4,4) = -COST*SINP
      trafomat_dp(2,4) = COST*COSP
      trafomat_dp(3,4) = 0.0_wp
      trafomat_dp(4,2) = -COSP
      trafomat_dp(2,2) = -SINP
      trafomat_dp(3,2) = 0.0_wp
      ! y-direction
      trafomat_dpy(4,3) = -SINT*SINPY
      trafomat_dpy(2,3) = SINT*COSPY
      trafomat_dpy(3,3) = 0.0_wp
      trafomat_dpy(4,4) = -COST*SINPY
      trafomat_dpy(2,4) = COST*COSPY
      trafomat_dpy(3,4) = 0.0_wp
      trafomat_dpy(4,2) = -COSPY
      trafomat_dpy(2,2) = -SINPY
      trafomat_dpy(3,2) = 0.0_wp
           

      if ( maxl <= 1 ) then 
         dtrafomat(1, 1:4, 1:4) = dpdx * trafomat_dp(1:4, 1:4) + dtdx * trafomat_dt(1:4, 1:4) 
         dtrafomat(2, 1:4, 1:4) = dpdy * trafomat_dpy(1:4, 1:4) + dtdy * trafomat_dty(1:4, 1:4) 
         dtrafomat(3, 1:4, 1:4) = dtdz * trafomat_dt(1:4, 1:4)
         return
      end if

      ! -----------------------------
      !  d functions (trafomat(9x9)) 
      ! -----------------------------

      SQRT3 = SQRT(3.0_wp)
      COS2T = COST**2 - SINT**2
      SIN2T = 2.0_wp * SINT*COST
      COS2P = COSP**2 - SINP**2
      SIN2P = 2.0_wp * SINP*COSP
      COS2PY = COSPY**2 - SINPY**2
      SIN2PY = 2.0_wp * SINPY*COSPY
      
      DCOS2T = -2.0_wp * SIN2T
      DSIN2T =  2.0_wp * COS2T
      DCOS2P = -2.0_wp * SIN2P
      DSIN2P =  2.0_wp * COS2P
      DCOS2PY = -2.0_wp * SIN2PY
      DSIN2PY =  2.0_wp * COS2PY


      ! Changed from MSINDO ordering (0,-1,1,-2,2) to tblite ordering (-2,-1,0,1,2) of d-functions 
      ! (5,:)_MSINDO -> (dz2,:) -> (7,:)_tblite
      ! (6,:)_MSINDO -> (dxz,:) -> (8,:)_tblite
      ! (7,:)_MSINDO -> (dyz,:) -> (6,:)_tblite
      ! (8,:)_MSINDO -> (dx2-y2,:) -> (5,:)_tblite
      ! (9,:)_MSINDO -> (dxy,:) -> (9,:)_tblite
      ! x-direction
      trafomat(1,7,7) = (3.0_wp * COST**2 - 1.0_wp) * 0.5_wp
      trafomat(1,8,7) = SQRT3*SIN2T*COSP*0.5_wp
      trafomat(1,6,7) = SQRT3*SIN2T*SINP*0.5_wp
      trafomat(1,9,7) = SQRT3*SINT**2*COS2P*0.5_wp
      trafomat(1,5,7) = SQRT3*SINT**2*SIN2P*0.5_wp
      trafomat(1,7,8) = -SQRT3*SIN2T*0.5_wp
      trafomat(1,8,8) = COS2T*COSP
      trafomat(1,6,8) = COS2T*SINP
      trafomat(1,9,8) = SIN2T*COS2P*0.5_wp
      trafomat(1,5,8) = SIN2T*SIN2P*0.5_wp
      trafomat(1,7,6) = 0.0_wp
      trafomat(1,8,6) = -COST*SINP
      trafomat(1,6,6) = COST*COSP
      trafomat(1,9,6) = -SINT*SIN2P
      trafomat(1,5,6) = SINT*COS2P
      trafomat(1,7,9) = SQRT3*SINT**2 * 0.5_wp
      trafomat(1,8,9) = -SIN2T*COSP*0.5_wp
      trafomat(1,6,9) = -SIN2T*SINP*0.5_wp
      trafomat(1,9,9) = (1.0_wp + COST**2) * COS2P * 0.5_wp
      trafomat(1,5,9) = (1.0_wp + COST**2) * SIN2P * 0.5_wp
      trafomat(1,7,5) = 0.0_wp
      trafomat(1,8,5) = SINT*SINP
      trafomat(1,6,5) = -SINT*COSP
      trafomat(1,9,5) = -COST*SIN2P
      trafomat(1,5,5) = COST*COS2P
      ! y-direction
      trafomat(2,7,7) = (3.0_wp * COST**2 - 1.0_wp) * 0.5_wp
      trafomat(2,8,7) = SQRT3*SIN2T*COSPY*0.5_wp
      trafomat(2,6,7) = SQRT3*SIN2T*SINPY*0.5_wp
      trafomat(2,9,7) = SQRT3*SINT**2*COS2PY*0.5_wp
      trafomat(2,5,7) = SQRT3*SINT**2*SIN2PY*0.5_wp
      trafomat(2,7,8) = -SQRT3*SIN2T*0.5_wp
      trafomat(2,8,8) = COS2T*COSPY
      trafomat(2,6,8) = COS2T*SINPY
      trafomat(2,9,8) = SIN2T*COS2PY*0.5_wp
      trafomat(2,5,8) = SIN2T*SIN2PY*0.5_wp
      trafomat(2,7,6) = 0.0_wp
      trafomat(2,8,6) = -COST*SINPY
      trafomat(2,6,6) = COST*COSPY
      trafomat(2,9,6) = -SINT*SIN2PY
      trafomat(2,5,6) = SINT*COS2PY
      trafomat(2,7,9) = SQRT3*SINT**2 * 0.5_wp
      trafomat(2,8,9) = -SIN2T*COSPY*0.5_wp
      trafomat(2,6,9) = -SIN2T*SINPY*0.5_wp
      trafomat(2,9,9) = (1.0_wp + COST**2) * COS2PY * 0.5_wp
      trafomat(2,5,9) = (1.0_wp + COST**2) * SIN2PY * 0.5_wp
      trafomat(2,7,5) = 0.0_wp
      trafomat(2,8,5) = SINT*SINPY
      trafomat(2,6,5) = -SINT*COSPY
      trafomat(2,9,5) = -COST*SIN2PY
      trafomat(2,5,5) = COST*COS2PY
      ! z-direction
      trafomat(3,:,:) = trafomat(1,:,:)
      
      ! derivative w.r.t. theta (x- or z-direction)
      trafomat_dt(7,7) = -3.0_wp*SIN2T*0.5_wp
      trafomat_dt(8,7) = SQRT3*DSIN2T*COSP*0.5_wp
      trafomat_dt(6,7) = SQRT3*DSIN2T*SINP*0.5_wp
      trafomat_dt(9,7) = SQRT3*SIN2T*COS2P*0.5_wp
      trafomat_dt(5,7) = SQRT3*SIN2T*SIN2P*0.5_wp
      trafomat_dt(7,8) = -SQRT3*DSIN2T*0.5_wp
      trafomat_dt(8,8) = DCOS2T*COSP
      trafomat_dt(6,8) = DCOS2T*SINP
      trafomat_dt(9,8) = DSIN2T*COS2P*0.5_wp
      trafomat_dt(5,8) = DSIN2T*SIN2P*0.5_wp
      trafomat_dt(7,6) = 0.0_wp
      trafomat_dt(8,6) = SINT*SINP
      trafomat_dt(6,6) = -SINT*COSP
      trafomat_dt(9,6) = -COST*SIN2P
      trafomat_dt(5,6) = COST*COS2P
      trafomat_dt(7,9) = SQRT3*SIN2T*0.5_wp
      trafomat_dt(8,9) = -DSIN2T*COSP*0.5_wp
      trafomat_dt(6,9) = -DSIN2T*SINP*0.5_wp
      trafomat_dt(9,9) = -SIN2T*COS2P*0.5_wp
      trafomat_dt(5,9) = -SIN2T*SIN2P*0.5_wp
      trafomat_dt(7,5) = 0.0_wp
      trafomat_dt(8,5) = COST*SINP
      trafomat_dt(6,5) = -COST*COSP
      trafomat_dt(9,5) = SINT*SIN2P
      trafomat_dt(5,5) = -SINT*COS2P
      ! y-direction
      trafomat_dty(7,7) = -3.0_wp*SIN2T*0.5_wp
      trafomat_dty(8,7) = SQRT3*DSIN2T*COSPY*0.5_wp
      trafomat_dty(6,7) = SQRT3*DSIN2T*SINPY*0.5_wp
      trafomat_dty(9,7) = SQRT3*SIN2T*COS2PY*0.5_wp
      trafomat_dty(5,7) = SQRT3*SIN2T*SIN2PY*0.5_wp
      trafomat_dty(7,8) = -SQRT3*DSIN2T*0.5_wp
      trafomat_dty(8,8) = DCOS2T*COSPY
      trafomat_dty(6,8) = DCOS2T*SINPY
      trafomat_dty(9,8) = DSIN2T*COS2PY*0.5_wp
      trafomat_dty(5,8) = DSIN2T*SIN2PY*0.5_wp
      trafomat_dty(7,6) = 0.0_wp
      trafomat_dty(8,6) = SINT*SINPY
      trafomat_dty(6,6) = -SINT*COSPY
      trafomat_dty(9,6) = -COST*SIN2PY
      trafomat_dty(5,6) = COST*COS2PY
      trafomat_dty(7,9) = SQRT3*SIN2T*0.5_wp
      trafomat_dty(8,9) = -DSIN2T*COSPY*0.5_wp
      trafomat_dty(6,9) = -DSIN2T*SINPY*0.5_wp
      trafomat_dty(9,9) = -SIN2T*COS2PY*0.5_wp
      trafomat_dty(5,9) = -SIN2T*SIN2PY*0.5_wp
      trafomat_dty(7,5) = 0.0_wp
      trafomat_dty(8,5) = COST*SINPY
      trafomat_dty(6,5) = -COST*COSPY
      trafomat_dty(9,5) = SINT*SIN2PY
      trafomat_dty(5,5) = -SINT*COS2PY

      ! derivative w.r.t. phi (x- or z-direction)
      trafomat_dp(7,7) = 0.0_wp
      trafomat_dp(8,7) = -SQRT3*SIN2T*SINP*0.5_wp
      trafomat_dp(6,7) = SQRT3*SIN2T*COSP*0.5_wp
      trafomat_dp(9,7) = SQRT3*SINT**2*DCOS2P*0.5_wp
      trafomat_dp(5,7) = SQRT3*SINT**2*DSIN2P*0.5_wp
      trafomat_dp(7,8) = 0.0_wp
      trafomat_dp(8,8) = -COS2T*SINP
      trafomat_dp(6,8) = COS2T*COSP
      trafomat_dp(9,8) = SIN2T*DCOS2P*0.5_wp
      trafomat_dp(5,8) = SIN2T*DSIN2P*0.5_wp
      trafomat_dp(7,6) = 0.0_wp
      trafomat_dp(8,6) = -COST*COSP
      trafomat_dp(6,6) = -COST*SINP
      trafomat_dp(9,6) = -SINT*DSIN2P
      trafomat_dp(5,6) = SINT*DCOS2P
      trafomat_dp(7,9) = 0.0_wp
      trafomat_dp(8,9) = SIN2T*SINP*0.5_wp
      trafomat_dp(6,9) = -SIN2T*COSP*0.5_wp
      trafomat_dp(9,9) = (1.0+COST**2)*DCOS2P*0.5_wp
      trafomat_dp(5,9) = (1.0+COST**2)*DSIN2P*0.5_wp
      trafomat_dp(7,5) = 0.0_wp
      trafomat_dp(8,5) = SINT*COSP
      trafomat_dp(6,5) = SINT*SINP
      trafomat_dp(9,5) = -COST*DSIN2P
      trafomat_dp(5,5) = COST*DCOS2P
      ! y-direction
      trafomat_dpy(7,7) = 0.0_wp
      trafomat_dpy(8,7) = -SQRT3*SIN2T*SINP*0.5_wp
      trafomat_dpy(6,7) = SQRT3*SIN2T*COSP*0.5_wp
      trafomat_dpy(9,7) = SQRT3*SINT**2*DCOS2P*0.5_wp
      trafomat_dpy(5,7) = SQRT3*SINT**2*DSIN2P*0.5_wp
      trafomat_dpy(7,8) = 0.0_wp
      trafomat_dpy(8,8) = -COS2T*SINP
      trafomat_dpy(6,8) = COS2T*COSP
      trafomat_dpy(9,8) = SIN2T*DCOS2P*0.5_wp
      trafomat_dpy(5,8) = SIN2T*DSIN2P*0.5_wp
      trafomat_dpy(7,6) = 0.0_wp
      trafomat_dpy(8,6) = -COST*COSP
      trafomat_dpy(6,6) = -COST*SINP
      trafomat_dpy(9,6) = -SINT*DSIN2P
      trafomat_dpy(5,6) = SINT*DCOS2P
      trafomat_dpy(7,9) = 0.0_wp
      trafomat_dpy(8,9) = SIN2T*SINP*0.5_wp
      trafomat_dpy(6,9) = -SIN2T*COSP*0.5_wp
      trafomat_dpy(9,9) = (1.0+COST**2)*DCOS2P*0.5_wp
      trafomat_dpy(5,9) = (1.0+COST**2)*DSIN2P*0.5_wp
      trafomat_dpy(7,5) = 0.0_wp
      trafomat_dpy(8,5) = SINT*COSP
      trafomat_dpy(6,5) = SINT*SINP
      trafomat_dpy(9,5) = -COST*DSIN2P
      trafomat_dpy(5,5) = COST*DCOS2P

      if ( maxl <= 2 ) then 
         ! Transform to cartesian coordinates
         dtrafomat(1, 1:9, 1:9) = dpdx * trafomat_dp(1:9, 1:9) + dtdx * trafomat_dt(1:9, 1:9)
         dtrafomat(2, 1:9, 1:9) = dpdy * trafomat_dpy(1:9, 1:9) + dtdy * trafomat_dty(1:9, 1:9)
         dtrafomat(3, 1:9, 1:9) = dtdz * trafomat_dt(1:9, 1:9)
         return
      end if

      ! -------------------------------
      !  f functions (trafomat(16x16)) 
      ! -------------------------------

      ! f-functions are not transformed to the diatomic frame!
      ! Hence, the derivative remains 0!
      trafomat(:,10,10) = 1.0_wp
      trafomat(:,11,11) = 1.0_wp
      trafomat(:,12,12) = 1.0_wp
      trafomat(:,13,13) = 1.0_wp
      trafomat(:,14,14) = 1.0_wp
      trafomat(:,15,15) = 1.0_wp
      trafomat(:,16,16) = 1.0_wp

      if ( maxl <= 3 ) then 
         ! Transform to cartesian coordinates
         dtrafomat(1, 1:16, 1:16) = dpdx * trafomat_dp(1:16, 1:16) + dtdx * trafomat_dt(1:16, 1:16)
         dtrafomat(2, 1:16, 1:16) = dpdy * trafomat_dpy(1:16, 1:16) + dtdy * trafomat_dty(1:16, 1:16)
         dtrafomat(3, 1:16, 1:16) = dtdz * trafomat_dt(1:16, 1:16)
         return
      end if

      ! -------------------------------
      !  g functions (trafomat(25x25)) 
      ! -------------------------------

      ! g-functions are not transformed to the diatomic frame!
      ! Hence, the derivative remains 0!
      trafomat(:,17,17) = 1.0_wp
      trafomat(:,18,18) = 1.0_wp
      trafomat(:,19,19) = 1.0_wp
      trafomat(:,20,20) = 1.0_wp
      trafomat(:,21,21) = 1.0_wp
      trafomat(:,22,22) = 1.0_wp
      trafomat(:,23,23) = 1.0_wp
      trafomat(:,24,24) = 1.0_wp
      trafomat(:,25,25) = 1.0_wp

      if ( maxl <= 4 ) then 
         ! Transform to cartesian coordinates
         dtrafomat(1, 1:25, 1:25) = dpdx * trafomat_dp(1:25, 1:25) + dtdx * trafomat_dt(1:25, 1:25)
         dtrafomat(2, 1:25, 1:25) = dpdy * trafomat_dpy(1:25, 1:25) + dtdy * trafomat_dty(1:25, 1:25)
         dtrafomat(3, 1:25, 1:25) = dtdz * trafomat_dt(1:25, 1:25)
         return
      end if

   end subroutine d_harmtr

   pure subroutine scale_diatomic_frame(diat_mat, ksig, kpi, kdel, maxlj, maxli)
      !> Block matrix in the diatomic frame to be scaled
      real(wp),intent(inout)    :: diat_mat(:,:)
      !> Scaling parameters for different bonding contributions
      real(wp),intent(in)       :: ksig, kpi, kdel
      !> Highest angular momentum of atom j (first index)
      integer,intent(in)        :: maxlj
      !> Highest angular momentum of atom i (second index)
      integer,intent(in)        :: maxli

      integer :: maxl

      maxl = max(maxlj, maxli)

      diat_mat(1,1) = diat_mat(1,1)*ksig ! Sigma bond s   <-> s
      if(maxlj > 0) then
         diat_mat(3,1) = diat_mat(3,1)*ksig ! Sigma bond pz  <-> s 
      end if
      if(maxli > 0)  then
         diat_mat(1,3) = diat_mat(1,3)*ksig ! Sigma bond s   <-> pz
      end if
      if(maxlj > 0 .and. maxli > 0) then 
         diat_mat(3,3) = diat_mat(3,3)*ksig ! Sigma bond pz  <-> pz
         diat_mat(4,4) = diat_mat(4,4)*kpi  ! Pi    bond px  <-> px
         diat_mat(2,2) = diat_mat(2,2)*kpi  ! Pi    bond py  <-> py
         if(maxlj > 1) then
            diat_mat(7,3) = diat_mat(7,3)*ksig ! Sigma bond dz2 <-> pz
            diat_mat(8,4) = diat_mat(8,4)*kpi  ! Pi    bond dxz <-> px
            diat_mat(6,2) = diat_mat(6,2)*kpi  ! Pi    bond dyz <-> py
         end if
         if(maxli > 1) then         
            diat_mat(3,7) = diat_mat(3,7)*ksig ! Sigma bond pz  <-> dz2
            diat_mat(4,8) = diat_mat(4,8)*kpi  ! Pi    bond px  <-> dxz
            diat_mat(2,6) = diat_mat(2,6)*kpi  ! Pi    bond py  <-> dyz
         end if
      end if
      if (maxlj > 1) then
         diat_mat(7,1) = diat_mat(7,1)*ksig ! Sigma bond dz2 <-> s
      end if
      if (maxli > 1) then
         diat_mat(1,7) = diat_mat(1,7)*ksig ! Sigma bond s   <-> dz2   
      end if
      if (maxlj > 1 .and. maxli > 1) then
         diat_mat(7,7) = diat_mat(7,7)*ksig ! Sigma bond dz2 <-> dz2
         diat_mat(8,8) = diat_mat(8,8)*kpi  ! Pi    bond dxz <-> dxz
         diat_mat(6,6) = diat_mat(6,6)*kpi  ! Pi    bond dyz <-> dyz
         diat_mat(9,9) = diat_mat(9,9)*kdel ! Delta bond dx2-y2 <-> dx2-y2
         diat_mat(5,5) = diat_mat(5,5)*kdel ! Delta bond dxy <-> dxy
      endif
      ! f- and g-functions remain unscaled

   end subroutine scale_diatomic_frame

end module tblite_integral_diat_trafo

program tester
  use, intrinsic :: iso_fortran_env, only : error_unit
  use testdrive, only : run_testsuite, new_testsuite, testsuite_type
  implicit none
  integer :: stat, is
  type(testsuite_type), allocatable :: testsuites(:)
  character(len=*), parameter :: fmt = '("#", *(1x, a))'

  stat = 0

  allocate(testsuites(0))

  do is = 1, size(testsuites)
    write(error_unit, fmt) "Testing:", testsuites(is)%name
    call run_testsuite(testsuites(is)%collect, error_unit, stat)
  end do

  if (stat > 0) then
    write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
    error stop
  end if

end program tester

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the driver entry points for the singlepoint runner
module tblite_driver_run
   use, intrinsic :: iso_fortran_env, only : output_unit, error_unit, input_unit
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_io, only : structure_type, read_structure, filetype
   use mctc_io_constants, only : codata
   use mctc_io_convert, only : aatoau, ctoau
   use tblite_cli, only : run_config
   use tblite_basis_type, only : basis_type
   use tblite_container, only : container_type
   use tblite_context, only : context_type, context_terminal, escape
   use tblite_data_spin, only : get_spin_constant
   use tblite_external_field, only : electric_field
   use tblite_io_molden, only : save_molden
   use tblite_io_trexio, only : save_trexio
   use tblite_lapack_solver, only : lapack_solver
   use tblite_output_ascii, only : ascii_levels, ascii_dipole_moments, &
      & ascii_quadrupole_moments, tagged_result, json_results
   use tblite_param, only : param_record
   use tblite_results, only : results_type
   use tblite_scf_mixer_input, only : anneal_input
   use tblite_spin, only : spin_polarization, new_spin_polarization
   use tblite_solvation, only : new_solvation, new_solvation_cds, new_solvation_shift, solvation_type
   use tblite_wavefunction, only : wavefunction_type, new_wavefunction, &
      & sad_guess, eeq_guess, eeqbc_guess, shell_partition, &
      & load_wavefunction, save_wavefunction
   use tblite_xtb_calculator, only : xtb_calculator, new_xtb_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator, export_gfn2_param
   use tblite_xtb_gfn1, only : new_gfn1_calculator, export_gfn1_param
   use tblite_xtb_ipea1, only : new_ipea1_calculator, export_ipea1_param
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   use tblite_ceh_singlepoint, only : ceh_singlepoint
   use tblite_ceh_ceh, only : new_ceh_calculator
   use tblite_post_processing_list, only : add_post_processing, post_processing_list

   implicit none
   private

   public :: main

   interface main
      module procedure :: run_main
   end interface

   real(wp), parameter :: kt = 3.166808578545117e-06_wp
   real(wp), parameter :: jtoau = 1.0_wp / (codata%me*codata%c**2*codata%alpha**2)
   !> Convert V/Å = J/(C·Å) to atomic units
   real(wp), parameter :: vatoau = jtoau / (ctoau * aatoau)
   character(len=:), allocatable :: wbo_label, molmom_label

contains


subroutine run_main(config, error)
   type(run_config), intent(in) :: config
   type(error_type), allocatable, intent(out) :: error

   type(structure_type) :: mol
   character(len=:), allocatable :: method, filename
   integer :: unpaired, charge, unit, nspin, etemp_hold, etemp_steps
   logical :: restart_exist, use_guess
   real(wp) :: energy
   real(wp), allocatable :: dpmom(:), qpmom(:)
   real(wp), allocatable :: gradient(:, :), sigma(:, :)
   type(param_record) :: param
   type(context_type) :: ctx
   type(xtb_calculator) :: calc
   type(xtb_calculator) :: calc_ceh
   type(wavefunction_type) :: wfn, wfn_ceh
   type(results_type) :: results
   class(post_processing_list), allocatable :: post_proc

   ctx%terminal = context_terminal(config%color)
   ctx%solver = lapack_solver(config%solver)

   if (config%input == "-") then
      if (allocated(config%input_format)) then
         call read_structure(mol, input_unit, config%input_format, error)
      else
         call read_structure(mol, input_unit, filetype%xyz, error)
      end if
   else
      call read_structure(mol, config%input, error, config%input_format)
   end if
   if (allocated(error)) return

   if (allocated(config%charge)) then
      mol%charge = config%charge
   else
      filename = join(dirname(config%input), ".CHRG")
      if (exists(filename)) then
         call read_file(filename, charge, error)
         if (allocated(error)) return
         if (config%verbosity > 0) &
            & call info(ctx, "Molecular charge read from '"//filename//"'")
         mol%charge = charge
      end if
   end if
   if (allocated(error)) return

   if (allocated(config%spin)) then
      mol%uhf = config%spin
   else
      filename = join(dirname(config%input), ".UHF")
      if (exists(filename)) then
         call read_file(filename, unpaired, error)
         if (allocated(error)) return
         if (config%verbosity > 0) &
            & call info(ctx, "Molecular spin read from '"//filename//"'")
         mol%uhf = unpaired
      end if
   end if

   nspin = merge(2, 1, config%spin_polarized)

   if (config%grad) then
      allocate(gradient(3, mol%nat), sigma(3, 3))
   end if
   
   if (allocated(error)) return

   if (allocated(config%param)) then
      call param%load(config%param, error)
      if (.not. allocated(error)) then
         call new_xtb_calculator(calc, mol, param, error, config%cfg)
      end if
   else
      method = "gfn2"
      if (allocated(config%method)) method = config%method
      select case(method)
      case default
         call fatal_error(error, "Unknown method '"//method//"' requested")
      case("gfn2")
         call new_gfn2_calculator(calc, mol, error, config%cfg)
      case("gfn1")
         call new_gfn1_calculator(calc, mol, error, config%cfg)
      case("ipea1")
         call new_ipea1_calculator(calc, mol, error, config%cfg)
      end select
   end if
   if (allocated(error)) return

   calc%mixer_input = config%mixer

   use_guess = .true.
   restart_exist = .false.
   if (config%restart) restart_exist = exists(config%restart_file)
   if (restart_exist) then
      call load_wavefunction(wfn, config%restart_file, error, &
         & nat=mol%nat, nsh=calc%bas%nsh, nao=calc%bas%nao, nspin=nspin)
      if (allocated(error)) then
         call warn(ctx, error%message)
         deallocate(error)
         call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, nspin, config%etemp * kt)
      else
         call info(ctx, "Restarting from wavefunction '"//config%restart_file//"'")
         use_guess = .false.
      end if
      wfn%kt = config%etemp * kt
   else
      call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, nspin, config%etemp * kt)
   end if

   if (use_guess .and. config%guess == "ceh") then
      call new_ceh_calculator(calc_ceh, mol, error)
      if (allocated(error)) return
      call new_wavefunction(wfn_ceh, mol%nat, calc_ceh%bas%nsh, calc_ceh%bas%nao, 1, config%etemp_guess * kt)
   end if

   if (allocated(config%efield)) then
      block
         class(container_type), allocatable :: cont
         cont = electric_field(config%efield*vatoau)
         call calc%push_back(cont)
      end block
      if (use_guess .and. config%guess == "ceh") then
         block
         class(container_type), allocatable :: cont
         cont = electric_field(config%efield*vatoau)
         call calc_ceh%push_back(cont)
         end block
      end if
   end if

   if (use_guess) then
      select case(config%guess)
      case default
         call fatal_error(error, "Unknown starting guess '"//config%guess//"' requested")
      case("sad")
         call sad_guess(mol, calc, wfn)
      case("eeq")
         call eeq_guess(mol, calc, wfn, error)
      case("eeqbc")
         call eeqbc_guess(mol, calc, wfn, error)
      case("ceh")
         call ceh_singlepoint(ctx, calc_ceh, mol, wfn_ceh, config%accuracy, config%verbosity)
         if (ctx%failed()) then
            call fatal(ctx, "CEH singlepoint calculation failed")
            do while(ctx%failed())
               call ctx%get_error(error)
               write(error_unit, '("->", 1x, a)') error%message
            end do
            error stop
         end if
         wfn%qat(:, 1) = wfn_ceh%qat(:, 1)
         call shell_partition(mol, calc, wfn)
      end select
   end if
   if (allocated(error)) return

   if (config%spin_polarized) then
      block
         class(container_type), allocatable :: cont
         type(spin_polarization), allocatable :: spin
         real(wp), allocatable :: wll(:, :, :)
         allocate(spin)
         call get_spin_constants(wll, mol, calc%bas)
         call new_spin_polarization(spin, mol, wll, calc%bas%nsh_id)
         call move_alloc(spin, cont)
         call calc%push_back(cont)
      end block
   end if

   if (allocated(config%solvation)) then
      method = "gfn2"
      if (allocated(config%method)) method = config%method
      block
         class(container_type), allocatable :: cont
         class(solvation_type), allocatable :: solv
         call new_solvation(solv, mol, config%solvation, error, method)
         if (allocated(error)) return
         call move_alloc(solv, cont)
         call calc%push_back(cont)
      end block
      if (allocated(config%solvation%cds)) then
         block
            class(container_type), allocatable :: cont
            class(solvation_type), allocatable :: cds
            call new_solvation_cds(cds, mol, config%solvation, error, method)
            if (allocated(error)) return
            call move_alloc(cds, cont)
            call calc%push_back(cont)
         end block
      end if
      if (allocated(config%solvation%shift)) then
         block
            class(container_type), allocatable :: cont
            class(solvation_type), allocatable :: shift
            call new_solvation_shift(shift, config%solvation, error, method)
            if (allocated(error)) return
            call move_alloc(shift, cont)
            call calc%push_back(cont)
         end block
      end if
   end if

   wbo_label = "bond-orders"
   allocate(post_proc)
   call add_post_processing(post_proc, mol, wbo_label, error)
   if (allocated(error)) return

   if (config%verbosity > 2) then
      molmom_label = "molmom"
      call add_post_processing(post_proc, mol, molmom_label, error)
      if (allocated(error)) return
   end if

   if (allocated(config%post_processing)) then
      call add_post_processing(post_proc, mol, config%post_processing, error)
      if (allocated(error)) return
   end if

   if (allocated(param%post_proc)) then
      call add_post_processing(post_proc, mol, param%post_proc, error)
      if (allocated(error)) return
   end if

   if (config%verbosity > 0) then
      call ctx%message(calc%info(config%verbosity, " | "))
      call ctx%message("")
   end if

   call xtb_singlepoint(ctx, mol, calc, wfn, config%accuracy, energy, gradient, sigma, &
      & config%verbosity, results, post_proc)
   if (ctx%failed()) then
      call fatal(ctx, "Singlepoint calculation failed")
      do while(ctx%failed())
         call ctx%get_error(error)
         write(error_unit, '("->", 1x, a)') error%message
      end do
      error stop
   end if

   if (allocated(config%restart_file)) then
      call info(ctx, "Writing wavefunction information to '"//config%restart_file//"'")
      call save_wavefunction(wfn, config%restart_file, error)
      if (allocated(error)) return
   end if

   if (allocated(post_proc) .and. allocated(config%post_proc_output)) then
      call results%dict%dump(config%post_proc_output, error)
      if (allocated(error)) return
   end if

   if (config%verbosity > 2) then
      call ascii_levels(ctx%unit, config%verbosity, wfn%emo, wfn%focc, 7)
      call results%dict%get_entry("molecular-dipole", dpmom)
      call results%dict%get_entry("molecular-quadrupole", qpmom)
      
      call ascii_dipole_moments(ctx%unit, 1, mol, wfn%dpat(:, :, 1), dpmom)
      call ascii_quadrupole_moments(ctx%unit, 1, mol, wfn%qpat(:, :, 1), qpmom)
   end if

   deallocate(post_proc)

   if (allocated(config%grad_output)) then
      open(file=config%grad_output, newunit=unit)
      call tagged_result(unit, energy, gradient, sigma, energies=results%energies)
      close(unit)
      if (config%verbosity > 0) then
         call info(ctx, "Tight-binding results written to '"//config%grad_output//"'")
      end if
   end if

   if (config%json) then
      open(file=config%json_output, newunit=unit)
      call json_results(unit, "  ", energy=energy, gradient=gradient, sigma=sigma, &
         & energies=results%energies)
      close(unit)
      if (config%verbosity > 0) then
         call info(ctx, "JSON dump of results written to '"//config%json_output//"'")
      end if
   end if

   if (config%trexio) then
      call save_trexio(config%trexio_output, mol, calc%bas, wfn, energy, error)
      if (allocated(error)) return
      if (config%verbosity > 0) then
         call info(ctx, "TREXIO output written to '"//config%trexio_output//"'")
      end if
   end if

   if (config%molden) then
      call save_molden(config%molden_output, mol, calc%bas, wfn, error)
      if (allocated(error)) return
      if (config%verbosity > 0) then
         call info(ctx, "Molden file written to '"//config%molden_output//"'")
      end if
   end if

end subroutine run_main


subroutine info(ctx, message)
   type(context_type), intent(inout) :: ctx
   character(len=*), intent(in) :: message

   call ctx%message( &
      & escape(ctx%terminal%bold) // "[" // &
      & escape(ctx%terminal%bold_cyan) // "Info" // &
      & escape(ctx%terminal%bold) // "]" // &
      & escape(ctx%terminal%reset) // " " // &
      & message)
end subroutine info


subroutine warn(ctx, message)
   type(context_type), intent(inout) :: ctx
   character(len=*), intent(in) :: message

   call ctx%message( &
      & escape(ctx%terminal%bold) // "[" // &
      & escape(ctx%terminal%bold_yellow) // "Warn" // &
      & escape(ctx%terminal%bold) // "]" // &
      & escape(ctx%terminal%reset) // " " // &
      & message)
end subroutine warn


subroutine fatal(ctx, message)
   type(context_type), intent(inout) :: ctx
   character(len=*), intent(in) :: message

   call ctx%message( &
      & escape(ctx%terminal%bold) // "[" // &
      & escape(ctx%terminal%bold_red) // "Fatal" // &
      & escape(ctx%terminal%bold) // "]" // &
      & escape(ctx%terminal%reset) // " " // &
      & message)
end subroutine fatal


subroutine get_spin_constants(wll, mol, bas)
   real(wp), allocatable, intent(out) :: wll(:, :, :)
   type(structure_type), intent(in) :: mol
   type(basis_type), intent(in) :: bas

   integer :: izp, ish, jsh, il, jl

   allocate(wll(bas%nsh, bas%nsh, mol%nid), source=0.0_wp)

   do izp = 1, mol%nid
      do ish = 1, bas%nsh_id(izp)
         il = bas%cgto(ish, izp)%ang
         do jsh = 1, bas%nsh_id(izp)
            jl = bas%cgto(jsh, izp)%ang
            wll(jsh, ish, izp) = get_spin_constant(jl, il, mol%num(izp))
         end do
      end do
   end do
end subroutine get_spin_constants


!> Extract dirname from path
function dirname(filename)
   character(len=*), intent(in) :: filename
   character(len=:), allocatable :: dirname

   dirname = filename(1:scan(filename, "/\", back=.true.))
   if (len_trim(dirname) == 0) dirname = "."
end function dirname


!> Construct path by joining strings with os file separator
function join(a1, a2) result(path)
   use mctc_env_system, only : is_windows
   character(len=*), intent(in) :: a1, a2
   character(len=:), allocatable :: path
   character :: filesep

   if (is_windows()) then
      filesep = '\'
   else
      filesep = '/'
   end if

   path = a1 // filesep // a2
end function join


!> test if pathname already exists
function exists(filename)
    character(len=*), intent(in) :: filename
    logical :: exists
    inquire(file=filename, exist=exists)
end function exists


subroutine read_file(filename, val, error)
   use mctc_io_utils, only : next_line, read_next_token, io_error, token_type
   character(len=*), intent(in) :: filename
   integer, intent(out) :: val
   type(error_type), allocatable, intent(out) :: error

   integer :: io, stat, lnum, pos
   type(token_type) :: token
   character(len=:), allocatable :: line

   lnum = 0

   open(file=filename, newunit=io, status='old', iostat=stat)
   if (stat /= 0) then
      call fatal_error(error, "Error: Could not open file '"//filename//"'")
      return
   end if

   call next_line(io, line, pos, lnum, stat)
   if (stat == 0) &
      call read_next_token(line, pos, token, val, stat)
   if (stat /= 0) then
      call io_error(error, "Cannot read value from file", line, token, &
         filename, lnum, "expected integer value")
      return
   end if

   close(io, iostat=stat)

end subroutine read_file


end module tblite_driver_run

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

!> @file tblite/wavefunction/fermi.f90
!> Provides a Fermi based electronic filling function

!> Implementation of a Fermi distribution for filling the electronic levels
module tblite_wavefunction_fermi
   use mctc_env, only : wp
   implicit none
   private

   public :: get_fermi_filling


contains

subroutine get_fermi_filling(nel, kt, emo, homo, focc, e_fermi)
   real(wp), intent(in) :: nel
   real(wp), intent(in) :: emo(:)
   real(wp), intent(in) :: kt
   integer, intent(out) :: homo
   real(wp), intent(out) :: focc(:)
   real(wp), intent(out) :: e_fermi

   real(wp) :: etmp

   e_fermi = 0.0_wp

   call get_aufbau_filling(nel, homo, focc)

   if (homo > 0) then
      call get_fermi_filling_(homo, kt, emo, focc, etmp)
      e_fermi = 0.5_wp * etmp
   end if

end subroutine get_fermi_filling

subroutine get_aufbau_filling(nel, homo, occ)
   real(wp), intent(in) :: nel
   integer, intent(out) :: homo
   real(wp), intent(out) :: occ(:)

   occ(:) = 0.0_wp
   homo = floor(nel)
   occ(:min(homo, size(occ))) = 1.0_wp
   if (homo < size(occ)) occ(homo+1) = mod(nel, 1.0_wp)
   homo = merge(homo+1, homo, mod(nel, 1.0_wp) > 0.5_wp)
end subroutine get_aufbau_filling

subroutine get_fermi_filling_(homo, kt, emo, occ, e_fermi)
   integer, intent(in) :: homo
   real(wp), intent(in) :: emo(:)
   real(wp), intent(in) :: kt
   real(wp), intent(out) :: occ(:)
   real(wp), intent(out) :: e_fermi

   real(wp) :: occt, total_number
   real(wp) :: total_dfermi, dfermifunct, fermifunct, change_fermi
   integer, parameter :: max_cycle = 200
   real(wp), parameter :: thr = sqrt(epsilon(1.0_wp))
   real(wp), parameter :: sqrttiny = sqrt(tiny(1.0_wp))
   integer :: ncycle, iao

   e_fermi = 0.5*(emo(max(homo, 1))+emo(min(homo+1, size(emo))))
   occt = homo

   do ncycle = 1, max_cycle
      total_number = 0.0
      total_dfermi = 0.0
      do iao = 1, size(emo)
         fermifunct = 0.0
         if((emo(iao)-e_fermi)/kt.lt.50) then
            fermifunct = 1.0/(exp((emo(iao)-e_fermi)/kt)+1.0)
            dfermifunct = exp((emo(iao)-e_fermi)/kt) / &
               & (kt*(exp((emo(iao)-e_fermi)/kt)+1.0)**2)
         else
            dfermifunct = 0.0
         end if
         occ(iao) = fermifunct
         total_number = total_number + fermifunct
         total_dfermi = total_dfermi + dfermifunct
      end do
      if (total_dfermi > sqrttiny) then
          change_fermi = (occt-total_number)/total_dfermi
      else
          change_fermi = 0.0_wp
      end if
      e_fermi = e_fermi+change_fermi
      if (abs(occt-total_number) <= thr) exit
   end do

end subroutine get_fermi_filling_

end module tblite_wavefunction_fermi

!> Defines a simple dependency type to express requirements of a project.
module demo_requirements
  use demo_error, only : error_type, fatal_error
  use tomlf, only : toml_table, toml_key, get_value, set_value
  implicit none
  private

  public :: requirement_type, new_requirement, new_requirements

  !> Declaration of a dependency
  type :: requirement_type
    !> Name to identify dependency
    character(len=:), allocatable :: name
    ! ... further declaration of entries
  end type requirement_type

contains

  !> Create a new list of requirements from a table
  subroutine new_requirements(error, table, req)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    !> TOML data structure
    type(toml_table), intent(inout) :: table
    !> List of all dependencies
    type(requirement_type), allocatable, intent(out) :: req(:)

    integer :: ikey
    type(toml_key), allocatable :: list(:)
    type(toml_table), pointer :: child
    type(toml_table), allocatable, target :: dummy
    character(len=:), allocatable :: version

    ! Get all entries of current table, the `list` is guaranteed to be allocated
    call table%get_keys(list)
    allocate(req(size(list)))

    do ikey = 1, size(list)
      call get_value(table, list(ikey), child)

      ! Not providing a subtable is okay if a string provides the version constraint
      if (.not. associated(child)) then
        call get_value(table, list(ikey), version)
        if (.not.allocated(version)) then
          call fatal_error(error, "Requirement '"//list(ikey)%key//&
            & "' must be version constraint or subtable")
          exit
        end if

        ! Create a dummy table we can reference when initializing
        dummy = toml_table()
        call set_value(dummy, "version", version)
        child => dummy
      end if

      ! Initialize dependency from subtable
      call new_requirement(error, child, req(ikey), list(ikey)%key)

      ! Cleanup, alternatively the dummy could be pushed back into the main table
      if (allocated(dummy)) deallocate(dummy)
      ! Leave loop in case of error
      if (allocated(error)) exit
    end do
    ! Requirements are in a half-finished state, invalidate them to avoid confusion
    if (allocated(error)) deallocate(req)
  end subroutine new_requirements

  !> Initialize a dependency from a TOML data structure
  subroutine new_requirement(error, table, req, name)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    !> TOML data structure
    type(toml_table), intent(inout) :: table
    !> New dependency object
    type(requirement_type), intent(out) :: req
    !> Name of the dependency
    character(len=*), intent(in) :: name

    req%name = name
    ! ... further reading of entries
  end subroutine new_requirement

end module demo_requirements

! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Central registry for error codes
module mctc_env_error
   implicit none
   private

   public :: mctc_stat, error_type
   public :: fatal_error


   !> Possible error codes
   type :: enum_stat

      !> Successful run
      integer :: success = 0

      !> Internal error:
      integer :: fatal = 1

   end type enum_stat

   !> Actual enumerator for return states
   type(enum_stat), parameter :: mctc_stat = enum_stat()


   !> Error message
   type :: error_type

      !> Error code
      integer :: stat

      !> Payload of the error
      character(len=:), allocatable :: message

   end type error_type


contains


!> A fatal error is encountered
subroutine fatal_error(error, message, stat)

   !> Instance of the error
   type(error_type), allocatable, intent(out) :: error

   !> A detailed message describing the error and (optionally) offering advice
   character(len=*), intent(in), optional :: message

   !> Overwrite of the error code
   integer, intent(in), optional :: stat

   allocate(error)

   if (present(stat)) then
      error%stat = stat
   else
      error%stat = mctc_stat%fatal
   end if

   if (present(message)) then
      error%message = message
   else
      error%message = "Fatal error"
   end if

end subroutine fatal_error


end module mctc_env_error

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file src/ddx_driver.f90
!! Main ddx driver.
!!
!! @version 1.0.0
!! @author Aleksandr Mikhalev
!! @date 2021-02-25

!> Standalone application of ddX: this program can compute the solvation
!! energy and forces for a solute made of point charges. All the
!! relevant steps are here outlined.
program main
use ddx
use ddx_multipolar_solutes
use omp_lib
implicit none

character(len=255) :: fname
character(len=2047) :: banner
type(ddx_type) :: ddx_data
type(ddx_state_type) :: state
type(ddx_error_type) :: ddx_error
type(ddx_electrostatics_type) :: electrostatics
real(dp), allocatable :: psi(:, :), force(:, :), charges(:), &
    & multipoles(:, :)
real(dp) :: tol, esolv, start_time, finish_time
integer :: i, isph, info
100 format(1X,A,ES11.4E2,A)
200 format(1X,A,I4,A,ES21.14)
300 format(1X,A,I4)
400 format(1X,A,ES25.16E3)
500 format(1X,I5,3ES25.16E3)

! Get the input file from the command line arguments
call get_command_argument(1, fname)
write(6, *) "Using provided file ", trim(fname), " as a config file"

! STEP 1: Initialization of the model.
! Read the input file and call "allocate_model" to initialize the model.
! The model is a container for all the parameters, precomputed constants
! and preallocated workspaces.
start_time = omp_get_wtime()
call ddfromfile(fname, ddx_data, tol, charges, ddx_error)
finish_time = omp_get_wtime()
write(*, 100) "Initialization time:", finish_time - start_time, " seconds"
call check_error(ddx_error)

! STEP 2: Initialization of the state.
! The state is a high level object which is related to solving the
! solvation problem for a given solute. A state must be used with a
! model (ddx_data). Different states can be used at the same time with
! a given model, for instance when solving for different solutes,
! or for different states of the solute.
call allocate_state(ddx_data % params, ddx_data % constants, state, ddx_error)
call check_error(ddx_error)

! Print the ddX banner
call get_banner(banner)
write(6, *) trim(banner)

! STEP 3: Building the required RHSs and electrostatic properties.
!
! dd models require two different kind of RHS. The primal RHS which is
! based on electrostatic properties, and the adjoint RHS which is a
! representation of the density in spherical harmonics (with extra steps).
! Furthermore, when computing the forces, electrostatic properties of
! order +1 are required to compute the force contribution from the RHS.
!
! ddLPB is slightly more complicated as its primal RHS requires also
! the electric field, and if forces are to be computed, requires the
! electric field gradient.
!
! For convenience all the required electrostatic properties are computed
! together in STEP 3a. The adjoint RHS is computed in STEP 3b.

! STEP 3a: electrostatic properties for primal RHS and for the forces.

start_time = omp_get_wtime()

! The ddx_multipolar_solute provides routines to compute the
! electrostatic properties up to field gradient for multipolar
! distributions of arbitrary order, provided that they are given in
! real spherical harmonics. Here we have charges, so we need to convert
! them to monopoles. For charges the conversion is simply a scaling by
! 1/sqrt(four*pi). For more complicated cases, up to the 16-poles, check
! https://en.wikipedia.org/wiki/Table_of_spherical_harmonics#Real_spherical_harmonics
allocate(multipoles(1, ddx_data % params % nsph), stat=info)
if (info .ne. 0) then
    write(6, *) "Allocation failed in ddx_driver"
    stop 1
end if
multipoles(1, :) = charges/sqrt4pi

! compute the required electrostatics properties for a multipolar solute
call multipole_electrostatics(ddx_data % params, ddx_data % constants, &
    & ddx_data % workspace, multipoles, 0, electrostatics, ddx_error)

finish_time = omp_get_wtime()
write(*, 100) "Electrostatic properties time:", finish_time-start_time, &
    & " seconds"

! STEP 3b: adjoint RHS.
start_time = omp_get_wtime()
allocate(psi(ddx_data % constants % nbasis, ddx_data % params % nsph), &
    & stat=info)
if (info .ne. 0) then
    write(6, *) "Allocation failed in ddx_driver"
    stop 1
end if
call multipole_psi(ddx_data % params, multipoles, 0, psi)
finish_time = omp_get_wtime()
write(*, 100) "Psi time:", finish_time-start_time, " seconds"

if (ddx_data % params % force .eq. 1) then
    allocate(force(3, ddx_data % params % nsph), stat=info)
    if (info .ne. 0) then
        write(6, *) "Allocation failed in ddx_driver"
        stop 1
    end if
    call ddrun(ddx_data, state, electrostatics, psi, tol, esolv, ddx_error, &
        & force)
else
    call ddrun(ddx_data, state, electrostatics, psi, tol, esolv, ddx_error)
end if
call check_error(ddx_error)

if (ddx_data % params % force .eq. 1) write(*, 100) &
    & "solvation force terms time:", state % force_time, " seconds"

! STEP 8: if required compute the solute specific contributions to the
! forces.
if (ddx_data % params % force .eq. 1) then
    start_time = omp_get_wtime()
    call multipole_force_terms(ddx_data % params, ddx_data % constants, &
        & ddx_data % workspace, state, 0, multipoles, force, ddx_error)
        call check_error(ddx_error)
    finish_time = omp_get_wtime()
    write(*, 100) "multipolar force terms time:", &
        & finish_time - start_time, " seconds"
end if

! From now on, we print the results.

! Print info on the primal ddPCM system
if (ddx_data % params % model .eq. 2) then
    ! Print each iteration if needed
    do i = 1, state % phieps_niter
        write(6, 200) "iter=", i, " relative difference: ", &
            & state % phieps_rel_diff(i)
    end do
    ! Print number of iterations and time
    write(6, 100) "ddpcm step time: ", state % phieps_time, &
        & " seconds"
    write(6, 300) "ddpcm step iterations: ", &
        & state % phieps_niter
end if

! Print info on the primal ddLPB system
if (ddx_data % params % model .eq. 3) then
    ! Print each iteration if needed
    do i = 1, state % x_lpb_niter
        write(6, 200) "iter=", i, " relative difference: ", &
            & state % x_lpb_rel_diff(i)
    end do
    ! Print number of iterations and time
    write(6, 100) "ddlpb step time: ", state % x_lpb_time, &
        & " seconds, of which:"
    write(6, 100) "    ddcosmo: ", state % xs_time, " seconds"
    write(6, 100) "    hsp: ", state % hsp_time, " seconds"
    write(6, 100) "    coupling terms: ", state % x_lpb_time &
        & - state % xs_time - state % hsp_time, " seconds"
    write(6, 300) "ddlpb step iterations: ", state % x_lpb_niter
end if

! Print info on the primal ddCOSMO system
! Print each iteration if needed
if ((ddx_data % params % model.eq.1) .or. &
        & (ddx_data % params % model.eq.2)) then
    do i = 1, state % xs_niter
        write(6, 200) "iter=", i, " relative difference: ", &
            & state % xs_rel_diff(i)
    end do
    ! Print number of iterations and time
    write(6, 100) "ddcosmo step time: ", state % xs_time, " seconds"
    write(6, 300) "ddcosmo step iterations: ", state % xs_niter
end if

! Print info on the adjoint solver
if (ddx_data % params % force .eq. 1) then
    ! Print info on the adjoint ddCOSMO system
    if ((ddx_data % params % model.eq.1) .or. &
            & (ddx_data % params % model.eq.2)) then
        do i = 1, state % s_niter
            write(6, 200) "iter=", i, " relative difference: ", &
                & state % s_rel_diff(i)
        end do
        ! Print number of iterations and time
        write(6, 100) "adjoint ddcosmo step time: ", state % s_time, " seconds"
        write(6, 300) "adjoint ddcosmo step iterations: ", state % s_niter
    end if

    ! Print info on the adjoint ddPCM system
    if (ddx_data % params % model .eq. 2) then
        ! Print each iteration if needed
        do i = 1, state % y_niter
            write(6, 200) "iter=", i, " relative difference: ", &
                & state % y_rel_diff(i)
        end do
        write(6, 100) "adjoint ddpcm step time: ", state % y_time, " seconds"
        write(6, 300) "adjoint ddpcm step iterations: ", state % y_niter
    end if

    ! Print info on the adjoint ddLPB system
    if (ddx_data % params % model .eq. 3) then
        do i = 1, state % x_adj_lpb_niter
            write(6, 200) "iter=", i, " relative difference: ", &
                & state % x_adj_lpb_rel_diff(i)
        end do
        ! Print number of iterations and time
        write(6, 100) "adjoint ddlpb step time: ", &
            & state % x_adj_lpb_time, " seconds, of which:"
        write(6, 100) "    adjoint ddcosmo: ", state % s_time, " seconds"
        write(6, 100) "    adjoint hsp: ", state % hsp_adj_time, " seconds"
        write(6, 100) "    adjoint coupling terms: ", state % x_adj_lpb_time &
            & - state % s_time - state % hsp_adj_time, " seconds"
        write(6, 200) "adjoint ddlpb step iterations: ", &
            & state % x_adj_lpb_niter
    end if
end if

write(6, 400) "Solvation energy (Hartree):", esolv
write(6, 400) "Solvation energy (kcal/mol):", esolv*tokcal
if (ddx_data % params % force .eq. 1) then
    write(6, *) "Full forces (kcal/mol/A)"
    do isph = 1, ddx_data % params % nsph
        write(6, 500) isph, force(:, isph)*tokcal/toang
    end do
end if

! Clean the workspace.

deallocate(psi, multipoles, charges, stat=info)
if (info .ne. 0) then
    write(6, *) "Deallocation failed in ddx_driver"
    stop 1
end if
if (allocated(force)) then
    deallocate(force, stat=info)
    if (info .ne. 0) then
        write(6, *) "Deallocation failed in ddx_driver"
        stop 1
    end if
end if

call deallocate_electrostatics(electrostatics, ddx_error)
call deallocate_state(state, ddx_error)
call deallocate_model(ddx_data, ddx_error)

end program main

! This file is part of s-dftd3.
! SPDX-Identifier: LGPL-3.0-or-later
!
! s-dftd3 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! s-dftd3 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with s-dftd3.  If not, see <https://www.gnu.org/licenses/>.

module dftd3_app_cli
   use, intrinsic :: iso_fortran_env, only : output_unit
   use mctc_env, only : wp, error_type, fatal_error
   use mctc_io, only : structure_type, read_structure, filetype, get_filetype
   use dftd3, only : d3_param
   use dftd3_app_argument, only : argument_list, len
   use dftd3_app_help, only : prog_name, header, help_text, run_help_text, param_help_text, &
      & gcp_help_text, version
   implicit none
   private

   public :: app_config, run_config, param_config, gcp_config, get_arguments

   type, abstract :: app_config
   end type app_config

   type, extends(app_config) :: run_config
      !> Geometry input file
      character(len=:), allocatable :: input
      !> Format of the geometry input
      integer, allocatable :: input_format
      !> Method name
      character(len=:), allocatable :: method
      !> Basis name
      character(len=:), allocatable :: basis
      !> Damping paramaters
      type(d3_param) :: inp
      logical :: json = .false.
      character(len=:), allocatable :: json_output
      logical :: wrap = .true.
      logical :: tmer = .true.
      logical :: properties = .false.
      logical :: atm = .false.
      logical :: grad = .false.
      character(len=:), allocatable :: grad_output
      logical :: zero = .false.
      logical :: rational = .false.
      logical :: mzero = .false.
      logical :: mrational = .false.
      logical :: optimizedpower = .false.
      logical :: cso = .false.
      logical :: has_param = .false.
      integer :: verbosity = 2
      logical :: pair_resolved = .false.
      logical :: citation = .false.
      logical :: gcp = .false.
      character(len=:), allocatable :: citation_output
      !> Parameter data base
      character(len=:), allocatable :: db
   end type run_config

   type, extends(app_config) :: param_config
      !> Data base input file
      character(len=:), allocatable :: input
      !> Method name
      character(len=:), allocatable :: method
      !> Damping function
      character(len=:), allocatable :: damping
   end type param_config

   type, extends(app_config) :: gcp_config
      !> Geometry input file
      character(len=:), allocatable :: input
      !> Format of the geometry input
      integer, allocatable :: input_format
      !> Method name
      character(len=:), allocatable :: method
      !> Basis name
      character(len=:), allocatable :: basis
      logical :: json = .false.
      character(len=:), allocatable :: json_output
      logical :: wrap = .true.
      logical :: tmer = .true.
      logical :: grad = .false.
      character(len=:), allocatable :: grad_output
      integer :: verbosity = 2
      logical :: citation = .false.
      character(len=:), allocatable :: citation_output
   end type gcp_config

contains


subroutine get_argument_as_real(arg, val, error)
   !> Index of command line argument, range [0:command_argument_count()]
   character(len=:), intent(in), allocatable :: arg
   !> Real value
   real(wp), intent(out) :: val
   !> Error handling
   type(error_type), allocatable :: error

   integer :: stat

   if (.not.allocated(arg)) then
      call fatal_error(error, "Cannot read real value, argument missing")
      return
   end if
   read(arg, *, iostat=stat) val
   if (stat /= 0) then
      call fatal_error(error, "Cannot read real value from '"//arg//"'")
      return
   end if

end subroutine get_argument_as_real


subroutine get_arguments(config, error)

   !> Configuation data
   class(app_config), allocatable, intent(out) :: config

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(argument_list) :: list
   integer :: iarg, narg
   character(len=:), allocatable :: arg

   iarg = 0
   list = argument_list()
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      select case(arg)
      case("--help")
         call info_message(error, help_text)
         exit
      case("--version")
         call version(output_unit)
         stop
      case default
         iarg = iarg - 1
         allocate(run_config :: config)
         exit
      case("run")
         allocate(run_config :: config)
         exit
      case("param")
         allocate(param_config :: config)
         exit
      case("gcp")
         allocate(gcp_config :: config)
         exit
      end select
   end do
   if (allocated(error)) return

   if (.not.allocated(config)) then
      write(output_unit, '(a)') help_text
      call fatal_error(error, "Insufficient arguments provided")
      return
   end if

   select type(config)
   type is(run_config)
      call get_run_arguments(config, list, iarg, error)
   type is(param_config)
      call get_param_arguments(config, list, iarg, error)
   type is(gcp_config)
      call get_gcp_arguments(config, list, iarg, error)
   end select
end subroutine get_arguments


subroutine get_run_arguments(config, list, start, error)

   !> Configuation data
   type(run_config), intent(out) :: config

   !> List of command line arguments
   type(argument_list), intent(in) :: list

   !> First command line argument
   integer, intent(in) :: start

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   logical :: read_args
   character(len=:), allocatable :: arg

   read_args = .true.
   iarg = start
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      if (.not.read_args) then
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         call fatal_error(error, "Too many positional arguments present")
         exit
      end if
      select case(arg)
      case("--")
         read_args = .false.
      case("--help")
         call info_message(error, run_help_text)
         exit
      case("--version")
         call version(output_unit)
         stop
      case("-v", "--verbose")
         config%verbosity = config%verbosity + 1
      case("-s", "--silent")
         config%verbosity = config%verbosity - 1
      case default
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         if (arg(1:1) == "-") then
            call fatal_error(error, "Unknown argument encountered: '"//arg//"'")
         else
            call fatal_error(error, "Too many positional arguments present")
         end if
         exit
      case("-i", "--input")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for input format")
            exit
         end if
         config%input_format = get_filetype("."//arg)
      case("--json")
         config%json = .true.
         config%json_output = "dftd3.json"
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (allocated(arg)) then
            if (arg(1:1) == "-") then
               iarg = iarg - 1
               cycle
            end if
            call move_alloc(arg, config%json_output)
         end if
      case("--citation")
         config%citation = .true.
         config%citation_output = "dftd3.bib"
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (allocated(arg)) then
            if (arg(1:1) == "-") then
               iarg = iarg - 1
               cycle
            end if
            call move_alloc(arg, config%citation_output)
         end if
      case("--property")
         config%properties = .true.
      case("--pair-resolved")
         config%pair_resolved = .true.
      case("--noedisp")
         config%tmer = .false.
      case("--nowrap")
         config%wrap = .false.
      case("--grad")
         config%grad = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (allocated(arg)) then
            if (arg(1:1) == "-") then
               iarg = iarg - 1
               cycle
            end if
            call move_alloc(arg, config%grad_output)
         end if
      case("--atm")
         config%inp%s9 = 1.0_wp
         config%atm = .true.
      case("--atm-scale")
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%s9, error)
         if (allocated(error)) exit
         config%atm = .true.
      case("--gcp")
         config%gcp = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (allocated(arg)) then
            if (arg(1:1) == "-") then
               iarg = iarg - 1
               cycle
            end if
            call move_alloc(arg, config%basis)
         end if
      case("--zero")
         config%zero = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for method")
            exit
         end if
         call move_alloc(arg, config%method)
      case("--zerom")
         config%mzero = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for method")
            exit
         end if
         call move_alloc(arg, config%method)
      case("--zero-param")
         config%zero = .true.
         config%has_param = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%s6, error)
         if (allocated(error)) exit
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%s8, error)
         if (allocated(error)) exit
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%rs6, error)
         if (allocated(error)) exit
      case("--zerom-param")
         config%mzero = .true.
         config%has_param = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%s6, error)
         if (allocated(error)) exit
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%s8, error)
         if (allocated(error)) exit
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%rs6, error)
         if (allocated(error)) exit
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%bet, error)
         if (allocated(error)) exit
      case("--bj")
         config%rational = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for method")
            exit
         end if
         call move_alloc(arg, config%method)
      case("--bjm")
         config%mrational = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for method")
            exit
         end if
         call move_alloc(arg, config%method)
      case("--bj-param", "--bjm-param")
         config%rational = .true.
         config%has_param = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%s6, error)
         if (allocated(error)) exit
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%s8, error)
         if (allocated(error)) exit
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%a1, error)
         if (allocated(error)) exit
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%a2, error)
         if (allocated(error)) exit
      case("--op")
         config%optimizedpower = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for method")
            exit
         end if
         call move_alloc(arg, config%method)
      case("--op-param")
         config%optimizedpower = .true.
         config%has_param = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%s6, error)
         if (allocated(error)) exit
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%s8, error)
         if (allocated(error)) exit
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%a1, error)
         if (allocated(error)) exit
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%a2, error)
         if (allocated(error)) exit
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%bet, error)
         if (allocated(error)) exit
      case("--cso")
         config%cso = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for method")
            exit
         end if
         call move_alloc(arg, config%method)
      case("--cso-param")
         config%cso = .true.
         config%has_param = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%s6, error)
         if (allocated(error)) exit
         iarg = iarg + 1
         call list%get(iarg, arg)
         call get_argument_as_real(arg, config%inp%a1, error)
         if (allocated(error)) exit
      case("--db")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (allocated(arg)) then
            if (arg(1:1) == "-") then
               iarg = iarg - 1
               cycle
            end if
            call move_alloc(arg, config%db)
         end if
         if (.not.allocated(config%db)) then
            call fatal_error(error, "No argument provided for data base path")
            exit
         end if
      end select
   end do
   if (allocated(error)) return

   if (.not.config%has_param .and. .not.allocated(config%method)) then
      config%properties = .true.
   end if

   if (count([config%zero, config%rational, config%mzero, config%mrational, &
      & config%optimizedpower, config%cso]) > 1) then
      call fatal_error(error, "Can only select one damping scheme (zero, rational, mzero, mrational, optimizedpower, or cso)")
      return
   end if

   if (config%grad.and. .not.config%json .and. .not.allocated(config%grad_output)) then
      config%grad_output = "dftd3.txt"
   end if

   if (.not.allocated(config%input)) then
      if (.not.allocated(error)) then
         write(output_unit, '(a)') run_help_text
         call fatal_error(error, "Insufficient arguments provided")
      end if
   end if

end subroutine get_run_arguments

subroutine get_param_arguments(config, list, start, error)

   !> Configuation data
   type(param_config), intent(out) :: config

   !> List of command line arguments
   type(argument_list), intent(in) :: list

   !> First command line argument
   integer, intent(in) :: start

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   character(len=:), allocatable :: arg

   iarg = start
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      select case(arg)
      case("--help")
         call info_message(error, param_help_text)
         exit
      case("--version")
         call version(output_unit)
         stop
      case default
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         if (.not.allocated(config%method)) then
            call move_alloc(arg, config%method)
            cycle
         end if
         if (.not.allocated(config%damping)) then
            call move_alloc(arg, config%damping)
            cycle
         end if
         if (arg(1:1) == "-") then
            call fatal_error(error, "Unknown argument encountered: '"//arg//"'")
         else
            call fatal_error(error, "Too many positional arguments present")
         end if
         exit
      end select
   end do
   if (allocated(error)) return

   if (.not.allocated(config%input)) then
      if (.not.allocated(error)) then
         write(output_unit, '(a)') param_help_text
         call fatal_error(error, "Insufficient arguments provided")
      end if
   end if

end subroutine get_param_arguments

subroutine get_gcp_arguments(config, list, start, error)

   !> Configuation data
   type(gcp_config), intent(out) :: config

   !> List of command line arguments
   type(argument_list), intent(in) :: list

   !> First command line argument
   integer, intent(in) :: start

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   integer :: iarg, narg
   character(len=:), allocatable :: arg

   iarg = start
   narg = len(list)
   do while(iarg < narg)
      iarg = iarg + 1
      call list%get(iarg, arg)
      select case(arg)
      case("--help")
         call info_message(error, gcp_help_text)
         exit
      case("--version")
         call version(output_unit)
         stop
      case("-v", "--verbose")
         config%verbosity = config%verbosity + 1
      case("-s", "--silent")
         config%verbosity = config%verbosity - 1
      case default
         if (.not.allocated(config%input)) then
            call move_alloc(arg, config%input)
            cycle
         end if
         if (arg(1:1) == "-") then
            call fatal_error(error, "Unknown argument encountered: '"//arg//"'")
         else
            call fatal_error(error, "Too many positional arguments present")
         end if
         exit
      case("-i", "--input")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for input format")
            exit
         end if
         config%input_format = get_filetype("."//arg)
      case("-l", "--level")
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (.not.allocated(arg)) then
            call fatal_error(error, "Missing argument for input format")
            exit
         end if
         if (index(arg, "/") > 0) then
            config%method = arg(1:index(arg, "/")-1)
            config%basis = arg(index(arg, "/")+1:)
         else
            call move_alloc(arg, config%method)
         end if
      case("--json")
         config%json = .true.
         config%json_output = "dftd3.json"
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (allocated(arg)) then
            if (arg(1:1) == "-") then
               iarg = iarg - 1
               cycle
            end if
            call move_alloc(arg, config%json_output)
         end if
      case("--nocpc")
         config%tmer = .false.
      case("--nowrap")
         config%wrap = .false.
      case("--grad")
         config%grad = .true.
         iarg = iarg + 1
         call list%get(iarg, arg)
         if (allocated(arg)) then
            if (arg(1:1) == "-") then
               iarg = iarg - 1
               cycle
            end if
            call move_alloc(arg, config%grad_output)
         end if
      end select
   end do
   if (allocated(error)) return

   if (config%grad.and. .not.config%json .and. .not.allocated(config%grad_output)) then
      config%grad_output = "dftd3.txt"
   end if

   if (.not.allocated(config%input)) then
      if (.not.allocated(error)) then
         write(output_unit, '(a)') gcp_help_text
         call fatal_error(error, "Insufficient arguments provided")
      end if
   end if

end subroutine get_gcp_arguments

subroutine info_message(error, message)
   type(error_type), allocatable, intent(out) :: error
   character(len=*), intent(in) :: message

   allocate(error)
   error%stat = 0
   error%message = message
end subroutine info_message

end module dftd3_app_cli

! This file is part of tblite.
! SPDX-Identifier: LGPL-3.0-or-later
!
! tblite is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! tblite is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with tblite.  If not, see <https://www.gnu.org/licenses/>.

module test_molden
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_env_testing, only : new_unittest, &
      & unittest_type, check
   use mctc_io, only : structure_type, new
   use mstore, only : get_structure
   use tblite_basis_type, only : basis_type, cgto_type, &
      & new_basis
   use tblite_context_type, only : context_type
   use tblite_io_molden, only : load_molden, save_molden
   use tblite_wavefunction, only : wavefunction_type, &
      & new_wavefunction, eeq_guess
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   implicit none
   private

   public :: collect_molden

   real(wp), parameter :: kt = 300.0_wp * 3.166808578545117e-06_wp
   real(wp), parameter :: acc = 0.01_wp

contains

subroutine collect_molden(testsuite)
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("roundtrip", test_roundtrip), &
      new_unittest("reordered-sections", test_reordered_sections), &
      new_unittest("restart", test_restart_from_molden), &
      new_unittest("restart-unrestricted", test_restart_uhf_from_molden), &
      new_unittest("num-prim-fail", test_num_prim_fail, should_fail=.true.), &
      new_unittest("ang-mom-fail", test_angmom_fail, should_fail=.true.), &
      new_unittest("missing-atoms-fail", test_missing_atoms_fail, should_fail=.true.), &
      new_unittest("missing-gto-fail", test_missing_gto_fail, should_fail=.true.), &
      new_unittest("missing-mo-fail", test_missing_mo_fail, should_fail=.true.) &
      ]

end subroutine collect_molden

!> Test Molden roundtrip with standard section order
subroutine test_roundtrip(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_roundtrip(".molden-roundtrip.molden", .false., error)
end subroutine test_roundtrip

!> Test Molden roundtrip with reordered sections
subroutine test_reordered_sections(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_roundtrip(".molden-reordered.molden", .true., error)
end subroutine test_reordered_sections

subroutine check_roundtrip(filename, reorder, error)
   !> Molden file name
   character(len=*), intent(in) :: filename
   !> Whether to reorder sections before loading
   logical, intent(in) :: reorder
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=:), allocatable :: input
   type(structure_type) :: mol, mol_loaded
   type(basis_type) :: bas, bas_loaded
   type(wavefunction_type) :: wfn, wfn_loaded

   call make_roundtrip_data(mol, bas, wfn)

   call remove_file(filename)
   call save_molden(filename, mol, bas, wfn, error)
   if (allocated(error)) return

   if (reorder) then
      input = filename//".input"
      call remove_file(input)
      call rewrite_reordered(filename, input)
   else
      input = filename
   end if

   call load_molden(input, mol_loaded, bas_loaded, wfn_loaded, error)
   if (allocated(error)) return
   call remove_file(filename)
   call remove_file(input)

   call check_structure(error, mol_loaded, mol)
   if (allocated(error)) return
   call check_basis(error, bas_loaded, bas)
   if (allocated(error)) return
   call check_wavefunction(error, wfn_loaded, wfn)
   if (allocated(error)) return
end subroutine check_roundtrip

subroutine check_structure(error, actual, expected)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Read structure data
   type(structure_type), intent(in) :: actual
   !> Reference structure data
   type(structure_type), intent(in) :: expected

   integer :: i

   call check(error, actual%nat, expected%nat)
   if (allocated(error)) return
   call check(error, all(actual%num(actual%id) == expected%num(expected%id)), &
      & "Nuclear charges changed in Molden round trip")
   if (allocated(error)) return
   call check(error, all(abs(actual%xyz - expected%xyz) <= epsilon(1.0_wp)), &
      & "Nuclear coordinates changed in Molden round trip")
   if (allocated(error)) return
   call check(error, size(actual%sym) == size(expected%sym), &
      & "Nuclear symbol table size changed in Molden round trip")
   if (allocated(error)) return
   do i = 1, size(expected%sym)
      call check(error, trim(actual%sym(i)) == trim(expected%sym(i)), &
         & "Nuclear symbol " // trim(expected%sym(i)) // " changed in Molden round trip")
      if (allocated(error)) return
   end do
   call check(error, abs(actual%charge - expected%charge) <= epsilon(1.0_wp), &
      & "Molecular charge changed in Molden round trip")
   if (allocated(error)) return
   call check(error, actual%uhf, expected%uhf, &
      & "Molecular spin multiplicity changed in Molden round trip")
   if (allocated(error)) return
   if (allocated(expected%periodic)) then
      if (.not. allocated(actual%periodic)) then
         call fatal_error(error, "Periodicity missing in Molden round trip")
         return
      end if
      call check(error, all(actual%periodic .eqv. expected%periodic), &
         & "Periodicity changed in Molden round trip")
      if (allocated(error)) return
   else
      call check(error, .not. allocated(actual%periodic), &
         & "Unexpected periodicity in Molden round trip")
      if (allocated(error)) return
   end if
   if (allocated(expected%lattice)) then
      if (.not. allocated(actual%lattice)) then
         call fatal_error(error, "Lattice vectors missing in Molden round trip")
         return
      end if
      call check(error, all(abs(actual%lattice - expected%lattice) <= epsilon(1.0_wp)), &
         & "Lattice vectors changed in Molden round trip")
   else
      call check(error, .not. allocated(actual%lattice), &
         & "Unexpected lattice vectors in Molden round trip")
   end if
end subroutine check_structure

subroutine check_basis(error, actual, expected)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Read basis set information
   type(basis_type), intent(in) :: actual
   !> Reference basis set information
   type(basis_type), intent(in) :: expected

   integer :: isp, ish, nprim

   call check(error, actual%nsh, expected%nsh, &
      & "Basis shell count changed in Molden round trip")
   if (allocated(error)) return
   call check(error, actual%nao, expected%nao, &
      & "Basis AO count changed in Molden round trip")
   if (allocated(error)) return
   call check(error, actual%nao_cart, expected%nao_cart, &
      & "Basis Cartesian AO count changed in Molden round trip")
   if (allocated(error)) return
   call check(error, actual%maxl, expected%maxl, &
      & "Basis maximum angular momentum changed in Molden round trip")
   if (allocated(error)) return
   call check(error, all(actual%sh2at == expected%sh2at), &
      & "Basis nucleus map changed in Molden round trip")
   if (allocated(error)) return
   call check(error, all(actual%nao_sh == expected%nao_sh), &
      & "Basis shell AO counts changed in Molden round trip")
   if (allocated(error)) return
   call check(error, all(actual%iao_sh == expected%iao_sh), &
      & "Basis shell AO offsets changed in Molden round trip")
   if (allocated(error)) return
   call check(error, all(actual%ao2sh == expected%ao2sh), &
      & "Basis AO shell map changed in Molden round trip")
   if (allocated(error)) return
   call check(error, all(actual%ao2at == expected%ao2at), &
      & "Basis AO atom map changed in Molden round trip")
   if (allocated(error)) return

   ! Check CGTO primitives
   do isp = 1, size(expected%cgto, 2)
      do ish = 1, expected%nsh_id(isp)
         call check(error, actual%cgto(ish, isp)%ang, expected%cgto(ish, isp)%ang, &
            & "Shell angular momentum changed in Molden round trip")
         if (allocated(error)) return
         call check(error, actual%cgto(ish, isp)%nprim, expected%cgto(ish, isp)%nprim, &
            & "Shell primitive count changed in Molden round trip")
         nprim = expected%cgto(ish, isp)%nprim
         if (allocated(error)) return
         call check(error, all(abs(actual%cgto(ish, isp)%alpha(:nprim) - &
            & expected%cgto(ish, isp)%alpha(:nprim)) <= epsilon(1.0_wp)), &
            & "Primitive exponents changed in Molden round trip")
         if (allocated(error)) return
         call check(error, all(abs(actual%cgto(ish, isp)%coeff(:nprim) - &
            & expected%cgto(ish, isp)%coeff(:nprim)) <= epsilon(1.0_wp)), &
            & "Primitive coefficients changed in Molden round trip")
         if (allocated(error)) return
      end do
   end do
end subroutine check_basis

subroutine check_wavefunction(error, actual, expected)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error
   !> Read wavefunction data
   type(wavefunction_type), intent(in) :: actual
   !> Reference wavefunction data
   type(wavefunction_type), intent(in) :: expected

   call check(error, actual%nspin, expected%nspin)
   if (allocated(error)) return
   call check(error, abs(actual%nocc - expected%nocc) <= epsilon(1.0_wp), &
      & "Wavefunction electron count changed in Molden round trip")
   if (allocated(error)) return
   call check(error, abs(actual%nuhf - expected%nuhf) <= epsilon(1.0_wp), &
      & "Wavefunction unpaired electron count changed in Molden round trip")
   if (allocated(error)) return
   call check(error, all(abs(actual%nel - expected%nel) <= epsilon(1.0_wp)), &
      & "Wavefunction spin electron counts changed in Molden round trip")
   if (allocated(error)) return
   call check(error, all(abs(actual%emo - expected%emo) <= epsilon(1.0_wp)), &
      & "Wavefunction MO energies changed in Molden round trip")
   if (allocated(error)) return
   call check(error, all(abs(actual%n0at - expected%n0at) <= epsilon(1.0_wp)), &
      & "Wavefunction atomic reference occupation changed in Molden round trip")
   if (allocated(error)) return
   call check(error, all(abs(actual%focc - expected%focc) <= epsilon(1.0_wp)), &
      & "Wavefunction MO occupations changed in Molden round trip")
   if (allocated(error)) return
   call check(error, all(abs(actual%coeff - expected%coeff) <= epsilon(1.0_wp)), &
      & "Wavefunction MO coefficients changed in Molden round trip")
end subroutine check_wavefunction

subroutine make_roundtrip_data(mol, bas, wfn)
   !> Molecular structure data
   type(structure_type), intent(out) :: mol
   !> Basis set information
   type(basis_type), intent(out) :: bas
   !> Wavefunction data
   type(wavefunction_type), intent(out) :: wfn

   integer :: iao
   integer, allocatable :: nshell(:)
   real(wp) :: lattice(3, 3)
   type(cgto_type), allocatable :: cgto(:, :)

   lattice = reshape([ &
      & 8.0_wp, 0.0_wp, 0.0_wp, &
      & 0.0_wp, 9.0_wp, 0.0_wp, &
      & 0.0_wp, 0.0_wp, 10.0_wp], [3, 3])

   call new(mol, [1, 4], reshape([ &
      & 0.0_wp, 0.0_wp, 0.0_wp, &
      & 0.0_wp, 0.0_wp, 1.4_wp], [3, 2]), &
      & charge=0.0_wp, uhf=1, lattice=lattice)

   allocate(nshell(mol%nid), cgto(1, mol%nid))
   nshell(:) = 1
   cgto(:, :) = cgto_type()

   cgto(1, 1)%ang = 0
   cgto(1, 1)%nprim = 1
   cgto(1, 1)%alpha(1) = 1.2_wp
   cgto(1, 1)%coeff(1) = 0.8_wp

   cgto(1, 2)%ang = 1
   cgto(1, 2)%nprim = 2
   cgto(1, 2)%alpha(:2) = [0.9_wp, 0.4_wp]
   cgto(1, 2)%coeff(:2) = [0.7_wp, 0.2_wp]

   call new_basis(bas, mol, nshell, cgto, 1.0_wp)

   call new_wavefunction(wfn, mol%nat, bas%nsh, bas%nao, 2, 0.0_wp)
   wfn%nocc = 3.0_wp
   wfn%nuhf = 1.0_wp
   wfn%nel = [2.0_wp, 1.0_wp]
   wfn%n0at = [1.0_wp, 2.0_wp]
   wfn%n0sh = [1.0_wp, 2.0_wp]
   wfn%emo(:, 1) = [-0.7_wp, -0.2_wp, 0.1_wp, 0.3_wp]
   wfn%emo(:, 2) = [-0.6_wp, -0.1_wp, 0.2_wp, 0.4_wp]
   wfn%focc(:, 1) = [1.0_wp, 1.0_wp, 0.0_wp, 0.0_wp]
   wfn%focc(:, 2) = [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp]

   wfn%coeff(:, :, :) = 0.0_wp
   do iao = 1, bas%nao
      wfn%coeff(iao, iao, 1) = 1.0_wp
      wfn%coeff(iao, iao, 2) = 1.0_wp
   end do
   wfn%coeff(2, 3, 1) = 0.25_wp
   wfn%coeff(3, 2, 1) = -0.15_wp
   wfn%coeff(4, 4, 1) = 0.85_wp
   wfn%coeff(2, 4, 2) = -0.20_wp
   wfn%coeff(4, 2, 2) = 0.30_wp
end subroutine make_roundtrip_data

subroutine rewrite_reordered(input, output)
   !> Input file name
   character(len=*), intent(in) :: input
   !> Output file name
   character(len=*), intent(in) :: output

   character(len=512) :: lines(512)
   integer :: iline, ios, nline, unit

   nline = 0
   open(newunit=unit, file=input, status="old", action="read")
   do
      read(unit, '(a)', iostat=ios) lines(nline + 1)
      if (ios /= 0) exit
      nline = nline + 1
   end do
   close(unit)

   open(newunit=unit, file=output, &
      & status="replace", action="write")
   call write_section(unit, lines(:nline), "molden format")
   call write_section(unit, lines(:nline), "title")
   call write_section(unit, lines(:nline), "atoms")
   call write_section(unit, lines(:nline), "gto")
   call write_section(unit, lines(:nline), "6d")
   call write_section(unit, lines(:nline), "10f")
   call write_section(unit, lines(:nline), "15g")
   call write_section(unit, lines(:nline), "cell")
   call write_section(unit, lines(:nline), "core")
   call write_section(unit, lines(:nline), "pseudo")
   call write_section(unit, lines(:nline), "nval")
   call write_section(unit, lines(:nline), "mo")
   close(unit)

end subroutine rewrite_reordered

subroutine write_section(unit, lines, name)
   !> Output file unit
   integer, intent(in) :: unit
   !> All lines from the original file
   character(len=*), intent(in) :: lines(:)
   !> Section name to write
   character(len=*), intent(in) :: name

   integer :: first, iline, last

   first = 0
   do iline = 1, size(lines)
      if (section_id(lines(iline)) == name) then
         first = iline
         exit
      end if
   end do
   if (first == 0) return

   last = size(lines)
   do iline = first + 1, size(lines)
      if (len_trim(section_id(lines(iline))) > 0) then
         last = iline - 1
         exit
      end if
   end do

   do iline = first, last
      write(unit, '(a)') trim(lines(iline))
   end do
end subroutine write_section

function section_id(line) result(id)
   !> Input line
   character(len=*), intent(in) :: line
   character(len=32) :: id

   character(len=len(line)) :: work
   integer :: right, i, ic

   id = ""
   work = adjustl(line)
   if (len_trim(work) < 3) return
   if (work(1:1) /= "[") return

   right = index(work, "]")
   if (right <= 2) return
   id = adjustl(work(2:right-1))
   ! Lower case
   do i = 1, len_trim(id)
      ic = iachar(id(i:i))
      if (ic >= iachar("A") .and. ic <= iachar("Z")) then
         id(i:i) = achar(ic + iachar("a") - iachar("A"))
      end if
   end do
end function section_id

subroutine remove_file(filename)
   !> Molden file name to remove
   character(len=*), intent(in) :: filename

   integer :: io, stat
   logical :: exist

   inquire(file=filename, exist=exist)
   if (exist) then
      open(newunit=io, file=filename, status="old", action="write", iostat=stat)
      if (stat == 0) close(io, status="delete")
   end if
end subroutine remove_file

subroutine test_restart_from_molden(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_restart_from_molden(".molden-restart.molden", 1, error)
end subroutine test_restart_from_molden

subroutine test_restart_uhf_from_molden(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_restart_from_molden(".molden-restart-uhf.molden", 2, error)
end subroutine test_restart_uhf_from_molden

subroutine check_restart_from_molden(filename, nspin, error)
   !> Molden file name
   character(len=*), intent(in) :: filename
   !> Number of spin channels in the wavefunction to test
   integer, intent(in) :: nspin
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   type(context_type) :: ctx
   type(structure_type) :: mol, mol_loaded
   type(basis_type) :: bas, bas_loaded
   type(wavefunction_type) :: wfn, wfn_loaded
   type(xtb_calculator) :: calc
   real(wp) :: energy

   ! Perform GFN2-xTB calculation to save in trexio
   call make_restart_data(nspin, mol, bas, wfn, energy)

   call remove_file(filename)
   call save_molden(filename, mol, bas, wfn, error)
   if (allocated(error)) return

   call load_molden(filename, mol_loaded, bas_loaded, wfn_loaded, error)
   if (allocated(error)) return
   call remove_file(filename)

   ! Setup a new calculator
   call new_gfn2_calculator(calc, mol, error)
   if (allocated(error)) return

   !> Check that loaded structure and basis set
   call check_structure(error, mol_loaded, mol)
   if (allocated(error)) return
   call check_basis(error, bas_loaded, calc%bas)
   if (allocated(error)) return

   ! Copy all necessary restart wavefunction information
   wfn%coeff = wfn_loaded%coeff
   wfn%focc = wfn_loaded%focc
   wfn%emo = wfn_loaded%emo
   wfn%nocc = wfn_loaded%nocc
   wfn%nel = wfn_loaded%nel
   ! Copy also the basis set to check for correct normalization and mappings
   calc%bas = bas_loaded

   ! Check for immediate convergence with Molden guess
   calc%max_iter = 2
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0)
   call check(error, .not.ctx%failed(), &
      & "Calculation did not converge in < 3 iterations with Molden guess")
end subroutine check_restart_from_molden

subroutine make_restart_data(nspin, mol, bas, wfn, energy)
   !> Number of spin channels
   integer, intent(in) :: nspin
   !> Molecular structure data
   type(structure_type), intent(out) :: mol
   !> Basis set information
   type(basis_type), intent(out) :: bas
   !> Wavefunction data
   type(wavefunction_type), intent(out) :: wfn
   !> Total energy
   real(wp), intent(out) :: energy

   type(context_type) :: ctx
   type(xtb_calculator) :: calc
   type(error_type), allocatable :: error

   call get_structure(mol, "X23", "oxacb")

   call new_gfn2_calculator(calc, mol, error)
   call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, nspin, kt)
   call eeq_guess(mol, calc, wfn, error)

   energy = 0.0_wp
   call xtb_singlepoint(ctx, mol, calc, wfn, acc, energy, verbosity=0)

   bas = calc%bas
end subroutine make_restart_data

subroutine test_num_prim_fail(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: filename = ".molden-num-prim-fail.molden"
   type(structure_type) :: mol, mol_loaded
   type(basis_type) :: bas, bas_loaded
   type(wavefunction_type) :: wfn, wfn_loaded

   call make_roundtrip_data(mol, bas, wfn)
   bas%cgto(1, 2)%nprim = 0

   call remove_file(filename)
   call save_molden(filename, mol, bas, wfn, error)
   if (allocated(error)) return

   call load_molden(filename, mol_loaded, bas_loaded, wfn_loaded, error)
   call remove_file(filename)
end subroutine test_num_prim_fail

subroutine test_angmom_fail(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=*), parameter :: filename = ".molden-angmom-fail.molden"
   type(structure_type) :: mol, mol_loaded
   type(basis_type) :: bas, bas_loaded
   type(wavefunction_type) :: wfn, wfn_loaded

   call make_roundtrip_data(mol, bas, wfn)
   bas%cgto(1, 2)%ang = 5

   call remove_file(filename)
   call save_molden(filename, mol, bas, wfn, error)
   call remove_file(filename)
end subroutine test_angmom_fail

subroutine test_missing_atoms_fail(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_missing_section(".molden-missing-atoms.molden", "atoms", error)
end subroutine test_missing_atoms_fail

subroutine test_missing_gto_fail(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_missing_section(".molden-missing-gto.molden", "gto", error)
end subroutine test_missing_gto_fail

subroutine test_missing_mo_fail(error)
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check_missing_section(".molden-missing-mo.molden", "mo", error)
end subroutine test_missing_mo_fail

subroutine check_missing_section(filename, missing, error)
   !> Molden file name
   character(len=*), intent(in) :: filename
   !> Section to remove
   character(len=*), intent(in) :: missing
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   character(len=:), allocatable :: input
   type(structure_type) :: mol, mol_loaded
   type(basis_type) :: bas, bas_loaded
   type(wavefunction_type) :: wfn, wfn_loaded
   character(len=512) :: lines(1024)
   integer :: ios, nline, unit

   call make_roundtrip_data(mol, bas, wfn)

   call remove_file(filename)
   call save_molden(filename, mol, bas, wfn, error)
   if (allocated(error)) return

   input = filename//".input"
   call remove_file(input)

   ! Read Molden file into memory
   nline = 0
   open(newunit=unit, file=filename, status="old", action="read")
   do
      read(unit, '(a)', iostat=ios) lines(nline + 1)
      if (ios /= 0) exit
      nline = nline + 1
   end do
   close(unit)
   ! Write new file with the specified section missing
   open(newunit=unit, file=input, status="replace", action="write")
   if (trim(missing) /= "atoms") &
      call write_section(unit, lines(:nline), "atoms")
   if (trim(missing) /= "gto") &
      call write_section(unit, lines(:nline), "gto")
   if (trim(missing) /= "mo") &
      call write_section(unit, lines(:nline), "mo")
   close(unit)

   call load_molden(input, mol_loaded, bas_loaded, wfn_loaded, error)
   call remove_file(filename)
   call remove_file(input)
end subroutine check_missing_section

end module test_molden

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> TOML array data type
!>
!> A [[toml_array]] represents a TOML array, which is an ordered sequence
!> of values. TOML arrays can contain values of any type, including nested
!> arrays and tables (arrays of tables).
!>
!> Use [[get_value]] from the build module to retrieve array elements by
!> index, or the type-bound procedures for direct access. The intrinsic
!> [[len]] function is overloaded to return the number of elements.
module tomlf_type_array
   use tomlf_error, only : toml_stat
   use tomlf_type_value, only : toml_value, toml_visitor
   use tomlf_structure, only : toml_list_structure, new_list_structure
   implicit none
   private

   public :: toml_array, new_array, new, initialized, len


   !> TOML array
   type, extends(toml_value) :: toml_array

      !> Is an inline array rather than an array of tables
      logical :: inline = .true.

      !> Storage unit for TOML values of this array
      class(toml_list_structure), allocatable, private :: list

   contains

      !> Get the TOML value at a given index
      procedure :: get

      !> Append value to array
      procedure :: push_back

      !> Remove the first element from the array
      procedure :: shift

      !> Remove the last element from the array
      procedure :: pop

      !> Release allocation hold by TOML array
      procedure :: destroy

   end type toml_array


   !> Create standard constructor
   interface toml_array
      module procedure :: new_array_func
   end interface toml_array


   !> Overloaded constructor for TOML values
   interface new
      module procedure :: new_array
   end interface


   !> Overload len function
   interface len
      module procedure :: get_len
   end interface


   !> Check whether data structure is initialized properly
   interface initialized
      module procedure :: array_initialized
   end interface initialized


contains


!> Constructor to create a new TOML array and allocate the internal storage
subroutine new_array(self)

   !> Instance of the TOML array
   type(toml_array), intent(out) :: self

   call new_list_structure(self%list)

end subroutine new_array


!> Default constructor for TOML array type
function new_array_func() result(self)

   !> Instance of the TOML array
   type(toml_array) :: self

   call new_array(self)

end function new_array_func


!> Check whether data structure is initialized properly
pure function array_initialized(self) result(okay)

   !> Instance of the TOML array
   type(toml_array), intent(in) :: self

   !> Data structure is initialized
   logical :: okay

   okay = allocated(self%list)
end function array_initialized


!> Get number of TOML values in the array
pure function get_len(self) result(length)

   !> Instance of the TOML array
   class(toml_array), intent(in) :: self

   !> Current length of the array
   integer :: length

   length = self%list%get_len()

end function get_len


!> Get the TOML value at the respective index
subroutine get(self, idx, ptr)

   !> Instance of the TOML array
   class(toml_array), intent(inout) :: self

   !> Index to the TOML value
   integer, intent(in) :: idx

   !> Pointer to the TOML value
   class(toml_value), pointer, intent(out) :: ptr

   call self%list%get(idx, ptr)

end subroutine get


!> Push back a TOML value to the array
subroutine push_back(self, val, stat)

   !> Instance of the TOML array
   class(toml_array), intent(inout) :: self

   !> TOML value to append to array
   class(toml_value), allocatable, intent(inout) :: val

   !> Status of operation
   integer, intent(out) :: stat

   if (allocated(val%key)) then
      stat = toml_stat%fatal
      return
   end if

   call self%list%push_back(val)

   stat = toml_stat%success

end subroutine push_back


!> Remove the first element from the data structure
subroutine shift(self, val)

   !> Instance of the TOML array
   class(toml_array), intent(inout) :: self

   !> TOML value to be retrieved
   class(toml_value), allocatable, intent(out) :: val

   call self%list%shift(val)

end subroutine shift


!> Remove the last element from the data structure
subroutine pop(self, val)

   !> Instance of the TOML array
   class(toml_array), intent(inout) :: self

   !> TOML value to be retrieved
   class(toml_value), allocatable, intent(out) :: val

   call self%list%pop(val)

end subroutine pop


!> Deconstructor to cleanup allocations (optional)
subroutine destroy(self)

   !> Instance of the TOML array
   class(toml_array), intent(inout) :: self

   if (allocated(self%key)) then
      deallocate(self%key)
   end if

   if (allocated(self%list)) then
      call self%list%destroy
      deallocate(self%list)
   end if

end subroutine destroy


end module tomlf_type_array

! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module tftest_utils
   use testdrive
   implicit none
   private

   public :: collect_utils


contains


!> Collect all exported unit tests
subroutine collect_utils(testsuite)

   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      & new_unittest("string-i1", string_i1), &
      & new_unittest("string-i2", string_i2), &
      & new_unittest("string-i4", string_i4), &
      & new_unittest("string-i8", string_i8)]

end subroutine collect_utils


subroutine string_i1(error)
   use tomlf_constants, only : tf_i1
   use tomlf_utils, only : to_string

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check(error, to_string(-huge(1_tf_i1) - 1_tf_i1), "-128")
end subroutine string_i1


subroutine string_i2(error)
   use tomlf_constants, only : tf_i2
   use tomlf_utils, only : to_string

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check(error, to_string(-huge(1_tf_i2) - 1_tf_i2), "-32768")
end subroutine string_i2


subroutine string_i4(error)
   use tomlf_constants, only : tf_i4
   use tomlf_utils, only : to_string

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check(error, to_string(-huge(1_tf_i4) - 1_tf_i4), "-2147483648")
end subroutine string_i4


subroutine string_i8(error)
   use tomlf_constants, only : tfi
   use tomlf_utils, only : to_string

   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   call check(error, to_string(-huge(1_tfi) - 1_tfi), "-9223372036854775808")
end subroutine string_i8


end module tftest_utils

module ddx_cinterface
    use, intrinsic :: iso_c_binding
    use ddx
    implicit none

    type ddx_setup_type
        type(ddx_params_type)    :: params
        type(ddx_constants_type) :: constants
        type(ddx_workspace_type) :: workspace
    end type ddx_setup_type

contains
!
! Generic stuff
!
subroutine ddx_get_banner(message, maxlen) bind(C)
    integer(c_int), intent(in), value :: maxlen
    character(len=1, kind=C_char), intent(out) :: message(maxlen)
    integer :: length, i
    character (len=4095) :: header
    call get_banner(header)
    message(maxlen) = c_null_char
    length = min(maxlen-1, 4095)
    do i = length, 1, -1
        if (header(i:i) .eq. ' ') then
            length = i-1
        else
            exit
        endif
    enddo
    message(length + 1) = c_null_char
    do i = 1, length
        message(i) = header(i:i)
    enddo
end

function ddx_supported_lebedev_grids(n, grids) result(c_ngrids) bind(C)
    integer(c_int), intent(in), value ::  n
    integer(c_int), intent(out) :: grids(n)
    integer(c_int) :: c_ngrids
    c_ngrids = min(n, nllg)
    grids(1:c_ngrids) = ng0(1:c_ngrids)
end

! With reference to a atomic sphere `sphere` of radius `r` centred at `a` compute:
!       4π     |x - a|^l
!     ------  ----------- Y_l^m(|x - a|)
!     2l + 1       r^l
! lmax should be identical to the value stored inside c_ddx or less.
subroutine ddx_scaled_ylm(c_ddx, lmax, x, sphere, ylm) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    integer(c_int), intent(in), value :: lmax
    real(c_double), intent(in) :: x(3)
    integer(c_int), intent(in), value :: sphere
    real(c_double), intent(out) :: ylm((lmax+1)**2)
    real(dp) :: delta(3)
    real(dp) :: ratio, rho, ctheta, stheta, cphi, sphi, dnorm
    real(dp) :: vplm((lmax+1)**2), vcos(lmax+1), vsin(lmax+1)
    double precision, external :: dnrm2
    integer :: ind, m, l
    type(ddx_setup_type), pointer :: ddx_model
    call c_f_pointer(c_ddx, ddx_model)

    associate(rsph => ddx_model%params%rsph, lmax => ddx_model%params%lmax, vscales => ddx_model%constants%vscales)
        delta = x(:) - ddx_model%params%csph(:, sphere)
        dnorm = dnrm2(3, delta, 1)
        delta = delta / dnorm
        call ylmbas(delta, rho, ctheta, stheta, cphi, sphi, lmax, vscales, ylm, vplm, vcos, vsin)
        do l = 0, lmax
            ratio = ddx_model%constants%v4pi2lp1(l+1) * (dnorm / rsph(sphere))**l
            do m = -l, l
                ind = l*(l+1) + m + 1
                ylm(ind) = ylm(ind) * ratio
            enddo
        enddo
    end associate
end

!
! Error
!

function ddx_allocate_error() result(c_error) bind(C)
    type(c_ptr) :: c_error
    type(ddx_error_type), pointer :: ddx_error
    allocate(ddx_error)
    c_error = c_loc(ddx_error)
end function

function ddx_get_error_flag(c_error) result(has_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(ddx_error_type), pointer :: ddx_error
    integer(c_int) :: has_error
    call c_f_pointer(c_error, ddx_error)
    has_error = ddx_error%flag
end

subroutine ddx_get_error_message(c_error, message, maxlen) bind(C)
    type(c_ptr), intent(in), value :: c_error
    integer(c_int), intent(in), value :: maxlen
    character(len=1, kind=C_char), intent(out) :: message(maxlen)
    character(len=2047) :: error_message
    type(ddx_error_type), pointer :: ddx_error
    integer :: length, i
    call c_f_pointer(c_error, ddx_error)
    if (ddx_error%flag .ne. 0) then
        error_message = ddx_error%message
    else
        error_message = ''
    endif

    ! Convert to C message
    message(maxlen) = c_null_char
    length = min(maxlen-1, ddx_error%message_length-1)
    do i = length, 1, -1
        if (error_message(i:i) .eq. ' ') then
            length = i-1
        else
            exit
        endif
    enddo
    message(length + 1) = c_null_char
    do i = 1, length
        message(i) = error_message(i:i)
    enddo
end

!
! Electrostatics container
!
function ddx_allocate_electrostatics(c_ddx, c_error) result(c_electrostatics) bind(C)
    type(c_ptr), intent(in), value :: c_ddx, c_error
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(c_ptr) :: c_electrostatics
    type(ddx_electrostatics_type), pointer :: electrostatics
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    allocate(electrostatics)
    call allocate_electrostatics(ddx_model%params, ddx_model%constants, electrostatics, ddx_error)
    c_electrostatics = c_loc(electrostatics)
end function

subroutine ddx_deallocate_electrostatics(c_electrostatics, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_electrostatics, c_error
    type(ddx_electrostatics_type), pointer :: electrostatics
    type(ddx_error_type), pointer :: ddx_error
    call c_f_pointer(c_electrostatics, electrostatics)
    call c_f_pointer(c_error, ddx_error)
    call deallocate_electrostatics(electrostatics, ddx_error)
    deallocate(electrostatics)
end

subroutine ddx_multipole_electrostatics(c_ddx, nsph, nmultipoles, multipoles, &
        & c_electrostatics, c_error) bind(C)
    implicit none
    type(c_ptr), intent(in), value :: c_ddx, c_electrostatics, c_error
    integer(c_int), intent(in), value :: nsph, nmultipoles
    real(c_double), intent(in) :: multipoles(nmultipoles, nsph)
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_electrostatics_type), pointer :: electrostatics
    integer :: mmax

    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_electrostatics, electrostatics)
    mmax = int(sqrt(dble(nmultipoles)) - 1d0)

    call multipole_electrostatics(ddx_model%params, ddx_model%constants, ddx_model%workspace, &
        & multipoles, mmax, electrostatics, ddx_error)
end
!
! Setup object
!
function ddx_allocate_model(model, enable_force, solvent_epsilon, solvent_kappa, eta, se, lmax, &
        & n_lebedev, incore, maxiter, jacobi_n_diis, enable_fmm, fmm_multipole_lmax, fmm_local_lmax, &
        & n_proc, n_spheres, sphere_centres, sphere_radii, length_logfile, c_logfile, c_error) result(c_ddx) bind(C)
    integer(c_int), intent(in), value :: model, enable_force, lmax, n_lebedev, maxiter, &
        & incore, jacobi_n_diis, enable_fmm, fmm_multipole_lmax, fmm_local_lmax, n_proc, &
        & n_spheres, length_logfile
    real(c_double), intent(in) :: sphere_centres(3, n_spheres), sphere_radii(n_spheres)
    real(c_double), intent(in), value :: eta, se, solvent_epsilon, solvent_kappa
    type(c_ptr), intent(in), value :: c_error
    type(ddx_error_type), pointer :: ddx_error
    !type(c_funptr), value :: printfctn
    type(c_ptr) :: c_ddx
    integer :: passproc, i
    type(ddx_setup_type), pointer :: ddx_model
    character(len=1, kind=C_char), intent(in) :: c_logfile(length_logfile)
    character(len=255) :: logfile

    call c_f_pointer(c_error, ddx_error)

    ! Allocate DDX object
    allocate(ddx_model)
    c_ddx = c_loc(ddx_model)

    ! Convert to Fortran objects
    passproc = n_proc
    logfile = ''
    do i = 1, min(length_logfile, 255)
        if (c_logfile(i) .ne. c_null_char) then
            logfile(i:i) = c_logfile(i)
        endif
    enddo

    call params_init(model, enable_force, solvent_epsilon, solvent_kappa, eta, se, lmax, &
        & n_lebedev, incore, maxiter, jacobi_n_diis, enable_fmm, &
        & fmm_multipole_lmax, fmm_local_lmax, passproc, n_spheres, &
        & sphere_centres, sphere_radii, logfile, ddx_model%params, ddx_error)
    if (ddx_error%flag .ne. 0) then
        return
    endif
    call constants_init(ddx_model%params, ddx_model%constants, ddx_error)
    if (ddx_error%flag .ne. 0) then
        return
    endif
    call workspace_init(ddx_model%params, ddx_model%constants, ddx_model%workspace, ddx_error)
    if (ddx_error%flag .ne. 0) then
        return
    endif
end function

subroutine ddx_deallocate_model(c_ddx, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_ddx, c_error
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call params_free(ddx_model%params, ddx_error)
    call constants_free(ddx_model%constants, ddx_error)
    call workspace_free(ddx_model%workspace, ddx_error)
    deallocate(ddx_model)
end

subroutine ddx_get_logfile(c_ddx, message, maxlen) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    integer(c_int), intent(in), value :: maxlen
    character(len=1, kind=C_char), intent(out) :: message(maxlen)
    type(ddx_setup_type), pointer :: ddx_model
    integer :: length, i
    call c_f_pointer(c_ddx, ddx_model)
    ! Convert to C message
    message(maxlen) = c_null_char
    length = min(maxlen-1, 255)
    do i = length, 1, -1
        if (ddx_model%params%output_filename(i:i) .eq. ' ') then
            length = i-1
        else
            exit
        endif
    enddo
    message(length + 1) = c_null_char
    do i = 1, length
        message(i) = ddx_model%params%output_filename(i:i)
    enddo
end

! Generated block, see scripts/generate_cinterface.py
function ddx_get_enable_fmm(c_ddx) result(c_fmm) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_fmm
    call c_f_pointer(c_ddx, ddx_model)
    c_fmm = ddx_model % params % fmm
end function

function ddx_get_enable_force(c_ddx) result(c_force) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_force
    call c_f_pointer(c_ddx, ddx_model)
    c_force = ddx_model % params % force
end function

function ddx_get_jacobi_n_diis(c_ddx) result(c_jacobi_ndiis) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_jacobi_ndiis
    call c_f_pointer(c_ddx, ddx_model)
    c_jacobi_ndiis = ddx_model % params % jacobi_ndiis
end function

function ddx_get_lmax(c_ddx) result(c_lmax) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_lmax
    call c_f_pointer(c_ddx, ddx_model)
    c_lmax = ddx_model % params % lmax
end function

function ddx_get_incore(c_ddx) result(c_matvecmem) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_matvecmem
    call c_f_pointer(c_ddx, ddx_model)
    c_matvecmem = ddx_model % params % matvecmem
end function

function ddx_get_maxiter(c_ddx) result(c_maxiter) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_maxiter
    call c_f_pointer(c_ddx, ddx_model)
    c_maxiter = ddx_model % params % maxiter
end function

function ddx_get_model(c_ddx) result(c_model) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_model
    call c_f_pointer(c_ddx, ddx_model)
    c_model = ddx_model % params % model
end function

function ddx_get_n_lebedev(c_ddx) result(c_ngrid) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_ngrid
    call c_f_pointer(c_ddx, ddx_model)
    c_ngrid = ddx_model % params % ngrid
end function

function ddx_get_n_spheres(c_ddx) result(c_nsph) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_nsph
    call c_f_pointer(c_ddx, ddx_model)
    c_nsph = ddx_model % params % nsph
end function

function ddx_get_n_proc(c_ddx) result(c_nproc) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_nproc
    call c_f_pointer(c_ddx, ddx_model)
    c_nproc = ddx_model % params % nproc
end function

function ddx_get_fmm_local_lmax(c_ddx) result(c_pl) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_pl
    call c_f_pointer(c_ddx, ddx_model)
    c_pl = ddx_model % params % pl
end function

function ddx_get_fmm_multipole_lmax(c_ddx) result(c_pm) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_pm
    call c_f_pointer(c_ddx, ddx_model)
    c_pm = ddx_model % params % pm
end function

function ddx_get_solvent_epsilon(c_ddx) result(c_eps) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    real(c_double) :: c_eps
    call c_f_pointer(c_ddx, ddx_model)
    c_eps = ddx_model % params % eps
end function

function ddx_get_eta(c_ddx) result(c_eta) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    real(c_double) :: c_eta
    call c_f_pointer(c_ddx, ddx_model)
    c_eta = ddx_model % params % eta
end function

function ddx_get_solvent_kappa(c_ddx) result(c_kappa) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    real(c_double) :: c_kappa
    call c_f_pointer(c_ddx, ddx_model)
    c_kappa = ddx_model % params % kappa
end function

function ddx_get_shift(c_ddx) result(c_se) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    real(c_double) :: c_se
    call c_f_pointer(c_ddx, ddx_model)
    c_se = ddx_model % params % se
end function

subroutine ddx_get_sphere_centres(c_ddx, nsph, c_csph) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    integer(c_int), intent(in), value :: nsph
    real(c_double), intent(out) :: c_csph(3, nsph)
    type(ddx_setup_type), pointer :: ddx_model
    call c_f_pointer(c_ddx, ddx_model)
    c_csph(:, :) = ddx_model % params % csph(:, :)
end subroutine

subroutine ddx_get_sphere_radii(c_ddx, nsph, c_rsph) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    integer(c_int), intent(in), value :: nsph
    real(c_double), intent(out) :: c_rsph(nsph)
    type(ddx_setup_type), pointer :: ddx_model
    call c_f_pointer(c_ddx, ddx_model)
    c_rsph(:) = ddx_model % params % rsph(:)
end subroutine

function ddx_get_n_basis(c_ddx) result(c_nbasis) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_nbasis
    call c_f_pointer(c_ddx, ddx_model)
    c_nbasis = ddx_model % constants % nbasis
end function

function ddx_get_n_cav(c_ddx) result(c_ncav) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int) :: c_ncav
    call c_f_pointer(c_ddx, ddx_model)
    c_ncav = ddx_model % constants % ncav
end function

subroutine ddx_get_cavity(c_ddx, ncav, c_ccav) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    integer(c_int), intent(in), value :: ncav
    real(c_double), intent(out) :: c_ccav(3, ncav)
    type(ddx_setup_type), pointer :: ddx_model
    call c_f_pointer(c_ddx, ddx_model)
    c_ccav(:, :) = ddx_model % constants % ccav(:, :)
end subroutine
! end generated block

!
! State object
!
function ddx_allocate_state(c_ddx, c_error) result(c_state) bind(C)
    type(c_ptr), intent(in), value :: c_ddx, c_error
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(c_ptr) :: c_state
    type(ddx_state_type), pointer :: state
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    allocate(state)
    call allocate_state(ddx_model%params, ddx_model%constants, state, ddx_error)
    c_state = c_loc(state)
end function

subroutine ddx_deallocate_state(c_state, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_state, c_error
    type(ddx_state_type), pointer :: state
    type(ddx_error_type), pointer :: ddx_error
    call c_f_pointer(c_state, state)
    call c_f_pointer(c_error, ddx_error)
    call deallocate_state(state, ddx_error)
    deallocate(state)
end subroutine

subroutine ddx_get_x(c_state, nbasis, nsph, x) bind(C)
    type(c_ptr), intent(in), value :: c_state
    type(ddx_state_type), pointer :: state
    integer(c_int), intent(in), value :: nsph, nbasis
    real(c_double), intent(out)  :: x(nbasis, nsph)
    call c_f_pointer(c_state, state)

    if (allocated(state%x_lpb)) then  ! Case for ddLPB
        x(:, :) = state%x_lpb(:, :, 1)  ! Use only the first of the two solutions
    else
        x(:, :) = state%xs(:, :)
    endif
end subroutine

function ddx_get_x_niter(c_state) bind(C) result(c_niter)
    type(c_ptr), intent(in), value :: c_state
    type(ddx_state_type), pointer :: state
    integer(c_int) :: c_niter
    call c_f_pointer(c_state, state)
    if (allocated(state%x_lpb)) then  ! Case for ddLPB
        c_niter = state%x_lpb_niter
    else
        c_niter = state%xs_niter
    endif
end function

subroutine ddx_get_s(c_state, nbasis, nsph, s) bind(C)
    type(c_ptr), intent(in), value :: c_state
    type(ddx_state_type), pointer :: state
    integer(c_int), intent(in), value :: nsph, nbasis
    real(c_double), intent(out)  :: s(nbasis, nsph)
    call c_f_pointer(c_state, state)
    if (allocated(state%x_adj_lpb)) then  ! Case for ddLPB
        s(:, :) = state%x_adj_lpb(:, :, 1)  ! Use only the first of the two solutions
    else
        s(:, :) = state%s(:, :)
    endif
end subroutine

function ddx_get_s_niter(c_state) bind(C) result(c_niter)
    type(c_ptr), intent(in), value :: c_state
    type(ddx_state_type), pointer :: state
    integer(c_int) :: c_niter
    call c_f_pointer(c_state, state)
    if (allocated(state%x_adj_lpb)) then  ! Case for ddLPB
        c_niter = state%x_adj_lpb_niter
    else
        c_niter = state%s_niter
    endif
end function

subroutine ddx_get_xi(c_state, c_ddx, ncav, xi) bind(C)
    type(c_ptr), intent(in), value :: c_state, c_ddx
    type(ddx_state_type), pointer :: state
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int), intent(in), value :: ncav
    real(c_double), intent(out)  :: xi(ncav)
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_state, state)
    call ddproject_cav(ddx_model%params, ddx_model%constants, state%q, xi)
end subroutine

subroutine ddx_get_zeta_dip(c_state, c_ddx, ncav, zeta_dip) bind(C)
    type(c_ptr), intent(in), value :: c_state, c_ddx
    type(ddx_state_type), pointer :: state
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int), intent(in), value :: ncav
    real(c_double), intent(out)  :: zeta_dip(3, ncav)
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_state, state)
    if (allocated(state%zeta_dip)) then
        zeta_dip(:, :) = state%zeta_dip(:, :)
    else
        zeta_dip(:, :) = 0d0
    endif
end subroutine

!
! High level APIs (model nonspecific)
!
function ddx_ddrun(c_ddx, c_state, c_electrostatics, nbasis, nsph, &
        & psi, tol, force, read_guess, c_error) result(c_energy) bind(C)
    type(c_ptr), intent(in), value :: c_ddx, c_state, c_electrostatics, &
        & c_error
    integer(c_int), intent(in), value :: nbasis, nsph
    real(c_double), intent(in) :: psi(nbasis, nsph)
    real(c_double), intent(in), value :: tol
    real(c_double), intent(out) :: force(3, nsph)
    real(c_double) :: c_energy
    integer(c_int), intent(in), value :: read_guess
    type(ddx_setup_type), pointer :: ddx_model
    logical :: do_guess

    ! at least return something in case of errors
    c_energy = zero

    ! setup
    do_guess = read_guess.eq.0
    call c_f_pointer(c_ddx, ddx_model)
    call ddx_setup(c_ddx, c_state, c_electrostatics, nbasis, nsph, psi, c_error)
    if (ddx_get_error_flag(c_error) .ne. 0) return

    ! primal linear system
    if (do_guess) then
        call ddx_fill_guess(c_ddx, c_state, tol, c_error)
        if (ddx_get_error_flag(c_error) .ne. 0) return
    end if
    call ddx_solve(c_ddx, c_state, tol, c_error)
    if (ddx_get_error_flag(c_error) .ne. 0) return

    ! energy
    c_energy = ddx_energy(c_ddx, c_state, c_error)
    if (ddx_get_error_flag(c_error) .ne. 0) return

    ! adjoint linear system
    if (ddx_model%params%force .eq. 1) then
        if (do_guess) then
            call ddx_fill_guess_adjoint(c_ddx, c_state, tol, c_error)
        end if
        if (ddx_get_error_flag(c_error) .ne. 0) return
        call ddx_solve_adjoint(c_ddx, c_state, tol, c_error)
        if (ddx_get_error_flag(c_error) .ne. 0) return
    end if

    ! forces
    if (ddx_model%params%force .eq. 1) then
        call ddx_solvation_force_terms(c_ddx, c_state, c_electrostatics, &
            & nsph, force, c_error)
        if (ddx_get_error_flag(c_error) .ne. 0) return
    end if

end function

subroutine ddx_setup(c_ddx, c_state, c_electrostatics, nbasis, nsph, psi, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_ddx, c_state, c_electrostatics, &
        & c_error
    integer(c_int), intent(in), value :: nbasis, nsph
    real(c_double), intent(in) :: psi(nbasis, nsph)
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_state_type), pointer :: state
    type(ddx_electrostatics_type), pointer :: electrostatics
    type(ddx_error_type), pointer :: ddx_error
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_state, state)
    call c_f_pointer(c_electrostatics, electrostatics)
    call c_f_pointer(c_error, ddx_error)
    call setup(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, &
        & electrostatics, psi, ddx_error)
end subroutine

subroutine ddx_fill_guess(c_ddx, c_state, tol, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_ddx, c_state, c_error
    real(c_double), intent(in), value :: tol
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_state_type), pointer :: state
    type(ddx_error_type), pointer :: ddx_error
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_state, state)
    call c_f_pointer(c_error, ddx_error)
    call fill_guess(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, &
        & tol, ddx_error)
end subroutine

subroutine ddx_fill_guess_adjoint(c_ddx, c_state, tol, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_ddx, c_state, c_error
    real(c_double), intent(in), value :: tol
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_state_type), pointer :: state
    type(ddx_error_type), pointer :: ddx_error
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_state, state)
    call c_f_pointer(c_error, ddx_error)
    call fill_guess_adjoint(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, &
        & tol, ddx_error)
end subroutine

subroutine ddx_solve(c_ddx, c_state, tol, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_ddx, c_state, c_error
    real(c_double), intent(in), value :: tol
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_state_type), pointer :: state
    type(ddx_error_type), pointer :: ddx_error
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_state, state)
    call c_f_pointer(c_error, ddx_error)
    call solve(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, tol, ddx_error)
end subroutine

subroutine ddx_solve_adjoint(c_ddx, c_state, tol, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_ddx, c_state, c_error
    real(c_double), intent(in), value :: tol
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_state_type), pointer :: state
    type(ddx_error_type), pointer :: ddx_error
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_state, state)
    call c_f_pointer(c_error, ddx_error)
    call solve_adjoint(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, &
        & tol, ddx_error)
end subroutine

function ddx_energy(c_ddx, c_state, c_error) result(c_energy) bind(C)
    type(c_ptr), intent(in), value :: c_ddx, c_state, c_error
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_state_type), pointer :: state
    type(ddx_error_type), pointer :: ddx_error
    real(c_double) :: c_energy
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_state, state)
    call c_f_pointer(c_error, ddx_error)
    call energy(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, &
        & c_energy, ddx_error)
end function

subroutine ddx_solvation_force_terms(c_ddx, c_state, c_electrostatics, &
        & nsph, forces, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_ddx, c_state, c_electrostatics, &
        & c_error
    integer(c_int), intent(in), value :: nsph
    real(c_double), intent(out) :: forces(3, nsph)
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_state_type), pointer :: state
    type(ddx_electrostatics_type), pointer :: electrostatics
    type(ddx_error_type), pointer :: ddx_error
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_state, state)
    call c_f_pointer(c_electrostatics, electrostatics)
    call c_f_pointer(c_error, ddx_error)
    call solvation_force_terms(ddx_model%params, ddx_model%constants, ddx_model%workspace, &
        & state, electrostatics, forces, ddx_error)
end subroutine

!
! Cosmo
!
! Setup the problem in the state
subroutine ddx_cosmo_setup(c_ddx, c_state, ncav, nbasis, nsph, psi, phi_cav, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    integer(c_int), intent(in), value :: ncav, nbasis, nsph
    real(c_double), intent(in) :: phi_cav(ncav), psi(nbasis, nsph)
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call cosmo_setup(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, phi_cav, psi, ddx_error)
end subroutine

! Put a guess for the problem into the state (optional)
subroutine ddx_cosmo_guess(c_ddx, c_state, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call cosmo_guess(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, ddx_error)
end

! Solve the problem
subroutine ddx_cosmo_solve(c_ddx, c_state, tol, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    real(c_double), intent(in), value :: tol
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call cosmo_solve(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, tol, ddx_error)
end subroutine

! Put a guess for the adjoint problem into the state (optional)
subroutine ddx_cosmo_guess_adjoint(c_ddx, c_state, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call cosmo_guess_adjoint(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, ddx_error)
end

! Solve the adjoint problem inside the state
subroutine ddx_cosmo_solve_adjoint(c_ddx, c_state, tol, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    real(c_double), intent(in), value :: tol
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call cosmo_solve_adjoint(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, tol, ddx_error)
end

! Compute the ddCOSMO energy
function ddx_cosmo_energy(c_ddx, c_state, c_error) result(c_energy) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    real(c_double) :: c_energy
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call cosmo_energy(ddx_model%constants, state, c_energy, ddx_error)
end function

! Compute the forces
subroutine ddx_cosmo_solvation_force_terms(c_ddx, c_state, nsph, ncav, e_cav, forces, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    integer(c_int), intent(in), value :: nsph, ncav
    real(c_double), intent(in) :: e_cav(3, ncav)
    real(c_double), intent(out) :: forces(3, nsph)
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call cosmo_solvation_force_terms(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, e_cav, forces, ddx_error)
end

!
! PCM
!
subroutine ddx_pcm_setup(c_ddx, c_state, ncav, nbasis, nsph, psi, phi_cav, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    integer(c_int), intent(in), value :: ncav, nbasis, nsph
    real(c_double), intent(in) :: phi_cav(ncav), psi(nbasis, nsph)
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call pcm_setup(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, phi_cav, psi, ddx_error)
end subroutine

subroutine ddx_pcm_guess(c_ddx, c_state, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call pcm_guess(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, ddx_error)
end

subroutine ddx_pcm_solve(c_ddx, c_state, tol, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    real(c_double), intent(in), value :: tol
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call pcm_solve(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, tol, ddx_error)
end subroutine

subroutine ddx_pcm_guess_adjoint(c_ddx, c_state, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call pcm_guess_adjoint(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, ddx_error)
end

subroutine ddx_pcm_solve_adjoint(c_ddx, c_state, tol, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    real(c_double), intent(in), value :: tol
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call pcm_solve_adjoint(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, tol, ddx_error)
end

function ddx_pcm_energy(c_ddx, c_state, c_error) result(c_energy) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    real(c_double) :: c_energy
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call pcm_energy(ddx_model%constants, state, c_energy, ddx_error)
end function

subroutine ddx_pcm_solvation_force_terms(c_ddx, c_state, nsph, ncav, e_cav, forces, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    integer(c_int), intent(in), value :: nsph, ncav
    real(c_double), intent(in) :: e_cav(3, ncav)
    real(c_double), intent(out) :: forces(3, nsph)
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call pcm_solvation_force_terms(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, e_cav, forces, ddx_error)
end

!
! LPB
!
subroutine ddx_lpb_setup(c_ddx, c_state, ncav, nbasis, nsph, psi, phi_cav, gradphi_cav, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    integer(c_int), intent(in), value :: ncav, nbasis, nsph
    real(c_double), intent(in) :: phi_cav(ncav), psi(nbasis, nsph), gradphi_cav(3, ncav)
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call lpb_setup(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, phi_cav, gradphi_cav, psi, ddx_error)
end subroutine

subroutine ddx_lpb_guess(c_ddx, c_state, tol, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    real(c_double), intent(in), value :: tol
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call lpb_guess(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, tol, ddx_error)
end

subroutine ddx_lpb_solve(c_ddx, c_state, tol, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    real(c_double), intent(in), value :: tol
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call lpb_solve(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, tol, ddx_error)
end subroutine

subroutine ddx_lpb_guess_adjoint(c_ddx, c_state, tol, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    real(c_double), intent(in), value :: tol
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call lpb_guess_adjoint(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, tol, ddx_error)
end

subroutine ddx_lpb_solve_adjoint(c_ddx, c_state, tol, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    real(c_double), intent(in), value :: tol
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call lpb_solve_adjoint(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, tol, ddx_error)
end

function ddx_lpb_energy(c_ddx, c_state, c_error) result(c_energy) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    real(c_double) :: c_energy
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call lpb_energy(ddx_model%constants, state, c_energy, ddx_error)
end function

subroutine ddx_lpb_solvation_force_terms(c_ddx, c_state, nsph, ncav, g_cav, forces, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    integer(c_int), intent(in), value :: nsph, ncav
    real(c_double), intent(in) :: g_cav(3, 3, ncav)
    real(c_double), intent(out) :: forces(3, nsph)
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    call lpb_solvation_force_terms(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, g_cav, forces, ddx_error)
end

!
! multipolar solutes
!
subroutine ddx_multipole_electrostatics_0(c_ddx, nsph, ncav, nmultipoles, multipoles, &
        & phi_cav, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    integer(c_int), intent(in), value :: nsph, ncav, nmultipoles
    real(c_double), intent(in) :: multipoles(nmultipoles, nsph)
    real(c_double), intent(out) :: phi_cav(ncav)
    type(c_ptr), intent(in), value :: c_error
    type(ddx_error_type), pointer :: ddx_error
    integer :: mmax
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_ddx, ddx_model)
    mmax = int(sqrt(dble(nmultipoles)) - 1d0)
    call multipole_electrostatics_0(ddx_model%params, ddx_model%constants, &
        & ddx_model%workspace, multipoles, mmax, phi_cav, ddx_error)
end

subroutine ddx_multipole_electrostatics_1(c_ddx, nsph, ncav, nmultipoles, multipoles, &
        & phi_cav, e_cav, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    integer(c_int), intent(in), value :: nsph, ncav, nmultipoles
    real(c_double), intent(in) :: multipoles(nmultipoles, nsph)
    real(c_double), intent(out) :: phi_cav(ncav), e_cav(3, ncav)
    integer :: mmax
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    mmax = int(sqrt(dble(nmultipoles)) - 1d0)
    call multipole_electrostatics_1(ddx_model%params, ddx_model%constants, &
        & ddx_model%workspace, multipoles, mmax, phi_cav, e_cav, ddx_error)
end

subroutine ddx_multipole_electrostatics_2(c_ddx, nsph, ncav, nmultipoles, multipoles, &
        & phi_cav, e_cav, g_cav, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    integer(c_int), intent(in), value :: nsph, ncav, nmultipoles
    real(c_double), intent(in) :: multipoles(nmultipoles, nsph)
    real(c_double), intent(out) :: phi_cav(ncav), e_cav(3, ncav), g_cav(3, 3, ncav)
    integer :: mmax
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    mmax = int(sqrt(dble(nmultipoles)) - 1d0)
    call multipole_electrostatics_2(ddx_model%params, ddx_model%constants, &
        & ddx_model%workspace, multipoles, mmax, phi_cav, e_cav, g_cav, ddx_error)
end

subroutine ddx_multipole_psi(c_ddx, nbasis, nsph, nmultipoles, multipoles, psi, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    integer(c_int), intent(in), value :: nmultipoles, nsph, nbasis
    real(c_double), intent(in) :: multipoles(nmultipoles, nsph)
    real(c_double), intent(out) :: psi(nbasis, nsph)
    integer :: mmax
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    mmax = int(sqrt(dble(nmultipoles)) - 1d0)
    call multipole_psi(ddx_model%params, multipoles, mmax, psi)
end

subroutine ddx_multipole_force_terms(c_ddx, c_state, nsph, nmultipoles, multipoles, &
        & forces, c_error) bind(C)
    type(c_ptr), intent(in), value :: c_error
    type(c_ptr), intent(in), value :: c_ddx, c_state
    type(ddx_setup_type), pointer :: ddx_model
    type(ddx_error_type), pointer :: ddx_error
    type(ddx_state_type), pointer :: state
    integer(c_int), intent(in), value :: nmultipoles, nsph
    integer :: mmax
    real(c_double), intent(in) :: multipoles(nmultipoles, nsph)
    real(c_double), intent(inout) :: forces(3, nsph)
    call c_f_pointer(c_ddx, ddx_model)
    call c_f_pointer(c_error, ddx_error)
    call c_f_pointer(c_state, state)
    mmax = int(sqrt(dble(nmultipoles)) - 1d0)
    forces = zero
    call multipole_force_terms(ddx_model%params, ddx_model%constants, ddx_model%workspace, state, mmax, &
        & multipoles, forces, ddx_error)
end

end

! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.

!> Generic interface to define damping functions for the DFT-D4 model
module dftd4_damping
   use mctc_env, only : wp
   use mctc_io, only : structure_type
   implicit none

   public :: damping_param, dispersion_interface


   type, abstract :: damping_param
   contains
      generic :: get_dispersion2 => get_dispersion2_impl, get_dispersion2_compat
      procedure(dispersion_interface), deferred :: get_dispersion2_impl
      procedure :: get_dispersion2_compat
      generic :: get_dispersion3 => get_dispersion3_impl, get_dispersion3_compat
      procedure(dispersion_interface), deferred :: get_dispersion3_impl
      procedure :: get_dispersion3_compat
      generic :: get_pairwise_dispersion2 => get_pairwise_dispersion2_impl, get_pairwise_dispersion2_compat
      procedure(pairwise_dispersion_interface), deferred :: get_pairwise_dispersion2_impl
      procedure :: get_pairwise_dispersion2_compat
      generic :: get_pairwise_dispersion3 => get_pairwise_dispersion3_impl, get_pairwise_dispersion3_compat
      procedure(pairwise_dispersion_interface), deferred :: get_pairwise_dispersion3_impl
      procedure :: get_pairwise_dispersion3_compat
   end type damping_param


   abstract interface
      !> Evaluation of the dispersion energy expression
      subroutine dispersion_interface(self, mol, trans, cutoff, width, r4r2, &
            & c6, dc6dcn, dc6dq, energy, dEdcn, dEdq, gradient, sigma)
         import :: structure_type, damping_param, wp

         !> Damping parameters
         class(damping_param), intent(in) :: self

         !> Molecular structure data
         class(structure_type), intent(in) :: mol

         !> Lattice points
         real(wp), intent(in) :: trans(:, :)

         !> Real space cutoff
         real(wp), intent(in) :: cutoff

         !> Width of smooth cutoff
         real(wp), intent(in) :: width

         !> Expectation values for r4 over r2 operator
         real(wp), intent(in) :: r4r2(:)

         !> C6 coefficients for all atom pairs.
         real(wp), intent(in) :: c6(:, :)

         !> Derivative of the C6 w.r.t. the coordination number
         real(wp), intent(in), optional :: dc6dcn(:, :)

         !> Derivative of the C6 w.r.t. the partial charges
         real(wp), intent(in), optional :: dc6dq(:, :)

         !> Dispersion energy
         real(wp), intent(inout) :: energy(:)

         !> Derivative of the energy w.r.t. the coordination number
         real(wp), intent(inout), optional :: dEdcn(:)

         !> Derivative of the energy w.r.t. the partial charges
         real(wp), intent(inout), optional :: dEdq(:)

         !> Dispersion gradient
         real(wp), intent(inout), optional :: gradient(:, :)

         !> Dispersion virial
         real(wp), intent(inout), optional :: sigma(:, :)
      end subroutine dispersion_interface

      !> Evaluation of the pairwise representation of the dispersion energy
      subroutine pairwise_dispersion_interface(self, mol, trans, cutoff, width, r4r2, c6, energy)
         import :: structure_type, damping_param, wp

         !> Damping parameters
         class(damping_param), intent(in) :: self

         !> Molecular structure data
         class(structure_type), intent(in) :: mol

         !> Lattice points
         real(wp), intent(in) :: trans(:, :)

         !> Real space cutoff
         real(wp), intent(in) :: cutoff

         !> Width of smooth cutoff
         real(wp), intent(in) :: width

         !> Expectation values for r4 over r2 operator
         real(wp), intent(in) :: r4r2(:)

         !> C6 coefficients for all atom pairs.
         real(wp), intent(in) :: c6(:, :)

         !> Pairwise representation of the dispersion energy
         real(wp), intent(inout) :: energy(:, :)
      end subroutine pairwise_dispersion_interface
   end interface

contains

!> Evaluation of the dispersion energy expression
subroutine get_dispersion2_compat(self, mol, trans, cutoff, r4r2, &
      & c6, dc6dcn, dc6dq, energy, dEdcn, dEdq, gradient, sigma)

   !> Damping parameters
   class(damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Derivative of the C6 w.r.t. the coordination number
   real(wp), intent(in), optional :: dc6dcn(:, :)

   !> Derivative of the C6 w.r.t. the partial charges
   real(wp), intent(in), optional :: dc6dq(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:)

   !> Derivative of the energy w.r.t. the coordination number
   real(wp), intent(inout), optional :: dEdcn(:)

   !> Derivative of the energy w.r.t. the partial charges
   real(wp), intent(inout), optional :: dEdq(:)

   !> Dispersion gradient
   real(wp), intent(inout), optional :: gradient(:, :)

   !> Dispersion virial
   real(wp), intent(inout), optional :: sigma(:, :)

   call self%get_dispersion2(mol, trans, cutoff, 0.0_wp, r4r2, c6, &
      & dc6dcn, dc6dq, energy, dEdcn, dEdq, gradient, sigma)
end subroutine get_dispersion2_compat

!> Evaluation of the dispersion energy expression
subroutine get_dispersion3_compat(self, mol, trans, cutoff, r4r2, &
      & c6, dc6dcn, dc6dq, energy, dEdcn, dEdq, gradient, sigma)

   !> Damping parameters
   class(damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Derivative of the C6 w.r.t. the coordination number
   real(wp), intent(in), optional :: dc6dcn(:, :)

   !> Derivative of the C6 w.r.t. the partial charges
   real(wp), intent(in), optional :: dc6dq(:, :)

   !> Dispersion energy
   real(wp), intent(inout) :: energy(:)

   !> Derivative of the energy w.r.t. the coordination number
   real(wp), intent(inout), optional :: dEdcn(:)

   !> Derivative of the energy w.r.t. the partial charges
   real(wp), intent(inout), optional :: dEdq(:)

   !> Dispersion gradient
   real(wp), intent(inout), optional :: gradient(:, :)

   !> Dispersion virial
   real(wp), intent(inout), optional :: sigma(:, :)

   call self%get_dispersion3(mol, trans, cutoff, 0.0_wp, r4r2, c6, &
      & dc6dcn, dc6dq, energy, dEdcn, dEdq, gradient, sigma)
end subroutine get_dispersion3_compat

!> Evaluation of the pairwise representation of the dispersion energy
subroutine get_pairwise_dispersion2_compat(self, mol, trans, cutoff, r4r2, c6, energy)

   !> Damping parameters
   class(damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Pairwise representation of the dispersion energy
   real(wp), intent(inout) :: energy(:, :)

   call self%get_pairwise_dispersion2(mol, trans, cutoff, 0.0_wp, r4r2, c6, energy)
end subroutine get_pairwise_dispersion2_compat

!> Evaluation of the pairwise representation of the dispersion energy
subroutine get_pairwise_dispersion3_compat(self, mol, trans, cutoff, r4r2, c6, energy)

   !> Damping parameters
   class(damping_param), intent(in) :: self

   !> Molecular structure data
   class(structure_type), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Expectation values for r4 over r2 operator
   real(wp), intent(in) :: r4r2(:)

   !> C6 coefficients for all atom pairs.
   real(wp), intent(in) :: c6(:, :)

   !> Pairwise representation of the dispersion energy
   real(wp), intent(inout) :: energy(:, :)

   call self%get_pairwise_dispersion3(mol, trans, cutoff, 0.0_wp, r4r2, c6, energy)
end subroutine get_pairwise_dispersion3_compat

end module dftd4_damping

!> @copyright (c) 2020-2021 RWTH Aachen. All rights reserved.
!!
!! ddX software
!!
!! @file tests/ddlpb_esolv_iterations.f90
!! Test for solvation energy and number of outer iterations for different
!! values of input parameter
!! NOTE: This test is not a definitive test. If the values are different
!!       maybe the new ones are correct as they might be improved values.
!!       But, the default values should be used as a benchmark
!!
!! @version 1.0.0
!! @author Abhinav Jha
!! @date 2022-03-28

program main
use ddx_core
use ddx_operators
use ddx_solvers
use ddx_lpb
use ddx_legacy
use ddx
implicit none

character(len=255) :: fname
type(ddx_type) :: ddx_data
type(ddx_error_type) :: error

real(dp) :: esolv, default_value, tol
integer :: i, istatus, default_lmax_val, n_iter
real(dp), allocatable :: default_epsilon(:), default_eta(:), &
                       & default_kappa(:), default_lmax(:)
integer, allocatable :: default_iter_epsilon(:), default_iter_eta(:), &
                       & default_iter_kappa(:), default_iter_lmax(:)
real(dp), allocatable :: charges(:)

real(dp), external :: dnrm2
character(len=255) :: dummy_file_name = ''

! Read input file name
call get_command_argument(1, fname)
write(*, *) "Using provided file ", trim(fname), " as a config file"
call ddfromfile(fname, ddx_data, tol, charges, error)
call check_error(error)

! Allocation for variable vectors
! default_"variable_name" : These are the precomputed values
! computed_"variable_name" : These are the computed values
allocate(default_epsilon(4), default_eta(4), &
       & default_kappa(4), default_lmax(4), &
       & default_iter_epsilon(4), default_iter_eta(4), &
       & default_iter_kappa(4), default_iter_lmax(4), stat=istatus)

if (istatus.ne.0) write(6,*) 'Allocation failed'

!Default values precomputed
!epsilon_solv : 2, 20, 200, 2000

default_epsilon = (/ -5.3280230267698165E-004, -9.7406452041931936E-004, &
                   & -1.0243211234919017E-003, -1.0294180585685288E-003 /)

! obsolete case: lmax0 = min(6, lmax), ngrid ~ 200
! default_epsilon = (/ -5.3518110117345332E-004, -9.7393853923451006E-004, &
!                    & -1.0237954253809903E-003, -1.0288501533655906E-003 /)

!eta : 0.0001, 0.001, 0.01, 0.1
default_eta = (/ -1.0151699327713233E-003, -1.0152224349631500E-003, &
               & -1.0153111171958898E-003, -1.0155598899696948E-003 /)

! obsolete case: lmax0 = min(6, lmax), ngrid ~ 200
! default_eta = (/ -1.0144763156304426E-003, -1.0144763156304426E-003, &
!                & -1.0144761325115853E-003, -1.0151060052969220E-003 /)

!kappa : 0.5, 0.25, 0.16667, 0.125
default_kappa = (/ -1.0233753433615445E-003, -1.0197139938641997E-003, &
                 & -1.0175938367002952E-003, -1.0162805489436332E-003 /)

! obsolete case: lmax0 = min(6, lmax), ngrid ~ 200
! default_kappa = (/ -1.0228739915625511E-003, -1.0192321310712657E-003,&
!                  & -1.0171251065945882E-003, -1.0158211256043079E-003 /)

!lmax : 2, 4, 8, 16
default_lmax = (/ -1.0000499299268406E-003, -1.0131496803324205E-003, &
                & -1.0163417969913872E-003, -1.0180392518042718E-003 /)

! obsolete case: lmax0 = min(6, lmax), ngrid ~ 200
! default_lmax = (/ -9.9977268971430206E-004, -1.0128441259120659E-003, &
!               & -1.0157913843224611E-003, -1.0177420746553952E-003 /)

!Default values precomputed
!epsilon_solv : 2, 20, 200, 2000
default_iter_epsilon = (/ 7, 8, 7, 7 /)

!eta : 0.0001, 0.001, 0.01, 0.1
default_iter_eta = (/ 8, 8, 8, 8 /)
!kappa : 0.5, 0.25, 0.16667, 0.125
default_iter_kappa = (/ 7, 7, 8, 8 /)
!lmax : 2, 4, 8, 16
default_iter_lmax = (/ 7, 7, 8, 8 /)

! Initial values
esolv = zero
n_iter = zero
! Computation for different eps_solv
write(*,*) 'Varying values of epsilon_solv'
do i = 1, 4
  default_value = 0.2*(10**i)
  write(*,*) 'epsilon_solv : ', default_value
  esolv = zero
  call test_solve(ddx_data, esolv, n_iter, default_value, &
           & ddx_data % params % eta, ddx_data % params % kappa, &
           & ddx_data % params % lmax, tol, charges)
  call check_values(default_epsilon(i), esolv)
  call check_iter_values(default_iter_epsilon(i), n_iter)
end do


! Computation for different eta
write(*,*) 'Varying values of eta'
do i = 1, 4
  default_value = 0.00001*(10**i)
  write(*,*) 'eta : ', default_value
  esolv = zero
  call test_solve(ddx_data, esolv, n_iter, ddx_data % params % eps, &
           & default_value, ddx_data % params % kappa, &
           & ddx_data % params % lmax, tol, charges)
  call check_values(default_eta(i), esolv)
  call check_iter_values(default_iter_eta(i), n_iter)
end do

! Computation for different kappa
write(*,*) 'Varying values of kappa'
do i = 1, 4
  default_value = 1.0/(2.0*i)
  write(*,*) 'kappa : ', default_value
  esolv = zero
  call test_solve(ddx_data, esolv, n_iter, ddx_data % params % eps, &
           & ddx_data % params % eta, default_value, &
           & ddx_data % params % lmax, tol, charges)
  call check_values(default_kappa(i), esolv)
  call check_iter_values(default_iter_kappa(i), n_iter)
end do

! Computation for different lmax
write(*,*) 'Varying values of lmax'
do i = 1, 4
  default_lmax_val = 2**i
  write(*,*) 'lmax : ', default_lmax_val
  esolv = zero
  call test_solve(ddx_data, esolv, n_iter, ddx_data % params % eps, &
           & ddx_data % params % eta, &
           & ddx_data % params % kappa, default_lmax_val, tol, charges)
  call check_values(default_lmax(i), esolv)
  call check_iter_values(default_iter_lmax(i), n_iter)
end do

deallocate(default_epsilon, default_eta, &
       & default_kappa, default_lmax, &
       & default_iter_epsilon, default_iter_eta, &
       & default_iter_kappa, default_iter_lmax, charges, stat = istatus)

if (istatus.ne.0) write(6,*) 'Deallocation failed'

call deallocate_model(ddx_data, error)

contains

subroutine test_solve(ddx_data, esolv_in, n_iter, epsilon_solv, eta, kappa, lmax, tol, charges)
    implicit none
    type(ddx_type), intent(inout) :: ddx_data
    real(dp), intent(in) :: charges(ddx_data % params % nsph)
    real(dp), intent(inout) :: esolv_in
    integer, intent(inout)  :: n_iter
    real(dp), intent(in) :: epsilon_solv
    real(dp), intent(in) :: eta
    real(dp), intent(in) :: kappa
    integer, intent(in)  :: lmax
    real(dp), intent(in) :: tol

    type(ddx_state_type) :: state
    type(ddx_type) :: ddx_data2
    type(ddx_error_type) :: error2
    real(dp), allocatable :: phi_cav2(:)
    real(dp), allocatable :: gradphi_cav2(:,:)
    real(dp), allocatable :: hessianphi_cav2(:,:,:)
    real(dp), allocatable :: psi2(:,:)
    real(dp), allocatable :: force2(:,:)

    call allocate_model(ddx_data % params % nsph, &
        & ddx_data % params % csph(1, :), &
        & ddx_data % params % csph(2, :), ddx_data % params % csph(3, :), ddx_data % params % rsph, &
        & ddx_data % params % model, lmax, ddx_data % params % ngrid, 0, &
        & ddx_data % params % fmm, ddx_data % params % pm, ddx_data % params % pl, &
        & ddx_data % params % se, &
        & eta, epsilon_solv, kappa, 0,&
        & ddx_data % params % maxiter, &
        & ddx_data % params % jacobi_ndiis, &
        & ddx_data % params % nproc, dummy_file_name, ddx_data2, error2)
    call check_error(error2)

    ! the state depends on lmax, so it is allocated here
    call allocate_state(ddx_data2 % params, ddx_data2 % constants, state, error2)
    call check_error(error2)

    allocate(phi_cav2(ddx_data2 % constants % ncav), gradphi_cav2(3, ddx_data2 % constants % ncav), &
            & hessianphi_cav2(3, 3, ddx_data2 % constants % ncav), &
            & psi2(ddx_data2 % constants % nbasis, ddx_data2 % params % nsph), &
            & force2(3, ddx_data2 % params % nsph))

    gradphi_cav2 = zero; phi_cav2 = zero
    hessianphi_cav2 = zero; psi2 = zero; force2 = zero

    call mkrhs(ddx_data2 % params, ddx_data2 % constants, ddx_data2 % workspace, &
        &  1, phi_cav2, 1, gradphi_cav2, 1, hessianphi_cav2, psi2, charges)
    gradphi_cav2 = - gradphi_cav2
    call ddsolve_legacy(ddx_data2, state, phi_cav2, gradphi_cav2, hessianphi_cav2, &
        & psi2, tol, esolv_in, force2, error2)
    call check_error(error2)

    n_iter = state % x_lpb_niter
    deallocate(phi_cav2, gradphi_cav2, hessianphi_cav2, psi2, force2)

    call deallocate_state(state, error2)
    call deallocate_model(ddx_data2, error2)
end subroutine test_solve

! This subroutine checks if the default and computed values are same
subroutine check_values(default_value, computed_value)
    real(dp), intent(in) :: default_value
    real(dp), intent(in) :: computed_value
    if(abs(default_value - computed_value) .gt. 1d-9) then
      write(*,*) 'Issue in value, default : ', default_value, ', computed : ',&
                & computed_value
      stop 1
    endif
end subroutine check_values

! This subroutine checks if the default and computed values are same
subroutine check_iter_values(default_value, computed_value)
    integer, intent(in) :: default_value
    integer, intent(in) :: computed_value
    if(default_value .ne. computed_value) then
      write(*,*) 'Issue in iterative value, default : ', default_value, ', computed : ',&
                & computed_value
      stop 1
    endif
end subroutine check_iter_values


end program main

#!/usr/bin/env bash
# This file is part of tblite.
# SPDX-Identifier: LGPL-3.0-or-later
#
# tblite is free software: you can redistribute it and/or modify it under
# the terms of the Lesser GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# tblite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# Lesser GNU General Public License for more details.
#
# You should have received a copy of the Lesser GNU General Public License
# along with tblite.  If not, see <https://www.gnu.org/licenses/>.

if [ -z "$MESON_DIST_ROOT" ]; then
    echo "Error: This script must be run via meson dist."
    exit 1
fi

echo "Setting up symlinks for nested subprojects in distribution tarball..."

cd "$MESON_DIST_ROOT/subprojects" || exit 1

if [ -d "test-drive" ] && [ -d "toml-f" ]; then
    echo "  -> Symlinking test-drive into toml-f/subprojects"
    mkdir -p toml-f/subprojects
    cd toml-f/subprojects
    ln -sfn ../../test-drive test-drive
    cd ../../
fi

if [ -d "mstore" ] && [ -d "dftd4" ]; then
    echo "  -> Symlinking mstore into dftd4/subprojects"
    mkdir -p dftd4/subprojects
    cd dftd4/subprojects
    ln -sfn ../../mstore mstore
    cd ../../
fi

echo "Symlink setup complete."

# AGENTS.md - Development Guide for DFT-D4

This document provides guidance for AI agents and contributors working with the DFT-D4 codebase.

## Project Overview

**DFT-D4** (Generally Applicable Atomic-Charge Dependent London Dispersion Correction) is a Fortran-based library and CLI tool implementing the D4 dispersion model. The project delivers:
- Dispersion energies, gradients, and Hessian via numerical differentiation.
- Pairwise-resolved analysis and support for 3D periodic systems.
- Public APIs: Fortran modules, a C interface, and an optional Python CFFI extension with interfaces to ASE, PySCF and QCSchema.

## Repository Structure

```
dftd4/
├── app/              # CLI frontend (dftd4) and sample input files
├── assets/           # Parameter tables and example data
├── config/           # Build configuration scripts
├── doc/              # Sphinx documentation; ford.md for developer docs
├── include/          # Public C headers (dftd4.h)
├── man/              # Manual pages (asciidoc)
├── python/           # Optional Python extension (CFFI-based)
├── src/dftd4/        # Main library source code
│   ├── damping/      # Damping models and parameters
│   ├── data/         # Element and model data
│   ├── model/        # Dispersion model implementations
│   ├── api.f90       # C API implementation (optional)
│   ├── compat.f90    # API v2 compatibility layer (optional)
│   └── ...           # Core modules: cutoff, param, numdiff, output, utils, version
└── subprojects/      # Meson wrap dependencies (mctc-lib, mstore, multicharge, json-fortran)
├── test/             # Tests (unit/ for Fortran, api/ for C examples)
```

## Build Systems

DFT-D4 supports Meson (preferred), CMake, and fpm.

### Meson (Recommended)

```bash
# Configure
meson setup _build

# Build
meson compile -C _build

# Test
meson test -C _build --print-errorlogs

# Install
meson install -C _build
```

**Notes**:
- Requires Fortran 2008 compiler, Ninja backend, and a BLAS/LAPACK provider.
- GCC/Intel are tested; GCC 15.0.x–15.1.x have a known bug that can trigger interface mismatch errors.
- Meson version 1.8.0 has a known bug and is explicitly unsupported. Use any other version ≥ 0.55.
- Select compiler via `FC=... meson setup ...`.

### CMake

```bash
# Configure
cmake -B _build -G Ninja -DCMAKE_INSTALL_PREFIX=$HOME/.local

# Build
cmake --build _build

# Test
ctest --test-dir _build --output-on-failure

# Install
cmake --install _build
```

**Note**: The CMake build does not produce the Python extension module.

### fpm (Fortran Package Manager)

```bash
# Build
fpm build

# Test
fpm test

# Run application
fpm run -- --help
```

**Note**: The fpm build targets the standalone binary and Fortran library; it does not export the C API.

## Dependencies

- **BLAS/LAPACK** backend (MKL, OpenBLAS, Netlib, or custom).
- **mctc-lib** – structure handling and error management.
- **mstore** – data storage utilities.
- **multicharge** – atomic charge model.
- **json-fortran** – JSON parsing (used for JSON output and tests).
- **OpenMP** – enabled by default; disable with build options if needed.
- Optional: asciidoctor (man pages), FORD (developer docs), Python ≥ 3.6 with `cffi` (Python extension), C compiler (C API tests).

Dependencies are provided via Meson subprojects/wraps, CMake find modules, fpm, or external installs.

## APIs and Interaction Modes

### Fortran API (preferred)
- Consume as a Meson subproject (`dependency('dftd4')`) or link an installed library via pkg-config.
- With fpm, add to your manifest:
  ```toml
  [dependencies]
  dftd4.git = "https://github.com/dftd4/dftd4"
  ```
  then `use dftd4_*` modules (e.g., `dftd4_model`, `dftd4_damping`).

#### Core Data Types
- `structure_type` (`mctc_io`) - molecular structure container (numbers, positions, lattice, periodic flags).
- `dispersion_model` (`dftd4_model_type`) - abstract base for D4/D4S dispersion models.
- `d4_model` / `d4s_model` (`dftd4_model_d4`, `dftd4_model_d4s`) - concrete dispersion model instances.
- `damping_param` (`dftd4_damping`) and `rational_damping_param` (`dftd4_damping_rational`) - damping configuration objects.
- `realspace_cutoff` (`dftd4_cutoff`) - cutoff settings for CN, two-body, and three-body terms.
- `error_type` (`mctc_env`) - error propagation across Fortran APIs.

#### Core Functions
- `read_structure` (`mctc_io`) - load a structure from disk into `structure_type`.
- `new_d4_model` / `new_d4s_model` (`dftd4_model_d4`, `dftd4_model_d4s`) - construct dispersion models.
- `get_rational_damping` (`dftd4_param`) - fetch damping parameters by functional name or ID.
- `get_dispersion` (`dftd4_disp`) - compute dispersion energy (and optionally gradients/virial).
- `get_pairwise_dispersion` (`dftd4_disp`) - compute pairwise-resolved energies.
- `get_properties` (`dftd4_disp`) - compute CN, charges, C6, and polarizabilities.

### C API
- Enable with `-Dapi=true`; interfaces live in `src/dftd4/api.f90`, header in `include/dftd4.h`.
- Include the header and link with pkg-config:
  ```bash
  pkg-config --cflags --libs dftd4
  ```
  If pkg-config omits transitive deps, append `-lmulticharge -lmctc-lib -lmstore`.
- Compatibility layer for the 2.5.x API via `-Dapi_v2=true` (`compat.f90`), primarily to preserve VASP compatibility.

### Python API
- Install from conda-forge (`conda install dftd4-python`), or build in-tree:
  ```bash
  meson setup _build -Dpython=true -Dpython_version=$(which python3)
  meson compile -C _build
  ```
  Out-of-tree build instructions live in `python/README.rst`.

### CLI (for scripting/verification)
- Build and run the installed or in-tree binary:
  ```bash
  meson compile -C _build
  _build/app/dftd4 --func pbe0 coord
  ```
  Add `--json` to emit machine-readable output for downstream tools.

## Testing

### Running Tests

Tests are organized by functionality in `test/`:
- `test/unit/test_model.f90` - dispersion model construction and core behavior.
- `test/unit/test_dftd4.f90` - end-to-end D4 energy/gradient computations.
- `test/unit/test_pairwise.f90` - pairwise-resolved dispersion energies.
- `test/unit/test_param.f90` - parameter parsing and access from `assets/parameters.toml`.
- `test/unit/test_periodic.f90` - periodic boundary handling and cell-related paths.
- `test/api/example.c` - build/link sanity check for the C interface.

Commands:
```bash
meson test -C _build --print-errorlogs
ctest --test-dir _build --output-on-failure
fpm test
```

### Python API Tests

The Python tests live in `python/dftd4/test_*.py` and use `pytest`.

Recommended setup (editable install into the venv + test; no optional deps):
```bash
python3 -m venv .venv
source .venv/bin/activate
python -m pip install --upgrade pip
python -m pip install meson meson-python ninja cffi numpy pkgconfig pytest

meson setup --wipe _build \
  -Dprefix="$VIRTUAL_ENV/_install" \
  -Dlibdir=lib \
  -Ddefault_library=shared \
  -Dapi=true \
  -Dpython=true \
  -Dpython_version="$(command -v python3)" \
  -Dbuildtype=debug
meson compile -C _build
meson install -C _build

PKG_CONFIG_PATH="$VIRTUAL_ENV/_install/lib/pkgconfig:$PKG_CONFIG_PATH" \
  pkg-config --modversion dftd4
PKG_CONFIG_PATH="$VIRTUAL_ENV/_install/lib/pkgconfig:$PKG_CONFIG_PATH" \
  python -m pip install -e python -Csetup-args="-Dbuildtype=debug"

LD_LIBRARY_PATH="$VIRTUAL_ENV/_install/lib:$LD_LIBRARY_PATH" \
  python -m pytest -vv --pyargs dftd4
```

Optional test modules require extra dependencies:
- `test_ase.py` → `ase`
- `test_qcschema.py` → `qcelemental`
- `test_pyscf.py` → `pyscf`

Out-of-tree build (Python-only):
```bash
cd python
meson setup _build -Dpython_version=$(which python3)
meson compile -C _build
```
Ensure `PKG_CONFIG_PATH` can find the installed `dftd4` library before building.

### Writing Tests

Fortran tests use `mctc_env_testing`:
```fortran
use mctc_env_testing, only : new_unittest, unittest_type, error_type, check

subroutine collect_my_tests(testsuite)
   type(unittest_type), allocatable, intent(out) :: testsuite(:)
   testsuite = [ &
      & new_unittest("test-name", test_procedure), &
      & new_unittest("expected-fail", test_fail, should_fail=.true.) &
   ]
end subroutine
```

Add new tests alongside feature changes and register them in the relevant suite.

## Code Style and Conventions

- Fortran 2008, free-form (`.f90`, `.F90` for preprocessed).
- Module naming: `dftd4_<subsystem>_<component>` (e.g., `dftd4_model_d4`, `dftd4_damping`).
- Default `private`; explicitly export public entities.
- Always `implicit none` in all program units.
- Error handling via `mctc_env:error_type` and `fatal_error` for propagation; avoid bare `error stop` except in test drivers.
- Maintain consistent formatting and clear intent; add brief comments where code is non-obvious.

### File Header

All source files must include the LGPL header and SPDX tag:

```fortran
! This file is part of dftd4.
! SPDX-Identifier: LGPL-3.0-or-later
!
! dftd4 is free software: you can redistribute it and/or modify it under
! the terms of the Lesser GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! dftd4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! Lesser GNU General Public License for more details.
!
! You should have received a copy of the Lesser GNU General Public License
! along with dftd4.  If not, see <https://www.gnu.org/licenses/>.
```

### Error Handling

Use the `error_type` for error propagation:

```fortran
use mctc_env, only : error_type, fatal_error

subroutine my_routine(result, error)
   type(error_type), allocatable, intent(out) :: error
   
   if (some_error_condition) then
      call fatal_error(error, "Descriptive error message")
      return
   end if
end subroutine
```

### Documentation

- FORD docstrings for public interfaces (`!>` preceding, `!<` trailing).
- Sphinx docs in `doc/`; man pages in `man/` (asciidoc).
- Keep CLI help (`app/help.f90`), man pages, and README examples synchronized when changing behavior.

## CI/CD Workflow

GitHub Actions workflows are configured in `.github/workflows/`:
- Build systems: Meson, CMake, and fpm.
- Compilers: GCC and Intel.
- Documentation builds (Sphinx/FORD where applicable).
- Coverage upload to Codecov.
- DCO enforcement via `.github/dco.yml` (all commits must be signed off).

## Adding New Features

### Adding or Updating Parameters/Functionals
1. Update `assets/parameters.toml` with new entries and references.
2. Adjust parameter handling in `src/dftd4/param.f90` and related data modules if needed.
3. Add regression/unit tests in `test/unit/`.
4. Update documentation (`doc/`, man pages, README snippets) to reflect new options or defaults.

### Extending APIs
1. Fortran: add modules under `src/dftd4/` and export needed interfaces.
2. C API: extend `src/dftd4/api.f90` and `include/dftd4.h`.
3. VASP compatibility layer: update `compat.f90` and only compile it when the `api_v2` option is enabled (set `-Dapi_v2=true`) to preserve 2.5.x behavior.
4. Python: update CFFI bindings in `python/` and adjust `pyproject.toml`/`meson_options.txt` as needed.
5. Register new sources in `meson.build`/`CMakeLists.txt`.
6. Add tests (Fortran or C) and documentation.

### CLI Enhancements
1. Implement behavior in `app/` (e.g., `argument.f90`, `driver.f90`, `help.f90`).
2. Sync help text, man page (`man/dftd4.1.adoc`), and README/recipes.
3. Add examples to `app/` if helpful.
4. Cover with regression tests when feasible.

## Common Tasks

### Run a Dispersion Calculation
```bash
meson compile -C _build
_build/app/dftd4 --func pbe0 coord
```

### Dump Results to JSON (suppress .EDISP)
```bash
_build/app/dftd4 --func pbe0 --json --grad --noedisp struct.xyz
```

### Pairwise-Resolved Energies
```bash
_build/app/dftd4 --pair-resolved mol.xyz
```

### Fortran API Example (compute D4 energy)
```fortran
program d4_energy
   use mctc_env, only : wp, error_type
   use mctc_io, only : structure_type, read_structure
   use dftd4, only : d4_model, new_d4_model, damping_param, &
      & get_rational_damping, realspace_cutoff, get_dispersion
   implicit none

   type(structure_type) :: mol
   type(d4_model) :: model
   class(damping_param), allocatable :: param
   type(realspace_cutoff) :: cutoff
   type(error_type), allocatable :: error
   real(wp) :: energy

   call read_structure(mol, "coord", error)
   if (allocated(error)) then
      write (*, '(a)') trim(error%message)
      stop 1
   end if

   call new_d4_model(error, model, mol)
   if (allocated(error)) then
      write (*, '(a)') trim(error%message)
      stop 1
   end if

   call get_rational_damping("pbe", param)
   call get_dispersion(mol, model, param, cutoff, energy)

   write (*, '(a,f18.12)') "D4 dispersion energy (Hartree): ", energy
end program d4_energy
```

### List Available Parameters
```bash
_build/app/dftd4 param --list
# or inspect assets/parameters.toml
```

### Linking into Other Codes (e.g., VASP)
- Use pkg-config: `pkg-config --cflags --libs dftd4`
- If transitive deps are missed, add `-lmulticharge -lmctc-lib -lmstore` explicitly.

## Build Options

### Meson Options (`meson_options.txt`)

| Option | Type | Default | Description |
|--------|------|---------|-------------|
| `lapack` | combo | `auto` | BLAS/LAPACK backend (`auto`, `mkl`, `mkl-rt`, `openblas`, `netlib`, `custom`) |
| `custom_libraries` | array | `[]` | Extra libraries for custom BLAS/LAPACK |
| `openmp` | boolean | `true` | Enable OpenMP parallelization |
| `api` | boolean | `true` | Build C API |
| `api_v2` | boolean | `false` | Enable 2.5.x compatibility layer |
| `python` | boolean | `false` | Build Python extension module |
| `python_version` | string | `python3` | Python executable to link against |
| `ilp64` | boolean | `false` | Enable BLAS/LAPACK ILP64 |

### CMake Options (selected)

| Option | Description |
|--------|-------------|
| `WITH_OpenMP` | Enable OpenMP |
| `WITH_API` | Build C API |
| `WITH_API_V2` | Enable compatibility layer |
| `WITH_PYTHON` | Build Python extension (may require out-of-tree steps) |

## Troubleshooting

1. **GCC 15.0.x–15.1.x interface mismatch bug**: use another GCC version.
2. **Meson 1.8.0 error**: upgrade or downgrade meson (`pip install meson!=1.8.0`).
3. **JSON tests fail** (mctc-lib JSON I/O): ensure the jonquil dependency is available, or disable JSON in the mctc-lib subproject with Meson (`-Djson=disabled`).
4. **Missing BLAS/LAPACK**: set `lapack` option (Meson) or pass provider paths; ensure `LD_LIBRARY_PATH`/`LIBRARY_PATH` includes the backend.
5. **Pkg-config misses deps**: link `-lmulticharge -lmctc-lib -lmstore` explicitly.
6. **OpenMP issues**: disable with `-Dopenmp=false` if encountering runtime problems.
7. **Python build failures**: ensure `python_version` points to a Python 3 with `cffi` installed.

## External Resources

- [GitHub Repository](https://github.com/dftd4/dftd4)
- [Documentation](https://dftd4.readthedocs.io/en/latest/)
- [API Docs](https://dftd4.github.io/dftd4/)
- [Issue Tracker](https://github.com/dftd4/dftd4/issues)

## Contributing

1. Fork the repository and create a feature branch.
2. Follow code style and licensing conventions (LGPL header, SPDX).
3. Add tests for new functionality and keep docs in sync.
4. Ensure all tests pass on the supported build systems.
5. Sign off commits (DCO requirement: `git commit -s -m "message"`).
6. Submit a pull request with a clear description and rationale.

Error messages are designed to be helpful; report unclear errors as bugs with reproduction steps.

---
name: Bug report
about: Create a report to help us improve
title: ''
labels: ''
assignees: ''

---

**Describe the bug**
A clear and concise description of what the bug is.

**To Reproduce**
Steps to reproduce the behaviour:

1. happens with input (include input files)
2. start `dftd4` with (all the options here)
3. output showing the error

Please provide all input and output file such that we confirm your report.

**Expected behaviour**
A clear and concise description of what you expected to happen.

**Additional context**
Add any other context about the problem here.

# Theory
## Introduction


## Cavity and solute density
ddX considers vdW- and SAS-cavities that can be defined by a set of \f$M\f$ balls \f$\Omega_j\f$ each of which is located at \f$\textbf{x}_j\in\mathbb R^3\f$ with radius \f$r_j\in\mathbb R\f$. The region occupied by the solute molecule is given by
\f[
    \Omega = \cup_{j=1}^M \Omega_j.
\f]
The charge density of the solute molecule is denoted by \f$\rho\f$ and it can consist of point-charges (partial charges) for classical models or nuclear point-charges with electronic densities for quantum-mechanical models.
Within ddX, the solute molecule is completely described by the cavity \f$\Omega\f$ and the charge distribution \f$\rho\f$. 
The methods used in ddX assume that the charge \f$\rho\f$ is supported in \f$\Omega\f$, i.e. \f$\rho(\textbf{x})=0\f$ for \f$\textbf{x}\in\mathbb R^3\backslash\Omega\f$.

### Fundamental solutions and free-space potentials
The free-space potential, i.e. the potential generated by \f$\rho\f$ in vacuum, is then defined by 
\f[
    \Phi(\textbf{x}) = \int_{\Omega} \rho(\textbf{y}) \, G_0(|\textbf{x}-\textbf{y}|) d\textbf{y}
    \qquad\textrm{ and satisfies }\qquad
    -\Delta \Phi = 4\pi \rho, \textrm{ in } \mathbb R^3,
\f]
where \f$G_0(r) = \frac{1}{4\pi r} \f$ denotes the fundamental solution of the Laplace-operator \f$\mathcal L_\Delta=-\Delta\f$. 
We also introduce the Yukawa-potential \f$G_\kappa(r) = \frac{e^{-\kappa r}}{4\pi r} \f$, which is the fundamental solution of the operator \f$\mathcal L_\kappa = -\Delta+\kappa^2\f$.


## Models
The three methods COSMO, PCM and LPB differ by the model of the physical between the solute and the implicit/bulk solvent. 

###Linearized Poisson-Boltzmann model (LPB)

The LPB-model is the most general one of the three models and the (implicit) solvent is assumed to be homogeneous continuum with relative dielectric permittivity \f$\varepsilon_s\f$ and Debye Hückel constant \f$\kappa_s\f$. 
Then the LPB-equations are given by: find the potential \f$V\f$ solution to 
\f[
    -\nabla\cdot (\varepsilon\nabla V) + \kappa^2 V = 4\pi \rho, \qquad \textrm{in } \mathbb R^3,
\f]
where
\f[
    \varepsilon(\textbf{x}) = 
    \begin{cases}
    1 & \textrm{if } \textbf{x}\in\Omega, \\
    \varepsilon_s & \textrm{otherwise}, 
    \end{cases}
    \qquad\textrm{ and }\qquad
    \kappa(\textbf{x}) = 
    \begin{cases}
    0 & \textrm{if } \textbf{x}\in\Omega, \\
    \sqrt{\varepsilon_s}\kappa_s & \textrm{otherwise}.
    \end{cases}
\f]

ddLPB is based on the following coupled equations: find the reaction-potential \f$W=V-\Phi\f$ and the auxilliary potential \f$V_e\f$ that satisfy 
\f{align*}{
    -\Delta W &= 0, && \textrm{in }\Omega, \\
    -\Delta V_e + \kappa_s^2 V_e^2 &= 0, &&\textrm{in }\Omega,
\f}
with (nonlocal) boundary conditions
\f{align*}{
    W + \Phi &= V_e, && \textrm{on }\partial\Omega, \\
   V_e + S_\kappa\big(\tfrac{1}{\varepsilon_s} \partial_n W - \partial_n V_e\big) &= -S_\kappa\big(\tfrac{1}{\varepsilon_s} \partial_n \Phi\big), && \textrm{on }\partial\Omega,
\f}
where \f$S_\kappa\f$ denotes the single-layer potential with respect to the operator \f$\mathcal L_\kappa\f$ defined by
\f{align*}{
    (S_\kappa\sigma)(\textbf{s}) &= \int_{\partial\Omega} \sigma(\textbf{s'}) \, G_\kappa(|\textbf{s}-\textbf{s'}|) \, d\textbf{s'}.
\f}
Note that \f$\partial_n=\frac{\partial}{\partial n}\f$ stands for the normal derivative.


###Polarizable Continuum Model (PCM)

The PCM is the particular case of LPB with \f$\kappa_s=0\f$. 
ddPCM relies on the following equivalent Integral-Equation formulation: find the charge density \f$\sigma\f$ and the intermediate potential \f$\Phi_\varepsilon\f$ that satisfy
\f{align*}
    R_\varepsilon \Phi_\varepsilon &= R_\infty \Phi, &&\textrm{on }\partial\Omega, \\
    S \sigma &= -\Phi_\varepsilon, &&\textrm{on }\partial\Omega,
\f}
where
\f[
    R_\varepsilon = 2\pi \frac{\varepsilon_s+1}{\varepsilon_s-1} I - D,
\f]
and \f$S\f$ and \f$D\f$ denote the single and double-layer boundary operators respectively with respect to the Laplace-operator \f$\mathcal L_\Delta\f$ defined by
\f{align*}{
    \forall \textbf{s}\in\partial\Omega: \qquad
    (S\sigma)(\textbf{s}) &= \int_{\partial\Omega} \sigma(\textbf{s'}) \, G_0(|\textbf{s}-\textbf{s'}|) \, d\textbf{s'}, \\
    \forall \textbf{s}\in\partial\Omega: \qquad
    (D\sigma)(\textbf{s}) &= \int_{\partial\Omega} \sigma(\textbf{s'}) \, \frac{\partial}{\partial n(\textbf{s'})} \, G_0(|\textbf{s}-\textbf{s'}|) \, d\textbf{s'}.
 \f}
 Note that \f$n(\textbf{s'})\f$ denotes the outward-pointing unit normal at \f$\textbf{s'}\in\partial\Omega\f$.

###COnductor-like Screening MOdel (COSMO)

The COSMO is the particular case of PCM with \f$\varepsilon_s=+\infty\f$, i.e. the solvent is assumed to be a perfect conductor. In consequence, \f$V=0\f$ in \f$\mathbb R^3\backslash \Omega\f$ and the problem reduces to 
\f[
    -\Delta V = 4\pi \rho, \qquad \textrm{in } \Omega,
\f]
which,for \f$W=V-\Phi\f$, can be reformulated as  
\f{align*}{
    -\Delta W &= 0, && \textrm{in } \Omega,
    \\
    W &= - \Phi, && \textrm{on } \partial\Omega.
\f}
The corresponding Integral-Equation formulation is: find the charge density \f$\sigma:\partial\Omega\to\mathbb R\f$ such that
\f[
    S\sigma = - \Phi, \qquad \textrm{on } \partial\Omega,
\f]
and \f$\sigma\f$ relates to \f$W\f$ through
\f[
    \forall \textbf{x}\in\mathbb R^3: \qquad W(\textbf{x}) = \int_{\partial\Omega} \sigma(\textbf{y}) \, G_0(|\textbf{x}-\textbf{y}|) \, d\textbf{y}.
\f]


#### General remarks
1. As \f$\varepsilon_s\to\infty\f$, the solution to the PCM becomes the COSMO solution. The first PCM equation yields \f$\Phi_\varepsilon \to \Phi\f$ and the second PCM equation corresponds to the Integral-Equation formulation of COSMO.
2. lpb different formulation

In all three models, the solvation energy \f$E_s\f$ is defined as
\f[
    E_s=\frac12 \int_{\Omega} \rho(\textbf{x}) \, W(\textbf{x}) \, d\textbf{x},
\f]
where \f$W=V-\Phi\f$ denotes the reaction-potential and the force-vector \f$F_i\f$ acting on the \f$i\f$th atom corresponding to the solvation energy is given by
\f[
    F_i = -\nabla_{\textbf{x}_i} E_s.
\f]

## Discrete equations in a general framework - overview
The resulting linear system for all three methods can be written in the general form
\f[
        \tilde{\operatorname{L}} \tilde{\operatorname{X}} = \tilde{\operatorname{F}},
\f]
and the (approximate) energy can be computed as
\f[
    E_s = \frac12 \langle \tilde \Psi, \tilde{\operatorname{X}} \rangle,
\f]
where \f$\langle \cdot, \cdot \rangle\f$ denotes the scalar product of the two enclosed vectors.
###ddCOSMO:
\f[
    \tilde{\operatorname{L}} = \begin{pmatrix} \operatorname{L} & 0 \\ 0 & 0 \end{pmatrix}
    \qquad
    \tilde{\operatorname{X}} = \begin{pmatrix} \operatorname{X} \\ 0 \end{pmatrix}
    \qquad
    \tilde{\operatorname{F}} = \begin{pmatrix} -\Phi \\ 0 \end{pmatrix}
    \qquad
    \tilde{\Psi} = f(\varepsilon)\begin{pmatrix} \Psi \\ 0 \end{pmatrix}
\f]
*Note*: The notation used in the ddCOSMO-literature, see e.g. [1,2,7], uses \f$\operatorname{g} = -\Phi\f$. The references [1--9] also give the definition of the matrix \f$\operatorname{L}\f$ and the vectors \f$\operatorname{g} = -\Phi\f$, \f$\Psi\f$ as well as the scalar function \f$f(\varepsilon)\f$. 

The subroutine for matrix-vector multiplications of the \f${\operatorname{L}}\f$ with a vector is 
``` markdown
> lx(...)     in ddx_operators.f90
```
###ddPCM:
\f[
    \tilde{\operatorname{L}} = \begin{pmatrix} \operatorname{L} & \operatorname{I}_d \\ 0 & \operatorname{R}_\varepsilon \end{pmatrix}
    \qquad
    \tilde{\operatorname{S}} = \begin{pmatrix} \operatorname{X} \\ \Phi_\varepsilon \end{pmatrix}
    \qquad
    \tilde{\operatorname{F}} = \begin{pmatrix} \operatorname{0} \\ \operatorname{R}_\infty\Phi \end{pmatrix}
    \qquad
    \tilde{\Psi} = \begin{pmatrix} \Psi \\ 0 \end{pmatrix}
\f]
*Note*: The notation used in the references [10,11], uses \f$\sigma = \operatorname{X}\f$. The references [10--13] also give the definition of the matrices \f$\operatorname{R}_\varepsilon\f$, \f$\operatorname{R}_\infty\f$ and the vector \f$\operatorname{g} = -\Phi\f$. \f$\operatorname{I}_d\f$ denotes the identity matrix.

The subroutine for matrix-vector multiplications of the \f$\operatorname{R}_\varepsilon\f$ and \f$\operatorname{R}_\infty\f$ with a vector is 
``` markdown
> repsx(...)     in ddx_operators.f90
> rinfx(...)     in ddx_operators.f90
```
###ddLPB:
\f[
    \tilde{\operatorname{L}} = \tilde{\operatorname{T}} = \begin{pmatrix} \operatorname{A} & 0 \\ 0 & \operatorname{B} \end{pmatrix} + \tilde{\operatorname{C}}
    \qquad
    \tilde{\operatorname{C}} = \begin{pmatrix} \operatorname{C}_1 & \operatorname{C}_2 \\ \operatorname{C}_1 & \operatorname{C}_2 \end{pmatrix}
    \qquad
    \tilde{\operatorname{X}} = \begin{pmatrix} \operatorname{X} \\ \operatorname{X}_e \end{pmatrix}
    \qquad
    \tilde{\operatorname{F}} = \begin{pmatrix} \operatorname{F}_0-\Phi \\ \operatorname{F}_0 \end{pmatrix}
    \qquad
    \tilde{\Psi} = \begin{pmatrix} \Psi \\ 0 \end{pmatrix}
\f]
*Note*: The notation used in the ddLPB-literature, see e.g. [14,15], uses \f$\operatorname{X}_r = \operatorname{X}\f$ and \f$\operatorname{G}_0 = -\Phi\f$. These references also provide the definition of the matrices \f$\operatorname{A}\f$ (which is a scaled verion of \f$\operatorname{L}\f$), \f$\operatorname{B}\f$, \f$\operatorname{C}_1\f$, \f$\operatorname{C}_2\f$ as well as the vectors \f$\operatorname{F}_0\f$, \f$\operatorname{G}_0 = -\Phi\f$.

The subroutine for matrix-vector multiplications of the \f$\tilde{\operatorname{T}}\f$, \f$\operatorname{A}\f$,\f$\operatorname{B}\f$  and \f$\tilde{\operatorname{C}}\f$ with a vector is 
``` markdown
> tx(...)     in ddx_operators.f90
> ax(...)     in ddx_operators.f90
> bx(...)     in ddx_operators.f90
> cx(...)     in ddx_operators.f90
```
## Gradient computations
The derivative of the energy with respect to a parameter \f$\lambda\f$ is computed using the adjoint method
\f{align*}{
E^\lambda_s 
&= \frac12 \langle \tilde \Psi^\lambda, \tilde{\operatorname{X}} \rangle + \frac12 \langle \tilde \Psi, \tilde{\operatorname{X}}^\lambda \rangle
= \frac12 \langle \tilde \Psi^\lambda, \tilde{\operatorname{X}} \rangle + \frac12 \langle \tilde{\operatorname{S}}, \tilde{\operatorname{H}} \rangle 
\f}
where \f$\tilde{\operatorname{S}}\f$ is solution to the adjoint linear system
\f[
            \tilde{\operatorname{L}}^\top \tilde{\operatorname{S}} = \tilde{\Psi},
\f]
and 
\f[
    \tilde{\operatorname{H}} = \tilde{\operatorname{F}}^\lambda - \tilde{\operatorname{L}}^\lambda \tilde{\operatorname{X}}.
\f]
###ddCOSMO:
\f[
    \tilde{\operatorname{L}}^\top = \begin{pmatrix} \operatorname{L}^\top & 0 \\ 0 & 0 \end{pmatrix}
    \qquad
    \tilde{\operatorname{S}} = \begin{pmatrix} \operatorname{S} \\ 0 \end{pmatrix}
    \qquad
    \tilde{\operatorname{H}} = \begin{pmatrix} -\Phi^\lambda - \operatorname{L}^\lambda \operatorname{X} \\ 0 \end{pmatrix}
\f]
The subroutine for matrix-vector multiplications of the \f$\tilde{\operatorname{L}}^\top\f$ with a vector is 
``` markdown
> lstarx(...)     in ddx_operators.f90
```
The term \f$\langle \tilde{\operatorname{S}}, \tilde{\operatorname{H}} \rangle\f$ then writes
\f[
    \langle \tilde{\operatorname{S}}, \tilde{\operatorname{H}} \rangle
    = 
    - \langle \operatorname{S}, \Phi^\lambda\rangle
    - \langle \operatorname{S}, \operatorname{L}^\lambda\operatorname{X} \rangle
\f]
The subroutine for the contraction of the differentiated matrix \f$\operatorname{L}^\lambda\f$ with two vectors is 
``` markdown
> contract_grad_l(...)     in ddx_gradients.f90
```

###ddPCM:
\f[
    \tilde{\operatorname{L}}^\top = \begin{pmatrix} \operatorname{L}^\top & 0 \\ \operatorname{I}_d & \operatorname{R}_\varepsilon^\top \end{pmatrix}
    \qquad
    \tilde{\operatorname{S}} = \begin{pmatrix} \operatorname{S} \\ -\operatorname{Y} \end{pmatrix}
    \qquad
    \tilde{\operatorname{H}} = \begin{pmatrix} -\operatorname{L}^\lambda\operatorname{X} \\ \operatorname{R}^\lambda(\Phi-\Phi_\varepsilon)+\operatorname{R}_\infty\Phi^\lambda \end{pmatrix}
\f]
*Note*: The minus sign in front of \f$\operatorname{Y}\f$ appears for consistency with the notation introduced in [12].

The subroutine for matrix-vector multiplications of the \f$\operatorname{R}_\varepsilon^\top\f$ and \f$\operatorname{R}_\infty^\top\f$ with a vector is 
``` markdown
> repsstarx(...)     in ddx_operators.f90
> rinfstarx(...)     in ddx_operators.f90
```
**Remarks**:
1. There holds \f$\operatorname{S}=\operatorname{R}_\varepsilon^\top\operatorname{Y}\f$.
2. Since \f$\operatorname{R}_\infty-\operatorname{R}_\varepsilon=-\frac{4\pi}{\varepsilon_s-1}\f$ is constant there holds \f$\operatorname{R}^\lambda:=\operatorname{R}^\lambda_\varepsilon=\operatorname{R}^\lambda_\infty\f$.
3. As consequence of 1. and 2., it is advantageous to write
\f[
    \langle \tilde{\operatorname{S}}, \tilde{\operatorname{H}} \rangle
    = 
    - \langle \operatorname{S}, \operatorname{L}^\lambda\operatorname{X} \rangle
    + \langle \operatorname{Y}, \operatorname{R}^\lambda(\Phi_\varepsilon-\Phi) \rangle
    -  \langle \operatorname{Q}, \Phi^\lambda \rangle
    \qquad 
    \operatorname{Q} := \operatorname{S} - \frac{4\pi}{\varepsilon_s-1} \operatorname{Y}.
\f]

The subroutine for the contraction of the differentiated matrix \f$\operatorname{R}^\lambda\f$ with two vectors is 
``` markdown
> contract_gradr(...)     in ddx_gradients.f90
```

###ddLPB:
\f[
    \tilde{\operatorname{L}}^\top = \tilde{\operatorname{T}}^\top = \begin{pmatrix} \operatorname{A}^\top & 0 \\ 0 & \operatorname{B}^\top \end{pmatrix} + \tilde{\operatorname{C}}^\top
    \qquad
    \tilde{\operatorname{C}}^\top = \begin{pmatrix} \operatorname{C}_1^\top & \operatorname{C}_1^\top \\ \operatorname{C}_2^\top & \operatorname{C}_2^\top \end{pmatrix}
    \qquad
    \tilde{\operatorname{X}} = \begin{pmatrix} \operatorname{S} \\ \operatorname{S}_e \end{pmatrix}
    \qquad
    \tilde{\operatorname{H}} = \begin{pmatrix} 
        \operatorname{F}_0^\lambda-\Phi^\lambda - \operatorname{A}^\lambda - \operatorname{C}_1^\lambda \operatorname{X} - \operatorname{C}_2^\lambda \operatorname{X}_e 
        \\
        \operatorname{F}_0^\lambda - \operatorname{B}^\lambda - \operatorname{C}_1^\lambda \operatorname{X} - \operatorname{C}_2^\lambda \operatorname{X}_e 
     \end{pmatrix}
\f]
The subroutine for matrix-vector multiplications of the \f$\tilde{\operatorname{T}}^\top\f$, \f$\operatorname{A}^\top\f$,\f$\operatorname{B}^\top\f$  and \f$\tilde{\operatorname{C}}^\top\f$ with a vector is 
``` markdown
> tstarx(...)     in ddx_operators.f90
> astarx(...)     in ddx_operators.f90
> bstarx(...)     in ddx_operators.f90
> cstarx(...)     in ddx_operators.f90
```
The term \f$\langle \tilde{\operatorname{S}}, \tilde{\operatorname{H}} \rangle\f$ then writes
\f[
    \langle \tilde{\operatorname{S}}, \tilde{\operatorname{H}} \rangle
    = 
    \langle \operatorname{S}, \operatorname{F}_0^\lambda-\Phi\lambda^\rangle
    + \langle \operatorname{S}_e, \operatorname{F}_0^\lambda\rangle
    - \langle \operatorname{S}, \operatorname{A}^\lambda\operatorname{X} \rangle
    - \langle \operatorname{S}_e, \operatorname{B}^\lambda\operatorname{X}_e \rangle
    - \langle \tilde{\operatorname{S}}, \tilde{\operatorname{C}}_1^\lambda\tilde{\operatorname{X}} \rangle.
\f]
The subroutine for the contraction of the differentiated matrices \f$\operatorname{A}^\lambda\f$, \f$\operatorname{B}^\lambda\f$ and \f$\tilde{\operatorname{C}}^\lambda\f$ with two vectors is 
``` markdown
> contract_grad_a(...)     in ddx_gradients.f90
> contract_grad_b(...)     in ddx_gradients.f90
> contract_grad_c(...)     in ddx_gradients.f90
```

# AGENTS.md - Development Guide for mctc-lib

This document provides guidance for AI agents and contributors working with the mctc-lib codebase.

## Project Overview

**mctc-lib** (Modular Computation Tool Chain Library) is a Fortran library providing unified molecular structure data handling and geometry file format I/O for computational chemistry applications.

### Supported Geometry Formats

The library supports reading and writing 12+ geometry formats:

*General ASCII formats:*
- **xyz** - Xmol/xyz files (`.xyz`, `.log`)
- **pdb** - Protein Data Bank format (`.pdb`)
- **mol/sdf** - MDL connection table files (`.mol`, `.sdf`)

*JSON-based formats:*
- **QCSchema** - MolSSI QCSchema JSON (`.qcjson`, `.json`)
- **Chemical JSON** - Avogadro Chemical JSON (`.cjson`, `.json`)
- **Pymatgen JSON** - Pymatgen Molecule/Structure (`.pmgjson`, `.json`)

*Program-specific formats:*
- **Turbomole coord** - Turbomole/riper coordinates (`.tmol`, `.coord`)
- **VASP POSCAR** - VASP geometry files (`.vasp`, `.poscar`, `.contcar`)
- **DFTB+ gen** - DFTB+ genFormat (`.gen`)
- **Gaussian external** - Gaussian external program input (`.ein`)
- **FHI-aims** - FHI-aims geometry input (`geometry.in`)
- **Q-Chem** - Q-Chem molecule block (`.qchem`)

## Repository Structure

```
mctc-lib/
├── src/mctc/           # Main library source code
│   ├── io/             # I/O module (readers/writers for all formats)
│   │   ├── read/       # Format-specific readers
│   │   └── write/      # Format-specific writers
│   ├── env/            # Environment module (error handling, testing)
│   ├── data/           # Element data (radii, electronegativities)
│   └── ncoord/         # Coordination number utilities
├── app/                # Application code (mctc-convert tool)
├── test/               # Unit test suite
├── doc/                # FORD documentation pages (format descriptions)
├── man/                # Manual pages (asciidoc format)
├── include/            # Public include files
├── config/             # Build configuration scripts
└── subprojects/        # Meson wrap dependencies (jonquil, toml-f, test-drive)
```

## Build Systems

This project supports three build systems. Choose based on your workflow:

### Meson (Recommended)

```bash
# Configure
meson setup _build

# Build
meson compile -C _build

# Test
meson test -C _build --print-errorlogs

# Install
meson install -C _build
```

**Note**: Meson version 1.8.0 has a known bug and is explicitly unsupported. Use any other version ≥ 0.55.

### CMake

```bash
# Configure
cmake -B _build -G Ninja

# Build
cmake --build _build

# Test
cd _build && ctest && cd ..
```

### fpm (Fortran Package Manager)

```bash
# Build
fpm build

# Test
fpm test

# Run application
fpm run -- --help
```

## Dependencies

- **jonquil** (v0.3.0 or later) - JSON parsing (optional, enables JSON format support)
- **toml-f** (v0.4.3 or later) - TOML parsing (dependency of jonquil)
- **test-drive** - Testing framework (test dependency only)

Dependencies are managed via Meson subprojects (wrap files), CMake find modules, or fpm.

## Testing

### Running Tests

Tests are organized by functionality in `test/`:

- `test_read_*.f90` - Reader tests for each format
- `test_write_*.f90` - Writer tests for each format
- `test_math.f90` - Mathematical utility tests
- `test_ncoord.f90` - Coordination number tests
- `test_symbols.f90` - Element symbol conversion tests

```bash
# Run all tests with meson
meson test -C _build --print-errorlogs --suite mctc-lib

# Run specific test
meson test -C _build test_read_xyz --print-errorlogs
```

### Writing Tests

Tests use the `mctc_env_testing` module:

```fortran
use mctc_env_testing, only : new_unittest, unittest_type, error_type, check

subroutine collect_my_tests(testsuite)
   type(unittest_type), allocatable, intent(out) :: testsuite(:)
   testsuite = [ &
      & new_unittest("test-name", test_procedure), &
      & new_unittest("expected-fail", test_fail, should_fail=.true.) &
   ]
end subroutine
```

## Code Style and Conventions

### Fortran Style

- Use Fortran 2008 standard features
- Free-form source format (`.f90`, `.F90` for preprocessed)
- Module names: `mctc_<subsystem>_<component>` (e.g., `mctc_io_read`)
- Private by default, explicitly export public entities
- Use `implicit none` in all program units

### File Header

All source files must include the Apache-2.0 license header:

```fortran
! This file is part of mctc-lib.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! ...
```

### Error Handling

Use the `error_type` for error propagation:

```fortran
use mctc_env, only : error_type, fatal_error

subroutine my_routine(result, error)
   type(error_type), allocatable, intent(out) :: error
   
   if (some_error_condition) then
      call fatal_error(error, "Descriptive error message")
      return
   end if
end subroutine
```

### Documentation

- Use FORD-compatible docstrings (`!>` for preceding, `!<` for trailing)
- Document all public interfaces
- Run `ford docs.md` to generate documentation

## CI/CD Workflow

### GitHub Actions

The CI pipeline (`.github/workflows/build.yml`) runs on push and pull requests:

- **Platforms**: Ubuntu, macOS
- **Compilers**: GCC (10, 11, 12, 14), Intel oneAPI (2021)
- **Build systems**: Meson, CMake, fpm
- **Coverage**: Collected with GCC 11 and uploaded to Codecov

### DCO (Developer Certificate of Origin)

Contributions require sign-off. The DCO bot checks all commits. Sign your commits:

```bash
git commit -s -m "Your commit message"
```

### Documentation Deployment

Documentation is built with FORD and deployed to GitHub Pages on:
- Pushes to `main` branch
- Tagged releases

## Adding New Features

### Adding a New File Format

1. Create reader in `src/mctc/io/read/` (e.g., `format.f90`)
2. Create writer in `src/mctc/io/write/` (e.g., `format.f90`)
3. Add filetype enum in `src/mctc/io/filetype.f90`
4. Register in `src/mctc/io/read.f90` and `src/mctc/io/write.f90`
5. Update meson.build and CMakeLists.txt in relevant directories
6. Add tests in `test/test_read_format.f90` and `test/test_write_format.f90`
7. Document in `doc/format-<name>.md`

### Core Data Types

- `structure_type` (`mctc_io_structure`) - Main molecular structure container
- `error_type` (`mctc_env`) - Error handling type

## Common Tasks

### Convert Geometry Files

```bash
# Using the mctc-convert tool
meson compile -C _build
./_build/app/mctc-convert input.xyz output.mol
```

### Read Structure in Your Code

```fortran
use mctc_io
use mctc_env

type(structure_type) :: mol
type(error_type), allocatable :: error

call read_structure(mol, "input.xyz", error)
if (allocated(error)) then
   print '(a)', error%message
   error stop
end if
```

## Build Options

### Meson Options (`meson_options.txt`)

| Option | Type | Default | Description |
|--------|------|---------|-------------|
| `openmp` | boolean | false | Enable OpenMP parallelization |
| `json` | feature | auto | Enable JSON format support |

```bash
meson setup _build -Djson=enabled -Dopenmp=true
```

### CMake Options

| Option | Description |
|--------|-------------|
| `WITH_JSON` | Enable JSON support |
| `WITH_OpenMP` | Enable OpenMP |

## Troubleshooting

### Common Issues

1. **Meson 1.8.0 error**: Upgrade or downgrade meson (`pip install meson!=1.8.0`)

2. **JSON tests fail**: Ensure jonquil dependency is available or disable with `-Djson=disabled`

3. **Missing Fortran compiler**: Set `FC` environment variable:
   ```bash
   FC=gfortran meson setup _build
   ```

## External Resources

- [GitHub Repository](https://github.com/grimme-lab/mctc-lib)
- [API Documentation](https://grimme-lab.github.io/mctc-lib)
- [Issue Tracker](https://github.com/grimme-lab/mctc-lib/issues)

## Contributing

1. Fork the repository
2. Create a feature branch
3. Make changes following the code style guidelines
4. Add tests for new functionality
5. Ensure all tests pass
6. Sign off commits (DCO requirement)
7. Submit a pull request

Error messages in mctc-lib are designed to be helpful with source location information.
If you encounter unclear error messages, please report them as bugs.

# The dd-story
*“A quantum chemist, an applied mathematician and a molecular dynamics expert enter in a meeting room…”*



### A long story short
#### ddCOSMO

The first aspect that should be apparent in the ddCOSMO story is that this is a multidisciplinary story, involving three different communities: applied mathematicians, quantum chemists and the classical molecular dynamics community. Therefore, the answer to the questions “what was the most rewarding part of the project” and “what was the most difficult part of the project” is unique: working together. The incredible language barrier between mathematicians and chemist has made the communication quite difficult until a common ground was found, and, after quite a few very funny reunions which ended with people looking at each other with a very puzzled face, we finally managed to fully understand each other. This certainly required a big effort from every side, but such an effort was amply rewarded not only by the results, which couldn’t have been obtained without such a collaboration, but also, or even mainly, for the fun we had working together and for the pleasure of collaborating with scientist that do not share the same education and view on problems, but can provide, every day and in every occasion, an exciting and new perspective on old and new problems.

The project has its roots in an awarded France-Berkeley-Fund proposal in 2011 which allowed the collaboration between the applied mathematicians Eric Cancès, Yvon Maday (Paris region) and Benjamin Stamm (UC Berkeley at that time). The initial plan was to use reduced order techniques in solvation models, but, as so often in life, we deviated from the original route and the ddCOSMO was developed. 

The chemistry side of this story starts in June 2012. Realizing the potentialities of the algorithm for chemical applications, Eric Cancès contacted Benedetta Mennucci to inquire whether she was interested in the development of the method, and whether she had a student who could work on the implementation and on the interface with the various quantum chemical packages. On Thursday June the 7th, Filippo Lipparini, at the time a Ph.D. student in Prof. Mennucci’s group, attended the first meeting in Paris. It was love at first sight!

A first, preliminary, pedestrian implementation was obtained in the following summer. The iterative solver was a simple Jacobi Solver, Spherical Harmonics – needed for the discretization – were generated using library calls for the trigonometric functions, no vectorization attempt of the code had been made and the stand-alone, Fortran 77 initial code was quite a mess: nevertheless, it was already at least two order of magnitude faster than the traditional COSMO implementations.

A first paper describing the algorithm was submitted to the Journal of Chemical Physics in March 2013. At the same time, the work on a more efficient implementation, and on the implementation of analytical derivatives of the ddCOSMO energy with respect to the nuclei’s positions had started. The results of this work were submitted to the Journal of Chemical Theory and Computation in April 2013. 

With the preliminary development of the ddCOSMO machinery completed, the interfacing work started. From the quantum chemistry side, a first implementation was achieved in Gaussian together with Benedetta Mennucci, first for semiempirical methods, then, in collaboration with Giovanni Scalmani, for general Quantum Mechanical models. From the classical side, ddCOSMO was implemented in Tinker for classical force field simulations first and for polarizable force fields later together with Jean-Philip Piquemal.

The results were very encouraging. We compared ddCOSMO to the fastest implementation we knew of – based on the Fast Multipole Method – and obtained a gain of two to three orders of magnitude. The comparison with traditional, quadratic scaling implementations was even more impressive, with elapsed time of several hours being reduced to a few seconds.
ddCOSMO proved to be so fast that we considered using it to provide a boundary condition in polarizable molecular dynamics simulation: taking fully into account the mutual polarization between the solvent and the solute, we could carry out MD simulations of medium-sized molecules on a standard computer node.

**A funny side note:** The first paper describing the algorithm that was submitted to the Journal of Chemical Physics in March 2013 by the three Mathematicians Cancès, Maday and Stamm received a funny review with statements such as:
*“..., however the manuscript suffers greatly from the reliance on the authors trying to write and act like mathematicians”*
*“There's a useful numerical method here, at the heart of it all, but the presentation is a convoluted mess …, if it is to be useful to (and understood by) the chemical physics community.”*
*“It's just a 3-d differential equation that they are mapping onto a boundary-element method and solving via domain decomposition. It's not rocket science, it's just linear equations -- so why present the material in a complicated (and tediously long) way?”*

#### ddPCM

#### ddLPB

Welcome to the API documentation for **TOML Fortran** (toml-f), a TOML parser implementation for data serialization and deserialization in Fortran.

## Getting Started

To use TOML Fortran in your project, import the main module:

```fortran
use tomlf
```

This provides access to all public types and procedures for parsing, manipulating, and serializing TOML data.

## Core Functionality

### Parsing TOML

- [[toml_load]] - Load a TOML document from a file
- [[toml_loads]] - Parse a TOML document from a string
- [[toml_parse]] - Parse TOML from a connected unit

### Serialization

- [[toml_dump]] - Write a TOML table to a file
- [[toml_dumps]] - Serialize a TOML table to a string
- [[toml_serialize]] - Serialize using the visitor pattern

### Data Access

- [[get_value]] - Retrieve values from TOML tables and arrays
- [[set_value]] - Set values in TOML tables and arrays

## Data Types

| Type | Description |
|------|-------------|
| [[toml_table]] | TOML table (key-value mapping) |
| [[toml_array]] | TOML array |
| [[toml_keyval]] | Single key-value pair |
| [[toml_value]] | Abstract base type for all TOML values |
| [[toml_datetime]] | TOML datetime representation |
| [[toml_error]] | Error information from parsing |

## Example

```fortran
use tomlf
implicit none
type(toml_table), allocatable :: table
type(toml_error), allocatable :: error
character(len=:), allocatable :: title

call toml_load(table, "config.toml", error=error)
if (allocated(error)) then
   print '(a)', error%message
   stop 1
end if

call get_value(table, "title", title)
print '(a)', title
```

## Further Resources

- [User Documentation](https://toml-f.readthedocs.io) - Tutorials and how-to guides
- [TOML Specification](https://toml.io/en/v1.0.0) - The TOML v1.0.0 standard
- [GitHub Repository](https://github.com/toml-f/toml-f) - Source code and issue tracker

---
project: Simple DFT-D3
summary: A simple reimplementation of the DFT-D3 dispersion model
project_github: https://github.com/dftd3/simple-dftd3
project_download: https://github.com/dftd3/simple-dftd3/releases
project_website: https://dftd3.readthedocs.io
author: Sebastian Ehlert
author_description: Quantum chemistry researcher developing semi-empirical quantum chemistry in Fortran and Python.
github: https://github.com/awvwgk
src_dir: ./src
         ./app
output_dir: ./_docs
exclude_dir: ./test
docmark: <
predocmark: >
source: true
graph: false
sort: alpha
preprocess: false
print_creation_date: true
extra_mods: iso_fortran_env:https://gcc.gnu.org/onlinedocs/gfortran/ISO_005fFORTRAN_005fENV.html
            mctc_io:https://grimme-lab.github.io/mctc-lib/modules/mctc_io.html
            mctc_env:https://grimme-lab.github.io/mctc-lib/modules/mctc_env.html
creation_date: %Y-%m-%d %H:%M %z
md_extensions: markdown.extensions.toc
               markdown.extensions.smarty
---

A simple drop-in replacement for ``dftd3``.

This program provides a small and easy to use implementation of the DFT-D3 dispersion correction
(see [*JCP* **132**, 154104 (2010)](https://dx.doi.org/10.1063/1.3382344)
and [*JCC* **32**, 1456 (2011)](https://dx.doi.org/10.1002/jcc.21759) for details).

It is mostly based on the [`dftd4`](https://github.com/dftd4/dftd4) program and
borrows one or two ideas from the implementation in [`ased3`](https://github.com/ehermes/ased3).


[TOC]


## Usage

To use DFT-D3 in your application you can either use the Fortran API or the C API.

### Fortran API

To perform a D3(BJ)-ATM calculation in a Fortran program, the [[dftd3]] module should be imported.
Other data types to communicate with the library are obtained from the [MCTC library](https://grimme-lab.github.io/mctc-lib) using the environment module ([[mctc_env]]) and the IO module ([[mctc_io]]).

```fortran
subroutine calc_dftd3(mol, method, energy, gradient, sigma, error)
   use mctc_env
   use mctc_io
   use dftd3
   type(structure_type), intent(in) :: mol
   character(len=*), intent(in) :: method
   real(wp), intent(out) :: energy
   real(wp), intent(out) :: gradient(:, :)
   real(wp), intent(out) :: sigma(:, :)
   type(error_type), allocatable, intent(out) :: error
   type(d3_model) :: disp
   type(d3_param) :: inp
   type(rational_damping_param), allocatable :: param

   call get_rational_damping(inp, method, error, s9=1.0_wp)
   if (allocated(error)) return
   call new_rational_damping(param, inp)

   call new_d3_model(disp, mol)

   call get_dispersion(mol, disp, param, realspace_cutoff(), energy, &
      & gradient, sigma)

end subroutine calc_dftd3
```


### C API

An example wrapper for a DFT-D3(BJ)-ATM calculation is given here.

```c
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

#include "dftd3.h"

static const buffersize = 512;

int
calc_dftd3(int natoms, int* numbers, double* positions,
           double* lattice, bool* periodic, char* method,
           double* energy, double* gradient, double* sigma)
{
   // Local API objects from the s-dftd3 library
   dftd3_error error = dftd3_new_error();
   dftd3_structure mol = NULL;
   dftd3_model disp = NULL;
   dftd3_param param = NULL;
   int stat = EXIT_SUCCESS;

   // Create a new geometry for the library to work with
   mol = dftd3_new_structure(error, natoms, numbers, positions, lattice, periodic);
   stat = dftd3_check_error(error);

   if (stat) {
      // Initialize the D3 dispersion model for the given structure,
      // this step depends on the atomic numbers, but not on the actual geometry
      disp = dftd3_new_d3_model(error, mol);
      stat = dftd3_check_error(error);
   }

   if (stat) {
      // Load D3(BJ)-ATM parameters for the given method from internal storage,
      // this step depends on the atomic numbers, but not on the actual geometry
      param = dftd3_load_rational_damping(error, mol, method, true);
      stat = dftd3_check_error(error);
   }

   if (stat) {
      // Evaluate the dispersion energy, gradient and virial,
      // the gradient and virial are optional and can be replaced by NULL
      dftd3_get_dispersion(error, mol, disp, param, &energy, gradient, sigma);
      stat = dftd3_check_error(error);
   }

   if (!stat) {
      char buffer[buffersize];
      dftd3_get_error(error, buffer, buffersize);
      printf("[Error] %s\n", buffer);
   }

   // Always free the used memory
   dftd3_delete_error(&error);
   dftd3_delete_structure(&mol);
   dftd3_delete_model(&disp);
   dftd3_delete_param(&param);

   return stat;
}
```

Overall, any DFT-D3 calculation requires the creation of four API objects.

The error handling is done with a ``dftd3_error`` handle, it can be checked using the ``dftd3_error_check`` function and returns zero values on success and non-zero values on failures.
On failures the error handle can be queried for the error message with ``dftd3_get_error``.
The library itself will not attempt to write or terminate on any encounter of an error.

To pass the geometry information a ``dftd3_structure`` object is used.
The object has immutable number of atoms, atomic numbers and boundary conditions, but allows updating the coordinates and lattice vectors after creation.
The structure object is required to initialize system specific data of other API objects.
Atomic numbers are allowed in a range of 1 to 118, but the used dispersion model might support a smaller range.

The actual D3 dispersion model is created as ``dftd3_model`` object using the ``new_d3_model`` constructor.
It contains the interpolation scheme for the dispersion coefficients, which is common to all DFT-D3 dispersion corrections independently of the damping function.
In principle this part can be replaced by a different scheme to evaluate the dispersion coefficients.
This step might require an internal initialization on the first invocation.
The internal initialization is done once and in an OpenMP thread-safe way in case the library is compiled OpenMP threading.
Otherwise guard this API call with a ``critical`` pragma if you require thread-safe execution.

Finally, to evaluate dispersion energies and gradients a damping function is required to connect the dispersion model to a method like a density functional.
The damping parameters are stored as ``dftd3_param`` object and can either be loaded from the internal storage of the library or created by supplying the parameters directly.

Make sure to delete the API objects after you are done with them.
The deconstructor will return without any action in case a null pointer is passed.
After deconstructing the API objects are overwritten with a null pointer.


## Getting Started

### Meson

Create a new meson project and include `s-dftd3` either as git-submodule in your subprojects directory or create a wrap file to fetch it from upstream:

```ini
[wrap-git]
directory = s-dftd3
url = https://github.com/dftd3/simple-dftd3
revision = head
```

To load the project the necessary boilerplate code for subprojects is just

<!--pygments doesn't know about meson, python highlighting looks okayish-->
```python
sdftd3_prj = subproject(
  's-dftd3',
  version: '>=0.1',
  default_options: [
    'default_library=static',
  ],
)
sdftd3_dep = sdftd3_prj.get_variable('sdftd3_dep')
```

Now you can add `sdftd3_dep` to your dependencies and access the public API by the `dftd3` module.

We recommend to set the default library type of `s-dftd3` to static when linking your applications or library against it.
Note for library type both and shared `s-dftd3` will install itself along with your project.

For more fine-tuned control you can access:

- the library target with `sdftd3_lib`
- the private include dir of this target, containing the Fortran module files, with `sdftd3_inc`
- the license files of `s-dftd3` with `sdftd3_lic`

If you are linking your application statically against `s-dftd3` and still want to distribute the license files of `s-dftd3` (thank you), just use

```python
install_data(
  sdftd3_prj.get_variable('sdftd3_lic'),
  install_dir: get_option('datadir')/'licenses'/meson.project_name()/'s-dftd3',
)
```


### Fortran Package Manager (fpm)

This project supports [fpm](https://github.com/fortran-lang/fpm) as build system as well.
Just add it to the dependencies in your `fpm.toml` file:

```toml
[dependencies]
s-dftd3.git = "https://github.com/dftd3/simple-dftd3"
```

# General information
ddX is an open-source software package for continuum solvation models based on
the domain decomposition paradigm. It contains a common interface for the three
different methods ddCOSMO, ddPCM and ddLPB for the numerical solution to the
COSMO, PCM and LPB solvation models. 
ddX computes for these methods the electrostatic contribution to the solvation
energy, the corresponding contribution to the forces and/or the contribution to
the Fock- or DFT Kohn-Sham-matrix.
Using a common [Python interface](@ref label_python_interface), all three
methods are accessible from a host-code that is used to model the solute. The
host code can be on the level of QM, QM/MM, polarizable MM or MM.
In this fashion an [interface to Psi4](https://psicode.org/psi4manual/master/ddx.html)
has been recently realised.
Additionally a standalone application, the [*ddx_driver* is available](@ref label_run_as_standalone).

For referencing the library and methods, see [the list of relevant references](@ref label_references).

# Download and Installation  {#label_download_and_install}

## Python package

ddx is available in the form of the `pyddx` python package. This can be installed
directly from pypi:
```
pip install pyddx
```
A conda-forge package will be added soon.

If you want to build the python package from source, simply run:
```
setup.py test
```

<br />

## Source Code

**Download the ddX source code** from GitHub:

```
git clone git@github.com:ddsolvation/ddX.git
```

Then change into the cloned directory:

```
cd ddX
```

The main Fortran sources for ddX reside in the `src/` folder. You can build ddX using either **CMake** or **Meson**, as outlined below.

---

## Building with CMake

1. Create a build directory and enter it:
   ```bash
   mkdir build
   cd build
   ```
2. Run CMake to configure:
   ```bash
   cmake ..
   ```
3. Compile the library and executables:
   ```bash
   make
   ```
4. (Optional) Run the test suite:
   ```bash
   make test
   ```

By default, the compiled library and executables will appear in the `build` folder. The original sources remain in `src/`.

**Build the documentation** as follows (after you have done the above process):
```bash
cd build
make docs
```
**To see the documentation**
```bash
cd ../doxygen
pwd
```
Copy the link shown by pwd and add /index.html in a web browser

**Specifying compilers** can be done by passing the desired compilers to CMake:
```
cmake -D CMAKE_CXX_COMPILER=/usr/local/bin/g++-11 CMAKE_Fortran_COMPILER=/usr/local/bin/gfortran-11 ..
```
or
```
cmake -D CMAKE_CXX_COMPILER=icx CMAKE_Fortran_COMPILER=ifort ..
```
**NOTE**: Replace with the compilers you desire.


---

## Building with Meson

[meson](https://mesonbuild.com) version 0.61 or newer, with
  a build-system backend, *i.e.* [ninja](https://ninja-build.org) version 1.10 or newer, are required.

1. Set up a build directory:
   ```bash
   meson setup build
   ```
2. Compile:
   ```bash
   meson compile -C build
   ```
3. Run the test suite (and print any error logs):
   ```bash
   meson test -C build
   ```

Again, the built library and any executables will appear in the `build` folder, while the ddX source remains in `src/`.


---

## Building with FPM

[Fortran Package Manager (FPM)](https://fpm.fortran-lang.org/) version 0.8.0 or newer is required.

1. Build and compile:
   ```bash
   fpm build
   ```
2. Run the standalone with an input file:
   ```bash
   fpm run -- [path/to/input].txt
   ```
   *For instance:*
   ```bash
   fpm run -- tests/Input-example.txt
   ```
3. Run the test suite:
   ```bash
   fpm test
   ```

# AGENTS.md - Guidelines for AI Coding Assistants

This document provides guidance for AI coding assistants (GitHub Copilot, Claude, etc.) working with the TOML-Fortran (toml-f) codebase.

## Project Overview

TOML-Fortran is a TOML parser implementation for data serialization and deserialization in Fortran. It provides a complete implementation of the [TOML v1.0.0 specification](https://toml.io/en/v1.0.0).

- **Language**: Fortran 2008
- **License**: Apache-2.0 OR MIT (dual-licensed)
- **Repository**: https://github.com/toml-f/toml-f

## Code Structure

```
toml-f/
├── src/                   # Main source code
│   ├── tomlf.f90          # Public API module
│   └── tomlf/             # Implementation modules
│       ├── build/         # Builder utilities (get_value, set_value)
│       ├── de/            # Deserializer (parser, lexer)
│       ├── ser.f90        # Serializer
│       ├── structure/     # Internal generic data structures (list, map, ordered_map, etc.)
│       ├── type/          # Type definitions (TOML types: toml_table, toml_array, toml_keyval)
│       ├── utils/         # Utility functions
│       └── ...
├── test/                  # Test suite
│   ├── unit/              # Unit tests (using test-drive framework)
│   ├── compliance/        # TOML compliance tests (toml2json, json2toml)
│   ├── example-1/         # Example programs
│   └── version/           # Version tests
├── doc/                   # Sphinx documentation source
├── config/                # Build configuration files
└── subprojects/           # Meson subprojects (test-drive)
```

## Build Systems

This project supports three build systems:

### Meson (Preferred)
```bash
meson setup _build
meson compile -C _build
meson test -C _build --print-errorlogs
```

### CMake
```bash
cmake -B _build -G Ninja
cmake --build _build
ctest --test-dir _build
```

### Fortran Package Manager (fpm)
```bash
fpm build
fpm test
```

## Coding Conventions

### File Headers

All source files must include the SPDX license header:

```fortran
! This file is part of toml-f.
! SPDX-Identifier: Apache-2.0 OR MIT
!
! Licensed under either of Apache License, Version 2.0 or MIT license
! at your option; you may not use this file except in compliance with
! the License.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.
```

### Fortran Style

- Use **free-form** Fortran source format (`.f90` extension)
- Use `implicit none` in all program units
- Prefer `intent(in)`, `intent(out)`, or `intent(inout)` for all dummy arguments
- Use descriptive variable and procedure names
- Document public procedures with comment blocks describing parameters
- Use `allocatable` for dynamic data rather than pointers where possible

### Naming Conventions

- Module names: `tomlf_<component>` (e.g., `tomlf_de`, `tomlf_ser`)
- Public API uses `toml_` prefix (e.g., `toml_load`, `toml_dumps`, `toml_table`)
- Type names: `toml_<name>` (e.g., `toml_table`, `toml_array`)
- Internal/private procedures use descriptive names without prefix
- Test modules: `test_<component>` (e.g., `test_lexer`)

### Module Structure

```fortran
module tomlf_example
   use dependency_module, only : specific_imports
   implicit none
   private

   public :: public_type, public_procedure

   ! Type definitions

   ! Interface definitions

contains

   ! Procedure implementations

end module tomlf_example
```

### Documentation

- Use FORD-compatible docstrings (marked with `!>`)
- User documentation is written in reStructuredText (Sphinx)

## Public API

The main public API is exposed through the `tomlf` module (`src/tomlf.f90`):

- **Parsing**: `toml_parse`, `toml_load`, `toml_loads`
- **Serialization**: `toml_serialize`, `toml_dump`, `toml_dumps`
- **Data access**: `get_value`, `set_value`
- **Types**: `toml_table`, `toml_array`, `toml_keyval`, `toml_value`
- **Utilities**: `toml_datetime`, `toml_error`, `toml_stat`

Internal modules under `src/tomlf/` are not part of the public API and may change between versions.

## Testing

Unit tests are located in `test/unit/`, using the [test-drive](https://github.com/fortran-lang/test-drive) framework.

- Each test module should have a `collect_<name>` subroutine that returns a testsuite
- Run tests with: `meson test -C _build` or `fpm test` or `ctest`

Key test files:
- `test/unit/lexer.f90` - Lexer tests
- `test/unit/parser.f90` - Parser tests
- `test/unit/build.f90` - Builder tests
- `test/unit/utils.f90` - Utility tests
- `test/unit/sort.f90` - Sorting tests

### Adding New Tests

1. Create a new test file `test/unit/test_<name>.f90`
2. Add the test to the build system files (`meson.build`, `CMakeLists.txt`)
3. Register the test collection in `test/unit/main.f90`

### Compliance Tests

The project uses the [BurntSushi/toml-test](https://github.com/BurntSushi/toml-test) validator suite for TOML standard compliance testing. The `toml2json` and `json2toml` binaries in `test/compliance/` are used for this.

## Key Components

### Lexer (`src/tomlf/de/lexer.f90`)
Tokenizes TOML input into a stream of tokens.

### Parser (`src/tomlf/de/parser.f90`)
Parses token stream into TOML data structures.

### TOML Types (`src/tomlf/type/`)
- `toml_table` - TOML table (hash map)
- `toml_array` - TOML array
- `toml_keyval` - Key-value pair

### Serializer (`src/tomlf/ser.f90`)
Converts TOML data structures back to TOML format.

## Contributing Guidelines

1. **One feature/fix per PR** - Keep pull requests focused
2. **Sign commits** - Use `git commit -s` (Developer Certificate of Origin)
3. **Test changes** - Add or update tests for new functionality
4. **Follow style** - Match existing code formatting and conventions

## Dependencies

- **Build-time**: Fortran compiler (GFortran 5+, Intel Fortran 18+, NAG 7+)
- **test-drive** (v0.4.0): Unit testing framework (test dependency only)
- **Compliance testing**: Go (for toml-test validator)

## When Making Changes

1. Ensure changes compile with all three build systems
2. Add or update unit tests for new functionality
3. Maintain backward compatibility with the public API
4. Update version numbers in `src/tomlf/version.f90` and build files for releases
5. Follow the existing code style in neighboring code

## Common Tasks

### Adding a new feature
1. Implement in appropriate module under `src/tomlf/`
2. Export through `src/tomlf.f90` if part of public API
3. Add unit tests in `test/unit/`
4. Update documentation in `doc/`

### Fixing a parser bug
1. Check `src/tomlf/de/lexer.f90` for tokenization issues
2. Check `src/tomlf/de/parser.f90` for parsing logic
3. Run compliance tests to verify fix

### Updating documentation
- User docs: Edit files in `doc/` (reStructuredText)
- API docs: Update docstrings in source files (FORD format)

## Resources

- [TOML v1.0.0 Specification](https://toml.io/en/v1.0.0)
- [TOML Fortran Documentation](https://toml-f.readthedocs.io)
- [Fortran Best Practices](https://fortran-lang.org/learn/best_practices)

API documentation for the modular computation tool chain library.
For installation instructions and getting started, see the [README](https://github.com/grimme-lab/mctc-lib).

[TOC]

## Module Overview

The library is organized into four main modules:

| Module | Purpose |
|--------|---------|
| [[mctc_io]] | Structure I/O and representation |
| [[mctc_env]] | Error handling and precision constants |
| [[mctc_data]] | Element data (radii, electronegativities) |
| [[mctc_ncoord]] | Coordination number evaluation |

### Units Convention

All quantities in mctc-lib use **atomic units**:

- Coordinates and radii are in **Bohr** (1 Bohr = 0.529177 Å)
- Energies are in **Hartree** (where applicable)

The [[mctc_io_convert]] module provides conversion factors derived from CODATA constants:

```f90
use mctc_io_convert, only : aatoau, autoaa

! Convert Ångström to Bohr (atomic units)
xyz_bohr = xyz_ang * aatoau

! Convert Bohr to Ångström
xyz_ang = xyz_bohr * autoaa
```

Available conversion factors:

| Factor | Description |
|--------|-------------|
| `aatoau` | Ångström → Bohr |
| `autoaa` | Bohr → Ångström |
| `autoeV` | Hartree → electron volts |
| `evtoau` | electron volts → Hartree |
| `autokj` | Hartree → kJ/mol |
| `kjtoau` | kJ/mol → Hartree |
| `autokcal` | Hartree → kcal/mol |
| `kcaltoau` | kcal/mol → Hartree |
| `autorcm` | Hartree → cm⁻¹ |
| `rcmtoau` | cm⁻¹ → Hartree |
| `autonm` | Hartree → nm (wavelength) |
| `nmtoau` | nm (wavelength) → Hartree |


## Structure Representation

The [[structure_type]] is the central data structure for molecular and periodic systems.

### Key Components

| Component | Type | Description |
|-----------|------|-------------|
| `nat` | integer | Number of atoms |
| `nid` | integer | Number of unique species |
| `xyz(3, nat)` | real(wp) | Cartesian coordinates (Bohr) |
| `num(nid)` | integer | Atomic numbers for each species |
| `id(nat)` | integer | Species index for each atom |
| `sym(nid)` | character | Element symbols for each species |
| `charge` | real(wp) | Total molecular charge |
| `uhf` | integer | Number of unpaired electrons |
| `lattice(3, 3)` | real(wp) | Lattice vectors (Bohr), optional |
| `periodic(3)` | logical | Periodic directions, optional |
| `bond(2, nbd)` | integer | Bond connectivity, optional |

### Creating Structures

Use [[new]] for programmatic construction:

```f90
use mctc_io
type(structure_type) :: mol

! From atomic numbers and coordinates (in Bohr)
call new(mol, [8, 1, 1], xyz, charge=0.0_wp, uhf=0)

! From element symbols
call new(mol, ["O", "H", "H"], xyz)

! With periodicity
call new(mol, num, xyz, lattice=lattice, periodic=[.true., .true., .true.])
```


## Input and Output

The [[mctc_io]] module provides format-agnostic structure I/O.

### Reading Structures

Use [[read_structure]] to read from files:

```f90
use mctc_io
use mctc_env

type(structure_type) :: mol
type(error_type), allocatable :: error

! Auto-detect format from extension
call read_structure(mol, "input.xyz", error)

! Explicit format specification
call read_structure(mol, "input.dat", error, filetype%xyz)
```

### Writing Structures

Use [[write_structure]] to write to files:

```f90
! Auto-detect format
call write_structure(mol, "output.mol", error)

! Explicit format
call write_structure(mol, "output.dat", error, filetype%gen)
```

### Format Detection

Use [[get_filetype]] to determine the file format from a filename, or the
[[mctc_io_filetype:filetype]] enumerator directly when the format is known.
See [[mctc_io_filetype]] for the complete list of supported formats.

```f90
use mctc_io, only : filetype, get_filetype

integer :: ftype
ftype = get_filetype("molecule.xyz")  ! Returns filetype%xyz
```

See the [format documentation](./page/index.html) for details on each format.


## Error Handling

The [[mctc_env]] module provides the [[error_type]] for error propagation.

### Error Pattern

```f90
use mctc_env
type(error_type), allocatable :: error

call library_routine(result, error)
if (allocated(error)) then
   write(*, '(a)') error%message
   error stop 1
end if
```

### Creating Errors

Use [[fatal_error]] in your own routines:

```f90
use mctc_env, only : error_type, fatal_error

subroutine my_routine(input, output, error)
   type(error_type), allocatable, intent(out) :: error

   if (invalid_condition) then
      call fatal_error(error, "Descriptive error message")
      return
   end if
end subroutine
```


## Element Data

The [[mctc_data]] module provides element-specific data.
All radii are returned in **Bohr**.

### Available Functions

| Function | Description |
|----------|-------------|
| [[get_covalent_rad]] | Covalent radii |
| [[get_vdw_rad]] | van der Waals radii |
| [[get_atomic_rad]] | Atomic radii |
| [[get_pauling_en]] | Pauling electronegativities |

### Usage

```f90
use mctc_data
use mctc_env, only : wp

real(wp) :: r_cov, r_vdw, en

r_cov = get_covalent_rad(6)   ! Carbon
r_vdw = get_vdw_rad(6)
en = get_pauling_en(6)
```


## Coordination Numbers

The [[mctc_ncoord]] module provides coordination number evaluators.
See the module documentation for the complete list of available counting functions.

### Usage

```f90
use mctc_ncoord
use mctc_io, only : structure_type
use mctc_env, only : wp, error_type

class(ncoord_type), allocatable :: ncoord
type(error_type), allocatable :: error
real(wp), allocatable :: cn(:)

call new_ncoord(ncoord, mol, cn_count%exp, error)
if (allocated(error)) stop error%message

allocate(cn(mol%nat))
call ncoord%get_cn(mol, cn)
```


## Symbol Conversion

Convert between element symbols and atomic numbers:

```f90
use mctc_io, only : to_symbol, to_number

character(len=2) :: sym
integer :: num

sym = to_symbol(6)     ! Returns "C"
num = to_number("C")   ! Returns 6
num = to_number("c")   ! Case-insensitive, returns 6
```


## Integration Guide

### As Meson Subproject

Add to `subprojects/mctc-lib.wrap`:

```ini
[wrap-git]
directory = mctc-lib
url = https://github.com/grimme-lab/mctc-lib
revision = head
```

In `meson.build`:

```python
mctc_dep = dependency('mctc-lib', fallback: ['mctc-lib', 'mctc_dep'])
```

### As fpm Dependency

In `fpm.toml`:

```toml
[dependencies.mctc-lib]
git = "https://github.com/grimme-lab/mctc-lib"
```

# Run as standalone  {#label_run_as_standalone}
The standalone application requires an input file within the specific format outlined below. 
Run the code as
``` markdown
> ./src/ddx_driver *path-to-input-file*
```
**Example:** (using the default input-file)
``` markdown
> ./src/ddx_driver ../tests/Input-example.txt
```

<br />
**Description of input parameters in input-file**

Line number  | type           | description   
------------- | ------------- | -------------- 
1  | String | Filename for Log-file where information about the convergence of the linear solver is saved, the void string '' means that no log-file is saved
2  | Integer  | Number of OpenMP cores to be used
3  | Integer  | Specification of the model <br />  1: COSMO, 2: PCM, 3: LPB
4  | Integer  | Maximal degree \f$\ell_{\max}\f$ of modeling spherical harmonics
5  | Integer  | Approximate number of Lebedev grid points
6  | Float    | Dielectric permittivity constant \f$\varepsilon_s\f$ of the bulk solvent
7  | Float    | Shift \f$s\f$ of the regularized characteristic function \f$\chi_\eta\f$, range=[-1,1]. Recommended value: -1 for ddcosmo and 0 for ddpcm or ddplpb
8  | Float    | Regularization parameter \f$\eta\f$ of the smoothing function \f$\chi_\eta\f$, range=[0,1]. Recommended value: 0.1
9  | Float    | Debye Hückel parameter \f$\kappa_s\f$ of the bulk solvent
10  | Integer  | Whether to compute and store sparse matrices (1) or apply the matrix-vector product on the fly (0), range={0,1} <br /> The sparse matrices are the solution matrix of ddCOSMO referred to as \f$L\f$ used in ddCOSMO and ddPCM, and the matrices \f$A\f$ and \f$B\f$ in ddLPB.
11 | Float    | The relative threshold \f$tol\f$ for the iterative solver
12 | Integer  | Maximum number of iterations of the iterative solver before stopping
13 | Integer  | Number of Jacobi/DIIS extrapolation points
14 | Integer  | Whether to compute (1) or not (0) the forces, range={0,1}
15 | Integer  | Whether to use (1) or not (0) the FMM, range={0,1} 
16 | Integer  | Max degree of multipole spherical harmonics \f$\tilde\ell_{\max}\f$ for the FMM (recommended value \f$\tilde\ell_{\max}=\ell_{\max}\f$)
17 | Integer  | Max degree of local spherical harmonics \f$p_{\max}\f$ for the FMM (recommended value \f$p_{\max}=6\f$)
18 | Integer  | Number of spheres of the atomic structure
19--END | Float[5] | The flollowing lines specify for each atom (should be consistent with entry on line 20) the values c,x,y,z,r where the partial charge (c), x-coordinate (x), y-coordinate (y), z-coordinate (z), radius (r) are listed (see example below). The charges are in *atomic units* and the coordinates and the radii in *Ångstrom*.


**Remarks:**
1. The order of the lines is essential


**Example of an input file:**
```
''          ! Name of log-file for convergence history of the solvers 
1           ! Number of OpenMP cores to be used
1           ! Specification of the model: 1 for COSMO, 2 for PCM and 3 for LPB
7           ! Maximal degree of modeling spherical harmonics
302         ! Approximate number of Lebedev grid points
78.3553     ! Dielectric permittivity constant
0.0         ! Shift of the regularized characteristic function
0.1         ! Regularization parameter
0.0         ! Debye Hückel parameter
0           ! Whether to compute and store sparse matrices (1) or not (0)
1d-8        ! The relative threshold for the iterative solver
100         ! Maximum number of iterations
20          ! Number of Jacobi DIIS extrapolation points
1           ! Whether to compute (1) or not (0) forces
1           ! Whether to use (1) or not (0) the FMM
7           ! Max degree of multipole spherical harmonics for the FMM
6           ! Max degree of local spherical harmonics for the FMM
12          ! Number of spheres of the atomic structure
-0.04192   0.00000   2.29035   1.32281   4.00253    ! partial charge[a.u.], x[Å], y[Å], z[Å], radius[Å]
-0.04192   0.00000   2.29035  -1.32281   4.00253
-0.04198   0.00000   0.00000  -2.64562   4.00253
-0.04192   0.00000  -2.29035  -1.32281   4.00253
-0.04192   0.00000  -2.29035   1.32281   4.00253
-0.04198   0.00000   0.00000   2.64562   4.00253
 0.04193   0.00103   4.05914   2.34326   2.99956
 0.04193   0.00103   4.05914  -2.34326   2.99956
 0.04197   0.00000   0.00000  -4.68652   2.99956
 0.04193  -0.00103  -4.05914  -2.34326   2.99956
 0.04193  -0.00103  -4.05914   2.34326   2.99956
 0.04197   0.00000   0.00000   4.68652   2.99956
```

# Python interface  {#label_python_interface}

## Download the python package pyddx
### Using conda
Pyddx is available on [conda-forge](https://anaconda.org/conda-forge/pyddx)
and can be seamlessly installed via `conda`:
```
conda install -c conda-forge pyddx
```

### Using pip
You can download the python-interface with ddx from pypi.org following:
```
pip install pyddx
```
Note that at least pip 10 is required.
Please find [here](https://pypi.org/project/pyddx/) the PyPI-webpage.


<br />
## Example
It is simplest by starting with an example. 
The following example can be found in examples/run_ddx.py. 

In the terminal, run the example (from the root directory)
```
python examples/run_ddx.py
```

or launch it interactively within python:
```python
import pyddx
import numpy as np

tobohr = 1 / 0.52917721092
charges = np.array([
    -0.04192, -0.04192, -0.04198, -0.04192, -0.04192, -0.04198,
    0.04193, 0.04193,  0.04197,  0.04193,  0.04193,  0.04197
])
rvdw = tobohr * np.array([
    4.00253, 4.00253, 4.00253, 4.00253, 4.00253, 4.00253,
    2.99956, 2.99956, 2.99956, 2.99956, 2.99956, 2.99956
])
centres = tobohr * np.array([
    [ 0.00000,  2.29035,  1.32281],
    [ 0.00000,  2.29035, -1.32281],
    [ 0.00000,  0.00000, -2.64562],
    [ 0.00000, -2.29035, -1.32281],
    [ 0.00000, -2.29035,  1.32281],
    [ 0.00000,  0.00000,  2.64562],
    [ 0.00103,  4.05914,  2.34326],
    [ 0.00103,  4.05914, -2.34326],
    [ 0.00000,  0.00000, -4.68652],
    [-0.00103, -4.05914, -2.34326],
    [-0.00103, -4.05914,  2.34326],
    [ 0.00000,  0.00000,  4.68652],
]).T

print(pyddx.banner())

model = pyddx.Model("pcm", charges, centres, rvdw, solvent_epsilon=78.3553)

# Compute solute contributions (here just charges)
solute_multipoles = charges.reshape(1, -1) / np.sqrt(4 * np.pi)
solute_field = model.multipole_electrostatics(solute_multipoles)
solute_psi = model.multipole_psi(solute_multipoles)

# Solve the problem
state = pyddx.State(model, solute_field["phi"], solute_psi)
state.fill_guess()
state.solve()
state.fill_guess_adjoint()
state.solve_adjoint()

# Show results
energy = 0.5 * np.sum(state.x * solute_psi)
force = state.solvation_force_terms()
print(energy)
print(force)
```

<br />
## Use ddX in python
We now proceed with further informations.
Within python, import the pyddx-package
```
>>> import pyddx
```

<br />
### Model constructor
Define the model as follows
```python
model = pyddx.Model(model, sphere_charges, sphere_centres, sphere_radii, solvent_epsilon)
```
Here, the model is constructed with the following mandatory arguments:

Argument number | name | type        | description   
------------- | ------------- | -------------- | -------------- 
1  | model | string | String with the model name, i.e. "cosmo", "pcm" or "lpb"
2  | sphere_charges | array  | Numpy-array containing the charges (of dimension 1 x n_spheres)
3  | sphere_centres | array  | Numpy-array  containing the centres of the spheres/atoms (of dimension 3 x n_spheres)
4  | sphere_radii | array  | Numpy-array  containing the radii of the cavity spheres (of dimension 1 x n_spheres)
5  | solvent_epsilon | double | Value of the solvent dielectric permittivity

The following arguments are optional:

Name | type        | description   
------------- | ------------- | -------------- 
solvent_kappa  | double | Debye Hückel parameter \f$\kappa_s\f$ of the bulk solvent
eta  | double  | Regularization parameter \f$\eta\f$ of the smoothing function \f$\chi_\eta\f$, range=[0,1]
lmax  | int  | Maximal degree \f$\ell_{\max}\f$ of modeling spherical harmonics
n_lebedev  | int  | Approximate number of Lebedev grid points
incore | bool | Whether to compute and store sparse matrices (1) or apply the matrix-vector product on the fly (0), range={0,1} <br /> The sparse matrices are the solution matrix of ddCOSMO referred to as \f$L\f$ used in ddCOSMO and ddPCM, and the matrices \f$A\f$ and \f$B\f$ in ddLPB.
maxiter  | int  | Maximum number of iterations of the iterative solver before stopping
jacobi_n_diis | int | Number of Jacobi/DIIS extrapolation points
enable_fmm | bool | Whether to use (1) or not (0) the FMM, range={0,1} 
fmm_multipole_lmax | int | Max degree of multipole spherical harmonics \f$\tilde\ell_{\max}\f$ for the FMM (recommended value \f$\tilde\ell_{\max}=\ell_{\max}\f$). 
fmm_local_lmax | int | Max degree of local spherical harmonics \f$p_{\max}\f$ for the FMM (recommended value \f$p_{\max}=6\f$). 
n_proc | int | Number of OpenMP cores to be used

<br />
### Functions
The following functions are available 
Name | description   
------------- | ------------- 
initial_guess | Builds an initial guess for the state variable
solve         | Solves the linear system that defines the state variable
adjoint_solve | Solves the adjoint linear system that is required for the force computation and/or the contribution to the Fock-/DFT-operator
force_terms   | Computes the forces due to the presence of the solvent, i.e. minus the gradient of the solvation energy w.r.t. the nuclear coordinates
solute_nuclear_contribution | Returns the terms of the nuclear contribution to the solvation as a python dictionary
scaled_ylm    | Computes the scaled harmonics with reference to a atomic sphere "sphere" of radius "r" centred at "a" compute \f$\frac{4π}{2 \ell +1} \cdot \frac{\|x-a\|^\ell}{r^\ell} \cdot Y_\ell^m(\|x-a\|)\f$

For further informations about the arguments, see the documentation in python 
```
>>> help(pyddx)
>>> help(pyddx.Model)
>>> help(pyddx.State)
```

# ddX-References  {#label_references}

The relevant literature for the ddX and the individual ddCOSMO, ddPCM and ddLPB methods is listed below. If you're using one of the methods through the ddX-library, please cite the corresponding paper(s).

<br />
#### ddX library
[1]  <a href="https://doi.org/10.1002/wcms.1726" target="_blank">M. Nottoli, M. F. Herbst, A. Mikhalev, A. Jha, F. Lipparini, B. Stamm,  ddX: Polarizable continuum solvation from small molecules to proteins, WIREs Computational Molecular Science, Vol. 14, No. 4, pp. e1726 (2024)</a>

<br />
#### ddCOSMO: 

[2] <a href="https://doi.org/10.1063/1.4816767" target="_blank">E. Cancès, Y. Maday, B. Stamm, Domain decomposition for implicit solvation models, Journal of Chemical Physics, Vol. 139, No. 5, pp. 054111 (2013)</a>

[3] <a href="https://doi.org/10.1021/ct400280b" target="_blank">F. Lipparini, B. Stamm, E. Cancès, Y. Maday, B. Mennucci, A Fast Domain Decomposition Algorithm for Continuum Solvation Models: Energy and First Derivatives, J. Chem. Theory Comput., Vol. 9, No. 8, pp. 3637–3648 (2013)</a>

[4] <a href="https://doi.org/10.1021/jz5002506" target="_blank">F. Lipparini, L. Lagardère, G. Scalmani, B. Stamm, E. Cancès, Y. Maday, J.-P. Piquemal, M. J. Frisch, B. Mennucci, Quantum calculations in solution for large to very large molecules: a new linear scaling QM/continuum approach, J. Phys. Chem. Lett., Vol. 5, No. 4, pp. 953-958 (2014)</a>

[5] <a href="https://doi.org/10.1063/1.4901304" target="_blank">F. Lipparini, G. Scalmani, L. Lagardère, B. Stamm, E. Cancès, Y. Maday, J.-P. Piquemal, M. Frisch and B. Mennucci, Quantum, Classical and Hybrid QM/MM Calculations in Solution: General Implementation of the ddCOSMO Linear Scaling Strategy, Journal of Chemical Physics., Vol. 141, pp. 184108 (2014)</a>

[6] <a href="https://doi.org/10.1021/ct501087m" target="_blank">S. Caprasecca, S. Jurinovich, L. Lagardère, B. Stamm, F. Lipparini, Achieving linear scaling in computational cost for a fully polarizable MM/Continuum embedding, J. Chem. Theory Comput., Vol. 11, No. 2, pp. 694-704 (2015)</a>

[7] <a href="https://doi.org/10.1021/ct500998q" target="_blank">F. Lipparini, L. Lagardère, Ch. Raynaud, B. Stamm, E. Cancès, B. Mennucci, M. Schnieders, P. Ren,Y. Maday, J.-P. Piquemal, Polarizable Molecular Dynamics in a Polarizable Continuum Solvent, J. Chem. Theory Comput., Vol. 11, No. 2, pp. 623-634 (2015)</a>

[8] <a href="https://doi.org/10.1002/qua.25669" target="_blank">B. Stamm, L. Lagardère, G. Scalmani, P. Gatto, E. Cances, J. Piquemal, Y. Maday, B. Mennucci, F. Lipparini, How to make continuum solvation incredibly fast in a few simple steps: a practical guide to the domain decomposition paradigm for the Conductor-like Screening Model, Int. J. Quantum Chem. (2019)</a>

[9] <a href="https://doi.org/10.1021/acs.jpcb.2c04579" target="_blank">M. Nottoli, A. Mikhalev, B. Stamm, F. Lipparini, Coarse-Graining ddCOSMO through an Interface between Tinker and the ddX Library, J. Phys. Chem. B, Vol. 157, (2022)</a>

[10] <a href="https://doi.org/10.1021/acs.jctc.1c00555" target="_blank">M. Nottoli, R. Nifosì, B. Mennucci, F. Lipparini, Energy, Structures, and Response Properties with a Fully Coupled QM/AMOEBA/ddCOSMO Implementation, J. Chem. Theory Comput., Vol. 17, No. 9, pp. 5661--5672 (2021)</a>

<br />
#### ddPCM: 
[11] <a href="https://doi.org/10.1063/1.4940136" target="_blank">B. Stamm, E. Cancès, F. Lipparini, Y. Maday, A new discretization for the Polarizable Continuum Model within the domain decomposition paradigm, J. Chem. Physics, Vol. 144, 054101 (2016)</a>

[12] <a href="https://doi.org/10.1063/1.5008329" target="_blank">P. Gatto, F. Lipparini, and B. Stamm, Computation of Forces arising from the Polarizable Continuum Model within the Domain-Decomposition Paradigm,  J. Chem. Physics, Vol. 147, 224108 (2017)</a>

[13] <a href="https://doi.org/10.1021/acs.jctc.9b00640" target="_blank">M. Nottoli, B. Stamm, G. Scalmani, F. Lipparini, Quantum calculations in solution of energies, structures and properties with a domain decomposition polarizable continuum model, J. Chem. Theory Comput., Vol. 15, No. 11, pp. 6061–6073 (2019)</a>

[14] <a href="https://doi.org/10.1063/5.0104536" target="_blank">A. Mikhalev, M. Nottoli, B. Stamm, Linearly scaling computation of ddPCM solvation energy and forces using the fast multipole method, J. Chem. Physics, Vol. 157, 114103 (2022)</a>

<br />
#### ddLPB: 
[15] <a href="https://doi.org/10.1137/18M119553X" target="_blank">Ch. Quan, B. Stamm, Y. Maday, A Domain Decomposition Method for the Poisson-Boltzmann Solvation Models, SIAM J. Sci. Comput., Vol. 41, No. 2, pp. B320-B350, (2019)</a>

[16] <a href="https://doi.org/10.1063/5.0141025" target="_blank">A. Jha, M. Nottoli, A. Mikhalev, Ch. Quan, B. Stamm, Linear scaling computation of forces for the domain-decomposition linear Poisson–Boltzmann method, J. Chem. Physics, Vol. 158, 104105 (2023)</a>

---
title: Supported Geometry Formats
---

This library supports reading and writing molecular structures in the following formats.
All formats can be auto-detected by file extension or explicitly specified using the `filetype` enumerator.

## General ASCII Formats

- [xyz format](./format-xyz.html) - Simple Cartesian coordinate format (`.xyz`, `.log`)
- [Connection table files](./format-ctfile.html) - MDL molfile and SDF formats (`.mol`, `.sdf`)
- [Protein Data Bank](./format-pdb.html) - PDB format for biomolecules (`.pdb`)

## JSON-based Formats

- [QCSchema JSON](./format-qcschema.html) - MolSSI QCSchema format (`.qcjson`, `.json`)
- [Chemical JSON](./format-cjson.html) - Avogadro Chemical JSON (`.cjson`, `.json`)
- [Pymatgen JSON](./format-pymatgen.html) - Pymatgen Molecule/Structure (`.pmgjson`, `.json`)

## Program-specific Formats

- [Turbomole coord](./format-tmol.html) - Turbomole/riper coordinate format (`.tmol`, `.coord`)
- [VASP POSCAR](./format-vasp.html) - VASP geometry input (`.vasp`, `.poscar`, `.contcar`)
- [DFTB+ gen format](./format-gen.html) - DFTB+ general format (`.gen`)
- [Gaussian external](./format-ein.html) - Gaussian external program input (`.ein`)
- [FHI-aims geometry.in](./format-aims.html) - FHI-aims input format (`geometry.in`)
- [Q-Chem molecule](./format-qchem.html) - Q-Chem molecule block (`.qchem`)

## Format Detection

File formats are detected automatically based on:

1. File extension (e.g., `.xyz`, `.mol`, `.vasp`)
2. Basename (e.g., `coord`, `POSCAR`, `CONTCAR`, `geometry.in`)

When automatic detection is not possible (e.g., reading from stdin), use the format hint options in `mctc-convert` or the `filetype` enumerator in the library API.
